#!/usr/bin/env node
/*
 * Copyright IBM Corp. 2023, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const require = (await import("node:module")).createRequire(import.meta.url);
const __filename = (await import("node:url")).fileURLToPath(import.meta.url);
const __dirname = (await import("node:path")).dirname(__filename);

var wqt=Object.create;var One=Object.defineProperty;var Iqt=Object.getOwnPropertyDescriptor;var Oqt=Object.getOwnPropertyNames;var Rqt=Object.getPrototypeOf,Mqt=Object.prototype.hasOwnProperty;var Bu=(l=>typeof require<"u"?require:typeof Proxy<"u"?new Proxy(l,{get:(c,f)=>(typeof require<"u"?require:c)[f]}):l)(function(l){if(typeof require<"u")return require.apply(this,arguments);throw Error('Dynamic require of "'+l+'" is not supported')});var Jo=(l,c)=>()=>(l&&(c=l(l=0)),c);var xt=(l,c)=>()=>(c||l((c={exports:{}}).exports,c),c.exports),fAe=(l,c)=>{for(var f in c)One(l,f,{get:c[f],enumerable:!0})},fXe=(l,c,f,y)=>{if(c&&typeof c=="object"||typeof c=="function")for(let b of Oqt(c))!Mqt.call(l,b)&&b!==f&&One(l,b,{get:()=>c[b],enumerable:!(y=Iqt(c,b))||y.enumerable});return l};var vf=(l,c,f)=>(f=l!=null?wqt(Rqt(l)):{},fXe(c||!l||!l.__esModule?One(f,"default",{value:l,enumerable:!0}):f,l)),fc=l=>fXe(One({},"__esModule",{value:!0}),l);var Mq=xt(dAe=>{var Rne=class extends Error{constructor(c,f,y){super(y),Error.captureStackTrace(this,this.constructor),this.name=this.constructor.name,this.code=f,this.exitCode=c,this.nestedError=void 0}},pAe=class extends Rne{constructor(c){super(1,"commander.invalidArgument",c),Error.captureStackTrace(this,this.constructor),this.name=this.constructor.name}};dAe.CommanderError=Rne;dAe.InvalidArgumentError=pAe});var Mne=xt(gAe=>{var{InvalidArgumentError:Lqt}=Mq(),mAe=class{constructor(c,f){switch(this.description=f||"",this.variadic=!1,this.parseArg=void 0,this.defaultValue=void 0,this.defaultValueDescription=void 0,this.argChoices=void 0,c[0]){case"<":this.required=!0,this._name=c.slice(1,-1);break;case"[":this.required=!1,this._name=c.slice(1,-1);break;default:this.required=!0,this._name=c;break}this._name.length>3&&this._name.slice(-3)==="..."&&(this.variadic=!0,this._name=this._name.slice(0,-3))}name(){return this._name}_concatValue(c,f){return f===this.defaultValue||!Array.isArray(f)?[c]:f.concat(c)}default(c,f){return this.defaultValue=c,this.defaultValueDescription=f,this}argParser(c){return this.parseArg=c,this}choices(c){return this.argChoices=c.slice(),this.parseArg=(f,y)=>{if(!this.argChoices.includes(f))throw new Lqt(`Allowed choices are ${this.argChoices.join(", ")}.`);return this.variadic?this._concatValue(f,y):f},this}argRequired(){return this.required=!0,this}argOptional(){return this.required=!1,this}};function Fqt(l){let c=l.name()+(l.variadic===!0?"...":"");return l.required?"<"+c+">":"["+c+"]"}gAe.Argument=mAe;gAe.humanReadableArgName=Fqt});var yAe=xt(pXe=>{var{humanReadableArgName:jqt}=Mne(),hAe=class{constructor(){this.helpWidth=void 0,this.sortSubcommands=!1,this.sortOptions=!1,this.showGlobalOptions=!1}visibleCommands(c){let f=c.commands.filter(b=>!b._hidden),y=c._getHelpCommand();return y&&!y._hidden&&f.push(y),this.sortSubcommands&&f.sort((b,A)=>b.name().localeCompare(A.name())),f}compareOptions(c,f){let y=b=>b.short?b.short.replace(/^-/,""):b.long.replace(/^--/,"");return y(c).localeCompare(y(f))}visibleOptions(c){let f=c.options.filter(b=>!b.hidden),y=c._getHelpOption();if(y&&!y.hidden){let b=y.short&&c._findOption(y.short),A=y.long&&c._findOption(y.long);!b&&!A?f.push(y):y.long&&!A?f.push(c.createOption(y.long,y.description)):y.short&&!b&&f.push(c.createOption(y.short,y.description))}return this.sortOptions&&f.sort(this.compareOptions),f}visibleGlobalOptions(c){if(!this.showGlobalOptions)return[];let f=[];for(let y=c.parent;y;y=y.parent){let b=y.options.filter(A=>!A.hidden);f.push(...b)}return this.sortOptions&&f.sort(this.compareOptions),f}visibleArguments(c){return c._argsDescription&&c.registeredArguments.forEach(f=>{f.description=f.description||c._argsDescription[f.name()]||""}),c.registeredArguments.find(f=>f.description)?c.registeredArguments:[]}subcommandTerm(c){let f=c.registeredArguments.map(y=>jqt(y)).join(" ");return c._name+(c._aliases[0]?"|"+c._aliases[0]:"")+(c.options.length?" [options]":"")+(f?" "+f:"")}optionTerm(c){return c.flags}argumentTerm(c){return c.name()}longestSubcommandTermLength(c,f){return f.visibleCommands(c).reduce((y,b)=>Math.max(y,f.subcommandTerm(b).length),0)}longestOptionTermLength(c,f){return f.visibleOptions(c).reduce((y,b)=>Math.max(y,f.optionTerm(b).length),0)}longestGlobalOptionTermLength(c,f){return f.visibleGlobalOptions(c).reduce((y,b)=>Math.max(y,f.optionTerm(b).length),0)}longestArgumentTermLength(c,f){return f.visibleArguments(c).reduce((y,b)=>Math.max(y,f.argumentTerm(b).length),0)}commandUsage(c){let f=c._name;c._aliases[0]&&(f=f+"|"+c._aliases[0]);let y="";for(let b=c.parent;b;b=b.parent)y=b.name()+" "+y;return y+f+" "+c.usage()}commandDescription(c){return c.description()}subcommandDescription(c){return c.summary()||c.description()}optionDescription(c){let f=[];return c.argChoices&&f.push(`choices: ${c.argChoices.map(y=>JSON.stringify(y)).join(", ")}`),c.defaultValue!==void 0&&(c.required||c.optional||c.isBoolean()&&typeof c.defaultValue=="boolean")&&f.push(`default: ${c.defaultValueDescription||JSON.stringify(c.defaultValue)}`),c.presetArg!==void 0&&c.optional&&f.push(`preset: ${JSON.stringify(c.presetArg)}`),c.envVar!==void 0&&f.push(`env: ${c.envVar}`),f.length>0?`${c.description} (${f.join(", ")})`:c.description}argumentDescription(c){let f=[];if(c.argChoices&&f.push(`choices: ${c.argChoices.map(y=>JSON.stringify(y)).join(", ")}`),c.defaultValue!==void 0&&f.push(`default: ${c.defaultValueDescription||JSON.stringify(c.defaultValue)}`),f.length>0){let y=`(${f.join(", ")})`;return c.description?`${c.description} ${y}`:y}return c.description}formatHelp(c,f){let y=f.padWidth(c,f),b=f.helpWidth||80,A=2,g=2;function p(Br,wt){if(wt){let kt=`${Br.padEnd(y+g)}${wt}`;return f.wrap(kt,b-A,y+g)}return Br}function k(Br){return Br.join(`
`).replace(/^/gm," ".repeat(A))}let j=[`Usage: ${f.commandUsage(c)}`,""],se=f.commandDescription(c);se.length>0&&(j=j.concat([f.wrap(se,b,0),""]));let ze=f.visibleArguments(c).map(Br=>p(f.argumentTerm(Br),f.argumentDescription(Br)));ze.length>0&&(j=j.concat(["Arguments:",k(ze),""]));let ve=f.visibleOptions(c).map(Br=>p(f.optionTerm(Br),f.optionDescription(Br)));if(ve.length>0&&(j=j.concat(["Options:",k(ve),""])),this.showGlobalOptions){let Br=f.visibleGlobalOptions(c).map(wt=>p(f.optionTerm(wt),f.optionDescription(wt)));Br.length>0&&(j=j.concat(["Global Options:",k(Br),""]))}let lr=f.visibleCommands(c).map(Br=>p(f.subcommandTerm(Br),f.subcommandDescription(Br)));return lr.length>0&&(j=j.concat(["Commands:",k(lr),""])),j.join(`
`)}padWidth(c,f){return Math.max(f.longestOptionTermLength(c,f),f.longestGlobalOptionTermLength(c,f),f.longestSubcommandTermLength(c,f),f.longestArgumentTermLength(c,f))}wrap(c,f,y,b=40){let A=" \\f\\t\\v\xA0\u1680\u2000-\u200A\u202F\u205F\u3000\uFEFF",g=new RegExp(`[\\n][${A}]+`);if(c.match(g))return c;let p=f-y;if(p<b)return c;let k=c.slice(0,y),j=c.slice(y).replace(`\r
`,`
`),se=" ".repeat(y),ve="\\s\u200B",lr=new RegExp(`
|.{1,${p-1}}([${ve}]|$)|[^${ve}]+?([${ve}]|$)`,"g"),Br=j.match(lr)||[];return k+Br.map((wt,kt)=>wt===`
`?"":(kt>0?se:"")+wt.trimEnd()).join(`
`)}};pXe.Help=hAe});var TAe=xt(bAe=>{var{InvalidArgumentError:Bqt}=Mq(),vAe=class{constructor(c,f){this.flags=c,this.description=f||"",this.required=c.includes("<"),this.optional=c.includes("["),this.variadic=/\w\.\.\.[>\]]$/.test(c),this.mandatory=!1;let y=Vqt(c);this.short=y.shortFlag,this.long=y.longFlag,this.negate=!1,this.long&&(this.negate=this.long.startsWith("--no-")),this.defaultValue=void 0,this.defaultValueDescription=void 0,this.presetArg=void 0,this.envVar=void 0,this.parseArg=void 0,this.hidden=!1,this.argChoices=void 0,this.conflictsWith=[],this.implied=void 0}default(c,f){return this.defaultValue=c,this.defaultValueDescription=f,this}preset(c){return this.presetArg=c,this}conflicts(c){return this.conflictsWith=this.conflictsWith.concat(c),this}implies(c){let f=c;return typeof c=="string"&&(f={[c]:!0}),this.implied=Object.assign(this.implied||{},f),this}env(c){return this.envVar=c,this}argParser(c){return this.parseArg=c,this}makeOptionMandatory(c=!0){return this.mandatory=!!c,this}hideHelp(c=!0){return this.hidden=!!c,this}_concatValue(c,f){return f===this.defaultValue||!Array.isArray(f)?[c]:f.concat(c)}choices(c){return this.argChoices=c.slice(),this.parseArg=(f,y)=>{if(!this.argChoices.includes(f))throw new Bqt(`Allowed choices are ${this.argChoices.join(", ")}.`);return this.variadic?this._concatValue(f,y):f},this}name(){return this.long?this.long.replace(/^--/,""):this.short.replace(/^-/,"")}attributeName(){return Uqt(this.name().replace(/^no-/,""))}is(c){return this.short===c||this.long===c}isBoolean(){return!this.required&&!this.optional&&!this.negate}},SAe=class{constructor(c){this.positiveOptions=new Map,this.negativeOptions=new Map,this.dualOptions=new Set,c.forEach(f=>{f.negate?this.negativeOptions.set(f.attributeName(),f):this.positiveOptions.set(f.attributeName(),f)}),this.negativeOptions.forEach((f,y)=>{this.positiveOptions.has(y)&&this.dualOptions.add(y)})}valueFromOption(c,f){let y=f.attributeName();if(!this.dualOptions.has(y))return!0;let b=this.negativeOptions.get(y).presetArg,A=b!==void 0?b:!1;return f.negate===(A===c)}};function Uqt(l){return l.split("-").reduce((c,f)=>c+f[0].toUpperCase()+f.slice(1))}function Vqt(l){let c,f,y=l.split(/[ |,]+/);return y.length>1&&!/^[[<]/.test(y[1])&&(c=y.shift()),f=y.shift(),!c&&/^-[^-]$/.test(f)&&(c=f,f=void 0),{shortFlag:c,longFlag:f}}bAe.Option=vAe;bAe.DualOptions=SAe});var mXe=xt(dXe=>{function Jqt(l,c){if(Math.abs(l.length-c.length)>3)return Math.max(l.length,c.length);let f=[];for(let y=0;y<=l.length;y++)f[y]=[y];for(let y=0;y<=c.length;y++)f[0][y]=y;for(let y=1;y<=c.length;y++)for(let b=1;b<=l.length;b++){let A=1;l[b-1]===c[y-1]?A=0:A=1,f[b][y]=Math.min(f[b-1][y]+1,f[b][y-1]+1,f[b-1][y-1]+A),b>1&&y>1&&l[b-1]===c[y-2]&&l[b-2]===c[y-1]&&(f[b][y]=Math.min(f[b][y],f[b-2][y-2]+1))}return f[l.length][c.length]}function qqt(l,c){if(!c||c.length===0)return"";c=Array.from(new Set(c));let f=l.startsWith("--");f&&(l=l.slice(2),c=c.map(g=>g.slice(2)));let y=[],b=3,A=.4;return c.forEach(g=>{if(g.length<=1)return;let p=Jqt(l,g),k=Math.max(l.length,g.length);(k-p)/k>A&&(p<b?(b=p,y=[g]):p===b&&y.push(g))}),y.sort((g,p)=>g.localeCompare(p)),f&&(y=y.map(g=>`--${g}`)),y.length>1?`
(Did you mean one of ${y.join(", ")}?)`:y.length===1?`
(Did you mean ${y[0]}?)`:""}dXe.suggestSimilar=qqt});var SXe=xt(vXe=>{var zqt=Bu("node:events").EventEmitter,EAe=Bu("node:child_process"),iP=Bu("node:path"),xAe=Bu("node:fs"),qd=Bu("node:process"),{Argument:Wqt,humanReadableArgName:$qt}=Mne(),{CommanderError:CAe}=Mq(),{Help:Hqt}=yAe(),{Option:gXe,DualOptions:Gqt}=TAe(),{suggestSimilar:hXe}=mXe(),AAe=class l extends zqt{constructor(c){super(),this.commands=[],this.options=[],this.parent=null,this._allowUnknownOption=!1,this._allowExcessArguments=!0,this.registeredArguments=[],this._args=this.registeredArguments,this.args=[],this.rawArgs=[],this.processedArgs=[],this._scriptPath=null,this._name=c||"",this._optionValues={},this._optionValueSources={},this._storeOptionsAsProperties=!1,this._actionHandler=null,this._executableHandler=!1,this._executableFile=null,this._executableDir=null,this._defaultCommandName=null,this._exitCallback=null,this._aliases=[],this._combineFlagAndOptionalValue=!0,this._description="",this._summary="",this._argsDescription=void 0,this._enablePositionalOptions=!1,this._passThroughOptions=!1,this._lifeCycleHooks={},this._showHelpAfterError=!1,this._showSuggestionAfterError=!0,this._outputConfiguration={writeOut:f=>qd.stdout.write(f),writeErr:f=>qd.stderr.write(f),getOutHelpWidth:()=>qd.stdout.isTTY?qd.stdout.columns:void 0,getErrHelpWidth:()=>qd.stderr.isTTY?qd.stderr.columns:void 0,outputError:(f,y)=>y(f)},this._hidden=!1,this._helpOption=void 0,this._addImplicitHelpCommand=void 0,this._helpCommand=void 0,this._helpConfiguration={}}copyInheritedSettings(c){return this._outputConfiguration=c._outputConfiguration,this._helpOption=c._helpOption,this._helpCommand=c._helpCommand,this._helpConfiguration=c._helpConfiguration,this._exitCallback=c._exitCallback,this._storeOptionsAsProperties=c._storeOptionsAsProperties,this._combineFlagAndOptionalValue=c._combineFlagAndOptionalValue,this._allowExcessArguments=c._allowExcessArguments,this._enablePositionalOptions=c._enablePositionalOptions,this._showHelpAfterError=c._showHelpAfterError,this._showSuggestionAfterError=c._showSuggestionAfterError,this}_getCommandAndAncestors(){let c=[];for(let f=this;f;f=f.parent)c.push(f);return c}command(c,f,y){let b=f,A=y;typeof b=="object"&&b!==null&&(A=b,b=null),A=A||{};let[,g,p]=c.match(/([^ ]+) *(.*)/),k=this.createCommand(g);return b&&(k.description(b),k._executableHandler=!0),A.isDefault&&(this._defaultCommandName=k._name),k._hidden=!!(A.noHelp||A.hidden),k._executableFile=A.executableFile||null,p&&k.arguments(p),this._registerCommand(k),k.parent=this,k.copyInheritedSettings(this),b?this:k}createCommand(c){return new l(c)}createHelp(){return Object.assign(new Hqt,this.configureHelp())}configureHelp(c){return c===void 0?this._helpConfiguration:(this._helpConfiguration=c,this)}configureOutput(c){return c===void 0?this._outputConfiguration:(Object.assign(this._outputConfiguration,c),this)}showHelpAfterError(c=!0){return typeof c!="string"&&(c=!!c),this._showHelpAfterError=c,this}showSuggestionAfterError(c=!0){return this._showSuggestionAfterError=!!c,this}addCommand(c,f){if(!c._name)throw new Error(`Command passed to .addCommand() must have a name
- specify the name in Command constructor or using .name()`);return f=f||{},f.isDefault&&(this._defaultCommandName=c._name),(f.noHelp||f.hidden)&&(c._hidden=!0),this._registerCommand(c),c.parent=this,c._checkForBrokenPassThrough(),this}createArgument(c,f){return new Wqt(c,f)}argument(c,f,y,b){let A=this.createArgument(c,f);return typeof y=="function"?A.default(b).argParser(y):A.default(y),this.addArgument(A),this}arguments(c){return c.trim().split(/ +/).forEach(f=>{this.argument(f)}),this}addArgument(c){let f=this.registeredArguments.slice(-1)[0];if(f&&f.variadic)throw new Error(`only the last argument can be variadic '${f.name()}'`);if(c.required&&c.defaultValue!==void 0&&c.parseArg===void 0)throw new Error(`a default value for a required argument is never used: '${c.name()}'`);return this.registeredArguments.push(c),this}helpCommand(c,f){if(typeof c=="boolean")return this._addImplicitHelpCommand=c,this;c=c??"help [command]";let[,y,b]=c.match(/([^ ]+) *(.*)/),A=f??"display help for command",g=this.createCommand(y);return g.helpOption(!1),b&&g.arguments(b),A&&g.description(A),this._addImplicitHelpCommand=!0,this._helpCommand=g,this}addHelpCommand(c,f){return typeof c!="object"?(this.helpCommand(c,f),this):(this._addImplicitHelpCommand=!0,this._helpCommand=c,this)}_getHelpCommand(){return this._addImplicitHelpCommand??(this.commands.length&&!this._actionHandler&&!this._findCommand("help"))?(this._helpCommand===void 0&&this.helpCommand(void 0,void 0),this._helpCommand):null}hook(c,f){let y=["preSubcommand","preAction","postAction"];if(!y.includes(c))throw new Error(`Unexpected value for event passed to hook : '${c}'.
Expecting one of '${y.join("', '")}'`);return this._lifeCycleHooks[c]?this._lifeCycleHooks[c].push(f):this._lifeCycleHooks[c]=[f],this}exitOverride(c){return c?this._exitCallback=c:this._exitCallback=f=>{if(f.code!=="commander.executeSubCommandAsync")throw f},this}_exit(c,f,y){this._exitCallback&&this._exitCallback(new CAe(c,f,y)),qd.exit(c)}action(c){let f=y=>{let b=this.registeredArguments.length,A=y.slice(0,b);return this._storeOptionsAsProperties?A[b]=this:A[b]=this.opts(),A.push(this),c.apply(this,A)};return this._actionHandler=f,this}createOption(c,f){return new gXe(c,f)}_callParseArg(c,f,y,b){try{return c.parseArg(f,y)}catch(A){if(A.code==="commander.invalidArgument"){let g=`${b} ${A.message}`;this.error(g,{exitCode:A.exitCode,code:A.code})}throw A}}_registerOption(c){let f=c.short&&this._findOption(c.short)||c.long&&this._findOption(c.long);if(f){let y=c.long&&this._findOption(c.long)?c.long:c.short;throw new Error(`Cannot add option '${c.flags}'${this._name&&` to command '${this._name}'`} due to conflicting flag '${y}'
-  already used by option '${f.flags}'`)}this.options.push(c)}_registerCommand(c){let f=b=>[b.name()].concat(b.aliases()),y=f(c).find(b=>this._findCommand(b));if(y){let b=f(this._findCommand(y)).join("|"),A=f(c).join("|");throw new Error(`cannot add command '${A}' as already have command '${b}'`)}this.commands.push(c)}addOption(c){this._registerOption(c);let f=c.name(),y=c.attributeName();if(c.negate){let A=c.long.replace(/^--no-/,"--");this._findOption(A)||this.setOptionValueWithSource(y,c.defaultValue===void 0?!0:c.defaultValue,"default")}else c.defaultValue!==void 0&&this.setOptionValueWithSource(y,c.defaultValue,"default");let b=(A,g,p)=>{A==null&&c.presetArg!==void 0&&(A=c.presetArg);let k=this.getOptionValue(y);A!==null&&c.parseArg?A=this._callParseArg(c,A,k,g):A!==null&&c.variadic&&(A=c._concatValue(A,k)),A==null&&(c.negate?A=!1:c.isBoolean()||c.optional?A=!0:A=""),this.setOptionValueWithSource(y,A,p)};return this.on("option:"+f,A=>{let g=`error: option '${c.flags}' argument '${A}' is invalid.`;b(A,g,"cli")}),c.envVar&&this.on("optionEnv:"+f,A=>{let g=`error: option '${c.flags}' value '${A}' from env '${c.envVar}' is invalid.`;b(A,g,"env")}),this}_optionEx(c,f,y,b,A){if(typeof f=="object"&&f instanceof gXe)throw new Error("To add an Option object use addOption() instead of option() or requiredOption()");let g=this.createOption(f,y);if(g.makeOptionMandatory(!!c.mandatory),typeof b=="function")g.default(A).argParser(b);else if(b instanceof RegExp){let p=b;b=(k,j)=>{let se=p.exec(k);return se?se[0]:j},g.default(A).argParser(b)}else g.default(b);return this.addOption(g)}option(c,f,y,b){return this._optionEx({},c,f,y,b)}requiredOption(c,f,y,b){return this._optionEx({mandatory:!0},c,f,y,b)}combineFlagAndOptionalValue(c=!0){return this._combineFlagAndOptionalValue=!!c,this}allowUnknownOption(c=!0){return this._allowUnknownOption=!!c,this}allowExcessArguments(c=!0){return this._allowExcessArguments=!!c,this}enablePositionalOptions(c=!0){return this._enablePositionalOptions=!!c,this}passThroughOptions(c=!0){return this._passThroughOptions=!!c,this._checkForBrokenPassThrough(),this}_checkForBrokenPassThrough(){if(this.parent&&this._passThroughOptions&&!this.parent._enablePositionalOptions)throw new Error(`passThroughOptions cannot be used for '${this._name}' without turning on enablePositionalOptions for parent command(s)`)}storeOptionsAsProperties(c=!0){if(this.options.length)throw new Error("call .storeOptionsAsProperties() before adding options");if(Object.keys(this._optionValues).length)throw new Error("call .storeOptionsAsProperties() before setting option values");return this._storeOptionsAsProperties=!!c,this}getOptionValue(c){return this._storeOptionsAsProperties?this[c]:this._optionValues[c]}setOptionValue(c,f){return this.setOptionValueWithSource(c,f,void 0)}setOptionValueWithSource(c,f,y){return this._storeOptionsAsProperties?this[c]=f:this._optionValues[c]=f,this._optionValueSources[c]=y,this}getOptionValueSource(c){return this._optionValueSources[c]}getOptionValueSourceWithGlobals(c){let f;return this._getCommandAndAncestors().forEach(y=>{y.getOptionValueSource(c)!==void 0&&(f=y.getOptionValueSource(c))}),f}_prepareUserArgs(c,f){if(c!==void 0&&!Array.isArray(c))throw new Error("first parameter to parse must be array or undefined");if(f=f||{},c===void 0&&f.from===void 0){qd.versions?.electron&&(f.from="electron");let b=qd.execArgv??[];(b.includes("-e")||b.includes("--eval")||b.includes("-p")||b.includes("--print"))&&(f.from="eval")}c===void 0&&(c=qd.argv),this.rawArgs=c.slice();let y;switch(f.from){case void 0:case"node":this._scriptPath=c[1],y=c.slice(2);break;case"electron":qd.defaultApp?(this._scriptPath=c[1],y=c.slice(2)):y=c.slice(1);break;case"user":y=c.slice(0);break;case"eval":y=c.slice(1);break;default:throw new Error(`unexpected parse option { from: '${f.from}' }`)}return!this._name&&this._scriptPath&&this.nameFromFilename(this._scriptPath),this._name=this._name||"program",y}parse(c,f){let y=this._prepareUserArgs(c,f);return this._parseCommand([],y),this}async parseAsync(c,f){let y=this._prepareUserArgs(c,f);return await this._parseCommand([],y),this}_executeSubCommand(c,f){f=f.slice();let y=!1,b=[".js",".ts",".tsx",".mjs",".cjs"];function A(se,ze){let ve=iP.resolve(se,ze);if(xAe.existsSync(ve))return ve;if(b.includes(iP.extname(ze)))return;let lr=b.find(Br=>xAe.existsSync(`${ve}${Br}`));if(lr)return`${ve}${lr}`}this._checkForMissingMandatoryOptions(),this._checkForConflictingOptions();let g=c._executableFile||`${this._name}-${c._name}`,p=this._executableDir||"";if(this._scriptPath){let se;try{se=xAe.realpathSync(this._scriptPath)}catch{se=this._scriptPath}p=iP.resolve(iP.dirname(se),p)}if(p){let se=A(p,g);if(!se&&!c._executableFile&&this._scriptPath){let ze=iP.basename(this._scriptPath,iP.extname(this._scriptPath));ze!==this._name&&(se=A(p,`${ze}-${c._name}`))}g=se||g}y=b.includes(iP.extname(g));let k;qd.platform!=="win32"?y?(f.unshift(g),f=yXe(qd.execArgv).concat(f),k=EAe.spawn(qd.argv[0],f,{stdio:"inherit"})):k=EAe.spawn(g,f,{stdio:"inherit"}):(f.unshift(g),f=yXe(qd.execArgv).concat(f),k=EAe.spawn(qd.execPath,f,{stdio:"inherit"})),k.killed||["SIGUSR1","SIGUSR2","SIGTERM","SIGINT","SIGHUP"].forEach(ze=>{qd.on(ze,()=>{k.killed===!1&&k.exitCode===null&&k.kill(ze)})});let j=this._exitCallback;k.on("close",se=>{se=se??1,j?j(new CAe(se,"commander.executeSubCommandAsync","(close)")):qd.exit(se)}),k.on("error",se=>{if(se.code==="ENOENT"){let ze=p?`searched for local subcommand relative to directory '${p}'`:"no directory for search for local subcommand, use .executableDir() to supply a custom directory",ve=`'${g}' does not exist
 - if '${c._name}' is not meant to be an executable command, remove description parameter from '.command()' and use '.description()' instead
 - if the default executable name is not suitable, use the executableFile option to supply a custom name or path
 - ${ze}`;throw new Error(ve)}else if(se.code==="EACCES")throw new Error(`'${g}' not executable`);if(!j)qd.exit(1);else{let ze=new CAe(1,"commander.executeSubCommandAsync","(error)");ze.nestedError=se,j(ze)}}),this.runningCommand=k}_dispatchSubcommand(c,f,y){let b=this._findCommand(c);b||this.help({error:!0});let A;return A=this._chainOrCallSubCommandHook(A,b,"preSubcommand"),A=this._chainOrCall(A,()=>{if(b._executableHandler)this._executeSubCommand(b,f.concat(y));else return b._parseCommand(f,y)}),A}_dispatchHelpCommand(c){c||this.help();let f=this._findCommand(c);return f&&!f._executableHandler&&f.help(),this._dispatchSubcommand(c,[],[this._getHelpOption()?.long??this._getHelpOption()?.short??"--help"])}_checkNumberOfArguments(){this.registeredArguments.forEach((c,f)=>{c.required&&this.args[f]==null&&this.missingArgument(c.name())}),!(this.registeredArguments.length>0&&this.registeredArguments[this.registeredArguments.length-1].variadic)&&this.args.length>this.registeredArguments.length&&this._excessArguments(this.args)}_processArguments(){let c=(y,b,A)=>{let g=b;if(b!==null&&y.parseArg){let p=`error: command-argument value '${b}' is invalid for argument '${y.name()}'.`;g=this._callParseArg(y,b,A,p)}return g};this._checkNumberOfArguments();let f=[];this.registeredArguments.forEach((y,b)=>{let A=y.defaultValue;y.variadic?b<this.args.length?(A=this.args.slice(b),y.parseArg&&(A=A.reduce((g,p)=>c(y,p,g),y.defaultValue))):A===void 0&&(A=[]):b<this.args.length&&(A=this.args[b],y.parseArg&&(A=c(y,A,y.defaultValue))),f[b]=A}),this.processedArgs=f}_chainOrCall(c,f){return c&&c.then&&typeof c.then=="function"?c.then(()=>f()):f()}_chainOrCallHooks(c,f){let y=c,b=[];return this._getCommandAndAncestors().reverse().filter(A=>A._lifeCycleHooks[f]!==void 0).forEach(A=>{A._lifeCycleHooks[f].forEach(g=>{b.push({hookedCommand:A,callback:g})})}),f==="postAction"&&b.reverse(),b.forEach(A=>{y=this._chainOrCall(y,()=>A.callback(A.hookedCommand,this))}),y}_chainOrCallSubCommandHook(c,f,y){let b=c;return this._lifeCycleHooks[y]!==void 0&&this._lifeCycleHooks[y].forEach(A=>{b=this._chainOrCall(b,()=>A(this,f))}),b}_parseCommand(c,f){let y=this.parseOptions(f);if(this._parseOptionsEnv(),this._parseOptionsImplied(),c=c.concat(y.operands),f=y.unknown,this.args=c.concat(f),c&&this._findCommand(c[0]))return this._dispatchSubcommand(c[0],c.slice(1),f);if(this._getHelpCommand()&&c[0]===this._getHelpCommand().name())return this._dispatchHelpCommand(c[1]);if(this._defaultCommandName)return this._outputHelpIfRequested(f),this._dispatchSubcommand(this._defaultCommandName,c,f);this.commands.length&&this.args.length===0&&!this._actionHandler&&!this._defaultCommandName&&this.help({error:!0}),this._outputHelpIfRequested(y.unknown),this._checkForMissingMandatoryOptions(),this._checkForConflictingOptions();let b=()=>{y.unknown.length>0&&this.unknownOption(y.unknown[0])},A=`command:${this.name()}`;if(this._actionHandler){b(),this._processArguments();let g;return g=this._chainOrCallHooks(g,"preAction"),g=this._chainOrCall(g,()=>this._actionHandler(this.processedArgs)),this.parent&&(g=this._chainOrCall(g,()=>{this.parent.emit(A,c,f)})),g=this._chainOrCallHooks(g,"postAction"),g}if(this.parent&&this.parent.listenerCount(A))b(),this._processArguments(),this.parent.emit(A,c,f);else if(c.length){if(this._findCommand("*"))return this._dispatchSubcommand("*",c,f);this.listenerCount("command:*")?this.emit("command:*",c,f):this.commands.length?this.unknownCommand():(b(),this._processArguments())}else this.commands.length?(b(),this.help({error:!0})):(b(),this._processArguments())}_findCommand(c){if(c)return this.commands.find(f=>f._name===c||f._aliases.includes(c))}_findOption(c){return this.options.find(f=>f.is(c))}_checkForMissingMandatoryOptions(){this._getCommandAndAncestors().forEach(c=>{c.options.forEach(f=>{f.mandatory&&c.getOptionValue(f.attributeName())===void 0&&c.missingMandatoryOptionValue(f)})})}_checkForConflictingLocalOptions(){let c=this.options.filter(y=>{let b=y.attributeName();return this.getOptionValue(b)===void 0?!1:this.getOptionValueSource(b)!=="default"});c.filter(y=>y.conflictsWith.length>0).forEach(y=>{let b=c.find(A=>y.conflictsWith.includes(A.attributeName()));b&&this._conflictingOption(y,b)})}_checkForConflictingOptions(){this._getCommandAndAncestors().forEach(c=>{c._checkForConflictingLocalOptions()})}parseOptions(c){let f=[],y=[],b=f,A=c.slice();function g(k){return k.length>1&&k[0]==="-"}let p=null;for(;A.length;){let k=A.shift();if(k==="--"){b===y&&b.push(k),b.push(...A);break}if(p&&!g(k)){this.emit(`option:${p.name()}`,k);continue}if(p=null,g(k)){let j=this._findOption(k);if(j){if(j.required){let se=A.shift();se===void 0&&this.optionMissingArgument(j),this.emit(`option:${j.name()}`,se)}else if(j.optional){let se=null;A.length>0&&!g(A[0])&&(se=A.shift()),this.emit(`option:${j.name()}`,se)}else this.emit(`option:${j.name()}`);p=j.variadic?j:null;continue}}if(k.length>2&&k[0]==="-"&&k[1]!=="-"){let j=this._findOption(`-${k[1]}`);if(j){j.required||j.optional&&this._combineFlagAndOptionalValue?this.emit(`option:${j.name()}`,k.slice(2)):(this.emit(`option:${j.name()}`),A.unshift(`-${k.slice(2)}`));continue}}if(/^--[^=]+=/.test(k)){let j=k.indexOf("="),se=this._findOption(k.slice(0,j));if(se&&(se.required||se.optional)){this.emit(`option:${se.name()}`,k.slice(j+1));continue}}if(g(k)&&(b=y),(this._enablePositionalOptions||this._passThroughOptions)&&f.length===0&&y.length===0){if(this._findCommand(k)){f.push(k),A.length>0&&y.push(...A);break}else if(this._getHelpCommand()&&k===this._getHelpCommand().name()){f.push(k),A.length>0&&f.push(...A);break}else if(this._defaultCommandName){y.push(k),A.length>0&&y.push(...A);break}}if(this._passThroughOptions){b.push(k),A.length>0&&b.push(...A);break}b.push(k)}return{operands:f,unknown:y}}opts(){if(this._storeOptionsAsProperties){let c={},f=this.options.length;for(let y=0;y<f;y++){let b=this.options[y].attributeName();c[b]=b===this._versionOptionName?this._version:this[b]}return c}return this._optionValues}optsWithGlobals(){return this._getCommandAndAncestors().reduce((c,f)=>Object.assign(c,f.opts()),{})}error(c,f){this._outputConfiguration.outputError(`${c}
`,this._outputConfiguration.writeErr),typeof this._showHelpAfterError=="string"?this._outputConfiguration.writeErr(`${this._showHelpAfterError}
`):this._showHelpAfterError&&(this._outputConfiguration.writeErr(`
`),this.outputHelp({error:!0}));let y=f||{},b=y.exitCode||1,A=y.code||"commander.error";this._exit(b,A,c)}_parseOptionsEnv(){this.options.forEach(c=>{if(c.envVar&&c.envVar in qd.env){let f=c.attributeName();(this.getOptionValue(f)===void 0||["default","config","env"].includes(this.getOptionValueSource(f)))&&(c.required||c.optional?this.emit(`optionEnv:${c.name()}`,qd.env[c.envVar]):this.emit(`optionEnv:${c.name()}`))}})}_parseOptionsImplied(){let c=new Gqt(this.options),f=y=>this.getOptionValue(y)!==void 0&&!["default","implied"].includes(this.getOptionValueSource(y));this.options.filter(y=>y.implied!==void 0&&f(y.attributeName())&&c.valueFromOption(this.getOptionValue(y.attributeName()),y)).forEach(y=>{Object.keys(y.implied).filter(b=>!f(b)).forEach(b=>{this.setOptionValueWithSource(b,y.implied[b],"implied")})})}missingArgument(c){let f=`error: missing required argument '${c}'`;this.error(f,{code:"commander.missingArgument"})}optionMissingArgument(c){let f=`error: option '${c.flags}' argument missing`;this.error(f,{code:"commander.optionMissingArgument"})}missingMandatoryOptionValue(c){let f=`error: required option '${c.flags}' not specified`;this.error(f,{code:"commander.missingMandatoryOptionValue"})}_conflictingOption(c,f){let y=g=>{let p=g.attributeName(),k=this.getOptionValue(p),j=this.options.find(ze=>ze.negate&&p===ze.attributeName()),se=this.options.find(ze=>!ze.negate&&p===ze.attributeName());return j&&(j.presetArg===void 0&&k===!1||j.presetArg!==void 0&&k===j.presetArg)?j:se||g},b=g=>{let p=y(g),k=p.attributeName();return this.getOptionValueSource(k)==="env"?`environment variable '${p.envVar}'`:`option '${p.flags}'`},A=`error: ${b(c)} cannot be used with ${b(f)}`;this.error(A,{code:"commander.conflictingOption"})}unknownOption(c){if(this._allowUnknownOption)return;let f="";if(c.startsWith("--")&&this._showSuggestionAfterError){let b=[],A=this;do{let g=A.createHelp().visibleOptions(A).filter(p=>p.long).map(p=>p.long);b=b.concat(g),A=A.parent}while(A&&!A._enablePositionalOptions);f=hXe(c,b)}let y=`error: unknown option '${c}'${f}`;this.error(y,{code:"commander.unknownOption"})}_excessArguments(c){if(this._allowExcessArguments)return;let f=this.registeredArguments.length,y=f===1?"":"s",A=`error: too many arguments${this.parent?` for '${this.name()}'`:""}. Expected ${f} argument${y} but got ${c.length}.`;this.error(A,{code:"commander.excessArguments"})}unknownCommand(){let c=this.args[0],f="";if(this._showSuggestionAfterError){let b=[];this.createHelp().visibleCommands(this).forEach(A=>{b.push(A.name()),A.alias()&&b.push(A.alias())}),f=hXe(c,b)}let y=`error: unknown command '${c}'${f}`;this.error(y,{code:"commander.unknownCommand"})}version(c,f,y){if(c===void 0)return this._version;this._version=c,f=f||"-V, --version",y=y||"output the version number";let b=this.createOption(f,y);return this._versionOptionName=b.attributeName(),this._registerOption(b),this.on("option:"+b.name(),()=>{this._outputConfiguration.writeOut(`${c}
`),this._exit(0,"commander.version",c)}),this}description(c,f){return c===void 0&&f===void 0?this._description:(this._description=c,f&&(this._argsDescription=f),this)}summary(c){return c===void 0?this._summary:(this._summary=c,this)}alias(c){if(c===void 0)return this._aliases[0];let f=this;if(this.commands.length!==0&&this.commands[this.commands.length-1]._executableHandler&&(f=this.commands[this.commands.length-1]),c===f._name)throw new Error("Command alias can't be the same as its name");let y=this.parent?._findCommand(c);if(y){let b=[y.name()].concat(y.aliases()).join("|");throw new Error(`cannot add alias '${c}' to command '${this.name()}' as already have command '${b}'`)}return f._aliases.push(c),this}aliases(c){return c===void 0?this._aliases:(c.forEach(f=>this.alias(f)),this)}usage(c){if(c===void 0){if(this._usage)return this._usage;let f=this.registeredArguments.map(y=>$qt(y));return[].concat(this.options.length||this._helpOption!==null?"[options]":[],this.commands.length?"[command]":[],this.registeredArguments.length?f:[]).join(" ")}return this._usage=c,this}name(c){return c===void 0?this._name:(this._name=c,this)}nameFromFilename(c){return this._name=iP.basename(c,iP.extname(c)),this}executableDir(c){return c===void 0?this._executableDir:(this._executableDir=c,this)}helpInformation(c){let f=this.createHelp();return f.helpWidth===void 0&&(f.helpWidth=c&&c.error?this._outputConfiguration.getErrHelpWidth():this._outputConfiguration.getOutHelpWidth()),f.formatHelp(this,f)}_getHelpContext(c){c=c||{};let f={error:!!c.error},y;return f.error?y=b=>this._outputConfiguration.writeErr(b):y=b=>this._outputConfiguration.writeOut(b),f.write=c.write||y,f.command=this,f}outputHelp(c){let f;typeof c=="function"&&(f=c,c=void 0);let y=this._getHelpContext(c);this._getCommandAndAncestors().reverse().forEach(A=>A.emit("beforeAllHelp",y)),this.emit("beforeHelp",y);let b=this.helpInformation(y);if(f&&(b=f(b),typeof b!="string"&&!Buffer.isBuffer(b)))throw new Error("outputHelp callback must return a string or a Buffer");y.write(b),this._getHelpOption()?.long&&this.emit(this._getHelpOption().long),this.emit("afterHelp",y),this._getCommandAndAncestors().forEach(A=>A.emit("afterAllHelp",y))}helpOption(c,f){return typeof c=="boolean"?(c?this._helpOption=this._helpOption??void 0:this._helpOption=null,this):(c=c??"-h, --help",f=f??"display help for command",this._helpOption=this.createOption(c,f),this)}_getHelpOption(){return this._helpOption===void 0&&this.helpOption(void 0,void 0),this._helpOption}addHelpOption(c){return this._helpOption=c,this}help(c){this.outputHelp(c);let f=qd.exitCode||0;f===0&&c&&typeof c!="function"&&c.error&&(f=1),this._exit(f,"commander.help","(outputHelp)")}addHelpText(c,f){let y=["beforeAll","before","after","afterAll"];if(!y.includes(c))throw new Error(`Unexpected value for position to addHelpText.
Expecting one of '${y.join("', '")}'`);let b=`${c}Help`;return this.on(b,A=>{let g;typeof f=="function"?g=f({error:A.error,command:A.command}):g=f,g&&A.write(`${g}
`)}),this}_outputHelpIfRequested(c){let f=this._getHelpOption();f&&c.find(b=>f.is(b))&&(this.outputHelp(),this._exit(0,"commander.helpDisplayed","(outputHelp)"))}};function yXe(l){return l.map(c=>{if(!c.startsWith("--inspect"))return c;let f,y="127.0.0.1",b="9229",A;return(A=c.match(/^(--inspect(-brk)?)$/))!==null?f=A[1]:(A=c.match(/^(--inspect(-brk|-port)?)=([^:]+)$/))!==null?(f=A[1],/^\d+$/.test(A[3])?b=A[3]:y=A[3]):(A=c.match(/^(--inspect(-brk|-port)?)=([^:]+):(\d+)$/))!==null&&(f=A[1],y=A[3],b=A[4]),f&&b!=="0"?`${f}=${y}:${parseInt(b)+1}`:c})}vXe.Command=AAe});var xXe=xt(AT=>{var{Argument:bXe}=Mne(),{Command:kAe}=SXe(),{CommanderError:Yqt,InvalidArgumentError:TXe}=Mq(),{Help:Kqt}=yAe(),{Option:EXe}=TAe();AT.program=new kAe;AT.createCommand=l=>new kAe(l);AT.createOption=(l,c)=>new EXe(l,c);AT.createArgument=(l,c)=>new bXe(l,c);AT.Command=kAe;AT.Option=EXe;AT.Argument=bXe;AT.Help=Kqt;AT.CommanderError=Yqt;AT.InvalidArgumentError=TXe;AT.InvalidOptionArgumentError=TXe});var AXe,kXe=Jo(()=>{AXe=typeof globalThis=="object"?globalThis:global});var PXe=Jo(()=>{kXe()});var NXe=Jo(()=>{PXe()});var sP,NAe=Jo(()=>{sP="1.9.0"});function uzt(l){var c=new Set([l]),f=new Set,y=l.match(DXe);if(!y)return function(){return!1};var b={major:+y[1],minor:+y[2],patch:+y[3],prerelease:y[4]};if(b.prerelease!=null)return function(k){return k===l};function A(p){return f.add(p),!1}function g(p){return c.add(p),!0}return function(k){if(c.has(k))return!0;if(f.has(k))return!1;var j=k.match(DXe);if(!j)return A(k);var se={major:+j[1],minor:+j[2],patch:+j[3],prerelease:j[4]};return se.prerelease!=null||b.major!==se.major?A(k):b.major===0?b.minor===se.minor&&b.patch<=se.patch?g(k):A(k):b.minor<=se.minor?g(k):A(k)}}var DXe,wXe,IXe=Jo(()=>{NAe();DXe=/^(\d+)\.(\d+)\.(\d+)(-(.+))?$/;wXe=uzt(sP)});function dC(l,c,f,y){var b;y===void 0&&(y=!1);var A=Fq[Lq]=(b=Fq[Lq])!==null&&b!==void 0?b:{version:sP};if(!y&&A[l]){var g=new Error("@opentelemetry/api: Attempted duplicate registration of API: "+l);return f.error(g.stack||g.message),!1}if(A.version!==sP){var g=new Error("@opentelemetry/api: Registration of version v"+A.version+" for "+l+" does not match previously registered API v"+sP);return f.error(g.stack||g.message),!1}return A[l]=c,f.debug("@opentelemetry/api: Registered a global for "+l+" v"+sP+"."),!0}function zS(l){var c,f,y=(c=Fq[Lq])===null||c===void 0?void 0:c.version;if(!(!y||!wXe(y)))return(f=Fq[Lq])===null||f===void 0?void 0:f[l]}function mC(l,c){c.debug("@opentelemetry/api: Unregistering a global for "+l+" v"+sP+".");var f=Fq[Lq];f&&delete f[l]}var _zt,Lq,Fq,x4=Jo(()=>{NXe();NAe();IXe();_zt=sP.split(".")[0],Lq=Symbol.for("opentelemetry.js.api."+_zt),Fq=AXe});function jq(l,c,f){var y=zS("diag");if(y)return f.unshift(c),y[l].apply(y,pzt([],fzt(f),!1))}var fzt,pzt,OXe,RXe=Jo(()=>{x4();fzt=function(l,c){var f=typeof Symbol=="function"&&l[Symbol.iterator];if(!f)return l;var y=f.call(l),b,A=[],g;try{for(;(c===void 0||c-- >0)&&!(b=y.next()).done;)A.push(b.value)}catch(p){g={error:p}}finally{try{b&&!b.done&&(f=y.return)&&f.call(y)}finally{if(g)throw g.error}}return A},pzt=function(l,c,f){if(f||arguments.length===2)for(var y=0,b=c.length,A;y<b;y++)(A||!(y in c))&&(A||(A=Array.prototype.slice.call(c,0,y)),A[y]=c[y]);return l.concat(A||Array.prototype.slice.call(c))},OXe=function(){function l(c){this._namespace=c.namespace||"DiagComponentLogger"}return l.prototype.debug=function(){for(var c=[],f=0;f<arguments.length;f++)c[f]=arguments[f];return jq("debug",this._namespace,c)},l.prototype.error=function(){for(var c=[],f=0;f<arguments.length;f++)c[f]=arguments[f];return jq("error",this._namespace,c)},l.prototype.info=function(){for(var c=[],f=0;f<arguments.length;f++)c[f]=arguments[f];return jq("info",this._namespace,c)},l.prototype.warn=function(){for(var c=[],f=0;f<arguments.length;f++)c[f]=arguments[f];return jq("warn",this._namespace,c)},l.prototype.verbose=function(){for(var c=[],f=0;f<arguments.length;f++)c[f]=arguments[f];return jq("verbose",this._namespace,c)},l}()});var fy,Fne=Jo(()=>{(function(l){l[l.NONE=0]="NONE",l[l.ERROR=30]="ERROR",l[l.WARN=50]="WARN",l[l.INFO=60]="INFO",l[l.DEBUG=70]="DEBUG",l[l.VERBOSE=80]="VERBOSE",l[l.ALL=9999]="ALL"})(fy||(fy={}))});function MXe(l,c){l<fy.NONE?l=fy.NONE:l>fy.ALL&&(l=fy.ALL),c=c||{};function f(y,b){var A=c[y];return typeof A=="function"&&l>=b?A.bind(c):function(){}}return{error:f("error",fy.ERROR),warn:f("warn",fy.WARN),info:f("info",fy.INFO),debug:f("debug",fy.DEBUG),verbose:f("verbose",fy.VERBOSE)}}var LXe=Jo(()=>{Fne()});var dzt,mzt,gzt,Qy,C4=Jo(()=>{RXe();LXe();Fne();x4();dzt=function(l,c){var f=typeof Symbol=="function"&&l[Symbol.iterator];if(!f)return l;var y=f.call(l),b,A=[],g;try{for(;(c===void 0||c-- >0)&&!(b=y.next()).done;)A.push(b.value)}catch(p){g={error:p}}finally{try{b&&!b.done&&(f=y.return)&&f.call(y)}finally{if(g)throw g.error}}return A},mzt=function(l,c,f){if(f||arguments.length===2)for(var y=0,b=c.length,A;y<b;y++)(A||!(y in c))&&(A||(A=Array.prototype.slice.call(c,0,y)),A[y]=c[y]);return l.concat(A||Array.prototype.slice.call(c))},gzt="diag",Qy=function(){function l(){function c(b){return function(){for(var A=[],g=0;g<arguments.length;g++)A[g]=arguments[g];var p=zS("diag");if(p)return p[b].apply(p,mzt([],dzt(A),!1))}}var f=this,y=function(b,A){var g,p,k;if(A===void 0&&(A={logLevel:fy.INFO}),b===f){var j=new Error("Cannot use diag as the logger for itself. Please use a DiagLogger implementation like ConsoleDiagLogger or a custom implementation");return f.error((g=j.stack)!==null&&g!==void 0?g:j.message),!1}typeof A=="number"&&(A={logLevel:A});var se=zS("diag"),ze=MXe((p=A.logLevel)!==null&&p!==void 0?p:fy.INFO,b);if(se&&!A.suppressOverrideMessage){var ve=(k=new Error().stack)!==null&&k!==void 0?k:"<failed to generate stacktrace>";se.warn("Current logger will be overwritten from "+ve),ze.warn("Current logger will overwrite one already registered from "+ve)}return dC("diag",ze,f,!0)};f.setLogger=y,f.disable=function(){mC(gzt,f)},f.createComponentLogger=function(b){return new OXe(b)},f.verbose=c("verbose"),f.debug=c("debug"),f.info=c("info"),f.warn=c("warn"),f.error=c("error")}return l.instance=function(){return this._instance||(this._instance=new l),this._instance},l}()});var hzt,yzt,FXe,jXe=Jo(()=>{hzt=function(l,c){var f=typeof Symbol=="function"&&l[Symbol.iterator];if(!f)return l;var y=f.call(l),b,A=[],g;try{for(;(c===void 0||c-- >0)&&!(b=y.next()).done;)A.push(b.value)}catch(p){g={error:p}}finally{try{b&&!b.done&&(f=y.return)&&f.call(y)}finally{if(g)throw g.error}}return A},yzt=function(l){var c=typeof Symbol=="function"&&Symbol.iterator,f=c&&l[c],y=0;if(f)return f.call(l);if(l&&typeof l.length=="number")return{next:function(){return l&&y>=l.length&&(l=void 0),{value:l&&l[y++],done:!l}}};throw new TypeError(c?"Object is not iterable.":"Symbol.iterator is not defined.")},FXe=function(){function l(c){this._entries=c?new Map(c):new Map}return l.prototype.getEntry=function(c){var f=this._entries.get(c);if(f)return Object.assign({},f)},l.prototype.getAllEntries=function(){return Array.from(this._entries.entries()).map(function(c){var f=hzt(c,2),y=f[0],b=f[1];return[y,b]})},l.prototype.setEntry=function(c,f){var y=new l(this._entries);return y._entries.set(c,f),y},l.prototype.removeEntry=function(c){var f=new l(this._entries);return f._entries.delete(c),f},l.prototype.removeEntries=function(){for(var c,f,y=[],b=0;b<arguments.length;b++)y[b]=arguments[b];var A=new l(this._entries);try{for(var g=yzt(y),p=g.next();!p.done;p=g.next()){var k=p.value;A._entries.delete(k)}}catch(j){c={error:j}}finally{try{p&&!p.done&&(f=g.return)&&f.call(g)}finally{if(c)throw c.error}}return A},l.prototype.clear=function(){return new l},l}()});var BXe,UXe=Jo(()=>{BXe=Symbol("BaggageEntryMetadata")});function VXe(l){return l===void 0&&(l={}),new FXe(new Map(Object.entries(l)))}function JXe(l){return typeof l!="string"&&(vzt.error("Cannot create baggage metadata from unknown type: "+typeof l),l=""),{__TYPE__:BXe,toString:function(){return l}}}var vzt,DAe=Jo(()=>{C4();jXe();UXe();vzt=Qy.instance()});function gL(l){return Symbol.for(l)}var Szt,jne,Bq=Jo(()=>{Szt=function(){function l(c){var f=this;f._currentContext=c?new Map(c):new Map,f.getValue=function(y){return f._currentContext.get(y)},f.setValue=function(y,b){var A=new l(f._currentContext);return A._currentContext.set(y,b),A},f.deleteValue=function(y){var b=new l(f._currentContext);return b._currentContext.delete(y),b}}return l}(),jne=new Szt});var wAe,qXe,zXe=Jo(()=>{wAe=[{n:"error",c:"error"},{n:"warn",c:"warn"},{n:"info",c:"info"},{n:"debug",c:"debug"},{n:"verbose",c:"trace"}],qXe=function(){function l(){function c(y){return function(){for(var b=[],A=0;A<arguments.length;A++)b[A]=arguments[A];if(console){var g=console[y];if(typeof g!="function"&&(g=console.log),typeof g=="function")return g.apply(console,b)}}}for(var f=0;f<wAe.length;f++)this[wAe[f].n]=c(wAe[f].c)}return l}()});function WXe(){return OAe}var A4,bzt,Bne,Tzt,Ezt,xzt,Czt,IAe,Azt,kzt,Pzt,OAe,Nzt,Dzt,wzt,Izt,Ozt,Rzt,Mzt,RAe=Jo(()=>{A4=function(){var l=function(c,f){return l=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(y,b){y.__proto__=b}||function(y,b){for(var A in b)Object.prototype.hasOwnProperty.call(b,A)&&(y[A]=b[A])},l(c,f)};return function(c,f){if(typeof f!="function"&&f!==null)throw new TypeError("Class extends value "+String(f)+" is not a constructor or null");l(c,f);function y(){this.constructor=c}c.prototype=f===null?Object.create(f):(y.prototype=f.prototype,new y)}}(),bzt=function(){function l(){}return l.prototype.createGauge=function(c,f){return Dzt},l.prototype.createHistogram=function(c,f){return wzt},l.prototype.createCounter=function(c,f){return Nzt},l.prototype.createUpDownCounter=function(c,f){return Izt},l.prototype.createObservableGauge=function(c,f){return Rzt},l.prototype.createObservableCounter=function(c,f){return Ozt},l.prototype.createObservableUpDownCounter=function(c,f){return Mzt},l.prototype.addBatchObservableCallback=function(c,f){},l.prototype.removeBatchObservableCallback=function(c){},l}(),Bne=function(){function l(){}return l}(),Tzt=function(l){A4(c,l);function c(){return l!==null&&l.apply(this,arguments)||this}return c.prototype.add=function(f,y){},c}(Bne),Ezt=function(l){A4(c,l);function c(){return l!==null&&l.apply(this,arguments)||this}return c.prototype.add=function(f,y){},c}(Bne),xzt=function(l){A4(c,l);function c(){return l!==null&&l.apply(this,arguments)||this}return c.prototype.record=function(f,y){},c}(Bne),Czt=function(l){A4(c,l);function c(){return l!==null&&l.apply(this,arguments)||this}return c.prototype.record=function(f,y){},c}(Bne),IAe=function(){function l(){}return l.prototype.addCallback=function(c){},l.prototype.removeCallback=function(c){},l}(),Azt=function(l){A4(c,l);function c(){return l!==null&&l.apply(this,arguments)||this}return c}(IAe),kzt=function(l){A4(c,l);function c(){return l!==null&&l.apply(this,arguments)||this}return c}(IAe),Pzt=function(l){A4(c,l);function c(){return l!==null&&l.apply(this,arguments)||this}return c}(IAe),OAe=new bzt,Nzt=new Tzt,Dzt=new xzt,wzt=new Czt,Izt=new Ezt,Ozt=new Azt,Rzt=new kzt,Mzt=new Pzt});var hL,$Xe=Jo(()=>{(function(l){l[l.INT=0]="INT",l[l.DOUBLE=1]="DOUBLE"})(hL||(hL={}))});var Une,Vne,MAe=Jo(()=>{Une={get:function(l,c){if(l!=null)return l[c]},keys:function(l){return l==null?[]:Object.keys(l)}},Vne={set:function(l,c,f){l!=null&&(l[c]=f)}}});var Lzt,Fzt,HXe,GXe=Jo(()=>{Bq();Lzt=function(l,c){var f=typeof Symbol=="function"&&l[Symbol.iterator];if(!f)return l;var y=f.call(l),b,A=[],g;try{for(;(c===void 0||c-- >0)&&!(b=y.next()).done;)A.push(b.value)}catch(p){g={error:p}}finally{try{b&&!b.done&&(f=y.return)&&f.call(y)}finally{if(g)throw g.error}}return A},Fzt=function(l,c,f){if(f||arguments.length===2)for(var y=0,b=c.length,A;y<b;y++)(A||!(y in c))&&(A||(A=Array.prototype.slice.call(c,0,y)),A[y]=c[y]);return l.concat(A||Array.prototype.slice.call(c))},HXe=function(){function l(){}return l.prototype.active=function(){return jne},l.prototype.with=function(c,f,y){for(var b=[],A=3;A<arguments.length;A++)b[A-3]=arguments[A];return f.call.apply(f,Fzt([y],Lzt(b),!1))},l.prototype.bind=function(c,f){return f},l.prototype.enable=function(){return this},l.prototype.disable=function(){return this},l}()});var jzt,Bzt,LAe,Uzt,cw,Uq=Jo(()=>{GXe();x4();C4();jzt=function(l,c){var f=typeof Symbol=="function"&&l[Symbol.iterator];if(!f)return l;var y=f.call(l),b,A=[],g;try{for(;(c===void 0||c-- >0)&&!(b=y.next()).done;)A.push(b.value)}catch(p){g={error:p}}finally{try{b&&!b.done&&(f=y.return)&&f.call(y)}finally{if(g)throw g.error}}return A},Bzt=function(l,c,f){if(f||arguments.length===2)for(var y=0,b=c.length,A;y<b;y++)(A||!(y in c))&&(A||(A=Array.prototype.slice.call(c,0,y)),A[y]=c[y]);return l.concat(A||Array.prototype.slice.call(c))},LAe="context",Uzt=new HXe,cw=function(){function l(){}return l.getInstance=function(){return this._instance||(this._instance=new l),this._instance},l.prototype.setGlobalContextManager=function(c){return dC(LAe,c,Qy.instance())},l.prototype.active=function(){return this._getContextManager().active()},l.prototype.with=function(c,f,y){for(var b,A=[],g=3;g<arguments.length;g++)A[g-3]=arguments[g];return(b=this._getContextManager()).with.apply(b,Bzt([c,f,y],jzt(A),!1))},l.prototype.bind=function(c,f){return this._getContextManager().bind(c,f)},l.prototype._getContextManager=function(){return zS(LAe)||Uzt},l.prototype.disable=function(){this._getContextManager().disable(),mC(LAe,Qy.instance())},l}()});var yL,FAe=Jo(()=>{(function(l){l[l.NONE=0]="NONE",l[l.SAMPLED=1]="SAMPLED"})(yL||(yL={}))});var Vq,Jq,Jne,qne=Jo(()=>{FAe();Vq="0000000000000000",Jq="00000000000000000000000000000000",Jne={traceId:Jq,spanId:Vq,traceFlags:yL.NONE}});var lw,zne=Jo(()=>{qne();lw=function(){function l(c){c===void 0&&(c=Jne),this._spanContext=c}return l.prototype.spanContext=function(){return this._spanContext},l.prototype.setAttribute=function(c,f){return this},l.prototype.setAttributes=function(c){return this},l.prototype.addEvent=function(c,f){return this},l.prototype.addLink=function(c){return this},l.prototype.addLinks=function(c){return this},l.prototype.setStatus=function(c){return this},l.prototype.updateName=function(c){return this},l.prototype.end=function(c){},l.prototype.isRecording=function(){return!1},l.prototype.recordException=function(c,f){},l}()});function Wne(l){return l.getValue(jAe)||void 0}function YXe(){return Wne(cw.getInstance().active())}function qq(l,c){return l.setValue(jAe,c)}function KXe(l){return l.deleteValue(jAe)}function XXe(l,c){return qq(l,new lw(c))}function $ne(l){var c;return(c=Wne(l))===null||c===void 0?void 0:c.spanContext()}var jAe,BAe=Jo(()=>{Bq();zne();Uq();jAe=gL("OpenTelemetry Context Key SPAN")});function UAe(l){return Vzt.test(l)&&l!==Jq}function VAe(l){return Jzt.test(l)&&l!==Vq}function vL(l){return UAe(l.traceId)&&VAe(l.spanId)}function QXe(l){return new lw(l)}var Vzt,Jzt,Hne=Jo(()=>{qne();zne();Vzt=/^([0-9a-f]{32})$/i,Jzt=/^[0-9a-f]{16}$/i});function qzt(l){return typeof l=="object"&&typeof l.spanId=="string"&&typeof l.traceId=="string"&&typeof l.traceFlags=="number"}var JAe,Gne,qAe=Jo(()=>{Uq();BAe();zne();Hne();JAe=cw.getInstance(),Gne=function(){function l(){}return l.prototype.startSpan=function(c,f,y){y===void 0&&(y=JAe.active());var b=!!f?.root;if(b)return new lw;var A=y&&$ne(y);return qzt(A)&&vL(A)?new lw(A):new lw},l.prototype.startActiveSpan=function(c,f,y,b){var A,g,p;if(!(arguments.length<2)){arguments.length===2?p=f:arguments.length===3?(A=f,p=y):(A=f,g=y,p=b);var k=g??JAe.active(),j=this.startSpan(c,A,k),se=qq(k,j);return JAe.with(se,p,void 0,j)}},l}()});var zzt,Yne,zAe=Jo(()=>{qAe();zzt=new Gne,Yne=function(){function l(c,f,y,b){this._provider=c,this.name=f,this.version=y,this.options=b}return l.prototype.startSpan=function(c,f,y){return this._getTracer().startSpan(c,f,y)},l.prototype.startActiveSpan=function(c,f,y,b){var A=this._getTracer();return Reflect.apply(A.startActiveSpan,A,arguments)},l.prototype._getTracer=function(){if(this._delegate)return this._delegate;var c=this._provider.getDelegateTracer(this.name,this.version,this.options);return c?(this._delegate=c,this._delegate):zzt},l}()});var ZXe,eQe=Jo(()=>{qAe();ZXe=function(){function l(){}return l.prototype.getTracer=function(c,f,y){return new Gne},l}()});var Wzt,zq,WAe=Jo(()=>{zAe();eQe();Wzt=new ZXe,zq=function(){function l(){}return l.prototype.getTracer=function(c,f,y){var b;return(b=this.getDelegateTracer(c,f,y))!==null&&b!==void 0?b:new Yne(this,c,f,y)},l.prototype.getDelegate=function(){var c;return(c=this._delegate)!==null&&c!==void 0?c:Wzt},l.prototype.setDelegate=function(c){this._delegate=c},l.prototype.getDelegateTracer=function(c,f,y){var b;return(b=this._delegate)===null||b===void 0?void 0:b.getTracer(c,f,y)},l}()});var Kne,tQe=Jo(()=>{(function(l){l[l.NOT_RECORD=0]="NOT_RECORD",l[l.RECORD=1]="RECORD",l[l.RECORD_AND_SAMPLED=2]="RECORD_AND_SAMPLED"})(Kne||(Kne={}))});var Xne,rQe=Jo(()=>{(function(l){l[l.INTERNAL=0]="INTERNAL",l[l.SERVER=1]="SERVER",l[l.CLIENT=2]="CLIENT",l[l.PRODUCER=3]="PRODUCER",l[l.CONSUMER=4]="CONSUMER"})(Xne||(Xne={}))});var Qne,nQe=Jo(()=>{(function(l){l[l.UNSET=0]="UNSET",l[l.OK=1]="OK",l[l.ERROR=2]="ERROR"})(Qne||(Qne={}))});function iQe(l){return Gzt.test(l)}function sQe(l){return Yzt.test(l)&&!Kzt.test(l)}var $Ae,$zt,Hzt,Gzt,Yzt,Kzt,aQe=Jo(()=>{$Ae="[_0-9a-z-*/]",$zt="[a-z]"+$Ae+"{0,255}",Hzt="[a-z0-9]"+$Ae+"{0,240}@[a-z]"+$Ae+"{0,13}",Gzt=new RegExp("^(?:"+$zt+"|"+Hzt+")$"),Yzt=/^[ -~]{0,255}[!-~]$/,Kzt=/,|=/});var oQe,Xzt,cQe,lQe,uQe,_Qe=Jo(()=>{aQe();oQe=32,Xzt=512,cQe=",",lQe="=",uQe=function(){function l(c){this._internalState=new Map,c&&this._parse(c)}return l.prototype.set=function(c,f){var y=this._clone();return y._internalState.has(c)&&y._internalState.delete(c),y._internalState.set(c,f),y},l.prototype.unset=function(c){var f=this._clone();return f._internalState.delete(c),f},l.prototype.get=function(c){return this._internalState.get(c)},l.prototype.serialize=function(){var c=this;return this._keys().reduce(function(f,y){return f.push(y+lQe+c.get(y)),f},[]).join(cQe)},l.prototype._parse=function(c){c.length>Xzt||(this._internalState=c.split(cQe).reverse().reduce(function(f,y){var b=y.trim(),A=b.indexOf(lQe);if(A!==-1){var g=b.slice(0,A),p=b.slice(A+1,y.length);iQe(g)&&sQe(p)&&f.set(g,p)}return f},new Map),this._internalState.size>oQe&&(this._internalState=new Map(Array.from(this._internalState.entries()).reverse().slice(0,oQe))))},l.prototype._keys=function(){return Array.from(this._internalState.keys()).reverse()},l.prototype._clone=function(){var c=new l;return c._internalState=new Map(this._internalState),c},l}()});function fQe(l){return new uQe(l)}var pQe=Jo(()=>{_Qe()});var HAe,dQe=Jo(()=>{Uq();HAe=cw.getInstance()});var GAe,mQe=Jo(()=>{C4();GAe=Qy.instance()});var Qzt,gQe,hQe=Jo(()=>{RAe();Qzt=function(){function l(){}return l.prototype.getMeter=function(c,f,y){return OAe},l}(),gQe=new Qzt});var YAe,yQe,vQe=Jo(()=>{hQe();x4();C4();YAe="metrics",yQe=function(){function l(){}return l.getInstance=function(){return this._instance||(this._instance=new l),this._instance},l.prototype.setGlobalMeterProvider=function(c){return dC(YAe,c,Qy.instance())},l.prototype.getMeterProvider=function(){return zS(YAe)||gQe},l.prototype.getMeter=function(c,f,y){return this.getMeterProvider().getMeter(c,f,y)},l.prototype.disable=function(){mC(YAe,Qy.instance())},l}()});var KAe,SQe=Jo(()=>{vQe();KAe=yQe.getInstance()});var bQe,TQe=Jo(()=>{bQe=function(){function l(){}return l.prototype.inject=function(c,f){},l.prototype.extract=function(c,f){return c},l.prototype.fields=function(){return[]},l}()});function QAe(l){return l.getValue(XAe)||void 0}function EQe(){return QAe(cw.getInstance().active())}function xQe(l,c){return l.setValue(XAe,c)}function CQe(l){return l.deleteValue(XAe)}var XAe,AQe=Jo(()=>{Uq();Bq();XAe=gL("OpenTelemetry Baggage Key")});var ZAe,Zzt,kQe,PQe=Jo(()=>{x4();TQe();MAe();AQe();DAe();C4();ZAe="propagation",Zzt=new bQe,kQe=function(){function l(){this.createBaggage=VXe,this.getBaggage=QAe,this.getActiveBaggage=EQe,this.setBaggage=xQe,this.deleteBaggage=CQe}return l.getInstance=function(){return this._instance||(this._instance=new l),this._instance},l.prototype.setGlobalPropagator=function(c){return dC(ZAe,c,Qy.instance())},l.prototype.inject=function(c,f,y){return y===void 0&&(y=Vne),this._getGlobalPropagator().inject(c,f,y)},l.prototype.extract=function(c,f,y){return y===void 0&&(y=Une),this._getGlobalPropagator().extract(c,f,y)},l.prototype.fields=function(){return this._getGlobalPropagator().fields()},l.prototype.disable=function(){mC(ZAe,Qy.instance())},l.prototype._getGlobalPropagator=function(){return zS(ZAe)||Zzt},l}()});var eke,NQe=Jo(()=>{PQe();eke=kQe.getInstance()});var tke,DQe,wQe=Jo(()=>{x4();WAe();Hne();BAe();C4();tke="trace",DQe=function(){function l(){this._proxyTracerProvider=new zq,this.wrapSpanContext=QXe,this.isSpanContextValid=vL,this.deleteSpan=KXe,this.getSpan=Wne,this.getActiveSpan=YXe,this.getSpanContext=$ne,this.setSpan=qq,this.setSpanContext=XXe}return l.getInstance=function(){return this._instance||(this._instance=new l),this._instance},l.prototype.setGlobalTracerProvider=function(c){var f=dC(tke,this._proxyTracerProvider,Qy.instance());return f&&this._proxyTracerProvider.setDelegate(c),f},l.prototype.getTracerProvider=function(){return zS(tke)||this._proxyTracerProvider},l.prototype.getTracer=function(c,f){return this.getTracerProvider().getTracer(c,f)},l.prototype.disable=function(){mC(tke,Qy.instance()),this._proxyTracerProvider=new zq},l}()});var rke,IQe=Jo(()=>{wQe();rke=DQe.getInstance()});var Xc={};fAe(Xc,{DiagConsoleLogger:()=>qXe,DiagLogLevel:()=>fy,INVALID_SPANID:()=>Vq,INVALID_SPAN_CONTEXT:()=>Jne,INVALID_TRACEID:()=>Jq,ProxyTracer:()=>Yne,ProxyTracerProvider:()=>zq,ROOT_CONTEXT:()=>jne,SamplingDecision:()=>Kne,SpanKind:()=>Xne,SpanStatusCode:()=>Qne,TraceFlags:()=>yL,ValueType:()=>hL,baggageEntryMetadataFromString:()=>JXe,context:()=>HAe,createContextKey:()=>gL,createNoopMeter:()=>WXe,createTraceState:()=>fQe,default:()=>eWt,defaultTextMapGetter:()=>Une,defaultTextMapSetter:()=>Vne,diag:()=>GAe,isSpanContextValid:()=>vL,isValidSpanId:()=>VAe,isValidTraceId:()=>UAe,metrics:()=>KAe,propagation:()=>eke,trace:()=>rke});var eWt,zc=Jo(()=>{DAe();Bq();zXe();Fne();RAe();$Xe();MAe();zAe();WAe();tQe();rQe();nQe();FAe();pQe();Hne();qne();dQe();mQe();SQe();NQe();IQe();eWt={context:HAe,diag:GAe,metrics:KAe,propagation:eke,trace:rke}});var Wq=xt(uw=>{"use strict";Object.defineProperty(uw,"__esModule",{value:!0});uw.isTracingSuppressed=uw.unsuppressTracing=uw.suppressTracing=void 0;var tWt=(zc(),fc(Xc)),nke=(0,tWt.createContextKey)("OpenTelemetry SDK Context Key SUPPRESS_TRACING");function rWt(l){return l.setValue(nke,!0)}uw.suppressTracing=rWt;function nWt(l){return l.deleteValue(nke)}uw.unsuppressTracing=nWt;function iWt(l){return l.getValue(nke)===!0}uw.isTracingSuppressed=iWt});var ike=xt(Zy=>{"use strict";Object.defineProperty(Zy,"__esModule",{value:!0});Zy.BAGGAGE_MAX_TOTAL_LENGTH=Zy.BAGGAGE_MAX_PER_NAME_VALUE_PAIRS=Zy.BAGGAGE_MAX_NAME_VALUE_PAIRS=Zy.BAGGAGE_HEADER=Zy.BAGGAGE_ITEMS_SEPARATOR=Zy.BAGGAGE_PROPERTIES_SEPARATOR=Zy.BAGGAGE_KEY_PAIR_SEPARATOR=void 0;Zy.BAGGAGE_KEY_PAIR_SEPARATOR="=";Zy.BAGGAGE_PROPERTIES_SEPARATOR=";";Zy.BAGGAGE_ITEMS_SEPARATOR=",";Zy.BAGGAGE_HEADER="baggage";Zy.BAGGAGE_MAX_NAME_VALUE_PAIRS=180;Zy.BAGGAGE_MAX_PER_NAME_VALUE_PAIRS=4096;Zy.BAGGAGE_MAX_TOTAL_LENGTH=8192});var ske=xt(gC=>{"use strict";Object.defineProperty(gC,"__esModule",{value:!0});gC.parseKeyPairsIntoRecord=gC.parsePairKeyValue=gC.getKeyPairs=gC.serializeKeyPairs=void 0;var sWt=(zc(),fc(Xc)),k4=ike();function aWt(l){return l.reduce((c,f)=>{let y=`${c}${c!==""?k4.BAGGAGE_ITEMS_SEPARATOR:""}${f}`;return y.length>k4.BAGGAGE_MAX_TOTAL_LENGTH?c:y},"")}gC.serializeKeyPairs=aWt;function oWt(l){return l.getAllEntries().map(([c,f])=>{let y=`${encodeURIComponent(c)}=${encodeURIComponent(f.value)}`;return f.metadata!==void 0&&(y+=k4.BAGGAGE_PROPERTIES_SEPARATOR+f.metadata.toString()),y})}gC.getKeyPairs=oWt;function OQe(l){let c=l.split(k4.BAGGAGE_PROPERTIES_SEPARATOR);if(c.length<=0)return;let f=c.shift();if(!f)return;let y=f.indexOf(k4.BAGGAGE_KEY_PAIR_SEPARATOR);if(y<=0)return;let b=decodeURIComponent(f.substring(0,y).trim()),A=decodeURIComponent(f.substring(y+1).trim()),g;return c.length>0&&(g=(0,sWt.baggageEntryMetadataFromString)(c.join(k4.BAGGAGE_PROPERTIES_SEPARATOR))),{key:b,value:A,metadata:g}}gC.parsePairKeyValue=OQe;function cWt(l){return typeof l!="string"||l.length===0?{}:l.split(k4.BAGGAGE_ITEMS_SEPARATOR).map(c=>OQe(c)).filter(c=>c!==void 0&&c.value.length>0).reduce((c,f)=>(c[f.key]=f.value,c),{})}gC.parseKeyPairsIntoRecord=cWt});var RQe=xt(Zne=>{"use strict";Object.defineProperty(Zne,"__esModule",{value:!0});Zne.W3CBaggagePropagator=void 0;var ake=(zc(),fc(Xc)),lWt=Wq(),P4=ike(),oke=ske(),cke=class{inject(c,f,y){let b=ake.propagation.getBaggage(c);if(!b||(0,lWt.isTracingSuppressed)(c))return;let A=(0,oke.getKeyPairs)(b).filter(p=>p.length<=P4.BAGGAGE_MAX_PER_NAME_VALUE_PAIRS).slice(0,P4.BAGGAGE_MAX_NAME_VALUE_PAIRS),g=(0,oke.serializeKeyPairs)(A);g.length>0&&y.set(f,P4.BAGGAGE_HEADER,g)}extract(c,f,y){let b=y.get(f,P4.BAGGAGE_HEADER),A=Array.isArray(b)?b.join(P4.BAGGAGE_ITEMS_SEPARATOR):b;if(!A)return c;let g={};return A.length===0||(A.split(P4.BAGGAGE_ITEMS_SEPARATOR).forEach(k=>{let j=(0,oke.parsePairKeyValue)(k);if(j){let se={value:j.value};j.metadata&&(se.metadata=j.metadata),g[j.key]=se}}),Object.entries(g).length===0)?c:ake.propagation.setBaggage(c,ake.propagation.createBaggage(g))}fields(){return[P4.BAGGAGE_HEADER]}};Zne.W3CBaggagePropagator=cke});var MQe=xt(eie=>{"use strict";Object.defineProperty(eie,"__esModule",{value:!0});eie.AnchoredClock=void 0;var lke=class{constructor(c,f){this._monotonicClock=f,this._epochMillis=c.now(),this._performanceMillis=f.now()}now(){let c=this._monotonicClock.now()-this._performanceMillis;return this._epochMillis+c}};eie.AnchoredClock=lke});var UQe=xt(_w=>{"use strict";Object.defineProperty(_w,"__esModule",{value:!0});_w.isAttributeValue=_w.isAttributeKey=_w.sanitizeAttributes=void 0;var LQe=(zc(),fc(Xc));function uWt(l){let c={};if(typeof l!="object"||l==null)return c;for(let[f,y]of Object.entries(l)){if(!FQe(f)){LQe.diag.warn(`Invalid attribute key: ${f}`);continue}if(!jQe(y)){LQe.diag.warn(`Invalid attribute value set for key: ${f}`);continue}Array.isArray(y)?c[f]=y.slice():c[f]=y}return c}_w.sanitizeAttributes=uWt;function FQe(l){return typeof l=="string"&&l.length>0}_w.isAttributeKey=FQe;function jQe(l){return l==null?!0:Array.isArray(l)?_Wt(l):BQe(l)}_w.isAttributeValue=jQe;function _Wt(l){let c;for(let f of l)if(f!=null){if(!c){if(BQe(f)){c=typeof f;continue}return!1}if(typeof f!==c)return!1}return!0}function BQe(l){switch(typeof l){case"number":case"boolean":case"string":return!0}return!1}});var uke=xt(tie=>{"use strict";Object.defineProperty(tie,"__esModule",{value:!0});tie.loggingErrorHandler=void 0;var fWt=(zc(),fc(Xc));function pWt(){return l=>{fWt.diag.error(dWt(l))}}tie.loggingErrorHandler=pWt;function dWt(l){return typeof l=="string"?l:JSON.stringify(mWt(l))}function mWt(l){let c={},f=l;for(;f!==null;)Object.getOwnPropertyNames(f).forEach(y=>{if(c[y])return;let b=f[y];b&&(c[y]=String(b))}),f=Object.getPrototypeOf(f);return c}});var _ke=xt(SL=>{"use strict";Object.defineProperty(SL,"__esModule",{value:!0});SL.globalErrorHandler=SL.setGlobalErrorHandler=void 0;var gWt=uke(),VQe=(0,gWt.loggingErrorHandler)();function hWt(l){VQe=l}SL.setGlobalErrorHandler=hWt;function yWt(l){try{VQe(l)}catch{}}SL.globalErrorHandler=yWt});var fke=xt($q=>{"use strict";Object.defineProperty($q,"__esModule",{value:!0});$q.TracesSamplerValues=void 0;var vWt;(function(l){l.AlwaysOff="always_off",l.AlwaysOn="always_on",l.ParentBasedAlwaysOff="parentbased_always_off",l.ParentBasedAlwaysOn="parentbased_always_on",l.ParentBasedTraceIdRatio="parentbased_traceidratio",l.TraceIdRatio="traceidratio"})(vWt=$q.TracesSamplerValues||($q.TracesSamplerValues={}))});var pke=xt(hd=>{"use strict";Object.defineProperty(hd,"__esModule",{value:!0});hd.parseEnvironment=hd.DEFAULT_ENVIRONMENT=hd.DEFAULT_SPAN_ATTRIBUTE_PER_LINK_COUNT_LIMIT=hd.DEFAULT_SPAN_ATTRIBUTE_PER_EVENT_COUNT_LIMIT=hd.DEFAULT_ATTRIBUTE_COUNT_LIMIT=hd.DEFAULT_ATTRIBUTE_VALUE_LENGTH_LIMIT=void 0;var fw=(zc(),fc(Xc)),SWt=fke(),bWt=",",TWt=["OTEL_SDK_DISABLED"];function EWt(l){return TWt.indexOf(l)>-1}var xWt=["OTEL_BSP_EXPORT_TIMEOUT","OTEL_BSP_MAX_EXPORT_BATCH_SIZE","OTEL_BSP_MAX_QUEUE_SIZE","OTEL_BSP_SCHEDULE_DELAY","OTEL_BLRP_EXPORT_TIMEOUT","OTEL_BLRP_MAX_EXPORT_BATCH_SIZE","OTEL_BLRP_MAX_QUEUE_SIZE","OTEL_BLRP_SCHEDULE_DELAY","OTEL_ATTRIBUTE_VALUE_LENGTH_LIMIT","OTEL_ATTRIBUTE_COUNT_LIMIT","OTEL_SPAN_ATTRIBUTE_VALUE_LENGTH_LIMIT","OTEL_SPAN_ATTRIBUTE_COUNT_LIMIT","OTEL_LOGRECORD_ATTRIBUTE_VALUE_LENGTH_LIMIT","OTEL_LOGRECORD_ATTRIBUTE_COUNT_LIMIT","OTEL_SPAN_EVENT_COUNT_LIMIT","OTEL_SPAN_LINK_COUNT_LIMIT","OTEL_SPAN_ATTRIBUTE_PER_EVENT_COUNT_LIMIT","OTEL_SPAN_ATTRIBUTE_PER_LINK_COUNT_LIMIT","OTEL_EXPORTER_OTLP_TIMEOUT","OTEL_EXPORTER_OTLP_TRACES_TIMEOUT","OTEL_EXPORTER_OTLP_METRICS_TIMEOUT","OTEL_EXPORTER_OTLP_LOGS_TIMEOUT","OTEL_EXPORTER_JAEGER_AGENT_PORT"];function CWt(l){return xWt.indexOf(l)>-1}var AWt=["OTEL_NO_PATCH_MODULES","OTEL_PROPAGATORS"];function kWt(l){return AWt.indexOf(l)>-1}hd.DEFAULT_ATTRIBUTE_VALUE_LENGTH_LIMIT=1/0;hd.DEFAULT_ATTRIBUTE_COUNT_LIMIT=128;hd.DEFAULT_SPAN_ATTRIBUTE_PER_EVENT_COUNT_LIMIT=128;hd.DEFAULT_SPAN_ATTRIBUTE_PER_LINK_COUNT_LIMIT=128;hd.DEFAULT_ENVIRONMENT={OTEL_SDK_DISABLED:!1,CONTAINER_NAME:"",ECS_CONTAINER_METADATA_URI_V4:"",ECS_CONTAINER_METADATA_URI:"",HOSTNAME:"",KUBERNETES_SERVICE_HOST:"",NAMESPACE:"",OTEL_BSP_EXPORT_TIMEOUT:3e4,OTEL_BSP_MAX_EXPORT_BATCH_SIZE:512,OTEL_BSP_MAX_QUEUE_SIZE:2048,OTEL_BSP_SCHEDULE_DELAY:5e3,OTEL_BLRP_EXPORT_TIMEOUT:3e4,OTEL_BLRP_MAX_EXPORT_BATCH_SIZE:512,OTEL_BLRP_MAX_QUEUE_SIZE:2048,OTEL_BLRP_SCHEDULE_DELAY:5e3,OTEL_EXPORTER_JAEGER_AGENT_HOST:"",OTEL_EXPORTER_JAEGER_AGENT_PORT:6832,OTEL_EXPORTER_JAEGER_ENDPOINT:"",OTEL_EXPORTER_JAEGER_PASSWORD:"",OTEL_EXPORTER_JAEGER_USER:"",OTEL_EXPORTER_OTLP_ENDPOINT:"",OTEL_EXPORTER_OTLP_TRACES_ENDPOINT:"",OTEL_EXPORTER_OTLP_METRICS_ENDPOINT:"",OTEL_EXPORTER_OTLP_LOGS_ENDPOINT:"",OTEL_EXPORTER_OTLP_HEADERS:"",OTEL_EXPORTER_OTLP_TRACES_HEADERS:"",OTEL_EXPORTER_OTLP_METRICS_HEADERS:"",OTEL_EXPORTER_OTLP_LOGS_HEADERS:"",OTEL_EXPORTER_OTLP_TIMEOUT:1e4,OTEL_EXPORTER_OTLP_TRACES_TIMEOUT:1e4,OTEL_EXPORTER_OTLP_METRICS_TIMEOUT:1e4,OTEL_EXPORTER_OTLP_LOGS_TIMEOUT:1e4,OTEL_EXPORTER_ZIPKIN_ENDPOINT:"http://localhost:9411/api/v2/spans",OTEL_LOG_LEVEL:fw.DiagLogLevel.INFO,OTEL_NO_PATCH_MODULES:[],OTEL_PROPAGATORS:["tracecontext","baggage"],OTEL_RESOURCE_ATTRIBUTES:"",OTEL_SERVICE_NAME:"",OTEL_ATTRIBUTE_VALUE_LENGTH_LIMIT:hd.DEFAULT_ATTRIBUTE_VALUE_LENGTH_LIMIT,OTEL_ATTRIBUTE_COUNT_LIMIT:hd.DEFAULT_ATTRIBUTE_COUNT_LIMIT,OTEL_SPAN_ATTRIBUTE_VALUE_LENGTH_LIMIT:hd.DEFAULT_ATTRIBUTE_VALUE_LENGTH_LIMIT,OTEL_SPAN_ATTRIBUTE_COUNT_LIMIT:hd.DEFAULT_ATTRIBUTE_COUNT_LIMIT,OTEL_LOGRECORD_ATTRIBUTE_VALUE_LENGTH_LIMIT:hd.DEFAULT_ATTRIBUTE_VALUE_LENGTH_LIMIT,OTEL_LOGRECORD_ATTRIBUTE_COUNT_LIMIT:hd.DEFAULT_ATTRIBUTE_COUNT_LIMIT,OTEL_SPAN_EVENT_COUNT_LIMIT:128,OTEL_SPAN_LINK_COUNT_LIMIT:128,OTEL_SPAN_ATTRIBUTE_PER_EVENT_COUNT_LIMIT:hd.DEFAULT_SPAN_ATTRIBUTE_PER_EVENT_COUNT_LIMIT,OTEL_SPAN_ATTRIBUTE_PER_LINK_COUNT_LIMIT:hd.DEFAULT_SPAN_ATTRIBUTE_PER_LINK_COUNT_LIMIT,OTEL_TRACES_EXPORTER:"",OTEL_TRACES_SAMPLER:SWt.TracesSamplerValues.ParentBasedAlwaysOn,OTEL_TRACES_SAMPLER_ARG:"",OTEL_LOGS_EXPORTER:"",OTEL_EXPORTER_OTLP_INSECURE:"",OTEL_EXPORTER_OTLP_TRACES_INSECURE:"",OTEL_EXPORTER_OTLP_METRICS_INSECURE:"",OTEL_EXPORTER_OTLP_LOGS_INSECURE:"",OTEL_EXPORTER_OTLP_CERTIFICATE:"",OTEL_EXPORTER_OTLP_TRACES_CERTIFICATE:"",OTEL_EXPORTER_OTLP_METRICS_CERTIFICATE:"",OTEL_EXPORTER_OTLP_LOGS_CERTIFICATE:"",OTEL_EXPORTER_OTLP_COMPRESSION:"",OTEL_EXPORTER_OTLP_TRACES_COMPRESSION:"",OTEL_EXPORTER_OTLP_METRICS_COMPRESSION:"",OTEL_EXPORTER_OTLP_LOGS_COMPRESSION:"",OTEL_EXPORTER_OTLP_CLIENT_KEY:"",OTEL_EXPORTER_OTLP_TRACES_CLIENT_KEY:"",OTEL_EXPORTER_OTLP_METRICS_CLIENT_KEY:"",OTEL_EXPORTER_OTLP_LOGS_CLIENT_KEY:"",OTEL_EXPORTER_OTLP_CLIENT_CERTIFICATE:"",OTEL_EXPORTER_OTLP_TRACES_CLIENT_CERTIFICATE:"",OTEL_EXPORTER_OTLP_METRICS_CLIENT_CERTIFICATE:"",OTEL_EXPORTER_OTLP_LOGS_CLIENT_CERTIFICATE:"",OTEL_EXPORTER_OTLP_PROTOCOL:"http/protobuf",OTEL_EXPORTER_OTLP_TRACES_PROTOCOL:"http/protobuf",OTEL_EXPORTER_OTLP_METRICS_PROTOCOL:"http/protobuf",OTEL_EXPORTER_OTLP_LOGS_PROTOCOL:"http/protobuf",OTEL_EXPORTER_OTLP_METRICS_TEMPORALITY_PREFERENCE:"cumulative"};function PWt(l,c,f){if(typeof f[l]>"u")return;let y=String(f[l]);c[l]=y.toLowerCase()==="true"}function NWt(l,c,f,y=-1/0,b=1/0){if(typeof f[l]<"u"){let A=Number(f[l]);isNaN(A)||(A<y?c[l]=y:A>b?c[l]=b:c[l]=A)}}function DWt(l,c,f,y=bWt){let b=f[l];typeof b=="string"&&(c[l]=b.split(y).map(A=>A.trim()))}var wWt={ALL:fw.DiagLogLevel.ALL,VERBOSE:fw.DiagLogLevel.VERBOSE,DEBUG:fw.DiagLogLevel.DEBUG,INFO:fw.DiagLogLevel.INFO,WARN:fw.DiagLogLevel.WARN,ERROR:fw.DiagLogLevel.ERROR,NONE:fw.DiagLogLevel.NONE};function IWt(l,c,f){let y=f[l];if(typeof y=="string"){let b=wWt[y.toUpperCase()];b!=null&&(c[l]=b)}}function OWt(l){let c={};for(let f in hd.DEFAULT_ENVIRONMENT){let y=f;switch(y){case"OTEL_LOG_LEVEL":IWt(y,c,l);break;default:if(EWt(y))PWt(y,c,l);else if(CWt(y))NWt(y,c,l);else if(kWt(y))DWt(y,c,l);else{let b=l[y];typeof b<"u"&&b!==null&&(c[y]=String(b))}}}return c}hd.parseEnvironment=OWt});var JQe=xt(bL=>{"use strict";Object.defineProperty(bL,"__esModule",{value:!0});bL.getEnvWithoutDefaults=bL.getEnv=void 0;var dke=pke();function RWt(){let l=(0,dke.parseEnvironment)(process.env);return Object.assign({},dke.DEFAULT_ENVIRONMENT,l)}bL.getEnv=RWt;function MWt(){return(0,dke.parseEnvironment)(process.env)}bL.getEnvWithoutDefaults=MWt});var qQe=xt(rie=>{"use strict";Object.defineProperty(rie,"__esModule",{value:!0});rie._globalThis=void 0;rie._globalThis=typeof globalThis=="object"?globalThis:global});var mke=xt(nie=>{"use strict";Object.defineProperty(nie,"__esModule",{value:!0});nie.hexToBinary=void 0;function zQe(l){return l>=48&&l<=57?l-48:l>=97&&l<=102?l-87:l-55}function LWt(l){let c=new Uint8Array(l.length/2),f=0;for(let y=0;y<l.length;y+=2){let b=zQe(l.charCodeAt(y)),A=zQe(l.charCodeAt(y+1));c[f++]=b<<4|A}return c}nie.hexToBinary=LWt});var WQe=xt(iie=>{"use strict";Object.defineProperty(iie,"__esModule",{value:!0});iie.hexToBase64=void 0;var FWt=mke();function jWt(l){return Buffer.from((0,FWt.hexToBinary)(l)).toString("base64")}iie.hexToBase64=jWt});var GQe=xt(aie=>{"use strict";Object.defineProperty(aie,"__esModule",{value:!0});aie.RandomIdGenerator=void 0;var BWt=8,HQe=16,gke=class{constructor(){this.generateTraceId=$Qe(HQe),this.generateSpanId=$Qe(BWt)}};aie.RandomIdGenerator=gke;var sie=Buffer.allocUnsafe(HQe);function $Qe(l){return function(){for(let f=0;f<l/4;f++)sie.writeUInt32BE(Math.random()*2**32>>>0,f*4);for(let f=0;f<l&&!(sie[f]>0);f++)f===l-1&&(sie[l-1]=1);return sie.toString("hex",0,l)}}});var YQe=xt(oie=>{"use strict";Object.defineProperty(oie,"__esModule",{value:!0});oie.otperformance=void 0;var UWt=Bu("perf_hooks");oie.otperformance=UWt.performance});var hke=xt(cie=>{"use strict";Object.defineProperty(cie,"__esModule",{value:!0});cie.VERSION=void 0;cie.VERSION="1.26.0"});function Sm(l){for(var c={},f=l.length,y=0;y<f;y++){var b=l[y];b&&(c[String(b).toUpperCase().replace(/[-.]/g,"_")]=b)}return c}var yke=Jo(()=>{});var KQe,XQe,QQe,ZQe,eZe,tZe,rZe,nZe,iZe,sZe,aZe,oZe,cZe,lZe,uZe,_Ze,fZe,pZe,dZe,mZe,gZe,hZe,yZe,vZe,SZe,bZe,TZe,EZe,xZe,CZe,AZe,kZe,PZe,NZe,DZe,wZe,IZe,OZe,RZe,MZe,LZe,FZe,jZe,BZe,UZe,VZe,JZe,qZe,zZe,WZe,$Ze,HZe,GZe,YZe,KZe,XZe,QZe,ZZe,eet,tet,ret,net,iet,set,aet,oet,cet,uet,_et,fet,pet,det,met,get,het,yet,vet,bet,Tet,Eet,xet,Cet,Aet,ket,Pet,Net,Det,wet,Iet,Oet,Ret,Met,Let,Fet,jet,Bet,Uet,Vet,Jet,qet,zet,Wet,$et,Het,Get,Yet,Ket,Xet,Qet,Zet,ett,ttt,rtt,ntt,itt,stt,att,ott,ctt,ltt,utt,_tt,ftt,ptt,dtt,mtt,gtt,htt,VWt,JWt,qWt,zWt,WWt,$Wt,HWt,GWt,YWt,KWt,XWt,QWt,ZWt,e$t,t$t,r$t,n$t,i$t,s$t,a$t,o$t,c$t,l$t,u$t,_$t,f$t,p$t,d$t,m$t,g$t,h$t,y$t,v$t,S$t,b$t,T$t,E$t,x$t,C$t,A$t,k$t,P$t,N$t,D$t,w$t,I$t,O$t,R$t,M$t,L$t,F$t,j$t,B$t,U$t,V$t,J$t,q$t,z$t,W$t,$$t,H$t,G$t,Y$t,K$t,X$t,Q$t,Z$t,eHt,tHt,rHt,nHt,iHt,sHt,aHt,oHt,cHt,lHt,uHt,_Ht,fHt,pHt,dHt,mHt,gHt,hHt,yHt,vHt,SHt,bHt,THt,EHt,xHt,CHt,AHt,kHt,PHt,NHt,DHt,wHt,IHt,OHt,RHt,MHt,LHt,FHt,jHt,BHt,UHt,VHt,JHt,qHt,zHt,WHt,$Ht,HHt,GHt,YHt,KHt,XHt,QHt,ZHt,eGt,tGt,rGt,nGt,iGt,sGt,aGt,oGt,ytt,vtt,Stt,btt,Ttt,Ett,xtt,Ctt,Att,ktt,Ptt,Ntt,Dtt,wtt,Itt,Ott,Rtt,Mtt,Ltt,Ftt,jtt,Btt,Utt,Vtt,Jtt,qtt,ztt,Wtt,$tt,Htt,Gtt,Ytt,Ktt,Xtt,Qtt,Ztt,ert,trt,rrt,nrt,irt,srt,art,ort,crt,lrt,urt,cGt,lGt,uGt,_Gt,fGt,pGt,dGt,mGt,gGt,hGt,yGt,vGt,SGt,bGt,TGt,EGt,xGt,CGt,AGt,kGt,PGt,NGt,DGt,wGt,IGt,OGt,RGt,MGt,LGt,FGt,jGt,BGt,UGt,VGt,JGt,qGt,zGt,WGt,$Gt,HGt,GGt,YGt,KGt,XGt,QGt,ZGt,eYt,tYt,_rt,frt,prt,drt,mrt,grt,hrt,yrt,vrt,Srt,brt,rYt,nYt,iYt,sYt,aYt,oYt,cYt,lYt,uYt,_Yt,fYt,pYt,Trt,Ert,xrt,Crt,Art,dYt,mYt,gYt,hYt,yYt,vYt,krt,Prt,Nrt,SYt,bYt,TYt,EYt,Drt,wrt,Irt,Ort,xYt,CYt,AYt,kYt,PYt,Rrt,Mrt,Lrt,Frt,jrt,Brt,Urt,NYt,DYt,wYt,IYt,OYt,RYt,MYt,LYt,Vrt,Jrt,qrt,zrt,Wrt,FYt,jYt,BYt,UYt,VYt,JYt,$rt,Hrt,Grt,Yrt,Krt,Xrt,Qrt,Zrt,ent,tnt,rnt,nnt,int,snt,ant,ont,cnt,lnt,unt,_nt,fnt,qYt,zYt,WYt,$Yt,HYt,GYt,YYt,KYt,XYt,QYt,ZYt,eKt,tKt,rKt,nKt,iKt,sKt,aKt,oKt,cKt,lKt,uKt,pnt,dnt,mnt,gnt,hnt,_Kt,fKt,pKt,dKt,mKt,gKt,ynt,vnt,hKt,yKt,vKt,Snt,bnt,SKt,bKt,TKt,Tnt,Ent,xnt,Cnt,Ant,knt,Pnt,Nnt,Dnt,wnt,Int,Ont,Rnt,Mnt,Lnt,Fnt,jnt,EKt,xKt,CKt,AKt,kKt,PKt,NKt,DKt,wKt,IKt,OKt,RKt,MKt,LKt,FKt,jKt,BKt,UKt,Bnt,Unt,VKt,JKt,qKt,Vnt=Jo(()=>{yke();KQe="aws.lambda.invoked_arn",XQe="db.system",QQe="db.connection_string",ZQe="db.user",eZe="db.jdbc.driver_classname",tZe="db.name",rZe="db.statement",nZe="db.operation",iZe="db.mssql.instance_name",sZe="db.cassandra.keyspace",aZe="db.cassandra.page_size",oZe="db.cassandra.consistency_level",cZe="db.cassandra.table",lZe="db.cassandra.idempotence",uZe="db.cassandra.speculative_execution_count",_Ze="db.cassandra.coordinator.id",fZe="db.cassandra.coordinator.dc",pZe="db.hbase.namespace",dZe="db.redis.database_index",mZe="db.mongodb.collection",gZe="db.sql.table",hZe="exception.type",yZe="exception.message",vZe="exception.stacktrace",SZe="exception.escaped",bZe="faas.trigger",TZe="faas.execution",EZe="faas.document.collection",xZe="faas.document.operation",CZe="faas.document.time",AZe="faas.document.name",kZe="faas.time",PZe="faas.cron",NZe="faas.coldstart",DZe="faas.invoked_name",wZe="faas.invoked_provider",IZe="faas.invoked_region",OZe="net.transport",RZe="net.peer.ip",MZe="net.peer.port",LZe="net.peer.name",FZe="net.host.ip",jZe="net.host.port",BZe="net.host.name",UZe="net.host.connection.type",VZe="net.host.connection.subtype",JZe="net.host.carrier.name",qZe="net.host.carrier.mcc",zZe="net.host.carrier.mnc",WZe="net.host.carrier.icc",$Ze="peer.service",HZe="enduser.id",GZe="enduser.role",YZe="enduser.scope",KZe="thread.id",XZe="thread.name",QZe="code.function",ZZe="code.namespace",eet="code.filepath",tet="code.lineno",ret="http.method",net="http.url",iet="http.target",set="http.host",aet="http.scheme",oet="http.status_code",cet="http.flavor",uet="http.user_agent",_et="http.request_content_length",fet="http.request_content_length_uncompressed",pet="http.response_content_length",det="http.response_content_length_uncompressed",met="http.server_name",get="http.route",het="http.client_ip",yet="aws.dynamodb.table_names",vet="aws.dynamodb.consumed_capacity",bet="aws.dynamodb.item_collection_metrics",Tet="aws.dynamodb.provisioned_read_capacity",Eet="aws.dynamodb.provisioned_write_capacity",xet="aws.dynamodb.consistent_read",Cet="aws.dynamodb.projection",Aet="aws.dynamodb.limit",ket="aws.dynamodb.attributes_to_get",Pet="aws.dynamodb.index_name",Net="aws.dynamodb.select",Det="aws.dynamodb.global_secondary_indexes",wet="aws.dynamodb.local_secondary_indexes",Iet="aws.dynamodb.exclusive_start_table",Oet="aws.dynamodb.table_count",Ret="aws.dynamodb.scan_forward",Met="aws.dynamodb.segment",Let="aws.dynamodb.total_segments",Fet="aws.dynamodb.count",jet="aws.dynamodb.scanned_count",Bet="aws.dynamodb.attribute_definitions",Uet="aws.dynamodb.global_secondary_index_updates",Vet="messaging.system",Jet="messaging.destination",qet="messaging.destination_kind",zet="messaging.temp_destination",Wet="messaging.protocol",$et="messaging.protocol_version",Het="messaging.url",Get="messaging.message_id",Yet="messaging.conversation_id",Ket="messaging.message_payload_size_bytes",Xet="messaging.message_payload_compressed_size_bytes",Qet="messaging.operation",Zet="messaging.consumer_id",ett="messaging.rabbitmq.routing_key",ttt="messaging.kafka.message_key",rtt="messaging.kafka.consumer_group",ntt="messaging.kafka.client_id",itt="messaging.kafka.partition",stt="messaging.kafka.tombstone",att="rpc.system",ott="rpc.service",ctt="rpc.method",ltt="rpc.grpc.status_code",utt="rpc.jsonrpc.version",_tt="rpc.jsonrpc.request_id",ftt="rpc.jsonrpc.error_code",ptt="rpc.jsonrpc.error_message",dtt="message.type",mtt="message.id",gtt="message.compressed_size",htt="message.uncompressed_size",VWt=KQe,JWt=XQe,qWt=QQe,zWt=ZQe,WWt=eZe,$Wt=tZe,HWt=rZe,GWt=nZe,YWt=iZe,KWt=sZe,XWt=aZe,QWt=oZe,ZWt=cZe,e$t=lZe,t$t=uZe,r$t=_Ze,n$t=fZe,i$t=pZe,s$t=dZe,a$t=mZe,o$t=gZe,c$t=hZe,l$t=yZe,u$t=vZe,_$t=SZe,f$t=bZe,p$t=TZe,d$t=EZe,m$t=xZe,g$t=CZe,h$t=AZe,y$t=kZe,v$t=PZe,S$t=NZe,b$t=DZe,T$t=wZe,E$t=IZe,x$t=OZe,C$t=RZe,A$t=MZe,k$t=LZe,P$t=FZe,N$t=jZe,D$t=BZe,w$t=UZe,I$t=VZe,O$t=JZe,R$t=qZe,M$t=zZe,L$t=WZe,F$t=$Ze,j$t=HZe,B$t=GZe,U$t=YZe,V$t=KZe,J$t=XZe,q$t=QZe,z$t=ZZe,W$t=eet,$$t=tet,H$t=ret,G$t=net,Y$t=iet,K$t=set,X$t=aet,Q$t=oet,Z$t=cet,eHt=uet,tHt=_et,rHt=fet,nHt=pet,iHt=det,sHt=met,aHt=get,oHt=het,cHt=yet,lHt=vet,uHt=bet,_Ht=Tet,fHt=Eet,pHt=xet,dHt=Cet,mHt=Aet,gHt=ket,hHt=Pet,yHt=Net,vHt=Det,SHt=wet,bHt=Iet,THt=Oet,EHt=Ret,xHt=Met,CHt=Let,AHt=Fet,kHt=jet,PHt=Bet,NHt=Uet,DHt=Vet,wHt=Jet,IHt=qet,OHt=zet,RHt=Wet,MHt=$et,LHt=Het,FHt=Get,jHt=Yet,BHt=Ket,UHt=Xet,VHt=Qet,JHt=Zet,qHt=ett,zHt=ttt,WHt=rtt,$Ht=ntt,HHt=itt,GHt=stt,YHt=att,KHt=ott,XHt=ctt,QHt=ltt,ZHt=utt,eGt=_tt,tGt=ftt,rGt=ptt,nGt=dtt,iGt=mtt,sGt=gtt,aGt=htt,oGt=Sm([KQe,XQe,QQe,ZQe,eZe,tZe,rZe,nZe,iZe,sZe,aZe,oZe,cZe,lZe,uZe,_Ze,fZe,pZe,dZe,mZe,gZe,hZe,yZe,vZe,SZe,bZe,TZe,EZe,xZe,CZe,AZe,kZe,PZe,NZe,DZe,wZe,IZe,OZe,RZe,MZe,LZe,FZe,jZe,BZe,UZe,VZe,JZe,qZe,zZe,WZe,$Ze,HZe,GZe,YZe,KZe,XZe,QZe,ZZe,eet,tet,ret,net,iet,set,aet,oet,cet,uet,_et,fet,pet,det,met,get,het,yet,vet,bet,Tet,Eet,xet,Cet,Aet,ket,Pet,Net,Det,wet,Iet,Oet,Ret,Met,Let,Fet,jet,Bet,Uet,Vet,Jet,qet,zet,Wet,$et,Het,Get,Yet,Ket,Xet,Qet,Zet,ett,ttt,rtt,ntt,itt,stt,att,ott,ctt,ltt,utt,_tt,ftt,ptt,dtt,mtt,gtt,htt]),ytt="other_sql",vtt="mssql",Stt="mysql",btt="oracle",Ttt="db2",Ett="postgresql",xtt="redshift",Ctt="hive",Att="cloudscape",ktt="hsqldb",Ptt="progress",Ntt="maxdb",Dtt="hanadb",wtt="ingres",Itt="firstsql",Ott="edb",Rtt="cache",Mtt="adabas",Ltt="firebird",Ftt="derby",jtt="filemaker",Btt="informix",Utt="instantdb",Vtt="interbase",Jtt="mariadb",qtt="netezza",ztt="pervasive",Wtt="pointbase",$tt="sqlite",Htt="sybase",Gtt="teradata",Ytt="vertica",Ktt="h2",Xtt="coldfusion",Qtt="cassandra",Ztt="hbase",ert="mongodb",trt="redis",rrt="couchbase",nrt="couchdb",irt="cosmosdb",srt="dynamodb",art="neo4j",ort="geode",crt="elasticsearch",lrt="memcached",urt="cockroachdb",cGt=ytt,lGt=vtt,uGt=Stt,_Gt=btt,fGt=Ttt,pGt=Ett,dGt=xtt,mGt=Ctt,gGt=Att,hGt=ktt,yGt=Ptt,vGt=Ntt,SGt=Dtt,bGt=wtt,TGt=Itt,EGt=Ott,xGt=Rtt,CGt=Mtt,AGt=Ltt,kGt=Ftt,PGt=jtt,NGt=Btt,DGt=Utt,wGt=Vtt,IGt=Jtt,OGt=qtt,RGt=ztt,MGt=Wtt,LGt=$tt,FGt=Htt,jGt=Gtt,BGt=Ytt,UGt=Ktt,VGt=Xtt,JGt=Qtt,qGt=Ztt,zGt=ert,WGt=trt,$Gt=rrt,HGt=nrt,GGt=irt,YGt=srt,KGt=art,XGt=ort,QGt=crt,ZGt=lrt,eYt=urt,tYt=Sm([ytt,vtt,Stt,btt,Ttt,Ett,xtt,Ctt,Att,ktt,Ptt,Ntt,Dtt,wtt,Itt,Ott,Rtt,Mtt,Ltt,Ftt,jtt,Btt,Utt,Vtt,Jtt,qtt,ztt,Wtt,$tt,Htt,Gtt,Ytt,Ktt,Xtt,Qtt,Ztt,ert,trt,rrt,nrt,irt,srt,art,ort,crt,lrt,urt]),_rt="all",frt="each_quorum",prt="quorum",drt="local_quorum",mrt="one",grt="two",hrt="three",yrt="local_one",vrt="any",Srt="serial",brt="local_serial",rYt=_rt,nYt=frt,iYt=prt,sYt=drt,aYt=mrt,oYt=grt,cYt=hrt,lYt=yrt,uYt=vrt,_Yt=Srt,fYt=brt,pYt=Sm([_rt,frt,prt,drt,mrt,grt,hrt,yrt,vrt,Srt,brt]),Trt="datasource",Ert="http",xrt="pubsub",Crt="timer",Art="other",dYt=Trt,mYt=Ert,gYt=xrt,hYt=Crt,yYt=Art,vYt=Sm([Trt,Ert,xrt,Crt,Art]),krt="insert",Prt="edit",Nrt="delete",SYt=krt,bYt=Prt,TYt=Nrt,EYt=Sm([krt,Prt,Nrt]),Drt="alibaba_cloud",wrt="aws",Irt="azure",Ort="gcp",xYt=Drt,CYt=wrt,AYt=Irt,kYt=Ort,PYt=Sm([Drt,wrt,Irt,Ort]),Rrt="ip_tcp",Mrt="ip_udp",Lrt="ip",Frt="unix",jrt="pipe",Brt="inproc",Urt="other",NYt=Rrt,DYt=Mrt,wYt=Lrt,IYt=Frt,OYt=jrt,RYt=Brt,MYt=Urt,LYt=Sm([Rrt,Mrt,Lrt,Frt,jrt,Brt,Urt]),Vrt="wifi",Jrt="wired",qrt="cell",zrt="unavailable",Wrt="unknown",FYt=Vrt,jYt=Jrt,BYt=qrt,UYt=zrt,VYt=Wrt,JYt=Sm([Vrt,Jrt,qrt,zrt,Wrt]),$rt="gprs",Hrt="edge",Grt="umts",Yrt="cdma",Krt="evdo_0",Xrt="evdo_a",Qrt="cdma2000_1xrtt",Zrt="hsdpa",ent="hsupa",tnt="hspa",rnt="iden",nnt="evdo_b",int="lte",snt="ehrpd",ant="hspap",ont="gsm",cnt="td_scdma",lnt="iwlan",unt="nr",_nt="nrnsa",fnt="lte_ca",qYt=$rt,zYt=Hrt,WYt=Grt,$Yt=Yrt,HYt=Krt,GYt=Xrt,YYt=Qrt,KYt=Zrt,XYt=ent,QYt=tnt,ZYt=rnt,eKt=nnt,tKt=int,rKt=snt,nKt=ant,iKt=ont,sKt=cnt,aKt=lnt,oKt=unt,cKt=_nt,lKt=fnt,uKt=Sm([$rt,Hrt,Grt,Yrt,Krt,Xrt,Qrt,Zrt,ent,tnt,rnt,nnt,int,snt,ant,ont,cnt,lnt,unt,_nt,fnt]),pnt="1.0",dnt="1.1",mnt="2.0",gnt="SPDY",hnt="QUIC",_Kt=pnt,fKt=dnt,pKt=mnt,dKt=gnt,mKt=hnt,gKt={HTTP_1_0:pnt,HTTP_1_1:dnt,HTTP_2_0:mnt,SPDY:gnt,QUIC:hnt},ynt="queue",vnt="topic",hKt=ynt,yKt=vnt,vKt=Sm([ynt,vnt]),Snt="receive",bnt="process",SKt=Snt,bKt=bnt,TKt=Sm([Snt,bnt]),Tnt=0,Ent=1,xnt=2,Cnt=3,Ant=4,knt=5,Pnt=6,Nnt=7,Dnt=8,wnt=9,Int=10,Ont=11,Rnt=12,Mnt=13,Lnt=14,Fnt=15,jnt=16,EKt=Tnt,xKt=Ent,CKt=xnt,AKt=Cnt,kKt=Ant,PKt=knt,NKt=Pnt,DKt=Nnt,wKt=Dnt,IKt=wnt,OKt=Int,RKt=Ont,MKt=Rnt,LKt=Mnt,FKt=Lnt,jKt=Fnt,BKt=jnt,UKt={OK:Tnt,CANCELLED:Ent,UNKNOWN:xnt,INVALID_ARGUMENT:Cnt,DEADLINE_EXCEEDED:Ant,NOT_FOUND:knt,ALREADY_EXISTS:Pnt,PERMISSION_DENIED:Nnt,RESOURCE_EXHAUSTED:Dnt,FAILED_PRECONDITION:wnt,ABORTED:Int,OUT_OF_RANGE:Ont,UNIMPLEMENTED:Rnt,INTERNAL:Mnt,UNAVAILABLE:Lnt,DATA_LOSS:Fnt,UNAUTHENTICATED:jnt},Bnt="SENT",Unt="RECEIVED",VKt=Bnt,JKt=Unt,qKt=Sm([Bnt,Unt])});var Jnt=Jo(()=>{Vnt()});var qnt,znt,Wnt,$nt,Hnt,Gnt,Ynt,Knt,Xnt,Qnt,Znt,eit,tit,rit,nit,iit,sit,ait,oit,cit,lit,uit,_it,fit,pit,dit,mit,git,hit,yit,vit,Sit,bit,Tit,Eit,xit,Cit,Ait,kit,Pit,Nit,Dit,wit,Iit,Oit,Rit,Mit,Lit,Fit,jit,Bit,Uit,Vit,Jit,qit,zit,Wit,$it,Hit,Git,Yit,Kit,Xit,Qit,Zit,est,tst,rst,nst,ist,sst,ast,ost,cst,lst,ust,_st,fst,pst,dst,mst,zKt,WKt,$Kt,HKt,GKt,YKt,KKt,XKt,QKt,ZKt,eXt,tXt,rXt,nXt,iXt,sXt,aXt,oXt,cXt,lXt,uXt,_Xt,fXt,pXt,dXt,mXt,gXt,hXt,yXt,vXt,SXt,bXt,TXt,EXt,xXt,CXt,AXt,kXt,PXt,NXt,DXt,wXt,IXt,OXt,RXt,MXt,LXt,FXt,jXt,BXt,UXt,VXt,JXt,qXt,zXt,WXt,$Xt,HXt,GXt,YXt,KXt,XXt,QXt,ZXt,eQt,tQt,rQt,nQt,iQt,sQt,vke,aQt,oQt,cQt,lQt,uQt,_Qt,fQt,pQt,dQt,mQt,gQt,gst,hst,yst,vst,hQt,yQt,vQt,SQt,bQt,Sst,bst,Tst,Est,xst,Cst,Ast,kst,Pst,Nst,Dst,wst,Ist,Ost,Rst,Mst,Lst,TQt,EQt,xQt,CQt,AQt,kQt,PQt,NQt,DQt,wQt,IQt,OQt,RQt,MQt,LQt,FQt,jQt,BQt,Fst,jst,UQt,VQt,JQt,Bst,Ust,Vst,Jst,qst,zst,Wst,qQt,zQt,WQt,$Qt,HQt,GQt,YQt,KQt,$st,Hst,Gst,Yst,Kst,Xst,Qst,Zst,eat,tat,rat,XQt,QQt,ZQt,eZt,tZt,rZt,nZt,iZt,sZt,aZt,oZt,cZt,nat,iat,sat,aat,oat,cat,lat,uat,_at,fat,lZt,uZt,_Zt,fZt,pZt,dZt,mZt,gZt,hZt,yZt,vZt,pat=Jo(()=>{yke();qnt="cloud.provider",znt="cloud.account.id",Wnt="cloud.region",$nt="cloud.availability_zone",Hnt="cloud.platform",Gnt="aws.ecs.container.arn",Ynt="aws.ecs.cluster.arn",Knt="aws.ecs.launchtype",Xnt="aws.ecs.task.arn",Qnt="aws.ecs.task.family",Znt="aws.ecs.task.revision",eit="aws.eks.cluster.arn",tit="aws.log.group.names",rit="aws.log.group.arns",nit="aws.log.stream.names",iit="aws.log.stream.arns",sit="container.name",ait="container.id",oit="container.runtime",cit="container.image.name",lit="container.image.tag",uit="deployment.environment",_it="device.id",fit="device.model.identifier",pit="device.model.name",dit="faas.name",mit="faas.id",git="faas.version",hit="faas.instance",yit="faas.max_memory",vit="host.id",Sit="host.name",bit="host.type",Tit="host.arch",Eit="host.image.name",xit="host.image.id",Cit="host.image.version",Ait="k8s.cluster.name",kit="k8s.node.name",Pit="k8s.node.uid",Nit="k8s.namespace.name",Dit="k8s.pod.uid",wit="k8s.pod.name",Iit="k8s.container.name",Oit="k8s.replicaset.uid",Rit="k8s.replicaset.name",Mit="k8s.deployment.uid",Lit="k8s.deployment.name",Fit="k8s.statefulset.uid",jit="k8s.statefulset.name",Bit="k8s.daemonset.uid",Uit="k8s.daemonset.name",Vit="k8s.job.uid",Jit="k8s.job.name",qit="k8s.cronjob.uid",zit="k8s.cronjob.name",Wit="os.type",$it="os.description",Hit="os.name",Git="os.version",Yit="process.pid",Kit="process.executable.name",Xit="process.executable.path",Qit="process.command",Zit="process.command_line",est="process.command_args",tst="process.owner",rst="process.runtime.name",nst="process.runtime.version",ist="process.runtime.description",sst="service.name",ast="service.namespace",ost="service.instance.id",cst="service.version",lst="telemetry.sdk.name",ust="telemetry.sdk.language",_st="telemetry.sdk.version",fst="telemetry.auto.version",pst="webengine.name",dst="webengine.version",mst="webengine.description",zKt=qnt,WKt=znt,$Kt=Wnt,HKt=$nt,GKt=Hnt,YKt=Gnt,KKt=Ynt,XKt=Knt,QKt=Xnt,ZKt=Qnt,eXt=Znt,tXt=eit,rXt=tit,nXt=rit,iXt=nit,sXt=iit,aXt=sit,oXt=ait,cXt=oit,lXt=cit,uXt=lit,_Xt=uit,fXt=_it,pXt=fit,dXt=pit,mXt=dit,gXt=mit,hXt=git,yXt=hit,vXt=yit,SXt=vit,bXt=Sit,TXt=bit,EXt=Tit,xXt=Eit,CXt=xit,AXt=Cit,kXt=Ait,PXt=kit,NXt=Pit,DXt=Nit,wXt=Dit,IXt=wit,OXt=Iit,RXt=Oit,MXt=Rit,LXt=Mit,FXt=Lit,jXt=Fit,BXt=jit,UXt=Bit,VXt=Uit,JXt=Vit,qXt=Jit,zXt=qit,WXt=zit,$Xt=Wit,HXt=$it,GXt=Hit,YXt=Git,KXt=Yit,XXt=Kit,QXt=Xit,ZXt=Qit,eQt=Zit,tQt=est,rQt=tst,nQt=rst,iQt=nst,sQt=ist,vke=sst,aQt=ast,oQt=ost,cQt=cst,lQt=lst,uQt=ust,_Qt=_st,fQt=fst,pQt=pst,dQt=dst,mQt=mst,gQt=Sm([qnt,znt,Wnt,$nt,Hnt,Gnt,Ynt,Knt,Xnt,Qnt,Znt,eit,tit,rit,nit,iit,sit,ait,oit,cit,lit,uit,_it,fit,pit,dit,mit,git,hit,yit,vit,Sit,bit,Tit,Eit,xit,Cit,Ait,kit,Pit,Nit,Dit,wit,Iit,Oit,Rit,Mit,Lit,Fit,jit,Bit,Uit,Vit,Jit,qit,zit,Wit,$it,Hit,Git,Yit,Kit,Xit,Qit,Zit,est,tst,rst,nst,ist,sst,ast,ost,cst,lst,ust,_st,fst,pst,dst,mst]),gst="alibaba_cloud",hst="aws",yst="azure",vst="gcp",hQt=gst,yQt=hst,vQt=yst,SQt=vst,bQt=Sm([gst,hst,yst,vst]),Sst="alibaba_cloud_ecs",bst="alibaba_cloud_fc",Tst="aws_ec2",Est="aws_ecs",xst="aws_eks",Cst="aws_lambda",Ast="aws_elastic_beanstalk",kst="azure_vm",Pst="azure_container_instances",Nst="azure_aks",Dst="azure_functions",wst="azure_app_service",Ist="gcp_compute_engine",Ost="gcp_cloud_run",Rst="gcp_kubernetes_engine",Mst="gcp_cloud_functions",Lst="gcp_app_engine",TQt=Sst,EQt=bst,xQt=Tst,CQt=Est,AQt=xst,kQt=Cst,PQt=Ast,NQt=kst,DQt=Pst,wQt=Nst,IQt=Dst,OQt=wst,RQt=Ist,MQt=Ost,LQt=Rst,FQt=Mst,jQt=Lst,BQt=Sm([Sst,bst,Tst,Est,xst,Cst,Ast,kst,Pst,Nst,Dst,wst,Ist,Ost,Rst,Mst,Lst]),Fst="ec2",jst="fargate",UQt=Fst,VQt=jst,JQt=Sm([Fst,jst]),Bst="amd64",Ust="arm32",Vst="arm64",Jst="ia64",qst="ppc32",zst="ppc64",Wst="x86",qQt=Bst,zQt=Ust,WQt=Vst,$Qt=Jst,HQt=qst,GQt=zst,YQt=Wst,KQt=Sm([Bst,Ust,Vst,Jst,qst,zst,Wst]),$st="windows",Hst="linux",Gst="darwin",Yst="freebsd",Kst="netbsd",Xst="openbsd",Qst="dragonflybsd",Zst="hpux",eat="aix",tat="solaris",rat="z_os",XQt=$st,QQt=Hst,ZQt=Gst,eZt=Yst,tZt=Kst,rZt=Xst,nZt=Qst,iZt=Zst,sZt=eat,aZt=tat,oZt=rat,cZt=Sm([$st,Hst,Gst,Yst,Kst,Xst,Qst,Zst,eat,tat,rat]),nat="cpp",iat="dotnet",sat="erlang",aat="go",oat="java",cat="nodejs",lat="php",uat="python",_at="ruby",fat="webjs",lZt=nat,uZt=iat,_Zt=sat,fZt=aat,pZt=oat,dZt=cat,mZt=lat,gZt=uat,hZt=_at,yZt=fat,vZt=Sm([nat,iat,sat,aat,oat,cat,lat,uat,_at,fat])});var dat=Jo(()=>{pat()});var SZt,bZt,TZt,EZt,xZt,CZt,AZt,kZt,PZt,NZt,DZt,wZt,IZt,OZt,RZt,MZt,LZt,FZt,jZt,BZt,UZt,VZt,JZt,qZt,zZt,WZt,$Zt,HZt,GZt,YZt,KZt,XZt,QZt,ZZt,eer,ter,rer,ner,ier,ser,aer,oer,cer,ler,uer,_er,fer,per,der,mer,ger,her,yer,ver,Ser,ber,Ter,Eer,xer,Cer,Aer,ker,Per,Ner,Der,wer,Ier,Oer,Rer,Mer,Ler,Fer,jer,Ber,Uer,Ver,Jer,qer,zer,Wer,$er,Her,Ger,Yer,Ker,Xer,Qer,Zer,etr,ttr,rtr,ntr,itr,str,atr,otr,ctr,ltr,utr,_tr,ftr,ptr,dtr,mtr,gtr,htr,ytr,vtr,Str,btr,mat=Jo(()=>{SZt="aspnetcore.rate_limiting.result",bZt="acquired",TZt="endpoint_limiter",EZt="global_limiter",xZt="request_canceled",CZt="telemetry.sdk.language",AZt="cpp",kZt="dotnet",PZt="erlang",NZt="go",DZt="java",wZt="nodejs",IZt="php",OZt="python",RZt="ruby",MZt="rust",LZt="swift",FZt="webjs",jZt="telemetry.sdk.name",BZt="telemetry.sdk.version",UZt="aspnetcore.diagnostics.handler.type",VZt="aspnetcore.diagnostics.exception.result",JZt="aborted",qZt="handled",zZt="skipped",WZt="unhandled",$Zt="aspnetcore.rate_limiting.policy",HZt="aspnetcore.request.is_unhandled",GZt="aspnetcore.routing.is_fallback",YZt="aspnetcore.routing.match_status",KZt="failure",XZt="success",QZt="client.address",ZZt="client.port",eer="error.type",ter="_OTHER",rer="exception.escaped",ner="exception.message",ier="exception.stacktrace",ser="exception.type",aer=function(l){return"http.request.header."+l},oer="http.request.method",cer="_OTHER",ler="CONNECT",uer="DELETE",_er="GET",fer="HEAD",per="OPTIONS",der="PATCH",mer="POST",ger="PUT",her="TRACE",yer="http.request.method_original",ver="http.request.resend_count",Ser=function(l){return"http.response.header."+l},ber="http.response.status_code",Ter="http.route",Eer="jvm.gc.action",xer="jvm.gc.name",Cer="jvm.memory.pool.name",Aer="jvm.memory.type",ker="heap",Per="non_heap",Ner="jvm.thread.daemon",Der="jvm.thread.state",wer="blocked",Ier="new",Oer="runnable",Rer="terminated",Mer="timed_waiting",Ler="waiting",Fer="network.local.address",jer="network.local.port",Ber="network.peer.address",Uer="network.peer.port",Ver="network.protocol.name",Jer="network.protocol.version",qer="network.transport",zer="pipe",Wer="quic",$er="tcp",Her="udp",Ger="unix",Yer="network.type",Ker="ipv4",Xer="ipv6",Qer="otel.scope.name",Zer="otel.scope.version",etr="otel.status_code",ttr="ERROR",rtr="OK",ntr="otel.status_description",itr="server.address",str="server.port",atr="service.name",otr="service.version",ctr="signalr.connection.status",ltr="app_shutdown",utr="normal_closure",_tr="timeout",ftr="signalr.transport",ptr="long_polling",dtr="server_sent_events",mtr="web_sockets",gtr="url.fragment",htr="url.full",ytr="url.path",vtr="url.query",Str="url.scheme",btr="user_agent.original"});var Ttr,Etr,xtr,Ctr,Atr,ktr,Ptr,Ntr,Dtr,wtr,Itr,Otr,Rtr,Mtr,Ltr,Ftr,jtr,Btr,Utr,Vtr,Jtr,qtr,ztr,Wtr,$tr,Htr,Gtr,Ytr,Ktr,Xtr,Qtr,gat=Jo(()=>{Ttr="aspnetcore.diagnostics.exceptions",Etr="aspnetcore.rate_limiting.active_request_leases",xtr="aspnetcore.rate_limiting.queued_requests",Ctr="aspnetcore.rate_limiting.request.time_in_queue",Atr="aspnetcore.rate_limiting.request_lease.duration",ktr="aspnetcore.rate_limiting.requests",Ptr="aspnetcore.routing.match_attempts",Ntr="http.client.request.duration",Dtr="http.server.request.duration",wtr="jvm.class.count",Itr="jvm.class.loaded",Otr="jvm.class.unloaded",Rtr="jvm.cpu.count",Mtr="jvm.cpu.recent_utilization",Ltr="jvm.cpu.time",Ftr="jvm.gc.duration",jtr="jvm.memory.committed",Btr="jvm.memory.limit",Utr="jvm.memory.used",Vtr="jvm.memory.used_after_last_gc",Jtr="jvm.thread.count",qtr="kestrel.active_connections",ztr="kestrel.active_tls_handshakes",Wtr="kestrel.connection.duration",$tr="kestrel.queued_connections",Htr="kestrel.queued_requests",Gtr="kestrel.rejected_connections",Ytr="kestrel.tls_handshake.duration",Ktr="kestrel.upgraded_connections",Xtr="signalr.server.active_connections",Qtr="signalr.server.connection.duration"});var aP={};fAe(aP,{ASPNETCORE_DIAGNOSTICS_EXCEPTION_RESULT_VALUE_ABORTED:()=>JZt,ASPNETCORE_DIAGNOSTICS_EXCEPTION_RESULT_VALUE_HANDLED:()=>qZt,ASPNETCORE_DIAGNOSTICS_EXCEPTION_RESULT_VALUE_SKIPPED:()=>zZt,ASPNETCORE_DIAGNOSTICS_EXCEPTION_RESULT_VALUE_UNHANDLED:()=>WZt,ASPNETCORE_RATE_LIMITING_RESULT_VALUE_ACQUIRED:()=>bZt,ASPNETCORE_RATE_LIMITING_RESULT_VALUE_ENDPOINT_LIMITER:()=>TZt,ASPNETCORE_RATE_LIMITING_RESULT_VALUE_GLOBAL_LIMITER:()=>EZt,ASPNETCORE_RATE_LIMITING_RESULT_VALUE_REQUEST_CANCELED:()=>xZt,ASPNETCORE_ROUTING_MATCH_STATUS_VALUE_FAILURE:()=>KZt,ASPNETCORE_ROUTING_MATCH_STATUS_VALUE_SUCCESS:()=>XZt,ATTR_ASPNETCORE_DIAGNOSTICS_EXCEPTION_RESULT:()=>VZt,ATTR_ASPNETCORE_DIAGNOSTICS_HANDLER_TYPE:()=>UZt,ATTR_ASPNETCORE_RATE_LIMITING_POLICY:()=>$Zt,ATTR_ASPNETCORE_RATE_LIMITING_RESULT:()=>SZt,ATTR_ASPNETCORE_REQUEST_IS_UNHANDLED:()=>HZt,ATTR_ASPNETCORE_ROUTING_IS_FALLBACK:()=>GZt,ATTR_ASPNETCORE_ROUTING_MATCH_STATUS:()=>YZt,ATTR_CLIENT_ADDRESS:()=>QZt,ATTR_CLIENT_PORT:()=>ZZt,ATTR_ERROR_TYPE:()=>eer,ATTR_EXCEPTION_ESCAPED:()=>rer,ATTR_EXCEPTION_MESSAGE:()=>ner,ATTR_EXCEPTION_STACKTRACE:()=>ier,ATTR_EXCEPTION_TYPE:()=>ser,ATTR_HTTP_REQUEST_HEADER:()=>aer,ATTR_HTTP_REQUEST_METHOD:()=>oer,ATTR_HTTP_REQUEST_METHOD_ORIGINAL:()=>yer,ATTR_HTTP_REQUEST_RESEND_COUNT:()=>ver,ATTR_HTTP_RESPONSE_HEADER:()=>Ser,ATTR_HTTP_RESPONSE_STATUS_CODE:()=>ber,ATTR_HTTP_ROUTE:()=>Ter,ATTR_JVM_GC_ACTION:()=>Eer,ATTR_JVM_GC_NAME:()=>xer,ATTR_JVM_MEMORY_POOL_NAME:()=>Cer,ATTR_JVM_MEMORY_TYPE:()=>Aer,ATTR_JVM_THREAD_DAEMON:()=>Ner,ATTR_JVM_THREAD_STATE:()=>Der,ATTR_NETWORK_LOCAL_ADDRESS:()=>Fer,ATTR_NETWORK_LOCAL_PORT:()=>jer,ATTR_NETWORK_PEER_ADDRESS:()=>Ber,ATTR_NETWORK_PEER_PORT:()=>Uer,ATTR_NETWORK_PROTOCOL_NAME:()=>Ver,ATTR_NETWORK_PROTOCOL_VERSION:()=>Jer,ATTR_NETWORK_TRANSPORT:()=>qer,ATTR_NETWORK_TYPE:()=>Yer,ATTR_OTEL_SCOPE_NAME:()=>Qer,ATTR_OTEL_SCOPE_VERSION:()=>Zer,ATTR_OTEL_STATUS_CODE:()=>etr,ATTR_OTEL_STATUS_DESCRIPTION:()=>ntr,ATTR_SERVER_ADDRESS:()=>itr,ATTR_SERVER_PORT:()=>str,ATTR_SERVICE_NAME:()=>atr,ATTR_SERVICE_VERSION:()=>otr,ATTR_SIGNALR_CONNECTION_STATUS:()=>ctr,ATTR_SIGNALR_TRANSPORT:()=>ftr,ATTR_TELEMETRY_SDK_LANGUAGE:()=>CZt,ATTR_TELEMETRY_SDK_NAME:()=>jZt,ATTR_TELEMETRY_SDK_VERSION:()=>BZt,ATTR_URL_FRAGMENT:()=>gtr,ATTR_URL_FULL:()=>htr,ATTR_URL_PATH:()=>ytr,ATTR_URL_QUERY:()=>vtr,ATTR_URL_SCHEME:()=>Str,ATTR_USER_AGENT_ORIGINAL:()=>btr,AWSECSLAUNCHTYPEVALUES_EC2:()=>UQt,AWSECSLAUNCHTYPEVALUES_FARGATE:()=>VQt,AwsEcsLaunchtypeValues:()=>JQt,CLOUDPLATFORMVALUES_ALIBABA_CLOUD_ECS:()=>TQt,CLOUDPLATFORMVALUES_ALIBABA_CLOUD_FC:()=>EQt,CLOUDPLATFORMVALUES_AWS_EC2:()=>xQt,CLOUDPLATFORMVALUES_AWS_ECS:()=>CQt,CLOUDPLATFORMVALUES_AWS_EKS:()=>AQt,CLOUDPLATFORMVALUES_AWS_ELASTIC_BEANSTALK:()=>PQt,CLOUDPLATFORMVALUES_AWS_LAMBDA:()=>kQt,CLOUDPLATFORMVALUES_AZURE_AKS:()=>wQt,CLOUDPLATFORMVALUES_AZURE_APP_SERVICE:()=>OQt,CLOUDPLATFORMVALUES_AZURE_CONTAINER_INSTANCES:()=>DQt,CLOUDPLATFORMVALUES_AZURE_FUNCTIONS:()=>IQt,CLOUDPLATFORMVALUES_AZURE_VM:()=>NQt,CLOUDPLATFORMVALUES_GCP_APP_ENGINE:()=>jQt,CLOUDPLATFORMVALUES_GCP_CLOUD_FUNCTIONS:()=>FQt,CLOUDPLATFORMVALUES_GCP_CLOUD_RUN:()=>MQt,CLOUDPLATFORMVALUES_GCP_COMPUTE_ENGINE:()=>RQt,CLOUDPLATFORMVALUES_GCP_KUBERNETES_ENGINE:()=>LQt,CLOUDPROVIDERVALUES_ALIBABA_CLOUD:()=>hQt,CLOUDPROVIDERVALUES_AWS:()=>yQt,CLOUDPROVIDERVALUES_AZURE:()=>vQt,CLOUDPROVIDERVALUES_GCP:()=>SQt,CloudPlatformValues:()=>BQt,CloudProviderValues:()=>bQt,DBCASSANDRACONSISTENCYLEVELVALUES_ALL:()=>rYt,DBCASSANDRACONSISTENCYLEVELVALUES_ANY:()=>uYt,DBCASSANDRACONSISTENCYLEVELVALUES_EACH_QUORUM:()=>nYt,DBCASSANDRACONSISTENCYLEVELVALUES_LOCAL_ONE:()=>lYt,DBCASSANDRACONSISTENCYLEVELVALUES_LOCAL_QUORUM:()=>sYt,DBCASSANDRACONSISTENCYLEVELVALUES_LOCAL_SERIAL:()=>fYt,DBCASSANDRACONSISTENCYLEVELVALUES_ONE:()=>aYt,DBCASSANDRACONSISTENCYLEVELVALUES_QUORUM:()=>iYt,DBCASSANDRACONSISTENCYLEVELVALUES_SERIAL:()=>_Yt,DBCASSANDRACONSISTENCYLEVELVALUES_THREE:()=>cYt,DBCASSANDRACONSISTENCYLEVELVALUES_TWO:()=>oYt,DBSYSTEMVALUES_ADABAS:()=>CGt,DBSYSTEMVALUES_CACHE:()=>xGt,DBSYSTEMVALUES_CASSANDRA:()=>JGt,DBSYSTEMVALUES_CLOUDSCAPE:()=>gGt,DBSYSTEMVALUES_COCKROACHDB:()=>eYt,DBSYSTEMVALUES_COLDFUSION:()=>VGt,DBSYSTEMVALUES_COSMOSDB:()=>GGt,DBSYSTEMVALUES_COUCHBASE:()=>$Gt,DBSYSTEMVALUES_COUCHDB:()=>HGt,DBSYSTEMVALUES_DB2:()=>fGt,DBSYSTEMVALUES_DERBY:()=>kGt,DBSYSTEMVALUES_DYNAMODB:()=>YGt,DBSYSTEMVALUES_EDB:()=>EGt,DBSYSTEMVALUES_ELASTICSEARCH:()=>QGt,DBSYSTEMVALUES_FILEMAKER:()=>PGt,DBSYSTEMVALUES_FIREBIRD:()=>AGt,DBSYSTEMVALUES_FIRSTSQL:()=>TGt,DBSYSTEMVALUES_GEODE:()=>XGt,DBSYSTEMVALUES_H2:()=>UGt,DBSYSTEMVALUES_HANADB:()=>SGt,DBSYSTEMVALUES_HBASE:()=>qGt,DBSYSTEMVALUES_HIVE:()=>mGt,DBSYSTEMVALUES_HSQLDB:()=>hGt,DBSYSTEMVALUES_INFORMIX:()=>NGt,DBSYSTEMVALUES_INGRES:()=>bGt,DBSYSTEMVALUES_INSTANTDB:()=>DGt,DBSYSTEMVALUES_INTERBASE:()=>wGt,DBSYSTEMVALUES_MARIADB:()=>IGt,DBSYSTEMVALUES_MAXDB:()=>vGt,DBSYSTEMVALUES_MEMCACHED:()=>ZGt,DBSYSTEMVALUES_MONGODB:()=>zGt,DBSYSTEMVALUES_MSSQL:()=>lGt,DBSYSTEMVALUES_MYSQL:()=>uGt,DBSYSTEMVALUES_NEO4J:()=>KGt,DBSYSTEMVALUES_NETEZZA:()=>OGt,DBSYSTEMVALUES_ORACLE:()=>_Gt,DBSYSTEMVALUES_OTHER_SQL:()=>cGt,DBSYSTEMVALUES_PERVASIVE:()=>RGt,DBSYSTEMVALUES_POINTBASE:()=>MGt,DBSYSTEMVALUES_POSTGRESQL:()=>pGt,DBSYSTEMVALUES_PROGRESS:()=>yGt,DBSYSTEMVALUES_REDIS:()=>WGt,DBSYSTEMVALUES_REDSHIFT:()=>dGt,DBSYSTEMVALUES_SQLITE:()=>LGt,DBSYSTEMVALUES_SYBASE:()=>FGt,DBSYSTEMVALUES_TERADATA:()=>jGt,DBSYSTEMVALUES_VERTICA:()=>BGt,DbCassandraConsistencyLevelValues:()=>pYt,DbSystemValues:()=>tYt,ERROR_TYPE_VALUE_OTHER:()=>ter,FAASDOCUMENTOPERATIONVALUES_DELETE:()=>TYt,FAASDOCUMENTOPERATIONVALUES_EDIT:()=>bYt,FAASDOCUMENTOPERATIONVALUES_INSERT:()=>SYt,FAASINVOKEDPROVIDERVALUES_ALIBABA_CLOUD:()=>xYt,FAASINVOKEDPROVIDERVALUES_AWS:()=>CYt,FAASINVOKEDPROVIDERVALUES_AZURE:()=>AYt,FAASINVOKEDPROVIDERVALUES_GCP:()=>kYt,FAASTRIGGERVALUES_DATASOURCE:()=>dYt,FAASTRIGGERVALUES_HTTP:()=>mYt,FAASTRIGGERVALUES_OTHER:()=>yYt,FAASTRIGGERVALUES_PUBSUB:()=>gYt,FAASTRIGGERVALUES_TIMER:()=>hYt,FaasDocumentOperationValues:()=>EYt,FaasInvokedProviderValues:()=>PYt,FaasTriggerValues:()=>vYt,HOSTARCHVALUES_AMD64:()=>qQt,HOSTARCHVALUES_ARM32:()=>zQt,HOSTARCHVALUES_ARM64:()=>WQt,HOSTARCHVALUES_IA64:()=>$Qt,HOSTARCHVALUES_PPC32:()=>HQt,HOSTARCHVALUES_PPC64:()=>GQt,HOSTARCHVALUES_X86:()=>YQt,HTTPFLAVORVALUES_HTTP_1_0:()=>_Kt,HTTPFLAVORVALUES_HTTP_1_1:()=>fKt,HTTPFLAVORVALUES_HTTP_2_0:()=>pKt,HTTPFLAVORVALUES_QUIC:()=>mKt,HTTPFLAVORVALUES_SPDY:()=>dKt,HTTP_REQUEST_METHOD_VALUE_CONNECT:()=>ler,HTTP_REQUEST_METHOD_VALUE_DELETE:()=>uer,HTTP_REQUEST_METHOD_VALUE_GET:()=>_er,HTTP_REQUEST_METHOD_VALUE_HEAD:()=>fer,HTTP_REQUEST_METHOD_VALUE_OPTIONS:()=>per,HTTP_REQUEST_METHOD_VALUE_OTHER:()=>cer,HTTP_REQUEST_METHOD_VALUE_PATCH:()=>der,HTTP_REQUEST_METHOD_VALUE_POST:()=>mer,HTTP_REQUEST_METHOD_VALUE_PUT:()=>ger,HTTP_REQUEST_METHOD_VALUE_TRACE:()=>her,HostArchValues:()=>KQt,HttpFlavorValues:()=>gKt,JVM_MEMORY_TYPE_VALUE_HEAP:()=>ker,JVM_MEMORY_TYPE_VALUE_NON_HEAP:()=>Per,JVM_THREAD_STATE_VALUE_BLOCKED:()=>wer,JVM_THREAD_STATE_VALUE_NEW:()=>Ier,JVM_THREAD_STATE_VALUE_RUNNABLE:()=>Oer,JVM_THREAD_STATE_VALUE_TERMINATED:()=>Rer,JVM_THREAD_STATE_VALUE_TIMED_WAITING:()=>Mer,JVM_THREAD_STATE_VALUE_WAITING:()=>Ler,MESSAGETYPEVALUES_RECEIVED:()=>JKt,MESSAGETYPEVALUES_SENT:()=>VKt,MESSAGINGDESTINATIONKINDVALUES_QUEUE:()=>hKt,MESSAGINGDESTINATIONKINDVALUES_TOPIC:()=>yKt,MESSAGINGOPERATIONVALUES_PROCESS:()=>bKt,MESSAGINGOPERATIONVALUES_RECEIVE:()=>SKt,METRIC_ASPNETCORE_DIAGNOSTICS_EXCEPTIONS:()=>Ttr,METRIC_ASPNETCORE_RATE_LIMITING_ACTIVE_REQUEST_LEASES:()=>Etr,METRIC_ASPNETCORE_RATE_LIMITING_QUEUED_REQUESTS:()=>xtr,METRIC_ASPNETCORE_RATE_LIMITING_REQUESTS:()=>ktr,METRIC_ASPNETCORE_RATE_LIMITING_REQUEST_LEASE_DURATION:()=>Atr,METRIC_ASPNETCORE_RATE_LIMITING_REQUEST_TIME_IN_QUEUE:()=>Ctr,METRIC_ASPNETCORE_ROUTING_MATCH_ATTEMPTS:()=>Ptr,METRIC_HTTP_CLIENT_REQUEST_DURATION:()=>Ntr,METRIC_HTTP_SERVER_REQUEST_DURATION:()=>Dtr,METRIC_JVM_CLASS_COUNT:()=>wtr,METRIC_JVM_CLASS_LOADED:()=>Itr,METRIC_JVM_CLASS_UNLOADED:()=>Otr,METRIC_JVM_CPU_COUNT:()=>Rtr,METRIC_JVM_CPU_RECENT_UTILIZATION:()=>Mtr,METRIC_JVM_CPU_TIME:()=>Ltr,METRIC_JVM_GC_DURATION:()=>Ftr,METRIC_JVM_MEMORY_COMMITTED:()=>jtr,METRIC_JVM_MEMORY_LIMIT:()=>Btr,METRIC_JVM_MEMORY_USED:()=>Utr,METRIC_JVM_MEMORY_USED_AFTER_LAST_GC:()=>Vtr,METRIC_JVM_THREAD_COUNT:()=>Jtr,METRIC_KESTREL_ACTIVE_CONNECTIONS:()=>qtr,METRIC_KESTREL_ACTIVE_TLS_HANDSHAKES:()=>ztr,METRIC_KESTREL_CONNECTION_DURATION:()=>Wtr,METRIC_KESTREL_QUEUED_CONNECTIONS:()=>$tr,METRIC_KESTREL_QUEUED_REQUESTS:()=>Htr,METRIC_KESTREL_REJECTED_CONNECTIONS:()=>Gtr,METRIC_KESTREL_TLS_HANDSHAKE_DURATION:()=>Ytr,METRIC_KESTREL_UPGRADED_CONNECTIONS:()=>Ktr,METRIC_SIGNALR_SERVER_ACTIVE_CONNECTIONS:()=>Xtr,METRIC_SIGNALR_SERVER_CONNECTION_DURATION:()=>Qtr,MessageTypeValues:()=>qKt,MessagingDestinationKindValues:()=>vKt,MessagingOperationValues:()=>TKt,NETHOSTCONNECTIONSUBTYPEVALUES_CDMA:()=>$Yt,NETHOSTCONNECTIONSUBTYPEVALUES_CDMA2000_1XRTT:()=>YYt,NETHOSTCONNECTIONSUBTYPEVALUES_EDGE:()=>zYt,NETHOSTCONNECTIONSUBTYPEVALUES_EHRPD:()=>rKt,NETHOSTCONNECTIONSUBTYPEVALUES_EVDO_0:()=>HYt,NETHOSTCONNECTIONSUBTYPEVALUES_EVDO_A:()=>GYt,NETHOSTCONNECTIONSUBTYPEVALUES_EVDO_B:()=>eKt,NETHOSTCONNECTIONSUBTYPEVALUES_GPRS:()=>qYt,NETHOSTCONNECTIONSUBTYPEVALUES_GSM:()=>iKt,NETHOSTCONNECTIONSUBTYPEVALUES_HSDPA:()=>KYt,NETHOSTCONNECTIONSUBTYPEVALUES_HSPA:()=>QYt,NETHOSTCONNECTIONSUBTYPEVALUES_HSPAP:()=>nKt,NETHOSTCONNECTIONSUBTYPEVALUES_HSUPA:()=>XYt,NETHOSTCONNECTIONSUBTYPEVALUES_IDEN:()=>ZYt,NETHOSTCONNECTIONSUBTYPEVALUES_IWLAN:()=>aKt,NETHOSTCONNECTIONSUBTYPEVALUES_LTE:()=>tKt,NETHOSTCONNECTIONSUBTYPEVALUES_LTE_CA:()=>lKt,NETHOSTCONNECTIONSUBTYPEVALUES_NR:()=>oKt,NETHOSTCONNECTIONSUBTYPEVALUES_NRNSA:()=>cKt,NETHOSTCONNECTIONSUBTYPEVALUES_TD_SCDMA:()=>sKt,NETHOSTCONNECTIONSUBTYPEVALUES_UMTS:()=>WYt,NETHOSTCONNECTIONTYPEVALUES_CELL:()=>BYt,NETHOSTCONNECTIONTYPEVALUES_UNAVAILABLE:()=>UYt,NETHOSTCONNECTIONTYPEVALUES_UNKNOWN:()=>VYt,NETHOSTCONNECTIONTYPEVALUES_WIFI:()=>FYt,NETHOSTCONNECTIONTYPEVALUES_WIRED:()=>jYt,NETTRANSPORTVALUES_INPROC:()=>RYt,NETTRANSPORTVALUES_IP:()=>wYt,NETTRANSPORTVALUES_IP_TCP:()=>NYt,NETTRANSPORTVALUES_IP_UDP:()=>DYt,NETTRANSPORTVALUES_OTHER:()=>MYt,NETTRANSPORTVALUES_PIPE:()=>OYt,NETTRANSPORTVALUES_UNIX:()=>IYt,NETWORK_TRANSPORT_VALUE_PIPE:()=>zer,NETWORK_TRANSPORT_VALUE_QUIC:()=>Wer,NETWORK_TRANSPORT_VALUE_TCP:()=>$er,NETWORK_TRANSPORT_VALUE_UDP:()=>Her,NETWORK_TRANSPORT_VALUE_UNIX:()=>Ger,NETWORK_TYPE_VALUE_IPV4:()=>Ker,NETWORK_TYPE_VALUE_IPV6:()=>Xer,NetHostConnectionSubtypeValues:()=>uKt,NetHostConnectionTypeValues:()=>JYt,NetTransportValues:()=>LYt,OSTYPEVALUES_AIX:()=>sZt,OSTYPEVALUES_DARWIN:()=>ZQt,OSTYPEVALUES_DRAGONFLYBSD:()=>nZt,OSTYPEVALUES_FREEBSD:()=>eZt,OSTYPEVALUES_HPUX:()=>iZt,OSTYPEVALUES_LINUX:()=>QQt,OSTYPEVALUES_NETBSD:()=>tZt,OSTYPEVALUES_OPENBSD:()=>rZt,OSTYPEVALUES_SOLARIS:()=>aZt,OSTYPEVALUES_WINDOWS:()=>XQt,OSTYPEVALUES_Z_OS:()=>oZt,OTEL_STATUS_CODE_VALUE_ERROR:()=>ttr,OTEL_STATUS_CODE_VALUE_OK:()=>rtr,OsTypeValues:()=>cZt,RPCGRPCSTATUSCODEVALUES_ABORTED:()=>OKt,RPCGRPCSTATUSCODEVALUES_ALREADY_EXISTS:()=>NKt,RPCGRPCSTATUSCODEVALUES_CANCELLED:()=>xKt,RPCGRPCSTATUSCODEVALUES_DATA_LOSS:()=>jKt,RPCGRPCSTATUSCODEVALUES_DEADLINE_EXCEEDED:()=>kKt,RPCGRPCSTATUSCODEVALUES_FAILED_PRECONDITION:()=>IKt,RPCGRPCSTATUSCODEVALUES_INTERNAL:()=>LKt,RPCGRPCSTATUSCODEVALUES_INVALID_ARGUMENT:()=>AKt,RPCGRPCSTATUSCODEVALUES_NOT_FOUND:()=>PKt,RPCGRPCSTATUSCODEVALUES_OK:()=>EKt,RPCGRPCSTATUSCODEVALUES_OUT_OF_RANGE:()=>RKt,RPCGRPCSTATUSCODEVALUES_PERMISSION_DENIED:()=>DKt,RPCGRPCSTATUSCODEVALUES_RESOURCE_EXHAUSTED:()=>wKt,RPCGRPCSTATUSCODEVALUES_UNAUTHENTICATED:()=>BKt,RPCGRPCSTATUSCODEVALUES_UNAVAILABLE:()=>FKt,RPCGRPCSTATUSCODEVALUES_UNIMPLEMENTED:()=>MKt,RPCGRPCSTATUSCODEVALUES_UNKNOWN:()=>CKt,RpcGrpcStatusCodeValues:()=>UKt,SEMATTRS_AWS_DYNAMODB_ATTRIBUTES_TO_GET:()=>gHt,SEMATTRS_AWS_DYNAMODB_ATTRIBUTE_DEFINITIONS:()=>PHt,SEMATTRS_AWS_DYNAMODB_CONSISTENT_READ:()=>pHt,SEMATTRS_AWS_DYNAMODB_CONSUMED_CAPACITY:()=>lHt,SEMATTRS_AWS_DYNAMODB_COUNT:()=>AHt,SEMATTRS_AWS_DYNAMODB_EXCLUSIVE_START_TABLE:()=>bHt,SEMATTRS_AWS_DYNAMODB_GLOBAL_SECONDARY_INDEXES:()=>vHt,SEMATTRS_AWS_DYNAMODB_GLOBAL_SECONDARY_INDEX_UPDATES:()=>NHt,SEMATTRS_AWS_DYNAMODB_INDEX_NAME:()=>hHt,SEMATTRS_AWS_DYNAMODB_ITEM_COLLECTION_METRICS:()=>uHt,SEMATTRS_AWS_DYNAMODB_LIMIT:()=>mHt,SEMATTRS_AWS_DYNAMODB_LOCAL_SECONDARY_INDEXES:()=>SHt,SEMATTRS_AWS_DYNAMODB_PROJECTION:()=>dHt,SEMATTRS_AWS_DYNAMODB_PROVISIONED_READ_CAPACITY:()=>_Ht,SEMATTRS_AWS_DYNAMODB_PROVISIONED_WRITE_CAPACITY:()=>fHt,SEMATTRS_AWS_DYNAMODB_SCANNED_COUNT:()=>kHt,SEMATTRS_AWS_DYNAMODB_SCAN_FORWARD:()=>EHt,SEMATTRS_AWS_DYNAMODB_SEGMENT:()=>xHt,SEMATTRS_AWS_DYNAMODB_SELECT:()=>yHt,SEMATTRS_AWS_DYNAMODB_TABLE_COUNT:()=>THt,SEMATTRS_AWS_DYNAMODB_TABLE_NAMES:()=>cHt,SEMATTRS_AWS_DYNAMODB_TOTAL_SEGMENTS:()=>CHt,SEMATTRS_AWS_LAMBDA_INVOKED_ARN:()=>VWt,SEMATTRS_CODE_FILEPATH:()=>W$t,SEMATTRS_CODE_FUNCTION:()=>q$t,SEMATTRS_CODE_LINENO:()=>$$t,SEMATTRS_CODE_NAMESPACE:()=>z$t,SEMATTRS_DB_CASSANDRA_CONSISTENCY_LEVEL:()=>QWt,SEMATTRS_DB_CASSANDRA_COORDINATOR_DC:()=>n$t,SEMATTRS_DB_CASSANDRA_COORDINATOR_ID:()=>r$t,SEMATTRS_DB_CASSANDRA_IDEMPOTENCE:()=>e$t,SEMATTRS_DB_CASSANDRA_KEYSPACE:()=>KWt,SEMATTRS_DB_CASSANDRA_PAGE_SIZE:()=>XWt,SEMATTRS_DB_CASSANDRA_SPECULATIVE_EXECUTION_COUNT:()=>t$t,SEMATTRS_DB_CASSANDRA_TABLE:()=>ZWt,SEMATTRS_DB_CONNECTION_STRING:()=>qWt,SEMATTRS_DB_HBASE_NAMESPACE:()=>i$t,SEMATTRS_DB_JDBC_DRIVER_CLASSNAME:()=>WWt,SEMATTRS_DB_MONGODB_COLLECTION:()=>a$t,SEMATTRS_DB_MSSQL_INSTANCE_NAME:()=>YWt,SEMATTRS_DB_NAME:()=>$Wt,SEMATTRS_DB_OPERATION:()=>GWt,SEMATTRS_DB_REDIS_DATABASE_INDEX:()=>s$t,SEMATTRS_DB_SQL_TABLE:()=>o$t,SEMATTRS_DB_STATEMENT:()=>HWt,SEMATTRS_DB_SYSTEM:()=>JWt,SEMATTRS_DB_USER:()=>zWt,SEMATTRS_ENDUSER_ID:()=>j$t,SEMATTRS_ENDUSER_ROLE:()=>B$t,SEMATTRS_ENDUSER_SCOPE:()=>U$t,SEMATTRS_EXCEPTION_ESCAPED:()=>_$t,SEMATTRS_EXCEPTION_MESSAGE:()=>l$t,SEMATTRS_EXCEPTION_STACKTRACE:()=>u$t,SEMATTRS_EXCEPTION_TYPE:()=>c$t,SEMATTRS_FAAS_COLDSTART:()=>S$t,SEMATTRS_FAAS_CRON:()=>v$t,SEMATTRS_FAAS_DOCUMENT_COLLECTION:()=>d$t,SEMATTRS_FAAS_DOCUMENT_NAME:()=>h$t,SEMATTRS_FAAS_DOCUMENT_OPERATION:()=>m$t,SEMATTRS_FAAS_DOCUMENT_TIME:()=>g$t,SEMATTRS_FAAS_EXECUTION:()=>p$t,SEMATTRS_FAAS_INVOKED_NAME:()=>b$t,SEMATTRS_FAAS_INVOKED_PROVIDER:()=>T$t,SEMATTRS_FAAS_INVOKED_REGION:()=>E$t,SEMATTRS_FAAS_TIME:()=>y$t,SEMATTRS_FAAS_TRIGGER:()=>f$t,SEMATTRS_HTTP_CLIENT_IP:()=>oHt,SEMATTRS_HTTP_FLAVOR:()=>Z$t,SEMATTRS_HTTP_HOST:()=>K$t,SEMATTRS_HTTP_METHOD:()=>H$t,SEMATTRS_HTTP_REQUEST_CONTENT_LENGTH:()=>tHt,SEMATTRS_HTTP_REQUEST_CONTENT_LENGTH_UNCOMPRESSED:()=>rHt,SEMATTRS_HTTP_RESPONSE_CONTENT_LENGTH:()=>nHt,SEMATTRS_HTTP_RESPONSE_CONTENT_LENGTH_UNCOMPRESSED:()=>iHt,SEMATTRS_HTTP_ROUTE:()=>aHt,SEMATTRS_HTTP_SCHEME:()=>X$t,SEMATTRS_HTTP_SERVER_NAME:()=>sHt,SEMATTRS_HTTP_STATUS_CODE:()=>Q$t,SEMATTRS_HTTP_TARGET:()=>Y$t,SEMATTRS_HTTP_URL:()=>G$t,SEMATTRS_HTTP_USER_AGENT:()=>eHt,SEMATTRS_MESSAGE_COMPRESSED_SIZE:()=>sGt,SEMATTRS_MESSAGE_ID:()=>iGt,SEMATTRS_MESSAGE_TYPE:()=>nGt,SEMATTRS_MESSAGE_UNCOMPRESSED_SIZE:()=>aGt,SEMATTRS_MESSAGING_CONSUMER_ID:()=>JHt,SEMATTRS_MESSAGING_CONVERSATION_ID:()=>jHt,SEMATTRS_MESSAGING_DESTINATION:()=>wHt,SEMATTRS_MESSAGING_DESTINATION_KIND:()=>IHt,SEMATTRS_MESSAGING_KAFKA_CLIENT_ID:()=>$Ht,SEMATTRS_MESSAGING_KAFKA_CONSUMER_GROUP:()=>WHt,SEMATTRS_MESSAGING_KAFKA_MESSAGE_KEY:()=>zHt,SEMATTRS_MESSAGING_KAFKA_PARTITION:()=>HHt,SEMATTRS_MESSAGING_KAFKA_TOMBSTONE:()=>GHt,SEMATTRS_MESSAGING_MESSAGE_ID:()=>FHt,SEMATTRS_MESSAGING_MESSAGE_PAYLOAD_COMPRESSED_SIZE_BYTES:()=>UHt,SEMATTRS_MESSAGING_MESSAGE_PAYLOAD_SIZE_BYTES:()=>BHt,SEMATTRS_MESSAGING_OPERATION:()=>VHt,SEMATTRS_MESSAGING_PROTOCOL:()=>RHt,SEMATTRS_MESSAGING_PROTOCOL_VERSION:()=>MHt,SEMATTRS_MESSAGING_RABBITMQ_ROUTING_KEY:()=>qHt,SEMATTRS_MESSAGING_SYSTEM:()=>DHt,SEMATTRS_MESSAGING_TEMP_DESTINATION:()=>OHt,SEMATTRS_MESSAGING_URL:()=>LHt,SEMATTRS_NET_HOST_CARRIER_ICC:()=>L$t,SEMATTRS_NET_HOST_CARRIER_MCC:()=>R$t,SEMATTRS_NET_HOST_CARRIER_MNC:()=>M$t,SEMATTRS_NET_HOST_CARRIER_NAME:()=>O$t,SEMATTRS_NET_HOST_CONNECTION_SUBTYPE:()=>I$t,SEMATTRS_NET_HOST_CONNECTION_TYPE:()=>w$t,SEMATTRS_NET_HOST_IP:()=>P$t,SEMATTRS_NET_HOST_NAME:()=>D$t,SEMATTRS_NET_HOST_PORT:()=>N$t,SEMATTRS_NET_PEER_IP:()=>C$t,SEMATTRS_NET_PEER_NAME:()=>k$t,SEMATTRS_NET_PEER_PORT:()=>A$t,SEMATTRS_NET_TRANSPORT:()=>x$t,SEMATTRS_PEER_SERVICE:()=>F$t,SEMATTRS_RPC_GRPC_STATUS_CODE:()=>QHt,SEMATTRS_RPC_JSONRPC_ERROR_CODE:()=>tGt,SEMATTRS_RPC_JSONRPC_ERROR_MESSAGE:()=>rGt,SEMATTRS_RPC_JSONRPC_REQUEST_ID:()=>eGt,SEMATTRS_RPC_JSONRPC_VERSION:()=>ZHt,SEMATTRS_RPC_METHOD:()=>XHt,SEMATTRS_RPC_SERVICE:()=>KHt,SEMATTRS_RPC_SYSTEM:()=>YHt,SEMATTRS_THREAD_ID:()=>V$t,SEMATTRS_THREAD_NAME:()=>J$t,SEMRESATTRS_AWS_ECS_CLUSTER_ARN:()=>KKt,SEMRESATTRS_AWS_ECS_CONTAINER_ARN:()=>YKt,SEMRESATTRS_AWS_ECS_LAUNCHTYPE:()=>XKt,SEMRESATTRS_AWS_ECS_TASK_ARN:()=>QKt,SEMRESATTRS_AWS_ECS_TASK_FAMILY:()=>ZKt,SEMRESATTRS_AWS_ECS_TASK_REVISION:()=>eXt,SEMRESATTRS_AWS_EKS_CLUSTER_ARN:()=>tXt,SEMRESATTRS_AWS_LOG_GROUP_ARNS:()=>nXt,SEMRESATTRS_AWS_LOG_GROUP_NAMES:()=>rXt,SEMRESATTRS_AWS_LOG_STREAM_ARNS:()=>sXt,SEMRESATTRS_AWS_LOG_STREAM_NAMES:()=>iXt,SEMRESATTRS_CLOUD_ACCOUNT_ID:()=>WKt,SEMRESATTRS_CLOUD_AVAILABILITY_ZONE:()=>HKt,SEMRESATTRS_CLOUD_PLATFORM:()=>GKt,SEMRESATTRS_CLOUD_PROVIDER:()=>zKt,SEMRESATTRS_CLOUD_REGION:()=>$Kt,SEMRESATTRS_CONTAINER_ID:()=>oXt,SEMRESATTRS_CONTAINER_IMAGE_NAME:()=>lXt,SEMRESATTRS_CONTAINER_IMAGE_TAG:()=>uXt,SEMRESATTRS_CONTAINER_NAME:()=>aXt,SEMRESATTRS_CONTAINER_RUNTIME:()=>cXt,SEMRESATTRS_DEPLOYMENT_ENVIRONMENT:()=>_Xt,SEMRESATTRS_DEVICE_ID:()=>fXt,SEMRESATTRS_DEVICE_MODEL_IDENTIFIER:()=>pXt,SEMRESATTRS_DEVICE_MODEL_NAME:()=>dXt,SEMRESATTRS_FAAS_ID:()=>gXt,SEMRESATTRS_FAAS_INSTANCE:()=>yXt,SEMRESATTRS_FAAS_MAX_MEMORY:()=>vXt,SEMRESATTRS_FAAS_NAME:()=>mXt,SEMRESATTRS_FAAS_VERSION:()=>hXt,SEMRESATTRS_HOST_ARCH:()=>EXt,SEMRESATTRS_HOST_ID:()=>SXt,SEMRESATTRS_HOST_IMAGE_ID:()=>CXt,SEMRESATTRS_HOST_IMAGE_NAME:()=>xXt,SEMRESATTRS_HOST_IMAGE_VERSION:()=>AXt,SEMRESATTRS_HOST_NAME:()=>bXt,SEMRESATTRS_HOST_TYPE:()=>TXt,SEMRESATTRS_K8S_CLUSTER_NAME:()=>kXt,SEMRESATTRS_K8S_CONTAINER_NAME:()=>OXt,SEMRESATTRS_K8S_CRONJOB_NAME:()=>WXt,SEMRESATTRS_K8S_CRONJOB_UID:()=>zXt,SEMRESATTRS_K8S_DAEMONSET_NAME:()=>VXt,SEMRESATTRS_K8S_DAEMONSET_UID:()=>UXt,SEMRESATTRS_K8S_DEPLOYMENT_NAME:()=>FXt,SEMRESATTRS_K8S_DEPLOYMENT_UID:()=>LXt,SEMRESATTRS_K8S_JOB_NAME:()=>qXt,SEMRESATTRS_K8S_JOB_UID:()=>JXt,SEMRESATTRS_K8S_NAMESPACE_NAME:()=>DXt,SEMRESATTRS_K8S_NODE_NAME:()=>PXt,SEMRESATTRS_K8S_NODE_UID:()=>NXt,SEMRESATTRS_K8S_POD_NAME:()=>IXt,SEMRESATTRS_K8S_POD_UID:()=>wXt,SEMRESATTRS_K8S_REPLICASET_NAME:()=>MXt,SEMRESATTRS_K8S_REPLICASET_UID:()=>RXt,SEMRESATTRS_K8S_STATEFULSET_NAME:()=>BXt,SEMRESATTRS_K8S_STATEFULSET_UID:()=>jXt,SEMRESATTRS_OS_DESCRIPTION:()=>HXt,SEMRESATTRS_OS_NAME:()=>GXt,SEMRESATTRS_OS_TYPE:()=>$Xt,SEMRESATTRS_OS_VERSION:()=>YXt,SEMRESATTRS_PROCESS_COMMAND:()=>ZXt,SEMRESATTRS_PROCESS_COMMAND_ARGS:()=>tQt,SEMRESATTRS_PROCESS_COMMAND_LINE:()=>eQt,SEMRESATTRS_PROCESS_EXECUTABLE_NAME:()=>XXt,SEMRESATTRS_PROCESS_EXECUTABLE_PATH:()=>QXt,SEMRESATTRS_PROCESS_OWNER:()=>rQt,SEMRESATTRS_PROCESS_PID:()=>KXt,SEMRESATTRS_PROCESS_RUNTIME_DESCRIPTION:()=>sQt,SEMRESATTRS_PROCESS_RUNTIME_NAME:()=>nQt,SEMRESATTRS_PROCESS_RUNTIME_VERSION:()=>iQt,SEMRESATTRS_SERVICE_INSTANCE_ID:()=>oQt,SEMRESATTRS_SERVICE_NAME:()=>vke,SEMRESATTRS_SERVICE_NAMESPACE:()=>aQt,SEMRESATTRS_SERVICE_VERSION:()=>cQt,SEMRESATTRS_TELEMETRY_AUTO_VERSION:()=>fQt,SEMRESATTRS_TELEMETRY_SDK_LANGUAGE:()=>uQt,SEMRESATTRS_TELEMETRY_SDK_NAME:()=>lQt,SEMRESATTRS_TELEMETRY_SDK_VERSION:()=>_Qt,SEMRESATTRS_WEBENGINE_DESCRIPTION:()=>mQt,SEMRESATTRS_WEBENGINE_NAME:()=>pQt,SEMRESATTRS_WEBENGINE_VERSION:()=>dQt,SIGNALR_CONNECTION_STATUS_VALUE_APP_SHUTDOWN:()=>ltr,SIGNALR_CONNECTION_STATUS_VALUE_NORMAL_CLOSURE:()=>utr,SIGNALR_CONNECTION_STATUS_VALUE_TIMEOUT:()=>_tr,SIGNALR_TRANSPORT_VALUE_LONG_POLLING:()=>ptr,SIGNALR_TRANSPORT_VALUE_SERVER_SENT_EVENTS:()=>dtr,SIGNALR_TRANSPORT_VALUE_WEB_SOCKETS:()=>mtr,SemanticAttributes:()=>oGt,SemanticResourceAttributes:()=>gQt,TELEMETRYSDKLANGUAGEVALUES_CPP:()=>lZt,TELEMETRYSDKLANGUAGEVALUES_DOTNET:()=>uZt,TELEMETRYSDKLANGUAGEVALUES_ERLANG:()=>_Zt,TELEMETRYSDKLANGUAGEVALUES_GO:()=>fZt,TELEMETRYSDKLANGUAGEVALUES_JAVA:()=>pZt,TELEMETRYSDKLANGUAGEVALUES_NODEJS:()=>dZt,TELEMETRYSDKLANGUAGEVALUES_PHP:()=>mZt,TELEMETRYSDKLANGUAGEVALUES_PYTHON:()=>gZt,TELEMETRYSDKLANGUAGEVALUES_RUBY:()=>hZt,TELEMETRYSDKLANGUAGEVALUES_WEBJS:()=>yZt,TELEMETRY_SDK_LANGUAGE_VALUE_CPP:()=>AZt,TELEMETRY_SDK_LANGUAGE_VALUE_DOTNET:()=>kZt,TELEMETRY_SDK_LANGUAGE_VALUE_ERLANG:()=>PZt,TELEMETRY_SDK_LANGUAGE_VALUE_GO:()=>NZt,TELEMETRY_SDK_LANGUAGE_VALUE_JAVA:()=>DZt,TELEMETRY_SDK_LANGUAGE_VALUE_NODEJS:()=>wZt,TELEMETRY_SDK_LANGUAGE_VALUE_PHP:()=>IZt,TELEMETRY_SDK_LANGUAGE_VALUE_PYTHON:()=>OZt,TELEMETRY_SDK_LANGUAGE_VALUE_RUBY:()=>RZt,TELEMETRY_SDK_LANGUAGE_VALUE_RUST:()=>MZt,TELEMETRY_SDK_LANGUAGE_VALUE_SWIFT:()=>LZt,TELEMETRY_SDK_LANGUAGE_VALUE_WEBJS:()=>FZt,TelemetrySdkLanguageValues:()=>vZt});var hC=Jo(()=>{Jnt();dat();mat();gat()});var hat=xt(lie=>{"use strict";Object.defineProperty(lie,"__esModule",{value:!0});lie.SDK_INFO=void 0;var Ztr=hke(),Hq=(hC(),fc(aP));lie.SDK_INFO={[Hq.SEMRESATTRS_TELEMETRY_SDK_NAME]:"opentelemetry",[Hq.SEMRESATTRS_PROCESS_RUNTIME_NAME]:"node",[Hq.SEMRESATTRS_TELEMETRY_SDK_LANGUAGE]:Hq.TELEMETRYSDKLANGUAGEVALUES_NODEJS,[Hq.SEMRESATTRS_TELEMETRY_SDK_VERSION]:Ztr.VERSION}});var yat=xt(uie=>{"use strict";Object.defineProperty(uie,"__esModule",{value:!0});uie.unrefTimer=void 0;function err(l){l.unref()}uie.unrefTimer=err});var Sat=xt(xh=>{"use strict";Object.defineProperty(xh,"__esModule",{value:!0});xh.unrefTimer=xh.SDK_INFO=xh.otperformance=xh.RandomIdGenerator=xh.hexToBase64=xh._globalThis=xh.getEnv=xh.getEnvWithoutDefaults=void 0;var vat=JQe();Object.defineProperty(xh,"getEnvWithoutDefaults",{enumerable:!0,get:function(){return vat.getEnvWithoutDefaults}});Object.defineProperty(xh,"getEnv",{enumerable:!0,get:function(){return vat.getEnv}});var trr=qQe();Object.defineProperty(xh,"_globalThis",{enumerable:!0,get:function(){return trr._globalThis}});var rrr=WQe();Object.defineProperty(xh,"hexToBase64",{enumerable:!0,get:function(){return rrr.hexToBase64}});var nrr=GQe();Object.defineProperty(xh,"RandomIdGenerator",{enumerable:!0,get:function(){return nrr.RandomIdGenerator}});var irr=YQe();Object.defineProperty(xh,"otperformance",{enumerable:!0,get:function(){return irr.otperformance}});var srr=hat();Object.defineProperty(xh,"SDK_INFO",{enumerable:!0,get:function(){return srr.SDK_INFO}});var arr=yat();Object.defineProperty(xh,"unrefTimer",{enumerable:!0,get:function(){return arr.unrefTimer}})});var Ske=xt(Ch=>{"use strict";Object.defineProperty(Ch,"__esModule",{value:!0});Ch.unrefTimer=Ch.otperformance=Ch.hexToBase64=Ch.getEnvWithoutDefaults=Ch.getEnv=Ch._globalThis=Ch.SDK_INFO=Ch.RandomIdGenerator=void 0;var pw=Sat();Object.defineProperty(Ch,"RandomIdGenerator",{enumerable:!0,get:function(){return pw.RandomIdGenerator}});Object.defineProperty(Ch,"SDK_INFO",{enumerable:!0,get:function(){return pw.SDK_INFO}});Object.defineProperty(Ch,"_globalThis",{enumerable:!0,get:function(){return pw._globalThis}});Object.defineProperty(Ch,"getEnv",{enumerable:!0,get:function(){return pw.getEnv}});Object.defineProperty(Ch,"getEnvWithoutDefaults",{enumerable:!0,get:function(){return pw.getEnvWithoutDefaults}});Object.defineProperty(Ch,"hexToBase64",{enumerable:!0,get:function(){return pw.hexToBase64}});Object.defineProperty(Ch,"otperformance",{enumerable:!0,get:function(){return pw.otperformance}});Object.defineProperty(Ch,"unrefTimer",{enumerable:!0,get:function(){return pw.unrefTimer}})});var xat=xt(rp=>{"use strict";Object.defineProperty(rp,"__esModule",{value:!0});rp.addHrTimes=rp.isTimeInput=rp.isTimeInputHrTime=rp.hrTimeToMicroseconds=rp.hrTimeToMilliseconds=rp.hrTimeToNanoseconds=rp.hrTimeToTimeStamp=rp.hrTimeDuration=rp.timeInputToHrTime=rp.hrTime=rp.getTimeOrigin=rp.millisToHrTime=void 0;var bke=Ske(),bat=9,orr=6,crr=Math.pow(10,orr),_ie=Math.pow(10,bat);function Gq(l){let c=l/1e3,f=Math.trunc(c),y=Math.round(l%1e3*crr);return[f,y]}rp.millisToHrTime=Gq;function Tke(){let l=bke.otperformance.timeOrigin;if(typeof l!="number"){let c=bke.otperformance;l=c.timing&&c.timing.fetchStart}return l}rp.getTimeOrigin=Tke;function Tat(l){let c=Gq(Tke()),f=Gq(typeof l=="number"?l:bke.otperformance.now());return Eat(c,f)}rp.hrTime=Tat;function lrr(l){if(Eke(l))return l;if(typeof l=="number")return l<Tke()?Tat(l):Gq(l);if(l instanceof Date)return Gq(l.getTime());throw TypeError("Invalid input type")}rp.timeInputToHrTime=lrr;function urr(l,c){let f=c[0]-l[0],y=c[1]-l[1];return y<0&&(f-=1,y+=_ie),[f,y]}rp.hrTimeDuration=urr;function _rr(l){let c=bat,f=`${"0".repeat(c)}${l[1]}Z`,y=f.substr(f.length-c-1);return new Date(l[0]*1e3).toISOString().replace("000Z",y)}rp.hrTimeToTimeStamp=_rr;function frr(l){return l[0]*_ie+l[1]}rp.hrTimeToNanoseconds=frr;function prr(l){return l[0]*1e3+l[1]/1e6}rp.hrTimeToMilliseconds=prr;function drr(l){return l[0]*1e6+l[1]/1e3}rp.hrTimeToMicroseconds=drr;function Eke(l){return Array.isArray(l)&&l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"}rp.isTimeInputHrTime=Eke;function mrr(l){return Eke(l)||typeof l=="number"||l instanceof Date}rp.isTimeInput=mrr;function Eat(l,c){let f=[l[0]+c[0],l[1]+c[1]];return f[1]>=_ie&&(f[1]-=_ie,f[0]+=1),f}rp.addHrTimes=Eat});var Cat=xt(Yq=>{"use strict";Object.defineProperty(Yq,"__esModule",{value:!0});Yq.ExportResultCode=void 0;var grr;(function(l){l[l.SUCCESS=0]="SUCCESS",l[l.FAILED=1]="FAILED"})(grr=Yq.ExportResultCode||(Yq.ExportResultCode={}))});var kat=xt(fie=>{"use strict";Object.defineProperty(fie,"__esModule",{value:!0});fie.CompositePropagator=void 0;var Aat=(zc(),fc(Xc)),xke=class{constructor(c={}){var f;this._propagators=(f=c.propagators)!==null&&f!==void 0?f:[],this._fields=Array.from(new Set(this._propagators.map(y=>typeof y.fields=="function"?y.fields():[]).reduce((y,b)=>y.concat(b),[])))}inject(c,f,y){for(let b of this._propagators)try{b.inject(c,f,y)}catch(A){Aat.diag.warn(`Failed to inject with ${b.constructor.name}. Err: ${A.message}`)}}extract(c,f,y){return this._propagators.reduce((b,A)=>{try{return A.extract(b,f,y)}catch(g){Aat.diag.warn(`Failed to inject with ${A.constructor.name}. Err: ${g.message}`)}return b},c)}fields(){return this._fields.slice()}};fie.CompositePropagator=xke});var Pat=xt(TL=>{"use strict";Object.defineProperty(TL,"__esModule",{value:!0});TL.validateValue=TL.validateKey=void 0;var Cke="[_0-9a-z-*/]",hrr=`[a-z]${Cke}{0,255}`,yrr=`[a-z0-9]${Cke}{0,240}@[a-z]${Cke}{0,13}`,vrr=new RegExp(`^(?:${hrr}|${yrr})$`),Srr=/^[ -~]{0,255}[!-~]$/,brr=/,|=/;function Trr(l){return vrr.test(l)}TL.validateKey=Trr;function Err(l){return Srr.test(l)&&!brr.test(l)}TL.validateValue=Err});var kke=xt(pie=>{"use strict";Object.defineProperty(pie,"__esModule",{value:!0});pie.TraceState=void 0;var Nat=Pat(),Dat=32,xrr=512,wat=",",Iat="=",Ake=class l{constructor(c){this._internalState=new Map,c&&this._parse(c)}set(c,f){let y=this._clone();return y._internalState.has(c)&&y._internalState.delete(c),y._internalState.set(c,f),y}unset(c){let f=this._clone();return f._internalState.delete(c),f}get(c){return this._internalState.get(c)}serialize(){return this._keys().reduce((c,f)=>(c.push(f+Iat+this.get(f)),c),[]).join(wat)}_parse(c){c.length>xrr||(this._internalState=c.split(wat).reverse().reduce((f,y)=>{let b=y.trim(),A=b.indexOf(Iat);if(A!==-1){let g=b.slice(0,A),p=b.slice(A+1,y.length);(0,Nat.validateKey)(g)&&(0,Nat.validateValue)(p)&&f.set(g,p)}return f},new Map),this._internalState.size>Dat&&(this._internalState=new Map(Array.from(this._internalState.entries()).reverse().slice(0,Dat))))}_keys(){return Array.from(this._internalState.keys()).reverse()}_clone(){let c=new l;return c._internalState=new Map(this._internalState),c}};pie.TraceState=Ake});var Rat=xt(e0=>{"use strict";Object.defineProperty(e0,"__esModule",{value:!0});e0.W3CTraceContextPropagator=e0.parseTraceParent=e0.TRACE_STATE_HEADER=e0.TRACE_PARENT_HEADER=void 0;var die=(zc(),fc(Xc)),Crr=Wq(),Arr=kke();e0.TRACE_PARENT_HEADER="traceparent";e0.TRACE_STATE_HEADER="tracestate";var krr="00",Prr="(?!ff)[\\da-f]{2}",Nrr="(?![0]{32})[\\da-f]{32}",Drr="(?![0]{16})[\\da-f]{16}",wrr="[\\da-f]{2}",Irr=new RegExp(`^\\s?(${Prr})-(${Nrr})-(${Drr})-(${wrr})(-.*)?\\s?$`);function Oat(l){let c=Irr.exec(l);return!c||c[1]==="00"&&c[5]?null:{traceId:c[2],spanId:c[3],traceFlags:parseInt(c[4],16)}}e0.parseTraceParent=Oat;var Pke=class{inject(c,f,y){let b=die.trace.getSpanContext(c);if(!b||(0,Crr.isTracingSuppressed)(c)||!(0,die.isSpanContextValid)(b))return;let A=`${krr}-${b.traceId}-${b.spanId}-0${Number(b.traceFlags||die.TraceFlags.NONE).toString(16)}`;y.set(f,e0.TRACE_PARENT_HEADER,A),b.traceState&&y.set(f,e0.TRACE_STATE_HEADER,b.traceState.serialize())}extract(c,f,y){let b=y.get(f,e0.TRACE_PARENT_HEADER);if(!b)return c;let A=Array.isArray(b)?b[0]:b;if(typeof A!="string")return c;let g=Oat(A);if(!g)return c;g.isRemote=!0;let p=y.get(f,e0.TRACE_STATE_HEADER);if(p){let k=Array.isArray(p)?p.join(","):p;g.traceState=new Arr.TraceState(typeof k=="string"?k:void 0)}return die.trace.setSpanContext(c,g)}fields(){return[e0.TRACE_PARENT_HEADER,e0.TRACE_STATE_HEADER]}};e0.W3CTraceContextPropagator=Pke});var Mat=xt(hx=>{"use strict";Object.defineProperty(hx,"__esModule",{value:!0});hx.getRPCMetadata=hx.deleteRPCMetadata=hx.setRPCMetadata=hx.RPCType=void 0;var Orr=(zc(),fc(Xc)),Nke=(0,Orr.createContextKey)("OpenTelemetry SDK Context Key RPC_METADATA"),Rrr;(function(l){l.HTTP="http"})(Rrr=hx.RPCType||(hx.RPCType={}));function Mrr(l,c){return l.setValue(Nke,c)}hx.setRPCMetadata=Mrr;function Lrr(l){return l.deleteValue(Nke)}hx.deleteRPCMetadata=Lrr;function Frr(l){return l.getValue(Nke)}hx.getRPCMetadata=Frr});var wke=xt(mie=>{"use strict";Object.defineProperty(mie,"__esModule",{value:!0});mie.AlwaysOffSampler=void 0;var jrr=(zc(),fc(Xc)),Dke=class{shouldSample(){return{decision:jrr.SamplingDecision.NOT_RECORD}}toString(){return"AlwaysOffSampler"}};mie.AlwaysOffSampler=Dke});var Oke=xt(gie=>{"use strict";Object.defineProperty(gie,"__esModule",{value:!0});gie.AlwaysOnSampler=void 0;var Brr=(zc(),fc(Xc)),Ike=class{shouldSample(){return{decision:Brr.SamplingDecision.RECORD_AND_SAMPLED}}toString(){return"AlwaysOnSampler"}};gie.AlwaysOnSampler=Ike});var Fat=xt(yie=>{"use strict";Object.defineProperty(yie,"__esModule",{value:!0});yie.ParentBasedSampler=void 0;var hie=(zc(),fc(Xc)),Urr=_ke(),Lat=wke(),Rke=Oke(),Mke=class{constructor(c){var f,y,b,A;this._root=c.root,this._root||((0,Urr.globalErrorHandler)(new Error("ParentBasedSampler must have a root sampler configured")),this._root=new Rke.AlwaysOnSampler),this._remoteParentSampled=(f=c.remoteParentSampled)!==null&&f!==void 0?f:new Rke.AlwaysOnSampler,this._remoteParentNotSampled=(y=c.remoteParentNotSampled)!==null&&y!==void 0?y:new Lat.AlwaysOffSampler,this._localParentSampled=(b=c.localParentSampled)!==null&&b!==void 0?b:new Rke.AlwaysOnSampler,this._localParentNotSampled=(A=c.localParentNotSampled)!==null&&A!==void 0?A:new Lat.AlwaysOffSampler}shouldSample(c,f,y,b,A,g){let p=hie.trace.getSpanContext(c);return!p||!(0,hie.isSpanContextValid)(p)?this._root.shouldSample(c,f,y,b,A,g):p.isRemote?p.traceFlags&hie.TraceFlags.SAMPLED?this._remoteParentSampled.shouldSample(c,f,y,b,A,g):this._remoteParentNotSampled.shouldSample(c,f,y,b,A,g):p.traceFlags&hie.TraceFlags.SAMPLED?this._localParentSampled.shouldSample(c,f,y,b,A,g):this._localParentNotSampled.shouldSample(c,f,y,b,A,g)}toString(){return`ParentBased{root=${this._root.toString()}, remoteParentSampled=${this._remoteParentSampled.toString()}, remoteParentNotSampled=${this._remoteParentNotSampled.toString()}, localParentSampled=${this._localParentSampled.toString()}, localParentNotSampled=${this._localParentNotSampled.toString()}}`}};yie.ParentBasedSampler=Mke});var jat=xt(vie=>{"use strict";Object.defineProperty(vie,"__esModule",{value:!0});vie.TraceIdRatioBasedSampler=void 0;var Lke=(zc(),fc(Xc)),Fke=class{constructor(c=0){this._ratio=c,this._ratio=this._normalize(c),this._upperBound=Math.floor(this._ratio*4294967295)}shouldSample(c,f){return{decision:(0,Lke.isValidTraceId)(f)&&this._accumulate(f)<this._upperBound?Lke.SamplingDecision.RECORD_AND_SAMPLED:Lke.SamplingDecision.NOT_RECORD}}toString(){return`TraceIdRatioBased{${this._ratio}}`}_normalize(c){return typeof c!="number"||isNaN(c)?0:c>=1?1:c<=0?0:c}_accumulate(c){let f=0;for(let y=0;y<c.length/8;y++){let b=y*8,A=parseInt(c.slice(b,b+8),16);f=(f^A)>>>0}return f}};vie.TraceIdRatioBasedSampler=Fke});var qat=xt(Sie=>{"use strict";Object.defineProperty(Sie,"__esModule",{value:!0});Sie.isPlainObject=void 0;var Vrr="[object Object]",Jrr="[object Null]",qrr="[object Undefined]",zrr=Function.prototype,Bat=zrr.toString,Wrr=Bat.call(Object),$rr=Hrr(Object.getPrototypeOf,Object),Uat=Object.prototype,Vat=Uat.hasOwnProperty,N4=Symbol?Symbol.toStringTag:void 0,Jat=Uat.toString;function Hrr(l,c){return function(f){return l(c(f))}}function Grr(l){if(!Yrr(l)||Krr(l)!==Vrr)return!1;let c=$rr(l);if(c===null)return!0;let f=Vat.call(c,"constructor")&&c.constructor;return typeof f=="function"&&f instanceof f&&Bat.call(f)===Wrr}Sie.isPlainObject=Grr;function Yrr(l){return l!=null&&typeof l=="object"}function Krr(l){return l==null?l===void 0?qrr:Jrr:N4&&N4 in Object(l)?Xrr(l):Qrr(l)}function Xrr(l){let c=Vat.call(l,N4),f=l[N4],y=!1;try{l[N4]=void 0,y=!0}catch{}let b=Jat.call(l);return y&&(c?l[N4]=f:delete l[N4]),b}function Qrr(l){return Jat.call(l)}});var Gat=xt(Eie=>{"use strict";Object.defineProperty(Eie,"__esModule",{value:!0});Eie.merge=void 0;var zat=qat(),Zrr=20;function enr(...l){let c=l.shift(),f=new WeakMap;for(;l.length>0;)c=$at(c,l.shift(),0,f);return c}Eie.merge=enr;function jke(l){return Tie(l)?l.slice():l}function $at(l,c,f=0,y){let b;if(!(f>Zrr)){if(f++,bie(l)||bie(c)||Hat(c))b=jke(c);else if(Tie(l)){if(b=l.slice(),Tie(c))for(let A=0,g=c.length;A<g;A++)b.push(jke(c[A]));else if(Kq(c)){let A=Object.keys(c);for(let g=0,p=A.length;g<p;g++){let k=A[g];b[k]=jke(c[k])}}}else if(Kq(l))if(Kq(c)){if(!tnr(l,c))return c;b=Object.assign({},l);let A=Object.keys(c);for(let g=0,p=A.length;g<p;g++){let k=A[g],j=c[k];if(bie(j))typeof j>"u"?delete b[k]:b[k]=j;else{let se=b[k],ze=j;if(Wat(l,k,y)||Wat(c,k,y))delete b[k];else{if(Kq(se)&&Kq(ze)){let ve=y.get(se)||[],lr=y.get(ze)||[];ve.push({obj:l,key:k}),lr.push({obj:c,key:k}),y.set(se,ve),y.set(ze,lr)}b[k]=$at(b[k],j,f,y)}}}}else b=c;return b}}function Wat(l,c,f){let y=f.get(l[c])||[];for(let b=0,A=y.length;b<A;b++){let g=y[b];if(g.key===c&&g.obj===l)return!0}return!1}function Tie(l){return Array.isArray(l)}function Hat(l){return typeof l=="function"}function Kq(l){return!bie(l)&&!Tie(l)&&!Hat(l)&&typeof l=="object"}function bie(l){return typeof l=="string"||typeof l=="number"||typeof l=="boolean"||typeof l>"u"||l instanceof Date||l instanceof RegExp||l===null}function tnr(l,c){return!(!(0,zat.isPlainObject)(l)||!(0,zat.isPlainObject)(c))}});var Yat=xt(EL=>{"use strict";Object.defineProperty(EL,"__esModule",{value:!0});EL.callWithTimeout=EL.TimeoutError=void 0;var xie=class l extends Error{constructor(c){super(c),Object.setPrototypeOf(this,l.prototype)}};EL.TimeoutError=xie;function rnr(l,c){let f,y=new Promise(function(A,g){f=setTimeout(function(){g(new xie("Operation timed out."))},c)});return Promise.race([l,y]).then(b=>(clearTimeout(f),b),b=>{throw clearTimeout(f),b})}EL.callWithTimeout=rnr});var Xat=xt(xL=>{"use strict";Object.defineProperty(xL,"__esModule",{value:!0});xL.isUrlIgnored=xL.urlMatches=void 0;function Kat(l,c){return typeof c=="string"?l===c:!!l.match(c)}xL.urlMatches=Kat;function nnr(l,c){if(!c)return!1;for(let f of c)if(Kat(l,f))return!0;return!1}xL.isUrlIgnored=nnr});var Qat=xt(Cie=>{"use strict";Object.defineProperty(Cie,"__esModule",{value:!0});Cie.isWrapped=void 0;function inr(l){return typeof l=="function"&&typeof l.__original=="function"&&typeof l.__unwrap=="function"&&l.__wrapped===!0}Cie.isWrapped=inr});var Zat=xt(Aie=>{"use strict";Object.defineProperty(Aie,"__esModule",{value:!0});Aie.Deferred=void 0;var Bke=class{constructor(){this._promise=new Promise((c,f)=>{this._resolve=c,this._reject=f})}get promise(){return this._promise}resolve(c){this._resolve(c)}reject(c){this._reject(c)}};Aie.Deferred=Bke});var eot=xt(kie=>{"use strict";Object.defineProperty(kie,"__esModule",{value:!0});kie.BindOnceFuture=void 0;var snr=Zat(),Uke=class{constructor(c,f){this._callback=c,this._that=f,this._isCalled=!1,this._deferred=new snr.Deferred}get isCalled(){return this._isCalled}get promise(){return this._deferred.promise}call(...c){if(!this._isCalled){this._isCalled=!0;try{Promise.resolve(this._callback.call(this._that,...c)).then(f=>this._deferred.resolve(f),f=>this._deferred.reject(f))}catch(f){this._deferred.reject(f)}}return this._deferred.promise}};kie.BindOnceFuture=Uke});var rot=xt(Pie=>{"use strict";Object.defineProperty(Pie,"__esModule",{value:!0});Pie._export=void 0;var tot=(zc(),fc(Xc)),anr=Wq();function onr(l,c){return new Promise(f=>{tot.context.with((0,anr.suppressTracing)(tot.context.active()),()=>{l.export(c,y=>{f(y)})})})}Pie._export=onr});var py=xt(di=>{"use strict";Object.defineProperty(di,"__esModule",{value:!0});di.DEFAULT_ATTRIBUTE_VALUE_LENGTH_LIMIT=di.DEFAULT_ATTRIBUTE_COUNT_LIMIT=di.TraceState=di.unsuppressTracing=di.suppressTracing=di.isTracingSuppressed=di.TraceIdRatioBasedSampler=di.ParentBasedSampler=di.AlwaysOnSampler=di.AlwaysOffSampler=di.setRPCMetadata=di.getRPCMetadata=di.deleteRPCMetadata=di.RPCType=di.parseTraceParent=di.W3CTraceContextPropagator=di.TRACE_STATE_HEADER=di.TRACE_PARENT_HEADER=di.CompositePropagator=di.unrefTimer=di.otperformance=di.hexToBase64=di.getEnvWithoutDefaults=di.getEnv=di._globalThis=di.SDK_INFO=di.RandomIdGenerator=di.baggageUtils=di.ExportResultCode=di.hexToBinary=di.timeInputToHrTime=di.millisToHrTime=di.isTimeInputHrTime=di.isTimeInput=di.hrTimeToTimeStamp=di.hrTimeToNanoseconds=di.hrTimeToMilliseconds=di.hrTimeToMicroseconds=di.hrTimeDuration=di.hrTime=di.getTimeOrigin=di.addHrTimes=di.loggingErrorHandler=di.setGlobalErrorHandler=di.globalErrorHandler=di.sanitizeAttributes=di.isAttributeValue=di.isAttributeKey=di.AnchoredClock=di.W3CBaggagePropagator=void 0;di.internal=di.VERSION=di.BindOnceFuture=di.isWrapped=di.urlMatches=di.isUrlIgnored=di.callWithTimeout=di.TimeoutError=di.TracesSamplerValues=di.merge=di.parseEnvironment=di.DEFAULT_SPAN_ATTRIBUTE_PER_LINK_COUNT_LIMIT=di.DEFAULT_SPAN_ATTRIBUTE_PER_EVENT_COUNT_LIMIT=di.DEFAULT_ENVIRONMENT=void 0;var cnr=RQe();Object.defineProperty(di,"W3CBaggagePropagator",{enumerable:!0,get:function(){return cnr.W3CBaggagePropagator}});var lnr=MQe();Object.defineProperty(di,"AnchoredClock",{enumerable:!0,get:function(){return lnr.AnchoredClock}});var Vke=UQe();Object.defineProperty(di,"isAttributeKey",{enumerable:!0,get:function(){return Vke.isAttributeKey}});Object.defineProperty(di,"isAttributeValue",{enumerable:!0,get:function(){return Vke.isAttributeValue}});Object.defineProperty(di,"sanitizeAttributes",{enumerable:!0,get:function(){return Vke.sanitizeAttributes}});var not=_ke();Object.defineProperty(di,"globalErrorHandler",{enumerable:!0,get:function(){return not.globalErrorHandler}});Object.defineProperty(di,"setGlobalErrorHandler",{enumerable:!0,get:function(){return not.setGlobalErrorHandler}});var unr=uke();Object.defineProperty(di,"loggingErrorHandler",{enumerable:!0,get:function(){return unr.loggingErrorHandler}});var kT=xat();Object.defineProperty(di,"addHrTimes",{enumerable:!0,get:function(){return kT.addHrTimes}});Object.defineProperty(di,"getTimeOrigin",{enumerable:!0,get:function(){return kT.getTimeOrigin}});Object.defineProperty(di,"hrTime",{enumerable:!0,get:function(){return kT.hrTime}});Object.defineProperty(di,"hrTimeDuration",{enumerable:!0,get:function(){return kT.hrTimeDuration}});Object.defineProperty(di,"hrTimeToMicroseconds",{enumerable:!0,get:function(){return kT.hrTimeToMicroseconds}});Object.defineProperty(di,"hrTimeToMilliseconds",{enumerable:!0,get:function(){return kT.hrTimeToMilliseconds}});Object.defineProperty(di,"hrTimeToNanoseconds",{enumerable:!0,get:function(){return kT.hrTimeToNanoseconds}});Object.defineProperty(di,"hrTimeToTimeStamp",{enumerable:!0,get:function(){return kT.hrTimeToTimeStamp}});Object.defineProperty(di,"isTimeInput",{enumerable:!0,get:function(){return kT.isTimeInput}});Object.defineProperty(di,"isTimeInputHrTime",{enumerable:!0,get:function(){return kT.isTimeInputHrTime}});Object.defineProperty(di,"millisToHrTime",{enumerable:!0,get:function(){return kT.millisToHrTime}});Object.defineProperty(di,"timeInputToHrTime",{enumerable:!0,get:function(){return kT.timeInputToHrTime}});var _nr=mke();Object.defineProperty(di,"hexToBinary",{enumerable:!0,get:function(){return _nr.hexToBinary}});var fnr=Cat();Object.defineProperty(di,"ExportResultCode",{enumerable:!0,get:function(){return fnr.ExportResultCode}});var Nie=ske();di.baggageUtils={getKeyPairs:Nie.getKeyPairs,serializeKeyPairs:Nie.serializeKeyPairs,parseKeyPairsIntoRecord:Nie.parseKeyPairsIntoRecord,parsePairKeyValue:Nie.parsePairKeyValue};var dw=Ske();Object.defineProperty(di,"RandomIdGenerator",{enumerable:!0,get:function(){return dw.RandomIdGenerator}});Object.defineProperty(di,"SDK_INFO",{enumerable:!0,get:function(){return dw.SDK_INFO}});Object.defineProperty(di,"_globalThis",{enumerable:!0,get:function(){return dw._globalThis}});Object.defineProperty(di,"getEnv",{enumerable:!0,get:function(){return dw.getEnv}});Object.defineProperty(di,"getEnvWithoutDefaults",{enumerable:!0,get:function(){return dw.getEnvWithoutDefaults}});Object.defineProperty(di,"hexToBase64",{enumerable:!0,get:function(){return dw.hexToBase64}});Object.defineProperty(di,"otperformance",{enumerable:!0,get:function(){return dw.otperformance}});Object.defineProperty(di,"unrefTimer",{enumerable:!0,get:function(){return dw.unrefTimer}});var pnr=kat();Object.defineProperty(di,"CompositePropagator",{enumerable:!0,get:function(){return pnr.CompositePropagator}});var Die=Rat();Object.defineProperty(di,"TRACE_PARENT_HEADER",{enumerable:!0,get:function(){return Die.TRACE_PARENT_HEADER}});Object.defineProperty(di,"TRACE_STATE_HEADER",{enumerable:!0,get:function(){return Die.TRACE_STATE_HEADER}});Object.defineProperty(di,"W3CTraceContextPropagator",{enumerable:!0,get:function(){return Die.W3CTraceContextPropagator}});Object.defineProperty(di,"parseTraceParent",{enumerable:!0,get:function(){return Die.parseTraceParent}});var wie=Mat();Object.defineProperty(di,"RPCType",{enumerable:!0,get:function(){return wie.RPCType}});Object.defineProperty(di,"deleteRPCMetadata",{enumerable:!0,get:function(){return wie.deleteRPCMetadata}});Object.defineProperty(di,"getRPCMetadata",{enumerable:!0,get:function(){return wie.getRPCMetadata}});Object.defineProperty(di,"setRPCMetadata",{enumerable:!0,get:function(){return wie.setRPCMetadata}});var dnr=wke();Object.defineProperty(di,"AlwaysOffSampler",{enumerable:!0,get:function(){return dnr.AlwaysOffSampler}});var mnr=Oke();Object.defineProperty(di,"AlwaysOnSampler",{enumerable:!0,get:function(){return mnr.AlwaysOnSampler}});var gnr=Fat();Object.defineProperty(di,"ParentBasedSampler",{enumerable:!0,get:function(){return gnr.ParentBasedSampler}});var hnr=jat();Object.defineProperty(di,"TraceIdRatioBasedSampler",{enumerable:!0,get:function(){return hnr.TraceIdRatioBasedSampler}});var Jke=Wq();Object.defineProperty(di,"isTracingSuppressed",{enumerable:!0,get:function(){return Jke.isTracingSuppressed}});Object.defineProperty(di,"suppressTracing",{enumerable:!0,get:function(){return Jke.suppressTracing}});Object.defineProperty(di,"unsuppressTracing",{enumerable:!0,get:function(){return Jke.unsuppressTracing}});var ynr=kke();Object.defineProperty(di,"TraceState",{enumerable:!0,get:function(){return ynr.TraceState}});var CL=pke();Object.defineProperty(di,"DEFAULT_ATTRIBUTE_COUNT_LIMIT",{enumerable:!0,get:function(){return CL.DEFAULT_ATTRIBUTE_COUNT_LIMIT}});Object.defineProperty(di,"DEFAULT_ATTRIBUTE_VALUE_LENGTH_LIMIT",{enumerable:!0,get:function(){return CL.DEFAULT_ATTRIBUTE_VALUE_LENGTH_LIMIT}});Object.defineProperty(di,"DEFAULT_ENVIRONMENT",{enumerable:!0,get:function(){return CL.DEFAULT_ENVIRONMENT}});Object.defineProperty(di,"DEFAULT_SPAN_ATTRIBUTE_PER_EVENT_COUNT_LIMIT",{enumerable:!0,get:function(){return CL.DEFAULT_SPAN_ATTRIBUTE_PER_EVENT_COUNT_LIMIT}});Object.defineProperty(di,"DEFAULT_SPAN_ATTRIBUTE_PER_LINK_COUNT_LIMIT",{enumerable:!0,get:function(){return CL.DEFAULT_SPAN_ATTRIBUTE_PER_LINK_COUNT_LIMIT}});Object.defineProperty(di,"parseEnvironment",{enumerable:!0,get:function(){return CL.parseEnvironment}});var vnr=Gat();Object.defineProperty(di,"merge",{enumerable:!0,get:function(){return vnr.merge}});var Snr=fke();Object.defineProperty(di,"TracesSamplerValues",{enumerable:!0,get:function(){return Snr.TracesSamplerValues}});var iot=Yat();Object.defineProperty(di,"TimeoutError",{enumerable:!0,get:function(){return iot.TimeoutError}});Object.defineProperty(di,"callWithTimeout",{enumerable:!0,get:function(){return iot.callWithTimeout}});var sot=Xat();Object.defineProperty(di,"isUrlIgnored",{enumerable:!0,get:function(){return sot.isUrlIgnored}});Object.defineProperty(di,"urlMatches",{enumerable:!0,get:function(){return sot.urlMatches}});var bnr=Qat();Object.defineProperty(di,"isWrapped",{enumerable:!0,get:function(){return bnr.isWrapped}});var Tnr=eot();Object.defineProperty(di,"BindOnceFuture",{enumerable:!0,get:function(){return Tnr.BindOnceFuture}});var Enr=hke();Object.defineProperty(di,"VERSION",{enumerable:!0,get:function(){return Enr.VERSION}});var xnr=rot();di.internal={_export:xnr._export}});var Iie=xt(Xq=>{"use strict";Object.defineProperty(Xq,"__esModule",{value:!0});Xq.AggregationTemporality=void 0;var Cnr;(function(l){l[l.DELTA=0]="DELTA",l[l.CUMULATIVE=1]="CUMULATIVE"})(Cnr=Xq.AggregationTemporality||(Xq.AggregationTemporality={}))});var AL=xt(Qq=>{"use strict";Object.defineProperty(Qq,"__esModule",{value:!0});Qq.DataPointType=void 0;var Anr;(function(l){l[l.HISTOGRAM=0]="HISTOGRAM",l[l.EXPONENTIAL_HISTOGRAM=1]="EXPONENTIAL_HISTOGRAM",l[l.GAUGE=2]="GAUGE",l[l.SUM=3]="SUM"})(Anr=Qq.DataPointType||(Qq.DataPointType={}))});var yC=xt(Fp=>{"use strict";Object.defineProperty(Fp,"__esModule",{value:!0});Fp.equalsCaseInsensitive=Fp.binarySearchUB=Fp.setEquals=Fp.FlatMap=Fp.isPromiseAllSettledRejectionResult=Fp.PromiseAllSettled=Fp.callWithTimeout=Fp.TimeoutError=Fp.instrumentationScopeId=Fp.hashAttributes=Fp.isNotNullish=void 0;function knr(l){return l!=null}Fp.isNotNullish=knr;function Pnr(l){let c=Object.keys(l);return c.length===0?"":(c=c.sort(),JSON.stringify(c.map(f=>[f,l[f]])))}Fp.hashAttributes=Pnr;function Nnr(l){var c,f;return`${l.name}:${(c=l.version)!==null&&c!==void 0?c:""}:${(f=l.schemaUrl)!==null&&f!==void 0?f:""}`}Fp.instrumentationScopeId=Nnr;var Oie=class l extends Error{constructor(c){super(c),Object.setPrototypeOf(this,l.prototype)}};Fp.TimeoutError=Oie;function Dnr(l,c){let f,y=new Promise(function(A,g){f=setTimeout(function(){g(new Oie("Operation timed out."))},c)});return Promise.race([l,y]).then(b=>(clearTimeout(f),b),b=>{throw clearTimeout(f),b})}Fp.callWithTimeout=Dnr;async function wnr(l){return Promise.all(l.map(async c=>{try{return{status:"fulfilled",value:await c}}catch(f){return{status:"rejected",reason:f}}}))}Fp.PromiseAllSettled=wnr;function Inr(l){return l.status==="rejected"}Fp.isPromiseAllSettledRejectionResult=Inr;function Onr(l,c){let f=[];return l.forEach(y=>{f.push(...c(y))}),f}Fp.FlatMap=Onr;function Rnr(l,c){if(l.size!==c.size)return!1;for(let f of l)if(!c.has(f))return!1;return!0}Fp.setEquals=Rnr;function Mnr(l,c){let f=0,y=l.length-1,b=l.length;for(;y>=f;){let A=f+Math.trunc((y-f)/2);l[A]<c?f=A+1:(b=A,y=A-1)}return b}Fp.binarySearchUB=Mnr;function Lnr(l,c){return l.toLowerCase()===c.toLowerCase()}Fp.equalsCaseInsensitive=Lnr});var kL=xt(Zq=>{"use strict";Object.defineProperty(Zq,"__esModule",{value:!0});Zq.AggregatorKind=void 0;var Fnr;(function(l){l[l.DROP=0]="DROP",l[l.SUM=1]="SUM",l[l.LAST_VALUE=2]="LAST_VALUE",l[l.HISTOGRAM=3]="HISTOGRAM",l[l.EXPONENTIAL_HISTOGRAM=4]="EXPONENTIAL_HISTOGRAM"})(Fnr=Zq.AggregatorKind||(Zq.AggregatorKind={}))});var aot=xt(Rie=>{"use strict";Object.defineProperty(Rie,"__esModule",{value:!0});Rie.DropAggregator=void 0;var jnr=kL(),qke=class{constructor(){this.kind=jnr.AggregatorKind.DROP}createAccumulation(){}merge(c,f){}diff(c,f){}toMetricData(c,f,y,b){}};Rie.DropAggregator=qke});var oP=xt(WS=>{"use strict";Object.defineProperty(WS,"__esModule",{value:!0});WS.isValidName=WS.isDescriptorCompatibleWith=WS.createInstrumentDescriptorWithView=WS.createInstrumentDescriptor=WS.InstrumentType=void 0;var oot=(zc(),fc(Xc)),Bnr=yC(),Unr;(function(l){l.COUNTER="COUNTER",l.GAUGE="GAUGE",l.HISTOGRAM="HISTOGRAM",l.UP_DOWN_COUNTER="UP_DOWN_COUNTER",l.OBSERVABLE_COUNTER="OBSERVABLE_COUNTER",l.OBSERVABLE_GAUGE="OBSERVABLE_GAUGE",l.OBSERVABLE_UP_DOWN_COUNTER="OBSERVABLE_UP_DOWN_COUNTER"})(Unr=WS.InstrumentType||(WS.InstrumentType={}));function Vnr(l,c,f){var y,b,A,g;return cot(l)||oot.diag.warn(`Invalid metric name: "${l}". The metric name should be a ASCII string with a length no greater than 255 characters.`),{name:l,type:c,description:(y=f?.description)!==null&&y!==void 0?y:"",unit:(b=f?.unit)!==null&&b!==void 0?b:"",valueType:(A=f?.valueType)!==null&&A!==void 0?A:oot.ValueType.DOUBLE,advice:(g=f?.advice)!==null&&g!==void 0?g:{}}}WS.createInstrumentDescriptor=Vnr;function Jnr(l,c){var f,y;return{name:(f=l.name)!==null&&f!==void 0?f:c.name,description:(y=l.description)!==null&&y!==void 0?y:c.description,type:c.type,unit:c.unit,valueType:c.valueType,advice:c.advice}}WS.createInstrumentDescriptorWithView=Jnr;function qnr(l,c){return(0,Bnr.equalsCaseInsensitive)(l.name,c.name)&&l.unit===c.unit&&l.type===c.type&&l.valueType===c.valueType}WS.isDescriptorCompatibleWith=qnr;var znr=/^[a-z][a-z0-9_.\-/]{0,254}$/i;function cot(l){return l.match(znr)!=null}WS.isValidName=cot});var lot=xt(NL=>{"use strict";Object.defineProperty(NL,"__esModule",{value:!0});NL.HistogramAggregator=NL.HistogramAccumulation=void 0;var Wnr=kL(),$nr=AL(),Mie=oP(),Hnr=yC();function Gnr(l){let c=l.map(()=>0);return c.push(0),{buckets:{boundaries:l,counts:c},sum:0,count:0,hasMinMax:!1,min:1/0,max:-1/0}}var PL=class{constructor(c,f,y=!0,b=Gnr(f)){this.startTime=c,this._boundaries=f,this._recordMinMax=y,this._current=b}record(c){if(Number.isNaN(c))return;this._current.count+=1,this._current.sum+=c,this._recordMinMax&&(this._current.min=Math.min(c,this._current.min),this._current.max=Math.max(c,this._current.max),this._current.hasMinMax=!0);let f=(0,Hnr.binarySearchUB)(this._boundaries,c);this._current.buckets.counts[f]+=1}setStartTime(c){this.startTime=c}toPointValue(){return this._current}};NL.HistogramAccumulation=PL;var zke=class{constructor(c,f){this._boundaries=c,this._recordMinMax=f,this.kind=Wnr.AggregatorKind.HISTOGRAM}createAccumulation(c){return new PL(c,this._boundaries,this._recordMinMax)}merge(c,f){let y=c.toPointValue(),b=f.toPointValue(),A=y.buckets.counts,g=b.buckets.counts,p=new Array(A.length);for(let se=0;se<A.length;se++)p[se]=A[se]+g[se];let k=1/0,j=-1/0;return this._recordMinMax&&(y.hasMinMax&&b.hasMinMax?(k=Math.min(y.min,b.min),j=Math.max(y.max,b.max)):y.hasMinMax?(k=y.min,j=y.max):b.hasMinMax&&(k=b.min,j=b.max)),new PL(c.startTime,y.buckets.boundaries,this._recordMinMax,{buckets:{boundaries:y.buckets.boundaries,counts:p},count:y.count+b.count,sum:y.sum+b.sum,hasMinMax:this._recordMinMax&&(y.hasMinMax||b.hasMinMax),min:k,max:j})}diff(c,f){let y=c.toPointValue(),b=f.toPointValue(),A=y.buckets.counts,g=b.buckets.counts,p=new Array(A.length);for(let k=0;k<A.length;k++)p[k]=g[k]-A[k];return new PL(f.startTime,y.buckets.boundaries,this._recordMinMax,{buckets:{boundaries:y.buckets.boundaries,counts:p},count:b.count-y.count,sum:b.sum-y.sum,hasMinMax:!1,min:1/0,max:-1/0})}toMetricData(c,f,y,b){return{descriptor:c,aggregationTemporality:f,dataPointType:$nr.DataPointType.HISTOGRAM,dataPoints:y.map(([A,g])=>{let p=g.toPointValue(),k=c.type===Mie.InstrumentType.GAUGE||c.type===Mie.InstrumentType.UP_DOWN_COUNTER||c.type===Mie.InstrumentType.OBSERVABLE_GAUGE||c.type===Mie.InstrumentType.OBSERVABLE_UP_DOWN_COUNTER;return{attributes:A,startTime:g.startTime,endTime:b,value:{min:p.hasMinMax?p.min:void 0,max:p.hasMinMax?p.max:void 0,sum:k?void 0:p.sum,buckets:p.buckets,count:p.count}}})}}};NL.HistogramAggregator=zke});var uot=xt(Lie=>{"use strict";Object.defineProperty(Lie,"__esModule",{value:!0});Lie.Buckets=void 0;var Wke=class l{constructor(c=new $ke,f=0,y=0,b=0){this.backing=c,this.indexBase=f,this.indexStart=y,this.indexEnd=b}get offset(){return this.indexStart}get length(){return this.backing.length===0||this.indexEnd===this.indexStart&&this.at(0)===0?0:this.indexEnd-this.indexStart+1}counts(){return Array.from({length:this.length},(c,f)=>this.at(f))}at(c){let f=this.indexBase-this.indexStart;return c<f&&(c+=this.backing.length),c-=f,this.backing.countAt(c)}incrementBucket(c,f){this.backing.increment(c,f)}decrementBucket(c,f){this.backing.decrement(c,f)}trim(){for(let c=0;c<this.length;c++)if(this.at(c)!==0){this.indexStart+=c;break}else if(c===this.length-1){this.indexStart=this.indexEnd=this.indexBase=0;return}for(let c=this.length-1;c>=0;c--)if(this.at(c)!==0){this.indexEnd-=this.length-c-1;break}this._rotate()}downscale(c){this._rotate();let f=1+this.indexEnd-this.indexStart,y=1<<c,b=0,A=0;for(let g=this.indexStart;g<=this.indexEnd;){let p=g%y;p<0&&(p+=y);for(let k=p;k<y&&b<f;k++)this._relocateBucket(A,b),b++,g++;A++}this.indexStart>>=c,this.indexEnd>>=c,this.indexBase=this.indexStart}clone(){return new l(this.backing.clone(),this.indexBase,this.indexStart,this.indexEnd)}_rotate(){let c=this.indexBase-this.indexStart;c!==0&&(c>0?(this.backing.reverse(0,this.backing.length),this.backing.reverse(0,c),this.backing.reverse(c,this.backing.length)):(this.backing.reverse(0,this.backing.length),this.backing.reverse(0,this.backing.length+c)),this.indexBase=this.indexStart)}_relocateBucket(c,f){c!==f&&this.incrementBucket(c,this.backing.emptyBucket(f))}};Lie.Buckets=Wke;var $ke=class l{constructor(c=[0]){this._counts=c}get length(){return this._counts.length}countAt(c){return this._counts[c]}growTo(c,f,y){let b=new Array(c).fill(0);b.splice(y,this._counts.length-f,...this._counts.slice(f)),b.splice(0,f,...this._counts.slice(0,f)),this._counts=b}reverse(c,f){let y=Math.floor((c+f)/2)-c;for(let b=0;b<y;b++){let A=this._counts[c+b];this._counts[c+b]=this._counts[f-b-1],this._counts[f-b-1]=A}}emptyBucket(c){let f=this._counts[c];return this._counts[c]=0,f}increment(c,f){this._counts[c]+=f}decrement(c,f){this._counts[c]>=f?this._counts[c]-=f:this._counts[c]=0}clone(){return new l([...this._counts])}}});var Gke=xt(S1=>{"use strict";Object.defineProperty(S1,"__esModule",{value:!0});S1.getSignificand=S1.getNormalBase2=S1.MIN_VALUE=S1.MAX_NORMAL_EXPONENT=S1.MIN_NORMAL_EXPONENT=S1.SIGNIFICAND_WIDTH=void 0;S1.SIGNIFICAND_WIDTH=52;var Ynr=2146435072,Knr=1048575,Hke=1023;S1.MIN_NORMAL_EXPONENT=-Hke+1;S1.MAX_NORMAL_EXPONENT=Hke;S1.MIN_VALUE=Math.pow(2,-1022);function Xnr(l){let c=new DataView(new ArrayBuffer(8));return c.setFloat64(0,l),((c.getUint32(0)&Ynr)>>20)-Hke}S1.getNormalBase2=Xnr;function Qnr(l){let c=new DataView(new ArrayBuffer(8));c.setFloat64(0,l);let f=c.getUint32(0),y=c.getUint32(4);return(f&Knr)*Math.pow(2,32)+y}S1.getSignificand=Qnr});var Fie=xt(DL=>{"use strict";Object.defineProperty(DL,"__esModule",{value:!0});DL.nextGreaterSquare=DL.ldexp=void 0;function Znr(l,c){return l===0||l===Number.POSITIVE_INFINITY||l===Number.NEGATIVE_INFINITY||Number.isNaN(l)?l:l*Math.pow(2,c)}DL.ldexp=Znr;function eir(l){return l--,l|=l>>1,l|=l>>2,l|=l>>4,l|=l>>8,l|=l>>16,l++,l}DL.nextGreaterSquare=eir});var Bie=xt(jie=>{"use strict";Object.defineProperty(jie,"__esModule",{value:!0});jie.MappingError=void 0;var Yke=class extends Error{};jie.MappingError=Yke});var fot=xt(Uie=>{"use strict";Object.defineProperty(Uie,"__esModule",{value:!0});Uie.ExponentMapping=void 0;var wL=Gke(),tir=Fie(),_ot=Bie(),Kke=class{constructor(c){this._shift=-c}mapToIndex(c){if(c<wL.MIN_VALUE)return this._minNormalLowerBoundaryIndex();let f=wL.getNormalBase2(c),y=this._rightShift(wL.getSignificand(c)-1,wL.SIGNIFICAND_WIDTH);return f+y>>this._shift}lowerBoundary(c){let f=this._minNormalLowerBoundaryIndex();if(c<f)throw new _ot.MappingError(`underflow: ${c} is < minimum lower boundary: ${f}`);let y=this._maxNormalLowerBoundaryIndex();if(c>y)throw new _ot.MappingError(`overflow: ${c} is > maximum lower boundary: ${y}`);return tir.ldexp(1,c<<this._shift)}get scale(){return this._shift===0?0:-this._shift}_minNormalLowerBoundaryIndex(){let c=wL.MIN_NORMAL_EXPONENT>>this._shift;return this._shift<2&&c--,c}_maxNormalLowerBoundaryIndex(){return wL.MAX_NORMAL_EXPONENT>>this._shift}_rightShift(c,f){return Math.floor(c*Math.pow(2,-f))}};Uie.ExponentMapping=Kke});var mot=xt(Vie=>{"use strict";Object.defineProperty(Vie,"__esModule",{value:!0});Vie.LogarithmMapping=void 0;var IL=Gke(),pot=Fie(),dot=Bie(),Xke=class{constructor(c){this._scale=c,this._scaleFactor=pot.ldexp(Math.LOG2E,c),this._inverseFactor=pot.ldexp(Math.LN2,-c)}mapToIndex(c){if(c<=IL.MIN_VALUE)return this._minNormalLowerBoundaryIndex()-1;if(IL.getSignificand(c)===0)return(IL.getNormalBase2(c)<<this._scale)-1;let f=Math.floor(Math.log(c)*this._scaleFactor),y=this._maxNormalLowerBoundaryIndex();return f>=y?y:f}lowerBoundary(c){let f=this._maxNormalLowerBoundaryIndex();if(c>=f){if(c===f)return 2*Math.exp((c-(1<<this._scale))/this._scaleFactor);throw new dot.MappingError(`overflow: ${c} is > maximum lower boundary: ${f}`)}let y=this._minNormalLowerBoundaryIndex();if(c<=y){if(c===y)return IL.MIN_VALUE;if(c===y-1)return Math.exp((c+(1<<this._scale))/this._scaleFactor)/2;throw new dot.MappingError(`overflow: ${c} is < minimum lower boundary: ${y}`)}return Math.exp(c*this._inverseFactor)}get scale(){return this._scale}_minNormalLowerBoundaryIndex(){return IL.MIN_NORMAL_EXPONENT<<this._scale}_maxNormalLowerBoundaryIndex(){return(IL.MAX_NORMAL_EXPONENT+1<<this._scale)-1}};Vie.LogarithmMapping=Xke});var yot=xt(Jie=>{"use strict";Object.defineProperty(Jie,"__esModule",{value:!0});Jie.getMapping=void 0;var rir=fot(),nir=mot(),iir=Bie(),got=-10,hot=20,sir=Array.from({length:31},(l,c)=>c>10?new nir.LogarithmMapping(c-10):new rir.ExponentMapping(c-10));function air(l){if(l>hot||l<got)throw new iir.MappingError(`expected scale >= ${got} && <= ${hot}, got: ${l}`);return sir[l+10]}Jie.getMapping=air});var bot=xt(RL=>{"use strict";Object.defineProperty(RL,"__esModule",{value:!0});RL.ExponentialHistogramAggregator=RL.ExponentialHistogramAccumulation=void 0;var oir=kL(),cir=AL(),lir=(zc(),fc(Xc)),qie=oP(),vot=uot(),Sot=yot(),uir=Fie(),OL=class l{constructor(c,f){this.low=c,this.high=f}static combine(c,f){return new l(Math.min(c.low,f.low),Math.max(c.high,f.high))}},_ir=20,fir=160,Qke=2,zie=class l{constructor(c=c,f=fir,y=!0,b=0,A=0,g=0,p=Number.POSITIVE_INFINITY,k=Number.NEGATIVE_INFINITY,j=new vot.Buckets,se=new vot.Buckets,ze=(0,Sot.getMapping)(_ir)){this.startTime=c,this._maxSize=f,this._recordMinMax=y,this._sum=b,this._count=A,this._zeroCount=g,this._min=p,this._max=k,this._positive=j,this._negative=se,this._mapping=ze,this._maxSize<Qke&&(lir.diag.warn(`Exponential Histogram Max Size set to ${this._maxSize},                 changing to the minimum size of: ${Qke}`),this._maxSize=Qke)}record(c){this.updateByIncrement(c,1)}setStartTime(c){this.startTime=c}toPointValue(){return{hasMinMax:this._recordMinMax,min:this.min,max:this.max,sum:this.sum,positive:{offset:this.positive.offset,bucketCounts:this.positive.counts()},negative:{offset:this.negative.offset,bucketCounts:this.negative.counts()},count:this.count,scale:this.scale,zeroCount:this.zeroCount}}get sum(){return this._sum}get min(){return this._min}get max(){return this._max}get count(){return this._count}get zeroCount(){return this._zeroCount}get scale(){return this._count===this._zeroCount?0:this._mapping.scale}get positive(){return this._positive}get negative(){return this._negative}updateByIncrement(c,f){if(!Number.isNaN(c)){if(c>this._max&&(this._max=c),c<this._min&&(this._min=c),this._count+=f,c===0){this._zeroCount+=f;return}this._sum+=c*f,c>0?this._updateBuckets(this._positive,c,f):this._updateBuckets(this._negative,-c,f)}}merge(c){this._count===0?(this._min=c.min,this._max=c.max):c.count!==0&&(c.min<this.min&&(this._min=c.min),c.max>this.max&&(this._max=c.max)),this.startTime=c.startTime,this._sum+=c.sum,this._count+=c.count,this._zeroCount+=c.zeroCount;let f=this._minScale(c);this._downscale(this.scale-f),this._mergeBuckets(this.positive,c,c.positive,f),this._mergeBuckets(this.negative,c,c.negative,f)}diff(c){this._min=1/0,this._max=-1/0,this._sum-=c.sum,this._count-=c.count,this._zeroCount-=c.zeroCount;let f=this._minScale(c);this._downscale(this.scale-f),this._diffBuckets(this.positive,c,c.positive,f),this._diffBuckets(this.negative,c,c.negative,f)}clone(){return new l(this.startTime,this._maxSize,this._recordMinMax,this._sum,this._count,this._zeroCount,this._min,this._max,this.positive.clone(),this.negative.clone(),this._mapping)}_updateBuckets(c,f,y){let b=this._mapping.mapToIndex(f),A=!1,g=0,p=0;if(c.length===0?(c.indexStart=b,c.indexEnd=c.indexStart,c.indexBase=c.indexStart):b<c.indexStart&&c.indexEnd-b>=this._maxSize?(A=!0,p=b,g=c.indexEnd):b>c.indexEnd&&b-c.indexStart>=this._maxSize&&(A=!0,p=c.indexStart,g=b),A){let k=this._changeScale(g,p);this._downscale(k),b=this._mapping.mapToIndex(f)}this._incrementIndexBy(c,b,y)}_incrementIndexBy(c,f,y){if(y===0)return;if(c.length===0&&(c.indexStart=c.indexEnd=c.indexBase=f),f<c.indexStart){let A=c.indexEnd-f;A>=c.backing.length&&this._grow(c,A+1),c.indexStart=f}else if(f>c.indexEnd){let A=f-c.indexStart;A>=c.backing.length&&this._grow(c,A+1),c.indexEnd=f}let b=f-c.indexBase;b<0&&(b+=c.backing.length),c.incrementBucket(b,y)}_grow(c,f){let y=c.backing.length,b=c.indexBase-c.indexStart,A=y-b,g=(0,uir.nextGreaterSquare)(f);g>this._maxSize&&(g=this._maxSize);let p=g-b;c.backing.growTo(g,A,p)}_changeScale(c,f){let y=0;for(;c-f>=this._maxSize;)c>>=1,f>>=1,y++;return y}_downscale(c){if(c===0)return;if(c<0)throw new Error(`impossible change of scale: ${this.scale}`);let f=this._mapping.scale-c;this._positive.downscale(c),this._negative.downscale(c),this._mapping=(0,Sot.getMapping)(f)}_minScale(c){let f=Math.min(this.scale,c.scale),y=OL.combine(this._highLowAtScale(this.positive,this.scale,f),this._highLowAtScale(c.positive,c.scale,f)),b=OL.combine(this._highLowAtScale(this.negative,this.scale,f),this._highLowAtScale(c.negative,c.scale,f));return Math.min(f-this._changeScale(y.high,y.low),f-this._changeScale(b.high,b.low))}_highLowAtScale(c,f,y){if(c.length===0)return new OL(0,-1);let b=f-y;return new OL(c.indexStart>>b,c.indexEnd>>b)}_mergeBuckets(c,f,y,b){let A=y.offset,g=f.scale-b;for(let p=0;p<y.length;p++)this._incrementIndexBy(c,A+p>>g,y.at(p))}_diffBuckets(c,f,y,b){let A=y.offset,g=f.scale-b;for(let p=0;p<y.length;p++){let j=(A+p>>g)-c.indexBase;j<0&&(j+=c.backing.length),c.decrementBucket(j,y.at(p))}c.trim()}};RL.ExponentialHistogramAccumulation=zie;var Zke=class{constructor(c,f){this._maxSize=c,this._recordMinMax=f,this.kind=oir.AggregatorKind.EXPONENTIAL_HISTOGRAM}createAccumulation(c){return new zie(c,this._maxSize,this._recordMinMax)}merge(c,f){let y=f.clone();return y.merge(c),y}diff(c,f){let y=f.clone();return y.diff(c),y}toMetricData(c,f,y,b){return{descriptor:c,aggregationTemporality:f,dataPointType:cir.DataPointType.EXPONENTIAL_HISTOGRAM,dataPoints:y.map(([A,g])=>{let p=g.toPointValue(),k=c.type===qie.InstrumentType.GAUGE||c.type===qie.InstrumentType.UP_DOWN_COUNTER||c.type===qie.InstrumentType.OBSERVABLE_GAUGE||c.type===qie.InstrumentType.OBSERVABLE_UP_DOWN_COUNTER;return{attributes:A,startTime:g.startTime,endTime:b,value:{min:p.hasMinMax?p.min:void 0,max:p.hasMinMax?p.max:void 0,sum:k?void 0:p.sum,positive:{offset:p.positive.offset,bucketCounts:p.positive.bucketCounts},negative:{offset:p.negative.offset,bucketCounts:p.negative.bucketCounts},count:p.count,scale:p.scale,zeroCount:p.zeroCount}}})}}};RL.ExponentialHistogramAggregator=Zke});var Tot=xt(LL=>{"use strict";Object.defineProperty(LL,"__esModule",{value:!0});LL.LastValueAggregator=LL.LastValueAccumulation=void 0;var pir=kL(),ez=py(),dir=AL(),ML=class{constructor(c,f=0,y=[0,0]){this.startTime=c,this._current=f,this.sampleTime=y}record(c){this._current=c,this.sampleTime=(0,ez.millisToHrTime)(Date.now())}setStartTime(c){this.startTime=c}toPointValue(){return this._current}};LL.LastValueAccumulation=ML;var ePe=class{constructor(){this.kind=pir.AggregatorKind.LAST_VALUE}createAccumulation(c){return new ML(c)}merge(c,f){let y=(0,ez.hrTimeToMicroseconds)(f.sampleTime)>=(0,ez.hrTimeToMicroseconds)(c.sampleTime)?f:c;return new ML(c.startTime,y.toPointValue(),y.sampleTime)}diff(c,f){let y=(0,ez.hrTimeToMicroseconds)(f.sampleTime)>=(0,ez.hrTimeToMicroseconds)(c.sampleTime)?f:c;return new ML(f.startTime,y.toPointValue(),y.sampleTime)}toMetricData(c,f,y,b){return{descriptor:c,aggregationTemporality:f,dataPointType:dir.DataPointType.GAUGE,dataPoints:y.map(([A,g])=>({attributes:A,startTime:g.startTime,endTime:b,value:g.toPointValue()}))}}};LL.LastValueAggregator=ePe});var Eot=xt(FL=>{"use strict";Object.defineProperty(FL,"__esModule",{value:!0});FL.SumAggregator=FL.SumAccumulation=void 0;var mir=kL(),gir=AL(),mw=class{constructor(c,f,y=0,b=!1){this.startTime=c,this.monotonic=f,this._current=y,this.reset=b}record(c){this.monotonic&&c<0||(this._current+=c)}setStartTime(c){this.startTime=c}toPointValue(){return this._current}};FL.SumAccumulation=mw;var tPe=class{constructor(c){this.monotonic=c,this.kind=mir.AggregatorKind.SUM}createAccumulation(c){return new mw(c,this.monotonic)}merge(c,f){let y=c.toPointValue(),b=f.toPointValue();return f.reset?new mw(f.startTime,this.monotonic,b,f.reset):new mw(c.startTime,this.monotonic,y+b)}diff(c,f){let y=c.toPointValue(),b=f.toPointValue();return this.monotonic&&y>b?new mw(f.startTime,this.monotonic,b,!0):new mw(f.startTime,this.monotonic,b-y)}toMetricData(c,f,y,b){return{descriptor:c,aggregationTemporality:f,dataPointType:gir.DataPointType.SUM,dataPoints:y.map(([A,g])=>({attributes:A,startTime:g.startTime,endTime:b,value:g.toPointValue()})),isMonotonic:this.monotonic}}};FL.SumAggregator=tPe});var Pot=xt(Wm=>{"use strict";Object.defineProperty(Wm,"__esModule",{value:!0});Wm.SumAggregator=Wm.SumAccumulation=Wm.LastValueAggregator=Wm.LastValueAccumulation=Wm.ExponentialHistogramAggregator=Wm.ExponentialHistogramAccumulation=Wm.HistogramAggregator=Wm.HistogramAccumulation=Wm.DropAggregator=void 0;var hir=aot();Object.defineProperty(Wm,"DropAggregator",{enumerable:!0,get:function(){return hir.DropAggregator}});var xot=lot();Object.defineProperty(Wm,"HistogramAccumulation",{enumerable:!0,get:function(){return xot.HistogramAccumulation}});Object.defineProperty(Wm,"HistogramAggregator",{enumerable:!0,get:function(){return xot.HistogramAggregator}});var Cot=bot();Object.defineProperty(Wm,"ExponentialHistogramAccumulation",{enumerable:!0,get:function(){return Cot.ExponentialHistogramAccumulation}});Object.defineProperty(Wm,"ExponentialHistogramAggregator",{enumerable:!0,get:function(){return Cot.ExponentialHistogramAggregator}});var Aot=Tot();Object.defineProperty(Wm,"LastValueAccumulation",{enumerable:!0,get:function(){return Aot.LastValueAccumulation}});Object.defineProperty(Wm,"LastValueAggregator",{enumerable:!0,get:function(){return Aot.LastValueAggregator}});var kot=Eot();Object.defineProperty(Wm,"SumAccumulation",{enumerable:!0,get:function(){return kot.SumAccumulation}});Object.defineProperty(Wm,"SumAggregator",{enumerable:!0,get:function(){return kot.SumAggregator}})});var Gie=xt(Ah=>{"use strict";Object.defineProperty(Ah,"__esModule",{value:!0});Ah.DefaultAggregation=Ah.ExponentialHistogramAggregation=Ah.ExplicitBucketHistogramAggregation=Ah.HistogramAggregation=Ah.LastValueAggregation=Ah.SumAggregation=Ah.DropAggregation=Ah.Aggregation=void 0;var yir=(zc(),fc(Xc)),D4=Pot(),vC=oP(),SC=class{static Drop(){return Not}static Sum(){return Dot}static LastValue(){return wot}static Histogram(){return Iot}static ExponentialHistogram(){return vir}static Default(){return Sir}};Ah.Aggregation=SC;var tz=class l extends SC{createAggregator(c){return l.DEFAULT_INSTANCE}};Ah.DropAggregation=tz;tz.DEFAULT_INSTANCE=new D4.DropAggregator;var jL=class l extends SC{createAggregator(c){switch(c.type){case vC.InstrumentType.COUNTER:case vC.InstrumentType.OBSERVABLE_COUNTER:case vC.InstrumentType.HISTOGRAM:return l.MONOTONIC_INSTANCE;default:return l.NON_MONOTONIC_INSTANCE}}};Ah.SumAggregation=jL;jL.MONOTONIC_INSTANCE=new D4.SumAggregator(!0);jL.NON_MONOTONIC_INSTANCE=new D4.SumAggregator(!1);var rz=class l extends SC{createAggregator(c){return l.DEFAULT_INSTANCE}};Ah.LastValueAggregation=rz;rz.DEFAULT_INSTANCE=new D4.LastValueAggregator;var nz=class l extends SC{createAggregator(c){return l.DEFAULT_INSTANCE}};Ah.HistogramAggregation=nz;nz.DEFAULT_INSTANCE=new D4.HistogramAggregator([0,5,10,25,50,75,100,250,500,750,1e3,2500,5e3,7500,1e4],!0);var Wie=class extends SC{constructor(c,f=!0){if(super(),this._recordMinMax=f,c==null)throw new Error("ExplicitBucketHistogramAggregation should be created with explicit boundaries, if a single bucket histogram is required, please pass an empty array");c=c.concat(),c=c.sort((A,g)=>A-g);let y=c.lastIndexOf(-1/0),b=c.indexOf(1/0);b===-1&&(b=void 0),this._boundaries=c.slice(y+1,b)}createAggregator(c){return new D4.HistogramAggregator(this._boundaries,this._recordMinMax)}};Ah.ExplicitBucketHistogramAggregation=Wie;var $ie=class extends SC{constructor(c=160,f=!0){super(),this._maxSize=c,this._recordMinMax=f}createAggregator(c){return new D4.ExponentialHistogramAggregator(this._maxSize,this._recordMinMax)}};Ah.ExponentialHistogramAggregation=$ie;var Hie=class extends SC{_resolve(c){switch(c.type){case vC.InstrumentType.COUNTER:case vC.InstrumentType.UP_DOWN_COUNTER:case vC.InstrumentType.OBSERVABLE_COUNTER:case vC.InstrumentType.OBSERVABLE_UP_DOWN_COUNTER:return Dot;case vC.InstrumentType.GAUGE:case vC.InstrumentType.OBSERVABLE_GAUGE:return wot;case vC.InstrumentType.HISTOGRAM:return c.advice.explicitBucketBoundaries?new Wie(c.advice.explicitBucketBoundaries):Iot}return yir.diag.warn(`Unable to recognize instrument type: ${c.type}`),Not}createAggregator(c){return this._resolve(c).createAggregator(c)}};Ah.DefaultAggregation=Hie;var Not=new tz,Dot=new jL,wot=new rz,Iot=new nz,vir=new $ie,Sir=new Hie});var rPe=xt(BL=>{"use strict";Object.defineProperty(BL,"__esModule",{value:!0});BL.DEFAULT_AGGREGATION_TEMPORALITY_SELECTOR=BL.DEFAULT_AGGREGATION_SELECTOR=void 0;var bir=Gie(),Tir=Iie(),Eir=l=>bir.Aggregation.Default();BL.DEFAULT_AGGREGATION_SELECTOR=Eir;var xir=l=>Tir.AggregationTemporality.CUMULATIVE;BL.DEFAULT_AGGREGATION_TEMPORALITY_SELECTOR=xir});var iPe=xt(Kie=>{"use strict";Object.defineProperty(Kie,"__esModule",{value:!0});Kie.MetricReader=void 0;var Oot=(zc(),fc(Xc)),Yie=yC(),Rot=rPe(),nPe=class{constructor(c){var f,y,b;this._shutdown=!1,this._aggregationSelector=(f=c?.aggregationSelector)!==null&&f!==void 0?f:Rot.DEFAULT_AGGREGATION_SELECTOR,this._aggregationTemporalitySelector=(y=c?.aggregationTemporalitySelector)!==null&&y!==void 0?y:Rot.DEFAULT_AGGREGATION_TEMPORALITY_SELECTOR,this._metricProducers=(b=c?.metricProducers)!==null&&b!==void 0?b:[]}setMetricProducer(c){if(this._sdkMetricProducer)throw new Error("MetricReader can not be bound to a MeterProvider again.");this._sdkMetricProducer=c,this.onInitialized()}selectAggregation(c){return this._aggregationSelector(c)}selectAggregationTemporality(c){return this._aggregationTemporalitySelector(c)}onInitialized(){}async collect(c){if(this._sdkMetricProducer===void 0)throw new Error("MetricReader is not bound to a MetricProducer");if(this._shutdown)throw new Error("MetricReader is shutdown");let[f,...y]=await Promise.all([this._sdkMetricProducer.collect({timeoutMillis:c?.timeoutMillis}),...this._metricProducers.map(p=>p.collect({timeoutMillis:c?.timeoutMillis}))]),b=f.errors.concat((0,Yie.FlatMap)(y,p=>p.errors)),A=f.resourceMetrics.resource,g=f.resourceMetrics.scopeMetrics.concat((0,Yie.FlatMap)(y,p=>p.resourceMetrics.scopeMetrics));return{resourceMetrics:{resource:A,scopeMetrics:g},errors:b}}async shutdown(c){if(this._shutdown){Oot.diag.error("Cannot call shutdown twice.");return}c?.timeoutMillis==null?await this.onShutdown():await(0,Yie.callWithTimeout)(this.onShutdown(),c.timeoutMillis),this._shutdown=!0}async forceFlush(c){if(this._shutdown){Oot.diag.warn("Cannot forceFlush on already shutdown MetricReader.");return}if(c?.timeoutMillis==null){await this.onForceFlush();return}await(0,Yie.callWithTimeout)(this.onForceFlush(),c.timeoutMillis)}};Kie.MetricReader=nPe});var Fot=xt(Qie=>{"use strict";Object.defineProperty(Qie,"__esModule",{value:!0});Qie.PeriodicExportingMetricReader=void 0;var Mot=(zc(),fc(Xc)),Xie=py(),Cir=iPe(),Lot=yC(),Air=(zc(),fc(Xc)),sPe=class extends Cir.MetricReader{constructor(c){var f,y,b,A;if(super({aggregationSelector:(f=c.exporter.selectAggregation)===null||f===void 0?void 0:f.bind(c.exporter),aggregationTemporalitySelector:(y=c.exporter.selectAggregationTemporality)===null||y===void 0?void 0:y.bind(c.exporter),metricProducers:c.metricProducers}),c.exportIntervalMillis!==void 0&&c.exportIntervalMillis<=0)throw Error("exportIntervalMillis must be greater than 0");if(c.exportTimeoutMillis!==void 0&&c.exportTimeoutMillis<=0)throw Error("exportTimeoutMillis must be greater than 0");if(c.exportTimeoutMillis!==void 0&&c.exportIntervalMillis!==void 0&&c.exportIntervalMillis<c.exportTimeoutMillis)throw Error("exportIntervalMillis must be greater than or equal to exportTimeoutMillis");this._exportInterval=(b=c.exportIntervalMillis)!==null&&b!==void 0?b:6e4,this._exportTimeout=(A=c.exportTimeoutMillis)!==null&&A!==void 0?A:3e4,this._exporter=c.exporter}async _runOnce(){try{await(0,Lot.callWithTimeout)(this._doRun(),this._exportTimeout)}catch(c){if(c instanceof Lot.TimeoutError){Mot.diag.error("Export took longer than %s milliseconds and timed out.",this._exportTimeout);return}(0,Xie.globalErrorHandler)(c)}}async _doRun(){var c,f;let{resourceMetrics:y,errors:b}=await this.collect({timeoutMillis:this._exportTimeout});b.length>0&&Mot.diag.error("PeriodicExportingMetricReader: metrics collection errors",...b);let A=async()=>{let g=await Xie.internal._export(this._exporter,y);if(g.code!==Xie.ExportResultCode.SUCCESS)throw new Error(`PeriodicExportingMetricReader: metrics export failed (error ${g.error})`)};y.resource.asyncAttributesPending?(f=(c=y.resource).waitForAsyncAttributes)===null||f===void 0||f.call(c).then(A,g=>Air.diag.debug("Error while resolving async portion of resource: ",g)):await A()}onInitialized(){this._interval=setInterval(()=>{this._runOnce()},this._exportInterval),(0,Xie.unrefTimer)(this._interval)}async onForceFlush(){await this._runOnce(),await this._exporter.forceFlush()}async onShutdown(){this._interval&&clearInterval(this._interval),await this._exporter.shutdown()}};Qie.PeriodicExportingMetricReader=sPe});var Bot=xt(Zie=>{"use strict";Object.defineProperty(Zie,"__esModule",{value:!0});Zie.InMemoryMetricExporter=void 0;var jot=py(),aPe=class{constructor(c){this._shutdown=!1,this._metrics=[],this._aggregationTemporality=c}export(c,f){if(this._shutdown){setTimeout(()=>f({code:jot.ExportResultCode.FAILED}),0);return}this._metrics.push(c),setTimeout(()=>f({code:jot.ExportResultCode.SUCCESS}),0)}getMetrics(){return this._metrics}forceFlush(){return Promise.resolve()}reset(){this._metrics=[]}selectAggregationTemporality(c){return this._aggregationTemporality}shutdown(){return this._shutdown=!0,Promise.resolve()}};Zie.InMemoryMetricExporter=aPe});var Vot=xt(ese=>{"use strict";Object.defineProperty(ese,"__esModule",{value:!0});ese.ConsoleMetricExporter=void 0;var Uot=py(),kir=rPe(),oPe=class l{constructor(c){var f;this._shutdown=!1,this._temporalitySelector=(f=c?.temporalitySelector)!==null&&f!==void 0?f:kir.DEFAULT_AGGREGATION_TEMPORALITY_SELECTOR}export(c,f){if(this._shutdown){setImmediate(f,{code:Uot.ExportResultCode.FAILED});return}return l._sendMetrics(c,f)}forceFlush(){return Promise.resolve()}selectAggregationTemporality(c){return this._temporalitySelector(c)}shutdown(){return this._shutdown=!0,Promise.resolve()}static _sendMetrics(c,f){for(let y of c.scopeMetrics)for(let b of y.metrics)console.dir({descriptor:b.descriptor,dataPointType:b.dataPointType,dataPoints:b.dataPoints},{depth:null});f({code:Uot.ExportResultCode.SUCCESS})}};ese.ConsoleMetricExporter=oPe});var Jot=xt(tse=>{"use strict";Object.defineProperty(tse,"__esModule",{value:!0});tse.defaultServiceName=void 0;function Pir(){return`unknown_service:${process.argv0}`}tse.defaultServiceName=Pir});var qot=xt(rse=>{"use strict";Object.defineProperty(rse,"__esModule",{value:!0});rse.defaultServiceName=void 0;var Nir=Jot();Object.defineProperty(rse,"defaultServiceName",{enumerable:!0,get:function(){return Nir.defaultServiceName}})});var cPe=xt(nse=>{"use strict";Object.defineProperty(nse,"__esModule",{value:!0});nse.defaultServiceName=void 0;var Dir=qot();Object.defineProperty(nse,"defaultServiceName",{enumerable:!0,get:function(){return Dir.defaultServiceName}})});var cP=xt(ise=>{"use strict";Object.defineProperty(ise,"__esModule",{value:!0});ise.Resource=void 0;var zot=(zc(),fc(Xc)),w4=(hC(),fc(aP)),lPe=py(),wir=cPe(),iz=class l{constructor(c,f){var y;this._attributes=c,this.asyncAttributesPending=f!=null,this._syncAttributes=(y=this._attributes)!==null&&y!==void 0?y:{},this._asyncAttributesPromise=f?.then(b=>(this._attributes=Object.assign({},this._attributes,b),this.asyncAttributesPending=!1,b),b=>(zot.diag.debug("a resource's async attributes promise rejected: %s",b),this.asyncAttributesPending=!1,{}))}static empty(){return l.EMPTY}static default(){return new l({[w4.SEMRESATTRS_SERVICE_NAME]:(0,wir.defaultServiceName)(),[w4.SEMRESATTRS_TELEMETRY_SDK_LANGUAGE]:lPe.SDK_INFO[w4.SEMRESATTRS_TELEMETRY_SDK_LANGUAGE],[w4.SEMRESATTRS_TELEMETRY_SDK_NAME]:lPe.SDK_INFO[w4.SEMRESATTRS_TELEMETRY_SDK_NAME],[w4.SEMRESATTRS_TELEMETRY_SDK_VERSION]:lPe.SDK_INFO[w4.SEMRESATTRS_TELEMETRY_SDK_VERSION]})}get attributes(){var c;return this.asyncAttributesPending&&zot.diag.error("Accessing resource attributes before async attributes settled"),(c=this._attributes)!==null&&c!==void 0?c:{}}async waitForAsyncAttributes(){this.asyncAttributesPending&&await this._asyncAttributesPromise}merge(c){var f;if(!c)return this;let y=Object.assign(Object.assign({},this._syncAttributes),(f=c._syncAttributes)!==null&&f!==void 0?f:c.attributes);if(!this._asyncAttributesPromise&&!c._asyncAttributesPromise)return new l(y);let b=Promise.all([this._asyncAttributesPromise,c._asyncAttributesPromise]).then(([A,g])=>{var p;return Object.assign(Object.assign(Object.assign(Object.assign({},this._syncAttributes),A),(p=c._syncAttributes)!==null&&p!==void 0?p:c.attributes),g)});return new l(y,b)}};ise.Resource=iz;iz.EMPTY=new iz({})});var uPe=xt(UL=>{"use strict";Object.defineProperty(UL,"__esModule",{value:!0});UL.normalizeType=UL.normalizeArch=void 0;var Iir=l=>{switch(l){case"arm":return"arm32";case"ppc":return"ppc32";case"x64":return"amd64";default:return l}};UL.normalizeArch=Iir;var Oir=l=>{switch(l){case"sunos":return"solaris";case"win32":return"windows";default:return l}};UL.normalizeType=Oir});var ase=xt(sse=>{"use strict";Object.defineProperty(sse,"__esModule",{value:!0});sse.execAsync=void 0;var Rir=Bu("child_process"),Mir=Bu("util");sse.execAsync=Mir.promisify(Rir.exec)});var Wot=xt(ose=>{"use strict";Object.defineProperty(ose,"__esModule",{value:!0});ose.getMachineId=void 0;var Lir=ase(),Fir=(zc(),fc(Xc));async function jir(){try{let c=(await(0,Lir.execAsync)('ioreg -rd1 -c "IOPlatformExpertDevice"')).stdout.split(`
`).find(y=>y.includes("IOPlatformUUID"));if(!c)return"";let f=c.split('" = "');if(f.length===2)return f[1].slice(0,-1)}catch(l){Fir.diag.debug(`error reading machine id: ${l}`)}return""}ose.getMachineId=jir});var $ot=xt(cse=>{"use strict";Object.defineProperty(cse,"__esModule",{value:!0});cse.getMachineId=void 0;var Bir=Bu("fs"),Uir=(zc(),fc(Xc));async function Vir(){let l=["/etc/machine-id","/var/lib/dbus/machine-id"];for(let c of l)try{return(await Bir.promises.readFile(c,{encoding:"utf8"})).trim()}catch(f){Uir.diag.debug(`error reading machine id: ${f}`)}return""}cse.getMachineId=Vir});var Got=xt(lse=>{"use strict";Object.defineProperty(lse,"__esModule",{value:!0});lse.getMachineId=void 0;var Jir=Bu("fs"),qir=ase(),Hot=(zc(),fc(Xc));async function zir(){try{return(await Jir.promises.readFile("/etc/hostid",{encoding:"utf8"})).trim()}catch(l){Hot.diag.debug(`error reading machine id: ${l}`)}try{return(await(0,qir.execAsync)("kenv -q smbios.system.uuid")).stdout.trim()}catch(l){Hot.diag.debug(`error reading machine id: ${l}`)}return""}lse.getMachineId=zir});var Kot=xt(use=>{"use strict";Object.defineProperty(use,"__esModule",{value:!0});use.getMachineId=void 0;var Yot=Bu("process"),Wir=ase(),$ir=(zc(),fc(Xc));async function Hir(){let l="QUERY HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Cryptography /v MachineGuid",c="%windir%\\System32\\REG.exe";Yot.arch==="ia32"&&"PROCESSOR_ARCHITEW6432"in Yot.env&&(c="%windir%\\sysnative\\cmd.exe /c "+c);try{let y=(await(0,Wir.execAsync)(`${c} ${l}`)).stdout.split("REG_SZ");if(y.length===2)return y[1].trim()}catch(f){$ir.diag.debug(`error reading machine id: ${f}`)}return""}use.getMachineId=Hir});var Xot=xt(_se=>{"use strict";Object.defineProperty(_se,"__esModule",{value:!0});_se.getMachineId=void 0;var Gir=(zc(),fc(Xc));async function Yir(){return Gir.diag.debug("could not read machine-id: unsupported platform"),""}_se.getMachineId=Yir});var Qot=xt(lP=>{"use strict";Object.defineProperty(lP,"__esModule",{value:!0});lP.getMachineId=void 0;var Kir=Bu("process"),VL;lP.getMachineId=VL;switch(Kir.platform){case"darwin":lP.getMachineId=VL=Wot().getMachineId;break;case"linux":lP.getMachineId=VL=$ot().getMachineId;break;case"freebsd":lP.getMachineId=VL=Got().getMachineId;break;case"win32":lP.getMachineId=VL=Kot().getMachineId;break;default:lP.getMachineId=VL=Xot().getMachineId}});var pPe=xt(fse=>{"use strict";Object.defineProperty(fse,"__esModule",{value:!0});fse.hostDetectorSync=void 0;var _Pe=(hC(),fc(aP)),Xir=cP(),Zot=Bu("os"),Qir=uPe(),Zir=Qot(),fPe=class{detect(c){let f={[_Pe.SEMRESATTRS_HOST_NAME]:(0,Zot.hostname)(),[_Pe.SEMRESATTRS_HOST_ARCH]:(0,Qir.normalizeArch)((0,Zot.arch)())};return new Xir.Resource(f,this._getAsyncAttributes())}_getAsyncAttributes(){return(0,Zir.getMachineId)().then(c=>{let f={};return c&&(f[_Pe.SEMRESATTRS_HOST_ID]=c),f})}};fse.hostDetectorSync=new fPe});var ect=xt(pse=>{"use strict";Object.defineProperty(pse,"__esModule",{value:!0});pse.hostDetector=void 0;var esr=pPe(),dPe=class{detect(c){return Promise.resolve(esr.hostDetectorSync.detect(c))}};pse.hostDetector=new dPe});var gPe=xt(dse=>{"use strict";Object.defineProperty(dse,"__esModule",{value:!0});dse.osDetectorSync=void 0;var tct=(hC(),fc(aP)),tsr=cP(),rct=Bu("os"),rsr=uPe(),mPe=class{detect(c){let f={[tct.SEMRESATTRS_OS_TYPE]:(0,rsr.normalizeType)((0,rct.platform)()),[tct.SEMRESATTRS_OS_VERSION]:(0,rct.release)()};return new tsr.Resource(f)}};dse.osDetectorSync=new mPe});var nct=xt(mse=>{"use strict";Object.defineProperty(mse,"__esModule",{value:!0});mse.osDetector=void 0;var nsr=gPe(),hPe=class{detect(c){return Promise.resolve(nsr.osDetectorSync.detect(c))}};mse.osDetector=new hPe});var vPe=xt(gse=>{"use strict";Object.defineProperty(gse,"__esModule",{value:!0});gse.processDetectorSync=void 0;var isr=(zc(),fc(Xc)),uP=(hC(),fc(aP)),ssr=cP(),asr=Bu("os"),yPe=class{detect(c){let f={[uP.SEMRESATTRS_PROCESS_PID]:process.pid,[uP.SEMRESATTRS_PROCESS_EXECUTABLE_NAME]:process.title,[uP.SEMRESATTRS_PROCESS_EXECUTABLE_PATH]:process.execPath,[uP.SEMRESATTRS_PROCESS_COMMAND_ARGS]:[process.argv[0],...process.execArgv,...process.argv.slice(1)],[uP.SEMRESATTRS_PROCESS_RUNTIME_VERSION]:process.versions.node,[uP.SEMRESATTRS_PROCESS_RUNTIME_NAME]:"nodejs",[uP.SEMRESATTRS_PROCESS_RUNTIME_DESCRIPTION]:"Node.js"};process.argv.length>1&&(f[uP.SEMRESATTRS_PROCESS_COMMAND]=process.argv[1]);try{let y=asr.userInfo();f[uP.SEMRESATTRS_PROCESS_OWNER]=y.username}catch(y){isr.diag.debug(`error obtaining process owner: ${y}`)}return new ssr.Resource(f)}};gse.processDetectorSync=new yPe});var ict=xt(hse=>{"use strict";Object.defineProperty(hse,"__esModule",{value:!0});hse.processDetector=void 0;var osr=vPe(),SPe=class{detect(c){return Promise.resolve(osr.processDetectorSync.detect(c))}};hse.processDetector=new SPe});var sct=xt(yse=>{"use strict";Object.defineProperty(yse,"__esModule",{value:!0});yse.serviceInstanceIdDetectorSync=void 0;var csr=(hC(),fc(aP)),lsr=cP(),usr=Bu("crypto"),bPe=class{detect(c){let f={[csr.SEMRESATTRS_SERVICE_INSTANCE_ID]:(0,usr.randomUUID)()};return new lsr.Resource(f)}};yse.serviceInstanceIdDetectorSync=new bPe});var act=xt(t0=>{"use strict";Object.defineProperty(t0,"__esModule",{value:!0});t0.serviceInstanceIdDetectorSync=t0.processDetectorSync=t0.processDetector=t0.osDetectorSync=t0.osDetector=t0.hostDetectorSync=t0.hostDetector=void 0;var _sr=ect();Object.defineProperty(t0,"hostDetector",{enumerable:!0,get:function(){return _sr.hostDetector}});var fsr=pPe();Object.defineProperty(t0,"hostDetectorSync",{enumerable:!0,get:function(){return fsr.hostDetectorSync}});var psr=nct();Object.defineProperty(t0,"osDetector",{enumerable:!0,get:function(){return psr.osDetector}});var dsr=gPe();Object.defineProperty(t0,"osDetectorSync",{enumerable:!0,get:function(){return dsr.osDetectorSync}});var msr=ict();Object.defineProperty(t0,"processDetector",{enumerable:!0,get:function(){return msr.processDetector}});var gsr=vPe();Object.defineProperty(t0,"processDetectorSync",{enumerable:!0,get:function(){return gsr.processDetectorSync}});var hsr=sct();Object.defineProperty(t0,"serviceInstanceIdDetectorSync",{enumerable:!0,get:function(){return hsr.serviceInstanceIdDetectorSync}})});var oct=xt(r0=>{"use strict";Object.defineProperty(r0,"__esModule",{value:!0});r0.serviceInstanceIdDetectorSync=r0.processDetectorSync=r0.processDetector=r0.osDetectorSync=r0.osDetector=r0.hostDetectorSync=r0.hostDetector=void 0;var I4=act();Object.defineProperty(r0,"hostDetector",{enumerable:!0,get:function(){return I4.hostDetector}});Object.defineProperty(r0,"hostDetectorSync",{enumerable:!0,get:function(){return I4.hostDetectorSync}});Object.defineProperty(r0,"osDetector",{enumerable:!0,get:function(){return I4.osDetector}});Object.defineProperty(r0,"osDetectorSync",{enumerable:!0,get:function(){return I4.osDetectorSync}});Object.defineProperty(r0,"processDetector",{enumerable:!0,get:function(){return I4.processDetector}});Object.defineProperty(r0,"processDetectorSync",{enumerable:!0,get:function(){return I4.processDetectorSync}});Object.defineProperty(r0,"serviceInstanceIdDetectorSync",{enumerable:!0,get:function(){return I4.serviceInstanceIdDetectorSync}})});var xPe=xt(Sse=>{"use strict";Object.defineProperty(Sse,"__esModule",{value:!0});Sse.browserDetectorSync=void 0;var vse=(hC(),fc(aP)),ysr=(zc(),fc(Xc)),TPe=cP(),EPe=class{detect(c){var f,y,b;if(!(typeof navigator<"u"&&((y=(f=global.process)===null||f===void 0?void 0:f.versions)===null||y===void 0?void 0:y.node)===void 0&&((b=global.Bun)===null||b===void 0?void 0:b.version)===void 0))return TPe.Resource.empty();let g={[vse.SEMRESATTRS_PROCESS_RUNTIME_NAME]:"browser",[vse.SEMRESATTRS_PROCESS_RUNTIME_DESCRIPTION]:"Web Browser",[vse.SEMRESATTRS_PROCESS_RUNTIME_VERSION]:navigator.userAgent};return this._getResourceAttributes(g,c)}_getResourceAttributes(c,f){return c[vse.SEMRESATTRS_PROCESS_RUNTIME_VERSION]===""?(ysr.diag.debug("BrowserDetector failed: Unable to find required browser resources. "),TPe.Resource.empty()):new TPe.Resource(Object.assign({},c))}};Sse.browserDetectorSync=new EPe});var cct=xt(bse=>{"use strict";Object.defineProperty(bse,"__esModule",{value:!0});bse.browserDetector=void 0;var vsr=xPe(),CPe=class{detect(c){return Promise.resolve(vsr.browserDetectorSync.detect(c))}};bse.browserDetector=new CPe});var kPe=xt(Tse=>{"use strict";Object.defineProperty(Tse,"__esModule",{value:!0});Tse.envDetectorSync=void 0;var Ssr=(zc(),fc(Xc)),bsr=py(),Tsr=(hC(),fc(aP)),Esr=cP(),APe=class{constructor(){this._MAX_LENGTH=255,this._COMMA_SEPARATOR=",",this._LABEL_KEY_VALUE_SPLITTER="=",this._ERROR_MESSAGE_INVALID_CHARS="should be a ASCII string with a length greater than 0 and not exceed "+this._MAX_LENGTH+" characters.",this._ERROR_MESSAGE_INVALID_VALUE="should be a ASCII string with a length not exceed "+this._MAX_LENGTH+" characters."}detect(c){let f={},y=(0,bsr.getEnv)(),b=y.OTEL_RESOURCE_ATTRIBUTES,A=y.OTEL_SERVICE_NAME;if(b)try{let g=this._parseResourceAttributes(b);Object.assign(f,g)}catch(g){Ssr.diag.debug(`EnvDetector failed: ${g.message}`)}return A&&(f[Tsr.SEMRESATTRS_SERVICE_NAME]=A),new Esr.Resource(f)}_parseResourceAttributes(c){if(!c)return{};let f={},y=c.split(this._COMMA_SEPARATOR,-1);for(let b of y){let A=b.split(this._LABEL_KEY_VALUE_SPLITTER,-1);if(A.length!==2)continue;let[g,p]=A;if(g=g.trim(),p=p.trim().split(/^"|"$/).join(""),!this._isValidAndNotEmpty(g))throw new Error(`Attribute key ${this._ERROR_MESSAGE_INVALID_CHARS}`);if(!this._isValid(p))throw new Error(`Attribute value ${this._ERROR_MESSAGE_INVALID_VALUE}`);f[g]=decodeURIComponent(p)}return f}_isValid(c){return c.length<=this._MAX_LENGTH&&this._isBaggageOctetString(c)}_isBaggageOctetString(c){for(let f=0;f<c.length;f++){let y=c.charCodeAt(f);if(y<33||y===44||y===59||y===92||y>126)return!1}return!0}_isValidAndNotEmpty(c){return c.length>0&&this._isValid(c)}};Tse.envDetectorSync=new APe});var lct=xt(Ese=>{"use strict";Object.defineProperty(Ese,"__esModule",{value:!0});Ese.envDetector=void 0;var xsr=kPe(),PPe=class{detect(c){return Promise.resolve(xsr.envDetectorSync.detect(c))}};Ese.envDetector=new PPe});var uct=xt(jp=>{"use strict";Object.defineProperty(jp,"__esModule",{value:!0});jp.envDetectorSync=jp.browserDetectorSync=jp.envDetector=jp.browserDetector=jp.serviceInstanceIdDetectorSync=jp.processDetectorSync=jp.processDetector=jp.osDetectorSync=jp.osDetector=jp.hostDetectorSync=jp.hostDetector=void 0;var O4=oct();Object.defineProperty(jp,"hostDetector",{enumerable:!0,get:function(){return O4.hostDetector}});Object.defineProperty(jp,"hostDetectorSync",{enumerable:!0,get:function(){return O4.hostDetectorSync}});Object.defineProperty(jp,"osDetector",{enumerable:!0,get:function(){return O4.osDetector}});Object.defineProperty(jp,"osDetectorSync",{enumerable:!0,get:function(){return O4.osDetectorSync}});Object.defineProperty(jp,"processDetector",{enumerable:!0,get:function(){return O4.processDetector}});Object.defineProperty(jp,"processDetectorSync",{enumerable:!0,get:function(){return O4.processDetectorSync}});Object.defineProperty(jp,"serviceInstanceIdDetectorSync",{enumerable:!0,get:function(){return O4.serviceInstanceIdDetectorSync}});var Csr=cct();Object.defineProperty(jp,"browserDetector",{enumerable:!0,get:function(){return Csr.browserDetector}});var Asr=lct();Object.defineProperty(jp,"envDetector",{enumerable:!0,get:function(){return Asr.envDetector}});var ksr=xPe();Object.defineProperty(jp,"browserDetectorSync",{enumerable:!0,get:function(){return ksr.browserDetectorSync}});var Psr=kPe();Object.defineProperty(jp,"envDetectorSync",{enumerable:!0,get:function(){return Psr.envDetectorSync}})});var _ct=xt(xse=>{"use strict";Object.defineProperty(xse,"__esModule",{value:!0});xse.isPromiseLike=void 0;var Nsr=l=>l!==null&&typeof l=="object"&&typeof l.then=="function";xse.isPromiseLike=Nsr});var pct=xt(qL=>{"use strict";Object.defineProperty(qL,"__esModule",{value:!0});qL.detectResourcesSync=qL.detectResources=void 0;var sz=cP(),JL=(zc(),fc(Xc)),Dsr=_ct(),wsr=async(l={})=>{let c=await Promise.all((l.detectors||[]).map(async f=>{try{let y=await f.detect(l);return JL.diag.debug(`${f.constructor.name} found resource.`,y),y}catch(y){return JL.diag.debug(`${f.constructor.name} failed: ${y.message}`),sz.Resource.empty()}}));return fct(c),c.reduce((f,y)=>f.merge(y),sz.Resource.empty())};qL.detectResources=wsr;var Isr=(l={})=>{var c;let f=((c=l.detectors)!==null&&c!==void 0?c:[]).map(b=>{try{let A=b.detect(l),g;if((0,Dsr.isPromiseLike)(A)){let p=async()=>(await A).attributes;g=new sz.Resource({},p())}else g=A;return g.waitForAsyncAttributes?g.waitForAsyncAttributes().then(()=>JL.diag.debug(`${b.constructor.name} found resource.`,g)):JL.diag.debug(`${b.constructor.name} found resource.`,g),g}catch(A){return JL.diag.error(`${b.constructor.name} failed: ${A.message}`),sz.Resource.empty()}}),y=f.reduce((b,A)=>b.merge(A),sz.Resource.empty());return y.waitForAsyncAttributes&&y.waitForAsyncAttributes().then(()=>{fct(f)}),y};qL.detectResourcesSync=Isr;var fct=l=>{l.forEach(c=>{if(Object.keys(c.attributes).length>0){let f=JSON.stringify(c.attributes,null,4);JL.diag.verbose(f)}})}});var NPe=xt(a_=>{"use strict";Object.defineProperty(a_,"__esModule",{value:!0});a_.detectResources=a_.detectResourcesSync=a_.serviceInstanceIdDetectorSync=a_.processDetectorSync=a_.processDetector=a_.osDetectorSync=a_.osDetector=a_.hostDetectorSync=a_.hostDetector=a_.envDetectorSync=a_.envDetector=a_.browserDetectorSync=a_.browserDetector=a_.defaultServiceName=a_.Resource=void 0;var Osr=cP();Object.defineProperty(a_,"Resource",{enumerable:!0,get:function(){return Osr.Resource}});var Rsr=cPe();Object.defineProperty(a_,"defaultServiceName",{enumerable:!0,get:function(){return Rsr.defaultServiceName}});var yx=uct();Object.defineProperty(a_,"browserDetector",{enumerable:!0,get:function(){return yx.browserDetector}});Object.defineProperty(a_,"browserDetectorSync",{enumerable:!0,get:function(){return yx.browserDetectorSync}});Object.defineProperty(a_,"envDetector",{enumerable:!0,get:function(){return yx.envDetector}});Object.defineProperty(a_,"envDetectorSync",{enumerable:!0,get:function(){return yx.envDetectorSync}});Object.defineProperty(a_,"hostDetector",{enumerable:!0,get:function(){return yx.hostDetector}});Object.defineProperty(a_,"hostDetectorSync",{enumerable:!0,get:function(){return yx.hostDetectorSync}});Object.defineProperty(a_,"osDetector",{enumerable:!0,get:function(){return yx.osDetector}});Object.defineProperty(a_,"osDetectorSync",{enumerable:!0,get:function(){return yx.osDetectorSync}});Object.defineProperty(a_,"processDetector",{enumerable:!0,get:function(){return yx.processDetector}});Object.defineProperty(a_,"processDetectorSync",{enumerable:!0,get:function(){return yx.processDetectorSync}});Object.defineProperty(a_,"serviceInstanceIdDetectorSync",{enumerable:!0,get:function(){return yx.serviceInstanceIdDetectorSync}});var dct=pct();Object.defineProperty(a_,"detectResourcesSync",{enumerable:!0,get:function(){return dct.detectResourcesSync}});Object.defineProperty(a_,"detectResources",{enumerable:!0,get:function(){return dct.detectResources}})});var mct=xt(Cse=>{"use strict";Object.defineProperty(Cse,"__esModule",{value:!0});Cse.ViewRegistry=void 0;var DPe=class{constructor(){this._registeredViews=[]}addView(c){this._registeredViews.push(c)}findViews(c,f){return this._registeredViews.filter(b=>this._matchInstrument(b.instrumentSelector,c)&&this._matchMeter(b.meterSelector,f))}_matchInstrument(c,f){return(c.getType()===void 0||f.type===c.getType())&&c.getNameFilter().match(f.name)&&c.getUnitFilter().match(f.unit)}_matchMeter(c,f){return c.getNameFilter().match(f.name)&&(f.version===void 0||c.getVersionFilter().match(f.version))&&(f.schemaUrl===void 0||c.getSchemaUrlFilter().match(f.schemaUrl))}};Cse.ViewRegistry=DPe});var Ase=xt(zd=>{"use strict";Object.defineProperty(zd,"__esModule",{value:!0});zd.isObservableInstrument=zd.ObservableUpDownCounterInstrument=zd.ObservableGaugeInstrument=zd.ObservableCounterInstrument=zd.ObservableInstrument=zd.HistogramInstrument=zd.GaugeInstrument=zd.CounterInstrument=zd.UpDownCounterInstrument=zd.SyncInstrument=void 0;var zL=(zc(),fc(Xc)),Msr=py(),R4=class{constructor(c,f){this._writableMetricStorage=c,this._descriptor=f}_record(c,f={},y=zL.context.active()){if(typeof c!="number"){zL.diag.warn(`non-number value provided to metric ${this._descriptor.name}: ${c}`);return}this._descriptor.valueType===zL.ValueType.INT&&!Number.isInteger(c)&&(zL.diag.warn(`INT value type cannot accept a floating-point value for ${this._descriptor.name}, ignoring the fractional digits.`),c=Math.trunc(c),!Number.isInteger(c))||this._writableMetricStorage.record(c,f,y,(0,Msr.millisToHrTime)(Date.now()))}};zd.SyncInstrument=R4;var wPe=class extends R4{add(c,f,y){this._record(c,f,y)}};zd.UpDownCounterInstrument=wPe;var IPe=class extends R4{add(c,f,y){if(c<0){zL.diag.warn(`negative value provided to counter ${this._descriptor.name}: ${c}`);return}this._record(c,f,y)}};zd.CounterInstrument=IPe;var OPe=class extends R4{record(c,f,y){this._record(c,f,y)}};zd.GaugeInstrument=OPe;var RPe=class extends R4{record(c,f,y){if(c<0){zL.diag.warn(`negative value provided to histogram ${this._descriptor.name}: ${c}`);return}this._record(c,f,y)}};zd.HistogramInstrument=RPe;var M4=class{constructor(c,f,y){this._observableRegistry=y,this._descriptor=c,this._metricStorages=f}addCallback(c){this._observableRegistry.addCallback(c,this)}removeCallback(c){this._observableRegistry.removeCallback(c,this)}};zd.ObservableInstrument=M4;var MPe=class extends M4{};zd.ObservableCounterInstrument=MPe;var LPe=class extends M4{};zd.ObservableGaugeInstrument=LPe;var FPe=class extends M4{};zd.ObservableUpDownCounterInstrument=FPe;function Lsr(l){return l instanceof M4}zd.isObservableInstrument=Lsr});var gct=xt(kse=>{"use strict";Object.defineProperty(kse,"__esModule",{value:!0});kse.Meter=void 0;var b1=oP(),L4=Ase(),jPe=class{constructor(c){this._meterSharedState=c}createGauge(c,f){let y=(0,b1.createInstrumentDescriptor)(c,b1.InstrumentType.GAUGE,f),b=this._meterSharedState.registerMetricStorage(y);return new L4.GaugeInstrument(b,y)}createHistogram(c,f){let y=(0,b1.createInstrumentDescriptor)(c,b1.InstrumentType.HISTOGRAM,f),b=this._meterSharedState.registerMetricStorage(y);return new L4.HistogramInstrument(b,y)}createCounter(c,f){let y=(0,b1.createInstrumentDescriptor)(c,b1.InstrumentType.COUNTER,f),b=this._meterSharedState.registerMetricStorage(y);return new L4.CounterInstrument(b,y)}createUpDownCounter(c,f){let y=(0,b1.createInstrumentDescriptor)(c,b1.InstrumentType.UP_DOWN_COUNTER,f),b=this._meterSharedState.registerMetricStorage(y);return new L4.UpDownCounterInstrument(b,y)}createObservableGauge(c,f){let y=(0,b1.createInstrumentDescriptor)(c,b1.InstrumentType.OBSERVABLE_GAUGE,f),b=this._meterSharedState.registerAsyncMetricStorage(y);return new L4.ObservableGaugeInstrument(y,b,this._meterSharedState.observableRegistry)}createObservableCounter(c,f){let y=(0,b1.createInstrumentDescriptor)(c,b1.InstrumentType.OBSERVABLE_COUNTER,f),b=this._meterSharedState.registerAsyncMetricStorage(y);return new L4.ObservableCounterInstrument(y,b,this._meterSharedState.observableRegistry)}createObservableUpDownCounter(c,f){let y=(0,b1.createInstrumentDescriptor)(c,b1.InstrumentType.OBSERVABLE_UP_DOWN_COUNTER,f),b=this._meterSharedState.registerAsyncMetricStorage(y);return new L4.ObservableUpDownCounterInstrument(y,b,this._meterSharedState.observableRegistry)}addBatchObservableCallback(c,f){this._meterSharedState.observableRegistry.addBatchCallback(c,f)}removeBatchObservableCallback(c,f){this._meterSharedState.observableRegistry.removeBatchCallback(c,f)}};kse.Meter=jPe});var UPe=xt(Pse=>{"use strict";Object.defineProperty(Pse,"__esModule",{value:!0});Pse.MetricStorage=void 0;var Fsr=oP(),BPe=class{constructor(c){this._instrumentDescriptor=c}getInstrumentDescriptor(){return this._instrumentDescriptor}updateDescription(c){this._instrumentDescriptor=(0,Fsr.createInstrumentDescriptor)(this._instrumentDescriptor.name,this._instrumentDescriptor.type,{description:c,valueType:this._instrumentDescriptor.valueType,unit:this._instrumentDescriptor.unit,advice:this._instrumentDescriptor.advice})}};Pse.MetricStorage=BPe});var az=xt(WL=>{"use strict";Object.defineProperty(WL,"__esModule",{value:!0});WL.AttributeHashMap=WL.HashMap=void 0;var jsr=yC(),Nse=class{constructor(c){this._hash=c,this._valueMap=new Map,this._keyMap=new Map}get(c,f){return f??(f=this._hash(c)),this._valueMap.get(f)}getOrDefault(c,f){let y=this._hash(c);if(this._valueMap.has(y))return this._valueMap.get(y);let b=f();return this._keyMap.has(y)||this._keyMap.set(y,c),this._valueMap.set(y,b),b}set(c,f,y){y??(y=this._hash(c)),this._keyMap.has(y)||this._keyMap.set(y,c),this._valueMap.set(y,f)}has(c,f){return f??(f=this._hash(c)),this._valueMap.has(f)}*keys(){let c=this._keyMap.entries(),f=c.next();for(;f.done!==!0;)yield[f.value[1],f.value[0]],f=c.next()}*entries(){let c=this._valueMap.entries(),f=c.next();for(;f.done!==!0;)yield[this._keyMap.get(f.value[0]),f.value[1],f.value[0]],f=c.next()}get size(){return this._valueMap.size}};WL.HashMap=Nse;var VPe=class extends Nse{constructor(){super(jsr.hashAttributes)}};WL.AttributeHashMap=VPe});var zPe=xt(Dse=>{"use strict";Object.defineProperty(Dse,"__esModule",{value:!0});Dse.DeltaMetricProcessor=void 0;var JPe=az(),qPe=class{constructor(c){this._aggregator=c,this._activeCollectionStorage=new JPe.AttributeHashMap,this._cumulativeMemoStorage=new JPe.AttributeHashMap}record(c,f,y,b){let A=this._activeCollectionStorage.getOrDefault(f,()=>this._aggregator.createAccumulation(b));A?.record(c)}batchCumulate(c,f){Array.from(c.entries()).forEach(([y,b,A])=>{let g=this._aggregator.createAccumulation(f);g?.record(b);let p=g;if(this._cumulativeMemoStorage.has(y,A)){let k=this._cumulativeMemoStorage.get(y,A);p=this._aggregator.diff(k,g)}if(this._activeCollectionStorage.has(y,A)){let k=this._activeCollectionStorage.get(y,A);p=this._aggregator.merge(k,p)}this._cumulativeMemoStorage.set(y,g,A),this._activeCollectionStorage.set(y,p,A)})}collect(){let c=this._activeCollectionStorage;return this._activeCollectionStorage=new JPe.AttributeHashMap,c}};Dse.DeltaMetricProcessor=qPe});var $Pe=xt(wse=>{"use strict";Object.defineProperty(wse,"__esModule",{value:!0});wse.TemporalMetricProcessor=void 0;var Bsr=Iie(),Usr=az(),WPe=class l{constructor(c,f){this._aggregator=c,this._unreportedAccumulations=new Map,this._reportHistory=new Map,f.forEach(y=>{this._unreportedAccumulations.set(y,[])})}buildMetrics(c,f,y,b){this._stashAccumulations(y);let A=this._getMergedUnreportedAccumulations(c),g=A,p;if(this._reportHistory.has(c)){let j=this._reportHistory.get(c),se=j.collectionTime;p=j.aggregationTemporality,p===Bsr.AggregationTemporality.CUMULATIVE?g=l.merge(j.accumulations,A,this._aggregator):g=l.calibrateStartTime(j.accumulations,A,se)}else p=c.selectAggregationTemporality(f.type);this._reportHistory.set(c,{accumulations:g,collectionTime:b,aggregationTemporality:p});let k=Vsr(g);if(k.length!==0)return this._aggregator.toMetricData(f,p,k,b)}_stashAccumulations(c){let f=this._unreportedAccumulations.keys();for(let y of f){let b=this._unreportedAccumulations.get(y);b===void 0&&(b=[],this._unreportedAccumulations.set(y,b)),b.push(c)}}_getMergedUnreportedAccumulations(c){let f=new Usr.AttributeHashMap,y=this._unreportedAccumulations.get(c);if(this._unreportedAccumulations.set(c,[]),y===void 0)return f;for(let b of y)f=l.merge(f,b,this._aggregator);return f}static merge(c,f,y){let b=c,A=f.entries(),g=A.next();for(;g.done!==!0;){let[p,k,j]=g.value;if(c.has(p,j)){let se=c.get(p,j),ze=y.merge(se,k);b.set(p,ze,j)}else b.set(p,k,j);g=A.next()}return b}static calibrateStartTime(c,f,y){for(let[b,A]of c.keys()){let g=f.get(b,A);g?.setStartTime(y)}return f}};wse.TemporalMetricProcessor=WPe;function Vsr(l){return Array.from(l.entries())}});var hct=xt(Ise=>{"use strict";Object.defineProperty(Ise,"__esModule",{value:!0});Ise.AsyncMetricStorage=void 0;var Jsr=UPe(),qsr=zPe(),zsr=$Pe(),Wsr=az(),HPe=class extends Jsr.MetricStorage{constructor(c,f,y,b){super(c),this._attributesProcessor=y,this._deltaMetricStorage=new qsr.DeltaMetricProcessor(f),this._temporalMetricStorage=new zsr.TemporalMetricProcessor(f,b)}record(c,f){let y=new Wsr.AttributeHashMap;Array.from(c.entries()).forEach(([b,A])=>{y.set(this._attributesProcessor.process(b),A)}),this._deltaMetricStorage.batchCumulate(y,f)}collect(c,f){let y=this._deltaMetricStorage.collect();return this._temporalMetricStorage.buildMetrics(c,this._instrumentDescriptor,y,f)}};Ise.AsyncMetricStorage=HPe});var Tct=xt(T1=>{"use strict";Object.defineProperty(T1,"__esModule",{value:!0});T1.getConflictResolutionRecipe=T1.getDescriptionResolutionRecipe=T1.getTypeConflictResolutionRecipe=T1.getUnitConflictResolutionRecipe=T1.getValueTypeConflictResolutionRecipe=T1.getIncompatibilityDetails=void 0;function $sr(l,c){let f="";return l.unit!==c.unit&&(f+=`	- Unit '${l.unit}' does not match '${c.unit}'
`),l.type!==c.type&&(f+=`	- Type '${l.type}' does not match '${c.type}'
`),l.valueType!==c.valueType&&(f+=`	- Value Type '${l.valueType}' does not match '${c.valueType}'
`),l.description!==c.description&&(f+=`	- Description '${l.description}' does not match '${c.description}'
`),f}T1.getIncompatibilityDetails=$sr;function yct(l,c){return`	- use valueType '${l.valueType}' on instrument creation or use an instrument name other than '${c.name}'`}T1.getValueTypeConflictResolutionRecipe=yct;function vct(l,c){return`	- use unit '${l.unit}' on instrument creation or use an instrument name other than '${c.name}'`}T1.getUnitConflictResolutionRecipe=vct;function Sct(l,c){let f={name:c.name,type:c.type,unit:c.unit},y=JSON.stringify(f);return`	- create a new view with a name other than '${l.name}' and InstrumentSelector '${y}'`}T1.getTypeConflictResolutionRecipe=Sct;function bct(l,c){let f={name:c.name,type:c.type,unit:c.unit},y=JSON.stringify(f);return`	- create a new view with a name other than '${l.name}' and InstrumentSelector '${y}'
    	- OR - create a new view with the name ${l.name} and description '${l.description}' and InstrumentSelector ${y}
    	- OR - create a new view with the name ${c.name} and description '${l.description}' and InstrumentSelector ${y}`}T1.getDescriptionResolutionRecipe=bct;function Hsr(l,c){return l.valueType!==c.valueType?yct(l,c):l.unit!==c.unit?vct(l,c):l.type!==c.type?Sct(l,c):l.description!==c.description?bct(l,c):""}T1.getConflictResolutionRecipe=Hsr});var xct=xt(Rse=>{"use strict";Object.defineProperty(Rse,"__esModule",{value:!0});Rse.MetricStorageRegistry=void 0;var Gsr=oP(),Ect=(zc(),fc(Xc)),Ose=Tct(),GPe=class l{constructor(){this._sharedRegistry=new Map,this._perCollectorRegistry=new Map}static create(){return new l}getStorages(c){let f=[];for(let b of this._sharedRegistry.values())f=f.concat(b);let y=this._perCollectorRegistry.get(c);if(y!=null)for(let b of y.values())f=f.concat(b);return f}register(c){this._registerStorage(c,this._sharedRegistry)}registerForCollector(c,f){let y=this._perCollectorRegistry.get(c);y==null&&(y=new Map,this._perCollectorRegistry.set(c,y)),this._registerStorage(f,y)}findOrUpdateCompatibleStorage(c){let f=this._sharedRegistry.get(c.name);return f===void 0?null:this._findOrUpdateCompatibleStorage(c,f)}findOrUpdateCompatibleCollectorStorage(c,f){let y=this._perCollectorRegistry.get(c);if(y===void 0)return null;let b=y.get(f.name);return b===void 0?null:this._findOrUpdateCompatibleStorage(f,b)}_registerStorage(c,f){let y=c.getInstrumentDescriptor(),b=f.get(y.name);if(b===void 0){f.set(y.name,[c]);return}b.push(c)}_findOrUpdateCompatibleStorage(c,f){let y=null;for(let b of f){let A=b.getInstrumentDescriptor();(0,Gsr.isDescriptorCompatibleWith)(A,c)?(A.description!==c.description&&(c.description.length>A.description.length&&b.updateDescription(c.description),Ect.diag.warn("A view or instrument with the name ",c.name,` has already been registered, but has a different description and is incompatible with another registered view.
`,`Details:
`,(0,Ose.getIncompatibilityDetails)(A,c),`The longer description will be used.
To resolve the conflict:`,(0,Ose.getConflictResolutionRecipe)(A,c))),y=b):Ect.diag.warn("A view or instrument with the name ",c.name,` has already been registered and is incompatible with another registered view.
`,`Details:
`,(0,Ose.getIncompatibilityDetails)(A,c),`To resolve the conflict:
`,(0,Ose.getConflictResolutionRecipe)(A,c))}return y}};Rse.MetricStorageRegistry=GPe});var Cct=xt(Mse=>{"use strict";Object.defineProperty(Mse,"__esModule",{value:!0});Mse.MultiMetricStorage=void 0;var YPe=class{constructor(c){this._backingStorages=c}record(c,f,y,b){this._backingStorages.forEach(A=>{A.record(c,f,y,b)})}};Mse.MultiMetricStorage=YPe});var kct=xt(HL=>{"use strict";Object.defineProperty(HL,"__esModule",{value:!0});HL.BatchObservableResultImpl=HL.ObservableResultImpl=void 0;var $L=(zc(),fc(Xc)),Act=az(),Ysr=Ase(),KPe=class{constructor(c,f){this._instrumentName=c,this._valueType=f,this._buffer=new Act.AttributeHashMap}observe(c,f={}){if(typeof c!="number"){$L.diag.warn(`non-number value provided to metric ${this._instrumentName}: ${c}`);return}this._valueType===$L.ValueType.INT&&!Number.isInteger(c)&&($L.diag.warn(`INT value type cannot accept a floating-point value for ${this._instrumentName}, ignoring the fractional digits.`),c=Math.trunc(c),!Number.isInteger(c))||this._buffer.set(f,c)}};HL.ObservableResultImpl=KPe;var XPe=class{constructor(){this._buffer=new Map}observe(c,f,y={}){if(!(0,Ysr.isObservableInstrument)(c))return;let b=this._buffer.get(c);if(b==null&&(b=new Act.AttributeHashMap,this._buffer.set(c,b)),typeof f!="number"){$L.diag.warn(`non-number value provided to metric ${c._descriptor.name}: ${f}`);return}c._descriptor.valueType===$L.ValueType.INT&&!Number.isInteger(f)&&($L.diag.warn(`INT value type cannot accept a floating-point value for ${c._descriptor.name}, ignoring the fractional digits.`),f=Math.trunc(f),!Number.isInteger(f))||b.set(y,f)}};HL.BatchObservableResultImpl=XPe});var Dct=xt(Lse=>{"use strict";Object.defineProperty(Lse,"__esModule",{value:!0});Lse.ObservableRegistry=void 0;var Ksr=(zc(),fc(Xc)),Pct=Ase(),Nct=kct(),oz=yC(),QPe=class{constructor(){this._callbacks=[],this._batchCallbacks=[]}addCallback(c,f){this._findCallback(c,f)>=0||this._callbacks.push({callback:c,instrument:f})}removeCallback(c,f){let y=this._findCallback(c,f);y<0||this._callbacks.splice(y,1)}addBatchCallback(c,f){let y=new Set(f.filter(Pct.isObservableInstrument));if(y.size===0){Ksr.diag.error("BatchObservableCallback is not associated with valid instruments",f);return}this._findBatchCallback(c,y)>=0||this._batchCallbacks.push({callback:c,instruments:y})}removeBatchCallback(c,f){let y=new Set(f.filter(Pct.isObservableInstrument)),b=this._findBatchCallback(c,y);b<0||this._batchCallbacks.splice(b,1)}async observe(c,f){let y=this._observeCallbacks(c,f),b=this._observeBatchCallbacks(c,f);return(await(0,oz.PromiseAllSettled)([...y,...b])).filter(oz.isPromiseAllSettledRejectionResult).map(p=>p.reason)}_observeCallbacks(c,f){return this._callbacks.map(async({callback:y,instrument:b})=>{let A=new Nct.ObservableResultImpl(b._descriptor.name,b._descriptor.valueType),g=Promise.resolve(y(A));f!=null&&(g=(0,oz.callWithTimeout)(g,f)),await g,b._metricStorages.forEach(p=>{p.record(A._buffer,c)})})}_observeBatchCallbacks(c,f){return this._batchCallbacks.map(async({callback:y,instruments:b})=>{let A=new Nct.BatchObservableResultImpl,g=Promise.resolve(y(A));f!=null&&(g=(0,oz.callWithTimeout)(g,f)),await g,b.forEach(p=>{let k=A._buffer.get(p);k!=null&&p._metricStorages.forEach(j=>{j.record(k,c)})})})}_findCallback(c,f){return this._callbacks.findIndex(y=>y.callback===c&&y.instrument===f)}_findBatchCallback(c,f){return this._batchCallbacks.findIndex(y=>y.callback===c&&(0,oz.setEquals)(y.instruments,f))}};Lse.ObservableRegistry=QPe});var wct=xt(Fse=>{"use strict";Object.defineProperty(Fse,"__esModule",{value:!0});Fse.SyncMetricStorage=void 0;var Xsr=UPe(),Qsr=zPe(),Zsr=$Pe(),ZPe=class extends Xsr.MetricStorage{constructor(c,f,y,b){super(c),this._attributesProcessor=y,this._deltaMetricStorage=new Qsr.DeltaMetricProcessor(f),this._temporalMetricStorage=new Zsr.TemporalMetricProcessor(f,b)}record(c,f,y,b){f=this._attributesProcessor.process(f,y),this._deltaMetricStorage.record(c,f,y,b)}collect(c,f){let y=this._deltaMetricStorage.collect();return this._temporalMetricStorage.buildMetrics(c,this._instrumentDescriptor,y,f)}};Fse.SyncMetricStorage=ZPe});var tNe=xt(gw=>{"use strict";Object.defineProperty(gw,"__esModule",{value:!0});gw.FilteringAttributesProcessor=gw.NoopAttributesProcessor=gw.AttributesProcessor=void 0;var cz=class{static Noop(){return ear}};gw.AttributesProcessor=cz;var jse=class extends cz{process(c,f){return c}};gw.NoopAttributesProcessor=jse;var eNe=class extends cz{constructor(c){super(),this._allowedAttributeNames=c}process(c,f){let y={};return Object.keys(c).filter(b=>this._allowedAttributeNames.includes(b)).forEach(b=>y[b]=c[b]),y}};gw.FilteringAttributesProcessor=eNe;var ear=new jse});var Ict=xt(Bse=>{"use strict";Object.defineProperty(Bse,"__esModule",{value:!0});Bse.MeterSharedState=void 0;var tar=oP(),rar=gct(),nar=yC(),iar=hct(),sar=xct(),aar=Cct(),oar=Dct(),car=wct(),lar=tNe(),rNe=class{constructor(c,f){this._meterProviderSharedState=c,this._instrumentationScope=f,this.metricStorageRegistry=new sar.MetricStorageRegistry,this.observableRegistry=new oar.ObservableRegistry,this.meter=new rar.Meter(this)}registerMetricStorage(c){let f=this._registerMetricStorage(c,car.SyncMetricStorage);return f.length===1?f[0]:new aar.MultiMetricStorage(f)}registerAsyncMetricStorage(c){return this._registerMetricStorage(c,iar.AsyncMetricStorage)}async collect(c,f,y){let b=await this.observableRegistry.observe(f,y?.timeoutMillis),A=this.metricStorageRegistry.getStorages(c);if(A.length===0)return null;let g=A.map(p=>p.collect(c,f)).filter(nar.isNotNullish);return g.length===0?{errors:b}:{scopeMetrics:{scope:this._instrumentationScope,metrics:g},errors:b}}_registerMetricStorage(c,f){let b=this._meterProviderSharedState.viewRegistry.findViews(c,this._instrumentationScope).map(A=>{let g=(0,tar.createInstrumentDescriptorWithView)(A,c),p=this.metricStorageRegistry.findOrUpdateCompatibleStorage(g);if(p!=null)return p;let k=A.aggregation.createAggregator(g),j=new f(g,k,A.attributesProcessor,this._meterProviderSharedState.metricCollectors);return this.metricStorageRegistry.register(j),j});if(b.length===0){let g=this._meterProviderSharedState.selectAggregations(c.type).map(([p,k])=>{let j=this.metricStorageRegistry.findOrUpdateCompatibleCollectorStorage(p,c);if(j!=null)return j;let se=k.createAggregator(c),ze=new f(c,se,lar.AttributesProcessor.Noop(),[p]);return this.metricStorageRegistry.registerForCollector(p,ze),ze});b=b.concat(g)}return b}};Bse.MeterSharedState=rNe});var Oct=xt(Use=>{"use strict";Object.defineProperty(Use,"__esModule",{value:!0});Use.MeterProviderSharedState=void 0;var uar=yC(),_ar=mct(),far=Ict(),nNe=class{constructor(c){this.resource=c,this.viewRegistry=new _ar.ViewRegistry,this.metricCollectors=[],this.meterSharedStates=new Map}getMeterSharedState(c){let f=(0,uar.instrumentationScopeId)(c),y=this.meterSharedStates.get(f);return y==null&&(y=new far.MeterSharedState(this,c),this.meterSharedStates.set(f,y)),y}selectAggregations(c){let f=[];for(let y of this.metricCollectors)f.push([y,y.selectAggregation(c)]);return f}};Use.MeterProviderSharedState=nNe});var Rct=xt(Vse=>{"use strict";Object.defineProperty(Vse,"__esModule",{value:!0});Vse.MetricCollector=void 0;var par=py(),iNe=class{constructor(c,f){this._sharedState=c,this._metricReader=f}async collect(c){let f=(0,par.millisToHrTime)(Date.now()),y=[],b=[],A=Array.from(this._sharedState.meterSharedStates.values()).map(async g=>{let p=await g.collect(this,f,c);p?.scopeMetrics!=null&&y.push(p.scopeMetrics),p?.errors!=null&&b.push(...p.errors)});return await Promise.all(A),{resourceMetrics:{resource:this._sharedState.resource,scopeMetrics:y},errors:b}}async forceFlush(c){await this._metricReader.forceFlush(c)}async shutdown(c){await this._metricReader.shutdown(c)}selectAggregationTemporality(c){return this._metricReader.selectAggregationTemporality(c)}selectAggregation(c){return this._metricReader.selectAggregation(c)}};Vse.MetricCollector=iNe});var Lct=xt(qse=>{"use strict";Object.defineProperty(qse,"__esModule",{value:!0});qse.MeterProvider=void 0;var Jse=(zc(),fc(Xc)),Mct=NPe(),dar=Oct(),mar=Rct(),sNe=class{constructor(c){var f;this._shutdown=!1;let y=Mct.Resource.default().merge((f=c?.resource)!==null&&f!==void 0?f:Mct.Resource.empty());if(this._sharedState=new dar.MeterProviderSharedState(y),c?.views!=null&&c.views.length>0)for(let b of c.views)this._sharedState.viewRegistry.addView(b);if(c?.readers!=null&&c.readers.length>0)for(let b of c.readers)this.addMetricReader(b)}getMeter(c,f="",y={}){return this._shutdown?(Jse.diag.warn("A shutdown MeterProvider cannot provide a Meter"),(0,Jse.createNoopMeter)()):this._sharedState.getMeterSharedState({name:c,version:f,schemaUrl:y.schemaUrl}).meter}addMetricReader(c){let f=new mar.MetricCollector(this._sharedState,c);c.setMetricProducer(f),this._sharedState.metricCollectors.push(f)}async shutdown(c){if(this._shutdown){Jse.diag.warn("shutdown may only be called once per MeterProvider");return}this._shutdown=!0,await Promise.all(this._sharedState.metricCollectors.map(f=>f.shutdown(c)))}async forceFlush(c){if(this._shutdown){Jse.diag.warn("invalid attempt to force flush after MeterProvider shutdown");return}await Promise.all(this._sharedState.metricCollectors.map(f=>f.forceFlush(c)))}};qse.MeterProvider=sNe});var zse=xt(GL=>{"use strict";Object.defineProperty(GL,"__esModule",{value:!0});GL.ExactPredicate=GL.PatternPredicate=void 0;var gar=/[\^$\\.+?()[\]{}|]/g,aNe=class l{constructor(c){c==="*"?(this._matchAll=!0,this._regexp=/.*/):(this._matchAll=!1,this._regexp=new RegExp(l.escapePattern(c)))}match(c){return this._matchAll?!0:this._regexp.test(c)}static escapePattern(c){return`^${c.replace(gar,"\\$&").replace("*",".*")}$`}static hasWildcard(c){return c.includes("*")}};GL.PatternPredicate=aNe;var oNe=class{constructor(c){this._matchAll=c===void 0,this._pattern=c}match(c){return!!(this._matchAll||c===this._pattern)}};GL.ExactPredicate=oNe});var jct=xt(Wse=>{"use strict";Object.defineProperty(Wse,"__esModule",{value:!0});Wse.InstrumentSelector=void 0;var Fct=zse(),cNe=class{constructor(c){var f;this._nameFilter=new Fct.PatternPredicate((f=c?.name)!==null&&f!==void 0?f:"*"),this._type=c?.type,this._unitFilter=new Fct.ExactPredicate(c?.unit)}getType(){return this._type}getNameFilter(){return this._nameFilter}getUnitFilter(){return this._unitFilter}};Wse.InstrumentSelector=cNe});var Bct=xt($se=>{"use strict";Object.defineProperty($se,"__esModule",{value:!0});$se.MeterSelector=void 0;var lNe=zse(),uNe=class{constructor(c){this._nameFilter=new lNe.ExactPredicate(c?.name),this._versionFilter=new lNe.ExactPredicate(c?.version),this._schemaUrlFilter=new lNe.ExactPredicate(c?.schemaUrl)}getNameFilter(){return this._nameFilter}getVersionFilter(){return this._versionFilter}getSchemaUrlFilter(){return this._schemaUrlFilter}};$se.MeterSelector=uNe});var Vct=xt(Hse=>{"use strict";Object.defineProperty(Hse,"__esModule",{value:!0});Hse.View=void 0;var har=zse(),Uct=tNe(),yar=jct(),Sar=Bct(),bar=Gie();function Tar(l){return l.instrumentName==null&&l.instrumentType==null&&l.instrumentUnit==null&&l.meterName==null&&l.meterVersion==null&&l.meterSchemaUrl==null}var _Ne=class{constructor(c){var f;if(Tar(c))throw new Error("Cannot create view with no selector arguments supplied");if(c.name!=null&&(c?.instrumentName==null||har.PatternPredicate.hasWildcard(c.instrumentName)))throw new Error("Views with a specified name must be declared with an instrument selector that selects at most one instrument per meter.");c.attributeKeys!=null?this.attributesProcessor=new Uct.FilteringAttributesProcessor(c.attributeKeys):this.attributesProcessor=Uct.AttributesProcessor.Noop(),this.name=c.name,this.description=c.description,this.aggregation=(f=c.aggregation)!==null&&f!==void 0?f:bar.Aggregation.Default(),this.instrumentSelector=new yar.InstrumentSelector({name:c.instrumentName,type:c.instrumentType,unit:c.instrumentUnit}),this.meterSelector=new Sar.MeterSelector({name:c.meterName,version:c.meterVersion,schemaUrl:c.meterSchemaUrl})}};Hse.View=_Ne});var YL=xt(Gl=>{"use strict";Object.defineProperty(Gl,"__esModule",{value:!0});Gl.TimeoutError=Gl.View=Gl.Aggregation=Gl.SumAggregation=Gl.LastValueAggregation=Gl.HistogramAggregation=Gl.DropAggregation=Gl.ExponentialHistogramAggregation=Gl.ExplicitBucketHistogramAggregation=Gl.DefaultAggregation=Gl.MeterProvider=Gl.InstrumentType=Gl.ConsoleMetricExporter=Gl.InMemoryMetricExporter=Gl.PeriodicExportingMetricReader=Gl.MetricReader=Gl.DataPointType=Gl.AggregationTemporality=void 0;var Ear=Iie();Object.defineProperty(Gl,"AggregationTemporality",{enumerable:!0,get:function(){return Ear.AggregationTemporality}});var xar=AL();Object.defineProperty(Gl,"DataPointType",{enumerable:!0,get:function(){return xar.DataPointType}});var Car=iPe();Object.defineProperty(Gl,"MetricReader",{enumerable:!0,get:function(){return Car.MetricReader}});var Aar=Fot();Object.defineProperty(Gl,"PeriodicExportingMetricReader",{enumerable:!0,get:function(){return Aar.PeriodicExportingMetricReader}});var kar=Bot();Object.defineProperty(Gl,"InMemoryMetricExporter",{enumerable:!0,get:function(){return kar.InMemoryMetricExporter}});var Par=Vot();Object.defineProperty(Gl,"ConsoleMetricExporter",{enumerable:!0,get:function(){return Par.ConsoleMetricExporter}});var Nar=oP();Object.defineProperty(Gl,"InstrumentType",{enumerable:!0,get:function(){return Nar.InstrumentType}});var Dar=Lct();Object.defineProperty(Gl,"MeterProvider",{enumerable:!0,get:function(){return Dar.MeterProvider}});var hw=Gie();Object.defineProperty(Gl,"DefaultAggregation",{enumerable:!0,get:function(){return hw.DefaultAggregation}});Object.defineProperty(Gl,"ExplicitBucketHistogramAggregation",{enumerable:!0,get:function(){return hw.ExplicitBucketHistogramAggregation}});Object.defineProperty(Gl,"ExponentialHistogramAggregation",{enumerable:!0,get:function(){return hw.ExponentialHistogramAggregation}});Object.defineProperty(Gl,"DropAggregation",{enumerable:!0,get:function(){return hw.DropAggregation}});Object.defineProperty(Gl,"HistogramAggregation",{enumerable:!0,get:function(){return hw.HistogramAggregation}});Object.defineProperty(Gl,"LastValueAggregation",{enumerable:!0,get:function(){return hw.LastValueAggregation}});Object.defineProperty(Gl,"SumAggregation",{enumerable:!0,get:function(){return hw.SumAggregation}});Object.defineProperty(Gl,"Aggregation",{enumerable:!0,get:function(){return hw.Aggregation}});var war=Vct();Object.defineProperty(Gl,"View",{enumerable:!0,get:function(){return war.View}});var Iar=yC();Object.defineProperty(Gl,"TimeoutError",{enumerable:!0,get:function(){return Iar.TimeoutError}})});var fNe=xt(lz=>{"use strict";Object.defineProperty(lz,"__esModule",{value:!0});lz.AggregationTemporalityPreference=void 0;var Oar;(function(l){l[l.DELTA=0]="DELTA",l[l.CUMULATIVE=1]="CUMULATIVE",l[l.LOWMEMORY=2]="LOWMEMORY"})(Oar=lz.AggregationTemporalityPreference||(lz.AggregationTemporalityPreference={}))});var dNe=xt(dy=>{"use strict";Object.defineProperty(dy,"__esModule",{value:!0});dy.OTLPMetricExporterBase=dy.LowMemoryTemporalitySelector=dy.DeltaTemporalitySelector=dy.CumulativeTemporalitySelector=void 0;var Rar=py(),$m=YL(),Jct=fNe(),Mar=(zc(),fc(Xc)),Lar=()=>$m.AggregationTemporality.CUMULATIVE;dy.CumulativeTemporalitySelector=Lar;var Far=l=>{switch(l){case $m.InstrumentType.COUNTER:case $m.InstrumentType.OBSERVABLE_COUNTER:case $m.InstrumentType.GAUGE:case $m.InstrumentType.HISTOGRAM:case $m.InstrumentType.OBSERVABLE_GAUGE:return $m.AggregationTemporality.DELTA;case $m.InstrumentType.UP_DOWN_COUNTER:case $m.InstrumentType.OBSERVABLE_UP_DOWN_COUNTER:return $m.AggregationTemporality.CUMULATIVE}};dy.DeltaTemporalitySelector=Far;var jar=l=>{switch(l){case $m.InstrumentType.COUNTER:case $m.InstrumentType.HISTOGRAM:return $m.AggregationTemporality.DELTA;case $m.InstrumentType.GAUGE:case $m.InstrumentType.UP_DOWN_COUNTER:case $m.InstrumentType.OBSERVABLE_UP_DOWN_COUNTER:case $m.InstrumentType.OBSERVABLE_COUNTER:case $m.InstrumentType.OBSERVABLE_GAUGE:return $m.AggregationTemporality.CUMULATIVE}};dy.LowMemoryTemporalitySelector=jar;function Bar(){let l=(0,Rar.getEnv)(),c=l.OTEL_EXPORTER_OTLP_METRICS_TEMPORALITY_PREFERENCE.trim().toLowerCase();return c==="cumulative"?dy.CumulativeTemporalitySelector:c==="delta"?dy.DeltaTemporalitySelector:c==="lowmemory"?dy.LowMemoryTemporalitySelector:(Mar.diag.warn(`OTEL_EXPORTER_OTLP_METRICS_TEMPORALITY_PREFERENCE is set to '${l.OTEL_EXPORTER_OTLP_METRICS_TEMPORALITY_PREFERENCE}', but only 'cumulative' and 'delta' are allowed. Using default ('cumulative') instead.`),dy.CumulativeTemporalitySelector)}function Uar(l){return l!=null?l===Jct.AggregationTemporalityPreference.DELTA?dy.DeltaTemporalitySelector:l===Jct.AggregationTemporalityPreference.LOWMEMORY?dy.LowMemoryTemporalitySelector:dy.CumulativeTemporalitySelector:Bar()}function Var(l){return l?.aggregationPreference?l.aggregationPreference:c=>$m.Aggregation.Default()}var pNe=class{constructor(c,f){this._otlpExporter=c,this._aggregationSelector=Var(f),this._aggregationTemporalitySelector=Uar(f?.temporalityPreference)}export(c,f){this._otlpExporter.export([c],f)}async shutdown(){await this._otlpExporter.shutdown()}forceFlush(){return Promise.resolve()}selectAggregation(c){return this._aggregationSelector(c)}selectAggregationTemporality(c){return this._aggregationTemporalitySelector(c)}};dy.OTLPMetricExporterBase=pNe});var uz=xt(Bp=>{"use strict";Object.defineProperty(Bp,"__esModule",{value:!0});Bp.parseRetryAfterToMills=Bp.isExportRetryable=Bp.invalidTimeout=Bp.configureExporterTimeout=Bp.appendRootPathToUrlIfNeeded=Bp.appendResourcePathToUrl=Bp.parseHeaders=Bp.DEFAULT_EXPORT_BACKOFF_MULTIPLIER=Bp.DEFAULT_EXPORT_MAX_BACKOFF=Bp.DEFAULT_EXPORT_INITIAL_BACKOFF=Bp.DEFAULT_EXPORT_MAX_ATTEMPTS=void 0;var mNe=(zc(),fc(Xc)),qct=py(),zct=1e4;Bp.DEFAULT_EXPORT_MAX_ATTEMPTS=5;Bp.DEFAULT_EXPORT_INITIAL_BACKOFF=1e3;Bp.DEFAULT_EXPORT_MAX_BACKOFF=5e3;Bp.DEFAULT_EXPORT_BACKOFF_MULTIPLIER=1.5;function Jar(l={}){let c={};return Object.entries(l).forEach(([f,y])=>{typeof y<"u"?c[f]=String(y):mNe.diag.warn(`Header "${f}" has invalid value (${y}) and will be ignored`)}),c}Bp.parseHeaders=Jar;function qar(l,c){return l.endsWith("/")||(l=l+"/"),l+c}Bp.appendResourcePathToUrl=qar;function zar(l){try{let c=new URL(l);return c.pathname===""&&(c.pathname=c.pathname+"/"),c.toString()}catch{return mNe.diag.warn(`Could not parse export URL: '${l}'`),l}}Bp.appendRootPathToUrlIfNeeded=zar;function War(l){return typeof l=="number"?l<=0?gNe(l,zct):l:$ar()}Bp.configureExporterTimeout=War;function $ar(){var l;let c=Number((l=(0,qct.getEnv)().OTEL_EXPORTER_OTLP_TRACES_TIMEOUT)!==null&&l!==void 0?l:(0,qct.getEnv)().OTEL_EXPORTER_OTLP_TIMEOUT);return c<=0?gNe(c,zct):c}function gNe(l,c){return mNe.diag.warn("Timeout must be greater than 0",l),c}Bp.invalidTimeout=gNe;function Har(l){return[429,502,503,504].includes(l)}Bp.isExportRetryable=Har;function Gar(l){if(l==null)return-1;let c=Number.parseInt(l,10);if(Number.isInteger(c))return c>0?c*1e3:-1;let f=new Date(l).getTime()-Date.now();return f>=0?f:0}Bp.parseRetryAfterToMills=Gar});var Yse=xt(Gse=>{"use strict";Object.defineProperty(Gse,"__esModule",{value:!0});Gse.OTLPExporterBase=void 0;var Wct=(zc(),fc(Xc)),_z=py(),Yar=uz(),hNe=class{constructor(c={}){this._sendingPromises=[],this.url=this.getDefaultUrl(c),typeof c.hostname=="string"&&(this.hostname=c.hostname),this.shutdown=this.shutdown.bind(this),this._shutdownOnce=new _z.BindOnceFuture(this._shutdown,this),this._concurrencyLimit=typeof c.concurrencyLimit=="number"?c.concurrencyLimit:30,this.timeoutMillis=(0,Yar.configureExporterTimeout)(c.timeoutMillis),this.onInit(c)}export(c,f){if(this._shutdownOnce.isCalled){f({code:_z.ExportResultCode.FAILED,error:new Error("Exporter has been shutdown")});return}if(this._sendingPromises.length>=this._concurrencyLimit){f({code:_z.ExportResultCode.FAILED,error:new Error("Concurrent export limit reached")});return}this._export(c).then(()=>{f({code:_z.ExportResultCode.SUCCESS})}).catch(y=>{f({code:_z.ExportResultCode.FAILED,error:y})})}_export(c){return new Promise((f,y)=>{try{Wct.diag.debug("items to be sent",c),this.send(c,f,y)}catch(b){y(b)}})}shutdown(){return this._shutdownOnce.call()}forceFlush(){return Promise.all(this._sendingPromises).then(()=>{})}_shutdown(){return Wct.diag.debug("shutdown started"),this.onShutdown(),this.forceFlush()}};Gse.OTLPExporterBase=hNe});var yNe=xt(fz=>{"use strict";Object.defineProperty(fz,"__esModule",{value:!0});fz.CompressionAlgorithm=void 0;var Kar;(function(l){l.NONE="none",l.GZIP="gzip"})(Kar=fz.CompressionAlgorithm||(fz.CompressionAlgorithm={}))});var Hct=xt(Kse=>{"use strict";Object.defineProperty(Kse,"__esModule",{value:!0});Kse.configureCompression=void 0;var vNe=yNe(),$ct=py();function Xar(l){return l||(((0,$ct.getEnv)().OTEL_EXPORTER_OTLP_TRACES_COMPRESSION||(0,$ct.getEnv)().OTEL_EXPORTER_OTLP_COMPRESSION)===vNe.CompressionAlgorithm.GZIP?vNe.CompressionAlgorithm.GZIP:vNe.CompressionAlgorithm.NONE)}Kse.configureCompression=Xar});var Gct=xt(KL=>{"use strict";Object.defineProperty(KL,"__esModule",{value:!0});KL.parseRetryAfterToMills=KL.isExportRetryable=void 0;function Qar(l){return[429,502,503,504].includes(l)}KL.isExportRetryable=Qar;function Zar(l){if(l==null)return;let c=Number.parseInt(l,10);if(Number.isInteger(c))return c>0?c*1e3:-1;let f=new Date(l).getTime()-Date.now();return f>=0?f:0}KL.parseRetryAfterToMills=Zar});var pz=xt(Xse=>{"use strict";Object.defineProperty(Xse,"__esModule",{value:!0});Xse.OTLPExporterError=void 0;var SNe=class extends Error{constructor(c,f,y){super(c),this.name="OTLPExporterError",this.data=y,this.code=f}};Xse.OTLPExporterError=SNe});var Qct=xt(XL=>{"use strict";Object.defineProperty(XL,"__esModule",{value:!0});XL.createHttpAgent=XL.sendWithHttp=void 0;var Kct=Bu("http"),Xct=Bu("https"),eor=Bu("zlib"),tor=Bu("stream"),Yct=Gct(),ror=pz();function nor(l,c,f,y,b){let A=new URL(l.url),g=Number(process.versions.node.split(".")[0]),p={hostname:A.hostname,port:A.port,path:A.pathname,method:"POST",headers:Object.assign({},l.headers),agent:c},j=(A.protocol==="http:"?Kct.request:Xct.request)(p,ze=>{let ve=[];ze.on("data",lr=>ve.push(lr)),ze.on("end",()=>{if(ze.statusCode&&ze.statusCode<299)y({status:"success",data:Buffer.concat(ve)});else if(ze.statusCode&&(0,Yct.isExportRetryable)(ze.statusCode))y({status:"retryable",retryInMillis:(0,Yct.parseRetryAfterToMills)(ze.headers["retry-after"])});else{let lr=new ror.OTLPExporterError(ze.statusMessage,ze.statusCode);y({status:"failure",error:lr})}})});j.setTimeout(b,()=>{j.destroy(),y({status:"failure",error:new Error("Request Timeout")})}),j.on("error",ze=>{y({status:"failure",error:ze})});let se=g>=14?"close":"abort";j.on(se,()=>{y({status:"failure",error:new Error("Request timed out")})}),ior(j,l.compression,f,ze=>{y({status:"failure",error:ze})})}XL.sendWithHttp=nor;function ior(l,c,f,y){let b=sor(f);c==="gzip"&&(l.setHeader("Content-Encoding","gzip"),b=b.on("error",y).pipe(eor.createGzip()).on("error",y)),b.pipe(l)}function sor(l){let c=new tor.Readable;return c.push(l),c.push(null),c}function aor(l,c){let y=new URL(l).protocol==="http:"?Kct.Agent:Xct.Agent;return new y(c)}XL.createHttpAgent=aor});var Zct=xt(Qse=>{"use strict";Object.defineProperty(Qse,"__esModule",{value:!0});Qse.createHttpExporterTransport=void 0;var bNe=class{constructor(c){this._parameters=c,this._send=null,this._agent=null}async send(c,f){if(this._send==null){let{sendWithHttp:y,createHttpAgent:b}=Qct();this._agent=b(this._parameters.url,this._parameters.agentOptions),this._send=y}return new Promise(y=>{var b;(b=this._send)===null||b===void 0||b.call(this,this._parameters,this._agent,c,A=>{y(A)},f)})}shutdown(){}};function oor(l){return new bNe(l)}Qse.createHttpExporterTransport=oor});var ENe=xt(Zse=>{"use strict";Object.defineProperty(Zse,"__esModule",{value:!0});Zse.createRetryingTransport=void 0;var cor=5,lor=1e3,uor=5e3,_or=1.5,elt=.2;function por(){return Math.random()*(2*elt)-elt}var TNe=class{constructor(c){this._transport=c}retry(c,f,y){return new Promise((b,A)=>{setTimeout(()=>{this._transport.send(c,f).then(b,A)},y)})}async send(c,f){var y;let b=Date.now()+f,A=await this._transport.send(c,f),g=cor,p=lor;for(;A.status==="retryable"&&g>0;){g--;let k=Math.max(Math.min(p,uor)+por(),0);p=p*_or;let j=(y=A.retryInMillis)!==null&&y!==void 0?y:k,se=b-Date.now();if(j>se)return A;A=await this.retry(c,se,j)}return A}shutdown(){return this._transport.shutdown()}};function dor(l){return new TNe(l.transport)}Zse.createRetryingTransport=dor});var ilt=xt(eae=>{"use strict";Object.defineProperty(eae,"__esModule",{value:!0});eae.OTLPExporterNodeBase=void 0;var mor=Yse(),gor=Hct(),tlt=(zc(),fc(Xc)),rlt=py(),hor=Zct(),nlt=pz(),yor=ENe(),xNe=class extends mor.OTLPExporterBase{constructor(c={},f,y){var b;super(c),c.metadata&&tlt.diag.warn("Metadata cannot be set when using http"),this._serializer=f,c?.keepAlive!=null&&(c.httpAgentOptions!=null?c.httpAgentOptions.keepAlive==null&&(c.httpAgentOptions.keepAlive=c.keepAlive):c.httpAgentOptions={keepAlive:c.keepAlive});let A=rlt.baggageUtils.parseKeyPairsIntoRecord((0,rlt.getEnv)().OTEL_EXPORTER_OTLP_HEADERS);this._transport=(0,yor.createRetryingTransport)({transport:(0,hor.createHttpExporterTransport)({agentOptions:(b=c.httpAgentOptions)!==null&&b!==void 0?b:{keepAlive:!0},compression:(0,gor.configureCompression)(c.compression),headers:Object.assign({},A,y),url:this.url})})}onInit(c){}send(c,f,y){if(this._shutdownOnce.isCalled){tlt.diag.debug("Shutdown already started. Cannot send objects");return}let b=this._serializer.serializeRequest(c);if(b==null){y(new Error("Could not serialize message"));return}let A=this._transport.send(b,this.timeoutMillis).then(p=>{p.status==="success"?f():p.status==="failure"&&p.error?y(p.error):p.status==="retryable"?y(new nlt.OTLPExporterError("Export failed with retryable status")):y(new nlt.OTLPExporterError("Export failed with unknown error"))},y);this._sendingPromises.push(A);let g=()=>{let p=this._sendingPromises.indexOf(A);this._sendingPromises.splice(p,1)};A.then(g,g)}onShutdown(){}};eae.OTLPExporterNodeBase=xNe});var slt=xt(QL=>{"use strict";Object.defineProperty(QL,"__esModule",{value:!0});QL.CompressionAlgorithm=QL.OTLPExporterNodeBase=void 0;var vor=ilt();Object.defineProperty(QL,"OTLPExporterNodeBase",{enumerable:!0,get:function(){return vor.OTLPExporterNodeBase}});var Sor=yNe();Object.defineProperty(QL,"CompressionAlgorithm",{enumerable:!0,get:function(){return Sor.CompressionAlgorithm}})});var olt=xt(tae=>{"use strict";Object.defineProperty(tae,"__esModule",{value:!0});tae.createXhrTransport=void 0;var alt=uz(),bor=(zc(),fc(Xc)),CNe=class{constructor(c){this._parameters=c}send(c,f){return new Promise(y=>{let b=new XMLHttpRequest;b.timeout=f,b.open("POST",this._parameters.url),Object.entries(this._parameters.headers).forEach(([A,g])=>{b.setRequestHeader(A,g)}),b.ontimeout=A=>{y({status:"failure",error:new Error("XHR request timed out")})},b.onreadystatechange=()=>{b.status>=200&&b.status<=299?(bor.diag.debug("XHR success"),y({status:"success"})):b.status&&(0,alt.isExportRetryable)(b.status)?y({status:"retryable",retryInMillis:(0,alt.parseRetryAfterToMills)(b.getResponseHeader("Retry-After"))}):b.status!==0&&y({status:"failure",error:new Error("XHR request failed with non-retryable status")})},b.onabort=()=>{y({status:"failure",error:new Error("XHR request aborted")})},b.onerror=()=>{y({status:"failure",error:new Error("XHR request errored")})},b.send(new Blob([c],{type:this._parameters.headers["Content-Type"]}))})}shutdown(){}};function Tor(l){return new CNe(l)}tae.createXhrTransport=Tor});var clt=xt(rae=>{"use strict";Object.defineProperty(rae,"__esModule",{value:!0});rae.createSendBeaconTransport=void 0;var Eor=(zc(),fc(Xc)),ANe=class{constructor(c){this._params=c}send(c){return new Promise(f=>{navigator.sendBeacon(this._params.url,new Blob([c],{type:this._params.blobType}))?(Eor.diag.debug("SendBeacon success"),f({status:"success"})):f({status:"failure",error:new Error("SendBeacon failed")})})}shutdown(){}};function xor(l){return new ANe(l)}rae.createSendBeaconTransport=xor});var _lt=xt(nae=>{"use strict";Object.defineProperty(nae,"__esModule",{value:!0});nae.OTLPExporterBrowserBase=void 0;var Cor=Yse(),llt=pz(),Aor=uz(),kor=(zc(),fc(Xc)),ult=py(),Por=olt(),Nor=clt(),Dor=ENe(),kNe=class extends Cor.OTLPExporterBase{constructor(c={},f,y){super(c),this._serializer=f,!!c.headers||typeof navigator.sendBeacon!="function"?this._transport=(0,Dor.createRetryingTransport)({transport:(0,Por.createXhrTransport)({headers:Object.assign({},(0,Aor.parseHeaders)(c.headers),ult.baggageUtils.parseKeyPairsIntoRecord((0,ult.getEnv)().OTEL_EXPORTER_OTLP_HEADERS),{"Content-Type":y}),url:this.url})}):this._transport=(0,Nor.createSendBeaconTransport)({url:this.url,blobType:y})}onInit(){}onShutdown(){}send(c,f,y){if(this._shutdownOnce.isCalled){kor.diag.debug("Shutdown already started. Cannot send objects");return}let b=this._serializer.serializeRequest(c);if(b==null){y(new Error("Could not serialize message"));return}let A=this._transport.send(b,this.timeoutMillis).then(p=>{p.status==="success"?f():p.status==="failure"&&p.error?y(p.error):p.status==="retryable"?y(new llt.OTLPExporterError("Export failed with retryable status")):y(new llt.OTLPExporterError("Export failed with unknown error"))},y);this._sendingPromises.push(A);let g=()=>{let p=this._sendingPromises.indexOf(A);this._sendingPromises.splice(p,1)};A.then(g,g)}};nae.OTLPExporterBrowserBase=kNe});var flt=xt(iae=>{"use strict";Object.defineProperty(iae,"__esModule",{value:!0});iae.OTLPExporterBrowserBase=void 0;var wor=_lt();Object.defineProperty(iae,"OTLPExporterBrowserBase",{enumerable:!0,get:function(){return wor.OTLPExporterBrowserBase}})});var dlt=xt(yw=>{"use strict";Object.defineProperty(yw,"__esModule",{value:!0});yw.OTLPExporterBrowserBase=yw.CompressionAlgorithm=yw.OTLPExporterNodeBase=void 0;var plt=slt();Object.defineProperty(yw,"OTLPExporterNodeBase",{enumerable:!0,get:function(){return plt.OTLPExporterNodeBase}});Object.defineProperty(yw,"CompressionAlgorithm",{enumerable:!0,get:function(){return plt.CompressionAlgorithm}});var Ior=flt();Object.defineProperty(yw,"OTLPExporterBrowserBase",{enumerable:!0,get:function(){return Ior.OTLPExporterBrowserBase}})});var PNe=xt(bm=>{"use strict";var Oor=bm&&bm.__createBinding||(Object.create?function(l,c,f,y){y===void 0&&(y=f),Object.defineProperty(l,y,{enumerable:!0,get:function(){return c[f]}})}:function(l,c,f,y){y===void 0&&(y=f),l[y]=c[f]}),Ror=bm&&bm.__exportStar||function(l,c){for(var f in l)f!=="default"&&!Object.prototype.hasOwnProperty.call(c,f)&&Oor(c,l,f)};Object.defineProperty(bm,"__esModule",{value:!0});bm.invalidTimeout=bm.configureExporterTimeout=bm.appendRootPathToUrlIfNeeded=bm.appendResourcePathToUrl=bm.parseHeaders=bm.OTLPExporterError=bm.OTLPExporterBase=void 0;Ror(dlt(),bm);var Mor=Yse();Object.defineProperty(bm,"OTLPExporterBase",{enumerable:!0,get:function(){return Mor.OTLPExporterBase}});var Lor=pz();Object.defineProperty(bm,"OTLPExporterError",{enumerable:!0,get:function(){return Lor.OTLPExporterError}});var dz=uz();Object.defineProperty(bm,"parseHeaders",{enumerable:!0,get:function(){return dz.parseHeaders}});Object.defineProperty(bm,"appendResourcePathToUrl",{enumerable:!0,get:function(){return dz.appendResourcePathToUrl}});Object.defineProperty(bm,"appendRootPathToUrlIfNeeded",{enumerable:!0,get:function(){return dz.appendRootPathToUrlIfNeeded}});Object.defineProperty(bm,"configureExporterTimeout",{enumerable:!0,get:function(){return dz.configureExporterTimeout}});Object.defineProperty(bm,"invalidTimeout",{enumerable:!0,get:function(){return dz.invalidTimeout}})});var mz=xt(PT=>{"use strict";Object.defineProperty(PT,"__esModule",{value:!0});PT.getOtlpEncoder=PT.encodeAsString=PT.encodeAsLongBits=PT.toLongBits=PT.hrTimeToNanos=void 0;var sae=py();function NNe(l){let c=BigInt(1e9);return BigInt(l[0])*c+BigInt(l[1])}PT.hrTimeToNanos=NNe;function glt(l){let c=Number(BigInt.asUintN(32,l)),f=Number(BigInt.asUintN(32,l>>BigInt(32)));return{low:c,high:f}}PT.toLongBits=glt;function DNe(l){let c=NNe(l);return glt(c)}PT.encodeAsLongBits=DNe;function hlt(l){return NNe(l).toString()}PT.encodeAsString=hlt;var For=typeof BigInt<"u"?hlt:sae.hrTimeToNanoseconds;function mlt(l){return l}function ylt(l){if(l!==void 0)return(0,sae.hexToBinary)(l)}var jor={encodeHrTime:DNe,encodeSpanContext:sae.hexToBinary,encodeOptionalSpanContext:ylt};function Bor(l){var c,f;if(l===void 0)return jor;let y=(c=l.useLongBits)!==null&&c!==void 0?c:!0,b=(f=l.useHex)!==null&&f!==void 0?f:!1;return{encodeHrTime:y?DNe:For,encodeSpanContext:b?mlt:sae.hexToBinary,encodeOptionalSpanContext:b?mlt:ylt}}PT.getOtlpEncoder=Bor});var vlt=xt(gz=>{"use strict";Object.defineProperty(gz,"__esModule",{value:!0});gz.ESpanKind=void 0;var Uor;(function(l){l[l.SPAN_KIND_UNSPECIFIED=0]="SPAN_KIND_UNSPECIFIED",l[l.SPAN_KIND_INTERNAL=1]="SPAN_KIND_INTERNAL",l[l.SPAN_KIND_SERVER=2]="SPAN_KIND_SERVER",l[l.SPAN_KIND_CLIENT=3]="SPAN_KIND_CLIENT",l[l.SPAN_KIND_PRODUCER=4]="SPAN_KIND_PRODUCER",l[l.SPAN_KIND_CONSUMER=5]="SPAN_KIND_CONSUMER"})(Uor=gz.ESpanKind||(gz.ESpanKind={}))});var ZL=xt(bC=>{"use strict";Object.defineProperty(bC,"__esModule",{value:!0});bC.toAnyValue=bC.toKeyValue=bC.toAttributes=bC.createInstrumentationScope=void 0;function Vor(l){return{name:l.name,version:l.version}}bC.createInstrumentationScope=Vor;function Jor(l){return Object.keys(l).map(c=>wNe(c,l[c]))}bC.toAttributes=Jor;function wNe(l,c){return{key:l,value:INe(c)}}bC.toKeyValue=wNe;function INe(l){let c=typeof l;return c==="string"?{stringValue:l}:c==="number"?Number.isInteger(l)?{intValue:l}:{doubleValue:l}:c==="boolean"?{boolValue:l}:l instanceof Uint8Array?{bytesValue:l}:Array.isArray(l)?{arrayValue:{values:l.map(INe)}}:c==="object"&&l!=null?{kvlistValue:{values:Object.entries(l).map(([f,y])=>wNe(f,y))}}:{}}bC.toAnyValue=INe});var Tlt=xt(vw=>{"use strict";Object.defineProperty(vw,"__esModule",{value:!0});vw.toOtlpSpanEvent=vw.toOtlpLink=vw.sdkSpanToOtlpSpan=void 0;var ONe=ZL();function qor(l,c){var f;let y=l.spanContext(),b=l.status;return{traceId:c.encodeSpanContext(y.traceId),spanId:c.encodeSpanContext(y.spanId),parentSpanId:c.encodeOptionalSpanContext(l.parentSpanId),traceState:(f=y.traceState)===null||f===void 0?void 0:f.serialize(),name:l.name,kind:l.kind==null?0:l.kind+1,startTimeUnixNano:c.encodeHrTime(l.startTime),endTimeUnixNano:c.encodeHrTime(l.endTime),attributes:(0,ONe.toAttributes)(l.attributes),droppedAttributesCount:l.droppedAttributesCount,events:l.events.map(A=>blt(A,c)),droppedEventsCount:l.droppedEventsCount,status:{code:b.code,message:b.message},links:l.links.map(A=>Slt(A,c)),droppedLinksCount:l.droppedLinksCount}}vw.sdkSpanToOtlpSpan=qor;function Slt(l,c){var f;return{attributes:l.attributes?(0,ONe.toAttributes)(l.attributes):[],spanId:c.encodeSpanContext(l.context.spanId),traceId:c.encodeSpanContext(l.context.traceId),traceState:(f=l.context.traceState)===null||f===void 0?void 0:f.serialize(),droppedAttributesCount:l.droppedAttributesCount||0}}vw.toOtlpLink=Slt;function blt(l,c){return{attributes:l.attributes?(0,ONe.toAttributes)(l.attributes):[],name:l.name,timeUnixNano:c.encodeHrTime(l.time),droppedAttributesCount:l.droppedAttributesCount||0}}vw.toOtlpSpanEvent=blt});var oae=xt(aae=>{"use strict";Object.defineProperty(aae,"__esModule",{value:!0});aae.createResource=void 0;var zor=ZL();function Wor(l){return{attributes:(0,zor.toAttributes)(l.attributes),droppedAttributesCount:0}}aae.createResource=Wor});var lae=xt(cae=>{"use strict";Object.defineProperty(cae,"__esModule",{value:!0});cae.createExportTraceServiceRequest=void 0;var $or=Tlt(),Hor=mz(),Gor=ZL(),Yor=oae();function Kor(l,c){let f=(0,Hor.getOtlpEncoder)(c);return{resourceSpans:Qor(l,f)}}cae.createExportTraceServiceRequest=Kor;function Xor(l){let c=new Map;for(let f of l){let y=c.get(f.resource);y||(y=new Map,c.set(f.resource,y));let b=`${f.instrumentationLibrary.name}@${f.instrumentationLibrary.version||""}:${f.instrumentationLibrary.schemaUrl||""}`,A=y.get(b);A||(A=[],y.set(b,A)),A.push(f)}return c}function Qor(l,c){let f=Xor(l),y=[],b=f.entries(),A=b.next();for(;!A.done;){let[g,p]=A.value,k=[],j=p.values(),se=j.next();for(;!se.done;){let ve=se.value;if(ve.length>0){let lr=ve.map(Br=>(0,$or.sdkSpanToOtlpSpan)(Br,c));k.push({scope:(0,Gor.createInstrumentationScope)(ve[0].instrumentationLibrary),spans:lr,schemaUrl:ve[0].instrumentationLibrary.schemaUrl})}se=j.next()}let ze={resource:(0,Yor.createResource)(g),scopeSpans:k,schemaUrl:void 0};y.push(ze),A=b.next()}return y}});var klt=xt(Sw=>{"use strict";Object.defineProperty(Sw,"__esModule",{value:!0});Sw.toMetric=Sw.toScopeMetrics=Sw.toResourceMetrics=void 0;var Elt=(zc(),fc(Xc)),eF=YL(),Zor=mz(),uae=ZL(),ecr=oae();function tcr(l,c){let f=(0,Zor.getOtlpEncoder)(c);return{resource:(0,ecr.createResource)(l.resource),schemaUrl:void 0,scopeMetrics:Clt(l.scopeMetrics,f)}}Sw.toResourceMetrics=tcr;function Clt(l,c){return Array.from(l.map(f=>({scope:(0,uae.createInstrumentationScope)(f.scope),metrics:f.metrics.map(y=>Alt(y,c)),schemaUrl:f.scope.schemaUrl})))}Sw.toScopeMetrics=Clt;function Alt(l,c){let f={name:l.descriptor.name,description:l.descriptor.description,unit:l.descriptor.unit},y=scr(l.aggregationTemporality);switch(l.dataPointType){case eF.DataPointType.SUM:f.sum={aggregationTemporality:y,isMonotonic:l.isMonotonic,dataPoints:xlt(l,c)};break;case eF.DataPointType.GAUGE:f.gauge={dataPoints:xlt(l,c)};break;case eF.DataPointType.HISTOGRAM:f.histogram={aggregationTemporality:y,dataPoints:ncr(l,c)};break;case eF.DataPointType.EXPONENTIAL_HISTOGRAM:f.exponentialHistogram={aggregationTemporality:y,dataPoints:icr(l,c)};break}return f}Sw.toMetric=Alt;function rcr(l,c,f){let y={attributes:(0,uae.toAttributes)(l.attributes),startTimeUnixNano:f.encodeHrTime(l.startTime),timeUnixNano:f.encodeHrTime(l.endTime)};switch(c){case Elt.ValueType.INT:y.asInt=l.value;break;case Elt.ValueType.DOUBLE:y.asDouble=l.value;break}return y}function xlt(l,c){return l.dataPoints.map(f=>rcr(f,l.descriptor.valueType,c))}function ncr(l,c){return l.dataPoints.map(f=>{let y=f.value;return{attributes:(0,uae.toAttributes)(f.attributes),bucketCounts:y.buckets.counts,explicitBounds:y.buckets.boundaries,count:y.count,sum:y.sum,min:y.min,max:y.max,startTimeUnixNano:c.encodeHrTime(f.startTime),timeUnixNano:c.encodeHrTime(f.endTime)}})}function icr(l,c){return l.dataPoints.map(f=>{let y=f.value;return{attributes:(0,uae.toAttributes)(f.attributes),count:y.count,min:y.min,max:y.max,sum:y.sum,positive:{offset:y.positive.offset,bucketCounts:y.positive.bucketCounts},negative:{offset:y.negative.offset,bucketCounts:y.negative.bucketCounts},scale:y.scale,zeroCount:y.zeroCount,startTimeUnixNano:c.encodeHrTime(f.startTime),timeUnixNano:c.encodeHrTime(f.endTime)}})}function scr(l){switch(l){case eF.AggregationTemporality.DELTA:return 1;case eF.AggregationTemporality.CUMULATIVE:return 2}}});var fae=xt(_ae=>{"use strict";Object.defineProperty(_ae,"__esModule",{value:!0});_ae.createExportMetricsServiceRequest=void 0;var acr=klt();function ocr(l,c){return{resourceMetrics:l.map(f=>(0,acr.toResourceMetrics)(f,c))}}_ae.createExportMetricsServiceRequest=ocr});var pae=xt(tF=>{"use strict";Object.defineProperty(tF,"__esModule",{value:!0});tF.toLogAttributes=tF.createExportLogsServiceRequest=void 0;var ccr=mz(),RNe=ZL(),lcr=oae();function ucr(l,c){let f=(0,ccr.getOtlpEncoder)(c);return{resourceLogs:fcr(l,f)}}tF.createExportLogsServiceRequest=ucr;function _cr(l){let c=new Map;for(let f of l){let{resource:y,instrumentationScope:{name:b,version:A="",schemaUrl:g=""}}=f,p=c.get(y);p||(p=new Map,c.set(y,p));let k=`${b}@${A}:${g}`,j=p.get(k);j||(j=[],p.set(k,j)),j.push(f)}return c}function fcr(l,c){let f=_cr(l);return Array.from(f,([y,b])=>({resource:(0,lcr.createResource)(y),scopeLogs:Array.from(b,([,A])=>({scope:(0,RNe.createInstrumentationScope)(A[0].instrumentationScope),logRecords:A.map(g=>pcr(g,c)),schemaUrl:A[0].instrumentationScope.schemaUrl})),schemaUrl:void 0}))}function pcr(l,c){var f,y,b;return{timeUnixNano:c.encodeHrTime(l.hrTime),observedTimeUnixNano:c.encodeHrTime(l.hrTimeObserved),severityNumber:l.severityNumber,severityText:l.severityText,body:(0,RNe.toAnyValue)(l.body),attributes:Plt(l.attributes),droppedAttributesCount:l.droppedAttributesCount,flags:(f=l.spanContext)===null||f===void 0?void 0:f.traceFlags,traceId:c.encodeOptionalSpanContext((y=l.spanContext)===null||y===void 0?void 0:y.traceId),spanId:c.encodeOptionalSpanContext((b=l.spanContext)===null||b===void 0?void 0:b.spanId)}}function Plt(l){return Object.keys(l).map(c=>(0,RNe.toKeyValue)(c,l[c]))}tF.toLogAttributes=Plt});var Dlt=xt((NAr,Nlt)=>{"use strict";Nlt.exports=dcr;function dcr(l,c){for(var f=new Array(arguments.length-1),y=0,b=2,A=!0;b<arguments.length;)f[y++]=arguments[b++];return new Promise(function(p,k){f[y]=function(se){if(A)if(A=!1,se)k(se);else{for(var ze=new Array(arguments.length-1),ve=0;ve<ze.length;)ze[ve++]=arguments[ve];p.apply(null,ze)}};try{l.apply(c||null,f)}catch(j){A&&(A=!1,k(j))}})}});var Rlt=xt(Olt=>{"use strict";var dae=Olt;dae.length=function(c){var f=c.length;if(!f)return 0;for(var y=0;--f%4>1&&c.charAt(f)==="=";)++y;return Math.ceil(c.length*3)/4-y};var rF=new Array(64),Ilt=new Array(123);for(vx=0;vx<64;)Ilt[rF[vx]=vx<26?vx+65:vx<52?vx+71:vx<62?vx-4:vx-59|43]=vx++;var vx;dae.encode=function(c,f,y){for(var b=null,A=[],g=0,p=0,k;f<y;){var j=c[f++];switch(p){case 0:A[g++]=rF[j>>2],k=(j&3)<<4,p=1;break;case 1:A[g++]=rF[k|j>>4],k=(j&15)<<2,p=2;break;case 2:A[g++]=rF[k|j>>6],A[g++]=rF[j&63],p=0;break}g>8191&&((b||(b=[])).push(String.fromCharCode.apply(String,A)),g=0)}return p&&(A[g++]=rF[k],A[g++]=61,p===1&&(A[g++]=61)),b?(g&&b.push(String.fromCharCode.apply(String,A.slice(0,g))),b.join("")):String.fromCharCode.apply(String,A.slice(0,g))};var wlt="invalid encoding";dae.decode=function(c,f,y){for(var b=y,A=0,g,p=0;p<c.length;){var k=c.charCodeAt(p++);if(k===61&&A>1)break;if((k=Ilt[k])===void 0)throw Error(wlt);switch(A){case 0:g=k,A=1;break;case 1:f[y++]=g<<2|(k&48)>>4,g=k,A=2;break;case 2:f[y++]=(g&15)<<4|(k&60)>>2,g=k,A=3;break;case 3:f[y++]=(g&3)<<6|k,A=0;break}}if(A===1)throw Error(wlt);return y-b};dae.test=function(c){return/^(?:[A-Za-z0-9+/]{4})*(?:[A-Za-z0-9+/]{2}==|[A-Za-z0-9+/]{3}=)?$/.test(c)}});var Llt=xt((wAr,Mlt)=>{"use strict";Mlt.exports=mae;function mae(){this._listeners={}}mae.prototype.on=function(c,f,y){return(this._listeners[c]||(this._listeners[c]=[])).push({fn:f,ctx:y||this}),this};mae.prototype.off=function(c,f){if(c===void 0)this._listeners={};else if(f===void 0)this._listeners[c]=[];else for(var y=this._listeners[c],b=0;b<y.length;)y[b].fn===f?y.splice(b,1):++b;return this};mae.prototype.emit=function(c){var f=this._listeners[c];if(f){for(var y=[],b=1;b<arguments.length;)y.push(arguments[b++]);for(b=0;b<f.length;)f[b].fn.apply(f[b++].ctx,y)}return this}});var qlt=xt((IAr,Jlt)=>{"use strict";Jlt.exports=Flt(Flt);function Flt(l){return typeof Float32Array<"u"?function(){var c=new Float32Array([-0]),f=new Uint8Array(c.buffer),y=f[3]===128;function b(k,j,se){c[0]=k,j[se]=f[0],j[se+1]=f[1],j[se+2]=f[2],j[se+3]=f[3]}function A(k,j,se){c[0]=k,j[se]=f[3],j[se+1]=f[2],j[se+2]=f[1],j[se+3]=f[0]}l.writeFloatLE=y?b:A,l.writeFloatBE=y?A:b;function g(k,j){return f[0]=k[j],f[1]=k[j+1],f[2]=k[j+2],f[3]=k[j+3],c[0]}function p(k,j){return f[3]=k[j],f[2]=k[j+1],f[1]=k[j+2],f[0]=k[j+3],c[0]}l.readFloatLE=y?g:p,l.readFloatBE=y?p:g}():function(){function c(y,b,A,g){var p=b<0?1:0;if(p&&(b=-b),b===0)y(1/b>0?0:2147483648,A,g);else if(isNaN(b))y(2143289344,A,g);else if(b>34028234663852886e22)y((p<<31|2139095040)>>>0,A,g);else if(b<11754943508222875e-54)y((p<<31|Math.round(b/1401298464324817e-60))>>>0,A,g);else{var k=Math.floor(Math.log(b)/Math.LN2),j=Math.round(b*Math.pow(2,-k)*8388608)&8388607;y((p<<31|k+127<<23|j)>>>0,A,g)}}l.writeFloatLE=c.bind(null,jlt),l.writeFloatBE=c.bind(null,Blt);function f(y,b,A){var g=y(b,A),p=(g>>31)*2+1,k=g>>>23&255,j=g&8388607;return k===255?j?NaN:p*(1/0):k===0?p*1401298464324817e-60*j:p*Math.pow(2,k-150)*(j+8388608)}l.readFloatLE=f.bind(null,Ult),l.readFloatBE=f.bind(null,Vlt)}(),typeof Float64Array<"u"?function(){var c=new Float64Array([-0]),f=new Uint8Array(c.buffer),y=f[7]===128;function b(k,j,se){c[0]=k,j[se]=f[0],j[se+1]=f[1],j[se+2]=f[2],j[se+3]=f[3],j[se+4]=f[4],j[se+5]=f[5],j[se+6]=f[6],j[se+7]=f[7]}function A(k,j,se){c[0]=k,j[se]=f[7],j[se+1]=f[6],j[se+2]=f[5],j[se+3]=f[4],j[se+4]=f[3],j[se+5]=f[2],j[se+6]=f[1],j[se+7]=f[0]}l.writeDoubleLE=y?b:A,l.writeDoubleBE=y?A:b;function g(k,j){return f[0]=k[j],f[1]=k[j+1],f[2]=k[j+2],f[3]=k[j+3],f[4]=k[j+4],f[5]=k[j+5],f[6]=k[j+6],f[7]=k[j+7],c[0]}function p(k,j){return f[7]=k[j],f[6]=k[j+1],f[5]=k[j+2],f[4]=k[j+3],f[3]=k[j+4],f[2]=k[j+5],f[1]=k[j+6],f[0]=k[j+7],c[0]}l.readDoubleLE=y?g:p,l.readDoubleBE=y?p:g}():function(){function c(y,b,A,g,p,k){var j=g<0?1:0;if(j&&(g=-g),g===0)y(0,p,k+b),y(1/g>0?0:2147483648,p,k+A);else if(isNaN(g))y(0,p,k+b),y(2146959360,p,k+A);else if(g>17976931348623157e292)y(0,p,k+b),y((j<<31|2146435072)>>>0,p,k+A);else{var se;if(g<22250738585072014e-324)se=g/5e-324,y(se>>>0,p,k+b),y((j<<31|se/4294967296)>>>0,p,k+A);else{var ze=Math.floor(Math.log(g)/Math.LN2);ze===1024&&(ze=1023),se=g*Math.pow(2,-ze),y(se*4503599627370496>>>0,p,k+b),y((j<<31|ze+1023<<20|se*1048576&1048575)>>>0,p,k+A)}}}l.writeDoubleLE=c.bind(null,jlt,0,4),l.writeDoubleBE=c.bind(null,Blt,4,0);function f(y,b,A,g,p){var k=y(g,p+b),j=y(g,p+A),se=(j>>31)*2+1,ze=j>>>20&2047,ve=4294967296*(j&1048575)+k;return ze===2047?ve?NaN:se*(1/0):ze===0?se*5e-324*ve:se*Math.pow(2,ze-1075)*(ve+4503599627370496)}l.readDoubleLE=f.bind(null,Ult,0,4),l.readDoubleBE=f.bind(null,Vlt,4,0)}(),l}function jlt(l,c,f){c[f]=l&255,c[f+1]=l>>>8&255,c[f+2]=l>>>16&255,c[f+3]=l>>>24}function Blt(l,c,f){c[f]=l>>>24,c[f+1]=l>>>16&255,c[f+2]=l>>>8&255,c[f+3]=l&255}function Ult(l,c){return(l[c]|l[c+1]<<8|l[c+2]<<16|l[c+3]<<24)>>>0}function Vlt(l,c){return(l[c]<<24|l[c+1]<<16|l[c+2]<<8|l[c+3])>>>0}});var zlt=xt((exports,module)=>{"use strict";module.exports=inquire;function inquire(moduleName){try{var mod=eval("quire".replace(/^/,"re"))(moduleName);if(mod&&(mod.length||Object.keys(mod).length))return mod}catch(l){}return null}});var $lt=xt(Wlt=>{"use strict";var MNe=Wlt;MNe.length=function(c){for(var f=0,y=0,b=0;b<c.length;++b)y=c.charCodeAt(b),y<128?f+=1:y<2048?f+=2:(y&64512)===55296&&(c.charCodeAt(b+1)&64512)===56320?(++b,f+=4):f+=3;return f};MNe.read=function(c,f,y){var b=y-f;if(b<1)return"";for(var A=null,g=[],p=0,k;f<y;)k=c[f++],k<128?g[p++]=k:k>191&&k<224?g[p++]=(k&31)<<6|c[f++]&63:k>239&&k<365?(k=((k&7)<<18|(c[f++]&63)<<12|(c[f++]&63)<<6|c[f++]&63)-65536,g[p++]=55296+(k>>10),g[p++]=56320+(k&1023)):g[p++]=(k&15)<<12|(c[f++]&63)<<6|c[f++]&63,p>8191&&((A||(A=[])).push(String.fromCharCode.apply(String,g)),p=0);return A?(p&&A.push(String.fromCharCode.apply(String,g.slice(0,p))),A.join("")):String.fromCharCode.apply(String,g.slice(0,p))};MNe.write=function(c,f,y){for(var b=y,A,g,p=0;p<c.length;++p)A=c.charCodeAt(p),A<128?f[y++]=A:A<2048?(f[y++]=A>>6|192,f[y++]=A&63|128):(A&64512)===55296&&((g=c.charCodeAt(p+1))&64512)===56320?(A=65536+((A&1023)<<10)+(g&1023),++p,f[y++]=A>>18|240,f[y++]=A>>12&63|128,f[y++]=A>>6&63|128,f[y++]=A&63|128):(f[y++]=A>>12|224,f[y++]=A>>6&63|128,f[y++]=A&63|128);return y-b}});var Glt=xt((RAr,Hlt)=>{"use strict";Hlt.exports=mcr;function mcr(l,c,f){var y=f||8192,b=y>>>1,A=null,g=y;return function(k){if(k<1||k>b)return l(k);g+k>y&&(A=l(y),g=0);var j=c.call(A,g,g+=k);return g&7&&(g=(g|7)+1),j}}});var Klt=xt((MAr,Ylt)=>{"use strict";Ylt.exports=kh;var hz=Tw();function kh(l,c){this.lo=l>>>0,this.hi=c>>>0}var F4=kh.zero=new kh(0,0);F4.toNumber=function(){return 0};F4.zzEncode=F4.zzDecode=function(){return this};F4.length=function(){return 1};var gcr=kh.zeroHash="\0\0\0\0\0\0\0\0";kh.fromNumber=function(c){if(c===0)return F4;var f=c<0;f&&(c=-c);var y=c>>>0,b=(c-y)/4294967296>>>0;return f&&(b=~b>>>0,y=~y>>>0,++y>4294967295&&(y=0,++b>4294967295&&(b=0))),new kh(y,b)};kh.from=function(c){if(typeof c=="number")return kh.fromNumber(c);if(hz.isString(c))if(hz.Long)c=hz.Long.fromString(c);else return kh.fromNumber(parseInt(c,10));return c.low||c.high?new kh(c.low>>>0,c.high>>>0):F4};kh.prototype.toNumber=function(c){if(!c&&this.hi>>>31){var f=~this.lo+1>>>0,y=~this.hi>>>0;return f||(y=y+1>>>0),-(f+y*4294967296)}return this.lo+this.hi*4294967296};kh.prototype.toLong=function(c){return hz.Long?new hz.Long(this.lo|0,this.hi|0,!!c):{low:this.lo|0,high:this.hi|0,unsigned:!!c}};var bw=String.prototype.charCodeAt;kh.fromHash=function(c){return c===gcr?F4:new kh((bw.call(c,0)|bw.call(c,1)<<8|bw.call(c,2)<<16|bw.call(c,3)<<24)>>>0,(bw.call(c,4)|bw.call(c,5)<<8|bw.call(c,6)<<16|bw.call(c,7)<<24)>>>0)};kh.prototype.toHash=function(){return String.fromCharCode(this.lo&255,this.lo>>>8&255,this.lo>>>16&255,this.lo>>>24,this.hi&255,this.hi>>>8&255,this.hi>>>16&255,this.hi>>>24)};kh.prototype.zzEncode=function(){var c=this.hi>>31;return this.hi=((this.hi<<1|this.lo>>>31)^c)>>>0,this.lo=(this.lo<<1^c)>>>0,this};kh.prototype.zzDecode=function(){var c=-(this.lo&1);return this.lo=((this.lo>>>1|this.hi<<31)^c)>>>0,this.hi=(this.hi>>>1^c)>>>0,this};kh.prototype.length=function(){var c=this.lo,f=(this.lo>>>28|this.hi<<4)>>>0,y=this.hi>>>24;return y===0?f===0?c<16384?c<128?1:2:c<2097152?3:4:f<16384?f<128?5:6:f<2097152?7:8:y<128?9:10}});var Tw=xt(LNe=>{"use strict";var Io=LNe;Io.asPromise=Dlt();Io.base64=Rlt();Io.EventEmitter=Llt();Io.float=qlt();Io.inquire=zlt();Io.utf8=$lt();Io.pool=Glt();Io.LongBits=Klt();Io.isNode=!!(typeof global<"u"&&global&&global.process&&global.process.versions&&global.process.versions.node);Io.global=Io.isNode&&global||typeof window<"u"&&window||typeof self<"u"&&self||LNe;Io.emptyArray=Object.freeze?Object.freeze([]):[];Io.emptyObject=Object.freeze?Object.freeze({}):{};Io.isInteger=Number.isInteger||function(c){return typeof c=="number"&&isFinite(c)&&Math.floor(c)===c};Io.isString=function(c){return typeof c=="string"||c instanceof String};Io.isObject=function(c){return c&&typeof c=="object"};Io.isset=Io.isSet=function(c,f){var y=c[f];return y!=null&&c.hasOwnProperty(f)?typeof y!="object"||(Array.isArray(y)?y.length:Object.keys(y).length)>0:!1};Io.Buffer=function(){try{var l=Io.inquire("buffer").Buffer;return l.prototype.utf8Write?l:null}catch{return null}}();Io._Buffer_from=null;Io._Buffer_allocUnsafe=null;Io.newBuffer=function(c){return typeof c=="number"?Io.Buffer?Io._Buffer_allocUnsafe(c):new Io.Array(c):Io.Buffer?Io._Buffer_from(c):typeof Uint8Array>"u"?c:new Uint8Array(c)};Io.Array=typeof Uint8Array<"u"?Uint8Array:Array;Io.Long=Io.global.dcodeIO&&Io.global.dcodeIO.Long||Io.global.Long||Io.inquire("long");Io.key2Re=/^true|false|0|1$/;Io.key32Re=/^-?(?:0|[1-9][0-9]*)$/;Io.key64Re=/^(?:[\\x00-\\xff]{8}|-?(?:0|[1-9][0-9]*))$/;Io.longToHash=function(c){return c?Io.LongBits.from(c).toHash():Io.LongBits.zeroHash};Io.longFromHash=function(c,f){var y=Io.LongBits.fromHash(c);return Io.Long?Io.Long.fromBits(y.lo,y.hi,f):y.toNumber(!!f)};function Xlt(l,c,f){for(var y=Object.keys(c),b=0;b<y.length;++b)(l[y[b]]===void 0||!f)&&(l[y[b]]=c[y[b]]);return l}Io.merge=Xlt;Io.lcFirst=function(c){return c.charAt(0).toLowerCase()+c.substring(1)};function Qlt(l){function c(f,y){if(!(this instanceof c))return new c(f,y);Object.defineProperty(this,"message",{get:function(){return f}}),Error.captureStackTrace?Error.captureStackTrace(this,c):Object.defineProperty(this,"stack",{value:new Error().stack||""}),y&&Xlt(this,y)}return c.prototype=Object.create(Error.prototype,{constructor:{value:c,writable:!0,enumerable:!1,configurable:!0},name:{get:function(){return l},set:void 0,enumerable:!1,configurable:!0},toString:{value:function(){return this.name+": "+this.message},writable:!0,enumerable:!1,configurable:!0}}),c}Io.newError=Qlt;Io.ProtocolError=Qlt("ProtocolError");Io.oneOfGetter=function(c){for(var f={},y=0;y<c.length;++y)f[c[y]]=1;return function(){for(var b=Object.keys(this),A=b.length-1;A>-1;--A)if(f[b[A]]===1&&this[b[A]]!==void 0&&this[b[A]]!==null)return b[A]}};Io.oneOfSetter=function(c){return function(f){for(var y=0;y<c.length;++y)c[y]!==f&&delete this[c[y]]}};Io.toJSONOptions={longs:String,enums:String,bytes:String,json:!0};Io._configure=function(){var l=Io.Buffer;if(!l){Io._Buffer_from=Io._Buffer_allocUnsafe=null;return}Io._Buffer_from=l.from!==Uint8Array.from&&l.from||function(f,y){return new l(f,y)},Io._Buffer_allocUnsafe=l.allocUnsafe||function(f){return new l(f)}}});var qNe=xt((FAr,rut)=>{"use strict";rut.exports=Uu;var NT=Tw(),FNe,gae=NT.LongBits,Zlt=NT.base64,eut=NT.utf8;function yz(l,c,f){this.fn=l,this.len=c,this.next=void 0,this.val=f}function BNe(){}function hcr(l){this.head=l.head,this.tail=l.tail,this.len=l.len,this.next=l.states}function Uu(){this.len=0,this.head=new yz(BNe,0,0),this.tail=this.head,this.states=null}var tut=function(){return NT.Buffer?function(){return(Uu.create=function(){return new FNe})()}:function(){return new Uu}};Uu.create=tut();Uu.alloc=function(c){return new NT.Array(c)};NT.Array!==Array&&(Uu.alloc=NT.pool(Uu.alloc,NT.Array.prototype.subarray));Uu.prototype._push=function(c,f,y){return this.tail=this.tail.next=new yz(c,f,y),this.len+=f,this};function UNe(l,c,f){c[f]=l&255}function ycr(l,c,f){for(;l>127;)c[f++]=l&127|128,l>>>=7;c[f]=l}function VNe(l,c){this.len=l,this.next=void 0,this.val=c}VNe.prototype=Object.create(yz.prototype);VNe.prototype.fn=ycr;Uu.prototype.uint32=function(c){return this.len+=(this.tail=this.tail.next=new VNe((c=c>>>0)<128?1:c<16384?2:c<2097152?3:c<268435456?4:5,c)).len,this};Uu.prototype.int32=function(c){return c<0?this._push(JNe,10,gae.fromNumber(c)):this.uint32(c)};Uu.prototype.sint32=function(c){return this.uint32((c<<1^c>>31)>>>0)};function JNe(l,c,f){for(;l.hi;)c[f++]=l.lo&127|128,l.lo=(l.lo>>>7|l.hi<<25)>>>0,l.hi>>>=7;for(;l.lo>127;)c[f++]=l.lo&127|128,l.lo=l.lo>>>7;c[f++]=l.lo}Uu.prototype.uint64=function(c){var f=gae.from(c);return this._push(JNe,f.length(),f)};Uu.prototype.int64=Uu.prototype.uint64;Uu.prototype.sint64=function(c){var f=gae.from(c).zzEncode();return this._push(JNe,f.length(),f)};Uu.prototype.bool=function(c){return this._push(UNe,1,c?1:0)};function jNe(l,c,f){c[f]=l&255,c[f+1]=l>>>8&255,c[f+2]=l>>>16&255,c[f+3]=l>>>24}Uu.prototype.fixed32=function(c){return this._push(jNe,4,c>>>0)};Uu.prototype.sfixed32=Uu.prototype.fixed32;Uu.prototype.fixed64=function(c){var f=gae.from(c);return this._push(jNe,4,f.lo)._push(jNe,4,f.hi)};Uu.prototype.sfixed64=Uu.prototype.fixed64;Uu.prototype.float=function(c){return this._push(NT.float.writeFloatLE,4,c)};Uu.prototype.double=function(c){return this._push(NT.float.writeDoubleLE,8,c)};var vcr=NT.Array.prototype.set?function(c,f,y){f.set(c,y)}:function(c,f,y){for(var b=0;b<c.length;++b)f[y+b]=c[b]};Uu.prototype.bytes=function(c){var f=c.length>>>0;if(!f)return this._push(UNe,1,0);if(NT.isString(c)){var y=Uu.alloc(f=Zlt.length(c));Zlt.decode(c,y,0),c=y}return this.uint32(f)._push(vcr,f,c)};Uu.prototype.string=function(c){var f=eut.length(c);return f?this.uint32(f)._push(eut.write,f,c):this._push(UNe,1,0)};Uu.prototype.fork=function(){return this.states=new hcr(this),this.head=this.tail=new yz(BNe,0,0),this.len=0,this};Uu.prototype.reset=function(){return this.states?(this.head=this.states.head,this.tail=this.states.tail,this.len=this.states.len,this.states=this.states.next):(this.head=this.tail=new yz(BNe,0,0),this.len=0),this};Uu.prototype.ldelim=function(){var c=this.head,f=this.tail,y=this.len;return this.reset().uint32(y),y&&(this.tail.next=c.next,this.tail=f,this.len+=y),this};Uu.prototype.finish=function(){for(var c=this.head.next,f=this.constructor.alloc(this.len),y=0;c;)c.fn(c.val,f,y),y+=c.len,c=c.next;return f};Uu._configure=function(l){FNe=l,Uu.create=tut(),FNe._configure()}});var sut=xt((jAr,iut)=>{"use strict";iut.exports=TC;var nut=qNe();(TC.prototype=Object.create(nut.prototype)).constructor=TC;var Ew=Tw();function TC(){nut.call(this)}TC._configure=function(){TC.alloc=Ew._Buffer_allocUnsafe,TC.writeBytesBuffer=Ew.Buffer&&Ew.Buffer.prototype instanceof Uint8Array&&Ew.Buffer.prototype.set.name==="set"?function(c,f,y){f.set(c,y)}:function(c,f,y){if(c.copy)c.copy(f,y,0,c.length);else for(var b=0;b<c.length;)f[y++]=c[b++]}};TC.prototype.bytes=function(c){Ew.isString(c)&&(c=Ew._Buffer_from(c,"base64"));var f=c.length>>>0;return this.uint32(f),f&&this._push(TC.writeBytesBuffer,f,c),this};function Scr(l,c,f){l.length<40?Ew.utf8.write(l,c,f):c.utf8Write?c.utf8Write(l,f):c.write(l,f)}TC.prototype.string=function(c){var f=Ew.Buffer.byteLength(c);return this.uint32(f),f&&this._push(Scr,f,c),this};TC._configure()});var $Ne=xt((BAr,uut)=>{"use strict";uut.exports=Tm;var Sx=Tw(),WNe,cut=Sx.LongBits,bcr=Sx.utf8;function bx(l,c){return RangeError("index out of range: "+l.pos+" + "+(c||1)+" > "+l.len)}function Tm(l){this.buf=l,this.pos=0,this.len=l.length}var aut=typeof Uint8Array<"u"?function(c){if(c instanceof Uint8Array||Array.isArray(c))return new Tm(c);throw Error("illegal buffer")}:function(c){if(Array.isArray(c))return new Tm(c);throw Error("illegal buffer")},lut=function(){return Sx.Buffer?function(f){return(Tm.create=function(b){return Sx.Buffer.isBuffer(b)?new WNe(b):aut(b)})(f)}:aut};Tm.create=lut();Tm.prototype._slice=Sx.Array.prototype.subarray||Sx.Array.prototype.slice;Tm.prototype.uint32=function(){var c=4294967295;return function(){if(c=(this.buf[this.pos]&127)>>>0,this.buf[this.pos++]<128||(c=(c|(this.buf[this.pos]&127)<<7)>>>0,this.buf[this.pos++]<128)||(c=(c|(this.buf[this.pos]&127)<<14)>>>0,this.buf[this.pos++]<128)||(c=(c|(this.buf[this.pos]&127)<<21)>>>0,this.buf[this.pos++]<128)||(c=(c|(this.buf[this.pos]&15)<<28)>>>0,this.buf[this.pos++]<128))return c;if((this.pos+=5)>this.len)throw this.pos=this.len,bx(this,10);return c}}();Tm.prototype.int32=function(){return this.uint32()|0};Tm.prototype.sint32=function(){var c=this.uint32();return c>>>1^-(c&1)|0};function zNe(){var l=new cut(0,0),c=0;if(this.len-this.pos>4){for(;c<4;++c)if(l.lo=(l.lo|(this.buf[this.pos]&127)<<c*7)>>>0,this.buf[this.pos++]<128)return l;if(l.lo=(l.lo|(this.buf[this.pos]&127)<<28)>>>0,l.hi=(l.hi|(this.buf[this.pos]&127)>>4)>>>0,this.buf[this.pos++]<128)return l;c=0}else{for(;c<3;++c){if(this.pos>=this.len)throw bx(this);if(l.lo=(l.lo|(this.buf[this.pos]&127)<<c*7)>>>0,this.buf[this.pos++]<128)return l}return l.lo=(l.lo|(this.buf[this.pos++]&127)<<c*7)>>>0,l}if(this.len-this.pos>4){for(;c<5;++c)if(l.hi=(l.hi|(this.buf[this.pos]&127)<<c*7+3)>>>0,this.buf[this.pos++]<128)return l}else for(;c<5;++c){if(this.pos>=this.len)throw bx(this);if(l.hi=(l.hi|(this.buf[this.pos]&127)<<c*7+3)>>>0,this.buf[this.pos++]<128)return l}throw Error("invalid varint encoding")}Tm.prototype.bool=function(){return this.uint32()!==0};function hae(l,c){return(l[c-4]|l[c-3]<<8|l[c-2]<<16|l[c-1]<<24)>>>0}Tm.prototype.fixed32=function(){if(this.pos+4>this.len)throw bx(this,4);return hae(this.buf,this.pos+=4)};Tm.prototype.sfixed32=function(){if(this.pos+4>this.len)throw bx(this,4);return hae(this.buf,this.pos+=4)|0};function out(){if(this.pos+8>this.len)throw bx(this,8);return new cut(hae(this.buf,this.pos+=4),hae(this.buf,this.pos+=4))}Tm.prototype.float=function(){if(this.pos+4>this.len)throw bx(this,4);var c=Sx.float.readFloatLE(this.buf,this.pos);return this.pos+=4,c};Tm.prototype.double=function(){if(this.pos+8>this.len)throw bx(this,4);var c=Sx.float.readDoubleLE(this.buf,this.pos);return this.pos+=8,c};Tm.prototype.bytes=function(){var c=this.uint32(),f=this.pos,y=this.pos+c;if(y>this.len)throw bx(this,c);if(this.pos+=c,Array.isArray(this.buf))return this.buf.slice(f,y);if(f===y){var b=Sx.Buffer;return b?b.alloc(0):new this.buf.constructor(0)}return this._slice.call(this.buf,f,y)};Tm.prototype.string=function(){var c=this.bytes();return bcr.read(c,0,c.length)};Tm.prototype.skip=function(c){if(typeof c=="number"){if(this.pos+c>this.len)throw bx(this,c);this.pos+=c}else do if(this.pos>=this.len)throw bx(this);while(this.buf[this.pos++]&128);return this};Tm.prototype.skipType=function(l){switch(l){case 0:this.skip();break;case 1:this.skip(8);break;case 2:this.skip(this.uint32());break;case 3:for(;(l=this.uint32()&7)!==4;)this.skipType(l);break;case 5:this.skip(4);break;default:throw Error("invalid wire type "+l+" at offset "+this.pos)}return this};Tm._configure=function(l){WNe=l,Tm.create=lut(),WNe._configure();var c=Sx.Long?"toLong":"toNumber";Sx.merge(Tm.prototype,{int64:function(){return zNe.call(this)[c](!1)},uint64:function(){return zNe.call(this)[c](!0)},sint64:function(){return zNe.call(this).zzDecode()[c](!1)},fixed64:function(){return out.call(this)[c](!0)},sfixed64:function(){return out.call(this)[c](!1)}})}});var dut=xt((UAr,put)=>{"use strict";put.exports=j4;var fut=$Ne();(j4.prototype=Object.create(fut.prototype)).constructor=j4;var _ut=Tw();function j4(l){fut.call(this,l)}j4._configure=function(){_ut.Buffer&&(j4.prototype._slice=_ut.Buffer.prototype.slice)};j4.prototype.string=function(){var c=this.uint32();return this.buf.utf8Slice?this.buf.utf8Slice(this.pos,this.pos=Math.min(this.pos+c,this.len)):this.buf.toString("utf-8",this.pos,this.pos=Math.min(this.pos+c,this.len))};j4._configure()});var gut=xt((VAr,mut)=>{"use strict";mut.exports=vz;var HNe=Tw();(vz.prototype=Object.create(HNe.EventEmitter.prototype)).constructor=vz;function vz(l,c,f){if(typeof l!="function")throw TypeError("rpcImpl must be a function");HNe.EventEmitter.call(this),this.rpcImpl=l,this.requestDelimited=!!c,this.responseDelimited=!!f}vz.prototype.rpcCall=function l(c,f,y,b,A){if(!b)throw TypeError("request must be specified");var g=this;if(!A)return HNe.asPromise(l,g,c,f,y,b);if(!g.rpcImpl){setTimeout(function(){A(Error("already ended"))},0);return}try{return g.rpcImpl(c,f[g.requestDelimited?"encodeDelimited":"encode"](b).finish(),function(k,j){if(k)return g.emit("error",k,c),A(k);if(j===null){g.end(!0);return}if(!(j instanceof y))try{j=y[g.responseDelimited?"decodeDelimited":"decode"](j)}catch(se){return g.emit("error",se,c),A(se)}return g.emit("data",j,c),A(null,j)})}catch(p){g.emit("error",p,c),setTimeout(function(){A(p)},0);return}};vz.prototype.end=function(c){return this.rpcImpl&&(c||this.rpcImpl(null,null,null),this.rpcImpl=null,this.emit("end").off()),this}});var yut=xt(hut=>{"use strict";var Tcr=hut;Tcr.Service=gut()});var Sut=xt((qAr,vut)=>{"use strict";vut.exports={}});var Eut=xt(Tut=>{"use strict";var E1=Tut;E1.build="minimal";E1.Writer=qNe();E1.BufferWriter=sut();E1.Reader=$Ne();E1.BufferReader=dut();E1.util=Tw();E1.rpc=yut();E1.roots=Sut();E1.configure=but;function but(){E1.util._configure(),E1.Writer._configure(E1.BufferWriter),E1.Reader._configure(E1.BufferReader)}but()});var Cut=xt((WAr,xut)=>{"use strict";xut.exports=Eut()});var kut=xt(($Ar,Aut)=>{"use strict";var Zo=Cut(),mn=Zo.Reader,gl=Zo.Writer,gt=Zo.util,at=Zo.roots.default||(Zo.roots.default={});at.opentelemetry=function(){var l={};return l.proto=function(){var c={};return c.common=function(){var f={};return f.v1=function(){var y={};return y.AnyValue=function(){function b(g){if(g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}b.prototype.stringValue=null,b.prototype.boolValue=null,b.prototype.intValue=null,b.prototype.doubleValue=null,b.prototype.arrayValue=null,b.prototype.kvlistValue=null,b.prototype.bytesValue=null;var A;return Object.defineProperty(b.prototype,"value",{get:gt.oneOfGetter(A=["stringValue","boolValue","intValue","doubleValue","arrayValue","kvlistValue","bytesValue"]),set:gt.oneOfSetter(A)}),b.create=function(p){return new b(p)},b.encode=function(p,k){return k||(k=gl.create()),p.stringValue!=null&&Object.hasOwnProperty.call(p,"stringValue")&&k.uint32(10).string(p.stringValue),p.boolValue!=null&&Object.hasOwnProperty.call(p,"boolValue")&&k.uint32(16).bool(p.boolValue),p.intValue!=null&&Object.hasOwnProperty.call(p,"intValue")&&k.uint32(24).int64(p.intValue),p.doubleValue!=null&&Object.hasOwnProperty.call(p,"doubleValue")&&k.uint32(33).double(p.doubleValue),p.arrayValue!=null&&Object.hasOwnProperty.call(p,"arrayValue")&&at.opentelemetry.proto.common.v1.ArrayValue.encode(p.arrayValue,k.uint32(42).fork()).ldelim(),p.kvlistValue!=null&&Object.hasOwnProperty.call(p,"kvlistValue")&&at.opentelemetry.proto.common.v1.KeyValueList.encode(p.kvlistValue,k.uint32(50).fork()).ldelim(),p.bytesValue!=null&&Object.hasOwnProperty.call(p,"bytesValue")&&k.uint32(58).bytes(p.bytesValue),k},b.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},b.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.common.v1.AnyValue;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 1:{se.stringValue=p.string();break}case 2:{se.boolValue=p.bool();break}case 3:{se.intValue=p.int64();break}case 4:{se.doubleValue=p.double();break}case 5:{se.arrayValue=at.opentelemetry.proto.common.v1.ArrayValue.decode(p,p.uint32());break}case 6:{se.kvlistValue=at.opentelemetry.proto.common.v1.KeyValueList.decode(p,p.uint32());break}case 7:{se.bytesValue=p.bytes();break}default:p.skipType(ze&7);break}}return se},b.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},b.verify=function(p){if(typeof p!="object"||p===null)return"object expected";var k={};if(p.stringValue!=null&&p.hasOwnProperty("stringValue")&&(k.value=1,!gt.isString(p.stringValue)))return"stringValue: string expected";if(p.boolValue!=null&&p.hasOwnProperty("boolValue")){if(k.value===1)return"value: multiple values";if(k.value=1,typeof p.boolValue!="boolean")return"boolValue: boolean expected"}if(p.intValue!=null&&p.hasOwnProperty("intValue")){if(k.value===1)return"value: multiple values";if(k.value=1,!gt.isInteger(p.intValue)&&!(p.intValue&&gt.isInteger(p.intValue.low)&&gt.isInteger(p.intValue.high)))return"intValue: integer|Long expected"}if(p.doubleValue!=null&&p.hasOwnProperty("doubleValue")){if(k.value===1)return"value: multiple values";if(k.value=1,typeof p.doubleValue!="number")return"doubleValue: number expected"}if(p.arrayValue!=null&&p.hasOwnProperty("arrayValue")){if(k.value===1)return"value: multiple values";k.value=1;{var j=at.opentelemetry.proto.common.v1.ArrayValue.verify(p.arrayValue);if(j)return"arrayValue."+j}}if(p.kvlistValue!=null&&p.hasOwnProperty("kvlistValue")){if(k.value===1)return"value: multiple values";k.value=1;{var j=at.opentelemetry.proto.common.v1.KeyValueList.verify(p.kvlistValue);if(j)return"kvlistValue."+j}}if(p.bytesValue!=null&&p.hasOwnProperty("bytesValue")){if(k.value===1)return"value: multiple values";if(k.value=1,!(p.bytesValue&&typeof p.bytesValue.length=="number"||gt.isString(p.bytesValue)))return"bytesValue: buffer expected"}return null},b.fromObject=function(p){if(p instanceof at.opentelemetry.proto.common.v1.AnyValue)return p;var k=new at.opentelemetry.proto.common.v1.AnyValue;if(p.stringValue!=null&&(k.stringValue=String(p.stringValue)),p.boolValue!=null&&(k.boolValue=!!p.boolValue),p.intValue!=null&&(gt.Long?(k.intValue=gt.Long.fromValue(p.intValue)).unsigned=!1:typeof p.intValue=="string"?k.intValue=parseInt(p.intValue,10):typeof p.intValue=="number"?k.intValue=p.intValue:typeof p.intValue=="object"&&(k.intValue=new gt.LongBits(p.intValue.low>>>0,p.intValue.high>>>0).toNumber())),p.doubleValue!=null&&(k.doubleValue=Number(p.doubleValue)),p.arrayValue!=null){if(typeof p.arrayValue!="object")throw TypeError(".opentelemetry.proto.common.v1.AnyValue.arrayValue: object expected");k.arrayValue=at.opentelemetry.proto.common.v1.ArrayValue.fromObject(p.arrayValue)}if(p.kvlistValue!=null){if(typeof p.kvlistValue!="object")throw TypeError(".opentelemetry.proto.common.v1.AnyValue.kvlistValue: object expected");k.kvlistValue=at.opentelemetry.proto.common.v1.KeyValueList.fromObject(p.kvlistValue)}return p.bytesValue!=null&&(typeof p.bytesValue=="string"?gt.base64.decode(p.bytesValue,k.bytesValue=gt.newBuffer(gt.base64.length(p.bytesValue)),0):p.bytesValue.length>=0&&(k.bytesValue=p.bytesValue)),k},b.toObject=function(p,k){k||(k={});var j={};return p.stringValue!=null&&p.hasOwnProperty("stringValue")&&(j.stringValue=p.stringValue,k.oneofs&&(j.value="stringValue")),p.boolValue!=null&&p.hasOwnProperty("boolValue")&&(j.boolValue=p.boolValue,k.oneofs&&(j.value="boolValue")),p.intValue!=null&&p.hasOwnProperty("intValue")&&(typeof p.intValue=="number"?j.intValue=k.longs===String?String(p.intValue):p.intValue:j.intValue=k.longs===String?gt.Long.prototype.toString.call(p.intValue):k.longs===Number?new gt.LongBits(p.intValue.low>>>0,p.intValue.high>>>0).toNumber():p.intValue,k.oneofs&&(j.value="intValue")),p.doubleValue!=null&&p.hasOwnProperty("doubleValue")&&(j.doubleValue=k.json&&!isFinite(p.doubleValue)?String(p.doubleValue):p.doubleValue,k.oneofs&&(j.value="doubleValue")),p.arrayValue!=null&&p.hasOwnProperty("arrayValue")&&(j.arrayValue=at.opentelemetry.proto.common.v1.ArrayValue.toObject(p.arrayValue,k),k.oneofs&&(j.value="arrayValue")),p.kvlistValue!=null&&p.hasOwnProperty("kvlistValue")&&(j.kvlistValue=at.opentelemetry.proto.common.v1.KeyValueList.toObject(p.kvlistValue,k),k.oneofs&&(j.value="kvlistValue")),p.bytesValue!=null&&p.hasOwnProperty("bytesValue")&&(j.bytesValue=k.bytes===String?gt.base64.encode(p.bytesValue,0,p.bytesValue.length):k.bytes===Array?Array.prototype.slice.call(p.bytesValue):p.bytesValue,k.oneofs&&(j.value="bytesValue")),j},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.common.v1.AnyValue"},b}(),y.ArrayValue=function(){function b(A){if(this.values=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.values=gt.emptyArray,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.values!=null&&g.values.length)for(var k=0;k<g.values.length;++k)at.opentelemetry.proto.common.v1.AnyValue.encode(g.values[k],p.uint32(10).fork()).ldelim();return p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.common.v1.ArrayValue;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.values&&j.values.length||(j.values=[]),j.values.push(at.opentelemetry.proto.common.v1.AnyValue.decode(g,g.uint32()));break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.values!=null&&g.hasOwnProperty("values")){if(!Array.isArray(g.values))return"values: array expected";for(var p=0;p<g.values.length;++p){var k=at.opentelemetry.proto.common.v1.AnyValue.verify(g.values[p]);if(k)return"values."+k}}return null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.common.v1.ArrayValue)return g;var p=new at.opentelemetry.proto.common.v1.ArrayValue;if(g.values){if(!Array.isArray(g.values))throw TypeError(".opentelemetry.proto.common.v1.ArrayValue.values: array expected");p.values=[];for(var k=0;k<g.values.length;++k){if(typeof g.values[k]!="object")throw TypeError(".opentelemetry.proto.common.v1.ArrayValue.values: object expected");p.values[k]=at.opentelemetry.proto.common.v1.AnyValue.fromObject(g.values[k])}}return p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.values=[]),g.values&&g.values.length){k.values=[];for(var j=0;j<g.values.length;++j)k.values[j]=at.opentelemetry.proto.common.v1.AnyValue.toObject(g.values[j],p)}return k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.common.v1.ArrayValue"},b}(),y.KeyValueList=function(){function b(A){if(this.values=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.values=gt.emptyArray,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.values!=null&&g.values.length)for(var k=0;k<g.values.length;++k)at.opentelemetry.proto.common.v1.KeyValue.encode(g.values[k],p.uint32(10).fork()).ldelim();return p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.common.v1.KeyValueList;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.values&&j.values.length||(j.values=[]),j.values.push(at.opentelemetry.proto.common.v1.KeyValue.decode(g,g.uint32()));break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.values!=null&&g.hasOwnProperty("values")){if(!Array.isArray(g.values))return"values: array expected";for(var p=0;p<g.values.length;++p){var k=at.opentelemetry.proto.common.v1.KeyValue.verify(g.values[p]);if(k)return"values."+k}}return null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.common.v1.KeyValueList)return g;var p=new at.opentelemetry.proto.common.v1.KeyValueList;if(g.values){if(!Array.isArray(g.values))throw TypeError(".opentelemetry.proto.common.v1.KeyValueList.values: array expected");p.values=[];for(var k=0;k<g.values.length;++k){if(typeof g.values[k]!="object")throw TypeError(".opentelemetry.proto.common.v1.KeyValueList.values: object expected");p.values[k]=at.opentelemetry.proto.common.v1.KeyValue.fromObject(g.values[k])}}return p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.values=[]),g.values&&g.values.length){k.values=[];for(var j=0;j<g.values.length;++j)k.values[j]=at.opentelemetry.proto.common.v1.KeyValue.toObject(g.values[j],p)}return k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.common.v1.KeyValueList"},b}(),y.KeyValue=function(){function b(A){if(A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.key=null,b.prototype.value=null,b.create=function(g){return new b(g)},b.encode=function(g,p){return p||(p=gl.create()),g.key!=null&&Object.hasOwnProperty.call(g,"key")&&p.uint32(10).string(g.key),g.value!=null&&Object.hasOwnProperty.call(g,"value")&&at.opentelemetry.proto.common.v1.AnyValue.encode(g.value,p.uint32(18).fork()).ldelim(),p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.common.v1.KeyValue;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.key=g.string();break}case 2:{j.value=at.opentelemetry.proto.common.v1.AnyValue.decode(g,g.uint32());break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.key!=null&&g.hasOwnProperty("key")&&!gt.isString(g.key))return"key: string expected";if(g.value!=null&&g.hasOwnProperty("value")){var p=at.opentelemetry.proto.common.v1.AnyValue.verify(g.value);if(p)return"value."+p}return null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.common.v1.KeyValue)return g;var p=new at.opentelemetry.proto.common.v1.KeyValue;if(g.key!=null&&(p.key=String(g.key)),g.value!=null){if(typeof g.value!="object")throw TypeError(".opentelemetry.proto.common.v1.KeyValue.value: object expected");p.value=at.opentelemetry.proto.common.v1.AnyValue.fromObject(g.value)}return p},b.toObject=function(g,p){p||(p={});var k={};return p.defaults&&(k.key="",k.value=null),g.key!=null&&g.hasOwnProperty("key")&&(k.key=g.key),g.value!=null&&g.hasOwnProperty("value")&&(k.value=at.opentelemetry.proto.common.v1.AnyValue.toObject(g.value,p)),k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.common.v1.KeyValue"},b}(),y.InstrumentationScope=function(){function b(A){if(this.attributes=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.name=null,b.prototype.version=null,b.prototype.attributes=gt.emptyArray,b.prototype.droppedAttributesCount=null,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.name!=null&&Object.hasOwnProperty.call(g,"name")&&p.uint32(10).string(g.name),g.version!=null&&Object.hasOwnProperty.call(g,"version")&&p.uint32(18).string(g.version),g.attributes!=null&&g.attributes.length)for(var k=0;k<g.attributes.length;++k)at.opentelemetry.proto.common.v1.KeyValue.encode(g.attributes[k],p.uint32(26).fork()).ldelim();return g.droppedAttributesCount!=null&&Object.hasOwnProperty.call(g,"droppedAttributesCount")&&p.uint32(32).uint32(g.droppedAttributesCount),p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.common.v1.InstrumentationScope;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.name=g.string();break}case 2:{j.version=g.string();break}case 3:{j.attributes&&j.attributes.length||(j.attributes=[]),j.attributes.push(at.opentelemetry.proto.common.v1.KeyValue.decode(g,g.uint32()));break}case 4:{j.droppedAttributesCount=g.uint32();break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.name!=null&&g.hasOwnProperty("name")&&!gt.isString(g.name))return"name: string expected";if(g.version!=null&&g.hasOwnProperty("version")&&!gt.isString(g.version))return"version: string expected";if(g.attributes!=null&&g.hasOwnProperty("attributes")){if(!Array.isArray(g.attributes))return"attributes: array expected";for(var p=0;p<g.attributes.length;++p){var k=at.opentelemetry.proto.common.v1.KeyValue.verify(g.attributes[p]);if(k)return"attributes."+k}}return g.droppedAttributesCount!=null&&g.hasOwnProperty("droppedAttributesCount")&&!gt.isInteger(g.droppedAttributesCount)?"droppedAttributesCount: integer expected":null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.common.v1.InstrumentationScope)return g;var p=new at.opentelemetry.proto.common.v1.InstrumentationScope;if(g.name!=null&&(p.name=String(g.name)),g.version!=null&&(p.version=String(g.version)),g.attributes){if(!Array.isArray(g.attributes))throw TypeError(".opentelemetry.proto.common.v1.InstrumentationScope.attributes: array expected");p.attributes=[];for(var k=0;k<g.attributes.length;++k){if(typeof g.attributes[k]!="object")throw TypeError(".opentelemetry.proto.common.v1.InstrumentationScope.attributes: object expected");p.attributes[k]=at.opentelemetry.proto.common.v1.KeyValue.fromObject(g.attributes[k])}}return g.droppedAttributesCount!=null&&(p.droppedAttributesCount=g.droppedAttributesCount>>>0),p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.attributes=[]),p.defaults&&(k.name="",k.version="",k.droppedAttributesCount=0),g.name!=null&&g.hasOwnProperty("name")&&(k.name=g.name),g.version!=null&&g.hasOwnProperty("version")&&(k.version=g.version),g.attributes&&g.attributes.length){k.attributes=[];for(var j=0;j<g.attributes.length;++j)k.attributes[j]=at.opentelemetry.proto.common.v1.KeyValue.toObject(g.attributes[j],p)}return g.droppedAttributesCount!=null&&g.hasOwnProperty("droppedAttributesCount")&&(k.droppedAttributesCount=g.droppedAttributesCount),k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.common.v1.InstrumentationScope"},b}(),y}(),f}(),c.resource=function(){var f={};return f.v1=function(){var y={};return y.Resource=function(){function b(A){if(this.attributes=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.attributes=gt.emptyArray,b.prototype.droppedAttributesCount=null,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.attributes!=null&&g.attributes.length)for(var k=0;k<g.attributes.length;++k)at.opentelemetry.proto.common.v1.KeyValue.encode(g.attributes[k],p.uint32(10).fork()).ldelim();return g.droppedAttributesCount!=null&&Object.hasOwnProperty.call(g,"droppedAttributesCount")&&p.uint32(16).uint32(g.droppedAttributesCount),p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.resource.v1.Resource;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.attributes&&j.attributes.length||(j.attributes=[]),j.attributes.push(at.opentelemetry.proto.common.v1.KeyValue.decode(g,g.uint32()));break}case 2:{j.droppedAttributesCount=g.uint32();break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.attributes!=null&&g.hasOwnProperty("attributes")){if(!Array.isArray(g.attributes))return"attributes: array expected";for(var p=0;p<g.attributes.length;++p){var k=at.opentelemetry.proto.common.v1.KeyValue.verify(g.attributes[p]);if(k)return"attributes."+k}}return g.droppedAttributesCount!=null&&g.hasOwnProperty("droppedAttributesCount")&&!gt.isInteger(g.droppedAttributesCount)?"droppedAttributesCount: integer expected":null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.resource.v1.Resource)return g;var p=new at.opentelemetry.proto.resource.v1.Resource;if(g.attributes){if(!Array.isArray(g.attributes))throw TypeError(".opentelemetry.proto.resource.v1.Resource.attributes: array expected");p.attributes=[];for(var k=0;k<g.attributes.length;++k){if(typeof g.attributes[k]!="object")throw TypeError(".opentelemetry.proto.resource.v1.Resource.attributes: object expected");p.attributes[k]=at.opentelemetry.proto.common.v1.KeyValue.fromObject(g.attributes[k])}}return g.droppedAttributesCount!=null&&(p.droppedAttributesCount=g.droppedAttributesCount>>>0),p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.attributes=[]),p.defaults&&(k.droppedAttributesCount=0),g.attributes&&g.attributes.length){k.attributes=[];for(var j=0;j<g.attributes.length;++j)k.attributes[j]=at.opentelemetry.proto.common.v1.KeyValue.toObject(g.attributes[j],p)}return g.droppedAttributesCount!=null&&g.hasOwnProperty("droppedAttributesCount")&&(k.droppedAttributesCount=g.droppedAttributesCount),k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.resource.v1.Resource"},b}(),y}(),f}(),c.trace=function(){var f={};return f.v1=function(){var y={};return y.TracesData=function(){function b(A){if(this.resourceSpans=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.resourceSpans=gt.emptyArray,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.resourceSpans!=null&&g.resourceSpans.length)for(var k=0;k<g.resourceSpans.length;++k)at.opentelemetry.proto.trace.v1.ResourceSpans.encode(g.resourceSpans[k],p.uint32(10).fork()).ldelim();return p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.trace.v1.TracesData;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.resourceSpans&&j.resourceSpans.length||(j.resourceSpans=[]),j.resourceSpans.push(at.opentelemetry.proto.trace.v1.ResourceSpans.decode(g,g.uint32()));break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.resourceSpans!=null&&g.hasOwnProperty("resourceSpans")){if(!Array.isArray(g.resourceSpans))return"resourceSpans: array expected";for(var p=0;p<g.resourceSpans.length;++p){var k=at.opentelemetry.proto.trace.v1.ResourceSpans.verify(g.resourceSpans[p]);if(k)return"resourceSpans."+k}}return null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.trace.v1.TracesData)return g;var p=new at.opentelemetry.proto.trace.v1.TracesData;if(g.resourceSpans){if(!Array.isArray(g.resourceSpans))throw TypeError(".opentelemetry.proto.trace.v1.TracesData.resourceSpans: array expected");p.resourceSpans=[];for(var k=0;k<g.resourceSpans.length;++k){if(typeof g.resourceSpans[k]!="object")throw TypeError(".opentelemetry.proto.trace.v1.TracesData.resourceSpans: object expected");p.resourceSpans[k]=at.opentelemetry.proto.trace.v1.ResourceSpans.fromObject(g.resourceSpans[k])}}return p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.resourceSpans=[]),g.resourceSpans&&g.resourceSpans.length){k.resourceSpans=[];for(var j=0;j<g.resourceSpans.length;++j)k.resourceSpans[j]=at.opentelemetry.proto.trace.v1.ResourceSpans.toObject(g.resourceSpans[j],p)}return k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.trace.v1.TracesData"},b}(),y.ResourceSpans=function(){function b(A){if(this.scopeSpans=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.resource=null,b.prototype.scopeSpans=gt.emptyArray,b.prototype.schemaUrl=null,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.resource!=null&&Object.hasOwnProperty.call(g,"resource")&&at.opentelemetry.proto.resource.v1.Resource.encode(g.resource,p.uint32(10).fork()).ldelim(),g.scopeSpans!=null&&g.scopeSpans.length)for(var k=0;k<g.scopeSpans.length;++k)at.opentelemetry.proto.trace.v1.ScopeSpans.encode(g.scopeSpans[k],p.uint32(18).fork()).ldelim();return g.schemaUrl!=null&&Object.hasOwnProperty.call(g,"schemaUrl")&&p.uint32(26).string(g.schemaUrl),p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.trace.v1.ResourceSpans;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.resource=at.opentelemetry.proto.resource.v1.Resource.decode(g,g.uint32());break}case 2:{j.scopeSpans&&j.scopeSpans.length||(j.scopeSpans=[]),j.scopeSpans.push(at.opentelemetry.proto.trace.v1.ScopeSpans.decode(g,g.uint32()));break}case 3:{j.schemaUrl=g.string();break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.resource!=null&&g.hasOwnProperty("resource")){var p=at.opentelemetry.proto.resource.v1.Resource.verify(g.resource);if(p)return"resource."+p}if(g.scopeSpans!=null&&g.hasOwnProperty("scopeSpans")){if(!Array.isArray(g.scopeSpans))return"scopeSpans: array expected";for(var k=0;k<g.scopeSpans.length;++k){var p=at.opentelemetry.proto.trace.v1.ScopeSpans.verify(g.scopeSpans[k]);if(p)return"scopeSpans."+p}}return g.schemaUrl!=null&&g.hasOwnProperty("schemaUrl")&&!gt.isString(g.schemaUrl)?"schemaUrl: string expected":null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.trace.v1.ResourceSpans)return g;var p=new at.opentelemetry.proto.trace.v1.ResourceSpans;if(g.resource!=null){if(typeof g.resource!="object")throw TypeError(".opentelemetry.proto.trace.v1.ResourceSpans.resource: object expected");p.resource=at.opentelemetry.proto.resource.v1.Resource.fromObject(g.resource)}if(g.scopeSpans){if(!Array.isArray(g.scopeSpans))throw TypeError(".opentelemetry.proto.trace.v1.ResourceSpans.scopeSpans: array expected");p.scopeSpans=[];for(var k=0;k<g.scopeSpans.length;++k){if(typeof g.scopeSpans[k]!="object")throw TypeError(".opentelemetry.proto.trace.v1.ResourceSpans.scopeSpans: object expected");p.scopeSpans[k]=at.opentelemetry.proto.trace.v1.ScopeSpans.fromObject(g.scopeSpans[k])}}return g.schemaUrl!=null&&(p.schemaUrl=String(g.schemaUrl)),p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.scopeSpans=[]),p.defaults&&(k.resource=null,k.schemaUrl=""),g.resource!=null&&g.hasOwnProperty("resource")&&(k.resource=at.opentelemetry.proto.resource.v1.Resource.toObject(g.resource,p)),g.scopeSpans&&g.scopeSpans.length){k.scopeSpans=[];for(var j=0;j<g.scopeSpans.length;++j)k.scopeSpans[j]=at.opentelemetry.proto.trace.v1.ScopeSpans.toObject(g.scopeSpans[j],p)}return g.schemaUrl!=null&&g.hasOwnProperty("schemaUrl")&&(k.schemaUrl=g.schemaUrl),k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.trace.v1.ResourceSpans"},b}(),y.ScopeSpans=function(){function b(A){if(this.spans=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.scope=null,b.prototype.spans=gt.emptyArray,b.prototype.schemaUrl=null,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.scope!=null&&Object.hasOwnProperty.call(g,"scope")&&at.opentelemetry.proto.common.v1.InstrumentationScope.encode(g.scope,p.uint32(10).fork()).ldelim(),g.spans!=null&&g.spans.length)for(var k=0;k<g.spans.length;++k)at.opentelemetry.proto.trace.v1.Span.encode(g.spans[k],p.uint32(18).fork()).ldelim();return g.schemaUrl!=null&&Object.hasOwnProperty.call(g,"schemaUrl")&&p.uint32(26).string(g.schemaUrl),p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.trace.v1.ScopeSpans;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.scope=at.opentelemetry.proto.common.v1.InstrumentationScope.decode(g,g.uint32());break}case 2:{j.spans&&j.spans.length||(j.spans=[]),j.spans.push(at.opentelemetry.proto.trace.v1.Span.decode(g,g.uint32()));break}case 3:{j.schemaUrl=g.string();break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.scope!=null&&g.hasOwnProperty("scope")){var p=at.opentelemetry.proto.common.v1.InstrumentationScope.verify(g.scope);if(p)return"scope."+p}if(g.spans!=null&&g.hasOwnProperty("spans")){if(!Array.isArray(g.spans))return"spans: array expected";for(var k=0;k<g.spans.length;++k){var p=at.opentelemetry.proto.trace.v1.Span.verify(g.spans[k]);if(p)return"spans."+p}}return g.schemaUrl!=null&&g.hasOwnProperty("schemaUrl")&&!gt.isString(g.schemaUrl)?"schemaUrl: string expected":null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.trace.v1.ScopeSpans)return g;var p=new at.opentelemetry.proto.trace.v1.ScopeSpans;if(g.scope!=null){if(typeof g.scope!="object")throw TypeError(".opentelemetry.proto.trace.v1.ScopeSpans.scope: object expected");p.scope=at.opentelemetry.proto.common.v1.InstrumentationScope.fromObject(g.scope)}if(g.spans){if(!Array.isArray(g.spans))throw TypeError(".opentelemetry.proto.trace.v1.ScopeSpans.spans: array expected");p.spans=[];for(var k=0;k<g.spans.length;++k){if(typeof g.spans[k]!="object")throw TypeError(".opentelemetry.proto.trace.v1.ScopeSpans.spans: object expected");p.spans[k]=at.opentelemetry.proto.trace.v1.Span.fromObject(g.spans[k])}}return g.schemaUrl!=null&&(p.schemaUrl=String(g.schemaUrl)),p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.spans=[]),p.defaults&&(k.scope=null,k.schemaUrl=""),g.scope!=null&&g.hasOwnProperty("scope")&&(k.scope=at.opentelemetry.proto.common.v1.InstrumentationScope.toObject(g.scope,p)),g.spans&&g.spans.length){k.spans=[];for(var j=0;j<g.spans.length;++j)k.spans[j]=at.opentelemetry.proto.trace.v1.Span.toObject(g.spans[j],p)}return g.schemaUrl!=null&&g.hasOwnProperty("schemaUrl")&&(k.schemaUrl=g.schemaUrl),k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.trace.v1.ScopeSpans"},b}(),y.Span=function(){function b(A){if(this.attributes=[],this.events=[],this.links=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.traceId=null,b.prototype.spanId=null,b.prototype.traceState=null,b.prototype.parentSpanId=null,b.prototype.name=null,b.prototype.kind=null,b.prototype.startTimeUnixNano=null,b.prototype.endTimeUnixNano=null,b.prototype.attributes=gt.emptyArray,b.prototype.droppedAttributesCount=null,b.prototype.events=gt.emptyArray,b.prototype.droppedEventsCount=null,b.prototype.links=gt.emptyArray,b.prototype.droppedLinksCount=null,b.prototype.status=null,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.traceId!=null&&Object.hasOwnProperty.call(g,"traceId")&&p.uint32(10).bytes(g.traceId),g.spanId!=null&&Object.hasOwnProperty.call(g,"spanId")&&p.uint32(18).bytes(g.spanId),g.traceState!=null&&Object.hasOwnProperty.call(g,"traceState")&&p.uint32(26).string(g.traceState),g.parentSpanId!=null&&Object.hasOwnProperty.call(g,"parentSpanId")&&p.uint32(34).bytes(g.parentSpanId),g.name!=null&&Object.hasOwnProperty.call(g,"name")&&p.uint32(42).string(g.name),g.kind!=null&&Object.hasOwnProperty.call(g,"kind")&&p.uint32(48).int32(g.kind),g.startTimeUnixNano!=null&&Object.hasOwnProperty.call(g,"startTimeUnixNano")&&p.uint32(57).fixed64(g.startTimeUnixNano),g.endTimeUnixNano!=null&&Object.hasOwnProperty.call(g,"endTimeUnixNano")&&p.uint32(65).fixed64(g.endTimeUnixNano),g.attributes!=null&&g.attributes.length)for(var k=0;k<g.attributes.length;++k)at.opentelemetry.proto.common.v1.KeyValue.encode(g.attributes[k],p.uint32(74).fork()).ldelim();if(g.droppedAttributesCount!=null&&Object.hasOwnProperty.call(g,"droppedAttributesCount")&&p.uint32(80).uint32(g.droppedAttributesCount),g.events!=null&&g.events.length)for(var k=0;k<g.events.length;++k)at.opentelemetry.proto.trace.v1.Span.Event.encode(g.events[k],p.uint32(90).fork()).ldelim();if(g.droppedEventsCount!=null&&Object.hasOwnProperty.call(g,"droppedEventsCount")&&p.uint32(96).uint32(g.droppedEventsCount),g.links!=null&&g.links.length)for(var k=0;k<g.links.length;++k)at.opentelemetry.proto.trace.v1.Span.Link.encode(g.links[k],p.uint32(106).fork()).ldelim();return g.droppedLinksCount!=null&&Object.hasOwnProperty.call(g,"droppedLinksCount")&&p.uint32(112).uint32(g.droppedLinksCount),g.status!=null&&Object.hasOwnProperty.call(g,"status")&&at.opentelemetry.proto.trace.v1.Status.encode(g.status,p.uint32(122).fork()).ldelim(),p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.trace.v1.Span;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.traceId=g.bytes();break}case 2:{j.spanId=g.bytes();break}case 3:{j.traceState=g.string();break}case 4:{j.parentSpanId=g.bytes();break}case 5:{j.name=g.string();break}case 6:{j.kind=g.int32();break}case 7:{j.startTimeUnixNano=g.fixed64();break}case 8:{j.endTimeUnixNano=g.fixed64();break}case 9:{j.attributes&&j.attributes.length||(j.attributes=[]),j.attributes.push(at.opentelemetry.proto.common.v1.KeyValue.decode(g,g.uint32()));break}case 10:{j.droppedAttributesCount=g.uint32();break}case 11:{j.events&&j.events.length||(j.events=[]),j.events.push(at.opentelemetry.proto.trace.v1.Span.Event.decode(g,g.uint32()));break}case 12:{j.droppedEventsCount=g.uint32();break}case 13:{j.links&&j.links.length||(j.links=[]),j.links.push(at.opentelemetry.proto.trace.v1.Span.Link.decode(g,g.uint32()));break}case 14:{j.droppedLinksCount=g.uint32();break}case 15:{j.status=at.opentelemetry.proto.trace.v1.Status.decode(g,g.uint32());break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.traceId!=null&&g.hasOwnProperty("traceId")&&!(g.traceId&&typeof g.traceId.length=="number"||gt.isString(g.traceId)))return"traceId: buffer expected";if(g.spanId!=null&&g.hasOwnProperty("spanId")&&!(g.spanId&&typeof g.spanId.length=="number"||gt.isString(g.spanId)))return"spanId: buffer expected";if(g.traceState!=null&&g.hasOwnProperty("traceState")&&!gt.isString(g.traceState))return"traceState: string expected";if(g.parentSpanId!=null&&g.hasOwnProperty("parentSpanId")&&!(g.parentSpanId&&typeof g.parentSpanId.length=="number"||gt.isString(g.parentSpanId)))return"parentSpanId: buffer expected";if(g.name!=null&&g.hasOwnProperty("name")&&!gt.isString(g.name))return"name: string expected";if(g.kind!=null&&g.hasOwnProperty("kind"))switch(g.kind){default:return"kind: enum value expected";case 0:case 1:case 2:case 3:case 4:case 5:break}if(g.startTimeUnixNano!=null&&g.hasOwnProperty("startTimeUnixNano")&&!gt.isInteger(g.startTimeUnixNano)&&!(g.startTimeUnixNano&&gt.isInteger(g.startTimeUnixNano.low)&&gt.isInteger(g.startTimeUnixNano.high)))return"startTimeUnixNano: integer|Long expected";if(g.endTimeUnixNano!=null&&g.hasOwnProperty("endTimeUnixNano")&&!gt.isInteger(g.endTimeUnixNano)&&!(g.endTimeUnixNano&&gt.isInteger(g.endTimeUnixNano.low)&&gt.isInteger(g.endTimeUnixNano.high)))return"endTimeUnixNano: integer|Long expected";if(g.attributes!=null&&g.hasOwnProperty("attributes")){if(!Array.isArray(g.attributes))return"attributes: array expected";for(var p=0;p<g.attributes.length;++p){var k=at.opentelemetry.proto.common.v1.KeyValue.verify(g.attributes[p]);if(k)return"attributes."+k}}if(g.droppedAttributesCount!=null&&g.hasOwnProperty("droppedAttributesCount")&&!gt.isInteger(g.droppedAttributesCount))return"droppedAttributesCount: integer expected";if(g.events!=null&&g.hasOwnProperty("events")){if(!Array.isArray(g.events))return"events: array expected";for(var p=0;p<g.events.length;++p){var k=at.opentelemetry.proto.trace.v1.Span.Event.verify(g.events[p]);if(k)return"events."+k}}if(g.droppedEventsCount!=null&&g.hasOwnProperty("droppedEventsCount")&&!gt.isInteger(g.droppedEventsCount))return"droppedEventsCount: integer expected";if(g.links!=null&&g.hasOwnProperty("links")){if(!Array.isArray(g.links))return"links: array expected";for(var p=0;p<g.links.length;++p){var k=at.opentelemetry.proto.trace.v1.Span.Link.verify(g.links[p]);if(k)return"links."+k}}if(g.droppedLinksCount!=null&&g.hasOwnProperty("droppedLinksCount")&&!gt.isInteger(g.droppedLinksCount))return"droppedLinksCount: integer expected";if(g.status!=null&&g.hasOwnProperty("status")){var k=at.opentelemetry.proto.trace.v1.Status.verify(g.status);if(k)return"status."+k}return null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.trace.v1.Span)return g;var p=new at.opentelemetry.proto.trace.v1.Span;switch(g.traceId!=null&&(typeof g.traceId=="string"?gt.base64.decode(g.traceId,p.traceId=gt.newBuffer(gt.base64.length(g.traceId)),0):g.traceId.length>=0&&(p.traceId=g.traceId)),g.spanId!=null&&(typeof g.spanId=="string"?gt.base64.decode(g.spanId,p.spanId=gt.newBuffer(gt.base64.length(g.spanId)),0):g.spanId.length>=0&&(p.spanId=g.spanId)),g.traceState!=null&&(p.traceState=String(g.traceState)),g.parentSpanId!=null&&(typeof g.parentSpanId=="string"?gt.base64.decode(g.parentSpanId,p.parentSpanId=gt.newBuffer(gt.base64.length(g.parentSpanId)),0):g.parentSpanId.length>=0&&(p.parentSpanId=g.parentSpanId)),g.name!=null&&(p.name=String(g.name)),g.kind){default:if(typeof g.kind=="number"){p.kind=g.kind;break}break;case"SPAN_KIND_UNSPECIFIED":case 0:p.kind=0;break;case"SPAN_KIND_INTERNAL":case 1:p.kind=1;break;case"SPAN_KIND_SERVER":case 2:p.kind=2;break;case"SPAN_KIND_CLIENT":case 3:p.kind=3;break;case"SPAN_KIND_PRODUCER":case 4:p.kind=4;break;case"SPAN_KIND_CONSUMER":case 5:p.kind=5;break}if(g.startTimeUnixNano!=null&&(gt.Long?(p.startTimeUnixNano=gt.Long.fromValue(g.startTimeUnixNano)).unsigned=!1:typeof g.startTimeUnixNano=="string"?p.startTimeUnixNano=parseInt(g.startTimeUnixNano,10):typeof g.startTimeUnixNano=="number"?p.startTimeUnixNano=g.startTimeUnixNano:typeof g.startTimeUnixNano=="object"&&(p.startTimeUnixNano=new gt.LongBits(g.startTimeUnixNano.low>>>0,g.startTimeUnixNano.high>>>0).toNumber())),g.endTimeUnixNano!=null&&(gt.Long?(p.endTimeUnixNano=gt.Long.fromValue(g.endTimeUnixNano)).unsigned=!1:typeof g.endTimeUnixNano=="string"?p.endTimeUnixNano=parseInt(g.endTimeUnixNano,10):typeof g.endTimeUnixNano=="number"?p.endTimeUnixNano=g.endTimeUnixNano:typeof g.endTimeUnixNano=="object"&&(p.endTimeUnixNano=new gt.LongBits(g.endTimeUnixNano.low>>>0,g.endTimeUnixNano.high>>>0).toNumber())),g.attributes){if(!Array.isArray(g.attributes))throw TypeError(".opentelemetry.proto.trace.v1.Span.attributes: array expected");p.attributes=[];for(var k=0;k<g.attributes.length;++k){if(typeof g.attributes[k]!="object")throw TypeError(".opentelemetry.proto.trace.v1.Span.attributes: object expected");p.attributes[k]=at.opentelemetry.proto.common.v1.KeyValue.fromObject(g.attributes[k])}}if(g.droppedAttributesCount!=null&&(p.droppedAttributesCount=g.droppedAttributesCount>>>0),g.events){if(!Array.isArray(g.events))throw TypeError(".opentelemetry.proto.trace.v1.Span.events: array expected");p.events=[];for(var k=0;k<g.events.length;++k){if(typeof g.events[k]!="object")throw TypeError(".opentelemetry.proto.trace.v1.Span.events: object expected");p.events[k]=at.opentelemetry.proto.trace.v1.Span.Event.fromObject(g.events[k])}}if(g.droppedEventsCount!=null&&(p.droppedEventsCount=g.droppedEventsCount>>>0),g.links){if(!Array.isArray(g.links))throw TypeError(".opentelemetry.proto.trace.v1.Span.links: array expected");p.links=[];for(var k=0;k<g.links.length;++k){if(typeof g.links[k]!="object")throw TypeError(".opentelemetry.proto.trace.v1.Span.links: object expected");p.links[k]=at.opentelemetry.proto.trace.v1.Span.Link.fromObject(g.links[k])}}if(g.droppedLinksCount!=null&&(p.droppedLinksCount=g.droppedLinksCount>>>0),g.status!=null){if(typeof g.status!="object")throw TypeError(".opentelemetry.proto.trace.v1.Span.status: object expected");p.status=at.opentelemetry.proto.trace.v1.Status.fromObject(g.status)}return p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.attributes=[],k.events=[],k.links=[]),p.defaults){if(p.bytes===String?k.traceId="":(k.traceId=[],p.bytes!==Array&&(k.traceId=gt.newBuffer(k.traceId))),p.bytes===String?k.spanId="":(k.spanId=[],p.bytes!==Array&&(k.spanId=gt.newBuffer(k.spanId))),k.traceState="",p.bytes===String?k.parentSpanId="":(k.parentSpanId=[],p.bytes!==Array&&(k.parentSpanId=gt.newBuffer(k.parentSpanId))),k.name="",k.kind=p.enums===String?"SPAN_KIND_UNSPECIFIED":0,gt.Long){var j=new gt.Long(0,0,!1);k.startTimeUnixNano=p.longs===String?j.toString():p.longs===Number?j.toNumber():j}else k.startTimeUnixNano=p.longs===String?"0":0;if(gt.Long){var j=new gt.Long(0,0,!1);k.endTimeUnixNano=p.longs===String?j.toString():p.longs===Number?j.toNumber():j}else k.endTimeUnixNano=p.longs===String?"0":0;k.droppedAttributesCount=0,k.droppedEventsCount=0,k.droppedLinksCount=0,k.status=null}if(g.traceId!=null&&g.hasOwnProperty("traceId")&&(k.traceId=p.bytes===String?gt.base64.encode(g.traceId,0,g.traceId.length):p.bytes===Array?Array.prototype.slice.call(g.traceId):g.traceId),g.spanId!=null&&g.hasOwnProperty("spanId")&&(k.spanId=p.bytes===String?gt.base64.encode(g.spanId,0,g.spanId.length):p.bytes===Array?Array.prototype.slice.call(g.spanId):g.spanId),g.traceState!=null&&g.hasOwnProperty("traceState")&&(k.traceState=g.traceState),g.parentSpanId!=null&&g.hasOwnProperty("parentSpanId")&&(k.parentSpanId=p.bytes===String?gt.base64.encode(g.parentSpanId,0,g.parentSpanId.length):p.bytes===Array?Array.prototype.slice.call(g.parentSpanId):g.parentSpanId),g.name!=null&&g.hasOwnProperty("name")&&(k.name=g.name),g.kind!=null&&g.hasOwnProperty("kind")&&(k.kind=p.enums===String?at.opentelemetry.proto.trace.v1.Span.SpanKind[g.kind]===void 0?g.kind:at.opentelemetry.proto.trace.v1.Span.SpanKind[g.kind]:g.kind),g.startTimeUnixNano!=null&&g.hasOwnProperty("startTimeUnixNano")&&(typeof g.startTimeUnixNano=="number"?k.startTimeUnixNano=p.longs===String?String(g.startTimeUnixNano):g.startTimeUnixNano:k.startTimeUnixNano=p.longs===String?gt.Long.prototype.toString.call(g.startTimeUnixNano):p.longs===Number?new gt.LongBits(g.startTimeUnixNano.low>>>0,g.startTimeUnixNano.high>>>0).toNumber():g.startTimeUnixNano),g.endTimeUnixNano!=null&&g.hasOwnProperty("endTimeUnixNano")&&(typeof g.endTimeUnixNano=="number"?k.endTimeUnixNano=p.longs===String?String(g.endTimeUnixNano):g.endTimeUnixNano:k.endTimeUnixNano=p.longs===String?gt.Long.prototype.toString.call(g.endTimeUnixNano):p.longs===Number?new gt.LongBits(g.endTimeUnixNano.low>>>0,g.endTimeUnixNano.high>>>0).toNumber():g.endTimeUnixNano),g.attributes&&g.attributes.length){k.attributes=[];for(var se=0;se<g.attributes.length;++se)k.attributes[se]=at.opentelemetry.proto.common.v1.KeyValue.toObject(g.attributes[se],p)}if(g.droppedAttributesCount!=null&&g.hasOwnProperty("droppedAttributesCount")&&(k.droppedAttributesCount=g.droppedAttributesCount),g.events&&g.events.length){k.events=[];for(var se=0;se<g.events.length;++se)k.events[se]=at.opentelemetry.proto.trace.v1.Span.Event.toObject(g.events[se],p)}if(g.droppedEventsCount!=null&&g.hasOwnProperty("droppedEventsCount")&&(k.droppedEventsCount=g.droppedEventsCount),g.links&&g.links.length){k.links=[];for(var se=0;se<g.links.length;++se)k.links[se]=at.opentelemetry.proto.trace.v1.Span.Link.toObject(g.links[se],p)}return g.droppedLinksCount!=null&&g.hasOwnProperty("droppedLinksCount")&&(k.droppedLinksCount=g.droppedLinksCount),g.status!=null&&g.hasOwnProperty("status")&&(k.status=at.opentelemetry.proto.trace.v1.Status.toObject(g.status,p)),k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.trace.v1.Span"},b.SpanKind=function(){var A={},g=Object.create(A);return g[A[0]="SPAN_KIND_UNSPECIFIED"]=0,g[A[1]="SPAN_KIND_INTERNAL"]=1,g[A[2]="SPAN_KIND_SERVER"]=2,g[A[3]="SPAN_KIND_CLIENT"]=3,g[A[4]="SPAN_KIND_PRODUCER"]=4,g[A[5]="SPAN_KIND_CONSUMER"]=5,g}(),b.Event=function(){function A(g){if(this.attributes=[],g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}return A.prototype.timeUnixNano=null,A.prototype.name=null,A.prototype.attributes=gt.emptyArray,A.prototype.droppedAttributesCount=null,A.create=function(p){return new A(p)},A.encode=function(p,k){if(k||(k=gl.create()),p.timeUnixNano!=null&&Object.hasOwnProperty.call(p,"timeUnixNano")&&k.uint32(9).fixed64(p.timeUnixNano),p.name!=null&&Object.hasOwnProperty.call(p,"name")&&k.uint32(18).string(p.name),p.attributes!=null&&p.attributes.length)for(var j=0;j<p.attributes.length;++j)at.opentelemetry.proto.common.v1.KeyValue.encode(p.attributes[j],k.uint32(26).fork()).ldelim();return p.droppedAttributesCount!=null&&Object.hasOwnProperty.call(p,"droppedAttributesCount")&&k.uint32(32).uint32(p.droppedAttributesCount),k},A.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},A.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.trace.v1.Span.Event;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 1:{se.timeUnixNano=p.fixed64();break}case 2:{se.name=p.string();break}case 3:{se.attributes&&se.attributes.length||(se.attributes=[]),se.attributes.push(at.opentelemetry.proto.common.v1.KeyValue.decode(p,p.uint32()));break}case 4:{se.droppedAttributesCount=p.uint32();break}default:p.skipType(ze&7);break}}return se},A.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},A.verify=function(p){if(typeof p!="object"||p===null)return"object expected";if(p.timeUnixNano!=null&&p.hasOwnProperty("timeUnixNano")&&!gt.isInteger(p.timeUnixNano)&&!(p.timeUnixNano&&gt.isInteger(p.timeUnixNano.low)&&gt.isInteger(p.timeUnixNano.high)))return"timeUnixNano: integer|Long expected";if(p.name!=null&&p.hasOwnProperty("name")&&!gt.isString(p.name))return"name: string expected";if(p.attributes!=null&&p.hasOwnProperty("attributes")){if(!Array.isArray(p.attributes))return"attributes: array expected";for(var k=0;k<p.attributes.length;++k){var j=at.opentelemetry.proto.common.v1.KeyValue.verify(p.attributes[k]);if(j)return"attributes."+j}}return p.droppedAttributesCount!=null&&p.hasOwnProperty("droppedAttributesCount")&&!gt.isInteger(p.droppedAttributesCount)?"droppedAttributesCount: integer expected":null},A.fromObject=function(p){if(p instanceof at.opentelemetry.proto.trace.v1.Span.Event)return p;var k=new at.opentelemetry.proto.trace.v1.Span.Event;if(p.timeUnixNano!=null&&(gt.Long?(k.timeUnixNano=gt.Long.fromValue(p.timeUnixNano)).unsigned=!1:typeof p.timeUnixNano=="string"?k.timeUnixNano=parseInt(p.timeUnixNano,10):typeof p.timeUnixNano=="number"?k.timeUnixNano=p.timeUnixNano:typeof p.timeUnixNano=="object"&&(k.timeUnixNano=new gt.LongBits(p.timeUnixNano.low>>>0,p.timeUnixNano.high>>>0).toNumber())),p.name!=null&&(k.name=String(p.name)),p.attributes){if(!Array.isArray(p.attributes))throw TypeError(".opentelemetry.proto.trace.v1.Span.Event.attributes: array expected");k.attributes=[];for(var j=0;j<p.attributes.length;++j){if(typeof p.attributes[j]!="object")throw TypeError(".opentelemetry.proto.trace.v1.Span.Event.attributes: object expected");k.attributes[j]=at.opentelemetry.proto.common.v1.KeyValue.fromObject(p.attributes[j])}}return p.droppedAttributesCount!=null&&(k.droppedAttributesCount=p.droppedAttributesCount>>>0),k},A.toObject=function(p,k){k||(k={});var j={};if((k.arrays||k.defaults)&&(j.attributes=[]),k.defaults){if(gt.Long){var se=new gt.Long(0,0,!1);j.timeUnixNano=k.longs===String?se.toString():k.longs===Number?se.toNumber():se}else j.timeUnixNano=k.longs===String?"0":0;j.name="",j.droppedAttributesCount=0}if(p.timeUnixNano!=null&&p.hasOwnProperty("timeUnixNano")&&(typeof p.timeUnixNano=="number"?j.timeUnixNano=k.longs===String?String(p.timeUnixNano):p.timeUnixNano:j.timeUnixNano=k.longs===String?gt.Long.prototype.toString.call(p.timeUnixNano):k.longs===Number?new gt.LongBits(p.timeUnixNano.low>>>0,p.timeUnixNano.high>>>0).toNumber():p.timeUnixNano),p.name!=null&&p.hasOwnProperty("name")&&(j.name=p.name),p.attributes&&p.attributes.length){j.attributes=[];for(var ze=0;ze<p.attributes.length;++ze)j.attributes[ze]=at.opentelemetry.proto.common.v1.KeyValue.toObject(p.attributes[ze],k)}return p.droppedAttributesCount!=null&&p.hasOwnProperty("droppedAttributesCount")&&(j.droppedAttributesCount=p.droppedAttributesCount),j},A.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},A.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.trace.v1.Span.Event"},A}(),b.Link=function(){function A(g){if(this.attributes=[],g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}return A.prototype.traceId=null,A.prototype.spanId=null,A.prototype.traceState=null,A.prototype.attributes=gt.emptyArray,A.prototype.droppedAttributesCount=null,A.create=function(p){return new A(p)},A.encode=function(p,k){if(k||(k=gl.create()),p.traceId!=null&&Object.hasOwnProperty.call(p,"traceId")&&k.uint32(10).bytes(p.traceId),p.spanId!=null&&Object.hasOwnProperty.call(p,"spanId")&&k.uint32(18).bytes(p.spanId),p.traceState!=null&&Object.hasOwnProperty.call(p,"traceState")&&k.uint32(26).string(p.traceState),p.attributes!=null&&p.attributes.length)for(var j=0;j<p.attributes.length;++j)at.opentelemetry.proto.common.v1.KeyValue.encode(p.attributes[j],k.uint32(34).fork()).ldelim();return p.droppedAttributesCount!=null&&Object.hasOwnProperty.call(p,"droppedAttributesCount")&&k.uint32(40).uint32(p.droppedAttributesCount),k},A.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},A.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.trace.v1.Span.Link;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 1:{se.traceId=p.bytes();break}case 2:{se.spanId=p.bytes();break}case 3:{se.traceState=p.string();break}case 4:{se.attributes&&se.attributes.length||(se.attributes=[]),se.attributes.push(at.opentelemetry.proto.common.v1.KeyValue.decode(p,p.uint32()));break}case 5:{se.droppedAttributesCount=p.uint32();break}default:p.skipType(ze&7);break}}return se},A.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},A.verify=function(p){if(typeof p!="object"||p===null)return"object expected";if(p.traceId!=null&&p.hasOwnProperty("traceId")&&!(p.traceId&&typeof p.traceId.length=="number"||gt.isString(p.traceId)))return"traceId: buffer expected";if(p.spanId!=null&&p.hasOwnProperty("spanId")&&!(p.spanId&&typeof p.spanId.length=="number"||gt.isString(p.spanId)))return"spanId: buffer expected";if(p.traceState!=null&&p.hasOwnProperty("traceState")&&!gt.isString(p.traceState))return"traceState: string expected";if(p.attributes!=null&&p.hasOwnProperty("attributes")){if(!Array.isArray(p.attributes))return"attributes: array expected";for(var k=0;k<p.attributes.length;++k){var j=at.opentelemetry.proto.common.v1.KeyValue.verify(p.attributes[k]);if(j)return"attributes."+j}}return p.droppedAttributesCount!=null&&p.hasOwnProperty("droppedAttributesCount")&&!gt.isInteger(p.droppedAttributesCount)?"droppedAttributesCount: integer expected":null},A.fromObject=function(p){if(p instanceof at.opentelemetry.proto.trace.v1.Span.Link)return p;var k=new at.opentelemetry.proto.trace.v1.Span.Link;if(p.traceId!=null&&(typeof p.traceId=="string"?gt.base64.decode(p.traceId,k.traceId=gt.newBuffer(gt.base64.length(p.traceId)),0):p.traceId.length>=0&&(k.traceId=p.traceId)),p.spanId!=null&&(typeof p.spanId=="string"?gt.base64.decode(p.spanId,k.spanId=gt.newBuffer(gt.base64.length(p.spanId)),0):p.spanId.length>=0&&(k.spanId=p.spanId)),p.traceState!=null&&(k.traceState=String(p.traceState)),p.attributes){if(!Array.isArray(p.attributes))throw TypeError(".opentelemetry.proto.trace.v1.Span.Link.attributes: array expected");k.attributes=[];for(var j=0;j<p.attributes.length;++j){if(typeof p.attributes[j]!="object")throw TypeError(".opentelemetry.proto.trace.v1.Span.Link.attributes: object expected");k.attributes[j]=at.opentelemetry.proto.common.v1.KeyValue.fromObject(p.attributes[j])}}return p.droppedAttributesCount!=null&&(k.droppedAttributesCount=p.droppedAttributesCount>>>0),k},A.toObject=function(p,k){k||(k={});var j={};if((k.arrays||k.defaults)&&(j.attributes=[]),k.defaults&&(k.bytes===String?j.traceId="":(j.traceId=[],k.bytes!==Array&&(j.traceId=gt.newBuffer(j.traceId))),k.bytes===String?j.spanId="":(j.spanId=[],k.bytes!==Array&&(j.spanId=gt.newBuffer(j.spanId))),j.traceState="",j.droppedAttributesCount=0),p.traceId!=null&&p.hasOwnProperty("traceId")&&(j.traceId=k.bytes===String?gt.base64.encode(p.traceId,0,p.traceId.length):k.bytes===Array?Array.prototype.slice.call(p.traceId):p.traceId),p.spanId!=null&&p.hasOwnProperty("spanId")&&(j.spanId=k.bytes===String?gt.base64.encode(p.spanId,0,p.spanId.length):k.bytes===Array?Array.prototype.slice.call(p.spanId):p.spanId),p.traceState!=null&&p.hasOwnProperty("traceState")&&(j.traceState=p.traceState),p.attributes&&p.attributes.length){j.attributes=[];for(var se=0;se<p.attributes.length;++se)j.attributes[se]=at.opentelemetry.proto.common.v1.KeyValue.toObject(p.attributes[se],k)}return p.droppedAttributesCount!=null&&p.hasOwnProperty("droppedAttributesCount")&&(j.droppedAttributesCount=p.droppedAttributesCount),j},A.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},A.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.trace.v1.Span.Link"},A}(),b}(),y.Status=function(){function b(A){if(A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.message=null,b.prototype.code=null,b.create=function(g){return new b(g)},b.encode=function(g,p){return p||(p=gl.create()),g.message!=null&&Object.hasOwnProperty.call(g,"message")&&p.uint32(18).string(g.message),g.code!=null&&Object.hasOwnProperty.call(g,"code")&&p.uint32(24).int32(g.code),p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.trace.v1.Status;g.pos<k;){var se=g.uint32();switch(se>>>3){case 2:{j.message=g.string();break}case 3:{j.code=g.int32();break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.message!=null&&g.hasOwnProperty("message")&&!gt.isString(g.message))return"message: string expected";if(g.code!=null&&g.hasOwnProperty("code"))switch(g.code){default:return"code: enum value expected";case 0:case 1:case 2:break}return null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.trace.v1.Status)return g;var p=new at.opentelemetry.proto.trace.v1.Status;switch(g.message!=null&&(p.message=String(g.message)),g.code){default:if(typeof g.code=="number"){p.code=g.code;break}break;case"STATUS_CODE_UNSET":case 0:p.code=0;break;case"STATUS_CODE_OK":case 1:p.code=1;break;case"STATUS_CODE_ERROR":case 2:p.code=2;break}return p},b.toObject=function(g,p){p||(p={});var k={};return p.defaults&&(k.message="",k.code=p.enums===String?"STATUS_CODE_UNSET":0),g.message!=null&&g.hasOwnProperty("message")&&(k.message=g.message),g.code!=null&&g.hasOwnProperty("code")&&(k.code=p.enums===String?at.opentelemetry.proto.trace.v1.Status.StatusCode[g.code]===void 0?g.code:at.opentelemetry.proto.trace.v1.Status.StatusCode[g.code]:g.code),k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.trace.v1.Status"},b.StatusCode=function(){var A={},g=Object.create(A);return g[A[0]="STATUS_CODE_UNSET"]=0,g[A[1]="STATUS_CODE_OK"]=1,g[A[2]="STATUS_CODE_ERROR"]=2,g}(),b}(),y}(),f}(),c.collector=function(){var f={};return f.trace=function(){var y={};return y.v1=function(){var b={};return b.TraceService=function(){function A(g,p,k){Zo.rpc.Service.call(this,g,p,k)}return(A.prototype=Object.create(Zo.rpc.Service.prototype)).constructor=A,A.create=function(p,k,j){return new this(p,k,j)},Object.defineProperty(A.prototype.export=function g(p,k){return this.rpcCall(g,at.opentelemetry.proto.collector.trace.v1.ExportTraceServiceRequest,at.opentelemetry.proto.collector.trace.v1.ExportTraceServiceResponse,p,k)},"name",{value:"Export"}),A}(),b.ExportTraceServiceRequest=function(){function A(g){if(this.resourceSpans=[],g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}return A.prototype.resourceSpans=gt.emptyArray,A.create=function(p){return new A(p)},A.encode=function(p,k){if(k||(k=gl.create()),p.resourceSpans!=null&&p.resourceSpans.length)for(var j=0;j<p.resourceSpans.length;++j)at.opentelemetry.proto.trace.v1.ResourceSpans.encode(p.resourceSpans[j],k.uint32(10).fork()).ldelim();return k},A.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},A.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.collector.trace.v1.ExportTraceServiceRequest;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 1:{se.resourceSpans&&se.resourceSpans.length||(se.resourceSpans=[]),se.resourceSpans.push(at.opentelemetry.proto.trace.v1.ResourceSpans.decode(p,p.uint32()));break}default:p.skipType(ze&7);break}}return se},A.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},A.verify=function(p){if(typeof p!="object"||p===null)return"object expected";if(p.resourceSpans!=null&&p.hasOwnProperty("resourceSpans")){if(!Array.isArray(p.resourceSpans))return"resourceSpans: array expected";for(var k=0;k<p.resourceSpans.length;++k){var j=at.opentelemetry.proto.trace.v1.ResourceSpans.verify(p.resourceSpans[k]);if(j)return"resourceSpans."+j}}return null},A.fromObject=function(p){if(p instanceof at.opentelemetry.proto.collector.trace.v1.ExportTraceServiceRequest)return p;var k=new at.opentelemetry.proto.collector.trace.v1.ExportTraceServiceRequest;if(p.resourceSpans){if(!Array.isArray(p.resourceSpans))throw TypeError(".opentelemetry.proto.collector.trace.v1.ExportTraceServiceRequest.resourceSpans: array expected");k.resourceSpans=[];for(var j=0;j<p.resourceSpans.length;++j){if(typeof p.resourceSpans[j]!="object")throw TypeError(".opentelemetry.proto.collector.trace.v1.ExportTraceServiceRequest.resourceSpans: object expected");k.resourceSpans[j]=at.opentelemetry.proto.trace.v1.ResourceSpans.fromObject(p.resourceSpans[j])}}return k},A.toObject=function(p,k){k||(k={});var j={};if((k.arrays||k.defaults)&&(j.resourceSpans=[]),p.resourceSpans&&p.resourceSpans.length){j.resourceSpans=[];for(var se=0;se<p.resourceSpans.length;++se)j.resourceSpans[se]=at.opentelemetry.proto.trace.v1.ResourceSpans.toObject(p.resourceSpans[se],k)}return j},A.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},A.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.collector.trace.v1.ExportTraceServiceRequest"},A}(),b.ExportTraceServiceResponse=function(){function A(g){if(g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}return A.prototype.partialSuccess=null,A.create=function(p){return new A(p)},A.encode=function(p,k){return k||(k=gl.create()),p.partialSuccess!=null&&Object.hasOwnProperty.call(p,"partialSuccess")&&at.opentelemetry.proto.collector.trace.v1.ExportTracePartialSuccess.encode(p.partialSuccess,k.uint32(10).fork()).ldelim(),k},A.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},A.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.collector.trace.v1.ExportTraceServiceResponse;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 1:{se.partialSuccess=at.opentelemetry.proto.collector.trace.v1.ExportTracePartialSuccess.decode(p,p.uint32());break}default:p.skipType(ze&7);break}}return se},A.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},A.verify=function(p){if(typeof p!="object"||p===null)return"object expected";if(p.partialSuccess!=null&&p.hasOwnProperty("partialSuccess")){var k=at.opentelemetry.proto.collector.trace.v1.ExportTracePartialSuccess.verify(p.partialSuccess);if(k)return"partialSuccess."+k}return null},A.fromObject=function(p){if(p instanceof at.opentelemetry.proto.collector.trace.v1.ExportTraceServiceResponse)return p;var k=new at.opentelemetry.proto.collector.trace.v1.ExportTraceServiceResponse;if(p.partialSuccess!=null){if(typeof p.partialSuccess!="object")throw TypeError(".opentelemetry.proto.collector.trace.v1.ExportTraceServiceResponse.partialSuccess: object expected");k.partialSuccess=at.opentelemetry.proto.collector.trace.v1.ExportTracePartialSuccess.fromObject(p.partialSuccess)}return k},A.toObject=function(p,k){k||(k={});var j={};return k.defaults&&(j.partialSuccess=null),p.partialSuccess!=null&&p.hasOwnProperty("partialSuccess")&&(j.partialSuccess=at.opentelemetry.proto.collector.trace.v1.ExportTracePartialSuccess.toObject(p.partialSuccess,k)),j},A.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},A.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.collector.trace.v1.ExportTraceServiceResponse"},A}(),b.ExportTracePartialSuccess=function(){function A(g){if(g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}return A.prototype.rejectedSpans=null,A.prototype.errorMessage=null,A.create=function(p){return new A(p)},A.encode=function(p,k){return k||(k=gl.create()),p.rejectedSpans!=null&&Object.hasOwnProperty.call(p,"rejectedSpans")&&k.uint32(8).int64(p.rejectedSpans),p.errorMessage!=null&&Object.hasOwnProperty.call(p,"errorMessage")&&k.uint32(18).string(p.errorMessage),k},A.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},A.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.collector.trace.v1.ExportTracePartialSuccess;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 1:{se.rejectedSpans=p.int64();break}case 2:{se.errorMessage=p.string();break}default:p.skipType(ze&7);break}}return se},A.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},A.verify=function(p){return typeof p!="object"||p===null?"object expected":p.rejectedSpans!=null&&p.hasOwnProperty("rejectedSpans")&&!gt.isInteger(p.rejectedSpans)&&!(p.rejectedSpans&&gt.isInteger(p.rejectedSpans.low)&&gt.isInteger(p.rejectedSpans.high))?"rejectedSpans: integer|Long expected":p.errorMessage!=null&&p.hasOwnProperty("errorMessage")&&!gt.isString(p.errorMessage)?"errorMessage: string expected":null},A.fromObject=function(p){if(p instanceof at.opentelemetry.proto.collector.trace.v1.ExportTracePartialSuccess)return p;var k=new at.opentelemetry.proto.collector.trace.v1.ExportTracePartialSuccess;return p.rejectedSpans!=null&&(gt.Long?(k.rejectedSpans=gt.Long.fromValue(p.rejectedSpans)).unsigned=!1:typeof p.rejectedSpans=="string"?k.rejectedSpans=parseInt(p.rejectedSpans,10):typeof p.rejectedSpans=="number"?k.rejectedSpans=p.rejectedSpans:typeof p.rejectedSpans=="object"&&(k.rejectedSpans=new gt.LongBits(p.rejectedSpans.low>>>0,p.rejectedSpans.high>>>0).toNumber())),p.errorMessage!=null&&(k.errorMessage=String(p.errorMessage)),k},A.toObject=function(p,k){k||(k={});var j={};if(k.defaults){if(gt.Long){var se=new gt.Long(0,0,!1);j.rejectedSpans=k.longs===String?se.toString():k.longs===Number?se.toNumber():se}else j.rejectedSpans=k.longs===String?"0":0;j.errorMessage=""}return p.rejectedSpans!=null&&p.hasOwnProperty("rejectedSpans")&&(typeof p.rejectedSpans=="number"?j.rejectedSpans=k.longs===String?String(p.rejectedSpans):p.rejectedSpans:j.rejectedSpans=k.longs===String?gt.Long.prototype.toString.call(p.rejectedSpans):k.longs===Number?new gt.LongBits(p.rejectedSpans.low>>>0,p.rejectedSpans.high>>>0).toNumber():p.rejectedSpans),p.errorMessage!=null&&p.hasOwnProperty("errorMessage")&&(j.errorMessage=p.errorMessage),j},A.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},A.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.collector.trace.v1.ExportTracePartialSuccess"},A}(),b}(),y}(),f.metrics=function(){var y={};return y.v1=function(){var b={};return b.MetricsService=function(){function A(g,p,k){Zo.rpc.Service.call(this,g,p,k)}return(A.prototype=Object.create(Zo.rpc.Service.prototype)).constructor=A,A.create=function(p,k,j){return new this(p,k,j)},Object.defineProperty(A.prototype.export=function g(p,k){return this.rpcCall(g,at.opentelemetry.proto.collector.metrics.v1.ExportMetricsServiceRequest,at.opentelemetry.proto.collector.metrics.v1.ExportMetricsServiceResponse,p,k)},"name",{value:"Export"}),A}(),b.ExportMetricsServiceRequest=function(){function A(g){if(this.resourceMetrics=[],g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}return A.prototype.resourceMetrics=gt.emptyArray,A.create=function(p){return new A(p)},A.encode=function(p,k){if(k||(k=gl.create()),p.resourceMetrics!=null&&p.resourceMetrics.length)for(var j=0;j<p.resourceMetrics.length;++j)at.opentelemetry.proto.metrics.v1.ResourceMetrics.encode(p.resourceMetrics[j],k.uint32(10).fork()).ldelim();return k},A.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},A.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.collector.metrics.v1.ExportMetricsServiceRequest;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 1:{se.resourceMetrics&&se.resourceMetrics.length||(se.resourceMetrics=[]),se.resourceMetrics.push(at.opentelemetry.proto.metrics.v1.ResourceMetrics.decode(p,p.uint32()));break}default:p.skipType(ze&7);break}}return se},A.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},A.verify=function(p){if(typeof p!="object"||p===null)return"object expected";if(p.resourceMetrics!=null&&p.hasOwnProperty("resourceMetrics")){if(!Array.isArray(p.resourceMetrics))return"resourceMetrics: array expected";for(var k=0;k<p.resourceMetrics.length;++k){var j=at.opentelemetry.proto.metrics.v1.ResourceMetrics.verify(p.resourceMetrics[k]);if(j)return"resourceMetrics."+j}}return null},A.fromObject=function(p){if(p instanceof at.opentelemetry.proto.collector.metrics.v1.ExportMetricsServiceRequest)return p;var k=new at.opentelemetry.proto.collector.metrics.v1.ExportMetricsServiceRequest;if(p.resourceMetrics){if(!Array.isArray(p.resourceMetrics))throw TypeError(".opentelemetry.proto.collector.metrics.v1.ExportMetricsServiceRequest.resourceMetrics: array expected");k.resourceMetrics=[];for(var j=0;j<p.resourceMetrics.length;++j){if(typeof p.resourceMetrics[j]!="object")throw TypeError(".opentelemetry.proto.collector.metrics.v1.ExportMetricsServiceRequest.resourceMetrics: object expected");k.resourceMetrics[j]=at.opentelemetry.proto.metrics.v1.ResourceMetrics.fromObject(p.resourceMetrics[j])}}return k},A.toObject=function(p,k){k||(k={});var j={};if((k.arrays||k.defaults)&&(j.resourceMetrics=[]),p.resourceMetrics&&p.resourceMetrics.length){j.resourceMetrics=[];for(var se=0;se<p.resourceMetrics.length;++se)j.resourceMetrics[se]=at.opentelemetry.proto.metrics.v1.ResourceMetrics.toObject(p.resourceMetrics[se],k)}return j},A.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},A.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.collector.metrics.v1.ExportMetricsServiceRequest"},A}(),b.ExportMetricsServiceResponse=function(){function A(g){if(g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}return A.prototype.partialSuccess=null,A.create=function(p){return new A(p)},A.encode=function(p,k){return k||(k=gl.create()),p.partialSuccess!=null&&Object.hasOwnProperty.call(p,"partialSuccess")&&at.opentelemetry.proto.collector.metrics.v1.ExportMetricsPartialSuccess.encode(p.partialSuccess,k.uint32(10).fork()).ldelim(),k},A.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},A.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.collector.metrics.v1.ExportMetricsServiceResponse;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 1:{se.partialSuccess=at.opentelemetry.proto.collector.metrics.v1.ExportMetricsPartialSuccess.decode(p,p.uint32());break}default:p.skipType(ze&7);break}}return se},A.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},A.verify=function(p){if(typeof p!="object"||p===null)return"object expected";if(p.partialSuccess!=null&&p.hasOwnProperty("partialSuccess")){var k=at.opentelemetry.proto.collector.metrics.v1.ExportMetricsPartialSuccess.verify(p.partialSuccess);if(k)return"partialSuccess."+k}return null},A.fromObject=function(p){if(p instanceof at.opentelemetry.proto.collector.metrics.v1.ExportMetricsServiceResponse)return p;var k=new at.opentelemetry.proto.collector.metrics.v1.ExportMetricsServiceResponse;if(p.partialSuccess!=null){if(typeof p.partialSuccess!="object")throw TypeError(".opentelemetry.proto.collector.metrics.v1.ExportMetricsServiceResponse.partialSuccess: object expected");k.partialSuccess=at.opentelemetry.proto.collector.metrics.v1.ExportMetricsPartialSuccess.fromObject(p.partialSuccess)}return k},A.toObject=function(p,k){k||(k={});var j={};return k.defaults&&(j.partialSuccess=null),p.partialSuccess!=null&&p.hasOwnProperty("partialSuccess")&&(j.partialSuccess=at.opentelemetry.proto.collector.metrics.v1.ExportMetricsPartialSuccess.toObject(p.partialSuccess,k)),j},A.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},A.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.collector.metrics.v1.ExportMetricsServiceResponse"},A}(),b.ExportMetricsPartialSuccess=function(){function A(g){if(g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}return A.prototype.rejectedDataPoints=null,A.prototype.errorMessage=null,A.create=function(p){return new A(p)},A.encode=function(p,k){return k||(k=gl.create()),p.rejectedDataPoints!=null&&Object.hasOwnProperty.call(p,"rejectedDataPoints")&&k.uint32(8).int64(p.rejectedDataPoints),p.errorMessage!=null&&Object.hasOwnProperty.call(p,"errorMessage")&&k.uint32(18).string(p.errorMessage),k},A.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},A.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.collector.metrics.v1.ExportMetricsPartialSuccess;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 1:{se.rejectedDataPoints=p.int64();break}case 2:{se.errorMessage=p.string();break}default:p.skipType(ze&7);break}}return se},A.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},A.verify=function(p){return typeof p!="object"||p===null?"object expected":p.rejectedDataPoints!=null&&p.hasOwnProperty("rejectedDataPoints")&&!gt.isInteger(p.rejectedDataPoints)&&!(p.rejectedDataPoints&&gt.isInteger(p.rejectedDataPoints.low)&&gt.isInteger(p.rejectedDataPoints.high))?"rejectedDataPoints: integer|Long expected":p.errorMessage!=null&&p.hasOwnProperty("errorMessage")&&!gt.isString(p.errorMessage)?"errorMessage: string expected":null},A.fromObject=function(p){if(p instanceof at.opentelemetry.proto.collector.metrics.v1.ExportMetricsPartialSuccess)return p;var k=new at.opentelemetry.proto.collector.metrics.v1.ExportMetricsPartialSuccess;return p.rejectedDataPoints!=null&&(gt.Long?(k.rejectedDataPoints=gt.Long.fromValue(p.rejectedDataPoints)).unsigned=!1:typeof p.rejectedDataPoints=="string"?k.rejectedDataPoints=parseInt(p.rejectedDataPoints,10):typeof p.rejectedDataPoints=="number"?k.rejectedDataPoints=p.rejectedDataPoints:typeof p.rejectedDataPoints=="object"&&(k.rejectedDataPoints=new gt.LongBits(p.rejectedDataPoints.low>>>0,p.rejectedDataPoints.high>>>0).toNumber())),p.errorMessage!=null&&(k.errorMessage=String(p.errorMessage)),k},A.toObject=function(p,k){k||(k={});var j={};if(k.defaults){if(gt.Long){var se=new gt.Long(0,0,!1);j.rejectedDataPoints=k.longs===String?se.toString():k.longs===Number?se.toNumber():se}else j.rejectedDataPoints=k.longs===String?"0":0;j.errorMessage=""}return p.rejectedDataPoints!=null&&p.hasOwnProperty("rejectedDataPoints")&&(typeof p.rejectedDataPoints=="number"?j.rejectedDataPoints=k.longs===String?String(p.rejectedDataPoints):p.rejectedDataPoints:j.rejectedDataPoints=k.longs===String?gt.Long.prototype.toString.call(p.rejectedDataPoints):k.longs===Number?new gt.LongBits(p.rejectedDataPoints.low>>>0,p.rejectedDataPoints.high>>>0).toNumber():p.rejectedDataPoints),p.errorMessage!=null&&p.hasOwnProperty("errorMessage")&&(j.errorMessage=p.errorMessage),j},A.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},A.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.collector.metrics.v1.ExportMetricsPartialSuccess"},A}(),b}(),y}(),f.logs=function(){var y={};return y.v1=function(){var b={};return b.LogsService=function(){function A(g,p,k){Zo.rpc.Service.call(this,g,p,k)}return(A.prototype=Object.create(Zo.rpc.Service.prototype)).constructor=A,A.create=function(p,k,j){return new this(p,k,j)},Object.defineProperty(A.prototype.export=function g(p,k){return this.rpcCall(g,at.opentelemetry.proto.collector.logs.v1.ExportLogsServiceRequest,at.opentelemetry.proto.collector.logs.v1.ExportLogsServiceResponse,p,k)},"name",{value:"Export"}),A}(),b.ExportLogsServiceRequest=function(){function A(g){if(this.resourceLogs=[],g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}return A.prototype.resourceLogs=gt.emptyArray,A.create=function(p){return new A(p)},A.encode=function(p,k){if(k||(k=gl.create()),p.resourceLogs!=null&&p.resourceLogs.length)for(var j=0;j<p.resourceLogs.length;++j)at.opentelemetry.proto.logs.v1.ResourceLogs.encode(p.resourceLogs[j],k.uint32(10).fork()).ldelim();return k},A.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},A.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.collector.logs.v1.ExportLogsServiceRequest;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 1:{se.resourceLogs&&se.resourceLogs.length||(se.resourceLogs=[]),se.resourceLogs.push(at.opentelemetry.proto.logs.v1.ResourceLogs.decode(p,p.uint32()));break}default:p.skipType(ze&7);break}}return se},A.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},A.verify=function(p){if(typeof p!="object"||p===null)return"object expected";if(p.resourceLogs!=null&&p.hasOwnProperty("resourceLogs")){if(!Array.isArray(p.resourceLogs))return"resourceLogs: array expected";for(var k=0;k<p.resourceLogs.length;++k){var j=at.opentelemetry.proto.logs.v1.ResourceLogs.verify(p.resourceLogs[k]);if(j)return"resourceLogs."+j}}return null},A.fromObject=function(p){if(p instanceof at.opentelemetry.proto.collector.logs.v1.ExportLogsServiceRequest)return p;var k=new at.opentelemetry.proto.collector.logs.v1.ExportLogsServiceRequest;if(p.resourceLogs){if(!Array.isArray(p.resourceLogs))throw TypeError(".opentelemetry.proto.collector.logs.v1.ExportLogsServiceRequest.resourceLogs: array expected");k.resourceLogs=[];for(var j=0;j<p.resourceLogs.length;++j){if(typeof p.resourceLogs[j]!="object")throw TypeError(".opentelemetry.proto.collector.logs.v1.ExportLogsServiceRequest.resourceLogs: object expected");k.resourceLogs[j]=at.opentelemetry.proto.logs.v1.ResourceLogs.fromObject(p.resourceLogs[j])}}return k},A.toObject=function(p,k){k||(k={});var j={};if((k.arrays||k.defaults)&&(j.resourceLogs=[]),p.resourceLogs&&p.resourceLogs.length){j.resourceLogs=[];for(var se=0;se<p.resourceLogs.length;++se)j.resourceLogs[se]=at.opentelemetry.proto.logs.v1.ResourceLogs.toObject(p.resourceLogs[se],k)}return j},A.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},A.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.collector.logs.v1.ExportLogsServiceRequest"},A}(),b.ExportLogsServiceResponse=function(){function A(g){if(g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}return A.prototype.partialSuccess=null,A.create=function(p){return new A(p)},A.encode=function(p,k){return k||(k=gl.create()),p.partialSuccess!=null&&Object.hasOwnProperty.call(p,"partialSuccess")&&at.opentelemetry.proto.collector.logs.v1.ExportLogsPartialSuccess.encode(p.partialSuccess,k.uint32(10).fork()).ldelim(),k},A.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},A.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.collector.logs.v1.ExportLogsServiceResponse;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 1:{se.partialSuccess=at.opentelemetry.proto.collector.logs.v1.ExportLogsPartialSuccess.decode(p,p.uint32());break}default:p.skipType(ze&7);break}}return se},A.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},A.verify=function(p){if(typeof p!="object"||p===null)return"object expected";if(p.partialSuccess!=null&&p.hasOwnProperty("partialSuccess")){var k=at.opentelemetry.proto.collector.logs.v1.ExportLogsPartialSuccess.verify(p.partialSuccess);if(k)return"partialSuccess."+k}return null},A.fromObject=function(p){if(p instanceof at.opentelemetry.proto.collector.logs.v1.ExportLogsServiceResponse)return p;var k=new at.opentelemetry.proto.collector.logs.v1.ExportLogsServiceResponse;if(p.partialSuccess!=null){if(typeof p.partialSuccess!="object")throw TypeError(".opentelemetry.proto.collector.logs.v1.ExportLogsServiceResponse.partialSuccess: object expected");k.partialSuccess=at.opentelemetry.proto.collector.logs.v1.ExportLogsPartialSuccess.fromObject(p.partialSuccess)}return k},A.toObject=function(p,k){k||(k={});var j={};return k.defaults&&(j.partialSuccess=null),p.partialSuccess!=null&&p.hasOwnProperty("partialSuccess")&&(j.partialSuccess=at.opentelemetry.proto.collector.logs.v1.ExportLogsPartialSuccess.toObject(p.partialSuccess,k)),j},A.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},A.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.collector.logs.v1.ExportLogsServiceResponse"},A}(),b.ExportLogsPartialSuccess=function(){function A(g){if(g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}return A.prototype.rejectedLogRecords=null,A.prototype.errorMessage=null,A.create=function(p){return new A(p)},A.encode=function(p,k){return k||(k=gl.create()),p.rejectedLogRecords!=null&&Object.hasOwnProperty.call(p,"rejectedLogRecords")&&k.uint32(8).int64(p.rejectedLogRecords),p.errorMessage!=null&&Object.hasOwnProperty.call(p,"errorMessage")&&k.uint32(18).string(p.errorMessage),k},A.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},A.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.collector.logs.v1.ExportLogsPartialSuccess;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 1:{se.rejectedLogRecords=p.int64();break}case 2:{se.errorMessage=p.string();break}default:p.skipType(ze&7);break}}return se},A.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},A.verify=function(p){return typeof p!="object"||p===null?"object expected":p.rejectedLogRecords!=null&&p.hasOwnProperty("rejectedLogRecords")&&!gt.isInteger(p.rejectedLogRecords)&&!(p.rejectedLogRecords&&gt.isInteger(p.rejectedLogRecords.low)&&gt.isInteger(p.rejectedLogRecords.high))?"rejectedLogRecords: integer|Long expected":p.errorMessage!=null&&p.hasOwnProperty("errorMessage")&&!gt.isString(p.errorMessage)?"errorMessage: string expected":null},A.fromObject=function(p){if(p instanceof at.opentelemetry.proto.collector.logs.v1.ExportLogsPartialSuccess)return p;var k=new at.opentelemetry.proto.collector.logs.v1.ExportLogsPartialSuccess;return p.rejectedLogRecords!=null&&(gt.Long?(k.rejectedLogRecords=gt.Long.fromValue(p.rejectedLogRecords)).unsigned=!1:typeof p.rejectedLogRecords=="string"?k.rejectedLogRecords=parseInt(p.rejectedLogRecords,10):typeof p.rejectedLogRecords=="number"?k.rejectedLogRecords=p.rejectedLogRecords:typeof p.rejectedLogRecords=="object"&&(k.rejectedLogRecords=new gt.LongBits(p.rejectedLogRecords.low>>>0,p.rejectedLogRecords.high>>>0).toNumber())),p.errorMessage!=null&&(k.errorMessage=String(p.errorMessage)),k},A.toObject=function(p,k){k||(k={});var j={};if(k.defaults){if(gt.Long){var se=new gt.Long(0,0,!1);j.rejectedLogRecords=k.longs===String?se.toString():k.longs===Number?se.toNumber():se}else j.rejectedLogRecords=k.longs===String?"0":0;j.errorMessage=""}return p.rejectedLogRecords!=null&&p.hasOwnProperty("rejectedLogRecords")&&(typeof p.rejectedLogRecords=="number"?j.rejectedLogRecords=k.longs===String?String(p.rejectedLogRecords):p.rejectedLogRecords:j.rejectedLogRecords=k.longs===String?gt.Long.prototype.toString.call(p.rejectedLogRecords):k.longs===Number?new gt.LongBits(p.rejectedLogRecords.low>>>0,p.rejectedLogRecords.high>>>0).toNumber():p.rejectedLogRecords),p.errorMessage!=null&&p.hasOwnProperty("errorMessage")&&(j.errorMessage=p.errorMessage),j},A.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},A.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.collector.logs.v1.ExportLogsPartialSuccess"},A}(),b}(),y}(),f}(),c.metrics=function(){var f={};return f.v1=function(){var y={};return y.MetricsData=function(){function b(A){if(this.resourceMetrics=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.resourceMetrics=gt.emptyArray,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.resourceMetrics!=null&&g.resourceMetrics.length)for(var k=0;k<g.resourceMetrics.length;++k)at.opentelemetry.proto.metrics.v1.ResourceMetrics.encode(g.resourceMetrics[k],p.uint32(10).fork()).ldelim();return p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.metrics.v1.MetricsData;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.resourceMetrics&&j.resourceMetrics.length||(j.resourceMetrics=[]),j.resourceMetrics.push(at.opentelemetry.proto.metrics.v1.ResourceMetrics.decode(g,g.uint32()));break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.resourceMetrics!=null&&g.hasOwnProperty("resourceMetrics")){if(!Array.isArray(g.resourceMetrics))return"resourceMetrics: array expected";for(var p=0;p<g.resourceMetrics.length;++p){var k=at.opentelemetry.proto.metrics.v1.ResourceMetrics.verify(g.resourceMetrics[p]);if(k)return"resourceMetrics."+k}}return null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.metrics.v1.MetricsData)return g;var p=new at.opentelemetry.proto.metrics.v1.MetricsData;if(g.resourceMetrics){if(!Array.isArray(g.resourceMetrics))throw TypeError(".opentelemetry.proto.metrics.v1.MetricsData.resourceMetrics: array expected");p.resourceMetrics=[];for(var k=0;k<g.resourceMetrics.length;++k){if(typeof g.resourceMetrics[k]!="object")throw TypeError(".opentelemetry.proto.metrics.v1.MetricsData.resourceMetrics: object expected");p.resourceMetrics[k]=at.opentelemetry.proto.metrics.v1.ResourceMetrics.fromObject(g.resourceMetrics[k])}}return p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.resourceMetrics=[]),g.resourceMetrics&&g.resourceMetrics.length){k.resourceMetrics=[];for(var j=0;j<g.resourceMetrics.length;++j)k.resourceMetrics[j]=at.opentelemetry.proto.metrics.v1.ResourceMetrics.toObject(g.resourceMetrics[j],p)}return k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.metrics.v1.MetricsData"},b}(),y.ResourceMetrics=function(){function b(A){if(this.scopeMetrics=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.resource=null,b.prototype.scopeMetrics=gt.emptyArray,b.prototype.schemaUrl=null,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.resource!=null&&Object.hasOwnProperty.call(g,"resource")&&at.opentelemetry.proto.resource.v1.Resource.encode(g.resource,p.uint32(10).fork()).ldelim(),g.scopeMetrics!=null&&g.scopeMetrics.length)for(var k=0;k<g.scopeMetrics.length;++k)at.opentelemetry.proto.metrics.v1.ScopeMetrics.encode(g.scopeMetrics[k],p.uint32(18).fork()).ldelim();return g.schemaUrl!=null&&Object.hasOwnProperty.call(g,"schemaUrl")&&p.uint32(26).string(g.schemaUrl),p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.metrics.v1.ResourceMetrics;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.resource=at.opentelemetry.proto.resource.v1.Resource.decode(g,g.uint32());break}case 2:{j.scopeMetrics&&j.scopeMetrics.length||(j.scopeMetrics=[]),j.scopeMetrics.push(at.opentelemetry.proto.metrics.v1.ScopeMetrics.decode(g,g.uint32()));break}case 3:{j.schemaUrl=g.string();break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.resource!=null&&g.hasOwnProperty("resource")){var p=at.opentelemetry.proto.resource.v1.Resource.verify(g.resource);if(p)return"resource."+p}if(g.scopeMetrics!=null&&g.hasOwnProperty("scopeMetrics")){if(!Array.isArray(g.scopeMetrics))return"scopeMetrics: array expected";for(var k=0;k<g.scopeMetrics.length;++k){var p=at.opentelemetry.proto.metrics.v1.ScopeMetrics.verify(g.scopeMetrics[k]);if(p)return"scopeMetrics."+p}}return g.schemaUrl!=null&&g.hasOwnProperty("schemaUrl")&&!gt.isString(g.schemaUrl)?"schemaUrl: string expected":null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.metrics.v1.ResourceMetrics)return g;var p=new at.opentelemetry.proto.metrics.v1.ResourceMetrics;if(g.resource!=null){if(typeof g.resource!="object")throw TypeError(".opentelemetry.proto.metrics.v1.ResourceMetrics.resource: object expected");p.resource=at.opentelemetry.proto.resource.v1.Resource.fromObject(g.resource)}if(g.scopeMetrics){if(!Array.isArray(g.scopeMetrics))throw TypeError(".opentelemetry.proto.metrics.v1.ResourceMetrics.scopeMetrics: array expected");p.scopeMetrics=[];for(var k=0;k<g.scopeMetrics.length;++k){if(typeof g.scopeMetrics[k]!="object")throw TypeError(".opentelemetry.proto.metrics.v1.ResourceMetrics.scopeMetrics: object expected");p.scopeMetrics[k]=at.opentelemetry.proto.metrics.v1.ScopeMetrics.fromObject(g.scopeMetrics[k])}}return g.schemaUrl!=null&&(p.schemaUrl=String(g.schemaUrl)),p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.scopeMetrics=[]),p.defaults&&(k.resource=null,k.schemaUrl=""),g.resource!=null&&g.hasOwnProperty("resource")&&(k.resource=at.opentelemetry.proto.resource.v1.Resource.toObject(g.resource,p)),g.scopeMetrics&&g.scopeMetrics.length){k.scopeMetrics=[];for(var j=0;j<g.scopeMetrics.length;++j)k.scopeMetrics[j]=at.opentelemetry.proto.metrics.v1.ScopeMetrics.toObject(g.scopeMetrics[j],p)}return g.schemaUrl!=null&&g.hasOwnProperty("schemaUrl")&&(k.schemaUrl=g.schemaUrl),k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.metrics.v1.ResourceMetrics"},b}(),y.ScopeMetrics=function(){function b(A){if(this.metrics=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.scope=null,b.prototype.metrics=gt.emptyArray,b.prototype.schemaUrl=null,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.scope!=null&&Object.hasOwnProperty.call(g,"scope")&&at.opentelemetry.proto.common.v1.InstrumentationScope.encode(g.scope,p.uint32(10).fork()).ldelim(),g.metrics!=null&&g.metrics.length)for(var k=0;k<g.metrics.length;++k)at.opentelemetry.proto.metrics.v1.Metric.encode(g.metrics[k],p.uint32(18).fork()).ldelim();return g.schemaUrl!=null&&Object.hasOwnProperty.call(g,"schemaUrl")&&p.uint32(26).string(g.schemaUrl),p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.metrics.v1.ScopeMetrics;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.scope=at.opentelemetry.proto.common.v1.InstrumentationScope.decode(g,g.uint32());break}case 2:{j.metrics&&j.metrics.length||(j.metrics=[]),j.metrics.push(at.opentelemetry.proto.metrics.v1.Metric.decode(g,g.uint32()));break}case 3:{j.schemaUrl=g.string();break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.scope!=null&&g.hasOwnProperty("scope")){var p=at.opentelemetry.proto.common.v1.InstrumentationScope.verify(g.scope);if(p)return"scope."+p}if(g.metrics!=null&&g.hasOwnProperty("metrics")){if(!Array.isArray(g.metrics))return"metrics: array expected";for(var k=0;k<g.metrics.length;++k){var p=at.opentelemetry.proto.metrics.v1.Metric.verify(g.metrics[k]);if(p)return"metrics."+p}}return g.schemaUrl!=null&&g.hasOwnProperty("schemaUrl")&&!gt.isString(g.schemaUrl)?"schemaUrl: string expected":null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.metrics.v1.ScopeMetrics)return g;var p=new at.opentelemetry.proto.metrics.v1.ScopeMetrics;if(g.scope!=null){if(typeof g.scope!="object")throw TypeError(".opentelemetry.proto.metrics.v1.ScopeMetrics.scope: object expected");p.scope=at.opentelemetry.proto.common.v1.InstrumentationScope.fromObject(g.scope)}if(g.metrics){if(!Array.isArray(g.metrics))throw TypeError(".opentelemetry.proto.metrics.v1.ScopeMetrics.metrics: array expected");p.metrics=[];for(var k=0;k<g.metrics.length;++k){if(typeof g.metrics[k]!="object")throw TypeError(".opentelemetry.proto.metrics.v1.ScopeMetrics.metrics: object expected");p.metrics[k]=at.opentelemetry.proto.metrics.v1.Metric.fromObject(g.metrics[k])}}return g.schemaUrl!=null&&(p.schemaUrl=String(g.schemaUrl)),p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.metrics=[]),p.defaults&&(k.scope=null,k.schemaUrl=""),g.scope!=null&&g.hasOwnProperty("scope")&&(k.scope=at.opentelemetry.proto.common.v1.InstrumentationScope.toObject(g.scope,p)),g.metrics&&g.metrics.length){k.metrics=[];for(var j=0;j<g.metrics.length;++j)k.metrics[j]=at.opentelemetry.proto.metrics.v1.Metric.toObject(g.metrics[j],p)}return g.schemaUrl!=null&&g.hasOwnProperty("schemaUrl")&&(k.schemaUrl=g.schemaUrl),k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.metrics.v1.ScopeMetrics"},b}(),y.Metric=function(){function b(g){if(g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}b.prototype.name=null,b.prototype.description=null,b.prototype.unit=null,b.prototype.gauge=null,b.prototype.sum=null,b.prototype.histogram=null,b.prototype.exponentialHistogram=null,b.prototype.summary=null;var A;return Object.defineProperty(b.prototype,"data",{get:gt.oneOfGetter(A=["gauge","sum","histogram","exponentialHistogram","summary"]),set:gt.oneOfSetter(A)}),b.create=function(p){return new b(p)},b.encode=function(p,k){return k||(k=gl.create()),p.name!=null&&Object.hasOwnProperty.call(p,"name")&&k.uint32(10).string(p.name),p.description!=null&&Object.hasOwnProperty.call(p,"description")&&k.uint32(18).string(p.description),p.unit!=null&&Object.hasOwnProperty.call(p,"unit")&&k.uint32(26).string(p.unit),p.gauge!=null&&Object.hasOwnProperty.call(p,"gauge")&&at.opentelemetry.proto.metrics.v1.Gauge.encode(p.gauge,k.uint32(42).fork()).ldelim(),p.sum!=null&&Object.hasOwnProperty.call(p,"sum")&&at.opentelemetry.proto.metrics.v1.Sum.encode(p.sum,k.uint32(58).fork()).ldelim(),p.histogram!=null&&Object.hasOwnProperty.call(p,"histogram")&&at.opentelemetry.proto.metrics.v1.Histogram.encode(p.histogram,k.uint32(74).fork()).ldelim(),p.exponentialHistogram!=null&&Object.hasOwnProperty.call(p,"exponentialHistogram")&&at.opentelemetry.proto.metrics.v1.ExponentialHistogram.encode(p.exponentialHistogram,k.uint32(82).fork()).ldelim(),p.summary!=null&&Object.hasOwnProperty.call(p,"summary")&&at.opentelemetry.proto.metrics.v1.Summary.encode(p.summary,k.uint32(90).fork()).ldelim(),k},b.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},b.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.metrics.v1.Metric;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 1:{se.name=p.string();break}case 2:{se.description=p.string();break}case 3:{se.unit=p.string();break}case 5:{se.gauge=at.opentelemetry.proto.metrics.v1.Gauge.decode(p,p.uint32());break}case 7:{se.sum=at.opentelemetry.proto.metrics.v1.Sum.decode(p,p.uint32());break}case 9:{se.histogram=at.opentelemetry.proto.metrics.v1.Histogram.decode(p,p.uint32());break}case 10:{se.exponentialHistogram=at.opentelemetry.proto.metrics.v1.ExponentialHistogram.decode(p,p.uint32());break}case 11:{se.summary=at.opentelemetry.proto.metrics.v1.Summary.decode(p,p.uint32());break}default:p.skipType(ze&7);break}}return se},b.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},b.verify=function(p){if(typeof p!="object"||p===null)return"object expected";var k={};if(p.name!=null&&p.hasOwnProperty("name")&&!gt.isString(p.name))return"name: string expected";if(p.description!=null&&p.hasOwnProperty("description")&&!gt.isString(p.description))return"description: string expected";if(p.unit!=null&&p.hasOwnProperty("unit")&&!gt.isString(p.unit))return"unit: string expected";if(p.gauge!=null&&p.hasOwnProperty("gauge")){k.data=1;{var j=at.opentelemetry.proto.metrics.v1.Gauge.verify(p.gauge);if(j)return"gauge."+j}}if(p.sum!=null&&p.hasOwnProperty("sum")){if(k.data===1)return"data: multiple values";k.data=1;{var j=at.opentelemetry.proto.metrics.v1.Sum.verify(p.sum);if(j)return"sum."+j}}if(p.histogram!=null&&p.hasOwnProperty("histogram")){if(k.data===1)return"data: multiple values";k.data=1;{var j=at.opentelemetry.proto.metrics.v1.Histogram.verify(p.histogram);if(j)return"histogram."+j}}if(p.exponentialHistogram!=null&&p.hasOwnProperty("exponentialHistogram")){if(k.data===1)return"data: multiple values";k.data=1;{var j=at.opentelemetry.proto.metrics.v1.ExponentialHistogram.verify(p.exponentialHistogram);if(j)return"exponentialHistogram."+j}}if(p.summary!=null&&p.hasOwnProperty("summary")){if(k.data===1)return"data: multiple values";k.data=1;{var j=at.opentelemetry.proto.metrics.v1.Summary.verify(p.summary);if(j)return"summary."+j}}return null},b.fromObject=function(p){if(p instanceof at.opentelemetry.proto.metrics.v1.Metric)return p;var k=new at.opentelemetry.proto.metrics.v1.Metric;if(p.name!=null&&(k.name=String(p.name)),p.description!=null&&(k.description=String(p.description)),p.unit!=null&&(k.unit=String(p.unit)),p.gauge!=null){if(typeof p.gauge!="object")throw TypeError(".opentelemetry.proto.metrics.v1.Metric.gauge: object expected");k.gauge=at.opentelemetry.proto.metrics.v1.Gauge.fromObject(p.gauge)}if(p.sum!=null){if(typeof p.sum!="object")throw TypeError(".opentelemetry.proto.metrics.v1.Metric.sum: object expected");k.sum=at.opentelemetry.proto.metrics.v1.Sum.fromObject(p.sum)}if(p.histogram!=null){if(typeof p.histogram!="object")throw TypeError(".opentelemetry.proto.metrics.v1.Metric.histogram: object expected");k.histogram=at.opentelemetry.proto.metrics.v1.Histogram.fromObject(p.histogram)}if(p.exponentialHistogram!=null){if(typeof p.exponentialHistogram!="object")throw TypeError(".opentelemetry.proto.metrics.v1.Metric.exponentialHistogram: object expected");k.exponentialHistogram=at.opentelemetry.proto.metrics.v1.ExponentialHistogram.fromObject(p.exponentialHistogram)}if(p.summary!=null){if(typeof p.summary!="object")throw TypeError(".opentelemetry.proto.metrics.v1.Metric.summary: object expected");k.summary=at.opentelemetry.proto.metrics.v1.Summary.fromObject(p.summary)}return k},b.toObject=function(p,k){k||(k={});var j={};return k.defaults&&(j.name="",j.description="",j.unit=""),p.name!=null&&p.hasOwnProperty("name")&&(j.name=p.name),p.description!=null&&p.hasOwnProperty("description")&&(j.description=p.description),p.unit!=null&&p.hasOwnProperty("unit")&&(j.unit=p.unit),p.gauge!=null&&p.hasOwnProperty("gauge")&&(j.gauge=at.opentelemetry.proto.metrics.v1.Gauge.toObject(p.gauge,k),k.oneofs&&(j.data="gauge")),p.sum!=null&&p.hasOwnProperty("sum")&&(j.sum=at.opentelemetry.proto.metrics.v1.Sum.toObject(p.sum,k),k.oneofs&&(j.data="sum")),p.histogram!=null&&p.hasOwnProperty("histogram")&&(j.histogram=at.opentelemetry.proto.metrics.v1.Histogram.toObject(p.histogram,k),k.oneofs&&(j.data="histogram")),p.exponentialHistogram!=null&&p.hasOwnProperty("exponentialHistogram")&&(j.exponentialHistogram=at.opentelemetry.proto.metrics.v1.ExponentialHistogram.toObject(p.exponentialHistogram,k),k.oneofs&&(j.data="exponentialHistogram")),p.summary!=null&&p.hasOwnProperty("summary")&&(j.summary=at.opentelemetry.proto.metrics.v1.Summary.toObject(p.summary,k),k.oneofs&&(j.data="summary")),j},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.metrics.v1.Metric"},b}(),y.Gauge=function(){function b(A){if(this.dataPoints=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.dataPoints=gt.emptyArray,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.dataPoints!=null&&g.dataPoints.length)for(var k=0;k<g.dataPoints.length;++k)at.opentelemetry.proto.metrics.v1.NumberDataPoint.encode(g.dataPoints[k],p.uint32(10).fork()).ldelim();return p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.metrics.v1.Gauge;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.dataPoints&&j.dataPoints.length||(j.dataPoints=[]),j.dataPoints.push(at.opentelemetry.proto.metrics.v1.NumberDataPoint.decode(g,g.uint32()));break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.dataPoints!=null&&g.hasOwnProperty("dataPoints")){if(!Array.isArray(g.dataPoints))return"dataPoints: array expected";for(var p=0;p<g.dataPoints.length;++p){var k=at.opentelemetry.proto.metrics.v1.NumberDataPoint.verify(g.dataPoints[p]);if(k)return"dataPoints."+k}}return null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.metrics.v1.Gauge)return g;var p=new at.opentelemetry.proto.metrics.v1.Gauge;if(g.dataPoints){if(!Array.isArray(g.dataPoints))throw TypeError(".opentelemetry.proto.metrics.v1.Gauge.dataPoints: array expected");p.dataPoints=[];for(var k=0;k<g.dataPoints.length;++k){if(typeof g.dataPoints[k]!="object")throw TypeError(".opentelemetry.proto.metrics.v1.Gauge.dataPoints: object expected");p.dataPoints[k]=at.opentelemetry.proto.metrics.v1.NumberDataPoint.fromObject(g.dataPoints[k])}}return p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.dataPoints=[]),g.dataPoints&&g.dataPoints.length){k.dataPoints=[];for(var j=0;j<g.dataPoints.length;++j)k.dataPoints[j]=at.opentelemetry.proto.metrics.v1.NumberDataPoint.toObject(g.dataPoints[j],p)}return k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.metrics.v1.Gauge"},b}(),y.Sum=function(){function b(A){if(this.dataPoints=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.dataPoints=gt.emptyArray,b.prototype.aggregationTemporality=null,b.prototype.isMonotonic=null,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.dataPoints!=null&&g.dataPoints.length)for(var k=0;k<g.dataPoints.length;++k)at.opentelemetry.proto.metrics.v1.NumberDataPoint.encode(g.dataPoints[k],p.uint32(10).fork()).ldelim();return g.aggregationTemporality!=null&&Object.hasOwnProperty.call(g,"aggregationTemporality")&&p.uint32(16).int32(g.aggregationTemporality),g.isMonotonic!=null&&Object.hasOwnProperty.call(g,"isMonotonic")&&p.uint32(24).bool(g.isMonotonic),p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.metrics.v1.Sum;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.dataPoints&&j.dataPoints.length||(j.dataPoints=[]),j.dataPoints.push(at.opentelemetry.proto.metrics.v1.NumberDataPoint.decode(g,g.uint32()));break}case 2:{j.aggregationTemporality=g.int32();break}case 3:{j.isMonotonic=g.bool();break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.dataPoints!=null&&g.hasOwnProperty("dataPoints")){if(!Array.isArray(g.dataPoints))return"dataPoints: array expected";for(var p=0;p<g.dataPoints.length;++p){var k=at.opentelemetry.proto.metrics.v1.NumberDataPoint.verify(g.dataPoints[p]);if(k)return"dataPoints."+k}}if(g.aggregationTemporality!=null&&g.hasOwnProperty("aggregationTemporality"))switch(g.aggregationTemporality){default:return"aggregationTemporality: enum value expected";case 0:case 1:case 2:break}return g.isMonotonic!=null&&g.hasOwnProperty("isMonotonic")&&typeof g.isMonotonic!="boolean"?"isMonotonic: boolean expected":null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.metrics.v1.Sum)return g;var p=new at.opentelemetry.proto.metrics.v1.Sum;if(g.dataPoints){if(!Array.isArray(g.dataPoints))throw TypeError(".opentelemetry.proto.metrics.v1.Sum.dataPoints: array expected");p.dataPoints=[];for(var k=0;k<g.dataPoints.length;++k){if(typeof g.dataPoints[k]!="object")throw TypeError(".opentelemetry.proto.metrics.v1.Sum.dataPoints: object expected");p.dataPoints[k]=at.opentelemetry.proto.metrics.v1.NumberDataPoint.fromObject(g.dataPoints[k])}}switch(g.aggregationTemporality){default:if(typeof g.aggregationTemporality=="number"){p.aggregationTemporality=g.aggregationTemporality;break}break;case"AGGREGATION_TEMPORALITY_UNSPECIFIED":case 0:p.aggregationTemporality=0;break;case"AGGREGATION_TEMPORALITY_DELTA":case 1:p.aggregationTemporality=1;break;case"AGGREGATION_TEMPORALITY_CUMULATIVE":case 2:p.aggregationTemporality=2;break}return g.isMonotonic!=null&&(p.isMonotonic=!!g.isMonotonic),p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.dataPoints=[]),p.defaults&&(k.aggregationTemporality=p.enums===String?"AGGREGATION_TEMPORALITY_UNSPECIFIED":0,k.isMonotonic=!1),g.dataPoints&&g.dataPoints.length){k.dataPoints=[];for(var j=0;j<g.dataPoints.length;++j)k.dataPoints[j]=at.opentelemetry.proto.metrics.v1.NumberDataPoint.toObject(g.dataPoints[j],p)}return g.aggregationTemporality!=null&&g.hasOwnProperty("aggregationTemporality")&&(k.aggregationTemporality=p.enums===String?at.opentelemetry.proto.metrics.v1.AggregationTemporality[g.aggregationTemporality]===void 0?g.aggregationTemporality:at.opentelemetry.proto.metrics.v1.AggregationTemporality[g.aggregationTemporality]:g.aggregationTemporality),g.isMonotonic!=null&&g.hasOwnProperty("isMonotonic")&&(k.isMonotonic=g.isMonotonic),k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.metrics.v1.Sum"},b}(),y.Histogram=function(){function b(A){if(this.dataPoints=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.dataPoints=gt.emptyArray,b.prototype.aggregationTemporality=null,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.dataPoints!=null&&g.dataPoints.length)for(var k=0;k<g.dataPoints.length;++k)at.opentelemetry.proto.metrics.v1.HistogramDataPoint.encode(g.dataPoints[k],p.uint32(10).fork()).ldelim();return g.aggregationTemporality!=null&&Object.hasOwnProperty.call(g,"aggregationTemporality")&&p.uint32(16).int32(g.aggregationTemporality),p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.metrics.v1.Histogram;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.dataPoints&&j.dataPoints.length||(j.dataPoints=[]),j.dataPoints.push(at.opentelemetry.proto.metrics.v1.HistogramDataPoint.decode(g,g.uint32()));break}case 2:{j.aggregationTemporality=g.int32();break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.dataPoints!=null&&g.hasOwnProperty("dataPoints")){if(!Array.isArray(g.dataPoints))return"dataPoints: array expected";for(var p=0;p<g.dataPoints.length;++p){var k=at.opentelemetry.proto.metrics.v1.HistogramDataPoint.verify(g.dataPoints[p]);if(k)return"dataPoints."+k}}if(g.aggregationTemporality!=null&&g.hasOwnProperty("aggregationTemporality"))switch(g.aggregationTemporality){default:return"aggregationTemporality: enum value expected";case 0:case 1:case 2:break}return null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.metrics.v1.Histogram)return g;var p=new at.opentelemetry.proto.metrics.v1.Histogram;if(g.dataPoints){if(!Array.isArray(g.dataPoints))throw TypeError(".opentelemetry.proto.metrics.v1.Histogram.dataPoints: array expected");p.dataPoints=[];for(var k=0;k<g.dataPoints.length;++k){if(typeof g.dataPoints[k]!="object")throw TypeError(".opentelemetry.proto.metrics.v1.Histogram.dataPoints: object expected");p.dataPoints[k]=at.opentelemetry.proto.metrics.v1.HistogramDataPoint.fromObject(g.dataPoints[k])}}switch(g.aggregationTemporality){default:if(typeof g.aggregationTemporality=="number"){p.aggregationTemporality=g.aggregationTemporality;break}break;case"AGGREGATION_TEMPORALITY_UNSPECIFIED":case 0:p.aggregationTemporality=0;break;case"AGGREGATION_TEMPORALITY_DELTA":case 1:p.aggregationTemporality=1;break;case"AGGREGATION_TEMPORALITY_CUMULATIVE":case 2:p.aggregationTemporality=2;break}return p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.dataPoints=[]),p.defaults&&(k.aggregationTemporality=p.enums===String?"AGGREGATION_TEMPORALITY_UNSPECIFIED":0),g.dataPoints&&g.dataPoints.length){k.dataPoints=[];for(var j=0;j<g.dataPoints.length;++j)k.dataPoints[j]=at.opentelemetry.proto.metrics.v1.HistogramDataPoint.toObject(g.dataPoints[j],p)}return g.aggregationTemporality!=null&&g.hasOwnProperty("aggregationTemporality")&&(k.aggregationTemporality=p.enums===String?at.opentelemetry.proto.metrics.v1.AggregationTemporality[g.aggregationTemporality]===void 0?g.aggregationTemporality:at.opentelemetry.proto.metrics.v1.AggregationTemporality[g.aggregationTemporality]:g.aggregationTemporality),k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.metrics.v1.Histogram"},b}(),y.ExponentialHistogram=function(){function b(A){if(this.dataPoints=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.dataPoints=gt.emptyArray,b.prototype.aggregationTemporality=null,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.dataPoints!=null&&g.dataPoints.length)for(var k=0;k<g.dataPoints.length;++k)at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.encode(g.dataPoints[k],p.uint32(10).fork()).ldelim();return g.aggregationTemporality!=null&&Object.hasOwnProperty.call(g,"aggregationTemporality")&&p.uint32(16).int32(g.aggregationTemporality),p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.metrics.v1.ExponentialHistogram;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.dataPoints&&j.dataPoints.length||(j.dataPoints=[]),j.dataPoints.push(at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.decode(g,g.uint32()));break}case 2:{j.aggregationTemporality=g.int32();break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.dataPoints!=null&&g.hasOwnProperty("dataPoints")){if(!Array.isArray(g.dataPoints))return"dataPoints: array expected";for(var p=0;p<g.dataPoints.length;++p){var k=at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.verify(g.dataPoints[p]);if(k)return"dataPoints."+k}}if(g.aggregationTemporality!=null&&g.hasOwnProperty("aggregationTemporality"))switch(g.aggregationTemporality){default:return"aggregationTemporality: enum value expected";case 0:case 1:case 2:break}return null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.metrics.v1.ExponentialHistogram)return g;var p=new at.opentelemetry.proto.metrics.v1.ExponentialHistogram;if(g.dataPoints){if(!Array.isArray(g.dataPoints))throw TypeError(".opentelemetry.proto.metrics.v1.ExponentialHistogram.dataPoints: array expected");p.dataPoints=[];for(var k=0;k<g.dataPoints.length;++k){if(typeof g.dataPoints[k]!="object")throw TypeError(".opentelemetry.proto.metrics.v1.ExponentialHistogram.dataPoints: object expected");p.dataPoints[k]=at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.fromObject(g.dataPoints[k])}}switch(g.aggregationTemporality){default:if(typeof g.aggregationTemporality=="number"){p.aggregationTemporality=g.aggregationTemporality;break}break;case"AGGREGATION_TEMPORALITY_UNSPECIFIED":case 0:p.aggregationTemporality=0;break;case"AGGREGATION_TEMPORALITY_DELTA":case 1:p.aggregationTemporality=1;break;case"AGGREGATION_TEMPORALITY_CUMULATIVE":case 2:p.aggregationTemporality=2;break}return p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.dataPoints=[]),p.defaults&&(k.aggregationTemporality=p.enums===String?"AGGREGATION_TEMPORALITY_UNSPECIFIED":0),g.dataPoints&&g.dataPoints.length){k.dataPoints=[];for(var j=0;j<g.dataPoints.length;++j)k.dataPoints[j]=at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.toObject(g.dataPoints[j],p)}return g.aggregationTemporality!=null&&g.hasOwnProperty("aggregationTemporality")&&(k.aggregationTemporality=p.enums===String?at.opentelemetry.proto.metrics.v1.AggregationTemporality[g.aggregationTemporality]===void 0?g.aggregationTemporality:at.opentelemetry.proto.metrics.v1.AggregationTemporality[g.aggregationTemporality]:g.aggregationTemporality),k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.metrics.v1.ExponentialHistogram"},b}(),y.Summary=function(){function b(A){if(this.dataPoints=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.dataPoints=gt.emptyArray,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.dataPoints!=null&&g.dataPoints.length)for(var k=0;k<g.dataPoints.length;++k)at.opentelemetry.proto.metrics.v1.SummaryDataPoint.encode(g.dataPoints[k],p.uint32(10).fork()).ldelim();return p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.metrics.v1.Summary;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.dataPoints&&j.dataPoints.length||(j.dataPoints=[]),j.dataPoints.push(at.opentelemetry.proto.metrics.v1.SummaryDataPoint.decode(g,g.uint32()));break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.dataPoints!=null&&g.hasOwnProperty("dataPoints")){if(!Array.isArray(g.dataPoints))return"dataPoints: array expected";for(var p=0;p<g.dataPoints.length;++p){var k=at.opentelemetry.proto.metrics.v1.SummaryDataPoint.verify(g.dataPoints[p]);if(k)return"dataPoints."+k}}return null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.metrics.v1.Summary)return g;var p=new at.opentelemetry.proto.metrics.v1.Summary;if(g.dataPoints){if(!Array.isArray(g.dataPoints))throw TypeError(".opentelemetry.proto.metrics.v1.Summary.dataPoints: array expected");p.dataPoints=[];for(var k=0;k<g.dataPoints.length;++k){if(typeof g.dataPoints[k]!="object")throw TypeError(".opentelemetry.proto.metrics.v1.Summary.dataPoints: object expected");p.dataPoints[k]=at.opentelemetry.proto.metrics.v1.SummaryDataPoint.fromObject(g.dataPoints[k])}}return p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.dataPoints=[]),g.dataPoints&&g.dataPoints.length){k.dataPoints=[];for(var j=0;j<g.dataPoints.length;++j)k.dataPoints[j]=at.opentelemetry.proto.metrics.v1.SummaryDataPoint.toObject(g.dataPoints[j],p)}return k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.metrics.v1.Summary"},b}(),y.AggregationTemporality=function(){var b={},A=Object.create(b);return A[b[0]="AGGREGATION_TEMPORALITY_UNSPECIFIED"]=0,A[b[1]="AGGREGATION_TEMPORALITY_DELTA"]=1,A[b[2]="AGGREGATION_TEMPORALITY_CUMULATIVE"]=2,A}(),y.DataPointFlags=function(){var b={},A=Object.create(b);return A[b[0]="DATA_POINT_FLAGS_DO_NOT_USE"]=0,A[b[1]="DATA_POINT_FLAGS_NO_RECORDED_VALUE_MASK"]=1,A}(),y.NumberDataPoint=function(){function b(g){if(this.attributes=[],this.exemplars=[],g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}b.prototype.attributes=gt.emptyArray,b.prototype.startTimeUnixNano=null,b.prototype.timeUnixNano=null,b.prototype.asDouble=null,b.prototype.asInt=null,b.prototype.exemplars=gt.emptyArray,b.prototype.flags=null;var A;return Object.defineProperty(b.prototype,"value",{get:gt.oneOfGetter(A=["asDouble","asInt"]),set:gt.oneOfSetter(A)}),b.create=function(p){return new b(p)},b.encode=function(p,k){if(k||(k=gl.create()),p.startTimeUnixNano!=null&&Object.hasOwnProperty.call(p,"startTimeUnixNano")&&k.uint32(17).fixed64(p.startTimeUnixNano),p.timeUnixNano!=null&&Object.hasOwnProperty.call(p,"timeUnixNano")&&k.uint32(25).fixed64(p.timeUnixNano),p.asDouble!=null&&Object.hasOwnProperty.call(p,"asDouble")&&k.uint32(33).double(p.asDouble),p.exemplars!=null&&p.exemplars.length)for(var j=0;j<p.exemplars.length;++j)at.opentelemetry.proto.metrics.v1.Exemplar.encode(p.exemplars[j],k.uint32(42).fork()).ldelim();if(p.asInt!=null&&Object.hasOwnProperty.call(p,"asInt")&&k.uint32(49).sfixed64(p.asInt),p.attributes!=null&&p.attributes.length)for(var j=0;j<p.attributes.length;++j)at.opentelemetry.proto.common.v1.KeyValue.encode(p.attributes[j],k.uint32(58).fork()).ldelim();return p.flags!=null&&Object.hasOwnProperty.call(p,"flags")&&k.uint32(64).uint32(p.flags),k},b.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},b.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.metrics.v1.NumberDataPoint;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 7:{se.attributes&&se.attributes.length||(se.attributes=[]),se.attributes.push(at.opentelemetry.proto.common.v1.KeyValue.decode(p,p.uint32()));break}case 2:{se.startTimeUnixNano=p.fixed64();break}case 3:{se.timeUnixNano=p.fixed64();break}case 4:{se.asDouble=p.double();break}case 6:{se.asInt=p.sfixed64();break}case 5:{se.exemplars&&se.exemplars.length||(se.exemplars=[]),se.exemplars.push(at.opentelemetry.proto.metrics.v1.Exemplar.decode(p,p.uint32()));break}case 8:{se.flags=p.uint32();break}default:p.skipType(ze&7);break}}return se},b.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},b.verify=function(p){if(typeof p!="object"||p===null)return"object expected";var k={};if(p.attributes!=null&&p.hasOwnProperty("attributes")){if(!Array.isArray(p.attributes))return"attributes: array expected";for(var j=0;j<p.attributes.length;++j){var se=at.opentelemetry.proto.common.v1.KeyValue.verify(p.attributes[j]);if(se)return"attributes."+se}}if(p.startTimeUnixNano!=null&&p.hasOwnProperty("startTimeUnixNano")&&!gt.isInteger(p.startTimeUnixNano)&&!(p.startTimeUnixNano&&gt.isInteger(p.startTimeUnixNano.low)&&gt.isInteger(p.startTimeUnixNano.high)))return"startTimeUnixNano: integer|Long expected";if(p.timeUnixNano!=null&&p.hasOwnProperty("timeUnixNano")&&!gt.isInteger(p.timeUnixNano)&&!(p.timeUnixNano&&gt.isInteger(p.timeUnixNano.low)&&gt.isInteger(p.timeUnixNano.high)))return"timeUnixNano: integer|Long expected";if(p.asDouble!=null&&p.hasOwnProperty("asDouble")&&(k.value=1,typeof p.asDouble!="number"))return"asDouble: number expected";if(p.asInt!=null&&p.hasOwnProperty("asInt")){if(k.value===1)return"value: multiple values";if(k.value=1,!gt.isInteger(p.asInt)&&!(p.asInt&&gt.isInteger(p.asInt.low)&&gt.isInteger(p.asInt.high)))return"asInt: integer|Long expected"}if(p.exemplars!=null&&p.hasOwnProperty("exemplars")){if(!Array.isArray(p.exemplars))return"exemplars: array expected";for(var j=0;j<p.exemplars.length;++j){var se=at.opentelemetry.proto.metrics.v1.Exemplar.verify(p.exemplars[j]);if(se)return"exemplars."+se}}return p.flags!=null&&p.hasOwnProperty("flags")&&!gt.isInteger(p.flags)?"flags: integer expected":null},b.fromObject=function(p){if(p instanceof at.opentelemetry.proto.metrics.v1.NumberDataPoint)return p;var k=new at.opentelemetry.proto.metrics.v1.NumberDataPoint;if(p.attributes){if(!Array.isArray(p.attributes))throw TypeError(".opentelemetry.proto.metrics.v1.NumberDataPoint.attributes: array expected");k.attributes=[];for(var j=0;j<p.attributes.length;++j){if(typeof p.attributes[j]!="object")throw TypeError(".opentelemetry.proto.metrics.v1.NumberDataPoint.attributes: object expected");k.attributes[j]=at.opentelemetry.proto.common.v1.KeyValue.fromObject(p.attributes[j])}}if(p.startTimeUnixNano!=null&&(gt.Long?(k.startTimeUnixNano=gt.Long.fromValue(p.startTimeUnixNano)).unsigned=!1:typeof p.startTimeUnixNano=="string"?k.startTimeUnixNano=parseInt(p.startTimeUnixNano,10):typeof p.startTimeUnixNano=="number"?k.startTimeUnixNano=p.startTimeUnixNano:typeof p.startTimeUnixNano=="object"&&(k.startTimeUnixNano=new gt.LongBits(p.startTimeUnixNano.low>>>0,p.startTimeUnixNano.high>>>0).toNumber())),p.timeUnixNano!=null&&(gt.Long?(k.timeUnixNano=gt.Long.fromValue(p.timeUnixNano)).unsigned=!1:typeof p.timeUnixNano=="string"?k.timeUnixNano=parseInt(p.timeUnixNano,10):typeof p.timeUnixNano=="number"?k.timeUnixNano=p.timeUnixNano:typeof p.timeUnixNano=="object"&&(k.timeUnixNano=new gt.LongBits(p.timeUnixNano.low>>>0,p.timeUnixNano.high>>>0).toNumber())),p.asDouble!=null&&(k.asDouble=Number(p.asDouble)),p.asInt!=null&&(gt.Long?(k.asInt=gt.Long.fromValue(p.asInt)).unsigned=!1:typeof p.asInt=="string"?k.asInt=parseInt(p.asInt,10):typeof p.asInt=="number"?k.asInt=p.asInt:typeof p.asInt=="object"&&(k.asInt=new gt.LongBits(p.asInt.low>>>0,p.asInt.high>>>0).toNumber())),p.exemplars){if(!Array.isArray(p.exemplars))throw TypeError(".opentelemetry.proto.metrics.v1.NumberDataPoint.exemplars: array expected");k.exemplars=[];for(var j=0;j<p.exemplars.length;++j){if(typeof p.exemplars[j]!="object")throw TypeError(".opentelemetry.proto.metrics.v1.NumberDataPoint.exemplars: object expected");k.exemplars[j]=at.opentelemetry.proto.metrics.v1.Exemplar.fromObject(p.exemplars[j])}}return p.flags!=null&&(k.flags=p.flags>>>0),k},b.toObject=function(p,k){k||(k={});var j={};if((k.arrays||k.defaults)&&(j.exemplars=[],j.attributes=[]),k.defaults){if(gt.Long){var se=new gt.Long(0,0,!1);j.startTimeUnixNano=k.longs===String?se.toString():k.longs===Number?se.toNumber():se}else j.startTimeUnixNano=k.longs===String?"0":0;if(gt.Long){var se=new gt.Long(0,0,!1);j.timeUnixNano=k.longs===String?se.toString():k.longs===Number?se.toNumber():se}else j.timeUnixNano=k.longs===String?"0":0;j.flags=0}if(p.startTimeUnixNano!=null&&p.hasOwnProperty("startTimeUnixNano")&&(typeof p.startTimeUnixNano=="number"?j.startTimeUnixNano=k.longs===String?String(p.startTimeUnixNano):p.startTimeUnixNano:j.startTimeUnixNano=k.longs===String?gt.Long.prototype.toString.call(p.startTimeUnixNano):k.longs===Number?new gt.LongBits(p.startTimeUnixNano.low>>>0,p.startTimeUnixNano.high>>>0).toNumber():p.startTimeUnixNano),p.timeUnixNano!=null&&p.hasOwnProperty("timeUnixNano")&&(typeof p.timeUnixNano=="number"?j.timeUnixNano=k.longs===String?String(p.timeUnixNano):p.timeUnixNano:j.timeUnixNano=k.longs===String?gt.Long.prototype.toString.call(p.timeUnixNano):k.longs===Number?new gt.LongBits(p.timeUnixNano.low>>>0,p.timeUnixNano.high>>>0).toNumber():p.timeUnixNano),p.asDouble!=null&&p.hasOwnProperty("asDouble")&&(j.asDouble=k.json&&!isFinite(p.asDouble)?String(p.asDouble):p.asDouble,k.oneofs&&(j.value="asDouble")),p.exemplars&&p.exemplars.length){j.exemplars=[];for(var ze=0;ze<p.exemplars.length;++ze)j.exemplars[ze]=at.opentelemetry.proto.metrics.v1.Exemplar.toObject(p.exemplars[ze],k)}if(p.asInt!=null&&p.hasOwnProperty("asInt")&&(typeof p.asInt=="number"?j.asInt=k.longs===String?String(p.asInt):p.asInt:j.asInt=k.longs===String?gt.Long.prototype.toString.call(p.asInt):k.longs===Number?new gt.LongBits(p.asInt.low>>>0,p.asInt.high>>>0).toNumber():p.asInt,k.oneofs&&(j.value="asInt")),p.attributes&&p.attributes.length){j.attributes=[];for(var ze=0;ze<p.attributes.length;++ze)j.attributes[ze]=at.opentelemetry.proto.common.v1.KeyValue.toObject(p.attributes[ze],k)}return p.flags!=null&&p.hasOwnProperty("flags")&&(j.flags=p.flags),j},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.metrics.v1.NumberDataPoint"},b}(),y.HistogramDataPoint=function(){function b(g){if(this.attributes=[],this.bucketCounts=[],this.explicitBounds=[],this.exemplars=[],g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}b.prototype.attributes=gt.emptyArray,b.prototype.startTimeUnixNano=null,b.prototype.timeUnixNano=null,b.prototype.count=null,b.prototype.sum=null,b.prototype.bucketCounts=gt.emptyArray,b.prototype.explicitBounds=gt.emptyArray,b.prototype.exemplars=gt.emptyArray,b.prototype.flags=null,b.prototype.min=null,b.prototype.max=null;var A;return Object.defineProperty(b.prototype,"_sum",{get:gt.oneOfGetter(A=["sum"]),set:gt.oneOfSetter(A)}),Object.defineProperty(b.prototype,"_min",{get:gt.oneOfGetter(A=["min"]),set:gt.oneOfSetter(A)}),Object.defineProperty(b.prototype,"_max",{get:gt.oneOfGetter(A=["max"]),set:gt.oneOfSetter(A)}),b.create=function(p){return new b(p)},b.encode=function(p,k){if(k||(k=gl.create()),p.startTimeUnixNano!=null&&Object.hasOwnProperty.call(p,"startTimeUnixNano")&&k.uint32(17).fixed64(p.startTimeUnixNano),p.timeUnixNano!=null&&Object.hasOwnProperty.call(p,"timeUnixNano")&&k.uint32(25).fixed64(p.timeUnixNano),p.count!=null&&Object.hasOwnProperty.call(p,"count")&&k.uint32(33).fixed64(p.count),p.sum!=null&&Object.hasOwnProperty.call(p,"sum")&&k.uint32(41).double(p.sum),p.bucketCounts!=null&&p.bucketCounts.length){k.uint32(50).fork();for(var j=0;j<p.bucketCounts.length;++j)k.fixed64(p.bucketCounts[j]);k.ldelim()}if(p.explicitBounds!=null&&p.explicitBounds.length){k.uint32(58).fork();for(var j=0;j<p.explicitBounds.length;++j)k.double(p.explicitBounds[j]);k.ldelim()}if(p.exemplars!=null&&p.exemplars.length)for(var j=0;j<p.exemplars.length;++j)at.opentelemetry.proto.metrics.v1.Exemplar.encode(p.exemplars[j],k.uint32(66).fork()).ldelim();if(p.attributes!=null&&p.attributes.length)for(var j=0;j<p.attributes.length;++j)at.opentelemetry.proto.common.v1.KeyValue.encode(p.attributes[j],k.uint32(74).fork()).ldelim();return p.flags!=null&&Object.hasOwnProperty.call(p,"flags")&&k.uint32(80).uint32(p.flags),p.min!=null&&Object.hasOwnProperty.call(p,"min")&&k.uint32(89).double(p.min),p.max!=null&&Object.hasOwnProperty.call(p,"max")&&k.uint32(97).double(p.max),k},b.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},b.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.metrics.v1.HistogramDataPoint;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 9:{se.attributes&&se.attributes.length||(se.attributes=[]),se.attributes.push(at.opentelemetry.proto.common.v1.KeyValue.decode(p,p.uint32()));break}case 2:{se.startTimeUnixNano=p.fixed64();break}case 3:{se.timeUnixNano=p.fixed64();break}case 4:{se.count=p.fixed64();break}case 5:{se.sum=p.double();break}case 6:{if(se.bucketCounts&&se.bucketCounts.length||(se.bucketCounts=[]),(ze&7)===2)for(var ve=p.uint32()+p.pos;p.pos<ve;)se.bucketCounts.push(p.fixed64());else se.bucketCounts.push(p.fixed64());break}case 7:{if(se.explicitBounds&&se.explicitBounds.length||(se.explicitBounds=[]),(ze&7)===2)for(var ve=p.uint32()+p.pos;p.pos<ve;)se.explicitBounds.push(p.double());else se.explicitBounds.push(p.double());break}case 8:{se.exemplars&&se.exemplars.length||(se.exemplars=[]),se.exemplars.push(at.opentelemetry.proto.metrics.v1.Exemplar.decode(p,p.uint32()));break}case 10:{se.flags=p.uint32();break}case 11:{se.min=p.double();break}case 12:{se.max=p.double();break}default:p.skipType(ze&7);break}}return se},b.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},b.verify=function(p){if(typeof p!="object"||p===null)return"object expected";var k={};if(p.attributes!=null&&p.hasOwnProperty("attributes")){if(!Array.isArray(p.attributes))return"attributes: array expected";for(var j=0;j<p.attributes.length;++j){var se=at.opentelemetry.proto.common.v1.KeyValue.verify(p.attributes[j]);if(se)return"attributes."+se}}if(p.startTimeUnixNano!=null&&p.hasOwnProperty("startTimeUnixNano")&&!gt.isInteger(p.startTimeUnixNano)&&!(p.startTimeUnixNano&&gt.isInteger(p.startTimeUnixNano.low)&&gt.isInteger(p.startTimeUnixNano.high)))return"startTimeUnixNano: integer|Long expected";if(p.timeUnixNano!=null&&p.hasOwnProperty("timeUnixNano")&&!gt.isInteger(p.timeUnixNano)&&!(p.timeUnixNano&&gt.isInteger(p.timeUnixNano.low)&&gt.isInteger(p.timeUnixNano.high)))return"timeUnixNano: integer|Long expected";if(p.count!=null&&p.hasOwnProperty("count")&&!gt.isInteger(p.count)&&!(p.count&&gt.isInteger(p.count.low)&&gt.isInteger(p.count.high)))return"count: integer|Long expected";if(p.sum!=null&&p.hasOwnProperty("sum")&&(k._sum=1,typeof p.sum!="number"))return"sum: number expected";if(p.bucketCounts!=null&&p.hasOwnProperty("bucketCounts")){if(!Array.isArray(p.bucketCounts))return"bucketCounts: array expected";for(var j=0;j<p.bucketCounts.length;++j)if(!gt.isInteger(p.bucketCounts[j])&&!(p.bucketCounts[j]&&gt.isInteger(p.bucketCounts[j].low)&&gt.isInteger(p.bucketCounts[j].high)))return"bucketCounts: integer|Long[] expected"}if(p.explicitBounds!=null&&p.hasOwnProperty("explicitBounds")){if(!Array.isArray(p.explicitBounds))return"explicitBounds: array expected";for(var j=0;j<p.explicitBounds.length;++j)if(typeof p.explicitBounds[j]!="number")return"explicitBounds: number[] expected"}if(p.exemplars!=null&&p.hasOwnProperty("exemplars")){if(!Array.isArray(p.exemplars))return"exemplars: array expected";for(var j=0;j<p.exemplars.length;++j){var se=at.opentelemetry.proto.metrics.v1.Exemplar.verify(p.exemplars[j]);if(se)return"exemplars."+se}}return p.flags!=null&&p.hasOwnProperty("flags")&&!gt.isInteger(p.flags)?"flags: integer expected":p.min!=null&&p.hasOwnProperty("min")&&(k._min=1,typeof p.min!="number")?"min: number expected":p.max!=null&&p.hasOwnProperty("max")&&(k._max=1,typeof p.max!="number")?"max: number expected":null},b.fromObject=function(p){if(p instanceof at.opentelemetry.proto.metrics.v1.HistogramDataPoint)return p;var k=new at.opentelemetry.proto.metrics.v1.HistogramDataPoint;if(p.attributes){if(!Array.isArray(p.attributes))throw TypeError(".opentelemetry.proto.metrics.v1.HistogramDataPoint.attributes: array expected");k.attributes=[];for(var j=0;j<p.attributes.length;++j){if(typeof p.attributes[j]!="object")throw TypeError(".opentelemetry.proto.metrics.v1.HistogramDataPoint.attributes: object expected");k.attributes[j]=at.opentelemetry.proto.common.v1.KeyValue.fromObject(p.attributes[j])}}if(p.startTimeUnixNano!=null&&(gt.Long?(k.startTimeUnixNano=gt.Long.fromValue(p.startTimeUnixNano)).unsigned=!1:typeof p.startTimeUnixNano=="string"?k.startTimeUnixNano=parseInt(p.startTimeUnixNano,10):typeof p.startTimeUnixNano=="number"?k.startTimeUnixNano=p.startTimeUnixNano:typeof p.startTimeUnixNano=="object"&&(k.startTimeUnixNano=new gt.LongBits(p.startTimeUnixNano.low>>>0,p.startTimeUnixNano.high>>>0).toNumber())),p.timeUnixNano!=null&&(gt.Long?(k.timeUnixNano=gt.Long.fromValue(p.timeUnixNano)).unsigned=!1:typeof p.timeUnixNano=="string"?k.timeUnixNano=parseInt(p.timeUnixNano,10):typeof p.timeUnixNano=="number"?k.timeUnixNano=p.timeUnixNano:typeof p.timeUnixNano=="object"&&(k.timeUnixNano=new gt.LongBits(p.timeUnixNano.low>>>0,p.timeUnixNano.high>>>0).toNumber())),p.count!=null&&(gt.Long?(k.count=gt.Long.fromValue(p.count)).unsigned=!1:typeof p.count=="string"?k.count=parseInt(p.count,10):typeof p.count=="number"?k.count=p.count:typeof p.count=="object"&&(k.count=new gt.LongBits(p.count.low>>>0,p.count.high>>>0).toNumber())),p.sum!=null&&(k.sum=Number(p.sum)),p.bucketCounts){if(!Array.isArray(p.bucketCounts))throw TypeError(".opentelemetry.proto.metrics.v1.HistogramDataPoint.bucketCounts: array expected");k.bucketCounts=[];for(var j=0;j<p.bucketCounts.length;++j)gt.Long?(k.bucketCounts[j]=gt.Long.fromValue(p.bucketCounts[j])).unsigned=!1:typeof p.bucketCounts[j]=="string"?k.bucketCounts[j]=parseInt(p.bucketCounts[j],10):typeof p.bucketCounts[j]=="number"?k.bucketCounts[j]=p.bucketCounts[j]:typeof p.bucketCounts[j]=="object"&&(k.bucketCounts[j]=new gt.LongBits(p.bucketCounts[j].low>>>0,p.bucketCounts[j].high>>>0).toNumber())}if(p.explicitBounds){if(!Array.isArray(p.explicitBounds))throw TypeError(".opentelemetry.proto.metrics.v1.HistogramDataPoint.explicitBounds: array expected");k.explicitBounds=[];for(var j=0;j<p.explicitBounds.length;++j)k.explicitBounds[j]=Number(p.explicitBounds[j])}if(p.exemplars){if(!Array.isArray(p.exemplars))throw TypeError(".opentelemetry.proto.metrics.v1.HistogramDataPoint.exemplars: array expected");k.exemplars=[];for(var j=0;j<p.exemplars.length;++j){if(typeof p.exemplars[j]!="object")throw TypeError(".opentelemetry.proto.metrics.v1.HistogramDataPoint.exemplars: object expected");k.exemplars[j]=at.opentelemetry.proto.metrics.v1.Exemplar.fromObject(p.exemplars[j])}}return p.flags!=null&&(k.flags=p.flags>>>0),p.min!=null&&(k.min=Number(p.min)),p.max!=null&&(k.max=Number(p.max)),k},b.toObject=function(p,k){k||(k={});var j={};if((k.arrays||k.defaults)&&(j.bucketCounts=[],j.explicitBounds=[],j.exemplars=[],j.attributes=[]),k.defaults){if(gt.Long){var se=new gt.Long(0,0,!1);j.startTimeUnixNano=k.longs===String?se.toString():k.longs===Number?se.toNumber():se}else j.startTimeUnixNano=k.longs===String?"0":0;if(gt.Long){var se=new gt.Long(0,0,!1);j.timeUnixNano=k.longs===String?se.toString():k.longs===Number?se.toNumber():se}else j.timeUnixNano=k.longs===String?"0":0;if(gt.Long){var se=new gt.Long(0,0,!1);j.count=k.longs===String?se.toString():k.longs===Number?se.toNumber():se}else j.count=k.longs===String?"0":0;j.flags=0}if(p.startTimeUnixNano!=null&&p.hasOwnProperty("startTimeUnixNano")&&(typeof p.startTimeUnixNano=="number"?j.startTimeUnixNano=k.longs===String?String(p.startTimeUnixNano):p.startTimeUnixNano:j.startTimeUnixNano=k.longs===String?gt.Long.prototype.toString.call(p.startTimeUnixNano):k.longs===Number?new gt.LongBits(p.startTimeUnixNano.low>>>0,p.startTimeUnixNano.high>>>0).toNumber():p.startTimeUnixNano),p.timeUnixNano!=null&&p.hasOwnProperty("timeUnixNano")&&(typeof p.timeUnixNano=="number"?j.timeUnixNano=k.longs===String?String(p.timeUnixNano):p.timeUnixNano:j.timeUnixNano=k.longs===String?gt.Long.prototype.toString.call(p.timeUnixNano):k.longs===Number?new gt.LongBits(p.timeUnixNano.low>>>0,p.timeUnixNano.high>>>0).toNumber():p.timeUnixNano),p.count!=null&&p.hasOwnProperty("count")&&(typeof p.count=="number"?j.count=k.longs===String?String(p.count):p.count:j.count=k.longs===String?gt.Long.prototype.toString.call(p.count):k.longs===Number?new gt.LongBits(p.count.low>>>0,p.count.high>>>0).toNumber():p.count),p.sum!=null&&p.hasOwnProperty("sum")&&(j.sum=k.json&&!isFinite(p.sum)?String(p.sum):p.sum,k.oneofs&&(j._sum="sum")),p.bucketCounts&&p.bucketCounts.length){j.bucketCounts=[];for(var ze=0;ze<p.bucketCounts.length;++ze)typeof p.bucketCounts[ze]=="number"?j.bucketCounts[ze]=k.longs===String?String(p.bucketCounts[ze]):p.bucketCounts[ze]:j.bucketCounts[ze]=k.longs===String?gt.Long.prototype.toString.call(p.bucketCounts[ze]):k.longs===Number?new gt.LongBits(p.bucketCounts[ze].low>>>0,p.bucketCounts[ze].high>>>0).toNumber():p.bucketCounts[ze]}if(p.explicitBounds&&p.explicitBounds.length){j.explicitBounds=[];for(var ze=0;ze<p.explicitBounds.length;++ze)j.explicitBounds[ze]=k.json&&!isFinite(p.explicitBounds[ze])?String(p.explicitBounds[ze]):p.explicitBounds[ze]}if(p.exemplars&&p.exemplars.length){j.exemplars=[];for(var ze=0;ze<p.exemplars.length;++ze)j.exemplars[ze]=at.opentelemetry.proto.metrics.v1.Exemplar.toObject(p.exemplars[ze],k)}if(p.attributes&&p.attributes.length){j.attributes=[];for(var ze=0;ze<p.attributes.length;++ze)j.attributes[ze]=at.opentelemetry.proto.common.v1.KeyValue.toObject(p.attributes[ze],k)}return p.flags!=null&&p.hasOwnProperty("flags")&&(j.flags=p.flags),p.min!=null&&p.hasOwnProperty("min")&&(j.min=k.json&&!isFinite(p.min)?String(p.min):p.min,k.oneofs&&(j._min="min")),p.max!=null&&p.hasOwnProperty("max")&&(j.max=k.json&&!isFinite(p.max)?String(p.max):p.max,k.oneofs&&(j._max="max")),j},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.metrics.v1.HistogramDataPoint"},b}(),y.ExponentialHistogramDataPoint=function(){function b(g){if(this.attributes=[],this.exemplars=[],g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}b.prototype.attributes=gt.emptyArray,b.prototype.startTimeUnixNano=null,b.prototype.timeUnixNano=null,b.prototype.count=null,b.prototype.sum=null,b.prototype.scale=null,b.prototype.zeroCount=null,b.prototype.positive=null,b.prototype.negative=null,b.prototype.flags=null,b.prototype.exemplars=gt.emptyArray,b.prototype.min=null,b.prototype.max=null,b.prototype.zeroThreshold=null;var A;return Object.defineProperty(b.prototype,"_sum",{get:gt.oneOfGetter(A=["sum"]),set:gt.oneOfSetter(A)}),Object.defineProperty(b.prototype,"_min",{get:gt.oneOfGetter(A=["min"]),set:gt.oneOfSetter(A)}),Object.defineProperty(b.prototype,"_max",{get:gt.oneOfGetter(A=["max"]),set:gt.oneOfSetter(A)}),b.create=function(p){return new b(p)},b.encode=function(p,k){if(k||(k=gl.create()),p.attributes!=null&&p.attributes.length)for(var j=0;j<p.attributes.length;++j)at.opentelemetry.proto.common.v1.KeyValue.encode(p.attributes[j],k.uint32(10).fork()).ldelim();if(p.startTimeUnixNano!=null&&Object.hasOwnProperty.call(p,"startTimeUnixNano")&&k.uint32(17).fixed64(p.startTimeUnixNano),p.timeUnixNano!=null&&Object.hasOwnProperty.call(p,"timeUnixNano")&&k.uint32(25).fixed64(p.timeUnixNano),p.count!=null&&Object.hasOwnProperty.call(p,"count")&&k.uint32(33).fixed64(p.count),p.sum!=null&&Object.hasOwnProperty.call(p,"sum")&&k.uint32(41).double(p.sum),p.scale!=null&&Object.hasOwnProperty.call(p,"scale")&&k.uint32(48).sint32(p.scale),p.zeroCount!=null&&Object.hasOwnProperty.call(p,"zeroCount")&&k.uint32(57).fixed64(p.zeroCount),p.positive!=null&&Object.hasOwnProperty.call(p,"positive")&&at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.Buckets.encode(p.positive,k.uint32(66).fork()).ldelim(),p.negative!=null&&Object.hasOwnProperty.call(p,"negative")&&at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.Buckets.encode(p.negative,k.uint32(74).fork()).ldelim(),p.flags!=null&&Object.hasOwnProperty.call(p,"flags")&&k.uint32(80).uint32(p.flags),p.exemplars!=null&&p.exemplars.length)for(var j=0;j<p.exemplars.length;++j)at.opentelemetry.proto.metrics.v1.Exemplar.encode(p.exemplars[j],k.uint32(90).fork()).ldelim();return p.min!=null&&Object.hasOwnProperty.call(p,"min")&&k.uint32(97).double(p.min),p.max!=null&&Object.hasOwnProperty.call(p,"max")&&k.uint32(105).double(p.max),p.zeroThreshold!=null&&Object.hasOwnProperty.call(p,"zeroThreshold")&&k.uint32(113).double(p.zeroThreshold),k},b.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},b.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 1:{se.attributes&&se.attributes.length||(se.attributes=[]),se.attributes.push(at.opentelemetry.proto.common.v1.KeyValue.decode(p,p.uint32()));break}case 2:{se.startTimeUnixNano=p.fixed64();break}case 3:{se.timeUnixNano=p.fixed64();break}case 4:{se.count=p.fixed64();break}case 5:{se.sum=p.double();break}case 6:{se.scale=p.sint32();break}case 7:{se.zeroCount=p.fixed64();break}case 8:{se.positive=at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.Buckets.decode(p,p.uint32());break}case 9:{se.negative=at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.Buckets.decode(p,p.uint32());break}case 10:{se.flags=p.uint32();break}case 11:{se.exemplars&&se.exemplars.length||(se.exemplars=[]),se.exemplars.push(at.opentelemetry.proto.metrics.v1.Exemplar.decode(p,p.uint32()));break}case 12:{se.min=p.double();break}case 13:{se.max=p.double();break}case 14:{se.zeroThreshold=p.double();break}default:p.skipType(ze&7);break}}return se},b.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},b.verify=function(p){if(typeof p!="object"||p===null)return"object expected";var k={};if(p.attributes!=null&&p.hasOwnProperty("attributes")){if(!Array.isArray(p.attributes))return"attributes: array expected";for(var j=0;j<p.attributes.length;++j){var se=at.opentelemetry.proto.common.v1.KeyValue.verify(p.attributes[j]);if(se)return"attributes."+se}}if(p.startTimeUnixNano!=null&&p.hasOwnProperty("startTimeUnixNano")&&!gt.isInteger(p.startTimeUnixNano)&&!(p.startTimeUnixNano&&gt.isInteger(p.startTimeUnixNano.low)&&gt.isInteger(p.startTimeUnixNano.high)))return"startTimeUnixNano: integer|Long expected";if(p.timeUnixNano!=null&&p.hasOwnProperty("timeUnixNano")&&!gt.isInteger(p.timeUnixNano)&&!(p.timeUnixNano&&gt.isInteger(p.timeUnixNano.low)&&gt.isInteger(p.timeUnixNano.high)))return"timeUnixNano: integer|Long expected";if(p.count!=null&&p.hasOwnProperty("count")&&!gt.isInteger(p.count)&&!(p.count&&gt.isInteger(p.count.low)&&gt.isInteger(p.count.high)))return"count: integer|Long expected";if(p.sum!=null&&p.hasOwnProperty("sum")&&(k._sum=1,typeof p.sum!="number"))return"sum: number expected";if(p.scale!=null&&p.hasOwnProperty("scale")&&!gt.isInteger(p.scale))return"scale: integer expected";if(p.zeroCount!=null&&p.hasOwnProperty("zeroCount")&&!gt.isInteger(p.zeroCount)&&!(p.zeroCount&&gt.isInteger(p.zeroCount.low)&&gt.isInteger(p.zeroCount.high)))return"zeroCount: integer|Long expected";if(p.positive!=null&&p.hasOwnProperty("positive")){var se=at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.Buckets.verify(p.positive);if(se)return"positive."+se}if(p.negative!=null&&p.hasOwnProperty("negative")){var se=at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.Buckets.verify(p.negative);if(se)return"negative."+se}if(p.flags!=null&&p.hasOwnProperty("flags")&&!gt.isInteger(p.flags))return"flags: integer expected";if(p.exemplars!=null&&p.hasOwnProperty("exemplars")){if(!Array.isArray(p.exemplars))return"exemplars: array expected";for(var j=0;j<p.exemplars.length;++j){var se=at.opentelemetry.proto.metrics.v1.Exemplar.verify(p.exemplars[j]);if(se)return"exemplars."+se}}return p.min!=null&&p.hasOwnProperty("min")&&(k._min=1,typeof p.min!="number")?"min: number expected":p.max!=null&&p.hasOwnProperty("max")&&(k._max=1,typeof p.max!="number")?"max: number expected":p.zeroThreshold!=null&&p.hasOwnProperty("zeroThreshold")&&typeof p.zeroThreshold!="number"?"zeroThreshold: number expected":null},b.fromObject=function(p){if(p instanceof at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint)return p;var k=new at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint;if(p.attributes){if(!Array.isArray(p.attributes))throw TypeError(".opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.attributes: array expected");k.attributes=[];for(var j=0;j<p.attributes.length;++j){if(typeof p.attributes[j]!="object")throw TypeError(".opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.attributes: object expected");k.attributes[j]=at.opentelemetry.proto.common.v1.KeyValue.fromObject(p.attributes[j])}}if(p.startTimeUnixNano!=null&&(gt.Long?(k.startTimeUnixNano=gt.Long.fromValue(p.startTimeUnixNano)).unsigned=!1:typeof p.startTimeUnixNano=="string"?k.startTimeUnixNano=parseInt(p.startTimeUnixNano,10):typeof p.startTimeUnixNano=="number"?k.startTimeUnixNano=p.startTimeUnixNano:typeof p.startTimeUnixNano=="object"&&(k.startTimeUnixNano=new gt.LongBits(p.startTimeUnixNano.low>>>0,p.startTimeUnixNano.high>>>0).toNumber())),p.timeUnixNano!=null&&(gt.Long?(k.timeUnixNano=gt.Long.fromValue(p.timeUnixNano)).unsigned=!1:typeof p.timeUnixNano=="string"?k.timeUnixNano=parseInt(p.timeUnixNano,10):typeof p.timeUnixNano=="number"?k.timeUnixNano=p.timeUnixNano:typeof p.timeUnixNano=="object"&&(k.timeUnixNano=new gt.LongBits(p.timeUnixNano.low>>>0,p.timeUnixNano.high>>>0).toNumber())),p.count!=null&&(gt.Long?(k.count=gt.Long.fromValue(p.count)).unsigned=!1:typeof p.count=="string"?k.count=parseInt(p.count,10):typeof p.count=="number"?k.count=p.count:typeof p.count=="object"&&(k.count=new gt.LongBits(p.count.low>>>0,p.count.high>>>0).toNumber())),p.sum!=null&&(k.sum=Number(p.sum)),p.scale!=null&&(k.scale=p.scale|0),p.zeroCount!=null&&(gt.Long?(k.zeroCount=gt.Long.fromValue(p.zeroCount)).unsigned=!1:typeof p.zeroCount=="string"?k.zeroCount=parseInt(p.zeroCount,10):typeof p.zeroCount=="number"?k.zeroCount=p.zeroCount:typeof p.zeroCount=="object"&&(k.zeroCount=new gt.LongBits(p.zeroCount.low>>>0,p.zeroCount.high>>>0).toNumber())),p.positive!=null){if(typeof p.positive!="object")throw TypeError(".opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.positive: object expected");k.positive=at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.Buckets.fromObject(p.positive)}if(p.negative!=null){if(typeof p.negative!="object")throw TypeError(".opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.negative: object expected");k.negative=at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.Buckets.fromObject(p.negative)}if(p.flags!=null&&(k.flags=p.flags>>>0),p.exemplars){if(!Array.isArray(p.exemplars))throw TypeError(".opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.exemplars: array expected");k.exemplars=[];for(var j=0;j<p.exemplars.length;++j){if(typeof p.exemplars[j]!="object")throw TypeError(".opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.exemplars: object expected");k.exemplars[j]=at.opentelemetry.proto.metrics.v1.Exemplar.fromObject(p.exemplars[j])}}return p.min!=null&&(k.min=Number(p.min)),p.max!=null&&(k.max=Number(p.max)),p.zeroThreshold!=null&&(k.zeroThreshold=Number(p.zeroThreshold)),k},b.toObject=function(p,k){k||(k={});var j={};if((k.arrays||k.defaults)&&(j.attributes=[],j.exemplars=[]),k.defaults){if(gt.Long){var se=new gt.Long(0,0,!1);j.startTimeUnixNano=k.longs===String?se.toString():k.longs===Number?se.toNumber():se}else j.startTimeUnixNano=k.longs===String?"0":0;if(gt.Long){var se=new gt.Long(0,0,!1);j.timeUnixNano=k.longs===String?se.toString():k.longs===Number?se.toNumber():se}else j.timeUnixNano=k.longs===String?"0":0;if(gt.Long){var se=new gt.Long(0,0,!1);j.count=k.longs===String?se.toString():k.longs===Number?se.toNumber():se}else j.count=k.longs===String?"0":0;if(j.scale=0,gt.Long){var se=new gt.Long(0,0,!1);j.zeroCount=k.longs===String?se.toString():k.longs===Number?se.toNumber():se}else j.zeroCount=k.longs===String?"0":0;j.positive=null,j.negative=null,j.flags=0,j.zeroThreshold=0}if(p.attributes&&p.attributes.length){j.attributes=[];for(var ze=0;ze<p.attributes.length;++ze)j.attributes[ze]=at.opentelemetry.proto.common.v1.KeyValue.toObject(p.attributes[ze],k)}if(p.startTimeUnixNano!=null&&p.hasOwnProperty("startTimeUnixNano")&&(typeof p.startTimeUnixNano=="number"?j.startTimeUnixNano=k.longs===String?String(p.startTimeUnixNano):p.startTimeUnixNano:j.startTimeUnixNano=k.longs===String?gt.Long.prototype.toString.call(p.startTimeUnixNano):k.longs===Number?new gt.LongBits(p.startTimeUnixNano.low>>>0,p.startTimeUnixNano.high>>>0).toNumber():p.startTimeUnixNano),p.timeUnixNano!=null&&p.hasOwnProperty("timeUnixNano")&&(typeof p.timeUnixNano=="number"?j.timeUnixNano=k.longs===String?String(p.timeUnixNano):p.timeUnixNano:j.timeUnixNano=k.longs===String?gt.Long.prototype.toString.call(p.timeUnixNano):k.longs===Number?new gt.LongBits(p.timeUnixNano.low>>>0,p.timeUnixNano.high>>>0).toNumber():p.timeUnixNano),p.count!=null&&p.hasOwnProperty("count")&&(typeof p.count=="number"?j.count=k.longs===String?String(p.count):p.count:j.count=k.longs===String?gt.Long.prototype.toString.call(p.count):k.longs===Number?new gt.LongBits(p.count.low>>>0,p.count.high>>>0).toNumber():p.count),p.sum!=null&&p.hasOwnProperty("sum")&&(j.sum=k.json&&!isFinite(p.sum)?String(p.sum):p.sum,k.oneofs&&(j._sum="sum")),p.scale!=null&&p.hasOwnProperty("scale")&&(j.scale=p.scale),p.zeroCount!=null&&p.hasOwnProperty("zeroCount")&&(typeof p.zeroCount=="number"?j.zeroCount=k.longs===String?String(p.zeroCount):p.zeroCount:j.zeroCount=k.longs===String?gt.Long.prototype.toString.call(p.zeroCount):k.longs===Number?new gt.LongBits(p.zeroCount.low>>>0,p.zeroCount.high>>>0).toNumber():p.zeroCount),p.positive!=null&&p.hasOwnProperty("positive")&&(j.positive=at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.Buckets.toObject(p.positive,k)),p.negative!=null&&p.hasOwnProperty("negative")&&(j.negative=at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.Buckets.toObject(p.negative,k)),p.flags!=null&&p.hasOwnProperty("flags")&&(j.flags=p.flags),p.exemplars&&p.exemplars.length){j.exemplars=[];for(var ze=0;ze<p.exemplars.length;++ze)j.exemplars[ze]=at.opentelemetry.proto.metrics.v1.Exemplar.toObject(p.exemplars[ze],k)}return p.min!=null&&p.hasOwnProperty("min")&&(j.min=k.json&&!isFinite(p.min)?String(p.min):p.min,k.oneofs&&(j._min="min")),p.max!=null&&p.hasOwnProperty("max")&&(j.max=k.json&&!isFinite(p.max)?String(p.max):p.max,k.oneofs&&(j._max="max")),p.zeroThreshold!=null&&p.hasOwnProperty("zeroThreshold")&&(j.zeroThreshold=k.json&&!isFinite(p.zeroThreshold)?String(p.zeroThreshold):p.zeroThreshold),j},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint"},b.Buckets=function(){function g(p){if(this.bucketCounts=[],p)for(var k=Object.keys(p),j=0;j<k.length;++j)p[k[j]]!=null&&(this[k[j]]=p[k[j]])}return g.prototype.offset=null,g.prototype.bucketCounts=gt.emptyArray,g.create=function(k){return new g(k)},g.encode=function(k,j){if(j||(j=gl.create()),k.offset!=null&&Object.hasOwnProperty.call(k,"offset")&&j.uint32(8).sint32(k.offset),k.bucketCounts!=null&&k.bucketCounts.length){j.uint32(18).fork();for(var se=0;se<k.bucketCounts.length;++se)j.uint64(k.bucketCounts[se]);j.ldelim()}return j},g.encodeDelimited=function(k,j){return this.encode(k,j).ldelim()},g.decode=function(k,j){k instanceof mn||(k=mn.create(k));for(var se=j===void 0?k.len:k.pos+j,ze=new at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.Buckets;k.pos<se;){var ve=k.uint32();switch(ve>>>3){case 1:{ze.offset=k.sint32();break}case 2:{if(ze.bucketCounts&&ze.bucketCounts.length||(ze.bucketCounts=[]),(ve&7)===2)for(var lr=k.uint32()+k.pos;k.pos<lr;)ze.bucketCounts.push(k.uint64());else ze.bucketCounts.push(k.uint64());break}default:k.skipType(ve&7);break}}return ze},g.decodeDelimited=function(k){return k instanceof mn||(k=new mn(k)),this.decode(k,k.uint32())},g.verify=function(k){if(typeof k!="object"||k===null)return"object expected";if(k.offset!=null&&k.hasOwnProperty("offset")&&!gt.isInteger(k.offset))return"offset: integer expected";if(k.bucketCounts!=null&&k.hasOwnProperty("bucketCounts")){if(!Array.isArray(k.bucketCounts))return"bucketCounts: array expected";for(var j=0;j<k.bucketCounts.length;++j)if(!gt.isInteger(k.bucketCounts[j])&&!(k.bucketCounts[j]&&gt.isInteger(k.bucketCounts[j].low)&&gt.isInteger(k.bucketCounts[j].high)))return"bucketCounts: integer|Long[] expected"}return null},g.fromObject=function(k){if(k instanceof at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.Buckets)return k;var j=new at.opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.Buckets;if(k.offset!=null&&(j.offset=k.offset|0),k.bucketCounts){if(!Array.isArray(k.bucketCounts))throw TypeError(".opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.Buckets.bucketCounts: array expected");j.bucketCounts=[];for(var se=0;se<k.bucketCounts.length;++se)gt.Long?(j.bucketCounts[se]=gt.Long.fromValue(k.bucketCounts[se])).unsigned=!0:typeof k.bucketCounts[se]=="string"?j.bucketCounts[se]=parseInt(k.bucketCounts[se],10):typeof k.bucketCounts[se]=="number"?j.bucketCounts[se]=k.bucketCounts[se]:typeof k.bucketCounts[se]=="object"&&(j.bucketCounts[se]=new gt.LongBits(k.bucketCounts[se].low>>>0,k.bucketCounts[se].high>>>0).toNumber(!0))}return j},g.toObject=function(k,j){j||(j={});var se={};if((j.arrays||j.defaults)&&(se.bucketCounts=[]),j.defaults&&(se.offset=0),k.offset!=null&&k.hasOwnProperty("offset")&&(se.offset=k.offset),k.bucketCounts&&k.bucketCounts.length){se.bucketCounts=[];for(var ze=0;ze<k.bucketCounts.length;++ze)typeof k.bucketCounts[ze]=="number"?se.bucketCounts[ze]=j.longs===String?String(k.bucketCounts[ze]):k.bucketCounts[ze]:se.bucketCounts[ze]=j.longs===String?gt.Long.prototype.toString.call(k.bucketCounts[ze]):j.longs===Number?new gt.LongBits(k.bucketCounts[ze].low>>>0,k.bucketCounts[ze].high>>>0).toNumber(!0):k.bucketCounts[ze]}return se},g.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},g.getTypeUrl=function(k){return k===void 0&&(k="type.googleapis.com"),k+"/opentelemetry.proto.metrics.v1.ExponentialHistogramDataPoint.Buckets"},g}(),b}(),y.SummaryDataPoint=function(){function b(A){if(this.attributes=[],this.quantileValues=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.attributes=gt.emptyArray,b.prototype.startTimeUnixNano=null,b.prototype.timeUnixNano=null,b.prototype.count=null,b.prototype.sum=null,b.prototype.quantileValues=gt.emptyArray,b.prototype.flags=null,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.startTimeUnixNano!=null&&Object.hasOwnProperty.call(g,"startTimeUnixNano")&&p.uint32(17).fixed64(g.startTimeUnixNano),g.timeUnixNano!=null&&Object.hasOwnProperty.call(g,"timeUnixNano")&&p.uint32(25).fixed64(g.timeUnixNano),g.count!=null&&Object.hasOwnProperty.call(g,"count")&&p.uint32(33).fixed64(g.count),g.sum!=null&&Object.hasOwnProperty.call(g,"sum")&&p.uint32(41).double(g.sum),g.quantileValues!=null&&g.quantileValues.length)for(var k=0;k<g.quantileValues.length;++k)at.opentelemetry.proto.metrics.v1.SummaryDataPoint.ValueAtQuantile.encode(g.quantileValues[k],p.uint32(50).fork()).ldelim();if(g.attributes!=null&&g.attributes.length)for(var k=0;k<g.attributes.length;++k)at.opentelemetry.proto.common.v1.KeyValue.encode(g.attributes[k],p.uint32(58).fork()).ldelim();return g.flags!=null&&Object.hasOwnProperty.call(g,"flags")&&p.uint32(64).uint32(g.flags),p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.metrics.v1.SummaryDataPoint;g.pos<k;){var se=g.uint32();switch(se>>>3){case 7:{j.attributes&&j.attributes.length||(j.attributes=[]),j.attributes.push(at.opentelemetry.proto.common.v1.KeyValue.decode(g,g.uint32()));break}case 2:{j.startTimeUnixNano=g.fixed64();break}case 3:{j.timeUnixNano=g.fixed64();break}case 4:{j.count=g.fixed64();break}case 5:{j.sum=g.double();break}case 6:{j.quantileValues&&j.quantileValues.length||(j.quantileValues=[]),j.quantileValues.push(at.opentelemetry.proto.metrics.v1.SummaryDataPoint.ValueAtQuantile.decode(g,g.uint32()));break}case 8:{j.flags=g.uint32();break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.attributes!=null&&g.hasOwnProperty("attributes")){if(!Array.isArray(g.attributes))return"attributes: array expected";for(var p=0;p<g.attributes.length;++p){var k=at.opentelemetry.proto.common.v1.KeyValue.verify(g.attributes[p]);if(k)return"attributes."+k}}if(g.startTimeUnixNano!=null&&g.hasOwnProperty("startTimeUnixNano")&&!gt.isInteger(g.startTimeUnixNano)&&!(g.startTimeUnixNano&&gt.isInteger(g.startTimeUnixNano.low)&&gt.isInteger(g.startTimeUnixNano.high)))return"startTimeUnixNano: integer|Long expected";if(g.timeUnixNano!=null&&g.hasOwnProperty("timeUnixNano")&&!gt.isInteger(g.timeUnixNano)&&!(g.timeUnixNano&&gt.isInteger(g.timeUnixNano.low)&&gt.isInteger(g.timeUnixNano.high)))return"timeUnixNano: integer|Long expected";if(g.count!=null&&g.hasOwnProperty("count")&&!gt.isInteger(g.count)&&!(g.count&&gt.isInteger(g.count.low)&&gt.isInteger(g.count.high)))return"count: integer|Long expected";if(g.sum!=null&&g.hasOwnProperty("sum")&&typeof g.sum!="number")return"sum: number expected";if(g.quantileValues!=null&&g.hasOwnProperty("quantileValues")){if(!Array.isArray(g.quantileValues))return"quantileValues: array expected";for(var p=0;p<g.quantileValues.length;++p){var k=at.opentelemetry.proto.metrics.v1.SummaryDataPoint.ValueAtQuantile.verify(g.quantileValues[p]);if(k)return"quantileValues."+k}}return g.flags!=null&&g.hasOwnProperty("flags")&&!gt.isInteger(g.flags)?"flags: integer expected":null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.metrics.v1.SummaryDataPoint)return g;var p=new at.opentelemetry.proto.metrics.v1.SummaryDataPoint;if(g.attributes){if(!Array.isArray(g.attributes))throw TypeError(".opentelemetry.proto.metrics.v1.SummaryDataPoint.attributes: array expected");p.attributes=[];for(var k=0;k<g.attributes.length;++k){if(typeof g.attributes[k]!="object")throw TypeError(".opentelemetry.proto.metrics.v1.SummaryDataPoint.attributes: object expected");p.attributes[k]=at.opentelemetry.proto.common.v1.KeyValue.fromObject(g.attributes[k])}}if(g.startTimeUnixNano!=null&&(gt.Long?(p.startTimeUnixNano=gt.Long.fromValue(g.startTimeUnixNano)).unsigned=!1:typeof g.startTimeUnixNano=="string"?p.startTimeUnixNano=parseInt(g.startTimeUnixNano,10):typeof g.startTimeUnixNano=="number"?p.startTimeUnixNano=g.startTimeUnixNano:typeof g.startTimeUnixNano=="object"&&(p.startTimeUnixNano=new gt.LongBits(g.startTimeUnixNano.low>>>0,g.startTimeUnixNano.high>>>0).toNumber())),g.timeUnixNano!=null&&(gt.Long?(p.timeUnixNano=gt.Long.fromValue(g.timeUnixNano)).unsigned=!1:typeof g.timeUnixNano=="string"?p.timeUnixNano=parseInt(g.timeUnixNano,10):typeof g.timeUnixNano=="number"?p.timeUnixNano=g.timeUnixNano:typeof g.timeUnixNano=="object"&&(p.timeUnixNano=new gt.LongBits(g.timeUnixNano.low>>>0,g.timeUnixNano.high>>>0).toNumber())),g.count!=null&&(gt.Long?(p.count=gt.Long.fromValue(g.count)).unsigned=!1:typeof g.count=="string"?p.count=parseInt(g.count,10):typeof g.count=="number"?p.count=g.count:typeof g.count=="object"&&(p.count=new gt.LongBits(g.count.low>>>0,g.count.high>>>0).toNumber())),g.sum!=null&&(p.sum=Number(g.sum)),g.quantileValues){if(!Array.isArray(g.quantileValues))throw TypeError(".opentelemetry.proto.metrics.v1.SummaryDataPoint.quantileValues: array expected");p.quantileValues=[];for(var k=0;k<g.quantileValues.length;++k){if(typeof g.quantileValues[k]!="object")throw TypeError(".opentelemetry.proto.metrics.v1.SummaryDataPoint.quantileValues: object expected");p.quantileValues[k]=at.opentelemetry.proto.metrics.v1.SummaryDataPoint.ValueAtQuantile.fromObject(g.quantileValues[k])}}return g.flags!=null&&(p.flags=g.flags>>>0),p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.quantileValues=[],k.attributes=[]),p.defaults){if(gt.Long){var j=new gt.Long(0,0,!1);k.startTimeUnixNano=p.longs===String?j.toString():p.longs===Number?j.toNumber():j}else k.startTimeUnixNano=p.longs===String?"0":0;if(gt.Long){var j=new gt.Long(0,0,!1);k.timeUnixNano=p.longs===String?j.toString():p.longs===Number?j.toNumber():j}else k.timeUnixNano=p.longs===String?"0":0;if(gt.Long){var j=new gt.Long(0,0,!1);k.count=p.longs===String?j.toString():p.longs===Number?j.toNumber():j}else k.count=p.longs===String?"0":0;k.sum=0,k.flags=0}if(g.startTimeUnixNano!=null&&g.hasOwnProperty("startTimeUnixNano")&&(typeof g.startTimeUnixNano=="number"?k.startTimeUnixNano=p.longs===String?String(g.startTimeUnixNano):g.startTimeUnixNano:k.startTimeUnixNano=p.longs===String?gt.Long.prototype.toString.call(g.startTimeUnixNano):p.longs===Number?new gt.LongBits(g.startTimeUnixNano.low>>>0,g.startTimeUnixNano.high>>>0).toNumber():g.startTimeUnixNano),g.timeUnixNano!=null&&g.hasOwnProperty("timeUnixNano")&&(typeof g.timeUnixNano=="number"?k.timeUnixNano=p.longs===String?String(g.timeUnixNano):g.timeUnixNano:k.timeUnixNano=p.longs===String?gt.Long.prototype.toString.call(g.timeUnixNano):p.longs===Number?new gt.LongBits(g.timeUnixNano.low>>>0,g.timeUnixNano.high>>>0).toNumber():g.timeUnixNano),g.count!=null&&g.hasOwnProperty("count")&&(typeof g.count=="number"?k.count=p.longs===String?String(g.count):g.count:k.count=p.longs===String?gt.Long.prototype.toString.call(g.count):p.longs===Number?new gt.LongBits(g.count.low>>>0,g.count.high>>>0).toNumber():g.count),g.sum!=null&&g.hasOwnProperty("sum")&&(k.sum=p.json&&!isFinite(g.sum)?String(g.sum):g.sum),g.quantileValues&&g.quantileValues.length){k.quantileValues=[];for(var se=0;se<g.quantileValues.length;++se)k.quantileValues[se]=at.opentelemetry.proto.metrics.v1.SummaryDataPoint.ValueAtQuantile.toObject(g.quantileValues[se],p)}if(g.attributes&&g.attributes.length){k.attributes=[];for(var se=0;se<g.attributes.length;++se)k.attributes[se]=at.opentelemetry.proto.common.v1.KeyValue.toObject(g.attributes[se],p)}return g.flags!=null&&g.hasOwnProperty("flags")&&(k.flags=g.flags),k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.metrics.v1.SummaryDataPoint"},b.ValueAtQuantile=function(){function A(g){if(g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}return A.prototype.quantile=null,A.prototype.value=null,A.create=function(p){return new A(p)},A.encode=function(p,k){return k||(k=gl.create()),p.quantile!=null&&Object.hasOwnProperty.call(p,"quantile")&&k.uint32(9).double(p.quantile),p.value!=null&&Object.hasOwnProperty.call(p,"value")&&k.uint32(17).double(p.value),k},A.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},A.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.metrics.v1.SummaryDataPoint.ValueAtQuantile;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 1:{se.quantile=p.double();break}case 2:{se.value=p.double();break}default:p.skipType(ze&7);break}}return se},A.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},A.verify=function(p){return typeof p!="object"||p===null?"object expected":p.quantile!=null&&p.hasOwnProperty("quantile")&&typeof p.quantile!="number"?"quantile: number expected":p.value!=null&&p.hasOwnProperty("value")&&typeof p.value!="number"?"value: number expected":null},A.fromObject=function(p){if(p instanceof at.opentelemetry.proto.metrics.v1.SummaryDataPoint.ValueAtQuantile)return p;var k=new at.opentelemetry.proto.metrics.v1.SummaryDataPoint.ValueAtQuantile;return p.quantile!=null&&(k.quantile=Number(p.quantile)),p.value!=null&&(k.value=Number(p.value)),k},A.toObject=function(p,k){k||(k={});var j={};return k.defaults&&(j.quantile=0,j.value=0),p.quantile!=null&&p.hasOwnProperty("quantile")&&(j.quantile=k.json&&!isFinite(p.quantile)?String(p.quantile):p.quantile),p.value!=null&&p.hasOwnProperty("value")&&(j.value=k.json&&!isFinite(p.value)?String(p.value):p.value),j},A.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},A.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.metrics.v1.SummaryDataPoint.ValueAtQuantile"},A}(),b}(),y.Exemplar=function(){function b(g){if(this.filteredAttributes=[],g)for(var p=Object.keys(g),k=0;k<p.length;++k)g[p[k]]!=null&&(this[p[k]]=g[p[k]])}b.prototype.filteredAttributes=gt.emptyArray,b.prototype.timeUnixNano=null,b.prototype.asDouble=null,b.prototype.asInt=null,b.prototype.spanId=null,b.prototype.traceId=null;var A;return Object.defineProperty(b.prototype,"value",{get:gt.oneOfGetter(A=["asDouble","asInt"]),set:gt.oneOfSetter(A)}),b.create=function(p){return new b(p)},b.encode=function(p,k){if(k||(k=gl.create()),p.timeUnixNano!=null&&Object.hasOwnProperty.call(p,"timeUnixNano")&&k.uint32(17).fixed64(p.timeUnixNano),p.asDouble!=null&&Object.hasOwnProperty.call(p,"asDouble")&&k.uint32(25).double(p.asDouble),p.spanId!=null&&Object.hasOwnProperty.call(p,"spanId")&&k.uint32(34).bytes(p.spanId),p.traceId!=null&&Object.hasOwnProperty.call(p,"traceId")&&k.uint32(42).bytes(p.traceId),p.asInt!=null&&Object.hasOwnProperty.call(p,"asInt")&&k.uint32(49).sfixed64(p.asInt),p.filteredAttributes!=null&&p.filteredAttributes.length)for(var j=0;j<p.filteredAttributes.length;++j)at.opentelemetry.proto.common.v1.KeyValue.encode(p.filteredAttributes[j],k.uint32(58).fork()).ldelim();return k},b.encodeDelimited=function(p,k){return this.encode(p,k).ldelim()},b.decode=function(p,k){p instanceof mn||(p=mn.create(p));for(var j=k===void 0?p.len:p.pos+k,se=new at.opentelemetry.proto.metrics.v1.Exemplar;p.pos<j;){var ze=p.uint32();switch(ze>>>3){case 7:{se.filteredAttributes&&se.filteredAttributes.length||(se.filteredAttributes=[]),se.filteredAttributes.push(at.opentelemetry.proto.common.v1.KeyValue.decode(p,p.uint32()));break}case 2:{se.timeUnixNano=p.fixed64();break}case 3:{se.asDouble=p.double();break}case 6:{se.asInt=p.sfixed64();break}case 4:{se.spanId=p.bytes();break}case 5:{se.traceId=p.bytes();break}default:p.skipType(ze&7);break}}return se},b.decodeDelimited=function(p){return p instanceof mn||(p=new mn(p)),this.decode(p,p.uint32())},b.verify=function(p){if(typeof p!="object"||p===null)return"object expected";var k={};if(p.filteredAttributes!=null&&p.hasOwnProperty("filteredAttributes")){if(!Array.isArray(p.filteredAttributes))return"filteredAttributes: array expected";for(var j=0;j<p.filteredAttributes.length;++j){var se=at.opentelemetry.proto.common.v1.KeyValue.verify(p.filteredAttributes[j]);if(se)return"filteredAttributes."+se}}if(p.timeUnixNano!=null&&p.hasOwnProperty("timeUnixNano")&&!gt.isInteger(p.timeUnixNano)&&!(p.timeUnixNano&&gt.isInteger(p.timeUnixNano.low)&&gt.isInteger(p.timeUnixNano.high)))return"timeUnixNano: integer|Long expected";if(p.asDouble!=null&&p.hasOwnProperty("asDouble")&&(k.value=1,typeof p.asDouble!="number"))return"asDouble: number expected";if(p.asInt!=null&&p.hasOwnProperty("asInt")){if(k.value===1)return"value: multiple values";if(k.value=1,!gt.isInteger(p.asInt)&&!(p.asInt&&gt.isInteger(p.asInt.low)&&gt.isInteger(p.asInt.high)))return"asInt: integer|Long expected"}return p.spanId!=null&&p.hasOwnProperty("spanId")&&!(p.spanId&&typeof p.spanId.length=="number"||gt.isString(p.spanId))?"spanId: buffer expected":p.traceId!=null&&p.hasOwnProperty("traceId")&&!(p.traceId&&typeof p.traceId.length=="number"||gt.isString(p.traceId))?"traceId: buffer expected":null},b.fromObject=function(p){if(p instanceof at.opentelemetry.proto.metrics.v1.Exemplar)return p;var k=new at.opentelemetry.proto.metrics.v1.Exemplar;if(p.filteredAttributes){if(!Array.isArray(p.filteredAttributes))throw TypeError(".opentelemetry.proto.metrics.v1.Exemplar.filteredAttributes: array expected");k.filteredAttributes=[];for(var j=0;j<p.filteredAttributes.length;++j){if(typeof p.filteredAttributes[j]!="object")throw TypeError(".opentelemetry.proto.metrics.v1.Exemplar.filteredAttributes: object expected");k.filteredAttributes[j]=at.opentelemetry.proto.common.v1.KeyValue.fromObject(p.filteredAttributes[j])}}return p.timeUnixNano!=null&&(gt.Long?(k.timeUnixNano=gt.Long.fromValue(p.timeUnixNano)).unsigned=!1:typeof p.timeUnixNano=="string"?k.timeUnixNano=parseInt(p.timeUnixNano,10):typeof p.timeUnixNano=="number"?k.timeUnixNano=p.timeUnixNano:typeof p.timeUnixNano=="object"&&(k.timeUnixNano=new gt.LongBits(p.timeUnixNano.low>>>0,p.timeUnixNano.high>>>0).toNumber())),p.asDouble!=null&&(k.asDouble=Number(p.asDouble)),p.asInt!=null&&(gt.Long?(k.asInt=gt.Long.fromValue(p.asInt)).unsigned=!1:typeof p.asInt=="string"?k.asInt=parseInt(p.asInt,10):typeof p.asInt=="number"?k.asInt=p.asInt:typeof p.asInt=="object"&&(k.asInt=new gt.LongBits(p.asInt.low>>>0,p.asInt.high>>>0).toNumber())),p.spanId!=null&&(typeof p.spanId=="string"?gt.base64.decode(p.spanId,k.spanId=gt.newBuffer(gt.base64.length(p.spanId)),0):p.spanId.length>=0&&(k.spanId=p.spanId)),p.traceId!=null&&(typeof p.traceId=="string"?gt.base64.decode(p.traceId,k.traceId=gt.newBuffer(gt.base64.length(p.traceId)),0):p.traceId.length>=0&&(k.traceId=p.traceId)),k},b.toObject=function(p,k){k||(k={});var j={};if((k.arrays||k.defaults)&&(j.filteredAttributes=[]),k.defaults){if(gt.Long){var se=new gt.Long(0,0,!1);j.timeUnixNano=k.longs===String?se.toString():k.longs===Number?se.toNumber():se}else j.timeUnixNano=k.longs===String?"0":0;k.bytes===String?j.spanId="":(j.spanId=[],k.bytes!==Array&&(j.spanId=gt.newBuffer(j.spanId))),k.bytes===String?j.traceId="":(j.traceId=[],k.bytes!==Array&&(j.traceId=gt.newBuffer(j.traceId)))}if(p.timeUnixNano!=null&&p.hasOwnProperty("timeUnixNano")&&(typeof p.timeUnixNano=="number"?j.timeUnixNano=k.longs===String?String(p.timeUnixNano):p.timeUnixNano:j.timeUnixNano=k.longs===String?gt.Long.prototype.toString.call(p.timeUnixNano):k.longs===Number?new gt.LongBits(p.timeUnixNano.low>>>0,p.timeUnixNano.high>>>0).toNumber():p.timeUnixNano),p.asDouble!=null&&p.hasOwnProperty("asDouble")&&(j.asDouble=k.json&&!isFinite(p.asDouble)?String(p.asDouble):p.asDouble,k.oneofs&&(j.value="asDouble")),p.spanId!=null&&p.hasOwnProperty("spanId")&&(j.spanId=k.bytes===String?gt.base64.encode(p.spanId,0,p.spanId.length):k.bytes===Array?Array.prototype.slice.call(p.spanId):p.spanId),p.traceId!=null&&p.hasOwnProperty("traceId")&&(j.traceId=k.bytes===String?gt.base64.encode(p.traceId,0,p.traceId.length):k.bytes===Array?Array.prototype.slice.call(p.traceId):p.traceId),p.asInt!=null&&p.hasOwnProperty("asInt")&&(typeof p.asInt=="number"?j.asInt=k.longs===String?String(p.asInt):p.asInt:j.asInt=k.longs===String?gt.Long.prototype.toString.call(p.asInt):k.longs===Number?new gt.LongBits(p.asInt.low>>>0,p.asInt.high>>>0).toNumber():p.asInt,k.oneofs&&(j.value="asInt")),p.filteredAttributes&&p.filteredAttributes.length){j.filteredAttributes=[];for(var ze=0;ze<p.filteredAttributes.length;++ze)j.filteredAttributes[ze]=at.opentelemetry.proto.common.v1.KeyValue.toObject(p.filteredAttributes[ze],k)}return j},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(p){return p===void 0&&(p="type.googleapis.com"),p+"/opentelemetry.proto.metrics.v1.Exemplar"},b}(),y}(),f}(),c.logs=function(){var f={};return f.v1=function(){var y={};return y.LogsData=function(){function b(A){if(this.resourceLogs=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.resourceLogs=gt.emptyArray,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.resourceLogs!=null&&g.resourceLogs.length)for(var k=0;k<g.resourceLogs.length;++k)at.opentelemetry.proto.logs.v1.ResourceLogs.encode(g.resourceLogs[k],p.uint32(10).fork()).ldelim();return p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.logs.v1.LogsData;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.resourceLogs&&j.resourceLogs.length||(j.resourceLogs=[]),j.resourceLogs.push(at.opentelemetry.proto.logs.v1.ResourceLogs.decode(g,g.uint32()));break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.resourceLogs!=null&&g.hasOwnProperty("resourceLogs")){if(!Array.isArray(g.resourceLogs))return"resourceLogs: array expected";for(var p=0;p<g.resourceLogs.length;++p){var k=at.opentelemetry.proto.logs.v1.ResourceLogs.verify(g.resourceLogs[p]);if(k)return"resourceLogs."+k}}return null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.logs.v1.LogsData)return g;var p=new at.opentelemetry.proto.logs.v1.LogsData;if(g.resourceLogs){if(!Array.isArray(g.resourceLogs))throw TypeError(".opentelemetry.proto.logs.v1.LogsData.resourceLogs: array expected");p.resourceLogs=[];for(var k=0;k<g.resourceLogs.length;++k){if(typeof g.resourceLogs[k]!="object")throw TypeError(".opentelemetry.proto.logs.v1.LogsData.resourceLogs: object expected");p.resourceLogs[k]=at.opentelemetry.proto.logs.v1.ResourceLogs.fromObject(g.resourceLogs[k])}}return p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.resourceLogs=[]),g.resourceLogs&&g.resourceLogs.length){k.resourceLogs=[];for(var j=0;j<g.resourceLogs.length;++j)k.resourceLogs[j]=at.opentelemetry.proto.logs.v1.ResourceLogs.toObject(g.resourceLogs[j],p)}return k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.logs.v1.LogsData"},b}(),y.ResourceLogs=function(){function b(A){if(this.scopeLogs=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.resource=null,b.prototype.scopeLogs=gt.emptyArray,b.prototype.schemaUrl=null,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.resource!=null&&Object.hasOwnProperty.call(g,"resource")&&at.opentelemetry.proto.resource.v1.Resource.encode(g.resource,p.uint32(10).fork()).ldelim(),g.scopeLogs!=null&&g.scopeLogs.length)for(var k=0;k<g.scopeLogs.length;++k)at.opentelemetry.proto.logs.v1.ScopeLogs.encode(g.scopeLogs[k],p.uint32(18).fork()).ldelim();return g.schemaUrl!=null&&Object.hasOwnProperty.call(g,"schemaUrl")&&p.uint32(26).string(g.schemaUrl),p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.logs.v1.ResourceLogs;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.resource=at.opentelemetry.proto.resource.v1.Resource.decode(g,g.uint32());break}case 2:{j.scopeLogs&&j.scopeLogs.length||(j.scopeLogs=[]),j.scopeLogs.push(at.opentelemetry.proto.logs.v1.ScopeLogs.decode(g,g.uint32()));break}case 3:{j.schemaUrl=g.string();break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.resource!=null&&g.hasOwnProperty("resource")){var p=at.opentelemetry.proto.resource.v1.Resource.verify(g.resource);if(p)return"resource."+p}if(g.scopeLogs!=null&&g.hasOwnProperty("scopeLogs")){if(!Array.isArray(g.scopeLogs))return"scopeLogs: array expected";for(var k=0;k<g.scopeLogs.length;++k){var p=at.opentelemetry.proto.logs.v1.ScopeLogs.verify(g.scopeLogs[k]);if(p)return"scopeLogs."+p}}return g.schemaUrl!=null&&g.hasOwnProperty("schemaUrl")&&!gt.isString(g.schemaUrl)?"schemaUrl: string expected":null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.logs.v1.ResourceLogs)return g;var p=new at.opentelemetry.proto.logs.v1.ResourceLogs;if(g.resource!=null){if(typeof g.resource!="object")throw TypeError(".opentelemetry.proto.logs.v1.ResourceLogs.resource: object expected");p.resource=at.opentelemetry.proto.resource.v1.Resource.fromObject(g.resource)}if(g.scopeLogs){if(!Array.isArray(g.scopeLogs))throw TypeError(".opentelemetry.proto.logs.v1.ResourceLogs.scopeLogs: array expected");p.scopeLogs=[];for(var k=0;k<g.scopeLogs.length;++k){if(typeof g.scopeLogs[k]!="object")throw TypeError(".opentelemetry.proto.logs.v1.ResourceLogs.scopeLogs: object expected");p.scopeLogs[k]=at.opentelemetry.proto.logs.v1.ScopeLogs.fromObject(g.scopeLogs[k])}}return g.schemaUrl!=null&&(p.schemaUrl=String(g.schemaUrl)),p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.scopeLogs=[]),p.defaults&&(k.resource=null,k.schemaUrl=""),g.resource!=null&&g.hasOwnProperty("resource")&&(k.resource=at.opentelemetry.proto.resource.v1.Resource.toObject(g.resource,p)),g.scopeLogs&&g.scopeLogs.length){k.scopeLogs=[];for(var j=0;j<g.scopeLogs.length;++j)k.scopeLogs[j]=at.opentelemetry.proto.logs.v1.ScopeLogs.toObject(g.scopeLogs[j],p)}return g.schemaUrl!=null&&g.hasOwnProperty("schemaUrl")&&(k.schemaUrl=g.schemaUrl),k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.logs.v1.ResourceLogs"},b}(),y.ScopeLogs=function(){function b(A){if(this.logRecords=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.scope=null,b.prototype.logRecords=gt.emptyArray,b.prototype.schemaUrl=null,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.scope!=null&&Object.hasOwnProperty.call(g,"scope")&&at.opentelemetry.proto.common.v1.InstrumentationScope.encode(g.scope,p.uint32(10).fork()).ldelim(),g.logRecords!=null&&g.logRecords.length)for(var k=0;k<g.logRecords.length;++k)at.opentelemetry.proto.logs.v1.LogRecord.encode(g.logRecords[k],p.uint32(18).fork()).ldelim();return g.schemaUrl!=null&&Object.hasOwnProperty.call(g,"schemaUrl")&&p.uint32(26).string(g.schemaUrl),p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.logs.v1.ScopeLogs;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.scope=at.opentelemetry.proto.common.v1.InstrumentationScope.decode(g,g.uint32());break}case 2:{j.logRecords&&j.logRecords.length||(j.logRecords=[]),j.logRecords.push(at.opentelemetry.proto.logs.v1.LogRecord.decode(g,g.uint32()));break}case 3:{j.schemaUrl=g.string();break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.scope!=null&&g.hasOwnProperty("scope")){var p=at.opentelemetry.proto.common.v1.InstrumentationScope.verify(g.scope);if(p)return"scope."+p}if(g.logRecords!=null&&g.hasOwnProperty("logRecords")){if(!Array.isArray(g.logRecords))return"logRecords: array expected";for(var k=0;k<g.logRecords.length;++k){var p=at.opentelemetry.proto.logs.v1.LogRecord.verify(g.logRecords[k]);if(p)return"logRecords."+p}}return g.schemaUrl!=null&&g.hasOwnProperty("schemaUrl")&&!gt.isString(g.schemaUrl)?"schemaUrl: string expected":null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.logs.v1.ScopeLogs)return g;var p=new at.opentelemetry.proto.logs.v1.ScopeLogs;if(g.scope!=null){if(typeof g.scope!="object")throw TypeError(".opentelemetry.proto.logs.v1.ScopeLogs.scope: object expected");p.scope=at.opentelemetry.proto.common.v1.InstrumentationScope.fromObject(g.scope)}if(g.logRecords){if(!Array.isArray(g.logRecords))throw TypeError(".opentelemetry.proto.logs.v1.ScopeLogs.logRecords: array expected");p.logRecords=[];for(var k=0;k<g.logRecords.length;++k){if(typeof g.logRecords[k]!="object")throw TypeError(".opentelemetry.proto.logs.v1.ScopeLogs.logRecords: object expected");p.logRecords[k]=at.opentelemetry.proto.logs.v1.LogRecord.fromObject(g.logRecords[k])}}return g.schemaUrl!=null&&(p.schemaUrl=String(g.schemaUrl)),p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.logRecords=[]),p.defaults&&(k.scope=null,k.schemaUrl=""),g.scope!=null&&g.hasOwnProperty("scope")&&(k.scope=at.opentelemetry.proto.common.v1.InstrumentationScope.toObject(g.scope,p)),g.logRecords&&g.logRecords.length){k.logRecords=[];for(var j=0;j<g.logRecords.length;++j)k.logRecords[j]=at.opentelemetry.proto.logs.v1.LogRecord.toObject(g.logRecords[j],p)}return g.schemaUrl!=null&&g.hasOwnProperty("schemaUrl")&&(k.schemaUrl=g.schemaUrl),k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.logs.v1.ScopeLogs"},b}(),y.SeverityNumber=function(){var b={},A=Object.create(b);return A[b[0]="SEVERITY_NUMBER_UNSPECIFIED"]=0,A[b[1]="SEVERITY_NUMBER_TRACE"]=1,A[b[2]="SEVERITY_NUMBER_TRACE2"]=2,A[b[3]="SEVERITY_NUMBER_TRACE3"]=3,A[b[4]="SEVERITY_NUMBER_TRACE4"]=4,A[b[5]="SEVERITY_NUMBER_DEBUG"]=5,A[b[6]="SEVERITY_NUMBER_DEBUG2"]=6,A[b[7]="SEVERITY_NUMBER_DEBUG3"]=7,A[b[8]="SEVERITY_NUMBER_DEBUG4"]=8,A[b[9]="SEVERITY_NUMBER_INFO"]=9,A[b[10]="SEVERITY_NUMBER_INFO2"]=10,A[b[11]="SEVERITY_NUMBER_INFO3"]=11,A[b[12]="SEVERITY_NUMBER_INFO4"]=12,A[b[13]="SEVERITY_NUMBER_WARN"]=13,A[b[14]="SEVERITY_NUMBER_WARN2"]=14,A[b[15]="SEVERITY_NUMBER_WARN3"]=15,A[b[16]="SEVERITY_NUMBER_WARN4"]=16,A[b[17]="SEVERITY_NUMBER_ERROR"]=17,A[b[18]="SEVERITY_NUMBER_ERROR2"]=18,A[b[19]="SEVERITY_NUMBER_ERROR3"]=19,A[b[20]="SEVERITY_NUMBER_ERROR4"]=20,A[b[21]="SEVERITY_NUMBER_FATAL"]=21,A[b[22]="SEVERITY_NUMBER_FATAL2"]=22,A[b[23]="SEVERITY_NUMBER_FATAL3"]=23,A[b[24]="SEVERITY_NUMBER_FATAL4"]=24,A}(),y.LogRecordFlags=function(){var b={},A=Object.create(b);return A[b[0]="LOG_RECORD_FLAGS_DO_NOT_USE"]=0,A[b[255]="LOG_RECORD_FLAGS_TRACE_FLAGS_MASK"]=255,A}(),y.LogRecord=function(){function b(A){if(this.attributes=[],A)for(var g=Object.keys(A),p=0;p<g.length;++p)A[g[p]]!=null&&(this[g[p]]=A[g[p]])}return b.prototype.timeUnixNano=null,b.prototype.observedTimeUnixNano=null,b.prototype.severityNumber=null,b.prototype.severityText=null,b.prototype.body=null,b.prototype.attributes=gt.emptyArray,b.prototype.droppedAttributesCount=null,b.prototype.flags=null,b.prototype.traceId=null,b.prototype.spanId=null,b.create=function(g){return new b(g)},b.encode=function(g,p){if(p||(p=gl.create()),g.timeUnixNano!=null&&Object.hasOwnProperty.call(g,"timeUnixNano")&&p.uint32(9).fixed64(g.timeUnixNano),g.severityNumber!=null&&Object.hasOwnProperty.call(g,"severityNumber")&&p.uint32(16).int32(g.severityNumber),g.severityText!=null&&Object.hasOwnProperty.call(g,"severityText")&&p.uint32(26).string(g.severityText),g.body!=null&&Object.hasOwnProperty.call(g,"body")&&at.opentelemetry.proto.common.v1.AnyValue.encode(g.body,p.uint32(42).fork()).ldelim(),g.attributes!=null&&g.attributes.length)for(var k=0;k<g.attributes.length;++k)at.opentelemetry.proto.common.v1.KeyValue.encode(g.attributes[k],p.uint32(50).fork()).ldelim();return g.droppedAttributesCount!=null&&Object.hasOwnProperty.call(g,"droppedAttributesCount")&&p.uint32(56).uint32(g.droppedAttributesCount),g.flags!=null&&Object.hasOwnProperty.call(g,"flags")&&p.uint32(69).fixed32(g.flags),g.traceId!=null&&Object.hasOwnProperty.call(g,"traceId")&&p.uint32(74).bytes(g.traceId),g.spanId!=null&&Object.hasOwnProperty.call(g,"spanId")&&p.uint32(82).bytes(g.spanId),g.observedTimeUnixNano!=null&&Object.hasOwnProperty.call(g,"observedTimeUnixNano")&&p.uint32(89).fixed64(g.observedTimeUnixNano),p},b.encodeDelimited=function(g,p){return this.encode(g,p).ldelim()},b.decode=function(g,p){g instanceof mn||(g=mn.create(g));for(var k=p===void 0?g.len:g.pos+p,j=new at.opentelemetry.proto.logs.v1.LogRecord;g.pos<k;){var se=g.uint32();switch(se>>>3){case 1:{j.timeUnixNano=g.fixed64();break}case 11:{j.observedTimeUnixNano=g.fixed64();break}case 2:{j.severityNumber=g.int32();break}case 3:{j.severityText=g.string();break}case 5:{j.body=at.opentelemetry.proto.common.v1.AnyValue.decode(g,g.uint32());break}case 6:{j.attributes&&j.attributes.length||(j.attributes=[]),j.attributes.push(at.opentelemetry.proto.common.v1.KeyValue.decode(g,g.uint32()));break}case 7:{j.droppedAttributesCount=g.uint32();break}case 8:{j.flags=g.fixed32();break}case 9:{j.traceId=g.bytes();break}case 10:{j.spanId=g.bytes();break}default:g.skipType(se&7);break}}return j},b.decodeDelimited=function(g){return g instanceof mn||(g=new mn(g)),this.decode(g,g.uint32())},b.verify=function(g){if(typeof g!="object"||g===null)return"object expected";if(g.timeUnixNano!=null&&g.hasOwnProperty("timeUnixNano")&&!gt.isInteger(g.timeUnixNano)&&!(g.timeUnixNano&&gt.isInteger(g.timeUnixNano.low)&&gt.isInteger(g.timeUnixNano.high)))return"timeUnixNano: integer|Long expected";if(g.observedTimeUnixNano!=null&&g.hasOwnProperty("observedTimeUnixNano")&&!gt.isInteger(g.observedTimeUnixNano)&&!(g.observedTimeUnixNano&&gt.isInteger(g.observedTimeUnixNano.low)&&gt.isInteger(g.observedTimeUnixNano.high)))return"observedTimeUnixNano: integer|Long expected";if(g.severityNumber!=null&&g.hasOwnProperty("severityNumber"))switch(g.severityNumber){default:return"severityNumber: enum value expected";case 0:case 1:case 2:case 3:case 4:case 5:case 6:case 7:case 8:case 9:case 10:case 11:case 12:case 13:case 14:case 15:case 16:case 17:case 18:case 19:case 20:case 21:case 22:case 23:case 24:break}if(g.severityText!=null&&g.hasOwnProperty("severityText")&&!gt.isString(g.severityText))return"severityText: string expected";if(g.body!=null&&g.hasOwnProperty("body")){var p=at.opentelemetry.proto.common.v1.AnyValue.verify(g.body);if(p)return"body."+p}if(g.attributes!=null&&g.hasOwnProperty("attributes")){if(!Array.isArray(g.attributes))return"attributes: array expected";for(var k=0;k<g.attributes.length;++k){var p=at.opentelemetry.proto.common.v1.KeyValue.verify(g.attributes[k]);if(p)return"attributes."+p}}return g.droppedAttributesCount!=null&&g.hasOwnProperty("droppedAttributesCount")&&!gt.isInteger(g.droppedAttributesCount)?"droppedAttributesCount: integer expected":g.flags!=null&&g.hasOwnProperty("flags")&&!gt.isInteger(g.flags)?"flags: integer expected":g.traceId!=null&&g.hasOwnProperty("traceId")&&!(g.traceId&&typeof g.traceId.length=="number"||gt.isString(g.traceId))?"traceId: buffer expected":g.spanId!=null&&g.hasOwnProperty("spanId")&&!(g.spanId&&typeof g.spanId.length=="number"||gt.isString(g.spanId))?"spanId: buffer expected":null},b.fromObject=function(g){if(g instanceof at.opentelemetry.proto.logs.v1.LogRecord)return g;var p=new at.opentelemetry.proto.logs.v1.LogRecord;switch(g.timeUnixNano!=null&&(gt.Long?(p.timeUnixNano=gt.Long.fromValue(g.timeUnixNano)).unsigned=!1:typeof g.timeUnixNano=="string"?p.timeUnixNano=parseInt(g.timeUnixNano,10):typeof g.timeUnixNano=="number"?p.timeUnixNano=g.timeUnixNano:typeof g.timeUnixNano=="object"&&(p.timeUnixNano=new gt.LongBits(g.timeUnixNano.low>>>0,g.timeUnixNano.high>>>0).toNumber())),g.observedTimeUnixNano!=null&&(gt.Long?(p.observedTimeUnixNano=gt.Long.fromValue(g.observedTimeUnixNano)).unsigned=!1:typeof g.observedTimeUnixNano=="string"?p.observedTimeUnixNano=parseInt(g.observedTimeUnixNano,10):typeof g.observedTimeUnixNano=="number"?p.observedTimeUnixNano=g.observedTimeUnixNano:typeof g.observedTimeUnixNano=="object"&&(p.observedTimeUnixNano=new gt.LongBits(g.observedTimeUnixNano.low>>>0,g.observedTimeUnixNano.high>>>0).toNumber())),g.severityNumber){default:if(typeof g.severityNumber=="number"){p.severityNumber=g.severityNumber;break}break;case"SEVERITY_NUMBER_UNSPECIFIED":case 0:p.severityNumber=0;break;case"SEVERITY_NUMBER_TRACE":case 1:p.severityNumber=1;break;case"SEVERITY_NUMBER_TRACE2":case 2:p.severityNumber=2;break;case"SEVERITY_NUMBER_TRACE3":case 3:p.severityNumber=3;break;case"SEVERITY_NUMBER_TRACE4":case 4:p.severityNumber=4;break;case"SEVERITY_NUMBER_DEBUG":case 5:p.severityNumber=5;break;case"SEVERITY_NUMBER_DEBUG2":case 6:p.severityNumber=6;break;case"SEVERITY_NUMBER_DEBUG3":case 7:p.severityNumber=7;break;case"SEVERITY_NUMBER_DEBUG4":case 8:p.severityNumber=8;break;case"SEVERITY_NUMBER_INFO":case 9:p.severityNumber=9;break;case"SEVERITY_NUMBER_INFO2":case 10:p.severityNumber=10;break;case"SEVERITY_NUMBER_INFO3":case 11:p.severityNumber=11;break;case"SEVERITY_NUMBER_INFO4":case 12:p.severityNumber=12;break;case"SEVERITY_NUMBER_WARN":case 13:p.severityNumber=13;break;case"SEVERITY_NUMBER_WARN2":case 14:p.severityNumber=14;break;case"SEVERITY_NUMBER_WARN3":case 15:p.severityNumber=15;break;case"SEVERITY_NUMBER_WARN4":case 16:p.severityNumber=16;break;case"SEVERITY_NUMBER_ERROR":case 17:p.severityNumber=17;break;case"SEVERITY_NUMBER_ERROR2":case 18:p.severityNumber=18;break;case"SEVERITY_NUMBER_ERROR3":case 19:p.severityNumber=19;break;case"SEVERITY_NUMBER_ERROR4":case 20:p.severityNumber=20;break;case"SEVERITY_NUMBER_FATAL":case 21:p.severityNumber=21;break;case"SEVERITY_NUMBER_FATAL2":case 22:p.severityNumber=22;break;case"SEVERITY_NUMBER_FATAL3":case 23:p.severityNumber=23;break;case"SEVERITY_NUMBER_FATAL4":case 24:p.severityNumber=24;break}if(g.severityText!=null&&(p.severityText=String(g.severityText)),g.body!=null){if(typeof g.body!="object")throw TypeError(".opentelemetry.proto.logs.v1.LogRecord.body: object expected");p.body=at.opentelemetry.proto.common.v1.AnyValue.fromObject(g.body)}if(g.attributes){if(!Array.isArray(g.attributes))throw TypeError(".opentelemetry.proto.logs.v1.LogRecord.attributes: array expected");p.attributes=[];for(var k=0;k<g.attributes.length;++k){if(typeof g.attributes[k]!="object")throw TypeError(".opentelemetry.proto.logs.v1.LogRecord.attributes: object expected");p.attributes[k]=at.opentelemetry.proto.common.v1.KeyValue.fromObject(g.attributes[k])}}return g.droppedAttributesCount!=null&&(p.droppedAttributesCount=g.droppedAttributesCount>>>0),g.flags!=null&&(p.flags=g.flags>>>0),g.traceId!=null&&(typeof g.traceId=="string"?gt.base64.decode(g.traceId,p.traceId=gt.newBuffer(gt.base64.length(g.traceId)),0):g.traceId.length>=0&&(p.traceId=g.traceId)),g.spanId!=null&&(typeof g.spanId=="string"?gt.base64.decode(g.spanId,p.spanId=gt.newBuffer(gt.base64.length(g.spanId)),0):g.spanId.length>=0&&(p.spanId=g.spanId)),p},b.toObject=function(g,p){p||(p={});var k={};if((p.arrays||p.defaults)&&(k.attributes=[]),p.defaults){if(gt.Long){var j=new gt.Long(0,0,!1);k.timeUnixNano=p.longs===String?j.toString():p.longs===Number?j.toNumber():j}else k.timeUnixNano=p.longs===String?"0":0;if(k.severityNumber=p.enums===String?"SEVERITY_NUMBER_UNSPECIFIED":0,k.severityText="",k.body=null,k.droppedAttributesCount=0,k.flags=0,p.bytes===String?k.traceId="":(k.traceId=[],p.bytes!==Array&&(k.traceId=gt.newBuffer(k.traceId))),p.bytes===String?k.spanId="":(k.spanId=[],p.bytes!==Array&&(k.spanId=gt.newBuffer(k.spanId))),gt.Long){var j=new gt.Long(0,0,!1);k.observedTimeUnixNano=p.longs===String?j.toString():p.longs===Number?j.toNumber():j}else k.observedTimeUnixNano=p.longs===String?"0":0}if(g.timeUnixNano!=null&&g.hasOwnProperty("timeUnixNano")&&(typeof g.timeUnixNano=="number"?k.timeUnixNano=p.longs===String?String(g.timeUnixNano):g.timeUnixNano:k.timeUnixNano=p.longs===String?gt.Long.prototype.toString.call(g.timeUnixNano):p.longs===Number?new gt.LongBits(g.timeUnixNano.low>>>0,g.timeUnixNano.high>>>0).toNumber():g.timeUnixNano),g.severityNumber!=null&&g.hasOwnProperty("severityNumber")&&(k.severityNumber=p.enums===String?at.opentelemetry.proto.logs.v1.SeverityNumber[g.severityNumber]===void 0?g.severityNumber:at.opentelemetry.proto.logs.v1.SeverityNumber[g.severityNumber]:g.severityNumber),g.severityText!=null&&g.hasOwnProperty("severityText")&&(k.severityText=g.severityText),g.body!=null&&g.hasOwnProperty("body")&&(k.body=at.opentelemetry.proto.common.v1.AnyValue.toObject(g.body,p)),g.attributes&&g.attributes.length){k.attributes=[];for(var se=0;se<g.attributes.length;++se)k.attributes[se]=at.opentelemetry.proto.common.v1.KeyValue.toObject(g.attributes[se],p)}return g.droppedAttributesCount!=null&&g.hasOwnProperty("droppedAttributesCount")&&(k.droppedAttributesCount=g.droppedAttributesCount),g.flags!=null&&g.hasOwnProperty("flags")&&(k.flags=g.flags),g.traceId!=null&&g.hasOwnProperty("traceId")&&(k.traceId=p.bytes===String?gt.base64.encode(g.traceId,0,g.traceId.length):p.bytes===Array?Array.prototype.slice.call(g.traceId):g.traceId),g.spanId!=null&&g.hasOwnProperty("spanId")&&(k.spanId=p.bytes===String?gt.base64.encode(g.spanId,0,g.spanId.length):p.bytes===Array?Array.prototype.slice.call(g.spanId):g.spanId),g.observedTimeUnixNano!=null&&g.hasOwnProperty("observedTimeUnixNano")&&(typeof g.observedTimeUnixNano=="number"?k.observedTimeUnixNano=p.longs===String?String(g.observedTimeUnixNano):g.observedTimeUnixNano:k.observedTimeUnixNano=p.longs===String?gt.Long.prototype.toString.call(g.observedTimeUnixNano):p.longs===Number?new gt.LongBits(g.observedTimeUnixNano.low>>>0,g.observedTimeUnixNano.high>>>0).toNumber():g.observedTimeUnixNano),k},b.prototype.toJSON=function(){return this.constructor.toObject(this,Zo.util.toJSONOptions)},b.getTypeUrl=function(g){return g===void 0&&(g="type.googleapis.com"),g+"/opentelemetry.proto.logs.v1.LogRecord"},b}(),y}(),f}(),c}(),l}();Aut.exports=at});var Put=xt(xw=>{"use strict";Object.defineProperty(xw,"__esModule",{value:!0});xw.ProtobufTraceSerializer=xw.ProtobufMetricsSerializer=xw.ProtobufLogsSerializer=void 0;var nF=kut(),Ecr=lae(),xcr=fae(),Ccr=pae(),Acr=nF.opentelemetry.proto.collector.logs.v1.ExportLogsServiceResponse,kcr=nF.opentelemetry.proto.collector.logs.v1.ExportLogsServiceRequest,Pcr=nF.opentelemetry.proto.collector.metrics.v1.ExportMetricsServiceResponse,Ncr=nF.opentelemetry.proto.collector.metrics.v1.ExportMetricsServiceRequest,Dcr=nF.opentelemetry.proto.collector.trace.v1.ExportTraceServiceResponse,wcr=nF.opentelemetry.proto.collector.trace.v1.ExportTraceServiceRequest;xw.ProtobufLogsSerializer={serializeRequest:l=>{let c=(0,Ccr.createExportLogsServiceRequest)(l);return kcr.encode(c).finish()},deserializeResponse:l=>Acr.decode(l)};xw.ProtobufMetricsSerializer={serializeRequest:l=>{let c=(0,xcr.createExportMetricsServiceRequest)(l);return Ncr.encode(c).finish()},deserializeResponse:l=>Pcr.decode(l)};xw.ProtobufTraceSerializer={serializeRequest:l=>{let c=(0,Ecr.createExportTraceServiceRequest)(l);return wcr.encode(c).finish()},deserializeResponse:l=>Dcr.decode(l)}});var Nut=xt(Cw=>{"use strict";Object.defineProperty(Cw,"__esModule",{value:!0});Cw.JsonLogsSerializer=Cw.JsonMetricsSerializer=Cw.JsonTraceSerializer=void 0;var Icr=lae(),Ocr=fae(),Rcr=pae();Cw.JsonTraceSerializer={serializeRequest:l=>{let c=(0,Icr.createExportTraceServiceRequest)(l,{useHex:!0,useLongBits:!1});return new TextEncoder().encode(JSON.stringify(c))},deserializeResponse:l=>{let c=new TextDecoder;return JSON.parse(c.decode(l))}};Cw.JsonMetricsSerializer={serializeRequest:l=>{let c=(0,Ocr.createExportMetricsServiceRequest)(l,{useLongBits:!1});return new TextEncoder().encode(JSON.stringify(c))},deserializeResponse:l=>{let c=new TextDecoder;return JSON.parse(c.decode(l))}};Cw.JsonLogsSerializer={serializeRequest:l=>{let c=(0,Rcr.createExportLogsServiceRequest)(l,{useHex:!0,useLongBits:!1});return new TextEncoder().encode(JSON.stringify(c))},deserializeResponse:l=>{let c=new TextDecoder;return JSON.parse(c.decode(l))}}});var Dut=xt(o_=>{"use strict";Object.defineProperty(o_,"__esModule",{value:!0});o_.JsonMetricsSerializer=o_.JsonLogsSerializer=o_.JsonTraceSerializer=o_.ProtobufTraceSerializer=o_.ProtobufMetricsSerializer=o_.ProtobufLogsSerializer=o_.createExportLogsServiceRequest=o_.createExportMetricsServiceRequest=o_.createExportTraceServiceRequest=o_.ESpanKind=o_.hrTimeToNanos=o_.encodeAsString=o_.encodeAsLongBits=o_.getOtlpEncoder=o_.toLongBits=void 0;var Sz=mz();Object.defineProperty(o_,"toLongBits",{enumerable:!0,get:function(){return Sz.toLongBits}});Object.defineProperty(o_,"getOtlpEncoder",{enumerable:!0,get:function(){return Sz.getOtlpEncoder}});Object.defineProperty(o_,"encodeAsLongBits",{enumerable:!0,get:function(){return Sz.encodeAsLongBits}});Object.defineProperty(o_,"encodeAsString",{enumerable:!0,get:function(){return Sz.encodeAsString}});Object.defineProperty(o_,"hrTimeToNanos",{enumerable:!0,get:function(){return Sz.hrTimeToNanos}});var Mcr=vlt();Object.defineProperty(o_,"ESpanKind",{enumerable:!0,get:function(){return Mcr.ESpanKind}});var Lcr=lae();Object.defineProperty(o_,"createExportTraceServiceRequest",{enumerable:!0,get:function(){return Lcr.createExportTraceServiceRequest}});var Fcr=fae();Object.defineProperty(o_,"createExportMetricsServiceRequest",{enumerable:!0,get:function(){return Fcr.createExportMetricsServiceRequest}});var jcr=pae();Object.defineProperty(o_,"createExportLogsServiceRequest",{enumerable:!0,get:function(){return jcr.createExportLogsServiceRequest}});var GNe=Put();Object.defineProperty(o_,"ProtobufLogsSerializer",{enumerable:!0,get:function(){return GNe.ProtobufLogsSerializer}});Object.defineProperty(o_,"ProtobufMetricsSerializer",{enumerable:!0,get:function(){return GNe.ProtobufMetricsSerializer}});Object.defineProperty(o_,"ProtobufTraceSerializer",{enumerable:!0,get:function(){return GNe.ProtobufTraceSerializer}});var YNe=Nut();Object.defineProperty(o_,"JsonTraceSerializer",{enumerable:!0,get:function(){return YNe.JsonTraceSerializer}});Object.defineProperty(o_,"JsonLogsSerializer",{enumerable:!0,get:function(){return YNe.JsonLogsSerializer}});Object.defineProperty(o_,"JsonMetricsSerializer",{enumerable:!0,get:function(){return YNe.JsonMetricsSerializer}})});var wut=xt(yae=>{"use strict";Object.defineProperty(yae,"__esModule",{value:!0});yae.VERSION=void 0;yae.VERSION="0.53.0"});var Out=xt(Sae=>{"use strict";Object.defineProperty(Sae,"__esModule",{value:!0});Sae.OTLPMetricExporter=void 0;var KNe=py(),Bcr=dNe(),vae=PNe(),Ucr=Dut(),Vcr=wut(),Iut="v1/metrics",Jcr=`http://localhost:4318/${Iut}`,qcr={"User-Agent":`OTel-OTLP-Exporter-JavaScript/${Vcr.VERSION}`},XNe=class extends vae.OTLPExporterNodeBase{constructor(c){super(c,Ucr.JsonMetricsSerializer,Object.assign(Object.assign(Object.assign(Object.assign({},KNe.baggageUtils.parseKeyPairsIntoRecord((0,KNe.getEnv)().OTEL_EXPORTER_OTLP_METRICS_HEADERS)),(0,vae.parseHeaders)(c?.headers)),qcr),{"Content-Type":"application/json"}))}getDefaultUrl(c){if(typeof c.url=="string")return c.url;let f=(0,KNe.getEnv)();return f.OTEL_EXPORTER_OTLP_METRICS_ENDPOINT.length>0?(0,vae.appendRootPathToUrlIfNeeded)(f.OTEL_EXPORTER_OTLP_METRICS_ENDPOINT):f.OTEL_EXPORTER_OTLP_ENDPOINT.length>0?(0,vae.appendResourcePathToUrl)(f.OTEL_EXPORTER_OTLP_ENDPOINT,Iut):Jcr}},QNe=class extends Bcr.OTLPMetricExporterBase{constructor(c){super(new XNe(c),c)}};Sae.OTLPMetricExporter=QNe});var Rut=xt(B4=>{"use strict";var zcr=B4&&B4.__createBinding||(Object.create?function(l,c,f,y){y===void 0&&(y=f),Object.defineProperty(l,y,{enumerable:!0,get:function(){return c[f]}})}:function(l,c,f,y){y===void 0&&(y=f),l[y]=c[f]}),Wcr=B4&&B4.__exportStar||function(l,c){for(var f in l)f!=="default"&&!Object.prototype.hasOwnProperty.call(c,f)&&zcr(c,l,f)};Object.defineProperty(B4,"__esModule",{value:!0});Wcr(Out(),B4)});var Mut=xt(U4=>{"use strict";var $cr=U4&&U4.__createBinding||(Object.create?function(l,c,f,y){y===void 0&&(y=f),Object.defineProperty(l,y,{enumerable:!0,get:function(){return c[f]}})}:function(l,c,f,y){y===void 0&&(y=f),l[y]=c[f]}),Hcr=U4&&U4.__exportStar||function(l,c){for(var f in l)f!=="default"&&!Object.prototype.hasOwnProperty.call(c,f)&&$cr(c,l,f)};Object.defineProperty(U4,"__esModule",{value:!0});Hcr(Rut(),U4)});var Lut=xt(_P=>{"use strict";var Gcr=_P&&_P.__createBinding||(Object.create?function(l,c,f,y){y===void 0&&(y=f),Object.defineProperty(l,y,{enumerable:!0,get:function(){return c[f]}})}:function(l,c,f,y){y===void 0&&(y=f),l[y]=c[f]}),ZNe=_P&&_P.__exportStar||function(l,c){for(var f in l)f!=="default"&&!Object.prototype.hasOwnProperty.call(c,f)&&Gcr(c,l,f)};Object.defineProperty(_P,"__esModule",{value:!0});ZNe(Mut(),_P);ZNe(fNe(),_P);ZNe(dNe(),_P)});var Vut=xt(()=>{var Uut;(function(l){(function(c){var f=typeof globalThis=="object"?globalThis:typeof global=="object"?global:typeof self=="object"?self:typeof this=="object"?this:p(),y=b(l);typeof f.Reflect<"u"&&(y=b(f.Reflect,y)),c(y,f),typeof f.Reflect>"u"&&(f.Reflect=l);function b(k,j){return function(se,ze){Object.defineProperty(k,se,{configurable:!0,writable:!0,value:ze}),j&&j(se,ze)}}function A(){try{return Function("return this;")()}catch{}}function g(){try{return(0,eval)("(function() { return this; })()")}catch{}}function p(){return A()||g()}})(function(c,f){var y=Object.prototype.hasOwnProperty,b=typeof Symbol=="function",A=b&&typeof Symbol.toPrimitive<"u"?Symbol.toPrimitive:"@@toPrimitive",g=b&&typeof Symbol.iterator<"u"?Symbol.iterator:"@@iterator",p=typeof Object.create=="function",k={__proto__:[]}instanceof Array,j=!p&&!k,se={create:p?function(){return Vp(Object.create(null))}:k?function(){return Vp({__proto__:null})}:function(){return Vp({})},has:j?function(cn,Un){return y.call(cn,Un)}:function(cn,Un){return Un in cn},get:j?function(cn,Un){return y.call(cn,Un)?cn[Un]:void 0}:function(cn,Un){return cn[Un]}},ze=Object.getPrototypeOf(Function),ve=typeof Map=="function"&&typeof Map.prototype.entries=="function"?Map:l0(),lr=typeof Set=="function"&&typeof Set.prototype.entries=="function"?Set:jC(),Br=typeof WeakMap=="function"?WeakMap:NW(),wt=b?Symbol.for("@reflect-metadata:registry"):void 0,kt=Fce(),Fi=I1(kt);function yi(cn,Un,Bt,vs){if(Fs(Bt)){if(!l3(cn))throw new TypeError;if(!Pg(Un))throw new TypeError;return Jw(cn,Un)}else{if(!l3(cn))throw new TypeError;if(!M_(Un))throw new TypeError;if(!M_(vs)&&!Fs(vs)&&!ef(vs))throw new TypeError;return ef(vs)&&(vs=void 0),Bt=Up(Bt),Es(cn,Un,Bt,vs)}}c("decorate",yi);function qo(cn,Un){function Bt(vs,Eo){if(!M_(vs))throw new TypeError;if(!Fs(Eo)&&!XF(Eo))throw new TypeError;zw(cn,Un,vs,Eo)}return Bt}c("metadata",qo);function Xl(cn,Un,Bt,vs){if(!M_(Bt))throw new TypeError;return Fs(vs)||(vs=Up(vs)),zw(cn,Un,Bt,vs)}c("defineMetadata",Xl);function ho(cn,Un,Bt){if(!M_(Un))throw new TypeError;return Fs(Bt)||(Bt=Up(Bt)),UT(cn,Un,Bt)}c("hasMetadata",ho);function bf(cn,Un,Bt){if(!M_(Un))throw new TypeError;return Fs(Bt)||(Bt=Up(Bt)),qw(cn,Un,Bt)}c("hasOwnMetadata",bf);function wi(cn,Un,Bt){if(!M_(Un))throw new TypeError;return Fs(Bt)||(Bt=Up(Bt)),vy(cn,Un,Bt)}c("getMetadata",wi);function Ln(cn,Un,Bt){if(!M_(Un))throw new TypeError;return Fs(Bt)||(Bt=Up(Bt)),Zn(cn,Un,Bt)}c("getOwnMetadata",Ln);function xm(cn,Un){if(!M_(cn))throw new TypeError;return Fs(Un)||(Un=Up(Un)),Ym(cn,Un)}c("getMetadataKeys",xm);function Bo(cn,Un){if(!M_(cn))throw new TypeError;return Fs(Un)||(Un=Up(Un)),Cr(cn,Un)}c("getOwnMetadataKeys",Bo);function pv(cn,Un,Bt){if(!M_(Un))throw new TypeError;if(Fs(Bt)||(Bt=Up(Bt)),!M_(Un))throw new TypeError;Fs(Bt)||(Bt=Up(Bt));var vs=Rx(Un,Bt,!1);return Fs(vs)?!1:vs.OrdinaryDeleteMetadata(cn,Un,Bt)}c("deleteMetadata",pv);function Jw(cn,Un){for(var Bt=cn.length-1;Bt>=0;--Bt){var vs=cn[Bt],Eo=vs(Un);if(!Fs(Eo)&&!ef(Eo)){if(!Pg(Eo))throw new TypeError;Un=Eo}}return Un}function Es(cn,Un,Bt,vs){for(var Eo=cn.length-1;Eo>=0;--Eo){var wn=cn[Eo],ol=wn(Un,Bt,vs);if(!Fs(ol)&&!ef(ol)){if(!M_(ol))throw new TypeError;vs=ol}}return vs}function UT(cn,Un,Bt){var vs=qw(cn,Un,Bt);if(vs)return!0;var Eo=Ox(Un);return ef(Eo)?!1:UT(cn,Eo,Bt)}function qw(cn,Un,Bt){var vs=Rx(Un,Bt,!1);return Fs(vs)?!1:Ww(vs.OrdinaryHasOwnMetadata(cn,Un,Bt))}function vy(cn,Un,Bt){var vs=qw(cn,Un,Bt);if(vs)return Zn(cn,Un,Bt);var Eo=Ox(Un);if(!ef(Eo))return vy(cn,Eo,Bt)}function Zn(cn,Un,Bt){var vs=Rx(Un,Bt,!1);if(!Fs(vs))return vs.OrdinaryGetOwnMetadata(cn,Un,Bt)}function zw(cn,Un,Bt,vs){var Eo=Rx(Bt,vs,!0);Eo.OrdinaryDefineOwnMetadata(cn,Un,Bt,vs)}function Ym(cn,Un){var Bt=Cr(cn,Un),vs=Ox(cn);if(vs===null)return Bt;var Eo=Ym(vs,Un);if(Eo.length<=0)return Bt;if(Bt.length<=0)return Eo;for(var wn=new lr,ol=[],$o=0,na=Bt;$o<na.length;$o++){var pa=na[$o],Ra=wn.has(pa);Ra||(wn.add(pa),ol.push(pa))}for(var Qs=0,hl=Eo;Qs<hl.length;Qs++){var pa=hl[Qs],Ra=wn.has(pa);Ra||(wn.add(pa),ol.push(pa))}return ol}function Cr(cn,Un){var Bt=Rx(cn,Un,!1);return Bt?Bt.OrdinaryOwnMetadataKeys(cn,Un):[]}function Ix(cn){if(cn===null)return 1;switch(typeof cn){case"undefined":return 0;case"boolean":return 2;case"string":return 3;case"symbol":return 4;case"number":return 5;case"object":return cn===null?1:6;default:return 6}}function Fs(cn){return cn===void 0}function ef(cn){return cn===null}function va(cn){return typeof cn=="symbol"}function M_(cn){return typeof cn=="object"?cn!==null:typeof cn=="function"}function c3(cn,Un){switch(Ix(cn)){case 0:return cn;case 1:return cn;case 2:return cn;case 3:return cn;case 4:return cn;case 5:return cn}var Bt=Un===3?"string":Un===5?"number":"default",vs=u3(cn,A);if(vs!==void 0){var Eo=vs.call(cn,Bt);if(M_(Eo))throw new TypeError;return Eo}return KF(cn,Bt==="default"?"number":Bt)}function KF(cn,Un){if(Un==="string"){var Bt=cn.toString;if(dv(Bt)){var vs=Bt.call(cn);if(!M_(vs))return vs}var Eo=cn.valueOf;if(dv(Eo)){var vs=Eo.call(cn);if(!M_(vs))return vs}}else{var Eo=cn.valueOf;if(dv(Eo)){var vs=Eo.call(cn);if(!M_(vs))return vs}var wn=cn.toString;if(dv(wn)){var vs=wn.call(cn);if(!M_(vs))return vs}}throw new TypeError}function Ww(cn){return!!cn}function Gi(cn){return""+cn}function Up(cn){var Un=c3(cn,3);return va(Un)?Un:Gi(Un)}function l3(cn){return Array.isArray?Array.isArray(cn):cn instanceof Object?cn instanceof Array:Object.prototype.toString.call(cn)==="[object Array]"}function dv(cn){return typeof cn=="function"}function Pg(cn){return typeof cn=="function"}function XF(cn){switch(Ix(cn)){case 3:return!0;case 4:return!0;default:return!1}}function EP(cn,Un){return cn===Un||cn!==cn&&Un!==Un}function u3(cn,Un){var Bt=cn[Un];if(Bt!=null){if(!dv(Bt))throw new TypeError;return Bt}}function Pt(cn){var Un=u3(cn,g);if(!dv(Un))throw new TypeError;var Bt=Un.call(cn);if(!M_(Bt))throw new TypeError;return Bt}function $w(cn){return cn.value}function ps(cn){var Un=cn.next();return Un.done?!1:Un}function PW(cn){var Un=cn.return;Un&&Un.call(cn)}function Ox(cn){var Un=Object.getPrototypeOf(cn);if(typeof cn!="function"||cn===ze||Un!==ze)return Un;var Bt=cn.prototype,vs=Bt&&Object.getPrototypeOf(Bt);if(vs==null||vs===Object.prototype)return Un;var Eo=vs.constructor;return typeof Eo!="function"||Eo===cn?Un:Eo}function Lce(){var cn;!Fs(wt)&&typeof f.Reflect<"u"&&!(wt in f.Reflect)&&typeof f.Reflect.defineMetadata=="function"&&(cn=jce(f.Reflect));var Un,Bt,vs,Eo=new Br,wn={registerProvider:ol,getProvider:na,setProvider:Ra};return wn;function ol(Qs){if(!Object.isExtensible(wn))throw new Error("Cannot add provider to a frozen registry.");switch(!0){case cn===Qs:break;case Fs(Un):Un=Qs;break;case Un===Qs:break;case Fs(Bt):Bt=Qs;break;case Bt===Qs:break;default:vs===void 0&&(vs=new lr),vs.add(Qs);break}}function $o(Qs,hl){if(!Fs(Un)){if(Un.isProviderFor(Qs,hl))return Un;if(!Fs(Bt)){if(Bt.isProviderFor(Qs,hl))return Un;if(!Fs(vs))for(var Dl=Pt(vs);;){var xo=ps(Dl);if(!xo)return;var Nh=$w(xo);if(Nh.isProviderFor(Qs,hl))return PW(Dl),Nh}}}if(!Fs(cn)&&cn.isProviderFor(Qs,hl))return cn}function na(Qs,hl){var Dl=Eo.get(Qs),xo;return Fs(Dl)||(xo=Dl.get(hl)),Fs(xo)&&(xo=$o(Qs,hl),Fs(xo)||(Fs(Dl)&&(Dl=new ve,Eo.set(Qs,Dl)),Dl.set(hl,xo))),xo}function pa(Qs){if(Fs(Qs))throw new TypeError;return Un===Qs||Bt===Qs||!Fs(vs)&&vs.has(Qs)}function Ra(Qs,hl,Dl){if(!pa(Dl))throw new Error("Metadata provider not registered.");var xo=na(Qs,hl);if(xo!==Dl){if(!Fs(xo))return!1;var Nh=Eo.get(Qs);Fs(Nh)&&(Nh=new ve,Eo.set(Qs,Nh)),Nh.set(hl,Dl)}return!0}}function Fce(){var cn;return!Fs(wt)&&M_(f.Reflect)&&Object.isExtensible(f.Reflect)&&(cn=f.Reflect[wt]),Fs(cn)&&(cn=Lce()),!Fs(wt)&&M_(f.Reflect)&&Object.isExtensible(f.Reflect)&&Object.defineProperty(f.Reflect,wt,{enumerable:!1,configurable:!1,writable:!1,value:cn}),cn}function I1(cn){var Un=new Br,Bt={isProviderFor:function(pa,Ra){var Qs=Un.get(pa);return Fs(Qs)?!1:Qs.has(Ra)},OrdinaryDefineOwnMetadata:ol,OrdinaryHasOwnMetadata:Eo,OrdinaryGetOwnMetadata:wn,OrdinaryOwnMetadataKeys:$o,OrdinaryDeleteMetadata:na};return kt.registerProvider(Bt),Bt;function vs(pa,Ra,Qs){var hl=Un.get(pa),Dl=!1;if(Fs(hl)){if(!Qs)return;hl=new ve,Un.set(pa,hl),Dl=!0}var xo=hl.get(Ra);if(Fs(xo)){if(!Qs)return;if(xo=new ve,hl.set(Ra,xo),!cn.setProvider(pa,Ra,Bt))throw hl.delete(Ra),Dl&&Un.delete(pa),new Error("Wrong provider for target.")}return xo}function Eo(pa,Ra,Qs){var hl=vs(Ra,Qs,!1);return Fs(hl)?!1:Ww(hl.has(pa))}function wn(pa,Ra,Qs){var hl=vs(Ra,Qs,!1);if(!Fs(hl))return hl.get(pa)}function ol(pa,Ra,Qs,hl){var Dl=vs(Qs,hl,!0);Dl.set(pa,Ra)}function $o(pa,Ra){var Qs=[],hl=vs(pa,Ra,!1);if(Fs(hl))return Qs;for(var Dl=hl.keys(),xo=Pt(Dl),Nh=0;;){var Ma=ps(xo);if(!Ma)return Qs.length=Nh,Qs;var _3=$w(Ma);try{Qs[Nh]=_3}catch(vc){try{PW(xo)}finally{throw vc}}Nh++}}function na(pa,Ra,Qs){var hl=vs(Ra,Qs,!1);if(Fs(hl)||!hl.delete(pa))return!1;if(hl.size===0){var Dl=Un.get(Ra);Fs(Dl)||(Dl.delete(Qs),Dl.size===0&&Un.delete(Dl))}return!0}}function jce(cn){var Un=cn.defineMetadata,Bt=cn.hasOwnMetadata,vs=cn.getOwnMetadata,Eo=cn.getOwnMetadataKeys,wn=cn.deleteMetadata,ol=new Br,$o={isProviderFor:function(na,pa){var Ra=ol.get(na);return Fs(Ra)?Eo(na,pa).length?(Fs(Ra)&&(Ra=new lr,ol.set(na,Ra)),Ra.add(pa),!0):!1:Ra.has(pa)},OrdinaryDefineOwnMetadata:Un,OrdinaryHasOwnMetadata:Bt,OrdinaryGetOwnMetadata:vs,OrdinaryOwnMetadataKeys:Eo,OrdinaryDeleteMetadata:wn};return $o}function Rx(cn,Un,Bt){var vs=kt.getProvider(cn,Un);if(!Fs(vs))return vs;if(Bt){if(kt.setProvider(cn,Un,Fi))return Fi;throw new Error("Illegal state.")}}function l0(){var cn={},Un=[],Bt=function(){function $o(na,pa,Ra){this._index=0,this._keys=na,this._values=pa,this._selector=Ra}return $o.prototype["@@iterator"]=function(){return this},$o.prototype[g]=function(){return this},$o.prototype.next=function(){var na=this._index;if(na>=0&&na<this._keys.length){var pa=this._selector(this._keys[na],this._values[na]);return na+1>=this._keys.length?(this._index=-1,this._keys=Un,this._values=Un):this._index++,{value:pa,done:!1}}return{value:void 0,done:!0}},$o.prototype.throw=function(na){throw this._index>=0&&(this._index=-1,this._keys=Un,this._values=Un),na},$o.prototype.return=function(na){return this._index>=0&&(this._index=-1,this._keys=Un,this._values=Un),{value:na,done:!0}},$o}(),vs=function(){function $o(){this._keys=[],this._values=[],this._cacheKey=cn,this._cacheIndex=-2}return Object.defineProperty($o.prototype,"size",{get:function(){return this._keys.length},enumerable:!0,configurable:!0}),$o.prototype.has=function(na){return this._find(na,!1)>=0},$o.prototype.get=function(na){var pa=this._find(na,!1);return pa>=0?this._values[pa]:void 0},$o.prototype.set=function(na,pa){var Ra=this._find(na,!0);return this._values[Ra]=pa,this},$o.prototype.delete=function(na){var pa=this._find(na,!1);if(pa>=0){for(var Ra=this._keys.length,Qs=pa+1;Qs<Ra;Qs++)this._keys[Qs-1]=this._keys[Qs],this._values[Qs-1]=this._values[Qs];return this._keys.length--,this._values.length--,EP(na,this._cacheKey)&&(this._cacheKey=cn,this._cacheIndex=-2),!0}return!1},$o.prototype.clear=function(){this._keys.length=0,this._values.length=0,this._cacheKey=cn,this._cacheIndex=-2},$o.prototype.keys=function(){return new Bt(this._keys,this._values,Eo)},$o.prototype.values=function(){return new Bt(this._keys,this._values,wn)},$o.prototype.entries=function(){return new Bt(this._keys,this._values,ol)},$o.prototype["@@iterator"]=function(){return this.entries()},$o.prototype[g]=function(){return this.entries()},$o.prototype._find=function(na,pa){if(!EP(this._cacheKey,na)){this._cacheIndex=-1;for(var Ra=0;Ra<this._keys.length;Ra++)if(EP(this._keys[Ra],na)){this._cacheIndex=Ra;break}}return this._cacheIndex<0&&pa&&(this._cacheIndex=this._keys.length,this._keys.push(na),this._values.push(void 0)),this._cacheIndex},$o}();return vs;function Eo($o,na){return $o}function wn($o,na){return na}function ol($o,na){return[$o,na]}}function jC(){var cn=function(){function Un(){this._map=new ve}return Object.defineProperty(Un.prototype,"size",{get:function(){return this._map.size},enumerable:!0,configurable:!0}),Un.prototype.has=function(Bt){return this._map.has(Bt)},Un.prototype.add=function(Bt){return this._map.set(Bt,Bt),this},Un.prototype.delete=function(Bt){return this._map.delete(Bt)},Un.prototype.clear=function(){this._map.clear()},Un.prototype.keys=function(){return this._map.keys()},Un.prototype.values=function(){return this._map.keys()},Un.prototype.entries=function(){return this._map.entries()},Un.prototype["@@iterator"]=function(){return this.keys()},Un.prototype[g]=function(){return this.keys()},Un}();return cn}function NW(){var cn=16,Un=se.create(),Bt=vs();return function(){function na(){this._key=vs()}return na.prototype.has=function(pa){var Ra=Eo(pa,!1);return Ra!==void 0?se.has(Ra,this._key):!1},na.prototype.get=function(pa){var Ra=Eo(pa,!1);return Ra!==void 0?se.get(Ra,this._key):void 0},na.prototype.set=function(pa,Ra){var Qs=Eo(pa,!0);return Qs[this._key]=Ra,this},na.prototype.delete=function(pa){var Ra=Eo(pa,!1);return Ra!==void 0?delete Ra[this._key]:!1},na.prototype.clear=function(){this._key=vs()},na}();function vs(){var na;do na="@@WeakMap@@"+$o();while(se.has(Un,na));return Un[na]=!0,na}function Eo(na,pa){if(!y.call(na,Bt)){if(!pa)return;Object.defineProperty(na,Bt,{value:se.create()})}return na[Bt]}function wn(na,pa){for(var Ra=0;Ra<pa;++Ra)na[Ra]=Math.random()*255|0;return na}function ol(na){return typeof Uint8Array=="function"?typeof crypto<"u"?crypto.getRandomValues(new Uint8Array(na)):typeof msCrypto<"u"?msCrypto.getRandomValues(new Uint8Array(na)):wn(new Uint8Array(na),na):wn(new Array(na),na)}function $o(){var na=ol(cn);na[6]=na[6]&79|64,na[8]=na[8]&191|128;for(var pa="",Ra=0;Ra<cn;++Ra){var Qs=na[Ra];(Ra===4||Ra===6||Ra===8)&&(pa+="-"),Qs<16&&(pa+="0"),pa+=Qs.toString(16).toLowerCase()}return pa}}function Vp(cn){return cn.__=void 0,delete cn.__,cn}})})(Uut||(Uut={}))});var Mae=xt((Hkr,Hut)=>{var ilr=Array.isArray;Hut.exports=ilr});var Yut=xt((Gkr,Gut)=>{var slr=typeof global=="object"&&global&&global.Object===Object&&global;Gut.exports=slr});var Lae=xt((Ykr,Kut)=>{var alr=Yut(),olr=typeof self=="object"&&self&&self.Object===Object&&self,clr=alr||olr||Function("return this")();Kut.exports=clr});var Fae=xt((Kkr,Xut)=>{var llr=Lae(),ulr=llr.Symbol;Xut.exports=ulr});var t_t=xt((Xkr,e_t)=>{var Qut=Fae(),Zut=Object.prototype,_lr=Zut.hasOwnProperty,flr=Zut.toString,xz=Qut?Qut.toStringTag:void 0;function plr(l){var c=_lr.call(l,xz),f=l[xz];try{l[xz]=void 0;var y=!0}catch{}var b=flr.call(l);return y&&(c?l[xz]=f:delete l[xz]),b}e_t.exports=plr});var n_t=xt((Qkr,r_t)=>{var dlr=Object.prototype,mlr=dlr.toString;function glr(l){return mlr.call(l)}r_t.exports=glr});var iDe=xt((Zkr,a_t)=>{var i_t=Fae(),hlr=t_t(),ylr=n_t(),vlr="[object Null]",Slr="[object Undefined]",s_t=i_t?i_t.toStringTag:void 0;function blr(l){return l==null?l===void 0?Slr:vlr:s_t&&s_t in Object(l)?hlr(l):ylr(l)}a_t.exports=blr});var c_t=xt((ePr,o_t)=>{function Tlr(l){return l!=null&&typeof l=="object"}o_t.exports=Tlr});var jae=xt((tPr,l_t)=>{var Elr=iDe(),xlr=c_t(),Clr="[object Symbol]";function Alr(l){return typeof l=="symbol"||xlr(l)&&Elr(l)==Clr}l_t.exports=Alr});var __t=xt((rPr,u_t)=>{var klr=Mae(),Plr=jae(),Nlr=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,Dlr=/^\w*$/;function wlr(l,c){if(klr(l))return!1;var f=typeof l;return f=="number"||f=="symbol"||f=="boolean"||l==null||Plr(l)?!0:Dlr.test(l)||!Nlr.test(l)||c!=null&&l in Object(c)}u_t.exports=wlr});var sDe=xt((nPr,f_t)=>{function Ilr(l){var c=typeof l;return l!=null&&(c=="object"||c=="function")}f_t.exports=Ilr});var d_t=xt((iPr,p_t)=>{var Olr=iDe(),Rlr=sDe(),Mlr="[object AsyncFunction]",Llr="[object Function]",Flr="[object GeneratorFunction]",jlr="[object Proxy]";function Blr(l){if(!Rlr(l))return!1;var c=Olr(l);return c==Llr||c==Flr||c==Mlr||c==jlr}p_t.exports=Blr});var g_t=xt((sPr,m_t)=>{var Ulr=Lae(),Vlr=Ulr["__core-js_shared__"];m_t.exports=Vlr});var v_t=xt((aPr,y_t)=>{var aDe=g_t(),h_t=function(){var l=/[^.]+$/.exec(aDe&&aDe.keys&&aDe.keys.IE_PROTO||"");return l?"Symbol(src)_1."+l:""}();function Jlr(l){return!!h_t&&h_t in l}y_t.exports=Jlr});var b_t=xt((oPr,S_t)=>{var qlr=Function.prototype,zlr=qlr.toString;function Wlr(l){if(l!=null){try{return zlr.call(l)}catch{}try{return l+""}catch{}}return""}S_t.exports=Wlr});var E_t=xt((cPr,T_t)=>{var $lr=d_t(),Hlr=v_t(),Glr=sDe(),Ylr=b_t(),Klr=/[\\^$.*+?()[\]{}|]/g,Xlr=/^\[object .+?Constructor\]$/,Qlr=Function.prototype,Zlr=Object.prototype,eur=Qlr.toString,tur=Zlr.hasOwnProperty,rur=RegExp("^"+eur.call(tur).replace(Klr,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");function nur(l){if(!Glr(l)||Hlr(l))return!1;var c=$lr(l)?rur:Xlr;return c.test(Ylr(l))}T_t.exports=nur});var C_t=xt((lPr,x_t)=>{function iur(l,c){return l?.[c]}x_t.exports=iur});var oDe=xt((uPr,A_t)=>{var sur=E_t(),aur=C_t();function our(l,c){var f=aur(l,c);return sur(f)?f:void 0}A_t.exports=our});var Cz=xt((_Pr,k_t)=>{var cur=oDe(),lur=cur(Object,"create");k_t.exports=lur});var D_t=xt((fPr,N_t)=>{var P_t=Cz();function uur(){this.__data__=P_t?P_t(null):{},this.size=0}N_t.exports=uur});var I_t=xt((pPr,w_t)=>{function _ur(l){var c=this.has(l)&&delete this.__data__[l];return this.size-=c?1:0,c}w_t.exports=_ur});var R_t=xt((dPr,O_t)=>{var fur=Cz(),pur="__lodash_hash_undefined__",dur=Object.prototype,mur=dur.hasOwnProperty;function gur(l){var c=this.__data__;if(fur){var f=c[l];return f===pur?void 0:f}return mur.call(c,l)?c[l]:void 0}O_t.exports=gur});var L_t=xt((mPr,M_t)=>{var hur=Cz(),yur=Object.prototype,vur=yur.hasOwnProperty;function Sur(l){var c=this.__data__;return hur?c[l]!==void 0:vur.call(c,l)}M_t.exports=Sur});var j_t=xt((gPr,F_t)=>{var bur=Cz(),Tur="__lodash_hash_undefined__";function Eur(l,c){var f=this.__data__;return this.size+=this.has(l)?0:1,f[l]=bur&&c===void 0?Tur:c,this}F_t.exports=Eur});var U_t=xt((hPr,B_t)=>{var xur=D_t(),Cur=I_t(),Aur=R_t(),kur=L_t(),Pur=j_t();function oF(l){var c=-1,f=l==null?0:l.length;for(this.clear();++c<f;){var y=l[c];this.set(y[0],y[1])}}oF.prototype.clear=xur;oF.prototype.delete=Cur;oF.prototype.get=Aur;oF.prototype.has=kur;oF.prototype.set=Pur;B_t.exports=oF});var J_t=xt((yPr,V_t)=>{function Nur(){this.__data__=[],this.size=0}V_t.exports=Nur});var z_t=xt((vPr,q_t)=>{function Dur(l,c){return l===c||l!==l&&c!==c}q_t.exports=Dur});var Az=xt((SPr,W_t)=>{var wur=z_t();function Iur(l,c){for(var f=l.length;f--;)if(wur(l[f][0],c))return f;return-1}W_t.exports=Iur});var H_t=xt((bPr,$_t)=>{var Our=Az(),Rur=Array.prototype,Mur=Rur.splice;function Lur(l){var c=this.__data__,f=Our(c,l);if(f<0)return!1;var y=c.length-1;return f==y?c.pop():Mur.call(c,f,1),--this.size,!0}$_t.exports=Lur});var Y_t=xt((TPr,G_t)=>{var Fur=Az();function jur(l){var c=this.__data__,f=Fur(c,l);return f<0?void 0:c[f][1]}G_t.exports=jur});var X_t=xt((EPr,K_t)=>{var Bur=Az();function Uur(l){return Bur(this.__data__,l)>-1}K_t.exports=Uur});var Z_t=xt((xPr,Q_t)=>{var Vur=Az();function Jur(l,c){var f=this.__data__,y=Vur(f,l);return y<0?(++this.size,f.push([l,c])):f[y][1]=c,this}Q_t.exports=Jur});var tft=xt((CPr,eft)=>{var qur=J_t(),zur=H_t(),Wur=Y_t(),$ur=X_t(),Hur=Z_t();function cF(l){var c=-1,f=l==null?0:l.length;for(this.clear();++c<f;){var y=l[c];this.set(y[0],y[1])}}cF.prototype.clear=qur;cF.prototype.delete=zur;cF.prototype.get=Wur;cF.prototype.has=$ur;cF.prototype.set=Hur;eft.exports=cF});var nft=xt((APr,rft)=>{var Gur=oDe(),Yur=Lae(),Kur=Gur(Yur,"Map");rft.exports=Kur});var aft=xt((kPr,sft)=>{var ift=U_t(),Xur=tft(),Qur=nft();function Zur(){this.size=0,this.__data__={hash:new ift,map:new(Qur||Xur),string:new ift}}sft.exports=Zur});var cft=xt((PPr,oft)=>{function e_r(l){var c=typeof l;return c=="string"||c=="number"||c=="symbol"||c=="boolean"?l!=="__proto__":l===null}oft.exports=e_r});var kz=xt((NPr,lft)=>{var t_r=cft();function r_r(l,c){var f=l.__data__;return t_r(c)?f[typeof c=="string"?"string":"hash"]:f.map}lft.exports=r_r});var _ft=xt((DPr,uft)=>{var n_r=kz();function i_r(l){var c=n_r(this,l).delete(l);return this.size-=c?1:0,c}uft.exports=i_r});var pft=xt((wPr,fft)=>{var s_r=kz();function a_r(l){return s_r(this,l).get(l)}fft.exports=a_r});var mft=xt((IPr,dft)=>{var o_r=kz();function c_r(l){return o_r(this,l).has(l)}dft.exports=c_r});var hft=xt((OPr,gft)=>{var l_r=kz();function u_r(l,c){var f=l_r(this,l),y=f.size;return f.set(l,c),this.size+=f.size==y?0:1,this}gft.exports=u_r});var vft=xt((RPr,yft)=>{var __r=aft(),f_r=_ft(),p_r=pft(),d_r=mft(),m_r=hft();function lF(l){var c=-1,f=l==null?0:l.length;for(this.clear();++c<f;){var y=l[c];this.set(y[0],y[1])}}lF.prototype.clear=__r;lF.prototype.delete=f_r;lF.prototype.get=p_r;lF.prototype.has=d_r;lF.prototype.set=m_r;yft.exports=lF});var Tft=xt((MPr,bft)=>{var Sft=vft(),g_r="Expected a function";function cDe(l,c){if(typeof l!="function"||c!=null&&typeof c!="function")throw new TypeError(g_r);var f=function(){var y=arguments,b=c?c.apply(this,y):y[0],A=f.cache;if(A.has(b))return A.get(b);var g=l.apply(this,y);return f.cache=A.set(b,g)||A,g};return f.cache=new(cDe.Cache||Sft),f}cDe.Cache=Sft;bft.exports=cDe});var xft=xt((LPr,Eft)=>{var h_r=Tft(),y_r=500;function v_r(l){var c=h_r(l,function(y){return f.size===y_r&&f.clear(),y}),f=c.cache;return c}Eft.exports=v_r});var Aft=xt((FPr,Cft)=>{var S_r=xft(),b_r=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,T_r=/\\(\\)?/g,E_r=S_r(function(l){var c=[];return l.charCodeAt(0)===46&&c.push(""),l.replace(b_r,function(f,y,b,A){c.push(b?A.replace(T_r,"$1"):y||f)}),c});Cft.exports=E_r});var Pft=xt((jPr,kft)=>{function x_r(l,c){for(var f=-1,y=l==null?0:l.length,b=Array(y);++f<y;)b[f]=c(l[f],f,l);return b}kft.exports=x_r});var Rft=xt((BPr,Oft)=>{var Nft=Fae(),C_r=Pft(),A_r=Mae(),k_r=jae(),P_r=1/0,Dft=Nft?Nft.prototype:void 0,wft=Dft?Dft.toString:void 0;function Ift(l){if(typeof l=="string")return l;if(A_r(l))return C_r(l,Ift)+"";if(k_r(l))return wft?wft.call(l):"";var c=l+"";return c=="0"&&1/l==-P_r?"-0":c}Oft.exports=Ift});var Lft=xt((UPr,Mft)=>{var N_r=Rft();function D_r(l){return l==null?"":N_r(l)}Mft.exports=D_r});var jft=xt((VPr,Fft)=>{var w_r=Mae(),I_r=__t(),O_r=Aft(),R_r=Lft();function M_r(l,c){return w_r(l)?l:I_r(l,c)?[l]:O_r(R_r(l))}Fft.exports=M_r});var Uft=xt((JPr,Bft)=>{var L_r=jae(),F_r=1/0;function j_r(l){if(typeof l=="string"||L_r(l))return l;var c=l+"";return c=="0"&&1/l==-F_r?"-0":c}Bft.exports=j_r});var Jft=xt((qPr,Vft)=>{var B_r=jft(),U_r=Uft();function V_r(l,c){c=B_r(c,l);for(var f=0,y=c.length;l!=null&&f<y;)l=l[U_r(c[f++])];return f&&f==y?l:void 0}Vft.exports=V_r});var Pz=xt((zPr,qft)=>{var J_r=Jft();function q_r(l,c,f){var y=l==null?void 0:J_r(l,c);return y===void 0?f:y}qft.exports=q_r});var Wft=xt(lDe=>{var zft="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".split("");lDe.encode=function(l){if(0<=l&&l<zft.length)return zft[l];throw new TypeError("Must be between 0 and 63: "+l)};lDe.decode=function(l){var c=65,f=90,y=97,b=122,A=48,g=57,p=43,k=47,j=26,se=52;return c<=l&&l<=f?l-c:y<=l&&l<=b?l-y+j:A<=l&&l<=g?l-A+se:l==p?62:l==k?63:-1}});var fDe=xt(_De=>{var $ft=Wft(),uDe=5,Hft=1<<uDe,Gft=Hft-1,Yft=Hft;function z_r(l){return l<0?(-l<<1)+1:(l<<1)+0}function W_r(l){var c=(l&1)===1,f=l>>1;return c?-f:f}_De.encode=function(c){var f="",y,b=z_r(c);do y=b&Gft,b>>>=uDe,b>0&&(y|=Yft),f+=$ft.encode(y);while(b>0);return f};_De.decode=function(c,f,y){var b=c.length,A=0,g=0,p,k;do{if(f>=b)throw new Error("Expected more digits in base 64 VLQ value.");if(k=$ft.decode(c.charCodeAt(f++)),k===-1)throw new Error("Invalid base64 digit: "+c.charAt(f-1));p=!!(k&Yft),k&=Gft,A=A+(k<<g),g+=uDe}while(p);y.value=W_r(A),y.rest=f}});var fF=xt(n0=>{function $_r(l,c,f){if(c in l)return l[c];if(arguments.length===3)return f;throw new Error('"'+c+'" is a required argument.')}n0.getArg=$_r;var Kft=/^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.-]*)(?::(\d+))?(.*)$/,H_r=/^data:.+\,.+$/;function Nz(l){var c=l.match(Kft);return c?{scheme:c[1],auth:c[2],host:c[3],port:c[4],path:c[5]}:null}n0.urlParse=Nz;function uF(l){var c="";return l.scheme&&(c+=l.scheme+":"),c+="//",l.auth&&(c+=l.auth+"@"),l.host&&(c+=l.host),l.port&&(c+=":"+l.port),l.path&&(c+=l.path),c}n0.urlGenerate=uF;function pDe(l){var c=l,f=Nz(l);if(f){if(!f.path)return l;c=f.path}for(var y=n0.isAbsolute(c),b=c.split(/\/+/),A,g=0,p=b.length-1;p>=0;p--)A=b[p],A==="."?b.splice(p,1):A===".."?g++:g>0&&(A===""?(b.splice(p+1,g),g=0):(b.splice(p,2),g--));return c=b.join("/"),c===""&&(c=y?"/":"."),f?(f.path=c,uF(f)):c}n0.normalize=pDe;function Xft(l,c){l===""&&(l="."),c===""&&(c=".");var f=Nz(c),y=Nz(l);if(y&&(l=y.path||"/"),f&&!f.scheme)return y&&(f.scheme=y.scheme),uF(f);if(f||c.match(H_r))return c;if(y&&!y.host&&!y.path)return y.host=c,uF(y);var b=c.charAt(0)==="/"?c:pDe(l.replace(/\/+$/,"")+"/"+c);return y?(y.path=b,uF(y)):b}n0.join=Xft;n0.isAbsolute=function(l){return l.charAt(0)==="/"||Kft.test(l)};function G_r(l,c){l===""&&(l="."),l=l.replace(/\/$/,"");for(var f=0;c.indexOf(l+"/")!==0;){var y=l.lastIndexOf("/");if(y<0||(l=l.slice(0,y),l.match(/^([^\/]+:\/)?\/*$/)))return c;++f}return Array(f+1).join("../")+c.substr(l.length+1)}n0.relative=G_r;var Qft=function(){var l=Object.create(null);return!("__proto__"in l)}();function Zft(l){return l}function Y_r(l){return ept(l)?"$"+l:l}n0.toSetString=Qft?Zft:Y_r;function K_r(l){return ept(l)?l.slice(1):l}n0.fromSetString=Qft?Zft:K_r;function ept(l){if(!l)return!1;var c=l.length;if(c<9||l.charCodeAt(c-1)!==95||l.charCodeAt(c-2)!==95||l.charCodeAt(c-3)!==111||l.charCodeAt(c-4)!==116||l.charCodeAt(c-5)!==111||l.charCodeAt(c-6)!==114||l.charCodeAt(c-7)!==112||l.charCodeAt(c-8)!==95||l.charCodeAt(c-9)!==95)return!1;for(var f=c-10;f>=0;f--)if(l.charCodeAt(f)!==36)return!1;return!0}function X_r(l,c,f){var y=_F(l.source,c.source);return y!==0||(y=l.originalLine-c.originalLine,y!==0)||(y=l.originalColumn-c.originalColumn,y!==0||f)||(y=l.generatedColumn-c.generatedColumn,y!==0)||(y=l.generatedLine-c.generatedLine,y!==0)?y:_F(l.name,c.name)}n0.compareByOriginalPositions=X_r;function Q_r(l,c,f){var y=l.generatedLine-c.generatedLine;return y!==0||(y=l.generatedColumn-c.generatedColumn,y!==0||f)||(y=_F(l.source,c.source),y!==0)||(y=l.originalLine-c.originalLine,y!==0)||(y=l.originalColumn-c.originalColumn,y!==0)?y:_F(l.name,c.name)}n0.compareByGeneratedPositionsDeflated=Q_r;function _F(l,c){return l===c?0:l===null?1:c===null?-1:l>c?1:-1}function Z_r(l,c){var f=l.generatedLine-c.generatedLine;return f!==0||(f=l.generatedColumn-c.generatedColumn,f!==0)||(f=_F(l.source,c.source),f!==0)||(f=l.originalLine-c.originalLine,f!==0)||(f=l.originalColumn-c.originalColumn,f!==0)?f:_F(l.name,c.name)}n0.compareByGeneratedPositionsInflated=Z_r;function efr(l){return JSON.parse(l.replace(/^\)]}'[^\n]*\n/,""))}n0.parseSourceMapInput=efr;function tfr(l,c,f){if(c=c||"",l&&(l[l.length-1]!=="/"&&c[0]!=="/"&&(l+="/"),c=l+c),f){var y=Nz(f);if(!y)throw new Error("sourceMapURL could not be parsed");if(y.path){var b=y.path.lastIndexOf("/");b>=0&&(y.path=y.path.substring(0,b+1))}c=Xft(uF(y),c)}return pDe(c)}n0.computeSourceURL=tfr});var gDe=xt(tpt=>{var dDe=fF(),mDe=Object.prototype.hasOwnProperty,J4=typeof Map<"u";function pP(){this._array=[],this._set=J4?new Map:Object.create(null)}pP.fromArray=function(c,f){for(var y=new pP,b=0,A=c.length;b<A;b++)y.add(c[b],f);return y};pP.prototype.size=function(){return J4?this._set.size:Object.getOwnPropertyNames(this._set).length};pP.prototype.add=function(c,f){var y=J4?c:dDe.toSetString(c),b=J4?this.has(c):mDe.call(this._set,y),A=this._array.length;(!b||f)&&this._array.push(c),b||(J4?this._set.set(c,A):this._set[y]=A)};pP.prototype.has=function(c){if(J4)return this._set.has(c);var f=dDe.toSetString(c);return mDe.call(this._set,f)};pP.prototype.indexOf=function(c){if(J4){var f=this._set.get(c);if(f>=0)return f}else{var y=dDe.toSetString(c);if(mDe.call(this._set,y))return this._set[y]}throw new Error('"'+c+'" is not in the set.')};pP.prototype.at=function(c){if(c>=0&&c<this._array.length)return this._array[c];throw new Error("No element indexed by "+c)};pP.prototype.toArray=function(){return this._array.slice()};tpt.ArraySet=pP});var ipt=xt(npt=>{var rpt=fF();function rfr(l,c){var f=l.generatedLine,y=c.generatedLine,b=l.generatedColumn,A=c.generatedColumn;return y>f||y==f&&A>=b||rpt.compareByGeneratedPositionsInflated(l,c)<=0}function Bae(){this._array=[],this._sorted=!0,this._last={generatedLine:-1,generatedColumn:0}}Bae.prototype.unsortedForEach=function(c,f){this._array.forEach(c,f)};Bae.prototype.add=function(c){rfr(this._last,c)?(this._last=c,this._array.push(c)):(this._sorted=!1,this._array.push(c))};Bae.prototype.toArray=function(){return this._sorted||(this._array.sort(rpt.compareByGeneratedPositionsInflated),this._sorted=!0),this._array};npt.MappingList=Bae});var hDe=xt(spt=>{var Dz=fDe(),Hm=fF(),Uae=gDe().ArraySet,nfr=ipt().MappingList;function DT(l){l||(l={}),this._file=Hm.getArg(l,"file",null),this._sourceRoot=Hm.getArg(l,"sourceRoot",null),this._skipValidation=Hm.getArg(l,"skipValidation",!1),this._sources=new Uae,this._names=new Uae,this._mappings=new nfr,this._sourcesContents=null}DT.prototype._version=3;DT.fromSourceMap=function(c){var f=c.sourceRoot,y=new DT({file:c.file,sourceRoot:f});return c.eachMapping(function(b){var A={generated:{line:b.generatedLine,column:b.generatedColumn}};b.source!=null&&(A.source=b.source,f!=null&&(A.source=Hm.relative(f,A.source)),A.original={line:b.originalLine,column:b.originalColumn},b.name!=null&&(A.name=b.name)),y.addMapping(A)}),c.sources.forEach(function(b){var A=b;f!==null&&(A=Hm.relative(f,b)),y._sources.has(A)||y._sources.add(A);var g=c.sourceContentFor(b);g!=null&&y.setSourceContent(b,g)}),y};DT.prototype.addMapping=function(c){var f=Hm.getArg(c,"generated"),y=Hm.getArg(c,"original",null),b=Hm.getArg(c,"source",null),A=Hm.getArg(c,"name",null);this._skipValidation||this._validateMapping(f,y,b,A),b!=null&&(b=String(b),this._sources.has(b)||this._sources.add(b)),A!=null&&(A=String(A),this._names.has(A)||this._names.add(A)),this._mappings.add({generatedLine:f.line,generatedColumn:f.column,originalLine:y!=null&&y.line,originalColumn:y!=null&&y.column,source:b,name:A})};DT.prototype.setSourceContent=function(c,f){var y=c;this._sourceRoot!=null&&(y=Hm.relative(this._sourceRoot,y)),f!=null?(this._sourcesContents||(this._sourcesContents=Object.create(null)),this._sourcesContents[Hm.toSetString(y)]=f):this._sourcesContents&&(delete this._sourcesContents[Hm.toSetString(y)],Object.keys(this._sourcesContents).length===0&&(this._sourcesContents=null))};DT.prototype.applySourceMap=function(c,f,y){var b=f;if(f==null){if(c.file==null)throw new Error(`SourceMapGenerator.prototype.applySourceMap requires either an explicit source file, or the source map's "file" property. Both were omitted.`);b=c.file}var A=this._sourceRoot;A!=null&&(b=Hm.relative(A,b));var g=new Uae,p=new Uae;this._mappings.unsortedForEach(function(k){if(k.source===b&&k.originalLine!=null){var j=c.originalPositionFor({line:k.originalLine,column:k.originalColumn});j.source!=null&&(k.source=j.source,y!=null&&(k.source=Hm.join(y,k.source)),A!=null&&(k.source=Hm.relative(A,k.source)),k.originalLine=j.line,k.originalColumn=j.column,j.name!=null&&(k.name=j.name))}var se=k.source;se!=null&&!g.has(se)&&g.add(se);var ze=k.name;ze!=null&&!p.has(ze)&&p.add(ze)},this),this._sources=g,this._names=p,c.sources.forEach(function(k){var j=c.sourceContentFor(k);j!=null&&(y!=null&&(k=Hm.join(y,k)),A!=null&&(k=Hm.relative(A,k)),this.setSourceContent(k,j))},this)};DT.prototype._validateMapping=function(c,f,y,b){if(f&&typeof f.line!="number"&&typeof f.column!="number")throw new Error("original.line and original.column are not numbers -- you probably meant to omit the original mapping entirely and only map the generated position. If so, pass null for the original mapping instead of an object with empty or null values.");if(!(c&&"line"in c&&"column"in c&&c.line>0&&c.column>=0&&!f&&!y&&!b)){if(c&&"line"in c&&"column"in c&&f&&"line"in f&&"column"in f&&c.line>0&&c.column>=0&&f.line>0&&f.column>=0&&y)return;throw new Error("Invalid mapping: "+JSON.stringify({generated:c,source:y,original:f,name:b}))}};DT.prototype._serializeMappings=function(){for(var c=0,f=1,y=0,b=0,A=0,g=0,p="",k,j,se,ze,ve=this._mappings.toArray(),lr=0,Br=ve.length;lr<Br;lr++){if(j=ve[lr],k="",j.generatedLine!==f)for(c=0;j.generatedLine!==f;)k+=";",f++;else if(lr>0){if(!Hm.compareByGeneratedPositionsInflated(j,ve[lr-1]))continue;k+=","}k+=Dz.encode(j.generatedColumn-c),c=j.generatedColumn,j.source!=null&&(ze=this._sources.indexOf(j.source),k+=Dz.encode(ze-g),g=ze,k+=Dz.encode(j.originalLine-1-b),b=j.originalLine-1,k+=Dz.encode(j.originalColumn-y),y=j.originalColumn,j.name!=null&&(se=this._names.indexOf(j.name),k+=Dz.encode(se-A),A=se)),p+=k}return p};DT.prototype._generateSourcesContent=function(c,f){return c.map(function(y){if(!this._sourcesContents)return null;f!=null&&(y=Hm.relative(f,y));var b=Hm.toSetString(y);return Object.prototype.hasOwnProperty.call(this._sourcesContents,b)?this._sourcesContents[b]:null},this)};DT.prototype.toJSON=function(){var c={version:this._version,sources:this._sources.toArray(),names:this._names.toArray(),mappings:this._serializeMappings()};return this._file!=null&&(c.file=this._file),this._sourceRoot!=null&&(c.sourceRoot=this._sourceRoot),this._sourcesContents&&(c.sourcesContent=this._generateSourcesContent(c.sources,c.sourceRoot)),c};DT.prototype.toString=function(){return JSON.stringify(this.toJSON())};spt.SourceMapGenerator=DT});var apt=xt(q4=>{q4.GREATEST_LOWER_BOUND=1;q4.LEAST_UPPER_BOUND=2;function yDe(l,c,f,y,b,A){var g=Math.floor((c-l)/2)+l,p=b(f,y[g],!0);return p===0?g:p>0?c-g>1?yDe(g,c,f,y,b,A):A==q4.LEAST_UPPER_BOUND?c<y.length?c:-1:g:g-l>1?yDe(l,g,f,y,b,A):A==q4.LEAST_UPPER_BOUND?g:l<0?-1:l}q4.search=function(c,f,y,b){if(f.length===0)return-1;var A=yDe(-1,f.length,c,f,y,b||q4.GREATEST_LOWER_BOUND);if(A<0)return-1;for(;A-1>=0&&y(f[A],f[A-1],!0)===0;)--A;return A}});var cpt=xt(opt=>{function vDe(l,c,f){var y=l[c];l[c]=l[f],l[f]=y}function ifr(l,c){return Math.round(l+Math.random()*(c-l))}function SDe(l,c,f,y){if(f<y){var b=ifr(f,y),A=f-1;vDe(l,b,y);for(var g=l[y],p=f;p<y;p++)c(l[p],g)<=0&&(A+=1,vDe(l,A,p));vDe(l,A+1,p);var k=A+1;SDe(l,c,f,k-1),SDe(l,c,k+1,y)}}opt.quickSort=function(l,c){SDe(l,c,0,l.length-1)}});var upt=xt(Vae=>{var co=fF(),bDe=apt(),pF=gDe().ArraySet,sfr=fDe(),wz=cpt().quickSort;function xp(l,c){var f=l;return typeof l=="string"&&(f=co.parseSourceMapInput(l)),f.sections!=null?new Tx(f,c):new my(f,c)}xp.fromSourceMap=function(l,c){return my.fromSourceMap(l,c)};xp.prototype._version=3;xp.prototype.__generatedMappings=null;Object.defineProperty(xp.prototype,"_generatedMappings",{configurable:!0,enumerable:!0,get:function(){return this.__generatedMappings||this._parseMappings(this._mappings,this.sourceRoot),this.__generatedMappings}});xp.prototype.__originalMappings=null;Object.defineProperty(xp.prototype,"_originalMappings",{configurable:!0,enumerable:!0,get:function(){return this.__originalMappings||this._parseMappings(this._mappings,this.sourceRoot),this.__originalMappings}});xp.prototype._charIsMappingSeparator=function(c,f){var y=c.charAt(f);return y===";"||y===","};xp.prototype._parseMappings=function(c,f){throw new Error("Subclasses must implement _parseMappings")};xp.GENERATED_ORDER=1;xp.ORIGINAL_ORDER=2;xp.GREATEST_LOWER_BOUND=1;xp.LEAST_UPPER_BOUND=2;xp.prototype.eachMapping=function(c,f,y){var b=f||null,A=y||xp.GENERATED_ORDER,g;switch(A){case xp.GENERATED_ORDER:g=this._generatedMappings;break;case xp.ORIGINAL_ORDER:g=this._originalMappings;break;default:throw new Error("Unknown order of iteration.")}var p=this.sourceRoot;g.map(function(k){var j=k.source===null?null:this._sources.at(k.source);return j=co.computeSourceURL(p,j,this._sourceMapURL),{source:j,generatedLine:k.generatedLine,generatedColumn:k.generatedColumn,originalLine:k.originalLine,originalColumn:k.originalColumn,name:k.name===null?null:this._names.at(k.name)}},this).forEach(c,b)};xp.prototype.allGeneratedPositionsFor=function(c){var f=co.getArg(c,"line"),y={source:co.getArg(c,"source"),originalLine:f,originalColumn:co.getArg(c,"column",0)};if(y.source=this._findSourceIndex(y.source),y.source<0)return[];var b=[],A=this._findMapping(y,this._originalMappings,"originalLine","originalColumn",co.compareByOriginalPositions,bDe.LEAST_UPPER_BOUND);if(A>=0){var g=this._originalMappings[A];if(c.column===void 0)for(var p=g.originalLine;g&&g.originalLine===p;)b.push({line:co.getArg(g,"generatedLine",null),column:co.getArg(g,"generatedColumn",null),lastColumn:co.getArg(g,"lastGeneratedColumn",null)}),g=this._originalMappings[++A];else for(var k=g.originalColumn;g&&g.originalLine===f&&g.originalColumn==k;)b.push({line:co.getArg(g,"generatedLine",null),column:co.getArg(g,"generatedColumn",null),lastColumn:co.getArg(g,"lastGeneratedColumn",null)}),g=this._originalMappings[++A]}return b};Vae.SourceMapConsumer=xp;function my(l,c){var f=l;typeof l=="string"&&(f=co.parseSourceMapInput(l));var y=co.getArg(f,"version"),b=co.getArg(f,"sources"),A=co.getArg(f,"names",[]),g=co.getArg(f,"sourceRoot",null),p=co.getArg(f,"sourcesContent",null),k=co.getArg(f,"mappings"),j=co.getArg(f,"file",null);if(y!=this._version)throw new Error("Unsupported version: "+y);g&&(g=co.normalize(g)),b=b.map(String).map(co.normalize).map(function(se){return g&&co.isAbsolute(g)&&co.isAbsolute(se)?co.relative(g,se):se}),this._names=pF.fromArray(A.map(String),!0),this._sources=pF.fromArray(b,!0),this._absoluteSources=this._sources.toArray().map(function(se){return co.computeSourceURL(g,se,c)}),this.sourceRoot=g,this.sourcesContent=p,this._mappings=k,this._sourceMapURL=c,this.file=j}my.prototype=Object.create(xp.prototype);my.prototype.consumer=xp;my.prototype._findSourceIndex=function(l){var c=l;if(this.sourceRoot!=null&&(c=co.relative(this.sourceRoot,c)),this._sources.has(c))return this._sources.indexOf(c);var f;for(f=0;f<this._absoluteSources.length;++f)if(this._absoluteSources[f]==l)return f;return-1};my.fromSourceMap=function(c,f){var y=Object.create(my.prototype),b=y._names=pF.fromArray(c._names.toArray(),!0),A=y._sources=pF.fromArray(c._sources.toArray(),!0);y.sourceRoot=c._sourceRoot,y.sourcesContent=c._generateSourcesContent(y._sources.toArray(),y.sourceRoot),y.file=c._file,y._sourceMapURL=f,y._absoluteSources=y._sources.toArray().map(function(lr){return co.computeSourceURL(y.sourceRoot,lr,f)});for(var g=c._mappings.toArray().slice(),p=y.__generatedMappings=[],k=y.__originalMappings=[],j=0,se=g.length;j<se;j++){var ze=g[j],ve=new lpt;ve.generatedLine=ze.generatedLine,ve.generatedColumn=ze.generatedColumn,ze.source&&(ve.source=A.indexOf(ze.source),ve.originalLine=ze.originalLine,ve.originalColumn=ze.originalColumn,ze.name&&(ve.name=b.indexOf(ze.name)),k.push(ve)),p.push(ve)}return wz(y.__originalMappings,co.compareByOriginalPositions),y};my.prototype._version=3;Object.defineProperty(my.prototype,"sources",{get:function(){return this._absoluteSources.slice()}});function lpt(){this.generatedLine=0,this.generatedColumn=0,this.source=null,this.originalLine=null,this.originalColumn=null,this.name=null}my.prototype._parseMappings=function(c,f){for(var y=1,b=0,A=0,g=0,p=0,k=0,j=c.length,se=0,ze={},ve={},lr=[],Br=[],wt,kt,Fi,yi,qo;se<j;)if(c.charAt(se)===";")y++,se++,b=0;else if(c.charAt(se)===",")se++;else{for(wt=new lpt,wt.generatedLine=y,yi=se;yi<j&&!this._charIsMappingSeparator(c,yi);yi++);if(kt=c.slice(se,yi),Fi=ze[kt],Fi)se+=kt.length;else{for(Fi=[];se<yi;)sfr.decode(c,se,ve),qo=ve.value,se=ve.rest,Fi.push(qo);if(Fi.length===2)throw new Error("Found a source, but no line and column");if(Fi.length===3)throw new Error("Found a source and line, but no column");ze[kt]=Fi}wt.generatedColumn=b+Fi[0],b=wt.generatedColumn,Fi.length>1&&(wt.source=p+Fi[1],p+=Fi[1],wt.originalLine=A+Fi[2],A=wt.originalLine,wt.originalLine+=1,wt.originalColumn=g+Fi[3],g=wt.originalColumn,Fi.length>4&&(wt.name=k+Fi[4],k+=Fi[4])),Br.push(wt),typeof wt.originalLine=="number"&&lr.push(wt)}wz(Br,co.compareByGeneratedPositionsDeflated),this.__generatedMappings=Br,wz(lr,co.compareByOriginalPositions),this.__originalMappings=lr};my.prototype._findMapping=function(c,f,y,b,A,g){if(c[y]<=0)throw new TypeError("Line must be greater than or equal to 1, got "+c[y]);if(c[b]<0)throw new TypeError("Column must be greater than or equal to 0, got "+c[b]);return bDe.search(c,f,A,g)};my.prototype.computeColumnSpans=function(){for(var c=0;c<this._generatedMappings.length;++c){var f=this._generatedMappings[c];if(c+1<this._generatedMappings.length){var y=this._generatedMappings[c+1];if(f.generatedLine===y.generatedLine){f.lastGeneratedColumn=y.generatedColumn-1;continue}}f.lastGeneratedColumn=1/0}};my.prototype.originalPositionFor=function(c){var f={generatedLine:co.getArg(c,"line"),generatedColumn:co.getArg(c,"column")},y=this._findMapping(f,this._generatedMappings,"generatedLine","generatedColumn",co.compareByGeneratedPositionsDeflated,co.getArg(c,"bias",xp.GREATEST_LOWER_BOUND));if(y>=0){var b=this._generatedMappings[y];if(b.generatedLine===f.generatedLine){var A=co.getArg(b,"source",null);A!==null&&(A=this._sources.at(A),A=co.computeSourceURL(this.sourceRoot,A,this._sourceMapURL));var g=co.getArg(b,"name",null);return g!==null&&(g=this._names.at(g)),{source:A,line:co.getArg(b,"originalLine",null),column:co.getArg(b,"originalColumn",null),name:g}}}return{source:null,line:null,column:null,name:null}};my.prototype.hasContentsOfAllSources=function(){return this.sourcesContent?this.sourcesContent.length>=this._sources.size()&&!this.sourcesContent.some(function(c){return c==null}):!1};my.prototype.sourceContentFor=function(c,f){if(!this.sourcesContent)return null;var y=this._findSourceIndex(c);if(y>=0)return this.sourcesContent[y];var b=c;this.sourceRoot!=null&&(b=co.relative(this.sourceRoot,b));var A;if(this.sourceRoot!=null&&(A=co.urlParse(this.sourceRoot))){var g=b.replace(/^file:\/\//,"");if(A.scheme=="file"&&this._sources.has(g))return this.sourcesContent[this._sources.indexOf(g)];if((!A.path||A.path=="/")&&this._sources.has("/"+b))return this.sourcesContent[this._sources.indexOf("/"+b)]}if(f)return null;throw new Error('"'+b+'" is not in the SourceMap.')};my.prototype.generatedPositionFor=function(c){var f=co.getArg(c,"source");if(f=this._findSourceIndex(f),f<0)return{line:null,column:null,lastColumn:null};var y={source:f,originalLine:co.getArg(c,"line"),originalColumn:co.getArg(c,"column")},b=this._findMapping(y,this._originalMappings,"originalLine","originalColumn",co.compareByOriginalPositions,co.getArg(c,"bias",xp.GREATEST_LOWER_BOUND));if(b>=0){var A=this._originalMappings[b];if(A.source===y.source)return{line:co.getArg(A,"generatedLine",null),column:co.getArg(A,"generatedColumn",null),lastColumn:co.getArg(A,"lastGeneratedColumn",null)}}return{line:null,column:null,lastColumn:null}};Vae.BasicSourceMapConsumer=my;function Tx(l,c){var f=l;typeof l=="string"&&(f=co.parseSourceMapInput(l));var y=co.getArg(f,"version"),b=co.getArg(f,"sections");if(y!=this._version)throw new Error("Unsupported version: "+y);this._sources=new pF,this._names=new pF;var A={line:-1,column:0};this._sections=b.map(function(g){if(g.url)throw new Error("Support for url field in sections not implemented.");var p=co.getArg(g,"offset"),k=co.getArg(p,"line"),j=co.getArg(p,"column");if(k<A.line||k===A.line&&j<A.column)throw new Error("Section offsets must be ordered and non-overlapping.");return A=p,{generatedOffset:{generatedLine:k+1,generatedColumn:j+1},consumer:new xp(co.getArg(g,"map"),c)}})}Tx.prototype=Object.create(xp.prototype);Tx.prototype.constructor=xp;Tx.prototype._version=3;Object.defineProperty(Tx.prototype,"sources",{get:function(){for(var l=[],c=0;c<this._sections.length;c++)for(var f=0;f<this._sections[c].consumer.sources.length;f++)l.push(this._sections[c].consumer.sources[f]);return l}});Tx.prototype.originalPositionFor=function(c){var f={generatedLine:co.getArg(c,"line"),generatedColumn:co.getArg(c,"column")},y=bDe.search(f,this._sections,function(A,g){var p=A.generatedLine-g.generatedOffset.generatedLine;return p||A.generatedColumn-g.generatedOffset.generatedColumn}),b=this._sections[y];return b?b.consumer.originalPositionFor({line:f.generatedLine-(b.generatedOffset.generatedLine-1),column:f.generatedColumn-(b.generatedOffset.generatedLine===f.generatedLine?b.generatedOffset.generatedColumn-1:0),bias:c.bias}):{source:null,line:null,column:null,name:null}};Tx.prototype.hasContentsOfAllSources=function(){return this._sections.every(function(c){return c.consumer.hasContentsOfAllSources()})};Tx.prototype.sourceContentFor=function(c,f){for(var y=0;y<this._sections.length;y++){var b=this._sections[y],A=b.consumer.sourceContentFor(c,!0);if(A)return A}if(f)return null;throw new Error('"'+c+'" is not in the SourceMap.')};Tx.prototype.generatedPositionFor=function(c){for(var f=0;f<this._sections.length;f++){var y=this._sections[f];if(y.consumer._findSourceIndex(co.getArg(c,"source"))!==-1){var b=y.consumer.generatedPositionFor(c);if(b){var A={line:b.line+(y.generatedOffset.generatedLine-1),column:b.column+(y.generatedOffset.generatedLine===b.line?y.generatedOffset.generatedColumn-1:0)};return A}}}return{line:null,column:null}};Tx.prototype._parseMappings=function(c,f){this.__generatedMappings=[],this.__originalMappings=[];for(var y=0;y<this._sections.length;y++)for(var b=this._sections[y],A=b.consumer._generatedMappings,g=0;g<A.length;g++){var p=A[g],k=b.consumer._sources.at(p.source);k=co.computeSourceURL(b.consumer.sourceRoot,k,this._sourceMapURL),this._sources.add(k),k=this._sources.indexOf(k);var j=null;p.name&&(j=b.consumer._names.at(p.name),this._names.add(j),j=this._names.indexOf(j));var se={source:k,generatedLine:p.generatedLine+(b.generatedOffset.generatedLine-1),generatedColumn:p.generatedColumn+(b.generatedOffset.generatedLine===p.generatedLine?b.generatedOffset.generatedColumn-1:0),originalLine:p.originalLine,originalColumn:p.originalColumn,name:j};this.__generatedMappings.push(se),typeof se.originalLine=="number"&&this.__originalMappings.push(se)}wz(this.__generatedMappings,co.compareByGeneratedPositionsDeflated),wz(this.__originalMappings,co.compareByOriginalPositions)};Vae.IndexedSourceMapConsumer=Tx});var fpt=xt(_pt=>{var afr=hDe().SourceMapGenerator,Jae=fF(),ofr=/(\r?\n)/,cfr=10,dF="$$$isSourceNode$$$";function $S(l,c,f,y,b){this.children=[],this.sourceContents={},this.line=l??null,this.column=c??null,this.source=f??null,this.name=b??null,this[dF]=!0,y!=null&&this.add(y)}$S.fromStringWithSourceMap=function(c,f,y){var b=new $S,A=c.split(ofr),g=0,p=function(){var ve=Br(),lr=Br()||"";return ve+lr;function Br(){return g<A.length?A[g++]:void 0}},k=1,j=0,se=null;return f.eachMapping(function(ve){if(se!==null)if(k<ve.generatedLine)ze(se,p()),k++,j=0;else{var lr=A[g]||"",Br=lr.substr(0,ve.generatedColumn-j);A[g]=lr.substr(ve.generatedColumn-j),j=ve.generatedColumn,ze(se,Br),se=ve;return}for(;k<ve.generatedLine;)b.add(p()),k++;if(j<ve.generatedColumn){var lr=A[g]||"";b.add(lr.substr(0,ve.generatedColumn)),A[g]=lr.substr(ve.generatedColumn),j=ve.generatedColumn}se=ve},this),g<A.length&&(se&&ze(se,p()),b.add(A.splice(g).join(""))),f.sources.forEach(function(ve){var lr=f.sourceContentFor(ve);lr!=null&&(y!=null&&(ve=Jae.join(y,ve)),b.setSourceContent(ve,lr))}),b;function ze(ve,lr){if(ve===null||ve.source===void 0)b.add(lr);else{var Br=y?Jae.join(y,ve.source):ve.source;b.add(new $S(ve.originalLine,ve.originalColumn,Br,lr,ve.name))}}};$S.prototype.add=function(c){if(Array.isArray(c))c.forEach(function(f){this.add(f)},this);else if(c[dF]||typeof c=="string")c&&this.children.push(c);else throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got "+c);return this};$S.prototype.prepend=function(c){if(Array.isArray(c))for(var f=c.length-1;f>=0;f--)this.prepend(c[f]);else if(c[dF]||typeof c=="string")this.children.unshift(c);else throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got "+c);return this};$S.prototype.walk=function(c){for(var f,y=0,b=this.children.length;y<b;y++)f=this.children[y],f[dF]?f.walk(c):f!==""&&c(f,{source:this.source,line:this.line,column:this.column,name:this.name})};$S.prototype.join=function(c){var f,y,b=this.children.length;if(b>0){for(f=[],y=0;y<b-1;y++)f.push(this.children[y]),f.push(c);f.push(this.children[y]),this.children=f}return this};$S.prototype.replaceRight=function(c,f){var y=this.children[this.children.length-1];return y[dF]?y.replaceRight(c,f):typeof y=="string"?this.children[this.children.length-1]=y.replace(c,f):this.children.push("".replace(c,f)),this};$S.prototype.setSourceContent=function(c,f){this.sourceContents[Jae.toSetString(c)]=f};$S.prototype.walkSourceContents=function(c){for(var f=0,y=this.children.length;f<y;f++)this.children[f][dF]&&this.children[f].walkSourceContents(c);for(var b=Object.keys(this.sourceContents),f=0,y=b.length;f<y;f++)c(Jae.fromSetString(b[f]),this.sourceContents[b[f]])};$S.prototype.toString=function(){var c="";return this.walk(function(f){c+=f}),c};$S.prototype.toStringWithSourceMap=function(c){var f={code:"",line:1,column:0},y=new afr(c),b=!1,A=null,g=null,p=null,k=null;return this.walk(function(j,se){f.code+=j,se.source!==null&&se.line!==null&&se.column!==null?((A!==se.source||g!==se.line||p!==se.column||k!==se.name)&&y.addMapping({source:se.source,original:{line:se.line,column:se.column},generated:{line:f.line,column:f.column},name:se.name}),A=se.source,g=se.line,p=se.column,k=se.name,b=!0):b&&(y.addMapping({generated:{line:f.line,column:f.column}}),A=null,b=!1);for(var ze=0,ve=j.length;ze<ve;ze++)j.charCodeAt(ze)===cfr?(f.line++,f.column=0,ze+1===ve?(A=null,b=!1):b&&y.addMapping({source:se.source,original:{line:se.line,column:se.column},generated:{line:f.line,column:f.column},name:se.name})):f.column++}),this.walkSourceContents(function(j,se){y.setSourceContent(j,se)}),{code:f.code,map:y}};_pt.SourceNode=$S});var ppt=xt(qae=>{qae.SourceMapGenerator=hDe().SourceMapGenerator;qae.SourceMapConsumer=upt().SourceMapConsumer;qae.SourceNode=fpt().SourceNode});var mpt=xt((rNr,dpt)=>{var lfr=Object.prototype.toString,TDe=typeof Buffer<"u"&&typeof Buffer.alloc=="function"&&typeof Buffer.allocUnsafe=="function"&&typeof Buffer.from=="function";function ufr(l){return lfr.call(l).slice(8,-1)==="ArrayBuffer"}function _fr(l,c,f){c>>>=0;var y=l.byteLength-c;if(y<0)throw new RangeError("'offset' is out of bounds");if(f===void 0)f=y;else if(f>>>=0,f>y)throw new RangeError("'length' is out of bounds");return TDe?Buffer.from(l.slice(c,c+f)):new Buffer(new Uint8Array(l.slice(c,c+f)))}function ffr(l,c){if((typeof c!="string"||c==="")&&(c="utf8"),!Buffer.isEncoding(c))throw new TypeError('"encoding" must be a valid string encoding');return TDe?Buffer.from(l,c):new Buffer(l,c)}function pfr(l,c,f){if(typeof l=="number")throw new TypeError('"value" argument must not be a number');return ufr(l)?_fr(l,c,f):typeof l=="string"?ffr(l,c):TDe?Buffer.from(l):new Buffer(l)}dpt.exports=pfr});var Ept=xt((W4,ADe)=>{var dfr=ppt().SourceMapConsumer,EDe=Bu("path"),xC;try{xC=Bu("fs"),(!xC.existsSync||!xC.readFileSync)&&(xC=null)}catch{}var mfr=mpt();function gpt(l,c){return l.require(c)}var hpt=!1,ypt=!1,xDe=!1,Iz="auto",z4={},Oz={},gfr=/^data:application\/json[^,]+base64,/,kw=[],Pw=[];function kDe(){return Iz==="browser"?!0:Iz==="node"?!1:typeof window<"u"&&typeof XMLHttpRequest=="function"&&!(window.require&&window.module&&window.process&&window.process.type==="renderer")}function hfr(){return typeof process=="object"&&process!==null&&typeof process.on=="function"}function yfr(){return typeof process=="object"&&process!==null?process.version:""}function vfr(){if(typeof process=="object"&&process!==null)return process.stderr}function Sfr(l){if(typeof process=="object"&&process!==null&&typeof process.exit=="function")return process.exit(l)}function zae(l){return function(c){for(var f=0;f<l.length;f++){var y=l[f](c);if(y)return y}return null}}var PDe=zae(kw);kw.push(function(l){if(l=l.trim(),/^file:/.test(l)&&(l=l.replace(/file:\/\/\/(\w:)?/,function(y,b){return b?"":"/"})),l in z4)return z4[l];var c="";try{if(xC)xC.existsSync(l)&&(c=xC.readFileSync(l,"utf8"));else{var f=new XMLHttpRequest;f.open("GET",l,!1),f.send(null),f.readyState===4&&f.status===200&&(c=f.responseText)}}catch{}return z4[l]=c});function CDe(l,c){if(!l)return c;var f=EDe.dirname(l),y=/^\w+:\/\/[^\/]*/.exec(f),b=y?y[0]:"",A=f.slice(b.length);return b&&/^\/\w\:/.test(A)?(b+="/",b+EDe.resolve(f.slice(b.length),c).replace(/\\/g,"/")):b+EDe.resolve(f.slice(b.length),c)}function bfr(l){var c;if(kDe())try{var f=new XMLHttpRequest;f.open("GET",l,!1),f.send(null),c=f.readyState===4?f.responseText:null;var y=f.getResponseHeader("SourceMap")||f.getResponseHeader("X-SourceMap");if(y)return y}catch{}c=PDe(l);for(var b=/(?:\/\/[@#][\s]*sourceMappingURL=([^\s'"]+)[\s]*$)|(?:\/\*[@#][\s]*sourceMappingURL=([^\s*'"]+)[\s]*(?:\*\/)[\s]*$)/mg,A,g;g=b.exec(c);)A=g;return A?A[1]:null}var NDe=zae(Pw);Pw.push(function(l){var c=bfr(l);if(!c)return null;var f;if(gfr.test(c)){var y=c.slice(c.indexOf(",")+1);f=mfr(y,"base64").toString(),c=l}else c=CDe(l,c),f=PDe(c);return f?{url:c,map:f}:null});function DDe(l){var c=Oz[l.source];if(!c){var f=NDe(l.source);f?(c=Oz[l.source]={url:f.url,map:new dfr(f.map)},c.map.sourcesContent&&c.map.sources.forEach(function(b,A){var g=c.map.sourcesContent[A];if(g){var p=CDe(c.url,b);z4[p]=g}})):c=Oz[l.source]={url:null,map:null}}if(c&&c.map&&typeof c.map.originalPositionFor=="function"){var y=c.map.originalPositionFor(l);if(y.source!==null)return y.source=CDe(c.url,y.source),y}return l}function Spt(l){var c=/^eval at ([^(]+) \((.+):(\d+):(\d+)\)$/.exec(l);if(c){var f=DDe({source:c[2],line:+c[3],column:c[4]-1});return"eval at "+c[1]+" ("+f.source+":"+f.line+":"+(f.column+1)+")"}return c=/^eval at ([^(]+) \((.+)\)$/.exec(l),c?"eval at "+c[1]+" ("+Spt(c[2])+")":l}function Tfr(){var l,c="";if(this.isNative())c="native";else{l=this.getScriptNameOrSourceURL(),!l&&this.isEval()&&(c=this.getEvalOrigin(),c+=", "),l?c+=l:c+="<anonymous>";var f=this.getLineNumber();if(f!=null){c+=":"+f;var y=this.getColumnNumber();y&&(c+=":"+y)}}var b="",A=this.getFunctionName(),g=!0,p=this.isConstructor(),k=!(this.isToplevel()||p);if(k){var j=this.getTypeName();j==="[object Object]"&&(j="null");var se=this.getMethodName();A?(j&&A.indexOf(j)!=0&&(b+=j+"."),b+=A,se&&A.indexOf("."+se)!=A.length-se.length-1&&(b+=" [as "+se+"]")):b+=j+"."+(se||"<anonymous>")}else p?b+="new "+(A||"<anonymous>"):A?b+=A:(b+=c,g=!1);return g&&(b+=" ("+c+")"),b}function vpt(l){var c={};return Object.getOwnPropertyNames(Object.getPrototypeOf(l)).forEach(function(f){c[f]=/^(?:is|get)/.test(f)?function(){return l[f].call(l)}:l[f]}),c.toString=Tfr,c}function bpt(l,c){if(c===void 0&&(c={nextPosition:null,curPosition:null}),l.isNative())return c.curPosition=null,l;var f=l.getFileName()||l.getScriptNameOrSourceURL();if(f){var y=l.getLineNumber(),b=l.getColumnNumber()-1,A=/^v(10\.1[6-9]|10\.[2-9][0-9]|10\.[0-9]{3,}|1[2-9]\d*|[2-9]\d|\d{3,}|11\.11)/,g=A.test(yfr())?0:62;y===1&&b>g&&!kDe()&&!l.isEval()&&(b-=g);var p=DDe({source:f,line:y,column:b});c.curPosition=p,l=vpt(l);var k=l.getFunctionName;return l.getFunctionName=function(){return c.nextPosition==null?k():c.nextPosition.name||k()},l.getFileName=function(){return p.source},l.getLineNumber=function(){return p.line},l.getColumnNumber=function(){return p.column+1},l.getScriptNameOrSourceURL=function(){return p.source},l}var j=l.isEval()&&l.getEvalOrigin();return j&&(j=Spt(j),l=vpt(l),l.getEvalOrigin=function(){return j}),l}function Efr(l,c){xDe&&(z4={},Oz={});for(var f=l.name||"Error",y=l.message||"",b=f+": "+y,A={nextPosition:null,curPosition:null},g=[],p=c.length-1;p>=0;p--)g.push(`
    at `+bpt(c[p],A)),A.nextPosition=A.curPosition;return A.curPosition=A.nextPosition=null,b+g.reverse().join("")}function Tpt(l){var c=/\n    at [^(]+ \((.*):(\d+):(\d+)\)/.exec(l.stack);if(c){var f=c[1],y=+c[2],b=+c[3],A=z4[f];if(!A&&xC&&xC.existsSync(f))try{A=xC.readFileSync(f,"utf8")}catch{A=""}if(A){var g=A.split(/(?:\r\n|\r|\n)/)[y-1];if(g)return f+":"+y+`
`+g+`
`+new Array(b).join(" ")+"^"}}return null}function xfr(l){var c=Tpt(l),f=vfr();f&&f._handle&&f._handle.setBlocking&&f._handle.setBlocking(!0),c&&(console.error(),console.error(c)),console.error(l.stack),Sfr(1)}function Cfr(){var l=process.emit;process.emit=function(c){if(c==="uncaughtException"){var f=arguments[1]&&arguments[1].stack,y=this.listeners(c).length>0;if(f&&!y)return xfr(arguments[1])}return l.apply(this,arguments)}}var Afr=kw.slice(0),kfr=Pw.slice(0);W4.wrapCallSite=bpt;W4.getErrorSource=Tpt;W4.mapSourcePosition=DDe;W4.retrieveSourceMap=NDe;W4.install=function(l){if(l=l||{},l.environment&&(Iz=l.environment,["node","browser","auto"].indexOf(Iz)===-1))throw new Error("environment "+Iz+" was unknown. Available options are {auto, browser, node}");if(l.retrieveFile&&(l.overrideRetrieveFile&&(kw.length=0),kw.unshift(l.retrieveFile)),l.retrieveSourceMap&&(l.overrideRetrieveSourceMap&&(Pw.length=0),Pw.unshift(l.retrieveSourceMap)),l.hookRequire&&!kDe()){var c=gpt(ADe,"module"),f=c.prototype._compile;f.__sourceMapSupport||(c.prototype._compile=function(A,g){return z4[g]=A,Oz[g]=void 0,f.call(this,A,g)},c.prototype._compile.__sourceMapSupport=!0)}if(xDe||(xDe="emptyCacheBetweenOperations"in l?l.emptyCacheBetweenOperations:!1),hpt||(hpt=!0,Error.prepareStackTrace=Efr),!ypt){var y="handleUncaughtExceptions"in l?l.handleUncaughtExceptions:!0;try{var b=gpt(ADe,"worker_threads");b.isMainThread===!1&&(y=!1)}catch{}y&&hfr()&&(ypt=!0,Cfr())}};W4.resetRetrieveHandlers=function(){kw.length=0,Pw.length=0,kw=Afr.slice(0),Pw=kfr.slice(0),NDe=zae(Pw),PDe=zae(kw)}});var x1=xt((nNr,$ae)=>{var xpt={};(l=>{"use strict";var c=Object.defineProperty,f=Object.getOwnPropertyDescriptor,y=Object.getOwnPropertyNames,b=Object.prototype.hasOwnProperty,A=(e,t)=>{for(var n in t)c(e,n,{get:t[n],enumerable:!0})},g=(e,t,n,i)=>{if(t&&typeof t=="object"||typeof t=="function")for(let s of y(t))!b.call(e,s)&&s!==n&&c(e,s,{get:()=>t[s],enumerable:!(i=f(t,s))||i.enumerable});return e},p=e=>e,k={};A(k,{ANONYMOUS:()=>GQ,AccessFlags:()=>Rle,AssertionLevel:()=>zce,AssignmentDeclarationKind:()=>qle,AssignmentKind:()=>pfe,Associativity:()=>Tfe,BreakpointResolver:()=>HZ,BuilderFileEmit:()=>Xhe,BuilderProgramKind:()=>iye,BuilderState:()=>lg,CallHierarchy:()=>uk,CharacterCodes:()=>eue,CheckFlags:()=>Dle,CheckMode:()=>dK,ClassificationType:()=>tQ,ClassificationTypeNames:()=>u0e,CommentDirectiveType:()=>mle,Comparison:()=>ze,CompletionInfoFlags:()=>n0e,CompletionTriggerKind:()=>ZX,Completions:()=>gk,ContainerFlags:()=>Age,ContextFlags:()=>Tle,Debug:()=>M,DiagnosticCategory:()=>c5,Diagnostics:()=>v,DocumentHighlights:()=>_V,ElementFlags:()=>Ole,EmitFlags:()=>o$,EmitHint:()=>sue,EmitOnly:()=>hle,EndOfLineState:()=>a0e,ExitStatus:()=>yle,ExportKind:()=>ove,Extension:()=>tue,ExternalEmitHelpers:()=>iue,FileIncludeKind:()=>XW,FilePreprocessingDiagnosticsKind:()=>gle,FileSystemEntryKind:()=>due,FileWatcherEventKind:()=>_ue,FindAllReferences:()=>lc,FlattenLevel:()=>Zge,FlowFlags:()=>o5,ForegroundColorEscapeSequences:()=>qhe,FunctionFlags:()=>vfe,GeneratedIdentifierFlags:()=>KW,GetLiteralTextFlags:()=>k_e,GoToDefinition:()=>oD,HighlightSpanKind:()=>t0e,IdentifierNameMap:()=>LN,IdentifierNameMultiMap:()=>$ge,ImportKind:()=>ave,ImportsNotUsedAsValues:()=>Yle,IndentStyle:()=>r0e,IndexFlags:()=>Mle,IndexKind:()=>jle,InferenceFlags:()=>Vle,InferencePriority:()=>Ule,InlayHintKind:()=>e0e,InlayHints:()=>jee,InternalEmitFlags:()=>rue,InternalSymbolName:()=>wle,IntersectionFlags:()=>ble,InvalidatedProjectKind:()=>Pye,JSDocParsingMode:()=>uue,JsDoc:()=>Bb,JsTyping:()=>eh,JsxEmit:()=>Gle,JsxFlags:()=>fle,JsxReferenceKind:()=>Lle,LanguageFeatureMinimumTarget:()=>nue,LanguageServiceMode:()=>Qye,LanguageVariant:()=>Qle,LexicalEnvironmentFlags:()=>oue,ListFormat:()=>cue,LogLevel:()=>tle,MapCode:()=>Bee,MemberOverrideStatus:()=>vle,ModifierFlags:()=>GW,ModuleDetectionKind:()=>zle,ModuleInstanceState:()=>xge,ModuleKind:()=>y3,ModuleResolutionKind:()=>rI,ModuleSpecifierEnding:()=>bpe,NavigateTo:()=>Nve,NavigationBar:()=>wve,NewLineKind:()=>Kle,NodeBuilderFlags:()=>Ele,NodeCheckFlags:()=>e$,NodeFactoryFlags:()=>Hpe,NodeFlags:()=>HW,NodeResolutionFeatures:()=>dge,ObjectFlags:()=>r$,OperationCanceledException:()=>tI,OperatorPrecedence:()=>Efe,OrganizeImports:()=>Ub,OrganizeImportsMode:()=>QX,OuterExpressionKinds:()=>aue,OutliningElementsCollector:()=>Jee,OutliningSpanKind:()=>i0e,OutputFileType:()=>s0e,PackageJsonAutoImportPreference:()=>Xye,PackageJsonDependencyGroup:()=>Kye,PatternMatchKind:()=>dZ,PollingInterval:()=>c$,PollingWatchKind:()=>Hle,PragmaKindFlags:()=>lue,PrivateIdentifierKind:()=>ide,ProcessLevel:()=>she,ProgramUpdateLevel:()=>jhe,QuotePreference:()=>R0e,RegularExpressionFlags:()=>ple,RelationComparisonResult:()=>YW,Rename:()=>KV,ScriptElementKind:()=>c0e,ScriptElementKindModifier:()=>l0e,ScriptKind:()=>i$,ScriptSnapshot:()=>yU,ScriptTarget:()=>Xle,SemanticClassificationFormat:()=>Zye,SemanticMeaning:()=>_0e,SemicolonPreference:()=>eQ,SignatureCheckMode:()=>mK,SignatureFlags:()=>n$,SignatureHelp:()=>YM,SignatureInfo:()=>Khe,SignatureKind:()=>Fle,SmartSelectionRange:()=>Wee,SnippetKind:()=>a$,StatisticType:()=>Uye,StructureIsReused:()=>QW,SymbolAccessibility:()=>Ale,SymbolDisplay:()=>zv,SymbolDisplayPartKind:()=>SU,SymbolFlags:()=>ZW,SymbolFormatFlags:()=>Cle,SyntaxKind:()=>$W,SyntheticSymbolKind:()=>kle,Ternary:()=>Jle,ThrottledCancellationToken:()=>U1e,TokenClass:()=>o0e,TokenFlags:()=>dle,TransformFlags:()=>s$,TypeFacts:()=>pK,TypeFlags:()=>t$,TypeFormatFlags:()=>xle,TypeMapKind:()=>Ble,TypePredicateKind:()=>Ple,TypeReferenceSerializationKind:()=>Nle,UnionReduction:()=>Sle,UpToDateStatusType:()=>bye,VarianceFlags:()=>Ile,Version:()=>Km,VersionRange:()=>s5,WatchDirectoryFlags:()=>Zle,WatchDirectoryKind:()=>$le,WatchFileKind:()=>Wle,WatchLogLevel:()=>Uhe,WatchType:()=>Tu,accessPrivateIdentifier:()=>Xge,addDisposableResourceHelper:()=>Ide,addEmitFlags:()=>zg,addEmitHelper:()=>NA,addEmitHelpers:()=>E0,addInternalEmitFlags:()=>kA,addNodeFactoryPatcher:()=>f4e,addObjectAllocatorPatcher:()=>X6e,addRange:()=>wn,addRelatedInfo:()=>ca,addSyntheticLeadingComment:()=>vO,addSyntheticTrailingComment:()=>Tj,addToSeen:()=>em,advancedAsyncSuperHelper:()=>Aj,affectsDeclarationPathOptionDeclarations:()=>Mme,affectsEmitOptionDeclarations:()=>Rme,allKeysStartWithDot:()=>TB,altDirectorySeparator:()=>f5,and:()=>r5,append:()=>Bt,appendIfUnique:()=>$o,arrayFrom:()=>Is,arrayIsEqualTo:()=>Vp,arrayIsHomogeneous:()=>Dpe,arrayIsSorted:()=>NW,arrayOf:()=>Bce,arrayReverseIterator:()=>Ra,arrayToMap:()=>xP,arrayToMultiMap:()=>f3,arrayToNumericMap:()=>Vce,arraysEqual:()=>UT,assertType:()=>mOe,assign:()=>Mx,assignHelper:()=>fde,asyncDelegator:()=>dde,asyncGeneratorHelper:()=>pde,asyncSuperHelper:()=>Cj,asyncValues:()=>mde,attachFileToDiagnostics:()=>yA,awaitHelper:()=>SO,awaiterHelper:()=>hde,base64decode:()=>Gfe,base64encode:()=>Hfe,binarySearch:()=>mv,binarySearchKey:()=>BC,bindSourceFile:()=>kge,breakIntoCharacterSpans:()=>bve,breakIntoWordSpans:()=>Tve,buildLinkParts:()=>q0e,buildOpts:()=>A8,buildOverload:()=>Qqe,bundlerModuleNameResolver:()=>mge,canBeConvertedToAsync:()=>SZ,canHaveDecorators:()=>TE,canHaveExportModifier:()=>XR,canHaveFlowNode:()=>ER,canHaveIllegalDecorators:()=>EY,canHaveIllegalModifiers:()=>mme,canHaveIllegalType:()=>j4e,canHaveIllegalTypeParameters:()=>dme,canHaveJSDoc:()=>xR,canHaveLocals:()=>Lh,canHaveModifiers:()=>wm,canHaveSymbol:()=>Zm,canIncludeBindAndCheckDiagnsotics:()=>KR,canJsonReportNoInputFiles:()=>VO,canProduceDiagnostics:()=>LB,canUsePropertyAccess:()=>OG,canWatchAffectingLocation:()=>fye,canWatchAtTypes:()=>_ye,canWatchDirectoryOrFile:()=>eU,cartesianProduct:()=>Zce,cast:()=>aa,chainBundle:()=>cg,chainDiagnosticMessages:()=>js,changeAnyExtension:()=>b3,changeCompilerHostLikeToUseCache:()=>a6,changeExtension:()=>Y1,changeFullExtension:()=>yue,changesAffectModuleResolution:()=>U5,changesAffectingProgramStructure:()=>S_e,characterToRegularExpressionFlag:()=>S$,childIsDecorated:()=>wI,classElementOrClassElementParameterIsDecorated:()=>yH,classHasClassThisAssignment:()=>DK,classHasDeclaredOrExplicitlyAssignedName:()=>wK,classHasExplicitlyAssignedName:()=>OB,classOrConstructorParameterIsDecorated:()=>Cv,classPrivateFieldGetHelper:()=>Nde,classPrivateFieldInHelper:()=>wde,classPrivateFieldSetHelper:()=>Dde,classicNameResolver:()=>Tge,classifier:()=>z1e,cleanExtendedConfigCache:()=>zB,clear:()=>Ym,clearMap:()=>Vf,clearSharedExtendedConfigFileWatcher:()=>zK,climbPastPropertyAccess:()=>EU,climbPastPropertyOrElementAccess:()=>m0e,clone:()=>Jce,cloneCompilerOptions:()=>SQ,closeFileWatcher:()=>Dm,closeFileWatcherOf:()=>Nd,codefix:()=>A_,collapseTextChangeRangesAcrossMultipleVersions:()=>Oue,collectExternalModuleInfo:()=>AK,combine:()=>vs,combinePaths:()=>ri,commandLineOptionOfCustomType:()=>Ume,commentPragmas:()=>l5,commonOptionsWithBuild:()=>tB,commonPackageFolders:()=>mpe,compact:()=>cn,compareBooleans:()=>XS,compareDataObjects:()=>cG,compareDiagnostics:()=>rO,compareDiagnosticsSkipRelatedInformation:()=>z9,compareEmitHelpers:()=>ade,compareNumberOfDirectorySeparators:()=>GR,comparePaths:()=>_0,comparePathsCaseInsensitive:()=>jOe,comparePathsCaseSensitive:()=>FOe,comparePatternKeys:()=>lK,compareProperties:()=>Yce,compareStringsCaseInsensitive:()=>d3,compareStringsCaseInsensitiveEslintCompatible:()=>Wce,compareStringsCaseSensitive:()=>c_,compareStringsCaseSensitiveUI:()=>m3,compareTextSpans:()=>e5,compareValues:()=>tc,compileOnSaveCommandLineOption:()=>Zj,compilerOptionsAffectDeclarationPath:()=>ppe,compilerOptionsAffectEmit:()=>fpe,compilerOptionsAffectSemanticDiagnostics:()=>_pe,compilerOptionsDidYouMeanDiagnostics:()=>sB,compilerOptionsIndicateEsModules:()=>kQ,compose:()=>pOe,computeCommonSourceDirectoryOfFilenames:()=>Vhe,computeLineAndCharacterOfPosition:()=>NP,computeLineOfPosition:()=>oI,computeLineStarts:()=>$C,computePositionOfLineAndCharacter:()=>h5,computeSignature:()=>sye,computeSignatureWithDiagnostics:()=>fX,computeSuggestionDiagnostics:()=>hZ,computedOptions:()=>Ql,concatenate:()=>ps,concatenateDiagnosticMessageChains:()=>ope,configDirTemplateSubstitutionOptions:()=>jme,configDirTemplateSubstitutionWatchOptions:()=>Bme,consumesNodeCoreModules:()=>tV,contains:()=>Es,containsIgnoredPath:()=>pO,containsObjectRestOrSpread:()=>T8,containsParseError:()=>VP,containsPath:()=>Cm,convertCompilerOptionsForTelemetry:()=>rge,convertCompilerOptionsFromJson:()=>G3e,convertJsonOption:()=>g2,convertToBase64:()=>$fe,convertToJson:()=>N8,convertToObject:()=>Yme,convertToOptionsWithAbsolutePaths:()=>lB,convertToRelativePath:()=>sI,convertToTSConfig:()=>WY,convertTypeAcquisitionFromJson:()=>Y3e,copyComments:()=>T2,copyEntries:()=>V5,copyLeadingComments:()=>QN,copyProperties:()=>OW,copyTrailingAsLeadingComments:()=>TM,copyTrailingComments:()=>b6,couldStartTrivia:()=>Eue,countWhere:()=>vy,createAbstractBuilder:()=>K8e,createAccessorPropertyBackingField:()=>AY,createAccessorPropertyGetRedirector:()=>Eme,createAccessorPropertySetRedirector:()=>xme,createBaseNodeFactory:()=>Jpe,createBinaryExpressionTrampoline:()=>Kj,createBindingHelper:()=>xj,createBuildInfo:()=>UB,createBuilderProgram:()=>pX,createBuilderProgramUsingProgramBuildInfo:()=>lye,createBuilderStatusReporter:()=>lU,createCacheWithRedirects:()=>tK,createCacheableExportInfoMap:()=>sZ,createCachedDirectoryStructureHost:()=>JB,createClassNamedEvaluationHelperBlock:()=>ihe,createClassThisAssignmentBlock:()=>rhe,createClassifier:()=>N7e,createCommentDirectivesMap:()=>A_e,createCompilerDiagnostic:()=>Nc,createCompilerDiagnosticForInvalidCustomType:()=>Vme,createCompilerDiagnosticFromMessageChain:()=>q9,createCompilerHost:()=>Jhe,createCompilerHostFromProgramHost:()=>OX,createCompilerHostWorker:()=>WB,createDetachedDiagnostic:()=>hA,createDiagnosticCollection:()=>WI,createDiagnosticForFileFromMessageChain:()=>pH,createDiagnosticForNode:()=>pn,createDiagnosticForNodeArray:()=>qP,createDiagnosticForNodeArrayFromMessageChain:()=>Z3,createDiagnosticForNodeFromMessageChain:()=>ky,createDiagnosticForNodeInSourceFile:()=>bd,createDiagnosticForRange:()=>U_e,createDiagnosticMessageChainFromDiagnostic:()=>B_e,createDiagnosticReporter:()=>rk,createDocumentPositionMapper:()=>zge,createDocumentRegistry:()=>uve,createDocumentRegistryInternal:()=>_Z,createEmitAndSemanticDiagnosticsBuilderProgram:()=>hX,createEmitHelperFactory:()=>sde,createEmptyExports:()=>m8,createEvaluator:()=>Bpe,createExpressionForJsxElement:()=>ome,createExpressionForJsxFragment:()=>cme,createExpressionForObjectLiteralElementLike:()=>lme,createExpressionForPropertyName:()=>hY,createExpressionFromEntityName:()=>g8,createExternalHelpersImportDeclarationIfNeeded:()=>SY,createFileDiagnostic:()=>bu,createFileDiagnosticFromMessageChain:()=>X5,createFlowNode:()=>Wh,createForOfBindingStatement:()=>gY,createFutureSourceFile:()=>lV,createGetCanonicalFileName:()=>l_,createGetIsolatedDeclarationErrors:()=>Phe,createGetSourceFile:()=>YK,createGetSymbolAccessibilityDiagnosticForNode:()=>Fv,createGetSymbolAccessibilityDiagnosticForNodeName:()=>khe,createGetSymbolWalker:()=>Pge,createIncrementalCompilerHost:()=>cU,createIncrementalProgram:()=>Sye,createJsxFactoryExpression:()=>mY,createLanguageService:()=>V1e,createLanguageServiceSourceFile:()=>kV,createMemberAccessForPropertyName:()=>d2,createModeAwareCache:()=>wN,createModeAwareCacheKey:()=>WO,createModuleNotFoundChain:()=>J5,createModuleResolutionCache:()=>IN,createModuleResolutionLoader:()=>nX,createModuleResolutionLoaderUsingGlobalCache:()=>gye,createModuleSpecifierResolutionHost:()=>ak,createMultiMap:()=>yd,createNameResolver:()=>jG,createNodeConverters:()=>Wpe,createNodeFactory:()=>t8,createOptionNameMap:()=>nB,createOverload:()=>ite,createPackageJsonImportFilter:()=>ZN,createPackageJsonInfo:()=>XQ,createParenthesizerRules:()=>qpe,createPatternMatcher:()=>mve,createPrinter:()=>oS,createPrinterWithDefaults:()=>Lhe,createPrinterWithRemoveComments:()=>v2,createPrinterWithRemoveCommentsNeverAsciiEscape:()=>Fhe,createPrinterWithRemoveCommentsOmitTrailingSemicolon:()=>VB,createProgram:()=>X8,createProgramHost:()=>RX,createPropertyNameNodeForIdentifierOrLiteral:()=>pj,createQueue:()=>p3,createRange:()=>Td,createRedirectedBuilderProgram:()=>gX,createResolutionCache:()=>vX,createRuntimeTypeSerializer:()=>uhe,createScanner:()=>xy,createSemanticDiagnosticsBuilderProgram:()=>Y8e,createSet:()=>RW,createSolutionBuilder:()=>Cye,createSolutionBuilderHost:()=>Eye,createSolutionBuilderWithWatch:()=>Aye,createSolutionBuilderWithWatchHost:()=>xye,createSortedArray:()=>Rx,createSourceFile:()=>HA,createSourceMapGenerator:()=>jge,createSourceMapSource:()=>g4e,createSuperAccessVariableStatement:()=>MB,createSymbolTable:()=>fa,createSymlinkCache:()=>vG,createSyntacticTypeNodeBuilder:()=>Hye,createSystemWatchFunctions:()=>mue,createTextChange:()=>dM,createTextChangeFromStartLength:()=>FU,createTextChangeRange:()=>D3,createTextRangeFromNode:()=>EQ,createTextRangeFromSpan:()=>LU,createTextSpan:()=>zu,createTextSpanFromBounds:()=>Il,createTextSpanFromNode:()=>df,createTextSpanFromRange:()=>lS,createTextSpanFromStringLiteralLikeContent:()=>TQ,createTextWriter:()=>MR,createTokenRange:()=>iG,createTypeChecker:()=>Lge,createTypeReferenceDirectiveResolutionCache:()=>yB,createTypeReferenceResolutionLoader:()=>$B,createWatchCompilerHost:()=>aMe,createWatchCompilerHostOfConfigFile:()=>MX,createWatchCompilerHostOfFilesAndCompilerOptions:()=>LX,createWatchFactory:()=>IX,createWatchHost:()=>wX,createWatchProgram:()=>FX,createWatchStatusReporter:()=>bX,createWriteFileMeasuringIO:()=>KK,declarationNameToString:()=>Yo,decodeMappings:()=>EK,decodedTextSpanIntersectsWith:()=>N3,decorateHelper:()=>ode,deduplicate:()=>I1,defaultIncludeSpec:()=>GY,defaultInitCompilerOptions:()=>jY,defaultMaximumTruncationLength:()=>xI,diagnosticCategoryName:()=>Bx,diagnosticToString:()=>wE,diagnosticsEqualityComparer:()=>W9,directoryProbablyExists:()=>rg,directorySeparator:()=>Ec,displayPart:()=>Jf,displayPartsToString:()=>MM,disposeEmitNodes:()=>VG,disposeResourcesHelper:()=>Ode,documentSpansEqual:()=>RQ,dumpTracingLegend:()=>_le,elementAt:()=>Dl,elideNodes:()=>Tme,emitComments:()=>Mfe,emitDetachedComments:()=>Lfe,emitFiles:()=>JK,emitFilesAndReportErrors:()=>iU,emitFilesAndReportErrorsAndGetExitStatus:()=>DX,emitModuleKindIsNonNodeESM:()=>H9,emitNewLineBeforeLeadingCommentOfPosition:()=>Rfe,emitNewLineBeforeLeadingComments:()=>Ife,emitNewLineBeforeLeadingCommentsOfPosition:()=>Ofe,emitResolverSkipsTypeChecking:()=>VK,emitSkippedWithNoDiagnostics:()=>lX,emptyArray:()=>ve,emptyFileSystemEntries:()=>CG,emptyMap:()=>lr,emptyOptions:()=>am,emptySet:()=>Br,endsWith:()=>Wc,ensurePathIsNonModuleName:()=>Vx,ensureScriptKind:()=>nj,ensureTrailingDirectorySeparator:()=>yu,entityNameToString:()=>op,enumerateInsertsAndDeletes:()=>i5,equalOwnProperties:()=>Uce,equateStringsCaseInsensitive:()=>KS,equateStringsCaseSensitive:()=>Lx,equateValues:()=>gv,esDecorateHelper:()=>ude,escapeJsxAttributeString:()=>qH,escapeLeadingUnderscores:()=>Uc,escapeNonAsciiString:()=>E9,escapeSnippetText:()=>_E,escapeString:()=>Vh,escapeTemplateSubstitution:()=>VH,evaluatorResult:()=>_u,every:()=>wi,executeCommandLine:()=>VMe,expandPreOrPostfixIncrementOrDecrementExpression:()=>zj,explainFiles:()=>CX,explainIfFileIsRedirectAndImpliedFormat:()=>AX,exportAssignmentIsAlias:()=>ZP,exportStarHelper:()=>Pde,expressionResultIsUnused:()=>Ipe,extend:()=>ZF,extendsHelper:()=>yde,extensionFromPath:()=>cO,extensionIsTS:()=>lj,extensionsNotSupportingExtensionlessResolution:()=>oj,externalHelpersModuleNameText:()=>ab,factory:()=>U,fileExtensionIs:()=>Ic,fileExtensionIsOneOf:()=>wl,fileIncludeReasonToDiagnostics:()=>NX,fileShouldUseJavaScriptRequire:()=>iZ,filter:()=>Zn,filterMutate:()=>zw,filterSemanticDiagnostics:()=>KB,find:()=>Ln,findAncestor:()=>Pr,findBestPatternMatch:()=>BW,findChildOfKind:()=>Oo,findComputedPropertyNameCacheAssignment:()=>Xj,findConfigFile:()=>HK,findConstructorDeclaration:()=>e8,findContainingList:()=>PU,findDiagnosticForNode:()=>tve,findFirstNonJsxWhitespaceToken:()=>S0e,findIndex:()=>Bo,findLast:()=>xm,findLastIndex:()=>pv,findListItemInfo:()=>v0e,findMap:()=>Jw,findModifier:()=>YN,findNextToken:()=>NE,findPackageJson:()=>Z0e,findPackageJsons:()=>KQ,findPrecedingMatchingToken:()=>RU,findPrecedingToken:()=>iu,findSuperStatementIndexPath:()=>DB,findTokenOnLeftOfPosition:()=>wU,findUseStrictPrologue:()=>vY,first:()=>Ma,firstDefined:()=>yi,firstDefinedIterator:()=>qo,firstIterator:()=>_3,firstOrOnly:()=>tZ,firstOrUndefined:()=>xo,firstOrUndefinedIterator:()=>Nh,fixupCompilerOptions:()=>bZ,flatMap:()=>va,flatMapIterator:()=>c3,flatMapToMutable:()=>M_,flatten:()=>ef,flattenCommaList:()=>Cme,flattenDestructuringAssignment:()=>y2,flattenDestructuringBinding:()=>CE,flattenDiagnosticMessageText:()=>Zg,forEach:()=>kt,forEachAncestor:()=>b_e,forEachAncestorDirectory:()=>Am,forEachChild:()=>Js,forEachChildRecursively:()=>$A,forEachEmittedFile:()=>FK,forEachEnclosingBlockScopeContainer:()=>L_e,forEachEntry:()=>Nu,forEachExternalModuleToImportFrom:()=>oZ,forEachImportClauseDeclaration:()=>_fe,forEachKey:()=>d0,forEachLeadingCommentRange:()=>x3,forEachNameInAccessChainWalkingLeft:()=>rpe,forEachNameOfDefaultExport:()=>cZ,forEachPropertyAssignment:()=>$P,forEachResolvedProjectReference:()=>sX,forEachReturnStatement:()=>xv,forEachRight:()=>Fi,forEachTrailingCommentRange:()=>C3,forEachTsConfigPropArray:()=>iR,forEachUnique:()=>LQ,forEachYieldExpression:()=>$_e,forSomeAncestorDirectory:()=>Y6e,formatColorAndReset:()=>AE,formatDiagnostic:()=>XK,formatDiagnostics:()=>k8e,formatDiagnosticsWithColorAndContext:()=>$he,formatGeneratedName:()=>xb,formatGeneratedNamePart:()=>kN,formatLocation:()=>QK,formatMessage:()=>vA,formatStringFromArgs:()=>wy,formatting:()=>zl,fullTripleSlashAMDReferencePathRegEx:()=>W_e,fullTripleSlashReferencePathRegEx:()=>z_e,generateDjb2Hash:()=>nI,generateTSConfig:()=>Xme,generatorHelper:()=>Cde,getAdjustedReferenceLocation:()=>dQ,getAdjustedRenameLocation:()=>DU,getAliasDeclarationFromName:()=>DH,getAllAccessorDeclarations:()=>W1,getAllDecoratorsOfClass:()=>PK,getAllDecoratorsOfClassElement:()=>IB,getAllJSDocTags:()=>C5,getAllJSDocTagsOfKind:()=>a6e,getAllKeys:()=>lOe,getAllProjectOutputs:()=>BB,getAllSuperTypeNodes:()=>BI,getAllowJSCompilerOption:()=>H1,getAllowSyntheticDefaultImports:()=>SA,getAncestor:()=>pb,getAnyExtensionFromPath:()=>PP,getAreDeclarationMapsEnabled:()=>$9,getAssignedExpandoInitializer:()=>iA,getAssignedName:()=>E5,getAssignedNameOfIdentifier:()=>t6,getAssignmentDeclarationKind:()=>cl,getAssignmentDeclarationPropertyAccessKind:()=>yR,getAssignmentTargetKind:()=>fb,getAutomaticTypeDirectiveNames:()=>gB,getBaseFileName:()=>Ul,getBinaryOperatorPrecedence:()=>OR,getBuildInfo:()=>qK,getBuildInfoFileVersionMap:()=>mX,getBuildInfoText:()=>Rhe,getBuildOrderFromAnyBuildOrder:()=>tM,getBuilderCreationParameters:()=>QB,getBuilderFileEmit:()=>cS,getCanonicalDiagnostic:()=>V_e,getCheckFlags:()=>ll,getClassExtendsHeritageElement:()=>nE,getClassLikeDeclarationOfSymbol:()=>S0,getCombinedLocalAndExportSymbolFlags:()=>cN,getCombinedModifierFlags:()=>eb,getCombinedNodeFlags:()=>f0,getCombinedNodeFlagsAlwaysIncludeJSDoc:()=>A$,getCommentRange:()=>Wg,getCommonSourceDirectory:()=>s6,getCommonSourceDirectoryOfConfig:()=>tk,getCompilerOptionValue:()=>K9,getCompilerOptionsDiffValue:()=>Kme,getConditions:()=>sS,getConfigFileParsingDiagnostics:()=>kE,getConstantValue:()=>Xpe,getContainerFlags:()=>_K,getContainerNode:()=>b2,getContainingClass:()=>Ou,getContainingClassExcludingClassDecorators:()=>s9,getContainingClassStaticBlock:()=>rfe,getContainingFunction:()=>Dp,getContainingFunctionDeclaration:()=>tfe,getContainingFunctionOrClassStaticBlock:()=>i9,getContainingNodeArray:()=>Ope,getContainingObjectLiteralElement:()=>LM,getContextualTypeFromParent:()=>HU,getContextualTypeFromParentOrAncestorTypeNode:()=>NU,getCurrentTime:()=>eM,getDeclarationDiagnostics:()=>Nhe,getDeclarationEmitExtensionForPath:()=>A9,getDeclarationEmitOutputFilePath:()=>kfe,getDeclarationEmitOutputFilePathWorker:()=>C9,getDeclarationFileExtension:()=>DY,getDeclarationFromName:()=>jI,getDeclarationModifierFlagsFromSymbol:()=>xd,getDeclarationOfKind:()=>Pc,getDeclarationsOfKind:()=>y_e,getDeclaredExpandoInitializer:()=>RI,getDecorators:()=>F1,getDefaultCompilerOptions:()=>AV,getDefaultFormatCodeSettings:()=>vU,getDefaultLibFileName:()=>k3,getDefaultLibFilePath:()=>J1e,getDefaultLikeExportInfo:()=>uV,getDefaultLikeExportNameFromDeclaration:()=>nV,getDiagnosticText:()=>Df,getDiagnosticsWithinSpan:()=>rve,getDirectoryPath:()=>mi,getDirectoryToWatchFailedLookupLocation:()=>yX,getDirectoryToWatchFailedLookupLocationFromTypeRoot:()=>dye,getDocumentPositionMapper:()=>gZ,getDocumentSpansEqualityComparer:()=>MQ,getESModuleInterop:()=>Iy,getEditsForFileRename:()=>fve,getEffectiveBaseTypeNode:()=>Fg,getEffectiveConstraintOfTypeParameter:()=>RP,getEffectiveContainerForJSDocTemplateTag:()=>y9,getEffectiveImplementsTypeNodes:()=>eN,getEffectiveInitializer:()=>dR,getEffectiveJSDocHost:()=>_b,getEffectiveModifierFlags:()=>U_,getEffectiveModifierFlagsAlwaysIncludeJSDoc:()=>Ufe,getEffectiveModifierFlagsNoCache:()=>Vfe,getEffectiveReturnTypeNode:()=>lp,getEffectiveSetAccessorTypeAnnotationNode:()=>wfe,getEffectiveTypeAnnotationNode:()=>Vl,getEffectiveTypeParameterDeclarations:()=>j1,getEffectiveTypeRoots:()=>zO,getElementOrPropertyAccessArgumentExpressionOrName:()=>h9,getElementOrPropertyAccessName:()=>m0,getElementsOfBindingOrAssignmentPattern:()=>AN,getEmitDeclarations:()=>$p,getEmitFlags:()=>Ga,getEmitHelpers:()=>Ej,getEmitModuleDetectionKind:()=>cpe,getEmitModuleKind:()=>V_,getEmitModuleResolutionKind:()=>af,getEmitScriptTarget:()=>Ka,getEmitStandardClassFields:()=>hG,getEnclosingBlockScopeContainer:()=>eg,getEnclosingContainer:()=>K5,getEncodedSemanticClassifications:()=>lZ,getEncodedSyntacticClassifications:()=>uZ,getEndLinePosition:()=>G3,getEntityNameFromTypeNode:()=>oR,getEntrypointsFromPackageJsonInfo:()=>aK,getErrorCountForSummary:()=>rU,getErrorSpanForNode:()=>Yx,getErrorSummaryText:()=>EX,getEscapedTextOfIdentifierOrLiteral:()=>JI,getEscapedTextOfJsxAttributeName:()=>gO,getEscapedTextOfJsxNamespacedName:()=>xA,getExpandoInitializer:()=>lb,getExportAssignmentExpression:()=>wH,getExportInfoMap:()=>PM,getExportNeedsImportStarHelper:()=>Wge,getExpressionAssociativity:()=>jH,getExpressionPrecedence:()=>zI,getExternalHelpersModuleName:()=>Hj,getExternalModuleImportEqualsDeclarationExpression:()=>II,getExternalModuleName:()=>sA,getExternalModuleNameFromDeclaration:()=>Cfe,getExternalModuleNameFromPath:()=>$H,getExternalModuleNameLiteral:()=>WA,getExternalModuleRequireArgument:()=>SH,getFallbackOptions:()=>H8,getFileEmitOutput:()=>Yhe,getFileMatcherPatterns:()=>rj,getFileNamesFromConfigSpecs:()=>JO,getFileWatcherEventKind:()=>_$,getFilesInErrorForSummary:()=>nU,getFirstConstructorWithBody:()=>Ny,getFirstIdentifier:()=>_p,getFirstNonSpaceCharacterPosition:()=>$0e,getFirstProjectOutput:()=>UK,getFixableErrorSpanExpression:()=>ZQ,getFormatCodeSettingsForWriting:()=>oV,getFullWidth:()=>H3,getFunctionFlags:()=>Rl,getHeritageClause:()=>NR,getHostSignatureFromJSDoc:()=>ub,getIdentifierAutoGenerate:()=>v4e,getIdentifierGeneratedImportReference:()=>nde,getIdentifierTypeArguments:()=>i2,getImmediatelyInvokedFunctionExpression:()=>QT,getImpliedNodeFormatForFile:()=>K8,getImpliedNodeFormatForFileWorker:()=>YB,getImportNeedsImportDefaultHelper:()=>CK,getImportNeedsImportStarHelper:()=>PB,getIndentSize:()=>iN,getIndentString:()=>x9,getInferredLibraryNameResolveFrom:()=>GB,getInitializedVariables:()=>ZI,getInitializerOfBinaryExpression:()=>EH,getInitializerOfBindingOrAssignmentElement:()=>v8,getInterfaceBaseTypeNodes:()=>UI,getInternalEmitFlags:()=>Pm,getInvokedExpression:()=>c9,getIsolatedModules:()=>Cd,getJSDocAugmentsTag:()=>que,getJSDocClassTag:()=>N$,getJSDocCommentRanges:()=>mH,getJSDocCommentsAndTags:()=>CH,getJSDocDeprecatedTag:()=>D$,getJSDocDeprecatedTagNoCache:()=>Kue,getJSDocEnumTag:()=>w$,getJSDocHost:()=>tE,getJSDocImplementsTags:()=>zue,getJSDocOverloadTags:()=>kH,getJSDocOverrideTagNoCache:()=>Yue,getJSDocParameterTags:()=>OP,getJSDocParameterTagsNoCache:()=>Bue,getJSDocPrivateTag:()=>t6e,getJSDocPrivateTagNoCache:()=>$ue,getJSDocProtectedTag:()=>r6e,getJSDocProtectedTagNoCache:()=>Hue,getJSDocPublicTag:()=>e6e,getJSDocPublicTagNoCache:()=>Wue,getJSDocReadonlyTag:()=>n6e,getJSDocReadonlyTagNoCache:()=>Gue,getJSDocReturnTag:()=>Xue,getJSDocReturnType:()=>I3,getJSDocRoot:()=>QP,getJSDocSatisfiesExpressionType:()=>MG,getJSDocSatisfiesTag:()=>I$,getJSDocTags:()=>nb,getJSDocTagsNoCache:()=>s6e,getJSDocTemplateTag:()=>i6e,getJSDocThisTag:()=>x5,getJSDocType:()=>rb,getJSDocTypeAliasName:()=>TY,getJSDocTypeAssertionType:()=>FO,getJSDocTypeParameterDeclarations:()=>w9,getJSDocTypeParameterTags:()=>Uue,getJSDocTypeParameterTagsNoCache:()=>Vue,getJSDocTypeTag:()=>tb,getJSXImplicitImportBase:()=>Q9,getJSXRuntimeImport:()=>Z9,getJSXTransformEnabled:()=>X9,getKeyForCompilerOptions:()=>eK,getLanguageVariant:()=>zR,getLastChild:()=>lG,getLeadingCommentRanges:()=>Ty,getLeadingCommentRangesOfNode:()=>dH,getLeftmostAccessExpression:()=>lN,getLeftmostExpression:()=>uN,getLibraryNameFromLibFileName:()=>aX,getLineAndCharacterOfPosition:()=>ba,getLineInfo:()=>TK,getLineOfLocalPosition:()=>$I,getLineOfLocalPositionFromLineMap:()=>r2,getLineStartPositionForPosition:()=>om,getLineStarts:()=>Sy,getLinesBetweenPositionAndNextNonWhitespaceCharacter:()=>Zfe,getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter:()=>Qfe,getLinesBetweenPositions:()=>cI,getLinesBetweenRangeEndAndRangeStart:()=>sG,getLinesBetweenRangeEndPositions:()=>G6e,getLiteralText:()=>P_e,getLocalNameForExternalImport:()=>CN,getLocalSymbolForExportDefault:()=>KI,getLocaleSpecificMessage:()=>Ms,getLocaleTimeString:()=>Z8,getMappedContextSpan:()=>FQ,getMappedDocumentSpan:()=>qU,getMappedLocation:()=>y6,getMatchedFileSpec:()=>kX,getMatchedIncludeSpec:()=>PX,getMeaningFromDeclaration:()=>bU,getMeaningFromLocation:()=>S2,getMembersOfDeclaration:()=>H_e,getModeForFileReference:()=>G8,getModeForResolutionAtIndex:()=>Hhe,getModeForUsageLocation:()=>eX,getModifiedTime:()=>zC,getModifiers:()=>qT,getModuleInstanceState:()=>N0,getModuleNameStringLiteralAt:()=>Q8,getModuleSpecifierEndingPreference:()=>Epe,getModuleSpecifierResolverHost:()=>PQ,getNameForExportedSymbol:()=>rV,getNameFromImportAttribute:()=>hj,getNameFromIndexInfo:()=>F_e,getNameFromPropertyName:()=>gM,getNameOfAccessExpression:()=>_G,getNameOfCompilerOptionValue:()=>$Y,getNameOfDeclaration:()=>Ps,getNameOfExpando:()=>bH,getNameOfJSDocTypedef:()=>jue,getNameOfScriptTarget:()=>Y9,getNameOrArgument:()=>hR,getNameTable:()=>$Z,getNamesForExportedSymbol:()=>nve,getNamespaceDeclarationNode:()=>KP,getNewLineCharacter:()=>wv,getNewLineKind:()=>kM,getNewLineOrDefaultFromHost:()=>Vv,getNewTargetContainer:()=>ife,getNextJSDocCommentLocation:()=>AH,getNodeChildren:()=>pY,getNodeForGeneratedName:()=>b8,getNodeId:()=>yo,getNodeKind:()=>PE,getNodeModifiers:()=>m6,getNodeModulePathParts:()=>dj,getNonAssignedNameOfDeclaration:()=>T5,getNonAssignmentOperatorForCompoundAssignment:()=>QO,getNonAugmentationDeclaration:()=>oH,getNonDecoratorTokenPosOfNode:()=>tH,getNormalizedAbsolutePath:()=>xs,getNormalizedAbsolutePathWithoutRoot:()=>m$,getNormalizedPathComponents:()=>S3,getObjectFlags:()=>Kn,getOperator:()=>UH,getOperatorAssociativity:()=>BH,getOperatorPrecedence:()=>IR,getOptionFromName:()=>UY,getOptionsForLibraryResolution:()=>rK,getOptionsNameMap:()=>NN,getOrCreateEmitNode:()=>f_,getOrCreateExternalHelpersModuleNameIfNeeded:()=>pme,getOrUpdate:()=>dv,getOriginalNode:()=>Bc,getOriginalNodeId:()=>pf,getOriginalSourceFile:()=>F6e,getOutputDeclarationFileName:()=>jN,getOutputDeclarationFileNameWorker:()=>jK,getOutputExtension:()=>jB,getOutputFileNames:()=>C8e,getOutputJSFileNameWorker:()=>BK,getOutputPathsFor:()=>i6,getOutputPathsForBundle:()=>FB,getOwnEmitOutputFilePath:()=>Afe,getOwnKeys:()=>Ng,getOwnValues:()=>UC,getPackageJsonInfo:()=>Db,getPackageJsonTypesVersionsPaths:()=>mB,getPackageJsonsVisibleToFile:()=>eve,getPackageNameFromTypesPackageName:()=>GO,getPackageScopeForPath:()=>HO,getParameterSymbolFromJSDoc:()=>CR,getParameterTypeNode:()=>u4e,getParentNodeInSpan:()=>yM,getParseTreeNode:()=>ks,getParsedCommandLineOfConfigFile:()=>k8,getPathComponents:()=>hu,getPathComponentsRelativeTo:()=>y$,getPathFromPathComponents:()=>u0,getPathUpdater:()=>pZ,getPathsBasePath:()=>k9,getPatternFromSpec:()=>ype,getPendingEmitKind:()=>JN,getPositionOfLineAndCharacter:()=>T3,getPossibleGenericSignatures:()=>gQ,getPossibleOriginalInputExtensionForExtension:()=>Pfe,getPossibleTypeArgumentsInfo:()=>hQ,getPreEmitDiagnostics:()=>A8e,getPrecedingNonSpaceCharacterPosition:()=>WU,getPrivateIdentifier:()=>NK,getProperties:()=>kK,getProperty:()=>QF,getPropertyArrayElementValue:()=>efe,getPropertyAssignmentAliasLikeExpression:()=>yfe,getPropertyNameForPropertyNameNode:()=>e2,getPropertyNameForUniqueESSymbol:()=>M6e,getPropertyNameFromType:()=>rm,getPropertyNameOfBindingOrAssignmentElement:()=>bY,getPropertySymbolFromBindingElement:()=>JU,getPropertySymbolsFromContextualType:()=>PV,getQuoteFromPreference:()=>DQ,getQuotePreference:()=>ed,getRangesWhere:()=>$w,getRefactorContextSpan:()=>ok,getReferencedFileLocation:()=>c6,getRegexFromPattern:()=>G1,getRegularExpressionForWildcard:()=>iO,getRegularExpressionsForWildcards:()=>ej,getRelativePathFromDirectory:()=>Xm,getRelativePathFromFile:()=>aI,getRelativePathToDirectoryOrUrl:()=>WC,getRenameLocation:()=>bM,getReplacementSpanForContextToken:()=>bQ,getResolutionDiagnostic:()=>_X,getResolutionModeOverride:()=>BN,getResolveJsonModule:()=>cE,getResolvePackageJsonExports:()=>mG,getResolvePackageJsonImports:()=>gG,getResolvedExternalModuleName:()=>WH,getRestIndicatorOfBindingOrAssignmentElement:()=>Gj,getRestParameterElementType:()=>gH,getRightMostAssignedExpression:()=>mR,getRootDeclaration:()=>Bg,getRootDirectoryOfResolutionCache:()=>mye,getRootLength:()=>Rh,getRootPathSplitLength:()=>eMe,getScriptKind:()=>JQ,getScriptKindFromFileName:()=>ij,getScriptTargetFeatures:()=>rH,getSelectedEffectiveModifierFlags:()=>fA,getSelectedSyntacticModifierFlags:()=>jfe,getSemanticClassifications:()=>cve,getSemanticJsxChildren:()=>rN,getSetAccessorTypeAnnotationNode:()=>Nfe,getSetAccessorValueParameter:()=>aN,getSetExternalModuleIndicator:()=>WR,getShebang:()=>v5,getSingleInitializerOfVariableStatementOrPropertyDeclaration:()=>xH,getSingleVariableOfVariableStatement:()=>cA,getSnapshotText:()=>sk,getSnippetElement:()=>JG,getSourceFileOfModule:()=>z5,getSourceFileOfNode:()=>Ur,getSourceFilePathInNewDir:()=>N9,getSourceFilePathInNewDirWorker:()=>D9,getSourceFileVersionAsHashFromText:()=>sU,getSourceFilesToEmit:()=>P9,getSourceMapRange:()=>Ov,getSourceMapper:()=>xve,getSourceTextOfNodeFromSourceFile:()=>GT,getSpanOfTokenAtPosition:()=>Bh,getSpellingSuggestion:()=>Fx,getStartPositionOfLine:()=>q1,getStartPositionOfRange:()=>QI,getStartsOnNewLine:()=>yO,getStaticPropertiesAndClassStaticBlock:()=>wB,getStrictOptionValue:()=>J_,getStringComparer:()=>CP,getSubPatternFromSpec:()=>tj,getSuperCallFromStatement:()=>NB,getSuperContainer:()=>sR,getSupportedCodeFixes:()=>zZ,getSupportedExtensions:()=>aO,getSupportedExtensionsWithJsonIfResolveJsonModule:()=>HR,getSwitchedType:()=>HQ,getSymbolId:()=>Aa,getSymbolNameForPrivateIdentifier:()=>DR,getSymbolParentOrFail:()=>iV,getSymbolTarget:()=>qQ,getSyntacticClassifications:()=>lve,getSyntacticModifierFlags:()=>Nv,getSyntacticModifierFlagsNoCache:()=>XH,getSynthesizedDeepClone:()=>Co,getSynthesizedDeepCloneWithReplacements:()=>SM,getSynthesizedDeepClones:()=>DE,getSynthesizedDeepClonesWithReplacements:()=>zQ,getSyntheticLeadingComments:()=>mN,getSyntheticTrailingComments:()=>s8,getTargetLabel:()=>xU,getTargetOfBindingOrAssignmentElement:()=>iS,getTemporaryModuleResolutionState:()=>$O,getTextOfConstantValue:()=>N_e,getTextOfIdentifierOrLiteral:()=>Qd,getTextOfJSDocComment:()=>R3,getTextOfJsxAttributeName:()=>ZR,getTextOfJsxNamespacedName:()=>hO,getTextOfNode:()=>Hc,getTextOfNodeFromSourceText:()=>kI,getTextOfPropertyName:()=>tA,getThisContainer:()=>nf,getThisParameter:()=>iE,getTokenAtPosition:()=>Yi,getTokenPosOfNode:()=>ob,getTokenSourceMapRange:()=>h4e,getTouchingPropertyName:()=>wf,getTouchingToken:()=>HN,getTrailingCommentRanges:()=>L1,getTrailingSemicolonDeferringWriter:()=>zH,getTransformFlagsSubtreeExclusions:()=>Gpe,getTransformers:()=>Ihe,getTsBuildInfoEmitOutputFilePath:()=>jv,getTsConfigObjectLiteralExpression:()=>DI,getTsConfigPropArrayElementValue:()=>n9,getTypeAnnotationNode:()=>Dfe,getTypeArgumentOrTypeParameterList:()=>P0e,getTypeKeywordOfTypeOnlyImport:()=>OQ,getTypeNode:()=>tde,getTypeNodeIfAccessible:()=>E6,getTypeParameterFromJsDoc:()=>ffe,getTypeParameterOwner:()=>KOe,getTypesPackageName:()=>EB,getUILocale:()=>Hce,getUniqueName:()=>E2,getUniqueSymbolId:()=>W0e,getUseDefineForClassFields:()=>$R,getWatchErrorSummaryDiagnosticMessage:()=>TX,getWatchFactory:()=>$K,group:()=>Hw,groupBy:()=>IW,guessIndentation:()=>g_e,handleNoEmitOptions:()=>uX,handleWatchOptionsConfigDirTemplateSubstitution:()=>uB,hasAbstractModifier:()=>oE,hasAccessorModifier:()=>Ug,hasAmbientModifier:()=>KH,hasChangesInResolutions:()=>Q$,hasChildOfKind:()=>_M,hasContextSensitiveParameters:()=>fj,hasDecorators:()=>Wp,hasDocComment:()=>A0e,hasDynamicName:()=>h0,hasEffectiveModifier:()=>up,hasEffectiveModifiers:()=>YH,hasEffectiveReadonlyModifier:()=>HI,hasExtension:()=>kP,hasIndexSignature:()=>$Q,hasInferredType:()=>Vpe,hasInitializer:()=>bv,hasInvalidEscape:()=>JH,hasJSDocNodes:()=>Pp,hasJSDocParameterTags:()=>Jue,hasJSFileExtension:()=>Oy,hasJsonModuleEmitEnabled:()=>G9,hasOnlyExpressionInitializer:()=>Hx,hasOverrideModifier:()=>I9,hasPossibleExternalModuleReference:()=>M_e,hasProperty:()=>Ho,hasPropertyAccessExpressionWithName:()=>aM,hasQuestionToken:()=>oA,hasRecordedExternalHelpers:()=>fme,hasResolutionModeOverride:()=>jpe,hasRestParameter:()=>G$,hasScopeMarker:()=>c_e,hasStaticModifier:()=>Jl,hasSyntacticModifier:()=>li,hasSyntacticModifiers:()=>Ffe,hasTSFileExtension:()=>TA,hasTabstop:()=>Mpe,hasTrailingDirectorySeparator:()=>hv,hasType:()=>F5,hasTypeArguments:()=>D6e,hasZeroOrOneAsteriskCharacter:()=>yG,helperString:()=>WG,hostGetCanonicalFileName:()=>Pv,hostUsesCaseSensitiveFileNames:()=>sN,idText:()=>Nn,identifierIsThisKeyword:()=>GH,identifierToKeywordKind:()=>Jx,identity:()=>ec,identitySourceMapConsumer:()=>xK,ignoreSourceNewlines:()=>zG,ignoredPaths:()=>_5,importDefaultHelper:()=>kde,importFromModuleSpecifier:()=>LI,importStarHelper:()=>$G,indexOfAnyCharCode:()=>qw,indexOfNode:()=>JP,indicesOf:()=>Ox,inferredTypesContainingFile:()=>o6,injectClassNamedEvaluationHelperBlockIfMissing:()=>RB,injectClassThisAssignmentIfMissing:()=>nhe,insertImports:()=>IQ,insertLeadingStatement:()=>R4e,insertSorted:()=>l0,insertStatementAfterCustomPrologue:()=>Gx,insertStatementAfterStandardPrologue:()=>b6e,insertStatementsAfterCustomPrologue:()=>Z$,insertStatementsAfterStandardPrologue:()=>Ay,intersperse:()=>bf,intrinsicTagNameToString:()=>LG,introducesArgumentsExoticObject:()=>X_e,inverseJsxOptionMap:()=>C8,isAbstractConstructorSymbol:()=>epe,isAbstractModifier:()=>Bde,isAccessExpression:()=>oc,isAccessibilityModifier:()=>vQ,isAccessor:()=>U1,isAccessorModifier:()=>Vde,isAliasSymbolDeclaration:()=>I6e,isAliasableExpression:()=>PR,isAmbientModule:()=>B_,isAmbientPropertyDeclaration:()=>lH,isAnonymousFunctionDefinition:()=>qI,isAnyDirectorySeparator:()=>f$,isAnyImportOrBareOrAccessedRequire:()=>O_e,isAnyImportOrReExport:()=>X3,isAnyImportOrRequireStatement:()=>R_e,isAnyImportSyntax:()=>eA,isAnySupportedFileExtension:()=>c4e,isApplicableVersionedTypesKey:()=>R8,isArgumentExpressionOfElementAccess:()=>cQ,isArray:()=>Rs,isArrayBindingElement:()=>w5,isArrayBindingOrAssignmentElement:()=>V3,isArrayBindingOrAssignmentPattern:()=>J$,isArrayBindingPattern:()=>Lv,isArrayLiteralExpression:()=>Gu,isArrayLiteralOrObjectLiteralDestructuringPattern:()=>Uv,isArrayTypeNode:()=>_8,isArrowFunction:()=>pc,isAsExpression:()=>CO,isAssertClause:()=>Hde,isAssertEntry:()=>A4e,isAssertionExpression:()=>sb,isAssertsKeyword:()=>Fde,isAssignmentDeclaration:()=>OI,isAssignmentExpression:()=>Su,isAssignmentOperator:()=>y0,isAssignmentPattern:()=>TI,isAssignmentTarget:()=>kv,isAsteriskToken:()=>c8,isAsyncFunction:()=>VI,isAsyncModifier:()=>TO,isAutoAccessorPropertyDeclaration:()=>Ef,isAwaitExpression:()=>eS,isAwaitKeyword:()=>XG,isBigIntLiteral:()=>o8,isBinaryExpression:()=>Pn,isBinaryOperatorToken:()=>bme,isBindableObjectDefinePropertyCall:()=>Qx,isBindableStaticAccessExpression:()=>eE,isBindableStaticElementAccessExpression:()=>g9,isBindableStaticNameExpression:()=>Zx,isBindingElement:()=>Xa,isBindingElementOfBareOrAccessedRequire:()=>ofe,isBindingName:()=>Wx,isBindingOrAssignmentElement:()=>n_e,isBindingOrAssignmentPattern:()=>B3,isBindingPattern:()=>Hs,isBlock:()=>Vs,isBlockLike:()=>tD,isBlockOrCatchScoped:()=>nH,isBlockScope:()=>uH,isBlockScopedContainerTopLevel:()=>I_e,isBooleanLiteral:()=>bI,isBreakOrContinueStatement:()=>gI,isBreakStatement:()=>E4e,isBuild:()=>Vye,isBuildInfoFile:()=>Ohe,isBuilderProgram:()=>yye,isBundle:()=>Kde,isCallChain:()=>qx,isCallExpression:()=>ea,isCallExpressionTarget:()=>rQ,isCallLikeExpression:()=>HT,isCallLikeOrFunctionLikeExpression:()=>q$,isCallOrNewExpression:()=>Ig,isCallOrNewExpressionTarget:()=>nQ,isCallSignatureDeclaration:()=>MA,isCallToHelper:()=>bO,isCaseBlock:()=>DO,isCaseClause:()=>SN,isCaseKeyword:()=>Jde,isCaseOrDefaultClause:()=>M5,isCatchClause:()=>bE,isCatchClauseVariableDeclaration:()=>Rpe,isCatchClauseVariableDeclarationOrBindingElement:()=>iH,isCheckJsEnabledForFile:()=>lO,isChildOfNodeWithKind:()=>E6e,isCircularBuildOrder:()=>nk,isClassDeclaration:()=>tu,isClassElement:()=>uu,isClassExpression:()=>eu,isClassInstanceProperty:()=>t_e,isClassLike:()=>gi,isClassMemberModifier:()=>B$,isClassNamedEvaluationHelperBlock:()=>ek,isClassOrTypeElement:()=>D5,isClassStaticBlockDeclaration:()=>Gc,isClassThisAssignmentBlock:()=>e6,isCollapsedRange:()=>H6e,isColonToken:()=>Mde,isCommaExpression:()=>h8,isCommaListExpression:()=>kO,isCommaSequence:()=>LO,isCommaToken:()=>Rde,isComment:()=>MU,isCommonJsExportPropertyAssignment:()=>t9,isCommonJsExportedExpression:()=>Y_e,isCompoundAssignment:()=>XO,isComputedNonLiteralName:()=>Q3,isComputedPropertyName:()=>za,isConciseBody:()=>O5,isConditionalExpression:()=>UA,isConditionalTypeNode:()=>dE,isConstAssertion:()=>FG,isConstTypeReference:()=>Qm,isConstructSignatureDeclaration:()=>u8,isConstructorDeclaration:()=>Vc,isConstructorTypeNode:()=>gN,isContextualKeyword:()=>S9,isContinueStatement:()=>T4e,isCustomPrologue:()=>nR,isDebuggerStatement:()=>x4e,isDeclaration:()=>u_,isDeclarationBindingElement:()=>j3,isDeclarationFileName:()=>Mu,isDeclarationName:()=>Uh,isDeclarationNameOfEnumOrNamespace:()=>aG,isDeclarationReadonly:()=>eR,isDeclarationStatement:()=>f_e,isDeclarationWithTypeParameterChildren:()=>fH,isDeclarationWithTypeParameters:()=>_H,isDecorator:()=>fu,isDecoratorTarget:()=>p0e,isDefaultClause:()=>IO,isDefaultImport:()=>aA,isDefaultModifier:()=>Dj,isDefaultedExpandoInitializer:()=>cfe,isDeleteExpression:()=>zde,isDeleteTarget:()=>NH,isDeprecatedDeclaration:()=>sV,isDestructuringAssignment:()=>Dv,isDiagnosticWithLocation:()=>QQ,isDiskPathRoot:()=>p$,isDoStatement:()=>b4e,isDocumentRegistryEntry:()=>NM,isDotDotDotToken:()=>Pj,isDottedName:()=>BR,isDynamicName:()=>T9,isESSymbolIdentifier:()=>L6e,isEffectiveExternalModule:()=>ZC,isEffectiveModuleDeclaration:()=>w_e,isEffectiveStrictModeSourceFile:()=>cH,isElementAccessChain:()=>O$,isElementAccessExpression:()=>cc,isEmittedFileOfProgram:()=>Bhe,isEmptyArrayLiteral:()=>Wfe,isEmptyBindingElement:()=>Mue,isEmptyBindingPattern:()=>Rue,isEmptyObjectLiteral:()=>rG,isEmptyStatement:()=>tY,isEmptyStringLiteral:()=>vH,isEntityName:()=>Tf,isEntityNameExpression:()=>nc,isEnumConst:()=>KT,isEnumDeclaration:()=>bb,isEnumMember:()=>nS,isEqualityOperatorKind:()=>GU,isEqualsGreaterThanToken:()=>Lde,isExclamationToken:()=>l8,isExcludedFile:()=>Zme,isExclusivelyTypeOnlyImportOrExport:()=>ZK,isExpandoPropertyDeclaration:()=>CA,isExportAssignment:()=>dc,isExportDeclaration:()=>xl,isExportModifier:()=>OA,isExportName:()=>Wj,isExportNamespaceAsDefaultDeclaration:()=>H5,isExportOrDefaultModifier:()=>S8,isExportSpecifier:()=>b_,isExportsIdentifier:()=>Xx,isExportsOrModuleExportsOrAlias:()=>EE,isExpression:()=>Ct,isExpressionNode:()=>tg,isExpressionOfExternalModuleImportEqualsDeclaration:()=>h0e,isExpressionOfOptionalChainRoot:()=>k5,isExpressionStatement:()=>Du,isExpressionWithTypeArguments:()=>x0,isExpressionWithTypeArgumentsInClassExtendsClause:()=>O9,isExternalModule:()=>nu,isExternalModuleAugmentation:()=>YT,isExternalModuleImportEqualsDeclaration:()=>cb,isExternalModuleIndicator:()=>q3,isExternalModuleNameRelative:()=>vu,isExternalModuleReference:()=>C0,isExternalModuleSymbol:()=>BP,isExternalOrCommonJsModule:()=>Uf,isFileLevelReservedGeneratedIdentifier:()=>F3,isFileLevelUniqueName:()=>W5,isFileProbablyExternalModule:()=>E8,isFirstDeclarationOfSymbolParameter:()=>jQ,isFixablePromiseHandler:()=>vZ,isForInOrOfStatement:()=>$x,isForInStatement:()=>Fj,isForInitializer:()=>Sd,isForOfStatement:()=>f8,isForStatement:()=>Sb,isFullSourceFile:()=>Av,isFunctionBlock:()=>XT,isFunctionBody:()=>W$,isFunctionDeclaration:()=>Tl,isFunctionExpression:()=>ic,isFunctionExpressionOrArrowFunction:()=>K1,isFunctionLike:()=>Bs,isFunctionLikeDeclaration:()=>Go,isFunctionLikeKind:()=>YC,isFunctionLikeOrClassStaticBlockDeclaration:()=>LP,isFunctionOrConstructorTypeNode:()=>r_e,isFunctionOrModuleBlock:()=>U$,isFunctionSymbol:()=>ufe,isFunctionTypeNode:()=>Jh,isFutureReservedKeyword:()=>O6e,isGeneratedIdentifier:()=>xc,isGeneratedPrivateIdentifier:()=>zx,isGetAccessor:()=>Sv,isGetAccessorDeclaration:()=>Hp,isGetOrSetAccessorDeclaration:()=>M3,isGlobalDeclaration:()=>A7e,isGlobalScopeAugmentation:()=>Rg,isGlobalSourceFile:()=>Tv,isGrammarError:()=>C_e,isHeritageClause:()=>pp,isHoistedFunction:()=>Z5,isHoistedVariableStatement:()=>e9,isIdentifier:()=>He,isIdentifierANonContextualKeyword:()=>RH,isIdentifierName:()=>hfe,isIdentifierOrThisTypeNode:()=>hme,isIdentifierPart:()=>yv,isIdentifierStart:()=>Ey,isIdentifierText:()=>sp,isIdentifierTypePredicate:()=>Q_e,isIdentifierTypeReference:()=>Npe,isIfStatement:()=>vb,isIgnoredFileFromWildCardWatching:()=>$8,isImplicitGlob:()=>bG,isImportAttribute:()=>Gde,isImportAttributeName:()=>e_e,isImportAttributes:()=>l2,isImportCall:()=>Np,isImportClause:()=>ig,isImportDeclaration:()=>Yc,isImportEqualsDeclaration:()=>ru,isImportKeyword:()=>xO,isImportMeta:()=>WP,isImportOrExportSpecifier:()=>GC,isImportOrExportSpecifierName:()=>z0e,isImportSpecifier:()=>_f,isImportTypeAssertionContainer:()=>C4e,isImportTypeNode:()=>qh,isImportableFile:()=>aZ,isInComment:()=>Bv,isInCompoundLikeAssignment:()=>PH,isInExpressionContext:()=>l9,isInJSDoc:()=>uR,isInJSFile:()=>hn,isInJSXText:()=>x0e,isInJsonFile:()=>_9,isInNonReferenceComment:()=>w0e,isInReferenceComment:()=>D0e,isInRightSideOfInternalImportEqualsDeclaration:()=>TU,isInString:()=>ik,isInTemplateString:()=>mQ,isInTopLevelContext:()=>a9,isInTypeQuery:()=>_A,isIncrementalCompilation:()=>nO,isIndexSignatureDeclaration:()=>fE,isIndexedAccessTypeNode:()=>mE,isInferTypeNode:()=>s2,isInfinityOrNaNString:()=>dO,isInitializedProperty:()=>B8,isInitializedVariable:()=>qR,isInsideJsxElement:()=>OU,isInsideJsxElementOrAttribute:()=>E0e,isInsideNodeModules:()=>CM,isInsideTemplateLiteral:()=>pM,isInstanceOfExpression:()=>R9,isInstantiatedModule:()=>hK,isInterfaceDeclaration:()=>Yu,isInternalDeclaration:()=>h_e,isInternalModuleImportEqualsDeclaration:()=>nA,isInternalName:()=>yY,isIntersectionTypeNode:()=>jA,isIntrinsicJsxName:()=>nN,isIterationStatement:()=>V1,isJSDoc:()=>ag,isJSDocAllType:()=>Zde,isJSDocAugmentsTag:()=>zA,isJSDocAuthorTag:()=>D4e,isJSDocCallbackTag:()=>aY,isJSDocClassTag:()=>tme,isJSDocCommentContainingNode:()=>L5,isJSDocConstructSignature:()=>XP,isJSDocDeprecatedTag:()=>_Y,isJSDocEnumTag:()=>d8,isJSDocFunctionType:()=>TN,isJSDocImplementsTag:()=>Jj,isJSDocImportTag:()=>Xg,isJSDocIndexSignature:()=>p9,isJSDocLikeText:()=>kY,isJSDocLink:()=>Xde,isJSDocLinkCode:()=>Qde,isJSDocLinkLike:()=>QC,isJSDocLinkPlain:()=>P4e,isJSDocMemberName:()=>Eb,isJSDocNameReference:()=>OO,isJSDocNamepathType:()=>N4e,isJSDocNamespaceBody:()=>d6e,isJSDocNode:()=>FP,isJSDocNonNullableType:()=>jj,isJSDocNullableType:()=>bN,isJSDocOptionalParameter:()=>mj,isJSDocOptionalType:()=>sY,isJSDocOverloadTag:()=>EN,isJSDocOverrideTag:()=>Uj,isJSDocParameterTag:()=>Pd,isJSDocPrivateTag:()=>cY,isJSDocPropertyLikeTag:()=>hI,isJSDocPropertyTag:()=>rme,isJSDocProtectedTag:()=>lY,isJSDocPublicTag:()=>oY,isJSDocReadonlyTag:()=>uY,isJSDocReturnTag:()=>Vj,isJSDocSatisfiesExpression:()=>RG,isJSDocSatisfiesTag:()=>qj,isJSDocSeeTag:()=>w4e,isJSDocSignature:()=>A0,isJSDocTag:()=>jP,isJSDocTemplateTag:()=>sm,isJSDocThisTag:()=>fY,isJSDocThrowsTag:()=>O4e,isJSDocTypeAlias:()=>Xd,isJSDocTypeAssertion:()=>m2,isJSDocTypeExpression:()=>Tb,isJSDocTypeLiteral:()=>f2,isJSDocTypeTag:()=>RO,isJSDocTypedefTag:()=>p2,isJSDocUnknownTag:()=>I4e,isJSDocUnknownType:()=>eme,isJSDocVariadicType:()=>Bj,isJSXTagName:()=>GP,isJsonEqual:()=>uj,isJsonSourceFile:()=>Kd,isJsxAttribute:()=>Kg,isJsxAttributeLike:()=>R5,isJsxAttributeName:()=>Fpe,isJsxAttributes:()=>SE,isJsxChild:()=>$3,isJsxClosingElement:()=>yE,isJsxClosingFragment:()=>Yde,isJsxElement:()=>Ly,isJsxExpression:()=>wO,isJsxFragment:()=>vE,isJsxNamespacedName:()=>sg,isJsxOpeningElement:()=>Yg,isJsxOpeningFragment:()=>_2,isJsxOpeningLikeElement:()=>__,isJsxOpeningLikeElementTagName:()=>d0e,isJsxSelfClosingElement:()=>u2,isJsxSpreadAttribute:()=>qA,isJsxTagNameExpression:()=>EI,isJsxText:()=>DA,isJumpStatementTarget:()=>oM,isKeyword:()=>sf,isKeywordOrPunctuation:()=>v9,isKnownSymbol:()=>wR,isLabelName:()=>aQ,isLabelOfLabeledStatement:()=>sQ,isLabeledStatement:()=>rS,isLateVisibilityPaintedStatement:()=>Y5,isLeftHandSideExpression:()=>xf,isLeftHandSideOfAssignment:()=>$6e,isLet:()=>Q5,isLineBreak:()=>v_,isLiteralComputedPropertyDeclarationName:()=>kR,isLiteralExpression:()=>WT,isLiteralExpressionOfObject:()=>F$,isLiteralImportTypeNode:()=>Ev,isLiteralKind:()=>yI,isLiteralLikeAccess:()=>m9,isLiteralLikeElementAccess:()=>gR,isLiteralNameOfPropertyDeclarationOrIndexAccess:()=>CU,isLiteralTypeLikeExpression:()=>B4e,isLiteralTypeLiteral:()=>a_e,isLiteralTypeNode:()=>Mv,isLocalName:()=>k0,isLogicalOperator:()=>Jfe,isLogicalOrCoalescingAssignmentExpression:()=>QH,isLogicalOrCoalescingAssignmentOperator:()=>GI,isLogicalOrCoalescingBinaryExpression:()=>jR,isLogicalOrCoalescingBinaryOperator:()=>FR,isMappedTypeNode:()=>o2,isMemberName:()=>Cy,isMetaProperty:()=>AO,isMethodDeclaration:()=>ul,isMethodOrAccessor:()=>KC,isMethodSignature:()=>$g,isMinusToken:()=>KG,isMissingDeclaration:()=>k4e,isMissingPackageJsonInfo:()=>_ge,isModifier:()=>Pa,isModifierKind:()=>vv,isModifierLike:()=>Cc,isModuleAugmentationExternal:()=>aH,isModuleBlock:()=>Hg,isModuleBody:()=>l_e,isModuleDeclaration:()=>El,isModuleExportsAccessExpression:()=>Py,isModuleIdentifier:()=>TH,isModuleName:()=>Sme,isModuleOrEnumDeclaration:()=>z3,isModuleReference:()=>d_e,isModuleSpecifierLike:()=>VU,isModuleWithStringLiteralName:()=>G5,isNameOfFunctionDeclaration:()=>uQ,isNameOfModuleDeclaration:()=>lQ,isNamedClassElement:()=>l6e,isNamedDeclaration:()=>Wu,isNamedEvaluation:()=>cp,isNamedEvaluationSource:()=>MH,isNamedExportBindings:()=>M$,isNamedExports:()=>kd,isNamedImportBindings:()=>$$,isNamedImports:()=>Gg,isNamedImportsOrExports:()=>V9,isNamedTupleMember:()=>hN,isNamespaceBody:()=>p6e,isNamespaceExport:()=>zh,isNamespaceExportDeclaration:()=>p8,isNamespaceImport:()=>My,isNamespaceReexportDeclaration:()=>afe,isNewExpression:()=>gE,isNewExpressionTarget:()=>p6,isNoSubstitutionTemplateLiteral:()=>wA,isNode:()=>o6e,isNodeArray:()=>zT,isNodeArrayMultiLine:()=>Xfe,isNodeDescendantOf:()=>rE,isNodeKind:()=>L3,isNodeLikeSystem:()=>JW,isNodeModulesDirectory:()=>d5,isNodeWithPossibleHoistedDeclaration:()=>mfe,isNonContextualKeyword:()=>OH,isNonExportDefaultModifier:()=>V4e,isNonGlobalAmbientModule:()=>sH,isNonGlobalDeclaration:()=>sve,isNonNullAccess:()=>Lpe,isNonNullChain:()=>P5,isNonNullExpression:()=>VA,isNonStaticMethodOrAccessorWithPrivateName:()=>Hge,isNotEmittedOrPartiallyEmittedNode:()=>f6e,isNotEmittedStatement:()=>iY,isNullishCoalesce:()=>R$,isNumber:()=>O1,isNumericLiteral:()=>Pf,isNumericLiteralName:()=>Ry,isObjectBindingElementWithoutPropertyName:()=>hM,isObjectBindingOrAssignmentElement:()=>U3,isObjectBindingOrAssignmentPattern:()=>V$,isObjectBindingPattern:()=>Yp,isObjectLiteralElement:()=>H$,isObjectLiteralElementLike:()=>p0,isObjectLiteralExpression:()=>Ca,isObjectLiteralMethod:()=>Nm,isObjectLiteralOrClassExpressionMethodOrAccessor:()=>r9,isObjectTypeDeclaration:()=>gA,isOctalDigit:()=>y5,isOmittedExpression:()=>pu,isOptionalChain:()=>S_,isOptionalChainRoot:()=>dI,isOptionalDeclaration:()=>dN,isOptionalJSDocPropertyLikeTag:()=>QR,isOptionalTypeNode:()=>wj,isOuterExpression:()=>$j,isOutermostOptionalChain:()=>mI,isOverrideModifier:()=>Ude,isPackageJsonInfo:()=>hB,isPackedArrayLiteral:()=>IG,isParameter:()=>ns,isParameterPropertyDeclaration:()=>ap,isParameterPropertyModifier:()=>SI,isParenthesizedExpression:()=>uf,isParenthesizedTypeNode:()=>a2,isParseTreeNode:()=>pI,isPartOfParameterDeclaration:()=>db,isPartOfTypeNode:()=>Lg,isPartOfTypeQuery:()=>u9,isPartiallyEmittedExpression:()=>Lj,isPatternMatch:()=>t5,isPinnedComment:()=>$5,isPlainJsFile:()=>AI,isPlusToken:()=>YG,isPossiblyTypeArgumentPosition:()=>fM,isPostfixUnaryExpression:()=>eY,isPrefixUnaryExpression:()=>tS,isPrimitiveLiteralValue:()=>yj,isPrivateIdentifier:()=>Zi,isPrivateIdentifierClassElementDeclaration:()=>j_,isPrivateIdentifierPropertyAccessExpression:()=>MP,isPrivateIdentifierSymbol:()=>Sfe,isProgramBundleEmitBuildInfo:()=>nye,isProgramUptoDate:()=>oX,isPrologueDirective:()=>Mg,isPropertyAccessChain:()=>A5,isPropertyAccessEntityNameExpression:()=>UR,isPropertyAccessExpression:()=>Wn,isPropertyAccessOrQualifiedName:()=>J3,isPropertyAccessOrQualifiedNameOrImportTypeNode:()=>i_e,isPropertyAssignment:()=>ql,isPropertyDeclaration:()=>Ns,isPropertyName:()=>Ol,isPropertyNameLiteral:()=>jg,isPropertySignature:()=>Nf,isProtoSetter:()=>bfe,isPrototypeAccess:()=>$1,isPrototypePropertyAssignment:()=>vR,isPunctuation:()=>IH,isPushOrUnshiftIdentifier:()=>LH,isQualifiedName:()=>cf,isQuestionDotToken:()=>Nj,isQuestionOrExclamationToken:()=>gme,isQuestionOrPlusOrMinusToken:()=>vme,isQuestionToken:()=>Q1,isRawSourceMap:()=>Vge,isReadonlyKeyword:()=>jde,isReadonlyKeywordOrPlusOrMinusToken:()=>yme,isRecognizedTripleSlashComment:()=>eH,isReferenceFileLocation:()=>UN,isReferencedFile:()=>Ib,isRegularExpressionLiteral:()=>HG,isRequireCall:()=>kf,isRequireVariableStatement:()=>fR,isRestParameter:()=>Fh,isRestTypeNode:()=>Ij,isReturnStatement:()=>nm,isReturnStatementWithFixablePromiseHandler:()=>fV,isRightSideOfAccessExpression:()=>tG,isRightSideOfInstanceofExpression:()=>zfe,isRightSideOfPropertyAccess:()=>WN,isRightSideOfQualifiedName:()=>g0e,isRightSideOfQualifiedNameOrPropertyAccess:()=>YI,isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName:()=>qfe,isRootedDiskPath:()=>ip,isSameEntityName:()=>YP,isSatisfiesExpression:()=>Mj,isScopeMarker:()=>o_e,isSemicolonClassElement:()=>Wde,isSetAccessor:()=>Og,isSetAccessorDeclaration:()=>fp,isShebangTrivia:()=>T$,isShiftOperatorOrHigher:()=>xY,isShorthandAmbientModuleSymbol:()=>K3,isShorthandPropertyAssignment:()=>p_,isSignedNumericLiteral:()=>b9,isSimpleCopiableExpression:()=>xE,isSimpleInlineableExpression:()=>Qg,isSimpleParameter:()=>Qge,isSimpleParameterList:()=>U8,isSingleOrDoubleQuote:()=>pR,isSourceFile:()=>Ji,isSourceFileFromLibrary:()=>eD,isSourceFileJS:()=>Af,isSourceFileNotJS:()=>C6e,isSourceFileNotJson:()=>f9,isSourceMapping:()=>qge,isSpecialPropertyDeclaration:()=>lfe,isSpreadAssignment:()=>Fy,isSpreadElement:()=>Ad,isStatement:()=>Vi,isStatementButNotDeclaration:()=>W3,isStatementOrBlock:()=>p_e,isStatementWithLocals:()=>x_e,isStatic:()=>oa,isStaticModifier:()=>RA,isString:()=>bs,isStringAKeyword:()=>R6e,isStringANonContextualKeyword:()=>uA,isStringAndEmptyAnonymousObjectIntersection:()=>N0e,isStringDoubleQuoted:()=>d9,isStringLiteral:()=>La,isStringLiteralLike:()=>No,isStringLiteralOrJsxExpression:()=>m_e,isStringLiteralOrTemplate:()=>K0e,isStringOrNumericLiteralLike:()=>zp,isStringOrRegularExpressionOrTemplateLiteral:()=>yQ,isStringTextContainingNode:()=>j$,isSuperCall:()=>Kx,isSuperKeyword:()=>EO,isSuperOrSuperProperty:()=>x6e,isSuperProperty:()=>Cf,isSupportedSourceFileName:()=>xpe,isSwitchStatement:()=>NO,isSyntaxList:()=>xN,isSyntheticExpression:()=>S4e,isSyntheticReference:()=>JA,isTagName:()=>oQ,isTaggedTemplateExpression:()=>hE,isTaggedTemplateTag:()=>f0e,isTemplateExpression:()=>Oj,isTemplateHead:()=>IA,isTemplateLiteral:()=>XC,isTemplateLiteralKind:()=>B1,isTemplateLiteralToken:()=>Que,isTemplateLiteralTypeNode:()=>qde,isTemplateLiteralTypeSpan:()=>QG,isTemplateMiddle:()=>GG,isTemplateMiddleOrTemplateTail:()=>N5,isTemplateSpan:()=>PO,isTemplateTail:()=>kj,isTextWhiteSpaceLike:()=>M0e,isThis:()=>$N,isThisContainerOrFunctionBlock:()=>nfe,isThisIdentifier:()=>z1,isThisInTypeQuery:()=>aE,isThisInitializedDeclaration:()=>o9,isThisInitializedObjectBindingExpression:()=>sfe,isThisProperty:()=>aR,isThisTypeNode:()=>yN,isThisTypeParameter:()=>mO,isThisTypePredicate:()=>Z_e,isThrowStatement:()=>nY,isToken:()=>HC,isTokenKind:()=>L$,isTraceEnabled:()=>P0,isTransientSymbol:()=>jh,isTrivia:()=>tN,isTryStatement:()=>c2,isTupleTypeNode:()=>FA,isTypeAlias:()=>TR,isTypeAliasDeclaration:()=>im,isTypeAssertionExpression:()=>ZG,isTypeDeclaration:()=>EA,isTypeElement:()=>$T,isTypeKeyword:()=>g6,isTypeKeywordToken:()=>CQ,isTypeKeywordTokenOrIdentifier:()=>jU,isTypeLiteralNode:()=>lf,isTypeNode:()=>Di,isTypeNodeKind:()=>uG,isTypeOfExpression:()=>vN,isTypeOnlyExportDeclaration:()=>Zue,isTypeOnlyImportDeclaration:()=>vI,isTypeOnlyImportOrExportDeclaration:()=>ib,isTypeOperatorNode:()=>yb,isTypeParameterDeclaration:()=>Ac,isTypePredicateNode:()=>LA,isTypeQueryNode:()=>pE,isTypeReferenceNode:()=>Gp,isTypeReferenceType:()=>j5,isTypeUsableAsPropertyName:()=>tm,isUMDExportSymbol:()=>U9,isUnaryExpression:()=>z$,isUnaryExpressionWithWrite:()=>s_e,isUnicodeIdentifierStart:()=>g5,isUnionTypeNode:()=>Z1,isUrl:()=>hue,isValidBigIntString:()=>_j,isValidESSymbolDeclaration:()=>K_e,isValidTypeOnlyAliasUseSite:()=>gb,isValueSignatureDeclaration:()=>lA,isVarAwaitUsing:()=>tR,isVarConst:()=>zP,isVarConstLike:()=>q_e,isVarUsing:()=>rR,isVariableDeclaration:()=>Ei,isVariableDeclarationInVariableStatement:()=>NI,isVariableDeclarationInitializedToBareOrAccessedRequire:()=>ZT,isVariableDeclarationInitializedToRequire:()=>_R,isVariableDeclarationList:()=>Ru,isVariableLike:()=>rA,isVariableLikeOrAccessor:()=>G_e,isVariableStatement:()=>_l,isVoidExpression:()=>BA,isWatchSet:()=>oG,isWhileStatement:()=>rY,isWhiteSpaceLike:()=>by,isWhiteSpaceSingleLine:()=>wg,isWithStatement:()=>$de,isWriteAccess:()=>mA,isWriteOnlyAccess:()=>B9,isYieldExpression:()=>Rj,jsxModeNeedsExplicitImport:()=>nZ,keywordPart:()=>mp,last:()=>Va,lastOrUndefined:()=>vc,length:()=>wt,libMap:()=>OY,libs:()=>eB,lineBreakPart:()=>XN,linkNamePart:()=>J0e,linkPart:()=>UQ,linkTextPart:()=>zU,listFiles:()=>xX,loadModuleFromGlobalCache:()=>Ege,loadWithModeAwareCache:()=>Y8,makeIdentifierFromModuleName:()=>D_e,makeImport:()=>uS,makeStringLiteral:()=>h6,mangleScopedPackageName:()=>RN,map:()=>Cr,mapAllOrFail:()=>Ww,mapDefined:()=>Gi,mapDefinedEntries:()=>l3,mapDefinedIterator:()=>Up,mapEntries:()=>u3,mapIterator:()=>Ix,mapOneOrMany:()=>eZ,mapToDisplayParts:()=>_S,matchFiles:()=>TG,matchPatternOrExact:()=>AG,matchedText:()=>Qce,matchesExclude:()=>pB,maybeBind:()=>ia,maybeSetLocalizedDiagnosticMessages:()=>ape,memoize:()=>tf,memoizeCached:()=>fOe,memoizeOne:()=>Ih,memoizeWeak:()=>_Oe,metadataHelper:()=>cde,min:()=>MW,minAndMax:()=>kpe,missingFileModifiedTime:()=>np,modifierToFlag:()=>pA,modifiersToFlags:()=>Vg,moduleOptionDeclaration:()=>wme,moduleResolutionIsEqualTo:()=>T_e,moduleResolutionNameAndModeGetter:()=>rX,moduleResolutionOptionDeclarations:()=>MY,moduleResolutionSupportsPackageJsonExportsAndImports:()=>bA,moduleResolutionUsesNodeModules:()=>BU,moduleSpecifierToValidIdentifier:()=>AM,moduleSpecifiers:()=>wb,moduleSymbolToValidIdentifier:()=>x6,moveEmitHelpers:()=>Zpe,moveRangeEnd:()=>F9,moveRangePastDecorators:()=>v0,moveRangePastModifiers:()=>Jg,moveRangePos:()=>mb,moveSyntheticComments:()=>Kpe,mutateMap:()=>tO,mutateMapSkippingNewValues:()=>Dy,needsParentheses:()=>$U,needsScopeMarker:()=>I5,newCaseClauseTracker:()=>cV,newPrivateEnvironment:()=>Kge,noEmitNotification:()=>J8,noEmitSubstitution:()=>n6,noTransformers:()=>whe,noTruncationMaximumTruncationLength:()=>K$,nodeCanBeDecorated:()=>cR,nodeHasName:()=>w3,nodeIsDecorated:()=>HP,nodeIsMissing:()=>$c,nodeIsPresent:()=>Yd,nodeIsSynthesized:()=>Ko,nodeModuleNameResolver:()=>gge,nodeModulesPathPart:()=>jy,nodeNextJsonConfigResolver:()=>hge,nodeOrChildIsDecorated:()=>lR,nodeOverlapsWithStartEnd:()=>AU,nodePosToString:()=>h6e,nodeSeenTracker:()=>GN,nodeStartsNewLexicalEnvironment:()=>FH,nodeToDisplayParts:()=>b7e,noop:()=>io,noopFileWatcher:()=>l6,normalizePath:()=>Zs,normalizeSlashes:()=>qu,not:()=>n5,notImplemented:()=>_a,notImplementedResolver:()=>Mhe,nullNodeConverters:()=>$pe,nullParenthesizerRules:()=>zpe,nullTransformationContext:()=>z8,objectAllocator:()=>Hu,operatorPart:()=>v6,optionDeclarations:()=>og,optionMapToObject:()=>oB,optionsAffectingProgramStructure:()=>Lme,optionsForBuild:()=>FY,optionsForWatch:()=>YA,optionsHaveChanges:()=>UP,optionsHaveModuleResolutionChanges:()=>v_e,or:()=>Jp,orderedRemoveItem:()=>Gw,orderedRemoveItemAt:()=>M1,packageIdToPackageName:()=>q5,packageIdToString:()=>J1,paramHelper:()=>lde,parameterIsThisKeyword:()=>sE,parameterNamePart:()=>j0e,parseBaseNodeFactory:()=>Ame,parseBigInt:()=>Ppe,parseBuildCommand:()=>$me,parseCommandLine:()=>zme,parseCommandLineWorker:()=>BY,parseConfigFileTextToJson:()=>VY,parseConfigFileWithSystem:()=>hye,parseConfigHostFromCompilerHostLike:()=>XB,parseCustomTypeOption:()=>iB,parseIsolatedEntityName:()=>GA,parseIsolatedJSDocComment:()=>Pme,parseJSDocTypeExpressionForTests:()=>c3e,parseJsonConfigFileContent:()=>F3e,parseJsonSourceFileConfigFileContent:()=>D8,parseJsonText:()=>x8,parseListTypeOption:()=>Jme,parseNodeFactory:()=>Cb,parseNodeModuleFromPath:()=>O8,parsePackageName:()=>bB,parsePseudoBigInt:()=>_O,parseValidBigInt:()=>DG,pasteEdits:()=>nte,patchWriteFileEnsuringDirectory:()=>gue,pathContainsNodeModules:()=>Nb,pathIsAbsolute:()=>iI,pathIsBareSpecifier:()=>d$,pathIsRelative:()=>qp,patternText:()=>Xce,perfLogger:()=>rf,performIncrementalCompilation:()=>vye,performance:()=>ale,plainJSErrors:()=>cX,positionBelongsToNode:()=>fQ,positionIsASICandidate:()=>KU,positionIsSynthesized:()=>ng,positionsAreOnSameLine:()=>Ed,preProcessFile:()=>q7e,probablyUsesSemicolons:()=>EM,processCommentPragmas:()=>wY,processPragmasIntoFields:()=>IY,processTaggedTemplateExpression:()=>IK,programContainsEsModules:()=>O0e,programContainsModules:()=>I0e,projectReferenceIsEqualTo:()=>X$,propKeyHelper:()=>Tde,propertyNamePart:()=>B0e,pseudoBigIntToString:()=>uE,punctuationPart:()=>C_,pushIfUnique:()=>ol,quote:()=>T6,quotePreferenceFromString:()=>NQ,rangeContainsPosition:()=>cM,rangeContainsPositionExclusive:()=>lM,rangeContainsRange:()=>Zp,rangeContainsRangeExclusive:()=>y0e,rangeContainsStartEnd:()=>uM,rangeEndIsOnSameLineAsRangeStart:()=>JR,rangeEndPositionsAreOnSameLine:()=>Yfe,rangeEquals:()=>hl,rangeIsOnSingleLine:()=>n2,rangeOfNode:()=>PG,rangeOfTypeParameters:()=>NG,rangeOverlapsWithStartEnd:()=>d6,rangeStartIsOnSameLineAsRangeEnd:()=>Kfe,rangeStartPositionsAreOnSameLine:()=>j9,readBuilderProgram:()=>oU,readConfigFile:()=>P8,readHelper:()=>Sde,readJson:()=>XI,readJsonConfigFile:()=>Hme,readJsonOrUndefined:()=>nG,reduceEachLeadingCommentRange:()=>Cue,reduceEachTrailingCommentRange:()=>Aue,reduceLeft:()=>L_,reduceLeftIterator:()=>Xl,reducePathComponents:()=>Ux,refactor:()=>lk,regExpEscape:()=>n4e,regularExpressionFlagToCharacter:()=>JOe,relativeComplement:()=>Un,removeAllComments:()=>n8,removeEmitHelper:()=>y4e,removeExtension:()=>YR,removeFileExtension:()=>of,removeIgnoredPath:()=>ZB,removeMinAndVersionNumbers:()=>FW,removeOptionality:()=>C0e,removePrefix:()=>Yw,removeSuffix:()=>AP,removeTrailingDirectorySeparator:()=>ZS,repeatString:()=>mM,replaceElement:()=>wW,replaceFirstStar:()=>AA,resolutionExtensionIsTSOrJson:()=>oO,resolveConfigFileProjectName:()=>jX,resolveJSModule:()=>pge,resolveLibrary:()=>vB,resolveModuleName:()=>QA,resolveModuleNameFromCache:()=>_Re,resolvePackageNameToPackageJson:()=>ZY,resolvePath:()=>QS,resolveProjectReferencePath:()=>VN,resolveTripleslashReference:()=>GK,resolveTypeReferenceDirective:()=>lge,resolvingEmptyArray:()=>Y$,restHelper:()=>gde,returnFalse:()=>Dg,returnNoopFileWatcher:()=>u6,returnTrue:()=>YS,returnUndefined:()=>VT,returnsPromise:()=>yZ,runInitializersHelper:()=>_de,sameFlatMap:()=>KF,sameMap:()=>Fs,sameMapping:()=>t8e,scanShebangTrivia:()=>E$,scanTokenAtPosition:()=>J_e,scanner:()=>q_,screenStartingMessageCodes:()=>SX,semanticDiagnosticsOptionDeclarations:()=>Ome,serializeCompilerOptions:()=>cB,server:()=>Vze,servicesVersion:()=>BFe,setCommentRange:()=>Zl,setConfigFileInOptions:()=>HY,setConstantValue:()=>Qpe,setEachParent:()=>l4e,setEmitFlags:()=>Tn,setFunctionNameHelper:()=>Ede,setGetSourceFileAsHashVersioned:()=>aU,setIdentifierAutoGenerate:()=>a8,setIdentifierGeneratedImportReference:()=>rde,setIdentifierTypeArguments:()=>Rv,setInternalEmitFlags:()=>i8,setLocalizedDiagnosticMessages:()=>spe,setModuleDefaultHelper:()=>Ade,setNodeChildren:()=>nme,setNodeFlags:()=>wpe,setObjectAllocator:()=>ipe,setOriginalNode:()=>zn,setParent:()=>lo,setParentRecursive:()=>T0,setPrivateIdentifier:()=>h2,setSnippetElement:()=>qG,setSourceMapRange:()=>qa,setStackTraceLimit:()=>kOe,setStartsOnNewLine:()=>bj,setSyntheticLeadingComments:()=>hb,setSyntheticTrailingComments:()=>PA,setSys:()=>OOe,setSysLog:()=>pue,setTextRange:()=>Et,setTextRangeEnd:()=>pN,setTextRangePos:()=>fO,setTextRangePosEnd:()=>qg,setTextRangePosWidth:()=>wG,setTokenSourceMapRange:()=>Ype,setTypeNode:()=>ede,setUILocale:()=>Gce,setValueDeclaration:()=>SR,shouldAllowImportingTsExtension:()=>MN,shouldPreserveConstEnums:()=>lE,shouldUseUriStyleNodeCoreModules:()=>aV,showModuleSpecifier:()=>tpe,signatureHasLiteralTypes:()=>yK,signatureHasRestParameter:()=>E_,signatureToDisplayParts:()=>VQ,single:()=>DW,singleElementArray:()=>qC,singleIterator:()=>XF,singleOrMany:()=>wh,singleOrUndefined:()=>Dh,skipAlias:()=>$u,skipAssertions:()=>L4e,skipConstraint:()=>AQ,skipOuterExpressions:()=>Ml,skipParentheses:()=>So,skipPartiallyEmittedExpressions:()=>km,skipTrivia:()=>Ja,skipTypeChecking:()=>uO,skipTypeParentheses:()=>FI,skipWhile:()=>ele,sliceAfter:()=>kG,some:()=>Pt,sort:()=>pa,sortAndDeduplicate:()=>jC,sortAndDeduplicateDiagnostics:()=>wP,sourceFileAffectingCompilerOptions:()=>LY,sourceFileMayBeEmitted:()=>t2,sourceMapCommentRegExp:()=>SK,sourceMapCommentRegExpDontCareLineStart:()=>Bge,spacePart:()=>Zc,spanMap:()=>EP,spreadArrayHelper:()=>bde,stableSort:()=>Qs,startEndContainsRange:()=>_Q,startEndOverlapsWithStartEnd:()=>kU,startOnNewLine:()=>T_,startTracing:()=>ule,startsWith:()=>_s,startsWithDirectory:()=>h$,startsWithUnderscore:()=>rZ,startsWithUseStrict:()=>ume,stringContainsAt:()=>ive,stringToToken:()=>JT,stripQuotes:()=>Zd,supportedDeclarationExtensions:()=>sj,supportedJSExtensions:()=>Spe,supportedJSExtensionsFlat:()=>_N,supportedLocaleDirectories:()=>Fue,supportedTSExtensions:()=>sO,supportedTSExtensionsFlat:()=>EG,supportedTSImplementationExtensions:()=>aj,suppressLeadingAndTrailingTrivia:()=>gp,suppressLeadingTrivia:()=>WQ,suppressTrailingTrivia:()=>H0e,symbolEscapedNameNoDefault:()=>UU,symbolName:()=>Qc,symbolNameNoDefault:()=>wQ,symbolPart:()=>F0e,symbolToDisplayParts:()=>S6,syntaxMayBeASICandidate:()=>Q0e,syntaxRequiresTrailingSemicolonOrASI:()=>YU,sys:()=>lu,sysLog:()=>v3,tagNamesAreEquivalent:()=>kb,takeWhile:()=>VW,targetOptionDeclaration:()=>RY,templateObjectHelper:()=>vde,testFormatSettings:()=>f7e,textChangeRangeIsUnchanged:()=>Iue,textChangeRangeNewSpan:()=>fI,textChanges:()=>Sn,textOrKeywordPart:()=>BQ,textPart:()=>td,textRangeContainsPositionInclusive:()=>P3,textSpanContainsPosition:()=>C$,textSpanContainsTextSpan:()=>Pue,textSpanEnd:()=>bl,textSpanIntersection:()=>wue,textSpanIntersectsWith:()=>S5,textSpanIntersectsWithPosition:()=>Due,textSpanIntersectsWithTextSpan:()=>YOe,textSpanIsEmpty:()=>kue,textSpanOverlap:()=>Nue,textSpanOverlapsWith:()=>GOe,textSpansEqual:()=>KN,textToKeywordObj:()=>m5,timestamp:()=>Tc,toArray:()=>VC,toBuilderFileEmit:()=>oye,toBuilderStateFileInfoForMultiEmit:()=>aye,toEditorSettings:()=>RM,toFileNameLowerCase:()=>R1,toLowerCase:()=>qce,toPath:()=>rc,toProgramEmitPending:()=>cye,tokenIsIdentifierOrKeyword:()=>F_,tokenIsIdentifierOrKeywordOrGreaterThan:()=>Sue,tokenToString:()=>Sa,trace:()=>ds,tracing:()=>Cn,tracingEnabled:()=>h3,transferSourceFileChildren:()=>ime,transform:()=>YFe,transformClassFields:()=>lhe,transformDeclarations:()=>LK,transformECMAScriptModule:()=>MK,transformES2015:()=>Ehe,transformES2016:()=>The,transformES2017:()=>phe,transformES2018:()=>dhe,transformES2019:()=>mhe,transformES2020:()=>ghe,transformES2021:()=>hhe,transformESDecorators:()=>fhe,transformESNext:()=>yhe,transformGenerators:()=>xhe,transformJsx:()=>bhe,transformLegacyDecorators:()=>_he,transformModule:()=>RK,transformNamedEvaluation:()=>dp,transformNodeModule:()=>Ahe,transformNodes:()=>q8,transformSystemModule:()=>Che,transformTypeScript:()=>che,transpile:()=>Q7e,transpileDeclaration:()=>K7e,transpileModule:()=>Ave,transpileOptionValueCompilerOptions:()=>Fme,tryAddToSet:()=>Pg,tryAndIgnoreErrors:()=>ZU,tryCast:()=>ai,tryDirectoryExists:()=>QU,tryExtractTSExtension:()=>M9,tryFileExists:()=>xM,tryGetClassExtendingExpressionWithTypeArguments:()=>ZH,tryGetClassImplementingOrExtendingExpressionWithTypeArguments:()=>eG,tryGetDirectories:()=>XU,tryGetExtensionFromPath:()=>b0,tryGetImportFromModuleSpecifier:()=>bR,tryGetJSDocSatisfiesTypeNode:()=>gj,tryGetModuleNameFromFile:()=>y8,tryGetModuleSpecifierFromDeclaration:()=>MI,tryGetNativePerformanceHooks:()=>sle,tryGetPropertyAccessOrIdentifierToString:()=>VR,tryGetPropertyNameOfBindingOrAssignmentElement:()=>Yj,tryGetSourceMappingURL:()=>Uge,tryGetTextOfPropertyName:()=>PI,tryIOAndConsumeErrors:()=>eV,tryParseJson:()=>L9,tryParsePattern:()=>fN,tryParsePatterns:()=>cj,tryParseRawSourceMap:()=>Jge,tryReadDirectory:()=>YQ,tryReadFile:()=>UO,tryRemoveDirectoryPrefix:()=>SG,tryRemoveExtension:()=>Ape,tryRemovePrefix:()=>UW,tryRemoveSuffix:()=>Kce,typeAcquisitionDeclarations:()=>rB,typeAliasNamePart:()=>U0e,typeDirectiveIsEqualTo:()=>E_e,typeKeywords:()=>xQ,typeParameterNamePart:()=>V0e,typeToDisplayParts:()=>vM,unchangedPollThresholds:()=>u5,unchangedTextChangeRange:()=>b5,unescapeLeadingUnderscores:()=>Qi,unmangleScopedPackageName:()=>M8,unorderedRemoveItem:()=>JC,unorderedRemoveItemAt:()=>jW,unreachableCodeIsError:()=>lpe,unsetNodeChildren:()=>dY,unusedLabelIsError:()=>upe,unwrapInnermostStatementOfLabel:()=>hH,unwrapParenthesizedExpression:()=>Upe,updateErrorForNoInputFiles:()=>fB,updateLanguageServiceSourceFile:()=>WZ,updateMissingFilePathsWatch:()=>WK,updateResolutionField:()=>DN,updateSharedExtendedConfigFileWatcher:()=>qB,updateSourceFile:()=>PY,updateWatchingWildcardDirectories:()=>W8,usesExtensionsOnImports:()=>Tpe,usingSingleLineStringWriter:()=>CI,utf16EncodeAsString:()=>_I,validateLocaleAndSetLanguage:()=>k$,valuesHelper:()=>xde,version:()=>se,versionMajorMinor:()=>j,visitArray:()=>F8,visitCommaListElements:()=>j8,visitEachChild:()=>Mr,visitFunctionBody:()=>Qp,visitIterationBody:()=>ff,visitLexicalEnvironment:()=>vK,visitNode:()=>ot,visitNodes:()=>Kr,visitParameterList:()=>Kc,walkUpBindingElementsAndPatterns:()=>IP,walkUpLexicalEnvironments:()=>Yge,walkUpOuterExpressions:()=>_me,walkUpParenthesizedExpressions:()=>g0,walkUpParenthesizedTypes:()=>AR,walkUpParenthesizedTypesAndGetParentAndChild:()=>gfe,whitespaceOrMapCommentRegExp:()=>bK,writeCommentRange:()=>oN,writeFile:()=>LR,writeFileEnsuringDirectories:()=>HH,zipWith:()=>ho}),l.exports=p(k);var j="5.5",se="5.5.4",ze=(e=>(e[e.LessThan=-1]="LessThan",e[e.EqualTo=0]="EqualTo",e[e.GreaterThan=1]="GreaterThan",e))(ze||{}),ve=[],lr=new Map,Br=new Set;function wt(e){return e?e.length:0}function kt(e,t){if(e)for(let n=0;n<e.length;n++){let i=t(e[n],n);if(i)return i}}function Fi(e,t){if(e)for(let n=e.length-1;n>=0;n--){let i=t(e[n],n);if(i)return i}}function yi(e,t){if(e!==void 0)for(let n=0;n<e.length;n++){let i=t(e[n],n);if(i!==void 0)return i}}function qo(e,t){for(let n of e){let i=t(n);if(i!==void 0)return i}}function Xl(e,t,n){let i=n;if(e){let s=0;for(let o of e)i=t(i,o,s),s++}return i}function ho(e,t,n){let i=[];M.assertEqual(e.length,t.length);for(let s=0;s<e.length;s++)i.push(n(e[s],t[s],s));return i}function bf(e,t){if(e.length<=1)return e;let n=[];for(let i=0,s=e.length;i<s;i++)i&&n.push(t),n.push(e[i]);return n}function wi(e,t){if(e){for(let n=0;n<e.length;n++)if(!t(e[n],n))return!1}return!0}function Ln(e,t,n){if(e!==void 0)for(let i=n??0;i<e.length;i++){let s=e[i];if(t(s,i))return s}}function xm(e,t,n){if(e!==void 0)for(let i=n??e.length-1;i>=0;i--){let s=e[i];if(t(s,i))return s}}function Bo(e,t,n){if(e===void 0)return-1;for(let i=n??0;i<e.length;i++)if(t(e[i],i))return i;return-1}function pv(e,t,n){if(e===void 0)return-1;for(let i=n??e.length-1;i>=0;i--)if(t(e[i],i))return i;return-1}function Jw(e,t){for(let n=0;n<e.length;n++){let i=t(e[n],n);if(i)return i}return M.fail()}function Es(e,t,n=gv){if(e){for(let i of e)if(n(i,t))return!0}return!1}function UT(e,t,n=gv){return e.length===t.length&&e.every((i,s)=>n(i,t[s]))}function qw(e,t,n){for(let i=n||0;i<e.length;i++)if(Es(t,e.charCodeAt(i)))return i;return-1}function vy(e,t){let n=0;if(e)for(let i=0;i<e.length;i++){let s=e[i];t(s,i)&&n++}return n}function Zn(e,t){if(e){let n=e.length,i=0;for(;i<n&&t(e[i]);)i++;if(i<n){let s=e.slice(0,i);for(i++;i<n;){let o=e[i];t(o)&&s.push(o),i++}return s}}return e}function zw(e,t){let n=0;for(let i=0;i<e.length;i++)t(e[i],i,e)&&(e[n]=e[i],n++);e.length=n}function Ym(e){e.length=0}function Cr(e,t){let n;if(e){n=[];for(let i=0;i<e.length;i++)n.push(t(e[i],i))}return n}function*Ix(e,t){for(let n of e)yield t(n)}function Fs(e,t){if(e)for(let n=0;n<e.length;n++){let i=e[n],s=t(i,n);if(i!==s){let o=e.slice(0,n);for(o.push(s),n++;n<e.length;n++)o.push(t(e[n],n));return o}}return e}function ef(e){let t=[];for(let n of e)n&&(Rs(n)?wn(t,n):t.push(n));return t}function va(e,t){let n;if(e)for(let i=0;i<e.length;i++){let s=t(e[i],i);s&&(Rs(s)?n=wn(n,s):n=Bt(n,s))}return n||ve}function M_(e,t){let n=[];if(e)for(let i=0;i<e.length;i++){let s=t(e[i],i);s&&(Rs(s)?wn(n,s):n.push(s))}return n}function*c3(e,t){for(let n of e){let i=t(n);i&&(yield*i)}}function KF(e,t){let n;if(e)for(let i=0;i<e.length;i++){let s=e[i],o=t(s,i);(n||s!==o||Rs(o))&&(n||(n=e.slice(0,i)),Rs(o)?wn(n,o):n.push(o))}return n||e}function Ww(e,t){let n=[];for(let i=0;i<e.length;i++){let s=t(e[i],i);if(s===void 0)return;n.push(s)}return n}function Gi(e,t){let n=[];if(e)for(let i=0;i<e.length;i++){let s=t(e[i],i);s!==void 0&&n.push(s)}return n}function*Up(e,t){for(let n of e){let i=t(n);i!==void 0&&(yield i)}}function l3(e,t){if(!e)return;let n=new Map;return e.forEach((i,s)=>{let o=t(s,i);if(o!==void 0){let[u,m]=o;u!==void 0&&m!==void 0&&n.set(u,m)}}),n}function dv(e,t,n){if(e.has(t))return e.get(t);let i=n();return e.set(t,i),i}function Pg(e,t){return e.has(t)?!1:(e.add(t),!0)}function*XF(e){yield e}function EP(e,t,n){let i;if(e){i=[];let s=e.length,o,u,m=0,d=0;for(;m<s;){for(;d<s;){let S=e[d];if(u=t(S,d),d===0)o=u;else if(u!==o)break;d++}if(m<d){let S=n(e.slice(m,d),o,m,d);S&&i.push(S),m=d}o=u,d++}}return i}function u3(e,t){if(!e)return;let n=new Map;return e.forEach((i,s)=>{let[o,u]=t(s,i);n.set(o,u)}),n}function Pt(e,t){if(e)if(t){for(let n of e)if(t(n))return!0}else return e.length>0;return!1}function $w(e,t,n){let i;for(let s=0;s<e.length;s++)t(e[s])?i=i===void 0?s:i:i!==void 0&&(n(i,s),i=void 0);i!==void 0&&n(i,e.length)}function ps(e,t){return Pt(t)?Pt(e)?[...e,...t]:t:e}function PW(e,t){return t}function Ox(e){return e.map(PW)}function Lce(e,t,n){let i=Ox(e);na(e,i,n);let s=e[i[0]],o=[i[0]];for(let u=1;u<i.length;u++){let m=i[u],d=e[m];t(s,d)||(o.push(m),s=d)}return o.sort(),o.map(u=>e[u])}function Fce(e,t){let n=[];for(let i of e)ol(n,i,t);return n}function I1(e,t,n){return e.length===0?[]:e.length===1?e.slice():n?Lce(e,t,n):Fce(e,t)}function jce(e,t){if(e.length===0)return ve;let n=e[0],i=[n];for(let s=1;s<e.length;s++){let o=e[s];switch(t(o,n)){case!0:case 0:continue;case-1:return M.fail("Array is unsorted.")}i.push(n=o)}return i}function Rx(){return[]}function l0(e,t,n,i,s){if(e.length===0)return e.push(t),!0;let o=mv(e,t,ec,n);if(o<0){if(i&&!s){let u=~o;if(u>0&&i(t,e[u-1]))return!1;if(u<e.length&&i(t,e[u]))return e.splice(u,1,t),!0}return e.splice(~o,0,t),!0}return s?(e.splice(o,0,t),!0):!1}function jC(e,t,n){return jce(pa(e,t),n||t||c_)}function NW(e,t){if(e.length<2)return!0;for(let n=1,i=e.length;n<i;n++)if(t(e[n-1],e[n])===1)return!1;return!0}function Vp(e,t,n=gv){if(!e||!t)return e===t;if(e.length!==t.length)return!1;for(let i=0;i<e.length;i++)if(!n(e[i],t[i],i))return!1;return!0}function cn(e){let t;if(e)for(let n=0;n<e.length;n++){let i=e[n];(t||!i)&&(t||(t=e.slice(0,n)),i&&t.push(i))}return t||e}function Un(e,t,n){if(!t||!e||t.length===0||e.length===0)return t;let i=[];e:for(let s=0,o=0;o<t.length;o++){o>0&&M.assertGreaterThanOrEqual(n(t[o],t[o-1]),0);t:for(let u=s;s<e.length;s++)switch(s>u&&M.assertGreaterThanOrEqual(n(e[s],e[s-1]),0),n(t[o],e[s])){case-1:i.push(t[o]);continue e;case 0:continue e;case 1:continue t}}return i}function Bt(e,t){return t===void 0?e:e===void 0?[t]:(e.push(t),e)}function vs(e,t){return e===void 0?t:t===void 0?e:Rs(e)?Rs(t)?ps(e,t):Bt(e,t):Rs(t)?Bt(t,e):[e,t]}function Eo(e,t){return t<0?e.length+t:t}function wn(e,t,n,i){if(t===void 0||t.length===0)return e;if(e===void 0)return t.slice(n,i);n=n===void 0?0:Eo(t,n),i=i===void 0?t.length:Eo(t,i);for(let s=n;s<i&&s<t.length;s++)t[s]!==void 0&&e.push(t[s]);return e}function ol(e,t,n){return Es(e,t,n)?!1:(e.push(t),!0)}function $o(e,t,n){return e?(ol(e,t,n),e):[t]}function na(e,t,n){t.sort((i,s)=>n(e[i],e[s])||tc(i,s))}function pa(e,t){return e.length===0?e:e.slice().sort(t)}function*Ra(e){for(let t=e.length-1;t>=0;t--)yield e[t]}function Qs(e,t){let n=Ox(e);return na(e,n,t),n.map(i=>e[i])}function hl(e,t,n,i){for(;n<i;){if(e[n]!==t[n])return!1;n++}return!0}var Dl=Array.prototype.at?(e,t)=>e?.at(t):(e,t)=>{if(e&&(t=Eo(e,t),t<e.length))return e[t]};function xo(e){return e===void 0||e.length===0?void 0:e[0]}function Nh(e){if(e)for(let t of e)return t}function Ma(e){return M.assert(e.length!==0),e[0]}function _3(e){for(let t of e)return t;M.fail("iterator is empty")}function vc(e){return e===void 0||e.length===0?void 0:e[e.length-1]}function Va(e){return M.assert(e.length!==0),e[e.length-1]}function Dh(e){return e&&e.length===1?e[0]:void 0}function DW(e){return M.checkDefined(Dh(e))}function wh(e){return e&&e.length===1?e[0]:e}function wW(e,t,n){let i=e.slice(0);return i[t]=n,i}function mv(e,t,n,i,s){return BC(e,n(t),n,i,s)}function BC(e,t,n,i,s){if(!Pt(e))return-1;let o=s||0,u=e.length-1;for(;o<=u;){let m=o+(u-o>>1),d=n(e[m],m);switch(i(d,t)){case-1:o=m+1;break;case 0:return m;case 1:u=m-1;break}}return~o}function L_(e,t,n,i,s){if(e&&e.length>0){let o=e.length;if(o>0){let u=i===void 0||i<0?0:i,m=s===void 0||u+s>o-1?o-1:u+s,d;for(arguments.length<=2?(d=e[u],u++):d=n;u<=m;)d=t(d,e[u],u),u++;return d}}return n}var GS=Object.prototype.hasOwnProperty;function Ho(e,t){return GS.call(e,t)}function QF(e,t){return GS.call(e,t)?e[t]:void 0}function Ng(e){let t=[];for(let n in e)GS.call(e,n)&&t.push(n);return t}function lOe(e){let t=[];do{let n=Object.getOwnPropertyNames(e);for(let i of n)ol(t,i)}while(e=Object.getPrototypeOf(e));return t}function UC(e){let t=[];for(let n in e)GS.call(e,n)&&t.push(e[n]);return t}function Bce(e,t){let n=new Array(e);for(let i=0;i<e;i++)n[i]=t(i);return n}function Is(e,t){let n=[];for(let i of e)n.push(t?t(i):i);return n}function Mx(e,...t){for(let n of t)if(n!==void 0)for(let i in n)Ho(n,i)&&(e[i]=n[i]);return e}function Uce(e,t,n=gv){if(e===t)return!0;if(!e||!t)return!1;for(let i in e)if(GS.call(e,i)&&(!GS.call(t,i)||!n(e[i],t[i])))return!1;for(let i in t)if(GS.call(t,i)&&!GS.call(e,i))return!1;return!0}function xP(e,t,n=ec){let i=new Map;for(let s of e){let o=t(s);o!==void 0&&i.set(o,n(s))}return i}function Vce(e,t,n=ec){let i=[];for(let s of e)i[t(s)]=n(s);return i}function f3(e,t,n=ec){let i=yd();for(let s of e)i.add(t(s),n(s));return i}function Hw(e,t,n=ec){return Is(f3(e,t).values(),n)}function IW(e,t){let n={};if(e)for(let i of e){let s=`${t(i)}`;(n[s]??(n[s]=[])).push(i)}return n}function Jce(e){let t={};for(let n in e)GS.call(e,n)&&(t[n]=e[n]);return t}function ZF(e,t){let n={};for(let i in t)GS.call(t,i)&&(n[i]=t[i]);for(let i in e)GS.call(e,i)&&(n[i]=e[i]);return n}function OW(e,t){for(let n in t)GS.call(t,n)&&(e[n]=t[n])}function ia(e,t){return t?t.bind(e):void 0}function yd(){let e=new Map;return e.add=fvt,e.remove=pvt,e}function fvt(e,t){let n=this.get(e);return n?n.push(t):this.set(e,n=[t]),n}function pvt(e,t){let n=this.get(e);n&&(JC(n,t),n.length||this.delete(e))}function p3(e){let t=e?.slice()||[],n=0;function i(){return n===t.length}function s(...u){t.push(...u)}function o(){if(i())throw new Error("Queue is empty");let u=t[n];if(t[n]=void 0,n++,n>100&&n>t.length>>1){let m=t.length-n;t.copyWithin(0,n),t.length=m,n=0}return u}return{enqueue:s,dequeue:o,isEmpty:i}}function RW(e,t){let n=new Map,i=0;function*s(){for(let u of n.values())Rs(u)?yield*u:yield u}let o={has(u){let m=e(u);if(!n.has(m))return!1;let d=n.get(m);if(!Rs(d))return t(d,u);for(let S of d)if(t(S,u))return!0;return!1},add(u){let m=e(u);if(n.has(m)){let d=n.get(m);if(Rs(d))Es(d,u,t)||(d.push(u),i++);else{let S=d;t(S,u)||(n.set(m,[S,u]),i++)}}else n.set(m,u),i++;return this},delete(u){let m=e(u);if(!n.has(m))return!1;let d=n.get(m);if(Rs(d)){for(let S=0;S<d.length;S++)if(t(d[S],u))return d.length===1?n.delete(m):d.length===2?n.set(m,d[1-S]):jW(d,S),i--,!0}else if(t(d,u))return n.delete(m),i--,!0;return!1},clear(){n.clear(),i=0},get size(){return i},forEach(u){for(let m of Is(n.values()))if(Rs(m))for(let d of m)u(d,d,o);else{let d=m;u(d,d,o)}},keys(){return s()},values(){return s()},*entries(){for(let u of s())yield[u,u]},[Symbol.iterator]:()=>s(),[Symbol.toStringTag]:n[Symbol.toStringTag]};return o}function Rs(e){return Array.isArray(e)}function VC(e){return Rs(e)?e:[e]}function bs(e){return typeof e=="string"}function O1(e){return typeof e=="number"}function ai(e,t){return e!==void 0&&t(e)?e:void 0}function aa(e,t){return e!==void 0&&t(e)?e:M.fail(`Invalid cast. The supplied value ${e} did not pass the test '${M.getFunctionName(t)}'.`)}function io(e){}function Dg(){return!1}function YS(){return!0}function VT(){}function ec(e){return e}function qce(e){return e.toLowerCase()}var uOe=/[^\u0130\u0131\u00DFa-z0-9\\/:\-_. ]+/g;function R1(e){return uOe.test(e)?e.replace(uOe,qce):e}function _a(){throw new Error("Not implemented")}function tf(e){let t;return()=>(e&&(t=e(),e=void 0),t)}function Ih(e){let t=new Map;return n=>{let i=`${typeof n}:${n}`,s=t.get(i);return s===void 0&&!t.has(i)&&(s=e(n),t.set(i,s)),s}}function _Oe(e){let t=new WeakMap;return n=>{let i=t.get(n);return i===void 0&&!t.has(n)&&(i=e(n),t.set(n,i)),i}}function fOe(e,t){return(...n)=>{let i=t.get(n);return i===void 0&&!t.has(n)&&(i=e(...n),t.set(n,i)),i}}function pOe(e,t,n,i,s){if(s){let o=[];for(let u=0;u<arguments.length;u++)o[u]=arguments[u];return u=>L_(o,(m,d)=>d(m),u)}else return i?o=>i(n(t(e(o)))):n?o=>n(t(e(o))):t?o=>t(e(o)):e?o=>e(o):o=>o}var zce=(e=>(e[e.None=0]="None",e[e.Normal=1]="Normal",e[e.Aggressive=2]="Aggressive",e[e.VeryAggressive=3]="VeryAggressive",e))(zce||{});function gv(e,t){return e===t}function KS(e,t){return e===t||e!==void 0&&t!==void 0&&e.toUpperCase()===t.toUpperCase()}function Lx(e,t){return gv(e,t)}function dOe(e,t){return e===t?0:e===void 0?-1:t===void 0?1:e<t?-1:1}function tc(e,t){return dOe(e,t)}function e5(e,t){return tc(e?.start,t?.start)||tc(e?.length,t?.length)}function MW(e,t){return L_(e,(n,i)=>t(n,i)===-1?n:i)}function d3(e,t){return e===t?0:e===void 0?-1:t===void 0?1:(e=e.toUpperCase(),t=t.toUpperCase(),e<t?-1:e>t?1:0)}function Wce(e,t){return e===t?0:e===void 0?-1:t===void 0?1:(e=e.toLowerCase(),t=t.toLowerCase(),e<t?-1:e>t?1:0)}function c_(e,t){return dOe(e,t)}function CP(e){return e?d3:c_}var dvt=(()=>{return t;function e(n,i,s){if(n===i)return 0;if(n===void 0)return-1;if(i===void 0)return 1;let o=s(n,i);return o<0?-1:o>0?1:0}function t(n){let i=new Intl.Collator(n,{usage:"sort",sensitivity:"variant",numeric:!0}).compare;return(s,o)=>e(s,o,i)}})(),$ce,LW;function Hce(){return LW}function Gce(e){LW!==e&&(LW=e,$ce=void 0)}function m3(e,t){return($ce||($ce=dvt(LW)))(e,t)}function Yce(e,t,n,i){return e===t?0:e===void 0?-1:t===void 0?1:i(e[n],t[n])}function XS(e,t){return tc(e?1:0,t?1:0)}function Fx(e,t,n){let i=Math.max(2,Math.floor(e.length*.34)),s=Math.floor(e.length*.4)+1,o;for(let u of t){let m=n(u);if(m!==void 0&&Math.abs(m.length-e.length)<=i){if(m===e||m.length<3&&m.toLowerCase()!==e.toLowerCase())continue;let d=mvt(e,m,s-.1);if(d===void 0)continue;M.assert(d<s),s=d,o=u}}return o}function mvt(e,t,n){let i=new Array(t.length+1),s=new Array(t.length+1),o=n+.01;for(let m=0;m<=t.length;m++)i[m]=m;for(let m=1;m<=e.length;m++){let d=e.charCodeAt(m-1),S=Math.ceil(m>n?m-n:1),E=Math.floor(t.length>n+m?n+m:t.length);s[0]=m;let x=m;for(let w=1;w<S;w++)s[w]=o;for(let w=S;w<=E;w++){let R=e[m-1].toLowerCase()===t[w-1].toLowerCase()?i[w-1]+.1:i[w-1]+2,L=d===t.charCodeAt(w-1)?i[w-1]:Math.min(i[w]+1,s[w-1]+1,R);s[w]=L,x=Math.min(x,L)}for(let w=E+1;w<=t.length;w++)s[w]=o;if(x>n)return;let D=i;i=s,s=D}let u=i[t.length];return u>n?void 0:u}function Wc(e,t,n){let i=e.length-t.length;return i>=0&&(n?KS(e.slice(i),t):e.indexOf(t,i)===i)}function AP(e,t){return Wc(e,t)?e.slice(0,e.length-t.length):e}function Kce(e,t){return Wc(e,t)?e.slice(0,e.length-t.length):void 0}function FW(e){let t=e.length;for(let n=t-1;n>0;n--){let i=e.charCodeAt(n);if(i>=48&&i<=57)do--n,i=e.charCodeAt(n);while(n>0&&i>=48&&i<=57);else if(n>4&&(i===110||i===78)){if(--n,i=e.charCodeAt(n),i!==105&&i!==73||(--n,i=e.charCodeAt(n),i!==109&&i!==77))break;--n,i=e.charCodeAt(n)}else break;if(i!==45&&i!==46)break;t=n}return t===e.length?e:e.slice(0,t)}function Gw(e,t){for(let n=0;n<e.length;n++)if(e[n]===t)return M1(e,n),!0;return!1}function M1(e,t){for(let n=t;n<e.length-1;n++)e[n]=e[n+1];e.pop()}function jW(e,t){e[t]=e[e.length-1],e.pop()}function JC(e,t){return gvt(e,n=>n===t)}function gvt(e,t){for(let n=0;n<e.length;n++)if(t(e[n]))return jW(e,n),!0;return!1}function l_(e){return e?ec:R1}function Xce({prefix:e,suffix:t}){return`${e}*${t}`}function Qce(e,t){return M.assert(t5(e,t)),t.substring(e.prefix.length,t.length-e.suffix.length)}function BW(e,t,n){let i,s=-1;for(let o of e){let u=t(o);t5(u,n)&&u.prefix.length>s&&(s=u.prefix.length,i=o)}return i}function _s(e,t,n){return n?KS(e.slice(0,t.length),t):e.lastIndexOf(t,0)===0}function Yw(e,t){return _s(e,t)?e.substr(t.length):e}function UW(e,t,n=ec){return _s(n(e),n(t))?e.substring(t.length):void 0}function t5({prefix:e,suffix:t},n){return n.length>=e.length+t.length&&_s(n,e)&&Wc(n,t)}function r5(e,t){return n=>e(n)&&t(n)}function Jp(...e){return(...t)=>{let n;for(let i of e)if(n=i(...t),n)return n;return n}}function n5(e){return(...t)=>!e(...t)}function mOe(e){}function qC(e){return e===void 0?void 0:[e]}function i5(e,t,n,i,s,o){o=o||io;let u=0,m=0,d=e.length,S=t.length,E=!1;for(;u<d&&m<S;){let x=e[u],D=t[m],w=n(x,D);w===-1?(i(x),u++,E=!0):w===1?(s(D),m++,E=!0):(o(D,x),u++,m++)}for(;u<d;)i(e[u++]),E=!0;for(;m<S;)s(t[m++]),E=!0;return E}function Zce(e){let t=[];return gOe(e,t,void 0,0),t}function gOe(e,t,n,i){for(let s of e[i]){let o;n?(o=n.slice(),o.push(s)):o=[s],i===e.length-1?t.push(o):gOe(e,t,o,i+1)}}function VW(e,t){if(e){let n=e.length,i=0;for(;i<n&&t(e[i]);)i++;return e.slice(0,i)}}function ele(e,t){if(e){let n=e.length,i=0;for(;i<n&&t(e[i]);)i++;return e.slice(i)}}function JW(){return typeof process<"u"&&!!process.nextTick&&!process.browser&&typeof Bu<"u"}var tle=(e=>(e[e.Off=0]="Off",e[e.Error=1]="Error",e[e.Warning=2]="Warning",e[e.Info=3]="Info",e[e.Verbose=4]="Verbose",e))(tle||{}),M;(e=>{let t=0;e.currentLogLevel=2,e.isDebugging=!1;function n($e){return e.currentLogLevel<=$e}e.shouldLog=n;function i($e,Yt){e.loggingHost&&n($e)&&e.loggingHost.log($e,Yt)}function s($e){i(3,$e)}e.log=s,($e=>{function Yt(Ci){i(1,Ci)}$e.error=Yt;function Vr(Ci){i(2,Ci)}$e.warn=Vr;function An(Ci){i(3,Ci)}$e.log=An;function vi(Ci){i(4,Ci)}$e.trace=vi})(s=e.log||(e.log={}));let o={};function u(){return t}e.getAssertionLevel=u;function m($e){let Yt=t;if(t=$e,$e>Yt)for(let Vr of Ng(o)){let An=o[Vr];An!==void 0&&e[Vr]!==An.assertion&&$e>=An.level&&(e[Vr]=An,o[Vr]=void 0)}}e.setAssertionLevel=m;function d($e){return t>=$e}e.shouldAssert=d;function S($e,Yt){return d($e)?!0:(o[Yt]={level:$e,assertion:e[Yt]},e[Yt]=io,!1)}function E($e,Yt){debugger;let Vr=new Error($e?`Debug Failure. ${$e}`:"Debug Failure.");throw Error.captureStackTrace&&Error.captureStackTrace(Vr,Yt||E),Vr}e.fail=E;function x($e,Yt,Vr){return E(`${Yt||"Unexpected node."}\r
Node ${he($e.kind)} was unexpected.`,Vr||x)}e.failBadSyntaxKind=x;function D($e,Yt,Vr,An){$e||(Yt=Yt?`False expression: ${Yt}`:"False expression.",Vr&&(Yt+=`\r
Verbose Debug Information: `+(typeof Vr=="string"?Vr:Vr())),E(Yt,An||D))}e.assert=D;function w($e,Yt,Vr,An,vi){if($e!==Yt){let Ci=Vr?An?`${Vr} ${An}`:Vr:"";E(`Expected ${$e} === ${Yt}. ${Ci}`,vi||w)}}e.assertEqual=w;function R($e,Yt,Vr,An){$e>=Yt&&E(`Expected ${$e} < ${Yt}. ${Vr||""}`,An||R)}e.assertLessThan=R;function L($e,Yt,Vr){$e>Yt&&E(`Expected ${$e} <= ${Yt}`,Vr||L)}e.assertLessThanOrEqual=L;function F($e,Yt,Vr){$e<Yt&&E(`Expected ${$e} >= ${Yt}`,Vr||F)}e.assertGreaterThanOrEqual=F;function J($e,Yt,Vr){$e==null&&E(Yt,Vr||J)}e.assertIsDefined=J;function G($e,Yt,Vr){return J($e,Yt,Vr||G),$e}e.checkDefined=G;function q($e,Yt,Vr){for(let An of $e)J(An,Yt,Vr||q)}e.assertEachIsDefined=q;function ee($e,Yt,Vr){return q($e,Yt,Vr||ee),$e}e.checkEachDefined=ee;function W($e,Yt="Illegal value:",Vr){let An=typeof $e=="object"&&Ho($e,"kind")&&Ho($e,"pos")?"SyntaxKind: "+he($e.kind):JSON.stringify($e);return E(`${Yt} ${An}`,Vr||W)}e.assertNever=W;function pe($e,Yt,Vr,An){S(1,"assertEachNode")&&D(Yt===void 0||wi($e,Yt),Vr||"Unexpected node.",()=>`Node array did not pass test '${me(Yt)}'.`,An||pe)}e.assertEachNode=pe;function K($e,Yt,Vr,An){S(1,"assertNode")&&D($e!==void 0&&(Yt===void 0||Yt($e)),Vr||"Unexpected node.",()=>`Node ${he($e?.kind)} did not pass test '${me(Yt)}'.`,An||K)}e.assertNode=K;function re($e,Yt,Vr,An){S(1,"assertNotNode")&&D($e===void 0||Yt===void 0||!Yt($e),Vr||"Unexpected node.",()=>`Node ${he($e.kind)} should not have passed test '${me(Yt)}'.`,An||re)}e.assertNotNode=re;function ue($e,Yt,Vr,An){S(1,"assertOptionalNode")&&D(Yt===void 0||$e===void 0||Yt($e),Vr||"Unexpected node.",()=>`Node ${he($e?.kind)} did not pass test '${me(Yt)}'.`,An||ue)}e.assertOptionalNode=ue;function ce($e,Yt,Vr,An){S(1,"assertOptionalToken")&&D(Yt===void 0||$e===void 0||$e.kind===Yt,Vr||"Unexpected node.",()=>`Node ${he($e?.kind)} was not a '${he(Yt)}' token.`,An||ce)}e.assertOptionalToken=ce;function ne($e,Yt,Vr){S(1,"assertMissingNode")&&D($e===void 0,Yt||"Unexpected node.",()=>`Node ${he($e.kind)} was unexpected'.`,Vr||ne)}e.assertMissingNode=ne;function le($e){}e.type=le;function me($e){if(typeof $e!="function")return"";if(Ho($e,"name"))return $e.name;{let Yt=Function.prototype.toString.call($e),Vr=/^function\s+([\w$]+)\s*\(/.exec(Yt);return Vr?Vr[1]:""}}e.getFunctionName=me;function de($e){return`{ name: ${Qi($e.escapedName)}; flags: ${qe($e.flags)}; declarations: ${Cr($e.declarations,Yt=>he(Yt.kind))} }`}e.formatSymbol=de;function Ae($e=0,Yt,Vr){let An=te(Yt);if($e===0)return An.length>0&&An[0][0]===0?An[0][1]:"0";if(Vr){let vi=[],Ci=$e;for(let[Ui,la]of An){if(Ui>$e)break;Ui!==0&&Ui&$e&&(vi.push(la),Ci&=~Ui)}if(Ci===0)return vi.join("|")}else for(let[vi,Ci]of An)if(vi===$e)return Ci;return $e.toString()}e.formatEnum=Ae;let xe=new Map;function te($e){let Yt=xe.get($e);if(Yt)return Yt;let Vr=[];for(let vi in $e){let Ci=$e[vi];typeof Ci=="number"&&Vr.push([Ci,vi])}let An=Qs(Vr,(vi,Ci)=>tc(vi[0],Ci[0]));return xe.set($e,An),An}function he($e){return Ae($e,$W,!1)}e.formatSyntaxKind=he;function be($e){return Ae($e,a$,!1)}e.formatSnippetKind=be;function Ve($e){return Ae($e,i$,!1)}e.formatScriptKind=Ve;function Pe($e){return Ae($e,HW,!0)}e.formatNodeFlags=Pe;function ke($e){return Ae($e,e$,!0)}e.formatNodeCheckFlags=ke;function De($e){return Ae($e,GW,!0)}e.formatModifierFlags=De;function Be($e){return Ae($e,s$,!0)}e.formatTransformFlags=Be;function ct($e){return Ae($e,o$,!0)}e.formatEmitFlags=ct;function qe($e){return Ae($e,ZW,!0)}e.formatSymbolFlags=qe;function et($e){return Ae($e,t$,!0)}e.formatTypeFlags=et;function Ie($e){return Ae($e,n$,!0)}e.formatSignatureFlags=Ie;function _t($e){return Ae($e,r$,!0)}e.formatObjectFlags=_t;function mt($e){return Ae($e,o5,!0)}e.formatFlowFlags=mt;function Xe($e){return Ae($e,YW,!0)}e.formatRelationComparisonResult=Xe;function ht($e){return Ae($e,dK,!0)}e.formatCheckMode=ht;function rr($e){return Ae($e,mK,!0)}e.formatSignatureCheckMode=rr;function vr($e){return Ae($e,pK,!0)}e.formatTypeFacts=vr;let xr=!1,jr;function ur($e){"__debugFlowFlags"in $e||Object.defineProperties($e,{__tsDebuggerDisplay:{value(){let Yt=this.flags&2?"FlowStart":this.flags&4?"FlowBranchLabel":this.flags&8?"FlowLoopLabel":this.flags&16?"FlowAssignment":this.flags&32?"FlowTrueCondition":this.flags&64?"FlowFalseCondition":this.flags&128?"FlowSwitchClause":this.flags&256?"FlowArrayMutation":this.flags&512?"FlowCall":this.flags&1024?"FlowReduceLabel":this.flags&1?"FlowUnreachable":"UnknownFlow",Vr=this.flags&-2048;return`${Yt}${Vr?` (${mt(Vr)})`:""}`}},__debugFlowFlags:{get(){return Ae(this.flags,o5,!0)}},__debugToString:{value(){return Xs(this)}}})}function or($e){return xr&&(typeof Object.setPrototypeOf=="function"?(jr||(jr=Object.create(Object.prototype),ur(jr)),Object.setPrototypeOf($e,jr)):ur($e)),$e}e.attachFlowNodeDebugInfo=or;let Zr;function Oi($e){"__tsDebuggerDisplay"in $e||Object.defineProperties($e,{__tsDebuggerDisplay:{value(Yt){return Yt=String(Yt).replace(/(?:,[\s\w\d_]+:[^,]+)+\]$/,"]"),`NodeArray ${Yt}`}}})}function Sr($e){xr&&(typeof Object.setPrototypeOf=="function"?(Zr||(Zr=Object.create(Array.prototype),Oi(Zr)),Object.setPrototypeOf($e,Zr)):Oi($e))}e.attachNodeArrayDebugInfo=Sr;function Pi(){if(xr)return;let $e=new WeakMap,Yt=new WeakMap;Object.defineProperties(Hu.getSymbolConstructor().prototype,{__tsDebuggerDisplay:{value(){let An=this.flags&33554432?"TransientSymbol":"Symbol",vi=this.flags&-33554433;return`${An} '${Qc(this)}'${vi?` (${qe(vi)})`:""}`}},__debugFlags:{get(){return qe(this.flags)}}}),Object.defineProperties(Hu.getTypeConstructor().prototype,{__tsDebuggerDisplay:{value(){let An=this.flags&67359327?`IntrinsicType ${this.intrinsicName}${this.debugIntrinsicName?` (${this.debugIntrinsicName})`:""}`:this.flags&98304?"NullableType":this.flags&384?`LiteralType ${JSON.stringify(this.value)}`:this.flags&2048?`LiteralType ${this.value.negative?"-":""}${this.value.base10Value}n`:this.flags&8192?"UniqueESSymbolType":this.flags&32?"EnumType":this.flags&1048576?"UnionType":this.flags&2097152?"IntersectionType":this.flags&4194304?"IndexType":this.flags&8388608?"IndexedAccessType":this.flags&16777216?"ConditionalType":this.flags&33554432?"SubstitutionType":this.flags&262144?"TypeParameter":this.flags&524288?this.objectFlags&3?"InterfaceType":this.objectFlags&4?"TypeReference":this.objectFlags&8?"TupleType":this.objectFlags&16?"AnonymousType":this.objectFlags&32?"MappedType":this.objectFlags&1024?"ReverseMappedType":this.objectFlags&256?"EvolvingArrayType":"ObjectType":"Type",vi=this.flags&524288?this.objectFlags&-1344:0;return`${An}${this.symbol?` '${Qc(this.symbol)}'`:""}${vi?` (${_t(vi)})`:""}`}},__debugFlags:{get(){return et(this.flags)}},__debugObjectFlags:{get(){return this.flags&524288?_t(this.objectFlags):""}},__debugTypeToString:{value(){let An=$e.get(this);return An===void 0&&(An=this.checker.typeToString(this),$e.set(this,An)),An}}}),Object.defineProperties(Hu.getSignatureConstructor().prototype,{__debugFlags:{get(){return Ie(this.flags)}},__debugSignatureToString:{value(){var An;return(An=this.checker)==null?void 0:An.signatureToString(this)}}});let Vr=[Hu.getNodeConstructor(),Hu.getIdentifierConstructor(),Hu.getTokenConstructor(),Hu.getSourceFileConstructor()];for(let An of Vr)Ho(An.prototype,"__debugKind")||Object.defineProperties(An.prototype,{__tsDebuggerDisplay:{value(){return`${xc(this)?"GeneratedIdentifier":He(this)?`Identifier '${Nn(this)}'`:Zi(this)?`PrivateIdentifier '${Nn(this)}'`:La(this)?`StringLiteral ${JSON.stringify(this.text.length<10?this.text:this.text.slice(10)+"...")}`:Pf(this)?`NumericLiteral ${this.text}`:o8(this)?`BigIntLiteral ${this.text}n`:Ac(this)?"TypeParameterDeclaration":ns(this)?"ParameterDeclaration":Vc(this)?"ConstructorDeclaration":Hp(this)?"GetAccessorDeclaration":fp(this)?"SetAccessorDeclaration":MA(this)?"CallSignatureDeclaration":u8(this)?"ConstructSignatureDeclaration":fE(this)?"IndexSignatureDeclaration":LA(this)?"TypePredicateNode":Gp(this)?"TypeReferenceNode":Jh(this)?"FunctionTypeNode":gN(this)?"ConstructorTypeNode":pE(this)?"TypeQueryNode":lf(this)?"TypeLiteralNode":_8(this)?"ArrayTypeNode":FA(this)?"TupleTypeNode":wj(this)?"OptionalTypeNode":Ij(this)?"RestTypeNode":Z1(this)?"UnionTypeNode":jA(this)?"IntersectionTypeNode":dE(this)?"ConditionalTypeNode":s2(this)?"InferTypeNode":a2(this)?"ParenthesizedTypeNode":yN(this)?"ThisTypeNode":yb(this)?"TypeOperatorNode":mE(this)?"IndexedAccessTypeNode":o2(this)?"MappedTypeNode":Mv(this)?"LiteralTypeNode":hN(this)?"NamedTupleMember":qh(this)?"ImportTypeNode":he(this.kind)}${this.flags?` (${Pe(this.flags)})`:""}`}},__debugKind:{get(){return he(this.kind)}},__debugNodeFlags:{get(){return Pe(this.flags)}},__debugModifierFlags:{get(){return De(Vfe(this))}},__debugTransformFlags:{get(){return Be(this.transformFlags)}},__debugIsParseTreeNode:{get(){return pI(this)}},__debugEmitFlags:{get(){return ct(Ga(this))}},__debugGetText:{value(vi){if(Ko(this))return"";let Ci=Yt.get(this);if(Ci===void 0){let Ui=ks(this),la=Ui&&Ur(Ui);Ci=la?GT(la,Ui,vi):"",Yt.set(this,Ci)}return Ci}}});xr=!0}e.enableDebugInfo=Pi;function Cs($e){let Yt=$e&7,Vr=Yt===0?"in out":Yt===3?"[bivariant]":Yt===2?"in":Yt===1?"out":Yt===4?"[independent]":"";return $e&8?Vr+=" (unmeasurable)":$e&16&&(Vr+=" (unreliable)"),Vr}e.formatVariance=Cs;class ss{__debugToString(){var Yt;switch(this.kind){case 3:return((Yt=this.debugInfo)==null?void 0:Yt.call(this))||"(function mapper)";case 0:return`${this.source.__debugTypeToString()} -> ${this.target.__debugTypeToString()}`;case 1:return ho(this.sources,this.targets||Cr(this.sources,()=>"any"),(Vr,An)=>`${Vr.__debugTypeToString()} -> ${typeof An=="string"?An:An.__debugTypeToString()}`).join(", ");case 2:return ho(this.sources,this.targets,(Vr,An)=>`${Vr.__debugTypeToString()} -> ${An().__debugTypeToString()}`).join(", ");case 5:case 4:return`m1: ${this.mapper1.__debugToString().split(`
`).join(`
    `)}
m2: ${this.mapper2.__debugToString().split(`
`).join(`
    `)}`;default:return W(this)}}}e.DebugTypeMapper=ss;function Ii($e){return e.isDebugging?Object.setPrototypeOf($e,ss.prototype):$e}e.attachDebugPrototypeIfDebug=Ii;function $r($e){return console.log(Xs($e))}e.printControlFlowGraph=$r;function Xs($e){let Yt=-1;function Vr(z){return z.id||(z.id=Yt,Yt--),z.id}let An;(z=>{z.lr="\u2500",z.ud="\u2502",z.dr="\u256D",z.dl="\u256E",z.ul="\u256F",z.ur="\u2570",z.udr="\u251C",z.udl="\u2524",z.dlr="\u252C",z.ulr="\u2534",z.udlr="\u256B"})(An||(An={}));let vi;(z=>{z[z.None=0]="None",z[z.Up=1]="Up",z[z.Down=2]="Down",z[z.Left=4]="Left",z[z.Right=8]="Right",z[z.UpDown=3]="UpDown",z[z.LeftRight=12]="LeftRight",z[z.UpLeft=5]="UpLeft",z[z.UpRight=9]="UpRight",z[z.DownLeft=6]="DownLeft",z[z.DownRight=10]="DownRight",z[z.UpDownLeft=7]="UpDownLeft",z[z.UpDownRight=11]="UpDownRight",z[z.UpLeftRight=13]="UpLeftRight",z[z.DownLeftRight=14]="DownLeftRight",z[z.UpDownLeftRight=15]="UpDownLeftRight",z[z.NoChildren=16]="NoChildren"})(vi||(vi={}));let Ci=2032,Ui=882,la=Object.create(null),Gs=[],yr=[],to=ft($e,new Set);for(let z of Gs)z.text=Z(z.flowNode,z.circular),Oe(z);let lt=At(to),St=Nt(lt);return Ut(to,0),Ge();function fe(z){return!!(z.flags&128)}function vt(z){return!!(z.flags&12)&&!!z.antecedent}function Ce(z){return!!(z.flags&Ci)}function nt(z){return!!(z.flags&Ui)}function Me(z){let Ue=[];for(let Te of z.edges)Te.source===z&&Ue.push(Te.target);return Ue}function tt(z){let Ue=[];for(let Te of z.edges)Te.target===z&&Ue.push(Te.source);return Ue}function ft(z,Ue){let Te=Vr(z),Re=la[Te];if(Re&&Ue.has(z))return Re.circular=!0,Re={id:-1,flowNode:z,edges:[],text:"",lane:-1,endLane:-1,level:-1,circular:"circularity"},Gs.push(Re),Re;if(Ue.add(z),!Re)if(la[Te]=Re={id:Te,flowNode:z,edges:[],text:"",lane:-1,endLane:-1,level:-1,circular:!1},Gs.push(Re),vt(z))for(let It of z.antecedent)tr(Re,It,Ue);else Ce(z)&&tr(Re,z.antecedent,Ue);return Ue.delete(z),Re}function tr(z,Ue,Te){let Re=ft(Ue,Te),It={source:z,target:Re};yr.push(It),z.edges.push(It),Re.edges.push(It)}function Oe(z){if(z.level!==-1)return z.level;let Ue=0;for(let Te of tt(z))Ue=Math.max(Ue,Oe(Te)+1);return z.level=Ue}function At(z){let Ue=0;for(let Te of Me(z))Ue=Math.max(Ue,At(Te));return Ue+1}function Nt(z){let Ue=Q(Array(z),0);for(let Te of Gs)Ue[Te.level]=Math.max(Ue[Te.level],Te.text.length);return Ue}function Ut(z,Ue){if(z.lane===-1){z.lane=Ue,z.endLane=Ue;let Te=Me(z);for(let Re=0;Re<Te.length;Re++){Re>0&&Ue++;let It=Te[Re];Ut(It,Ue),It.endLane>z.endLane&&(Ue=It.endLane)}z.endLane=Ue}}function Rt(z){if(z&2)return"Start";if(z&4)return"Branch";if(z&8)return"Loop";if(z&16)return"Assignment";if(z&32)return"True";if(z&64)return"False";if(z&128)return"SwitchClause";if(z&256)return"ArrayMutation";if(z&512)return"Call";if(z&1024)return"ReduceLabel";if(z&1)return"Unreachable";throw new Error}function nr(z){let Ue=Ur(z);return GT(Ue,z,!1)}function Z(z,Ue){let Te=Rt(z.flags);if(Ue&&(Te=`${Te}#${Vr(z)}`),fe(z)){let Re=[],{switchStatement:It,clauseStart:$t,clauseEnd:Ht}=z.node;for(let dr=$t;dr<Ht;dr++){let qr=It.caseBlock.clauses[dr];IO(qr)?Re.push("default"):Re.push(nr(qr.expression))}Te+=` (${Re.join(", ")})`}else nt(z)&&z.node&&(Te+=` (${nr(z.node)})`);return Ue==="circularity"?`Circular(${Te})`:Te}function Ge(){let z=St.length,Ue=Gs.reduce((Ht,dr)=>Math.max(Ht,dr.lane),0)+1,Te=Q(Array(Ue),""),Re=St.map(()=>Array(Ue)),It=St.map(()=>Q(Array(Ue),0));for(let Ht of Gs){Re[Ht.level][Ht.lane]=Ht;let dr=Me(Ht);for(let Hr=0;Hr<dr.length;Hr++){let dn=dr[Hr],Ar=8;dn.lane===Ht.lane&&(Ar|=4),Hr>0&&(Ar|=1),Hr<dr.length-1&&(Ar|=2),It[Ht.level][dn.lane]|=Ar}dr.length===0&&(It[Ht.level][Ht.lane]|=16);let qr=tt(Ht);for(let Hr=0;Hr<qr.length;Hr++){let dn=qr[Hr],Ar=4;Hr>0&&(Ar|=1),Hr<qr.length-1&&(Ar|=2),It[Ht.level-1][dn.lane]|=Ar}}for(let Ht=0;Ht<z;Ht++)for(let dr=0;dr<Ue;dr++){let qr=Ht>0?It[Ht-1][dr]:0,Hr=dr>0?It[Ht][dr-1]:0,dn=It[Ht][dr];dn||(qr&8&&(dn|=12),Hr&2&&(dn|=3),It[Ht][dr]=dn)}for(let Ht=0;Ht<z;Ht++)for(let dr=0;dr<Te.length;dr++){let qr=It[Ht][dr],Hr=qr&4?"\u2500":" ",dn=Re[Ht][dr];dn?($t(dr,dn.text),Ht<z-1&&($t(dr," "),$t(dr,Ke(Hr,St[Ht]-dn.text.length)))):Ht<z-1&&$t(dr,Ke(Hr,St[Ht]+1)),$t(dr,bt(qr)),$t(dr,qr&8&&Ht<z-1&&!Re[Ht+1][dr]?"\u2500":" ")}return`
${Te.join(`
`)}
`;function $t(Ht,dr){Te[Ht]+=dr}}function bt(z){switch(z){case 3:return"\u2502";case 12:return"\u2500";case 5:return"\u256F";case 9:return"\u2570";case 6:return"\u256E";case 10:return"\u256D";case 7:return"\u2524";case 11:return"\u251C";case 13:return"\u2534";case 14:return"\u252C";case 15:return"\u256B"}return" "}function Q(z,Ue){if(z.fill)z.fill(Ue);else for(let Te=0;Te<z.length;Te++)z[Te]=Ue;return z}function Ke(z,Ue){if(z.repeat)return Ue>0?z.repeat(Ue):"";let Te="";for(;Te.length<Ue;)Te+=z;return Te}}e.formatControlFlowGraph=Xs})(M||(M={}));var hvt=/^(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i,yvt=/^(?:0|[1-9]\d*|[a-z-][a-z0-9-]*)(?:\.(?:0|[1-9]\d*|[a-z-][a-z0-9-]*))*$/i,vvt=/^(?:0|[1-9]\d*|[a-z-][a-z0-9-]*)$/i,Svt=/^[a-z0-9-]+(?:\.[a-z0-9-]+)*$/i,bvt=/^[a-z0-9-]+$/i,hOe=/^(0|[1-9]\d*)$/,rle=class mF{constructor(t,n=0,i=0,s="",o=""){typeof t=="string"&&({major:t,minor:n,patch:i,prerelease:s,build:o}=M.checkDefined(yOe(t),"Invalid version")),M.assert(t>=0,"Invalid argument: major"),M.assert(n>=0,"Invalid argument: minor"),M.assert(i>=0,"Invalid argument: patch");let u=s?Rs(s)?s:s.split("."):ve,m=o?Rs(o)?o:o.split("."):ve;M.assert(wi(u,d=>vvt.test(d)),"Invalid argument: prerelease"),M.assert(wi(m,d=>bvt.test(d)),"Invalid argument: build"),this.major=t,this.minor=n,this.patch=i,this.prerelease=u,this.build=m}static tryParse(t){let n=yOe(t);if(!n)return;let{major:i,minor:s,patch:o,prerelease:u,build:m}=n;return new mF(i,s,o,u,m)}compareTo(t){return this===t?0:t===void 0?1:tc(this.major,t.major)||tc(this.minor,t.minor)||tc(this.patch,t.patch)||Tvt(this.prerelease,t.prerelease)}increment(t){switch(t){case"major":return new mF(this.major+1,0,0);case"minor":return new mF(this.major,this.minor+1,0);case"patch":return new mF(this.major,this.minor,this.patch+1);default:return M.assertNever(t)}}with(t){let{major:n=this.major,minor:i=this.minor,patch:s=this.patch,prerelease:o=this.prerelease,build:u=this.build}=t;return new mF(n,i,s,o,u)}toString(){let t=`${this.major}.${this.minor}.${this.patch}`;return Pt(this.prerelease)&&(t+=`-${this.prerelease.join(".")}`),Pt(this.build)&&(t+=`+${this.build.join(".")}`),t}};rle.zero=new rle(0,0,0,["0"]);var Km=rle;function yOe(e){let t=hvt.exec(e);if(!t)return;let[,n,i="0",s="0",o="",u=""]=t;if(!(o&&!yvt.test(o))&&!(u&&!Svt.test(u)))return{major:parseInt(n,10),minor:parseInt(i,10),patch:parseInt(s,10),prerelease:o,build:u}}function Tvt(e,t){if(e===t)return 0;if(e.length===0)return t.length===0?0:1;if(t.length===0)return-1;let n=Math.min(e.length,t.length);for(let i=0;i<n;i++){let s=e[i],o=t[i];if(s===o)continue;let u=hOe.test(s),m=hOe.test(o);if(u||m){if(u!==m)return u?-1:1;let d=tc(+s,+o);if(d)return d}else{let d=c_(s,o);if(d)return d}}return tc(e.length,t.length)}var s5=class Cpt{constructor(t){this._alternatives=t?M.checkDefined(vOe(t),"Invalid range spec."):ve}static tryParse(t){let n=vOe(t);if(n){let i=new Cpt("");return i._alternatives=n,i}}test(t){return typeof t=="string"&&(t=new Km(t)),Dvt(t,this._alternatives)}toString(){return Ovt(this._alternatives)}},Evt=/\|\|/g,xvt=/\s+/g,Cvt=/^([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i,Avt=/^\s*([a-z0-9-+.*]+)\s+-\s+([a-z0-9-+.*]+)\s*$/i,kvt=/^(~|\^|<|<=|>|>=|=)?\s*([a-z0-9-+.*]+)$/i;function vOe(e){let t=[];for(let n of e.trim().split(Evt)){if(!n)continue;let i=[];n=n.trim();let s=Avt.exec(n);if(s){if(!Pvt(s[1],s[2],i))return}else for(let o of n.split(xvt)){let u=kvt.exec(o.trim());if(!u||!Nvt(u[1],u[2],i))return}t.push(i)}return t}function nle(e){let t=Cvt.exec(e);if(!t)return;let[,n,i="*",s="*",o,u]=t;return{version:new Km(Hd(n)?0:parseInt(n,10),Hd(n)||Hd(i)?0:parseInt(i,10),Hd(n)||Hd(i)||Hd(s)?0:parseInt(s,10),o,u),major:n,minor:i,patch:s}}function Pvt(e,t,n){let i=nle(e);if(!i)return!1;let s=nle(t);return s?(Hd(i.major)||n.push(Oh(">=",i.version)),Hd(s.major)||n.push(Hd(s.minor)?Oh("<",s.version.increment("major")):Hd(s.patch)?Oh("<",s.version.increment("minor")):Oh("<=",s.version)),!0):!1}function Nvt(e,t,n){let i=nle(t);if(!i)return!1;let{version:s,major:o,minor:u,patch:m}=i;if(Hd(o))(e==="<"||e===">")&&n.push(Oh("<",Km.zero));else switch(e){case"~":n.push(Oh(">=",s)),n.push(Oh("<",s.increment(Hd(u)?"major":"minor")));break;case"^":n.push(Oh(">=",s)),n.push(Oh("<",s.increment(s.major>0||Hd(u)?"major":s.minor>0||Hd(m)?"minor":"patch")));break;case"<":case">=":n.push(Hd(u)||Hd(m)?Oh(e,s.with({prerelease:"0"})):Oh(e,s));break;case"<=":case">":n.push(Hd(u)?Oh(e==="<="?"<":">=",s.increment("major").with({prerelease:"0"})):Hd(m)?Oh(e==="<="?"<":">=",s.increment("minor").with({prerelease:"0"})):Oh(e,s));break;case"=":case void 0:Hd(u)||Hd(m)?(n.push(Oh(">=",s.with({prerelease:"0"}))),n.push(Oh("<",s.increment(Hd(u)?"major":"minor").with({prerelease:"0"})))):n.push(Oh("=",s));break;default:return!1}return!0}function Hd(e){return e==="*"||e==="x"||e==="X"}function Oh(e,t){return{operator:e,operand:t}}function Dvt(e,t){if(t.length===0)return!0;for(let n of t)if(wvt(e,n))return!0;return!1}function wvt(e,t){for(let n of t)if(!Ivt(e,n.operator,n.operand))return!1;return!0}function Ivt(e,t,n){let i=e.compareTo(n);switch(t){case"<":return i<0;case"<=":return i<=0;case">":return i>0;case">=":return i>=0;case"=":return i===0;default:return M.assertNever(t)}}function Ovt(e){return Cr(e,Rvt).join(" || ")||"*"}function Rvt(e){return Cr(e,Mvt).join(" ")}function Mvt(e){return`${e.operator}${e.operand}`}function Lvt(){if(JW())try{let{performance:e}=Bu("perf_hooks");if(e)return{shouldWriteNativeEvents:!1,performance:e}}catch{}if(typeof performance=="object")return{shouldWriteNativeEvents:!0,performance}}function Fvt(){let e=Lvt();if(!e)return;let{shouldWriteNativeEvents:t,performance:n}=e,i={shouldWriteNativeEvents:t,performance:void 0,performanceTime:void 0};return typeof n.timeOrigin=="number"&&typeof n.now=="function"&&(i.performanceTime=n),i.performanceTime&&typeof n.mark=="function"&&typeof n.measure=="function"&&typeof n.clearMarks=="function"&&typeof n.clearMeasures=="function"&&(i.performance=n),i}var ile=Fvt(),SOe=ile?.performanceTime;function sle(){return ile}var Tc=SOe?()=>SOe.now():Date.now,a5;try{let e=process.env.TS_ETW_MODULE_PATH??"./node_modules/@microsoft/typescript-etw";a5=Bu(e)}catch{a5=void 0}var rf=a5?.logEvent?a5:void 0,ale={};A(ale,{clearMarks:()=>AOe,clearMeasures:()=>COe,createTimer:()=>qW,createTimerIf:()=>bOe,disable:()=>lle,enable:()=>WW,forEachMark:()=>xOe,forEachMeasure:()=>zW,getCount:()=>EOe,getDuration:()=>eI,isEnabled:()=>cle,mark:()=>jc,measure:()=>vd,nullTimer:()=>ole});var Kw,jx;function bOe(e,t,n,i){return e?qW(t,n,i):ole}function qW(e,t,n){let i=0;return{enter:s,exit:o};function s(){++i===1&&jc(t)}function o(){--i===0?(jc(n),vd(e,t,n)):i<0&&M.fail("enter/exit count does not match.")}}var ole={enter:io,exit:io},Xw=!1,TOe=Tc(),Qw=new Map,g3=new Map,Zw=new Map;function jc(e){if(Xw){let t=g3.get(e)??0;g3.set(e,t+1),Qw.set(e,Tc()),jx?.mark(e),typeof onProfilerEvent=="function"&&onProfilerEvent(e)}}function vd(e,t,n){if(Xw){let i=(n!==void 0?Qw.get(n):void 0)??Tc(),s=(t!==void 0?Qw.get(t):void 0)??TOe,o=Zw.get(e)||0;Zw.set(e,o+(i-s)),jx?.measure(e,t,n)}}function EOe(e){return g3.get(e)||0}function eI(e){return Zw.get(e)||0}function zW(e){Zw.forEach((t,n)=>e(n,t))}function xOe(e){Qw.forEach((t,n)=>e(n))}function COe(e){e!==void 0?Zw.delete(e):Zw.clear(),jx?.clearMeasures(e)}function AOe(e){e!==void 0?(g3.delete(e),Qw.delete(e)):(g3.clear(),Qw.clear()),jx?.clearMarks(e)}function cle(){return Xw}function WW(e=lu){var t;return Xw||(Xw=!0,Kw||(Kw=sle()),Kw?.performance&&(TOe=Kw.performance.timeOrigin,(Kw.shouldWriteNativeEvents||(t=e?.cpuProfilingEnabled)!=null&&t.call(e)||e?.debugMode)&&(jx=Kw.performance))),!0}function lle(){Xw&&(Qw.clear(),g3.clear(),Zw.clear(),jx=void 0,Xw=!1)}var Cn,h3;(e=>{let t,n=0,i=0,s,o=[],u,m=[];function d(K,re,ue){if(M.assert(!Cn,"Tracing already started"),t===void 0)try{t=Bu("fs")}catch(de){throw new Error(`tracing requires having fs
(original error: ${de.message||de})`)}s=K,o.length=0,u===void 0&&(u=ri(re,"legend.json")),t.existsSync(re)||t.mkdirSync(re,{recursive:!0});let ce=s==="build"?`.${process.pid}-${++n}`:s==="server"?`.${process.pid}`:"",ne=ri(re,`trace${ce}.json`),le=ri(re,`types${ce}.json`);m.push({configFilePath:ue,tracePath:ne,typesPath:le}),i=t.openSync(ne,"w"),Cn=e;let me={cat:"__metadata",ph:"M",ts:1e3*Tc(),pid:1,tid:1};t.writeSync(i,`[
`+[{name:"process_name",args:{name:"tsc"},...me},{name:"thread_name",args:{name:"Main"},...me},{name:"TracingStartedInBrowser",...me,cat:"disabled-by-default-devtools.timeline"}].map(de=>JSON.stringify(de)).join(`,
`))}e.startTracing=d;function S(){M.assert(Cn,"Tracing is not in progress"),M.assert(!!o.length==(s!=="server")),t.writeSync(i,`
]
`),t.closeSync(i),Cn=void 0,o.length?W(o):m[m.length-1].typesPath=void 0}e.stopTracing=S;function E(K){s!=="server"&&o.push(K)}e.recordType=E;let x;(K=>{K.Parse="parse",K.Program="program",K.Bind="bind",K.Check="check",K.CheckTypes="checkTypes",K.Emit="emit",K.Session="session"})(x=e.Phase||(e.Phase={}));function D(K,re,ue){q("I",K,re,ue,'"s":"g"')}e.instant=D;let w=[];function R(K,re,ue,ce=!1){ce&&q("B",K,re,ue),w.push({phase:K,name:re,args:ue,time:1e3*Tc(),separateBeginAndEnd:ce})}e.push=R;function L(K){M.assert(w.length>0),G(w.length-1,1e3*Tc(),K),w.length--}e.pop=L;function F(){let K=1e3*Tc();for(let re=w.length-1;re>=0;re--)G(re,K);w.length=0}e.popAll=F;let J=1e3*10;function G(K,re,ue){let{phase:ce,name:ne,args:le,time:me,separateBeginAndEnd:de}=w[K];de?(M.assert(!ue,"`results` are not supported for events with `separateBeginAndEnd`"),q("E",ce,ne,le,void 0,re)):J-me%J<=re-me&&q("X",ce,ne,{...le,results:ue},`"dur":${re-me}`,me)}function q(K,re,ue,ce,ne,le=1e3*Tc()){s==="server"&&re==="checkTypes"||(jc("beginTracing"),t.writeSync(i,`,
{"pid":1,"tid":1,"ph":"${K}","cat":"${re}","ts":${le},"name":"${ue}"`),ne&&t.writeSync(i,`,${ne}`),ce&&t.writeSync(i,`,"args":${JSON.stringify(ce)}`),t.writeSync(i,"}"),jc("endTracing"),vd("Tracing","beginTracing","endTracing"))}function ee(K){let re=Ur(K);return re?{path:re.path,start:ue(ba(re,K.pos)),end:ue(ba(re,K.end))}:void 0;function ue(ce){return{line:ce.line+1,character:ce.character+1}}}function W(K){var re,ue,ce,ne,le,me,de,Ae,xe,te,he,be,Ve,Pe,ke,De,Be,ct,qe;jc("beginDumpTypes");let et=m[m.length-1].typesPath,Ie=t.openSync(et,"w"),_t=new Map;t.writeSync(Ie,"[");let mt=K.length;for(let Xe=0;Xe<mt;Xe++){let ht=K[Xe],rr=ht.objectFlags,vr=ht.aliasSymbol??ht.symbol,xr;if(rr&16|ht.flags&2944)try{xr=(re=ht.checker)==null?void 0:re.typeToString(ht)}catch{xr=void 0}let jr={};if(ht.flags&8388608){let Ii=ht;jr={indexedAccessObjectType:(ue=Ii.objectType)==null?void 0:ue.id,indexedAccessIndexType:(ce=Ii.indexType)==null?void 0:ce.id}}let ur={};if(rr&4){let Ii=ht;ur={instantiatedType:(ne=Ii.target)==null?void 0:ne.id,typeArguments:(le=Ii.resolvedTypeArguments)==null?void 0:le.map($r=>$r.id),referenceLocation:ee(Ii.node)}}let or={};if(ht.flags&16777216){let Ii=ht;or={conditionalCheckType:(me=Ii.checkType)==null?void 0:me.id,conditionalExtendsType:(de=Ii.extendsType)==null?void 0:de.id,conditionalTrueType:((Ae=Ii.resolvedTrueType)==null?void 0:Ae.id)??-1,conditionalFalseType:((xe=Ii.resolvedFalseType)==null?void 0:xe.id)??-1}}let Zr={};if(ht.flags&33554432){let Ii=ht;Zr={substitutionBaseType:(te=Ii.baseType)==null?void 0:te.id,constraintType:(he=Ii.constraint)==null?void 0:he.id}}let Oi={};if(rr&1024){let Ii=ht;Oi={reverseMappedSourceType:(be=Ii.source)==null?void 0:be.id,reverseMappedMappedType:(Ve=Ii.mappedType)==null?void 0:Ve.id,reverseMappedConstraintType:(Pe=Ii.constraintType)==null?void 0:Pe.id}}let Sr={};if(rr&256){let Ii=ht;Sr={evolvingArrayElementType:Ii.elementType.id,evolvingArrayFinalType:(ke=Ii.finalArrayType)==null?void 0:ke.id}}let Pi,Cs=ht.checker.getRecursionIdentity(ht);Cs&&(Pi=_t.get(Cs),Pi||(Pi=_t.size,_t.set(Cs,Pi)));let ss={id:ht.id,intrinsicName:ht.intrinsicName,symbolName:vr?.escapedName&&Qi(vr.escapedName),recursionId:Pi,isTuple:rr&8?!0:void 0,unionTypes:ht.flags&1048576?(De=ht.types)==null?void 0:De.map(Ii=>Ii.id):void 0,intersectionTypes:ht.flags&2097152?ht.types.map(Ii=>Ii.id):void 0,aliasTypeArguments:(Be=ht.aliasTypeArguments)==null?void 0:Be.map(Ii=>Ii.id),keyofType:ht.flags&4194304?(ct=ht.type)==null?void 0:ct.id:void 0,...jr,...ur,...or,...Zr,...Oi,...Sr,destructuringPattern:ee(ht.pattern),firstDeclaration:ee((qe=vr?.declarations)==null?void 0:qe[0]),flags:M.formatTypeFlags(ht.flags).split("|"),display:xr};t.writeSync(Ie,JSON.stringify(ss)),Xe<mt-1&&t.writeSync(Ie,`,
`)}t.writeSync(Ie,`]
`),t.closeSync(Ie),jc("endDumpTypes"),vd("Dump types","beginDumpTypes","endDumpTypes")}function pe(){u&&t.writeFileSync(u,JSON.stringify(m))}e.dumpLegend=pe})(h3||(h3={}));var ule=h3.startTracing,_le=h3.dumpLegend,$W=(e=>(e[e.Unknown=0]="Unknown",e[e.EndOfFileToken=1]="EndOfFileToken",e[e.SingleLineCommentTrivia=2]="SingleLineCommentTrivia",e[e.MultiLineCommentTrivia=3]="MultiLineCommentTrivia",e[e.NewLineTrivia=4]="NewLineTrivia",e[e.WhitespaceTrivia=5]="WhitespaceTrivia",e[e.ShebangTrivia=6]="ShebangTrivia",e[e.ConflictMarkerTrivia=7]="ConflictMarkerTrivia",e[e.NonTextFileMarkerTrivia=8]="NonTextFileMarkerTrivia",e[e.NumericLiteral=9]="NumericLiteral",e[e.BigIntLiteral=10]="BigIntLiteral",e[e.StringLiteral=11]="StringLiteral",e[e.JsxText=12]="JsxText",e[e.JsxTextAllWhiteSpaces=13]="JsxTextAllWhiteSpaces",e[e.RegularExpressionLiteral=14]="RegularExpressionLiteral",e[e.NoSubstitutionTemplateLiteral=15]="NoSubstitutionTemplateLiteral",e[e.TemplateHead=16]="TemplateHead",e[e.TemplateMiddle=17]="TemplateMiddle",e[e.TemplateTail=18]="TemplateTail",e[e.OpenBraceToken=19]="OpenBraceToken",e[e.CloseBraceToken=20]="CloseBraceToken",e[e.OpenParenToken=21]="OpenParenToken",e[e.CloseParenToken=22]="CloseParenToken",e[e.OpenBracketToken=23]="OpenBracketToken",e[e.CloseBracketToken=24]="CloseBracketToken",e[e.DotToken=25]="DotToken",e[e.DotDotDotToken=26]="DotDotDotToken",e[e.SemicolonToken=27]="SemicolonToken",e[e.CommaToken=28]="CommaToken",e[e.QuestionDotToken=29]="QuestionDotToken",e[e.LessThanToken=30]="LessThanToken",e[e.LessThanSlashToken=31]="LessThanSlashToken",e[e.GreaterThanToken=32]="GreaterThanToken",e[e.LessThanEqualsToken=33]="LessThanEqualsToken",e[e.GreaterThanEqualsToken=34]="GreaterThanEqualsToken",e[e.EqualsEqualsToken=35]="EqualsEqualsToken",e[e.ExclamationEqualsToken=36]="ExclamationEqualsToken",e[e.EqualsEqualsEqualsToken=37]="EqualsEqualsEqualsToken",e[e.ExclamationEqualsEqualsToken=38]="ExclamationEqualsEqualsToken",e[e.EqualsGreaterThanToken=39]="EqualsGreaterThanToken",e[e.PlusToken=40]="PlusToken",e[e.MinusToken=41]="MinusToken",e[e.AsteriskToken=42]="AsteriskToken",e[e.AsteriskAsteriskToken=43]="AsteriskAsteriskToken",e[e.SlashToken=44]="SlashToken",e[e.PercentToken=45]="PercentToken",e[e.PlusPlusToken=46]="PlusPlusToken",e[e.MinusMinusToken=47]="MinusMinusToken",e[e.LessThanLessThanToken=48]="LessThanLessThanToken",e[e.GreaterThanGreaterThanToken=49]="GreaterThanGreaterThanToken",e[e.GreaterThanGreaterThanGreaterThanToken=50]="GreaterThanGreaterThanGreaterThanToken",e[e.AmpersandToken=51]="AmpersandToken",e[e.BarToken=52]="BarToken",e[e.CaretToken=53]="CaretToken",e[e.ExclamationToken=54]="ExclamationToken",e[e.TildeToken=55]="TildeToken",e[e.AmpersandAmpersandToken=56]="AmpersandAmpersandToken",e[e.BarBarToken=57]="BarBarToken",e[e.QuestionToken=58]="QuestionToken",e[e.ColonToken=59]="ColonToken",e[e.AtToken=60]="AtToken",e[e.QuestionQuestionToken=61]="QuestionQuestionToken",e[e.BacktickToken=62]="BacktickToken",e[e.HashToken=63]="HashToken",e[e.EqualsToken=64]="EqualsToken",e[e.PlusEqualsToken=65]="PlusEqualsToken",e[e.MinusEqualsToken=66]="MinusEqualsToken",e[e.AsteriskEqualsToken=67]="AsteriskEqualsToken",e[e.AsteriskAsteriskEqualsToken=68]="AsteriskAsteriskEqualsToken",e[e.SlashEqualsToken=69]="SlashEqualsToken",e[e.PercentEqualsToken=70]="PercentEqualsToken",e[e.LessThanLessThanEqualsToken=71]="LessThanLessThanEqualsToken",e[e.GreaterThanGreaterThanEqualsToken=72]="GreaterThanGreaterThanEqualsToken",e[e.GreaterThanGreaterThanGreaterThanEqualsToken=73]="GreaterThanGreaterThanGreaterThanEqualsToken",e[e.AmpersandEqualsToken=74]="AmpersandEqualsToken",e[e.BarEqualsToken=75]="BarEqualsToken",e[e.BarBarEqualsToken=76]="BarBarEqualsToken",e[e.AmpersandAmpersandEqualsToken=77]="AmpersandAmpersandEqualsToken",e[e.QuestionQuestionEqualsToken=78]="QuestionQuestionEqualsToken",e[e.CaretEqualsToken=79]="CaretEqualsToken",e[e.Identifier=80]="Identifier",e[e.PrivateIdentifier=81]="PrivateIdentifier",e[e.JSDocCommentTextToken=82]="JSDocCommentTextToken",e[e.BreakKeyword=83]="BreakKeyword",e[e.CaseKeyword=84]="CaseKeyword",e[e.CatchKeyword=85]="CatchKeyword",e[e.ClassKeyword=86]="ClassKeyword",e[e.ConstKeyword=87]="ConstKeyword",e[e.ContinueKeyword=88]="ContinueKeyword",e[e.DebuggerKeyword=89]="DebuggerKeyword",e[e.DefaultKeyword=90]="DefaultKeyword",e[e.DeleteKeyword=91]="DeleteKeyword",e[e.DoKeyword=92]="DoKeyword",e[e.ElseKeyword=93]="ElseKeyword",e[e.EnumKeyword=94]="EnumKeyword",e[e.ExportKeyword=95]="ExportKeyword",e[e.ExtendsKeyword=96]="ExtendsKeyword",e[e.FalseKeyword=97]="FalseKeyword",e[e.FinallyKeyword=98]="FinallyKeyword",e[e.ForKeyword=99]="ForKeyword",e[e.FunctionKeyword=100]="FunctionKeyword",e[e.IfKeyword=101]="IfKeyword",e[e.ImportKeyword=102]="ImportKeyword",e[e.InKeyword=103]="InKeyword",e[e.InstanceOfKeyword=104]="InstanceOfKeyword",e[e.NewKeyword=105]="NewKeyword",e[e.NullKeyword=106]="NullKeyword",e[e.ReturnKeyword=107]="ReturnKeyword",e[e.SuperKeyword=108]="SuperKeyword",e[e.SwitchKeyword=109]="SwitchKeyword",e[e.ThisKeyword=110]="ThisKeyword",e[e.ThrowKeyword=111]="ThrowKeyword",e[e.TrueKeyword=112]="TrueKeyword",e[e.TryKeyword=113]="TryKeyword",e[e.TypeOfKeyword=114]="TypeOfKeyword",e[e.VarKeyword=115]="VarKeyword",e[e.VoidKeyword=116]="VoidKeyword",e[e.WhileKeyword=117]="WhileKeyword",e[e.WithKeyword=118]="WithKeyword",e[e.ImplementsKeyword=119]="ImplementsKeyword",e[e.InterfaceKeyword=120]="InterfaceKeyword",e[e.LetKeyword=121]="LetKeyword",e[e.PackageKeyword=122]="PackageKeyword",e[e.PrivateKeyword=123]="PrivateKeyword",e[e.ProtectedKeyword=124]="ProtectedKeyword",e[e.PublicKeyword=125]="PublicKeyword",e[e.StaticKeyword=126]="StaticKeyword",e[e.YieldKeyword=127]="YieldKeyword",e[e.AbstractKeyword=128]="AbstractKeyword",e[e.AccessorKeyword=129]="AccessorKeyword",e[e.AsKeyword=130]="AsKeyword",e[e.AssertsKeyword=131]="AssertsKeyword",e[e.AssertKeyword=132]="AssertKeyword",e[e.AnyKeyword=133]="AnyKeyword",e[e.AsyncKeyword=134]="AsyncKeyword",e[e.AwaitKeyword=135]="AwaitKeyword",e[e.BooleanKeyword=136]="BooleanKeyword",e[e.ConstructorKeyword=137]="ConstructorKeyword",e[e.DeclareKeyword=138]="DeclareKeyword",e[e.GetKeyword=139]="GetKeyword",e[e.InferKeyword=140]="InferKeyword",e[e.IntrinsicKeyword=141]="IntrinsicKeyword",e[e.IsKeyword=142]="IsKeyword",e[e.KeyOfKeyword=143]="KeyOfKeyword",e[e.ModuleKeyword=144]="ModuleKeyword",e[e.NamespaceKeyword=145]="NamespaceKeyword",e[e.NeverKeyword=146]="NeverKeyword",e[e.OutKeyword=147]="OutKeyword",e[e.ReadonlyKeyword=148]="ReadonlyKeyword",e[e.RequireKeyword=149]="RequireKeyword",e[e.NumberKeyword=150]="NumberKeyword",e[e.ObjectKeyword=151]="ObjectKeyword",e[e.SatisfiesKeyword=152]="SatisfiesKeyword",e[e.SetKeyword=153]="SetKeyword",e[e.StringKeyword=154]="StringKeyword",e[e.SymbolKeyword=155]="SymbolKeyword",e[e.TypeKeyword=156]="TypeKeyword",e[e.UndefinedKeyword=157]="UndefinedKeyword",e[e.UniqueKeyword=158]="UniqueKeyword",e[e.UnknownKeyword=159]="UnknownKeyword",e[e.UsingKeyword=160]="UsingKeyword",e[e.FromKeyword=161]="FromKeyword",e[e.GlobalKeyword=162]="GlobalKeyword",e[e.BigIntKeyword=163]="BigIntKeyword",e[e.OverrideKeyword=164]="OverrideKeyword",e[e.OfKeyword=165]="OfKeyword",e[e.QualifiedName=166]="QualifiedName",e[e.ComputedPropertyName=167]="ComputedPropertyName",e[e.TypeParameter=168]="TypeParameter",e[e.Parameter=169]="Parameter",e[e.Decorator=170]="Decorator",e[e.PropertySignature=171]="PropertySignature",e[e.PropertyDeclaration=172]="PropertyDeclaration",e[e.MethodSignature=173]="MethodSignature",e[e.MethodDeclaration=174]="MethodDeclaration",e[e.ClassStaticBlockDeclaration=175]="ClassStaticBlockDeclaration",e[e.Constructor=176]="Constructor",e[e.GetAccessor=177]="GetAccessor",e[e.SetAccessor=178]="SetAccessor",e[e.CallSignature=179]="CallSignature",e[e.ConstructSignature=180]="ConstructSignature",e[e.IndexSignature=181]="IndexSignature",e[e.TypePredicate=182]="TypePredicate",e[e.TypeReference=183]="TypeReference",e[e.FunctionType=184]="FunctionType",e[e.ConstructorType=185]="ConstructorType",e[e.TypeQuery=186]="TypeQuery",e[e.TypeLiteral=187]="TypeLiteral",e[e.ArrayType=188]="ArrayType",e[e.TupleType=189]="TupleType",e[e.OptionalType=190]="OptionalType",e[e.RestType=191]="RestType",e[e.UnionType=192]="UnionType",e[e.IntersectionType=193]="IntersectionType",e[e.ConditionalType=194]="ConditionalType",e[e.InferType=195]="InferType",e[e.ParenthesizedType=196]="ParenthesizedType",e[e.ThisType=197]="ThisType",e[e.TypeOperator=198]="TypeOperator",e[e.IndexedAccessType=199]="IndexedAccessType",e[e.MappedType=200]="MappedType",e[e.LiteralType=201]="LiteralType",e[e.NamedTupleMember=202]="NamedTupleMember",e[e.TemplateLiteralType=203]="TemplateLiteralType",e[e.TemplateLiteralTypeSpan=204]="TemplateLiteralTypeSpan",e[e.ImportType=205]="ImportType",e[e.ObjectBindingPattern=206]="ObjectBindingPattern",e[e.ArrayBindingPattern=207]="ArrayBindingPattern",e[e.BindingElement=208]="BindingElement",e[e.ArrayLiteralExpression=209]="ArrayLiteralExpression",e[e.ObjectLiteralExpression=210]="ObjectLiteralExpression",e[e.PropertyAccessExpression=211]="PropertyAccessExpression",e[e.ElementAccessExpression=212]="ElementAccessExpression",e[e.CallExpression=213]="CallExpression",e[e.NewExpression=214]="NewExpression",e[e.TaggedTemplateExpression=215]="TaggedTemplateExpression",e[e.TypeAssertionExpression=216]="TypeAssertionExpression",e[e.ParenthesizedExpression=217]="ParenthesizedExpression",e[e.FunctionExpression=218]="FunctionExpression",e[e.ArrowFunction=219]="ArrowFunction",e[e.DeleteExpression=220]="DeleteExpression",e[e.TypeOfExpression=221]="TypeOfExpression",e[e.VoidExpression=222]="VoidExpression",e[e.AwaitExpression=223]="AwaitExpression",e[e.PrefixUnaryExpression=224]="PrefixUnaryExpression",e[e.PostfixUnaryExpression=225]="PostfixUnaryExpression",e[e.BinaryExpression=226]="BinaryExpression",e[e.ConditionalExpression=227]="ConditionalExpression",e[e.TemplateExpression=228]="TemplateExpression",e[e.YieldExpression=229]="YieldExpression",e[e.SpreadElement=230]="SpreadElement",e[e.ClassExpression=231]="ClassExpression",e[e.OmittedExpression=232]="OmittedExpression",e[e.ExpressionWithTypeArguments=233]="ExpressionWithTypeArguments",e[e.AsExpression=234]="AsExpression",e[e.NonNullExpression=235]="NonNullExpression",e[e.MetaProperty=236]="MetaProperty",e[e.SyntheticExpression=237]="SyntheticExpression",e[e.SatisfiesExpression=238]="SatisfiesExpression",e[e.TemplateSpan=239]="TemplateSpan",e[e.SemicolonClassElement=240]="SemicolonClassElement",e[e.Block=241]="Block",e[e.EmptyStatement=242]="EmptyStatement",e[e.VariableStatement=243]="VariableStatement",e[e.ExpressionStatement=244]="ExpressionStatement",e[e.IfStatement=245]="IfStatement",e[e.DoStatement=246]="DoStatement",e[e.WhileStatement=247]="WhileStatement",e[e.ForStatement=248]="ForStatement",e[e.ForInStatement=249]="ForInStatement",e[e.ForOfStatement=250]="ForOfStatement",e[e.ContinueStatement=251]="ContinueStatement",e[e.BreakStatement=252]="BreakStatement",e[e.ReturnStatement=253]="ReturnStatement",e[e.WithStatement=254]="WithStatement",e[e.SwitchStatement=255]="SwitchStatement",e[e.LabeledStatement=256]="LabeledStatement",e[e.ThrowStatement=257]="ThrowStatement",e[e.TryStatement=258]="TryStatement",e[e.DebuggerStatement=259]="DebuggerStatement",e[e.VariableDeclaration=260]="VariableDeclaration",e[e.VariableDeclarationList=261]="VariableDeclarationList",e[e.FunctionDeclaration=262]="FunctionDeclaration",e[e.ClassDeclaration=263]="ClassDeclaration",e[e.InterfaceDeclaration=264]="InterfaceDeclaration",e[e.TypeAliasDeclaration=265]="TypeAliasDeclaration",e[e.EnumDeclaration=266]="EnumDeclaration",e[e.ModuleDeclaration=267]="ModuleDeclaration",e[e.ModuleBlock=268]="ModuleBlock",e[e.CaseBlock=269]="CaseBlock",e[e.NamespaceExportDeclaration=270]="NamespaceExportDeclaration",e[e.ImportEqualsDeclaration=271]="ImportEqualsDeclaration",e[e.ImportDeclaration=272]="ImportDeclaration",e[e.ImportClause=273]="ImportClause",e[e.NamespaceImport=274]="NamespaceImport",e[e.NamedImports=275]="NamedImports",e[e.ImportSpecifier=276]="ImportSpecifier",e[e.ExportAssignment=277]="ExportAssignment",e[e.ExportDeclaration=278]="ExportDeclaration",e[e.NamedExports=279]="NamedExports",e[e.NamespaceExport=280]="NamespaceExport",e[e.ExportSpecifier=281]="ExportSpecifier",e[e.MissingDeclaration=282]="MissingDeclaration",e[e.ExternalModuleReference=283]="ExternalModuleReference",e[e.JsxElement=284]="JsxElement",e[e.JsxSelfClosingElement=285]="JsxSelfClosingElement",e[e.JsxOpeningElement=286]="JsxOpeningElement",e[e.JsxClosingElement=287]="JsxClosingElement",e[e.JsxFragment=288]="JsxFragment",e[e.JsxOpeningFragment=289]="JsxOpeningFragment",e[e.JsxClosingFragment=290]="JsxClosingFragment",e[e.JsxAttribute=291]="JsxAttribute",e[e.JsxAttributes=292]="JsxAttributes",e[e.JsxSpreadAttribute=293]="JsxSpreadAttribute",e[e.JsxExpression=294]="JsxExpression",e[e.JsxNamespacedName=295]="JsxNamespacedName",e[e.CaseClause=296]="CaseClause",e[e.DefaultClause=297]="DefaultClause",e[e.HeritageClause=298]="HeritageClause",e[e.CatchClause=299]="CatchClause",e[e.ImportAttributes=300]="ImportAttributes",e[e.ImportAttribute=301]="ImportAttribute",e[e.AssertClause=300]="AssertClause",e[e.AssertEntry=301]="AssertEntry",e[e.ImportTypeAssertionContainer=302]="ImportTypeAssertionContainer",e[e.PropertyAssignment=303]="PropertyAssignment",e[e.ShorthandPropertyAssignment=304]="ShorthandPropertyAssignment",e[e.SpreadAssignment=305]="SpreadAssignment",e[e.EnumMember=306]="EnumMember",e[e.SourceFile=307]="SourceFile",e[e.Bundle=308]="Bundle",e[e.JSDocTypeExpression=309]="JSDocTypeExpression",e[e.JSDocNameReference=310]="JSDocNameReference",e[e.JSDocMemberName=311]="JSDocMemberName",e[e.JSDocAllType=312]="JSDocAllType",e[e.JSDocUnknownType=313]="JSDocUnknownType",e[e.JSDocNullableType=314]="JSDocNullableType",e[e.JSDocNonNullableType=315]="JSDocNonNullableType",e[e.JSDocOptionalType=316]="JSDocOptionalType",e[e.JSDocFunctionType=317]="JSDocFunctionType",e[e.JSDocVariadicType=318]="JSDocVariadicType",e[e.JSDocNamepathType=319]="JSDocNamepathType",e[e.JSDoc=320]="JSDoc",e[e.JSDocComment=320]="JSDocComment",e[e.JSDocText=321]="JSDocText",e[e.JSDocTypeLiteral=322]="JSDocTypeLiteral",e[e.JSDocSignature=323]="JSDocSignature",e[e.JSDocLink=324]="JSDocLink",e[e.JSDocLinkCode=325]="JSDocLinkCode",e[e.JSDocLinkPlain=326]="JSDocLinkPlain",e[e.JSDocTag=327]="JSDocTag",e[e.JSDocAugmentsTag=328]="JSDocAugmentsTag",e[e.JSDocImplementsTag=329]="JSDocImplementsTag",e[e.JSDocAuthorTag=330]="JSDocAuthorTag",e[e.JSDocDeprecatedTag=331]="JSDocDeprecatedTag",e[e.JSDocClassTag=332]="JSDocClassTag",e[e.JSDocPublicTag=333]="JSDocPublicTag",e[e.JSDocPrivateTag=334]="JSDocPrivateTag",e[e.JSDocProtectedTag=335]="JSDocProtectedTag",e[e.JSDocReadonlyTag=336]="JSDocReadonlyTag",e[e.JSDocOverrideTag=337]="JSDocOverrideTag",e[e.JSDocCallbackTag=338]="JSDocCallbackTag",e[e.JSDocOverloadTag=339]="JSDocOverloadTag",e[e.JSDocEnumTag=340]="JSDocEnumTag",e[e.JSDocParameterTag=341]="JSDocParameterTag",e[e.JSDocReturnTag=342]="JSDocReturnTag",e[e.JSDocThisTag=343]="JSDocThisTag",e[e.JSDocTypeTag=344]="JSDocTypeTag",e[e.JSDocTemplateTag=345]="JSDocTemplateTag",e[e.JSDocTypedefTag=346]="JSDocTypedefTag",e[e.JSDocSeeTag=347]="JSDocSeeTag",e[e.JSDocPropertyTag=348]="JSDocPropertyTag",e[e.JSDocThrowsTag=349]="JSDocThrowsTag",e[e.JSDocSatisfiesTag=350]="JSDocSatisfiesTag",e[e.JSDocImportTag=351]="JSDocImportTag",e[e.SyntaxList=352]="SyntaxList",e[e.NotEmittedStatement=353]="NotEmittedStatement",e[e.PartiallyEmittedExpression=354]="PartiallyEmittedExpression",e[e.CommaListExpression=355]="CommaListExpression",e[e.SyntheticReferenceExpression=356]="SyntheticReferenceExpression",e[e.Count=357]="Count",e[e.FirstAssignment=64]="FirstAssignment",e[e.LastAssignment=79]="LastAssignment",e[e.FirstCompoundAssignment=65]="FirstCompoundAssignment",e[e.LastCompoundAssignment=79]="LastCompoundAssignment",e[e.FirstReservedWord=83]="FirstReservedWord",e[e.LastReservedWord=118]="LastReservedWord",e[e.FirstKeyword=83]="FirstKeyword",e[e.LastKeyword=165]="LastKeyword",e[e.FirstFutureReservedWord=119]="FirstFutureReservedWord",e[e.LastFutureReservedWord=127]="LastFutureReservedWord",e[e.FirstTypeNode=182]="FirstTypeNode",e[e.LastTypeNode=205]="LastTypeNode",e[e.FirstPunctuation=19]="FirstPunctuation",e[e.LastPunctuation=79]="LastPunctuation",e[e.FirstToken=0]="FirstToken",e[e.LastToken=165]="LastToken",e[e.FirstTriviaToken=2]="FirstTriviaToken",e[e.LastTriviaToken=7]="LastTriviaToken",e[e.FirstLiteralToken=9]="FirstLiteralToken",e[e.LastLiteralToken=15]="LastLiteralToken",e[e.FirstTemplateToken=15]="FirstTemplateToken",e[e.LastTemplateToken=18]="LastTemplateToken",e[e.FirstBinaryOperator=30]="FirstBinaryOperator",e[e.LastBinaryOperator=79]="LastBinaryOperator",e[e.FirstStatement=243]="FirstStatement",e[e.LastStatement=259]="LastStatement",e[e.FirstNode=166]="FirstNode",e[e.FirstJSDocNode=309]="FirstJSDocNode",e[e.LastJSDocNode=351]="LastJSDocNode",e[e.FirstJSDocTagNode=327]="FirstJSDocTagNode",e[e.LastJSDocTagNode=351]="LastJSDocTagNode",e[e.FirstContextualKeyword=128]="FirstContextualKeyword",e[e.LastContextualKeyword=165]="LastContextualKeyword",e))($W||{}),HW=(e=>(e[e.None=0]="None",e[e.Let=1]="Let",e[e.Const=2]="Const",e[e.Using=4]="Using",e[e.AwaitUsing=6]="AwaitUsing",e[e.NestedNamespace=8]="NestedNamespace",e[e.Synthesized=16]="Synthesized",e[e.Namespace=32]="Namespace",e[e.OptionalChain=64]="OptionalChain",e[e.ExportContext=128]="ExportContext",e[e.ContainsThis=256]="ContainsThis",e[e.HasImplicitReturn=512]="HasImplicitReturn",e[e.HasExplicitReturn=1024]="HasExplicitReturn",e[e.GlobalAugmentation=2048]="GlobalAugmentation",e[e.HasAsyncFunctions=4096]="HasAsyncFunctions",e[e.DisallowInContext=8192]="DisallowInContext",e[e.YieldContext=16384]="YieldContext",e[e.DecoratorContext=32768]="DecoratorContext",e[e.AwaitContext=65536]="AwaitContext",e[e.DisallowConditionalTypesContext=131072]="DisallowConditionalTypesContext",e[e.ThisNodeHasError=262144]="ThisNodeHasError",e[e.JavaScriptFile=524288]="JavaScriptFile",e[e.ThisNodeOrAnySubNodesHasError=1048576]="ThisNodeOrAnySubNodesHasError",e[e.HasAggregatedChildData=2097152]="HasAggregatedChildData",e[e.PossiblyContainsDynamicImport=4194304]="PossiblyContainsDynamicImport",e[e.PossiblyContainsImportMeta=8388608]="PossiblyContainsImportMeta",e[e.JSDoc=16777216]="JSDoc",e[e.Ambient=33554432]="Ambient",e[e.InWithStatement=67108864]="InWithStatement",e[e.JsonFile=134217728]="JsonFile",e[e.TypeCached=268435456]="TypeCached",e[e.Deprecated=536870912]="Deprecated",e[e.BlockScoped=7]="BlockScoped",e[e.Constant=6]="Constant",e[e.ReachabilityCheckFlags=1536]="ReachabilityCheckFlags",e[e.ReachabilityAndEmitFlags=5632]="ReachabilityAndEmitFlags",e[e.ContextFlags=101441536]="ContextFlags",e[e.TypeExcludesFlags=81920]="TypeExcludesFlags",e[e.PermanentlySetIncrementalFlags=12582912]="PermanentlySetIncrementalFlags",e[e.IdentifierHasExtendedUnicodeEscape=256]="IdentifierHasExtendedUnicodeEscape",e[e.IdentifierIsInJSDocNamespace=4096]="IdentifierIsInJSDocNamespace",e))(HW||{}),GW=(e=>(e[e.None=0]="None",e[e.Public=1]="Public",e[e.Private=2]="Private",e[e.Protected=4]="Protected",e[e.Readonly=8]="Readonly",e[e.Override=16]="Override",e[e.Export=32]="Export",e[e.Abstract=64]="Abstract",e[e.Ambient=128]="Ambient",e[e.Static=256]="Static",e[e.Accessor=512]="Accessor",e[e.Async=1024]="Async",e[e.Default=2048]="Default",e[e.Const=4096]="Const",e[e.In=8192]="In",e[e.Out=16384]="Out",e[e.Decorator=32768]="Decorator",e[e.Deprecated=65536]="Deprecated",e[e.JSDocPublic=8388608]="JSDocPublic",e[e.JSDocPrivate=16777216]="JSDocPrivate",e[e.JSDocProtected=33554432]="JSDocProtected",e[e.JSDocReadonly=67108864]="JSDocReadonly",e[e.JSDocOverride=134217728]="JSDocOverride",e[e.SyntacticOrJSDocModifiers=31]="SyntacticOrJSDocModifiers",e[e.SyntacticOnlyModifiers=65504]="SyntacticOnlyModifiers",e[e.SyntacticModifiers=65535]="SyntacticModifiers",e[e.JSDocCacheOnlyModifiers=260046848]="JSDocCacheOnlyModifiers",e[e.JSDocOnlyModifiers=65536]="JSDocOnlyModifiers",e[e.NonCacheOnlyModifiers=131071]="NonCacheOnlyModifiers",e[e.HasComputedJSDocModifiers=268435456]="HasComputedJSDocModifiers",e[e.HasComputedFlags=536870912]="HasComputedFlags",e[e.AccessibilityModifier=7]="AccessibilityModifier",e[e.ParameterPropertyModifier=31]="ParameterPropertyModifier",e[e.NonPublicAccessibilityModifier=6]="NonPublicAccessibilityModifier",e[e.TypeScriptModifier=28895]="TypeScriptModifier",e[e.ExportDefault=2080]="ExportDefault",e[e.All=131071]="All",e[e.Modifier=98303]="Modifier",e))(GW||{}),fle=(e=>(e[e.None=0]="None",e[e.IntrinsicNamedElement=1]="IntrinsicNamedElement",e[e.IntrinsicIndexedElement=2]="IntrinsicIndexedElement",e[e.IntrinsicElement=3]="IntrinsicElement",e))(fle||{}),YW=(e=>(e[e.None=0]="None",e[e.Succeeded=1]="Succeeded",e[e.Failed=2]="Failed",e[e.Reported=4]="Reported",e[e.ReportsUnmeasurable=8]="ReportsUnmeasurable",e[e.ReportsUnreliable=16]="ReportsUnreliable",e[e.ReportsMask=24]="ReportsMask",e))(YW||{}),KW=(e=>(e[e.None=0]="None",e[e.Auto=1]="Auto",e[e.Loop=2]="Loop",e[e.Unique=3]="Unique",e[e.Node=4]="Node",e[e.KindMask=7]="KindMask",e[e.ReservedInNestedScopes=8]="ReservedInNestedScopes",e[e.Optimistic=16]="Optimistic",e[e.FileLevel=32]="FileLevel",e[e.AllowNameSubstitution=64]="AllowNameSubstitution",e))(KW||{}),ple=(e=>(e[e.None=0]="None",e[e.HasIndices=1]="HasIndices",e[e.Global=2]="Global",e[e.IgnoreCase=4]="IgnoreCase",e[e.Multiline=8]="Multiline",e[e.DotAll=16]="DotAll",e[e.Unicode=32]="Unicode",e[e.UnicodeSets=64]="UnicodeSets",e[e.Sticky=128]="Sticky",e[e.AnyUnicodeMode=96]="AnyUnicodeMode",e[e.Modifiers=28]="Modifiers",e))(ple||{}),dle=(e=>(e[e.None=0]="None",e[e.PrecedingLineBreak=1]="PrecedingLineBreak",e[e.PrecedingJSDocComment=2]="PrecedingJSDocComment",e[e.Unterminated=4]="Unterminated",e[e.ExtendedUnicodeEscape=8]="ExtendedUnicodeEscape",e[e.Scientific=16]="Scientific",e[e.Octal=32]="Octal",e[e.HexSpecifier=64]="HexSpecifier",e[e.BinarySpecifier=128]="BinarySpecifier",e[e.OctalSpecifier=256]="OctalSpecifier",e[e.ContainsSeparator=512]="ContainsSeparator",e[e.UnicodeEscape=1024]="UnicodeEscape",e[e.ContainsInvalidEscape=2048]="ContainsInvalidEscape",e[e.HexEscape=4096]="HexEscape",e[e.ContainsLeadingZero=8192]="ContainsLeadingZero",e[e.ContainsInvalidSeparator=16384]="ContainsInvalidSeparator",e[e.BinaryOrOctalSpecifier=384]="BinaryOrOctalSpecifier",e[e.WithSpecifier=448]="WithSpecifier",e[e.StringLiteralFlags=7176]="StringLiteralFlags",e[e.NumericLiteralFlags=25584]="NumericLiteralFlags",e[e.TemplateLiteralLikeFlags=7176]="TemplateLiteralLikeFlags",e[e.IsInvalid=26656]="IsInvalid",e))(dle||{}),o5=(e=>(e[e.Unreachable=1]="Unreachable",e[e.Start=2]="Start",e[e.BranchLabel=4]="BranchLabel",e[e.LoopLabel=8]="LoopLabel",e[e.Assignment=16]="Assignment",e[e.TrueCondition=32]="TrueCondition",e[e.FalseCondition=64]="FalseCondition",e[e.SwitchClause=128]="SwitchClause",e[e.ArrayMutation=256]="ArrayMutation",e[e.Call=512]="Call",e[e.ReduceLabel=1024]="ReduceLabel",e[e.Referenced=2048]="Referenced",e[e.Shared=4096]="Shared",e[e.Label=12]="Label",e[e.Condition=96]="Condition",e))(o5||{}),mle=(e=>(e[e.ExpectError=0]="ExpectError",e[e.Ignore=1]="Ignore",e))(mle||{}),tI=class{},XW=(e=>(e[e.RootFile=0]="RootFile",e[e.SourceFromProjectReference=1]="SourceFromProjectReference",e[e.OutputFromProjectReference=2]="OutputFromProjectReference",e[e.Import=3]="Import",e[e.ReferenceFile=4]="ReferenceFile",e[e.TypeReferenceDirective=5]="TypeReferenceDirective",e[e.LibFile=6]="LibFile",e[e.LibReferenceDirective=7]="LibReferenceDirective",e[e.AutomaticTypeDirectiveFile=8]="AutomaticTypeDirectiveFile",e))(XW||{}),gle=(e=>(e[e.FilePreprocessingLibReferenceDiagnostic=0]="FilePreprocessingLibReferenceDiagnostic",e[e.FilePreprocessingFileExplainingDiagnostic=1]="FilePreprocessingFileExplainingDiagnostic",e[e.ResolutionDiagnostics=2]="ResolutionDiagnostics",e))(gle||{}),hle=(e=>(e[e.Js=0]="Js",e[e.Dts=1]="Dts",e[e.BuilderSignature=2]="BuilderSignature",e))(hle||{}),QW=(e=>(e[e.Not=0]="Not",e[e.SafeModules=1]="SafeModules",e[e.Completely=2]="Completely",e))(QW||{}),yle=(e=>(e[e.Success=0]="Success",e[e.DiagnosticsPresent_OutputsSkipped=1]="DiagnosticsPresent_OutputsSkipped",e[e.DiagnosticsPresent_OutputsGenerated=2]="DiagnosticsPresent_OutputsGenerated",e[e.InvalidProject_OutputsSkipped=3]="InvalidProject_OutputsSkipped",e[e.ProjectReferenceCycle_OutputsSkipped=4]="ProjectReferenceCycle_OutputsSkipped",e))(yle||{}),vle=(e=>(e[e.Ok=0]="Ok",e[e.NeedsOverride=1]="NeedsOverride",e[e.HasInvalidOverride=2]="HasInvalidOverride",e))(vle||{}),Sle=(e=>(e[e.None=0]="None",e[e.Literal=1]="Literal",e[e.Subtype=2]="Subtype",e))(Sle||{}),ble=(e=>(e[e.None=0]="None",e[e.NoSupertypeReduction=1]="NoSupertypeReduction",e[e.NoConstraintReduction=2]="NoConstraintReduction",e))(ble||{}),Tle=(e=>(e[e.None=0]="None",e[e.Signature=1]="Signature",e[e.NoConstraints=2]="NoConstraints",e[e.Completions=4]="Completions",e[e.SkipBindingPatterns=8]="SkipBindingPatterns",e))(Tle||{}),Ele=(e=>(e[e.None=0]="None",e[e.NoTruncation=1]="NoTruncation",e[e.WriteArrayAsGenericType=2]="WriteArrayAsGenericType",e[e.GenerateNamesForShadowedTypeParams=4]="GenerateNamesForShadowedTypeParams",e[e.UseStructuralFallback=8]="UseStructuralFallback",e[e.ForbidIndexedAccessSymbolReferences=16]="ForbidIndexedAccessSymbolReferences",e[e.WriteTypeArgumentsOfSignature=32]="WriteTypeArgumentsOfSignature",e[e.UseFullyQualifiedType=64]="UseFullyQualifiedType",e[e.UseOnlyExternalAliasing=128]="UseOnlyExternalAliasing",e[e.SuppressAnyReturnType=256]="SuppressAnyReturnType",e[e.WriteTypeParametersInQualifiedName=512]="WriteTypeParametersInQualifiedName",e[e.MultilineObjectLiterals=1024]="MultilineObjectLiterals",e[e.WriteClassExpressionAsTypeLiteral=2048]="WriteClassExpressionAsTypeLiteral",e[e.UseTypeOfFunction=4096]="UseTypeOfFunction",e[e.OmitParameterModifiers=8192]="OmitParameterModifiers",e[e.UseAliasDefinedOutsideCurrentScope=16384]="UseAliasDefinedOutsideCurrentScope",e[e.UseSingleQuotesForStringLiteralType=268435456]="UseSingleQuotesForStringLiteralType",e[e.NoTypeReduction=536870912]="NoTypeReduction",e[e.OmitThisParameter=33554432]="OmitThisParameter",e[e.AllowThisInObjectLiteral=32768]="AllowThisInObjectLiteral",e[e.AllowQualifiedNameInPlaceOfIdentifier=65536]="AllowQualifiedNameInPlaceOfIdentifier",e[e.AllowAnonymousIdentifier=131072]="AllowAnonymousIdentifier",e[e.AllowEmptyUnionOrIntersection=262144]="AllowEmptyUnionOrIntersection",e[e.AllowEmptyTuple=524288]="AllowEmptyTuple",e[e.AllowUniqueESSymbolType=1048576]="AllowUniqueESSymbolType",e[e.AllowEmptyIndexInfoType=2097152]="AllowEmptyIndexInfoType",e[e.WriteComputedProps=1073741824]="WriteComputedProps",e[e.NoSyntacticPrinter=-2147483648]="NoSyntacticPrinter",e[e.AllowNodeModulesRelativePaths=67108864]="AllowNodeModulesRelativePaths",e[e.DoNotIncludeSymbolChain=134217728]="DoNotIncludeSymbolChain",e[e.AllowUnresolvedNames=1]="AllowUnresolvedNames",e[e.IgnoreErrors=70221824]="IgnoreErrors",e[e.InObjectTypeLiteral=4194304]="InObjectTypeLiteral",e[e.InTypeAlias=8388608]="InTypeAlias",e[e.InInitialEntityName=16777216]="InInitialEntityName",e))(Ele||{}),xle=(e=>(e[e.None=0]="None",e[e.NoTruncation=1]="NoTruncation",e[e.WriteArrayAsGenericType=2]="WriteArrayAsGenericType",e[e.GenerateNamesForShadowedTypeParams=4]="GenerateNamesForShadowedTypeParams",e[e.UseStructuralFallback=8]="UseStructuralFallback",e[e.WriteTypeArgumentsOfSignature=32]="WriteTypeArgumentsOfSignature",e[e.UseFullyQualifiedType=64]="UseFullyQualifiedType",e[e.SuppressAnyReturnType=256]="SuppressAnyReturnType",e[e.MultilineObjectLiterals=1024]="MultilineObjectLiterals",e[e.WriteClassExpressionAsTypeLiteral=2048]="WriteClassExpressionAsTypeLiteral",e[e.UseTypeOfFunction=4096]="UseTypeOfFunction",e[e.OmitParameterModifiers=8192]="OmitParameterModifiers",e[e.UseAliasDefinedOutsideCurrentScope=16384]="UseAliasDefinedOutsideCurrentScope",e[e.UseSingleQuotesForStringLiteralType=268435456]="UseSingleQuotesForStringLiteralType",e[e.NoTypeReduction=536870912]="NoTypeReduction",e[e.OmitThisParameter=33554432]="OmitThisParameter",e[e.AllowUniqueESSymbolType=1048576]="AllowUniqueESSymbolType",e[e.AddUndefined=131072]="AddUndefined",e[e.WriteArrowStyleSignature=262144]="WriteArrowStyleSignature",e[e.InArrayType=524288]="InArrayType",e[e.InElementType=2097152]="InElementType",e[e.InFirstTypeArgument=4194304]="InFirstTypeArgument",e[e.InTypeAlias=8388608]="InTypeAlias",e[e.NodeBuilderFlagsMask=848330095]="NodeBuilderFlagsMask",e))(xle||{}),Cle=(e=>(e[e.None=0]="None",e[e.WriteTypeParametersOrArguments=1]="WriteTypeParametersOrArguments",e[e.UseOnlyExternalAliasing=2]="UseOnlyExternalAliasing",e[e.AllowAnyNodeKind=4]="AllowAnyNodeKind",e[e.UseAliasDefinedOutsideCurrentScope=8]="UseAliasDefinedOutsideCurrentScope",e[e.WriteComputedProps=16]="WriteComputedProps",e[e.DoNotIncludeSymbolChain=32]="DoNotIncludeSymbolChain",e))(Cle||{}),Ale=(e=>(e[e.Accessible=0]="Accessible",e[e.NotAccessible=1]="NotAccessible",e[e.CannotBeNamed=2]="CannotBeNamed",e[e.NotResolved=3]="NotResolved",e))(Ale||{}),kle=(e=>(e[e.UnionOrIntersection=0]="UnionOrIntersection",e[e.Spread=1]="Spread",e))(kle||{}),Ple=(e=>(e[e.This=0]="This",e[e.Identifier=1]="Identifier",e[e.AssertsThis=2]="AssertsThis",e[e.AssertsIdentifier=3]="AssertsIdentifier",e))(Ple||{}),Nle=(e=>(e[e.Unknown=0]="Unknown",e[e.TypeWithConstructSignatureAndValue=1]="TypeWithConstructSignatureAndValue",e[e.VoidNullableOrNeverType=2]="VoidNullableOrNeverType",e[e.NumberLikeType=3]="NumberLikeType",e[e.BigIntLikeType=4]="BigIntLikeType",e[e.StringLikeType=5]="StringLikeType",e[e.BooleanType=6]="BooleanType",e[e.ArrayLikeType=7]="ArrayLikeType",e[e.ESSymbolType=8]="ESSymbolType",e[e.Promise=9]="Promise",e[e.TypeWithCallSignature=10]="TypeWithCallSignature",e[e.ObjectType=11]="ObjectType",e))(Nle||{}),ZW=(e=>(e[e.None=0]="None",e[e.FunctionScopedVariable=1]="FunctionScopedVariable",e[e.BlockScopedVariable=2]="BlockScopedVariable",e[e.Property=4]="Property",e[e.EnumMember=8]="EnumMember",e[e.Function=16]="Function",e[e.Class=32]="Class",e[e.Interface=64]="Interface",e[e.ConstEnum=128]="ConstEnum",e[e.RegularEnum=256]="RegularEnum",e[e.ValueModule=512]="ValueModule",e[e.NamespaceModule=1024]="NamespaceModule",e[e.TypeLiteral=2048]="TypeLiteral",e[e.ObjectLiteral=4096]="ObjectLiteral",e[e.Method=8192]="Method",e[e.Constructor=16384]="Constructor",e[e.GetAccessor=32768]="GetAccessor",e[e.SetAccessor=65536]="SetAccessor",e[e.Signature=131072]="Signature",e[e.TypeParameter=262144]="TypeParameter",e[e.TypeAlias=524288]="TypeAlias",e[e.ExportValue=1048576]="ExportValue",e[e.Alias=2097152]="Alias",e[e.Prototype=4194304]="Prototype",e[e.ExportStar=8388608]="ExportStar",e[e.Optional=16777216]="Optional",e[e.Transient=33554432]="Transient",e[e.Assignment=67108864]="Assignment",e[e.ModuleExports=134217728]="ModuleExports",e[e.All=-1]="All",e[e.Enum=384]="Enum",e[e.Variable=3]="Variable",e[e.Value=111551]="Value",e[e.Type=788968]="Type",e[e.Namespace=1920]="Namespace",e[e.Module=1536]="Module",e[e.Accessor=98304]="Accessor",e[e.FunctionScopedVariableExcludes=111550]="FunctionScopedVariableExcludes",e[e.BlockScopedVariableExcludes=111551]="BlockScopedVariableExcludes",e[e.ParameterExcludes=111551]="ParameterExcludes",e[e.PropertyExcludes=0]="PropertyExcludes",e[e.EnumMemberExcludes=900095]="EnumMemberExcludes",e[e.FunctionExcludes=110991]="FunctionExcludes",e[e.ClassExcludes=899503]="ClassExcludes",e[e.InterfaceExcludes=788872]="InterfaceExcludes",e[e.RegularEnumExcludes=899327]="RegularEnumExcludes",e[e.ConstEnumExcludes=899967]="ConstEnumExcludes",e[e.ValueModuleExcludes=110735]="ValueModuleExcludes",e[e.NamespaceModuleExcludes=0]="NamespaceModuleExcludes",e[e.MethodExcludes=103359]="MethodExcludes",e[e.GetAccessorExcludes=46015]="GetAccessorExcludes",e[e.SetAccessorExcludes=78783]="SetAccessorExcludes",e[e.AccessorExcludes=13247]="AccessorExcludes",e[e.TypeParameterExcludes=526824]="TypeParameterExcludes",e[e.TypeAliasExcludes=788968]="TypeAliasExcludes",e[e.AliasExcludes=2097152]="AliasExcludes",e[e.ModuleMember=2623475]="ModuleMember",e[e.ExportHasLocal=944]="ExportHasLocal",e[e.BlockScoped=418]="BlockScoped",e[e.PropertyOrAccessor=98308]="PropertyOrAccessor",e[e.ClassMember=106500]="ClassMember",e[e.ExportSupportsDefaultModifier=112]="ExportSupportsDefaultModifier",e[e.ExportDoesNotSupportDefaultModifier=-113]="ExportDoesNotSupportDefaultModifier",e[e.Classifiable=2885600]="Classifiable",e[e.LateBindingContainer=6256]="LateBindingContainer",e))(ZW||{}),Dle=(e=>(e[e.None=0]="None",e[e.Instantiated=1]="Instantiated",e[e.SyntheticProperty=2]="SyntheticProperty",e[e.SyntheticMethod=4]="SyntheticMethod",e[e.Readonly=8]="Readonly",e[e.ReadPartial=16]="ReadPartial",e[e.WritePartial=32]="WritePartial",e[e.HasNonUniformType=64]="HasNonUniformType",e[e.HasLiteralType=128]="HasLiteralType",e[e.ContainsPublic=256]="ContainsPublic",e[e.ContainsProtected=512]="ContainsProtected",e[e.ContainsPrivate=1024]="ContainsPrivate",e[e.ContainsStatic=2048]="ContainsStatic",e[e.Late=4096]="Late",e[e.ReverseMapped=8192]="ReverseMapped",e[e.OptionalParameter=16384]="OptionalParameter",e[e.RestParameter=32768]="RestParameter",e[e.DeferredType=65536]="DeferredType",e[e.HasNeverType=131072]="HasNeverType",e[e.Mapped=262144]="Mapped",e[e.StripOptional=524288]="StripOptional",e[e.Unresolved=1048576]="Unresolved",e[e.Synthetic=6]="Synthetic",e[e.Discriminant=192]="Discriminant",e[e.Partial=48]="Partial",e))(Dle||{}),wle=(e=>(e.Call="__call",e.Constructor="__constructor",e.New="__new",e.Index="__index",e.ExportStar="__export",e.Global="__global",e.Missing="__missing",e.Type="__type",e.Object="__object",e.JSXAttributes="__jsxAttributes",e.Class="__class",e.Function="__function",e.Computed="__computed",e.Resolving="__resolving__",e.ExportEquals="export=",e.Default="default",e.This="this",e.InstantiationExpression="__instantiationExpression",e.ImportAttributes="__importAttributes",e))(wle||{}),e$=(e=>(e[e.None=0]="None",e[e.TypeChecked=1]="TypeChecked",e[e.LexicalThis=2]="LexicalThis",e[e.CaptureThis=4]="CaptureThis",e[e.CaptureNewTarget=8]="CaptureNewTarget",e[e.SuperInstance=16]="SuperInstance",e[e.SuperStatic=32]="SuperStatic",e[e.ContextChecked=64]="ContextChecked",e[e.MethodWithSuperPropertyAccessInAsync=128]="MethodWithSuperPropertyAccessInAsync",e[e.MethodWithSuperPropertyAssignmentInAsync=256]="MethodWithSuperPropertyAssignmentInAsync",e[e.CaptureArguments=512]="CaptureArguments",e[e.EnumValuesComputed=1024]="EnumValuesComputed",e[e.LexicalModuleMergesWithClass=2048]="LexicalModuleMergesWithClass",e[e.LoopWithCapturedBlockScopedBinding=4096]="LoopWithCapturedBlockScopedBinding",e[e.ContainsCapturedBlockScopeBinding=8192]="ContainsCapturedBlockScopeBinding",e[e.CapturedBlockScopedBinding=16384]="CapturedBlockScopedBinding",e[e.BlockScopedBindingInLoop=32768]="BlockScopedBindingInLoop",e[e.NeedsLoopOutParameter=65536]="NeedsLoopOutParameter",e[e.AssignmentsMarked=131072]="AssignmentsMarked",e[e.ContainsConstructorReference=262144]="ContainsConstructorReference",e[e.ConstructorReference=536870912]="ConstructorReference",e[e.ContainsClassWithPrivateIdentifiers=1048576]="ContainsClassWithPrivateIdentifiers",e[e.ContainsSuperPropertyInStaticInitializer=2097152]="ContainsSuperPropertyInStaticInitializer",e[e.InCheckIdentifier=4194304]="InCheckIdentifier",e[e.LazyFlags=539358128]="LazyFlags",e))(e$||{}),t$=(e=>(e[e.Any=1]="Any",e[e.Unknown=2]="Unknown",e[e.String=4]="String",e[e.Number=8]="Number",e[e.Boolean=16]="Boolean",e[e.Enum=32]="Enum",e[e.BigInt=64]="BigInt",e[e.StringLiteral=128]="StringLiteral",e[e.NumberLiteral=256]="NumberLiteral",e[e.BooleanLiteral=512]="BooleanLiteral",e[e.EnumLiteral=1024]="EnumLiteral",e[e.BigIntLiteral=2048]="BigIntLiteral",e[e.ESSymbol=4096]="ESSymbol",e[e.UniqueESSymbol=8192]="UniqueESSymbol",e[e.Void=16384]="Void",e[e.Undefined=32768]="Undefined",e[e.Null=65536]="Null",e[e.Never=131072]="Never",e[e.TypeParameter=262144]="TypeParameter",e[e.Object=524288]="Object",e[e.Union=1048576]="Union",e[e.Intersection=2097152]="Intersection",e[e.Index=4194304]="Index",e[e.IndexedAccess=8388608]="IndexedAccess",e[e.Conditional=16777216]="Conditional",e[e.Substitution=33554432]="Substitution",e[e.NonPrimitive=67108864]="NonPrimitive",e[e.TemplateLiteral=134217728]="TemplateLiteral",e[e.StringMapping=268435456]="StringMapping",e[e.Reserved1=536870912]="Reserved1",e[e.Reserved2=1073741824]="Reserved2",e[e.AnyOrUnknown=3]="AnyOrUnknown",e[e.Nullable=98304]="Nullable",e[e.Literal=2944]="Literal",e[e.Unit=109472]="Unit",e[e.Freshable=2976]="Freshable",e[e.StringOrNumberLiteral=384]="StringOrNumberLiteral",e[e.StringOrNumberLiteralOrUnique=8576]="StringOrNumberLiteralOrUnique",e[e.DefinitelyFalsy=117632]="DefinitelyFalsy",e[e.PossiblyFalsy=117724]="PossiblyFalsy",e[e.Intrinsic=67359327]="Intrinsic",e[e.StringLike=402653316]="StringLike",e[e.NumberLike=296]="NumberLike",e[e.BigIntLike=2112]="BigIntLike",e[e.BooleanLike=528]="BooleanLike",e[e.EnumLike=1056]="EnumLike",e[e.ESSymbolLike=12288]="ESSymbolLike",e[e.VoidLike=49152]="VoidLike",e[e.Primitive=402784252]="Primitive",e[e.DefinitelyNonNullable=470302716]="DefinitelyNonNullable",e[e.DisjointDomains=469892092]="DisjointDomains",e[e.UnionOrIntersection=3145728]="UnionOrIntersection",e[e.StructuredType=3670016]="StructuredType",e[e.TypeVariable=8650752]="TypeVariable",e[e.InstantiableNonPrimitive=58982400]="InstantiableNonPrimitive",e[e.InstantiablePrimitive=406847488]="InstantiablePrimitive",e[e.Instantiable=465829888]="Instantiable",e[e.StructuredOrInstantiable=469499904]="StructuredOrInstantiable",e[e.ObjectFlagsType=3899393]="ObjectFlagsType",e[e.Simplifiable=25165824]="Simplifiable",e[e.Singleton=67358815]="Singleton",e[e.Narrowable=536624127]="Narrowable",e[e.IncludesMask=473694207]="IncludesMask",e[e.IncludesMissingType=262144]="IncludesMissingType",e[e.IncludesNonWideningType=4194304]="IncludesNonWideningType",e[e.IncludesWildcard=8388608]="IncludesWildcard",e[e.IncludesEmptyObject=16777216]="IncludesEmptyObject",e[e.IncludesInstantiable=33554432]="IncludesInstantiable",e[e.IncludesConstrainedTypeVariable=536870912]="IncludesConstrainedTypeVariable",e[e.IncludesError=1073741824]="IncludesError",e[e.NotPrimitiveUnion=36323331]="NotPrimitiveUnion",e))(t$||{}),r$=(e=>(e[e.None=0]="None",e[e.Class=1]="Class",e[e.Interface=2]="Interface",e[e.Reference=4]="Reference",e[e.Tuple=8]="Tuple",e[e.Anonymous=16]="Anonymous",e[e.Mapped=32]="Mapped",e[e.Instantiated=64]="Instantiated",e[e.ObjectLiteral=128]="ObjectLiteral",e[e.EvolvingArray=256]="EvolvingArray",e[e.ObjectLiteralPatternWithComputedProperties=512]="ObjectLiteralPatternWithComputedProperties",e[e.ReverseMapped=1024]="ReverseMapped",e[e.JsxAttributes=2048]="JsxAttributes",e[e.JSLiteral=4096]="JSLiteral",e[e.FreshLiteral=8192]="FreshLiteral",e[e.ArrayLiteral=16384]="ArrayLiteral",e[e.PrimitiveUnion=32768]="PrimitiveUnion",e[e.ContainsWideningType=65536]="ContainsWideningType",e[e.ContainsObjectOrArrayLiteral=131072]="ContainsObjectOrArrayLiteral",e[e.NonInferrableType=262144]="NonInferrableType",e[e.CouldContainTypeVariablesComputed=524288]="CouldContainTypeVariablesComputed",e[e.CouldContainTypeVariables=1048576]="CouldContainTypeVariables",e[e.ClassOrInterface=3]="ClassOrInterface",e[e.RequiresWidening=196608]="RequiresWidening",e[e.PropagatingFlags=458752]="PropagatingFlags",e[e.InstantiatedMapped=96]="InstantiatedMapped",e[e.ObjectTypeKindMask=1343]="ObjectTypeKindMask",e[e.ContainsSpread=2097152]="ContainsSpread",e[e.ObjectRestType=4194304]="ObjectRestType",e[e.InstantiationExpressionType=8388608]="InstantiationExpressionType",e[e.SingleSignatureType=134217728]="SingleSignatureType",e[e.IsClassInstanceClone=16777216]="IsClassInstanceClone",e[e.IdenticalBaseTypeCalculated=33554432]="IdenticalBaseTypeCalculated",e[e.IdenticalBaseTypeExists=67108864]="IdenticalBaseTypeExists",e[e.IsGenericTypeComputed=2097152]="IsGenericTypeComputed",e[e.IsGenericObjectType=4194304]="IsGenericObjectType",e[e.IsGenericIndexType=8388608]="IsGenericIndexType",e[e.IsGenericType=12582912]="IsGenericType",e[e.ContainsIntersections=16777216]="ContainsIntersections",e[e.IsUnknownLikeUnionComputed=33554432]="IsUnknownLikeUnionComputed",e[e.IsUnknownLikeUnion=67108864]="IsUnknownLikeUnion",e[e.IsNeverIntersectionComputed=16777216]="IsNeverIntersectionComputed",e[e.IsNeverIntersection=33554432]="IsNeverIntersection",e[e.IsConstrainedTypeVariable=67108864]="IsConstrainedTypeVariable",e))(r$||{}),Ile=(e=>(e[e.Invariant=0]="Invariant",e[e.Covariant=1]="Covariant",e[e.Contravariant=2]="Contravariant",e[e.Bivariant=3]="Bivariant",e[e.Independent=4]="Independent",e[e.VarianceMask=7]="VarianceMask",e[e.Unmeasurable=8]="Unmeasurable",e[e.Unreliable=16]="Unreliable",e[e.AllowsStructuralFallback=24]="AllowsStructuralFallback",e))(Ile||{}),Ole=(e=>(e[e.Required=1]="Required",e[e.Optional=2]="Optional",e[e.Rest=4]="Rest",e[e.Variadic=8]="Variadic",e[e.Fixed=3]="Fixed",e[e.Variable=12]="Variable",e[e.NonRequired=14]="NonRequired",e[e.NonRest=11]="NonRest",e))(Ole||{}),Rle=(e=>(e[e.None=0]="None",e[e.IncludeUndefined=1]="IncludeUndefined",e[e.NoIndexSignatures=2]="NoIndexSignatures",e[e.Writing=4]="Writing",e[e.CacheSymbol=8]="CacheSymbol",e[e.NoTupleBoundsCheck=16]="NoTupleBoundsCheck",e[e.ExpressionPosition=32]="ExpressionPosition",e[e.ReportDeprecated=64]="ReportDeprecated",e[e.SuppressNoImplicitAnyError=128]="SuppressNoImplicitAnyError",e[e.Contextual=256]="Contextual",e[e.Persistent=1]="Persistent",e))(Rle||{}),Mle=(e=>(e[e.None=0]="None",e[e.StringsOnly=1]="StringsOnly",e[e.NoIndexSignatures=2]="NoIndexSignatures",e[e.NoReducibleCheck=4]="NoReducibleCheck",e))(Mle||{}),Lle=(e=>(e[e.Component=0]="Component",e[e.Function=1]="Function",e[e.Mixed=2]="Mixed",e))(Lle||{}),Fle=(e=>(e[e.Call=0]="Call",e[e.Construct=1]="Construct",e))(Fle||{}),n$=(e=>(e[e.None=0]="None",e[e.HasRestParameter=1]="HasRestParameter",e[e.HasLiteralTypes=2]="HasLiteralTypes",e[e.Abstract=4]="Abstract",e[e.IsInnerCallChain=8]="IsInnerCallChain",e[e.IsOuterCallChain=16]="IsOuterCallChain",e[e.IsUntypedSignatureInJSFile=32]="IsUntypedSignatureInJSFile",e[e.IsNonInferrable=64]="IsNonInferrable",e[e.IsSignatureCandidateForOverloadFailure=128]="IsSignatureCandidateForOverloadFailure",e[e.PropagatingFlags=167]="PropagatingFlags",e[e.CallChainFlags=24]="CallChainFlags",e))(n$||{}),jle=(e=>(e[e.String=0]="String",e[e.Number=1]="Number",e))(jle||{}),Ble=(e=>(e[e.Simple=0]="Simple",e[e.Array=1]="Array",e[e.Deferred=2]="Deferred",e[e.Function=3]="Function",e[e.Composite=4]="Composite",e[e.Merged=5]="Merged",e))(Ble||{}),Ule=(e=>(e[e.None=0]="None",e[e.NakedTypeVariable=1]="NakedTypeVariable",e[e.SpeculativeTuple=2]="SpeculativeTuple",e[e.SubstituteSource=4]="SubstituteSource",e[e.HomomorphicMappedType=8]="HomomorphicMappedType",e[e.PartialHomomorphicMappedType=16]="PartialHomomorphicMappedType",e[e.MappedTypeConstraint=32]="MappedTypeConstraint",e[e.ContravariantConditional=64]="ContravariantConditional",e[e.ReturnType=128]="ReturnType",e[e.LiteralKeyof=256]="LiteralKeyof",e[e.NoConstraints=512]="NoConstraints",e[e.AlwaysStrict=1024]="AlwaysStrict",e[e.MaxValue=2048]="MaxValue",e[e.PriorityImpliesCombination=416]="PriorityImpliesCombination",e[e.Circularity=-1]="Circularity",e))(Ule||{}),Vle=(e=>(e[e.None=0]="None",e[e.NoDefault=1]="NoDefault",e[e.AnyDefault=2]="AnyDefault",e[e.SkippedGenericFunction=4]="SkippedGenericFunction",e))(Vle||{}),Jle=(e=>(e[e.False=0]="False",e[e.Unknown=1]="Unknown",e[e.Maybe=3]="Maybe",e[e.True=-1]="True",e))(Jle||{}),qle=(e=>(e[e.None=0]="None",e[e.ExportsProperty=1]="ExportsProperty",e[e.ModuleExports=2]="ModuleExports",e[e.PrototypeProperty=3]="PrototypeProperty",e[e.ThisProperty=4]="ThisProperty",e[e.Property=5]="Property",e[e.Prototype=6]="Prototype",e[e.ObjectDefinePropertyValue=7]="ObjectDefinePropertyValue",e[e.ObjectDefinePropertyExports=8]="ObjectDefinePropertyExports",e[e.ObjectDefinePrototypeProperty=9]="ObjectDefinePrototypeProperty",e))(qle||{}),c5=(e=>(e[e.Warning=0]="Warning",e[e.Error=1]="Error",e[e.Suggestion=2]="Suggestion",e[e.Message=3]="Message",e))(c5||{});function Bx(e,t=!0){let n=c5[e.category];return t?n.toLowerCase():n}var rI=(e=>(e[e.Classic=1]="Classic",e[e.NodeJs=2]="NodeJs",e[e.Node10=2]="Node10",e[e.Node16=3]="Node16",e[e.NodeNext=99]="NodeNext",e[e.Bundler=100]="Bundler",e))(rI||{}),zle=(e=>(e[e.Legacy=1]="Legacy",e[e.Auto=2]="Auto",e[e.Force=3]="Force",e))(zle||{}),Wle=(e=>(e[e.FixedPollingInterval=0]="FixedPollingInterval",e[e.PriorityPollingInterval=1]="PriorityPollingInterval",e[e.DynamicPriorityPolling=2]="DynamicPriorityPolling",e[e.FixedChunkSizePolling=3]="FixedChunkSizePolling",e[e.UseFsEvents=4]="UseFsEvents",e[e.UseFsEventsOnParentDirectory=5]="UseFsEventsOnParentDirectory",e))(Wle||{}),$le=(e=>(e[e.UseFsEvents=0]="UseFsEvents",e[e.FixedPollingInterval=1]="FixedPollingInterval",e[e.DynamicPriorityPolling=2]="DynamicPriorityPolling",e[e.FixedChunkSizePolling=3]="FixedChunkSizePolling",e))($le||{}),Hle=(e=>(e[e.FixedInterval=0]="FixedInterval",e[e.PriorityInterval=1]="PriorityInterval",e[e.DynamicPriority=2]="DynamicPriority",e[e.FixedChunkSize=3]="FixedChunkSize",e))(Hle||{}),y3=(e=>(e[e.None=0]="None",e[e.CommonJS=1]="CommonJS",e[e.AMD=2]="AMD",e[e.UMD=3]="UMD",e[e.System=4]="System",e[e.ES2015=5]="ES2015",e[e.ES2020=6]="ES2020",e[e.ES2022=7]="ES2022",e[e.ESNext=99]="ESNext",e[e.Node16=100]="Node16",e[e.NodeNext=199]="NodeNext",e[e.Preserve=200]="Preserve",e))(y3||{}),Gle=(e=>(e[e.None=0]="None",e[e.Preserve=1]="Preserve",e[e.React=2]="React",e[e.ReactNative=3]="ReactNative",e[e.ReactJSX=4]="ReactJSX",e[e.ReactJSXDev=5]="ReactJSXDev",e))(Gle||{}),Yle=(e=>(e[e.Remove=0]="Remove",e[e.Preserve=1]="Preserve",e[e.Error=2]="Error",e))(Yle||{}),Kle=(e=>(e[e.CarriageReturnLineFeed=0]="CarriageReturnLineFeed",e[e.LineFeed=1]="LineFeed",e))(Kle||{}),i$=(e=>(e[e.Unknown=0]="Unknown",e[e.JS=1]="JS",e[e.JSX=2]="JSX",e[e.TS=3]="TS",e[e.TSX=4]="TSX",e[e.External=5]="External",e[e.JSON=6]="JSON",e[e.Deferred=7]="Deferred",e))(i$||{}),Xle=(e=>(e[e.ES3=0]="ES3",e[e.ES5=1]="ES5",e[e.ES2015=2]="ES2015",e[e.ES2016=3]="ES2016",e[e.ES2017=4]="ES2017",e[e.ES2018=5]="ES2018",e[e.ES2019=6]="ES2019",e[e.ES2020=7]="ES2020",e[e.ES2021=8]="ES2021",e[e.ES2022=9]="ES2022",e[e.ES2023=10]="ES2023",e[e.ESNext=99]="ESNext",e[e.JSON=100]="JSON",e[e.Latest=99]="Latest",e))(Xle||{}),Qle=(e=>(e[e.Standard=0]="Standard",e[e.JSX=1]="JSX",e))(Qle||{}),Zle=(e=>(e[e.None=0]="None",e[e.Recursive=1]="Recursive",e))(Zle||{}),eue=(e=>(e[e.EOF=-1]="EOF",e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e.replacementCharacter=65533]="replacementCharacter",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.backtick=96]="backtick",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.hash=35]="hash",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab",e))(eue||{}),tue=(e=>(e.Ts=".ts",e.Tsx=".tsx",e.Dts=".d.ts",e.Js=".js",e.Jsx=".jsx",e.Json=".json",e.TsBuildInfo=".tsbuildinfo",e.Mjs=".mjs",e.Mts=".mts",e.Dmts=".d.mts",e.Cjs=".cjs",e.Cts=".cts",e.Dcts=".d.cts",e))(tue||{}),s$=(e=>(e[e.None=0]="None",e[e.ContainsTypeScript=1]="ContainsTypeScript",e[e.ContainsJsx=2]="ContainsJsx",e[e.ContainsESNext=4]="ContainsESNext",e[e.ContainsES2022=8]="ContainsES2022",e[e.ContainsES2021=16]="ContainsES2021",e[e.ContainsES2020=32]="ContainsES2020",e[e.ContainsES2019=64]="ContainsES2019",e[e.ContainsES2018=128]="ContainsES2018",e[e.ContainsES2017=256]="ContainsES2017",e[e.ContainsES2016=512]="ContainsES2016",e[e.ContainsES2015=1024]="ContainsES2015",e[e.ContainsGenerator=2048]="ContainsGenerator",e[e.ContainsDestructuringAssignment=4096]="ContainsDestructuringAssignment",e[e.ContainsTypeScriptClassSyntax=8192]="ContainsTypeScriptClassSyntax",e[e.ContainsLexicalThis=16384]="ContainsLexicalThis",e[e.ContainsRestOrSpread=32768]="ContainsRestOrSpread",e[e.ContainsObjectRestOrSpread=65536]="ContainsObjectRestOrSpread",e[e.ContainsComputedPropertyName=131072]="ContainsComputedPropertyName",e[e.ContainsBlockScopedBinding=262144]="ContainsBlockScopedBinding",e[e.ContainsBindingPattern=524288]="ContainsBindingPattern",e[e.ContainsYield=1048576]="ContainsYield",e[e.ContainsAwait=2097152]="ContainsAwait",e[e.ContainsHoistedDeclarationOrCompletion=4194304]="ContainsHoistedDeclarationOrCompletion",e[e.ContainsDynamicImport=8388608]="ContainsDynamicImport",e[e.ContainsClassFields=16777216]="ContainsClassFields",e[e.ContainsDecorators=33554432]="ContainsDecorators",e[e.ContainsPossibleTopLevelAwait=67108864]="ContainsPossibleTopLevelAwait",e[e.ContainsLexicalSuper=134217728]="ContainsLexicalSuper",e[e.ContainsUpdateExpressionForIdentifier=268435456]="ContainsUpdateExpressionForIdentifier",e[e.ContainsPrivateIdentifierInExpression=536870912]="ContainsPrivateIdentifierInExpression",e[e.HasComputedFlags=-2147483648]="HasComputedFlags",e[e.AssertTypeScript=1]="AssertTypeScript",e[e.AssertJsx=2]="AssertJsx",e[e.AssertESNext=4]="AssertESNext",e[e.AssertES2022=8]="AssertES2022",e[e.AssertES2021=16]="AssertES2021",e[e.AssertES2020=32]="AssertES2020",e[e.AssertES2019=64]="AssertES2019",e[e.AssertES2018=128]="AssertES2018",e[e.AssertES2017=256]="AssertES2017",e[e.AssertES2016=512]="AssertES2016",e[e.AssertES2015=1024]="AssertES2015",e[e.AssertGenerator=2048]="AssertGenerator",e[e.AssertDestructuringAssignment=4096]="AssertDestructuringAssignment",e[e.OuterExpressionExcludes=-2147483648]="OuterExpressionExcludes",e[e.PropertyAccessExcludes=-2147483648]="PropertyAccessExcludes",e[e.NodeExcludes=-2147483648]="NodeExcludes",e[e.ArrowFunctionExcludes=-2072174592]="ArrowFunctionExcludes",e[e.FunctionExcludes=-1937940480]="FunctionExcludes",e[e.ConstructorExcludes=-1937948672]="ConstructorExcludes",e[e.MethodOrAccessorExcludes=-2005057536]="MethodOrAccessorExcludes",e[e.PropertyExcludes=-2013249536]="PropertyExcludes",e[e.ClassExcludes=-2147344384]="ClassExcludes",e[e.ModuleExcludes=-1941676032]="ModuleExcludes",e[e.TypeExcludes=-2]="TypeExcludes",e[e.ObjectLiteralExcludes=-2147278848]="ObjectLiteralExcludes",e[e.ArrayLiteralOrCallOrNewExcludes=-2147450880]="ArrayLiteralOrCallOrNewExcludes",e[e.VariableDeclarationListExcludes=-2146893824]="VariableDeclarationListExcludes",e[e.ParameterExcludes=-2147483648]="ParameterExcludes",e[e.CatchClauseExcludes=-2147418112]="CatchClauseExcludes",e[e.BindingPatternExcludes=-2147450880]="BindingPatternExcludes",e[e.ContainsLexicalThisOrSuper=134234112]="ContainsLexicalThisOrSuper",e[e.PropertyNamePropagatingFlags=134234112]="PropertyNamePropagatingFlags",e))(s$||{}),a$=(e=>(e[e.TabStop=0]="TabStop",e[e.Placeholder=1]="Placeholder",e[e.Choice=2]="Choice",e[e.Variable=3]="Variable",e))(a$||{}),o$=(e=>(e[e.None=0]="None",e[e.SingleLine=1]="SingleLine",e[e.MultiLine=2]="MultiLine",e[e.AdviseOnEmitNode=4]="AdviseOnEmitNode",e[e.NoSubstitution=8]="NoSubstitution",e[e.CapturesThis=16]="CapturesThis",e[e.NoLeadingSourceMap=32]="NoLeadingSourceMap",e[e.NoTrailingSourceMap=64]="NoTrailingSourceMap",e[e.NoSourceMap=96]="NoSourceMap",e[e.NoNestedSourceMaps=128]="NoNestedSourceMaps",e[e.NoTokenLeadingSourceMaps=256]="NoTokenLeadingSourceMaps",e[e.NoTokenTrailingSourceMaps=512]="NoTokenTrailingSourceMaps",e[e.NoTokenSourceMaps=768]="NoTokenSourceMaps",e[e.NoLeadingComments=1024]="NoLeadingComments",e[e.NoTrailingComments=2048]="NoTrailingComments",e[e.NoComments=3072]="NoComments",e[e.NoNestedComments=4096]="NoNestedComments",e[e.HelperName=8192]="HelperName",e[e.ExportName=16384]="ExportName",e[e.LocalName=32768]="LocalName",e[e.InternalName=65536]="InternalName",e[e.Indented=131072]="Indented",e[e.NoIndentation=262144]="NoIndentation",e[e.AsyncFunctionBody=524288]="AsyncFunctionBody",e[e.ReuseTempVariableScope=1048576]="ReuseTempVariableScope",e[e.CustomPrologue=2097152]="CustomPrologue",e[e.NoHoisting=4194304]="NoHoisting",e[e.Iterator=8388608]="Iterator",e[e.NoAsciiEscaping=16777216]="NoAsciiEscaping",e))(o$||{}),rue=(e=>(e[e.None=0]="None",e[e.TypeScriptClassWrapper=1]="TypeScriptClassWrapper",e[e.NeverApplyImportHelper=2]="NeverApplyImportHelper",e[e.IgnoreSourceNewlines=4]="IgnoreSourceNewlines",e[e.Immutable=8]="Immutable",e[e.IndirectCall=16]="IndirectCall",e[e.TransformPrivateStaticElements=32]="TransformPrivateStaticElements",e))(rue||{}),nue=(e=>(e[e.Classes=2]="Classes",e[e.ForOf=2]="ForOf",e[e.Generators=2]="Generators",e[e.Iteration=2]="Iteration",e[e.SpreadElements=2]="SpreadElements",e[e.RestElements=2]="RestElements",e[e.TaggedTemplates=2]="TaggedTemplates",e[e.DestructuringAssignment=2]="DestructuringAssignment",e[e.BindingPatterns=2]="BindingPatterns",e[e.ArrowFunctions=2]="ArrowFunctions",e[e.BlockScopedVariables=2]="BlockScopedVariables",e[e.ObjectAssign=2]="ObjectAssign",e[e.RegularExpressionFlagsUnicode=2]="RegularExpressionFlagsUnicode",e[e.RegularExpressionFlagsSticky=2]="RegularExpressionFlagsSticky",e[e.Exponentiation=3]="Exponentiation",e[e.AsyncFunctions=4]="AsyncFunctions",e[e.ForAwaitOf=5]="ForAwaitOf",e[e.AsyncGenerators=5]="AsyncGenerators",e[e.AsyncIteration=5]="AsyncIteration",e[e.ObjectSpreadRest=5]="ObjectSpreadRest",e[e.RegularExpressionFlagsDotAll=5]="RegularExpressionFlagsDotAll",e[e.BindinglessCatch=6]="BindinglessCatch",e[e.BigInt=7]="BigInt",e[e.NullishCoalesce=7]="NullishCoalesce",e[e.OptionalChaining=7]="OptionalChaining",e[e.LogicalAssignment=8]="LogicalAssignment",e[e.TopLevelAwait=9]="TopLevelAwait",e[e.ClassFields=9]="ClassFields",e[e.PrivateNamesAndClassStaticBlocks=9]="PrivateNamesAndClassStaticBlocks",e[e.RegularExpressionFlagsHasIndices=9]="RegularExpressionFlagsHasIndices",e[e.ShebangComments=99]="ShebangComments",e[e.UsingAndAwaitUsing=99]="UsingAndAwaitUsing",e[e.ClassAndClassElementDecorators=99]="ClassAndClassElementDecorators",e[e.RegularExpressionFlagsUnicodeSets=99]="RegularExpressionFlagsUnicodeSets",e))(nue||{}),iue=(e=>(e[e.Extends=1]="Extends",e[e.Assign=2]="Assign",e[e.Rest=4]="Rest",e[e.Decorate=8]="Decorate",e[e.ESDecorateAndRunInitializers=8]="ESDecorateAndRunInitializers",e[e.Metadata=16]="Metadata",e[e.Param=32]="Param",e[e.Awaiter=64]="Awaiter",e[e.Generator=128]="Generator",e[e.Values=256]="Values",e[e.Read=512]="Read",e[e.SpreadArray=1024]="SpreadArray",e[e.Await=2048]="Await",e[e.AsyncGenerator=4096]="AsyncGenerator",e[e.AsyncDelegator=8192]="AsyncDelegator",e[e.AsyncValues=16384]="AsyncValues",e[e.ExportStar=32768]="ExportStar",e[e.ImportStar=65536]="ImportStar",e[e.ImportDefault=131072]="ImportDefault",e[e.MakeTemplateObject=262144]="MakeTemplateObject",e[e.ClassPrivateFieldGet=524288]="ClassPrivateFieldGet",e[e.ClassPrivateFieldSet=1048576]="ClassPrivateFieldSet",e[e.ClassPrivateFieldIn=2097152]="ClassPrivateFieldIn",e[e.SetFunctionName=4194304]="SetFunctionName",e[e.PropKey=8388608]="PropKey",e[e.AddDisposableResourceAndDisposeResources=16777216]="AddDisposableResourceAndDisposeResources",e[e.FirstEmitHelper=1]="FirstEmitHelper",e[e.LastEmitHelper=16777216]="LastEmitHelper",e[e.ForOfIncludes=256]="ForOfIncludes",e[e.ForAwaitOfIncludes=16384]="ForAwaitOfIncludes",e[e.AsyncGeneratorIncludes=6144]="AsyncGeneratorIncludes",e[e.AsyncDelegatorIncludes=26624]="AsyncDelegatorIncludes",e[e.SpreadIncludes=1536]="SpreadIncludes",e))(iue||{}),sue=(e=>(e[e.SourceFile=0]="SourceFile",e[e.Expression=1]="Expression",e[e.IdentifierName=2]="IdentifierName",e[e.MappedTypeParameter=3]="MappedTypeParameter",e[e.Unspecified=4]="Unspecified",e[e.EmbeddedStatement=5]="EmbeddedStatement",e[e.JsxAttributeValue=6]="JsxAttributeValue",e[e.ImportTypeNodeAttributes=7]="ImportTypeNodeAttributes",e))(sue||{}),aue=(e=>(e[e.Parentheses=1]="Parentheses",e[e.TypeAssertions=2]="TypeAssertions",e[e.NonNullAssertions=4]="NonNullAssertions",e[e.PartiallyEmittedExpressions=8]="PartiallyEmittedExpressions",e[e.Assertions=6]="Assertions",e[e.All=15]="All",e[e.ExcludeJSDocTypeAssertion=16]="ExcludeJSDocTypeAssertion",e))(aue||{}),oue=(e=>(e[e.None=0]="None",e[e.InParameters=1]="InParameters",e[e.VariablesHoistedInParameters=2]="VariablesHoistedInParameters",e))(oue||{}),cue=(e=>(e[e.None=0]="None",e[e.SingleLine=0]="SingleLine",e[e.MultiLine=1]="MultiLine",e[e.PreserveLines=2]="PreserveLines",e[e.LinesMask=3]="LinesMask",e[e.NotDelimited=0]="NotDelimited",e[e.BarDelimited=4]="BarDelimited",e[e.AmpersandDelimited=8]="AmpersandDelimited",e[e.CommaDelimited=16]="CommaDelimited",e[e.AsteriskDelimited=32]="AsteriskDelimited",e[e.DelimitersMask=60]="DelimitersMask",e[e.AllowTrailingComma=64]="AllowTrailingComma",e[e.Indented=128]="Indented",e[e.SpaceBetweenBraces=256]="SpaceBetweenBraces",e[e.SpaceBetweenSiblings=512]="SpaceBetweenSiblings",e[e.Braces=1024]="Braces",e[e.Parenthesis=2048]="Parenthesis",e[e.AngleBrackets=4096]="AngleBrackets",e[e.SquareBrackets=8192]="SquareBrackets",e[e.BracketsMask=15360]="BracketsMask",e[e.OptionalIfUndefined=16384]="OptionalIfUndefined",e[e.OptionalIfEmpty=32768]="OptionalIfEmpty",e[e.Optional=49152]="Optional",e[e.PreferNewLine=65536]="PreferNewLine",e[e.NoTrailingNewLine=131072]="NoTrailingNewLine",e[e.NoInterveningComments=262144]="NoInterveningComments",e[e.NoSpaceIfEmpty=524288]="NoSpaceIfEmpty",e[e.SingleElement=1048576]="SingleElement",e[e.SpaceAfterList=2097152]="SpaceAfterList",e[e.Modifiers=2359808]="Modifiers",e[e.HeritageClauses=512]="HeritageClauses",e[e.SingleLineTypeLiteralMembers=768]="SingleLineTypeLiteralMembers",e[e.MultiLineTypeLiteralMembers=32897]="MultiLineTypeLiteralMembers",e[e.SingleLineTupleTypeElements=528]="SingleLineTupleTypeElements",e[e.MultiLineTupleTypeElements=657]="MultiLineTupleTypeElements",e[e.UnionTypeConstituents=516]="UnionTypeConstituents",e[e.IntersectionTypeConstituents=520]="IntersectionTypeConstituents",e[e.ObjectBindingPatternElements=525136]="ObjectBindingPatternElements",e[e.ArrayBindingPatternElements=524880]="ArrayBindingPatternElements",e[e.ObjectLiteralExpressionProperties=526226]="ObjectLiteralExpressionProperties",e[e.ImportAttributes=526226]="ImportAttributes",e[e.ImportClauseEntries=526226]="ImportClauseEntries",e[e.ArrayLiteralExpressionElements=8914]="ArrayLiteralExpressionElements",e[e.CommaListElements=528]="CommaListElements",e[e.CallExpressionArguments=2576]="CallExpressionArguments",e[e.NewExpressionArguments=18960]="NewExpressionArguments",e[e.TemplateExpressionSpans=262144]="TemplateExpressionSpans",e[e.SingleLineBlockStatements=768]="SingleLineBlockStatements",e[e.MultiLineBlockStatements=129]="MultiLineBlockStatements",e[e.VariableDeclarationList=528]="VariableDeclarationList",e[e.SingleLineFunctionBodyStatements=768]="SingleLineFunctionBodyStatements",e[e.MultiLineFunctionBodyStatements=1]="MultiLineFunctionBodyStatements",e[e.ClassHeritageClauses=0]="ClassHeritageClauses",e[e.ClassMembers=129]="ClassMembers",e[e.InterfaceMembers=129]="InterfaceMembers",e[e.EnumMembers=145]="EnumMembers",e[e.CaseBlockClauses=129]="CaseBlockClauses",e[e.NamedImportsOrExportsElements=525136]="NamedImportsOrExportsElements",e[e.JsxElementOrFragmentChildren=262144]="JsxElementOrFragmentChildren",e[e.JsxElementAttributes=262656]="JsxElementAttributes",e[e.CaseOrDefaultClauseStatements=163969]="CaseOrDefaultClauseStatements",e[e.HeritageClauseTypes=528]="HeritageClauseTypes",e[e.SourceFileStatements=131073]="SourceFileStatements",e[e.Decorators=2146305]="Decorators",e[e.TypeArguments=53776]="TypeArguments",e[e.TypeParameters=53776]="TypeParameters",e[e.Parameters=2576]="Parameters",e[e.IndexSignatureParameters=8848]="IndexSignatureParameters",e[e.JSDocComment=33]="JSDocComment",e))(cue||{}),lue=(e=>(e[e.None=0]="None",e[e.TripleSlashXML=1]="TripleSlashXML",e[e.SingleLine=2]="SingleLine",e[e.MultiLine=4]="MultiLine",e[e.All=7]="All",e[e.Default=7]="Default",e))(lue||{}),l5={reference:{args:[{name:"types",optional:!0,captureSpan:!0},{name:"lib",optional:!0,captureSpan:!0},{name:"path",optional:!0,captureSpan:!0},{name:"no-default-lib",optional:!0},{name:"resolution-mode",optional:!0},{name:"preserve",optional:!0}],kind:1},"amd-dependency":{args:[{name:"path"},{name:"name",optional:!0}],kind:1},"amd-module":{args:[{name:"name"}],kind:1},"ts-check":{kind:2},"ts-nocheck":{kind:2},jsx:{args:[{name:"factory"}],kind:4},jsxfrag:{args:[{name:"factory"}],kind:4},jsximportsource:{args:[{name:"factory"}],kind:4},jsxruntime:{args:[{name:"factory"}],kind:4}},uue=(e=>(e[e.ParseAll=0]="ParseAll",e[e.ParseNone=1]="ParseNone",e[e.ParseForTypeErrors=2]="ParseForTypeErrors",e[e.ParseForTypeInfo=3]="ParseForTypeInfo",e))(uue||{});function nI(e){let t=5381;for(let n=0;n<e.length;n++)t=(t<<5)+t+e.charCodeAt(n);return t.toString()}function kOe(){Error.stackTraceLimit<100&&(Error.stackTraceLimit=100)}var _ue=(e=>(e[e.Created=0]="Created",e[e.Changed=1]="Changed",e[e.Deleted=2]="Deleted",e))(_ue||{}),c$=(e=>(e[e.High=2e3]="High",e[e.Medium=500]="Medium",e[e.Low=250]="Low",e))(c$||{}),np=new Date(0);function zC(e,t){return e.getModifiedTime(t)||np}function fue(e){return{250:e.Low,500:e.Medium,2e3:e.High}}var l$={Low:32,Medium:64,High:256},u$=fue(l$),u5=fue(l$);function jvt(e){if(!e.getEnvironmentVariable)return;let t=s("TSC_WATCH_POLLINGINTERVAL",c$);u$=o("TSC_WATCH_POLLINGCHUNKSIZE",l$)||u$,u5=o("TSC_WATCH_UNCHANGEDPOLLTHRESHOLDS",l$)||u5;function n(u,m){return e.getEnvironmentVariable(`${u}_${m.toUpperCase()}`)}function i(u){let m;return d("Low"),d("Medium"),d("High"),m;function d(S){let E=n(u,S);E&&((m||(m={}))[S]=Number(E))}}function s(u,m){let d=i(u);if(d)return S("Low"),S("Medium"),S("High"),!0;return!1;function S(E){m[E]=d[E]||m[E]}}function o(u,m){let d=i(u);return(t||d)&&fue(d?{...m,...d}:m)}}function POe(e,t,n,i,s){let o=n;for(let m=t.length;i&&m;u(),m--){let d=t[n];if(d){if(d.isClosed){t[n]=void 0;continue}}else continue;i--;let S=Jvt(d,zC(e,d.fileName));if(d.isClosed){t[n]=void 0;continue}s?.(d,n,S),t[n]&&(o<n&&(t[o]=d,t[n]=void 0),o++)}return n;function u(){n++,n===t.length&&(o<n&&(t.length=o),n=0,o=0)}}function Bvt(e){let t=[],n=[],i=m(250),s=m(500),o=m(2e3);return u;function u(F,J,G){let q={fileName:F,callback:J,unchangedPolls:0,mtime:zC(e,F)};return t.push(q),D(q,G),{close:()=>{q.isClosed=!0,JC(t,q)}}}function m(F){let J=[];return J.pollingInterval=F,J.pollIndex=0,J.pollScheduled=!1,J}function d(F,J){J.pollIndex=E(J,J.pollingInterval,J.pollIndex,u$[J.pollingInterval]),J.length?L(J.pollingInterval):(M.assert(J.pollIndex===0),J.pollScheduled=!1)}function S(F,J){E(n,250,0,n.length),d(F,J),!J.pollScheduled&&n.length&&L(250)}function E(F,J,G,q){return POe(e,F,G,q,ee);function ee(W,pe,K){K?(W.unchangedPolls=0,F!==n&&(F[pe]=void 0,w(W))):W.unchangedPolls!==u5[J]?W.unchangedPolls++:F===n?(W.unchangedPolls=1,F[pe]=void 0,D(W,250)):J!==2e3&&(W.unchangedPolls++,F[pe]=void 0,D(W,J===250?500:2e3))}}function x(F){switch(F){case 250:return i;case 500:return s;case 2e3:return o}}function D(F,J){x(J).push(F),R(J)}function w(F){n.push(F),R(250)}function R(F){x(F).pollScheduled||L(F)}function L(F){x(F).pollScheduled=e.setTimeout(F===250?S:d,F,F===250?"pollLowPollingIntervalQueue":"pollPollingIntervalQueue",x(F))}}function Uvt(e,t,n,i){let s=yd(),o=i?new Map:void 0,u=new Map,m=l_(t);return d;function d(E,x,D,w){let R=m(E);s.add(R,x).length===1&&o&&o.set(R,n(E)||np);let L=mi(R)||".",F=u.get(L)||S(mi(E)||".",L,w);return F.referenceCount++,{close:()=>{F.referenceCount===1?(F.close(),u.delete(L)):F.referenceCount--,s.remove(R,x)}}}function S(E,x,D){let w=e(E,1,(R,L)=>{if(!bs(L))return;let F=xs(L,E),J=m(F),G=F&&s.get(J);if(G){let q,ee=1;if(o){let W=o.get(J);if(R==="change"&&(q=n(F)||np,q.getTime()===W.getTime()))return;q||(q=n(F)||np),o.set(J,q),W===np?ee=0:q===np&&(ee=2)}for(let W of G)W(F,ee,q)}},!1,500,D);return w.referenceCount=0,u.set(x,w),w}}function Vvt(e){let t=[],n=0,i;return s;function s(m,d){let S={fileName:m,callback:d,mtime:zC(e,m)};return t.push(S),u(),{close:()=>{S.isClosed=!0,JC(t,S)}}}function o(){i=void 0,n=POe(e,t,n,u$[250]),u()}function u(){!t.length||i||(i=e.setTimeout(o,2e3,"pollQueue"))}}function NOe(e,t,n,i,s){let u=l_(t)(n),m=e.get(u);return m?m.callbacks.push(i):e.set(u,{watcher:s((d,S,E)=>{var x;return(x=e.get(u))==null?void 0:x.callbacks.slice().forEach(D=>D(d,S,E))}),callbacks:[i]}),{close:()=>{let d=e.get(u);d&&(!Gw(d.callbacks,i)||d.callbacks.length||(e.delete(u),Nd(d)))}}}function Jvt(e,t){let n=e.mtime.getTime(),i=t.getTime();return n!==i?(e.mtime=t,e.callback(e.fileName,_$(n,i),t),!0):!1}function _$(e,t){return e===0?0:t===0?2:1}var _5=["/node_modules/.","/.git","/.#"],DOe=io;function v3(e){return DOe(e)}function pue(e){DOe=e}function qvt({watchDirectory:e,useCaseSensitiveFileNames:t,getCurrentDirectory:n,getAccessibleSortedChildDirectories:i,fileSystemEntryExists:s,realpath:o,setTimeout:u,clearTimeout:m}){let d=new Map,S=yd(),E=new Map,x,D=CP(!t),w=l_(t);return(re,ue,ce,ne)=>ce?R(re,ne,ue):e(re,ue,ce,ne);function R(re,ue,ce,ne){let le=w(re),me=d.get(le);me?me.refCount++:(me={watcher:e(re,Ae=>{var xe;pe(Ae,ue)||(ue?.synchronousWatchDirectory?((xe=d.get(le))!=null&&xe.targetWatcher||L(re,le,Ae),W(re,le,ue)):F(re,le,Ae,ue))},!1,ue),refCount:1,childWatches:ve,targetWatcher:void 0,links:void 0},d.set(le,me),W(re,le,ue)),ne&&(me.links??(me.links=new Set)).add(ne);let de=ce&&{dirName:re,callback:ce};return de&&S.add(le,de),{dirName:re,close:()=>{var Ae;let xe=M.checkDefined(d.get(le));de&&S.remove(le,de),ne&&((Ae=xe.links)==null||Ae.delete(ne)),xe.refCount--,!xe.refCount&&(d.delete(le),xe.links=void 0,Nd(xe),ee(xe),xe.childWatches.forEach(Dm))}}}function L(re,ue,ce,ne){var le,me;let de,Ae;bs(ce)?de=ce:Ae=ce,S.forEach((xe,te)=>{if(!(Ae&&Ae.get(te)===!0)&&(te===ue||_s(ue,te)&&ue[te.length]===Ec))if(Ae)if(ne){let he=Ae.get(te);he?he.push(...ne):Ae.set(te,ne.slice())}else Ae.set(te,!0);else xe.forEach(({callback:he})=>he(de))}),(me=(le=d.get(ue))==null?void 0:le.links)==null||me.forEach(xe=>{let te=he=>ri(xe,Xm(re,he,w));Ae?L(xe,w(xe),Ae,ne?.map(te)):L(xe,w(xe),te(de))})}function F(re,ue,ce,ne){let le=d.get(ue);if(le&&s(re,1)){J(re,ue,ce,ne);return}L(re,ue,ce),ee(le),q(le)}function J(re,ue,ce,ne){let le=E.get(ue);le?le.fileNames.push(ce):E.set(ue,{dirName:re,options:ne,fileNames:[ce]}),x&&(m(x),x=void 0),x=u(G,1e3,"timerToUpdateChildWatches")}function G(){var re;x=void 0,v3(`sysLog:: onTimerToUpdateChildWatches:: ${E.size}`);let ue=Tc(),ce=new Map;for(;!x&&E.size;){let le=E.entries().next();M.assert(!le.done);let{value:[me,{dirName:de,options:Ae,fileNames:xe}]}=le;E.delete(me);let te=W(de,me,Ae);(re=d.get(me))!=null&&re.targetWatcher||L(de,me,ce,te?void 0:xe)}v3(`sysLog:: invokingWatchers:: Elapsed:: ${Tc()-ue}ms:: ${E.size}`),S.forEach((le,me)=>{let de=ce.get(me);de&&le.forEach(({callback:Ae,dirName:xe})=>{Rs(de)?de.forEach(Ae):Ae(xe)})});let ne=Tc()-ue;v3(`sysLog:: Elapsed:: ${ne}ms:: onTimerToUpdateChildWatches:: ${E.size} ${x}`)}function q(re){if(!re)return;let ue=re.childWatches;re.childWatches=ve;for(let ce of ue)ce.close(),q(d.get(w(ce.dirName)))}function ee(re){re?.targetWatcher&&(re.targetWatcher.close(),re.targetWatcher=void 0)}function W(re,ue,ce){let ne=d.get(ue);if(!ne)return!1;let le=Zs(o(re)),me,de;return D(le,re)===0?me=i5(s(re,1)?Gi(i(re),te=>{let he=xs(te,re);return!pe(he,ce)&&D(he,Zs(o(he)))===0?he:void 0}):ve,ne.childWatches,(te,he)=>D(te,he.dirName),Ae,Dm,xe):ne.targetWatcher&&D(le,ne.targetWatcher.dirName)===0?(me=!1,M.assert(ne.childWatches===ve)):(ee(ne),ne.targetWatcher=R(le,ce,void 0,re),ne.childWatches.forEach(Dm),me=!0),ne.childWatches=de||ve,me;function Ae(te){let he=R(te,ce);xe(he)}function xe(te){(de||(de=[])).push(te)}}function pe(re,ue){return Pt(_5,ce=>K(re,ce))||wOe(re,ue,t,n)}function K(re,ue){return re.includes(ue)?!0:t?!1:w(re).includes(ue)}}var due=(e=>(e[e.File=0]="File",e[e.Directory=1]="Directory",e))(due||{});function zvt(e){return(t,n,i)=>e(n===1?"change":"rename","",i)}function Wvt(e,t,n){return(i,s,o)=>{i==="rename"?(o||(o=n(e)||np),t(e,o!==np?0:2,o)):t(e,1,o)}}function wOe(e,t,n,i){return(t?.excludeDirectories||t?.excludeFiles)&&(pB(e,t?.excludeFiles,n,i())||pB(e,t?.excludeDirectories,n,i()))}function IOe(e,t,n,i,s){return(o,u)=>{if(o==="rename"){let m=u?Zs(ri(e,u)):e;(!u||!wOe(m,n,i,s))&&t(m)}}}function mue({pollingWatchFileWorker:e,getModifiedTime:t,setTimeout:n,clearTimeout:i,fsWatchWorker:s,fileSystemEntryExists:o,useCaseSensitiveFileNames:u,getCurrentDirectory:m,fsSupportsRecursiveFsWatch:d,getAccessibleSortedChildDirectories:S,realpath:E,tscWatchFile:x,useNonPollingWatchers:D,tscWatchDirectory:w,inodeWatching:R,fsWatchWithTimestamp:L,sysLog:F}){let J=new Map,G=new Map,q=new Map,ee,W,pe,K,re=!1;return{watchFile:ue,watchDirectory:de};function ue(Pe,ke,De,Be){Be=le(Be,D);let ct=M.checkDefined(Be.watchFile);switch(ct){case 0:return te(Pe,ke,250,void 0);case 1:return te(Pe,ke,De,void 0);case 2:return ce()(Pe,ke,De,void 0);case 3:return ne()(Pe,ke,void 0,void 0);case 4:return he(Pe,0,Wvt(Pe,ke,t),!1,De,H8(Be));case 5:return pe||(pe=Uvt(he,u,t,L)),pe(Pe,ke,De,H8(Be));default:M.assertNever(ct)}}function ce(){return ee||(ee=Bvt({getModifiedTime:t,setTimeout:n}))}function ne(){return W||(W=Vvt({getModifiedTime:t,setTimeout:n}))}function le(Pe,ke){if(Pe&&Pe.watchFile!==void 0)return Pe;switch(x){case"PriorityPollingInterval":return{watchFile:1};case"DynamicPriorityPolling":return{watchFile:2};case"UseFsEvents":return me(4,1,Pe);case"UseFsEventsWithFallbackDynamicPolling":return me(4,2,Pe);case"UseFsEventsOnParentDirectory":ke=!0;default:return ke?me(5,1,Pe):{watchFile:4}}}function me(Pe,ke,De){let Be=De?.fallbackPolling;return{watchFile:Pe,fallbackPolling:Be===void 0?ke:Be}}function de(Pe,ke,De,Be){return d?he(Pe,1,IOe(Pe,ke,Be,u,m),De,500,H8(Be)):(K||(K=qvt({useCaseSensitiveFileNames:u,getCurrentDirectory:m,fileSystemEntryExists:o,getAccessibleSortedChildDirectories:S,watchDirectory:Ae,realpath:E,setTimeout:n,clearTimeout:i})),K(Pe,ke,De,Be))}function Ae(Pe,ke,De,Be){M.assert(!De);let ct=xe(Be),qe=M.checkDefined(ct.watchDirectory);switch(qe){case 1:return te(Pe,()=>ke(Pe),500,void 0);case 2:return ce()(Pe,()=>ke(Pe),500,void 0);case 3:return ne()(Pe,()=>ke(Pe),void 0,void 0);case 0:return he(Pe,1,IOe(Pe,ke,Be,u,m),De,500,H8(ct));default:M.assertNever(qe)}}function xe(Pe){if(Pe&&Pe.watchDirectory!==void 0)return Pe;switch(w){case"RecursiveDirectoryUsingFsWatchFile":return{watchDirectory:1};case"RecursiveDirectoryUsingDynamicPriorityPolling":return{watchDirectory:2};default:let ke=Pe?.fallbackPolling;return{watchDirectory:0,fallbackPolling:ke!==void 0?ke:void 0}}}function te(Pe,ke,De,Be){return NOe(J,u,Pe,ke,ct=>e(Pe,ct,De,Be))}function he(Pe,ke,De,Be,ct,qe){return NOe(Be?q:G,u,Pe,De,et=>be(Pe,ke,et,Be,ct,qe))}function be(Pe,ke,De,Be,ct,qe){let et,Ie;R&&(et=Pe.substring(Pe.lastIndexOf(Ec)),Ie=et.slice(Ec.length));let _t=o(Pe,ke)?Xe():vr();return{close:()=>{_t&&(_t.close(),_t=void 0)}};function mt(xr){_t&&(F(`sysLog:: ${Pe}:: Changing watcher to ${xr===Xe?"Present":"Missing"}FileSystemEntryWatcher`),_t.close(),_t=xr())}function Xe(){if(re)return F(`sysLog:: ${Pe}:: Defaulting to watchFile`),rr();try{let xr=(ke===1||!L?s:Ve)(Pe,Be,R?ht:De);return xr.on("error",()=>{De("rename",""),mt(vr)}),xr}catch(xr){return re||(re=xr.code==="ENOSPC"),F(`sysLog:: ${Pe}:: Changing to watchFile`),rr()}}function ht(xr,jr){let ur;if(jr&&Wc(jr,"~")&&(ur=jr,jr=jr.slice(0,jr.length-1)),xr==="rename"&&(!jr||jr===Ie||Wc(jr,et))){let or=t(Pe)||np;ur&&De(xr,ur,or),De(xr,jr,or),R?mt(or===np?vr:Xe):or===np&&mt(vr)}else ur&&De(xr,ur),De(xr,jr)}function rr(){return ue(Pe,zvt(De),ct,qe)}function vr(){return ue(Pe,(xr,jr,ur)=>{jr===0&&(ur||(ur=t(Pe)||np),ur!==np&&(De("rename","",ur),mt(Xe)))},ct,qe)}}function Ve(Pe,ke,De){let Be=t(Pe)||np;return s(Pe,ke,(ct,qe,et)=>{ct==="change"&&(et||(et=t(Pe)||np),et.getTime()===Be.getTime())||(Be=et||t(Pe)||np,De(ct,qe,Be))})}}function gue(e){let t=e.writeFile;e.writeFile=(n,i,s)=>HH(n,i,!!s,(o,u,m)=>t.call(e,o,u,m),o=>e.createDirectory(o),o=>e.directoryExists(o))}var lu=(()=>{let e="\uFEFF";function t(){let i=/^native |^\([^)]+\)$|^(internal[\\/]|[a-zA-Z0-9_\s]+(\.js)?$)/,s=Bu("fs"),o=Bu("path"),u=Bu("os"),m;try{m=Bu("crypto")}catch{m=void 0}let d,S="./profile.cpuprofile",E=process.platform==="darwin",x=process.platform==="linux"||E,D=u.platform(),w=ue(),R=s.realpathSync.native?process.platform==="win32"?ke:s.realpathSync.native:s.realpathSync,L=__filename.endsWith("sys.js")?o.join(o.dirname(__dirname),"__fake__.js"):__filename,F=process.platform==="win32"||E,J=tf(()=>process.cwd()),{watchFile:G,watchDirectory:q}=mue({pollingWatchFileWorker:ne,getModifiedTime:Be,setTimeout,clearTimeout,fsWatchWorker:le,useCaseSensitiveFileNames:w,getCurrentDirectory:J,fileSystemEntryExists:he,fsSupportsRecursiveFsWatch:F,getAccessibleSortedChildDirectories:Ie=>xe(Ie).directories,realpath:De,tscWatchFile:process.env.TSC_WATCHFILE,useNonPollingWatchers:!!process.env.TSC_NONPOLLING_WATCHER,tscWatchDirectory:process.env.TSC_WATCHDIRECTORY,inodeWatching:x,fsWatchWithTimestamp:E,sysLog:v3}),ee={args:process.argv.slice(2),newLine:u.EOL,useCaseSensitiveFileNames:w,write(Ie){process.stdout.write(Ie)},getWidthOfTerminal(){return process.stdout.columns},writeOutputIsTTY(){return process.stdout.isTTY},readFile:de,writeFile:Ae,watchFile:G,watchDirectory:q,resolvePath:Ie=>o.resolve(Ie),fileExists:be,directoryExists:Ve,getAccessibleFileSystemEntries:xe,createDirectory(Ie){if(!ee.directoryExists(Ie))try{s.mkdirSync(Ie)}catch(_t){if(_t.code!=="EEXIST")throw _t}},getExecutingFilePath(){return L},getCurrentDirectory:J,getDirectories:Pe,getEnvironmentVariable(Ie){return process.env[Ie]||""},readDirectory:te,getModifiedTime:Be,setModifiedTime:ct,deleteFile:qe,createHash:m?et:nI,createSHA256Hash:m?et:void 0,getMemoryUsage(){return global.gc&&global.gc(),process.memoryUsage().heapUsed},getFileSize(Ie){try{let _t=W(Ie);if(_t?.isFile())return _t.size}catch{}return 0},exit(Ie){re(()=>process.exit(Ie))},enableCPUProfiler:pe,disableCPUProfiler:re,cpuProfilingEnabled:()=>!!d||Es(process.execArgv,"--cpu-prof")||Es(process.execArgv,"--prof"),realpath:De,debugMode:!!process.env.NODE_INSPECTOR_IPC||!!process.env.VSCODE_INSPECTOR_OPTIONS||Pt(process.execArgv,Ie=>/^--(inspect|debug)(-brk)?(=\d+)?$/i.test(Ie))||!!process.recordreplay,tryEnableSourceMapsForHost(){try{Ept().install()}catch{}},setTimeout,clearTimeout,clearScreen:()=>{process.stdout.write("\x1Bc")},setBlocking:()=>{var Ie;let _t=(Ie=process.stdout)==null?void 0:Ie._handle;_t&&_t.setBlocking&&_t.setBlocking(!0)},base64decode:Ie=>Buffer.from(Ie,"base64").toString("utf8"),base64encode:Ie=>Buffer.from(Ie).toString("base64"),require:(Ie,_t)=>{try{let mt=pge(_t,Ie,ee);return{module:Bu(mt),modulePath:mt,error:void 0}}catch(mt){return{module:void 0,modulePath:void 0,error:mt}}}};return ee;function W(Ie){return s.statSync(Ie,{throwIfNoEntry:!1})}function pe(Ie,_t){if(d)return _t(),!1;let mt=Bu("inspector");if(!mt||!mt.Session)return _t(),!1;let Xe=new mt.Session;return Xe.connect(),Xe.post("Profiler.enable",()=>{Xe.post("Profiler.start",()=>{d=Xe,S=Ie,_t()})}),!0}function K(Ie){let _t=0,mt=new Map,Xe=qu(o.dirname(L)),ht=`file://${Rh(Xe)===1?"":"/"}${Xe}`;for(let rr of Ie.nodes)if(rr.callFrame.url){let vr=qu(rr.callFrame.url);Cm(ht,vr,w)?rr.callFrame.url=WC(ht,vr,ht,l_(w),!0):i.test(vr)||(rr.callFrame.url=(mt.has(vr)?mt:mt.set(vr,`external${_t}.js`)).get(vr),_t++)}return Ie}function re(Ie){if(d&&d!=="stopping"){let _t=d;return d.post("Profiler.stop",(mt,{profile:Xe})=>{var ht;if(!mt){try{(ht=W(S))!=null&&ht.isDirectory()&&(S=o.join(S,`${new Date().toISOString().replace(/:/g,"-")}+P${process.pid}.cpuprofile`))}catch{}try{s.mkdirSync(o.dirname(S),{recursive:!0})}catch{}s.writeFileSync(S,JSON.stringify(K(Xe)))}d=void 0,_t.disconnect(),Ie()}),d="stopping",!0}else return Ie(),!1}function ue(){return D==="win32"||D==="win64"?!1:!be(ce(__filename))}function ce(Ie){return Ie.replace(/\w/g,_t=>{let mt=_t.toUpperCase();return _t===mt?_t.toLowerCase():mt})}function ne(Ie,_t,mt){s.watchFile(Ie,{persistent:!0,interval:mt},ht);let Xe;return{close:()=>s.unwatchFile(Ie,ht)};function ht(rr,vr){let xr=+vr.mtime==0||Xe===2;if(+rr.mtime==0){if(xr)return;Xe=2}else if(xr)Xe=0;else{if(+rr.mtime==+vr.mtime)return;Xe=1}_t(Ie,Xe,rr.mtime)}}function le(Ie,_t,mt){return s.watch(Ie,F?{persistent:!0,recursive:!!_t}:{persistent:!0},mt)}function me(Ie,_t){let mt;try{mt=s.readFileSync(Ie)}catch{return}let Xe=mt.length;if(Xe>=2&&mt[0]===254&&mt[1]===255){Xe&=-2;for(let ht=0;ht<Xe;ht+=2){let rr=mt[ht];mt[ht]=mt[ht+1],mt[ht+1]=rr}return mt.toString("utf16le",2)}return Xe>=2&&mt[0]===255&&mt[1]===254?mt.toString("utf16le",2):Xe>=3&&mt[0]===239&&mt[1]===187&&mt[2]===191?mt.toString("utf8",3):mt.toString("utf8")}function de(Ie,_t){var mt,Xe;(mt=rf)==null||mt.logStartReadFile(Ie);let ht=me(Ie,_t);return(Xe=rf)==null||Xe.logStopReadFile(),ht}function Ae(Ie,_t,mt){var Xe;(Xe=rf)==null||Xe.logEvent("WriteFile: "+Ie),mt&&(_t=e+_t);let ht;try{ht=s.openSync(Ie,"w"),s.writeSync(ht,_t,void 0,"utf8")}finally{ht!==void 0&&s.closeSync(ht)}}function xe(Ie){var _t;(_t=rf)==null||_t.logEvent("ReadDir: "+(Ie||"."));try{let mt=s.readdirSync(Ie||".",{withFileTypes:!0}),Xe=[],ht=[];for(let rr of mt){let vr=typeof rr=="string"?rr:rr.name;if(vr==="."||vr==="..")continue;let xr;if(typeof rr=="string"||rr.isSymbolicLink()){let jr=ri(Ie,vr);try{if(xr=W(jr),!xr)continue}catch{continue}}else xr=rr;xr.isFile()?Xe.push(vr):xr.isDirectory()&&ht.push(vr)}return Xe.sort(),ht.sort(),{files:Xe,directories:ht}}catch{return CG}}function te(Ie,_t,mt,Xe,ht){return TG(Ie,_t,mt,Xe,w,process.cwd(),ht,xe,De)}function he(Ie,_t){let mt=Error.stackTraceLimit;Error.stackTraceLimit=0;try{let Xe=W(Ie);if(!Xe)return!1;switch(_t){case 0:return Xe.isFile();case 1:return Xe.isDirectory();default:return!1}}catch{return!1}finally{Error.stackTraceLimit=mt}}function be(Ie){return he(Ie,0)}function Ve(Ie){return he(Ie,1)}function Pe(Ie){return xe(Ie).directories.slice()}function ke(Ie){return Ie.length<260?s.realpathSync.native(Ie):s.realpathSync(Ie)}function De(Ie){try{return R(Ie)}catch{return Ie}}function Be(Ie){var _t;let mt=Error.stackTraceLimit;Error.stackTraceLimit=0;try{return(_t=W(Ie))==null?void 0:_t.mtime}catch{return}finally{Error.stackTraceLimit=mt}}function ct(Ie,_t){try{s.utimesSync(Ie,_t,_t)}catch{return}}function qe(Ie){try{return s.unlinkSync(Ie)}catch{return}}function et(Ie){let _t=m.createHash("sha256");return _t.update(Ie),_t.digest("hex")}}let n;return JW()&&(n=t()),n&&gue(n),n})();function OOe(e){lu=e}lu&&lu.getEnvironmentVariable&&(jvt(lu),M.setAssertionLevel(/^development$/i.test(lu.getEnvironmentVariable("NODE_ENV"))?1:0)),lu&&lu.debugMode&&(M.isDebugging=!0);var Ec="/",f5="\\",ROe="://",$vt=/\\/g;function f$(e){return e===47||e===92}function hue(e){return p5(e)<0}function ip(e){return p5(e)>0}function p$(e){let t=p5(e);return t>0&&t===e.length}function iI(e){return p5(e)!==0}function qp(e){return/^\.\.?($|[\\/])/.test(e)}function d$(e){return!iI(e)&&!qp(e)}function kP(e){return Ul(e).includes(".")}function Ic(e,t){return e.length>t.length&&Wc(e,t)}function wl(e,t){for(let n of t)if(Ic(e,n))return!0;return!1}function hv(e){return e.length>0&&f$(e.charCodeAt(e.length-1))}function MOe(e){return e>=97&&e<=122||e>=65&&e<=90}function Hvt(e,t){let n=e.charCodeAt(t);if(n===58)return t+1;if(n===37&&e.charCodeAt(t+1)===51){let i=e.charCodeAt(t+2);if(i===97||i===65)return t+3}return-1}function p5(e){if(!e)return 0;let t=e.charCodeAt(0);if(t===47||t===92){if(e.charCodeAt(1)!==t)return 1;let i=e.indexOf(t===47?Ec:f5,2);return i<0?e.length:i+1}if(MOe(t)&&e.charCodeAt(1)===58){let i=e.charCodeAt(2);if(i===47||i===92)return 3;if(e.length===2)return 2}let n=e.indexOf(ROe);if(n!==-1){let i=n+ROe.length,s=e.indexOf(Ec,i);if(s!==-1){let o=e.slice(0,n),u=e.slice(i,s);if(o==="file"&&(u===""||u==="localhost")&&MOe(e.charCodeAt(s+1))){let m=Hvt(e,s+2);if(m!==-1){if(e.charCodeAt(m)===47)return~(m+1);if(m===e.length)return~m}}return~(s+1)}return~e.length}return 0}function Rh(e){let t=p5(e);return t<0?~t:t}function mi(e){e=qu(e);let t=Rh(e);return t===e.length?e:(e=ZS(e),e.slice(0,Math.max(t,e.lastIndexOf(Ec))))}function Ul(e,t,n){if(e=qu(e),Rh(e)===e.length)return"";e=ZS(e);let s=e.slice(Math.max(Rh(e),e.lastIndexOf(Ec)+1)),o=t!==void 0&&n!==void 0?PP(s,t,n):void 0;return o?s.slice(0,s.length-o.length):s}function LOe(e,t,n){if(_s(t,".")||(t="."+t),e.length>=t.length&&e.charCodeAt(e.length-t.length)===46){let i=e.slice(e.length-t.length);if(n(i,t))return i}}function Gvt(e,t,n){if(typeof t=="string")return LOe(e,t,n)||"";for(let i of t){let s=LOe(e,i,n);if(s)return s}return""}function PP(e,t,n){if(t)return Gvt(ZS(e),t,n?KS:Lx);let i=Ul(e),s=i.lastIndexOf(".");return s>=0?i.substring(s):""}function Yvt(e,t){let n=e.substring(0,t),i=e.substring(t).split(Ec);return i.length&&!vc(i)&&i.pop(),[n,...i]}function hu(e,t=""){return e=ri(t,e),Yvt(e,Rh(e))}function u0(e,t){return e.length===0?"":(e[0]&&yu(e[0]))+e.slice(1,t).join(Ec)}function qu(e){return e.includes("\\")?e.replace($vt,Ec):e}function Ux(e){if(!Pt(e))return[];let t=[e[0]];for(let n=1;n<e.length;n++){let i=e[n];if(i&&i!=="."){if(i===".."){if(t.length>1){if(t[t.length-1]!==".."){t.pop();continue}}else if(t[0])continue}t.push(i)}}return t}function ri(e,...t){e&&(e=qu(e));for(let n of t)n&&(n=qu(n),!e||Rh(n)!==0?e=n:e=yu(e)+n);return e}function QS(e,...t){return Zs(Pt(t)?ri(e,...t):qu(e))}function S3(e,t){return Ux(hu(e,t))}function xs(e,t){return u0(S3(e,t))}function Zs(e){if(e=qu(e),!g$.test(e))return e;let t=e.replace(/\/\.\//g,"/").replace(/^\.\//,"");if(t!==e&&(e=t,!g$.test(e)))return e;let n=u0(Ux(hu(e)));return n&&hv(e)?yu(n):n}function Kvt(e){return e.length===0?"":e.slice(1).join(Ec)}function m$(e,t){return Kvt(S3(e,t))}function rc(e,t,n){let i=ip(e)?Zs(e):xs(e,t);return n(i)}function ZS(e){return hv(e)?e.substr(0,e.length-1):e}function yu(e){return hv(e)?e:e+Ec}function Vx(e){return!iI(e)&&!qp(e)?"./"+e:e}function b3(e,t,n,i){let s=n!==void 0&&i!==void 0?PP(e,n,i):PP(e);return s?e.slice(0,e.length-s.length)+(_s(t,".")?t:"."+t):e}function yue(e,t){let n=DY(e);return n?e.slice(0,e.length-n.length)+(_s(t,".")?t:"."+t):b3(e,t)}var g$=/(?:\/\/)|(?:^|\/)\.\.?(?:$|\/)/;function vue(e,t,n){if(e===t)return 0;if(e===void 0)return-1;if(t===void 0)return 1;let i=e.substring(0,Rh(e)),s=t.substring(0,Rh(t)),o=d3(i,s);if(o!==0)return o;let u=e.substring(i.length),m=t.substring(s.length);if(!g$.test(u)&&!g$.test(m))return n(u,m);let d=Ux(hu(e)),S=Ux(hu(t)),E=Math.min(d.length,S.length);for(let x=1;x<E;x++){let D=n(d[x],S[x]);if(D!==0)return D}return tc(d.length,S.length)}function FOe(e,t){return vue(e,t,c_)}function jOe(e,t){return vue(e,t,d3)}function _0(e,t,n,i){return typeof n=="string"?(e=ri(n,e),t=ri(n,t)):typeof n=="boolean"&&(i=n),vue(e,t,CP(i))}function Cm(e,t,n,i){if(typeof n=="string"?(e=ri(n,e),t=ri(n,t)):typeof n=="boolean"&&(i=n),e===void 0||t===void 0)return!1;if(e===t)return!0;let s=Ux(hu(e)),o=Ux(hu(t));if(o.length<s.length)return!1;let u=i?KS:Lx;for(let m=0;m<s.length;m++)if(!(m===0?KS:u)(s[m],o[m]))return!1;return!0}function h$(e,t,n){let i=n(e),s=n(t);return _s(i,s+"/")||_s(i,s+"\\")}function y$(e,t,n,i){let s=Ux(hu(e)),o=Ux(hu(t)),u;for(u=0;u<s.length&&u<o.length;u++){let S=i(s[u]),E=i(o[u]);if(!(u===0?KS:n)(S,E))break}if(u===0)return o;let m=o.slice(u),d=[];for(;u<s.length;u++)d.push("..");return["",...d,...m]}function Xm(e,t,n){M.assert(Rh(e)>0==Rh(t)>0,"Paths must either both be absolute or both be relative");let o=y$(e,t,(typeof n=="boolean"?n:!1)?KS:Lx,typeof n=="function"?n:ec);return u0(o)}function sI(e,t,n){return ip(e)?WC(t,e,t,n,!1):e}function aI(e,t,n){return Vx(Xm(mi(e),t,n))}function WC(e,t,n,i,s){let o=y$(QS(n,e),QS(n,t),Lx,i),u=o[0];if(s&&ip(u)){let m=u.charAt(0)===Ec?"file://":"file:///";o[0]=m+u}return u0(o)}function Am(e,t){for(;;){let n=t(e);if(n!==void 0)return n;let i=mi(e);if(i===e)return;e=i}}function d5(e){return Wc(e,"/node_modules")}function N(e,t,n,i,s,o,u){return{code:e,category:t,key:n,message:i,reportsUnnecessary:s,elidedInCompatabilityPyramid:o,reportsDeprecated:u}}var v={Unterminated_string_literal:N(1002,1,"Unterminated_string_literal_1002","Unterminated string literal."),Identifier_expected:N(1003,1,"Identifier_expected_1003","Identifier expected."),_0_expected:N(1005,1,"_0_expected_1005","'{0}' expected."),A_file_cannot_have_a_reference_to_itself:N(1006,1,"A_file_cannot_have_a_reference_to_itself_1006","A file cannot have a reference to itself."),The_parser_expected_to_find_a_1_to_match_the_0_token_here:N(1007,1,"The_parser_expected_to_find_a_1_to_match_the_0_token_here_1007","The parser expected to find a '{1}' to match the '{0}' token here."),Trailing_comma_not_allowed:N(1009,1,"Trailing_comma_not_allowed_1009","Trailing comma not allowed."),Asterisk_Slash_expected:N(1010,1,"Asterisk_Slash_expected_1010","'*/' expected."),An_element_access_expression_should_take_an_argument:N(1011,1,"An_element_access_expression_should_take_an_argument_1011","An element access expression should take an argument."),Unexpected_token:N(1012,1,"Unexpected_token_1012","Unexpected token."),A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma:N(1013,1,"A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma_1013","A rest parameter or binding pattern may not have a trailing comma."),A_rest_parameter_must_be_last_in_a_parameter_list:N(1014,1,"A_rest_parameter_must_be_last_in_a_parameter_list_1014","A rest parameter must be last in a parameter list."),Parameter_cannot_have_question_mark_and_initializer:N(1015,1,"Parameter_cannot_have_question_mark_and_initializer_1015","Parameter cannot have question mark and initializer."),A_required_parameter_cannot_follow_an_optional_parameter:N(1016,1,"A_required_parameter_cannot_follow_an_optional_parameter_1016","A required parameter cannot follow an optional parameter."),An_index_signature_cannot_have_a_rest_parameter:N(1017,1,"An_index_signature_cannot_have_a_rest_parameter_1017","An index signature cannot have a rest parameter."),An_index_signature_parameter_cannot_have_an_accessibility_modifier:N(1018,1,"An_index_signature_parameter_cannot_have_an_accessibility_modifier_1018","An index signature parameter cannot have an accessibility modifier."),An_index_signature_parameter_cannot_have_a_question_mark:N(1019,1,"An_index_signature_parameter_cannot_have_a_question_mark_1019","An index signature parameter cannot have a question mark."),An_index_signature_parameter_cannot_have_an_initializer:N(1020,1,"An_index_signature_parameter_cannot_have_an_initializer_1020","An index signature parameter cannot have an initializer."),An_index_signature_must_have_a_type_annotation:N(1021,1,"An_index_signature_must_have_a_type_annotation_1021","An index signature must have a type annotation."),An_index_signature_parameter_must_have_a_type_annotation:N(1022,1,"An_index_signature_parameter_must_have_a_type_annotation_1022","An index signature parameter must have a type annotation."),readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature:N(1024,1,"readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature_1024","'readonly' modifier can only appear on a property declaration or index signature."),An_index_signature_cannot_have_a_trailing_comma:N(1025,1,"An_index_signature_cannot_have_a_trailing_comma_1025","An index signature cannot have a trailing comma."),Accessibility_modifier_already_seen:N(1028,1,"Accessibility_modifier_already_seen_1028","Accessibility modifier already seen."),_0_modifier_must_precede_1_modifier:N(1029,1,"_0_modifier_must_precede_1_modifier_1029","'{0}' modifier must precede '{1}' modifier."),_0_modifier_already_seen:N(1030,1,"_0_modifier_already_seen_1030","'{0}' modifier already seen."),_0_modifier_cannot_appear_on_class_elements_of_this_kind:N(1031,1,"_0_modifier_cannot_appear_on_class_elements_of_this_kind_1031","'{0}' modifier cannot appear on class elements of this kind."),super_must_be_followed_by_an_argument_list_or_member_access:N(1034,1,"super_must_be_followed_by_an_argument_list_or_member_access_1034","'super' must be followed by an argument list or member access."),Only_ambient_modules_can_use_quoted_names:N(1035,1,"Only_ambient_modules_can_use_quoted_names_1035","Only ambient modules can use quoted names."),Statements_are_not_allowed_in_ambient_contexts:N(1036,1,"Statements_are_not_allowed_in_ambient_contexts_1036","Statements are not allowed in ambient contexts."),A_declare_modifier_cannot_be_used_in_an_already_ambient_context:N(1038,1,"A_declare_modifier_cannot_be_used_in_an_already_ambient_context_1038","A 'declare' modifier cannot be used in an already ambient context."),Initializers_are_not_allowed_in_ambient_contexts:N(1039,1,"Initializers_are_not_allowed_in_ambient_contexts_1039","Initializers are not allowed in ambient contexts."),_0_modifier_cannot_be_used_in_an_ambient_context:N(1040,1,"_0_modifier_cannot_be_used_in_an_ambient_context_1040","'{0}' modifier cannot be used in an ambient context."),_0_modifier_cannot_be_used_here:N(1042,1,"_0_modifier_cannot_be_used_here_1042","'{0}' modifier cannot be used here."),_0_modifier_cannot_appear_on_a_module_or_namespace_element:N(1044,1,"_0_modifier_cannot_appear_on_a_module_or_namespace_element_1044","'{0}' modifier cannot appear on a module or namespace element."),Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier:N(1046,1,"Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier_1046","Top-level declarations in .d.ts files must start with either a 'declare' or 'export' modifier."),A_rest_parameter_cannot_be_optional:N(1047,1,"A_rest_parameter_cannot_be_optional_1047","A rest parameter cannot be optional."),A_rest_parameter_cannot_have_an_initializer:N(1048,1,"A_rest_parameter_cannot_have_an_initializer_1048","A rest parameter cannot have an initializer."),A_set_accessor_must_have_exactly_one_parameter:N(1049,1,"A_set_accessor_must_have_exactly_one_parameter_1049","A 'set' accessor must have exactly one parameter."),A_set_accessor_cannot_have_an_optional_parameter:N(1051,1,"A_set_accessor_cannot_have_an_optional_parameter_1051","A 'set' accessor cannot have an optional parameter."),A_set_accessor_parameter_cannot_have_an_initializer:N(1052,1,"A_set_accessor_parameter_cannot_have_an_initializer_1052","A 'set' accessor parameter cannot have an initializer."),A_set_accessor_cannot_have_rest_parameter:N(1053,1,"A_set_accessor_cannot_have_rest_parameter_1053","A 'set' accessor cannot have rest parameter."),A_get_accessor_cannot_have_parameters:N(1054,1,"A_get_accessor_cannot_have_parameters_1054","A 'get' accessor cannot have parameters."),Type_0_is_not_a_valid_async_function_return_type_in_ES5_because_it_does_not_refer_to_a_Promise_compatible_constructor_value:N(1055,1,"Type_0_is_not_a_valid_async_function_return_type_in_ES5_because_it_does_not_refer_to_a_Promise_compa_1055","Type '{0}' is not a valid async function return type in ES5 because it does not refer to a Promise-compatible constructor value."),Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher:N(1056,1,"Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher_1056","Accessors are only available when targeting ECMAScript 5 and higher."),The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:N(1058,1,"The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_t_1058","The return type of an async function must either be a valid promise or must not contain a callable 'then' member."),A_promise_must_have_a_then_method:N(1059,1,"A_promise_must_have_a_then_method_1059","A promise must have a 'then' method."),The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback:N(1060,1,"The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback_1060","The first parameter of the 'then' method of a promise must be a callback."),Enum_member_must_have_initializer:N(1061,1,"Enum_member_must_have_initializer_1061","Enum member must have initializer."),Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method:N(1062,1,"Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method_1062","Type is referenced directly or indirectly in the fulfillment callback of its own 'then' method."),An_export_assignment_cannot_be_used_in_a_namespace:N(1063,1,"An_export_assignment_cannot_be_used_in_a_namespace_1063","An export assignment cannot be used in a namespace."),The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0:N(1064,1,"The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_wri_1064","The return type of an async function or method must be the global Promise<T> type. Did you mean to write 'Promise<{0}>'?"),The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type:N(1065,1,"The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_1065","The return type of an async function or method must be the global Promise<T> type."),In_ambient_enum_declarations_member_initializer_must_be_constant_expression:N(1066,1,"In_ambient_enum_declarations_member_initializer_must_be_constant_expression_1066","In ambient enum declarations member initializer must be constant expression."),Unexpected_token_A_constructor_method_accessor_or_property_was_expected:N(1068,1,"Unexpected_token_A_constructor_method_accessor_or_property_was_expected_1068","Unexpected token. A constructor, method, accessor, or property was expected."),Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces:N(1069,1,"Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces_1069","Unexpected token. A type parameter name was expected without curly braces."),_0_modifier_cannot_appear_on_a_type_member:N(1070,1,"_0_modifier_cannot_appear_on_a_type_member_1070","'{0}' modifier cannot appear on a type member."),_0_modifier_cannot_appear_on_an_index_signature:N(1071,1,"_0_modifier_cannot_appear_on_an_index_signature_1071","'{0}' modifier cannot appear on an index signature."),A_0_modifier_cannot_be_used_with_an_import_declaration:N(1079,1,"A_0_modifier_cannot_be_used_with_an_import_declaration_1079","A '{0}' modifier cannot be used with an import declaration."),Invalid_reference_directive_syntax:N(1084,1,"Invalid_reference_directive_syntax_1084","Invalid 'reference' directive syntax."),_0_modifier_cannot_appear_on_a_constructor_declaration:N(1089,1,"_0_modifier_cannot_appear_on_a_constructor_declaration_1089","'{0}' modifier cannot appear on a constructor declaration."),_0_modifier_cannot_appear_on_a_parameter:N(1090,1,"_0_modifier_cannot_appear_on_a_parameter_1090","'{0}' modifier cannot appear on a parameter."),Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement:N(1091,1,"Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement_1091","Only a single variable declaration is allowed in a 'for...in' statement."),Type_parameters_cannot_appear_on_a_constructor_declaration:N(1092,1,"Type_parameters_cannot_appear_on_a_constructor_declaration_1092","Type parameters cannot appear on a constructor declaration."),Type_annotation_cannot_appear_on_a_constructor_declaration:N(1093,1,"Type_annotation_cannot_appear_on_a_constructor_declaration_1093","Type annotation cannot appear on a constructor declaration."),An_accessor_cannot_have_type_parameters:N(1094,1,"An_accessor_cannot_have_type_parameters_1094","An accessor cannot have type parameters."),A_set_accessor_cannot_have_a_return_type_annotation:N(1095,1,"A_set_accessor_cannot_have_a_return_type_annotation_1095","A 'set' accessor cannot have a return type annotation."),An_index_signature_must_have_exactly_one_parameter:N(1096,1,"An_index_signature_must_have_exactly_one_parameter_1096","An index signature must have exactly one parameter."),_0_list_cannot_be_empty:N(1097,1,"_0_list_cannot_be_empty_1097","'{0}' list cannot be empty."),Type_parameter_list_cannot_be_empty:N(1098,1,"Type_parameter_list_cannot_be_empty_1098","Type parameter list cannot be empty."),Type_argument_list_cannot_be_empty:N(1099,1,"Type_argument_list_cannot_be_empty_1099","Type argument list cannot be empty."),Invalid_use_of_0_in_strict_mode:N(1100,1,"Invalid_use_of_0_in_strict_mode_1100","Invalid use of '{0}' in strict mode."),with_statements_are_not_allowed_in_strict_mode:N(1101,1,"with_statements_are_not_allowed_in_strict_mode_1101","'with' statements are not allowed in strict mode."),delete_cannot_be_called_on_an_identifier_in_strict_mode:N(1102,1,"delete_cannot_be_called_on_an_identifier_in_strict_mode_1102","'delete' cannot be called on an identifier in strict mode."),for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules:N(1103,1,"for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_1103","'for await' loops are only allowed within async functions and at the top levels of modules."),A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement:N(1104,1,"A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement_1104","A 'continue' statement can only be used within an enclosing iteration statement."),A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement:N(1105,1,"A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement_1105","A 'break' statement can only be used within an enclosing iteration or switch statement."),The_left_hand_side_of_a_for_of_statement_may_not_be_async:N(1106,1,"The_left_hand_side_of_a_for_of_statement_may_not_be_async_1106","The left-hand side of a 'for...of' statement may not be 'async'."),Jump_target_cannot_cross_function_boundary:N(1107,1,"Jump_target_cannot_cross_function_boundary_1107","Jump target cannot cross function boundary."),A_return_statement_can_only_be_used_within_a_function_body:N(1108,1,"A_return_statement_can_only_be_used_within_a_function_body_1108","A 'return' statement can only be used within a function body."),Expression_expected:N(1109,1,"Expression_expected_1109","Expression expected."),Type_expected:N(1110,1,"Type_expected_1110","Type expected."),Private_field_0_must_be_declared_in_an_enclosing_class:N(1111,1,"Private_field_0_must_be_declared_in_an_enclosing_class_1111","Private field '{0}' must be declared in an enclosing class."),A_default_clause_cannot_appear_more_than_once_in_a_switch_statement:N(1113,1,"A_default_clause_cannot_appear_more_than_once_in_a_switch_statement_1113","A 'default' clause cannot appear more than once in a 'switch' statement."),Duplicate_label_0:N(1114,1,"Duplicate_label_0_1114","Duplicate label '{0}'."),A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement:N(1115,1,"A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement_1115","A 'continue' statement can only jump to a label of an enclosing iteration statement."),A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement:N(1116,1,"A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement_1116","A 'break' statement can only jump to a label of an enclosing statement."),An_object_literal_cannot_have_multiple_properties_with_the_same_name:N(1117,1,"An_object_literal_cannot_have_multiple_properties_with_the_same_name_1117","An object literal cannot have multiple properties with the same name."),An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name:N(1118,1,"An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name_1118","An object literal cannot have multiple get/set accessors with the same name."),An_object_literal_cannot_have_property_and_accessor_with_the_same_name:N(1119,1,"An_object_literal_cannot_have_property_and_accessor_with_the_same_name_1119","An object literal cannot have property and accessor with the same name."),An_export_assignment_cannot_have_modifiers:N(1120,1,"An_export_assignment_cannot_have_modifiers_1120","An export assignment cannot have modifiers."),Octal_literals_are_not_allowed_Use_the_syntax_0:N(1121,1,"Octal_literals_are_not_allowed_Use_the_syntax_0_1121","Octal literals are not allowed. Use the syntax '{0}'."),Variable_declaration_list_cannot_be_empty:N(1123,1,"Variable_declaration_list_cannot_be_empty_1123","Variable declaration list cannot be empty."),Digit_expected:N(1124,1,"Digit_expected_1124","Digit expected."),Hexadecimal_digit_expected:N(1125,1,"Hexadecimal_digit_expected_1125","Hexadecimal digit expected."),Unexpected_end_of_text:N(1126,1,"Unexpected_end_of_text_1126","Unexpected end of text."),Invalid_character:N(1127,1,"Invalid_character_1127","Invalid character."),Declaration_or_statement_expected:N(1128,1,"Declaration_or_statement_expected_1128","Declaration or statement expected."),Statement_expected:N(1129,1,"Statement_expected_1129","Statement expected."),case_or_default_expected:N(1130,1,"case_or_default_expected_1130","'case' or 'default' expected."),Property_or_signature_expected:N(1131,1,"Property_or_signature_expected_1131","Property or signature expected."),Enum_member_expected:N(1132,1,"Enum_member_expected_1132","Enum member expected."),Variable_declaration_expected:N(1134,1,"Variable_declaration_expected_1134","Variable declaration expected."),Argument_expression_expected:N(1135,1,"Argument_expression_expected_1135","Argument expression expected."),Property_assignment_expected:N(1136,1,"Property_assignment_expected_1136","Property assignment expected."),Expression_or_comma_expected:N(1137,1,"Expression_or_comma_expected_1137","Expression or comma expected."),Parameter_declaration_expected:N(1138,1,"Parameter_declaration_expected_1138","Parameter declaration expected."),Type_parameter_declaration_expected:N(1139,1,"Type_parameter_declaration_expected_1139","Type parameter declaration expected."),Type_argument_expected:N(1140,1,"Type_argument_expected_1140","Type argument expected."),String_literal_expected:N(1141,1,"String_literal_expected_1141","String literal expected."),Line_break_not_permitted_here:N(1142,1,"Line_break_not_permitted_here_1142","Line break not permitted here."),or_expected:N(1144,1,"or_expected_1144","'{' or ';' expected."),or_JSX_element_expected:N(1145,1,"or_JSX_element_expected_1145","'{' or JSX element expected."),Declaration_expected:N(1146,1,"Declaration_expected_1146","Declaration expected."),Import_declarations_in_a_namespace_cannot_reference_a_module:N(1147,1,"Import_declarations_in_a_namespace_cannot_reference_a_module_1147","Import declarations in a namespace cannot reference a module."),Cannot_use_imports_exports_or_module_augmentations_when_module_is_none:N(1148,1,"Cannot_use_imports_exports_or_module_augmentations_when_module_is_none_1148","Cannot use imports, exports, or module augmentations when '--module' is 'none'."),File_name_0_differs_from_already_included_file_name_1_only_in_casing:N(1149,1,"File_name_0_differs_from_already_included_file_name_1_only_in_casing_1149","File name '{0}' differs from already included file name '{1}' only in casing."),_0_declarations_must_be_initialized:N(1155,1,"_0_declarations_must_be_initialized_1155","'{0}' declarations must be initialized."),_0_declarations_can_only_be_declared_inside_a_block:N(1156,1,"_0_declarations_can_only_be_declared_inside_a_block_1156","'{0}' declarations can only be declared inside a block."),Unterminated_template_literal:N(1160,1,"Unterminated_template_literal_1160","Unterminated template literal."),Unterminated_regular_expression_literal:N(1161,1,"Unterminated_regular_expression_literal_1161","Unterminated regular expression literal."),An_object_member_cannot_be_declared_optional:N(1162,1,"An_object_member_cannot_be_declared_optional_1162","An object member cannot be declared optional."),A_yield_expression_is_only_allowed_in_a_generator_body:N(1163,1,"A_yield_expression_is_only_allowed_in_a_generator_body_1163","A 'yield' expression is only allowed in a generator body."),Computed_property_names_are_not_allowed_in_enums:N(1164,1,"Computed_property_names_are_not_allowed_in_enums_1164","Computed property names are not allowed in enums."),A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type:N(1165,1,"A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_t_1165","A computed property name in an ambient context must refer to an expression whose type is a literal type or a 'unique symbol' type."),A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_symbol_type:N(1166,1,"A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_1166","A computed property name in a class property declaration must have a simple literal type or a 'unique symbol' type."),A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type:N(1168,1,"A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_ty_1168","A computed property name in a method overload must refer to an expression whose type is a literal type or a 'unique symbol' type."),A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type:N(1169,1,"A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_1169","A computed property name in an interface must refer to an expression whose type is a literal type or a 'unique symbol' type."),A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type:N(1170,1,"A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type__1170","A computed property name in a type literal must refer to an expression whose type is a literal type or a 'unique symbol' type."),A_comma_expression_is_not_allowed_in_a_computed_property_name:N(1171,1,"A_comma_expression_is_not_allowed_in_a_computed_property_name_1171","A comma expression is not allowed in a computed property name."),extends_clause_already_seen:N(1172,1,"extends_clause_already_seen_1172","'extends' clause already seen."),extends_clause_must_precede_implements_clause:N(1173,1,"extends_clause_must_precede_implements_clause_1173","'extends' clause must precede 'implements' clause."),Classes_can_only_extend_a_single_class:N(1174,1,"Classes_can_only_extend_a_single_class_1174","Classes can only extend a single class."),implements_clause_already_seen:N(1175,1,"implements_clause_already_seen_1175","'implements' clause already seen."),Interface_declaration_cannot_have_implements_clause:N(1176,1,"Interface_declaration_cannot_have_implements_clause_1176","Interface declaration cannot have 'implements' clause."),Binary_digit_expected:N(1177,1,"Binary_digit_expected_1177","Binary digit expected."),Octal_digit_expected:N(1178,1,"Octal_digit_expected_1178","Octal digit expected."),Unexpected_token_expected:N(1179,1,"Unexpected_token_expected_1179","Unexpected token. '{' expected."),Property_destructuring_pattern_expected:N(1180,1,"Property_destructuring_pattern_expected_1180","Property destructuring pattern expected."),Array_element_destructuring_pattern_expected:N(1181,1,"Array_element_destructuring_pattern_expected_1181","Array element destructuring pattern expected."),A_destructuring_declaration_must_have_an_initializer:N(1182,1,"A_destructuring_declaration_must_have_an_initializer_1182","A destructuring declaration must have an initializer."),An_implementation_cannot_be_declared_in_ambient_contexts:N(1183,1,"An_implementation_cannot_be_declared_in_ambient_contexts_1183","An implementation cannot be declared in ambient contexts."),Modifiers_cannot_appear_here:N(1184,1,"Modifiers_cannot_appear_here_1184","Modifiers cannot appear here."),Merge_conflict_marker_encountered:N(1185,1,"Merge_conflict_marker_encountered_1185","Merge conflict marker encountered."),A_rest_element_cannot_have_an_initializer:N(1186,1,"A_rest_element_cannot_have_an_initializer_1186","A rest element cannot have an initializer."),A_parameter_property_may_not_be_declared_using_a_binding_pattern:N(1187,1,"A_parameter_property_may_not_be_declared_using_a_binding_pattern_1187","A parameter property may not be declared using a binding pattern."),Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement:N(1188,1,"Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement_1188","Only a single variable declaration is allowed in a 'for...of' statement."),The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer:N(1189,1,"The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer_1189","The variable declaration of a 'for...in' statement cannot have an initializer."),The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer:N(1190,1,"The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer_1190","The variable declaration of a 'for...of' statement cannot have an initializer."),An_import_declaration_cannot_have_modifiers:N(1191,1,"An_import_declaration_cannot_have_modifiers_1191","An import declaration cannot have modifiers."),Module_0_has_no_default_export:N(1192,1,"Module_0_has_no_default_export_1192","Module '{0}' has no default export."),An_export_declaration_cannot_have_modifiers:N(1193,1,"An_export_declaration_cannot_have_modifiers_1193","An export declaration cannot have modifiers."),Export_declarations_are_not_permitted_in_a_namespace:N(1194,1,"Export_declarations_are_not_permitted_in_a_namespace_1194","Export declarations are not permitted in a namespace."),export_Asterisk_does_not_re_export_a_default:N(1195,1,"export_Asterisk_does_not_re_export_a_default_1195","'export *' does not re-export a default."),Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified:N(1196,1,"Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified_1196","Catch clause variable type annotation must be 'any' or 'unknown' if specified."),Catch_clause_variable_cannot_have_an_initializer:N(1197,1,"Catch_clause_variable_cannot_have_an_initializer_1197","Catch clause variable cannot have an initializer."),An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive:N(1198,1,"An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive_1198","An extended Unicode escape value must be between 0x0 and 0x10FFFF inclusive."),Unterminated_Unicode_escape_sequence:N(1199,1,"Unterminated_Unicode_escape_sequence_1199","Unterminated Unicode escape sequence."),Line_terminator_not_permitted_before_arrow:N(1200,1,"Line_terminator_not_permitted_before_arrow_1200","Line terminator not permitted before arrow."),Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead:N(1202,1,"Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_1202",`Import assignment cannot be used when targeting ECMAScript modules. Consider using 'import * as ns from "mod"', 'import {a} from "mod"', 'import d from "mod"', or another module format instead.`),Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead:N(1203,1,"Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or__1203","Export assignment cannot be used when targeting ECMAScript modules. Consider using 'export default' or another module format instead."),Re_exporting_a_type_when_0_is_enabled_requires_using_export_type:N(1205,1,"Re_exporting_a_type_when_0_is_enabled_requires_using_export_type_1205","Re-exporting a type when '{0}' is enabled requires using 'export type'."),Decorators_are_not_valid_here:N(1206,1,"Decorators_are_not_valid_here_1206","Decorators are not valid here."),Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name:N(1207,1,"Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name_1207","Decorators cannot be applied to multiple get/set accessors of the same name."),Invalid_optional_chain_from_new_expression_Did_you_mean_to_call_0:N(1209,1,"Invalid_optional_chain_from_new_expression_Did_you_mean_to_call_0_1209","Invalid optional chain from new expression. Did you mean to call '{0}()'?"),Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode:N(1210,1,"Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of__1210","Code contained in a class is evaluated in JavaScript's strict mode which does not allow this use of '{0}'. For more information, see https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Strict_mode."),A_class_declaration_without_the_default_modifier_must_have_a_name:N(1211,1,"A_class_declaration_without_the_default_modifier_must_have_a_name_1211","A class declaration without the 'default' modifier must have a name."),Identifier_expected_0_is_a_reserved_word_in_strict_mode:N(1212,1,"Identifier_expected_0_is_a_reserved_word_in_strict_mode_1212","Identifier expected. '{0}' is a reserved word in strict mode."),Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode:N(1213,1,"Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_stric_1213","Identifier expected. '{0}' is a reserved word in strict mode. Class definitions are automatically in strict mode."),Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode:N(1214,1,"Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode_1214","Identifier expected. '{0}' is a reserved word in strict mode. Modules are automatically in strict mode."),Invalid_use_of_0_Modules_are_automatically_in_strict_mode:N(1215,1,"Invalid_use_of_0_Modules_are_automatically_in_strict_mode_1215","Invalid use of '{0}'. Modules are automatically in strict mode."),Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules:N(1216,1,"Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules_1216","Identifier expected. '__esModule' is reserved as an exported marker when transforming ECMAScript modules."),Export_assignment_is_not_supported_when_module_flag_is_system:N(1218,1,"Export_assignment_is_not_supported_when_module_flag_is_system_1218","Export assignment is not supported when '--module' flag is 'system'."),Generators_are_not_allowed_in_an_ambient_context:N(1221,1,"Generators_are_not_allowed_in_an_ambient_context_1221","Generators are not allowed in an ambient context."),An_overload_signature_cannot_be_declared_as_a_generator:N(1222,1,"An_overload_signature_cannot_be_declared_as_a_generator_1222","An overload signature cannot be declared as a generator."),_0_tag_already_specified:N(1223,1,"_0_tag_already_specified_1223","'{0}' tag already specified."),Signature_0_must_be_a_type_predicate:N(1224,1,"Signature_0_must_be_a_type_predicate_1224","Signature '{0}' must be a type predicate."),Cannot_find_parameter_0:N(1225,1,"Cannot_find_parameter_0_1225","Cannot find parameter '{0}'."),Type_predicate_0_is_not_assignable_to_1:N(1226,1,"Type_predicate_0_is_not_assignable_to_1_1226","Type predicate '{0}' is not assignable to '{1}'."),Parameter_0_is_not_in_the_same_position_as_parameter_1:N(1227,1,"Parameter_0_is_not_in_the_same_position_as_parameter_1_1227","Parameter '{0}' is not in the same position as parameter '{1}'."),A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods:N(1228,1,"A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods_1228","A type predicate is only allowed in return type position for functions and methods."),A_type_predicate_cannot_reference_a_rest_parameter:N(1229,1,"A_type_predicate_cannot_reference_a_rest_parameter_1229","A type predicate cannot reference a rest parameter."),A_type_predicate_cannot_reference_element_0_in_a_binding_pattern:N(1230,1,"A_type_predicate_cannot_reference_element_0_in_a_binding_pattern_1230","A type predicate cannot reference element '{0}' in a binding pattern."),An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration:N(1231,1,"An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration_1231","An export assignment must be at the top level of a file or module declaration."),An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module:N(1232,1,"An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module_1232","An import declaration can only be used at the top level of a namespace or module."),An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module:N(1233,1,"An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module_1233","An export declaration can only be used at the top level of a namespace or module."),An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file:N(1234,1,"An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file_1234","An ambient module declaration is only allowed at the top level in a file."),A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module:N(1235,1,"A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module_1235","A namespace declaration is only allowed at the top level of a namespace or module."),The_return_type_of_a_property_decorator_function_must_be_either_void_or_any:N(1236,1,"The_return_type_of_a_property_decorator_function_must_be_either_void_or_any_1236","The return type of a property decorator function must be either 'void' or 'any'."),The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any:N(1237,1,"The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any_1237","The return type of a parameter decorator function must be either 'void' or 'any'."),Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression:N(1238,1,"Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression_1238","Unable to resolve signature of class decorator when called as an expression."),Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression:N(1239,1,"Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression_1239","Unable to resolve signature of parameter decorator when called as an expression."),Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression:N(1240,1,"Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression_1240","Unable to resolve signature of property decorator when called as an expression."),Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression:N(1241,1,"Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression_1241","Unable to resolve signature of method decorator when called as an expression."),abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration:N(1242,1,"abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration_1242","'abstract' modifier can only appear on a class, method, or property declaration."),_0_modifier_cannot_be_used_with_1_modifier:N(1243,1,"_0_modifier_cannot_be_used_with_1_modifier_1243","'{0}' modifier cannot be used with '{1}' modifier."),Abstract_methods_can_only_appear_within_an_abstract_class:N(1244,1,"Abstract_methods_can_only_appear_within_an_abstract_class_1244","Abstract methods can only appear within an abstract class."),Method_0_cannot_have_an_implementation_because_it_is_marked_abstract:N(1245,1,"Method_0_cannot_have_an_implementation_because_it_is_marked_abstract_1245","Method '{0}' cannot have an implementation because it is marked abstract."),An_interface_property_cannot_have_an_initializer:N(1246,1,"An_interface_property_cannot_have_an_initializer_1246","An interface property cannot have an initializer."),A_type_literal_property_cannot_have_an_initializer:N(1247,1,"A_type_literal_property_cannot_have_an_initializer_1247","A type literal property cannot have an initializer."),A_class_member_cannot_have_the_0_keyword:N(1248,1,"A_class_member_cannot_have_the_0_keyword_1248","A class member cannot have the '{0}' keyword."),A_decorator_can_only_decorate_a_method_implementation_not_an_overload:N(1249,1,"A_decorator_can_only_decorate_a_method_implementation_not_an_overload_1249","A decorator can only decorate a method implementation, not an overload."),Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES5:N(1250,1,"Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES5_1250","Function declarations are not allowed inside blocks in strict mode when targeting 'ES5'."),Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES5_Class_definitions_are_automatically_in_strict_mode:N(1251,1,"Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES5_Class_definiti_1251","Function declarations are not allowed inside blocks in strict mode when targeting 'ES5'. Class definitions are automatically in strict mode."),Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES5_Modules_are_automatically_in_strict_mode:N(1252,1,"Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES5_Modules_are_au_1252","Function declarations are not allowed inside blocks in strict mode when targeting 'ES5'. Modules are automatically in strict mode."),Abstract_properties_can_only_appear_within_an_abstract_class:N(1253,1,"Abstract_properties_can_only_appear_within_an_abstract_class_1253","Abstract properties can only appear within an abstract class."),A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference:N(1254,1,"A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_refere_1254","A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference."),A_definite_assignment_assertion_is_not_permitted_in_this_context:N(1255,1,"A_definite_assignment_assertion_is_not_permitted_in_this_context_1255","A definite assignment assertion '!' is not permitted in this context."),A_required_element_cannot_follow_an_optional_element:N(1257,1,"A_required_element_cannot_follow_an_optional_element_1257","A required element cannot follow an optional element."),A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration:N(1258,1,"A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration_1258","A default export must be at the top level of a file or module declaration."),Module_0_can_only_be_default_imported_using_the_1_flag:N(1259,1,"Module_0_can_only_be_default_imported_using_the_1_flag_1259","Module '{0}' can only be default-imported using the '{1}' flag"),Keywords_cannot_contain_escape_characters:N(1260,1,"Keywords_cannot_contain_escape_characters_1260","Keywords cannot contain escape characters."),Already_included_file_name_0_differs_from_file_name_1_only_in_casing:N(1261,1,"Already_included_file_name_0_differs_from_file_name_1_only_in_casing_1261","Already included file name '{0}' differs from file name '{1}' only in casing."),Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module:N(1262,1,"Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module_1262","Identifier expected. '{0}' is a reserved word at the top-level of a module."),Declarations_with_initializers_cannot_also_have_definite_assignment_assertions:N(1263,1,"Declarations_with_initializers_cannot_also_have_definite_assignment_assertions_1263","Declarations with initializers cannot also have definite assignment assertions."),Declarations_with_definite_assignment_assertions_must_also_have_type_annotations:N(1264,1,"Declarations_with_definite_assignment_assertions_must_also_have_type_annotations_1264","Declarations with definite assignment assertions must also have type annotations."),A_rest_element_cannot_follow_another_rest_element:N(1265,1,"A_rest_element_cannot_follow_another_rest_element_1265","A rest element cannot follow another rest element."),An_optional_element_cannot_follow_a_rest_element:N(1266,1,"An_optional_element_cannot_follow_a_rest_element_1266","An optional element cannot follow a rest element."),Property_0_cannot_have_an_initializer_because_it_is_marked_abstract:N(1267,1,"Property_0_cannot_have_an_initializer_because_it_is_marked_abstract_1267","Property '{0}' cannot have an initializer because it is marked abstract."),An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type:N(1268,1,"An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type_1268","An index signature parameter type must be 'string', 'number', 'symbol', or a template literal type."),Cannot_use_export_import_on_a_type_or_type_only_namespace_when_0_is_enabled:N(1269,1,"Cannot_use_export_import_on_a_type_or_type_only_namespace_when_0_is_enabled_1269","Cannot use 'export import' on a type or type-only namespace when '{0}' is enabled."),Decorator_function_return_type_0_is_not_assignable_to_type_1:N(1270,1,"Decorator_function_return_type_0_is_not_assignable_to_type_1_1270","Decorator function return type '{0}' is not assignable to type '{1}'."),Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any:N(1271,1,"Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any_1271","Decorator function return type is '{0}' but is expected to be 'void' or 'any'."),A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled:N(1272,1,"A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_w_1272","A type referenced in a decorated signature must be imported with 'import type' or a namespace import when 'isolatedModules' and 'emitDecoratorMetadata' are enabled."),_0_modifier_cannot_appear_on_a_type_parameter:N(1273,1,"_0_modifier_cannot_appear_on_a_type_parameter_1273","'{0}' modifier cannot appear on a type parameter"),_0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias:N(1274,1,"_0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias_1274","'{0}' modifier can only appear on a type parameter of a class, interface or type alias"),accessor_modifier_can_only_appear_on_a_property_declaration:N(1275,1,"accessor_modifier_can_only_appear_on_a_property_declaration_1275","'accessor' modifier can only appear on a property declaration."),An_accessor_property_cannot_be_declared_optional:N(1276,1,"An_accessor_property_cannot_be_declared_optional_1276","An 'accessor' property cannot be declared optional."),_0_modifier_can_only_appear_on_a_type_parameter_of_a_function_method_or_class:N(1277,1,"_0_modifier_can_only_appear_on_a_type_parameter_of_a_function_method_or_class_1277","'{0}' modifier can only appear on a type parameter of a function, method or class"),The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_0:N(1278,1,"The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_0_1278","The runtime will invoke the decorator with {1} arguments, but the decorator expects {0}."),The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_at_least_0:N(1279,1,"The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_at_least_0_1279","The runtime will invoke the decorator with {1} arguments, but the decorator expects at least {0}."),Namespaces_are_not_allowed_in_global_script_files_when_0_is_enabled_If_this_file_is_not_intended_to_be_a_global_script_set_moduleDetection_to_force_or_add_an_empty_export_statement:N(1280,1,"Namespaces_are_not_allowed_in_global_script_files_when_0_is_enabled_If_this_file_is_not_intended_to__1280","Namespaces are not allowed in global script files when '{0}' is enabled. If this file is not intended to be a global script, set 'moduleDetection' to 'force' or add an empty 'export {}' statement."),Cannot_access_0_from_another_file_without_qualification_when_1_is_enabled_Use_2_instead:N(1281,1,"Cannot_access_0_from_another_file_without_qualification_when_1_is_enabled_Use_2_instead_1281","Cannot access '{0}' from another file without qualification when '{1}' is enabled. Use '{2}' instead."),An_export_declaration_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers_to_a_type:N(1282,1,"An_export_declaration_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers__1282","An 'export =' declaration must reference a value when 'verbatimModuleSyntax' is enabled, but '{0}' only refers to a type."),An_export_declaration_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolves_to_a_type_only_declaration:N(1283,1,"An_export_declaration_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolve_1283","An 'export =' declaration must reference a real value when 'verbatimModuleSyntax' is enabled, but '{0}' resolves to a type-only declaration."),An_export_default_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers_to_a_type:N(1284,1,"An_export_default_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers_to_a_1284","An 'export default' must reference a value when 'verbatimModuleSyntax' is enabled, but '{0}' only refers to a type."),An_export_default_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolves_to_a_type_only_declaration:N(1285,1,"An_export_default_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolves_to_1285","An 'export default' must reference a real value when 'verbatimModuleSyntax' is enabled, but '{0}' resolves to a type-only declaration."),ESM_syntax_is_not_allowed_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled:N(1286,1,"ESM_syntax_is_not_allowed_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled_1286","ESM syntax is not allowed in a CommonJS module when 'verbatimModuleSyntax' is enabled."),A_top_level_export_modifier_cannot_be_used_on_value_declarations_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled:N(1287,1,"A_top_level_export_modifier_cannot_be_used_on_value_declarations_in_a_CommonJS_module_when_verbatimM_1287","A top-level 'export' modifier cannot be used on value declarations in a CommonJS module when 'verbatimModuleSyntax' is enabled."),An_import_alias_cannot_resolve_to_a_type_or_type_only_declaration_when_verbatimModuleSyntax_is_enabled:N(1288,1,"An_import_alias_cannot_resolve_to_a_type_or_type_only_declaration_when_verbatimModuleSyntax_is_enabl_1288","An import alias cannot resolve to a type or type-only declaration when 'verbatimModuleSyntax' is enabled."),_0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_import_type_where_0_is_imported:N(1289,1,"_0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_1289","'{0}' resolves to a type-only declaration and must be marked type-only in this file before re-exporting when '{1}' is enabled. Consider using 'import type' where '{0}' is imported."),_0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_export_type_0_as_default:N(1290,1,"_0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_1290","'{0}' resolves to a type-only declaration and must be marked type-only in this file before re-exporting when '{1}' is enabled. Consider using 'export type { {0} as default }'."),_0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_import_type_where_0_is_imported:N(1291,1,"_0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enable_1291","'{0}' resolves to a type and must be marked type-only in this file before re-exporting when '{1}' is enabled. Consider using 'import type' where '{0}' is imported."),_0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_export_type_0_as_default:N(1292,1,"_0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enable_1292","'{0}' resolves to a type and must be marked type-only in this file before re-exporting when '{1}' is enabled. Consider using 'export type { {0} as default }'."),with_statements_are_not_allowed_in_an_async_function_block:N(1300,1,"with_statements_are_not_allowed_in_an_async_function_block_1300","'with' statements are not allowed in an async function block."),await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules:N(1308,1,"await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_1308","'await' expressions are only allowed within async functions and at the top levels of modules."),The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level:N(1309,1,"The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level_1309","The current file is a CommonJS module and cannot use 'await' at the top level."),Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern:N(1312,1,"Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_1312","Did you mean to use a ':'? An '=' can only follow a property name when the containing object literal is part of a destructuring pattern."),The_body_of_an_if_statement_cannot_be_the_empty_statement:N(1313,1,"The_body_of_an_if_statement_cannot_be_the_empty_statement_1313","The body of an 'if' statement cannot be the empty statement."),Global_module_exports_may_only_appear_in_module_files:N(1314,1,"Global_module_exports_may_only_appear_in_module_files_1314","Global module exports may only appear in module files."),Global_module_exports_may_only_appear_in_declaration_files:N(1315,1,"Global_module_exports_may_only_appear_in_declaration_files_1315","Global module exports may only appear in declaration files."),Global_module_exports_may_only_appear_at_top_level:N(1316,1,"Global_module_exports_may_only_appear_at_top_level_1316","Global module exports may only appear at top level."),A_parameter_property_cannot_be_declared_using_a_rest_parameter:N(1317,1,"A_parameter_property_cannot_be_declared_using_a_rest_parameter_1317","A parameter property cannot be declared using a rest parameter."),An_abstract_accessor_cannot_have_an_implementation:N(1318,1,"An_abstract_accessor_cannot_have_an_implementation_1318","An abstract accessor cannot have an implementation."),A_default_export_can_only_be_used_in_an_ECMAScript_style_module:N(1319,1,"A_default_export_can_only_be_used_in_an_ECMAScript_style_module_1319","A default export can only be used in an ECMAScript-style module."),Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:N(1320,1,"Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member_1320","Type of 'await' operand must either be a valid promise or must not contain a callable 'then' member."),Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:N(1321,1,"Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_cal_1321","Type of 'yield' operand in an async generator must either be a valid promise or must not contain a callable 'then' member."),Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:N(1322,1,"Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_con_1322","Type of iterated elements of a 'yield*' operand must either be a valid promise or must not contain a callable 'then' member."),Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd_system_umd_node16_or_nodenext:N(1323,1,"Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd__1323","Dynamic imports are only supported when the '--module' flag is set to 'es2020', 'es2022', 'esnext', 'commonjs', 'amd', 'system', 'umd', 'node16', or 'nodenext'."),Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nodenext:N(1324,1,"Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nod_1324","Dynamic imports only support a second argument when the '--module' option is set to 'esnext', 'node16', or 'nodenext'."),Argument_of_dynamic_import_cannot_be_spread_element:N(1325,1,"Argument_of_dynamic_import_cannot_be_spread_element_1325","Argument of dynamic import cannot be spread element."),This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments:N(1326,1,"This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot__1326","This use of 'import' is invalid. 'import()' calls can be written, but they must have parentheses and cannot have type arguments."),String_literal_with_double_quotes_expected:N(1327,1,"String_literal_with_double_quotes_expected_1327","String literal with double quotes expected."),Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal:N(1328,1,"Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_li_1328","Property value can only be string literal, numeric literal, 'true', 'false', 'null', object literal or array literal."),_0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0:N(1329,1,"_0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write__1329","'{0}' accepts too few arguments to be used as a decorator here. Did you mean to call it first and write '@{0}()'?"),A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly:N(1330,1,"A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly_1330","A property of an interface or type literal whose type is a 'unique symbol' type must be 'readonly'."),A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly:N(1331,1,"A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly_1331","A property of a class whose type is a 'unique symbol' type must be both 'static' and 'readonly'."),A_variable_whose_type_is_a_unique_symbol_type_must_be_const:N(1332,1,"A_variable_whose_type_is_a_unique_symbol_type_must_be_const_1332","A variable whose type is a 'unique symbol' type must be 'const'."),unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name:N(1333,1,"unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name_1333","'unique symbol' types may not be used on a variable declaration with a binding name."),unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement:N(1334,1,"unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement_1334","'unique symbol' types are only allowed on variables in a variable statement."),unique_symbol_types_are_not_allowed_here:N(1335,1,"unique_symbol_types_are_not_allowed_here_1335","'unique symbol' types are not allowed here."),An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead:N(1337,1,"An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_o_1337","An index signature parameter type cannot be a literal type or generic type. Consider using a mapped object type instead."),infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type:N(1338,1,"infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type_1338","'infer' declarations are only permitted in the 'extends' clause of a conditional type."),Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here:N(1339,1,"Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here_1339","Module '{0}' does not refer to a value, but is used as a value here."),Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0:N(1340,1,"Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0_1340","Module '{0}' does not refer to a type, but is used as a type here. Did you mean 'typeof import('{0}')'?"),Class_constructor_may_not_be_an_accessor:N(1341,1,"Class_constructor_may_not_be_an_accessor_1341","Class constructor may not be an accessor."),The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system_node16_or_nodenext:N(1343,1,"The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system__1343","The 'import.meta' meta-property is only allowed when the '--module' option is 'es2020', 'es2022', 'esnext', 'system', 'node16', or 'nodenext'."),A_label_is_not_allowed_here:N(1344,1,"A_label_is_not_allowed_here_1344","'A label is not allowed here."),An_expression_of_type_void_cannot_be_tested_for_truthiness:N(1345,1,"An_expression_of_type_void_cannot_be_tested_for_truthiness_1345","An expression of type 'void' cannot be tested for truthiness."),This_parameter_is_not_allowed_with_use_strict_directive:N(1346,1,"This_parameter_is_not_allowed_with_use_strict_directive_1346","This parameter is not allowed with 'use strict' directive."),use_strict_directive_cannot_be_used_with_non_simple_parameter_list:N(1347,1,"use_strict_directive_cannot_be_used_with_non_simple_parameter_list_1347","'use strict' directive cannot be used with non-simple parameter list."),Non_simple_parameter_declared_here:N(1348,1,"Non_simple_parameter_declared_here_1348","Non-simple parameter declared here."),use_strict_directive_used_here:N(1349,1,"use_strict_directive_used_here_1349","'use strict' directive used here."),Print_the_final_configuration_instead_of_building:N(1350,3,"Print_the_final_configuration_instead_of_building_1350","Print the final configuration instead of building."),An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal:N(1351,1,"An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal_1351","An identifier or keyword cannot immediately follow a numeric literal."),A_bigint_literal_cannot_use_exponential_notation:N(1352,1,"A_bigint_literal_cannot_use_exponential_notation_1352","A bigint literal cannot use exponential notation."),A_bigint_literal_must_be_an_integer:N(1353,1,"A_bigint_literal_must_be_an_integer_1353","A bigint literal must be an integer."),readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types:N(1354,1,"readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types_1354","'readonly' type modifier is only permitted on array and tuple literal types."),A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals:N(1355,1,"A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array__1355","A 'const' assertions can only be applied to references to enum members, or string, number, boolean, array, or object literals."),Did_you_mean_to_mark_this_function_as_async:N(1356,1,"Did_you_mean_to_mark_this_function_as_async_1356","Did you mean to mark this function as 'async'?"),An_enum_member_name_must_be_followed_by_a_or:N(1357,1,"An_enum_member_name_must_be_followed_by_a_or_1357","An enum member name must be followed by a ',', '=', or '}'."),Tagged_template_expressions_are_not_permitted_in_an_optional_chain:N(1358,1,"Tagged_template_expressions_are_not_permitted_in_an_optional_chain_1358","Tagged template expressions are not permitted in an optional chain."),Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here:N(1359,1,"Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here_1359","Identifier expected. '{0}' is a reserved word that cannot be used here."),Type_0_does_not_satisfy_the_expected_type_1:N(1360,1,"Type_0_does_not_satisfy_the_expected_type_1_1360","Type '{0}' does not satisfy the expected type '{1}'."),_0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type:N(1361,1,"_0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type_1361","'{0}' cannot be used as a value because it was imported using 'import type'."),_0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type:N(1362,1,"_0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type_1362","'{0}' cannot be used as a value because it was exported using 'export type'."),A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both:N(1363,1,"A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both_1363","A type-only import can specify a default import or named bindings, but not both."),Convert_to_type_only_export:N(1364,3,"Convert_to_type_only_export_1364","Convert to type-only export"),Convert_all_re_exported_types_to_type_only_exports:N(1365,3,"Convert_all_re_exported_types_to_type_only_exports_1365","Convert all re-exported types to type-only exports"),Split_into_two_separate_import_declarations:N(1366,3,"Split_into_two_separate_import_declarations_1366","Split into two separate import declarations"),Split_all_invalid_type_only_imports:N(1367,3,"Split_all_invalid_type_only_imports_1367","Split all invalid type-only imports"),Class_constructor_may_not_be_a_generator:N(1368,1,"Class_constructor_may_not_be_a_generator_1368","Class constructor may not be a generator."),Did_you_mean_0:N(1369,3,"Did_you_mean_0_1369","Did you mean '{0}'?"),await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module:N(1375,1,"await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_fi_1375","'await' expressions are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."),_0_was_imported_here:N(1376,3,"_0_was_imported_here_1376","'{0}' was imported here."),_0_was_exported_here:N(1377,3,"_0_was_exported_here_1377","'{0}' was exported here."),Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher:N(1378,1,"Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_n_1378","Top-level 'await' expressions are only allowed when the 'module' option is set to 'es2022', 'esnext', 'system', 'node16', 'nodenext', or 'preserve', and the 'target' option is set to 'es2017' or higher."),An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type:N(1379,1,"An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type_1379","An import alias cannot reference a declaration that was exported using 'export type'."),An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type:N(1380,1,"An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type_1380","An import alias cannot reference a declaration that was imported using 'import type'."),Unexpected_token_Did_you_mean_or_rbrace:N(1381,1,"Unexpected_token_Did_you_mean_or_rbrace_1381","Unexpected token. Did you mean `{'}'}` or `&rbrace;`?"),Unexpected_token_Did_you_mean_or_gt:N(1382,1,"Unexpected_token_Did_you_mean_or_gt_1382","Unexpected token. Did you mean `{'>'}` or `&gt;`?"),Function_type_notation_must_be_parenthesized_when_used_in_a_union_type:N(1385,1,"Function_type_notation_must_be_parenthesized_when_used_in_a_union_type_1385","Function type notation must be parenthesized when used in a union type."),Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type:N(1386,1,"Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type_1386","Constructor type notation must be parenthesized when used in a union type."),Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type:N(1387,1,"Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type_1387","Function type notation must be parenthesized when used in an intersection type."),Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type:N(1388,1,"Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type_1388","Constructor type notation must be parenthesized when used in an intersection type."),_0_is_not_allowed_as_a_variable_declaration_name:N(1389,1,"_0_is_not_allowed_as_a_variable_declaration_name_1389","'{0}' is not allowed as a variable declaration name."),_0_is_not_allowed_as_a_parameter_name:N(1390,1,"_0_is_not_allowed_as_a_parameter_name_1390","'{0}' is not allowed as a parameter name."),An_import_alias_cannot_use_import_type:N(1392,1,"An_import_alias_cannot_use_import_type_1392","An import alias cannot use 'import type'"),Imported_via_0_from_file_1:N(1393,3,"Imported_via_0_from_file_1_1393","Imported via {0} from file '{1}'"),Imported_via_0_from_file_1_with_packageId_2:N(1394,3,"Imported_via_0_from_file_1_with_packageId_2_1394","Imported via {0} from file '{1}' with packageId '{2}'"),Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions:N(1395,3,"Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions_1395","Imported via {0} from file '{1}' to import 'importHelpers' as specified in compilerOptions"),Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions:N(1396,3,"Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions_1396","Imported via {0} from file '{1}' with packageId '{2}' to import 'importHelpers' as specified in compilerOptions"),Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions:N(1397,3,"Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions_1397","Imported via {0} from file '{1}' to import 'jsx' and 'jsxs' factory functions"),Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions:N(1398,3,"Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions_1398","Imported via {0} from file '{1}' with packageId '{2}' to import 'jsx' and 'jsxs' factory functions"),File_is_included_via_import_here:N(1399,3,"File_is_included_via_import_here_1399","File is included via import here."),Referenced_via_0_from_file_1:N(1400,3,"Referenced_via_0_from_file_1_1400","Referenced via '{0}' from file '{1}'"),File_is_included_via_reference_here:N(1401,3,"File_is_included_via_reference_here_1401","File is included via reference here."),Type_library_referenced_via_0_from_file_1:N(1402,3,"Type_library_referenced_via_0_from_file_1_1402","Type library referenced via '{0}' from file '{1}'"),Type_library_referenced_via_0_from_file_1_with_packageId_2:N(1403,3,"Type_library_referenced_via_0_from_file_1_with_packageId_2_1403","Type library referenced via '{0}' from file '{1}' with packageId '{2}'"),File_is_included_via_type_library_reference_here:N(1404,3,"File_is_included_via_type_library_reference_here_1404","File is included via type library reference here."),Library_referenced_via_0_from_file_1:N(1405,3,"Library_referenced_via_0_from_file_1_1405","Library referenced via '{0}' from file '{1}'"),File_is_included_via_library_reference_here:N(1406,3,"File_is_included_via_library_reference_here_1406","File is included via library reference here."),Matched_by_include_pattern_0_in_1:N(1407,3,"Matched_by_include_pattern_0_in_1_1407","Matched by include pattern '{0}' in '{1}'"),File_is_matched_by_include_pattern_specified_here:N(1408,3,"File_is_matched_by_include_pattern_specified_here_1408","File is matched by include pattern specified here."),Part_of_files_list_in_tsconfig_json:N(1409,3,"Part_of_files_list_in_tsconfig_json_1409","Part of 'files' list in tsconfig.json"),File_is_matched_by_files_list_specified_here:N(1410,3,"File_is_matched_by_files_list_specified_here_1410","File is matched by 'files' list specified here."),Output_from_referenced_project_0_included_because_1_specified:N(1411,3,"Output_from_referenced_project_0_included_because_1_specified_1411","Output from referenced project '{0}' included because '{1}' specified"),Output_from_referenced_project_0_included_because_module_is_specified_as_none:N(1412,3,"Output_from_referenced_project_0_included_because_module_is_specified_as_none_1412","Output from referenced project '{0}' included because '--module' is specified as 'none'"),File_is_output_from_referenced_project_specified_here:N(1413,3,"File_is_output_from_referenced_project_specified_here_1413","File is output from referenced project specified here."),Source_from_referenced_project_0_included_because_1_specified:N(1414,3,"Source_from_referenced_project_0_included_because_1_specified_1414","Source from referenced project '{0}' included because '{1}' specified"),Source_from_referenced_project_0_included_because_module_is_specified_as_none:N(1415,3,"Source_from_referenced_project_0_included_because_module_is_specified_as_none_1415","Source from referenced project '{0}' included because '--module' is specified as 'none'"),File_is_source_from_referenced_project_specified_here:N(1416,3,"File_is_source_from_referenced_project_specified_here_1416","File is source from referenced project specified here."),Entry_point_of_type_library_0_specified_in_compilerOptions:N(1417,3,"Entry_point_of_type_library_0_specified_in_compilerOptions_1417","Entry point of type library '{0}' specified in compilerOptions"),Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1:N(1418,3,"Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1_1418","Entry point of type library '{0}' specified in compilerOptions with packageId '{1}'"),File_is_entry_point_of_type_library_specified_here:N(1419,3,"File_is_entry_point_of_type_library_specified_here_1419","File is entry point of type library specified here."),Entry_point_for_implicit_type_library_0:N(1420,3,"Entry_point_for_implicit_type_library_0_1420","Entry point for implicit type library '{0}'"),Entry_point_for_implicit_type_library_0_with_packageId_1:N(1421,3,"Entry_point_for_implicit_type_library_0_with_packageId_1_1421","Entry point for implicit type library '{0}' with packageId '{1}'"),Library_0_specified_in_compilerOptions:N(1422,3,"Library_0_specified_in_compilerOptions_1422","Library '{0}' specified in compilerOptions"),File_is_library_specified_here:N(1423,3,"File_is_library_specified_here_1423","File is library specified here."),Default_library:N(1424,3,"Default_library_1424","Default library"),Default_library_for_target_0:N(1425,3,"Default_library_for_target_0_1425","Default library for target '{0}'"),File_is_default_library_for_target_specified_here:N(1426,3,"File_is_default_library_for_target_specified_here_1426","File is default library for target specified here."),Root_file_specified_for_compilation:N(1427,3,"Root_file_specified_for_compilation_1427","Root file specified for compilation"),File_is_output_of_project_reference_source_0:N(1428,3,"File_is_output_of_project_reference_source_0_1428","File is output of project reference source '{0}'"),File_redirects_to_file_0:N(1429,3,"File_redirects_to_file_0_1429","File redirects to file '{0}'"),The_file_is_in_the_program_because_Colon:N(1430,3,"The_file_is_in_the_program_because_Colon_1430","The file is in the program because:"),for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module:N(1431,1,"for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_1431","'for await' loops are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."),Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher:N(1432,1,"Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_nod_1432","Top-level 'for await' loops are only allowed when the 'module' option is set to 'es2022', 'esnext', 'system', 'node16', 'nodenext', or 'preserve', and the 'target' option is set to 'es2017' or higher."),Neither_decorators_nor_modifiers_may_be_applied_to_this_parameters:N(1433,1,"Neither_decorators_nor_modifiers_may_be_applied_to_this_parameters_1433","Neither decorators nor modifiers may be applied to 'this' parameters."),Unexpected_keyword_or_identifier:N(1434,1,"Unexpected_keyword_or_identifier_1434","Unexpected keyword or identifier."),Unknown_keyword_or_identifier_Did_you_mean_0:N(1435,1,"Unknown_keyword_or_identifier_Did_you_mean_0_1435","Unknown keyword or identifier. Did you mean '{0}'?"),Decorators_must_precede_the_name_and_all_keywords_of_property_declarations:N(1436,1,"Decorators_must_precede_the_name_and_all_keywords_of_property_declarations_1436","Decorators must precede the name and all keywords of property declarations."),Namespace_must_be_given_a_name:N(1437,1,"Namespace_must_be_given_a_name_1437","Namespace must be given a name."),Interface_must_be_given_a_name:N(1438,1,"Interface_must_be_given_a_name_1438","Interface must be given a name."),Type_alias_must_be_given_a_name:N(1439,1,"Type_alias_must_be_given_a_name_1439","Type alias must be given a name."),Variable_declaration_not_allowed_at_this_location:N(1440,1,"Variable_declaration_not_allowed_at_this_location_1440","Variable declaration not allowed at this location."),Cannot_start_a_function_call_in_a_type_annotation:N(1441,1,"Cannot_start_a_function_call_in_a_type_annotation_1441","Cannot start a function call in a type annotation."),Expected_for_property_initializer:N(1442,1,"Expected_for_property_initializer_1442","Expected '=' for property initializer."),Module_declaration_names_may_only_use_or_quoted_strings:N(1443,1,"Module_declaration_names_may_only_use_or_quoted_strings_1443",`Module declaration names may only use ' or " quoted strings.`),_0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_1_is_enabled:N(1448,1,"_0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_1_is_1448","'{0}' resolves to a type-only declaration and must be re-exported using a type-only re-export when '{1}' is enabled."),Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed:N(1449,3,"Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed_1449","Preserve unused imported values in the JavaScript output that would otherwise be removed."),Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_set_of_attributes_as_arguments:N(1450,3,"Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_set_of_attributes_as_arguments_1450","Dynamic imports can only accept a module specifier and an optional set of attributes as arguments"),Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression:N(1451,1,"Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member__1451","Private identifiers are only allowed in class bodies and may only be used as part of a class member declaration, property access, or on the left-hand-side of an 'in' expression"),resolution_mode_should_be_either_require_or_import:N(1453,1,"resolution_mode_should_be_either_require_or_import_1453","`resolution-mode` should be either `require` or `import`."),resolution_mode_can_only_be_set_for_type_only_imports:N(1454,1,"resolution_mode_can_only_be_set_for_type_only_imports_1454","`resolution-mode` can only be set for type-only imports."),resolution_mode_is_the_only_valid_key_for_type_import_assertions:N(1455,1,"resolution_mode_is_the_only_valid_key_for_type_import_assertions_1455","`resolution-mode` is the only valid key for type import assertions."),Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require:N(1456,1,"Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require_1456","Type import assertions should have exactly one key - `resolution-mode` - with value `import` or `require`."),Matched_by_default_include_pattern_Asterisk_Asterisk_Slash_Asterisk:N(1457,3,"Matched_by_default_include_pattern_Asterisk_Asterisk_Slash_Asterisk_1457","Matched by default include pattern '**/*'"),File_is_ECMAScript_module_because_0_has_field_type_with_value_module:N(1458,3,"File_is_ECMAScript_module_because_0_has_field_type_with_value_module_1458",`File is ECMAScript module because '{0}' has field "type" with value "module"`),File_is_CommonJS_module_because_0_has_field_type_whose_value_is_not_module:N(1459,3,"File_is_CommonJS_module_because_0_has_field_type_whose_value_is_not_module_1459",`File is CommonJS module because '{0}' has field "type" whose value is not "module"`),File_is_CommonJS_module_because_0_does_not_have_field_type:N(1460,3,"File_is_CommonJS_module_because_0_does_not_have_field_type_1460",`File is CommonJS module because '{0}' does not have field "type"`),File_is_CommonJS_module_because_package_json_was_not_found:N(1461,3,"File_is_CommonJS_module_because_package_json_was_not_found_1461","File is CommonJS module because 'package.json' was not found"),resolution_mode_is_the_only_valid_key_for_type_import_attributes:N(1463,1,"resolution_mode_is_the_only_valid_key_for_type_import_attributes_1463","'resolution-mode' is the only valid key for type import attributes."),Type_import_attributes_should_have_exactly_one_key_resolution_mode_with_value_import_or_require:N(1464,1,"Type_import_attributes_should_have_exactly_one_key_resolution_mode_with_value_import_or_require_1464","Type import attributes should have exactly one key - 'resolution-mode' - with value 'import' or 'require'."),The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output:N(1470,1,"The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output_1470","The 'import.meta' meta-property is not allowed in files which will build into CommonJS output."),Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_cannot_be_imported_with_require_Use_an_ECMAScript_import_instead:N(1471,1,"Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_c_1471","Module '{0}' cannot be imported using this construct. The specifier only resolves to an ES module, which cannot be imported with 'require'. Use an ECMAScript import instead."),catch_or_finally_expected:N(1472,1,"catch_or_finally_expected_1472","'catch' or 'finally' expected."),An_import_declaration_can_only_be_used_at_the_top_level_of_a_module:N(1473,1,"An_import_declaration_can_only_be_used_at_the_top_level_of_a_module_1473","An import declaration can only be used at the top level of a module."),An_export_declaration_can_only_be_used_at_the_top_level_of_a_module:N(1474,1,"An_export_declaration_can_only_be_used_at_the_top_level_of_a_module_1474","An export declaration can only be used at the top level of a module."),Control_what_method_is_used_to_detect_module_format_JS_files:N(1475,3,"Control_what_method_is_used_to_detect_module_format_JS_files_1475","Control what method is used to detect module-format JS files."),auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_with_module_Colon_node16_as_modules:N(1476,3,"auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_w_1476",'"auto": Treat files with imports, exports, import.meta, jsx (with jsx: react-jsx), or esm format (with module: node16+) as modules.'),An_instantiation_expression_cannot_be_followed_by_a_property_access:N(1477,1,"An_instantiation_expression_cannot_be_followed_by_a_property_access_1477","An instantiation expression cannot be followed by a property access."),Identifier_or_string_literal_expected:N(1478,1,"Identifier_or_string_literal_expected_1478","Identifier or string literal expected."),The_current_file_is_a_CommonJS_module_whose_imports_will_produce_require_calls_however_the_referenced_file_is_an_ECMAScript_module_and_cannot_be_imported_with_require_Consider_writing_a_dynamic_import_0_call_instead:N(1479,1,"The_current_file_is_a_CommonJS_module_whose_imports_will_produce_require_calls_however_the_reference_1479",`The current file is a CommonJS module whose imports will produce 'require' calls; however, the referenced file is an ECMAScript module and cannot be imported with 'require'. Consider writing a dynamic 'import("{0}")' call instead.`),To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_create_a_local_package_json_file_with_type_Colon_module:N(1480,3,"To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_create_a_local_packag_1480",'To convert this file to an ECMAScript module, change its file extension to \'{0}\' or create a local package.json file with `{ "type": "module" }`.'),To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_add_the_field_type_Colon_module_to_1:N(1481,3,"To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_add_the_field_type_Co_1481",`To convert this file to an ECMAScript module, change its file extension to '{0}', or add the field \`"type": "module"\` to '{1}'.`),To_convert_this_file_to_an_ECMAScript_module_add_the_field_type_Colon_module_to_0:N(1482,3,"To_convert_this_file_to_an_ECMAScript_module_add_the_field_type_Colon_module_to_0_1482",'To convert this file to an ECMAScript module, add the field `"type": "module"` to \'{0}\'.'),To_convert_this_file_to_an_ECMAScript_module_create_a_local_package_json_file_with_type_Colon_module:N(1483,3,"To_convert_this_file_to_an_ECMAScript_module_create_a_local_package_json_file_with_type_Colon_module_1483",'To convert this file to an ECMAScript module, create a local package.json file with `{ "type": "module" }`.'),_0_is_a_type_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled:N(1484,1,"_0_is_a_type_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled_1484","'{0}' is a type and must be imported using a type-only import when 'verbatimModuleSyntax' is enabled."),_0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled:N(1485,1,"_0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_verbatimMo_1485","'{0}' resolves to a type-only declaration and must be imported using a type-only import when 'verbatimModuleSyntax' is enabled."),Decorator_used_before_export_here:N(1486,1,"Decorator_used_before_export_here_1486","Decorator used before 'export' here."),Octal_escape_sequences_are_not_allowed_Use_the_syntax_0:N(1487,1,"Octal_escape_sequences_are_not_allowed_Use_the_syntax_0_1487","Octal escape sequences are not allowed. Use the syntax '{0}'."),Escape_sequence_0_is_not_allowed:N(1488,1,"Escape_sequence_0_is_not_allowed_1488","Escape sequence '{0}' is not allowed."),Decimals_with_leading_zeros_are_not_allowed:N(1489,1,"Decimals_with_leading_zeros_are_not_allowed_1489","Decimals with leading zeros are not allowed."),File_appears_to_be_binary:N(1490,1,"File_appears_to_be_binary_1490","File appears to be binary."),_0_modifier_cannot_appear_on_a_using_declaration:N(1491,1,"_0_modifier_cannot_appear_on_a_using_declaration_1491","'{0}' modifier cannot appear on a 'using' declaration."),_0_declarations_may_not_have_binding_patterns:N(1492,1,"_0_declarations_may_not_have_binding_patterns_1492","'{0}' declarations may not have binding patterns."),The_left_hand_side_of_a_for_in_statement_cannot_be_a_using_declaration:N(1493,1,"The_left_hand_side_of_a_for_in_statement_cannot_be_a_using_declaration_1493","The left-hand side of a 'for...in' statement cannot be a 'using' declaration."),The_left_hand_side_of_a_for_in_statement_cannot_be_an_await_using_declaration:N(1494,1,"The_left_hand_side_of_a_for_in_statement_cannot_be_an_await_using_declaration_1494","The left-hand side of a 'for...in' statement cannot be an 'await using' declaration."),_0_modifier_cannot_appear_on_an_await_using_declaration:N(1495,1,"_0_modifier_cannot_appear_on_an_await_using_declaration_1495","'{0}' modifier cannot appear on an 'await using' declaration."),Identifier_string_literal_or_number_literal_expected:N(1496,1,"Identifier_string_literal_or_number_literal_expected_1496","Identifier, string literal, or number literal expected."),Expression_must_be_enclosed_in_parentheses_to_be_used_as_a_decorator:N(1497,1,"Expression_must_be_enclosed_in_parentheses_to_be_used_as_a_decorator_1497","Expression must be enclosed in parentheses to be used as a decorator."),Invalid_syntax_in_decorator:N(1498,1,"Invalid_syntax_in_decorator_1498","Invalid syntax in decorator."),Unknown_regular_expression_flag:N(1499,1,"Unknown_regular_expression_flag_1499","Unknown regular expression flag."),Duplicate_regular_expression_flag:N(1500,1,"Duplicate_regular_expression_flag_1500","Duplicate regular expression flag."),This_regular_expression_flag_is_only_available_when_targeting_0_or_later:N(1501,1,"This_regular_expression_flag_is_only_available_when_targeting_0_or_later_1501","This regular expression flag is only available when targeting '{0}' or later."),The_Unicode_u_flag_and_the_Unicode_Sets_v_flag_cannot_be_set_simultaneously:N(1502,1,"The_Unicode_u_flag_and_the_Unicode_Sets_v_flag_cannot_be_set_simultaneously_1502","The Unicode (u) flag and the Unicode Sets (v) flag cannot be set simultaneously."),Named_capturing_groups_are_only_available_when_targeting_ES2018_or_later:N(1503,1,"Named_capturing_groups_are_only_available_when_targeting_ES2018_or_later_1503","Named capturing groups are only available when targeting 'ES2018' or later."),Subpattern_flags_must_be_present_when_there_is_a_minus_sign:N(1504,1,"Subpattern_flags_must_be_present_when_there_is_a_minus_sign_1504","Subpattern flags must be present when there is a minus sign."),Incomplete_quantifier_Digit_expected:N(1505,1,"Incomplete_quantifier_Digit_expected_1505","Incomplete quantifier. Digit expected."),Numbers_out_of_order_in_quantifier:N(1506,1,"Numbers_out_of_order_in_quantifier_1506","Numbers out of order in quantifier."),There_is_nothing_available_for_repetition:N(1507,1,"There_is_nothing_available_for_repetition_1507","There is nothing available for repetition."),Unexpected_0_Did_you_mean_to_escape_it_with_backslash:N(1508,1,"Unexpected_0_Did_you_mean_to_escape_it_with_backslash_1508","Unexpected '{0}'. Did you mean to escape it with backslash?"),This_regular_expression_flag_cannot_be_toggled_within_a_subpattern:N(1509,1,"This_regular_expression_flag_cannot_be_toggled_within_a_subpattern_1509","This regular expression flag cannot be toggled within a subpattern."),k_must_be_followed_by_a_capturing_group_name_enclosed_in_angle_brackets:N(1510,1,"k_must_be_followed_by_a_capturing_group_name_enclosed_in_angle_brackets_1510","'\\k' must be followed by a capturing group name enclosed in angle brackets."),q_is_only_available_inside_character_class:N(1511,1,"q_is_only_available_inside_character_class_1511","'\\q' is only available inside character class."),c_must_be_followed_by_an_ASCII_letter:N(1512,1,"c_must_be_followed_by_an_ASCII_letter_1512","'\\c' must be followed by an ASCII letter."),Undetermined_character_escape:N(1513,1,"Undetermined_character_escape_1513","Undetermined character escape."),Expected_a_capturing_group_name:N(1514,1,"Expected_a_capturing_group_name_1514","Expected a capturing group name."),Named_capturing_groups_with_the_same_name_must_be_mutually_exclusive_to_each_other:N(1515,1,"Named_capturing_groups_with_the_same_name_must_be_mutually_exclusive_to_each_other_1515","Named capturing groups with the same name must be mutually exclusive to each other."),A_character_class_range_must_not_be_bounded_by_another_character_class:N(1516,1,"A_character_class_range_must_not_be_bounded_by_another_character_class_1516","A character class range must not be bounded by another character class."),Range_out_of_order_in_character_class:N(1517,1,"Range_out_of_order_in_character_class_1517","Range out of order in character class."),Anything_that_would_possibly_match_more_than_a_single_character_is_invalid_inside_a_negated_character_class:N(1518,1,"Anything_that_would_possibly_match_more_than_a_single_character_is_invalid_inside_a_negated_characte_1518","Anything that would possibly match more than a single character is invalid inside a negated character class."),Operators_must_not_be_mixed_within_a_character_class_Wrap_it_in_a_nested_class_instead:N(1519,1,"Operators_must_not_be_mixed_within_a_character_class_Wrap_it_in_a_nested_class_instead_1519","Operators must not be mixed within a character class. Wrap it in a nested class instead."),Expected_a_class_set_operand:N(1520,1,"Expected_a_class_set_operand_1520","Expected a class set operand."),q_must_be_followed_by_string_alternatives_enclosed_in_braces:N(1521,1,"q_must_be_followed_by_string_alternatives_enclosed_in_braces_1521","'\\q' must be followed by string alternatives enclosed in braces."),A_character_class_must_not_contain_a_reserved_double_punctuator_Did_you_mean_to_escape_it_with_backslash:N(1522,1,"A_character_class_must_not_contain_a_reserved_double_punctuator_Did_you_mean_to_escape_it_with_backs_1522","A character class must not contain a reserved double punctuator. Did you mean to escape it with backslash?"),Expected_a_Unicode_property_name:N(1523,1,"Expected_a_Unicode_property_name_1523","Expected a Unicode property name."),Unknown_Unicode_property_name:N(1524,1,"Unknown_Unicode_property_name_1524","Unknown Unicode property name."),Expected_a_Unicode_property_value:N(1525,1,"Expected_a_Unicode_property_value_1525","Expected a Unicode property value."),Unknown_Unicode_property_value:N(1526,1,"Unknown_Unicode_property_value_1526","Unknown Unicode property value."),Expected_a_Unicode_property_name_or_value:N(1527,1,"Expected_a_Unicode_property_name_or_value_1527","Expected a Unicode property name or value."),Any_Unicode_property_that_would_possibly_match_more_than_a_single_character_is_only_available_when_the_Unicode_Sets_v_flag_is_set:N(1528,1,"Any_Unicode_property_that_would_possibly_match_more_than_a_single_character_is_only_available_when_t_1528","Any Unicode property that would possibly match more than a single character is only available when the Unicode Sets (v) flag is set."),Unknown_Unicode_property_name_or_value:N(1529,1,"Unknown_Unicode_property_name_or_value_1529","Unknown Unicode property name or value."),Unicode_property_value_expressions_are_only_available_when_the_Unicode_u_flag_or_the_Unicode_Sets_v_flag_is_set:N(1530,1,"Unicode_property_value_expressions_are_only_available_when_the_Unicode_u_flag_or_the_Unicode_Sets_v__1530","Unicode property value expressions are only available when the Unicode (u) flag or the Unicode Sets (v) flag is set."),_0_must_be_followed_by_a_Unicode_property_value_expression_enclosed_in_braces:N(1531,1,"_0_must_be_followed_by_a_Unicode_property_value_expression_enclosed_in_braces_1531","'\\{0}' must be followed by a Unicode property value expression enclosed in braces."),There_is_no_capturing_group_named_0_in_this_regular_expression:N(1532,1,"There_is_no_capturing_group_named_0_in_this_regular_expression_1532","There is no capturing group named '{0}' in this regular expression."),This_backreference_refers_to_a_group_that_does_not_exist_There_are_only_0_capturing_groups_in_this_regular_expression:N(1533,1,"This_backreference_refers_to_a_group_that_does_not_exist_There_are_only_0_capturing_groups_in_this_r_1533","This backreference refers to a group that does not exist. There are only {0} capturing groups in this regular expression."),This_backreference_refers_to_a_group_that_does_not_exist_There_are_no_capturing_groups_in_this_regular_expression:N(1534,1,"This_backreference_refers_to_a_group_that_does_not_exist_There_are_no_capturing_groups_in_this_regul_1534","This backreference refers to a group that does not exist. There are no capturing groups in this regular expression."),This_character_cannot_be_escaped_in_a_regular_expression:N(1535,1,"This_character_cannot_be_escaped_in_a_regular_expression_1535","This character cannot be escaped in a regular expression."),Octal_escape_sequences_and_backreferences_are_not_allowed_in_a_character_class_If_this_was_intended_as_an_escape_sequence_use_the_syntax_0_instead:N(1536,1,"Octal_escape_sequences_and_backreferences_are_not_allowed_in_a_character_class_If_this_was_intended__1536","Octal escape sequences and backreferences are not allowed in a character class. If this was intended as an escape sequence, use the syntax '{0}' instead."),Decimal_escape_sequences_and_backreferences_are_not_allowed_in_a_character_class:N(1537,1,"Decimal_escape_sequences_and_backreferences_are_not_allowed_in_a_character_class_1537","Decimal escape sequences and backreferences are not allowed in a character class."),The_types_of_0_are_incompatible_between_these_types:N(2200,1,"The_types_of_0_are_incompatible_between_these_types_2200","The types of '{0}' are incompatible between these types."),The_types_returned_by_0_are_incompatible_between_these_types:N(2201,1,"The_types_returned_by_0_are_incompatible_between_these_types_2201","The types returned by '{0}' are incompatible between these types."),Call_signature_return_types_0_and_1_are_incompatible:N(2202,1,"Call_signature_return_types_0_and_1_are_incompatible_2202","Call signature return types '{0}' and '{1}' are incompatible.",void 0,!0),Construct_signature_return_types_0_and_1_are_incompatible:N(2203,1,"Construct_signature_return_types_0_and_1_are_incompatible_2203","Construct signature return types '{0}' and '{1}' are incompatible.",void 0,!0),Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1:N(2204,1,"Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1_2204","Call signatures with no arguments have incompatible return types '{0}' and '{1}'.",void 0,!0),Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1:N(2205,1,"Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1_2205","Construct signatures with no arguments have incompatible return types '{0}' and '{1}'.",void 0,!0),The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement:N(2206,1,"The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement_2206","The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement."),The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement:N(2207,1,"The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement_2207","The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement."),This_type_parameter_might_need_an_extends_0_constraint:N(2208,1,"This_type_parameter_might_need_an_extends_0_constraint_2208","This type parameter might need an `extends {0}` constraint."),The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate:N(2209,1,"The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_roo_2209","The project root is ambiguous, but is required to resolve export map entry '{0}' in file '{1}'. Supply the `rootDir` compiler option to disambiguate."),The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate:N(2210,1,"The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_roo_2210","The project root is ambiguous, but is required to resolve import map entry '{0}' in file '{1}'. Supply the `rootDir` compiler option to disambiguate."),Add_extends_constraint:N(2211,3,"Add_extends_constraint_2211","Add `extends` constraint."),Add_extends_constraint_to_all_type_parameters:N(2212,3,"Add_extends_constraint_to_all_type_parameters_2212","Add `extends` constraint to all type parameters"),Duplicate_identifier_0:N(2300,1,"Duplicate_identifier_0_2300","Duplicate identifier '{0}'."),Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor:N(2301,1,"Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor_2301","Initializer of instance member variable '{0}' cannot reference identifier '{1}' declared in the constructor."),Static_members_cannot_reference_class_type_parameters:N(2302,1,"Static_members_cannot_reference_class_type_parameters_2302","Static members cannot reference class type parameters."),Circular_definition_of_import_alias_0:N(2303,1,"Circular_definition_of_import_alias_0_2303","Circular definition of import alias '{0}'."),Cannot_find_name_0:N(2304,1,"Cannot_find_name_0_2304","Cannot find name '{0}'."),Module_0_has_no_exported_member_1:N(2305,1,"Module_0_has_no_exported_member_1_2305","Module '{0}' has no exported member '{1}'."),File_0_is_not_a_module:N(2306,1,"File_0_is_not_a_module_2306","File '{0}' is not a module."),Cannot_find_module_0_or_its_corresponding_type_declarations:N(2307,1,"Cannot_find_module_0_or_its_corresponding_type_declarations_2307","Cannot find module '{0}' or its corresponding type declarations."),Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity:N(2308,1,"Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambig_2308","Module {0} has already exported a member named '{1}'. Consider explicitly re-exporting to resolve the ambiguity."),An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements:N(2309,1,"An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements_2309","An export assignment cannot be used in a module with other exported elements."),Type_0_recursively_references_itself_as_a_base_type:N(2310,1,"Type_0_recursively_references_itself_as_a_base_type_2310","Type '{0}' recursively references itself as a base type."),Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function:N(2311,1,"Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function_2311","Cannot find name '{0}'. Did you mean to write this in an async function?"),An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members:N(2312,1,"An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_me_2312","An interface can only extend an object type or intersection of object types with statically known members."),Type_parameter_0_has_a_circular_constraint:N(2313,1,"Type_parameter_0_has_a_circular_constraint_2313","Type parameter '{0}' has a circular constraint."),Generic_type_0_requires_1_type_argument_s:N(2314,1,"Generic_type_0_requires_1_type_argument_s_2314","Generic type '{0}' requires {1} type argument(s)."),Type_0_is_not_generic:N(2315,1,"Type_0_is_not_generic_2315","Type '{0}' is not generic."),Global_type_0_must_be_a_class_or_interface_type:N(2316,1,"Global_type_0_must_be_a_class_or_interface_type_2316","Global type '{0}' must be a class or interface type."),Global_type_0_must_have_1_type_parameter_s:N(2317,1,"Global_type_0_must_have_1_type_parameter_s_2317","Global type '{0}' must have {1} type parameter(s)."),Cannot_find_global_type_0:N(2318,1,"Cannot_find_global_type_0_2318","Cannot find global type '{0}'."),Named_property_0_of_types_1_and_2_are_not_identical:N(2319,1,"Named_property_0_of_types_1_and_2_are_not_identical_2319","Named property '{0}' of types '{1}' and '{2}' are not identical."),Interface_0_cannot_simultaneously_extend_types_1_and_2:N(2320,1,"Interface_0_cannot_simultaneously_extend_types_1_and_2_2320","Interface '{0}' cannot simultaneously extend types '{1}' and '{2}'."),Excessive_stack_depth_comparing_types_0_and_1:N(2321,1,"Excessive_stack_depth_comparing_types_0_and_1_2321","Excessive stack depth comparing types '{0}' and '{1}'."),Type_0_is_not_assignable_to_type_1:N(2322,1,"Type_0_is_not_assignable_to_type_1_2322","Type '{0}' is not assignable to type '{1}'."),Cannot_redeclare_exported_variable_0:N(2323,1,"Cannot_redeclare_exported_variable_0_2323","Cannot redeclare exported variable '{0}'."),Property_0_is_missing_in_type_1:N(2324,1,"Property_0_is_missing_in_type_1_2324","Property '{0}' is missing in type '{1}'."),Property_0_is_private_in_type_1_but_not_in_type_2:N(2325,1,"Property_0_is_private_in_type_1_but_not_in_type_2_2325","Property '{0}' is private in type '{1}' but not in type '{2}'."),Types_of_property_0_are_incompatible:N(2326,1,"Types_of_property_0_are_incompatible_2326","Types of property '{0}' are incompatible."),Property_0_is_optional_in_type_1_but_required_in_type_2:N(2327,1,"Property_0_is_optional_in_type_1_but_required_in_type_2_2327","Property '{0}' is optional in type '{1}' but required in type '{2}'."),Types_of_parameters_0_and_1_are_incompatible:N(2328,1,"Types_of_parameters_0_and_1_are_incompatible_2328","Types of parameters '{0}' and '{1}' are incompatible."),Index_signature_for_type_0_is_missing_in_type_1:N(2329,1,"Index_signature_for_type_0_is_missing_in_type_1_2329","Index signature for type '{0}' is missing in type '{1}'."),_0_and_1_index_signatures_are_incompatible:N(2330,1,"_0_and_1_index_signatures_are_incompatible_2330","'{0}' and '{1}' index signatures are incompatible."),this_cannot_be_referenced_in_a_module_or_namespace_body:N(2331,1,"this_cannot_be_referenced_in_a_module_or_namespace_body_2331","'this' cannot be referenced in a module or namespace body."),this_cannot_be_referenced_in_current_location:N(2332,1,"this_cannot_be_referenced_in_current_location_2332","'this' cannot be referenced in current location."),this_cannot_be_referenced_in_a_static_property_initializer:N(2334,1,"this_cannot_be_referenced_in_a_static_property_initializer_2334","'this' cannot be referenced in a static property initializer."),super_can_only_be_referenced_in_a_derived_class:N(2335,1,"super_can_only_be_referenced_in_a_derived_class_2335","'super' can only be referenced in a derived class."),super_cannot_be_referenced_in_constructor_arguments:N(2336,1,"super_cannot_be_referenced_in_constructor_arguments_2336","'super' cannot be referenced in constructor arguments."),Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors:N(2337,1,"Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors_2337","Super calls are not permitted outside constructors or in nested functions inside constructors."),super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class:N(2338,1,"super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_der_2338","'super' property access is permitted only in a constructor, member function, or member accessor of a derived class."),Property_0_does_not_exist_on_type_1:N(2339,1,"Property_0_does_not_exist_on_type_1_2339","Property '{0}' does not exist on type '{1}'."),Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword:N(2340,1,"Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword_2340","Only public and protected methods of the base class are accessible via the 'super' keyword."),Property_0_is_private_and_only_accessible_within_class_1:N(2341,1,"Property_0_is_private_and_only_accessible_within_class_1_2341","Property '{0}' is private and only accessible within class '{1}'."),This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_version_of_0:N(2343,1,"This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_ve_2343","This syntax requires an imported helper named '{1}' which does not exist in '{0}'. Consider upgrading your version of '{0}'."),Type_0_does_not_satisfy_the_constraint_1:N(2344,1,"Type_0_does_not_satisfy_the_constraint_1_2344","Type '{0}' does not satisfy the constraint '{1}'."),Argument_of_type_0_is_not_assignable_to_parameter_of_type_1:N(2345,1,"Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_2345","Argument of type '{0}' is not assignable to parameter of type '{1}'."),Untyped_function_calls_may_not_accept_type_arguments:N(2347,1,"Untyped_function_calls_may_not_accept_type_arguments_2347","Untyped function calls may not accept type arguments."),Value_of_type_0_is_not_callable_Did_you_mean_to_include_new:N(2348,1,"Value_of_type_0_is_not_callable_Did_you_mean_to_include_new_2348","Value of type '{0}' is not callable. Did you mean to include 'new'?"),This_expression_is_not_callable:N(2349,1,"This_expression_is_not_callable_2349","This expression is not callable."),Only_a_void_function_can_be_called_with_the_new_keyword:N(2350,1,"Only_a_void_function_can_be_called_with_the_new_keyword_2350","Only a void function can be called with the 'new' keyword."),This_expression_is_not_constructable:N(2351,1,"This_expression_is_not_constructable_2351","This expression is not constructable."),Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first:N(2352,1,"Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the__2352","Conversion of type '{0}' to type '{1}' may be a mistake because neither type sufficiently overlaps with the other. If this was intentional, convert the expression to 'unknown' first."),Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1:N(2353,1,"Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1_2353","Object literal may only specify known properties, and '{0}' does not exist in type '{1}'."),This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found:N(2354,1,"This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found_2354","This syntax requires an imported helper but module '{0}' cannot be found."),A_function_whose_declared_type_is_neither_undefined_void_nor_any_must_return_a_value:N(2355,1,"A_function_whose_declared_type_is_neither_undefined_void_nor_any_must_return_a_value_2355","A function whose declared type is neither 'undefined', 'void', nor 'any' must return a value."),An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type:N(2356,1,"An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type_2356","An arithmetic operand must be of type 'any', 'number', 'bigint' or an enum type."),The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access:N(2357,1,"The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access_2357","The operand of an increment or decrement operator must be a variable or a property access."),The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter:N(2358,1,"The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_paramete_2358","The left-hand side of an 'instanceof' expression must be of type 'any', an object type or a type parameter."),The_right_hand_side_of_an_instanceof_expression_must_be_either_of_type_any_a_class_function_or_other_type_assignable_to_the_Function_interface_type_or_an_object_type_with_a_Symbol_hasInstance_method:N(2359,1,"The_right_hand_side_of_an_instanceof_expression_must_be_either_of_type_any_a_class_function_or_other_2359","The right-hand side of an 'instanceof' expression must be either of type 'any', a class, function, or other type assignable to the 'Function' interface type, or an object type with a 'Symbol.hasInstance' method."),The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type:N(2362,1,"The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2362","The left-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."),The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type:N(2363,1,"The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2363","The right-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."),The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access:N(2364,1,"The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access_2364","The left-hand side of an assignment expression must be a variable or a property access."),Operator_0_cannot_be_applied_to_types_1_and_2:N(2365,1,"Operator_0_cannot_be_applied_to_types_1_and_2_2365","Operator '{0}' cannot be applied to types '{1}' and '{2}'."),Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined:N(2366,1,"Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined_2366","Function lacks ending return statement and return type does not include 'undefined'."),This_comparison_appears_to_be_unintentional_because_the_types_0_and_1_have_no_overlap:N(2367,1,"This_comparison_appears_to_be_unintentional_because_the_types_0_and_1_have_no_overlap_2367","This comparison appears to be unintentional because the types '{0}' and '{1}' have no overlap."),Type_parameter_name_cannot_be_0:N(2368,1,"Type_parameter_name_cannot_be_0_2368","Type parameter name cannot be '{0}'."),A_parameter_property_is_only_allowed_in_a_constructor_implementation:N(2369,1,"A_parameter_property_is_only_allowed_in_a_constructor_implementation_2369","A parameter property is only allowed in a constructor implementation."),A_rest_parameter_must_be_of_an_array_type:N(2370,1,"A_rest_parameter_must_be_of_an_array_type_2370","A rest parameter must be of an array type."),A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation:N(2371,1,"A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation_2371","A parameter initializer is only allowed in a function or constructor implementation."),Parameter_0_cannot_reference_itself:N(2372,1,"Parameter_0_cannot_reference_itself_2372","Parameter '{0}' cannot reference itself."),Parameter_0_cannot_reference_identifier_1_declared_after_it:N(2373,1,"Parameter_0_cannot_reference_identifier_1_declared_after_it_2373","Parameter '{0}' cannot reference identifier '{1}' declared after it."),Duplicate_index_signature_for_type_0:N(2374,1,"Duplicate_index_signature_for_type_0_2374","Duplicate index signature for type '{0}'."),Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties:N(2375,1,"Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefi_2375","Type '{0}' is not assignable to type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the types of the target's properties."),A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_class_contains_initialized_properties_parameter_properties_or_private_identifiers:N(2376,1,"A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_2376","A 'super' call must be the first statement in the constructor to refer to 'super' or 'this' when a derived class contains initialized properties, parameter properties, or private identifiers."),Constructors_for_derived_classes_must_contain_a_super_call:N(2377,1,"Constructors_for_derived_classes_must_contain_a_super_call_2377","Constructors for derived classes must contain a 'super' call."),A_get_accessor_must_return_a_value:N(2378,1,"A_get_accessor_must_return_a_value_2378","A 'get' accessor must return a value."),Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties:N(2379,1,"Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_tr_2379","Argument of type '{0}' is not assignable to parameter of type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the types of the target's properties."),Overload_signatures_must_all_be_exported_or_non_exported:N(2383,1,"Overload_signatures_must_all_be_exported_or_non_exported_2383","Overload signatures must all be exported or non-exported."),Overload_signatures_must_all_be_ambient_or_non_ambient:N(2384,1,"Overload_signatures_must_all_be_ambient_or_non_ambient_2384","Overload signatures must all be ambient or non-ambient."),Overload_signatures_must_all_be_public_private_or_protected:N(2385,1,"Overload_signatures_must_all_be_public_private_or_protected_2385","Overload signatures must all be public, private or protected."),Overload_signatures_must_all_be_optional_or_required:N(2386,1,"Overload_signatures_must_all_be_optional_or_required_2386","Overload signatures must all be optional or required."),Function_overload_must_be_static:N(2387,1,"Function_overload_must_be_static_2387","Function overload must be static."),Function_overload_must_not_be_static:N(2388,1,"Function_overload_must_not_be_static_2388","Function overload must not be static."),Function_implementation_name_must_be_0:N(2389,1,"Function_implementation_name_must_be_0_2389","Function implementation name must be '{0}'."),Constructor_implementation_is_missing:N(2390,1,"Constructor_implementation_is_missing_2390","Constructor implementation is missing."),Function_implementation_is_missing_or_not_immediately_following_the_declaration:N(2391,1,"Function_implementation_is_missing_or_not_immediately_following_the_declaration_2391","Function implementation is missing or not immediately following the declaration."),Multiple_constructor_implementations_are_not_allowed:N(2392,1,"Multiple_constructor_implementations_are_not_allowed_2392","Multiple constructor implementations are not allowed."),Duplicate_function_implementation:N(2393,1,"Duplicate_function_implementation_2393","Duplicate function implementation."),This_overload_signature_is_not_compatible_with_its_implementation_signature:N(2394,1,"This_overload_signature_is_not_compatible_with_its_implementation_signature_2394","This overload signature is not compatible with its implementation signature."),Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local:N(2395,1,"Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local_2395","Individual declarations in merged declaration '{0}' must be all exported or all local."),Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters:N(2396,1,"Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters_2396","Duplicate identifier 'arguments'. Compiler uses 'arguments' to initialize rest parameters."),Declaration_name_conflicts_with_built_in_global_identifier_0:N(2397,1,"Declaration_name_conflicts_with_built_in_global_identifier_0_2397","Declaration name conflicts with built-in global identifier '{0}'."),constructor_cannot_be_used_as_a_parameter_property_name:N(2398,1,"constructor_cannot_be_used_as_a_parameter_property_name_2398","'constructor' cannot be used as a parameter property name."),Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference:N(2399,1,"Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference_2399","Duplicate identifier '_this'. Compiler uses variable declaration '_this' to capture 'this' reference."),Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference:N(2400,1,"Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference_2400","Expression resolves to variable declaration '_this' that compiler uses to capture 'this' reference."),A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_initialized_properties_parameter_properties_or_private_identifiers:N(2401,1,"A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_in_2401","A 'super' call must be a root-level statement within a constructor of a derived class that contains initialized properties, parameter properties, or private identifiers."),Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference:N(2402,1,"Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference_2402","Expression resolves to '_super' that compiler uses to capture base class reference."),Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2:N(2403,1,"Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_t_2403","Subsequent variable declarations must have the same type.  Variable '{0}' must be of type '{1}', but here has type '{2}'."),The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation:N(2404,1,"The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation_2404","The left-hand side of a 'for...in' statement cannot use a type annotation."),The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any:N(2405,1,"The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any_2405","The left-hand side of a 'for...in' statement must be of type 'string' or 'any'."),The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access:N(2406,1,"The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access_2406","The left-hand side of a 'for...in' statement must be a variable or a property access."),The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0:N(2407,1,"The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_2407","The right-hand side of a 'for...in' statement must be of type 'any', an object type or a type parameter, but here has type '{0}'."),Setters_cannot_return_a_value:N(2408,1,"Setters_cannot_return_a_value_2408","Setters cannot return a value."),Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class:N(2409,1,"Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class_2409","Return type of constructor signature must be assignable to the instance type of the class."),The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any:N(2410,1,"The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any_2410","The 'with' statement is not supported. All symbols in a 'with' block will have type 'any'."),Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target:N(2412,1,"Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefi_2412","Type '{0}' is not assignable to type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the type of the target."),Property_0_of_type_1_is_not_assignable_to_2_index_type_3:N(2411,1,"Property_0_of_type_1_is_not_assignable_to_2_index_type_3_2411","Property '{0}' of type '{1}' is not assignable to '{2}' index type '{3}'."),_0_index_type_1_is_not_assignable_to_2_index_type_3:N(2413,1,"_0_index_type_1_is_not_assignable_to_2_index_type_3_2413","'{0}' index type '{1}' is not assignable to '{2}' index type '{3}'."),Class_name_cannot_be_0:N(2414,1,"Class_name_cannot_be_0_2414","Class name cannot be '{0}'."),Class_0_incorrectly_extends_base_class_1:N(2415,1,"Class_0_incorrectly_extends_base_class_1_2415","Class '{0}' incorrectly extends base class '{1}'."),Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2:N(2416,1,"Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2_2416","Property '{0}' in type '{1}' is not assignable to the same property in base type '{2}'."),Class_static_side_0_incorrectly_extends_base_class_static_side_1:N(2417,1,"Class_static_side_0_incorrectly_extends_base_class_static_side_1_2417","Class static side '{0}' incorrectly extends base class static side '{1}'."),Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1:N(2418,1,"Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1_2418","Type of computed property's value is '{0}', which is not assignable to type '{1}'."),Types_of_construct_signatures_are_incompatible:N(2419,1,"Types_of_construct_signatures_are_incompatible_2419","Types of construct signatures are incompatible."),Class_0_incorrectly_implements_interface_1:N(2420,1,"Class_0_incorrectly_implements_interface_1_2420","Class '{0}' incorrectly implements interface '{1}'."),A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members:N(2422,1,"A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_memb_2422","A class can only implement an object type or intersection of object types with statically known members."),Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor:N(2423,1,"Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_access_2423","Class '{0}' defines instance member function '{1}', but extended class '{2}' defines it as instance member accessor."),Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function:N(2425,1,"Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_functi_2425","Class '{0}' defines instance member property '{1}', but extended class '{2}' defines it as instance member function."),Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function:N(2426,1,"Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_functi_2426","Class '{0}' defines instance member accessor '{1}', but extended class '{2}' defines it as instance member function."),Interface_name_cannot_be_0:N(2427,1,"Interface_name_cannot_be_0_2427","Interface name cannot be '{0}'."),All_declarations_of_0_must_have_identical_type_parameters:N(2428,1,"All_declarations_of_0_must_have_identical_type_parameters_2428","All declarations of '{0}' must have identical type parameters."),Interface_0_incorrectly_extends_interface_1:N(2430,1,"Interface_0_incorrectly_extends_interface_1_2430","Interface '{0}' incorrectly extends interface '{1}'."),Enum_name_cannot_be_0:N(2431,1,"Enum_name_cannot_be_0_2431","Enum name cannot be '{0}'."),In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element:N(2432,1,"In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enu_2432","In an enum with multiple declarations, only one declaration can omit an initializer for its first enum element."),A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged:N(2433,1,"A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merg_2433","A namespace declaration cannot be in a different file from a class or function with which it is merged."),A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged:N(2434,1,"A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged_2434","A namespace declaration cannot be located prior to a class or function with which it is merged."),Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces:N(2435,1,"Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces_2435","Ambient modules cannot be nested in other modules or namespaces."),Ambient_module_declaration_cannot_specify_relative_module_name:N(2436,1,"Ambient_module_declaration_cannot_specify_relative_module_name_2436","Ambient module declaration cannot specify relative module name."),Module_0_is_hidden_by_a_local_declaration_with_the_same_name:N(2437,1,"Module_0_is_hidden_by_a_local_declaration_with_the_same_name_2437","Module '{0}' is hidden by a local declaration with the same name."),Import_name_cannot_be_0:N(2438,1,"Import_name_cannot_be_0_2438","Import name cannot be '{0}'."),Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name:N(2439,1,"Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relati_2439","Import or export declaration in an ambient module declaration cannot reference module through relative module name."),Import_declaration_conflicts_with_local_declaration_of_0:N(2440,1,"Import_declaration_conflicts_with_local_declaration_of_0_2440","Import declaration conflicts with local declaration of '{0}'."),Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module:N(2441,1,"Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_2441","Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module."),Types_have_separate_declarations_of_a_private_property_0:N(2442,1,"Types_have_separate_declarations_of_a_private_property_0_2442","Types have separate declarations of a private property '{0}'."),Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2:N(2443,1,"Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2_2443","Property '{0}' is protected but type '{1}' is not a class derived from '{2}'."),Property_0_is_protected_in_type_1_but_public_in_type_2:N(2444,1,"Property_0_is_protected_in_type_1_but_public_in_type_2_2444","Property '{0}' is protected in type '{1}' but public in type '{2}'."),Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses:N(2445,1,"Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses_2445","Property '{0}' is protected and only accessible within class '{1}' and its subclasses."),Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_class_2:N(2446,1,"Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_cl_2446","Property '{0}' is protected and only accessible through an instance of class '{1}'. This is an instance of class '{2}'."),The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead:N(2447,1,"The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead_2447","The '{0}' operator is not allowed for boolean types. Consider using '{1}' instead."),Block_scoped_variable_0_used_before_its_declaration:N(2448,1,"Block_scoped_variable_0_used_before_its_declaration_2448","Block-scoped variable '{0}' used before its declaration."),Class_0_used_before_its_declaration:N(2449,1,"Class_0_used_before_its_declaration_2449","Class '{0}' used before its declaration."),Enum_0_used_before_its_declaration:N(2450,1,"Enum_0_used_before_its_declaration_2450","Enum '{0}' used before its declaration."),Cannot_redeclare_block_scoped_variable_0:N(2451,1,"Cannot_redeclare_block_scoped_variable_0_2451","Cannot redeclare block-scoped variable '{0}'."),An_enum_member_cannot_have_a_numeric_name:N(2452,1,"An_enum_member_cannot_have_a_numeric_name_2452","An enum member cannot have a numeric name."),Variable_0_is_used_before_being_assigned:N(2454,1,"Variable_0_is_used_before_being_assigned_2454","Variable '{0}' is used before being assigned."),Type_alias_0_circularly_references_itself:N(2456,1,"Type_alias_0_circularly_references_itself_2456","Type alias '{0}' circularly references itself."),Type_alias_name_cannot_be_0:N(2457,1,"Type_alias_name_cannot_be_0_2457","Type alias name cannot be '{0}'."),An_AMD_module_cannot_have_multiple_name_assignments:N(2458,1,"An_AMD_module_cannot_have_multiple_name_assignments_2458","An AMD module cannot have multiple name assignments."),Module_0_declares_1_locally_but_it_is_not_exported:N(2459,1,"Module_0_declares_1_locally_but_it_is_not_exported_2459","Module '{0}' declares '{1}' locally, but it is not exported."),Module_0_declares_1_locally_but_it_is_exported_as_2:N(2460,1,"Module_0_declares_1_locally_but_it_is_exported_as_2_2460","Module '{0}' declares '{1}' locally, but it is exported as '{2}'."),Type_0_is_not_an_array_type:N(2461,1,"Type_0_is_not_an_array_type_2461","Type '{0}' is not an array type."),A_rest_element_must_be_last_in_a_destructuring_pattern:N(2462,1,"A_rest_element_must_be_last_in_a_destructuring_pattern_2462","A rest element must be last in a destructuring pattern."),A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature:N(2463,1,"A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature_2463","A binding pattern parameter cannot be optional in an implementation signature."),A_computed_property_name_must_be_of_type_string_number_symbol_or_any:N(2464,1,"A_computed_property_name_must_be_of_type_string_number_symbol_or_any_2464","A computed property name must be of type 'string', 'number', 'symbol', or 'any'."),this_cannot_be_referenced_in_a_computed_property_name:N(2465,1,"this_cannot_be_referenced_in_a_computed_property_name_2465","'this' cannot be referenced in a computed property name."),super_cannot_be_referenced_in_a_computed_property_name:N(2466,1,"super_cannot_be_referenced_in_a_computed_property_name_2466","'super' cannot be referenced in a computed property name."),A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type:N(2467,1,"A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type_2467","A computed property name cannot reference a type parameter from its containing type."),Cannot_find_global_value_0:N(2468,1,"Cannot_find_global_value_0_2468","Cannot find global value '{0}'."),The_0_operator_cannot_be_applied_to_type_symbol:N(2469,1,"The_0_operator_cannot_be_applied_to_type_symbol_2469","The '{0}' operator cannot be applied to type 'symbol'."),Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher:N(2472,1,"Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher_2472","Spread operator in 'new' expressions is only available when targeting ECMAScript 5 and higher."),Enum_declarations_must_all_be_const_or_non_const:N(2473,1,"Enum_declarations_must_all_be_const_or_non_const_2473","Enum declarations must all be const or non-const."),const_enum_member_initializers_must_be_constant_expressions:N(2474,1,"const_enum_member_initializers_must_be_constant_expressions_2474","const enum member initializers must be constant expressions."),const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query:N(2475,1,"const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_im_2475","'const' enums can only be used in property or index access expressions or the right hand side of an import declaration or export assignment or type query."),A_const_enum_member_can_only_be_accessed_using_a_string_literal:N(2476,1,"A_const_enum_member_can_only_be_accessed_using_a_string_literal_2476","A const enum member can only be accessed using a string literal."),const_enum_member_initializer_was_evaluated_to_a_non_finite_value:N(2477,1,"const_enum_member_initializer_was_evaluated_to_a_non_finite_value_2477","'const' enum member initializer was evaluated to a non-finite value."),const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN:N(2478,1,"const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN_2478","'const' enum member initializer was evaluated to disallowed value 'NaN'."),let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations:N(2480,1,"let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations_2480","'let' is not allowed to be used as a name in 'let' or 'const' declarations."),Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1:N(2481,1,"Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1_2481","Cannot initialize outer scoped variable '{0}' in the same scope as block scoped declaration '{1}'."),The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation:N(2483,1,"The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation_2483","The left-hand side of a 'for...of' statement cannot use a type annotation."),Export_declaration_conflicts_with_exported_declaration_of_0:N(2484,1,"Export_declaration_conflicts_with_exported_declaration_of_0_2484","Export declaration conflicts with exported declaration of '{0}'."),The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access:N(2487,1,"The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access_2487","The left-hand side of a 'for...of' statement must be a variable or a property access."),Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator:N(2488,1,"Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator_2488","Type '{0}' must have a '[Symbol.iterator]()' method that returns an iterator."),An_iterator_must_have_a_next_method:N(2489,1,"An_iterator_must_have_a_next_method_2489","An iterator must have a 'next()' method."),The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property:N(2490,1,"The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property_2490","The type returned by the '{0}()' method of an iterator must have a 'value' property."),The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern:N(2491,1,"The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern_2491","The left-hand side of a 'for...in' statement cannot be a destructuring pattern."),Cannot_redeclare_identifier_0_in_catch_clause:N(2492,1,"Cannot_redeclare_identifier_0_in_catch_clause_2492","Cannot redeclare identifier '{0}' in catch clause."),Tuple_type_0_of_length_1_has_no_element_at_index_2:N(2493,1,"Tuple_type_0_of_length_1_has_no_element_at_index_2_2493","Tuple type '{0}' of length '{1}' has no element at index '{2}'."),Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher:N(2494,1,"Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher_2494","Using a string in a 'for...of' statement is only supported in ECMAScript 5 and higher."),Type_0_is_not_an_array_type_or_a_string_type:N(2495,1,"Type_0_is_not_an_array_type_or_a_string_type_2495","Type '{0}' is not an array type or a string type."),The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES5_Consider_using_a_standard_function_expression:N(2496,1,"The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES5_Consider_using_a_standard_func_2496","The 'arguments' object cannot be referenced in an arrow function in ES5. Consider using a standard function expression."),This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export:N(2497,1,"This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_2497","This module can only be referenced with ECMAScript imports/exports by turning on the '{0}' flag and referencing its default export."),Module_0_uses_export_and_cannot_be_used_with_export_Asterisk:N(2498,1,"Module_0_uses_export_and_cannot_be_used_with_export_Asterisk_2498","Module '{0}' uses 'export =' and cannot be used with 'export *'."),An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments:N(2499,1,"An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments_2499","An interface can only extend an identifier/qualified-name with optional type arguments."),A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments:N(2500,1,"A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments_2500","A class can only implement an identifier/qualified-name with optional type arguments."),A_rest_element_cannot_contain_a_binding_pattern:N(2501,1,"A_rest_element_cannot_contain_a_binding_pattern_2501","A rest element cannot contain a binding pattern."),_0_is_referenced_directly_or_indirectly_in_its_own_type_annotation:N(2502,1,"_0_is_referenced_directly_or_indirectly_in_its_own_type_annotation_2502","'{0}' is referenced directly or indirectly in its own type annotation."),Cannot_find_namespace_0:N(2503,1,"Cannot_find_namespace_0_2503","Cannot find namespace '{0}'."),Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator:N(2504,1,"Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator_2504","Type '{0}' must have a '[Symbol.asyncIterator]()' method that returns an async iterator."),A_generator_cannot_have_a_void_type_annotation:N(2505,1,"A_generator_cannot_have_a_void_type_annotation_2505","A generator cannot have a 'void' type annotation."),_0_is_referenced_directly_or_indirectly_in_its_own_base_expression:N(2506,1,"_0_is_referenced_directly_or_indirectly_in_its_own_base_expression_2506","'{0}' is referenced directly or indirectly in its own base expression."),Type_0_is_not_a_constructor_function_type:N(2507,1,"Type_0_is_not_a_constructor_function_type_2507","Type '{0}' is not a constructor function type."),No_base_constructor_has_the_specified_number_of_type_arguments:N(2508,1,"No_base_constructor_has_the_specified_number_of_type_arguments_2508","No base constructor has the specified number of type arguments."),Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members:N(2509,1,"Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_2509","Base constructor return type '{0}' is not an object type or intersection of object types with statically known members."),Base_constructors_must_all_have_the_same_return_type:N(2510,1,"Base_constructors_must_all_have_the_same_return_type_2510","Base constructors must all have the same return type."),Cannot_create_an_instance_of_an_abstract_class:N(2511,1,"Cannot_create_an_instance_of_an_abstract_class_2511","Cannot create an instance of an abstract class."),Overload_signatures_must_all_be_abstract_or_non_abstract:N(2512,1,"Overload_signatures_must_all_be_abstract_or_non_abstract_2512","Overload signatures must all be abstract or non-abstract."),Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression:N(2513,1,"Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression_2513","Abstract method '{0}' in class '{1}' cannot be accessed via super expression."),A_tuple_type_cannot_be_indexed_with_a_negative_value:N(2514,1,"A_tuple_type_cannot_be_indexed_with_a_negative_value_2514","A tuple type cannot be indexed with a negative value."),Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2:N(2515,1,"Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2_2515","Non-abstract class '{0}' does not implement inherited abstract member {1} from class '{2}'."),All_declarations_of_an_abstract_method_must_be_consecutive:N(2516,1,"All_declarations_of_an_abstract_method_must_be_consecutive_2516","All declarations of an abstract method must be consecutive."),Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type:N(2517,1,"Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type_2517","Cannot assign an abstract constructor type to a non-abstract constructor type."),A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard:N(2518,1,"A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard_2518","A 'this'-based type guard is not compatible with a parameter-based type guard."),An_async_iterator_must_have_a_next_method:N(2519,1,"An_async_iterator_must_have_a_next_method_2519","An async iterator must have a 'next()' method."),Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions:N(2520,1,"Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions_2520","Duplicate identifier '{0}'. Compiler uses declaration '{1}' to support async functions."),The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES5_Consider_using_a_standard_function_or_method:N(2522,1,"The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES5_Consider_using_a_sta_2522","The 'arguments' object cannot be referenced in an async function or method in ES5. Consider using a standard function or method."),yield_expressions_cannot_be_used_in_a_parameter_initializer:N(2523,1,"yield_expressions_cannot_be_used_in_a_parameter_initializer_2523","'yield' expressions cannot be used in a parameter initializer."),await_expressions_cannot_be_used_in_a_parameter_initializer:N(2524,1,"await_expressions_cannot_be_used_in_a_parameter_initializer_2524","'await' expressions cannot be used in a parameter initializer."),Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value:N(2525,1,"Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value_2525","Initializer provides no value for this binding element and the binding element has no default value."),A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface:N(2526,1,"A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface_2526","A 'this' type is available only in a non-static member of a class or interface."),The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary:N(2527,1,"The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary_2527","The inferred type of '{0}' references an inaccessible '{1}' type. A type annotation is necessary."),A_module_cannot_have_multiple_default_exports:N(2528,1,"A_module_cannot_have_multiple_default_exports_2528","A module cannot have multiple default exports."),Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions:N(2529,1,"Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_func_2529","Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module containing async functions."),Property_0_is_incompatible_with_index_signature:N(2530,1,"Property_0_is_incompatible_with_index_signature_2530","Property '{0}' is incompatible with index signature."),Object_is_possibly_null:N(2531,1,"Object_is_possibly_null_2531","Object is possibly 'null'."),Object_is_possibly_undefined:N(2532,1,"Object_is_possibly_undefined_2532","Object is possibly 'undefined'."),Object_is_possibly_null_or_undefined:N(2533,1,"Object_is_possibly_null_or_undefined_2533","Object is possibly 'null' or 'undefined'."),A_function_returning_never_cannot_have_a_reachable_end_point:N(2534,1,"A_function_returning_never_cannot_have_a_reachable_end_point_2534","A function returning 'never' cannot have a reachable end point."),Type_0_cannot_be_used_to_index_type_1:N(2536,1,"Type_0_cannot_be_used_to_index_type_1_2536","Type '{0}' cannot be used to index type '{1}'."),Type_0_has_no_matching_index_signature_for_type_1:N(2537,1,"Type_0_has_no_matching_index_signature_for_type_1_2537","Type '{0}' has no matching index signature for type '{1}'."),Type_0_cannot_be_used_as_an_index_type:N(2538,1,"Type_0_cannot_be_used_as_an_index_type_2538","Type '{0}' cannot be used as an index type."),Cannot_assign_to_0_because_it_is_not_a_variable:N(2539,1,"Cannot_assign_to_0_because_it_is_not_a_variable_2539","Cannot assign to '{0}' because it is not a variable."),Cannot_assign_to_0_because_it_is_a_read_only_property:N(2540,1,"Cannot_assign_to_0_because_it_is_a_read_only_property_2540","Cannot assign to '{0}' because it is a read-only property."),Index_signature_in_type_0_only_permits_reading:N(2542,1,"Index_signature_in_type_0_only_permits_reading_2542","Index signature in type '{0}' only permits reading."),Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference:N(2543,1,"Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_me_2543","Duplicate identifier '_newTarget'. Compiler uses variable declaration '_newTarget' to capture 'new.target' meta-property reference."),Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference:N(2544,1,"Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta__2544","Expression resolves to variable declaration '_newTarget' that compiler uses to capture 'new.target' meta-property reference."),A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any:N(2545,1,"A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any_2545","A mixin class must have a constructor with a single rest parameter of type 'any[]'."),The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property:N(2547,1,"The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_pro_2547","The type returned by the '{0}()' method of an async iterator must be a promise for a type with a 'value' property."),Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator:N(2548,1,"Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator_2548","Type '{0}' is not an array type or does not have a '[Symbol.iterator]()' method that returns an iterator."),Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator:N(2549,1,"Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns__2549","Type '{0}' is not an array type or a string type or does not have a '[Symbol.iterator]()' method that returns an iterator."),Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2_or_later:N(2550,1,"Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_c_2550","Property '{0}' does not exist on type '{1}'. Do you need to change your target library? Try changing the 'lib' compiler option to '{2}' or later."),Property_0_does_not_exist_on_type_1_Did_you_mean_2:N(2551,1,"Property_0_does_not_exist_on_type_1_Did_you_mean_2_2551","Property '{0}' does not exist on type '{1}'. Did you mean '{2}'?"),Cannot_find_name_0_Did_you_mean_1:N(2552,1,"Cannot_find_name_0_Did_you_mean_1_2552","Cannot find name '{0}'. Did you mean '{1}'?"),Computed_values_are_not_permitted_in_an_enum_with_string_valued_members:N(2553,1,"Computed_values_are_not_permitted_in_an_enum_with_string_valued_members_2553","Computed values are not permitted in an enum with string valued members."),Expected_0_arguments_but_got_1:N(2554,1,"Expected_0_arguments_but_got_1_2554","Expected {0} arguments, but got {1}."),Expected_at_least_0_arguments_but_got_1:N(2555,1,"Expected_at_least_0_arguments_but_got_1_2555","Expected at least {0} arguments, but got {1}."),A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter:N(2556,1,"A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter_2556","A spread argument must either have a tuple type or be passed to a rest parameter."),Expected_0_type_arguments_but_got_1:N(2558,1,"Expected_0_type_arguments_but_got_1_2558","Expected {0} type arguments, but got {1}."),Type_0_has_no_properties_in_common_with_type_1:N(2559,1,"Type_0_has_no_properties_in_common_with_type_1_2559","Type '{0}' has no properties in common with type '{1}'."),Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it:N(2560,1,"Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it_2560","Value of type '{0}' has no properties in common with type '{1}'. Did you mean to call it?"),Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2:N(2561,1,"Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_writ_2561","Object literal may only specify known properties, but '{0}' does not exist in type '{1}'. Did you mean to write '{2}'?"),Base_class_expressions_cannot_reference_class_type_parameters:N(2562,1,"Base_class_expressions_cannot_reference_class_type_parameters_2562","Base class expressions cannot reference class type parameters."),The_containing_function_or_module_body_is_too_large_for_control_flow_analysis:N(2563,1,"The_containing_function_or_module_body_is_too_large_for_control_flow_analysis_2563","The containing function or module body is too large for control flow analysis."),Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor:N(2564,1,"Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor_2564","Property '{0}' has no initializer and is not definitely assigned in the constructor."),Property_0_is_used_before_being_assigned:N(2565,1,"Property_0_is_used_before_being_assigned_2565","Property '{0}' is used before being assigned."),A_rest_element_cannot_have_a_property_name:N(2566,1,"A_rest_element_cannot_have_a_property_name_2566","A rest element cannot have a property name."),Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations:N(2567,1,"Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations_2567","Enum declarations can only merge with namespace or other enum declarations."),Property_0_may_not_exist_on_type_1_Did_you_mean_2:N(2568,1,"Property_0_may_not_exist_on_type_1_Did_you_mean_2_2568","Property '{0}' may not exist on type '{1}'. Did you mean '{2}'?"),Could_not_find_name_0_Did_you_mean_1:N(2570,1,"Could_not_find_name_0_Did_you_mean_1_2570","Could not find name '{0}'. Did you mean '{1}'?"),Object_is_of_type_unknown:N(2571,1,"Object_is_of_type_unknown_2571","Object is of type 'unknown'."),A_rest_element_type_must_be_an_array_type:N(2574,1,"A_rest_element_type_must_be_an_array_type_2574","A rest element type must be an array type."),No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments:N(2575,1,"No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments_2575","No overload expects {0} arguments, but overloads do exist that expect either {1} or {2} arguments."),Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead:N(2576,1,"Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead_2576","Property '{0}' does not exist on type '{1}'. Did you mean to access the static member '{2}' instead?"),Return_type_annotation_circularly_references_itself:N(2577,1,"Return_type_annotation_circularly_references_itself_2577","Return type annotation circularly references itself."),Unused_ts_expect_error_directive:N(2578,1,"Unused_ts_expect_error_directive_2578","Unused '@ts-expect-error' directive."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode:N(2580,1,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashno_2580","Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i --save-dev @types/node`."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery:N(2581,1,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slash_2581","Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i --save-dev @types/jquery`."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha:N(2582,1,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_type_2582","Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i --save-dev @types/jest` or `npm i --save-dev @types/mocha`."),Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_1_or_later:N(2583,1,"Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2583","Cannot find name '{0}'. Do you need to change your target library? Try changing the 'lib' compiler option to '{1}' or later."),Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom:N(2584,1,"Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2584","Cannot find name '{0}'. Do you need to change your target library? Try changing the 'lib' compiler option to include 'dom'."),_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later:N(2585,1,"_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_2585","'{0}' only refers to a type, but is being used as a value here. Do you need to change your target library? Try changing the 'lib' compiler option to es2015 or later."),Cannot_assign_to_0_because_it_is_a_constant:N(2588,1,"Cannot_assign_to_0_because_it_is_a_constant_2588","Cannot assign to '{0}' because it is a constant."),Type_instantiation_is_excessively_deep_and_possibly_infinite:N(2589,1,"Type_instantiation_is_excessively_deep_and_possibly_infinite_2589","Type instantiation is excessively deep and possibly infinite."),Expression_produces_a_union_type_that_is_too_complex_to_represent:N(2590,1,"Expression_produces_a_union_type_that_is_too_complex_to_represent_2590","Expression produces a union type that is too complex to represent."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig:N(2591,1,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashno_2591","Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i --save-dev @types/node` and then add 'node' to the types field in your tsconfig."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig:N(2592,1,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slash_2592","Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i --save-dev @types/jquery` and then add 'jquery' to the types field in your tsconfig."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig:N(2593,1,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_type_2593","Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i --save-dev @types/jest` or `npm i --save-dev @types/mocha` and then add 'jest' or 'mocha' to the types field in your tsconfig."),This_module_is_declared_with_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag:N(2594,1,"This_module_is_declared_with_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag_2594","This module is declared with 'export =', and can only be used with a default import when using the '{0}' flag."),_0_can_only_be_imported_by_using_a_default_import:N(2595,1,"_0_can_only_be_imported_by_using_a_default_import_2595","'{0}' can only be imported by using a default import."),_0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import:N(2596,1,"_0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import_2596","'{0}' can only be imported by turning on the 'esModuleInterop' flag and using a default import."),_0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import:N(2597,1,"_0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import_2597","'{0}' can only be imported by using a 'require' call or by using a default import."),_0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import:N(2598,1,"_0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using__2598","'{0}' can only be imported by using a 'require' call or by turning on the 'esModuleInterop' flag and using a default import."),JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist:N(2602,1,"JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist_2602","JSX element implicitly has type 'any' because the global type 'JSX.Element' does not exist."),Property_0_in_type_1_is_not_assignable_to_type_2:N(2603,1,"Property_0_in_type_1_is_not_assignable_to_type_2_2603","Property '{0}' in type '{1}' is not assignable to type '{2}'."),JSX_element_type_0_does_not_have_any_construct_or_call_signatures:N(2604,1,"JSX_element_type_0_does_not_have_any_construct_or_call_signatures_2604","JSX element type '{0}' does not have any construct or call signatures."),Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property:N(2606,1,"Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property_2606","Property '{0}' of JSX spread attribute is not assignable to target property."),JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property:N(2607,1,"JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property_2607","JSX element class does not support attributes because it does not have a '{0}' property."),The_global_type_JSX_0_may_not_have_more_than_one_property:N(2608,1,"The_global_type_JSX_0_may_not_have_more_than_one_property_2608","The global type 'JSX.{0}' may not have more than one property."),JSX_spread_child_must_be_an_array_type:N(2609,1,"JSX_spread_child_must_be_an_array_type_2609","JSX spread child must be an array type."),_0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property:N(2610,1,"_0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property_2610","'{0}' is defined as an accessor in class '{1}', but is overridden here in '{2}' as an instance property."),_0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor:N(2611,1,"_0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor_2611","'{0}' is defined as a property in class '{1}', but is overridden here in '{2}' as an accessor."),Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration:N(2612,1,"Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_2612","Property '{0}' will overwrite the base property in '{1}'. If this is intentional, add an initializer. Otherwise, add a 'declare' modifier or remove the redundant declaration."),Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead:N(2613,1,"Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead_2613","Module '{0}' has no default export. Did you mean to use 'import { {1} } from {0}' instead?"),Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead:N(2614,1,"Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead_2614","Module '{0}' has no exported member '{1}'. Did you mean to use 'import {1} from {0}' instead?"),Type_of_property_0_circularly_references_itself_in_mapped_type_1:N(2615,1,"Type_of_property_0_circularly_references_itself_in_mapped_type_1_2615","Type of property '{0}' circularly references itself in mapped type '{1}'."),_0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import:N(2616,1,"_0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import_2616","'{0}' can only be imported by using 'import {1} = require({2})' or a default import."),_0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import:N(2617,1,"_0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_us_2617","'{0}' can only be imported by using 'import {1} = require({2})' or by turning on the 'esModuleInterop' flag and using a default import."),Source_has_0_element_s_but_target_requires_1:N(2618,1,"Source_has_0_element_s_but_target_requires_1_2618","Source has {0} element(s) but target requires {1}."),Source_has_0_element_s_but_target_allows_only_1:N(2619,1,"Source_has_0_element_s_but_target_allows_only_1_2619","Source has {0} element(s) but target allows only {1}."),Target_requires_0_element_s_but_source_may_have_fewer:N(2620,1,"Target_requires_0_element_s_but_source_may_have_fewer_2620","Target requires {0} element(s) but source may have fewer."),Target_allows_only_0_element_s_but_source_may_have_more:N(2621,1,"Target_allows_only_0_element_s_but_source_may_have_more_2621","Target allows only {0} element(s) but source may have more."),Source_provides_no_match_for_required_element_at_position_0_in_target:N(2623,1,"Source_provides_no_match_for_required_element_at_position_0_in_target_2623","Source provides no match for required element at position {0} in target."),Source_provides_no_match_for_variadic_element_at_position_0_in_target:N(2624,1,"Source_provides_no_match_for_variadic_element_at_position_0_in_target_2624","Source provides no match for variadic element at position {0} in target."),Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target:N(2625,1,"Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target_2625","Variadic element at position {0} in source does not match element at position {1} in target."),Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target:N(2626,1,"Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target_2626","Type at position {0} in source is not compatible with type at position {1} in target."),Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target:N(2627,1,"Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target_2627","Type at positions {0} through {1} in source is not compatible with type at position {2} in target."),Cannot_assign_to_0_because_it_is_an_enum:N(2628,1,"Cannot_assign_to_0_because_it_is_an_enum_2628","Cannot assign to '{0}' because it is an enum."),Cannot_assign_to_0_because_it_is_a_class:N(2629,1,"Cannot_assign_to_0_because_it_is_a_class_2629","Cannot assign to '{0}' because it is a class."),Cannot_assign_to_0_because_it_is_a_function:N(2630,1,"Cannot_assign_to_0_because_it_is_a_function_2630","Cannot assign to '{0}' because it is a function."),Cannot_assign_to_0_because_it_is_a_namespace:N(2631,1,"Cannot_assign_to_0_because_it_is_a_namespace_2631","Cannot assign to '{0}' because it is a namespace."),Cannot_assign_to_0_because_it_is_an_import:N(2632,1,"Cannot_assign_to_0_because_it_is_an_import_2632","Cannot assign to '{0}' because it is an import."),JSX_property_access_expressions_cannot_include_JSX_namespace_names:N(2633,1,"JSX_property_access_expressions_cannot_include_JSX_namespace_names_2633","JSX property access expressions cannot include JSX namespace names"),_0_index_signatures_are_incompatible:N(2634,1,"_0_index_signatures_are_incompatible_2634","'{0}' index signatures are incompatible."),Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable:N(2635,1,"Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable_2635","Type '{0}' has no signatures for which the type argument list is applicable."),Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation:N(2636,1,"Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation_2636","Type '{0}' is not assignable to type '{1}' as implied by variance annotation."),Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_types:N(2637,1,"Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_t_2637","Variance annotations are only supported in type aliases for object, function, constructor, and mapped types."),Type_0_may_represent_a_primitive_value_which_is_not_permitted_as_the_right_operand_of_the_in_operator:N(2638,1,"Type_0_may_represent_a_primitive_value_which_is_not_permitted_as_the_right_operand_of_the_in_operato_2638","Type '{0}' may represent a primitive value, which is not permitted as the right operand of the 'in' operator."),React_components_cannot_include_JSX_namespace_names:N(2639,1,"React_components_cannot_include_JSX_namespace_names_2639","React components cannot include JSX namespace names"),Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity:N(2649,1,"Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity_2649","Cannot augment module '{0}' with value exports because it resolves to a non-module entity."),Non_abstract_class_expression_is_missing_implementations_for_the_following_members_of_0_Colon_1_and_2_more:N(2650,1,"Non_abstract_class_expression_is_missing_implementations_for_the_following_members_of_0_Colon_1_and__2650","Non-abstract class expression is missing implementations for the following members of '{0}': {1} and {2} more."),A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums:N(2651,1,"A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_memb_2651","A member initializer in a enum declaration cannot reference members declared after it, including members defined in other enums."),Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead:N(2652,1,"Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_d_2652","Merged declaration '{0}' cannot include a default export declaration. Consider adding a separate 'export default {0}' declaration instead."),Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1:N(2653,1,"Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1_2653","Non-abstract class expression does not implement inherited abstract member '{0}' from class '{1}'."),Non_abstract_class_0_is_missing_implementations_for_the_following_members_of_1_Colon_2:N(2654,1,"Non_abstract_class_0_is_missing_implementations_for_the_following_members_of_1_Colon_2_2654","Non-abstract class '{0}' is missing implementations for the following members of '{1}': {2}."),Non_abstract_class_0_is_missing_implementations_for_the_following_members_of_1_Colon_2_and_3_more:N(2655,1,"Non_abstract_class_0_is_missing_implementations_for_the_following_members_of_1_Colon_2_and_3_more_2655","Non-abstract class '{0}' is missing implementations for the following members of '{1}': {2} and {3} more."),Non_abstract_class_expression_is_missing_implementations_for_the_following_members_of_0_Colon_1:N(2656,1,"Non_abstract_class_expression_is_missing_implementations_for_the_following_members_of_0_Colon_1_2656","Non-abstract class expression is missing implementations for the following members of '{0}': {1}."),JSX_expressions_must_have_one_parent_element:N(2657,1,"JSX_expressions_must_have_one_parent_element_2657","JSX expressions must have one parent element."),Type_0_provides_no_match_for_the_signature_1:N(2658,1,"Type_0_provides_no_match_for_the_signature_1_2658","Type '{0}' provides no match for the signature '{1}'."),super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher:N(2659,1,"super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_highe_2659","'super' is only allowed in members of object literal expressions when option 'target' is 'ES2015' or higher."),super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions:N(2660,1,"super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions_2660","'super' can only be referenced in members of derived classes or object literal expressions."),Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module:N(2661,1,"Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module_2661","Cannot export '{0}'. Only local declarations can be exported from a module."),Cannot_find_name_0_Did_you_mean_the_static_member_1_0:N(2662,1,"Cannot_find_name_0_Did_you_mean_the_static_member_1_0_2662","Cannot find name '{0}'. Did you mean the static member '{1}.{0}'?"),Cannot_find_name_0_Did_you_mean_the_instance_member_this_0:N(2663,1,"Cannot_find_name_0_Did_you_mean_the_instance_member_this_0_2663","Cannot find name '{0}'. Did you mean the instance member 'this.{0}'?"),Invalid_module_name_in_augmentation_module_0_cannot_be_found:N(2664,1,"Invalid_module_name_in_augmentation_module_0_cannot_be_found_2664","Invalid module name in augmentation, module '{0}' cannot be found."),Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented:N(2665,1,"Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augm_2665","Invalid module name in augmentation. Module '{0}' resolves to an untyped module at '{1}', which cannot be augmented."),Exports_and_export_assignments_are_not_permitted_in_module_augmentations:N(2666,1,"Exports_and_export_assignments_are_not_permitted_in_module_augmentations_2666","Exports and export assignments are not permitted in module augmentations."),Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module:N(2667,1,"Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_mod_2667","Imports are not permitted in module augmentations. Consider moving them to the enclosing external module."),export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible:N(2668,1,"export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always__2668","'export' modifier cannot be applied to ambient modules and module augmentations since they are always visible."),Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations:N(2669,1,"Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_2669","Augmentations for the global scope can only be directly nested in external modules or ambient module declarations."),Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context:N(2670,1,"Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambien_2670","Augmentations for the global scope should have 'declare' modifier unless they appear in already ambient context."),Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity:N(2671,1,"Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity_2671","Cannot augment module '{0}' because it resolves to a non-module entity."),Cannot_assign_a_0_constructor_type_to_a_1_constructor_type:N(2672,1,"Cannot_assign_a_0_constructor_type_to_a_1_constructor_type_2672","Cannot assign a '{0}' constructor type to a '{1}' constructor type."),Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration:N(2673,1,"Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration_2673","Constructor of class '{0}' is private and only accessible within the class declaration."),Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration:N(2674,1,"Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration_2674","Constructor of class '{0}' is protected and only accessible within the class declaration."),Cannot_extend_a_class_0_Class_constructor_is_marked_as_private:N(2675,1,"Cannot_extend_a_class_0_Class_constructor_is_marked_as_private_2675","Cannot extend a class '{0}'. Class constructor is marked as private."),Accessors_must_both_be_abstract_or_non_abstract:N(2676,1,"Accessors_must_both_be_abstract_or_non_abstract_2676","Accessors must both be abstract or non-abstract."),A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type:N(2677,1,"A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type_2677","A type predicate's type must be assignable to its parameter's type."),Type_0_is_not_comparable_to_type_1:N(2678,1,"Type_0_is_not_comparable_to_type_1_2678","Type '{0}' is not comparable to type '{1}'."),A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void:N(2679,1,"A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void_2679","A function that is called with the 'new' keyword cannot have a 'this' type that is 'void'."),A_0_parameter_must_be_the_first_parameter:N(2680,1,"A_0_parameter_must_be_the_first_parameter_2680","A '{0}' parameter must be the first parameter."),A_constructor_cannot_have_a_this_parameter:N(2681,1,"A_constructor_cannot_have_a_this_parameter_2681","A constructor cannot have a 'this' parameter."),this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation:N(2683,1,"this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_2683","'this' implicitly has type 'any' because it does not have a type annotation."),The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1:N(2684,1,"The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1_2684","The 'this' context of type '{0}' is not assignable to method's 'this' of type '{1}'."),The_this_types_of_each_signature_are_incompatible:N(2685,1,"The_this_types_of_each_signature_are_incompatible_2685","The 'this' types of each signature are incompatible."),_0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead:N(2686,1,"_0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead_2686","'{0}' refers to a UMD global, but the current file is a module. Consider adding an import instead."),All_declarations_of_0_must_have_identical_modifiers:N(2687,1,"All_declarations_of_0_must_have_identical_modifiers_2687","All declarations of '{0}' must have identical modifiers."),Cannot_find_type_definition_file_for_0:N(2688,1,"Cannot_find_type_definition_file_for_0_2688","Cannot find type definition file for '{0}'."),Cannot_extend_an_interface_0_Did_you_mean_implements:N(2689,1,"Cannot_extend_an_interface_0_Did_you_mean_implements_2689","Cannot extend an interface '{0}'. Did you mean 'implements'?"),_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0:N(2690,1,"_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0_2690","'{0}' only refers to a type, but is being used as a value here. Did you mean to use '{1} in {0}'?"),_0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible:N(2692,1,"_0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible_2692","'{0}' is a primitive, but '{1}' is a wrapper object. Prefer using '{0}' when possible."),_0_only_refers_to_a_type_but_is_being_used_as_a_value_here:N(2693,1,"_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_2693","'{0}' only refers to a type, but is being used as a value here."),Namespace_0_has_no_exported_member_1:N(2694,1,"Namespace_0_has_no_exported_member_1_2694","Namespace '{0}' has no exported member '{1}'."),Left_side_of_comma_operator_is_unused_and_has_no_side_effects:N(2695,1,"Left_side_of_comma_operator_is_unused_and_has_no_side_effects_2695","Left side of comma operator is unused and has no side effects.",!0),The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead:N(2696,1,"The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead_2696","The 'Object' type is assignable to very few other types. Did you mean to use the 'any' type instead?"),An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option:N(2697,1,"An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_in_2697","An async function or method must return a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your '--lib' option."),Spread_types_may_only_be_created_from_object_types:N(2698,1,"Spread_types_may_only_be_created_from_object_types_2698","Spread types may only be created from object types."),Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1:N(2699,1,"Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1_2699","Static property '{0}' conflicts with built-in property 'Function.{0}' of constructor function '{1}'."),Rest_types_may_only_be_created_from_object_types:N(2700,1,"Rest_types_may_only_be_created_from_object_types_2700","Rest types may only be created from object types."),The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access:N(2701,1,"The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access_2701","The target of an object rest assignment must be a variable or a property access."),_0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here:N(2702,1,"_0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here_2702","'{0}' only refers to a type, but is being used as a namespace here."),The_operand_of_a_delete_operator_must_be_a_property_reference:N(2703,1,"The_operand_of_a_delete_operator_must_be_a_property_reference_2703","The operand of a 'delete' operator must be a property reference."),The_operand_of_a_delete_operator_cannot_be_a_read_only_property:N(2704,1,"The_operand_of_a_delete_operator_cannot_be_a_read_only_property_2704","The operand of a 'delete' operator cannot be a read-only property."),An_async_function_or_method_in_ES5_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option:N(2705,1,"An_async_function_or_method_in_ES5_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_2705","An async function or method in ES5 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your '--lib' option."),Required_type_parameters_may_not_follow_optional_type_parameters:N(2706,1,"Required_type_parameters_may_not_follow_optional_type_parameters_2706","Required type parameters may not follow optional type parameters."),Generic_type_0_requires_between_1_and_2_type_arguments:N(2707,1,"Generic_type_0_requires_between_1_and_2_type_arguments_2707","Generic type '{0}' requires between {1} and {2} type arguments."),Cannot_use_namespace_0_as_a_value:N(2708,1,"Cannot_use_namespace_0_as_a_value_2708","Cannot use namespace '{0}' as a value."),Cannot_use_namespace_0_as_a_type:N(2709,1,"Cannot_use_namespace_0_as_a_type_2709","Cannot use namespace '{0}' as a type."),_0_are_specified_twice_The_attribute_named_0_will_be_overwritten:N(2710,1,"_0_are_specified_twice_The_attribute_named_0_will_be_overwritten_2710","'{0}' are specified twice. The attribute named '{0}' will be overwritten."),A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option:N(2711,1,"A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES20_2711","A dynamic import call returns a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your '--lib' option."),A_dynamic_import_call_in_ES5_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option:N(2712,1,"A_dynamic_import_call_in_ES5_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_t_2712","A dynamic import call in ES5 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your '--lib' option."),Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1:N(2713,1,"Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_p_2713",`Cannot access '{0}.{1}' because '{0}' is a type, but not a namespace. Did you mean to retrieve the type of the property '{1}' in '{0}' with '{0}["{1}"]'?`),The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context:N(2714,1,"The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context_2714","The expression of an export assignment must be an identifier or qualified name in an ambient context."),Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor:N(2715,1,"Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor_2715","Abstract property '{0}' in class '{1}' cannot be accessed in the constructor."),Type_parameter_0_has_a_circular_default:N(2716,1,"Type_parameter_0_has_a_circular_default_2716","Type parameter '{0}' has a circular default."),Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2:N(2717,1,"Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_t_2717","Subsequent property declarations must have the same type.  Property '{0}' must be of type '{1}', but here has type '{2}'."),Duplicate_property_0:N(2718,1,"Duplicate_property_0_2718","Duplicate property '{0}'."),Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated:N(2719,1,"Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated_2719","Type '{0}' is not assignable to type '{1}'. Two different types with this name exist, but they are unrelated."),Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass:N(2720,1,"Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclas_2720","Class '{0}' incorrectly implements class '{1}'. Did you mean to extend '{1}' and inherit its members as a subclass?"),Cannot_invoke_an_object_which_is_possibly_null:N(2721,1,"Cannot_invoke_an_object_which_is_possibly_null_2721","Cannot invoke an object which is possibly 'null'."),Cannot_invoke_an_object_which_is_possibly_undefined:N(2722,1,"Cannot_invoke_an_object_which_is_possibly_undefined_2722","Cannot invoke an object which is possibly 'undefined'."),Cannot_invoke_an_object_which_is_possibly_null_or_undefined:N(2723,1,"Cannot_invoke_an_object_which_is_possibly_null_or_undefined_2723","Cannot invoke an object which is possibly 'null' or 'undefined'."),_0_has_no_exported_member_named_1_Did_you_mean_2:N(2724,1,"_0_has_no_exported_member_named_1_Did_you_mean_2_2724","'{0}' has no exported member named '{1}'. Did you mean '{2}'?"),Class_name_cannot_be_Object_when_targeting_ES5_with_module_0:N(2725,1,"Class_name_cannot_be_Object_when_targeting_ES5_with_module_0_2725","Class name cannot be 'Object' when targeting ES5 with module {0}."),Cannot_find_lib_definition_for_0:N(2726,1,"Cannot_find_lib_definition_for_0_2726","Cannot find lib definition for '{0}'."),Cannot_find_lib_definition_for_0_Did_you_mean_1:N(2727,1,"Cannot_find_lib_definition_for_0_Did_you_mean_1_2727","Cannot find lib definition for '{0}'. Did you mean '{1}'?"),_0_is_declared_here:N(2728,3,"_0_is_declared_here_2728","'{0}' is declared here."),Property_0_is_used_before_its_initialization:N(2729,1,"Property_0_is_used_before_its_initialization_2729","Property '{0}' is used before its initialization."),An_arrow_function_cannot_have_a_this_parameter:N(2730,1,"An_arrow_function_cannot_have_a_this_parameter_2730","An arrow function cannot have a 'this' parameter."),Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String:N(2731,1,"Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_i_2731","Implicit conversion of a 'symbol' to a 'string' will fail at runtime. Consider wrapping this expression in 'String(...)'."),Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension:N(2732,1,"Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension_2732","Cannot find module '{0}'. Consider using '--resolveJsonModule' to import module with '.json' extension."),Property_0_was_also_declared_here:N(2733,1,"Property_0_was_also_declared_here_2733","Property '{0}' was also declared here."),Are_you_missing_a_semicolon:N(2734,1,"Are_you_missing_a_semicolon_2734","Are you missing a semicolon?"),Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1:N(2735,1,"Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1_2735","Did you mean for '{0}' to be constrained to type 'new (...args: any[]) => {1}'?"),Operator_0_cannot_be_applied_to_type_1:N(2736,1,"Operator_0_cannot_be_applied_to_type_1_2736","Operator '{0}' cannot be applied to type '{1}'."),BigInt_literals_are_not_available_when_targeting_lower_than_ES2020:N(2737,1,"BigInt_literals_are_not_available_when_targeting_lower_than_ES2020_2737","BigInt literals are not available when targeting lower than ES2020."),An_outer_value_of_this_is_shadowed_by_this_container:N(2738,3,"An_outer_value_of_this_is_shadowed_by_this_container_2738","An outer value of 'this' is shadowed by this container."),Type_0_is_missing_the_following_properties_from_type_1_Colon_2:N(2739,1,"Type_0_is_missing_the_following_properties_from_type_1_Colon_2_2739","Type '{0}' is missing the following properties from type '{1}': {2}"),Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more:N(2740,1,"Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more_2740","Type '{0}' is missing the following properties from type '{1}': {2}, and {3} more."),Property_0_is_missing_in_type_1_but_required_in_type_2:N(2741,1,"Property_0_is_missing_in_type_1_but_required_in_type_2_2741","Property '{0}' is missing in type '{1}' but required in type '{2}'."),The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary:N(2742,1,"The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_a_2742","The inferred type of '{0}' cannot be named without a reference to '{1}'. This is likely not portable. A type annotation is necessary."),No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments:N(2743,1,"No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments_2743","No overload expects {0} type arguments, but overloads do exist that expect either {1} or {2} type arguments."),Type_parameter_defaults_can_only_reference_previously_declared_type_parameters:N(2744,1,"Type_parameter_defaults_can_only_reference_previously_declared_type_parameters_2744","Type parameter defaults can only reference previously declared type parameters."),This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided:N(2745,1,"This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_pr_2745","This JSX tag's '{0}' prop expects type '{1}' which requires multiple children, but only a single child was provided."),This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided:N(2746,1,"This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided_2746","This JSX tag's '{0}' prop expects a single child of type '{1}', but multiple children were provided."),_0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2:N(2747,1,"_0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_t_2747","'{0}' components don't accept text as child elements. Text in JSX has the type 'string', but the expected type of '{1}' is '{2}'."),Cannot_access_ambient_const_enums_when_0_is_enabled:N(2748,1,"Cannot_access_ambient_const_enums_when_0_is_enabled_2748","Cannot access ambient const enums when '{0}' is enabled."),_0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0:N(2749,1,"_0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0_2749","'{0}' refers to a value, but is being used as a type here. Did you mean 'typeof {0}'?"),The_implementation_signature_is_declared_here:N(2750,1,"The_implementation_signature_is_declared_here_2750","The implementation signature is declared here."),Circularity_originates_in_type_at_this_location:N(2751,1,"Circularity_originates_in_type_at_this_location_2751","Circularity originates in type at this location."),The_first_export_default_is_here:N(2752,1,"The_first_export_default_is_here_2752","The first export default is here."),Another_export_default_is_here:N(2753,1,"Another_export_default_is_here_2753","Another export default is here."),super_may_not_use_type_arguments:N(2754,1,"super_may_not_use_type_arguments_2754","'super' may not use type arguments."),No_constituent_of_type_0_is_callable:N(2755,1,"No_constituent_of_type_0_is_callable_2755","No constituent of type '{0}' is callable."),Not_all_constituents_of_type_0_are_callable:N(2756,1,"Not_all_constituents_of_type_0_are_callable_2756","Not all constituents of type '{0}' are callable."),Type_0_has_no_call_signatures:N(2757,1,"Type_0_has_no_call_signatures_2757","Type '{0}' has no call signatures."),Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_other:N(2758,1,"Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_2758","Each member of the union type '{0}' has signatures, but none of those signatures are compatible with each other."),No_constituent_of_type_0_is_constructable:N(2759,1,"No_constituent_of_type_0_is_constructable_2759","No constituent of type '{0}' is constructable."),Not_all_constituents_of_type_0_are_constructable:N(2760,1,"Not_all_constituents_of_type_0_are_constructable_2760","Not all constituents of type '{0}' are constructable."),Type_0_has_no_construct_signatures:N(2761,1,"Type_0_has_no_construct_signatures_2761","Type '{0}' has no construct signatures."),Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_with_each_other:N(2762,1,"Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_2762","Each member of the union type '{0}' has construct signatures, but none of those signatures are compatible with each other."),Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_send_0:N(2763,1,"Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_s_2763","Cannot iterate value because the 'next' method of its iterator expects type '{1}', but for-of will always send '{0}'."),Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_always_send_0:N(2764,1,"Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_al_2764","Cannot iterate value because the 'next' method of its iterator expects type '{1}', but array spread will always send '{0}'."),Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring_will_always_send_0:N(2765,1,"Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring__2765","Cannot iterate value because the 'next' method of its iterator expects type '{1}', but array destructuring will always send '{0}'."),Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_containing_generator_will_always_send_0:N(2766,1,"Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_co_2766","Cannot delegate iteration to value because the 'next' method of its iterator expects type '{1}', but the containing generator will always send '{0}'."),The_0_property_of_an_iterator_must_be_a_method:N(2767,1,"The_0_property_of_an_iterator_must_be_a_method_2767","The '{0}' property of an iterator must be a method."),The_0_property_of_an_async_iterator_must_be_a_method:N(2768,1,"The_0_property_of_an_async_iterator_must_be_a_method_2768","The '{0}' property of an async iterator must be a method."),No_overload_matches_this_call:N(2769,1,"No_overload_matches_this_call_2769","No overload matches this call."),The_last_overload_gave_the_following_error:N(2770,1,"The_last_overload_gave_the_following_error_2770","The last overload gave the following error."),The_last_overload_is_declared_here:N(2771,1,"The_last_overload_is_declared_here_2771","The last overload is declared here."),Overload_0_of_1_2_gave_the_following_error:N(2772,1,"Overload_0_of_1_2_gave_the_following_error_2772","Overload {0} of {1}, '{2}', gave the following error."),Did_you_forget_to_use_await:N(2773,1,"Did_you_forget_to_use_await_2773","Did you forget to use 'await'?"),This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead:N(2774,1,"This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_2774","This condition will always return true since this function is always defined. Did you mean to call it instead?"),Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation:N(2775,1,"Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation_2775","Assertions require every name in the call target to be declared with an explicit type annotation."),Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name:N(2776,1,"Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name_2776","Assertions require the call target to be an identifier or qualified name."),The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access:N(2777,1,"The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access_2777","The operand of an increment or decrement operator may not be an optional property access."),The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access:N(2778,1,"The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access_2778","The target of an object rest assignment may not be an optional property access."),The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access:N(2779,1,"The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access_2779","The left-hand side of an assignment expression may not be an optional property access."),The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access:N(2780,1,"The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access_2780","The left-hand side of a 'for...in' statement may not be an optional property access."),The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access:N(2781,1,"The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access_2781","The left-hand side of a 'for...of' statement may not be an optional property access."),_0_needs_an_explicit_type_annotation:N(2782,3,"_0_needs_an_explicit_type_annotation_2782","'{0}' needs an explicit type annotation."),_0_is_specified_more_than_once_so_this_usage_will_be_overwritten:N(2783,1,"_0_is_specified_more_than_once_so_this_usage_will_be_overwritten_2783","'{0}' is specified more than once, so this usage will be overwritten."),get_and_set_accessors_cannot_declare_this_parameters:N(2784,1,"get_and_set_accessors_cannot_declare_this_parameters_2784","'get' and 'set' accessors cannot declare 'this' parameters."),This_spread_always_overwrites_this_property:N(2785,1,"This_spread_always_overwrites_this_property_2785","This spread always overwrites this property."),_0_cannot_be_used_as_a_JSX_component:N(2786,1,"_0_cannot_be_used_as_a_JSX_component_2786","'{0}' cannot be used as a JSX component."),Its_return_type_0_is_not_a_valid_JSX_element:N(2787,1,"Its_return_type_0_is_not_a_valid_JSX_element_2787","Its return type '{0}' is not a valid JSX element."),Its_instance_type_0_is_not_a_valid_JSX_element:N(2788,1,"Its_instance_type_0_is_not_a_valid_JSX_element_2788","Its instance type '{0}' is not a valid JSX element."),Its_element_type_0_is_not_a_valid_JSX_element:N(2789,1,"Its_element_type_0_is_not_a_valid_JSX_element_2789","Its element type '{0}' is not a valid JSX element."),The_operand_of_a_delete_operator_must_be_optional:N(2790,1,"The_operand_of_a_delete_operator_must_be_optional_2790","The operand of a 'delete' operator must be optional."),Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_later:N(2791,1,"Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_lat_2791","Exponentiation cannot be performed on 'bigint' values unless the 'target' option is set to 'es2016' or later."),Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_nodenext_or_to_add_aliases_to_the_paths_option:N(2792,1,"Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_nodenext_or_to_add_aliases_t_2792","Cannot find module '{0}'. Did you mean to set the 'moduleResolution' option to 'nodenext', or to add aliases to the 'paths' option?"),The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_are_not_externally_visible:N(2793,1,"The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_2793","The call would have succeeded against this implementation, but implementation signatures of overloads are not externally visible."),Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise:N(2794,1,"Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise_2794","Expected {0} arguments, but got {1}. Did you forget to include 'void' in your type argument to 'Promise'?"),The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types:N(2795,1,"The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types_2795","The 'intrinsic' keyword can only be used to declare compiler provided intrinsic types."),It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tagged_template_expression_which_cannot_be_invoked:N(2796,1,"It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tag_2796","It is likely that you are missing a comma to separate these two template expressions. They form a tagged template expression which cannot be invoked."),A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_be_declared_abstract:N(2797,1,"A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_2797","A mixin class that extends from a type variable containing an abstract construct signature must also be declared 'abstract'."),The_declaration_was_marked_as_deprecated_here:N(2798,1,"The_declaration_was_marked_as_deprecated_here_2798","The declaration was marked as deprecated here."),Type_produces_a_tuple_type_that_is_too_large_to_represent:N(2799,1,"Type_produces_a_tuple_type_that_is_too_large_to_represent_2799","Type produces a tuple type that is too large to represent."),Expression_produces_a_tuple_type_that_is_too_large_to_represent:N(2800,1,"Expression_produces_a_tuple_type_that_is_too_large_to_represent_2800","Expression produces a tuple type that is too large to represent."),This_condition_will_always_return_true_since_this_0_is_always_defined:N(2801,1,"This_condition_will_always_return_true_since_this_0_is_always_defined_2801","This condition will always return true since this '{0}' is always defined."),Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher:N(2802,1,"Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es201_2802","Type '{0}' can only be iterated through when using the '--downlevelIteration' flag or with a '--target' of 'es2015' or higher."),Cannot_assign_to_private_method_0_Private_methods_are_not_writable:N(2803,1,"Cannot_assign_to_private_method_0_Private_methods_are_not_writable_2803","Cannot assign to private method '{0}'. Private methods are not writable."),Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name:N(2804,1,"Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name_2804","Duplicate identifier '{0}'. Static and instance elements cannot share the same private name."),Private_accessor_was_defined_without_a_getter:N(2806,1,"Private_accessor_was_defined_without_a_getter_2806","Private accessor was defined without a getter."),This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0:N(2807,1,"This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_o_2807","This syntax requires an imported helper named '{1}' with {2} parameters, which is not compatible with the one in '{0}'. Consider upgrading your version of '{0}'."),A_get_accessor_must_be_at_least_as_accessible_as_the_setter:N(2808,1,"A_get_accessor_must_be_at_least_as_accessible_as_the_setter_2808","A get accessor must be at least as accessible as the setter"),Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_destructuring_assignment_you_might_need_to_wrap_the_whole_assignment_in_parentheses:N(2809,1,"Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_d_2809","Declaration or statement expected. This '=' follows a block of statements, so if you intended to write a destructuring assignment, you might need to wrap the whole assignment in parentheses."),Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments:N(2810,1,"Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_2810","Expected 1 argument, but got 0. 'new Promise()' needs a JSDoc hint to produce a 'resolve' that can be called without arguments."),Initializer_for_property_0:N(2811,1,"Initializer_for_property_0_2811","Initializer for property '{0}'"),Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom:N(2812,1,"Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom_2812","Property '{0}' does not exist on type '{1}'. Try changing the 'lib' compiler option to include 'dom'."),Class_declaration_cannot_implement_overload_list_for_0:N(2813,1,"Class_declaration_cannot_implement_overload_list_for_0_2813","Class declaration cannot implement overload list for '{0}'."),Function_with_bodies_can_only_merge_with_classes_that_are_ambient:N(2814,1,"Function_with_bodies_can_only_merge_with_classes_that_are_ambient_2814","Function with bodies can only merge with classes that are ambient."),arguments_cannot_be_referenced_in_property_initializers:N(2815,1,"arguments_cannot_be_referenced_in_property_initializers_2815","'arguments' cannot be referenced in property initializers."),Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class:N(2816,1,"Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class_2816","Cannot use 'this' in a static property initializer of a decorated class."),Property_0_has_no_initializer_and_is_not_definitely_assigned_in_a_class_static_block:N(2817,1,"Property_0_has_no_initializer_and_is_not_definitely_assigned_in_a_class_static_block_2817","Property '{0}' has no initializer and is not definitely assigned in a class static block."),Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializers:N(2818,1,"Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializer_2818","Duplicate identifier '{0}'. Compiler reserves name '{1}' when emitting 'super' references in static initializers."),Namespace_name_cannot_be_0:N(2819,1,"Namespace_name_cannot_be_0_2819","Namespace name cannot be '{0}'."),Type_0_is_not_assignable_to_type_1_Did_you_mean_2:N(2820,1,"Type_0_is_not_assignable_to_type_1_Did_you_mean_2_2820","Type '{0}' is not assignable to type '{1}'. Did you mean '{2}'?"),Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve:N(2821,1,"Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve_2821","Import assertions are only supported when the '--module' option is set to 'esnext', 'nodenext', or 'preserve'."),Import_assertions_cannot_be_used_with_type_only_imports_or_exports:N(2822,1,"Import_assertions_cannot_be_used_with_type_only_imports_or_exports_2822","Import assertions cannot be used with type-only imports or exports."),Import_attributes_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve:N(2823,1,"Import_attributes_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve_2823","Import attributes are only supported when the '--module' option is set to 'esnext', 'nodenext', or 'preserve'."),Cannot_find_namespace_0_Did_you_mean_1:N(2833,1,"Cannot_find_namespace_0_Did_you_mean_1_2833","Cannot find namespace '{0}'. Did you mean '{1}'?"),Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_node16_or_nodenext_Consider_adding_an_extension_to_the_import_path:N(2834,1,"Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_n_2834","Relative import paths need explicit file extensions in ECMAScript imports when '--moduleResolution' is 'node16' or 'nodenext'. Consider adding an extension to the import path."),Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_node16_or_nodenext_Did_you_mean_0:N(2835,1,"Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_n_2835","Relative import paths need explicit file extensions in ECMAScript imports when '--moduleResolution' is 'node16' or 'nodenext'. Did you mean '{0}'?"),Import_assertions_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls:N(2836,1,"Import_assertions_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls_2836","Import assertions are not allowed on statements that compile to CommonJS 'require' calls."),Import_assertion_values_must_be_string_literal_expressions:N(2837,1,"Import_assertion_values_must_be_string_literal_expressions_2837","Import assertion values must be string literal expressions."),All_declarations_of_0_must_have_identical_constraints:N(2838,1,"All_declarations_of_0_must_have_identical_constraints_2838","All declarations of '{0}' must have identical constraints."),This_condition_will_always_return_0_since_JavaScript_compares_objects_by_reference_not_value:N(2839,1,"This_condition_will_always_return_0_since_JavaScript_compares_objects_by_reference_not_value_2839","This condition will always return '{0}' since JavaScript compares objects by reference, not value."),An_interface_cannot_extend_a_primitive_type_like_0_It_can_only_extend_other_named_object_types:N(2840,1,"An_interface_cannot_extend_a_primitive_type_like_0_It_can_only_extend_other_named_object_types_2840","An interface cannot extend a primitive type like '{0}'. It can only extend other named object types."),_0_is_an_unused_renaming_of_1_Did_you_intend_to_use_it_as_a_type_annotation:N(2842,1,"_0_is_an_unused_renaming_of_1_Did_you_intend_to_use_it_as_a_type_annotation_2842","'{0}' is an unused renaming of '{1}'. Did you intend to use it as a type annotation?"),We_can_only_write_a_type_for_0_by_adding_a_type_for_the_entire_parameter_here:N(2843,1,"We_can_only_write_a_type_for_0_by_adding_a_type_for_the_entire_parameter_here_2843","We can only write a type for '{0}' by adding a type for the entire parameter here."),Type_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor:N(2844,1,"Type_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor_2844","Type of instance member variable '{0}' cannot reference identifier '{1}' declared in the constructor."),This_condition_will_always_return_0:N(2845,1,"This_condition_will_always_return_0_2845","This condition will always return '{0}'."),A_declaration_file_cannot_be_imported_without_import_type_Did_you_mean_to_import_an_implementation_file_0_instead:N(2846,1,"A_declaration_file_cannot_be_imported_without_import_type_Did_you_mean_to_import_an_implementation_f_2846","A declaration file cannot be imported without 'import type'. Did you mean to import an implementation file '{0}' instead?"),The_right_hand_side_of_an_instanceof_expression_must_not_be_an_instantiation_expression:N(2848,1,"The_right_hand_side_of_an_instanceof_expression_must_not_be_an_instantiation_expression_2848","The right-hand side of an 'instanceof' expression must not be an instantiation expression."),Target_signature_provides_too_few_arguments_Expected_0_or_more_but_got_1:N(2849,1,"Target_signature_provides_too_few_arguments_Expected_0_or_more_but_got_1_2849","Target signature provides too few arguments. Expected {0} or more, but got {1}."),The_initializer_of_a_using_declaration_must_be_either_an_object_with_a_Symbol_dispose_method_or_be_null_or_undefined:N(2850,1,"The_initializer_of_a_using_declaration_must_be_either_an_object_with_a_Symbol_dispose_method_or_be_n_2850","The initializer of a 'using' declaration must be either an object with a '[Symbol.dispose]()' method, or be 'null' or 'undefined'."),The_initializer_of_an_await_using_declaration_must_be_either_an_object_with_a_Symbol_asyncDispose_or_Symbol_dispose_method_or_be_null_or_undefined:N(2851,1,"The_initializer_of_an_await_using_declaration_must_be_either_an_object_with_a_Symbol_asyncDispose_or_2851","The initializer of an 'await using' declaration must be either an object with a '[Symbol.asyncDispose]()' or '[Symbol.dispose]()' method, or be 'null' or 'undefined'."),await_using_statements_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules:N(2852,1,"await_using_statements_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_2852","'await using' statements are only allowed within async functions and at the top levels of modules."),await_using_statements_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module:N(2853,1,"await_using_statements_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_th_2853","'await using' statements are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."),Top_level_await_using_statements_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher:N(2854,1,"Top_level_await_using_statements_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_sys_2854","Top-level 'await using' statements are only allowed when the 'module' option is set to 'es2022', 'esnext', 'system', 'node16', 'nodenext', or 'preserve', and the 'target' option is set to 'es2017' or higher."),Class_field_0_defined_by_the_parent_class_is_not_accessible_in_the_child_class_via_super:N(2855,1,"Class_field_0_defined_by_the_parent_class_is_not_accessible_in_the_child_class_via_super_2855","Class field '{0}' defined by the parent class is not accessible in the child class via super."),Import_attributes_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls:N(2856,1,"Import_attributes_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls_2856","Import attributes are not allowed on statements that compile to CommonJS 'require' calls."),Import_attributes_cannot_be_used_with_type_only_imports_or_exports:N(2857,1,"Import_attributes_cannot_be_used_with_type_only_imports_or_exports_2857","Import attributes cannot be used with type-only imports or exports."),Import_attribute_values_must_be_string_literal_expressions:N(2858,1,"Import_attribute_values_must_be_string_literal_expressions_2858","Import attribute values must be string literal expressions."),Excessive_complexity_comparing_types_0_and_1:N(2859,1,"Excessive_complexity_comparing_types_0_and_1_2859","Excessive complexity comparing types '{0}' and '{1}'."),The_left_hand_side_of_an_instanceof_expression_must_be_assignable_to_the_first_argument_of_the_right_hand_side_s_Symbol_hasInstance_method:N(2860,1,"The_left_hand_side_of_an_instanceof_expression_must_be_assignable_to_the_first_argument_of_the_right_2860","The left-hand side of an 'instanceof' expression must be assignable to the first argument of the right-hand side's '[Symbol.hasInstance]' method."),An_object_s_Symbol_hasInstance_method_must_return_a_boolean_value_for_it_to_be_used_on_the_right_hand_side_of_an_instanceof_expression:N(2861,1,"An_object_s_Symbol_hasInstance_method_must_return_a_boolean_value_for_it_to_be_used_on_the_right_han_2861","An object's '[Symbol.hasInstance]' method must return a boolean value for it to be used on the right-hand side of an 'instanceof' expression."),Type_0_is_generic_and_can_only_be_indexed_for_reading:N(2862,1,"Type_0_is_generic_and_can_only_be_indexed_for_reading_2862","Type '{0}' is generic and can only be indexed for reading."),A_class_cannot_extend_a_primitive_type_like_0_Classes_can_only_extend_constructable_values:N(2863,1,"A_class_cannot_extend_a_primitive_type_like_0_Classes_can_only_extend_constructable_values_2863","A class cannot extend a primitive type like '{0}'. Classes can only extend constructable values."),A_class_cannot_implement_a_primitive_type_like_0_It_can_only_implement_other_named_object_types:N(2864,1,"A_class_cannot_implement_a_primitive_type_like_0_It_can_only_implement_other_named_object_types_2864","A class cannot implement a primitive type like '{0}'. It can only implement other named object types."),Import_0_conflicts_with_local_value_so_must_be_declared_with_a_type_only_import_when_isolatedModules_is_enabled:N(2865,1,"Import_0_conflicts_with_local_value_so_must_be_declared_with_a_type_only_import_when_isolatedModules_2865","Import '{0}' conflicts with local value, so must be declared with a type-only import when 'isolatedModules' is enabled."),Import_0_conflicts_with_global_value_used_in_this_file_so_must_be_declared_with_a_type_only_import_when_isolatedModules_is_enabled:N(2866,1,"Import_0_conflicts_with_global_value_used_in_this_file_so_must_be_declared_with_a_type_only_import_w_2866","Import '{0}' conflicts with global value used in this file, so must be declared with a type-only import when 'isolatedModules' is enabled."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun:N(2867,1,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun_2867","Cannot find name '{0}'. Do you need to install type definitions for Bun? Try `npm i --save-dev @types/bun`."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun_and_then_add_bun_to_the_types_field_in_your_tsconfig:N(2868,1,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun_2868","Cannot find name '{0}'. Do you need to install type definitions for Bun? Try `npm i --save-dev @types/bun` and then add 'bun' to the types field in your tsconfig."),Import_declaration_0_is_using_private_name_1:N(4e3,1,"Import_declaration_0_is_using_private_name_1_4000","Import declaration '{0}' is using private name '{1}'."),Type_parameter_0_of_exported_class_has_or_is_using_private_name_1:N(4002,1,"Type_parameter_0_of_exported_class_has_or_is_using_private_name_1_4002","Type parameter '{0}' of exported class has or is using private name '{1}'."),Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1:N(4004,1,"Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1_4004","Type parameter '{0}' of exported interface has or is using private name '{1}'."),Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1:N(4006,1,"Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4006","Type parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."),Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1:N(4008,1,"Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4008","Type parameter '{0}' of call signature from exported interface has or is using private name '{1}'."),Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:N(4010,1,"Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4010","Type parameter '{0}' of public static method from exported class has or is using private name '{1}'."),Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:N(4012,1,"Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4012","Type parameter '{0}' of public method from exported class has or is using private name '{1}'."),Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1:N(4014,1,"Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4014","Type parameter '{0}' of method from exported interface has or is using private name '{1}'."),Type_parameter_0_of_exported_function_has_or_is_using_private_name_1:N(4016,1,"Type_parameter_0_of_exported_function_has_or_is_using_private_name_1_4016","Type parameter '{0}' of exported function has or is using private name '{1}'."),Implements_clause_of_exported_class_0_has_or_is_using_private_name_1:N(4019,1,"Implements_clause_of_exported_class_0_has_or_is_using_private_name_1_4019","Implements clause of exported class '{0}' has or is using private name '{1}'."),extends_clause_of_exported_class_0_has_or_is_using_private_name_1:N(4020,1,"extends_clause_of_exported_class_0_has_or_is_using_private_name_1_4020","'extends' clause of exported class '{0}' has or is using private name '{1}'."),extends_clause_of_exported_class_has_or_is_using_private_name_0:N(4021,1,"extends_clause_of_exported_class_has_or_is_using_private_name_0_4021","'extends' clause of exported class has or is using private name '{0}'."),extends_clause_of_exported_interface_0_has_or_is_using_private_name_1:N(4022,1,"extends_clause_of_exported_interface_0_has_or_is_using_private_name_1_4022","'extends' clause of exported interface '{0}' has or is using private name '{1}'."),Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:N(4023,1,"Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4023","Exported variable '{0}' has or is using name '{1}' from external module {2} but cannot be named."),Exported_variable_0_has_or_is_using_name_1_from_private_module_2:N(4024,1,"Exported_variable_0_has_or_is_using_name_1_from_private_module_2_4024","Exported variable '{0}' has or is using name '{1}' from private module '{2}'."),Exported_variable_0_has_or_is_using_private_name_1:N(4025,1,"Exported_variable_0_has_or_is_using_private_name_1_4025","Exported variable '{0}' has or is using private name '{1}'."),Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:N(4026,1,"Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot__4026","Public static property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:N(4027,1,"Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4027","Public static property '{0}' of exported class has or is using name '{1}' from private module '{2}'."),Public_static_property_0_of_exported_class_has_or_is_using_private_name_1:N(4028,1,"Public_static_property_0_of_exported_class_has_or_is_using_private_name_1_4028","Public static property '{0}' of exported class has or is using private name '{1}'."),Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:N(4029,1,"Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_name_4029","Public property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:N(4030,1,"Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4030","Public property '{0}' of exported class has or is using name '{1}' from private module '{2}'."),Public_property_0_of_exported_class_has_or_is_using_private_name_1:N(4031,1,"Public_property_0_of_exported_class_has_or_is_using_private_name_1_4031","Public property '{0}' of exported class has or is using private name '{1}'."),Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:N(4032,1,"Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4032","Property '{0}' of exported interface has or is using name '{1}' from private module '{2}'."),Property_0_of_exported_interface_has_or_is_using_private_name_1:N(4033,1,"Property_0_of_exported_interface_has_or_is_using_private_name_1_4033","Property '{0}' of exported interface has or is using private name '{1}'."),Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:N(4034,1,"Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_mod_4034","Parameter type of public static setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1:N(4035,1,"Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1_4035","Parameter type of public static setter '{0}' from exported class has or is using private name '{1}'."),Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:N(4036,1,"Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4036","Parameter type of public setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1:N(4037,1,"Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1_4037","Parameter type of public setter '{0}' from exported class has or is using private name '{1}'."),Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:N(4038,1,"Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_modul_4038","Return type of public static getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."),Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:N(4039,1,"Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_4039","Return type of public static getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1:N(4040,1,"Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1_4040","Return type of public static getter '{0}' from exported class has or is using private name '{1}'."),Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:N(4041,1,"Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_4041","Return type of public getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."),Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:N(4042,1,"Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4042","Return type of public getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1:N(4043,1,"Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1_4043","Return type of public getter '{0}' from exported class has or is using private name '{1}'."),Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:N(4044,1,"Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_mod_4044","Return type of constructor signature from exported interface has or is using name '{0}' from private module '{1}'."),Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0:N(4045,1,"Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0_4045","Return type of constructor signature from exported interface has or is using private name '{0}'."),Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:N(4046,1,"Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4046","Return type of call signature from exported interface has or is using name '{0}' from private module '{1}'."),Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0:N(4047,1,"Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0_4047","Return type of call signature from exported interface has or is using private name '{0}'."),Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:N(4048,1,"Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4048","Return type of index signature from exported interface has or is using name '{0}' from private module '{1}'."),Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0:N(4049,1,"Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0_4049","Return type of index signature from exported interface has or is using private name '{0}'."),Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:N(4050,1,"Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module__4050","Return type of public static method from exported class has or is using name '{0}' from external module {1} but cannot be named."),Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:N(4051,1,"Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4051","Return type of public static method from exported class has or is using name '{0}' from private module '{1}'."),Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0:N(4052,1,"Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0_4052","Return type of public static method from exported class has or is using private name '{0}'."),Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:N(4053,1,"Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_c_4053","Return type of public method from exported class has or is using name '{0}' from external module {1} but cannot be named."),Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:N(4054,1,"Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4054","Return type of public method from exported class has or is using name '{0}' from private module '{1}'."),Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0:N(4055,1,"Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0_4055","Return type of public method from exported class has or is using private name '{0}'."),Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1:N(4056,1,"Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4056","Return type of method from exported interface has or is using name '{0}' from private module '{1}'."),Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0:N(4057,1,"Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0_4057","Return type of method from exported interface has or is using private name '{0}'."),Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:N(4058,1,"Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named_4058","Return type of exported function has or is using name '{0}' from external module {1} but cannot be named."),Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1:N(4059,1,"Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1_4059","Return type of exported function has or is using name '{0}' from private module '{1}'."),Return_type_of_exported_function_has_or_is_using_private_name_0:N(4060,1,"Return_type_of_exported_function_has_or_is_using_private_name_0_4060","Return type of exported function has or is using private name '{0}'."),Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:N(4061,1,"Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_can_4061","Parameter '{0}' of constructor from exported class has or is using name '{1}' from external module {2} but cannot be named."),Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2:N(4062,1,"Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2_4062","Parameter '{0}' of constructor from exported class has or is using name '{1}' from private module '{2}'."),Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1:N(4063,1,"Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1_4063","Parameter '{0}' of constructor from exported class has or is using private name '{1}'."),Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:N(4064,1,"Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_mod_4064","Parameter '{0}' of constructor signature from exported interface has or is using name '{1}' from private module '{2}'."),Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1:N(4065,1,"Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4065","Parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."),Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:N(4066,1,"Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4066","Parameter '{0}' of call signature from exported interface has or is using name '{1}' from private module '{2}'."),Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1:N(4067,1,"Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4067","Parameter '{0}' of call signature from exported interface has or is using private name '{1}'."),Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:N(4068,1,"Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module__4068","Parameter '{0}' of public static method from exported class has or is using name '{1}' from external module {2} but cannot be named."),Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:N(4069,1,"Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4069","Parameter '{0}' of public static method from exported class has or is using name '{1}' from private module '{2}'."),Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:N(4070,1,"Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4070","Parameter '{0}' of public static method from exported class has or is using private name '{1}'."),Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:N(4071,1,"Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_c_4071","Parameter '{0}' of public method from exported class has or is using name '{1}' from external module {2} but cannot be named."),Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:N(4072,1,"Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4072","Parameter '{0}' of public method from exported class has or is using name '{1}' from private module '{2}'."),Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:N(4073,1,"Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4073","Parameter '{0}' of public method from exported class has or is using private name '{1}'."),Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2:N(4074,1,"Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4074","Parameter '{0}' of method from exported interface has or is using name '{1}' from private module '{2}'."),Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1:N(4075,1,"Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4075","Parameter '{0}' of method from exported interface has or is using private name '{1}'."),Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:N(4076,1,"Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4076","Parameter '{0}' of exported function has or is using name '{1}' from external module {2} but cannot be named."),Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2:N(4077,1,"Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2_4077","Parameter '{0}' of exported function has or is using name '{1}' from private module '{2}'."),Parameter_0_of_exported_function_has_or_is_using_private_name_1:N(4078,1,"Parameter_0_of_exported_function_has_or_is_using_private_name_1_4078","Parameter '{0}' of exported function has or is using private name '{1}'."),Exported_type_alias_0_has_or_is_using_private_name_1:N(4081,1,"Exported_type_alias_0_has_or_is_using_private_name_1_4081","Exported type alias '{0}' has or is using private name '{1}'."),Default_export_of_the_module_has_or_is_using_private_name_0:N(4082,1,"Default_export_of_the_module_has_or_is_using_private_name_0_4082","Default export of the module has or is using private name '{0}'."),Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1:N(4083,1,"Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1_4083","Type parameter '{0}' of exported type alias has or is using private name '{1}'."),Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2:N(4084,1,"Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2_4084","Exported type alias '{0}' has or is using private name '{1}' from module {2}."),Extends_clause_for_inferred_type_0_has_or_is_using_private_name_1:N(4085,1,"Extends_clause_for_inferred_type_0_has_or_is_using_private_name_1_4085","Extends clause for inferred type '{0}' has or is using private name '{1}'."),Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:N(4091,1,"Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4091","Parameter '{0}' of index signature from exported interface has or is using name '{1}' from private module '{2}'."),Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1:N(4092,1,"Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1_4092","Parameter '{0}' of index signature from exported interface has or is using private name '{1}'."),Property_0_of_exported_class_expression_may_not_be_private_or_protected:N(4094,1,"Property_0_of_exported_class_expression_may_not_be_private_or_protected_4094","Property '{0}' of exported class expression may not be private or protected."),Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:N(4095,1,"Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_4095","Public static method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:N(4096,1,"Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4096","Public static method '{0}' of exported class has or is using name '{1}' from private module '{2}'."),Public_static_method_0_of_exported_class_has_or_is_using_private_name_1:N(4097,1,"Public_static_method_0_of_exported_class_has_or_is_using_private_name_1_4097","Public static method '{0}' of exported class has or is using private name '{1}'."),Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:N(4098,1,"Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4098","Public method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:N(4099,1,"Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4099","Public method '{0}' of exported class has or is using name '{1}' from private module '{2}'."),Public_method_0_of_exported_class_has_or_is_using_private_name_1:N(4100,1,"Public_method_0_of_exported_class_has_or_is_using_private_name_1_4100","Public method '{0}' of exported class has or is using private name '{1}'."),Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:N(4101,1,"Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4101","Method '{0}' of exported interface has or is using name '{1}' from private module '{2}'."),Method_0_of_exported_interface_has_or_is_using_private_name_1:N(4102,1,"Method_0_of_exported_interface_has_or_is_using_private_name_1_4102","Method '{0}' of exported interface has or is using private name '{1}'."),Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1:N(4103,1,"Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1_4103","Type parameter '{0}' of exported mapped object type is using private name '{1}'."),The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1:N(4104,1,"The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1_4104","The type '{0}' is 'readonly' and cannot be assigned to the mutable type '{1}'."),Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter:N(4105,1,"Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter_4105","Private or protected member '{0}' cannot be accessed on a type parameter."),Parameter_0_of_accessor_has_or_is_using_private_name_1:N(4106,1,"Parameter_0_of_accessor_has_or_is_using_private_name_1_4106","Parameter '{0}' of accessor has or is using private name '{1}'."),Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2:N(4107,1,"Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2_4107","Parameter '{0}' of accessor has or is using name '{1}' from private module '{2}'."),Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:N(4108,1,"Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4108","Parameter '{0}' of accessor has or is using name '{1}' from external module '{2}' but cannot be named."),Type_arguments_for_0_circularly_reference_themselves:N(4109,1,"Type_arguments_for_0_circularly_reference_themselves_4109","Type arguments for '{0}' circularly reference themselves."),Tuple_type_arguments_circularly_reference_themselves:N(4110,1,"Tuple_type_arguments_circularly_reference_themselves_4110","Tuple type arguments circularly reference themselves."),Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0:N(4111,1,"Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0_4111","Property '{0}' comes from an index signature, so it must be accessed with ['{0}']."),This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class:N(4112,1,"This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another__4112","This member cannot have an 'override' modifier because its containing class '{0}' does not extend another class."),This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0:N(4113,1,"This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_4113","This member cannot have an 'override' modifier because it is not declared in the base class '{0}'."),This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0:N(4114,1,"This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0_4114","This member must have an 'override' modifier because it overrides a member in the base class '{0}'."),This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0:N(4115,1,"This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0_4115","This parameter property must have an 'override' modifier because it overrides a member in base class '{0}'."),This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0:N(4116,1,"This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared__4116","This member must have an 'override' modifier because it overrides an abstract method that is declared in the base class '{0}'."),This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1:N(4117,1,"This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you__4117","This member cannot have an 'override' modifier because it is not declared in the base class '{0}'. Did you mean '{1}'?"),The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized:N(4118,1,"The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized_4118","The type of this node cannot be serialized because its property '{0}' cannot be serialized."),This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0:N(4119,1,"This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_4119","This member must have a JSDoc comment with an '@override' tag because it overrides a member in the base class '{0}'."),This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0:N(4120,1,"This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_4120","This parameter property must have a JSDoc comment with an '@override' tag because it overrides a member in the base class '{0}'."),This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class:N(4121,1,"This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_4121","This member cannot have a JSDoc comment with an '@override' tag because its containing class '{0}' does not extend another class."),This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0:N(4122,1,"This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base__4122","This member cannot have a JSDoc comment with an '@override' tag because it is not declared in the base class '{0}'."),This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1:N(4123,1,"This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base__4123","This member cannot have a JSDoc comment with an 'override' tag because it is not declared in the base class '{0}'. Did you mean '{1}'?"),Compiler_option_0_of_value_1_is_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next:N(4124,1,"Compiler_option_0_of_value_1_is_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_w_4124","Compiler option '{0}' of value '{1}' is unstable. Use nightly TypeScript to silence this error. Try updating with 'npm install -D typescript@next'."),Each_declaration_of_0_1_differs_in_its_value_where_2_was_expected_but_3_was_given:N(4125,1,"Each_declaration_of_0_1_differs_in_its_value_where_2_was_expected_but_3_was_given_4125","Each declaration of '{0}.{1}' differs in its value, where '{2}' was expected but '{3}' was given."),One_value_of_0_1_is_the_string_2_and_the_other_is_assumed_to_be_an_unknown_numeric_value:N(4126,1,"One_value_of_0_1_is_the_string_2_and_the_other_is_assumed_to_be_an_unknown_numeric_value_4126","One value of '{0}.{1}' is the string '{2}', and the other is assumed to be an unknown numeric value."),The_current_host_does_not_support_the_0_option:N(5001,1,"The_current_host_does_not_support_the_0_option_5001","The current host does not support the '{0}' option."),Cannot_find_the_common_subdirectory_path_for_the_input_files:N(5009,1,"Cannot_find_the_common_subdirectory_path_for_the_input_files_5009","Cannot find the common subdirectory path for the input files."),File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0:N(5010,1,"File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0_5010","File specification cannot end in a recursive directory wildcard ('**'): '{0}'."),Cannot_read_file_0_Colon_1:N(5012,1,"Cannot_read_file_0_Colon_1_5012","Cannot read file '{0}': {1}."),Failed_to_parse_file_0_Colon_1:N(5014,1,"Failed_to_parse_file_0_Colon_1_5014","Failed to parse file '{0}': {1}."),Unknown_compiler_option_0:N(5023,1,"Unknown_compiler_option_0_5023","Unknown compiler option '{0}'."),Compiler_option_0_requires_a_value_of_type_1:N(5024,1,"Compiler_option_0_requires_a_value_of_type_1_5024","Compiler option '{0}' requires a value of type {1}."),Unknown_compiler_option_0_Did_you_mean_1:N(5025,1,"Unknown_compiler_option_0_Did_you_mean_1_5025","Unknown compiler option '{0}'. Did you mean '{1}'?"),Could_not_write_file_0_Colon_1:N(5033,1,"Could_not_write_file_0_Colon_1_5033","Could not write file '{0}': {1}."),Option_project_cannot_be_mixed_with_source_files_on_a_command_line:N(5042,1,"Option_project_cannot_be_mixed_with_source_files_on_a_command_line_5042","Option 'project' cannot be mixed with source files on a command line."),Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher:N(5047,1,"Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES_5047","Option 'isolatedModules' can only be used when either option '--module' is provided or option 'target' is 'ES2015' or higher."),Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided:N(5051,1,"Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided_5051","Option '{0} can only be used when either option '--inlineSourceMap' or option '--sourceMap' is provided."),Option_0_cannot_be_specified_without_specifying_option_1:N(5052,1,"Option_0_cannot_be_specified_without_specifying_option_1_5052","Option '{0}' cannot be specified without specifying option '{1}'."),Option_0_cannot_be_specified_with_option_1:N(5053,1,"Option_0_cannot_be_specified_with_option_1_5053","Option '{0}' cannot be specified with option '{1}'."),A_tsconfig_json_file_is_already_defined_at_Colon_0:N(5054,1,"A_tsconfig_json_file_is_already_defined_at_Colon_0_5054","A 'tsconfig.json' file is already defined at: '{0}'."),Cannot_write_file_0_because_it_would_overwrite_input_file:N(5055,1,"Cannot_write_file_0_because_it_would_overwrite_input_file_5055","Cannot write file '{0}' because it would overwrite input file."),Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files:N(5056,1,"Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files_5056","Cannot write file '{0}' because it would be overwritten by multiple input files."),Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0:N(5057,1,"Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0_5057","Cannot find a tsconfig.json file at the specified directory: '{0}'."),The_specified_path_does_not_exist_Colon_0:N(5058,1,"The_specified_path_does_not_exist_Colon_0_5058","The specified path does not exist: '{0}'."),Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier:N(5059,1,"Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier_5059","Invalid value for '--reactNamespace'. '{0}' is not a valid identifier."),Pattern_0_can_have_at_most_one_Asterisk_character:N(5061,1,"Pattern_0_can_have_at_most_one_Asterisk_character_5061","Pattern '{0}' can have at most one '*' character."),Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character:N(5062,1,"Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character_5062","Substitution '{0}' in pattern '{1}' can have at most one '*' character."),Substitutions_for_pattern_0_should_be_an_array:N(5063,1,"Substitutions_for_pattern_0_should_be_an_array_5063","Substitutions for pattern '{0}' should be an array."),Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2:N(5064,1,"Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2_5064","Substitution '{0}' for pattern '{1}' has incorrect type, expected 'string', got '{2}'."),File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0:N(5065,1,"File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildca_5065","File specification cannot contain a parent directory ('..') that appears after a recursive directory wildcard ('**'): '{0}'."),Substitutions_for_pattern_0_shouldn_t_be_an_empty_array:N(5066,1,"Substitutions_for_pattern_0_shouldn_t_be_an_empty_array_5066","Substitutions for pattern '{0}' shouldn't be an empty array."),Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name:N(5067,1,"Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name_5067","Invalid value for 'jsxFactory'. '{0}' is not a valid identifier or qualified-name."),Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig:N(5068,1,"Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript__5068","Adding a tsconfig.json file will help organize projects that contain both TypeScript and JavaScript files. Learn more at https://aka.ms/tsconfig."),Option_0_cannot_be_specified_without_specifying_option_1_or_option_2:N(5069,1,"Option_0_cannot_be_specified_without_specifying_option_1_or_option_2_5069","Option '{0}' cannot be specified without specifying option '{1}' or option '{2}'."),Option_resolveJsonModule_cannot_be_specified_when_moduleResolution_is_set_to_classic:N(5070,1,"Option_resolveJsonModule_cannot_be_specified_when_moduleResolution_is_set_to_classic_5070","Option '--resolveJsonModule' cannot be specified when 'moduleResolution' is set to 'classic'."),Option_resolveJsonModule_cannot_be_specified_when_module_is_set_to_none_system_or_umd:N(5071,1,"Option_resolveJsonModule_cannot_be_specified_when_module_is_set_to_none_system_or_umd_5071","Option '--resolveJsonModule' cannot be specified when 'module' is set to 'none', 'system', or 'umd'."),Unknown_build_option_0:N(5072,1,"Unknown_build_option_0_5072","Unknown build option '{0}'."),Build_option_0_requires_a_value_of_type_1:N(5073,1,"Build_option_0_requires_a_value_of_type_1_5073","Build option '{0}' requires a value of type {1}."),Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified:N(5074,1,"Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBui_5074","Option '--incremental' can only be specified using tsconfig, emitting to single file or when option '--tsBuildInfoFile' is specified."),_0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2:N(5075,1,"_0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_5075","'{0}' is assignable to the constraint of type '{1}', but '{1}' could be instantiated with a different subtype of constraint '{2}'."),_0_and_1_operations_cannot_be_mixed_without_parentheses:N(5076,1,"_0_and_1_operations_cannot_be_mixed_without_parentheses_5076","'{0}' and '{1}' operations cannot be mixed without parentheses."),Unknown_build_option_0_Did_you_mean_1:N(5077,1,"Unknown_build_option_0_Did_you_mean_1_5077","Unknown build option '{0}'. Did you mean '{1}'?"),Unknown_watch_option_0:N(5078,1,"Unknown_watch_option_0_5078","Unknown watch option '{0}'."),Unknown_watch_option_0_Did_you_mean_1:N(5079,1,"Unknown_watch_option_0_Did_you_mean_1_5079","Unknown watch option '{0}'. Did you mean '{1}'?"),Watch_option_0_requires_a_value_of_type_1:N(5080,1,"Watch_option_0_requires_a_value_of_type_1_5080","Watch option '{0}' requires a value of type {1}."),Cannot_find_a_tsconfig_json_file_at_the_current_directory_Colon_0:N(5081,1,"Cannot_find_a_tsconfig_json_file_at_the_current_directory_Colon_0_5081","Cannot find a tsconfig.json file at the current directory: {0}."),_0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1:N(5082,1,"_0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1_5082","'{0}' could be instantiated with an arbitrary type which could be unrelated to '{1}'."),Cannot_read_file_0:N(5083,1,"Cannot_read_file_0_5083","Cannot read file '{0}'."),A_tuple_member_cannot_be_both_optional_and_rest:N(5085,1,"A_tuple_member_cannot_be_both_optional_and_rest_5085","A tuple member cannot be both optional and rest."),A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type:N(5086,1,"A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_c_5086","A labeled tuple element is declared as optional with a question mark after the name and before the colon, rather than after the type."),A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type:N(5087,1,"A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type_5087","A labeled tuple element is declared as rest with a '...' before the name, rather than before the type."),The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialized_A_type_annotation_is_necessary:N(5088,1,"The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialize_5088","The inferred type of '{0}' references a type with a cyclic structure which cannot be trivially serialized. A type annotation is necessary."),Option_0_cannot_be_specified_when_option_jsx_is_1:N(5089,1,"Option_0_cannot_be_specified_when_option_jsx_is_1_5089","Option '{0}' cannot be specified when option 'jsx' is '{1}'."),Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash:N(5090,1,"Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash_5090","Non-relative paths are not allowed when 'baseUrl' is not set. Did you forget a leading './'?"),Option_preserveConstEnums_cannot_be_disabled_when_0_is_enabled:N(5091,1,"Option_preserveConstEnums_cannot_be_disabled_when_0_is_enabled_5091","Option 'preserveConstEnums' cannot be disabled when '{0}' is enabled."),The_root_value_of_a_0_file_must_be_an_object:N(5092,1,"The_root_value_of_a_0_file_must_be_an_object_5092","The root value of a '{0}' file must be an object."),Compiler_option_0_may_only_be_used_with_build:N(5093,1,"Compiler_option_0_may_only_be_used_with_build_5093","Compiler option '--{0}' may only be used with '--build'."),Compiler_option_0_may_not_be_used_with_build:N(5094,1,"Compiler_option_0_may_not_be_used_with_build_5094","Compiler option '--{0}' may not be used with '--build'."),Option_0_can_only_be_used_when_module_is_set_to_preserve_or_to_es2015_or_later:N(5095,1,"Option_0_can_only_be_used_when_module_is_set_to_preserve_or_to_es2015_or_later_5095","Option '{0}' can only be used when 'module' is set to 'preserve' or to 'es2015' or later."),Option_allowImportingTsExtensions_can_only_be_used_when_either_noEmit_or_emitDeclarationOnly_is_set:N(5096,1,"Option_allowImportingTsExtensions_can_only_be_used_when_either_noEmit_or_emitDeclarationOnly_is_set_5096","Option 'allowImportingTsExtensions' can only be used when either 'noEmit' or 'emitDeclarationOnly' is set."),An_import_path_can_only_end_with_a_0_extension_when_allowImportingTsExtensions_is_enabled:N(5097,1,"An_import_path_can_only_end_with_a_0_extension_when_allowImportingTsExtensions_is_enabled_5097","An import path can only end with a '{0}' extension when 'allowImportingTsExtensions' is enabled."),Option_0_can_only_be_used_when_moduleResolution_is_set_to_node16_nodenext_or_bundler:N(5098,1,"Option_0_can_only_be_used_when_moduleResolution_is_set_to_node16_nodenext_or_bundler_5098","Option '{0}' can only be used when 'moduleResolution' is set to 'node16', 'nodenext', or 'bundler'."),Option_0_is_deprecated_and_will_stop_functioning_in_TypeScript_1_Specify_compilerOption_ignoreDeprecations_Colon_2_to_silence_this_error:N(5101,1,"Option_0_is_deprecated_and_will_stop_functioning_in_TypeScript_1_Specify_compilerOption_ignoreDeprec_5101",`Option '{0}' is deprecated and will stop functioning in TypeScript {1}. Specify compilerOption '"ignoreDeprecations": "{2}"' to silence this error.`),Option_0_has_been_removed_Please_remove_it_from_your_configuration:N(5102,1,"Option_0_has_been_removed_Please_remove_it_from_your_configuration_5102","Option '{0}' has been removed. Please remove it from your configuration."),Invalid_value_for_ignoreDeprecations:N(5103,1,"Invalid_value_for_ignoreDeprecations_5103","Invalid value for '--ignoreDeprecations'."),Option_0_is_redundant_and_cannot_be_specified_with_option_1:N(5104,1,"Option_0_is_redundant_and_cannot_be_specified_with_option_1_5104","Option '{0}' is redundant and cannot be specified with option '{1}'."),Option_verbatimModuleSyntax_cannot_be_used_when_module_is_set_to_UMD_AMD_or_System:N(5105,1,"Option_verbatimModuleSyntax_cannot_be_used_when_module_is_set_to_UMD_AMD_or_System_5105","Option 'verbatimModuleSyntax' cannot be used when 'module' is set to 'UMD', 'AMD', or 'System'."),Use_0_instead:N(5106,3,"Use_0_instead_5106","Use '{0}' instead."),Option_0_1_is_deprecated_and_will_stop_functioning_in_TypeScript_2_Specify_compilerOption_ignoreDeprecations_Colon_3_to_silence_this_error:N(5107,1,"Option_0_1_is_deprecated_and_will_stop_functioning_in_TypeScript_2_Specify_compilerOption_ignoreDepr_5107",`Option '{0}={1}' is deprecated and will stop functioning in TypeScript {2}. Specify compilerOption '"ignoreDeprecations": "{3}"' to silence this error.`),Option_0_1_has_been_removed_Please_remove_it_from_your_configuration:N(5108,1,"Option_0_1_has_been_removed_Please_remove_it_from_your_configuration_5108","Option '{0}={1}' has been removed. Please remove it from your configuration."),Option_moduleResolution_must_be_set_to_0_or_left_unspecified_when_option_module_is_set_to_1:N(5109,1,"Option_moduleResolution_must_be_set_to_0_or_left_unspecified_when_option_module_is_set_to_1_5109","Option 'moduleResolution' must be set to '{0}' (or left unspecified) when option 'module' is set to '{1}'."),Option_module_must_be_set_to_0_when_option_moduleResolution_is_set_to_1:N(5110,1,"Option_module_must_be_set_to_0_when_option_moduleResolution_is_set_to_1_5110","Option 'module' must be set to '{0}' when option 'moduleResolution' is set to '{1}'."),Generates_a_sourcemap_for_each_corresponding_d_ts_file:N(6e3,3,"Generates_a_sourcemap_for_each_corresponding_d_ts_file_6000","Generates a sourcemap for each corresponding '.d.ts' file."),Concatenate_and_emit_output_to_single_file:N(6001,3,"Concatenate_and_emit_output_to_single_file_6001","Concatenate and emit output to single file."),Generates_corresponding_d_ts_file:N(6002,3,"Generates_corresponding_d_ts_file_6002","Generates corresponding '.d.ts' file."),Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations:N(6004,3,"Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations_6004","Specify the location where debugger should locate TypeScript files instead of source locations."),Watch_input_files:N(6005,3,"Watch_input_files_6005","Watch input files."),Redirect_output_structure_to_the_directory:N(6006,3,"Redirect_output_structure_to_the_directory_6006","Redirect output structure to the directory."),Do_not_erase_const_enum_declarations_in_generated_code:N(6007,3,"Do_not_erase_const_enum_declarations_in_generated_code_6007","Do not erase const enum declarations in generated code."),Do_not_emit_outputs_if_any_errors_were_reported:N(6008,3,"Do_not_emit_outputs_if_any_errors_were_reported_6008","Do not emit outputs if any errors were reported."),Do_not_emit_comments_to_output:N(6009,3,"Do_not_emit_comments_to_output_6009","Do not emit comments to output."),Do_not_emit_outputs:N(6010,3,"Do_not_emit_outputs_6010","Do not emit outputs."),Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typechecking:N(6011,3,"Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typech_6011","Allow default imports from modules with no default export. This does not affect code emit, just typechecking."),Skip_type_checking_of_declaration_files:N(6012,3,"Skip_type_checking_of_declaration_files_6012","Skip type checking of declaration files."),Do_not_resolve_the_real_path_of_symlinks:N(6013,3,"Do_not_resolve_the_real_path_of_symlinks_6013","Do not resolve the real path of symlinks."),Only_emit_d_ts_declaration_files:N(6014,3,"Only_emit_d_ts_declaration_files_6014","Only emit '.d.ts' declaration files."),Specify_ECMAScript_target_version:N(6015,3,"Specify_ECMAScript_target_version_6015","Specify ECMAScript target version."),Specify_module_code_generation:N(6016,3,"Specify_module_code_generation_6016","Specify module code generation."),Print_this_message:N(6017,3,"Print_this_message_6017","Print this message."),Print_the_compiler_s_version:N(6019,3,"Print_the_compiler_s_version_6019","Print the compiler's version."),Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json:N(6020,3,"Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json_6020","Compile the project given the path to its configuration file, or to a folder with a 'tsconfig.json'."),Syntax_Colon_0:N(6023,3,"Syntax_Colon_0_6023","Syntax: {0}"),options:N(6024,3,"options_6024","options"),file:N(6025,3,"file_6025","file"),Examples_Colon_0:N(6026,3,"Examples_Colon_0_6026","Examples: {0}"),Options_Colon:N(6027,3,"Options_Colon_6027","Options:"),Version_0:N(6029,3,"Version_0_6029","Version {0}"),Insert_command_line_options_and_files_from_a_file:N(6030,3,"Insert_command_line_options_and_files_from_a_file_6030","Insert command line options and files from a file."),Starting_compilation_in_watch_mode:N(6031,3,"Starting_compilation_in_watch_mode_6031","Starting compilation in watch mode..."),File_change_detected_Starting_incremental_compilation:N(6032,3,"File_change_detected_Starting_incremental_compilation_6032","File change detected. Starting incremental compilation..."),KIND:N(6034,3,"KIND_6034","KIND"),FILE:N(6035,3,"FILE_6035","FILE"),VERSION:N(6036,3,"VERSION_6036","VERSION"),LOCATION:N(6037,3,"LOCATION_6037","LOCATION"),DIRECTORY:N(6038,3,"DIRECTORY_6038","DIRECTORY"),STRATEGY:N(6039,3,"STRATEGY_6039","STRATEGY"),FILE_OR_DIRECTORY:N(6040,3,"FILE_OR_DIRECTORY_6040","FILE OR DIRECTORY"),Errors_Files:N(6041,3,"Errors_Files_6041","Errors  Files"),Generates_corresponding_map_file:N(6043,3,"Generates_corresponding_map_file_6043","Generates corresponding '.map' file."),Compiler_option_0_expects_an_argument:N(6044,1,"Compiler_option_0_expects_an_argument_6044","Compiler option '{0}' expects an argument."),Unterminated_quoted_string_in_response_file_0:N(6045,1,"Unterminated_quoted_string_in_response_file_0_6045","Unterminated quoted string in response file '{0}'."),Argument_for_0_option_must_be_Colon_1:N(6046,1,"Argument_for_0_option_must_be_Colon_1_6046","Argument for '{0}' option must be: {1}."),Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1:N(6048,1,"Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1_6048","Locale must be of the form <language> or <language>-<territory>. For example '{0}' or '{1}'."),Unable_to_open_file_0:N(6050,1,"Unable_to_open_file_0_6050","Unable to open file '{0}'."),Corrupted_locale_file_0:N(6051,1,"Corrupted_locale_file_0_6051","Corrupted locale file {0}."),Raise_error_on_expressions_and_declarations_with_an_implied_any_type:N(6052,3,"Raise_error_on_expressions_and_declarations_with_an_implied_any_type_6052","Raise error on expressions and declarations with an implied 'any' type."),File_0_not_found:N(6053,1,"File_0_not_found_6053","File '{0}' not found."),File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1:N(6054,1,"File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1_6054","File '{0}' has an unsupported extension. The only supported extensions are {1}."),Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures:N(6055,3,"Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures_6055","Suppress noImplicitAny errors for indexing objects lacking index signatures."),Do_not_emit_declarations_for_code_that_has_an_internal_annotation:N(6056,3,"Do_not_emit_declarations_for_code_that_has_an_internal_annotation_6056","Do not emit declarations for code that has an '@internal' annotation."),Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir:N(6058,3,"Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir_6058","Specify the root directory of input files. Use to control the output directory structure with --outDir."),File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files:N(6059,1,"File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files_6059","File '{0}' is not under 'rootDir' '{1}'. 'rootDir' is expected to contain all source files."),Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix:N(6060,3,"Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix_6060","Specify the end of line sequence to be used when emitting files: 'CRLF' (dos) or 'LF' (unix)."),NEWLINE:N(6061,3,"NEWLINE_6061","NEWLINE"),Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line:N(6064,1,"Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line_6064","Option '{0}' can only be specified in 'tsconfig.json' file or set to 'null' on command line."),Enables_experimental_support_for_ES7_decorators:N(6065,3,"Enables_experimental_support_for_ES7_decorators_6065","Enables experimental support for ES7 decorators."),Enables_experimental_support_for_emitting_type_metadata_for_decorators:N(6066,3,"Enables_experimental_support_for_emitting_type_metadata_for_decorators_6066","Enables experimental support for emitting type metadata for decorators."),Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file:N(6070,3,"Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file_6070","Initializes a TypeScript project and creates a tsconfig.json file."),Successfully_created_a_tsconfig_json_file:N(6071,3,"Successfully_created_a_tsconfig_json_file_6071","Successfully created a tsconfig.json file."),Suppress_excess_property_checks_for_object_literals:N(6072,3,"Suppress_excess_property_checks_for_object_literals_6072","Suppress excess property checks for object literals."),Stylize_errors_and_messages_using_color_and_context_experimental:N(6073,3,"Stylize_errors_and_messages_using_color_and_context_experimental_6073","Stylize errors and messages using color and context (experimental)."),Do_not_report_errors_on_unused_labels:N(6074,3,"Do_not_report_errors_on_unused_labels_6074","Do not report errors on unused labels."),Report_error_when_not_all_code_paths_in_function_return_a_value:N(6075,3,"Report_error_when_not_all_code_paths_in_function_return_a_value_6075","Report error when not all code paths in function return a value."),Report_errors_for_fallthrough_cases_in_switch_statement:N(6076,3,"Report_errors_for_fallthrough_cases_in_switch_statement_6076","Report errors for fallthrough cases in switch statement."),Do_not_report_errors_on_unreachable_code:N(6077,3,"Do_not_report_errors_on_unreachable_code_6077","Do not report errors on unreachable code."),Disallow_inconsistently_cased_references_to_the_same_file:N(6078,3,"Disallow_inconsistently_cased_references_to_the_same_file_6078","Disallow inconsistently-cased references to the same file."),Specify_library_files_to_be_included_in_the_compilation:N(6079,3,"Specify_library_files_to_be_included_in_the_compilation_6079","Specify library files to be included in the compilation."),Specify_JSX_code_generation:N(6080,3,"Specify_JSX_code_generation_6080","Specify JSX code generation."),Only_amd_and_system_modules_are_supported_alongside_0:N(6082,1,"Only_amd_and_system_modules_are_supported_alongside_0_6082","Only 'amd' and 'system' modules are supported alongside --{0}."),Base_directory_to_resolve_non_absolute_module_names:N(6083,3,"Base_directory_to_resolve_non_absolute_module_names_6083","Base directory to resolve non-absolute module names."),Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react_JSX_emit:N(6084,3,"Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react__6084","[Deprecated] Use '--jsxFactory' instead. Specify the object invoked for createElement when targeting 'react' JSX emit"),Enable_tracing_of_the_name_resolution_process:N(6085,3,"Enable_tracing_of_the_name_resolution_process_6085","Enable tracing of the name resolution process."),Resolving_module_0_from_1:N(6086,3,"Resolving_module_0_from_1_6086","======== Resolving module '{0}' from '{1}'. ========"),Explicitly_specified_module_resolution_kind_Colon_0:N(6087,3,"Explicitly_specified_module_resolution_kind_Colon_0_6087","Explicitly specified module resolution kind: '{0}'."),Module_resolution_kind_is_not_specified_using_0:N(6088,3,"Module_resolution_kind_is_not_specified_using_0_6088","Module resolution kind is not specified, using '{0}'."),Module_name_0_was_successfully_resolved_to_1:N(6089,3,"Module_name_0_was_successfully_resolved_to_1_6089","======== Module name '{0}' was successfully resolved to '{1}'. ========"),Module_name_0_was_not_resolved:N(6090,3,"Module_name_0_was_not_resolved_6090","======== Module name '{0}' was not resolved. ========"),paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0:N(6091,3,"paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0_6091","'paths' option is specified, looking for a pattern to match module name '{0}'."),Module_name_0_matched_pattern_1:N(6092,3,"Module_name_0_matched_pattern_1_6092","Module name '{0}', matched pattern '{1}'."),Trying_substitution_0_candidate_module_location_Colon_1:N(6093,3,"Trying_substitution_0_candidate_module_location_Colon_1_6093","Trying substitution '{0}', candidate module location: '{1}'."),Resolving_module_name_0_relative_to_base_url_1_2:N(6094,3,"Resolving_module_name_0_relative_to_base_url_1_2_6094","Resolving module name '{0}' relative to base url '{1}' - '{2}'."),Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_types_Colon_1:N(6095,3,"Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_types_Colon_1_6095","Loading module as file / folder, candidate module location '{0}', target file types: {1}."),File_0_does_not_exist:N(6096,3,"File_0_does_not_exist_6096","File '{0}' does not exist."),File_0_exists_use_it_as_a_name_resolution_result:N(6097,3,"File_0_exists_use_it_as_a_name_resolution_result_6097","File '{0}' exists - use it as a name resolution result."),Loading_module_0_from_node_modules_folder_target_file_types_Colon_1:N(6098,3,"Loading_module_0_from_node_modules_folder_target_file_types_Colon_1_6098","Loading module '{0}' from 'node_modules' folder, target file types: {1}."),Found_package_json_at_0:N(6099,3,"Found_package_json_at_0_6099","Found 'package.json' at '{0}'."),package_json_does_not_have_a_0_field:N(6100,3,"package_json_does_not_have_a_0_field_6100","'package.json' does not have a '{0}' field."),package_json_has_0_field_1_that_references_2:N(6101,3,"package_json_has_0_field_1_that_references_2_6101","'package.json' has '{0}' field '{1}' that references '{2}'."),Allow_javascript_files_to_be_compiled:N(6102,3,"Allow_javascript_files_to_be_compiled_6102","Allow javascript files to be compiled."),Checking_if_0_is_the_longest_matching_prefix_for_1_2:N(6104,3,"Checking_if_0_is_the_longest_matching_prefix_for_1_2_6104","Checking if '{0}' is the longest matching prefix for '{1}' - '{2}'."),Expected_type_of_0_field_in_package_json_to_be_1_got_2:N(6105,3,"Expected_type_of_0_field_in_package_json_to_be_1_got_2_6105","Expected type of '{0}' field in 'package.json' to be '{1}', got '{2}'."),baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1:N(6106,3,"baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1_6106","'baseUrl' option is set to '{0}', using this value to resolve non-relative module name '{1}'."),rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0:N(6107,3,"rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0_6107","'rootDirs' option is set, using it to resolve relative module name '{0}'."),Longest_matching_prefix_for_0_is_1:N(6108,3,"Longest_matching_prefix_for_0_is_1_6108","Longest matching prefix for '{0}' is '{1}'."),Loading_0_from_the_root_dir_1_candidate_location_2:N(6109,3,"Loading_0_from_the_root_dir_1_candidate_location_2_6109","Loading '{0}' from the root dir '{1}', candidate location '{2}'."),Trying_other_entries_in_rootDirs:N(6110,3,"Trying_other_entries_in_rootDirs_6110","Trying other entries in 'rootDirs'."),Module_resolution_using_rootDirs_has_failed:N(6111,3,"Module_resolution_using_rootDirs_has_failed_6111","Module resolution using 'rootDirs' has failed."),Do_not_emit_use_strict_directives_in_module_output:N(6112,3,"Do_not_emit_use_strict_directives_in_module_output_6112","Do not emit 'use strict' directives in module output."),Enable_strict_null_checks:N(6113,3,"Enable_strict_null_checks_6113","Enable strict null checks."),Unknown_option_excludes_Did_you_mean_exclude:N(6114,1,"Unknown_option_excludes_Did_you_mean_exclude_6114","Unknown option 'excludes'. Did you mean 'exclude'?"),Raise_error_on_this_expressions_with_an_implied_any_type:N(6115,3,"Raise_error_on_this_expressions_with_an_implied_any_type_6115","Raise error on 'this' expressions with an implied 'any' type."),Resolving_type_reference_directive_0_containing_file_1_root_directory_2:N(6116,3,"Resolving_type_reference_directive_0_containing_file_1_root_directory_2_6116","======== Resolving type reference directive '{0}', containing file '{1}', root directory '{2}'. ========"),Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2:N(6119,3,"Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2_6119","======== Type reference directive '{0}' was successfully resolved to '{1}', primary: {2}. ========"),Type_reference_directive_0_was_not_resolved:N(6120,3,"Type_reference_directive_0_was_not_resolved_6120","======== Type reference directive '{0}' was not resolved. ========"),Resolving_with_primary_search_path_0:N(6121,3,"Resolving_with_primary_search_path_0_6121","Resolving with primary search path '{0}'."),Root_directory_cannot_be_determined_skipping_primary_search_paths:N(6122,3,"Root_directory_cannot_be_determined_skipping_primary_search_paths_6122","Root directory cannot be determined, skipping primary search paths."),Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set:N(6123,3,"Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set_6123","======== Resolving type reference directive '{0}', containing file '{1}', root directory not set. ========"),Type_declaration_files_to_be_included_in_compilation:N(6124,3,"Type_declaration_files_to_be_included_in_compilation_6124","Type declaration files to be included in compilation."),Looking_up_in_node_modules_folder_initial_location_0:N(6125,3,"Looking_up_in_node_modules_folder_initial_location_0_6125","Looking up in 'node_modules' folder, initial location '{0}'."),Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder:N(6126,3,"Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_mod_6126","Containing file is not specified and root directory cannot be determined, skipping lookup in 'node_modules' folder."),Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1:N(6127,3,"Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1_6127","======== Resolving type reference directive '{0}', containing file not set, root directory '{1}'. ========"),Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set:N(6128,3,"Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set_6128","======== Resolving type reference directive '{0}', containing file not set, root directory not set. ========"),Resolving_real_path_for_0_result_1:N(6130,3,"Resolving_real_path_for_0_result_1_6130","Resolving real path for '{0}', result '{1}'."),Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system:N(6131,1,"Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system_6131","Cannot compile modules using option '{0}' unless the '--module' flag is 'amd' or 'system'."),File_name_0_has_a_1_extension_stripping_it:N(6132,3,"File_name_0_has_a_1_extension_stripping_it_6132","File name '{0}' has a '{1}' extension - stripping it."),_0_is_declared_but_its_value_is_never_read:N(6133,1,"_0_is_declared_but_its_value_is_never_read_6133","'{0}' is declared but its value is never read.",!0),Report_errors_on_unused_locals:N(6134,3,"Report_errors_on_unused_locals_6134","Report errors on unused locals."),Report_errors_on_unused_parameters:N(6135,3,"Report_errors_on_unused_parameters_6135","Report errors on unused parameters."),The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files:N(6136,3,"The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files_6136","The maximum dependency depth to search under node_modules and load JavaScript files."),Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1:N(6137,1,"Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1_6137","Cannot import type declaration files. Consider importing '{0}' instead of '{1}'."),Property_0_is_declared_but_its_value_is_never_read:N(6138,1,"Property_0_is_declared_but_its_value_is_never_read_6138","Property '{0}' is declared but its value is never read.",!0),Import_emit_helpers_from_tslib:N(6139,3,"Import_emit_helpers_from_tslib_6139","Import emit helpers from 'tslib'."),Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2:N(6140,1,"Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using__6140","Auto discovery for typings is enabled in project '{0}'. Running extra resolution pass for module '{1}' using cache location '{2}'."),Parse_in_strict_mode_and_emit_use_strict_for_each_source_file:N(6141,3,"Parse_in_strict_mode_and_emit_use_strict_for_each_source_file_6141",'Parse in strict mode and emit "use strict" for each source file.'),Module_0_was_resolved_to_1_but_jsx_is_not_set:N(6142,1,"Module_0_was_resolved_to_1_but_jsx_is_not_set_6142","Module '{0}' was resolved to '{1}', but '--jsx' is not set."),Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1:N(6144,3,"Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1_6144","Module '{0}' was resolved as locally declared ambient module in file '{1}'."),Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified:N(6145,3,"Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified_6145","Module '{0}' was resolved as ambient module declared in '{1}' since this file was not modified."),Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h:N(6146,3,"Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h_6146","Specify the JSX factory function to use when targeting 'react' JSX emit, e.g. 'React.createElement' or 'h'."),Resolution_for_module_0_was_found_in_cache_from_location_1:N(6147,3,"Resolution_for_module_0_was_found_in_cache_from_location_1_6147","Resolution for module '{0}' was found in cache from location '{1}'."),Directory_0_does_not_exist_skipping_all_lookups_in_it:N(6148,3,"Directory_0_does_not_exist_skipping_all_lookups_in_it_6148","Directory '{0}' does not exist, skipping all lookups in it."),Show_diagnostic_information:N(6149,3,"Show_diagnostic_information_6149","Show diagnostic information."),Show_verbose_diagnostic_information:N(6150,3,"Show_verbose_diagnostic_information_6150","Show verbose diagnostic information."),Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file:N(6151,3,"Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file_6151","Emit a single file with source maps instead of having a separate file."),Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap_to_be_set:N(6152,3,"Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap__6152","Emit the source alongside the sourcemaps within a single file; requires '--inlineSourceMap' or '--sourceMap' to be set."),Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule:N(6153,3,"Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule_6153","Transpile each file as a separate module (similar to 'ts.transpileModule')."),Print_names_of_generated_files_part_of_the_compilation:N(6154,3,"Print_names_of_generated_files_part_of_the_compilation_6154","Print names of generated files part of the compilation."),Print_names_of_files_part_of_the_compilation:N(6155,3,"Print_names_of_files_part_of_the_compilation_6155","Print names of files part of the compilation."),The_locale_used_when_displaying_messages_to_the_user_e_g_en_us:N(6156,3,"The_locale_used_when_displaying_messages_to_the_user_e_g_en_us_6156","The locale used when displaying messages to the user (e.g. 'en-us')"),Do_not_generate_custom_helper_functions_like_extends_in_compiled_output:N(6157,3,"Do_not_generate_custom_helper_functions_like_extends_in_compiled_output_6157","Do not generate custom helper functions like '__extends' in compiled output."),Do_not_include_the_default_library_file_lib_d_ts:N(6158,3,"Do_not_include_the_default_library_file_lib_d_ts_6158","Do not include the default library file (lib.d.ts)."),Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files:N(6159,3,"Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files_6159","Do not add triple-slash references or imported modules to the list of compiled files."),Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files:N(6160,3,"Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files_6160","[Deprecated] Use '--skipLibCheck' instead. Skip type checking of default library declaration files."),List_of_folders_to_include_type_definitions_from:N(6161,3,"List_of_folders_to_include_type_definitions_from_6161","List of folders to include type definitions from."),Disable_size_limitations_on_JavaScript_projects:N(6162,3,"Disable_size_limitations_on_JavaScript_projects_6162","Disable size limitations on JavaScript projects."),The_character_set_of_the_input_files:N(6163,3,"The_character_set_of_the_input_files_6163","The character set of the input files."),Skipping_module_0_that_looks_like_an_absolute_URI_target_file_types_Colon_1:N(6164,3,"Skipping_module_0_that_looks_like_an_absolute_URI_target_file_types_Colon_1_6164","Skipping module '{0}' that looks like an absolute URI, target file types: {1}."),Do_not_truncate_error_messages:N(6165,3,"Do_not_truncate_error_messages_6165","Do not truncate error messages."),Output_directory_for_generated_declaration_files:N(6166,3,"Output_directory_for_generated_declaration_files_6166","Output directory for generated declaration files."),A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl:N(6167,3,"A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl_6167","A series of entries which re-map imports to lookup locations relative to the 'baseUrl'."),List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime:N(6168,3,"List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime_6168","List of root folders whose combined content represents the structure of the project at runtime."),Show_all_compiler_options:N(6169,3,"Show_all_compiler_options_6169","Show all compiler options."),Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file:N(6170,3,"Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file_6170","[Deprecated] Use '--outFile' instead. Concatenate and emit output to single file"),Command_line_Options:N(6171,3,"Command_line_Options_6171","Command-line Options"),Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5:N(6179,3,"Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_6179","Provide full support for iterables in 'for-of', spread, and destructuring when targeting 'ES5'."),Enable_all_strict_type_checking_options:N(6180,3,"Enable_all_strict_type_checking_options_6180","Enable all strict type-checking options."),Scoped_package_detected_looking_in_0:N(6182,3,"Scoped_package_detected_looking_in_0_6182","Scoped package detected, looking in '{0}'"),Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2:N(6183,3,"Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_6183","Reusing resolution of module '{0}' from '{1}' of old program, it was successfully resolved to '{2}'."),Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3:N(6184,3,"Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package__6184","Reusing resolution of module '{0}' from '{1}' of old program, it was successfully resolved to '{2}' with Package ID '{3}'."),Enable_strict_checking_of_function_types:N(6186,3,"Enable_strict_checking_of_function_types_6186","Enable strict checking of function types."),Enable_strict_checking_of_property_initialization_in_classes:N(6187,3,"Enable_strict_checking_of_property_initialization_in_classes_6187","Enable strict checking of property initialization in classes."),Numeric_separators_are_not_allowed_here:N(6188,1,"Numeric_separators_are_not_allowed_here_6188","Numeric separators are not allowed here."),Multiple_consecutive_numeric_separators_are_not_permitted:N(6189,1,"Multiple_consecutive_numeric_separators_are_not_permitted_6189","Multiple consecutive numeric separators are not permitted."),Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen:N(6191,3,"Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen_6191","Whether to keep outdated console output in watch mode instead of clearing the screen."),All_imports_in_import_declaration_are_unused:N(6192,1,"All_imports_in_import_declaration_are_unused_6192","All imports in import declaration are unused.",!0),Found_1_error_Watching_for_file_changes:N(6193,3,"Found_1_error_Watching_for_file_changes_6193","Found 1 error. Watching for file changes."),Found_0_errors_Watching_for_file_changes:N(6194,3,"Found_0_errors_Watching_for_file_changes_6194","Found {0} errors. Watching for file changes."),Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols:N(6195,3,"Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols_6195","Resolve 'keyof' to string valued property names only (no numbers or symbols)."),_0_is_declared_but_never_used:N(6196,1,"_0_is_declared_but_never_used_6196","'{0}' is declared but never used.",!0),Include_modules_imported_with_json_extension:N(6197,3,"Include_modules_imported_with_json_extension_6197","Include modules imported with '.json' extension"),All_destructured_elements_are_unused:N(6198,1,"All_destructured_elements_are_unused_6198","All destructured elements are unused.",!0),All_variables_are_unused:N(6199,1,"All_variables_are_unused_6199","All variables are unused.",!0),Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0:N(6200,1,"Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0_6200","Definitions of the following identifiers conflict with those in another file: {0}"),Conflicts_are_in_this_file:N(6201,3,"Conflicts_are_in_this_file_6201","Conflicts are in this file."),Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0:N(6202,1,"Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0_6202","Project references may not form a circular graph. Cycle detected: {0}"),_0_was_also_declared_here:N(6203,3,"_0_was_also_declared_here_6203","'{0}' was also declared here."),and_here:N(6204,3,"and_here_6204","and here."),All_type_parameters_are_unused:N(6205,1,"All_type_parameters_are_unused_6205","All type parameters are unused."),package_json_has_a_typesVersions_field_with_version_specific_path_mappings:N(6206,3,"package_json_has_a_typesVersions_field_with_version_specific_path_mappings_6206","'package.json' has a 'typesVersions' field with version-specific path mappings."),package_json_does_not_have_a_typesVersions_entry_that_matches_version_0:N(6207,3,"package_json_does_not_have_a_typesVersions_entry_that_matches_version_0_6207","'package.json' does not have a 'typesVersions' entry that matches version '{0}'."),package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2:N(6208,3,"package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_ma_6208","'package.json' has a 'typesVersions' entry '{0}' that matches compiler version '{1}', looking for a pattern to match module name '{2}'."),package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range:N(6209,3,"package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range_6209","'package.json' has a 'typesVersions' entry '{0}' that is not a valid semver range."),An_argument_for_0_was_not_provided:N(6210,3,"An_argument_for_0_was_not_provided_6210","An argument for '{0}' was not provided."),An_argument_matching_this_binding_pattern_was_not_provided:N(6211,3,"An_argument_matching_this_binding_pattern_was_not_provided_6211","An argument matching this binding pattern was not provided."),Did_you_mean_to_call_this_expression:N(6212,3,"Did_you_mean_to_call_this_expression_6212","Did you mean to call this expression?"),Did_you_mean_to_use_new_with_this_expression:N(6213,3,"Did_you_mean_to_use_new_with_this_expression_6213","Did you mean to use 'new' with this expression?"),Enable_strict_bind_call_and_apply_methods_on_functions:N(6214,3,"Enable_strict_bind_call_and_apply_methods_on_functions_6214","Enable strict 'bind', 'call', and 'apply' methods on functions."),Using_compiler_options_of_project_reference_redirect_0:N(6215,3,"Using_compiler_options_of_project_reference_redirect_0_6215","Using compiler options of project reference redirect '{0}'."),Found_1_error:N(6216,3,"Found_1_error_6216","Found 1 error."),Found_0_errors:N(6217,3,"Found_0_errors_6217","Found {0} errors."),Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2:N(6218,3,"Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2_6218","======== Module name '{0}' was successfully resolved to '{1}' with Package ID '{2}'. ========"),Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3:N(6219,3,"Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3_6219","======== Type reference directive '{0}' was successfully resolved to '{1}' with Package ID '{2}', primary: {3}. ========"),package_json_had_a_falsy_0_field:N(6220,3,"package_json_had_a_falsy_0_field_6220","'package.json' had a falsy '{0}' field."),Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects:N(6221,3,"Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects_6221","Disable use of source files instead of declaration files from referenced projects."),Emit_class_fields_with_Define_instead_of_Set:N(6222,3,"Emit_class_fields_with_Define_instead_of_Set_6222","Emit class fields with Define instead of Set."),Generates_a_CPU_profile:N(6223,3,"Generates_a_CPU_profile_6223","Generates a CPU profile."),Disable_solution_searching_for_this_project:N(6224,3,"Disable_solution_searching_for_this_project_6224","Disable solution searching for this project."),Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_DynamicPriorityPolling_FixedChunkSizePolling_UseFsEvents_UseFsEventsOnParentDirectory:N(6225,3,"Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_Dynami_6225","Specify strategy for watching file: 'FixedPollingInterval' (default), 'PriorityPollingInterval', 'DynamicPriorityPolling', 'FixedChunkSizePolling', 'UseFsEvents', 'UseFsEventsOnParentDirectory'."),Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively_Colon_UseFsEvents_default_FixedPollingInterval_DynamicPriorityPolling_FixedChunkSizePolling:N(6226,3,"Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively__6226","Specify strategy for watching directory on platforms that don't support recursive watching natively: 'UseFsEvents' (default), 'FixedPollingInterval', 'DynamicPriorityPolling', 'FixedChunkSizePolling'."),Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_FixedInterval_default_PriorityInterval_DynamicPriority_FixedChunkSize:N(6227,3,"Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_6227","Specify strategy for creating a polling watch when it fails to create using file system events: 'FixedInterval' (default), 'PriorityInterval', 'DynamicPriority', 'FixedChunkSize'."),Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3:N(6229,1,"Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3_6229","Tag '{0}' expects at least '{1}' arguments, but the JSX factory '{2}' provides at most '{3}'."),Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line:N(6230,1,"Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line_6230","Option '{0}' can only be specified in 'tsconfig.json' file or set to 'false' or 'null' on command line."),Could_not_resolve_the_path_0_with_the_extensions_Colon_1:N(6231,1,"Could_not_resolve_the_path_0_with_the_extensions_Colon_1_6231","Could not resolve the path '{0}' with the extensions: {1}."),Declaration_augments_declaration_in_another_file_This_cannot_be_serialized:N(6232,1,"Declaration_augments_declaration_in_another_file_This_cannot_be_serialized_6232","Declaration augments declaration in another file. This cannot be serialized."),This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_file:N(6233,1,"This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_fil_6233","This is the declaration being augmented. Consider moving the augmenting declaration into the same file."),This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without:N(6234,1,"This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without_6234","This expression is not callable because it is a 'get' accessor. Did you mean to use it without '()'?"),Disable_loading_referenced_projects:N(6235,3,"Disable_loading_referenced_projects_6235","Disable loading referenced projects."),Arguments_for_the_rest_parameter_0_were_not_provided:N(6236,1,"Arguments_for_the_rest_parameter_0_were_not_provided_6236","Arguments for the rest parameter '{0}' were not provided."),Generates_an_event_trace_and_a_list_of_types:N(6237,3,"Generates_an_event_trace_and_a_list_of_types_6237","Generates an event trace and a list of types."),Specify_the_module_specifier_to_be_used_to_import_the_jsx_and_jsxs_factory_functions_from_eg_react:N(6238,1,"Specify_the_module_specifier_to_be_used_to_import_the_jsx_and_jsxs_factory_functions_from_eg_react_6238","Specify the module specifier to be used to import the 'jsx' and 'jsxs' factory functions from. eg, react"),File_0_exists_according_to_earlier_cached_lookups:N(6239,3,"File_0_exists_according_to_earlier_cached_lookups_6239","File '{0}' exists according to earlier cached lookups."),File_0_does_not_exist_according_to_earlier_cached_lookups:N(6240,3,"File_0_does_not_exist_according_to_earlier_cached_lookups_6240","File '{0}' does not exist according to earlier cached lookups."),Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1:N(6241,3,"Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1_6241","Resolution for type reference directive '{0}' was found in cache from location '{1}'."),Resolving_type_reference_directive_0_containing_file_1:N(6242,3,"Resolving_type_reference_directive_0_containing_file_1_6242","======== Resolving type reference directive '{0}', containing file '{1}'. ========"),Interpret_optional_property_types_as_written_rather_than_adding_undefined:N(6243,3,"Interpret_optional_property_types_as_written_rather_than_adding_undefined_6243","Interpret optional property types as written, rather than adding 'undefined'."),Modules:N(6244,3,"Modules_6244","Modules"),File_Management:N(6245,3,"File_Management_6245","File Management"),Emit:N(6246,3,"Emit_6246","Emit"),JavaScript_Support:N(6247,3,"JavaScript_Support_6247","JavaScript Support"),Type_Checking:N(6248,3,"Type_Checking_6248","Type Checking"),Editor_Support:N(6249,3,"Editor_Support_6249","Editor Support"),Watch_and_Build_Modes:N(6250,3,"Watch_and_Build_Modes_6250","Watch and Build Modes"),Compiler_Diagnostics:N(6251,3,"Compiler_Diagnostics_6251","Compiler Diagnostics"),Interop_Constraints:N(6252,3,"Interop_Constraints_6252","Interop Constraints"),Backwards_Compatibility:N(6253,3,"Backwards_Compatibility_6253","Backwards Compatibility"),Language_and_Environment:N(6254,3,"Language_and_Environment_6254","Language and Environment"),Projects:N(6255,3,"Projects_6255","Projects"),Output_Formatting:N(6256,3,"Output_Formatting_6256","Output Formatting"),Completeness:N(6257,3,"Completeness_6257","Completeness"),_0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file:N(6258,1,"_0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file_6258","'{0}' should be set inside the 'compilerOptions' object of the config json file"),Found_1_error_in_0:N(6259,3,"Found_1_error_in_0_6259","Found 1 error in {0}"),Found_0_errors_in_the_same_file_starting_at_Colon_1:N(6260,3,"Found_0_errors_in_the_same_file_starting_at_Colon_1_6260","Found {0} errors in the same file, starting at: {1}"),Found_0_errors_in_1_files:N(6261,3,"Found_0_errors_in_1_files_6261","Found {0} errors in {1} files."),File_name_0_has_a_1_extension_looking_up_2_instead:N(6262,3,"File_name_0_has_a_1_extension_looking_up_2_instead_6262","File name '{0}' has a '{1}' extension - looking up '{2}' instead."),Module_0_was_resolved_to_1_but_allowArbitraryExtensions_is_not_set:N(6263,1,"Module_0_was_resolved_to_1_but_allowArbitraryExtensions_is_not_set_6263","Module '{0}' was resolved to '{1}', but '--allowArbitraryExtensions' is not set."),Enable_importing_files_with_any_extension_provided_a_declaration_file_is_present:N(6264,3,"Enable_importing_files_with_any_extension_provided_a_declaration_file_is_present_6264","Enable importing files with any extension, provided a declaration file is present."),Resolving_type_reference_directive_for_program_that_specifies_custom_typeRoots_skipping_lookup_in_node_modules_folder:N(6265,3,"Resolving_type_reference_directive_for_program_that_specifies_custom_typeRoots_skipping_lookup_in_no_6265","Resolving type reference directive for program that specifies custom typeRoots, skipping lookup in 'node_modules' folder."),Option_0_can_only_be_specified_on_command_line:N(6266,1,"Option_0_can_only_be_specified_on_command_line_6266","Option '{0}' can only be specified on command line."),Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve:N(6270,3,"Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve_6270","Directory '{0}' has no containing package.json scope. Imports will not resolve."),Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1:N(6271,3,"Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1_6271","Import specifier '{0}' does not exist in package.json scope at path '{1}'."),Invalid_import_specifier_0_has_no_possible_resolutions:N(6272,3,"Invalid_import_specifier_0_has_no_possible_resolutions_6272","Invalid import specifier '{0}' has no possible resolutions."),package_json_scope_0_has_no_imports_defined:N(6273,3,"package_json_scope_0_has_no_imports_defined_6273","package.json scope '{0}' has no imports defined."),package_json_scope_0_explicitly_maps_specifier_1_to_null:N(6274,3,"package_json_scope_0_explicitly_maps_specifier_1_to_null_6274","package.json scope '{0}' explicitly maps specifier '{1}' to null."),package_json_scope_0_has_invalid_type_for_target_of_specifier_1:N(6275,3,"package_json_scope_0_has_invalid_type_for_target_of_specifier_1_6275","package.json scope '{0}' has invalid type for target of specifier '{1}'"),Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1:N(6276,3,"Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1_6276","Export specifier '{0}' does not exist in package.json scope at path '{1}'."),Resolution_of_non_relative_name_failed_trying_with_modern_Node_resolution_features_disabled_to_see_if_npm_library_needs_configuration_update:N(6277,3,"Resolution_of_non_relative_name_failed_trying_with_modern_Node_resolution_features_disabled_to_see_i_6277","Resolution of non-relative name failed; trying with modern Node resolution features disabled to see if npm library needs configuration update."),There_are_types_at_0_but_this_result_could_not_be_resolved_when_respecting_package_json_exports_The_1_library_may_need_to_update_its_package_json_or_typings:N(6278,3,"There_are_types_at_0_but_this_result_could_not_be_resolved_when_respecting_package_json_exports_The__6278",`There are types at '{0}', but this result could not be resolved when respecting package.json "exports". The '{1}' library may need to update its package.json or typings.`),Resolution_of_non_relative_name_failed_trying_with_moduleResolution_bundler_to_see_if_project_may_need_configuration_update:N(6279,3,"Resolution_of_non_relative_name_failed_trying_with_moduleResolution_bundler_to_see_if_project_may_ne_6279","Resolution of non-relative name failed; trying with '--moduleResolution bundler' to see if project may need configuration update."),There_are_types_at_0_but_this_result_could_not_be_resolved_under_your_current_moduleResolution_setting_Consider_updating_to_node16_nodenext_or_bundler:N(6280,3,"There_are_types_at_0_but_this_result_could_not_be_resolved_under_your_current_moduleResolution_setti_6280","There are types at '{0}', but this result could not be resolved under your current 'moduleResolution' setting. Consider updating to 'node16', 'nodenext', or 'bundler'."),package_json_has_a_peerDependencies_field:N(6281,3,"package_json_has_a_peerDependencies_field_6281","'package.json' has a 'peerDependencies' field."),Found_peerDependency_0_with_1_version:N(6282,3,"Found_peerDependency_0_with_1_version_6282","Found peerDependency '{0}' with '{1}' version."),Failed_to_find_peerDependency_0:N(6283,3,"Failed_to_find_peerDependency_0_6283","Failed to find peerDependency '{0}'."),Enable_project_compilation:N(6302,3,"Enable_project_compilation_6302","Enable project compilation"),Composite_projects_may_not_disable_declaration_emit:N(6304,1,"Composite_projects_may_not_disable_declaration_emit_6304","Composite projects may not disable declaration emit."),Output_file_0_has_not_been_built_from_source_file_1:N(6305,1,"Output_file_0_has_not_been_built_from_source_file_1_6305","Output file '{0}' has not been built from source file '{1}'."),Referenced_project_0_must_have_setting_composite_Colon_true:N(6306,1,"Referenced_project_0_must_have_setting_composite_Colon_true_6306",`Referenced project '{0}' must have setting "composite": true.`),File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_include_pattern:N(6307,1,"File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_includ_6307","File '{0}' is not listed within the file list of project '{1}'. Projects must list all files or use an 'include' pattern."),Referenced_project_0_may_not_disable_emit:N(6310,1,"Referenced_project_0_may_not_disable_emit_6310","Referenced project '{0}' may not disable emit."),Project_0_is_out_of_date_because_output_1_is_older_than_input_2:N(6350,3,"Project_0_is_out_of_date_because_output_1_is_older_than_input_2_6350","Project '{0}' is out of date because output '{1}' is older than input '{2}'"),Project_0_is_up_to_date_because_newest_input_1_is_older_than_output_2:N(6351,3,"Project_0_is_up_to_date_because_newest_input_1_is_older_than_output_2_6351","Project '{0}' is up to date because newest input '{1}' is older than output '{2}'"),Project_0_is_out_of_date_because_output_file_1_does_not_exist:N(6352,3,"Project_0_is_out_of_date_because_output_file_1_does_not_exist_6352","Project '{0}' is out of date because output file '{1}' does not exist"),Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date:N(6353,3,"Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date_6353","Project '{0}' is out of date because its dependency '{1}' is out of date"),Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies:N(6354,3,"Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies_6354","Project '{0}' is up to date with .d.ts files from its dependencies"),Projects_in_this_build_Colon_0:N(6355,3,"Projects_in_this_build_Colon_0_6355","Projects in this build: {0}"),A_non_dry_build_would_delete_the_following_files_Colon_0:N(6356,3,"A_non_dry_build_would_delete_the_following_files_Colon_0_6356","A non-dry build would delete the following files: {0}"),A_non_dry_build_would_build_project_0:N(6357,3,"A_non_dry_build_would_build_project_0_6357","A non-dry build would build project '{0}'"),Building_project_0:N(6358,3,"Building_project_0_6358","Building project '{0}'..."),Updating_output_timestamps_of_project_0:N(6359,3,"Updating_output_timestamps_of_project_0_6359","Updating output timestamps of project '{0}'..."),Project_0_is_up_to_date:N(6361,3,"Project_0_is_up_to_date_6361","Project '{0}' is up to date"),Skipping_build_of_project_0_because_its_dependency_1_has_errors:N(6362,3,"Skipping_build_of_project_0_because_its_dependency_1_has_errors_6362","Skipping build of project '{0}' because its dependency '{1}' has errors"),Project_0_can_t_be_built_because_its_dependency_1_has_errors:N(6363,3,"Project_0_can_t_be_built_because_its_dependency_1_has_errors_6363","Project '{0}' can't be built because its dependency '{1}' has errors"),Build_one_or_more_projects_and_their_dependencies_if_out_of_date:N(6364,3,"Build_one_or_more_projects_and_their_dependencies_if_out_of_date_6364","Build one or more projects and their dependencies, if out of date"),Delete_the_outputs_of_all_projects:N(6365,3,"Delete_the_outputs_of_all_projects_6365","Delete the outputs of all projects."),Show_what_would_be_built_or_deleted_if_specified_with_clean:N(6367,3,"Show_what_would_be_built_or_deleted_if_specified_with_clean_6367","Show what would be built (or deleted, if specified with '--clean')"),Option_build_must_be_the_first_command_line_argument:N(6369,1,"Option_build_must_be_the_first_command_line_argument_6369","Option '--build' must be the first command line argument."),Options_0_and_1_cannot_be_combined:N(6370,1,"Options_0_and_1_cannot_be_combined_6370","Options '{0}' and '{1}' cannot be combined."),Updating_unchanged_output_timestamps_of_project_0:N(6371,3,"Updating_unchanged_output_timestamps_of_project_0_6371","Updating unchanged output timestamps of project '{0}'..."),A_non_dry_build_would_update_timestamps_for_output_of_project_0:N(6374,3,"A_non_dry_build_would_update_timestamps_for_output_of_project_0_6374","A non-dry build would update timestamps for output of project '{0}'"),Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1:N(6377,1,"Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1_6377","Cannot write file '{0}' because it will overwrite '.tsbuildinfo' file generated by referenced project '{1}'"),Composite_projects_may_not_disable_incremental_compilation:N(6379,1,"Composite_projects_may_not_disable_incremental_compilation_6379","Composite projects may not disable incremental compilation."),Specify_file_to_store_incremental_compilation_information:N(6380,3,"Specify_file_to_store_incremental_compilation_information_6380","Specify file to store incremental compilation information"),Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2:N(6381,3,"Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_curren_6381","Project '{0}' is out of date because output for it was generated with version '{1}' that differs with current version '{2}'"),Skipping_build_of_project_0_because_its_dependency_1_was_not_built:N(6382,3,"Skipping_build_of_project_0_because_its_dependency_1_was_not_built_6382","Skipping build of project '{0}' because its dependency '{1}' was not built"),Project_0_can_t_be_built_because_its_dependency_1_was_not_built:N(6383,3,"Project_0_can_t_be_built_because_its_dependency_1_was_not_built_6383","Project '{0}' can't be built because its dependency '{1}' was not built"),Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it:N(6384,3,"Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_di_6384","Have recompiles in '--incremental' and '--watch' assume that changes within a file will only affect files directly depending on it."),_0_is_deprecated:N(6385,2,"_0_is_deprecated_6385","'{0}' is deprecated.",void 0,void 0,!0),Performance_timings_for_diagnostics_or_extendedDiagnostics_are_not_available_in_this_session_A_native_implementation_of_the_Web_Performance_API_could_not_be_found:N(6386,3,"Performance_timings_for_diagnostics_or_extendedDiagnostics_are_not_available_in_this_session_A_nativ_6386","Performance timings for '--diagnostics' or '--extendedDiagnostics' are not available in this session. A native implementation of the Web Performance API could not be found."),The_signature_0_of_1_is_deprecated:N(6387,2,"The_signature_0_of_1_is_deprecated_6387","The signature '{0}' of '{1}' is deprecated.",void 0,void 0,!0),Project_0_is_being_forcibly_rebuilt:N(6388,3,"Project_0_is_being_forcibly_rebuilt_6388","Project '{0}' is being forcibly rebuilt"),Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved:N(6389,3,"Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved_6389","Reusing resolution of module '{0}' from '{1}' of old program, it was not resolved."),Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2:N(6390,3,"Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved__6390","Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was successfully resolved to '{2}'."),Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3:N(6391,3,"Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved__6391","Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was successfully resolved to '{2}' with Package ID '{3}'."),Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved:N(6392,3,"Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved_6392","Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was not resolved."),Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3:N(6393,3,"Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_6393","Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}'."),Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4:N(6394,3,"Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_6394","Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}' with Package ID '{4}'."),Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_not_resolved:N(6395,3,"Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_not_resolved_6395","Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was not resolved."),Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3:N(6396,3,"Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_succes_6396","Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}'."),Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4:N(6397,3,"Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_succes_6397","Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}' with Package ID '{4}'."),Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_not_resolved:N(6398,3,"Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_not_re_6398","Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was not resolved."),Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_some_of_the_changes_were_not_emitted:N(6399,3,"Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_some_of_the_changes_were_not_emitte_6399","Project '{0}' is out of date because buildinfo file '{1}' indicates that some of the changes were not emitted"),Project_0_is_up_to_date_but_needs_to_update_timestamps_of_output_files_that_are_older_than_input_files:N(6400,3,"Project_0_is_up_to_date_but_needs_to_update_timestamps_of_output_files_that_are_older_than_input_fil_6400","Project '{0}' is up to date but needs to update timestamps of output files that are older than input files"),Project_0_is_out_of_date_because_there_was_error_reading_file_1:N(6401,3,"Project_0_is_out_of_date_because_there_was_error_reading_file_1_6401","Project '{0}' is out of date because there was error reading file '{1}'"),Resolving_in_0_mode_with_conditions_1:N(6402,3,"Resolving_in_0_mode_with_conditions_1_6402","Resolving in {0} mode with conditions {1}."),Matched_0_condition_1:N(6403,3,"Matched_0_condition_1_6403","Matched '{0}' condition '{1}'."),Using_0_subpath_1_with_target_2:N(6404,3,"Using_0_subpath_1_with_target_2_6404","Using '{0}' subpath '{1}' with target '{2}'."),Saw_non_matching_condition_0:N(6405,3,"Saw_non_matching_condition_0_6405","Saw non-matching condition '{0}'."),Project_0_is_out_of_date_because_buildinfo_file_1_indicates_there_is_change_in_compilerOptions:N(6406,3,"Project_0_is_out_of_date_because_buildinfo_file_1_indicates_there_is_change_in_compilerOptions_6406","Project '{0}' is out of date because buildinfo file '{1}' indicates there is change in compilerOptions"),Allow_imports_to_include_TypeScript_file_extensions_Requires_moduleResolution_bundler_and_either_noEmit_or_emitDeclarationOnly_to_be_set:N(6407,3,"Allow_imports_to_include_TypeScript_file_extensions_Requires_moduleResolution_bundler_and_either_noE_6407","Allow imports to include TypeScript file extensions. Requires '--moduleResolution bundler' and either '--noEmit' or '--emitDeclarationOnly' to be set."),Use_the_package_json_exports_field_when_resolving_package_imports:N(6408,3,"Use_the_package_json_exports_field_when_resolving_package_imports_6408","Use the package.json 'exports' field when resolving package imports."),Use_the_package_json_imports_field_when_resolving_imports:N(6409,3,"Use_the_package_json_imports_field_when_resolving_imports_6409","Use the package.json 'imports' field when resolving imports."),Conditions_to_set_in_addition_to_the_resolver_specific_defaults_when_resolving_imports:N(6410,3,"Conditions_to_set_in_addition_to_the_resolver_specific_defaults_when_resolving_imports_6410","Conditions to set in addition to the resolver-specific defaults when resolving imports."),true_when_moduleResolution_is_node16_nodenext_or_bundler_otherwise_false:N(6411,3,"true_when_moduleResolution_is_node16_nodenext_or_bundler_otherwise_false_6411","`true` when 'moduleResolution' is 'node16', 'nodenext', or 'bundler'; otherwise `false`."),Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_file_2_was_root_file_of_compilation_but_not_any_more:N(6412,3,"Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_file_2_was_root_file_of_compilation_6412","Project '{0}' is out of date because buildinfo file '{1}' indicates that file '{2}' was root file of compilation but not any more."),Entering_conditional_exports:N(6413,3,"Entering_conditional_exports_6413","Entering conditional exports."),Resolved_under_condition_0:N(6414,3,"Resolved_under_condition_0_6414","Resolved under condition '{0}'."),Failed_to_resolve_under_condition_0:N(6415,3,"Failed_to_resolve_under_condition_0_6415","Failed to resolve under condition '{0}'."),Exiting_conditional_exports:N(6416,3,"Exiting_conditional_exports_6416","Exiting conditional exports."),Searching_all_ancestor_node_modules_directories_for_preferred_extensions_Colon_0:N(6417,3,"Searching_all_ancestor_node_modules_directories_for_preferred_extensions_Colon_0_6417","Searching all ancestor node_modules directories for preferred extensions: {0}."),Searching_all_ancestor_node_modules_directories_for_fallback_extensions_Colon_0:N(6418,3,"Searching_all_ancestor_node_modules_directories_for_fallback_extensions_Colon_0_6418","Searching all ancestor node_modules directories for fallback extensions: {0}."),The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1:N(6500,3,"The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1_6500","The expected type comes from property '{0}' which is declared here on type '{1}'"),The_expected_type_comes_from_this_index_signature:N(6501,3,"The_expected_type_comes_from_this_index_signature_6501","The expected type comes from this index signature."),The_expected_type_comes_from_the_return_type_of_this_signature:N(6502,3,"The_expected_type_comes_from_the_return_type_of_this_signature_6502","The expected type comes from the return type of this signature."),Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing:N(6503,3,"Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing_6503","Print names of files that are part of the compilation and then stop processing."),File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option:N(6504,1,"File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option_6504","File '{0}' is a JavaScript file. Did you mean to enable the 'allowJs' option?"),Print_names_of_files_and_the_reason_they_are_part_of_the_compilation:N(6505,3,"Print_names_of_files_and_the_reason_they_are_part_of_the_compilation_6505","Print names of files and the reason they are part of the compilation."),Consider_adding_a_declare_modifier_to_this_class:N(6506,3,"Consider_adding_a_declare_modifier_to_this_class_6506","Consider adding a 'declare' modifier to this class."),Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these_files:N(6600,3,"Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these__6600","Allow JavaScript files to be a part of your program. Use the 'checkJS' option to get errors from these files."),Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export:N(6601,3,"Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export_6601","Allow 'import x from y' when a module doesn't have a default export."),Allow_accessing_UMD_globals_from_modules:N(6602,3,"Allow_accessing_UMD_globals_from_modules_6602","Allow accessing UMD globals from modules."),Disable_error_reporting_for_unreachable_code:N(6603,3,"Disable_error_reporting_for_unreachable_code_6603","Disable error reporting for unreachable code."),Disable_error_reporting_for_unused_labels:N(6604,3,"Disable_error_reporting_for_unused_labels_6604","Disable error reporting for unused labels."),Ensure_use_strict_is_always_emitted:N(6605,3,"Ensure_use_strict_is_always_emitted_6605","Ensure 'use strict' is always emitted."),Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it:N(6606,3,"Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_wi_6606","Have recompiles in projects that use 'incremental' and 'watch' mode assume that changes within a file will only affect files directly depending on it."),Specify_the_base_directory_to_resolve_non_relative_module_names:N(6607,3,"Specify_the_base_directory_to_resolve_non_relative_module_names_6607","Specify the base directory to resolve non-relative module names."),No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files:N(6608,3,"No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files_6608","No longer supported. In early versions, manually set the text encoding for reading files."),Enable_error_reporting_in_type_checked_JavaScript_files:N(6609,3,"Enable_error_reporting_in_type_checked_JavaScript_files_6609","Enable error reporting in type-checked JavaScript files."),Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references:N(6611,3,"Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references_6611","Enable constraints that allow a TypeScript project to be used with project references."),Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project:N(6612,3,"Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project_6612","Generate .d.ts files from TypeScript and JavaScript files in your project."),Specify_the_output_directory_for_generated_declaration_files:N(6613,3,"Specify_the_output_directory_for_generated_declaration_files_6613","Specify the output directory for generated declaration files."),Create_sourcemaps_for_d_ts_files:N(6614,3,"Create_sourcemaps_for_d_ts_files_6614","Create sourcemaps for d.ts files."),Output_compiler_performance_information_after_building:N(6615,3,"Output_compiler_performance_information_after_building_6615","Output compiler performance information after building."),Disables_inference_for_type_acquisition_by_looking_at_filenames_in_a_project:N(6616,3,"Disables_inference_for_type_acquisition_by_looking_at_filenames_in_a_project_6616","Disables inference for type acquisition by looking at filenames in a project."),Reduce_the_number_of_projects_loaded_automatically_by_TypeScript:N(6617,3,"Reduce_the_number_of_projects_loaded_automatically_by_TypeScript_6617","Reduce the number of projects loaded automatically by TypeScript."),Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server:N(6618,3,"Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server_6618","Remove the 20mb cap on total source code size for JavaScript files in the TypeScript language server."),Opt_a_project_out_of_multi_project_reference_checking_when_editing:N(6619,3,"Opt_a_project_out_of_multi_project_reference_checking_when_editing_6619","Opt a project out of multi-project reference checking when editing."),Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects:N(6620,3,"Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects_6620","Disable preferring source files instead of declaration files when referencing composite projects."),Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration:N(6621,3,"Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration_6621","Emit more compliant, but verbose and less performant JavaScript for iteration."),Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files:N(6622,3,"Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files_6622","Emit a UTF-8 Byte Order Mark (BOM) in the beginning of output files."),Only_output_d_ts_files_and_not_JavaScript_files:N(6623,3,"Only_output_d_ts_files_and_not_JavaScript_files_6623","Only output d.ts files and not JavaScript files."),Emit_design_type_metadata_for_decorated_declarations_in_source_files:N(6624,3,"Emit_design_type_metadata_for_decorated_declarations_in_source_files_6624","Emit design-type metadata for decorated declarations in source files."),Disable_the_type_acquisition_for_JavaScript_projects:N(6625,3,"Disable_the_type_acquisition_for_JavaScript_projects_6625","Disable the type acquisition for JavaScript projects"),Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheticDefaultImports_for_type_compatibility:N(6626,3,"Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheti_6626","Emit additional JavaScript to ease support for importing CommonJS modules. This enables 'allowSyntheticDefaultImports' for type compatibility."),Filters_results_from_the_include_option:N(6627,3,"Filters_results_from_the_include_option_6627","Filters results from the `include` option."),Remove_a_list_of_directories_from_the_watch_process:N(6628,3,"Remove_a_list_of_directories_from_the_watch_process_6628","Remove a list of directories from the watch process."),Remove_a_list_of_files_from_the_watch_mode_s_processing:N(6629,3,"Remove_a_list_of_files_from_the_watch_mode_s_processing_6629","Remove a list of files from the watch mode's processing."),Enable_experimental_support_for_legacy_experimental_decorators:N(6630,3,"Enable_experimental_support_for_legacy_experimental_decorators_6630","Enable experimental support for legacy experimental decorators."),Print_files_read_during_the_compilation_including_why_it_was_included:N(6631,3,"Print_files_read_during_the_compilation_including_why_it_was_included_6631","Print files read during the compilation including why it was included."),Output_more_detailed_compiler_performance_information_after_building:N(6632,3,"Output_more_detailed_compiler_performance_information_after_building_6632","Output more detailed compiler performance information after building."),Specify_one_or_more_path_or_node_module_references_to_base_configuration_files_from_which_settings_are_inherited:N(6633,3,"Specify_one_or_more_path_or_node_module_references_to_base_configuration_files_from_which_settings_a_6633","Specify one or more path or node module references to base configuration files from which settings are inherited."),Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers:N(6634,3,"Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers_6634","Specify what approach the watcher should use if the system runs out of native file watchers."),Include_a_list_of_files_This_does_not_support_glob_patterns_as_opposed_to_include:N(6635,3,"Include_a_list_of_files_This_does_not_support_glob_patterns_as_opposed_to_include_6635","Include a list of files. This does not support glob patterns, as opposed to `include`."),Build_all_projects_including_those_that_appear_to_be_up_to_date:N(6636,3,"Build_all_projects_including_those_that_appear_to_be_up_to_date_6636","Build all projects, including those that appear to be up to date."),Ensure_that_casing_is_correct_in_imports:N(6637,3,"Ensure_that_casing_is_correct_in_imports_6637","Ensure that casing is correct in imports."),Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging:N(6638,3,"Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging_6638","Emit a v8 CPU profile of the compiler run for debugging."),Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file:N(6639,3,"Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file_6639","Allow importing helper functions from tslib once per project, instead of including them per-file."),Specify_a_list_of_glob_patterns_that_match_files_to_be_included_in_compilation:N(6641,3,"Specify_a_list_of_glob_patterns_that_match_files_to_be_included_in_compilation_6641","Specify a list of glob patterns that match files to be included in compilation."),Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects:N(6642,3,"Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects_6642","Save .tsbuildinfo files to allow for incremental compilation of projects."),Include_sourcemap_files_inside_the_emitted_JavaScript:N(6643,3,"Include_sourcemap_files_inside_the_emitted_JavaScript_6643","Include sourcemap files inside the emitted JavaScript."),Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript:N(6644,3,"Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript_6644","Include source code in the sourcemaps inside the emitted JavaScript."),Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports:N(6645,3,"Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports_6645","Ensure that each file can be safely transpiled without relying on other imports."),Specify_what_JSX_code_is_generated:N(6646,3,"Specify_what_JSX_code_is_generated_6646","Specify what JSX code is generated."),Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h:N(6647,3,"Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h_6647","Specify the JSX factory function used when targeting React JSX emit, e.g. 'React.createElement' or 'h'."),Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragment_or_Fragment:N(6648,3,"Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragme_6648","Specify the JSX Fragment reference used for fragments when targeting React JSX emit e.g. 'React.Fragment' or 'Fragment'."),Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Asterisk:N(6649,3,"Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Ast_6649","Specify module specifier used to import the JSX factory functions when using 'jsx: react-jsx*'."),Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option:N(6650,3,"Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option_6650","Make keyof only return strings instead of string, numbers or symbols. Legacy option."),Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment:N(6651,3,"Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment_6651","Specify a set of bundled library declaration files that describe the target runtime environment."),Print_the_names_of_emitted_files_after_a_compilation:N(6652,3,"Print_the_names_of_emitted_files_after_a_compilation_6652","Print the names of emitted files after a compilation."),Print_all_of_the_files_read_during_the_compilation:N(6653,3,"Print_all_of_the_files_read_during_the_compilation_6653","Print all of the files read during the compilation."),Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit:N(6654,3,"Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit_6654","Set the language of the messaging from TypeScript. This does not affect emit."),Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations:N(6655,3,"Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations_6655","Specify the location where debugger should locate map files instead of generated locations."),Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicable_with_allowJs:N(6656,3,"Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicabl_6656","Specify the maximum folder depth used for checking JavaScript files from 'node_modules'. Only applicable with 'allowJs'."),Specify_what_module_code_is_generated:N(6657,3,"Specify_what_module_code_is_generated_6657","Specify what module code is generated."),Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier:N(6658,3,"Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier_6658","Specify how TypeScript looks up a file from a given module specifier."),Set_the_newline_character_for_emitting_files:N(6659,3,"Set_the_newline_character_for_emitting_files_6659","Set the newline character for emitting files."),Disable_emitting_files_from_a_compilation:N(6660,3,"Disable_emitting_files_from_a_compilation_6660","Disable emitting files from a compilation."),Disable_generating_custom_helper_functions_like_extends_in_compiled_output:N(6661,3,"Disable_generating_custom_helper_functions_like_extends_in_compiled_output_6661","Disable generating custom helper functions like '__extends' in compiled output."),Disable_emitting_files_if_any_type_checking_errors_are_reported:N(6662,3,"Disable_emitting_files_if_any_type_checking_errors_are_reported_6662","Disable emitting files if any type checking errors are reported."),Disable_truncating_types_in_error_messages:N(6663,3,"Disable_truncating_types_in_error_messages_6663","Disable truncating types in error messages."),Enable_error_reporting_for_fallthrough_cases_in_switch_statements:N(6664,3,"Enable_error_reporting_for_fallthrough_cases_in_switch_statements_6664","Enable error reporting for fallthrough cases in switch statements."),Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type:N(6665,3,"Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type_6665","Enable error reporting for expressions and declarations with an implied 'any' type."),Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier:N(6666,3,"Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier_6666","Ensure overriding members in derived classes are marked with an override modifier."),Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function:N(6667,3,"Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function_6667","Enable error reporting for codepaths that do not explicitly return in a function."),Enable_error_reporting_when_this_is_given_the_type_any:N(6668,3,"Enable_error_reporting_when_this_is_given_the_type_any_6668","Enable error reporting when 'this' is given the type 'any'."),Disable_adding_use_strict_directives_in_emitted_JavaScript_files:N(6669,3,"Disable_adding_use_strict_directives_in_emitted_JavaScript_files_6669","Disable adding 'use strict' directives in emitted JavaScript files."),Disable_including_any_library_files_including_the_default_lib_d_ts:N(6670,3,"Disable_including_any_library_files_including_the_default_lib_d_ts_6670","Disable including any library files, including the default lib.d.ts."),Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type:N(6671,3,"Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type_6671","Enforces using indexed accessors for keys declared using an indexed type."),Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add_to_a_project:N(6672,3,"Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add__6672","Disallow 'import's, 'require's or '<reference>'s from expanding the number of files TypeScript should add to a project."),Disable_strict_checking_of_generic_signatures_in_function_types:N(6673,3,"Disable_strict_checking_of_generic_signatures_in_function_types_6673","Disable strict checking of generic signatures in function types."),Add_undefined_to_a_type_when_accessed_using_an_index:N(6674,3,"Add_undefined_to_a_type_when_accessed_using_an_index_6674","Add 'undefined' to a type when accessed using an index."),Enable_error_reporting_when_local_variables_aren_t_read:N(6675,3,"Enable_error_reporting_when_local_variables_aren_t_read_6675","Enable error reporting when local variables aren't read."),Raise_an_error_when_a_function_parameter_isn_t_read:N(6676,3,"Raise_an_error_when_a_function_parameter_isn_t_read_6676","Raise an error when a function parameter isn't read."),Deprecated_setting_Use_outFile_instead:N(6677,3,"Deprecated_setting_Use_outFile_instead_6677","Deprecated setting. Use 'outFile' instead."),Specify_an_output_folder_for_all_emitted_files:N(6678,3,"Specify_an_output_folder_for_all_emitted_files_6678","Specify an output folder for all emitted files."),Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designates_a_file_that_bundles_all_d_ts_output:N(6679,3,"Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designa_6679","Specify a file that bundles all outputs into one JavaScript file. If 'declaration' is true, also designates a file that bundles all .d.ts output."),Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations:N(6680,3,"Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations_6680","Specify a set of entries that re-map imports to additional lookup locations."),Specify_a_list_of_language_service_plugins_to_include:N(6681,3,"Specify_a_list_of_language_service_plugins_to_include_6681","Specify a list of language service plugins to include."),Disable_erasing_const_enum_declarations_in_generated_code:N(6682,3,"Disable_erasing_const_enum_declarations_in_generated_code_6682","Disable erasing 'const enum' declarations in generated code."),Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node:N(6683,3,"Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node_6683","Disable resolving symlinks to their realpath. This correlates to the same flag in node."),Disable_wiping_the_console_in_watch_mode:N(6684,3,"Disable_wiping_the_console_in_watch_mode_6684","Disable wiping the console in watch mode."),Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read:N(6685,3,"Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read_6685","Enable color and formatting in TypeScript's output to make compiler errors easier to read."),Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit:N(6686,3,"Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit_6686","Specify the object invoked for 'createElement'. This only applies when targeting 'react' JSX emit."),Specify_an_array_of_objects_that_specify_paths_for_projects_Used_in_project_references:N(6687,3,"Specify_an_array_of_objects_that_specify_paths_for_projects_Used_in_project_references_6687","Specify an array of objects that specify paths for projects. Used in project references."),Disable_emitting_comments:N(6688,3,"Disable_emitting_comments_6688","Disable emitting comments."),Enable_importing_json_files:N(6689,3,"Enable_importing_json_files_6689","Enable importing .json files."),Specify_the_root_folder_within_your_source_files:N(6690,3,"Specify_the_root_folder_within_your_source_files_6690","Specify the root folder within your source files."),Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules:N(6691,3,"Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules_6691","Allow multiple folders to be treated as one when resolving modules."),Skip_type_checking_d_ts_files_that_are_included_with_TypeScript:N(6692,3,"Skip_type_checking_d_ts_files_that_are_included_with_TypeScript_6692","Skip type checking .d.ts files that are included with TypeScript."),Skip_type_checking_all_d_ts_files:N(6693,3,"Skip_type_checking_all_d_ts_files_6693","Skip type checking all .d.ts files."),Create_source_map_files_for_emitted_JavaScript_files:N(6694,3,"Create_source_map_files_for_emitted_JavaScript_files_6694","Create source map files for emitted JavaScript files."),Specify_the_root_path_for_debuggers_to_find_the_reference_source_code:N(6695,3,"Specify_the_root_path_for_debuggers_to_find_the_reference_source_code_6695","Specify the root path for debuggers to find the reference source code."),Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function:N(6697,3,"Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function_6697","Check that the arguments for 'bind', 'call', and 'apply' methods match the original function."),When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible:N(6698,3,"When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible_6698","When assigning functions, check to ensure parameters and the return values are subtype-compatible."),When_type_checking_take_into_account_null_and_undefined:N(6699,3,"When_type_checking_take_into_account_null_and_undefined_6699","When type checking, take into account 'null' and 'undefined'."),Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor:N(6700,3,"Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor_6700","Check for class properties that are declared but not set in the constructor."),Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments:N(6701,3,"Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments_6701","Disable emitting declarations that have '@internal' in their JSDoc comments."),Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals:N(6702,3,"Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals_6702","Disable reporting of excess property errors during the creation of object literals."),Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures:N(6703,3,"Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures_6703","Suppress 'noImplicitAny' errors when indexing objects that lack index signatures."),Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively:N(6704,3,"Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_supp_6704","Synchronously call callbacks and update the state of directory watchers on platforms that don`t support recursive watching natively."),Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declarations:N(6705,3,"Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declaratio_6705","Set the JavaScript language version for emitted JavaScript and include compatible library declarations."),Log_paths_used_during_the_moduleResolution_process:N(6706,3,"Log_paths_used_during_the_moduleResolution_process_6706","Log paths used during the 'moduleResolution' process."),Specify_the_path_to_tsbuildinfo_incremental_compilation_file:N(6707,3,"Specify_the_path_to_tsbuildinfo_incremental_compilation_file_6707","Specify the path to .tsbuildinfo incremental compilation file."),Specify_options_for_automatic_acquisition_of_declaration_files:N(6709,3,"Specify_options_for_automatic_acquisition_of_declaration_files_6709","Specify options for automatic acquisition of declaration files."),Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types:N(6710,3,"Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types_6710","Specify multiple folders that act like './node_modules/@types'."),Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file:N(6711,3,"Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file_6711","Specify type package names to be included without being referenced in a source file."),Emit_ECMAScript_standard_compliant_class_fields:N(6712,3,"Emit_ECMAScript_standard_compliant_class_fields_6712","Emit ECMAScript-standard-compliant class fields."),Enable_verbose_logging:N(6713,3,"Enable_verbose_logging_6713","Enable verbose logging."),Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality:N(6714,3,"Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality_6714","Specify how directories are watched on systems that lack recursive file-watching functionality."),Specify_how_the_TypeScript_watch_mode_works:N(6715,3,"Specify_how_the_TypeScript_watch_mode_works_6715","Specify how the TypeScript watch mode works."),Require_undeclared_properties_from_index_signatures_to_use_element_accesses:N(6717,3,"Require_undeclared_properties_from_index_signatures_to_use_element_accesses_6717","Require undeclared properties from index signatures to use element accesses."),Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types:N(6718,3,"Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types_6718","Specify emit/checking behavior for imports that are only used for types."),Require_sufficient_annotation_on_exports_so_other_tools_can_trivially_generate_declaration_files:N(6719,3,"Require_sufficient_annotation_on_exports_so_other_tools_can_trivially_generate_declaration_files_6719","Require sufficient annotation on exports so other tools can trivially generate declaration files."),Default_catch_clause_variables_as_unknown_instead_of_any:N(6803,3,"Default_catch_clause_variables_as_unknown_instead_of_any_6803","Default catch clause variables as 'unknown' instead of 'any'."),Do_not_transform_or_elide_any_imports_or_exports_not_marked_as_type_only_ensuring_they_are_written_in_the_output_file_s_format_based_on_the_module_setting:N(6804,3,"Do_not_transform_or_elide_any_imports_or_exports_not_marked_as_type_only_ensuring_they_are_written_i_6804","Do not transform or elide any imports or exports not marked as type-only, ensuring they are written in the output file's format based on the 'module' setting."),Disable_full_type_checking_only_critical_parse_and_emit_errors_will_be_reported:N(6805,3,"Disable_full_type_checking_only_critical_parse_and_emit_errors_will_be_reported_6805","Disable full type checking (only critical parse and emit errors will be reported)."),one_of_Colon:N(6900,3,"one_of_Colon_6900","one of:"),one_or_more_Colon:N(6901,3,"one_or_more_Colon_6901","one or more:"),type_Colon:N(6902,3,"type_Colon_6902","type:"),default_Colon:N(6903,3,"default_Colon_6903","default:"),module_system_or_esModuleInterop:N(6904,3,"module_system_or_esModuleInterop_6904",'module === "system" or esModuleInterop'),false_unless_strict_is_set:N(6905,3,"false_unless_strict_is_set_6905","`false`, unless `strict` is set"),false_unless_composite_is_set:N(6906,3,"false_unless_composite_is_set_6906","`false`, unless `composite` is set"),node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified:N(6907,3,"node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified_6907",'`["node_modules", "bower_components", "jspm_packages"]`, plus the value of `outDir` if one is specified.'),if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk:N(6908,3,"if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk_6908",'`[]` if `files` is specified, otherwise `["**/*"]`'),true_if_composite_false_otherwise:N(6909,3,"true_if_composite_false_otherwise_6909","`true` if `composite`, `false` otherwise"),module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node:N(69010,3,"module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node_69010","module === `AMD` or `UMD` or `System` or `ES6`, then `Classic`, Otherwise `Node`"),Computed_from_the_list_of_input_files:N(6911,3,"Computed_from_the_list_of_input_files_6911","Computed from the list of input files"),Platform_specific:N(6912,3,"Platform_specific_6912","Platform specific"),You_can_learn_about_all_of_the_compiler_options_at_0:N(6913,3,"You_can_learn_about_all_of_the_compiler_options_at_0_6913","You can learn about all of the compiler options at {0}"),Including_watch_w_will_start_watching_the_current_project_for_the_file_changes_Once_set_you_can_config_watch_mode_with_Colon:N(6914,3,"Including_watch_w_will_start_watching_the_current_project_for_the_file_changes_Once_set_you_can_conf_6914","Including --watch, -w will start watching the current project for the file changes. Once set, you can config watch mode with:"),Using_build_b_will_make_tsc_behave_more_like_a_build_orchestrator_than_a_compiler_This_is_used_to_trigger_building_composite_projects_which_you_can_learn_more_about_at_0:N(6915,3,"Using_build_b_will_make_tsc_behave_more_like_a_build_orchestrator_than_a_compiler_This_is_used_to_tr_6915","Using --build, -b will make tsc behave more like a build orchestrator than a compiler. This is used to trigger building composite projects which you can learn more about at {0}"),COMMON_COMMANDS:N(6916,3,"COMMON_COMMANDS_6916","COMMON COMMANDS"),ALL_COMPILER_OPTIONS:N(6917,3,"ALL_COMPILER_OPTIONS_6917","ALL COMPILER OPTIONS"),WATCH_OPTIONS:N(6918,3,"WATCH_OPTIONS_6918","WATCH OPTIONS"),BUILD_OPTIONS:N(6919,3,"BUILD_OPTIONS_6919","BUILD OPTIONS"),COMMON_COMPILER_OPTIONS:N(6920,3,"COMMON_COMPILER_OPTIONS_6920","COMMON COMPILER OPTIONS"),COMMAND_LINE_FLAGS:N(6921,3,"COMMAND_LINE_FLAGS_6921","COMMAND LINE FLAGS"),tsc_Colon_The_TypeScript_Compiler:N(6922,3,"tsc_Colon_The_TypeScript_Compiler_6922","tsc: The TypeScript Compiler"),Compiles_the_current_project_tsconfig_json_in_the_working_directory:N(6923,3,"Compiles_the_current_project_tsconfig_json_in_the_working_directory_6923","Compiles the current project (tsconfig.json in the working directory.)"),Ignoring_tsconfig_json_compiles_the_specified_files_with_default_compiler_options:N(6924,3,"Ignoring_tsconfig_json_compiles_the_specified_files_with_default_compiler_options_6924","Ignoring tsconfig.json, compiles the specified files with default compiler options."),Build_a_composite_project_in_the_working_directory:N(6925,3,"Build_a_composite_project_in_the_working_directory_6925","Build a composite project in the working directory."),Creates_a_tsconfig_json_with_the_recommended_settings_in_the_working_directory:N(6926,3,"Creates_a_tsconfig_json_with_the_recommended_settings_in_the_working_directory_6926","Creates a tsconfig.json with the recommended settings in the working directory."),Compiles_the_TypeScript_project_located_at_the_specified_path:N(6927,3,"Compiles_the_TypeScript_project_located_at_the_specified_path_6927","Compiles the TypeScript project located at the specified path."),An_expanded_version_of_this_information_showing_all_possible_compiler_options:N(6928,3,"An_expanded_version_of_this_information_showing_all_possible_compiler_options_6928","An expanded version of this information, showing all possible compiler options"),Compiles_the_current_project_with_additional_settings:N(6929,3,"Compiles_the_current_project_with_additional_settings_6929","Compiles the current project, with additional settings."),true_for_ES2022_and_above_including_ESNext:N(6930,3,"true_for_ES2022_and_above_including_ESNext_6930","`true` for ES2022 and above, including ESNext."),List_of_file_name_suffixes_to_search_when_resolving_a_module:N(6931,1,"List_of_file_name_suffixes_to_search_when_resolving_a_module_6931","List of file name suffixes to search when resolving a module."),Variable_0_implicitly_has_an_1_type:N(7005,1,"Variable_0_implicitly_has_an_1_type_7005","Variable '{0}' implicitly has an '{1}' type."),Parameter_0_implicitly_has_an_1_type:N(7006,1,"Parameter_0_implicitly_has_an_1_type_7006","Parameter '{0}' implicitly has an '{1}' type."),Member_0_implicitly_has_an_1_type:N(7008,1,"Member_0_implicitly_has_an_1_type_7008","Member '{0}' implicitly has an '{1}' type."),new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type:N(7009,1,"new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type_7009","'new' expression, whose target lacks a construct signature, implicitly has an 'any' type."),_0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type:N(7010,1,"_0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type_7010","'{0}', which lacks return-type annotation, implicitly has an '{1}' return type."),Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type:N(7011,1,"Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7011","Function expression, which lacks return-type annotation, implicitly has an '{0}' return type."),This_overload_implicitly_returns_the_type_0_because_it_lacks_a_return_type_annotation:N(7012,1,"This_overload_implicitly_returns_the_type_0_because_it_lacks_a_return_type_annotation_7012","This overload implicitly returns the type '{0}' because it lacks a return type annotation."),Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type:N(7013,1,"Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7013","Construct signature, which lacks return-type annotation, implicitly has an 'any' return type."),Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type:N(7014,1,"Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7014","Function type, which lacks return-type annotation, implicitly has an '{0}' return type."),Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number:N(7015,1,"Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number_7015","Element implicitly has an 'any' type because index expression is not of type 'number'."),Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type:N(7016,1,"Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type_7016","Could not find a declaration file for module '{0}'. '{1}' implicitly has an 'any' type."),Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature:N(7017,1,"Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_7017","Element implicitly has an 'any' type because type '{0}' has no index signature."),Object_literal_s_property_0_implicitly_has_an_1_type:N(7018,1,"Object_literal_s_property_0_implicitly_has_an_1_type_7018","Object literal's property '{0}' implicitly has an '{1}' type."),Rest_parameter_0_implicitly_has_an_any_type:N(7019,1,"Rest_parameter_0_implicitly_has_an_any_type_7019","Rest parameter '{0}' implicitly has an 'any[]' type."),Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type:N(7020,1,"Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7020","Call signature, which lacks return-type annotation, implicitly has an 'any' return type."),_0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer:N(7022,1,"_0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or__7022","'{0}' implicitly has type 'any' because it does not have a type annotation and is referenced directly or indirectly in its own initializer."),_0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions:N(7023,1,"_0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_reference_7023","'{0}' implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."),Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions:N(7024,1,"Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_ref_7024","Function implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."),Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type_annotation:N(7025,1,"Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_retu_7025","Generator implicitly has yield type '{0}' because it does not yield any values. Consider supplying a return type annotation."),JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists:N(7026,1,"JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists_7026","JSX element implicitly has type 'any' because no interface 'JSX.{0}' exists."),Unreachable_code_detected:N(7027,1,"Unreachable_code_detected_7027","Unreachable code detected.",!0),Unused_label:N(7028,1,"Unused_label_7028","Unused label.",!0),Fallthrough_case_in_switch:N(7029,1,"Fallthrough_case_in_switch_7029","Fallthrough case in switch."),Not_all_code_paths_return_a_value:N(7030,1,"Not_all_code_paths_return_a_value_7030","Not all code paths return a value."),Binding_element_0_implicitly_has_an_1_type:N(7031,1,"Binding_element_0_implicitly_has_an_1_type_7031","Binding element '{0}' implicitly has an '{1}' type."),Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation:N(7032,1,"Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation_7032","Property '{0}' implicitly has type 'any', because its set accessor lacks a parameter type annotation."),Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation:N(7033,1,"Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation_7033","Property '{0}' implicitly has type 'any', because its get accessor lacks a return type annotation."),Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined:N(7034,1,"Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined_7034","Variable '{0}' implicitly has type '{1}' in some locations where its type cannot be determined."),Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0:N(7035,1,"Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare__7035","Try `npm i --save-dev @types/{1}` if it exists or add a new declaration (.d.ts) file containing `declare module '{0}';`"),Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0:N(7036,1,"Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0_7036","Dynamic import's specifier must be of type 'string', but here has type '{0}'."),Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for_all_imports_Implies_allowSyntheticDefaultImports:N(7037,3,"Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for__7037","Enables emit interoperability between CommonJS and ES Modules via creation of namespace objects for all imports. Implies 'allowSyntheticDefaultImports'."),Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead:N(7038,3,"Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cau_7038","Type originates at this import. A namespace-style import cannot be called or constructed, and will cause a failure at runtime. Consider using a default import or import require here instead."),Mapped_object_type_implicitly_has_an_any_template_type:N(7039,1,"Mapped_object_type_implicitly_has_an_any_template_type_7039","Mapped object type implicitly has an 'any' template type."),If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1:N(7040,1,"If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_S_7040","If the '{0}' package actually exposes this module, consider sending a pull request to amend 'https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/{1}'"),The_containing_arrow_function_captures_the_global_value_of_this:N(7041,1,"The_containing_arrow_function_captures_the_global_value_of_this_7041","The containing arrow function captures the global value of 'this'."),Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used:N(7042,1,"Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used_7042","Module '{0}' was resolved to '{1}', but '--resolveJsonModule' is not used."),Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage:N(7043,2,"Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7043","Variable '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage:N(7044,2,"Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7044","Parameter '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage:N(7045,2,"Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7045","Member '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage:N(7046,2,"Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage_7046","Variable '{0}' implicitly has type '{1}' in some locations, but a better type may be inferred from usage."),Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage:N(7047,2,"Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage_7047","Rest parameter '{0}' implicitly has an 'any[]' type, but a better type may be inferred from usage."),Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage:N(7048,2,"Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage_7048","Property '{0}' implicitly has type 'any', but a better type for its get accessor may be inferred from usage."),Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage:N(7049,2,"Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage_7049","Property '{0}' implicitly has type 'any', but a better type for its set accessor may be inferred from usage."),_0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage:N(7050,2,"_0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage_7050","'{0}' implicitly has an '{1}' return type, but a better type may be inferred from usage."),Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1:N(7051,1,"Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1_7051","Parameter has a name but no type. Did you mean '{0}: {1}'?"),Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1:N(7052,1,"Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1_7052","Element implicitly has an 'any' type because type '{0}' has no index signature. Did you mean to call '{1}'?"),Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1:N(7053,1,"Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1_7053","Element implicitly has an 'any' type because expression of type '{0}' can't be used to index type '{1}'."),No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1:N(7054,1,"No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1_7054","No index signature with a parameter of type '{0}' was found on type '{1}'."),_0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type:N(7055,1,"_0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type_7055","'{0}', which lacks return-type annotation, implicitly has an '{1}' yield type."),The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_type_annotation_is_needed:N(7056,1,"The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_ty_7056","The inferred type of this node exceeds the maximum length the compiler will serialize. An explicit type annotation is needed."),yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_type_annotation:N(7057,1,"yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_t_7057","'yield' expression implicitly results in an 'any' type because its containing generator lacks a return-type annotation."),If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_declare_module_1:N(7058,1,"If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_decl_7058","If the '{0}' package actually exposes this module, try adding a new declaration (.d.ts) file containing `declare module '{1}';`"),This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead:N(7059,1,"This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead_7059","This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead."),This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_constraint:N(7060,1,"This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_cons_7060","This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma or explicit constraint."),A_mapped_type_may_not_declare_properties_or_methods:N(7061,1,"A_mapped_type_may_not_declare_properties_or_methods_7061","A mapped type may not declare properties or methods."),You_cannot_rename_this_element:N(8e3,1,"You_cannot_rename_this_element_8000","You cannot rename this element."),You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library:N(8001,1,"You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library_8001","You cannot rename elements that are defined in the standard TypeScript library."),import_can_only_be_used_in_TypeScript_files:N(8002,1,"import_can_only_be_used_in_TypeScript_files_8002","'import ... =' can only be used in TypeScript files."),export_can_only_be_used_in_TypeScript_files:N(8003,1,"export_can_only_be_used_in_TypeScript_files_8003","'export =' can only be used in TypeScript files."),Type_parameter_declarations_can_only_be_used_in_TypeScript_files:N(8004,1,"Type_parameter_declarations_can_only_be_used_in_TypeScript_files_8004","Type parameter declarations can only be used in TypeScript files."),implements_clauses_can_only_be_used_in_TypeScript_files:N(8005,1,"implements_clauses_can_only_be_used_in_TypeScript_files_8005","'implements' clauses can only be used in TypeScript files."),_0_declarations_can_only_be_used_in_TypeScript_files:N(8006,1,"_0_declarations_can_only_be_used_in_TypeScript_files_8006","'{0}' declarations can only be used in TypeScript files."),Type_aliases_can_only_be_used_in_TypeScript_files:N(8008,1,"Type_aliases_can_only_be_used_in_TypeScript_files_8008","Type aliases can only be used in TypeScript files."),The_0_modifier_can_only_be_used_in_TypeScript_files:N(8009,1,"The_0_modifier_can_only_be_used_in_TypeScript_files_8009","The '{0}' modifier can only be used in TypeScript files."),Type_annotations_can_only_be_used_in_TypeScript_files:N(8010,1,"Type_annotations_can_only_be_used_in_TypeScript_files_8010","Type annotations can only be used in TypeScript files."),Type_arguments_can_only_be_used_in_TypeScript_files:N(8011,1,"Type_arguments_can_only_be_used_in_TypeScript_files_8011","Type arguments can only be used in TypeScript files."),Parameter_modifiers_can_only_be_used_in_TypeScript_files:N(8012,1,"Parameter_modifiers_can_only_be_used_in_TypeScript_files_8012","Parameter modifiers can only be used in TypeScript files."),Non_null_assertions_can_only_be_used_in_TypeScript_files:N(8013,1,"Non_null_assertions_can_only_be_used_in_TypeScript_files_8013","Non-null assertions can only be used in TypeScript files."),Type_assertion_expressions_can_only_be_used_in_TypeScript_files:N(8016,1,"Type_assertion_expressions_can_only_be_used_in_TypeScript_files_8016","Type assertion expressions can only be used in TypeScript files."),Signature_declarations_can_only_be_used_in_TypeScript_files:N(8017,1,"Signature_declarations_can_only_be_used_in_TypeScript_files_8017","Signature declarations can only be used in TypeScript files."),Report_errors_in_js_files:N(8019,3,"Report_errors_in_js_files_8019","Report errors in .js files."),JSDoc_types_can_only_be_used_inside_documentation_comments:N(8020,1,"JSDoc_types_can_only_be_used_inside_documentation_comments_8020","JSDoc types can only be used inside documentation comments."),JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags:N(8021,1,"JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags_8021","JSDoc '@typedef' tag should either have a type annotation or be followed by '@property' or '@member' tags."),JSDoc_0_is_not_attached_to_a_class:N(8022,1,"JSDoc_0_is_not_attached_to_a_class_8022","JSDoc '@{0}' is not attached to a class."),JSDoc_0_1_does_not_match_the_extends_2_clause:N(8023,1,"JSDoc_0_1_does_not_match_the_extends_2_clause_8023","JSDoc '@{0} {1}' does not match the 'extends {2}' clause."),JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name:N(8024,1,"JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_8024","JSDoc '@param' tag has name '{0}', but there is no parameter with that name."),Class_declarations_cannot_have_more_than_one_augments_or_extends_tag:N(8025,1,"Class_declarations_cannot_have_more_than_one_augments_or_extends_tag_8025","Class declarations cannot have more than one '@augments' or '@extends' tag."),Expected_0_type_arguments_provide_these_with_an_extends_tag:N(8026,1,"Expected_0_type_arguments_provide_these_with_an_extends_tag_8026","Expected {0} type arguments; provide these with an '@extends' tag."),Expected_0_1_type_arguments_provide_these_with_an_extends_tag:N(8027,1,"Expected_0_1_type_arguments_provide_these_with_an_extends_tag_8027","Expected {0}-{1} type arguments; provide these with an '@extends' tag."),JSDoc_may_only_appear_in_the_last_parameter_of_a_signature:N(8028,1,"JSDoc_may_only_appear_in_the_last_parameter_of_a_signature_8028","JSDoc '...' may only appear in the last parameter of a signature."),JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type:N(8029,1,"JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_h_8029","JSDoc '@param' tag has name '{0}', but there is no parameter with that name. It would match 'arguments' if it had an array type."),The_type_of_a_function_declaration_must_match_the_function_s_signature:N(8030,1,"The_type_of_a_function_declaration_must_match_the_function_s_signature_8030","The type of a function declaration must match the function's signature."),You_cannot_rename_a_module_via_a_global_import:N(8031,1,"You_cannot_rename_a_module_via_a_global_import_8031","You cannot rename a module via a global import."),Qualified_name_0_is_not_allowed_without_a_leading_param_object_1:N(8032,1,"Qualified_name_0_is_not_allowed_without_a_leading_param_object_1_8032","Qualified name '{0}' is not allowed without a leading '@param {object} {1}'."),A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags:N(8033,1,"A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags_8033","A JSDoc '@typedef' comment may not contain multiple '@type' tags."),The_tag_was_first_specified_here:N(8034,1,"The_tag_was_first_specified_here_8034","The tag was first specified here."),You_cannot_rename_elements_that_are_defined_in_a_node_modules_folder:N(8035,1,"You_cannot_rename_elements_that_are_defined_in_a_node_modules_folder_8035","You cannot rename elements that are defined in a 'node_modules' folder."),You_cannot_rename_elements_that_are_defined_in_another_node_modules_folder:N(8036,1,"You_cannot_rename_elements_that_are_defined_in_another_node_modules_folder_8036","You cannot rename elements that are defined in another 'node_modules' folder."),Type_satisfaction_expressions_can_only_be_used_in_TypeScript_files:N(8037,1,"Type_satisfaction_expressions_can_only_be_used_in_TypeScript_files_8037","Type satisfaction expressions can only be used in TypeScript files."),Decorators_may_not_appear_after_export_or_export_default_if_they_also_appear_before_export:N(8038,1,"Decorators_may_not_appear_after_export_or_export_default_if_they_also_appear_before_export_8038","Decorators may not appear after 'export' or 'export default' if they also appear before 'export'."),A_JSDoc_template_tag_may_not_follow_a_typedef_callback_or_overload_tag:N(8039,1,"A_JSDoc_template_tag_may_not_follow_a_typedef_callback_or_overload_tag_8039","A JSDoc '@template' tag may not follow a '@typedef', '@callback', or '@overload' tag"),Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_declaration_emit:N(9005,1,"Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_9005","Declaration emit for this file requires using private name '{0}'. An explicit type annotation may unblock declaration emit."),Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotation_may_unblock_declaration_emit:N(9006,1,"Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotati_9006","Declaration emit for this file requires using private name '{0}' from module '{1}'. An explicit type annotation may unblock declaration emit."),Function_must_have_an_explicit_return_type_annotation_with_isolatedDeclarations:N(9007,1,"Function_must_have_an_explicit_return_type_annotation_with_isolatedDeclarations_9007","Function must have an explicit return type annotation with --isolatedDeclarations."),Method_must_have_an_explicit_return_type_annotation_with_isolatedDeclarations:N(9008,1,"Method_must_have_an_explicit_return_type_annotation_with_isolatedDeclarations_9008","Method must have an explicit return type annotation with --isolatedDeclarations."),At_least_one_accessor_must_have_an_explicit_return_type_annotation_with_isolatedDeclarations:N(9009,1,"At_least_one_accessor_must_have_an_explicit_return_type_annotation_with_isolatedDeclarations_9009","At least one accessor must have an explicit return type annotation with --isolatedDeclarations."),Variable_must_have_an_explicit_type_annotation_with_isolatedDeclarations:N(9010,1,"Variable_must_have_an_explicit_type_annotation_with_isolatedDeclarations_9010","Variable must have an explicit type annotation with --isolatedDeclarations."),Parameter_must_have_an_explicit_type_annotation_with_isolatedDeclarations:N(9011,1,"Parameter_must_have_an_explicit_type_annotation_with_isolatedDeclarations_9011","Parameter must have an explicit type annotation with --isolatedDeclarations."),Property_must_have_an_explicit_type_annotation_with_isolatedDeclarations:N(9012,1,"Property_must_have_an_explicit_type_annotation_with_isolatedDeclarations_9012","Property must have an explicit type annotation with --isolatedDeclarations."),Expression_type_can_t_be_inferred_with_isolatedDeclarations:N(9013,1,"Expression_type_can_t_be_inferred_with_isolatedDeclarations_9013","Expression type can't be inferred with --isolatedDeclarations."),Computed_properties_must_be_number_or_string_literals_variables_or_dotted_expressions_with_isolatedDeclarations:N(9014,1,"Computed_properties_must_be_number_or_string_literals_variables_or_dotted_expressions_with_isolatedD_9014","Computed properties must be number or string literals, variables or dotted expressions with --isolatedDeclarations."),Objects_that_contain_spread_assignments_can_t_be_inferred_with_isolatedDeclarations:N(9015,1,"Objects_that_contain_spread_assignments_can_t_be_inferred_with_isolatedDeclarations_9015","Objects that contain spread assignments can't be inferred with --isolatedDeclarations."),Objects_that_contain_shorthand_properties_can_t_be_inferred_with_isolatedDeclarations:N(9016,1,"Objects_that_contain_shorthand_properties_can_t_be_inferred_with_isolatedDeclarations_9016","Objects that contain shorthand properties can't be inferred with --isolatedDeclarations."),Only_const_arrays_can_be_inferred_with_isolatedDeclarations:N(9017,1,"Only_const_arrays_can_be_inferred_with_isolatedDeclarations_9017","Only const arrays can be inferred with --isolatedDeclarations."),Arrays_with_spread_elements_can_t_inferred_with_isolatedDeclarations:N(9018,1,"Arrays_with_spread_elements_can_t_inferred_with_isolatedDeclarations_9018","Arrays with spread elements can't inferred with --isolatedDeclarations."),Binding_elements_can_t_be_exported_directly_with_isolatedDeclarations:N(9019,1,"Binding_elements_can_t_be_exported_directly_with_isolatedDeclarations_9019","Binding elements can't be exported directly with --isolatedDeclarations."),Enum_member_initializers_must_be_computable_without_references_to_external_symbols_with_isolatedDeclarations:N(9020,1,"Enum_member_initializers_must_be_computable_without_references_to_external_symbols_with_isolatedDecl_9020","Enum member initializers must be computable without references to external symbols with --isolatedDeclarations."),Extends_clause_can_t_contain_an_expression_with_isolatedDeclarations:N(9021,1,"Extends_clause_can_t_contain_an_expression_with_isolatedDeclarations_9021","Extends clause can't contain an expression with --isolatedDeclarations."),Inference_from_class_expressions_is_not_supported_with_isolatedDeclarations:N(9022,1,"Inference_from_class_expressions_is_not_supported_with_isolatedDeclarations_9022","Inference from class expressions is not supported with --isolatedDeclarations."),Assigning_properties_to_functions_without_declaring_them_is_not_supported_with_isolatedDeclarations_Add_an_explicit_declaration_for_the_properties_assigned_to_this_function:N(9023,1,"Assigning_properties_to_functions_without_declaring_them_is_not_supported_with_isolatedDeclarations__9023","Assigning properties to functions without declaring them is not supported with --isolatedDeclarations. Add an explicit declaration for the properties assigned to this function."),Declaration_emit_for_this_parameter_requires_implicitly_adding_undefined_to_it_s_type_This_is_not_supported_with_isolatedDeclarations:N(9025,1,"Declaration_emit_for_this_parameter_requires_implicitly_adding_undefined_to_it_s_type_This_is_not_su_9025","Declaration emit for this parameter requires implicitly adding undefined to it's type. This is not supported with --isolatedDeclarations."),Declaration_emit_for_this_file_requires_preserving_this_import_for_augmentations_This_is_not_supported_with_isolatedDeclarations:N(9026,1,"Declaration_emit_for_this_file_requires_preserving_this_import_for_augmentations_This_is_not_support_9026","Declaration emit for this file requires preserving this import for augmentations. This is not supported with --isolatedDeclarations."),Add_a_type_annotation_to_the_variable_0:N(9027,1,"Add_a_type_annotation_to_the_variable_0_9027","Add a type annotation to the variable {0}."),Add_a_type_annotation_to_the_parameter_0:N(9028,1,"Add_a_type_annotation_to_the_parameter_0_9028","Add a type annotation to the parameter {0}."),Add_a_type_annotation_to_the_property_0:N(9029,1,"Add_a_type_annotation_to_the_property_0_9029","Add a type annotation to the property {0}."),Add_a_return_type_to_the_function_expression:N(9030,1,"Add_a_return_type_to_the_function_expression_9030","Add a return type to the function expression."),Add_a_return_type_to_the_function_declaration:N(9031,1,"Add_a_return_type_to_the_function_declaration_9031","Add a return type to the function declaration."),Add_a_return_type_to_the_get_accessor_declaration:N(9032,1,"Add_a_return_type_to_the_get_accessor_declaration_9032","Add a return type to the get accessor declaration."),Add_a_type_to_parameter_of_the_set_accessor_declaration:N(9033,1,"Add_a_type_to_parameter_of_the_set_accessor_declaration_9033","Add a type to parameter of the set accessor declaration."),Add_a_return_type_to_the_method:N(9034,1,"Add_a_return_type_to_the_method_9034","Add a return type to the method"),Add_satisfies_and_a_type_assertion_to_this_expression_satisfies_T_as_T_to_make_the_type_explicit:N(9035,1,"Add_satisfies_and_a_type_assertion_to_this_expression_satisfies_T_as_T_to_make_the_type_explicit_9035","Add satisfies and a type assertion to this expression (satisfies T as T) to make the type explicit."),Move_the_expression_in_default_export_to_a_variable_and_add_a_type_annotation_to_it:N(9036,1,"Move_the_expression_in_default_export_to_a_variable_and_add_a_type_annotation_to_it_9036","Move the expression in default export to a variable and add a type annotation to it."),Default_exports_can_t_be_inferred_with_isolatedDeclarations:N(9037,1,"Default_exports_can_t_be_inferred_with_isolatedDeclarations_9037","Default exports can't be inferred with --isolatedDeclarations."),Computed_property_names_on_class_or_object_literals_cannot_be_inferred_with_isolatedDeclarations:N(9038,1,"Computed_property_names_on_class_or_object_literals_cannot_be_inferred_with_isolatedDeclarations_9038","Computed property names on class or object literals cannot be inferred with --isolatedDeclarations."),Type_containing_private_name_0_can_t_be_used_with_isolatedDeclarations:N(9039,1,"Type_containing_private_name_0_can_t_be_used_with_isolatedDeclarations_9039","Type containing private name '{0}' can't be used with --isolatedDeclarations."),JSX_attributes_must_only_be_assigned_a_non_empty_expression:N(17e3,1,"JSX_attributes_must_only_be_assigned_a_non_empty_expression_17000","JSX attributes must only be assigned a non-empty 'expression'."),JSX_elements_cannot_have_multiple_attributes_with_the_same_name:N(17001,1,"JSX_elements_cannot_have_multiple_attributes_with_the_same_name_17001","JSX elements cannot have multiple attributes with the same name."),Expected_corresponding_JSX_closing_tag_for_0:N(17002,1,"Expected_corresponding_JSX_closing_tag_for_0_17002","Expected corresponding JSX closing tag for '{0}'."),Cannot_use_JSX_unless_the_jsx_flag_is_provided:N(17004,1,"Cannot_use_JSX_unless_the_jsx_flag_is_provided_17004","Cannot use JSX unless the '--jsx' flag is provided."),A_constructor_cannot_contain_a_super_call_when_its_class_extends_null:N(17005,1,"A_constructor_cannot_contain_a_super_call_when_its_class_extends_null_17005","A constructor cannot contain a 'super' call when its class extends 'null'."),An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses:N(17006,1,"An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_ex_17006","An unary expression with the '{0}' operator is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."),A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses:N(17007,1,"A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Con_17007","A type assertion expression is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."),JSX_element_0_has_no_corresponding_closing_tag:N(17008,1,"JSX_element_0_has_no_corresponding_closing_tag_17008","JSX element '{0}' has no corresponding closing tag."),super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class:N(17009,1,"super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class_17009","'super' must be called before accessing 'this' in the constructor of a derived class."),Unknown_type_acquisition_option_0:N(17010,1,"Unknown_type_acquisition_option_0_17010","Unknown type acquisition option '{0}'."),super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class:N(17011,1,"super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class_17011","'super' must be called before accessing a property of 'super' in the constructor of a derived class."),_0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2:N(17012,1,"_0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2_17012","'{0}' is not a valid meta-property for keyword '{1}'. Did you mean '{2}'?"),Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor:N(17013,1,"Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constru_17013","Meta-property '{0}' is only allowed in the body of a function declaration, function expression, or constructor."),JSX_fragment_has_no_corresponding_closing_tag:N(17014,1,"JSX_fragment_has_no_corresponding_closing_tag_17014","JSX fragment has no corresponding closing tag."),Expected_corresponding_closing_tag_for_JSX_fragment:N(17015,1,"Expected_corresponding_closing_tag_for_JSX_fragment_17015","Expected corresponding closing tag for JSX fragment."),The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_compiler_option:N(17016,1,"The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_com_17016","The 'jsxFragmentFactory' compiler option must be provided to use JSX fragments with the 'jsxFactory' compiler option."),An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments:N(17017,1,"An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments_17017","An @jsxFrag pragma is required when using an @jsx pragma with JSX fragments."),Unknown_type_acquisition_option_0_Did_you_mean_1:N(17018,1,"Unknown_type_acquisition_option_0_Did_you_mean_1_17018","Unknown type acquisition option '{0}'. Did you mean '{1}'?"),_0_at_the_end_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1:N(17019,1,"_0_at_the_end_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1_17019","'{0}' at the end of a type is not valid TypeScript syntax. Did you mean to write '{1}'?"),_0_at_the_start_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1:N(17020,1,"_0_at_the_start_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1_17020","'{0}' at the start of a type is not valid TypeScript syntax. Did you mean to write '{1}'?"),Unicode_escape_sequence_cannot_appear_here:N(17021,1,"Unicode_escape_sequence_cannot_appear_here_17021","Unicode escape sequence cannot appear here."),Circularity_detected_while_resolving_configuration_Colon_0:N(18e3,1,"Circularity_detected_while_resolving_configuration_Colon_0_18000","Circularity detected while resolving configuration: {0}"),The_files_list_in_config_file_0_is_empty:N(18002,1,"The_files_list_in_config_file_0_is_empty_18002","The 'files' list in config file '{0}' is empty."),No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2:N(18003,1,"No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2_18003","No inputs were found in config file '{0}'. Specified 'include' paths were '{1}' and 'exclude' paths were '{2}'."),File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module:N(80001,2,"File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module_80001","File is a CommonJS module; it may be converted to an ES module."),This_constructor_function_may_be_converted_to_a_class_declaration:N(80002,2,"This_constructor_function_may_be_converted_to_a_class_declaration_80002","This constructor function may be converted to a class declaration."),Import_may_be_converted_to_a_default_import:N(80003,2,"Import_may_be_converted_to_a_default_import_80003","Import may be converted to a default import."),JSDoc_types_may_be_moved_to_TypeScript_types:N(80004,2,"JSDoc_types_may_be_moved_to_TypeScript_types_80004","JSDoc types may be moved to TypeScript types."),require_call_may_be_converted_to_an_import:N(80005,2,"require_call_may_be_converted_to_an_import_80005","'require' call may be converted to an import."),This_may_be_converted_to_an_async_function:N(80006,2,"This_may_be_converted_to_an_async_function_80006","This may be converted to an async function."),await_has_no_effect_on_the_type_of_this_expression:N(80007,2,"await_has_no_effect_on_the_type_of_this_expression_80007","'await' has no effect on the type of this expression."),Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers:N(80008,2,"Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accur_80008","Numeric literals with absolute values equal to 2^53 or greater are too large to be represented accurately as integers."),JSDoc_typedef_may_be_converted_to_TypeScript_type:N(80009,2,"JSDoc_typedef_may_be_converted_to_TypeScript_type_80009","JSDoc typedef may be converted to TypeScript type."),JSDoc_typedefs_may_be_converted_to_TypeScript_types:N(80010,2,"JSDoc_typedefs_may_be_converted_to_TypeScript_types_80010","JSDoc typedefs may be converted to TypeScript types."),Add_missing_super_call:N(90001,3,"Add_missing_super_call_90001","Add missing 'super()' call"),Make_super_call_the_first_statement_in_the_constructor:N(90002,3,"Make_super_call_the_first_statement_in_the_constructor_90002","Make 'super()' call the first statement in the constructor"),Change_extends_to_implements:N(90003,3,"Change_extends_to_implements_90003","Change 'extends' to 'implements'"),Remove_unused_declaration_for_Colon_0:N(90004,3,"Remove_unused_declaration_for_Colon_0_90004","Remove unused declaration for: '{0}'"),Remove_import_from_0:N(90005,3,"Remove_import_from_0_90005","Remove import from '{0}'"),Implement_interface_0:N(90006,3,"Implement_interface_0_90006","Implement interface '{0}'"),Implement_inherited_abstract_class:N(90007,3,"Implement_inherited_abstract_class_90007","Implement inherited abstract class"),Add_0_to_unresolved_variable:N(90008,3,"Add_0_to_unresolved_variable_90008","Add '{0}.' to unresolved variable"),Remove_variable_statement:N(90010,3,"Remove_variable_statement_90010","Remove variable statement"),Remove_template_tag:N(90011,3,"Remove_template_tag_90011","Remove template tag"),Remove_type_parameters:N(90012,3,"Remove_type_parameters_90012","Remove type parameters"),Import_0_from_1:N(90013,3,"Import_0_from_1_90013",`Import '{0}' from "{1}"`),Change_0_to_1:N(90014,3,"Change_0_to_1_90014","Change '{0}' to '{1}'"),Declare_property_0:N(90016,3,"Declare_property_0_90016","Declare property '{0}'"),Add_index_signature_for_property_0:N(90017,3,"Add_index_signature_for_property_0_90017","Add index signature for property '{0}'"),Disable_checking_for_this_file:N(90018,3,"Disable_checking_for_this_file_90018","Disable checking for this file"),Ignore_this_error_message:N(90019,3,"Ignore_this_error_message_90019","Ignore this error message"),Initialize_property_0_in_the_constructor:N(90020,3,"Initialize_property_0_in_the_constructor_90020","Initialize property '{0}' in the constructor"),Initialize_static_property_0:N(90021,3,"Initialize_static_property_0_90021","Initialize static property '{0}'"),Change_spelling_to_0:N(90022,3,"Change_spelling_to_0_90022","Change spelling to '{0}'"),Declare_method_0:N(90023,3,"Declare_method_0_90023","Declare method '{0}'"),Declare_static_method_0:N(90024,3,"Declare_static_method_0_90024","Declare static method '{0}'"),Prefix_0_with_an_underscore:N(90025,3,"Prefix_0_with_an_underscore_90025","Prefix '{0}' with an underscore"),Rewrite_as_the_indexed_access_type_0:N(90026,3,"Rewrite_as_the_indexed_access_type_0_90026","Rewrite as the indexed access type '{0}'"),Declare_static_property_0:N(90027,3,"Declare_static_property_0_90027","Declare static property '{0}'"),Call_decorator_expression:N(90028,3,"Call_decorator_expression_90028","Call decorator expression"),Add_async_modifier_to_containing_function:N(90029,3,"Add_async_modifier_to_containing_function_90029","Add async modifier to containing function"),Replace_infer_0_with_unknown:N(90030,3,"Replace_infer_0_with_unknown_90030","Replace 'infer {0}' with 'unknown'"),Replace_all_unused_infer_with_unknown:N(90031,3,"Replace_all_unused_infer_with_unknown_90031","Replace all unused 'infer' with 'unknown'"),Add_parameter_name:N(90034,3,"Add_parameter_name_90034","Add parameter name"),Declare_private_property_0:N(90035,3,"Declare_private_property_0_90035","Declare private property '{0}'"),Replace_0_with_Promise_1:N(90036,3,"Replace_0_with_Promise_1_90036","Replace '{0}' with 'Promise<{1}>'"),Fix_all_incorrect_return_type_of_an_async_functions:N(90037,3,"Fix_all_incorrect_return_type_of_an_async_functions_90037","Fix all incorrect return type of an async functions"),Declare_private_method_0:N(90038,3,"Declare_private_method_0_90038","Declare private method '{0}'"),Remove_unused_destructuring_declaration:N(90039,3,"Remove_unused_destructuring_declaration_90039","Remove unused destructuring declaration"),Remove_unused_declarations_for_Colon_0:N(90041,3,"Remove_unused_declarations_for_Colon_0_90041","Remove unused declarations for: '{0}'"),Declare_a_private_field_named_0:N(90053,3,"Declare_a_private_field_named_0_90053","Declare a private field named '{0}'."),Includes_imports_of_types_referenced_by_0:N(90054,3,"Includes_imports_of_types_referenced_by_0_90054","Includes imports of types referenced by '{0}'"),Remove_type_from_import_declaration_from_0:N(90055,3,"Remove_type_from_import_declaration_from_0_90055",`Remove 'type' from import declaration from "{0}"`),Remove_type_from_import_of_0_from_1:N(90056,3,"Remove_type_from_import_of_0_from_1_90056",`Remove 'type' from import of '{0}' from "{1}"`),Add_import_from_0:N(90057,3,"Add_import_from_0_90057",'Add import from "{0}"'),Update_import_from_0:N(90058,3,"Update_import_from_0_90058",'Update import from "{0}"'),Export_0_from_module_1:N(90059,3,"Export_0_from_module_1_90059","Export '{0}' from module '{1}'"),Export_all_referenced_locals:N(90060,3,"Export_all_referenced_locals_90060","Export all referenced locals"),Update_modifiers_of_0:N(90061,3,"Update_modifiers_of_0_90061","Update modifiers of '{0}'"),Add_annotation_of_type_0:N(90062,3,"Add_annotation_of_type_0_90062","Add annotation of type '{0}'"),Add_return_type_0:N(90063,3,"Add_return_type_0_90063","Add return type '{0}'"),Extract_base_class_to_variable:N(90064,3,"Extract_base_class_to_variable_90064","Extract base class to variable"),Extract_default_export_to_variable:N(90065,3,"Extract_default_export_to_variable_90065","Extract default export to variable"),Extract_binding_expressions_to_variable:N(90066,3,"Extract_binding_expressions_to_variable_90066","Extract binding expressions to variable"),Add_all_missing_type_annotations:N(90067,3,"Add_all_missing_type_annotations_90067","Add all missing type annotations"),Add_satisfies_and_an_inline_type_assertion_with_0:N(90068,3,"Add_satisfies_and_an_inline_type_assertion_with_0_90068","Add satisfies and an inline type assertion with '{0}'"),Extract_to_variable_and_replace_with_0_as_typeof_0:N(90069,3,"Extract_to_variable_and_replace_with_0_as_typeof_0_90069","Extract to variable and replace with '{0} as typeof {0}'"),Mark_array_literal_as_const:N(90070,3,"Mark_array_literal_as_const_90070","Mark array literal as const"),Annotate_types_of_properties_expando_function_in_a_namespace:N(90071,3,"Annotate_types_of_properties_expando_function_in_a_namespace_90071","Annotate types of properties expando function in a namespace"),Convert_function_to_an_ES2015_class:N(95001,3,"Convert_function_to_an_ES2015_class_95001","Convert function to an ES2015 class"),Convert_0_to_1_in_0:N(95003,3,"Convert_0_to_1_in_0_95003","Convert '{0}' to '{1} in {0}'"),Extract_to_0_in_1:N(95004,3,"Extract_to_0_in_1_95004","Extract to {0} in {1}"),Extract_function:N(95005,3,"Extract_function_95005","Extract function"),Extract_constant:N(95006,3,"Extract_constant_95006","Extract constant"),Extract_to_0_in_enclosing_scope:N(95007,3,"Extract_to_0_in_enclosing_scope_95007","Extract to {0} in enclosing scope"),Extract_to_0_in_1_scope:N(95008,3,"Extract_to_0_in_1_scope_95008","Extract to {0} in {1} scope"),Annotate_with_type_from_JSDoc:N(95009,3,"Annotate_with_type_from_JSDoc_95009","Annotate with type from JSDoc"),Infer_type_of_0_from_usage:N(95011,3,"Infer_type_of_0_from_usage_95011","Infer type of '{0}' from usage"),Infer_parameter_types_from_usage:N(95012,3,"Infer_parameter_types_from_usage_95012","Infer parameter types from usage"),Convert_to_default_import:N(95013,3,"Convert_to_default_import_95013","Convert to default import"),Install_0:N(95014,3,"Install_0_95014","Install '{0}'"),Replace_import_with_0:N(95015,3,"Replace_import_with_0_95015","Replace import with '{0}'."),Use_synthetic_default_member:N(95016,3,"Use_synthetic_default_member_95016","Use synthetic 'default' member."),Convert_to_ES_module:N(95017,3,"Convert_to_ES_module_95017","Convert to ES module"),Add_undefined_type_to_property_0:N(95018,3,"Add_undefined_type_to_property_0_95018","Add 'undefined' type to property '{0}'"),Add_initializer_to_property_0:N(95019,3,"Add_initializer_to_property_0_95019","Add initializer to property '{0}'"),Add_definite_assignment_assertion_to_property_0:N(95020,3,"Add_definite_assignment_assertion_to_property_0_95020","Add definite assignment assertion to property '{0}'"),Convert_all_type_literals_to_mapped_type:N(95021,3,"Convert_all_type_literals_to_mapped_type_95021","Convert all type literals to mapped type"),Add_all_missing_members:N(95022,3,"Add_all_missing_members_95022","Add all missing members"),Infer_all_types_from_usage:N(95023,3,"Infer_all_types_from_usage_95023","Infer all types from usage"),Delete_all_unused_declarations:N(95024,3,"Delete_all_unused_declarations_95024","Delete all unused declarations"),Prefix_all_unused_declarations_with_where_possible:N(95025,3,"Prefix_all_unused_declarations_with_where_possible_95025","Prefix all unused declarations with '_' where possible"),Fix_all_detected_spelling_errors:N(95026,3,"Fix_all_detected_spelling_errors_95026","Fix all detected spelling errors"),Add_initializers_to_all_uninitialized_properties:N(95027,3,"Add_initializers_to_all_uninitialized_properties_95027","Add initializers to all uninitialized properties"),Add_definite_assignment_assertions_to_all_uninitialized_properties:N(95028,3,"Add_definite_assignment_assertions_to_all_uninitialized_properties_95028","Add definite assignment assertions to all uninitialized properties"),Add_undefined_type_to_all_uninitialized_properties:N(95029,3,"Add_undefined_type_to_all_uninitialized_properties_95029","Add undefined type to all uninitialized properties"),Change_all_jsdoc_style_types_to_TypeScript:N(95030,3,"Change_all_jsdoc_style_types_to_TypeScript_95030","Change all jsdoc-style types to TypeScript"),Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types:N(95031,3,"Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types_95031","Change all jsdoc-style types to TypeScript (and add '| undefined' to nullable types)"),Implement_all_unimplemented_interfaces:N(95032,3,"Implement_all_unimplemented_interfaces_95032","Implement all unimplemented interfaces"),Install_all_missing_types_packages:N(95033,3,"Install_all_missing_types_packages_95033","Install all missing types packages"),Rewrite_all_as_indexed_access_types:N(95034,3,"Rewrite_all_as_indexed_access_types_95034","Rewrite all as indexed access types"),Convert_all_to_default_imports:N(95035,3,"Convert_all_to_default_imports_95035","Convert all to default imports"),Make_all_super_calls_the_first_statement_in_their_constructor:N(95036,3,"Make_all_super_calls_the_first_statement_in_their_constructor_95036","Make all 'super()' calls the first statement in their constructor"),Add_qualifier_to_all_unresolved_variables_matching_a_member_name:N(95037,3,"Add_qualifier_to_all_unresolved_variables_matching_a_member_name_95037","Add qualifier to all unresolved variables matching a member name"),Change_all_extended_interfaces_to_implements:N(95038,3,"Change_all_extended_interfaces_to_implements_95038","Change all extended interfaces to 'implements'"),Add_all_missing_super_calls:N(95039,3,"Add_all_missing_super_calls_95039","Add all missing super calls"),Implement_all_inherited_abstract_classes:N(95040,3,"Implement_all_inherited_abstract_classes_95040","Implement all inherited abstract classes"),Add_all_missing_async_modifiers:N(95041,3,"Add_all_missing_async_modifiers_95041","Add all missing 'async' modifiers"),Add_ts_ignore_to_all_error_messages:N(95042,3,"Add_ts_ignore_to_all_error_messages_95042","Add '@ts-ignore' to all error messages"),Annotate_everything_with_types_from_JSDoc:N(95043,3,"Annotate_everything_with_types_from_JSDoc_95043","Annotate everything with types from JSDoc"),Add_to_all_uncalled_decorators:N(95044,3,"Add_to_all_uncalled_decorators_95044","Add '()' to all uncalled decorators"),Convert_all_constructor_functions_to_classes:N(95045,3,"Convert_all_constructor_functions_to_classes_95045","Convert all constructor functions to classes"),Generate_get_and_set_accessors:N(95046,3,"Generate_get_and_set_accessors_95046","Generate 'get' and 'set' accessors"),Convert_require_to_import:N(95047,3,"Convert_require_to_import_95047","Convert 'require' to 'import'"),Convert_all_require_to_import:N(95048,3,"Convert_all_require_to_import_95048","Convert all 'require' to 'import'"),Move_to_a_new_file:N(95049,3,"Move_to_a_new_file_95049","Move to a new file"),Remove_unreachable_code:N(95050,3,"Remove_unreachable_code_95050","Remove unreachable code"),Remove_all_unreachable_code:N(95051,3,"Remove_all_unreachable_code_95051","Remove all unreachable code"),Add_missing_typeof:N(95052,3,"Add_missing_typeof_95052","Add missing 'typeof'"),Remove_unused_label:N(95053,3,"Remove_unused_label_95053","Remove unused label"),Remove_all_unused_labels:N(95054,3,"Remove_all_unused_labels_95054","Remove all unused labels"),Convert_0_to_mapped_object_type:N(95055,3,"Convert_0_to_mapped_object_type_95055","Convert '{0}' to mapped object type"),Convert_namespace_import_to_named_imports:N(95056,3,"Convert_namespace_import_to_named_imports_95056","Convert namespace import to named imports"),Convert_named_imports_to_namespace_import:N(95057,3,"Convert_named_imports_to_namespace_import_95057","Convert named imports to namespace import"),Add_or_remove_braces_in_an_arrow_function:N(95058,3,"Add_or_remove_braces_in_an_arrow_function_95058","Add or remove braces in an arrow function"),Add_braces_to_arrow_function:N(95059,3,"Add_braces_to_arrow_function_95059","Add braces to arrow function"),Remove_braces_from_arrow_function:N(95060,3,"Remove_braces_from_arrow_function_95060","Remove braces from arrow function"),Convert_default_export_to_named_export:N(95061,3,"Convert_default_export_to_named_export_95061","Convert default export to named export"),Convert_named_export_to_default_export:N(95062,3,"Convert_named_export_to_default_export_95062","Convert named export to default export"),Add_missing_enum_member_0:N(95063,3,"Add_missing_enum_member_0_95063","Add missing enum member '{0}'"),Add_all_missing_imports:N(95064,3,"Add_all_missing_imports_95064","Add all missing imports"),Convert_to_async_function:N(95065,3,"Convert_to_async_function_95065","Convert to async function"),Convert_all_to_async_functions:N(95066,3,"Convert_all_to_async_functions_95066","Convert all to async functions"),Add_missing_call_parentheses:N(95067,3,"Add_missing_call_parentheses_95067","Add missing call parentheses"),Add_all_missing_call_parentheses:N(95068,3,"Add_all_missing_call_parentheses_95068","Add all missing call parentheses"),Add_unknown_conversion_for_non_overlapping_types:N(95069,3,"Add_unknown_conversion_for_non_overlapping_types_95069","Add 'unknown' conversion for non-overlapping types"),Add_unknown_to_all_conversions_of_non_overlapping_types:N(95070,3,"Add_unknown_to_all_conversions_of_non_overlapping_types_95070","Add 'unknown' to all conversions of non-overlapping types"),Add_missing_new_operator_to_call:N(95071,3,"Add_missing_new_operator_to_call_95071","Add missing 'new' operator to call"),Add_missing_new_operator_to_all_calls:N(95072,3,"Add_missing_new_operator_to_all_calls_95072","Add missing 'new' operator to all calls"),Add_names_to_all_parameters_without_names:N(95073,3,"Add_names_to_all_parameters_without_names_95073","Add names to all parameters without names"),Enable_the_experimentalDecorators_option_in_your_configuration_file:N(95074,3,"Enable_the_experimentalDecorators_option_in_your_configuration_file_95074","Enable the 'experimentalDecorators' option in your configuration file"),Convert_parameters_to_destructured_object:N(95075,3,"Convert_parameters_to_destructured_object_95075","Convert parameters to destructured object"),Extract_type:N(95077,3,"Extract_type_95077","Extract type"),Extract_to_type_alias:N(95078,3,"Extract_to_type_alias_95078","Extract to type alias"),Extract_to_typedef:N(95079,3,"Extract_to_typedef_95079","Extract to typedef"),Infer_this_type_of_0_from_usage:N(95080,3,"Infer_this_type_of_0_from_usage_95080","Infer 'this' type of '{0}' from usage"),Add_const_to_unresolved_variable:N(95081,3,"Add_const_to_unresolved_variable_95081","Add 'const' to unresolved variable"),Add_const_to_all_unresolved_variables:N(95082,3,"Add_const_to_all_unresolved_variables_95082","Add 'const' to all unresolved variables"),Add_await:N(95083,3,"Add_await_95083","Add 'await'"),Add_await_to_initializer_for_0:N(95084,3,"Add_await_to_initializer_for_0_95084","Add 'await' to initializer for '{0}'"),Fix_all_expressions_possibly_missing_await:N(95085,3,"Fix_all_expressions_possibly_missing_await_95085","Fix all expressions possibly missing 'await'"),Remove_unnecessary_await:N(95086,3,"Remove_unnecessary_await_95086","Remove unnecessary 'await'"),Remove_all_unnecessary_uses_of_await:N(95087,3,"Remove_all_unnecessary_uses_of_await_95087","Remove all unnecessary uses of 'await'"),Enable_the_jsx_flag_in_your_configuration_file:N(95088,3,"Enable_the_jsx_flag_in_your_configuration_file_95088","Enable the '--jsx' flag in your configuration file"),Add_await_to_initializers:N(95089,3,"Add_await_to_initializers_95089","Add 'await' to initializers"),Extract_to_interface:N(95090,3,"Extract_to_interface_95090","Extract to interface"),Convert_to_a_bigint_numeric_literal:N(95091,3,"Convert_to_a_bigint_numeric_literal_95091","Convert to a bigint numeric literal"),Convert_all_to_bigint_numeric_literals:N(95092,3,"Convert_all_to_bigint_numeric_literals_95092","Convert all to bigint numeric literals"),Convert_const_to_let:N(95093,3,"Convert_const_to_let_95093","Convert 'const' to 'let'"),Prefix_with_declare:N(95094,3,"Prefix_with_declare_95094","Prefix with 'declare'"),Prefix_all_incorrect_property_declarations_with_declare:N(95095,3,"Prefix_all_incorrect_property_declarations_with_declare_95095","Prefix all incorrect property declarations with 'declare'"),Convert_to_template_string:N(95096,3,"Convert_to_template_string_95096","Convert to template string"),Add_export_to_make_this_file_into_a_module:N(95097,3,"Add_export_to_make_this_file_into_a_module_95097","Add 'export {}' to make this file into a module"),Set_the_target_option_in_your_configuration_file_to_0:N(95098,3,"Set_the_target_option_in_your_configuration_file_to_0_95098","Set the 'target' option in your configuration file to '{0}'"),Set_the_module_option_in_your_configuration_file_to_0:N(95099,3,"Set_the_module_option_in_your_configuration_file_to_0_95099","Set the 'module' option in your configuration file to '{0}'"),Convert_invalid_character_to_its_html_entity_code:N(95100,3,"Convert_invalid_character_to_its_html_entity_code_95100","Convert invalid character to its html entity code"),Convert_all_invalid_characters_to_HTML_entity_code:N(95101,3,"Convert_all_invalid_characters_to_HTML_entity_code_95101","Convert all invalid characters to HTML entity code"),Convert_all_const_to_let:N(95102,3,"Convert_all_const_to_let_95102","Convert all 'const' to 'let'"),Convert_function_expression_0_to_arrow_function:N(95105,3,"Convert_function_expression_0_to_arrow_function_95105","Convert function expression '{0}' to arrow function"),Convert_function_declaration_0_to_arrow_function:N(95106,3,"Convert_function_declaration_0_to_arrow_function_95106","Convert function declaration '{0}' to arrow function"),Fix_all_implicit_this_errors:N(95107,3,"Fix_all_implicit_this_errors_95107","Fix all implicit-'this' errors"),Wrap_invalid_character_in_an_expression_container:N(95108,3,"Wrap_invalid_character_in_an_expression_container_95108","Wrap invalid character in an expression container"),Wrap_all_invalid_characters_in_an_expression_container:N(95109,3,"Wrap_all_invalid_characters_in_an_expression_container_95109","Wrap all invalid characters in an expression container"),Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file:N(95110,3,"Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file_95110","Visit https://aka.ms/tsconfig to read more about this file"),Add_a_return_statement:N(95111,3,"Add_a_return_statement_95111","Add a return statement"),Remove_braces_from_arrow_function_body:N(95112,3,"Remove_braces_from_arrow_function_body_95112","Remove braces from arrow function body"),Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal:N(95113,3,"Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal_95113","Wrap the following body with parentheses which should be an object literal"),Add_all_missing_return_statement:N(95114,3,"Add_all_missing_return_statement_95114","Add all missing return statement"),Remove_braces_from_all_arrow_function_bodies_with_relevant_issues:N(95115,3,"Remove_braces_from_all_arrow_function_bodies_with_relevant_issues_95115","Remove braces from all arrow function bodies with relevant issues"),Wrap_all_object_literal_with_parentheses:N(95116,3,"Wrap_all_object_literal_with_parentheses_95116","Wrap all object literal with parentheses"),Move_labeled_tuple_element_modifiers_to_labels:N(95117,3,"Move_labeled_tuple_element_modifiers_to_labels_95117","Move labeled tuple element modifiers to labels"),Convert_overload_list_to_single_signature:N(95118,3,"Convert_overload_list_to_single_signature_95118","Convert overload list to single signature"),Generate_get_and_set_accessors_for_all_overriding_properties:N(95119,3,"Generate_get_and_set_accessors_for_all_overriding_properties_95119","Generate 'get' and 'set' accessors for all overriding properties"),Wrap_in_JSX_fragment:N(95120,3,"Wrap_in_JSX_fragment_95120","Wrap in JSX fragment"),Wrap_all_unparented_JSX_in_JSX_fragment:N(95121,3,"Wrap_all_unparented_JSX_in_JSX_fragment_95121","Wrap all unparented JSX in JSX fragment"),Convert_arrow_function_or_function_expression:N(95122,3,"Convert_arrow_function_or_function_expression_95122","Convert arrow function or function expression"),Convert_to_anonymous_function:N(95123,3,"Convert_to_anonymous_function_95123","Convert to anonymous function"),Convert_to_named_function:N(95124,3,"Convert_to_named_function_95124","Convert to named function"),Convert_to_arrow_function:N(95125,3,"Convert_to_arrow_function_95125","Convert to arrow function"),Remove_parentheses:N(95126,3,"Remove_parentheses_95126","Remove parentheses"),Could_not_find_a_containing_arrow_function:N(95127,3,"Could_not_find_a_containing_arrow_function_95127","Could not find a containing arrow function"),Containing_function_is_not_an_arrow_function:N(95128,3,"Containing_function_is_not_an_arrow_function_95128","Containing function is not an arrow function"),Could_not_find_export_statement:N(95129,3,"Could_not_find_export_statement_95129","Could not find export statement"),This_file_already_has_a_default_export:N(95130,3,"This_file_already_has_a_default_export_95130","This file already has a default export"),Could_not_find_import_clause:N(95131,3,"Could_not_find_import_clause_95131","Could not find import clause"),Could_not_find_namespace_import_or_named_imports:N(95132,3,"Could_not_find_namespace_import_or_named_imports_95132","Could not find namespace import or named imports"),Selection_is_not_a_valid_type_node:N(95133,3,"Selection_is_not_a_valid_type_node_95133","Selection is not a valid type node"),No_type_could_be_extracted_from_this_type_node:N(95134,3,"No_type_could_be_extracted_from_this_type_node_95134","No type could be extracted from this type node"),Could_not_find_property_for_which_to_generate_accessor:N(95135,3,"Could_not_find_property_for_which_to_generate_accessor_95135","Could not find property for which to generate accessor"),Name_is_not_valid:N(95136,3,"Name_is_not_valid_95136","Name is not valid"),Can_only_convert_property_with_modifier:N(95137,3,"Can_only_convert_property_with_modifier_95137","Can only convert property with modifier"),Switch_each_misused_0_to_1:N(95138,3,"Switch_each_misused_0_to_1_95138","Switch each misused '{0}' to '{1}'"),Convert_to_optional_chain_expression:N(95139,3,"Convert_to_optional_chain_expression_95139","Convert to optional chain expression"),Could_not_find_convertible_access_expression:N(95140,3,"Could_not_find_convertible_access_expression_95140","Could not find convertible access expression"),Could_not_find_matching_access_expressions:N(95141,3,"Could_not_find_matching_access_expressions_95141","Could not find matching access expressions"),Can_only_convert_logical_AND_access_chains:N(95142,3,"Can_only_convert_logical_AND_access_chains_95142","Can only convert logical AND access chains"),Add_void_to_Promise_resolved_without_a_value:N(95143,3,"Add_void_to_Promise_resolved_without_a_value_95143","Add 'void' to Promise resolved without a value"),Add_void_to_all_Promises_resolved_without_a_value:N(95144,3,"Add_void_to_all_Promises_resolved_without_a_value_95144","Add 'void' to all Promises resolved without a value"),Use_element_access_for_0:N(95145,3,"Use_element_access_for_0_95145","Use element access for '{0}'"),Use_element_access_for_all_undeclared_properties:N(95146,3,"Use_element_access_for_all_undeclared_properties_95146","Use element access for all undeclared properties."),Delete_all_unused_imports:N(95147,3,"Delete_all_unused_imports_95147","Delete all unused imports"),Infer_function_return_type:N(95148,3,"Infer_function_return_type_95148","Infer function return type"),Return_type_must_be_inferred_from_a_function:N(95149,3,"Return_type_must_be_inferred_from_a_function_95149","Return type must be inferred from a function"),Could_not_determine_function_return_type:N(95150,3,"Could_not_determine_function_return_type_95150","Could not determine function return type"),Could_not_convert_to_arrow_function:N(95151,3,"Could_not_convert_to_arrow_function_95151","Could not convert to arrow function"),Could_not_convert_to_named_function:N(95152,3,"Could_not_convert_to_named_function_95152","Could not convert to named function"),Could_not_convert_to_anonymous_function:N(95153,3,"Could_not_convert_to_anonymous_function_95153","Could not convert to anonymous function"),Can_only_convert_string_concatenations_and_string_literals:N(95154,3,"Can_only_convert_string_concatenations_and_string_literals_95154","Can only convert string concatenations and string literals"),Selection_is_not_a_valid_statement_or_statements:N(95155,3,"Selection_is_not_a_valid_statement_or_statements_95155","Selection is not a valid statement or statements"),Add_missing_function_declaration_0:N(95156,3,"Add_missing_function_declaration_0_95156","Add missing function declaration '{0}'"),Add_all_missing_function_declarations:N(95157,3,"Add_all_missing_function_declarations_95157","Add all missing function declarations"),Method_not_implemented:N(95158,3,"Method_not_implemented_95158","Method not implemented."),Function_not_implemented:N(95159,3,"Function_not_implemented_95159","Function not implemented."),Add_override_modifier:N(95160,3,"Add_override_modifier_95160","Add 'override' modifier"),Remove_override_modifier:N(95161,3,"Remove_override_modifier_95161","Remove 'override' modifier"),Add_all_missing_override_modifiers:N(95162,3,"Add_all_missing_override_modifiers_95162","Add all missing 'override' modifiers"),Remove_all_unnecessary_override_modifiers:N(95163,3,"Remove_all_unnecessary_override_modifiers_95163","Remove all unnecessary 'override' modifiers"),Can_only_convert_named_export:N(95164,3,"Can_only_convert_named_export_95164","Can only convert named export"),Add_missing_properties:N(95165,3,"Add_missing_properties_95165","Add missing properties"),Add_all_missing_properties:N(95166,3,"Add_all_missing_properties_95166","Add all missing properties"),Add_missing_attributes:N(95167,3,"Add_missing_attributes_95167","Add missing attributes"),Add_all_missing_attributes:N(95168,3,"Add_all_missing_attributes_95168","Add all missing attributes"),Add_undefined_to_optional_property_type:N(95169,3,"Add_undefined_to_optional_property_type_95169","Add 'undefined' to optional property type"),Convert_named_imports_to_default_import:N(95170,3,"Convert_named_imports_to_default_import_95170","Convert named imports to default import"),Delete_unused_param_tag_0:N(95171,3,"Delete_unused_param_tag_0_95171","Delete unused '@param' tag '{0}'"),Delete_all_unused_param_tags:N(95172,3,"Delete_all_unused_param_tags_95172","Delete all unused '@param' tags"),Rename_param_tag_name_0_to_1:N(95173,3,"Rename_param_tag_name_0_to_1_95173","Rename '@param' tag name '{0}' to '{1}'"),Use_0:N(95174,3,"Use_0_95174","Use `{0}`."),Use_Number_isNaN_in_all_conditions:N(95175,3,"Use_Number_isNaN_in_all_conditions_95175","Use `Number.isNaN` in all conditions."),Convert_typedef_to_TypeScript_type:N(95176,3,"Convert_typedef_to_TypeScript_type_95176","Convert typedef to TypeScript type."),Convert_all_typedef_to_TypeScript_types:N(95177,3,"Convert_all_typedef_to_TypeScript_types_95177","Convert all typedef to TypeScript types."),Move_to_file:N(95178,3,"Move_to_file_95178","Move to file"),Cannot_move_to_file_selected_file_is_invalid:N(95179,3,"Cannot_move_to_file_selected_file_is_invalid_95179","Cannot move to file, selected file is invalid"),Use_import_type:N(95180,3,"Use_import_type_95180","Use 'import type'"),Use_type_0:N(95181,3,"Use_type_0_95181","Use 'type {0}'"),Fix_all_with_type_only_imports:N(95182,3,"Fix_all_with_type_only_imports_95182","Fix all with type-only imports"),Cannot_move_statements_to_the_selected_file:N(95183,3,"Cannot_move_statements_to_the_selected_file_95183","Cannot move statements to the selected file"),Inline_variable:N(95184,3,"Inline_variable_95184","Inline variable"),Could_not_find_variable_to_inline:N(95185,3,"Could_not_find_variable_to_inline_95185","Could not find variable to inline."),Variables_with_multiple_declarations_cannot_be_inlined:N(95186,3,"Variables_with_multiple_declarations_cannot_be_inlined_95186","Variables with multiple declarations cannot be inlined."),Add_missing_comma_for_object_member_completion_0:N(95187,3,"Add_missing_comma_for_object_member_completion_0_95187","Add missing comma for object member completion '{0}'."),Add_missing_parameter_to_0:N(95188,3,"Add_missing_parameter_to_0_95188","Add missing parameter to '{0}'"),Add_missing_parameters_to_0:N(95189,3,"Add_missing_parameters_to_0_95189","Add missing parameters to '{0}'"),Add_all_missing_parameters:N(95190,3,"Add_all_missing_parameters_95190","Add all missing parameters"),Add_optional_parameter_to_0:N(95191,3,"Add_optional_parameter_to_0_95191","Add optional parameter to '{0}'"),Add_optional_parameters_to_0:N(95192,3,"Add_optional_parameters_to_0_95192","Add optional parameters to '{0}'"),Add_all_optional_parameters:N(95193,3,"Add_all_optional_parameters_95193","Add all optional parameters"),Wrap_in_parentheses:N(95194,3,"Wrap_in_parentheses_95194","Wrap in parentheses"),Wrap_all_invalid_decorator_expressions_in_parentheses:N(95195,3,"Wrap_all_invalid_decorator_expressions_in_parentheses_95195","Wrap all invalid decorator expressions in parentheses"),No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer:N(18004,1,"No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer_18004","No value exists in scope for the shorthand property '{0}'. Either declare one or provide an initializer."),Classes_may_not_have_a_field_named_constructor:N(18006,1,"Classes_may_not_have_a_field_named_constructor_18006","Classes may not have a field named 'constructor'."),JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array:N(18007,1,"JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array_18007","JSX expressions may not use the comma operator. Did you mean to write an array?"),Private_identifiers_cannot_be_used_as_parameters:N(18009,1,"Private_identifiers_cannot_be_used_as_parameters_18009","Private identifiers cannot be used as parameters."),An_accessibility_modifier_cannot_be_used_with_a_private_identifier:N(18010,1,"An_accessibility_modifier_cannot_be_used_with_a_private_identifier_18010","An accessibility modifier cannot be used with a private identifier."),The_operand_of_a_delete_operator_cannot_be_a_private_identifier:N(18011,1,"The_operand_of_a_delete_operator_cannot_be_a_private_identifier_18011","The operand of a 'delete' operator cannot be a private identifier."),constructor_is_a_reserved_word:N(18012,1,"constructor_is_a_reserved_word_18012","'#constructor' is a reserved word."),Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier:N(18013,1,"Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier_18013","Property '{0}' is not accessible outside class '{1}' because it has a private identifier."),The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_private_identifier_with_the_same_spelling:N(18014,1,"The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_priv_18014","The property '{0}' cannot be accessed on type '{1}' within this class because it is shadowed by another private identifier with the same spelling."),Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2:N(18015,1,"Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2_18015","Property '{0}' in type '{1}' refers to a different member that cannot be accessed from within type '{2}'."),Private_identifiers_are_not_allowed_outside_class_bodies:N(18016,1,"Private_identifiers_are_not_allowed_outside_class_bodies_18016","Private identifiers are not allowed outside class bodies."),The_shadowing_declaration_of_0_is_defined_here:N(18017,1,"The_shadowing_declaration_of_0_is_defined_here_18017","The shadowing declaration of '{0}' is defined here"),The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here:N(18018,1,"The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here_18018","The declaration of '{0}' that you probably intended to use is defined here"),_0_modifier_cannot_be_used_with_a_private_identifier:N(18019,1,"_0_modifier_cannot_be_used_with_a_private_identifier_18019","'{0}' modifier cannot be used with a private identifier."),An_enum_member_cannot_be_named_with_a_private_identifier:N(18024,1,"An_enum_member_cannot_be_named_with_a_private_identifier_18024","An enum member cannot be named with a private identifier."),can_only_be_used_at_the_start_of_a_file:N(18026,1,"can_only_be_used_at_the_start_of_a_file_18026","'#!' can only be used at the start of a file."),Compiler_reserves_name_0_when_emitting_private_identifier_downlevel:N(18027,1,"Compiler_reserves_name_0_when_emitting_private_identifier_downlevel_18027","Compiler reserves name '{0}' when emitting private identifier downlevel."),Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher:N(18028,1,"Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher_18028","Private identifiers are only available when targeting ECMAScript 2015 and higher."),Private_identifiers_are_not_allowed_in_variable_declarations:N(18029,1,"Private_identifiers_are_not_allowed_in_variable_declarations_18029","Private identifiers are not allowed in variable declarations."),An_optional_chain_cannot_contain_private_identifiers:N(18030,1,"An_optional_chain_cannot_contain_private_identifiers_18030","An optional chain cannot contain private identifiers."),The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituents:N(18031,1,"The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituent_18031","The intersection '{0}' was reduced to 'never' because property '{1}' has conflicting types in some constituents."),The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_private_in_some:N(18032,1,"The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_pr_18032","The intersection '{0}' was reduced to 'never' because property '{1}' exists in multiple constituents and is private in some."),Type_0_is_not_assignable_to_type_1_as_required_for_computed_enum_member_values:N(18033,1,"Type_0_is_not_assignable_to_type_1_as_required_for_computed_enum_member_values_18033","Type '{0}' is not assignable to type '{1}' as required for computed enum member values."),Specify_the_JSX_fragment_factory_function_to_use_when_targeting_react_JSX_emit_with_jsxFactory_compiler_option_is_specified_e_g_Fragment:N(18034,3,"Specify_the_JSX_fragment_factory_function_to_use_when_targeting_react_JSX_emit_with_jsxFactory_compi_18034","Specify the JSX fragment factory function to use when targeting 'react' JSX emit with 'jsxFactory' compiler option is specified, e.g. 'Fragment'."),Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name:N(18035,1,"Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name_18035","Invalid value for 'jsxFragmentFactory'. '{0}' is not a valid identifier or qualified-name."),Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator:N(18036,1,"Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_dec_18036","Class decorators can't be used with static private identifier. Consider removing the experimental decorator."),await_expression_cannot_be_used_inside_a_class_static_block:N(18037,1,"await_expression_cannot_be_used_inside_a_class_static_block_18037","'await' expression cannot be used inside a class static block."),for_await_loops_cannot_be_used_inside_a_class_static_block:N(18038,1,"for_await_loops_cannot_be_used_inside_a_class_static_block_18038","'for await' loops cannot be used inside a class static block."),Invalid_use_of_0_It_cannot_be_used_inside_a_class_static_block:N(18039,1,"Invalid_use_of_0_It_cannot_be_used_inside_a_class_static_block_18039","Invalid use of '{0}'. It cannot be used inside a class static block."),A_return_statement_cannot_be_used_inside_a_class_static_block:N(18041,1,"A_return_statement_cannot_be_used_inside_a_class_static_block_18041","A 'return' statement cannot be used inside a class static block."),_0_is_a_type_and_cannot_be_imported_in_JavaScript_files_Use_1_in_a_JSDoc_type_annotation:N(18042,1,"_0_is_a_type_and_cannot_be_imported_in_JavaScript_files_Use_1_in_a_JSDoc_type_annotation_18042","'{0}' is a type and cannot be imported in JavaScript files. Use '{1}' in a JSDoc type annotation."),Types_cannot_appear_in_export_declarations_in_JavaScript_files:N(18043,1,"Types_cannot_appear_in_export_declarations_in_JavaScript_files_18043","Types cannot appear in export declarations in JavaScript files."),_0_is_automatically_exported_here:N(18044,3,"_0_is_automatically_exported_here_18044","'{0}' is automatically exported here."),Properties_with_the_accessor_modifier_are_only_available_when_targeting_ECMAScript_2015_and_higher:N(18045,1,"Properties_with_the_accessor_modifier_are_only_available_when_targeting_ECMAScript_2015_and_higher_18045","Properties with the 'accessor' modifier are only available when targeting ECMAScript 2015 and higher."),_0_is_of_type_unknown:N(18046,1,"_0_is_of_type_unknown_18046","'{0}' is of type 'unknown'."),_0_is_possibly_null:N(18047,1,"_0_is_possibly_null_18047","'{0}' is possibly 'null'."),_0_is_possibly_undefined:N(18048,1,"_0_is_possibly_undefined_18048","'{0}' is possibly 'undefined'."),_0_is_possibly_null_or_undefined:N(18049,1,"_0_is_possibly_null_or_undefined_18049","'{0}' is possibly 'null' or 'undefined'."),The_value_0_cannot_be_used_here:N(18050,1,"The_value_0_cannot_be_used_here_18050","The value '{0}' cannot be used here."),Compiler_option_0_cannot_be_given_an_empty_string:N(18051,1,"Compiler_option_0_cannot_be_given_an_empty_string_18051","Compiler option '{0}' cannot be given an empty string."),Its_type_0_is_not_a_valid_JSX_element_type:N(18053,1,"Its_type_0_is_not_a_valid_JSX_element_type_18053","Its type '{0}' is not a valid JSX element type."),await_using_statements_cannot_be_used_inside_a_class_static_block:N(18054,1,"await_using_statements_cannot_be_used_inside_a_class_static_block_18054","'await using' statements cannot be used inside a class static block."),_0_has_a_string_type_but_must_have_syntactically_recognizable_string_syntax_when_isolatedModules_is_enabled:N(18055,1,"_0_has_a_string_type_but_must_have_syntactically_recognizable_string_syntax_when_isolatedModules_is__18055","'{0}' has a string type, but must have syntactically recognizable string syntax when 'isolatedModules' is enabled."),Enum_member_following_a_non_literal_numeric_member_must_have_an_initializer_when_isolatedModules_is_enabled:N(18056,1,"Enum_member_following_a_non_literal_numeric_member_must_have_an_initializer_when_isolatedModules_is__18056","Enum member following a non-literal numeric member must have an initializer when 'isolatedModules' is enabled.")};function F_(e){return e>=80}function Sue(e){return e===32||F_(e)}var m5={abstract:128,accessor:129,any:133,as:130,asserts:131,assert:132,bigint:163,boolean:136,break:83,case:84,catch:85,class:86,continue:88,const:87,constructor:137,debugger:89,declare:138,default:90,delete:91,do:92,else:93,enum:94,export:95,extends:96,false:97,finally:98,for:99,from:161,function:100,get:139,if:101,implements:119,import:102,in:103,infer:140,instanceof:104,interface:120,intrinsic:141,is:142,keyof:143,let:121,module:144,namespace:145,never:146,new:105,null:106,number:150,object:151,package:122,private:123,protected:124,public:125,override:164,out:147,readonly:148,require:149,global:162,return:107,satisfies:152,set:153,static:126,string:154,super:108,switch:109,symbol:155,this:110,throw:111,true:112,try:113,type:156,typeof:114,undefined:157,unique:158,unknown:159,using:160,var:115,void:116,while:117,with:118,yield:127,async:134,await:135,of:165},Xvt=new Map(Object.entries(m5)),BOe=new Map(Object.entries({...m5,"{":19,"}":20,"(":21,")":22,"[":23,"]":24,".":25,"...":26,";":27,",":28,"<":30,">":32,"<=":33,">=":34,"==":35,"!=":36,"===":37,"!==":38,"=>":39,"+":40,"-":41,"**":43,"*":42,"/":44,"%":45,"++":46,"--":47,"<<":48,"</":31,">>":49,">>>":50,"&":51,"|":52,"^":53,"!":54,"~":55,"&&":56,"||":57,"?":58,"??":61,"?.":29,":":59,"=":64,"+=":65,"-=":66,"*=":67,"**=":68,"/=":69,"%=":70,"<<=":71,">>=":72,">>>=":73,"&=":74,"|=":75,"^=":79,"||=":76,"&&=":77,"??=":78,"@":60,"#":63,"`":62})),UOe=new Map(Object.entries({d:1,g:2,i:4,m:8,s:16,u:32,v:64,y:128})),Qvt=new Map([[1,9],[16,5],[32,2],[64,99],[128,2]]),Zvt=[170,170,181,181,186,186,192,214,216,246,248,705,710,721,736,740,748,748,750,750,880,884,886,887,890,893,902,902,904,906,908,908,910,929,931,1013,1015,1153,1162,1319,1329,1366,1369,1369,1377,1415,1488,1514,1520,1522,1568,1610,1646,1647,1649,1747,1749,1749,1765,1766,1774,1775,1786,1788,1791,1791,1808,1808,1810,1839,1869,1957,1969,1969,1994,2026,2036,2037,2042,2042,2048,2069,2074,2074,2084,2084,2088,2088,2112,2136,2208,2208,2210,2220,2308,2361,2365,2365,2384,2384,2392,2401,2417,2423,2425,2431,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2493,2493,2510,2510,2524,2525,2527,2529,2544,2545,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2649,2652,2654,2654,2674,2676,2693,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2749,2749,2768,2768,2784,2785,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2869,2873,2877,2877,2908,2909,2911,2913,2929,2929,2947,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,3001,3024,3024,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3133,3133,3160,3161,3168,3169,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3261,3261,3294,3294,3296,3297,3313,3314,3333,3340,3342,3344,3346,3386,3389,3389,3406,3406,3424,3425,3450,3455,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3585,3632,3634,3635,3648,3654,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3760,3762,3763,3773,3773,3776,3780,3782,3782,3804,3807,3840,3840,3904,3911,3913,3948,3976,3980,4096,4138,4159,4159,4176,4181,4186,4189,4193,4193,4197,4198,4206,4208,4213,4225,4238,4238,4256,4293,4295,4295,4301,4301,4304,4346,4348,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4744,4746,4749,4752,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4822,4824,4880,4882,4885,4888,4954,4992,5007,5024,5108,5121,5740,5743,5759,5761,5786,5792,5866,5870,5872,5888,5900,5902,5905,5920,5937,5952,5969,5984,5996,5998,6e3,6016,6067,6103,6103,6108,6108,6176,6263,6272,6312,6314,6314,6320,6389,6400,6428,6480,6509,6512,6516,6528,6571,6593,6599,6656,6678,6688,6740,6823,6823,6917,6963,6981,6987,7043,7072,7086,7087,7098,7141,7168,7203,7245,7247,7258,7293,7401,7404,7406,7409,7413,7414,7424,7615,7680,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8305,8305,8319,8319,8336,8348,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8505,8508,8511,8517,8521,8526,8526,8544,8584,11264,11310,11312,11358,11360,11492,11499,11502,11506,11507,11520,11557,11559,11559,11565,11565,11568,11623,11631,11631,11648,11670,11680,11686,11688,11694,11696,11702,11704,11710,11712,11718,11720,11726,11728,11734,11736,11742,11823,11823,12293,12295,12321,12329,12337,12341,12344,12348,12353,12438,12445,12447,12449,12538,12540,12543,12549,12589,12593,12686,12704,12730,12784,12799,13312,19893,19968,40908,40960,42124,42192,42237,42240,42508,42512,42527,42538,42539,42560,42606,42623,42647,42656,42735,42775,42783,42786,42888,42891,42894,42896,42899,42912,42922,43e3,43009,43011,43013,43015,43018,43020,43042,43072,43123,43138,43187,43250,43255,43259,43259,43274,43301,43312,43334,43360,43388,43396,43442,43471,43471,43520,43560,43584,43586,43588,43595,43616,43638,43642,43642,43648,43695,43697,43697,43701,43702,43705,43709,43712,43712,43714,43714,43739,43741,43744,43754,43762,43764,43777,43782,43785,43790,43793,43798,43808,43814,43816,43822,43968,44002,44032,55203,55216,55238,55243,55291,63744,64109,64112,64217,64256,64262,64275,64279,64285,64285,64287,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65136,65140,65142,65276,65313,65338,65345,65370,65382,65470,65474,65479,65482,65487,65490,65495,65498,65500],e1t=[170,170,181,181,186,186,192,214,216,246,248,705,710,721,736,740,748,748,750,750,768,884,886,887,890,893,902,902,904,906,908,908,910,929,931,1013,1015,1153,1155,1159,1162,1319,1329,1366,1369,1369,1377,1415,1425,1469,1471,1471,1473,1474,1476,1477,1479,1479,1488,1514,1520,1522,1552,1562,1568,1641,1646,1747,1749,1756,1759,1768,1770,1788,1791,1791,1808,1866,1869,1969,1984,2037,2042,2042,2048,2093,2112,2139,2208,2208,2210,2220,2276,2302,2304,2403,2406,2415,2417,2423,2425,2431,2433,2435,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2492,2500,2503,2504,2507,2510,2519,2519,2524,2525,2527,2531,2534,2545,2561,2563,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2620,2620,2622,2626,2631,2632,2635,2637,2641,2641,2649,2652,2654,2654,2662,2677,2689,2691,2693,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2748,2757,2759,2761,2763,2765,2768,2768,2784,2787,2790,2799,2817,2819,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2869,2873,2876,2884,2887,2888,2891,2893,2902,2903,2908,2909,2911,2915,2918,2927,2929,2929,2946,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,3001,3006,3010,3014,3016,3018,3021,3024,3024,3031,3031,3046,3055,3073,3075,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3133,3140,3142,3144,3146,3149,3157,3158,3160,3161,3168,3171,3174,3183,3202,3203,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3260,3268,3270,3272,3274,3277,3285,3286,3294,3294,3296,3299,3302,3311,3313,3314,3330,3331,3333,3340,3342,3344,3346,3386,3389,3396,3398,3400,3402,3406,3415,3415,3424,3427,3430,3439,3450,3455,3458,3459,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3530,3530,3535,3540,3542,3542,3544,3551,3570,3571,3585,3642,3648,3662,3664,3673,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3769,3771,3773,3776,3780,3782,3782,3784,3789,3792,3801,3804,3807,3840,3840,3864,3865,3872,3881,3893,3893,3895,3895,3897,3897,3902,3911,3913,3948,3953,3972,3974,3991,3993,4028,4038,4038,4096,4169,4176,4253,4256,4293,4295,4295,4301,4301,4304,4346,4348,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4744,4746,4749,4752,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4822,4824,4880,4882,4885,4888,4954,4957,4959,4992,5007,5024,5108,5121,5740,5743,5759,5761,5786,5792,5866,5870,5872,5888,5900,5902,5908,5920,5940,5952,5971,5984,5996,5998,6e3,6002,6003,6016,6099,6103,6103,6108,6109,6112,6121,6155,6157,6160,6169,6176,6263,6272,6314,6320,6389,6400,6428,6432,6443,6448,6459,6470,6509,6512,6516,6528,6571,6576,6601,6608,6617,6656,6683,6688,6750,6752,6780,6783,6793,6800,6809,6823,6823,6912,6987,6992,7001,7019,7027,7040,7155,7168,7223,7232,7241,7245,7293,7376,7378,7380,7414,7424,7654,7676,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8204,8205,8255,8256,8276,8276,8305,8305,8319,8319,8336,8348,8400,8412,8417,8417,8421,8432,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8505,8508,8511,8517,8521,8526,8526,8544,8584,11264,11310,11312,11358,11360,11492,11499,11507,11520,11557,11559,11559,11565,11565,11568,11623,11631,11631,11647,11670,11680,11686,11688,11694,11696,11702,11704,11710,11712,11718,11720,11726,11728,11734,11736,11742,11744,11775,11823,11823,12293,12295,12321,12335,12337,12341,12344,12348,12353,12438,12441,12442,12445,12447,12449,12538,12540,12543,12549,12589,12593,12686,12704,12730,12784,12799,13312,19893,19968,40908,40960,42124,42192,42237,42240,42508,42512,42539,42560,42607,42612,42621,42623,42647,42655,42737,42775,42783,42786,42888,42891,42894,42896,42899,42912,42922,43e3,43047,43072,43123,43136,43204,43216,43225,43232,43255,43259,43259,43264,43309,43312,43347,43360,43388,43392,43456,43471,43481,43520,43574,43584,43597,43600,43609,43616,43638,43642,43643,43648,43714,43739,43741,43744,43759,43762,43766,43777,43782,43785,43790,43793,43798,43808,43814,43816,43822,43968,44010,44012,44013,44016,44025,44032,55203,55216,55238,55243,55291,63744,64109,64112,64217,64256,64262,64275,64279,64285,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65024,65039,65056,65062,65075,65076,65101,65103,65136,65140,65142,65276,65296,65305,65313,65338,65343,65343,65345,65370,65382,65470,65474,65479,65482,65487,65490,65495,65498,65500],t1t=[65,90,97,122,170,170,181,181,186,186,192,214,216,246,248,705,710,721,736,740,748,748,750,750,880,884,886,887,890,893,895,895,902,902,904,906,908,908,910,929,931,1013,1015,1153,1162,1327,1329,1366,1369,1369,1376,1416,1488,1514,1519,1522,1568,1610,1646,1647,1649,1747,1749,1749,1765,1766,1774,1775,1786,1788,1791,1791,1808,1808,1810,1839,1869,1957,1969,1969,1994,2026,2036,2037,2042,2042,2048,2069,2074,2074,2084,2084,2088,2088,2112,2136,2144,2154,2160,2183,2185,2190,2208,2249,2308,2361,2365,2365,2384,2384,2392,2401,2417,2432,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2493,2493,2510,2510,2524,2525,2527,2529,2544,2545,2556,2556,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2649,2652,2654,2654,2674,2676,2693,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2749,2749,2768,2768,2784,2785,2809,2809,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2869,2873,2877,2877,2908,2909,2911,2913,2929,2929,2947,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,3001,3024,3024,3077,3084,3086,3088,3090,3112,3114,3129,3133,3133,3160,3162,3165,3165,3168,3169,3200,3200,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3261,3261,3293,3294,3296,3297,3313,3314,3332,3340,3342,3344,3346,3386,3389,3389,3406,3406,3412,3414,3423,3425,3450,3455,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3585,3632,3634,3635,3648,3654,3713,3714,3716,3716,3718,3722,3724,3747,3749,3749,3751,3760,3762,3763,3773,3773,3776,3780,3782,3782,3804,3807,3840,3840,3904,3911,3913,3948,3976,3980,4096,4138,4159,4159,4176,4181,4186,4189,4193,4193,4197,4198,4206,4208,4213,4225,4238,4238,4256,4293,4295,4295,4301,4301,4304,4346,4348,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4744,4746,4749,4752,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4822,4824,4880,4882,4885,4888,4954,4992,5007,5024,5109,5112,5117,5121,5740,5743,5759,5761,5786,5792,5866,5870,5880,5888,5905,5919,5937,5952,5969,5984,5996,5998,6e3,6016,6067,6103,6103,6108,6108,6176,6264,6272,6312,6314,6314,6320,6389,6400,6430,6480,6509,6512,6516,6528,6571,6576,6601,6656,6678,6688,6740,6823,6823,6917,6963,6981,6988,7043,7072,7086,7087,7098,7141,7168,7203,7245,7247,7258,7293,7296,7304,7312,7354,7357,7359,7401,7404,7406,7411,7413,7414,7418,7418,7424,7615,7680,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8305,8305,8319,8319,8336,8348,8450,8450,8455,8455,8458,8467,8469,8469,8472,8477,8484,8484,8486,8486,8488,8488,8490,8505,8508,8511,8517,8521,8526,8526,8544,8584,11264,11492,11499,11502,11506,11507,11520,11557,11559,11559,11565,11565,11568,11623,11631,11631,11648,11670,11680,11686,11688,11694,11696,11702,11704,11710,11712,11718,11720,11726,11728,11734,11736,11742,12293,12295,12321,12329,12337,12341,12344,12348,12353,12438,12443,12447,12449,12538,12540,12543,12549,12591,12593,12686,12704,12735,12784,12799,13312,19903,19968,42124,42192,42237,42240,42508,42512,42527,42538,42539,42560,42606,42623,42653,42656,42735,42775,42783,42786,42888,42891,42954,42960,42961,42963,42963,42965,42969,42994,43009,43011,43013,43015,43018,43020,43042,43072,43123,43138,43187,43250,43255,43259,43259,43261,43262,43274,43301,43312,43334,43360,43388,43396,43442,43471,43471,43488,43492,43494,43503,43514,43518,43520,43560,43584,43586,43588,43595,43616,43638,43642,43642,43646,43695,43697,43697,43701,43702,43705,43709,43712,43712,43714,43714,43739,43741,43744,43754,43762,43764,43777,43782,43785,43790,43793,43798,43808,43814,43816,43822,43824,43866,43868,43881,43888,44002,44032,55203,55216,55238,55243,55291,63744,64109,64112,64217,64256,64262,64275,64279,64285,64285,64287,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65136,65140,65142,65276,65313,65338,65345,65370,65382,65470,65474,65479,65482,65487,65490,65495,65498,65500,65536,65547,65549,65574,65576,65594,65596,65597,65599,65613,65616,65629,65664,65786,65856,65908,66176,66204,66208,66256,66304,66335,66349,66378,66384,66421,66432,66461,66464,66499,66504,66511,66513,66517,66560,66717,66736,66771,66776,66811,66816,66855,66864,66915,66928,66938,66940,66954,66956,66962,66964,66965,66967,66977,66979,66993,66995,67001,67003,67004,67072,67382,67392,67413,67424,67431,67456,67461,67463,67504,67506,67514,67584,67589,67592,67592,67594,67637,67639,67640,67644,67644,67647,67669,67680,67702,67712,67742,67808,67826,67828,67829,67840,67861,67872,67897,67968,68023,68030,68031,68096,68096,68112,68115,68117,68119,68121,68149,68192,68220,68224,68252,68288,68295,68297,68324,68352,68405,68416,68437,68448,68466,68480,68497,68608,68680,68736,68786,68800,68850,68864,68899,69248,69289,69296,69297,69376,69404,69415,69415,69424,69445,69488,69505,69552,69572,69600,69622,69635,69687,69745,69746,69749,69749,69763,69807,69840,69864,69891,69926,69956,69956,69959,69959,69968,70002,70006,70006,70019,70066,70081,70084,70106,70106,70108,70108,70144,70161,70163,70187,70207,70208,70272,70278,70280,70280,70282,70285,70287,70301,70303,70312,70320,70366,70405,70412,70415,70416,70419,70440,70442,70448,70450,70451,70453,70457,70461,70461,70480,70480,70493,70497,70656,70708,70727,70730,70751,70753,70784,70831,70852,70853,70855,70855,71040,71086,71128,71131,71168,71215,71236,71236,71296,71338,71352,71352,71424,71450,71488,71494,71680,71723,71840,71903,71935,71942,71945,71945,71948,71955,71957,71958,71960,71983,71999,71999,72001,72001,72096,72103,72106,72144,72161,72161,72163,72163,72192,72192,72203,72242,72250,72250,72272,72272,72284,72329,72349,72349,72368,72440,72704,72712,72714,72750,72768,72768,72818,72847,72960,72966,72968,72969,72971,73008,73030,73030,73056,73061,73063,73064,73066,73097,73112,73112,73440,73458,73474,73474,73476,73488,73490,73523,73648,73648,73728,74649,74752,74862,74880,75075,77712,77808,77824,78895,78913,78918,82944,83526,92160,92728,92736,92766,92784,92862,92880,92909,92928,92975,92992,92995,93027,93047,93053,93071,93760,93823,93952,94026,94032,94032,94099,94111,94176,94177,94179,94179,94208,100343,100352,101589,101632,101640,110576,110579,110581,110587,110589,110590,110592,110882,110898,110898,110928,110930,110933,110933,110948,110951,110960,111355,113664,113770,113776,113788,113792,113800,113808,113817,119808,119892,119894,119964,119966,119967,119970,119970,119973,119974,119977,119980,119982,119993,119995,119995,119997,120003,120005,120069,120071,120074,120077,120084,120086,120092,120094,120121,120123,120126,120128,120132,120134,120134,120138,120144,120146,120485,120488,120512,120514,120538,120540,120570,120572,120596,120598,120628,120630,120654,120656,120686,120688,120712,120714,120744,120746,120770,120772,120779,122624,122654,122661,122666,122928,122989,123136,123180,123191,123197,123214,123214,123536,123565,123584,123627,124112,124139,124896,124902,124904,124907,124909,124910,124912,124926,124928,125124,125184,125251,125259,125259,126464,126467,126469,126495,126497,126498,126500,126500,126503,126503,126505,126514,126516,126519,126521,126521,126523,126523,126530,126530,126535,126535,126537,126537,126539,126539,126541,126543,126545,126546,126548,126548,126551,126551,126553,126553,126555,126555,126557,126557,126559,126559,126561,126562,126564,126564,126567,126570,126572,126578,126580,126583,126585,126588,126590,126590,126592,126601,126603,126619,126625,126627,126629,126633,126635,126651,131072,173791,173824,177977,177984,178205,178208,183969,183984,191456,191472,192093,194560,195101,196608,201546,201552,205743],r1t=[48,57,65,90,95,95,97,122,170,170,181,181,183,183,186,186,192,214,216,246,248,705,710,721,736,740,748,748,750,750,768,884,886,887,890,893,895,895,902,906,908,908,910,929,931,1013,1015,1153,1155,1159,1162,1327,1329,1366,1369,1369,1376,1416,1425,1469,1471,1471,1473,1474,1476,1477,1479,1479,1488,1514,1519,1522,1552,1562,1568,1641,1646,1747,1749,1756,1759,1768,1770,1788,1791,1791,1808,1866,1869,1969,1984,2037,2042,2042,2045,2045,2048,2093,2112,2139,2144,2154,2160,2183,2185,2190,2200,2273,2275,2403,2406,2415,2417,2435,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2492,2500,2503,2504,2507,2510,2519,2519,2524,2525,2527,2531,2534,2545,2556,2556,2558,2558,2561,2563,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2620,2620,2622,2626,2631,2632,2635,2637,2641,2641,2649,2652,2654,2654,2662,2677,2689,2691,2693,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2748,2757,2759,2761,2763,2765,2768,2768,2784,2787,2790,2799,2809,2815,2817,2819,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2869,2873,2876,2884,2887,2888,2891,2893,2901,2903,2908,2909,2911,2915,2918,2927,2929,2929,2946,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,3001,3006,3010,3014,3016,3018,3021,3024,3024,3031,3031,3046,3055,3072,3084,3086,3088,3090,3112,3114,3129,3132,3140,3142,3144,3146,3149,3157,3158,3160,3162,3165,3165,3168,3171,3174,3183,3200,3203,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3260,3268,3270,3272,3274,3277,3285,3286,3293,3294,3296,3299,3302,3311,3313,3315,3328,3340,3342,3344,3346,3396,3398,3400,3402,3406,3412,3415,3423,3427,3430,3439,3450,3455,3457,3459,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3530,3530,3535,3540,3542,3542,3544,3551,3558,3567,3570,3571,3585,3642,3648,3662,3664,3673,3713,3714,3716,3716,3718,3722,3724,3747,3749,3749,3751,3773,3776,3780,3782,3782,3784,3790,3792,3801,3804,3807,3840,3840,3864,3865,3872,3881,3893,3893,3895,3895,3897,3897,3902,3911,3913,3948,3953,3972,3974,3991,3993,4028,4038,4038,4096,4169,4176,4253,4256,4293,4295,4295,4301,4301,4304,4346,4348,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4744,4746,4749,4752,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4822,4824,4880,4882,4885,4888,4954,4957,4959,4969,4977,4992,5007,5024,5109,5112,5117,5121,5740,5743,5759,5761,5786,5792,5866,5870,5880,5888,5909,5919,5940,5952,5971,5984,5996,5998,6e3,6002,6003,6016,6099,6103,6103,6108,6109,6112,6121,6155,6157,6159,6169,6176,6264,6272,6314,6320,6389,6400,6430,6432,6443,6448,6459,6470,6509,6512,6516,6528,6571,6576,6601,6608,6618,6656,6683,6688,6750,6752,6780,6783,6793,6800,6809,6823,6823,6832,6845,6847,6862,6912,6988,6992,7001,7019,7027,7040,7155,7168,7223,7232,7241,7245,7293,7296,7304,7312,7354,7357,7359,7376,7378,7380,7418,7424,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8204,8205,8255,8256,8276,8276,8305,8305,8319,8319,8336,8348,8400,8412,8417,8417,8421,8432,8450,8450,8455,8455,8458,8467,8469,8469,8472,8477,8484,8484,8486,8486,8488,8488,8490,8505,8508,8511,8517,8521,8526,8526,8544,8584,11264,11492,11499,11507,11520,11557,11559,11559,11565,11565,11568,11623,11631,11631,11647,11670,11680,11686,11688,11694,11696,11702,11704,11710,11712,11718,11720,11726,11728,11734,11736,11742,11744,11775,12293,12295,12321,12335,12337,12341,12344,12348,12353,12438,12441,12447,12449,12543,12549,12591,12593,12686,12704,12735,12784,12799,13312,19903,19968,42124,42192,42237,42240,42508,42512,42539,42560,42607,42612,42621,42623,42737,42775,42783,42786,42888,42891,42954,42960,42961,42963,42963,42965,42969,42994,43047,43052,43052,43072,43123,43136,43205,43216,43225,43232,43255,43259,43259,43261,43309,43312,43347,43360,43388,43392,43456,43471,43481,43488,43518,43520,43574,43584,43597,43600,43609,43616,43638,43642,43714,43739,43741,43744,43759,43762,43766,43777,43782,43785,43790,43793,43798,43808,43814,43816,43822,43824,43866,43868,43881,43888,44010,44012,44013,44016,44025,44032,55203,55216,55238,55243,55291,63744,64109,64112,64217,64256,64262,64275,64279,64285,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65024,65039,65056,65071,65075,65076,65101,65103,65136,65140,65142,65276,65296,65305,65313,65338,65343,65343,65345,65370,65381,65470,65474,65479,65482,65487,65490,65495,65498,65500,65536,65547,65549,65574,65576,65594,65596,65597,65599,65613,65616,65629,65664,65786,65856,65908,66045,66045,66176,66204,66208,66256,66272,66272,66304,66335,66349,66378,66384,66426,66432,66461,66464,66499,66504,66511,66513,66517,66560,66717,66720,66729,66736,66771,66776,66811,66816,66855,66864,66915,66928,66938,66940,66954,66956,66962,66964,66965,66967,66977,66979,66993,66995,67001,67003,67004,67072,67382,67392,67413,67424,67431,67456,67461,67463,67504,67506,67514,67584,67589,67592,67592,67594,67637,67639,67640,67644,67644,67647,67669,67680,67702,67712,67742,67808,67826,67828,67829,67840,67861,67872,67897,67968,68023,68030,68031,68096,68099,68101,68102,68108,68115,68117,68119,68121,68149,68152,68154,68159,68159,68192,68220,68224,68252,68288,68295,68297,68326,68352,68405,68416,68437,68448,68466,68480,68497,68608,68680,68736,68786,68800,68850,68864,68903,68912,68921,69248,69289,69291,69292,69296,69297,69373,69404,69415,69415,69424,69456,69488,69509,69552,69572,69600,69622,69632,69702,69734,69749,69759,69818,69826,69826,69840,69864,69872,69881,69888,69940,69942,69951,69956,69959,69968,70003,70006,70006,70016,70084,70089,70092,70094,70106,70108,70108,70144,70161,70163,70199,70206,70209,70272,70278,70280,70280,70282,70285,70287,70301,70303,70312,70320,70378,70384,70393,70400,70403,70405,70412,70415,70416,70419,70440,70442,70448,70450,70451,70453,70457,70459,70468,70471,70472,70475,70477,70480,70480,70487,70487,70493,70499,70502,70508,70512,70516,70656,70730,70736,70745,70750,70753,70784,70853,70855,70855,70864,70873,71040,71093,71096,71104,71128,71133,71168,71232,71236,71236,71248,71257,71296,71352,71360,71369,71424,71450,71453,71467,71472,71481,71488,71494,71680,71738,71840,71913,71935,71942,71945,71945,71948,71955,71957,71958,71960,71989,71991,71992,71995,72003,72016,72025,72096,72103,72106,72151,72154,72161,72163,72164,72192,72254,72263,72263,72272,72345,72349,72349,72368,72440,72704,72712,72714,72758,72760,72768,72784,72793,72818,72847,72850,72871,72873,72886,72960,72966,72968,72969,72971,73014,73018,73018,73020,73021,73023,73031,73040,73049,73056,73061,73063,73064,73066,73102,73104,73105,73107,73112,73120,73129,73440,73462,73472,73488,73490,73530,73534,73538,73552,73561,73648,73648,73728,74649,74752,74862,74880,75075,77712,77808,77824,78895,78912,78933,82944,83526,92160,92728,92736,92766,92768,92777,92784,92862,92864,92873,92880,92909,92912,92916,92928,92982,92992,92995,93008,93017,93027,93047,93053,93071,93760,93823,93952,94026,94031,94087,94095,94111,94176,94177,94179,94180,94192,94193,94208,100343,100352,101589,101632,101640,110576,110579,110581,110587,110589,110590,110592,110882,110898,110898,110928,110930,110933,110933,110948,110951,110960,111355,113664,113770,113776,113788,113792,113800,113808,113817,113821,113822,118528,118573,118576,118598,119141,119145,119149,119154,119163,119170,119173,119179,119210,119213,119362,119364,119808,119892,119894,119964,119966,119967,119970,119970,119973,119974,119977,119980,119982,119993,119995,119995,119997,120003,120005,120069,120071,120074,120077,120084,120086,120092,120094,120121,120123,120126,120128,120132,120134,120134,120138,120144,120146,120485,120488,120512,120514,120538,120540,120570,120572,120596,120598,120628,120630,120654,120656,120686,120688,120712,120714,120744,120746,120770,120772,120779,120782,120831,121344,121398,121403,121452,121461,121461,121476,121476,121499,121503,121505,121519,122624,122654,122661,122666,122880,122886,122888,122904,122907,122913,122915,122916,122918,122922,122928,122989,123023,123023,123136,123180,123184,123197,123200,123209,123214,123214,123536,123566,123584,123641,124112,124153,124896,124902,124904,124907,124909,124910,124912,124926,124928,125124,125136,125142,125184,125259,125264,125273,126464,126467,126469,126495,126497,126498,126500,126500,126503,126503,126505,126514,126516,126519,126521,126521,126523,126523,126530,126530,126535,126535,126537,126537,126539,126539,126541,126543,126545,126546,126548,126548,126551,126551,126553,126553,126555,126555,126557,126557,126559,126559,126561,126562,126564,126564,126567,126570,126572,126578,126580,126583,126585,126588,126590,126590,126592,126601,126603,126619,126625,126627,126629,126633,126635,126651,130032,130041,131072,173791,173824,177977,177984,178205,178208,183969,183984,191456,191472,192093,194560,195101,196608,201546,201552,205743,917760,917999],n1t=/^\/\/\/?\s*@(ts-expect-error|ts-ignore)/,i1t=/^(?:\/|\*)*\s*@(ts-expect-error|ts-ignore)/,s1t=/@(?:see|link)/i;function v$(e,t){if(e<t[0])return!1;let n=0,i=t.length,s;for(;n+1<i;){if(s=n+(i-n)/2,s-=s%2,t[s]<=e&&e<=t[s+1])return!0;e<t[s]?i=s:n=s+2}return!1}function g5(e,t){return t>=2?v$(e,t1t):v$(e,Zvt)}function a1t(e,t){return t>=2?v$(e,r1t):v$(e,e1t)}function VOe(e){let t=[];return e.forEach((n,i)=>{t[n]=i}),t}var o1t=VOe(BOe);function Sa(e){return o1t[e]}function JT(e){return BOe.get(e)}var c1t=VOe(UOe);function JOe(e){return c1t[e]}function S$(e){return UOe.get(e)}function $C(e){let t=[],n=0,i=0;for(;n<e.length;){let s=e.charCodeAt(n);switch(n++,s){case 13:e.charCodeAt(n)===10&&n++;case 10:t.push(i),i=n;break;default:s>127&&v_(s)&&(t.push(i),i=n);break}}return t.push(i),t}function T3(e,t,n,i){return e.getPositionOfLineAndCharacter?e.getPositionOfLineAndCharacter(t,n,i):h5(Sy(e),t,n,e.text,i)}function h5(e,t,n,i,s){(t<0||t>=e.length)&&(s?t=t<0?0:t>=e.length?e.length-1:t:M.fail(`Bad line number. Line: ${t}, lineStarts.length: ${e.length} , line map is correct? ${i!==void 0?UT(e,$C(i)):"unknown"}`));let o=e[t]+n;return s?o>e[t+1]?e[t+1]:typeof i=="string"&&o>i.length?i.length:o:(t<e.length-1?M.assert(o<e[t+1]):i!==void 0&&M.assert(o<=i.length),o)}function Sy(e){return e.lineMap||(e.lineMap=$C(e.text))}function NP(e,t){let n=oI(e,t);return{line:n,character:t-e[n]}}function oI(e,t,n){let i=mv(e,t,ec,tc,n);return i<0&&(i=~i-1,M.assert(i!==-1,"position cannot precede the beginning of the file")),i}function cI(e,t,n){if(t===n)return 0;let i=Sy(e),s=Math.min(t,n),o=s===n,u=o?t:n,m=oI(i,s),d=oI(i,u,m);return o?m-d:d-m}function ba(e,t){return NP(Sy(e),t)}function by(e){return wg(e)||v_(e)}function wg(e){return e===32||e===9||e===11||e===12||e===160||e===133||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function v_(e){return e===10||e===13||e===8232||e===8233}function DP(e){return e>=48&&e<=57}function bue(e){return DP(e)||e>=65&&e<=70||e>=97&&e<=102}function Tue(e){return e>=65&&e<=90||e>=97&&e<=122}function qOe(e){return Tue(e)||DP(e)||e===95}function y5(e){return e>=48&&e<=55}function Eue(e,t){let n=e.charCodeAt(t);switch(n){case 13:case 10:case 9:case 11:case 12:case 32:case 47:case 60:case 124:case 61:case 62:return!0;case 35:return t===0;default:return n>127}}function Ja(e,t,n,i,s){if(ng(t))return t;let o=!1;for(;;){let u=e.charCodeAt(t);switch(u){case 13:e.charCodeAt(t+1)===10&&t++;case 10:if(t++,n)return t;o=!!s;continue;case 9:case 11:case 12:case 32:t++;continue;case 47:if(i)break;if(e.charCodeAt(t+1)===47){for(t+=2;t<e.length&&!v_(e.charCodeAt(t));)t++;o=!1;continue}if(e.charCodeAt(t+1)===42){for(t+=2;t<e.length;){if(e.charCodeAt(t)===42&&e.charCodeAt(t+1)===47){t+=2;break}t++}o=!1;continue}break;case 60:case 124:case 61:case 62:if(lI(e,t)){t=E3(e,t),o=!1;continue}break;case 35:if(t===0&&T$(e,t)){t=E$(e,t),o=!1;continue}break;case 42:if(o){t++,o=!1;continue}break;default:if(u>127&&by(u)){t++;continue}break}return t}}var b$=7;function lI(e,t){if(M.assert(t>=0),t===0||v_(e.charCodeAt(t-1))){let n=e.charCodeAt(t);if(t+b$<e.length){for(let i=0;i<b$;i++)if(e.charCodeAt(t+i)!==n)return!1;return n===61||e.charCodeAt(t+b$)===32}}return!1}function E3(e,t,n){n&&n(v.Merge_conflict_marker_encountered,t,b$);let i=e.charCodeAt(t),s=e.length;if(i===60||i===62)for(;t<s&&!v_(e.charCodeAt(t));)t++;else for(M.assert(i===124||i===61);t<s;){let o=e.charCodeAt(t);if((o===61||o===62)&&o!==i&&lI(e,t))break;t++}return t}var xue=/^#!.*/;function T$(e,t){return M.assert(t===0),xue.test(e)}function E$(e,t){let n=xue.exec(e)[0];return t=t+n.length,t}function x$(e,t,n,i,s,o,u){let m,d,S,E,x=!1,D=i,w=u;if(n===0){D=!0;let R=v5(t);R&&(n=R.length)}e:for(;n>=0&&n<t.length;){let R=t.charCodeAt(n);switch(R){case 13:t.charCodeAt(n+1)===10&&n++;case 10:if(n++,i)break e;D=!0,x&&(E=!0);continue;case 9:case 11:case 12:case 32:n++;continue;case 47:let L=t.charCodeAt(n+1),F=!1;if(L===47||L===42){let J=L===47?2:3,G=n;if(n+=2,L===47)for(;n<t.length;){if(v_(t.charCodeAt(n))){F=!0;break}n++}else for(;n<t.length;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2;break}n++}if(D){if(x&&(w=s(m,d,S,E,o,w),!e&&w))return w;m=G,d=n,S=J,E=F,x=!0}continue}break e;default:if(R>127&&by(R)){x&&v_(R)&&(E=!0),n++;continue}break e}}return x&&(w=s(m,d,S,E,o,w)),w}function x3(e,t,n,i){return x$(!1,e,t,!1,n,i)}function C3(e,t,n,i){return x$(!1,e,t,!0,n,i)}function Cue(e,t,n,i,s){return x$(!0,e,t,!1,n,i,s)}function Aue(e,t,n,i,s){return x$(!0,e,t,!0,n,i,s)}function zOe(e,t,n,i,s,o=[]){return o.push({kind:n,pos:e,end:t,hasTrailingNewLine:i}),o}function Ty(e,t){return Cue(e,t,zOe,void 0,void 0)}function L1(e,t){return Aue(e,t,zOe,void 0,void 0)}function v5(e){let t=xue.exec(e);if(t)return t[0]}function Ey(e,t){return Tue(e)||e===36||e===95||e>127&&g5(e,t)}function yv(e,t,n){return qOe(e)||e===36||(n===1?e===45||e===58:!1)||e>127&&a1t(e,t)}function sp(e,t,n){let i=uI(e,0);if(!Ey(i,t))return!1;for(let s=Mh(i);s<e.length;s+=Mh(i))if(!yv(i=uI(e,s),t,n))return!1;return!0}function xy(e,t,n=0,i,s,o,u){var m=i,d,S,E,x,D,w,R,L,F=0,J=!1,G=0,q=0;Gs(m,o,u);var ee={getTokenFullStart:()=>E,getStartPos:()=>E,getTokenEnd:()=>d,getTextPos:()=>d,getToken:()=>D,getTokenStart:()=>x,getTokenPos:()=>x,getTokenText:()=>m.substring(x,d),getTokenValue:()=>w,hasUnicodeEscape:()=>(R&1024)!==0,hasExtendedUnicodeEscape:()=>(R&8)!==0,hasPrecedingLineBreak:()=>(R&1)!==0,hasPrecedingJSDocComment:()=>(R&2)!==0,isIdentifier:()=>D===80||D>118,isReservedWord:()=>D>=83&&D<=118,isUnterminated:()=>(R&4)!==0,getCommentDirectives:()=>L,getNumericLiteralFlags:()=>R&25584,getTokenFlags:()=>R,reScanGreaterToken:Xe,reScanAsteriskEqualsToken:ht,reScanSlashToken:rr,reScanTemplateToken:or,reScanTemplateHeadOrNoSubstitutionTemplate:Zr,scanJsxIdentifier:Ii,scanJsxAttributeValue:$r,reScanJsxAttributeValue:Xs,reScanJsxToken:Oi,reScanLessThanToken:Sr,reScanHashToken:Pi,reScanQuestionToken:Cs,reScanInvalidIdentifier:_t,scanJsxToken:ss,scanJsDocToken:Yt,scanJSDocCommentTextToken:$e,scan:et,getText:Ui,clearCommentDirectives:la,setText:Gs,setScriptTarget:to,setLanguageVariant:lt,setScriptKind:St,setJSDocParsingMode:fe,setOnError:yr,resetTokenState:vt,setTextPos:vt,setSkipJsDocLeadingAsterisks:Ce,hasLeadingAsterisks:nt,tryScan:Ci,lookAhead:vi,scanRange:An};return M.isDebugging&&Object.defineProperty(ee,"__debugShowCurrentPositionInText",{get:()=>{let Me=ee.getText();return Me.slice(0,ee.getTokenFullStart())+"\u2551"+Me.slice(ee.getTokenFullStart())}}),ee;function W(Me){return uI(m,Me)}function pe(Me){return Me>=0&&Me<S?W(Me):-1}function K(Me){return m.charCodeAt(Me)}function re(Me){return Me>=0&&Me<S?K(Me):-1}function ue(Me,tt=d,ft,tr){if(s){let Oe=d;d=tt,s(Me,ft||0,tr),d=Oe}}function ce(){let Me=d,tt=!1,ft=!1,tr="";for(;;){let Oe=K(d);if(Oe===95){R|=512,tt?(tt=!1,ft=!0,tr+=m.substring(Me,d)):(R|=16384,ue(ft?v.Multiple_consecutive_numeric_separators_are_not_permitted:v.Numeric_separators_are_not_allowed_here,d,1)),d++,Me=d;continue}if(DP(Oe)){tt=!0,ft=!1,d++;continue}break}return K(d-1)===95&&(R|=16384,ue(v.Numeric_separators_are_not_allowed_here,d-1,1)),tr+m.substring(Me,d)}function ne(){let Me=d,tt;if(K(d)===48)if(d++,K(d)===95)R|=16896,ue(v.Numeric_separators_are_not_allowed_here,d,1),d--,tt=ce();else if(!me())R|=8192,tt=""+ +w;else if(!w)tt="0";else{w=""+parseInt(w,8),R|=32;let Nt=D===41,Ut=(Nt?"-":"")+"0o"+(+w).toString(8);return Nt&&Me--,ue(v.Octal_literals_are_not_allowed_Use_the_syntax_0,Me,d-Me,Ut),9}else tt=ce();let ft,tr;K(d)===46&&(d++,ft=ce());let Oe=d;if(K(d)===69||K(d)===101){d++,R|=16,(K(d)===43||K(d)===45)&&d++;let Nt=d,Ut=ce();Ut?(tr=m.substring(Oe,Nt)+Ut,Oe=d):ue(v.Digit_expected)}let At;if(R&512?(At=tt,ft&&(At+="."+ft),tr&&(At+=tr)):At=m.substring(Me,Oe),R&8192)return ue(v.Decimals_with_leading_zeros_are_not_allowed,Me,Oe-Me),w=""+ +At,9;if(ft!==void 0||R&16)return le(Me,ft===void 0&&!!(R&16)),w=""+ +At,9;{w=At;let Nt=qe();return le(Me),Nt}}function le(Me,tt){if(!Ey(W(d),e))return;let ft=d,{length:tr}=De();tr===1&&m[ft]==="n"?ue(tt?v.A_bigint_literal_cannot_use_exponential_notation:v.A_bigint_literal_must_be_an_integer,Me,ft-Me+1):(ue(v.An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal,ft,tr),d=ft)}function me(){let Me=d,tt=!0;for(;DP(re(d));)y5(K(d))||(tt=!1),d++;return w=m.substring(Me,d),tt}function de(Me,tt){let ft=xe(Me,!1,tt);return ft?parseInt(ft,16):-1}function Ae(Me,tt){return xe(Me,!0,tt)}function xe(Me,tt,ft){let tr=[],Oe=!1,At=!1;for(;tr.length<Me||tt;){let Nt=K(d);if(ft&&Nt===95){R|=512,Oe?(Oe=!1,At=!0):ue(At?v.Multiple_consecutive_numeric_separators_are_not_permitted:v.Numeric_separators_are_not_allowed_here,d,1),d++;continue}if(Oe=ft,Nt>=65&&Nt<=70)Nt+=32;else if(!(Nt>=48&&Nt<=57||Nt>=97&&Nt<=102))break;tr.push(Nt),d++,At=!1}return tr.length<Me&&(tr=[]),K(d-1)===95&&ue(v.Numeric_separators_are_not_allowed_here,d-1,1),String.fromCharCode(...tr)}function te(Me=!1){let tt=K(d);d++;let ft="",tr=d;for(;;){if(d>=S){ft+=m.substring(tr,d),R|=4,ue(v.Unterminated_string_literal);break}let Oe=K(d);if(Oe===tt){ft+=m.substring(tr,d),d++;break}if(Oe===92&&!Me){ft+=m.substring(tr,d),ft+=be(3),tr=d;continue}if((Oe===10||Oe===13)&&!Me){ft+=m.substring(tr,d),R|=4,ue(v.Unterminated_string_literal);break}d++}return ft}function he(Me){let tt=K(d)===96;d++;let ft=d,tr="",Oe;for(;;){if(d>=S){tr+=m.substring(ft,d),R|=4,ue(v.Unterminated_template_literal),Oe=tt?15:18;break}let At=K(d);if(At===96){tr+=m.substring(ft,d),d++,Oe=tt?15:18;break}if(At===36&&d+1<S&&K(d+1)===123){tr+=m.substring(ft,d),d+=2,Oe=tt?16:17;break}if(At===92){tr+=m.substring(ft,d),tr+=be(1|(Me?2:0)),ft=d;continue}if(At===13){tr+=m.substring(ft,d),d++,d<S&&K(d)===10&&d++,tr+=`
`,ft=d;continue}d++}return M.assert(Oe!==void 0),w=tr,Oe}function be(Me){let tt=d;if(d++,d>=S)return ue(v.Unexpected_end_of_text),"";let ft=K(d);switch(d++,ft){case 48:if(d>=S||!DP(K(d)))return"\0";case 49:case 50:case 51:d<S&&y5(K(d))&&d++;case 52:case 53:case 54:case 55:if(d<S&&y5(K(d))&&d++,R|=2048,Me&6){let At=parseInt(m.substring(tt+1,d),8);return Me&4&&!(Me&32)&&ft!==48?ue(v.Octal_escape_sequences_and_backreferences_are_not_allowed_in_a_character_class_If_this_was_intended_as_an_escape_sequence_use_the_syntax_0_instead,tt,d-tt,"\\x"+At.toString(16).padStart(2,"0")):ue(v.Octal_escape_sequences_are_not_allowed_Use_the_syntax_0,tt,d-tt,"\\x"+At.toString(16).padStart(2,"0")),String.fromCharCode(At)}return m.substring(tt,d);case 56:case 57:return R|=2048,Me&6?(Me&4&&!(Me&32)?ue(v.Decimal_escape_sequences_and_backreferences_are_not_allowed_in_a_character_class,tt,d-tt):ue(v.Escape_sequence_0_is_not_allowed,tt,d-tt,m.substring(tt,d)),String.fromCharCode(ft)):m.substring(tt,d);case 98:return"\b";case 116:return"	";case 110:return`
`;case 118:return"\v";case 102:return"\f";case 114:return"\r";case 39:return"'";case 34:return'"';case 117:if(Me&17&&d<S&&K(d)===123)return d-=2,Ve(!!(Me&6));for(;d<tt+6;d++)if(!(d<S&&bue(K(d))))return R|=2048,Me&6&&ue(v.Hexadecimal_digit_expected),m.substring(tt,d);R|=1024;let tr=parseInt(m.substring(tt+2,d),16),Oe=String.fromCharCode(tr);if(Me&16&&tr>=55296&&tr<=56319&&d+6<S&&m.substring(d,d+2)==="\\u"&&K(d+2)!==123){let At=d,Nt=d+2;for(;Nt<At+6;Nt++)if(!bue(K(d)))return Oe;let Ut=parseInt(m.substring(At+2,Nt),16);if(Ut>=56320&&Ut<=57343)return d=Nt,Oe+String.fromCharCode(Ut)}return Oe;case 120:for(;d<tt+4;d++)if(!(d<S&&bue(K(d))))return R|=2048,Me&6&&ue(v.Hexadecimal_digit_expected),m.substring(tt,d);return R|=4096,String.fromCharCode(parseInt(m.substring(tt+2,d),16));case 13:d<S&&K(d)===10&&d++;case 10:case 8232:case 8233:return"";default:return(Me&16||Me&4&&!(Me&8)&&yv(ft,e))&&ue(v.This_character_cannot_be_escaped_in_a_regular_expression,d-2,2),String.fromCharCode(ft)}}function Ve(Me){let tt=d;d+=3;let ft=d,tr=Ae(1,!1),Oe=tr?parseInt(tr,16):-1,At=!1;return Oe<0?(Me&&ue(v.Hexadecimal_digit_expected),At=!0):Oe>1114111&&(Me&&ue(v.An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive,ft,d-ft),At=!0),d>=S?(Me&&ue(v.Unexpected_end_of_text),At=!0):K(d)===125?d++:(Me&&ue(v.Unterminated_Unicode_escape_sequence),At=!0),At?(R|=2048,m.substring(tt,d)):(R|=8,_I(Oe))}function Pe(){if(d+5<S&&K(d+1)===117){let Me=d;d+=2;let tt=de(4,!1);return d=Me,tt}return-1}function ke(){if(W(d+1)===117&&W(d+2)===123){let Me=d;d+=3;let tt=Ae(1,!1),ft=tt?parseInt(tt,16):-1;return d=Me,ft}return-1}function De(){let Me="",tt=d;for(;d<S;){let ft=W(d);if(yv(ft,e))d+=Mh(ft);else if(ft===92){if(ft=ke(),ft>=0&&yv(ft,e)){Me+=Ve(!0),tt=d;continue}if(ft=Pe(),!(ft>=0&&yv(ft,e)))break;R|=1024,Me+=m.substring(tt,d),Me+=_I(ft),d+=6,tt=d}else break}return Me+=m.substring(tt,d),Me}function Be(){let Me=w.length;if(Me>=2&&Me<=12){let tt=w.charCodeAt(0);if(tt>=97&&tt<=122){let ft=Xvt.get(w);if(ft!==void 0)return D=ft}}return D=80}function ct(Me){let tt="",ft=!1,tr=!1;for(;;){let Oe=K(d);if(Oe===95){R|=512,ft?(ft=!1,tr=!0):ue(tr?v.Multiple_consecutive_numeric_separators_are_not_permitted:v.Numeric_separators_are_not_allowed_here,d,1),d++;continue}if(ft=!0,!DP(Oe)||Oe-48>=Me)break;tt+=m[d],d++,tr=!1}return K(d-1)===95&&ue(v.Numeric_separators_are_not_allowed_here,d-1,1),tt}function qe(){return K(d)===110?(w+="n",R&384&&(w=_O(w)+"n"),d++,10):(w=""+(R&128?parseInt(w.slice(2),2):R&256?parseInt(w.slice(2),8):+w),9)}function et(){for(E=d,R=0,J=!1;;){if(x=d,d>=S)return D=1;let Me=W(d);if(d===0&&Me===35&&T$(m,d)){if(d=E$(m,d),t)continue;return D=6}switch(Me){case 10:case 13:if(R|=1,t){d++;continue}else return Me===13&&d+1<S&&K(d+1)===10?d+=2:d++,D=4;case 9:case 11:case 12:case 32:case 160:case 5760:case 8192:case 8193:case 8194:case 8195:case 8196:case 8197:case 8198:case 8199:case 8200:case 8201:case 8202:case 8203:case 8239:case 8287:case 12288:case 65279:if(t){d++;continue}else{for(;d<S&&wg(K(d));)d++;return D=5}case 33:return K(d+1)===61?K(d+2)===61?(d+=3,D=38):(d+=2,D=36):(d++,D=54);case 34:case 39:return w=te(),D=11;case 96:return D=he(!1);case 37:return K(d+1)===61?(d+=2,D=70):(d++,D=45);case 38:return K(d+1)===38?K(d+2)===61?(d+=3,D=77):(d+=2,D=56):K(d+1)===61?(d+=2,D=74):(d++,D=51);case 40:return d++,D=21;case 41:return d++,D=22;case 42:if(K(d+1)===61)return d+=2,D=67;if(K(d+1)===42)return K(d+2)===61?(d+=3,D=68):(d+=2,D=43);if(d++,F&&!J&&R&1){J=!0;continue}return D=42;case 43:return K(d+1)===43?(d+=2,D=46):K(d+1)===61?(d+=2,D=65):(d++,D=40);case 44:return d++,D=28;case 45:return K(d+1)===45?(d+=2,D=47):K(d+1)===61?(d+=2,D=66):(d++,D=41);case 46:return DP(K(d+1))?(ne(),D=9):K(d+1)===46&&K(d+2)===46?(d+=3,D=26):(d++,D=25);case 47:if(K(d+1)===47){for(d+=2;d<S&&!v_(K(d));)d++;if(L=jr(L,m.slice(x,d),n1t,x),t)continue;return D=2}if(K(d+1)===42){d+=2;let Nt=K(d)===42&&K(d+1)!==47,Ut=!1,Rt=x;for(;d<S;){let nr=K(d);if(nr===42&&K(d+1)===47){d+=2,Ut=!0;break}d++,v_(nr)&&(Rt=d,R|=1)}if(Nt&&Ie()&&(R|=2),L=jr(L,m.slice(Rt,d),i1t,Rt),Ut||ue(v.Asterisk_Slash_expected),t)continue;return Ut||(R|=4),D=3}return K(d+1)===61?(d+=2,D=69):(d++,D=44);case 48:if(d+2<S&&(K(d+1)===88||K(d+1)===120))return d+=2,w=Ae(1,!0),w||(ue(v.Hexadecimal_digit_expected),w="0"),w="0x"+w,R|=64,D=qe();if(d+2<S&&(K(d+1)===66||K(d+1)===98))return d+=2,w=ct(2),w||(ue(v.Binary_digit_expected),w="0"),w="0b"+w,R|=128,D=qe();if(d+2<S&&(K(d+1)===79||K(d+1)===111))return d+=2,w=ct(8),w||(ue(v.Octal_digit_expected),w="0"),w="0o"+w,R|=256,D=qe();case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return D=ne();case 58:return d++,D=59;case 59:return d++,D=27;case 60:if(lI(m,d)){if(d=E3(m,d,ue),t)continue;return D=7}return K(d+1)===60?K(d+2)===61?(d+=3,D=71):(d+=2,D=48):K(d+1)===61?(d+=2,D=33):n===1&&K(d+1)===47&&K(d+2)!==42?(d+=2,D=31):(d++,D=30);case 61:if(lI(m,d)){if(d=E3(m,d,ue),t)continue;return D=7}return K(d+1)===61?K(d+2)===61?(d+=3,D=37):(d+=2,D=35):K(d+1)===62?(d+=2,D=39):(d++,D=64);case 62:if(lI(m,d)){if(d=E3(m,d,ue),t)continue;return D=7}return d++,D=32;case 63:return K(d+1)===46&&!DP(K(d+2))?(d+=2,D=29):K(d+1)===63?K(d+2)===61?(d+=3,D=78):(d+=2,D=61):(d++,D=58);case 91:return d++,D=23;case 93:return d++,D=24;case 94:return K(d+1)===61?(d+=2,D=79):(d++,D=53);case 123:return d++,D=19;case 124:if(lI(m,d)){if(d=E3(m,d,ue),t)continue;return D=7}return K(d+1)===124?K(d+2)===61?(d+=3,D=76):(d+=2,D=57):K(d+1)===61?(d+=2,D=75):(d++,D=52);case 125:return d++,D=20;case 126:return d++,D=55;case 64:return d++,D=60;case 92:let tt=ke();if(tt>=0&&Ey(tt,e))return w=Ve(!0)+De(),D=Be();let ft=Pe();return ft>=0&&Ey(ft,e)?(d+=6,R|=1024,w=String.fromCharCode(ft)+De(),D=Be()):(ue(v.Invalid_character),d++,D=0);case 35:if(d!==0&&m[d+1]==="!")return ue(v.can_only_be_used_at_the_start_of_a_file,d,2),d++,D=0;let tr=W(d+1);if(tr===92){d++;let Nt=ke();if(Nt>=0&&Ey(Nt,e))return w="#"+Ve(!0)+De(),D=81;let Ut=Pe();if(Ut>=0&&Ey(Ut,e))return d+=6,R|=1024,w="#"+String.fromCharCode(Ut)+De(),D=81;d--}return Ey(tr,e)?(d++,mt(tr,e)):(w="#",ue(v.Invalid_character,d++,Mh(Me))),D=81;case 65533:return ue(v.File_appears_to_be_binary,0,0),d=S,D=8;default:let Oe=mt(Me,e);if(Oe)return D=Oe;if(wg(Me)){d+=Mh(Me);continue}else if(v_(Me)){R|=1,d+=Mh(Me);continue}let At=Mh(Me);return ue(v.Invalid_character,d,At),d+=At,D=0}}}function Ie(){switch(q){case 0:return!0;case 1:return!1}return G!==3&&G!==4?!0:q===3?!1:s1t.test(m.slice(E,d))}function _t(){M.assert(D===0,"'reScanInvalidIdentifier' should only be called when the current token is 'SyntaxKind.Unknown'."),d=x=E,R=0;let Me=W(d),tt=mt(Me,99);return tt?D=tt:(d+=Mh(Me),D)}function mt(Me,tt){let ft=Me;if(Ey(ft,tt)){for(d+=Mh(ft);d<S&&yv(ft=W(d),tt);)d+=Mh(ft);return w=m.substring(x,d),ft===92&&(w+=De()),Be()}}function Xe(){if(D===32){if(K(d)===62)return K(d+1)===62?K(d+2)===61?(d+=3,D=73):(d+=2,D=50):K(d+1)===61?(d+=2,D=72):(d++,D=49);if(K(d)===61)return d++,D=34}return D}function ht(){return M.assert(D===67,"'reScanAsteriskEqualsToken' should only be called on a '*='"),d=x+1,D=64}function rr(Me){if(D===44||D===69){let tt=x+1;d=tt;let ft=!1,tr=!1,Oe=!1;for(;;){let Nt=re(d);if(Nt===-1||v_(Nt)){R|=4;break}if(ft)ft=!1;else{if(Nt===47&&!Oe)break;Nt===91?Oe=!0:Nt===92?ft=!0:Nt===93?Oe=!1:!Oe&&Nt===40&&re(d+1)===63&&re(d+2)===60&&re(d+3)!==61&&re(d+3)!==33&&(tr=!0)}d++}let At=d;if(R&4){d=tt,ft=!1;let Nt=0,Ut=!1,Rt=0;for(;d<At;){let nr=K(d);if(ft)ft=!1;else if(nr===92)ft=!0;else if(nr===91)Nt++;else if(nr===93&&Nt)Nt--;else if(!Nt){if(nr===123)Ut=!0;else if(nr===125&&Ut)Ut=!1;else if(!Ut){if(nr===40)Rt++;else if(nr===41&&Rt)Rt--;else if(nr===41||nr===93||nr===125)break}}d++}for(;by(re(d-1))||re(d-1)===59;)d--;ue(v.Unterminated_regular_expression_literal,x,d-x)}else{d++;let Nt=0;for(;;){let Ut=re(d);if(Ut===-1||!yv(Ut,e))break;if(Me){let Rt=S$(String.fromCharCode(Ut));Rt===void 0?ue(v.Unknown_regular_expression_flag,d,1):Nt&Rt?ue(v.Duplicate_regular_expression_flag,d,1):((Nt|Rt)&96)===96?ue(v.The_Unicode_u_flag_and_the_Unicode_Sets_v_flag_cannot_be_set_simultaneously,d,1):(Nt|=Rt,xr(Rt,d))}d++}Me&&An(tt,At-tt,()=>{vr(Nt,!0,tr)})}w=m.substring(x,d),D=14}return D}function vr(Me,tt,ft){var tr=!!(Me&64),Oe=!!(Me&96),At=Oe||!tt,Nt=!1,Ut=0,Rt,nr,Z,Ge=[],bt;function Q(Er){for(;;){if(Ge.push(bt),bt=void 0,Ke(Er),bt=Ge.pop(),re(d)!==124)return;d++}}function Ke(Er){let tn=!1;for(;;){let er=d,qs=re(d);switch(qs){case-1:return;case 94:case 36:d++,tn=!1;break;case 92:switch(d++,re(d)){case 98:case 66:d++,tn=!1;break;default:Ue(),tn=!0;break}break;case 40:if(d++,re(d)===63)switch(d++,re(d)){case 61:case 33:d++,tn=!At;break;case 60:let Do=d;switch(d++,re(d)){case 61:case 33:d++,tn=!1;break;default:It(!1),pi(62),e<5&&ue(v.Named_capturing_groups_are_only_available_when_targeting_ES2018_or_later,Do,d-Do),Ut++,tn=!0;break}break;default:let ms=d,sa=z(0);re(d)===45&&(d++,z(sa),d===ms+1&&ue(v.Subpattern_flags_must_be_present_when_there_is_a_minus_sign,ms,d-ms)),pi(58),tn=!0;break}else Ut++,tn=!0;Q(!0),pi(41);break;case 123:d++;let uo=d;me();let Mo=w;if(!At&&!Mo){tn=!0;break}if(re(d)===44){d++,me();let Do=w;if(Mo)Do&&Number.parseInt(Mo)>Number.parseInt(Do)&&(At||re(d)===125)&&ue(v.Numbers_out_of_order_in_quantifier,uo,d-uo);else if(Do||re(d)===125)ue(v.Incomplete_quantifier_Digit_expected,uo,0);else{ue(v.Unexpected_0_Did_you_mean_to_escape_it_with_backslash,er,1,String.fromCharCode(qs)),tn=!0;break}}else if(!Mo){At&&ue(v.Unexpected_0_Did_you_mean_to_escape_it_with_backslash,er,1,String.fromCharCode(qs)),tn=!0;break}if(re(d)!==125)if(At)ue(v._0_expected,d,0,"}"),d--;else{tn=!0;break}case 42:case 43:case 63:d++,re(d)===63&&d++,tn||ue(v.There_is_nothing_available_for_repetition,er,d-er),tn=!1;break;case 46:d++,tn=!0;break;case 91:d++,tr?dr():Ht(),pi(93),tn=!0;break;case 41:if(Er)return;case 93:case 125:(At||qs===41)&&ue(v.Unexpected_0_Did_you_mean_to_escape_it_with_backslash,d,1,String.fromCharCode(qs)),d++,tn=!0;break;case 47:case 124:return;default:Yn(),tn=!0;break}}}function z(Er){for(;;){let tn=re(d);if(tn===-1||!yv(tn,e))break;let er=S$(String.fromCharCode(tn));er===void 0?ue(v.Unknown_regular_expression_flag,d,1):Er&er?ue(v.Duplicate_regular_expression_flag,d,1):er&28?(Er|=er,xr(er,d)):ue(v.This_regular_expression_flag_cannot_be_toggled_within_a_subpattern,d,1),d++}return Er}function Ue(){switch(M.assertEqual(K(d-1),92),re(d)){case 107:d++,re(d)===60?(d++,It(!0),pi(62)):(At||ft)&&ue(v.k_must_be_followed_by_a_capturing_group_name_enclosed_in_angle_brackets,d-2,2);break;case 113:if(tr){d++,ue(v.q_is_only_available_inside_character_class,d-2,2);break}default:M.assert(Ki()||Te()||Re(!0));break}}function Te(){M.assertEqual(K(d-1),92);let Er=re(d);if(Er>=49&&Er<=57){let tn=d;return me(),Z=Bt(Z,{pos:tn,end:d,value:+w}),!0}return!1}function Re(Er){M.assertEqual(K(d-1),92);let tn=re(d);switch(tn){case-1:return ue(v.Undetermined_character_escape,d-1,1),"\\";case 99:if(d++,tn=re(d),Tue(tn))return d++,String.fromCharCode(tn&31);if(At)ue(v.c_must_be_followed_by_an_ASCII_letter,d-2,2);else if(Er)return d--,"\\";return String.fromCharCode(tn);case 94:case 36:case 47:case 92:case 46:case 42:case 43:case 63:case 40:case 41:case 91:case 93:case 123:case 125:case 124:return d++,String.fromCharCode(tn);default:return d--,be(4|(tt?8:0)|(Oe?16:0)|(Er?32:0))}}function It(Er){M.assertEqual(K(d-1),60),x=d,mt(pe(d),e),d===x?ue(v.Expected_a_capturing_group_name):Er?nr=Bt(nr,{pos:x,end:d,name:w}):bt?.has(w)||Ge.some(tn=>tn?.has(w))?ue(v.Named_capturing_groups_with_the_same_name_must_be_mutually_exclusive_to_each_other,x,d-x):(bt??(bt=new Set),bt.add(w),Rt??(Rt=new Set),Rt.add(w))}function $t(Er){return Er===93||Er===-1||d>=S}function Ht(){for(M.assertEqual(K(d-1),91),re(d)===94&&d++;;){let Er=re(d);if($t(Er))return;let tn=d,er=In();if(re(d)===45){d++;let qs=re(d);if($t(qs))return;!er&&At&&ue(v.A_character_class_range_must_not_be_bounded_by_another_character_class,tn,d-1-tn);let uo=d,Mo=In();if(!Mo&&At){ue(v.A_character_class_range_must_not_be_bounded_by_another_character_class,uo,d-uo);continue}if(!er)continue;let Do=uI(er,0),ms=uI(Mo,0);er.length===Mh(Do)&&Mo.length===Mh(ms)&&Do>ms&&ue(v.Range_out_of_order_in_character_class,tn,d-tn)}}}function dr(){M.assertEqual(K(d-1),91);let Er=!1;re(d)===94&&(d++,Er=!0);let tn=!1,er=re(d);if($t(er))return;let qs=d,uo;switch(m.slice(d,d+2)){case"--":case"&&":ue(v.Expected_a_class_set_operand),Nt=!1;break;default:uo=Hr();break}switch(re(d)){case 45:if(re(d+1)===45){Er&&Nt&&ue(v.Anything_that_would_possibly_match_more_than_a_single_character_is_invalid_inside_a_negated_character_class,qs,d-qs),tn=Nt,qr(3),Nt=!Er&&tn;return}break;case 38:if(re(d+1)===38){qr(2),Er&&Nt&&ue(v.Anything_that_would_possibly_match_more_than_a_single_character_is_invalid_inside_a_negated_character_class,qs,d-qs),tn=Nt,Nt=!Er&&tn;return}else ue(v.Unexpected_0_Did_you_mean_to_escape_it_with_backslash,d,1,String.fromCharCode(er));break;default:Er&&Nt&&ue(v.Anything_that_would_possibly_match_more_than_a_single_character_is_invalid_inside_a_negated_character_class,qs,d-qs),tn=Nt;break}for(;er=re(d),er!==-1;){switch(er){case 45:if(d++,er=re(d),$t(er)){Nt=!Er&&tn;return}if(er===45){d++,ue(v.Operators_must_not_be_mixed_within_a_character_class_Wrap_it_in_a_nested_class_instead,d-2,2),qs=d-2,uo=m.slice(qs,d);continue}else{uo||ue(v.A_character_class_range_must_not_be_bounded_by_another_character_class,qs,d-1-qs);let Mo=d,Do=Hr();if(Er&&Nt&&ue(v.Anything_that_would_possibly_match_more_than_a_single_character_is_invalid_inside_a_negated_character_class,Mo,d-Mo),tn||(tn=Nt),!Do){ue(v.A_character_class_range_must_not_be_bounded_by_another_character_class,Mo,d-Mo);break}if(!uo)break;let ms=uI(uo,0),sa=uI(Do,0);uo.length===Mh(ms)&&Do.length===Mh(sa)&&ms>sa&&ue(v.Range_out_of_order_in_character_class,qs,d-qs)}break;case 38:qs=d,d++,re(d)===38?(d++,ue(v.Operators_must_not_be_mixed_within_a_character_class_Wrap_it_in_a_nested_class_instead,d-2,2),re(d)===38&&(ue(v.Unexpected_0_Did_you_mean_to_escape_it_with_backslash,d,1,String.fromCharCode(er)),d++)):ue(v.Unexpected_0_Did_you_mean_to_escape_it_with_backslash,d-1,1,String.fromCharCode(er)),uo=m.slice(qs,d);continue}if($t(re(d)))break;switch(qs=d,m.slice(d,d+2)){case"--":case"&&":ue(v.Operators_must_not_be_mixed_within_a_character_class_Wrap_it_in_a_nested_class_instead,d,2),d+=2,uo=m.slice(qs,d);break;default:uo=Hr();break}}Nt=!Er&&tn}function qr(Er){let tn=Nt;for(;;){let er=re(d);if($t(er))break;switch(er){case 45:d++,re(d)===45?(d++,Er!==3&&ue(v.Operators_must_not_be_mixed_within_a_character_class_Wrap_it_in_a_nested_class_instead,d-2,2)):ue(v.Operators_must_not_be_mixed_within_a_character_class_Wrap_it_in_a_nested_class_instead,d-1,1);break;case 38:d++,re(d)===38?(d++,Er!==2&&ue(v.Operators_must_not_be_mixed_within_a_character_class_Wrap_it_in_a_nested_class_instead,d-2,2),re(d)===38&&(ue(v.Unexpected_0_Did_you_mean_to_escape_it_with_backslash,d,1,String.fromCharCode(er)),d++)):ue(v.Unexpected_0_Did_you_mean_to_escape_it_with_backslash,d-1,1,String.fromCharCode(er));break;default:switch(Er){case 3:ue(v._0_expected,d,0,"--");break;case 2:ue(v._0_expected,d,0,"&&");break;default:break}break}if(er=re(d),$t(er)){ue(v.Expected_a_class_set_operand);break}Hr(),tn&&(tn=Nt)}Nt=tn}function Hr(){switch(Nt=!1,re(d)){case-1:return"";case 91:return d++,dr(),pi(93),"";case 92:if(d++,Ki())return"";if(re(d)===113)return d++,re(d)===123?(d++,dn(),pi(125),""):(ue(v.q_must_be_followed_by_string_alternatives_enclosed_in_braces,d-2,2),"q");d--;default:return Ar()}}function dn(){M.assertEqual(K(d-1),123);let Er=0;for(;;)switch(re(d)){case-1:return;case 125:Er!==1&&(Nt=!0);return;case 124:Er!==1&&(Nt=!0),d++,o=d,Er=0;break;default:Ar(),Er++;break}}function Ar(){let Er=re(d);if(Er===-1)return"";if(Er===92){d++;let tn=re(d);switch(tn){case 98:return d++,"\b";case 38:case 45:case 33:case 35:case 37:case 44:case 58:case 59:case 60:case 61:case 62:case 64:case 96:case 126:return d++,String.fromCharCode(tn);default:return Re(!1)}}else if(Er===re(d+1))switch(Er){case 38:case 33:case 35:case 37:case 42:case 43:case 44:case 46:case 58:case 59:case 60:case 61:case 62:case 63:case 64:case 96:case 126:return ue(v.A_character_class_must_not_contain_a_reserved_double_punctuator_Did_you_mean_to_escape_it_with_backslash,d,2),d+=2,m.substring(d-2,d)}switch(Er){case 47:case 40:case 41:case 91:case 93:case 123:case 125:case 45:case 124:return ue(v.Unexpected_0_Did_you_mean_to_escape_it_with_backslash,d,1,String.fromCharCode(Er)),d++,String.fromCharCode(Er)}return Yn()}function In(){if(re(d)===92){d++;let Er=re(d);switch(Er){case 98:return d++,"\b";case 45:return d++,String.fromCharCode(Er);default:return Ki()?"":Re(!1)}}else return Yn()}function Ki(){M.assertEqual(K(d-1),92);let Er=!1,tn=d-1,er=re(d);switch(er){case 100:case 68:case 115:case 83:case 119:case 87:return d++,!0;case 80:Er=!0;case 112:if(d++,re(d)===123){d++;let qs=d,uo=ls();if(re(d)===61){let Mo=WOe.get(uo);if(d===qs)ue(v.Expected_a_Unicode_property_name);else if(Mo===void 0){ue(v.Unknown_Unicode_property_name,qs,d-qs);let sa=Fx(uo,WOe.keys(),ec);sa&&ue(v.Did_you_mean_0,qs,d-qs,sa)}d++;let Do=d,ms=ls();if(d===Do)ue(v.Expected_a_Unicode_property_value);else if(Mo!==void 0&&!A3[Mo].has(ms)){ue(v.Unknown_Unicode_property_value,Do,d-Do);let sa=Fx(ms,A3[Mo],ec);sa&&ue(v.Did_you_mean_0,Do,d-Do,sa)}}else if(d===qs)ue(v.Expected_a_Unicode_property_name_or_value);else if(HOe.has(uo))tr?Er?ue(v.Anything_that_would_possibly_match_more_than_a_single_character_is_invalid_inside_a_negated_character_class,qs,d-qs):Nt=!0:ue(v.Any_Unicode_property_that_would_possibly_match_more_than_a_single_character_is_only_available_when_the_Unicode_Sets_v_flag_is_set,qs,d-qs);else if(!A3.General_Category.has(uo)&&!$Oe.has(uo)){ue(v.Unknown_Unicode_property_name_or_value,qs,d-qs);let Mo=Fx(uo,[...A3.General_Category,...$Oe,...HOe],ec);Mo&&ue(v.Did_you_mean_0,qs,d-qs,Mo)}pi(125),Oe||ue(v.Unicode_property_value_expressions_are_only_available_when_the_Unicode_u_flag_or_the_Unicode_Sets_v_flag_is_set,tn,d-tn)}else if(At)ue(v._0_must_be_followed_by_a_Unicode_property_value_expression_enclosed_in_braces,d-2,2,String.fromCharCode(er));else return d--,!1;return!0}return!1}function ls(){let Er="";for(;;){let tn=re(d);if(tn===-1||!qOe(tn))break;Er+=String.fromCharCode(tn),d++}return Er}function Yn(){let Er=Oe?Mh(re(d)):1;return d+=Er,Er>0?m.substring(d-Er,d):""}function pi(Er){re(d)===Er?d++:ue(v._0_expected,d,0,String.fromCharCode(Er))}Q(!1),kt(nr,Er=>{Rt?.has(Er.name)||ue(v.There_is_no_capturing_group_named_0_in_this_regular_expression,Er.pos,Er.end-Er.pos,Er.name)}),kt(Z,Er=>{Er.value>Ut&&(Ut?ue(v.This_backreference_refers_to_a_group_that_does_not_exist_There_are_only_0_capturing_groups_in_this_regular_expression,Er.pos,Er.end-Er.pos,Ut):ue(v.This_backreference_refers_to_a_group_that_does_not_exist_There_are_no_capturing_groups_in_this_regular_expression,Er.pos,Er.end-Er.pos))})}function xr(Me,tt){let ft=Qvt.get(Me);ft&&e<ft&&ue(v.This_regular_expression_flag_is_only_available_when_targeting_0_or_later,tt,1,Y9(ft))}function jr(Me,tt,ft,tr){let Oe=ur(tt.trimStart(),ft);return Oe===void 0?Me:Bt(Me,{range:{pos:tr,end:d},type:Oe})}function ur(Me,tt){let ft=tt.exec(Me);if(ft)switch(ft[1]){case"ts-expect-error":return 0;case"ts-ignore":return 1}}function or(Me){return d=x,D=he(!Me)}function Zr(){return d=x,D=he(!0)}function Oi(Me=!0){return d=x=E,D=ss(Me)}function Sr(){return D===48?(d=x+1,D=30):D}function Pi(){return D===81?(d=x+1,D=63):D}function Cs(){return M.assert(D===61,"'reScanQuestionToken' should only be called on a '??'"),d=x+1,D=58}function ss(Me=!0){if(E=x=d,d>=S)return D=1;let tt=K(d);if(tt===60)return K(d+1)===47?(d+=2,D=31):(d++,D=30);if(tt===123)return d++,D=19;let ft=0;for(;d<S&&(tt=K(d),tt!==123);){if(tt===60){if(lI(m,d))return d=E3(m,d,ue),D=7;break}if(tt===62&&ue(v.Unexpected_token_Did_you_mean_or_gt,d,1),tt===125&&ue(v.Unexpected_token_Did_you_mean_or_rbrace,d,1),v_(tt)&&ft===0)ft=-1;else{if(!Me&&v_(tt)&&ft>0)break;by(tt)||(ft=d)}d++}return w=m.substring(E,d),ft===-1?13:12}function Ii(){if(F_(D)){for(;d<S;){if(K(d)===45){w+="-",d++;continue}let tt=d;if(w+=De(),d===tt)break}return Be()}return D}function $r(){switch(E=d,K(d)){case 34:case 39:return w=te(!0),D=11;default:return et()}}function Xs(){return d=x=E,$r()}function $e(Me){if(E=x=d,R=0,d>=S)return D=1;for(let tt=K(d);d<S&&!v_(tt)&&tt!==96;tt=W(++d))if(!Me){if(tt===123)break;if(tt===64&&d-1>=0&&wg(K(d-1))&&!(d+1<S&&by(K(d+1))))break}return d===x?Yt():(w=m.substring(x,d),D=82)}function Yt(){if(E=x=d,R=0,d>=S)return D=1;let Me=W(d);switch(d+=Mh(Me),Me){case 9:case 11:case 12:case 32:for(;d<S&&wg(K(d));)d++;return D=5;case 64:return D=60;case 13:K(d)===10&&d++;case 10:return R|=1,D=4;case 42:return D=42;case 123:return D=19;case 125:return D=20;case 91:return D=23;case 93:return D=24;case 40:return D=21;case 41:return D=22;case 60:return D=30;case 62:return D=32;case 61:return D=64;case 44:return D=28;case 46:return D=25;case 96:return D=62;case 35:return D=63;case 92:d--;let tt=ke();if(tt>=0&&Ey(tt,e))return w=Ve(!0)+De(),D=Be();let ft=Pe();return ft>=0&&Ey(ft,e)?(d+=6,R|=1024,w=String.fromCharCode(ft)+De(),D=Be()):(d++,D=0)}if(Ey(Me,e)){let tt=Me;for(;d<S&&yv(tt=W(d),e)||tt===45;)d+=Mh(tt);return w=m.substring(x,d),tt===92&&(w+=De()),D=Be()}else return D=0}function Vr(Me,tt){let ft=d,tr=E,Oe=x,At=D,Nt=w,Ut=R,Rt=Me();return(!Rt||tt)&&(d=ft,E=tr,x=Oe,D=At,w=Nt,R=Ut),Rt}function An(Me,tt,ft){let tr=S,Oe=d,At=E,Nt=x,Ut=D,Rt=w,nr=R,Z=L;Gs(m,Me,tt);let Ge=ft();return S=tr,d=Oe,E=At,x=Nt,D=Ut,w=Rt,R=nr,L=Z,Ge}function vi(Me){return Vr(Me,!0)}function Ci(Me){return Vr(Me,!1)}function Ui(){return m}function la(){L=void 0}function Gs(Me,tt,ft){m=Me||"",S=ft===void 0?m.length:tt+ft,vt(tt||0)}function yr(Me){s=Me}function to(Me){e=Me}function lt(Me){n=Me}function St(Me){G=Me}function fe(Me){q=Me}function vt(Me){M.assert(Me>=0),d=Me,E=Me,x=Me,D=0,w=void 0,R=0}function Ce(Me){F+=Me?1:-1}function nt(){return J}}function uI(e,t){return e.codePointAt(t)}function Mh(e){return e>=65536?2:e===-1?0:1}function l1t(e){if(M.assert(0<=e&&e<=1114111),e<=65535)return String.fromCharCode(e);let t=Math.floor((e-65536)/1024)+55296,n=(e-65536)%1024+56320;return String.fromCharCode(t,n)}var u1t=String.fromCodePoint?e=>String.fromCodePoint(e):l1t;function _I(e){return u1t(e)}var WOe=new Map(Object.entries({General_Category:"General_Category",gc:"General_Category",Script:"Script",sc:"Script",Script_Extensions:"Script_Extensions",scx:"Script_Extensions"})),$Oe=new Set(["ASCII","ASCII_Hex_Digit","AHex","Alphabetic","Alpha","Any","Assigned","Bidi_Control","Bidi_C","Bidi_Mirrored","Bidi_M","Case_Ignorable","CI","Cased","Changes_When_Casefolded","CWCF","Changes_When_Casemapped","CWCM","Changes_When_Lowercased","CWL","Changes_When_NFKC_Casefolded","CWKCF","Changes_When_Titlecased","CWT","Changes_When_Uppercased","CWU","Dash","Default_Ignorable_Code_Point","DI","Deprecated","Dep","Diacritic","Dia","Emoji","Emoji_Component","EComp","Emoji_Modifier","EMod","Emoji_Modifier_Base","EBase","Emoji_Presentation","EPres","Extended_Pictographic","ExtPict","Extender","Ext","Grapheme_Base","Gr_Base","Grapheme_Extend","Gr_Ext","Hex_Digit","Hex","IDS_Binary_Operator","IDSB","IDS_Trinary_Operator","IDST","ID_Continue","IDC","ID_Start","IDS","Ideographic","Ideo","Join_Control","Join_C","Logical_Order_Exception","LOE","Lowercase","Lower","Math","Noncharacter_Code_Point","NChar","Pattern_Syntax","Pat_Syn","Pattern_White_Space","Pat_WS","Quotation_Mark","QMark","Radical","Regional_Indicator","RI","Sentence_Terminal","STerm","Soft_Dotted","SD","Terminal_Punctuation","Term","Unified_Ideograph","UIdeo","Uppercase","Upper","Variation_Selector","VS","White_Space","space","XID_Continue","XIDC","XID_Start","XIDS"]),HOe=new Set(["Basic_Emoji","Emoji_Keycap_Sequence","RGI_Emoji_Modifier_Sequence","RGI_Emoji_Flag_Sequence","RGI_Emoji_Tag_Sequence","RGI_Emoji_ZWJ_Sequence","RGI_Emoji"]),A3={General_Category:new Set(["C","Other","Cc","Control","cntrl","Cf","Format","Cn","Unassigned","Co","Private_Use","Cs","Surrogate","L","Letter","LC","Cased_Letter","Ll","Lowercase_Letter","Lm","Modifier_Letter","Lo","Other_Letter","Lt","Titlecase_Letter","Lu","Uppercase_Letter","M","Mark","Combining_Mark","Mc","Spacing_Mark","Me","Enclosing_Mark","Mn","Nonspacing_Mark","N","Number","Nd","Decimal_Number","digit","Nl","Letter_Number","No","Other_Number","P","Punctuation","punct","Pc","Connector_Punctuation","Pd","Dash_Punctuation","Pe","Close_Punctuation","Pf","Final_Punctuation","Pi","Initial_Punctuation","Po","Other_Punctuation","Ps","Open_Punctuation","S","Symbol","Sc","Currency_Symbol","Sk","Modifier_Symbol","Sm","Math_Symbol","So","Other_Symbol","Z","Separator","Zl","Line_Separator","Zp","Paragraph_Separator","Zs","Space_Separator"]),Script:new Set(["Adlm","Adlam","Aghb","Caucasian_Albanian","Ahom","Arab","Arabic","Armi","Imperial_Aramaic","Armn","Armenian","Avst","Avestan","Bali","Balinese","Bamu","Bamum","Bass","Bassa_Vah","Batk","Batak","Beng","Bengali","Bhks","Bhaiksuki","Bopo","Bopomofo","Brah","Brahmi","Brai","Braille","Bugi","Buginese","Buhd","Buhid","Cakm","Chakma","Cans","Canadian_Aboriginal","Cari","Carian","Cham","Cher","Cherokee","Chrs","Chorasmian","Copt","Coptic","Qaac","Cpmn","Cypro_Minoan","Cprt","Cypriot","Cyrl","Cyrillic","Deva","Devanagari","Diak","Dives_Akuru","Dogr","Dogra","Dsrt","Deseret","Dupl","Duployan","Egyp","Egyptian_Hieroglyphs","Elba","Elbasan","Elym","Elymaic","Ethi","Ethiopic","Geor","Georgian","Glag","Glagolitic","Gong","Gunjala_Gondi","Gonm","Masaram_Gondi","Goth","Gothic","Gran","Grantha","Grek","Greek","Gujr","Gujarati","Guru","Gurmukhi","Hang","Hangul","Hani","Han","Hano","Hanunoo","Hatr","Hatran","Hebr","Hebrew","Hira","Hiragana","Hluw","Anatolian_Hieroglyphs","Hmng","Pahawh_Hmong","Hmnp","Nyiakeng_Puachue_Hmong","Hrkt","Katakana_Or_Hiragana","Hung","Old_Hungarian","Ital","Old_Italic","Java","Javanese","Kali","Kayah_Li","Kana","Katakana","Kawi","Khar","Kharoshthi","Khmr","Khmer","Khoj","Khojki","Kits","Khitan_Small_Script","Knda","Kannada","Kthi","Kaithi","Lana","Tai_Tham","Laoo","Lao","Latn","Latin","Lepc","Lepcha","Limb","Limbu","Lina","Linear_A","Linb","Linear_B","Lisu","Lyci","Lycian","Lydi","Lydian","Mahj","Mahajani","Maka","Makasar","Mand","Mandaic","Mani","Manichaean","Marc","Marchen","Medf","Medefaidrin","Mend","Mende_Kikakui","Merc","Meroitic_Cursive","Mero","Meroitic_Hieroglyphs","Mlym","Malayalam","Modi","Mong","Mongolian","Mroo","Mro","Mtei","Meetei_Mayek","Mult","Multani","Mymr","Myanmar","Nagm","Nag_Mundari","Nand","Nandinagari","Narb","Old_North_Arabian","Nbat","Nabataean","Newa","Nkoo","Nko","Nshu","Nushu","Ogam","Ogham","Olck","Ol_Chiki","Orkh","Old_Turkic","Orya","Oriya","Osge","Osage","Osma","Osmanya","Ougr","Old_Uyghur","Palm","Palmyrene","Pauc","Pau_Cin_Hau","Perm","Old_Permic","Phag","Phags_Pa","Phli","Inscriptional_Pahlavi","Phlp","Psalter_Pahlavi","Phnx","Phoenician","Plrd","Miao","Prti","Inscriptional_Parthian","Rjng","Rejang","Rohg","Hanifi_Rohingya","Runr","Runic","Samr","Samaritan","Sarb","Old_South_Arabian","Saur","Saurashtra","Sgnw","SignWriting","Shaw","Shavian","Shrd","Sharada","Sidd","Siddham","Sind","Khudawadi","Sinh","Sinhala","Sogd","Sogdian","Sogo","Old_Sogdian","Sora","Sora_Sompeng","Soyo","Soyombo","Sund","Sundanese","Sylo","Syloti_Nagri","Syrc","Syriac","Tagb","Tagbanwa","Takr","Takri","Tale","Tai_Le","Talu","New_Tai_Lue","Taml","Tamil","Tang","Tangut","Tavt","Tai_Viet","Telu","Telugu","Tfng","Tifinagh","Tglg","Tagalog","Thaa","Thaana","Thai","Tibt","Tibetan","Tirh","Tirhuta","Tnsa","Tangsa","Toto","Ugar","Ugaritic","Vaii","Vai","Vith","Vithkuqi","Wara","Warang_Citi","Wcho","Wancho","Xpeo","Old_Persian","Xsux","Cuneiform","Yezi","Yezidi","Yiii","Yi","Zanb","Zanabazar_Square","Zinh","Inherited","Qaai","Zyyy","Common","Zzzz","Unknown"]),Script_Extensions:void 0};A3.Script_Extensions=A3.Script;function vu(e){return qp(e)||ip(e)}function wP(e){return jC(e,rO,W9)}function k3(e){switch(Ka(e)){case 99:return"lib.esnext.full.d.ts";case 10:return"lib.es2023.full.d.ts";case 9:return"lib.es2022.full.d.ts";case 8:return"lib.es2021.full.d.ts";case 7:return"lib.es2020.full.d.ts";case 6:return"lib.es2019.full.d.ts";case 5:return"lib.es2018.full.d.ts";case 4:return"lib.es2017.full.d.ts";case 3:return"lib.es2016.full.d.ts";case 2:return"lib.es6.d.ts";default:return"lib.d.ts"}}function bl(e){return e.start+e.length}function kue(e){return e.length===0}function C$(e,t){return t>=e.start&&t<bl(e)}function P3(e,t){return t>=e.pos&&t<=e.end}function Pue(e,t){return t.start>=e.start&&bl(t)<=bl(e)}function GOe(e,t){return Nue(e,t)!==void 0}function Nue(e,t){let n=wue(e,t);return n&&n.length===0?void 0:n}function YOe(e,t){return N3(e.start,e.length,t.start,t.length)}function S5(e,t,n){return N3(e.start,e.length,t,n)}function N3(e,t,n,i){let s=e+t,o=n+i;return n<=s&&o>=e}function Due(e,t){return t<=bl(e)&&t>=e.start}function wue(e,t){let n=Math.max(e.start,t.start),i=Math.min(bl(e),bl(t));return n<=i?Il(n,i):void 0}function zu(e,t){if(e<0)throw new Error("start < 0");if(t<0)throw new Error("length < 0");return{start:e,length:t}}function Il(e,t){return zu(e,t-e)}function fI(e){return zu(e.span.start,e.newLength)}function Iue(e){return kue(e.span)&&e.newLength===0}function D3(e,t){if(t<0)throw new Error("newLength < 0");return{span:e,newLength:t}}var b5=D3(zu(0,0),0);function Oue(e){if(e.length===0)return b5;if(e.length===1)return e[0];let t=e[0],n=t.span.start,i=bl(t.span),s=n+t.newLength;for(let o=1;o<e.length;o++){let u=e[o],m=n,d=i,S=s,E=u.span.start,x=bl(u.span),D=E+u.newLength;n=Math.min(m,E),i=Math.max(d,d+(x-S)),s=Math.max(D,D+(S-x))}return D3(Il(n,i),s-n)}function KOe(e){if(e&&e.kind===168){for(let t=e;t;t=t.parent)if(Bs(t)||gi(t)||t.kind===264)return t}}function ap(e,t){return ns(e)&&li(e,31)&&t.kind===176}function Rue(e){return Hs(e)?wi(e.elements,Mue):!1}function Mue(e){return pu(e)?!0:Rue(e.name)}function IP(e){let t=e.parent;for(;Xa(t.parent);)t=t.parent.parent;return t.parent}function Lue(e,t){Xa(e)&&(e=IP(e));let n=t(e);return e.kind===260&&(e=e.parent),e&&e.kind===261&&(n|=t(e),e=e.parent),e&&e.kind===243&&(n|=t(e)),n}function eb(e){return Lue(e,U_)}function A$(e){return Lue(e,Ufe)}function f0(e){return Lue(e,_1t)}function _1t(e){return e.flags}var Fue=["cs","de","es","fr","it","ja","ko","pl","pt-br","ru","tr","zh-cn","zh-tw"];function k$(e,t,n){let i=e.toLowerCase(),s=/^([a-z]+)([_-]([a-z]+))?$/.exec(i);if(!s){n&&n.push(Nc(v.Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1,"en","ja-jp"));return}let o=s[1],u=s[3];Es(Fue,i)&&!m(o,u,n)&&m(o,void 0,n),Gce(e);function m(d,S,E){let x=Zs(t.getExecutingFilePath()),D=mi(x),w=ri(D,d);if(S&&(w=w+"-"+S),w=t.resolvePath(ri(w,"diagnosticMessages.generated.json")),!t.fileExists(w))return!1;let R="";try{R=t.readFile(w)}catch{return E&&E.push(Nc(v.Unable_to_open_file_0,w)),!1}try{spe(JSON.parse(R))}catch{return E&&E.push(Nc(v.Corrupted_locale_file_0,w)),!1}return!0}}function Bc(e,t){if(e)for(;e.original!==void 0;)e=e.original;return!e||!t||t(e)?e:void 0}function Pr(e,t){for(;e;){let n=t(e);if(n==="quit")return;if(n)return e;e=e.parent}}function pI(e){return(e.flags&16)===0}function ks(e,t){if(e===void 0||pI(e))return e;for(e=e.original;e;){if(pI(e))return!t||t(e)?e:void 0;e=e.original}}function Uc(e){return e.length>=2&&e.charCodeAt(0)===95&&e.charCodeAt(1)===95?"_"+e:e}function Qi(e){let t=e;return t.length>=3&&t.charCodeAt(0)===95&&t.charCodeAt(1)===95&&t.charCodeAt(2)===95?t.substr(1):t}function Nn(e){return Qi(e.escapedText)}function Jx(e){let t=JT(e.escapedText);return t?ai(t,sf):void 0}function Qc(e){return e.valueDeclaration&&j_(e.valueDeclaration)?Nn(e.valueDeclaration.name):Qi(e.escapedName)}function XOe(e){let t=e.parent.parent;if(t){if(u_(t))return P$(t);switch(t.kind){case 243:if(t.declarationList&&t.declarationList.declarations[0])return P$(t.declarationList.declarations[0]);break;case 244:let n=t.expression;switch(n.kind===226&&n.operatorToken.kind===64&&(n=n.left),n.kind){case 211:return n.name;case 212:let i=n.argumentExpression;if(He(i))return i}break;case 217:return P$(t.expression);case 256:{if(u_(t.statement)||Ct(t.statement))return P$(t.statement);break}}}}function P$(e){let t=Ps(e);return t&&He(t)?t:void 0}function w3(e,t){return!!(Wu(e)&&He(e.name)&&Nn(e.name)===Nn(t)||_l(e)&&Pt(e.declarationList.declarations,n=>w3(n,t)))}function jue(e){return e.name||XOe(e)}function Wu(e){return!!e.name}function T5(e){switch(e.kind){case 80:return e;case 348:case 341:{let{name:n}=e;if(n.kind===166)return n.right;break}case 213:case 226:{let n=e;switch(cl(n)){case 1:case 4:case 5:case 3:return h9(n.left);case 7:case 8:case 9:return n.arguments[1];default:return}}case 346:return jue(e);case 340:return XOe(e);case 277:{let{expression:n}=e;return He(n)?n:void 0}case 212:let t=e;if(g9(t))return t.argumentExpression}return e.name}function Ps(e){if(e!==void 0)return T5(e)||(ic(e)||pc(e)||eu(e)?E5(e):void 0)}function E5(e){if(e.parent){if(ql(e.parent)||Xa(e.parent))return e.parent.name;if(Pn(e.parent)&&e===e.parent.right){if(He(e.parent.left))return e.parent.left;if(oc(e.parent.left))return h9(e.parent.left)}else if(Ei(e.parent)&&He(e.parent.name))return e.parent.name}else return}function F1(e){if(Wp(e))return Zn(e.modifiers,fu)}function qT(e){if(li(e,98303))return Zn(e.modifiers,Pa)}function QOe(e,t){if(e.name)if(He(e.name)){let n=e.name.escapedText;return O3(e.parent,t).filter(i=>Pd(i)&&He(i.name)&&i.name.escapedText===n)}else{let n=e.parent.parameters.indexOf(e);M.assert(n>-1,"Parameters should always be in their parents' parameter list");let i=O3(e.parent,t).filter(Pd);if(n<i.length)return[i[n]]}return ve}function OP(e){return QOe(e,!1)}function Bue(e){return QOe(e,!0)}function ZOe(e,t){let n=e.name.escapedText;return O3(e.parent,t).filter(i=>sm(i)&&i.typeParameters.some(s=>s.name.escapedText===n))}function Uue(e){return ZOe(e,!1)}function Vue(e){return ZOe(e,!0)}function Jue(e){return!!Gd(e,Pd)}function que(e){return Gd(e,zA)}function zue(e){return C5(e,Jj)}function N$(e){return Gd(e,tme)}function e6e(e){return Gd(e,oY)}function Wue(e){return Gd(e,oY,!0)}function t6e(e){return Gd(e,cY)}function $ue(e){return Gd(e,cY,!0)}function r6e(e){return Gd(e,lY)}function Hue(e){return Gd(e,lY,!0)}function n6e(e){return Gd(e,uY)}function Gue(e){return Gd(e,uY,!0)}function Yue(e){return Gd(e,Uj,!0)}function D$(e){return Gd(e,_Y)}function Kue(e){return Gd(e,_Y,!0)}function w$(e){return Gd(e,d8)}function x5(e){return Gd(e,fY)}function Xue(e){return Gd(e,Vj)}function i6e(e){return Gd(e,sm)}function I$(e){return Gd(e,qj)}function tb(e){let t=Gd(e,RO);if(t&&t.typeExpression&&t.typeExpression.type)return t}function rb(e){let t=Gd(e,RO);return!t&&ns(e)&&(t=Ln(OP(e),n=>!!n.typeExpression)),t&&t.typeExpression&&t.typeExpression.type}function I3(e){let t=Xue(e);if(t&&t.typeExpression)return t.typeExpression.type;let n=tb(e);if(n&&n.typeExpression){let i=n.typeExpression.type;if(lf(i)){let s=Ln(i.members,MA);return s&&s.type}if(Jh(i)||TN(i))return i.type}}function O3(e,t){var n;if(!xR(e))return ve;let i=(n=e.jsDoc)==null?void 0:n.jsDocCache;if(i===void 0||t){let s=CH(e,t);M.assert(s.length<2||s[0]!==s[1]),i=va(s,o=>ag(o)?o.tags:o),t||(e.jsDoc??(e.jsDoc=[]),e.jsDoc.jsDocCache=i)}return i}function nb(e){return O3(e,!1)}function s6e(e){return O3(e,!0)}function Gd(e,t,n){return Ln(O3(e,n),t)}function C5(e,t){return nb(e).filter(t)}function a6e(e,t){return nb(e).filter(n=>n.kind===t)}function R3(e){return typeof e=="string"?e:e?.map(t=>t.kind===321?t.text:f1t(t)).join("")}function f1t(e){let t=e.kind===324?"link":e.kind===325?"linkcode":"linkplain",n=e.name?op(e.name):"",i=e.name&&(e.text===""||e.text.startsWith("://"))?"":" ";return`{@${t} ${n}${i}${e.text}}`}function j1(e){if(A0(e)){if(EN(e.parent)){let t=QP(e.parent);if(t&&wt(t.tags))return va(t.tags,n=>sm(n)?n.typeParameters:void 0)}return ve}if(Xd(e))return M.assert(e.parent.kind===320),va(e.parent.tags,t=>sm(t)?t.typeParameters:void 0);if(e.typeParameters||dme(e)&&e.typeParameters)return e.typeParameters;if(hn(e)){let t=w9(e);if(t.length)return t;let n=rb(e);if(n&&Jh(n)&&n.typeParameters)return n.typeParameters}return ve}function RP(e){return e.constraint?e.constraint:sm(e.parent)&&e===e.parent.typeParameters[0]?e.parent.constraint:void 0}function Cy(e){return e.kind===80||e.kind===81}function M3(e){return e.kind===178||e.kind===177}function A5(e){return Wn(e)&&!!(e.flags&64)}function O$(e){return cc(e)&&!!(e.flags&64)}function qx(e){return ea(e)&&!!(e.flags&64)}function S_(e){let t=e.kind;return!!(e.flags&64)&&(t===211||t===212||t===213||t===235)}function dI(e){return S_(e)&&!VA(e)&&!!e.questionDotToken}function k5(e){return dI(e.parent)&&e.parent.expression===e}function mI(e){return!S_(e.parent)||dI(e.parent)||e!==e.parent.expression}function R$(e){return e.kind===226&&e.operatorToken.kind===61}function Qm(e){return Gp(e)&&He(e.typeName)&&e.typeName.escapedText==="const"&&!e.typeArguments}function km(e){return Ml(e,8)}function P5(e){return VA(e)&&!!(e.flags&64)}function gI(e){return e.kind===252||e.kind===251}function M$(e){return e.kind===280||e.kind===279}function hI(e){return e.kind===348||e.kind===341}function o6e(e){return L3(e.kind)}function L3(e){return e>=166}function L$(e){return e>=0&&e<=165}function HC(e){return L$(e.kind)}function zT(e){return Ho(e,"pos")&&Ho(e,"end")}function yI(e){return 9<=e&&e<=15}function WT(e){return yI(e.kind)}function F$(e){switch(e.kind){case 210:case 209:case 14:case 218:case 231:return!0}return!1}function B1(e){return 15<=e&&e<=18}function Que(e){return B1(e.kind)}function N5(e){let t=e.kind;return t===17||t===18}function GC(e){return _f(e)||b_(e)}function vI(e){switch(e.kind){case 276:return e.isTypeOnly||e.parent.parent.isTypeOnly;case 274:return e.parent.isTypeOnly;case 273:case 271:return e.isTypeOnly}return!1}function Zue(e){switch(e.kind){case 281:return e.isTypeOnly||e.parent.parent.isTypeOnly;case 278:return e.isTypeOnly&&!!e.moduleSpecifier&&!e.exportClause;case 280:return e.parent.isTypeOnly}return!1}function ib(e){return vI(e)||Zue(e)}function j$(e){return e.kind===11||B1(e.kind)}function e_e(e){return La(e)||He(e)}function xc(e){var t;return He(e)&&((t=e.emitNode)==null?void 0:t.autoGenerate)!==void 0}function zx(e){var t;return Zi(e)&&((t=e.emitNode)==null?void 0:t.autoGenerate)!==void 0}function F3(e){let t=e.emitNode.autoGenerate.flags;return!!(t&32)&&!!(t&16)&&!!(t&8)}function j_(e){return(Ns(e)||KC(e))&&Zi(e.name)}function MP(e){return Wn(e)&&Zi(e.name)}function vv(e){switch(e){case 128:case 129:case 134:case 87:case 138:case 90:case 95:case 103:case 125:case 123:case 124:case 148:case 126:case 147:case 164:return!0}return!1}function SI(e){return!!(pA(e)&31)}function B$(e){return SI(e)||e===126||e===164||e===129}function Pa(e){return vv(e.kind)}function Tf(e){let t=e.kind;return t===166||t===80}function Ol(e){let t=e.kind;return t===80||t===81||t===11||t===9||t===167}function Wx(e){let t=e.kind;return t===80||t===206||t===207}function Bs(e){return!!e&&YC(e.kind)}function LP(e){return!!e&&(YC(e.kind)||Gc(e))}function Go(e){return e&&c6e(e.kind)}function bI(e){return e.kind===112||e.kind===97}function c6e(e){switch(e){case 262:case 174:case 176:case 177:case 178:case 218:case 219:return!0;default:return!1}}function YC(e){switch(e){case 173:case 179:case 323:case 180:case 181:case 184:case 317:case 185:return!0;default:return c6e(e)}}function U$(e){return Ji(e)||Hg(e)||Vs(e)&&Bs(e.parent)}function uu(e){let t=e.kind;return t===176||t===172||t===174||t===177||t===178||t===181||t===175||t===240}function gi(e){return e&&(e.kind===263||e.kind===231)}function U1(e){return e&&(e.kind===177||e.kind===178)}function Ef(e){return Ns(e)&&Ug(e)}function t_e(e){return hn(e)&&CA(e)?(!eE(e)||!$1(e.expression))&&!Zx(e,!0):e.parent&&gi(e.parent)&&Ns(e)&&!Ug(e)}function KC(e){switch(e.kind){case 174:case 177:case 178:return!0;default:return!1}}function l6e(e){switch(e.kind){case 174:case 177:case 178:case 172:return!0;default:return!1}}function Cc(e){return Pa(e)||fu(e)}function $T(e){let t=e.kind;return t===180||t===179||t===171||t===173||t===181||t===177||t===178}function D5(e){return $T(e)||uu(e)}function p0(e){let t=e.kind;return t===303||t===304||t===305||t===174||t===177||t===178}function Di(e){return uG(e.kind)}function r_e(e){switch(e.kind){case 184:case 185:return!0}return!1}function Hs(e){if(e){let t=e.kind;return t===207||t===206}return!1}function TI(e){let t=e.kind;return t===209||t===210}function w5(e){let t=e.kind;return t===208||t===232}function j3(e){switch(e.kind){case 260:case 169:case 208:return!0}return!1}function n_e(e){return Ei(e)||ns(e)||U3(e)||V3(e)}function B3(e){return V$(e)||J$(e)}function V$(e){switch(e.kind){case 206:case 210:return!0}return!1}function U3(e){switch(e.kind){case 208:case 303:case 304:case 305:return!0}return!1}function J$(e){switch(e.kind){case 207:case 209:return!0}return!1}function V3(e){switch(e.kind){case 208:case 232:case 230:case 209:case 210:case 80:case 211:case 212:return!0}return Su(e,!0)}function i_e(e){let t=e.kind;return t===211||t===166||t===205}function J3(e){let t=e.kind;return t===211||t===166}function q$(e){return HT(e)||K1(e)}function HT(e){switch(e.kind){case 286:case 285:case 213:case 214:case 215:case 170:return!0;default:return!1}}function Ig(e){return e.kind===213||e.kind===214}function XC(e){let t=e.kind;return t===228||t===15}function xf(e){return u6e(km(e).kind)}function u6e(e){switch(e){case 211:case 212:case 214:case 213:case 284:case 285:case 288:case 215:case 209:case 217:case 210:case 231:case 218:case 80:case 81:case 14:case 9:case 10:case 11:case 15:case 228:case 97:case 106:case 110:case 112:case 108:case 235:case 233:case 236:case 102:case 282:return!0;default:return!1}}function z$(e){return _6e(km(e).kind)}function _6e(e){switch(e){case 224:case 225:case 220:case 221:case 222:case 223:case 216:return!0;default:return u6e(e)}}function s_e(e){switch(e.kind){case 225:return!0;case 224:return e.operator===46||e.operator===47;default:return!1}}function a_e(e){switch(e.kind){case 106:case 112:case 97:case 224:return!0;default:return WT(e)}}function Ct(e){return p1t(km(e).kind)}function p1t(e){switch(e){case 227:case 229:case 219:case 226:case 230:case 234:case 232:case 355:case 354:case 238:return!0;default:return _6e(e)}}function sb(e){let t=e.kind;return t===216||t===234}function f6e(e){return iY(e)||Lj(e)}function V1(e,t){switch(e.kind){case 248:case 249:case 250:case 246:case 247:return!0;case 256:return t&&V1(e.statement,t)}return!1}function o_e(e){return dc(e)||xl(e)}function c_e(e){return Pt(e,o_e)}function I5(e){return!X3(e)&&!dc(e)&&!li(e,32)&&!B_(e)}function q3(e){return X3(e)||dc(e)||li(e,32)}function $x(e){return e.kind===249||e.kind===250}function O5(e){return Vs(e)||Ct(e)}function W$(e){return Vs(e)}function Sd(e){return Ru(e)||Ct(e)}function l_e(e){let t=e.kind;return t===268||t===267||t===80}function p6e(e){let t=e.kind;return t===268||t===267}function d6e(e){let t=e.kind;return t===80||t===267}function $$(e){let t=e.kind;return t===275||t===274}function z3(e){return e.kind===267||e.kind===266}function Zm(e){switch(e.kind){case 219:case 226:case 208:case 213:case 179:case 263:case 231:case 175:case 176:case 185:case 180:case 212:case 266:case 306:case 277:case 278:case 281:case 262:case 218:case 184:case 177:case 80:case 273:case 271:case 276:case 181:case 264:case 338:case 340:case 317:case 341:case 348:case 323:case 346:case 322:case 291:case 292:case 293:case 200:case 174:case 173:case 267:case 202:case 280:case 270:case 274:case 214:case 15:case 9:case 210:case 169:case 211:case 303:case 172:case 171:case 178:case 304:case 307:case 305:case 11:case 265:case 187:case 168:case 260:return!0;default:return!1}}function Lh(e){switch(e.kind){case 219:case 241:case 179:case 269:case 299:case 175:case 194:case 176:case 185:case 180:case 248:case 249:case 250:case 262:case 218:case 184:case 177:case 181:case 338:case 340:case 317:case 323:case 346:case 200:case 174:case 173:case 267:case 178:case 307:case 265:return!0;default:return!1}}function d1t(e){return e===219||e===208||e===263||e===231||e===175||e===176||e===266||e===306||e===281||e===262||e===218||e===177||e===273||e===271||e===276||e===264||e===291||e===174||e===173||e===267||e===270||e===274||e===280||e===169||e===303||e===172||e===171||e===178||e===304||e===265||e===168||e===260||e===346||e===338||e===348||e===202}function u_e(e){return e===262||e===282||e===263||e===264||e===265||e===266||e===267||e===272||e===271||e===278||e===277||e===270}function __e(e){return e===252||e===251||e===259||e===246||e===244||e===242||e===249||e===250||e===248||e===245||e===256||e===253||e===255||e===257||e===258||e===243||e===247||e===254||e===353}function u_(e){return e.kind===168?e.parent&&e.parent.kind!==345||hn(e):d1t(e.kind)}function f_e(e){return u_e(e.kind)}function W3(e){return __e(e.kind)}function Vi(e){let t=e.kind;return __e(t)||u_e(t)||m1t(e)}function m1t(e){return e.kind!==241||e.parent!==void 0&&(e.parent.kind===258||e.parent.kind===299)?!1:!XT(e)}function p_e(e){let t=e.kind;return __e(t)||u_e(t)||t===241}function d_e(e){let t=e.kind;return t===283||t===166||t===80}function EI(e){let t=e.kind;return t===110||t===80||t===211||t===295}function $3(e){let t=e.kind;return t===284||t===294||t===285||t===12||t===288}function R5(e){let t=e.kind;return t===291||t===293}function m_e(e){let t=e.kind;return t===11||t===294}function __(e){let t=e.kind;return t===286||t===285}function M5(e){let t=e.kind;return t===296||t===297}function FP(e){return e.kind>=309&&e.kind<=351}function L5(e){return e.kind===320||e.kind===319||e.kind===321||QC(e)||jP(e)||f2(e)||A0(e)}function jP(e){return e.kind>=327&&e.kind<=351}function Og(e){return e.kind===178}function Sv(e){return e.kind===177}function Pp(e){if(!xR(e))return!1;let{jsDoc:t}=e;return!!t&&t.length>0}function F5(e){return!!e.type}function bv(e){return!!e.initializer}function Hx(e){switch(e.kind){case 260:case 169:case 208:case 172:case 303:case 306:return!0;default:return!1}}function H$(e){return e.kind===291||e.kind===293||p0(e)}function j5(e){return e.kind===183||e.kind===233}var m6e=1073741823;function g_e(e){let t=m6e;for(let n of e){if(!n.length)continue;let i=0;for(;i<n.length&&i<t&&by(n.charCodeAt(i));i++);if(i<t&&(t=i),t===0)return 0}return t===m6e?void 0:t}function No(e){return e.kind===11||e.kind===15}function QC(e){return e.kind===324||e.kind===325||e.kind===326}function G$(e){let t=vc(e.parameters);return!!t&&Fh(t)}function Fh(e){let t=Pd(e)?e.typeExpression&&e.typeExpression.type:e.type;return e.dotDotDotToken!==void 0||!!t&&t.kind===318}function g6e(e,t){return t.text.substring(e.pos,e.end).includes("@internal")}function h_e(e,t){t??(t=Ur(e));let n=ks(e);if(n&&n.kind===169){let s=n.parent.parameters.indexOf(n),o=s>0?n.parent.parameters[s-1]:void 0,u=t.text,m=o?ps(L1(u,Ja(u,o.end+1,!1,!0)),Ty(u,e.pos)):L1(u,Ja(u,e.pos,!1,!0));return Pt(m)&&g6e(Va(m),t)}let i=n&&dH(n,t);return!!kt(i,s=>g6e(s,t))}var Y$=[],ab="tslib",xI=160,K$=1e6;function Pc(e,t){let n=e.declarations;if(n){for(let i of n)if(i.kind===t)return i}}function y_e(e,t){return Zn(e.declarations||ve,n=>n.kind===t)}function fa(e){let t=new Map;if(e)for(let n of e)t.set(n.escapedName,n);return t}function jh(e){return(e.flags&33554432)!==0}function BP(e){return!!(e.flags&1536)&&e.escapedName.charCodeAt(0)===34}var B5=g1t();function g1t(){var e="";let t=n=>e+=n;return{getText:()=>e,write:t,rawWrite:t,writeKeyword:t,writeOperator:t,writePunctuation:t,writeSpace:t,writeStringLiteral:t,writeLiteral:t,writeParameter:t,writeProperty:t,writeSymbol:(n,i)=>t(n),writeTrailingSemicolon:t,writeComment:t,getTextPos:()=>e.length,getLine:()=>0,getColumn:()=>0,getIndent:()=>0,isAtStartOfLine:()=>!1,hasTrailingComment:()=>!1,hasTrailingWhitespace:()=>!!e.length&&by(e.charCodeAt(e.length-1)),writeLine:()=>e+=" ",increaseIndent:io,decreaseIndent:io,clear:()=>e=""}}function U5(e,t){return e.configFilePath!==t.configFilePath||v_e(e,t)}function v_e(e,t){return UP(e,t,MY)}function S_e(e,t){return UP(e,t,Lme)}function UP(e,t,n){return e!==t&&n.some(i=>!uj(K9(e,i),K9(t,i)))}function b_e(e,t){for(;;){let n=t(e);if(n==="quit")return;if(n!==void 0)return n;if(Ji(e))return;e=e.parent}}function Nu(e,t){let n=e.entries();for(let[i,s]of n){let o=t(s,i);if(o)return o}}function d0(e,t){let n=e.keys();for(let i of n){let s=t(i);if(s)return s}}function V5(e,t){e.forEach((n,i)=>{t.set(i,n)})}function CI(e){let t=B5.getText();try{return e(B5),B5.getText()}finally{B5.clear(),B5.writeKeyword(t)}}function H3(e){return e.end-e.pos}function X$(e,t){return e.path===t.path&&!e.prepend==!t.prepend&&!e.circular==!t.circular}function T_e(e,t){return e===t||e.resolvedModule===t.resolvedModule||!!e.resolvedModule&&!!t.resolvedModule&&e.resolvedModule.isExternalLibraryImport===t.resolvedModule.isExternalLibraryImport&&e.resolvedModule.extension===t.resolvedModule.extension&&e.resolvedModule.resolvedFileName===t.resolvedModule.resolvedFileName&&e.resolvedModule.originalPath===t.resolvedModule.originalPath&&h1t(e.resolvedModule.packageId,t.resolvedModule.packageId)&&e.alternateResult===t.alternateResult}function J5(e,t,n,i,s){var o;let u=(o=t.getResolvedModule(e,n,i))==null?void 0:o.alternateResult,m=u&&(af(t.getCompilerOptions())===2?[v.There_are_types_at_0_but_this_result_could_not_be_resolved_under_your_current_moduleResolution_setting_Consider_updating_to_node16_nodenext_or_bundler,[u]]:[v.There_are_types_at_0_but_this_result_could_not_be_resolved_when_respecting_package_json_exports_The_1_library_may_need_to_update_its_package_json_or_typings,[u,u.includes(jy+"@types/")?`@types/${RN(s)}`:s]]),d=m?js(void 0,m[0],...m[1]):t.typesPackageExists(s)?js(void 0,v.If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1,s,RN(s)):t.packageBundlesTypes(s)?js(void 0,v.If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_declare_module_1,s,n):js(void 0,v.Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0,n,RN(s));return d&&(d.repopulateInfo=()=>({moduleReference:n,mode:i,packageName:s===n?void 0:s})),d}function h1t(e,t){return e===t||!!e&&!!t&&e.name===t.name&&e.subModuleName===t.subModuleName&&e.version===t.version&&e.peerDependencies===t.peerDependencies}function q5({name:e,subModuleName:t}){return t?`${e}/${t}`:e}function J1(e){return`${q5(e)}@${e.version}${e.peerDependencies??""}`}function E_e(e,t){return e===t||e.resolvedTypeReferenceDirective===t.resolvedTypeReferenceDirective||!!e.resolvedTypeReferenceDirective&&!!t.resolvedTypeReferenceDirective&&e.resolvedTypeReferenceDirective.resolvedFileName===t.resolvedTypeReferenceDirective.resolvedFileName&&!!e.resolvedTypeReferenceDirective.primary==!!t.resolvedTypeReferenceDirective.primary&&e.resolvedTypeReferenceDirective.originalPath===t.resolvedTypeReferenceDirective.originalPath}function Q$(e,t,n,i){M.assert(e.length===t.length);for(let s=0;s<e.length;s++){let o=t[s],u=e[s],m=n(u);if(m?!o||!i(m,o):o)return!0}return!1}function VP(e){return y1t(e),(e.flags&1048576)!==0}function y1t(e){e.flags&2097152||((e.flags&262144||Js(e,VP))&&(e.flags|=1048576),e.flags|=2097152)}function Ur(e){for(;e&&e.kind!==307;)e=e.parent;return e}function z5(e){return Ur(e.valueDeclaration||oH(e))}function AI(e,t){return!!e&&(e.scriptKind===1||e.scriptKind===2)&&!e.checkJsDirective&&t===void 0}function x_e(e){switch(e.kind){case 241:case 269:case 248:case 249:case 250:return!0}return!1}function q1(e,t){return M.assert(e>=0),Sy(t)[e]}function h6e(e){let t=Ur(e),n=ba(t,e.pos);return`${t.fileName}(${n.line+1},${n.character+1})`}function G3(e,t){M.assert(e>=0);let n=Sy(t),i=e,s=t.text;if(i+1===n.length)return s.length-1;{let o=n[i],u=n[i+1]-1;for(M.assert(v_(s.charCodeAt(u)));o<=u&&v_(s.charCodeAt(u));)u--;return u}}function W5(e,t,n){return!(n&&n(t))&&!e.identifiers.has(t)}function $c(e){return e===void 0?!0:e.pos===e.end&&e.pos>=0&&e.kind!==1}function Yd(e){return!$c(e)}function C_e(e,t){return Ac(e)?t===e.expression:Gc(e)?t===e.modifiers:Nf(e)?t===e.initializer:Ns(e)?t===e.questionToken&&Ef(e):ql(e)?t===e.modifiers||t===e.questionToken||t===e.exclamationToken||Y3(e.modifiers,t,Cc):p_(e)?t===e.equalsToken||t===e.modifiers||t===e.questionToken||t===e.exclamationToken||Y3(e.modifiers,t,Cc):ul(e)?t===e.exclamationToken:Vc(e)?t===e.typeParameters||t===e.type||Y3(e.typeParameters,t,Ac):Hp(e)?t===e.typeParameters||Y3(e.typeParameters,t,Ac):fp(e)?t===e.typeParameters||t===e.type||Y3(e.typeParameters,t,Ac):p8(e)?t===e.modifiers||Y3(e.modifiers,t,Cc):!1}function Y3(e,t,n){return!e||Rs(t)||!n(t)?!1:Es(e,t)}function y6e(e,t,n){if(t===void 0||t.length===0)return e;let i=0;for(;i<e.length&&n(e[i]);++i);return e.splice(i,0,...t),e}function v6e(e,t,n){if(t===void 0)return e;let i=0;for(;i<e.length&&n(e[i]);++i);return e.splice(i,0,t),e}function S6e(e){return Mg(e)||!!(Ga(e)&2097152)}function Ay(e,t){return y6e(e,t,Mg)}function Z$(e,t){return y6e(e,t,S6e)}function b6e(e,t){return v6e(e,t,Mg)}function Gx(e,t){return v6e(e,t,S6e)}function eH(e,t,n){if(e.charCodeAt(t+1)===47&&t+2<n&&e.charCodeAt(t+2)===47){let i=e.substring(t,n);return!!(z_e.test(i)||W_e.test(i)||P1t.test(i)||A1t.test(i)||k1t.test(i)||N1t.test(i))}return!1}function $5(e,t){return e.charCodeAt(t+1)===42&&e.charCodeAt(t+2)===33}function A_e(e,t){let n=new Map(t.map(u=>[`${ba(e,u.range.end).line}`,u])),i=new Map;return{getUnusedExpectations:s,markUsed:o};function s(){return Is(n.entries()).filter(([u,m])=>m.type===0&&!i.get(u)).map(([u,m])=>m)}function o(u){return n.has(`${u}`)?(i.set(`${u}`,!0),!0):!1}}function ob(e,t,n){if($c(e))return e.pos;if(FP(e)||e.kind===12)return Ja((t??Ur(e)).text,e.pos,!1,!0);if(n&&Pp(e))return ob(e.jsDoc[0],t);if(e.kind===352){t??(t=Ur(e));let i=xo(pY(e,t));if(i)return ob(i,t,n)}return Ja((t??Ur(e)).text,e.pos,!1,!1,uR(e))}function tH(e,t){let n=!$c(e)&&wm(e)?xm(e.modifiers,fu):void 0;return n?Ja((t||Ur(e)).text,n.end):ob(e,t)}function GT(e,t,n=!1){return kI(e.text,t,n)}function v1t(e){return!!Pr(e,Tb)}function H5(e){return!!(xl(e)&&e.exportClause&&zh(e.exportClause)&&e.exportClause.name.escapedText==="default")}function kI(e,t,n=!1){if($c(t))return"";let i=e.substring(n?t.pos:Ja(e,t.pos),t.end);return v1t(t)&&(i=i.split(/\r\n|\n|\r/).map(s=>s.replace(/^\s*\*/,"").trimStart()).join(`
`)),i}function Hc(e,t=!1){return GT(Ur(e),e,t)}function S1t(e){return e.pos}function JP(e,t){return mv(e,t,S1t,tc)}function Ga(e){let t=e.emitNode;return t&&t.flags||0}function Pm(e){let t=e.emitNode;return t&&t.internalFlags||0}var rH=tf(()=>new Map(Object.entries({Array:new Map(Object.entries({es2015:["find","findIndex","fill","copyWithin","entries","keys","values"],es2016:["includes"],es2019:["flat","flatMap"],es2022:["at"],es2023:["findLastIndex","findLast"]})),Iterator:new Map(Object.entries({es2015:ve})),AsyncIterator:new Map(Object.entries({es2015:ve})),Atomics:new Map(Object.entries({es2017:ve})),SharedArrayBuffer:new Map(Object.entries({es2017:ve})),AsyncIterable:new Map(Object.entries({es2018:ve})),AsyncIterableIterator:new Map(Object.entries({es2018:ve})),AsyncGenerator:new Map(Object.entries({es2018:ve})),AsyncGeneratorFunction:new Map(Object.entries({es2018:ve})),RegExp:new Map(Object.entries({es2015:["flags","sticky","unicode"],es2018:["dotAll"]})),Reflect:new Map(Object.entries({es2015:["apply","construct","defineProperty","deleteProperty","get","getOwnPropertyDescriptor","getPrototypeOf","has","isExtensible","ownKeys","preventExtensions","set","setPrototypeOf"]})),ArrayConstructor:new Map(Object.entries({es2015:["from","of"],esnext:["fromAsync"]})),ObjectConstructor:new Map(Object.entries({es2015:["assign","getOwnPropertySymbols","keys","is","setPrototypeOf"],es2017:["values","entries","getOwnPropertyDescriptors"],es2019:["fromEntries"],es2022:["hasOwn"]})),NumberConstructor:new Map(Object.entries({es2015:["isFinite","isInteger","isNaN","isSafeInteger","parseFloat","parseInt"]})),Math:new Map(Object.entries({es2015:["clz32","imul","sign","log10","log2","log1p","expm1","cosh","sinh","tanh","acosh","asinh","atanh","hypot","trunc","fround","cbrt"]})),Map:new Map(Object.entries({es2015:["entries","keys","values"]})),Set:new Map(Object.entries({es2015:["entries","keys","values"]})),PromiseConstructor:new Map(Object.entries({es2015:["all","race","reject","resolve"],es2020:["allSettled"],es2021:["any"]})),Symbol:new Map(Object.entries({es2015:["for","keyFor"],es2019:["description"]})),WeakMap:new Map(Object.entries({es2015:["entries","keys","values"]})),WeakSet:new Map(Object.entries({es2015:["entries","keys","values"]})),String:new Map(Object.entries({es2015:["codePointAt","includes","endsWith","normalize","repeat","startsWith","anchor","big","blink","bold","fixed","fontcolor","fontsize","italics","link","small","strike","sub","sup"],es2017:["padStart","padEnd"],es2019:["trimStart","trimEnd","trimLeft","trimRight"],es2020:["matchAll"],es2021:["replaceAll"],es2022:["at"],esnext:["isWellFormed","toWellFormed"]})),StringConstructor:new Map(Object.entries({es2015:["fromCodePoint","raw"]})),DateTimeFormat:new Map(Object.entries({es2017:["formatToParts"]})),Promise:new Map(Object.entries({es2015:ve,es2018:["finally"]})),RegExpMatchArray:new Map(Object.entries({es2018:["groups"]})),RegExpExecArray:new Map(Object.entries({es2018:["groups"]})),Intl:new Map(Object.entries({es2018:["PluralRules"]})),NumberFormat:new Map(Object.entries({es2018:["formatToParts"]})),SymbolConstructor:new Map(Object.entries({es2020:["matchAll"]})),DataView:new Map(Object.entries({es2020:["setBigInt64","setBigUint64","getBigInt64","getBigUint64"]})),BigInt:new Map(Object.entries({es2020:ve})),RelativeTimeFormat:new Map(Object.entries({es2020:["format","formatToParts","resolvedOptions"]})),Int8Array:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),Uint8Array:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),Uint8ClampedArray:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),Int16Array:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),Uint16Array:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),Int32Array:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),Uint32Array:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),Float32Array:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),Float64Array:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),BigInt64Array:new Map(Object.entries({es2020:ve,es2022:["at"],es2023:["findLastIndex","findLast"]})),BigUint64Array:new Map(Object.entries({es2020:ve,es2022:["at"],es2023:["findLastIndex","findLast"]})),Error:new Map(Object.entries({es2022:["cause"]}))}))),k_e=(e=>(e[e.None=0]="None",e[e.NeverAsciiEscape=1]="NeverAsciiEscape",e[e.JsxAttributeEscape=2]="JsxAttributeEscape",e[e.TerminateUnterminatedLiterals=4]="TerminateUnterminatedLiterals",e[e.AllowNumericSeparator=8]="AllowNumericSeparator",e))(k_e||{});function P_e(e,t,n){if(t&&b1t(e,n))return GT(t,e);switch(e.kind){case 11:{let i=n&2?qH:n&1||Ga(e)&16777216?Vh:E9;return e.singleQuote?"'"+i(e.text,39)+"'":'"'+i(e.text,34)+'"'}case 15:case 16:case 17:case 18:{let i=n&1||Ga(e)&16777216?Vh:E9,s=e.rawText??VH(i(e.text,96));switch(e.kind){case 15:return"`"+s+"`";case 16:return"`"+s+"${";case 17:return"}"+s+"${";case 18:return"}"+s+"`"}break}case 9:case 10:return e.text;case 14:return n&4&&e.isUnterminated?e.text+(e.text.charCodeAt(e.text.length-1)===92?" /":"/"):e.text}return M.fail(`Literal kind '${e.kind}' not accounted for.`)}function b1t(e,t){if(Ko(e)||!e.parent||t&4&&e.isUnterminated)return!1;if(Pf(e)){if(e.numericLiteralFlags&26656)return!1;if(e.numericLiteralFlags&512)return!!(t&8)}return!o8(e)}function N_e(e){return bs(e)?`"${Vh(e)}"`:""+e}function D_e(e){return Ul(e).replace(/^(\d)/,"_$1").replace(/\W/g,"_")}function nH(e){return(f0(e)&7)!==0||iH(e)}function iH(e){let t=Bg(e);return t.kind===260&&t.parent.kind===299}function B_(e){return El(e)&&(e.name.kind===11||Rg(e))}function G5(e){return El(e)&&e.name.kind===11}function sH(e){return El(e)&&La(e.name)}function w_e(e){return El(e)||He(e)}function K3(e){return T1t(e.valueDeclaration)}function T1t(e){return!!e&&e.kind===267&&!e.body}function I_e(e){return e.kind===307||e.kind===267||LP(e)}function Rg(e){return!!(e.flags&2048)}function YT(e){return B_(e)&&aH(e)}function aH(e){switch(e.parent.kind){case 307:return nu(e.parent);case 268:return B_(e.parent.parent)&&Ji(e.parent.parent.parent)&&!nu(e.parent.parent.parent)}return!1}function oH(e){var t;return(t=e.declarations)==null?void 0:t.find(n=>!YT(n)&&!(El(n)&&Rg(n)))}function E1t(e){return e===1||e===100||e===199}function ZC(e,t){return nu(e)||E1t(V_(t))&&!!e.commonJsModuleIndicator}function cH(e,t){switch(e.scriptKind){case 1:case 3:case 2:case 4:break;default:return!1}return e.isDeclarationFile?!1:!!(J_(t,"alwaysStrict")||ume(e.statements)||nu(e)||Cd(t))}function lH(e){return!!(e.flags&33554432)||li(e,128)}function uH(e,t){switch(e.kind){case 307:case 269:case 299:case 267:case 248:case 249:case 250:case 176:case 174:case 177:case 178:case 262:case 218:case 219:case 172:case 175:return!0;case 241:return!LP(t)}return!1}function _H(e){switch(M.type(e),e.kind){case 338:case 346:case 323:return!0;default:return fH(e)}}function fH(e){switch(M.type(e),e.kind){case 179:case 180:case 173:case 181:case 184:case 185:case 317:case 263:case 231:case 264:case 265:case 345:case 262:case 174:case 176:case 177:case 178:case 218:case 219:return!0;default:return!1}}function eA(e){switch(e.kind){case 272:case 271:return!0;default:return!1}}function O_e(e){return eA(e)||ZT(e)}function R_e(e){return eA(e)||fR(e)}function Y5(e){switch(e.kind){case 272:case 271:case 243:case 263:case 262:case 267:case 265:case 264:case 266:return!0;default:return!1}}function M_e(e){return X3(e)||El(e)||qh(e)||Np(e)}function X3(e){return eA(e)||xl(e)}function K5(e){return Pr(e.parent,t=>!!(_K(t)&1))}function eg(e){return Pr(e.parent,t=>uH(t,t.parent))}function L_e(e,t){let n=eg(e);for(;n;)t(n),n=eg(n)}function Yo(e){return!e||H3(e)===0?"(Missing)":Hc(e)}function F_e(e){return e.declaration?Yo(e.declaration.parameters[0].name):void 0}function Q3(e){return e.kind===167&&!zp(e.expression)}function PI(e){var t;switch(e.kind){case 80:case 81:return(t=e.emitNode)!=null&&t.autoGenerate?void 0:e.escapedText;case 11:case 9:case 15:return Uc(e.text);case 167:return zp(e.expression)?Uc(e.expression.text):void 0;case 295:return xA(e);default:return M.assertNever(e)}}function tA(e){return M.checkDefined(PI(e))}function op(e){switch(e.kind){case 110:return"this";case 81:case 80:return H3(e)===0?Nn(e):Hc(e);case 166:return op(e.left)+"."+op(e.right);case 211:return He(e.name)||Zi(e.name)?op(e.expression)+"."+op(e.name):M.assertNever(e.name);case 311:return op(e.left)+"#"+op(e.right);case 295:return op(e.namespace)+":"+op(e.name);default:return M.assertNever(e)}}function pn(e,t,...n){let i=Ur(e);return bd(i,e,t,...n)}function qP(e,t,n,...i){let s=Ja(e.text,t.pos);return bu(e,s,t.end-s,n,...i)}function bd(e,t,n,...i){let s=Yx(e,t);return bu(e,s.start,s.length,n,...i)}function ky(e,t,n,i){let s=Yx(e,t);return X5(e,s.start,s.length,n,i)}function Z3(e,t,n,i){let s=Ja(e.text,t.pos);return X5(e,s,t.end-s,n,i)}function j_e(e,t,n){M.assertGreaterThanOrEqual(t,0),M.assertGreaterThanOrEqual(n,0),M.assertLessThanOrEqual(t,e.length),M.assertLessThanOrEqual(t+n,e.length)}function X5(e,t,n,i,s){return j_e(e.text,t,n),{file:e,start:t,length:n,code:i.code,category:i.category,messageText:i.next?i:i.messageText,relatedInformation:s,canonicalHead:i.canonicalHead}}function pH(e,t,n){return{file:e,start:0,length:0,code:t.code,category:t.category,messageText:t.next?t:t.messageText,relatedInformation:n}}function B_e(e){return typeof e.messageText=="string"?{code:e.code,category:e.category,messageText:e.messageText,next:e.next}:e.messageText}function U_e(e,t,n){return{file:e,start:t.pos,length:t.end-t.pos,code:n.code,category:n.category,messageText:n.message}}function V_e(e,...t){return{code:e.code,messageText:vA(e,...t)}}function Bh(e,t){let n=xy(e.languageVersion,!0,e.languageVariant,e.text,void 0,t);n.scan();let i=n.getTokenStart();return Il(i,n.getTokenEnd())}function J_e(e,t){let n=xy(e.languageVersion,!0,e.languageVariant,e.text,void 0,t);return n.scan(),n.getToken()}function x1t(e,t){let n=Ja(e.text,t.pos);if(t.body&&t.body.kind===241){let{line:i}=ba(e,t.body.pos),{line:s}=ba(e,t.body.end);if(i<s)return zu(n,G3(i,e)-n+1)}return Il(n,t.end)}function Yx(e,t){let n=t;switch(t.kind){case 307:{let o=Ja(e.text,0,!1);return o===e.text.length?zu(0,0):Bh(e,o)}case 260:case 208:case 263:case 231:case 264:case 267:case 266:case 306:case 262:case 218:case 174:case 177:case 178:case 265:case 172:case 171:case 274:n=t.name;break;case 219:return x1t(e,t);case 296:case 297:{let o=Ja(e.text,t.pos),u=t.statements.length>0?t.statements[0].pos:t.end;return Il(o,u)}case 253:case 229:{let o=Ja(e.text,t.pos);return Bh(e,o)}case 238:{let o=Ja(e.text,t.expression.end);return Bh(e,o)}case 350:{let o=Ja(e.text,t.tagName.pos);return Bh(e,o)}case 176:{let o=t,u=Ja(e.text,o.pos),m=xy(e.languageVersion,!0,e.languageVariant,e.text,void 0,u),d=m.scan();for(;d!==137&&d!==1;)d=m.scan();let S=m.getTokenEnd();return Il(u,S)}}if(n===void 0)return Bh(e,t.pos);M.assert(!ag(n));let i=$c(n),s=i||DA(t)?n.pos:Ja(e.text,n.pos);return i?(M.assert(s===n.pos,"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809"),M.assert(s===n.end,"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809")):(M.assert(s>=n.pos,"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809"),M.assert(s<=n.end,"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809")),Il(s,n.end)}function Tv(e){return e.kind===307&&!Uf(e)}function Uf(e){return(e.externalModuleIndicator||e.commonJsModuleIndicator)!==void 0}function Kd(e){return e.scriptKind===6}function KT(e){return!!(eb(e)&4096)}function eR(e){return!!(eb(e)&8&&!ap(e,e.parent))}function tR(e){return(f0(e)&7)===6}function rR(e){return(f0(e)&7)===4}function zP(e){return(f0(e)&7)===2}function q_e(e){let t=f0(e)&7;return t===2||t===4||t===6}function Q5(e){return(f0(e)&7)===1}function Kx(e){return e.kind===213&&e.expression.kind===108}function Np(e){return e.kind===213&&e.expression.kind===102}function WP(e){return AO(e)&&e.keywordToken===102&&e.name.escapedText==="meta"}function Ev(e){return qh(e)&&Mv(e.argument)&&La(e.argument.literal)}function Mg(e){return e.kind===244&&e.expression.kind===11}function nR(e){return!!(Ga(e)&2097152)}function Z5(e){return nR(e)&&Tl(e)}function C1t(e){return He(e.name)&&!e.initializer}function e9(e){return nR(e)&&_l(e)&&wi(e.declarationList.declarations,C1t)}function dH(e,t){return e.kind!==12?Ty(t.text,e.pos):void 0}function mH(e,t){let n=e.kind===169||e.kind===168||e.kind===218||e.kind===219||e.kind===217||e.kind===260||e.kind===281?ps(L1(t,e.pos),Ty(t,e.pos)):Ty(t,e.pos);return Zn(n,i=>i.end<=e.end&&t.charCodeAt(i.pos+1)===42&&t.charCodeAt(i.pos+2)===42&&t.charCodeAt(i.pos+3)!==47)}var z_e=/^(\/\/\/\s*<reference\s+path\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/,A1t=/^(\/\/\/\s*<reference\s+types\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/,k1t=/^(\/\/\/\s*<reference\s+lib\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/,W_e=/^(\/\/\/\s*<amd-dependency\s+path\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/,P1t=/^\/\/\/\s*<amd-module\s+.*?\/>/,N1t=/^(\/\/\/\s*<reference\s+no-default-lib\s*=\s*)(('[^']*')|("[^"]*"))\s*\/>/;function Lg(e){if(182<=e.kind&&e.kind<=205)return!0;switch(e.kind){case 133:case 159:case 150:case 163:case 154:case 136:case 155:case 151:case 157:case 106:case 146:return!0;case 116:return e.parent.kind!==222;case 233:return T6e(e);case 168:return e.parent.kind===200||e.parent.kind===195;case 80:(e.parent.kind===166&&e.parent.right===e||e.parent.kind===211&&e.parent.name===e)&&(e=e.parent),M.assert(e.kind===80||e.kind===166||e.kind===211,"'node' was expected to be a qualified name, identifier or property access in 'isPartOfTypeNode'.");case 166:case 211:case 110:{let{parent:t}=e;if(t.kind===186)return!1;if(t.kind===205)return!t.isTypeOf;if(182<=t.kind&&t.kind<=205)return!0;switch(t.kind){case 233:return T6e(t);case 168:return e===t.constraint;case 345:return e===t.constraint;case 172:case 171:case 169:case 260:return e===t.type;case 262:case 218:case 219:case 176:case 174:case 173:case 177:case 178:return e===t.type;case 179:case 180:case 181:return e===t.type;case 216:return e===t.type;case 213:case 214:case 215:return Es(t.typeArguments,e)}}}return!1}function T6e(e){return Jj(e.parent)||zA(e.parent)||pp(e.parent)&&!O9(e)}function E6e(e,t){for(;e;){if(e.kind===t)return!0;e=e.parent}return!1}function xv(e,t){return n(e);function n(i){switch(i.kind){case 253:return t(i);case 269:case 241:case 245:case 246:case 247:case 248:case 249:case 250:case 254:case 255:case 296:case 297:case 256:case 258:case 299:return Js(i,n)}}}function $_e(e,t){return n(e);function n(i){switch(i.kind){case 229:t(i);let s=i.expression;s&&n(s);return;case 266:case 264:case 267:case 265:return;default:if(Bs(i)){if(i.name&&i.name.kind===167){n(i.name.expression);return}}else Lg(i)||Js(i,n)}}}function gH(e){return e&&e.kind===188?e.elementType:e&&e.kind===183?Dh(e.typeArguments):void 0}function H_e(e){switch(e.kind){case 264:case 263:case 231:case 187:return e.members;case 210:return e.properties}}function rA(e){if(e)switch(e.kind){case 208:case 306:case 169:case 303:case 172:case 171:case 304:case 260:return!0}return!1}function G_e(e){return rA(e)||U1(e)}function NI(e){return e.parent.kind===261&&e.parent.parent.kind===243}function Y_e(e){return hn(e)?Ca(e.parent)&&Pn(e.parent.parent)&&cl(e.parent.parent)===2||t9(e.parent):!1}function t9(e){return hn(e)?Pn(e)&&cl(e)===1:!1}function K_e(e){return(Ei(e)?zP(e)&&He(e.name)&&NI(e):Ns(e)?HI(e)&&Jl(e):Nf(e)&&HI(e))||t9(e)}function X_e(e){switch(e.kind){case 174:case 173:case 176:case 177:case 178:case 262:case 218:return!0}return!1}function hH(e,t){for(;;){if(t&&t(e),e.statement.kind!==256)return e.statement;e=e.statement}}function XT(e){return e&&e.kind===241&&Bs(e.parent)}function Nm(e){return e&&e.kind===174&&e.parent.kind===210}function r9(e){return(e.kind===174||e.kind===177||e.kind===178)&&(e.parent.kind===210||e.parent.kind===231)}function Q_e(e){return e&&e.kind===1}function Z_e(e){return e&&e.kind===0}function $P(e,t,n,i){return kt(e?.properties,s=>{if(!ql(s))return;let o=PI(s.name);return t===o||i&&i===o?n(s):void 0})}function efe(e,t,n){return $P(e,t,i=>Gu(i.initializer)?Ln(i.initializer.elements,s=>La(s)&&s.text===n):void 0)}function DI(e){if(e&&e.statements.length){let t=e.statements[0].expression;return ai(t,Ca)}}function n9(e,t,n){return iR(e,t,i=>Gu(i.initializer)?Ln(i.initializer.elements,s=>La(s)&&s.text===n):void 0)}function iR(e,t,n){return $P(DI(e),t,n)}function Dp(e){return Pr(e.parent,Bs)}function tfe(e){return Pr(e.parent,Go)}function Ou(e){return Pr(e.parent,gi)}function rfe(e){return Pr(e.parent,t=>gi(t)||Bs(t)?"quit":Gc(t))}function i9(e){return Pr(e.parent,LP)}function s9(e){let t=Pr(e.parent,n=>gi(n)?"quit":fu(n));return t&&gi(t.parent)?Ou(t.parent):Ou(t??e)}function nf(e,t,n){for(M.assert(e.kind!==307);;){if(e=e.parent,!e)return M.fail();switch(e.kind){case 167:if(n&&gi(e.parent.parent))return e;e=e.parent.parent;break;case 170:e.parent.kind===169&&uu(e.parent.parent)?e=e.parent.parent:uu(e.parent)&&(e=e.parent);break;case 219:if(!t)continue;case 262:case 218:case 267:case 175:case 172:case 171:case 174:case 173:case 176:case 177:case 178:case 179:case 180:case 181:case 266:case 307:return e}}}function nfe(e){switch(e.kind){case 219:case 262:case 218:case 172:return!0;case 241:switch(e.parent.kind){case 176:case 174:case 177:case 178:return!0;default:return!1}default:return!1}}function a9(e){He(e)&&(tu(e.parent)||Tl(e.parent))&&e.parent.name===e&&(e=e.parent);let t=nf(e,!0,!1);return Ji(t)}function ife(e){let t=nf(e,!1,!1);if(t)switch(t.kind){case 176:case 262:case 218:return t}}function sR(e,t){for(;;){if(e=e.parent,!e)return;switch(e.kind){case 167:e=e.parent;break;case 262:case 218:case 219:if(!t)continue;case 172:case 171:case 174:case 173:case 176:case 177:case 178:case 175:return e;case 170:e.parent.kind===169&&uu(e.parent.parent)?e=e.parent.parent:uu(e.parent)&&(e=e.parent);break}}}function QT(e){if(e.kind===218||e.kind===219){let t=e,n=e.parent;for(;n.kind===217;)t=n,n=n.parent;if(n.kind===213&&n.expression===t)return n}}function x6e(e){return e.kind===108||Cf(e)}function Cf(e){let t=e.kind;return(t===211||t===212)&&e.expression.kind===108}function aR(e){let t=e.kind;return(t===211||t===212)&&e.expression.kind===110}function o9(e){var t;return!!e&&Ei(e)&&((t=e.initializer)==null?void 0:t.kind)===110}function sfe(e){return!!e&&(p_(e)||ql(e))&&Pn(e.parent.parent)&&e.parent.parent.operatorToken.kind===64&&e.parent.parent.right.kind===110}function oR(e){switch(e.kind){case 183:return e.typeName;case 233:return nc(e.expression)?e.expression:void 0;case 80:case 166:return e}}function c9(e){switch(e.kind){case 215:return e.tag;case 286:case 285:return e.tagName;case 226:return e.right;default:return e.expression}}function cR(e,t,n,i){if(e&&Wu(t)&&Zi(t.name))return!1;switch(t.kind){case 263:return!0;case 231:return!e;case 172:return n!==void 0&&(e?tu(n):gi(n)&&!oE(t)&&!KH(t));case 177:case 178:case 174:return t.body!==void 0&&n!==void 0&&(e?tu(n):gi(n));case 169:return e?n!==void 0&&n.body!==void 0&&(n.kind===176||n.kind===174||n.kind===178)&&iE(n)!==t&&i!==void 0&&i.kind===263:!1}return!1}function HP(e,t,n,i){return Wp(t)&&cR(e,t,n,i)}function lR(e,t,n,i){return HP(e,t,n,i)||wI(e,t,n)}function wI(e,t,n){switch(t.kind){case 263:return Pt(t.members,i=>lR(e,i,t,n));case 231:return!e&&Pt(t.members,i=>lR(e,i,t,n));case 174:case 178:case 176:return Pt(t.parameters,i=>HP(e,i,t,n));default:return!1}}function Cv(e,t){if(HP(e,t))return!0;let n=Ny(t);return!!n&&wI(e,n,t)}function yH(e,t,n){let i;if(U1(t)){let{firstAccessor:s,secondAccessor:o,setAccessor:u}=W1(n.members,t),m=Wp(s)?s:o&&Wp(o)?o:void 0;if(!m||t!==m)return!1;i=u?.parameters}else ul(t)&&(i=t.parameters);if(HP(e,t,n))return!0;if(i){for(let s of i)if(!sE(s)&&HP(e,s,t,n))return!0}return!1}function vH(e){if(e.textSourceNode){switch(e.textSourceNode.kind){case 11:return vH(e.textSourceNode);case 15:return e.text===""}return!1}return e.text===""}function GP(e){let{parent:t}=e;return t.kind===286||t.kind===285||t.kind===287?t.tagName===e:!1}function tg(e){switch(e.kind){case 108:case 106:case 112:case 97:case 14:case 209:case 210:case 211:case 212:case 213:case 214:case 215:case 234:case 216:case 238:case 235:case 217:case 218:case 231:case 219:case 222:case 220:case 221:case 224:case 225:case 226:case 227:case 230:case 228:case 232:case 284:case 285:case 288:case 229:case 223:case 236:return!0;case 233:return!pp(e.parent)&&!zA(e.parent);case 166:for(;e.parent.kind===166;)e=e.parent;return e.parent.kind===186||QC(e.parent)||OO(e.parent)||Eb(e.parent)||GP(e);case 311:for(;Eb(e.parent);)e=e.parent;return e.parent.kind===186||QC(e.parent)||OO(e.parent)||Eb(e.parent)||GP(e);case 81:return Pn(e.parent)&&e.parent.left===e&&e.parent.operatorToken.kind===103;case 80:if(e.parent.kind===186||QC(e.parent)||OO(e.parent)||Eb(e.parent)||GP(e))return!0;case 9:case 10:case 11:case 15:case 110:return l9(e);default:return!1}}function l9(e){let{parent:t}=e;switch(t.kind){case 260:case 169:case 172:case 171:case 306:case 303:case 208:return t.initializer===e;case 244:case 245:case 246:case 247:case 253:case 254:case 255:case 296:case 257:return t.expression===e;case 248:let n=t;return n.initializer===e&&n.initializer.kind!==261||n.condition===e||n.incrementor===e;case 249:case 250:let i=t;return i.initializer===e&&i.initializer.kind!==261||i.expression===e;case 216:case 234:return e===t.expression;case 239:return e===t.expression;case 167:return e===t.expression;case 170:case 294:case 293:case 305:return!0;case 233:return t.expression===e&&!Lg(t);case 304:return t.objectAssignmentInitializer===e;case 238:return e===t.expression;default:return tg(t)}}function u9(e){for(;e.kind===166||e.kind===80;)e=e.parent;return e.kind===186}function afe(e){return zh(e)&&!!e.parent.moduleSpecifier}function cb(e){return e.kind===271&&e.moduleReference.kind===283}function II(e){return M.assert(cb(e)),e.moduleReference.expression}function SH(e){return ZT(e)&&lN(e.initializer).arguments[0]}function nA(e){return e.kind===271&&e.moduleReference.kind!==283}function Av(e){return e?.kind===307}function Af(e){return hn(e)}function C6e(e){return!hn(e)}function hn(e){return!!e&&!!(e.flags&524288)}function _9(e){return!!e&&!!(e.flags&134217728)}function f9(e){return!Kd(e)}function uR(e){return!!e&&!!(e.flags&16777216)}function p9(e){return Gp(e)&&He(e.typeName)&&e.typeName.escapedText==="Object"&&e.typeArguments&&e.typeArguments.length===2&&(e.typeArguments[0].kind===154||e.typeArguments[0].kind===150)}function kf(e,t){if(e.kind!==213)return!1;let{expression:n,arguments:i}=e;if(n.kind!==80||n.escapedText!=="require"||i.length!==1)return!1;let s=i[0];return!t||No(s)}function _R(e){return A6e(e,!1)}function ZT(e){return A6e(e,!0)}function ofe(e){return Xa(e)&&ZT(e.parent.parent)}function A6e(e,t){return Ei(e)&&!!e.initializer&&kf(t?lN(e.initializer):e.initializer,!0)}function fR(e){return _l(e)&&e.declarationList.declarations.length>0&&wi(e.declarationList.declarations,t=>_R(t))}function pR(e){return e===39||e===34}function d9(e,t){return GT(t,e).charCodeAt(0)===34}function OI(e){return Pn(e)||oc(e)||He(e)||ea(e)}function dR(e){return hn(e)&&e.initializer&&Pn(e.initializer)&&(e.initializer.operatorToken.kind===57||e.initializer.operatorToken.kind===61)&&e.name&&nc(e.name)&&YP(e.name,e.initializer.left)?e.initializer.right:e.initializer}function RI(e){let t=dR(e);return t&&lb(t,$1(e.name))}function D1t(e,t){return kt(e.properties,n=>ql(n)&&He(n.name)&&n.name.escapedText==="value"&&n.initializer&&lb(n.initializer,t))}function iA(e){if(e&&e.parent&&Pn(e.parent)&&e.parent.operatorToken.kind===64){let t=$1(e.parent.left);return lb(e.parent.right,t)||w1t(e.parent.left,e.parent.right,t)}if(e&&ea(e)&&Qx(e)){let t=D1t(e.arguments[2],e.arguments[1].text==="prototype");if(t)return t}}function lb(e,t){if(ea(e)){let n=So(e.expression);return n.kind===218||n.kind===219?e:void 0}if(e.kind===218||e.kind===231||e.kind===219||Ca(e)&&(e.properties.length===0||t))return e}function w1t(e,t,n){let i=Pn(t)&&(t.operatorToken.kind===57||t.operatorToken.kind===61)&&lb(t.right,n);if(i&&YP(e,t.left))return i}function cfe(e){let t=Ei(e.parent)?e.parent.name:Pn(e.parent)&&e.parent.operatorToken.kind===64?e.parent.left:void 0;return t&&lb(e.right,$1(t))&&nc(t)&&YP(t,e.left)}function bH(e){if(Pn(e.parent)){let t=(e.parent.operatorToken.kind===57||e.parent.operatorToken.kind===61)&&Pn(e.parent.parent)?e.parent.parent:e.parent;if(t.operatorToken.kind===64&&He(t.left))return t.left}else if(Ei(e.parent))return e.parent.name}function YP(e,t){return jg(e)&&jg(t)?Qd(e)===Qd(t):Cy(e)&&m9(t)&&(t.expression.kind===110||He(t.expression)&&(t.expression.escapedText==="window"||t.expression.escapedText==="self"||t.expression.escapedText==="global"))?YP(e,hR(t)):m9(e)&&m9(t)?m0(e)===m0(t)&&YP(e.expression,t.expression):!1}function mR(e){for(;Su(e,!0);)e=e.right;return e}function Xx(e){return He(e)&&e.escapedText==="exports"}function TH(e){return He(e)&&e.escapedText==="module"}function Py(e){return(Wn(e)||gR(e))&&TH(e.expression)&&m0(e)==="exports"}function cl(e){let t=I1t(e);return t===5||hn(e)?t:0}function Qx(e){return wt(e.arguments)===3&&Wn(e.expression)&&He(e.expression.expression)&&Nn(e.expression.expression)==="Object"&&Nn(e.expression.name)==="defineProperty"&&zp(e.arguments[1])&&Zx(e.arguments[0],!0)}function m9(e){return Wn(e)||gR(e)}function gR(e){return cc(e)&&zp(e.argumentExpression)}function eE(e,t){return Wn(e)&&(!t&&e.expression.kind===110||He(e.name)&&Zx(e.expression,!0))||g9(e,t)}function g9(e,t){return gR(e)&&(!t&&e.expression.kind===110||nc(e.expression)||eE(e.expression,!0))}function Zx(e,t){return nc(e)||eE(e,t)}function hR(e){return Wn(e)?e.name:e.argumentExpression}function I1t(e){if(ea(e)){if(!Qx(e))return 0;let t=e.arguments[0];return Xx(t)||Py(t)?8:eE(t)&&m0(t)==="prototype"?9:7}return e.operatorToken.kind!==64||!oc(e.left)||O1t(mR(e))?0:Zx(e.left.expression,!0)&&m0(e.left)==="prototype"&&Ca(EH(e))?6:yR(e.left)}function O1t(e){return BA(e)&&Pf(e.expression)&&e.expression.text==="0"}function h9(e){if(Wn(e))return e.name;let t=So(e.argumentExpression);return Pf(t)||No(t)?t:e}function m0(e){let t=h9(e);if(t){if(He(t))return t.escapedText;if(No(t)||Pf(t))return Uc(t.text)}}function yR(e){if(e.expression.kind===110)return 4;if(Py(e))return 2;if(Zx(e.expression,!0)){if($1(e.expression))return 3;let t=e;for(;!He(t.expression);)t=t.expression;let n=t.expression;if((n.escapedText==="exports"||n.escapedText==="module"&&m0(t)==="exports")&&eE(e))return 1;if(Zx(e,!0)||cc(e)&&T9(e))return 5}return 0}function EH(e){for(;Pn(e.right);)e=e.right;return e.right}function vR(e){return Pn(e)&&cl(e)===3}function lfe(e){return hn(e)&&e.parent&&e.parent.kind===244&&(!cc(e)||gR(e))&&!!tb(e.parent)}function SR(e,t){let{valueDeclaration:n}=e;(!n||!(t.flags&33554432&&!hn(t)&&!(n.flags&33554432))&&OI(n)&&!OI(t)||n.kind!==t.kind&&w_e(n))&&(e.valueDeclaration=t)}function ufe(e){if(!e||!e.valueDeclaration)return!1;let t=e.valueDeclaration;return t.kind===262||Ei(t)&&t.initializer&&Bs(t.initializer)}function MI(e){var t,n;switch(e.kind){case 260:case 208:return(t=Pr(e.initializer,i=>kf(i,!0)))==null?void 0:t.arguments[0];case 272:case 278:case 351:return ai(e.moduleSpecifier,No);case 271:return ai((n=ai(e.moduleReference,C0))==null?void 0:n.expression,No);case 273:case 280:return ai(e.parent.moduleSpecifier,No);case 274:case 281:return ai(e.parent.parent.moduleSpecifier,No);case 276:return ai(e.parent.parent.parent.moduleSpecifier,No);case 205:return Ev(e)?e.argument.literal:void 0;default:M.assertNever(e)}}function LI(e){return bR(e)||M.failBadSyntaxKind(e.parent)}function bR(e){switch(e.parent.kind){case 272:case 278:case 351:return e.parent;case 283:return e.parent.parent;case 213:return Np(e.parent)||kf(e.parent,!1)?e.parent:void 0;case 201:return M.assert(La(e)),ai(e.parent.parent,qh);default:return}}function sA(e){switch(e.kind){case 272:case 278:case 351:return e.moduleSpecifier;case 271:return e.moduleReference.kind===283?e.moduleReference.expression:void 0;case 205:return Ev(e)?e.argument.literal:void 0;case 213:return e.arguments[0];case 267:return e.name.kind===11?e.name:void 0;default:return M.assertNever(e)}}function KP(e){switch(e.kind){case 272:return e.importClause&&ai(e.importClause.namedBindings,My);case 271:return e;case 278:return e.exportClause&&ai(e.exportClause,zh);default:return M.assertNever(e)}}function aA(e){return(e.kind===272||e.kind===351)&&!!e.importClause&&!!e.importClause.name}function _fe(e,t){if(e.name){let n=t(e);if(n)return n}if(e.namedBindings){let n=My(e.namedBindings)?t(e.namedBindings):kt(e.namedBindings.elements,t);if(n)return n}}function oA(e){if(e)switch(e.kind){case 169:case 174:case 173:case 304:case 303:case 172:case 171:return e.questionToken!==void 0}return!1}function XP(e){let t=TN(e)?xo(e.parameters):void 0,n=ai(t&&t.name,He);return!!n&&n.escapedText==="new"}function Xd(e){return e.kind===346||e.kind===338||e.kind===340}function TR(e){return Xd(e)||im(e)}function R1t(e){return Du(e)&&Pn(e.expression)&&e.expression.operatorToken.kind===64?mR(e.expression):void 0}function k6e(e){return Du(e)&&Pn(e.expression)&&cl(e.expression)!==0&&Pn(e.expression.right)&&(e.expression.right.operatorToken.kind===57||e.expression.right.operatorToken.kind===61)?e.expression.right.right:void 0}function xH(e){switch(e.kind){case 243:let t=cA(e);return t&&t.initializer;case 172:return e.initializer;case 303:return e.initializer}}function cA(e){return _l(e)?xo(e.declarationList.declarations):void 0}function P6e(e){return El(e)&&e.body&&e.body.kind===267?e.body:void 0}function ER(e){if(e.kind>=243&&e.kind<=259)return!0;switch(e.kind){case 80:case 110:case 108:case 166:case 236:case 212:case 211:case 208:case 218:case 219:case 174:case 177:case 178:return!0;default:return!1}}function xR(e){switch(e.kind){case 219:case 226:case 241:case 252:case 179:case 296:case 263:case 231:case 175:case 176:case 185:case 180:case 251:case 259:case 246:case 212:case 242:case 1:case 266:case 306:case 277:case 278:case 281:case 244:case 249:case 250:case 248:case 262:case 218:case 184:case 177:case 80:case 245:case 272:case 271:case 181:case 264:case 317:case 323:case 256:case 174:case 173:case 267:case 202:case 270:case 210:case 169:case 217:case 211:case 303:case 172:case 171:case 253:case 240:case 178:case 304:case 305:case 255:case 257:case 258:case 265:case 168:case 260:case 243:case 247:case 254:return!0;default:return!1}}function CH(e,t){let n;rA(e)&&bv(e)&&Pp(e.initializer)&&(n=wn(n,N6e(e,e.initializer.jsDoc)));let i=e;for(;i&&i.parent;){if(Pp(i)&&(n=wn(n,N6e(e,i.jsDoc))),i.kind===169){n=wn(n,(t?Bue:OP)(i));break}if(i.kind===168){n=wn(n,(t?Vue:Uue)(i));break}i=AH(i)}return n||ve}function N6e(e,t){let n=Va(t);return va(t,i=>{if(i===n){let s=Zn(i.tags,o=>M1t(e,o));return i.tags===s?[i]:s}else return Zn(i.tags,EN)})}function M1t(e,t){return!(RO(t)||qj(t))||!t.parent||!ag(t.parent)||!uf(t.parent.parent)||t.parent.parent===e}function AH(e){let t=e.parent;if(t.kind===303||t.kind===277||t.kind===172||t.kind===244&&e.kind===211||t.kind===253||P6e(t)||Su(e))return t;if(t.parent&&(cA(t.parent)===e||Su(t)))return t.parent;if(t.parent&&t.parent.parent&&(cA(t.parent.parent)||xH(t.parent.parent)===e||k6e(t.parent.parent)))return t.parent.parent}function CR(e){if(e.symbol)return e.symbol;if(!He(e.name))return;let t=e.name.escapedText,n=ub(e);if(!n)return;let i=Ln(n.parameters,s=>s.name.kind===80&&s.name.escapedText===t);return i&&i.symbol}function y9(e){if(ag(e.parent)&&e.parent.tags){let t=Ln(e.parent.tags,Xd);if(t)return t}return ub(e)}function kH(e){return C5(e,EN)}function ub(e){let t=_b(e);if(t)return Nf(t)&&t.type&&Bs(t.type)?t.type:Bs(t)?t:void 0}function _b(e){let t=tE(e);if(t)return k6e(t)||R1t(t)||xH(t)||cA(t)||P6e(t)||t}function tE(e){let t=QP(e);if(!t)return;let n=t.parent;if(n&&n.jsDoc&&t===vc(n.jsDoc))return n}function QP(e){return Pr(e.parent,ag)}function ffe(e){let t=e.name.escapedText,{typeParameters:n}=e.parent.parent.parent;return n&&Ln(n,i=>i.name.escapedText===t)}function D6e(e){return!!e.typeArguments}var pfe=(e=>(e[e.None=0]="None",e[e.Definite=1]="Definite",e[e.Compound=2]="Compound",e))(pfe||{});function dfe(e){let t=e.parent;for(;;){switch(t.kind){case 226:let n=t,i=n.operatorToken.kind;return y0(i)&&n.left===e?n:void 0;case 224:case 225:let s=t,o=s.operator;return o===46||o===47?s:void 0;case 249:case 250:let u=t;return u.initializer===e?u:void 0;case 217:case 209:case 230:case 235:e=t;break;case 305:e=t.parent;break;case 304:if(t.name!==e)return;e=t.parent;break;case 303:if(t.name===e)return;e=t.parent;break;default:return}t=e.parent}}function fb(e){let t=dfe(e);if(!t)return 0;switch(t.kind){case 226:let n=t.operatorToken.kind;return n===64||GI(n)?1:2;case 224:case 225:return 2;case 249:case 250:return 1}}function kv(e){return!!dfe(e)}function L1t(e){let t=So(e.right);return t.kind===226&&xY(t.operatorToken.kind)}function PH(e){let t=dfe(e);return!!t&&Su(t,!0)&&L1t(t)}function mfe(e){switch(e.kind){case 241:case 243:case 254:case 245:case 255:case 269:case 296:case 297:case 256:case 248:case 249:case 250:case 246:case 247:case 258:case 299:return!0}return!1}function lA(e){return ic(e)||pc(e)||KC(e)||Tl(e)||Vc(e)}function w6e(e,t){for(;e&&e.kind===t;)e=e.parent;return e}function AR(e){return w6e(e,196)}function g0(e){return w6e(e,217)}function gfe(e){let t;for(;e&&e.kind===196;)t=e,e=e.parent;return[t,e]}function FI(e){for(;a2(e);)e=e.type;return e}function So(e,t){return Ml(e,t?17:1)}function NH(e){return e.kind!==211&&e.kind!==212?!1:(e=g0(e.parent),e&&e.kind===220)}function rE(e,t){for(;e;){if(e===t)return!0;e=e.parent}return!1}function Uh(e){return!Ji(e)&&!Hs(e)&&u_(e.parent)&&e.parent.name===e}function jI(e){let t=e.parent;switch(e.kind){case 11:case 15:case 9:if(za(t))return t.parent;case 80:if(u_(t))return t.name===e?t:void 0;if(cf(t)){let n=t.parent;return Pd(n)&&n.name===t?n:void 0}else{let n=t.parent;return Pn(n)&&cl(n)!==0&&(n.left.symbol||n.symbol)&&Ps(n)===e?n:void 0}case 81:return u_(t)&&t.name===e?t:void 0;default:return}}function kR(e){return zp(e)&&e.parent.kind===167&&u_(e.parent.parent)}function hfe(e){let t=e.parent;switch(t.kind){case 172:case 171:case 174:case 173:case 177:case 178:case 306:case 303:case 211:return t.name===e;case 166:return t.right===e;case 208:case 276:return t.propertyName===e;case 281:case 291:case 285:case 286:case 287:return!0}return!1}function I6e(e){return e.kind===271||e.kind===270||e.kind===273&&e.name||e.kind===274||e.kind===280||e.kind===276||e.kind===281||e.kind===277&&ZP(e)?!0:hn(e)&&(Pn(e)&&cl(e)===2&&ZP(e)||Wn(e)&&Pn(e.parent)&&e.parent.left===e&&e.parent.operatorToken.kind===64&&PR(e.parent.right))}function DH(e){switch(e.parent.kind){case 273:case 276:case 274:case 281:case 277:case 271:case 280:return e.parent;case 166:do e=e.parent;while(e.parent.kind===166);return DH(e)}}function PR(e){return nc(e)||eu(e)}function ZP(e){let t=wH(e);return PR(t)}function wH(e){return dc(e)?e.expression:e.right}function yfe(e){return e.kind===304?e.name:e.kind===303?e.initializer:e.parent.right}function Fg(e){let t=nE(e);if(t&&hn(e)){let n=que(e);if(n)return n.class}return t}function nE(e){let t=NR(e.heritageClauses,96);return t&&t.types.length>0?t.types[0]:void 0}function eN(e){if(hn(e))return zue(e).map(t=>t.class);{let t=NR(e.heritageClauses,119);return t?.types}}function BI(e){return Yu(e)?UI(e)||ve:gi(e)&&ps(qC(Fg(e)),eN(e))||ve}function UI(e){let t=NR(e.heritageClauses,96);return t?t.types:void 0}function NR(e,t){if(e){for(let n of e)if(n.token===t)return n}}function pb(e,t){for(;e;){if(e.kind===t)return e;e=e.parent}}function sf(e){return 83<=e&&e<=165}function IH(e){return 19<=e&&e<=79}function v9(e){return sf(e)||IH(e)}function S9(e){return 128<=e&&e<=165}function OH(e){return sf(e)&&!S9(e)}function O6e(e){return 119<=e&&e<=127}function uA(e){let t=JT(e);return t!==void 0&&OH(t)}function R6e(e){let t=JT(e);return t!==void 0&&sf(t)}function RH(e){let t=Jx(e);return!!t&&!S9(t)}function tN(e){return 2<=e&&e<=7}var vfe=(e=>(e[e.Normal=0]="Normal",e[e.Generator=1]="Generator",e[e.Async=2]="Async",e[e.Invalid=4]="Invalid",e[e.AsyncGenerator=3]="AsyncGenerator",e))(vfe||{});function Rl(e){if(!e)return 4;let t=0;switch(e.kind){case 262:case 218:case 174:e.asteriskToken&&(t|=1);case 219:li(e,1024)&&(t|=2);break}return e.body||(t|=4),t}function VI(e){switch(e.kind){case 262:case 218:case 219:case 174:return e.body!==void 0&&e.asteriskToken===void 0&&li(e,1024)}return!1}function zp(e){return No(e)||Pf(e)}function b9(e){return tS(e)&&(e.operator===40||e.operator===41)&&Pf(e.operand)}function h0(e){let t=Ps(e);return!!t&&T9(t)}function T9(e){if(!(e.kind===167||e.kind===212))return!1;let t=cc(e)?So(e.argumentExpression):e.expression;return!zp(t)&&!b9(t)}function e2(e){switch(e.kind){case 80:case 81:return e.escapedText;case 11:case 15:case 9:return Uc(e.text);case 167:let t=e.expression;return zp(t)?Uc(t.text):b9(t)?t.operator===41?Sa(t.operator)+t.operand.text:t.operand.text:void 0;case 295:return xA(e);default:return M.assertNever(e)}}function jg(e){switch(e.kind){case 80:case 11:case 15:case 9:return!0;default:return!1}}function Qd(e){return Cy(e)?Nn(e):sg(e)?hO(e):e.text}function JI(e){return Cy(e)?e.escapedText:sg(e)?xA(e):Uc(e.text)}function M6e(e){return`__@${Aa(e)}@${e.escapedName}`}function DR(e,t){return`__#${Aa(e)}@${t}`}function wR(e){return _s(e.escapedName,"__@")}function Sfe(e){return _s(e.escapedName,"__#")}function L6e(e){return e.kind===80&&e.escapedText==="Symbol"}function bfe(e){return He(e)?Nn(e)==="__proto__":La(e)&&e.text==="__proto__"}function qI(e,t){switch(e=Ml(e),e.kind){case 231:if(wK(e))return!1;break;case 218:if(e.name)return!1;break;case 219:break;default:return!1}return typeof t=="function"?t(e):!0}function MH(e){switch(e.kind){case 303:return!bfe(e.name);case 304:return!!e.objectAssignmentInitializer;case 260:return He(e.name)&&!!e.initializer;case 169:return He(e.name)&&!!e.initializer&&!e.dotDotDotToken;case 208:return He(e.name)&&!!e.initializer&&!e.dotDotDotToken;case 172:return!!e.initializer;case 226:switch(e.operatorToken.kind){case 64:case 77:case 76:case 78:return He(e.left)}break;case 277:return!0}return!1}function cp(e,t){if(!MH(e))return!1;switch(e.kind){case 303:return qI(e.initializer,t);case 304:return qI(e.objectAssignmentInitializer,t);case 260:case 169:case 208:case 172:return qI(e.initializer,t);case 226:return qI(e.right,t);case 277:return qI(e.expression,t)}}function LH(e){return e.escapedText==="push"||e.escapedText==="unshift"}function db(e){return Bg(e).kind===169}function Bg(e){for(;e.kind===208;)e=e.parent.parent;return e}function FH(e){let t=e.kind;return t===176||t===218||t===262||t===219||t===174||t===177||t===178||t===267||t===307}function Ko(e){return ng(e.pos)||ng(e.end)}function F6e(e){return ks(e,Ji)||e}var Tfe=(e=>(e[e.Left=0]="Left",e[e.Right=1]="Right",e))(Tfe||{});function jH(e){let t=UH(e),n=e.kind===214&&e.arguments!==void 0;return BH(e.kind,t,n)}function BH(e,t,n){switch(e){case 214:return n?0:1;case 224:case 221:case 222:case 220:case 223:case 227:case 229:return 1;case 226:switch(t){case 43:case 64:case 65:case 66:case 68:case 67:case 69:case 70:case 71:case 72:case 73:case 74:case 79:case 75:case 76:case 77:case 78:return 1}}return 0}function zI(e){let t=UH(e),n=e.kind===214&&e.arguments!==void 0;return IR(e.kind,t,n)}function UH(e){return e.kind===226?e.operatorToken.kind:e.kind===224||e.kind===225?e.operator:e.kind}var Efe=(e=>(e[e.Comma=0]="Comma",e[e.Spread=1]="Spread",e[e.Yield=2]="Yield",e[e.Assignment=3]="Assignment",e[e.Conditional=4]="Conditional",e[e.Coalesce=4]="Coalesce",e[e.LogicalOR=5]="LogicalOR",e[e.LogicalAND=6]="LogicalAND",e[e.BitwiseOR=7]="BitwiseOR",e[e.BitwiseXOR=8]="BitwiseXOR",e[e.BitwiseAND=9]="BitwiseAND",e[e.Equality=10]="Equality",e[e.Relational=11]="Relational",e[e.Shift=12]="Shift",e[e.Additive=13]="Additive",e[e.Multiplicative=14]="Multiplicative",e[e.Exponentiation=15]="Exponentiation",e[e.Unary=16]="Unary",e[e.Update=17]="Update",e[e.LeftHandSide=18]="LeftHandSide",e[e.Member=19]="Member",e[e.Primary=20]="Primary",e[e.Highest=20]="Highest",e[e.Lowest=0]="Lowest",e[e.Invalid=-1]="Invalid",e))(Efe||{});function IR(e,t,n){switch(e){case 355:return 0;case 230:return 1;case 229:return 2;case 227:return 4;case 226:switch(t){case 28:return 0;case 64:case 65:case 66:case 68:case 67:case 69:case 70:case 71:case 72:case 73:case 74:case 79:case 75:case 76:case 77:case 78:return 3;default:return OR(t)}case 216:case 235:case 224:case 221:case 222:case 220:case 223:return 16;case 225:return 17;case 213:return 18;case 214:return n?19:18;case 215:case 211:case 212:case 236:return 19;case 234:case 238:return 11;case 110:case 108:case 80:case 81:case 106:case 112:case 97:case 9:case 10:case 11:case 209:case 210:case 218:case 219:case 231:case 14:case 15:case 228:case 217:case 232:case 284:case 285:case 288:return 20;default:return-1}}function OR(e){switch(e){case 61:return 4;case 57:return 5;case 56:return 6;case 52:return 7;case 53:return 8;case 51:return 9;case 35:case 36:case 37:case 38:return 10;case 30:case 32:case 33:case 34:case 104:case 103:case 130:case 152:return 11;case 48:case 49:case 50:return 12;case 40:case 41:return 13;case 42:case 44:case 45:return 14;case 43:return 15}return-1}function rN(e){return Zn(e,t=>{switch(t.kind){case 294:return!!t.expression;case 12:return!t.containsOnlyTriviaWhiteSpaces;default:return!0}})}function WI(){let e=[],t=[],n=new Map,i=!1;return{add:o,lookup:s,getGlobalDiagnostics:u,getDiagnostics:m};function s(d){let S;if(d.file?S=n.get(d.file.fileName):S=e,!S)return;let E=mv(S,d,ec,z9);if(E>=0)return S[E];if(~E>0&&W9(d,S[~E-1]))return S[~E-1]}function o(d){let S;d.file?(S=n.get(d.file.fileName),S||(S=[],n.set(d.file.fileName,S),l0(t,d.file.fileName,c_))):(i&&(i=!1,e=e.slice()),S=e),l0(S,d,z9,W9)}function u(){return i=!0,e}function m(d){if(d)return n.get(d)||[];let S=M_(t,E=>n.get(E));return e.length&&S.unshift(...e),S}}var F1t=/\$\{/g;function VH(e){return e.replace(F1t,"\\${")}function xfe(e){return!!((e.templateFlags||0)&2048)}function JH(e){return e&&!!(wA(e)?xfe(e):xfe(e.head)||Pt(e.templateSpans,t=>xfe(t.literal)))}var j1t=/[\\"\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g,B1t=/[\\'\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g,U1t=/\r\n|[\\`\u0000-\u001f\t\v\f\b\r\u2028\u2029\u0085]/g,V1t=new Map(Object.entries({"	":"\\t","\v":"\\v","\f":"\\f","\b":"\\b","\r":"\\r","\n":"\\n","\\":"\\\\",'"':'\\"',"'":"\\'","`":"\\`","\u2028":"\\u2028","\u2029":"\\u2029","\x85":"\\u0085","\r\n":"\\r\\n"}));function j6e(e){return"\\u"+("0000"+e.toString(16).toUpperCase()).slice(-4)}function J1t(e,t,n){if(e.charCodeAt(0)===0){let i=n.charCodeAt(t+e.length);return i>=48&&i<=57?"\\x00":"\\0"}return V1t.get(e)||j6e(e.charCodeAt(0))}function Vh(e,t){let n=t===96?U1t:t===39?B1t:j1t;return e.replace(n,J1t)}var B6e=/[^\u0000-\u007F]/g;function E9(e,t){return e=Vh(e,t),B6e.test(e)?e.replace(B6e,n=>j6e(n.charCodeAt(0))):e}var q1t=/["\u0000-\u001f\u2028\u2029\u0085]/g,z1t=/['\u0000-\u001f\u2028\u2029\u0085]/g,W1t=new Map(Object.entries({'"':"&quot;","'":"&apos;"}));function $1t(e){return"&#x"+e.toString(16).toUpperCase()+";"}function H1t(e){return e.charCodeAt(0)===0?"&#0;":W1t.get(e)||$1t(e.charCodeAt(0))}function qH(e,t){let n=t===39?z1t:q1t;return e.replace(n,H1t)}function Zd(e){let t=e.length;return t>=2&&e.charCodeAt(0)===e.charCodeAt(t-1)&&G1t(e.charCodeAt(0))?e.substring(1,t-1):e}function G1t(e){return e===39||e===34||e===96}function nN(e){let t=e.charCodeAt(0);return t>=97&&t<=122||e.includes("-")}var RR=["","    "];function x9(e){let t=RR[1];for(let n=RR.length;n<=e;n++)RR.push(RR[n-1]+t);return RR[e]}function iN(){return RR[1].length}function MR(e){var t,n,i,s,o,u=!1;function m(L){let F=$C(L);F.length>1?(s=s+F.length-1,o=t.length-L.length+Va(F),i=o-t.length===0):i=!1}function d(L){L&&L.length&&(i&&(L=x9(n)+L,i=!1),t+=L,m(L))}function S(L){L&&(u=!1),d(L)}function E(L){L&&(u=!0),d(L)}function x(){t="",n=0,i=!0,s=0,o=0,u=!1}function D(L){L!==void 0&&(t+=L,m(L),u=!1)}function w(L){L&&L.length&&S(L)}function R(L){(!i||L)&&(t+=e,s++,o=t.length,i=!0,u=!1)}return x(),{write:S,rawWrite:D,writeLiteral:w,writeLine:R,increaseIndent:()=>{n++},decreaseIndent:()=>{n--},getIndent:()=>n,getTextPos:()=>t.length,getLine:()=>s,getColumn:()=>i?n*iN():t.length-o,getText:()=>t,isAtStartOfLine:()=>i,hasTrailingComment:()=>u,hasTrailingWhitespace:()=>!!t.length&&by(t.charCodeAt(t.length-1)),clear:x,writeKeyword:S,writeOperator:S,writeParameter:S,writeProperty:S,writePunctuation:S,writeSpace:S,writeStringLiteral:S,writeSymbol:(L,F)=>S(L),writeTrailingSemicolon:S,writeComment:E}}function zH(e){let t=!1;function n(){t&&(e.writeTrailingSemicolon(";"),t=!1)}return{...e,writeTrailingSemicolon(){t=!0},writeLiteral(i){n(),e.writeLiteral(i)},writeStringLiteral(i){n(),e.writeStringLiteral(i)},writeSymbol(i,s){n(),e.writeSymbol(i,s)},writePunctuation(i){n(),e.writePunctuation(i)},writeKeyword(i){n(),e.writeKeyword(i)},writeOperator(i){n(),e.writeOperator(i)},writeParameter(i){n(),e.writeParameter(i)},writeSpace(i){n(),e.writeSpace(i)},writeProperty(i){n(),e.writeProperty(i)},writeComment(i){n(),e.writeComment(i)},writeLine(){n(),e.writeLine()},increaseIndent(){n(),e.increaseIndent()},decreaseIndent(){n(),e.decreaseIndent()}}}function sN(e){return e.useCaseSensitiveFileNames?e.useCaseSensitiveFileNames():!1}function Pv(e){return l_(sN(e))}function WH(e,t,n){return t.moduleName||$H(e,t.fileName,n&&n.fileName)}function U6e(e,t){return e.getCanonicalFileName(xs(t,e.getCurrentDirectory()))}function Cfe(e,t,n){let i=t.getExternalModuleFileFromDeclaration(n);if(!i||i.isDeclarationFile)return;let s=sA(n);if(!(s&&No(s)&&!qp(s.text)&&!U6e(e,i.path).includes(U6e(e,yu(e.getCommonSourceDirectory())))))return WH(e,i)}function $H(e,t,n){let i=d=>e.getCanonicalFileName(d),s=rc(n?mi(n):e.getCommonSourceDirectory(),e.getCurrentDirectory(),i),o=xs(t,e.getCurrentDirectory()),u=WC(s,o,s,i,!1),m=of(u);return n?Vx(m):m}function Afe(e,t,n){let i=t.getCompilerOptions(),s;return i.outDir?s=of(N9(e,t,i.outDir)):s=of(e),s+n}function kfe(e,t){return C9(e,t.getCompilerOptions(),t)}function C9(e,t,n){let i=t.declarationDir||t.outDir,s=i?D9(e,i,n.getCurrentDirectory(),n.getCommonSourceDirectory(),u=>n.getCanonicalFileName(u)):e,o=A9(s);return of(s)+o}function A9(e){return wl(e,[".mjs",".mts"])?".d.mts":wl(e,[".cjs",".cts"])?".d.cts":wl(e,[".json"])?".d.json.ts":".d.ts"}function Pfe(e){return wl(e,[".d.mts",".mjs",".mts"])?[".mts",".mjs"]:wl(e,[".d.cts",".cjs",".cts"])?[".cts",".cjs"]:wl(e,[".d.json.ts"])?[".json"]:[".tsx",".ts",".jsx",".js"]}function k9(e,t){var n;if(e.paths)return e.baseUrl??M.checkDefined(e.pathsBasePath||((n=t.getCurrentDirectory)==null?void 0:n.call(t)),"Encountered 'paths' without a 'baseUrl', config file, or host 'getCurrentDirectory'.")}function P9(e,t,n){let i=e.getCompilerOptions();if(i.outFile){let s=V_(i),o=i.emitDeclarationOnly||s===2||s===4;return Zn(e.getSourceFiles(),u=>(o||!nu(u))&&t2(u,e,n))}else{let s=t===void 0?e.getSourceFiles():[t];return Zn(s,o=>t2(o,e,n))}}function t2(e,t,n){let i=t.getCompilerOptions();if(i.noEmitForJsFiles&&Af(e)||e.isDeclarationFile||t.isSourceFileFromExternalLibrary(e))return!1;if(n)return!0;if(t.isSourceOfProjectReferenceRedirect(e.fileName))return!1;if(!Kd(e))return!0;if(t.getResolvedProjectReferenceToRedirect(e.fileName))return!1;if(i.outFile)return!0;if(!i.outDir)return!1;if(i.rootDir||i.composite&&i.configFilePath){let s=xs(s6(i,()=>[],t.getCurrentDirectory(),t.getCanonicalFileName),t.getCurrentDirectory()),o=D9(e.fileName,i.outDir,t.getCurrentDirectory(),s,t.getCanonicalFileName);if(_0(e.fileName,o,t.getCurrentDirectory(),!t.useCaseSensitiveFileNames())===0)return!1}return!0}function N9(e,t,n){return D9(e,n,t.getCurrentDirectory(),t.getCommonSourceDirectory(),i=>t.getCanonicalFileName(i))}function D9(e,t,n,i,s){let o=xs(e,n);return o=s(o).indexOf(s(i))===0?o.substring(i.length):o,ri(t,o)}function LR(e,t,n,i,s,o,u){e.writeFile(n,i,s,m=>{t.add(Nc(v.Could_not_write_file_0_Colon_1,n,m))},o,u)}function V6e(e,t,n){if(e.length>Rh(e)&&!n(e)){let i=mi(e);V6e(i,t,n),t(e)}}function HH(e,t,n,i,s,o){try{i(e,t,n)}catch{V6e(mi(Zs(e)),s,o),i(e,t,n)}}function $I(e,t){let n=Sy(e);return oI(n,t)}function r2(e,t){return oI(e,t)}function Ny(e){return Ln(e.members,t=>Vc(t)&&Yd(t.body))}function aN(e){if(e&&e.parameters.length>0){let t=e.parameters.length===2&&sE(e.parameters[0]);return e.parameters[t?1:0]}}function Nfe(e){let t=aN(e);return t&&t.type}function iE(e){if(e.parameters.length&&!A0(e)){let t=e.parameters[0];if(sE(t))return t}}function sE(e){return z1(e.name)}function z1(e){return!!e&&e.kind===80&&GH(e)}function _A(e){return!!Pr(e,t=>t.kind===186?!0:t.kind===80||t.kind===166?!1:"quit")}function aE(e){if(!z1(e))return!1;for(;cf(e.parent)&&e.parent.left===e;)e=e.parent;return e.parent.kind===186}function GH(e){return e.escapedText==="this"}function W1(e,t){let n,i,s,o;return h0(t)?(n=t,t.kind===177?s=t:t.kind===178?o=t:M.fail("Accessor has wrong kind")):kt(e,u=>{if(U1(u)&&oa(u)===oa(t)){let m=e2(u.name),d=e2(t.name);m===d&&(n?i||(i=u):n=u,u.kind===177&&!s&&(s=u),u.kind===178&&!o&&(o=u))}}),{firstAccessor:n,secondAccessor:i,getAccessor:s,setAccessor:o}}function Vl(e){if(!hn(e)&&Tl(e)||im(e))return;let t=e.type;return t||!hn(e)?t:hI(e)?e.typeExpression&&e.typeExpression.type:rb(e)}function Dfe(e){return e.type}function lp(e){return A0(e)?e.type&&e.type.typeExpression&&e.type.typeExpression.type:e.type||(hn(e)?I3(e):void 0)}function w9(e){return va(nb(e),t=>Y1t(t)?t.typeParameters:void 0)}function Y1t(e){return sm(e)&&!(e.parent.kind===320&&(e.parent.tags.some(Xd)||e.parent.tags.some(EN)))}function wfe(e){let t=aN(e);return t&&Vl(t)}function Ife(e,t,n,i){Ofe(e,t,n.pos,i)}function Ofe(e,t,n,i){i&&i.length&&n!==i[0].pos&&r2(e,n)!==r2(e,i[0].pos)&&t.writeLine()}function Rfe(e,t,n,i){n!==i&&r2(e,n)!==r2(e,i)&&t.writeLine()}function Mfe(e,t,n,i,s,o,u,m){if(i&&i.length>0){s&&n.writeSpace(" ");let d=!1;for(let S of i)d&&(n.writeSpace(" "),d=!1),m(e,t,n,S.pos,S.end,u),S.hasTrailingNewLine?n.writeLine():d=!0;d&&o&&n.writeSpace(" ")}}function Lfe(e,t,n,i,s,o,u){let m,d;if(u?s.pos===0&&(m=Zn(Ty(e,s.pos),S)):m=Ty(e,s.pos),m){let E=[],x;for(let D of m){if(x){let w=r2(t,x.end);if(r2(t,D.pos)>=w+2)break}E.push(D),x=D}if(E.length){let D=r2(t,Va(E).end);r2(t,Ja(e,s.pos))>=D+2&&(Ife(t,n,s,m),Mfe(e,t,n,E,!1,!0,o,i),d={nodePos:s.pos,detachedCommentEndPos:Va(E).end})}}return d;function S(E){return $5(e,E.pos)}}function oN(e,t,n,i,s,o){if(e.charCodeAt(i+1)===42){let u=NP(t,i),m=t.length,d;for(let S=i,E=u.line;S<s;E++){let x=E+1===m?e.length+1:t[E+1];if(S!==i){d===void 0&&(d=J6e(e,t[u.line],i));let w=n.getIndent()*iN()-d+J6e(e,S,x);if(w>0){let R=w%iN(),L=x9((w-R)/iN());for(n.rawWrite(L);R;)n.rawWrite(" "),R--}else n.rawWrite("")}K1t(e,s,n,o,S,x),S=x}}else n.writeComment(e.substring(i,s))}function K1t(e,t,n,i,s,o){let u=Math.min(t,o-1),m=e.substring(s,u).trim();m?(n.writeComment(m),u!==t&&n.writeLine()):n.rawWrite(i)}function J6e(e,t,n){let i=0;for(;t<n&&wg(e.charCodeAt(t));t++)e.charCodeAt(t)===9?i+=iN()-i%iN():i++;return i}function YH(e){return U_(e)!==0}function Ffe(e){return Nv(e)!==0}function up(e,t){return!!fA(e,t)}function li(e,t){return!!jfe(e,t)}function oa(e){return uu(e)&&Jl(e)||Gc(e)}function Jl(e){return li(e,256)}function I9(e){return up(e,16)}function oE(e){return li(e,64)}function KH(e){return li(e,128)}function Ug(e){return li(e,512)}function HI(e){return up(e,8)}function Wp(e){return li(e,32768)}function fA(e,t){return U_(e)&t}function jfe(e,t){return Nv(e)&t}function Bfe(e,t,n){return e.kind>=0&&e.kind<=165?0:(e.modifierFlagsCache&536870912||(e.modifierFlagsCache=XH(e)|536870912),n||t&&hn(e)?(!(e.modifierFlagsCache&268435456)&&e.parent&&(e.modifierFlagsCache|=q6e(e)|268435456),z6e(e.modifierFlagsCache)):X1t(e.modifierFlagsCache))}function U_(e){return Bfe(e,!0)}function Ufe(e){return Bfe(e,!0,!0)}function Nv(e){return Bfe(e,!1)}function q6e(e){let t=0;return e.parent&&!ns(e)&&(hn(e)&&(Wue(e)&&(t|=8388608),$ue(e)&&(t|=16777216),Hue(e)&&(t|=33554432),Gue(e)&&(t|=67108864),Yue(e)&&(t|=134217728)),Kue(e)&&(t|=65536)),t}function X1t(e){return e&65535}function z6e(e){return e&131071|(e&260046848)>>>23}function Q1t(e){return z6e(q6e(e))}function Vfe(e){return XH(e)|Q1t(e)}function XH(e){let t=wm(e)?Vg(e.modifiers):0;return(e.flags&8||e.kind===80&&e.flags&4096)&&(t|=32),t}function Vg(e){let t=0;if(e)for(let n of e)t|=pA(n.kind);return t}function pA(e){switch(e){case 126:return 256;case 125:return 1;case 124:return 4;case 123:return 2;case 128:return 64;case 129:return 512;case 95:return 32;case 138:return 128;case 87:return 4096;case 90:return 2048;case 134:return 1024;case 148:return 8;case 164:return 16;case 103:return 8192;case 147:return 16384;case 170:return 32768}return 0}function W6e(e){return e===57||e===56}function Jfe(e){return W6e(e)||e===54}function GI(e){return e===76||e===77||e===78}function QH(e){return Pn(e)&&GI(e.operatorToken.kind)}function FR(e){return W6e(e)||e===61}function jR(e){return Pn(e)&&FR(e.operatorToken.kind)}function y0(e){return e>=64&&e<=79}function ZH(e){let t=eG(e);return t&&!t.isImplements?t.class:void 0}function eG(e){if(x0(e)){if(pp(e.parent)&&gi(e.parent.parent))return{class:e.parent.parent,isImplements:e.parent.token===119};if(zA(e.parent)){let t=_b(e.parent);if(t&&gi(t))return{class:t,isImplements:!1}}}}function Su(e,t){return Pn(e)&&(t?e.operatorToken.kind===64:y0(e.operatorToken.kind))&&xf(e.left)}function $6e(e){return Su(e.parent)&&e.parent.left===e}function Dv(e){if(Su(e,!0)){let t=e.left.kind;return t===210||t===209}return!1}function O9(e){return ZH(e)!==void 0}function nc(e){return e.kind===80||UR(e)}function _p(e){switch(e.kind){case 80:return e;case 166:do e=e.left;while(e.kind!==80);return e;case 211:do e=e.expression;while(e.kind!==80);return e}}function BR(e){return e.kind===80||e.kind===110||e.kind===108||e.kind===236||e.kind===211&&BR(e.expression)||e.kind===217&&BR(e.expression)}function UR(e){return Wn(e)&&He(e.name)&&nc(e.expression)}function VR(e){if(Wn(e)){let t=VR(e.expression);if(t!==void 0)return t+"."+op(e.name)}else if(cc(e)){let t=VR(e.expression);if(t!==void 0&&Ol(e.argumentExpression))return t+"."+e2(e.argumentExpression)}else{if(He(e))return Qi(e.escapedText);if(sg(e))return hO(e)}}function $1(e){return eE(e)&&m0(e)==="prototype"}function YI(e){return e.parent.kind===166&&e.parent.right===e||e.parent.kind===211&&e.parent.name===e||e.parent.kind===236&&e.parent.name===e}function tG(e){return!!e.parent&&(Wn(e.parent)&&e.parent.name===e||cc(e.parent)&&e.parent.argumentExpression===e)}function qfe(e){return cf(e.parent)&&e.parent.right===e||Wn(e.parent)&&e.parent.name===e||Eb(e.parent)&&e.parent.right===e}function R9(e){return Pn(e)&&e.operatorToken.kind===104}function zfe(e){return R9(e.parent)&&e===e.parent.right}function rG(e){return e.kind===210&&e.properties.length===0}function Wfe(e){return e.kind===209&&e.elements.length===0}function KI(e){if(!(!Z1t(e)||!e.declarations)){for(let t of e.declarations)if(t.localSymbol)return t.localSymbol}}function Z1t(e){return e&&wt(e.declarations)>0&&li(e.declarations[0],2048)}function M9(e){return Ln(ASt,t=>Ic(e,t))}function eSt(e){let t=[],n=e.length;for(let i=0;i<n;i++){let s=e.charCodeAt(i);s<128?t.push(s):s<2048?(t.push(s>>6|192),t.push(s&63|128)):s<65536?(t.push(s>>12|224),t.push(s>>6&63|128),t.push(s&63|128)):s<131072?(t.push(s>>18|240),t.push(s>>12&63|128),t.push(s>>6&63|128),t.push(s&63|128)):M.assert(!1,"Unexpected code point")}return t}var dA="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";function $fe(e){let t="",n=eSt(e),i=0,s=n.length,o,u,m,d;for(;i<s;)o=n[i]>>2,u=(n[i]&3)<<4|n[i+1]>>4,m=(n[i+1]&15)<<2|n[i+2]>>6,d=n[i+2]&63,i+1>=s?m=d=64:i+2>=s&&(d=64),t+=dA.charAt(o)+dA.charAt(u)+dA.charAt(m)+dA.charAt(d),i+=3;return t}function tSt(e){let t="",n=0,i=e.length;for(;n<i;){let s=e[n];if(s<128)t+=String.fromCharCode(s),n++;else if((s&192)===192){let o=s&63;n++;let u=e[n];for(;(u&192)===128;)o=o<<6|u&63,n++,u=e[n];t+=String.fromCharCode(o)}else t+=String.fromCharCode(s),n++}return t}function Hfe(e,t){return e&&e.base64encode?e.base64encode(t):$fe(t)}function Gfe(e,t){if(e&&e.base64decode)return e.base64decode(t);let n=t.length,i=[],s=0;for(;s<n&&t.charCodeAt(s)!==dA.charCodeAt(64);){let o=dA.indexOf(t[s]),u=dA.indexOf(t[s+1]),m=dA.indexOf(t[s+2]),d=dA.indexOf(t[s+3]),S=(o&63)<<2|u>>4&3,E=(u&15)<<4|m>>2&15,x=(m&3)<<6|d&63;E===0&&m!==0?i.push(S):x===0&&d!==0?i.push(S,E):i.push(S,E,x),s+=4}return tSt(i)}function nG(e,t){let n=bs(t)?t:t.readFile(e);if(!n)return;let i=VY(e,n);return i.error?void 0:i.config}function XI(e,t){return nG(e,t)||{}}function L9(e){try{return JSON.parse(e)}catch{return}}function rg(e,t){return!t.directoryExists||t.directoryExists(e)}var rSt=`\r
`,nSt=`
`;function wv(e){switch(e.newLine){case 0:return rSt;case 1:case void 0:return nSt}}function Td(e,t=e){return M.assert(t>=e||t===-1),{pos:e,end:t}}function F9(e,t){return Td(e.pos,t)}function mb(e,t){return Td(t,e.end)}function v0(e){let t=wm(e)?xm(e.modifiers,fu):void 0;return t&&!ng(t.end)?mb(e,t.end):e}function Jg(e){if(Ns(e)||ul(e))return mb(e,e.name.pos);let t=wm(e)?vc(e.modifiers):void 0;return t&&!ng(t.end)?mb(e,t.end):v0(e)}function H6e(e){return e.pos===e.end}function iG(e,t){return Td(e,e+Sa(t).length)}function n2(e,t){return Kfe(e,e,t)}function j9(e,t,n){return Ed(QI(e,n,!1),QI(t,n,!1),n)}function Yfe(e,t,n){return Ed(e.end,t.end,n)}function Kfe(e,t,n){return Ed(QI(e,n,!1),t.end,n)}function JR(e,t,n){return Ed(e.end,QI(t,n,!1),n)}function sG(e,t,n,i){let s=QI(t,n,i);return cI(n,e.end,s)}function G6e(e,t,n){return cI(n,e.end,t.end)}function Xfe(e,t){return!Ed(e.pos,e.end,t)}function Ed(e,t,n){return cI(n,e,t)===0}function QI(e,t,n){return ng(e.pos)?-1:Ja(t.text,e.pos,!1,n)}function Qfe(e,t,n,i){let s=Ja(n.text,e,!1,i),o=iSt(s,t,n);return cI(n,o??t,s)}function Zfe(e,t,n,i){let s=Ja(n.text,e,!1,i);return cI(n,e,Math.min(t,s))}function iSt(e,t=0,n){for(;e-- >t;)if(!by(n.text.charCodeAt(e)))return e}function aG(e){let t=ks(e);if(t)switch(t.parent.kind){case 266:case 267:return t===t.parent.name}return!1}function ZI(e){return Zn(e.declarations,qR)}function qR(e){return Ei(e)&&e.initializer!==void 0}function oG(e){return e.watch&&Ho(e,"watch")}function Dm(e){e.close()}function ll(e){return e.flags&33554432?e.links.checkFlags:0}function xd(e,t=!1){if(e.valueDeclaration){let n=t&&e.declarations&&Ln(e.declarations,fp)||e.flags&32768&&Ln(e.declarations,Hp)||e.valueDeclaration,i=eb(n);return e.parent&&e.parent.flags&32?i:i&-8}if(ll(e)&6){let n=e.links.checkFlags,i=n&1024?2:n&256?1:4,s=n&2048?256:0;return i|s}return e.flags&4194304?257:0}function $u(e,t){return e.flags&2097152?t.getAliasedSymbol(e):e}function cN(e){return e.exportSymbol?e.exportSymbol.flags|e.flags:e.flags}function B9(e){return eO(e)===1}function mA(e){return eO(e)!==0}function eO(e){let{parent:t}=e;switch(t?.kind){case 217:return eO(t);case 225:case 224:let{operator:n}=t;return n===46||n===47?2:0;case 226:let{left:i,operatorToken:s}=t;return i===e&&y0(s.kind)?s.kind===64?1:2:0;case 211:return t.name!==e?0:eO(t);case 303:{let o=eO(t.parent);return e===t.name?sSt(o):o}case 304:return e===t.objectAssignmentInitializer?0:eO(t.parent);case 209:return eO(t);default:return 0}}function sSt(e){switch(e){case 0:return 1;case 1:return 0;case 2:return 2;default:return M.assertNever(e)}}function cG(e,t){if(!e||!t||Object.keys(e).length!==Object.keys(t).length)return!1;for(let n in e)if(typeof e[n]=="object"){if(!cG(e[n],t[n]))return!1}else if(typeof e[n]!="function"&&e[n]!==t[n])return!1;return!0}function Vf(e,t){e.forEach(t),e.clear()}function Dy(e,t,n){let{onDeleteValue:i,onExistingValue:s}=n;e.forEach((o,u)=>{var m;t?.has(u)?s&&s(o,(m=t.get)==null?void 0:m.call(t,u),u):(e.delete(u),i(o,u))})}function tO(e,t,n){Dy(e,t,n);let{createNewValue:i}=n;t?.forEach((s,o)=>{e.has(o)||e.set(o,i(o,s))})}function epe(e){if(e.flags&32){let t=S0(e);return!!t&&li(t,64)}return!1}function S0(e){var t;return(t=e.declarations)==null?void 0:t.find(gi)}function Kn(e){return e.flags&3899393?e.objectFlags:0}function Y6e(e,t){return!!Am(e,n=>t(n)?!0:void 0)}function U9(e){return!!e&&!!e.declarations&&!!e.declarations[0]&&p8(e.declarations[0])}function tpe({moduleSpecifier:e}){return La(e)?e.text:Hc(e)}function lG(e){let t;return Js(e,n=>{Yd(n)&&(t=n)},n=>{for(let i=n.length-1;i>=0;i--)if(Yd(n[i])){t=n[i];break}}),t}function em(e,t,n=!0){return e.has(t)?!1:(e.set(t,n),!0)}function gA(e){return gi(e)||Yu(e)||lf(e)}function uG(e){return e>=182&&e<=205||e===133||e===159||e===150||e===163||e===151||e===136||e===154||e===155||e===116||e===157||e===146||e===141||e===233||e===312||e===313||e===314||e===315||e===316||e===317||e===318}function oc(e){return e.kind===211||e.kind===212}function _G(e){return e.kind===211?e.name:(M.assert(e.kind===212),e.argumentExpression)}function V9(e){return e.kind===275||e.kind===279}function lN(e){for(;oc(e);)e=e.expression;return e}function rpe(e,t){if(oc(e.parent)&&tG(e))return n(e.parent);function n(i){if(i.kind===211){let s=t(i.name);if(s!==void 0)return s}else if(i.kind===212)if(He(i.argumentExpression)||No(i.argumentExpression)){let s=t(i.argumentExpression);if(s!==void 0)return s}else return;if(oc(i.expression))return n(i.expression);if(He(i.expression))return t(i.expression)}}function uN(e,t){for(;;){switch(e.kind){case 225:e=e.operand;continue;case 226:e=e.left;continue;case 227:e=e.condition;continue;case 215:e=e.tag;continue;case 213:if(t)return e;case 234:case 212:case 211:case 235:case 354:case 238:e=e.expression;continue}return e}}function aSt(e,t){this.flags=e,this.escapedName=t,this.declarations=void 0,this.valueDeclaration=void 0,this.id=0,this.mergeId=0,this.parent=void 0,this.members=void 0,this.exports=void 0,this.exportSymbol=void 0,this.constEnumOnlyModule=void 0,this.isReferenced=void 0,this.lastAssignmentPos=void 0,this.links=void 0}function oSt(e,t){this.flags=t,(M.isDebugging||Cn)&&(this.checker=e)}function cSt(e,t){this.flags=t,M.isDebugging&&(this.checker=e)}function npe(e,t,n){this.pos=t,this.end=n,this.kind=e,this.id=0,this.flags=0,this.modifierFlagsCache=0,this.transformFlags=0,this.parent=void 0,this.original=void 0,this.emitNode=void 0}function lSt(e,t,n){this.pos=t,this.end=n,this.kind=e,this.id=0,this.flags=0,this.transformFlags=0,this.parent=void 0,this.emitNode=void 0}function uSt(e,t,n){this.pos=t,this.end=n,this.kind=e,this.id=0,this.flags=0,this.transformFlags=0,this.parent=void 0,this.original=void 0,this.emitNode=void 0}function _St(e,t,n){this.fileName=e,this.text=t,this.skipTrivia=n||(i=>i)}var Hu={getNodeConstructor:()=>npe,getTokenConstructor:()=>lSt,getIdentifierConstructor:()=>uSt,getPrivateIdentifierConstructor:()=>npe,getSourceFileConstructor:()=>npe,getSymbolConstructor:()=>aSt,getTypeConstructor:()=>oSt,getSignatureConstructor:()=>cSt,getSourceMapSourceConstructor:()=>_St},K6e=[];function X6e(e){K6e.push(e),e(Hu)}function ipe(e){Object.assign(Hu,e),kt(K6e,t=>t(Hu))}function wy(e,t){return e.replace(/{(\d+)}/g,(n,i)=>""+M.checkDefined(t[+i]))}var J9;function spe(e){J9=e}function ape(e){!J9&&e&&(J9=e())}function Ms(e){return J9&&J9[e.key]||e.message}function hA(e,t,n,i,s,...o){n+i>t.length&&(i=t.length-n),j_e(t,n,i);let u=Ms(s);return Pt(o)&&(u=wy(u,o)),{file:void 0,start:n,length:i,messageText:u,category:s.category,code:s.code,reportsUnnecessary:s.reportsUnnecessary,fileName:e}}function fSt(e){return e.file===void 0&&e.start!==void 0&&e.length!==void 0&&typeof e.fileName=="string"}function Q6e(e,t){let n=t.fileName||"",i=t.text.length;M.assertEqual(e.fileName,n),M.assertLessThanOrEqual(e.start,i),M.assertLessThanOrEqual(e.start+e.length,i);let s={file:t,start:e.start,length:e.length,messageText:e.messageText,category:e.category,code:e.code,reportsUnnecessary:e.reportsUnnecessary};if(e.relatedInformation){s.relatedInformation=[];for(let o of e.relatedInformation)fSt(o)&&o.fileName===n?(M.assertLessThanOrEqual(o.start,i),M.assertLessThanOrEqual(o.start+o.length,i),s.relatedInformation.push(Q6e(o,t))):s.relatedInformation.push(o)}return s}function yA(e,t){let n=[];for(let i of e)n.push(Q6e(i,t));return n}function bu(e,t,n,i,...s){j_e(e.text,t,n);let o=Ms(i);return Pt(s)&&(o=wy(o,s)),{file:e,start:t,length:n,messageText:o,category:i.category,code:i.code,reportsUnnecessary:i.reportsUnnecessary,reportsDeprecated:i.reportsDeprecated}}function vA(e,...t){let n=Ms(e);return Pt(t)&&(n=wy(n,t)),n}function Nc(e,...t){let n=Ms(e);return Pt(t)&&(n=wy(n,t)),{file:void 0,start:void 0,length:void 0,messageText:n,category:e.category,code:e.code,reportsUnnecessary:e.reportsUnnecessary,reportsDeprecated:e.reportsDeprecated}}function q9(e,t){return{file:void 0,start:void 0,length:void 0,code:e.code,category:e.category,messageText:e.next?e:e.messageText,relatedInformation:t}}function js(e,t,...n){let i=Ms(t);return Pt(n)&&(i=wy(i,n)),{messageText:i,category:t.category,code:t.code,next:e===void 0||Array.isArray(e)?e:[e]}}function ope(e,t){let n=e;for(;n.next;)n=n.next[0];n.next=[t]}function fG(e){return e.file?e.file.path:void 0}function rO(e,t){return z9(e,t)||pSt(e,t)||0}function z9(e,t){let n=pG(e),i=pG(t);return c_(fG(e),fG(t))||tc(e.start,t.start)||tc(e.length,t.length)||tc(n,i)||dSt(e,t)||0}function pSt(e,t){return!e.relatedInformation&&!t.relatedInformation?0:e.relatedInformation&&t.relatedInformation?tc(t.relatedInformation.length,e.relatedInformation.length)||kt(e.relatedInformation,(n,i)=>{let s=t.relatedInformation[i];return rO(n,s)})||0:e.relatedInformation?-1:1}function dSt(e,t){let n=dG(e),i=dG(t);typeof n!="string"&&(n=n.messageText),typeof i!="string"&&(i=i.messageText);let s=typeof e.messageText!="string"?e.messageText.next:void 0,o=typeof t.messageText!="string"?t.messageText.next:void 0,u=c_(n,i);return u||(u=mSt(s,o),u)?u:e.canonicalHead&&!t.canonicalHead?-1:t.canonicalHead&&!e.canonicalHead?1:0}function mSt(e,t){return e===void 0&&t===void 0?0:e===void 0?1:t===void 0?-1:Z6e(e,t)||e4e(e,t)}function Z6e(e,t){if(e===void 0&&t===void 0)return 0;if(e===void 0)return 1;if(t===void 0)return-1;let n=tc(t.length,e.length);if(n)return n;for(let i=0;i<t.length;i++)if(n=Z6e(e[i].next,t[i].next),n)return n;return 0}function e4e(e,t){let n;for(let i=0;i<t.length;i++){if(n=c_(e[i].messageText,t[i].messageText),n)return n;if(e[i].next!==void 0&&(n=e4e(e[i].next,t[i].next),n))return n}return 0}function W9(e,t){let n=pG(e),i=pG(t),s=dG(e),o=dG(t);return c_(fG(e),fG(t))===0&&tc(e.start,t.start)===0&&tc(e.length,t.length)===0&&tc(n,i)===0&&gSt(s,o)}function pG(e){var t;return((t=e.canonicalHead)==null?void 0:t.code)||e.code}function dG(e){var t;return((t=e.canonicalHead)==null?void 0:t.messageText)||e.messageText}function gSt(e,t){let n=typeof e=="string"?e:e.messageText,i=typeof t=="string"?t:t.messageText;return c_(n,i)===0}function zR(e){return e===4||e===2||e===1||e===6?1:0}function t4e(e){if(e.transformFlags&2)return __(e)||vE(e)?e:Js(e,t4e)}function hSt(e){return e.isDeclarationFile?void 0:t4e(e)}function ySt(e){return(e.impliedNodeFormat===99||wl(e.fileName,[".cjs",".cts",".mjs",".mts"]))&&!e.isDeclarationFile?!0:void 0}function WR(e){switch(cpe(e)){case 3:return s=>{s.externalModuleIndicator=E8(s)||!s.isDeclarationFile||void 0};case 1:return s=>{s.externalModuleIndicator=E8(s)};case 2:let t=[E8];(e.jsx===4||e.jsx===5)&&t.push(hSt),t.push(ySt);let n=Jp(...t);return s=>void(s.externalModuleIndicator=n(s))}}function Wbr(e){return e}var Ql={target:{dependencies:["module"],computeValue:e=>(e.target===0?void 0:e.target)??(e.module===100&&9||e.module===199&&99||1)},module:{dependencies:["target"],computeValue:e=>typeof e.module=="number"?e.module:Ql.target.computeValue(e)>=2?5:1},moduleResolution:{dependencies:["module","target"],computeValue:e=>{let t=e.moduleResolution;if(t===void 0)switch(Ql.module.computeValue(e)){case 1:t=2;break;case 100:t=3;break;case 199:t=99;break;case 200:t=100;break;default:t=1;break}return t}},moduleDetection:{dependencies:["module","target"],computeValue:e=>e.moduleDetection||(Ql.module.computeValue(e)===100||Ql.module.computeValue(e)===199?3:2)},isolatedModules:{dependencies:["verbatimModuleSyntax"],computeValue:e=>!!(e.isolatedModules||e.verbatimModuleSyntax)},esModuleInterop:{dependencies:["module","target"],computeValue:e=>{if(e.esModuleInterop!==void 0)return e.esModuleInterop;switch(Ql.module.computeValue(e)){case 100:case 199:case 200:return!0}return!1}},allowSyntheticDefaultImports:{dependencies:["module","target","moduleResolution"],computeValue:e=>e.allowSyntheticDefaultImports!==void 0?e.allowSyntheticDefaultImports:Ql.esModuleInterop.computeValue(e)||Ql.module.computeValue(e)===4||Ql.moduleResolution.computeValue(e)===100},resolvePackageJsonExports:{dependencies:["moduleResolution"],computeValue:e=>{let t=Ql.moduleResolution.computeValue(e);if(!bA(t))return!1;if(e.resolvePackageJsonExports!==void 0)return e.resolvePackageJsonExports;switch(t){case 3:case 99:case 100:return!0}return!1}},resolvePackageJsonImports:{dependencies:["moduleResolution","resolvePackageJsonExports"],computeValue:e=>{let t=Ql.moduleResolution.computeValue(e);if(!bA(t))return!1;if(e.resolvePackageJsonExports!==void 0)return e.resolvePackageJsonExports;switch(t){case 3:case 99:case 100:return!0}return!1}},resolveJsonModule:{dependencies:["moduleResolution","module","target"],computeValue:e=>e.resolveJsonModule!==void 0?e.resolveJsonModule:Ql.moduleResolution.computeValue(e)===100},declaration:{dependencies:["composite"],computeValue:e=>!!(e.declaration||e.composite)},preserveConstEnums:{dependencies:["isolatedModules","verbatimModuleSyntax"],computeValue:e=>!!(e.preserveConstEnums||Ql.isolatedModules.computeValue(e))},incremental:{dependencies:["composite"],computeValue:e=>!!(e.incremental||e.composite)},declarationMap:{dependencies:["declaration","composite"],computeValue:e=>!!(e.declarationMap&&Ql.declaration.computeValue(e))},allowJs:{dependencies:["checkJs"],computeValue:e=>e.allowJs===void 0?!!e.checkJs:e.allowJs},useDefineForClassFields:{dependencies:["target","module"],computeValue:e=>e.useDefineForClassFields===void 0?Ql.target.computeValue(e)>=9:e.useDefineForClassFields},noImplicitAny:{dependencies:["strict"],computeValue:e=>J_(e,"noImplicitAny")},noImplicitThis:{dependencies:["strict"],computeValue:e=>J_(e,"noImplicitThis")},strictNullChecks:{dependencies:["strict"],computeValue:e=>J_(e,"strictNullChecks")},strictFunctionTypes:{dependencies:["strict"],computeValue:e=>J_(e,"strictFunctionTypes")},strictBindCallApply:{dependencies:["strict"],computeValue:e=>J_(e,"strictBindCallApply")},strictPropertyInitialization:{dependencies:["strict"],computeValue:e=>J_(e,"strictPropertyInitialization")},alwaysStrict:{dependencies:["strict"],computeValue:e=>J_(e,"alwaysStrict")},useUnknownInCatchVariables:{dependencies:["strict"],computeValue:e=>J_(e,"useUnknownInCatchVariables")}},Ka=Ql.target.computeValue,V_=Ql.module.computeValue,af=Ql.moduleResolution.computeValue,cpe=Ql.moduleDetection.computeValue,Cd=Ql.isolatedModules.computeValue,Iy=Ql.esModuleInterop.computeValue,SA=Ql.allowSyntheticDefaultImports.computeValue,mG=Ql.resolvePackageJsonExports.computeValue,gG=Ql.resolvePackageJsonImports.computeValue,cE=Ql.resolveJsonModule.computeValue,$p=Ql.declaration.computeValue,lE=Ql.preserveConstEnums.computeValue,nO=Ql.incremental.computeValue,$9=Ql.declarationMap.computeValue,H1=Ql.allowJs.computeValue,$R=Ql.useDefineForClassFields.computeValue;function H9(e){return e>=5&&e<=99}function G9(e){switch(V_(e)){case 0:case 4:case 3:return!1}return!0}function lpe(e){return e.allowUnreachableCode===!1}function upe(e){return e.allowUnusedLabels===!1}function bA(e){return e>=3&&e<=99||e===100}function J_(e,t){return e[t]===void 0?!!e.strict:!!e[t]}function Y9(e){return Nu(RY.type,(t,n)=>t===e?n:void 0)}function hG(e){return e.useDefineForClassFields!==!1&&Ka(e)>=9}function _pe(e,t){return UP(t,e,Ome)}function fpe(e,t){return UP(t,e,Rme)}function ppe(e,t){return UP(t,e,Mme)}function K9(e,t){return t.strictFlag?J_(e,t.name):t.allowJsFlag?H1(e):e[t.name]}function X9(e){let t=e.jsx;return t===2||t===4||t===5}function Q9(e,t){let n=t?.pragmas.get("jsximportsource"),i=Rs(n)?n[n.length-1]:n;return e.jsx===4||e.jsx===5||e.jsxImportSource||i?i?.arguments.factory||e.jsxImportSource||"react":void 0}function Z9(e,t){return e?`${e}/${t.jsx===5?"jsx-dev-runtime":"jsx-runtime"}`:void 0}function yG(e){let t=!1;for(let n=0;n<e.length;n++)if(e.charCodeAt(n)===42)if(!t)t=!0;else return!1;return!0}function vG(e,t){let n,i,s,o=!1;return{getSymlinkedFiles:()=>s,getSymlinkedDirectories:()=>n,getSymlinkedDirectoriesByRealpath:()=>i,setSymlinkedFile:(d,S)=>(s||(s=new Map)).set(d,S),setSymlinkedDirectory:(d,S)=>{let E=rc(d,e,t);pO(E)||(E=yu(E),S!==!1&&!n?.has(E)&&(i||(i=yd())).add(S.realPath,d),(n||(n=new Map)).set(E,S))},setSymlinksFromResolutions(d,S,E){M.assert(!o),o=!0,d(x=>m(this,x.resolvedModule)),S(x=>m(this,x.resolvedTypeReferenceDirective)),E.forEach(x=>m(this,x.resolvedTypeReferenceDirective))},hasProcessedResolutions:()=>o,setSymlinksFromResolution(d){m(this,d)},hasAnySymlinks:u};function u(){return!!s?.size||!!n&&!!Nu(n,d=>!!d)}function m(d,S){if(!S||!S.originalPath||!S.resolvedFileName)return;let{resolvedFileName:E,originalPath:x}=S;d.setSymlinkedFile(rc(x,e,t),E);let[D,w]=vSt(E,x,e,t)||ve;D&&w&&d.setSymlinkedDirectory(w,{real:yu(D),realPath:yu(rc(D,e,t))})}}function vSt(e,t,n,i){let s=hu(xs(e,n)),o=hu(xs(t,n)),u=!1;for(;s.length>=2&&o.length>=2&&!r4e(s[s.length-2],i)&&!r4e(o[o.length-2],i)&&i(s[s.length-1])===i(o[o.length-1]);)s.pop(),o.pop(),u=!0;return u?[u0(s),u0(o)]:void 0}function r4e(e,t){return e!==void 0&&(t(e)==="node_modules"||_s(e,"@"))}function SSt(e){return f$(e.charCodeAt(0))?e.slice(1):void 0}function SG(e,t,n){let i=UW(e,t,n);return i===void 0?void 0:SSt(i)}var dpe=/[^\w\s/]/g;function n4e(e){return e.replace(dpe,bSt)}function bSt(e){return"\\"+e}var TSt=[42,63],mpe=["node_modules","bower_components","jspm_packages"],gpe=`(?!(${mpe.join("|")})(/|$))`,i4e={singleAsteriskRegexFragment:"([^./]|(\\.(?!min\\.js$))?)*",doubleAsteriskRegexFragment:`(/${gpe}[^/.][^/]*)*?`,replaceWildcardCharacter:e=>vpe(e,i4e.singleAsteriskRegexFragment)},s4e={singleAsteriskRegexFragment:"[^/]*",doubleAsteriskRegexFragment:`(/${gpe}[^/.][^/]*)*?`,replaceWildcardCharacter:e=>vpe(e,s4e.singleAsteriskRegexFragment)},a4e={singleAsteriskRegexFragment:"[^/]*",doubleAsteriskRegexFragment:"(/.+?)?",replaceWildcardCharacter:e=>vpe(e,a4e.singleAsteriskRegexFragment)},hpe={files:i4e,directories:s4e,exclude:a4e};function iO(e,t,n){let i=ej(e,t,n);return!i||!i.length?void 0:`^(${i.map(u=>`(${u})`).join("|")})${n==="exclude"?"($|/)":"$"}`}function ej(e,t,n){if(!(e===void 0||e.length===0))return va(e,i=>i&&tj(i,t,n,hpe[n]))}function bG(e){return!/[.*?]/.test(e)}function ype(e,t,n){let i=e&&tj(e,t,n,hpe[n]);return i&&`^(${i})${n==="exclude"?"($|/)":"$"}`}function tj(e,t,n,{singleAsteriskRegexFragment:i,doubleAsteriskRegexFragment:s,replaceWildcardCharacter:o}=hpe[n]){let u="",m=!1,d=S3(e,t),S=Va(d);if(n!=="exclude"&&S==="**")return;d[0]=ZS(d[0]),bG(S)&&d.push("**","*");let E=0;for(let x of d){if(x==="**")u+=s;else if(n==="directories"&&(u+="(",E++),m&&(u+=Ec),n!=="exclude"){let D="";x.charCodeAt(0)===42?(D+="([^./]"+i+")?",x=x.substr(1)):x.charCodeAt(0)===63&&(D+="[^./]",x=x.substr(1)),D+=x.replace(dpe,o),D!==x&&(u+=gpe),u+=D}else u+=x.replace(dpe,o);m=!0}for(;E>0;)u+=")?",E--;return u}function vpe(e,t){return e==="*"?t:e==="?"?"[^/]":"\\"+e}function rj(e,t,n,i,s){e=Zs(e),s=Zs(s);let o=ri(s,e);return{includeFilePatterns:Cr(ej(n,o,"files"),u=>`^${u}$`),includeFilePattern:iO(n,o,"files"),includeDirectoryPattern:iO(n,o,"directories"),excludePattern:iO(t,o,"exclude"),basePaths:ESt(e,n,i)}}function G1(e,t){return new RegExp(e,t?"":"i")}function TG(e,t,n,i,s,o,u,m,d){e=Zs(e),o=Zs(o);let S=rj(e,n,i,s,o),E=S.includeFilePatterns&&S.includeFilePatterns.map(J=>G1(J,s)),x=S.includeDirectoryPattern&&G1(S.includeDirectoryPattern,s),D=S.excludePattern&&G1(S.excludePattern,s),w=E?E.map(()=>[]):[[]],R=new Map,L=l_(s);for(let J of S.basePaths)F(J,ri(o,J),u);return ef(w);function F(J,G,q){let ee=L(d(G));if(R.has(ee))return;R.set(ee,!0);let{files:W,directories:pe}=m(J);for(let K of pa(W,c_)){let re=ri(J,K),ue=ri(G,K);if(!(t&&!wl(re,t))&&!(D&&D.test(ue)))if(!E)w[0].push(re);else{let ce=Bo(E,ne=>ne.test(ue));ce!==-1&&w[ce].push(re)}}if(!(q!==void 0&&(q--,q===0)))for(let K of pa(pe,c_)){let re=ri(J,K),ue=ri(G,K);(!x||x.test(ue))&&(!D||!D.test(ue))&&F(re,ue,q)}}}function ESt(e,t,n){let i=[e];if(t){let s=[];for(let o of t){let u=ip(o)?o:Zs(ri(e,o));s.push(xSt(u))}s.sort(CP(!n));for(let o of s)wi(i,u=>!Cm(u,o,e,!n))&&i.push(o)}return i}function xSt(e){let t=qw(e,TSt);return t<0?kP(e)?ZS(mi(e)):e:e.substring(0,e.lastIndexOf(Ec,t))}function nj(e,t){return t||ij(e)||3}function ij(e){switch(e.substr(e.lastIndexOf(".")).toLowerCase()){case".js":case".cjs":case".mjs":return 1;case".jsx":return 2;case".ts":case".cts":case".mts":return 3;case".tsx":return 4;case".json":return 6;default:return 0}}var sO=[[".ts",".tsx",".d.ts"],[".cts",".d.cts"],[".mts",".d.mts"]],EG=ef(sO),CSt=[...sO,[".json"]],ASt=[".d.ts",".d.cts",".d.mts",".cts",".mts",".ts",".tsx"],Spe=[[".js",".jsx"],[".mjs"],[".cjs"]],_N=ef(Spe),xG=[[".ts",".tsx",".d.ts",".js",".jsx"],[".cts",".d.cts",".cjs"],[".mts",".d.mts",".mjs"]],kSt=[...xG,[".json"]],sj=[".d.ts",".d.cts",".d.mts"],aj=[".ts",".cts",".mts",".tsx"],oj=[".mts",".d.mts",".mjs",".cts",".d.cts",".cjs"];function aO(e,t){let n=e&&H1(e);if(!t||t.length===0)return n?xG:sO;let i=n?xG:sO,s=ef(i);return[...i,...Gi(t,u=>u.scriptKind===7||n&&PSt(u.scriptKind)&&!s.includes(u.extension)?[u.extension]:void 0)]}function HR(e,t){return!e||!cE(e)?t:t===xG?kSt:t===sO?CSt:[...t,[".json"]]}function PSt(e){return e===1||e===2}function Oy(e){return Pt(_N,t=>Ic(e,t))}function TA(e){return Pt(EG,t=>Ic(e,t))}var bpe=(e=>(e[e.Minimal=0]="Minimal",e[e.Index=1]="Index",e[e.JsExtension=2]="JsExtension",e[e.TsExtension=3]="TsExtension",e))(bpe||{});function Tpe({imports:e},t=Jp(Oy,TA)){return yi(e,({text:n})=>qp(n)&&!wl(n,oj)?t(n):void 0)||!1}function Epe(e,t,n,i){let s=af(n),o=3<=s&&s<=99;if(e==="js"||t===99&&o)return MN(n)&&u()!==2?3:2;if(e==="minimal")return 0;if(e==="index")return 1;if(!MN(n))return i&&Tpe(i)?2:0;return u();function u(){let m=!1,d=i?.imports.length?i.imports:i&&Af(i)?NSt(i).map(S=>S.arguments[0]):ve;for(let S of d)if(qp(S.text)){if(o&&t===1&&eX(i,S,n)===99||wl(S.text,oj))continue;if(TA(S.text))return 3;Oy(S.text)&&(m=!0)}return m?2:0}}function NSt(e){let t=0,n;for(let i of e.statements){if(t>3)break;fR(i)?n=ps(n,i.declarationList.declarations.map(s=>s.initializer)):Du(i)&&kf(i.expression,!0)?n=Bt(n,i.expression):t++}return n||ve}function xpe(e,t,n){if(!e)return!1;let i=aO(t,n);for(let s of ef(HR(t,i)))if(Ic(e,s))return!0;return!1}function o4e(e){let t=e.match(/\//g);return t?t.length:0}function GR(e,t){return tc(o4e(e),o4e(t))}var Cpe=[".d.ts",".d.mts",".d.cts",".mjs",".mts",".cjs",".cts",".ts",".js",".tsx",".jsx",".json"];function of(e){for(let t of Cpe){let n=Ape(e,t);if(n!==void 0)return n}return e}function Ape(e,t){return Ic(e,t)?YR(e,t):void 0}function YR(e,t){return e.substring(0,e.length-t.length)}function Y1(e,t){return b3(e,t,Cpe,!1)}function fN(e){let t=e.indexOf("*");return t===-1?e:e.indexOf("*",t+1)!==-1?void 0:{prefix:e.substr(0,t),suffix:e.substr(t+1)}}function cj(e){return Gi(Ng(e),t=>fN(t))}function ng(e){return!(e>=0)}function lj(e){return e===".ts"||e===".tsx"||e===".d.ts"||e===".cts"||e===".mts"||e===".d.mts"||e===".d.cts"||_s(e,".d.")&&Wc(e,".ts")}function oO(e){return lj(e)||e===".json"}function cO(e){let t=b0(e);return t!==void 0?t:M.fail(`File ${e} has unknown extension.`)}function c4e(e){return b0(e)!==void 0}function b0(e){return Ln(Cpe,t=>Ic(e,t))}function lO(e,t){return e.checkJsDirective?e.checkJsDirective.enabled:t.checkJs}var CG={files:ve,directories:ve};function AG(e,t){let n=[];for(let i of e){if(i===t)return t;bs(i)||n.push(i)}return BW(n,i=>i,t)}function kG(e,t){let n=e.indexOf(t);return M.assert(n!==-1),e.slice(n)}function ca(e,...t){return t.length&&(e.relatedInformation||(e.relatedInformation=[]),M.assert(e.relatedInformation!==ve,"Diagnostic had empty array singleton for related info, but is still being constructed!"),e.relatedInformation.push(...t)),e}function kpe(e,t){M.assert(e.length!==0);let n=t(e[0]),i=n;for(let s=1;s<e.length;s++){let o=t(e[s]);o<n?n=o:o>i&&(i=o)}return{min:n,max:i}}function PG(e){return{pos:ob(e),end:e.end}}function NG(e,t){let n=t.pos-1,i=Math.min(e.text.length,Ja(e.text,t.end)+1);return{pos:n,end:i}}function uO(e,t,n){return t.skipLibCheck&&e.isDeclarationFile||t.skipDefaultLibCheck&&e.hasNoDefaultLib||t.noCheck||n.isSourceOfProjectReferenceRedirect(e.fileName)||!KR(e,t)}function KR(e,t){if(e.checkJsDirective&&e.checkJsDirective.enabled===!1)return!1;if(e.scriptKind===3||e.scriptKind===4||e.scriptKind===5)return!0;let i=(e.scriptKind===1||e.scriptKind===2)&&lO(e,t);return AI(e,t.checkJs)||i||e.scriptKind===7}function uj(e,t){return e===t||typeof e=="object"&&e!==null&&typeof t=="object"&&t!==null&&Uce(e,t,uj)}function _O(e){let t;switch(e.charCodeAt(1)){case 98:case 66:t=1;break;case 111:case 79:t=3;break;case 120:case 88:t=4;break;default:let S=e.length-1,E=0;for(;e.charCodeAt(E)===48;)E++;return e.slice(E,S)||"0"}let n=2,i=e.length-1,s=(i-n)*t,o=new Uint16Array((s>>>4)+(s&15?1:0));for(let S=i-1,E=0;S>=n;S--,E+=t){let x=E>>>4,D=e.charCodeAt(S),R=(D<=57?D-48:10+D-(D<=70?65:97))<<(E&15);o[x]|=R;let L=R>>>16;L&&(o[x+1]|=L)}let u="",m=o.length-1,d=!0;for(;d;){let S=0;d=!1;for(let E=m;E>=0;E--){let x=S<<16|o[E],D=x/10|0;o[E]=D,S=x-D*10,D&&!d&&(m=E,d=!0)}u=S+u}return u}function uE({negative:e,base10Value:t}){return(e&&t!=="0"?"-":"")+t}function Ppe(e){if(_j(e,!1))return DG(e)}function DG(e){let t=e.startsWith("-"),n=_O(`${t?e.slice(1):e}n`);return{negative:t,base10Value:n}}function _j(e,t){if(e==="")return!1;let n=xy(99,!1),i=!0;n.setOnError(()=>i=!1),n.setText(e+"n");let s=n.scan(),o=s===41;o&&(s=n.scan());let u=n.getTokenFlags();return i&&s===10&&n.getTokenEnd()===e.length+1&&!(u&512)&&(!t||e===uE({negative:o,base10Value:_O(n.getTokenValue())}))}function gb(e){return!!(e.flags&33554432)||u9(e)||ISt(e)||wSt(e)||!(tg(e)||DSt(e))}function DSt(e){return He(e)&&p_(e.parent)&&e.parent.name===e}function wSt(e){for(;e.kind===80||e.kind===211;)e=e.parent;if(e.kind!==167)return!1;if(li(e.parent,64))return!0;let t=e.parent.parent.kind;return t===264||t===187}function ISt(e){if(e.kind!==80)return!1;let t=Pr(e.parent,n=>{switch(n.kind){case 298:return!0;case 211:case 233:return!1;default:return"quit"}});return t?.token===119||t?.parent.kind===264}function Npe(e){return Gp(e)&&He(e.typeName)}function Dpe(e,t=gv){if(e.length<2)return!0;let n=e[0];for(let i=1,s=e.length;i<s;i++){let o=e[i];if(!t(n,o))return!1}return!0}function fO(e,t){return e.pos=t,e}function pN(e,t){return e.end=t,e}function qg(e,t,n){return pN(fO(e,t),n)}function wG(e,t,n){return qg(e,t,t+n)}function wpe(e,t){return e&&(e.flags=t),e}function lo(e,t){return e&&t&&(e.parent=t),e}function l4e(e,t){if(e)for(let n of e)lo(n,t);return e}function T0(e,t){if(!e)return e;return $A(e,FP(e)?n:s),e;function n(o,u){if(t&&o.parent===u)return"skip";lo(o,u)}function i(o){if(Pp(o))for(let u of o.jsDoc)n(u,o),$A(u,n)}function s(o,u){return n(o,u)||i(o)}}function OSt(e){return!pu(e)}function IG(e){return Gu(e)&&wi(e.elements,OSt)}function Ipe(e){for(M.assertIsDefined(e.parent);;){let t=e.parent;if(uf(t)){e=t;continue}if(Du(t)||BA(t)||Sb(t)&&(t.initializer===e||t.incrementor===e))return!0;if(kO(t)){if(e!==Va(t.elements))return!0;e=t;continue}if(Pn(t)&&t.operatorToken.kind===28){if(e===t.left)return!0;e=t;continue}return!1}}function pO(e){return Pt(_5,t=>e.includes(t))}function Ope(e){if(!e.parent)return;switch(e.kind){case 168:let{parent:n}=e;return n.kind===195?void 0:n.typeParameters;case 169:return e.parent.parameters;case 204:return e.parent.templateSpans;case 239:return e.parent.templateSpans;case 170:{let{parent:i}=e;return TE(i)?i.modifiers:void 0}case 298:return e.parent.heritageClauses}let{parent:t}=e;if(jP(e))return f2(e.parent)?void 0:e.parent.tags;switch(t.kind){case 187:case 264:return $T(e)?t.members:void 0;case 192:case 193:return t.types;case 189:case 209:case 355:case 275:case 279:return t.elements;case 210:case 292:return t.properties;case 213:case 214:return Di(e)?t.typeArguments:t.expression===e?void 0:t.arguments;case 284:case 288:return $3(e)?t.children:void 0;case 286:case 285:return Di(e)?t.typeArguments:void 0;case 241:case 296:case 297:case 268:return t.statements;case 269:return t.clauses;case 263:case 231:return uu(e)?t.members:void 0;case 266:return nS(e)?t.members:void 0;case 307:return t.statements}}function fj(e){if(!e.typeParameters){if(Pt(e.parameters,t=>!Vl(t)))return!0;if(e.kind!==219){let t=xo(e.parameters);if(!(t&&sE(t)))return!0}}return!1}function dO(e){return e==="Infinity"||e==="-Infinity"||e==="NaN"}function Rpe(e){return e.kind===260&&e.parent.kind===299}function K1(e){return e.kind===218||e.kind===219}function _E(e){return e.replace(/\$/gm,()=>"\\$")}function Ry(e){return(+e).toString()===e}function pj(e,t,n,i,s){let o=s&&e==="new";return!o&&sp(e,t)?U.createIdentifier(e):!i&&!o&&Ry(e)&&+e>=0?U.createNumericLiteral(+e):U.createStringLiteral(e,!!n)}function mO(e){return!!(e.flags&262144&&e.isThisType)}function dj(e){let t=0,n=0,i=0,s=0,o;(S=>{S[S.BeforeNodeModules=0]="BeforeNodeModules",S[S.NodeModules=1]="NodeModules",S[S.Scope=2]="Scope",S[S.PackageContent=3]="PackageContent"})(o||(o={}));let u=0,m=0,d=0;for(;m>=0;)switch(u=m,m=e.indexOf("/",u+1),d){case 0:e.indexOf(jy,u)===u&&(t=u,n=m,d=1);break;case 1:case 2:d===1&&e.charAt(u+1)==="@"?d=2:(i=m,d=3);break;case 3:e.indexOf(jy,u)===u?d=1:d=3;break}return s=u,d>1?{topLevelNodeModulesIndex:t,topLevelPackageNameIndex:n,packageRootIndex:i,fileNameIndex:s}:void 0}function u4e(e){var t;return e.kind===341?(t=e.typeExpression)==null?void 0:t.type:e.type}function EA(e){switch(e.kind){case 168:case 263:case 264:case 265:case 266:case 346:case 338:case 340:return!0;case 273:return e.isTypeOnly;case 276:case 281:return e.parent.parent.isTypeOnly;default:return!1}}function XR(e){return bb(e)||_l(e)||Tl(e)||tu(e)||Yu(e)||EA(e)||El(e)&&!YT(e)&&!Rg(e)}function QR(e){if(!hI(e))return!1;let{isBracketed:t,typeExpression:n}=e;return t||!!n&&n.type.kind===316}function OG(e,t){if(e.length===0)return!1;let n=e.charCodeAt(0);return n===35?e.length>1&&Ey(e.charCodeAt(1),t):Ey(n,t)}function Mpe(e){var t;return((t=JG(e))==null?void 0:t.kind)===0}function mj(e){return hn(e)&&(e.type&&e.type.kind===316||OP(e).some(QR))}function dN(e){switch(e.kind){case 172:case 171:return!!e.questionToken;case 169:return!!e.questionToken||mj(e);case 348:case 341:return QR(e);default:return!1}}function Lpe(e){let t=e.kind;return(t===211||t===212)&&VA(e.expression)}function RG(e){return hn(e)&&uf(e)&&Pp(e)&&!!I$(e)}function MG(e){return M.checkDefined(gj(e))}function gj(e){let t=I$(e);return t&&t.typeExpression&&t.typeExpression.type}function gO(e){return He(e)?e.escapedText:xA(e)}function ZR(e){return He(e)?Nn(e):hO(e)}function Fpe(e){let t=e.kind;return t===80||t===295}function xA(e){return`${e.namespace.escapedText}:${Nn(e.name)}`}function hO(e){return`${Nn(e.namespace)}:${Nn(e.name)}`}function LG(e){return He(e)?Nn(e):hO(e)}function tm(e){return!!(e.flags&8576)}function rm(e){return e.flags&8192?e.escapedName:e.flags&384?Uc(""+e.value):M.fail()}function CA(e){return!!e&&(Wn(e)||cc(e)||Pn(e))}function jpe(e){return e===void 0?!1:!!BN(e.attributes)}var RSt=String.prototype.replace;function AA(e,t){return RSt.call(e,"*",t)}function hj(e){return He(e.name)?e.name.escapedText:Uc(e.name.text)}function _u(e,t=!1,n=!1,i=!1){return{value:e,isSyntacticallyString:t,resolvedOtherFiles:n,hasExternalReferences:i}}function Bpe({evaluateElementAccessExpression:e,evaluateEntityNameExpression:t}){function n(s,o){let u=!1,m=!1,d=!1;switch(s=So(s),s.kind){case 224:let S=n(s.operand,o);if(m=S.resolvedOtherFiles,d=S.hasExternalReferences,typeof S.value=="number")switch(s.operator){case 40:return _u(S.value,u,m,d);case 41:return _u(-S.value,u,m,d);case 55:return _u(~S.value,u,m,d)}break;case 226:{let E=n(s.left,o),x=n(s.right,o);if(u=(E.isSyntacticallyString||x.isSyntacticallyString)&&s.operatorToken.kind===40,m=E.resolvedOtherFiles||x.resolvedOtherFiles,d=E.hasExternalReferences||x.hasExternalReferences,typeof E.value=="number"&&typeof x.value=="number")switch(s.operatorToken.kind){case 52:return _u(E.value|x.value,u,m,d);case 51:return _u(E.value&x.value,u,m,d);case 49:return _u(E.value>>x.value,u,m,d);case 50:return _u(E.value>>>x.value,u,m,d);case 48:return _u(E.value<<x.value,u,m,d);case 53:return _u(E.value^x.value,u,m,d);case 42:return _u(E.value*x.value,u,m,d);case 44:return _u(E.value/x.value,u,m,d);case 40:return _u(E.value+x.value,u,m,d);case 41:return _u(E.value-x.value,u,m,d);case 45:return _u(E.value%x.value,u,m,d);case 43:return _u(E.value**x.value,u,m,d)}else if((typeof E.value=="string"||typeof E.value=="number")&&(typeof x.value=="string"||typeof x.value=="number")&&s.operatorToken.kind===40)return _u(""+E.value+x.value,u,m,d);break}case 11:case 15:return _u(s.text,!0);case 228:return i(s,o);case 9:return _u(+s.text);case 80:return t(s,o);case 211:if(nc(s))return t(s,o);break;case 212:return e(s,o)}return _u(void 0,u,m,d)}function i(s,o){let u=s.head.text,m=!1,d=!1;for(let S of s.templateSpans){let E=n(S.expression,o);if(E.value===void 0)return _u(void 0,!0);u+=E.value,u+=S.literal.text,m||(m=E.resolvedOtherFiles),d||(d=E.hasExternalReferences)}return _u(u,!0,m,d)}return n}function FG(e){return sb(e)&&Qm(e.type)||RO(e)&&Qm(e.typeExpression)}function e8(e){let t=e.members;for(let n of t)if(n.kind===176&&Yd(n.body))return n}function jG({compilerOptions:e,requireSymbol:t,argumentsSymbol:n,error:i,getSymbolOfDeclaration:s,globals:o,lookup:u,setRequiresScopeChangeCache:m=VT,getRequiresScopeChangeCache:d=VT,onPropertyWithInvalidInitializer:S=Dg,onFailedToResolveSymbol:E=VT,onSuccessfullyResolvedSymbol:x=VT}){var D=e.verbatimModuleSyntax?"verbatimModuleSyntax":"isolatedModules",w=hG(e),R=fa();return L;function L(ee,W,pe,K,re,ue){var ce,ne,le;let me=ee,de,Ae,xe,te,he,be=!1,Ve,Pe=bs(W)?W:W.escapedText;e:for(;ee;){if(Pe==="const"&&FG(ee))return;if(z3(ee)&&Ae&&ee.name===Ae&&(Ae=ee,ee=ee.parent),Lh(ee)&&ee.locals&&!Tv(ee)&&(de=u(ee.locals,Pe,pe))){let ke=!0;if(Bs(ee)&&Ae&&Ae!==ee.body?(pe&de.flags&788968&&Ae.kind!==320&&(ke=de.flags&262144?!!(Ae.flags&16)||Ae===ee.type||Ae.kind===169||Ae.kind===341||Ae.kind===342||Ae.kind===168:!1),pe&de.flags&3&&(F(de,ee,Ae)?ke=!1:de.flags&1&&(ke=Ae.kind===169||!!(Ae.flags&16)||Ae===ee.type&&!!Pr(de.valueDeclaration,ns)))):ee.kind===194&&(ke=Ae===ee.trueType),ke)break e;de=void 0}switch(be=be||J(ee,Ae),ee.kind){case 307:if(!Uf(ee))break;case 267:let ke=((ce=s(ee))==null?void 0:ce.exports)||R;if(ee.kind===307||El(ee)&&ee.flags&33554432&&!Rg(ee)){if(de=ke.get("default")){let ct=KI(de);if(ct&&de.flags&pe&&ct.escapedName===Pe)break e;de=void 0}let Be=ke.get(Pe);if(Be&&Be.flags===2097152&&(Pc(Be,281)||Pc(Be,280)))break}if(Pe!=="default"&&(de=u(ke,Pe,pe&2623475)))if(Ji(ee)&&ee.commonJsModuleIndicator&&!((ne=de.declarations)!=null&&ne.some(Xd)))de=void 0;else break e;break;case 266:if(de=u(((le=s(ee))==null?void 0:le.exports)||R,Pe,pe&8)){K&&Cd(e)&&!(ee.flags&33554432)&&Ur(ee)!==Ur(de.valueDeclaration)&&i(me,v.Cannot_access_0_from_another_file_without_qualification_when_1_is_enabled_Use_2_instead,Qi(Pe),D,`${Qi(s(ee).escapedName)}.${Qi(Pe)}`);break e}break;case 172:if(!oa(ee)){let Be=e8(ee.parent);Be&&Be.locals&&u(Be.locals,Pe,pe&111551)&&(M.assertNode(ee,Ns),te=ee)}break;case 263:case 231:case 264:if(de=u(s(ee).members||R,Pe,pe&788968)){if(!q(de,ee)){de=void 0;break}if(Ae&&oa(Ae)){K&&i(me,v.Static_members_cannot_reference_class_type_parameters);return}break e}if(eu(ee)&&pe&32){let Be=ee.name;if(Be&&Pe===Be.escapedText){de=ee.symbol;break e}}break;case 233:if(Ae===ee.expression&&ee.parent.token===96){let Be=ee.parent.parent;if(gi(Be)&&(de=u(s(Be).members,Pe,pe&788968))){K&&i(me,v.Base_class_expressions_cannot_reference_class_type_parameters);return}}break;case 167:if(Ve=ee.parent.parent,(gi(Ve)||Ve.kind===264)&&(de=u(s(Ve).members,Pe,pe&788968))){K&&i(me,v.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);return}break;case 219:if(Ka(e)>=2)break;case 174:case 176:case 177:case 178:case 262:if(pe&3&&Pe==="arguments"){de=n;break e}break;case 218:if(pe&3&&Pe==="arguments"){de=n;break e}if(pe&16){let Be=ee.name;if(Be&&Pe===Be.escapedText){de=ee.symbol;break e}}break;case 170:ee.parent&&ee.parent.kind===169&&(ee=ee.parent),ee.parent&&(uu(ee.parent)||ee.parent.kind===263)&&(ee=ee.parent);break;case 346:case 338:case 340:case 351:let De=QP(ee);De&&(ee=De.parent);break;case 169:Ae&&(Ae===ee.initializer||Ae===ee.name&&Hs(Ae))&&(he||(he=ee));break;case 208:Ae&&(Ae===ee.initializer||Ae===ee.name&&Hs(Ae))&&db(ee)&&!he&&(he=ee);break;case 195:if(pe&262144){let Be=ee.typeParameter.name;if(Be&&Pe===Be.escapedText){de=ee.typeParameter.symbol;break e}}break;case 281:Ae&&Ae===ee.propertyName&&ee.parent.parent.moduleSpecifier&&(ee=ee.parent.parent.parent);break}G(ee,Ae)&&(xe=ee),Ae=ee,ee=sm(ee)?y9(ee)||ee.parent:(Pd(ee)||Vj(ee))&&ub(ee)||ee.parent}if(re&&de&&(!xe||de!==xe.symbol)&&(de.isReferenced|=pe),!de){if(Ae&&(M.assertNode(Ae,Ji),Ae.commonJsModuleIndicator&&Pe==="exports"&&pe&Ae.symbol.flags))return Ae.symbol;ue||(de=u(o,Pe,pe))}if(!de&&me&&hn(me)&&me.parent&&kf(me.parent,!1))return t;if(K){if(te&&S(me,Pe,te,de))return;de?x(me,de,pe,Ae,he,be):E(me,W,pe,K)}return de}function F(ee,W,pe){let K=Ka(e),re=W;if(ns(pe)&&re.body&&ee.valueDeclaration&&ee.valueDeclaration.pos>=re.body.pos&&ee.valueDeclaration.end<=re.body.end&&K>=2){let ne=d(re);return ne===void 0&&(ne=kt(re.parameters,ue)||!1,m(re,ne)),!ne}return!1;function ue(ne){return ce(ne.name)||!!ne.initializer&&ce(ne.initializer)}function ce(ne){switch(ne.kind){case 219:case 218:case 262:case 176:return!1;case 174:case 177:case 178:case 303:return ce(ne.name);case 172:return Jl(ne)?!w:ce(ne.name);default:return R$(ne)||S_(ne)?K<7:Xa(ne)&&ne.dotDotDotToken&&Yp(ne.parent)?K<4:Di(ne)?!1:Js(ne,ce)||!1}}}function J(ee,W){return ee.kind!==219&&ee.kind!==218?pE(ee)||(Go(ee)||ee.kind===172&&!oa(ee))&&(!W||W!==ee.name):W&&W===ee.name?!1:ee.asteriskToken||li(ee,1024)?!0:!QT(ee)}function G(ee,W){switch(ee.kind){case 169:return!!W&&W===ee.name;case 262:case 263:case 264:case 266:case 265:case 267:return!0;default:return!1}}function q(ee,W){if(ee.declarations){for(let pe of ee.declarations)if(pe.kind===168&&(sm(pe.parent)?tE(pe.parent):pe.parent)===W)return!(sm(pe.parent)&&Ln(pe.parent.parent.tags,Xd))}return!1}}function yj(e,t=!0){switch(M.type(e),e.kind){case 112:case 97:case 9:case 11:case 15:return!0;case 10:return t;case 224:return e.operator===41?Pf(e.operand)||t&&o8(e.operand):e.operator===40?Pf(e.operand):!1;default:return!1}}function Upe(e){for(;e.kind===217;)e=e.expression;return e}function Vpe(e){switch(M.type(e),e.kind){case 169:case 171:case 172:case 208:case 211:case 212:case 226:case 260:case 277:case 303:return!0;default:return!1}}function Jpe(){let e,t,n,i,s;return{createBaseSourceFileNode:o,createBaseIdentifierNode:u,createBasePrivateIdentifierNode:m,createBaseTokenNode:d,createBaseNode:S};function o(E){return new(s||(s=Hu.getSourceFileConstructor()))(E,-1,-1)}function u(E){return new(n||(n=Hu.getIdentifierConstructor()))(E,-1,-1)}function m(E){return new(i||(i=Hu.getPrivateIdentifierConstructor()))(E,-1,-1)}function d(E){return new(t||(t=Hu.getTokenConstructor()))(E,-1,-1)}function S(E){return new(e||(e=Hu.getNodeConstructor()))(E,-1,-1)}}function qpe(e){let t,n;return{getParenthesizeLeftSideOfBinaryForOperator:i,getParenthesizeRightSideOfBinaryForOperator:s,parenthesizeLeftSideOfBinary:S,parenthesizeRightSideOfBinary:E,parenthesizeExpressionOfComputedPropertyName:x,parenthesizeConditionOfConditionalExpression:D,parenthesizeBranchOfConditionalExpression:w,parenthesizeExpressionOfExportDefault:R,parenthesizeExpressionOfNew:L,parenthesizeLeftSideOfAccess:F,parenthesizeOperandOfPostfixUnary:J,parenthesizeOperandOfPrefixUnary:G,parenthesizeExpressionsOfCommaDelimitedList:q,parenthesizeExpressionForDisallowedComma:ee,parenthesizeExpressionOfExpressionStatement:W,parenthesizeConciseBodyOfArrowFunction:pe,parenthesizeCheckTypeOfConditionalType:K,parenthesizeExtendsTypeOfConditionalType:re,parenthesizeConstituentTypesOfUnionType:ce,parenthesizeConstituentTypeOfUnionType:ue,parenthesizeConstituentTypesOfIntersectionType:le,parenthesizeConstituentTypeOfIntersectionType:ne,parenthesizeOperandOfTypeOperator:me,parenthesizeOperandOfReadonlyTypeOperator:de,parenthesizeNonArrayTypeOfPostfixType:Ae,parenthesizeElementTypesOfTupleType:xe,parenthesizeElementTypeOfTupleType:te,parenthesizeTypeOfOptionalType:be,parenthesizeTypeArguments:ke,parenthesizeLeadingTypeArgument:Ve};function i(De){t||(t=new Map);let Be=t.get(De);return Be||(Be=ct=>S(De,ct),t.set(De,Be)),Be}function s(De){n||(n=new Map);let Be=n.get(De);return Be||(Be=ct=>E(De,void 0,ct),n.set(De,Be)),Be}function o(De,Be,ct,qe){let et=IR(226,De),Ie=BH(226,De),_t=km(Be);if(!ct&&Be.kind===219&&et>3)return!0;let mt=zI(_t);switch(tc(mt,et)){case-1:return!(!ct&&Ie===1&&Be.kind===229);case 1:return!1;case 0:if(ct)return Ie===1;if(Pn(_t)&&_t.operatorToken.kind===De){if(u(De))return!1;if(De===40){let ht=qe?m(qe):0;if(yI(ht)&&ht===m(_t))return!1}}return jH(_t)===0}}function u(De){return De===42||De===52||De===51||De===53||De===28}function m(De){if(De=km(De),yI(De.kind))return De.kind;if(De.kind===226&&De.operatorToken.kind===40){if(De.cachedLiteralKind!==void 0)return De.cachedLiteralKind;let Be=m(De.left),ct=yI(Be)&&Be===m(De.right)?Be:0;return De.cachedLiteralKind=ct,ct}return 0}function d(De,Be,ct,qe){return km(Be).kind===217?Be:o(De,Be,ct,qe)?e.createParenthesizedExpression(Be):Be}function S(De,Be){return d(De,Be,!0)}function E(De,Be,ct){return d(De,ct,!1,Be)}function x(De){return LO(De)?e.createParenthesizedExpression(De):De}function D(De){let Be=IR(227,58),ct=km(De),qe=zI(ct);return tc(qe,Be)!==1?e.createParenthesizedExpression(De):De}function w(De){let Be=km(De);return LO(Be)?e.createParenthesizedExpression(De):De}function R(De){let Be=km(De),ct=LO(Be);if(!ct)switch(uN(Be,!1).kind){case 231:case 218:ct=!0}return ct?e.createParenthesizedExpression(De):De}function L(De){let Be=uN(De,!0);switch(Be.kind){case 213:return e.createParenthesizedExpression(De);case 214:return Be.arguments?De:e.createParenthesizedExpression(De)}return F(De)}function F(De,Be){let ct=km(De);return xf(ct)&&(ct.kind!==214||ct.arguments)&&(Be||!S_(ct))?De:Et(e.createParenthesizedExpression(De),De)}function J(De){return xf(De)?De:Et(e.createParenthesizedExpression(De),De)}function G(De){return z$(De)?De:Et(e.createParenthesizedExpression(De),De)}function q(De){let Be=Fs(De,ee);return Et(e.createNodeArray(Be,De.hasTrailingComma),De)}function ee(De){let Be=km(De),ct=zI(Be),qe=IR(226,28);return ct>qe?De:Et(e.createParenthesizedExpression(De),De)}function W(De){let Be=km(De);if(ea(Be)){let qe=Be.expression,et=km(qe).kind;if(et===218||et===219){let Ie=e.updateCallExpression(Be,Et(e.createParenthesizedExpression(qe),qe),Be.typeArguments,Be.arguments);return e.restoreOuterExpressions(De,Ie,8)}}let ct=uN(Be,!1).kind;return ct===210||ct===218?Et(e.createParenthesizedExpression(De),De):De}function pe(De){return!Vs(De)&&(LO(De)||uN(De,!1).kind===210)?Et(e.createParenthesizedExpression(De),De):De}function K(De){switch(De.kind){case 184:case 185:case 194:return e.createParenthesizedType(De)}return De}function re(De){switch(De.kind){case 194:return e.createParenthesizedType(De)}return De}function ue(De){switch(De.kind){case 192:case 193:return e.createParenthesizedType(De)}return K(De)}function ce(De){return e.createNodeArray(Fs(De,ue))}function ne(De){switch(De.kind){case 192:case 193:return e.createParenthesizedType(De)}return ue(De)}function le(De){return e.createNodeArray(Fs(De,ne))}function me(De){switch(De.kind){case 193:return e.createParenthesizedType(De)}return ne(De)}function de(De){switch(De.kind){case 198:return e.createParenthesizedType(De)}return me(De)}function Ae(De){switch(De.kind){case 195:case 198:case 186:return e.createParenthesizedType(De)}return me(De)}function xe(De){return e.createNodeArray(Fs(De,te))}function te(De){return he(De)?e.createParenthesizedType(De):De}function he(De){return bN(De)?De.postfix:hN(De)||Jh(De)||gN(De)||yb(De)?he(De.type):dE(De)?he(De.falseType):Z1(De)||jA(De)?he(Va(De.types)):s2(De)?!!De.typeParameter.constraint&&he(De.typeParameter.constraint):!1}function be(De){return he(De)?e.createParenthesizedType(De):Ae(De)}function Ve(De){return r_e(De)&&De.typeParameters?e.createParenthesizedType(De):De}function Pe(De,Be){return Be===0?Ve(De):De}function ke(De){if(Pt(De))return e.createNodeArray(Fs(De,Pe))}}var zpe={getParenthesizeLeftSideOfBinaryForOperator:e=>ec,getParenthesizeRightSideOfBinaryForOperator:e=>ec,parenthesizeLeftSideOfBinary:(e,t)=>t,parenthesizeRightSideOfBinary:(e,t,n)=>n,parenthesizeExpressionOfComputedPropertyName:ec,parenthesizeConditionOfConditionalExpression:ec,parenthesizeBranchOfConditionalExpression:ec,parenthesizeExpressionOfExportDefault:ec,parenthesizeExpressionOfNew:e=>aa(e,xf),parenthesizeLeftSideOfAccess:e=>aa(e,xf),parenthesizeOperandOfPostfixUnary:e=>aa(e,xf),parenthesizeOperandOfPrefixUnary:e=>aa(e,z$),parenthesizeExpressionsOfCommaDelimitedList:e=>aa(e,zT),parenthesizeExpressionForDisallowedComma:ec,parenthesizeExpressionOfExpressionStatement:ec,parenthesizeConciseBodyOfArrowFunction:ec,parenthesizeCheckTypeOfConditionalType:ec,parenthesizeExtendsTypeOfConditionalType:ec,parenthesizeConstituentTypesOfUnionType:e=>aa(e,zT),parenthesizeConstituentTypeOfUnionType:ec,parenthesizeConstituentTypesOfIntersectionType:e=>aa(e,zT),parenthesizeConstituentTypeOfIntersectionType:ec,parenthesizeOperandOfTypeOperator:ec,parenthesizeOperandOfReadonlyTypeOperator:ec,parenthesizeNonArrayTypeOfPostfixType:ec,parenthesizeElementTypesOfTupleType:e=>aa(e,zT),parenthesizeElementTypeOfTupleType:ec,parenthesizeTypeOfOptionalType:ec,parenthesizeTypeArguments:e=>e&&aa(e,zT),parenthesizeLeadingTypeArgument:ec};function Wpe(e){return{convertToFunctionBlock:t,convertToFunctionExpression:n,convertToClassExpression:i,convertToArrayAssignmentElement:s,convertToObjectAssignmentElement:o,convertToAssignmentPattern:u,convertToObjectAssignmentPattern:m,convertToArrayAssignmentPattern:d,convertToAssignmentElementTarget:S};function t(E,x){if(Vs(E))return E;let D=e.createReturnStatement(E);Et(D,E);let w=e.createBlock([D],x);return Et(w,E),w}function n(E){var x;if(!E.body)return M.fail("Cannot convert a FunctionDeclaration without a body");let D=e.createFunctionExpression((x=qT(E))==null?void 0:x.filter(w=>!OA(w)&&!Dj(w)),E.asteriskToken,E.name,E.typeParameters,E.parameters,E.type,E.body);return zn(D,E),Et(D,E),yO(E)&&bj(D,!0),D}function i(E){var x;let D=e.createClassExpression((x=E.modifiers)==null?void 0:x.filter(w=>!OA(w)&&!Dj(w)),E.name,E.typeParameters,E.heritageClauses,E.members);return zn(D,E),Et(D,E),yO(E)&&bj(D,!0),D}function s(E){if(Xa(E)){if(E.dotDotDotToken)return M.assertNode(E.name,He),zn(Et(e.createSpreadElement(E.name),E),E);let x=S(E.name);return E.initializer?zn(Et(e.createAssignment(x,E.initializer),E),E):x}return aa(E,Ct)}function o(E){if(Xa(E)){if(E.dotDotDotToken)return M.assertNode(E.name,He),zn(Et(e.createSpreadAssignment(E.name),E),E);if(E.propertyName){let x=S(E.name);return zn(Et(e.createPropertyAssignment(E.propertyName,E.initializer?e.createAssignment(x,E.initializer):x),E),E)}return M.assertNode(E.name,He),zn(Et(e.createShorthandPropertyAssignment(E.name,E.initializer),E),E)}return aa(E,p0)}function u(E){switch(E.kind){case 207:case 209:return d(E);case 206:case 210:return m(E)}}function m(E){return Yp(E)?zn(Et(e.createObjectLiteralExpression(Cr(E.elements,o)),E),E):aa(E,Ca)}function d(E){return Lv(E)?zn(Et(e.createArrayLiteralExpression(Cr(E.elements,s)),E),E):aa(E,Gu)}function S(E){return Hs(E)?u(E):aa(E,Ct)}}var $pe={convertToFunctionBlock:_a,convertToFunctionExpression:_a,convertToClassExpression:_a,convertToArrayAssignmentElement:_a,convertToObjectAssignmentElement:_a,convertToAssignmentPattern:_a,convertToObjectAssignmentPattern:_a,convertToArrayAssignmentPattern:_a,convertToAssignmentElementTarget:_a},BG=0,Hpe=(e=>(e[e.None=0]="None",e[e.NoParenthesizerRules=1]="NoParenthesizerRules",e[e.NoNodeConverters=2]="NoNodeConverters",e[e.NoIndentationOnFreshPropertyAccess=4]="NoIndentationOnFreshPropertyAccess",e[e.NoOriginalNode=8]="NoOriginalNode",e))(Hpe||{}),_4e=[];function f4e(e){_4e.push(e)}function t8(e,t){let n=e&8?ec:zn,i=tf(()=>e&1?zpe:qpe(J)),s=tf(()=>e&2?$pe:Wpe(J)),o=Ih(P=>(B,Y)=>nn(B,P,Y)),u=Ih(P=>B=>yt(P,B)),m=Ih(P=>B=>Xt(B,P)),d=Ih(P=>()=>Ls(P)),S=Ih(P=>B=>M2(P,B)),E=Ih(P=>(B,Y)=>yn(P,B,Y)),x=Ih(P=>(B,Y)=>U0(P,B,Y)),D=Ih(P=>(B,Y)=>yp(P,B,Y)),w=Ih(P=>(B,Y)=>uh(P,B,Y)),R=Ih(P=>(B,Y,ge)=>gS(P,B,Y,ge)),L=Ih(P=>(B,Y,ge)=>TD(P,B,Y,ge)),F=Ih(P=>(B,Y,ge,rt)=>nl(P,B,Y,ge,rt)),J={get parenthesizer(){return i()},get converters(){return s()},baseFactory:t,flags:e,createNodeArray:G,createNumericLiteral:pe,createBigIntLiteral:K,createStringLiteral:ue,createStringLiteralFromNode:ce,createRegularExpressionLiteral:ne,createLiteralLikeNode:le,createIdentifier:Ae,createTempVariable:xe,createLoopVariable:te,createUniqueName:he,getGeneratedNameForNode:be,createPrivateIdentifier:Pe,createUniquePrivateName:De,getGeneratedPrivateNameForNode:Be,createToken:qe,createSuper:et,createThis:Ie,createNull:_t,createTrue:mt,createFalse:Xe,createModifier:ht,createModifiersFromModifierFlags:rr,createQualifiedName:vr,updateQualifiedName:xr,createComputedPropertyName:jr,updateComputedPropertyName:ur,createTypeParameterDeclaration:or,updateTypeParameterDeclaration:Zr,createParameterDeclaration:Oi,updateParameterDeclaration:Sr,createDecorator:Pi,updateDecorator:Cs,createPropertySignature:ss,updatePropertySignature:Ii,createPropertyDeclaration:Xs,updatePropertyDeclaration:$e,createMethodSignature:Yt,updateMethodSignature:Vr,createMethodDeclaration:An,updateMethodDeclaration:vi,createConstructorDeclaration:yr,updateConstructorDeclaration:to,createGetAccessorDeclaration:St,updateGetAccessorDeclaration:fe,createSetAccessorDeclaration:Ce,updateSetAccessorDeclaration:nt,createCallSignature:tt,updateCallSignature:ft,createConstructSignature:tr,updateConstructSignature:Oe,createIndexSignature:At,updateIndexSignature:Nt,createClassStaticBlockDeclaration:Ui,updateClassStaticBlockDeclaration:la,createTemplateLiteralTypeSpan:Ut,updateTemplateLiteralTypeSpan:Rt,createKeywordTypeNode:nr,createTypePredicateNode:Z,updateTypePredicateNode:Ge,createTypeReferenceNode:bt,updateTypeReferenceNode:Q,createFunctionTypeNode:Ke,updateFunctionTypeNode:z,createConstructorTypeNode:Te,updateConstructorTypeNode:$t,createTypeQueryNode:qr,updateTypeQueryNode:Hr,createTypeLiteralNode:dn,updateTypeLiteralNode:Ar,createArrayTypeNode:In,updateArrayTypeNode:Ki,createTupleTypeNode:ls,updateTupleTypeNode:Yn,createNamedTupleMember:pi,updateNamedTupleMember:Er,createOptionalTypeNode:tn,updateOptionalTypeNode:er,createRestTypeNode:qs,updateRestTypeNode:uo,createUnionTypeNode:ms,updateUnionTypeNode:sa,createIntersectionTypeNode:Sc,updateIntersectionTypeNode:ts,createConditionalTypeNode:zi,updateConditionalTypeNode:Eu,createInferTypeNode:kc,updateInferTypeNode:P_,createImportTypeNode:Fa,updateImportTypeNode:bc,createParenthesizedType:Lo,updateParenthesizedType:po,createThisTypeNode:_r,createTypeOperatorNode:Jc,updateTypeOperatorNode:z_,createIndexedAccessTypeNode:W_,updateIndexedAccessTypeNode:qf,createMappedTypeNode:mc,updateMappedTypeNode:tl,createLiteralTypeNode:Se,updateLiteralTypeNode:ae,createTemplateLiteralType:el,updateTemplateLiteralType:Xu,createObjectBindingPattern:Ye,updateObjectBindingPattern:Ot,createArrayBindingPattern:Tr,updateArrayBindingPattern:Vn,createBindingElement:pr,updateBindingElement:Jn,createArrayLiteralExpression:Ri,updateArrayLiteralExpression:Ai,createObjectLiteralExpression:Na,updateObjectLiteralExpression:gc,createPropertyAccessExpression:e&4?(P,B)=>Tn(Oc(P,B),262144):Oc,updatePropertyAccessExpression:du,createPropertyAccessChain:e&4?(P,B,Y)=>Tn(hc(P,B,Y),262144):hc,updatePropertyAccessChain:mu,createElementAccessExpression:rl,updateElementAccessExpression:$l,createElementAccessChain:nd,updateElementAccessChain:Je,createCallExpression:Gr,updateCallExpression:gs,createCallChain:Qa,updateCallChain:so,createNewExpression:fl,updateNewExpression:au,createTaggedTemplateExpression:Uo,updateTaggedTemplateExpression:Fo,createTypeAssertion:Cl,updateTypeAssertion:Wf,createParenthesizedExpression:fg,updateParenthesizedExpression:id,createFunctionExpression:If,updateFunctionExpression:wd,createArrowFunction:sd,updateArrowFunction:Gh,createDeleteExpression:Yh,updateDeleteExpression:Of,createTypeOfExpression:Hl,updateTypeOfExpression:Kh,createVoidExpression:$f,updateVoidExpression:nh,createAwaitExpression:ad,updateAwaitExpression:oe,createPrefixUnaryExpression:yt,updatePrefixUnaryExpression:Gt,createPostfixUnaryExpression:Xt,updatePostfixUnaryExpression:Fr,createBinaryExpression:nn,updateBinaryExpression:Si,createConditionalExpression:$,updateConditionalExpression:Fe,createTemplateExpression:jt,updateTemplateExpression:Xr,createTemplateHead:Wa,createTemplateMiddle:qc,createTemplateTail:Id,createNoSubstitutionTemplateLiteral:Om,createTemplateLiteralLikeNode:vo,createYieldExpression:Xh,updateYieldExpression:Vy,createSpreadElement:$v,updateSpreadElement:Jy,createClassExpression:Od,updateClassExpression:od,createOmittedExpression:Vo,createExpressionWithTypeArguments:d_,updateExpressionWithTypeArguments:$_,createAsExpression:Rm,updateAsExpression:Hv,createNonNullExpression:O0,updateNonNullExpression:pS,createSatisfiesExpression:cm,updateSatisfiesExpression:dS,createNonNullChain:lm,updateNonNullChain:Vb,createMetaProperty:pg,updateMetaProperty:cd,createTemplateSpan:R0,updateTemplateSpan:We,createSemicolonClassElement:st,createBlock:Jt,updateBlock:sr,createVariableStatement:kr,updateVariableStatement:_n,createEmptyStatement:Ir,createExpressionStatement:kn,updateExpressionStatement:ji,createIfStatement:En,updateIfStatement:Ni,createDoStatement:an,updateDoStatement:Ds,createWhileStatement:wa,updateWhileStatement:xu,createForStatement:N_,updateForStatement:um,createForInStatement:Gv,updateForInStatement:_m,createForOfStatement:Sk,updateForOfStatement:mD,createContinueStatement:bk,updateContinueStatement:FE,createBreakStatement:Jb,updateBreakStatement:qb,createReturnStatement:zb,updateReturnStatement:P2,createWithStatement:Yv,updateWithStatement:jE,createSwitchStatement:qy,updateSwitchStatement:BE,createLabeledStatement:_o,updateLabeledStatement:N2,createThrowStatement:D2,updateThrowStatement:Wb,createTryStatement:M0,updateTryStatement:ih,createDebuggerStatement:Rd,createVariableDeclaration:Rf,updateVariableDeclaration:hp,createVariableDeclarationList:Hf,updateVariableDeclarationList:Kv,createFunctionDeclaration:Tk,updateFunctionDeclaration:Ek,createClassDeclaration:Xv,updateClassDeclaration:Hb,createInterfaceDeclaration:xk,updateInterfaceDeclaration:ou,createTypeAliasDeclaration:Qv,updateTypeAliasDeclaration:Ck,createEnumDeclaration:dg,updateEnumDeclaration:w2,createModuleDeclaration:Qe,updateModuleDeclaration:Mm,createModuleBlock:Cu,updateModuleBlock:Gb,createCaseBlock:Qh,updateCaseBlock:Md,createNamespaceExportDeclaration:sh,updateNamespaceExportDeclaration:L0,createImportEqualsDeclaration:Za,updateImportEqualsDeclaration:Lm,createImportDeclaration:UE,updateImportDeclaration:I2,createImportClause:O2,updateImportClause:Yb,createAssertClause:F0,updateAssertClause:j0,createAssertEntry:Kb,updateAssertEntry:ld,createImportTypeAssertionContainer:Ip,updateImportTypeAssertionContainer:Zv,createImportAttributes:e1,updateImportAttributes:as,createImportAttribute:qn,updateImportAttribute:m_,createNamespaceImport:gD,updateNamespaceImport:Fm,createNamespaceExport:Ak,updateNamespaceExport:Zh,createNamedImports:t1,updateNamedImports:B0,createImportSpecifier:hD,updateImportSpecifier:Xb,createExportAssignment:Op,updateExportAssignment:VE,createExportDeclaration:sc,updateExportDeclaration:zy,createNamedExports:R2,updateNamedExports:JE,createExportSpecifier:kk,updateExportSpecifier:J6,createMissingDeclaration:vD,createExternalModuleReference:Mn,updateExternalModuleReference:D_,get createJSDocAllType(){return d(312)},get createJSDocUnknownType(){return d(313)},get createJSDocNonNullableType(){return x(315)},get updateJSDocNonNullableType(){return D(315)},get createJSDocNullableType(){return x(314)},get updateJSDocNullableType(){return D(314)},get createJSDocOptionalType(){return S(316)},get updateJSDocOptionalType(){return E(316)},get createJSDocVariadicType(){return S(318)},get updateJSDocVariadicType(){return E(318)},get createJSDocNamepathType(){return S(319)},get updateJSDocNamepathType(){return E(319)},createJSDocFunctionType:Pk,updateJSDocFunctionType:Nk,createJSDocTypeLiteral:H_,updateJSDocTypeLiteral:jm,createJSDocTypeExpression:fm,updateJSDocTypeExpression:r1,createJSDocSignature:qE,updateJSDocSignature:ah,createJSDocTemplateTag:Wy,updateJSDocTemplateTag:Qb,createJSDocTypedefTag:Dk,updateJSDocTypedefTag:L2,createJSDocParameterTag:zE,updateJSDocParameterTag:SD,createJSDocPropertyTag:F2,updateJSDocPropertyTag:Zb,createJSDocCallbackTag:Bm,updateJSDocCallbackTag:bD,createJSDocOverloadTag:eT,updateJSDocOverloadTag:mS,createJSDocAugmentsTag:V0,updateJSDocAugmentsTag:n1,createJSDocImplementsTag:pm,updateJSDocImplementsTag:Ik,createJSDocSeeTag:i1,updateJSDocSeeTag:tT,createJSDocImportTag:G_,updateJSDocImportTag:j2,createJSDocNameReference:wu,updateJSDocNameReference:J0,createJSDocMemberName:ch,updateJSDocMemberName:pl,createJSDocLink:Au,updateJSDocLink:q0,createJSDocLinkCode:Gf,updateJSDocLinkCode:Fd,createJSDocLinkPlain:wk,updateJSDocLinkPlain:lh,get createJSDocTypeTag(){return L(344)},get updateJSDocTypeTag(){return F(344)},get createJSDocReturnTag(){return L(342)},get updateJSDocReturnTag(){return F(342)},get createJSDocThisTag(){return L(343)},get updateJSDocThisTag(){return F(343)},get createJSDocAuthorTag(){return w(330)},get updateJSDocAuthorTag(){return R(330)},get createJSDocClassTag(){return w(332)},get updateJSDocClassTag(){return R(332)},get createJSDocPublicTag(){return w(333)},get updateJSDocPublicTag(){return R(333)},get createJSDocPrivateTag(){return w(334)},get updateJSDocPrivateTag(){return R(334)},get createJSDocProtectedTag(){return w(335)},get updateJSDocProtectedTag(){return R(335)},get createJSDocReadonlyTag(){return w(336)},get updateJSDocReadonlyTag(){return R(336)},get createJSDocOverrideTag(){return w(337)},get updateJSDocOverrideTag(){return R(337)},get createJSDocDeprecatedTag(){return w(331)},get updateJSDocDeprecatedTag(){return R(331)},get createJSDocThrowsTag(){return L(349)},get updateJSDocThrowsTag(){return F(349)},get createJSDocSatisfiesTag(){return L(350)},get updateJSDocSatisfiesTag(){return F(350)},createJSDocEnumTag:rT,updateJSDocEnumTag:q6,createJSDocUnknownTag:ED,updateJSDocUnknownTag:xD,createJSDocText:WE,updateJSDocText:nT,createJSDocComment:Mf,updateJSDocComment:z6,createJsxElement:iT,updateJsxElement:CD,createJsxSelfClosingElement:sT,updateJsxSelfClosingElement:$E,createJsxOpeningElement:Ok,updateJsxOpeningElement:B2,createJsxClosingElement:ud,updateJsxClosingElement:AD,createJsxFragment:hS,createJsxText:mg,updateJsxText:U2,createJsxOpeningFragment:V2,createJsxJsxClosingFragment:ro,updateJsxFragment:Rp,createJsxAttribute:jn,updateJsxAttribute:_d,createJsxAttributes:Qu,updateJsxAttributes:kD,createJsxSpreadAttribute:PD,updateJsxSpreadAttribute:aT,createJsxExpression:yS,updateJsxExpression:ND,createJsxNamespacedName:vS,updateJsxNamespacedName:Um,createCaseClause:Mp,updateCaseClause:ey,createDefaultClause:_h,updateDefaultClause:z0,createHeritageClause:J2,updateHeritageClause:Ll,createCatchClause:Vm,updateCatchClause:Lp,createPropertyAssignment:s1,updatePropertyAssignment:fd,createShorthandPropertyAssignment:SS,updateShorthandPropertyAssignment:O,createSpreadAssignment:Dt,updateSpreadAssignment:Zt,createEnumMember:bi,updateEnumMember:ys,createSourceFile:fs,updateSourceFile:HE,createRedirectedSourceFile:As,createBundle:Sp,updateBundle:gg,createSyntheticExpression:W0,createSyntaxList:GE,createNotEmittedStatement:DD,createPartiallyEmittedExpression:$0,updatePartiallyEmittedExpression:oT,createCommaListExpression:bS,updateCommaListExpression:rs,createSyntheticReferenceExpression:TS,updateSyntheticReferenceExpression:ln,cloneNode:OD,get createComma(){return o(28)},get createAssignment(){return o(64)},get createLogicalOr(){return o(57)},get createLogicalAnd(){return o(56)},get createBitwiseOr(){return o(52)},get createBitwiseXor(){return o(53)},get createBitwiseAnd(){return o(51)},get createStrictEquality(){return o(37)},get createStrictInequality(){return o(38)},get createEquality(){return o(35)},get createInequality(){return o(36)},get createLessThan(){return o(30)},get createLessThanEquals(){return o(33)},get createGreaterThan(){return o(32)},get createGreaterThanEquals(){return o(34)},get createLeftShift(){return o(48)},get createRightShift(){return o(49)},get createUnsignedRightShift(){return o(50)},get createAdd(){return o(40)},get createSubtract(){return o(41)},get createMultiply(){return o(42)},get createDivide(){return o(44)},get createModulo(){return o(45)},get createExponent(){return o(43)},get createPrefixPlus(){return u(40)},get createPrefixMinus(){return u(41)},get createPrefixIncrement(){return u(46)},get createPrefixDecrement(){return u(47)},get createBitwiseNot(){return u(55)},get createLogicalNot(){return u(54)},get createPostfixIncrement(){return m(46)},get createPostfixDecrement(){return m(47)},createImmediatelyInvokedFunctionExpression:aJ,createImmediatelyInvokedArrowFunction:oJ,createVoidZero:ty,createExportDefault:p7,createExternalModuleExport:$6,createTypeCheck:H6,createIsNotTypeCheck:d7,createMethodCall:cT,createGlobalMethodCall:KE,createFunctionBindCall:m7,createFunctionCallCall:YE,createFunctionApplyCall:H0,createArraySliceCall:dm,createArrayConcatCall:RD,createObjectDefinePropertyCall:g7,createObjectGetOwnPropertyDescriptorCall:ry,createReflectGetCall:z2,createReflectSetCall:h7,createPropertyDescriptor:G6,createCallBinding:Le,createAssignmentTargetWrapper:it,inlineExpressions:Lt,getInternalName:Rr,getLocalName:ni,getExportName:Xi,getDeclarationName:Li,getNamespaceMemberName:xi,getExternalModuleOrNamespaceExportName:us,restoreOuterExpressions:Mk,restoreEnclosingLabel:Lk,createUseStrictPrologue:$a,copyPrologue:zo,copyStandardPrologue:pd,copyCustomPrologue:hg,ensureUseStrict:G0,liftToBlock:ES,mergeLexicalEnvironment:lT,replaceModifiers:Y6,replaceDecoratorsAndModifiers:MD,replacePropertyName:y7};return kt(_4e,P=>P(J)),J;function G(P,B){if(P===void 0||P===ve)P=[];else if(zT(P)){if(B===void 0||P.hasTrailingComma===B)return P.transformFlags===void 0&&d4e(P),M.attachNodeArrayDebugInfo(P),P;let rt=P.slice();return rt.pos=P.pos,rt.end=P.end,rt.hasTrailingComma=B,rt.transformFlags=P.transformFlags,M.attachNodeArrayDebugInfo(rt),rt}let Y=P.length,ge=Y>=1&&Y<=4?P.slice():P;return ge.pos=-1,ge.end=-1,ge.hasTrailingComma=!!B,ge.transformFlags=0,d4e(ge),M.attachNodeArrayDebugInfo(ge),ge}function q(P){return t.createBaseNode(P)}function ee(P){let B=q(P);return B.symbol=void 0,B.localSymbol=void 0,B}function W(P,B){return P!==B&&(P.typeArguments=B.typeArguments),vn(P,B)}function pe(P,B=0){let Y=typeof P=="number"?P+"":P;M.assert(Y.charCodeAt(0)!==45,"Negative numbers should be created in combination with createPrefixUnaryExpression");let ge=ee(9);return ge.text=Y,ge.numericLiteralFlags=B,B&384&&(ge.transformFlags|=1024),ge}function K(P){let B=ct(10);return B.text=typeof P=="string"?P:uE(P)+"n",B.transformFlags|=32,B}function re(P,B){let Y=ee(11);return Y.text=P,Y.singleQuote=B,Y}function ue(P,B,Y){let ge=re(P,B);return ge.hasExtendedUnicodeEscape=Y,Y&&(ge.transformFlags|=1024),ge}function ce(P){let B=re(Qd(P),void 0);return B.textSourceNode=P,B}function ne(P){let B=ct(14);return B.text=P,B}function le(P,B){switch(P){case 9:return pe(B,0);case 10:return K(B);case 11:return ue(B,void 0);case 12:return mg(B,!1);case 13:return mg(B,!0);case 14:return ne(B);case 15:return vo(P,B,void 0,0)}}function me(P){let B=t.createBaseIdentifierNode(80);return B.escapedText=P,B.jsDoc=void 0,B.flowNode=void 0,B.symbol=void 0,B}function de(P,B,Y,ge){let rt=me(Uc(P));return a8(rt,{flags:B,id:BG,prefix:Y,suffix:ge}),BG++,rt}function Ae(P,B,Y){B===void 0&&P&&(B=JT(P)),B===80&&(B=void 0);let ge=me(Uc(P));return Y&&(ge.flags|=256),ge.escapedText==="await"&&(ge.transformFlags|=67108864),ge.flags&256&&(ge.transformFlags|=1024),ge}function xe(P,B,Y,ge){let rt=1;B&&(rt|=8);let Qt=de("",rt,Y,ge);return P&&P(Qt),Qt}function te(P){let B=2;return P&&(B|=8),de("",B,void 0,void 0)}function he(P,B=0,Y,ge){return M.assert(!(B&7),"Argument out of range: flags"),M.assert((B&48)!==32,"GeneratedIdentifierFlags.FileLevel cannot be set without also setting GeneratedIdentifierFlags.Optimistic"),de(P,3|B,Y,ge)}function be(P,B=0,Y,ge){M.assert(!(B&7),"Argument out of range: flags");let rt=P?Cy(P)?xb(!1,Y,P,ge,Nn):`generated@${yo(P)}`:"";(Y||ge)&&(B|=16);let Qt=de(rt,4|B,Y,ge);return Qt.original=P,Qt}function Ve(P){let B=t.createBasePrivateIdentifierNode(81);return B.escapedText=P,B.transformFlags|=16777216,B}function Pe(P){return _s(P,"#")||M.fail("First character of private identifier must be #: "+P),Ve(Uc(P))}function ke(P,B,Y,ge){let rt=Ve(Uc(P));return a8(rt,{flags:B,id:BG,prefix:Y,suffix:ge}),BG++,rt}function De(P,B,Y){P&&!_s(P,"#")&&M.fail("First character of private identifier must be #: "+P);let ge=8|(P?3:1);return ke(P??"",ge,B,Y)}function Be(P,B,Y){let ge=Cy(P)?xb(!0,B,P,Y,Nn):`#generated@${yo(P)}`,Qt=ke(ge,4|(B||Y?16:0),B,Y);return Qt.original=P,Qt}function ct(P){return t.createBaseTokenNode(P)}function qe(P){M.assert(P>=0&&P<=165,"Invalid token"),M.assert(P<=15||P>=18,"Invalid token. Use 'createTemplateLiteralLikeNode' to create template literals."),M.assert(P<=9||P>=15,"Invalid token. Use 'createLiteralLikeNode' to create literals."),M.assert(P!==80,"Invalid token. Use 'createIdentifier' to create identifiers");let B=ct(P),Y=0;switch(P){case 134:Y=384;break;case 160:Y=4;break;case 125:case 123:case 124:case 148:case 128:case 138:case 87:case 133:case 150:case 163:case 146:case 151:case 103:case 147:case 164:case 154:case 136:case 155:case 116:case 159:case 157:Y=1;break;case 108:Y=134218752,B.flowNode=void 0;break;case 126:Y=1024;break;case 129:Y=16777216;break;case 110:Y=16384,B.flowNode=void 0;break}return Y&&(B.transformFlags|=Y),B}function et(){return qe(108)}function Ie(){return qe(110)}function _t(){return qe(106)}function mt(){return qe(112)}function Xe(){return qe(97)}function ht(P){return qe(P)}function rr(P){let B=[];return P&32&&B.push(ht(95)),P&128&&B.push(ht(138)),P&2048&&B.push(ht(90)),P&4096&&B.push(ht(87)),P&1&&B.push(ht(125)),P&2&&B.push(ht(123)),P&4&&B.push(ht(124)),P&64&&B.push(ht(128)),P&256&&B.push(ht(126)),P&16&&B.push(ht(164)),P&8&&B.push(ht(148)),P&512&&B.push(ht(129)),P&1024&&B.push(ht(134)),P&8192&&B.push(ht(103)),P&16384&&B.push(ht(147)),B.length?B:void 0}function vr(P,B){let Y=q(166);return Y.left=P,Y.right=cu(B),Y.transformFlags|=Rn(Y.left)|r8(Y.right),Y.flowNode=void 0,Y}function xr(P,B,Y){return P.left!==B||P.right!==Y?vn(vr(B,Y),P):P}function jr(P){let B=q(167);return B.expression=i().parenthesizeExpressionOfComputedPropertyName(P),B.transformFlags|=Rn(B.expression)|1024|131072,B}function ur(P,B){return P.expression!==B?vn(jr(B),P):P}function or(P,B,Y,ge){let rt=ee(168);return rt.modifiers=oo(P),rt.name=cu(B),rt.constraint=Y,rt.default=ge,rt.transformFlags=1,rt.expression=void 0,rt.jsDoc=void 0,rt}function Zr(P,B,Y,ge,rt){return P.modifiers!==B||P.name!==Y||P.constraint!==ge||P.default!==rt?vn(or(B,Y,ge,rt),P):P}function Oi(P,B,Y,ge,rt,Qt){let fn=ee(169);return fn.modifiers=oo(P),fn.dotDotDotToken=B,fn.name=cu(Y),fn.questionToken=ge,fn.type=rt,fn.initializer=yg(Qt),z1(fn.name)?fn.transformFlags=1:fn.transformFlags=eo(fn.modifiers)|Rn(fn.dotDotDotToken)|X1(fn.name)|Rn(fn.questionToken)|Rn(fn.initializer)|(fn.questionToken??fn.type?1:0)|(fn.dotDotDotToken??fn.initializer?1024:0)|(Vg(fn.modifiers)&31?8192:0),fn.jsDoc=void 0,fn}function Sr(P,B,Y,ge,rt,Qt,fn){return P.modifiers!==B||P.dotDotDotToken!==Y||P.name!==ge||P.questionToken!==rt||P.type!==Qt||P.initializer!==fn?vn(Oi(B,Y,ge,rt,Qt,fn),P):P}function Pi(P){let B=q(170);return B.expression=i().parenthesizeLeftSideOfAccess(P,!1),B.transformFlags|=Rn(B.expression)|1|8192|33554432,B}function Cs(P,B){return P.expression!==B?vn(Pi(B),P):P}function ss(P,B,Y,ge){let rt=ee(171);return rt.modifiers=oo(P),rt.name=cu(B),rt.type=ge,rt.questionToken=Y,rt.transformFlags=1,rt.initializer=void 0,rt.jsDoc=void 0,rt}function Ii(P,B,Y,ge,rt){return P.modifiers!==B||P.name!==Y||P.questionToken!==ge||P.type!==rt?$r(ss(B,Y,ge,rt),P):P}function $r(P,B){return P!==B&&(P.initializer=B.initializer),vn(P,B)}function Xs(P,B,Y,ge,rt){let Qt=ee(172);Qt.modifiers=oo(P),Qt.name=cu(B),Qt.questionToken=Y&&Q1(Y)?Y:void 0,Qt.exclamationToken=Y&&l8(Y)?Y:void 0,Qt.type=ge,Qt.initializer=yg(rt);let fn=Qt.flags&33554432||Vg(Qt.modifiers)&128;return Qt.transformFlags=eo(Qt.modifiers)|X1(Qt.name)|Rn(Qt.initializer)|(fn||Qt.questionToken||Qt.exclamationToken||Qt.type?1:0)|(za(Qt.name)||Vg(Qt.modifiers)&256&&Qt.initializer?8192:0)|16777216,Qt.jsDoc=void 0,Qt}function $e(P,B,Y,ge,rt,Qt){return P.modifiers!==B||P.name!==Y||P.questionToken!==(ge!==void 0&&Q1(ge)?ge:void 0)||P.exclamationToken!==(ge!==void 0&&l8(ge)?ge:void 0)||P.type!==rt||P.initializer!==Qt?vn(Xs(B,Y,ge,rt,Qt),P):P}function Yt(P,B,Y,ge,rt,Qt){let fn=ee(173);return fn.modifiers=oo(P),fn.name=cu(B),fn.questionToken=Y,fn.typeParameters=oo(ge),fn.parameters=oo(rt),fn.type=Qt,fn.transformFlags=1,fn.jsDoc=void 0,fn.locals=void 0,fn.nextContainer=void 0,fn.typeArguments=void 0,fn}function Vr(P,B,Y,ge,rt,Qt,fn){return P.modifiers!==B||P.name!==Y||P.questionToken!==ge||P.typeParameters!==rt||P.parameters!==Qt||P.type!==fn?W(Yt(B,Y,ge,rt,Qt,fn),P):P}function An(P,B,Y,ge,rt,Qt,fn,Ts){let Xo=ee(174);if(Xo.modifiers=oo(P),Xo.asteriskToken=B,Xo.name=cu(Y),Xo.questionToken=ge,Xo.exclamationToken=void 0,Xo.typeParameters=oo(rt),Xo.parameters=G(Qt),Xo.type=fn,Xo.body=Ts,!Xo.body)Xo.transformFlags=1;else{let Jm=Vg(Xo.modifiers)&1024,qm=!!Xo.asteriskToken,ny=Jm&&qm;Xo.transformFlags=eo(Xo.modifiers)|Rn(Xo.asteriskToken)|X1(Xo.name)|Rn(Xo.questionToken)|eo(Xo.typeParameters)|eo(Xo.parameters)|Rn(Xo.type)|Rn(Xo.body)&-67108865|(ny?128:Jm?256:qm?2048:0)|(Xo.questionToken||Xo.typeParameters||Xo.type?1:0)|1024}return Xo.typeArguments=void 0,Xo.jsDoc=void 0,Xo.locals=void 0,Xo.nextContainer=void 0,Xo.flowNode=void 0,Xo.endFlowNode=void 0,Xo.returnFlowNode=void 0,Xo}function vi(P,B,Y,ge,rt,Qt,fn,Ts,Xo){return P.modifiers!==B||P.asteriskToken!==Y||P.name!==ge||P.questionToken!==rt||P.typeParameters!==Qt||P.parameters!==fn||P.type!==Ts||P.body!==Xo?Ci(An(B,Y,ge,rt,Qt,fn,Ts,Xo),P):P}function Ci(P,B){return P!==B&&(P.exclamationToken=B.exclamationToken),vn(P,B)}function Ui(P){let B=ee(175);return B.body=P,B.transformFlags=Rn(P)|16777216,B.modifiers=void 0,B.jsDoc=void 0,B.locals=void 0,B.nextContainer=void 0,B.endFlowNode=void 0,B.returnFlowNode=void 0,B}function la(P,B){return P.body!==B?Gs(Ui(B),P):P}function Gs(P,B){return P!==B&&(P.modifiers=B.modifiers),vn(P,B)}function yr(P,B,Y){let ge=ee(176);return ge.modifiers=oo(P),ge.parameters=G(B),ge.body=Y,ge.transformFlags=eo(ge.modifiers)|eo(ge.parameters)|Rn(ge.body)&-67108865|1024,ge.typeParameters=void 0,ge.type=void 0,ge.typeArguments=void 0,ge.jsDoc=void 0,ge.locals=void 0,ge.nextContainer=void 0,ge.endFlowNode=void 0,ge.returnFlowNode=void 0,ge}function to(P,B,Y,ge){return P.modifiers!==B||P.parameters!==Y||P.body!==ge?lt(yr(B,Y,ge),P):P}function lt(P,B){return P!==B&&(P.typeParameters=B.typeParameters,P.type=B.type),W(P,B)}function St(P,B,Y,ge,rt){let Qt=ee(177);return Qt.modifiers=oo(P),Qt.name=cu(B),Qt.parameters=G(Y),Qt.type=ge,Qt.body=rt,Qt.body?Qt.transformFlags=eo(Qt.modifiers)|X1(Qt.name)|eo(Qt.parameters)|Rn(Qt.type)|Rn(Qt.body)&-67108865|(Qt.type?1:0):Qt.transformFlags=1,Qt.typeArguments=void 0,Qt.typeParameters=void 0,Qt.jsDoc=void 0,Qt.locals=void 0,Qt.nextContainer=void 0,Qt.flowNode=void 0,Qt.endFlowNode=void 0,Qt.returnFlowNode=void 0,Qt}function fe(P,B,Y,ge,rt,Qt){return P.modifiers!==B||P.name!==Y||P.parameters!==ge||P.type!==rt||P.body!==Qt?vt(St(B,Y,ge,rt,Qt),P):P}function vt(P,B){return P!==B&&(P.typeParameters=B.typeParameters),W(P,B)}function Ce(P,B,Y,ge){let rt=ee(178);return rt.modifiers=oo(P),rt.name=cu(B),rt.parameters=G(Y),rt.body=ge,rt.body?rt.transformFlags=eo(rt.modifiers)|X1(rt.name)|eo(rt.parameters)|Rn(rt.body)&-67108865|(rt.type?1:0):rt.transformFlags=1,rt.typeArguments=void 0,rt.typeParameters=void 0,rt.type=void 0,rt.jsDoc=void 0,rt.locals=void 0,rt.nextContainer=void 0,rt.flowNode=void 0,rt.endFlowNode=void 0,rt.returnFlowNode=void 0,rt}function nt(P,B,Y,ge,rt){return P.modifiers!==B||P.name!==Y||P.parameters!==ge||P.body!==rt?Me(Ce(B,Y,ge,rt),P):P}function Me(P,B){return P!==B&&(P.typeParameters=B.typeParameters,P.type=B.type),W(P,B)}function tt(P,B,Y){let ge=ee(179);return ge.typeParameters=oo(P),ge.parameters=oo(B),ge.type=Y,ge.transformFlags=1,ge.jsDoc=void 0,ge.locals=void 0,ge.nextContainer=void 0,ge.typeArguments=void 0,ge}function ft(P,B,Y,ge){return P.typeParameters!==B||P.parameters!==Y||P.type!==ge?W(tt(B,Y,ge),P):P}function tr(P,B,Y){let ge=ee(180);return ge.typeParameters=oo(P),ge.parameters=oo(B),ge.type=Y,ge.transformFlags=1,ge.jsDoc=void 0,ge.locals=void 0,ge.nextContainer=void 0,ge.typeArguments=void 0,ge}function Oe(P,B,Y,ge){return P.typeParameters!==B||P.parameters!==Y||P.type!==ge?W(tr(B,Y,ge),P):P}function At(P,B,Y){let ge=ee(181);return ge.modifiers=oo(P),ge.parameters=oo(B),ge.type=Y,ge.transformFlags=1,ge.jsDoc=void 0,ge.locals=void 0,ge.nextContainer=void 0,ge.typeArguments=void 0,ge}function Nt(P,B,Y,ge){return P.parameters!==Y||P.type!==ge||P.modifiers!==B?W(At(B,Y,ge),P):P}function Ut(P,B){let Y=q(204);return Y.type=P,Y.literal=B,Y.transformFlags=1,Y}function Rt(P,B,Y){return P.type!==B||P.literal!==Y?vn(Ut(B,Y),P):P}function nr(P){return qe(P)}function Z(P,B,Y){let ge=q(182);return ge.assertsModifier=P,ge.parameterName=cu(B),ge.type=Y,ge.transformFlags=1,ge}function Ge(P,B,Y,ge){return P.assertsModifier!==B||P.parameterName!==Y||P.type!==ge?vn(Z(B,Y,ge),P):P}function bt(P,B){let Y=q(183);return Y.typeName=cu(P),Y.typeArguments=B&&i().parenthesizeTypeArguments(G(B)),Y.transformFlags=1,Y}function Q(P,B,Y){return P.typeName!==B||P.typeArguments!==Y?vn(bt(B,Y),P):P}function Ke(P,B,Y){let ge=ee(184);return ge.typeParameters=oo(P),ge.parameters=oo(B),ge.type=Y,ge.transformFlags=1,ge.modifiers=void 0,ge.jsDoc=void 0,ge.locals=void 0,ge.nextContainer=void 0,ge.typeArguments=void 0,ge}function z(P,B,Y,ge){return P.typeParameters!==B||P.parameters!==Y||P.type!==ge?Ue(Ke(B,Y,ge),P):P}function Ue(P,B){return P!==B&&(P.modifiers=B.modifiers),W(P,B)}function Te(...P){return P.length===4?Re(...P):P.length===3?It(...P):M.fail("Incorrect number of arguments specified.")}function Re(P,B,Y,ge){let rt=ee(185);return rt.modifiers=oo(P),rt.typeParameters=oo(B),rt.parameters=oo(Y),rt.type=ge,rt.transformFlags=1,rt.jsDoc=void 0,rt.locals=void 0,rt.nextContainer=void 0,rt.typeArguments=void 0,rt}function It(P,B,Y){return Re(void 0,P,B,Y)}function $t(...P){return P.length===5?Ht(...P):P.length===4?dr(...P):M.fail("Incorrect number of arguments specified.")}function Ht(P,B,Y,ge,rt){return P.modifiers!==B||P.typeParameters!==Y||P.parameters!==ge||P.type!==rt?W(Te(B,Y,ge,rt),P):P}function dr(P,B,Y,ge){return Ht(P,P.modifiers,B,Y,ge)}function qr(P,B){let Y=q(186);return Y.exprName=P,Y.typeArguments=B&&i().parenthesizeTypeArguments(B),Y.transformFlags=1,Y}function Hr(P,B,Y){return P.exprName!==B||P.typeArguments!==Y?vn(qr(B,Y),P):P}function dn(P){let B=ee(187);return B.members=G(P),B.transformFlags=1,B}function Ar(P,B){return P.members!==B?vn(dn(B),P):P}function In(P){let B=q(188);return B.elementType=i().parenthesizeNonArrayTypeOfPostfixType(P),B.transformFlags=1,B}function Ki(P,B){return P.elementType!==B?vn(In(B),P):P}function ls(P){let B=q(189);return B.elements=G(i().parenthesizeElementTypesOfTupleType(P)),B.transformFlags=1,B}function Yn(P,B){return P.elements!==B?vn(ls(B),P):P}function pi(P,B,Y,ge){let rt=ee(202);return rt.dotDotDotToken=P,rt.name=B,rt.questionToken=Y,rt.type=ge,rt.transformFlags=1,rt.jsDoc=void 0,rt}function Er(P,B,Y,ge,rt){return P.dotDotDotToken!==B||P.name!==Y||P.questionToken!==ge||P.type!==rt?vn(pi(B,Y,ge,rt),P):P}function tn(P){let B=q(190);return B.type=i().parenthesizeTypeOfOptionalType(P),B.transformFlags=1,B}function er(P,B){return P.type!==B?vn(tn(B),P):P}function qs(P){let B=q(191);return B.type=P,B.transformFlags=1,B}function uo(P,B){return P.type!==B?vn(qs(B),P):P}function Mo(P,B,Y){let ge=q(P);return ge.types=J.createNodeArray(Y(B)),ge.transformFlags=1,ge}function Do(P,B,Y){return P.types!==B?vn(Mo(P.kind,B,Y),P):P}function ms(P){return Mo(192,P,i().parenthesizeConstituentTypesOfUnionType)}function sa(P,B){return Do(P,B,i().parenthesizeConstituentTypesOfUnionType)}function Sc(P){return Mo(193,P,i().parenthesizeConstituentTypesOfIntersectionType)}function ts(P,B){return Do(P,B,i().parenthesizeConstituentTypesOfIntersectionType)}function zi(P,B,Y,ge){let rt=q(194);return rt.checkType=i().parenthesizeCheckTypeOfConditionalType(P),rt.extendsType=i().parenthesizeExtendsTypeOfConditionalType(B),rt.trueType=Y,rt.falseType=ge,rt.transformFlags=1,rt.locals=void 0,rt.nextContainer=void 0,rt}function Eu(P,B,Y,ge,rt){return P.checkType!==B||P.extendsType!==Y||P.trueType!==ge||P.falseType!==rt?vn(zi(B,Y,ge,rt),P):P}function kc(P){let B=q(195);return B.typeParameter=P,B.transformFlags=1,B}function P_(P,B){return P.typeParameter!==B?vn(kc(B),P):P}function el(P,B){let Y=q(203);return Y.head=P,Y.templateSpans=G(B),Y.transformFlags=1,Y}function Xu(P,B,Y){return P.head!==B||P.templateSpans!==Y?vn(el(B,Y),P):P}function Fa(P,B,Y,ge,rt=!1){let Qt=q(205);return Qt.argument=P,Qt.attributes=B,Qt.assertions&&Qt.assertions.assertClause&&Qt.attributes&&(Qt.assertions.assertClause=Qt.attributes),Qt.qualifier=Y,Qt.typeArguments=ge&&i().parenthesizeTypeArguments(ge),Qt.isTypeOf=rt,Qt.transformFlags=1,Qt}function bc(P,B,Y,ge,rt,Qt=P.isTypeOf){return P.argument!==B||P.attributes!==Y||P.qualifier!==ge||P.typeArguments!==rt||P.isTypeOf!==Qt?vn(Fa(B,Y,ge,rt,Qt),P):P}function Lo(P){let B=q(196);return B.type=P,B.transformFlags=1,B}function po(P,B){return P.type!==B?vn(Lo(B),P):P}function _r(){let P=q(197);return P.transformFlags=1,P}function Jc(P,B){let Y=q(198);return Y.operator=P,Y.type=P===148?i().parenthesizeOperandOfReadonlyTypeOperator(B):i().parenthesizeOperandOfTypeOperator(B),Y.transformFlags=1,Y}function z_(P,B){return P.type!==B?vn(Jc(P.operator,B),P):P}function W_(P,B){let Y=q(199);return Y.objectType=i().parenthesizeNonArrayTypeOfPostfixType(P),Y.indexType=B,Y.transformFlags=1,Y}function qf(P,B,Y){return P.objectType!==B||P.indexType!==Y?vn(W_(B,Y),P):P}function mc(P,B,Y,ge,rt,Qt){let fn=ee(200);return fn.readonlyToken=P,fn.typeParameter=B,fn.nameType=Y,fn.questionToken=ge,fn.type=rt,fn.members=Qt&&G(Qt),fn.transformFlags=1,fn.locals=void 0,fn.nextContainer=void 0,fn}function tl(P,B,Y,ge,rt,Qt,fn){return P.readonlyToken!==B||P.typeParameter!==Y||P.nameType!==ge||P.questionToken!==rt||P.type!==Qt||P.members!==fn?vn(mc(B,Y,ge,rt,Qt,fn),P):P}function Se(P){let B=q(201);return B.literal=P,B.transformFlags=1,B}function ae(P,B){return P.literal!==B?vn(Se(B),P):P}function Ye(P){let B=q(206);return B.elements=G(P),B.transformFlags|=eo(B.elements)|1024|524288,B.transformFlags&32768&&(B.transformFlags|=65664),B}function Ot(P,B){return P.elements!==B?vn(Ye(B),P):P}function Tr(P){let B=q(207);return B.elements=G(P),B.transformFlags|=eo(B.elements)|1024|524288,B}function Vn(P,B){return P.elements!==B?vn(Tr(B),P):P}function pr(P,B,Y,ge){let rt=ee(208);return rt.dotDotDotToken=P,rt.propertyName=cu(B),rt.name=cu(Y),rt.initializer=yg(ge),rt.transformFlags|=Rn(rt.dotDotDotToken)|X1(rt.propertyName)|X1(rt.name)|Rn(rt.initializer)|(rt.dotDotDotToken?32768:0)|1024,rt.flowNode=void 0,rt}function Jn(P,B,Y,ge,rt){return P.propertyName!==Y||P.dotDotDotToken!==B||P.name!==ge||P.initializer!==rt?vn(pr(B,Y,ge,rt),P):P}function Ri(P,B){let Y=q(209),ge=P&&vc(P),rt=G(P,ge&&pu(ge)?!0:void 0);return Y.elements=i().parenthesizeExpressionsOfCommaDelimitedList(rt),Y.multiLine=B,Y.transformFlags|=eo(Y.elements),Y}function Ai(P,B){return P.elements!==B?vn(Ri(B,P.multiLine),P):P}function Na(P,B){let Y=ee(210);return Y.properties=G(P),Y.multiLine=B,Y.transformFlags|=eo(Y.properties),Y.jsDoc=void 0,Y}function gc(P,B){return P.properties!==B?vn(Na(B,P.multiLine),P):P}function Wl(P,B,Y){let ge=ee(211);return ge.expression=P,ge.questionDotToken=B,ge.name=Y,ge.transformFlags=Rn(ge.expression)|Rn(ge.questionDotToken)|(He(ge.name)?r8(ge.name):Rn(ge.name)|536870912),ge.jsDoc=void 0,ge.flowNode=void 0,ge}function Oc(P,B){let Y=Wl(i().parenthesizeLeftSideOfAccess(P,!1),void 0,cu(B));return EO(P)&&(Y.transformFlags|=384),Y}function du(P,B,Y){return A5(P)?mu(P,B,P.questionDotToken,aa(Y,He)):P.expression!==B||P.name!==Y?vn(Oc(B,Y),P):P}function hc(P,B,Y){let ge=Wl(i().parenthesizeLeftSideOfAccess(P,!0),B,cu(Y));return ge.flags|=64,ge.transformFlags|=32,ge}function mu(P,B,Y,ge){return M.assert(!!(P.flags&64),"Cannot update a PropertyAccessExpression using updatePropertyAccessChain. Use updatePropertyAccess instead."),P.expression!==B||P.questionDotToken!==Y||P.name!==ge?vn(hc(B,Y,ge),P):P}function zf(P,B,Y){let ge=ee(212);return ge.expression=P,ge.questionDotToken=B,ge.argumentExpression=Y,ge.transformFlags|=Rn(ge.expression)|Rn(ge.questionDotToken)|Rn(ge.argumentExpression),ge.jsDoc=void 0,ge.flowNode=void 0,ge}function rl(P,B){let Y=zf(i().parenthesizeLeftSideOfAccess(P,!1),void 0,xS(B));return EO(P)&&(Y.transformFlags|=384),Y}function $l(P,B,Y){return O$(P)?Je(P,B,P.questionDotToken,Y):P.expression!==B||P.argumentExpression!==Y?vn(rl(B,Y),P):P}function nd(P,B,Y){let ge=zf(i().parenthesizeLeftSideOfAccess(P,!0),B,xS(Y));return ge.flags|=64,ge.transformFlags|=32,ge}function Je(P,B,Y,ge){return M.assert(!!(P.flags&64),"Cannot update a ElementAccessExpression using updateElementAccessChain. Use updateElementAccess instead."),P.expression!==B||P.questionDotToken!==Y||P.argumentExpression!==ge?vn(nd(B,Y,ge),P):P}function qt(P,B,Y,ge){let rt=ee(213);return rt.expression=P,rt.questionDotToken=B,rt.typeArguments=Y,rt.arguments=ge,rt.transformFlags|=Rn(rt.expression)|Rn(rt.questionDotToken)|eo(rt.typeArguments)|eo(rt.arguments),rt.typeArguments&&(rt.transformFlags|=1),Cf(rt.expression)&&(rt.transformFlags|=16384),rt}function Gr(P,B,Y){let ge=qt(i().parenthesizeLeftSideOfAccess(P,!1),void 0,oo(B),i().parenthesizeExpressionsOfCommaDelimitedList(G(Y)));return xO(ge.expression)&&(ge.transformFlags|=8388608),ge}function gs(P,B,Y,ge){return qx(P)?so(P,B,P.questionDotToken,Y,ge):P.expression!==B||P.typeArguments!==Y||P.arguments!==ge?vn(Gr(B,Y,ge),P):P}function Qa(P,B,Y,ge){let rt=qt(i().parenthesizeLeftSideOfAccess(P,!0),B,oo(Y),i().parenthesizeExpressionsOfCommaDelimitedList(G(ge)));return rt.flags|=64,rt.transformFlags|=32,rt}function so(P,B,Y,ge,rt){return M.assert(!!(P.flags&64),"Cannot update a CallExpression using updateCallChain. Use updateCall instead."),P.expression!==B||P.questionDotToken!==Y||P.typeArguments!==ge||P.arguments!==rt?vn(Qa(B,Y,ge,rt),P):P}function fl(P,B,Y){let ge=ee(214);return ge.expression=i().parenthesizeExpressionOfNew(P),ge.typeArguments=oo(B),ge.arguments=Y?i().parenthesizeExpressionsOfCommaDelimitedList(Y):void 0,ge.transformFlags|=Rn(ge.expression)|eo(ge.typeArguments)|eo(ge.arguments)|32,ge.typeArguments&&(ge.transformFlags|=1),ge}function au(P,B,Y,ge){return P.expression!==B||P.typeArguments!==Y||P.arguments!==ge?vn(fl(B,Y,ge),P):P}function Uo(P,B,Y){let ge=q(215);return ge.tag=i().parenthesizeLeftSideOfAccess(P,!1),ge.typeArguments=oo(B),ge.template=Y,ge.transformFlags|=Rn(ge.tag)|eo(ge.typeArguments)|Rn(ge.template)|1024,ge.typeArguments&&(ge.transformFlags|=1),JH(ge.template)&&(ge.transformFlags|=128),ge}function Fo(P,B,Y,ge){return P.tag!==B||P.typeArguments!==Y||P.template!==ge?vn(Uo(B,Y,ge),P):P}function Cl(P,B){let Y=q(216);return Y.expression=i().parenthesizeOperandOfPrefixUnary(B),Y.type=P,Y.transformFlags|=Rn(Y.expression)|Rn(Y.type)|1,Y}function Wf(P,B,Y){return P.type!==B||P.expression!==Y?vn(Cl(B,Y),P):P}function fg(P){let B=q(217);return B.expression=P,B.transformFlags=Rn(B.expression),B.jsDoc=void 0,B}function id(P,B){return P.expression!==B?vn(fg(B),P):P}function If(P,B,Y,ge,rt,Qt,fn){let Ts=ee(218);Ts.modifiers=oo(P),Ts.asteriskToken=B,Ts.name=cu(Y),Ts.typeParameters=oo(ge),Ts.parameters=G(rt),Ts.type=Qt,Ts.body=fn;let Xo=Vg(Ts.modifiers)&1024,Jm=!!Ts.asteriskToken,qm=Xo&&Jm;return Ts.transformFlags=eo(Ts.modifiers)|Rn(Ts.asteriskToken)|X1(Ts.name)|eo(Ts.typeParameters)|eo(Ts.parameters)|Rn(Ts.type)|Rn(Ts.body)&-67108865|(qm?128:Xo?256:Jm?2048:0)|(Ts.typeParameters||Ts.type?1:0)|4194304,Ts.typeArguments=void 0,Ts.jsDoc=void 0,Ts.locals=void 0,Ts.nextContainer=void 0,Ts.flowNode=void 0,Ts.endFlowNode=void 0,Ts.returnFlowNode=void 0,Ts}function wd(P,B,Y,ge,rt,Qt,fn,Ts){return P.name!==ge||P.modifiers!==B||P.asteriskToken!==Y||P.typeParameters!==rt||P.parameters!==Qt||P.type!==fn||P.body!==Ts?W(If(B,Y,ge,rt,Qt,fn,Ts),P):P}function sd(P,B,Y,ge,rt,Qt){let fn=ee(219);fn.modifiers=oo(P),fn.typeParameters=oo(B),fn.parameters=G(Y),fn.type=ge,fn.equalsGreaterThanToken=rt??qe(39),fn.body=i().parenthesizeConciseBodyOfArrowFunction(Qt);let Ts=Vg(fn.modifiers)&1024;return fn.transformFlags=eo(fn.modifiers)|eo(fn.typeParameters)|eo(fn.parameters)|Rn(fn.type)|Rn(fn.equalsGreaterThanToken)|Rn(fn.body)&-67108865|(fn.typeParameters||fn.type?1:0)|(Ts?16640:0)|1024,fn.typeArguments=void 0,fn.jsDoc=void 0,fn.locals=void 0,fn.nextContainer=void 0,fn.flowNode=void 0,fn.endFlowNode=void 0,fn.returnFlowNode=void 0,fn}function Gh(P,B,Y,ge,rt,Qt,fn){return P.modifiers!==B||P.typeParameters!==Y||P.parameters!==ge||P.type!==rt||P.equalsGreaterThanToken!==Qt||P.body!==fn?W(sd(B,Y,ge,rt,Qt,fn),P):P}function Yh(P){let B=q(220);return B.expression=i().parenthesizeOperandOfPrefixUnary(P),B.transformFlags|=Rn(B.expression),B}function Of(P,B){return P.expression!==B?vn(Yh(B),P):P}function Hl(P){let B=q(221);return B.expression=i().parenthesizeOperandOfPrefixUnary(P),B.transformFlags|=Rn(B.expression),B}function Kh(P,B){return P.expression!==B?vn(Hl(B),P):P}function $f(P){let B=q(222);return B.expression=i().parenthesizeOperandOfPrefixUnary(P),B.transformFlags|=Rn(B.expression),B}function nh(P,B){return P.expression!==B?vn($f(B),P):P}function ad(P){let B=q(223);return B.expression=i().parenthesizeOperandOfPrefixUnary(P),B.transformFlags|=Rn(B.expression)|256|128|2097152,B}function oe(P,B){return P.expression!==B?vn(ad(B),P):P}function yt(P,B){let Y=q(224);return Y.operator=P,Y.operand=i().parenthesizeOperandOfPrefixUnary(B),Y.transformFlags|=Rn(Y.operand),(P===46||P===47)&&He(Y.operand)&&!xc(Y.operand)&&!k0(Y.operand)&&(Y.transformFlags|=268435456),Y}function Gt(P,B){return P.operand!==B?vn(yt(P.operator,B),P):P}function Xt(P,B){let Y=q(225);return Y.operator=B,Y.operand=i().parenthesizeOperandOfPostfixUnary(P),Y.transformFlags|=Rn(Y.operand),He(Y.operand)&&!xc(Y.operand)&&!k0(Y.operand)&&(Y.transformFlags|=268435456),Y}function Fr(P,B){return P.operand!==B?vn(Xt(B,P.operator),P):P}function nn(P,B,Y){let ge=ee(226),rt=uT(B),Qt=rt.kind;return ge.left=i().parenthesizeLeftSideOfBinary(Qt,P),ge.operatorToken=rt,ge.right=i().parenthesizeRightSideOfBinary(Qt,ge.left,Y),ge.transformFlags|=Rn(ge.left)|Rn(ge.operatorToken)|Rn(ge.right),Qt===61?ge.transformFlags|=32:Qt===64?Ca(ge.left)?ge.transformFlags|=5248|Hn(ge.left):Gu(ge.left)&&(ge.transformFlags|=5120|Hn(ge.left)):Qt===43||Qt===68?ge.transformFlags|=512:GI(Qt)&&(ge.transformFlags|=16),Qt===103&&Zi(ge.left)&&(ge.transformFlags|=536870912),ge.jsDoc=void 0,ge}function Hn(P){return T8(P)?65536:0}function Si(P,B,Y,ge){return P.left!==B||P.operatorToken!==Y||P.right!==ge?vn(nn(B,Y,ge),P):P}function $(P,B,Y,ge,rt){let Qt=q(227);return Qt.condition=i().parenthesizeConditionOfConditionalExpression(P),Qt.questionToken=B??qe(58),Qt.whenTrue=i().parenthesizeBranchOfConditionalExpression(Y),Qt.colonToken=ge??qe(59),Qt.whenFalse=i().parenthesizeBranchOfConditionalExpression(rt),Qt.transformFlags|=Rn(Qt.condition)|Rn(Qt.questionToken)|Rn(Qt.whenTrue)|Rn(Qt.colonToken)|Rn(Qt.whenFalse),Qt}function Fe(P,B,Y,ge,rt,Qt){return P.condition!==B||P.questionToken!==Y||P.whenTrue!==ge||P.colonToken!==rt||P.whenFalse!==Qt?vn($(B,Y,ge,rt,Qt),P):P}function jt(P,B){let Y=q(228);return Y.head=P,Y.templateSpans=G(B),Y.transformFlags|=Rn(Y.head)|eo(Y.templateSpans)|1024,Y}function Xr(P,B,Y){return P.head!==B||P.templateSpans!==Y?vn(jt(B,Y),P):P}function Mi(P,B,Y,ge=0){M.assert(!(ge&-7177),"Unsupported template flags.");let rt;if(Y!==void 0&&Y!==B&&(rt=MSt(P,Y),typeof rt=="object"))return M.fail("Invalid raw text");if(B===void 0){if(rt===void 0)return M.fail("Arguments 'text' and 'rawText' may not both be undefined.");B=rt}else rt!==void 0&&M.assert(B===rt,"Expected argument 'text' to be the normalized (i.e. 'cooked') version of argument 'rawText'.");return B}function Us(P){let B=1024;return P&&(B|=128),B}function Ss(P,B,Y,ge){let rt=ct(P);return rt.text=B,rt.rawText=Y,rt.templateFlags=ge&7176,rt.transformFlags=Us(rt.templateFlags),rt}function zs(P,B,Y,ge){let rt=ee(P);return rt.text=B,rt.rawText=Y,rt.templateFlags=ge&7176,rt.transformFlags=Us(rt.templateFlags),rt}function vo(P,B,Y,ge){return P===15?zs(P,B,Y,ge):Ss(P,B,Y,ge)}function Wa(P,B,Y){return P=Mi(16,P,B,Y),vo(16,P,B,Y)}function qc(P,B,Y){return P=Mi(16,P,B,Y),vo(17,P,B,Y)}function Id(P,B,Y){return P=Mi(16,P,B,Y),vo(18,P,B,Y)}function Om(P,B,Y){return P=Mi(16,P,B,Y),zs(15,P,B,Y)}function Xh(P,B){M.assert(!P||!!B,"A `YieldExpression` with an asteriskToken must have an expression.");let Y=q(229);return Y.expression=B&&i().parenthesizeExpressionForDisallowedComma(B),Y.asteriskToken=P,Y.transformFlags|=Rn(Y.expression)|Rn(Y.asteriskToken)|1024|128|1048576,Y}function Vy(P,B,Y){return P.expression!==Y||P.asteriskToken!==B?vn(Xh(B,Y),P):P}function $v(P){let B=q(230);return B.expression=i().parenthesizeExpressionForDisallowedComma(P),B.transformFlags|=Rn(B.expression)|1024|32768,B}function Jy(P,B){return P.expression!==B?vn($v(B),P):P}function Od(P,B,Y,ge,rt){let Qt=ee(231);return Qt.modifiers=oo(P),Qt.name=cu(B),Qt.typeParameters=oo(Y),Qt.heritageClauses=oo(ge),Qt.members=G(rt),Qt.transformFlags|=eo(Qt.modifiers)|X1(Qt.name)|eo(Qt.typeParameters)|eo(Qt.heritageClauses)|eo(Qt.members)|(Qt.typeParameters?1:0)|1024,Qt.jsDoc=void 0,Qt}function od(P,B,Y,ge,rt,Qt){return P.modifiers!==B||P.name!==Y||P.typeParameters!==ge||P.heritageClauses!==rt||P.members!==Qt?vn(Od(B,Y,ge,rt,Qt),P):P}function Vo(){return q(232)}function d_(P,B){let Y=q(233);return Y.expression=i().parenthesizeLeftSideOfAccess(P,!1),Y.typeArguments=B&&i().parenthesizeTypeArguments(B),Y.transformFlags|=Rn(Y.expression)|eo(Y.typeArguments)|1024,Y}function $_(P,B,Y){return P.expression!==B||P.typeArguments!==Y?vn(d_(B,Y),P):P}function Rm(P,B){let Y=q(234);return Y.expression=P,Y.type=B,Y.transformFlags|=Rn(Y.expression)|Rn(Y.type)|1,Y}function Hv(P,B,Y){return P.expression!==B||P.type!==Y?vn(Rm(B,Y),P):P}function O0(P){let B=q(235);return B.expression=i().parenthesizeLeftSideOfAccess(P,!1),B.transformFlags|=Rn(B.expression)|1,B}function pS(P,B){return P5(P)?Vb(P,B):P.expression!==B?vn(O0(B),P):P}function cm(P,B){let Y=q(238);return Y.expression=P,Y.type=B,Y.transformFlags|=Rn(Y.expression)|Rn(Y.type)|1,Y}function dS(P,B,Y){return P.expression!==B||P.type!==Y?vn(cm(B,Y),P):P}function lm(P){let B=q(235);return B.flags|=64,B.expression=i().parenthesizeLeftSideOfAccess(P,!0),B.transformFlags|=Rn(B.expression)|1,B}function Vb(P,B){return M.assert(!!(P.flags&64),"Cannot update a NonNullExpression using updateNonNullChain. Use updateNonNullExpression instead."),P.expression!==B?vn(lm(B),P):P}function pg(P,B){let Y=q(236);switch(Y.keywordToken=P,Y.name=B,Y.transformFlags|=Rn(Y.name),P){case 105:Y.transformFlags|=1024;break;case 102:Y.transformFlags|=32;break;default:return M.assertNever(P)}return Y.flowNode=void 0,Y}function cd(P,B){return P.name!==B?vn(pg(P.keywordToken,B),P):P}function R0(P,B){let Y=q(239);return Y.expression=P,Y.literal=B,Y.transformFlags|=Rn(Y.expression)|Rn(Y.literal)|1024,Y}function We(P,B,Y){return P.expression!==B||P.literal!==Y?vn(R0(B,Y),P):P}function st(){let P=q(240);return P.transformFlags|=1024,P}function Jt(P,B){let Y=q(241);return Y.statements=G(P),Y.multiLine=B,Y.transformFlags|=eo(Y.statements),Y.jsDoc=void 0,Y.locals=void 0,Y.nextContainer=void 0,Y}function sr(P,B){return P.statements!==B?vn(Jt(B,P.multiLine),P):P}function kr(P,B){let Y=q(243);return Y.modifiers=oo(P),Y.declarationList=Rs(B)?Hf(B):B,Y.transformFlags|=eo(Y.modifiers)|Rn(Y.declarationList),Vg(Y.modifiers)&128&&(Y.transformFlags=1),Y.jsDoc=void 0,Y.flowNode=void 0,Y}function _n(P,B,Y){return P.modifiers!==B||P.declarationList!==Y?vn(kr(B,Y),P):P}function Ir(){let P=q(242);return P.jsDoc=void 0,P}function kn(P){let B=q(244);return B.expression=i().parenthesizeExpressionOfExpressionStatement(P),B.transformFlags|=Rn(B.expression),B.jsDoc=void 0,B.flowNode=void 0,B}function ji(P,B){return P.expression!==B?vn(kn(B),P):P}function En(P,B,Y){let ge=q(245);return ge.expression=P,ge.thenStatement=$y(B),ge.elseStatement=$y(Y),ge.transformFlags|=Rn(ge.expression)|Rn(ge.thenStatement)|Rn(ge.elseStatement),ge.jsDoc=void 0,ge.flowNode=void 0,ge}function Ni(P,B,Y,ge){return P.expression!==B||P.thenStatement!==Y||P.elseStatement!==ge?vn(En(B,Y,ge),P):P}function an(P,B){let Y=q(246);return Y.statement=$y(P),Y.expression=B,Y.transformFlags|=Rn(Y.statement)|Rn(Y.expression),Y.jsDoc=void 0,Y.flowNode=void 0,Y}function Ds(P,B,Y){return P.statement!==B||P.expression!==Y?vn(an(B,Y),P):P}function wa(P,B){let Y=q(247);return Y.expression=P,Y.statement=$y(B),Y.transformFlags|=Rn(Y.expression)|Rn(Y.statement),Y.jsDoc=void 0,Y.flowNode=void 0,Y}function xu(P,B,Y){return P.expression!==B||P.statement!==Y?vn(wa(B,Y),P):P}function N_(P,B,Y,ge){let rt=q(248);return rt.initializer=P,rt.condition=B,rt.incrementor=Y,rt.statement=$y(ge),rt.transformFlags|=Rn(rt.initializer)|Rn(rt.condition)|Rn(rt.incrementor)|Rn(rt.statement),rt.jsDoc=void 0,rt.locals=void 0,rt.nextContainer=void 0,rt.flowNode=void 0,rt}function um(P,B,Y,ge,rt){return P.initializer!==B||P.condition!==Y||P.incrementor!==ge||P.statement!==rt?vn(N_(B,Y,ge,rt),P):P}function Gv(P,B,Y){let ge=q(249);return ge.initializer=P,ge.expression=B,ge.statement=$y(Y),ge.transformFlags|=Rn(ge.initializer)|Rn(ge.expression)|Rn(ge.statement),ge.jsDoc=void 0,ge.locals=void 0,ge.nextContainer=void 0,ge.flowNode=void 0,ge}function _m(P,B,Y,ge){return P.initializer!==B||P.expression!==Y||P.statement!==ge?vn(Gv(B,Y,ge),P):P}function Sk(P,B,Y,ge){let rt=q(250);return rt.awaitModifier=P,rt.initializer=B,rt.expression=i().parenthesizeExpressionForDisallowedComma(Y),rt.statement=$y(ge),rt.transformFlags|=Rn(rt.awaitModifier)|Rn(rt.initializer)|Rn(rt.expression)|Rn(rt.statement)|1024,P&&(rt.transformFlags|=128),rt.jsDoc=void 0,rt.locals=void 0,rt.nextContainer=void 0,rt.flowNode=void 0,rt}function mD(P,B,Y,ge,rt){return P.awaitModifier!==B||P.initializer!==Y||P.expression!==ge||P.statement!==rt?vn(Sk(B,Y,ge,rt),P):P}function bk(P){let B=q(251);return B.label=cu(P),B.transformFlags|=Rn(B.label)|4194304,B.jsDoc=void 0,B.flowNode=void 0,B}function FE(P,B){return P.label!==B?vn(bk(B),P):P}function Jb(P){let B=q(252);return B.label=cu(P),B.transformFlags|=Rn(B.label)|4194304,B.jsDoc=void 0,B.flowNode=void 0,B}function qb(P,B){return P.label!==B?vn(Jb(B),P):P}function zb(P){let B=q(253);return B.expression=P,B.transformFlags|=Rn(B.expression)|128|4194304,B.jsDoc=void 0,B.flowNode=void 0,B}function P2(P,B){return P.expression!==B?vn(zb(B),P):P}function Yv(P,B){let Y=q(254);return Y.expression=P,Y.statement=$y(B),Y.transformFlags|=Rn(Y.expression)|Rn(Y.statement),Y.jsDoc=void 0,Y.flowNode=void 0,Y}function jE(P,B,Y){return P.expression!==B||P.statement!==Y?vn(Yv(B,Y),P):P}function qy(P,B){let Y=q(255);return Y.expression=i().parenthesizeExpressionForDisallowedComma(P),Y.caseBlock=B,Y.transformFlags|=Rn(Y.expression)|Rn(Y.caseBlock),Y.jsDoc=void 0,Y.flowNode=void 0,Y.possiblyExhaustive=!1,Y}function BE(P,B,Y){return P.expression!==B||P.caseBlock!==Y?vn(qy(B,Y),P):P}function _o(P,B){let Y=q(256);return Y.label=cu(P),Y.statement=$y(B),Y.transformFlags|=Rn(Y.label)|Rn(Y.statement),Y.jsDoc=void 0,Y.flowNode=void 0,Y}function N2(P,B,Y){return P.label!==B||P.statement!==Y?vn(_o(B,Y),P):P}function D2(P){let B=q(257);return B.expression=P,B.transformFlags|=Rn(B.expression),B.jsDoc=void 0,B.flowNode=void 0,B}function Wb(P,B){return P.expression!==B?vn(D2(B),P):P}function M0(P,B,Y){let ge=q(258);return ge.tryBlock=P,ge.catchClause=B,ge.finallyBlock=Y,ge.transformFlags|=Rn(ge.tryBlock)|Rn(ge.catchClause)|Rn(ge.finallyBlock),ge.jsDoc=void 0,ge.flowNode=void 0,ge}function ih(P,B,Y,ge){return P.tryBlock!==B||P.catchClause!==Y||P.finallyBlock!==ge?vn(M0(B,Y,ge),P):P}function Rd(){let P=q(259);return P.jsDoc=void 0,P.flowNode=void 0,P}function Rf(P,B,Y,ge){let rt=ee(260);return rt.name=cu(P),rt.exclamationToken=B,rt.type=Y,rt.initializer=yg(ge),rt.transformFlags|=X1(rt.name)|Rn(rt.initializer)|(rt.exclamationToken??rt.type?1:0),rt.jsDoc=void 0,rt}function hp(P,B,Y,ge,rt){return P.name!==B||P.type!==ge||P.exclamationToken!==Y||P.initializer!==rt?vn(Rf(B,Y,ge,rt),P):P}function Hf(P,B=0){let Y=q(261);return Y.flags|=B&7,Y.declarations=G(P),Y.transformFlags|=eo(Y.declarations)|4194304,B&7&&(Y.transformFlags|=263168),B&4&&(Y.transformFlags|=4),Y}function Kv(P,B){return P.declarations!==B?vn(Hf(B,P.flags),P):P}function Tk(P,B,Y,ge,rt,Qt,fn){let Ts=ee(262);if(Ts.modifiers=oo(P),Ts.asteriskToken=B,Ts.name=cu(Y),Ts.typeParameters=oo(ge),Ts.parameters=G(rt),Ts.type=Qt,Ts.body=fn,!Ts.body||Vg(Ts.modifiers)&128)Ts.transformFlags=1;else{let Xo=Vg(Ts.modifiers)&1024,Jm=!!Ts.asteriskToken,qm=Xo&&Jm;Ts.transformFlags=eo(Ts.modifiers)|Rn(Ts.asteriskToken)|X1(Ts.name)|eo(Ts.typeParameters)|eo(Ts.parameters)|Rn(Ts.type)|Rn(Ts.body)&-67108865|(qm?128:Xo?256:Jm?2048:0)|(Ts.typeParameters||Ts.type?1:0)|4194304}return Ts.typeArguments=void 0,Ts.jsDoc=void 0,Ts.locals=void 0,Ts.nextContainer=void 0,Ts.endFlowNode=void 0,Ts.returnFlowNode=void 0,Ts}function Ek(P,B,Y,ge,rt,Qt,fn,Ts){return P.modifiers!==B||P.asteriskToken!==Y||P.name!==ge||P.typeParameters!==rt||P.parameters!==Qt||P.type!==fn||P.body!==Ts?$b(Tk(B,Y,ge,rt,Qt,fn,Ts),P):P}function $b(P,B){return P!==B&&P.modifiers===B.modifiers&&(P.modifiers=B.modifiers),W(P,B)}function Xv(P,B,Y,ge,rt){let Qt=ee(263);return Qt.modifiers=oo(P),Qt.name=cu(B),Qt.typeParameters=oo(Y),Qt.heritageClauses=oo(ge),Qt.members=G(rt),Vg(Qt.modifiers)&128?Qt.transformFlags=1:(Qt.transformFlags|=eo(Qt.modifiers)|X1(Qt.name)|eo(Qt.typeParameters)|eo(Qt.heritageClauses)|eo(Qt.members)|(Qt.typeParameters?1:0)|1024,Qt.transformFlags&8192&&(Qt.transformFlags|=1)),Qt.jsDoc=void 0,Qt}function Hb(P,B,Y,ge,rt,Qt){return P.modifiers!==B||P.name!==Y||P.typeParameters!==ge||P.heritageClauses!==rt||P.members!==Qt?vn(Xv(B,Y,ge,rt,Qt),P):P}function xk(P,B,Y,ge,rt){let Qt=ee(264);return Qt.modifiers=oo(P),Qt.name=cu(B),Qt.typeParameters=oo(Y),Qt.heritageClauses=oo(ge),Qt.members=G(rt),Qt.transformFlags=1,Qt.jsDoc=void 0,Qt}function ou(P,B,Y,ge,rt,Qt){return P.modifiers!==B||P.name!==Y||P.typeParameters!==ge||P.heritageClauses!==rt||P.members!==Qt?vn(xk(B,Y,ge,rt,Qt),P):P}function Qv(P,B,Y,ge){let rt=ee(265);return rt.modifiers=oo(P),rt.name=cu(B),rt.typeParameters=oo(Y),rt.type=ge,rt.transformFlags=1,rt.jsDoc=void 0,rt.locals=void 0,rt.nextContainer=void 0,rt}function Ck(P,B,Y,ge,rt){return P.modifiers!==B||P.name!==Y||P.typeParameters!==ge||P.type!==rt?vn(Qv(B,Y,ge,rt),P):P}function dg(P,B,Y){let ge=ee(266);return ge.modifiers=oo(P),ge.name=cu(B),ge.members=G(Y),ge.transformFlags|=eo(ge.modifiers)|Rn(ge.name)|eo(ge.members)|1,ge.transformFlags&=-67108865,ge.jsDoc=void 0,ge}function w2(P,B,Y,ge){return P.modifiers!==B||P.name!==Y||P.members!==ge?vn(dg(B,Y,ge),P):P}function Qe(P,B,Y,ge=0){let rt=ee(267);return rt.modifiers=oo(P),rt.flags|=ge&2088,rt.name=B,rt.body=Y,Vg(rt.modifiers)&128?rt.transformFlags=1:rt.transformFlags|=eo(rt.modifiers)|Rn(rt.name)|Rn(rt.body)|1,rt.transformFlags&=-67108865,rt.jsDoc=void 0,rt.locals=void 0,rt.nextContainer=void 0,rt}function Mm(P,B,Y,ge){return P.modifiers!==B||P.name!==Y||P.body!==ge?vn(Qe(B,Y,ge,P.flags),P):P}function Cu(P){let B=q(268);return B.statements=G(P),B.transformFlags|=eo(B.statements),B.jsDoc=void 0,B}function Gb(P,B){return P.statements!==B?vn(Cu(B),P):P}function Qh(P){let B=q(269);return B.clauses=G(P),B.transformFlags|=eo(B.clauses),B.locals=void 0,B.nextContainer=void 0,B}function Md(P,B){return P.clauses!==B?vn(Qh(B),P):P}function sh(P){let B=ee(270);return B.name=cu(P),B.transformFlags|=r8(B.name)|1,B.modifiers=void 0,B.jsDoc=void 0,B}function L0(P,B){return P.name!==B?V6(sh(B),P):P}function V6(P,B){return P!==B&&(P.modifiers=B.modifiers),vn(P,B)}function Za(P,B,Y,ge){let rt=ee(271);return rt.modifiers=oo(P),rt.name=cu(Y),rt.isTypeOnly=B,rt.moduleReference=ge,rt.transformFlags|=eo(rt.modifiers)|r8(rt.name)|Rn(rt.moduleReference),C0(rt.moduleReference)||(rt.transformFlags|=1),rt.transformFlags&=-67108865,rt.jsDoc=void 0,rt}function Lm(P,B,Y,ge,rt){return P.modifiers!==B||P.isTypeOnly!==Y||P.name!==ge||P.moduleReference!==rt?vn(Za(B,Y,ge,rt),P):P}function UE(P,B,Y,ge){let rt=q(272);return rt.modifiers=oo(P),rt.importClause=B,rt.moduleSpecifier=Y,rt.attributes=rt.assertClause=ge,rt.transformFlags|=Rn(rt.importClause)|Rn(rt.moduleSpecifier),rt.transformFlags&=-67108865,rt.jsDoc=void 0,rt}function I2(P,B,Y,ge,rt){return P.modifiers!==B||P.importClause!==Y||P.moduleSpecifier!==ge||P.attributes!==rt?vn(UE(B,Y,ge,rt),P):P}function O2(P,B,Y){let ge=ee(273);return ge.isTypeOnly=P,ge.name=B,ge.namedBindings=Y,ge.transformFlags|=Rn(ge.name)|Rn(ge.namedBindings),P&&(ge.transformFlags|=1),ge.transformFlags&=-67108865,ge}function Yb(P,B,Y,ge){return P.isTypeOnly!==B||P.name!==Y||P.namedBindings!==ge?vn(O2(B,Y,ge),P):P}function F0(P,B){let Y=q(300);return Y.elements=G(P),Y.multiLine=B,Y.token=132,Y.transformFlags|=4,Y}function j0(P,B,Y){return P.elements!==B||P.multiLine!==Y?vn(F0(B,Y),P):P}function Kb(P,B){let Y=q(301);return Y.name=P,Y.value=B,Y.transformFlags|=4,Y}function ld(P,B,Y){return P.name!==B||P.value!==Y?vn(Kb(B,Y),P):P}function Ip(P,B){let Y=q(302);return Y.assertClause=P,Y.multiLine=B,Y}function Zv(P,B,Y){return P.assertClause!==B||P.multiLine!==Y?vn(Ip(B,Y),P):P}function e1(P,B,Y){let ge=q(300);return ge.token=Y??118,ge.elements=G(P),ge.multiLine=B,ge.transformFlags|=4,ge}function as(P,B,Y){return P.elements!==B||P.multiLine!==Y?vn(e1(B,Y,P.token),P):P}function qn(P,B){let Y=q(301);return Y.name=P,Y.value=B,Y.transformFlags|=4,Y}function m_(P,B,Y){return P.name!==B||P.value!==Y?vn(qn(B,Y),P):P}function gD(P){let B=ee(274);return B.name=P,B.transformFlags|=Rn(B.name),B.transformFlags&=-67108865,B}function Fm(P,B){return P.name!==B?vn(gD(B),P):P}function Ak(P){let B=ee(280);return B.name=P,B.transformFlags|=Rn(B.name)|32,B.transformFlags&=-67108865,B}function Zh(P,B){return P.name!==B?vn(Ak(B),P):P}function t1(P){let B=q(275);return B.elements=G(P),B.transformFlags|=eo(B.elements),B.transformFlags&=-67108865,B}function B0(P,B){return P.elements!==B?vn(t1(B),P):P}function hD(P,B,Y){let ge=ee(276);return ge.isTypeOnly=P,ge.propertyName=B,ge.name=Y,ge.transformFlags|=Rn(ge.propertyName)|Rn(ge.name),ge.transformFlags&=-67108865,ge}function Xb(P,B,Y,ge){return P.isTypeOnly!==B||P.propertyName!==Y||P.name!==ge?vn(hD(B,Y,ge),P):P}function Op(P,B,Y){let ge=ee(277);return ge.modifiers=oo(P),ge.isExportEquals=B,ge.expression=B?i().parenthesizeRightSideOfBinary(64,void 0,Y):i().parenthesizeExpressionOfExportDefault(Y),ge.transformFlags|=eo(ge.modifiers)|Rn(ge.expression),ge.transformFlags&=-67108865,ge.jsDoc=void 0,ge}function VE(P,B,Y){return P.modifiers!==B||P.expression!==Y?vn(Op(B,P.isExportEquals,Y),P):P}function sc(P,B,Y,ge,rt){let Qt=ee(278);return Qt.modifiers=oo(P),Qt.isTypeOnly=B,Qt.exportClause=Y,Qt.moduleSpecifier=ge,Qt.attributes=Qt.assertClause=rt,Qt.transformFlags|=eo(Qt.modifiers)|Rn(Qt.exportClause)|Rn(Qt.moduleSpecifier),Qt.transformFlags&=-67108865,Qt.jsDoc=void 0,Qt}function zy(P,B,Y,ge,rt,Qt){return P.modifiers!==B||P.isTypeOnly!==Y||P.exportClause!==ge||P.moduleSpecifier!==rt||P.attributes!==Qt?yD(sc(B,Y,ge,rt,Qt),P):P}function yD(P,B){return P!==B&&P.modifiers===B.modifiers&&(P.modifiers=B.modifiers),vn(P,B)}function R2(P){let B=q(279);return B.elements=G(P),B.transformFlags|=eo(B.elements),B.transformFlags&=-67108865,B}function JE(P,B){return P.elements!==B?vn(R2(B),P):P}function kk(P,B,Y){let ge=q(281);return ge.isTypeOnly=P,ge.propertyName=cu(B),ge.name=cu(Y),ge.transformFlags|=Rn(ge.propertyName)|Rn(ge.name),ge.transformFlags&=-67108865,ge.jsDoc=void 0,ge}function J6(P,B,Y,ge){return P.isTypeOnly!==B||P.propertyName!==Y||P.name!==ge?vn(kk(B,Y,ge),P):P}function vD(){let P=ee(282);return P.jsDoc=void 0,P}function Mn(P){let B=q(283);return B.expression=P,B.transformFlags|=Rn(B.expression),B.transformFlags&=-67108865,B}function D_(P,B){return P.expression!==B?vn(Mn(B),P):P}function Ls(P){return q(P)}function U0(P,B,Y=!1){let ge=M2(P,Y?B&&i().parenthesizeNonArrayTypeOfPostfixType(B):B);return ge.postfix=Y,ge}function M2(P,B){let Y=q(P);return Y.type=B,Y}function yp(P,B,Y){return B.type!==Y?vn(U0(P,Y,B.postfix),B):B}function yn(P,B,Y){return B.type!==Y?vn(M2(P,Y),B):B}function Pk(P,B){let Y=ee(317);return Y.parameters=oo(P),Y.type=B,Y.transformFlags=eo(Y.parameters)|(Y.type?1:0),Y.jsDoc=void 0,Y.locals=void 0,Y.nextContainer=void 0,Y.typeArguments=void 0,Y}function Nk(P,B,Y){return P.parameters!==B||P.type!==Y?vn(Pk(B,Y),P):P}function H_(P,B=!1){let Y=ee(322);return Y.jsDocPropertyTags=oo(P),Y.isArrayType=B,Y}function jm(P,B,Y){return P.jsDocPropertyTags!==B||P.isArrayType!==Y?vn(H_(B,Y),P):P}function fm(P){let B=q(309);return B.type=P,B}function r1(P,B){return P.type!==B?vn(fm(B),P):P}function qE(P,B,Y){let ge=ee(323);return ge.typeParameters=oo(P),ge.parameters=G(B),ge.type=Y,ge.jsDoc=void 0,ge.locals=void 0,ge.nextContainer=void 0,ge}function ah(P,B,Y,ge){return P.typeParameters!==B||P.parameters!==Y||P.type!==ge?vn(qE(B,Y,ge),P):P}function vp(P){let B=UG(P.kind);return P.tagName.escapedText===Uc(B)?P.tagName:Ae(B)}function oh(P,B,Y){let ge=q(P);return ge.tagName=B,ge.comment=Y,ge}function Ld(P,B,Y){let ge=ee(P);return ge.tagName=B,ge.comment=Y,ge}function Wy(P,B,Y,ge){let rt=oh(345,P??Ae("template"),ge);return rt.constraint=B,rt.typeParameters=G(Y),rt}function Qb(P,B=vp(P),Y,ge,rt){return P.tagName!==B||P.constraint!==Y||P.typeParameters!==ge||P.comment!==rt?vn(Wy(B,Y,ge,rt),P):P}function Dk(P,B,Y,ge){let rt=Ld(346,P??Ae("typedef"),ge);return rt.typeExpression=B,rt.fullName=Y,rt.name=TY(Y),rt.locals=void 0,rt.nextContainer=void 0,rt}function L2(P,B=vp(P),Y,ge,rt){return P.tagName!==B||P.typeExpression!==Y||P.fullName!==ge||P.comment!==rt?vn(Dk(B,Y,ge,rt),P):P}function zE(P,B,Y,ge,rt,Qt){let fn=Ld(341,P??Ae("param"),Qt);return fn.typeExpression=ge,fn.name=B,fn.isNameFirst=!!rt,fn.isBracketed=Y,fn}function SD(P,B=vp(P),Y,ge,rt,Qt,fn){return P.tagName!==B||P.name!==Y||P.isBracketed!==ge||P.typeExpression!==rt||P.isNameFirst!==Qt||P.comment!==fn?vn(zE(B,Y,ge,rt,Qt,fn),P):P}function F2(P,B,Y,ge,rt,Qt){let fn=Ld(348,P??Ae("prop"),Qt);return fn.typeExpression=ge,fn.name=B,fn.isNameFirst=!!rt,fn.isBracketed=Y,fn}function Zb(P,B=vp(P),Y,ge,rt,Qt,fn){return P.tagName!==B||P.name!==Y||P.isBracketed!==ge||P.typeExpression!==rt||P.isNameFirst!==Qt||P.comment!==fn?vn(F2(B,Y,ge,rt,Qt,fn),P):P}function Bm(P,B,Y,ge){let rt=Ld(338,P??Ae("callback"),ge);return rt.typeExpression=B,rt.fullName=Y,rt.name=TY(Y),rt.locals=void 0,rt.nextContainer=void 0,rt}function bD(P,B=vp(P),Y,ge,rt){return P.tagName!==B||P.typeExpression!==Y||P.fullName!==ge||P.comment!==rt?vn(Bm(B,Y,ge,rt),P):P}function eT(P,B,Y){let ge=oh(339,P??Ae("overload"),Y);return ge.typeExpression=B,ge}function mS(P,B=vp(P),Y,ge){return P.tagName!==B||P.typeExpression!==Y||P.comment!==ge?vn(eT(B,Y,ge),P):P}function V0(P,B,Y){let ge=oh(328,P??Ae("augments"),Y);return ge.class=B,ge}function n1(P,B=vp(P),Y,ge){return P.tagName!==B||P.class!==Y||P.comment!==ge?vn(V0(B,Y,ge),P):P}function pm(P,B,Y){let ge=oh(329,P??Ae("implements"),Y);return ge.class=B,ge}function i1(P,B,Y){let ge=oh(347,P??Ae("see"),Y);return ge.name=B,ge}function tT(P,B,Y,ge){return P.tagName!==B||P.name!==Y||P.comment!==ge?vn(i1(B,Y,ge),P):P}function wu(P){let B=q(310);return B.name=P,B}function J0(P,B){return P.name!==B?vn(wu(B),P):P}function ch(P,B){let Y=q(311);return Y.left=P,Y.right=B,Y.transformFlags|=Rn(Y.left)|Rn(Y.right),Y}function pl(P,B,Y){return P.left!==B||P.right!==Y?vn(ch(B,Y),P):P}function Au(P,B){let Y=q(324);return Y.name=P,Y.text=B,Y}function q0(P,B,Y){return P.name!==B?vn(Au(B,Y),P):P}function Gf(P,B){let Y=q(325);return Y.name=P,Y.text=B,Y}function Fd(P,B,Y){return P.name!==B?vn(Gf(B,Y),P):P}function wk(P,B){let Y=q(326);return Y.name=P,Y.text=B,Y}function lh(P,B,Y){return P.name!==B?vn(wk(B,Y),P):P}function Ik(P,B=vp(P),Y,ge){return P.tagName!==B||P.class!==Y||P.comment!==ge?vn(pm(B,Y,ge),P):P}function uh(P,B,Y){return oh(P,B??Ae(UG(P)),Y)}function gS(P,B,Y=vp(B),ge){return B.tagName!==Y||B.comment!==ge?vn(uh(P,Y,ge),B):B}function TD(P,B,Y,ge){let rt=oh(P,B??Ae(UG(P)),ge);return rt.typeExpression=Y,rt}function nl(P,B,Y=vp(B),ge,rt){return B.tagName!==Y||B.typeExpression!==ge||B.comment!==rt?vn(TD(P,Y,ge,rt),B):B}function ED(P,B){return oh(327,P,B)}function xD(P,B,Y){return P.tagName!==B||P.comment!==Y?vn(ED(B,Y),P):P}function rT(P,B,Y){let ge=Ld(340,P??Ae(UG(340)),Y);return ge.typeExpression=B,ge.locals=void 0,ge.nextContainer=void 0,ge}function q6(P,B=vp(P),Y,ge){return P.tagName!==B||P.typeExpression!==Y||P.comment!==ge?vn(rT(B,Y,ge),P):P}function G_(P,B,Y,ge,rt){let Qt=oh(351,P??Ae("import"),rt);return Qt.importClause=B,Qt.moduleSpecifier=Y,Qt.attributes=ge,Qt.comment=rt,Qt}function j2(P,B,Y,ge,rt,Qt){return P.tagName!==B||P.comment!==Qt||P.importClause!==Y||P.moduleSpecifier!==ge||P.attributes!==rt?vn(G_(B,Y,ge,rt,Qt),P):P}function WE(P){let B=q(321);return B.text=P,B}function nT(P,B){return P.text!==B?vn(WE(B),P):P}function Mf(P,B){let Y=q(320);return Y.comment=P,Y.tags=oo(B),Y}function z6(P,B,Y){return P.comment!==B||P.tags!==Y?vn(Mf(B,Y),P):P}function iT(P,B,Y){let ge=q(284);return ge.openingElement=P,ge.children=G(B),ge.closingElement=Y,ge.transformFlags|=Rn(ge.openingElement)|eo(ge.children)|Rn(ge.closingElement)|2,ge}function CD(P,B,Y,ge){return P.openingElement!==B||P.children!==Y||P.closingElement!==ge?vn(iT(B,Y,ge),P):P}function sT(P,B,Y){let ge=q(285);return ge.tagName=P,ge.typeArguments=oo(B),ge.attributes=Y,ge.transformFlags|=Rn(ge.tagName)|eo(ge.typeArguments)|Rn(ge.attributes)|2,ge.typeArguments&&(ge.transformFlags|=1),ge}function $E(P,B,Y,ge){return P.tagName!==B||P.typeArguments!==Y||P.attributes!==ge?vn(sT(B,Y,ge),P):P}function Ok(P,B,Y){let ge=q(286);return ge.tagName=P,ge.typeArguments=oo(B),ge.attributes=Y,ge.transformFlags|=Rn(ge.tagName)|eo(ge.typeArguments)|Rn(ge.attributes)|2,B&&(ge.transformFlags|=1),ge}function B2(P,B,Y,ge){return P.tagName!==B||P.typeArguments!==Y||P.attributes!==ge?vn(Ok(B,Y,ge),P):P}function ud(P){let B=q(287);return B.tagName=P,B.transformFlags|=Rn(B.tagName)|2,B}function AD(P,B){return P.tagName!==B?vn(ud(B),P):P}function hS(P,B,Y){let ge=q(288);return ge.openingFragment=P,ge.children=G(B),ge.closingFragment=Y,ge.transformFlags|=Rn(ge.openingFragment)|eo(ge.children)|Rn(ge.closingFragment)|2,ge}function Rp(P,B,Y,ge){return P.openingFragment!==B||P.children!==Y||P.closingFragment!==ge?vn(hS(B,Y,ge),P):P}function mg(P,B){let Y=q(12);return Y.text=P,Y.containsOnlyTriviaWhiteSpaces=!!B,Y.transformFlags|=2,Y}function U2(P,B,Y){return P.text!==B||P.containsOnlyTriviaWhiteSpaces!==Y?vn(mg(B,Y),P):P}function V2(){let P=q(289);return P.transformFlags|=2,P}function ro(){let P=q(290);return P.transformFlags|=2,P}function jn(P,B){let Y=ee(291);return Y.name=P,Y.initializer=B,Y.transformFlags|=Rn(Y.name)|Rn(Y.initializer)|2,Y}function _d(P,B,Y){return P.name!==B||P.initializer!==Y?vn(jn(B,Y),P):P}function Qu(P){let B=ee(292);return B.properties=G(P),B.transformFlags|=eo(B.properties)|2,B}function kD(P,B){return P.properties!==B?vn(Qu(B),P):P}function PD(P){let B=q(293);return B.expression=P,B.transformFlags|=Rn(B.expression)|2,B}function aT(P,B){return P.expression!==B?vn(PD(B),P):P}function yS(P,B){let Y=q(294);return Y.dotDotDotToken=P,Y.expression=B,Y.transformFlags|=Rn(Y.dotDotDotToken)|Rn(Y.expression)|2,Y}function ND(P,B){return P.expression!==B?vn(yS(P.dotDotDotToken,B),P):P}function vS(P,B){let Y=q(295);return Y.namespace=P,Y.name=B,Y.transformFlags|=Rn(Y.namespace)|Rn(Y.name)|2,Y}function Um(P,B,Y){return P.namespace!==B||P.name!==Y?vn(vS(B,Y),P):P}function Mp(P,B){let Y=q(296);return Y.expression=i().parenthesizeExpressionForDisallowedComma(P),Y.statements=G(B),Y.transformFlags|=Rn(Y.expression)|eo(Y.statements),Y.jsDoc=void 0,Y}function ey(P,B,Y){return P.expression!==B||P.statements!==Y?vn(Mp(B,Y),P):P}function _h(P){let B=q(297);return B.statements=G(P),B.transformFlags=eo(B.statements),B}function z0(P,B){return P.statements!==B?vn(_h(B),P):P}function J2(P,B){let Y=q(298);switch(Y.token=P,Y.types=G(B),Y.transformFlags|=eo(Y.types),P){case 96:Y.transformFlags|=1024;break;case 119:Y.transformFlags|=1;break;default:return M.assertNever(P)}return Y}function Ll(P,B){return P.types!==B?vn(J2(P.token,B),P):P}function Vm(P,B){let Y=q(299);return Y.variableDeclaration=jd(P),Y.block=B,Y.transformFlags|=Rn(Y.variableDeclaration)|Rn(Y.block)|(P?0:64),Y.locals=void 0,Y.nextContainer=void 0,Y}function Lp(P,B,Y){return P.variableDeclaration!==B||P.block!==Y?vn(Vm(B,Y),P):P}function s1(P,B){let Y=ee(303);return Y.name=cu(P),Y.initializer=i().parenthesizeExpressionForDisallowedComma(B),Y.transformFlags|=X1(Y.name)|Rn(Y.initializer),Y.modifiers=void 0,Y.questionToken=void 0,Y.exclamationToken=void 0,Y.jsDoc=void 0,Y}function fd(P,B,Y){return P.name!==B||P.initializer!==Y?q2(s1(B,Y),P):P}function q2(P,B){return P!==B&&(P.modifiers=B.modifiers,P.questionToken=B.questionToken,P.exclamationToken=B.exclamationToken),vn(P,B)}function SS(P,B){let Y=ee(304);return Y.name=cu(P),Y.objectAssignmentInitializer=B&&i().parenthesizeExpressionForDisallowedComma(B),Y.transformFlags|=r8(Y.name)|Rn(Y.objectAssignmentInitializer)|1024,Y.equalsToken=void 0,Y.modifiers=void 0,Y.questionToken=void 0,Y.exclamationToken=void 0,Y.jsDoc=void 0,Y}function O(P,B,Y){return P.name!==B||P.objectAssignmentInitializer!==Y?ye(SS(B,Y),P):P}function ye(P,B){return P!==B&&(P.modifiers=B.modifiers,P.questionToken=B.questionToken,P.exclamationToken=B.exclamationToken,P.equalsToken=B.equalsToken),vn(P,B)}function Dt(P){let B=ee(305);return B.expression=i().parenthesizeExpressionForDisallowedComma(P),B.transformFlags|=Rn(B.expression)|128|65536,B.jsDoc=void 0,B}function Zt(P,B){return P.expression!==B?vn(Dt(B),P):P}function bi(P,B){let Y=ee(306);return Y.name=cu(P),Y.initializer=B&&i().parenthesizeExpressionForDisallowedComma(B),Y.transformFlags|=Rn(Y.name)|Rn(Y.initializer)|1,Y.jsDoc=void 0,Y}function ys(P,B,Y){return P.name!==B||P.initializer!==Y?vn(bi(B,Y),P):P}function fs(P,B,Y){let ge=t.createBaseSourceFileNode(307);return ge.statements=G(P),ge.endOfFileToken=B,ge.flags|=Y,ge.text="",ge.fileName="",ge.path="",ge.resolvedPath="",ge.originalFileName="",ge.languageVersion=1,ge.languageVariant=0,ge.scriptKind=0,ge.isDeclarationFile=!1,ge.hasNoDefaultLib=!1,ge.transformFlags|=eo(ge.statements)|Rn(ge.endOfFileToken),ge.locals=void 0,ge.nextContainer=void 0,ge.endFlowNode=void 0,ge.nodeCount=0,ge.identifierCount=0,ge.symbolCount=0,ge.parseDiagnostics=void 0,ge.bindDiagnostics=void 0,ge.bindSuggestionDiagnostics=void 0,ge.lineMap=void 0,ge.externalModuleIndicator=void 0,ge.setExternalModuleIndicator=void 0,ge.pragmas=void 0,ge.checkJsDirective=void 0,ge.referencedFiles=void 0,ge.typeReferenceDirectives=void 0,ge.libReferenceDirectives=void 0,ge.amdDependencies=void 0,ge.commentDirectives=void 0,ge.identifiers=void 0,ge.packageJsonLocations=void 0,ge.packageJsonScope=void 0,ge.imports=void 0,ge.moduleAugmentations=void 0,ge.ambientModuleNames=void 0,ge.classifiableNames=void 0,ge.impliedNodeFormat=void 0,ge}function As(P){let B=Object.create(P.redirectTarget);return Object.defineProperties(B,{id:{get(){return this.redirectInfo.redirectTarget.id},set(Y){this.redirectInfo.redirectTarget.id=Y}},symbol:{get(){return this.redirectInfo.redirectTarget.symbol},set(Y){this.redirectInfo.redirectTarget.symbol=Y}}}),B.redirectInfo=P,B}function Ia(P){let B=As(P.redirectInfo);return B.flags|=P.flags&-17,B.fileName=P.fileName,B.path=P.path,B.resolvedPath=P.resolvedPath,B.originalFileName=P.originalFileName,B.packageJsonLocations=P.packageJsonLocations,B.packageJsonScope=P.packageJsonScope,B.emitNode=void 0,B}function Y_(P){let B=t.createBaseSourceFileNode(307);B.flags|=P.flags&-17;for(let Y in P)if(!(Ho(B,Y)||!Ho(P,Y))){if(Y==="emitNode"){B.emitNode=void 0;continue}B[Y]=P[Y]}return B}function w_(P){let B=P.redirectInfo?Ia(P):Y_(P);return n(B,P),B}function a1(P,B,Y,ge,rt,Qt,fn){let Ts=w_(P);return Ts.statements=G(B),Ts.isDeclarationFile=Y,Ts.referencedFiles=ge,Ts.typeReferenceDirectives=rt,Ts.hasNoDefaultLib=Qt,Ts.libReferenceDirectives=fn,Ts.transformFlags=eo(Ts.statements)|Rn(Ts.endOfFileToken),Ts}function HE(P,B,Y=P.isDeclarationFile,ge=P.referencedFiles,rt=P.typeReferenceDirectives,Qt=P.hasNoDefaultLib,fn=P.libReferenceDirectives){return P.statements!==B||P.isDeclarationFile!==Y||P.referencedFiles!==ge||P.typeReferenceDirectives!==rt||P.hasNoDefaultLib!==Qt||P.libReferenceDirectives!==fn?vn(a1(P,B,Y,ge,rt,Qt,fn),P):P}function Sp(P){let B=q(308);return B.sourceFiles=P,B.syntheticFileReferences=void 0,B.syntheticTypeReferences=void 0,B.syntheticLibReferences=void 0,B.hasNoDefaultLib=void 0,B}function gg(P,B){return P.sourceFiles!==B?vn(Sp(B),P):P}function W0(P,B=!1,Y){let ge=q(237);return ge.type=P,ge.isSpread=B,ge.tupleNameSource=Y,ge}function GE(P){let B=q(352);return B._children=P,B}function DD(P){let B=q(353);return B.original=P,Et(B,P),B}function $0(P,B){let Y=q(354);return Y.expression=P,Y.original=B,Y.transformFlags|=Rn(Y.expression)|1,Et(Y,B),Y}function oT(P,B){return P.expression!==B?vn($0(B,P.original),P):P}function o1(P){if(Ko(P)&&!pI(P)&&!P.original&&!P.emitNode&&!P.id){if(kO(P))return P.elements;if(Pn(P)&&Rde(P.operatorToken))return[P.left,P.right]}return P}function bS(P){let B=q(355);return B.elements=G(KF(P,o1)),B.transformFlags|=eo(B.elements),B}function rs(P,B){return P.elements!==B?vn(bS(B),P):P}function TS(P,B){let Y=q(356);return Y.expression=P,Y.thisArg=B,Y.transformFlags|=Rn(Y.expression)|Rn(Y.thisArg),Y}function ln(P,B,Y){return P.expression!==B||P.thisArg!==Y?vn(TS(B,Y),P):P}function W6(P){let B=me(P.escapedText);return B.flags|=P.flags&-17,B.transformFlags=P.transformFlags,n(B,P),a8(B,{...P.emitNode.autoGenerate}),B}function wD(P){let B=me(P.escapedText);B.flags|=P.flags&-17,B.jsDoc=P.jsDoc,B.flowNode=P.flowNode,B.symbol=P.symbol,B.transformFlags=P.transformFlags,n(B,P);let Y=i2(P);return Y&&Rv(B,Y),B}function Rk(P){let B=Ve(P.escapedText);return B.flags|=P.flags&-17,B.transformFlags=P.transformFlags,n(B,P),a8(B,{...P.emitNode.autoGenerate}),B}function ID(P){let B=Ve(P.escapedText);return B.flags|=P.flags&-17,B.transformFlags=P.transformFlags,n(B,P),B}function OD(P){if(P===void 0)return P;if(Ji(P))return w_(P);if(xc(P))return W6(P);if(He(P))return wD(P);if(zx(P))return Rk(P);if(Zi(P))return ID(P);let B=L3(P.kind)?t.createBaseNode(P.kind):t.createBaseTokenNode(P.kind);B.flags|=P.flags&-17,B.transformFlags=P.transformFlags,n(B,P);for(let Y in P)Ho(B,Y)||!Ho(P,Y)||(B[Y]=P[Y]);return B}function aJ(P,B,Y){return Gr(If(void 0,void 0,void 0,void 0,B?[B]:[],void 0,Jt(P,!0)),void 0,Y?[Y]:[])}function oJ(P,B,Y){return Gr(sd(void 0,void 0,B?[B]:[],void 0,void 0,Jt(P,!0)),void 0,Y?[Y]:[])}function ty(){return $f(pe("0"))}function p7(P){return Op(void 0,!1,P)}function $6(P){return sc(void 0,!1,R2([kk(!1,void 0,P)]))}function H6(P,B){return B==="null"?J.createStrictEquality(P,_t()):B==="undefined"?J.createStrictEquality(P,ty()):J.createStrictEquality(Hl(P),ue(B))}function d7(P,B){return B==="null"?J.createStrictInequality(P,_t()):B==="undefined"?J.createStrictInequality(P,ty()):J.createStrictInequality(Hl(P),ue(B))}function cT(P,B,Y){return qx(P)?Qa(hc(P,void 0,B),void 0,void 0,Y):Gr(Oc(P,B),void 0,Y)}function m7(P,B,Y){return cT(P,"bind",[B,...Y])}function YE(P,B,Y){return cT(P,"call",[B,...Y])}function H0(P,B,Y){return cT(P,"apply",[B,Y])}function KE(P,B,Y){return cT(Ae(P),B,Y)}function dm(P,B){return cT(P,"slice",B===void 0?[]:[xS(B)])}function RD(P,B){return cT(P,"concat",B)}function g7(P,B,Y){return KE("Object","defineProperty",[P,xS(B),Y])}function ry(P,B){return KE("Object","getOwnPropertyDescriptor",[P,xS(B)])}function z2(P,B,Y){return KE("Reflect","get",Y?[P,B,Y]:[P,B])}function h7(P,B,Y,ge){return KE("Reflect","set",ge?[P,B,Y,ge]:[P,B,Y])}function il(P,B,Y){return Y?(P.push(s1(B,Y)),!0):!1}function G6(P,B){let Y=[];il(Y,"enumerable",xS(P.enumerable)),il(Y,"configurable",xS(P.configurable));let ge=il(Y,"writable",xS(P.writable));ge=il(Y,"value",P.value)||ge;let rt=il(Y,"get",P.get);return rt=il(Y,"set",P.set)||rt,M.assert(!(ge&&rt),"A PropertyDescriptor may not be both an accessor descriptor and a data descriptor."),Na(Y,!B)}function Ao(P,B){switch(P.kind){case 217:return id(P,B);case 216:return Wf(P,P.type,B);case 234:return Hv(P,B,P.type);case 238:return dS(P,B,P.type);case 235:return pS(P,B);case 354:return oT(P,B)}}function ao(P){return uf(P)&&Ko(P)&&Ko(Ov(P))&&Ko(Wg(P))&&!Pt(mN(P))&&!Pt(s8(P))}function Mk(P,B,Y=15){return P&&$j(P,Y)&&!ao(P)?Ao(P,Mk(P.expression,B)):B}function Lk(P,B,Y){if(!B)return P;let ge=N2(B,B.label,rS(B.statement)?Lk(P,B.statement):P);return Y&&Y(B),ge}function ie(P,B){let Y=So(P);switch(Y.kind){case 80:return B;case 110:case 9:case 10:case 11:return!1;case 209:return Y.elements.length!==0;case 210:return Y.properties.length>0;default:return!0}}function Le(P,B,Y,ge=!1){let rt=Ml(P,15),Qt,fn;return Cf(rt)?(Qt=Ie(),fn=rt):EO(rt)?(Qt=Ie(),fn=Y!==void 0&&Y<2?Et(Ae("_super"),rt):rt):Ga(rt)&8192?(Qt=ty(),fn=i().parenthesizeLeftSideOfAccess(rt,!1)):Wn(rt)?ie(rt.expression,ge)?(Qt=xe(B),fn=Oc(Et(J.createAssignment(Qt,rt.expression),rt.expression),rt.name),Et(fn,rt)):(Qt=rt.expression,fn=rt):cc(rt)?ie(rt.expression,ge)?(Qt=xe(B),fn=rl(Et(J.createAssignment(Qt,rt.expression),rt.expression),rt.argumentExpression),Et(fn,rt)):(Qt=rt.expression,fn=rt):(Qt=ty(),fn=i().parenthesizeLeftSideOfAccess(P,!1)),{target:fn,thisArg:Qt}}function it(P,B){return Oc(fg(Na([Ce(void 0,"value",[Oi(void 0,void 0,P,void 0,void 0,void 0)],Jt([kn(B)]))])),"value")}function Lt(P){return P.length>10?bS(P):L_(P,J.createComma)}function Kt(P,B,Y,ge=0,rt){let Qt=rt?P&&T5(P):Ps(P);if(Qt&&He(Qt)&&!xc(Qt)){let fn=lo(Et(OD(Qt),Qt),Qt.parent);return ge|=Ga(Qt),Y||(ge|=96),B||(ge|=3072),ge&&Tn(fn,ge),fn}return be(P)}function Rr(P,B,Y){return Kt(P,B,Y,98304)}function ni(P,B,Y,ge){return Kt(P,B,Y,32768,ge)}function Xi(P,B,Y){return Kt(P,B,Y,16384)}function Li(P,B,Y){return Kt(P,B,Y)}function xi(P,B,Y,ge){let rt=Oc(P,Ko(B)?B:OD(B));Et(rt,B);let Qt=0;return ge||(Qt|=96),Y||(Qt|=3072),Qt&&Tn(rt,Qt),rt}function us(P,B,Y,ge){return P&&li(B,32)?xi(P,Kt(B),Y,ge):Xi(B,Y,ge)}function zo(P,B,Y,ge){let rt=pd(P,B,0,Y);return hg(P,B,rt,ge)}function da(P){return La(P.expression)&&P.expression.text==="use strict"}function $a(){return T_(kn(ue("use strict")))}function pd(P,B,Y=0,ge){M.assert(B.length===0,"Prologue directives should be at the first statement in the target statements array");let rt=!1,Qt=P.length;for(;Y<Qt;){let fn=P[Y];if(Mg(fn))da(fn)&&(rt=!0),B.push(fn);else break;Y++}return ge&&!rt&&B.push($a()),Y}function hg(P,B,Y,ge,rt=YS){let Qt=P.length;for(;Y!==void 0&&Y<Qt;){let fn=P[Y];if(Ga(fn)&2097152&&rt(fn))Bt(B,ge?ot(fn,ge,Vi):fn);else break;Y++}return Y}function G0(P){return vY(P)?P:Et(G([$a(),...P]),P)}function ES(P){return M.assert(wi(P,p_e),"Cannot lift nodes to a Block."),Dh(P)||Jt(P)}function mm(P,B,Y){let ge=Y;for(;ge<P.length&&B(P[ge]);)ge++;return ge}function lT(P,B){if(!Pt(B))return P;let Y=mm(P,Mg,0),ge=mm(P,Z5,Y),rt=mm(P,e9,ge),Qt=mm(B,Mg,0),fn=mm(B,Z5,Qt),Ts=mm(B,e9,fn),Xo=mm(B,nR,Ts);M.assert(Xo===B.length,"Expected declarations to be valid standard or custom prologues");let Jm=zT(P)?P.slice():P;if(Xo>Ts&&Jm.splice(rt,0,...B.slice(Ts,Xo)),Ts>fn&&Jm.splice(ge,0,...B.slice(fn,Ts)),fn>Qt&&Jm.splice(Y,0,...B.slice(Qt,fn)),Qt>0)if(Y===0)Jm.splice(0,0,...B.slice(0,Qt));else{let qm=new Map;for(let ny=0;ny<Y;ny++){let Fk=P[ny];qm.set(Fk.expression.text,!0)}for(let ny=Qt-1;ny>=0;ny--){let Fk=B[ny];qm.has(Fk.expression.text)||Jm.unshift(Fk)}}return zT(P)?Et(G(Jm,P.hasTrailingComma),P):P}function Y6(P,B){let Y;return typeof B=="number"?Y=rr(B):Y=B,Ac(P)?Zr(P,Y,P.name,P.constraint,P.default):ns(P)?Sr(P,Y,P.dotDotDotToken,P.name,P.questionToken,P.type,P.initializer):gN(P)?Ht(P,Y,P.typeParameters,P.parameters,P.type):Nf(P)?Ii(P,Y,P.name,P.questionToken,P.type):Ns(P)?$e(P,Y,P.name,P.questionToken??P.exclamationToken,P.type,P.initializer):$g(P)?Vr(P,Y,P.name,P.questionToken,P.typeParameters,P.parameters,P.type):ul(P)?vi(P,Y,P.asteriskToken,P.name,P.questionToken,P.typeParameters,P.parameters,P.type,P.body):Vc(P)?to(P,Y,P.parameters,P.body):Hp(P)?fe(P,Y,P.name,P.parameters,P.type,P.body):fp(P)?nt(P,Y,P.name,P.parameters,P.body):fE(P)?Nt(P,Y,P.parameters,P.type):ic(P)?wd(P,Y,P.asteriskToken,P.name,P.typeParameters,P.parameters,P.type,P.body):pc(P)?Gh(P,Y,P.typeParameters,P.parameters,P.type,P.equalsGreaterThanToken,P.body):eu(P)?od(P,Y,P.name,P.typeParameters,P.heritageClauses,P.members):_l(P)?_n(P,Y,P.declarationList):Tl(P)?Ek(P,Y,P.asteriskToken,P.name,P.typeParameters,P.parameters,P.type,P.body):tu(P)?Hb(P,Y,P.name,P.typeParameters,P.heritageClauses,P.members):Yu(P)?ou(P,Y,P.name,P.typeParameters,P.heritageClauses,P.members):im(P)?Ck(P,Y,P.name,P.typeParameters,P.type):bb(P)?w2(P,Y,P.name,P.members):El(P)?Mm(P,Y,P.name,P.body):ru(P)?Lm(P,Y,P.isTypeOnly,P.name,P.moduleReference):Yc(P)?I2(P,Y,P.importClause,P.moduleSpecifier,P.attributes):dc(P)?VE(P,Y,P.expression):xl(P)?zy(P,Y,P.isTypeOnly,P.exportClause,P.moduleSpecifier,P.attributes):M.assertNever(P)}function MD(P,B){return ns(P)?Sr(P,B,P.dotDotDotToken,P.name,P.questionToken,P.type,P.initializer):Ns(P)?$e(P,B,P.name,P.questionToken??P.exclamationToken,P.type,P.initializer):ul(P)?vi(P,B,P.asteriskToken,P.name,P.questionToken,P.typeParameters,P.parameters,P.type,P.body):Hp(P)?fe(P,B,P.name,P.parameters,P.type,P.body):fp(P)?nt(P,B,P.name,P.parameters,P.body):eu(P)?od(P,B,P.name,P.typeParameters,P.heritageClauses,P.members):tu(P)?Hb(P,B,P.name,P.typeParameters,P.heritageClauses,P.members):M.assertNever(P)}function y7(P,B){switch(P.kind){case 177:return fe(P,P.modifiers,B,P.parameters,P.type,P.body);case 178:return nt(P,P.modifiers,B,P.parameters,P.body);case 174:return vi(P,P.modifiers,P.asteriskToken,B,P.questionToken,P.typeParameters,P.parameters,P.type,P.body);case 173:return Vr(P,P.modifiers,B,P.questionToken,P.typeParameters,P.parameters,P.type);case 172:return $e(P,P.modifiers,B,P.questionToken??P.exclamationToken,P.type,P.initializer);case 171:return Ii(P,P.modifiers,B,P.questionToken,P.type);case 303:return fd(P,B,P.initializer)}}function oo(P){return P?G(P):void 0}function cu(P){return typeof P=="string"?Ae(P):P}function xS(P){return typeof P=="string"?ue(P):typeof P=="number"?pe(P):typeof P=="boolean"?P?mt():Xe():P}function yg(P){return P&&i().parenthesizeExpressionForDisallowedComma(P)}function uT(P){return typeof P=="number"?qe(P):P}function $y(P){return P&&iY(P)?Et(n(Ir(),P),P):P}function jd(P){return typeof P=="string"||P&&!Ei(P)?Rf(P,void 0,void 0,void 0):P}function vn(P,B){return P!==B&&(n(P,B),Et(P,B)),P}}function UG(e){switch(e){case 344:return"type";case 342:return"returns";case 343:return"this";case 340:return"enum";case 330:return"author";case 332:return"class";case 333:return"public";case 334:return"private";case 335:return"protected";case 336:return"readonly";case 337:return"override";case 345:return"template";case 346:return"typedef";case 341:return"param";case 348:return"prop";case 338:return"callback";case 339:return"overload";case 328:return"augments";case 329:return"implements";case 351:return"import";default:return M.fail(`Unsupported kind: ${M.formatSyntaxKind(e)}`)}}var Iv,p4e={};function MSt(e,t){switch(Iv||(Iv=xy(99,!1,0)),e){case 15:Iv.setText("`"+t+"`");break;case 16:Iv.setText("`"+t+"${");break;case 17:Iv.setText("}"+t+"${");break;case 18:Iv.setText("}"+t+"`");break}let n=Iv.scan();if(n===20&&(n=Iv.reScanTemplateToken(!1)),Iv.isUnterminated())return Iv.setText(void 0),p4e;let i;switch(n){case 15:case 16:case 17:case 18:i=Iv.getTokenValue();break}return i===void 0||Iv.scan()!==1?(Iv.setText(void 0),p4e):(Iv.setText(void 0),i)}function X1(e){return e&&He(e)?r8(e):Rn(e)}function r8(e){return Rn(e)&-67108865}function LSt(e,t){return t|e.transformFlags&134234112}function Rn(e){if(!e)return 0;let t=e.transformFlags&~Gpe(e.kind);return Wu(e)&&Ol(e.name)?LSt(e.name,t):t}function eo(e){return e?e.transformFlags:0}function d4e(e){let t=0;for(let n of e)t|=Rn(n);e.transformFlags=t}function Gpe(e){if(e>=182&&e<=205)return-2;switch(e){case 213:case 214:case 209:return-2147450880;case 267:return-1941676032;case 169:return-2147483648;case 219:return-2072174592;case 218:case 262:return-1937940480;case 261:return-2146893824;case 263:case 231:return-2147344384;case 176:return-1937948672;case 172:return-2013249536;case 174:case 177:case 178:return-2005057536;case 133:case 150:case 163:case 146:case 154:case 151:case 136:case 155:case 116:case 168:case 171:case 173:case 179:case 180:case 181:case 264:case 265:return-2;case 210:return-2147278848;case 299:return-2147418112;case 206:case 207:return-2147450880;case 216:case 238:case 234:case 354:case 217:case 108:return-2147483648;case 211:case 212:return-2147483648;default:return-2147483648}}var vj=Jpe();function Sj(e){return e.flags|=16,e}var FSt={createBaseSourceFileNode:e=>Sj(vj.createBaseSourceFileNode(e)),createBaseIdentifierNode:e=>Sj(vj.createBaseIdentifierNode(e)),createBasePrivateIdentifierNode:e=>Sj(vj.createBasePrivateIdentifierNode(e)),createBaseTokenNode:e=>Sj(vj.createBaseTokenNode(e)),createBaseNode:e=>Sj(vj.createBaseNode(e))},U=t8(4,FSt),m4e;function g4e(e,t,n){return new(m4e||(m4e=Hu.getSourceMapSourceConstructor()))(e,t,n)}function zn(e,t){if(e.original!==t&&(e.original=t,t)){let n=t.emitNode;n&&(e.emitNode=jSt(n,e.emitNode))}return e}function jSt(e,t){let{flags:n,internalFlags:i,leadingComments:s,trailingComments:o,commentRange:u,sourceMapRange:m,tokenSourceMapRanges:d,constantValue:S,helpers:E,startsOnNewLine:x,snippetElement:D,classThis:w,assignedName:R}=e;if(t||(t={}),n&&(t.flags=n),i&&(t.internalFlags=i&-9),s&&(t.leadingComments=wn(s.slice(),t.leadingComments)),o&&(t.trailingComments=wn(o.slice(),t.trailingComments)),u&&(t.commentRange=u),m&&(t.sourceMapRange=m),d&&(t.tokenSourceMapRanges=BSt(d,t.tokenSourceMapRanges)),S!==void 0&&(t.constantValue=S),E)for(let L of E)t.helpers=$o(t.helpers,L);return x!==void 0&&(t.startsOnNewLine=x),D!==void 0&&(t.snippetElement=D),w&&(t.classThis=w),R&&(t.assignedName=R),t}function BSt(e,t){t||(t=[]);for(let n in e)t[n]=e[n];return t}function f_(e){if(e.emitNode)M.assert(!(e.emitNode.internalFlags&8),"Invalid attempt to mutate an immutable node.");else{if(pI(e)){if(e.kind===307)return e.emitNode={annotatedNodes:[e]};let t=Ur(ks(Ur(e)))??M.fail("Could not determine parsed source file.");f_(t).annotatedNodes.push(e)}e.emitNode={}}return e.emitNode}function VG(e){var t,n;let i=(n=(t=Ur(ks(e)))==null?void 0:t.emitNode)==null?void 0:n.annotatedNodes;if(i)for(let s of i)s.emitNode=void 0}function n8(e){let t=f_(e);return t.flags|=3072,t.leadingComments=void 0,t.trailingComments=void 0,e}function Tn(e,t){return f_(e).flags=t,e}function zg(e,t){let n=f_(e);return n.flags=n.flags|t,e}function i8(e,t){return f_(e).internalFlags=t,e}function kA(e,t){let n=f_(e);return n.internalFlags=n.internalFlags|t,e}function Ov(e){var t;return((t=e.emitNode)==null?void 0:t.sourceMapRange)??e}function qa(e,t){return f_(e).sourceMapRange=t,e}function h4e(e,t){var n,i;return(i=(n=e.emitNode)==null?void 0:n.tokenSourceMapRanges)==null?void 0:i[t]}function Ype(e,t,n){let i=f_(e),s=i.tokenSourceMapRanges??(i.tokenSourceMapRanges=[]);return s[t]=n,e}function yO(e){var t;return(t=e.emitNode)==null?void 0:t.startsOnNewLine}function bj(e,t){return f_(e).startsOnNewLine=t,e}function Wg(e){var t;return((t=e.emitNode)==null?void 0:t.commentRange)??e}function Zl(e,t){return f_(e).commentRange=t,e}function mN(e){var t;return(t=e.emitNode)==null?void 0:t.leadingComments}function hb(e,t){return f_(e).leadingComments=t,e}function vO(e,t,n,i){return hb(e,Bt(mN(e),{kind:t,pos:-1,end:-1,hasTrailingNewLine:i,text:n}))}function s8(e){var t;return(t=e.emitNode)==null?void 0:t.trailingComments}function PA(e,t){return f_(e).trailingComments=t,e}function Tj(e,t,n,i){return PA(e,Bt(s8(e),{kind:t,pos:-1,end:-1,hasTrailingNewLine:i,text:n}))}function Kpe(e,t){hb(e,mN(t)),PA(e,s8(t));let n=f_(t);return n.leadingComments=void 0,n.trailingComments=void 0,e}function Xpe(e){var t;return(t=e.emitNode)==null?void 0:t.constantValue}function Qpe(e,t){let n=f_(e);return n.constantValue=t,e}function NA(e,t){let n=f_(e);return n.helpers=Bt(n.helpers,t),e}function E0(e,t){if(Pt(t)){let n=f_(e);for(let i of t)n.helpers=$o(n.helpers,i)}return e}function y4e(e,t){var n;let i=(n=e.emitNode)==null?void 0:n.helpers;return i?Gw(i,t):!1}function Ej(e){var t;return(t=e.emitNode)==null?void 0:t.helpers}function Zpe(e,t,n){let i=e.emitNode,s=i&&i.helpers;if(!Pt(s))return;let o=f_(t),u=0;for(let m=0;m<s.length;m++){let d=s[m];n(d)?(u++,o.helpers=$o(o.helpers,d)):u>0&&(s[m-u]=d)}u>0&&(s.length-=u)}function JG(e){var t;return(t=e.emitNode)==null?void 0:t.snippetElement}function qG(e,t){let n=f_(e);return n.snippetElement=t,e}function zG(e){return f_(e).internalFlags|=4,e}function ede(e,t){let n=f_(e);return n.typeNode=t,e}function tde(e){var t;return(t=e.emitNode)==null?void 0:t.typeNode}function Rv(e,t){return f_(e).identifierTypeArguments=t,e}function i2(e){var t;return(t=e.emitNode)==null?void 0:t.identifierTypeArguments}function a8(e,t){return f_(e).autoGenerate=t,e}function v4e(e){var t;return(t=e.emitNode)==null?void 0:t.autoGenerate}function rde(e,t){return f_(e).generatedImportReference=t,e}function nde(e){var t;return(t=e.emitNode)==null?void 0:t.generatedImportReference}var ide=(e=>(e.Field="f",e.Method="m",e.Accessor="a",e))(ide||{});function sde(e){let t=e.factory,n=tf(()=>i8(t.createTrue(),8)),i=tf(()=>i8(t.createFalse(),8));return{getUnscopedHelperName:s,createDecorateHelper:o,createMetadataHelper:u,createParamHelper:m,createESDecorateHelper:L,createRunInitializersHelper:F,createAssignHelper:J,createAwaitHelper:G,createAsyncGeneratorHelper:q,createAsyncDelegatorHelper:ee,createAsyncValuesHelper:W,createRestHelper:pe,createAwaiterHelper:K,createExtendsHelper:re,createTemplateObjectHelper:ue,createSpreadArrayHelper:ce,createPropKeyHelper:ne,createSetFunctionNameHelper:le,createValuesHelper:me,createReadHelper:de,createGeneratorHelper:Ae,createImportStarHelper:xe,createImportStarCallbackHelper:te,createImportDefaultHelper:he,createExportStarHelper:be,createClassPrivateFieldGetHelper:Ve,createClassPrivateFieldSetHelper:Pe,createClassPrivateFieldInHelper:ke,createAddDisposableResourceHelper:De,createDisposeResourcesHelper:Be};function s(ct){return Tn(t.createIdentifier(ct),8196)}function o(ct,qe,et,Ie){e.requestEmitHelper(ode);let _t=[];return _t.push(t.createArrayLiteralExpression(ct,!0)),_t.push(qe),et&&(_t.push(et),Ie&&_t.push(Ie)),t.createCallExpression(s("__decorate"),void 0,_t)}function u(ct,qe){return e.requestEmitHelper(cde),t.createCallExpression(s("__metadata"),void 0,[t.createStringLiteral(ct),qe])}function m(ct,qe,et){return e.requestEmitHelper(lde),Et(t.createCallExpression(s("__param"),void 0,[t.createNumericLiteral(qe+""),ct]),et)}function d(ct){let qe=[t.createPropertyAssignment(t.createIdentifier("kind"),t.createStringLiteral("class")),t.createPropertyAssignment(t.createIdentifier("name"),ct.name),t.createPropertyAssignment(t.createIdentifier("metadata"),ct.metadata)];return t.createObjectLiteralExpression(qe)}function S(ct){let qe=ct.computed?t.createElementAccessExpression(t.createIdentifier("obj"),ct.name):t.createPropertyAccessExpression(t.createIdentifier("obj"),ct.name);return t.createPropertyAssignment("get",t.createArrowFunction(void 0,void 0,[t.createParameterDeclaration(void 0,void 0,t.createIdentifier("obj"))],void 0,void 0,qe))}function E(ct){let qe=ct.computed?t.createElementAccessExpression(t.createIdentifier("obj"),ct.name):t.createPropertyAccessExpression(t.createIdentifier("obj"),ct.name);return t.createPropertyAssignment("set",t.createArrowFunction(void 0,void 0,[t.createParameterDeclaration(void 0,void 0,t.createIdentifier("obj")),t.createParameterDeclaration(void 0,void 0,t.createIdentifier("value"))],void 0,void 0,t.createBlock([t.createExpressionStatement(t.createAssignment(qe,t.createIdentifier("value")))])))}function x(ct){let qe=ct.computed?ct.name:He(ct.name)?t.createStringLiteralFromNode(ct.name):ct.name;return t.createPropertyAssignment("has",t.createArrowFunction(void 0,void 0,[t.createParameterDeclaration(void 0,void 0,t.createIdentifier("obj"))],void 0,void 0,t.createBinaryExpression(qe,103,t.createIdentifier("obj"))))}function D(ct,qe){let et=[];return et.push(x(ct)),qe.get&&et.push(S(ct)),qe.set&&et.push(E(ct)),t.createObjectLiteralExpression(et)}function w(ct){let qe=[t.createPropertyAssignment(t.createIdentifier("kind"),t.createStringLiteral(ct.kind)),t.createPropertyAssignment(t.createIdentifier("name"),ct.name.computed?ct.name.name:t.createStringLiteralFromNode(ct.name.name)),t.createPropertyAssignment(t.createIdentifier("static"),ct.static?t.createTrue():t.createFalse()),t.createPropertyAssignment(t.createIdentifier("private"),ct.private?t.createTrue():t.createFalse()),t.createPropertyAssignment(t.createIdentifier("access"),D(ct.name,ct.access)),t.createPropertyAssignment(t.createIdentifier("metadata"),ct.metadata)];return t.createObjectLiteralExpression(qe)}function R(ct){return ct.kind==="class"?d(ct):w(ct)}function L(ct,qe,et,Ie,_t,mt){return e.requestEmitHelper(ude),t.createCallExpression(s("__esDecorate"),void 0,[ct??t.createNull(),qe??t.createNull(),et,R(Ie),_t,mt])}function F(ct,qe,et){return e.requestEmitHelper(_de),t.createCallExpression(s("__runInitializers"),void 0,et?[ct,qe,et]:[ct,qe])}function J(ct){return Ka(e.getCompilerOptions())>=2?t.createCallExpression(t.createPropertyAccessExpression(t.createIdentifier("Object"),"assign"),void 0,ct):(e.requestEmitHelper(fde),t.createCallExpression(s("__assign"),void 0,ct))}function G(ct){return e.requestEmitHelper(SO),t.createCallExpression(s("__await"),void 0,[ct])}function q(ct,qe){return e.requestEmitHelper(SO),e.requestEmitHelper(pde),(ct.emitNode||(ct.emitNode={})).flags|=1572864,t.createCallExpression(s("__asyncGenerator"),void 0,[qe?t.createThis():t.createVoidZero(),t.createIdentifier("arguments"),ct])}function ee(ct){return e.requestEmitHelper(SO),e.requestEmitHelper(dde),t.createCallExpression(s("__asyncDelegator"),void 0,[ct])}function W(ct){return e.requestEmitHelper(mde),t.createCallExpression(s("__asyncValues"),void 0,[ct])}function pe(ct,qe,et,Ie){e.requestEmitHelper(gde);let _t=[],mt=0;for(let Xe=0;Xe<qe.length-1;Xe++){let ht=bY(qe[Xe]);if(ht)if(za(ht)){M.assertIsDefined(et,"Encountered computed property name but 'computedTempVariables' argument was not provided.");let rr=et[mt];mt++,_t.push(t.createConditionalExpression(t.createTypeCheck(rr,"symbol"),void 0,rr,void 0,t.createAdd(rr,t.createStringLiteral(""))))}else _t.push(t.createStringLiteralFromNode(ht))}return t.createCallExpression(s("__rest"),void 0,[ct,Et(t.createArrayLiteralExpression(_t),Ie)])}function K(ct,qe,et,Ie,_t){e.requestEmitHelper(hde);let mt=t.createFunctionExpression(void 0,t.createToken(42),void 0,void 0,Ie??[],void 0,_t);return(mt.emitNode||(mt.emitNode={})).flags|=1572864,t.createCallExpression(s("__awaiter"),void 0,[ct?t.createThis():t.createVoidZero(),qe??t.createVoidZero(),et?g8(t,et):t.createVoidZero(),mt])}function re(ct){return e.requestEmitHelper(yde),t.createCallExpression(s("__extends"),void 0,[ct,t.createUniqueName("_super",48)])}function ue(ct,qe){return e.requestEmitHelper(vde),t.createCallExpression(s("__makeTemplateObject"),void 0,[ct,qe])}function ce(ct,qe,et){return e.requestEmitHelper(bde),t.createCallExpression(s("__spreadArray"),void 0,[ct,qe,et?n():i()])}function ne(ct){return e.requestEmitHelper(Tde),t.createCallExpression(s("__propKey"),void 0,[ct])}function le(ct,qe,et){return e.requestEmitHelper(Ede),e.factory.createCallExpression(s("__setFunctionName"),void 0,et?[ct,qe,e.factory.createStringLiteral(et)]:[ct,qe])}function me(ct){return e.requestEmitHelper(xde),t.createCallExpression(s("__values"),void 0,[ct])}function de(ct,qe){return e.requestEmitHelper(Sde),t.createCallExpression(s("__read"),void 0,qe!==void 0?[ct,t.createNumericLiteral(qe+"")]:[ct])}function Ae(ct){return e.requestEmitHelper(Cde),t.createCallExpression(s("__generator"),void 0,[t.createThis(),ct])}function xe(ct){return e.requestEmitHelper($G),t.createCallExpression(s("__importStar"),void 0,[ct])}function te(){return e.requestEmitHelper($G),s("__importStar")}function he(ct){return e.requestEmitHelper(kde),t.createCallExpression(s("__importDefault"),void 0,[ct])}function be(ct,qe=t.createIdentifier("exports")){return e.requestEmitHelper(Pde),e.requestEmitHelper(xj),t.createCallExpression(s("__exportStar"),void 0,[ct,qe])}function Ve(ct,qe,et,Ie){e.requestEmitHelper(Nde);let _t;return Ie?_t=[ct,qe,t.createStringLiteral(et),Ie]:_t=[ct,qe,t.createStringLiteral(et)],t.createCallExpression(s("__classPrivateFieldGet"),void 0,_t)}function Pe(ct,qe,et,Ie,_t){e.requestEmitHelper(Dde);let mt;return _t?mt=[ct,qe,et,t.createStringLiteral(Ie),_t]:mt=[ct,qe,et,t.createStringLiteral(Ie)],t.createCallExpression(s("__classPrivateFieldSet"),void 0,mt)}function ke(ct,qe){return e.requestEmitHelper(wde),t.createCallExpression(s("__classPrivateFieldIn"),void 0,[ct,qe])}function De(ct,qe,et){return e.requestEmitHelper(Ide),t.createCallExpression(s("__addDisposableResource"),void 0,[ct,qe,et?t.createTrue():t.createFalse()])}function Be(ct){return e.requestEmitHelper(Ode),t.createCallExpression(s("__disposeResources"),void 0,[ct])}}function ade(e,t){return e===t||e.priority===t.priority?0:e.priority===void 0?1:t.priority===void 0?-1:tc(e.priority,t.priority)}function WG(e,...t){return n=>{let i="";for(let s=0;s<t.length;s++)i+=e[s],i+=n(t[s]);return i+=e[e.length-1],i}}var ode={name:"typescript:decorate",importName:"__decorate",scoped:!1,priority:2,text:`
            var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
                var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
                if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
                else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
                return c > 3 && r && Object.defineProperty(target, key, r), r;
            };`},cde={name:"typescript:metadata",importName:"__metadata",scoped:!1,priority:3,text:`
            var __metadata = (this && this.__metadata) || function (k, v) {
                if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
            };`},lde={name:"typescript:param",importName:"__param",scoped:!1,priority:4,text:`
            var __param = (this && this.__param) || function (paramIndex, decorator) {
                return function (target, key) { decorator(target, key, paramIndex); }
            };`},ude={name:"typescript:esDecorate",importName:"__esDecorate",scoped:!1,priority:2,text:`
        var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
            function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
            var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
            var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
            var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
            var _, done = false;
            for (var i = decorators.length - 1; i >= 0; i--) {
                var context = {};
                for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
                for (var p in contextIn.access) context.access[p] = contextIn.access[p];
                context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
                var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
                if (kind === "accessor") {
                    if (result === void 0) continue;
                    if (result === null || typeof result !== "object") throw new TypeError("Object expected");
                    if (_ = accept(result.get)) descriptor.get = _;
                    if (_ = accept(result.set)) descriptor.set = _;
                    if (_ = accept(result.init)) initializers.unshift(_);
                }
                else if (_ = accept(result)) {
                    if (kind === "field") initializers.unshift(_);
                    else descriptor[key] = _;
                }
            }
            if (target) Object.defineProperty(target, contextIn.name, descriptor);
            done = true;
        };`},_de={name:"typescript:runInitializers",importName:"__runInitializers",scoped:!1,priority:2,text:`
        var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
            var useValue = arguments.length > 2;
            for (var i = 0; i < initializers.length; i++) {
                value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
            }
            return useValue ? value : void 0;
        };`},fde={name:"typescript:assign",importName:"__assign",scoped:!1,priority:1,text:`
            var __assign = (this && this.__assign) || function () {
                __assign = Object.assign || function(t) {
                    for (var s, i = 1, n = arguments.length; i < n; i++) {
                        s = arguments[i];
                        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                            t[p] = s[p];
                    }
                    return t;
                };
                return __assign.apply(this, arguments);
            };`},SO={name:"typescript:await",importName:"__await",scoped:!1,text:`
            var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }`},pde={name:"typescript:asyncGenerator",importName:"__asyncGenerator",scoped:!1,dependencies:[SO],text:`
        var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
            if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
            var g = generator.apply(thisArg, _arguments || []), i, q = [];
            return i = {}, verb("next"), verb("throw"), verb("return", awaitReturn), i[Symbol.asyncIterator] = function () { return this; }, i;
            function awaitReturn(f) { return function (v) { return Promise.resolve(v).then(f, reject); }; }
            function verb(n, f) { if (g[n]) { i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; if (f) i[n] = f(i[n]); } }
            function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
            function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
            function fulfill(value) { resume("next", value); }
            function reject(value) { resume("throw", value); }
            function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
        };`},dde={name:"typescript:asyncDelegator",importName:"__asyncDelegator",scoped:!1,dependencies:[SO],text:`
            var __asyncDelegator = (this && this.__asyncDelegator) || function (o) {
                var i, p;
                return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
                function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
            };`},mde={name:"typescript:asyncValues",importName:"__asyncValues",scoped:!1,text:`
            var __asyncValues = (this && this.__asyncValues) || function (o) {
                if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
                var m = o[Symbol.asyncIterator], i;
                return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
                function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
                function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
            };`},gde={name:"typescript:rest",importName:"__rest",scoped:!1,text:`
            var __rest = (this && this.__rest) || function (s, e) {
                var t = {};
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                    t[p] = s[p];
                if (s != null && typeof Object.getOwnPropertySymbols === "function")
                    for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                        if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                            t[p[i]] = s[p[i]];
                    }
                return t;
            };`},hde={name:"typescript:awaiter",importName:"__awaiter",scoped:!1,priority:5,text:`
            var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
                function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
                return new (P || (P = Promise))(function (resolve, reject) {
                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
                    function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
                    step((generator = generator.apply(thisArg, _arguments || [])).next());
                });
            };`},yde={name:"typescript:extends",importName:"__extends",scoped:!1,priority:0,text:`
            var __extends = (this && this.__extends) || (function () {
                var extendStatics = function (d, b) {
                    extendStatics = Object.setPrototypeOf ||
                        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
                    return extendStatics(d, b);
                };

                return function (d, b) {
                    if (typeof b !== "function" && b !== null)
                        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
                    extendStatics(d, b);
                    function __() { this.constructor = d; }
                    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
                };
            })();`},vde={name:"typescript:makeTemplateObject",importName:"__makeTemplateObject",scoped:!1,priority:0,text:`
            var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
                if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
                return cooked;
            };`},Sde={name:"typescript:read",importName:"__read",scoped:!1,text:`
            var __read = (this && this.__read) || function (o, n) {
                var m = typeof Symbol === "function" && o[Symbol.iterator];
                if (!m) return o;
                var i = m.call(o), r, ar = [], e;
                try {
                    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
                }
                catch (error) { e = { error: error }; }
                finally {
                    try {
                        if (r && !r.done && (m = i["return"])) m.call(i);
                    }
                    finally { if (e) throw e.error; }
                }
                return ar;
            };`},bde={name:"typescript:spreadArray",importName:"__spreadArray",scoped:!1,text:`
            var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
                if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
                    if (ar || !(i in from)) {
                        if (!ar) ar = Array.prototype.slice.call(from, 0, i);
                        ar[i] = from[i];
                    }
                }
                return to.concat(ar || Array.prototype.slice.call(from));
            };`},Tde={name:"typescript:propKey",importName:"__propKey",scoped:!1,text:`
        var __propKey = (this && this.__propKey) || function (x) {
            return typeof x === "symbol" ? x : "".concat(x);
        };`},Ede={name:"typescript:setFunctionName",importName:"__setFunctionName",scoped:!1,text:`
        var __setFunctionName = (this && this.__setFunctionName) || function (f, name, prefix) {
            if (typeof name === "symbol") name = name.description ? "[".concat(name.description, "]") : "";
            return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
        };`},xde={name:"typescript:values",importName:"__values",scoped:!1,text:`
            var __values = (this && this.__values) || function(o) {
                var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
                if (m) return m.call(o);
                if (o && typeof o.length === "number") return {
                    next: function () {
                        if (o && i >= o.length) o = void 0;
                        return { value: o && o[i++], done: !o };
                    }
                };
                throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
            };`},Cde={name:"typescript:generator",importName:"__generator",scoped:!1,priority:6,text:`
            var __generator = (this && this.__generator) || function (thisArg, body) {
                var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
                return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
                function verb(n) { return function (v) { return step([n, v]); }; }
                function step(op) {
                    if (f) throw new TypeError("Generator is already executing.");
                    while (g && (g = 0, op[0] && (_ = 0)), _) try {
                        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                        if (y = 0, t) op = [op[0] & 2, t.value];
                        switch (op[0]) {
                            case 0: case 1: t = op; break;
                            case 4: _.label++; return { value: op[1], done: false };
                            case 5: _.label++; y = op[1]; op = [0]; continue;
                            case 7: op = _.ops.pop(); _.trys.pop(); continue;
                            default:
                                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                                if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                                if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                                if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                                if (t[2]) _.ops.pop();
                                _.trys.pop(); continue;
                        }
                        op = body.call(thisArg, _);
                    } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
                    if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
                }
            };`},xj={name:"typescript:commonjscreatebinding",importName:"__createBinding",scoped:!1,priority:1,text:`
            var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
                if (k2 === undefined) k2 = k;
                var desc = Object.getOwnPropertyDescriptor(m, k);
                if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
                  desc = { enumerable: true, get: function() { return m[k]; } };
                }
                Object.defineProperty(o, k2, desc);
            }) : (function(o, m, k, k2) {
                if (k2 === undefined) k2 = k;
                o[k2] = m[k];
            }));`},Ade={name:"typescript:commonjscreatevalue",importName:"__setModuleDefault",scoped:!1,priority:1,text:`
            var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
                Object.defineProperty(o, "default", { enumerable: true, value: v });
            }) : function(o, v) {
                o["default"] = v;
            });`},$G={name:"typescript:commonjsimportstar",importName:"__importStar",scoped:!1,dependencies:[xj,Ade],priority:2,text:`
            var __importStar = (this && this.__importStar) || function (mod) {
                if (mod && mod.__esModule) return mod;
                var result = {};
                if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
                __setModuleDefault(result, mod);
                return result;
            };`},kde={name:"typescript:commonjsimportdefault",importName:"__importDefault",scoped:!1,text:`
            var __importDefault = (this && this.__importDefault) || function (mod) {
                return (mod && mod.__esModule) ? mod : { "default": mod };
            };`},Pde={name:"typescript:export-star",importName:"__exportStar",scoped:!1,dependencies:[xj],priority:2,text:`
            var __exportStar = (this && this.__exportStar) || function(m, exports) {
                for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
            };`},Nde={name:"typescript:classPrivateFieldGet",importName:"__classPrivateFieldGet",scoped:!1,text:`
            var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
                if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
                if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
                return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
            };`},Dde={name:"typescript:classPrivateFieldSet",importName:"__classPrivateFieldSet",scoped:!1,text:`
            var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
                if (kind === "m") throw new TypeError("Private method is not writable");
                if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
                if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
                return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
            };`},wde={name:"typescript:classPrivateFieldIn",importName:"__classPrivateFieldIn",scoped:!1,text:`
            var __classPrivateFieldIn = (this && this.__classPrivateFieldIn) || function(state, receiver) {
                if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function")) throw new TypeError("Cannot use 'in' operator on non-object");
                return typeof state === "function" ? receiver === state : state.has(receiver);
            };`},Ide={name:"typescript:addDisposableResource",importName:"__addDisposableResource",scoped:!1,text:`
        var __addDisposableResource = (this && this.__addDisposableResource) || function (env, value, async) {
            if (value !== null && value !== void 0) {
                if (typeof value !== "object" && typeof value !== "function") throw new TypeError("Object expected.");
                var dispose, inner;
                if (async) {
                    if (!Symbol.asyncDispose) throw new TypeError("Symbol.asyncDispose is not defined.");
                    dispose = value[Symbol.asyncDispose];
                }
                if (dispose === void 0) {
                    if (!Symbol.dispose) throw new TypeError("Symbol.dispose is not defined.");
                    dispose = value[Symbol.dispose];
                    if (async) inner = dispose;
                }
                if (typeof dispose !== "function") throw new TypeError("Object not disposable.");
                if (inner) dispose = function() { try { inner.call(this); } catch (e) { return Promise.reject(e); } };
                env.stack.push({ value: value, dispose: dispose, async: async });
            }
            else if (async) {
                env.stack.push({ async: true });
            }
            return value;
        };`},Ode={name:"typescript:disposeResources",importName:"__disposeResources",scoped:!1,text:`
        var __disposeResources = (this && this.__disposeResources) || (function (SuppressedError) {
            return function (env) {
                function fail(e) {
                    env.error = env.hasError ? new SuppressedError(e, env.error, "An error was suppressed during disposal.") : e;
                    env.hasError = true;
                }
                function next() {
                    while (env.stack.length) {
                        var rec = env.stack.pop();
                        try {
                            var result = rec.dispose && rec.dispose.call(rec.value);
                            if (rec.async) return Promise.resolve(result).then(next, function(e) { fail(e); return next(); });
                        }
                        catch (e) {
                            fail(e);
                        }
                    }
                    if (env.hasError) throw env.error;
                }
                return next();
            };
        })(typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
            var e = new Error(message);
            return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
        });`},Cj={name:"typescript:async-super",scoped:!0,text:WG`
            const ${"_superIndex"} = name => super[name];`},Aj={name:"typescript:advanced-async-super",scoped:!0,text:WG`
            const ${"_superIndex"} = (function (geti, seti) {
                const cache = Object.create(null);
                return name => cache[name] || (cache[name] = { get value() { return geti(name); }, set value(v) { seti(name, v); } });
            })(name => super[name], (name, value) => super[name] = value);`};function bO(e,t){return ea(e)&&He(e.expression)&&(Ga(e.expression)&8192)!==0&&e.expression.escapedText===t}function Pf(e){return e.kind===9}function o8(e){return e.kind===10}function La(e){return e.kind===11}function DA(e){return e.kind===12}function HG(e){return e.kind===14}function wA(e){return e.kind===15}function IA(e){return e.kind===16}function GG(e){return e.kind===17}function kj(e){return e.kind===18}function Pj(e){return e.kind===26}function Rde(e){return e.kind===28}function YG(e){return e.kind===40}function KG(e){return e.kind===41}function c8(e){return e.kind===42}function l8(e){return e.kind===54}function Q1(e){return e.kind===58}function Mde(e){return e.kind===59}function Nj(e){return e.kind===29}function Lde(e){return e.kind===39}function He(e){return e.kind===80}function Zi(e){return e.kind===81}function OA(e){return e.kind===95}function Dj(e){return e.kind===90}function TO(e){return e.kind===134}function Fde(e){return e.kind===131}function XG(e){return e.kind===135}function jde(e){return e.kind===148}function RA(e){return e.kind===126}function Bde(e){return e.kind===128}function Ude(e){return e.kind===164}function Vde(e){return e.kind===129}function EO(e){return e.kind===108}function xO(e){return e.kind===102}function Jde(e){return e.kind===84}function cf(e){return e.kind===166}function za(e){return e.kind===167}function Ac(e){return e.kind===168}function ns(e){return e.kind===169}function fu(e){return e.kind===170}function Nf(e){return e.kind===171}function Ns(e){return e.kind===172}function $g(e){return e.kind===173}function ul(e){return e.kind===174}function Gc(e){return e.kind===175}function Vc(e){return e.kind===176}function Hp(e){return e.kind===177}function fp(e){return e.kind===178}function MA(e){return e.kind===179}function u8(e){return e.kind===180}function fE(e){return e.kind===181}function LA(e){return e.kind===182}function Gp(e){return e.kind===183}function Jh(e){return e.kind===184}function gN(e){return e.kind===185}function pE(e){return e.kind===186}function lf(e){return e.kind===187}function _8(e){return e.kind===188}function FA(e){return e.kind===189}function hN(e){return e.kind===202}function wj(e){return e.kind===190}function Ij(e){return e.kind===191}function Z1(e){return e.kind===192}function jA(e){return e.kind===193}function dE(e){return e.kind===194}function s2(e){return e.kind===195}function a2(e){return e.kind===196}function yN(e){return e.kind===197}function yb(e){return e.kind===198}function mE(e){return e.kind===199}function o2(e){return e.kind===200}function Mv(e){return e.kind===201}function qh(e){return e.kind===205}function QG(e){return e.kind===204}function qde(e){return e.kind===203}function Yp(e){return e.kind===206}function Lv(e){return e.kind===207}function Xa(e){return e.kind===208}function Gu(e){return e.kind===209}function Ca(e){return e.kind===210}function Wn(e){return e.kind===211}function cc(e){return e.kind===212}function ea(e){return e.kind===213}function gE(e){return e.kind===214}function hE(e){return e.kind===215}function ZG(e){return e.kind===216}function uf(e){return e.kind===217}function ic(e){return e.kind===218}function pc(e){return e.kind===219}function zde(e){return e.kind===220}function vN(e){return e.kind===221}function BA(e){return e.kind===222}function eS(e){return e.kind===223}function tS(e){return e.kind===224}function eY(e){return e.kind===225}function Pn(e){return e.kind===226}function UA(e){return e.kind===227}function Oj(e){return e.kind===228}function Rj(e){return e.kind===229}function Ad(e){return e.kind===230}function eu(e){return e.kind===231}function pu(e){return e.kind===232}function x0(e){return e.kind===233}function CO(e){return e.kind===234}function Mj(e){return e.kind===238}function VA(e){return e.kind===235}function AO(e){return e.kind===236}function S4e(e){return e.kind===237}function Lj(e){return e.kind===354}function kO(e){return e.kind===355}function PO(e){return e.kind===239}function Wde(e){return e.kind===240}function Vs(e){return e.kind===241}function _l(e){return e.kind===243}function tY(e){return e.kind===242}function Du(e){return e.kind===244}function vb(e){return e.kind===245}function b4e(e){return e.kind===246}function rY(e){return e.kind===247}function Sb(e){return e.kind===248}function Fj(e){return e.kind===249}function f8(e){return e.kind===250}function T4e(e){return e.kind===251}function E4e(e){return e.kind===252}function nm(e){return e.kind===253}function $de(e){return e.kind===254}function NO(e){return e.kind===255}function rS(e){return e.kind===256}function nY(e){return e.kind===257}function c2(e){return e.kind===258}function x4e(e){return e.kind===259}function Ei(e){return e.kind===260}function Ru(e){return e.kind===261}function Tl(e){return e.kind===262}function tu(e){return e.kind===263}function Yu(e){return e.kind===264}function im(e){return e.kind===265}function bb(e){return e.kind===266}function El(e){return e.kind===267}function Hg(e){return e.kind===268}function DO(e){return e.kind===269}function p8(e){return e.kind===270}function ru(e){return e.kind===271}function Yc(e){return e.kind===272}function ig(e){return e.kind===273}function C4e(e){return e.kind===302}function Hde(e){return e.kind===300}function A4e(e){return e.kind===301}function l2(e){return e.kind===300}function Gde(e){return e.kind===301}function My(e){return e.kind===274}function zh(e){return e.kind===280}function Gg(e){return e.kind===275}function _f(e){return e.kind===276}function dc(e){return e.kind===277}function xl(e){return e.kind===278}function kd(e){return e.kind===279}function b_(e){return e.kind===281}function k4e(e){return e.kind===282}function iY(e){return e.kind===353}function JA(e){return e.kind===356}function C0(e){return e.kind===283}function Ly(e){return e.kind===284}function u2(e){return e.kind===285}function Yg(e){return e.kind===286}function yE(e){return e.kind===287}function vE(e){return e.kind===288}function _2(e){return e.kind===289}function Yde(e){return e.kind===290}function Kg(e){return e.kind===291}function SE(e){return e.kind===292}function qA(e){return e.kind===293}function wO(e){return e.kind===294}function sg(e){return e.kind===295}function SN(e){return e.kind===296}function IO(e){return e.kind===297}function pp(e){return e.kind===298}function bE(e){return e.kind===299}function ql(e){return e.kind===303}function p_(e){return e.kind===304}function Fy(e){return e.kind===305}function nS(e){return e.kind===306}function Ji(e){return e.kind===307}function Kde(e){return e.kind===308}function Tb(e){return e.kind===309}function OO(e){return e.kind===310}function Eb(e){return e.kind===311}function Xde(e){return e.kind===324}function Qde(e){return e.kind===325}function P4e(e){return e.kind===326}function Zde(e){return e.kind===312}function eme(e){return e.kind===313}function bN(e){return e.kind===314}function jj(e){return e.kind===315}function sY(e){return e.kind===316}function TN(e){return e.kind===317}function Bj(e){return e.kind===318}function N4e(e){return e.kind===319}function ag(e){return e.kind===320}function f2(e){return e.kind===322}function A0(e){return e.kind===323}function zA(e){return e.kind===328}function D4e(e){return e.kind===330}function tme(e){return e.kind===332}function aY(e){return e.kind===338}function oY(e){return e.kind===333}function cY(e){return e.kind===334}function lY(e){return e.kind===335}function uY(e){return e.kind===336}function Uj(e){return e.kind===337}function EN(e){return e.kind===339}function _Y(e){return e.kind===331}function w4e(e){return e.kind===347}function d8(e){return e.kind===340}function Pd(e){return e.kind===341}function Vj(e){return e.kind===342}function fY(e){return e.kind===343}function RO(e){return e.kind===344}function sm(e){return e.kind===345}function p2(e){return e.kind===346}function I4e(e){return e.kind===327}function rme(e){return e.kind===348}function Jj(e){return e.kind===329}function qj(e){return e.kind===350}function O4e(e){return e.kind===349}function Xg(e){return e.kind===351}function xN(e){return e.kind===352}var MO=new WeakMap;function pY(e,t){var n;let i=e.kind;return L3(i)?i===352?e._children:(n=MO.get(t))==null?void 0:n.get(e):ve}function nme(e,t,n){e.kind===352&&M.fail("Should not need to re-set the children of a SyntaxList.");let i=MO.get(t);return i===void 0&&(i=new WeakMap,MO.set(t,i)),i.set(e,n),n}function dY(e,t){var n;e.kind===352&&M.fail("Did not expect to unset the children of a SyntaxList."),(n=MO.get(t))==null||n.delete(e)}function ime(e,t){let n=MO.get(e);n!==void 0&&(MO.delete(e),MO.set(t,n))}function m8(e){return e.createExportDeclaration(void 0,!1,e.createNamedExports([]),void 0)}function d2(e,t,n,i){if(za(n))return Et(e.createElementAccessExpression(t,n.expression),i);{let s=Et(Cy(n)?e.createPropertyAccessExpression(t,n):e.createElementAccessExpression(t,n),n);return zg(s,128),s}}function sme(e,t){let n=Cb.createIdentifier(e||"React");return lo(n,ks(t)),n}function ame(e,t,n){if(cf(t)){let i=ame(e,t.left,n),s=e.createIdentifier(Nn(t.right));return s.escapedText=t.right.escapedText,e.createPropertyAccessExpression(i,s)}else return sme(Nn(t),n)}function mY(e,t,n,i){return t?ame(e,t,i):e.createPropertyAccessExpression(sme(n,i),"createElement")}function USt(e,t,n,i){return t?ame(e,t,i):e.createPropertyAccessExpression(sme(n,i),"Fragment")}function ome(e,t,n,i,s,o){let u=[n];if(i&&u.push(i),s&&s.length>0)if(i||u.push(e.createNull()),s.length>1)for(let m of s)T_(m),u.push(m);else u.push(s[0]);return Et(e.createCallExpression(t,void 0,u),o)}function cme(e,t,n,i,s,o,u){let d=[USt(e,n,i,o),e.createNull()];if(s&&s.length>0)if(s.length>1)for(let S of s)T_(S),d.push(S);else d.push(s[0]);return Et(e.createCallExpression(mY(e,t,i,o),void 0,d),u)}function gY(e,t,n){if(Ru(t)){let i=Ma(t.declarations),s=e.updateVariableDeclaration(i,i.name,void 0,void 0,n);return Et(e.createVariableStatement(void 0,e.updateVariableDeclarationList(t,[s])),t)}else{let i=Et(e.createAssignment(t,n),t);return Et(e.createExpressionStatement(i),t)}}function R4e(e,t,n){return Vs(t)?e.updateBlock(t,Et(e.createNodeArray([n,...t.statements]),t.statements)):e.createBlock(e.createNodeArray([t,n]),!0)}function g8(e,t){if(cf(t)){let n=g8(e,t.left),i=lo(Et(e.cloneNode(t.right),t.right),t.right.parent);return Et(e.createPropertyAccessExpression(n,i),t)}else return lo(Et(e.cloneNode(t),t),t.parent)}function hY(e,t){return He(t)?e.createStringLiteralFromNode(t):za(t)?lo(Et(e.cloneNode(t.expression),t.expression),t.expression.parent):lo(Et(e.cloneNode(t),t),t.parent)}function VSt(e,t,n,i,s){let{firstAccessor:o,getAccessor:u,setAccessor:m}=W1(t,n);if(n===o)return Et(e.createObjectDefinePropertyCall(i,hY(e,n.name),e.createPropertyDescriptor({enumerable:e.createFalse(),configurable:!0,get:u&&Et(zn(e.createFunctionExpression(qT(u),void 0,void 0,void 0,u.parameters,void 0,u.body),u),u),set:m&&Et(zn(e.createFunctionExpression(qT(m),void 0,void 0,void 0,m.parameters,void 0,m.body),m),m)},!s)),o)}function JSt(e,t,n){return zn(Et(e.createAssignment(d2(e,n,t.name,t.name),t.initializer),t),t)}function qSt(e,t,n){return zn(Et(e.createAssignment(d2(e,n,t.name,t.name),e.cloneNode(t.name)),t),t)}function zSt(e,t,n){return zn(Et(e.createAssignment(d2(e,n,t.name,t.name),zn(Et(e.createFunctionExpression(qT(t),t.asteriskToken,void 0,void 0,t.parameters,void 0,t.body),t),t)),t),t)}function lme(e,t,n,i){switch(n.name&&Zi(n.name)&&M.failBadSyntaxKind(n.name,"Private identifiers are not allowed in object literals."),n.kind){case 177:case 178:return VSt(e,t.properties,n,i,!!t.multiLine);case 303:return JSt(e,n,i);case 304:return qSt(e,n,i);case 174:return zSt(e,n,i)}}function zj(e,t,n,i,s){let o=t.operator;M.assert(o===46||o===47,"Expected 'node' to be a pre- or post-increment or pre- or post-decrement expression");let u=e.createTempVariable(i);n=e.createAssignment(u,n),Et(n,t.operand);let m=tS(t)?e.createPrefixUnaryExpression(o,u):e.createPostfixUnaryExpression(u,o);return Et(m,t),s&&(m=e.createAssignment(s,m),Et(m,t)),n=e.createComma(n,m),Et(n,t),eY(t)&&(n=e.createComma(n,u),Et(n,t)),n}function yY(e){return(Ga(e)&65536)!==0}function k0(e){return(Ga(e)&32768)!==0}function Wj(e){return(Ga(e)&16384)!==0}function M4e(e){return La(e.expression)&&e.expression.text==="use strict"}function vY(e){for(let t of e)if(Mg(t)){if(M4e(t))return t}else break}function ume(e){let t=xo(e);return t!==void 0&&Mg(t)&&M4e(t)}function h8(e){return e.kind===226&&e.operatorToken.kind===28}function LO(e){return h8(e)||kO(e)}function m2(e){return uf(e)&&hn(e)&&!!tb(e)}function FO(e){let t=rb(e);return M.assertIsDefined(t),t}function $j(e,t=15){switch(e.kind){case 217:return t&16&&m2(e)?!1:(t&1)!==0;case 216:case 234:case 233:case 238:return(t&2)!==0;case 235:return(t&4)!==0;case 354:return(t&8)!==0}return!1}function Ml(e,t=15){for(;$j(e,t);)e=e.expression;return e}function _me(e,t=15){let n=e.parent;for(;$j(n,t);)n=n.parent,M.assert(n);return n}function L4e(e){return Ml(e,6)}function T_(e){return bj(e,!0)}function Hj(e){let t=Bc(e,Ji),n=t&&t.emitNode;return n&&n.externalHelpersModuleName}function fme(e){let t=Bc(e,Ji),n=t&&t.emitNode;return!!n&&(!!n.externalHelpersModuleName||!!n.externalHelpers)}function SY(e,t,n,i,s,o,u){if(i.importHelpers&&ZC(n,i)){let m,d=V_(i);if(d>=5&&d<=99||n.impliedNodeFormat===99){let S=Ej(n);if(S){let E=[];for(let x of S)if(!x.scoped){let D=x.importName;D&&ol(E,D)}if(Pt(E)){E.sort(c_),m=e.createNamedImports(Cr(E,w=>W5(n,w)?e.createImportSpecifier(!1,void 0,e.createIdentifier(w)):e.createImportSpecifier(!1,e.createIdentifier(w),t.getUnscopedHelperName(w))));let x=Bc(n,Ji),D=f_(x);D.externalHelpers=!0}}}else{let S=pme(e,n,i,s,o||u);S&&(m=e.createNamespaceImport(S))}if(m){let S=e.createImportDeclaration(void 0,e.createImportClause(!1,void 0,m),e.createStringLiteral(ab),void 0);return kA(S,2),S}}}function pme(e,t,n,i,s){if(n.importHelpers&&ZC(t,n)){let o=Hj(t);if(o)return o;let u=V_(n),m=(i||Iy(n)&&s)&&u!==4&&(u<5||t.impliedNodeFormat===1);if(!m){let d=Ej(t);if(d){for(let S of d)if(!S.scoped){m=!0;break}}}if(m){let d=Bc(t,Ji),S=f_(d);return S.externalHelpersModuleName||(S.externalHelpersModuleName=e.createUniqueName(ab))}}}function CN(e,t,n){let i=KP(t);if(i&&!aA(t)&&!H5(t)){let s=i.name;return xc(s)?s:e.createIdentifier(GT(n,s)||Nn(s))}if(t.kind===272&&t.importClause||t.kind===278&&t.moduleSpecifier)return e.getGeneratedNameForNode(t)}function WA(e,t,n,i,s,o){let u=sA(t);if(u&&La(u))return $St(t,i,e,s,o)||WSt(e,u,n)||e.cloneNode(u)}function WSt(e,t,n){let i=n.renamedDependencies&&n.renamedDependencies.get(t.text);return i?e.createStringLiteral(i):void 0}function y8(e,t,n,i){if(t){if(t.moduleName)return e.createStringLiteral(t.moduleName);if(!t.isDeclarationFile&&i.outFile)return e.createStringLiteral($H(n,t.fileName))}}function $St(e,t,n,i,s){return y8(n,i.getExternalModuleFileFromDeclaration(e),t,s)}function v8(e){if(j3(e))return e.initializer;if(ql(e)){let t=e.initializer;return Su(t,!0)?t.right:void 0}if(p_(e))return e.objectAssignmentInitializer;if(Su(e,!0))return e.right;if(Ad(e))return v8(e.expression)}function iS(e){if(j3(e))return e.name;if(p0(e)){switch(e.kind){case 303:return iS(e.initializer);case 304:return e.name;case 305:return iS(e.expression)}return}return Su(e,!0)?iS(e.left):Ad(e)?iS(e.expression):e}function Gj(e){switch(e.kind){case 169:case 208:return e.dotDotDotToken;case 230:case 305:return e}}function bY(e){let t=Yj(e);return M.assert(!!t||Fy(e),"Invalid property name for binding element."),t}function Yj(e){switch(e.kind){case 208:if(e.propertyName){let n=e.propertyName;return Zi(n)?M.failBadSyntaxKind(n):za(n)&&F4e(n.expression)?n.expression:n}break;case 303:if(e.name){let n=e.name;return Zi(n)?M.failBadSyntaxKind(n):za(n)&&F4e(n.expression)?n.expression:n}break;case 305:return e.name&&Zi(e.name)?M.failBadSyntaxKind(e.name):e.name}let t=iS(e);if(t&&Ol(t))return t}function F4e(e){let t=e.kind;return t===11||t===9}function AN(e){switch(e.kind){case 206:case 207:case 209:return e.elements;case 210:return e.properties}}function TY(e){if(e){let t=e;for(;;){if(He(t)||!t.body)return He(t)?t:t.name;t=t.body}}}function j4e(e){let t=e.kind;return t===176||t===178}function dme(e){let t=e.kind;return t===176||t===177||t===178}function EY(e){let t=e.kind;return t===303||t===304||t===262||t===176||t===181||t===175||t===282||t===243||t===264||t===265||t===266||t===267||t===271||t===272||t===270||t===278||t===277}function mme(e){let t=e.kind;return t===175||t===303||t===304||t===282||t===270}function gme(e){return Q1(e)||l8(e)}function hme(e){return He(e)||yN(e)}function yme(e){return jde(e)||YG(e)||KG(e)}function vme(e){return Q1(e)||YG(e)||KG(e)}function Sme(e){return He(e)||La(e)}function B4e(e){let t=e.kind;return t===106||t===112||t===97||WT(e)||tS(e)}function HSt(e){return e===43}function GSt(e){return e===42||e===44||e===45}function YSt(e){return HSt(e)||GSt(e)}function KSt(e){return e===40||e===41}function XSt(e){return KSt(e)||YSt(e)}function QSt(e){return e===48||e===49||e===50}function xY(e){return QSt(e)||XSt(e)}function ZSt(e){return e===30||e===33||e===32||e===34||e===104||e===103}function ebt(e){return ZSt(e)||xY(e)}function tbt(e){return e===35||e===37||e===36||e===38}function rbt(e){return tbt(e)||ebt(e)}function nbt(e){return e===51||e===52||e===53}function ibt(e){return nbt(e)||rbt(e)}function sbt(e){return e===56||e===57}function abt(e){return sbt(e)||ibt(e)}function obt(e){return e===61||abt(e)||y0(e)}function cbt(e){return obt(e)||e===28}function bme(e){return cbt(e.kind)}var CY;(e=>{function t(E,x,D,w,R,L,F){let J=x>0?R[x-1]:void 0;return M.assertEqual(D[x],t),R[x]=E.onEnter(w[x],J,F),D[x]=m(E,t),x}e.enter=t;function n(E,x,D,w,R,L,F){M.assertEqual(D[x],n),M.assertIsDefined(E.onLeft),D[x]=m(E,n);let J=E.onLeft(w[x].left,R[x],w[x]);return J?(S(x,w,J),d(x,D,w,R,J)):x}e.left=n;function i(E,x,D,w,R,L,F){return M.assertEqual(D[x],i),M.assertIsDefined(E.onOperator),D[x]=m(E,i),E.onOperator(w[x].operatorToken,R[x],w[x]),x}e.operator=i;function s(E,x,D,w,R,L,F){M.assertEqual(D[x],s),M.assertIsDefined(E.onRight),D[x]=m(E,s);let J=E.onRight(w[x].right,R[x],w[x]);return J?(S(x,w,J),d(x,D,w,R,J)):x}e.right=s;function o(E,x,D,w,R,L,F){M.assertEqual(D[x],o),D[x]=m(E,o);let J=E.onExit(w[x],R[x]);if(x>0){if(x--,E.foldState){let G=D[x]===o?"right":"left";R[x]=E.foldState(R[x],J,G)}}else L.value=J;return x}e.exit=o;function u(E,x,D,w,R,L,F){return M.assertEqual(D[x],u),x}e.done=u;function m(E,x){switch(x){case t:if(E.onLeft)return n;case n:if(E.onOperator)return i;case i:if(E.onRight)return s;case s:return o;case o:return u;case u:return u;default:M.fail("Invalid state")}}e.nextState=m;function d(E,x,D,w,R){return E++,x[E]=t,D[E]=R,w[E]=void 0,E}function S(E,x,D){if(M.shouldAssert(2))for(;E>=0;)M.assert(x[E]!==D,"Circular traversal detected."),E--}})(CY||(CY={}));var lbt=class{constructor(e,t,n,i,s,o){this.onEnter=e,this.onLeft=t,this.onOperator=n,this.onRight=i,this.onExit=s,this.foldState=o}};function Kj(e,t,n,i,s,o){let u=new lbt(e,t,n,i,s,o);return m;function m(d,S){let E={value:void 0},x=[CY.enter],D=[d],w=[void 0],R=0;for(;x[R]!==CY.done;)R=x[R](u,R,x,D,w,E,S);return M.assertEqual(R,0),E.value}}function U4e(e){return e===95||e===90}function S8(e){let t=e.kind;return U4e(t)}function V4e(e){let t=e.kind;return vv(t)&&!U4e(t)}function Tme(e,t){if(t!==void 0)return t.length===0?t:Et(e.createNodeArray([],t.hasTrailingComma),t)}function b8(e){var t;let n=e.emitNode.autoGenerate;if(n.flags&4){let i=n.id,s=e,o=s.original;for(;o;){s=o;let u=(t=s.emitNode)==null?void 0:t.autoGenerate;if(Cy(s)&&(u===void 0||u.flags&4&&u.id!==i))break;o=s.original}return s}return e}function kN(e,t){return typeof e=="object"?xb(!1,e.prefix,e.node,e.suffix,t):typeof e=="string"?e.length>0&&e.charCodeAt(0)===35?e.slice(1):e:""}function ubt(e,t){return typeof e=="string"?e:_bt(e,M.checkDefined(t))}function _bt(e,t){return zx(e)?t(e).slice(1):xc(e)?t(e):Zi(e)?e.escapedText.slice(1):Nn(e)}function xb(e,t,n,i,s){return t=kN(t,s),i=kN(i,s),n=ubt(n,s),`${e?"#":""}${t}${n}${i}`}function AY(e,t,n,i){return e.updatePropertyDeclaration(t,n,e.getGeneratedPrivateNameForNode(t.name,void 0,"_accessor_storage"),void 0,void 0,i)}function Eme(e,t,n,i,s=e.createThis()){return e.createGetAccessorDeclaration(n,i,[],void 0,e.createBlock([e.createReturnStatement(e.createPropertyAccessExpression(s,e.getGeneratedPrivateNameForNode(t.name,void 0,"_accessor_storage")))]))}function xme(e,t,n,i,s=e.createThis()){return e.createSetAccessorDeclaration(n,i,[e.createParameterDeclaration(void 0,void 0,"value")],e.createBlock([e.createExpressionStatement(e.createAssignment(e.createPropertyAccessExpression(s,e.getGeneratedPrivateNameForNode(t.name,void 0,"_accessor_storage")),e.createIdentifier("value")))]))}function Xj(e){let t=e.expression;for(;;){if(t=Ml(t),kO(t)){t=Va(t.elements);continue}if(h8(t)){t=t.right;continue}if(Su(t,!0)&&xc(t.left))return t;break}}function fbt(e){return uf(e)&&Ko(e)&&!e.emitNode}function Qj(e,t){if(fbt(e))Qj(e.expression,t);else if(h8(e))Qj(e.left,t),Qj(e.right,t);else if(kO(e))for(let n of e.elements)Qj(n,t);else t.push(e)}function Cme(e){let t=[];return Qj(e,t),t}function T8(e){if(e.transformFlags&65536)return!0;if(e.transformFlags&128)for(let t of AN(e)){let n=iS(t);if(n&&TI(n)&&(n.transformFlags&65536||n.transformFlags&128&&T8(n)))return!0}return!1}function Et(e,t){return t?qg(e,t.pos,t.end):e}function wm(e){let t=e.kind;return t===168||t===169||t===171||t===172||t===173||t===174||t===176||t===177||t===178||t===181||t===185||t===218||t===219||t===231||t===243||t===262||t===263||t===264||t===265||t===266||t===267||t===271||t===272||t===277||t===278}function TE(e){let t=e.kind;return t===169||t===172||t===174||t===177||t===178||t===231||t===263}var J4e,q4e,z4e,W4e,$4e,Ame={createBaseSourceFileNode:e=>new($4e||($4e=Hu.getSourceFileConstructor()))(e,-1,-1),createBaseIdentifierNode:e=>new(z4e||(z4e=Hu.getIdentifierConstructor()))(e,-1,-1),createBasePrivateIdentifierNode:e=>new(W4e||(W4e=Hu.getPrivateIdentifierConstructor()))(e,-1,-1),createBaseTokenNode:e=>new(q4e||(q4e=Hu.getTokenConstructor()))(e,-1,-1),createBaseNode:e=>new(J4e||(J4e=Hu.getNodeConstructor()))(e,-1,-1)},Cb=t8(1,Ame);function ir(e,t){return t&&e(t)}function qi(e,t,n){if(n){if(t)return t(n);for(let i of n){let s=e(i);if(s)return s}}}function kY(e,t){return e.charCodeAt(t+1)===42&&e.charCodeAt(t+2)===42&&e.charCodeAt(t+3)!==47}function E8(e){return kt(e.statements,pbt)||dbt(e)}function pbt(e){return wm(e)&&mbt(e,95)||ru(e)&&C0(e.moduleReference)||Yc(e)||dc(e)||xl(e)?e:void 0}function dbt(e){return e.flags&8388608?H4e(e):void 0}function H4e(e){return gbt(e)?e:Js(e,H4e)}function mbt(e,t){return Pt(e.modifiers,n=>n.kind===t)}function gbt(e){return AO(e)&&e.keywordToken===102&&e.name.escapedText==="meta"}var hbt={166:function(t,n,i){return ir(n,t.left)||ir(n,t.right)},168:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.name)||ir(n,t.constraint)||ir(n,t.default)||ir(n,t.expression)},304:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.name)||ir(n,t.questionToken)||ir(n,t.exclamationToken)||ir(n,t.equalsToken)||ir(n,t.objectAssignmentInitializer)},305:function(t,n,i){return ir(n,t.expression)},169:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.dotDotDotToken)||ir(n,t.name)||ir(n,t.questionToken)||ir(n,t.type)||ir(n,t.initializer)},172:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.name)||ir(n,t.questionToken)||ir(n,t.exclamationToken)||ir(n,t.type)||ir(n,t.initializer)},171:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.name)||ir(n,t.questionToken)||ir(n,t.type)||ir(n,t.initializer)},303:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.name)||ir(n,t.questionToken)||ir(n,t.exclamationToken)||ir(n,t.initializer)},260:function(t,n,i){return ir(n,t.name)||ir(n,t.exclamationToken)||ir(n,t.type)||ir(n,t.initializer)},208:function(t,n,i){return ir(n,t.dotDotDotToken)||ir(n,t.propertyName)||ir(n,t.name)||ir(n,t.initializer)},181:function(t,n,i){return qi(n,i,t.modifiers)||qi(n,i,t.typeParameters)||qi(n,i,t.parameters)||ir(n,t.type)},185:function(t,n,i){return qi(n,i,t.modifiers)||qi(n,i,t.typeParameters)||qi(n,i,t.parameters)||ir(n,t.type)},184:function(t,n,i){return qi(n,i,t.modifiers)||qi(n,i,t.typeParameters)||qi(n,i,t.parameters)||ir(n,t.type)},179:G4e,180:G4e,174:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.asteriskToken)||ir(n,t.name)||ir(n,t.questionToken)||ir(n,t.exclamationToken)||qi(n,i,t.typeParameters)||qi(n,i,t.parameters)||ir(n,t.type)||ir(n,t.body)},173:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.name)||ir(n,t.questionToken)||qi(n,i,t.typeParameters)||qi(n,i,t.parameters)||ir(n,t.type)},176:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.name)||qi(n,i,t.typeParameters)||qi(n,i,t.parameters)||ir(n,t.type)||ir(n,t.body)},177:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.name)||qi(n,i,t.typeParameters)||qi(n,i,t.parameters)||ir(n,t.type)||ir(n,t.body)},178:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.name)||qi(n,i,t.typeParameters)||qi(n,i,t.parameters)||ir(n,t.type)||ir(n,t.body)},262:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.asteriskToken)||ir(n,t.name)||qi(n,i,t.typeParameters)||qi(n,i,t.parameters)||ir(n,t.type)||ir(n,t.body)},218:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.asteriskToken)||ir(n,t.name)||qi(n,i,t.typeParameters)||qi(n,i,t.parameters)||ir(n,t.type)||ir(n,t.body)},219:function(t,n,i){return qi(n,i,t.modifiers)||qi(n,i,t.typeParameters)||qi(n,i,t.parameters)||ir(n,t.type)||ir(n,t.equalsGreaterThanToken)||ir(n,t.body)},175:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.body)},183:function(t,n,i){return ir(n,t.typeName)||qi(n,i,t.typeArguments)},182:function(t,n,i){return ir(n,t.assertsModifier)||ir(n,t.parameterName)||ir(n,t.type)},186:function(t,n,i){return ir(n,t.exprName)||qi(n,i,t.typeArguments)},187:function(t,n,i){return qi(n,i,t.members)},188:function(t,n,i){return ir(n,t.elementType)},189:function(t,n,i){return qi(n,i,t.elements)},192:Y4e,193:Y4e,194:function(t,n,i){return ir(n,t.checkType)||ir(n,t.extendsType)||ir(n,t.trueType)||ir(n,t.falseType)},195:function(t,n,i){return ir(n,t.typeParameter)},205:function(t,n,i){return ir(n,t.argument)||ir(n,t.attributes)||ir(n,t.qualifier)||qi(n,i,t.typeArguments)},302:function(t,n,i){return ir(n,t.assertClause)},196:K4e,198:K4e,199:function(t,n,i){return ir(n,t.objectType)||ir(n,t.indexType)},200:function(t,n,i){return ir(n,t.readonlyToken)||ir(n,t.typeParameter)||ir(n,t.nameType)||ir(n,t.questionToken)||ir(n,t.type)||qi(n,i,t.members)},201:function(t,n,i){return ir(n,t.literal)},202:function(t,n,i){return ir(n,t.dotDotDotToken)||ir(n,t.name)||ir(n,t.questionToken)||ir(n,t.type)},206:X4e,207:X4e,209:function(t,n,i){return qi(n,i,t.elements)},210:function(t,n,i){return qi(n,i,t.properties)},211:function(t,n,i){return ir(n,t.expression)||ir(n,t.questionDotToken)||ir(n,t.name)},212:function(t,n,i){return ir(n,t.expression)||ir(n,t.questionDotToken)||ir(n,t.argumentExpression)},213:Q4e,214:Q4e,215:function(t,n,i){return ir(n,t.tag)||ir(n,t.questionDotToken)||qi(n,i,t.typeArguments)||ir(n,t.template)},216:function(t,n,i){return ir(n,t.type)||ir(n,t.expression)},217:function(t,n,i){return ir(n,t.expression)},220:function(t,n,i){return ir(n,t.expression)},221:function(t,n,i){return ir(n,t.expression)},222:function(t,n,i){return ir(n,t.expression)},224:function(t,n,i){return ir(n,t.operand)},229:function(t,n,i){return ir(n,t.asteriskToken)||ir(n,t.expression)},223:function(t,n,i){return ir(n,t.expression)},225:function(t,n,i){return ir(n,t.operand)},226:function(t,n,i){return ir(n,t.left)||ir(n,t.operatorToken)||ir(n,t.right)},234:function(t,n,i){return ir(n,t.expression)||ir(n,t.type)},235:function(t,n,i){return ir(n,t.expression)},238:function(t,n,i){return ir(n,t.expression)||ir(n,t.type)},236:function(t,n,i){return ir(n,t.name)},227:function(t,n,i){return ir(n,t.condition)||ir(n,t.questionToken)||ir(n,t.whenTrue)||ir(n,t.colonToken)||ir(n,t.whenFalse)},230:function(t,n,i){return ir(n,t.expression)},241:Z4e,268:Z4e,307:function(t,n,i){return qi(n,i,t.statements)||ir(n,t.endOfFileToken)},243:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.declarationList)},261:function(t,n,i){return qi(n,i,t.declarations)},244:function(t,n,i){return ir(n,t.expression)},245:function(t,n,i){return ir(n,t.expression)||ir(n,t.thenStatement)||ir(n,t.elseStatement)},246:function(t,n,i){return ir(n,t.statement)||ir(n,t.expression)},247:function(t,n,i){return ir(n,t.expression)||ir(n,t.statement)},248:function(t,n,i){return ir(n,t.initializer)||ir(n,t.condition)||ir(n,t.incrementor)||ir(n,t.statement)},249:function(t,n,i){return ir(n,t.initializer)||ir(n,t.expression)||ir(n,t.statement)},250:function(t,n,i){return ir(n,t.awaitModifier)||ir(n,t.initializer)||ir(n,t.expression)||ir(n,t.statement)},251:e3e,252:e3e,253:function(t,n,i){return ir(n,t.expression)},254:function(t,n,i){return ir(n,t.expression)||ir(n,t.statement)},255:function(t,n,i){return ir(n,t.expression)||ir(n,t.caseBlock)},269:function(t,n,i){return qi(n,i,t.clauses)},296:function(t,n,i){return ir(n,t.expression)||qi(n,i,t.statements)},297:function(t,n,i){return qi(n,i,t.statements)},256:function(t,n,i){return ir(n,t.label)||ir(n,t.statement)},257:function(t,n,i){return ir(n,t.expression)},258:function(t,n,i){return ir(n,t.tryBlock)||ir(n,t.catchClause)||ir(n,t.finallyBlock)},299:function(t,n,i){return ir(n,t.variableDeclaration)||ir(n,t.block)},170:function(t,n,i){return ir(n,t.expression)},263:t3e,231:t3e,264:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.name)||qi(n,i,t.typeParameters)||qi(n,i,t.heritageClauses)||qi(n,i,t.members)},265:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.name)||qi(n,i,t.typeParameters)||ir(n,t.type)},266:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.name)||qi(n,i,t.members)},306:function(t,n,i){return ir(n,t.name)||ir(n,t.initializer)},267:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.name)||ir(n,t.body)},271:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.name)||ir(n,t.moduleReference)},272:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.importClause)||ir(n,t.moduleSpecifier)||ir(n,t.attributes)},273:function(t,n,i){return ir(n,t.name)||ir(n,t.namedBindings)},300:function(t,n,i){return qi(n,i,t.elements)},301:function(t,n,i){return ir(n,t.name)||ir(n,t.value)},270:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.name)},274:function(t,n,i){return ir(n,t.name)},280:function(t,n,i){return ir(n,t.name)},275:r3e,279:r3e,278:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.exportClause)||ir(n,t.moduleSpecifier)||ir(n,t.attributes)},276:n3e,281:n3e,277:function(t,n,i){return qi(n,i,t.modifiers)||ir(n,t.expression)},228:function(t,n,i){return ir(n,t.head)||qi(n,i,t.templateSpans)},239:function(t,n,i){return ir(n,t.expression)||ir(n,t.literal)},203:function(t,n,i){return ir(n,t.head)||qi(n,i,t.templateSpans)},204:function(t,n,i){return ir(n,t.type)||ir(n,t.literal)},167:function(t,n,i){return ir(n,t.expression)},298:function(t,n,i){return qi(n,i,t.types)},233:function(t,n,i){return ir(n,t.expression)||qi(n,i,t.typeArguments)},283:function(t,n,i){return ir(n,t.expression)},282:function(t,n,i){return qi(n,i,t.modifiers)},355:function(t,n,i){return qi(n,i,t.elements)},284:function(t,n,i){return ir(n,t.openingElement)||qi(n,i,t.children)||ir(n,t.closingElement)},288:function(t,n,i){return ir(n,t.openingFragment)||qi(n,i,t.children)||ir(n,t.closingFragment)},285:i3e,286:i3e,292:function(t,n,i){return qi(n,i,t.properties)},291:function(t,n,i){return ir(n,t.name)||ir(n,t.initializer)},293:function(t,n,i){return ir(n,t.expression)},294:function(t,n,i){return ir(n,t.dotDotDotToken)||ir(n,t.expression)},287:function(t,n,i){return ir(n,t.tagName)},295:function(t,n,i){return ir(n,t.namespace)||ir(n,t.name)},190:jO,191:jO,309:jO,315:jO,314:jO,316:jO,318:jO,317:function(t,n,i){return qi(n,i,t.parameters)||ir(n,t.type)},320:function(t,n,i){return(typeof t.comment=="string"?void 0:qi(n,i,t.comment))||qi(n,i,t.tags)},347:function(t,n,i){return ir(n,t.tagName)||ir(n,t.name)||(typeof t.comment=="string"?void 0:qi(n,i,t.comment))},310:function(t,n,i){return ir(n,t.name)},311:function(t,n,i){return ir(n,t.left)||ir(n,t.right)},341:s3e,348:s3e,330:function(t,n,i){return ir(n,t.tagName)||(typeof t.comment=="string"?void 0:qi(n,i,t.comment))},329:function(t,n,i){return ir(n,t.tagName)||ir(n,t.class)||(typeof t.comment=="string"?void 0:qi(n,i,t.comment))},328:function(t,n,i){return ir(n,t.tagName)||ir(n,t.class)||(typeof t.comment=="string"?void 0:qi(n,i,t.comment))},345:function(t,n,i){return ir(n,t.tagName)||ir(n,t.constraint)||qi(n,i,t.typeParameters)||(typeof t.comment=="string"?void 0:qi(n,i,t.comment))},346:function(t,n,i){return ir(n,t.tagName)||(t.typeExpression&&t.typeExpression.kind===309?ir(n,t.typeExpression)||ir(n,t.fullName)||(typeof t.comment=="string"?void 0:qi(n,i,t.comment)):ir(n,t.fullName)||ir(n,t.typeExpression)||(typeof t.comment=="string"?void 0:qi(n,i,t.comment)))},338:function(t,n,i){return ir(n,t.tagName)||ir(n,t.fullName)||ir(n,t.typeExpression)||(typeof t.comment=="string"?void 0:qi(n,i,t.comment))},342:BO,344:BO,343:BO,340:BO,350:BO,349:BO,339:BO,323:function(t,n,i){return kt(t.typeParameters,n)||kt(t.parameters,n)||ir(n,t.type)},324:kme,325:kme,326:kme,322:function(t,n,i){return kt(t.jsDocPropertyTags,n)},327:PN,332:PN,333:PN,334:PN,335:PN,336:PN,331:PN,337:PN,351:ybt,354:vbt};function G4e(e,t,n){return qi(t,n,e.typeParameters)||qi(t,n,e.parameters)||ir(t,e.type)}function Y4e(e,t,n){return qi(t,n,e.types)}function K4e(e,t,n){return ir(t,e.type)}function X4e(e,t,n){return qi(t,n,e.elements)}function Q4e(e,t,n){return ir(t,e.expression)||ir(t,e.questionDotToken)||qi(t,n,e.typeArguments)||qi(t,n,e.arguments)}function Z4e(e,t,n){return qi(t,n,e.statements)}function e3e(e,t,n){return ir(t,e.label)}function t3e(e,t,n){return qi(t,n,e.modifiers)||ir(t,e.name)||qi(t,n,e.typeParameters)||qi(t,n,e.heritageClauses)||qi(t,n,e.members)}function r3e(e,t,n){return qi(t,n,e.elements)}function n3e(e,t,n){return ir(t,e.propertyName)||ir(t,e.name)}function i3e(e,t,n){return ir(t,e.tagName)||qi(t,n,e.typeArguments)||ir(t,e.attributes)}function jO(e,t,n){return ir(t,e.type)}function s3e(e,t,n){return ir(t,e.tagName)||(e.isNameFirst?ir(t,e.name)||ir(t,e.typeExpression):ir(t,e.typeExpression)||ir(t,e.name))||(typeof e.comment=="string"?void 0:qi(t,n,e.comment))}function BO(e,t,n){return ir(t,e.tagName)||ir(t,e.typeExpression)||(typeof e.comment=="string"?void 0:qi(t,n,e.comment))}function kme(e,t,n){return ir(t,e.name)}function PN(e,t,n){return ir(t,e.tagName)||(typeof e.comment=="string"?void 0:qi(t,n,e.comment))}function ybt(e,t,n){return ir(t,e.tagName)||ir(t,e.importClause)||ir(t,e.moduleSpecifier)||ir(t,e.attributes)||(typeof e.comment=="string"?void 0:qi(t,n,e.comment))}function vbt(e,t,n){return ir(t,e.expression)}function Js(e,t,n){if(e===void 0||e.kind<=165)return;let i=hbt[e.kind];return i===void 0?void 0:i(e,t,n)}function $A(e,t,n){let i=a3e(e),s=[];for(;s.length<i.length;)s.push(e);for(;i.length!==0;){let o=i.pop(),u=s.pop();if(Rs(o)){if(n){let m=n(o,u);if(m){if(m==="skip")continue;return m}}for(let m=o.length-1;m>=0;--m)i.push(o[m]),s.push(u)}else{let m=t(o,u);if(m){if(m==="skip")continue;return m}if(o.kind>=166)for(let d of a3e(o))i.push(d),s.push(o)}}}function a3e(e){let t=[];return Js(e,n,n),t;function n(i){t.unshift(i)}}function o3e(e){e.externalModuleIndicator=E8(e)}function HA(e,t,n,i=!1,s){var o,u,m,d;(o=Cn)==null||o.push(Cn.Phase.Parse,"createSourceFile",{path:e},!0),jc("beforeParse");let S;(u=rf)==null||u.logStartParseSourceFile(e);let{languageVersion:E,setExternalModuleIndicator:x,impliedNodeFormat:D,jsDocParsingMode:w}=typeof n=="object"?n:{languageVersion:n};if(E===100)S=Ab.parseSourceFile(e,t,E,void 0,i,6,io,w);else{let R=D===void 0?x:L=>(L.impliedNodeFormat=D,(x||o3e)(L));S=Ab.parseSourceFile(e,t,E,void 0,i,s,R,w)}return(m=rf)==null||m.logStopParseSourceFile(),jc("afterParse"),vd("Parse","beforeParse","afterParse"),(d=Cn)==null||d.pop(),S}function GA(e,t){return Ab.parseIsolatedEntityName(e,t)}function x8(e,t){return Ab.parseJsonText(e,t)}function nu(e){return e.externalModuleIndicator!==void 0}function PY(e,t,n,i=!1){let s=NY.updateSourceFile(e,t,n,i);return s.flags|=e.flags&12582912,s}function Pme(e,t,n){let i=Ab.JSDocParser.parseIsolatedJSDocComment(e,t,n);return i&&i.jsDoc&&Ab.fixupParentReferences(i.jsDoc),i}function c3e(e,t,n){return Ab.JSDocParser.parseJSDocTypeExpressionForTests(e,t,n)}var Ab;(e=>{var t=xy(99,!0),n=40960,i,s,o,u,m;function d(ie){return Xe++,ie}var S={createBaseSourceFileNode:ie=>d(new m(ie,0,0)),createBaseIdentifierNode:ie=>d(new o(ie,0,0)),createBasePrivateIdentifierNode:ie=>d(new u(ie,0,0)),createBaseTokenNode:ie=>d(new s(ie,0,0)),createBaseNode:ie=>d(new i(ie,0,0))},E=t8(11,S),{createNodeArray:x,createNumericLiteral:D,createStringLiteral:w,createLiteralLikeNode:R,createIdentifier:L,createPrivateIdentifier:F,createToken:J,createArrayLiteralExpression:G,createObjectLiteralExpression:q,createPropertyAccessExpression:ee,createPropertyAccessChain:W,createElementAccessExpression:pe,createElementAccessChain:K,createCallExpression:re,createCallChain:ue,createNewExpression:ce,createParenthesizedExpression:ne,createBlock:le,createVariableStatement:me,createExpressionStatement:de,createIfStatement:Ae,createWhileStatement:xe,createForStatement:te,createForOfStatement:he,createVariableDeclaration:be,createVariableDeclarationList:Ve}=E,Pe,ke,De,Be,ct,qe,et,Ie,_t,mt,Xe,ht,rr,vr,xr,jr,ur=!0,or=!1;function Zr(ie,Le,it,Lt,Kt=!1,Rr,ni,Xi=0){var Li;if(Rr=nj(ie,Rr),Rr===6){let us=Sr(ie,Le,it,Lt,Kt);return N8(us,(Li=us.statements[0])==null?void 0:Li.expression,us.parseDiagnostics,!1,void 0),us.referencedFiles=ve,us.typeReferenceDirectives=ve,us.libReferenceDirectives=ve,us.amdDependencies=ve,us.hasNoDefaultLib=!1,us.pragmas=lr,us}Pi(ie,Le,it,Lt,Rr,Xi);let xi=ss(it,Kt,Rr,ni||o3e,Xi);return Cs(),xi}e.parseSourceFile=Zr;function Oi(ie,Le){Pi("",ie,Le,void 0,1,0),Re();let it=oe(!0),Lt=z()===1&&!et.length;return Cs(),Lt?it:void 0}e.parseIsolatedEntityName=Oi;function Sr(ie,Le,it=2,Lt,Kt=!1){Pi(ie,Le,it,Lt,6,0),ke=jr,Re();let Rr=Q(),ni,Xi;if(z()===1)ni=po([],Rr,Rr),Xi=el();else{let us;for(;z()!==1;){let $a;switch(z()){case 23:$a=Bm();break;case 112:case 97:case 106:$a=el();break;case 41:Yn(()=>Re()===9&&Re()!==59)?$a=qn():$a=eT();break;case 9:case 11:if(Yn(()=>Re()!==59)){$a=jt();break}default:$a=eT();break}us&&Rs(us)?us.push($a):us?us=[us,$a]:(us=$a,z()!==1&&Rt(v.Unexpected_token))}let zo=Rs(us)?_r(G(us),Rr):M.checkDefined(us),da=de(zo);_r(da,Rr),ni=po([da],Rr),Xi=kc(1,v.Unexpected_token)}let Li=Yt(ie,2,6,!1,ni,Xi,ke,io);Kt&&$e(Li),Li.nodeCount=Xe,Li.identifierCount=rr,Li.identifiers=ht,Li.parseDiagnostics=yA(et,Li),Ie&&(Li.jsDocDiagnostics=yA(Ie,Li));let xi=Li;return Cs(),xi}e.parseJsonText=Sr;function Pi(ie,Le,it,Lt,Kt,Rr){switch(i=Hu.getNodeConstructor(),s=Hu.getTokenConstructor(),o=Hu.getIdentifierConstructor(),u=Hu.getPrivateIdentifierConstructor(),m=Hu.getSourceFileConstructor(),Pe=Zs(ie),De=Le,Be=it,_t=Lt,ct=Kt,qe=zR(Kt),et=[],vr=0,ht=new Map,rr=0,Xe=0,ke=0,ur=!0,ct){case 1:case 2:jr=524288;break;case 6:jr=134742016;break;default:jr=0;break}or=!1,t.setText(De),t.setOnError(bt),t.setScriptTarget(Be),t.setLanguageVariant(qe),t.setScriptKind(ct),t.setJSDocParsingMode(Rr)}function Cs(){t.clearCommentDirectives(),t.setText(""),t.setOnError(void 0),t.setScriptKind(0),t.setJSDocParsingMode(0),De=void 0,Be=void 0,_t=void 0,ct=void 0,qe=void 0,ke=0,et=void 0,Ie=void 0,vr=0,ht=void 0,xr=void 0,ur=!0}function ss(ie,Le,it,Lt,Kt){let Rr=Mu(Pe);Rr&&(jr|=33554432),ke=jr,Re();let ni=so(0,ud);M.assert(z()===1);let Xi=Ke(),Li=$r(el(),Xi),xi=Yt(Pe,ie,it,Rr,ni,Li,ke,Lt);return wY(xi,De),IY(xi,us),xi.commentDirectives=t.getCommentDirectives(),xi.nodeCount=Xe,xi.identifierCount=rr,xi.identifiers=ht,xi.parseDiagnostics=yA(et,xi),xi.jsDocParsingMode=Kt,Ie&&(xi.jsDocDiagnostics=yA(Ie,xi)),Le&&$e(xi),xi;function us(zo,da,$a){et.push(hA(Pe,De,zo,da,$a))}}let Ii=!1;function $r(ie,Le){if(!Le)return ie;M.assert(!ie.jsDoc);let it=Gi(mH(ie,De),Lt=>Lk.parseJSDocComment(ie,Lt.pos,Lt.end-Lt.pos));return it.length&&(ie.jsDoc=it),Ii&&(Ii=!1,ie.flags|=536870912),ie}function Xs(ie){let Le=_t,it=NY.createSyntaxCursor(ie);_t={currentNode:us};let Lt=[],Kt=et;et=[];let Rr=0,ni=Li(ie.statements,0);for(;ni!==-1;){let zo=ie.statements[Rr],da=ie.statements[ni];wn(Lt,ie.statements,Rr,ni),Rr=xi(ie.statements,ni);let $a=Bo(Kt,hg=>hg.start>=zo.pos),pd=$a>=0?Bo(Kt,hg=>hg.start>=da.pos,$a):-1;$a>=0&&wn(et,Kt,$a,pd>=0?pd:void 0),ls(()=>{let hg=jr;for(jr|=65536,t.resetTokenState(da.pos),Re();z()!==1;){let G0=t.getTokenFullStart(),ES=fl(0,ud);if(Lt.push(ES),G0===t.getTokenFullStart()&&Re(),Rr>=0){let mm=ie.statements[Rr];if(ES.end===mm.pos)break;ES.end>mm.pos&&(Rr=xi(ie.statements,Rr+1))}}jr=hg},2),ni=Rr>=0?Li(ie.statements,Rr):-1}if(Rr>=0){let zo=ie.statements[Rr];wn(Lt,ie.statements,Rr);let da=Bo(Kt,$a=>$a.start>=zo.pos);da>=0&&wn(et,Kt,da)}return _t=Le,E.updateSourceFile(ie,Et(x(Lt),ie.statements));function Xi(zo){return!(zo.flags&65536)&&!!(zo.transformFlags&67108864)}function Li(zo,da){for(let $a=da;$a<zo.length;$a++)if(Xi(zo[$a]))return $a;return-1}function xi(zo,da){for(let $a=da;$a<zo.length;$a++)if(!Xi(zo[$a]))return $a;return-1}function us(zo){let da=it.currentNode(zo);return ur&&da&&Xi(da)&&Nme(da),da}}function $e(ie){T0(ie,!0)}e.fixupParentReferences=$e;function Yt(ie,Le,it,Lt,Kt,Rr,ni,Xi){let Li=E.createSourceFile(Kt,Rr,ni);if(wG(Li,0,De.length),xi(Li),!Lt&&nu(Li)&&Li.transformFlags&67108864){let us=Li;Li=Xs(Li),us!==Li&&xi(Li)}return Li;function xi(us){us.text=De,us.bindDiagnostics=[],us.bindSuggestionDiagnostics=void 0,us.languageVersion=Le,us.fileName=ie,us.languageVariant=zR(it),us.isDeclarationFile=Lt,us.scriptKind=it,Xi(us),us.setExternalModuleIndicator=Xi}}function Vr(ie,Le){ie?jr|=Le:jr&=~Le}function An(ie){Vr(ie,8192)}function vi(ie){Vr(ie,16384)}function Ci(ie){Vr(ie,32768)}function Ui(ie){Vr(ie,65536)}function la(ie,Le){let it=ie&jr;if(it){Vr(!1,it);let Lt=Le();return Vr(!0,it),Lt}return Le()}function Gs(ie,Le){let it=ie&~jr;if(it){Vr(!0,it);let Lt=Le();return Vr(!1,it),Lt}return Le()}function yr(ie){return la(8192,ie)}function to(ie){return Gs(8192,ie)}function lt(ie){return la(131072,ie)}function St(ie){return Gs(131072,ie)}function fe(ie){return Gs(16384,ie)}function vt(ie){return Gs(32768,ie)}function Ce(ie){return Gs(65536,ie)}function nt(ie){return la(65536,ie)}function Me(ie){return Gs(81920,ie)}function tt(ie){return la(81920,ie)}function ft(ie){return(jr&ie)!==0}function tr(){return ft(16384)}function Oe(){return ft(8192)}function At(){return ft(131072)}function Nt(){return ft(32768)}function Ut(){return ft(65536)}function Rt(ie,...Le){return Z(t.getTokenStart(),t.getTokenEnd(),ie,...Le)}function nr(ie,Le,it,...Lt){let Kt=vc(et),Rr;return(!Kt||ie!==Kt.start)&&(Rr=hA(Pe,De,ie,Le,it,...Lt),et.push(Rr)),or=!0,Rr}function Z(ie,Le,it,...Lt){return nr(ie,Le-ie,it,...Lt)}function Ge(ie,Le,...it){Z(ie.pos,ie.end,Le,...it)}function bt(ie,Le,it){nr(t.getTokenEnd(),Le,ie,it)}function Q(){return t.getTokenFullStart()}function Ke(){return t.hasPrecedingJSDocComment()}function z(){return mt}function Ue(){return mt=t.scan()}function Te(ie){return Re(),ie()}function Re(){return sf(mt)&&(t.hasUnicodeEscape()||t.hasExtendedUnicodeEscape())&&Z(t.getTokenStart(),t.getTokenEnd(),v.Keywords_cannot_contain_escape_characters),Ue()}function It(){return mt=t.scanJsDocToken()}function $t(ie){return mt=t.scanJSDocCommentTextToken(ie)}function Ht(){return mt=t.reScanGreaterToken()}function dr(){return mt=t.reScanSlashToken()}function qr(ie){return mt=t.reScanTemplateToken(ie)}function Hr(){return mt=t.reScanLessThanToken()}function dn(){return mt=t.reScanHashToken()}function Ar(){return mt=t.scanJsxIdentifier()}function In(){return mt=t.scanJsxToken()}function Ki(){return mt=t.scanJsxAttributeValue()}function ls(ie,Le){let it=mt,Lt=et.length,Kt=or,Rr=jr,ni=Le!==0?t.lookAhead(ie):t.tryScan(ie);return M.assert(Rr===jr),(!ni||Le!==0)&&(mt=it,Le!==2&&(et.length=Lt),or=Kt),ni}function Yn(ie){return ls(ie,1)}function pi(ie){return ls(ie,0)}function Er(){return z()===80?!0:z()>118}function tn(){return z()===80?!0:z()===127&&tr()||z()===135&&Ut()?!1:z()>118}function er(ie,Le,it=!0){return z()===ie?(it&&Re(),!0):(Le?Rt(Le):Rt(v._0_expected,Sa(ie)),!1)}let qs=Object.keys(m5).filter(ie=>ie.length>2);function uo(ie){if(hE(ie)){Z(Ja(De,ie.template.pos),ie.template.end,v.Module_declaration_names_may_only_use_or_quoted_strings);return}let Le=He(ie)?Nn(ie):void 0;if(!Le||!sp(Le,Be)){Rt(v._0_expected,Sa(27));return}let it=Ja(De,ie.pos);switch(Le){case"const":case"let":case"var":Z(it,ie.end,v.Variable_declaration_not_allowed_at_this_location);return;case"declare":return;case"interface":Mo(v.Interface_name_cannot_be_0,v.Interface_must_be_given_a_name,19);return;case"is":Z(it,t.getTokenStart(),v.A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods);return;case"module":case"namespace":Mo(v.Namespace_name_cannot_be_0,v.Namespace_must_be_given_a_name,19);return;case"type":Mo(v.Type_alias_name_cannot_be_0,v.Type_alias_must_be_given_a_name,64);return}let Lt=Fx(Le,qs,ec)??Do(Le);if(Lt){Z(it,ie.end,v.Unknown_keyword_or_identifier_Did_you_mean_0,Lt);return}z()!==0&&Z(it,ie.end,v.Unexpected_keyword_or_identifier)}function Mo(ie,Le,it){z()===it?Rt(Le):Rt(ie,t.getTokenValue())}function Do(ie){for(let Le of qs)if(ie.length>Le.length+2&&_s(ie,Le))return`${Le} ${ie.slice(Le.length)}`}function ms(ie,Le,it){if(z()===60&&!t.hasPrecedingLineBreak()){Rt(v.Decorators_must_precede_the_name_and_all_keywords_of_property_declarations);return}if(z()===21){Rt(v.Cannot_start_a_function_call_in_a_type_annotation),Re();return}if(Le&&!Fa()){it?Rt(v._0_expected,Sa(27)):Rt(v.Expected_for_property_initializer);return}if(!bc()){if(it){Rt(v._0_expected,Sa(27));return}uo(ie)}}function sa(ie){return z()===ie?(It(),!0):(M.assert(v9(ie)),Rt(v._0_expected,Sa(ie)),!1)}function Sc(ie,Le,it,Lt){if(z()===Le){Re();return}let Kt=Rt(v._0_expected,Sa(Le));it&&Kt&&ca(Kt,hA(Pe,De,Lt,1,v.The_parser_expected_to_find_a_1_to_match_the_0_token_here,Sa(ie),Sa(Le)))}function ts(ie){return z()===ie?(Re(),!0):!1}function zi(ie){if(z()===ie)return el()}function Eu(ie){if(z()===ie)return Xu()}function kc(ie,Le,it){return zi(ie)||Jc(ie,!1,Le||v._0_expected,it||Sa(ie))}function P_(ie){let Le=Eu(ie);return Le||(M.assert(v9(ie)),Jc(ie,!1,v._0_expected,Sa(ie)))}function el(){let ie=Q(),Le=z();return Re(),_r(J(Le),ie)}function Xu(){let ie=Q(),Le=z();return It(),_r(J(Le),ie)}function Fa(){return z()===27?!0:z()===20||z()===1||t.hasPrecedingLineBreak()}function bc(){return Fa()?(z()===27&&Re(),!0):!1}function Lo(){return bc()||er(27)}function po(ie,Le,it,Lt){let Kt=x(ie,Lt);return qg(Kt,Le,it??t.getTokenFullStart()),Kt}function _r(ie,Le,it){return qg(ie,Le,it??t.getTokenFullStart()),jr&&(ie.flags|=jr),or&&(or=!1,ie.flags|=262144),ie}function Jc(ie,Le,it,...Lt){Le?nr(t.getTokenFullStart(),0,it,...Lt):it&&Rt(it,...Lt);let Kt=Q(),Rr=ie===80?L("",void 0):B1(ie)?E.createTemplateLiteralLikeNode(ie,"","",void 0):ie===9?D("",void 0):ie===11?w("",void 0):ie===282?E.createMissingDeclaration():J(ie);return _r(Rr,Kt)}function z_(ie){let Le=ht.get(ie);return Le===void 0&&ht.set(ie,Le=ie),Le}function W_(ie,Le,it){if(ie){rr++;let Xi=t.hasLeadingAsterisks()?t.getTokenStart():Q(),Li=z(),xi=z_(t.getTokenValue()),us=t.hasExtendedUnicodeEscape();return Ue(),_r(L(xi,Li,us),Xi)}if(z()===81)return Rt(it||v.Private_identifiers_are_not_allowed_outside_class_bodies),W_(!0);if(z()===0&&t.tryScan(()=>t.reScanInvalidIdentifier()===80))return W_(!0);rr++;let Lt=z()===1,Kt=t.isReservedWord(),Rr=t.getTokenText(),ni=Kt?v.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here:v.Identifier_expected;return Jc(80,Lt,Le||ni,Rr)}function qf(ie){return W_(Er(),void 0,ie)}function mc(ie,Le){return W_(tn(),ie,Le)}function tl(ie){return W_(F_(z()),ie)}function Se(){return(t.hasUnicodeEscape()||t.hasExtendedUnicodeEscape())&&Rt(v.Unicode_escape_sequence_cannot_appear_here),W_(F_(z()))}function ae(){return F_(z())||z()===11||z()===9}function Ye(){return F_(z())||z()===11}function Ot(ie){if(z()===11||z()===9){let Le=jt();return Le.text=z_(Le.text),Le}return ie&&z()===23?Vn():z()===81?pr():tl()}function Tr(){return Ot(!0)}function Vn(){let ie=Q();er(23);let Le=yr(Qe);return er(24),_r(E.createComputedPropertyName(Le),ie)}function pr(){let ie=Q(),Le=F(z_(t.getTokenValue()));return Re(),_r(Le,ie)}function Jn(ie){return z()===ie&&pi(Ai)}function Ri(){return Re(),t.hasPrecedingLineBreak()?!1:Oc()}function Ai(){switch(z()){case 87:return Re()===94;case 95:return Re(),z()===90?Yn(du):z()===156?Yn(gc):Na();case 90:return du();case 126:case 139:case 153:return Re(),Oc();default:return Ri()}}function Na(){return z()===60||z()!==42&&z()!==130&&z()!==19&&Oc()}function gc(){return Re(),Na()}function Wl(){return vv(z())&&pi(Ai)}function Oc(){return z()===23||z()===19||z()===42||z()===26||ae()}function du(){return Re(),z()===86||z()===100||z()===120||z()===60||z()===128&&Yn(q6)||z()===134&&Yn(G_)}function hc(ie,Le){if(au(ie))return!0;switch(ie){case 0:case 1:case 3:return!(z()===27&&Le)&&Mf();case 2:return z()===84||z()===90;case 4:return Yn(_n);case 5:return Yn(fd)||z()===27&&!Le;case 6:return z()===23||ae();case 12:switch(z()){case 23:case 42:case 26:case 25:return!0;default:return ae()}case 18:return ae();case 9:return z()===23||z()===26||ae();case 24:return Ye();case 7:return z()===19?Yn(mu):Le?tn()&&!nd():Ck()&&!nd();case 8:return aT();case 10:return z()===28||z()===26||aT();case 19:return z()===103||z()===87||tn();case 15:switch(z()){case 28:case 25:return!0}case 11:return z()===26||dg();case 16:return Rm(!1);case 17:return Rm(!0);case 20:case 21:return z()===28||qy();case 22:return GE();case 23:return z()===161&&Yn(U2)?!1:F_(z());case 13:return F_(z())||z()===19;case 14:return!0;case 25:return!0;case 26:return M.fail("ParsingContext.Count used as a context");default:M.assertNever(ie,"Non-exhaustive case in 'isListElement'.")}}function mu(){if(M.assert(z()===19),Re()===20){let ie=Re();return ie===28||ie===19||ie===96||ie===119}return!0}function zf(){return Re(),tn()}function rl(){return Re(),F_(z())}function $l(){return Re(),Sue(z())}function nd(){return z()===119||z()===96?Yn(Je):!1}function Je(){return Re(),dg()}function qt(){return Re(),qy()}function Gr(ie){if(z()===1)return!0;switch(ie){case 1:case 2:case 4:case 5:case 6:case 12:case 9:case 23:case 24:return z()===20;case 3:return z()===20||z()===84||z()===90;case 7:return z()===19||z()===96||z()===119;case 8:return gs();case 19:return z()===32||z()===21||z()===19||z()===96||z()===119;case 11:return z()===22||z()===27;case 15:case 21:case 10:return z()===24;case 17:case 16:case 18:return z()===22||z()===24;case 20:return z()!==28;case 22:return z()===19||z()===20;case 13:return z()===32||z()===44;case 14:return z()===30&&Yn(OD);default:return!1}}function gs(){return!!(Fa()||Kb(z())||z()===39)}function Qa(){M.assert(vr,"Missing parsing context");for(let ie=0;ie<26;ie++)if(vr&1<<ie&&(hc(ie,!0)||Gr(ie)))return!0;return!1}function so(ie,Le){let it=vr;vr|=1<<ie;let Lt=[],Kt=Q();for(;!Gr(ie);){if(hc(ie,!1)){Lt.push(fl(ie,Le));continue}if(Yh(ie))break}return vr=it,po(Lt,Kt)}function fl(ie,Le){let it=au(ie);return it?Uo(it):Le()}function au(ie,Le){var it;if(!_t||!Fo(ie)||or)return;let Lt=_t.currentNode(Le??t.getTokenFullStart());if(!($c(Lt)||bbt(Lt)||VP(Lt)||(Lt.flags&101441536)!==jr)&&Cl(Lt,ie))return xR(Lt)&&((it=Lt.jsDoc)!=null&&it.jsDocCache)&&(Lt.jsDoc.jsDocCache=void 0),Lt}function Uo(ie){return t.resetTokenState(ie.end),Re(),ie}function Fo(ie){switch(ie){case 5:case 2:case 0:case 1:case 3:case 6:case 4:case 8:case 17:case 16:return!0}return!1}function Cl(ie,Le){switch(Le){case 5:return Wf(ie);case 2:return fg(ie);case 0:case 1:case 3:return id(ie);case 6:return If(ie);case 4:return wd(ie);case 8:return sd(ie);case 17:case 16:return Gh(ie)}return!1}function Wf(ie){if(ie)switch(ie.kind){case 176:case 181:case 177:case 178:case 172:case 240:return!0;case 174:let Le=ie;return!(Le.name.kind===80&&Le.name.escapedText==="constructor")}return!1}function fg(ie){if(ie)switch(ie.kind){case 296:case 297:return!0}return!1}function id(ie){if(ie)switch(ie.kind){case 262:case 243:case 241:case 245:case 244:case 257:case 253:case 255:case 252:case 251:case 249:case 250:case 248:case 247:case 254:case 242:case 258:case 256:case 246:case 259:case 272:case 271:case 278:case 277:case 267:case 263:case 264:case 266:case 265:return!0}return!1}function If(ie){return ie.kind===306}function wd(ie){if(ie)switch(ie.kind){case 180:case 173:case 181:case 171:case 179:return!0}return!1}function sd(ie){return ie.kind!==260?!1:ie.initializer===void 0}function Gh(ie){return ie.kind!==169?!1:ie.initializer===void 0}function Yh(ie){return Of(ie),Qa()?!0:(Re(),!1)}function Of(ie){switch(ie){case 0:return z()===90?Rt(v._0_expected,Sa(95)):Rt(v.Declaration_or_statement_expected);case 1:return Rt(v.Declaration_or_statement_expected);case 2:return Rt(v.case_or_default_expected);case 3:return Rt(v.Statement_expected);case 18:case 4:return Rt(v.Property_or_signature_expected);case 5:return Rt(v.Unexpected_token_A_constructor_method_accessor_or_property_was_expected);case 6:return Rt(v.Enum_member_expected);case 7:return Rt(v.Expression_expected);case 8:return sf(z())?Rt(v._0_is_not_allowed_as_a_variable_declaration_name,Sa(z())):Rt(v.Variable_declaration_expected);case 9:return Rt(v.Property_destructuring_pattern_expected);case 10:return Rt(v.Array_element_destructuring_pattern_expected);case 11:return Rt(v.Argument_expression_expected);case 12:return Rt(v.Property_assignment_expected);case 15:return Rt(v.Expression_or_comma_expected);case 17:return Rt(v.Parameter_declaration_expected);case 16:return sf(z())?Rt(v._0_is_not_allowed_as_a_parameter_name,Sa(z())):Rt(v.Parameter_declaration_expected);case 19:return Rt(v.Type_parameter_declaration_expected);case 20:return Rt(v.Type_argument_expected);case 21:return Rt(v.Type_expected);case 22:return Rt(v.Unexpected_token_expected);case 23:return z()===161?Rt(v._0_expected,"}"):Rt(v.Identifier_expected);case 13:return Rt(v.Identifier_expected);case 14:return Rt(v.Identifier_expected);case 24:return Rt(v.Identifier_or_string_literal_expected);case 25:return Rt(v.Identifier_expected);case 26:return M.fail("ParsingContext.Count used as a context");default:M.assertNever(ie)}}function Hl(ie,Le,it){let Lt=vr;vr|=1<<ie;let Kt=[],Rr=Q(),ni=-1;for(;;){if(hc(ie,!1)){let Xi=t.getTokenFullStart(),Li=fl(ie,Le);if(!Li){vr=Lt;return}if(Kt.push(Li),ni=t.getTokenStart(),ts(28))continue;if(ni=-1,Gr(ie))break;er(28,Kh(ie)),it&&z()===27&&!t.hasPrecedingLineBreak()&&Re(),Xi===t.getTokenFullStart()&&Re();continue}if(Gr(ie)||Yh(ie))break}return vr=Lt,po(Kt,Rr,void 0,ni>=0)}function Kh(ie){return ie===6?v.An_enum_member_name_must_be_followed_by_a_or:void 0}function $f(){let ie=po([],Q());return ie.isMissingList=!0,ie}function nh(ie){return!!ie.isMissingList}function ad(ie,Le,it,Lt){if(er(it)){let Kt=Hl(ie,Le);return er(Lt),Kt}return $f()}function oe(ie,Le){let it=Q(),Lt=ie?tl(Le):mc(Le);for(;ts(25)&&z()!==30;)Lt=_r(E.createQualifiedName(Lt,Gt(ie,!1,!0)),it);return Lt}function yt(ie,Le){return _r(E.createQualifiedName(ie,Le),ie.pos)}function Gt(ie,Le,it){if(t.hasPrecedingLineBreak()&&F_(z())&&Yn(rT))return Jc(80,!0,v.Identifier_expected);if(z()===81){let Lt=pr();return Le?Lt:Jc(80,!0,v.Identifier_expected)}return ie?it?tl():Se():mc()}function Xt(ie){let Le=Q(),it=[],Lt;do Lt=Fe(ie),it.push(Lt);while(Lt.literal.kind===17);return po(it,Le)}function Fr(ie){let Le=Q();return _r(E.createTemplateExpression(Xr(ie),Xt(ie)),Le)}function nn(){let ie=Q();return _r(E.createTemplateLiteralType(Xr(!1),Hn()),ie)}function Hn(){let ie=Q(),Le=[],it;do it=Si(),Le.push(it);while(it.literal.kind===17);return po(Le,ie)}function Si(){let ie=Q();return _r(E.createTemplateLiteralTypeSpan(ou(),$(!1)),ie)}function $(ie){return z()===20?(qr(ie),Mi()):kc(18,v._0_expected,Sa(20))}function Fe(ie){let Le=Q();return _r(E.createTemplateSpan(yr(Qe),$(ie)),Le)}function jt(){return Ss(z())}function Xr(ie){!ie&&t.getTokenFlags()&26656&&qr(!1);let Le=Ss(z());return M.assert(Le.kind===16,"Template head has wrong token kind"),Le}function Mi(){let ie=Ss(z());return M.assert(ie.kind===17||ie.kind===18,"Template fragment has wrong token kind"),ie}function Us(ie){let Le=ie===15||ie===18,it=t.getTokenText();return it.substring(1,it.length-(t.isUnterminated()?0:Le?1:2))}function Ss(ie){let Le=Q(),it=B1(ie)?E.createTemplateLiteralLikeNode(ie,t.getTokenValue(),Us(ie),t.getTokenFlags()&7176):ie===9?D(t.getTokenValue(),t.getNumericLiteralFlags()):ie===11?w(t.getTokenValue(),void 0,t.hasExtendedUnicodeEscape()):yI(ie)?R(ie,t.getTokenValue()):M.fail();return t.hasExtendedUnicodeEscape()&&(it.hasExtendedUnicodeEscape=!0),t.isUnterminated()&&(it.isUnterminated=!0),Re(),_r(it,Le)}function zs(){return oe(!0,v.Type_expected)}function vo(){if(!t.hasPrecedingLineBreak()&&Hr()===30)return ad(20,ou,30,32)}function Wa(){let ie=Q();return _r(E.createTypeReferenceNode(zs(),vo()),ie)}function qc(ie){switch(ie.kind){case 183:return $c(ie.typeName);case 184:case 185:{let{parameters:Le,type:it}=ie;return nh(Le)||qc(it)}case 196:return qc(ie.type);default:return!1}}function Id(ie){return Re(),_r(E.createTypePredicateNode(void 0,ie,ou()),ie.pos)}function Om(){let ie=Q();return Re(),_r(E.createThisTypeNode(),ie)}function Xh(){let ie=Q();return Re(),_r(E.createJSDocAllType(),ie)}function Vy(){let ie=Q();return Re(),_r(E.createJSDocNonNullableType(jE(),!1),ie)}function $v(){let ie=Q();return Re(),z()===28||z()===20||z()===22||z()===32||z()===64||z()===52?_r(E.createJSDocUnknownType(),ie):_r(E.createJSDocNullableType(ou(),!1),ie)}function Jy(){let ie=Q(),Le=Ke();if(pi(Rk)){let it=cd(36),Lt=lm(59,!1);return $r(_r(E.createJSDocFunctionType(it,Lt),ie),Le)}return _r(E.createTypeReferenceNode(tl(),void 0),ie)}function Od(){let ie=Q(),Le;return(z()===110||z()===105)&&(Le=tl(),er(59)),_r(E.createParameterDeclaration(void 0,void 0,Le,void 0,od(),void 0),ie)}function od(){t.setSkipJsDocLeadingAsterisks(!0);let ie=Q();if(ts(144)){let Lt=E.createJSDocNamepathType(void 0);e:for(;;)switch(z()){case 20:case 1:case 28:case 5:break e;default:It()}return t.setSkipJsDocLeadingAsterisks(!1),_r(Lt,ie)}let Le=ts(26),it=Xv();return t.setSkipJsDocLeadingAsterisks(!1),Le&&(it=_r(E.createJSDocVariadicType(it),ie)),z()===64?(Re(),_r(E.createJSDocOptionalType(it),ie)):it}function Vo(){let ie=Q();er(114);let Le=oe(!0),it=t.hasPrecedingLineBreak()?void 0:W0();return _r(E.createTypeQueryNode(Le,it),ie)}function d_(){let ie=Q(),Le=Zt(!1,!0),it=mc(),Lt,Kt;ts(96)&&(qy()||!dg()?Lt=ou():Kt=t1());let Rr=ts(64)?ou():void 0,ni=E.createTypeParameterDeclaration(Le,it,Lt,Rr);return ni.expression=Kt,_r(ni,ie)}function $_(){if(z()===30)return ad(19,d_,30,32)}function Rm(ie){return z()===26||aT()||vv(z())||z()===60||qy(!ie)}function Hv(ie){let Le=yS(v.Private_identifiers_cannot_be_used_as_parameters);return H3(Le)===0&&!Pt(ie)&&vv(z())&&Re(),Le}function O0(){return Er()||z()===23||z()===19}function pS(ie){return dS(ie)}function cm(ie){return dS(ie,!1)}function dS(ie,Le=!0){let it=Q(),Lt=Ke(),Kt=ie?Ce(()=>Zt(!0)):nt(()=>Zt(!0));if(z()===110){let Li=E.createParameterDeclaration(Kt,void 0,W_(!0),void 0,Qv(),void 0),xi=xo(Kt);return xi&&Ge(xi,v.Neither_decorators_nor_modifiers_may_be_applied_to_this_parameters),$r(_r(Li,it),Lt)}let Rr=ur;ur=!1;let ni=zi(26);if(!Le&&!O0())return;let Xi=$r(_r(E.createParameterDeclaration(Kt,ni,Hv(Kt),zi(58),Qv(),Mm()),it),Lt);return ur=Rr,Xi}function lm(ie,Le){if(Vb(ie,Le))return lt(Xv)}function Vb(ie,Le){return ie===39?(er(ie),!0):ts(59)?!0:Le&&z()===39?(Rt(v._0_expected,Sa(59)),Re(),!0):!1}function pg(ie,Le){let it=tr(),Lt=Ut();vi(!!(ie&1)),Ui(!!(ie&2));let Kt=ie&32?Hl(17,Od):Hl(16,()=>Le?pS(Lt):cm(Lt));return vi(it),Ui(Lt),Kt}function cd(ie){if(!er(21))return $f();let Le=pg(ie,!0);return er(22),Le}function R0(){ts(28)||Lo()}function We(ie){let Le=Q(),it=Ke();ie===180&&er(105);let Lt=$_(),Kt=cd(4),Rr=lm(59,!0);R0();let ni=ie===179?E.createCallSignature(Lt,Kt,Rr):E.createConstructSignature(Lt,Kt,Rr);return $r(_r(ni,Le),it)}function st(){return z()===23&&Yn(Jt)}function Jt(){if(Re(),z()===26||z()===24)return!0;if(vv(z())){if(Re(),tn())return!0}else if(tn())Re();else return!1;return z()===59||z()===28?!0:z()!==58?!1:(Re(),z()===59||z()===28||z()===24)}function sr(ie,Le,it){let Lt=ad(16,()=>pS(!1),23,24),Kt=Qv();R0();let Rr=E.createIndexSignature(it,Lt,Kt);return $r(_r(Rr,ie),Le)}function kr(ie,Le,it){let Lt=Tr(),Kt=zi(58),Rr;if(z()===21||z()===30){let ni=$_(),Xi=cd(4),Li=lm(59,!0);Rr=E.createMethodSignature(it,Lt,Kt,ni,Xi,Li)}else{let ni=Qv();Rr=E.createPropertySignature(it,Lt,Kt,ni),z()===64&&(Rr.initializer=Mm())}return R0(),$r(_r(Rr,ie),Le)}function _n(){if(z()===21||z()===30||z()===139||z()===153)return!0;let ie=!1;for(;vv(z());)ie=!0,Re();return z()===23?!0:(ae()&&(ie=!0,Re()),ie?z()===21||z()===30||z()===58||z()===59||z()===28||Fa():!1)}function Ir(){if(z()===21||z()===30)return We(179);if(z()===105&&Yn(kn))return We(180);let ie=Q(),Le=Ke(),it=Zt(!1);return Jn(139)?s1(ie,Le,it,177,4):Jn(153)?s1(ie,Le,it,178,4):st()?sr(ie,Le,it):kr(ie,Le,it)}function kn(){return Re(),z()===21||z()===30}function ji(){return Re()===25}function En(){switch(Re()){case 21:case 30:case 25:return!0}return!1}function Ni(){let ie=Q();return _r(E.createTypeLiteralNode(an()),ie)}function an(){let ie;return er(19)?(ie=so(4,Ir),er(20)):ie=$f(),ie}function Ds(){return Re(),z()===40||z()===41?Re()===148:(z()===148&&Re(),z()===23&&zf()&&Re()===103)}function wa(){let ie=Q(),Le=tl();er(103);let it=ou();return _r(E.createTypeParameterDeclaration(void 0,Le,it,void 0),ie)}function xu(){let ie=Q();er(19);let Le;(z()===148||z()===40||z()===41)&&(Le=el(),Le.kind!==148&&er(148)),er(23);let it=wa(),Lt=ts(130)?ou():void 0;er(24);let Kt;(z()===58||z()===40||z()===41)&&(Kt=el(),Kt.kind!==58&&er(58));let Rr=Qv();Lo();let ni=so(4,Ir);return er(20),_r(E.createMappedTypeNode(Le,it,Lt,Kt,Rr,ni),ie)}function N_(){let ie=Q();if(ts(26))return _r(E.createRestTypeNode(ou()),ie);let Le=ou();if(bN(Le)&&Le.pos===Le.type.pos){let it=E.createOptionalTypeNode(Le.type);return Et(it,Le),it.flags=Le.flags,it}return Le}function um(){return Re()===59||z()===58&&Re()===59}function Gv(){return z()===26?F_(Re())&&um():F_(z())&&um()}function _m(){if(Yn(Gv)){let ie=Q(),Le=Ke(),it=zi(26),Lt=tl(),Kt=zi(58);er(59);let Rr=N_(),ni=E.createNamedTupleMember(it,Lt,Kt,Rr);return $r(_r(ni,ie),Le)}return N_()}function Sk(){let ie=Q();return _r(E.createTupleTypeNode(ad(21,_m,23,24)),ie)}function mD(){let ie=Q();er(21);let Le=ou();return er(22),_r(E.createParenthesizedType(Le),ie)}function bk(){let ie;if(z()===128){let Le=Q();Re();let it=_r(J(128),Le);ie=po([it],Le)}return ie}function FE(){let ie=Q(),Le=Ke(),it=bk(),Lt=ts(105);M.assert(!it||Lt,"Per isStartOfFunctionOrConstructorType, a function type cannot have modifiers.");let Kt=$_(),Rr=cd(4),ni=lm(39,!1),Xi=Lt?E.createConstructorTypeNode(it,Kt,Rr,ni):E.createFunctionTypeNode(Kt,Rr,ni);return $r(_r(Xi,ie),Le)}function Jb(){let ie=el();return z()===25?void 0:ie}function qb(ie){let Le=Q();ie&&Re();let it=z()===112||z()===97||z()===106?el():Ss(z());return ie&&(it=_r(E.createPrefixUnaryExpression(41,it),Le)),_r(E.createLiteralTypeNode(it),Le)}function zb(){return Re(),z()===102}function P2(){ke|=4194304;let ie=Q(),Le=ts(114);er(102),er(21);let it=ou(),Lt;if(ts(28)){let ni=t.getTokenStart();er(19);let Xi=z();if(Xi===118||Xi===132?Re():Rt(v._0_expected,Sa(118)),er(59),Lt=H6(Xi,!0),!er(20)){let Li=vc(et);Li&&Li.code===v._0_expected.code&&ca(Li,hA(Pe,De,ni,1,v.The_parser_expected_to_find_a_1_to_match_the_0_token_here,"{","}"))}}er(22);let Kt=ts(25)?zs():void 0,Rr=vo();return _r(E.createImportTypeNode(it,Lt,Kt,Rr,Le),ie)}function Yv(){return Re(),z()===9||z()===10}function jE(){switch(z()){case 133:case 159:case 154:case 150:case 163:case 155:case 136:case 157:case 146:case 151:return pi(Jb)||Wa();case 67:t.reScanAsteriskEqualsToken();case 42:return Xh();case 61:t.reScanQuestionToken();case 58:return $v();case 100:return Jy();case 54:return Vy();case 15:case 11:case 9:case 10:case 112:case 97:case 106:return qb();case 41:return Yn(Yv)?qb(!0):Wa();case 116:return el();case 110:{let ie=Om();return z()===142&&!t.hasPrecedingLineBreak()?Id(ie):ie}case 114:return Yn(zb)?P2():Vo();case 19:return Yn(Ds)?xu():Ni();case 23:return Sk();case 21:return mD();case 102:return P2();case 131:return Yn(rT)?xk():Wa();case 16:return nn();default:return Wa()}}function qy(ie){switch(z()){case 133:case 159:case 154:case 150:case 163:case 136:case 148:case 155:case 158:case 116:case 157:case 106:case 110:case 114:case 146:case 19:case 23:case 30:case 52:case 51:case 105:case 11:case 9:case 10:case 112:case 97:case 151:case 42:case 58:case 54:case 26:case 140:case 102:case 131:case 15:case 16:return!0;case 100:return!ie;case 41:return!ie&&Yn(Yv);case 21:return!ie&&Yn(BE);default:return tn()}}function BE(){return Re(),z()===22||Rm(!1)||qy()}function _o(){let ie=Q(),Le=jE();for(;!t.hasPrecedingLineBreak();)switch(z()){case 54:Re(),Le=_r(E.createJSDocNonNullableType(Le,!0),ie);break;case 58:if(Yn(qt))return Le;Re(),Le=_r(E.createJSDocNullableType(Le,!0),ie);break;case 23:if(er(23),qy()){let it=ou();er(24),Le=_r(E.createIndexedAccessTypeNode(Le,it),ie)}else er(24),Le=_r(E.createArrayTypeNode(Le),ie);break;default:return Le}return Le}function N2(ie){let Le=Q();return er(ie),_r(E.createTypeOperatorNode(ie,ih()),Le)}function D2(){if(ts(96)){let ie=St(ou);if(At()||z()!==58)return ie}}function Wb(){let ie=Q(),Le=mc(),it=pi(D2),Lt=E.createTypeParameterDeclaration(void 0,Le,it);return _r(Lt,ie)}function M0(){let ie=Q();return er(140),_r(E.createInferTypeNode(Wb()),ie)}function ih(){let ie=z();switch(ie){case 143:case 158:case 148:return N2(ie);case 140:return M0()}return lt(_o)}function Rd(ie){if(Tk()){let Le=FE(),it;return Jh(Le)?it=ie?v.Function_type_notation_must_be_parenthesized_when_used_in_a_union_type:v.Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type:it=ie?v.Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type:v.Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type,Ge(Le,it),Le}}function Rf(ie,Le,it){let Lt=Q(),Kt=ie===52,Rr=ts(ie),ni=Rr&&Rd(Kt)||Le();if(z()===ie||Rr){let Xi=[ni];for(;ts(ie);)Xi.push(Rd(Kt)||Le());ni=_r(it(po(Xi,Lt)),Lt)}return ni}function hp(){return Rf(51,ih,E.createIntersectionTypeNode)}function Hf(){return Rf(52,hp,E.createUnionTypeNode)}function Kv(){return Re(),z()===105}function Tk(){return z()===30||z()===21&&Yn($b)?!0:z()===105||z()===128&&Yn(Kv)}function Ek(){if(vv(z())&&Zt(!1),tn()||z()===110)return Re(),!0;if(z()===23||z()===19){let ie=et.length;return yS(),ie===et.length}return!1}function $b(){return Re(),!!(z()===22||z()===26||Ek()&&(z()===59||z()===28||z()===58||z()===64||z()===22&&(Re(),z()===39)))}function Xv(){let ie=Q(),Le=tn()&&pi(Hb),it=ou();return Le?_r(E.createTypePredicateNode(void 0,Le,it),ie):it}function Hb(){let ie=mc();if(z()===142&&!t.hasPrecedingLineBreak())return Re(),ie}function xk(){let ie=Q(),Le=kc(131),it=z()===110?Om():mc(),Lt=ts(142)?ou():void 0;return _r(E.createTypePredicateNode(Le,it,Lt),ie)}function ou(){if(jr&81920)return la(81920,ou);if(Tk())return FE();let ie=Q(),Le=Hf();if(!At()&&!t.hasPrecedingLineBreak()&&ts(96)){let it=St(ou);er(58);let Lt=lt(ou);er(59);let Kt=lt(ou);return _r(E.createConditionalTypeNode(Le,it,Lt,Kt),ie)}return Le}function Qv(){return ts(59)?ou():void 0}function Ck(){switch(z()){case 110:case 108:case 106:case 112:case 97:case 9:case 10:case 11:case 15:case 16:case 21:case 23:case 19:case 100:case 86:case 105:case 44:case 69:case 80:return!0;case 102:return Yn(En);default:return tn()}}function dg(){if(Ck())return!0;switch(z()){case 40:case 41:case 55:case 54:case 91:case 114:case 116:case 46:case 47:case 30:case 135:case 127:case 81:case 60:return!0;default:return Ip()?!0:tn()}}function w2(){return z()!==19&&z()!==100&&z()!==86&&z()!==60&&dg()}function Qe(){let ie=Nt();ie&&Ci(!1);let Le=Q(),it=Cu(!0),Lt;for(;Lt=zi(28);)it=e1(it,Lt,Cu(!0),Le);return ie&&Ci(!0),it}function Mm(){return ts(64)?Cu(!0):void 0}function Cu(ie){if(Gb())return Md();let Le=L0(ie)||UE(ie);if(Le)return Le;let it=Q(),Lt=Ke(),Kt=j0(0);return Kt.kind===80&&z()===39?sh(it,Kt,ie,Lt,void 0):xf(Kt)&&y0(Ht())?e1(Kt,el(),Cu(ie),it):F0(Kt,it,ie)}function Gb(){return z()===127?tr()?!0:Yn(j2):!1}function Qh(){return Re(),!t.hasPrecedingLineBreak()&&tn()}function Md(){let ie=Q();return Re(),!t.hasPrecedingLineBreak()&&(z()===42||dg())?_r(E.createYieldExpression(zi(42),Cu(!0)),ie):_r(E.createYieldExpression(void 0,void 0),ie)}function sh(ie,Le,it,Lt,Kt){M.assert(z()===39,"parseSimpleArrowFunctionExpression should only have been called if we had a =>");let Rr=E.createParameterDeclaration(void 0,void 0,Le,void 0,void 0,void 0);_r(Rr,Le.pos);let ni=po([Rr],Rr.pos,Rr.end),Xi=kc(39),Li=Yb(!!Kt,it),xi=E.createArrowFunction(Kt,void 0,ni,void 0,Xi,Li);return $r(_r(xi,ie),Lt)}function L0(ie){let Le=V6();if(Le!==0)return Le===1?O2(!0,!0):pi(()=>Lm(ie))}function V6(){return z()===21||z()===30||z()===134?Yn(Za):z()===39?1:0}function Za(){if(z()===134&&(Re(),t.hasPrecedingLineBreak()||z()!==21&&z()!==30))return 0;let ie=z(),Le=Re();if(ie===21){if(Le===22)switch(Re()){case 39:case 59:case 19:return 1;default:return 0}if(Le===23||Le===19)return 2;if(Le===26)return 1;if(vv(Le)&&Le!==134&&Yn(zf))return Re()===130?0:1;if(!tn()&&Le!==110)return 0;switch(Re()){case 59:return 1;case 58:return Re(),z()===59||z()===28||z()===64||z()===22?1:0;case 28:case 64:case 22:return 2}return 0}else return M.assert(ie===30),!tn()&&z()!==87?0:qe===1?Yn(()=>{ts(87);let Lt=Re();if(Lt===96)switch(Re()){case 64:case 32:case 44:return!1;default:return!0}else if(Lt===28||Lt===64)return!0;return!1})?1:0:2}function Lm(ie){let Le=t.getTokenStart();if(xr?.has(Le))return;let it=O2(!1,ie);return it||(xr||(xr=new Set)).add(Le),it}function UE(ie){if(z()===134&&Yn(I2)===1){let Le=Q(),it=Ke(),Lt=bi(),Kt=j0(0);return sh(Le,Kt,ie,it,Lt)}}function I2(){if(z()===134){if(Re(),t.hasPrecedingLineBreak()||z()===39)return 0;let ie=j0(0);if(!t.hasPrecedingLineBreak()&&ie.kind===80&&z()===39)return 1}return 0}function O2(ie,Le){let it=Q(),Lt=Ke(),Kt=bi(),Rr=Pt(Kt,TO)?2:0,ni=$_(),Xi;if(er(21)){if(ie)Xi=pg(Rr,ie);else{let G0=pg(Rr,ie);if(!G0)return;Xi=G0}if(!er(22)&&!ie)return}else{if(!ie)return;Xi=$f()}let Li=z()===59,xi=lm(59,!1);if(xi&&!ie&&qc(xi))return;let us=xi;for(;us?.kind===196;)us=us.type;let zo=us&&TN(us);if(!ie&&z()!==39&&(zo||z()!==19))return;let da=z(),$a=kc(39),pd=da===39||da===19?Yb(Pt(Kt,TO),Le):mc();if(!Le&&Li&&z()!==59)return;let hg=E.createArrowFunction(Kt,ni,Xi,xi,$a,pd);return $r(_r(hg,it),Lt)}function Yb(ie,Le){if(z()===19)return i1(ie?2:0);if(z()!==27&&z()!==100&&z()!==86&&Mf()&&!w2())return i1(16|(ie?2:0));let it=ur;ur=!1;let Lt=ie?Ce(()=>Cu(Le)):nt(()=>Cu(Le));return ur=it,Lt}function F0(ie,Le,it){let Lt=zi(58);if(!Lt)return ie;let Kt;return _r(E.createConditionalExpression(ie,Lt,la(n,()=>Cu(!1)),Kt=kc(59),Yd(Kt)?Cu(it):Jc(80,!1,v._0_expected,Sa(59))),Le)}function j0(ie){let Le=Q(),it=t1();return ld(ie,it,Le)}function Kb(ie){return ie===103||ie===165}function ld(ie,Le,it){for(;;){Ht();let Lt=OR(z());if(!(z()===43?Lt>=ie:Lt>ie)||z()===103&&Oe())break;if(z()===130||z()===152){if(t.hasPrecedingLineBreak())break;{let Rr=z();Re(),Le=Rr===152?Zv(Le,ou()):as(Le,ou())}}else Le=e1(Le,el(),j0(Lt),it)}return Le}function Ip(){return Oe()&&z()===103?!1:OR(z())>0}function Zv(ie,Le){return _r(E.createSatisfiesExpression(ie,Le),ie.pos)}function e1(ie,Le,it,Lt){return _r(E.createBinaryExpression(ie,Le,it),Lt)}function as(ie,Le){return _r(E.createAsExpression(ie,Le),ie.pos)}function qn(){let ie=Q();return _r(E.createPrefixUnaryExpression(z(),Te(B0)),ie)}function m_(){let ie=Q();return _r(E.createDeleteExpression(Te(B0)),ie)}function gD(){let ie=Q();return _r(E.createTypeOfExpression(Te(B0)),ie)}function Fm(){let ie=Q();return _r(E.createVoidExpression(Te(B0)),ie)}function Ak(){return z()===135?Ut()?!0:Yn(j2):!1}function Zh(){let ie=Q();return _r(E.createAwaitExpression(Te(B0)),ie)}function t1(){if(hD()){let it=Q(),Lt=Xb();return z()===43?ld(OR(z()),Lt,it):Lt}let ie=z(),Le=B0();if(z()===43){let it=Ja(De,Le.pos),{end:Lt}=Le;Le.kind===216?Z(it,Lt,v.A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses):(M.assert(v9(ie)),Z(it,Lt,v.An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses,Sa(ie)))}return Le}function B0(){switch(z()){case 40:case 41:case 55:case 54:return qn();case 91:return m_();case 114:return gD();case 116:return Fm();case 30:return qe===1?zy(!0,void 0,void 0,!0):Nk();case 135:if(Ak())return Zh();default:return Xb()}}function hD(){switch(z()){case 40:case 41:case 55:case 54:case 91:case 114:case 116:case 135:return!1;case 30:if(qe!==1)return!1;default:return!0}}function Xb(){if(z()===46||z()===47){let Le=Q();return _r(E.createPrefixUnaryExpression(z(),Te(Op)),Le)}else if(qe===1&&z()===30&&Yn($l))return zy(!0);let ie=Op();if(M.assert(xf(ie)),(z()===46||z()===47)&&!t.hasPrecedingLineBreak()){let Le=z();return Re(),_r(E.createPostfixUnaryExpression(ie,Le),ie.pos)}return ie}function Op(){let ie=Q(),Le;return z()===102?Yn(kn)?(ke|=4194304,Le=el()):Yn(ji)?(Re(),Re(),Le=_r(E.createMetaProperty(102,tl()),ie),ke|=8388608):Le=VE():Le=z()===108?sc():VE(),Ld(ie,Le)}function VE(){let ie=Q(),Le=L2();return ah(ie,Le,!0)}function sc(){let ie=Q(),Le=el();if(z()===30){let it=Q(),Lt=pi(Qb);Lt!==void 0&&(Z(it,Q(),v.super_may_not_use_type_arguments),vp()||(Le=E.createExpressionWithTypeArguments(Le,Lt)))}return z()===21||z()===25||z()===23?Le:(kc(25,v.super_must_be_followed_by_an_argument_list_or_member_access),_r(ee(Le,Gt(!0,!0,!0)),ie))}function zy(ie,Le,it,Lt=!1){let Kt=Q(),Rr=J6(ie),ni;if(Rr.kind===286){let Xi=JE(Rr),Li,xi=Xi[Xi.length-1];if(xi?.kind===284&&!kb(xi.openingElement.tagName,xi.closingElement.tagName)&&kb(Rr.tagName,xi.closingElement.tagName)){let us=xi.children.end,zo=_r(E.createJsxElement(xi.openingElement,xi.children,_r(E.createJsxClosingElement(_r(L(""),us,us)),us,us)),xi.openingElement.pos,us);Xi=po([...Xi.slice(0,Xi.length-1),zo],Xi.pos,us),Li=xi.closingElement}else Li=yn(Rr,ie),kb(Rr.tagName,Li.tagName)||(it&&Yg(it)&&kb(Li.tagName,it.tagName)?Ge(Rr.tagName,v.JSX_element_0_has_no_corresponding_closing_tag,kI(De,Rr.tagName)):Ge(Li.tagName,v.Expected_corresponding_JSX_closing_tag_for_0,kI(De,Rr.tagName)));ni=_r(E.createJsxElement(Rr,Xi,Li),Kt)}else Rr.kind===289?ni=_r(E.createJsxFragment(Rr,JE(Rr),Pk(ie)),Kt):(M.assert(Rr.kind===285),ni=Rr);if(!Lt&&ie&&z()===30){let Xi=typeof Le>"u"?ni.pos:Le,Li=pi(()=>zy(!0,Xi));if(Li){let xi=Jc(28,!1);return wG(xi,Li.pos,0),Z(Ja(De,Xi),Li.end,v.JSX_expressions_must_have_one_parent_element),_r(E.createBinaryExpression(ni,xi,Li),Kt)}}return ni}function yD(){let ie=Q(),Le=E.createJsxText(t.getTokenValue(),mt===13);return mt=t.scanJsxToken(),_r(Le,ie)}function R2(ie,Le){switch(Le){case 1:if(_2(ie))Ge(ie,v.JSX_fragment_has_no_corresponding_closing_tag);else{let it=ie.tagName,Lt=Math.min(Ja(De,it.pos),it.end);Z(Lt,it.end,v.JSX_element_0_has_no_corresponding_closing_tag,kI(De,ie.tagName))}return;case 31:case 7:return;case 12:case 13:return yD();case 19:return D_(!1);case 30:return zy(!1,void 0,ie);default:return M.assertNever(Le)}}function JE(ie){let Le=[],it=Q(),Lt=vr;for(vr|=16384;;){let Kt=R2(ie,mt=t.reScanJsxToken());if(!Kt||(Le.push(Kt),Yg(ie)&&Kt?.kind===284&&!kb(Kt.openingElement.tagName,Kt.closingElement.tagName)&&kb(ie.tagName,Kt.closingElement.tagName)))break}return vr=Lt,po(Le,it)}function kk(){let ie=Q();return _r(E.createJsxAttributes(so(13,Ls)),ie)}function J6(ie){let Le=Q();if(er(30),z()===32)return In(),_r(E.createJsxOpeningFragment(),Le);let it=vD(),Lt=jr&524288?void 0:W0(),Kt=kk(),Rr;return z()===32?(In(),Rr=E.createJsxOpeningElement(it,Lt,Kt)):(er(44),er(32,void 0,!1)&&(ie?Re():In()),Rr=E.createJsxSelfClosingElement(it,Lt,Kt)),_r(Rr,Le)}function vD(){let ie=Q(),Le=Mn();if(sg(Le))return Le;let it=Le;for(;ts(25);)it=_r(ee(it,Gt(!0,!1,!1)),ie);return it}function Mn(){let ie=Q();Ar();let Le=z()===110,it=Se();return ts(59)?(Ar(),_r(E.createJsxNamespacedName(it,Se()),ie)):Le?_r(E.createToken(110),ie):it}function D_(ie){let Le=Q();if(!er(19))return;let it,Lt;return z()!==20&&(ie||(it=zi(26)),Lt=Qe()),ie?er(20):er(20,void 0,!1)&&In(),_r(E.createJsxExpression(it,Lt),Le)}function Ls(){if(z()===19)return yp();let ie=Q();return _r(E.createJsxAttribute(M2(),U0()),ie)}function U0(){if(z()===64){if(Ki()===11)return jt();if(z()===19)return D_(!0);if(z()===30)return zy(!0);Rt(v.or_JSX_element_expected)}}function M2(){let ie=Q();Ar();let Le=Se();return ts(59)?(Ar(),_r(E.createJsxNamespacedName(Le,Se()),ie)):Le}function yp(){let ie=Q();er(19),er(26);let Le=Qe();return er(20),_r(E.createJsxSpreadAttribute(Le),ie)}function yn(ie,Le){let it=Q();er(31);let Lt=vD();return er(32,void 0,!1)&&(Le||!kb(ie.tagName,Lt)?Re():In()),_r(E.createJsxClosingElement(Lt),it)}function Pk(ie){let Le=Q();return er(31),er(32,v.Expected_corresponding_closing_tag_for_JSX_fragment,!1)&&(ie?Re():In()),_r(E.createJsxJsxClosingFragment(),Le)}function Nk(){M.assert(qe!==1,"Type assertions should never be parsed in JSX; they should be parsed as comparisons or JSX elements/fragments.");let ie=Q();er(30);let Le=ou();er(32);let it=B0();return _r(E.createTypeAssertion(Le,it),ie)}function H_(){return Re(),F_(z())||z()===23||vp()}function jm(){return z()===29&&Yn(H_)}function fm(ie){if(ie.flags&64)return!0;if(VA(ie)){let Le=ie.expression;for(;VA(Le)&&!(Le.flags&64);)Le=Le.expression;if(Le.flags&64){for(;VA(ie);)ie.flags|=64,ie=ie.expression;return!0}}return!1}function r1(ie,Le,it){let Lt=Gt(!0,!0,!0),Kt=it||fm(Le),Rr=Kt?W(Le,it,Lt):ee(Le,Lt);if(Kt&&Zi(Rr.name)&&Ge(Rr.name,v.An_optional_chain_cannot_contain_private_identifiers),x0(Le)&&Le.typeArguments){let ni=Le.typeArguments.pos-1,Xi=Ja(De,Le.typeArguments.end)+1;Z(ni,Xi,v.An_instantiation_expression_cannot_be_followed_by_a_property_access)}return _r(Rr,ie)}function qE(ie,Le,it){let Lt;if(z()===24)Lt=Jc(80,!0,v.An_element_access_expression_should_take_an_argument);else{let Rr=yr(Qe);zp(Rr)&&(Rr.text=z_(Rr.text)),Lt=Rr}er(24);let Kt=it||fm(Le)?K(Le,it,Lt):pe(Le,Lt);return _r(Kt,ie)}function ah(ie,Le,it){for(;;){let Lt,Kt=!1;if(it&&jm()?(Lt=kc(29),Kt=F_(z())):Kt=ts(25),Kt){Le=r1(ie,Le,Lt);continue}if((Lt||!Nt())&&ts(23)){Le=qE(ie,Le,Lt);continue}if(vp()){Le=!Lt&&Le.kind===233?oh(ie,Le.expression,Lt,Le.typeArguments):oh(ie,Le,Lt,void 0);continue}if(!Lt){if(z()===54&&!t.hasPrecedingLineBreak()){Re(),Le=_r(E.createNonNullExpression(Le),ie);continue}let Rr=pi(Qb);if(Rr){Le=_r(E.createExpressionWithTypeArguments(Le,Rr),ie);continue}}return Le}}function vp(){return z()===15||z()===16}function oh(ie,Le,it,Lt){let Kt=E.createTaggedTemplateExpression(Le,Lt,z()===15?(qr(!0),jt()):Fr(!0));return(it||Le.flags&64)&&(Kt.flags|=64),Kt.questionDotToken=it,_r(Kt,ie)}function Ld(ie,Le){for(;;){Le=ah(ie,Le,!0);let it,Lt=zi(29);if(Lt&&(it=pi(Qb),vp())){Le=oh(ie,Le,Lt,it);continue}if(it||z()===21){!Lt&&Le.kind===233&&(it=Le.typeArguments,Le=Le.expression);let Kt=Wy(),Rr=Lt||fm(Le)?ue(Le,Lt,it,Kt):re(Le,it,Kt);Le=_r(Rr,ie);continue}if(Lt){let Kt=Jc(80,!1,v.Identifier_expected);Le=_r(W(Le,Lt,Kt),ie)}break}return Le}function Wy(){er(21);let ie=Hl(11,Zb);return er(22),ie}function Qb(){if(jr&524288||Hr()!==30)return;Re();let ie=Hl(20,ou);if(Ht()===32)return Re(),ie&&Dk()?ie:void 0}function Dk(){switch(z()){case 21:case 15:case 16:return!0;case 30:case 32:case 40:case 41:return!1}return t.hasPrecedingLineBreak()||Ip()||!dg()}function L2(){switch(z()){case 15:t.getTokenFlags()&26656&&qr(!1);case 9:case 10:case 11:return jt();case 110:case 108:case 106:case 112:case 97:return el();case 21:return zE();case 23:return Bm();case 19:return eT();case 134:if(!Yn(G_))break;return mS();case 60:return fs();case 86:return As();case 100:return mS();case 105:return n1();case 44:case 69:if(dr()===14)return jt();break;case 16:return Fr(!1);case 81:return pr()}return mc(v.Expression_expected)}function zE(){let ie=Q(),Le=Ke();er(21);let it=yr(Qe);return er(22),$r(_r(ne(it),ie),Le)}function SD(){let ie=Q();er(26);let Le=Cu(!0);return _r(E.createSpreadElement(Le),ie)}function F2(){return z()===26?SD():z()===28?_r(E.createOmittedExpression(),Q()):Cu(!0)}function Zb(){return la(n,F2)}function Bm(){let ie=Q(),Le=t.getTokenStart(),it=er(23),Lt=t.hasPrecedingLineBreak(),Kt=Hl(15,F2);return Sc(23,24,it,Le),_r(G(Kt,Lt),ie)}function bD(){let ie=Q(),Le=Ke();if(zi(26)){let us=Cu(!0);return $r(_r(E.createSpreadAssignment(us),ie),Le)}let it=Zt(!0);if(Jn(139))return s1(ie,Le,it,177,0);if(Jn(153))return s1(ie,Le,it,178,0);let Lt=zi(42),Kt=tn(),Rr=Tr(),ni=zi(58),Xi=zi(54);if(Lt||z()===21||z()===30)return Ll(ie,Le,it,Lt,Rr,ni,Xi);let Li;if(Kt&&z()!==59){let us=zi(64),zo=us?yr(()=>Cu(!0)):void 0;Li=E.createShorthandPropertyAssignment(Rr,zo),Li.equalsToken=us}else{er(59);let us=yr(()=>Cu(!0));Li=E.createPropertyAssignment(Rr,us)}return Li.modifiers=it,Li.questionToken=ni,Li.exclamationToken=Xi,$r(_r(Li,ie),Le)}function eT(){let ie=Q(),Le=t.getTokenStart(),it=er(19),Lt=t.hasPrecedingLineBreak(),Kt=Hl(12,bD,!0);return Sc(19,20,it,Le),_r(q(Kt,Lt),ie)}function mS(){let ie=Nt();Ci(!1);let Le=Q(),it=Ke(),Lt=Zt(!1);er(100);let Kt=zi(42),Rr=Kt?1:0,ni=Pt(Lt,TO)?2:0,Xi=Rr&&ni?Me(V0):Rr?fe(V0):ni?Ce(V0):V0(),Li=$_(),xi=cd(Rr|ni),us=lm(59,!1),zo=i1(Rr|ni);Ci(ie);let da=E.createFunctionExpression(Lt,Kt,Xi,Li,xi,us,zo);return $r(_r(da,Le),it)}function V0(){return Er()?qf():void 0}function n1(){let ie=Q();if(er(105),ts(25)){let Rr=tl();return _r(E.createMetaProperty(105,Rr),ie)}let Le=Q(),it=ah(Le,L2(),!1),Lt;it.kind===233&&(Lt=it.typeArguments,it=it.expression),z()===29&&Rt(v.Invalid_optional_chain_from_new_expression_Did_you_mean_to_call_0,kI(De,it));let Kt=z()===21?Wy():void 0;return _r(ce(it,Lt,Kt),ie)}function pm(ie,Le){let it=Q(),Lt=Ke(),Kt=t.getTokenStart(),Rr=er(19,Le);if(Rr||ie){let ni=t.hasPrecedingLineBreak(),Xi=so(1,ud);Sc(19,20,Rr,Kt);let Li=$r(_r(le(Xi,ni),it),Lt);return z()===64&&(Rt(v.Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_destructuring_assignment_you_might_need_to_wrap_the_whole_assignment_in_parentheses),Re()),Li}else{let ni=$f();return $r(_r(le(ni,void 0),it),Lt)}}function i1(ie,Le){let it=tr();vi(!!(ie&1));let Lt=Ut();Ui(!!(ie&2));let Kt=ur;ur=!1;let Rr=Nt();Rr&&Ci(!1);let ni=pm(!!(ie&16),Le);return Rr&&Ci(!0),ur=Kt,vi(it),Ui(Lt),ni}function tT(){let ie=Q(),Le=Ke();return er(27),$r(_r(E.createEmptyStatement(),ie),Le)}function wu(){let ie=Q(),Le=Ke();er(101);let it=t.getTokenStart(),Lt=er(21),Kt=yr(Qe);Sc(21,22,Lt,it);let Rr=ud(),ni=ts(93)?ud():void 0;return $r(_r(Ae(Kt,Rr,ni),ie),Le)}function J0(){let ie=Q(),Le=Ke();er(92);let it=ud();er(117);let Lt=t.getTokenStart(),Kt=er(21),Rr=yr(Qe);return Sc(21,22,Kt,Lt),ts(27),$r(_r(E.createDoStatement(it,Rr),ie),Le)}function ch(){let ie=Q(),Le=Ke();er(117);let it=t.getTokenStart(),Lt=er(21),Kt=yr(Qe);Sc(21,22,Lt,it);let Rr=ud();return $r(_r(xe(Kt,Rr),ie),Le)}function pl(){let ie=Q(),Le=Ke();er(99);let it=zi(135);er(21);let Lt;z()!==27&&(z()===115||z()===121||z()===87||z()===160&&Yn(CD)||z()===135&&Yn(Ok)?Lt=Um(!0):Lt=to(Qe));let Kt;if(it?er(165):ts(165)){let Rr=yr(()=>Cu(!0));er(22),Kt=he(it,Lt,Rr,ud())}else if(ts(103)){let Rr=yr(Qe);er(22),Kt=E.createForInStatement(Lt,Rr,ud())}else{er(27);let Rr=z()!==27&&z()!==22?yr(Qe):void 0;er(27);let ni=z()!==22?yr(Qe):void 0;er(22),Kt=te(Lt,Rr,ni,ud())}return $r(_r(Kt,ie),Le)}function Au(ie){let Le=Q(),it=Ke();er(ie===252?83:88);let Lt=Fa()?void 0:mc();Lo();let Kt=ie===252?E.createBreakStatement(Lt):E.createContinueStatement(Lt);return $r(_r(Kt,Le),it)}function q0(){let ie=Q(),Le=Ke();er(107);let it=Fa()?void 0:yr(Qe);return Lo(),$r(_r(E.createReturnStatement(it),ie),Le)}function Gf(){let ie=Q(),Le=Ke();er(118);let it=t.getTokenStart(),Lt=er(21),Kt=yr(Qe);Sc(21,22,Lt,it);let Rr=Gs(67108864,ud);return $r(_r(E.createWithStatement(Kt,Rr),ie),Le)}function Fd(){let ie=Q(),Le=Ke();er(84);let it=yr(Qe);er(59);let Lt=so(3,ud);return $r(_r(E.createCaseClause(it,Lt),ie),Le)}function wk(){let ie=Q();er(90),er(59);let Le=so(3,ud);return _r(E.createDefaultClause(Le),ie)}function lh(){return z()===84?Fd():wk()}function Ik(){let ie=Q();er(19);let Le=so(2,lh);return er(20),_r(E.createCaseBlock(Le),ie)}function uh(){let ie=Q(),Le=Ke();er(109),er(21);let it=yr(Qe);er(22);let Lt=Ik();return $r(_r(E.createSwitchStatement(it,Lt),ie),Le)}function gS(){let ie=Q(),Le=Ke();er(111);let it=t.hasPrecedingLineBreak()?void 0:yr(Qe);return it===void 0&&(rr++,it=_r(L(""),Q())),bc()||uo(it),$r(_r(E.createThrowStatement(it),ie),Le)}function TD(){let ie=Q(),Le=Ke();er(113);let it=pm(!1),Lt=z()===85?nl():void 0,Kt;return(!Lt||z()===98)&&(er(98,v.catch_or_finally_expected),Kt=pm(!1)),$r(_r(E.createTryStatement(it,Lt,Kt),ie),Le)}function nl(){let ie=Q();er(85);let Le;ts(21)?(Le=vS(),er(22)):Le=void 0;let it=pm(!1);return _r(E.createCatchClause(Le,it),ie)}function ED(){let ie=Q(),Le=Ke();return er(89),Lo(),$r(_r(E.createDebuggerStatement(),ie),Le)}function xD(){let ie=Q(),Le=Ke(),it,Lt=z()===21,Kt=yr(Qe);return He(Kt)&&ts(59)?it=E.createLabeledStatement(Kt,ud()):(bc()||uo(Kt),it=de(Kt),Lt&&(Le=!1)),$r(_r(it,ie),Le)}function rT(){return Re(),F_(z())&&!t.hasPrecedingLineBreak()}function q6(){return Re(),z()===86&&!t.hasPrecedingLineBreak()}function G_(){return Re(),z()===100&&!t.hasPrecedingLineBreak()}function j2(){return Re(),(F_(z())||z()===9||z()===10||z()===11)&&!t.hasPrecedingLineBreak()}function WE(){for(;;)switch(z()){case 115:case 121:case 87:case 100:case 86:case 94:return!0;case 160:return $E();case 135:return B2();case 120:case 156:return Qh();case 144:case 145:return ro();case 128:case 129:case 134:case 138:case 123:case 124:case 125:case 148:let ie=z();if(Re(),t.hasPrecedingLineBreak())return!1;if(ie===138&&z()===156)return!0;continue;case 162:return Re(),z()===19||z()===80||z()===95;case 102:return Re(),z()===11||z()===42||z()===19||F_(z());case 95:let Le=Re();if(Le===156&&(Le=Yn(Re)),Le===64||Le===42||Le===19||Le===90||Le===130||Le===60)return!0;continue;case 126:Re();continue;default:return!1}}function nT(){return Yn(WE)}function Mf(){switch(z()){case 60:case 27:case 19:case 115:case 121:case 160:case 100:case 86:case 94:case 101:case 92:case 117:case 99:case 88:case 83:case 107:case 118:case 109:case 111:case 113:case 89:case 85:case 98:return!0;case 102:return nT()||Yn(En);case 87:case 95:return nT();case 134:case 138:case 120:case 144:case 145:case 156:case 162:return!0;case 129:case 125:case 123:case 124:case 126:case 148:return nT()||!Yn(rT);default:return dg()}}function z6(){return Re(),Er()||z()===19||z()===23}function iT(){return Yn(z6)}function CD(){return sT(!0)}function sT(ie){return Re(),ie&&z()===165?!1:(Er()||z()===19)&&!t.hasPrecedingLineBreak()}function $E(){return Yn(sT)}function Ok(ie){return Re()===160?sT(ie):!1}function B2(){return Yn(Ok)}function ud(){switch(z()){case 27:return tT();case 19:return pm(!1);case 115:return ey(Q(),Ke(),void 0);case 121:if(iT())return ey(Q(),Ke(),void 0);break;case 135:if(B2())return ey(Q(),Ke(),void 0);break;case 160:if($E())return ey(Q(),Ke(),void 0);break;case 100:return _h(Q(),Ke(),void 0);case 86:return Ia(Q(),Ke(),void 0);case 101:return wu();case 92:return J0();case 117:return ch();case 99:return pl();case 88:return Au(251);case 83:return Au(252);case 107:return q0();case 118:return Gf();case 109:return uh();case 111:return gS();case 113:case 85:case 98:return TD();case 89:return ED();case 60:return hS();case 134:case 120:case 156:case 144:case 145:case 138:case 87:case 94:case 95:case 102:case 123:case 124:case 125:case 128:case 129:case 126:case 148:case 162:if(nT())return hS();break}return xD()}function AD(ie){return ie.kind===138}function hS(){let ie=Q(),Le=Ke(),it=Zt(!0);if(Pt(it,AD)){let Kt=Rp(ie);if(Kt)return Kt;for(let Rr of it)Rr.flags|=33554432;return Gs(33554432,()=>mg(ie,Le,it))}else return mg(ie,Le,it)}function Rp(ie){return Gs(33554432,()=>{let Le=au(vr,ie);if(Le)return Uo(Le)})}function mg(ie,Le,it){switch(z()){case 115:case 121:case 87:case 160:case 135:return ey(ie,Le,it);case 100:return _h(ie,Le,it);case 86:return Ia(ie,Le,it);case 120:return $0(ie,Le,it);case 156:return oT(ie,Le,it);case 94:return bS(ie,Le,it);case 162:case 144:case 145:return W6(ie,Le,it);case 102:return oJ(ie,Le,it);case 95:switch(Re(),z()){case 90:case 64:return Ao(ie,Le,it);case 130:return aJ(ie,Le,it);default:return G6(ie,Le,it)}default:if(it){let Lt=Jc(282,!0,v.Declaration_expected);return fO(Lt,ie),Lt.modifiers=it,Lt}return}}function U2(){return Re()===11}function V2(){return Re(),z()===161||z()===64}function ro(){return Re(),!t.hasPrecedingLineBreak()&&(tn()||z()===11)}function jn(ie,Le){if(z()!==19){if(ie&4){R0();return}if(Fa()){Lo();return}}return i1(ie,Le)}function _d(){let ie=Q();if(z()===28)return _r(E.createOmittedExpression(),ie);let Le=zi(26),it=yS(),Lt=Mm();return _r(E.createBindingElement(Le,void 0,it,Lt),ie)}function Qu(){let ie=Q(),Le=zi(26),it=Er(),Lt=Tr(),Kt;it&&z()!==59?(Kt=Lt,Lt=void 0):(er(59),Kt=yS());let Rr=Mm();return _r(E.createBindingElement(Le,Lt,Kt,Rr),ie)}function kD(){let ie=Q();er(19);let Le=yr(()=>Hl(9,Qu));return er(20),_r(E.createObjectBindingPattern(Le),ie)}function PD(){let ie=Q();er(23);let Le=yr(()=>Hl(10,_d));return er(24),_r(E.createArrayBindingPattern(Le),ie)}function aT(){return z()===19||z()===23||z()===81||Er()}function yS(ie){return z()===23?PD():z()===19?kD():qf(ie)}function ND(){return vS(!0)}function vS(ie){let Le=Q(),it=Ke(),Lt=yS(v.Private_identifiers_are_not_allowed_in_variable_declarations),Kt;ie&&Lt.kind===80&&z()===54&&!t.hasPrecedingLineBreak()&&(Kt=el());let Rr=Qv(),ni=Kb(z())?void 0:Mm(),Xi=be(Lt,Kt,Rr,ni);return $r(_r(Xi,Le),it)}function Um(ie){let Le=Q(),it=0;switch(z()){case 115:break;case 121:it|=1;break;case 87:it|=2;break;case 160:it|=4;break;case 135:M.assert(B2()),it|=6,Re();break;default:M.fail()}Re();let Lt;if(z()===165&&Yn(Mp))Lt=$f();else{let Kt=Oe();An(ie),Lt=Hl(8,ie?vS:ND),An(Kt)}return _r(Ve(Lt,it),Le)}function Mp(){return zf()&&Re()===22}function ey(ie,Le,it){let Lt=Um(!1);Lo();let Kt=me(it,Lt);return $r(_r(Kt,ie),Le)}function _h(ie,Le,it){let Lt=Ut(),Kt=Vg(it);er(100);let Rr=zi(42),ni=Kt&2048?V0():qf(),Xi=Rr?1:0,Li=Kt&1024?2:0,xi=$_();Kt&32&&Ui(!0);let us=cd(Xi|Li),zo=lm(59,!1),da=jn(Xi|Li,v.or_expected);Ui(Lt);let $a=E.createFunctionDeclaration(it,Rr,ni,xi,us,zo,da);return $r(_r($a,ie),Le)}function z0(){if(z()===137)return er(137);if(z()===11&&Yn(Re)===21)return pi(()=>{let ie=jt();return ie.text==="constructor"?ie:void 0})}function J2(ie,Le,it){return pi(()=>{if(z0()){let Lt=$_(),Kt=cd(0),Rr=lm(59,!1),ni=jn(0,v.or_expected),Xi=E.createConstructorDeclaration(it,Kt,ni);return Xi.typeParameters=Lt,Xi.type=Rr,$r(_r(Xi,ie),Le)}})}function Ll(ie,Le,it,Lt,Kt,Rr,ni,Xi){let Li=Lt?1:0,xi=Pt(it,TO)?2:0,us=$_(),zo=cd(Li|xi),da=lm(59,!1),$a=jn(Li|xi,Xi),pd=E.createMethodDeclaration(it,Lt,Kt,Rr,us,zo,da,$a);return pd.exclamationToken=ni,$r(_r(pd,ie),Le)}function Vm(ie,Le,it,Lt,Kt){let Rr=!Kt&&!t.hasPrecedingLineBreak()?zi(54):void 0,ni=Qv(),Xi=la(90112,Mm);ms(Lt,ni,Xi);let Li=E.createPropertyDeclaration(it,Lt,Kt||Rr,ni,Xi);return $r(_r(Li,ie),Le)}function Lp(ie,Le,it){let Lt=zi(42),Kt=Tr(),Rr=zi(58);return Lt||z()===21||z()===30?Ll(ie,Le,it,Lt,Kt,Rr,void 0,v.or_expected):Vm(ie,Le,it,Kt,Rr)}function s1(ie,Le,it,Lt,Kt){let Rr=Tr(),ni=$_(),Xi=cd(0),Li=lm(59,!1),xi=jn(Kt),us=Lt===177?E.createGetAccessorDeclaration(it,Rr,Xi,Li,xi):E.createSetAccessorDeclaration(it,Rr,Xi,xi);return us.typeParameters=ni,fp(us)&&(us.type=Li),$r(_r(us,ie),Le)}function fd(){let ie;if(z()===60)return!0;for(;vv(z());){if(ie=z(),B$(ie))return!0;Re()}if(z()===42||(ae()&&(ie=z(),Re()),z()===23))return!0;if(ie!==void 0){if(!sf(ie)||ie===153||ie===139)return!0;switch(z()){case 21:case 30:case 54:case 59:case 64:case 58:return!0;default:return Fa()}}return!1}function q2(ie,Le,it){kc(126);let Lt=SS(),Kt=$r(_r(E.createClassStaticBlockDeclaration(Lt),ie),Le);return Kt.modifiers=it,Kt}function SS(){let ie=tr(),Le=Ut();vi(!1),Ui(!0);let it=pm(!1);return vi(ie),Ui(Le),it}function O(){if(Ut()&&z()===135){let ie=Q(),Le=mc(v.Expression_expected);Re();let it=ah(ie,Le,!0);return Ld(ie,it)}return Op()}function ye(){let ie=Q();if(!ts(60))return;let Le=vt(O);return _r(E.createDecorator(Le),ie)}function Dt(ie,Le,it){let Lt=Q(),Kt=z();if(z()===87&&Le){if(!pi(Ri))return}else{if(it&&z()===126&&Yn(ID))return;if(ie&&z()===126)return;if(!Wl())return}return _r(J(Kt),Lt)}function Zt(ie,Le,it){let Lt=Q(),Kt,Rr,ni,Xi=!1,Li=!1,xi=!1;if(ie&&z()===60)for(;Rr=ye();)Kt=Bt(Kt,Rr);for(;ni=Dt(Xi,Le,it);)ni.kind===126&&(Xi=!0),Kt=Bt(Kt,ni),Li=!0;if(Li&&ie&&z()===60)for(;Rr=ye();)Kt=Bt(Kt,Rr),xi=!0;if(xi)for(;ni=Dt(Xi,Le,it);)ni.kind===126&&(Xi=!0),Kt=Bt(Kt,ni);return Kt&&po(Kt,Lt)}function bi(){let ie;if(z()===134){let Le=Q();Re();let it=_r(J(134),Le);ie=po([it],Le)}return ie}function ys(){let ie=Q(),Le=Ke();if(z()===27)return Re(),$r(_r(E.createSemicolonClassElement(),ie),Le);let it=Zt(!0,!0,!0);if(z()===126&&Yn(ID))return q2(ie,Le,it);if(Jn(139))return s1(ie,Le,it,177,0);if(Jn(153))return s1(ie,Le,it,178,0);if(z()===137||z()===11){let Lt=J2(ie,Le,it);if(Lt)return Lt}if(st())return sr(ie,Le,it);if(F_(z())||z()===11||z()===9||z()===42||z()===23)if(Pt(it,AD)){for(let Kt of it)Kt.flags|=33554432;return Gs(33554432,()=>Lp(ie,Le,it))}else return Lp(ie,Le,it);if(it){let Lt=Jc(80,!0,v.Declaration_expected);return Vm(ie,Le,it,Lt,void 0)}return M.fail("Should not have attempted to parse class member declaration.")}function fs(){let ie=Q(),Le=Ke(),it=Zt(!0);if(z()===86)return Y_(ie,Le,it,231);let Lt=Jc(282,!0,v.Expression_expected);return fO(Lt,ie),Lt.modifiers=it,Lt}function As(){return Y_(Q(),Ke(),void 0,231)}function Ia(ie,Le,it){return Y_(ie,Le,it,263)}function Y_(ie,Le,it,Lt){let Kt=Ut();er(86);let Rr=w_(),ni=$_();Pt(it,OA)&&Ui(!0);let Xi=HE(),Li;er(19)?(Li=DD(),er(20)):Li=$f(),Ui(Kt);let xi=Lt===263?E.createClassDeclaration(it,Rr,ni,Xi,Li):E.createClassExpression(it,Rr,ni,Xi,Li);return $r(_r(xi,ie),Le)}function w_(){return Er()&&!a1()?W_(Er()):void 0}function a1(){return z()===119&&Yn(rl)}function HE(){if(GE())return so(22,Sp)}function Sp(){let ie=Q(),Le=z();M.assert(Le===96||Le===119),Re();let it=Hl(7,gg);return _r(E.createHeritageClause(Le,it),ie)}function gg(){let ie=Q(),Le=Op();if(Le.kind===233)return Le;let it=W0();return _r(E.createExpressionWithTypeArguments(Le,it),ie)}function W0(){return z()===30?ad(20,ou,30,32):void 0}function GE(){return z()===96||z()===119}function DD(){return so(5,ys)}function $0(ie,Le,it){er(120);let Lt=mc(),Kt=$_(),Rr=HE(),ni=an(),Xi=E.createInterfaceDeclaration(it,Lt,Kt,Rr,ni);return $r(_r(Xi,ie),Le)}function oT(ie,Le,it){er(156),t.hasPrecedingLineBreak()&&Rt(v.Line_break_not_permitted_here);let Lt=mc(),Kt=$_();er(64);let Rr=z()===141&&pi(Jb)||ou();Lo();let ni=E.createTypeAliasDeclaration(it,Lt,Kt,Rr);return $r(_r(ni,ie),Le)}function o1(){let ie=Q(),Le=Ke(),it=Tr(),Lt=yr(Mm);return $r(_r(E.createEnumMember(it,Lt),ie),Le)}function bS(ie,Le,it){er(94);let Lt=mc(),Kt;er(19)?(Kt=tt(()=>Hl(6,o1)),er(20)):Kt=$f();let Rr=E.createEnumDeclaration(it,Lt,Kt);return $r(_r(Rr,ie),Le)}function rs(){let ie=Q(),Le;return er(19)?(Le=so(1,ud),er(20)):Le=$f(),_r(E.createModuleBlock(Le),ie)}function TS(ie,Le,it,Lt){let Kt=Lt&32,Rr=Lt&8?tl():mc(),ni=ts(25)?TS(Q(),!1,void 0,8|Kt):rs(),Xi=E.createModuleDeclaration(it,Rr,ni,Lt);return $r(_r(Xi,ie),Le)}function ln(ie,Le,it){let Lt=0,Kt;z()===162?(Kt=mc(),Lt|=2048):(Kt=jt(),Kt.text=z_(Kt.text));let Rr;z()===19?Rr=rs():Lo();let ni=E.createModuleDeclaration(it,Kt,Rr,Lt);return $r(_r(ni,ie),Le)}function W6(ie,Le,it){let Lt=0;if(z()===162)return ln(ie,Le,it);if(ts(145))Lt|=32;else if(er(144),z()===11)return ln(ie,Le,it);return TS(ie,Le,it,Lt)}function wD(){return z()===149&&Yn(Rk)}function Rk(){return Re()===21}function ID(){return Re()===19}function OD(){return Re()===44}function aJ(ie,Le,it){er(130),er(145);let Lt=mc();Lo();let Kt=E.createNamespaceExportDeclaration(Lt);return Kt.modifiers=it,$r(_r(Kt,ie),Le)}function oJ(ie,Le,it){er(102);let Lt=t.getTokenFullStart(),Kt;tn()&&(Kt=mc());let Rr=!1;if(Kt?.escapedText==="type"&&(z()!==161||tn()&&Yn(V2))&&(tn()||d7())&&(Rr=!0,Kt=tn()?mc():void 0),Kt&&!cT())return m7(ie,Le,it,Kt,Rr);let ni=ty(Kt,Lt,Rr),Xi=dm(),Li=p7();Lo();let xi=E.createImportDeclaration(it,ni,Xi,Li);return $r(_r(xi,ie),Le)}function ty(ie,Le,it,Lt=!1){let Kt;return(ie||z()===42||z()===19)&&(Kt=YE(ie,Le,it,Lt),er(161)),Kt}function p7(){let ie=z();if((ie===118||ie===132)&&!t.hasPrecedingLineBreak())return H6(ie)}function $6(){let ie=Q(),Le=F_(z())?tl():Ss(11);er(59);let it=Cu(!0);return _r(E.createImportAttribute(Le,it),ie)}function H6(ie,Le){let it=Q();Le||er(ie);let Lt=t.getTokenStart();if(er(19)){let Kt=t.hasPrecedingLineBreak(),Rr=Hl(24,$6,!0);if(!er(20)){let ni=vc(et);ni&&ni.code===v._0_expected.code&&ca(ni,hA(Pe,De,Lt,1,v.The_parser_expected_to_find_a_1_to_match_the_0_token_here,"{","}"))}return _r(E.createImportAttributes(Rr,Kt,ie),it)}else{let Kt=po([],Q(),void 0,!1);return _r(E.createImportAttributes(Kt,!1,ie),it)}}function d7(){return z()===42||z()===19}function cT(){return z()===28||z()===161}function m7(ie,Le,it,Lt,Kt){er(64);let Rr=H0();Lo();let ni=E.createImportEqualsDeclaration(it,Kt,Lt,Rr);return $r(_r(ni,ie),Le)}function YE(ie,Le,it,Lt){let Kt;return(!ie||ts(28))&&(Lt&&t.setSkipJsDocLeadingAsterisks(!0),Kt=z()===42?RD():g7(275),Lt&&t.setSkipJsDocLeadingAsterisks(!1)),_r(E.createImportClause(it,ie,Kt),Le)}function H0(){return wD()?KE():oe(!1)}function KE(){let ie=Q();er(149),er(21);let Le=dm();return er(22),_r(E.createExternalModuleReference(Le),ie)}function dm(){if(z()===11){let ie=jt();return ie.text=z_(ie.text),ie}else return Qe()}function RD(){let ie=Q();er(42),er(130);let Le=mc();return _r(E.createNamespaceImport(Le),ie)}function g7(ie){let Le=Q(),it=ie===275?E.createNamedImports(ad(23,z2,19,20)):E.createNamedExports(ad(23,ry,19,20));return _r(it,Le)}function ry(){let ie=Ke();return $r(h7(281),ie)}function z2(){return h7(276)}function h7(ie){let Le=Q(),it=sf(z())&&!tn(),Lt=t.getTokenStart(),Kt=t.getTokenEnd(),Rr=!1,ni,Xi=!0,Li=tl();if(Li.escapedText==="type")if(z()===130){let zo=tl();if(z()===130){let da=tl();F_(z())?(Rr=!0,ni=zo,Li=us(),Xi=!1):(ni=Li,Li=da,Xi=!1)}else F_(z())?(ni=Li,Xi=!1,Li=us()):(Rr=!0,Li=zo)}else F_(z())&&(Rr=!0,Li=us());Xi&&z()===130&&(ni=Li,er(130),Li=us()),ie===276&&it&&Z(Lt,Kt,v.Identifier_expected);let xi=ie===276?E.createImportSpecifier(Rr,ni,Li):E.createExportSpecifier(Rr,ni,Li);return _r(xi,Le);function us(){return it=sf(z())&&!tn(),Lt=t.getTokenStart(),Kt=t.getTokenEnd(),tl()}}function il(ie){return _r(E.createNamespaceExport(tl()),ie)}function G6(ie,Le,it){let Lt=Ut();Ui(!0);let Kt,Rr,ni,Xi=ts(156),Li=Q();ts(42)?(ts(130)&&(Kt=il(Li)),er(161),Rr=dm()):(Kt=g7(279),(z()===161||z()===11&&!t.hasPrecedingLineBreak())&&(er(161),Rr=dm()));let xi=z();Rr&&(xi===118||xi===132)&&!t.hasPrecedingLineBreak()&&(ni=H6(xi)),Lo(),Ui(Lt);let us=E.createExportDeclaration(it,Xi,Kt,Rr,ni);return $r(_r(us,ie),Le)}function Ao(ie,Le,it){let Lt=Ut();Ui(!0);let Kt;ts(64)?Kt=!0:er(90);let Rr=Cu(!0);Lo(),Ui(Lt);let ni=E.createExportAssignment(it,Kt,Rr);return $r(_r(ni,ie),Le)}let ao;(ie=>{ie[ie.SourceElements=0]="SourceElements",ie[ie.BlockStatements=1]="BlockStatements",ie[ie.SwitchClauses=2]="SwitchClauses",ie[ie.SwitchClauseStatements=3]="SwitchClauseStatements",ie[ie.TypeMembers=4]="TypeMembers",ie[ie.ClassMembers=5]="ClassMembers",ie[ie.EnumMembers=6]="EnumMembers",ie[ie.HeritageClauseElement=7]="HeritageClauseElement",ie[ie.VariableDeclarations=8]="VariableDeclarations",ie[ie.ObjectBindingElements=9]="ObjectBindingElements",ie[ie.ArrayBindingElements=10]="ArrayBindingElements",ie[ie.ArgumentExpressions=11]="ArgumentExpressions",ie[ie.ObjectLiteralMembers=12]="ObjectLiteralMembers",ie[ie.JsxAttributes=13]="JsxAttributes",ie[ie.JsxChildren=14]="JsxChildren",ie[ie.ArrayLiteralMembers=15]="ArrayLiteralMembers",ie[ie.Parameters=16]="Parameters",ie[ie.JSDocParameters=17]="JSDocParameters",ie[ie.RestProperties=18]="RestProperties",ie[ie.TypeParameters=19]="TypeParameters",ie[ie.TypeArguments=20]="TypeArguments",ie[ie.TupleElementTypes=21]="TupleElementTypes",ie[ie.HeritageClauses=22]="HeritageClauses",ie[ie.ImportOrExportSpecifiers=23]="ImportOrExportSpecifiers",ie[ie.ImportAttributes=24]="ImportAttributes",ie[ie.JSDocComment=25]="JSDocComment",ie[ie.Count=26]="Count"})(ao||(ao={}));let Mk;(ie=>{ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Unknown=2]="Unknown"})(Mk||(Mk={}));let Lk;(ie=>{function Le(xi,us,zo){Pi("file.js",xi,99,void 0,1,0),t.setText(xi,us,zo),mt=t.scan();let da=it(),$a=Yt("file.js",99,1,!1,[],J(1),0,io),pd=yA(et,$a);return Ie&&($a.jsDocDiagnostics=yA(Ie,$a)),Cs(),da?{jsDocTypeExpression:da,diagnostics:pd}:void 0}ie.parseJSDocTypeExpressionForTests=Le;function it(xi){let us=Q(),zo=(xi?ts:er)(19),da=Gs(16777216,od);(!xi||zo)&&sa(20);let $a=E.createJSDocTypeExpression(da);return $e($a),_r($a,us)}ie.parseJSDocTypeExpression=it;function Lt(){let xi=Q(),us=ts(19),zo=Q(),da=oe(!1);for(;z()===81;)dn(),It(),da=_r(E.createJSDocMemberName(da,mc()),zo);us&&sa(20);let $a=E.createJSDocNameReference(da);return $e($a),_r($a,xi)}ie.parseJSDocNameReference=Lt;function Kt(xi,us,zo){Pi("",xi,99,void 0,1,0);let da=Gs(16777216,()=>Li(us,zo)),pd=yA(et,{languageVariant:0,text:xi});return Cs(),da?{jsDoc:da,diagnostics:pd}:void 0}ie.parseIsolatedJSDocComment=Kt;function Rr(xi,us,zo){let da=mt,$a=et.length,pd=or,hg=Gs(16777216,()=>Li(us,zo));return lo(hg,xi),jr&524288&&(Ie||(Ie=[]),wn(Ie,et,$a)),mt=da,et.length=$a,or=pd,hg}ie.parseJSDocComment=Rr;let ni;(xi=>{xi[xi.BeginningOfLine=0]="BeginningOfLine",xi[xi.SawAsterisk=1]="SawAsterisk",xi[xi.SavingComments=2]="SavingComments",xi[xi.SavingBackticks=3]="SavingBackticks"})(ni||(ni={}));let Xi;(xi=>{xi[xi.Property=1]="Property",xi[xi.Parameter=2]="Parameter",xi[xi.CallbackParameter=4]="CallbackParameter"})(Xi||(Xi={}));function Li(xi=0,us){let zo=De,da=us===void 0?zo.length:xi+us;if(us=da-xi,M.assert(xi>=0),M.assert(xi<=da),M.assert(da<=zo.length),!kY(zo,xi))return;let $a,pd,hg,G0,ES,mm=[],lT=[],Y6=vr;vr|=1<<25;let MD=t.scanRange(xi+3,us-5,y7);return vr=Y6,MD;function y7(){let Lr=1,Xn,ei=xi-(zo.lastIndexOf(`
`,xi)+1)+4;function _i(Qo){Xn||(Xn=ei),mm.push(Qo),ei+=Qo.length}for(It();fT(5););fT(4)&&(Lr=0,ei=0);e:for(;;){switch(z()){case 60:cu(mm),ES||(ES=Q()),Qt($y(ei)),Lr=0,Xn=void 0;break;case 4:mm.push(t.getTokenText()),Lr=0,ei=0;break;case 42:let Qo=t.getTokenText();Lr===1?(Lr=2,_i(Qo)):(M.assert(Lr===0),Lr=1,ei+=Qo.length);break;case 5:M.assert(Lr!==2,"whitespace shouldn't come from the scanner while saving top-level comment text");let ku=t.getTokenText();Xn!==void 0&&ei+ku.length>Xn&&mm.push(ku.slice(Xn-ei)),ei+=ku.length;break;case 1:break e;case 82:Lr=2,_i(t.getTokenValue());break;case 19:Lr=2;let iy=t.getTokenFullStart(),fh=t.getTokenEnd()-1,Al=P(fh);if(Al){G0||oo(mm),lT.push(_r(E.createJSDocText(mm.join("")),G0??xi,iy)),lT.push(Al),mm=[],G0=t.getTokenEnd();break}default:Lr=2,_i(t.getTokenText());break}Lr===2?$t(!1):It()}let Bi=mm.join("").trimEnd();lT.length&&Bi.length&&lT.push(_r(E.createJSDocText(Bi),G0??xi,ES)),lT.length&&$a&&M.assertIsDefined(ES,"having parsed tags implies that the end of the comment span should be set");let mo=$a&&po($a,pd,hg);return _r(E.createJSDocComment(lT.length?po(lT,xi,ES):Bi.length?Bi:void 0,mo),xi,da)}function oo(Lr){for(;Lr.length&&(Lr[0]===`
`||Lr[0]==="\r");)Lr.shift()}function cu(Lr){for(;Lr.length;){let Xn=Lr[Lr.length-1].trimEnd();if(Xn==="")Lr.pop();else if(Xn.length<Lr[Lr.length-1].length){Lr[Lr.length-1]=Xn;break}else break}}function xS(){for(;;){if(It(),z()===1)return!0;if(!(z()===5||z()===4))return!1}}function yg(){if(!((z()===5||z()===4)&&Yn(xS)))for(;z()===5||z()===4;)It()}function uT(){if((z()===5||z()===4)&&Yn(xS))return"";let Lr=t.hasPrecedingLineBreak(),Xn=!1,ei="";for(;Lr&&z()===42||z()===5||z()===4;)ei+=t.getTokenText(),z()===4?(Lr=!0,Xn=!0,ei=""):z()===42&&(Lr=!1),It();return Xn?ei:""}function $y(Lr){M.assert(z()===60);let Xn=t.getTokenStart();It();let ei=pT(void 0),_i=uT(),Bi;switch(ei.escapedText){case"author":Bi=wte(Xn,ei,Lr,_i);break;case"implements":Bi=K6(Xn,ei,Lr,_i);break;case"augments":case"extends":Bi=OEe(Xn,ei,Lr,_i);break;case"class":case"constructor":Bi=c1(Xn,E.createJSDocClassTag,ei,Lr,_i);break;case"public":Bi=c1(Xn,E.createJSDocPublicTag,ei,Lr,_i);break;case"private":Bi=c1(Xn,E.createJSDocPrivateTag,ei,Lr,_i);break;case"protected":Bi=c1(Xn,E.createJSDocProtectedTag,ei,Lr,_i);break;case"readonly":Bi=c1(Xn,E.createJSDocReadonlyTag,ei,Lr,_i);break;case"override":Bi=c1(Xn,E.createJSDocOverrideTag,ei,Lr,_i);break;case"deprecated":Ii=!0,Bi=c1(Xn,E.createJSDocDeprecatedTag,ei,Lr,_i);break;case"this":Bi=cJ(Xn,ei,Lr,_i);break;case"enum":Bi=LEe(Xn,ei,Lr,_i);break;case"arg":case"argument":case"param":return Jm(Xn,ei,2,Lr);case"return":case"returns":Bi=ny(Xn,ei,Lr,_i);break;case"template":Bi=b7(Xn,ei,Lr,_i);break;case"type":Bi=Fk(Xn,ei,Lr,_i);break;case"typedef":Bi=_T(Xn,ei,Lr,_i);break;case"callback":Bi=LD(Xn,ei,Lr,_i);break;case"overload":Bi=FD(Xn,ei,Lr,_i);break;case"satisfies":Bi=Ote(Xn,ei,Lr,_i);break;case"see":Bi=IEe(Xn,ei,Lr,_i);break;case"exception":case"throws":Bi=v7(Xn,ei,Lr,_i);break;case"import":Bi=REe(Xn,ei,Lr,_i);break;default:Bi=rt(Xn,ei,Lr,_i);break}return Bi}function jd(Lr,Xn,ei,_i){return _i||(ei+=Xn-Lr),vn(ei,_i.slice(ei))}function vn(Lr,Xn){let ei=Q(),_i=[],Bi=[],mo,Qo=0,ku;function iy(Y0){ku||(ku=Lr),_i.push(Y0),Lr+=Y0.length}Xn!==void 0&&(Xn!==""&&iy(Xn),Qo=1);let fh=z();e:for(;;){switch(fh){case 4:Qo=0,_i.push(t.getTokenText()),Lr=0;break;case 60:t.resetTokenState(t.getTokenEnd()-1);break e;case 1:break e;case 5:M.assert(Qo!==2&&Qo!==3,"whitespace shouldn't come from the scanner while saving comment text");let Y0=t.getTokenText();ku!==void 0&&Lr+Y0.length>ku&&(_i.push(Y0.slice(ku-Lr)),Qo=2),Lr+=Y0.length;break;case 19:Qo=2;let jk=t.getTokenFullStart(),Bk=t.getTokenEnd()-1,X6=P(Bk);X6?(Bi.push(_r(E.createJSDocText(_i.join("")),mo??ei,jk)),Bi.push(X6),_i=[],mo=t.getTokenEnd()):iy(t.getTokenText());break;case 62:Qo===3?Qo=2:Qo=3,iy(t.getTokenText());break;case 82:Qo!==3&&(Qo=2),iy(t.getTokenValue());break;case 42:if(Qo===0){Qo=1,Lr+=1;break}default:Qo!==3&&(Qo=2),iy(t.getTokenText());break}Qo===2||Qo===3?fh=$t(Qo===3):fh=It()}oo(_i);let Al=_i.join("").trimEnd();if(Bi.length)return Al.length&&Bi.push(_r(E.createJSDocText(Al),mo??ei)),po(Bi,ei,t.getTokenEnd());if(Al.length)return Al}function P(Lr){let Xn=pi(Y);if(!Xn)return;It(),yg();let ei=B(),_i=[];for(;z()!==20&&z()!==4&&z()!==1;)_i.push(t.getTokenText()),It();let Bi=Xn==="link"?E.createJSDocLink:Xn==="linkcode"?E.createJSDocLinkCode:E.createJSDocLinkPlain;return _r(Bi(ei,_i.join("")),Lr,t.getTokenEnd())}function B(){if(F_(z())){let Lr=Q(),Xn=tl();for(;ts(25);)Xn=_r(E.createQualifiedName(Xn,z()===81?Jc(80,!1):tl()),Lr);for(;z()===81;)dn(),It(),Xn=_r(E.createJSDocMemberName(Xn,mc()),Lr);return Xn}}function Y(){if(uT(),z()===19&&It()===60&&F_(It())){let Lr=t.getTokenValue();if(ge(Lr))return Lr}}function ge(Lr){return Lr==="link"||Lr==="linkcode"||Lr==="linkplain"}function rt(Lr,Xn,ei,_i){return _r(E.createJSDocUnknownTag(Xn,jd(Lr,Q(),ei,_i)),Lr)}function Qt(Lr){Lr&&($a?$a.push(Lr):($a=[Lr],pd=Lr.pos),hg=Lr.end)}function fn(){return uT(),z()===19?it():void 0}function Ts(){let Lr=fT(23);Lr&&yg();let Xn=fT(62),ei=Mte();return Xn&&P_(62),Lr&&(yg(),zi(64)&&Qe(),er(24)),{name:ei,isBracketed:Lr}}function Xo(Lr){switch(Lr.kind){case 151:return!0;case 188:return Xo(Lr.elementType);default:return Gp(Lr)&&He(Lr.typeName)&&Lr.typeName.escapedText==="Object"&&!Lr.typeArguments}}function Jm(Lr,Xn,ei,_i){let Bi=fn(),mo=!Bi;uT();let{name:Qo,isBracketed:ku}=Ts(),iy=uT();mo&&!Yn(Y)&&(Bi=fn());let fh=jd(Lr,Q(),_i,iy),Al=qm(Bi,Qo,ei,_i);Al&&(Bi=Al,mo=!0);let Y0=ei===1?E.createJSDocPropertyTag(Xn,Qo,ku,Bi,mo,fh):E.createJSDocParameterTag(Xn,Qo,ku,Bi,mo,fh);return _r(Y0,Lr)}function qm(Lr,Xn,ei,_i){if(Lr&&Xo(Lr.type)){let Bi=Q(),mo,Qo;for(;mo=pi(()=>S7(ei,_i,Xn));)mo.kind===341||mo.kind===348?Qo=Bt(Qo,mo):mo.kind===345&&Ge(mo.tagName,v.A_JSDoc_template_tag_may_not_follow_a_typedef_callback_or_overload_tag);if(Qo){let ku=_r(E.createJSDocTypeLiteral(Qo,Lr.type.kind===188),Bi);return _r(E.createJSDocTypeExpression(ku),Bi)}}}function ny(Lr,Xn,ei,_i){Pt($a,Vj)&&Z(Xn.pos,t.getTokenStart(),v._0_tag_already_specified,Qi(Xn.escapedText));let Bi=fn();return _r(E.createJSDocReturnTag(Xn,Bi,jd(Lr,Q(),ei,_i)),Lr)}function Fk(Lr,Xn,ei,_i){Pt($a,RO)&&Z(Xn.pos,t.getTokenStart(),v._0_tag_already_specified,Qi(Xn.escapedText));let Bi=it(!0),mo=ei!==void 0&&_i!==void 0?jd(Lr,Q(),ei,_i):void 0;return _r(E.createJSDocTypeTag(Xn,Bi,mo),Lr)}function IEe(Lr,Xn,ei,_i){let mo=z()===23||Yn(()=>It()===60&&F_(It())&&ge(t.getTokenValue()))?void 0:Lt(),Qo=ei!==void 0&&_i!==void 0?jd(Lr,Q(),ei,_i):void 0;return _r(E.createJSDocSeeTag(Xn,mo,Qo),Lr)}function v7(Lr,Xn,ei,_i){let Bi=fn(),mo=jd(Lr,Q(),ei,_i);return _r(E.createJSDocThrowsTag(Xn,Bi,mo),Lr)}function wte(Lr,Xn,ei,_i){let Bi=Q(),mo=Ite(),Qo=t.getTokenFullStart(),ku=jd(Lr,Qo,ei,_i);ku||(Qo=t.getTokenFullStart());let iy=typeof ku!="string"?po(ps([_r(mo,Bi,Qo)],ku),Bi):mo.text+ku;return _r(E.createJSDocAuthorTag(Xn,iy),Lr)}function Ite(){let Lr=[],Xn=!1,ei=t.getToken();for(;ei!==1&&ei!==4;){if(ei===30)Xn=!0;else{if(ei===60&&!Xn)break;if(ei===32&&Xn){Lr.push(t.getTokenText()),t.resetTokenState(t.getTokenEnd());break}}Lr.push(t.getTokenText()),ei=It()}return E.createJSDocText(Lr.join(""))}function K6(Lr,Xn,ei,_i){let Bi=Rte();return _r(E.createJSDocImplementsTag(Xn,Bi,jd(Lr,Q(),ei,_i)),Lr)}function OEe(Lr,Xn,ei,_i){let Bi=Rte();return _r(E.createJSDocAugmentsTag(Xn,Bi,jd(Lr,Q(),ei,_i)),Lr)}function Ote(Lr,Xn,ei,_i){let Bi=it(!1),mo=ei!==void 0&&_i!==void 0?jd(Lr,Q(),ei,_i):void 0;return _r(E.createJSDocSatisfiesTag(Xn,Bi,mo),Lr)}function REe(Lr,Xn,ei,_i){let Bi=t.getTokenFullStart(),mo;tn()&&(mo=mc());let Qo=ty(mo,Bi,!0,!0),ku=dm(),iy=p7(),fh=ei!==void 0&&_i!==void 0?jd(Lr,Q(),ei,_i):void 0;return _r(E.createJSDocImportTag(Xn,Qo,ku,iy,fh),Lr)}function Rte(){let Lr=ts(19),Xn=Q(),ei=MEe();t.setSkipJsDocLeadingAsterisks(!0);let _i=W0();t.setSkipJsDocLeadingAsterisks(!1);let Bi=E.createExpressionWithTypeArguments(ei,_i),mo=_r(Bi,Xn);return Lr&&er(20),mo}function MEe(){let Lr=Q(),Xn=pT();for(;ts(25);){let ei=pT();Xn=_r(ee(Xn,ei),Lr)}return Xn}function c1(Lr,Xn,ei,_i,Bi){return _r(Xn(ei,jd(Lr,Q(),_i,Bi)),Lr)}function cJ(Lr,Xn,ei,_i){let Bi=it(!0);return yg(),_r(E.createJSDocThisTag(Xn,Bi,jd(Lr,Q(),ei,_i)),Lr)}function LEe(Lr,Xn,ei,_i){let Bi=it(!0);return yg(),_r(E.createJSDocEnumTag(Xn,Bi,jd(Lr,Q(),ei,_i)),Lr)}function _T(Lr,Xn,ei,_i){let Bi=fn();uT();let mo=gn();yg();let Qo=vn(ei),ku;if(!Bi||Xo(Bi.type)){let fh,Al,Y0,jk=!1;for(;(fh=pi(()=>jD(ei)))&&fh.kind!==345;)if(jk=!0,fh.kind===344)if(Al){let Bk=Rt(v.A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags);Bk&&ca(Bk,hA(Pe,De,0,0,v.The_tag_was_first_specified_here));break}else Al=fh;else Y0=Bt(Y0,fh);if(jk){let Bk=Bi&&Bi.type.kind===188,X6=E.createJSDocTypeLiteral(Y0,Bk);Bi=Al&&Al.typeExpression&&!Xo(Al.typeExpression.type)?Al.typeExpression:_r(X6,Lr),ku=Bi.end}}ku=ku||Qo!==void 0?Q():(mo??Bi??Xn).end,Qo||(Qo=jd(Lr,ku,ei,_i));let iy=E.createJSDocTypedefTag(Xn,Bi,mo,Qo);return _r(iy,Lr,ku)}function gn(Lr){let Xn=t.getTokenStart();if(!F_(z()))return;let ei=pT();if(ts(25)){let _i=gn(!0),Bi=E.createModuleDeclaration(void 0,ei,_i,Lr?8:void 0);return _r(Bi,Xn)}return Lr&&(ei.flags|=4096),ei}function CS(Lr){let Xn=Q(),ei,_i;for(;ei=pi(()=>S7(4,Lr));){if(ei.kind===345){Ge(ei.tagName,v.A_JSDoc_template_tag_may_not_follow_a_typedef_callback_or_overload_tag);break}_i=Bt(_i,ei)}return po(_i||[],Xn)}function AS(Lr,Xn){let ei=CS(Xn),_i=pi(()=>{if(fT(60)){let Bi=$y(Xn);if(Bi&&Bi.kind===342)return Bi}});return _r(E.createJSDocSignature(void 0,ei,_i),Lr)}function LD(Lr,Xn,ei,_i){let Bi=gn();yg();let mo=vn(ei),Qo=AS(Lr,ei);mo||(mo=jd(Lr,Q(),ei,_i));let ku=mo!==void 0?Q():Qo.end;return _r(E.createJSDocCallbackTag(Xn,Qo,Bi,mo),Lr,ku)}function FD(Lr,Xn,ei,_i){yg();let Bi=vn(ei),mo=AS(Lr,ei);Bi||(Bi=jd(Lr,Q(),ei,_i));let Qo=Bi!==void 0?Q():mo.end;return _r(E.createJSDocOverloadTag(Xn,mo,Bi),Lr,Qo)}function lJ(Lr,Xn){for(;!He(Lr)||!He(Xn);)if(!He(Lr)&&!He(Xn)&&Lr.right.escapedText===Xn.right.escapedText)Lr=Lr.left,Xn=Xn.left;else return!1;return Lr.escapedText===Xn.escapedText}function jD(Lr){return S7(1,Lr)}function S7(Lr,Xn,ei){let _i=!0,Bi=!1;for(;;)switch(It()){case 60:if(_i){let mo=l1(Lr,Xn);return mo&&(mo.kind===341||mo.kind===348)&&ei&&(He(mo.name)||!lJ(ei,mo.name.left))?!1:mo}Bi=!1;break;case 4:_i=!0,Bi=!1;break;case 42:Bi&&(_i=!1),Bi=!0;break;case 80:_i=!1;break;case 1:return!1}}function l1(Lr,Xn){M.assert(z()===60);let ei=t.getTokenFullStart();It();let _i=pT(),Bi=uT(),mo;switch(_i.escapedText){case"type":return Lr===1&&Fk(ei,_i);case"prop":case"property":mo=1;break;case"arg":case"argument":case"param":mo=6;break;case"template":return b7(ei,_i,Xn,Bi);case"this":return cJ(ei,_i,Xn,Bi);default:return!1}return Lr&mo?Jm(ei,_i,Lr,Xn):!1}function FEe(){let Lr=Q(),Xn=fT(23);Xn&&yg();let ei=Zt(!1,!0),_i=pT(v.Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces),Bi;if(Xn&&(yg(),er(64),Bi=Gs(16777216,od),er(24)),!$c(_i))return _r(E.createTypeParameterDeclaration(ei,_i,void 0,Bi),Lr)}function uJ(){let Lr=Q(),Xn=[];do{yg();let ei=FEe();ei!==void 0&&Xn.push(ei),uT()}while(fT(28));return po(Xn,Lr)}function b7(Lr,Xn,ei,_i){let Bi=z()===19?it():void 0,mo=uJ();return _r(E.createJSDocTemplateTag(Xn,Bi,mo,jd(Lr,Q(),ei,_i)),Lr)}function fT(Lr){return z()===Lr?(It(),!0):!1}function Mte(){let Lr=pT();for(ts(23)&&er(24);ts(25);){let Xn=pT();ts(23)&&er(24),Lr=yt(Lr,Xn)}return Lr}function pT(Lr){if(!F_(z()))return Jc(80,!Lr,Lr||v.Identifier_expected);rr++;let Xn=t.getTokenStart(),ei=t.getTokenEnd(),_i=z(),Bi=z_(t.getTokenValue()),mo=_r(L(Bi,_i),Xn,ei);return It(),mo}}})(Lk=e.JSDocParser||(e.JSDocParser={}))})(Ab||(Ab={}));var l3e=new WeakSet;function Sbt(e){l3e.has(e)&&M.fail("Source file has already been incrementally parsed"),l3e.add(e)}var u3e=new WeakSet;function bbt(e){return u3e.has(e)}function Nme(e){u3e.add(e)}var NY;(e=>{function t(w,R,L,F){if(F=F||M.shouldAssert(2),E(w,R,L,F),Iue(L))return w;if(w.statements.length===0)return Ab.parseSourceFile(w.fileName,R,w.languageVersion,void 0,!0,w.scriptKind,w.setExternalModuleIndicator,w.jsDocParsingMode);Sbt(w),Ab.fixupParentReferences(w);let J=w.text,G=x(w),q=d(w,L);E(w,R,q,F),M.assert(q.span.start<=L.span.start),M.assert(bl(q.span)===bl(L.span)),M.assert(bl(fI(q))===bl(fI(L)));let ee=fI(q).length-q.span.length;m(w,q.span.start,bl(q.span),bl(fI(q)),ee,J,R,F);let W=Ab.parseSourceFile(w.fileName,R,w.languageVersion,G,!0,w.scriptKind,w.setExternalModuleIndicator,w.jsDocParsingMode);return W.commentDirectives=n(w.commentDirectives,W.commentDirectives,q.span.start,bl(q.span),ee,J,R,F),W.impliedNodeFormat=w.impliedNodeFormat,ime(w,W),W}e.updateSourceFile=t;function n(w,R,L,F,J,G,q,ee){if(!w)return R;let W,pe=!1;for(let re of w){let{range:ue,type:ce}=re;if(ue.end<L)W=Bt(W,re);else if(ue.pos>F){K();let ne={range:{pos:ue.pos+J,end:ue.end+J},type:ce};W=Bt(W,ne),ee&&M.assert(G.substring(ue.pos,ue.end)===q.substring(ne.range.pos,ne.range.end))}}return K(),W;function K(){pe||(pe=!0,W?R&&W.push(...R):W=R)}}function i(w,R,L,F,J,G,q){L?W(w):ee(w);return;function ee(pe){let K="";if(q&&s(pe)&&(K=J.substring(pe.pos,pe.end)),dY(pe,R),qg(pe,pe.pos+F,pe.end+F),q&&s(pe)&&M.assert(K===G.substring(pe.pos,pe.end)),Js(pe,ee,W),Pp(pe))for(let re of pe.jsDoc)ee(re);u(pe,q)}function W(pe){qg(pe,pe.pos+F,pe.end+F);for(let K of pe)ee(K)}}function s(w){switch(w.kind){case 11:case 9:case 80:return!0}return!1}function o(w,R,L,F,J){M.assert(w.end>=R,"Adjusting an element that was entirely before the change range"),M.assert(w.pos<=L,"Adjusting an element that was entirely after the change range"),M.assert(w.pos<=w.end);let G=Math.min(w.pos,F),q=w.end>=L?w.end+J:Math.min(w.end,F);if(M.assert(G<=q),w.parent){let ee=w.parent;M.assertGreaterThanOrEqual(G,ee.pos),M.assertLessThanOrEqual(q,ee.end)}qg(w,G,q)}function u(w,R){if(R){let L=w.pos,F=J=>{M.assert(J.pos>=L),L=J.end};if(Pp(w))for(let J of w.jsDoc)F(J);Js(w,F),M.assert(L<=w.end)}}function m(w,R,L,F,J,G,q,ee){W(w);return;function W(K){if(M.assert(K.pos<=K.end),K.pos>L){i(K,w,!1,J,G,q,ee);return}let re=K.end;if(re>=R){if(Nme(K),dY(K,w),o(K,R,L,F,J),Js(K,W,pe),Pp(K))for(let ue of K.jsDoc)W(ue);u(K,ee);return}M.assert(re<R)}function pe(K){if(M.assert(K.pos<=K.end),K.pos>L){i(K,w,!0,J,G,q,ee);return}let re=K.end;if(re>=R){Nme(K),o(K,R,L,F,J);for(let ue of K)W(ue);return}M.assert(re<R)}}function d(w,R){let F=R.span.start;for(let q=0;F>0&&q<=1;q++){let ee=S(w,F);M.assert(ee.pos<=F);let W=ee.pos;F=Math.max(0,W-1)}let J=Il(F,bl(R.span)),G=R.newLength+(R.span.start-F);return D3(J,G)}function S(w,R){let L=w,F;if(Js(w,G),F){let q=J(F);q.pos>L.pos&&(L=q)}return L;function J(q){for(;;){let ee=lG(q);if(ee)q=ee;else return q}}function G(q){if(!$c(q))if(q.pos<=R){if(q.pos>=L.pos&&(L=q),R<q.end)return Js(q,G),!0;M.assert(q.end<=R),F=q}else return M.assert(q.pos>R),!0}}function E(w,R,L,F){let J=w.text;if(L&&(M.assert(J.length-L.span.length+L.newLength===R.length),F||M.shouldAssert(3))){let G=J.substr(0,L.span.start),q=R.substr(0,L.span.start);M.assert(G===q);let ee=J.substring(bl(L.span),J.length),W=R.substring(bl(fI(L)),R.length);M.assert(ee===W)}}function x(w){let R=w.statements,L=0;M.assert(L<R.length);let F=R[L],J=-1;return{currentNode(q){return q!==J&&(F&&F.end===q&&L<R.length-1&&(L++,F=R[L]),(!F||F.pos!==q)&&G(q)),J=q,M.assert(!F||F.pos===q),F}};function G(q){R=void 0,L=-1,F=void 0,Js(w,ee,W);return;function ee(pe){return q>=pe.pos&&q<pe.end?(Js(pe,ee,W),!0):!1}function W(pe){if(q>=pe.pos&&q<pe.end)for(let K=0;K<pe.length;K++){let re=pe[K];if(re){if(re.pos===q)return R=pe,L=K,F=re,!0;if(re.pos<q&&q<re.end)return Js(re,ee,W),!0}}return!1}}}e.createSyntaxCursor=x;let D;(w=>{w[w.Value=-1]="Value"})(D||(D={}))})(NY||(NY={}));function Mu(e){return DY(e)!==void 0}function DY(e){let t=PP(e,sj,!1);if(t)return t;if(Ic(e,".ts")){let n=Ul(e).lastIndexOf(".d.");if(n>=0)return e.substring(n)}}function Tbt(e,t,n,i){if(e){if(e==="import")return 99;if(e==="require")return 1;i(t,n-t,v.resolution_mode_should_be_either_require_or_import)}}function wY(e,t){let n=[];for(let i of Ty(t,0)||ve){let s=t.substring(i.pos,i.end);Abt(n,i,s)}e.pragmas=new Map;for(let i of n){if(e.pragmas.has(i.name)){let s=e.pragmas.get(i.name);s instanceof Array?s.push(i.args):e.pragmas.set(i.name,[s,i.args]);continue}e.pragmas.set(i.name,i.args)}}function IY(e,t){e.checkJsDirective=void 0,e.referencedFiles=[],e.typeReferenceDirectives=[],e.libReferenceDirectives=[],e.amdDependencies=[],e.hasNoDefaultLib=!1,e.pragmas.forEach((n,i)=>{switch(i){case"reference":{let s=e.referencedFiles,o=e.typeReferenceDirectives,u=e.libReferenceDirectives;kt(VC(n),m=>{let{types:d,lib:S,path:E,["resolution-mode"]:x,preserve:D}=m.arguments,w=D==="true"?!0:void 0;if(m.arguments["no-default-lib"]==="true")e.hasNoDefaultLib=!0;else if(d){let R=Tbt(x,d.pos,d.end,t);o.push({pos:d.pos,end:d.end,fileName:d.value,...R?{resolutionMode:R}:{},...w?{preserve:w}:{}})}else S?u.push({pos:S.pos,end:S.end,fileName:S.value,...w?{preserve:w}:{}}):E?s.push({pos:E.pos,end:E.end,fileName:E.value,...w?{preserve:w}:{}}):t(m.range.pos,m.range.end-m.range.pos,v.Invalid_reference_directive_syntax)});break}case"amd-dependency":{e.amdDependencies=Cr(VC(n),s=>({name:s.arguments.name,path:s.arguments.path}));break}case"amd-module":{if(n instanceof Array)for(let s of n)e.moduleName&&t(s.range.pos,s.range.end-s.range.pos,v.An_AMD_module_cannot_have_multiple_name_assignments),e.moduleName=s.arguments.name;else e.moduleName=n.arguments.name;break}case"ts-nocheck":case"ts-check":{kt(VC(n),s=>{(!e.checkJsDirective||s.range.pos>e.checkJsDirective.pos)&&(e.checkJsDirective={enabled:i==="ts-check",end:s.range.end,pos:s.range.pos})});break}case"jsx":case"jsxfrag":case"jsximportsource":case"jsxruntime":return;default:M.fail("Unhandled pragma kind")}})}var Dme=new Map;function Ebt(e){if(Dme.has(e))return Dme.get(e);let t=new RegExp(`(\\s${e}\\s*=\\s*)(?:(?:'([^']*)')|(?:"([^"]*)"))`,"im");return Dme.set(e,t),t}var xbt=/^\/\/\/\s*<(\S+)\s.*?\/>/im,Cbt=/^\/\/\/?\s*@([^\s:]+)(.*)\s*$/im;function Abt(e,t,n){let i=t.kind===2&&xbt.exec(n);if(i){let o=i[1].toLowerCase(),u=l5[o];if(!u||!(u.kind&1))return;if(u.args){let m={};for(let d of u.args){let E=Ebt(d.name).exec(n);if(!E&&!d.optional)return;if(E){let x=E[2]||E[3];if(d.captureSpan){let D=t.pos+E.index+E[1].length+1;m[d.name]={value:x,pos:D,end:D+x.length}}else m[d.name]=x}}e.push({name:o,args:{arguments:m,range:t}})}else e.push({name:o,args:{arguments:{},range:t}});return}let s=t.kind===2&&Cbt.exec(n);if(s)return _3e(e,t,2,s);if(t.kind===3){let o=/@(\S+)(\s+.*)?$/gim,u;for(;u=o.exec(n);)_3e(e,t,4,u)}}function _3e(e,t,n,i){if(!i)return;let s=i[1].toLowerCase(),o=l5[s];if(!o||!(o.kind&n))return;let u=i[2],m=kbt(o,u);m!=="fail"&&e.push({name:s,args:{arguments:m,range:t}})}function kbt(e,t){if(!t)return{};if(!e.args)return{};let n=t.trim().split(/\s+/),i={};for(let s=0;s<e.args.length;s++){let o=e.args[s];if(!n[s]&&!o.optional)return"fail";if(o.captureSpan)return M.fail("Capture spans not yet implemented for non-xml pragmas");i[o.name]=n[s]}return i}function kb(e,t){return e.kind!==t.kind?!1:e.kind===80?e.escapedText===t.escapedText:e.kind===110?!0:e.kind===295?e.namespace.escapedText===t.namespace.escapedText&&e.name.escapedText===t.name.escapedText:e.name.escapedText===t.name.escapedText&&kb(e.expression,t.expression)}var Zj={name:"compileOnSave",type:"boolean",defaultValueDescription:!1},f3e=new Map(Object.entries({preserve:1,"react-native":3,react:2,"react-jsx":4,"react-jsxdev":5})),C8=new Map(Ix(f3e.entries(),([e,t])=>[""+t,e])),p3e=[["es5","lib.es5.d.ts"],["es6","lib.es2015.d.ts"],["es2015","lib.es2015.d.ts"],["es7","lib.es2016.d.ts"],["es2016","lib.es2016.d.ts"],["es2017","lib.es2017.d.ts"],["es2018","lib.es2018.d.ts"],["es2019","lib.es2019.d.ts"],["es2020","lib.es2020.d.ts"],["es2021","lib.es2021.d.ts"],["es2022","lib.es2022.d.ts"],["es2023","lib.es2023.d.ts"],["esnext","lib.esnext.d.ts"],["dom","lib.dom.d.ts"],["dom.iterable","lib.dom.iterable.d.ts"],["dom.asynciterable","lib.dom.asynciterable.d.ts"],["webworker","lib.webworker.d.ts"],["webworker.importscripts","lib.webworker.importscripts.d.ts"],["webworker.iterable","lib.webworker.iterable.d.ts"],["webworker.asynciterable","lib.webworker.asynciterable.d.ts"],["scripthost","lib.scripthost.d.ts"],["es2015.core","lib.es2015.core.d.ts"],["es2015.collection","lib.es2015.collection.d.ts"],["es2015.generator","lib.es2015.generator.d.ts"],["es2015.iterable","lib.es2015.iterable.d.ts"],["es2015.promise","lib.es2015.promise.d.ts"],["es2015.proxy","lib.es2015.proxy.d.ts"],["es2015.reflect","lib.es2015.reflect.d.ts"],["es2015.symbol","lib.es2015.symbol.d.ts"],["es2015.symbol.wellknown","lib.es2015.symbol.wellknown.d.ts"],["es2016.array.include","lib.es2016.array.include.d.ts"],["es2016.intl","lib.es2016.intl.d.ts"],["es2017.date","lib.es2017.date.d.ts"],["es2017.object","lib.es2017.object.d.ts"],["es2017.sharedmemory","lib.es2017.sharedmemory.d.ts"],["es2017.string","lib.es2017.string.d.ts"],["es2017.intl","lib.es2017.intl.d.ts"],["es2017.typedarrays","lib.es2017.typedarrays.d.ts"],["es2018.asyncgenerator","lib.es2018.asyncgenerator.d.ts"],["es2018.asynciterable","lib.es2018.asynciterable.d.ts"],["es2018.intl","lib.es2018.intl.d.ts"],["es2018.promise","lib.es2018.promise.d.ts"],["es2018.regexp","lib.es2018.regexp.d.ts"],["es2019.array","lib.es2019.array.d.ts"],["es2019.object","lib.es2019.object.d.ts"],["es2019.string","lib.es2019.string.d.ts"],["es2019.symbol","lib.es2019.symbol.d.ts"],["es2019.intl","lib.es2019.intl.d.ts"],["es2020.bigint","lib.es2020.bigint.d.ts"],["es2020.date","lib.es2020.date.d.ts"],["es2020.promise","lib.es2020.promise.d.ts"],["es2020.sharedmemory","lib.es2020.sharedmemory.d.ts"],["es2020.string","lib.es2020.string.d.ts"],["es2020.symbol.wellknown","lib.es2020.symbol.wellknown.d.ts"],["es2020.intl","lib.es2020.intl.d.ts"],["es2020.number","lib.es2020.number.d.ts"],["es2021.promise","lib.es2021.promise.d.ts"],["es2021.string","lib.es2021.string.d.ts"],["es2021.weakref","lib.es2021.weakref.d.ts"],["es2021.intl","lib.es2021.intl.d.ts"],["es2022.array","lib.es2022.array.d.ts"],["es2022.error","lib.es2022.error.d.ts"],["es2022.intl","lib.es2022.intl.d.ts"],["es2022.object","lib.es2022.object.d.ts"],["es2022.sharedmemory","lib.es2022.sharedmemory.d.ts"],["es2022.string","lib.es2022.string.d.ts"],["es2022.regexp","lib.es2022.regexp.d.ts"],["es2023.array","lib.es2023.array.d.ts"],["es2023.collection","lib.es2023.collection.d.ts"],["es2023.intl","lib.es2023.intl.d.ts"],["esnext.array","lib.es2023.array.d.ts"],["esnext.collection","lib.esnext.collection.d.ts"],["esnext.symbol","lib.es2019.symbol.d.ts"],["esnext.asynciterable","lib.es2018.asynciterable.d.ts"],["esnext.intl","lib.esnext.intl.d.ts"],["esnext.disposable","lib.esnext.disposable.d.ts"],["esnext.bigint","lib.es2020.bigint.d.ts"],["esnext.string","lib.es2022.string.d.ts"],["esnext.promise","lib.esnext.promise.d.ts"],["esnext.weakref","lib.es2021.weakref.d.ts"],["esnext.decorators","lib.esnext.decorators.d.ts"],["esnext.object","lib.esnext.object.d.ts"],["esnext.array","lib.esnext.array.d.ts"],["esnext.regexp","lib.esnext.regexp.d.ts"],["esnext.string","lib.esnext.string.d.ts"],["decorators","lib.decorators.d.ts"],["decorators.legacy","lib.decorators.legacy.d.ts"]],eB=p3e.map(e=>e[0]),OY=new Map(p3e),YA=[{name:"watchFile",type:new Map(Object.entries({fixedpollinginterval:0,prioritypollinginterval:1,dynamicprioritypolling:2,fixedchunksizepolling:3,usefsevents:4,usefseventsonparentdirectory:5})),category:v.Watch_and_Build_Modes,description:v.Specify_how_the_TypeScript_watch_mode_works,defaultValueDescription:4},{name:"watchDirectory",type:new Map(Object.entries({usefsevents:0,fixedpollinginterval:1,dynamicprioritypolling:2,fixedchunksizepolling:3})),category:v.Watch_and_Build_Modes,description:v.Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality,defaultValueDescription:0},{name:"fallbackPolling",type:new Map(Object.entries({fixedinterval:0,priorityinterval:1,dynamicpriority:2,fixedchunksize:3})),category:v.Watch_and_Build_Modes,description:v.Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers,defaultValueDescription:1},{name:"synchronousWatchDirectory",type:"boolean",category:v.Watch_and_Build_Modes,description:v.Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively,defaultValueDescription:!1},{name:"excludeDirectories",type:"list",element:{name:"excludeDirectory",type:"string",isFilePath:!0,extraValidation:ege},allowConfigDirTemplateSubstitution:!0,category:v.Watch_and_Build_Modes,description:v.Remove_a_list_of_directories_from_the_watch_process},{name:"excludeFiles",type:"list",element:{name:"excludeFile",type:"string",isFilePath:!0,extraValidation:ege},allowConfigDirTemplateSubstitution:!0,category:v.Watch_and_Build_Modes,description:v.Remove_a_list_of_files_from_the_watch_mode_s_processing}],tB=[{name:"help",shortName:"h",type:"boolean",showInSimplifiedHelpView:!0,isCommandLineOnly:!0,category:v.Command_line_Options,description:v.Print_this_message,defaultValueDescription:!1},{name:"help",shortName:"?",type:"boolean",isCommandLineOnly:!0,category:v.Command_line_Options,defaultValueDescription:!1},{name:"watch",shortName:"w",type:"boolean",showInSimplifiedHelpView:!0,isCommandLineOnly:!0,category:v.Command_line_Options,description:v.Watch_input_files,defaultValueDescription:!1},{name:"preserveWatchOutput",type:"boolean",showInSimplifiedHelpView:!1,category:v.Output_Formatting,description:v.Disable_wiping_the_console_in_watch_mode,defaultValueDescription:!1},{name:"listFiles",type:"boolean",category:v.Compiler_Diagnostics,description:v.Print_all_of_the_files_read_during_the_compilation,defaultValueDescription:!1},{name:"explainFiles",type:"boolean",category:v.Compiler_Diagnostics,description:v.Print_files_read_during_the_compilation_including_why_it_was_included,defaultValueDescription:!1},{name:"listEmittedFiles",type:"boolean",category:v.Compiler_Diagnostics,description:v.Print_the_names_of_emitted_files_after_a_compilation,defaultValueDescription:!1},{name:"pretty",type:"boolean",showInSimplifiedHelpView:!0,category:v.Output_Formatting,description:v.Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read,defaultValueDescription:!0},{name:"traceResolution",type:"boolean",category:v.Compiler_Diagnostics,description:v.Log_paths_used_during_the_moduleResolution_process,defaultValueDescription:!1},{name:"diagnostics",type:"boolean",category:v.Compiler_Diagnostics,description:v.Output_compiler_performance_information_after_building,defaultValueDescription:!1},{name:"extendedDiagnostics",type:"boolean",category:v.Compiler_Diagnostics,description:v.Output_more_detailed_compiler_performance_information_after_building,defaultValueDescription:!1},{name:"generateCpuProfile",type:"string",isFilePath:!0,paramType:v.FILE_OR_DIRECTORY,category:v.Compiler_Diagnostics,description:v.Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging,defaultValueDescription:"profile.cpuprofile"},{name:"generateTrace",type:"string",isFilePath:!0,isCommandLineOnly:!0,paramType:v.DIRECTORY,category:v.Compiler_Diagnostics,description:v.Generates_an_event_trace_and_a_list_of_types},{name:"incremental",shortName:"i",type:"boolean",category:v.Projects,description:v.Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects,transpileOptionValue:void 0,defaultValueDescription:v.false_unless_composite_is_set},{name:"declaration",shortName:"d",type:"boolean",affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:v.Emit,transpileOptionValue:void 0,description:v.Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project,defaultValueDescription:v.false_unless_composite_is_set},{name:"declarationMap",type:"boolean",affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:v.Emit,defaultValueDescription:!1,description:v.Create_sourcemaps_for_d_ts_files},{name:"emitDeclarationOnly",type:"boolean",affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:v.Emit,description:v.Only_output_d_ts_files_and_not_JavaScript_files,transpileOptionValue:void 0,defaultValueDescription:!1},{name:"sourceMap",type:"boolean",affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:v.Emit,defaultValueDescription:!1,description:v.Create_source_map_files_for_emitted_JavaScript_files},{name:"inlineSourceMap",type:"boolean",affectsBuildInfo:!0,category:v.Emit,description:v.Include_sourcemap_files_inside_the_emitted_JavaScript,defaultValueDescription:!1},{name:"assumeChangesOnlyAffectDirectDependencies",type:"boolean",affectsSemanticDiagnostics:!0,affectsEmit:!0,affectsBuildInfo:!0,category:v.Watch_and_Build_Modes,description:v.Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it,defaultValueDescription:!1},{name:"locale",type:"string",category:v.Command_line_Options,isCommandLineOnly:!0,description:v.Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit,defaultValueDescription:v.Platform_specific}],RY={name:"target",shortName:"t",type:new Map(Object.entries({es3:0,es5:1,es6:2,es2015:2,es2016:3,es2017:4,es2018:5,es2019:6,es2020:7,es2021:8,es2022:9,es2023:10,esnext:99})),affectsSourceFile:!0,affectsModuleResolution:!0,affectsEmit:!0,affectsBuildInfo:!0,deprecatedKeys:new Set(["es3"]),paramType:v.VERSION,showInSimplifiedHelpView:!0,category:v.Language_and_Environment,description:v.Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declarations,defaultValueDescription:1},wme={name:"module",shortName:"m",type:new Map(Object.entries({none:0,commonjs:1,amd:2,system:4,umd:3,es6:5,es2015:5,es2020:6,es2022:7,esnext:99,node16:100,nodenext:199,preserve:200})),affectsSourceFile:!0,affectsModuleResolution:!0,affectsEmit:!0,affectsBuildInfo:!0,paramType:v.KIND,showInSimplifiedHelpView:!0,category:v.Modules,description:v.Specify_what_module_code_is_generated,defaultValueDescription:void 0},Ime=[{name:"all",type:"boolean",showInSimplifiedHelpView:!0,category:v.Command_line_Options,description:v.Show_all_compiler_options,defaultValueDescription:!1},{name:"version",shortName:"v",type:"boolean",showInSimplifiedHelpView:!0,category:v.Command_line_Options,description:v.Print_the_compiler_s_version,defaultValueDescription:!1},{name:"init",type:"boolean",showInSimplifiedHelpView:!0,category:v.Command_line_Options,description:v.Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file,defaultValueDescription:!1},{name:"project",shortName:"p",type:"string",isFilePath:!0,showInSimplifiedHelpView:!0,category:v.Command_line_Options,paramType:v.FILE_OR_DIRECTORY,description:v.Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json},{name:"build",type:"boolean",shortName:"b",showInSimplifiedHelpView:!0,category:v.Command_line_Options,description:v.Build_one_or_more_projects_and_their_dependencies_if_out_of_date,defaultValueDescription:!1},{name:"showConfig",type:"boolean",showInSimplifiedHelpView:!0,category:v.Command_line_Options,isCommandLineOnly:!0,description:v.Print_the_final_configuration_instead_of_building,defaultValueDescription:!1},{name:"listFilesOnly",type:"boolean",category:v.Command_line_Options,isCommandLineOnly:!0,description:v.Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing,defaultValueDescription:!1},RY,wme,{name:"lib",type:"list",element:{name:"lib",type:OY,defaultValueDescription:void 0},affectsProgramStructure:!0,showInSimplifiedHelpView:!0,category:v.Language_and_Environment,description:v.Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment,transpileOptionValue:void 0},{name:"allowJs",type:"boolean",allowJsFlag:!0,affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:v.JavaScript_Support,description:v.Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these_files,defaultValueDescription:!1},{name:"checkJs",type:"boolean",affectsModuleResolution:!0,affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:v.JavaScript_Support,description:v.Enable_error_reporting_in_type_checked_JavaScript_files,defaultValueDescription:!1},{name:"jsx",type:f3e,affectsSourceFile:!0,affectsEmit:!0,affectsBuildInfo:!0,affectsModuleResolution:!0,affectsSemanticDiagnostics:!0,paramType:v.KIND,showInSimplifiedHelpView:!0,category:v.Language_and_Environment,description:v.Specify_what_JSX_code_is_generated,defaultValueDescription:void 0},{name:"outFile",type:"string",affectsEmit:!0,affectsBuildInfo:!0,affectsDeclarationPath:!0,isFilePath:!0,paramType:v.FILE,showInSimplifiedHelpView:!0,category:v.Emit,description:v.Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designates_a_file_that_bundles_all_d_ts_output,transpileOptionValue:void 0},{name:"outDir",type:"string",affectsEmit:!0,affectsBuildInfo:!0,affectsDeclarationPath:!0,isFilePath:!0,paramType:v.DIRECTORY,showInSimplifiedHelpView:!0,category:v.Emit,description:v.Specify_an_output_folder_for_all_emitted_files},{name:"rootDir",type:"string",affectsEmit:!0,affectsBuildInfo:!0,affectsDeclarationPath:!0,isFilePath:!0,paramType:v.LOCATION,category:v.Modules,description:v.Specify_the_root_folder_within_your_source_files,defaultValueDescription:v.Computed_from_the_list_of_input_files},{name:"composite",type:"boolean",affectsBuildInfo:!0,isTSConfigOnly:!0,category:v.Projects,transpileOptionValue:void 0,defaultValueDescription:!1,description:v.Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references},{name:"tsBuildInfoFile",type:"string",affectsEmit:!0,affectsBuildInfo:!0,isFilePath:!0,paramType:v.FILE,category:v.Projects,transpileOptionValue:void 0,defaultValueDescription:".tsbuildinfo",description:v.Specify_the_path_to_tsbuildinfo_incremental_compilation_file},{name:"removeComments",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:v.Emit,defaultValueDescription:!1,description:v.Disable_emitting_comments},{name:"noCheck",type:"boolean",showInSimplifiedHelpView:!1,category:v.Compiler_Diagnostics,description:v.Disable_full_type_checking_only_critical_parse_and_emit_errors_will_be_reported,transpileOptionValue:!0,defaultValueDescription:!1,affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,extraValidation(){return[v.Unknown_compiler_option_0,"noCheck"]}},{name:"noEmit",type:"boolean",showInSimplifiedHelpView:!0,category:v.Emit,description:v.Disable_emitting_files_from_a_compilation,transpileOptionValue:void 0,defaultValueDescription:!1},{name:"importHelpers",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,affectsSourceFile:!0,category:v.Emit,description:v.Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file,defaultValueDescription:!1},{name:"importsNotUsedAsValues",type:new Map(Object.entries({remove:0,preserve:1,error:2})),affectsEmit:!0,affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Backwards_Compatibility,description:v.Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types,defaultValueDescription:0},{name:"downlevelIteration",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,category:v.Emit,description:v.Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration,defaultValueDescription:!1},{name:"isolatedModules",type:"boolean",category:v.Interop_Constraints,description:v.Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports,transpileOptionValue:!0,defaultValueDescription:!1},{name:"verbatimModuleSyntax",type:"boolean",affectsEmit:!0,affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Interop_Constraints,description:v.Do_not_transform_or_elide_any_imports_or_exports_not_marked_as_type_only_ensuring_they_are_written_in_the_output_file_s_format_based_on_the_module_setting,defaultValueDescription:!1},{name:"isolatedDeclarations",type:"boolean",category:v.Interop_Constraints,description:v.Require_sufficient_annotation_on_exports_so_other_tools_can_trivially_generate_declaration_files,defaultValueDescription:!1,affectsBuildInfo:!0,affectsSemanticDiagnostics:!0},{name:"strict",type:"boolean",affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:v.Type_Checking,description:v.Enable_all_strict_type_checking_options,defaultValueDescription:!1},{name:"noImplicitAny",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,strictFlag:!0,category:v.Type_Checking,description:v.Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type,defaultValueDescription:v.false_unless_strict_is_set},{name:"strictNullChecks",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,strictFlag:!0,category:v.Type_Checking,description:v.When_type_checking_take_into_account_null_and_undefined,defaultValueDescription:v.false_unless_strict_is_set},{name:"strictFunctionTypes",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,strictFlag:!0,category:v.Type_Checking,description:v.When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible,defaultValueDescription:v.false_unless_strict_is_set},{name:"strictBindCallApply",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,strictFlag:!0,category:v.Type_Checking,description:v.Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function,defaultValueDescription:v.false_unless_strict_is_set},{name:"strictPropertyInitialization",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,strictFlag:!0,category:v.Type_Checking,description:v.Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor,defaultValueDescription:v.false_unless_strict_is_set},{name:"noImplicitThis",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,strictFlag:!0,category:v.Type_Checking,description:v.Enable_error_reporting_when_this_is_given_the_type_any,defaultValueDescription:v.false_unless_strict_is_set},{name:"useUnknownInCatchVariables",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,strictFlag:!0,category:v.Type_Checking,description:v.Default_catch_clause_variables_as_unknown_instead_of_any,defaultValueDescription:v.false_unless_strict_is_set},{name:"alwaysStrict",type:"boolean",affectsSourceFile:!0,affectsEmit:!0,affectsBuildInfo:!0,strictFlag:!0,category:v.Type_Checking,description:v.Ensure_use_strict_is_always_emitted,defaultValueDescription:v.false_unless_strict_is_set},{name:"noUnusedLocals",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Type_Checking,description:v.Enable_error_reporting_when_local_variables_aren_t_read,defaultValueDescription:!1},{name:"noUnusedParameters",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Type_Checking,description:v.Raise_an_error_when_a_function_parameter_isn_t_read,defaultValueDescription:!1},{name:"exactOptionalPropertyTypes",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Type_Checking,description:v.Interpret_optional_property_types_as_written_rather_than_adding_undefined,defaultValueDescription:!1},{name:"noImplicitReturns",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Type_Checking,description:v.Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function,defaultValueDescription:!1},{name:"noFallthroughCasesInSwitch",type:"boolean",affectsBindDiagnostics:!0,affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Type_Checking,description:v.Enable_error_reporting_for_fallthrough_cases_in_switch_statements,defaultValueDescription:!1},{name:"noUncheckedIndexedAccess",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Type_Checking,description:v.Add_undefined_to_a_type_when_accessed_using_an_index,defaultValueDescription:!1},{name:"noImplicitOverride",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Type_Checking,description:v.Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier,defaultValueDescription:!1},{name:"noPropertyAccessFromIndexSignature",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,showInSimplifiedHelpView:!1,category:v.Type_Checking,description:v.Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type,defaultValueDescription:!1},{name:"moduleResolution",type:new Map(Object.entries({node10:2,node:2,classic:1,node16:3,nodenext:99,bundler:100})),deprecatedKeys:new Set(["node"]),affectsSourceFile:!0,affectsModuleResolution:!0,paramType:v.STRATEGY,category:v.Modules,description:v.Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier,defaultValueDescription:v.module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node},{name:"baseUrl",type:"string",affectsModuleResolution:!0,isFilePath:!0,category:v.Modules,description:v.Specify_the_base_directory_to_resolve_non_relative_module_names},{name:"paths",type:"object",affectsModuleResolution:!0,allowConfigDirTemplateSubstitution:!0,isTSConfigOnly:!0,category:v.Modules,description:v.Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations,transpileOptionValue:void 0},{name:"rootDirs",type:"list",isTSConfigOnly:!0,element:{name:"rootDirs",type:"string",isFilePath:!0},affectsModuleResolution:!0,allowConfigDirTemplateSubstitution:!0,category:v.Modules,description:v.Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules,transpileOptionValue:void 0,defaultValueDescription:v.Computed_from_the_list_of_input_files},{name:"typeRoots",type:"list",element:{name:"typeRoots",type:"string",isFilePath:!0},affectsModuleResolution:!0,allowConfigDirTemplateSubstitution:!0,category:v.Modules,description:v.Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types},{name:"types",type:"list",element:{name:"types",type:"string"},affectsProgramStructure:!0,showInSimplifiedHelpView:!0,category:v.Modules,description:v.Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file,transpileOptionValue:void 0},{name:"allowSyntheticDefaultImports",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Interop_Constraints,description:v.Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export,defaultValueDescription:v.module_system_or_esModuleInterop},{name:"esModuleInterop",type:"boolean",affectsSemanticDiagnostics:!0,affectsEmit:!0,affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:v.Interop_Constraints,description:v.Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheticDefaultImports_for_type_compatibility,defaultValueDescription:!1},{name:"preserveSymlinks",type:"boolean",category:v.Interop_Constraints,description:v.Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node,defaultValueDescription:!1},{name:"allowUmdGlobalAccess",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Modules,description:v.Allow_accessing_UMD_globals_from_modules,defaultValueDescription:!1},{name:"moduleSuffixes",type:"list",element:{name:"suffix",type:"string"},listPreserveFalsyValues:!0,affectsModuleResolution:!0,category:v.Modules,description:v.List_of_file_name_suffixes_to_search_when_resolving_a_module},{name:"allowImportingTsExtensions",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Modules,description:v.Allow_imports_to_include_TypeScript_file_extensions_Requires_moduleResolution_bundler_and_either_noEmit_or_emitDeclarationOnly_to_be_set,defaultValueDescription:!1,transpileOptionValue:void 0},{name:"resolvePackageJsonExports",type:"boolean",affectsModuleResolution:!0,category:v.Modules,description:v.Use_the_package_json_exports_field_when_resolving_package_imports,defaultValueDescription:v.true_when_moduleResolution_is_node16_nodenext_or_bundler_otherwise_false},{name:"resolvePackageJsonImports",type:"boolean",affectsModuleResolution:!0,category:v.Modules,description:v.Use_the_package_json_imports_field_when_resolving_imports,defaultValueDescription:v.true_when_moduleResolution_is_node16_nodenext_or_bundler_otherwise_false},{name:"customConditions",type:"list",element:{name:"condition",type:"string"},affectsModuleResolution:!0,category:v.Modules,description:v.Conditions_to_set_in_addition_to_the_resolver_specific_defaults_when_resolving_imports},{name:"sourceRoot",type:"string",affectsEmit:!0,affectsBuildInfo:!0,paramType:v.LOCATION,category:v.Emit,description:v.Specify_the_root_path_for_debuggers_to_find_the_reference_source_code},{name:"mapRoot",type:"string",affectsEmit:!0,affectsBuildInfo:!0,paramType:v.LOCATION,category:v.Emit,description:v.Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations},{name:"inlineSources",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,category:v.Emit,description:v.Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript,defaultValueDescription:!1},{name:"experimentalDecorators",type:"boolean",affectsEmit:!0,affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Language_and_Environment,description:v.Enable_experimental_support_for_legacy_experimental_decorators,defaultValueDescription:!1},{name:"emitDecoratorMetadata",type:"boolean",affectsSemanticDiagnostics:!0,affectsEmit:!0,affectsBuildInfo:!0,category:v.Language_and_Environment,description:v.Emit_design_type_metadata_for_decorated_declarations_in_source_files,defaultValueDescription:!1},{name:"jsxFactory",type:"string",category:v.Language_and_Environment,description:v.Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h,defaultValueDescription:"`React.createElement`"},{name:"jsxFragmentFactory",type:"string",category:v.Language_and_Environment,description:v.Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragment_or_Fragment,defaultValueDescription:"React.Fragment"},{name:"jsxImportSource",type:"string",affectsSemanticDiagnostics:!0,affectsEmit:!0,affectsBuildInfo:!0,affectsModuleResolution:!0,affectsSourceFile:!0,category:v.Language_and_Environment,description:v.Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Asterisk,defaultValueDescription:"react"},{name:"resolveJsonModule",type:"boolean",affectsModuleResolution:!0,category:v.Modules,description:v.Enable_importing_json_files,defaultValueDescription:!1},{name:"allowArbitraryExtensions",type:"boolean",affectsProgramStructure:!0,category:v.Modules,description:v.Enable_importing_files_with_any_extension_provided_a_declaration_file_is_present,defaultValueDescription:!1},{name:"out",type:"string",affectsEmit:!0,affectsBuildInfo:!0,affectsDeclarationPath:!0,isFilePath:!1,category:v.Backwards_Compatibility,paramType:v.FILE,transpileOptionValue:void 0,description:v.Deprecated_setting_Use_outFile_instead},{name:"reactNamespace",type:"string",affectsEmit:!0,affectsBuildInfo:!0,category:v.Language_and_Environment,description:v.Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit,defaultValueDescription:"`React`"},{name:"skipDefaultLibCheck",type:"boolean",affectsBuildInfo:!0,category:v.Completeness,description:v.Skip_type_checking_d_ts_files_that_are_included_with_TypeScript,defaultValueDescription:!1},{name:"charset",type:"string",category:v.Backwards_Compatibility,description:v.No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files,defaultValueDescription:"utf8"},{name:"emitBOM",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,category:v.Emit,description:v.Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files,defaultValueDescription:!1},{name:"newLine",type:new Map(Object.entries({crlf:0,lf:1})),affectsEmit:!0,affectsBuildInfo:!0,paramType:v.NEWLINE,category:v.Emit,description:v.Set_the_newline_character_for_emitting_files,defaultValueDescription:"lf"},{name:"noErrorTruncation",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Output_Formatting,description:v.Disable_truncating_types_in_error_messages,defaultValueDescription:!1},{name:"noLib",type:"boolean",category:v.Language_and_Environment,affectsProgramStructure:!0,description:v.Disable_including_any_library_files_including_the_default_lib_d_ts,transpileOptionValue:!0,defaultValueDescription:!1},{name:"noResolve",type:"boolean",affectsModuleResolution:!0,category:v.Modules,description:v.Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add_to_a_project,transpileOptionValue:!0,defaultValueDescription:!1},{name:"stripInternal",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,category:v.Emit,description:v.Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments,defaultValueDescription:!1},{name:"disableSizeLimit",type:"boolean",affectsProgramStructure:!0,category:v.Editor_Support,description:v.Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server,defaultValueDescription:!1},{name:"disableSourceOfProjectReferenceRedirect",type:"boolean",isTSConfigOnly:!0,category:v.Projects,description:v.Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects,defaultValueDescription:!1},{name:"disableSolutionSearching",type:"boolean",isTSConfigOnly:!0,category:v.Projects,description:v.Opt_a_project_out_of_multi_project_reference_checking_when_editing,defaultValueDescription:!1},{name:"disableReferencedProjectLoad",type:"boolean",isTSConfigOnly:!0,category:v.Projects,description:v.Reduce_the_number_of_projects_loaded_automatically_by_TypeScript,defaultValueDescription:!1},{name:"noImplicitUseStrict",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Backwards_Compatibility,description:v.Disable_adding_use_strict_directives_in_emitted_JavaScript_files,defaultValueDescription:!1},{name:"noEmitHelpers",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,category:v.Emit,description:v.Disable_generating_custom_helper_functions_like_extends_in_compiled_output,defaultValueDescription:!1},{name:"noEmitOnError",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,category:v.Emit,transpileOptionValue:void 0,description:v.Disable_emitting_files_if_any_type_checking_errors_are_reported,defaultValueDescription:!1},{name:"preserveConstEnums",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,category:v.Emit,description:v.Disable_erasing_const_enum_declarations_in_generated_code,defaultValueDescription:!1},{name:"declarationDir",type:"string",affectsEmit:!0,affectsBuildInfo:!0,affectsDeclarationPath:!0,isFilePath:!0,paramType:v.DIRECTORY,category:v.Emit,transpileOptionValue:void 0,description:v.Specify_the_output_directory_for_generated_declaration_files},{name:"skipLibCheck",type:"boolean",affectsBuildInfo:!0,category:v.Completeness,description:v.Skip_type_checking_all_d_ts_files,defaultValueDescription:!1},{name:"allowUnusedLabels",type:"boolean",affectsBindDiagnostics:!0,affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Type_Checking,description:v.Disable_error_reporting_for_unused_labels,defaultValueDescription:void 0},{name:"allowUnreachableCode",type:"boolean",affectsBindDiagnostics:!0,affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Type_Checking,description:v.Disable_error_reporting_for_unreachable_code,defaultValueDescription:void 0},{name:"suppressExcessPropertyErrors",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Backwards_Compatibility,description:v.Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals,defaultValueDescription:!1},{name:"suppressImplicitAnyIndexErrors",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Backwards_Compatibility,description:v.Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures,defaultValueDescription:!1},{name:"forceConsistentCasingInFileNames",type:"boolean",affectsModuleResolution:!0,category:v.Interop_Constraints,description:v.Ensure_that_casing_is_correct_in_imports,defaultValueDescription:!0},{name:"maxNodeModuleJsDepth",type:"number",affectsModuleResolution:!0,category:v.JavaScript_Support,description:v.Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicable_with_allowJs,defaultValueDescription:0},{name:"noStrictGenericChecks",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:v.Backwards_Compatibility,description:v.Disable_strict_checking_of_generic_signatures_in_function_types,defaultValueDescription:!1},{name:"useDefineForClassFields",type:"boolean",affectsSemanticDiagnostics:!0,affectsEmit:!0,affectsBuildInfo:!0,category:v.Language_and_Environment,description:v.Emit_ECMAScript_standard_compliant_class_fields,defaultValueDescription:v.true_for_ES2022_and_above_including_ESNext},{name:"preserveValueImports",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,category:v.Backwards_Compatibility,description:v.Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed,defaultValueDescription:!1},{name:"keyofStringsOnly",type:"boolean",category:v.Backwards_Compatibility,description:v.Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option,defaultValueDescription:!1},{name:"plugins",type:"list",isTSConfigOnly:!0,element:{name:"plugin",type:"object"},description:v.Specify_a_list_of_language_service_plugins_to_include,category:v.Editor_Support},{name:"moduleDetection",type:new Map(Object.entries({auto:2,legacy:1,force:3})),affectsSourceFile:!0,affectsModuleResolution:!0,description:v.Control_what_method_is_used_to_detect_module_format_JS_files,category:v.Language_and_Environment,defaultValueDescription:v.auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_with_module_Colon_node16_as_modules},{name:"ignoreDeprecations",type:"string",defaultValueDescription:void 0}],og=[...tB,...Ime],Ome=og.filter(e=>!!e.affectsSemanticDiagnostics),Rme=og.filter(e=>!!e.affectsEmit),Mme=og.filter(e=>!!e.affectsDeclarationPath),MY=og.filter(e=>!!e.affectsModuleResolution),LY=og.filter(e=>!!e.affectsSourceFile||!!e.affectsBindDiagnostics),Lme=og.filter(e=>!!e.affectsProgramStructure),Fme=og.filter(e=>Ho(e,"transpileOptionValue")),jme=og.filter(e=>e.allowConfigDirTemplateSubstitution||!e.isCommandLineOnly&&e.isFilePath),Bme=YA.filter(e=>e.allowConfigDirTemplateSubstitution||!e.isCommandLineOnly&&e.isFilePath),Ume=og.filter(Pbt);function Pbt(e){return!bs(e.type)}var FY=[{name:"verbose",shortName:"v",category:v.Command_line_Options,description:v.Enable_verbose_logging,type:"boolean",defaultValueDescription:!1},{name:"dry",shortName:"d",category:v.Command_line_Options,description:v.Show_what_would_be_built_or_deleted_if_specified_with_clean,type:"boolean",defaultValueDescription:!1},{name:"force",shortName:"f",category:v.Command_line_Options,description:v.Build_all_projects_including_those_that_appear_to_be_up_to_date,type:"boolean",defaultValueDescription:!1},{name:"clean",category:v.Command_line_Options,description:v.Delete_the_outputs_of_all_projects,type:"boolean",defaultValueDescription:!1}],A8=[...tB,...FY],rB=[{name:"enable",type:"boolean",defaultValueDescription:!1},{name:"include",type:"list",element:{name:"include",type:"string"}},{name:"exclude",type:"list",element:{name:"exclude",type:"string"}},{name:"disableFilenameBasedTypeAcquisition",type:"boolean",defaultValueDescription:!1}];function nB(e){let t=new Map,n=new Map;return kt(e,i=>{t.set(i.name.toLowerCase(),i),i.shortName&&n.set(i.shortName,i.name)}),{optionsNameMap:t,shortOptionNames:n}}var d3e;function NN(){return d3e||(d3e=nB(og))}var Nbt={diagnostic:v.Compiler_option_0_may_only_be_used_with_build,getOptionsNameMap:v3e},jY={module:1,target:3,strict:!0,esModuleInterop:!0,forceConsistentCasingInFileNames:!0,skipLibCheck:!0};function Vme(e){return m3e(e,Nc)}function m3e(e,t){let n=Is(e.type.keys()),i=(e.deprecatedKeys?n.filter(s=>!e.deprecatedKeys.has(s)):n).map(s=>`'${s}'`).join(", ");return t(v.Argument_for_0_option_must_be_Colon_1,`--${e.name}`,i)}function iB(e,t,n){return Z3e(e,(t??"").trim(),n)}function Jme(e,t="",n){if(t=t.trim(),_s(t,"-"))return;if(e.type==="listOrElement"&&!t.includes(","))return KA(e,t,n);if(t==="")return[];let i=t.split(",");switch(e.element.type){case"number":return Gi(i,s=>KA(e.element,parseInt(s),n));case"string":return Gi(i,s=>KA(e.element,s||"",n));case"boolean":case"object":return M.fail(`List of ${e.element.type} is not yet supported.`);default:return Gi(i,s=>iB(e.element,s,n))}}function g3e(e){return e.name}function qme(e,t,n,i,s){var o;if((o=t.alternateMode)!=null&&o.getOptionsNameMap().optionsNameMap.has(e.toLowerCase()))return Pb(s,i,t.alternateMode.diagnostic,e);let u=Fx(e,t.optionDeclarations,g3e);return u?Pb(s,i,t.unknownDidYouMeanDiagnostic,n||e,u.name):Pb(s,i,t.unknownOptionDiagnostic,n||e)}function BY(e,t,n){let i={},s,o=[],u=[];return m(t),{options:i,watchOptions:s,fileNames:o,errors:u};function m(S){let E=0;for(;E<S.length;){let x=S[E];if(E++,x.charCodeAt(0)===64)d(x.slice(1));else if(x.charCodeAt(0)===45){let D=x.slice(x.charCodeAt(1)===45?2:1),w=Wme(e.getOptionsNameMap,D,!0);if(w)E=h3e(S,E,e,w,i,u);else{let R=Wme(qY.getOptionsNameMap,D,!0);R?E=h3e(S,E,qY,R,s||(s={}),u):u.push(qme(D,e,x))}}else o.push(x)}}function d(S){let E=UO(S,n||(w=>lu.readFile(w)));if(!bs(E)){u.push(E);return}let x=[],D=0;for(;;){for(;D<E.length&&E.charCodeAt(D)<=32;)D++;if(D>=E.length)break;let w=D;if(E.charCodeAt(w)===34){for(D++;D<E.length&&E.charCodeAt(D)!==34;)D++;D<E.length?(x.push(E.substring(w+1,D)),D++):u.push(Nc(v.Unterminated_quoted_string_in_response_file_0,S))}else{for(;E.charCodeAt(D)>32;)D++;x.push(E.substring(w,D))}}m(x)}}function h3e(e,t,n,i,s,o){if(i.isTSConfigOnly){let u=e[t];u==="null"?(s[i.name]=void 0,t++):i.type==="boolean"?u==="false"?(s[i.name]=KA(i,!1,o),t++):(u==="true"&&t++,o.push(Nc(v.Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line,i.name))):(o.push(Nc(v.Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line,i.name)),u&&!_s(u,"-")&&t++)}else if(!e[t]&&i.type!=="boolean"&&o.push(Nc(n.optionTypeMismatchDiagnostic,i.name,zY(i))),e[t]!=="null")switch(i.type){case"number":s[i.name]=KA(i,parseInt(e[t]),o),t++;break;case"boolean":let u=e[t];s[i.name]=KA(i,u!=="false",o),(u==="false"||u==="true")&&t++;break;case"string":s[i.name]=KA(i,e[t]||"",o),t++;break;case"list":let m=Jme(i,e[t],o);s[i.name]=m||[],m&&t++;break;case"listOrElement":M.fail("listOrElement not supported here");break;default:s[i.name]=iB(i,e[t],o),t++;break}else s[i.name]=void 0,t++;return t}var sB={alternateMode:Nbt,getOptionsNameMap:NN,optionDeclarations:og,unknownOptionDiagnostic:v.Unknown_compiler_option_0,unknownDidYouMeanDiagnostic:v.Unknown_compiler_option_0_Did_you_mean_1,optionTypeMismatchDiagnostic:v.Compiler_option_0_expects_an_argument};function zme(e,t){return BY(sB,e,t)}function UY(e,t){return Wme(NN,e,t)}function Wme(e,t,n=!1){t=t.toLowerCase();let{optionsNameMap:i,shortOptionNames:s}=e();if(n){let o=s.get(t);o!==void 0&&(t=o)}return i.get(t)}var y3e;function v3e(){return y3e||(y3e=nB(A8))}var Dbt={diagnostic:v.Compiler_option_0_may_not_be_used_with_build,getOptionsNameMap:NN},wbt={alternateMode:Dbt,getOptionsNameMap:v3e,optionDeclarations:A8,unknownOptionDiagnostic:v.Unknown_build_option_0,unknownDidYouMeanDiagnostic:v.Unknown_build_option_0_Did_you_mean_1,optionTypeMismatchDiagnostic:v.Build_option_0_requires_a_value_of_type_1};function $me(e){let{options:t,watchOptions:n,fileNames:i,errors:s}=BY(wbt,e),o=t;return i.length===0&&i.push("."),o.clean&&o.force&&s.push(Nc(v.Options_0_and_1_cannot_be_combined,"clean","force")),o.clean&&o.verbose&&s.push(Nc(v.Options_0_and_1_cannot_be_combined,"clean","verbose")),o.clean&&o.watch&&s.push(Nc(v.Options_0_and_1_cannot_be_combined,"clean","watch")),o.watch&&o.dry&&s.push(Nc(v.Options_0_and_1_cannot_be_combined,"watch","dry")),{buildOptions:o,watchOptions:n,projects:i,errors:s}}function Df(e,...t){return aa(Nc(e,...t).messageText,bs)}function k8(e,t,n,i,s,o){let u=UO(e,S=>n.readFile(S));if(!bs(u)){n.onUnRecoverableConfigFileDiagnostic(u);return}let m=x8(e,u),d=n.getCurrentDirectory();return m.path=rc(e,d,l_(n.useCaseSensitiveFileNames)),m.resolvedPath=m.path,m.originalFileName=m.fileName,D8(m,n,xs(mi(e),d),t,xs(e,d),void 0,o,i,s)}function P8(e,t){let n=UO(e,t);return bs(n)?VY(e,n):{config:{},error:n}}function VY(e,t){let n=x8(e,t);return{config:I3e(n,n.parseDiagnostics,void 0),error:n.parseDiagnostics.length?n.parseDiagnostics[0]:void 0}}function Hme(e,t){let n=UO(e,t);return bs(n)?x8(e,n):{fileName:e,parseDiagnostics:[n]}}function UO(e,t){let n;try{n=t(e)}catch(i){return Nc(v.Cannot_read_file_0_Colon_1,e,i.message)}return n===void 0?Nc(v.Cannot_read_file_0,e):n}function JY(e){return xP(e,g3e)}var S3e={optionDeclarations:rB,unknownOptionDiagnostic:v.Unknown_type_acquisition_option_0,unknownDidYouMeanDiagnostic:v.Unknown_type_acquisition_option_0_Did_you_mean_1},b3e;function T3e(){return b3e||(b3e=nB(YA))}var qY={getOptionsNameMap:T3e,optionDeclarations:YA,unknownOptionDiagnostic:v.Unknown_watch_option_0,unknownDidYouMeanDiagnostic:v.Unknown_watch_option_0_Did_you_mean_1,optionTypeMismatchDiagnostic:v.Watch_option_0_requires_a_value_of_type_1},E3e;function x3e(){return E3e||(E3e=JY(og))}var C3e;function A3e(){return C3e||(C3e=JY(YA))}var k3e;function P3e(){return k3e||(k3e=JY(rB))}var aB={name:"extends",type:"listOrElement",element:{name:"extends",type:"string"},category:v.File_Management,disallowNullOrUndefined:!0},N3e={name:"compilerOptions",type:"object",elementOptions:x3e(),extraKeyDiagnostics:sB},D3e={name:"watchOptions",type:"object",elementOptions:A3e(),extraKeyDiagnostics:qY},w3e={name:"typeAcquisition",type:"object",elementOptions:P3e(),extraKeyDiagnostics:S3e},Gme;function Ibt(){return Gme===void 0&&(Gme={name:void 0,type:"object",elementOptions:JY([N3e,D3e,w3e,aB,{name:"references",type:"list",element:{name:"references",type:"object"},category:v.Projects},{name:"files",type:"list",element:{name:"files",type:"string"},category:v.File_Management},{name:"include",type:"list",element:{name:"include",type:"string"},category:v.File_Management,defaultValueDescription:v.if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk},{name:"exclude",type:"list",element:{name:"exclude",type:"string"},category:v.File_Management,defaultValueDescription:v.node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified},Zj])}),Gme}function I3e(e,t,n){var i;let s=(i=e.statements[0])==null?void 0:i.expression;if(s&&s.kind!==210){if(t.push(bd(e,s,v.The_root_value_of_a_0_file_must_be_an_object,Ul(e.fileName)==="jsconfig.json"?"jsconfig.json":"tsconfig.json")),Gu(s)){let o=Ln(s.elements,Ca);if(o)return N8(e,o,t,!0,n)}return{}}return N8(e,s,t,!0,n)}function Yme(e,t){var n;return N8(e,(n=e.statements[0])==null?void 0:n.expression,t,!0,void 0)}function N8(e,t,n,i,s){if(!t)return i?{}:void 0;return m(t,s?.rootOptions);function o(S,E){var x;let D=i?{}:void 0;for(let w of S.properties){if(w.kind!==303){n.push(bd(e,w,v.Property_assignment_expected));continue}w.questionToken&&n.push(bd(e,w.questionToken,v.The_0_modifier_can_only_be_used_in_TypeScript_files,"?")),d(w.name)||n.push(bd(e,w.name,v.String_literal_with_double_quotes_expected));let R=Q3(w.name)?void 0:tA(w.name),L=R&&Qi(R),F=L?(x=E?.elementOptions)==null?void 0:x.get(L):void 0,J=m(w.initializer,F);typeof L<"u"&&(i&&(D[L]=J),s?.onPropertySet(L,J,w,E,F))}return D}function u(S,E){if(!i){S.forEach(x=>m(x,E));return}return Zn(S.map(x=>m(x,E)),x=>x!==void 0)}function m(S,E){switch(S.kind){case 112:return!0;case 97:return!1;case 106:return null;case 11:return d(S)||n.push(bd(e,S,v.String_literal_with_double_quotes_expected)),S.text;case 9:return Number(S.text);case 224:if(S.operator!==41||S.operand.kind!==9)break;return-Number(S.operand.text);case 210:return o(S,E);case 209:return u(S.elements,E&&E.element)}E?n.push(bd(e,S,v.Compiler_option_0_requires_a_value_of_type_1,E.name,zY(E))):n.push(bd(e,S,v.Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal))}function d(S){return La(S)&&d9(S,e)}}function zY(e){return e.type==="listOrElement"?`${zY(e.element)} or Array`:e.type==="list"?"Array":bs(e.type)?e.type:"string"}function O3e(e,t){if(e){if(w8(t))return!e.disallowNullOrUndefined;if(e.type==="list")return Rs(t);if(e.type==="listOrElement")return Rs(t)||O3e(e.element,t);let n=bs(e.type)?e.type:"string";return typeof t===n}return!1}function WY(e,t,n){var i,s,o;let u=l_(n.useCaseSensitiveFileNames),m=Cr(Zn(e.fileNames,(s=(i=e.options.configFile)==null?void 0:i.configFileSpecs)!=null&&s.validatedIncludeSpecs?Rbt(t,e.options.configFile.configFileSpecs.validatedIncludeSpecs,e.options.configFile.configFileSpecs.validatedExcludeSpecs,n):YS),R=>aI(xs(t,n.getCurrentDirectory()),xs(R,n.getCurrentDirectory()),u)),d={configFilePath:xs(t,n.getCurrentDirectory()),useCaseSensitiveFileNames:n.useCaseSensitiveFileNames},S=cB(e.options,d),E=e.watchOptions&&Mbt(e.watchOptions),x={compilerOptions:{...oB(S),showConfig:void 0,configFile:void 0,configFilePath:void 0,help:void 0,init:void 0,listFiles:void 0,listEmittedFiles:void 0,project:void 0,build:void 0,version:void 0},watchOptions:E&&oB(E),references:Cr(e.projectReferences,R=>({...R,path:R.originalPath?R.originalPath:"",originalPath:void 0})),files:wt(m)?m:void 0,...(o=e.options.configFile)!=null&&o.configFileSpecs?{include:Obt(e.options.configFile.configFileSpecs.validatedIncludeSpecs),exclude:e.options.configFile.configFileSpecs.validatedExcludeSpecs}:{},compileOnSave:e.compileOnSave?!0:void 0},D=new Set(S.keys()),w={};for(let R in Ql)if(!D.has(R)&&Pt(Ql[R].dependencies,L=>D.has(L))){let L=Ql[R].computeValue(e.options),F=Ql[R].computeValue({});L!==F&&(w[R]=Ql[R].computeValue(e.options))}return Mx(x.compilerOptions,oB(cB(w,d))),x}function oB(e){return{...Is(e.entries()).reduce((t,n)=>({...t,[n[0]]:n[1]}),{})}}function Obt(e){if(wt(e)){if(wt(e)!==1)return e;if(e[0]!==GY)return e}}function Rbt(e,t,n,i){if(!t)return YS;let s=rj(e,n,t,i.useCaseSensitiveFileNames,i.getCurrentDirectory()),o=s.excludePattern&&G1(s.excludePattern,i.useCaseSensitiveFileNames),u=s.includeFilePattern&&G1(s.includeFilePattern,i.useCaseSensitiveFileNames);return u?o?m=>!(u.test(m)&&!o.test(m)):m=>!u.test(m):o?m=>o.test(m):YS}function R3e(e){switch(e.type){case"string":case"number":case"boolean":case"object":return;case"list":case"listOrElement":return R3e(e.element);default:return e.type}}function $Y(e,t){return Nu(t,(n,i)=>{if(n===e)return i})}function cB(e,t){return M3e(e,NN(),t)}function Mbt(e){return M3e(e,T3e())}function M3e(e,{optionsNameMap:t},n){let i=new Map,s=n&&l_(n.useCaseSensitiveFileNames);for(let o in e)if(Ho(e,o)){if(t.has(o)&&(t.get(o).category===v.Command_line_Options||t.get(o).category===v.Output_Formatting))continue;let u=e[o],m=t.get(o.toLowerCase());if(m){M.assert(m.type!=="listOrElement");let d=R3e(m);d?m.type==="list"?i.set(o,u.map(S=>$Y(S,d))):i.set(o,$Y(u,d)):n&&m.isFilePath?i.set(o,aI(n.configFilePath,xs(u,mi(n.configFilePath)),s)):n&&m.type==="list"&&m.element.isFilePath?i.set(o,u.map(S=>aI(n.configFilePath,xs(S,mi(n.configFilePath)),s))):i.set(o,u)}}return i}function Kme(e,t){let n=L3e(e);return s();function i(o){return Array(o+1).join(" ")}function s(){let o=[],u=i(2);return Ime.forEach(m=>{if(!n.has(m.name))return;let d=n.get(m.name),S=ige(m);d!==S?o.push(`${u}${m.name}: ${d}`):Ho(jY,m.name)&&o.push(`${u}${m.name}: ${S}`)}),o.join(t)+t}}function L3e(e){let t=ZF(e,jY);return cB(t)}function Xme(e,t,n){let i=L3e(e);return u();function s(m){return Array(m+1).join(" ")}function o({category:m,name:d,isCommandLineOnly:S}){let E=[v.Command_line_Options,v.Editor_Support,v.Compiler_Diagnostics,v.Backwards_Compatibility,v.Watch_and_Build_Modes,v.Output_Formatting];return!S&&m!==void 0&&(!E.includes(m)||i.has(d))}function u(){let m=new Map;m.set(v.Projects,[]),m.set(v.Language_and_Environment,[]),m.set(v.Modules,[]),m.set(v.JavaScript_Support,[]),m.set(v.Emit,[]),m.set(v.Interop_Constraints,[]),m.set(v.Type_Checking,[]),m.set(v.Completeness,[]);for(let w of og)if(o(w)){let R=m.get(w.category);R||m.set(w.category,R=[]),R.push(w)}let d=0,S=0,E=[];m.forEach((w,R)=>{E.length!==0&&E.push({value:""}),E.push({value:`/* ${Ms(R)} */`});for(let L of w){let F;i.has(L.name)?F=`"${L.name}": ${JSON.stringify(i.get(L.name))}${(S+=1)===i.size?"":","}`:F=`// "${L.name}": ${JSON.stringify(ige(L))},`,E.push({value:F,description:`/* ${L.description&&Ms(L.description)||L.name} */`}),d=Math.max(F.length,d)}});let x=s(2),D=[];D.push("{"),D.push(`${x}"compilerOptions": {`),D.push(`${x}${x}/* ${Ms(v.Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file)} */`),D.push("");for(let w of E){let{value:R,description:L=""}=w;D.push(R&&`${x}${x}${R}${L&&s(d-R.length+2)+L}`)}if(t.length){D.push(`${x}},`),D.push(`${x}"files": [`);for(let w=0;w<t.length;w++)D.push(`${x}${x}${JSON.stringify(t[w])}${w===t.length-1?"":","}`);D.push(`${x}]`)}else D.push(`${x}}`);return D.push("}"),D.join(n)+n}}function lB(e,t){let n={},i=NN().optionsNameMap;for(let s in e)Ho(e,s)&&(n[s]=Lbt(i.get(s.toLowerCase()),e[s],t));return n.configFilePath&&(n.configFilePath=t(n.configFilePath)),n}function Lbt(e,t,n){if(e&&!w8(t)){if(e.type==="list"){let i=t;if(e.element.isFilePath&&i.length)return i.map(n)}else if(e.isFilePath)return n(t);M.assert(e.type!=="listOrElement")}return t}function F3e(e,t,n,i,s,o,u,m,d){return B3e(e,void 0,t,n,i,d,s,o,u,m)}function D8(e,t,n,i,s,o,u,m,d){var S,E;(S=Cn)==null||S.push(Cn.Phase.Parse,"parseJsonSourceFileConfigFileContent",{path:e.fileName});let x=B3e(void 0,e,t,n,i,d,s,o,u,m);return(E=Cn)==null||E.pop(),x}function HY(e,t){t&&Object.defineProperty(e,"configFile",{enumerable:!1,writable:!1,value:t})}function w8(e){return e==null}function j3e(e,t){return mi(xs(e,t))}var GY="**/*";function B3e(e,t,n,i,s={},o,u,m=[],d=[],S){M.assert(e===void 0&&t!==void 0||e!==void 0&&t===void 0);let E=[],x=W3e(e,t,n,i,u,m,E,S),{raw:D}=x,w=U3e(ZF(s,x.options||{}),jme,i),R=uB(o&&x.watchOptions?ZF(o,x.watchOptions):x.watchOptions||o,i);w.configFilePath=u&&qu(u);let L=Zs(u?j3e(u,i):i),F=J();return t&&(t.configFileSpecs=F),HY(w,t),{options:w,watchOptions:R,fileNames:G(L),projectReferences:q(L),typeAcquisition:x.typeAcquisition||KY(),raw:D,errors:E,wildcardDirectories:Gbt(F,L,n.useCaseSensitiveFileNames),compileOnSave:!!D.compileOnSave};function J(){let re=pe("references",Ve=>typeof Ve=="object","object"),ue=ee(W("files"));if(ue){let Ve=re==="no-prop"||Rs(re)&&re.length===0,Pe=Ho(D,"extends");if(ue.length===0&&Ve&&!Pe)if(t){let ke=u||"tsconfig.json",De=v.The_files_list_in_config_file_0_is_empty,Be=iR(t,"files",qe=>qe.initializer),ct=Pb(t,Be,De,ke);E.push(ct)}else K(v.The_files_list_in_config_file_0_is_empty,u||"tsconfig.json")}let ce=ee(W("include")),ne=W("exclude"),le=!1,me=ee(ne);if(ne==="no-prop"){let Ve=w.outDir,Pe=w.declarationDir;(Ve||Pe)&&(me=Zn([Ve,Pe],ke=>!!ke))}ue===void 0&&ce===void 0&&(ce=[GY],le=!0);let de,Ae,xe,te;ce&&(de=nRe(ce,E,!0,t,"include"),xe=_B(de,L)||de),me&&(Ae=nRe(me,E,!1,t,"exclude"),te=_B(Ae,L)||Ae);let he=Zn(ue,bs),be=_B(he,L)||he;return{filesSpecs:ue,includeSpecs:ce,excludeSpecs:me,validatedFilesSpec:be,validatedIncludeSpecs:xe,validatedExcludeSpecs:te,validatedFilesSpecBeforeSubstitution:he,validatedIncludeSpecsBeforeSubstitution:de,validatedExcludeSpecsBeforeSubstitution:Ae,pathPatterns:void 0,isDefaultIncludeSpec:le}}function G(re){let ue=JO(F,re,w,n,d);return z3e(ue,VO(D),m)&&E.push(q3e(F,u)),ue}function q(re){let ue,ce=pe("references",ne=>typeof ne=="object","object");if(Rs(ce))for(let ne of ce)typeof ne.path!="string"?K(v.Compiler_option_0_requires_a_value_of_type_1,"reference.path","string"):(ue||(ue=[])).push({path:xs(ne.path,re),originalPath:ne.path,prepend:ne.prepend,circular:ne.circular});return ue}function ee(re){return Rs(re)?re:void 0}function W(re){return pe(re,bs,"string")}function pe(re,ue,ce){if(Ho(D,re)&&!w8(D[re]))if(Rs(D[re])){let ne=D[re];return!t&&!wi(ne,ue)&&E.push(Nc(v.Compiler_option_0_requires_a_value_of_type_1,re,ce)),ne}else return K(v.Compiler_option_0_requires_a_value_of_type_1,re,"Array"),"not-array";return"no-prop"}function K(re,...ue){t||E.push(Nc(re,...ue))}}function uB(e,t){return U3e(e,Bme,t)}function U3e(e,t,n){if(!e)return e;let i;for(let o of t)if(e[o.name]!==void 0){let u=e[o.name];switch(o.type){case"string":M.assert(o.isFilePath),YY(u)&&s(o,J3e(u,n));break;case"list":M.assert(o.element.isFilePath);let m=_B(u,n);m&&s(o,m);break;case"object":M.assert(o.name==="paths");let d=Fbt(u,n);d&&s(o,d);break;default:M.fail("option type not supported")}}return i||e;function s(o,u){(i??(i=Mx({},e)))[o.name]=u}}var V3e="${configDir}";function YY(e){return bs(e)&&_s(e,V3e,!0)}function J3e(e,t){return xs(e.replace(V3e,"./"),t)}function _B(e,t){if(!e)return e;let n;return e.forEach((i,s)=>{YY(i)&&((n??(n=e.slice()))[s]=J3e(i,t))}),n}function Fbt(e,t){let n;return Ng(e).forEach(s=>{if(!Rs(e[s]))return;let o=_B(e[s],t);o&&((n??(n=Mx({},e)))[s]=o)}),n}function jbt(e){return e.code===v.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2.code}function q3e({includeSpecs:e,excludeSpecs:t},n){return Nc(v.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2,n||"tsconfig.json",JSON.stringify(e||[]),JSON.stringify(t||[]))}function z3e(e,t,n){return e.length===0&&t&&(!n||n.length===0)}function VO(e){return!Ho(e,"files")&&!Ho(e,"references")}function fB(e,t,n,i,s){let o=i.length;return z3e(e,s)?i.push(q3e(n,t)):zw(i,u=>!jbt(u)),o!==i.length}function Bbt(e){return!!e.options}function W3e(e,t,n,i,s,o,u,m){var d;i=qu(i);let S=xs(s||"",i);if(o.includes(S))return u.push(Nc(v.Circularity_detected_while_resolving_configuration_Colon_0,[...o,S].join(" -> "))),{raw:e||Yme(t,u)};let E=e?Ubt(e,n,i,s,u):Vbt(t,n,i,s,u);if((d=E.options)!=null&&d.paths&&(E.options.pathsBasePath=i),E.extendedConfigPath){o=o.concat([S]);let D={options:{}};bs(E.extendedConfigPath)?x(D,E.extendedConfigPath):E.extendedConfigPath.forEach(w=>x(D,w)),D.include&&(E.raw.include=D.include),D.exclude&&(E.raw.exclude=D.exclude),D.files&&(E.raw.files=D.files),E.raw.compileOnSave===void 0&&D.compileOnSave&&(E.raw.compileOnSave=D.compileOnSave),t&&D.extendedSourceFiles&&(t.extendedSourceFiles=Is(D.extendedSourceFiles.keys())),E.options=Mx(D.options,E.options),E.watchOptions=E.watchOptions&&D.watchOptions?Mx(D.watchOptions,E.watchOptions):E.watchOptions||D.watchOptions}return E;function x(D,w){let R=Jbt(t,w,n,o,u,m,D);if(R&&Bbt(R)){let L=R.raw,F,J=G=>{E.raw[G]||L[G]&&(D[G]=Cr(L[G],q=>YY(q)||ip(q)?q:ri(F||(F=sI(mi(w),i,l_(n.useCaseSensitiveFileNames))),q)))};J("include"),J("exclude"),J("files"),L.compileOnSave!==void 0&&(D.compileOnSave=L.compileOnSave),Mx(D.options,R.options),D.watchOptions=D.watchOptions&&R.watchOptions?Mx({},D.watchOptions,R.watchOptions):D.watchOptions||R.watchOptions}}}function Ubt(e,t,n,i,s){Ho(e,"excludes")&&s.push(Nc(v.Unknown_option_excludes_Did_you_mean_exclude));let o=X3e(e.compilerOptions,n,s,i),u=Q3e(e.typeAcquisition,n,s,i),m=zbt(e.watchOptions,n,s);e.compileOnSave=qbt(e,n,s);let d=e.extends||e.extends===""?$3e(e.extends,t,n,i,s):void 0;return{raw:e,options:o,watchOptions:m,typeAcquisition:u,extendedConfigPath:d}}function $3e(e,t,n,i,s,o,u,m){let d,S=i?j3e(i,n):n;if(bs(e))d=H3e(e,t,S,s,u,m);else if(Rs(e)){d=[];for(let E=0;E<e.length;E++){let x=e[E];bs(x)?d=Bt(d,H3e(x,t,S,s,u?.elements[E],m)):g2(aB.element,e,n,s,o,u?.elements[E],m)}}else g2(aB,e,n,s,o,u,m);return d}function Vbt(e,t,n,i,s){let o=K3e(i),u,m,d,S,E=Ibt(),x=I3e(e,s,{rootOptions:E,onPropertySet:D});return u||(u=KY(i)),S&&x&&x.compilerOptions===void 0&&s.push(bd(e,S[0],v._0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file,tA(S[0]))),{raw:x,options:o,watchOptions:m,typeAcquisition:u,extendedConfigPath:d};function D(w,R,L,F,J){if(J&&J!==aB&&(R=g2(J,R,n,s,L,L.initializer,e)),F?.name)if(J){let G;F===N3e?G=o:F===D3e?G=m??(m={}):F===w3e?G=u??(u=KY(i)):M.fail("Unknown option"),G[J.name]=R}else w&&F?.extraKeyDiagnostics&&(F.elementOptions?s.push(qme(w,F.extraKeyDiagnostics,void 0,L.name,e)):s.push(bd(e,L.name,F.extraKeyDiagnostics.unknownOptionDiagnostic,w)));else F===E&&(J===aB?d=$3e(R,t,n,i,s,L,L.initializer,e):J||(w==="excludes"&&s.push(bd(e,L.name,v.Unknown_option_excludes_Did_you_mean_exclude)),Ln(Ime,G=>G.name===w)&&(S=Bt(S,L.name))))}}function H3e(e,t,n,i,s,o){if(e=qu(e),ip(e)||_s(e,"./")||_s(e,"../")){let m=xs(e,n);if(!t.fileExists(m)&&!Wc(m,".json")&&(m=`${m}.json`,!t.fileExists(m))){i.push(Pb(o,s,v.File_0_not_found,e));return}return m}let u=hge(e,ri(n,"tsconfig.json"),t);if(u.resolvedModule)return u.resolvedModule.resolvedFileName;e===""?i.push(Pb(o,s,v.Compiler_option_0_cannot_be_given_an_empty_string,"extends")):i.push(Pb(o,s,v.File_0_not_found,e))}function Jbt(e,t,n,i,s,o,u){let m=n.useCaseSensitiveFileNames?t:R1(t),d,S,E;if(o&&(d=o.get(m))?{extendedResult:S,extendedConfig:E}=d:(S=Hme(t,x=>n.readFile(x)),S.parseDiagnostics.length||(E=W3e(void 0,S,n,mi(t),Ul(t),i,s,o)),o&&o.set(m,{extendedResult:S,extendedConfig:E})),e&&((u.extendedSourceFiles??(u.extendedSourceFiles=new Set)).add(S.fileName),S.extendedSourceFiles))for(let x of S.extendedSourceFiles)u.extendedSourceFiles.add(x);if(S.parseDiagnostics.length){s.push(...S.parseDiagnostics);return}return E}function qbt(e,t,n){if(!Ho(e,Zj.name))return!1;let i=g2(Zj,e.compileOnSave,t,n);return typeof i=="boolean"&&i}function G3e(e,t,n){let i=[];return{options:X3e(e,t,i,n),errors:i}}function Y3e(e,t,n){let i=[];return{options:Q3e(e,t,i,n),errors:i}}function K3e(e){return e&&Ul(e)==="jsconfig.json"?{allowJs:!0,maxNodeModuleJsDepth:2,allowSyntheticDefaultImports:!0,skipLibCheck:!0,noEmit:!0}:{}}function X3e(e,t,n,i){let s=K3e(i);return Qme(x3e(),e,t,s,sB,n),i&&(s.configFilePath=qu(i)),s}function KY(e){return{enable:!!e&&Ul(e)==="jsconfig.json",include:[],exclude:[]}}function Q3e(e,t,n,i){let s=KY(i);return Qme(P3e(),e,t,s,S3e,n),s}function zbt(e,t,n){return Qme(A3e(),e,t,void 0,qY,n)}function Qme(e,t,n,i,s,o){if(t){for(let u in t){let m=e.get(u);m?(i||(i={}))[m.name]=g2(m,t[u],n,o):o.push(qme(u,s))}return i}}function Pb(e,t,n,...i){return e&&t?bd(e,t,n,...i):Nc(n,...i)}function g2(e,t,n,i,s,o,u){if(e.isCommandLineOnly){i.push(Pb(u,s?.name,v.Option_0_can_only_be_specified_on_command_line,e.name));return}if(O3e(e,t)){let m=e.type;if(m==="list"&&Rs(t))return eRe(e,t,n,i,s,o,u);if(m==="listOrElement")return Rs(t)?eRe(e,t,n,i,s,o,u):g2(e.element,t,n,i,s,o,u);if(!bs(e.type))return Z3e(e,t,i,o,u);let d=KA(e,t,i,o,u);return w8(d)?d:Wbt(e,n,d)}else i.push(Pb(u,o,v.Compiler_option_0_requires_a_value_of_type_1,e.name,zY(e)))}function Wbt(e,t,n){return e.isFilePath&&(n=qu(n),n=YY(n)?n:xs(n,t),n===""&&(n=".")),n}function KA(e,t,n,i,s){var o;if(w8(t))return;let u=(o=e.extraValidation)==null?void 0:o.call(e,t);if(!u)return t;n.push(Pb(s,i,...u))}function Z3e(e,t,n,i,s){if(w8(t))return;let o=t.toLowerCase(),u=e.type.get(o);if(u!==void 0)return KA(e,u,n,i,s);n.push(m3e(e,(m,...d)=>Pb(s,i,m,...d)))}function eRe(e,t,n,i,s,o,u){return Zn(Cr(t,(m,d)=>g2(e.element,m,n,i,s,o?.elements[d],u)),m=>e.listPreserveFalsyValues?!0:!!m)}var $bt=/(^|\/)\*\*\/?$/,Hbt=/^[^*?]*(?=\/[^/]*[*?])/;function JO(e,t,n,i,s=ve){t=Zs(t);let o=l_(i.useCaseSensitiveFileNames),u=new Map,m=new Map,d=new Map,{validatedFilesSpec:S,validatedIncludeSpecs:E,validatedExcludeSpecs:x}=e,D=aO(n,s),w=HR(n,D);if(S)for(let J of S){let G=xs(J,t);u.set(o(G),G)}let R;if(E&&E.length>0)for(let J of i.readDirectory(t,ef(w),x,E,void 0)){if(Ic(J,".json")){if(!R){let ee=E.filter(pe=>Wc(pe,".json")),W=Cr(ej(ee,t,"files"),pe=>`^${pe}$`);R=W?W.map(pe=>G1(pe,i.useCaseSensitiveFileNames)):ve}if(Bo(R,ee=>ee.test(J))!==-1){let ee=o(J);!u.has(ee)&&!d.has(ee)&&d.set(ee,J)}continue}if(Kbt(J,u,m,D,o))continue;Xbt(J,m,D,o);let G=o(J);!u.has(G)&&!m.has(G)&&m.set(G,J)}let L=Is(u.values()),F=Is(m.values());return L.concat(F,Is(d.values()))}function Zme(e,t,n,i,s){let{validatedFilesSpec:o,validatedIncludeSpecs:u,validatedExcludeSpecs:m}=t;if(!wt(u)||!wt(m))return!1;n=Zs(n);let d=l_(i);if(o){for(let S of o)if(d(xs(S,n))===e)return!1}return rRe(e,m,i,s,n)}function tRe(e){let t=_s(e,"**/")?0:e.indexOf("/**/");return t===-1?!1:(Wc(e,"/..")?e.length:e.lastIndexOf("/../"))>t}function pB(e,t,n,i){return rRe(e,Zn(t,s=>!tRe(s)),n,i)}function rRe(e,t,n,i,s){let o=iO(t,ri(Zs(i),s),"exclude"),u=o&&G1(o,n);return u?u.test(e)?!0:!kP(e)&&u.test(yu(e)):!1}function nRe(e,t,n,i,s){return e.filter(u=>{if(!bs(u))return!1;let m=ege(u,n);return m!==void 0&&t.push(o(...m)),m===void 0});function o(u,m){let d=n9(i,s,m);return Pb(i,d,u,m)}}function ege(e,t){if(M.assert(typeof e=="string"),t&&$bt.test(e))return[v.File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0,e];if(tRe(e))return[v.File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0,e]}function Gbt({validatedIncludeSpecs:e,validatedExcludeSpecs:t},n,i){let s=iO(t,n,"exclude"),o=s&&new RegExp(s,i?"":"i"),u={},m=new Map;if(e!==void 0){let d=[];for(let S of e){let E=Zs(ri(n,S));if(o&&o.test(E))continue;let x=Ybt(E,i);if(x){let{key:D,path:w,flags:R}=x,L=m.get(D),F=L!==void 0?u[L]:void 0;(F===void 0||F<R)&&(u[L!==void 0?L:w]=R,L===void 0&&m.set(D,w),R===1&&d.push(D))}}for(let S in u)if(Ho(u,S))for(let E of d){let x=tge(S,i);x!==E&&Cm(E,x,n,!i)&&delete u[S]}}return u}function tge(e,t){return t?e:R1(e)}function Ybt(e,t){let n=Hbt.exec(e);if(n){let i=e.indexOf("?"),s=e.indexOf("*"),o=e.lastIndexOf(Ec);return{key:tge(n[0],t),path:n[0],flags:i!==-1&&i<o||s!==-1&&s<o?1:0}}if(bG(e.substring(e.lastIndexOf(Ec)+1))){let i=ZS(e);return{key:tge(i,t),path:i,flags:1}}}function Kbt(e,t,n,i,s){let o=kt(i,u=>wl(e,u)?u:void 0);if(!o)return!1;for(let u of o){if(Ic(e,u)&&(u!==".ts"||!Ic(e,".d.ts")))return!1;let m=s(Y1(e,u));if(t.has(m)||n.has(m)){if(u===".d.ts"&&(Ic(e,".js")||Ic(e,".jsx")))continue;return!0}}return!1}function Xbt(e,t,n,i){let s=kt(n,o=>wl(e,o)?o:void 0);if(s)for(let o=s.length-1;o>=0;o--){let u=s[o];if(Ic(e,u))return;let m=i(Y1(e,u));t.delete(m)}}function rge(e){let t={};for(let n in e)if(Ho(e,n)){let i=UY(n);i!==void 0&&(t[n]=nge(e[n],i))}return t}function nge(e,t){if(e===void 0)return e;switch(t.type){case"object":return"";case"string":return"";case"number":return typeof e=="number"?e:"";case"boolean":return typeof e=="boolean"?e:"";case"listOrElement":if(!Rs(e))return nge(e,t.element);case"list":let n=t.element;return Rs(e)?Gi(e,i=>nge(i,n)):"";default:return Nu(t.type,(i,s)=>{if(i===e)return s})}}function ige(e){switch(e.type){case"number":return 1;case"boolean":return!0;case"string":let t=e.defaultValueDescription;return e.isFilePath?`./${t&&typeof t=="string"?t:""}`:"";case"list":return[];case"listOrElement":return ige(e.element);case"object":return{};default:let n=Nh(e.type.keys());return n!==void 0?n:M.fail("Expected 'option.type' to have entries.")}}function ds(e,t,...n){e.trace(vA(t,...n))}function P0(e,t){return!!e.traceResolution&&t.trace!==void 0}function XA(e,t,n){let i;if(t&&e){let s=e.contents.packageJsonContent;typeof s.name=="string"&&typeof s.version=="string"&&(i={name:s.name,subModuleName:t.path.slice(e.packageDirectory.length+Ec.length),version:s.version,peerDependencies:vTt(e,n)})}return t&&{path:t.path,extension:t.ext,packageId:i,resolvedUsingTsExtension:t.resolvedUsingTsExtension}}function XY(e){return XA(void 0,e,void 0)}function iRe(e){if(e)return M.assert(e.packageId===void 0),{path:e.path,ext:e.extension,resolvedUsingTsExtension:e.resolvedUsingTsExtension}}function dB(e){let t=[];return e&1&&t.push("TypeScript"),e&2&&t.push("JavaScript"),e&4&&t.push("Declaration"),e&8&&t.push("JSON"),t.join(", ")}function Qbt(e){let t=[];return e&1&&t.push(...aj),e&2&&t.push(..._N),e&4&&t.push(...sj),e&8&&t.push(".json"),t}function sge(e){if(e)return M.assert(lj(e.extension)),{fileName:e.path,packageId:e.packageId}}function sRe(e,t,n,i,s,o,u,m,d){if(!u.resultFromCache&&!u.compilerOptions.preserveSymlinks&&t&&n&&!t.originalPath&&!vu(e)){let{resolvedFileName:S,originalPath:E}=oRe(t.path,u.host,u.traceEnabled);E&&(t={...t,path:S,originalPath:E})}return aRe(t,n,i,s,o,u.resultFromCache,m,d)}function aRe(e,t,n,i,s,o,u,m){return o?u?.isReadonly?{...o,failedLookupLocations:age(o.failedLookupLocations,n),affectingLocations:age(o.affectingLocations,i),resolutionDiagnostics:age(o.resolutionDiagnostics,s)}:(o.failedLookupLocations=DN(o.failedLookupLocations,n),o.affectingLocations=DN(o.affectingLocations,i),o.resolutionDiagnostics=DN(o.resolutionDiagnostics,s),o):{resolvedModule:e&&{resolvedFileName:e.path,originalPath:e.originalPath===!0?void 0:e.originalPath,extension:e.extension,isExternalLibraryImport:t,packageId:e.packageId,resolvedUsingTsExtension:!!e.resolvedUsingTsExtension},failedLookupLocations:qO(n),affectingLocations:qO(i),resolutionDiagnostics:qO(s),alternateResult:m}}function qO(e){return e.length?e:void 0}function DN(e,t){return t?.length?e?.length?(e.push(...t),e):t:e}function age(e,t){return e?.length?t.length?[...e,...t]:e.slice():qO(t)}function oge(e,t,n,i){if(!Ho(e,t)){i.traceEnabled&&ds(i.host,v.package_json_does_not_have_a_0_field,t);return}let s=e[t];if(typeof s!==n||s===null){i.traceEnabled&&ds(i.host,v.Expected_type_of_0_field_in_package_json_to_be_1_got_2,t,n,s===null?"null":typeof s);return}return s}function QY(e,t,n,i){let s=oge(e,t,"string",i);if(s===void 0)return;if(!s){i.traceEnabled&&ds(i.host,v.package_json_had_a_falsy_0_field,t);return}let o=Zs(ri(n,s));return i.traceEnabled&&ds(i.host,v.package_json_has_0_field_1_that_references_2,t,s,o),o}function Zbt(e,t,n){return QY(e,"typings",t,n)||QY(e,"types",t,n)}function eTt(e,t,n){return QY(e,"tsconfig",t,n)}function tTt(e,t,n){return QY(e,"main",t,n)}function rTt(e,t){let n=oge(e,"typesVersions","object",t);if(n!==void 0)return t.traceEnabled&&ds(t.host,v.package_json_has_a_typesVersions_field_with_version_specific_path_mappings),n}function nTt(e,t){let n=rTt(e,t);if(n===void 0)return;if(t.traceEnabled)for(let u in n)Ho(n,u)&&!s5.tryParse(u)&&ds(t.host,v.package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range,u);let i=mB(n);if(!i){t.traceEnabled&&ds(t.host,v.package_json_does_not_have_a_typesVersions_entry_that_matches_version_0,j);return}let{version:s,paths:o}=i;if(typeof o!="object"){t.traceEnabled&&ds(t.host,v.Expected_type_of_0_field_in_package_json_to_be_1_got_2,`typesVersions['${s}']`,"object",typeof o);return}return i}var cge;function mB(e){cge||(cge=new Km(se));for(let t in e){if(!Ho(e,t))continue;let n=s5.tryParse(t);if(n!==void 0&&n.test(cge))return{version:t,paths:e[t]}}}function zO(e,t){if(e.typeRoots)return e.typeRoots;let n;if(e.configFilePath?n=mi(e.configFilePath):t.getCurrentDirectory&&(n=t.getCurrentDirectory()),n!==void 0)return iTt(n)}function iTt(e){let t;return Am(Zs(e),n=>{let i=ri(n,sTt);(t??(t=[])).push(i)}),t}var sTt=ri("node_modules","@types");function aTt(e,t,n){let i=typeof n.useCaseSensitiveFileNames=="function"?n.useCaseSensitiveFileNames():n.useCaseSensitiveFileNames;return _0(e,t,!i)===0}function oRe(e,t,n){let i=mRe(e,t,n),s=aTt(e,i,t);return{resolvedFileName:s?e:i,originalPath:s?void 0:e}}function cRe(e,t,n){let i=Wc(e,"/node_modules/@types")||Wc(e,"/node_modules/@types/")?kRe(t,n):t;return ri(e,i)}function lge(e,t,n,i,s,o,u){M.assert(typeof e=="string","Non-string value passed to `ts.resolveTypeReferenceDirective`, likely by a wrapping package working with an outdated `resolveTypeReferenceDirectives` signature. This is probably not a problem in TS itself.");let m=P0(n,i);s&&(n=s.commandLine.options);let d=t?mi(t):void 0,S=d?o?.getFromDirectoryCache(e,u,d,s):void 0;if(!S&&d&&!vu(e)&&(S=o?.getFromNonRelativeNameCache(e,u,d,s)),S)return m&&(ds(i,v.Resolving_type_reference_directive_0_containing_file_1,e,t),s&&ds(i,v.Using_compiler_options_of_project_reference_redirect_0,s.sourceFile.fileName),ds(i,v.Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1,e,d),W(S)),S;let E=zO(n,i);m&&(t===void 0?E===void 0?ds(i,v.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set,e):ds(i,v.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1,e,E):E===void 0?ds(i,v.Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set,e,t):ds(i,v.Resolving_type_reference_directive_0_containing_file_1_root_directory_2,e,t,E),s&&ds(i,v.Using_compiler_options_of_project_reference_redirect_0,s.sourceFile.fileName));let x=[],D=[],w=uge(n);u!==void 0&&(w|=30);let R=af(n);u===99&&3<=R&&R<=99&&(w|=32);let L=w&8?sS(n,u):[],F=[],J={compilerOptions:n,host:i,traceEnabled:m,failedLookupLocations:x,affectingLocations:D,packageJsonInfoCache:o,features:w,conditions:L,requestContainingDirectory:d,reportDiagnostic:re=>void F.push(re),isConfigLookup:!1,candidateIsFromPackageJsonField:!1,resolvedPackageDirectory:!1},G=pe(),q=!0;G||(G=K(),q=!1);let ee;if(G){let{fileName:re,packageId:ue}=G,ce=re,ne;n.preserveSymlinks||({resolvedFileName:ce,originalPath:ne}=oRe(re,i,m)),ee={primary:q,resolvedFileName:ce,originalPath:ne,packageId:ue,isExternalLibraryImport:Nb(re)}}return S={resolvedTypeReferenceDirective:ee,failedLookupLocations:qO(x),affectingLocations:qO(D),resolutionDiagnostics:qO(F)},d&&o&&!o.isReadonly&&(o.getOrCreateCacheForDirectory(d,s).set(e,u,S),vu(e)||o.getOrCreateCacheForNonRelativeName(e,u,s).set(d,S)),m&&W(S),S;function W(re){var ue;(ue=re.resolvedTypeReferenceDirective)!=null&&ue.resolvedFileName?re.resolvedTypeReferenceDirective.packageId?ds(i,v.Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3,e,re.resolvedTypeReferenceDirective.resolvedFileName,J1(re.resolvedTypeReferenceDirective.packageId),re.resolvedTypeReferenceDirective.primary):ds(i,v.Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2,e,re.resolvedTypeReferenceDirective.resolvedFileName,re.resolvedTypeReferenceDirective.primary):ds(i,v.Type_reference_directive_0_was_not_resolved,e)}function pe(){if(E&&E.length)return m&&ds(i,v.Resolving_with_primary_search_path_0,E.join(", ")),yi(E,re=>{let ue=cRe(re,e,J),ce=rg(re,i);if(!ce&&m&&ds(i,v.Directory_0_does_not_exist_skipping_all_lookups_in_it,re),n.typeRoots){let ne=ON(4,ue,!ce,J);if(ne){let le=O8(ne.path),me=le?Db(le,!1,J):void 0;return sge(XA(me,ne,J))}}return sge(vge(4,ue,!ce,J))});m&&ds(i,v.Root_directory_cannot_be_determined_skipping_primary_search_paths)}function K(){let re=t&&mi(t);if(re!==void 0){let ue;if(!n.typeRoots||!Wc(t,o6))if(m&&ds(i,v.Looking_up_in_node_modules_folder_initial_location_0,re),vu(e)){let{path:ce}=dRe(re,e);ue=nK(4,ce,!1,J,!0)}else{let ce=ERe(4,e,re,J,void 0,void 0);ue=ce&&ce.value}else m&&ds(i,v.Resolving_type_reference_directive_for_program_that_specifies_custom_typeRoots_skipping_lookup_in_node_modules_folder);return sge(ue)}else m&&ds(i,v.Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder)}}function uge(e){let t=0;switch(af(e)){case 3:t=30;break;case 99:t=30;break;case 100:t=30;break}return e.resolvePackageJsonExports?t|=8:e.resolvePackageJsonExports===!1&&(t&=-9),e.resolvePackageJsonImports?t|=2:e.resolvePackageJsonImports===!1&&(t&=-3),t}function sS(e,t){let n=af(e);if(t===void 0){if(n===100)t=99;else if(n===2)return[]}let i=t===99?["import"]:["require"];return e.noDtsResolution||i.push("types"),n!==100&&i.push("node"),ps(i,e.customConditions)}function ZY(e,t,n,i,s){let o=$O(s?.getPackageJsonInfoCache(),i,n);return Am(t,u=>{if(Ul(u)!=="node_modules"){let m=ri(u,"node_modules"),d=ri(m,e);return Db(d,!1,o)}})}function gB(e,t){if(e.types)return e.types;let n=[];if(t.directoryExists&&t.getDirectories){let i=zO(e,t);if(i){for(let s of i)if(t.directoryExists(s))for(let o of t.getDirectories(s)){let u=Zs(o),m=ri(s,u,"package.json");if(!(t.fileExists(m)&&XI(m,t).typings===null)){let S=Ul(u);S.charCodeAt(0)!==46&&n.push(S)}}}}return n}function hB(e){return!!e?.contents}function _ge(e){return!!e&&!e.contents}function fge(e){var t;if(e===null||typeof e!="object")return""+e;if(Rs(e))return`[${(t=e.map(i=>fge(i)))==null?void 0:t.join(",")}]`;let n="{";for(let i in e)Ho(e,i)&&(n+=`${i}: ${fge(e[i])}`);return n+"}"}function eK(e,t){return t.map(n=>fge(K9(e,n))).join("|")+`|${e.pathsBasePath}`}function tK(e,t){let n=new Map,i=new Map,s=new Map;return e&&n.set(e,s),{getMapOfCacheRedirects:o,getOrCreateMapOfCacheRedirects:u,update:m,clear:S,getOwnMap:()=>s};function o(x){return x?d(x.commandLine.options,!1):s}function u(x){return x?d(x.commandLine.options,!0):s}function m(x){e!==x&&(e?s=d(x,!0):n.set(x,s),e=x)}function d(x,D){let w=n.get(x);if(w)return w;let R=E(x);if(w=i.get(R),!w){if(e){let L=E(e);L===R?w=s:i.has(L)||i.set(L,s)}D&&(w??(w=new Map)),w&&i.set(R,w)}return w&&n.set(x,w),w}function S(){let x=e&&t.get(e);s.clear(),n.clear(),t.clear(),i.clear(),e&&(x&&t.set(e,x),n.set(e,s))}function E(x){let D=t.get(x);return D||t.set(x,D=eK(x,MY)),D}}function oTt(e,t){let n;return{getPackageJsonInfo:i,setPackageJsonInfo:s,clear:o,getInternalMap:u};function i(m){return n?.get(rc(m,e,t))}function s(m,d){(n||(n=new Map)).set(rc(m,e,t),d)}function o(){n=void 0}function u(){return n}}function lRe(e,t,n,i){let s=e.getOrCreateMapOfCacheRedirects(t),o=s.get(n);return o||(o=i(),s.set(n,o)),o}function cTt(e,t,n,i){let s=tK(n,i);return{getFromDirectoryCache:d,getOrCreateCacheForDirectory:m,clear:o,update:u,directoryToModuleNameMap:s};function o(){s.clear()}function u(S){s.update(S)}function m(S,E){let x=rc(S,e,t);return lRe(s,E,x,()=>wN())}function d(S,E,x,D){var w,R;let L=rc(x,e,t);return(R=(w=s.getMapOfCacheRedirects(D))==null?void 0:w.get(L))==null?void 0:R.get(S,E)}}function WO(e,t){return t===void 0?e:`${t}|${e}`}function wN(){let e=new Map,t=new Map,n={get(s,o){return e.get(i(s,o))},set(s,o,u){return e.set(i(s,o),u),n},delete(s,o){return e.delete(i(s,o)),n},has(s,o){return e.has(i(s,o))},forEach(s){return e.forEach((o,u)=>{let[m,d]=t.get(u);return s(o,m,d)})},size(){return e.size}};return n;function i(s,o){let u=WO(s,o);return t.set(u,[s,o]),u}}function lTt(e){return e.resolvedModule&&(e.resolvedModule.originalPath||e.resolvedModule.resolvedFileName)}function uTt(e){return e.resolvedTypeReferenceDirective&&(e.resolvedTypeReferenceDirective.originalPath||e.resolvedTypeReferenceDirective.resolvedFileName)}function _Tt(e,t,n,i,s){let o=tK(n,s);return{getFromNonRelativeNameCache:d,getOrCreateCacheForNonRelativeName:S,clear:u,update:m};function u(){o.clear()}function m(x){o.update(x)}function d(x,D,w,R){var L,F;return M.assert(!vu(x)),(F=(L=o.getMapOfCacheRedirects(R))==null?void 0:L.get(WO(x,D)))==null?void 0:F.get(w)}function S(x,D,w){return M.assert(!vu(x)),lRe(o,w,WO(x,D),E)}function E(){let x=new Map;return{get:D,set:w};function D(L){return x.get(rc(L,e,t))}function w(L,F){let J=rc(L,e,t);if(x.has(J))return;x.set(J,F);let G=i(F),q=G&&R(J,G),ee=J;for(;ee!==q;){let W=mi(ee);if(W===ee||x.has(W))break;x.set(W,F),ee=W}}function R(L,F){let J=rc(mi(F),e,t),G=0,q=Math.min(L.length,J.length);for(;G<q&&L.charCodeAt(G)===J.charCodeAt(G);)G++;if(G===L.length&&(J.length===G||J[G]===Ec))return L;let ee=Rh(L);if(G<ee)return;let W=L.lastIndexOf(Ec,G-1);if(W!==-1)return L.substr(0,Math.max(W,ee))}}}function uRe(e,t,n,i,s,o){o??(o=new Map);let u=cTt(e,t,n,o),m=_Tt(e,t,n,s,o);return i??(i=oTt(e,t)),{...i,...u,...m,clear:d,update:E,getPackageJsonInfoCache:()=>i,clearAllExceptPackageJsonInfoCache:S,optionsToRedirectsKey:o};function d(){S(),i.clear()}function S(){u.clear(),m.clear()}function E(x){u.update(x),m.update(x)}}function IN(e,t,n,i,s){let o=uRe(e,t,n,i,lTt,s);return o.getOrCreateCacheForModuleName=(u,m,d)=>o.getOrCreateCacheForNonRelativeName(u,m,d),o}function yB(e,t,n,i,s){return uRe(e,t,n,i,uTt,s)}function rK(e){return{moduleResolution:2,traceResolution:e.traceResolution}}function vB(e,t,n,i,s){return QA(e,t,rK(n),i,s)}function _Re(e,t,n,i){let s=mi(t);return n.getFromDirectoryCache(e,i,s,void 0)}function QA(e,t,n,i,s,o,u){var m,d,S;let E=P0(n,i);o&&(n=o.commandLine.options),E&&(ds(i,v.Resolving_module_0_from_1,e,t),o&&ds(i,v.Using_compiler_options_of_project_reference_redirect_0,o.sourceFile.fileName));let x=mi(t),D=s?.getFromDirectoryCache(e,u,x,o);if(D)E&&ds(i,v.Resolution_for_module_0_was_found_in_cache_from_location_1,e,x);else{let w=n.moduleResolution;switch(w===void 0?(w=af(n),E&&ds(i,v.Module_resolution_kind_is_not_specified_using_0,rI[w])):E&&ds(i,v.Explicitly_specified_module_resolution_kind_Colon_0,rI[w]),(m=rf)==null||m.logStartResolveModule(e),w){case 3:D=mTt(e,t,n,i,s,o,u);break;case 99:D=gTt(e,t,n,i,s,o,u);break;case 2:D=gge(e,t,n,i,s,o,u?sS(n,u):void 0);break;case 1:D=Tge(e,t,n,i,s,o);break;case 100:D=mge(e,t,n,i,s,o,u?sS(n,u):void 0);break;default:return M.fail(`Unexpected moduleResolution: ${w}`)}D&&D.resolvedModule&&((d=rf)==null||d.logInfoEvent(`Module "${e}" resolved to "${D.resolvedModule.resolvedFileName}"`)),(S=rf)==null||S.logStopResolveModule(D&&D.resolvedModule?""+D.resolvedModule.resolvedFileName:"null"),s&&!s.isReadonly&&(s.getOrCreateCacheForDirectory(x,o).set(e,u,D),vu(e)||s.getOrCreateCacheForNonRelativeName(e,u,o).set(x,D))}return E&&(D.resolvedModule?D.resolvedModule.packageId?ds(i,v.Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2,e,D.resolvedModule.resolvedFileName,J1(D.resolvedModule.packageId)):ds(i,v.Module_name_0_was_successfully_resolved_to_1,e,D.resolvedModule.resolvedFileName):ds(i,v.Module_name_0_was_not_resolved,e)),D}function fRe(e,t,n,i,s){let o=fTt(e,t,i,s);return o?o.value:vu(t)?pTt(e,t,n,i,s):dTt(e,t,i,s)}function fTt(e,t,n,i){var s;let{baseUrl:o,paths:u,configFile:m}=i.compilerOptions;if(u&&!qp(t)){i.traceEnabled&&(o&&ds(i.host,v.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1,o,t),ds(i.host,v.paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0,t));let d=k9(i.compilerOptions,i.host),S=m?.configFileSpecs?(s=m.configFileSpecs).pathPatterns||(s.pathPatterns=cj(u)):void 0;return Sge(e,t,d,u,S,n,!1,i)}}function pTt(e,t,n,i,s){if(!s.compilerOptions.rootDirs)return;s.traceEnabled&&ds(s.host,v.rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0,t);let o=Zs(ri(n,t)),u,m;for(let d of s.compilerOptions.rootDirs){let S=Zs(d);Wc(S,Ec)||(S+=Ec);let E=_s(o,S)&&(m===void 0||m.length<S.length);s.traceEnabled&&ds(s.host,v.Checking_if_0_is_the_longest_matching_prefix_for_1_2,S,o,E),E&&(m=S,u=d)}if(m){s.traceEnabled&&ds(s.host,v.Longest_matching_prefix_for_0_is_1,o,m);let d=o.substr(m.length);s.traceEnabled&&ds(s.host,v.Loading_0_from_the_root_dir_1_candidate_location_2,d,m,o);let S=i(e,o,!rg(n,s.host),s);if(S)return S;s.traceEnabled&&ds(s.host,v.Trying_other_entries_in_rootDirs);for(let E of s.compilerOptions.rootDirs){if(E===u)continue;let x=ri(Zs(E),d);s.traceEnabled&&ds(s.host,v.Loading_0_from_the_root_dir_1_candidate_location_2,d,E,x);let D=mi(x),w=i(e,x,!rg(D,s.host),s);if(w)return w}s.traceEnabled&&ds(s.host,v.Module_resolution_using_rootDirs_has_failed)}}function dTt(e,t,n,i){let{baseUrl:s}=i.compilerOptions;if(!s)return;i.traceEnabled&&ds(i.host,v.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1,s,t);let o=Zs(ri(s,t));return i.traceEnabled&&ds(i.host,v.Resolving_module_name_0_relative_to_base_url_1_2,t,s,o),n(e,o,!rg(mi(o),i.host),i)}function pge(e,t,n){let{resolvedModule:i,failedLookupLocations:s}=hTt(e,t,n);if(!i)throw new Error(`Could not resolve JS module '${e}' starting at '${t}'. Looked in: ${s?.join(", ")}`);return i.resolvedFileName}var dge=(e=>(e[e.None=0]="None",e[e.Imports=2]="Imports",e[e.SelfName=4]="SelfName",e[e.Exports=8]="Exports",e[e.ExportsPatternTrailers=16]="ExportsPatternTrailers",e[e.AllFeatures=30]="AllFeatures",e[e.Node16Default=30]="Node16Default",e[e.NodeNextDefault=30]="NodeNextDefault",e[e.BundlerDefault=30]="BundlerDefault",e[e.EsmMode=32]="EsmMode",e))(dge||{});function mTt(e,t,n,i,s,o,u){return pRe(30,e,t,n,i,s,o,u)}function gTt(e,t,n,i,s,o,u){return pRe(30,e,t,n,i,s,o,u)}function pRe(e,t,n,i,s,o,u,m,d){let S=mi(n),E=m===99?32:0,x=i.noDtsResolution?3:7;return cE(i)&&(x|=8),I8(e|E,t,S,i,s,o,x,!1,u,d)}function hTt(e,t,n){return I8(0,e,t,{moduleResolution:2,allowJs:!0},n,void 0,2,!1,void 0,void 0)}function mge(e,t,n,i,s,o,u){let m=mi(t),d=n.noDtsResolution?3:7;return cE(n)&&(d|=8),I8(uge(n),e,m,n,i,s,d,!1,o,u)}function gge(e,t,n,i,s,o,u,m){let d;return m?d=8:n.noDtsResolution?(d=3,cE(n)&&(d|=8)):d=cE(n)?15:7,I8(u?30:0,e,mi(t),n,i,s,d,!!m,o,u)}function hge(e,t,n){return I8(30,e,mi(t),{moduleResolution:99},n,void 0,8,!0,void 0,void 0)}function I8(e,t,n,i,s,o,u,m,d,S){var E,x,D,w,R;let L=P0(i,s),F=[],J=[],G=af(i);S??(S=sS(i,G===100||G===2?void 0:e&32?99:1));let q=[],ee={compilerOptions:i,host:s,traceEnabled:L,failedLookupLocations:F,affectingLocations:J,packageJsonInfoCache:o,features:e,conditions:S??ve,requestContainingDirectory:n,reportDiagnostic:re=>void q.push(re),isConfigLookup:m,candidateIsFromPackageJsonField:!1,resolvedPackageDirectory:!1};L&&bA(G)&&ds(s,v.Resolving_in_0_mode_with_conditions_1,e&32?"ESM":"CJS",ee.conditions.map(re=>`'${re}'`).join(", "));let W;if(G===2){let re=u&5,ue=u&-6;W=re&&K(re,ee)||ue&&K(ue,ee)||void 0}else W=K(u,ee);let pe;if(ee.resolvedPackageDirectory&&!m&&!vu(t)){let re=W?.value&&u&5&&!SRe(5,W.value.resolved.extension);if((E=W?.value)!=null&&E.isExternalLibraryImport&&re&&e&8&&S?.includes("import")){aS(ee,v.Resolution_of_non_relative_name_failed_trying_with_modern_Node_resolution_features_disabled_to_see_if_npm_library_needs_configuration_update);let ue={...ee,features:ee.features&-9,reportDiagnostic:io},ce=K(u&5,ue);(x=ce?.value)!=null&&x.isExternalLibraryImport&&(pe=ce.value.resolved.path)}else if((!W?.value||re)&&G===2){aS(ee,v.Resolution_of_non_relative_name_failed_trying_with_moduleResolution_bundler_to_see_if_project_may_need_configuration_update);let ue={...ee.compilerOptions,moduleResolution:100},ce={...ee,compilerOptions:ue,features:30,conditions:sS(ue),reportDiagnostic:io},ne=K(u&5,ce);(D=ne?.value)!=null&&D.isExternalLibraryImport&&(pe=ne.value.resolved.path)}}return sRe(t,(w=W?.value)==null?void 0:w.resolved,(R=W?.value)==null?void 0:R.isExternalLibraryImport,F,J,q,ee,o,pe);function K(re,ue){let ne=fRe(re,t,n,(le,me,de,Ae)=>nK(le,me,de,Ae,!0),ue);if(ne)return Kp({resolved:ne,isExternalLibraryImport:Nb(ne.path)});if(vu(t)){let{path:le,parts:me}=dRe(n,t),de=nK(re,le,!1,ue,!0);return de&&Kp({resolved:de,isExternalLibraryImport:Es(me,"node_modules")})}else{let le;if(e&2&&_s(t,"#")&&(le=ETt(re,t,n,ue,o,d)),!le&&e&4&&(le=TTt(re,t,n,ue,o,d)),!le){if(t.includes(":")){L&&ds(s,v.Skipping_module_0_that_looks_like_an_absolute_URI_target_file_types_Colon_1,t,dB(re));return}L&&ds(s,v.Loading_module_0_from_node_modules_folder_target_file_types_Colon_1,t,dB(re)),le=ERe(re,t,n,ue,o,d)}return re&4&&(le??(le=NRe(t,ue))),le&&{value:le.value&&{resolved:le.value,isExternalLibraryImport:!0}}}}}function dRe(e,t){let n=ri(e,t),i=hu(n),s=vc(i);return{path:s==="."||s===".."?yu(Zs(n)):Zs(n),parts:i}}function mRe(e,t,n){if(!t.realpath)return e;let i=Zs(t.realpath(e));return n&&ds(t,v.Resolving_real_path_for_0_result_1,e,i),i}function nK(e,t,n,i,s){if(i.traceEnabled&&ds(i.host,v.Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_types_Colon_1,t,dB(e)),!hv(t)){if(!n){let u=mi(t);rg(u,i.host)||(i.traceEnabled&&ds(i.host,v.Directory_0_does_not_exist_skipping_all_lookups_in_it,u),n=!0)}let o=ON(e,t,n,i);if(o){let u=s?O8(o.path):void 0,m=u?Db(u,!1,i):void 0;return XA(m,o,i)}}if(n||rg(t,i.host)||(i.traceEnabled&&ds(i.host,v.Directory_0_does_not_exist_skipping_all_lookups_in_it,t),n=!0),!(i.features&32))return vge(e,t,n,i,s)}var jy="/node_modules/";function Nb(e){return e.includes(jy)}function O8(e,t){let n=Zs(e),i=n.lastIndexOf(jy);if(i===-1)return;let s=i+jy.length,o=gRe(n,s,t);return n.charCodeAt(s)===64&&(o=gRe(n,o,t)),n.slice(0,o)}function gRe(e,t,n){let i=e.indexOf(Ec,t+1);return i===-1?n?e.length:t:i}function yge(e,t,n,i){return XY(ON(e,t,n,i))}function ON(e,t,n,i){let s=hRe(e,t,n,i);if(s)return s;if(!(i.features&32)){let o=yRe(t,e,"",n,i);if(o)return o}}function hRe(e,t,n,i){if(!Ul(t).includes("."))return;let o=of(t);o===t&&(o=t.substring(0,t.lastIndexOf(".")));let u=t.substring(o.length);return i.traceEnabled&&ds(i.host,v.File_name_0_has_a_1_extension_stripping_it,t,u),yRe(o,e,u,n,i)}function iK(e,t,n,i){return e&1&&wl(t,aj)||e&4&&wl(t,sj)?sK(t,n,i)!==void 0?{path:t,ext:M9(t),resolvedUsingTsExtension:void 0}:void 0:i.isConfigLookup&&e===8&&Ic(t,".json")?sK(t,n,i)!==void 0?{path:t,ext:".json",resolvedUsingTsExtension:void 0}:void 0:hRe(e,t,n,i)}function yRe(e,t,n,i,s){if(!i){let u=mi(e);u&&(i=!rg(u,s.host))}switch(n){case".mjs":case".mts":case".d.mts":return t&1&&o(".mts",n===".mts"||n===".d.mts")||t&4&&o(".d.mts",n===".mts"||n===".d.mts")||t&2&&o(".mjs")||void 0;case".cjs":case".cts":case".d.cts":return t&1&&o(".cts",n===".cts"||n===".d.cts")||t&4&&o(".d.cts",n===".cts"||n===".d.cts")||t&2&&o(".cjs")||void 0;case".json":return t&4&&o(".d.json.ts")||t&8&&o(".json")||void 0;case".tsx":case".jsx":return t&1&&(o(".tsx",n===".tsx")||o(".ts",n===".tsx"))||t&4&&o(".d.ts",n===".tsx")||t&2&&(o(".jsx")||o(".js"))||void 0;case".ts":case".d.ts":case".js":case"":return t&1&&(o(".ts",n===".ts"||n===".d.ts")||o(".tsx",n===".ts"||n===".d.ts"))||t&4&&o(".d.ts",n===".ts"||n===".d.ts")||t&2&&(o(".js")||o(".jsx"))||s.isConfigLookup&&o(".json")||void 0;default:return t&4&&!Mu(e+n)&&o(`.d${n}.ts`)||void 0}function o(u,m){let d=sK(e+u,i,s);return d===void 0?void 0:{path:d,ext:u,resolvedUsingTsExtension:!s.candidateIsFromPackageJsonField&&m}}}function sK(e,t,n){var i;if(!((i=n.compilerOptions.moduleSuffixes)!=null&&i.length))return vRe(e,t,n);let s=b0(e)??"",o=s?YR(e,s):e;return kt(n.compilerOptions.moduleSuffixes,u=>vRe(o+u+s,t,n))}function vRe(e,t,n){var i;if(!t){if(n.host.fileExists(e))return n.traceEnabled&&ds(n.host,v.File_0_exists_use_it_as_a_name_resolution_result,e),e;n.traceEnabled&&ds(n.host,v.File_0_does_not_exist,e)}(i=n.failedLookupLocations)==null||i.push(e)}function vge(e,t,n,i,s=!0){let o=s?Db(t,n,i):void 0,u=o&&o.contents.packageJsonContent,m=o&&SB(o,i);return XA(o,oK(e,t,n,i,u,m),i)}function aK(e,t,n,i,s){if(!s&&e.contents.resolvedEntrypoints!==void 0)return e.contents.resolvedEntrypoints;let o,u=5|(s?2:0),m=uge(t),d=$O(i?.getPackageJsonInfoCache(),n,t);d.conditions=sS(t),d.requestContainingDirectory=e.packageDirectory;let S=oK(u,e.packageDirectory,!1,d,e.contents.packageJsonContent,SB(e,d));if(o=Bt(o,S?.path),m&8&&e.contents.packageJsonContent.exports){let E=I1([sS(t,99),sS(t,1)],Vp);for(let x of E){let D={...d,failedLookupLocations:[],conditions:x,host:n},w=yTt(e,e.contents.packageJsonContent.exports,D,u);if(w)for(let R of w)o=$o(o,R.path)}}return e.contents.resolvedEntrypoints=o||!1}function yTt(e,t,n,i){let s;if(Rs(t))for(let u of t)o(u);else if(typeof t=="object"&&t!==null&&TB(t))for(let u in t)o(t[u]);else o(t);return s;function o(u){var m,d;if(typeof u=="string"&&_s(u,"./"))if(u.includes("*")&&n.host.readDirectory){if(u.indexOf("*")!==u.lastIndexOf("*"))return!1;n.host.readDirectory(e.packageDirectory,Qbt(i),void 0,[yue(AA(u,"**/*"),".*")]).forEach(S=>{s=$o(s,{path:S,ext:PP(S),resolvedUsingTsExtension:void 0})})}else{let S=hu(u).slice(2);if(S.includes("..")||S.includes(".")||S.includes("node_modules"))return!1;let E=ri(e.packageDirectory,u),x=xs(E,(d=(m=n.host).getCurrentDirectory)==null?void 0:d.call(m)),D=iK(i,x,!1,n);if(D)return s=$o(s,D,(w,R)=>w.path===R.path),!0}else if(Array.isArray(u)){for(let S of u)if(o(S))return!0}else if(typeof u=="object"&&u!==null)return kt(Ng(u),S=>{if(S==="default"||Es(n.conditions,S)||R8(n.conditions,S))return o(u[S]),!0})}}function $O(e,t,n){return{host:t,compilerOptions:n,traceEnabled:P0(n,t),failedLookupLocations:void 0,affectingLocations:void 0,packageJsonInfoCache:e,features:0,conditions:ve,requestContainingDirectory:void 0,reportDiagnostic:io,isConfigLookup:!1,candidateIsFromPackageJsonField:!1,resolvedPackageDirectory:!1}}function HO(e,t){let n=hu(e);for(n.pop();n.length>0;){let i=Db(u0(n),!1,t);if(i)return i;n.pop()}}function SB(e,t){return e.contents.versionPaths===void 0&&(e.contents.versionPaths=nTt(e.contents.packageJsonContent,t)||!1),e.contents.versionPaths||void 0}function vTt(e,t){return e.contents.peerDependencies===void 0&&(e.contents.peerDependencies=STt(e,t)||!1),e.contents.peerDependencies||void 0}function STt(e,t){let n=oge(e.contents.packageJsonContent,"peerDependencies","object",t);if(n===void 0)return;t.traceEnabled&&ds(t.host,v.package_json_has_a_peerDependencies_field);let i=mRe(e.packageDirectory,t.host,t.traceEnabled),s=i.substring(0,i.lastIndexOf("node_modules")+12)+Ec,o="";for(let u in n)if(Ho(n,u)){let m=Db(s+u,!1,t);if(m){let d=m.contents.packageJsonContent.version;o+=`+${u}@${d}`,t.traceEnabled&&ds(t.host,v.Found_peerDependency_0_with_1_version,u,d)}else t.traceEnabled&&ds(t.host,v.Failed_to_find_peerDependency_0,u)}return o}function Db(e,t,n){var i,s,o,u,m,d;let{host:S,traceEnabled:E}=n,x=ri(e,"package.json");if(t){(i=n.failedLookupLocations)==null||i.push(x);return}let D=(s=n.packageJsonInfoCache)==null?void 0:s.getPackageJsonInfo(x);if(D!==void 0){if(hB(D))return E&&ds(S,v.File_0_exists_according_to_earlier_cached_lookups,x),(o=n.affectingLocations)==null||o.push(x),D.packageDirectory===e?D:{packageDirectory:e,contents:D.contents};D.directoryExists&&E&&ds(S,v.File_0_does_not_exist_according_to_earlier_cached_lookups,x),(u=n.failedLookupLocations)==null||u.push(x);return}let w=rg(e,S);if(w&&S.fileExists(x)){let R=XI(x,S);E&&ds(S,v.Found_package_json_at_0,x);let L={packageDirectory:e,contents:{packageJsonContent:R,versionPaths:void 0,resolvedEntrypoints:void 0,peerDependencies:void 0}};return n.packageJsonInfoCache&&!n.packageJsonInfoCache.isReadonly&&n.packageJsonInfoCache.setPackageJsonInfo(x,L),(m=n.affectingLocations)==null||m.push(x),L}else w&&E&&ds(S,v.File_0_does_not_exist,x),n.packageJsonInfoCache&&!n.packageJsonInfoCache.isReadonly&&n.packageJsonInfoCache.setPackageJsonInfo(x,{packageDirectory:e,directoryExists:w}),(d=n.failedLookupLocations)==null||d.push(x)}function oK(e,t,n,i,s,o){let u;s&&(i.isConfigLookup?u=eTt(s,t,i):u=e&4&&Zbt(s,t,i)||e&7&&tTt(s,t,i)||void 0);let m=(D,w,R,L)=>{let F=iK(D,w,R,L);if(F)return XY(F);let J=D===4?5:D,G=L.features,q=L.candidateIsFromPackageJsonField;L.candidateIsFromPackageJsonField=!0,s?.type!=="module"&&(L.features&=-33);let ee=nK(J,w,R,L,!1);return L.features=G,L.candidateIsFromPackageJsonField=q,ee},d=u?!rg(mi(u),i.host):void 0,S=n||!rg(t,i.host),E=ri(t,i.isConfigLookup?"tsconfig":"index");if(o&&(!u||Cm(t,u))){let D=Xm(t,u||E,!1);i.traceEnabled&&ds(i.host,v.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2,o.version,se,D);let w=Sge(e,D,t,o.paths,void 0,m,d||S,i);if(w)return iRe(w.value)}let x=u&&iRe(m(e,u,d,i));if(x)return x;if(!(i.features&32))return ON(e,E,S,i)}function SRe(e,t){return e&2&&(t===".js"||t===".jsx"||t===".mjs"||t===".cjs")||e&1&&(t===".ts"||t===".tsx"||t===".mts"||t===".cts")||e&4&&(t===".d.ts"||t===".d.mts"||t===".d.cts")||e&8&&t===".json"||!1}function bB(e){let t=e.indexOf(Ec);return e[0]==="@"&&(t=e.indexOf(Ec,t+1)),t===-1?{packageName:e,rest:""}:{packageName:e.slice(0,t),rest:e.slice(t+1)}}function TB(e){return wi(Ng(e),t=>_s(t,"."))}function bTt(e){return!Pt(Ng(e),t=>_s(t,"."))}function TTt(e,t,n,i,s,o){var u,m;let d=xs(ri(n,"dummy"),(m=(u=i.host).getCurrentDirectory)==null?void 0:m.call(u)),S=HO(d,i);if(!S||!S.contents.packageJsonContent.exports||typeof S.contents.packageJsonContent.name!="string")return;let E=hu(t),x=hu(S.contents.packageJsonContent.name);if(!wi(x,(F,J)=>E[J]===F))return;let D=E.slice(x.length),w=wt(D)?`.${Ec}${D.join(Ec)}`:".";if(H1(i.compilerOptions)&&!Nb(n))return cK(S,e,w,i,s,o);let R=e&5,L=e&-6;return cK(S,R,w,i,s,o)||cK(S,L,w,i,s,o)}function cK(e,t,n,i,s,o){if(e.contents.packageJsonContent.exports){if(n==="."){let u;if(typeof e.contents.packageJsonContent.exports=="string"||Array.isArray(e.contents.packageJsonContent.exports)||typeof e.contents.packageJsonContent.exports=="object"&&bTt(e.contents.packageJsonContent.exports)?u=e.contents.packageJsonContent.exports:Ho(e.contents.packageJsonContent.exports,".")&&(u=e.contents.packageJsonContent.exports["."]),u)return TRe(t,i,s,o,n,e,!1)(u,"",!1,".")}else if(TB(e.contents.packageJsonContent.exports)){if(typeof e.contents.packageJsonContent.exports!="object")return i.traceEnabled&&ds(i.host,v.Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1,n,e.packageDirectory),Kp(void 0);let u=bRe(t,i,s,o,n,e.contents.packageJsonContent.exports,e,!1);if(u)return u}return i.traceEnabled&&ds(i.host,v.Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1,n,e.packageDirectory),Kp(void 0)}}function ETt(e,t,n,i,s,o){var u,m;if(t==="#"||_s(t,"#/"))return i.traceEnabled&&ds(i.host,v.Invalid_import_specifier_0_has_no_possible_resolutions,t),Kp(void 0);let d=xs(ri(n,"dummy"),(m=(u=i.host).getCurrentDirectory)==null?void 0:m.call(u)),S=HO(d,i);if(!S)return i.traceEnabled&&ds(i.host,v.Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve,d),Kp(void 0);if(!S.contents.packageJsonContent.imports)return i.traceEnabled&&ds(i.host,v.package_json_scope_0_has_no_imports_defined,S.packageDirectory),Kp(void 0);let E=bRe(e,i,s,o,t,S.contents.packageJsonContent.imports,S,!0);return E||(i.traceEnabled&&ds(i.host,v.Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1,t,S.packageDirectory),Kp(void 0))}function lK(e,t){let n=e.indexOf("*"),i=t.indexOf("*"),s=n===-1?e.length:n+1,o=i===-1?t.length:i+1;return s>o?-1:o>s||n===-1?1:i===-1||e.length>t.length?-1:t.length>e.length?1:0}function bRe(e,t,n,i,s,o,u,m){let d=TRe(e,t,n,i,s,u,m);if(!Wc(s,Ec)&&!s.includes("*")&&Ho(o,s)){let x=o[s];return d(x,"",!1,s)}let S=pa(Zn(Ng(o),x=>xTt(x)||Wc(x,"/")),lK);for(let x of S)if(t.features&16&&E(x,s)){let D=o[x],w=x.indexOf("*"),R=s.substring(x.substring(0,w).length,s.length-(x.length-1-w));return d(D,R,!0,x)}else if(Wc(x,"*")&&_s(s,x.substring(0,x.length-1))){let D=o[x],w=s.substring(x.length-1);return d(D,w,!0,x)}else if(_s(s,x)){let D=o[x],w=s.substring(x.length);return d(D,w,!1,x)}function E(x,D){if(Wc(x,"*"))return!1;let w=x.indexOf("*");return w===-1?!1:_s(D,x.substring(0,w))&&Wc(D,x.substring(w+1))}}function xTt(e){let t=e.indexOf("*");return t!==-1&&t===e.lastIndexOf("*")}function TRe(e,t,n,i,s,o,u){return m;function m(d,S,E,x){if(typeof d=="string"){if(!E&&S.length>0&&!Wc(d,"/"))return t.traceEnabled&&ds(t.host,v.package_json_scope_0_has_invalid_type_for_target_of_specifier_1,o.packageDirectory,s),Kp(void 0);if(!_s(d,"./")){if(u&&!_s(d,"../")&&!_s(d,"/")&&!ip(d)){let W=E?d.replace(/\*/g,S):d+S;aS(t,v.Using_0_subpath_1_with_target_2,"imports",x,W),aS(t,v.Resolving_module_0_from_1,W,o.packageDirectory+"/");let pe=I8(t.features,W,o.packageDirectory+"/",t.compilerOptions,t.host,n,e,!1,i,t.conditions);return Kp(pe.resolvedModule?{path:pe.resolvedModule.resolvedFileName,extension:pe.resolvedModule.extension,packageId:pe.resolvedModule.packageId,originalPath:pe.resolvedModule.originalPath,resolvedUsingTsExtension:pe.resolvedModule.resolvedUsingTsExtension}:void 0)}return t.traceEnabled&&ds(t.host,v.package_json_scope_0_has_invalid_type_for_target_of_specifier_1,o.packageDirectory,s),Kp(void 0)}let F=(qp(d)?hu(d).slice(1):hu(d)).slice(1);if(F.includes("..")||F.includes(".")||F.includes("node_modules"))return t.traceEnabled&&ds(t.host,v.package_json_scope_0_has_invalid_type_for_target_of_specifier_1,o.packageDirectory,s),Kp(void 0);let J=ri(o.packageDirectory,d),G=hu(S);if(G.includes("..")||G.includes(".")||G.includes("node_modules"))return t.traceEnabled&&ds(t.host,v.package_json_scope_0_has_invalid_type_for_target_of_specifier_1,o.packageDirectory,s),Kp(void 0);t.traceEnabled&&ds(t.host,v.Using_0_subpath_1_with_target_2,u?"imports":"exports",x,E?d.replace(/\*/g,S):d+S);let q=D(E?J.replace(/\*/g,S):J+S),ee=R(q,S,ri(o.packageDirectory,"package.json"),u);return ee||Kp(XA(o,iK(e,q,!1,t),t))}else if(typeof d=="object"&&d!==null)if(Array.isArray(d)){if(!wt(d))return t.traceEnabled&&ds(t.host,v.package_json_scope_0_has_invalid_type_for_target_of_specifier_1,o.packageDirectory,s),Kp(void 0);for(let L of d){let F=m(L,S,E,x);if(F)return F}}else{aS(t,v.Entering_conditional_exports);for(let L of Ng(d))if(L==="default"||t.conditions.includes(L)||R8(t.conditions,L)){aS(t,v.Matched_0_condition_1,u?"imports":"exports",L);let F=d[L],J=m(F,S,E,x);if(J)return aS(t,v.Resolved_under_condition_0,L),aS(t,v.Exiting_conditional_exports),J;aS(t,v.Failed_to_resolve_under_condition_0,L)}else aS(t,v.Saw_non_matching_condition_0,L);aS(t,v.Exiting_conditional_exports);return}else if(d===null)return t.traceEnabled&&ds(t.host,v.package_json_scope_0_explicitly_maps_specifier_1_to_null,o.packageDirectory,s),Kp(void 0);return t.traceEnabled&&ds(t.host,v.package_json_scope_0_has_invalid_type_for_target_of_specifier_1,o.packageDirectory,s),Kp(void 0);function D(L){var F,J;return L===void 0?L:xs(L,(J=(F=t.host).getCurrentDirectory)==null?void 0:J.call(F))}function w(L,F){return yu(ri(L,F))}function R(L,F,J,G){var q,ee,W,pe;if(!t.isConfigLookup&&(t.compilerOptions.declarationDir||t.compilerOptions.outDir)&&!L.includes("/node_modules/")&&(!t.compilerOptions.configFile||Cm(o.packageDirectory,D(t.compilerOptions.configFile.fileName),!uK(t)))){let re=Pv({useCaseSensitiveFileNames:()=>uK(t)}),ue=[];if(t.compilerOptions.rootDir||t.compilerOptions.composite&&t.compilerOptions.configFilePath){let ce=D(s6(t.compilerOptions,()=>[],((ee=(q=t.host).getCurrentDirectory)==null?void 0:ee.call(q))||"",re));ue.push(ce)}else if(t.requestContainingDirectory){let ce=D(ri(t.requestContainingDirectory,"index.ts")),ne=D(s6(t.compilerOptions,()=>[ce,D(J)],((pe=(W=t.host).getCurrentDirectory)==null?void 0:pe.call(W))||"",re));ue.push(ne);let le=yu(ne);for(;le&&le.length>1;){let me=hu(le);me.pop();let de=u0(me);ue.unshift(de),le=yu(de)}}ue.length>1&&t.reportDiagnostic(Nc(G?v.The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate:v.The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate,F===""?".":F,J));for(let ce of ue){let ne=K(ce);for(let le of ne)if(Cm(le,L,!uK(t))){let me=L.slice(le.length+1),de=ri(ce,me),Ae=[".mjs",".cjs",".js",".json",".d.mts",".d.cts",".d.ts"];for(let xe of Ae)if(Ic(de,xe)){let te=Pfe(de);for(let he of te){if(!SRe(e,he))continue;let be=b3(de,he,xe,!uK(t));if(t.host.fileExists(be))return Kp(XA(o,iK(e,be,!1,t),t))}}}}}return;function K(re){var ue,ce;let ne=t.compilerOptions.configFile?((ce=(ue=t.host).getCurrentDirectory)==null?void 0:ce.call(ue))||"":re,le=[];return t.compilerOptions.declarationDir&&le.push(D(w(ne,t.compilerOptions.declarationDir))),t.compilerOptions.outDir&&t.compilerOptions.outDir!==t.compilerOptions.declarationDir&&le.push(D(w(ne,t.compilerOptions.outDir))),le}}}}function R8(e,t){if(!e.includes("types")||!_s(t,"types@"))return!1;let n=s5.tryParse(t.substring(6));return n?n.test(se):!1}function ERe(e,t,n,i,s,o){return xRe(e,t,n,i,!1,s,o)}function CTt(e,t,n){return xRe(4,e,t,n,!0,void 0,void 0)}function xRe(e,t,n,i,s,o,u){let m=i.features===0?void 0:i.features&32?99:1,d=e&5,S=e&-6;if(d){aS(i,v.Searching_all_ancestor_node_modules_directories_for_preferred_extensions_Colon_0,dB(d));let x=E(d);if(x)return x}if(S&&!s)return aS(i,v.Searching_all_ancestor_node_modules_directories_for_fallback_extensions_Colon_0,dB(S)),E(S);function E(x){return Am(qu(n),D=>{if(Ul(D)!=="node_modules"){let w=PRe(o,t,m,D,u,i);return w||Kp(CRe(x,t,D,i,s,o,u))}})}}function CRe(e,t,n,i,s,o,u){let m=ri(n,"node_modules"),d=rg(m,i.host);if(!d&&i.traceEnabled&&ds(i.host,v.Directory_0_does_not_exist_skipping_all_lookups_in_it,m),!s){let S=ARe(e,t,m,d,i,o,u);if(S)return S}if(e&4){let S=ri(m,"@types"),E=d;return d&&!rg(S,i.host)&&(i.traceEnabled&&ds(i.host,v.Directory_0_does_not_exist_skipping_all_lookups_in_it,S),E=!1),ARe(4,kRe(t,i),S,E,i,o,u)}}function ARe(e,t,n,i,s,o,u){var m,d;let S=Zs(ri(n,t)),{packageName:E,rest:x}=bB(t),D=ri(n,E),w,R=Db(S,!i,s);if(x!==""&&R&&(!(s.features&8)||!Ho(((m=w=Db(D,!i,s))==null?void 0:m.contents.packageJsonContent)??ve,"exports"))){let J=ON(e,S,!i,s);if(J)return XY(J);let G=oK(e,S,!i,s,R.contents.packageJsonContent,SB(R,s));return XA(R,G,s)}let L=(J,G,q,ee)=>{let W=(x||!(ee.features&32))&&ON(J,G,q,ee)||oK(J,G,q,ee,R&&R.contents.packageJsonContent,R&&SB(R,ee));return!W&&R&&(R.contents.packageJsonContent.exports===void 0||R.contents.packageJsonContent.exports===null)&&ee.features&32&&(W=ON(J,ri(G,"index.js"),q,ee)),XA(R,W,ee)};if(x!==""&&(R=w??Db(D,!i,s)),R&&(s.resolvedPackageDirectory=!0),R&&R.contents.packageJsonContent.exports&&s.features&8)return(d=cK(R,e,ri(".",x),s,o,u))==null?void 0:d.value;let F=x!==""&&R?SB(R,s):void 0;if(F){s.traceEnabled&&ds(s.host,v.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2,F.version,se,x);let J=i&&rg(D,s.host),G=Sge(e,x,D,F.paths,void 0,L,!J,s);if(G)return G.value}return L(e,S,!i,s)}function Sge(e,t,n,i,s,o,u,m){s||(s=cj(i));let d=AG(s,t);if(d){let S=bs(d)?void 0:Qce(d,t),E=bs(d)?d:Xce(d);return m.traceEnabled&&ds(m.host,v.Module_name_0_matched_pattern_1,t,E),{value:kt(i[E],D=>{let w=S?AA(D,S):D,R=Zs(ri(n,w));m.traceEnabled&&ds(m.host,v.Trying_substitution_0_candidate_module_location_Colon_1,D,w);let L=b0(D);if(L!==void 0){let F=sK(R,u,m);if(F!==void 0)return XY({path:F,ext:L,resolvedUsingTsExtension:void 0})}return o(e,R,u||!rg(mi(R),m.host),m)})}}}var bge="__";function kRe(e,t){let n=RN(e);return t.traceEnabled&&n!==e&&ds(t.host,v.Scoped_package_detected_looking_in_0,n),n}function EB(e){return`@types/${RN(e)}`}function RN(e){if(_s(e,"@")){let t=e.replace(Ec,bge);if(t!==e)return t.slice(1)}return e}function GO(e){let t=Yw(e,"@types/");return t!==e?M8(t):e}function M8(e){return e.includes(bge)?"@"+e.replace(bge,Ec):e}function PRe(e,t,n,i,s,o){let u=e&&e.getFromNonRelativeNameCache(t,n,i,s);if(u)return o.traceEnabled&&ds(o.host,v.Resolution_for_module_0_was_found_in_cache_from_location_1,t,i),o.resultFromCache=u,{value:u.resolvedModule&&{path:u.resolvedModule.resolvedFileName,originalPath:u.resolvedModule.originalPath||!0,extension:u.resolvedModule.extension,packageId:u.resolvedModule.packageId,resolvedUsingTsExtension:u.resolvedModule.resolvedUsingTsExtension}}}function Tge(e,t,n,i,s,o){let u=P0(n,i),m=[],d=[],S=mi(t),E=[],x={compilerOptions:n,host:i,traceEnabled:u,failedLookupLocations:m,affectingLocations:d,packageJsonInfoCache:s,features:0,conditions:[],requestContainingDirectory:S,reportDiagnostic:R=>void E.push(R),isConfigLookup:!1,candidateIsFromPackageJsonField:!1,resolvedPackageDirectory:!1},D=w(5)||w(2|(n.resolveJsonModule?8:0));return sRe(e,D&&D.value,D?.value&&Nb(D.value.path),m,d,E,x,s);function w(R){let L=fRe(R,e,S,yge,x);if(L)return{value:L};if(vu(e)){let F=Zs(ri(S,e));return Kp(yge(R,F,!1,x))}else{let F=Am(S,J=>{let G=PRe(s,e,void 0,J,o,x);if(G)return G;let q=Zs(ri(J,e));return Kp(yge(R,q,!1,x))});if(F)return F;if(R&5){let J=CTt(e,S,x);return R&4&&(J??(J=NRe(e,x))),J}}}}function NRe(e,t){if(t.compilerOptions.typeRoots)for(let n of t.compilerOptions.typeRoots){let i=cRe(n,e,t),s=rg(n,t.host);!s&&t.traceEnabled&&ds(t.host,v.Directory_0_does_not_exist_skipping_all_lookups_in_it,n);let o=ON(4,i,!s,t);if(o){let m=O8(o.path),d=m?Db(m,!1,t):void 0;return Kp(XA(d,o,t))}let u=vge(4,i,!s,t);if(u)return Kp(u)}}function MN(e,t){return!!e.allowImportingTsExtensions||t&&Mu(t)}function Ege(e,t,n,i,s,o){let u=P0(n,i);u&&ds(i,v.Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2,t,e,s);let m=[],d=[],S=[],E={compilerOptions:n,host:i,traceEnabled:u,failedLookupLocations:m,affectingLocations:d,packageJsonInfoCache:o,features:0,conditions:[],requestContainingDirectory:void 0,reportDiagnostic:D=>void S.push(D),isConfigLookup:!1,candidateIsFromPackageJsonField:!1,resolvedPackageDirectory:!1},x=CRe(4,e,s,E,!1,void 0,void 0);return aRe(x,!0,m,d,S,E.resultFromCache,void 0)}function Kp(e){return e!==void 0?{value:e}:void 0}function aS(e,t,...n){e.traceEnabled&&ds(e.host,t,...n)}function uK(e){return e.host.useCaseSensitiveFileNames?typeof e.host.useCaseSensitiveFileNames=="boolean"?e.host.useCaseSensitiveFileNames:e.host.useCaseSensitiveFileNames():!0}var xge=(e=>(e[e.NonInstantiated=0]="NonInstantiated",e[e.Instantiated=1]="Instantiated",e[e.ConstEnumOnly=2]="ConstEnumOnly",e))(xge||{});function N0(e,t){return e.body&&!e.body.parent&&(lo(e.body,e),T0(e.body,!1)),e.body?Cge(e.body,t):1}function Cge(e,t=new Map){let n=yo(e);if(t.has(n))return t.get(n)||0;t.set(n,void 0);let i=ATt(e,t);return t.set(n,i),i}function ATt(e,t){switch(e.kind){case 264:case 265:return 0;case 266:if(KT(e))return 2;break;case 272:case 271:if(!li(e,32))return 0;break;case 278:let n=e;if(!n.moduleSpecifier&&n.exportClause&&n.exportClause.kind===279){let i=0;for(let s of n.exportClause.elements){let o=kTt(s,t);if(o>i&&(i=o),i===1)return i}return i}break;case 268:{let i=0;return Js(e,s=>{let o=Cge(s,t);switch(o){case 0:return;case 2:i=2;return;case 1:return i=1,!0;default:M.assertNever(o)}}),i}case 267:return N0(e,t);case 80:if(e.flags&4096)return 0}return 1}function kTt(e,t){let n=e.propertyName||e.name,i=e.parent;for(;i;){if(Vs(i)||Hg(i)||Ji(i)){let s=i.statements,o;for(let u of s)if(w3(u,n)){u.parent||(lo(u,i),T0(u,!1));let m=Cge(u,t);if((o===void 0||m>o)&&(o=m),o===1)return o;u.kind===271&&(o=1)}if(o!==void 0)return o}i=i.parent}return 1}var Age=(e=>(e[e.None=0]="None",e[e.IsContainer=1]="IsContainer",e[e.IsBlockScopedContainer=2]="IsBlockScopedContainer",e[e.IsControlFlowContainer=4]="IsControlFlowContainer",e[e.IsFunctionLike=8]="IsFunctionLike",e[e.IsFunctionExpression=16]="IsFunctionExpression",e[e.HasLocals=32]="HasLocals",e[e.IsInterface=64]="IsInterface",e[e.IsObjectLiteralOrClassExpressionMethodOrAccessor=128]="IsObjectLiteralOrClassExpressionMethodOrAccessor",e))(Age||{});function Wh(e,t,n){return M.attachFlowNodeDebugInfo({flags:e,id:0,node:t,antecedent:n})}var PTt=NTt();function kge(e,t){var n,i;jc("beforeBind"),(n=rf)==null||n.logStartBindFile(""+e.fileName),PTt(e,t),(i=rf)==null||i.logStopBindFile(),jc("afterBind"),vd("Bind","beforeBind","afterBind")}function NTt(){var e,t,n,i,s,o,u,m,d,S,E,x,D,w,R,L,F,J,G,q,ee,W,pe,K,re=!1,ue=0,ce,ne,le=Wh(1,void 0,void 0),me=Wh(1,void 0,void 0),de=bt();return xe;function Ae($,Fe,...jt){return bd(Ur($)||e,$,Fe,...jt)}function xe($,Fe){var jt,Xr;e=$,t=Fe,n=Ka(t),K=te(e,Fe),ne=new Set,ue=0,ce=Hu.getSymbolConstructor(),M.attachFlowNodeDebugInfo(le),M.attachFlowNodeDebugInfo(me),e.locals||((jt=Cn)==null||jt.push(Cn.Phase.Bind,"bindSourceFile",{path:e.path},!0),pr(e),(Xr=Cn)==null||Xr.pop(),e.symbolCount=ue,e.classifiableNames=ne,Eu(),kc()),e=void 0,t=void 0,n=void 0,i=void 0,s=void 0,o=void 0,u=void 0,m=void 0,d=void 0,E=void 0,S=!1,x=void 0,D=void 0,w=void 0,R=void 0,L=void 0,F=void 0,J=void 0,q=void 0,ee=!1,W=!1,re=!1,pe=0}function te($,Fe){return J_(Fe,"alwaysStrict")&&!$.isDeclarationFile?!0:!!$.externalModuleIndicator}function he($,Fe){return ue++,new ce($,Fe)}function be($,Fe,jt){$.flags|=jt,Fe.symbol=$,$.declarations=$o($.declarations,Fe),jt&1955&&!$.exports&&($.exports=fa()),jt&6240&&!$.members&&($.members=fa()),$.constEnumOnlyModule&&$.flags&304&&($.constEnumOnlyModule=!1),jt&111551&&SR($,Fe)}function Ve($){if($.kind===277)return $.isExportEquals?"export=":"default";let Fe=Ps($);if(Fe){if(B_($)){let jt=Qd(Fe);return Rg($)?"__global":`"${jt}"`}if(Fe.kind===167){let jt=Fe.expression;if(zp(jt))return Uc(jt.text);if(b9(jt))return Sa(jt.operator)+jt.operand.text;M.fail("Only computed properties with literal names have declaration names")}if(Zi(Fe)){let jt=Ou($);if(!jt)return;let Xr=jt.symbol;return DR(Xr,Fe.escapedText)}return sg(Fe)?xA(Fe):jg(Fe)?JI(Fe):void 0}switch($.kind){case 176:return"__constructor";case 184:case 179:case 323:return"__call";case 185:case 180:return"__new";case 181:return"__index";case 278:return"__export";case 307:return"export=";case 226:if(cl($)===2)return"export=";M.fail("Unknown binary declaration kind");break;case 317:return XP($)?"__new":"__call";case 169:return M.assert($.parent.kind===317,"Impossible parameter parent kind",()=>`parent is: ${M.formatSyntaxKind($.parent.kind)}, expected JSDocFunctionType`),"arg"+$.parent.parameters.indexOf($)}}function Pe($){return Wu($)?Yo($.name):Qi(M.checkDefined(Ve($)))}function ke($,Fe,jt,Xr,Mi,Us,Ss){M.assert(Ss||!h0(jt));let zs=li(jt,2048)||b_(jt)&&jt.name.escapedText==="default",vo=Ss?"__computed":zs&&Fe?"default":Ve(jt),Wa;if(vo===void 0)Wa=he(0,"__missing");else if(Wa=$.get(vo),Xr&2885600&&ne.add(vo),!Wa)$.set(vo,Wa=he(0,vo)),Us&&(Wa.isReplaceableByMethod=!0);else{if(Us&&!Wa.isReplaceableByMethod)return Wa;if(Wa.flags&Mi){if(Wa.isReplaceableByMethod)$.set(vo,Wa=he(0,vo));else if(!(Xr&3&&Wa.flags&67108864)){Wu(jt)&&lo(jt.name,jt);let qc=Wa.flags&2?v.Cannot_redeclare_block_scoped_variable_0:v.Duplicate_identifier_0,Id=!0;(Wa.flags&384||Xr&384)&&(qc=v.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations,Id=!1);let Om=!1;wt(Wa.declarations)&&(zs||Wa.declarations&&Wa.declarations.length&&jt.kind===277&&!jt.isExportEquals)&&(qc=v.A_module_cannot_have_multiple_default_exports,Id=!1,Om=!0);let Xh=[];im(jt)&&$c(jt.type)&&li(jt,32)&&Wa.flags&2887656&&Xh.push(Ae(jt,v.Did_you_mean_0,`export type { ${Qi(jt.name.escapedText)} }`));let Vy=Ps(jt)||jt;kt(Wa.declarations,(Jy,Od)=>{let od=Ps(Jy)||Jy,Vo=Id?Ae(od,qc,Pe(Jy)):Ae(od,qc);e.bindDiagnostics.push(Om?ca(Vo,Ae(Vy,Od===0?v.Another_export_default_is_here:v.and_here)):Vo),Om&&Xh.push(Ae(od,v.The_first_export_default_is_here))});let $v=Id?Ae(Vy,qc,Pe(jt)):Ae(Vy,qc);e.bindDiagnostics.push(ca($v,...Xh)),Wa=he(0,vo)}}}return be(Wa,jt,Xr),Wa.parent?M.assert(Wa.parent===Fe,"Existing symbol parent should match new one"):Wa.parent=Fe,Wa}function De($,Fe,jt){let Xr=!!(eb($)&32)||Be($);if(Fe&2097152)return $.kind===281||$.kind===271&&Xr?ke(s.symbol.exports,s.symbol,$,Fe,jt):(M.assertNode(s,Lh),ke(s.locals,void 0,$,Fe,jt));if(Xd($)&&M.assert(hn($)),!B_($)&&(Xr||s.flags&128)){if(!Lh(s)||!s.locals||li($,2048)&&!Ve($))return ke(s.symbol.exports,s.symbol,$,Fe,jt);let Mi=Fe&111551?1048576:0,Us=ke(s.locals,void 0,$,Mi,jt);return Us.exportSymbol=ke(s.symbol.exports,s.symbol,$,Fe,jt),$.localSymbol=Us,Us}else return M.assertNode(s,Lh),ke(s.locals,void 0,$,Fe,jt)}function Be($){if($.parent&&El($)&&($=$.parent),!Xd($))return!1;if(!d8($)&&$.fullName)return!0;let Fe=Ps($);return Fe?!!(UR(Fe.parent)&&wd(Fe.parent)||u_(Fe.parent)&&eb(Fe.parent)&32):!1}function ct($,Fe){let jt=s,Xr=o,Mi=u;if(Fe&1?($.kind!==219&&(o=s),s=u=$,Fe&32&&(s.locals=fa(),Yn(s))):Fe&2&&(u=$,Fe&32&&(u.locals=void 0)),Fe&4){let Us=x,Ss=D,zs=w,vo=R,Wa=J,qc=q,Id=ee,Om=Fe&16&&!li($,1024)&&!$.asteriskToken&&!!QT($)||$.kind===175;Om||(x=Wh(2,void 0,void 0),Fe&144&&(x.node=$)),R=Om||$.kind===176||hn($)&&($.kind===262||$.kind===218)?ur():void 0,J=void 0,D=void 0,w=void 0,q=void 0,ee=!1,_t($),$.flags&=-5633,!(x.flags&1)&&Fe&8&&Yd($.body)&&($.flags|=512,ee&&($.flags|=1024),$.endFlowNode=x),$.kind===307&&($.flags|=pe,$.endFlowNode=x),R&&(Sr(R,x),x=$r(R),($.kind===176||$.kind===175||hn($)&&($.kind===262||$.kind===218))&&($.returnFlowNode=x)),Om||(x=Us),D=Ss,w=zs,R=vo,J=Wa,q=qc,ee=Id}else Fe&64?(S=!1,_t($),M.assertNotNode($,He),$.flags=S?$.flags|256:$.flags&-257):_t($);s=jt,o=Xr,u=Mi}function qe($){et($,Fe=>Fe.kind===262?pr(Fe):void 0),et($,Fe=>Fe.kind!==262?pr(Fe):void 0)}function et($,Fe=pr){$!==void 0&&kt($,Fe)}function Ie($){Js($,pr,et)}function _t($){let Fe=re;if(re=!1,Si($)){Ie($),Jn($),re=Fe;return}switch($.kind>=243&&$.kind<=259&&(!t.allowUnreachableCode||$.kind===253)&&($.flowNode=x),$.kind){case 247:la($);break;case 246:Gs($);break;case 248:yr($);break;case 249:case 250:to($);break;case 245:lt($);break;case 253:case 257:St($);break;case 252:case 251:Ce($);break;case 258:nt($);break;case 255:Me($);break;case 269:tt($);break;case 296:ft($);break;case 244:tr($);break;case 256:At($);break;case 224:nr($);break;case 225:Z($);break;case 226:if(Dv($)){re=Fe,Ge($);return}de($);break;case 220:Q($);break;case 227:Ke($);break;case 260:Ue($);break;case 211:case 212:Ki($);break;case 213:ls($);break;case 235:In($);break;case 346:case 338:case 340:$t($);break;case 351:dr($);break;case 307:{qe($.statements),pr($.endOfFileToken);break}case 241:case 268:qe($.statements);break;case 208:Te($);break;case 169:Re($);break;case 210:case 209:case 303:case 230:re=Fe;default:Ie($);break}Jn($),re=Fe}function mt($){switch($.kind){case 80:case 110:return!0;case 211:case 212:return ht($);case 213:return rr($);case 217:if(m2($))return!1;case 235:return mt($.expression);case 226:return xr($);case 224:return $.operator===54&&mt($.operand);case 221:return mt($.expression)}return!1}function Xe($){switch($.kind){case 80:case 110:case 108:case 236:return!0;case 211:case 217:case 235:return Xe($.expression);case 212:return(zp($.argumentExpression)||nc($.argumentExpression))&&Xe($.expression);case 226:return $.operatorToken.kind===28&&Xe($.right)||y0($.operatorToken.kind)&&xf($.left)}return!1}function ht($){return Xe($)||S_($)&&ht($.expression)}function rr($){if($.arguments){for(let Fe of $.arguments)if(ht(Fe))return!0}return!!($.expression.kind===211&&ht($.expression.expression))}function vr($,Fe){return vN($)&&jr($.expression)&&No(Fe)}function xr($){switch($.operatorToken.kind){case 64:case 76:case 77:case 78:return ht($.left);case 35:case 36:case 37:case 38:return jr($.left)||jr($.right)||vr($.right,$.left)||vr($.left,$.right)||bI($.right)&&mt($.left)||bI($.left)&&mt($.right);case 104:return jr($.left);case 103:return mt($.right);case 28:return mt($.right)}return!1}function jr($){switch($.kind){case 217:return jr($.expression);case 226:switch($.operatorToken.kind){case 64:return jr($.left);case 28:return jr($.right)}}return ht($)}function ur(){return Wh(4,void 0,void 0)}function or(){return Wh(8,void 0,void 0)}function Zr($,Fe,jt){return Wh(1024,{target:$,antecedents:Fe},jt)}function Oi($){$.flags|=$.flags&2048?4096:2048}function Sr($,Fe){!(Fe.flags&1)&&!Es($.antecedent,Fe)&&(($.antecedent||($.antecedent=[])).push(Fe),Oi(Fe))}function Pi($,Fe,jt){return Fe.flags&1?Fe:jt?(jt.kind===112&&$&64||jt.kind===97&&$&32)&&!k5(jt)&&!R$(jt.parent)?le:mt(jt)?(Oi(Fe),Wh($,jt,Fe)):Fe:$&32?Fe:le}function Cs($,Fe,jt,Xr){return Oi($),Wh(128,{switchStatement:Fe,clauseStart:jt,clauseEnd:Xr},$)}function ss($,Fe,jt){Oi(Fe),W=!0;let Xr=Wh($,jt,Fe);return J&&Sr(J,Xr),Xr}function Ii($,Fe){return Oi($),W=!0,Wh(512,Fe,$)}function $r($){let Fe=$.antecedent;return Fe?Fe.length===1?Fe[0]:$:le}function Xs($){let Fe=$.parent;switch(Fe.kind){case 245:case 247:case 246:return Fe.expression===$;case 248:case 227:return Fe.condition===$}return!1}function $e($){for(;;)if($.kind===217)$=$.expression;else if($.kind===224&&$.operator===54)$=$.operand;else return jR($)}function Yt($){return QH(So($))}function Vr($){for(;uf($.parent)||tS($.parent)&&$.parent.operator===54;)$=$.parent;return!Xs($)&&!$e($.parent)&&!(S_($.parent)&&$.parent.expression===$)}function An($,Fe,jt,Xr){let Mi=L,Us=F;L=jt,F=Xr,$(Fe),L=Mi,F=Us}function vi($,Fe,jt){An(pr,$,Fe,jt),(!$||!Yt($)&&!$e($)&&!(S_($)&&mI($)))&&(Sr(Fe,Pi(32,x,$)),Sr(jt,Pi(64,x,$)))}function Ci($,Fe,jt){let Xr=D,Mi=w;D=Fe,w=jt,pr($),D=Xr,w=Mi}function Ui($,Fe){let jt=q;for(;jt&&$.parent.kind===256;)jt.continueTarget=Fe,jt=jt.next,$=$.parent;return Fe}function la($){let Fe=Ui($,or()),jt=ur(),Xr=ur();Sr(Fe,x),x=Fe,vi($.expression,jt,Xr),x=$r(jt),Ci($.statement,Xr,Fe),Sr(Fe,x),x=$r(Xr)}function Gs($){let Fe=or(),jt=Ui($,ur()),Xr=ur();Sr(Fe,x),x=Fe,Ci($.statement,Xr,jt),Sr(jt,x),x=$r(jt),vi($.expression,Fe,Xr),x=$r(Xr)}function yr($){let Fe=Ui($,or()),jt=ur(),Xr=ur();pr($.initializer),Sr(Fe,x),x=Fe,vi($.condition,jt,Xr),x=$r(jt),Ci($.statement,Xr,Fe),pr($.incrementor),Sr(Fe,x),x=$r(Xr)}function to($){let Fe=Ui($,or()),jt=ur();pr($.expression),Sr(Fe,x),x=Fe,$.kind===250&&pr($.awaitModifier),Sr(jt,x),pr($.initializer),$.initializer.kind!==261&&Ut($.initializer),Ci($.statement,jt,Fe),Sr(Fe,x),x=$r(jt)}function lt($){let Fe=ur(),jt=ur(),Xr=ur();vi($.expression,Fe,jt),x=$r(Fe),pr($.thenStatement),Sr(Xr,x),x=$r(jt),pr($.elseStatement),Sr(Xr,x),x=$r(Xr)}function St($){pr($.expression),$.kind===253&&(ee=!0,R&&Sr(R,x)),x=le,W=!0}function fe($){for(let Fe=q;Fe;Fe=Fe.next)if(Fe.name===$)return Fe}function vt($,Fe,jt){let Xr=$.kind===252?Fe:jt;Xr&&(Sr(Xr,x),x=le,W=!0)}function Ce($){if(pr($.label),$.label){let Fe=fe($.label.escapedText);Fe&&(Fe.referenced=!0,vt($,Fe.breakTarget,Fe.continueTarget))}else vt($,D,w)}function nt($){let Fe=R,jt=J,Xr=ur(),Mi=ur(),Us=ur();if($.finallyBlock&&(R=Mi),Sr(Us,x),J=Us,pr($.tryBlock),Sr(Xr,x),$.catchClause&&(x=$r(Us),Us=ur(),Sr(Us,x),J=Us,pr($.catchClause),Sr(Xr,x)),R=Fe,J=jt,$.finallyBlock){let Ss=ur();Ss.antecedent=ps(ps(Xr.antecedent,Us.antecedent),Mi.antecedent),x=Ss,pr($.finallyBlock),x.flags&1?x=le:(R&&Mi.antecedent&&Sr(R,Zr(Ss,Mi.antecedent,x)),J&&Us.antecedent&&Sr(J,Zr(Ss,Us.antecedent,x)),x=Xr.antecedent?Zr(Ss,Xr.antecedent,x):le)}else x=$r(Xr)}function Me($){let Fe=ur();pr($.expression);let jt=D,Xr=G;D=Fe,G=x,pr($.caseBlock),Sr(Fe,x);let Mi=kt($.caseBlock.clauses,Us=>Us.kind===297);$.possiblyExhaustive=!Mi&&!Fe.antecedent,Mi||Sr(Fe,Cs(G,$,0,0)),D=jt,G=Xr,x=$r(Fe)}function tt($){let Fe=$.clauses,jt=$.parent.expression.kind===112||mt($.parent.expression),Xr=le;for(let Mi=0;Mi<Fe.length;Mi++){let Us=Mi;for(;!Fe[Mi].statements.length&&Mi+1<Fe.length;)Xr===le&&(x=G),pr(Fe[Mi]),Mi++;let Ss=ur();Sr(Ss,jt?Cs(G,$.parent,Us,Mi+1):G),Sr(Ss,Xr),x=$r(Ss);let zs=Fe[Mi];pr(zs),Xr=x,!(x.flags&1)&&Mi!==Fe.length-1&&t.noFallthroughCasesInSwitch&&(zs.fallthroughFlowNode=x)}}function ft($){let Fe=x;x=G,pr($.expression),x=Fe,et($.statements)}function tr($){pr($.expression),Oe($.expression)}function Oe($){if($.kind===213){let Fe=$;Fe.expression.kind!==108&&BR(Fe.expression)&&(x=Ii(x,Fe))}}function At($){let Fe=ur();q={next:q,name:$.label.escapedText,breakTarget:Fe,continueTarget:void 0,referenced:!1},pr($.label),pr($.statement),!q.referenced&&!t.allowUnusedLabels&&Ot(upe(t),$.label,v.Unused_label),q=q.next,Sr(Fe,x),x=$r(Fe)}function Nt($){$.kind===226&&$.operatorToken.kind===64?Ut($.left):Ut($)}function Ut($){if(Xe($))x=ss(16,x,$);else if($.kind===209)for(let Fe of $.elements)Fe.kind===230?Ut(Fe.expression):Nt(Fe);else if($.kind===210)for(let Fe of $.properties)Fe.kind===303?Nt(Fe.initializer):Fe.kind===304?Ut(Fe.name):Fe.kind===305&&Ut(Fe.expression)}function Rt($,Fe,jt){let Xr=ur();$.operatorToken.kind===56||$.operatorToken.kind===77?vi($.left,Xr,jt):vi($.left,Fe,Xr),x=$r(Xr),pr($.operatorToken),GI($.operatorToken.kind)?(An(pr,$.right,Fe,jt),Ut($.left),Sr(Fe,Pi(32,x,$)),Sr(jt,Pi(64,x,$))):vi($.right,Fe,jt)}function nr($){if($.operator===54){let Fe=L;L=F,F=Fe,Ie($),F=L,L=Fe}else Ie($),($.operator===46||$.operator===47)&&Ut($.operand)}function Z($){Ie($),($.operator===46||$.operator===47)&&Ut($.operand)}function Ge($){re?(re=!1,pr($.operatorToken),pr($.right),re=!0,pr($.left)):(re=!0,pr($.left),re=!1,pr($.operatorToken),pr($.right)),Ut($.left)}function bt(){return Kj($,Fe,jt,Xr,Mi,void 0);function $(Ss,zs){if(zs){zs.stackIndex++,lo(Ss,i);let Wa=K;Na(Ss);let qc=i;i=Ss,zs.skip=!1,zs.inStrictModeStack[zs.stackIndex]=Wa,zs.parentStack[zs.stackIndex]=qc}else zs={stackIndex:0,skip:!1,inStrictModeStack:[void 0],parentStack:[void 0]};let vo=Ss.operatorToken.kind;if(FR(vo)||GI(vo)){if(Vr(Ss)){let Wa=ur(),qc=x,Id=W;W=!1,Rt(Ss,Wa,Wa),x=W?$r(Wa):qc,W||(W=Id)}else Rt(Ss,L,F);zs.skip=!0}return zs}function Fe(Ss,zs,vo){if(!zs.skip){let Wa=Us(Ss);return vo.operatorToken.kind===28&&Oe(Ss),Wa}}function jt(Ss,zs,vo){zs.skip||pr(Ss)}function Xr(Ss,zs,vo){if(!zs.skip){let Wa=Us(Ss);return vo.operatorToken.kind===28&&Oe(Ss),Wa}}function Mi(Ss,zs){if(!zs.skip){let qc=Ss.operatorToken.kind;if(y0(qc)&&!kv(Ss)&&(Ut(Ss.left),qc===64&&Ss.left.kind===212)){let Id=Ss.left;jr(Id.expression)&&(x=ss(256,x,Ss))}}let vo=zs.inStrictModeStack[zs.stackIndex],Wa=zs.parentStack[zs.stackIndex];vo!==void 0&&(K=vo),Wa!==void 0&&(i=Wa),zs.skip=!1,zs.stackIndex--}function Us(Ss){if(Ss&&Pn(Ss)&&!Dv(Ss))return Ss;pr(Ss)}}function Q($){Ie($),$.expression.kind===211&&Ut($.expression)}function Ke($){let Fe=ur(),jt=ur(),Xr=ur(),Mi=x,Us=W;W=!1,vi($.condition,Fe,jt),x=$r(Fe),pr($.questionToken),pr($.whenTrue),Sr(Xr,x),x=$r(jt),pr($.colonToken),pr($.whenFalse),Sr(Xr,x),x=W?$r(Xr):Mi,W||(W=Us)}function z($){let Fe=pu($)?void 0:$.name;if(Hs(Fe))for(let jt of Fe.elements)z(jt);else x=ss(16,x,$)}function Ue($){Ie($),($.initializer||$x($.parent.parent))&&z($)}function Te($){pr($.dotDotDotToken),pr($.propertyName),It($.initializer),pr($.name)}function Re($){et($.modifiers),pr($.dotDotDotToken),pr($.questionToken),pr($.type),It($.initializer),pr($.name)}function It($){if(!$)return;let Fe=x;if(pr($),Fe===le||Fe===x)return;let jt=ur();Sr(jt,Fe),Sr(jt,x),x=$r(jt)}function $t($){pr($.tagName),$.kind!==340&&$.fullName&&(lo($.fullName,$),T0($.fullName,!1)),typeof $.comment!="string"&&et($.comment)}function Ht($){Ie($);let Fe=ub($);Fe&&Fe.kind!==174&&be(Fe.symbol,Fe,32)}function dr($){pr($.tagName),typeof $.comment!="string"&&et($.comment)}function qr($,Fe,jt){An(pr,$,Fe,jt),(!S_($)||mI($))&&(Sr(Fe,Pi(32,x,$)),Sr(jt,Pi(64,x,$)))}function Hr($){switch($.kind){case 211:pr($.questionDotToken),pr($.name);break;case 212:pr($.questionDotToken),pr($.argumentExpression);break;case 213:pr($.questionDotToken),et($.typeArguments),et($.arguments);break}}function dn($,Fe,jt){let Xr=dI($)?ur():void 0;qr($.expression,Xr||Fe,jt),Xr&&(x=$r(Xr)),An(Hr,$,Fe,jt),mI($)&&(Sr(Fe,Pi(32,x,$)),Sr(jt,Pi(64,x,$)))}function Ar($){if(Vr($)){let Fe=ur(),jt=x,Xr=W;dn($,Fe,Fe),x=W?$r(Fe):jt,W||(W=Xr)}else dn($,L,F)}function In($){S_($)?Ar($):Ie($)}function Ki($){S_($)?Ar($):Ie($)}function ls($){if(S_($))Ar($);else{let Fe=So($.expression);Fe.kind===218||Fe.kind===219?(et($.typeArguments),et($.arguments),pr($.expression)):(Ie($),$.expression.kind===108&&(x=Ii(x,$)))}if($.expression.kind===211){let Fe=$.expression;He(Fe.name)&&jr(Fe.expression)&&LH(Fe.name)&&(x=ss(256,x,$))}}function Yn($){m&&(m.nextContainer=$),m=$}function pi($,Fe,jt){switch(s.kind){case 267:return De($,Fe,jt);case 307:return tn($,Fe,jt);case 231:case 263:return Er($,Fe,jt);case 266:return ke(s.symbol.exports,s.symbol,$,Fe,jt);case 187:case 322:case 210:case 264:case 292:return ke(s.symbol.members,s.symbol,$,Fe,jt);case 184:case 185:case 179:case 180:case 323:case 181:case 174:case 173:case 176:case 177:case 178:case 262:case 218:case 219:case 317:case 175:case 265:case 200:return s.locals&&M.assertNode(s,Lh),ke(s.locals,void 0,$,Fe,jt)}}function Er($,Fe,jt){return oa($)?ke(s.symbol.exports,s.symbol,$,Fe,jt):ke(s.symbol.members,s.symbol,$,Fe,jt)}function tn($,Fe,jt){return nu(e)?De($,Fe,jt):ke(e.locals,void 0,$,Fe,jt)}function er($){let Fe=Ji($)?$:ai($.body,Hg);return!!Fe&&Fe.statements.some(jt=>xl(jt)||dc(jt))}function qs($){$.flags&33554432&&!er($)?$.flags|=128:$.flags&=-129}function uo($){if(qs($),B_($))if(li($,32)&&Ye($,v.export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible),aH($))Mo($);else{let Fe;if($.name.kind===11){let{text:Xr}=$.name;Fe=fN(Xr),Fe===void 0&&Ye($.name,v.Pattern_0_can_have_at_most_one_Asterisk_character,Xr)}let jt=pi($,512,110735);e.patternAmbientModules=Bt(e.patternAmbientModules,Fe&&!bs(Fe)?{pattern:Fe,symbol:jt}:void 0)}else{let Fe=Mo($);if(Fe!==0){let{symbol:jt}=$;jt.constEnumOnlyModule=!(jt.flags&304)&&Fe===2&&jt.constEnumOnlyModule!==!1}}}function Mo($){let Fe=N0($),jt=Fe!==0;return pi($,jt?512:1024,jt?110735:0),Fe}function Do($){let Fe=he(131072,Ve($));be(Fe,$,131072);let jt=he(2048,"__type");be(jt,$,2048),jt.members=fa(),jt.members.set(Fe.escapedName,Fe)}function ms($){return ts($,4096,"__object")}function sa($){return ts($,4096,"__jsxAttributes")}function Sc($,Fe,jt){return pi($,Fe,jt)}function ts($,Fe,jt){let Xr=he(Fe,jt);return Fe&106508&&(Xr.parent=s.symbol),be(Xr,$,Fe),Xr}function zi($,Fe,jt){switch(u.kind){case 267:De($,Fe,jt);break;case 307:if(Uf(s)){De($,Fe,jt);break}default:M.assertNode(u,Lh),u.locals||(u.locals=fa(),Yn(u)),ke(u.locals,void 0,$,Fe,jt)}}function Eu(){if(!d)return;let $=s,Fe=m,jt=u,Xr=i,Mi=x;for(let Us of d){let Ss=Us.parent.parent;s=K5(Ss)||e,u=eg(Ss)||e,x=Wh(2,void 0,void 0),i=Us,pr(Us.typeExpression);let zs=Ps(Us);if((d8(Us)||!Us.fullName)&&zs&&UR(zs.parent)){let vo=wd(zs.parent);if(vo){id(e.symbol,zs.parent,vo,!!Pr(zs,qc=>Wn(qc)&&qc.name.escapedText==="prototype"),!1);let Wa=s;switch(yR(zs.parent)){case 1:case 2:Uf(e)?s=e:s=void 0;break;case 4:s=zs.parent.expression;break;case 3:s=zs.parent.expression.name;break;case 5:s=EE(e,zs.parent.expression)?e:Wn(zs.parent.expression)?zs.parent.expression.name:zs.parent.expression;break;case 0:return M.fail("Shouldn't have detected typedef or enum on non-assignment declaration")}s&&De(Us,524288,788968),s=Wa}}else d8(Us)||!Us.fullName||Us.fullName.kind===80?(i=Us.parent,zi(Us,524288,788968)):pr(Us.fullName)}s=$,m=Fe,u=jt,i=Xr,x=Mi}function kc(){if(E===void 0)return;let $=s,Fe=m,jt=u,Xr=i,Mi=x;for(let Us of E){let Ss=tE(Us),zs=Ss?K5(Ss):void 0,vo=Ss?eg(Ss):void 0;s=zs||e,u=vo||e,x=Wh(2,void 0,void 0),i=Us,pr(Us.importClause)}s=$,m=Fe,u=jt,i=Xr,x=Mi}function P_($){if(!e.parseDiagnostics.length&&!($.flags&33554432)&&!($.flags&16777216)&&!hfe($)){let Fe=Jx($);if(Fe===void 0)return;K&&Fe>=119&&Fe<=127?e.bindDiagnostics.push(Ae($,el($),Yo($))):Fe===135?nu(e)&&a9($)?e.bindDiagnostics.push(Ae($,v.Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module,Yo($))):$.flags&65536&&e.bindDiagnostics.push(Ae($,v.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here,Yo($))):Fe===127&&$.flags&16384&&e.bindDiagnostics.push(Ae($,v.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here,Yo($)))}}function el($){return Ou($)?v.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode:e.externalModuleIndicator?v.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode:v.Identifier_expected_0_is_a_reserved_word_in_strict_mode}function Xu($){$.escapedText==="#constructor"&&(e.parseDiagnostics.length||e.bindDiagnostics.push(Ae($,v.constructor_is_a_reserved_word,Yo($))))}function Fa($){K&&xf($.left)&&y0($.operatorToken.kind)&&_r($,$.left)}function bc($){K&&$.variableDeclaration&&_r($,$.variableDeclaration.name)}function Lo($){if(K&&$.expression.kind===80){let Fe=Yx(e,$.expression);e.bindDiagnostics.push(bu(e,Fe.start,Fe.length,v.delete_cannot_be_called_on_an_identifier_in_strict_mode))}}function po($){return He($)&&($.escapedText==="eval"||$.escapedText==="arguments")}function _r($,Fe){if(Fe&&Fe.kind===80){let jt=Fe;if(po(jt)){let Xr=Yx(e,Fe);e.bindDiagnostics.push(bu(e,Xr.start,Xr.length,Jc($),Nn(jt)))}}}function Jc($){return Ou($)?v.Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode:e.externalModuleIndicator?v.Invalid_use_of_0_Modules_are_automatically_in_strict_mode:v.Invalid_use_of_0_in_strict_mode}function z_($){K&&!($.flags&33554432)&&_r($,$.name)}function W_($){return Ou($)?v.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES5_Class_definitions_are_automatically_in_strict_mode:e.externalModuleIndicator?v.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES5_Modules_are_automatically_in_strict_mode:v.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES5}function qf($){if(n<2&&u.kind!==307&&u.kind!==267&&!LP(u)){let Fe=Yx(e,$);e.bindDiagnostics.push(bu(e,Fe.start,Fe.length,W_($)))}}function mc($){K&&_r($,$.operand)}function tl($){K&&($.operator===46||$.operator===47)&&_r($,$.operand)}function Se($){K&&Ye($,v.with_statements_are_not_allowed_in_strict_mode)}function ae($){K&&Ka(t)>=2&&(f_e($.statement)||_l($.statement))&&Ye($.label,v.A_label_is_not_allowed_here)}function Ye($,Fe,...jt){let Xr=Bh(e,$.pos);e.bindDiagnostics.push(bu(e,Xr.start,Xr.length,Fe,...jt))}function Ot($,Fe,jt){Tr($,Fe,Fe,jt)}function Tr($,Fe,jt,Xr){Vn($,{pos:ob(Fe,e),end:jt.end},Xr)}function Vn($,Fe,jt){let Xr=bu(e,Fe.pos,Fe.end-Fe.pos,jt);$?e.bindDiagnostics.push(Xr):e.bindSuggestionDiagnostics=Bt(e.bindSuggestionDiagnostics,{...Xr,category:2})}function pr($){if(!$)return;lo($,i),Cn&&($.tracingPath=e.path);let Fe=K;if(Na($),$.kind>165){let jt=i;i=$;let Xr=_K($);Xr===0?_t($):ct($,Xr),i=jt}else{let jt=i;$.kind===1&&(i=$),Jn($),i=jt}K=Fe}function Jn($){if(Pp($))if(hn($))for(let Fe of $.jsDoc)pr(Fe);else for(let Fe of $.jsDoc)lo(Fe,$),T0(Fe,!1)}function Ri($){if(!K)for(let Fe of $){if(!Mg(Fe))return;if(Ai(Fe)){K=!0;return}}}function Ai($){let Fe=GT(e,$.expression);return Fe==='"use strict"'||Fe==="'use strict'"}function Na($){switch($.kind){case 80:if($.flags&4096){let Ss=$.parent;for(;Ss&&!Xd(Ss);)Ss=Ss.parent;zi(Ss,524288,788968);break}case 110:return x&&(Ct($)||i.kind===304)&&($.flowNode=x),P_($);case 166:x&&u9($)&&($.flowNode=x);break;case 236:case 108:$.flowNode=x;break;case 81:return Xu($);case 211:case 212:let Fe=$;x&&Xe(Fe)&&(Fe.flowNode=x),lfe(Fe)&&fl(Fe),hn(Fe)&&e.commonJsModuleIndicator&&Py(Fe)&&!xB(u,"module")&&ke(e.locals,void 0,Fe.expression,134217729,111550);break;case 226:switch(cl($)){case 1:Je($);break;case 2:qt($);break;case 3:Fo($.left,$);break;case 6:au($);break;case 4:gs($);break;case 5:let Ss=$.left.expression;if(hn($)&&He(Ss)){let zs=xB(u,Ss.escapedText);if(o9(zs?.valueDeclaration)){gs($);break}}Wf($);break;case 0:break;default:M.fail("Unknown binary expression special property assignment kind")}return Fa($);case 299:return bc($);case 220:return Lo($);case 225:return mc($);case 224:return tl($);case 254:return Se($);case 256:return ae($);case 197:S=!0;return;case 182:break;case 168:return nn($);case 169:return oe($);case 260:return ad($);case 208:return $.flowNode=x,ad($);case 172:case 171:return gc($);case 303:case 304:return Xt($,4,0);case 306:return Xt($,8,900095);case 179:case 180:case 181:return pi($,131072,0);case 174:case 173:return Xt($,8192|($.questionToken?16777216:0),Nm($)?0:103359);case 262:return yt($);case 176:return pi($,16384,0);case 177:return Xt($,32768,46015);case 178:return Xt($,65536,78783);case 184:case 317:case 323:case 185:return Do($);case 187:case 322:case 200:return Wl($);case 332:return Ht($);case 210:return ms($);case 218:case 219:return Gt($);case 213:switch(cl($)){case 7:return Cl($);case 8:return nd($);case 9:return Uo($);case 0:break;default:return M.fail("Unknown call expression assignment declaration kind")}hn($)&&Kh($);break;case 231:case 263:return K=!0,$f($);case 264:return zi($,64,788872);case 265:return zi($,524288,788968);case 266:return nh($);case 267:return uo($);case 292:return sa($);case 291:return Sc($,4,0);case 271:case 274:case 276:case 281:return pi($,2097152,2097152);case 270:return mu($);case 273:return rl($);case 278:return zf($);case 277:return hc($);case 307:return Ri($.statements),Oc();case 241:if(!LP($.parent))return;case 268:return Ri($.statements);case 341:if($.parent.kind===323)return oe($);if($.parent.kind!==322)break;case 348:let Mi=$,Us=Mi.isBracketed||Mi.typeExpression&&Mi.typeExpression.type.kind===316?16777220:4;return pi(Mi,Us,0);case 346:case 338:case 340:return(d||(d=[])).push($);case 339:return pr($.typeExpression);case 351:return(E||(E=[])).push($)}}function gc($){let Fe=Ef($),jt=Fe?98304:4,Xr=Fe?13247:0;return Xt($,jt|($.questionToken?16777216:0),Xr)}function Wl($){return ts($,2048,"__type")}function Oc(){if(qs(e),nu(e))du();else if(Kd(e)){du();let $=e.symbol;ke(e.symbol.exports,e.symbol,e,4,-1),e.symbol=$}}function du(){ts(e,512,`"${of(e.fileName)}"`)}function hc($){if(!s.symbol||!s.symbol.exports)ts($,111551,Ve($));else{let Fe=ZP($)?2097152:4,jt=ke(s.symbol.exports,s.symbol,$,Fe,-1);$.isExportEquals&&SR(jt,$)}}function mu($){Pt($.modifiers)&&e.bindDiagnostics.push(Ae($,v.Modifiers_cannot_appear_here));let Fe=Ji($.parent)?nu($.parent)?$.parent.isDeclarationFile?void 0:v.Global_module_exports_may_only_appear_in_declaration_files:v.Global_module_exports_may_only_appear_in_module_files:v.Global_module_exports_may_only_appear_at_top_level;Fe?e.bindDiagnostics.push(Ae($,Fe)):(e.symbol.globalExports=e.symbol.globalExports||fa(),ke(e.symbol.globalExports,e.symbol,$,2097152,2097152))}function zf($){!s.symbol||!s.symbol.exports?ts($,8388608,Ve($)):$.exportClause?zh($.exportClause)&&(lo($.exportClause,$),ke(s.symbol.exports,s.symbol,$.exportClause,2097152,2097152)):ke(s.symbol.exports,s.symbol,$,8388608,0)}function rl($){$.name&&pi($,2097152,2097152)}function $l($){return e.externalModuleIndicator&&e.externalModuleIndicator!==!0?!1:(e.commonJsModuleIndicator||(e.commonJsModuleIndicator=$,e.externalModuleIndicator||du()),!0)}function nd($){if(!$l($))return;let Fe=Hl($.arguments[0],void 0,(jt,Xr)=>(Xr&&be(Xr,jt,67110400),Xr));Fe&&ke(Fe.exports,Fe,$,1048580,0)}function Je($){if(!$l($))return;let Fe=Hl($.left.expression,void 0,(jt,Xr)=>(Xr&&be(Xr,jt,67110400),Xr));if(Fe){let Xr=PR($.right)&&(Xx($.left.expression)||Py($.left.expression))?2097152:1048580;lo($.left,$),ke(Fe.exports,Fe,$.left,Xr,0)}}function qt($){if(!$l($))return;let Fe=mR($.right);if(rG(Fe)||s===e&&EE(e,Fe))return;if(Ca(Fe)&&wi(Fe.properties,p_)){kt(Fe.properties,Gr);return}let jt=ZP($)?2097152:1049092,Xr=ke(e.symbol.exports,e.symbol,$,jt|67108864,0);SR(Xr,$)}function Gr($){ke(e.symbol.exports,e.symbol,$,69206016,0)}function gs($){if(M.assert(hn($)),Pn($)&&Wn($.left)&&Zi($.left.name)||Wn($)&&Zi($.name))return;let jt=nf($,!1,!1);switch(jt.kind){case 262:case 218:let Xr=jt.symbol;if(Pn(jt.parent)&&jt.parent.operatorToken.kind===64){let Ss=jt.parent.left;eE(Ss)&&$1(Ss.expression)&&(Xr=Of(Ss.expression.expression,o))}Xr&&Xr.valueDeclaration&&(Xr.members=Xr.members||fa(),h0($)?Qa($,Xr,Xr.members):ke(Xr.members,Xr,$,67108868,0),be(Xr,Xr.valueDeclaration,32));break;case 176:case 172:case 174:case 177:case 178:case 175:let Mi=jt.parent,Us=oa(jt)?Mi.symbol.exports:Mi.symbol.members;h0($)?Qa($,Mi.symbol,Us):ke(Us,Mi.symbol,$,67108868,0,!0);break;case 307:if(h0($))break;jt.commonJsModuleIndicator?ke(jt.symbol.exports,jt.symbol,$,1048580,0):pi($,1,111550);break;case 267:break;default:M.failBadSyntaxKind(jt)}}function Qa($,Fe,jt){ke(jt,Fe,$,4,0,!0,!0),so($,Fe)}function so($,Fe){Fe&&(Fe.assignmentDeclarationMembers||(Fe.assignmentDeclarationMembers=new Map)).set(yo($),$)}function fl($){$.expression.kind===110?gs($):eE($)&&$.parent.parent.kind===307&&($1($.expression)?Fo($,$.parent):fg($))}function au($){lo($.left,$),lo($.right,$),sd($.left.expression,$.left,!1,!0)}function Uo($){let Fe=Of($.arguments[0].expression);Fe&&Fe.valueDeclaration&&be(Fe,Fe.valueDeclaration,32),If($,Fe,!0)}function Fo($,Fe){let jt=$.expression,Xr=jt.expression;lo(Xr,jt),lo(jt,$),lo($,Fe),sd(Xr,$,!0,!0)}function Cl($){let Fe=Of($.arguments[0]),jt=$.parent.parent.kind===307;Fe=id(Fe,$.arguments[0],jt,!1,!1),If($,Fe,!1)}function Wf($){var Fe;let jt=Of($.left.expression,u)||Of($.left.expression,s);if(!hn($)&&!ufe(jt))return;let Xr=lN($.left);if(!(He(Xr)&&((Fe=xB(s,Xr.escapedText))==null?void 0:Fe.flags)&2097152))if(lo($.left,$),lo($.right,$),He($.left.expression)&&s===e&&EE(e,$.left.expression))Je($);else if(h0($)){ts($,67108868,"__computed");let Mi=id(jt,$.left.expression,wd($.left),!1,!1);so($,Mi)}else fg(aa($.left,Zx))}function fg($){M.assert(!He($)),lo($.expression,$),sd($.expression,$,!1,!1)}function id($,Fe,jt,Xr,Mi){return $?.flags&2097152||(jt&&!Xr&&($=Hl(Fe,$,(zs,vo,Wa)=>{if(vo)return be(vo,zs,67110400),vo;{let qc=Wa?Wa.exports:e.jsGlobalAugmentations||(e.jsGlobalAugmentations=fa());return ke(qc,Wa,zs,67110400,110735)}})),Mi&&$&&$.valueDeclaration&&be($,$.valueDeclaration,32)),$}function If($,Fe,jt){if(!Fe||!Gh(Fe))return;let Xr=jt?Fe.members||(Fe.members=fa()):Fe.exports||(Fe.exports=fa()),Mi=0,Us=0;Go(iA($))?(Mi=8192,Us=103359):ea($)&&Qx($)&&(Pt($.arguments[2].properties,Ss=>{let zs=Ps(Ss);return!!zs&&He(zs)&&Nn(zs)==="set"})&&(Mi|=65540,Us|=78783),Pt($.arguments[2].properties,Ss=>{let zs=Ps(Ss);return!!zs&&He(zs)&&Nn(zs)==="get"})&&(Mi|=32772,Us|=46015)),Mi===0&&(Mi=4,Us=0),ke(Xr,Fe,$,Mi|67108864,Us&-67108865)}function wd($){return Pn($.parent)?Yh($.parent).parent.kind===307:$.parent.parent.kind===307}function sd($,Fe,jt,Xr){let Mi=Of($,u)||Of($,s),Us=wd(Fe);Mi=id(Mi,Fe.expression,Us,jt,Xr),If(Fe,Mi,jt)}function Gh($){if($.flags&1072)return!0;let Fe=$.valueDeclaration;if(Fe&&ea(Fe))return!!iA(Fe);let jt=Fe?Ei(Fe)?Fe.initializer:Pn(Fe)?Fe.right:Wn(Fe)&&Pn(Fe.parent)?Fe.parent.right:void 0:void 0;if(jt=jt&&mR(jt),jt){let Xr=$1(Ei(Fe)?Fe.name:Pn(Fe)?Fe.left:Fe);return!!lb(Pn(jt)&&(jt.operatorToken.kind===57||jt.operatorToken.kind===61)?jt.right:jt,Xr)}return!1}function Yh($){for(;Pn($.parent);)$=$.parent;return $.parent}function Of($,Fe=s){if(He($))return xB(Fe,$.escapedText);{let jt=Of($.expression);return jt&&jt.exports&&jt.exports.get(m0($))}}function Hl($,Fe,jt){if(EE(e,$))return e.symbol;if(He($))return jt($,Of($),Fe);{let Xr=Hl($.expression,Fe,jt),Mi=hR($);return Zi(Mi)&&M.fail("unexpected PrivateIdentifier"),jt(Mi,Xr&&Xr.exports&&Xr.exports.get(m0($)),Xr)}}function Kh($){!e.commonJsModuleIndicator&&kf($,!1)&&$l($)}function $f($){if($.kind===263)zi($,32,899503);else{let Mi=$.name?$.name.escapedText:"__class";ts($,32,Mi),$.name&&ne.add($.name.escapedText)}let{symbol:Fe}=$,jt=he(4194308,"prototype"),Xr=Fe.exports.get(jt.escapedName);Xr&&($.name&&lo($.name,$),e.bindDiagnostics.push(Ae(Xr.declarations[0],v.Duplicate_identifier_0,Qc(jt)))),Fe.exports.set(jt.escapedName,jt),jt.parent=Fe}function nh($){return KT($)?zi($,128,899967):zi($,256,899327)}function ad($){if(K&&_r($,$.name),!Hs($.name)){let Fe=$.kind===260?$:$.parent.parent;hn($)&&ZT(Fe)&&!tb($)&&!(eb($)&32)?pi($,2097152,2097152):nH($)?zi($,2,111551):db($)?pi($,1,111551):pi($,1,111550)}}function oe($){if(!($.kind===341&&s.kind!==323)&&(K&&!($.flags&33554432)&&_r($,$.name),Hs($.name)?ts($,1,"__"+$.parent.parameters.indexOf($)):pi($,1,111551),ap($,$.parent))){let Fe=$.parent.parent;ke(Fe.symbol.members,Fe.symbol,$,4|($.questionToken?16777216:0),0)}}function yt($){!e.isDeclarationFile&&!($.flags&33554432)&&VI($)&&(pe|=4096),z_($),K?(qf($),zi($,16,110991)):pi($,16,110991)}function Gt($){!e.isDeclarationFile&&!($.flags&33554432)&&VI($)&&(pe|=4096),x&&($.flowNode=x),z_($);let Fe=$.name?$.name.escapedText:"__function";return ts($,16,Fe)}function Xt($,Fe,jt){return!e.isDeclarationFile&&!($.flags&33554432)&&VI($)&&(pe|=4096),x&&r9($)&&($.flowNode=x),h0($)?ts($,Fe,"__computed"):pi($,Fe,jt)}function Fr($){let Fe=Pr($,jt=>jt.parent&&dE(jt.parent)&&jt.parent.extendsType===jt);return Fe&&Fe.parent}function nn($){if(sm($.parent)){let Fe=y9($.parent);Fe?(M.assertNode(Fe,Lh),Fe.locals??(Fe.locals=fa()),ke(Fe.locals,void 0,$,262144,526824)):pi($,262144,526824)}else if($.parent.kind===195){let Fe=Fr($.parent);Fe?(M.assertNode(Fe,Lh),Fe.locals??(Fe.locals=fa()),ke(Fe.locals,void 0,$,262144,526824)):ts($,262144,Ve($))}else pi($,262144,526824)}function Hn($){let Fe=N0($);return Fe===1||Fe===2&&lE(t)}function Si($){if(!(x.flags&1))return!1;if(x===le&&(W3($)&&$.kind!==242||$.kind===263||$.kind===267&&Hn($))&&(x=me,!t.allowUnreachableCode)){let jt=lpe(t)&&!($.flags&33554432)&&(!_l($)||!!(f0($.declarationList)&7)||$.declarationList.declarations.some(Xr=>!!Xr.initializer));DTt($,(Xr,Mi)=>Tr(jt,Xr,Mi,v.Unreachable_code_detected))}return!0}}function DTt(e,t){if(Vi(e)&&DRe(e)&&Vs(e.parent)){let{statements:n}=e.parent,i=kG(n,e);$w(i,DRe,(s,o)=>t(i[s],i[o-1]))}else t(e,e)}function DRe(e){return!Tl(e)&&!wTt(e)&&!bb(e)&&!(_l(e)&&!(f0(e)&7)&&e.declarationList.declarations.some(t=>!t.initializer))}function wTt(e){switch(e.kind){case 264:case 265:return!0;case 267:return N0(e)!==1;case 266:return li(e,4096);default:return!1}}function EE(e,t){let n=0,i=p3();for(i.enqueue(t);!i.isEmpty()&&n<100;){if(n++,t=i.dequeue(),Xx(t)||Py(t))return!0;if(He(t)){let s=xB(e,t.escapedText);if(s&&s.valueDeclaration&&Ei(s.valueDeclaration)&&s.valueDeclaration.initializer){let o=s.valueDeclaration.initializer;i.enqueue(o),Su(o,!0)&&(i.enqueue(o.left),i.enqueue(o.right))}}}return!1}function _K(e){switch(e.kind){case 231:case 263:case 266:case 210:case 187:case 322:case 292:return 1;case 264:return 65;case 267:case 265:case 200:case 181:return 33;case 307:return 37;case 177:case 178:case 174:if(r9(e))return 173;case 176:case 262:case 173:case 179:case 323:case 317:case 184:case 180:case 185:case 175:return 45;case 218:case 219:return 61;case 268:return 4;case 172:return e.initializer?4:0;case 299:case 248:case 249:case 250:case 269:return 34;case 241:return Bs(e.parent)||Gc(e.parent)?0:34}return 0}function xB(e,t){var n,i,s,o;let u=(i=(n=ai(e,Lh))==null?void 0:n.locals)==null?void 0:i.get(t);if(u)return u.exportSymbol??u;if(Ji(e)&&e.jsGlobalAugmentations&&e.jsGlobalAugmentations.has(t))return e.jsGlobalAugmentations.get(t);if(Zm(e))return(o=(s=e.symbol)==null?void 0:s.exports)==null?void 0:o.get(t)}function Pge(e,t,n,i,s,o,u,m,d,S){return E;function E(x=()=>!0){let D=[],w=[];return{walkType:ue=>{try{return R(ue),{visitedTypes:UC(D),visitedSymbols:UC(w)}}finally{Ym(D),Ym(w)}},walkSymbol:ue=>{try{return re(ue),{visitedTypes:UC(D),visitedSymbols:UC(w)}}finally{Ym(D),Ym(w)}}};function R(ue){if(!(!ue||D[ue.id]||(D[ue.id]=ue,re(ue.symbol)))){if(ue.flags&524288){let ne=ue,le=ne.objectFlags;le&4&&L(ue),le&32&&ee(ue),le&3&&pe(ue),le&24&&K(ne)}ue.flags&262144&&F(ue),ue.flags&3145728&&J(ue),ue.flags&4194304&&G(ue),ue.flags&8388608&&q(ue)}}function L(ue){R(ue.target),kt(S(ue),R)}function F(ue){R(m(ue))}function J(ue){kt(ue.types,R)}function G(ue){R(ue.type)}function q(ue){R(ue.objectType),R(ue.indexType),R(ue.constraint)}function ee(ue){R(ue.typeParameter),R(ue.constraintType),R(ue.templateType),R(ue.modifiersType)}function W(ue){let ce=t(ue);ce&&R(ce.type),kt(ue.typeParameters,R);for(let ne of ue.parameters)re(ne);R(e(ue)),R(n(ue))}function pe(ue){K(ue),kt(ue.typeParameters,R),kt(i(ue),R),R(ue.thisType)}function K(ue){let ce=s(ue);for(let ne of ce.indexInfos)R(ne.keyType),R(ne.type);for(let ne of ce.callSignatures)W(ne);for(let ne of ce.constructSignatures)W(ne);for(let ne of ce.properties)re(ne)}function re(ue){if(!ue)return!1;let ce=Aa(ue);if(w[ce])return!1;if(w[ce]=ue,!x(ue))return!0;let ne=o(ue);return R(ne),ue.exports&&ue.exports.forEach(re),kt(ue.declarations,le=>{if(le.type&&le.type.kind===186){let me=le.type,de=u(d(me.exprName));re(de)}}),!1}}}var wb={};A(wb,{RelativePreference:()=>wRe,countPathComponents:()=>AB,forEachFileNameOfModule:()=>jRe,getLocalModuleSpecifierBetweenFileNames:()=>MTt,getModuleSpecifier:()=>IRe,getModuleSpecifierPreferences:()=>YO,getModuleSpecifiers:()=>MRe,getModuleSpecifiersWithCacheInfo:()=>LRe,getNodeModulesPackageName:()=>OTt,tryGetJSExtensionForFile:()=>Oge,tryGetModuleSpecifiersFromCache:()=>RTt,tryGetRealFileNameForNonJsDeclarationFileName:()=>qRe,updateModuleSpecifier:()=>ITt});var wRe=(e=>(e[e.Relative=0]="Relative",e[e.NonRelative=1]="NonRelative",e[e.Shortest=2]="Shortest",e[e.ExternalNonRelative=3]="ExternalNonRelative",e))(wRe||{});function YO({importModuleSpecifierPreference:e,importModuleSpecifierEnding:t},n,i,s){let o=u();return{relativePreference:s!==void 0?vu(s)?0:1:e==="relative"?0:e==="non-relative"?1:e==="project-relative"?3:2,getAllowedEndingsInPreferredOrder:m=>{let d=m!==i.impliedNodeFormat?u(m):o;if((m??i.impliedNodeFormat)===99)return MN(n,i.fileName)?[3,2]:[2];if(af(n)===1)return d===2?[2,1]:[1,2];let S=MN(n,i.fileName);switch(d){case 2:return S?[2,3,0,1]:[2,0,1];case 3:return[3,0,2,1];case 1:return S?[1,0,3,2]:[1,0,2];case 0:return S?[0,1,3,2]:[0,1,2];default:M.assertNever(d)}}};function u(m){if(s!==void 0){if(Oy(s))return 2;if(Wc(s,"/index"))return 1}return Epe(t,m??i.impliedNodeFormat,n,Av(i)?i:void 0)}}function ITt(e,t,n,i,s,o,u={}){let m=ORe(e,t,n,i,s,YO({},e,t,o),{},u);if(m!==o)return m}function IRe(e,t,n,i,s,o={}){return ORe(e,t,n,i,s,YO({},e,t),{},o)}function OTt(e,t,n,i,s,o={}){let u=CB(t.fileName,i),m=BRe(u,n,i,s,e,o);return yi(m,d=>wge(d,u,t,i,e,s,!0,o.overrideImportMode))}function ORe(e,t,n,i,s,o,u,m={}){let d=CB(n,s),S=BRe(d,i,s,u,e,m);return yi(S,E=>wge(E,d,t,s,e,u,void 0,m.overrideImportMode))||Nge(i,d,e,s,m.overrideImportMode||t.impliedNodeFormat,o)}function RTt(e,t,n,i,s={}){let o=RRe(e,t,n,i,s);return o[1]&&{kind:o[0],moduleSpecifiers:o[1],computedWithoutCache:!1}}function RRe(e,t,n,i,s={}){var o;let u=z5(e);if(!u)return ve;let m=(o=n.getModuleSpecifierCache)==null?void 0:o.call(n),d=m?.get(t.path,u.path,i,s);return[d?.kind,d?.moduleSpecifiers,u,d?.modulePaths,m]}function MRe(e,t,n,i,s,o,u={}){return LRe(e,t,n,i,s,o,u,!1).moduleSpecifiers}function LRe(e,t,n,i,s,o,u={},m){let d=!1,S=UTt(e,t);if(S)return{kind:"ambient",moduleSpecifiers:[S],computedWithoutCache:d};let[E,x,D,w,R]=RRe(e,i,s,o,u);if(x)return{kind:E,moduleSpecifiers:x,computedWithoutCache:d};if(!D)return{kind:void 0,moduleSpecifiers:ve,computedWithoutCache:d};d=!0,w||(w=URe(CB(i.fileName,s),D.originalFileName,s,n,u));let L=LTt(w,n,i,s,o,u,m);return R?.set(i.path,D.path,o,u,L.kind,w,L.moduleSpecifiers),L}function MTt(e,t,n,i,s={}){let o=CB(e.fileName,i),u=s.overrideImportMode??e.impliedNodeFormat;return Nge(t,o,n,i,u,YO({},n,e))}function LTt(e,t,n,i,s,o={},u){let m=CB(n.fileName,i),d=YO(s,t,n),S=Av(n)&&kt(e,L=>kt(i.getFileIncludeReasons().get(rc(L.path,i.getCurrentDirectory(),m.getCanonicalFileName)),F=>{if(F.kind!==3||F.file!==n.path||n.impliedNodeFormat&&n.impliedNodeFormat!==Hhe(n,F.index,t))return;let J=Q8(n,F.index).text;return d.relativePreference!==1||!qp(J)?J:void 0}));if(S)return{kind:void 0,moduleSpecifiers:[S],computedWithoutCache:!0};let E=Pt(e,L=>L.isInNodeModules),x,D,w,R;for(let L of e){let F=L.isInNodeModules?wge(L,m,n,i,t,s,void 0,o.overrideImportMode):void 0;if(x=Bt(x,F),F&&L.isRedirect)return{kind:"node_modules",moduleSpecifiers:x,computedWithoutCache:!0};if(!F){let J=Nge(L.path,m,t,i,o.overrideImportMode||n.impliedNodeFormat,d,L.isRedirect);if(!J)continue;L.isRedirect?w=Bt(w,J):d$(J)?Nb(J)?R=Bt(R,J):D=Bt(D,J):(u||!E||L.isInNodeModules)&&(R=Bt(R,J))}}return D?.length?{kind:"paths",moduleSpecifiers:D,computedWithoutCache:!0}:w?.length?{kind:"redirect",moduleSpecifiers:w,computedWithoutCache:!0}:x?.length?{kind:"node_modules",moduleSpecifiers:x,computedWithoutCache:!0}:{kind:"relative",moduleSpecifiers:M.checkDefined(R),computedWithoutCache:!0}}function CB(e,t){e=xs(e,t.getCurrentDirectory());let n=l_(t.useCaseSensitiveFileNames?t.useCaseSensitiveFileNames():!0),i=mi(e);return{getCanonicalFileName:n,importingSourceFileName:e,sourceDirectory:i,canonicalSourceDirectory:n(i)}}function Nge(e,t,n,i,s,{getAllowedEndingsInPreferredOrder:o,relativePreference:u},m){let{baseUrl:d,paths:S,rootDirs:E}=n;if(m&&!S)return;let{sourceDirectory:x,canonicalSourceDirectory:D,getCanonicalFileName:w}=t,R=o(s),L=E&&qTt(E,e,x,w,R,n)||L8(Vx(Xm(x,e,w)),R,n);if(!d&&!S&&!gG(n)||u===0)return m?void 0:L;let F=xs(k9(n,i)||d,i.getCurrentDirectory()),J=zRe(e,F,w);if(!J)return m?void 0:L;let G=m?void 0:JTt(e,x,n,i,s),q=m||G===void 0?S&&VRe(J,S,R,i,n):void 0;if(m)return q;let ee=G??(q===void 0&&d!==void 0?L8(J,R,n):q);if(!ee)return L;if(u===1&&!qp(ee))return ee;if(u===3&&!qp(ee)){let W=n.configFilePath?rc(mi(n.configFilePath),i.getCurrentDirectory(),t.getCanonicalFileName):t.getCanonicalFileName(i.getCurrentDirectory()),pe=rc(e,W,w),K=_s(D,W),re=_s(pe,W);if(K&&!re||!K&&re)return ee;let ue=Dge(i,mi(pe)),ce=Dge(i,x),ne=!sN(i);return FTt(ue,ce,ne)?L:ee}return WRe(ee)||AB(L)<AB(ee)?L:ee}function FTt(e,t,n){return e===t?!0:e===void 0||t===void 0?!1:_0(e,t,n)===0}function AB(e){let t=0;for(let n=_s(e,"./")?2:0;n<e.length;n++)e.charCodeAt(n)===47&&t++;return t}function FRe(e,t){return XS(t.isRedirect,e.isRedirect)||GR(e.path,t.path)}function Dge(e,t){return e.getNearestAncestorDirectoryWithPackageJson?e.getNearestAncestorDirectoryWithPackageJson(t):Am(t,n=>e.fileExists(ri(n,"package.json"))?n:void 0)}function jRe(e,t,n,i,s){var o;let u=Pv(n),m=n.getCurrentDirectory(),d=n.isSourceOfProjectReferenceRedirect(t)?n.getProjectReferenceRedirect(t):void 0,S=rc(t,m,u),E=n.redirectTargetsMap.get(S)||ve,D=[...d?[d]:ve,t,...E].map(J=>xs(J,m)),w=!wi(D,pO);if(!i){let J=kt(D,G=>!(w&&pO(G))&&s(G,d===G));if(J)return J}let R=(o=n.getSymlinkCache)==null?void 0:o.call(n).getSymlinkedDirectoriesByRealpath(),L=xs(t,m);return R&&Am(mi(L),J=>{let G=R.get(yu(rc(J,m,u)));if(G)return h$(e,J,u)?!1:kt(D,q=>{if(!h$(q,J,u))return;let ee=Xm(J,q,u);for(let W of G){let pe=QS(W,ee),K=s(pe,q===d);if(w=!0,K)return K}})})||(i?kt(D,J=>w&&pO(J)?void 0:s(J,J===d)):void 0)}function BRe(e,t,n,i,s,o={}){var u;let m=rc(e.importingSourceFileName,n.getCurrentDirectory(),Pv(n)),d=rc(t,n.getCurrentDirectory(),Pv(n)),S=(u=n.getModuleSpecifierCache)==null?void 0:u.call(n);if(S){let x=S.get(m,d,i,o);if(x?.modulePaths)return x.modulePaths}let E=URe(e,t,n,s,o);return S&&S.setModulePaths(m,d,i,o,E),E}var jTt=["dependencies","peerDependencies","optionalDependencies"];function BTt(e){let t;for(let n of jTt){let i=e[n];i&&typeof i=="object"&&(t=ps(t,Ng(i)))}return t}function URe(e,t,n,i,s){var o,u;let m=(o=n.getModuleResolutionCache)==null?void 0:o.call(n),d=(u=n.getSymlinkCache)==null?void 0:u.call(n);if(m&&d&&n.readFile&&!Nb(e.importingSourceFileName)){M.type(n);let D=$O(m.getPackageJsonInfoCache(),n,{}),w=HO(e.importingSourceFileName,D);if(w){let R=BTt(w.contents.packageJsonContent);for(let L of R||ve){let F=QA(L,ri(w.packageDirectory,"package.json"),i,n,m,void 0,s.overrideImportMode);d.setSymlinksFromResolution(F.resolvedModule)}}}let S=new Map,E=!1;jRe(e.importingSourceFileName,t,n,!0,(D,w)=>{let R=Nb(D);S.set(D,{path:e.getCanonicalFileName(D),isRedirect:w,isInNodeModules:R}),E=E||R});let x=[];for(let D=e.canonicalSourceDirectory;S.size!==0;){let w=yu(D),R;S.forEach(({path:F,isRedirect:J,isInNodeModules:G},q)=>{_s(F,w)&&((R||(R=[])).push({path:q,isRedirect:J,isInNodeModules:G}),S.delete(q))}),R&&(R.length>1&&R.sort(FRe),x.push(...R));let L=mi(D);if(L===D)break;D=L}if(S.size){let D=Is(S.entries(),([w,{isRedirect:R,isInNodeModules:L}])=>({path:w,isRedirect:R,isInNodeModules:L}));D.length>1&&D.sort(FRe),x.push(...D)}return x}function UTt(e,t){var n;let i=(n=e.declarations)==null?void 0:n.find(u=>sH(u)&&(!YT(u)||!vu(Qd(u.name))));if(i)return i.name.text;let o=Gi(e.declarations,u=>{var m,d,S,E;if(!El(u))return;let x=L(u);if(!((m=x?.parent)!=null&&m.parent&&Hg(x.parent)&&B_(x.parent.parent)&&Ji(x.parent.parent.parent)))return;let D=(E=(S=(d=x.parent.parent.symbol.exports)==null?void 0:d.get("export="))==null?void 0:S.valueDeclaration)==null?void 0:E.expression;if(!D)return;let w=t.getSymbolAtLocation(D);if(!w)return;if((w?.flags&2097152?t.getAliasedSymbol(w):w)===u.symbol)return x.parent.parent;function L(F){for(;F.flags&8;)F=F.parent;return F}})[0];if(o)return o.name.text}function VRe(e,t,n,i,s){for(let u in t)for(let m of t[u]){let d=Zs(m),S=d.indexOf("*"),E=n.map(x=>({ending:x,value:L8(e,[x],s)}));if(b0(d)&&E.push({ending:void 0,value:e}),S!==-1){let x=d.substring(0,S),D=d.substring(S+1);for(let{ending:w,value:R}of E)if(R.length>=x.length+D.length&&_s(R,x)&&Wc(R,D)&&o({ending:w,value:R})){let L=R.substring(x.length,R.length-D.length);if(!qp(L))return AA(u,L)}}else if(Pt(E,x=>x.ending!==0&&d===x.value)||Pt(E,x=>x.ending===0&&d===x.value&&o(x)))return u}function o({ending:u,value:m}){return u!==0||m===L8(e,[u],s,i)}}function kB(e,t,n,i,s,o,u,m,d){if(typeof o=="string"){let S=!sN(t),E=()=>t.getCommonSourceDirectory(),x=d&&BK(n,e,S,E),D=d&&jK(n,e,S,E),w=xs(ri(i,o),void 0),R=TA(n)?of(n)+Oge(n,e):void 0;switch(m){case 0:if(R&&_0(R,w,S)===0||_0(n,w,S)===0||x&&_0(x,w,S)===0||D&&_0(D,w,S)===0)return{moduleFileToTry:s};break;case 1:if(R&&Cm(w,R,S)){let G=Xm(w,R,!1);return{moduleFileToTry:xs(ri(ri(s,o),G),void 0)}}if(Cm(w,n,S)){let G=Xm(w,n,!1);return{moduleFileToTry:xs(ri(ri(s,o),G),void 0)}}if(x&&Cm(w,x,S)){let G=Xm(w,x,!1);return{moduleFileToTry:ri(s,G)}}if(D&&Cm(w,D,S)){let G=Xm(w,D,!1);return{moduleFileToTry:ri(s,G)}}break;case 2:let L=w.indexOf("*"),F=w.slice(0,L),J=w.slice(L+1);if(R&&_s(R,F,S)&&Wc(R,J,S)){let G=R.slice(F.length,R.length-J.length);return{moduleFileToTry:AA(s,G)}}if(_s(n,F,S)&&Wc(n,J,S)){let G=n.slice(F.length,n.length-J.length);return{moduleFileToTry:AA(s,G)}}if(x&&_s(x,F,S)&&Wc(x,J,S)){let G=x.slice(F.length,x.length-J.length);return{moduleFileToTry:AA(s,G)}}if(D&&_s(D,F,S)&&Wc(D,J,S)){let G=D.slice(F.length,D.length-J.length);return{moduleFileToTry:AA(s,G)}}break}}else{if(Array.isArray(o))return kt(o,S=>kB(e,t,n,i,s,S,u,m,d));if(typeof o=="object"&&o!==null){for(let S of Ng(o))if(S==="default"||u.indexOf(S)>=0||R8(u,S)){let E=o[S],x=kB(e,t,n,i,s,E,u,m,d);if(x)return x}}}}function VTt(e,t,n,i,s,o,u){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&TB(o)?kt(Ng(o),m=>{let d=xs(ri(s,m),void 0),S=Wc(m,"/")?1:m.includes("*")?2:0;return kB(e,t,n,i,d,o[m],u,S,!1)}):kB(e,t,n,i,s,o,u,0,!1)}function JTt(e,t,n,i,s){var o,u,m;if(!i.readFile||!gG(n))return;let d=Dge(i,t);if(!d)return;let S=ri(d,"package.json"),E=(u=(o=i.getPackageJsonInfoCache)==null?void 0:o.call(i))==null?void 0:u.getPackageJsonInfo(S);if(_ge(E)||!i.fileExists(S))return;let x=E?.contents.packageJsonContent||L9(i.readFile(S)),D=x?.imports;if(!D)return;let w=sS(n,s);return(m=kt(Ng(D),R=>{if(!_s(R,"#")||R==="#"||_s(R,"#/"))return;let L=Wc(R,"/")?1:R.includes("*")?2:0;return kB(n,i,e,d,R,D[R],w,L,!0)}))==null?void 0:m.moduleFileToTry}function qTt(e,t,n,i,s,o){let u=JRe(t,e,i);if(u===void 0)return;let m=JRe(n,e,i),d=va(m,E=>Cr(u,x=>Vx(Xm(E,x,i)))),S=MW(d,GR);if(S)return L8(S,s,o)}function wge({path:e,isRedirect:t},{getCanonicalFileName:n,canonicalSourceDirectory:i},s,o,u,m,d,S){if(!o.fileExists||!o.readFile)return;let E=dj(e);if(!E)return;let D=YO(m,u,s).getAllowedEndingsInPreferredOrder(),w=e,R=!1;if(!d){let ee=E.packageRootIndex,W;for(;;){let{moduleFileToTry:pe,packageRootPath:K,blockedByExports:re,verbatimFromExports:ue}=q(ee);if(af(u)!==1){if(re)return;if(ue)return pe}if(K){w=K,R=!0;break}if(W||(W=pe),ee=e.indexOf(Ec,ee+1),ee===-1){w=L8(W,D,u,o);break}}}if(t&&!R)return;let L=o.getGlobalTypingsCacheLocation&&o.getGlobalTypingsCacheLocation(),F=n(w.substring(0,E.topLevelNodeModulesIndex));if(!(_s(i,F)||L&&_s(n(L),F)))return;let J=w.substring(E.topLevelPackageNameIndex+1),G=GO(J);return af(u)===1&&G===J?void 0:G;function q(ee){var W,pe;let K=e.substring(0,ee),re=ri(K,"package.json"),ue=e,ce=!1,ne=(pe=(W=o.getPackageJsonInfoCache)==null?void 0:W.call(o))==null?void 0:pe.getPackageJsonInfo(re);if(hB(ne)||ne===void 0&&o.fileExists(re)){let le=ne?.contents.packageJsonContent||L9(o.readFile(re)),me=S||s.impliedNodeFormat;if(mG(u)){let xe=K.substring(E.topLevelPackageNameIndex+1),te=GO(xe),he=sS(u,me),be=le?.exports?VTt(u,o,e,K,te,le.exports,he):void 0;if(be)return{...be,verbatimFromExports:!0};if(le?.exports)return{moduleFileToTry:e,blockedByExports:!0}}let de=le?.typesVersions?mB(le.typesVersions):void 0;if(de){let xe=e.slice(K.length+1),te=VRe(xe,de.paths,D,o,u);te===void 0?ce=!0:ue=ri(K,te)}let Ae=le?.typings||le?.types||le?.main||"index.js";if(bs(Ae)&&!(ce&&AG(cj(de.paths),Ae))){let xe=rc(Ae,K,n),te=n(ue);if(of(xe)===of(te))return{packageRootPath:K,moduleFileToTry:ue};if(le?.type!=="module"&&!wl(te,oj)&&_s(te,xe)&&mi(te)===ZS(xe)&&of(Ul(te))==="index")return{packageRootPath:K,moduleFileToTry:ue}}}else{let le=n(ue.substring(E.packageRootIndex+1));if(le==="index.d.ts"||le==="index.js"||le==="index.ts"||le==="index.tsx")return{moduleFileToTry:ue,packageRootPath:K}}return{moduleFileToTry:ue}}}function zTt(e,t){if(!e.fileExists)return;let n=ef(aO({allowJs:!0},[{extension:"node",isMixedContent:!1},{extension:"json",isMixedContent:!1,scriptKind:6}]));for(let i of n){let s=t+i;if(e.fileExists(s))return s}}function JRe(e,t,n){return Gi(t,i=>{let s=zRe(e,i,n);return s!==void 0&&WRe(s)?void 0:s})}function L8(e,t,n,i){if(wl(e,[".json",".mjs",".cjs"]))return e;let s=of(e);if(e===s)return e;let o=t.indexOf(2),u=t.indexOf(3);if(wl(e,[".mts",".cts"])&&u!==-1&&u<o)return e;if(wl(e,[".d.mts",".mts",".d.cts",".cts"]))return s+Ige(e,n);if(!wl(e,[".d.ts"])&&wl(e,[".ts"])&&e.includes(".d."))return qRe(e);switch(t[0]){case 0:let m=AP(s,"/index");return i&&m!==s&&zTt(i,m)?s:m;case 1:return s;case 2:return s+Ige(e,n);case 3:if(Mu(e)){let d=t.findIndex(S=>S===0||S===1);return d!==-1&&d<o?s:s+Ige(e,n)}return e;default:return M.assertNever(t[0])}}function qRe(e){let t=Ul(e);if(!Wc(e,".ts")||!t.includes(".d.")||wl(t,[".d.ts"]))return;let n=YR(e,".ts"),i=n.substring(n.lastIndexOf("."));return n.substring(0,n.indexOf(".d."))+i}function Ige(e,t){return Oge(e,t)??M.fail(`Extension ${cO(e)} is unsupported:: FileName:: ${e}`)}function Oge(e,t){let n=b0(e);switch(n){case".ts":case".d.ts":return".js";case".tsx":return t.jsx===1?".jsx":".js";case".js":case".jsx":case".json":return n;case".d.mts":case".mts":case".mjs":return".mjs";case".d.cts":case".cts":case".cjs":return".cjs";default:return}}function zRe(e,t,n){let i=WC(t,e,t,n,!1);return ip(i)?void 0:i}function WRe(e){return _s(e,"..")}var Rge=/^".+"$/,fK="(anonymous)",$Re=1,HRe=1,GRe=1,YRe=1,pK=(e=>(e[e.None=0]="None",e[e.TypeofEQString=1]="TypeofEQString",e[e.TypeofEQNumber=2]="TypeofEQNumber",e[e.TypeofEQBigInt=4]="TypeofEQBigInt",e[e.TypeofEQBoolean=8]="TypeofEQBoolean",e[e.TypeofEQSymbol=16]="TypeofEQSymbol",e[e.TypeofEQObject=32]="TypeofEQObject",e[e.TypeofEQFunction=64]="TypeofEQFunction",e[e.TypeofEQHostObject=128]="TypeofEQHostObject",e[e.TypeofNEString=256]="TypeofNEString",e[e.TypeofNENumber=512]="TypeofNENumber",e[e.TypeofNEBigInt=1024]="TypeofNEBigInt",e[e.TypeofNEBoolean=2048]="TypeofNEBoolean",e[e.TypeofNESymbol=4096]="TypeofNESymbol",e[e.TypeofNEObject=8192]="TypeofNEObject",e[e.TypeofNEFunction=16384]="TypeofNEFunction",e[e.TypeofNEHostObject=32768]="TypeofNEHostObject",e[e.EQUndefined=65536]="EQUndefined",e[e.EQNull=131072]="EQNull",e[e.EQUndefinedOrNull=262144]="EQUndefinedOrNull",e[e.NEUndefined=524288]="NEUndefined",e[e.NENull=1048576]="NENull",e[e.NEUndefinedOrNull=2097152]="NEUndefinedOrNull",e[e.Truthy=4194304]="Truthy",e[e.Falsy=8388608]="Falsy",e[e.IsUndefined=16777216]="IsUndefined",e[e.IsNull=33554432]="IsNull",e[e.IsUndefinedOrNull=50331648]="IsUndefinedOrNull",e[e.All=134217727]="All",e[e.BaseStringStrictFacts=3735041]="BaseStringStrictFacts",e[e.BaseStringFacts=12582401]="BaseStringFacts",e[e.StringStrictFacts=16317953]="StringStrictFacts",e[e.StringFacts=16776705]="StringFacts",e[e.EmptyStringStrictFacts=12123649]="EmptyStringStrictFacts",e[e.EmptyStringFacts=12582401]="EmptyStringFacts",e[e.NonEmptyStringStrictFacts=7929345]="NonEmptyStringStrictFacts",e[e.NonEmptyStringFacts=16776705]="NonEmptyStringFacts",e[e.BaseNumberStrictFacts=3734786]="BaseNumberStrictFacts",e[e.BaseNumberFacts=12582146]="BaseNumberFacts",e[e.NumberStrictFacts=16317698]="NumberStrictFacts",e[e.NumberFacts=16776450]="NumberFacts",e[e.ZeroNumberStrictFacts=12123394]="ZeroNumberStrictFacts",e[e.ZeroNumberFacts=12582146]="ZeroNumberFacts",e[e.NonZeroNumberStrictFacts=7929090]="NonZeroNumberStrictFacts",e[e.NonZeroNumberFacts=16776450]="NonZeroNumberFacts",e[e.BaseBigIntStrictFacts=3734276]="BaseBigIntStrictFacts",e[e.BaseBigIntFacts=12581636]="BaseBigIntFacts",e[e.BigIntStrictFacts=16317188]="BigIntStrictFacts",e[e.BigIntFacts=16775940]="BigIntFacts",e[e.ZeroBigIntStrictFacts=12122884]="ZeroBigIntStrictFacts",e[e.ZeroBigIntFacts=12581636]="ZeroBigIntFacts",e[e.NonZeroBigIntStrictFacts=7928580]="NonZeroBigIntStrictFacts",e[e.NonZeroBigIntFacts=16775940]="NonZeroBigIntFacts",e[e.BaseBooleanStrictFacts=3733256]="BaseBooleanStrictFacts",e[e.BaseBooleanFacts=12580616]="BaseBooleanFacts",e[e.BooleanStrictFacts=16316168]="BooleanStrictFacts",e[e.BooleanFacts=16774920]="BooleanFacts",e[e.FalseStrictFacts=12121864]="FalseStrictFacts",e[e.FalseFacts=12580616]="FalseFacts",e[e.TrueStrictFacts=7927560]="TrueStrictFacts",e[e.TrueFacts=16774920]="TrueFacts",e[e.SymbolStrictFacts=7925520]="SymbolStrictFacts",e[e.SymbolFacts=16772880]="SymbolFacts",e[e.ObjectStrictFacts=7888800]="ObjectStrictFacts",e[e.ObjectFacts=16736160]="ObjectFacts",e[e.FunctionStrictFacts=7880640]="FunctionStrictFacts",e[e.FunctionFacts=16728e3]="FunctionFacts",e[e.VoidFacts=9830144]="VoidFacts",e[e.UndefinedFacts=26607360]="UndefinedFacts",e[e.NullFacts=42917664]="NullFacts",e[e.EmptyObjectStrictFacts=83427327]="EmptyObjectStrictFacts",e[e.EmptyObjectFacts=83886079]="EmptyObjectFacts",e[e.UnknownFacts=83886079]="UnknownFacts",e[e.AllTypeofNE=556800]="AllTypeofNE",e[e.OrFactsMask=8256]="OrFactsMask",e[e.AndFactsMask=134209471]="AndFactsMask",e))(pK||{}),Mge=new Map(Object.entries({string:256,number:512,bigint:1024,boolean:2048,symbol:4096,undefined:524288,object:8192,function:16384})),dK=(e=>(e[e.Normal=0]="Normal",e[e.Contextual=1]="Contextual",e[e.Inferential=2]="Inferential",e[e.SkipContextSensitive=4]="SkipContextSensitive",e[e.SkipGenericFunctions=8]="SkipGenericFunctions",e[e.IsForSignatureHelp=16]="IsForSignatureHelp",e[e.RestBindingElement=32]="RestBindingElement",e[e.TypeOnly=64]="TypeOnly",e))(dK||{}),mK=(e=>(e[e.None=0]="None",e[e.BivariantCallback=1]="BivariantCallback",e[e.StrictCallback=2]="StrictCallback",e[e.IgnoreReturnTypes=4]="IgnoreReturnTypes",e[e.StrictArity=8]="StrictArity",e[e.StrictTopSignature=16]="StrictTopSignature",e[e.Callback=3]="Callback",e))(mK||{}),WTt=r5(XRe,HTt),gK=new Map(Object.entries({Uppercase:0,Lowercase:1,Capitalize:2,Uncapitalize:3,NoInfer:4})),KRe=class{};function $Tt(){this.flags=0}function yo(e){return e.id||(e.id=HRe,HRe++),e.id}function Aa(e){return e.id||(e.id=$Re,$Re++),e.id}function hK(e,t){let n=N0(e);return n===1||t&&n===2}function Lge(e){var t=[],n=r=>{t.push(r)},i,s,o=Hu.getSymbolConstructor(),u=Hu.getTypeConstructor(),m=Hu.getSignatureConstructor(),d=0,S=0,E=0,x=0,D=0,w=0,R,L,F=!1,J=fa(),G=[1],q=e.getCompilerOptions(),ee=Ka(q),W=V_(q),pe=!!q.experimentalDecorators,K=$R(q),re=hG(q),ue=SA(q),ce=J_(q,"strictNullChecks"),ne=J_(q,"strictFunctionTypes"),le=J_(q,"strictBindCallApply"),me=J_(q,"strictPropertyInitialization"),de=J_(q,"noImplicitAny"),Ae=J_(q,"noImplicitThis"),xe=J_(q,"useUnknownInCatchVariables"),te=q.exactOptionalPropertyTypes,he=Gjt(),be=kJt(),Ve=oJ(),Pe=Hye(q,{isEntityNameVisible:bS,isExpandoFunctionDeclaration:zKe,getAllAccessorDeclarations:wq,requiresAddingImplicitUndefined:kne,isUndefinedIdentifierExpression(r){return M.assert(tg(r)),vm(r)===Be},isDefinitelyReferenceToGlobalSymbolObject:Ek}),ke=Bpe({evaluateElementAccessExpression:gVt,evaluateEntityNameExpression:CKe}),De=fa(),Be=Za(4,"undefined");Be.declarations=[];var ct=Za(1536,"globalThis",8);ct.exports=De,ct.declarations=[],De.set(ct.escapedName,ct);var qe=Za(4,"arguments"),et=Za(4,"require"),Ie=q.verbatimModuleSyntax?"verbatimModuleSyntax":"isolatedModules",_t=!q.verbatimModuleSyntax,mt,Xe,ht=0,rr,vr=0,xr=jG({compilerOptions:q,requireSymbol:et,argumentsSymbol:qe,globals:De,getSymbolOfDeclaration:jn,error:Qe,getRequiresScopeChangeCache:Ak,setRequiresScopeChangeCache:Zh,lookup:m_,onPropertyWithInvalidInitializer:t1,onFailedToResolveSymbol:B0,onSuccessfullyResolvedSymbol:hD}),jr=jG({compilerOptions:q,requireSymbol:et,argumentsSymbol:qe,globals:De,getSymbolOfDeclaration:jn,error:Qe,getRequiresScopeChangeCache:Ak,setRequiresScopeChangeCache:Zh,lookup:m9t});let ur={getNodeCount:()=>L_(e.getSourceFiles(),(r,a)=>r+a.nodeCount,0),getIdentifierCount:()=>L_(e.getSourceFiles(),(r,a)=>r+a.identifierCount,0),getSymbolCount:()=>L_(e.getSourceFiles(),(r,a)=>r+a.symbolCount,S),getTypeCount:()=>d,getInstantiationCount:()=>E,getRelationCacheSizes:()=>({assignable:Rf.size,identity:Hf.size,subtype:ih.size,strictSubtype:Rd.size}),isUndefinedSymbol:r=>r===Be,isArgumentsSymbol:r=>r===qe,isUnknownSymbol:r=>r===St,getMergedSymbol:ro,symbolIsValue:ey,getDiagnostics:IKe,getGlobalDiagnostics:UVt,getRecursionIdentity:dre,getUnmatchedProperties:_2e,getTypeOfSymbolAtLocation:(r,a)=>{let _=ks(a);return _?wFt(r,_):Oe},getTypeOfSymbol:gn,getSymbolsOfParameterPropertyDeclaration:(r,a)=>{let _=ks(r,ns);return _===void 0?M.fail("Cannot get symbols of a synthetic parameter that cannot be resolved to a parse-tree node."):(M.assert(ap(_,_.parent)),gD(_,Uc(a)))},getDeclaredTypeOfSymbol:ac,getPropertiesOfType:bo,getPropertyOfType:(r,a)=>ma(r,Uc(a)),getPrivateIdentifierPropertyOfType:(r,a,_)=>{let h=ks(_);if(!h)return;let T=Uc(a),C=sq(T,h);return C?Gre(r,C):void 0},getTypeOfPropertyOfType:(r,a)=>il(r,Uc(a)),getIndexInfoOfType:(r,a)=>Gy(r,a===0?Ue:Te),getIndexInfosOfType:X_,getIndexInfosOfIndexSymbol:axe,getSignaturesOfType:Ys,getIndexTypeOfType:(r,a)=>dT(r,a===0?Ue:Te),getIndexType:r=>dh(r),getBaseTypes:_i,getBaseTypeOfLiteralType:ev,getWidenedType:Qf,getWidenedLiteralType:ST,getTypeFromTypeNode:r=>{let a=ks(r,Di);return a?Wi(a):Oe},getParameterType:xg,getParameterIdentifierInfoAtPosition:ljt,getPromisedTypeOfPromise:nL,getAwaitedType:r=>_C(r),getReturnTypeOfSignature:ko,isNullableType:iq,getNullableType:UJ,getNonNullableType:tv,getNonOptionalType:yre,getTypeArguments:yc,typeToTypeNode:Ve.typeToTypeNode,indexInfoToIndexSignatureDeclaration:Ve.indexInfoToIndexSignatureDeclaration,signatureToSignatureDeclaration:Ve.signatureToSignatureDeclaration,symbolToEntityName:Ve.symbolToEntityName,symbolToExpression:Ve.symbolToExpression,symbolToNode:Ve.symbolToNode,symbolToTypeParameterDeclarations:Ve.symbolToTypeParameterDeclarations,symbolToParameterDeclaration:Ve.symbolToParameterDeclaration,typeParameterToDeclaration:Ve.typeParameterToDeclaration,getSymbolsInScope:(r,a)=>{let _=ks(r);return _?VVt(_,a):[]},getSymbolAtLocation:r=>{let a=ks(r);return a?vm(a,!0):void 0},getIndexInfosAtLocation:r=>{let a=ks(r);return a?YVt(a):void 0},getShorthandAssignmentValueSymbol:r=>{let a=ks(r);return a?KVt(a):void 0},getExportSpecifierLocalTargetSymbol:r=>{let a=ks(r,b_);return a?XVt(a):void 0},getExportSymbolOfSymbol(r){return ro(r.exportSymbol||r)},getTypeAtLocation:r=>{let a=ks(r);return a?tP(a):Oe},getTypeOfAssignmentPattern:r=>{let a=ks(r,TI);return a&&xne(a)||Oe},getPropertySymbolOfDestructuringAssignment:r=>{let a=ks(r,He);return a?QVt(a):void 0},signatureToString:(r,a,_,h)=>TS(r,ks(a),_,h),typeToString:(r,a,_)=>ln(r,ks(a),_),symbolToString:(r,a,_,h)=>rs(r,ks(a),_,h),typePredicateToString:(r,a,_)=>ty(r,ks(a),_),writeSignature:(r,a,_,h,T)=>TS(r,ks(a),_,h,T),writeType:(r,a,_,h)=>ln(r,ks(a),_,h),writeSymbol:(r,a,_,h,T)=>rs(r,ks(a),_,h,T),writeTypePredicate:(r,a,_,h)=>ty(r,ks(a),_,h),getAugmentedPropertiesOfType:ZCe,getRootSymbols:BKe,getSymbolOfExpando:ene,getContextualType:(r,a)=>{let _=ks(r,Ct);if(_)return a&4?Oi(_,()=>hf(_,a)):hf(_,a)},getContextualTypeForObjectLiteralElement:r=>{let a=ks(r,p0);return a?F2e(a,void 0):void 0},getContextualTypeForArgumentAtIndex:(r,a)=>{let _=ks(r,HT);return _&&L2e(_,a)},getContextualTypeForJsxAttribute:r=>{let a=ks(r,R5);return a&&sGe(a,void 0)},isContextSensitive:Ud,getTypeOfPropertyOfContextualType:ET,getFullyQualifiedName:uh,getResolvedSignature:(r,a,_)=>Sr(r,a,_,0),getCandidateSignaturesForStringLiteralCompletions:or,getResolvedSignatureForSignatureHelp:(r,a,_)=>Zr(r,()=>Sr(r,a,_,16)),getExpandedParameters:Xze,hasEffectiveRestParameter:uy,containsArgumentsReference:nxe,getConstantValue:r=>{let a=ks(r,WKe);return a?tAe(a):void 0},isValidPropertyAccess:(r,a)=>{let _=ks(r,i_e);return!!_&&y9t(_,Uc(a))},isValidPropertyAccessForCompletions:(r,a,_)=>{let h=ks(r,Wn);return!!h&&MGe(h,a,_)},getSignatureFromDeclaration:r=>{let a=ks(r,Bs);return a?md(a):void 0},isImplementationOfOverload:r=>{let a=ks(r,Bs);return a?qKe(a):void 0},getImmediateAliasedSymbol:Jre,getAliasedSymbol:Au,getEmitResolver:Qv,requiresAddingImplicitUndefined:kne,getExportsOfModule:$E,getExportsAndPropertiesOfModule:Ok,forEachExportAndPropertyOfModule:B2,getSymbolWalker:Pge(Y8t,Bd,ko,_i,Sg,gn,gf,mf,_p,yc),getAmbientModules:gqt,getJsxIntrinsicTagNamesAt:Q5t,isOptionalParameter:r=>{let a=ks(r,ns);return a?vJ(a):!1},tryGetMemberInModuleExports:(r,a)=>ud(Uc(r),a),tryGetMemberInModuleExportsAndProperties:(r,a)=>AD(Uc(r),a),tryFindAmbientModule:r=>txe(r,!0),tryFindAmbientModuleWithoutAugmentations:r=>txe(r,!1),getApparentType:K_,getUnionType:fi,isTypeAssignableTo:ga,createAnonymousType:Zt,createSignature:Hy,createSymbol:Za,createIndexInfo:oy,getAnyType:()=>Me,getStringType:()=>Ue,getStringLiteralType:Lf,getNumberType:()=>Te,getNumberLiteralType:zm,getBigIntType:()=>Re,createPromiseType:gq,createArrayType:g_,getElementTypeOfArrayType:BJ,getBooleanType:()=>qr,getFalseType:r=>r?It:$t,getTrueType:r=>r?Ht:dr,getVoidType:()=>dn,getUndefinedType:()=>nr,getNullType:()=>Ke,getESSymbolType:()=>Hr,getNeverType:()=>Ar,getOptionalType:()=>Q,getPromiseType:()=>EJ(!1),getPromiseLikeType:()=>jWe(!1),getAsyncIterableType:()=>{let r=Yte(!1);if(r!==Fa)return r},isSymbolAccessible:gg,isArrayType:Jd,isTupleType:Ha,isArrayLikeType:g1,isEmptyAnonymousObjectType:ly,isTypeInvalidDueToUnionDiscriminant:D8t,getExactOptionalProperties:aLt,getAllPossiblePropertiesOfTypes:w8t,getSuggestedSymbolForNonexistentProperty:Z2e,getSuggestedSymbolForNonexistentJSXAttribute:wGe,getSuggestedSymbolForNonexistentSymbol:(r,a,_)=>OGe(r,Uc(a),_),getSuggestedSymbolForNonexistentModule:eCe,getSuggestedSymbolForNonexistentClassMember:DGe,getBaseConstraintOfType:Zu,getDefaultFromTypeParameter:r=>r&&r.flags&262144?H2(r):void 0,resolveName(r,a,_,h){return xr(a,Uc(r),_,void 0,!1,h)},getJsxNamespace:r=>Qi(Hb(r)),getJsxFragmentFactory:r=>{let a=nAe(r);return a&&Qi(_p(a).escapedText)},getAccessibleSymbolChain:As,getTypePredicateOfSignature:Bd,resolveExternalModuleName:r=>{let a=ks(r,Ct);return a&&G_(a,a,!0)},resolveExternalModuleSymbol:Mf,tryGetThisTypeAt:(r,a,_)=>{let h=ks(r);return h&&O2e(h,a,_)},getTypeArgumentConstraint:r=>{let a=ks(r,Di);return a&&ABt(a)},getSuggestionDiagnostics:(r,a)=>{let _=ks(r,Ji)||M.fail("Could not determine parsed source file.");if(uO(_,q,e))return ve;let h;try{return i=a,KCe(_),M.assert(!!(qn(_).flags&1)),h=wn(h,N2.getDiagnostics(_.fileName)),KYe(wKe(_),(T,C,I)=>{!VP(T)&&!DKe(C,!!(T.flags&33554432))&&(h||(h=[])).push({...I,category:2})}),h||ve}finally{i=void 0}},runWithCancellationToken:(r,a)=>{try{return i=r,a(ur)}finally{i=void 0}},getLocalTypeParametersOfClassOrInterfaceOrTypeAlias:l1,isDeclarationVisible:H0,isPropertyAccessible:rCe,getTypeOnlyAliasDeclaration:lh,getMemberOverrideModifierStatus:sVt,isTypeParameterPossiblyReferenced:DJ,typeHasCallOrConstructSignatures:Cne,getSymbolFlags:Gf};function or(r,a){let _=new Set,h=[];Oi(a,()=>Sr(r,h,void 0,0));for(let T of h)_.add(T);h.length=0,Zr(a,()=>Sr(r,h,void 0,0));for(let T of h)_.add(T);return Is(_)}function Zr(r,a){if(r=Pr(r,q$),r){let _=[],h=[];for(;r;){let C=qn(r);if(_.push([C,C.resolvedSignature]),C.resolvedSignature=void 0,K1(r)){let I=as(jn(r)),V=I.type;h.push([I,V]),I.type=void 0}r=Pr(r.parent,q$)}let T=a();for(let[C,I]of _)C.resolvedSignature=I;for(let[C,I]of h)C.type=I;return T}return a()}function Oi(r,a){let _=Pr(r,HT);if(_){let T=r;do qn(T).skipDirectInference=!0,T=T.parent;while(T&&T!==_)}F=!0;let h=Zr(r,a);if(F=!1,_){let T=r;do qn(T).skipDirectInference=void 0,T=T.parent;while(T&&T!==_)}return h}function Sr(r,a,_,h){let T=ks(r,HT);mt=_;let C=T?ew(T,a,h):void 0;return mt=void 0,C}var Pi=new Map,Cs=new Map,ss=new Map,Ii=new Map,$r=new Map,Xs=new Map,$e=new Map,Yt=new Map,Vr=new Map,An=new Map,vi=new Map,Ci=new Map,Ui=new Map,la=new Map,Gs=new Map,yr=[],to=new Map,lt=new Set,St=Za(4,"unknown"),fe=Za(0,"__resolving__"),vt=new Map,Ce=new Map,nt=new Set,Me=Ll(1,"any"),tt=Ll(1,"any",262144,"auto"),ft=Ll(1,"any",void 0,"wildcard"),tr=Ll(1,"any",void 0,"blocked string"),Oe=Ll(1,"error"),At=Ll(1,"unresolved"),Nt=Ll(1,"any",65536,"non-inferrable"),Ut=Ll(1,"intrinsic"),Rt=Ll(2,"unknown"),nr=Ll(32768,"undefined"),Z=ce?nr:Ll(32768,"undefined",65536,"widening"),Ge=Ll(32768,"undefined",void 0,"missing"),bt=te?Ge:nr,Q=Ll(32768,"undefined",void 0,"optional"),Ke=Ll(65536,"null"),z=ce?Ke:Ll(65536,"null",65536,"widening"),Ue=Ll(4,"string"),Te=Ll(8,"number"),Re=Ll(64,"bigint"),It=Ll(512,"false",void 0,"fresh"),$t=Ll(512,"false"),Ht=Ll(512,"true",void 0,"fresh"),dr=Ll(512,"true");Ht.regularType=dr,Ht.freshType=Ht,dr.regularType=dr,dr.freshType=Ht,It.regularType=$t,It.freshType=It,$t.regularType=$t,$t.freshType=It;var qr=fi([$t,dr]),Hr=Ll(4096,"symbol"),dn=Ll(16384,"void"),Ar=Ll(131072,"never"),In=Ll(131072,"never",262144,"silent"),Ki=Ll(131072,"never",void 0,"implicit"),ls=Ll(131072,"never",void 0,"unreachable"),Yn=Ll(67108864,"object"),pi=fi([Ue,Te]),Er=fi([Ue,Te,Hr]),tn=fi([Te,Re]),er=fi([Ue,Te,qr,Re,Ke,nr]),qs=Y2(["",""],[Te]),uo=NJ(r=>r.flags&262144?I7t(r):r,()=>"(restrictive mapper)"),Mo=NJ(r=>r.flags&262144?ft:r,()=>"(permissive mapper)"),Do=Ll(131072,"never",void 0,"unique literal"),ms=NJ(r=>r.flags&262144?Do:r,()=>"(unique literal mapper)"),sa,Sc=NJ(r=>(sa&&(r===Jc||r===z_||r===W_)&&sa(!0),r),()=>"(unmeasurable reporter)"),ts=NJ(r=>(sa&&(r===Jc||r===z_||r===W_)&&sa(!1),r),()=>"(unreliable reporter)"),zi=Zt(void 0,J,ve,ve,ve),Eu=Zt(void 0,J,ve,ve,ve);Eu.objectFlags|=2048;var kc=Za(2048,"__type");kc.members=fa();var P_=Zt(kc,J,ve,ve,ve),el=Zt(void 0,J,ve,ve,ve),Xu=ce?fi([nr,Ke,el]):Rt,Fa=Zt(void 0,J,ve,ve,ve);Fa.instantiations=new Map;var bc=Zt(void 0,J,ve,ve,ve);bc.objectFlags|=262144;var Lo=Zt(void 0,J,ve,ve,ve),po=Zt(void 0,J,ve,ve,ve),_r=Zt(void 0,J,ve,ve,ve),Jc=fd(),z_=fd();z_.constraint=Jc;var W_=fd(),qf=fd(),mc=fd();mc.constraint=qf;var tl=C7(1,"<<unresolved>>",0,Me),Se=Hy(void 0,void 0,void 0,ve,Me,void 0,0,0),ae=Hy(void 0,void 0,void 0,ve,Oe,void 0,0,0),Ye=Hy(void 0,void 0,void 0,ve,Me,void 0,0,0),Ot=Hy(void 0,void 0,void 0,ve,In,void 0,0,0),Tr=oy(Te,Ue,!0),Vn=new Map,pr={get yieldType(){return M.fail("Not supported")},get returnType(){return M.fail("Not supported")},get nextType(){return M.fail("Not supported")}},Jn=v1(Me,Me,Me),Ri=v1(Me,Me,Rt),Ai=v1(Ar,Me,nr),Na={iterableCacheKey:"iterationTypesOfAsyncIterable",iteratorCacheKey:"iterationTypesOfAsyncIterator",iteratorSymbolName:"asyncIterator",getGlobalIteratorType:fMt,getGlobalIterableType:Yte,getGlobalIterableIteratorType:pMt,getGlobalGeneratorType:dMt,resolveIterationType:(r,a)=>_C(r,a,v.Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member),mustHaveANextMethodDiagnostic:v.An_async_iterator_must_have_a_next_method,mustBeAMethodDiagnostic:v.The_0_property_of_an_async_iterator_must_be_a_method,mustHaveAValueDiagnostic:v.The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property},gc={iterableCacheKey:"iterationTypesOfIterable",iteratorCacheKey:"iterationTypesOfIterator",iteratorSymbolName:"iterator",getGlobalIteratorType:mMt,getGlobalIterableType:gxe,getGlobalIterableIteratorType:gMt,getGlobalGeneratorType:hMt,resolveIterationType:(r,a)=>r,mustHaveANextMethodDiagnostic:v.An_iterator_must_have_a_next_method,mustBeAMethodDiagnostic:v.The_0_property_of_an_iterator_must_be_a_method,mustHaveAValueDiagnostic:v.The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property},Wl,Oc=new Map,du=new Map,hc,mu,zf,rl,$l,nd,Je,qt,Gr,gs,Qa,so,fl,au,Uo,Fo,Cl,Wf,fg,id,If,wd,sd,Gh,Yh,Of,Hl,Kh,$f,nh,ad,oe,yt,Gt,Xt,Fr,nn,Hn,Si,$,Fe,jt,Xr,Mi,Us,Ss,zs,vo,Wa,qc,Id,Om,Xh,Vy,$v,Jy,Od,od=new Map,Vo=0,d_=0,$_=0,Rm=!1,Hv=0,O0,pS,cm,dS=[],lm=[],Vb=[],pg=0,cd=[],R0=[],We=0,st=Lf(""),Jt=zm(0),sr=ere({negative:!1,base10Value:"0"}),kr=[],_n=[],Ir=[],kn=0,ji=!1,En=0,Ni=10,an=[],Ds=[],wa=[],xu=[],N_=[],um=[],Gv=[],_m=[],Sk=[],mD=[],bk=[],FE=[],Jb=[],qb=[],zb=[],P2=[],Yv=[],jE=[],qy=[],BE=0,_o=WI(),N2=WI(),D2=s1(),Wb,M0,ih=new Map,Rd=new Map,Rf=new Map,hp=new Map,Hf=new Map,Kv=new Map,Tk=[[".mts",".mjs"],[".ts",".js"],[".cts",".cjs"],[".mjs",".mjs"],[".js",".js"],[".cjs",".cjs"],[".tsx",q.jsx===1?".jsx":".js"],[".jsx",".jsx"],[".json",".json"]];return PJt(),ur;function Ek(r){return!Wn(r)||!He(r.name)||!Wn(r.expression)&&!He(r.expression)?!1:He(r.expression)?Nn(r.expression)==="Symbol"&&gf(r.expression)===(WD("Symbol",1160127,void 0)||St):He(r.expression.expression)?Nn(r.expression.name)==="Symbol"&&Nn(r.expression.expression)==="globalThis"&&gf(r.expression.expression)===ct:!1}function $b(r){return r?Gs.get(r):void 0}function Xv(r,a){return r&&Gs.set(r,a),a}function Hb(r){if(r){let a=Ur(r);if(a)if(_2(r)){if(a.localJsxFragmentNamespace)return a.localJsxFragmentNamespace;let _=a.pragmas.get("jsxfrag");if(_){let T=Rs(_)?_[0]:_;if(a.localJsxFragmentFactory=GA(T.arguments.factory,ee),ot(a.localJsxFragmentFactory,ou,Tf),a.localJsxFragmentFactory)return a.localJsxFragmentNamespace=_p(a.localJsxFragmentFactory).escapedText}let h=nAe(r);if(h)return a.localJsxFragmentFactory=h,a.localJsxFragmentNamespace=_p(h).escapedText}else{let _=xk(a);if(_)return a.localJsxNamespace=_}}return Wb||(Wb="React",q.jsxFactory?(M0=GA(q.jsxFactory,ee),ot(M0,ou),M0&&(Wb=_p(M0).escapedText)):q.reactNamespace&&(Wb=Uc(q.reactNamespace))),M0||(M0=U.createQualifiedName(U.createIdentifier(Qi(Wb)),"createElement")),Wb}function xk(r){if(r.localJsxNamespace)return r.localJsxNamespace;let a=r.pragmas.get("jsx");if(a){let _=Rs(a)?a[0]:a;if(r.localJsxFactory=GA(_.arguments.factory,ee),ot(r.localJsxFactory,ou,Tf),r.localJsxFactory)return r.localJsxNamespace=_p(r.localJsxFactory).escapedText}}function ou(r){return qg(r,-1,-1),Mr(r,ou,void 0)}function Qv(r,a,_){return _||IKe(r,a),be}function Ck(r,a,..._){let h=r?pn(r,a,..._):Nc(a,..._),T=_o.lookup(h);return T||(_o.add(h),h)}function dg(r,a,_,...h){let T=Qe(a,_,...h);return T.skippedOn=r,T}function w2(r,a,..._){return r?pn(r,a,..._):Nc(a,..._)}function Qe(r,a,..._){let h=w2(r,a,..._);return _o.add(h),h}function Mm(r,a){r?_o.add(a):N2.add({...a,category:2})}function Cu(r,a,_,...h){if(a.pos<0||a.end<0){if(!r)return;let T=Ur(a);Mm(r,"message"in _?bu(T,0,0,_,...h):pH(T,_));return}Mm(r,"message"in _?pn(a,_,...h):ky(Ur(a),a,_))}function Gb(r,a,_,...h){let T=Qe(r,_,...h);if(a){let C=pn(r,v.Did_you_forget_to_use_await);ca(T,C)}return T}function Qh(r,a){let _=Array.isArray(r)?kt(r,D$):D$(r);return _&&ca(a,pn(_,v.The_declaration_was_marked_as_deprecated_here)),N2.add(a),a}function Md(r){let a=Qu(r);return a&&wt(r.declarations)>1?a.flags&64?Pt(r.declarations,sh):wi(r.declarations,sh):!!r.valueDeclaration&&sh(r.valueDeclaration)||wt(r.declarations)&&wi(r.declarations,sh)}function sh(r){return!!(px(r)&536870912)}function L0(r,a,_){let h=pn(r,v._0_is_deprecated,_);return Qh(a,h)}function V6(r,a,_,h){let T=_?pn(r,v.The_signature_0_of_1_is_deprecated,h,_):pn(r,v._0_is_deprecated,h);return Qh(a,T)}function Za(r,a,_){S++;let h=new o(r|33554432,a);return h.links=new KRe,h.links.checkFlags=_||0,h}function Lm(r,a){let _=Za(1,r);return _.links.type=a,_}function UE(r,a){let _=Za(4,r);return _.links.type=a,_}function I2(r){let a=0;return r&2&&(a|=111551),r&1&&(a|=111550),r&4&&(a|=0),r&8&&(a|=900095),r&16&&(a|=110991),r&32&&(a|=899503),r&64&&(a|=788872),r&256&&(a|=899327),r&128&&(a|=899967),r&512&&(a|=110735),r&8192&&(a|=103359),r&32768&&(a|=46015),r&65536&&(a|=78783),r&262144&&(a|=526824),r&524288&&(a|=788968),r&2097152&&(a|=2097152),a}function O2(r,a){a.mergeId||(a.mergeId=GRe,GRe++),an[a.mergeId]=r}function Yb(r){let a=Za(r.flags,r.escapedName);return a.declarations=r.declarations?r.declarations.slice():[],a.parent=r.parent,r.valueDeclaration&&(a.valueDeclaration=r.valueDeclaration),r.constEnumOnlyModule&&(a.constEnumOnlyModule=!0),r.members&&(a.members=new Map(r.members)),r.exports&&(a.exports=new Map(r.exports)),O2(a,r),a}function F0(r,a,_=!1){if(!(r.flags&I2(a.flags))||(a.flags|r.flags)&67108864){if(a===r)return r;if(!(r.flags&33554432)){let C=pl(r);if(C===St)return a;if(!(C.flags&I2(a.flags))||(a.flags|C.flags)&67108864)r=Yb(C);else return h(r,a),a}a.flags&512&&r.flags&512&&r.constEnumOnlyModule&&!a.constEnumOnlyModule&&(r.constEnumOnlyModule=!1),r.flags|=a.flags,a.valueDeclaration&&SR(r,a.valueDeclaration),wn(r.declarations,a.declarations),a.members&&(r.members||(r.members=fa()),Ip(r.members,a.members,_)),a.exports&&(r.exports||(r.exports=fa()),Ip(r.exports,a.exports,_)),_||O2(r,a)}else r.flags&1024?r!==ct&&Qe(a.declarations&&Ps(a.declarations[0]),v.Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity,rs(r)):h(r,a);return r;function h(C,I){let V=!!(C.flags&384||I.flags&384),H=!!(C.flags&2||I.flags&2),X=V?v.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations:H?v.Cannot_redeclare_block_scoped_variable_0:v.Duplicate_identifier_0,_e=I.declarations&&Ur(I.declarations[0]),we=C.declarations&&Ur(C.declarations[0]),Ne=AI(_e,q.checkJs),pt=AI(we,q.checkJs),Tt=rs(I);if(_e&&we&&Wl&&!V&&_e!==we){let Mt=_0(_e.path,we.path)===-1?_e:we,mr=Mt===_e?we:_e,br=dv(Wl,`${Mt.path}|${mr.path}`,()=>({firstFile:Mt,secondFile:mr,conflictingSymbols:new Map})),en=dv(br.conflictingSymbols,Tt,()=>({isBlockScoped:H,firstFileLocations:[],secondFileLocations:[]}));Ne||T(en.firstFileLocations,I),pt||T(en.secondFileLocations,C)}else Ne||j0(I,X,Tt,C),pt||j0(C,X,Tt,I)}function T(C,I){if(I.declarations)for(let V of I.declarations)ol(C,V)}}function j0(r,a,_,h){kt(r.declarations,T=>{Kb(T,a,_,h.declarations)})}function Kb(r,a,_,h){let T=(lb(r,!1)?bH(r):Ps(r))||r,C=Ck(T,a,_);for(let I of h||ve){let V=(lb(I,!1)?bH(I):Ps(I))||I;if(V===T)continue;C.relatedInformation=C.relatedInformation||[];let H=pn(V,v._0_was_also_declared_here,_),X=pn(V,v.and_here);wt(C.relatedInformation)>=5||Pt(C.relatedInformation,_e=>rO(_e,X)===0||rO(_e,H)===0)||ca(C,wt(C.relatedInformation)?X:H)}}function ld(r,a){if(!r?.size)return a;if(!a?.size)return r;let _=fa();return Ip(_,r),Ip(_,a),_}function Ip(r,a,_=!1){a.forEach((h,T)=>{let C=r.get(T);r.set(T,C?F0(C,h,_):ro(h))})}function Zv(r){var a,_,h;let T=r.parent;if(((a=T.symbol.declarations)==null?void 0:a[0])!==T){M.assert(T.symbol.declarations.length>1);return}if(Rg(T))Ip(De,T.symbol.exports);else{let C=r.parent.parent.flags&33554432?void 0:v.Invalid_module_name_in_augmentation_module_0_cannot_be_found,I=j2(r,r,C,!0);if(!I)return;if(I=Mf(I),I.flags&1920)if(Pt(mu,V=>I===V.symbol)){let V=F0(T.symbol,I,!0);zf||(zf=new Map),zf.set(r.text,V)}else{if((_=I.exports)!=null&&_.get("__export")&&((h=T.symbol.exports)!=null&&h.size)){let V=BEe(I,"resolvedExports");for(let[H,X]of Is(T.symbol.exports.entries()))V.has(H)&&!I.exports.has(H)&&F0(V.get(H),X)}F0(I,T.symbol)}else Qe(r,v.Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity,r.text)}}function e1(){let r=Be.escapedName,a=De.get(r);a?kt(a.declarations,_=>{EA(_)||_o.add(pn(_,v.Declaration_name_conflicts_with_built_in_global_identifier_0,Qi(r)))}):De.set(r,Be)}function as(r){if(r.flags&33554432)return r.links;let a=Aa(r);return Ds[a]??(Ds[a]=new KRe)}function qn(r){let a=yo(r);return wa[a]||(wa[a]=new $Tt)}function m_(r,a,_){if(_){let h=ro(r.get(a));if(h&&(h.flags&_||h.flags&2097152&&Gf(h)&_))return h}}function gD(r,a){let _=r.parent,h=r.parent.parent,T=m_(_.locals,a,111551),C=m_(kS(h.symbol),a,111551);return T&&C?[T,C]:M.fail("There should exist two symbols, one as property declaration and one as parameter declaration")}function Fm(r,a){let _=Ur(r),h=Ur(a),T=eg(r);if(_!==h){if(W&&(_.externalModuleIndicator||h.externalModuleIndicator)||!q.outFile||_A(a)||r.flags&33554432||I(a,r))return!0;let H=e.getSourceFiles();return H.indexOf(_)<=H.indexOf(h)}if(a.flags&16777216||_A(a)||y2e(a))return!0;if(r.pos<=a.pos&&!(Ns(r)&&aR(a.parent)&&!r.initializer&&!r.exclamationToken)){if(r.kind===208){let H=pb(a,208);return H?Pr(H,Xa)!==Pr(r,Xa)||r.pos<H.pos:Fm(pb(r,260),a)}else{if(r.kind===260)return!C(r,a);if(gi(r)){let H=Pr(a,X=>X===r?"quit":za(X)?X.parent.parent===r:!pe&&fu(X)&&(X.parent===r||ul(X.parent)&&X.parent.parent===r||M3(X.parent)&&X.parent.parent===r||Ns(X.parent)&&X.parent.parent===r||ns(X.parent)&&X.parent.parent.parent===r));return H?!pe&&fu(H)?!!Pr(a,X=>X===H?"quit":Bs(X)&&!QT(X)):!1:!0}else{if(Ns(r))return!V(r,a,!1);if(ap(r,r.parent))return!(re&&Ou(r)===Ou(a)&&I(a,r))}}return!0}if(a.parent.kind===281||a.parent.kind===277&&a.parent.isExportEquals||a.kind===277&&a.isExportEquals)return!0;if(I(a,r))return re&&Ou(r)&&(Ns(r)||ap(r,r.parent))?!V(r,a,!0):!0;return!1;function C(H,X){switch(H.parent.parent.kind){case 243:case 248:case 250:if(U0(X,H,T))return!0;break}let _e=H.parent.parent;return $x(_e)&&U0(X,_e.expression,T)}function I(H,X){return!!Pr(H,_e=>{if(_e===T)return"quit";if(Bs(_e))return!0;if(Gc(_e))return X.pos<H.pos;let we=ai(_e.parent,Ns);if(we&&we.initializer===_e){if(oa(_e.parent)){if(X.kind===174)return!0;if(Ns(X)&&Ou(H)===Ou(X)){let pt=X.name;if(He(pt)||Zi(pt)){let Tt=gn(jn(X)),Mt=Zn(X.parent.members,Gc);if(_Vt(pt,Tt,Mt,X.parent.pos,_e.pos))return!0}}}else if(!(X.kind===172&&!oa(X))||Ou(H)!==Ou(X))return!0}return!1})}function V(H,X,_e){return X.end>H.end?!1:Pr(X,Ne=>{if(Ne===H)return"quit";switch(Ne.kind){case 219:return!0;case 172:return _e&&(Ns(H)&&Ne.parent===H.parent||ap(H,H.parent)&&Ne.parent===H.parent.parent)?"quit":!0;case 241:switch(Ne.parent.kind){case 177:case 174:case 178:return!0;default:return!1}default:return!1}})===void 0}}function Ak(r){return qn(r).declarationRequiresScopeChange}function Zh(r,a){qn(r).declarationRequiresScopeChange=a}function t1(r,a,_,h){return re?!1:(r&&!h&&VE(r,a,a)||Qe(r,r&&_.type&&P3(_.type,r.pos)?v.Type_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor:v.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor,Yo(_.name),Op(a)),!0)}function B0(r,a,_,h){let T=bs(a)?a:a.escapedText;n(()=>{if(!r||r.parent.kind!==324&&!VE(r,T,a)&&!sc(r)&&!yD(r,T,_)&&!kk(r,T)&&!D_(r,T,_)&&!J6(r,T,_)&&!R2(r,T,_)){let C,I;if(a&&(I=p9t(a),I&&Qe(r,h,Op(a),I)),!I&&En<Ni&&(C=OGe(r,T,_),C?.valueDeclaration&&B_(C.valueDeclaration)&&Rg(C.valueDeclaration)&&(C=void 0),C)){let H=rs(C),X=X2e(r,C,!1),_e=_===1920||a&&typeof a!="string"&&Ko(a)?v.Cannot_find_namespace_0_Did_you_mean_1:X?v.Could_not_find_name_0_Did_you_mean_1:v.Cannot_find_name_0_Did_you_mean_1,we=w2(r,_e,Op(a),H);we.canonicalHead=V_e(h,Op(a)),Mm(!X,we),C.valueDeclaration&&ca(we,pn(C.valueDeclaration,v._0_is_declared_here,H))}!C&&!I&&a&&Qe(r,h,Op(a)),En++}})}function hD(r,a,_,h,T,C){n(()=>{var I;let V=a.escapedName,H=h&&Ji(h)&&Uf(h);if(r&&(_&2||(_&32||_&384)&&(_&111551)===111551)){let X=Mp(a);(X.flags&2||X.flags&32||X.flags&384)&&Ls(X,r)}if(H&&(_&111551)===111551&&!(r.flags&16777216)){let X=ro(a);wt(X.declarations)&&wi(X.declarations,_e=>p8(_e)||Ji(_e)&&!!_e.symbol.globalExports)&&Cu(!q.allowUmdGlobalAccess,r,v._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead,Qi(V))}if(T&&!C&&(_&111551)===111551){let X=ro(Fte(a)),_e=Bg(T);X===jn(T)?Qe(r,v.Parameter_0_cannot_reference_itself,Yo(T.name)):X.valueDeclaration&&X.valueDeclaration.pos>T.pos&&_e.parent.locals&&m_(_e.parent.locals,X.escapedName,_)===X&&Qe(r,v.Parameter_0_cannot_reference_identifier_1_declared_after_it,Yo(T.name),Yo(r))}if(r&&_&111551&&a.flags&2097152&&!(a.flags&111551)&&!gb(r)){let X=lh(a,111551);if(X){let _e=X.kind===281||X.kind===278||X.kind===280?v._0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type:v._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type,we=Qi(V);Xb(Qe(r,_e,we),X,we)}}if(q.isolatedModules&&a&&H&&(_&111551)===111551){let _e=m_(De,V,_)===a&&Ji(h)&&h.locals&&m_(h.locals,V,-111552);if(_e){let we=(I=_e.declarations)==null?void 0:I.find(Ne=>Ne.kind===276||Ne.kind===273||Ne.kind===274||Ne.kind===271);we&&!vI(we)&&Qe(we,v.Import_0_conflicts_with_global_value_used_in_this_file_so_must_be_declared_with_a_type_only_import_when_isolatedModules_is_enabled,Qi(V))}}})}function Xb(r,a,_){return a?ca(r,pn(a,a.kind===281||a.kind===278||a.kind===280?v._0_was_exported_here:v._0_was_imported_here,_)):r}function Op(r){return bs(r)?Qi(r):Yo(r)}function VE(r,a,_){if(!He(r)||r.escapedText!==a||OKe(r)||_A(r))return!1;let h=nf(r,!1,!1),T=h;for(;T;){if(gi(T.parent)){let C=jn(T.parent);if(!C)break;let I=gn(C);if(ma(I,a))return Qe(r,v.Cannot_find_name_0_Did_you_mean_the_static_member_1_0,Op(_),rs(C)),!0;if(T===h&&!oa(T)){let V=ac(C).thisType;if(ma(V,a))return Qe(r,v.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0,Op(_)),!0}}T=T.parent}return!1}function sc(r){let a=zy(r);return a&&nl(a,64,!0)?(Qe(r,v.Cannot_extend_an_interface_0_Did_you_mean_implements,Hc(a)),!0):!1}function zy(r){switch(r.kind){case 80:case 211:return r.parent?zy(r.parent):void 0;case 233:if(nc(r.expression))return r.expression;default:return}}function yD(r,a,_){let h=1920|(hn(r)?111551:0);if(_===h){let T=pl(xr(r,a,788968&~h,void 0,!1)),C=r.parent;if(T){if(cf(C)){M.assert(C.left===r,"Should only be resolving left side of qualified name as a namespace");let I=C.right.escapedText;if(ma(ac(T),I))return Qe(C,v.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1,Qi(a),Qi(I)),!0}return Qe(r,v._0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here,Qi(a)),!0}}return!1}function R2(r,a,_){if(_&788584){let h=pl(xr(r,a,111127,void 0,!1));if(h&&!(h.flags&1920))return Qe(r,v._0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0,Qi(a)),!0}return!1}function JE(r){return r==="any"||r==="string"||r==="number"||r==="boolean"||r==="never"||r==="unknown"}function kk(r,a){return JE(a)&&r.parent.kind===281?(Qe(r,v.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module,a),!0):!1}function J6(r,a,_){if(_&111551){if(JE(a)){let C=r.parent.parent;if(C&&C.parent&&pp(C)){let I=C.token,V=C.parent.kind;V===264&&I===96?Qe(r,v.An_interface_cannot_extend_a_primitive_type_like_0_It_can_only_extend_other_named_object_types,Qi(a)):V===263&&I===96?Qe(r,v.A_class_cannot_extend_a_primitive_type_like_0_Classes_can_only_extend_constructable_values,Qi(a)):V===263&&I===119&&Qe(r,v.A_class_cannot_implement_a_primitive_type_like_0_It_can_only_implement_other_named_object_types,Qi(a))}else Qe(r,v._0_only_refers_to_a_type_but_is_being_used_as_a_value_here,Qi(a));return!0}let h=pl(xr(r,a,788544,void 0,!1)),T=h&&Gf(h);if(h&&T!==void 0&&!(T&111551)){let C=Qi(a);return Mn(a)?Qe(r,v._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later,C):vD(r,h)?Qe(r,v._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0,C,C==="K"?"P":"K"):Qe(r,v._0_only_refers_to_a_type_but_is_being_used_as_a_value_here,C),!0}}return!1}function vD(r,a){let _=Pr(r.parent,h=>za(h)||Nf(h)?!1:lf(h)||"quit");if(_&&_.members.length===1){let h=ac(a);return!!(h.flags&1048576)&&eL(h,384,!0)}return!1}function Mn(r){switch(r){case"Promise":case"Symbol":case"Map":case"WeakMap":case"Set":case"WeakSet":return!0}return!1}function D_(r,a,_){if(_&111127){if(pl(xr(r,a,1024,void 0,!1)))return Qe(r,v.Cannot_use_namespace_0_as_a_value,Qi(a)),!0}else if(_&788544&&pl(xr(r,a,1536,void 0,!1)))return Qe(r,v.Cannot_use_namespace_0_as_a_type,Qi(a)),!0;return!1}function Ls(r,a){var _;if(M.assert(!!(r.flags&2||r.flags&32||r.flags&384)),r.flags&67108881&&r.flags&32)return;let h=(_=r.declarations)==null?void 0:_.find(T=>nH(T)||gi(T)||T.kind===266);if(h===void 0)return M.fail("checkResolvedBlockScopedVariable could not find block-scoped declaration");if(!(h.flags&33554432)&&!Fm(h,a)){let T,C=Yo(Ps(h));r.flags&2?T=Qe(a,v.Block_scoped_variable_0_used_before_its_declaration,C):r.flags&32?T=Qe(a,v.Class_0_used_before_its_declaration,C):r.flags&256?T=Qe(a,v.Enum_0_used_before_its_declaration,C):(M.assert(!!(r.flags&128)),Cd(q)&&(T=Qe(a,v.Enum_0_used_before_its_declaration,C))),T&&ca(T,pn(h,v._0_is_declared_here,C))}}function U0(r,a,_){return!!a&&!!Pr(r,h=>h===a||(h===_||Bs(h)&&(!QT(h)||Rl(h)&3)?"quit":!1))}function M2(r){switch(r.kind){case 271:return r;case 273:return r.parent;case 274:return r.parent.parent;case 276:return r.parent.parent.parent;default:return}}function yp(r){return r.declarations&&xm(r.declarations,yn)}function yn(r){return r.kind===271||r.kind===270||r.kind===273&&!!r.name||r.kind===274||r.kind===280||r.kind===276||r.kind===281||r.kind===277&&ZP(r)||Pn(r)&&cl(r)===2&&ZP(r)||oc(r)&&Pn(r.parent)&&r.parent.left===r&&r.parent.operatorToken.kind===64&&Pk(r.parent.right)||r.kind===304||r.kind===303&&Pk(r.initializer)||r.kind===260&&ZT(r)||r.kind===208&&ZT(r.parent.parent)}function Pk(r){return PR(r)||ic(r)&&vh(r)}function Nk(r,a){let _=V0(r);if(_){let T=lN(_.expression).arguments[0];return He(_.name)?pl(ma(hWe(T),_.name.escapedText)):void 0}if(Ei(r)||r.moduleReference.kind===283){let T=G_(r,SH(r)||II(r)),C=Mf(T);return Fd(r,T,C,!1),C}let h=Ik(r.moduleReference,a);return H_(r,h),h}function H_(r,a){if(Fd(r,void 0,a,!1)&&!r.isTypeOnly){let _=lh(jn(r)),h=_.kind===281||_.kind===278,T=h?v.An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type:v.An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type,C=h?v._0_was_exported_here:v._0_was_imported_here,I=_.kind===278?"*":Qi(_.name.escapedText);ca(Qe(r.moduleReference,T),pn(_,C,I))}}function jm(r,a,_,h){let T=r.exports.get("export="),C=T?ma(gn(T),a,!0):r.exports.get(a),I=pl(C,h);return Fd(_,C,I,!1),I}function fm(r){return dc(r)&&!r.isExportEquals||li(r,2048)||b_(r)||zh(r)}function r1(r){return No(r)?e.getModeForUsageLocation(Ur(r),r):void 0}function qE(r,a){return r===99&&a===1}function ah(r){return r1(r)===99&&Wc(r.text,".json")}function vp(r,a,_,h){let T=r&&r1(h);if(r&&T!==void 0&&100<=W&&W<=199){let C=qE(T,r.impliedNodeFormat);if(T===99||C)return C}if(!ue)return!1;if(!r||r.isDeclarationFile){let C=jm(a,"default",void 0,!0);return!(C&&Pt(C.declarations,fm)||jm(a,Uc("__esModule"),void 0,_))}return Af(r)?typeof r.externalModuleIndicator!="object"&&!jm(a,Uc("__esModule"),void 0,_):sT(a)}function oh(r,a){let _=G_(r,r.parent.moduleSpecifier);if(_)return Ld(_,r,a)}function Ld(r,a,_){var h;let T;K3(r)?T=r:T=jm(r,"default",a,_);let C=(h=r.declarations)==null?void 0:h.find(Ji),I=Wy(a);if(!I)return T;let V=ah(I),H=vp(C,r,_,I);if(!T&&!H&&!V)if(sT(r)&&!ue){let X=W>=5?"allowSyntheticDefaultImports":"esModuleInterop",we=r.exports.get("export=").valueDeclaration,Ne=Qe(a.name,v.Module_0_can_only_be_default_imported_using_the_1_flag,rs(r),X);we&&ca(Ne,pn(we,v.This_module_is_declared_with_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag,X))}else ig(a)?Qb(r,a):Bm(r,r,a,GC(a)&&a.propertyName||a.name);else if(H||V){let X=Mf(r,_)||pl(r,_);return Fd(a,r,X,!1),X}return Fd(a,T,void 0,!1),T}function Wy(r){switch(r.kind){case 273:return r.parent.moduleSpecifier;case 271:return C0(r.moduleReference)?r.moduleReference.expression:void 0;case 274:return r.parent.parent.moduleSpecifier;case 276:return r.parent.parent.parent.moduleSpecifier;case 281:return r.parent.parent.moduleSpecifier;default:return M.assertNever(r)}}function Qb(r,a){var _,h,T;if((_=r.exports)!=null&&_.has(a.symbol.escapedName))Qe(a.name,v.Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead,rs(r),rs(a.symbol));else{let C=Qe(a.name,v.Module_0_has_no_default_export,rs(r)),I=(h=r.exports)==null?void 0:h.get("__export");if(I){let V=(T=I.declarations)==null?void 0:T.find(H=>{var X,_e;return!!(xl(H)&&H.moduleSpecifier&&((_e=(X=G_(H,H.moduleSpecifier))==null?void 0:X.exports)!=null&&_e.has("default")))});V&&ca(C,pn(V,v.export_Asterisk_does_not_re_export_a_default))}}}function Dk(r,a){let _=r.parent.parent.moduleSpecifier,h=G_(r,_),T=iT(h,_,a,!1);return Fd(r,h,T,!1),T}function L2(r,a){let _=r.parent.moduleSpecifier,h=_&&G_(r,_),T=_&&iT(h,_,a,!1);return Fd(r,h,T,!1),T}function zE(r,a){if(r===St&&a===St)return St;if(r.flags&790504)return r;let _=Za(r.flags|a.flags,r.escapedName);return M.assert(r.declarations||a.declarations),_.declarations=I1(ps(r.declarations,a.declarations),gv),_.parent=r.parent||a.parent,r.valueDeclaration&&(_.valueDeclaration=r.valueDeclaration),a.members&&(_.members=new Map(a.members)),r.exports&&(_.exports=new Map(r.exports)),_}function SD(r,a,_,h){var T;if(r.flags&1536){let C=Rp(r).get(a.escapedText),I=pl(C,h),V=(T=as(r).typeOnlyExportStarMap)==null?void 0:T.get(a.escapedText);return Fd(_,C,I,!1,V,a.escapedText),I}}function F2(r,a){if(r.flags&3){let _=r.valueDeclaration.type;if(_)return pl(ma(Wi(_),a))}}function Zb(r,a,_=!1){var h;let T=SH(r)||r.moduleSpecifier,C=G_(r,T),I=!Wn(a)&&a.propertyName||a.name;if(!He(I))return;let V=I.escapedText==="default"&&ue,H=iT(C,T,!1,V);if(H&&I.escapedText){if(K3(C))return C;let X;C&&C.exports&&C.exports.get("export=")?X=ma(gn(H),I.escapedText,!0):X=F2(H,I.escapedText),X=pl(X,_);let _e=SD(H,I,a,_);if(_e===void 0&&I.escapedText==="default"){let Ne=(h=C.declarations)==null?void 0:h.find(Ji);(ah(T)||vp(Ne,C,_,T))&&(_e=Mf(C,_)||pl(C,_))}let we=_e&&X&&_e!==X?zE(X,_e):_e||X;return we||Bm(C,H,r,I),we}}function Bm(r,a,_,h){var T;let C=uh(r,_),I=Yo(h),V=eCe(h,a);if(V!==void 0){let H=rs(V),X=Qe(h,v._0_has_no_exported_member_named_1_Did_you_mean_2,C,I,H);V.valueDeclaration&&ca(X,pn(V.valueDeclaration,v._0_is_declared_here,H))}else(T=r.exports)!=null&&T.has("default")?Qe(h,v.Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead,C,I):bD(_,h,I,r,C)}function bD(r,a,_,h,T){var C,I;let V=(I=(C=ai(h.valueDeclaration,Lh))==null?void 0:C.locals)==null?void 0:I.get(a.escapedText),H=h.exports;if(V){let X=H?.get("export=");if(X)Um(X,V)?eT(r,a,_,T):Qe(a,v.Module_0_has_no_exported_member_1,T,_);else{let _e=H?Ln(exe(H),Ne=>!!Um(Ne,V)):void 0,we=_e?Qe(a,v.Module_0_declares_1_locally_but_it_is_exported_as_2,T,_,rs(_e)):Qe(a,v.Module_0_declares_1_locally_but_it_is_not_exported,T,_);V.declarations&&ca(we,...Cr(V.declarations,(Ne,pt)=>pn(Ne,pt===0?v._0_is_declared_here:v.and_here,_)))}}else Qe(a,v.Module_0_has_no_exported_member_1,T,_)}function eT(r,a,_,h){if(W>=5){let T=Iy(q)?v._0_can_only_be_imported_by_using_a_default_import:v._0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;Qe(a,T,_)}else if(hn(r)){let T=Iy(q)?v._0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import:v._0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;Qe(a,T,_)}else{let T=Iy(q)?v._0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import:v._0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;Qe(a,T,_,_,h)}}function mS(r,a){if(_f(r)&&Nn(r.propertyName||r.name)==="default"){let I=Wy(r),V=I&&G_(r,I);if(V)return Ld(V,r,a)}let _=Xa(r)?Bg(r):r.parent.parent.parent,h=V0(_),T=Zb(_,h||r,a),C=r.propertyName||r.name;return h&&T&&He(C)?pl(ma(gn(T),C.escapedText),a):(Fd(r,void 0,T,!1),T)}function V0(r){if(Ei(r)&&r.initializer&&Wn(r.initializer))return r.initializer}function n1(r,a){if(Zm(r.parent)){let _=Mf(r.parent.symbol,a);return Fd(r,void 0,_,!1),_}}function pm(r,a,_){if(Nn(r.propertyName||r.name)==="default"){let T=Wy(r),C=T&&G_(r,T);if(C)return Ld(C,r,!!_)}let h=r.parent.parent.moduleSpecifier?Zb(r.parent.parent,r,_):nl(r.propertyName||r.name,a,!1,_);return Fd(r,void 0,h,!1),h}function i1(r,a){let _=dc(r)?r.expression:r.right,h=tT(_,a);return Fd(r,void 0,h,!1),h}function tT(r,a){if(eu(r))return yl(r).symbol;if(!Tf(r)&&!nc(r))return;let _=nl(r,901119,!0,a);return _||(yl(r),qn(r).resolvedSymbol)}function wu(r,a){if(Pn(r.parent)&&r.parent.left===r&&r.parent.operatorToken.kind===64)return tT(r.parent.right,a)}function J0(r,a=!1){switch(r.kind){case 271:case 260:return Nk(r,a);case 273:return oh(r,a);case 274:return Dk(r,a);case 280:return L2(r,a);case 276:case 208:return mS(r,a);case 281:return pm(r,901119,a);case 277:case 226:return i1(r,a);case 270:return n1(r,a);case 304:return nl(r.name,901119,!0,a);case 303:return tT(r.initializer,a);case 212:case 211:return wu(r,a);default:return M.fail()}}function ch(r,a=901119){return r?(r.flags&(2097152|a))===2097152||!!(r.flags&2097152&&r.flags&67108864):!1}function pl(r,a){return!a&&ch(r)?Au(r):r}function Au(r){M.assert((r.flags&2097152)!==0,"Should only get Alias here.");let a=as(r);if(a.aliasTarget)a.aliasTarget===fe&&(a.aliasTarget=St);else{a.aliasTarget=fe;let _=yp(r);if(!_)return M.fail();let h=J0(_);a.aliasTarget===fe?a.aliasTarget=h||St:Qe(_,v.Circular_definition_of_import_alias_0,rs(r))}return a.aliasTarget}function q0(r){if(as(r).aliasTarget!==fe)return Au(r)}function Gf(r,a,_){let h=a&&lh(r),T=h&&xl(h),C=h&&(T?G_(h.moduleSpecifier,h.moduleSpecifier,!0):Au(h.symbol)),I=T&&C?mg(C):void 0,V=_?0:r.flags,H;for(;r.flags&2097152;){let X=Mp(Au(r));if(!T&&X===C||I?.get(X.escapedName)===X)break;if(X===St)return-1;if(X===r||H?.has(X))break;X.flags&2097152&&(H?H.add(X):H=new Set([r,X])),V|=X.flags,r=X}return V}function Fd(r,a,_,h,T,C){if(!r||Wn(r))return!1;let I=jn(r);if(ib(r)){let H=as(I);return H.typeOnlyDeclaration=r,!0}if(T){let H=as(I);return H.typeOnlyDeclaration=T,I.escapedName!==C&&(H.typeOnlyExportStarName=C),!0}let V=as(I);return wk(V,a,h)||wk(V,_,h)}function wk(r,a,_){var h;if(a&&(r.typeOnlyDeclaration===void 0||_&&r.typeOnlyDeclaration===!1)){let T=((h=a.exports)==null?void 0:h.get("export="))??a,C=T.declarations&&Ln(T.declarations,ib);r.typeOnlyDeclaration=C??as(T).typeOnlyDeclaration??!1}return!!r.typeOnlyDeclaration}function lh(r,a){var _;if(!(r.flags&2097152))return;let h=as(r);if(h.typeOnlyDeclaration===void 0){h.typeOnlyDeclaration=!1;let T=pl(r);Fd((_=r.declarations)==null?void 0:_[0],yp(r)&&Jre(r),T,!0)}if(a===void 0)return h.typeOnlyDeclaration||void 0;if(h.typeOnlyDeclaration){let T=h.typeOnlyDeclaration.kind===278?pl(mg(h.typeOnlyDeclaration.symbol.parent).get(h.typeOnlyExportStarName||r.escapedName)):Au(h.typeOnlyDeclaration.symbol);return Gf(T)&a?h.typeOnlyDeclaration:void 0}}function Ik(r,a){return r.kind===80&&YI(r)&&(r=r.parent),r.kind===80||r.parent.kind===166?nl(r,1920,!1,a):(M.assert(r.parent.kind===271),nl(r,901119,!1,a))}function uh(r,a){return r.parent?uh(r.parent,a)+"."+rs(r):rs(r,a,void 0,36)}function gS(r){for(;cf(r.parent);)r=r.parent;return r}function TD(r){let a=_p(r),_=xr(a,a,111551,void 0,!0);if(_){for(;cf(a.parent);){let h=gn(_);if(_=ma(h,a.parent.right.escapedText),!_)return;a=a.parent}return _}}function nl(r,a,_,h,T){if($c(r))return;let C=1920|(hn(r)?a&111551:0),I;if(r.kind===80){let V=a===C||Ko(r)?v.Cannot_find_namespace_0:_He(_p(r)),H=hn(r)&&!Ko(r)?ED(r,a):void 0;if(I=ro(xr(T||r,r,a,_||H?void 0:V,!0,!1)),!I)return ro(H)}else if(r.kind===166||r.kind===211){let V=r.kind===166?r.left:r.expression,H=r.kind===166?r.right:r.name,X=nl(V,C,_,!1,T);if(!X||$c(H))return;if(X===St)return X;if(X.valueDeclaration&&hn(X.valueDeclaration)&&af(q)!==100&&Ei(X.valueDeclaration)&&X.valueDeclaration.initializer&&nYe(X.valueDeclaration.initializer)){let _e=X.valueDeclaration.initializer.arguments[0],we=G_(_e,_e);if(we){let Ne=Mf(we);Ne&&(X=Ne)}}if(I=ro(m_(Rp(X),H.escapedText,a)),!I&&X.flags&2097152&&(I=ro(m_(Rp(Au(X)),H.escapedText,a))),!I){if(!_){let _e=uh(X),we=Yo(H),Ne=eCe(H,X);if(Ne){Qe(H,v._0_has_no_exported_member_named_1_Did_you_mean_2,_e,we,rs(Ne));return}let pt=cf(r)&&gS(r);if(rl&&a&788968&&pt&&!vN(pt.parent)&&TD(pt)){Qe(pt,v._0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0,op(pt));return}if(a&1920&&cf(r.parent)){let Mt=ro(m_(Rp(X),H.escapedText,788968));if(Mt){Qe(r.parent.right,v.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1,rs(Mt),Qi(r.parent.right.escapedText));return}}Qe(H,v.Namespace_0_has_no_exported_member_1,_e,we)}return}}else M.assertNever(r,"Unknown entity name kind.");return!Ko(r)&&Tf(r)&&(I.flags&2097152||r.parent.kind===277)&&Fd(DH(r),I,void 0,!0),I.flags&a||h?I:Au(I)}function ED(r,a){if(Hte(r.parent)){let _=xD(r.parent);if(_)return xr(_,r,a,void 0,!0)}}function xD(r){if(Pr(r,T=>FP(T)||T.flags&16777216?Xd(T):"quit"))return;let _=tE(r);if(_&&Du(_)&&vR(_.expression)){let T=jn(_.expression.left);if(T)return rT(T)}if(_&&ic(_)&&vR(_.parent)&&Du(_.parent.parent)){let T=jn(_.parent.left);if(T)return rT(T)}if(_&&(Nm(_)||ql(_))&&Pn(_.parent.parent)&&cl(_.parent.parent)===6){let T=jn(_.parent.parent.left);if(T)return rT(T)}let h=_b(r);if(h&&Bs(h)){let T=jn(h);return T&&T.valueDeclaration}}function rT(r){let a=r.parent.valueDeclaration;return a?(OI(a)?iA(a):Hx(a)?RI(a):void 0)||a:void 0}function q6(r){let a=r.valueDeclaration;if(!a||!hn(a)||r.flags&524288||lb(a,!1))return;let _=Ei(a)?RI(a):iA(a);if(_){let h=_d(_);if(h)return uCe(h,r)}}function G_(r,a,_){let T=af(q)===1?v.Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_nodenext_or_to_add_aliases_to_the_paths_option:v.Cannot_find_module_0_or_its_corresponding_type_declarations;return j2(r,a,_?void 0:T)}function j2(r,a,_,h=!1){return No(a)?WE(r,a.text,_,a,h):void 0}function WE(r,a,_,h,T=!1){var C,I,V,H,X,_e,we,Ne,pt,Tt,Mt;if(_s(a,"@types/")){let si=v.Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1,Ea=Yw(a,"@types/");Qe(h,si,Ea,a)}let mr=txe(a,!0);if(mr)return mr;let br=Ur(r),en=No(r)?r:((C=El(r)?r:r.parent&&El(r.parent)&&r.parent.name===r?r.parent:void 0)==null?void 0:C.name)||((I=Ev(r)?r:void 0)==null?void 0:I.argument.literal)||(hn(r)&&Xg(r)?r.moduleSpecifier:void 0)||(Ei(r)&&r.initializer&&kf(r.initializer,!0)?r.initializer.arguments[0]:void 0)||((V=Pr(r,Np))==null?void 0:V.arguments[0])||((H=Pr(r,Yc))==null?void 0:H.moduleSpecifier)||((X=Pr(r,cb))==null?void 0:X.moduleReference.expression)||((_e=Pr(r,xl))==null?void 0:_e.moduleSpecifier),Fn=en&&No(en)?e.getModeForUsageLocation(br,en):br.impliedNodeFormat,Dr=af(q),zr=(we=e.getResolvedModule(br,a,Fn))==null?void 0:we.resolvedModule,Qr=zr&&_X(q,zr,br),$n=zr&&(!Qr||Qr===v.Module_0_was_resolved_to_1_but_jsx_is_not_set)&&e.getSourceFile(zr.resolvedFileName);if($n){if(Qr&&Qe(h,Qr,a,zr.resolvedFileName),zr.resolvedUsingTsExtension&&Mu(a)){let si=((Ne=Pr(r,Yc))==null?void 0:Ne.importClause)||Pr(r,Jp(ru,xl));(si&&!si.isTypeOnly||Pr(r,Np))&&Qe(h,v.A_declaration_file_cannot_be_imported_without_import_type_Did_you_mean_to_import_an_implementation_file_0_instead,ii(M.checkDefined(M9(a))))}else if(zr.resolvedUsingTsExtension&&!MN(q,br.fileName)){let si=((pt=Pr(r,Yc))==null?void 0:pt.importClause)||Pr(r,Jp(ru,xl));if(!(si?.isTypeOnly||Pr(r,qh))){let Ea=M.checkDefined(M9(a));Qe(h,v.An_import_path_can_only_end_with_a_0_extension_when_allowImportingTsExtensions_is_enabled,Ea)}}if($n.symbol){if(zr.isExternalLibraryImport&&!oO(zr.extension)&&nT(!1,h,br,Fn,zr,a),Dr===3||Dr===99){let si=br.impliedNodeFormat===1&&!Pr(r,Np)||!!Pr(r,ru),Ea=Pr(r,Ks=>qh(Ks)||xl(Ks)||Yc(Ks)||Xg(Ks));if(si&&$n.impliedNodeFormat===99&&!jpe(Ea))if(Pr(r,ru))Qe(h,v.Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_cannot_be_imported_with_require_Use_an_ECMAScript_import_instead,a);else{let Ks,no=b0(br.fileName);if(no===".ts"||no===".js"||no===".tsx"||no===".jsx"){let Os=br.packageJsonScope,Rc=no===".ts"?".mts":no===".js"?".mjs":void 0;Os&&!Os.contents.packageJsonContent.type?Rc?Ks=js(void 0,v.To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_add_the_field_type_Colon_module_to_1,Rc,ri(Os.packageDirectory,"package.json")):Ks=js(void 0,v.To_convert_this_file_to_an_ECMAScript_module_add_the_field_type_Colon_module_to_0,ri(Os.packageDirectory,"package.json")):Rc?Ks=js(void 0,v.To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_create_a_local_package_json_file_with_type_Colon_module,Rc):Ks=js(void 0,v.To_convert_this_file_to_an_ECMAScript_module_create_a_local_package_json_file_with_type_Colon_module)}_o.add(ky(Ur(h),h,js(Ks,v.The_current_file_is_a_CommonJS_module_whose_imports_will_produce_require_calls_however_the_referenced_file_is_an_ECMAScript_module_and_cannot_be_imported_with_require_Consider_writing_a_dynamic_import_0_call_instead,a)))}}return ro($n.symbol)}_&&Qe(h,v.File_0_is_not_a_module,$n.fileName);return}if(mu){let si=BW(mu,Ea=>Ea.pattern,a);if(si){let Ea=zf&&zf.get(a);return ro(Ea||si.symbol)}}if(zr&&!oO(zr.extension)&&Qr===void 0||Qr===v.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type){if(T){let si=v.Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented;Qe(h,si,a,zr.resolvedFileName)}else nT(de&&!!_,h,br,Fn,zr,a);return}if(_){if(zr){let si=e.getProjectReferenceRedirect(zr.resolvedFileName);if(si){Qe(h,v.Output_file_0_has_not_been_built_from_source_file_1,si,zr.resolvedFileName);return}}if(Qr)Qe(h,Qr,a,zr.resolvedFileName);else{let si=qp(a)&&!kP(a),Ea=Dr===3||Dr===99;if(!cE(q)&&Ic(a,".json")&&Dr!==1&&G9(q))Qe(h,v.Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension,a);else if(Fn===99&&Ea&&si){let Ks=xs(a,mi(br.path)),no=(Tt=Tk.find(([Os,Rc])=>e.fileExists(Ks+Os)))==null?void 0:Tt[1];no?Qe(h,v.Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_node16_or_nodenext_Did_you_mean_0,a+no):Qe(h,v.Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_node16_or_nodenext_Consider_adding_an_extension_to_the_import_path)}else if((Mt=e.getResolvedModule(br,a,Fn))!=null&&Mt.alternateResult){let Ks=J5(br,e,a,Fn,a);Cu(!0,h,js(Ks,_,a))}else Qe(h,_,a)}}return;function ii(si){let Ea=YR(a,si);if(H9(W)||Fn===99){let Ks=Mu(a)&&MN(q);return Ea+(si===".mts"||si===".d.mts"?Ks?".mts":".mjs":si===".cts"||si===".d.mts"?Ks?".cts":".cjs":Ks?".ts":".js")}return Ea}}function nT(r,a,_,h,{packageId:T,resolvedFileName:C},I){let V;!vu(I)&&T&&(V=J5(_,e,I,h,T.name)),Cu(r,a,js(V,v.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type,I,C))}function Mf(r,a){if(r?.exports){let _=pl(r.exports.get("export="),a),h=z6(ro(_),ro(r));return ro(h)||r}}function z6(r,a){if(!r||r===St||r===a||a.exports.size===1||r.flags&2097152)return r;let _=as(r);if(_.cjsExportMerged)return _.cjsExportMerged;let h=r.flags&33554432?r:Yb(r);return h.flags=h.flags|512,h.exports===void 0&&(h.exports=fa()),a.exports.forEach((T,C)=>{C!=="export="&&h.exports.set(C,h.exports.has(C)?F0(h.exports.get(C),T):T)}),h===r&&(as(h).resolvedExports=void 0,as(h).resolvedMembers=void 0),as(h).cjsExportMerged=h,_.cjsExportMerged=h}function iT(r,a,_,h){var T;let C=Mf(r,_);if(!_&&C){if(!h&&!(C.flags&1539)&&!Pc(C,307)){let V=W>=5?"allowSyntheticDefaultImports":"esModuleInterop";return Qe(a,v.This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export,V),C}let I=a.parent;if(Yc(I)&&KP(I)||Np(I)){let V=Np(I)?I.arguments[0]:I.moduleSpecifier,H=gn(C),X=tYe(H,C,r,V);if(X)return CD(C,X,I);let _e=(T=r?.declarations)==null?void 0:T.find(Ji),we=_e&&qE(r1(V),_e.impliedNodeFormat);if(Iy(q)||we){let Ne=yJ(H,0);if((!Ne||!Ne.length)&&(Ne=yJ(H,1)),Ne&&Ne.length||ma(H,"default",!0)||we){let pt=H.flags&3670016?rYe(H,C,r,V):_Ce(C,C.parent);return CD(C,pt,I)}}}}return C}function CD(r,a,_){let h=Za(r.flags,r.escapedName);h.declarations=r.declarations?r.declarations.slice():[],h.parent=r.parent,h.links.target=r,h.links.originatingImport=_,r.valueDeclaration&&(h.valueDeclaration=r.valueDeclaration),r.constEnumOnlyModule&&(h.constEnumOnlyModule=!0),r.members&&(h.members=new Map(r.members)),r.exports&&(h.exports=new Map(r.exports));let T=Sg(a);return h.links.type=Zt(h,T.members,ve,ve,T.indexInfos),h}function sT(r){return r.exports.get("export=")!==void 0}function $E(r){return exe(mg(r))}function Ok(r){let a=$E(r),_=Mf(r);if(_!==r){let h=gn(_);hS(h)&&wn(a,bo(h))}return a}function B2(r,a){mg(r).forEach((T,C)=>{q2(C)||a(T,C)});let h=Mf(r);if(h!==r){let T=gn(h);hS(T)&&N8t(T,(C,I)=>{a(C,I)})}}function ud(r,a){let _=mg(a);if(_)return _.get(r)}function AD(r,a){let _=ud(r,a);if(_)return _;let h=Mf(a);if(h===a)return;let T=gn(h);return hS(T)?ma(T,r):void 0}function hS(r){return!(r.flags&402784252||Kn(r)&1||Jd(r)||Ha(r))}function Rp(r){return r.flags&6256?BEe(r,"resolvedExports"):r.flags&1536?mg(r):r.exports||J}function mg(r){let a=as(r);if(!a.resolvedExports){let{exports:_,typeOnlyExportStarMap:h}=V2(r);a.resolvedExports=_,a.typeOnlyExportStarMap=h}return a.resolvedExports}function U2(r,a,_,h){a&&a.forEach((T,C)=>{if(C==="default")return;let I=r.get(C);if(!I)r.set(C,T),_&&h&&_.set(C,{specifierText:Hc(h.moduleSpecifier)});else if(_&&h&&I&&pl(I)!==pl(T)){let V=_.get(C);V.exportsWithDuplicate?V.exportsWithDuplicate.push(h):V.exportsWithDuplicate=[h]}})}function V2(r){let a=[],_,h=new Set;r=Mf(r);let T=C(r)||J;return _&&h.forEach(I=>_.delete(I)),{exports:T,typeOnlyExportStarMap:_};function C(I,V,H){if(!H&&I?.exports&&I.exports.forEach((we,Ne)=>h.add(Ne)),!(I&&I.exports&&ol(a,I)))return;let X=new Map(I.exports),_e=I.exports.get("__export");if(_e){let we=fa(),Ne=new Map;if(_e.declarations)for(let pt of _e.declarations){let Tt=G_(pt,pt.moduleSpecifier),Mt=C(Tt,pt,H||pt.isTypeOnly);U2(we,Mt,Ne,pt)}Ne.forEach(({exportsWithDuplicate:pt},Tt)=>{if(!(Tt==="export="||!(pt&&pt.length)||X.has(Tt)))for(let Mt of pt)_o.add(pn(Mt,v.Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity,Ne.get(Tt).specifierText,Qi(Tt)))}),U2(X,we)}return V?.isTypeOnly&&(_??(_=new Map),X.forEach((we,Ne)=>_.set(Ne,V))),X}}function ro(r){let a;return r&&r.mergeId&&(a=an[r.mergeId])?a:r}function jn(r){return ro(r.symbol&&Fte(r.symbol))}function _d(r){return Zm(r)?jn(r):void 0}function Qu(r){return ro(r.parent&&Fte(r.parent))}function kD(r){var a,_;return(((a=r.valueDeclaration)==null?void 0:a.kind)===219||((_=r.valueDeclaration)==null?void 0:_.kind)===218)&&_d(r.valueDeclaration.parent)||r}function PD(r,a){let _=Ur(a),h=yo(_),T=as(r),C;if(T.extendedContainersByFile&&(C=T.extendedContainersByFile.get(h)))return C;if(_&&_.imports){for(let V of _.imports){if(Ko(V))continue;let H=G_(a,V,!0);!H||!vS(H,r)||(C=Bt(C,H))}if(wt(C))return(T.extendedContainersByFile||(T.extendedContainersByFile=new Map)).set(h,C),C}if(T.extendedContainers)return T.extendedContainers;let I=e.getSourceFiles();for(let V of I){if(!nu(V))continue;let H=jn(V);vS(H,r)&&(C=Bt(C,H))}return T.extendedContainers=C||ve}function aT(r,a,_){let h=Qu(r);if(h&&!(r.flags&262144))return H(h);let T=Gi(r.declarations,_e=>{if(!B_(_e)&&_e.parent){if($0(_e.parent))return jn(_e.parent);if(Hg(_e.parent)&&_e.parent.parent&&Mf(jn(_e.parent.parent))===r)return jn(_e.parent.parent)}if(eu(_e)&&Pn(_e.parent)&&_e.parent.operatorToken.kind===64&&oc(_e.parent.left)&&nc(_e.parent.left.expression))return Py(_e.parent.left)||Xx(_e.parent.left.expression)?jn(Ur(_e)):(yl(_e.parent.left.expression),qn(_e.parent.left.expression).resolvedSymbol)});if(!wt(T))return;let C=Gi(T,_e=>vS(_e,r)?_e:void 0),I=[],V=[];for(let _e of C){let[we,...Ne]=H(_e);I=Bt(I,we),V=wn(V,Ne)}return ps(I,V);function H(_e){let we=Gi(_e.declarations,X),Ne=a&&PD(r,a),pt=yS(_e,_);if(a&&_e.flags&fs(_)&&As(_e,a,1920,!1))return Bt(ps(ps([_e],we),Ne),pt);let Tt=!(_e.flags&fs(_))&&_e.flags&788968&&ac(_e).flags&524288&&_===111551?ys(a,mr=>Nu(mr,br=>{if(br.flags&fs(_)&&gn(br)===ac(_e))return br})):void 0,Mt=Tt?[Tt,...we,_e]:[...we,_e];return Mt=Bt(Mt,pt),Mt=wn(Mt,Ne),Mt}function X(_e){return h&&ND(_e,h)}}function yS(r,a){let _=!!wt(r.declarations)&&Ma(r.declarations);if(a&111551&&_&&_.parent&&Ei(_.parent)&&(Ca(_)&&_===_.parent.initializer||lf(_)&&_===_.parent.type))return jn(_.parent)}function ND(r,a){let _=GE(r),h=_&&_.exports&&_.exports.get("export=");return h&&Um(h,a)?_:void 0}function vS(r,a){if(r===Qu(a))return a;let _=r.exports&&r.exports.get("export=");if(_&&Um(_,a))return r;let h=Rp(r),T=h.get(a.escapedName);return T&&Um(T,a)?T:Nu(h,C=>{if(Um(C,a))return C})}function Um(r,a){if(ro(pl(ro(r)))===ro(pl(ro(a))))return r}function Mp(r){return ro(r&&(r.flags&1048576)!==0&&r.exportSymbol||r)}function ey(r,a){return!!(r.flags&111551||r.flags&2097152&&Gf(r,!a)&111551)}function _h(r){var a;let _=new u(ur,r);return d++,_.id=d,(a=Cn)==null||a.recordType(_),_}function z0(r,a){let _=_h(r);return _.symbol=a,_}function J2(r){return new u(ur,r)}function Ll(r,a,_=0,h){Vm(a,h);let T=_h(r);return T.intrinsicName=a,T.debugIntrinsicName=h,T.objectFlags=_|524288|2097152|33554432|16777216,T}function Vm(r,a){let _=`${r},${a??""}`;nt.has(_)&&M.fail(`Duplicate intrinsic type name ${r}${a?` (${a})`:""}; you may need to pass a name to createIntrinsicType.`),nt.add(_)}function Lp(r,a){let _=z0(524288,a);return _.objectFlags=r,_.members=void 0,_.properties=void 0,_.callSignatures=void 0,_.constructSignatures=void 0,_.indexInfos=void 0,_}function s1(){return fi(Is(Mge.keys(),Lf))}function fd(r){return z0(262144,r)}function q2(r){return r.charCodeAt(0)===95&&r.charCodeAt(1)===95&&r.charCodeAt(2)!==95&&r.charCodeAt(2)!==64&&r.charCodeAt(2)!==35}function SS(r){let a;return r.forEach((_,h)=>{O(_,h)&&(a||(a=[])).push(_)}),a||ve}function O(r,a){return!q2(a)&&ey(r)}function ye(r){let a=SS(r),_=Jte(r);return _?ps(a,[_]):a}function Dt(r,a,_,h,T){let C=r;return C.members=a,C.properties=ve,C.callSignatures=_,C.constructSignatures=h,C.indexInfos=T,a!==J&&(C.properties=SS(a)),C}function Zt(r,a,_,h,T){return Dt(Lp(16,r),a,_,h,T)}function bi(r){if(r.constructSignatures.length===0)return r;if(r.objectTypeWithoutAbstractConstructSignatures)return r.objectTypeWithoutAbstractConstructSignatures;let a=Zn(r.constructSignatures,h=>!(h.flags&4));if(r.constructSignatures===a)return r;let _=Zt(r.symbol,r.members,r.callSignatures,Pt(a)?a:ve,r.indexInfos);return r.objectTypeWithoutAbstractConstructSignatures=_,_.objectTypeWithoutAbstractConstructSignatures=_,_}function ys(r,a){let _;for(let h=r;h;h=h.parent){if(Lh(h)&&h.locals&&!Tv(h)&&(_=a(h.locals,void 0,!0,h)))return _;switch(h.kind){case 307:if(!Uf(h))break;case 267:let T=jn(h);if(_=a(T?.exports||J,void 0,!0,h))return _;break;case 263:case 231:case 264:let C;if((jn(h).members||J).forEach((I,V)=>{I.flags&788968&&(C||(C=fa())).set(V,I)}),C&&(_=a(C,void 0,!1,h)))return _;break}}return a(De,void 0,!0)}function fs(r){return r===111551?111551:1920}function As(r,a,_,h,T=new Map){if(!(r&&!Y_(r)))return;let C=as(r),I=C.accessibleChainCache||(C.accessibleChainCache=new Map),V=ys(a,(br,en,Fn,Dr)=>Dr),H=`${h?0:1}|${V&&yo(V)}|${_}`;if(I.has(H))return I.get(H);let X=Aa(r),_e=T.get(X);_e||T.set(X,_e=[]);let we=ys(a,Ne);return I.set(H,we),we;function Ne(br,en,Fn){if(!ol(_e,br))return;let Dr=Mt(br,en,Fn);return _e.pop(),Dr}function pt(br,en){return!Ia(br,a,en)||!!As(br.parent,a,fs(en),h,T)}function Tt(br,en,Fn){return(r===(en||br)||ro(r)===ro(en||br))&&!Pt(br.declarations,$0)&&(Fn||pt(ro(br),_))}function Mt(br,en,Fn){return Tt(br.get(r.escapedName),void 0,en)?[r]:Nu(br,zr=>{if(zr.flags&2097152&&zr.escapedName!=="export="&&zr.escapedName!=="default"&&!(U9(zr)&&a&&nu(Ur(a)))&&(!h||Pt(zr.declarations,cb))&&(!Fn||!Pt(zr.declarations,afe))&&(en||!Pc(zr,281))){let Qr=Au(zr),$n=mr(zr,Qr,en);if($n)return $n}if(zr.escapedName===r.escapedName&&zr.exportSymbol&&Tt(ro(zr.exportSymbol),void 0,en))return[r]})||(br===De?mr(ct,ct,en):void 0)}function mr(br,en,Fn){if(Tt(br,en,Fn))return[br];let Dr=Rp(en),zr=Dr&&Ne(Dr,!0);if(zr&&pt(br,fs(_)))return[br].concat(zr)}}function Ia(r,a,_){let h=!1;return ys(a,T=>{let C=ro(T.get(r.escapedName));if(!C)return!1;if(C===r)return!0;let I=C.flags&2097152&&!Pc(C,281);return C=I?Au(C):C,(I?Gf(C):C.flags)&_?(h=!0,!0):!1}),h}function Y_(r){if(r.declarations&&r.declarations.length){for(let a of r.declarations)switch(a.kind){case 172:case 174:case 177:case 178:continue;default:return!1}return!0}return!1}function w_(r,a){return W0(r,a,788968,!1,!0).accessibility===0}function a1(r,a){return W0(r,a,111551,!1,!0).accessibility===0}function HE(r,a,_){return W0(r,a,_,!1,!1).accessibility===0}function Sp(r,a,_,h,T,C){if(!wt(r))return;let I,V=!1;for(let H of r){let X=As(H,a,h,!1);if(X){I=H;let Ne=oT(X[0],T);if(Ne)return Ne}if(C&&Pt(H.declarations,$0)){if(T){V=!0;continue}return{accessibility:0}}let _e=aT(H,a,h),we=Sp(_e,a,_,_===H?fs(h):h,T,C);if(we)return we}if(V)return{accessibility:0};if(I)return{accessibility:1,errorSymbolName:rs(_,a,h),errorModuleName:I!==_?rs(I,a,1920):void 0}}function gg(r,a,_,h){return W0(r,a,_,h,!0)}function W0(r,a,_,h,T){if(r&&a){let C=Sp([r],a,r,_,h,T);if(C)return C;let I=kt(r.declarations,GE);if(I){let V=GE(a);if(I!==V)return{accessibility:2,errorSymbolName:rs(r,a,_),errorModuleName:rs(I),errorNode:hn(a)?a:void 0}}return{accessibility:1,errorSymbolName:rs(r,a,_)}}return{accessibility:0}}function GE(r){let a=Pr(r,DD);return a&&jn(a)}function DD(r){return B_(r)||r.kind===307&&Uf(r)}function $0(r){return G5(r)||r.kind===307&&Uf(r)}function oT(r,a){let _;if(!wi(Zn(r.declarations,C=>C.kind!==80),h))return;return{accessibility:0,aliasesToMakeVisible:_};function h(C){var I,V;if(!H0(C)){let H=M2(C);if(H&&!li(H,32)&&H0(H.parent))return T(C,H);if(Ei(C)&&_l(C.parent.parent)&&!li(C.parent.parent,32)&&H0(C.parent.parent.parent))return T(C,C.parent.parent);if(Y5(C)&&!li(C,32)&&H0(C.parent))return T(C,C);if(Xa(C)){if(r.flags&2097152&&hn(C)&&((I=C.parent)!=null&&I.parent)&&Ei(C.parent.parent)&&((V=C.parent.parent.parent)!=null&&V.parent)&&_l(C.parent.parent.parent.parent)&&!li(C.parent.parent.parent.parent,32)&&C.parent.parent.parent.parent.parent&&H0(C.parent.parent.parent.parent.parent))return T(C,C.parent.parent.parent.parent);if(r.flags&2){let X=Pr(C,_l);return li(X,32)?!0:H0(X.parent)?T(C,X):!1}}return!1}return!0}function T(C,I){return a&&(qn(C).isVisible=!0,_=$o(_,I)),!0}}function o1(r){let a;return r.parent.kind===186||r.parent.kind===233&&!Lg(r.parent)||r.parent.kind===167||r.parent.kind===182&&r.parent.parameterName===r?a=1160127:r.kind===166||r.kind===211||r.parent.kind===271||r.parent.kind===166&&r.parent.left===r||r.parent.kind===211&&r.parent.expression===r||r.parent.kind===212&&r.parent.expression===r?a=1920:a=788968,a}function bS(r,a,_=!0){let h=o1(r),T=_p(r),C=xr(a,T.escapedText,h,void 0,!1);return C&&C.flags&262144&&h&788968?{accessibility:0}:!C&&z1(T)&&gg(jn(nf(T,!1,!1)),T,h,!1).accessibility===0?{accessibility:0}:C?oT(C,_)||{accessibility:1,errorSymbolName:Hc(T),errorNode:T}:{accessibility:3,errorSymbolName:Hc(T),errorNode:T}}function rs(r,a,_,h=4,T){let C=70221824;h&2&&(C|=128),h&1&&(C|=512),h&8&&(C|=16384),h&32&&(C|=134217728),h&16&&(C|=1073741824);let I=h&4?Ve.symbolToNode:Ve.symbolToEntityName;return T?V(T).getText():CI(V);function V(H){let X=I(r,_,a,C),_e=a?.kind===307?Fhe():v2(),we=a&&Ur(a);return _e.writeNode(4,X,we,H),H}}function TS(r,a,_=0,h,T){return T?C(T).getText():CI(C);function C(I){let V;_&262144?V=h===1?185:184:V=h===1?180:179;let H=Ve.signatureToSignatureDeclaration(r,V,a,ID(_)|70221824|512),X=VB(),_e=a&&Ur(a);return X.writeNode(4,H,_e,zH(I)),I}}function ln(r,a,_=1064960,h=MR("")){let T=q.noErrorTruncation||_&1,C=Ve.typeToTypeNode(r,a,ID(_)|70221824|(T?1:0));if(C===void 0)return M.fail("should always get typenode");let I=r!==At?v2():Lhe(),V=a&&Ur(a);I.writeNode(4,C,V,h);let H=h.getText(),X=T?K$*2:xI*2;return X&&H&&H.length>=X?H.substr(0,X-3)+"...":H}function W6(r,a){let _=Rk(r.symbol)?ln(r,r.symbol.valueDeclaration):ln(r),h=Rk(a.symbol)?ln(a,a.symbol.valueDeclaration):ln(a);return _===h&&(_=wD(r),h=wD(a)),[_,h]}function wD(r){return ln(r,void 0,64)}function Rk(r){return r&&!!r.valueDeclaration&&Ct(r.valueDeclaration)&&!Ud(r.valueDeclaration)}function ID(r=0){return r&848330095}function OD(r){return!!r.symbol&&!!(r.symbol.flags&32)&&(r===Al(r.symbol)||!!(r.flags&524288)&&!!(Kn(r)&16777216))}function aJ(r){return Wi(r)}function oJ(){return{typeToTypeNode:(je,Ee,ar,wr)=>V(Ee,ar,wr,xn=>X(je,xn)),typePredicateToTypePredicateNode:(je,Ee,ar,wr)=>V(Ee,ar,wr,xn=>Ks(je,xn)),expressionOrTypeToTypeNode:(je,Ee,ar,wr,xn,bn)=>V(wr,xn,bn,On=>_(On,je,Ee,ar)),serializeTypeForDeclaration:(je,Ee,ar,wr,xn,bn)=>V(wr,xn,bn,On=>y_(On,je,Ee,ar)),serializeReturnTypeForSignature:(je,Ee,ar,wr)=>V(Ee,ar,wr,xn=>zt(xn,je)),indexInfoToIndexSignatureDeclaration:(je,Ee,ar,wr)=>V(Ee,ar,wr,xn=>br(je,xn,void 0)),signatureToSignatureDeclaration:(je,Ee,ar,wr,xn)=>V(ar,wr,xn,bn=>en(je,Ee,bn)),symbolToEntityName:(je,Ee,ar,wr,xn)=>V(ar,wr,xn,bn=>O_(je,bn,Ee,!1)),symbolToExpression:(je,Ee,ar,wr,xn)=>V(ar,wr,xn,bn=>Mc(je,bn,Ee)),symbolToTypeParameterDeclarations:(je,Ee,ar,wr)=>V(Ee,ar,wr,xn=>rn(je,xn)),symbolToParameterDeclaration:(je,Ee,ar,wr)=>V(Ee,ar,wr,xn=>Os(je,xn)),typeParameterToDeclaration:(je,Ee,ar,wr)=>V(Ee,ar,wr,xn=>Ea(je,xn)),symbolTableToDeclarationStatements:(je,Ee,ar,wr)=>V(Ee,ar,wr,xn=>Oa(je,xn)),symbolToNode:(je,Ee,ar,wr,xn)=>V(ar,wr,xn,bn=>I(je,bn,Ee))};function r(je,Ee,ar){let wr=aJ(Ee);if(!je.mapper)return wr;let xn=os(wr,je.mapper);return ar&&xn!==wr?void 0:xn}function a(je,Ee,ar){return(!Ko(Ee)||!(Ee.flags&16)||!je.enclosingFile||je.enclosingFile!==Ur(Bc(Ee)))&&(Ee=U.cloneNode(Ee)),Ee===ar||!ar?Ee:!je.enclosingFile||je.enclosingFile!==Ur(Bc(ar))?zn(Ee,ar):Et(zn(Ee,ar),ar)}function _(je,Ee,ar,wr){let xn=je.flags;Ee&&!(je.flags&-2147483648)&&Pe.serializeTypeOfExpression(Ee,je,wr),je.flags|=-2147483648;let bn=h(je,Ee,ar,wr);return je.flags=xn,bn}function h(je,Ee,ar,wr){if(Ee){let xn=sb(Ee)?Ee.type:m2(Ee)?FO(Ee):void 0;if(xn&&!Qm(xn)){let bn=T(je,xn,ar,Ee.parent,wr);if(bn)return bn}}return wr&&(ar=LS(ar)),X(ar,je)}function T(je,Ee,ar,wr,xn){let bn=ar;xn&&(ar=LS(ar,!ns(wr)));let On=C(je,Ee,ar,wr);if(On)return xn&&R$e(ar)&&!ym(r(je,Ee),Hi=>!!(Hi.flags&32768))?U.createUnionTypeNode([On,U.createKeywordTypeNode(157)]):On;if(xn&&bn!==ar){let Hi=C(je,Ee,bn,wr);if(Hi)return U.createUnionTypeNode([Hi,U.createKeywordTypeNode(157)])}}function C(je,Ee,ar,wr=je.enclosingDeclaration,xn=r(je,Ee,!0)){if(xn&&Oq(wr,ar,xn)&&b4(Ee,ar)){let bn=ka(je,Ee);if(bn)return bn}}function I(je,Ee,ar){if(Ee.flags&1073741824){if(je.valueDeclaration){let xn=Ps(je.valueDeclaration);if(xn&&za(xn))return xn}let wr=as(je).nameType;if(wr&&wr.flags&9216)return Ee.enclosingDeclaration=wr.symbol.valueDeclaration,U.createComputedPropertyName(Mc(wr.symbol,Ee,ar))}return Mc(je,Ee,ar)}function V(je,Ee,ar,wr){let xn=ar?.trackSymbol?ar.moduleResolverHost:Ee&134217728?GTt(e):void 0,bn={enclosingDeclaration:je,enclosingFile:je&&Ur(je),flags:Ee||0,tracker:void 0,encounteredError:!1,reportedDiagnostic:!1,visitedTypes:void 0,symbolDepth:void 0,inferTypeParameters:void 0,approximateLength:0,trackedSymbols:void 0,bundled:!!q.outFile&&!!je&&Uf(Ur(je)),truncating:!1,usedSymbolNames:void 0,remappedSymbolNames:void 0,remappedSymbolReferences:void 0,reverseMappedStack:void 0,mustCreateTypeParameterSymbolList:!0,typeParameterSymbolList:void 0,mustCreateTypeParametersNamesLookups:!0,typeParameterNames:void 0,typeParameterNamesByText:void 0,typeParameterNamesByTextNextNameCount:void 0,mapper:void 0};bn.tracker=new Fge(bn,ar,xn);let On=wr(bn);return bn.truncating&&bn.flags&1&&bn.tracker.reportTruncationError(),bn.encounteredError?void 0:On}function H(je){return je.truncating?je.truncating:je.truncating=je.approximateLength>(je.flags&1?K$:xI)}function X(je,Ee){let ar=Ee.flags,wr=_e(je,Ee);return Ee.flags=ar,wr}function _e(je,Ee){var ar,wr;i&&i.throwIfCancellationRequested&&i.throwIfCancellationRequested();let xn=Ee.flags&8388608;if(Ee.flags&=-8388609,!je){if(!(Ee.flags&262144)){Ee.encounteredError=!0;return}return Ee.approximateLength+=3,U.createKeywordTypeNode(133)}if(Ee.flags&536870912||(je=bg(je)),je.flags&1)return je.aliasSymbol?U.createTypeReferenceNode(To(je.aliasSymbol),Mt(je.aliasTypeArguments,Ee)):je===At?vO(U.createKeywordTypeNode(133),3,"unresolved"):(Ee.approximateLength+=3,U.createKeywordTypeNode(je===Ut?141:133));if(je.flags&2)return U.createKeywordTypeNode(159);if(je.flags&4)return Ee.approximateLength+=6,U.createKeywordTypeNode(154);if(je.flags&8)return Ee.approximateLength+=6,U.createKeywordTypeNode(150);if(je.flags&64)return Ee.approximateLength+=6,U.createKeywordTypeNode(163);if(je.flags&16&&!je.aliasSymbol)return Ee.approximateLength+=7,U.createKeywordTypeNode(136);if(je.flags&1056){if(je.symbol.flags&8){let Ft=Qu(je.symbol),gr=go(Ft,Ee,788968);if(ac(Ft)===je)return gr;let Yr=Qc(je.symbol);return sp(Yr,1)?ut(gr,U.createTypeReferenceNode(Yr,void 0)):qh(gr)?(gr.isTypeOf=!0,U.createIndexedAccessTypeNode(gr,U.createLiteralTypeNode(U.createStringLiteral(Yr)))):Gp(gr)?U.createIndexedAccessTypeNode(U.createTypeQueryNode(gr.typeName),U.createLiteralTypeNode(U.createStringLiteral(Yr))):M.fail("Unhandled type node kind returned from `symbolToTypeNode`.")}return go(je.symbol,Ee,788968)}if(je.flags&128)return Ee.approximateLength+=je.value.length+2,U.createLiteralTypeNode(Tn(U.createStringLiteral(je.value,!!(Ee.flags&268435456)),16777216));if(je.flags&256){let Ft=je.value;return Ee.approximateLength+=(""+Ft).length,U.createLiteralTypeNode(Ft<0?U.createPrefixUnaryExpression(41,U.createNumericLiteral(-Ft)):U.createNumericLiteral(Ft))}if(je.flags&2048)return Ee.approximateLength+=uE(je.value).length+1,U.createLiteralTypeNode(U.createBigIntLiteral(je.value));if(je.flags&512)return Ee.approximateLength+=je.intrinsicName.length,U.createLiteralTypeNode(je.intrinsicName==="true"?U.createTrue():U.createFalse());if(je.flags&8192){if(!(Ee.flags&1048576)){if(a1(je.symbol,Ee.enclosingDeclaration))return Ee.approximateLength+=6,go(je.symbol,Ee,111551);Ee.tracker.reportInaccessibleUniqueSymbolError&&Ee.tracker.reportInaccessibleUniqueSymbolError()}return Ee.approximateLength+=13,U.createTypeOperatorNode(158,U.createKeywordTypeNode(155))}if(je.flags&16384)return Ee.approximateLength+=4,U.createKeywordTypeNode(116);if(je.flags&32768)return Ee.approximateLength+=9,U.createKeywordTypeNode(157);if(je.flags&65536)return Ee.approximateLength+=4,U.createLiteralTypeNode(U.createNull());if(je.flags&131072)return Ee.approximateLength+=5,U.createKeywordTypeNode(146);if(je.flags&4096)return Ee.approximateLength+=6,U.createKeywordTypeNode(155);if(je.flags&67108864)return Ee.approximateLength+=6,U.createKeywordTypeNode(151);if(mO(je))return Ee.flags&4194304&&(!Ee.encounteredError&&!(Ee.flags&32768)&&(Ee.encounteredError=!0),(wr=(ar=Ee.tracker).reportInaccessibleThisError)==null||wr.call(ar)),Ee.approximateLength+=4,U.createThisTypeNode();if(!xn&&je.aliasSymbol&&(Ee.flags&16384||w_(je.aliasSymbol,Ee.enclosingDeclaration))){let Ft=Mt(je.aliasTypeArguments,Ee);return q2(je.aliasSymbol.escapedName)&&!(je.aliasSymbol.flags&32)?U.createTypeReferenceNode(U.createIdentifier(""),Ft):wt(Ft)===1&&je.aliasSymbol===qt.symbol?U.createArrayTypeNode(Ft[0]):go(je.aliasSymbol,Ee,788968,Ft)}let bn=Kn(je);if(bn&4)return M.assert(!!(je.flags&524288)),je.node?Ze(je,Wt):Wt(je);if(je.flags&262144||bn&3){if(je.flags&262144&&Es(Ee.inferTypeParameters,je)){Ee.approximateLength+=Qc(je.symbol).length+6;let gr,Yr=mf(je);if(Yr){let fr=bWe(je,!0);fr&&Q0(Yr,fr)||(Ee.approximateLength+=9,gr=Yr&&X(Yr,Ee))}return U.createInferTypeNode(ii(je,Ee,gr))}if(Ee.flags&4&&je.flags&262144){let gr=ha(je,Ee);return Ee.approximateLength+=Nn(gr).length,U.createTypeReferenceNode(U.createIdentifier(Nn(gr)),void 0)}if(je.symbol)return go(je.symbol,Ee,788968);let Ft=(je===qf||je===mc)&&L&&L.symbol?(je===mc?"sub-":"super-")+Qc(L.symbol):"?";return U.createTypeReferenceNode(U.createIdentifier(Ft),void 0)}if(je.flags&1048576&&je.origin&&(je=je.origin),je.flags&3145728){let Ft=je.flags&1048576?p7(je.types):je.types;if(wt(Ft)===1)return X(Ft[0],Ee);let gr=Mt(Ft,Ee,!0);if(gr&&gr.length>0)return je.flags&1048576?U.createUnionTypeNode(gr):U.createIntersectionTypeNode(gr);!Ee.encounteredError&&!(Ee.flags&262144)&&(Ee.encounteredError=!0);return}if(bn&48)return M.assert(!!(je.flags&524288)),Wo(je);if(je.flags&4194304){let Ft=je.type;Ee.approximateLength+=6;let gr=X(Ft,Ee);return U.createTypeOperatorNode(143,gr)}if(je.flags&134217728){let Ft=je.texts,gr=je.types,Yr=U.createTemplateHead(Ft[0]),fr=U.createNodeArray(Cr(gr,(un,Gn)=>U.createTemplateLiteralTypeSpan(X(un,Ee),(Gn<gr.length-1?U.createTemplateMiddle:U.createTemplateTail)(Ft[Gn+1]))));return Ee.approximateLength+=2,U.createTemplateLiteralType(Yr,fr)}if(je.flags&268435456){let Ft=X(je.type,Ee);return go(je.symbol,Ee,788968,[Ft])}if(je.flags&8388608){let Ft=X(je.objectType,Ee),gr=X(je.indexType,Ee);return Ee.approximateLength+=2,U.createIndexedAccessTypeNode(Ft,gr)}if(je.flags&16777216)return Ze(je,Ft=>On(Ft));if(je.flags&33554432){let Ft=X(je.baseType,Ee),gr=zD(je)&&pxe("NoInfer",!1);return gr?go(gr,Ee,788968,[Ft]):Ft}return M.fail("Should be unreachable.");function On(Ft){let gr=X(Ft.checkType,Ee);if(Ee.approximateLength+=15,Ee.flags&4&&Ft.root.isDistributive&&!(Ft.checkType.flags&262144)){let sn=fd(Za(262144,"T")),ui=ha(sn,Ee),ti=U.createTypeReferenceNode(ui);Ee.approximateLength+=37;let ra=Z2(Ft.root.checkType,sn,Ft.mapper),ya=Ee.inferTypeParameters;Ee.inferTypeParameters=Ft.root.inferTypeParameters;let uc=X(os(Ft.root.extendsType,ra),Ee);Ee.inferTypeParameters=ya;let yf=Hi(os(r(Ee,Ft.root.node.trueType),ra)),Tp=Hi(os(r(Ee,Ft.root.node.falseType),ra));return U.createConditionalTypeNode(gr,U.createInferTypeNode(U.createTypeParameterDeclaration(void 0,U.cloneNode(ti.typeName))),U.createConditionalTypeNode(U.createTypeReferenceNode(U.cloneNode(ui)),X(Ft.checkType,Ee),U.createConditionalTypeNode(ti,uc,yf,Tp),U.createKeywordTypeNode(146)),U.createKeywordTypeNode(146))}let Yr=Ee.inferTypeParameters;Ee.inferTypeParameters=Ft.root.inferTypeParameters;let fr=X(Ft.extendsType,Ee);Ee.inferTypeParameters=Yr;let un=Hi(gT(Ft)),Gn=Hi(hT(Ft));return U.createConditionalTypeNode(gr,fr,un,Gn)}function Hi(Ft){var gr,Yr,fr;return Ft.flags&1048576?(gr=Ee.visitedTypes)!=null&&gr.has(Lu(Ft))?(Ee.flags&131072||(Ee.encounteredError=!0,(fr=(Yr=Ee.tracker)==null?void 0:Yr.reportCyclicStructureError)==null||fr.call(Yr)),we(Ee)):Ze(Ft,un=>X(un,Ee)):X(Ft,Ee)}function cs(Ft){return!!O7(Ft)}function ws(Ft){return!!Ft.target&&cs(Ft.target)&&!cs(Ft)}function Ws(Ft){var gr;M.assert(!!(Ft.flags&524288));let Yr=Ft.declaration.readonlyToken?U.createToken(Ft.declaration.readonlyToken.kind):void 0,fr=Ft.declaration.questionToken?U.createToken(Ft.declaration.questionToken.kind):void 0,un,Gn,sn=!UD(Ft)&&!(QE(Ft).flags&2)&&Ee.flags&4&&!(dd(Ft).flags&262144&&((gr=mf(dd(Ft)))==null?void 0:gr.flags)&4194304);if(UD(Ft)){if(ws(Ft)&&Ee.flags&4){let yf=fd(Za(262144,"T")),Tp=ha(yf,Ee);Gn=U.createTypeReferenceNode(Tp)}un=U.createTypeOperatorNode(143,Gn||X(QE(Ft),Ee))}else if(sn){let yf=fd(Za(262144,"T")),Tp=ha(yf,Ee);Gn=U.createTypeReferenceNode(Tp),un=Gn}else un=X(dd(Ft),Ee);let ui=ii(vg(Ft),Ee,un),ti=Ft.declaration.nameType?X(u1(Ft),Ee):void 0,ra=X(rv(K0(Ft),!!(sy(Ft)&4)),Ee),ya=U.createMappedTypeNode(Yr,ui,ti,fr,ra,void 0);Ee.approximateLength+=10;let uc=Tn(ya,1);if(ws(Ft)&&Ee.flags&4){let yf=os(mf(r(Ee,Ft.declaration.typeParameter.constraint.type))||Rt,Ft.mapper);return U.createConditionalTypeNode(X(QE(Ft),Ee),U.createInferTypeNode(U.createTypeParameterDeclaration(void 0,U.cloneNode(Gn.typeName),yf.flags&2?void 0:X(yf,Ee))),uc,U.createKeywordTypeNode(146))}else if(sn)return U.createConditionalTypeNode(X(dd(Ft),Ee),U.createInferTypeNode(U.createTypeParameterDeclaration(void 0,U.cloneNode(Gn.typeName),U.createTypeOperatorNode(143,X(QE(Ft),Ee)))),uc,U.createKeywordTypeNode(146));return uc}function Wo(Ft){var gr,Yr;let fr=Ft.id,un=Ft.symbol;if(un){if(!!(Kn(Ft)&8388608)){let ra=Ft.node;if(pE(ra)){let ya=C(Ee,ra,Ft);if(ya)return ya}return(gr=Ee.visitedTypes)!=null&&gr.has(fr)?we(Ee):Ze(Ft,dt)}let ui=OD(Ft)?788968:111551;if(vh(un.valueDeclaration))return go(un,Ee,ui);if(un.flags&32&&!Ite(un)&&!(un.valueDeclaration&&gi(un.valueDeclaration)&&Ee.flags&2048&&(!tu(un.valueDeclaration)||gg(un,Ee.enclosingDeclaration,ui,!1).accessibility!==0))||un.flags&896||Gn())return go(un,Ee,ui);if((Yr=Ee.visitedTypes)!=null&&Yr.has(fr)){let ti=H6(Ft);return ti?go(ti,Ee,788968):we(Ee)}else return Ze(Ft,dt)}else return dt(Ft);function Gn(){var sn;let ui=!!(un.flags&8192)&&Pt(un.declarations,ra=>oa(ra)),ti=!!(un.flags&16)&&(un.parent||kt(un.declarations,ra=>ra.parent.kind===307||ra.parent.kind===268));if(ui||ti)return(!!(Ee.flags&4096)||((sn=Ee.visitedTypes)==null?void 0:sn.has(fr)))&&(!(Ee.flags&8)||a1(un,Ee.enclosingDeclaration))}}function Ze(Ft,gr){var Yr,fr,un;let Gn=Ft.id,sn=Kn(Ft)&16&&Ft.symbol&&Ft.symbol.flags&32,ui=Kn(Ft)&4&&Ft.node?"N"+yo(Ft.node):Ft.flags&16777216?"N"+yo(Ft.root.node):Ft.symbol?(sn?"+":"")+Aa(Ft.symbol):void 0;Ee.visitedTypes||(Ee.visitedTypes=new Set),ui&&!Ee.symbolDepth&&(Ee.symbolDepth=new Map);let ti=Ee.enclosingDeclaration&&qn(Ee.enclosingDeclaration),ra=`${Lu(Ft)}|${Ee.flags}`;ti&&(ti.serializedTypes||(ti.serializedTypes=new Map));let ya=(Yr=ti?.serializedTypes)==null?void 0:Yr.get(ra);if(ya)return(fr=ya.trackedSymbols)==null||fr.forEach(([tp,aw,VS])=>Ee.tracker.trackSymbol(tp,aw,VS)),ya.truncating&&(Ee.truncating=!0),Ee.approximateLength+=ya.addedLength,dx(ya.node);let uc;if(ui){if(uc=Ee.symbolDepth.get(ui)||0,uc>10)return we(Ee);Ee.symbolDepth.set(ui,uc+1)}Ee.visitedTypes.add(Gn);let yf=Ee.trackedSymbols;Ee.trackedSymbols=void 0;let Tp=Ee.approximateLength,US=gr(Ft),CT=Ee.approximateLength-Tp;return!Ee.reportedDiagnostic&&!Ee.encounteredError&&((un=ti?.serializedTypes)==null||un.set(ra,{node:US,truncating:Ee.truncating,addedLength:CT,trackedSymbols:Ee.trackedSymbols})),Ee.visitedTypes.delete(Gn),ui&&Ee.symbolDepth.set(ui,uc),Ee.trackedSymbols=yf,US;function dx(tp){return!Ko(tp)&&ks(tp)===tp?tp:a(Ee,U.cloneNode(Mr(tp,dx,void 0,bh,dx)),tp)}function bh(tp,aw,VS,mx,pL){return tp&&tp.length===0?Et(U.createNodeArray(void 0,tp.hasTrailingComma),tp):Kr(tp,aw,VS,mx,pL)}}function dt(Ft){if(Yf(Ft)||Ft.containsError)return Ws(Ft);let gr=Sg(Ft);if(!gr.properties.length&&!gr.indexInfos.length){if(!gr.callSignatures.length&&!gr.constructSignatures.length)return Ee.approximateLength+=2,Tn(U.createTypeLiteralNode(void 0),1);if(gr.callSignatures.length===1&&!gr.constructSignatures.length){let sn=gr.callSignatures[0];return en(sn,184,Ee)}if(gr.constructSignatures.length===1&&!gr.callSignatures.length){let sn=gr.constructSignatures[0];return en(sn,185,Ee)}}let Yr=Zn(gr.constructSignatures,sn=>!!(sn.flags&4));if(Pt(Yr)){let sn=Cr(Yr,ti=>G2(ti));return gr.callSignatures.length+(gr.constructSignatures.length-Yr.length)+gr.indexInfos.length+(Ee.flags&2048?vy(gr.properties,ti=>!(ti.flags&4194304)):wt(gr.properties))&&sn.push(bi(gr)),X(Da(sn),Ee)}let fr=Ee.flags;Ee.flags|=4194304;let un=cr(gr);Ee.flags=fr;let Gn=U.createTypeLiteralNode(un);return Ee.approximateLength+=2,Tn(Gn,Ee.flags&1024?0:1),Gn}function Wt(Ft){let gr=yc(Ft);if(Ft.target===qt||Ft.target===Gr){if(Ee.flags&2){let un=X(gr[0],Ee);return U.createTypeReferenceNode(Ft.target===qt?"Array":"ReadonlyArray",[un])}let Yr=X(gr[0],Ee),fr=U.createArrayTypeNode(Yr);return Ft.target===qt?fr:U.createTypeOperatorNode(148,fr)}else if(Ft.target.objectFlags&8){if(gr=Fs(gr,(Yr,fr)=>rv(Yr,!!(Ft.target.elementFlags[fr]&2))),gr.length>0){let Yr=f1(Ft),fr=Mt(gr.slice(0,Yr),Ee);if(fr){let{labeledElementDeclarations:un}=Ft.target;for(let sn=0;sn<fr.length;sn++){let ui=Ft.target.elementFlags[sn],ti=un?.[sn];ti?fr[sn]=U.createNamedTupleMember(ui&12?U.createToken(26):void 0,U.createIdentifier(Qi(mCe(ti))),ui&2?U.createToken(58):void 0,ui&4?U.createArrayTypeNode(fr[sn]):fr[sn]):fr[sn]=ui&12?U.createRestTypeNode(ui&4?U.createArrayTypeNode(fr[sn]):fr[sn]):ui&2?U.createOptionalTypeNode(fr[sn]):fr[sn]}let Gn=Tn(U.createTupleTypeNode(fr),1);return Ft.target.readonly?U.createTypeOperatorNode(148,Gn):Gn}}if(Ee.encounteredError||Ee.flags&524288){let Yr=Tn(U.createTupleTypeNode([]),1);return Ft.target.readonly?U.createTypeOperatorNode(148,Yr):Yr}Ee.encounteredError=!0;return}else{if(Ee.flags&2048&&Ft.symbol.valueDeclaration&&gi(Ft.symbol.valueDeclaration)&&!a1(Ft.symbol,Ee.enclosingDeclaration))return Wo(Ft);{let Yr=Ft.target.outerTypeParameters,fr=0,un;if(Yr){let ti=Yr.length;for(;fr<ti;){let ra=fr,ya=TWe(Yr[fr]);do fr++;while(fr<ti&&TWe(Yr[fr])===ya);if(!hl(Yr,gr,ra,fr)){let uc=Mt(gr.slice(ra,fr),Ee),yf=Ee.flags;Ee.flags|=16;let Tp=go(ya,Ee,788968,uc);Ee.flags=yf,un=un?ut(un,Tp):Tp}}}let Gn;if(gr.length>0){let ti=(Ft.target.typeParameters||ve).length;Gn=Mt(gr.slice(fr,ti),Ee)}let sn=Ee.flags;Ee.flags|=16;let ui=go(Ft.symbol,Ee,788968,Gn);return Ee.flags=sn,un?ut(un,ui):ui}}}function ut(Ft,gr){if(qh(Ft)){let Yr=Ft.typeArguments,fr=Ft.qualifier;fr&&(He(fr)?Yr!==i2(fr)&&(fr=Rv(U.cloneNode(fr),Yr)):Yr!==i2(fr.right)&&(fr=U.updateQualifiedName(fr,fr.left,Rv(U.cloneNode(fr.right),Yr)))),Yr=gr.typeArguments;let un=hr(gr);for(let Gn of un)fr=fr?U.createQualifiedName(fr,Gn):Gn;return U.updateImportTypeNode(Ft,Ft.argument,Ft.attributes,fr,Yr,Ft.isTypeOf)}else{let Yr=Ft.typeArguments,fr=Ft.typeName;He(fr)?Yr!==i2(fr)&&(fr=Rv(U.cloneNode(fr),Yr)):Yr!==i2(fr.right)&&(fr=U.updateQualifiedName(fr,fr.left,Rv(U.cloneNode(fr.right),Yr))),Yr=gr.typeArguments;let un=hr(gr);for(let Gn of un)fr=U.createQualifiedName(fr,Gn);return U.updateTypeReferenceNode(Ft,fr,Yr)}}function hr(Ft){let gr=Ft.typeName,Yr=[];for(;!He(gr);)Yr.unshift(gr.right),gr=gr.left;return Yr.unshift(gr),Yr}function cr(Ft){if(H(Ee))return[U.createPropertySignature(void 0,"...",void 0,void 0)];let gr=[];for(let un of Ft.callSignatures)gr.push(en(un,179,Ee));for(let un of Ft.constructSignatures)un.flags&4||gr.push(en(un,180,Ee));for(let un of Ft.indexInfos)gr.push(br(un,Ee,Ft.objectFlags&1024?we(Ee):void 0));let Yr=Ft.properties;if(!Yr)return gr;let fr=0;for(let un of Yr){if(fr++,Ee.flags&2048){if(un.flags&4194304)continue;xd(un)&6&&Ee.tracker.reportPrivateInBaseOfClassExpression&&Ee.tracker.reportPrivateInBaseOfClassExpression(Qi(un.escapedName))}if(H(Ee)&&fr+2<Yr.length-1){gr.push(U.createPropertySignature(void 0,`... ${Yr.length-fr} more ...`,void 0,void 0)),pt(Yr[Yr.length-1],Ee,gr);break}pt(un,Ee,gr)}return gr.length?gr:void 0}}function we(je){return je.approximateLength+=3,je.flags&1?U.createKeywordTypeNode(133):U.createTypeReferenceNode(U.createIdentifier("..."),void 0)}function Ne(je,Ee){var ar;return!!(ll(je)&8192)&&(Es(Ee.reverseMappedStack,je)||((ar=Ee.reverseMappedStack)==null?void 0:ar[0])&&!(Kn(Va(Ee.reverseMappedStack).links.propertyType)&16)||xn());function xn(){var bn;if((((bn=Ee.reverseMappedStack)==null?void 0:bn.length)??0)<3)return!1;for(let On=0;On<3;On++)if(Ee.reverseMappedStack[Ee.reverseMappedStack.length-1-On].links.mappedType.symbol!==je.links.mappedType.symbol)return!1;return!0}}function pt(je,Ee,ar){var wr;let xn=!!(ll(je)&8192),bn=Ne(je,Ee)?Me:CS(je),On=Ee.enclosingDeclaration;if(Ee.enclosingDeclaration=void 0,Ee.tracker.canTrackSymbol&&T7(je.escapedName))if(je.declarations){let dt=Ma(je.declarations);if(fJ(dt))if(Pn(dt)){let Wt=Ps(dt);Wt&&cc(Wt)&&UR(Wt.argumentExpression)&&r_(Wt.argumentExpression,On,Ee)}else r_(dt.name.expression,On,Ee)}else Ee.tracker.reportNonSerializableProperty(rs(je));Ee.enclosingDeclaration=je.valueDeclaration||((wr=je.declarations)==null?void 0:wr[0])||On;let Hi=ml(je,Ee);if(Ee.enclosingDeclaration=On,Ee.approximateLength+=Qc(je).length+1,je.flags&98304){let dt=_T(je);if(bn!==dt&&!ao(bn)&&!ao(dt)){let Wt=Pc(je,177),ut=md(Wt);ar.push(Tt(Ee,en(ut,177,Ee,{name:Hi}),Wt));let hr=Pc(je,178),cr=md(hr);ar.push(Tt(Ee,en(cr,178,Ee,{name:Hi}),hr));return}}let cs=je.flags&16777216?U.createToken(58):void 0;if(je.flags&8208&&!PS(bn).length&&!Cg(je)){let dt=Ys(Fl(bn,Wt=>!(Wt.flags&32768)),0);for(let Wt of dt){let ut=en(Wt,173,Ee,{name:Hi,questionToken:cs});ar.push(Ze(ut))}if(dt.length||!cs)return}let ws;Ne(je,Ee)?ws=we(Ee):(xn&&(Ee.reverseMappedStack||(Ee.reverseMappedStack=[]),Ee.reverseMappedStack.push(je)),ws=bn?y_(Ee,void 0,bn,je):U.createKeywordTypeNode(133),xn&&Ee.reverseMappedStack.pop());let Ws=Cg(je)?[U.createToken(148)]:void 0;Ws&&(Ee.approximateLength+=9);let Wo=U.createPropertySignature(Ws,Hi,cs,ws);ar.push(Ze(Wo));function Ze(dt){var Wt;let ut=(Wt=je.declarations)==null?void 0:Wt.find(hr=>hr.kind===348);if(ut){let hr=R3(ut.comment);hr&&hb(dt,[{kind:3,text:`*
 * `+hr.replace(/\n/g,`
 * `)+`
 `,pos:-1,end:-1,hasTrailingNewLine:!0}])}else je.valueDeclaration&&Tt(Ee,dt,je.valueDeclaration);return dt}}function Tt(je,Ee,ar){return je.enclosingFile&&je.enclosingFile===Ur(ar)?Zl(Ee,ar):Ee}function Mt(je,Ee,ar){if(Pt(je)){if(H(Ee))if(ar){if(je.length>2)return[X(je[0],Ee),U.createTypeReferenceNode(`... ${je.length-2} more ...`,void 0),X(je[je.length-1],Ee)]}else return[U.createTypeReferenceNode("...",void 0)];let xn=!(Ee.flags&64)?yd():void 0,bn=[],On=0;for(let Hi of je){if(On++,H(Ee)&&On+2<je.length-1){bn.push(U.createTypeReferenceNode(`... ${je.length-On} more ...`,void 0));let ws=X(je[je.length-1],Ee);ws&&bn.push(ws);break}Ee.approximateLength+=2;let cs=X(Hi,Ee);cs&&(bn.push(cs),xn&&Npe(cs)&&xn.add(cs.typeName.escapedText,[Hi,bn.length-1]))}if(xn){let Hi=Ee.flags;Ee.flags|=64,xn.forEach(cs=>{if(!Dpe(cs,([ws],[Ws])=>mr(ws,Ws)))for(let[ws,Ws]of cs)bn[Ws]=X(ws,Ee)}),Ee.flags=Hi}return bn}}function mr(je,Ee){return je===Ee||!!je.symbol&&je.symbol===Ee.symbol||!!je.aliasSymbol&&je.aliasSymbol===Ee.aliasSymbol}function br(je,Ee,ar){let wr=F_e(je)||"x",xn=X(je.keyType,Ee),bn=U.createParameterDeclaration(void 0,void 0,wr,void 0,xn,void 0);return ar||(ar=X(je.type||Me,Ee)),!je.type&&!(Ee.flags&2097152)&&(Ee.encounteredError=!0),Ee.approximateLength+=wr.length+4,U.createIndexSignature(je.isReadonly?[U.createToken(148)]:void 0,[bn],ar)}function en(je,Ee,ar,wr){var xn;let bn,On,Hi=Xze(je,!0)[0],cs=Qr(ar,je.declaration,Hi,je.typeParameters,je.parameters,je.mapper);ar.approximateLength+=3,ar.flags&32&&je.target&&je.mapper&&je.target.typeParameters?On=je.target.typeParameters.map(ut=>X(os(ut,je.mapper),ar)):bn=je.typeParameters&&je.typeParameters.map(ut=>Ea(ut,ar));let ws=ar.flags;ar.flags&=-257;let Ws=(Pt(Hi,ut=>ut!==Hi[Hi.length-1]&&!!(ll(ut)&32768))?je.parameters:Hi).map(ut=>Os(ut,ar,Ee===176)),Wo=ar.flags&33554432?void 0:$n(je,ar);Wo&&Ws.unshift(Wo),ar.flags=ws;let Ze=zt(ar,je),dt=wr?.modifiers;if(Ee===185&&je.flags&4){let ut=Vg(dt);dt=U.createModifiersFromModifierFlags(ut|64)}let Wt=Ee===179?U.createCallSignature(bn,Ws,Ze):Ee===180?U.createConstructSignature(bn,Ws,Ze):Ee===173?U.createMethodSignature(dt,wr?.name??U.createIdentifier(""),wr?.questionToken,bn,Ws,Ze):Ee===174?U.createMethodDeclaration(dt,void 0,wr?.name??U.createIdentifier(""),void 0,bn,Ws,Ze,void 0):Ee===176?U.createConstructorDeclaration(dt,Ws,void 0):Ee===177?U.createGetAccessorDeclaration(dt,wr?.name??U.createIdentifier(""),Ws,Ze,void 0):Ee===178?U.createSetAccessorDeclaration(dt,wr?.name??U.createIdentifier(""),Ws,void 0):Ee===181?U.createIndexSignature(dt,Ws,Ze):Ee===317?U.createJSDocFunctionType(Ws,Ze):Ee===184?U.createFunctionTypeNode(bn,Ws,Ze??U.createTypeReferenceNode(U.createIdentifier(""))):Ee===185?U.createConstructorTypeNode(dt,bn,Ws,Ze??U.createTypeReferenceNode(U.createIdentifier(""))):Ee===262?U.createFunctionDeclaration(dt,void 0,wr?.name?aa(wr.name,He):U.createIdentifier(""),bn,Ws,Ze,void 0):Ee===218?U.createFunctionExpression(dt,void 0,wr?.name?aa(wr.name,He):U.createIdentifier(""),bn,Ws,Ze,U.createBlock([])):Ee===219?U.createArrowFunction(dt,bn,Ws,Ze,void 0,U.createBlock([])):M.assertNever(Ee);if(On&&(Wt.typeArguments=U.createNodeArray(On)),((xn=je.declaration)==null?void 0:xn.kind)===323&&je.declaration.parent.kind===339){let ut=Hc(je.declaration.parent.parent,!0).slice(2,-2).split(/\r\n|\n|\r/).map(hr=>hr.replace(/^\s+/," ")).join(`
`);vO(Wt,3,ut,!0)}return cs?.(),Wt}function Fn(je){return Bs(je)||A0(je)||o2(je)}function Dr(je){return Bs(je)||A0(je)?md(je).typeParameters:dE(je)?Ixe(je):[XE(jn(je.typeParameter))]}function zr(je){return Bs(je)||A0(je)?md(je).parameters:void 0}function Qr(je,Ee,ar,wr,xn,bn){let On=av(je),Hi,cs,ws=je.enclosingDeclaration,Ws=je.mapper;if(bn&&(je.mapper=bn),je.enclosingDeclaration&&Ee){let Ze=function(dt,Wt){M.assert(je.enclosingDeclaration);let ut;qn(je.enclosingDeclaration).fakeScopeForSignatureDeclaration===dt?ut=je.enclosingDeclaration:je.enclosingDeclaration.parent&&qn(je.enclosingDeclaration.parent).fakeScopeForSignatureDeclaration===dt&&(ut=je.enclosingDeclaration.parent),M.assertOptionalNode(ut,Vs);let hr=ut?.locals??fa(),cr,Ft;if(Wt((gr,Yr)=>{if(ut){let fr=hr.get(gr);fr?Ft=Bt(Ft,{name:gr,oldSymbol:fr}):cr=Bt(cr,gr)}hr.set(gr,Yr)}),ut)return function(){kt(cr,Yr=>hr.delete(Yr)),kt(Ft,Yr=>hr.set(Yr.name,Yr.oldSymbol))};{let gr=U.createBlock(ve);qn(gr).fakeScopeForSignatureDeclaration=dt,gr.locals=hr,lo(gr,je.enclosingDeclaration),je.enclosingDeclaration=gr}};var Wo=Ze;Hi=Pt(ar)?Ze("params",dt=>{if(ar)for(let Wt=0;Wt<ar.length;Wt++){let ut=ar[Wt],hr=xn?.[Wt];xn&&hr!==ut?(dt(ut.escapedName,St),hr&&dt(hr.escapedName,St)):kt(ut.declarations,cr=>{if(ns(cr)&&Hs(cr.name))return Ft(cr.name),!0;return;function Ft(Yr){kt(Yr.elements,fr=>{switch(fr.kind){case 232:return;case 208:return gr(fr);default:return M.assertNever(fr)}})}function gr(Yr){if(Hs(Yr.name))return Ft(Yr.name);let fr=jn(Yr);dt(fr.escapedName,fr)}})||dt(ut.escapedName,ut)}}):void 0,je.flags&4&&Pt(wr)&&(cs=Ze("typeParams",dt=>{for(let Wt of wr??ve){let ut=ha(Wt,je).escapedText;dt(ut,Wt.symbol)}}))}return()=>{Hi?.(),cs?.(),On(),je.enclosingDeclaration=ws,je.mapper=Ws}}function $n(je,Ee){if(je.thisParameter)return Os(je.thisParameter,Ee);if(je.declaration&&hn(je.declaration)){let ar=x5(je.declaration);if(ar&&ar.typeExpression)return U.createParameterDeclaration(void 0,void 0,"this",void 0,X(r(Ee,ar.typeExpression),Ee))}}function ii(je,Ee,ar){let wr=Ee.flags;Ee.flags&=-513;let xn=U.createModifiersFromModifierFlags(Kxe(je)),bn=ha(je,Ee),On=H2(je),Hi=On&&X(On,Ee);return Ee.flags=wr,U.createTypeParameterDeclaration(xn,bn,ar,Hi)}function si(je,Ee,ar){return Ee&&C(ar,Ee,je)||X(je,ar)}function Ea(je,Ee,ar=mf(je)){let wr=ar&&si(ar,zte(je),Ee);return ii(je,Ee,wr)}function Ks(je,Ee){let ar=je.kind===2||je.kind===3?U.createToken(131):void 0,wr=je.kind===1||je.kind===3?Tn(U.createIdentifier(je.parameterName),16777216):U.createThisTypeNode(),xn=je.type&&X(je.type,Ee);return U.createTypePredicateNode(ar,wr,xn)}function no(je){let Ee=Pc(je,169);if(Ee)return Ee;if(!jh(je))return Pc(je,341)}function Os(je,Ee,ar){let wr=no(je),xn=gn(je),bn=y_(Ee,wr,xn,je),On=!(Ee.flags&8192)&&ar&&wr&&wm(wr)?Cr(qT(wr),U.cloneNode):void 0,cs=wr&&Fh(wr)||ll(je)&32768?U.createToken(26):void 0,ws=Rc(je,wr,Ee),Wo=wr&&vJ(wr)||ll(je)&16384?U.createToken(58):void 0,Ze=U.createParameterDeclaration(On,cs,ws,Wo,bn,void 0);return Ee.approximateLength+=Qc(je).length+3,Ze}function Rc(je,Ee,ar){return Ee&&Ee.name?Ee.name.kind===80?Tn(U.cloneNode(Ee.name),16777216):Ee.name.kind===166?Tn(U.cloneNode(Ee.name.right),16777216):wr(Ee.name):Qc(je);function wr(xn){return bn(xn);function bn(On){ar.tracker.canTrackSymbol&&za(On)&&Lte(On)&&r_(On.expression,ar.enclosingDeclaration,ar);let Hi=Mr(On,bn,void 0,void 0,bn);return Xa(Hi)&&(Hi=U.updateBindingElement(Hi,Hi.dotDotDotToken,Hi.propertyName,Hi.name,void 0)),Ko(Hi)||(Hi=U.cloneNode(Hi)),Tn(Hi,16777217)}}}function r_(je,Ee,ar){if(!ar.tracker.canTrackSymbol)return;let wr=_p(je),xn=xr(wr,wr.escapedText,1160127,void 0,!0);xn&&ar.tracker.trackSymbol(xn,Ee,111551)}function sl(je,Ee,ar,wr){return Ee.tracker.trackSymbol(je,Ee.enclosingDeclaration,ar),Jr(je,Ee,ar,wr)}function Jr(je,Ee,ar,wr){let xn;return!(je.flags&262144)&&(Ee.enclosingDeclaration||Ee.flags&64)&&!(Ee.flags&134217728)?(xn=M.checkDefined(On(je,ar,!0)),M.assert(xn&&xn.length>0)):xn=[je],xn;function On(Hi,cs,ws){let Ws=As(Hi,Ee.enclosingDeclaration,cs,!!(Ee.flags&128)),Wo;if(!Ws||Ia(Ws[0],Ee.enclosingDeclaration,Ws.length===1?cs:fs(cs))){let dt=aT(Ws?Ws[0]:Hi,Ee.enclosingDeclaration,cs);if(wt(dt)){Wo=dt.map(hr=>Pt(hr.declarations,$0)?is(hr,Ee):void 0);let Wt=dt.map((hr,cr)=>cr);Wt.sort(Ze);let ut=Wt.map(hr=>dt[hr]);for(let hr of ut){let cr=On(hr,fs(cs),!1);if(cr){if(hr.exports&&hr.exports.get("export=")&&Um(hr.exports.get("export="),Hi)){Ws=cr;break}Ws=cr.concat(Ws||[vS(hr,Hi)||Hi]);break}}}}if(Ws)return Ws;if(ws||!(Hi.flags&6144))return!ws&&!wr&&kt(Hi.declarations,$0)?void 0:[Hi];function Ze(dt,Wt){let ut=Wo[dt],hr=Wo[Wt];if(ut&&hr){let cr=qp(hr);return qp(ut)===cr?AB(ut)-AB(hr):cr?-1:1}return 0}}}function rn(je,Ee){let ar;return nw(je).flags&524384&&(ar=U.createNodeArray(Cr(l1(je),xn=>Ea(xn,Ee)))),ar}function $i(je,Ee,ar){var wr;M.assert(je&&0<=Ee&&Ee<je.length);let xn=je[Ee],bn=Aa(xn);if((wr=ar.typeParameterSymbolList)!=null&&wr.has(bn))return;ar.mustCreateTypeParameterSymbolList&&(ar.mustCreateTypeParameterSymbolList=!1,ar.typeParameterSymbolList=new Set(ar.typeParameterSymbolList)),ar.typeParameterSymbolList.add(bn);let On;if(ar.flags&512&&Ee<je.length-1){let Hi=xn,cs=je[Ee+1];if(ll(cs)&1){let ws=FEe(Hi.flags&2097152?Au(Hi):Hi);On=Mt(Cr(ws,Ws=>m1(Ws,cs.links.mapper)),ar)}else On=rn(xn,ar)}return On}function Dn(je){return mE(je.objectType)?Dn(je.objectType):je}function is(je,Ee,ar){let wr=Pc(je,307);if(!wr){let ws=yi(je.declarations,Ws=>ND(Ws,je));ws&&(wr=Pc(ws,307))}if(wr&&wr.moduleName!==void 0)return wr.moduleName;if(!wr&&Rge.test(je.escapedName))return je.escapedName.substring(1,je.escapedName.length-1);if(!Ee.enclosingFile||!Ee.tracker.moduleResolverHost)return Rge.test(je.escapedName)?je.escapedName.substring(1,je.escapedName.length-1):Ur(oH(je)).fileName;let xn=Ee.enclosingFile,bn=ar||xn?.impliedNodeFormat,On=WO(xn.path,bn),Hi=as(je),cs=Hi.specifierCache&&Hi.specifierCache.get(On);if(!cs){let ws=!!q.outFile,{moduleResolverHost:Ws}=Ee.tracker,Wo=ws?{...q,baseUrl:Ws.getCommonSourceDirectory()}:q;cs=Ma(MRe(je,ur,Wo,xn,Ws,{importModuleSpecifierPreference:ws?"non-relative":"project-relative",importModuleSpecifierEnding:ws?"minimal":bn===99?"js":void 0},{overrideImportMode:ar})),Hi.specifierCache??(Hi.specifierCache=new Map),Hi.specifierCache.set(On,cs)}return cs}function To(je){let Ee=U.createIdentifier(Qi(je.escapedName));return je.parent?U.createQualifiedName(To(je.parent),Ee):Ee}function go(je,Ee,ar,wr){let xn=sl(je,Ee,ar,!(Ee.flags&16384)),bn=ar===111551;if(Pt(xn[0].declarations,$0)){let cs=xn.length>1?Hi(xn,xn.length-1,1):void 0,ws=wr||$i(xn,0,Ee),Ws=Ur(Bc(Ee.enclosingDeclaration)),Wo=z5(xn[0]),Ze,dt;if((af(q)===3||af(q)===99)&&Wo?.impliedNodeFormat===99&&Wo.impliedNodeFormat!==Ws?.impliedNodeFormat&&(Ze=is(xn[0],Ee,99),dt=U.createImportAttributes(U.createNodeArray([U.createImportAttribute(U.createStringLiteral("resolution-mode"),U.createStringLiteral("import"))]))),Ze||(Ze=is(xn[0],Ee)),!(Ee.flags&67108864)&&af(q)!==1&&Ze.includes("/node_modules/")){let ut=Ze;if(af(q)===3||af(q)===99){let hr=Ws?.impliedNodeFormat===99?1:99;Ze=is(xn[0],Ee,hr),Ze.includes("/node_modules/")?Ze=ut:dt=U.createImportAttributes(U.createNodeArray([U.createImportAttribute(U.createStringLiteral("resolution-mode"),U.createStringLiteral(hr===99?"import":"require"))]))}dt||(Ee.encounteredError=!0,Ee.tracker.reportLikelyUnsafeImportRequiredError&&Ee.tracker.reportLikelyUnsafeImportRequiredError(ut))}let Wt=U.createLiteralTypeNode(U.createStringLiteral(Ze));if(Ee.approximateLength+=Ze.length+10,!cs||Tf(cs)){if(cs){let ut=He(cs)?cs:cs.right;Rv(ut,void 0)}return U.createImportTypeNode(Wt,dt,cs,ws,bn)}else{let ut=Dn(cs),hr=ut.objectType.typeName;return U.createIndexedAccessTypeNode(U.createImportTypeNode(Wt,dt,hr,ws,bn),ut.indexType)}}let On=Hi(xn,xn.length-1,0);if(mE(On))return On;if(bn)return U.createTypeQueryNode(On);{let cs=He(On)?On:On.right,ws=i2(cs);return Rv(cs,void 0),U.createTypeReferenceNode(On,ws)}function Hi(cs,ws,Ws){let Wo=ws===cs.length-1?wr:$i(cs,ws,Ee),Ze=cs[ws],dt=cs[ws-1],Wt;if(ws===0)Ee.flags|=16777216,Wt=YE(Ze,Ee),Ee.approximateLength+=(Wt?Wt.length:0)+1,Ee.flags^=16777216;else if(dt&&Rp(dt)){let hr=Rp(dt);Nu(hr,(cr,Ft)=>{if(Um(cr,Ze)&&!T7(Ft)&&Ft!=="export=")return Wt=Qi(Ft),!0})}if(Wt===void 0){let hr=yi(Ze.declarations,Ps);if(hr&&za(hr)&&Tf(hr.expression)){let cr=Hi(cs,ws-1,Ws);return Tf(cr)?U.createIndexedAccessTypeNode(U.createParenthesizedType(U.createTypeQueryNode(cr)),U.createTypeQueryNode(hr.expression)):cr}Wt=YE(Ze,Ee)}if(Ee.approximateLength+=Wt.length+1,!(Ee.flags&16)&&dt&&kS(dt)&&kS(dt).get(Ze.escapedName)&&Um(kS(dt).get(Ze.escapedName),Ze)){let hr=Hi(cs,ws-1,Ws);return mE(hr)?U.createIndexedAccessTypeNode(hr,U.createLiteralTypeNode(U.createStringLiteral(Wt))):U.createIndexedAccessTypeNode(U.createTypeReferenceNode(hr,Wo),U.createLiteralTypeNode(U.createStringLiteral(Wt)))}let ut=Tn(U.createIdentifier(Wt),16777216);if(Wo&&Rv(ut,U.createNodeArray(Wo)),ut.symbol=Ze,ws>Ws){let hr=Hi(cs,ws-1,Ws);return Tf(hr)?U.createQualifiedName(hr,ut):M.fail("Impossible construct - an export of an indexed access cannot be reachable")}return ut}}function h_(je,Ee,ar){let wr=xr(Ee.enclosingDeclaration,je,788968,void 0,!1);return wr&&wr.flags&262144?wr!==ar.symbol:!1}function ha(je,Ee){var ar,wr,xn,bn;if(Ee.flags&4&&Ee.typeParameterNames){let cs=Ee.typeParameterNames.get(Lu(je));if(cs)return cs}let On=O_(je.symbol,Ee,788968,!0);if(!(On.kind&80))return U.createIdentifier("(Missing type parameter)");let Hi=(wr=(ar=je.symbol)==null?void 0:ar.declarations)==null?void 0:wr[0];if(Hi&&Ac(Hi)&&(On=a(Ee,On,Hi.name)),Ee.flags&4){let cs=On.escapedText,ws=((xn=Ee.typeParameterNamesByTextNextNameCount)==null?void 0:xn.get(cs))||0,Ws=cs;for(;(bn=Ee.typeParameterNamesByText)!=null&&bn.has(Ws)||h_(Ws,Ee,je);)ws++,Ws=`${cs}_${ws}`;if(Ws!==cs){let Wo=i2(On);On=U.createIdentifier(Ws),Rv(On,Wo)}Ee.mustCreateTypeParametersNamesLookups&&(Ee.mustCreateTypeParametersNamesLookups=!1,Ee.typeParameterNames=new Map(Ee.typeParameterNames),Ee.typeParameterNamesByTextNextNameCount=new Map(Ee.typeParameterNamesByTextNextNameCount),Ee.typeParameterNamesByText=new Set(Ee.typeParameterNamesByText)),Ee.typeParameterNamesByTextNextNameCount.set(cs,ws),Ee.typeParameterNames.set(Lu(je),On),Ee.typeParameterNamesByText.add(Ws)}return On}function O_(je,Ee,ar,wr){let xn=sl(je,Ee,ar);return wr&&xn.length!==1&&!Ee.encounteredError&&!(Ee.flags&65536)&&(Ee.encounteredError=!0),bn(xn,xn.length-1);function bn(On,Hi){let cs=$i(On,Hi,Ee),ws=On[Hi];Hi===0&&(Ee.flags|=16777216);let Ws=YE(ws,Ee);Hi===0&&(Ee.flags^=16777216);let Wo=Tn(U.createIdentifier(Ws),16777216);return cs&&Rv(Wo,U.createNodeArray(cs)),Wo.symbol=ws,Hi>0?U.createQualifiedName(bn(On,Hi-1),Wo):Wo}}function Mc(je,Ee,ar){let wr=sl(je,Ee,ar);return xn(wr,wr.length-1);function xn(bn,On){let Hi=$i(bn,On,Ee),cs=bn[On];On===0&&(Ee.flags|=16777216);let ws=YE(cs,Ee);On===0&&(Ee.flags^=16777216);let Ws=ws.charCodeAt(0);if(pR(Ws)&&Pt(cs.declarations,$0))return U.createStringLiteral(is(cs,Ee));if(On===0||OG(ws,ee)){let Wo=Tn(U.createIdentifier(ws),16777216);return Hi&&Rv(Wo,U.createNodeArray(Hi)),Wo.symbol=cs,On>0?U.createPropertyAccessExpression(xn(bn,On-1),Wo):Wo}else{Ws===91&&(ws=ws.substring(1,ws.length-1),Ws=ws.charCodeAt(0));let Wo;if(pR(Ws)&&!(cs.flags&8)?Wo=U.createStringLiteral(Zd(ws).replace(/\\./g,Ze=>Ze.substring(1)),Ws===39):""+ +ws===ws&&(Wo=U.createNumericLiteral(+ws)),!Wo){let Ze=Tn(U.createIdentifier(ws),16777216);Hi&&Rv(Ze,U.createNodeArray(Hi)),Ze.symbol=cs,Wo=Ze}return U.createElementAccessExpression(xn(bn,On-1),Wo)}}}function Lc(je){let Ee=Ps(je);return Ee?za(Ee)?!!(hs(Ee.expression).flags&402653316):cc(Ee)?!!(hs(Ee.argumentExpression).flags&402653316):La(Ee):!1}function gd(je){let Ee=Ps(je);return!!(Ee&&La(Ee)&&(Ee.singleQuote||!Ko(Ee)&&_s(Hc(Ee,!1),"'")))}function ml(je,Ee){let ar=!!wt(je.declarations)&&wi(je.declarations,Lc),wr=!!wt(je.declarations)&&wi(je.declarations,gd),xn=!!(je.flags&8192),bn=jl(je,Ee,wr,ar,xn);if(bn)return bn;let On=Qi(je.escapedName);return pj(On,Ka(q),wr,ar,xn)}function jl(je,Ee,ar,wr,xn){let bn=as(je).nameType;if(bn){if(bn.flags&384){let On=""+bn.value;return!sp(On,Ka(q))&&(wr||!Ry(On))?U.createStringLiteral(On,!!ar):Ry(On)&&_s(On,"-")?U.createComputedPropertyName(U.createPrefixUnaryExpression(41,U.createNumericLiteral(-On))):pj(On,Ka(q),ar,wr,xn)}if(bn.flags&8192)return U.createComputedPropertyName(Mc(bn.symbol,Ee,111551))}}function av(je){let Ee=je.mustCreateTypeParameterSymbolList,ar=je.mustCreateTypeParametersNamesLookups;je.mustCreateTypeParameterSymbolList=!0,je.mustCreateTypeParametersNamesLookups=!0;let wr=je.typeParameterNames,xn=je.typeParameterNamesByText,bn=je.typeParameterNamesByTextNextNameCount,On=je.typeParameterSymbolList;return()=>{je.typeParameterNames=wr,je.typeParameterNamesByText=xn,je.typeParameterNamesByTextNextNameCount=bn,je.typeParameterSymbolList=On,je.mustCreateTypeParameterSymbolList=Ee,je.mustCreateTypeParametersNamesLookups=ar}}function sw(je,Ee){return je.declarations&&Ln(je.declarations,ar=>!!Pne(ar)&&(!Ee||!!Pr(ar,wr=>wr===Ee)))}function b4(je,Ee){if(!(Kn(Ee)&4)||!Gp(je))return!0;bJ(je);let ar=qn(je).resolvedSymbol,wr=ar&&ac(ar);return!wr||wr!==Ee.target?!0:wt(je.typeArguments)>=ph(Ee.target.typeParameters)}function fL(je){for(;qn(je).fakeScopeForSignatureDeclaration;)je=je.parent;return je}function y_(je,Ee,ar,wr){var xn,bn;let On=Ee&&(ns(Ee)||Pd(Ee))&&kne(Ee),Hi=je.enclosingDeclaration,cs=je.flags;if(Ee&&Vpe(Ee)&&!(je.flags&-2147483648)&&Pe.serializeTypeOfDeclaration(Ee,je),je.flags|=-2147483648,Hi&&(!ao(ar)||je.flags&1)){let Ze=Ee&&Pne(Ee)?Ee:sw(wr);if(Ze&&!Go(Ze)&&!Hp(Ze)){let dt=Pne(Ze),Wt=On||!!(wr.flags&4&&wr.flags&16777216&&dN(Ze)&&((xn=wr.links)!=null&&xn.mappedType)&&R$e(ar)),ut=!LA(dt)&&T(je,dt,ar,Ze,Wt);if(ut)return je.flags=cs,ut}}ar.flags&8192&&ar.symbol===wr&&(!je.enclosingDeclaration||Pt(wr.declarations,Ze=>Ur(Ze)===Ur(je.enclosingDeclaration)))&&(je.flags|=1048576);let ws=Ee??wr.valueDeclaration??((bn=wr.declarations)==null?void 0:bn[0]),Ws=ws&&gJt(ws)?$Ke(ws):void 0,Wo=_(je,Ws,ar,On);return je.flags=cs,Wo}function Oq(je,Ee,ar){return ar===Ee?!0:je&&(ns(je)||Nf(je)||Ns(je))&&je.questionToken?hm(Ee,524288)===ar:!1}function zt(je,Ee){let ar=je.flags&256,wr=je.flags;ar&&(je.flags&=-257);let xn,bn=ko(Ee);return bn&&!(ar&&Ao(bn))?(Ee.declaration&&!(je.flags&-2147483648)&&Pe.serializeReturnTypeForSignature(Ee.declaration,je),je.flags|=-2147483648,xn=Nr(je,Ee)):ar||(xn=U.createKeywordTypeNode(133)),je.flags=wr,xn}function Nr(je,Ee){let ar=Bd(Ee),wr=ko(Ee);if(je.enclosingDeclaration&&(!ao(wr)||je.flags&1)&&Ee.declaration&&!Ko(Ee.declaration)){let bn=AJt(Ee.declaration);if(bn){let On=T(je,bn,wr,je.enclosingDeclaration);if(On)return On}}if(ar)return Ks(ar,je);let xn=Ee.declaration&&$Ke(Ee.declaration);return _(je,xn,wr)}function Wr(je,Ee){let ar=!1,wr=_p(je);if(hn(je)&&(Xx(wr)||Py(wr.parent)||cf(wr.parent)&&TH(wr.parent.left)&&Xx(wr.parent.right)))return ar=!0,{introducesError:ar,node:je};let xn=o1(je),bn;if(z1(wr))return bn=jn(nf(wr,!1,!1)),gg(bn,wr,xn,!1).accessibility!==0&&(ar=!0,Ee.tracker.reportInaccessibleThisError()),{introducesError:ar,node:On(je)};if(bn=nl(wr,xn,!0,!0),Ee.enclosingDeclaration&&!(bn&&bn.flags&262144)){bn=Mp(bn);let Hi=nl(wr,xn,!0,!0,Ee.enclosingDeclaration);if(Hi===St||Hi===void 0&&bn!==void 0||Hi&&bn&&!Um(Mp(Hi),bn))return Hi!==St&&Ee.tracker.reportInferenceFallback(je),ar=!0,{introducesError:ar,node:je,sym:bn}}if(bn)return bn.flags&1&&bn.valueDeclaration&&(db(bn.valueDeclaration)||Pd(bn.valueDeclaration))?{introducesError:ar,node:On(je)}:(!(bn.flags&262144)&&!Uh(je)&&gg(bn,Ee.enclosingDeclaration,xn,!1).accessibility!==0?(Ee.tracker.reportInferenceFallback(je),ar=!0):Ee.tracker.trackSymbol(bn,Ee.enclosingDeclaration,xn),{introducesError:ar,node:On(je)});return{introducesError:ar,node:je};function On(Hi){if(Hi===wr){let ws=ac(bn),Ws=bn.flags&262144?ha(ws,Ee):U.cloneNode(Hi);return Ws.symbol=bn,a(Ee,Tn(Ws,16777216),Hi)}let cs=Mr(Hi,ws=>On(ws),void 0);return cs!==Hi&&a(Ee,cs,Hi),cs}}function on(je,Ee,ar,wr){let xn=ar?111551:788968,bn=nl(Ee,xn,!0);if(!bn)return;let On=bn.flags&2097152?Au(bn):bn;if(gg(bn,je.enclosingDeclaration,xn,!1).accessibility===0)return go(On,je,xn,wr)}function Bn(je,Ee){if(hn(Ee)&&Ev(Ee)){g$e(Ee);let ar=qn(Ee).resolvedSymbol;return!ar||!(!Ee.isTypeOf&&!(ar.flags&788968)||!(wt(Ee.typeArguments)>=ph(l1(ar))))}if(yN(Ee))return je.mapper===void 0?!0:!!r(je,Ee,!0);if(Gp(Ee)){if(Qm(Ee))return!1;let ar=bJ(Ee),wr=qn(Ee).resolvedSymbol;if(!wr)return!1;if(wr.flags&262144){let xn=ac(wr);if(je.mapper&&m1(xn,je.mapper)!==xn)return!1}if(uR(Ee))return b4(Ee,ar)&&!DWe(Ee)&&wr.flags&788968}if(yb(Ee)&&Ee.operator===158&&Ee.type.kind===155){let ar=je.enclosingDeclaration&&fL(je.enclosingDeclaration);return!!Pr(Ee,wr=>wr===ar)}return!0}function hi(je,Ee){let ar=r(je,Ee);return X(ar,je)}function ka(je,Ee){i&&i.throwIfCancellationRequested&&i.throwIfCancellationRequested();let ar=!1,{finalizeBoundary:wr,startRecoveryScope:xn}=Hi(),bn=ot(Ee,On,Di);if(!wr())return;return je.approximateLength+=Ee.end-Ee.pos,bn;function On(ut){if(ar)return ut;let hr=xn(),cr=Fn(ut)?cs(ut):void 0,Ft=Wt(ut);return cr?.(),ar?Di(ut)&&!LA(ut)?(hr(),hi(je,ut)):ut:Ft?a(je,Ft,ut):void 0}function Hi(){let ut,hr,cr=je.tracker,Ft=je.trackedSymbols;je.trackedSymbols=void 0;let gr=je.encounteredError;return je.tracker=new Fge(je,{...cr.inner,reportCyclicStructureError(){Yr(()=>cr.reportCyclicStructureError())},reportInaccessibleThisError(){Yr(()=>cr.reportInaccessibleThisError())},reportInaccessibleUniqueSymbolError(){Yr(()=>cr.reportInaccessibleUniqueSymbolError())},reportLikelyUnsafeImportRequiredError(Gn){Yr(()=>cr.reportLikelyUnsafeImportRequiredError(Gn))},reportNonSerializableProperty(Gn){Yr(()=>cr.reportNonSerializableProperty(Gn))},trackSymbol(Gn,sn,ui){return(ut??(ut=[])).push([Gn,sn,ui]),!1},moduleResolverHost:je.tracker.moduleResolverHost},je.tracker.moduleResolverHost),{startRecoveryScope:fr,finalizeBoundary:un};function Yr(Gn){ar=!0,(hr??(hr=[])).push(Gn)}function fr(){let Gn=ut?.length??0,sn=hr?.length??0;return()=>{ar=!1,ut&&(ut.length=Gn),hr&&(hr.length=sn)}}function un(){return je.tracker=cr,je.trackedSymbols=Ft,je.encounteredError=gr,hr?.forEach(Gn=>Gn()),ar?!1:(ut?.forEach(([Gn,sn,ui])=>je.tracker.trackSymbol(Gn,sn,ui)),!0)}}function cs(ut){return Qr(je,ut,zr(ut),Dr(ut))}function ws(ut){let hr=FI(ut);switch(hr.kind){case 183:return dt(hr);case 186:return Ze(hr);case 199:return Ws(hr);case 198:let cr=hr;if(cr.operator===143)return Wo(cr)}return ot(ut,On,Di)}function Ws(ut){let hr=ws(ut.objectType);if(hr!==void 0)return U.updateIndexedAccessTypeNode(ut,hr,ot(ut.indexType,On,Di))}function Wo(ut){M.assertEqual(ut.operator,143);let hr=ws(ut.type);if(hr!==void 0)return U.updateTypeOperatorNode(ut,hr)}function Ze(ut){let{introducesError:hr,node:cr}=Wr(ut.exprName,je);if(!hr)return U.updateTypeQueryNode(ut,cr,Kr(ut.typeArguments,On,Di));let Ft=on(je,ut.exprName,!0);if(Ft)return a(je,Ft,ut.exprName)}function dt(ut){if(Bn(je,ut)){let{introducesError:hr,node:cr}=Wr(ut.typeName,je),Ft=Kr(ut.typeArguments,On,Di);if(hr){let gr=on(je,ut.typeName,!1,Ft);if(gr)return a(je,gr,ut.typeName)}else{let gr=U.updateTypeReferenceNode(ut,cr,Ft);return a(je,gr,ut)}}}function Wt(ut){if(Tb(ut))return ot(ut.type,On,Di);if(Zde(ut)||ut.kind===319)return U.createKeywordTypeNode(133);if(eme(ut))return U.createKeywordTypeNode(159);if(bN(ut))return U.createUnionTypeNode([ot(ut.type,On,Di),U.createLiteralTypeNode(U.createNull())]);if(sY(ut))return U.createUnionTypeNode([ot(ut.type,On,Di),U.createKeywordTypeNode(157)]);if(jj(ut))return ot(ut.type,On);if(Bj(ut))return U.createArrayTypeNode(ot(ut.type,On,Di));if(f2(ut))return U.createTypeLiteralNode(Cr(ut.jsDocPropertyTags,fr=>{let un=ot(He(fr.name)?fr.name:fr.name.right,On,He),Gn=il(r(je,ut),un.escapedText),sn=Gn&&fr.typeExpression&&r(je,fr.typeExpression.type)!==Gn?X(Gn,je):void 0;return U.createPropertySignature(void 0,un,fr.isBracketed||fr.typeExpression&&sY(fr.typeExpression.type)?U.createToken(58):void 0,sn||fr.typeExpression&&ot(fr.typeExpression.type,On,Di)||U.createKeywordTypeNode(133))}));if(Gp(ut)&&He(ut.typeName)&&ut.typeName.escapedText==="")return zn(U.createKeywordTypeNode(133),ut);if((x0(ut)||Gp(ut))&&p9(ut))return U.createTypeLiteralNode([U.createIndexSignature(void 0,[U.createParameterDeclaration(void 0,void 0,"x",void 0,ot(ut.typeArguments[0],On,Di))],ot(ut.typeArguments[1],On,Di))]);if(TN(ut))if(XP(ut)){let fr;return U.createConstructorTypeNode(void 0,Kr(ut.typeParameters,On,Ac),Gi(ut.parameters,(un,Gn)=>un.name&&He(un.name)&&un.name.escapedText==="new"?(fr=un.type,void 0):U.createParameterDeclaration(void 0,Ft(un),a(je,U.createIdentifier(gr(un,Gn)),un),U.cloneNode(un.questionToken),ot(un.type,On,Di),void 0)),ot(fr||ut.type,On,Di)||U.createKeywordTypeNode(133))}else return U.createFunctionTypeNode(Kr(ut.typeParameters,On,Ac),Cr(ut.parameters,(fr,un)=>U.createParameterDeclaration(void 0,Ft(fr),a(je,U.createIdentifier(gr(fr,un)),fr),U.cloneNode(fr.questionToken),ot(fr.type,On,Di),void 0)),ot(ut.type,On,Di)||U.createKeywordTypeNode(133));if(yN(ut))return Bn(je,ut)||(ar=!0),ut;if(Ac(ut))return U.updateTypeParameterDeclaration(ut,Kr(ut.modifiers,On,Pa),a(je,ha(ac(jn(ut)),je),ut),ot(ut.constraint,On,Di),ot(ut.default,On,Di));if(mE(ut)){let fr=Ws(ut);return fr||(ar=!0,ut)}if(Gp(ut)){let fr=dt(ut);return fr||(ar=!0,ut)}if(Ev(ut)){let fr=qn(ut).resolvedSymbol;return uR(ut)&&fr&&(!ut.isTypeOf&&!(fr.flags&788968)||!(wt(ut.typeArguments)>=ph(l1(fr))))?a(je,X(r(je,ut),je),ut):U.updateImportTypeNode(ut,U.updateLiteralTypeNode(ut.argument,Yr(ut,ut.argument.literal)),ot(ut.attributes,On,l2),ot(ut.qualifier,On,Tf),Kr(ut.typeArguments,On,Di),ut.isTypeOf)}if(Wu(ut)&&ut.name.kind===167&&!Lte(ut.name)){if(!h0(ut))return hr(ut,On);if(!(je.flags&1&&nc(ut.name.expression)&&gh(ut.name).flags&1))return}if(Bs(ut)&&!ut.type||Ns(ut)&&!ut.type&&!ut.initializer||Nf(ut)&&!ut.type&&!ut.initializer||ns(ut)&&!ut.type&&!ut.initializer){let fr=hr(ut,On);return fr===ut&&(fr=a(je,U.cloneNode(ut),ut)),fr.type=U.createKeywordTypeNode(133),ns(ut)&&(fr.modifiers=void 0),fr}if(pE(ut)){let fr=Ze(ut);return fr||(ar=!0,ut)}if(za(ut)&&nc(ut.expression)){let{node:fr,introducesError:un}=Wr(ut.expression,je);if(un){let Gn=Qf(QCe(ut.expression)),sn=X(Gn,je),ui;if(Mv(sn))ui=sn.literal;else{let ti=CKe(ut.expression),ra=typeof ti.value=="string"?U.createStringLiteral(ti.value,void 0):typeof ti.value=="number"?U.createNumericLiteral(ti.value,0):void 0;if(!ra)return qh(sn)&&r_(ut.expression,je.enclosingDeclaration,je),ut;ui=ra}return ui.kind===11&&sp(ui.text,Ka(q))?U.createIdentifier(ui.text):ui.kind===9&&!ui.text.startsWith("-")?ui:U.updateComputedPropertyName(ut,ui)}else return U.updateComputedPropertyName(ut,fr)}if(LA(ut)){let fr;if(He(ut.parameterName)){let{node:un,introducesError:Gn}=Wr(ut.parameterName,je);ar=ar||Gn,fr=un}else fr=U.cloneNode(ut.parameterName);return U.updateTypePredicateNode(ut,U.cloneNode(ut.assertsModifier),fr,ot(ut.type,On,Di))}if(FA(ut)||lf(ut)||o2(ut)){let fr=hr(ut,On),un=a(je,fr===ut?U.cloneNode(ut):fr,ut),Gn=Ga(un);return Tn(un,Gn|(je.flags&1024&&lf(ut)?0:1)),un}if(La(ut)&&je.flags&268435456&&!ut.singleQuote){let fr=U.cloneNode(ut);return fr.singleQuote=!0,fr}if(dE(ut)){let fr=ot(ut.checkType,On,Di),un=cs(ut),Gn=ot(ut.extendsType,On,Di),sn=ot(ut.trueType,On,Di);un();let ui=ot(ut.falseType,On,Di);return U.updateConditionalTypeNode(ut,fr,Gn,sn,ui)}if(yb(ut)){if(ut.operator===158&&ut.type.kind===155){if(!Bn(je,ut))return ar=!0,ut}else if(ut.operator===143){let fr=Wo(ut);return fr||(ar=!0,ut)}}return hr(ut,On);function hr(fr,un){let Gn=!je.enclosingFile||je.enclosingFile!==Ur(fr);return Mr(fr,un,void 0,Gn?cr:void 0)}function cr(fr,un,Gn,sn,ui){let ti=Kr(fr,un,Gn,sn,ui);return ti&&(ti.pos!==-1||ti.end!==-1)&&(ti===fr&&(ti=U.createNodeArray(fr.slice(),fr.hasTrailingComma)),qg(ti,-1,-1)),ti}function Ft(fr){return fr.dotDotDotToken||(fr.type&&Bj(fr.type)?U.createToken(26):void 0)}function gr(fr,un){return fr.name&&He(fr.name)&&fr.name.escapedText==="this"?"this":Ft(fr)?"args":`arg${un}`}function Yr(fr,un){if(je.bundled||je.enclosingFile!==Ur(un)){let Gn=un.text,sn=qn(ut).resolvedSymbol,ui=fr.isTypeOf?111551:788968,ti=sn&&gg(sn,je.enclosingDeclaration,ui,!1).accessibility===0&&sl(sn,je,ui,!0)[0];if(ti&&BP(ti))Gn=is(ti,je);else{let ra=iAe(fr);ra&&(Gn=is(ra.symbol,je))}if(Gn.includes("/node_modules/")&&(je.encounteredError=!0,je.tracker.reportLikelyUnsafeImportRequiredError&&je.tracker.reportLikelyUnsafeImportRequiredError(Gn)),Gn!==un.text)return zn(U.createStringLiteral(Gn),un)}return ot(un,On,La)}}}function Oa(je,Ee){var ar;let wr=lXe(U.createPropertyDeclaration,174,!0),xn=lXe((Vt,Qn,ki,Ti)=>U.createPropertySignature(Vt,Qn,ki,Ti),173,!1),bn=Ee.enclosingDeclaration,On=[],Hi=new Set,cs=[],ws=Ee;Ee={...ws,usedSymbolNames:new Set(ws.usedSymbolNames),remappedSymbolNames:new Map,remappedSymbolReferences:new Map((ar=ws.remappedSymbolReferences)==null?void 0:ar.entries()),tracker:void 0};let Ws={...ws.tracker.inner,trackSymbol:(Vt,Qn,ki)=>{var Ti,ci;if((Ti=Ee.remappedSymbolNames)!=null&&Ti.has(Aa(Vt)))return!1;if(gg(Vt,Qn,ki,!1).accessibility===0){let ua=Jr(Vt,Ee,ki);if(!(Vt.flags&4)){let $s=ua[0],_c=Ur(ws.enclosingDeclaration);Pt($s.declarations,fo=>Ur(fo)===_c)&&sn($s)}}else if((ci=ws.tracker.inner)!=null&&ci.trackSymbol)return ws.tracker.inner.trackSymbol(Vt,Qn,ki);return!1}};Ee.tracker=new Fge(Ee,Ws,ws.tracker.moduleResolverHost),Nu(je,(Vt,Qn)=>{let ki=Qi(Qn);_y(Vt,ki)});let Wo=!Ee.bundled,Ze=je.get("export=");return Ze&&je.size>1&&Ze.flags&2098688&&(je=fa(),je.set("export=",Ze)),fr(je),Ft(On);function dt(Vt){return!!Vt&&Vt.kind===80}function Wt(Vt){return _l(Vt)?Zn(Cr(Vt.declarationList.declarations,Ps),dt):Zn([Ps(Vt)],dt)}function ut(Vt){let Qn=Ln(Vt,dc),ki=Bo(Vt,El),Ti=ki!==-1?Vt[ki]:void 0;if(Ti&&Qn&&Qn.isExportEquals&&He(Qn.expression)&&He(Ti.name)&&Nn(Ti.name)===Nn(Qn.expression)&&Ti.body&&Hg(Ti.body)){let ci=Zn(Vt,$s=>!!(U_($s)&32)),wo=Ti.name,ua=Ti.body;if(wt(ci)&&(Ti=U.updateModuleDeclaration(Ti,Ti.modifiers,Ti.name,ua=U.updateModuleBlock(ua,U.createNodeArray([...Ti.body.statements,U.createExportDeclaration(void 0,!1,U.createNamedExports(Cr(va(ci,$s=>Wt($s)),$s=>U.createExportSpecifier(!1,void 0,$s))),void 0)]))),Vt=[...Vt.slice(0,ki),Ti,...Vt.slice(ki+1)]),!Ln(Vt,$s=>$s!==Ti&&w3($s,wo))){On=[];let $s=!Pt(ua.statements,_c=>li(_c,32)||dc(_c)||xl(_c));kt(ua.statements,_c=>{ti(_c,$s?32:0)}),Vt=[...Zn(Vt,_c=>_c!==Ti&&_c!==Qn),...On]}}return Vt}function hr(Vt){let Qn=Zn(Vt,Ti=>xl(Ti)&&!Ti.moduleSpecifier&&!!Ti.exportClause&&kd(Ti.exportClause));wt(Qn)>1&&(Vt=[...Zn(Vt,ci=>!xl(ci)||!!ci.moduleSpecifier||!ci.exportClause),U.createExportDeclaration(void 0,!1,U.createNamedExports(va(Qn,ci=>aa(ci.exportClause,kd).elements)),void 0)]);let ki=Zn(Vt,Ti=>xl(Ti)&&!!Ti.moduleSpecifier&&!!Ti.exportClause&&kd(Ti.exportClause));if(wt(ki)>1){let Ti=Hw(ki,ci=>La(ci.moduleSpecifier)?">"+ci.moduleSpecifier.text:">");if(Ti.length!==ki.length)for(let ci of Ti)ci.length>1&&(Vt=[...Zn(Vt,wo=>!ci.includes(wo)),U.createExportDeclaration(void 0,!1,U.createNamedExports(va(ci,wo=>aa(wo.exportClause,kd).elements)),ci[0].moduleSpecifier)])}return Vt}function cr(Vt){let Qn=Bo(Vt,ki=>xl(ki)&&!ki.moduleSpecifier&&!ki.attributes&&!!ki.exportClause&&kd(ki.exportClause));if(Qn>=0){let ki=Vt[Qn],Ti=Gi(ki.exportClause.elements,ci=>{if(!ci.propertyName){let wo=Ox(Vt),ua=Zn(wo,$s=>w3(Vt[$s],ci.name));if(wt(ua)&&wi(ua,$s=>XR(Vt[$s]))){for(let $s of ua)Vt[$s]=gr(Vt[$s]);return}}return ci});wt(Ti)?Vt[Qn]=U.updateExportDeclaration(ki,ki.modifiers,ki.isTypeOnly,U.updateNamedExports(ki.exportClause,Ti),ki.moduleSpecifier,ki.attributes):M1(Vt,Qn)}return Vt}function Ft(Vt){return Vt=ut(Vt),Vt=hr(Vt),Vt=cr(Vt),bn&&(Ji(bn)&&Uf(bn)||El(bn))&&(!Pt(Vt,q3)||!c_e(Vt)&&Pt(Vt,I5))&&Vt.push(m8(U)),Vt}function gr(Vt){let Qn=(U_(Vt)|32)&-129;return U.replaceModifiers(Vt,Qn)}function Yr(Vt){let Qn=U_(Vt)&-33;return U.replaceModifiers(Vt,Qn)}function fr(Vt,Qn,ki){Qn||cs.push(new Map),Vt.forEach(Ti=>{un(Ti,!1,!!ki)}),Qn||(cs[cs.length-1].forEach(Ti=>{un(Ti,!0,!!ki)}),cs.pop())}function un(Vt,Qn,ki){bo(gn(Vt));let Ti=ro(Vt);if(Hi.has(Aa(Ti)))return;if(Hi.add(Aa(Ti)),!Qn||wt(Vt.declarations)&&Pt(Vt.declarations,wo=>!!Pr(wo,ua=>ua===bn))){let wo=av(Ee);Gn(Vt,Qn,ki),wo()}}function Gn(Vt,Qn,ki,Ti=Vt.escapedName){var ci,wo,ua,$s,_c,fo;let Ya=Qi(Ti),n_=Ti==="default";if(Qn&&!(Ee.flags&131072)&&uA(Ya)&&!n_){Ee.encounteredError=!0;return}let i_=n_&&!!(Vt.flags&-113||Vt.flags&16&&wt(bo(gn(Vt))))&&!(Vt.flags&2097152),Z_=!i_&&!Qn&&uA(Ya)&&!n_;(i_||Z_)&&(Qn=!0);let vl=(Qn?0:32)|(n_&&!i_?2048:0),s_=Vt.flags&1536&&Vt.flags&7&&Ti!=="export=",Ff=s_&&dL(gn(Vt),Vt);if((Vt.flags&8208||Ff)&&CT(gn(Vt),Vt,_y(Vt,Ya),vl),Vt.flags&524288&&ra(Vt,Ya,vl),Vt.flags&98311&&Ti!=="export="&&!(Vt.flags&4194304)&&!(Vt.flags&32)&&!(Vt.flags&8192)&&!Ff)if(ki)T4(Vt)&&(Z_=!1,i_=!1);else{let Pl=gn(Vt),jf=_y(Vt,Ya);if(Pl.symbol&&Pl.symbol!==Vt&&Pl.symbol.flags&16&&Pt(Pl.symbol.declarations,K1)&&((ci=Pl.symbol.members)!=null&&ci.size||(wo=Pl.symbol.exports)!=null&&wo.size))Ee.remappedSymbolReferences||(Ee.remappedSymbolReferences=new Map),Ee.remappedSymbolReferences.set(Aa(Pl.symbol),Vt),Gn(Pl.symbol,Qn,ki,Ti),Ee.remappedSymbolReferences.delete(Aa(Pl.symbol));else if(!(Vt.flags&16)&&dL(Pl,Vt))CT(Pl,Vt,jf,vl);else{let nP=Vt.flags&2?Xk(Vt)?2:1:(ua=Vt.parent)!=null&&ua.valueDeclaration&&Ji(($s=Vt.parent)==null?void 0:$s.valueDeclaration)?2:void 0,Th=i_||!(Vt.flags&4)?jf:Rq(jf,Vt),JS=Vt.declarations&&Ln(Vt.declarations,mL=>Ei(mL));JS&&Ru(JS.parent)&&JS.parent.declarations.length===1&&(JS=JS.parent.parent);let qS=(_c=Vt.declarations)==null?void 0:_c.find(Wn);if(qS&&Pn(qS.parent)&&He(qS.parent.right)&&((fo=Pl.symbol)!=null&&fo.valueDeclaration)&&Ji(Pl.symbol.valueDeclaration)){let mL=jf===qS.parent.right.escapedText?void 0:qS.parent.right;ti(U.createExportDeclaration(void 0,!1,U.createNamedExports([U.createExportSpecifier(!1,mL,jf)])),0),Ee.tracker.trackSymbol(Pl.symbol,Ee.enclosingDeclaration,111551)}else{let mL=a(Ee,U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(Th,void 0,y_(Ee,void 0,Pl,Vt))],nP)),JS);ti(mL,Th!==jf?vl&-33:vl),Th!==jf&&!Qn&&(ti(U.createExportDeclaration(void 0,!1,U.createNamedExports([U.createExportSpecifier(!1,Th,jf)])),0),Z_=!1,i_=!1)}}}if(Vt.flags&384&&US(Vt,Ya,vl),Vt.flags&32&&(Vt.flags&4&&Vt.valueDeclaration&&Pn(Vt.valueDeclaration.parent)&&eu(Vt.valueDeclaration.parent.right)?pL(Vt,_y(Vt,Ya),vl):VS(Vt,_y(Vt,Ya),vl)),(Vt.flags&1536&&(!s_||yf(Vt))||Ff)&&Tp(Vt,Ya,vl),Vt.flags&64&&!(Vt.flags&32)&&ya(Vt,Ya,vl),Vt.flags&2097152&&pL(Vt,_y(Vt,Ya),vl),Vt.flags&4&&Vt.escapedName==="export="&&T4(Vt),Vt.flags&8388608&&Vt.declarations)for(let Pl of Vt.declarations){let jf=G_(Pl,Pl.moduleSpecifier);jf&&ti(U.createExportDeclaration(void 0,Pl.isTypeOnly,void 0,U.createStringLiteral(is(jf,Ee))),0)}i_?ti(U.createExportAssignment(void 0,!1,U.createIdentifier(_y(Vt,Ya))),0):Z_&&ti(U.createExportDeclaration(void 0,!1,U.createNamedExports([U.createExportSpecifier(!1,_y(Vt,Ya),Ya)])),0)}function sn(Vt){if(Pt(Vt.declarations,db))return;M.assertIsDefined(cs[cs.length-1]),Rq(Qi(Vt.escapedName),Vt);let Qn=!!(Vt.flags&2097152)&&!Pt(Vt.declarations,ki=>!!Pr(ki,xl)||zh(ki)||ru(ki)&&!C0(ki.moduleReference));cs[Qn?0:cs.length-1].set(Aa(Vt),Vt)}function ui(Vt){return Ji(Vt)&&(Uf(Vt)||Kd(Vt))||B_(Vt)&&!Rg(Vt)}function ti(Vt,Qn){if(wm(Vt)){let ki=0,Ti=Ee.enclosingDeclaration&&(Xd(Ee.enclosingDeclaration)?Ur(Ee.enclosingDeclaration):Ee.enclosingDeclaration);Qn&32&&Ti&&(ui(Ti)||El(Ti))&&XR(Vt)&&(ki|=32),Wo&&!(ki&32)&&(!Ti||!(Ti.flags&33554432))&&(bb(Vt)||_l(Vt)||Tl(Vt)||tu(Vt)||El(Vt))&&(ki|=128),Qn&2048&&(tu(Vt)||Yu(Vt)||Tl(Vt))&&(ki|=2048),ki&&(Vt=U.replaceModifiers(Vt,ki|U_(Vt)))}On.push(Vt)}function ra(Vt,Qn,ki){var Ti;let ci=Y0(Vt),wo=as(Vt).typeParameters,ua=Cr(wo,i_=>Ea(i_,Ee)),$s=(Ti=Vt.declarations)==null?void 0:Ti.find(Xd),_c=R3($s?$s.comment||$s.parent.comment:void 0),fo=Ee.flags;Ee.flags|=8388608;let Ya=Ee.enclosingDeclaration;Ee.enclosingDeclaration=$s;let n_=$s&&$s.typeExpression&&Tb($s.typeExpression)&&C(Ee,$s.typeExpression.type,ci,void 0)||X(ci,Ee);ti(hb(U.createTypeAliasDeclaration(void 0,_y(Vt,Qn),ua,n_),_c?[{kind:3,text:`*
 * `+_c.replace(/\n/g,`
 * `)+`
 `,pos:-1,end:-1,hasTrailingNewLine:!0}]:[]),ki),Ee.flags=fo,Ee.enclosingDeclaration=Ya}function ya(Vt,Qn,ki){let Ti=Al(Vt),ci=l1(Vt),wo=Cr(ci,Z_=>Ea(Z_,Ee)),ua=_i(Ti),$s=wt(ua)?Da(ua):void 0,_c=va(bo(Ti),Z_=>Aqt(Z_,$s)),fo=uAe(0,Ti,$s,179),Ya=uAe(1,Ti,$s,180),n_=uXe(Ti,$s),i_=wt(ua)?[U.createHeritageClause(96,Gi(ua,Z_=>_Ae(Z_,111551)))]:void 0;ti(U.createInterfaceDeclaration(void 0,_y(Vt,Qn),wo,i_,[...n_,...Ya,...fo,..._c]),ki)}function uc(Vt){let Qn=Is(Rp(Vt).values()),ki=ro(Vt);if(ki!==Vt){let Ti=new Set(Qn);for(let ci of Rp(ki).values())Gf(pl(ci))&111551||Ti.add(ci);Qn=Is(Ti)}return Zn(Qn,Ti=>tp(Ti)&&sp(Ti.escapedName,99))}function yf(Vt){return wi(uc(Vt),Qn=>!(Gf(pl(Qn))&111551))}function Tp(Vt,Qn,ki){let Ti=uc(Vt),ci=f3(Ti,$s=>$s.parent&&$s.parent===Vt?"real":"merged"),wo=ci.get("real")||ve,ua=ci.get("merged")||ve;if(wt(wo)){let $s=_y(Vt,Qn);bh(wo,$s,ki,!!(Vt.flags&67108880))}if(wt(ua)){let $s=Ur(Ee.enclosingDeclaration),_c=_y(Vt,Qn),fo=U.createModuleBlock([U.createExportDeclaration(void 0,!1,U.createNamedExports(Gi(Zn(ua,Ya=>Ya.escapedName!=="export="),Ya=>{var n_,i_;let Z_=Qi(Ya.escapedName),vl=_y(Ya,Z_),s_=Ya.declarations&&yp(Ya);if($s&&(s_?$s!==Ur(s_):!Pt(Ya.declarations,jf=>Ur(jf)===$s))){(i_=(n_=Ee.tracker)==null?void 0:n_.reportNonlocalAugmentation)==null||i_.call(n_,$s,Vt,Ya);return}let Ff=s_&&J0(s_,!0);sn(Ff||Ya);let Pl=Ff?_y(Ff,Qi(Ff.escapedName)):vl;return U.createExportSpecifier(!1,Z_===Pl?void 0:Pl,Z_)})))]);ti(U.createModuleDeclaration(void 0,U.createIdentifier(_c),fo,32),0)}}function US(Vt,Qn,ki){ti(U.createEnumDeclaration(U.createModifiersFromModifierFlags(ECe(Vt)?4096:0),_y(Vt,Qn),Cr(Zn(bo(gn(Vt)),Ti=>!!(Ti.flags&8)),Ti=>{let ci=Ti.declarations&&Ti.declarations[0]&&nS(Ti.declarations[0])?tAe(Ti.declarations[0]):void 0;return U.createEnumMember(Qi(Ti.escapedName),ci===void 0?void 0:typeof ci=="string"?U.createStringLiteral(ci):U.createNumericLiteral(ci))})),ki)}function CT(Vt,Qn,ki,Ti){let ci=Ys(Vt,0);for(let wo of ci){let ua=en(wo,262,Ee,{name:U.createIdentifier(ki)});ti(a(Ee,ua,dx(wo)),Ti)}if(!(Qn.flags&1536&&Qn.exports&&Qn.exports.size)){let wo=Zn(bo(Vt),tp);bh(wo,ki,Ti,!0)}}function dx(Vt){if(Vt.declaration&&Vt.declaration.parent){if(Pn(Vt.declaration.parent)&&cl(Vt.declaration.parent)===5)return Vt.declaration.parent;if(Ei(Vt.declaration.parent)&&Vt.declaration.parent.parent)return Vt.declaration.parent.parent}return Vt.declaration}function bh(Vt,Qn,ki,Ti){if(wt(Vt)){let wo=f3(Vt,vl=>!wt(vl.declarations)||Pt(vl.declarations,s_=>Ur(s_)===Ur(Ee.enclosingDeclaration))?"local":"remote").get("local")||ve,ua=Cb.createModuleDeclaration(void 0,U.createIdentifier(Qn),U.createModuleBlock([]),32);lo(ua,bn),ua.locals=fa(Vt),ua.symbol=Vt[0].parent;let $s=On;On=[];let _c=Wo;Wo=!1;let fo={...Ee,enclosingDeclaration:ua},Ya=Ee;Ee=fo,fr(fa(wo),Ti,!0),Ee=Ya,Wo=_c;let n_=On;On=$s;let i_=Cr(n_,vl=>dc(vl)&&!vl.isExportEquals&&He(vl.expression)?U.createExportDeclaration(void 0,!1,U.createNamedExports([U.createExportSpecifier(!1,vl.expression,U.createIdentifier("default"))])):vl),Z_=wi(i_,vl=>li(vl,32))?Cr(i_,Yr):i_;ua=U.updateModuleDeclaration(ua,ua.modifiers,ua.name,U.createModuleBlock(Z_)),ti(ua,ki)}}function tp(Vt){return!!(Vt.flags&2887656)||!(Vt.flags&4194304||Vt.escapedName==="prototype"||Vt.valueDeclaration&&oa(Vt.valueDeclaration)&&gi(Vt.valueDeclaration.parent))}function aw(Vt){let Qn=Gi(Vt,ki=>{let Ti=Ee.enclosingDeclaration;Ee.enclosingDeclaration=ki;let ci=ki.expression;if(nc(ci)){if(He(ci)&&Nn(ci)==="")return wo(void 0);let ua;if({introducesError:ua,node:ci}=Wr(ci,Ee),ua)return wo(void 0)}return wo(U.createExpressionWithTypeArguments(ci,Cr(ki.typeArguments,ua=>C(Ee,ua,r(Ee,ua))||X(r(Ee,ua),Ee))));function wo(ua){return Ee.enclosingDeclaration=Ti,ua}});if(Qn.length===Vt.length)return Qn}function VS(Vt,Qn,ki){var Ti,ci;let wo=(Ti=Vt.declarations)==null?void 0:Ti.find(gi),ua=Ee.enclosingDeclaration;Ee.enclosingDeclaration=wo||ua;let $s=l1(Vt),_c=Cr($s,Eh=>Ea(Eh,Ee)),fo=bp(Al(Vt)),Ya=_i(fo),n_=wo&&eN(wo),i_=n_&&aw(n_)||Gi(Xn(fo),Pqt),Z_=gn(Vt),vl=!!((ci=Z_.symbol)!=null&&ci.valueDeclaration)&&gi(Z_.symbol.valueDeclaration),s_=vl?Lr(Z_):Me,Ff=[...wt(Ya)?[U.createHeritageClause(96,Cr(Ya,Eh=>kqt(Eh,s_,Qn)))]:[],...wt(i_)?[U.createHeritageClause(119,i_)]:[]],Pl=cVt(fo,Ya,bo(fo)),jf=Zn(Pl,Eh=>{let E4=Eh.valueDeclaration;return!!E4&&!(Wu(E4)&&Zi(E4.name))}),Th=Pt(Pl,Eh=>{let E4=Eh.valueDeclaration;return!!E4&&Wu(E4)&&Zi(E4.name)})?[U.createPropertyDeclaration(void 0,U.createPrivateIdentifier("#private"),void 0,void 0,void 0)]:ve,JS=va(jf,Eh=>wr(Eh,!1,Ya[0])),qS=va(Zn(bo(Z_),Eh=>!(Eh.flags&4194304)&&Eh.escapedName!=="prototype"&&!tp(Eh)),Eh=>wr(Eh,!0,s_)),Nqt=!vl&&!!Vt.valueDeclaration&&hn(Vt.valueDeclaration)&&!Pt(Ys(Z_,1))?[U.createConstructorDeclaration(U.createModifiersFromModifierFlags(2),[],void 0)]:uAe(1,Z_,s_,176),Dqt=uXe(fo,Ya[0]);Ee.enclosingDeclaration=ua,ti(a(Ee,U.createClassDeclaration(void 0,Qn,_c,Ff,[...Dqt,...qS,...Nqt,...JS,...Th]),Vt.declarations&&Zn(Vt.declarations,Eh=>tu(Eh)||eu(Eh))[0]),ki)}function mx(Vt){return yi(Vt,Qn=>{if(_f(Qn)||b_(Qn))return Nn(Qn.propertyName||Qn.name);if(Pn(Qn)||dc(Qn)){let ki=dc(Qn)?Qn.expression:Qn.right;if(Wn(ki))return Nn(ki.name)}if(yn(Qn)){let ki=Ps(Qn);if(ki&&He(ki))return Nn(ki)}})}function pL(Vt,Qn,ki){var Ti,ci,wo,ua,$s,_c;let fo=yp(Vt);if(!fo)return M.fail();let Ya=ro(J0(fo,!0));if(!Ya)return;let n_=K3(Ya)&&mx(Vt.declarations)||Qi(Ya.escapedName);n_==="export="&&ue&&(n_="default");let i_=_y(Ya,n_);switch(sn(Ya),fo.kind){case 208:if(((ci=(Ti=fo.parent)==null?void 0:Ti.parent)==null?void 0:ci.kind)===260){let s_=is(Ya.parent||Ya,Ee),{propertyName:Ff}=fo;ti(U.createImportDeclaration(void 0,U.createImportClause(!1,void 0,U.createNamedImports([U.createImportSpecifier(!1,Ff&&He(Ff)?U.createIdentifier(Nn(Ff)):void 0,U.createIdentifier(Qn))])),U.createStringLiteral(s_),void 0),0);break}M.failBadSyntaxKind(((wo=fo.parent)==null?void 0:wo.parent)||fo,"Unhandled binding element grandparent kind in declaration serialization");break;case 304:(($s=(ua=fo.parent)==null?void 0:ua.parent)==null?void 0:$s.kind)===226&&pC(Qi(Vt.escapedName),i_);break;case 260:if(Wn(fo.initializer)){let s_=fo.initializer,Ff=U.createUniqueName(Qn),Pl=is(Ya.parent||Ya,Ee);ti(U.createImportEqualsDeclaration(void 0,!1,Ff,U.createExternalModuleReference(U.createStringLiteral(Pl))),0),ti(U.createImportEqualsDeclaration(void 0,!1,U.createIdentifier(Qn),U.createQualifiedName(Ff,s_.name)),ki);break}case 271:if(Ya.escapedName==="export="&&Pt(Ya.declarations,s_=>Ji(s_)&&Kd(s_))){T4(Vt);break}let Z_=!(Ya.flags&512)&&!Ei(fo);ti(U.createImportEqualsDeclaration(void 0,!1,U.createIdentifier(Qn),Z_?O_(Ya,Ee,-1,!1):U.createExternalModuleReference(U.createStringLiteral(is(Ya,Ee)))),Z_?ki:0);break;case 270:ti(U.createNamespaceExportDeclaration(Nn(fo.name)),0);break;case 273:{let s_=is(Ya.parent||Ya,Ee),Ff=Ee.bundled?U.createStringLiteral(s_):fo.parent.moduleSpecifier,Pl=Yc(fo.parent)?fo.parent.attributes:void 0,jf=Xg(fo.parent);ti(U.createImportDeclaration(void 0,U.createImportClause(jf,U.createIdentifier(Qn),void 0),Ff,Pl),0);break}case 274:{let s_=is(Ya.parent||Ya,Ee),Ff=Ee.bundled?U.createStringLiteral(s_):fo.parent.parent.moduleSpecifier,Pl=Xg(fo.parent.parent);ti(U.createImportDeclaration(void 0,U.createImportClause(Pl,void 0,U.createNamespaceImport(U.createIdentifier(Qn))),Ff,fo.parent.attributes),0);break}case 280:ti(U.createExportDeclaration(void 0,!1,U.createNamespaceExport(U.createIdentifier(Qn)),U.createStringLiteral(is(Ya,Ee))),0);break;case 276:{let s_=is(Ya.parent||Ya,Ee),Ff=Ee.bundled?U.createStringLiteral(s_):fo.parent.parent.parent.moduleSpecifier,Pl=Xg(fo.parent.parent.parent);ti(U.createImportDeclaration(void 0,U.createImportClause(Pl,void 0,U.createNamedImports([U.createImportSpecifier(!1,Qn!==n_?U.createIdentifier(n_):void 0,U.createIdentifier(Qn))])),Ff,fo.parent.parent.parent.attributes),0);break}case 281:let vl=fo.parent.parent.moduleSpecifier;vl&&((_c=fo.propertyName)==null?void 0:_c.escapedText)==="default"&&(n_="default"),pC(Qi(Vt.escapedName),vl?n_:i_,vl&&No(vl)?U.createStringLiteral(vl.text):void 0);break;case 277:T4(Vt);break;case 226:case 211:case 212:Vt.escapedName==="default"||Vt.escapedName==="export="?T4(Vt):pC(Qn,i_);break;default:return M.failBadSyntaxKind(fo,"Unhandled alias declaration kind in symbol serializer!")}}function pC(Vt,Qn,ki){ti(U.createExportDeclaration(void 0,!1,U.createNamedExports([U.createExportSpecifier(!1,Vt!==Qn?Qn:void 0,Vt)]),ki),0)}function T4(Vt){var Qn;if(Vt.flags&4194304)return!1;let ki=Qi(Vt.escapedName),Ti=ki==="export=",wo=Ti||ki==="default",ua=Vt.declarations&&yp(Vt),$s=ua&&J0(ua,!0);if($s&&wt($s.declarations)&&Pt($s.declarations,_c=>Ur(_c)===Ur(bn))){let _c=ua&&(dc(ua)||Pn(ua)?wH(ua):yfe(ua)),fo=_c&&nc(_c)?EVt(_c):void 0,Ya=fo&&nl(fo,-1,!0,!0,bn);(Ya||$s)&&sn(Ya||$s);let n_=Ee.tracker.disableTrackSymbol;if(Ee.tracker.disableTrackSymbol=!0,wo)On.push(U.createExportAssignment(void 0,Ti,Mc($s,Ee,-1)));else if(fo===_c&&fo)pC(ki,Nn(fo));else if(_c&&eu(_c))pC(ki,_y($s,Qc($s)));else{let i_=Rq(ki,Vt);ti(U.createImportEqualsDeclaration(void 0,!1,U.createIdentifier(i_),O_($s,Ee,-1,!1)),0),pC(ki,i_)}return Ee.tracker.disableTrackSymbol=n_,!0}else{let _c=Rq(ki,Vt),fo=Qf(gn(ro(Vt)));if(dL(fo,Vt))CT(fo,Vt,_c,wo?0:32);else{let Ya=((Qn=Ee.enclosingDeclaration)==null?void 0:Qn.kind)===267&&(!(Vt.flags&98304)||Vt.flags&65536)?1:2,n_=U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(_c,void 0,y_(Ee,void 0,fo,Vt))],Ya));ti(n_,$s&&$s.flags&4&&$s.escapedName==="export="?128:ki===_c?32:0)}return wo?(On.push(U.createExportAssignment(void 0,Ti,U.createIdentifier(_c))),!0):ki!==_c?(pC(ki,_c),!0):!1}}function dL(Vt,Qn){var ki;let Ti=Ur(Ee.enclosingDeclaration);return Kn(Vt)&48&&!Pt((ki=Vt.symbol)==null?void 0:ki.declarations,Di)&&!wt(X_(Vt))&&!OD(Vt)&&!!(wt(Zn(bo(Vt),tp))||wt(Ys(Vt,0)))&&!wt(Ys(Vt,1))&&!sw(Qn,bn)&&!(Vt.symbol&&Pt(Vt.symbol.declarations,ci=>Ur(ci)!==Ti))&&!Pt(bo(Vt),ci=>T7(ci.escapedName))&&!Pt(bo(Vt),ci=>Pt(ci.declarations,wo=>Ur(wo)!==Ti))&&wi(bo(Vt),ci=>sp(Qc(ci),ee)?ci.flags&98304?CS(ci)===_T(ci):!0:!1)}function lXe(Vt,Qn,ki){return function(ci,wo,ua){var $s,_c,fo,Ya,n_;let i_=xd(ci),Z_=!!(i_&2);if(wo&&ci.flags&2887656)return[];if(ci.flags&4194304||ci.escapedName==="constructor"||ua&&ma(ua,ci.escapedName)&&Cg(ma(ua,ci.escapedName))===Cg(ci)&&(ci.flags&16777216)===(ma(ua,ci.escapedName).flags&16777216)&&Q0(gn(ci),il(ua,ci.escapedName)))return[];let vl=i_&-1025|(wo?256:0),s_=ml(ci,Ee),Ff=($s=ci.declarations)==null?void 0:$s.find(Jp(Ns,U1,Ei,Nf,Pn,Wn));if(ci.flags&98304&&ki){let Pl=[];if(ci.flags&65536){let jf=ci.declarations&&kt(ci.declarations,Th=>{if(Th.kind===178)return Th;if(ea(Th)&&Qx(Th))return kt(Th.arguments[2].properties,JS=>{let qS=Ps(JS);if(qS&&He(qS)&&Nn(qS)==="set")return JS})});M.assert(!!jf);let nP=Go(jf)?md(jf).parameters[0]:void 0;Pl.push(a(Ee,U.createSetAccessorDeclaration(U.createModifiersFromModifierFlags(vl),s_,[U.createParameterDeclaration(void 0,void 0,nP?Rc(nP,no(nP),Ee):"value",void 0,Z_?void 0:y_(Ee,void 0,_T(ci),ci))],void 0),((_c=ci.declarations)==null?void 0:_c.find(Og))||Ff))}if(ci.flags&32768){let jf=i_&2;Pl.push(a(Ee,U.createGetAccessorDeclaration(U.createModifiersFromModifierFlags(vl),s_,[],jf?void 0:y_(Ee,void 0,gn(ci),ci),void 0),((fo=ci.declarations)==null?void 0:fo.find(Sv))||Ff))}return Pl}else if(ci.flags&98311)return a(Ee,Vt(U.createModifiersFromModifierFlags((Cg(ci)?8:0)|vl),s_,ci.flags&16777216?U.createToken(58):void 0,Z_?void 0:y_(Ee,void 0,_T(ci),ci),void 0),((Ya=ci.declarations)==null?void 0:Ya.find(Jp(Ns,Ei)))||Ff);if(ci.flags&8208){let Pl=gn(ci),jf=Ys(Pl,0);if(vl&2)return a(Ee,Vt(U.createModifiersFromModifierFlags((Cg(ci)?8:0)|vl),s_,ci.flags&16777216?U.createToken(58):void 0,void 0,void 0),((n_=ci.declarations)==null?void 0:n_.find(Go))||jf[0]&&jf[0].declaration||ci.declarations&&ci.declarations[0]);let nP=[];for(let Th of jf){let JS=en(Th,Qn,Ee,{name:s_,questionToken:ci.flags&16777216?U.createToken(58):void 0,modifiers:vl?U.createModifiersFromModifierFlags(vl):void 0}),qS=Th.declaration&&vR(Th.declaration.parent)?Th.declaration.parent:Th.declaration;nP.push(a(Ee,JS,qS))}return nP}return M.fail(`Unhandled class member kind! ${ci.__debugFlags||ci.flags}`)}}function Aqt(Vt,Qn){return xn(Vt,!1,Qn)}function uAe(Vt,Qn,ki,Ti){let ci=Ys(Qn,Vt);if(Vt===1){if(!ki&&wi(ci,$s=>wt($s.parameters)===0))return[];if(ki){let $s=Ys(ki,1);if(!wt($s)&&wi(ci,_c=>wt(_c.parameters)===0))return[];if($s.length===ci.length){let _c=!1;for(let fo=0;fo<$s.length;fo++)if(!FJ(ci[fo],$s[fo],!1,!1,!0,M7)){_c=!0;break}if(!_c)return[]}}let ua=0;for(let $s of ci)$s.declaration&&(ua|=fA($s.declaration,6));if(ua)return[a(Ee,U.createConstructorDeclaration(U.createModifiersFromModifierFlags(ua),[],void 0),ci[0].declaration)]}let wo=[];for(let ua of ci){let $s=en(ua,Ti,Ee);wo.push(a(Ee,$s,ua.declaration))}return wo}function uXe(Vt,Qn){let ki=[];for(let Ti of X_(Vt)){if(Qn){let ci=Gy(Qn,Ti.keyType);if(ci&&Q0(Ti.type,ci.type))continue}ki.push(br(Ti,Ee,void 0))}return ki}function kqt(Vt,Qn,ki){let Ti=_Ae(Vt,111551);if(Ti)return Ti;let ci=Rq(`${ki}_base`),wo=U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(ci,void 0,X(Qn,Ee))],2));return ti(wo,0),U.createExpressionWithTypeArguments(U.createIdentifier(ci),void 0)}function _Ae(Vt,Qn){let ki,Ti;if(Vt.target&&HE(Vt.target.symbol,bn,Qn)?(ki=Cr(yc(Vt),ci=>X(ci,Ee)),Ti=Mc(Vt.target.symbol,Ee,788968)):Vt.symbol&&HE(Vt.symbol,bn,Qn)&&(Ti=Mc(Vt.symbol,Ee,788968)),Ti)return U.createExpressionWithTypeArguments(Ti,ki)}function Pqt(Vt){let Qn=_Ae(Vt,788968);if(Qn)return Qn;if(Vt.symbol)return U.createExpressionWithTypeArguments(Mc(Vt.symbol,Ee,788968),void 0)}function Rq(Vt,Qn){var ki,Ti;let ci=Qn?Aa(Qn):void 0;if(ci&&Ee.remappedSymbolNames.has(ci))return Ee.remappedSymbolNames.get(ci);Qn&&(Vt=_Xe(Qn,Vt));let wo=0,ua=Vt;for(;(ki=Ee.usedSymbolNames)!=null&&ki.has(Vt);)wo++,Vt=`${ua}_${wo}`;return(Ti=Ee.usedSymbolNames)==null||Ti.add(Vt),ci&&Ee.remappedSymbolNames.set(ci,Vt),Vt}function _Xe(Vt,Qn){if(Qn==="default"||Qn==="__class"||Qn==="__function"){let ki=Ee.flags;Ee.flags|=16777216;let Ti=YE(Vt,Ee);Ee.flags=ki,Qn=Ti.length>0&&pR(Ti.charCodeAt(0))?Zd(Ti):Ti}return Qn==="default"?Qn="_default":Qn==="export="&&(Qn="_exports"),Qn=sp(Qn,ee)&&!uA(Qn)?Qn:"_"+Qn.replace(/[^a-zA-Z0-9]/g,"_"),Qn}function _y(Vt,Qn){let ki=Aa(Vt);return Ee.remappedSymbolNames.has(ki)?Ee.remappedSymbolNames.get(ki):(Qn=_Xe(Vt,Qn),Ee.remappedSymbolNames.set(ki,Qn),Qn)}}}function ty(r,a,_=16384,h){return h?T(h).getText():CI(T);function T(C){let I=ID(_)|70221824|512,V=Ve.typePredicateToTypePredicateNode(r,a,I),H=v2(),X=a&&Ur(a);return H.writeNode(4,V,X,C),C}}function p7(r){let a=[],_=0;for(let h=0;h<r.length;h++){let T=r[h];if(_|=T.flags,!(T.flags&98304)){if(T.flags&1568){let C=T.flags&512?qr:jk(T);if(C.flags&1048576){let I=C.types.length;if(h+I<=r.length&&Q_(r[h+I-1])===Q_(C.types[I-1])){a.push(C),h+=I-1;continue}}}a.push(T)}}return _&65536&&a.push(Ke),_&32768&&a.push(nr),a||r}function $6(r){return r===2?"private":r===4?"protected":"public"}function H6(r){if(r.symbol&&r.symbol.flags&2048&&r.symbol.declarations){let a=AR(r.symbol.declarations[0].parent);if(im(a))return jn(a)}}function d7(r){return r&&r.parent&&r.parent.kind===268&&YT(r.parent.parent)}function cT(r){return r.kind===307||B_(r)}function m7(r,a){let _=as(r).nameType;if(_){if(_.flags&384){let h=""+_.value;return!sp(h,Ka(q))&&!Ry(h)?`"${Vh(h,34)}"`:Ry(h)&&_s(h,"-")?`[${h}]`:h}if(_.flags&8192)return`[${YE(_.symbol,a)}]`}}function YE(r,a){var _;if((_=a?.remappedSymbolReferences)!=null&&_.has(Aa(r))&&(r=a.remappedSymbolReferences.get(Aa(r))),a&&r.escapedName==="default"&&!(a.flags&16384)&&(!(a.flags&16777216)||!r.declarations||a.enclosingDeclaration&&Pr(r.declarations[0],cT)!==Pr(a.enclosingDeclaration,cT)))return"default";if(r.declarations&&r.declarations.length){let T=yi(r.declarations,I=>Ps(I)?I:void 0),C=T&&Ps(T);if(T&&C){if(ea(T)&&Qx(T))return Qc(r);if(za(C)&&!(ll(r)&4096)){let I=as(r).nameType;if(I&&I.flags&384){let V=m7(r,a);if(V!==void 0)return V}}return Yo(C)}if(T||(T=r.declarations[0]),T.parent&&T.parent.kind===260)return Yo(T.parent.name);switch(T.kind){case 231:case 218:case 219:return a&&!a.encounteredError&&!(a.flags&131072)&&(a.encounteredError=!0),T.kind===231?"(Anonymous class)":"(Anonymous function)"}}let h=m7(r,a);return h!==void 0?h:Qc(r)}function H0(r){if(r){let _=qn(r);return _.isVisible===void 0&&(_.isVisible=!!a()),_.isVisible}return!1;function a(){switch(r.kind){case 338:case 346:case 340:return!!(r.parent&&r.parent.parent&&r.parent.parent.parent&&Ji(r.parent.parent.parent));case 208:return H0(r.parent.parent);case 260:if(Hs(r.name)&&!r.name.elements.length)return!1;case 267:case 263:case 264:case 265:case 262:case 266:case 271:if(YT(r))return!0;let _=z2(r);return!(Ine(r)&32)&&!(r.kind!==271&&_.kind!==307&&_.flags&33554432)?Tv(_):H0(_);case 172:case 171:case 177:case 178:case 174:case 173:if(up(r,6))return!1;case 176:case 180:case 179:case 181:case 169:case 268:case 184:case 185:case 187:case 183:case 188:case 189:case 192:case 193:case 196:case 202:return H0(r.parent);case 273:case 274:case 276:return!1;case 168:case 307:case 270:return!0;case 277:return!1;default:return!1}}}function KE(r,a){let _;r.parent&&r.parent.kind===277?_=xr(r,r,2998271,void 0,!1):r.parent.kind===281&&(_=pm(r.parent,2998271));let h,T;return _&&(T=new Set,T.add(Aa(_)),C(_.declarations)),h;function C(I){kt(I,V=>{let H=M2(V)||V;if(a?qn(V).isVisible=!0:(h=h||[],ol(h,H)),nA(V)){let X=V.moduleReference,_e=_p(X),we=xr(V,_e.escapedText,901119,void 0,!1);we&&T&&Pg(T,Aa(we))&&C(we.declarations)}})}}function dm(r,a){let _=RD(r,a);if(_>=0){let{length:h}=kr;for(let T=_;T<h;T++)_n[T]=!1;return!1}return kr.push(r),_n.push(!0),Ir.push(a),!0}function RD(r,a){for(let _=kr.length-1;_>=kn;_--){if(g7(kr[_],Ir[_]))return-1;if(kr[_]===r&&Ir[_]===a)return _}return-1}function g7(r,a){switch(a){case 0:return!!as(r).type;case 2:return!!as(r).declaredType;case 1:return!!r.resolvedBaseConstructorType;case 3:return!!r.resolvedReturnType;case 4:return!!r.immediateBaseConstraint;case 5:return!!r.resolvedTypeArguments;case 6:return!!r.baseTypesResolved;case 7:return!!as(r).writeType;case 8:return qn(r).parameterInitializerContainsUndefined!==void 0}return M.assertNever(a)}function ry(){return kr.pop(),Ir.pop(),_n.pop()}function z2(r){return Pr(Bg(r),a=>{switch(a.kind){case 260:case 261:case 276:case 275:case 274:case 273:return!1;default:return!0}}).parent}function h7(r){let a=ac(Qu(r));return a.typeParameters?_1(a,Cr(a.typeParameters,_=>Me)):a}function il(r,a){let _=ma(r,a);return _?gn(_):void 0}function G6(r,a){var _;let h;return il(r,a)||(h=(_=Vk(r,a))==null?void 0:_.type)&&da(h,!0,!0)}function Ao(r){return r&&(r.flags&1)!==0}function ao(r){return r===Oe||!!(r.flags&1&&r.aliasSymbol)}function Mk(r,a){if(a!==0)return $a(r,!1,a);let _=jn(r);return _&&as(_).type||$a(r,!1,a)}function Lk(r,a,_){if(r=Fl(r,H=>!(H.flags&98304)),r.flags&131072)return zi;if(r.flags&1048576)return wc(r,H=>Lk(H,a,_));let h=fi(Cr(a,d1)),T=[],C=[];for(let H of bo(r)){let X=qk(H,8576);!ga(X,h)&&!(xd(H)&6)&&Zte(H)?T.push(H):C.push(X)}if(X2(r)||Q2(h)){if(C.length&&(h=fi([h,...C])),h.flags&131072)return r;let H=TMt();return H?qD(H,[r,h]):Oe}let I=fa();for(let H of T)I.set(H.escapedName,Mxe(H,!1));let V=Zt(_,I,ve,ve,X_(r));return V.objectFlags|=4194304,V}function ie(r){return!!(r.flags&465829888)&&dl(Zu(r)||Rt,32768)}function Le(r){let a=ym(r,ie)?wc(r,_=>_.flags&465829888?ay(_):_):r;return hm(a,524288)}function it(r,a){let _=Lt(r);return _?iv(_,a):a}function Lt(r){let a=Kt(r);if(a&&ER(a)&&a.flowNode){let _=Rr(r);if(_){let h=Et(Cb.createStringLiteral(_),r),T=xf(a)?a:Cb.createParenthesizedExpression(a),C=Et(Cb.createElementAccessExpression(T,h),r);return lo(h,C),lo(C,r),T!==a&&lo(T,C),C.flowNode=a.flowNode,C}}}function Kt(r){let a=r.parent.parent;switch(a.kind){case 208:case 303:return Lt(a);case 209:return Lt(r.parent);case 260:return a.initializer;case 226:return a.right}}function Rr(r){let a=r.parent;return r.kind===208&&a.kind===206?ni(r.propertyName||r.name):r.kind===303||r.kind===304?ni(r.name):""+a.elements.indexOf(r)}function ni(r){let a=d1(r);return a.flags&384?""+a.value:void 0}function Xi(r){let a=r.dotDotDotToken?32:0,_=Mk(r.parent.parent,a);return _&&Li(r,_,!1)}function Li(r,a,_){if(Ao(a))return a;let h=r.parent;ce&&r.flags&33554432&&db(r)?a=tv(a):ce&&h.parent.initializer&&!Eg(EHe(h.parent.initializer),65536)&&(a=hm(a,524288));let T;if(h.kind===206)if(r.dotDotDotToken){if(a=bg(a),a.flags&2||!tq(a))return Qe(r,v.Rest_types_may_only_be_created_from_object_types),Oe;let C=[];for(let I of h.elements)I.dotDotDotToken||C.push(I.propertyName||I.name);T=Lk(a,C,r.symbol)}else{let C=r.propertyName||r.name,I=d1(C),V=Kf(a,I,32,C);T=it(r,V)}else{let C=y1(65|(r.dotDotDotToken?0:128),a,nr,h),I=h.elements.indexOf(r);if(r.dotDotDotToken){let V=wc(a,H=>H.flags&58982400?ay(H):H);T=Zf(V,Ha)?wc(V,H=>n4(H,I)):g_(C)}else if(g1(a)){let V=zm(I),H=32|(_||u4(r)?16:0),X=wS(a,V,H,r.name)||Oe;T=it(r,X)}else T=C}return r.initializer?Vl(IP(r))?ce&&!Eg(f4(r,0),16777216)?Le(T):T:ane(r,fi([Le(T),f4(r,0)],2)):T}function xi(r){let a=rb(r);if(a)return Wi(a)}function us(r){let a=So(r,!0);return a.kind===106||a.kind===80&&gf(a)===Be}function zo(r){let a=So(r,!0);return a.kind===209&&a.elements.length===0}function da(r,a=!1,_=!0){return ce&&_?LS(r,a):r}function $a(r,a,_){if(Ei(r)&&r.parent.parent.kind===249){let I=dh(G2e(hs(r.parent.parent.expression,_)));return I.flags&4456448?i$e(I):Ue}if(Ei(r)&&r.parent.parent.kind===250){let I=r.parent.parent;return Aq(I)||Me}if(Hs(r.parent))return Xi(r);let h=Ns(r)&&!Ug(r)||Nf(r)||rme(r),T=a&&dN(r),C=fn(r);if(iH(r))return C?Ao(C)||C===Rt?C:Oe:xe?Rt:Me;if(C)return da(C,h,T);if((de||hn(r))&&Ei(r)&&!Hs(r.name)&&!(Ine(r)&32)&&!(r.flags&33554432)){if(!(px(r)&6)&&(!r.initializer||us(r.initializer)))return tt;if(r.initializer&&zo(r.initializer))return Fo}if(ns(r)){if(!r.symbol)return;let I=r.parent;if(I.kind===178&&BD(I)){let X=Pc(jn(r.parent),177);if(X){let _e=md(X),we=oAe(I);return we&&r===we?(M.assert(!we.type),gn(_e.thisParameter)):ko(_e)}}let V=$8t(I,r);if(V)return V;let H=r.symbol.escapedName==="this"?ZHe(I):eGe(r);if(H)return da(H,!1,T)}if(Hx(r)&&r.initializer){if(hn(r)&&!ns(r)){let V=y7(r,jn(r),RI(r));if(V)return V}let I=ane(r,f4(r,_));return da(I,h,T)}if(Ns(r)&&(de||hn(r)))if(Jl(r)){let I=Zn(r.parent.members,Gc),V=I.length?mm(r.symbol,I):U_(r)&128?pre(r.symbol):void 0;return V&&da(V,!0,T)}else{let I=e8(r.parent),V=I?lT(r.symbol,I):U_(r)&128?pre(r.symbol):void 0;return V&&da(V,!0,T)}if(Kg(r))return Ht;if(Hs(r.name))return P(r.name,!1,!0)}function pd(r){if(r.valueDeclaration&&Pn(r.valueDeclaration)){let a=as(r);return a.isConstructorDeclaredProperty===void 0&&(a.isConstructorDeclaredProperty=!1,a.isConstructorDeclaredProperty=!!G0(r)&&wi(r.declarations,_=>Pn(_)&&jre(_)&&(_.left.kind!==212||zp(_.left.argumentExpression))&&!oo(void 0,_,r,_))),a.isConstructorDeclaredProperty}return!1}function hg(r){let a=r.valueDeclaration;return a&&Ns(a)&&!Vl(a)&&!a.initializer&&(de||hn(a))}function G0(r){if(r.declarations)for(let a of r.declarations){let _=nf(a,!1,!1);if(_&&(_.kind===176||vh(_)))return _}}function ES(r){let a=Ur(r.declarations[0]),_=Qi(r.escapedName),h=r.declarations.every(C=>hn(C)&&oc(C)&&Py(C.expression)),T=h?U.createPropertyAccessExpression(U.createPropertyAccessExpression(U.createIdentifier("module"),U.createIdentifier("exports")),_):U.createPropertyAccessExpression(U.createIdentifier("exports"),_);return h&&lo(T.expression.expression,T.expression),lo(T.expression,T),lo(T,a),T.flowNode=a.endFlowNode,iv(T,tt,nr)}function mm(r,a){let _=_s(r.escapedName,"__#")?U.createPrivateIdentifier(r.escapedName.split("@")[1]):Qi(r.escapedName);for(let h of a){let T=U.createPropertyAccessExpression(U.createThis(),_);lo(T.expression,T),lo(T,h),T.flowNode=h.returnFlowNode;let C=Y6(T,r);if(de&&(C===tt||C===Fo)&&Qe(r.valueDeclaration,v.Member_0_implicitly_has_an_1_type,rs(r),ln(C)),!Zf(C,iq))return cL(C)}}function lT(r,a){let _=_s(r.escapedName,"__#")?U.createPrivateIdentifier(r.escapedName.split("@")[1]):Qi(r.escapedName),h=U.createPropertyAccessExpression(U.createThis(),_);lo(h.expression,h),lo(h,a),h.flowNode=a.returnFlowNode;let T=Y6(h,r);return de&&(T===tt||T===Fo)&&Qe(r.valueDeclaration,v.Member_0_implicitly_has_an_1_type,rs(r),ln(T)),Zf(T,iq)?void 0:cL(T)}function Y6(r,a){let _=a?.valueDeclaration&&(!hg(a)||U_(a.valueDeclaration)&128)&&pre(a)||nr;return iv(r,tt,_)}function MD(r,a){let _=iA(r.valueDeclaration);if(_){let V=hn(_)?tb(_):void 0;return V&&V.typeExpression?Wi(V.typeExpression):r.valueDeclaration&&y7(r.valueDeclaration,r,_)||ST(yl(_))}let h,T=!1,C=!1;if(pd(r)&&(h=lT(r,G0(r))),!h){let V;if(r.declarations){let H;for(let X of r.declarations){let _e=Pn(X)||ea(X)?X:oc(X)?Pn(X.parent)?X.parent:X:void 0;if(!_e)continue;let we=oc(_e)?yR(_e):cl(_e);(we===4||Pn(_e)&&jre(_e,we))&&(yg(_e)?T=!0:C=!0),ea(_e)||(H=oo(H,_e,r,X)),H||(V||(V=[])).push(Pn(_e)||ea(_e)?cu(r,a,_e,we):Ar)}h=H}if(!h){if(!wt(V))return Oe;let H=T&&r.declarations?uT(V,r.declarations):void 0;if(C){let _e=pre(r);_e&&((H||(H=[])).push(_e),T=!0)}let X=Pt(H,_e=>!!(_e.flags&-98305))?H:V;h=fi(X)}}let I=Qf(da(h,!1,C&&!T));return r.valueDeclaration&&hn(r.valueDeclaration)&&Fl(I,V=>!!(V.flags&-98305))===Ar?(bT(r.valueDeclaration,Me),Me):I}function y7(r,a,_){var h,T;if(!hn(r)||!_||!Ca(_)||_.properties.length)return;let C=fa();for(;Pn(r)||Wn(r);){let H=_d(r);(h=H?.exports)!=null&&h.size&&Ip(C,H.exports),r=Pn(r)?r.parent:r.parent.parent}let I=_d(r);(T=I?.exports)!=null&&T.size&&Ip(C,I.exports);let V=Zt(a,C,ve,ve,ve);return V.objectFlags|=4096,V}function oo(r,a,_,h){var T;let C=Vl(a.parent);if(C){let I=Qf(Wi(C));if(r)!ao(r)&&!ao(I)&&!Q0(r,I)&&tKe(void 0,r,h,I);else return I}if((T=_.parent)!=null&&T.valueDeclaration){let I=kD(_.parent);if(I.valueDeclaration){let V=Vl(I.valueDeclaration);if(V){let H=ma(Wi(V),_.escapedName);if(H)return CS(H)}}}return r}function cu(r,a,_,h){if(ea(_)){if(a)return gn(a);let I=yl(_.arguments[2]),V=il(I,"value");if(V)return V;let H=il(I,"get");if(H){let _e=lC(H);if(_e)return ko(_e)}let X=il(I,"set");if(X){let _e=lC(X);if(_e)return gCe(_e)}return Me}if(xS(_.left,_.right))return Me;let T=h===1&&(Wn(_.left)||cc(_.left))&&(Py(_.left.expression)||He(_.left.expression)&&Xx(_.left.expression)),C=a?gn(a):T?Q_(yl(_.right)):ST(yl(_.right));if(C.flags&524288&&h===2&&r.escapedName==="export="){let I=Sg(C),V=fa();V5(I.members,V);let H=V.size;a&&!a.exports&&(a.exports=fa()),(a||r).exports.forEach((_e,we)=>{var Ne;let pt=V.get(we);if(pt&&pt!==_e&&!(_e.flags&2097152))if(_e.flags&111551&&pt.flags&111551){if(_e.valueDeclaration&&pt.valueDeclaration&&Ur(_e.valueDeclaration)!==Ur(pt.valueDeclaration)){let Mt=Qi(_e.escapedName),mr=((Ne=ai(pt.valueDeclaration,Wu))==null?void 0:Ne.name)||pt.valueDeclaration;ca(Qe(_e.valueDeclaration,v.Duplicate_identifier_0,Mt),pn(mr,v._0_was_also_declared_here,Mt)),ca(Qe(mr,v.Duplicate_identifier_0,Mt),pn(_e.valueDeclaration,v._0_was_also_declared_here,Mt))}let Tt=Za(_e.flags|pt.flags,we);Tt.links.type=fi([gn(_e),gn(pt)]),Tt.valueDeclaration=pt.valueDeclaration,Tt.declarations=ps(pt.declarations,_e.declarations),V.set(we,Tt)}else V.set(we,F0(_e,pt));else V.set(we,_e)});let X=Zt(H!==V.size?void 0:I.symbol,V,I.callSignatures,I.constructSignatures,I.indexInfos);if(H===V.size&&(C.aliasSymbol&&(X.aliasSymbol=C.aliasSymbol,X.aliasTypeArguments=C.aliasTypeArguments),Kn(C)&4)){X.aliasSymbol=C.symbol;let _e=yc(C);X.aliasTypeArguments=wt(_e)?_e:void 0}return X.objectFlags|=SJ([C])|Kn(C)&20608,X.symbol&&X.symbol.flags&32&&C===Al(X.symbol)&&(X.objectFlags|=16777216),X}return mre(C)?(bT(_,Uo),Uo):C}function xS(r,a){return Wn(r)&&r.expression.kind===110&&$A(a,_=>Fu(r,_))}function yg(r){let a=nf(r,!1,!1);return a.kind===176||a.kind===262||a.kind===218&&!vR(a.parent)}function uT(r,a){return M.assert(r.length===a.length),r.filter((_,h)=>{let T=a[h],C=Pn(T)?T:Pn(T.parent)?T.parent:void 0;return C&&yg(C)})}function $y(r,a,_){if(r.initializer){let h=Hs(r.name)?P(r.name,!0,!1):Rt;return da(ane(r,f4(r,_?0:1,h)))}return Hs(r.name)?P(r.name,a,_):(_&&!Qt(r)&&bT(r,Me),a?Nt:Me)}function jd(r,a,_){let h=fa(),T,C=131200;kt(r.elements,V=>{let H=V.propertyName||V.name;if(V.dotDotDotToken){T=oy(Ue,Me,!1);return}let X=d1(H);if(!tm(X)){C|=512;return}let _e=rm(X),we=4|(V.initializer?16777216:0),Ne=Za(we,_e);Ne.links.type=$y(V,a,_),Ne.links.bindingElement=V,h.set(Ne.escapedName,Ne)});let I=Zt(void 0,h,ve,ve,T?[T]:ve);return I.objectFlags|=C,a&&(I.pattern=r,I.objectFlags|=131072),I}function vn(r,a,_){let h=r.elements,T=vc(h),C=T&&T.kind===208&&T.dotDotDotToken?T:void 0;if(h.length===0||h.length===1&&C)return ee>=2?JWe(Me):Uo;let I=Cr(h,_e=>pu(_e)?Me:$y(_e,a,_)),V=pv(h,_e=>!(_e===C||pu(_e)||u4(_e)),h.length-1)+1,H=Cr(h,(_e,we)=>_e===C?4:we>=V?2:1),X=cy(I,H);return a&&(X=EWe(X),X.pattern=r,X.objectFlags|=131072),X}function P(r,a=!1,_=!1){return r.kind===206?jd(r,a,_):vn(r,a,_)}function B(r,a){return rt($a(r,!0,0),r,a)}function Y(r){let a=qn(r);if(!a.resolvedType){let _=Za(4096,"__importAttributes"),h=fa();kt(r.elements,C=>{let I=Za(4,hj(C));I.parent=_,I.links.type=xVt(C),I.links.target=I,h.set(I.escapedName,I)});let T=Zt(_,h,ve,ve,ve);T.objectFlags|=262272,a.resolvedType=T}return a.resolvedType}function ge(r){let a=_d(r),_=uMt(!1);return _&&a&&a===_}function rt(r,a,_){return r?(r.flags&4096&&ge(a.parent)&&(r=Lxe(a)),_&&Ere(a,r),r.flags&8192&&(Xa(a)||!a.type)&&r.symbol!==jn(a)&&(r=Hr),Qf(r)):(r=ns(a)&&a.dotDotDotToken?Uo:Me,_&&(Qt(a)||bT(a,r)),r)}function Qt(r){let a=Bg(r),_=a.kind===169?a.parent:a;return bq(_)}function fn(r){let a=Vl(r);if(a)return Wi(a)}function Ts(r){let a=r.valueDeclaration;return a?(Xa(a)&&(a=IP(a)),ns(a)?are(a.parent):!1):!1}function Xo(r,a){let _=as(r);if(!_.type){let h=Jm(r,a);return!_.type&&!Ts(r)&&!a&&(_.type=h),h}return _.type}function Jm(r,a){if(r.flags&4194304)return h7(r);if(r===et)return Me;if(r.flags&134217728&&r.valueDeclaration){let T=jn(Ur(r.valueDeclaration)),C=Za(T.flags,"exports");C.declarations=T.declarations?T.declarations.slice():[],C.parent=r,C.links.target=T,T.valueDeclaration&&(C.valueDeclaration=T.valueDeclaration),T.members&&(C.members=new Map(T.members)),T.exports&&(C.exports=new Map(T.exports));let I=fa();return I.set("exports",C),Zt(r,I,ve,ve,ve)}M.assertIsDefined(r.valueDeclaration);let _=r.valueDeclaration;if(Ji(_)&&Kd(_))return _.statements.length?Qf(ST(hs(_.statements[0].expression))):zi;if(U1(_))return v7(r);if(!dm(r,0))return r.flags&512&&!(r.flags&67108864)?K6(r):Xa(_)&&a===1?Oe:c1(r);let h;if(_.kind===277)h=rt(fn(_)||yl(_.expression),_);else if(Pn(_)||hn(_)&&(ea(_)||(Wn(_)||g9(_))&&Pn(_.parent)))h=MD(r);else if(Wn(_)||cc(_)||He(_)||No(_)||Pf(_)||tu(_)||Tl(_)||ul(_)&&!Nm(_)||$g(_)||Ji(_)){if(r.flags&9136)return K6(r);h=Pn(_.parent)?MD(r):fn(_)||Me}else if(ql(_))h=fn(_)||PYe(_);else if(Kg(_))h=fn(_)||fGe(_);else if(p_(_))h=fn(_)||d4(_.name,0);else if(Nm(_))h=fn(_)||NYe(_,0);else if(ns(_)||Ns(_)||Nf(_)||Ei(_)||Xa(_)||hI(_))h=B(_,!0);else if(bb(_))h=K6(r);else if(nS(_))h=Ote(r);else return M.fail("Unhandled declaration kind! "+M.formatSyntaxKind(_.kind)+" for "+M.formatSymbol(r));return ry()?h:r.flags&512&&!(r.flags&67108864)?K6(r):Xa(_)&&a===1?h:c1(r)}function qm(r){if(r)switch(r.kind){case 177:return lp(r);case 178:return wfe(r);case 172:return M.assert(Ug(r)),Vl(r)}}function ny(r){let a=qm(r);return a&&Wi(a)}function Fk(r){let a=oAe(r);return a&&a.symbol}function IEe(r){return mT(md(r))}function v7(r){let a=as(r);if(!a.type){if(!dm(r,0))return Oe;let _=Pc(r,177),h=Pc(r,178),T=ai(Pc(r,172),Ef),C=_&&hn(_)&&xi(_)||ny(_)||ny(h)||ny(T)||_&&_.body&&rne(_)||T&&T.initializer&&B(T,!0);C||(h&&!bq(h)?Cu(de,h,v.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation,rs(r)):_&&!bq(_)?Cu(de,_,v.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation,rs(r)):T&&!bq(T)&&Cu(de,T,v.Member_0_implicitly_has_an_1_type,rs(r),"any"),C=Me),ry()||(qm(_)?Qe(_,v._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation,rs(r)):qm(h)||qm(T)?Qe(h,v._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation,rs(r)):_&&de&&Qe(_,v._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions,rs(r)),C=Me),a.type??(a.type=C)}return a.type}function wte(r){let a=as(r);if(!a.writeType){if(!dm(r,7))return Oe;let _=Pc(r,178)??ai(Pc(r,172),Ef),h=ny(_);ry()||(qm(_)&&Qe(_,v._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation,rs(r)),h=Me),a.writeType??(a.writeType=h||v7(r))}return a.writeType}function Ite(r){let a=Lr(Al(r));return a.flags&8650752?a:a.flags&2097152?Ln(a.types,_=>!!(_.flags&8650752)):void 0}function K6(r){let a=as(r),_=a;if(!a.type){let h=r.valueDeclaration&&ene(r.valueDeclaration,!1);if(h){let T=uCe(r,h);T&&(r=T,a=T.links)}_.type=a.type=OEe(r)}return a.type}function OEe(r){let a=r.valueDeclaration;if(r.flags&1536&&K3(r))return Me;if(a&&(a.kind===226||oc(a)&&a.parent.kind===226))return MD(r);if(r.flags&512&&a&&Ji(a)&&a.commonJsModuleIndicator){let h=Mf(r);if(h!==r){if(!dm(r,0))return Oe;let T=ro(r.exports.get("export=")),C=MD(T,T===h?void 0:h);return ry()?C:c1(r)}}let _=Lp(16,r);if(r.flags&32){let h=Ite(r);return h?Da([_,h]):_}else return ce&&r.flags&16777216?LS(_,!0):_}function Ote(r){let a=as(r);return a.type||(a.type=Jze(r))}function REe(r){let a=as(r);if(!a.type){if(!dm(r,0))return Oe;let _=Au(r),h=r.declarations&&J0(yp(r),!0),T=yi(h?.declarations,C=>dc(C)?fn(C):void 0);if(a.type??(a.type=h?.declarations&&Tne(h.declarations)&&r.declarations.length?ES(h):Tne(r.declarations)?tt:T||(Gf(_)&111551?gn(_):Oe)),!ry())return c1(h??r),a.type??(a.type=Oe)}return a.type}function Rte(r){let a=as(r);return a.type||(a.type=os(gn(a.target),a.mapper))}function MEe(r){let a=as(r);return a.writeType||(a.writeType=os(_T(a.target),a.mapper))}function c1(r){let a=r.valueDeclaration;if(a){if(Vl(a))return Qe(r.valueDeclaration,v._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation,rs(r)),Oe;de&&(a.kind!==169||a.initializer)&&Qe(r.valueDeclaration,v._0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer,rs(r))}else if(r.flags&2097152){let _=yp(r);_&&Qe(_,v.Circular_definition_of_import_alias_0,rs(r))}return Me}function cJ(r){let a=as(r);return a.type||(M.assertIsDefined(a.deferralParent),M.assertIsDefined(a.deferralConstituents),a.type=a.deferralParent.flags&1048576?fi(a.deferralConstituents):Da(a.deferralConstituents)),a.type}function LEe(r){let a=as(r);return!a.writeType&&a.deferralWriteConstituents&&(M.assertIsDefined(a.deferralParent),M.assertIsDefined(a.deferralConstituents),a.writeType=a.deferralParent.flags&1048576?fi(a.deferralWriteConstituents):Da(a.deferralWriteConstituents)),a.writeType}function _T(r){let a=ll(r);return r.flags&4?a&2?a&65536?LEe(r)||cJ(r):r.links.writeType||r.links.type:rv(gn(r),!!(r.flags&16777216)):r.flags&98304?a&1?MEe(r):wte(r):gn(r)}function gn(r,a){let _=ll(r);return _&65536?cJ(r):_&1?Rte(r):_&262144?k8t(r):_&8192?qLt(r):r.flags&7?Xo(r,a):r.flags&9136?K6(r):r.flags&8?Ote(r):r.flags&98304?v7(r):r.flags&2097152?REe(r):Oe}function CS(r){return rv(gn(r),!!(r.flags&16777216))}function AS(r,a){return r!==void 0&&a!==void 0&&(Kn(r)&4)!==0&&r.target===a}function LD(r){return Kn(r)&4?r.target:r}function FD(r,a){return _(r);function _(h){if(Kn(h)&7){let T=LD(h);return T===a||Pt(_i(T),_)}else if(h.flags&2097152)return Pt(h.types,_);return!1}}function lJ(r,a){for(let _ of a)r=$o(r,XE(jn(_)));return r}function jD(r,a){for(;;){if(r=r.parent,r&&Pn(r)){let _=cl(r);if(_===6||_===3){let h=jn(r.left);h&&h.parent&&!Pr(h.parent.valueDeclaration,T=>r===T)&&(r=h.parent.valueDeclaration)}}if(!r)return;switch(r.kind){case 263:case 231:case 264:case 179:case 180:case 173:case 184:case 185:case 317:case 262:case 174:case 218:case 219:case 265:case 345:case 346:case 340:case 338:case 200:case 194:{let h=jD(r,a);if(r.kind===200)return Bt(h,XE(jn(r.typeParameter)));if(r.kind===194)return ps(h,Ixe(r));let T=lJ(h,j1(r)),C=a&&(r.kind===263||r.kind===231||r.kind===264||vh(r))&&Al(jn(r)).thisType;return C?Bt(T,C):T}case 341:let _=CR(r);_&&(r=_.valueDeclaration);break;case 320:{let h=jD(r,a);return r.tags?lJ(h,va(r.tags,T=>sm(T)?T.typeParameters:void 0)):h}}}}function S7(r){var a;let _=r.flags&32||r.flags&16?r.valueDeclaration:(a=r.declarations)==null?void 0:a.find(h=>{if(h.kind===264)return!0;if(h.kind!==260)return!1;let T=h.initializer;return!!T&&(T.kind===218||T.kind===219)});return M.assert(!!_,"Class was missing valueDeclaration -OR- non-class had no interface declarations"),jD(_)}function l1(r){if(!r.declarations)return;let a;for(let _ of r.declarations)(_.kind===264||_.kind===263||_.kind===231||vh(_)||TR(_))&&(a=lJ(a,j1(_)));return a}function FEe(r){return ps(S7(r),l1(r))}function uJ(r){let a=Ys(r,1);if(a.length===1){let _=a[0];if(!_.typeParameters&&_.parameters.length===1&&E_(_)){let h=pq(_.parameters[0]);return Ao(h)||BJ(h)===Me}}return!1}function b7(r){if(Ys(r,1).length>0)return!0;if(r.flags&8650752){let a=Zu(r);return!!a&&uJ(a)}return!1}function fT(r){let a=S0(r.symbol);return a&&Fg(a)}function Mte(r,a,_){let h=wt(a),T=hn(_);return Zn(Ys(r,1),C=>(T||h>=ph(C.typeParameters))&&h<=wt(C.typeParameters))}function pT(r,a,_){let h=Mte(r,a,_),T=Cr(a,Wi);return Fs(h,C=>Pt(C.typeParameters)?A7(C,T,hn(_)):C)}function Lr(r){if(!r.resolvedBaseConstructorType){let a=S0(r.symbol),_=a&&Fg(a),h=fT(r);if(!h)return r.resolvedBaseConstructorType=nr;if(!dm(r,1))return Oe;let T=hs(h.expression);if(_&&h!==_&&(M.assert(!_.typeArguments),hs(_.expression)),T.flags&2621440&&Sg(T),!ry())return Qe(r.symbol.valueDeclaration,v._0_is_referenced_directly_or_indirectly_in_its_own_base_expression,rs(r.symbol)),r.resolvedBaseConstructorType??(r.resolvedBaseConstructorType=Oe);if(!(T.flags&1)&&T!==z&&!b7(T)){let C=Qe(h.expression,v.Type_0_is_not_a_constructor_function_type,ln(T));if(T.flags&262144){let I=t4(T),V=Rt;if(I){let H=Ys(I,1);H[0]&&(V=ko(H[0]))}T.symbol.declarations&&ca(C,pn(T.symbol.declarations[0],v.Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1,rs(T.symbol),ln(V)))}return r.resolvedBaseConstructorType??(r.resolvedBaseConstructorType=Oe)}r.resolvedBaseConstructorType??(r.resolvedBaseConstructorType=T)}return r.resolvedBaseConstructorType}function Xn(r){let a=ve;if(r.symbol.declarations)for(let _ of r.symbol.declarations){let h=eN(_);if(h)for(let T of h){let C=Wi(T);ao(C)||(a===ve?a=[C]:a.push(C))}}return a}function ei(r,a){Qe(r,v.Type_0_recursively_references_itself_as_a_base_type,ln(a,void 0,2))}function _i(r){if(!r.baseTypesResolved){if(dm(r,6)&&(r.objectFlags&8?r.resolvedBaseTypes=[Bi(r)]:r.symbol.flags&96?(r.symbol.flags&32&&mo(r),r.symbol.flags&64&&iy(r)):M.fail("type must be class or interface"),!ry()&&r.symbol.declarations))for(let a of r.symbol.declarations)(a.kind===263||a.kind===264)&&ei(a,r);r.baseTypesResolved=!0}return r.resolvedBaseTypes}function Bi(r){let a=Fs(r.typeParameters,(_,h)=>r.elementFlags[h]&8?Kf(_,Te):_);return g_(fi(a||ve),r.readonly)}function mo(r){r.resolvedBaseTypes=Y$;let a=K_(Lr(r));if(!(a.flags&2621441))return r.resolvedBaseTypes=ve;let _=fT(r),h,T=a.symbol?ac(a.symbol):void 0;if(a.symbol&&a.symbol.flags&32&&Qo(T))h=xWe(_,a.symbol);else if(a.flags&1)h=a;else{let I=pT(a,_.typeArguments,_);if(!I.length)return Qe(_.expression,v.No_base_constructor_has_the_specified_number_of_type_arguments),r.resolvedBaseTypes=ve;h=ko(I[0])}if(ao(h))return r.resolvedBaseTypes=ve;let C=bg(h);if(!ku(C)){let I=YEe(void 0,h),V=js(I,v.Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members,ln(C));return _o.add(ky(Ur(_.expression),_.expression,V)),r.resolvedBaseTypes=ve}return r===C||FD(C,r)?(Qe(r.symbol.valueDeclaration,v.Type_0_recursively_references_itself_as_a_base_type,ln(r,void 0,2)),r.resolvedBaseTypes=ve):(r.resolvedBaseTypes===Y$&&(r.members=void 0),r.resolvedBaseTypes=[C])}function Qo(r){let a=r.outerTypeParameters;if(a){let _=a.length-1,h=yc(r);return a[_].symbol!==h[_].symbol}return!0}function ku(r){if(r.flags&262144){let a=Zu(r);if(a)return ku(a)}return!!(r.flags&67633153&&!Yf(r)||r.flags&2097152&&wi(r.types,ku))}function iy(r){if(r.resolvedBaseTypes=r.resolvedBaseTypes||ve,r.symbol.declarations){for(let a of r.symbol.declarations)if(a.kind===264&&UI(a))for(let _ of UI(a)){let h=bg(Wi(_));ao(h)||(ku(h)?r!==h&&!FD(h,r)?r.resolvedBaseTypes===ve?r.resolvedBaseTypes=[h]:r.resolvedBaseTypes.push(h):ei(a,r):Qe(_,v.An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members))}}}function fh(r){if(!r.declarations)return!0;for(let a of r.declarations)if(a.kind===264){if(a.flags&256)return!1;let _=UI(a);if(_){for(let h of _)if(nc(h.expression)){let T=nl(h.expression,788968,!0);if(!T||!(T.flags&64)||Al(T).thisType)return!1}}}return!0}function Al(r){let a=as(r),_=a;if(!a.declaredType){let h=r.flags&32?1:2,T=uCe(r,r.valueDeclaration&&X9t(r.valueDeclaration));T&&(r=T,a=T.links);let C=_.declaredType=a.declaredType=Lp(h,r),I=S7(r),V=l1(r);(I||V||h===1||!fh(r))&&(C.objectFlags|=4,C.typeParameters=ps(I,V),C.outerTypeParameters=I,C.localTypeParameters=V,C.instantiations=new Map,C.instantiations.set(gm(C.typeParameters),C),C.target=C,C.resolvedTypeArguments=C.typeParameters,C.thisType=fd(r),C.thisType.isThisType=!0,C.thisType.constraint=C)}return a.declaredType}function Y0(r){var a;let _=as(r);if(!_.declaredType){if(!dm(r,2))return Oe;let h=M.checkDefined((a=r.declarations)==null?void 0:a.find(TR),"Type alias symbol with no valid declaration found"),T=Xd(h)?h.typeExpression:h.type,C=T?Wi(T):Oe;if(ry()){let I=l1(r);I&&(_.typeParameters=I,_.instantiations=new Map,_.instantiations.set(gm(I),C))}else C=Oe,h.kind===340?Qe(h.typeExpression.type,v.Type_alias_0_circularly_references_itself,rs(r)):Qe(Wu(h)&&h.name||h,v.Type_alias_0_circularly_references_itself,rs(r));_.declaredType??(_.declaredType=C)}return _.declaredType}function jk(r){return r.flags&1056&&r.symbol.flags&8?ac(Qu(r.symbol)):r}function Bk(r){let a=as(r);if(!a.declaredType){let _=[];if(r.declarations){for(let T of r.declarations)if(T.kind===266){for(let C of T.members)if(BD(C)){let I=jn(C),V=fC(C).value,H=Hk(V!==void 0?x7t(V,Aa(r),I):X6(I));as(I).declaredType=H,_.push(Q_(H))}}}let h=_.length?fi(_,1,r,void 0):X6(r);h.flags&1048576&&(h.flags|=1024,h.symbol=r),a.declaredType=h}return a.declaredType}function X6(r){let a=z0(32,r),_=z0(32,r);return a.regularType=a,a.freshType=_,_.regularType=a,_.freshType=_,a}function Jze(r){let a=as(r);if(!a.declaredType){let _=Bk(Qu(r));a.declaredType||(a.declaredType=_)}return a.declaredType}function XE(r){let a=as(r);return a.declaredType||(a.declaredType=fd(r))}function i8t(r){let a=as(r);return a.declaredType||(a.declaredType=ac(Au(r)))}function ac(r){return qze(r)||Oe}function qze(r){if(r.flags&96)return Al(r);if(r.flags&524288)return Y0(r);if(r.flags&262144)return XE(r);if(r.flags&384)return Bk(r);if(r.flags&8)return Jze(r);if(r.flags&2097152)return i8t(r)}function _J(r){switch(r.kind){case 133:case 159:case 154:case 150:case 163:case 136:case 155:case 151:case 116:case 157:case 146:case 201:return!0;case 188:return _J(r.elementType);case 183:return!r.typeArguments||r.typeArguments.every(_J)}return!1}function s8t(r){let a=RP(r);return!a||_J(a)}function zze(r){let a=Vl(r);return a?_J(a):!bv(r)}function a8t(r){let a=lp(r),_=j1(r);return(r.kind===176||!!a&&_J(a))&&r.parameters.every(zze)&&_.every(s8t)}function o8t(r){if(r.declarations&&r.declarations.length===1){let a=r.declarations[0];if(a)switch(a.kind){case 172:case 171:return zze(a);case 174:case 173:case 176:case 177:case 178:return a8t(a)}}return!1}function Wze(r,a,_){let h=fa();for(let T of r)h.set(T.escapedName,_&&o8t(T)?T:Bxe(T,a));return h}function $ze(r,a){for(let _ of a){if(Hze(_))continue;let h=r.get(_.escapedName);(!h||h.valueDeclaration&&Pn(h.valueDeclaration)&&!pd(h)&&!rfe(h.valueDeclaration))&&(r.set(_.escapedName,_),r.set(_.escapedName,_))}}function Hze(r){return!!r.valueDeclaration&&j_(r.valueDeclaration)&&oa(r.valueDeclaration)}function jEe(r){if(!r.declaredProperties){let a=r.symbol,_=kS(a);r.declaredProperties=SS(_),r.declaredCallSignatures=ve,r.declaredConstructSignatures=ve,r.declaredIndexInfos=ve,r.declaredCallSignatures=ex(_.get("__call")),r.declaredConstructSignatures=ex(_.get("__new")),r.declaredIndexInfos=SWe(a)}return r}function Lte(r){if(!za(r)&&!cc(r))return!1;let a=za(r)?r.expression:r.argumentExpression;return nc(a)&&tm(za(r)?gh(r):yl(a))}function T7(r){return r.charCodeAt(0)===95&&r.charCodeAt(1)===95&&r.charCodeAt(2)===64}function fJ(r){let a=Ps(r);return!!a&&Lte(a)}function BD(r){return!h0(r)||fJ(r)}function c8t(r){return T9(r)&&!Lte(r)}function l8t(r,a,_){M.assert(!!(ll(r)&4096),"Expected a late-bound symbol."),r.flags|=_,as(a.symbol).lateSymbol=r,r.declarations?a.symbol.isReplaceableByMethod||r.declarations.push(a):r.declarations=[a],_&111551&&(!r.valueDeclaration||r.valueDeclaration.kind!==a.kind)&&(r.valueDeclaration=a)}function Gze(r,a,_,h){M.assert(!!h.symbol,"The member is expected to have a symbol.");let T=qn(h);if(!T.resolvedSymbol){T.resolvedSymbol=h.symbol;let C=Pn(h)?h.left:h.name,I=cc(C)?yl(C.argumentExpression):gh(C);if(tm(I)){let V=rm(I),H=h.symbol.flags,X=_.get(V);X||_.set(V,X=Za(0,V,4096));let _e=a&&a.get(V);if(!(r.flags&32)&&X.flags&I2(H)){let we=_e?ps(_e.declarations,X.declarations):X.declarations,Ne=!(I.flags&8192)&&Qi(V)||Yo(C);kt(we,pt=>Qe(Ps(pt)||pt,v.Property_0_was_also_declared_here,Ne)),Qe(C||h,v.Duplicate_property_0,Ne),X=Za(0,V,4096)}return X.links.nameType=I,l8t(X,h,H),X.parent?M.assert(X.parent===r,"Existing symbol parent should match new one"):X.parent=r,T.resolvedSymbol=X}}return T.resolvedSymbol}function BEe(r,a){let _=as(r);if(!_[a]){let h=a==="resolvedExports",T=h?r.flags&1536?V2(r).exports:r.exports:r.members;_[a]=T||J;let C=fa();for(let H of r.declarations||ve){let X=H_e(H);if(X)for(let _e of X)h===Jl(_e)&&fJ(_e)&&Gze(r,T,C,_e)}let I=kD(r).assignmentDeclarationMembers;if(I){let H=Is(I.values());for(let X of H){let _e=cl(X),we=_e===3||Pn(X)&&jre(X,_e)||_e===9||_e===6;h===!we&&fJ(X)&&Gze(r,T,C,X)}}let V=ld(T,C);if(r.flags&33554432&&_.cjsExportMerged&&r.declarations)for(let H of r.declarations){let X=as(H.symbol)[a];if(!V){V=X;continue}X&&X.forEach((_e,we)=>{let Ne=V.get(we);if(!Ne)V.set(we,_e);else{if(Ne===_e)return;V.set(we,F0(Ne,_e))}})}_[a]=V||J}return _[a]}function kS(r){return r.flags&6256?BEe(r,"resolvedMembers"):r.members||J}function Fte(r){if(r.flags&106500&&r.escapedName==="__computed"){let a=as(r);if(!a.lateSymbol&&Pt(r.declarations,fJ)){let _=ro(r.parent);Pt(r.declarations,Jl)?Rp(_):kS(_)}return a.lateSymbol||(a.lateSymbol=r)}return r}function bp(r,a,_){if(Kn(r)&4){let h=r.target,T=yc(r);return wt(h.typeParameters)===wt(T)?_1(h,ps(T,[a||h.thisType])):r}else if(r.flags&2097152){let h=Fs(r.types,T=>bp(T,a,_));return h!==r.types?Da(h):r}return _?K_(r):r}function Yze(r,a,_,h){let T,C,I,V,H;hl(_,h,0,_.length)?(C=a.symbol?kS(a.symbol):fa(a.declaredProperties),I=a.declaredCallSignatures,V=a.declaredConstructSignatures,H=a.declaredIndexInfos):(T=Xf(_,h),C=Wze(a.declaredProperties,T,_.length===1),I=nre(a.declaredCallSignatures,T),V=nre(a.declaredConstructSignatures,T),H=b$e(a.declaredIndexInfos,T));let X=_i(a);if(X.length){if(a.symbol&&C===kS(a.symbol)){let we=fa(a.declaredProperties),Ne=sxe(a.symbol);Ne&&we.set("__index",Ne),C=we}Dt(r,C,I,V,H);let _e=vc(h);for(let we of X){let Ne=_e?bp(os(we,T),_e):we;$ze(C,bo(Ne)),I=ps(I,Ys(Ne,0)),V=ps(V,Ys(Ne,1));let pt=Ne!==Me?X_(Ne):[oy(Ue,Me,!1)];H=ps(H,Zn(pt,Tt=>!KEe(H,Tt.keyType)))}}Dt(r,C,I,V,H)}function u8t(r){Yze(r,jEe(r),ve,ve)}function _8t(r){let a=jEe(r.target),_=ps(a.typeParameters,[a.thisType]),h=yc(r),T=h.length===_.length?h:ps(h,[r]);Yze(r,a,_,T)}function Hy(r,a,_,h,T,C,I,V){let H=new m(ur,V);return H.declaration=r,H.typeParameters=a,H.parameters=h,H.thisParameter=_,H.resolvedReturnType=T,H.resolvedTypePredicate=C,H.minArgumentCount=I,H.resolvedMinArgumentCount=void 0,H.target=void 0,H.mapper=void 0,H.compositeSignatures=void 0,H.compositeKind=void 0,H}function E7(r){let a=Hy(r.declaration,r.typeParameters,r.thisParameter,r.parameters,void 0,void 0,r.minArgumentCount,r.flags&167);return a.target=r.target,a.mapper=r.mapper,a.compositeSignatures=r.compositeSignatures,a.compositeKind=r.compositeKind,a}function Kze(r,a){let _=E7(r);return _.compositeSignatures=a,_.compositeKind=1048576,_.target=void 0,_.mapper=void 0,_}function f8t(r,a){if((r.flags&24)===a)return r;r.optionalCallSignatureCache||(r.optionalCallSignatureCache={});let _=a===8?"inner":"outer";return r.optionalCallSignatureCache[_]||(r.optionalCallSignatureCache[_]=p8t(r,a))}function p8t(r,a){M.assert(a===8||a===16,"An optional call signature can either be for an inner call chain or an outer call chain, but not both.");let _=E7(r);return _.flags|=a,_}function Xze(r,a){if(E_(r)){let T=r.parameters.length-1,C=r.parameters[T].escapedName,I=gn(r.parameters[T]);if(Ha(I))return[_(I,T,C)];if(!a&&I.flags&1048576&&wi(I.types,Ha))return Cr(I.types,V=>_(V,T,C))}return[r.parameters];function _(T,C,I){let V=yc(T),H=h(T,I),X=Cr(V,(_e,we)=>{let Ne=H&&H[we]?H[we]:_4(r,C+we,T),pt=T.target.elementFlags[we],Tt=pt&12?32768:pt&2?16384:0,Mt=Za(1,Ne,Tt);return Mt.links.type=pt&4?g_(_e):_e,Mt});return ps(r.parameters.slice(0,C),X)}function h(T,C){let I=new Map;return Cr(T.target.labeledElementDeclarations,(V,H)=>{let X=mCe(V,H,C),_e=I.get(X);return _e===void 0?(I.set(X,1),X):(I.set(X,_e+1),`${X}_${_e}`)})}}function d8t(r){let a=Lr(r),_=Ys(a,1),h=S0(r.symbol),T=!!h&&li(h,64);if(_.length===0)return[Hy(void 0,r.localTypeParameters,void 0,ve,r,void 0,0,T?4:0)];let C=fT(r),I=hn(C),V=TJ(C),H=wt(V),X=[];for(let _e of _){let we=ph(_e.typeParameters),Ne=wt(_e.typeParameters);if(I||H>=we&&H<=Ne){let pt=Ne?Vte(_e,NS(V,_e.typeParameters,we,I)):E7(_e);pt.typeParameters=r.localTypeParameters,pt.resolvedReturnType=r,pt.flags=T?pt.flags|4:pt.flags&-5,X.push(pt)}}return X}function jte(r,a,_,h,T){for(let C of r)if(FJ(C,a,_,h,T,_?q7t:M7))return C}function m8t(r,a,_){if(a.typeParameters){if(_>0)return;for(let T=1;T<r.length;T++)if(!jte(r[T],a,!1,!1,!1))return;return[a]}let h;for(let T=0;T<r.length;T++){let C=T===_?a:jte(r[T],a,!1,!1,!0)||jte(r[T],a,!0,!1,!0);if(!C)return;h=$o(h,C)}return h}function UEe(r){let a,_;for(let h=0;h<r.length;h++){if(r[h].length===0)return ve;r[h].length>1&&(_=_===void 0?h:-1);for(let T of r[h])if(!a||!jte(a,T,!1,!1,!0)){let C=m8t(r,T,h);if(C){let I=T;if(C.length>1){let V=T.thisParameter,H=kt(C,X=>X.thisParameter);if(H){let X=Da(Gi(C,_e=>_e.thisParameter&&gn(_e.thisParameter)));V=tC(H,X)}I=Kze(T,C),I.thisParameter=V}(a||(a=[])).push(I)}}}if(!wt(a)&&_!==-1){let h=r[_!==void 0?_:0],T=h.slice();for(let C of r)if(C!==h){let I=C[0];if(M.assert(!!I,"getUnionSignatures bails early on empty signature lists and should not have empty lists on second pass"),T=I.typeParameters&&Pt(T,V=>!!V.typeParameters&&!Qze(I.typeParameters,V.typeParameters))?void 0:Cr(T,V=>y8t(V,I)),!T)break}a=T}return a||ve}function Qze(r,a){if(wt(r)!==wt(a))return!1;if(!r||!a)return!0;let _=Xf(a,r);for(let h=0;h<r.length;h++){let T=r[h],C=a[h];if(T!==C&&!Q0(t4(T)||Rt,os(t4(C)||Rt,_)))return!1}return!0}function g8t(r,a,_){if(!r||!a)return r||a;let h=Da([gn(r),os(gn(a),_)]);return tC(r,h)}function h8t(r,a,_){let h=ep(r),T=ep(a),C=h>=T?r:a,I=C===r?a:r,V=C===r?h:T,H=uy(r)||uy(a),X=H&&!uy(C),_e=new Array(V+(X?1:0));for(let we=0;we<V;we++){let Ne=ux(C,we);C===a&&(Ne=os(Ne,_));let pt=ux(I,we)||Rt;I===a&&(pt=os(pt,_));let Tt=Da([Ne,pt]),Mt=H&&!X&&we===V-1,mr=we>=Sh(C)&&we>=Sh(I),br=we>=h?void 0:_4(r,we),en=we>=T?void 0:_4(a,we),Fn=br===en?br:br?en?void 0:br:en,Dr=Za(1|(mr&&!Mt?16777216:0),Fn||`arg${we}`,Mt?32768:mr?16384:0);Dr.links.type=Mt?g_(Tt):Tt,_e[we]=Dr}if(X){let we=Za(1,"args",32768);we.links.type=g_(xg(I,V)),I===a&&(we.links.type=os(we.links.type,_)),_e[V]=we}return _e}function y8t(r,a){let _=r.typeParameters||a.typeParameters,h;r.typeParameters&&a.typeParameters&&(h=Xf(a.typeParameters,r.typeParameters));let T=r.declaration,C=h8t(r,a,h),I=g8t(r.thisParameter,a.thisParameter,h),V=Math.max(r.minArgumentCount,a.minArgumentCount),H=Hy(T,_,I,C,void 0,void 0,V,(r.flags|a.flags)&167);return H.compositeKind=1048576,H.compositeSignatures=ps(r.compositeKind!==2097152&&r.compositeSignatures||[r],[a]),h?H.mapper=r.compositeKind!==2097152&&r.mapper&&r.compositeSignatures?ax(r.mapper,h):h:r.compositeKind!==2097152&&r.mapper&&r.compositeSignatures&&(H.mapper=r.mapper),H}function Zze(r){let a=X_(r[0]);if(a){let _=[];for(let h of a){let T=h.keyType;wi(r,C=>!!Gy(C,T))&&_.push(oy(T,fi(Cr(r,C=>dT(C,T))),Pt(r,C=>Gy(C,T).isReadonly)))}return _}return ve}function v8t(r){let a=UEe(Cr(r.types,T=>T===$l?[ae]:Ys(T,0))),_=UEe(Cr(r.types,T=>Ys(T,1))),h=Zze(r.types);Dt(r,J,a,_,h)}function pJ(r,a){return r?a?Da([r,a]):r:a}function eWe(r){let a=vy(r,h=>Ys(h,1).length>0),_=Cr(r,uJ);if(a>0&&a===vy(_,h=>h)){let h=_.indexOf(!0);_[h]=!1}return _}function S8t(r,a,_,h){let T=[];for(let C=0;C<a.length;C++)C===h?T.push(r):_[C]&&T.push(ko(Ys(a[C],1)[0]));return Da(T)}function b8t(r){let a,_,h,T=r.types,C=eWe(T),I=vy(C,V=>V);for(let V=0;V<T.length;V++){let H=r.types[V];if(!C[V]){let X=Ys(H,1);X.length&&I>0&&(X=Cr(X,_e=>{let we=E7(_e);return we.resolvedReturnType=S8t(ko(_e),T,C,V),we})),_=tWe(_,X)}a=tWe(a,Ys(H,0)),h=L_(X_(H),(X,_e)=>rWe(X,_e,!1),h)}Dt(r,J,a||ve,_||ve,h||ve)}function tWe(r,a){for(let _ of a)(!r||wi(r,h=>!FJ(h,_,!1,!1,!1,M7)))&&(r=Bt(r,_));return r}function rWe(r,a,_){if(r)for(let h=0;h<r.length;h++){let T=r[h];if(T.keyType===a.keyType)return r[h]=oy(T.keyType,_?fi([T.type,a.type]):Da([T.type,a.type]),_?T.isReadonly||a.isReadonly:T.isReadonly&&a.isReadonly),r}return Bt(r,a)}function T8t(r){if(r.target){Dt(r,J,ve,ve,ve);let I=Wze(PS(r.target),r.mapper,!1),V=nre(Ys(r.target,0),r.mapper),H=nre(Ys(r.target,1),r.mapper),X=b$e(X_(r.target),r.mapper);Dt(r,I,V,H,X);return}let a=ro(r.symbol);if(a.flags&2048){Dt(r,J,ve,ve,ve);let I=kS(a),V=ex(I.get("__call")),H=ex(I.get("__new")),X=SWe(a);Dt(r,I,V,H,X);return}let _=Rp(a),h;if(a===ct){let I=new Map;_.forEach(V=>{var H;!(V.flags&418)&&!(V.flags&512&&((H=V.declarations)!=null&&H.length)&&wi(V.declarations,B_))&&I.set(V.escapedName,V)}),_=I}let T;if(Dt(r,_,ve,ve,ve),a.flags&32){let I=Al(a),V=Lr(I);V.flags&11272192?(_=fa(ye(_)),$ze(_,bo(V))):V===Me&&(T=oy(Ue,Me,!1))}let C=Jte(_);if(C?h=axe(C):(T&&(h=Bt(h,T)),a.flags&384&&(ac(a).flags&32||Pt(r.properties,I=>!!(gn(I).flags&296)))&&(h=Bt(h,Tr))),Dt(r,_,ve,ve,h||ve),a.flags&8208&&(r.callSignatures=ex(a)),a.flags&32){let I=Al(a),V=a.members?ex(a.members.get("__constructor")):ve;a.flags&16&&(V=wn(V.slice(),Gi(r.callSignatures,H=>vh(H.declaration)?Hy(H.declaration,H.typeParameters,H.thisParameter,H.parameters,I,void 0,H.minArgumentCount,H.flags&167):void 0))),V.length||(V=d8t(I)),r.constructSignatures=V}}function E8t(r,a,_){return os(r,Xf([a.indexType,a.objectType],[zm(0),cy([_])]))}function x8t(r){let a=dd(r.mappedType);if(!(a.flags&1048576||a.flags&2097152))return;let _=a.flags&1048576?a.origin:a;if(!_||!(_.flags&2097152))return;let h=Da(_.types.filter(T=>T!==r.constraintType));return h!==Ar?h:void 0}function C8t(r){let a=Gy(r.source,Ue),_=sy(r.mappedType),h=!(_&1),T=_&4?0:16777216,C=a?[oy(Ue,Cre(a.type,r.mappedType,r.constraintType)||Rt,h&&a.isReadonly)]:ve,I=fa(),V=x8t(r);for(let H of bo(r.source)){if(V){let we=qk(H,8576);if(!ga(we,V))continue}let X=8192|(h&&Cg(H)?8:0),_e=Za(4|H.flags&T,H.escapedName,X);if(_e.declarations=H.declarations,_e.links.nameType=as(H).nameType,_e.links.propertyType=gn(H),r.constraintType.type.flags&8388608&&r.constraintType.type.objectType.flags&262144&&r.constraintType.type.indexType.flags&262144){let we=r.constraintType.type.objectType,Ne=E8t(r.mappedType,r.constraintType.type,we);_e.links.mappedType=Ne,_e.links.constraintType=dh(we)}else _e.links.mappedType=r.mappedType,_e.links.constraintType=r.constraintType;I.set(H.escapedName,_e)}Dt(r,I,ve,ve,C)}function dJ(r){if(r.flags&4194304){let a=K_(r.type);return MS(a)?$We(a):dh(a)}if(r.flags&16777216){if(r.root.isDistributive){let a=r.checkType,_=dJ(a);if(_!==a)return Uxe(r,Z2(r.root.checkType,_,r.mapper),!1)}return r}if(r.flags&1048576)return wc(r,dJ,!0);if(r.flags&2097152){let a=r.types;return a.length===2&&a[0].flags&76&&a[1]===P_?r:Da(Fs(r.types,dJ))}return r}function VEe(r){return ll(r)&4096}function JEe(r,a,_,h){for(let T of bo(r))h(qk(T,a));if(r.flags&1)h(Ue);else for(let T of X_(r))(!_||T.keyType.flags&134217732)&&h(T.keyType)}function A8t(r){let a=fa(),_;Dt(r,J,ve,ve,ve);let h=vg(r),T=dd(r),C=r.target||r,I=u1(C),V=Bte(C)!==2,H=K0(C),X=K_(QE(r)),_e=sy(r);UD(r)?JEe(X,8576,!1,Ne):sC(dJ(T),Ne),Dt(r,a,ve,ve,_||ve);function Ne(Tt){let Mt=I?os(I,I7(r.mapper,h,Tt)):Tt;sC(Mt,mr=>pt(Tt,mr))}function pt(Tt,Mt){if(tm(Mt)){let mr=rm(Mt),br=a.get(mr);if(br)br.links.nameType=fi([br.links.nameType,Mt]),br.links.keyType=fi([br.links.keyType,Tt]);else{let en=tm(Tt)?ma(X,rm(Tt)):void 0,Fn=!!(_e&4||!(_e&8)&&en&&en.flags&16777216),Dr=!!(_e&1||!(_e&2)&&en&&Cg(en)),zr=ce&&!Fn&&en&&en.flags&16777216,Qr=en?VEe(en):0,$n=Za(4|(Fn?16777216:0),mr,Qr|262144|(Dr?8:0)|(zr?524288:0));$n.links.mappedType=r,$n.links.nameType=Mt,$n.links.keyType=Tt,en&&($n.links.syntheticOrigin=en,$n.declarations=V?en.declarations:void 0),a.set(mr,$n)}}else if(qte(Mt)||Mt.flags&33){let mr=Mt.flags&5?Ue:Mt.flags&40?Te:Mt,br=os(H,I7(r.mapper,h,Tt)),en=x7(X,Mt),Fn=!!(_e&1||!(_e&2)&&en?.isReadonly),Dr=oy(mr,br,Fn);_=rWe(_,Dr,!0)}}}function k8t(r){var a;if(!r.links.type){let _=r.links.mappedType;if(!dm(r,0))return _.containsError=!0,Oe;let h=K0(_.target||_),T=I7(_.mapper,vg(_),r.links.keyType),C=os(h,T),I=ce&&r.flags&16777216&&!dl(C,49152)?LS(C,!0):r.links.checkFlags&524288?Sre(C):C;ry()||(Qe(R,v.Type_of_property_0_circularly_references_itself_in_mapped_type_1,rs(r),ln(_)),I=Oe),(a=r.links).type??(a.type=I)}return r.links.type}function vg(r){return r.typeParameter||(r.typeParameter=XE(jn(r.declaration.typeParameter)))}function dd(r){return r.constraintType||(r.constraintType=mf(vg(r))||Oe)}function u1(r){return r.declaration.nameType?r.nameType||(r.nameType=os(Wi(r.declaration.nameType),r.mapper)):void 0}function K0(r){return r.templateType||(r.templateType=r.declaration.type?os(da(Wi(r.declaration.type),!0,!!(sy(r)&4)),r.mapper):Oe)}function nWe(r){return RP(r.declaration.typeParameter)}function UD(r){let a=nWe(r);return a.kind===198&&a.operator===143}function QE(r){if(!r.modifiersType)if(UD(r))r.modifiersType=os(Wi(nWe(r).type),r.mapper);else{let a=Dxe(r.declaration),_=dd(a),h=_&&_.flags&262144?mf(_):_;r.modifiersType=h&&h.flags&4194304?os(h.type,r.mapper):Rt}return r.modifiersType}function sy(r){let a=r.declaration;return(a.readonlyToken?a.readonlyToken.kind===41?2:1:0)|(a.questionToken?a.questionToken.kind===41?8:4:0)}function iWe(r){let a=sy(r);return a&8?-1:a&4?1:0}function Q6(r){if(Kn(r)&32)return iWe(r)||Q6(QE(r));if(r.flags&2097152){let a=Q6(r.types[0]);return wi(r.types,(_,h)=>h===0||Q6(_)===a)?a:0}return 0}function P8t(r){return!!(Kn(r)&32&&sy(r)&4)}function Yf(r){if(Kn(r)&32){let a=dd(r);if(Q2(a))return!0;let _=u1(r);if(_&&Q2(os(_,sx(vg(r),a))))return!0}return!1}function Bte(r){let a=u1(r);return a?ga(a,vg(r))?1:2:0}function Sg(r){return r.members||(r.flags&524288?r.objectFlags&4?_8t(r):r.objectFlags&3?u8t(r):r.objectFlags&1024?C8t(r):r.objectFlags&16?T8t(r):r.objectFlags&32?A8t(r):M.fail("Unhandled object type "+M.formatObjectFlags(r.objectFlags)):r.flags&1048576?v8t(r):r.flags&2097152?b8t(r):M.fail("Unhandled type "+M.formatTypeFlags(r.flags))),r}function PS(r){return r.flags&524288?Sg(r).properties:ve}function ZE(r,a){if(r.flags&524288){let h=Sg(r).members.get(a);if(h&&ey(h))return h}}function mJ(r){if(!r.resolvedProperties){let a=fa();for(let _ of r.types){for(let h of bo(_))if(!a.has(h.escapedName)){let T=hJ(r,h.escapedName,!!(r.flags&2097152));T&&a.set(h.escapedName,T)}if(r.flags&1048576&&X_(_).length===0)break}r.resolvedProperties=SS(a)}return r.resolvedProperties}function bo(r){return r=Z6(r),r.flags&3145728?mJ(r):PS(r)}function N8t(r,a){r=Z6(r),r.flags&3670016&&Sg(r).members.forEach((_,h)=>{O(_,h)&&a(_,h)})}function D8t(r,a){return a.properties.some(h=>{let T=h.name&&(sg(h.name)?Lf(ZR(h.name)):d1(h.name)),C=T&&tm(T)?rm(T):void 0,I=C===void 0?void 0:il(r,C);return!!I&&j7(I)&&!ga(tP(h),I)})}function w8t(r){let a=fi(r);if(!(a.flags&1048576))return ZCe(a);let _=fa();for(let h of r)for(let{escapedName:T}of ZCe(h))if(!_.has(T)){let C=_We(a,T);C&&_.set(T,C)}return Is(_.values())}function W2(r){return r.flags&262144?mf(r):r.flags&8388608?O8t(r):r.flags&16777216?oWe(r):Zu(r)}function mf(r){return gJ(r)?t4(r):void 0}function I8t(r,a){let _=O7(r);return!!_&&$2(_,a)}function $2(r,a=0){var _;return a<5&&!!(r&&(r.flags&262144&&Pt((_=r.symbol)==null?void 0:_.declarations,h=>li(h,4096))||r.flags&3145728&&Pt(r.types,h=>$2(h,a))||r.flags&8388608&&$2(r.objectType,a+1)||r.flags&16777216&&$2(oWe(r),a+1)||r.flags&33554432&&$2(r.baseType,a)||Kn(r)&32&&I8t(r,a)||MS(r)&&Bo(rx(r),(h,T)=>!!(r.target.elementFlags[T]&8)&&$2(h,a))>=0))}function O8t(r){return gJ(r)?R8t(r):void 0}function qEe(r){let a=X0(r,!1);return a!==r?a:W2(r)}function R8t(r){if(HEe(r))return Xte(r.objectType,r.indexType);let a=qEe(r.indexType);if(a&&a!==r.indexType){let h=wS(r.objectType,a,r.accessFlags);if(h)return h}let _=qEe(r.objectType);if(_&&_!==r.objectType)return wS(_,r.indexType,r.accessFlags)}function zEe(r){if(!r.resolvedDefaultConstraint){let a=v7t(r),_=hT(r);r.resolvedDefaultConstraint=Ao(a)?_:Ao(_)?a:fi([a,_])}return r.resolvedDefaultConstraint}function sWe(r){if(r.resolvedConstraintOfDistributive!==void 0)return r.resolvedConstraintOfDistributive||void 0;if(r.root.isDistributive&&r.restrictiveInstantiation!==r){let a=X0(r.checkType,!1),_=a===r.checkType?W2(a):a;if(_&&_!==r.checkType){let h=Uxe(r,Z2(r.root.checkType,_,r.mapper),!0);if(!(h.flags&131072))return r.resolvedConstraintOfDistributive=h,h}}r.resolvedConstraintOfDistributive=!1}function aWe(r){return sWe(r)||zEe(r)}function oWe(r){return gJ(r)?aWe(r):void 0}function M8t(r,a){let _,h=!1;for(let T of r)if(T.flags&465829888){let C=W2(T);for(;C&&C.flags&21233664;)C=W2(C);C&&(_=Bt(_,C),a&&(_=Bt(_,T)))}else(T.flags&469892092||ly(T))&&(h=!0);if(_&&(a||h)){if(h)for(let T of r)(T.flags&469892092||ly(T))&&(_=Bt(_,T));return RJ(Da(_,2),!1)}}function Zu(r){if(r.flags&464781312||MS(r)){let a=WEe(r);return a!==Lo&&a!==po?a:void 0}return r.flags&4194304?Er:void 0}function ay(r){return Zu(r)||r}function gJ(r){return WEe(r)!==po}function WEe(r){if(r.resolvedBaseConstraint)return r.resolvedBaseConstraint;let a=[];return r.resolvedBaseConstraint=_(r);function _(C){if(!C.immediateBaseConstraint){if(!dm(C,4))return po;let I,V=dre(C);if((a.length<10||a.length<50&&!Es(a,V))&&(a.push(V),I=T(X0(C,!1)),a.pop()),!ry()){if(C.flags&262144){let H=zte(C);if(H){let X=Qe(H,v.Type_parameter_0_has_a_circular_constraint,ln(C));R&&!rE(H,R)&&!rE(R,H)&&ca(X,pn(R,v.Circularity_originates_in_type_at_this_location))}}I=po}C.immediateBaseConstraint??(C.immediateBaseConstraint=I||Lo)}return C.immediateBaseConstraint}function h(C){let I=_(C);return I!==Lo&&I!==po?I:void 0}function T(C){if(C.flags&262144){let I=t4(C);return C.isThisType||!I?I:h(I)}if(C.flags&3145728){let I=C.types,V=[],H=!1;for(let X of I){let _e=h(X);_e?(_e!==X&&(H=!0),V.push(_e)):H=!0}return H?C.flags&1048576&&V.length===I.length?fi(V):C.flags&2097152&&V.length?Da(V):void 0:C}if(C.flags&4194304)return Er;if(C.flags&134217728){let I=C.types,V=Gi(I,h);return V.length===I.length?Y2(C.texts,V):Ue}if(C.flags&268435456){let I=h(C.type);return I&&I!==C.type?zk(C.symbol,I):Ue}if(C.flags&8388608){if(HEe(C))return h(Xte(C.objectType,C.indexType));let I=h(C.objectType),V=h(C.indexType),H=I&&V&&wS(I,V,C.accessFlags);return H&&h(H)}if(C.flags&16777216){let I=aWe(C);return I&&h(I)}if(C.flags&33554432)return h(_xe(C));if(MS(C)){let I=Cr(rx(C),(V,H)=>{let X=V.flags&262144&&C.target.elementFlags[H]&8&&h(V)||V;return X!==V&&Zf(X,_e=>vT(_e)&&!MS(_e))?X:V});return cy(I,C.target.elementFlags,C.target.readonly,C.target.labeledElementDeclarations)}return C}}function L8t(r,a){if(r===a)return r.resolvedApparentType||(r.resolvedApparentType=bp(r,a,!0));let _=`I${Lu(r)},${Lu(a)}`;return $b(_)??Xv(_,bp(r,a,!0))}function $Ee(r){if(r.default)r.default===_r&&(r.default=po);else if(r.target){let a=$Ee(r.target);r.default=a?os(a,r.mapper):Lo}else{r.default=_r;let a=r.symbol&&kt(r.symbol.declarations,h=>Ac(h)&&h.default),_=a?Wi(a):Lo;r.default===_r&&(r.default=_)}return r.default}function H2(r){let a=$Ee(r);return a!==Lo&&a!==po?a:void 0}function F8t(r){return $Ee(r)!==po}function cWe(r){return!!(r.symbol&&kt(r.symbol.declarations,a=>Ac(a)&&a.default))}function lWe(r){return r.resolvedApparentType||(r.resolvedApparentType=j8t(r))}function j8t(r){let a=r.target??r,_=O7(a);if(_&&!a.declaration.nameType){let h=QE(r),T=Yf(h)?lWe(h):Zu(h);if(T&&Zf(T,C=>vT(C)||uWe(C)))return os(a,Z2(_,T,r.mapper))}return r}function uWe(r){return!!(r.flags&2097152)&&wi(r.types,vT)}function HEe(r){let a;return!!(r.flags&8388608&&Kn(a=r.objectType)&32&&!Yf(a)&&Q2(r.indexType)&&!(sy(a)&8)&&!a.declaration.nameType)}function K_(r){let a=r.flags&465829888?Zu(r)||Rt:r,_=Kn(a);return _&32?lWe(a):_&4&&a!==r?bp(a,r):a.flags&2097152?L8t(a,r):a.flags&402653316?gs:a.flags&296?Qa:a.flags&2112?EMt():a.flags&528?so:a.flags&12288?FWe():a.flags&67108864?zi:a.flags&4194304?Er:a.flags&2&&!ce?zi:a}function Z6(r){return bg(K_(bg(r)))}function _We(r,a,_){var h,T,C;let I,V,H,X=r.flags&1048576,_e,we=4,Ne=X?0:8,pt=!1;for(let $n of r.types){let ii=K_($n);if(!(ao(ii)||ii.flags&131072)){let si=ma(ii,a,_),Ea=si?xd(si):0;if(si){if(si.flags&106500&&(_e??(_e=X?0:16777216),X?_e|=si.flags&16777216:_e&=si.flags),!I)I=si;else if(si!==I)if((nw(si)||si)===(nw(I)||I)&&Xxe(I,si,(no,Os)=>no===Os?-1:0)===-1)pt=!!I.parent&&!!wt(l1(I.parent));else{V||(V=new Map,V.set(Aa(I),I));let no=Aa(si);V.has(no)||V.set(no,si)}X&&Cg(si)?Ne|=8:!X&&!Cg(si)&&(Ne&=-9),Ne|=(Ea&6?0:256)|(Ea&4?512:0)|(Ea&2?1024:0)|(Ea&256?2048:0),$2e(si)||(we=2)}else if(X){let Ks=!T7(a)&&Vk(ii,a);Ks?(Ne|=32|(Ks.isReadonly?8:0),H=Bt(H,Ha(ii)?hre(ii)||nr:Ks.type)):TT(ii)&&!(Kn(ii)&2097152)?(Ne|=32,H=Bt(H,nr)):Ne|=16}}}if(!I||X&&(V||Ne&48)&&Ne&1536&&!(V&&B8t(V.values())))return;if(!V&&!(Ne&16)&&!H)if(pt){let $n=(h=ai(I,jh))==null?void 0:h.links,ii=tC(I,$n?.type);return ii.parent=(C=(T=I.valueDeclaration)==null?void 0:T.symbol)==null?void 0:C.parent,ii.links.containingType=r,ii.links.mapper=$n?.mapper,ii.links.writeType=_T(I),ii}else return I;let Tt=V?Is(V.values()):[I],Mt,mr,br,en=[],Fn,Dr,zr=!1;for(let $n of Tt){Dr?$n.valueDeclaration&&$n.valueDeclaration!==Dr&&(zr=!0):Dr=$n.valueDeclaration,Mt=wn(Mt,$n.declarations);let ii=gn($n);mr||(mr=ii,br=as($n).nameType);let si=_T($n);(Fn||si!==ii)&&(Fn=Bt(Fn||en.slice(),si)),ii!==mr&&(Ne|=64),(j7(ii)||K2(ii))&&(Ne|=128),ii.flags&131072&&ii!==Do&&(Ne|=131072),en.push(ii)}wn(en,H);let Qr=Za(4|(_e??0),a,we|Ne);return Qr.links.containingType=r,!zr&&Dr&&(Qr.valueDeclaration=Dr,Dr.symbol.parent&&(Qr.parent=Dr.symbol.parent)),Qr.declarations=Mt,Qr.links.nameType=br,en.length>2?(Qr.links.checkFlags|=65536,Qr.links.deferralParent=r,Qr.links.deferralConstituents=en,Qr.links.deferralWriteConstituents=Fn):(Qr.links.type=X?fi(en):Da(en),Fn&&(Qr.links.writeType=X?fi(Fn):Da(Fn))),Qr}function fWe(r,a,_){var h,T,C;let I=_?(h=r.propertyCacheWithoutObjectFunctionPropertyAugment)==null?void 0:h.get(a):(T=r.propertyCache)==null?void 0:T.get(a);return I||(I=_We(r,a,_),I&&((_?r.propertyCacheWithoutObjectFunctionPropertyAugment||(r.propertyCacheWithoutObjectFunctionPropertyAugment=fa()):r.propertyCache||(r.propertyCache=fa())).set(a,I),_&&!(ll(I)&48)&&!((C=r.propertyCache)!=null&&C.get(a))&&(r.propertyCache||(r.propertyCache=fa())).set(a,I))),I}function B8t(r){let a;for(let _ of r){if(!_.declarations)return;if(!a){a=new Set(_.declarations);continue}if(a.forEach(h=>{Es(_.declarations,h)||a.delete(h)}),a.size===0)return}return a}function hJ(r,a,_){let h=fWe(r,a,_);return h&&!(ll(h)&16)?h:void 0}function bg(r){return r.flags&1048576&&r.objectFlags&16777216?r.resolvedReducedType||(r.resolvedReducedType=U8t(r)):r.flags&2097152?(r.objectFlags&16777216||(r.objectFlags|=16777216|(Pt(mJ(r),V8t)?33554432:0)),r.objectFlags&33554432?Ar:r):r}function U8t(r){let a=Fs(r.types,bg);if(a===r.types)return r;let _=fi(a);return _.flags&1048576&&(_.resolvedReducedType=_),_}function V8t(r){return pWe(r)||dWe(r)}function pWe(r){return!(r.flags&16777216)&&(ll(r)&131264)===192&&!!(gn(r).flags&131072)}function dWe(r){return!r.valueDeclaration&&!!(ll(r)&1024)}function GEe(r){return!!(r.flags&1048576&&r.objectFlags&16777216&&Pt(r.types,GEe)||r.flags&2097152&&J8t(r))}function J8t(r){let a=r.uniqueLiteralFilledInstantiation||(r.uniqueLiteralFilledInstantiation=os(r,ms));return bg(a)!==a}function YEe(r,a){if(a.flags&2097152&&Kn(a)&33554432){let _=Ln(mJ(a),pWe);if(_)return js(r,v.The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituents,ln(a,void 0,536870912),rs(_));let h=Ln(mJ(a),dWe);if(h)return js(r,v.The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_private_in_some,ln(a,void 0,536870912),rs(h))}return r}function ma(r,a,_,h){var T,C;if(r=Z6(r),r.flags&524288){let I=Sg(r),V=I.members.get(a);if(V&&!h&&((T=r.symbol)==null?void 0:T.flags)&512&&((C=as(r.symbol).typeOnlyExportStarMap)!=null&&C.has(a)))return;if(V&&ey(V,h))return V;if(_)return;let H=I===bc?$l:I.callSignatures.length?nd:I.constructSignatures.length?Je:void 0;if(H){let X=ZE(H,a);if(X)return X}return ZE(rl,a)}if(r.flags&2097152){let I=hJ(r,a,!0);return I||(_?void 0:hJ(r,a,_))}if(r.flags&1048576)return hJ(r,a,_)}function yJ(r,a){if(r.flags&3670016){let _=Sg(r);return a===0?_.callSignatures:_.constructSignatures}return ve}function Ys(r,a){let _=yJ(Z6(r),a);if(a===0&&!wt(_)&&r.flags&1048576){if(r.arrayFallbackSignatures)return r.arrayFallbackSignatures;let h;if(Zf(r,T=>{var C;return!!((C=T.symbol)!=null&&C.parent)&&q8t(T.symbol.parent)&&(h?h===T.symbol.escapedName:(h=T.symbol.escapedName,!0))})){let T=wc(r,I=>m1((mWe(I.symbol.parent)?Gr:qt).typeParameters[0],I.mapper)),C=g_(T,ym(r,I=>mWe(I.symbol.parent)));return r.arrayFallbackSignatures=Ys(il(C,h),a)}r.arrayFallbackSignatures=_}return _}function q8t(r){return!r||!qt.symbol||!Gr.symbol?!1:!!Um(r,qt.symbol)||!!Um(r,Gr.symbol)}function mWe(r){return!r||!Gr.symbol?!1:!!Um(r,Gr.symbol)}function KEe(r,a){return Ln(r,_=>_.keyType===a)}function XEe(r,a){let _,h,T;for(let C of r)C.keyType===Ue?_=C:Uk(a,C.keyType)&&(h?(T||(T=[h])).push(C):h=C);return T?oy(Rt,Da(Cr(T,C=>C.type)),L_(T,(C,I)=>C&&I.isReadonly,!0)):h||(_&&Uk(a,Ue)?_:void 0)}function Uk(r,a){return ga(r,a)||a===Ue&&ga(r,Te)||a===Te&&(r===qs||!!(r.flags&128)&&Ry(r.value))}function QEe(r){return r.flags&3670016?Sg(r).indexInfos:ve}function X_(r){return QEe(Z6(r))}function Gy(r,a){return KEe(X_(r),a)}function dT(r,a){var _;return(_=Gy(r,a))==null?void 0:_.type}function ZEe(r,a){return X_(r).filter(_=>Uk(a,_.keyType))}function x7(r,a){return XEe(X_(r),a)}function Vk(r,a){return x7(r,T7(a)?Hr:Lf(Qi(a)))}function gWe(r){var a;let _;for(let h of j1(r))_=$o(_,XE(h.symbol));return _?.length?_:Tl(r)?(a=e4(r))==null?void 0:a.typeParameters:void 0}function exe(r){let a=[];return r.forEach((_,h)=>{q2(h)||a.push(_)}),a}function txe(r,a){if(vu(r))return;let _=m_(De,'"'+r+'"',512);return _&&a?ro(_):_}function rxe(r){return oA(r)||QR(r)||ns(r)&&mj(r)}function vJ(r){if(rxe(r))return!0;if(!ns(r))return!1;if(r.initializer){let _=md(r.parent),h=r.parent.parameters.indexOf(r);return M.assert(h>=0),h>=Sh(_,3)}let a=QT(r.parent);return a?!r.type&&!r.dotDotDotToken&&r.parent.parameters.indexOf(r)>=Qre(a).length:!1}function z8t(r){return Ns(r)&&!Ug(r)&&r.questionToken}function C7(r,a,_,h){return{kind:r,parameterName:a,parameterIndex:_,type:h}}function ph(r){let a=0;if(r)for(let _=0;_<r.length;_++)cWe(r[_])||(a=_+1);return a}function NS(r,a,_,h){let T=wt(a);if(!T)return[];let C=wt(r);if(h||C>=_&&C<=T){let I=r?r.slice():[];for(let H=C;H<T;H++)I[H]=Oe;let V=g2e(h);for(let H=C;H<T;H++){let X=H2(a[H]);h&&X&&(Q0(X,Rt)||Q0(X,zi))&&(X=Me),I[H]=X?os(X,Xf(a,I)):V}return I.length=a.length,I}return r&&r.slice()}function md(r){let a=qn(r);if(!a.resolvedSignature){let _=[],h=0,T=0,C,I=hn(r)?x5(r):void 0,V=!1,H=QT(r),X=XP(r);!H&&hn(r)&&lA(r)&&!Jue(r)&&!rb(r)&&(h|=32);for(let Tt=X?1:0;Tt<r.parameters.length;Tt++){let Mt=r.parameters[Tt];if(hn(Mt)&&fY(Mt)){I=Mt;continue}let mr=Mt.symbol,br=Pd(Mt)?Mt.typeExpression&&Mt.typeExpression.type:Mt.type;mr&&mr.flags&4&&!Hs(Mt.name)&&(mr=xr(Mt,mr.escapedName,111551,void 0,!1)),Tt===0&&mr.escapedName==="this"?(V=!0,C=Mt.symbol):_.push(mr),br&&br.kind===201&&(h|=2),rxe(Mt)||ns(Mt)&&Mt.initializer||Fh(Mt)||H&&_.length>H.arguments.length&&!br||(T=_.length)}if((r.kind===177||r.kind===178)&&BD(r)&&(!V||!C)){let Tt=r.kind===177?178:177,Mt=Pc(jn(r),Tt);Mt&&(C=Fk(Mt))}I&&I.typeExpression&&(C=tC(Za(1,"this"),Wi(I.typeExpression)));let we=A0(r)?_b(r):r,Ne=we&&Vc(we)?Al(ro(we.parent.symbol)):void 0,pt=Ne?Ne.localTypeParameters:gWe(r);(G$(r)||hn(r)&&W8t(r,_))&&(h|=1),(gN(r)&&li(r,64)||Vc(r)&&li(r.parent,64))&&(h|=4),a.resolvedSignature=Hy(r,pt,C,_,void 0,void 0,T,h)}return a.resolvedSignature}function W8t(r,a){if(A0(r)||!nxe(r))return!1;let _=vc(r.parameters),h=_?OP(_):nb(r).filter(Pd),T=yi(h,I=>I.typeExpression&&Bj(I.typeExpression.type)?I.typeExpression.type:void 0),C=Za(3,"args",32768);return T?C.links.type=g_(Wi(T.type)):(C.links.checkFlags|=65536,C.links.deferralParent=Ar,C.links.deferralConstituents=[Uo],C.links.deferralWriteConstituents=[Uo]),T&&a.pop(),a.push(C),!0}function e4(r){if(!(hn(r)&&Go(r)))return;let a=tb(r);return a?.typeExpression&&lC(Wi(a.typeExpression))}function $8t(r,a){let _=e4(r);if(!_)return;let h=r.parameters.indexOf(a);return a.dotDotDotToken?dq(_,h):xg(_,h)}function H8t(r){let a=e4(r);return a&&ko(a)}function nxe(r){let a=qn(r);return a.containsArgumentsReference===void 0&&(a.flags&512?a.containsArgumentsReference=!0:a.containsArgumentsReference=_(r.body)),a.containsArgumentsReference;function _(h){if(!h)return!1;switch(h.kind){case 80:return h.escapedText===qe.escapedName&&uL(h)===qe;case 172:case 174:case 177:case 178:return h.name.kind===167&&_(h.name);case 211:case 212:return _(h.expression);case 303:return _(h.initializer);default:return!FH(h)&&!Lg(h)&&!!Js(h,_)}}}function ex(r){if(!r||!r.declarations)return ve;let a=[];for(let _=0;_<r.declarations.length;_++){let h=r.declarations[_];if(Bs(h)){if(_>0&&h.body){let T=r.declarations[_-1];if(h.parent===T.parent&&h.kind===T.kind&&h.pos===T.end)continue}if(hn(h)&&h.jsDoc){let T=kH(h);if(wt(T)){for(let C of T){let I=C.typeExpression;I.type===void 0&&!Vc(h)&&bT(I,Me),a.push(md(I))}continue}}a.push(!K1(h)&&!Nm(h)&&e4(h)||md(h))}}return a}function hWe(r){let a=G_(r,r);if(a){let _=Mf(a);if(_)return gn(_)}return Me}function mT(r){if(r.thisParameter)return gn(r.thisParameter)}function Bd(r){if(!r.resolvedTypePredicate){if(r.target){let a=Bd(r.target);r.resolvedTypePredicate=a?O7t(a,r.mapper):tl}else if(r.compositeSignatures)r.resolvedTypePredicate=GMt(r.compositeSignatures,r.compositeKind)||tl;else{let a=r.declaration&&lp(r.declaration),_;if(!a){let h=e4(r.declaration);h&&r!==h&&(_=Bd(h))}if(a||_)r.resolvedTypePredicate=a&&LA(a)?G8t(a,r):_||tl;else if(r.declaration&&Go(r.declaration)&&(!r.resolvedReturnType||r.resolvedReturnType.flags&16)&&ep(r)>0){let{declaration:h}=r;r.resolvedTypePredicate=tl,r.resolvedTypePredicate=Njt(h)||tl}else r.resolvedTypePredicate=tl}M.assert(!!r.resolvedTypePredicate)}return r.resolvedTypePredicate===tl?void 0:r.resolvedTypePredicate}function G8t(r,a){let _=r.parameterName,h=r.type&&Wi(r.type);return _.kind===197?C7(r.assertsModifier?2:0,void 0,void 0,h):C7(r.assertsModifier?3:1,_.escapedText,Bo(a.parameters,T=>T.escapedName===_.escapedText),h)}function yWe(r,a,_){return a!==2097152?fi(r,_):Da(r)}function ko(r){if(!r.resolvedReturnType){if(!dm(r,3))return Oe;let a=r.target?os(ko(r.target),r.mapper):r.compositeSignatures?os(yWe(Cr(r.compositeSignatures,ko),r.compositeKind,2),r.mapper):VD(r.declaration)||($c(r.declaration.body)?Me:rne(r.declaration));if(r.flags&8?a=Z$e(a):r.flags&16&&(a=LS(a)),!ry()){if(r.declaration){let _=lp(r.declaration);if(_)Qe(_,v.Return_type_annotation_circularly_references_itself);else if(de){let h=r.declaration,T=Ps(h);T?Qe(T,v._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions,Yo(T)):Qe(h,v.Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions)}}a=Me}r.resolvedReturnType??(r.resolvedReturnType=a)}return r.resolvedReturnType}function VD(r){if(r.kind===176)return Al(ro(r.parent.symbol));let a=lp(r);if(A0(r)){let _=QP(r);if(_&&Vc(_.parent)&&!a)return Al(ro(_.parent.parent.symbol))}if(XP(r))return Wi(r.parameters[0].type);if(a)return Wi(a);if(r.kind===177&&BD(r)){let _=hn(r)&&xi(r);if(_)return _;let h=Pc(jn(r),178),T=ny(h);if(T)return T}return H8t(r)}function Ute(r){return r.compositeSignatures&&Pt(r.compositeSignatures,Ute)||!r.resolvedReturnType&&RD(r,3)>=0}function Y8t(r){return vWe(r)||Me}function vWe(r){if(E_(r)){let a=gn(r.parameters[r.parameters.length-1]),_=Ha(a)?hre(a):a;return _&&dT(_,Te)}}function A7(r,a,_,h){let T=ixe(r,NS(a,r.typeParameters,ph(r.typeParameters),_));if(h){let C=UGe(ko(T));if(C){let I=E7(C);I.typeParameters=h;let V=E7(T);return V.resolvedReturnType=G2(I),V}}return T}function ixe(r,a){let _=r.instantiations||(r.instantiations=new Map),h=gm(a),T=_.get(h);return T||_.set(h,T=Vte(r,a)),T}function Vte(r,a){return Gk(r,K8t(r,a),!0)}function K8t(r,a){return Xf(Fs(r.typeParameters,_=>_.mapper?os(_,_.mapper):_),a)}function k7(r){return r.typeParameters?r.erasedSignatureCache||(r.erasedSignatureCache=X8t(r)):r}function X8t(r){return Gk(r,T$e(r.typeParameters),!0)}function Q8t(r){return r.typeParameters?r.canonicalSignatureCache||(r.canonicalSignatureCache=Z8t(r)):r}function Z8t(r){return A7(r,Cr(r.typeParameters,a=>a.target&&!mf(a.target)?a.target:a),hn(r.declaration))}function eMt(r){return r.typeParameters?r.implementationSignatureCache||(r.implementationSignatureCache=tMt(r)):r}function tMt(r){return r.typeParameters?Gk(r,Xf([],[])):r}function rMt(r){let a=r.typeParameters;if(a){if(r.baseSignatureCache)return r.baseSignatureCache;let _=T$e(a),h=Xf(a,Cr(a,C=>mf(C)||Rt)),T=Cr(a,C=>os(C,h)||Rt);for(let C=0;C<a.length-1;C++)T=Yy(T,h);return T=Yy(T,_),r.baseSignatureCache=Gk(r,Xf(a,T),!0)}return r}function G2(r,a){var _;if(!r.isolatedSignatureType){let h=(_=r.declaration)==null?void 0:_.kind,T=h===void 0||h===176||h===180||h===185,C=Lp(134217744,Za(16,"__function"));r.declaration&&!Ko(r.declaration)&&(C.symbol.declarations=[r.declaration],C.symbol.valueDeclaration=r.declaration),a||(a=r.declaration&&jD(r.declaration,!0)),C.outerTypeParameters=a,C.members=J,C.properties=ve,C.callSignatures=T?ve:[r],C.constructSignatures=T?[r]:ve,C.indexInfos=ve,r.isolatedSignatureType=C}return r.isolatedSignatureType}function sxe(r){return r.members?Jte(r.members):void 0}function Jte(r){return r.get("__index")}function oy(r,a,_,h){return{keyType:r,type:a,isReadonly:_,declaration:h}}function SWe(r){let a=sxe(r);return a?axe(a):ve}function axe(r){if(r.declarations){let a=[];for(let _ of r.declarations)if(_.parameters.length===1){let h=_.parameters[0];h.type&&sC(Wi(h.type),T=>{qte(T)&&!KEe(a,T)&&a.push(oy(T,_.type?Wi(_.type):Me,up(_,8),_))})}return a}return ve}function qte(r){return!!(r.flags&4108)||K2(r)||!!(r.flags&2097152)&&!Wk(r)&&Pt(r.types,qte)}function zte(r){return Gi(Zn(r.symbol&&r.symbol.declarations,Ac),RP)[0]}function bWe(r,a){var _;let h;if((_=r.symbol)!=null&&_.declarations){for(let T of r.symbol.declarations)if(T.parent.kind===195){let[C=T.parent,I]=gfe(T.parent.parent);if(I.kind===183&&!a){let V=I,H=DCe(V);if(H){let X=V.typeArguments.indexOf(C);if(X<H.length){let _e=mf(H[X]);if(_e){let we=Fxe(H,H.map((pt,Tt)=>()=>xBt(V,H,Tt))),Ne=os(_e,we);Ne!==r&&(h=Bt(h,Ne))}}}}else if(I.kind===169&&I.dotDotDotToken||I.kind===191||I.kind===202&&I.dotDotDotToken)h=Bt(h,g_(Rt));else if(I.kind===204)h=Bt(h,Ue);else if(I.kind===168&&I.parent.kind===200)h=Bt(h,Er);else if(I.kind===200&&I.type&&So(I.type)===T.parent&&I.parent.kind===194&&I.parent.extendsType===I&&I.parent.checkType.kind===200&&I.parent.checkType.type){let V=I.parent.checkType,H=Wi(V.type);h=Bt(h,os(H,sx(XE(jn(V.typeParameter)),V.typeParameter.constraint?Wi(V.typeParameter.constraint):Er)))}}}return h&&Da(h)}function t4(r){if(!r.constraint)if(r.target){let a=mf(r.target);r.constraint=a?os(a,r.mapper):Lo}else{let a=zte(r);if(!a)r.constraint=bWe(r)||Lo;else{let _=Wi(a);_.flags&1&&!ao(_)&&(_=a.parent.parent.kind===200?Er:Rt),r.constraint=_}}return r.constraint===Lo?void 0:r.constraint}function TWe(r){let a=Pc(r.symbol,168),_=sm(a.parent)?y9(a.parent):a.parent;return _&&_d(_)}function gm(r){let a="";if(r){let _=r.length,h=0;for(;h<_;){let T=r[h].id,C=1;for(;h+C<_&&r[h+C].id===T+C;)C++;a.length&&(a+=","),a+=T,C>1&&(a+=":"+C),h+=C}}return a}function Jk(r,a){return r?`@${Aa(r)}`+(a?`:${gm(a)}`:""):""}function SJ(r,a){let _=0;for(let h of r)(a===void 0||!(h.flags&a))&&(_|=Kn(h));return _&458752}function JD(r,a){return Pt(a)&&r===Fa?Rt:_1(r,a)}function _1(r,a){let _=gm(a),h=r.instantiations.get(_);return h||(h=Lp(4,r.symbol),r.instantiations.set(_,h),h.objectFlags|=a?SJ(a):0,h.target=r,h.resolvedTypeArguments=a),h}function EWe(r){let a=z0(r.flags,r.symbol);return a.objectFlags=r.objectFlags,a.target=r.target,a.resolvedTypeArguments=r.resolvedTypeArguments,a}function oxe(r,a,_,h,T){if(!h){h=$k(a);let I=$D(h);T=_?Yy(I,_):I}let C=Lp(4,r.symbol);return C.target=r,C.node=a,C.mapper=_,C.aliasSymbol=h,C.aliasTypeArguments=T,C}function yc(r){var a,_;if(!r.resolvedTypeArguments){if(!dm(r,5))return((a=r.target.localTypeParameters)==null?void 0:a.map(()=>Oe))||ve;let h=r.node,T=h?h.kind===183?ps(r.target.outerTypeParameters,lne(h,r.target.localTypeParameters)):h.kind===188?[Wi(h.elementType)]:Cr(h.elements,Wi):ve;ry()?r.resolvedTypeArguments??(r.resolvedTypeArguments=r.mapper?Yy(T,r.mapper):T):(r.resolvedTypeArguments??(r.resolvedTypeArguments=((_=r.target.localTypeParameters)==null?void 0:_.map(()=>Oe))||ve),Qe(r.node||R,r.target.symbol?v.Type_arguments_for_0_circularly_reference_themselves:v.Tuple_type_arguments_circularly_reference_themselves,r.target.symbol&&rs(r.target.symbol)))}return r.resolvedTypeArguments}function f1(r){return wt(r.target.typeParameters)}function xWe(r,a){let _=ac(ro(a)),h=_.localTypeParameters;if(h){let T=wt(r.typeArguments),C=ph(h),I=hn(r);if(!(!de&&I)&&(T<C||T>h.length)){let X=I&&x0(r)&&!zA(r.parent),_e=C===h.length?X?v.Expected_0_type_arguments_provide_these_with_an_extends_tag:v.Generic_type_0_requires_1_type_argument_s:X?v.Expected_0_1_type_arguments_provide_these_with_an_extends_tag:v.Generic_type_0_requires_between_1_and_2_type_arguments,we=ln(_,void 0,2);if(Qe(r,_e,we,C,h.length),!I)return Oe}if(r.kind===183&&zWe(r,wt(r.typeArguments)!==h.length))return oxe(_,r,void 0);let H=ps(_.outerTypeParameters,NS(TJ(r),h,C,I));return _1(_,H)}return tx(r,a)?_:Oe}function qD(r,a,_,h){let T=ac(r);if(T===Ut){let X=gK.get(r.escapedName);if(X!==void 0&&a&&a.length===1)return X===4?cxe(a[0]):zk(r,a[0])}let C=as(r),I=C.typeParameters,V=gm(a)+Jk(_,h),H=C.instantiations.get(V);return H||C.instantiations.set(V,H=C$e(T,Xf(I,NS(a,I,ph(I),hn(r.valueDeclaration))),_,h)),H}function nMt(r,a){if(ll(a)&1048576){let T=TJ(r),C=Jk(a,T),I=Ce.get(C);return I||(I=Ll(1,"error",void 0,`alias ${C}`),I.aliasSymbol=a,I.aliasTypeArguments=T,Ce.set(C,I)),I}let _=ac(a),h=as(a).typeParameters;if(h){let T=wt(r.typeArguments),C=ph(h);if(T<C||T>h.length)return Qe(r,C===h.length?v.Generic_type_0_requires_1_type_argument_s:v.Generic_type_0_requires_between_1_and_2_type_arguments,rs(a),C,h.length),Oe;let I=$k(r),V=I&&(CWe(a)||!CWe(I))?I:void 0,H;if(V)H=$D(V);else if(j5(r)){let X=r4(r,2097152,!0);if(X&&X!==St){let _e=Au(X);_e&&_e.flags&524288&&(V=_e,H=TJ(r)||(h?[]:void 0))}}return qD(a,TJ(r),V,H)}return tx(r,a)?_:Oe}function CWe(r){var a;let _=(a=r.declarations)==null?void 0:a.find(TR);return!!(_&&Dp(_))}function iMt(r){switch(r.kind){case 183:return r.typeName;case 233:let a=r.expression;if(nc(a))return a}}function AWe(r){return r.parent?`${AWe(r.parent)}.${r.escapedName}`:r.escapedName}function Wte(r){let _=(r.kind===166?r.right:r.kind===211?r.name:r).escapedText;if(_){let h=r.kind===166?Wte(r.left):r.kind===211?Wte(r.expression):void 0,T=h?`${AWe(h)}.${_}`:_,C=vt.get(T);return C||(vt.set(T,C=Za(524288,_,1048576)),C.parent=h,C.links.declaredType=At),C}return St}function r4(r,a,_){let h=iMt(r);if(!h)return St;let T=nl(h,a,_);return T&&T!==St?T:_?St:Wte(h)}function $te(r,a){if(a===St)return Oe;if(a=q6(a)||a,a.flags&96)return xWe(r,a);if(a.flags&524288)return nMt(r,a);let _=qze(a);if(_)return tx(r,a)?Q_(_):Oe;if(a.flags&111551&&Hte(r)){let h=sMt(r,a);return h||(r4(r,788968),gn(a))}return Oe}function sMt(r,a){let _=qn(r);if(!_.resolvedJSDocType){let h=gn(a),T=h;if(a.valueDeclaration){let C=r.kind===205&&r.qualifier;h.symbol&&h.symbol!==a&&C&&(T=$te(r,h.symbol))}_.resolvedJSDocType=T}return _.resolvedJSDocType}function cxe(r){return lxe(r)?kWe(r,Rt):r}function lxe(r){return!!(r.flags&3145728&&Pt(r.types,lxe)||r.flags&33554432&&!zD(r)&&lxe(r.baseType)||r.flags&524288&&!ly(r)||r.flags&432275456&&!K2(r))}function zD(r){return!!(r.flags&33554432&&r.constraint.flags&2)}function uxe(r,a){return a.flags&3||a===r||r.flags&1?r:kWe(r,a)}function kWe(r,a){let _=`${Lu(r)}>${Lu(a)}`,h=Ci.get(_);if(h)return h;let T=_h(33554432);return T.baseType=r,T.constraint=a,Ci.set(_,T),T}function _xe(r){return zD(r)?r.baseType:Da([r.constraint,r.baseType])}function PWe(r){return r.kind===189&&r.elements.length===1}function NWe(r,a,_){return PWe(a)&&PWe(_)?NWe(r,a.elements[0],_.elements[0]):IS(Wi(a))===IS(r)?Wi(_):void 0}function aMt(r,a){let _,h=!0;for(;a&&!Vi(a)&&a.kind!==320;){let T=a.parent;if(T.kind===169&&(h=!h),(h||r.flags&8650752)&&T.kind===194&&a===T.trueType){let C=NWe(r,T.checkType,T.extendsType);C&&(_=Bt(_,C))}else if(r.flags&262144&&T.kind===200&&!T.nameType&&a===T.type){let C=Wi(T);if(vg(C)===IS(r)){let I=O7(C);if(I){let V=mf(I);V&&Zf(V,vT)&&(_=Bt(_,fi([Te,qs])))}}}a=T}return _?uxe(r,Da(_)):r}function Hte(r){return!!(r.flags&16777216)&&(r.kind===183||r.kind===205)}function tx(r,a){return r.typeArguments?(Qe(r,v.Type_0_is_not_generic,a?rs(a):r.typeName?Yo(r.typeName):fK),!1):!0}function DWe(r){if(He(r.typeName)){let a=r.typeArguments;switch(r.typeName.escapedText){case"String":return tx(r),Ue;case"Number":return tx(r),Te;case"Boolean":return tx(r),qr;case"Void":return tx(r),dn;case"Undefined":return tx(r),nr;case"Null":return tx(r),Ke;case"Function":case"function":return tx(r),$l;case"array":return(!a||!a.length)&&!de?Uo:void 0;case"promise":return(!a||!a.length)&&!de?gq(Me):void 0;case"Object":if(a&&a.length===2){if(p9(r)){let _=Wi(a[0]),h=Wi(a[1]),T=_===Ue||_===Te?[oy(_,h,!1)]:ve;return Zt(void 0,J,ve,ve,T)}return Me}return tx(r),de?void 0:Me}}}function oMt(r){let a=Wi(r.type);return ce?UJ(a,65536):a}function bJ(r){let a=qn(r);if(!a.resolvedType){if(Qm(r)&&sb(r.parent))return a.resolvedSymbol=St,a.resolvedType=yl(r.parent.expression);let _,h,T=788968;Hte(r)&&(h=DWe(r),h||(_=r4(r,T,!0),_===St?_=r4(r,T|111551):r4(r,T),h=$te(r,_))),h||(_=r4(r,T),h=$te(r,_)),a.resolvedSymbol=_,a.resolvedType=h}return a.resolvedType}function TJ(r){return Cr(r.typeArguments,Wi)}function wWe(r){let a=qn(r);if(!a.resolvedType){let _=aYe(r);a.resolvedType=Q_(Qf(_))}return a.resolvedType}function IWe(r,a){function _(T){let C=T.declarations;if(C)for(let I of C)switch(I.kind){case 263:case 264:case 266:return I}}if(!r)return a?Fa:zi;let h=ac(r);return h.flags&524288?wt(h.typeParameters)!==a?(Qe(_(r),v.Global_type_0_must_have_1_type_parameter_s,Qc(r),a),a?Fa:zi):h:(Qe(_(r),v.Global_type_0_must_be_a_class_or_interface_type,Qc(r)),a?Fa:zi)}function fxe(r,a){return WD(r,111551,a?v.Cannot_find_global_value_0:void 0)}function pxe(r,a){return WD(r,788968,a?v.Cannot_find_global_type_0:void 0)}function Gte(r,a,_){let h=WD(r,788968,_?v.Cannot_find_global_type_0:void 0);if(h&&(ac(h),wt(as(h).typeParameters)!==a)){let T=h.declarations&&Ln(h.declarations,im);Qe(T,v.Global_type_0_must_have_1_type_parameter_s,Qc(h),a);return}return h}function WD(r,a,_){return xr(void 0,r,a,_,!1,!1)}function kl(r,a,_){let h=pxe(r,_);return h||_?IWe(h,a):void 0}function cMt(){return wd||(wd=kl("TypedPropertyDescriptor",1,!0)||Fa)}function lMt(){return nn||(nn=kl("TemplateStringsArray",0,!0)||zi)}function OWe(){return Hn||(Hn=kl("ImportMeta",0,!0)||zi)}function RWe(){if(!Si){let r=Za(0,"ImportMetaExpression"),a=OWe(),_=Za(4,"meta",8);_.parent=r,_.links.type=a;let h=fa([_]);r.members=h,Si=Zt(r,h,ve,ve,ve)}return Si}function MWe(r){return $||($=kl("ImportCallOptions",0,r))||zi}function dxe(r){return Fe||(Fe=kl("ImportAttributes",0,r))||zi}function LWe(r){return fg||(fg=fxe("Symbol",r))}function uMt(r){return id||(id=pxe("SymbolConstructor",r))}function FWe(){return If||(If=kl("Symbol",0,!1))||zi}function EJ(r){return sd||(sd=kl("Promise",1,r))||Fa}function jWe(r){return Gh||(Gh=kl("PromiseLike",1,r))||Fa}function mxe(r){return Yh||(Yh=fxe("Promise",r))}function _Mt(r){return Of||(Of=kl("PromiseConstructorLike",0,r))||zi}function Yte(r){return yt||(yt=kl("AsyncIterable",1,r))||Fa}function fMt(r){return Gt||(Gt=kl("AsyncIterator",3,r))||Fa}function pMt(r){return Xt||(Xt=kl("AsyncIterableIterator",1,r))||Fa}function dMt(r){return Fr||(Fr=kl("AsyncGenerator",3,r))||Fa}function gxe(r){return Hl||(Hl=kl("Iterable",1,r))||Fa}function mMt(r){return Kh||(Kh=kl("Iterator",3,r))||Fa}function gMt(r){return $f||($f=kl("IterableIterator",1,r))||Fa}function hMt(r){return nh||(nh=kl("Generator",3,r))||Fa}function yMt(r){return ad||(ad=kl("IteratorYieldResult",1,r))||Fa}function vMt(r){return oe||(oe=kl("IteratorReturnResult",1,r))||Fa}function BWe(r){return jt||(jt=kl("Disposable",0,r))||zi}function SMt(r){return Xr||(Xr=kl("AsyncDisposable",0,r))||zi}function UWe(r,a=0){let _=WD(r,788968,void 0);return _&&IWe(_,a)}function bMt(){return Mi||(Mi=Gte("Extract",2,!0)||St),Mi===St?void 0:Mi}function TMt(){return Us||(Us=Gte("Omit",2,!0)||St),Us===St?void 0:Us}function hxe(r){return Ss||(Ss=Gte("Awaited",1,r)||(r?St:void 0)),Ss===St?void 0:Ss}function EMt(){return zs||(zs=kl("BigInt",0,!1))||zi}function xMt(r){return qc??(qc=kl("ClassDecoratorContext",1,r))??Fa}function CMt(r){return Id??(Id=kl("ClassMethodDecoratorContext",2,r))??Fa}function AMt(r){return Om??(Om=kl("ClassGetterDecoratorContext",2,r))??Fa}function kMt(r){return Xh??(Xh=kl("ClassSetterDecoratorContext",2,r))??Fa}function PMt(r){return Vy??(Vy=kl("ClassAccessorDecoratorContext",2,r))??Fa}function NMt(r){return $v??($v=kl("ClassAccessorDecoratorTarget",2,r))??Fa}function DMt(r){return Jy??(Jy=kl("ClassAccessorDecoratorResult",2,r))??Fa}function wMt(r){return Od??(Od=kl("ClassFieldDecoratorContext",2,r))??Fa}function IMt(){return vo||(vo=fxe("NaN",!1))}function OMt(){return Wa||(Wa=Gte("Record",2,!0)||St),Wa===St?void 0:Wa}function P7(r,a){return r!==Fa?_1(r,a):zi}function VWe(r){return P7(cMt(),[r])}function JWe(r){return P7(gxe(!0),[r])}function g_(r,a){return P7(a?Gr:qt,[r])}function yxe(r){switch(r.kind){case 190:return 2;case 191:return qWe(r);case 202:return r.questionToken?2:r.dotDotDotToken?qWe(r):1;default:return 1}}function qWe(r){return PJ(r.type)?4:8}function RMt(r){let a=FMt(r.parent);if(PJ(r))return a?Gr:qt;let h=Cr(r.elements,yxe);return vxe(h,a,Cr(r.elements,MMt))}function MMt(r){return hN(r)||ns(r)?r:void 0}function zWe(r,a){return!!$k(r)||WWe(r)&&(r.kind===188?DS(r.elementType):r.kind===189?Pt(r.elements,DS):a||Pt(r.typeArguments,DS))}function WWe(r){let a=r.parent;switch(a.kind){case 196:case 202:case 183:case 192:case 193:case 199:case 194:case 198:case 188:case 189:return WWe(a);case 265:return!0}return!1}function DS(r){switch(r.kind){case 183:return Hte(r)||!!(r4(r,788968).flags&524288);case 186:return!0;case 198:return r.operator!==158&&DS(r.type);case 196:case 190:case 202:case 316:case 314:case 315:case 309:return DS(r.type);case 191:return r.type.kind!==188||DS(r.type.elementType);case 192:case 193:return Pt(r.types,DS);case 199:return DS(r.objectType)||DS(r.indexType);case 194:return DS(r.checkType)||DS(r.extendsType)||DS(r.trueType)||DS(r.falseType)}return!1}function LMt(r){let a=qn(r);if(!a.resolvedType){let _=RMt(r);if(_===Fa)a.resolvedType=zi;else if(!(r.kind===189&&Pt(r.elements,h=>!!(yxe(h)&8)))&&zWe(r))a.resolvedType=r.kind===189&&r.elements.length===0?_:oxe(_,r,void 0);else{let h=r.kind===188?[Wi(r.elementType)]:Cr(r.elements,Wi);a.resolvedType=Sxe(_,h)}}return a.resolvedType}function FMt(r){return yb(r)&&r.operator===148}function cy(r,a,_=!1,h=[]){let T=vxe(a||Cr(r,C=>1),_,h);return T===Fa?zi:r.length?Sxe(T,r):T}function vxe(r,a,_){if(r.length===1&&r[0]&4)return a?Gr:qt;let h=Cr(r,C=>C&1?"#":C&2?"?":C&4?".":"*").join()+(a?"R":"")+(Pt(_,C=>!!C)?","+Cr(_,C=>C?yo(C):"_").join(","):""),T=Pi.get(h);return T||Pi.set(h,T=jMt(r,a,_)),T}function jMt(r,a,_){let h=r.length,T=vy(r,we=>!!(we&9)),C,I=[],V=0;if(h){C=new Array(h);for(let we=0;we<h;we++){let Ne=C[we]=fd(),pt=r[we];if(V|=pt,!(V&12)){let Tt=Za(4|(pt&2?16777216:0),""+we,a?8:0);Tt.links.tupleLabelDeclaration=_?.[we],Tt.links.type=Ne,I.push(Tt)}}}let H=I.length,X=Za(4,"length",a?8:0);if(V&12)X.links.type=Te;else{let we=[];for(let Ne=T;Ne<=h;Ne++)we.push(zm(Ne));X.links.type=fi(we)}I.push(X);let _e=Lp(12);return _e.typeParameters=C,_e.outerTypeParameters=void 0,_e.localTypeParameters=C,_e.instantiations=new Map,_e.instantiations.set(gm(_e.typeParameters),_e),_e.target=_e,_e.resolvedTypeArguments=_e.typeParameters,_e.thisType=fd(),_e.thisType.isThisType=!0,_e.thisType.constraint=_e,_e.declaredProperties=I,_e.declaredCallSignatures=ve,_e.declaredConstructSignatures=ve,_e.declaredIndexInfos=ve,_e.elementFlags=r,_e.minLength=T,_e.fixedLength=H,_e.hasRestElement=!!(V&12),_e.combinedFlags=V,_e.readonly=a,_e.labeledElementDeclarations=_,_e}function Sxe(r,a){return r.objectFlags&8?bxe(r,a):_1(r,a)}function bxe(r,a){var _,h,T,C;if(!(r.combinedFlags&14))return _1(r,a);if(r.combinedFlags&8){let Tt=Bo(a,(Mt,mr)=>!!(r.elementFlags[mr]&8&&Mt.flags&1179648));if(Tt>=0)return CJ(Cr(a,(Mt,mr)=>r.elementFlags[mr]&8?Mt:Rt))?wc(a[Tt],Mt=>bxe(r,wW(a,Tt,Mt))):Oe}let I=[],V=[],H=[],X=-1,_e=-1,we=-1;for(let Tt=0;Tt<a.length;Tt++){let Mt=a[Tt],mr=r.elementFlags[Tt];if(mr&8)if(Mt.flags&1)pt(Mt,4,(_=r.labeledElementDeclarations)==null?void 0:_[Tt]);else if(Mt.flags&58982400||Yf(Mt))pt(Mt,8,(h=r.labeledElementDeclarations)==null?void 0:h[Tt]);else if(Ha(Mt)){let br=rx(Mt);if(br.length+I.length>=1e4)return Qe(R,Lg(R)?v.Type_produces_a_tuple_type_that_is_too_large_to_represent:v.Expression_produces_a_tuple_type_that_is_too_large_to_represent),Oe;kt(br,(en,Fn)=>{var Dr;return pt(en,Mt.target.elementFlags[Fn],(Dr=Mt.target.labeledElementDeclarations)==null?void 0:Dr[Fn])})}else pt(g1(Mt)&&dT(Mt,Te)||Oe,4,(T=r.labeledElementDeclarations)==null?void 0:T[Tt]);else pt(Mt,mr,(C=r.labeledElementDeclarations)==null?void 0:C[Tt])}for(let Tt=0;Tt<X;Tt++)V[Tt]&2&&(V[Tt]=1);_e>=0&&_e<we&&(I[_e]=fi(Fs(I.slice(_e,we+1),(Tt,Mt)=>V[_e+Mt]&8?Kf(Tt,Te):Tt)),I.splice(_e+1,we-_e),V.splice(_e+1,we-_e),H.splice(_e+1,we-_e));let Ne=vxe(V,r.readonly,H);return Ne===Fa?zi:V.length?_1(Ne,I):Ne;function pt(Tt,Mt,mr){Mt&1&&(X=V.length),Mt&4&&_e<0&&(_e=V.length),Mt&6&&(we=V.length),I.push(Mt&2?da(Tt,!0):Tt),V.push(Mt),H.push(mr)}}function n4(r,a,_=0){let h=r.target,T=f1(r)-_;return a>h.fixedLength?xLt(r)||cy(ve):cy(yc(r).slice(a,T),h.elementFlags.slice(a,T),!1,h.labeledElementDeclarations&&h.labeledElementDeclarations.slice(a,T))}function $We(r){return fi(Bt(Bce(r.target.fixedLength,a=>Lf(""+a)),dh(r.target.readonly?Gr:qt)))}function BMt(r,a){let _=Bo(r.elementFlags,h=>!(h&a));return _>=0?_:r.elementFlags.length}function N7(r,a){return r.elementFlags.length-pv(r.elementFlags,_=>!(_&a))-1}function Txe(r){return r.fixedLength+N7(r,3)}function rx(r){let a=yc(r),_=f1(r);return a.length===_?a:a.slice(0,_)}function UMt(r){return da(Wi(r.type),!0)}function Lu(r){return r.id}function p1(r,a){return mv(r,a,Lu,tc)>=0}function xJ(r,a){let _=mv(r,a,Lu,tc);return _<0?(r.splice(~_,0,a),!0):!1}function VMt(r,a,_){let h=_.flags;if(!(h&131072))if(a|=h&473694207,h&465829888&&(a|=33554432),h&2097152&&Kn(_)&67108864&&(a|=536870912),_===ft&&(a|=8388608),ao(_)&&(a|=1073741824),!ce&&h&98304)Kn(_)&65536||(a|=4194304);else{let T=r.length,C=T&&_.id>r[T-1].id?~T:mv(r,_,Lu,tc);C<0&&r.splice(~C,0,_)}return a}function HWe(r,a,_){let h;for(let T of _)T!==h&&(a=T.flags&1048576?HWe(r,a|(HMt(T)?1048576:0),T.types):VMt(r,a,T),h=T);return a}function JMt(r,a){var _;if(r.length<2)return r;let h=gm(r),T=Ui.get(h);if(T)return T;let C=a&&Pt(r,X=>!!(X.flags&524288)&&!Yf(X)&&zxe(Sg(X))),I=r.length,V=I,H=0;for(;V>0;){V--;let X=r[V];if(C||X.flags&469499904){if(X.flags&262144&&ay(X).flags&1048576){mh(X,fi(Cr(r,Ne=>Ne===X?Ar:Ne)),Rd)&&M1(r,V);continue}let _e=X.flags&61603840?Ln(bo(X),Ne=>Tg(gn(Ne))):void 0,we=_e&&Q_(gn(_e));for(let Ne of r)if(X!==Ne){if(H===1e5&&H/(I-V)*I>1e6){(_=Cn)==null||_.instant(Cn.Phase.CheckTypes,"removeSubtypes_DepthLimit",{typeIds:r.map(Tt=>Tt.id)}),Qe(R,v.Expression_produces_a_union_type_that_is_too_complex_to_represent);return}if(H++,_e&&Ne.flags&61603840){let pt=il(Ne,_e.escapedName);if(pt&&Tg(pt)&&Q_(pt)!==we)continue}if(mh(X,Ne,Rd)&&(!(Kn(LD(X))&1)||!(Kn(LD(Ne))&1)||yT(X,Ne))){M1(r,V);break}}}}return Ui.set(h,r),r}function qMt(r,a,_){let h=r.length;for(;h>0;){h--;let T=r[h],C=T.flags;(C&402653312&&a&4||C&256&&a&8||C&2048&&a&64||C&8192&&a&4096||_&&C&32768&&a&16384||ix(T)&&p1(r,T.regularType))&&M1(r,h)}}function zMt(r){let a=Zn(r,K2);if(a.length){let _=r.length;for(;_>0;){_--;let h=r[_];h.flags&128&&Pt(a,T=>WMt(h,T))&&M1(r,_)}}}function WMt(r,a){return a.flags&134217728?kre(r,a):Are(r,a)}function $Mt(r){let a=[];for(let _ of r)if(_.flags&2097152&&Kn(_)&67108864){let h=_.types[0].flags&8650752?0:1;ol(a,_.types[h])}for(let _ of a){let h=[];for(let C of r)if(C.flags&2097152&&Kn(C)&67108864){let I=C.types[0].flags&8650752?0:1;C.types[I]===_&&xJ(h,C.types[1-I])}let T=Zu(_);if(Zf(T,C=>p1(h,C))){let C=r.length;for(;C>0;){C--;let I=r[C];if(I.flags&2097152&&Kn(I)&67108864){let V=I.types[0].flags&8650752?0:1;I.types[V]===_&&p1(h,I.types[1-V])&&M1(r,C)}}xJ(r,_)}}}function HMt(r){return!!(r.flags&1048576&&(r.aliasSymbol||r.origin))}function GWe(r,a){for(let _ of a)if(_.flags&1048576){let h=_.origin;_.aliasSymbol||h&&!(h.flags&1048576)?ol(r,_):h&&h.flags&1048576&&GWe(r,h.types)}}function Exe(r,a){let _=J2(r);return _.types=a,_}function fi(r,a=1,_,h,T){if(r.length===0)return Ar;if(r.length===1)return r[0];if(r.length===2&&!T&&(r[0].flags&1048576||r[1].flags&1048576)){let C=a===0?"N":a===2?"S":"L",I=r[0].id<r[1].id?0:1,V=r[I].id+C+r[1-I].id+Jk(_,h),H=ss.get(V);return H||(H=YWe(r,a,_,h,void 0),ss.set(V,H)),H}return YWe(r,a,_,h,T)}function YWe(r,a,_,h,T){let C=[],I=HWe(C,0,r);if(a!==0){if(I&3)return I&1?I&8388608?ft:I&1073741824?Oe:Me:Rt;if(I&32768&&C.length>=2&&C[0]===nr&&C[1]===Ge&&M1(C,1),(I&402664352||I&16384&&I&32768)&&qMt(C,I,!!(a&2)),I&128&&I&402653184&&zMt(C),I&536870912&&$Mt(C),a===2&&(C=JMt(C,!!(I&524288)),!C))return Oe;if(C.length===0)return I&65536?I&4194304?Ke:z:I&32768?I&4194304?nr:Z:Ar}if(!T&&I&1048576){let H=[];GWe(H,r);let X=[];for(let we of C)Pt(H,Ne=>p1(Ne.types,we))||X.push(we);if(!_&&H.length===1&&X.length===0)return H[0];if(L_(H,(we,Ne)=>we+Ne.types.length,0)+X.length===C.length){for(let we of H)xJ(X,we);T=Exe(1048576,X)}}let V=(I&36323331?0:32768)|(I&2097152?16777216:0);return Cxe(C,V,_,h,T)}function GMt(r,a){let _,h=[];for(let C of r){let I=Bd(C);if(I){if(I.kind!==0&&I.kind!==1||_&&!xxe(_,I))return;_=I,h.push(I.type)}else{let V=a!==2097152?ko(C):void 0;if(V!==It&&V!==$t)return}}if(!_)return;let T=yWe(h,a);return C7(_.kind,_.parameterName,_.parameterIndex,T)}function xxe(r,a){return r.kind===a.kind&&r.parameterIndex===a.parameterIndex}function Cxe(r,a,_,h,T){if(r.length===0)return Ar;if(r.length===1)return r[0];let I=(T?T.flags&1048576?`|${gm(T.types)}`:T.flags&2097152?`&${gm(T.types)}`:`#${T.type.id}|${gm(r)}`:gm(r))+Jk(_,h),V=Cs.get(I);return V||(V=_h(1048576),V.objectFlags=a|SJ(r,98304),V.types=r,V.origin=T,V.aliasSymbol=_,V.aliasTypeArguments=h,r.length===2&&r[0].flags&512&&r[1].flags&512&&(V.flags|=16,V.intrinsicName="boolean"),Cs.set(I,V)),V}function YMt(r){let a=qn(r);if(!a.resolvedType){let _=$k(r);a.resolvedType=fi(Cr(r.types,Wi),1,_,$D(_))}return a.resolvedType}function KMt(r,a,_){let h=_.flags;return h&2097152?KWe(r,a,_.types):(ly(_)?a&16777216||(a|=16777216,r.set(_.id.toString(),_)):(h&3?(_===ft&&(a|=8388608),ao(_)&&(a|=1073741824)):(ce||!(h&98304))&&(_===Ge&&(a|=262144,_=nr),r.has(_.id.toString())||(_.flags&109472&&a&109472&&(a|=67108864),r.set(_.id.toString(),_))),a|=h&473694207),a)}function KWe(r,a,_){for(let h of _)a=KMt(r,a,Q_(h));return a}function XMt(r,a){let _=r.length;for(;_>0;){_--;let h=r[_];(h.flags&4&&a&402653312||h.flags&8&&a&256||h.flags&64&&a&2048||h.flags&4096&&a&8192||h.flags&16384&&a&32768||ly(h)&&a&470302716)&&M1(r,_)}}function QMt(r,a){for(let _ of r)if(!p1(_.types,a)){let h=a.flags&128?Ue:a.flags&288?Te:a.flags&2048?Re:a.flags&8192?Hr:void 0;if(!h||!p1(_.types,h))return!1}return!0}function ZMt(r){let a=r.length,_=Zn(r,h=>!!(h.flags&128));for(;a>0;){a--;let h=r[a];if(h.flags&402653184){for(let T of _)if(OS(T,h)){M1(r,a);break}else if(K2(h))return!0}}return!1}function XWe(r,a){for(let _=0;_<r.length;_++)r[_]=Fl(r[_],h=>!(h.flags&a))}function e7t(r){let a,_=Bo(r,I=>!!(Kn(I)&32768));if(_<0)return!1;let h=_+1;for(;h<r.length;){let I=r[h];Kn(I)&32768?((a||(a=[r[_]])).push(I),M1(r,h)):h++}if(!a)return!1;let T=[],C=[];for(let I of a)for(let V of I.types)xJ(T,V)&&QMt(a,V)&&xJ(C,V);return r[_]=Cxe(C,32768),!0}function t7t(r,a,_,h){let T=_h(2097152);return T.objectFlags=a|SJ(r,98304),T.types=r,T.aliasSymbol=_,T.aliasTypeArguments=h,T}function Da(r,a=0,_,h){let T=new Map,C=KWe(T,0,r),I=Is(T.values()),V=0;if(C&131072)return Es(I,In)?In:Ar;if(ce&&C&98304&&C&84410368||C&67108864&&C&402783228||C&402653316&&C&67238776||C&296&&C&469891796||C&2112&&C&469889980||C&12288&&C&469879804||C&49152&&C&469842940||C&402653184&&C&128&&ZMt(I))return Ar;if(C&1)return C&8388608?ft:C&1073741824?Oe:Me;if(!ce&&C&98304)return C&16777216?Ar:C&32768?nr:Ke;if((C&4&&C&402653312||C&8&&C&256||C&64&&C&2048||C&4096&&C&8192||C&16384&&C&32768||C&16777216&&C&470302716)&&(a&1||XMt(I,C)),C&262144&&(I[I.indexOf(nr)]=Ge),I.length===0)return Rt;if(I.length===1)return I[0];if(I.length===2&&!(a&2)){let _e=I[0].flags&8650752?0:1,we=I[_e],Ne=I[1-_e];if(we.flags&8650752&&(Ne.flags&469893116&&!c$e(Ne)||C&16777216)){let pt=Zu(we);if(pt&&Zf(pt,Tt=>!!(Tt.flags&469893116)||ly(Tt))){if(wJ(pt,Ne))return we;if(!(pt.flags&1048576&&ym(pt,Tt=>wJ(Tt,Ne)))&&!wJ(Ne,pt))return Ar;V=67108864}}}let H=gm(I)+(a&2?"*":Jk(_,h)),X=Ii.get(H);if(!X){if(C&1048576)if(e7t(I))X=Da(I,a,_,h);else if(wi(I,_e=>!!(_e.flags&1048576&&_e.types[0].flags&32768))){let _e=Pt(I,U7)?Ge:nr;XWe(I,32768),X=fi([Da(I,a),_e],1,_,h)}else if(wi(I,_e=>!!(_e.flags&1048576&&(_e.types[0].flags&65536||_e.types[1].flags&65536))))XWe(I,65536),X=fi([Da(I,a),Ke],1,_,h);else if(I.length>=4){let _e=Math.floor(I.length/2);X=Da([Da(I.slice(0,_e),a),Da(I.slice(_e),a)],a,_,h)}else{if(!CJ(I))return Oe;let _e=r7t(I,a),we=Pt(_e,Ne=>!!(Ne.flags&2097152))&&Axe(_e)>Axe(I)?Exe(2097152,I):void 0;X=fi(_e,1,_,h,we)}else X=t7t(I,V,_,h);Ii.set(H,X)}return X}function QWe(r){return L_(r,(a,_)=>_.flags&1048576?a*_.types.length:_.flags&131072?0:a,1)}function CJ(r){var a;let _=QWe(r);return _>=1e5?((a=Cn)==null||a.instant(Cn.Phase.CheckTypes,"checkCrossProductUnion_DepthLimit",{typeIds:r.map(h=>h.id),size:_}),Qe(R,v.Expression_produces_a_union_type_that_is_too_complex_to_represent),!1):!0}function r7t(r,a){let _=QWe(r),h=[];for(let T=0;T<_;T++){let C=r.slice(),I=T;for(let H=r.length-1;H>=0;H--)if(r[H].flags&1048576){let X=r[H].types,_e=X.length;C[H]=X[I%_e],I=Math.floor(I/_e)}let V=Da(C,a);V.flags&131072||h.push(V)}return h}function ZWe(r){return!(r.flags&3145728)||r.aliasSymbol?1:r.flags&1048576&&r.origin?ZWe(r.origin):Axe(r.types)}function Axe(r){return L_(r,(a,_)=>a+ZWe(_),0)}function n7t(r){let a=qn(r);if(!a.resolvedType){let _=$k(r),h=Cr(r.types,Wi),T=h.length===2?h.indexOf(P_):-1,C=T>=0?h[1-T]:Rt,I=!!(C.flags&76||C.flags&134217728&&K2(C));a.resolvedType=Da(h,I?1:0,_,$D(_))}return a.resolvedType}function e$e(r,a){let _=_h(4194304);return _.type=r,_.indexFlags=a,_}function i7t(r){let a=J2(4194304);return a.type=r,a}function t$e(r,a){return a&1?r.resolvedStringIndexType||(r.resolvedStringIndexType=e$e(r,1)):r.resolvedIndexType||(r.resolvedIndexType=e$e(r,0))}function r$e(r,a){let _=vg(r),h=dd(r),T=u1(r.target||r);if(!T&&!(a&2))return h;let C=[];if(Q2(h)){if(UD(r))return t$e(r,a);sC(h,V)}else if(UD(r)){let H=K_(QE(r));JEe(H,8576,!!(a&1),V)}else sC(dJ(h),V);let I=a&2?Fl(fi(C),H=>!(H.flags&5)):fi(C);if(I.flags&1048576&&h.flags&1048576&&gm(I.types)===gm(h.types))return h;return I;function V(H){let X=T?os(T,I7(r.mapper,_,H)):H;C.push(X===Ue?pi:X)}}function s7t(r){let a=vg(r);return _(u1(r)||a);function _(h){return h.flags&470810623?!0:h.flags&16777216?h.root.isDistributive&&h.checkType===a:h.flags&137363456?wi(h.types,_):h.flags&8388608?_(h.objectType)&&_(h.indexType):h.flags&33554432?_(h.baseType)&&_(h.constraint):h.flags&268435456?_(h.type):!1}}function d1(r){if(Zi(r))return Ar;if(Pf(r))return Q_(hs(r));if(za(r))return Q_(gh(r));let a=e2(r);return a!==void 0?Lf(Qi(a)):Ct(r)?Q_(hs(r)):Ar}function qk(r,a,_){if(_||!(xd(r)&6)){let h=as(Fte(r)).nameType;if(!h){let T=Ps(r.valueDeclaration);h=r.escapedName==="default"?Lf("default"):T&&d1(T)||(wR(r)?void 0:Lf(Qc(r)))}if(h&&h.flags&a)return h}return Ar}function n$e(r,a){return!!(r.flags&a||r.flags&2097152&&Pt(r.types,_=>n$e(_,a)))}function a7t(r,a,_){let h=_&&(Kn(r)&7||r.aliasSymbol)?i7t(r):void 0,T=Cr(bo(r),I=>qk(I,a)),C=Cr(X_(r),I=>I!==Tr&&n$e(I.keyType,a)?I.keyType===Ue&&a&8?pi:I.keyType:Ar);return fi(ps(T,C),1,void 0,void 0,h)}function kxe(r,a=0){return!!(r.flags&58982400||MS(r)||Yf(r)&&(!s7t(r)||Bte(r)===2)||r.flags&1048576&&!(a&4)&&GEe(r)||r.flags&2097152&&dl(r,465829888)&&Pt(r.types,ly))}function dh(r,a=0){return r=bg(r),zD(r)?cxe(dh(r.baseType,a)):kxe(r,a)?t$e(r,a):r.flags&1048576?Da(Cr(r.types,_=>dh(_,a))):r.flags&2097152?fi(Cr(r.types,_=>dh(_,a))):Kn(r)&32?r$e(r,a):r===ft?ft:r.flags&2?Ar:r.flags&131073?Er:a7t(r,(a&2?128:402653316)|(a&1?0:12584),a===0)}function i$e(r){let a=bMt();return a?qD(a,[r,Ue]):Ue}function o7t(r){let a=i$e(dh(r));return a.flags&131072?Ue:a}function c7t(r){let a=qn(r);if(!a.resolvedType)switch(r.operator){case 143:a.resolvedType=dh(Wi(r.type));break;case 158:a.resolvedType=r.type.kind===155?Lxe(AR(r.parent)):Oe;break;case 148:a.resolvedType=Wi(r.type);break;default:M.assertNever(r.operator)}return a.resolvedType}function l7t(r){let a=qn(r);return a.resolvedType||(a.resolvedType=Y2([r.head.text,...Cr(r.templateSpans,_=>_.literal.text)],Cr(r.templateSpans,_=>Wi(_.type)))),a.resolvedType}function Y2(r,a){let _=Bo(a,X=>!!(X.flags&1179648));if(_>=0)return CJ(a)?wc(a[_],X=>Y2(r,wW(a,_,X))):Oe;if(Es(a,ft))return ft;let h=[],T=[],C=r[0];if(!H(r,a))return Ue;if(h.length===0)return Lf(C);if(T.push(C),wi(T,X=>X==="")){if(wi(h,X=>!!(X.flags&4)))return Ue;if(h.length===1&&K2(h[0]))return h[0]}let I=`${gm(h)}|${Cr(T,X=>X.length).join(",")}|${T.join("")}`,V=An.get(I);return V||An.set(I,V=_7t(T,h)),V;function H(X,_e){for(let we=0;we<_e.length;we++){let Ne=_e[we];if(Ne.flags&101248)C+=u7t(Ne)||"",C+=X[we+1];else if(Ne.flags&134217728){if(C+=Ne.texts[0],!H(Ne.texts,Ne.types))return!1;C+=X[we+1]}else if(Q2(Ne)||AJ(Ne))h.push(Ne),T.push(C),C=X[we+1];else return!1}return!0}}function u7t(r){return r.flags&128?r.value:r.flags&256?""+r.value:r.flags&2048?uE(r.value):r.flags&98816?r.intrinsicName:void 0}function _7t(r,a){let _=_h(134217728);return _.texts=r,_.types=a,_}function zk(r,a){return a.flags&1179648?wc(a,_=>zk(r,_)):a.flags&128?Lf(s$e(r,a.value)):a.flags&134217728?Y2(...f7t(r,a.texts,a.types)):a.flags&268435456&&r===a.symbol?a:a.flags&268435461||Q2(a)?a$e(r,a):AJ(a)?a$e(r,Y2(["",""],[a])):a}function s$e(r,a){switch(gK.get(r.escapedName)){case 0:return a.toUpperCase();case 1:return a.toLowerCase();case 2:return a.charAt(0).toUpperCase()+a.slice(1);case 3:return a.charAt(0).toLowerCase()+a.slice(1)}return a}function f7t(r,a,_){switch(gK.get(r.escapedName)){case 0:return[a.map(h=>h.toUpperCase()),_.map(h=>zk(r,h))];case 1:return[a.map(h=>h.toLowerCase()),_.map(h=>zk(r,h))];case 2:return[a[0]===""?a:[a[0].charAt(0).toUpperCase()+a[0].slice(1),...a.slice(1)],a[0]===""?[zk(r,_[0]),..._.slice(1)]:_];case 3:return[a[0]===""?a:[a[0].charAt(0).toLowerCase()+a[0].slice(1),...a.slice(1)],a[0]===""?[zk(r,_[0]),..._.slice(1)]:_]}return[a,_]}function a$e(r,a){let _=`${Aa(r)},${Lu(a)}`,h=vi.get(_);return h||vi.set(_,h=p7t(r,a)),h}function p7t(r,a){let _=z0(268435456,r);return _.type=a,_}function d7t(r,a,_,h,T){let C=_h(8388608);return C.objectType=r,C.indexType=a,C.accessFlags=_,C.aliasSymbol=h,C.aliasTypeArguments=T,C}function D7(r){if(de)return!1;if(Kn(r)&4096)return!0;if(r.flags&1048576)return wi(r.types,D7);if(r.flags&2097152)return Pt(r.types,D7);if(r.flags&465829888){let a=WEe(r);return a!==r&&D7(a)}return!1}function Kte(r,a){return tm(r)?rm(r):a&&Ol(a)?e2(a):void 0}function Pxe(r,a){if(a.flags&8208){let _=Pr(r.parent,h=>!oc(h))||r.parent;return HT(_)?Ig(_)&&He(r)&&gHe(_,r):wi(a.declarations,h=>!Bs(h)||sh(h))}return!0}function o$e(r,a,_,h,T,C){let I=T&&T.kind===212?T:void 0,V=T&&Zi(T)?void 0:Kte(_,T);if(V!==void 0){if(C&256)return ET(a,V)||Me;let X=ma(a,V);if(X){if(C&64&&T&&X.declarations&&Md(X)&&Pxe(T,X)){let we=I?.argumentExpression??(mE(T)?T.indexType:T);L0(we,X.declarations,V)}if(I){if(oq(X,I,RGe(I.expression,a.symbol)),bYe(I,X,fb(I))){Qe(I.argumentExpression,v.Cannot_assign_to_0_because_it_is_a_read_only_property,rs(X));return}if(C&8&&(qn(T).resolvedSymbol=X),AGe(I,X))return tt}let _e=C&4?_T(X):gn(X);return I&&fb(I)!==1?iv(I,_e):T&&mE(T)&&U7(_e)?fi([_e,nr]):_e}if(Zf(a,Ha)&&Ry(V)){let _e=+V;if(T&&Zf(a,we=>!we.target.hasRestElement)&&!(C&16)){let we=Nxe(T);if(Ha(a)){if(_e<0)return Qe(we,v.A_tuple_type_cannot_be_indexed_with_a_negative_value),nr;Qe(we,v.Tuple_type_0_of_length_1_has_no_element_at_index_2,ln(a),f1(a),Qi(V))}else Qe(we,v.Property_0_does_not_exist_on_type_1,Qi(V),ln(a))}if(_e>=0)return H(Gy(a,Te)),K$e(a,_e,C&1?Ge:void 0)}}if(!(_.flags&98304)&&e_(_,402665900)){if(a.flags&131073)return a;let X=x7(a,_)||Gy(a,Ue);if(X){if(C&2&&X.keyType!==Te){I&&(C&4?Qe(I,v.Type_0_is_generic_and_can_only_be_indexed_for_reading,ln(r)):Qe(I,v.Type_0_cannot_be_used_to_index_type_1,ln(_),ln(r)));return}if(T&&X.keyType===Ue&&!e_(_,12)){let _e=Nxe(T);return Qe(_e,v.Type_0_cannot_be_used_as_an_index_type,ln(_)),C&1?fi([X.type,Ge]):X.type}return H(X),C&1&&!(a.symbol&&a.symbol.flags&384&&_.symbol&&_.flags&1024&&Qu(_.symbol)===a.symbol)?fi([X.type,Ge]):X.type}if(_.flags&131072)return Ar;if(D7(a))return Me;if(I&&!sne(a)){if(TT(a)){if(de&&_.flags&384)return _o.add(pn(I,v.Property_0_does_not_exist_on_type_1,_.value,ln(a))),nr;if(_.flags&12){let _e=Cr(a.properties,we=>gn(we));return fi(Bt(_e,nr))}}if(a.symbol===ct&&V!==void 0&&ct.exports.has(V)&&ct.exports.get(V).flags&418)Qe(I,v.Property_0_does_not_exist_on_type_1,Qi(V),ln(a));else if(de&&!(C&128))if(V!==void 0&&NGe(V,a)){let _e=ln(a);Qe(I,v.Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead,V,_e,_e+"["+Hc(I.argumentExpression)+"]")}else if(dT(a,Te))Qe(I.argumentExpression,v.Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number);else{let _e;if(V!==void 0&&(_e=IGe(V,a)))_e!==void 0&&Qe(I.argumentExpression,v.Property_0_does_not_exist_on_type_1_Did_you_mean_2,V,ln(a),_e);else{let we=g9t(a,I,_);if(we!==void 0)Qe(I,v.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1,ln(a),we);else{let Ne;if(_.flags&1024)Ne=js(void 0,v.Property_0_does_not_exist_on_type_1,"["+ln(_)+"]",ln(a));else if(_.flags&8192){let pt=uh(_.symbol,I);Ne=js(void 0,v.Property_0_does_not_exist_on_type_1,"["+pt+"]",ln(a))}else _.flags&128||_.flags&256?Ne=js(void 0,v.Property_0_does_not_exist_on_type_1,_.value,ln(a)):_.flags&12&&(Ne=js(void 0,v.No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1,ln(_),ln(a)));Ne=js(Ne,v.Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1,ln(h),ln(a)),_o.add(ky(Ur(I),I,Ne))}}}return}}if(D7(a))return Me;if(T){let X=Nxe(T);_.flags&384?Qe(X,v.Property_0_does_not_exist_on_type_1,""+_.value,ln(a)):_.flags&12?Qe(X,v.Type_0_has_no_matching_index_signature_for_type_1,ln(a),ln(_)):Qe(X,v.Type_0_cannot_be_used_as_an_index_type,ln(_))}if(Ao(_))return _;return;function H(X){X&&X.isReadonly&&I&&(kv(I)||NH(I))&&Qe(I,v.Index_signature_in_type_0_only_permits_reading,ln(a))}}function Nxe(r){return r.kind===212?r.argumentExpression:r.kind===199?r.indexType:r.kind===167?r.expression:r}function AJ(r){if(r.flags&2097152){let a=!1;for(let _ of r.types)if(_.flags&101248||AJ(_))a=!0;else if(!(_.flags&524288))return!1;return a}return!!(r.flags&77)||K2(r)}function K2(r){return!!(r.flags&134217728)&&wi(r.types,AJ)||!!(r.flags&268435456)&&AJ(r.type)}function c$e(r){return!!(r.flags&402653184)&&!K2(r)}function Wk(r){return!!w7(r)}function X2(r){return!!(w7(r)&4194304)}function Q2(r){return!!(w7(r)&8388608)}function w7(r){return r.flags&3145728?(r.objectFlags&2097152||(r.objectFlags|=2097152|L_(r.types,(a,_)=>a|w7(_),0)),r.objectFlags&12582912):r.flags&33554432?(r.objectFlags&2097152||(r.objectFlags|=2097152|w7(r.baseType)|w7(r.constraint)),r.objectFlags&12582912):(r.flags&58982400||Yf(r)||MS(r)?4194304:0)|(r.flags&63176704||c$e(r)?8388608:0)}function X0(r,a){return r.flags&8388608?g7t(r,a):r.flags&16777216?h7t(r,a):r}function l$e(r,a,_){if(r.flags&1048576||r.flags&2097152&&!kxe(r)){let h=Cr(r.types,T=>X0(Kf(T,a),_));return r.flags&2097152||_?Da(h):fi(h)}}function m7t(r,a,_){if(a.flags&1048576){let h=Cr(a.types,T=>X0(Kf(r,T),_));return _?Da(h):fi(h)}}function g7t(r,a){let _=a?"simplifiedForWriting":"simplifiedForReading";if(r[_])return r[_]===po?r:r[_];r[_]=po;let h=X0(r.objectType,a),T=X0(r.indexType,a),C=m7t(h,T,a);if(C)return r[_]=C;if(!(T.flags&465829888)){let I=l$e(h,T,a);if(I)return r[_]=I}if(MS(h)&&T.flags&296){let I=a4(h,T.flags&8?0:h.target.fixedLength,0,a);if(I)return r[_]=I}return Yf(h)&&Bte(h)!==2?r[_]=wc(Xte(h,r.indexType),I=>X0(I,a)):r[_]=r}function h7t(r,a){let _=r.checkType,h=r.extendsType,T=gT(r),C=hT(r);if(C.flags&131072&&IS(T)===IS(_)){if(_.flags&1||ga(eC(_),eC(h)))return X0(T,a);if(u$e(_,h))return Ar}else if(T.flags&131072&&IS(C)===IS(_)){if(!(_.flags&1)&&ga(eC(_),eC(h)))return Ar;if(_.flags&1||u$e(_,h))return X0(C,a)}return r}function u$e(r,a){return!!(fi([pJ(r,a),Ar]).flags&131072)}function Xte(r,a){let _=Xf([vg(r)],[a]),h=ax(r.mapper,_),T=os(K0(r.target||r),h),C=iWe(r)>0||(Wk(r)?Q6(QE(r))>0:y7t(r,a));return da(T,!0,C)}function y7t(r,a){let _=Zu(a);return!!_&&Pt(bo(r),h=>!!(h.flags&16777216)&&ga(qk(h,8576),_))}function Kf(r,a,_=0,h,T,C){return wS(r,a,_,h,T,C)||(h?Oe:Rt)}function _$e(r,a){return Zf(r,_=>{if(_.flags&384){let h=rm(_);if(Ry(h)){let T=+h;return T>=0&&T<a}}return!1})}function wS(r,a,_=0,h,T,C){if(r===ft||a===ft)return ft;if(r=bg(r),M$e(r)&&!(a.flags&98304)&&e_(a,12)&&(a=Ue),q.noUncheckedIndexedAccess&&_&32&&(_|=1),Q2(a)||(h&&h.kind!==199?MS(r)&&!_$e(a,Txe(r.target)):X2(r)&&!(Ha(r)&&_$e(a,Txe(r.target)))||GEe(r))){if(r.flags&3)return r;let V=_&1,H=r.id+","+a.id+","+V+Jk(T,C),X=Vr.get(H);return X||Vr.set(H,X=d7t(r,a,V,T,C)),X}let I=Z6(r);if(a.flags&1048576&&!(a.flags&16)){let V=[],H=!1;for(let X of a.types){let _e=o$e(r,I,X,a,h,_|(H?128:0));if(_e)V.push(_e);else if(h)H=!0;else return}return H?void 0:_&4?Da(V,0,T,C):fi(V,1,T,C)}return o$e(r,I,a,a,h,_|8|64)}function f$e(r){let a=qn(r);if(!a.resolvedType){let _=Wi(r.objectType),h=Wi(r.indexType),T=$k(r);a.resolvedType=Kf(_,h,0,r,T,$D(T))}return a.resolvedType}function Dxe(r){let a=qn(r);if(!a.resolvedType){let _=Lp(32,r.symbol);_.declaration=r,_.aliasSymbol=$k(r),_.aliasTypeArguments=$D(_.aliasSymbol),a.resolvedType=_,dd(_)}return a.resolvedType}function IS(r){return r.flags&33554432?IS(r.baseType):r.flags&8388608&&(r.objectType.flags&33554432||r.indexType.flags&33554432)?Kf(IS(r.objectType),IS(r.indexType)):r}function p$e(r){return FA(r)&&wt(r.elements)>0&&!Pt(r.elements,a=>wj(a)||Ij(a)||hN(a)&&!!(a.questionToken||a.dotDotDotToken))}function d$e(r,a){return Wk(r)||a&&Ha(r)&&Pt(rx(r),Wk)}function wxe(r,a,_,h,T){let C,I,V=0;for(;;){if(V===1e3)return Qe(R,v.Type_instantiation_is_excessively_deep_and_possibly_infinite),Oe;let X=os(IS(r.checkType),a),_e=os(r.extendsType,a);if(X===Oe||_e===Oe)return Oe;if(X===ft||_e===ft)return ft;let we=FI(r.node.checkType),Ne=FI(r.node.extendsType),pt=p$e(we)&&p$e(Ne)&&wt(we.elements)===wt(Ne.elements),Tt=d$e(X,pt),Mt;if(r.inferTypeParameters){let br=J7(r.inferTypeParameters,void 0,0);a&&(br.nonFixingMapper=ax(br.nonFixingMapper,a)),Tt||nv(br.inferences,X,_e,1536),Mt=a?ax(br.mapper,a):br.mapper}let mr=Mt?os(r.extendsType,Mt):_e;if(!Tt&&!d$e(mr,pt)){if(!(mr.flags&3)&&(X.flags&1||!ga(R7(X),R7(mr)))){(X.flags&1||_&&!(mr.flags&131072)&&ym(R7(mr),en=>ga(en,R7(X))))&&(I||(I=[])).push(os(Wi(r.node.trueType),Mt||a));let br=Wi(r.node.falseType);if(br.flags&16777216){let en=br.root;if(en.node.parent===r.node&&(!en.isDistributive||en.checkType===r.checkType)){r=en;continue}if(H(br,a))continue}C=os(br,a);break}if(mr.flags&3||ga(eC(X),eC(mr))){let br=Wi(r.node.trueType),en=Mt||a;if(H(br,en))continue;C=os(br,en);break}}C=_h(16777216),C.root=r,C.checkType=os(r.checkType,a),C.extendsType=os(r.extendsType,a),C.mapper=a,C.combinedMapper=Mt,C.aliasSymbol=h||r.aliasSymbol,C.aliasTypeArguments=h?T:Yy(r.aliasTypeArguments,a);break}return I?fi(Bt(I,C)):C;function H(X,_e){if(X.flags&16777216&&_e){let we=X.root;if(we.outerTypeParameters){let Ne=ax(X.mapper,_e),pt=Cr(we.outerTypeParameters,mr=>m1(mr,Ne)),Tt=Xf(we.outerTypeParameters,pt),Mt=we.isDistributive?m1(we.checkType,Tt):void 0;if(!Mt||Mt===we.checkType||!(Mt.flags&1179648))return r=we,a=Tt,h=void 0,T=void 0,we.aliasSymbol&&V++,!0}}return!1}}function gT(r){return r.resolvedTrueType||(r.resolvedTrueType=os(Wi(r.root.node.trueType),r.mapper))}function hT(r){return r.resolvedFalseType||(r.resolvedFalseType=os(Wi(r.root.node.falseType),r.mapper))}function v7t(r){return r.resolvedInferredTrueType||(r.resolvedInferredTrueType=r.combinedMapper?os(Wi(r.root.node.trueType),r.combinedMapper):gT(r))}function Ixe(r){let a;return r.locals&&r.locals.forEach(_=>{_.flags&262144&&(a=Bt(a,ac(_)))}),a}function S7t(r){return r.isDistributive&&(DJ(r.checkType,r.node.trueType)||DJ(r.checkType,r.node.falseType))}function b7t(r){let a=qn(r);if(!a.resolvedType){let _=Wi(r.checkType),h=$k(r),T=$D(h),C=jD(r,!0),I=T?C:Zn(C,H=>DJ(H,r)),V={node:r,checkType:_,extendsType:Wi(r.extendsType),isDistributive:!!(_.flags&262144),inferTypeParameters:Ixe(r),outerTypeParameters:I,instantiations:void 0,aliasSymbol:h,aliasTypeArguments:T};a.resolvedType=wxe(V,void 0,!1),I&&(V.instantiations=new Map,V.instantiations.set(gm(I),a.resolvedType))}return a.resolvedType}function T7t(r){let a=qn(r);return a.resolvedType||(a.resolvedType=XE(jn(r.typeParameter))),a.resolvedType}function m$e(r){return He(r)?[r]:Bt(m$e(r.left),r.right)}function g$e(r){var a;let _=qn(r);if(!_.resolvedType){if(!Ev(r))return Qe(r.argument,v.String_literal_expected),_.resolvedSymbol=St,_.resolvedType=Oe;let h=r.isTypeOf?111551:r.flags&16777216?900095:788968,T=G_(r,r.argument.literal);if(!T)return _.resolvedSymbol=St,_.resolvedType=Oe;let C=!!((a=T.exports)!=null&&a.get("export=")),I=Mf(T,!1);if($c(r.qualifier))if(I.flags&h)_.resolvedType=h$e(r,_,I,h);else{let V=h===111551?v.Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here:v.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0;Qe(r,V,r.argument.literal.text),_.resolvedSymbol=St,_.resolvedType=Oe}else{let V=m$e(r.qualifier),H=I,X;for(;X=V.shift();){let _e=V.length?1920:h,we=ro(pl(H)),Ne=r.isTypeOf||hn(r)&&C?ma(gn(we),X.escapedText,!1,!0):void 0,Tt=(r.isTypeOf?void 0:m_(Rp(we),X.escapedText,_e))??Ne;if(!Tt)return Qe(X,v.Namespace_0_has_no_exported_member_1,uh(H),Yo(X)),_.resolvedType=Oe;qn(X).resolvedSymbol=Tt,qn(X.parent).resolvedSymbol=Tt,H=Tt}_.resolvedType=h$e(r,_,H,h)}}return _.resolvedType}function h$e(r,a,_,h){let T=pl(_);return a.resolvedSymbol=T,h===111551?oYe(gn(_),r):$te(r,T)}function y$e(r){let a=qn(r);if(!a.resolvedType){let _=$k(r);if(kS(r.symbol).size===0&&!_)a.resolvedType=P_;else{let h=Lp(16,r.symbol);h.aliasSymbol=_,h.aliasTypeArguments=$D(_),f2(r)&&r.isArrayType&&(h=g_(h)),a.resolvedType=h}}return a.resolvedType}function $k(r){let a=r.parent;for(;a2(a)||Tb(a)||yb(a)&&a.operator===148;)a=a.parent;return TR(a)?jn(a):void 0}function $D(r){return r?l1(r):void 0}function Qte(r){return!!(r.flags&524288)&&!Yf(r)}function Oxe(r){return Z0(r)||!!(r.flags&474058748)}function Rxe(r,a){if(!(r.flags&1048576))return r;if(wi(r.types,Oxe))return Ln(r.types,Z0)||zi;let _=Ln(r.types,C=>!Oxe(C));if(!_||Ln(r.types,C=>C!==_&&!Oxe(C)))return r;return T(_);function T(C){let I=fa();for(let H of bo(C))if(!(xd(H)&6)){if(Zte(H)){let X=H.flags&65536&&!(H.flags&32768),we=Za(16777220,H.escapedName,VEe(H)|(a?8:0));we.links.type=X?nr:da(gn(H),!0),we.declarations=H.declarations,we.links.nameType=as(H).nameType,we.links.syntheticOrigin=H,I.set(H.escapedName,we)}}let V=Zt(C.symbol,I,ve,ve,X_(C));return V.objectFlags|=131200,V}}function nx(r,a,_,h,T){if(r.flags&1||a.flags&1)return Me;if(r.flags&2||a.flags&2)return Rt;if(r.flags&131072)return a;if(a.flags&131072)return r;if(r=Rxe(r,T),r.flags&1048576)return CJ([r,a])?wc(r,X=>nx(X,a,_,h,T)):Oe;if(a=Rxe(a,T),a.flags&1048576)return CJ([r,a])?wc(a,X=>nx(r,X,_,h,T)):Oe;if(a.flags&473960444)return r;if(X2(r)||X2(a)){if(Z0(r))return a;if(r.flags&2097152){let X=r.types,_e=X[X.length-1];if(Qte(_e)&&Qte(a))return Da(ps(X.slice(0,X.length-1),[nx(_e,a,_,h,T)]))}return Da([r,a])}let C=fa(),I=new Set,V=r===zi?X_(a):Zze([r,a]);for(let X of bo(a))xd(X)&6?I.add(X.escapedName):Zte(X)&&C.set(X.escapedName,Mxe(X,T));for(let X of bo(r))if(!(I.has(X.escapedName)||!Zte(X)))if(C.has(X.escapedName)){let _e=C.get(X.escapedName),we=gn(_e);if(_e.flags&16777216){let Ne=ps(X.declarations,_e.declarations),pt=4|X.flags&16777216,Tt=Za(pt,X.escapedName),Mt=gn(X),mr=Sre(Mt),br=Sre(we);Tt.links.type=mr===br?Mt:fi([Mt,br],2),Tt.links.leftSpread=X,Tt.links.rightSpread=_e,Tt.declarations=Ne,Tt.links.nameType=as(X).nameType,C.set(X.escapedName,Tt)}}else C.set(X.escapedName,Mxe(X,T));let H=Zt(_,C,ve,ve,Fs(V,X=>E7t(X,T)));return H.objectFlags|=2228352|h,H}function Zte(r){var a;return!Pt(r.declarations,j_)&&(!(r.flags&106496)||!((a=r.declarations)!=null&&a.some(_=>gi(_.parent))))}function Mxe(r,a){let _=r.flags&65536&&!(r.flags&32768);if(!_&&a===Cg(r))return r;let h=4|r.flags&16777216,T=Za(h,r.escapedName,VEe(r)|(a?8:0));return T.links.type=_?nr:gn(r),T.declarations=r.declarations,T.links.nameType=as(r).nameType,T.links.syntheticOrigin=r,T}function E7t(r,a){return r.isReadonly!==a?oy(r.keyType,r.type,a,r.declaration):r}function kJ(r,a,_,h){let T=z0(r,_);return T.value=a,T.regularType=h||T,T}function Hk(r){if(r.flags&2976){if(!r.freshType){let a=kJ(r.flags,r.value,r.symbol,r);a.freshType=a,r.freshType=a}return r.freshType}return r}function Q_(r){return r.flags&2976?r.regularType:r.flags&1048576?r.regularType||(r.regularType=wc(r,Q_)):r}function ix(r){return!!(r.flags&2976)&&r.freshType===r}function Lf(r){let a;return $r.get(r)||($r.set(r,a=kJ(128,r)),a)}function zm(r){let a;return Xs.get(r)||(Xs.set(r,a=kJ(256,r)),a)}function ere(r){let a,_=uE(r);return $e.get(_)||($e.set(_,a=kJ(2048,r)),a)}function x7t(r,a,_){let h,T=`${a}${typeof r=="string"?"@":"#"}${r}`,C=1024|(typeof r=="string"?128:256);return Yt.get(T)||(Yt.set(T,h=kJ(C,r,_)),h)}function C7t(r){if(r.literal.kind===106)return Ke;let a=qn(r);return a.resolvedType||(a.resolvedType=Q_(hs(r.literal))),a.resolvedType}function A7t(r){let a=z0(8192,r);return a.escapedName=`__@${a.symbol.escapedName}@${Aa(a.symbol)}`,a}function Lxe(r){if(hn(r)&&Tb(r)){let a=tE(r);a&&(r=cA(a)||a)}if(K_e(r)){let a=t9(r)?_d(r.left):_d(r);if(a){let _=as(a);return _.uniqueESSymbolType||(_.uniqueESSymbolType=A7t(a))}}return Hr}function k7t(r){let a=nf(r,!1,!1),_=a&&a.parent;if(_&&(gi(_)||_.kind===264)&&!oa(a)&&(!Vc(a)||rE(r,a.body)))return Al(jn(_)).thisType;if(_&&Ca(_)&&Pn(_.parent)&&cl(_.parent)===6)return Al(_d(_.parent.left).parent).thisType;let h=r.flags&16777216?ub(r):void 0;return h&&ic(h)&&Pn(h.parent)&&cl(h.parent)===3?Al(_d(h.parent.left).parent).thisType:vh(a)&&rE(r,a.body)?Al(jn(a)).thisType:(Qe(r,v.A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface),Oe)}function tre(r){let a=qn(r);return a.resolvedType||(a.resolvedType=k7t(r)),a.resolvedType}function v$e(r){return Wi(PJ(r.type)||r.type)}function PJ(r){switch(r.kind){case 196:return PJ(r.type);case 189:if(r.elements.length===1&&(r=r.elements[0],r.kind===191||r.kind===202&&r.dotDotDotToken))return PJ(r.type);break;case 188:return r.elementType}}function P7t(r){let a=qn(r);return a.resolvedType||(a.resolvedType=r.dotDotDotToken?v$e(r):da(Wi(r.type),!0,!!r.questionToken))}function Wi(r){return aMt(S$e(r),r)}function S$e(r){switch(r.kind){case 133:case 312:case 313:return Me;case 159:return Rt;case 154:return Ue;case 150:return Te;case 163:return Re;case 136:return qr;case 155:return Hr;case 116:return dn;case 157:return nr;case 106:return Ke;case 146:return Ar;case 151:return r.flags&524288&&!de?Me:Yn;case 141:return Ut;case 197:case 110:return tre(r);case 201:return C7t(r);case 183:return bJ(r);case 182:return r.assertsModifier?dn:qr;case 233:return bJ(r);case 186:return wWe(r);case 188:case 189:return LMt(r);case 190:return UMt(r);case 192:return YMt(r);case 193:return n7t(r);case 314:return oMt(r);case 316:return da(Wi(r.type));case 202:return P7t(r);case 196:case 315:case 309:return Wi(r.type);case 191:return v$e(r);case 318:return RVt(r);case 184:case 185:case 187:case 322:case 317:case 323:return y$e(r);case 198:return c7t(r);case 199:return f$e(r);case 200:return Dxe(r);case 194:return b7t(r);case 195:return T7t(r);case 203:return l7t(r);case 205:return g$e(r);case 80:case 166:case 211:let a=vm(r);return a?ac(a):Oe;default:return Oe}}function rre(r,a,_){if(r&&r.length)for(let h=0;h<r.length;h++){let T=r[h],C=_(T,a);if(T!==C){let I=h===0?[]:r.slice(0,h);for(I.push(C),h++;h<r.length;h++)I.push(_(r[h],a));return I}}return r}function Yy(r,a){return rre(r,a,os)}function nre(r,a){return rre(r,a,Gk)}function b$e(r,a){return rre(r,a,V7t)}function Xf(r,a){return r.length===1?sx(r[0],a?a[0]:Me):N7t(r,a)}function m1(r,a){switch(a.kind){case 0:return r===a.source?a.target:r;case 1:{let h=a.sources,T=a.targets;for(let C=0;C<h.length;C++)if(r===h[C])return T?T[C]:Me;return r}case 2:{let h=a.sources,T=a.targets;for(let C=0;C<h.length;C++)if(r===h[C])return T[C]();return r}case 3:return a.func(r);case 4:case 5:let _=m1(r,a.mapper1);return _!==r&&a.kind===4?os(_,a.mapper2):m1(_,a.mapper2)}}function sx(r,a){return M.attachDebugPrototypeIfDebug({kind:0,source:r,target:a})}function N7t(r,a){return M.attachDebugPrototypeIfDebug({kind:1,sources:r,targets:a})}function NJ(r,a){return M.attachDebugPrototypeIfDebug({kind:3,func:r,debugInfo:M.isDebugging?a:void 0})}function Fxe(r,a){return M.attachDebugPrototypeIfDebug({kind:2,sources:r,targets:a})}function ire(r,a,_){return M.attachDebugPrototypeIfDebug({kind:r,mapper1:a,mapper2:_})}function T$e(r){return Xf(r,void 0)}function D7t(r,a){let _=r.inferences.slice(a);return Xf(Cr(_,h=>h.typeParameter),Cr(_,()=>Rt))}function ax(r,a){return r?ire(4,r,a):a}function w7t(r,a){return r?ire(5,r,a):a}function Z2(r,a,_){return _?ire(5,sx(r,a),_):sx(r,a)}function I7(r,a,_){return r?ire(5,r,sx(a,_)):sx(a,_)}function I7t(r){return!r.constraint&&!zte(r)||r.constraint===Lo?r:r.restrictiveInstantiation||(r.restrictiveInstantiation=fd(r.symbol),r.restrictiveInstantiation.constraint=Lo,r.restrictiveInstantiation)}function jxe(r){let a=fd(r.symbol);return a.target=r,a}function O7t(r,a){return C7(r.kind,r.parameterName,r.parameterIndex,os(r.type,a))}function Gk(r,a,_){let h;if(r.typeParameters&&!_){h=Cr(r.typeParameters,jxe),a=ax(Xf(r.typeParameters,h),a);for(let C of h)C.mapper=a}let T=Hy(r.declaration,h,r.thisParameter&&Bxe(r.thisParameter,a),rre(r.parameters,a,Bxe),void 0,void 0,r.minArgumentCount,r.flags&167);return T.target=r,T.mapper=a,T}function Bxe(r,a){let _=as(r);if(_.type&&!FS(_.type)&&(!(r.flags&65536)||_.writeType&&!FS(_.writeType)))return r;ll(r)&1&&(r=_.target,a=ax(_.mapper,a));let h=Za(r.flags,r.escapedName,1|ll(r)&53256);return h.declarations=r.declarations,h.parent=r.parent,h.links.target=r,h.links.mapper=a,r.valueDeclaration&&(h.valueDeclaration=r.valueDeclaration),_.nameType&&(h.links.nameType=_.nameType),h}function R7t(r,a,_,h){let T=r.objectFlags&4||r.objectFlags&8388608?r.node:r.symbol.declarations[0],C=qn(T),I=r.objectFlags&4?C.resolvedType:r.objectFlags&64?r.target:r,V=r.objectFlags&134217728?r.outerTypeParameters:C.outerTypeParameters;if(!V){let H=jD(T,!0);if(vh(T)){let _e=gWe(T);H=wn(H,_e)}V=H||ve;let X=r.objectFlags&8388612?[T]:r.symbol.declarations;V=(I.objectFlags&8388612||I.symbol.flags&8192||I.symbol.flags&2048)&&!I.aliasTypeArguments?Zn(V,_e=>Pt(X,we=>DJ(_e,we))):V,C.outerTypeParameters=V}if(V.length){let H=ax(r.mapper,a),X=Cr(V,Tt=>m1(Tt,H)),_e=_||r.aliasSymbol,we=_?h:Yy(r.aliasTypeArguments,a),Ne=(r.objectFlags&134217728?"S":"")+gm(X)+Jk(_e,we);I.instantiations||(I.instantiations=new Map,I.instantiations.set(gm(V)+Jk(I.aliasSymbol,I.aliasTypeArguments),I));let pt=I.instantiations.get(Ne);if(!pt){if(r.objectFlags&134217728)return pt=sre(r,a),I.instantiations.set(Ne,pt),pt;let Tt=Xf(V,X);pt=I.objectFlags&4?oxe(r.target,r.node,Tt,_e,we):I.objectFlags&32?L7t(I,Tt,_e,we):sre(I,Tt,_e,we),I.instantiations.set(Ne,pt);let Mt=Kn(pt);if(pt.flags&3899393&&!(Mt&524288)){let mr=Pt(X,FS);Kn(pt)&524288||(Mt&52?pt.objectFlags|=524288|(mr?1048576:0):pt.objectFlags|=mr?0:524288)}}return pt}return r}function M7t(r){return!(r.parent.kind===183&&r.parent.typeArguments&&r===r.parent.typeName||r.parent.kind===205&&r.parent.typeArguments&&r===r.parent.qualifier)}function DJ(r,a){if(r.symbol&&r.symbol.declarations&&r.symbol.declarations.length===1){let h=r.symbol.declarations[0].parent;for(let T=a;T!==h;T=T.parent)if(!T||T.kind===241||T.kind===194&&Js(T.extendsType,_))return!0;return _(a)}return!0;function _(h){switch(h.kind){case 197:return!!r.isThisType;case 80:return!r.isThisType&&Lg(h)&&M7t(h)&&S$e(h)===r;case 186:let T=h.exprName,C=_p(T);if(!z1(C)){let I=gf(C),V=r.symbol.declarations[0],H=V.kind===168?V.parent:r.isThisType?V:void 0;if(I.declarations&&H)return Pt(I.declarations,X=>rE(X,H))||Pt(h.typeArguments,_)}return!0;case 174:case 173:return!h.type&&!!h.body||Pt(h.typeParameters,_)||Pt(h.parameters,_)||!!h.type&&_(h.type)}return!!Js(h,_)}}function O7(r){let a=dd(r);if(a.flags&4194304){let _=IS(a.type);if(_.flags&262144)return _}}function L7t(r,a,_,h){let T=O7(r);if(T){let I=os(T,a);if(T!==I)return kHe(bg(I),C,_,h)}return os(dd(r),a)===ft?ft:sre(r,a,_,h);function C(I){if(I.flags&61603843&&I!==ft&&!ao(I)){if(!r.declaration.nameType){let V;if(Jd(I)||I.flags&1&&RD(T,4)<0&&(V=mf(T))&&Zf(V,vT))return j7t(I,r,Z2(T,I,a));if(Ha(I))return F7t(I,r,T,a);if(uWe(I))return Da(Cr(I.types,C))}return sre(r,Z2(T,I,a))}return I}}function E$e(r,a){return a&1?!0:a&2?!1:r}function F7t(r,a,_,h){let T=r.target.elementFlags,C=r.target.fixedLength,I=C?Z2(_,r,h):h,V=Cr(rx(r),(we,Ne)=>{let pt=T[Ne];return Ne<C?x$e(a,Lf(""+Ne),!!(pt&2),I):pt&8?os(a,Z2(_,we,h)):BJ(os(a,Z2(_,g_(we),h)))??Rt}),H=sy(a),X=H&4?Cr(T,we=>we&1?2:we):H&8?Cr(T,we=>we&2?1:we):T,_e=E$e(r.target.readonly,sy(a));return Es(V,Oe)?Oe:cy(V,X,_e,r.target.labeledElementDeclarations)}function j7t(r,a,_){let h=x$e(a,Te,!0,_);return ao(h)?Oe:g_(h,E$e(i4(r),sy(a)))}function x$e(r,a,_,h){let T=I7(h,vg(r),a),C=os(K0(r.target||r),T),I=sy(r);return ce&&I&4&&!dl(C,49152)?LS(C,!0):ce&&I&8&&_?hm(C,524288):C}function sre(r,a,_,h){M.assert(r.symbol,"anonymous type must have symbol to be instantiated");let T=Lp(r.objectFlags&-1572865|64,r.symbol);if(r.objectFlags&32){T.declaration=r.declaration;let C=vg(r),I=jxe(C);T.typeParameter=I,a=ax(sx(C,I),a),I.mapper=a}return r.objectFlags&8388608&&(T.node=r.node),r.objectFlags&134217728&&(T.outerTypeParameters=r.outerTypeParameters),T.target=r,T.mapper=a,T.aliasSymbol=_||r.aliasSymbol,T.aliasTypeArguments=_?h:Yy(r.aliasTypeArguments,a),T.objectFlags|=T.aliasTypeArguments?SJ(T.aliasTypeArguments):0,T}function Uxe(r,a,_,h,T){let C=r.root;if(C.outerTypeParameters){let I=Cr(C.outerTypeParameters,X=>m1(X,a)),V=(_?"C":"")+gm(I)+Jk(h,T),H=C.instantiations.get(V);if(!H){let X=Xf(C.outerTypeParameters,I),_e=C.checkType,we=C.isDistributive?bg(m1(_e,X)):void 0;H=we&&_e!==we&&we.flags&1179648?kHe(we,Ne=>wxe(C,Z2(_e,Ne,X),_),h,T):wxe(C,X,_,h,T),C.instantiations.set(V,H)}return H}return r}function os(r,a){return r&&a?C$e(r,a,void 0,void 0):r}function C$e(r,a,_,h){var T;if(!FS(r))return r;if(D===100||x>=5e6)return(T=Cn)==null||T.instant(Cn.Phase.CheckTypes,"instantiateType_DepthLimit",{typeId:r.id,instantiationDepth:D,instantiationCount:x}),Qe(R,v.Type_instantiation_is_excessively_deep_and_possibly_infinite),Oe;E++,x++,D++;let C=B7t(r,a,_,h);return D--,C}function B7t(r,a,_,h){let T=r.flags;if(T&262144)return m1(r,a);if(T&524288){let C=r.objectFlags;if(C&52){if(C&4&&!r.node){let I=r.resolvedTypeArguments,V=Yy(I,a);return V!==I?Sxe(r.target,V):r}return C&1024?U7t(r,a):R7t(r,a,_,h)}return r}if(T&3145728){let C=r.flags&1048576?r.origin:void 0,I=C&&C.flags&3145728?C.types:r.types,V=Yy(I,a);if(V===I&&_===r.aliasSymbol)return r;let H=_||r.aliasSymbol,X=_?h:Yy(r.aliasTypeArguments,a);return T&2097152||C&&C.flags&2097152?Da(V,0,H,X):fi(V,1,H,X)}if(T&4194304)return dh(os(r.type,a));if(T&134217728)return Y2(r.texts,Yy(r.types,a));if(T&268435456)return zk(r.symbol,os(r.type,a));if(T&8388608){let C=_||r.aliasSymbol,I=_?h:Yy(r.aliasTypeArguments,a);return Kf(os(r.objectType,a),os(r.indexType,a),r.accessFlags,void 0,C,I)}if(T&16777216)return Uxe(r,ax(r.mapper,a),!1,_,h);if(T&33554432){let C=os(r.baseType,a);if(zD(r))return cxe(C);let I=os(r.constraint,a);return C.flags&8650752&&Wk(I)?uxe(C,I):I.flags&3||ga(eC(C),eC(I))?C:C.flags&8650752?uxe(C,I):Da([I,C])}return r}function U7t(r,a){let _=os(r.mappedType,a);if(!(Kn(_)&32))return r;let h=os(r.constraintType,a);if(!(h.flags&4194304))return r;let T=iHe(os(r.source,a),_,h);return T||r}function R7(r){return r.flags&402915327?r:r.permissiveInstantiation||(r.permissiveInstantiation=os(r,Mo))}function eC(r){return r.flags&402915327?r:(r.restrictiveInstantiation||(r.restrictiveInstantiation=os(r,uo),r.restrictiveInstantiation.restrictiveInstantiation=r.restrictiveInstantiation),r.restrictiveInstantiation)}function V7t(r,a){return oy(r.keyType,os(r.type,a),r.isReadonly,r.declaration)}function Ud(r){switch(M.assert(r.kind!==174||Nm(r)),r.kind){case 218:case 219:case 174:case 262:return A$e(r);case 210:return Pt(r.properties,Ud);case 209:return Pt(r.elements,Ud);case 227:return Ud(r.whenTrue)||Ud(r.whenFalse);case 226:return(r.operatorToken.kind===57||r.operatorToken.kind===61)&&(Ud(r.left)||Ud(r.right));case 303:return Ud(r.initializer);case 217:return Ud(r.expression);case 292:return Pt(r.properties,Ud)||Yg(r.parent)&&Pt(r.parent.parent.children,Ud);case 291:{let{initializer:a}=r;return!!a&&Ud(a)}case 294:{let{expression:a}=r;return!!a&&Ud(a)}}return!1}function A$e(r){return fj(r)||J7t(r)}function J7t(r){return r.typeParameters||lp(r)||!r.body?!1:r.body.kind!==241?Ud(r.body):!!xv(r.body,a=>!!a.expression&&Ud(a.expression))}function are(r){return(K1(r)||Nm(r))&&A$e(r)}function k$e(r){if(r.flags&524288){let a=Sg(r);if(a.constructSignatures.length||a.callSignatures.length){let _=Lp(16,r.symbol);return _.members=a.members,_.properties=a.properties,_.callSignatures=ve,_.constructSignatures=ve,_.indexInfos=ve,_}}else if(r.flags&2097152)return Da(Cr(r.types,k$e));return r}function Q0(r,a){return mh(r,a,Hf)}function M7(r,a){return mh(r,a,Hf)?-1:0}function Vxe(r,a){return mh(r,a,Rf)?-1:0}function q7t(r,a){return mh(r,a,ih)?-1:0}function OS(r,a){return mh(r,a,ih)}function wJ(r,a){return mh(r,a,Rd)}function ga(r,a){return mh(r,a,Rf)}function yT(r,a){return r.flags&1048576?wi(r.types,_=>yT(_,a)):a.flags&1048576?Pt(a.types,_=>yT(r,_)):r.flags&2097152?Pt(r.types,_=>yT(_,a)):r.flags&58982400?yT(Zu(r)||Rt,a):ly(a)?!!(r.flags&67633152):a===rl?!!(r.flags&67633152)&&!ly(r):a===$l?!!(r.flags&524288)&&b2e(r):FD(r,LD(a))||Jd(a)&&!i4(a)&&yT(r,Gr)}function ore(r,a){return mh(r,a,hp)}function IJ(r,a){return ore(r,a)||ore(a,r)}function I_(r,a,_,h,T,C){return Vd(r,a,Rf,_,h,T,C)}function RS(r,a,_,h,T,C){return Jxe(r,a,Rf,_,h,T,C,void 0)}function Jxe(r,a,_,h,T,C,I,V){return mh(r,a,_)?!0:!h||!L7(T,r,a,_,C,I,V)?Vd(r,a,_,h,C,I,V):!1}function P$e(r){return!!(r.flags&16777216||r.flags&2097152&&Pt(r.types,P$e))}function L7(r,a,_,h,T,C,I){if(!r||P$e(_))return!1;if(!Vd(a,_,h,void 0)&&z7t(r,a,_,h,T,C,I))return!0;switch(r.kind){case 234:if(!FG(r))break;case 294:case 217:return L7(r.expression,a,_,h,T,C,I);case 226:switch(r.operatorToken.kind){case 64:case 28:return L7(r.right,a,_,h,T,C,I)}break;case 210:return Q7t(r,a,_,h,C,I);case 209:return K7t(r,a,_,h,C,I);case 292:return Y7t(r,a,_,h,C,I);case 219:return W7t(r,a,_,h,C,I)}return!1}function z7t(r,a,_,h,T,C,I){let V=Ys(a,0),H=Ys(a,1);for(let X of[H,V])if(Pt(X,_e=>{let we=ko(_e);return!(we.flags&131073)&&Vd(we,_,h,void 0)})){let _e=I||{};I_(a,_,r,T,C,_e);let we=_e.errors[_e.errors.length-1];return ca(we,pn(r,X===H?v.Did_you_mean_to_use_new_with_this_expression:v.Did_you_mean_to_call_this_expression)),!0}return!1}function W7t(r,a,_,h,T,C){if(Vs(r.body)||Pt(r.parameters,F5))return!1;let I=lC(a);if(!I)return!1;let V=Ys(_,0);if(!wt(V))return!1;let H=r.body,X=ko(I),_e=fi(Cr(V,ko));if(!Vd(X,_e,h,void 0)){let we=H&&L7(H,X,_e,h,void 0,T,C);if(we)return we;let Ne=C||{};if(Vd(X,_e,h,H,void 0,T,Ne),Ne.errors)return _.symbol&&wt(_.symbol.declarations)&&ca(Ne.errors[Ne.errors.length-1],pn(_.symbol.declarations[0],v.The_expected_type_comes_from_the_return_type_of_this_signature)),!(Rl(r)&2)&&!il(X,"then")&&Vd(gq(X),_e,h,void 0)&&ca(Ne.errors[Ne.errors.length-1],pn(r,v.Did_you_mean_to_mark_this_function_as_async)),!0}return!1}function N$e(r,a,_){let h=wS(a,_);if(h)return h;if(a.flags&1048576){let T=j$e(r,a);if(T)return wS(T,_)}}function D$e(r,a){eq(r,a,!1);let _=d4(r,1);return H7(),_}function OJ(r,a,_,h,T,C){let I=!1;for(let V of r){let{errorNode:H,innerExpression:X,nameType:_e,errorMessage:we}=V,Ne=N$e(a,_,_e);if(!Ne||Ne.flags&8388608)continue;let pt=wS(a,_e);if(!pt)continue;let Tt=Kte(_e,void 0);if(!Vd(pt,Ne,h,void 0)){let Mt=X&&L7(X,pt,Ne,h,void 0,T,C);if(I=!0,!Mt){let mr=C||{},br=X?D$e(X,pt):pt;if(te&&lre(br,Ne)){let en=pn(H,v.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target,ln(br),ln(Ne));_o.add(en),mr.errors=[en]}else{let en=!!(Tt&&(ma(_,Tt)||St).flags&16777216),Fn=!!(Tt&&(ma(a,Tt)||St).flags&16777216);Ne=rv(Ne,en),pt=rv(pt,en&&Fn),Vd(br,Ne,h,H,we,T,mr)&&br!==pt&&Vd(pt,Ne,h,H,we,T,mr)}if(mr.errors){let en=mr.errors[mr.errors.length-1],Fn=tm(_e)?rm(_e):void 0,Dr=Fn!==void 0?ma(_,Fn):void 0,zr=!1;if(!Dr){let Qr=x7(_,_e);Qr&&Qr.declaration&&!Ur(Qr.declaration).hasNoDefaultLib&&(zr=!0,ca(en,pn(Qr.declaration,v.The_expected_type_comes_from_this_index_signature)))}if(!zr&&(Dr&&wt(Dr.declarations)||_.symbol&&wt(_.symbol.declarations))){let Qr=Dr&&wt(Dr.declarations)?Dr.declarations[0]:_.symbol.declarations[0];Ur(Qr).hasNoDefaultLib||ca(en,pn(Qr,v.The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1,Fn&&!(_e.flags&8192)?Qi(Fn):ln(_e),ln(_)))}}}}}return I}function $7t(r,a,_,h,T,C){let I=Fl(_,gre),V=Fl(_,_e=>!gre(_e)),H=V!==Ar?BCe(13,0,V,void 0):void 0,X=!1;for(let _e=r.next();!_e.done;_e=r.next()){let{errorNode:we,innerExpression:Ne,nameType:pt,errorMessage:Tt}=_e.value,Mt=H,mr=I!==Ar?N$e(a,I,pt):void 0;if(mr&&!(mr.flags&8388608)&&(Mt=H?fi([H,mr]):mr),!Mt)continue;let br=wS(a,pt);if(!br)continue;let en=Kte(pt,void 0);if(!Vd(br,Mt,h,void 0)){let Fn=Ne&&L7(Ne,br,Mt,h,void 0,T,C);if(X=!0,!Fn){let Dr=C||{},zr=Ne?D$e(Ne,br):br;if(te&&lre(zr,Mt)){let Qr=pn(we,v.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target,ln(zr),ln(Mt));_o.add(Qr),Dr.errors=[Qr]}else{let Qr=!!(en&&(ma(I,en)||St).flags&16777216),$n=!!(en&&(ma(a,en)||St).flags&16777216);Mt=rv(Mt,Qr),br=rv(br,Qr&&$n),Vd(zr,Mt,h,we,Tt,T,Dr)&&zr!==br&&Vd(br,Mt,h,we,Tt,T,Dr)}}}}return X}function*H7t(r){if(wt(r.properties))for(let a of r.properties)qA(a)||J2e(ZR(a.name))||(yield{errorNode:a.name,innerExpression:a.initializer,nameType:Lf(ZR(a.name))})}function*G7t(r,a){if(!wt(r.children))return;let _=0;for(let h=0;h<r.children.length;h++){let T=r.children[h],C=zm(h-_),I=w$e(T,C,a);I?yield I:_++}}function w$e(r,a,_){switch(r.kind){case 294:return{errorNode:r,innerExpression:r.expression,nameType:a};case 12:if(r.containsOnlyTriviaWhiteSpaces)break;return{errorNode:r,innerExpression:void 0,nameType:a,errorMessage:_()};case 284:case 285:case 288:return{errorNode:r,innerExpression:r,nameType:a};default:return M.assertNever(r,"Found invalid jsx child")}}function Y7t(r,a,_,h,T,C){let I=OJ(H7t(r),a,_,h,T,C),V;if(Yg(r.parent)&&Ly(r.parent.parent)){let X=r.parent.parent,_e=rq(oC(r)),we=_e===void 0?"children":Qi(_e),Ne=Lf(we),pt=Kf(_,Ne),Tt=rN(X.children);if(!wt(Tt))return I;let Mt=wt(Tt)>1,mr,br;if(gxe(!1)!==Fa){let Fn=JWe(Me);mr=Fl(pt,Dr=>ga(Dr,Fn)),br=Fl(pt,Dr=>!ga(Dr,Fn))}else mr=Fl(pt,gre),br=Fl(pt,Fn=>!gre(Fn));if(Mt){if(mr!==Ar){let Fn=cy(qre(X,0)),Dr=G7t(X,H);I=$7t(Dr,Fn,mr,h,T,C)||I}else if(!mh(Kf(a,Ne),pt,h)){I=!0;let Fn=Qe(X.openingElement.tagName,v.This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided,we,ln(pt));C&&C.skipLogging&&(C.errors||(C.errors=[])).push(Fn)}}else if(br!==Ar){let Fn=Tt[0],Dr=w$e(Fn,Ne,H);Dr&&(I=OJ(function*(){yield Dr}(),a,_,h,T,C)||I)}else if(!mh(Kf(a,Ne),pt,h)){I=!0;let Fn=Qe(X.openingElement.tagName,v.This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided,we,ln(pt));C&&C.skipLogging&&(C.errors||(C.errors=[])).push(Fn)}}return I;function H(){if(!V){let X=Hc(r.parent.tagName),_e=rq(oC(r)),we=_e===void 0?"children":Qi(_e),Ne=Kf(_,Lf(we)),pt=v._0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2;V={...pt,key:"!!ALREADY FORMATTED!!",message:vA(pt,X,we,ln(Ne))}}return V}}function*I$e(r,a){let _=wt(r.elements);if(_)for(let h=0;h<_;h++){if(s4(a)&&!ma(a,""+h))continue;let T=r.elements[h];if(pu(T))continue;let C=zm(h),I=Xre(T);yield{errorNode:I,innerExpression:I,nameType:C}}}function K7t(r,a,_,h,T,C){if(_.flags&402915324)return!1;if(s4(a))return OJ(I$e(r,_),a,_,h,T,C);eq(r,_,!1);let I=lGe(r,1,!0);return H7(),s4(I)?OJ(I$e(r,_),I,_,h,T,C):!1}function*X7t(r){if(wt(r.properties))for(let a of r.properties){if(Fy(a))continue;let _=qk(jn(a),8576);if(!(!_||_.flags&131072))switch(a.kind){case 178:case 177:case 174:case 304:yield{errorNode:a.name,innerExpression:void 0,nameType:_};break;case 303:yield{errorNode:a.name,innerExpression:a.initializer,nameType:_,errorMessage:Q3(a.name)?v.Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1:void 0};break;default:M.assertNever(a)}}}function Q7t(r,a,_,h,T,C){return _.flags&402915324?!1:OJ(X7t(r),a,_,h,T,C)}function O$e(r,a,_,h,T){return Vd(r,a,hp,_,h,T)}function Z7t(r,a,_){return qxe(r,a,_?4:0,!1,void 0,void 0,Vxe,void 0)!==0}function cre(r){if(!r.typeParameters&&(!r.thisParameter||Ao(pq(r.thisParameter)))&&r.parameters.length===1&&E_(r)){let a=pq(r.parameters[0]);return!!((Jd(a)?yc(a)[0]:a).flags&131073&&ko(r).flags&3)}return!1}function qxe(r,a,_,h,T,C,I,V){if(r===a||!(_&16&&cre(r))&&cre(a))return-1;if(_&16&&cre(r)&&!cre(a))return 0;let H=ep(a);if(!uy(a)&&(_&8?uy(r)||ep(r)>H:Sh(r)>H))return h&&!(_&8)&&T(v.Target_signature_provides_too_few_arguments_Expected_0_or_more_but_got_1,Sh(r),H),0;r.typeParameters&&r.typeParameters!==a.typeParameters&&(a=Q8t(a),r=VGe(r,a,void 0,I));let _e=ep(r),we=Q7(r),Ne=Q7(a);(we||Ne)&&os(we||Ne,V);let pt=a.declaration?a.declaration.kind:0,Tt=!(_&3)&&ne&&pt!==174&&pt!==173&&pt!==176,Mt=-1,mr=mT(r);if(mr&&mr!==dn){let Fn=mT(a);if(Fn){let Dr=!Tt&&I(mr,Fn,!1)||I(Fn,mr,h);if(!Dr)return h&&T(v.The_this_types_of_each_signature_are_incompatible),0;Mt&=Dr}}let br=we||Ne?Math.min(_e,H):Math.max(_e,H),en=we||Ne?br-1:-1;for(let Fn=0;Fn<br;Fn++){let Dr=Fn===en?_Ye(r,Fn):ux(r,Fn),zr=Fn===en?_Ye(a,Fn):ux(a,Fn);if(Dr&&zr&&(Dr!==zr||_&8)){let Qr=_&3||BGe(r,Fn)?void 0:lC(tv(Dr)),$n=_&3||BGe(a,Fn)?void 0:lC(tv(zr)),si=Qr&&$n&&!Bd(Qr)&&!Bd($n)&&GD(Dr,50331648)===GD(zr,50331648)?qxe($n,Qr,_&8|(Tt?2:1),h,T,C,I,V):!(_&3)&&!Tt&&I(Dr,zr,!1)||I(zr,Dr,h);if(si&&_&8&&Fn>=Sh(r)&&Fn<Sh(a)&&I(Dr,zr,!1)&&(si=0),!si)return h&&T(v.Types_of_parameters_0_and_1_are_incompatible,Qi(_4(r,Fn)),Qi(_4(a,Fn))),0;Mt&=si}}if(!(_&4)){let Fn=Ute(a)?Me:a.declaration&&vh(a.declaration)?Al(ro(a.declaration.symbol)):ko(a);if(Fn===dn||Fn===Me)return Mt;let Dr=Ute(r)?Me:r.declaration&&vh(r.declaration)?Al(ro(r.declaration.symbol)):ko(r),zr=Bd(a);if(zr){let Qr=Bd(r);if(Qr)Mt&=eLt(Qr,zr,h,T,I);else if(Q_e(zr)||Z_e(zr))return h&&T(v.Signature_0_must_be_a_type_predicate,TS(r)),0}else Mt&=_&1&&I(Fn,Dr,!1)||I(Dr,Fn,h),!Mt&&h&&C&&C(Dr,Fn)}return Mt}function eLt(r,a,_,h,T){if(r.kind!==a.kind)return _&&(h(v.A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard),h(v.Type_predicate_0_is_not_assignable_to_1,ty(r),ty(a))),0;if((r.kind===1||r.kind===3)&&r.parameterIndex!==a.parameterIndex)return _&&(h(v.Parameter_0_is_not_in_the_same_position_as_parameter_1,r.parameterName,a.parameterName),h(v.Type_predicate_0_is_not_assignable_to_1,ty(r),ty(a))),0;let C=r.type===a.type?-1:r.type&&a.type?T(r.type,a.type,_):0;return C===0&&_&&h(v.Type_predicate_0_is_not_assignable_to_1,ty(r),ty(a)),C}function tLt(r,a){let _=k7(r),h=k7(a),T=ko(_),C=ko(h);return C===dn||mh(C,T,Rf)||mh(T,C,Rf)?Z7t(_,h,!0):!1}function zxe(r){return r!==bc&&r.properties.length===0&&r.callSignatures.length===0&&r.constructSignatures.length===0&&r.indexInfos.length===0}function Z0(r){return r.flags&524288?!Yf(r)&&zxe(Sg(r)):r.flags&67108864?!0:r.flags&1048576?Pt(r.types,Z0):r.flags&2097152?wi(r.types,Z0):!1}function ly(r){return!!(Kn(r)&16&&(r.members&&zxe(r)||r.symbol&&r.symbol.flags&2048&&kS(r.symbol).size===0))}function rLt(r){if(ce&&r.flags&1048576){if(!(r.objectFlags&33554432)){let a=r.types;r.objectFlags|=33554432|(a.length>=3&&a[0].flags&32768&&a[1].flags&65536&&Pt(a,ly)?67108864:0)}return!!(r.objectFlags&67108864)}return!1}function HD(r){return!!((r.flags&1048576?r.types[0]:r).flags&32768)}function R$e(r){let a=r.flags&1048576?r.types[0]:r;return!!(a.flags&32768)&&a!==Ge}function M$e(r){return r.flags&524288&&!Yf(r)&&bo(r).length===0&&X_(r).length===1&&!!Gy(r,Ue)||r.flags&3145728&&wi(r.types,M$e)||!1}function Wxe(r,a,_){let h=r.flags&8?Qu(r):r,T=a.flags&8?Qu(a):a;if(h===T)return!0;if(h.escapedName!==T.escapedName||!(h.flags&256)||!(T.flags&256))return!1;let C=Aa(h)+","+Aa(T),I=Kv.get(C);if(I!==void 0&&!(!(I&4)&&I&2&&_))return!!(I&1);let V=gn(T);for(let H of bo(gn(h)))if(H.flags&8){let X=ma(V,H.escapedName);if(!X||!(X.flags&8))return _?(_(v.Property_0_is_missing_in_type_1,Qc(H),ln(ac(T),void 0,64)),Kv.set(C,6)):Kv.set(C,2),!1;let _e=fC(Pc(H,306)).value,we=fC(Pc(X,306)).value;if(_e!==we){let Ne=typeof _e=="string",pt=typeof we=="string";if(_e!==void 0&&we!==void 0){if(!_)Kv.set(C,2);else{let Tt=Ne?`"${Vh(_e)}"`:_e,Mt=pt?`"${Vh(we)}"`:we;_(v.Each_declaration_of_0_1_differs_in_its_value_where_2_was_expected_but_3_was_given,Qc(T),Qc(X),Mt,Tt),Kv.set(C,6)}return!1}if(Ne||pt){if(!_)Kv.set(C,2);else{let Tt=_e??we;M.assert(typeof Tt=="string");let Mt=`"${Vh(Tt)}"`;_(v.One_value_of_0_1_is_the_string_2_and_the_other_is_assumed_to_be_an_unknown_numeric_value,Qc(T),Qc(X),Mt),Kv.set(C,6)}return!1}}}return Kv.set(C,1),!0}function F7(r,a,_,h){let T=r.flags,C=a.flags;return C&1||T&131072||r===ft||C&2&&!(_===Rd&&T&1)?!0:C&131072?!1:!!(T&402653316&&C&4||T&128&&T&1024&&C&128&&!(C&1024)&&r.value===a.value||T&296&&C&8||T&256&&T&1024&&C&256&&!(C&1024)&&r.value===a.value||T&2112&&C&64||T&528&&C&16||T&12288&&C&4096||T&32&&C&32&&r.symbol.escapedName===a.symbol.escapedName&&Wxe(r.symbol,a.symbol,h)||T&1024&&C&1024&&(T&1048576&&C&1048576&&Wxe(r.symbol,a.symbol,h)||T&2944&&C&2944&&r.value===a.value&&Wxe(r.symbol,a.symbol,h))||T&32768&&(!ce&&!(C&3145728)||C&49152)||T&65536&&(!ce&&!(C&3145728)||C&65536)||T&524288&&C&67108864&&!(_===Rd&&ly(r)&&!(Kn(r)&8192))||(_===Rf||_===hp)&&(T&1||T&8&&(C&32||C&256&&C&1024)||T&256&&!(T&1024)&&(C&32||C&256&&C&1024&&r.value===a.value)||rLt(a)))}function mh(r,a,_){if(ix(r)&&(r=r.regularType),ix(a)&&(a=a.regularType),r===a)return!0;if(_!==Hf){if(_===hp&&!(a.flags&131072)&&F7(a,r,_)||F7(r,a,_))return!0}else if(!((r.flags|a.flags)&61865984)){if(r.flags!==a.flags)return!1;if(r.flags&67358815)return!0}if(r.flags&524288&&a.flags&524288){let h=_.get(fre(r,a,0,_,!1));if(h!==void 0)return!!(h&1)}return r.flags&469499904||a.flags&469499904?Vd(r,a,_,void 0):!1}function L$e(r,a){return Kn(r)&2048&&J2e(a.escapedName)}function RJ(r,a){for(;;){let _=ix(r)?r.regularType:MS(r)?sLt(r,a):Kn(r)&4?r.node?_1(r.target,yc(r)):Zxe(r)||r:r.flags&3145728?nLt(r,a):r.flags&33554432?a?r.baseType:_xe(r):r.flags&25165824?X0(r,a):r;if(_===r)return _;r=_}}function nLt(r,a){let _=bg(r);if(_!==r)return _;if(r.flags&2097152&&iLt(r)){let h=Fs(r.types,T=>RJ(T,a));if(h!==r.types)return Da(h)}return r}function iLt(r){let a=!1,_=!1;for(let h of r.types)if(a||(a=!!(h.flags&465829888)),_||(_=!!(h.flags&98304)||ly(h)),a&&_)return!0;return!1}function sLt(r,a){let _=rx(r),h=Fs(_,T=>T.flags&25165824?X0(T,a):T);return _!==h?bxe(r.target,h):r}function Vd(r,a,_,h,T,C,I){var V;let H,X,_e,we,Ne,pt,Tt=0,Mt=0,mr=0,br=0,en=!1,Fn=0,Dr=0,zr,Qr,$n=16e6-_.size>>3;M.assert(_!==Hf||!h,"no error reporting in identity checking");let ii=Dn(r,a,3,!!h,T);if(Qr&&no(),en){let Ze=fre(r,a,0,_,!1);_.set(Ze,6),(V=Cn)==null||V.instant(Cn.Phase.CheckTypes,"checkTypeRelatedTo_DepthLimit",{sourceId:r.id,targetId:a.id,depth:Mt,targetDepth:mr});let dt=$n<=0?v.Excessive_complexity_comparing_types_0_and_1:v.Excessive_stack_depth_comparing_types_0_and_1,Wt=Qe(h||R,dt,ln(r),ln(a));I&&(I.errors||(I.errors=[])).push(Wt)}else if(H){if(C){let Wt=C();Wt&&(ope(Wt,H),H=Wt)}let Ze;if(T&&h&&!ii&&r.symbol){let Wt=as(r.symbol);if(Wt.originatingImport&&!Np(Wt.originatingImport)&&Vd(gn(Wt.target),a,_,void 0)){let hr=pn(Wt.originatingImport,v.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead);Ze=Bt(Ze,hr)}}let dt=ky(Ur(h),h,H,Ze);X&&ca(dt,...X),I&&(I.errors||(I.errors=[])).push(dt),(!I||!I.skipLogging)&&_o.add(dt)}return h&&I&&I.skipLogging&&ii===0&&M.assert(!!I.errors,"missed opportunity to interact with error."),ii!==0;function si(Ze){H=Ze.errorInfo,zr=Ze.lastSkippedInfo,Qr=Ze.incompatibleStack,Fn=Ze.overrideNextErrorInfo,Dr=Ze.skipParentCounter,X=Ze.relatedInfo}function Ea(){return{errorInfo:H,lastSkippedInfo:zr,incompatibleStack:Qr?.slice(),overrideNextErrorInfo:Fn,skipParentCounter:Dr,relatedInfo:X?.slice()}}function Ks(Ze,...dt){Fn++,zr=void 0,(Qr||(Qr=[])).push([Ze,...dt])}function no(){let Ze=Qr||[];Qr=void 0;let dt=zr;if(zr=void 0,Ze.length===1){Os(...Ze[0]),dt&&sl(void 0,...dt);return}let Wt="",ut=[];for(;Ze.length;){let[hr,...cr]=Ze.pop();switch(hr.code){case v.Types_of_property_0_are_incompatible.code:{Wt.indexOf("new ")===0&&(Wt=`(${Wt})`);let Ft=""+cr[0];Wt.length===0?Wt=`${Ft}`:sp(Ft,Ka(q))?Wt=`${Wt}.${Ft}`:Ft[0]==="["&&Ft[Ft.length-1]==="]"?Wt=`${Wt}${Ft}`:Wt=`${Wt}[${Ft}]`;break}case v.Call_signature_return_types_0_and_1_are_incompatible.code:case v.Construct_signature_return_types_0_and_1_are_incompatible.code:case v.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code:case v.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code:{if(Wt.length===0){let Ft=hr;hr.code===v.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code?Ft=v.Call_signature_return_types_0_and_1_are_incompatible:hr.code===v.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code&&(Ft=v.Construct_signature_return_types_0_and_1_are_incompatible),ut.unshift([Ft,cr[0],cr[1]])}else{let Ft=hr.code===v.Construct_signature_return_types_0_and_1_are_incompatible.code||hr.code===v.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code?"new ":"",gr=hr.code===v.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code||hr.code===v.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code?"":"...";Wt=`${Ft}${Wt}(${gr})`}break}case v.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target.code:{ut.unshift([v.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target,cr[0],cr[1]]);break}case v.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target.code:{ut.unshift([v.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target,cr[0],cr[1],cr[2]]);break}default:return M.fail(`Unhandled Diagnostic: ${hr.code}`)}}Wt?Os(Wt[Wt.length-1]===")"?v.The_types_returned_by_0_are_incompatible_between_these_types:v.The_types_of_0_are_incompatible_between_these_types,Wt):ut.shift();for(let[hr,...cr]of ut){let Ft=hr.elidedInCompatabilityPyramid;hr.elidedInCompatabilityPyramid=!1,Os(hr,...cr),hr.elidedInCompatabilityPyramid=Ft}dt&&sl(void 0,...dt)}function Os(Ze,...dt){M.assert(!!h),Qr&&no(),!Ze.elidedInCompatabilityPyramid&&(Dr===0?H=js(H,Ze,...dt):Dr--)}function Rc(Ze,...dt){Os(Ze,...dt),Dr++}function r_(Ze){M.assert(!!H),X?X.push(Ze):X=[Ze]}function sl(Ze,dt,Wt){Qr&&no();let[ut,hr]=W6(dt,Wt),cr=dt,Ft=ut;if(j7(dt)&&!$xe(Wt)&&(cr=ev(dt),M.assert(!ga(cr,Wt),"generalized source shouldn't be assignable"),Ft=wD(cr)),(Wt.flags&8388608&&!(dt.flags&8388608)?Wt.objectType.flags:Wt.flags)&262144&&Wt!==qf&&Wt!==mc){let Yr=Zu(Wt),fr;Yr&&(ga(cr,Yr)||(fr=ga(dt,Yr)))?Os(v._0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2,fr?ut:Ft,hr,ln(Yr)):(H=void 0,Os(v._0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1,hr,Ft))}if(Ze)Ze===v.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1&&te&&F$e(dt,Wt).length&&(Ze=v.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties);else if(_===hp)Ze=v.Type_0_is_not_comparable_to_type_1;else if(ut===hr)Ze=v.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated;else if(te&&F$e(dt,Wt).length)Ze=v.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties;else{if(dt.flags&128&&Wt.flags&1048576){let Yr=h9t(dt,Wt);if(Yr){Os(v.Type_0_is_not_assignable_to_type_1_Did_you_mean_2,Ft,hr,ln(Yr));return}}Ze=v.Type_0_is_not_assignable_to_type_1}Os(Ze,Ft,hr)}function Jr(Ze,dt){let Wt=Rk(Ze.symbol)?ln(Ze,Ze.symbol.valueDeclaration):ln(Ze),ut=Rk(dt.symbol)?ln(dt,dt.symbol.valueDeclaration):ln(dt);(gs===Ze&&Ue===dt||Qa===Ze&&Te===dt||so===Ze&&qr===dt||FWe()===Ze&&Hr===dt)&&Os(v._0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible,ut,Wt)}function rn(Ze,dt,Wt){return Ha(Ze)?Ze.target.readonly&&jJ(dt)?(Wt&&Os(v.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1,ln(Ze),ln(dt)),!1):vT(dt):i4(Ze)&&jJ(dt)?(Wt&&Os(v.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1,ln(Ze),ln(dt)),!1):Ha(dt)?Jd(Ze):!0}function $i(Ze,dt,Wt){return Dn(Ze,dt,3,Wt)}function Dn(Ze,dt,Wt=3,ut=!1,hr,cr=0){if(Ze===dt)return-1;if(Ze.flags&524288&&dt.flags&402784252)return _===hp&&!(dt.flags&131072)&&F7(dt,Ze,_)||F7(Ze,dt,_,ut?Os:void 0)?-1:(ut&&is(Ze,dt,Ze,dt,hr),0);let Ft=RJ(Ze,!1),gr=RJ(dt,!0);if(Ft===gr)return-1;if(_===Hf)return Ft.flags!==gr.flags?0:Ft.flags&67358815?-1:(To(Ft,gr),b4(Ft,gr,!1,0,Wt));if(Ft.flags&262144&&W2(Ft)===gr)return-1;if(Ft.flags&470302716&&gr.flags&1048576){let Yr=gr.types,fr=Yr.length===2&&Yr[0].flags&98304?Yr[1]:Yr.length===3&&Yr[0].flags&98304&&Yr[1].flags&98304?Yr[2]:void 0;if(fr&&!(fr.flags&98304)&&(gr=RJ(fr,!0),Ft===gr))return-1}if(_===hp&&!(gr.flags&131072)&&F7(gr,Ft,_)||F7(Ft,gr,_,ut?Os:void 0))return-1;if(Ft.flags&469499904||gr.flags&469499904){if(!(cr&2)&&TT(Ft)&&Kn(Ft)&8192&&h_(Ft,gr,ut))return ut&&sl(hr,Ft,dt.aliasSymbol?dt:gr),0;let fr=(_!==hp||Tg(Ft))&&!(cr&2)&&Ft.flags&405405692&&Ft!==rl&&gr.flags&2621440&&Gxe(gr)&&(bo(Ft).length>0||Cne(Ft)),un=!!(Kn(Ft)&2048);if(fr&&!oLt(Ft,gr,un)){if(ut){let ui=ln(Ze.aliasSymbol?Ze:Ft),ti=ln(dt.aliasSymbol?dt:gr),ra=Ys(Ft,0),ya=Ys(Ft,1);ra.length>0&&Dn(ko(ra[0]),gr,1,!1)||ya.length>0&&Dn(ko(ya[0]),gr,1,!1)?Os(v.Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it,ui,ti):Os(v.Type_0_has_no_properties_in_common_with_type_1,ui,ti)}return 0}To(Ft,gr);let sn=Ft.flags&1048576&&Ft.types.length<4&&!(gr.flags&1048576)||gr.flags&1048576&&gr.types.length<4&&!(Ft.flags&469499904)?O_(Ft,gr,ut,cr):b4(Ft,gr,ut,cr,Wt);if(sn)return sn}return ut&&is(Ze,dt,Ft,gr,hr),0}function is(Ze,dt,Wt,ut,hr){var cr,Ft;let gr=!!Zxe(Ze),Yr=!!Zxe(dt);Wt=Ze.aliasSymbol||gr?Ze:Wt,ut=dt.aliasSymbol||Yr?dt:ut;let fr=Fn>0;if(fr&&Fn--,Wt.flags&524288&&ut.flags&524288){let un=H;rn(Wt,ut,!0),H!==un&&(fr=!!H)}if(Wt.flags&524288&&ut.flags&402784252)Jr(Wt,ut);else if(Wt.symbol&&Wt.flags&524288&&rl===Wt)Os(v.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);else if(Kn(Wt)&2048&&ut.flags&2097152){let un=ut.types,Gn=lx(Xp.IntrinsicAttributes,h),sn=lx(Xp.IntrinsicClassAttributes,h);if(!ao(Gn)&&!ao(sn)&&(Es(un,Gn)||Es(un,sn)))return}else H=YEe(H,dt);if(!hr&&fr){let un=Ea();sl(hr,Wt,ut);let Gn;H&&H!==un.errorInfo&&(Gn={code:H.code,messageText:H.messageText}),si(un),Gn&&H&&(H.canonicalHead=Gn),zr=[Wt,ut];return}if(sl(hr,Wt,ut),Wt.flags&262144&&((Ft=(cr=Wt.symbol)==null?void 0:cr.declarations)!=null&&Ft[0])&&!W2(Wt)){let un=jxe(Wt);if(un.constraint=os(ut,sx(Wt,un)),gJ(un)){let Gn=ln(ut,Wt.symbol.declarations[0]);r_(pn(Wt.symbol.declarations[0],v.This_type_parameter_might_need_an_extends_0_constraint,Gn))}}}function To(Ze,dt){if(Cn&&Ze.flags&3145728&&dt.flags&3145728){let Wt=Ze,ut=dt;if(Wt.objectFlags&ut.objectFlags&32768)return;let hr=Wt.types.length,cr=ut.types.length;hr*cr>1e6&&Cn.instant(Cn.Phase.CheckTypes,"traceUnionsOrIntersectionsTooLarge_DepthLimit",{sourceId:Ze.id,sourceSize:hr,targetId:dt.id,targetSize:cr,pos:h?.pos,end:h?.end})}}function go(Ze,dt){return fi(L_(Ze,(ut,hr)=>{var cr;hr=K_(hr);let Ft=hr.flags&3145728?hJ(hr,dt):ZE(hr,dt),gr=Ft&&gn(Ft)||((cr=Vk(hr,dt))==null?void 0:cr.type)||nr;return Bt(ut,gr)},void 0)||ve)}function h_(Ze,dt,Wt){var ut;if(!Y7(dt)||!de&&Kn(dt)&4096)return!1;let hr=!!(Kn(Ze)&2048);if((_===Rf||_===hp)&&(c4(rl,dt)||!hr&&Z0(dt)))return!1;let cr=dt,Ft;dt.flags&1048576&&(cr=cXe(Ze,dt,Dn)||Eqt(dt),Ft=cr.flags&1048576?cr.types:[cr]);for(let gr of bo(Ze))if(ha(gr,Ze.symbol)&&!L$e(Ze,gr)){if(!Wre(cr,gr.escapedName,hr)){if(Wt){let Yr=Fl(cr,Y7);if(!h)return M.fail();if(SE(h)||__(h)||__(h.parent)){gr.valueDeclaration&&Kg(gr.valueDeclaration)&&Ur(h)===Ur(gr.valueDeclaration.name)&&(h=gr.valueDeclaration.name);let fr=rs(gr),un=wGe(fr,Yr),Gn=un?rs(un):void 0;Gn?Os(v.Property_0_does_not_exist_on_type_1_Did_you_mean_2,fr,ln(Yr),Gn):Os(v.Property_0_does_not_exist_on_type_1,fr,ln(Yr))}else{let fr=((ut=Ze.symbol)==null?void 0:ut.declarations)&&xo(Ze.symbol.declarations),un;if(gr.valueDeclaration&&Pr(gr.valueDeclaration,Gn=>Gn===fr)&&Ur(fr)===Ur(h)){let Gn=gr.valueDeclaration;M.assertNode(Gn,p0);let sn=Gn.name;h=sn,He(sn)&&(un=IGe(sn,Yr))}un!==void 0?Rc(v.Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2,rs(gr),ln(Yr),un):Rc(v.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1,rs(gr),ln(Yr))}}return!0}if(Ft&&!Dn(gn(gr),go(Ft,gr.escapedName),3,Wt))return Wt&&Ks(v.Types_of_property_0_are_incompatible,rs(gr)),!0}return!1}function ha(Ze,dt){return Ze.valueDeclaration&&dt.valueDeclaration&&Ze.valueDeclaration.parent===dt.valueDeclaration}function O_(Ze,dt,Wt,ut){if(Ze.flags&1048576){if(dt.flags&1048576){let hr=Ze.origin;if(hr&&hr.flags&2097152&&dt.aliasSymbol&&Es(hr.types,dt))return-1;let cr=dt.origin;if(cr&&cr.flags&1048576&&Ze.aliasSymbol&&Es(cr.types,Ze))return-1}return _===hp?ml(Ze,dt,Wt&&!(Ze.flags&402784252),ut):av(Ze,dt,Wt&&!(Ze.flags&402784252),ut)}if(dt.flags&1048576)return Lc(V7(Ze),dt,Wt&&!(Ze.flags&402784252)&&!(dt.flags&402784252),ut);if(dt.flags&2097152)return gd(Ze,dt,Wt,2);if(_===hp&&dt.flags&402784252){let hr=Fs(Ze.types,cr=>cr.flags&465829888?Zu(cr)||Rt:cr);if(hr!==Ze.types){if(Ze=Da(hr),Ze.flags&131072)return 0;if(!(Ze.flags&2097152))return Dn(Ze,dt,1,!1)||Dn(dt,Ze,1,!1)}}return ml(Ze,dt,!1,1)}function Mc(Ze,dt){let Wt=-1,ut=Ze.types;for(let hr of ut){let cr=Lc(hr,dt,!1,0);if(!cr)return 0;Wt&=cr}return Wt}function Lc(Ze,dt,Wt,ut){let hr=dt.types;if(dt.flags&1048576){if(p1(hr,Ze))return-1;if(_!==hp&&Kn(dt)&32768&&!(Ze.flags&1024)&&(Ze.flags&2688||(_===ih||_===Rd)&&Ze.flags&256)){let Ft=Ze===Ze.regularType?Ze.freshType:Ze.regularType,gr=Ze.flags&128?Ue:Ze.flags&256?Te:Ze.flags&2048?Re:void 0;return gr&&p1(hr,gr)||Ft&&p1(hr,Ft)?-1:0}let cr=dHe(dt,Ze);if(cr){let Ft=Dn(Ze,cr,2,!1,void 0,ut);if(Ft)return Ft}}for(let cr of hr){let Ft=Dn(Ze,cr,2,!1,void 0,ut);if(Ft)return Ft}if(Wt){let cr=j$e(Ze,dt,Dn);cr&&Dn(Ze,cr,2,!0,void 0,ut)}return 0}function gd(Ze,dt,Wt,ut){let hr=-1,cr=dt.types;for(let Ft of cr){let gr=Dn(Ze,Ft,2,Wt,void 0,ut);if(!gr)return 0;hr&=gr}return hr}function ml(Ze,dt,Wt,ut){let hr=Ze.types;if(Ze.flags&1048576&&p1(hr,dt))return-1;let cr=hr.length;for(let Ft=0;Ft<cr;Ft++){let gr=Dn(hr[Ft],dt,1,Wt&&Ft===cr-1,void 0,ut);if(gr)return gr}return 0}function jl(Ze,dt){return Ze.flags&1048576&&dt.flags&1048576&&!(Ze.types[0].flags&32768)&&dt.types[0].flags&32768?l4(dt,-32769):dt}function av(Ze,dt,Wt,ut){let hr=-1,cr=Ze.types,Ft=jl(Ze,dt);for(let gr=0;gr<cr.length;gr++){let Yr=cr[gr];if(Ft.flags&1048576&&cr.length>=Ft.types.length&&cr.length%Ft.types.length===0){let un=Dn(Yr,Ft.types[gr%Ft.types.length],3,!1,void 0,ut);if(un){hr&=un;continue}}let fr=Dn(Yr,dt,1,Wt,void 0,ut);if(!fr)return 0;hr&=fr}return hr}function sw(Ze=ve,dt=ve,Wt=ve,ut,hr){if(Ze.length!==dt.length&&_===Hf)return 0;let cr=Ze.length<=dt.length?Ze.length:dt.length,Ft=-1;for(let gr=0;gr<cr;gr++){let Yr=gr<Wt.length?Wt[gr]:1,fr=Yr&7;if(fr!==4){let un=Ze[gr],Gn=dt[gr],sn=-1;if(Yr&8?sn=_===Hf?Dn(un,Gn,3,!1):M7(un,Gn):fr===1?sn=Dn(un,Gn,3,ut,void 0,hr):fr===2?sn=Dn(Gn,un,3,ut,void 0,hr):fr===3?(sn=Dn(Gn,un,3,!1),sn||(sn=Dn(un,Gn,3,ut,void 0,hr))):(sn=Dn(un,Gn,3,ut,void 0,hr),sn&&(sn&=Dn(Gn,un,3,ut,void 0,hr))),!sn)return 0;Ft&=sn}}return Ft}function b4(Ze,dt,Wt,ut,hr){var cr,Ft,gr;if(en)return 0;let Yr=fre(Ze,dt,ut,_,!1),fr=_.get(Yr);if(fr!==void 0&&!(Wt&&fr&2&&!(fr&4))){if(sa){let ya=fr&24;ya&8&&os(Ze,ts),ya&16&&os(Ze,Sc)}return fr&1?-1:0}if($n<=0)return en=!0,0;if(!_e)_e=[],we=new Set,Ne=[],pt=[];else{if(we.has(Yr))return 3;let ya=Yr.startsWith("*")?fre(Ze,dt,ut,_,!0):void 0;if(ya&&we.has(ya))return 3;if(Mt===100||mr===100)return en=!0,0}let un=Tt;_e[Tt]=Yr,we.add(Yr),Tt++;let Gn=br;hr&1&&(Ne[Mt]=Ze,Mt++,!(br&1)&&Kk(Ze,Ne,Mt)&&(br|=1)),hr&2&&(pt[mr]=dt,mr++,!(br&2)&&Kk(dt,pt,mr)&&(br|=2));let sn,ui=0;sa&&(sn=sa,sa=ya=>(ui|=ya?16:8,sn(ya)));let ti;return br===3?((cr=Cn)==null||cr.instant(Cn.Phase.CheckTypes,"recursiveTypeRelatedTo_DepthLimit",{sourceId:Ze.id,sourceIdStack:Ne.map(ya=>ya.id),targetId:dt.id,targetIdStack:pt.map(ya=>ya.id),depth:Mt,targetDepth:mr}),ti=3):((Ft=Cn)==null||Ft.push(Cn.Phase.CheckTypes,"structuredTypeRelatedTo",{sourceId:Ze.id,targetId:dt.id}),ti=fL(Ze,dt,Wt,ut),(gr=Cn)==null||gr.pop()),sa&&(sa=sn),hr&1&&Mt--,hr&2&&mr--,br=Gn,ti?(ti===-1||Mt===0&&mr===0)&&ra(ti===-1||ti===3):(_.set(Yr,(Wt?4:0)|2|ui),$n--,ra(!1)),ti;function ra(ya){for(let uc=un;uc<Tt;uc++)we.delete(_e[uc]),ya&&(_.set(_e[uc],1|ui),$n--);Tt=un}}function fL(Ze,dt,Wt,ut){let hr=Ea(),cr=Oq(Ze,dt,Wt,ut,hr);if(_!==Hf){if(!cr&&(Ze.flags&2097152||Ze.flags&262144&&dt.flags&1048576)){let Ft=M8t(Ze.flags&2097152?Ze.types:[Ze],!!(dt.flags&1048576));Ft&&Zf(Ft,gr=>gr!==Ze)&&(cr=Dn(Ft,dt,1,!1,void 0,ut))}cr&&!(ut&2)&&dt.flags&2097152&&!X2(dt)&&Ze.flags&2621440?(cr&=ka(Ze,dt,Wt,void 0,!1,0),cr&&TT(Ze)&&Kn(Ze)&8192&&(cr&=cs(Ze,dt,!1,Wt,0))):cr&&Qte(dt)&&!vT(dt)&&Ze.flags&2097152&&K_(Ze).flags&3670016&&!Pt(Ze.types,Ft=>Ft===dt||!!(Kn(Ft)&262144))&&(cr&=ka(Ze,dt,Wt,void 0,!0,ut))}return cr&&si(hr),cr}function y_(Ze,dt){let Wt=K_(QE(dt)),ut=[];return JEe(Wt,8576,!1,hr=>void ut.push(os(Ze,I7(dt.mapper,vg(dt),hr)))),fi(ut)}function Oq(Ze,dt,Wt,ut,hr){let cr,Ft,gr=!1,Yr=Ze.flags,fr=dt.flags;if(_===Hf){if(Yr&3145728){let sn=Mc(Ze,dt);return sn&&(sn&=Mc(dt,Ze)),sn}if(Yr&4194304)return Dn(Ze.type,dt.type,3,!1);if(Yr&8388608&&(cr=Dn(Ze.objectType,dt.objectType,3,!1))&&(cr&=Dn(Ze.indexType,dt.indexType,3,!1))||Yr&16777216&&Ze.root.isDistributive===dt.root.isDistributive&&(cr=Dn(Ze.checkType,dt.checkType,3,!1))&&(cr&=Dn(Ze.extendsType,dt.extendsType,3,!1))&&(cr&=Dn(gT(Ze),gT(dt),3,!1))&&(cr&=Dn(hT(Ze),hT(dt),3,!1))||Yr&33554432&&(cr=Dn(Ze.baseType,dt.baseType,3,!1))&&(cr&=Dn(Ze.constraint,dt.constraint,3,!1)))return cr;if(!(Yr&524288))return 0}else if(Yr&3145728||fr&3145728){if(cr=O_(Ze,dt,Wt,ut))return cr;if(!(Yr&465829888||Yr&524288&&fr&1048576||Yr&2097152&&fr&467402752))return 0}if(Yr&17301504&&Ze.aliasSymbol&&Ze.aliasTypeArguments&&Ze.aliasSymbol===dt.aliasSymbol&&!(ure(Ze)||ure(dt))){let sn=B$e(Ze.aliasSymbol);if(sn===ve)return 1;let ui=as(Ze.aliasSymbol).typeParameters,ti=ph(ui),ra=NS(Ze.aliasTypeArguments,ui,ti,hn(Ze.aliasSymbol.valueDeclaration)),ya=NS(dt.aliasTypeArguments,ui,ti,hn(Ze.aliasSymbol.valueDeclaration)),uc=Gn(ra,ya,sn,ut);if(uc!==void 0)return uc}if(Y$e(Ze)&&!Ze.target.readonly&&(cr=Dn(yc(Ze)[0],dt,1))||Y$e(dt)&&(dt.target.readonly||jJ(Zu(Ze)||Ze))&&(cr=Dn(Ze,yc(dt)[0],2)))return cr;if(fr&262144){if(Kn(Ze)&32&&!Ze.declaration.nameType&&Dn(dh(dt),dd(Ze),3)&&!(sy(Ze)&4)){let sn=K0(Ze),ui=Kf(dt,vg(Ze));if(cr=Dn(sn,ui,3,Wt))return cr}if(_===hp&&Yr&262144){let sn=mf(Ze);if(sn)for(;sn&&ym(sn,ui=>!!(ui.flags&262144));){if(cr=Dn(sn,dt,1,!1))return cr;sn=mf(sn)}return 0}}else if(fr&4194304){let sn=dt.type;if(Yr&4194304&&(cr=Dn(sn,Ze.type,3,!1)))return cr;if(Ha(sn)){if(cr=Dn(Ze,$We(sn),2,Wt))return cr}else{let ui=qEe(sn);if(ui){if(Dn(Ze,dh(ui,dt.indexFlags|4),2,Wt)===-1)return-1}else if(Yf(sn)){let ti=u1(sn),ra=dd(sn),ya;if(ti&&UD(sn)){let uc=y_(ti,sn);ya=fi([uc,ti])}else ya=ti||ra;if(Dn(Ze,ya,2,Wt)===-1)return-1}}}else if(fr&8388608){if(Yr&8388608){if((cr=Dn(Ze.objectType,dt.objectType,3,Wt))&&(cr&=Dn(Ze.indexType,dt.indexType,3,Wt)),cr)return cr;Wt&&(Ft=H)}if(_===Rf||_===hp){let sn=dt.objectType,ui=dt.indexType,ti=Zu(sn)||sn,ra=Zu(ui)||ui;if(!X2(ti)&&!Q2(ra)){let ya=4|(ti!==sn?2:0),uc=wS(ti,ra,ya);if(uc){if(Wt&&Ft&&si(hr),cr=Dn(Ze,uc,2,Wt,void 0,ut))return cr;Wt&&Ft&&H&&(H=un([Ft])<=un([H])?Ft:H)}}}Wt&&(Ft=void 0)}else if(Yf(dt)&&_!==Hf){let sn=!!dt.declaration.nameType,ui=K0(dt),ti=sy(dt);if(!(ti&8)){if(!sn&&ui.flags&8388608&&ui.objectType===Ze&&ui.indexType===vg(dt))return-1;if(!Yf(Ze)){let ra=sn?u1(dt):dd(dt),ya=dh(Ze,2),uc=ti&4,yf=uc?pJ(ra,ya):void 0;if(uc?!(yf.flags&131072):Dn(ra,ya,3)){let Tp=K0(dt),US=vg(dt),CT=l4(Tp,-98305);if(!sn&&CT.flags&8388608&&CT.indexType===US){if(cr=Dn(Ze,CT.objectType,2,Wt))return cr}else{let dx=sn?yf||ra:yf?Da([yf,US]):US,bh=Kf(Ze,dx);if(cr=Dn(bh,Tp,3,Wt))return cr}}Ft=H,si(hr)}}}else if(fr&16777216){if(Kk(dt,pt,mr,10))return 3;let sn=dt;if(!sn.root.inferTypeParameters&&!S7t(sn.root)&&!(Ze.flags&16777216&&Ze.root===sn.root)){let ui=!ga(R7(sn.checkType),R7(sn.extendsType)),ti=!ui&&ga(eC(sn.checkType),eC(sn.extendsType));if((cr=ui?-1:Dn(Ze,gT(sn),2,!1,void 0,ut))&&(cr&=ti?-1:Dn(Ze,hT(sn),2,!1,void 0,ut),cr))return cr}}else if(fr&134217728){if(Yr&134217728){if(_===hp)return HLt(Ze,dt)?0:-1;os(Ze,Sc)}if(kre(Ze,dt))return-1}else if(dt.flags&268435456&&!(Ze.flags&268435456)&&Are(Ze,dt))return-1;if(Yr&8650752){if(!(Yr&8388608&&fr&8388608)){let sn=W2(Ze)||Rt;if(cr=Dn(sn,dt,1,!1,void 0,ut))return cr;if(cr=Dn(bp(sn,Ze),dt,1,Wt&&sn!==Rt&&!(fr&Yr&262144),void 0,ut))return cr;if(HEe(Ze)){let ui=W2(Ze.indexType);if(ui&&(cr=Dn(Kf(Ze.objectType,ui),dt,1,Wt)))return cr}}}else if(Yr&4194304){let sn=kxe(Ze.type,Ze.indexFlags)&&Kn(Ze.type)&32;if(cr=Dn(Er,dt,1,Wt&&!sn))return cr;if(sn){let ui=Ze.type,ti=u1(ui),ra=ti&&UD(ui)?y_(ti,ui):ti||dd(ui);if(cr=Dn(ra,dt,1,Wt))return cr}}else if(Yr&134217728&&!(fr&524288)){if(!(fr&134217728)){let sn=Zu(Ze);if(sn&&sn!==Ze&&(cr=Dn(sn,dt,1,Wt)))return cr}}else if(Yr&268435456)if(fr&268435456){if(Ze.symbol!==dt.symbol)return 0;if(cr=Dn(Ze.type,dt.type,3,Wt))return cr}else{let sn=Zu(Ze);if(sn&&(cr=Dn(sn,dt,1,Wt)))return cr}else if(Yr&16777216){if(Kk(Ze,Ne,Mt,10))return 3;if(fr&16777216){let ti=Ze.root.inferTypeParameters,ra=Ze.extendsType,ya;if(ti){let uc=J7(ti,void 0,0,$i);nv(uc.inferences,dt.extendsType,ra,1536),ra=os(ra,uc.mapper),ya=uc.mapper}if(Q0(ra,dt.extendsType)&&(Dn(Ze.checkType,dt.checkType,3)||Dn(dt.checkType,Ze.checkType,3))&&((cr=Dn(os(gT(Ze),ya),gT(dt),3,Wt))&&(cr&=Dn(hT(Ze),hT(dt),3,Wt)),cr))return cr}let sn=zEe(Ze);if(sn&&(cr=Dn(sn,dt,1,Wt)))return cr;let ui=!(fr&16777216)&&gJ(Ze)?sWe(Ze):void 0;if(ui&&(si(hr),cr=Dn(ui,dt,1,Wt)))return cr}else{if(_!==ih&&_!==Rd&&P8t(dt)&&Z0(Ze))return-1;if(Yf(dt))return Yf(Ze)&&(cr=zt(Ze,dt,Wt))?cr:0;let sn=!!(Yr&402784252);if(_!==Hf)Ze=K_(Ze),Yr=Ze.flags;else if(Yf(Ze))return 0;if(Kn(Ze)&4&&Kn(dt)&4&&Ze.target===dt.target&&!Ha(Ze)&&!(ure(Ze)||ure(dt))){if(mre(Ze))return-1;let ui=Yxe(Ze.target);if(ui===ve)return 1;let ti=Gn(yc(Ze),yc(dt),ui,ut);if(ti!==void 0)return ti}else{if(i4(dt)?Zf(Ze,vT):Jd(dt)&&Zf(Ze,ui=>Ha(ui)&&!ui.target.readonly))return _!==Hf?Dn(dT(Ze,Te)||Me,dT(dt,Te)||Me,3,Wt):0;if(MS(Ze)&&Ha(dt)&&!MS(dt)){let ui=ay(Ze);if(ui!==Ze)return Dn(ui,dt,1,Wt)}else if((_===ih||_===Rd)&&Z0(dt)&&Kn(dt)&8192&&!Z0(Ze))return 0}if(Yr&2621440&&fr&524288){let ui=Wt&&H===hr.errorInfo&&!sn;if(cr=ka(Ze,dt,ui,void 0,!1,ut),cr&&(cr&=je(Ze,dt,0,ui,ut),cr&&(cr&=je(Ze,dt,1,ui,ut),cr&&(cr&=cs(Ze,dt,sn,ui,ut)))),gr&&cr)H=Ft||H||hr.errorInfo;else if(cr)return cr}if(Yr&2621440&&fr&1048576){let ui=l4(dt,36175872);if(ui.flags&1048576){let ti=Nr(Ze,ui);if(ti)return ti}}}return 0;function un(sn){return sn?L_(sn,(ui,ti)=>ui+1+un(ti.next),0):0}function Gn(sn,ui,ti,ra){if(cr=sw(sn,ui,ti,Wt,ra))return cr;if(Pt(ti,uc=>!!(uc&24))){Ft=void 0,si(hr);return}let ya=ui&&cLt(ui,ti);if(gr=!ya,ti!==ve&&!ya){if(gr&&!(Wt&&Pt(ti,uc=>(uc&7)===0)))return 0;Ft=H,si(hr)}}}function zt(Ze,dt,Wt){if(_===hp||(_===Hf?sy(Ze)===sy(dt):Q6(Ze)<=Q6(dt))){let hr,cr=dd(dt),Ft=os(dd(Ze),Q6(Ze)<0?ts:Sc);if(hr=Dn(cr,Ft,3,Wt)){let gr=Xf([vg(Ze)],[vg(dt)]);if(os(u1(Ze),gr)===os(u1(dt),gr))return hr&Dn(os(K0(Ze),gr),K0(dt),3,Wt)}}return 0}function Nr(Ze,dt){var Wt;let ut=bo(Ze),hr=pHe(ut,dt);if(!hr)return 0;let cr=1;for(let Gn of hr)if(cr*=TFt(CS(Gn)),cr>25)return(Wt=Cn)==null||Wt.instant(Cn.Phase.CheckTypes,"typeRelatedToDiscriminatedType_DepthLimit",{sourceId:Ze.id,targetId:dt.id,numCombinations:cr}),0;let Ft=new Array(hr.length),gr=new Set;for(let Gn=0;Gn<hr.length;Gn++){let sn=hr[Gn],ui=CS(sn);Ft[Gn]=ui.flags&1048576?ui.types:[ui],gr.add(sn.escapedName)}let Yr=Zce(Ft),fr=[];for(let Gn of Yr){let sn=!1;e:for(let ui of dt.types){for(let ti=0;ti<hr.length;ti++){let ra=hr[ti],ya=ma(ui,ra.escapedName);if(!ya)continue e;if(ra===ya)continue;if(!Bn(Ze,dt,ra,ya,yf=>Gn[ti],!1,0,ce||_===hp))continue e}ol(fr,ui,gv),sn=!0}if(!sn)return 0}let un=-1;for(let Gn of fr)if(un&=ka(Ze,Gn,!1,gr,!1,0),un&&(un&=je(Ze,Gn,0,!1,0),un&&(un&=je(Ze,Gn,1,!1,0),un&&!(Ha(Ze)&&Ha(Gn))&&(un&=cs(Ze,Gn,!1,!1,0)))),!un)return un;return un}function Wr(Ze,dt){if(!dt||Ze.length===0)return Ze;let Wt;for(let ut=0;ut<Ze.length;ut++)dt.has(Ze[ut].escapedName)?Wt||(Wt=Ze.slice(0,ut)):Wt&&Wt.push(Ze[ut]);return Wt||Ze}function on(Ze,dt,Wt,ut,hr){let cr=ce&&!!(ll(dt)&48),Ft=da(CS(dt),!1,cr),gr=Wt(Ze);return Dn(gr,Ft,3,ut,void 0,hr)}function Bn(Ze,dt,Wt,ut,hr,cr,Ft,gr){let Yr=xd(Wt),fr=xd(ut);if(Yr&2||fr&2){if(Wt.valueDeclaration!==ut.valueDeclaration)return cr&&(Yr&2&&fr&2?Os(v.Types_have_separate_declarations_of_a_private_property_0,rs(ut)):Os(v.Property_0_is_private_in_type_1_but_not_in_type_2,rs(ut),ln(Yr&2?Ze:dt),ln(Yr&2?dt:Ze))),0}else if(fr&4){if(!pLt(Wt,ut))return cr&&Os(v.Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2,rs(ut),ln(Yk(Wt)||Ze),ln(Yk(ut)||dt)),0}else if(Yr&4)return cr&&Os(v.Property_0_is_protected_in_type_1_but_public_in_type_2,rs(ut),ln(Ze),ln(dt)),0;if(_===Rd&&Cg(Wt)&&!Cg(ut))return 0;let un=on(Wt,ut,hr,cr,Ft);return un?!gr&&Wt.flags&16777216&&ut.flags&106500&&!(ut.flags&16777216)?(cr&&Os(v.Property_0_is_optional_in_type_1_but_required_in_type_2,rs(ut),ln(Ze),ln(dt)),0):un:(cr&&Ks(v.Types_of_property_0_are_incompatible,rs(ut)),0)}function hi(Ze,dt,Wt,ut){let hr=!1;if(Wt.valueDeclaration&&Wu(Wt.valueDeclaration)&&Zi(Wt.valueDeclaration.name)&&Ze.symbol&&Ze.symbol.flags&32){let Ft=Wt.valueDeclaration.name.escapedText,gr=DR(Ze.symbol,Ft);if(gr&&ma(Ze,gr)){let Yr=U.getDeclarationName(Ze.symbol.valueDeclaration),fr=U.getDeclarationName(dt.symbol.valueDeclaration);Os(v.Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2,Op(Ft),Op(Yr.escapedText===""?fK:Yr),Op(fr.escapedText===""?fK:fr));return}}let cr=Is(_2e(Ze,dt,ut,!1));if((!T||T.code!==v.Class_0_incorrectly_implements_interface_1.code&&T.code!==v.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code)&&(hr=!0),cr.length===1){let Ft=rs(Wt,void 0,0,20);Os(v.Property_0_is_missing_in_type_1_but_required_in_type_2,Ft,...W6(Ze,dt)),wt(Wt.declarations)&&r_(pn(Wt.declarations[0],v._0_is_declared_here,Ft)),hr&&H&&Fn++}else rn(Ze,dt,!1)&&(cr.length>5?Os(v.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more,ln(Ze),ln(dt),Cr(cr.slice(0,4),Ft=>rs(Ft)).join(", "),cr.length-4):Os(v.Type_0_is_missing_the_following_properties_from_type_1_Colon_2,ln(Ze),ln(dt),Cr(cr,Ft=>rs(Ft)).join(", ")),hr&&H&&Fn++)}function ka(Ze,dt,Wt,ut,hr,cr){if(_===Hf)return Oa(Ze,dt,ut);let Ft=-1;if(Ha(dt)){if(vT(Ze)){if(!dt.target.readonly&&(i4(Ze)||Ha(Ze)&&Ze.target.readonly))return 0;let Gn=f1(Ze),sn=f1(dt),ui=Ha(Ze)?Ze.target.combinedFlags&4:4,ti=dt.target.combinedFlags&4,ra=Ha(Ze)?Ze.target.minLength:0,ya=dt.target.minLength;if(!ui&&Gn<ya)return Wt&&Os(v.Source_has_0_element_s_but_target_requires_1,Gn,ya),0;if(!ti&&sn<ra)return Wt&&Os(v.Source_has_0_element_s_but_target_allows_only_1,ra,sn),0;if(!ti&&(ui||sn<Gn))return Wt&&(ra<ya?Os(v.Target_requires_0_element_s_but_source_may_have_fewer,ya):Os(v.Target_allows_only_0_element_s_but_source_may_have_more,sn)),0;let uc=yc(Ze),yf=yc(dt),Tp=BMt(dt.target,11),US=N7(dt.target,11),CT=dt.target.hasRestElement,dx=!!ut;for(let bh=0;bh<Gn;bh++){let tp=Ha(Ze)?Ze.target.elementFlags[bh]:4,aw=Gn-1-bh,VS=CT&&bh>=Tp?sn-1-Math.min(aw,US):bh,mx=dt.target.elementFlags[VS];if(mx&8&&!(tp&8))return Wt&&Os(v.Source_provides_no_match_for_variadic_element_at_position_0_in_target,VS),0;if(tp&8&&!(mx&12))return Wt&&Os(v.Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target,bh,VS),0;if(mx&1&&!(tp&1))return Wt&&Os(v.Source_provides_no_match_for_required_element_at_position_0_in_target,VS),0;if(dx&&((tp&12||mx&12)&&(dx=!1),dx&&ut?.has(""+bh)))continue;let pL=rv(uc[bh],!!(tp&mx&2)),pC=yf[VS],T4=tp&8&&mx&4?g_(pC):rv(pC,!!(mx&2)),dL=Dn(pL,T4,3,Wt,void 0,cr);if(!dL)return Wt&&(sn>1||Gn>1)&&(CT&&bh>=Tp&&aw>=US&&Tp!==Gn-US-1?Ks(v.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target,Tp,Gn-US-1,VS):Ks(v.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target,bh,VS)),0;Ft&=dL}return Ft}if(dt.target.combinedFlags&12)return 0}let gr=(_===ih||_===Rd)&&!TT(Ze)&&!mre(Ze)&&!Ha(Ze),Yr=f2e(Ze,dt,gr,!1);if(Yr)return Wt&&Ee(Ze,dt)&&hi(Ze,dt,Yr,gr),0;if(TT(dt)){for(let Gn of Wr(bo(Ze),ut))if(!ZE(dt,Gn.escapedName)&&!(gn(Gn).flags&32768))return Wt&&Os(v.Property_0_does_not_exist_on_type_1,rs(Gn),ln(dt)),0}let fr=bo(dt),un=Ha(Ze)&&Ha(dt);for(let Gn of Wr(fr,ut)){let sn=Gn.escapedName;if(!(Gn.flags&4194304)&&(!un||Ry(sn)||sn==="length")&&(!hr||Gn.flags&16777216)){let ui=ma(Ze,sn);if(ui&&ui!==Gn){let ti=Bn(Ze,dt,ui,Gn,CS,Wt,cr,_===hp);if(!ti)return 0;Ft&=ti}}}return Ft}function Oa(Ze,dt,Wt){if(!(Ze.flags&524288&&dt.flags&524288))return 0;let ut=Wr(PS(Ze),Wt),hr=Wr(PS(dt),Wt);if(ut.length!==hr.length)return 0;let cr=-1;for(let Ft of ut){let gr=ZE(dt,Ft.escapedName);if(!gr)return 0;let Yr=Xxe(Ft,gr,Dn);if(!Yr)return 0;cr&=Yr}return cr}function je(Ze,dt,Wt,ut,hr){var cr,Ft;if(_===Hf)return bn(Ze,dt,Wt);if(dt===bc||Ze===bc)return-1;let gr=Ze.symbol&&vh(Ze.symbol.valueDeclaration),Yr=dt.symbol&&vh(dt.symbol.valueDeclaration),fr=Ys(Ze,gr&&Wt===1?0:Wt),un=Ys(dt,Yr&&Wt===1?0:Wt);if(Wt===1&&fr.length&&un.length){let ra=!!(fr[0].flags&4),ya=!!(un[0].flags&4);if(ra&&!ya)return ut&&Os(v.Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type),0;if(!Wo(fr[0],un[0],ut))return 0}let Gn=-1,sn=Wt===1?wr:ar,ui=Kn(Ze),ti=Kn(dt);if(ui&64&&ti&64&&Ze.symbol===dt.symbol||ui&4&&ti&4&&Ze.target===dt.target){M.assertEqual(fr.length,un.length);for(let ra=0;ra<un.length;ra++){let ya=xn(fr[ra],un[ra],!0,ut,hr,sn(fr[ra],un[ra]));if(!ya)return 0;Gn&=ya}}else if(fr.length===1&&un.length===1){let ra=_===hp,ya=Ma(fr),uc=Ma(un);if(Gn=xn(ya,uc,ra,ut,hr,sn(ya,uc)),!Gn&&ut&&Wt===1&&ui&ti&&(((cr=uc.declaration)==null?void 0:cr.kind)===176||((Ft=ya.declaration)==null?void 0:Ft.kind)===176)){let yf=Tp=>TS(Tp,void 0,262144,Wt);return Os(v.Type_0_is_not_assignable_to_type_1,yf(ya),yf(uc)),Os(v.Types_of_construct_signatures_are_incompatible),Gn}}else e:for(let ra of un){let ya=Ea(),uc=ut;for(let yf of fr){let Tp=xn(yf,ra,!0,uc,hr,sn(yf,ra));if(Tp){Gn&=Tp,si(ya);continue e}uc=!1}return uc&&Os(v.Type_0_provides_no_match_for_the_signature_1,ln(Ze),TS(ra,void 0,void 0,Wt)),0}return Gn}function Ee(Ze,dt){let Wt=yJ(Ze,0),ut=yJ(Ze,1),hr=PS(Ze);return(Wt.length||ut.length)&&!hr.length?!!(Ys(dt,0).length&&Wt.length||Ys(dt,1).length&&ut.length):!0}function ar(Ze,dt){return Ze.parameters.length===0&&dt.parameters.length===0?(Wt,ut)=>Ks(v.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1,ln(Wt),ln(ut)):(Wt,ut)=>Ks(v.Call_signature_return_types_0_and_1_are_incompatible,ln(Wt),ln(ut))}function wr(Ze,dt){return Ze.parameters.length===0&&dt.parameters.length===0?(Wt,ut)=>Ks(v.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1,ln(Wt),ln(ut)):(Wt,ut)=>Ks(v.Construct_signature_return_types_0_and_1_are_incompatible,ln(Wt),ln(ut))}function xn(Ze,dt,Wt,ut,hr,cr){let Ft=_===ih?16:_===Rd?24:0;return qxe(Wt?k7(Ze):Ze,Wt?k7(dt):dt,Ft,ut,Os,cr,gr,Sc);function gr(Yr,fr,un){return Dn(Yr,fr,3,un,void 0,hr)}}function bn(Ze,dt,Wt){let ut=Ys(Ze,Wt),hr=Ys(dt,Wt);if(ut.length!==hr.length)return 0;let cr=-1;for(let Ft=0;Ft<ut.length;Ft++){let gr=FJ(ut[Ft],hr[Ft],!1,!1,!1,Dn);if(!gr)return 0;cr&=gr}return cr}function On(Ze,dt,Wt,ut){let hr=-1,cr=dt.keyType,Ft=Ze.flags&2097152?mJ(Ze):PS(Ze);for(let gr of Ft)if(!L$e(Ze,gr)&&Uk(qk(gr,8576),cr)){let Yr=CS(gr),fr=te||Yr.flags&32768||cr===Te||!(gr.flags&16777216)?Yr:hm(Yr,524288),un=Dn(fr,dt.type,3,Wt,void 0,ut);if(!un)return Wt&&Os(v.Property_0_is_incompatible_with_index_signature,rs(gr)),0;hr&=un}for(let gr of X_(Ze))if(Uk(gr.keyType,cr)){let Yr=Hi(gr,dt,Wt,ut);if(!Yr)return 0;hr&=Yr}return hr}function Hi(Ze,dt,Wt,ut){let hr=Dn(Ze.type,dt.type,3,Wt,void 0,ut);return!hr&&Wt&&(Ze.keyType===dt.keyType?Os(v._0_index_signatures_are_incompatible,ln(Ze.keyType)):Os(v._0_and_1_index_signatures_are_incompatible,ln(Ze.keyType),ln(dt.keyType))),hr}function cs(Ze,dt,Wt,ut,hr){if(_===Hf)return Ws(Ze,dt);let cr=X_(dt),Ft=Pt(cr,Yr=>Yr.keyType===Ue),gr=-1;for(let Yr of cr){let fr=_!==Rd&&!Wt&&Ft&&Yr.type.flags&1?-1:Yf(Ze)&&Ft?Dn(K0(Ze),Yr.type,3,ut):ws(Ze,Yr,ut,hr);if(!fr)return 0;gr&=fr}return gr}function ws(Ze,dt,Wt,ut){let hr=x7(Ze,dt.keyType);return hr?Hi(hr,dt,Wt,ut):!(ut&1)&&(_!==Rd||Kn(Ze)&8192)&&bre(Ze)?On(Ze,dt,Wt,ut):(Wt&&Os(v.Index_signature_for_type_0_is_missing_in_type_1,ln(dt.keyType),ln(Ze)),0)}function Ws(Ze,dt){let Wt=X_(Ze),ut=X_(dt);if(Wt.length!==ut.length)return 0;for(let hr of ut){let cr=Gy(Ze,hr.keyType);if(!(cr&&Dn(cr.type,hr.type,3)&&cr.isReadonly===hr.isReadonly))return 0}return-1}function Wo(Ze,dt,Wt){if(!Ze.declaration||!dt.declaration)return!0;let ut=fA(Ze.declaration,6),hr=fA(dt.declaration,6);return hr===2||hr===4&&ut!==2||hr!==4&&!ut?!0:(Wt&&Os(v.Cannot_assign_a_0_constructor_type_to_a_1_constructor_type,$6(ut),$6(hr)),!1)}}function $xe(r){if(r.flags&16)return!1;if(r.flags&3145728)return!!kt(r.types,$xe);if(r.flags&465829888){let a=W2(r);if(a&&a!==r)return $xe(a)}return Tg(r)||!!(r.flags&134217728)||!!(r.flags&268435456)}function F$e(r,a){return Ha(r)&&Ha(a)?ve:bo(a).filter(_=>lre(il(r,_.escapedName),gn(_)))}function lre(r,a){return!!r&&!!a&&dl(r,32768)&&!!U7(a)}function aLt(r){return bo(r).filter(a=>U7(gn(a)))}function j$e(r,a,_=Vxe){return cXe(r,a,_)||vqt(r,a)||Sqt(r,a)||bqt(r,a)||Tqt(r,a)}function Hxe(r,a,_){let h=r.types,T=h.map(I=>I.flags&402784252?0:-1);for(let[I,V]of a){let H=!1;for(let X=0;X<h.length;X++)if(T[X]){let _e=G6(h[X],V);_e&&_(I(),_e)?H=!0:T[X]=3}for(let X=0;X<h.length;X++)T[X]===3&&(T[X]=H?0:-1)}let C=Es(T,0)?fi(h.filter((I,V)=>T[V]),0):r;return C.flags&131072?r:C}function Gxe(r){if(r.flags&524288){let a=Sg(r);return a.callSignatures.length===0&&a.constructSignatures.length===0&&a.indexInfos.length===0&&a.properties.length>0&&wi(a.properties,_=>!!(_.flags&16777216))}return r.flags&33554432?Gxe(r.baseType):r.flags&2097152?wi(r.types,Gxe):!1}function oLt(r,a,_){for(let h of bo(r))if(Wre(a,h.escapedName,_))return!0;return!1}function Yxe(r){return r===qt||r===Gr||r.objectFlags&8?G:U$e(r.symbol,r.typeParameters)}function B$e(r){return U$e(r,as(r).typeParameters)}function U$e(r,a=ve){var _,h;let T=as(r);if(!T.variances){(_=Cn)==null||_.push(Cn.Phase.CheckTypes,"getVariancesWorker",{arity:a.length,id:Lu(ac(r))});let C=ji,I=kn;ji||(ji=!0,kn=kr.length),T.variances=ve;let V=[];for(let H of a){let X=Kxe(H),_e=X&16384?X&8192?0:1:X&8192?2:void 0;if(_e===void 0){let we=!1,Ne=!1,pt=sa;sa=mr=>mr?Ne=!0:we=!0;let Tt=MJ(r,H,Jc),Mt=MJ(r,H,z_);_e=(ga(Mt,Tt)?1:0)|(ga(Tt,Mt)?2:0),_e===3&&ga(MJ(r,H,W_),Tt)&&(_e=4),sa=pt,(we||Ne)&&(we&&(_e|=8),Ne&&(_e|=16))}V.push(_e)}C||(ji=!1,kn=I),T.variances=V,(h=Cn)==null||h.pop({variances:V.map(M.formatVariance)})}return T.variances}function MJ(r,a,_){let h=sx(a,_),T=ac(r);if(ao(T))return T;let C=r.flags&524288?qD(r,Yy(as(r).typeParameters,h)):_1(T,Yy(T.typeParameters,h));return lt.add(Lu(C)),C}function ure(r){return lt.has(Lu(r))}function Kxe(r){var a;return L_((a=r.symbol)==null?void 0:a.declarations,(_,h)=>_|U_(h),0)&28672}function cLt(r,a){for(let _=0;_<a.length;_++)if((a[_]&7)===1&&r[_].flags&16384)return!0;return!1}function lLt(r){return r.flags&262144&&!mf(r)}function uLt(r){return!!(Kn(r)&4)&&!r.node}function _re(r){return uLt(r)&&Pt(yc(r),a=>!!(a.flags&262144)||_re(a))}function _Lt(r,a,_,h){let T=[],C="",I=H(r,0),V=H(a,0);return`${C}${I},${V}${_}`;function H(X,_e=0){let we=""+X.target.id;for(let Ne of yc(X)){if(Ne.flags&262144){if(h||lLt(Ne)){let pt=T.indexOf(Ne);pt<0&&(pt=T.length,T.push(Ne)),we+="="+pt;continue}C="*"}else if(_e<4&&_re(Ne)){we+="<"+H(Ne,_e+1)+">";continue}we+="-"+Ne.id}return we}}function fre(r,a,_,h,T){if(h===Hf&&r.id>a.id){let I=r;r=a,a=I}let C=_?":"+_:"";return _re(r)&&_re(a)?_Lt(r,a,C,T):`${r.id},${a.id}${C}`}function LJ(r,a){if(ll(r)&6){for(let _ of r.links.containingType.types){let h=ma(_,r.escapedName),T=h&&LJ(h,a);if(T)return T}return}return a(r)}function Yk(r){return r.parent&&r.parent.flags&32?ac(Qu(r)):void 0}function pre(r){let a=Yk(r),_=a&&_i(a)[0];return _&&il(_,r.escapedName)}function fLt(r,a){return LJ(r,_=>{let h=Yk(_);return h?FD(h,a):!1})}function pLt(r,a){return!LJ(a,_=>xd(_)&4?!fLt(r,Yk(_)):!1)}function V$e(r,a,_){return LJ(a,h=>xd(h,_)&4?!FD(r,Yk(h)):!1)?void 0:r}function Kk(r,a,_,h=3){if(_>=h){if((Kn(r)&96)===96&&(r=J$e(r)),r.flags&2097152)return Pt(r.types,V=>Kk(V,a,_,h));let T=dre(r),C=0,I=0;for(let V=0;V<_;V++){let H=a[V];if(q$e(H,T)){if(H.id>=I&&(C++,C>=h))return!0;I=H.id}}}return!1}function J$e(r){let a;for(;(Kn(r)&96)===96&&(a=QE(r))&&(a.symbol||a.flags&2097152&&Pt(a.types,_=>!!_.symbol));)r=a;return r}function q$e(r,a){return(Kn(r)&96)===96&&(r=J$e(r)),r.flags&2097152?Pt(r.types,_=>q$e(_,a)):dre(r)===a}function dre(r){if(r.flags&524288&&!d2e(r)){if(Kn(r)&4&&r.node)return r.node;if(r.symbol&&!(Kn(r)&16&&r.symbol.flags&32))return r.symbol;if(Ha(r))return r.target}if(r.flags&262144)return r.symbol;if(r.flags&8388608){do r=r.objectType;while(r.flags&8388608);return r}return r.flags&16777216?r.root:r}function dLt(r,a){return Xxe(r,a,M7)!==0}function Xxe(r,a,_){if(r===a)return-1;let h=xd(r)&6,T=xd(a)&6;if(h!==T)return 0;if(h){if(nw(r)!==nw(a))return 0}else if((r.flags&16777216)!==(a.flags&16777216))return 0;return Cg(r)!==Cg(a)?0:_(gn(r),gn(a))}function mLt(r,a,_){let h=ep(r),T=ep(a),C=Sh(r),I=Sh(a),V=uy(r),H=uy(a);return!!(h===T&&C===I&&V===H||_&&C<=I)}function FJ(r,a,_,h,T,C){if(r===a)return-1;if(!mLt(r,a,_)||wt(r.typeParameters)!==wt(a.typeParameters))return 0;if(a.typeParameters){let H=Xf(r.typeParameters,a.typeParameters);for(let X=0;X<a.typeParameters.length;X++){let _e=r.typeParameters[X],we=a.typeParameters[X];if(!(_e===we||C(os(t4(_e),H)||Rt,t4(we)||Rt)&&C(os(H2(_e),H)||Rt,H2(we)||Rt)))return 0}r=Gk(r,H,!0)}let I=-1;if(!h){let H=mT(r);if(H){let X=mT(a);if(X){let _e=C(H,X);if(!_e)return 0;I&=_e}}}let V=ep(a);for(let H=0;H<V;H++){let X=xg(r,H),_e=xg(a,H),we=C(_e,X);if(!we)return 0;I&=we}if(!T){let H=Bd(r),X=Bd(a);I&=H||X?gLt(H,X,C):C(ko(r),ko(a))}return I}function gLt(r,a,_){return r&&a&&xxe(r,a)?r.type===a.type?-1:r.type&&a.type?_(r.type,a.type):0:0}function hLt(r){let a;for(let _ of r)if(!(_.flags&131072)){let h=ev(_);if(a??(a=h),h===_||h!==a)return!1}return!0}function z$e(r){return L_(r,(a,_)=>a|(_.flags&1048576?z$e(_.types):_.flags),0)}function yLt(r){if(r.length===1)return r[0];let a=ce?Fs(r,h=>Fl(h,T=>!(T.flags&98304))):r,_=hLt(a)?fi(a):L_(a,(h,T)=>OS(h,T)?T:h);return a===r?_:UJ(_,z$e(r)&98304)}function vLt(r){return L_(r,(a,_)=>OS(_,a)?_:a)}function Jd(r){return!!(Kn(r)&4)&&(r.target===qt||r.target===Gr)}function i4(r){return!!(Kn(r)&4)&&r.target===Gr}function vT(r){return Jd(r)||Ha(r)}function jJ(r){return Jd(r)&&!i4(r)||Ha(r)&&!r.target.readonly}function BJ(r){return Jd(r)?yc(r)[0]:void 0}function g1(r){return Jd(r)||!(r.flags&98304)&&ga(r,Cl)}function Qxe(r){return jJ(r)||!(r.flags&98305)&&ga(r,Uo)}function Zxe(r){if(!(Kn(r)&4)||!(Kn(r.target)&3))return;if(Kn(r)&33554432)return Kn(r)&67108864?r.cachedEquivalentBaseType:void 0;r.objectFlags|=33554432;let a=r.target;if(Kn(a)&1){let T=fT(a);if(T&&T.expression.kind!==80&&T.expression.kind!==211)return}let _=_i(a);if(_.length!==1||kS(r.symbol).size)return;let h=wt(a.typeParameters)?os(_[0],Xf(a.typeParameters,yc(r).slice(0,a.typeParameters.length))):_[0];return wt(yc(r))>wt(a.typeParameters)&&(h=bp(h,Va(yc(r)))),r.objectFlags|=67108864,r.cachedEquivalentBaseType=h}function W$e(r){return ce?r===Ki:r===Z}function mre(r){let a=BJ(r);return!!a&&W$e(a)}function s4(r){let a;return Ha(r)||!!ma(r,"0")||g1(r)&&!!(a=il(r,"length"))&&Zf(a,_=>!!(_.flags&256))}function gre(r){return g1(r)||s4(r)}function $$e(r,a){let _=il(r,""+a);if(_)return _;if(Zf(r,Ha))return K$e(r,a,q.noUncheckedIndexedAccess?nr:void 0)}function SLt(r){return!(r.flags&240544)}function Tg(r){return!!(r.flags&109472)}function H$e(r){let a=ay(r);return a.flags&2097152?Pt(a.types,Tg):Tg(a)}function bLt(r){return r.flags&2097152&&Ln(r.types,Tg)||r}function j7(r){return r.flags&16?!0:r.flags&1048576?r.flags&1024?!0:wi(r.types,Tg):Tg(r)}function ev(r){return r.flags&1056?jk(r):r.flags&402653312?Ue:r.flags&256?Te:r.flags&2048?Re:r.flags&512?qr:r.flags&1048576?TLt(r):r}function TLt(r){let a=`B${Lu(r)}`;return $b(a)??Xv(a,wc(r,ev))}function e2e(r){return r.flags&402653312?Ue:r.flags&288?Te:r.flags&2048?Re:r.flags&512?qr:r.flags&1048576?wc(r,e2e):r}function ST(r){return r.flags&1056&&ix(r)?jk(r):r.flags&128&&ix(r)?Ue:r.flags&256&&ix(r)?Te:r.flags&2048&&ix(r)?Re:r.flags&512&&ix(r)?qr:r.flags&1048576?wc(r,ST):r}function G$e(r){return r.flags&8192?Hr:r.flags&1048576?wc(r,G$e):r}function t2e(r,a){return one(r,a)||(r=G$e(ST(r))),Q_(r)}function ELt(r,a,_){if(r&&Tg(r)){let h=a?_?nL(a):a:void 0;r=t2e(r,h)}return r}function r2e(r,a,_,h){if(r&&Tg(r)){let T=a?_x(_,a,h):void 0;r=t2e(r,T)}return r}function Ha(r){return!!(Kn(r)&4&&r.target.objectFlags&8)}function MS(r){return Ha(r)&&!!(r.target.combinedFlags&8)}function Y$e(r){return MS(r)&&r.target.elementFlags.length===1}function hre(r){return a4(r,r.target.fixedLength)}function K$e(r,a,_){return wc(r,h=>{let T=h,C=hre(T);return C?_&&a>=Txe(T.target)?fi([C,_]):C:nr})}function xLt(r){let a=hre(r);return a&&g_(a)}function a4(r,a,_=0,h=!1,T=!1){let C=f1(r)-_;if(a<C){let I=yc(r),V=[];for(let H=a;H<C;H++){let X=I[H];V.push(r.target.elementFlags[H]&8?Kf(X,Te):X)}return h?Da(V):fi(V,T?0:1)}}function CLt(r,a){return f1(r)===f1(a)&&wi(r.target.elementFlags,(_,h)=>(_&12)===(a.target.elementFlags[h]&12))}function X$e({value:r}){return r.base10Value==="0"}function Q$e(r){return Fl(r,a=>Eg(a,4194304))}function ALt(r){return wc(r,kLt)}function kLt(r){return r.flags&4?st:r.flags&8?Jt:r.flags&64?sr:r===$t||r===It||r.flags&114691||r.flags&128&&r.value===""||r.flags&256&&r.value===0||r.flags&2048&&X$e(r)?r:Ar}function UJ(r,a){let _=a&~r.flags&98304;return _===0?r:fi(_===32768?[r,nr]:_===65536?[r,Ke]:[r,nr,Ke])}function LS(r,a=!1){M.assert(ce);let _=a?bt:nr;return r===_||r.flags&1048576&&r.types[0]===_?r:fi([r,_])}function PLt(r){return Wf||(Wf=WD("NonNullable",524288,void 0)||St),Wf!==St?qD(Wf,[r]):Da([r,zi])}function tv(r){return ce?iC(r,2097152):r}function Z$e(r){return ce?fi([r,Q]):r}function yre(r){return ce?Nre(r,Q):r}function vre(r,a,_){return _?mI(a)?LS(r):Z$e(r):r}function B7(r,a){return k5(a)?tv(r):S_(a)?yre(r):r}function rv(r,a){return te&&a?Nre(r,Ge):r}function U7(r){return r===Ge||!!(r.flags&1048576)&&r.types[0]===Ge}function Sre(r){return te?Nre(r,Ge):hm(r,524288)}function NLt(r,a){return(r.flags&524)!==0&&(a.flags&28)!==0}function bre(r){let a=Kn(r);return r.flags&2097152?wi(r.types,bre):!!(r.symbol&&r.symbol.flags&7040&&!(r.symbol.flags&32)&&!Cne(r))||!!(a&4194304)||!!(a&1024&&bre(r.source))}function tC(r,a){let _=Za(r.flags,r.escapedName,ll(r)&8);_.declarations=r.declarations,_.parent=r.parent,_.links.type=a,_.links.target=r,r.valueDeclaration&&(_.valueDeclaration=r.valueDeclaration);let h=as(r).nameType;return h&&(_.links.nameType=h),_}function DLt(r,a){let _=fa();for(let h of PS(r)){let T=gn(h),C=a(T);_.set(h.escapedName,C===T?h:tC(h,C))}return _}function V7(r){if(!(TT(r)&&Kn(r)&8192))return r;let a=r.regularType;if(a)return a;let _=r,h=DLt(r,V7),T=Zt(_.symbol,h,_.callSignatures,_.constructSignatures,_.indexInfos);return T.flags=_.flags,T.objectFlags|=_.objectFlags&-8193,r.regularType=T,T}function eHe(r,a,_){return{parent:r,propertyName:a,siblings:_,resolvedProperties:void 0}}function tHe(r){if(!r.siblings){let a=[];for(let _ of tHe(r.parent))if(TT(_)){let h=ZE(_,r.propertyName);h&&sC(gn(h),T=>{a.push(T)})}r.siblings=a}return r.siblings}function wLt(r){if(!r.resolvedProperties){let a=new Map;for(let _ of tHe(r))if(TT(_)&&!(Kn(_)&2097152))for(let h of bo(_))a.set(h.escapedName,h);r.resolvedProperties=Is(a.values())}return r.resolvedProperties}function ILt(r,a){if(!(r.flags&4))return r;let _=gn(r),h=a&&eHe(a,r.escapedName,void 0),T=n2e(_,h);return T===_?r:tC(r,T)}function OLt(r){let a=to.get(r.escapedName);if(a)return a;let _=tC(r,bt);return _.flags|=16777216,to.set(r.escapedName,_),_}function RLt(r,a){let _=fa();for(let T of PS(r))_.set(T.escapedName,ILt(T,a));if(a)for(let T of wLt(a))_.has(T.escapedName)||_.set(T.escapedName,OLt(T));let h=Zt(r.symbol,_,ve,ve,Fs(X_(r),T=>oy(T.keyType,Qf(T.type),T.isReadonly)));return h.objectFlags|=Kn(r)&266240,h}function Qf(r){return n2e(r,void 0)}function n2e(r,a){if(Kn(r)&196608){if(a===void 0&&r.widened)return r.widened;let _;if(r.flags&98305)_=Me;else if(TT(r))_=RLt(r,a);else if(r.flags&1048576){let h=a||eHe(void 0,void 0,r.types),T=Fs(r.types,C=>C.flags&98304?C:n2e(C,h));_=fi(T,Pt(T,Z0)?2:1)}else r.flags&2097152?_=Da(Fs(r.types,Qf)):vT(r)&&(_=_1(r.target,Fs(yc(r),Qf)));return _&&a===void 0&&(r.widened=_),_||r}return r}function Tre(r){let a=!1;if(Kn(r)&65536){if(r.flags&1048576)if(Pt(r.types,Z0))a=!0;else for(let _ of r.types)Tre(_)&&(a=!0);if(vT(r))for(let _ of yc(r))Tre(_)&&(a=!0);if(TT(r))for(let _ of PS(r)){let h=gn(_);Kn(h)&65536&&(Tre(h)||Qe(_.valueDeclaration,v.Object_literal_s_property_0_implicitly_has_an_1_type,rs(_),ln(Qf(h))),a=!0)}}return a}function bT(r,a,_){let h=ln(Qf(a));if(hn(r)&&!lO(Ur(r),q))return;let T;switch(r.kind){case 226:case 172:case 171:T=de?v.Member_0_implicitly_has_an_1_type:v.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;break;case 169:let C=r;if(He(C.name)){let I=Jx(C.name);if((MA(C.parent)||$g(C.parent)||Jh(C.parent))&&C.parent.parameters.includes(C)&&(xr(C,C.name.escapedText,788968,void 0,!0)||I&&uG(I))){let V="arg"+C.parent.parameters.indexOf(C),H=Yo(C.name)+(C.dotDotDotToken?"[]":"");Cu(de,r,v.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1,V,H);return}}T=r.dotDotDotToken?de?v.Rest_parameter_0_implicitly_has_an_any_type:v.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage:de?v.Parameter_0_implicitly_has_an_1_type:v.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;break;case 208:if(T=v.Binding_element_0_implicitly_has_an_1_type,!de)return;break;case 317:Qe(r,v.Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type,h);return;case 323:de&&EN(r.parent)&&Qe(r.parent.tagName,v.This_overload_implicitly_returns_the_type_0_because_it_lacks_a_return_type_annotation,h);return;case 262:case 174:case 173:case 177:case 178:case 218:case 219:if(de&&!r.name){_===3?Qe(r,v.Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type_annotation,h):Qe(r,v.Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type,h);return}T=de?_===3?v._0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type:v._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type:v._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage;break;case 200:de&&Qe(r,v.Mapped_object_type_implicitly_has_an_any_template_type);return;default:T=de?v.Variable_0_implicitly_has_an_1_type:v.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage}Cu(de,r,T,Yo(Ps(r)),h)}function Ere(r,a,_){n(()=>{de&&Kn(a)&65536&&(!_||!U2e(r))&&(Tre(a)||bT(r,a,_))})}function i2e(r,a,_){let h=ep(r),T=ep(a),C=X7(r),I=X7(a),V=I?T-1:T,H=C?V:Math.min(h,V),X=mT(r);if(X){let _e=mT(a);_e&&_(X,_e)}for(let _e=0;_e<H;_e++)_(xg(r,_e),xg(a,_e));I&&_(dq(r,H,$2(I)&&!ym(I,Qxe)),I)}function s2e(r,a,_){let h=Bd(a);if(h){let C=Bd(r);if(C&&xxe(C,h)&&C.type&&h.type){_(C.type,h.type);return}}let T=ko(a);FS(T)&&_(ko(r),T)}function J7(r,a,_,h){return a2e(r.map(c2e),a,_,h||Vxe)}function MLt(r,a=0){return r&&a2e(Cr(r.inferences,rHe),r.signature,r.flags|a,r.compareTypes)}function a2e(r,a,_,h){let T={inferences:r,signature:a,flags:_,compareTypes:h,mapper:ts,nonFixingMapper:ts};return T.mapper=LLt(T),T.nonFixingMapper=FLt(T),T}function LLt(r){return Fxe(Cr(r.inferences,a=>a.typeParameter),Cr(r.inferences,(a,_)=>()=>(a.isFixed||(jLt(r),xre(r.inferences),a.isFixed=!0),m2e(r,_))))}function FLt(r){return Fxe(Cr(r.inferences,a=>a.typeParameter),Cr(r.inferences,(a,_)=>()=>m2e(r,_)))}function xre(r){for(let a of r)a.isFixed||(a.inferredType=void 0)}function o2e(r,a,_){(r.intraExpressionInferenceSites??(r.intraExpressionInferenceSites=[])).push({node:a,type:_})}function jLt(r){if(r.intraExpressionInferenceSites){for(let{node:a,type:_}of r.intraExpressionInferenceSites){let h=a.kind===174?iGe(a,2):hf(a,2);h&&nv(r.inferences,_,h)}r.intraExpressionInferenceSites=void 0}}function c2e(r){return{typeParameter:r,candidates:void 0,contraCandidates:void 0,inferredType:void 0,priority:void 0,topLevel:!0,isFixed:!1,impliedArity:void 0}}function rHe(r){return{typeParameter:r.typeParameter,candidates:r.candidates&&r.candidates.slice(),contraCandidates:r.contraCandidates&&r.contraCandidates.slice(),inferredType:r.inferredType,priority:r.priority,topLevel:r.topLevel,isFixed:r.isFixed,impliedArity:r.impliedArity}}function BLt(r){let a=Zn(r.inferences,rw);return a.length?a2e(Cr(a,rHe),r.signature,r.flags,r.compareTypes):void 0}function l2e(r){return r&&r.mapper}function FS(r){let a=Kn(r);if(a&524288)return!!(a&1048576);let _=!!(r.flags&465829888||r.flags&524288&&!nHe(r)&&(a&4&&(r.node||Pt(yc(r),FS))||a&134217728&&wt(r.outerTypeParameters)||a&16&&r.symbol&&r.symbol.flags&14384&&r.symbol.declarations||a&12583968)||r.flags&3145728&&!(r.flags&1024)&&!nHe(r)&&Pt(r.types,FS));return r.flags&3899393&&(r.objectFlags|=524288|(_?1048576:0)),_}function nHe(r){if(r.aliasSymbol&&!r.aliasTypeArguments){let a=Pc(r.aliasSymbol,265);return!!(a&&Pr(a.parent,_=>_.kind===307?!0:_.kind===267?!1:"quit"))}return!1}function q7(r,a,_=0){return!!(r===a||r.flags&3145728&&Pt(r.types,h=>q7(h,a,_))||_<3&&r.flags&16777216&&(q7(gT(r),a,_+1)||q7(hT(r),a,_+1)))}function ULt(r,a){let _=Bd(r);return _?!!_.type&&q7(_.type,a):q7(ko(r),a)}function VLt(r){let a=fa();sC(r,h=>{if(!(h.flags&128))return;let T=Uc(h.value),C=Za(4,T);C.links.type=Me,h.symbol&&(C.declarations=h.symbol.declarations,C.valueDeclaration=h.symbol.valueDeclaration),a.set(T,C)});let _=r.flags&4?[oy(Ue,zi,!1)]:ve;return Zt(void 0,a,ve,ve,_)}function iHe(r,a,_){let h=r.id+","+a.id+","+_.id;if(du.has(h))return du.get(h);let T=JLt(r,a,_);return du.set(h,T),T}function u2e(r){return!(Kn(r)&262144)||TT(r)&&Pt(bo(r),a=>u2e(gn(a)))||Ha(r)&&Pt(rx(r),u2e)}function JLt(r,a,_){if(!(Gy(r,Ue)||bo(r).length!==0&&u2e(r)))return;if(Jd(r)){let T=Cre(yc(r)[0],a,_);return T?g_(T,i4(r)):void 0}if(Ha(r)){let T=Cr(rx(r),I=>Cre(I,a,_));if(!wi(T,I=>!!I))return;let C=sy(a)&4?Fs(r.target.elementFlags,I=>I&2?1:I):r.target.elementFlags;return cy(T,C,r.target.readonly,r.target.labeledElementDeclarations)}let h=Lp(1040,void 0);return h.source=r,h.mappedType=a,h.constraintType=_,h}function qLt(r){let a=as(r);return a.type||(a.type=Cre(r.links.propertyType,r.links.mappedType,r.links.constraintType)||Rt),a.type}function zLt(r,a,_){let h=Kf(_.type,vg(a)),T=K0(a),C=c2e(h);return nv([C],r,T),sHe(C)||Rt}function Cre(r,a,_){let h=r.id+","+a.id+","+_.id;if(Oc.has(h))return Oc.get(h)||Rt;jE.push(r),qy.push(a);let T=BE;Kk(r,jE,jE.length,2)&&(BE|=1),Kk(a,qy,qy.length,2)&&(BE|=2);let C;return BE!==3&&(C=zLt(r,a,_)),jE.pop(),qy.pop(),BE=T,Oc.set(h,C),C}function*_2e(r,a,_,h){let T=bo(a);for(let C of T)if(!Hze(C)&&(_||!(C.flags&16777216||ll(C)&48))){let I=ma(r,C.escapedName);if(!I)yield C;else if(h){let V=gn(C);if(V.flags&109472){let H=gn(I);H.flags&1||Q_(H)===Q_(V)||(yield C)}}}}function f2e(r,a,_,h){return Nh(_2e(r,a,_,h))}function WLt(r,a){return!(a.target.combinedFlags&8)&&a.target.minLength>r.target.minLength||!a.target.hasRestElement&&(r.target.hasRestElement||a.target.fixedLength<r.target.fixedLength)}function $Lt(r,a){return Ha(r)&&Ha(a)?WLt(r,a):!!f2e(r,a,!1,!0)&&!!f2e(a,r,!1,!1)}function sHe(r){return r.candidates?fi(r.candidates,2):r.contraCandidates?Da(r.contraCandidates):void 0}function p2e(r){return!!qn(r).skipDirectInference}function aHe(r){return!!(r.symbol&&Pt(r.symbol.declarations,p2e))}function HLt(r,a){let _=r.texts[0],h=a.texts[0],T=r.texts[r.texts.length-1],C=a.texts[a.texts.length-1],I=Math.min(_.length,h.length),V=Math.min(T.length,C.length);return _.slice(0,I)!==h.slice(0,I)||T.slice(T.length-V)!==C.slice(C.length-V)}function oHe(r,a){if(r==="")return!1;let _=+r;return isFinite(_)&&(!a||""+_===r)}function GLt(r){return ere(DG(r))}function Are(r,a){if(a.flags&1)return!0;if(a.flags&134217732)return ga(r,a);if(a.flags&268435456){let _=[];for(;a.flags&268435456;)_.unshift(a.symbol),a=a.type;return L_(_,(T,C)=>zk(C,T),r)===r&&Are(r,a)}return!1}function cHe(r,a){if(a.flags&2097152)return wi(a.types,_=>_===P_||cHe(r,_));if(a.flags&4||ga(r,a))return!0;if(r.flags&128){let _=r.value;return!!(a.flags&8&&oHe(_,!1)||a.flags&64&&_j(_,!1)||a.flags&98816&&_===a.intrinsicName||a.flags&268435456&&Are(Lf(_),a)||a.flags&134217728&&kre(r,a))}if(r.flags&134217728){let _=r.texts;return _.length===2&&_[0]===""&&_[1]===""&&ga(r.types[0],a)}return!1}function lHe(r,a){return r.flags&128?uHe([r.value],ve,a):r.flags&134217728?UT(r.texts,a.texts)?Cr(r.types,(_,h)=>ga(ay(_),ay(a.types[h]))?_:YLt(_)):uHe(r.texts,r.types,a):void 0}function kre(r,a){let _=lHe(r,a);return!!_&&wi(_,(h,T)=>cHe(h,a.types[T]))}function YLt(r){return r.flags&402653317?r:Y2(["",""],[r])}function uHe(r,a,_){let h=r.length-1,T=r[0],C=r[h],I=_.texts,V=I.length-1,H=I[0],X=I[V];if(h===0&&T.length<H.length+X.length||!T.startsWith(H)||!C.endsWith(X))return;let _e=C.slice(0,C.length-X.length),we=[],Ne=0,pt=H.length;for(let mr=1;mr<V;mr++){let br=I[mr];if(br.length>0){let en=Ne,Fn=pt;for(;Fn=Tt(en).indexOf(br,Fn),!(Fn>=0);){if(en++,en===r.length)return;Fn=0}Mt(en,Fn),pt+=br.length}else if(pt<Tt(Ne).length)Mt(Ne,pt+1);else if(Ne<h)Mt(Ne+1,0);else return}return Mt(h,Tt(h).length),we;function Tt(mr){return mr<h?r[mr]:_e}function Mt(mr,br){let en=mr===Ne?Lf(Tt(mr).slice(pt,br)):Y2([r[Ne].slice(pt),...r.slice(Ne+1,mr),Tt(mr).slice(0,br)],a.slice(Ne,mr));we.push(en),Ne=mr,pt=br}}function KLt(r,a){return Ha(a)&&$$e(a,0)===Kf(r,zm(0))&&!il(a,"1")}function nv(r,a,_,h=0,T=!1){let C=!1,I,V=2048,H,X,_e,we=0;Ne(a,_);function Ne(Jr,rn){if(!(!FS(rn)||zD(rn))){if(Jr===ft||Jr===tr){let $i=I;I=Jr,Ne(rn,rn),I=$i;return}if(Jr.aliasSymbol&&Jr.aliasSymbol===rn.aliasSymbol){if(Jr.aliasTypeArguments){let $i=as(Jr.aliasSymbol).typeParameters,Dn=ph($i),is=NS(Jr.aliasTypeArguments,$i,Dn,hn(Jr.aliasSymbol.valueDeclaration)),To=NS(rn.aliasTypeArguments,$i,Dn,hn(Jr.aliasSymbol.valueDeclaration));en(is,To,B$e(Jr.aliasSymbol))}return}if(Jr===rn&&Jr.flags&3145728){for(let $i of Jr.types)Ne($i,$i);return}if(rn.flags&1048576){let[$i,Dn]=br(Jr.flags&1048576?Jr.types:[Jr],rn.types,XLt),[is,To]=br($i,Dn,QLt);if(To.length===0)return;if(rn=fi(To),is.length===0){pt(Jr,rn,1);return}Jr=fi(is)}else if(rn.flags&2097152&&!wi(rn.types,Qte)&&!(Jr.flags&1048576)){let[$i,Dn]=br(Jr.flags&2097152?Jr.types:[Jr],rn.types,Q0);if($i.length===0||Dn.length===0)return;Jr=Da($i),rn=Da(Dn)}if(rn.flags&41943040){if(zD(rn))return;rn=IS(rn)}if(rn.flags&8650752){if(aHe(Jr))return;let $i=zr(rn);if($i){if(Kn(Jr)&262144||Jr===Nt)return;if(!$i.isFixed){let is=I||Jr;if(is===tr)return;if(($i.priority===void 0||h<$i.priority)&&($i.candidates=void 0,$i.contraCandidates=void 0,$i.topLevel=!0,$i.priority=h),h===$i.priority){if(KLt($i.typeParameter,is))return;T&&!C?Es($i.contraCandidates,is)||($i.contraCandidates=Bt($i.contraCandidates,is),xre(r)):Es($i.candidates,is)||($i.candidates=Bt($i.candidates,is),xre(r))}!(h&128)&&rn.flags&262144&&$i.topLevel&&!q7(_,rn)&&($i.topLevel=!1,xre(r))}V=Math.min(V,h);return}let Dn=X0(rn,!1);if(Dn!==rn)Ne(Jr,Dn);else if(rn.flags&8388608){let is=X0(rn.indexType,!1);if(is.flags&465829888){let To=l$e(X0(rn.objectType,!1),is,!1);To&&To!==rn&&Ne(Jr,To)}}}if(Kn(Jr)&4&&Kn(rn)&4&&(Jr.target===rn.target||Jd(Jr)&&Jd(rn))&&!(Jr.node&&rn.node))en(yc(Jr),yc(rn),Yxe(Jr.target));else if(Jr.flags&4194304&&rn.flags&4194304)Fn(Jr.type,rn.type);else if((j7(Jr)||Jr.flags&4)&&rn.flags&4194304){let $i=VLt(Jr);Tt($i,rn.type,256)}else if(Jr.flags&8388608&&rn.flags&8388608)Ne(Jr.objectType,rn.objectType),Ne(Jr.indexType,rn.indexType);else if(Jr.flags&268435456&&rn.flags&268435456)Jr.symbol===rn.symbol&&Ne(Jr.type,rn.type);else if(Jr.flags&33554432)Ne(Jr.baseType,rn),pt(_xe(Jr),rn,4);else if(rn.flags&16777216)mr(Jr,rn,si);else if(rn.flags&3145728)$n(Jr,rn.types,rn.flags);else if(Jr.flags&1048576){let $i=Jr.types;for(let Dn of $i)Ne(Dn,rn)}else if(rn.flags&134217728)Ea(Jr,rn);else{if(Jr=bg(Jr),Yf(Jr)&&Yf(rn)&&mr(Jr,rn,Ks),!(h&512&&Jr.flags&467927040)){let $i=K_(Jr);if($i!==Jr&&!($i.flags&2621440))return Ne($i,rn);Jr=$i}Jr.flags&2621440&&mr(Jr,rn,no)}}}function pt(Jr,rn,$i){let Dn=h;h|=$i,Ne(Jr,rn),h=Dn}function Tt(Jr,rn,$i){let Dn=h;h|=$i,Fn(Jr,rn),h=Dn}function Mt(Jr,rn,$i,Dn){let is=h;h|=Dn,$n(Jr,rn,$i),h=is}function mr(Jr,rn,$i){let Dn=Jr.id+","+rn.id,is=H&&H.get(Dn);if(is!==void 0){V=Math.min(V,is);return}(H||(H=new Map)).set(Dn,-1);let To=V;V=2048;let go=we;(X??(X=[])).push(Jr),(_e??(_e=[])).push(rn),Kk(Jr,X,X.length,2)&&(we|=1),Kk(rn,_e,_e.length,2)&&(we|=2),we!==3?$i(Jr,rn):V=-1,_e.pop(),X.pop(),we=go,H.set(Dn,V),V=Math.min(V,To)}function br(Jr,rn,$i){let Dn,is;for(let To of rn)for(let go of Jr)$i(go,To)&&(Ne(go,To),Dn=$o(Dn,go),is=$o(is,To));return[Dn?Zn(Jr,To=>!Es(Dn,To)):Jr,is?Zn(rn,To=>!Es(is,To)):rn]}function en(Jr,rn,$i){let Dn=Jr.length<rn.length?Jr.length:rn.length;for(let is=0;is<Dn;is++)is<$i.length&&($i[is]&7)===2?Fn(Jr[is],rn[is]):Ne(Jr[is],rn[is])}function Fn(Jr,rn){T=!T,Ne(Jr,rn),T=!T}function Dr(Jr,rn){ne||h&1024?Fn(Jr,rn):Ne(Jr,rn)}function zr(Jr){if(Jr.flags&8650752){for(let rn of r)if(Jr===rn.typeParameter)return rn}}function Qr(Jr){let rn;for(let $i of Jr){let Dn=$i.flags&2097152&&Ln($i.types,is=>!!zr(is));if(!Dn||rn&&Dn!==rn)return;rn=Dn}return rn}function $n(Jr,rn,$i){let Dn=0;if($i&1048576){let is,To=Jr.flags&1048576?Jr.types:[Jr],go=new Array(To.length),h_=!1;for(let ha of rn)if(zr(ha))is=ha,Dn++;else for(let O_=0;O_<To.length;O_++){let Mc=V;V=2048,Ne(To[O_],ha),V===h&&(go[O_]=!0),h_=h_||V===-1,V=Math.min(V,Mc)}if(Dn===0){let ha=Qr(rn);ha&&pt(Jr,ha,1);return}if(Dn===1&&!h_){let ha=va(To,(O_,Mc)=>go[Mc]?void 0:O_);if(ha.length){Ne(fi(ha),is);return}}}else for(let is of rn)zr(is)?Dn++:Ne(Jr,is);if($i&2097152?Dn===1:Dn>0)for(let is of rn)zr(is)&&pt(Jr,is,1)}function ii(Jr,rn,$i){if($i.flags&1048576||$i.flags&2097152){let Dn=!1;for(let is of $i.types)Dn=ii(Jr,rn,is)||Dn;return Dn}if($i.flags&4194304){let Dn=zr($i.type);if(Dn&&!Dn.isFixed&&!aHe(Jr)){let is=iHe(Jr,rn,$i);is&&pt(is,Dn.typeParameter,Kn(Jr)&262144?16:8)}return!0}if($i.flags&262144){pt(dh(Jr,Jr.pattern?2:0),$i,32);let Dn=W2($i);if(Dn&&ii(Jr,rn,Dn))return!0;let is=Cr(bo(Jr),gn),To=Cr(X_(Jr),go=>go!==Tr?go.type:Ar);return Ne(fi(ps(is,To)),K0(rn)),!0}return!1}function si(Jr,rn){if(Jr.flags&16777216)Ne(Jr.checkType,rn.checkType),Ne(Jr.extendsType,rn.extendsType),Ne(gT(Jr),gT(rn)),Ne(hT(Jr),hT(rn));else{let $i=[gT(rn),hT(rn)];Mt(Jr,$i,rn.flags,T?64:0)}}function Ea(Jr,rn){let $i=lHe(Jr,rn),Dn=rn.types;if($i||wi(rn.texts,is=>is.length===0))for(let is=0;is<Dn.length;is++){let To=$i?$i[is]:Ar,go=Dn[is];if(To.flags&128&&go.flags&8650752){let h_=zr(go),ha=h_?Zu(h_.typeParameter):void 0;if(ha&&!Ao(ha)){let O_=ha.flags&1048576?ha.types:[ha],Mc=L_(O_,(Lc,gd)=>Lc|gd.flags,0);if(!(Mc&4)){let Lc=To.value;Mc&296&&!oHe(Lc,!0)&&(Mc&=-297),Mc&2112&&!_j(Lc,!0)&&(Mc&=-2113);let gd=L_(O_,(ml,jl)=>jl.flags&Mc?ml.flags&4?ml:jl.flags&4?To:ml.flags&134217728?ml:jl.flags&134217728&&kre(To,jl)?To:ml.flags&268435456?ml:jl.flags&268435456&&Lc===s$e(jl.symbol,Lc)?To:ml.flags&128?ml:jl.flags&128&&jl.value===Lc?jl:ml.flags&8?ml:jl.flags&8?zm(+Lc):ml.flags&32?ml:jl.flags&32?zm(+Lc):ml.flags&256?ml:jl.flags&256&&jl.value===+Lc?jl:ml.flags&64?ml:jl.flags&64?GLt(Lc):ml.flags&2048?ml:jl.flags&2048&&uE(jl.value)===Lc?jl:ml.flags&16?ml:jl.flags&16?Lc==="true"?Ht:Lc==="false"?It:qr:ml.flags&512?ml:jl.flags&512&&jl.intrinsicName===Lc?jl:ml.flags&32768?ml:jl.flags&32768&&jl.intrinsicName===Lc?jl:ml.flags&65536?ml:jl.flags&65536&&jl.intrinsicName===Lc?jl:ml:ml,Ar);if(!(gd.flags&131072)){Ne(gd,go);continue}}}}Ne(To,go)}}function Ks(Jr,rn){Ne(dd(Jr),dd(rn)),Ne(K0(Jr),K0(rn));let $i=u1(Jr),Dn=u1(rn);$i&&Dn&&Ne($i,Dn)}function no(Jr,rn){var $i,Dn;if(Kn(Jr)&4&&Kn(rn)&4&&(Jr.target===rn.target||Jd(Jr)&&Jd(rn))){en(yc(Jr),yc(rn),Yxe(Jr.target));return}if(Yf(Jr)&&Yf(rn)&&Ks(Jr,rn),Kn(rn)&32&&!rn.declaration.nameType){let is=dd(rn);if(ii(Jr,rn,is))return}if(!$Lt(Jr,rn)){if(vT(Jr)){if(Ha(rn)){let is=f1(Jr),To=f1(rn),go=yc(rn),h_=rn.target.elementFlags;if(Ha(Jr)&&CLt(Jr,rn)){for(let Mc=0;Mc<To;Mc++)Ne(yc(Jr)[Mc],go[Mc]);return}let ha=Ha(Jr)?Math.min(Jr.target.fixedLength,rn.target.fixedLength):0,O_=Math.min(Ha(Jr)?N7(Jr.target,3):0,rn.target.hasRestElement?N7(rn.target,3):0);for(let Mc=0;Mc<ha;Mc++)Ne(yc(Jr)[Mc],go[Mc]);if(!Ha(Jr)||is-ha-O_===1&&Jr.target.elementFlags[ha]&4){let Mc=yc(Jr)[ha];for(let Lc=ha;Lc<To-O_;Lc++)Ne(h_[Lc]&8?g_(Mc):Mc,go[Lc])}else{let Mc=To-ha-O_;if(Mc===2){if(h_[ha]&h_[ha+1]&8){let Lc=zr(go[ha]);Lc&&Lc.impliedArity!==void 0&&(Ne(n4(Jr,ha,O_+is-Lc.impliedArity),go[ha]),Ne(n4(Jr,ha+Lc.impliedArity,O_),go[ha+1]))}else if(h_[ha]&8&&h_[ha+1]&4){let Lc=($i=zr(go[ha]))==null?void 0:$i.typeParameter,gd=Lc&&Zu(Lc);if(gd&&Ha(gd)&&!gd.target.hasRestElement){let ml=gd.target.fixedLength;Ne(n4(Jr,ha,is-(ha+ml)),go[ha]),Ne(a4(Jr,ha+ml,O_),go[ha+1])}}else if(h_[ha]&4&&h_[ha+1]&8){let Lc=(Dn=zr(go[ha+1]))==null?void 0:Dn.typeParameter,gd=Lc&&Zu(Lc);if(gd&&Ha(gd)&&!gd.target.hasRestElement){let ml=gd.target.fixedLength,jl=is-N7(rn.target,3),av=jl-ml,sw=cy(yc(Jr).slice(av,jl),Jr.target.elementFlags.slice(av,jl),!1,Jr.target.labeledElementDeclarations&&Jr.target.labeledElementDeclarations.slice(av,jl));Ne(a4(Jr,ha,O_+ml),go[ha]),Ne(sw,go[ha+1])}}}else if(Mc===1&&h_[ha]&8){let Lc=rn.target.elementFlags[To-1]&2,gd=n4(Jr,ha,O_);pt(gd,go[ha],Lc?2:0)}else if(Mc===1&&h_[ha]&4){let Lc=a4(Jr,ha,O_);Lc&&Ne(Lc,go[ha])}}for(let Mc=0;Mc<O_;Mc++)Ne(yc(Jr)[is-Mc-1],go[To-Mc-1]);return}if(Jd(rn)){sl(Jr,rn);return}}Os(Jr,rn),Rc(Jr,rn,0),Rc(Jr,rn,1),sl(Jr,rn)}}function Os(Jr,rn){let $i=PS(rn);for(let Dn of $i){let is=ma(Jr,Dn.escapedName);is&&!Pt(is.declarations,p2e)&&Ne(rv(gn(is),!!(is.flags&16777216)),rv(gn(Dn),!!(Dn.flags&16777216)))}}function Rc(Jr,rn,$i){let Dn=Ys(Jr,$i),is=Dn.length;if(is>0){let To=Ys(rn,$i),go=To.length;for(let h_=0;h_<go;h_++){let ha=Math.max(is-go+h_,0);r_(rMt(Dn[ha]),k7(To[h_]))}}}function r_(Jr,rn){if(!(Jr.flags&64)){let $i=C,Dn=rn.declaration?rn.declaration.kind:0;C=C||Dn===174||Dn===173||Dn===176,i2e(Jr,rn,Dr),C=$i}s2e(Jr,rn,Ne)}function sl(Jr,rn){let $i=Kn(Jr)&Kn(rn)&32?8:0,Dn=X_(rn);if(bre(Jr))for(let is of Dn){let To=[];for(let go of bo(Jr))if(Uk(qk(go,8576),is.keyType)){let h_=gn(go);To.push(go.flags&16777216?Sre(h_):h_)}for(let go of X_(Jr))Uk(go.keyType,is.keyType)&&To.push(go.type);To.length&&pt(fi(To),is.type,$i)}for(let is of Dn){let To=x7(Jr,is.keyType);To&&pt(To.type,is.type,$i)}}}function XLt(r,a){return a===Ge?r===a:Q0(r,a)||!!(a.flags&4&&r.flags&128||a.flags&8&&r.flags&256)}function QLt(r,a){return!!(r.flags&524288&&a.flags&524288&&r.symbol&&r.symbol===a.symbol||r.aliasSymbol&&r.aliasTypeArguments&&r.aliasSymbol===a.aliasSymbol)}function ZLt(r){let a=mf(r);return!!a&&dl(a.flags&16777216?zEe(a):a,406978556)}function TT(r){return!!(Kn(r)&128)}function d2e(r){return!!(Kn(r)&16512)}function eFt(r){if(r.length>1){let a=Zn(r,d2e);if(a.length){let _=fi(a,2);return ps(Zn(r,h=>!d2e(h)),[_])}}return r}function tFt(r){return r.priority&416?Da(r.contraCandidates):vLt(r.contraCandidates)}function rFt(r,a){let _=eFt(r.candidates),h=ZLt(r.typeParameter)||$2(r.typeParameter),T=!h&&r.topLevel&&(r.isFixed||!ULt(a,r.typeParameter)),C=h?Fs(_,Q_):T?Fs(_,ST):_,I=r.priority&416?fi(C,2):yLt(C);return Qf(I)}function m2e(r,a){let _=r.inferences[a];if(!_.inferredType){let h,T;if(r.signature){let I=_.candidates?rFt(_,r.signature):void 0,V=_.contraCandidates?tFt(_):void 0;if(I||V){let H=I&&(!V||!(I.flags&131072)&&Pt(_.contraCandidates,X=>OS(I,X))&&wi(r.inferences,X=>X!==_&&mf(X.typeParameter)!==_.typeParameter||wi(X.candidates,_e=>OS(_e,I))));h=H?I:V,T=H?V:I}else if(r.flags&1)h=In;else{let H=H2(_.typeParameter);H&&(h=os(H,w7t(D7t(r,a),r.nonFixingMapper)))}}else h=sHe(_);_.inferredType=h||g2e(!!(r.flags&2));let C=mf(_.typeParameter);if(C){let I=os(C,r.nonFixingMapper);(!h||!r.compareTypes(h,bp(I,h)))&&(_.inferredType=T&&r.compareTypes(T,bp(I,T))?T:I)}}return _.inferredType}function g2e(r){return r?Me:Rt}function h2e(r){let a=[];for(let _=0;_<r.inferences.length;_++)a.push(m2e(r,_));return a}function _He(r){switch(r.escapedText){case"document":case"console":return v.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom;case"$":return q.types?v.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig:v.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery;case"describe":case"suite":case"it":case"test":return q.types?v.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig:v.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha;case"process":case"require":case"Buffer":case"module":return q.types?v.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig:v.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode;case"Bun":return q.types?v.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun_and_then_add_bun_to_the_types_field_in_your_tsconfig:v.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun;case"Map":case"Set":case"Promise":case"Symbol":case"WeakMap":case"WeakSet":case"Iterator":case"AsyncIterator":case"SharedArrayBuffer":case"Atomics":case"AsyncIterable":case"AsyncIterableIterator":case"AsyncGenerator":case"AsyncGeneratorFunction":case"BigInt":case"Reflect":case"BigInt64Array":case"BigUint64Array":return v.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_1_or_later;case"await":if(ea(r.parent))return v.Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function;default:return r.parent.kind===304?v.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer:v.Cannot_find_name_0}}function gf(r){let a=qn(r);return a.resolvedSymbol||(a.resolvedSymbol=!$c(r)&&xr(r,r,1160127,_He(r),!B9(r),!1)||St),a.resolvedSymbol}function y2e(r){return!!(r.flags&33554432||Pr(r,a=>Yu(a)||im(a)||lf(a)))}function VJ(r,a,_,h){switch(r.kind){case 80:if(!aE(r)){let I=gf(r);return I!==St?`${h?yo(h):"-1"}|${Lu(a)}|${Lu(_)}|${Aa(I)}`:void 0}case 110:return`0|${h?yo(h):"-1"}|${Lu(a)}|${Lu(_)}`;case 235:case 217:return VJ(r.expression,a,_,h);case 166:let T=VJ(r.left,a,_,h);return T&&`${T}.${r.right.escapedText}`;case 211:case 212:let C=rC(r);if(C!==void 0){let I=VJ(r.expression,a,_,h);return I&&`${I}.${C}`}if(cc(r)&&He(r.argumentExpression)){let I=gf(r.argumentExpression);if(Xk(I)||$7(I)&&!KJ(I)){let V=VJ(r.expression,a,_,h);return V&&`${V}.@${Aa(I)}`}}break;case 206:case 207:case 262:case 218:case 219:case 174:return`${yo(r)}#${Lu(a)}`}}function Fu(r,a){switch(a.kind){case 217:case 235:return Fu(r,a.expression);case 226:return Su(a)&&Fu(r,a.left)||Pn(a)&&a.operatorToken.kind===28&&Fu(r,a.right)}switch(r.kind){case 236:return a.kind===236&&r.keywordToken===a.keywordToken&&r.name.escapedText===a.name.escapedText;case 80:case 81:return aE(r)?a.kind===110:a.kind===80&&gf(r)===gf(a)||(Ei(a)||Xa(a))&&Mp(gf(r))===jn(a);case 110:return a.kind===110;case 108:return a.kind===108;case 235:case 217:return Fu(r.expression,a);case 211:case 212:let _=rC(r);if(_!==void 0){let h=oc(a)?rC(a):void 0;if(h!==void 0)return h===_&&Fu(r.expression,a.expression)}if(cc(r)&&cc(a)&&He(r.argumentExpression)&&He(a.argumentExpression)){let h=gf(r.argumentExpression);if(h===gf(a.argumentExpression)&&(Xk(h)||$7(h)&&!KJ(h)))return Fu(r.expression,a.expression)}break;case 166:return oc(a)&&r.right.escapedText===rC(a)&&Fu(r.left,a.expression);case 226:return Pn(r)&&r.operatorToken.kind===28&&Fu(r.right,a)}return!1}function rC(r){if(Wn(r))return r.name.escapedText;if(cc(r))return nFt(r);if(Xa(r)){let a=Rr(r);return a?Uc(a):void 0}if(ns(r))return""+r.parent.parameters.indexOf(r)}function v2e(r){return r.flags&8192?r.escapedName:r.flags&384?Uc(""+r.value):void 0}function nFt(r){return zp(r.argumentExpression)?Uc(r.argumentExpression.text):nc(r.argumentExpression)?iFt(r.argumentExpression):void 0}function iFt(r){let a=nl(r,111551,!0);if(!a||!(Xk(a)||a.flags&8))return;let _=a.valueDeclaration;if(_===void 0)return;let h=fn(_);if(h){let T=v2e(h);if(T!==void 0)return T}if(Hx(_)&&Fm(_,r)){let T=dR(_);if(T){let C=Hs(_.parent)?Xi(_):t_(T);return C&&v2e(C)}if(nS(_))return tA(_.name)}}function fHe(r,a){for(;oc(r);)if(r=r.expression,Fu(r,a))return!0;return!1}function nC(r,a){for(;S_(r);)if(r=r.expression,Fu(r,a))return!0;return!1}function o4(r,a){if(r&&r.flags&1048576){let _=fWe(r,a);if(_&&ll(_)&2)return _.links.isDiscriminantProperty===void 0&&(_.links.isDiscriminantProperty=(_.links.checkFlags&192)===192&&!Wk(gn(_))),!!_.links.isDiscriminantProperty}return!1}function pHe(r,a){let _;for(let h of r)if(o4(a,h.escapedName)){if(_){_.push(h);continue}_=[h]}return _}function sFt(r,a){let _=new Map,h=0;for(let T of r)if(T.flags&61603840){let C=il(T,a);if(C){if(!j7(C))return;let I=!1;sC(C,V=>{let H=Lu(Q_(V)),X=_.get(H);X?X!==Rt&&(_.set(H,Rt),I=!0):_.set(H,T)}),I||h++}}return h>=10&&h*2>=r.length?_:void 0}function JJ(r){let a=r.types;if(!(a.length<10||Kn(r)&32768||vy(a,_=>!!(_.flags&59506688))<10)){if(r.keyPropertyName===void 0){let _=kt(a,T=>T.flags&59506688?kt(bo(T),C=>Tg(gn(C))?C.escapedName:void 0):void 0),h=_&&sFt(a,_);r.keyPropertyName=h?_:"",r.constituentMap=h}return r.keyPropertyName.length?r.keyPropertyName:void 0}}function qJ(r,a){var _;let h=(_=r.constituentMap)==null?void 0:_.get(Lu(Q_(a)));return h!==Rt?h:void 0}function dHe(r,a){let _=JJ(r),h=_&&il(a,_);return h&&qJ(r,h)}function aFt(r,a){let _=JJ(r),h=_&&Ln(a.properties,C=>C.symbol&&C.kind===303&&C.symbol.escapedName===_&&ZJ(C.initializer)),T=h&&Sq(h.initializer);return T&&qJ(r,T)}function mHe(r,a){return Fu(r,a)||fHe(r,a)}function gHe(r,a){if(r.arguments){for(let _ of r.arguments)if(mHe(a,_)||nC(_,a))return!0}return!!(r.expression.kind===211&&mHe(a,r.expression.expression))}function S2e(r){return r.id<=0&&(r.id=YRe,YRe++),r.id}function oFt(r,a){if(!(r.flags&1048576))return ga(r,a);for(let _ of r.types)if(ga(_,a))return!0;return!1}function cFt(r,a){if(r===a)return r;if(a.flags&131072)return a;let _=`A${Lu(r)},${Lu(a)}`;return $b(_)??Xv(_,lFt(r,a))}function lFt(r,a){let _=Fl(r,T=>oFt(a,T)),h=a.flags&512&&ix(a)?wc(_,Hk):_;return ga(a,h)?h:r}function b2e(r){let a=Sg(r);return!!(a.callSignatures.length||a.constructSignatures.length||a.members.get("bind")&&OS(r,$l))}function GD(r,a){return T2e(r,a)&a}function Eg(r,a){return GD(r,a)!==0}function T2e(r,a){r.flags&467927040&&(r=Zu(r)||Rt);let _=r.flags;if(_&268435460)return ce?16317953:16776705;if(_&134217856){let h=_&128&&r.value==="";return ce?h?12123649:7929345:h?12582401:16776705}if(_&40)return ce?16317698:16776450;if(_&256){let h=r.value===0;return ce?h?12123394:7929090:h?12582146:16776450}if(_&64)return ce?16317188:16775940;if(_&2048){let h=X$e(r);return ce?h?12122884:7928580:h?12581636:16775940}return _&16?ce?16316168:16774920:_&528?ce?r===It||r===$t?12121864:7927560:r===It||r===$t?12580616:16774920:_&524288?a&(ce?83427327:83886079)?Kn(r)&16&&Z0(r)?ce?83427327:83886079:b2e(r)?ce?7880640:16728e3:ce?7888800:16736160:0:_&16384?9830144:_&32768?26607360:_&65536?42917664:_&12288?ce?7925520:16772880:_&67108864?ce?7888800:16736160:_&131072?0:_&1048576?L_(r.types,(h,T)=>h|T2e(T,a),0):_&2097152?uFt(r,a):83886079}function uFt(r,a){let _=dl(r,402784252),h=0,T=134217727;for(let C of r.types)if(!(_&&C.flags&524288)){let I=T2e(C,a);h|=I,T&=I}return h&8256|T&134209471}function hm(r,a){return Fl(r,_=>Eg(_,a))}function iC(r,a){let _=yHe(hm(ce&&r.flags&2?Xu:r,a));if(ce)switch(a){case 524288:return hHe(_,65536,131072,33554432,Ke);case 1048576:return hHe(_,131072,65536,16777216,nr);case 2097152:case 4194304:return wc(_,h=>Eg(h,262144)?PLt(h):h)}return _}function hHe(r,a,_,h,T){let C=GD(r,50528256);if(!(C&a))return r;let I=fi([zi,T]);return wc(r,V=>Eg(V,a)?Da([V,!(C&h)&&Eg(V,_)?I:zi]):V)}function yHe(r){return r===Xu?Rt:r}function E2e(r,a){return a?fi([Le(r),t_(a)]):r}function vHe(r,a){var _;let h=d1(a);if(!tm(h))return Oe;let T=rm(h);return il(r,T)||z7((_=Vk(r,T))==null?void 0:_.type)||Oe}function SHe(r,a){return Zf(r,s4)&&$$e(r,a)||z7(y1(65,r,nr,void 0))||Oe}function z7(r){return r&&(q.noUncheckedIndexedAccess?fi([r,Ge]):r)}function bHe(r){return g_(y1(65,r,nr,void 0)||Oe)}function _Ft(r){return r.parent.kind===209&&x2e(r.parent)||r.parent.kind===303&&x2e(r.parent.parent)?E2e(zJ(r),r.right):t_(r.right)}function x2e(r){return r.parent.kind===226&&r.parent.left===r||r.parent.kind===250&&r.parent.initializer===r}function fFt(r,a){return SHe(zJ(r),r.elements.indexOf(a))}function pFt(r){return bHe(zJ(r.parent))}function THe(r){return vHe(zJ(r.parent),r.name)}function dFt(r){return E2e(THe(r),r.objectAssignmentInitializer)}function zJ(r){let{parent:a}=r;switch(a.kind){case 249:return Ue;case 250:return Aq(a)||Oe;case 226:return _Ft(a);case 220:return nr;case 209:return fFt(a,r);case 230:return pFt(a);case 303:return THe(a);case 304:return dFt(a)}return Oe}function mFt(r){let a=r.parent,_=xHe(a.parent),h=a.kind===206?vHe(_,r.propertyName||r.name):r.dotDotDotToken?bHe(_):SHe(_,a.elements.indexOf(r));return E2e(h,r.initializer)}function EHe(r){return qn(r).resolvedType||t_(r)}function gFt(r){return r.initializer?EHe(r.initializer):r.parent.parent.kind===249?Ue:r.parent.parent.kind===250&&Aq(r.parent.parent)||Oe}function xHe(r){return r.kind===260?gFt(r):mFt(r)}function hFt(r){return r.kind===260&&r.initializer&&zo(r.initializer)||r.kind!==208&&r.parent.kind===226&&zo(r.parent.right)}function ox(r){switch(r.kind){case 217:return ox(r.expression);case 226:switch(r.operatorToken.kind){case 64:case 76:case 77:case 78:return ox(r.left);case 28:return ox(r.right)}}return r}function CHe(r){let{parent:a}=r;return a.kind===217||a.kind===226&&a.operatorToken.kind===64&&a.left===r||a.kind===226&&a.operatorToken.kind===28&&a.right===r?CHe(a):r}function yFt(r){return r.kind===296?Q_(t_(r.expression)):Ar}function Pre(r){let a=qn(r);if(!a.switchTypes){a.switchTypes=[];for(let _ of r.caseBlock.clauses)a.switchTypes.push(yFt(_))}return a.switchTypes}function AHe(r){if(Pt(r.caseBlock.clauses,_=>_.kind===296&&!No(_.expression)))return;let a=[];for(let _ of r.caseBlock.clauses){let h=_.kind===296?_.expression.text:void 0;a.push(h&&!Es(a,h)?h:void 0)}return a}function vFt(r,a){return r.flags&1048576?!kt(r.types,_=>!Es(a,_)):Es(a,r)}function c4(r,a){return!!(r===a||r.flags&131072||a.flags&1048576&&SFt(r,a))}function SFt(r,a){if(r.flags&1048576){for(let _ of r.types)if(!p1(a.types,_))return!1;return!0}return r.flags&1056&&jk(r)===a?!0:p1(a.types,r)}function sC(r,a){return r.flags&1048576?kt(r.types,a):a(r)}function ym(r,a){return r.flags&1048576?Pt(r.types,a):a(r)}function Zf(r,a){return r.flags&1048576?wi(r.types,a):a(r)}function bFt(r,a){return r.flags&3145728?wi(r.types,a):a(r)}function Fl(r,a){if(r.flags&1048576){let _=r.types,h=Zn(_,a);if(h===_)return r;let T=r.origin,C;if(T&&T.flags&1048576){let I=T.types,V=Zn(I,H=>!!(H.flags&1048576)||a(H));if(I.length-V.length===_.length-h.length){if(V.length===1)return V[0];C=Exe(1048576,V)}}return Cxe(h,r.objectFlags&16809984,void 0,void 0,C)}return r.flags&131072||a(r)?r:Ar}function Nre(r,a){return Fl(r,_=>_!==a)}function TFt(r){return r.flags&1048576?r.types.length:1}function wc(r,a,_){if(r.flags&131072)return r;if(!(r.flags&1048576))return a(r);let h=r.origin,T=h&&h.flags&1048576?h.types:r.types,C,I=!1;for(let V of T){let H=V.flags&1048576?wc(V,a,_):a(V);I||(I=V!==H),H&&(C?C.push(H):C=[H])}return I?C&&fi(C,_?0:1):r}function kHe(r,a,_,h){return r.flags&1048576&&_?fi(Cr(r.types,a),1,_,h):wc(r,a)}function l4(r,a){return Fl(r,_=>(_.flags&a)!==0)}function PHe(r,a){return dl(r,134217804)&&dl(a,402655616)?wc(r,_=>_.flags&4?l4(a,402653316):K2(_)&&!dl(a,402653188)?l4(a,128):_.flags&8?l4(a,264):_.flags&64?l4(a,2112):_):r}function YD(r){return r.flags===0}function aC(r){return r.flags===0?r.type:r}function KD(r,a){return a?{flags:0,type:r.flags&131072?In:r}:r}function EFt(r){let a=Lp(256);return a.elementType=r,a}function C2e(r){return yr[r.id]||(yr[r.id]=EFt(r))}function NHe(r,a){let _=V7(ev(Sq(a)));return c4(_,r.elementType)?r:C2e(fi([r.elementType,_]))}function xFt(r){return r.flags&131072?Fo:g_(r.flags&1048576?fi(r.types,2):r)}function CFt(r){return r.finalArrayType||(r.finalArrayType=xFt(r.elementType))}function WJ(r){return Kn(r)&256?CFt(r):r}function AFt(r){return Kn(r)&256?r.elementType:Ar}function kFt(r){let a=!1;for(let _ of r)if(!(_.flags&131072)){if(!(Kn(_)&256))return!1;a=!0}return a}function DHe(r){let a=CHe(r),_=a.parent,h=Wn(_)&&(_.name.escapedText==="length"||_.parent.kind===213&&He(_.name)&&LH(_.name)),T=_.kind===212&&_.expression===a&&_.parent.kind===226&&_.parent.operatorToken.kind===64&&_.parent.left===_&&!kv(_.parent)&&e_(t_(_.argumentExpression),296);return h||T}function PFt(r){return(Ei(r)||Ns(r)||Nf(r)||ns(r))&&!!(Vl(r)||hn(r)&&bv(r)&&r.initializer&&K1(r.initializer)&&lp(r.initializer))}function Dre(r,a){if(r=pl(r),r.flags&8752)return gn(r);if(r.flags&7){if(ll(r)&262144){let h=r.links.syntheticOrigin;if(h&&Dre(h))return gn(r)}let _=r.valueDeclaration;if(_){if(PFt(_))return gn(r);if(Ei(_)&&_.parent.parent.kind===250){let h=_.parent.parent,T=$J(h.expression,void 0);if(T){let C=h.awaitModifier?15:13;return y1(C,T,nr,void 0)}}a&&ca(a,pn(_,v._0_needs_an_explicit_type_annotation,rs(r)))}}}function $J(r,a){if(!(r.flags&67108864))switch(r.kind){case 80:let _=Mp(gf(r));return Dre(_,a);case 110:return YFt(r);case 108:return Lre(r);case 211:{let h=$J(r.expression,a);if(h){let T=r.name,C;if(Zi(T)){if(!h.symbol)return;C=ma(h,DR(h.symbol,T.escapedText))}else C=ma(h,T.escapedText);return C&&Dre(C,a)}return}case 217:return $J(r.expression,a)}}function HJ(r){let a=qn(r),_=a.effectsSignature;if(_===void 0){let h;if(Pn(r)){let I=QD(r.right);h=xCe(I)}else r.parent.kind===244?h=$J(r.expression,void 0):r.expression.kind!==108&&(S_(r)?h=hh(B7(hs(r.expression),r.expression),r.expression):h=QD(r.expression));let T=Ys(h&&K_(h)||Rt,0),C=T.length===1&&!T[0].typeParameters?T[0]:Pt(T,wHe)?ew(r):void 0;_=a.effectsSignature=C&&wHe(C)?C:ae}return _===ae?void 0:_}function wHe(r){return!!(Bd(r)||r.declaration&&(VD(r.declaration)||Rt).flags&131072)}function NFt(r,a){if(r.kind===1||r.kind===3)return a.arguments[r.parameterIndex];let _=So(a.expression);return oc(_)?So(_.expression):void 0}function DFt(r){let a=Pr(r,U$),_=Ur(r),h=Bh(_,a.statements.pos);_o.add(bu(_,h.start,h.length,v.The_containing_function_or_module_body_is_too_large_for_control_flow_analysis))}function GJ(r){let a=wre(r,!1);return O0=r,pS=a,a}function YJ(r){let a=So(r,!0);return a.kind===97||a.kind===226&&(a.operatorToken.kind===56&&(YJ(a.left)||YJ(a.right))||a.operatorToken.kind===57&&YJ(a.left)&&YJ(a.right))}function wre(r,a){for(;;){if(r===O0)return pS;let _=r.flags;if(_&4096){if(!a){let h=S2e(r),T=mD[h];return T!==void 0?T:mD[h]=wre(r,!0)}a=!1}if(_&368)r=r.antecedent;else if(_&512){let h=HJ(r.node);if(h){let T=Bd(h);if(T&&T.kind===3&&!T.type){let C=r.node.arguments[T.parameterIndex];if(C&&YJ(C))return!1}if(ko(h).flags&131072)return!1}r=r.antecedent}else{if(_&4)return Pt(r.antecedent,h=>wre(h,!1));if(_&8){let h=r.antecedent;if(h===void 0||h.length===0)return!1;r=h[0]}else if(_&128){let h=r.node;if(h.clauseStart===h.clauseEnd&&yYe(h.switchStatement))return!1;r=r.antecedent}else if(_&1024){O0=void 0;let h=r.node.target,T=h.antecedent;h.antecedent=r.node.antecedents;let C=wre(r.antecedent,!1);return h.antecedent=T,C}else return!(_&1)}}}function Ire(r,a){for(;;){let _=r.flags;if(_&4096){if(!a){let h=S2e(r),T=bk[h];return T!==void 0?T:bk[h]=Ire(r,!0)}a=!1}if(_&496)r=r.antecedent;else if(_&512){if(r.node.expression.kind===108)return!0;r=r.antecedent}else{if(_&4)return wi(r.antecedent,h=>Ire(h,!1));if(_&8)r=r.antecedent[0];else if(_&1024){let h=r.node.target,T=h.antecedent;h.antecedent=r.node.antecedents;let C=Ire(r.antecedent,!1);return h.antecedent=T,C}else return!!(_&1)}}}function A2e(r){switch(r.kind){case 110:return!0;case 80:if(!aE(r)){let _=gf(r);return Xk(_)||$7(_)&&!KJ(_)||!!_.valueDeclaration&&ic(_.valueDeclaration)}break;case 211:case 212:return A2e(r.expression)&&Cg(qn(r).resolvedSymbol||St);case 206:case 207:let a=Bg(r.parent);return ns(a)||Rpe(a)?!k2e(a):Ei(a)&&_L(a)}return!1}function iv(r,a,_=a,h,T=(C=>(C=ai(r,ER))==null?void 0:C.flowNode)()){let C,I=!1,V=0;if(Rm)return Oe;if(!T)return a;Hv++;let H=$_,X=aC(Ne(T));$_=H;let _e=Kn(X)&256&&DHe(r)?Fo:WJ(X);if(_e===ls||r.parent&&r.parent.kind===235&&!(_e.flags&131072)&&hm(_e,2097152).flags&131072)return a;return _e;function we(){return I?C:(I=!0,C=VJ(r,a,_,h))}function Ne(zt){var Nr;if(V===2e3)return(Nr=Cn)==null||Nr.instant(Cn.Phase.CheckTypes,"getTypeAtFlowNode_DepthLimit",{flowId:zt.id}),Rm=!0,DFt(r),Oe;V++;let Wr;for(;;){let on=zt.flags;if(on&4096){for(let hi=H;hi<$_;hi++)if(_m[hi]===zt)return V--,Sk[hi];Wr=zt}let Bn;if(on&16){if(Bn=Tt(zt),!Bn){zt=zt.antecedent;continue}}else if(on&512){if(Bn=mr(zt),!Bn){zt=zt.antecedent;continue}}else if(on&96)Bn=en(zt);else if(on&128)Bn=Fn(zt);else if(on&12){if(zt.antecedent.length===1){zt=zt.antecedent[0];continue}Bn=on&4?Dr(zt):zr(zt)}else if(on&256){if(Bn=br(zt),!Bn){zt=zt.antecedent;continue}}else if(on&1024){let hi=zt.node.target,ka=hi.antecedent;hi.antecedent=zt.node.antecedents,Bn=Ne(zt.antecedent),hi.antecedent=ka}else if(on&2){let hi=zt.node;if(hi&&hi!==h&&r.kind!==211&&r.kind!==212&&!(r.kind===110&&hi.kind!==219)){zt=hi.flowNode;continue}Bn=_}else Bn=cL(a);return Wr&&(_m[$_]=Wr,Sk[$_]=Bn,$_++),V--,Bn}}function pt(zt){let Nr=zt.node;return P2e(Nr.kind===260||Nr.kind===208?xHe(Nr):zJ(Nr),r)}function Tt(zt){let Nr=zt.node;if(Fu(r,Nr)){if(!GJ(zt))return ls;if(fb(Nr)===2){let on=Ne(zt.antecedent);return KD(ev(aC(on)),YD(on))}if(a===tt||a===Fo){if(hFt(Nr))return C2e(Ar);let on=ST(pt(zt));return ga(on,a)?on:Uo}let Wr=PH(Nr)?ev(a):a;return Wr.flags&1048576?cFt(Wr,pt(zt)):Wr}if(fHe(r,Nr)){if(!GJ(zt))return ls;if(Ei(Nr)&&(hn(Nr)||_L(Nr))){let Wr=RI(Nr);if(Wr&&(Wr.kind===218||Wr.kind===219))return Ne(zt.antecedent)}return a}if(Ei(Nr)&&Nr.parent.parent.kind===249&&(Fu(r,Nr.parent.parent.expression)||nC(Nr.parent.parent.expression,r)))return G2e(WJ(aC(Ne(zt.antecedent))))}function Mt(zt,Nr){let Wr=So(Nr,!0);if(Wr.kind===97)return ls;if(Wr.kind===226){if(Wr.operatorToken.kind===56)return Mt(Mt(zt,Wr.left),Wr.right);if(Wr.operatorToken.kind===57)return fi([Mt(zt,Wr.left),Mt(zt,Wr.right)])}return y_(zt,Wr,!0)}function mr(zt){let Nr=HJ(zt.node);if(Nr){let Wr=Bd(Nr);if(Wr&&(Wr.kind===2||Wr.kind===3)){let on=Ne(zt.antecedent),Bn=WJ(aC(on)),hi=Wr.type?fL(Bn,Wr,zt.node,!0):Wr.kind===3&&Wr.parameterIndex>=0&&Wr.parameterIndex<zt.node.arguments.length?Mt(Bn,zt.node.arguments[Wr.parameterIndex]):Bn;return hi===Bn?on:KD(hi,YD(on))}if(ko(Nr).flags&131072)return ls}}function br(zt){if(a===tt||a===Fo){let Nr=zt.node,Wr=Nr.kind===213?Nr.expression.expression:Nr.left.expression;if(Fu(r,ox(Wr))){let on=Ne(zt.antecedent),Bn=aC(on);if(Kn(Bn)&256){let hi=Bn;if(Nr.kind===213)for(let ka of Nr.arguments)hi=NHe(hi,ka);else{let ka=Sq(Nr.left.argumentExpression);e_(ka,296)&&(hi=NHe(hi,Nr.right))}return hi===Bn?on:KD(hi,YD(on))}return on}}}function en(zt){let Nr=Ne(zt.antecedent),Wr=aC(Nr);if(Wr.flags&131072)return Nr;let on=(zt.flags&32)!==0,Bn=WJ(Wr),hi=y_(Bn,zt.node,on);return hi===Bn?Nr:KD(hi,YD(Nr))}function Fn(zt){let Nr=So(zt.node.switchStatement.expression),Wr=Ne(zt.antecedent),on=aC(Wr);if(Fu(r,Nr))on=go(on,zt.node);else if(Nr.kind===221&&Fu(r,Nr.expression))on=O_(on,zt.node);else if(Nr.kind===112)on=Mc(on,zt.node);else{ce&&(nC(Nr,r)?on=To(on,zt.node,hi=>!(hi.flags&163840)):Nr.kind===221&&nC(Nr.expression,r)&&(on=To(on,zt.node,hi=>!(hi.flags&131072||hi.flags&128&&hi.value==="undefined"))));let Bn=ii(Nr,on);Bn&&(on=Ks(on,Bn,zt.node))}return KD(on,YD(Wr))}function Dr(zt){let Nr=[],Wr=!1,on=!1,Bn;for(let hi of zt.antecedent){if(!Bn&&hi.flags&128&&hi.node.clauseStart===hi.node.clauseEnd){Bn=hi;continue}let ka=Ne(hi),Oa=aC(ka);if(Oa===a&&a===_)return Oa;ol(Nr,Oa),c4(Oa,_)||(Wr=!0),YD(ka)&&(on=!0)}if(Bn){let hi=Ne(Bn),ka=aC(hi);if(!(ka.flags&131072)&&!Es(Nr,ka)&&!yYe(Bn.node.switchStatement)){if(ka===a&&a===_)return ka;Nr.push(ka),c4(ka,_)||(Wr=!0),YD(hi)&&(on=!0)}}return KD(Qr(Nr,Wr?2:1),on)}function zr(zt){let Nr=S2e(zt),Wr=xu[Nr]||(xu[Nr]=new Map),on=we();if(!on)return a;let Bn=Wr.get(on);if(Bn)return Bn;for(let Ee=Vo;Ee<d_;Ee++)if(N_[Ee]===zt&&um[Ee]===on&&Gv[Ee].length)return KD(Qr(Gv[Ee],1),!0);let hi=[],ka=!1,Oa;for(let Ee of zt.antecedent){let ar;if(!Oa)ar=Oa=Ne(Ee);else{N_[d_]=zt,um[d_]=on,Gv[d_]=hi,d_++;let xn=cm;cm=void 0,ar=Ne(Ee),cm=xn,d_--;let bn=Wr.get(on);if(bn)return bn}let wr=aC(ar);if(ol(hi,wr),c4(wr,_)||(ka=!0),wr===a)break}let je=Qr(hi,ka?2:1);return YD(Oa)?KD(je,!0):(Wr.set(on,je),je)}function Qr(zt,Nr){if(kFt(zt))return C2e(fi(Cr(zt,AFt)));let Wr=yHe(fi(Fs(zt,WJ),Nr));return Wr!==a&&Wr.flags&a.flags&1048576&&UT(Wr.types,a.types)?a:Wr}function $n(zt){if(Hs(r)||K1(r)||Nm(r)){if(He(zt)){let Wr=gf(zt).valueDeclaration;if(Wr&&(Xa(Wr)||ns(Wr))&&r===Wr.parent&&!Wr.initializer&&!Wr.dotDotDotToken)return Wr}}else if(oc(zt)){if(Fu(r,zt.expression))return zt}else if(He(zt)){let Nr=gf(zt);if(Xk(Nr)){let Wr=Nr.valueDeclaration;if(Ei(Wr)&&!Wr.type&&Wr.initializer&&oc(Wr.initializer)&&Fu(r,Wr.initializer.expression))return Wr.initializer;if(Xa(Wr)&&!Wr.initializer){let on=Wr.parent.parent;if(Ei(on)&&!on.type&&on.initializer&&(He(on.initializer)||oc(on.initializer))&&Fu(r,on.initializer))return Wr}}}}function ii(zt,Nr){if(a.flags&1048576||Nr.flags&1048576){let Wr=$n(zt);if(Wr){let on=rC(Wr);if(on){let Bn=a.flags&1048576&&c4(Nr,a)?a:Nr;if(o4(Bn,on))return Wr}}}}function si(zt,Nr,Wr){let on=rC(Nr);if(on===void 0)return zt;let Bn=S_(Nr),hi=ce&&(Bn||Lpe(Nr))&&dl(zt,98304),ka=il(hi?hm(zt,2097152):zt,on);if(!ka)return zt;ka=hi&&Bn?LS(ka):ka;let Oa=Wr(ka);return Fl(zt,je=>{let Ee=G6(je,on)||Rt;return!(Ee.flags&131072)&&!(Oa.flags&131072)&&IJ(Oa,Ee)})}function Ea(zt,Nr,Wr,on,Bn){if((Wr===37||Wr===38)&&zt.flags&1048576){let hi=JJ(zt);if(hi&&hi===rC(Nr)){let ka=qJ(zt,t_(on));if(ka)return Wr===(Bn?37:38)?ka:Tg(il(ka,hi)||Rt)?Nre(zt,ka):zt}}return si(zt,Nr,hi=>$i(hi,Wr,on,Bn))}function Ks(zt,Nr,Wr){if(Wr.clauseStart<Wr.clauseEnd&&zt.flags&1048576&&JJ(zt)===rC(Nr)){let on=Pre(Wr.switchStatement).slice(Wr.clauseStart,Wr.clauseEnd),Bn=fi(Cr(on,hi=>qJ(zt,hi)||Rt));if(Bn!==Rt)return Bn}return si(zt,Nr,on=>go(on,Wr))}function no(zt,Nr,Wr){if(Fu(r,Nr))return iC(zt,Wr?4194304:8388608);ce&&Wr&&nC(Nr,r)&&(zt=iC(zt,2097152));let on=ii(Nr,zt);return on?si(zt,on,Bn=>hm(Bn,Wr?4194304:8388608)):zt}function Os(zt,Nr,Wr){let on=ma(zt,Nr);return on?!!(on.flags&16777216||ll(on)&48)||Wr:!!Vk(zt,Nr)||!Wr}function Rc(zt,Nr,Wr){let on=rm(Nr);if(ym(zt,hi=>Os(hi,on,!0)))return Fl(zt,hi=>Os(hi,on,Wr));if(Wr){let hi=OMt();if(hi)return Da([zt,qD(hi,[Nr,Rt])])}return zt}function r_(zt,Nr,Wr,on,Bn){return Bn=Bn!==(Wr.kind===112)!=(on!==38&&on!==36),y_(zt,Nr,Bn)}function sl(zt,Nr,Wr){switch(Nr.operatorToken.kind){case 64:case 76:case 77:case 78:return no(y_(zt,Nr.right,Wr),Nr.left,Wr);case 35:case 36:case 37:case 38:let on=Nr.operatorToken.kind,Bn=ox(Nr.left),hi=ox(Nr.right);if(Bn.kind===221&&No(hi))return Dn(zt,Bn,on,hi,Wr);if(hi.kind===221&&No(Bn))return Dn(zt,hi,on,Bn,Wr);if(Fu(r,Bn))return $i(zt,on,hi,Wr);if(Fu(r,hi))return $i(zt,on,Bn,Wr);ce&&(nC(Bn,r)?zt=rn(zt,on,hi,Wr):nC(hi,r)&&(zt=rn(zt,on,Bn,Wr)));let ka=ii(Bn,zt);if(ka)return Ea(zt,ka,on,hi,Wr);let Oa=ii(hi,zt);if(Oa)return Ea(zt,Oa,on,Bn,Wr);if(Lc(Bn))return gd(zt,on,hi,Wr);if(Lc(hi))return gd(zt,on,Bn,Wr);if(bI(hi)&&!oc(Bn))return r_(zt,Bn,hi,on,Wr);if(bI(Bn)&&!oc(hi))return r_(zt,hi,Bn,on,Wr);break;case 104:return ml(zt,Nr,Wr);case 103:if(Zi(Nr.left))return Jr(zt,Nr,Wr);let je=ox(Nr.right);if(U7(zt)&&oc(r)&&Fu(r.expression,je)){let Ee=t_(Nr.left);if(tm(Ee)&&rC(r)===rm(Ee))return hm(zt,Wr?524288:65536)}if(Fu(r,je)){let Ee=t_(Nr.left);if(tm(Ee))return Rc(zt,Ee,Wr)}break;case 28:return y_(zt,Nr.right,Wr);case 56:return Wr?y_(y_(zt,Nr.left,!0),Nr.right,!0):fi([y_(zt,Nr.left,!1),y_(zt,Nr.right,!1)]);case 57:return Wr?fi([y_(zt,Nr.left,!0),y_(zt,Nr.right,!0)]):y_(y_(zt,Nr.left,!1),Nr.right,!1)}return zt}function Jr(zt,Nr,Wr){let on=ox(Nr.right);if(!Fu(r,on))return zt;M.assertNode(Nr.left,Zi);let Bn=Hre(Nr.left);if(Bn===void 0)return zt;let hi=Bn.parent,ka=Jl(M.checkDefined(Bn.valueDeclaration,"should always have a declaration"))?gn(hi):ac(hi);return av(zt,ka,Wr,!0)}function rn(zt,Nr,Wr,on){let Bn=Nr===35||Nr===37,hi=Nr===35||Nr===36?98304:32768,ka=t_(Wr);return Bn!==on&&Zf(ka,je=>!!(je.flags&hi))||Bn===on&&Zf(ka,je=>!(je.flags&(3|hi)))?iC(zt,2097152):zt}function $i(zt,Nr,Wr,on){if(zt.flags&1)return zt;(Nr===36||Nr===38)&&(on=!on);let Bn=t_(Wr),hi=Nr===35||Nr===36;if(Bn.flags&98304){if(!ce)return zt;let ka=hi?on?262144:2097152:Bn.flags&65536?on?131072:1048576:on?65536:524288;return iC(zt,ka)}if(on){if(!hi&&(zt.flags&2||ym(zt,ly))){if(Bn.flags&469893116||ly(Bn))return Bn;if(Bn.flags&524288)return Yn}let ka=Fl(zt,Oa=>IJ(Oa,Bn)||hi&&NLt(Oa,Bn));return PHe(ka,Bn)}return Tg(Bn)?Fl(zt,ka=>!(H$e(ka)&&IJ(ka,Bn))):zt}function Dn(zt,Nr,Wr,on,Bn){(Wr===36||Wr===38)&&(Bn=!Bn);let hi=ox(Nr.expression);if(!Fu(r,hi)){ce&&nC(hi,r)&&Bn===(on.text!=="undefined")&&(zt=iC(zt,2097152));let ka=ii(hi,zt);return ka?si(zt,ka,Oa=>is(Oa,on,Bn)):zt}return is(zt,on,Bn)}function is(zt,Nr,Wr){return Wr?h_(zt,Nr.text):iC(zt,Mge.get(Nr.text)||32768)}function To(zt,{switchStatement:Nr,clauseStart:Wr,clauseEnd:on},Bn){return Wr!==on&&wi(Pre(Nr).slice(Wr,on),Bn)?hm(zt,2097152):zt}function go(zt,{switchStatement:Nr,clauseStart:Wr,clauseEnd:on}){let Bn=Pre(Nr);if(!Bn.length)return zt;let hi=Bn.slice(Wr,on),ka=Wr===on||Es(hi,Ar);if(zt.flags&2&&!ka){let ar;for(let wr=0;wr<hi.length;wr+=1){let xn=hi[wr];if(xn.flags&469893116)ar!==void 0&&ar.push(xn);else if(xn.flags&524288)ar===void 0&&(ar=hi.slice(0,wr)),ar.push(Yn);else return zt}return fi(ar===void 0?hi:ar)}let Oa=fi(hi),je=Oa.flags&131072?Ar:PHe(Fl(zt,ar=>IJ(Oa,ar)),Oa);if(!ka)return je;let Ee=Fl(zt,ar=>!(H$e(ar)&&Es(Bn,ar.flags&32768?nr:Q_(bLt(ar)))));return je.flags&131072?Ee:fi([je,Ee])}function h_(zt,Nr){switch(Nr){case"string":return ha(zt,Ue,1);case"number":return ha(zt,Te,2);case"bigint":return ha(zt,Re,4);case"boolean":return ha(zt,qr,8);case"symbol":return ha(zt,Hr,16);case"object":return zt.flags&1?zt:fi([ha(zt,Yn,32),ha(zt,Ke,131072)]);case"function":return zt.flags&1?zt:ha(zt,$l,64);case"undefined":return ha(zt,nr,65536)}return ha(zt,Yn,128)}function ha(zt,Nr,Wr){return wc(zt,on=>mh(on,Nr,Rd)?Eg(on,Wr)?on:Ar:OS(Nr,on)?Nr:Eg(on,Wr)?Da([on,Nr]):Ar)}function O_(zt,{switchStatement:Nr,clauseStart:Wr,clauseEnd:on}){let Bn=AHe(Nr);if(!Bn)return zt;let hi=Bo(Nr.caseBlock.clauses,je=>je.kind===297);if(Wr===on||hi>=Wr&&hi<on){let je=hYe(Wr,on,Bn);return Fl(zt,Ee=>GD(Ee,je)===je)}let Oa=Bn.slice(Wr,on);return fi(Cr(Oa,je=>je?h_(zt,je):Ar))}function Mc(zt,{switchStatement:Nr,clauseStart:Wr,clauseEnd:on}){let Bn=Bo(Nr.caseBlock.clauses,Oa=>Oa.kind===297),hi=Wr===on||Bn>=Wr&&Bn<on;for(let Oa=0;Oa<Wr;Oa++){let je=Nr.caseBlock.clauses[Oa];je.kind===296&&(zt=y_(zt,je.expression,!1))}if(hi){for(let Oa=on;Oa<Nr.caseBlock.clauses.length;Oa++){let je=Nr.caseBlock.clauses[Oa];je.kind===296&&(zt=y_(zt,je.expression,!1))}return zt}let ka=Nr.caseBlock.clauses.slice(Wr,on);return fi(Cr(ka,Oa=>Oa.kind===296?y_(zt,Oa.expression,!0):Ar))}function Lc(zt){return(Wn(zt)&&Nn(zt.name)==="constructor"||cc(zt)&&No(zt.argumentExpression)&&zt.argumentExpression.text==="constructor")&&Fu(r,zt.expression)}function gd(zt,Nr,Wr,on){if(on?Nr!==35&&Nr!==37:Nr!==36&&Nr!==38)return zt;let Bn=t_(Wr);if(!rAe(Bn)&&!b7(Bn))return zt;let hi=ma(Bn,"prototype");if(!hi)return zt;let ka=gn(hi),Oa=Ao(ka)?void 0:ka;if(!Oa||Oa===rl||Oa===$l)return zt;if(Ao(zt))return Oa;return Fl(zt,Ee=>je(Ee,Oa));function je(Ee,ar){return Ee.flags&524288&&Kn(Ee)&1||ar.flags&524288&&Kn(ar)&1?Ee.symbol===ar.symbol:OS(Ee,ar)}}function ml(zt,Nr,Wr){let on=ox(Nr.left);if(!Fu(r,on))return Wr&&ce&&nC(on,r)?iC(zt,2097152):zt;let Bn=Nr.right,hi=t_(Bn);if(!yT(hi,rl))return zt;let ka=HJ(Nr),Oa=ka&&Bd(ka);if(Oa&&Oa.kind===1&&Oa.parameterIndex===0)return av(zt,Oa.type,Wr,!0);if(!yT(hi,$l))return zt;let je=wc(hi,jl);return Ao(zt)&&(je===rl||je===$l)||!Wr&&!(je.flags&524288&&!ly(je))?zt:av(zt,je,Wr,!0)}function jl(zt){let Nr=il(zt,"prototype");if(Nr&&!Ao(Nr))return Nr;let Wr=Ys(zt,1);return Wr.length?fi(Cr(Wr,on=>ko(k7(on)))):zi}function av(zt,Nr,Wr,on){let Bn=zt.flags&1048576?`N${Lu(zt)},${Lu(Nr)},${(Wr?1:0)|(on?2:0)}`:void 0;return $b(Bn)??Xv(Bn,sw(zt,Nr,Wr,on))}function sw(zt,Nr,Wr,on){if(!Wr){if(zt===Nr)return Ar;if(on)return Fl(zt,je=>!yT(je,Nr));let Oa=av(zt,Nr,!0,!1);return Fl(zt,je=>!c4(je,Oa))}if(zt.flags&3||zt===Nr)return Nr;let Bn=on?yT:OS,hi=zt.flags&1048576?JJ(zt):void 0,ka=wc(Nr,Oa=>{let je=hi&&il(Oa,hi),Ee=je&&qJ(zt,je),ar=wc(Ee||zt,on?wr=>yT(wr,Oa)?wr:yT(Oa,wr)?Oa:Ar:wr=>wJ(wr,Oa)?wr:wJ(Oa,wr)?Oa:OS(wr,Oa)?wr:OS(Oa,wr)?Oa:Ar);return ar.flags&131072?wc(zt,wr=>dl(wr,465829888)&&Bn(Oa,Zu(wr)||Rt)?Da([wr,Oa]):Ar):ar});return ka.flags&131072?OS(Nr,zt)?Nr:ga(zt,Nr)?zt:ga(Nr,zt)?Nr:Da([zt,Nr]):ka}function b4(zt,Nr,Wr){if(gHe(Nr,r)){let on=Wr||!qx(Nr)?HJ(Nr):void 0,Bn=on&&Bd(on);if(Bn&&(Bn.kind===0||Bn.kind===1))return fL(zt,Bn,Nr,Wr)}if(U7(zt)&&oc(r)&&Wn(Nr.expression)){let on=Nr.expression;if(Fu(r.expression,ox(on.expression))&&He(on.name)&&on.name.escapedText==="hasOwnProperty"&&Nr.arguments.length===1){let Bn=Nr.arguments[0];if(No(Bn)&&rC(r)===Uc(Bn.text))return hm(zt,Wr?524288:65536)}}return zt}function fL(zt,Nr,Wr,on){if(Nr.type&&!(Ao(zt)&&(Nr.type===rl||Nr.type===$l))){let Bn=NFt(Nr,Wr);if(Bn){if(Fu(r,Bn))return av(zt,Nr.type,on,!1);ce&&nC(Bn,r)&&(on&&!Eg(Nr.type,65536)||!on&&Zf(Nr.type,iq))&&(zt=iC(zt,2097152));let hi=ii(Bn,zt);if(hi)return si(zt,hi,ka=>av(ka,Nr.type,on,!1))}}return zt}function y_(zt,Nr,Wr){if(k5(Nr)||Pn(Nr.parent)&&(Nr.parent.operatorToken.kind===61||Nr.parent.operatorToken.kind===78)&&Nr.parent.left===Nr)return Oq(zt,Nr,Wr);switch(Nr.kind){case 80:if(!Fu(r,Nr)&&w<5){let on=gf(Nr);if(Xk(on)){let Bn=on.valueDeclaration;if(Bn&&Ei(Bn)&&!Bn.type&&Bn.initializer&&A2e(r)){w++;let hi=y_(zt,Bn.initializer,Wr);return w--,hi}}}case 110:case 108:case 211:case 212:return no(zt,Nr,Wr);case 213:return b4(zt,Nr,Wr);case 217:case 235:return y_(zt,Nr.expression,Wr);case 226:return sl(zt,Nr,Wr);case 224:if(Nr.operator===54)return y_(zt,Nr.operand,!Wr);break}return zt}function Oq(zt,Nr,Wr){if(Fu(r,Nr))return iC(zt,Wr?2097152:262144);let on=ii(Nr,zt);return on?si(zt,on,Bn=>hm(Bn,Wr?2097152:262144)):zt}}function wFt(r,a){if(r=Mp(r),(a.kind===80||a.kind===81)&&(YI(a)&&(a=a.parent),tg(a)&&(!kv(a)||mA(a)))){let _=yre(mA(a)&&a.kind===211?$re(a,void 0,!0):t_(a));if(Mp(qn(a).resolvedSymbol)===r)return _}return Uh(a)&&Og(a.parent)&&qm(a.parent)?wte(a.parent.symbol):tG(a)&&mA(a.parent)?_T(r):CS(r)}function W7(r){return Pr(r.parent,a=>Bs(a)&&!QT(a)||a.kind===268||a.kind===307||a.kind===172)}function KJ(r){return!IHe(r,void 0)}function IHe(r,a){let _=Pr(r.valueDeclaration,Ore);if(!_)return!1;let h=qn(_);return h.flags&131072||(h.flags|=131072,IFt(_)||RHe(_)),!r.lastAssignmentPos||a&&r.lastAssignmentPos<a.pos}function k2e(r){return M.assert(Ei(r)||ns(r)),OHe(r.name)}function OHe(r){return r.kind===80?KJ(jn(r.parent)):Pt(r.elements,a=>a.kind!==232&&OHe(a.name))}function IFt(r){return!!Pr(r.parent,a=>Ore(a)&&!!(qn(a).flags&131072))}function Ore(r){return Go(r)||Ji(r)}function RHe(r){switch(r.kind){case 80:if(kv(r)){let _=gf(r);if($7(_)&&_.lastAssignmentPos!==Number.MAX_VALUE){let h=Pr(r,Ore),T=Pr(_.valueDeclaration,Ore);_.lastAssignmentPos=h===T?OFt(r,_.valueDeclaration):Number.MAX_VALUE}}return;case 281:let a=r.parent.parent;if(!r.isTypeOnly&&!a.isTypeOnly&&!a.moduleSpecifier){let _=nl(r.propertyName||r.name,111551,!0,!0);_&&$7(_)&&(_.lastAssignmentPos=Number.MAX_VALUE)}return;case 264:case 265:case 266:return}Di(r)||Js(r,RHe)}function OFt(r,a){let _=r.pos;for(;r&&r.pos>a.pos;){switch(r.kind){case 243:case 244:case 245:case 246:case 247:case 248:case 249:case 250:case 254:case 255:case 258:case 263:_=r.end}r=r.parent}return _}function Xk(r){return r.flags&3&&(W2e(r)&6)!==0}function $7(r){let a=r.valueDeclaration&&Bg(r.valueDeclaration);return!!a&&(ns(a)||Ei(a)&&(bE(a.parent)||RFt(a)))}function RFt(r){return!!(r.parent.flags&1)&&!(eb(r)&32||r.parent.parent.kind===243&&Tv(r.parent.parent.parent))}function MFt(r){let a=qn(r);if(a.parameterInitializerContainsUndefined===void 0){if(!dm(r,8))return c1(r.symbol),!0;let _=!!Eg(f4(r,0),16777216);if(!ry())return c1(r.symbol),!0;a.parameterInitializerContainsUndefined??(a.parameterInitializerContainsUndefined=_)}return a.parameterInitializerContainsUndefined}function LFt(r,a){return ce&&a.kind===169&&a.initializer&&Eg(r,16777216)&&!MFt(a)?hm(r,524288):r}function FFt(r,a){let _=a.parent;return _.kind===211||_.kind===166||_.kind===213&&_.expression===a||_.kind===214&&_.expression===a||_.kind===212&&_.expression===a&&!(ym(r,LHe)&&Q2(t_(_.argumentExpression)))}function MHe(r){return r.flags&2097152?Pt(r.types,MHe):!!(r.flags&465829888&&ay(r).flags&1146880)}function LHe(r){return r.flags&2097152?Pt(r.types,LHe):!!(r.flags&465829888&&!dl(ay(r),98304))}function jFt(r,a){let _=(He(r)||Wn(r)||cc(r))&&!((Yg(r.parent)||u2(r.parent))&&r.parent.tagName===r)&&(a&&a&32?hf(r,8):hf(r,void 0));return _&&!Wk(_)}function P2e(r,a,_){return zD(r)&&(r=r.baseType),!(_&&_&2)&&ym(r,MHe)&&(FFt(r,a)||jFt(a,_))?wc(r,ay):r}function FHe(r){return!!Pr(r,a=>{let _=a.parent;return _===void 0?"quit":dc(_)?_.expression===a&&nc(a):b_(_)?_.name===a||_.propertyName===a:!1})}function Qk(r,a,_,h){if(_t&&!(r.flags&33554432&&!Nf(r)&&!Ns(r)))switch(a){case 1:return Rre(r);case 2:return jHe(r,_,h);case 3:return BHe(r);case 4:return N2e(r);case 5:return UHe(r);case 6:return VHe(r);case 7:return JHe(r);case 8:return qHe(r);case 0:{if(He(r)&&(tg(r)||p_(r.parent)||ru(r.parent)&&r.parent.moduleReference===r)&&HHe(r)){if(J3(r.parent)&&(Wn(r.parent)?r.parent.expression:r.parent.left)!==r)return;Rre(r);return}if(J3(r)){let T=r;for(;J3(T);){if(Lg(T))return;T=T.parent}return jHe(r)}return dc(r)?BHe(r):__(r)||_2(r)?N2e(r):ru(r)?nA(r)||vne(r)?VHe(r):void 0:b_(r)?JHe(r):((Go(r)||$g(r))&&UHe(r),!q.emitDecoratorMetadata||!TE(r)||!Wp(r)||!r.modifiers||!cR(pe,r,r.parent,r.parent.parent)?void 0:qHe(r))}default:M.assertNever(a,`Unhandled reference hint: ${a}`)}}function Rre(r){let a=gf(r);a&&a!==qe&&a!==St&&!aE(r)&&XJ(a,r)}function jHe(r,a,_){let h=Wn(r)?r.expression:r.left;if(z1(h)||!He(h))return;let T=gf(h);if(!T||T===St)return;if(Cd(q)||lE(q)&&FHe(r)){XJ(T,r);return}let C=_||yl(h);if(Ao(C)||C===In){XJ(T,r);return}let I=a;if(!I&&!_){let V=Wn(r)?r.name:r.right,H=Zi(V)&&sq(V.escapedText,V),X=fb(r),_e=K_(X!==0||Y2e(r)?Qf(C):C);I=Zi(V)?H&&Gre(_e,H)||void 0:ma(_e,V.escapedText)}I&&(lL(I)||I.flags&8&&r.parent.kind===306)||XJ(T,r)}function BHe(r){if(He(r.expression)){let a=r.expression,_=Mp(nl(a,-1,!0,!0,r));_&&XJ(_,a)}}function N2e(r){if(!q2e(r)){let a=_o&&q.jsx===2?v.Cannot_find_name_0:void 0,_=Hb(r),h=__(r)?r.tagName:r,T;if(_2(r)&&_==="null"||(T=xr(h,_,111551,a,!0)),T&&(T.isReferenced=-1,_t&&T.flags&2097152&&!lh(T)&&Mre(T)),_2(r)){let C=Ur(r),I=xk(C);I&&xr(h,I,111551,a,!0)}}}function UHe(r){if(ee<2&&Rl(r)&2){let a=lp(r);BFt(a)}}function VHe(r){li(r,32)&&zHe(r)}function JHe(r){if(!r.parent.parent.moduleSpecifier&&!r.isTypeOnly&&!r.parent.parent.isTypeOnly){let a=r.propertyName||r.name,_=xr(a,a.escapedText,2998271,void 0,!0);if(!(_&&(_===Be||_===ct||_.declarations&&Tv(z2(_.declarations[0]))))){let h=_&&(_.flags&2097152?Au(_):_);(!h||Gf(h)&111551)&&(zHe(r),Rre(r.propertyName||r.name))}return}}function qHe(r){if(q.emitDecoratorMetadata){let a=Ln(r.modifiers,fu);if(!a)return;switch(gu(a,16),r.kind){case 263:let _=Ny(r);if(_)for(let I of _.parameters)XD(pne(I));break;case 177:case 178:let h=r.kind===177?178:177,T=Pc(jn(r),h);XD(qm(r)||T&&qm(T));break;case 174:for(let I of r.parameters)XD(pne(I));XD(lp(r));break;case 172:XD(Vl(r));break;case 169:XD(pne(r));let C=r.parent;for(let I of C.parameters)XD(pne(I));XD(lp(C));break}}}function XJ(r,a){if(_t&&ch(r,111551)&&!_A(a)){let _=Au(r);Gf(r,!0)&1160127&&(Cd(q)||lE(q)&&FHe(a)||!lL(Mp(_)))&&Mre(r)}}function Mre(r){M.assert(_t);let a=as(r);if(!a.referenced){a.referenced=!0;let _=yp(r);if(!_)return M.fail();if(nA(_)&&Gf(pl(r))&111551){let h=_p(_.moduleReference);Rre(h)}}}function zHe(r){let a=jn(r),_=Au(a);_&&(_===St||Gf(a,!0)&111551&&!lL(_))&&Mre(a)}function WHe(r,a){if(!r)return;let _=_p(r),h=(r.kind===80?788968:1920)|2097152,T=xr(_,_.escapedText,h,void 0,!0);if(T&&T.flags&2097152){if(_t&&ey(T)&&!lL(Au(T))&&!lh(T))Mre(T);else if(a&&Cd(q)&&V_(q)>=5&&!ey(T)&&!Pt(T.declarations,ib)){let C=Qe(r,v.A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled),I=Ln(T.declarations||ve,yn);I&&ca(C,pn(I,v._0_was_imported_here,Nn(_)))}}}function BFt(r){WHe(r&&oR(r),!1)}function XD(r){let a=OCe(r);a&&Tf(a)&&WHe(a,!0)}function UFt(r,a,_){var h;let T=gn(r,_),C=r.valueDeclaration;if(C){if(Xa(C)&&!C.initializer&&!C.dotDotDotToken&&C.parent.elements.length>=2){let I=C.parent.parent,V=Bg(I);if(V.kind===260&&px(V)&6||V.kind===169){let H=qn(I);if(!(H.flags&4194304)){H.flags|=4194304;let X=Mk(I,0),_e=X&&wc(X,ay);if(H.flags&=-4194305,_e&&_e.flags&1048576&&!(V.kind===169&&k2e(V))){let we=C.parent,Ne=iv(we,_e,_e,void 0,a.flowNode);return Ne.flags&131072?Ar:Li(C,Ne,!0)}}}}if(ns(C)&&!C.type&&!C.initializer&&!C.dotDotDotToken){let I=C.parent;if(I.parameters.length>=2&&are(I)){let V=G7(I);if(V&&V.parameters.length===1&&E_(V)){let H=Z6(os(gn(V.parameters[0]),(h=cx(I))==null?void 0:h.nonFixingMapper));if(H.flags&1048576&&Zf(H,Ha)&&!Pt(I.parameters,k2e)){let X=iv(I,H,H,void 0,a.flowNode),_e=I.parameters.indexOf(C)-(iE(I)?1:0);return Kf(X,zm(_e))}}}}}return T}function $He(r,a){if(aE(r))return;if(a===qe){if(Q2e(r)){Qe(r,v.arguments_cannot_be_referenced_in_property_initializers);return}let C=Dp(r);if(C)for(ee<2&&(C.kind===219?Qe(r,v.The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES5_Consider_using_a_standard_function_expression):li(C,1024)&&Qe(r,v.The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES5_Consider_using_a_standard_function_or_method)),qn(C).flags|=512;C&&pc(C);)C=Dp(C),C&&(qn(C).flags|=512);return}let _=Mp(a),h=HCe(_,r);Md(h)&&Pxe(r,h)&&h.declarations&&L0(r,h.declarations,r.escapedText);let T=_.valueDeclaration;if(T&&_.flags&32&&gi(T)&&T.name!==r){let C=nf(r,!1,!1);for(;C.kind!==307&&C.parent!==T;)C=nf(C,!1,!1);C.kind!==307&&(qn(T).flags|=262144,qn(C).flags|=262144,qn(r).flags|=536870912)}WFt(r,a)}function VFt(r,a){if(aE(r))return QJ(r);let _=gf(r);if(_===St)return Oe;if($He(r,_),_===qe)return Q2e(r)?Oe:gn(_);HHe(r)&&Qk(r,1);let h=Mp(_),T=h.valueDeclaration,C=UFt(h,r,a),I=fb(r);if(I){if(!(h.flags&3)&&!(hn(r)&&h.flags&512)){let Fn=h.flags&384?v.Cannot_assign_to_0_because_it_is_an_enum:h.flags&32?v.Cannot_assign_to_0_because_it_is_a_class:h.flags&1536?v.Cannot_assign_to_0_because_it_is_a_namespace:h.flags&16?v.Cannot_assign_to_0_because_it_is_a_function:h.flags&2097152?v.Cannot_assign_to_0_because_it_is_an_import:v.Cannot_assign_to_0_because_it_is_not_a_variable;return Qe(r,Fn,rs(_)),Oe}if(Cg(h))return h.flags&3?Qe(r,v.Cannot_assign_to_0_because_it_is_a_constant,rs(_)):Qe(r,v.Cannot_assign_to_0_because_it_is_a_read_only_property,rs(_)),Oe}let V=h.flags&2097152;if(h.flags&3){if(I===1)return PH(r)?ev(C):C}else if(V)T=yp(_);else return C;if(!T)return C;C=P2e(C,r,a);let H=Bg(T).kind===169,X=W7(T),_e=W7(r),we=_e!==X,Ne=r.parent&&r.parent.parent&&Fy(r.parent)&&x2e(r.parent.parent),pt=_.flags&134217728,Tt=C===tt||C===Fo,Mt=Tt&&r.parent.kind===235;for(;_e!==X&&(_e.kind===218||_e.kind===219||r9(_e))&&(Xk(h)&&C!==Fo||$7(h)&&IHe(h,r));)_e=W7(_e);let mr=H||V||we||Ne||pt||JFt(r,T)||C!==tt&&C!==Fo&&(!ce||(C.flags&16387)!==0||_A(r)||y2e(r)||r.parent.kind===281)||r.parent.kind===235||T.kind===260&&T.exclamationToken||T.flags&33554432,br=Mt?nr:mr?H?LFt(C,T):C:Tt?nr:LS(C),en=Mt?tv(iv(r,C,br,_e)):iv(r,C,br,_e);if(!DHe(r)&&(C===tt||C===Fo)){if(en===tt||en===Fo)return de&&(Qe(Ps(T),v.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined,rs(_),ln(en)),Qe(r,v.Variable_0_implicitly_has_an_1_type,rs(_),ln(en))),cL(en)}else if(!mr&&!HD(C)&&HD(en))return Qe(r,v.Variable_0_is_used_before_being_assigned,rs(_)),C;return I?ev(en):en}function JFt(r,a){if(Xa(a)){let _=Pr(r,Xa);return _&&Bg(_)===Bg(a)}}function HHe(r){var a;let _=r.parent;if(_){if(Wn(_)&&_.expression===r||b_(_)&&_.isTypeOnly)return!1;let h=(a=_.parent)==null?void 0:a.parent;if(h&&xl(h)&&h.isTypeOnly)return!1}return!0}function qFt(r,a){return!!Pr(r,_=>_===a?"quit":Bs(_)||_.parent&&Ns(_.parent)&&!Jl(_.parent)&&_.parent.initializer===_)}function zFt(r,a){return Pr(r,_=>_===a?"quit":_===a.initializer||_===a.condition||_===a.incrementor||_===a.statement)}function D2e(r){return Pr(r,a=>!a||FH(a)?"quit":V1(a,!1))}function WFt(r,a){if(ee>=2||!(a.flags&34)||!a.valueDeclaration||Ji(a.valueDeclaration)||a.valueDeclaration.parent.kind===299)return;let _=eg(a.valueDeclaration),h=qFt(r,_),T=D2e(_);if(T){if(h){let C=!0;if(Sb(_)){let I=pb(a.valueDeclaration,261);if(I&&I.parent===_){let V=zFt(r.parent,_);if(V){let H=qn(V);H.flags|=8192;let X=H.capturedBlockScopeBindings||(H.capturedBlockScopeBindings=[]);ol(X,a),V===_.initializer&&(C=!1)}}}C&&(qn(T).flags|=4096)}if(Sb(_)){let C=pb(a.valueDeclaration,261);C&&C.parent===_&&HFt(r,_)&&(qn(a.valueDeclaration).flags|=65536)}qn(a.valueDeclaration).flags|=32768}h&&(qn(a.valueDeclaration).flags|=16384)}function $Ft(r,a){let _=qn(r);return!!_&&Es(_.capturedBlockScopeBindings,jn(a))}function HFt(r,a){let _=r;for(;_.parent.kind===217;)_=_.parent;let h=!1;if(kv(_))h=!0;else if(_.parent.kind===224||_.parent.kind===225){let T=_.parent;h=T.operator===46||T.operator===47}return h?!!Pr(_,T=>T===a?"quit":T===a.statement):!1}function w2e(r,a){if(qn(r).flags|=2,a.kind===172||a.kind===176){let _=a.parent;qn(_).flags|=4}else qn(a).flags|=4}function GHe(r){return Kx(r)?r:Bs(r)?void 0:Js(r,GHe)}function I2e(r){let a=jn(r),_=ac(a);return Lr(_)===z}function YHe(r,a,_){let h=a.parent;nE(h)&&!I2e(h)&&ER(r)&&r.flowNode&&!Ire(r.flowNode,!1)&&Qe(r,_)}function GFt(r,a){Ns(a)&&Jl(a)&&pe&&a.initializer&&P3(a.initializer,r.pos)&&Wp(a.parent)&&Qe(r,v.Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class)}function QJ(r){let a=_A(r),_=nf(r,!0,!0),h=!1,T=!1;for(_.kind===176&&YHe(r,_,v.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class);;){if(_.kind===219&&(_=nf(_,!1,!T),h=!0),_.kind===167){_=nf(_,!h,!1),T=!0;continue}break}if(GFt(r,_),T)Qe(r,v.this_cannot_be_referenced_in_a_computed_property_name);else switch(_.kind){case 267:Qe(r,v.this_cannot_be_referenced_in_a_module_or_namespace_body);break;case 266:Qe(r,v.this_cannot_be_referenced_in_current_location);break}!a&&h&&ee<2&&w2e(r,_);let C=O2e(r,!0,_);if(Ae){let I=gn(ct);if(C===I&&h)Qe(r,v.The_containing_arrow_function_captures_the_global_value_of_this);else if(!C){let V=Qe(r,v.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation);if(!Ji(_)){let H=O2e(_);H&&H!==I&&ca(V,pn(_,v.An_outer_value_of_this_is_shadowed_by_this_container))}}}return C||Me}function O2e(r,a=!0,_=nf(r,!1,!1)){let h=hn(r);if(Bs(_)&&(!M2e(r)||iE(_))){let T=IEe(_)||h&&XFt(_);if(!T){let C=KFt(_);if(h&&C){let I=hs(C).symbol;I&&I.members&&I.flags&16&&(T=ac(I).thisType)}else vh(_)&&(T=ac(ro(_.symbol)).thisType);T||(T=ZHe(_))}if(T)return iv(r,T)}if(gi(_.parent)){let T=jn(_.parent),C=oa(_)?gn(T):ac(T).thisType;return iv(r,C)}if(Ji(_))if(_.commonJsModuleIndicator){let T=jn(_);return T&&gn(T)}else{if(_.externalModuleIndicator)return nr;if(a)return gn(ct)}}function YFt(r){let a=nf(r,!1,!1);if(Bs(a)){let _=md(a);if(_.thisParameter)return Dre(_.thisParameter)}if(gi(a.parent)){let _=jn(a.parent);return oa(a)?gn(_):ac(_).thisType}}function KFt(r){if(r.kind===218&&Pn(r.parent)&&cl(r.parent)===3)return r.parent.left.expression.expression;if(r.kind===174&&r.parent.kind===210&&Pn(r.parent.parent)&&cl(r.parent.parent)===6)return r.parent.parent.left.expression;if(r.kind===218&&r.parent.kind===303&&r.parent.parent.kind===210&&Pn(r.parent.parent.parent)&&cl(r.parent.parent.parent)===6)return r.parent.parent.parent.left.expression;if(r.kind===218&&ql(r.parent)&&He(r.parent.name)&&(r.parent.name.escapedText==="value"||r.parent.name.escapedText==="get"||r.parent.name.escapedText==="set")&&Ca(r.parent.parent)&&ea(r.parent.parent.parent)&&r.parent.parent.parent.arguments[2]===r.parent.parent&&cl(r.parent.parent.parent)===9)return r.parent.parent.parent.arguments[0].expression;if(ul(r)&&He(r.name)&&(r.name.escapedText==="value"||r.name.escapedText==="get"||r.name.escapedText==="set")&&Ca(r.parent)&&ea(r.parent.parent)&&r.parent.parent.arguments[2]===r.parent&&cl(r.parent.parent)===9)return r.parent.parent.arguments[0].expression}function XFt(r){let a=x5(r);if(a&&a.typeExpression)return Wi(a.typeExpression);let _=e4(r);if(_)return mT(_)}function QFt(r,a){return!!Pr(r,_=>Go(_)?"quit":_.kind===169&&_.parent===a)}function Lre(r){let a=r.parent.kind===213&&r.parent.expression===r,_=sR(r,!0),h=_,T=!1,C=!1;if(!a){for(;h&&h.kind===219;)li(h,1024)&&(C=!0),h=sR(h,!0),T=ee<2;h&&li(h,1024)&&(C=!0)}let I=0;if(!h||!_e(h)){let we=Pr(r,Ne=>Ne===h?"quit":Ne.kind===167);return we&&we.kind===167?Qe(r,v.super_cannot_be_referenced_in_a_computed_property_name):a?Qe(r,v.Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors):!h||!h.parent||!(gi(h.parent)||h.parent.kind===210)?Qe(r,v.super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions):Qe(r,v.super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class),Oe}if(!a&&_.kind===176&&YHe(r,h,v.super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class),oa(h)||a?(I=32,!a&&ee>=2&&ee<=8&&(Ns(h)||Gc(h))&&L_e(r.parent,we=>{(!Ji(we)||Uf(we))&&(qn(we).flags|=2097152)})):I=16,qn(r).flags|=I,h.kind===174&&C&&(Cf(r.parent)&&kv(r.parent)?qn(h).flags|=256:qn(h).flags|=128),T&&w2e(r.parent,h),h.parent.kind===210)return ee<2?(Qe(r,v.super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher),Oe):Me;let V=h.parent;if(!nE(V))return Qe(r,v.super_can_only_be_referenced_in_a_derived_class),Oe;if(I2e(V))return a?Oe:z;let H=ac(jn(V)),X=H&&_i(H)[0];if(!X)return Oe;if(h.kind===176&&QFt(r,h))return Qe(r,v.super_cannot_be_referenced_in_constructor_arguments),Oe;return I===32?Lr(H):bp(X,H.thisType);function _e(we){return a?we.kind===176:gi(we.parent)||we.parent.kind===210?oa(we)?we.kind===174||we.kind===173||we.kind===177||we.kind===178||we.kind===172||we.kind===175:we.kind===174||we.kind===173||we.kind===177||we.kind===178||we.kind===172||we.kind===171||we.kind===176:!1}}function KHe(r){return(r.kind===174||r.kind===177||r.kind===178)&&r.parent.kind===210?r.parent:r.kind===218&&r.parent.kind===303?r.parent.parent:void 0}function XHe(r){return Kn(r)&4&&r.target===au?yc(r)[0]:void 0}function ZFt(r){return wc(r,a=>a.flags&2097152?kt(a.types,XHe):XHe(a))}function QHe(r,a){let _=r,h=a;for(;h;){let T=ZFt(h);if(T)return T;if(_.parent.kind!==303)break;_=_.parent.parent,h=xT(_,void 0)}}function ZHe(r){if(r.kind===219)return;if(are(r)){let _=G7(r);if(_){let h=_.thisParameter;if(h)return gn(h)}}let a=hn(r);if(Ae||a){let _=KHe(r);if(_){let T=xT(_,void 0),C=QHe(_,T);return C?os(C,l2e(cx(_))):Qf(T?tv(T):yl(_))}let h=g0(r.parent);if(Su(h)){let T=h.left;if(oc(T)){let{expression:C}=T;if(a&&He(C)){let I=Ur(h);if(I.commonJsModuleIndicator&&gf(C)===I.symbol)return}return Qf(yl(C))}}}}function eGe(r){let a=r.parent;if(!are(a))return;let _=QT(a);if(_&&_.arguments){let T=Qre(_),C=a.parameters.indexOf(r);if(r.dotDotDotToken)return aCe(T,C,T.length,Me,void 0,0);let I=qn(_),V=I.resolvedSignature;I.resolvedSignature=Se;let H=C<T.length?ST(hs(T[C])):r.initializer?void 0:Z;return I.resolvedSignature=V,H}let h=G7(a);if(h){let T=a.parameters.indexOf(r)-(iE(a)?1:0);return r.dotDotDotToken&&vc(a.parameters)===r?dq(h,T):ux(h,T)}}function R2e(r,a){let _=Vl(r)||(hn(r)?gj(r):void 0);if(_)return Wi(_);switch(r.kind){case 169:return eGe(r);case 208:return e5t(r,a);case 172:if(oa(r))return t5t(r,a)}}function e5t(r,a){let _=r.parent.parent,h=r.propertyName||r.name,T=R2e(_,a)||_.kind!==208&&_.initializer&&f4(_,r.dotDotDotToken?32:0);if(!T||Hs(h)||Q3(h))return;if(_.name.kind===207){let I=JP(r.parent.elements,r);return I<0?void 0:j2e(T,I)}let C=d1(h);if(tm(C)){let I=rm(C);return il(T,I)}}function t5t(r,a){let _=Ct(r.parent)&&hf(r.parent,a);if(_)return ET(_,jn(r).escapedName)}function r5t(r,a){let _=r.parent;if(bv(_)&&r===_.initializer){let h=R2e(_,a);if(h)return h;if(!(a&8)&&Hs(_.name)&&_.name.elements.length>0)return P(_.name,!0,!1)}}function n5t(r,a){let _=Dp(r);if(_){let h=Fre(_,a);if(h){let T=Rl(_);if(T&1){let C=(T&2)!==0;h.flags&1048576&&(h=Fl(h,V=>!!_x(1,V,C)));let I=_x(1,h,(T&2)!==0);if(!I)return;h=I}if(T&2){let C=wc(h,h1);return C&&fi([C,mYe(C)])}return h}}}function i5t(r,a){let _=hf(r,a);if(_){let h=h1(_);return h&&fi([h,mYe(h)])}}function s5t(r,a){let _=Dp(r);if(_){let h=Rl(_),T=Fre(_,a);if(T){let C=(h&2)!==0;if(!r.asteriskToken&&T.flags&1048576&&(T=Fl(T,I=>!!_x(1,I,C))),r.asteriskToken){let I=WCe(T,C),V=I?.yieldType??In,H=hf(r,a)??In,X=I?.nextType??Rt,_e=nne(V,H,X,!1);if(C){let we=nne(V,H,X,!0);return fi([_e,we])}return _e}return _x(0,T,C)}}}function M2e(r){let a=!1;for(;r.parent&&!Bs(r.parent);){if(ns(r.parent)&&(a||r.parent.initializer===r))return!0;Xa(r.parent)&&r.parent.initializer===r&&(a=!0),r=r.parent}return!1}function tGe(r,a){let _=!!(Rl(a)&2),h=Fre(a,void 0);if(h)return _x(r,h,_)||void 0}function Fre(r,a){let _=VD(r);if(_)return _;let h=U2e(r);if(h&&!Ute(h)){let C=ko(h),I=Rl(r);return I&1?Fl(C,V=>!!(V.flags&58998787)||PCe(V,I,void 0)):I&2?Fl(C,V=>!!(V.flags&58998787)||!!m4(V)):C}let T=QT(r);if(T)return hf(T,a)}function rGe(r,a){let h=Qre(r).indexOf(a);return h===-1?void 0:L2e(r,h)}function L2e(r,a){if(Np(r))return a===0?Ue:a===1?MWe(!1):Me;let _=qn(r).resolvedSignature===Ye?Ye:ew(r);if(__(r)&&a===0)return Vre(_,r);let h=_.parameters.length-1;return E_(_)&&a>=h?Kf(gn(_.parameters[h]),zm(a-h),256):xg(_,a)}function a5t(r){let a=vCe(r);return a?G2(a):void 0}function o5t(r,a){if(r.parent.kind===215)return rGe(r.parent,a)}function c5t(r,a){let _=r.parent,{left:h,operatorToken:T,right:C}=_;switch(T.kind){case 64:case 77:case 76:case 78:return r===C?u5t(_):void 0;case 57:case 61:let I=hf(_,a);return r===C&&(I&&I.pattern||!I&&!cfe(_))?t_(h):I;case 56:case 28:return r===C?hf(_,a):void 0;default:return}}function l5t(r){if(Zm(r)&&r.symbol)return r.symbol;if(He(r))return gf(r);if(Wn(r)){let _=t_(r.expression);return Zi(r.name)?a(_,r.name):ma(_,r.name.escapedText)}if(cc(r)){let _=yl(r.argumentExpression);if(!tm(_))return;let h=t_(r.expression);return ma(h,rm(_))}return;function a(_,h){let T=sq(h.escapedText,h);return T&&Gre(_,T)}}function u5t(r){var a,_;let h=cl(r);switch(h){case 0:case 4:let T=l5t(r.left),C=T&&T.valueDeclaration;if(C&&(Ns(C)||Nf(C))){let H=Vl(C);return H&&os(Wi(H),as(T).mapper)||(Ns(C)?C.initializer&&t_(r.left):void 0)}return h===0?t_(r.left):nGe(r);case 5:if(jre(r,h))return nGe(r);if(!Zm(r.left)||!r.left.symbol)return t_(r.left);{let H=r.left.symbol.valueDeclaration;if(!H)return;let X=aa(r.left,oc),_e=Vl(H);if(_e)return Wi(_e);if(He(X.expression)){let we=X.expression,Ne=xr(we,we.escapedText,111551,void 0,!0);if(Ne){let pt=Ne.valueDeclaration&&Vl(Ne.valueDeclaration);if(pt){let Tt=m0(X);if(Tt!==void 0)return ET(Wi(pt),Tt)}return}}return hn(H)||H===r.left?void 0:t_(r.left)}case 1:case 6:case 3:case 2:let I;h!==2&&(I=Zm(r.left)?(a=r.left.symbol)==null?void 0:a.valueDeclaration:void 0),I||(I=(_=r.symbol)==null?void 0:_.valueDeclaration);let V=I&&Vl(I);return V?Wi(V):void 0;case 7:case 8:case 9:return M.fail("Does not apply");default:return M.assertNever(h)}}function jre(r,a=cl(r)){if(a===4)return!0;if(!hn(r)||a!==5||!He(r.left.expression))return!1;let _=r.left.expression.escapedText,h=xr(r.left,_,111551,void 0,!0,!0);return o9(h?.valueDeclaration)}function nGe(r){if(!r.symbol)return t_(r.left);if(r.symbol.valueDeclaration){let T=Vl(r.symbol.valueDeclaration);if(T){let C=Wi(T);if(C)return C}}let a=aa(r.left,oc);if(!Nm(nf(a.expression,!1,!1)))return;let _=QJ(a.expression),h=m0(a);return h!==void 0&&ET(_,h)||void 0}function _5t(r){return!!(ll(r)&262144&&!r.links.type&&RD(r,0)>=0)}function ET(r,a,_){return wc(r,h=>{var T;if(Yf(h)&&!h.declaration.nameType){let C=dd(h),I=Zu(C)||C,V=_||Lf(Qi(a));if(ga(V,I))return Xte(h,V)}else if(h.flags&3670016){let C=ma(h,a);if(C)return _5t(C)?void 0:rv(gn(C),!!(C.flags&16777216));if(Ha(h)&&Ry(a)&&+a>=0){let I=a4(h,h.target.fixedLength,0,!1,!0);if(I)return I}return(T=XEe(QEe(h),_||Lf(Qi(a))))==null?void 0:T.type}},!0)}function iGe(r,a){if(M.assert(Nm(r)),!(r.flags&67108864))return F2e(r,a)}function F2e(r,a){let _=r.parent,h=ql(r)&&R2e(r,a);if(h)return h;let T=xT(_,a);if(T){if(BD(r)){let C=jn(r);return ET(T,C.escapedName,as(C).nameType)}if(h0(r)){let C=Ps(r);if(C&&za(C)){let I=hs(C.expression),V=tm(I)&&ET(T,rm(I));if(V)return V}}if(r.name){let C=d1(r.name);return wc(T,I=>{var V;return(V=XEe(QEe(I),C))==null?void 0:V.type},!0)}}}function f5t(r){let a,_;for(let h=0;h<r.length;h++)Ad(r[h])&&(a??(a=h),_=h);return{first:a,last:_}}function j2e(r,a,_,h,T){return r&&wc(r,C=>{if(Ha(C)){if((h===void 0||a<h)&&a<C.target.fixedLength)return rv(yc(C)[a],!!C.target.elementFlags[a]);let I=_!==void 0&&(T===void 0||a>T)?_-a:0,V=I>0&&C.target.hasRestElement?N7(C.target,3):0;return I>0&&I<=V?yc(C)[f1(C)-I]:a4(C,h===void 0?C.target.fixedLength:Math.min(C.target.fixedLength,h),_===void 0||T===void 0?V:Math.min(V,_-T),!1,!0)}return(!h||a<h)&&ET(C,""+a)||jCe(1,C,nr,void 0,!1)},!0)}function p5t(r,a){let _=r.parent;return r===_.whenTrue||r===_.whenFalse?hf(_,a):void 0}function d5t(r,a,_){let h=xT(r.openingElement.attributes,_),T=rq(oC(r));if(!(h&&!Ao(h)&&T&&T!==""))return;let C=rN(r.children),I=C.indexOf(a),V=ET(h,T);return V&&(C.length===1?V:wc(V,H=>g1(H)?Kf(H,zm(I)):H,!0))}function m5t(r,a){let _=r.parent;return R5(_)?hf(r,a):Ly(_)?d5t(_,r,a):void 0}function sGe(r,a){if(Kg(r)){let _=xT(r.parent,a);return!_||Ao(_)?void 0:ET(_,gO(r.name))}else return hf(r.parent,a)}function ZJ(r){switch(r.kind){case 11:case 9:case 10:case 15:case 228:case 112:case 97:case 106:case 80:case 157:return!0;case 211:case 217:return ZJ(r.expression);case 294:return!r.expression||ZJ(r.expression)}return!1}function g5t(r,a){let _=`D${yo(r)},${Lu(a)}`;return $b(_)??Xv(_,aFt(a,r)??Hxe(a,ps(Cr(Zn(r.properties,h=>h.symbol?h.kind===303?ZJ(h.initializer)&&o4(a,h.symbol.escapedName):h.kind===304?o4(a,h.symbol.escapedName):!1:!1),h=>[()=>Sq(h.kind===303?h.initializer:h.name),h.symbol.escapedName]),Cr(Zn(bo(a),h=>{var T;return!!(h.flags&16777216)&&!!((T=r?.symbol)!=null&&T.members)&&!r.symbol.members.has(h.escapedName)&&o4(a,h.escapedName)}),h=>[()=>nr,h.escapedName])),ga))}function h5t(r,a){let _=`D${yo(r)},${Lu(a)}`,h=$b(_);if(h)return h;let T=rq(oC(r));return Xv(_,Hxe(a,ps(Cr(Zn(r.properties,C=>!!C.symbol&&C.kind===291&&o4(a,C.symbol.escapedName)&&(!C.initializer||ZJ(C.initializer))),C=>[C.initializer?()=>Sq(C.initializer):()=>Ht,C.symbol.escapedName]),Cr(Zn(bo(a),C=>{var I;if(!(C.flags&16777216)||!((I=r?.symbol)!=null&&I.members))return!1;let V=r.parent.parent;return C.escapedName===T&&Ly(V)&&rN(V.children).length?!1:!r.symbol.members.has(C.escapedName)&&o4(a,C.escapedName)}),C=>[()=>nr,C.escapedName])),ga))}function xT(r,a){let _=Nm(r)?iGe(r,a):hf(r,a),h=Bre(_,r,a);if(h&&!(a&&a&2&&h.flags&8650752)){let T=wc(h,C=>Kn(C)&32?C:K_(C),!0);return T.flags&1048576&&Ca(r)?g5t(r,T):T.flags&1048576&&SE(r)?h5t(r,T):T}}function Bre(r,a,_){if(r&&dl(r,465829888)){let h=cx(a);if(h&&_&1&&Pt(h.inferences,iBt))return Ure(r,h.nonFixingMapper);if(h?.returnMapper){let T=Ure(r,h.returnMapper);return T.flags&1048576&&p1(T.types,$t)&&p1(T.types,dr)?Fl(T,C=>C!==$t&&C!==dr):T}}return r}function Ure(r,a){return r.flags&465829888?os(r,a):r.flags&1048576?fi(Cr(r.types,_=>Ure(_,a)),0):r.flags&2097152?Da(Cr(r.types,_=>Ure(_,a))):r}function hf(r,a){var _;if(r.flags&67108864)return;let h=oGe(r,!a);if(h>=0)return lm[h];let{parent:T}=r;switch(T.kind){case 260:case 169:case 172:case 171:case 208:return r5t(r,a);case 219:case 253:return n5t(r,a);case 229:return s5t(T,a);case 223:return i5t(T,a);case 213:case 214:return rGe(T,r);case 170:return a5t(T);case 216:case 234:return Qm(T.type)?hf(T,a):Wi(T.type);case 226:return c5t(r,a);case 303:case 304:return F2e(T,a);case 305:return hf(T.parent,a);case 209:{let C=T,I=xT(C,a),V=JP(C.elements,r),H=(_=qn(C)).spreadIndices??(_.spreadIndices=f5t(C.elements));return j2e(I,V,C.elements.length,H.first,H.last)}case 227:return p5t(r,a);case 239:return M.assert(T.parent.kind===228),o5t(T.parent,r);case 217:{if(hn(T)){if(RG(T))return Wi(MG(T));let C=tb(T);if(C&&!Qm(C.typeExpression.type))return Wi(C.typeExpression.type)}return hf(T,a)}case 235:return hf(T,a);case 238:return Wi(T.type);case 277:return fn(T);case 294:return m5t(T,a);case 291:case 293:return sGe(T,a);case 286:case 285:return b5t(T,a);case 301:return S5t(T)}}function aGe(r){eq(r,hf(r,void 0),!0)}function eq(r,a,_){dS[pg]=r,lm[pg]=a,Vb[pg]=_,pg++}function H7(){pg--}function oGe(r,a){for(let _=pg-1;_>=0;_--)if(r===dS[_]&&(a||!Vb[_]))return _;return-1}function y5t(r,a){cd[We]=r,R0[We]=a,We++}function v5t(){We--}function cx(r){for(let a=We-1;a>=0;a--)if(rE(r,cd[a]))return R0[a]}function S5t(r){return ET(dxe(!1),hj(r))}function b5t(r,a){if(Yg(r)&&a!==4){let _=oGe(r.parent,!a);if(_>=0)return lm[_]}return L2e(r,0)}function Vre(r,a){return zGe(a)!==0?T5t(r,a):C5t(r,a)}function T5t(r,a){let _=hCe(r,Rt);_=cGe(a,oC(a),_);let h=lx(Xp.IntrinsicAttributes,a);return ao(h)||(_=pJ(h,_)),_}function E5t(r,a){if(r.compositeSignatures){let h=[];for(let T of r.compositeSignatures){let C=ko(T);if(Ao(C))return C;let I=il(C,a);if(!I)return;h.push(I)}return Da(h)}let _=ko(r);return Ao(_)?_:il(_,a)}function x5t(r){if(Zk(r.tagName)){let _=hGe(r),h=Zre(r,_);return G2(h)}let a=yl(r.tagName);if(a.flags&128){let _=gGe(a,r);if(!_)return Oe;let h=Zre(r,_);return G2(h)}return a}function cGe(r,a,_){let h=H5t(a);if(h){let T=x5t(r),C=SGe(h,hn(r),T,_);if(C)return C}return _}function C5t(r,a){let _=oC(a),h=Y5t(_),T=h===void 0?hCe(r,Rt):h===""?ko(r):E5t(r,h);if(!T)return h&&wt(a.attributes.properties)&&Qe(a,v.JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property,Qi(h)),Rt;if(T=cGe(a,_,T),Ao(T))return T;{let C=T,I=lx(Xp.IntrinsicClassAttributes,a);if(!ao(I)){let H=l1(I.symbol),X=ko(r),_e;if(H){let we=NS([X],H,ph(H),hn(a));_e=os(I,Xf(H,we))}else _e=I;C=pJ(_e,C)}let V=lx(Xp.IntrinsicAttributes,a);return ao(V)||(C=pJ(V,C)),C}}function A5t(r){return J_(q,"noImplicitAny")?L_(r,(a,_)=>a===_||!a?a:Qze(a.typeParameters,_.typeParameters)?N5t(a,_):void 0):void 0}function k5t(r,a,_){if(!r||!a)return r||a;let h=fi([gn(r),os(gn(a),_)]);return tC(r,h)}function P5t(r,a,_){let h=ep(r),T=ep(a),C=h>=T?r:a,I=C===r?a:r,V=C===r?h:T,H=uy(r)||uy(a),X=H&&!uy(C),_e=new Array(V+(X?1:0));for(let we=0;we<V;we++){let Ne=ux(C,we);C===a&&(Ne=os(Ne,_));let pt=ux(I,we)||Rt;I===a&&(pt=os(pt,_));let Tt=fi([Ne,pt]),Mt=H&&!X&&we===V-1,mr=we>=Sh(C)&&we>=Sh(I),br=we>=h?void 0:_4(r,we),en=we>=T?void 0:_4(a,we),Fn=br===en?br:br?en?void 0:br:en,Dr=Za(1|(mr&&!Mt?16777216:0),Fn||`arg${we}`);Dr.links.type=Mt?g_(Tt):Tt,_e[we]=Dr}if(X){let we=Za(1,"args");we.links.type=g_(xg(I,V)),I===a&&(we.links.type=os(we.links.type,_)),_e[V]=we}return _e}function N5t(r,a){let _=r.typeParameters||a.typeParameters,h;r.typeParameters&&a.typeParameters&&(h=Xf(a.typeParameters,r.typeParameters));let T=r.declaration,C=P5t(r,a,h),I=k5t(r.thisParameter,a.thisParameter,h),V=Math.max(r.minArgumentCount,a.minArgumentCount),H=Hy(T,_,I,C,void 0,void 0,V,(r.flags|a.flags)&167);return H.compositeKind=2097152,H.compositeSignatures=ps(r.compositeKind===2097152&&r.compositeSignatures||[r],[a]),h&&(H.mapper=r.compositeKind===2097152&&r.mapper&&r.compositeSignatures?ax(r.mapper,h):h),H}function B2e(r,a){let _=Ys(r,0),h=Zn(_,T=>!D5t(T,a));return h.length===1?h[0]:A5t(h)}function D5t(r,a){let _=0;for(;_<a.parameters.length;_++){let h=a.parameters[_];if(h.initializer||h.questionToken||h.dotDotDotToken||mj(h))break}return a.parameters.length&&sE(a.parameters[0])&&_--,!uy(r)&&ep(r)<_}function U2e(r){return K1(r)||Nm(r)?G7(r):void 0}function G7(r){M.assert(r.kind!==174||Nm(r));let a=e4(r);if(a)return a;let _=xT(r,1);if(!_)return;if(!(_.flags&1048576))return B2e(_,r);let h,T=_.types;for(let C of T){let I=B2e(C,r);if(I)if(!h)h=[I];else if(FJ(h[0],I,!1,!0,!0,M7))h.push(I);else return}if(h)return h.length===1?h[0]:Kze(h[0],h)}function w5t(r){let a=Ur(r);if(!BS(a)&&!r.isUnterminated){let _;s??(s=xy(99,!0)),s.setScriptTarget(a.languageVersion),s.setLanguageVariant(a.languageVariant),s.setOnError((h,T,C)=>{let I=s.getTokenEnd();if(h.category===3&&_&&I===_.start&&T===_.length){let V=hA(a.fileName,a.text,I,T,h,C);ca(_,V)}else(!_||I!==_.start)&&(_=bu(a,I,T,h,C),_o.add(_))}),s.setText(a.text,r.pos,r.end-r.pos);try{return s.scan(),M.assert(s.reScanSlashToken(!0)===14,"Expected scanner to rescan RegularExpressionLiteral"),!!_}finally{s.setText(""),s.setOnError(void 0)}}return!1}function I5t(r){let a=qn(r);return a.flags&1||(a.flags|=1,n(()=>w5t(r))),fl}function O5t(r,a){ee<2&&gu(r,q.downlevelIteration?1536:1024);let _=hs(r.expression,a);return y1(33,_,nr,r.expression)}function R5t(r){return r.isSpread?Kf(r.type,Te):r.type}function u4(r){return r.kind===208&&!!r.initializer||r.kind===226&&r.operatorToken.kind===64}function M5t(r){let a=g0(r.parent);return Ad(a)&&Ig(a.parent)}function lGe(r,a,_){let h=r.elements,T=h.length,C=[],I=[];aGe(r);let V=kv(r),H=p4(r),X=xT(r,void 0),_e=M5t(r)||!!X&&ym(X,Ne=>s4(Ne)||Yf(Ne)&&!Ne.nameType&&!!O7(Ne.target||Ne)),we=!1;for(let Ne=0;Ne<T;Ne++){let pt=h[Ne];if(pt.kind===230){ee<2&&gu(pt,q.downlevelIteration?1536:1024);let Tt=hs(pt.expression,a,_);if(g1(Tt))C.push(Tt),I.push(8);else if(V){let Mt=dT(Tt,Te)||jCe(65,Tt,nr,void 0,!1)||Rt;C.push(Mt),I.push(4)}else C.push(y1(33,Tt,nr,pt.expression)),I.push(4)}else if(te&&pt.kind===232)we=!0,C.push(bt),I.push(2);else{let Tt=d4(pt,a,_);if(C.push(da(Tt,!0,we)),I.push(we?2:1),_e&&a&&a&2&&!(a&4)&&Ud(pt)){let Mt=cx(r);M.assert(Mt),o2e(Mt,pt,Tt)}}}return H7(),V?cy(C,I):uGe(_||H||_e?cy(C,I,H&&!(X&&ym(X,Qxe))):g_(C.length?fi(Fs(C,(Ne,pt)=>I[pt]&8?wS(Ne,Te)||Me:Ne),2):ce?Ki:Z,H))}function uGe(r){if(!(Kn(r)&4))return r;let a=r.literalType;return a||(a=r.literalType=EWe(r),a.objectFlags|=147456),a}function L5t(r){switch(r.kind){case 167:return F5t(r);case 80:return Ry(r.escapedText);case 9:case 11:return Ry(r.text);default:return!1}}function F5t(r){return e_(gh(r),296)}function gh(r){let a=qn(r.expression);if(!a.resolvedType){if((lf(r.parent.parent)||gi(r.parent.parent)||Yu(r.parent.parent))&&Pn(r.expression)&&r.expression.operatorToken.kind===103&&r.parent.kind!==177&&r.parent.kind!==178)return a.resolvedType=Oe;if(a.resolvedType=hs(r.expression),Ns(r.parent)&&!Jl(r.parent)&&eu(r.parent.parent)){let _=eg(r.parent.parent),h=D2e(_);h&&(qn(h).flags|=4096,qn(r).flags|=32768,qn(r.parent.parent).flags|=32768)}(a.resolvedType.flags&98304||!e_(a.resolvedType,402665900)&&!ga(a.resolvedType,Er))&&Qe(r,v.A_computed_property_name_must_be_of_type_string_number_symbol_or_any)}return a.resolvedType}function j5t(r){var a;let _=(a=r.declarations)==null?void 0:a[0];return Ry(r.escapedName)||_&&Wu(_)&&L5t(_.name)}function _Ge(r){var a;let _=(a=r.declarations)==null?void 0:a[0];return wR(r)||_&&Wu(_)&&za(_.name)&&e_(gh(_.name),4096)}function V2e(r,a,_,h){let T=[];for(let I=a;I<_.length;I++){let V=_[I];(h===Ue&&!_Ge(V)||h===Te&&j5t(V)||h===Hr&&_Ge(V))&&T.push(gn(_[I]))}let C=T.length?fi(T,2):nr;return oy(h,C,p4(r))}function Jre(r){M.assert((r.flags&2097152)!==0,"Should only get Alias here.");let a=as(r);if(!a.immediateTarget){let _=yp(r);if(!_)return M.fail();a.immediateTarget=J0(_,!0)}return a.immediateTarget}function B5t(r,a=0){var _;let h=kv(r);HJt(r,h);let T=ce?fa():void 0,C=fa(),I=[],V=zi;aGe(r);let H=xT(r,void 0),X=H&&H.pattern&&(H.pattern.kind===206||H.pattern.kind===210),_e=p4(r),we=_e?8:0,Ne=hn(r)&&!_9(r),pt=Ne?w$(r):void 0,Tt=!H&&Ne&&!pt,Mt=8192,mr=!1,br=!1,en=!1,Fn=!1;for(let Qr of r.properties)Qr.name&&za(Qr.name)&&gh(Qr.name);let Dr=0;for(let Qr of r.properties){let $n=jn(Qr),ii=Qr.name&&Qr.name.kind===167?gh(Qr.name):void 0;if(Qr.kind===303||Qr.kind===304||Nm(Qr)){let si=Qr.kind===303?PYe(Qr,a):Qr.kind===304?d4(!h&&Qr.objectAssignmentInitializer?Qr.objectAssignmentInitializer:Qr.name,a):NYe(Qr,a);if(Ne){let no=xi(Qr);no?(I_(si,no,Qr),si=no):pt&&pt.typeExpression&&I_(si,Wi(pt.typeExpression),Qr)}Mt|=Kn(si)&458752;let Ea=ii&&tm(ii)?ii:void 0,Ks=Ea?Za(4|$n.flags,rm(Ea),we|4096):Za(4|$n.flags,$n.escapedName,we);if(Ea&&(Ks.links.nameType=Ea),h)(Qr.kind===303&&u4(Qr.initializer)||Qr.kind===304&&Qr.objectAssignmentInitializer)&&(Ks.flags|=16777216);else if(X&&!(Kn(H)&512)){let no=ma(H,$n.escapedName);no?Ks.flags|=no.flags&16777216:Gy(H,Ue)||Qe(Qr.name,v.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1,rs($n),ln(H))}if(Ks.declarations=$n.declarations,Ks.parent=$n.parent,$n.valueDeclaration&&(Ks.valueDeclaration=$n.valueDeclaration),Ks.links.type=si,Ks.links.target=$n,$n=Ks,T?.set(Ks.escapedName,Ks),H&&a&2&&!(a&4)&&(Qr.kind===303||Qr.kind===174)&&Ud(Qr)){let no=cx(r);M.assert(no);let Os=Qr.kind===303?Qr.initializer:Qr;o2e(no,Os,si)}}else if(Qr.kind===305){ee<2&&gu(Qr,2),I.length>0&&(V=nx(V,zr(),r.symbol,Mt,_e),I=[],C=fa(),br=!1,en=!1,Fn=!1);let si=bg(hs(Qr.expression,a&2));if(tq(si)){let Ea=Rxe(si,_e);if(T&&pGe(Ea,T,Qr),Dr=I.length,ao(V))continue;V=nx(V,Ea,r.symbol,Mt,_e)}else Qe(Qr,v.Spread_types_may_only_be_created_from_object_types),V=Oe;continue}else M.assert(Qr.kind===177||Qr.kind===178),eP(Qr);ii&&!(ii.flags&8576)?ga(ii,Er)&&(ga(ii,Te)?en=!0:ga(ii,Hr)?Fn=!0:br=!0,h&&(mr=!0)):C.set($n.escapedName,$n),I.push($n)}if(H7(),X){let Qr=Pr(H.pattern.parent,ii=>ii.kind===260||ii.kind===226||ii.kind===169);if(Pr(r,ii=>ii===Qr||ii.kind===305).kind!==305)for(let ii of bo(H))!C.get(ii.escapedName)&&!ma(V,ii.escapedName)&&(ii.flags&16777216||Qe(ii.valueDeclaration||((_=ai(ii,jh))==null?void 0:_.links.bindingElement),v.Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value),C.set(ii.escapedName,ii),I.push(ii))}if(ao(V))return Oe;if(V!==zi)return I.length>0&&(V=nx(V,zr(),r.symbol,Mt,_e),I=[],C=fa(),br=!1,en=!1),wc(V,Qr=>Qr===zi?zr():Qr);return zr();function zr(){let Qr=[];br&&Qr.push(V2e(r,Dr,I,Ue)),en&&Qr.push(V2e(r,Dr,I,Te)),Fn&&Qr.push(V2e(r,Dr,I,Hr));let $n=Zt(r.symbol,C,ve,ve,Qr);return $n.objectFlags|=Mt|128|131072,Tt&&($n.objectFlags|=4096),mr&&($n.objectFlags|=512),h&&($n.pattern=r),$n}}function tq(r){let a=Q$e(wc(r,ay));return!!(a.flags&126615553||a.flags&3145728&&wi(a.types,tq))}function U5t(r){z2e(r)}function V5t(r,a){return eP(r),nq(r)||Me}function J5t(r){z2e(r.openingElement),Zk(r.closingElement.tagName)?zre(r.closingElement):hs(r.closingElement.tagName),qre(r)}function q5t(r,a){return eP(r),nq(r)||Me}function z5t(r){z2e(r.openingFragment);let a=Ur(r);return X9(q)&&(q.jsxFactory||a.pragmas.has("jsx"))&&!q.jsxFragmentFactory&&!a.pragmas.has("jsxfrag")&&Qe(r,q.jsxFactory?v.The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_compiler_option:v.An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments),qre(r),nq(r)||Me}function J2e(r){return r.includes("-")}function Zk(r){return He(r)&&nN(r.escapedText)||sg(r)}function fGe(r,a){return r.initializer?d4(r.initializer,a):Ht}function W5t(r,a=0){let _=r.attributes,h=hf(_,0),T=ce?fa():void 0,C=fa(),I=Eu,V=!1,H,X=!1,_e=2048,we=rq(oC(r));for(let Tt of _.properties){let Mt=Tt.symbol;if(Kg(Tt)){let mr=fGe(Tt,a);_e|=Kn(mr)&458752;let br=Za(4|Mt.flags,Mt.escapedName);if(br.declarations=Mt.declarations,br.parent=Mt.parent,Mt.valueDeclaration&&(br.valueDeclaration=Mt.valueDeclaration),br.links.type=mr,br.links.target=Mt,C.set(br.escapedName,br),T?.set(br.escapedName,br),gO(Tt.name)===we&&(X=!0),h){let en=ma(h,Mt.escapedName);en&&en.declarations&&Md(en)&&He(Tt.name)&&L0(Tt.name,en.declarations,Tt.name.escapedText)}if(h&&a&2&&!(a&4)&&Ud(Tt)){let en=cx(_);M.assert(en);let Fn=Tt.initializer.expression;o2e(en,Fn,mr)}}else{M.assert(Tt.kind===293),C.size>0&&(I=nx(I,pt(),_.symbol,_e,!1),C=fa());let mr=bg(hs(Tt.expression,a&2));Ao(mr)&&(V=!0),tq(mr)?(I=nx(I,mr,_.symbol,_e,!1),T&&pGe(mr,T,Tt)):(Qe(Tt.expression,v.Spread_types_may_only_be_created_from_object_types),H=H?Da([H,mr]):mr)}}V||C.size>0&&(I=nx(I,pt(),_.symbol,_e,!1));let Ne=r.parent.kind===284?r.parent:void 0;if(Ne&&Ne.openingElement===r&&rN(Ne.children).length>0){let Tt=qre(Ne,a);if(!V&&we&&we!==""){X&&Qe(_,v._0_are_specified_twice_The_attribute_named_0_will_be_overwritten,Qi(we));let Mt=xT(r.attributes,void 0),mr=Mt&&ET(Mt,we),br=Za(4,we);br.links.type=Tt.length===1?Tt[0]:mr&&ym(mr,s4)?cy(Tt):g_(fi(Tt)),br.valueDeclaration=U.createPropertySignature(void 0,Qi(we),void 0,void 0),lo(br.valueDeclaration,_),br.valueDeclaration.symbol=br;let en=fa();en.set(we,br),I=nx(I,Zt(_.symbol,en,ve,ve,ve),_.symbol,_e,!1)}}if(V)return Me;if(H&&I!==Eu)return Da([H,I]);return H||(I===Eu?pt():I);function pt(){_e|=8192;let Tt=Zt(_.symbol,C,ve,ve,ve);return Tt.objectFlags|=_e|128|131072,Tt}}function qre(r,a){let _=[];for(let h of r.children)if(h.kind===12)h.containsOnlyTriviaWhiteSpaces||_.push(Ue);else{if(h.kind===294&&!h.expression)continue;_.push(d4(h,a))}return _}function pGe(r,a,_){for(let h of bo(r))if(!(h.flags&16777216)){let T=a.get(h.escapedName);if(T){let C=Qe(T.valueDeclaration,v._0_is_specified_more_than_once_so_this_usage_will_be_overwritten,Qi(T.escapedName));ca(C,pn(_,v.This_spread_always_overwrites_this_property))}}}function $5t(r,a){return W5t(r.parent,a)}function lx(r,a){let _=oC(a),h=_&&Rp(_),T=h&&m_(h,r,788968);return T?ac(T):Oe}function zre(r){let a=qn(r);if(!a.resolvedSymbol){let _=lx(Xp.IntrinsicElements,r);if(ao(_))return de&&Qe(r,v.JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists,Qi(Xp.IntrinsicElements)),a.resolvedSymbol=St;{if(!He(r.tagName)&&!sg(r.tagName))return M.fail();let h=sg(r.tagName)?xA(r.tagName):r.tagName.escapedText,T=ma(_,h);if(T)return a.jsxFlags|=1,a.resolvedSymbol=T;let C=LKe(_,Lf(Qi(h)));return C?(a.jsxFlags|=2,a.resolvedSymbol=C):G6(_,h)?(a.jsxFlags|=2,a.resolvedSymbol=_.symbol):(Qe(r,v.Property_0_does_not_exist_on_type_1,LG(r.tagName),"JSX."+Xp.IntrinsicElements),a.resolvedSymbol=St)}}return a.resolvedSymbol}function q2e(r){let a=r&&Ur(r),_=a&&qn(a);if(_&&_.jsxImplicitImportContainer===!1)return;if(_&&_.jsxImplicitImportContainer)return _.jsxImplicitImportContainer;let h=Z9(Q9(q,a),q);if(!h)return;let C=af(q)===1?v.Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_nodenext_or_to_add_aliases_to_the_paths_option:v.Cannot_find_module_0_or_its_corresponding_type_declarations,I=xqt(a,h),V=WE(I||r,h,C,r),H=V&&V!==St?ro(pl(V)):void 0;return _&&(_.jsxImplicitImportContainer=H||!1),H}function oC(r){let a=r&&qn(r);if(a&&a.jsxNamespace)return a.jsxNamespace;if(!a||a.jsxNamespace!==!1){let h=q2e(r);if(!h||h===St){let T=Hb(r);h=xr(r,T,1920,void 0,!1)}if(h){let T=pl(m_(Rp(pl(h)),Xp.JSX,1920));if(T&&T!==St)return a&&(a.jsxNamespace=T),T}a&&(a.jsxNamespace=!1)}let _=pl(WD(Xp.JSX,1920,void 0));if(_!==St)return _}function dGe(r,a){let _=a&&m_(a.exports,r,788968),h=_&&ac(_),T=h&&bo(h);if(T){if(T.length===0)return"";if(T.length===1)return T[0].escapedName;T.length>1&&_.declarations&&Qe(_.declarations[0],v.The_global_type_JSX_0_may_not_have_more_than_one_property,Qi(r))}}function H5t(r){return r&&m_(r.exports,Xp.LibraryManagedAttributes,788968)}function G5t(r){return r&&m_(r.exports,Xp.ElementType,788968)}function Y5t(r){return dGe(Xp.ElementAttributesPropertyNameContainer,r)}function rq(r){return dGe(Xp.ElementChildrenAttributeNameContainer,r)}function mGe(r,a){if(r.flags&4)return[Se];if(r.flags&128){let T=gGe(r,a);return T?[Zre(a,T)]:(Qe(a,v.Property_0_does_not_exist_on_type_1,r.value,"JSX."+Xp.IntrinsicElements),ve)}let _=K_(r),h=Ys(_,1);return h.length===0&&(h=Ys(_,0)),h.length===0&&_.flags&1048576&&(h=UEe(Cr(_.types,T=>mGe(T,a)))),h}function gGe(r,a){let _=lx(Xp.IntrinsicElements,a);if(!ao(_)){let h=r.value,T=ma(_,Uc(h));if(T)return gn(T);let C=dT(_,Ue);return C||void 0}return Me}function K5t(r,a,_){if(r===1){let T=vGe(_);T&&Vd(a,T,Rf,_.tagName,v.Its_return_type_0_is_not_a_valid_JSX_element,h)}else if(r===0){let T=yGe(_);T&&Vd(a,T,Rf,_.tagName,v.Its_instance_type_0_is_not_a_valid_JSX_element,h)}else{let T=vGe(_),C=yGe(_);if(!T||!C)return;let I=fi([T,C]);Vd(a,I,Rf,_.tagName,v.Its_element_type_0_is_not_a_valid_JSX_element,h)}function h(){let T=Hc(_.tagName);return js(void 0,v._0_cannot_be_used_as_a_JSX_component,T)}}function hGe(r){var a;M.assert(Zk(r.tagName));let _=qn(r);if(!_.resolvedJsxElementAttributesType){let h=zre(r);if(_.jsxFlags&1)return _.resolvedJsxElementAttributesType=gn(h)||Oe;if(_.jsxFlags&2){let T=sg(r.tagName)?xA(r.tagName):r.tagName.escapedText;return _.resolvedJsxElementAttributesType=((a=Vk(lx(Xp.IntrinsicElements,r),T))==null?void 0:a.type)||Oe}else return _.resolvedJsxElementAttributesType=Oe}return _.resolvedJsxElementAttributesType}function yGe(r){let a=lx(Xp.ElementClass,r);if(!ao(a))return a}function nq(r){return lx(Xp.Element,r)}function vGe(r){let a=nq(r);if(a)return fi([a,Ke])}function X5t(r){let a=oC(r);if(!a)return;let _=G5t(a);if(!_)return;let h=SGe(_,hn(r));if(!(!h||ao(h)))return h}function SGe(r,a,..._){let h=ac(r);if(r.flags&524288){let T=as(r).typeParameters;if(wt(T)>=_.length){let C=NS(_,T,_.length,a);return wt(C)===0?h:qD(r,C)}}if(wt(h.typeParameters)>=_.length){let T=NS(_,h.typeParameters,_.length,a);return _1(h,T)}}function Q5t(r){let a=lx(Xp.IntrinsicElements,r);return a?bo(a):ve}function Z5t(r){(q.jsx||0)===0&&Qe(r,v.Cannot_use_JSX_unless_the_jsx_flag_is_provided),nq(r)===void 0&&de&&Qe(r,v.JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist)}function z2e(r){let a=__(r);if(a&&GJt(r),Z5t(r),N2e(r),a){let _=r,h=ew(_);tne(h,r);let T=X5t(_);if(T!==void 0){let C=_.tagName,I=Zk(C)?Lf(LG(C)):hs(C);Vd(I,T,Rf,C,v.Its_type_0_is_not_a_valid_JSX_element_type,()=>{let V=Hc(C);return js(void 0,v._0_cannot_be_used_as_a_JSX_component,V)})}else K5t(zGe(_),ko(h),_)}}function Wre(r,a,_){if(r.flags&524288&&(ZE(r,a)||Vk(r,a)||T7(a)&&Gy(r,Ue)||_&&J2e(a)))return!0;if(r.flags&33554432)return Wre(r.baseType,a,_);if(r.flags&3145728&&Y7(r)){for(let h of r.types)if(Wre(h,a,_))return!0}return!1}function Y7(r){return!!(r.flags&524288&&!(Kn(r)&512)||r.flags&67108864||r.flags&33554432&&Y7(r.baseType)||r.flags&1048576&&Pt(r.types,Y7)||r.flags&2097152&&wi(r.types,Y7))}function e9t(r,a){if(KJt(r),r.expression){let _=hs(r.expression,a);return r.dotDotDotToken&&_!==Me&&!Jd(_)&&Qe(r,v.JSX_spread_child_must_be_an_array_type),_}else return Oe}function W2e(r){return r.valueDeclaration?px(r.valueDeclaration):0}function $2e(r){if(r.flags&8192||ll(r)&4)return!0;if(hn(r.valueDeclaration)){let a=r.valueDeclaration.parent;return a&&Pn(a)&&cl(a)===3}}function H2e(r,a,_,h,T,C=!0){let I=C?r.kind===166?r.right:r.kind===205?r:r.kind===208&&r.propertyName?r.propertyName:r.name:void 0;return bGe(r,a,_,h,T,I)}function bGe(r,a,_,h,T,C){var I;let V=xd(T,_);if(a){if(ee<2&&TGe(T))return C&&Qe(C,v.Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword),!1;if(V&64)return C&&Qe(C,v.Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression,rs(T),ln(Yk(T))),!1;if(!(V&256)&&((I=T.declarations)!=null&&I.some(t_e)))return C&&Qe(C,v.Class_field_0_defined_by_the_parent_class_is_not_accessible_in_the_child_class_via_super,rs(T)),!1}if(V&64&&TGe(T)&&(aR(r)||sfe(r)||Yp(r.parent)&&o9(r.parent.parent))){let X=S0(Qu(T));if(X&&zVt(r))return C&&Qe(C,v.Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor,rs(T),Qd(X.name)),!1}if(!(V&6))return!0;if(V&2){let X=S0(Qu(T));return XCe(r,X)?!0:(C&&Qe(C,v.Property_0_is_private_and_only_accessible_within_class_1,rs(T),ln(Yk(T))),!1)}if(a)return!0;let H=RKe(r,X=>{let _e=ac(jn(X));return V$e(_e,T,_)});return!H&&(H=t9t(r),H=H&&V$e(H,T,_),V&256||!H)?(C&&Qe(C,v.Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses,rs(T),ln(Yk(T)||h)),!1):V&256?!0:(h.flags&262144&&(h=h.isThisType?mf(h):Zu(h)),!h||!FD(h,H)?(C&&Qe(C,v.Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_class_2,rs(T),ln(H),ln(h)),!1):!0)}function t9t(r){let a=r9t(r),_=a?.type&&Wi(a.type);if(_&&_.flags&262144&&(_=mf(_)),_&&Kn(_)&7)return LD(_)}function r9t(r){let a=nf(r,!1,!1);return a&&Bs(a)?iE(a):void 0}function TGe(r){return!!LJ(r,a=>!(a.flags&8192))}function QD(r){return hh(hs(r),r)}function iq(r){return Eg(r,50331648)}function G2e(r){return iq(r)?tv(r):r}function n9t(r,a){let _=nc(r)?op(r):void 0;if(r.kind===106){Qe(r,v.The_value_0_cannot_be_used_here,"null");return}if(_!==void 0&&_.length<100){if(He(r)&&_==="undefined"){Qe(r,v.The_value_0_cannot_be_used_here,"undefined");return}Qe(r,a&16777216?a&33554432?v._0_is_possibly_null_or_undefined:v._0_is_possibly_undefined:v._0_is_possibly_null,_)}else Qe(r,a&16777216?a&33554432?v.Object_is_possibly_null_or_undefined:v.Object_is_possibly_undefined:v.Object_is_possibly_null)}function i9t(r,a){Qe(r,a&16777216?a&33554432?v.Cannot_invoke_an_object_which_is_possibly_null_or_undefined:v.Cannot_invoke_an_object_which_is_possibly_undefined:v.Cannot_invoke_an_object_which_is_possibly_null)}function EGe(r,a,_){if(ce&&r.flags&2){if(nc(a)){let T=op(a);if(T.length<100)return Qe(a,v._0_is_of_type_unknown,T),Oe}return Qe(a,v.Object_is_of_type_unknown),Oe}let h=GD(r,50331648);if(h&50331648){_(a,h);let T=tv(r);return T.flags&229376?Oe:T}return r}function hh(r,a){return EGe(r,a,n9t)}function xGe(r,a){let _=hh(r,a);if(_.flags&16384){if(nc(a)){let h=op(a);if(He(a)&&h==="undefined")return Qe(a,v.The_value_0_cannot_be_used_here,h),_;if(h.length<100)return Qe(a,v._0_is_possibly_undefined,h),_}Qe(a,v.Object_is_possibly_undefined)}return _}function $re(r,a,_){return r.flags&64?s9t(r,a):K2e(r,r.expression,QD(r.expression),r.name,a,_)}function s9t(r,a){let _=hs(r.expression),h=B7(_,r.expression);return vre(K2e(r,r.expression,hh(h,r.expression),r.name,a),r,h!==_)}function CGe(r,a){let _=u9(r)&&z1(r.left)?hh(QJ(r.left),r.left):QD(r.left);return K2e(r,r.left,_,r.right,a)}function Y2e(r){for(;r.parent.kind===217;)r=r.parent;return Ig(r.parent)&&r.parent.expression===r}function sq(r,a){for(let _=s9(a);_;_=Ou(_)){let{symbol:h}=_,T=DR(h,r),C=h.members&&h.members.get(T)||h.exports&&h.exports.get(T);if(C)return C}}function a9t(r){if(!Ou(r))return Or(r,v.Private_identifiers_are_not_allowed_outside_class_bodies);if(!Fj(r.parent)){if(!tg(r))return Or(r,v.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression);let a=Pn(r.parent)&&r.parent.operatorToken.kind===103;if(!Hre(r)&&!a)return Or(r,v.Cannot_find_name_0,Nn(r))}return!1}function o9t(r){a9t(r);let a=Hre(r);return a&&oq(a,void 0,!1),Me}function Hre(r){if(!tg(r))return;let a=qn(r);return a.resolvedSymbol===void 0&&(a.resolvedSymbol=sq(r.escapedText,r)),a.resolvedSymbol}function Gre(r,a){return ma(r,a.escapedName)}function c9t(r,a,_){let h,T=bo(r);T&&kt(T,I=>{let V=I.valueDeclaration;if(V&&Wu(V)&&Zi(V.name)&&V.name.escapedText===a.escapedText)return h=I,!0});let C=Op(a);if(h){let I=M.checkDefined(h.valueDeclaration),V=M.checkDefined(Ou(I));if(_?.valueDeclaration){let H=_.valueDeclaration,X=Ou(H);if(M.assert(!!X),Pr(X,_e=>V===_e)){let _e=Qe(a,v.The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_private_identifier_with_the_same_spelling,C,ln(r));return ca(_e,pn(H,v.The_shadowing_declaration_of_0_is_defined_here,C),pn(I,v.The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here,C)),!0}}return Qe(a,v.Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier,C,Op(V.name||fK)),!0}return!1}function AGe(r,a){return(pd(a)||aR(r)&&hg(a))&&nf(r,!0,!1)===G0(a)}function K2e(r,a,_,h,T,C){let I=qn(a).resolvedSymbol,V=fb(r),H=K_(V!==0||Y2e(r)?Qf(_):_),X=Ao(H)||H===In,_e;if(Zi(h)){(ee<9||ee<99||!K)&&(V!==0&&gu(r,1048576),V!==1&&gu(r,524288));let Ne=sq(h.escapedText,h);if(V&&Ne&&Ne.valueDeclaration&&ul(Ne.valueDeclaration)&&Or(h,v.Cannot_assign_to_private_method_0_Private_methods_are_not_writable,Nn(h)),X){if(Ne)return ao(H)?Oe:H;if(s9(h)===void 0)return Or(h,v.Private_identifiers_are_not_allowed_outside_class_bodies),Me}if(_e=Ne&&Gre(_,Ne),_e===void 0){if(c9t(_,h,Ne))return Oe;let pt=s9(h);pt&&AI(Ur(pt),q.checkJs)&&Or(h,v.Private_field_0_must_be_declared_in_an_enclosing_class,Nn(h))}else _e.flags&65536&&!(_e.flags&32768)&&V!==1&&Qe(r,v.Private_accessor_was_defined_without_a_getter)}else{if(X)return He(a)&&I&&Qk(r,2,void 0,_),ao(H)?Oe:H;_e=ma(H,h.escapedText,sne(H),r.kind===166)}Qk(r,2,_e,_);let we;if(_e){let Ne=HCe(_e,h);if(Md(Ne)&&Pxe(r,Ne)&&Ne.declarations&&L0(h,Ne.declarations,h.escapedText),l9t(_e,r,h),oq(_e,r,RGe(a,I)),qn(r).resolvedSymbol=_e,H2e(r,a.kind===108,mA(r),H,_e),bYe(r,_e,V))return Qe(h,v.Cannot_assign_to_0_because_it_is_a_read_only_property,Nn(h)),Oe;we=AGe(r,_e)?tt:C||B9(r)?_T(_e):gn(_e)}else{let Ne=!Zi(h)&&(V===0||!X2(_)||mO(_))?Vk(H,h.escapedText):void 0;if(!(Ne&&Ne.type)){let pt=X2e(r,_.symbol,!0);return!pt&&D7(_)?Me:_.symbol===ct?(ct.exports.has(h.escapedText)&&ct.exports.get(h.escapedText).flags&418?Qe(h,v.Property_0_does_not_exist_on_type_1,Qi(h.escapedText),ln(_)):de&&Qe(h,v.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature,ln(_)),Me):(h.escapedText&&!sc(r)&&PGe(h,mO(_)?H:_,pt),Oe)}Ne.isReadonly&&(kv(r)||NH(r))&&Qe(r,v.Index_signature_in_type_0_only_permits_reading,ln(H)),we=Ne.type,q.noUncheckedIndexedAccess&&fb(r)!==1&&(we=fi([we,Ge])),q.noPropertyAccessFromIndexSignature&&Wn(r)&&Qe(h,v.Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0,Qi(h.escapedText)),Ne.declaration&&sh(Ne.declaration)&&L0(h,[Ne.declaration],h.escapedText)}return kGe(r,_e,we,h,T)}function X2e(r,a,_){var h;let T=Ur(r);if(T&&q.checkJs===void 0&&T.checkJsDirective===void 0&&(T.scriptKind===1||T.scriptKind===2)){let C=kt(a?.declarations,Ur),I=!a?.valueDeclaration||!gi(a.valueDeclaration)||((h=a.valueDeclaration.heritageClauses)==null?void 0:h.length)||Cv(!1,a.valueDeclaration);return!(T!==C&&C&&Tv(C))&&!(_&&a&&a.flags&32&&I)&&!(r&&_&&Wn(r)&&r.expression.kind===110&&I)}return!1}function kGe(r,a,_,h,T){let C=fb(r);if(C===1)return rv(_,!!(a&&a.flags&16777216));if(a&&!(a.flags&98311)&&!(a.flags&8192&&_.flags&1048576)&&!Tne(a.declarations))return _;if(_===tt)return Y6(r,a);_=P2e(_,r,T);let I=!1;if(ce&&me&&oc(r)&&r.expression.kind===110){let H=a&&a.valueDeclaration;if(H&&TKe(H)&&!oa(H)){let X=W7(r);X.kind===176&&X.parent===H.parent&&!(H.flags&33554432)&&(I=!0)}}else ce&&a&&a.valueDeclaration&&Wn(a.valueDeclaration)&&yR(a.valueDeclaration)&&W7(r)===W7(a.valueDeclaration)&&(I=!0);let V=iv(r,_,I?LS(_):_);return I&&!HD(_)&&HD(V)?(Qe(h,v.Property_0_is_used_before_being_assigned,rs(a)),_):C?ev(V):V}function l9t(r,a,_){let{valueDeclaration:h}=r;if(!h||Ur(a).isDeclarationFile)return;let T,C=Nn(_);Q2e(a)&&!z8t(h)&&!(oc(a)&&oc(a.expression))&&!Fm(h,_)&&!(ul(h)&&Ine(h)&256)&&(K||!u9t(r))?T=Qe(_,v.Property_0_is_used_before_its_initialization,C):h.kind===263&&a.parent.kind!==183&&!(h.flags&33554432)&&!Fm(h,_)&&(T=Qe(_,v.Class_0_used_before_its_declaration,C)),T&&ca(T,pn(h,v._0_is_declared_here,C))}function Q2e(r){return!!Pr(r,a=>{switch(a.kind){case 172:return!0;case 303:case 174:case 177:case 178:case 305:case 167:case 239:case 294:case 291:case 292:case 293:case 286:case 233:case 298:return!1;case 219:case 244:return Vs(a.parent)&&Gc(a.parent.parent)?!0:"quit";default:return tg(a)?!1:"quit"}})}function u9t(r){if(!(r.parent.flags&32))return!1;let a=gn(r.parent);for(;;){if(a=a.symbol&&_9t(a),!a)return!1;let _=ma(a,r.escapedName);if(_&&_.valueDeclaration)return!0}}function _9t(r){let a=_i(r);if(a.length!==0)return Da(a)}function PGe(r,a,_){let h,T;if(!Zi(r)&&a.flags&1048576&&!(a.flags&402784252)){for(let I of a.types)if(!ma(I,r.escapedText)&&!Vk(I,r.escapedText)){h=js(h,v.Property_0_does_not_exist_on_type_1,Yo(r),ln(I));break}}if(NGe(r.escapedText,a)){let I=Yo(r),V=ln(a);h=js(h,v.Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead,I,V,V+"."+I)}else{let I=nL(a);if(I&&ma(I,r.escapedText))h=js(h,v.Property_0_does_not_exist_on_type_1,Yo(r),ln(a)),T=pn(r,v.Did_you_forget_to_use_await);else{let V=Yo(r),H=ln(a),X=d9t(V,a);if(X!==void 0)h=js(h,v.Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2_or_later,V,H,X);else{let _e=Z2e(r,a);if(_e!==void 0){let we=Qc(_e),Ne=_?v.Property_0_may_not_exist_on_type_1_Did_you_mean_2:v.Property_0_does_not_exist_on_type_1_Did_you_mean_2;h=js(h,Ne,V,H,we),T=_e.valueDeclaration&&pn(_e.valueDeclaration,v._0_is_declared_here,we)}else{let we=f9t(a)?v.Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom:v.Property_0_does_not_exist_on_type_1;h=js(YEe(h,a),we,V,H)}}}}let C=ky(Ur(r),r,h);T&&ca(C,T),Mm(!_||h.code!==v.Property_0_may_not_exist_on_type_1_Did_you_mean_2.code,C)}function f9t(r){return q.lib&&!q.lib.includes("dom")&&bFt(r,a=>a.symbol&&/^(EventTarget|Node|((HTML[a-zA-Z]*)?Element))$/.test(Qi(a.symbol.escapedName)))&&Z0(r)}function NGe(r,a){let _=a.symbol&&ma(gn(a.symbol),r);return _!==void 0&&!!_.valueDeclaration&&oa(_.valueDeclaration)}function p9t(r){let a=Op(r),h=rH().get(a);return h&&_3(h.keys())}function d9t(r,a){let _=K_(a).symbol;if(!_)return;let h=Qc(_),C=rH().get(h);if(C){for(let[I,V]of C)if(Es(V,r))return I}}function DGe(r,a){return aq(r,bo(a),106500)}function Z2e(r,a){let _=bo(a);if(typeof r!="string"){let h=r.parent;Wn(h)&&(_=Zn(_,T=>MGe(h,a,T))),r=Nn(r)}return aq(r,_,111551)}function wGe(r,a){let _=bs(r)?r:Nn(r),h=bo(a);return(_==="for"?Ln(h,C=>Qc(C)==="htmlFor"):_==="class"?Ln(h,C=>Qc(C)==="className"):void 0)??aq(_,h,111551)}function IGe(r,a){let _=Z2e(r,a);return _&&Qc(_)}function m9t(r,a,_){let h=m_(r,a,_);if(h)return h;let T;return r===De?T=Gi(["string","number","boolean","object","bigint","symbol"],I=>r.has(I.charAt(0).toUpperCase()+I.slice(1))?Za(524288,I):void 0).concat(Is(r.values())):T=Is(r.values()),aq(Qi(a),T,_)}function OGe(r,a,_){return M.assert(a!==void 0,"outername should always be defined"),jr(r,a,_,void 0,!1,!1)}function eCe(r,a){return a.exports&&aq(Nn(r),$E(a),2623475)}function g9t(r,a,_){function h(I){let V=ZE(r,I);if(V){let H=lC(gn(V));return!!H&&Sh(H)>=1&&ga(_,xg(H,0))}return!1}let T=kv(a)?"set":"get";if(!h(T))return;let C=VR(a.expression);return C===void 0?C=T:C+="."+T,C}function h9t(r,a){let _=a.types.filter(h=>!!(h.flags&128));return Fx(r.value,_,h=>h.value)}function aq(r,a,_){return Fx(r,a,h);function h(T){let C=Qc(T);if(!_s(C,'"')){if(T.flags&_)return C;if(T.flags&2097152){let I=q0(T);if(I&&I.flags&_)return C}}}}function oq(r,a,_){let h=r&&r.flags&106500&&r.valueDeclaration;if(!h)return;let T=up(h,2),C=r.valueDeclaration&&Wu(r.valueDeclaration)&&Zi(r.valueDeclaration.name);if(!(!T&&!C)&&!(a&&B9(a)&&!(r.flags&65536))){if(_){let I=Pr(a,Go);if(I&&I.symbol===r)return}(ll(r)&1?as(r).target:r).isReferenced=-1}}function RGe(r,a){return r.kind===110||!!a&&nc(r)&&a===gf(_p(r))}function y9t(r,a){switch(r.kind){case 211:return tCe(r,r.expression.kind===108,a,Qf(hs(r.expression)));case 166:return tCe(r,!1,a,Qf(hs(r.left)));case 205:return tCe(r,!1,a,Wi(r))}}function MGe(r,a,_){return rCe(r,r.kind===211&&r.expression.kind===108,!1,a,_)}function tCe(r,a,_,h){if(Ao(h))return!0;let T=ma(h,_);return!!T&&rCe(r,a,!1,h,T)}function rCe(r,a,_,h,T){if(Ao(h))return!0;if(T.valueDeclaration&&j_(T.valueDeclaration)){let C=Ou(T.valueDeclaration);return!S_(r)&&!!Pr(r,I=>I===C)}return bGe(r,a,_,h,T)}function v9t(r){let a=r.initializer;if(a.kind===261){let _=a.declarations[0];if(_&&!Hs(_.name))return jn(_)}else if(a.kind===80)return gf(a)}function S9t(r){return X_(r).length===1&&!!Gy(r,Te)}function b9t(r){let a=So(r);if(a.kind===80){let _=gf(a);if(_.flags&3){let h=r,T=r.parent;for(;T;){if(T.kind===249&&h===T.statement&&v9t(T)===_&&S9t(t_(T.expression)))return!0;h=T,T=T.parent}}}return!1}function T9t(r,a){return r.flags&64?E9t(r,a):LGe(r,QD(r.expression),a)}function E9t(r,a){let _=hs(r.expression),h=B7(_,r.expression);return vre(LGe(r,hh(h,r.expression),a),r,h!==_)}function LGe(r,a,_){let h=fb(r)!==0||Y2e(r)?Qf(a):a,T=r.argumentExpression,C=hs(T);if(ao(h)||h===In)return h;if(sne(h)&&!No(T))return Qe(T,v.A_const_enum_member_can_only_be_accessed_using_a_string_literal),Oe;let I=b9t(T)?Te:C,V=fb(r),H;V===0?H=32:(H=4|(X2(h)&&!mO(h)?2:0),V===2&&(H|=32));let X=wS(h,I,H,r)||Oe;return JYe(kGe(r,qn(r).resolvedSymbol,X,T,_),r)}function FGe(r){return Ig(r)||hE(r)||__(r)}function cC(r){return FGe(r)&&kt(r.typeArguments,ja),r.kind===215?hs(r.template):__(r)?hs(r.attributes):Pn(r)?hs(r.left):Ig(r)&&kt(r.arguments,a=>{hs(a)}),Se}function yh(r){return cC(r),ae}function x9t(r,a,_){let h,T,C=0,I,V=-1,H;M.assert(!a.length);for(let X of r){let _e=X.declaration&&jn(X.declaration),we=X.declaration&&X.declaration.parent;!T||_e===T?h&&we===h?I=I+1:(h=we,I=C):(I=C=a.length,h=we),T=_e,yK(X)?(V++,H=V,C++):H=I,a.splice(H,0,_?f8t(X,_):X)}}function Yre(r){return!!r&&(r.kind===230||r.kind===237&&r.isSpread)}function nCe(r){return Bo(r,Yre)}function jGe(r){return!!(r.flags&16384)}function C9t(r){return!!(r.flags&49155)}function Kre(r,a,_,h=!1){let T,C=!1,I=ep(_),V=Sh(_);if(r.kind===215)if(T=a.length,r.template.kind===228){let H=Va(r.template.templateSpans);C=$c(H.literal)||!!H.literal.isUnterminated}else{let H=r.template;M.assert(H.kind===15),C=!!H.isUnterminated}else if(r.kind===170)T=$Ge(r,_);else if(r.kind===226)T=1;else if(__(r)){if(C=r.attributes.end===r.end,C)return!0;T=V===0?a.length:1,I=a.length===0?I:1,V=Math.min(V,1)}else if(r.arguments){T=h?a.length+1:a.length,C=r.arguments.end===r.end;let H=nCe(a);if(H>=0)return H>=Sh(_)&&(uy(_)||H<ep(_))}else return M.assert(r.kind===214),Sh(_)===0;if(!uy(_)&&T>I)return!1;if(C||T>=V)return!0;for(let H=T;H<V;H++){let X=xg(_,H);if(Fl(X,hn(r)&&!ce?C9t:jGe).flags&131072)return!1}return!0}function iCe(r,a){let _=wt(r.typeParameters),h=ph(r.typeParameters);return!Pt(a)||a.length>=h&&a.length<=_}function BGe(r,a){let _;return!!(r.target&&(_=ux(r.target,a))&&Wk(_))}function lC(r){return K7(r,0,!1)}function UGe(r){return K7(r,0,!1)||K7(r,1,!1)}function K7(r,a,_){if(r.flags&524288){let h=Sg(r);if(_||h.properties.length===0&&h.indexInfos.length===0){if(a===0&&h.callSignatures.length===1&&h.constructSignatures.length===0)return h.callSignatures[0];if(a===1&&h.constructSignatures.length===1&&h.callSignatures.length===0)return h.constructSignatures[0]}}}function VGe(r,a,_,h){let T=J7(r.typeParameters,r,0,h),C=X7(a),I=_&&(C&&C.flags&262144?_.nonFixingMapper:_.mapper),V=I?Gk(a,I):a;return i2e(V,r,(H,X)=>{nv(T.inferences,H,X)}),_||s2e(a,r,(H,X)=>{nv(T.inferences,H,X,128)}),A7(r,h2e(T),hn(a.declaration))}function A9t(r,a,_,h){let T=Vre(a,r),C=tw(r.attributes,T,h,_);return nv(h.inferences,C,T),h2e(h)}function JGe(r){if(!r)return dn;let a=hs(r);return zfe(r)?a:dI(r.parent)?tv(a):S_(r.parent)?yre(a):a}function sCe(r,a,_,h,T){if(__(r))return A9t(r,a,h,T);if(r.kind!==170&&r.kind!==226){let H=wi(a.typeParameters,_e=>!!H2(_e)),X=hf(r,H?8:0);if(X){let _e=ko(a);if(FS(_e)){let we=cx(r);if(!(!H&&hf(r,8)!==X)){let Mt=l2e(MLt(we,1)),mr=os(X,Mt),br=lC(mr),en=br&&br.typeParameters?G2(ixe(br,br.typeParameters)):mr;nv(T.inferences,en,_e,128)}let pt=J7(a.typeParameters,a,T.flags),Tt=os(X,we&&we.returnMapper);nv(pt.inferences,Tt,_e),T.returnMapper=Pt(pt.inferences,rw)?l2e(BLt(pt)):void 0}}}let C=Q7(a),I=C?Math.min(ep(a)-1,_.length):_.length;if(C&&C.flags&262144){let H=Ln(T.inferences,X=>X.typeParameter===C);H&&(H.impliedArity=Bo(_,Yre,I)<0?_.length-I:void 0)}let V=mT(a);if(V&&FS(V)){let H=WGe(r);nv(T.inferences,JGe(H),V)}for(let H=0;H<I;H++){let X=_[H];if(X.kind!==232){let _e=xg(a,H);if(FS(_e)){let we=tw(X,_e,T,h);nv(T.inferences,we,_e)}}}if(C&&FS(C)){let H=aCe(_,I,_.length,C,T,h);nv(T.inferences,H,C)}return h2e(T)}function qGe(r){return r.flags&1048576?wc(r,qGe):r.flags&1||jJ(Zu(r)||r)?r:Ha(r)?cy(rx(r),r.target.elementFlags,!1,r.target.labeledElementDeclarations):cy([r],[8])}function aCe(r,a,_,h,T,C){let I=$2(h);if(a>=_-1){let _e=r[_-1];if(Yre(_e)){let we=_e.kind===237?_e.type:tw(_e.expression,h,T,C);return g1(we)?qGe(we):g_(y1(33,we,nr,_e.kind===230?_e.expression:_e),I)}}let V=[],H=[],X=[];for(let _e=a;_e<_;_e++){let we=r[_e];if(Yre(we)){let Ne=we.kind===237?we.type:hs(we.expression);g1(Ne)?(V.push(Ne),H.push(8)):(V.push(y1(33,Ne,nr,we.kind===230?we.expression:we)),H.push(4))}else{let Ne=Ha(h)?j2e(h,_e-a,_-a)||Rt:Kf(h,zm(_e-a),256),pt=tw(we,Ne,T,C),Tt=I||dl(Ne,406978556);V.push(Tt?Q_(pt):ST(pt)),H.push(1)}we.kind===237&&we.tupleNameSource?X.push(we.tupleNameSource):X.push(void 0)}return cy(V,H,I&&!ym(h,Qxe),X)}function oCe(r,a,_,h){let T=hn(r.declaration),C=r.typeParameters,I=NS(Cr(a,Wi),C,ph(C),T),V;for(let H=0;H<a.length;H++){M.assert(C[H]!==void 0,"Should not call checkTypeArguments with too many type arguments");let X=mf(C[H]);if(X){let _e=_&&h?()=>js(void 0,v.Type_0_does_not_satisfy_the_constraint_1):void 0,we=h||v.Type_0_does_not_satisfy_the_constraint_1;V||(V=Xf(C,I));let Ne=I[H];if(!I_(Ne,bp(os(X,V),Ne),_?a[H]:void 0,we,_e))return}}return I}function zGe(r){if(Zk(r.tagName))return 2;let a=K_(hs(r.tagName));return wt(Ys(a,1))?0:wt(Ys(a,0))?1:2}function k9t(r,a,_,h,T,C,I){let V=Vre(a,r),H=tw(r.attributes,V,void 0,h),X=h&4?V7(H):H;return _e()&&Jxe(X,V,_,T?r.tagName:void 0,r.attributes,void 0,C,I);function _e(){var we;if(q2e(r))return!0;let Ne=(Yg(r)||u2(r))&&!(Zk(r.tagName)||sg(r.tagName))?hs(r.tagName):void 0;if(!Ne)return!0;let pt=Ys(Ne,0);if(!wt(pt))return!0;let Tt=GKe(r);if(!Tt)return!0;let Mt=nl(Tt,111551,!0,!1,r);if(!Mt)return!0;let mr=gn(Mt),br=Ys(mr,0);if(!wt(br))return!0;let en=!1,Fn=0;for(let zr of br){let Qr=xg(zr,0),$n=Ys(Qr,0);if(wt($n))for(let ii of $n){if(en=!0,uy(ii))return!0;let si=ep(ii);si>Fn&&(Fn=si)}}if(!en)return!0;let Dr=1/0;for(let zr of pt){let Qr=Sh(zr);Qr<Dr&&(Dr=Qr)}if(Dr<=Fn)return!0;if(T){let zr=pn(r.tagName,v.Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3,op(r.tagName),Dr,op(Tt),Fn),Qr=(we=vm(r.tagName))==null?void 0:we.valueDeclaration;Qr&&ca(zr,pn(Qr,v._0_is_declared_here,op(r.tagName))),I&&I.skipLogging&&(I.errors||(I.errors=[])).push(zr),I.skipLogging||_o.add(zr)}return!1}}function Xre(r){return r=So(r),Mj(r)?So(r.expression):r}function cq(r,a,_,h,T,C,I,V){let H={errors:void 0,skipLogging:!0};if(__(r))return k9t(r,_,h,T,C,I,H)?void 0:(M.assert(!C||!!H.errors,"jsx should have errors when reporting errors"),H.errors||ve);let X=mT(_);if(X&&X!==dn&&!(gE(r)||ea(r)&&Cf(r.expression))){let Tt=WGe(r),Mt=JGe(Tt),mr=C?Tt||r:void 0,br=v.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1;if(!Vd(Mt,X,h,mr,br,I,H))return M.assert(!C||!!H.errors,"this parameter should have errors when reporting errors"),H.errors||ve}let _e=v.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1,we=Q7(_),Ne=we?Math.min(ep(_)-1,a.length):a.length;for(let Tt=0;Tt<Ne;Tt++){let Mt=a[Tt];if(Mt.kind!==232){let mr=xg(_,Tt),br=tw(Mt,mr,void 0,T),en=T&4?V7(br):br,Fn=V?os(en,V.nonFixingMapper):en,Dr=Xre(Mt);if(!Jxe(Fn,mr,h,C?Dr:void 0,Dr,_e,I,H))return M.assert(!C||!!H.errors,"parameter should have errors when reporting errors"),pt(Mt,Fn,mr),H.errors||ve}}if(we){let Tt=aCe(a,Ne,a.length,we,void 0,T),Mt=a.length-Ne,mr=C?Mt===0?r:Mt===1?Xre(a[Ne]):qg(lq(r,Tt),a[Ne].pos,a[a.length-1].end):void 0;if(!Vd(Tt,we,h,mr,_e,void 0,H))return M.assert(!C||!!H.errors,"rest parameter should have errors when reporting errors"),pt(mr,Tt,we),H.errors||ve}return;function pt(Tt,Mt,mr){if(Tt&&C&&H.errors&&H.errors.length){if(m4(mr))return;let br=m4(Mt);br&&mh(br,mr,h)&&ca(H.errors[0],pn(Tt,v.Did_you_forget_to_use_await))}}}function WGe(r){if(r.kind===226)return r.right;let a=r.kind===213?r.expression:r.kind===215?r.tag:r.kind===170&&!pe?r.expression:void 0;if(a){let _=Ml(a);if(oc(_))return _.expression}}function lq(r,a,_,h){let T=Cb.createSyntheticExpression(a,_,h);return Et(T,r),lo(T,r),T}function Qre(r){if(r.kind===215){let h=r.template,T=[lq(h,lMt())];return h.kind===228&&kt(h.templateSpans,C=>{T.push(C.expression)}),T}if(r.kind===170)return P9t(r);if(r.kind===226)return[r.left];if(__(r))return r.attributes.properties.length>0||Yg(r)&&r.parent.children.length>0?[r.attributes]:ve;let a=r.arguments||ve,_=nCe(a);if(_>=0){let h=a.slice(0,_);for(let T=_;T<a.length;T++){let C=a[T],I=C.kind===230&&(d_?hs(C.expression):yl(C.expression));I&&Ha(I)?kt(rx(I),(V,H)=>{var X;let _e=I.target.elementFlags[H],we=lq(C,_e&4?g_(V):V,!!(_e&12),(X=I.target.labeledElementDeclarations)==null?void 0:X[H]);h.push(we)}):h.push(C)}return h}return a}function P9t(r){let a=r.expression,_=vCe(r);if(_){let h=[];for(let T of _.parameters){let C=gn(T);h.push(lq(a,C))}return h}return M.fail()}function $Ge(r,a){return q.experimentalDecorators?N9t(r,a):Math.min(Math.max(ep(a),1),2)}function N9t(r,a){switch(r.parent.kind){case 263:case 231:return 1;case 172:return Ug(r.parent)?3:2;case 174:case 177:case 178:return a.parameters.length<=2?2:3;case 169:return 3;default:return M.fail()}}function HGe(r){let a=Ur(r),{start:_,length:h}=Yx(a,Wn(r.expression)?r.expression.name:r.expression);return{start:_,length:h,sourceFile:a}}function uq(r,a,..._){if(ea(r)){let{sourceFile:h,start:T,length:C}=HGe(r);return"message"in a?bu(h,T,C,a,..._):pH(h,a)}else return"message"in a?pn(r,a,..._):ky(Ur(r),r,a)}function D9t(r){return Ig(r)?Wn(r.expression)?r.expression.name:r.expression:hE(r)?Wn(r.tag)?r.tag.name:r.tag:__(r)?r.tagName:r}function w9t(r){if(!ea(r)||!He(r.expression))return!1;let a=xr(r.expression,r.expression.escapedText,111551,void 0,!1),_=a?.valueDeclaration;if(!_||!ns(_)||!K1(_.parent)||!gE(_.parent.parent)||!He(_.parent.parent.expression))return!1;let h=mxe(!1);return h?vm(_.parent.parent.expression,!0)===h:!1}function GGe(r,a,_,h){var T;let C=nCe(_);if(C>-1)return pn(_[C],v.A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter);let I=Number.POSITIVE_INFINITY,V=Number.NEGATIVE_INFINITY,H=Number.NEGATIVE_INFINITY,X=Number.POSITIVE_INFINITY,_e;for(let Mt of a){let mr=Sh(Mt),br=ep(Mt);mr<I&&(I=mr,_e=Mt),V=Math.max(V,br),mr<_.length&&mr>H&&(H=mr),_.length<br&&br<X&&(X=br)}let we=Pt(a,uy),Ne=we?I:I<V?I+"-"+V:I,pt=!we&&Ne===1&&_.length===0&&w9t(r);if(pt&&hn(r))return uq(r,v.Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments);let Tt=fu(r)?we?v.The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_at_least_0:v.The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_0:we?v.Expected_at_least_0_arguments_but_got_1:pt?v.Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise:v.Expected_0_arguments_but_got_1;if(I<_.length&&_.length<V){if(h){let Mt=js(void 0,v.No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments,_.length,H,X);return Mt=js(Mt,h),uq(r,Mt)}return uq(r,v.No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments,_.length,H,X)}else if(_.length<I){let Mt;if(h){let br=js(void 0,Tt,Ne,_.length);br=js(br,h),Mt=uq(r,br)}else Mt=uq(r,Tt,Ne,_.length);let mr=(T=_e?.declaration)==null?void 0:T.parameters[_e.thisParameter?_.length+1:_.length];if(mr){let br=Hs(mr.name)?[v.An_argument_matching_this_binding_pattern_was_not_provided]:Fh(mr)?[v.Arguments_for_the_rest_parameter_0_were_not_provided,Nn(_p(mr.name))]:[v.An_argument_for_0_was_not_provided,mr.name?Nn(_p(mr.name)):_.length],en=pn(mr,...br);return ca(Mt,en)}return Mt}else{let Mt=U.createNodeArray(_.slice(V)),mr=Ma(Mt).pos,br=Va(Mt).end;if(br===mr&&br++,qg(Mt,mr,br),h){let en=js(void 0,Tt,Ne,_.length);return en=js(en,h),Z3(Ur(r),Mt,en)}return qP(Ur(r),Mt,Tt,Ne,_.length)}}function I9t(r,a,_,h){let T=_.length;if(a.length===1){let V=a[0],H=ph(V.typeParameters),X=wt(V.typeParameters);if(h){let _e=js(void 0,v.Expected_0_type_arguments_but_got_1,H<X?H+"-"+X:H,T);return _e=js(_e,h),Z3(Ur(r),_,_e)}return qP(Ur(r),_,v.Expected_0_type_arguments_but_got_1,H<X?H+"-"+X:H,T)}let C=-1/0,I=1/0;for(let V of a){let H=ph(V.typeParameters),X=wt(V.typeParameters);H>T?I=Math.min(I,H):X<T&&(C=Math.max(C,X))}if(C!==-1/0&&I!==1/0){if(h){let V=js(void 0,v.No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments,T,C,I);return V=js(V,h),Z3(Ur(r),_,V)}return qP(Ur(r),_,v.No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments,T,C,I)}if(h){let V=js(void 0,v.Expected_0_type_arguments_but_got_1,C===-1/0?I:C,T);return V=js(V,h),Z3(Ur(r),_,V)}return qP(Ur(r),_,v.Expected_0_type_arguments_but_got_1,C===-1/0?I:C,T)}function ZD(r,a,_,h,T,C){let I=r.kind===215,V=r.kind===170,H=__(r),X=r.kind===226,_e=!F&&!_,we;!V&&!X&&!Kx(r)&&(we=r.typeArguments,(I||H||r.expression.kind!==108)&&kt(we,ja));let Ne=_||[];x9t(a,Ne,T),M.assert(Ne.length,"Revert #54442 and add a testcase with whatever triggered this");let pt=Qre(r),Tt=Ne.length===1&&!Ne[0].typeParameters,Mt=!V&&!Tt&&Pt(pt,Ud)?4:0,mr,br,en,Fn,Dr=!!(h&16)&&r.kind===213&&r.arguments.hasTrailingComma;if(Ne.length>1&&(Fn=Qr(Ne,ih,Tt,Dr)),Fn||(Fn=Qr(Ne,Rf,Tt,Dr)),Fn)return Fn;if(Fn=O9t(r,Ne,pt,!!_,h),qn(r).resolvedSignature=Fn,_e)if(!C&&X&&(C=v.The_left_hand_side_of_an_instanceof_expression_must_be_assignable_to_the_first_argument_of_the_right_hand_side_s_Symbol_hasInstance_method),mr)if(mr.length===1||mr.length>3){let $n=mr[mr.length-1],ii;mr.length>3&&(ii=js(ii,v.The_last_overload_gave_the_following_error),ii=js(ii,v.No_overload_matches_this_call)),C&&(ii=js(ii,C));let si=cq(r,pt,$n,Rf,0,!0,()=>ii,void 0);if(si)for(let Ea of si)$n.declaration&&mr.length>3&&ca(Ea,pn($n.declaration,v.The_last_overload_is_declared_here)),zr($n,Ea),_o.add(Ea);else M.fail("No error for last overload signature")}else{let $n=[],ii=0,si=Number.MAX_VALUE,Ea=0,Ks=0;for(let sl of mr){let rn=cq(r,pt,sl,Rf,0,!0,()=>js(void 0,v.Overload_0_of_1_2_gave_the_following_error,Ks+1,Ne.length,TS(sl)),void 0);rn?(rn.length<=si&&(si=rn.length,Ea=Ks),ii=Math.max(ii,rn.length),$n.push(rn)):M.fail("No error for 3 or fewer overload signatures"),Ks++}let no=ii>1?$n[Ea]:ef($n);M.assert(no.length>0,"No errors reported for 3 or fewer overload signatures");let Os=js(Cr(no,B_e),v.No_overload_matches_this_call);C&&(Os=js(Os,C));let Rc=[...va(no,sl=>sl.relatedInformation)],r_;if(wi(no,sl=>sl.start===no[0].start&&sl.length===no[0].length&&sl.file===no[0].file)){let{file:sl,start:Jr,length:rn}=no[0];r_={file:sl,start:Jr,length:rn,code:Os.code,category:Os.category,messageText:Os,relatedInformation:Rc}}else r_=ky(Ur(r),D9t(r),Os,Rc);zr(mr[0],r_),_o.add(r_)}else if(br)_o.add(GGe(r,[br],pt,C));else if(en)oCe(en,r.typeArguments,!0,C);else{let $n=Zn(a,ii=>iCe(ii,we));$n.length===0?_o.add(I9t(r,a,we,C)):_o.add(GGe(r,$n,pt,C))}return Fn;function zr($n,ii){var si,Ea;let Ks=mr,no=br,Os=en,Rc=((Ea=(si=$n.declaration)==null?void 0:si.symbol)==null?void 0:Ea.declarations)||ve,sl=Rc.length>1?Ln(Rc,Jr=>Go(Jr)&&Yd(Jr.body)):void 0;if(sl){let Jr=md(sl),rn=!Jr.typeParameters;Qr([Jr],Rf,rn)&&ca(ii,pn(sl,v.The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_are_not_externally_visible))}mr=Ks,br=no,en=Os}function Qr($n,ii,si,Ea=!1){var Ks,no;if(mr=void 0,br=void 0,en=void 0,si){let Os=$n[0];if(Pt(we)||!Kre(r,pt,Os,Ea))return;if(cq(r,pt,Os,ii,0,!1,void 0,void 0)){mr=[Os];return}return Os}for(let Os=0;Os<$n.length;Os++){let Rc=$n[Os];if(!iCe(Rc,we)||!Kre(r,pt,Rc,Ea))continue;let r_,sl;if(Rc.typeParameters){let rn=((no=(Ks=Rc.typeParameters[0].symbol.declarations)==null?void 0:Ks[0])==null?void 0:no.parent)||(Rc.declaration&&Vc(Rc.declaration)?Rc.declaration.parent:Rc.declaration);rn&&Pr(r,Dn=>Dn===rn)&&(Rc=eMt(Rc));let $i;if(Pt(we)){if($i=oCe(Rc,we,!1),!$i){en=Rc;continue}}else sl=J7(Rc.typeParameters,Rc,hn(r)?2:0),$i=Yy(sCe(r,Rc,pt,Mt|8,sl),sl.nonFixingMapper),Mt|=sl.flags&4?8:0;if(r_=A7(Rc,$i,hn(Rc.declaration),sl&&sl.inferredTypeParameters),Q7(Rc)&&!Kre(r,pt,r_,Ea)){br=r_;continue}}else r_=Rc;if(cq(r,pt,r_,ii,Mt,!1,void 0,sl)){(mr||(mr=[])).push(r_);continue}if(Mt){if(Mt=0,sl){let Jr=Yy(sCe(r,Rc,pt,Mt,sl),sl.mapper);if(r_=A7(Rc,Jr,hn(Rc.declaration),sl.inferredTypeParameters),Q7(Rc)&&!Kre(r,pt,r_,Ea)){br=r_;continue}}if(cq(r,pt,r_,ii,Mt,!1,void 0,sl)){(mr||(mr=[])).push(r_);continue}}return $n[Os]=r_,r_}}}function O9t(r,a,_,h,T){return M.assert(a.length>0),eP(r),h||a.length===1||a.some(C=>!!C.typeParameters)?L9t(r,a,_,T):R9t(a)}function R9t(r){let a=Gi(r,H=>H.thisParameter),_;a.length&&(_=YGe(a,a.map(pq)));let{min:h,max:T}=kpe(r,M9t),C=[];for(let H=0;H<T;H++){let X=Gi(r,_e=>E_(_e)?H<_e.parameters.length-1?_e.parameters[H]:Va(_e.parameters):H<_e.parameters.length?_e.parameters[H]:void 0);M.assert(X.length!==0),C.push(YGe(X,Gi(r,_e=>ux(_e,H))))}let I=Gi(r,H=>E_(H)?Va(H.parameters):void 0),V=128;if(I.length!==0){let H=g_(fi(Gi(r,vWe),2));C.push(KGe(I,H)),V|=1}return r.some(yK)&&(V|=2),Hy(r[0].declaration,void 0,_,C,Da(r.map(ko)),void 0,h,V)}function M9t(r){let a=r.parameters.length;return E_(r)?a-1:a}function YGe(r,a){return KGe(r,fi(a,2))}function KGe(r,a){return tC(Ma(r),a)}function L9t(r,a,_,h){let T=B9t(a,mt===void 0?_.length:mt),C=a[T],{typeParameters:I}=C;if(!I)return C;let V=FGe(r)?r.typeArguments:void 0,H=V?Vte(C,F9t(V,I,hn(r))):j9t(r,I,C,_,h);return a[T]=H,H}function F9t(r,a,_){let h=r.map(tP);for(;h.length>a.length;)h.pop();for(;h.length<a.length;)h.push(H2(a[h.length])||mf(a[h.length])||g2e(_));return h}function j9t(r,a,_,h,T){let C=J7(a,_,hn(r)?2:0),I=sCe(r,_,h,T|4|8,C);return Vte(_,I)}function B9t(r,a){let _=-1,h=-1;for(let T=0;T<r.length;T++){let C=r[T],I=ep(C);if(uy(C)||I>=a)return T;I>h&&(h=I,_=T)}return _}function U9t(r,a,_){if(r.expression.kind===108){let H=Lre(r.expression);if(Ao(H)){for(let X of r.arguments)hs(X);return Se}if(!ao(H)){let X=Fg(Ou(r));if(X){let _e=pT(H,X.typeArguments,X);return ZD(r,_e,a,_,0)}}return cC(r)}let h,T=hs(r.expression);if(qx(r)){let H=B7(T,r.expression);h=H===T?0:mI(r)?16:8,T=H}else h=0;if(T=EGe(T,r.expression,i9t),T===In)return Ot;let C=K_(T);if(ao(C))return yh(r);let I=Ys(C,0),V=Ys(C,1).length;if(_q(T,C,I.length,V))return!ao(T)&&r.typeArguments&&Qe(r,v.Untyped_function_calls_may_not_accept_type_arguments),cC(r);if(!I.length){if(V)Qe(r,v.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new,ln(T));else{let H;if(r.arguments.length===1){let X=Ur(r).text;v_(X.charCodeAt(Ja(X,r.expression.end,!0)-1))&&(H=pn(r.expression,v.Are_you_missing_a_semicolon))}lCe(r.expression,C,0,H)}return yh(r)}return _&8&&!r.typeArguments&&I.some(V9t)?(wYe(r,_),Ye):I.some(H=>hn(H.declaration)&&!!N$(H.declaration))?(Qe(r,v.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new,ln(T)),yh(r)):ZD(r,I,a,_,h)}function V9t(r){return!!(r.typeParameters&&rAe(ko(r)))}function _q(r,a,_,h){return Ao(r)||Ao(a)&&!!(r.flags&262144)||!_&&!h&&!(a.flags&1048576)&&!(bg(a).flags&131072)&&ga(r,$l)}function J9t(r,a,_){let h=QD(r.expression);if(h===In)return Ot;if(h=K_(h),ao(h))return yh(r);if(Ao(h))return r.typeArguments&&Qe(r,v.Untyped_function_calls_may_not_accept_type_arguments),cC(r);let T=Ys(h,1);if(T.length){if(!q9t(r,T[0]))return yh(r);if(XGe(T,V=>!!(V.flags&4)))return Qe(r,v.Cannot_create_an_instance_of_an_abstract_class),yh(r);let I=h.symbol&&S0(h.symbol);return I&&li(I,64)?(Qe(r,v.Cannot_create_an_instance_of_an_abstract_class),yh(r)):ZD(r,T,a,_,0)}let C=Ys(h,0);if(C.length){let I=ZD(r,C,a,_,0);return de||(I.declaration&&!vh(I.declaration)&&ko(I)!==dn&&Qe(r,v.Only_a_void_function_can_be_called_with_the_new_keyword),mT(I)===dn&&Qe(r,v.A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void)),I}return lCe(r.expression,h,1),yh(r)}function XGe(r,a){return Rs(r)?Pt(r,_=>XGe(_,a)):r.compositeKind===1048576?Pt(r.compositeSignatures,a):a(r)}function cCe(r,a){let _=_i(a);if(!wt(_))return!1;let h=_[0];if(h.flags&2097152){let T=h.types,C=eWe(T),I=0;for(let V of h.types){if(!C[I]&&Kn(V)&3&&(V.symbol===r||cCe(r,V)))return!0;I++}return!1}return h.symbol===r?!0:cCe(r,h)}function q9t(r,a){if(!a||!a.declaration)return!0;let _=a.declaration,h=fA(_,6);if(!h||_.kind!==176)return!0;let T=S0(_.parent.symbol),C=ac(_.parent.symbol);if(!XCe(r,T)){let I=Ou(r);if(I&&h&4){let V=tP(I);if(cCe(_.parent.symbol,V))return!0}return h&2&&Qe(r,v.Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration,ln(C)),h&4&&Qe(r,v.Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration,ln(C)),!1}return!0}function QGe(r,a,_){let h,T=_===0,C=_C(a),I=C&&Ys(C,_).length>0;if(a.flags&1048576){let H=a.types,X=!1;for(let _e of H)if(Ys(_e,_).length!==0){if(X=!0,h)break}else if(h||(h=js(h,T?v.Type_0_has_no_call_signatures:v.Type_0_has_no_construct_signatures,ln(_e)),h=js(h,T?v.Not_all_constituents_of_type_0_are_callable:v.Not_all_constituents_of_type_0_are_constructable,ln(a))),X)break;X||(h=js(void 0,T?v.No_constituent_of_type_0_is_callable:v.No_constituent_of_type_0_is_constructable,ln(a))),h||(h=js(h,T?v.Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_other:v.Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_with_each_other,ln(a)))}else h=js(h,T?v.Type_0_has_no_call_signatures:v.Type_0_has_no_construct_signatures,ln(a));let V=T?v.This_expression_is_not_callable:v.This_expression_is_not_constructable;if(ea(r.parent)&&r.parent.arguments.length===0){let{resolvedSymbol:H}=qn(r);H&&H.flags&32768&&(V=v.This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without)}return{messageChain:js(h,V),relatedMessage:I?v.Did_you_forget_to_use_await:void 0}}function lCe(r,a,_,h){let{messageChain:T,relatedMessage:C}=QGe(r,a,_),I=ky(Ur(r),r,T);if(C&&ca(I,pn(r,C)),ea(r.parent)){let{start:V,length:H}=HGe(r.parent);I.start=V,I.length=H}_o.add(I),ZGe(a,_,h?ca(I,h):I)}function ZGe(r,a,_){if(!r.symbol)return;let h=as(r.symbol).originatingImport;if(h&&!Np(h)){let T=Ys(gn(as(r.symbol).target),a);if(!T||!T.length)return;ca(_,pn(h,v.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead))}}function z9t(r,a,_){let h=hs(r.tag),T=K_(h);if(ao(T))return yh(r);let C=Ys(T,0),I=Ys(T,1).length;if(_q(h,T,C.length,I))return cC(r);if(!C.length){if(Gu(r.parent)){let V=pn(r.tag,v.It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tagged_template_expression_which_cannot_be_invoked);return _o.add(V),yh(r)}return lCe(r.tag,T,0),yh(r)}return ZD(r,C,a,_,0)}function W9t(r){switch(r.parent.kind){case 263:case 231:return v.Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression;case 169:return v.Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression;case 172:return v.Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression;case 174:case 177:case 178:return v.Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression;default:return M.fail()}}function $9t(r,a,_){let h=hs(r.expression),T=K_(h);if(ao(T))return yh(r);let C=Ys(T,0),I=Ys(T,1).length;if(_q(h,T,C.length,I))return cC(r);if(Y9t(r,C)&&!uf(r.expression)){let H=Hc(r.expression,!1);return Qe(r,v._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0,H),yh(r)}let V=W9t(r);if(!C.length){let H=QGe(r.expression,T,0),X=js(H.messageChain,V),_e=ky(Ur(r.expression),r.expression,X);return H.relatedMessage&&ca(_e,pn(r.expression,H.relatedMessage)),_o.add(_e),ZGe(T,0,_e),yh(r)}return ZD(r,C,a,_,0,V)}function Zre(r,a){let _=oC(r),h=_&&Rp(_),T=h&&m_(h,Xp.Element,788968),C=T&&Ve.symbolToEntityName(T,788968,r),I=U.createFunctionTypeNode(void 0,[U.createParameterDeclaration(void 0,void 0,"props",void 0,Ve.typeToTypeNode(a,r))],C?U.createTypeReferenceNode(C,void 0):U.createKeywordTypeNode(133)),V=Za(1,"props");return V.links.type=a,Hy(I,void 0,void 0,[V],T?ac(T):Oe,void 0,1,0)}function H9t(r,a,_){if(Zk(r.tagName)){let I=hGe(r),V=Zre(r,I);return RS(tw(r.attributes,Vre(V,r),void 0,0),I,r.tagName,r.attributes),wt(r.typeArguments)&&(kt(r.typeArguments,ja),_o.add(qP(Ur(r),r.typeArguments,v.Expected_0_type_arguments_but_got_1,0,wt(r.typeArguments)))),V}let h=hs(r.tagName),T=K_(h);if(ao(T))return yh(r);let C=mGe(h,r);return _q(h,T,C.length,0)?cC(r):C.length===0?(Qe(r.tagName,v.JSX_element_type_0_does_not_have_any_construct_or_call_signatures,Hc(r.tagName)),yh(r)):ZD(r,C,a,_,0)}function G9t(r,a,_){let h=hs(r.right);if(!Ao(h)){let T=xCe(h);if(T){let C=K_(T);if(ao(C))return yh(r);let I=Ys(C,0),V=Ys(C,1);if(_q(T,C,I.length,V.length))return cC(r);if(I.length)return ZD(r,I,a,_,0)}else if(!(Cne(h)||OS(h,$l)))return Qe(r.right,v.The_right_hand_side_of_an_instanceof_expression_must_be_either_of_type_any_a_class_function_or_other_type_assignable_to_the_Function_interface_type_or_an_object_type_with_a_Symbol_hasInstance_method),yh(r)}return Se}function Y9t(r,a){return a.length&&wi(a,_=>_.minArgumentCount===0&&!E_(_)&&_.parameters.length<$Ge(r,_))}function K9t(r,a,_){switch(r.kind){case 213:return U9t(r,a,_);case 214:return J9t(r,a,_);case 215:return z9t(r,a,_);case 170:return $9t(r,a,_);case 286:case 285:return H9t(r,a,_);case 226:return G9t(r,a,_)}M.assertNever(r,"Branch in 'resolveSignature' should be unreachable.")}function ew(r,a,_){let h=qn(r),T=h.resolvedSignature;if(T&&T!==Ye&&!a)return T;let C=kn;T||(kn=kr.length),h.resolvedSignature=Ye;let I=K9t(r,a,_||0);return kn=C,I!==Ye&&(h.resolvedSignature!==Ye&&(I=h.resolvedSignature),h.resolvedSignature=Vo===d_?I:T),I}function vh(r){var a;if(!r||!hn(r))return!1;let _=Tl(r)||ic(r)?r:(Ei(r)||ql(r))&&r.initializer&&ic(r.initializer)?r.initializer:void 0;if(_){if(N$(r))return!0;if(ql(g0(_.parent)))return!1;let h=jn(_);return!!((a=h?.members)!=null&&a.size)}return!1}function uCe(r,a){var _,h;if(a){let T=as(a);if(!T.inferredClassSymbol||!T.inferredClassSymbol.has(Aa(r))){let C=jh(r)?r:Yb(r);return C.exports=C.exports||fa(),C.members=C.members||fa(),C.flags|=a.flags&32,(_=a.exports)!=null&&_.size&&Ip(C.exports,a.exports),(h=a.members)!=null&&h.size&&Ip(C.members,a.members),(T.inferredClassSymbol||(T.inferredClassSymbol=new Map)).set(Aa(C),C),C}return T.inferredClassSymbol.get(Aa(r))}}function X9t(r){var a;let _=r&&ene(r,!0),h=(a=_?.exports)==null?void 0:a.get("prototype"),T=h?.valueDeclaration&&Q9t(h.valueDeclaration);return T?jn(T):void 0}function ene(r,a){if(!r.parent)return;let _,h;if(Ei(r.parent)&&r.parent.initializer===r){if(!hn(r)&&!(_L(r.parent)&&Go(r)))return;_=r.parent.name,h=r.parent}else if(Pn(r.parent)){let T=r.parent,C=r.parent.operatorToken.kind;if(C===64&&(a||T.right===r))_=T.left,h=_;else if((C===57||C===61)&&(Ei(T.parent)&&T.parent.initializer===T?(_=T.parent.name,h=T.parent):Pn(T.parent)&&T.parent.operatorToken.kind===64&&(a||T.parent.right===T)&&(_=T.parent.left,h=_),!_||!Zx(_)||!YP(_,T.left)))return}else a&&Tl(r)&&(_=r.name,h=r);if(!(!h||!_||!a&&!lb(r,$1(_))))return _d(h)}function Q9t(r){if(!r.parent)return!1;let a=r.parent;for(;a&&a.kind===211;)a=a.parent;if(a&&Pn(a)&&$1(a.left)&&a.operatorToken.kind===64){let _=EH(a);return Ca(_)&&_}}function Z9t(r,a){var _,h,T;Iq(r,r.typeArguments);let C=ew(r,void 0,a);if(C===Ye)return In;if(tne(C,r),r.expression.kind===108)return dn;if(r.kind===214){let V=C.declaration;if(V&&V.kind!==176&&V.kind!==180&&V.kind!==185&&!(A0(V)&&((h=(_=QP(V))==null?void 0:_.parent)==null?void 0:h.kind)===176)&&!XP(V)&&!vh(V))return de&&Qe(r,v.new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type),Me}if(hn(r)&&nYe(r))return hWe(r.arguments[0]);let I=ko(C);if(I.flags&12288&&eYe(r))return Lxe(g0(r.parent));if(r.kind===213&&!r.questionDotToken&&r.parent.kind===244&&I.flags&16384&&Bd(C)){if(!BR(r.expression))Qe(r.expression,v.Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name);else if(!HJ(r)){let V=Qe(r.expression,v.Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation);$J(r.expression,V)}}if(hn(r)){let V=ene(r,!1);if((T=V?.exports)!=null&&T.size){let H=Zt(V,V.exports,ve,ve,ve);return H.objectFlags|=4096,Da([I,H])}}return I}function tne(r,a){if(!(r.flags&128)&&r.declaration&&r.declaration.flags&536870912){let _=fq(a),h=VR(c9(a));V6(_,r.declaration,h,TS(r))}}function fq(r){switch(r=So(r),r.kind){case 213:case 170:case 214:return fq(r.expression);case 215:return fq(r.tag);case 286:case 285:return fq(r.tagName);case 212:return r.argumentExpression;case 211:return r.name;case 183:let a=r;return cf(a.typeName)?a.typeName.right:a;default:return r}}function eYe(r){if(!ea(r))return!1;let a=r.expression;if(Wn(a)&&a.name.escapedText==="for"&&(a=a.expression),!He(a)||a.escapedText!=="Symbol")return!1;let _=LWe(!1);return _?_===xr(a,"Symbol",111551,void 0,!1):!1}function ejt(r){if(yqt(r),r.arguments.length===0)return hq(r,Me);let a=r.arguments[0],_=yl(a),h=r.arguments.length>1?yl(r.arguments[1]):void 0;for(let C=2;C<r.arguments.length;++C)yl(r.arguments[C]);if((_.flags&32768||_.flags&65536||!ga(_,Ue))&&Qe(a,v.Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0,ln(_)),h){let C=MWe(!0);C!==zi&&I_(h,UJ(C,32768),r.arguments[1])}let T=G_(r,a);if(T){let C=iT(T,a,!0,!1);if(C)return hq(r,tYe(gn(C),C,T,a)||rYe(gn(C),C,T,a))}return hq(r,Me)}function _Ce(r,a,_){let h=fa(),T=Za(2097152,"default");return T.parent=a,T.links.nameType=Lf("default"),T.links.aliasTarget=pl(r),h.set("default",T),Zt(_,h,ve,ve,ve)}function tYe(r,a,_,h){if(ah(h)&&r&&!ao(r)){let C=r;if(!C.defaultOnlyType){let I=_Ce(a,_);C.defaultOnlyType=I}return C.defaultOnlyType}}function rYe(r,a,_,h){var T;if(ue&&r&&!ao(r)){let C=r;if(!C.syntheticType){let I=(T=_.declarations)==null?void 0:T.find(Ji);if(vp(I,_,!1,h)){let H=Za(2048,"__type"),X=_Ce(a,_,H);H.links.type=X,C.syntheticType=tq(r)?nx(r,X,H,0,!1):X}else C.syntheticType=r}return C.syntheticType}return r}function nYe(r){if(!kf(r,!0))return!1;if(!He(r.expression))return M.fail();let a=xr(r.expression,r.expression.escapedText,111551,void 0,!0);if(a===et)return!0;if(a.flags&2097152)return!1;let _=a.flags&16?262:a.flags&3?260:0;if(_!==0){let h=Pc(a,_);return!!h&&!!(h.flags&33554432)}return!1}function tjt(r){zJt(r)||Iq(r,r.typeArguments),ee<2&&gu(r,262144);let a=ew(r);return tne(a,r),ko(a)}function rjt(r,a){if(r.kind===216){let _=Ur(r);_&&wl(_.fileName,[".cts",".mts"])&&Or(r,v.This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead)}return iYe(r,a)}function fCe(r){switch(r.kind){case 11:case 15:case 9:case 10:case 112:case 97:case 209:case 210:case 228:return!0;case 217:return fCe(r.expression);case 224:let a=r.operator,_=r.operand;return a===41&&(_.kind===9||_.kind===10)||a===40&&_.kind===9;case 211:case 212:let h=So(r.expression),T=nc(h)?nl(h,111551,!0):void 0;return!!(T&&T.flags&384)}return!1}function iYe(r,a){let{type:_,expression:h}=sYe(r),T=hs(h,a);if(Qm(_))return fCe(h)||Qe(h,v.A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals),Q_(T);let C=qn(r);return C.assertionExpressionType=T,ja(_),eP(r),Wi(_)}function sYe(r){let a,_;switch(r.kind){case 234:case 216:a=r.type,_=r.expression;break;case 217:a=FO(r),_=r.expression;break}return{type:a,expression:_}}function njt(r){let{type:a}=sYe(r),_=uf(r)?a:r,h=qn(r);M.assertIsDefined(h.assertionExpressionType);let T=V7(ev(h.assertionExpressionType)),C=Wi(a);ao(C)||n(()=>{let I=Qf(T);ore(C,I)||O$e(T,C,_,v.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first)})}function ijt(r){let a=hs(r.expression),_=B7(a,r.expression);return vre(tv(_),r,_!==a)}function sjt(r){return r.flags&64?ijt(r):tv(hs(r.expression))}function aYe(r){if(XKe(r),kt(r.typeArguments,ja),r.kind===233){let _=g0(r.parent);_.kind===226&&_.operatorToken.kind===104&&rE(r,_.right)&&Qe(r,v.The_right_hand_side_of_an_instanceof_expression_must_not_be_an_instantiation_expression)}let a=r.kind===233?hs(r.expression):z1(r.exprName)?QJ(r.exprName):hs(r.exprName);return oYe(a,r)}function oYe(r,a){let _=a.typeArguments;if(r===In||ao(r)||!Pt(_))return r;let h=!1,T,C=V(r),I=h?T:r;return I&&_o.add(qP(Ur(a),_,v.Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable,ln(I))),C;function V(X){let _e=!1,we=!1,Ne=pt(X);return h||(h=we),_e&&!we&&(T??(T=X)),Ne;function pt(Tt){if(Tt.flags&524288){let Mt=Sg(Tt),mr=H(Mt.callSignatures),br=H(Mt.constructSignatures);if(_e||(_e=Mt.callSignatures.length!==0||Mt.constructSignatures.length!==0),we||(we=mr.length!==0||br.length!==0),mr!==Mt.callSignatures||br!==Mt.constructSignatures){let en=Zt(Za(0,"__instantiationExpression"),Mt.members,mr,br,Mt.indexInfos);return en.objectFlags|=8388608,en.node=a,en}}else if(Tt.flags&58982400){let Mt=Zu(Tt);if(Mt){let mr=pt(Mt);if(mr!==Mt)return mr}}else{if(Tt.flags&1048576)return wc(Tt,V);if(Tt.flags&2097152)return Da(Fs(Tt.types,pt))}return Tt}}function H(X){let _e=Zn(X,we=>!!we.typeParameters&&iCe(we,_));return Fs(_e,we=>{let Ne=oCe(we,_,!0);return Ne?A7(we,Ne,hn(we.declaration)):we})}}function ajt(r){return ja(r.type),pCe(r.expression,r.type)}function pCe(r,a,_){let h=hs(r,_),T=Wi(a);if(ao(T))return T;let C=Pr(a.parent,I=>I.kind===238||I.kind===350);return RS(h,T,C,r,v.Type_0_does_not_satisfy_the_expected_type_1),h}function ojt(r){return aqt(r),r.keywordToken===105?dCe(r):r.keywordToken===102?cjt(r):M.assertNever(r.keywordToken)}function cYe(r){switch(r.keywordToken){case 102:return RWe();case 105:let a=dCe(r);return ao(a)?Oe:Cjt(a);default:M.assertNever(r.keywordToken)}}function dCe(r){let a=ife(r);if(a)if(a.kind===176){let _=jn(a.parent);return gn(_)}else{let _=jn(a);return gn(_)}else return Qe(r,v.Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor,"new.target"),Oe}function cjt(r){W===100||W===199?Ur(r).impliedNodeFormat!==99&&Qe(r,v.The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output):W<6&&W!==4&&Qe(r,v.The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system_node16_or_nodenext);let a=Ur(r);return M.assert(!!(a.flags&8388608),"Containing file is missing import meta node flag."),r.name.escapedText==="meta"?OWe():Oe}function pq(r){let a=r.valueDeclaration;return da(gn(r),!1,!!a&&(bv(a)||dN(a)))}function mCe(r,a,_="arg"){return r?(M.assert(He(r.name)),r.name.escapedText):`${_}_${a}`}function _4(r,a,_){let h=r.parameters.length-(E_(r)?1:0);if(a<h)return r.parameters[a].escapedName;let T=r.parameters[h]||St,C=_||gn(T);if(Ha(C)){let I=C.target.labeledElementDeclarations,V=a-h;return mCe(I?.[V],V,T.escapedName)}return T.escapedName}function ljt(r,a){var _;if(((_=r.declaration)==null?void 0:_.kind)===317)return;let h=r.parameters.length-(E_(r)?1:0);if(a<h){let V=r.parameters[a],H=lYe(V);return H?{parameter:H,parameterName:V.escapedName,isRestParameter:!1}:void 0}let T=r.parameters[h]||St,C=lYe(T);if(!C)return;let I=gn(T);if(Ha(I)){let V=I.target.labeledElementDeclarations,H=a-h,X=V?.[H],_e=!!X?.dotDotDotToken;return X?(M.assert(He(X.name)),{parameter:X.name,parameterName:X.name.escapedText,isRestParameter:_e}):void 0}if(a===h)return{parameter:C,parameterName:T.escapedName,isRestParameter:!0}}function lYe(r){return r.valueDeclaration&&ns(r.valueDeclaration)&&He(r.valueDeclaration.name)&&r.valueDeclaration.name}function uYe(r){return r.kind===202||ns(r)&&r.name&&He(r.name)}function ujt(r,a){let _=r.parameters.length-(E_(r)?1:0);if(a<_){let C=r.parameters[a].valueDeclaration;return C&&uYe(C)?C:void 0}let h=r.parameters[_]||St,T=gn(h);if(Ha(T)){let C=T.target.labeledElementDeclarations,I=a-_;return C&&C[I]}return h.valueDeclaration&&uYe(h.valueDeclaration)?h.valueDeclaration:void 0}function xg(r,a){return ux(r,a)||Me}function ux(r,a){let _=r.parameters.length-(E_(r)?1:0);if(a<_)return pq(r.parameters[a]);if(E_(r)){let h=gn(r.parameters[_]),T=a-_;if(!Ha(h)||h.target.hasRestElement||T<h.target.fixedLength)return Kf(h,zm(T))}}function dq(r,a,_){let h=ep(r),T=Sh(r),C=X7(r);if(C&&a>=h-1)return a===h-1?C:g_(Kf(C,Te));let I=[],V=[],H=[];for(let X=a;X<h;X++)!C||X<h-1?(I.push(xg(r,X)),V.push(X<T?1:2)):(I.push(C),V.push(8)),H.push(ujt(r,X));return cy(I,V,_,H)}function _Ye(r,a){let _=dq(r,a),h=_&&BJ(_);return h&&Ao(h)?Me:_}function ep(r){let a=r.parameters.length;if(E_(r)){let _=gn(r.parameters[a-1]);if(Ha(_))return a+_.target.fixedLength-(_.target.hasRestElement?0:1)}return a}function Sh(r,a){let _=a&1,h=a&2;if(h||r.resolvedMinArgumentCount===void 0){let T;if(E_(r)){let C=gn(r.parameters[r.parameters.length-1]);if(Ha(C)){let I=Bo(C.target.elementFlags,H=>!(H&1)),V=I<0?C.target.fixedLength:I;V>0&&(T=r.parameters.length-1+V)}}if(T===void 0){if(!_&&r.flags&32)return 0;T=r.minArgumentCount}if(h)return T;for(let C=T-1;C>=0;C--){let I=xg(r,C);if(Fl(I,jGe).flags&131072)break;T=C}r.resolvedMinArgumentCount=T}return r.resolvedMinArgumentCount}function uy(r){if(E_(r)){let a=gn(r.parameters[r.parameters.length-1]);return!Ha(a)||a.target.hasRestElement}return!1}function X7(r){if(E_(r)){let a=gn(r.parameters[r.parameters.length-1]);if(!Ha(a))return Ao(a)?Uo:a;if(a.target.hasRestElement)return n4(a,a.target.fixedLength)}}function Q7(r){let a=X7(r);return a&&!Jd(a)&&!Ao(a)?a:void 0}function gCe(r){return hCe(r,Ar)}function hCe(r,a){return r.parameters.length>0?xg(r,0):a}function fYe(r,a,_){let h=r.parameters.length-(E_(r)?1:0);for(let T=0;T<h;T++){let C=r.parameters[T].valueDeclaration,I=Vl(C);if(I){let V=da(Wi(I),!1,dN(C)),H=xg(a,T);nv(_.inferences,V,H)}}}function _jt(r,a){if(a.typeParameters)if(!r.typeParameters)r.typeParameters=a.typeParameters;else return;if(a.thisParameter){let h=r.thisParameter;(!h||h.valueDeclaration&&!h.valueDeclaration.type)&&(h||(r.thisParameter=tC(a.thisParameter,void 0)),mq(r.thisParameter,gn(a.thisParameter)))}let _=r.parameters.length-(E_(r)?1:0);for(let h=0;h<_;h++){let T=r.parameters[h],C=T.valueDeclaration;if(!Vl(C)){let I=ux(a,h);if(I&&C.initializer){let V=f4(C,0);!ga(V,I)&&ga(I,V=ane(C,V))&&(I=V)}mq(T,I)}}if(E_(r)){let h=Va(r.parameters);if(h.valueDeclaration?!Vl(h.valueDeclaration):ll(h)&65536){let T=dq(a,_);mq(h,T)}}}function fjt(r){r.thisParameter&&mq(r.thisParameter);for(let a of r.parameters)mq(a)}function mq(r,a){let _=as(r);if(_.type)a&&M.assertEqual(_.type,a,"Parameter symbol already has a cached type which differs from newly assigned type");else{let h=r.valueDeclaration;_.type=da(a||(h?B(h,!0):gn(r)),!1,!!h&&!h.initializer&&dN(h)),h&&h.name.kind!==80&&(_.type===Rt&&(_.type=P(h.name)),pYe(h.name,_.type))}}function pYe(r,a){for(let _ of r.elements)if(!pu(_)){let h=Li(_,a,!1);_.name.kind===80?as(jn(_)).type=h:pYe(_.name,h)}}function pjt(r){return JD(xMt(!0),[r])}function djt(r,a){return JD(CMt(!0),[r,a])}function mjt(r,a){return JD(AMt(!0),[r,a])}function gjt(r,a){return JD(kMt(!0),[r,a])}function hjt(r,a){return JD(PMt(!0),[r,a])}function yjt(r,a){return JD(wMt(!0),[r,a])}function vjt(r,a,_){let h=`${a?"p":"P"}${_?"s":"S"}${r.id}`,T=la.get(h);if(!T){let C=fa();C.set("name",UE("name",r)),C.set("private",UE("private",a?Ht:It)),C.set("static",UE("static",_?Ht:It)),T=Zt(void 0,C,ve,ve,ve),la.set(h,T)}return T}function dYe(r,a,_){let h=Jl(r),T=Zi(r.name),C=T?Lf(Nn(r.name)):d1(r.name),I=ul(r)?djt(a,_):Hp(r)?mjt(a,_):fp(r)?gjt(a,_):Ef(r)?hjt(a,_):Ns(r)?yjt(a,_):M.failBadSyntaxKind(r),V=vjt(C,T,h);return Da([I,V])}function Sjt(r,a){return JD(NMt(!0),[r,a])}function bjt(r,a){return JD(DMt(!0),[r,a])}function Tjt(r,a){let _=Lm("this",r),h=Lm("value",a);return ICe(void 0,_,[h],a,void 0,1)}function yCe(r,a,_){let h=Lm("target",r),T=Lm("context",a),C=fi([_,dn]);return sL(void 0,void 0,[h,T],C)}function Ejt(r){let{parent:a}=r,_=qn(a);if(!_.decoratorSignature)switch(_.decoratorSignature=Se,a.kind){case 263:case 231:{let T=gn(jn(a)),C=pjt(T);_.decoratorSignature=yCe(T,C,T);break}case 174:case 177:case 178:{let h=a;if(!gi(h.parent))break;let T=ul(h)?G2(md(h)):tP(h),C=Jl(h)?gn(jn(h.parent)):Al(jn(h.parent)),I=Hp(h)?WYe(T):fp(h)?$Ye(T):T,V=dYe(h,C,T),H=Hp(h)?WYe(T):fp(h)?$Ye(T):T;_.decoratorSignature=yCe(I,V,H);break}case 172:{let h=a;if(!gi(h.parent))break;let T=tP(h),C=Jl(h)?gn(jn(h.parent)):Al(jn(h.parent)),I=Ug(h)?Sjt(C,T):nr,V=dYe(h,C,T),H=Ug(h)?bjt(C,T):Tjt(C,T);_.decoratorSignature=yCe(I,V,H);break}}return _.decoratorSignature===Se?void 0:_.decoratorSignature}function xjt(r){let{parent:a}=r,_=qn(a);if(!_.decoratorSignature)switch(_.decoratorSignature=Se,a.kind){case 263:case 231:{let T=gn(jn(a)),C=Lm("target",T);_.decoratorSignature=sL(void 0,void 0,[C],fi([T,dn]));break}case 169:{let h=a;if(!Vc(h.parent)&&!(ul(h.parent)||fp(h.parent)&&gi(h.parent.parent))||iE(h.parent)===h)break;let T=iE(h.parent)?h.parent.parameters.indexOf(h)-1:h.parent.parameters.indexOf(h);M.assert(T>=0);let C=Vc(h.parent)?gn(jn(h.parent.parent)):FKe(h.parent),I=Vc(h.parent)?nr:jKe(h.parent),V=zm(T),H=Lm("target",C),X=Lm("propertyKey",I),_e=Lm("parameterIndex",V);_.decoratorSignature=sL(void 0,void 0,[H,X,_e],dn);break}case 174:case 177:case 178:case 172:{let h=a;if(!gi(h.parent))break;let T=FKe(h),C=Lm("target",T),I=jKe(h),V=Lm("propertyKey",I),H=Ns(h)?dn:VWe(tP(h));if(!Ns(a)||Ug(a)){let _e=VWe(tP(h)),we=Lm("descriptor",_e);_.decoratorSignature=sL(void 0,void 0,[C,V,we],fi([H,dn]))}else _.decoratorSignature=sL(void 0,void 0,[C,V],fi([H,dn]));break}}return _.decoratorSignature===Se?void 0:_.decoratorSignature}function vCe(r){return pe?xjt(r):Ejt(r)}function gq(r){let a=EJ(!0);return a!==Fa?(r=h1(g4(r))||Rt,_1(a,[r])):Rt}function mYe(r){let a=jWe(!0);return a!==Fa?(r=h1(g4(r))||Rt,_1(a,[r])):Rt}function hq(r,a){let _=gq(a);return _===Rt?(Qe(r,Np(r)?v.A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option:v.An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option),Oe):(mxe(!0)||Qe(r,Np(r)?v.A_dynamic_import_call_in_ES5_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option:v.An_async_function_or_method_in_ES5_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option),_)}function Cjt(r){let a=Za(0,"NewTargetExpression"),_=Za(4,"target",8);_.parent=a,_.links.type=r;let h=fa([_]);return a.members=h,Zt(a,h,ve,ve,ve)}function rne(r,a){if(!r.body)return Oe;let _=Rl(r),h=(_&2)!==0,T=(_&1)!==0,C,I,V,H=dn;if(r.body.kind!==241)C=yl(r.body,a&&a&-9),h&&(C=g4(iL(C,!1,r,v.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member)));else if(T){let X=vYe(r,a);X?X.length>0&&(C=fi(X,2)):H=Ar;let{yieldTypes:_e,nextTypes:we}=Ajt(r,a);I=Pt(_e)?fi(_e,2):void 0,V=Pt(we)?Da(we):void 0}else{let X=vYe(r,a);if(!X)return _&2?hq(r,Ar):Ar;if(X.length===0){let _e=Fre(r,void 0),we=_e&&(kq(_e,_)||dn).flags&32768?nr:dn;return _&2?hq(r,we):we}C=fi(X,2)}if(C||I||V){if(I&&Ere(r,I,3),C&&Ere(r,C,1),V&&Ere(r,V,2),C&&Tg(C)||I&&Tg(I)||V&&Tg(V)){let X=U2e(r),_e=X?X===md(r)?T?void 0:C:Bre(ko(X),r,void 0):void 0;T?(I=r2e(I,_e,0,h),C=r2e(C,_e,1,h),V=r2e(V,_e,2,h)):C=ELt(C,_e,h)}I&&(I=Qf(I)),C&&(C=Qf(C)),V&&(V=Qf(V))}return T?nne(I||Ar,C||H,V||tGe(2,r)||Rt,h):h?gq(C||H):C||H}function nne(r,a,_,h){let T=h?Na:gc,C=T.getGlobalGeneratorType(!1);if(r=T.resolveIterationType(r,void 0)||Rt,a=T.resolveIterationType(a,void 0)||Rt,_=T.resolveIterationType(_,void 0)||Rt,C===Fa){let I=T.getGlobalIterableIteratorType(!1),V=I!==Fa?sKe(I,T):void 0,H=V?V.returnType:Me,X=V?V.nextType:nr;return ga(a,H)&&ga(X,_)?I!==Fa?P7(I,[r]):(T.getGlobalIterableIteratorType(!0),zi):(T.getGlobalGeneratorType(!0),zi)}return P7(C,[r,a,_])}function Ajt(r,a){let _=[],h=[],T=(Rl(r)&2)!==0;return $_e(r.body,C=>{let I=C.expression?hs(C.expression,a):Z;ol(_,gYe(C,I,Me,T));let V;if(C.asteriskToken){let H=hne(I,T?19:17,C.expression);V=H&&H.nextType}else V=hf(C,void 0);V&&ol(h,V)}),{yieldTypes:_,nextTypes:h}}function gYe(r,a,_,h){let T=r.expression||r,C=r.asteriskToken?y1(h?19:17,a,_,T):a;return h?_C(C,T,r.asteriskToken?v.Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:v.Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member):C}function hYe(r,a,_){let h=0;for(let T=0;T<_.length;T++){let C=T<r||T>=a?_[T]:void 0;h|=C!==void 0?Mge.get(C)||32768:0}return h}function yYe(r){let a=qn(r);if(a.isExhaustive===void 0){a.isExhaustive=0;let _=kjt(r);a.isExhaustive===0&&(a.isExhaustive=_)}else a.isExhaustive===0&&(a.isExhaustive=!1);return a.isExhaustive}function kjt(r){if(r.expression.kind===221){let h=AHe(r);if(!h)return!1;let T=ay(yl(r.expression.expression)),C=hYe(0,0,h);return T.flags&3?(556800&C)===556800:!ym(T,I=>GD(I,C)===C)}let a=yl(r.expression);if(!j7(a))return!1;let _=Pre(r);return!_.length||Pt(_,SLt)?!1:vFt(wc(a,Q_),_)}function SCe(r){return r.endFlowNode&&GJ(r.endFlowNode)}function vYe(r,a){let _=Rl(r),h=[],T=SCe(r),C=!1;if(xv(r.body,I=>{let V=I.expression;if(V){if(V=So(V,!0),_&2&&V.kind===223&&(V=So(V.expression,!0)),V.kind===213&&V.expression.kind===80&&yl(V.expression).symbol===ro(r.symbol)&&(!K1(r.symbol.valueDeclaration)||A2e(V.expression))){C=!0;return}let H=yl(V,a&&a&-9);_&2&&(H=g4(iL(H,!1,r,v.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member))),H.flags&131072&&(C=!0),ol(h,H)}else T=!0}),!(h.length===0&&!T&&(C||Pjt(r))))return ce&&h.length&&T&&!(vh(r)&&h.some(I=>I.symbol===r.symbol))&&ol(h,nr),h}function Pjt(r){switch(r.kind){case 218:case 219:return!0;case 174:return r.parent.kind===210;default:return!1}}function Njt(r){switch(r.kind){case 176:case 177:case 178:return}if(Rl(r)!==0)return;let _;if(r.body&&r.body.kind!==241)_=r.body;else if(xv(r.body,T=>{if(_||!T.expression)return!0;_=T.expression})||!_||SCe(r))return;return Djt(r,_)}function Djt(r,a){if(a=So(a,!0),!!(yl(a).flags&16))return kt(r.parameters,(h,T)=>{let C=gn(h.symbol);if(!C||C.flags&16||!He(h.name)||KJ(h.symbol)||Fh(h))return;let I=wjt(r,a,h,C);if(I)return C7(1,Qi(h.name.escapedText),T,I)})}function wjt(r,a,_,h){let T=a.flowNode||a.parent.kind===253&&a.parent.flowNode||Wh(2,void 0,void 0),C=Wh(32,a,T),I=iv(_.name,h,h,r,C);if(I===h)return;let V=Wh(64,a,T);return iv(_.name,h,I,r,V).flags&131072?I:void 0}function bCe(r,a){n(_);return;function _(){let h=Rl(r),T=a&&kq(a,h);if(T&&(dl(T,16384)||T.flags&32769)||r.kind===173||$c(r.body)||r.body.kind!==241||!SCe(r))return;let C=r.flags&1024,I=lp(r)||r;if(T&&T.flags&131072)Qe(I,v.A_function_returning_never_cannot_have_a_reachable_end_point);else if(T&&!C)Qe(I,v.A_function_whose_declared_type_is_neither_undefined_void_nor_any_must_return_a_value);else if(T&&ce&&!ga(nr,T))Qe(I,v.Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined);else if(q.noImplicitReturns){if(!T){if(!C)return;let V=ko(md(r));if(fKe(r,V))return}Qe(I,v.Not_all_code_paths_return_a_value)}}}function SYe(r,a){if(M.assert(r.kind!==174||Nm(r)),eP(r),ic(r)&&h4(r,r.name),a&&a&4&&Ud(r)){if(!lp(r)&&!fj(r)){let h=G7(r);if(h&&FS(ko(h))){let T=qn(r);if(T.contextFreeType)return T.contextFreeType;let C=rne(r,a),I=Hy(void 0,void 0,void 0,ve,C,void 0,0,64),V=Zt(r.symbol,J,[I],ve,ve);return V.objectFlags|=262144,T.contextFreeType=V}}return bc}return!Dne(r)&&r.kind===218&&sAe(r),Ijt(r,a),gn(jn(r))}function Ijt(r,a){let _=qn(r);if(!(_.flags&64)){let h=G7(r);if(!(_.flags&64)){_.flags|=64;let T=xo(Ys(gn(jn(r)),0));if(!T)return;if(Ud(r))if(h){let C=cx(r),I;if(a&&a&2){fYe(T,h,C);let V=X7(h);V&&V.flags&262144&&(I=Gk(h,C.nonFixingMapper))}I||(I=C?Gk(h,C.mapper):h),_jt(T,I)}else fjt(T);else if(h&&!r.typeParameters&&h.parameters.length>r.parameters.length){let C=cx(r);a&&a&2&&fYe(T,h,C)}if(h&&!VD(r)&&!T.resolvedReturnType){let C=rne(r,a);T.resolvedReturnType||(T.resolvedReturnType=C)}tL(r)}}}function Ojt(r){M.assert(r.kind!==174||Nm(r));let a=Rl(r),_=VD(r);if(bCe(r,_),r.body)if(lp(r)||ko(md(r)),r.body.kind===241)ja(r.body);else{let h=hs(r.body),T=_&&kq(_,a);if(T){let C=Xre(r.body);if((a&3)===2){let I=iL(h,!1,C,v.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);RS(I,T,C,C)}else RS(h,T,C,C)}}}function ine(r,a,_,h=!1){if(!ga(a,tn)){let T=h&&m4(a);return Gb(r,!!T&&ga(T,tn),_),!1}return!0}function Rjt(r){if(!ea(r)||!Qx(r))return!1;let a=yl(r.arguments[2]);if(il(a,"value")){let T=ma(a,"writable"),C=T&&gn(T);if(!C||C===It||C===$t)return!0;if(T&&T.valueDeclaration&&ql(T.valueDeclaration)){let I=T.valueDeclaration.initializer,V=hs(I);if(V===It||V===$t)return!0}return!1}return!ma(a,"set")}function Cg(r){return!!(ll(r)&8||r.flags&4&&xd(r)&8||r.flags&3&&W2e(r)&6||r.flags&98304&&!(r.flags&65536)||r.flags&8||Pt(r.declarations,Rjt))}function bYe(r,a,_){var h,T;if(_===0)return!1;if(Cg(a)){if(a.flags&4&&oc(r)&&r.expression.kind===110){let C=Dp(r);if(!(C&&(C.kind===176||vh(C))))return!0;if(a.valueDeclaration){let I=Pn(a.valueDeclaration),V=C.parent===a.valueDeclaration.parent,H=C===a.valueDeclaration.parent,X=I&&((h=a.parent)==null?void 0:h.valueDeclaration)===C.parent,_e=I&&((T=a.parent)==null?void 0:T.valueDeclaration)===C;return!(V||H||X||_e)}}return!0}if(oc(r)){let C=So(r.expression);if(C.kind===80){let I=qn(C).resolvedSymbol;if(I.flags&2097152){let V=yp(I);return!!V&&V.kind===274}}}return!1}function Z7(r,a,_){let h=Ml(r,7);return h.kind!==80&&!oc(h)?(Qe(r,a),!1):h.flags&64?(Qe(r,_),!1):!0}function Mjt(r){hs(r.expression);let a=So(r.expression);if(!oc(a))return Qe(a,v.The_operand_of_a_delete_operator_must_be_a_property_reference),qr;Wn(a)&&Zi(a.name)&&Qe(a,v.The_operand_of_a_delete_operator_cannot_be_a_private_identifier);let _=qn(a),h=Mp(_.resolvedSymbol);return h&&(Cg(h)?Qe(a,v.The_operand_of_a_delete_operator_cannot_be_a_read_only_property):Ljt(a,h)),qr}function Ljt(r,a){let _=gn(a);ce&&!(_.flags&131075)&&!(te?a.flags&16777216:Eg(_,16777216))&&Qe(r,v.The_operand_of_a_delete_operator_must_be_optional)}function Fjt(r){return hs(r.expression),D2}function jjt(r){return eP(r),Z}function TYe(r){let a=!1,_=i9(r);if(_&&Gc(_)){let h=eS(r)?v.await_expression_cannot_be_used_inside_a_class_static_block:v.await_using_statements_cannot_be_used_inside_a_class_static_block;Qe(r,h),a=!0}else if(!(r.flags&65536))if(a9(r)){let h=Ur(r);if(!BS(h)){let T;if(!ZC(h,q)){T??(T=Bh(h,r.pos));let C=eS(r)?v.await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module:v.await_using_statements_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module,I=bu(h,T.start,T.length,C);_o.add(I),a=!0}switch(W){case 100:case 199:if(h.impliedNodeFormat===1){T??(T=Bh(h,r.pos)),_o.add(bu(h,T.start,T.length,v.The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level)),a=!0;break}case 7:case 99:case 200:case 4:if(ee>=4)break;default:T??(T=Bh(h,r.pos));let C=eS(r)?v.Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher:v.Top_level_await_using_statements_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher;_o.add(bu(h,T.start,T.length,C)),a=!0;break}}}else{let h=Ur(r);if(!BS(h)){let T=Bh(h,r.pos),C=eS(r)?v.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules:v.await_using_statements_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules,I=bu(h,T.start,T.length,C);if(_&&_.kind!==176&&!(Rl(_)&2)){let V=pn(_,v.Did_you_mean_to_mark_this_function_as_async);ca(I,V)}_o.add(I),a=!0}}return eS(r)&&M2e(r)&&(Qe(r,v.await_expressions_cannot_be_used_in_a_parameter_initializer),a=!0),a}function Bjt(r){n(()=>TYe(r));let a=hs(r.expression),_=iL(a,!0,r,v.Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);return _===a&&!ao(_)&&!(a.flags&3)&&Mm(!1,pn(r,v.await_has_no_effect_on_the_type_of_this_expression)),_}function Ujt(r){let a=hs(r.operand);if(a===In)return In;switch(r.operand.kind){case 9:switch(r.operator){case 41:return Hk(zm(-r.operand.text));case 40:return Hk(zm(+r.operand.text))}break;case 10:if(r.operator===41)return Hk(ere({negative:!0,base10Value:_O(r.operand.text)}))}switch(r.operator){case 40:case 41:case 55:return hh(a,r.operand),yq(a,12288)&&Qe(r.operand,v.The_0_operator_cannot_be_applied_to_type_symbol,Sa(r.operator)),r.operator===40?(yq(a,2112)&&Qe(r.operand,v.Operator_0_cannot_be_applied_to_type_1,Sa(r.operator),ln(ev(a))),Te):TCe(a);case 54:FCe(a,r.operand);let _=GD(a,12582912);return _===4194304?It:_===8388608?Ht:qr;case 46:case 47:return ine(r.operand,hh(a,r.operand),v.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type)&&Z7(r.operand,v.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access,v.The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access),TCe(a)}return Oe}function Vjt(r){let a=hs(r.operand);return a===In?In:(ine(r.operand,hh(a,r.operand),v.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type)&&Z7(r.operand,v.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access,v.The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access),TCe(a))}function TCe(r){return dl(r,2112)?e_(r,3)||dl(r,296)?tn:Re:Te}function yq(r,a){if(dl(r,a))return!0;let _=ay(r);return!!_&&dl(_,a)}function dl(r,a){if(r.flags&a)return!0;if(r.flags&3145728){let _=r.types;for(let h of _)if(dl(h,a))return!0}return!1}function e_(r,a,_){return r.flags&a?!0:_&&r.flags&114691?!1:!!(a&296)&&ga(r,Te)||!!(a&2112)&&ga(r,Re)||!!(a&402653316)&&ga(r,Ue)||!!(a&528)&&ga(r,qr)||!!(a&16384)&&ga(r,dn)||!!(a&131072)&&ga(r,Ar)||!!(a&65536)&&ga(r,Ke)||!!(a&32768)&&ga(r,nr)||!!(a&4096)&&ga(r,Hr)||!!(a&67108864)&&ga(r,Yn)}function eL(r,a,_){return r.flags&1048576?wi(r.types,h=>eL(h,a,_)):e_(r,a,_)}function sne(r){return!!(Kn(r)&16)&&!!r.symbol&&ECe(r.symbol)}function ECe(r){return(r.flags&128)!==0}function xCe(r){let a=oKe("hasInstance");if(eL(r,67108864)){let _=ma(r,a);if(_){let h=gn(_);if(h&&Ys(h,0).length!==0)return h}}}function Jjt(r,a,_,h,T){if(_===In||h===In)return In;!Ao(_)&&eL(_,402784252)&&Qe(r,v.The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter),M.assert(R9(r.parent));let C=ew(r.parent,void 0,T);if(C===Ye)return In;let I=ko(C);return I_(I,qr,a,v.An_object_s_Symbol_hasInstance_method_must_return_a_boolean_value_for_it_to_be_used_on_the_right_hand_side_of_an_instanceof_expression),qr}function qjt(r){return ym(r,a=>a===el||!!(a.flags&2097152)&&ly(ay(a)))}function zjt(r,a,_,h){if(_===In||h===In)return In;if(Zi(r)){if((ee<9||ee<99||!K)&&gu(r,2097152),!qn(r).resolvedSymbol&&Ou(r)){let T=X2e(r,h.symbol,!0);PGe(r,h,T)}}else I_(hh(_,r),Er,r);return I_(hh(h,a),Yn,a)&&qjt(h)&&Qe(a,v.Type_0_may_represent_a_primitive_value_which_is_not_permitted_as_the_right_operand_of_the_in_operator,ln(h)),qr}function Wjt(r,a,_){let h=r.properties;if(ce&&h.length===0)return hh(a,r);for(let T=0;T<h.length;T++)EYe(r,a,T,h,_);return a}function EYe(r,a,_,h,T=!1){let C=r.properties,I=C[_];if(I.kind===303||I.kind===304){let V=I.name,H=d1(V);if(tm(H)){let we=rm(H),Ne=ma(a,we);Ne&&(oq(Ne,I,T),H2e(I,!1,!0,a,Ne))}let X=Kf(a,H,32,V),_e=it(I,X);return uC(I.kind===304?I:I.initializer,_e)}else if(I.kind===305)if(_<C.length-1)Qe(I,v.A_rest_element_must_be_last_in_a_destructuring_pattern);else{ee<5&&gu(I,4);let V=[];if(h)for(let X of h)Fy(X)||V.push(X.name);let H=Lk(a,V,a.symbol);return rP(h,v.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma),uC(I.expression,H)}else Qe(I,v.Property_assignment_expected)}function $jt(r,a,_){let h=r.elements;ee<2&&q.downlevelIteration&&gu(r,512);let T=y1(193,a,nr,r)||Oe,C=q.noUncheckedIndexedAccess?void 0:T;for(let I=0;I<h.length;I++){let V=T;r.elements[I].kind===230&&(V=C=C??(y1(65,a,nr,r)||Oe)),xYe(r,a,I,V,_)}return a}function xYe(r,a,_,h,T){let C=r.elements,I=C[_];if(I.kind!==232){if(I.kind!==230){let V=zm(_);if(g1(a)){let H=32|(u4(I)?16:0),X=wS(a,V,H,lq(I,V))||Oe,_e=u4(I)?hm(X,524288):X,we=it(I,_e);return uC(I,we,T)}return uC(I,h,T)}if(_<C.length-1)Qe(I,v.A_rest_element_must_be_last_in_a_destructuring_pattern);else{let V=I.expression;if(V.kind===226&&V.operatorToken.kind===64)Qe(V.operatorToken,v.A_rest_element_cannot_have_an_initializer);else{rP(r.elements,v.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);let H=Zf(a,Ha)?wc(a,X=>n4(X,_)):g_(h);return uC(V,H,T)}}}}function uC(r,a,_,h){let T;if(r.kind===304){let C=r;C.objectAssignmentInitializer&&(ce&&!Eg(hs(C.objectAssignmentInitializer),16777216)&&(a=hm(a,524288)),Kjt(C.name,C.equalsToken,C.objectAssignmentInitializer,_)),T=r.name}else T=r;return T.kind===226&&T.operatorToken.kind===64&&(he(T,_),T=T.left,ce&&(a=hm(a,524288))),T.kind===210?Wjt(T,a,h):T.kind===209?$jt(T,a,_):Hjt(T,a,_)}function Hjt(r,a,_){let h=hs(r,_),T=r.parent.kind===305?v.The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access:v.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access,C=r.parent.kind===305?v.The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access:v.The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access;return Z7(r,T,C)&&RS(a,h,r,r),MP(r)&&gu(r.parent,1048576),a}function vq(r){switch(r=So(r),r.kind){case 80:case 11:case 14:case 215:case 228:case 15:case 9:case 10:case 112:case 97:case 106:case 157:case 218:case 231:case 219:case 209:case 210:case 221:case 235:case 285:case 284:return!0;case 227:return vq(r.whenTrue)&&vq(r.whenFalse);case 226:return y0(r.operatorToken.kind)?!1:vq(r.left)&&vq(r.right);case 224:case 225:switch(r.operator){case 54:case 40:case 41:case 55:return!0}return!1;case 222:case 216:case 234:default:return!1}}function CCe(r,a){return(a.flags&98304)!==0||ore(r,a)}function Gjt(){let r=Kj(a,_,h,T,C,I);return(Ne,pt)=>{let Tt=r(Ne,pt);return M.assertIsDefined(Tt),Tt};function a(Ne,pt,Tt){return pt?(pt.stackIndex++,pt.skip=!1,X(pt,void 0),we(pt,void 0)):pt={checkMode:Tt,skip:!1,stackIndex:0,typeStack:[void 0,void 0]},hn(Ne)&&iA(Ne)?(pt.skip=!0,we(pt,hs(Ne.right,Tt)),pt):(Yjt(Ne),Ne.operatorToken.kind===64&&(Ne.left.kind===210||Ne.left.kind===209)&&(pt.skip=!0,we(pt,uC(Ne.left,hs(Ne.right,Tt),Tt,Ne.right.kind===110))),pt)}function _(Ne,pt,Tt){if(!pt.skip)return V(pt,Ne)}function h(Ne,pt,Tt){if(!pt.skip){let Mt=_e(pt);M.assertIsDefined(Mt),X(pt,Mt),we(pt,void 0);let mr=Ne.kind;if(FR(mr)){let br=Tt.parent;for(;br.kind===217||jR(br);)br=br.parent;(mr===56||vb(br))&&LCe(Tt.left,Mt,vb(br)?br.thenStatement:void 0),FCe(Mt,Tt.left)}}}function T(Ne,pt,Tt){if(!pt.skip)return V(pt,Ne)}function C(Ne,pt){let Tt;if(pt.skip)Tt=_e(pt);else{let Mt=H(pt);M.assertIsDefined(Mt);let mr=_e(pt);M.assertIsDefined(mr),Tt=CYe(Ne.left,Ne.operatorToken,Ne.right,Mt,mr,pt.checkMode,Ne)}return pt.skip=!1,X(pt,void 0),we(pt,void 0),pt.stackIndex--,Tt}function I(Ne,pt,Tt){return we(Ne,pt),Ne}function V(Ne,pt){if(Pn(pt))return pt;we(Ne,hs(pt,Ne.checkMode))}function H(Ne){return Ne.typeStack[Ne.stackIndex]}function X(Ne,pt){Ne.typeStack[Ne.stackIndex]=pt}function _e(Ne){return Ne.typeStack[Ne.stackIndex+1]}function we(Ne,pt){Ne.typeStack[Ne.stackIndex+1]=pt}}function Yjt(r){let{left:a,operatorToken:_,right:h}=r;_.kind===61&&(Pn(a)&&(a.operatorToken.kind===57||a.operatorToken.kind===56)&&Or(a,v._0_and_1_operations_cannot_be_mixed_without_parentheses,Sa(a.operatorToken.kind),Sa(_.kind)),Pn(h)&&(h.operatorToken.kind===57||h.operatorToken.kind===56)&&Or(h,v._0_and_1_operations_cannot_be_mixed_without_parentheses,Sa(h.operatorToken.kind),Sa(_.kind)))}function Kjt(r,a,_,h,T){let C=a.kind;if(C===64&&(r.kind===210||r.kind===209))return uC(r,hs(_,h),h,_.kind===110);let I;FR(C)?I=y4(r,h):I=hs(r,h);let V=hs(_,h);return CYe(r,a,_,I,V,h,T)}function CYe(r,a,_,h,T,C,I){let V=a.kind;switch(V){case 42:case 43:case 67:case 68:case 44:case 69:case 45:case 70:case 41:case 66:case 48:case 71:case 49:case 72:case 50:case 73:case 52:case 75:case 53:case 79:case 51:case 74:if(h===In||T===In)return In;h=hh(h,r),T=hh(T,_);let Dr;if(h.flags&528&&T.flags&528&&(Dr=Ne(a.kind))!==void 0)return Qe(I||a,v.The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead,Sa(a.kind),Sa(Dr)),Te;{let $n=ine(r,h,v.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type,!0),ii=ine(_,T,v.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type,!0),si;if(e_(h,3)&&e_(T,3)||!(dl(h,2112)||dl(T,2112)))si=Te;else if(H(h,T)){switch(V){case 50:case 73:mr();break;case 43:case 68:ee<3&&Qe(I,v.Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_later)}si=Re}else mr(H),si=Oe;return $n&&ii&&pt(si),si}case 40:case 65:if(h===In||T===In)return In;!e_(h,402653316)&&!e_(T,402653316)&&(h=hh(h,r),T=hh(T,_));let zr;return e_(h,296,!0)&&e_(T,296,!0)?zr=Te:e_(h,2112,!0)&&e_(T,2112,!0)?zr=Re:e_(h,402653316,!0)||e_(T,402653316,!0)?zr=Ue:(Ao(h)||Ao(T))&&(zr=ao(h)||ao(T)?Oe:Me),zr&&!we(V)?zr:zr?(V===65&&pt(zr),zr):(mr((ii,si)=>e_(ii,402655727)&&e_(si,402655727)),Me);case 30:case 32:case 33:case 34:return we(V)&&(h=e2e(hh(h,r)),T=e2e(hh(T,_)),Mt(($n,ii)=>{if(Ao($n)||Ao(ii))return!0;let si=ga($n,tn),Ea=ga(ii,tn);return si&&Ea||!si&&!Ea&&IJ($n,ii)})),qr;case 35:case 36:case 37:case 38:if(!(C&&C&64)){if((F$(r)||F$(_))&&(!hn(r)||V===37||V===38)){let $n=V===35||V===37;Qe(I,v.This_condition_will_always_return_0_since_JavaScript_compares_objects_by_reference_not_value,$n?"false":"true")}en(I,V,r,_),Mt(($n,ii)=>CCe($n,ii)||CCe(ii,$n))}return qr;case 104:return Jjt(r,_,h,T,C);case 103:return zjt(r,_,h,T);case 56:case 77:{let $n=Eg(h,4194304)?fi([ALt(ce?h:ev(T)),T]):h;return V===77&&pt(T),$n}case 57:case 76:{let $n=Eg(h,8388608)?fi([tv(Q$e(h)),T],2):h;return V===76&&pt(T),$n}case 61:case 78:{let $n=Eg(h,262144)?fi([tv(h),T],2):h;return V===78&&pt(T),$n}case 64:let Qr=Pn(r.parent)?cl(r.parent):0;return X(Qr,T),Tt(Qr)?((!(T.flags&524288)||Qr!==2&&Qr!==6&&!Z0(T)&&!b2e(T)&&!(Kn(T)&1))&&pt(T),h):(pt(T),T);case 28:if(!q.allowUnreachableCode&&vq(r)&&!_e(r.parent)){let $n=Ur(r),ii=$n.text,si=Ja(ii,r.pos);$n.parseDiagnostics.some(Ks=>Ks.code!==v.JSX_expressions_must_have_one_parent_element.code?!1:C$(Ks,si))||Qe(r,v.Left_side_of_comma_operator_is_unused_and_has_no_side_effects)}return T;default:return M.fail()}function H(Dr,zr){return e_(Dr,2112)&&e_(zr,2112)}function X(Dr,zr){if(Dr===2)for(let Qr of PS(zr)){let $n=gn(Qr);if($n.symbol&&$n.symbol.flags&32){let ii=Qr.escapedName,si=xr(Qr.valueDeclaration,ii,788968,void 0,!1);si?.declarations&&si.declarations.some(p2)&&(j0(si,v.Duplicate_identifier_0,Qi(ii),Qr),j0(Qr,v.Duplicate_identifier_0,Qi(ii),si))}}}function _e(Dr){return Dr.parent.kind===217&&Pf(Dr.left)&&Dr.left.text==="0"&&(ea(Dr.parent.parent)&&Dr.parent.parent.expression===Dr.parent||Dr.parent.parent.kind===215)&&(oc(Dr.right)||He(Dr.right)&&Dr.right.escapedText==="eval")}function we(Dr){let zr=yq(h,12288)?r:yq(T,12288)?_:void 0;return zr?(Qe(zr,v.The_0_operator_cannot_be_applied_to_type_symbol,Sa(Dr)),!1):!0}function Ne(Dr){switch(Dr){case 52:case 75:return 57;case 53:case 79:return 38;case 51:case 74:return 56;default:return}}function pt(Dr){y0(V)&&n(zr);function zr(){let Qr=h;if(XO(a.kind)&&r.kind===211&&(Qr=$re(r,void 0,!0)),Z7(r,v.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access,v.The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access)){let $n;if(te&&Wn(r)&&dl(Dr,32768)){let ii=il(t_(r.expression),r.name.escapedText);lre(Dr,ii)&&($n=v.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target)}RS(Dr,Qr,r,_,$n)}}}function Tt(Dr){var zr;switch(Dr){case 2:return!0;case 1:case 5:case 6:case 3:case 4:let Qr=_d(r),$n=iA(_);return!!$n&&Ca($n)&&!!((zr=Qr?.exports)!=null&&zr.size);default:return!1}}function Mt(Dr){return Dr(h,T)?!1:(mr(Dr),!0)}function mr(Dr){let zr=!1,Qr=I||a;if(Dr){let Ks=h1(h),no=h1(T);zr=!(Ks===h&&no===T)&&!!(Ks&&no)&&Dr(Ks,no)}let $n=h,ii=T;!zr&&Dr&&([$n,ii]=Xjt(h,T,Dr));let[si,Ea]=W6($n,ii);br(Qr,zr,si,Ea)||Gb(Qr,zr,v.Operator_0_cannot_be_applied_to_types_1_and_2,Sa(a.kind),si,Ea)}function br(Dr,zr,Qr,$n){switch(a.kind){case 37:case 35:case 38:case 36:return Gb(Dr,zr,v.This_comparison_appears_to_be_unintentional_because_the_types_0_and_1_have_no_overlap,Qr,$n);default:return}}function en(Dr,zr,Qr,$n){let ii=Fn(So(Qr)),si=Fn(So($n));if(ii||si){let Ea=Qe(Dr,v.This_condition_will_always_return_0,Sa(zr===37||zr===35?97:112));if(ii&&si)return;let Ks=zr===38||zr===36?Sa(54):"",no=ii?$n:Qr,Os=So(no);ca(Ea,pn(no,v.Did_you_mean_0,`${Ks}Number.isNaN(${nc(Os)?op(Os):"..."})`))}}function Fn(Dr){if(He(Dr)&&Dr.escapedText==="NaN"){let zr=IMt();return!!zr&&zr===gf(Dr)}return!1}}function Xjt(r,a,_){let h=r,T=a,C=ev(r),I=ev(a);return _(C,I)||(h=C,T=I),[h,T]}function Qjt(r){n(Ne);let a=Dp(r);if(!a)return Me;let _=Rl(a);if(!(_&1))return Me;let h=(_&2)!==0;r.asteriskToken&&(h&&ee<5&&gu(r,26624),!h&&ee<2&&q.downlevelIteration&&gu(r,256));let T=VD(a);T&&T.flags&1048576&&(T=Fl(T,pt=>PCe(pt,_,void 0)));let C=T&&WCe(T,h),I=C&&C.yieldType||Me,V=C&&C.nextType||Me,H=h?_C(V)||Me:V,X=r.expression?hs(r.expression):Z,_e=gYe(r,X,H,h);if(T&&_e&&RS(_e,I,r.expression||r,r.expression),r.asteriskToken)return BCe(h?19:17,1,X,r.expression)||Me;if(T)return _x(2,T,h)||Me;let we=tGe(2,a);return we||(we=Me,n(()=>{if(de&&!Ipe(r)){let pt=hf(r,void 0);(!pt||Ao(pt))&&Qe(r,v.yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_type_annotation)}})),we;function Ne(){r.flags&16384||ju(r,v.A_yield_expression_is_only_allowed_in_a_generator_body),M2e(r)&&Qe(r,v.yield_expressions_cannot_be_used_in_a_parameter_initializer)}}function Zjt(r,a){let _=y4(r.condition,a);LCe(r.condition,_,r.whenTrue);let h=hs(r.whenTrue,a),T=hs(r.whenFalse,a);return fi([h,T],2)}function AYe(r){let a=r.parent;return uf(a)&&AYe(a)||cc(a)&&a.argumentExpression===r}function eBt(r){let a=[r.head.text],_=[];for(let T of r.templateSpans){let C=hs(T.expression);yq(C,12288)&&Qe(T.expression,v.Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String),a.push(T.literal.text),_.push(ga(C,er)?C:Ue)}let h=r.parent.kind!==215&&ke(r).value;return h?Hk(Lf(h)):p4(r)||AYe(r)||ym(hf(r,void 0)||Rt,tBt)?Y2(a,_):Ue}function tBt(r){return!!(r.flags&134217856||r.flags&58982400&&dl(Zu(r)||Rt,402653316))}function rBt(r){return SE(r)&&!u2(r.parent)?r.parent.parent:r}function tw(r,a,_,h){let T=rBt(r);eq(T,a,!1),y5t(T,_);let C=hs(r,h|1|(_?2:0));_&&_.intraExpressionInferenceSites&&(_.intraExpressionInferenceSites=void 0);let I=dl(C,2944)&&one(C,Bre(a,r,void 0))?Q_(C):C;return v5t(),H7(),I}function yl(r,a){if(a)return hs(r,a);let _=qn(r);if(!_.resolvedType){let h=Vo,T=cm;Vo=d_,cm=void 0,_.resolvedType=hs(r,a),cm=T,Vo=h}return _.resolvedType}function kYe(r){return r=So(r,!0),r.kind===216||r.kind===234||m2(r)}function f4(r,a,_){let h=dR(r);if(hn(r)){let C=gj(r);if(C)return pCe(h,C,a)}let T=kCe(h)||(_?tw(h,_,void 0,a||0):yl(h,a));return ns(r)&&r.name.kind===207&&Ha(T)&&!T.target.hasRestElement&&f1(T)<r.name.elements.length?nBt(T,r.name):T}function nBt(r,a){let _=a.elements,h=rx(r).slice(),T=r.target.elementFlags.slice();for(let C=f1(r);C<_.length;C++){let I=_[C];(C<_.length-1||!(I.kind===208&&I.dotDotDotToken))&&(h.push(!pu(I)&&u4(I)?$y(I,!1,!1):Me),T.push(2),!pu(I)&&!u4(I)&&bT(I,Me))}return cy(h,T,r.target.readonly)}function ane(r,a){let _=px(r)&6||eR(r)?a:ST(a);if(hn(r)){if(W$e(_))return bT(r,Me),Me;if(mre(_))return bT(r,Uo),Uo}return _}function one(r,a){if(a){if(a.flags&3145728){let _=a.types;return Pt(_,h=>one(r,h))}if(a.flags&58982400){let _=Zu(a)||Rt;return dl(_,4)&&dl(r,128)||dl(_,8)&&dl(r,256)||dl(_,64)&&dl(r,2048)||dl(_,4096)&&dl(r,8192)||one(r,_)}return!!(a.flags&406847616&&dl(r,128)||a.flags&256&&dl(r,256)||a.flags&2048&&dl(r,2048)||a.flags&512&&dl(r,512)||a.flags&8192&&dl(r,8192))}return!1}function p4(r){let a=r.parent;return sb(a)&&Qm(a.type)||m2(a)&&Qm(FO(a))||fCe(r)&&$2(hf(r,0))||(uf(a)||Gu(a)||Ad(a))&&p4(a)||(ql(a)||p_(a)||PO(a))&&p4(a.parent)}function d4(r,a,_){let h=hs(r,a,_);return p4(r)||Y_e(r)?Q_(h):kYe(r)?h:t2e(h,Bre(hf(r,void 0),r,void 0))}function PYe(r,a){return r.name.kind===167&&gh(r.name),d4(r.initializer,a)}function NYe(r,a){eXe(r),r.name.kind===167&&gh(r.name);let _=SYe(r,a);return DYe(r,_,a)}function DYe(r,a,_){if(_&&_&10){let h=K7(a,0,!0),T=K7(a,1,!0),C=h||T;if(C&&C.typeParameters){let I=xT(r,2);if(I){let V=K7(tv(I),h?0:1,!1);if(V&&!V.typeParameters){if(_&8)return wYe(r,_),bc;let H=cx(r),X=H.signature&&ko(H.signature),_e=X&&UGe(X);if(_e&&!_e.typeParameters&&!wi(H.inferences,rw)){let we=oBt(H,C.typeParameters),Ne=ixe(C,we),pt=Cr(H.inferences,Tt=>c2e(Tt.typeParameter));if(i2e(Ne,V,(Tt,Mt)=>{nv(pt,Tt,Mt,0,!0)}),Pt(pt,rw)&&(s2e(Ne,V,(Tt,Mt)=>{nv(pt,Tt,Mt)}),!sBt(H.inferences,pt)))return aBt(H.inferences,pt),H.inferredTypeParameters=ps(H.inferredTypeParameters,we),G2(Ne)}return G2(VGe(C,V,H),va(R0,we=>we&&Cr(we.inferences,Ne=>Ne.typeParameter)).slice())}}}}return a}function wYe(r,a){if(a&2){let _=cx(r);_.flags|=4}}function rw(r){return!!(r.candidates||r.contraCandidates)}function iBt(r){return!!(r.candidates||r.contraCandidates||cWe(r.typeParameter))}function sBt(r,a){for(let _=0;_<r.length;_++)if(rw(r[_])&&rw(a[_]))return!0;return!1}function aBt(r,a){for(let _=0;_<r.length;_++)!rw(r[_])&&rw(a[_])&&(r[_]=a[_])}function oBt(r,a){let _=[],h,T;for(let C of a){let I=C.symbol.escapedName;if(ACe(r.inferredTypeParameters,I)||ACe(_,I)){let V=cBt(ps(r.inferredTypeParameters,_),I),H=Za(262144,V),X=fd(H);X.target=C,h=Bt(h,C),T=Bt(T,X),_.push(X)}else _.push(C)}if(T){let C=Xf(h,T);for(let I of T)I.mapper=C}return _}function ACe(r,a){return Pt(r,_=>_.symbol.escapedName===a)}function cBt(r,a){let _=a.length;for(;_>1&&a.charCodeAt(_-1)>=48&&a.charCodeAt(_-1)<=57;)_--;let h=a.slice(0,_);for(let T=1;;T++){let C=h+T;if(!ACe(r,C))return C}}function IYe(r){let a=lC(r);if(a&&!a.typeParameters)return ko(a)}function lBt(r){let a=hs(r.expression),_=B7(a,r.expression),h=IYe(a);return h&&vre(h,r,_!==a)}function t_(r){let a=kCe(r);if(a)return a;if(r.flags&268435456&&cm){let T=cm[yo(r)];if(T)return T}let _=Hv,h=hs(r,64);if(Hv!==_){let T=cm||(cm=[]);T[yo(r)]=h,wpe(r,r.flags|268435456)}return h}function kCe(r){let a=So(r,!0);if(m2(a)){let _=FO(a);if(!Qm(_))return Wi(_)}if(a=So(r),eS(a)){let _=kCe(a.expression);return _?_C(_):void 0}if(ea(a)&&a.expression.kind!==108&&!kf(a,!0)&&!eYe(a))return qx(a)?lBt(a):IYe(QD(a.expression));if(sb(a)&&!Qm(a.type))return Wi(a.type);if(WT(r)||bI(r))return hs(r)}function Sq(r){let a=qn(r);if(a.contextFreeType)return a.contextFreeType;eq(r,Me,!1);let _=a.contextFreeType=hs(r,4);return H7(),_}function hs(r,a,_){var h,T;(h=Cn)==null||h.push(Cn.Phase.Check,"checkExpression",{kind:r.kind,pos:r.pos,end:r.end,path:r.tracingPath});let C=R;R=r,x=0;let I=fBt(r,a,_),V=DYe(r,I,a);return sne(V)&&uBt(r,V),R=C,(T=Cn)==null||T.pop(),V}function uBt(r,a){if(r.parent.kind===211&&r.parent.expression===r||r.parent.kind===212&&r.parent.expression===r||(r.kind===80||r.kind===166)&&Ene(r)||r.parent.kind===186&&r.parent.exprName===r||r.parent.kind===281||Qe(r,v.const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query),Cd(q)){M.assert(!!(a.symbol.flags&128));let h=a.symbol.valueDeclaration,T=e.getRedirectReferenceForResolutionFromSourceOfProject(Ur(h).resolvedPath);h.flags&33554432&&!gb(r)&&(!T||!lE(T.commandLine.options))&&Qe(r,v.Cannot_access_ambient_const_enums_when_0_is_enabled,Ie)}}function _Bt(r,a){if(Pp(r)){if(RG(r))return pCe(r.expression,MG(r),a);if(m2(r))return iYe(r,a)}return hs(r.expression,a)}function fBt(r,a,_){let h=r.kind;if(i)switch(h){case 231:case 218:case 219:i.throwIfCancellationRequested()}switch(h){case 80:return VFt(r,a);case 81:return o9t(r);case 110:return QJ(r);case 108:return Lre(r);case 106:return z;case 15:case 11:return p2e(r)?tr:Hk(Lf(r.text));case 9:return aXe(r),Hk(zm(+r.text));case 10:return dqt(r),Hk(ere({negative:!1,base10Value:_O(r.text)}));case 112:return Ht;case 97:return It;case 228:return eBt(r);case 14:return I5t(r);case 209:return lGe(r,a,_);case 210:return B5t(r,a);case 211:return $re(r,a);case 166:return CGe(r,a);case 212:return T9t(r,a);case 213:if(r.expression.kind===102)return ejt(r);case 214:return Z9t(r,a);case 215:return tjt(r);case 217:return _Bt(r,a);case 231:return eVt(r);case 218:case 219:return SYe(r,a);case 221:return Fjt(r);case 216:case 234:return rjt(r,a);case 235:return sjt(r);case 233:return aYe(r);case 238:return ajt(r);case 236:return ojt(r);case 220:return Mjt(r);case 222:return jjt(r);case 223:return Bjt(r);case 224:return Ujt(r);case 225:return Vjt(r);case 226:return he(r,a);case 227:return Zjt(r,a);case 230:return O5t(r,a);case 232:return Z;case 229:return Qjt(r);case 237:return R5t(r);case 294:return e9t(r,a);case 284:return q5t(r,a);case 285:return V5t(r,a);case 288:return z5t(r);case 292:return $5t(r,a);case 286:M.fail("Shouldn't ever directly check a JsxOpeningElement")}return Oe}function OYe(r){Xy(r),r.expression&&ju(r.expression,v.Type_expected),ja(r.constraint),ja(r.default);let a=XE(jn(r));Zu(a),F8t(a)||Qe(r.default,v.Type_parameter_0_has_a_circular_default,ln(a));let _=mf(a),h=H2(a);_&&h&&I_(h,bp(os(_,sx(a,h)),h),r.default,v.Type_0_does_not_satisfy_the_constraint_1),eP(r),n(()=>v4(r.name,v.Type_parameter_name_cannot_be_0))}function pBt(r){var a,_;if(Yu(r.parent)||gi(r.parent)||im(r.parent)){let h=XE(jn(r)),T=Kxe(h)&24576;if(T){let C=jn(r.parent);if(im(r.parent)&&!(Kn(ac(C))&52))Qe(r,v.Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_types);else if(T===8192||T===16384){(a=Cn)==null||a.push(Cn.Phase.CheckTypes,"checkTypeParameterDeferred",{parent:Lu(ac(C)),id:Lu(h)});let I=MJ(C,h,T===16384?mc:qf),V=MJ(C,h,T===16384?qf:mc),H=h;L=h,I_(I,V,r,v.Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation),L=H,(_=Cn)==null||_.pop()}}}}function RYe(r){Xy(r),Cq(r);let a=Dp(r);li(r,31)&&(a.kind===176&&Yd(a.body)||Qe(r,v.A_parameter_property_is_only_allowed_in_a_constructor_implementation),a.kind===176&&He(r.name)&&r.name.escapedText==="constructor"&&Qe(r.name,v.constructor_cannot_be_used_as_a_parameter_property_name)),!r.initializer&&dN(r)&&Hs(r.name)&&a.body&&Qe(r,v.A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature),r.name&&He(r.name)&&(r.name.escapedText==="this"||r.name.escapedText==="new")&&(a.parameters.indexOf(r)!==0&&Qe(r,v.A_0_parameter_must_be_the_first_parameter,r.name.escapedText),(a.kind===176||a.kind===180||a.kind===185)&&Qe(r,v.A_constructor_cannot_have_a_this_parameter),a.kind===219&&Qe(r,v.An_arrow_function_cannot_have_a_this_parameter),(a.kind===177||a.kind===178)&&Qe(r,v.get_and_set_accessors_cannot_declare_this_parameters)),r.dotDotDotToken&&!Hs(r.name)&&!ga(bg(gn(r.symbol)),Cl)&&Qe(r,v.A_rest_parameter_must_be_of_an_array_type)}function dBt(r){let a=mBt(r);if(!a){Qe(r,v.A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods);return}let _=md(a),h=Bd(_);if(!h)return;ja(r.type);let{parameterName:T}=r;if(h.kind===0||h.kind===2)tre(T);else if(h.parameterIndex>=0){if(E_(_)&&h.parameterIndex===_.parameters.length-1)Qe(T,v.A_type_predicate_cannot_reference_a_rest_parameter);else if(h.type){let C=()=>js(void 0,v.A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type);I_(h.type,gn(_.parameters[h.parameterIndex]),r.type,void 0,C)}}else if(T){let C=!1;for(let{name:I}of a.parameters)if(Hs(I)&&MYe(I,T,h.parameterName)){C=!0;break}C||Qe(r.parameterName,v.Cannot_find_parameter_0,h.parameterName)}}function mBt(r){switch(r.parent.kind){case 219:case 179:case 262:case 218:case 184:case 174:case 173:let a=r.parent;if(r===a.type)return a}}function MYe(r,a,_){for(let h of r.elements){if(pu(h))continue;let T=h.name;if(T.kind===80&&T.escapedText===_)return Qe(a,v.A_type_predicate_cannot_reference_element_0_in_a_binding_pattern,_),!0;if((T.kind===207||T.kind===206)&&MYe(T,a,_))return!0}}function tL(r){r.kind===181?JJt(r):(r.kind===184||r.kind===262||r.kind===185||r.kind===179||r.kind===176||r.kind===180)&&Dne(r);let a=Rl(r);a&4||((a&3)===3&&ee<5&&gu(r,6144),(a&3)===2&&ee<4&&gu(r,64),a&3&&ee<2&&gu(r,128)),Pq(j1(r)),XUt(r),kt(r.parameters,RYe),r.type&&ja(r.type),n(_);function _(){dUt(r);let h=lp(r),T=h;if(hn(r)){let C=tb(r);if(C&&C.typeExpression&&Gp(C.typeExpression.type)){let I=lC(Wi(C.typeExpression));I&&I.declaration&&(h=lp(I.declaration),T=C.typeExpression.type)}}if(de&&!h)switch(r.kind){case 180:Qe(r,v.Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);break;case 179:Qe(r,v.Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);break}if(h&&T){let C=Rl(r);if((C&5)===1){let I=Wi(h);I===dn?Qe(T,v.A_generator_cannot_have_a_void_type_annotation):PCe(I,C,T)}else(C&3)===2&&$Bt(r,h,T)}r.kind!==181&&r.kind!==317&&jS(r)}}function PCe(r,a,_){let h=_x(0,r,(a&2)!==0)||Me,T=_x(1,r,(a&2)!==0)||h,C=_x(2,r,(a&2)!==0)||Rt,I=nne(h,T,C,!!(a&2));return I_(I,r,_)}function gBt(r){let a=new Map,_=new Map,h=new Map;for(let C of r.members)if(C.kind===176)for(let I of C.parameters)ap(I,C)&&!Hs(I.name)&&T(a,I.name,I.name.escapedText,3);else{let I=oa(C),V=C.name;if(!V)continue;let H=Zi(V),X=H&&I?16:0,_e=H?h:I?_:a,we=V&&lAe(V);if(we)switch(C.kind){case 177:T(_e,V,we,1|X);break;case 178:T(_e,V,we,2|X);break;case 172:T(_e,V,we,3|X);break;case 174:T(_e,V,we,8|X);break}}function T(C,I,V,H){let X=C.get(V);if(X)if((X&16)!==(H&16))Qe(I,v.Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name,Hc(I));else{let _e=!!(X&8),we=!!(H&8);_e||we?_e!==we&&Qe(I,v.Duplicate_identifier_0,Hc(I)):X&H&-17?Qe(I,v.Duplicate_identifier_0,Hc(I)):C.set(V,X|H)}else C.set(V,H)}}function hBt(r){for(let a of r.members){let _=a.name;if(oa(a)&&_){let T=lAe(_);switch(T){case"name":case"length":case"caller":case"arguments":if(K)break;case"prototype":let C=v.Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1,I=YE(jn(r));Qe(_,C,T,I);break}}}}function LYe(r){let a=new Map;for(let _ of r.members)if(_.kind===171){let h,T=_.name;switch(T.kind){case 11:case 9:h=T.text;break;case 80:h=Nn(T);break;default:continue}a.get(h)?(Qe(Ps(_.symbol.valueDeclaration),v.Duplicate_identifier_0,h),Qe(_.name,v.Duplicate_identifier_0,h)):a.set(h,!0)}}function NCe(r){if(r.kind===264){let _=jn(r);if(_.declarations&&_.declarations.length>0&&_.declarations[0]!==r)return}let a=sxe(jn(r));if(a?.declarations){let _=new Map;for(let h of a.declarations)h.parameters.length===1&&h.parameters[0].type&&sC(Wi(h.parameters[0].type),T=>{let C=_.get(Lu(T));C?C.declarations.push(h):_.set(Lu(T),{type:T,declarations:[h]})});_.forEach(h=>{if(h.declarations.length>1)for(let T of h.declarations)Qe(T,v.Duplicate_index_signature_for_type_0,ln(h.type))})}}function FYe(r){!Xy(r)&&!uqt(r)&&wne(r.name),Cq(r),cne(r),li(r,64)&&r.kind===172&&r.initializer&&Qe(r,v.Property_0_cannot_have_an_initializer_because_it_is_marked_abstract,Yo(r.name))}function yBt(r){return Zi(r.name)&&Qe(r,v.Private_identifiers_are_not_allowed_outside_class_bodies),FYe(r)}function vBt(r){eXe(r)||wne(r.name),ul(r)&&r.asteriskToken&&He(r.name)&&Nn(r.name)==="constructor"&&Qe(r.name,v.Class_constructor_may_not_be_a_generator),YYe(r),li(r,64)&&r.kind===174&&r.body&&Qe(r,v.Method_0_cannot_have_an_implementation_because_it_is_marked_abstract,Yo(r.name)),Zi(r.name)&&!Ou(r)&&Qe(r,v.Private_identifiers_are_not_allowed_outside_class_bodies),cne(r)}function cne(r){if(Zi(r.name)&&(ee<9||ee<99||!K)){for(let a=eg(r);a;a=eg(a))qn(a).flags|=1048576;if(eu(r.parent)){let a=D2e(r.parent);a&&(qn(r.name).flags|=32768,qn(a).flags|=4096)}}}function SBt(r){Xy(r),Js(r,ja)}function bBt(r){tL(r),cqt(r)||lqt(r),ja(r.body);let a=jn(r),_=Pc(a,r.kind);if(r===_&&_ne(a),$c(r.body))return;n(T);return;function h(C){return j_(C)?!0:C.kind===172&&!oa(C)&&!!C.initializer}function T(){let C=r.parent;if(nE(C)){w2e(r.parent,C);let I=I2e(C),V=GHe(r.body);if(V){if(I&&Qe(V,v.A_constructor_cannot_contain_a_super_call_when_its_class_extends_null),!re&&(Pt(r.parent.members,h)||Pt(r.parameters,X=>li(X,31))))if(!TBt(V,r.body))Qe(V,v.A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_initialized_properties_parameter_properties_or_private_identifiers);else{let X;for(let _e of r.body.statements){if(Du(_e)&&Kx(Ml(_e.expression))){X=_e;break}if(jYe(_e))break}X===void 0&&Qe(r,v.A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_class_contains_initialized_properties_parameter_properties_or_private_identifiers)}}else I||Qe(r,v.Constructors_for_derived_classes_must_contain_a_super_call)}}}function TBt(r,a){let _=g0(r.parent);return Du(_)&&_.parent===a}function jYe(r){return r.kind===108||r.kind===110?!0:nfe(r)?!1:!!Js(r,jYe)}function BYe(r){He(r.name)&&Nn(r.name)==="constructor"&&gi(r.parent)&&Qe(r.name,v.Class_constructor_may_not_be_an_accessor),n(a),ja(r.body),cne(r);function a(){if(!Dne(r)&&!XJt(r)&&wne(r.name),Tq(r),tL(r),r.kind===177&&!(r.flags&33554432)&&Yd(r.body)&&r.flags&512&&(r.flags&1024||Qe(r.name,v.A_get_accessor_must_return_a_value)),r.name.kind===167&&gh(r.name),BD(r)){let h=jn(r),T=Pc(h,177),C=Pc(h,178);if(T&&C&&!(iw(T)&1)){qn(T).flags|=1;let I=U_(T),V=U_(C);(I&64)!==(V&64)&&(Qe(T.name,v.Accessors_must_both_be_abstract_or_non_abstract),Qe(C.name,v.Accessors_must_both_be_abstract_or_non_abstract)),(I&4&&!(V&6)||I&2&&!(V&2))&&(Qe(T.name,v.A_get_accessor_must_be_at_least_as_accessible_as_the_setter),Qe(C.name,v.A_get_accessor_must_be_at_least_as_accessible_as_the_setter))}}let _=v7(jn(r));r.kind===177&&bCe(r,_)}}function EBt(r){Tq(r)}function xBt(r,a,_){return r.typeArguments&&_<r.typeArguments.length?Wi(r.typeArguments[_]):lne(r,a)[_]}function lne(r,a){return NS(Cr(r.typeArguments,Wi),a,ph(a),hn(r))}function UYe(r,a){let _,h,T=!0;for(let C=0;C<a.length;C++){let I=mf(a[C]);I&&(_||(_=lne(r,a),h=Xf(a,_)),T=T&&I_(_[C],os(I,h),r.typeArguments[C],v.Type_0_does_not_satisfy_the_constraint_1))}return T}function CBt(r,a){if(!ao(r))return a.flags&524288&&as(a).typeParameters||(Kn(r)&4?r.target.localTypeParameters:void 0)}function DCe(r){let a=Wi(r);if(!ao(a)){let _=qn(r).resolvedSymbol;if(_)return CBt(a,_)}}function wCe(r){if(Iq(r,r.typeArguments),r.kind===183&&!hn(r)&&!uR(r)&&r.typeArguments&&r.typeName.end!==r.typeArguments.pos){let a=Ur(r);J_e(a,r.typeName.end)===25&&fx(r,Ja(a.text,r.typeName.end),1,v.JSDoc_types_can_only_be_used_inside_documentation_comments)}kt(r.typeArguments,ja),VYe(r)}function VYe(r){let a=Wi(r);if(!ao(a)){r.typeArguments&&n(()=>{let h=DCe(r);h&&UYe(r,h)});let _=qn(r).resolvedSymbol;_&&Pt(_.declarations,h=>EA(h)&&!!(h.flags&536870912))&&L0(fq(r),_.declarations,_.escapedName)}}function ABt(r){let a=ai(r.parent,j5);if(!a)return;let _=DCe(a);if(!_)return;let h=mf(_[a.typeArguments.indexOf(r)]);return h&&os(h,Xf(_,lne(a,_)))}function kBt(r){wWe(r)}function PBt(r){kt(r.members,ja),n(a);function a(){let _=y$e(r);yne(_,_.symbol),NCe(r),LYe(r)}}function NBt(r){ja(r.elementType)}function DBt(r){let a=!1,_=!1;for(let h of r.elements){let T=yxe(h);if(T&8){let C=Wi(h.type);if(!g1(C)){Qe(h,v.A_rest_element_type_must_be_an_array_type);break}(Jd(C)||Ha(C)&&C.target.combinedFlags&4)&&(T|=4)}if(T&4){if(_){Or(h,v.A_rest_element_cannot_follow_another_rest_element);break}_=!0}else if(T&2){if(_){Or(h,v.An_optional_element_cannot_follow_a_rest_element);break}a=!0}else if(T&1&&a){Or(h,v.A_required_element_cannot_follow_an_optional_element);break}}kt(r.elements,ja),Wi(r)}function wBt(r){kt(r.types,ja),Wi(r)}function JYe(r,a){if(!(r.flags&8388608))return r;let _=r.objectType,h=r.indexType,T=Yf(_)&&Bte(_)===2?r$e(_,0):dh(_,0),C=!!Gy(_,Te);if(Zf(h,I=>ga(I,T)||C&&Uk(I,Te)))return a.kind===212&&kv(a)&&Kn(_)&32&&sy(_)&1&&Qe(a,v.Index_signature_in_type_0_only_permits_reading,ln(_)),r;if(X2(_)){let I=Kte(h,a);if(I){let V=sC(K_(_),H=>ma(H,I));if(V&&xd(V)&6)return Qe(a,v.Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter,Qi(I)),Oe}}return Qe(a,v.Type_0_cannot_be_used_to_index_type_1,ln(h),ln(_)),Oe}function IBt(r){ja(r.objectType),ja(r.indexType),JYe(f$e(r),r)}function OBt(r){RBt(r),ja(r.typeParameter),ja(r.nameType),ja(r.type),r.type||bT(r,Me);let a=Dxe(r),_=u1(a);if(_)I_(_,Er,r.nameType);else{let h=dd(a);I_(h,Er,RP(r.typeParameter))}}function RBt(r){var a;if((a=r.members)!=null&&a.length)return Or(r.members[0],v.A_mapped_type_may_not_declare_properties_or_methods)}function MBt(r){tre(r)}function LBt(r){ZJt(r),ja(r.type)}function FBt(r){Js(r,ja)}function jBt(r){Pr(r,_=>_.parent&&_.parent.kind===194&&_.parent.extendsType===_)||Or(r,v.infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type),ja(r.typeParameter);let a=jn(r.typeParameter);if(a.declarations&&a.declarations.length>1){let _=as(a);if(!_.typeParametersChecked){_.typeParametersChecked=!0;let h=XE(a),T=y_e(a,168);if(!mKe(T,[h],C=>[C])){let C=rs(a);for(let I of T)Qe(I.name,v.All_declarations_of_0_must_have_identical_constraints,C)}}}jS(r)}function BBt(r){for(let a of r.templateSpans){ja(a.type);let _=Wi(a.type);I_(_,er,a.type)}Wi(r)}function UBt(r){ja(r.argument),r.attributes&&BN(r.attributes,Or),VYe(r)}function VBt(r){r.dotDotDotToken&&r.questionToken&&Or(r,v.A_tuple_member_cannot_be_both_optional_and_rest),r.type.kind===190&&Or(r.type,v.A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type),r.type.kind===191&&Or(r.type,v.A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type),ja(r.type),Wi(r)}function bq(r){return(up(r,2)||j_(r))&&!!(r.flags&33554432)}function une(r,a){let _=Ine(r);if(r.parent.kind!==264&&r.parent.kind!==263&&r.parent.kind!==231&&r.flags&33554432){let h=K5(r);h&&h.flags&128&&!(_&128)&&!(Hg(r.parent)&&El(r.parent.parent)&&Rg(r.parent.parent))&&(_|=32),_|=128}return _&a}function _ne(r){n(()=>JBt(r))}function JBt(r){function a(Dr,zr){return zr!==void 0&&zr.parent===Dr[0].parent?zr:Dr[0]}function _(Dr,zr,Qr,$n,ii){if(($n^ii)!==0){let Ea=une(a(Dr,zr),Qr);kt(Dr,Ks=>{let no=une(Ks,Qr)^Ea;no&32?Qe(Ps(Ks),v.Overload_signatures_must_all_be_exported_or_non_exported):no&128?Qe(Ps(Ks),v.Overload_signatures_must_all_be_ambient_or_non_ambient):no&6?Qe(Ps(Ks)||Ks,v.Overload_signatures_must_all_be_public_private_or_protected):no&64&&Qe(Ps(Ks),v.Overload_signatures_must_all_be_abstract_or_non_abstract)})}}function h(Dr,zr,Qr,$n){if(Qr!==$n){let ii=oA(a(Dr,zr));kt(Dr,si=>{oA(si)!==ii&&Qe(Ps(si),v.Overload_signatures_must_all_be_optional_or_required)})}}let T=230,C=0,I=T,V=!1,H=!0,X=!1,_e,we,Ne,pt=r.declarations,Tt=(r.flags&16384)!==0;function Mt(Dr){if(Dr.name&&$c(Dr.name))return;let zr=!1,Qr=Js(Dr.parent,ii=>{if(zr)return ii;zr=ii===Dr});if(Qr&&Qr.pos===Dr.end&&Qr.kind===Dr.kind){let ii=Qr.name||Qr,si=Qr.name;if(Dr.name&&si&&(Zi(Dr.name)&&Zi(si)&&Dr.name.escapedText===si.escapedText||za(Dr.name)&&za(si)&&Q0(gh(Dr.name),gh(si))||jg(Dr.name)&&jg(si)&&JI(Dr.name)===JI(si))){if((Dr.kind===174||Dr.kind===173)&&oa(Dr)!==oa(Qr)){let Ks=oa(Dr)?v.Function_overload_must_be_static:v.Function_overload_must_not_be_static;Qe(ii,Ks)}return}if(Yd(Qr.body)){Qe(ii,v.Function_implementation_name_must_be_0,Yo(Dr.name));return}}let $n=Dr.name||Dr;Tt?Qe($n,v.Constructor_implementation_is_missing):li(Dr,64)?Qe($n,v.All_declarations_of_an_abstract_method_must_be_consecutive):Qe($n,v.Function_implementation_is_missing_or_not_immediately_following_the_declaration)}let mr=!1,br=!1,en=!1,Fn=[];if(pt)for(let Dr of pt){let zr=Dr,Qr=zr.flags&33554432,$n=zr.parent&&(zr.parent.kind===264||zr.parent.kind===187)||Qr;if($n&&(Ne=void 0),(zr.kind===263||zr.kind===231)&&!Qr&&(en=!0),zr.kind===262||zr.kind===174||zr.kind===173||zr.kind===176){Fn.push(zr);let ii=une(zr,T);C|=ii,I&=ii,V=V||oA(zr),H=H&&oA(zr);let si=Yd(zr.body);si&&_e?Tt?br=!0:mr=!0:Ne?.parent===zr.parent&&Ne.end!==zr.pos&&Mt(Ne),si?_e||(_e=zr):X=!0,Ne=zr,$n||(we=zr)}hn(Dr)&&Bs(Dr)&&Dr.jsDoc&&(X=wt(kH(Dr))>0)}if(br&&kt(Fn,Dr=>{Qe(Dr,v.Multiple_constructor_implementations_are_not_allowed)}),mr&&kt(Fn,Dr=>{Qe(Ps(Dr)||Dr,v.Duplicate_function_implementation)}),en&&!Tt&&r.flags&16&&pt){let Dr=Zn(pt,zr=>zr.kind===263).map(zr=>pn(zr,v.Consider_adding_a_declare_modifier_to_this_class));kt(pt,zr=>{let Qr=zr.kind===263?v.Class_declaration_cannot_implement_overload_list_for_0:zr.kind===262?v.Function_with_bodies_can_only_merge_with_classes_that_are_ambient:void 0;Qr&&ca(Qe(Ps(zr)||zr,Qr,Qc(r)),...Dr)})}if(we&&!we.body&&!li(we,64)&&!we.questionToken&&Mt(we),X&&(pt&&(_(pt,_e,T,C,I),h(pt,_e,V,H)),_e)){let Dr=ex(r),zr=md(_e);for(let Qr of Dr)if(!tLt(zr,Qr)){let $n=Qr.declaration&&A0(Qr.declaration)?Qr.declaration.parent.tagName:Qr.declaration;ca(Qe($n,v.This_overload_signature_is_not_compatible_with_its_implementation_signature),pn(_e,v.The_implementation_signature_is_declared_here));break}}}function rL(r){n(()=>qBt(r))}function qBt(r){let a=r.localSymbol;if(!a&&(a=jn(r),!a.exportSymbol)||Pc(a,r.kind)!==r)return;let _=0,h=0,T=0;for(let X of a.declarations){let _e=H(X),we=une(X,2080);we&32?we&2048?T|=_e:_|=_e:h|=_e}let C=_|h,I=_&h,V=T&C;if(I||V)for(let X of a.declarations){let _e=H(X),we=Ps(X);_e&V?Qe(we,v.Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead,Yo(we)):_e&I&&Qe(we,v.Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local,Yo(we))}function H(X){let _e=X;switch(_e.kind){case 264:case 265:case 346:case 338:case 340:return 2;case 267:return B_(_e)||N0(_e)!==0?5:4;case 263:case 266:case 306:return 3;case 307:return 7;case 277:case 226:let we=_e,Ne=dc(we)?we.expression:we.right;if(!nc(Ne))return 1;_e=Ne;case 271:case 274:case 273:let pt=0,Tt=Au(jn(_e));return kt(Tt.declarations,Mt=>{pt|=H(Mt)}),pt;case 260:case 208:case 262:case 276:case 80:return 1;case 173:case 171:return 2;default:return M.failBadSyntaxKind(_e)}}}function m4(r,a,_,...h){let T=nL(r,a);return T&&_C(T,a,_,...h)}function nL(r,a,_){if(Ao(r))return;let h=r;if(h.promisedTypeOfPromise)return h.promisedTypeOfPromise;if(AS(r,EJ(!1)))return h.promisedTypeOfPromise=yc(r)[0];if(eL(ay(r),402915324))return;let T=il(r,"then");if(Ao(T))return;let C=T?Ys(T,0):ve;if(C.length===0){a&&Qe(a,v.A_promise_must_have_a_then_method);return}let I,V;for(let _e of C){let we=mT(_e);we&&we!==dn&&!mh(r,we,ih)?I=we:V=Bt(V,_e)}if(!V){M.assertIsDefined(I),_&&(_.value=I),a&&Qe(a,v.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1,ln(r),ln(I));return}let H=hm(fi(Cr(V,gCe)),2097152);if(Ao(H))return;let X=Ys(H,0);if(X.length===0){a&&Qe(a,v.The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback);return}return h.promisedTypeOfPromise=fi(Cr(X,gCe),2)}function iL(r,a,_,h,...T){return(a?_C(r,_,h,...T):h1(r,_,h,...T))||Oe}function qYe(r){if(eL(ay(r),402915324))return!1;let a=il(r,"then");return!!a&&Ys(hm(a,2097152),0).length>0}function fne(r){var a;if(r.flags&16777216){let _=hxe(!1);return!!_&&r.aliasSymbol===_&&((a=r.aliasTypeArguments)==null?void 0:a.length)===1}return!1}function g4(r){return r.flags&1048576?wc(r,g4):fne(r)?r.aliasTypeArguments[0]:r}function zYe(r){if(Ao(r)||fne(r))return!1;if(X2(r)){let a=Zu(r);if(a?a.flags&3||Z0(a)||ym(a,qYe):dl(r,8650752))return!0}return!1}function zBt(r){let a=hxe(!0);if(a)return qD(a,[g4(r)])}function WBt(r){return zYe(r)?zBt(r)??r:(M.assert(fne(r)||nL(r)===void 0,"type provided should not be a non-generic 'promise'-like."),r)}function _C(r,a,_,...h){let T=h1(r,a,_,...h);return T&&WBt(T)}function h1(r,a,_,...h){if(Ao(r)||fne(r))return r;let T=r;if(T.awaitedTypeOfType)return T.awaitedTypeOfType;if(r.flags&1048576){if(Yv.lastIndexOf(r.id)>=0){a&&Qe(a,v.Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method);return}let V=a?X=>h1(X,a,_,...h):h1;Yv.push(r.id);let H=wc(r,V);return Yv.pop(),T.awaitedTypeOfType=H}if(zYe(r))return T.awaitedTypeOfType=r;let C={value:void 0},I=nL(r,void 0,C);if(I){if(r.id===I.id||Yv.lastIndexOf(I.id)>=0){a&&Qe(a,v.Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method);return}Yv.push(r.id);let V=h1(I,a,_,...h);return Yv.pop(),V?T.awaitedTypeOfType=V:void 0}if(qYe(r)){if(a){M.assertIsDefined(_);let V;C.value&&(V=js(V,v.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1,ln(r),ln(C.value))),V=js(V,_,...h),_o.add(ky(Ur(a),a,V))}return}return T.awaitedTypeOfType=r}function $Bt(r,a,_){let h=Wi(a);if(ee>=2){if(ao(h))return;let C=EJ(!0);if(C!==Fa&&!AS(h,C)){T(v.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0,a,_,ln(h1(h)||dn));return}}else{if(Qk(r,5),ao(h))return;let C=oR(a);if(C===void 0){T(v.Type_0_is_not_a_valid_async_function_return_type_in_ES5_because_it_does_not_refer_to_a_Promise_compatible_constructor_value,a,_,ln(h));return}let I=nl(C,111551,!0),V=I?gn(I):Oe;if(ao(V)){C.kind===80&&C.escapedText==="Promise"&&LD(h)===EJ(!1)?Qe(_,v.An_async_function_or_method_in_ES5_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option):T(v.Type_0_is_not_a_valid_async_function_return_type_in_ES5_because_it_does_not_refer_to_a_Promise_compatible_constructor_value,a,_,op(C));return}let H=_Mt(!0);if(H===zi){T(v.Type_0_is_not_a_valid_async_function_return_type_in_ES5_because_it_does_not_refer_to_a_Promise_compatible_constructor_value,a,_,op(C));return}let X=v.Type_0_is_not_a_valid_async_function_return_type_in_ES5_because_it_does_not_refer_to_a_Promise_compatible_constructor_value;if(!I_(V,H,_,X,()=>a===_?void 0:js(void 0,v.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type)))return;let we=C&&_p(C),Ne=m_(r.locals,we.escapedText,111551);if(Ne){Qe(Ne.valueDeclaration,v.Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions,Nn(we),op(C));return}}iL(h,!1,r,v.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);function T(C,I,V,H){if(I===V)Qe(V,C,H);else{let X=Qe(V,v.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type);ca(X,pn(I,C,H))}}}function HBt(r){let a=Ur(r);if(!BS(a)){let _=r.expression;if(uf(_))return!1;let h=!0,T;for(;;){if(x0(_)||VA(_)){_=_.expression;continue}if(ea(_)){h||(T=_),_.questionDotToken&&(T=_.questionDotToken),_=_.expression,h=!1;continue}if(Wn(_)){_.questionDotToken&&(T=_.questionDotToken),_=_.expression,h=!1;continue}He(_)||(T=_);break}if(T)return ca(Qe(r.expression,v.Expression_must_be_enclosed_in_parentheses_to_be_used_as_a_decorator),pn(T,v.Invalid_syntax_in_decorator)),!0}return!1}function GBt(r){HBt(r);let a=ew(r);tne(a,r);let _=ko(a);if(_.flags&1)return;let h=vCe(r);if(!h?.resolvedReturnType)return;let T,C=h.resolvedReturnType;switch(r.parent.kind){case 263:case 231:T=v.Decorator_function_return_type_0_is_not_assignable_to_type_1;break;case 172:if(!pe){T=v.Decorator_function_return_type_0_is_not_assignable_to_type_1;break}case 169:T=v.Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any;break;case 174:case 177:case 178:T=v.Decorator_function_return_type_0_is_not_assignable_to_type_1;break;default:return M.failBadSyntaxKind(r.parent)}I_(_,C,r.expression,T)}function sL(r,a,_,h,T,C=_.length,I=0){let V=U.createFunctionTypeNode(void 0,ve,U.createKeywordTypeNode(133));return Hy(V,r,a,_,h,T,C,I)}function ICe(r,a,_,h,T,C,I){let V=sL(r,a,_,h,T,C,I);return G2(V)}function WYe(r){return ICe(void 0,void 0,ve,r)}function $Ye(r){let a=Lm("value",r);return ICe(void 0,void 0,[a],dn)}function OCe(r){if(r)switch(r.kind){case 193:case 192:return HYe(r.types);case 194:return HYe([r.trueType,r.falseType]);case 196:case 202:return OCe(r.type);case 183:return r.typeName}}function HYe(r){let a;for(let _ of r){for(;_.kind===196||_.kind===202;)_=_.type;if(_.kind===146||!ce&&(_.kind===201&&_.literal.kind===106||_.kind===157))continue;let h=OCe(_);if(!h)return;if(a){if(!He(a)||!He(h)||a.escapedText!==h.escapedText)return}else a=h}return a}function pne(r){let a=Vl(r);return Fh(r)?gH(a):a}function Tq(r){if(!TE(r)||!Wp(r)||!r.modifiers||!cR(pe,r,r.parent,r.parent.parent))return;let a=Ln(r.modifiers,fu);if(a){pe?(gu(a,8),r.kind===169&&gu(a,32)):ee<99&&(gu(a,8),tu(r)?r.name?gKe(r)&&gu(a,4194304):gu(a,4194304):eu(r)||(Zi(r.name)&&(ul(r)||U1(r)||Ef(r))&&gu(a,4194304),za(r.name)&&gu(a,8388608))),Qk(r,8);for(let _ of r.modifiers)fu(_)&&GBt(_)}}function YBt(r){n(a);function a(){YYe(r),sAe(r),h4(r,r.name)}}function KBt(r){r.typeExpression||Qe(r.name,v.JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags),r.name&&v4(r.name,v.Type_alias_name_cannot_be_0),ja(r.typeExpression),Pq(j1(r))}function XBt(r){ja(r.constraint);for(let a of r.typeParameters)ja(a)}function QBt(r){ja(r.typeExpression)}function ZBt(r){ja(r.typeExpression);let a=_b(r);if(a){let _=C5(a,qj);if(wt(_)>1)for(let h=1;h<wt(_);h++){let T=_[h].tagName;Qe(T,v._0_tag_already_specified,Nn(T))}}}function eUt(r){r.name&&Dq(r.name,!0)}function tUt(r){ja(r.typeExpression)}function rUt(r){ja(r.typeExpression)}function nUt(r){n(a),tL(r);function a(){!r.type&&!XP(r)&&bT(r,Me)}}function iUt(r){let a=_b(r);a&&pc(a)&&Qe(r.tagName,v.An_arrow_function_cannot_have_a_this_parameter)}function sUt(r){GCe(r)}function aUt(r){let a=_b(r);(!a||!tu(a)&&!eu(a))&&Qe(a,v.JSDoc_0_is_not_attached_to_a_class,Nn(r.tagName))}function oUt(r){let a=_b(r);if(!a||!tu(a)&&!eu(a)){Qe(a,v.JSDoc_0_is_not_attached_to_a_class,Nn(r.tagName));return}let _=nb(a).filter(zA);M.assert(_.length>0),_.length>1&&Qe(_[1],v.Class_declarations_cannot_have_more_than_one_augments_or_extends_tag);let h=GYe(r.class.expression),T=nE(a);if(T){let C=GYe(T.expression);C&&h.escapedText!==C.escapedText&&Qe(h,v.JSDoc_0_1_does_not_match_the_extends_2_clause,Nn(r.tagName),Nn(h),Nn(C))}}function cUt(r){let a=tE(r);a&&j_(a)&&Qe(r,v.An_accessibility_modifier_cannot_be_used_with_a_private_identifier)}function GYe(r){switch(r.kind){case 80:return r;case 211:return r.name;default:return}}function YYe(r){var a;Tq(r),tL(r);let _=Rl(r);if(r.name&&r.name.kind===167&&gh(r.name),BD(r)){let C=jn(r),I=r.localSymbol||C,V=(a=I.declarations)==null?void 0:a.find(H=>H.kind===r.kind&&!(H.flags&524288));r===V&&_ne(I),C.parent&&_ne(C)}let h=r.kind===173?void 0:r.body;if(ja(h),bCe(r,VD(r)),n(T),hn(r)){let C=tb(r);C&&C.typeExpression&&!B2e(Wi(C.typeExpression),r)&&Qe(C.typeExpression.type,v.The_type_of_a_function_declaration_must_match_the_function_s_signature)}function T(){lp(r)||($c(h)&&!bq(r)&&bT(r,Me),_&1&&Yd(h)&&ko(md(r)))}}function jS(r){n(a);function a(){let _=Ur(r),h=od.get(_.path);h||(h=[],od.set(_.path,h)),h.push(r)}}function KYe(r,a){for(let _ of r)switch(_.kind){case 263:case 231:lUt(_,a),RCe(_,a);break;case 307:case 267:case 241:case 269:case 248:case 249:case 250:ZYe(_,a);break;case 176:case 218:case 262:case 219:case 174:case 177:case 178:_.body&&ZYe(_,a),RCe(_,a);break;case 173:case 179:case 180:case 184:case 185:case 265:case 264:RCe(_,a);break;case 195:uUt(_,a);break;default:M.assertNever(_,"Node should not have been registered for unused identifiers check")}}function XYe(r,a,_){let h=Ps(r)||r,T=EA(r)?v._0_is_declared_but_never_used:v._0_is_declared_but_its_value_is_never_read;_(r,0,pn(h,T,a))}function aL(r){return He(r)&&Nn(r).charCodeAt(0)===95}function lUt(r,a){for(let _ of r.members)switch(_.kind){case 174:case 172:case 177:case 178:if(_.kind===178&&_.symbol.flags&32768)break;let h=jn(_);!h.isReferenced&&(up(_,2)||Wu(_)&&Zi(_.name))&&!(_.flags&33554432)&&a(_,0,pn(_.name,v._0_is_declared_but_its_value_is_never_read,rs(h)));break;case 176:for(let T of _.parameters)!T.symbol.isReferenced&&li(T,2)&&a(T,0,pn(T.name,v.Property_0_is_declared_but_its_value_is_never_read,Qc(T.symbol)));break;case 181:case 240:case 175:break;default:M.fail("Unexpected class member")}}function uUt(r,a){let{typeParameter:_}=r;MCe(_)&&a(r,1,pn(r,v._0_is_declared_but_its_value_is_never_read,Nn(_.name)))}function RCe(r,a){let _=jn(r).declarations;if(!_||Va(_)!==r)return;let h=j1(r),T=new Set;for(let C of h){if(!MCe(C))continue;let I=Nn(C.name),{parent:V}=C;if(V.kind!==195&&V.typeParameters.every(MCe)){if(Pg(T,V)){let H=Ur(V),X=sm(V)?PG(V):NG(H,V.typeParameters),we=V.typeParameters.length===1?[v._0_is_declared_but_its_value_is_never_read,I]:[v.All_type_parameters_are_unused];a(C,1,bu(H,X.pos,X.end-X.pos,...we))}}else a(C,1,pn(C,v._0_is_declared_but_its_value_is_never_read,I))}}function MCe(r){return!(ro(r.symbol).isReferenced&262144)&&!aL(r.name)}function Eq(r,a,_,h){let T=String(h(a)),C=r.get(T);C?C[1].push(_):r.set(T,[a,[_]])}function QYe(r){return ai(Bg(r),ns)}function _Ut(r){return Xa(r)?Yp(r.parent)?!!(r.propertyName&&aL(r.name)):aL(r.name):B_(r)||(Ei(r)&&$x(r.parent.parent)||eKe(r))&&aL(r.name)}function ZYe(r,a){let _=new Map,h=new Map,T=new Map;r.locals.forEach(C=>{if(!(C.flags&262144?!(C.flags&3&&!(C.isReferenced&3)):C.isReferenced||C.exportSymbol)&&C.declarations){for(let I of C.declarations)if(!_Ut(I))if(eKe(I))Eq(_,pUt(I),I,yo);else if(Xa(I)&&Yp(I.parent)){let V=Va(I.parent.elements);(I===V||!Va(I.parent.elements).dotDotDotToken)&&Eq(h,I.parent,I,yo)}else if(Ei(I)){let V=px(I)&7,H=Ps(I);(V!==4&&V!==6||!H||!aL(H))&&Eq(T,I.parent,I,yo)}else{let V=C.valueDeclaration&&QYe(C.valueDeclaration),H=C.valueDeclaration&&Ps(C.valueDeclaration);V&&H?!ap(V,V.parent)&&!sE(V)&&!aL(H)&&(Xa(I)&&Lv(I.parent)?Eq(h,I.parent,I,yo):a(V,1,pn(H,v._0_is_declared_but_its_value_is_never_read,Qc(C)))):XYe(I,Qc(C),a)}}}),_.forEach(([C,I])=>{let V=C.parent;if((C.name?1:0)+(C.namedBindings?C.namedBindings.kind===274?1:C.namedBindings.elements.length:0)===I.length)a(V,0,I.length===1?pn(V,v._0_is_declared_but_its_value_is_never_read,Nn(Ma(I).name)):pn(V,v.All_imports_in_import_declaration_are_unused));else for(let X of I)XYe(X,Nn(X.name),a)}),h.forEach(([C,I])=>{let V=QYe(C.parent)?1:0;if(C.elements.length===I.length)I.length===1&&C.parent.kind===260&&C.parent.parent.kind===261?Eq(T,C.parent.parent,C.parent,yo):a(C,V,I.length===1?pn(C,v._0_is_declared_but_its_value_is_never_read,xq(Ma(I).name)):pn(C,v.All_destructured_elements_are_unused));else for(let H of I)a(H,V,pn(H,v._0_is_declared_but_its_value_is_never_read,xq(H.name)))}),T.forEach(([C,I])=>{if(C.declarations.length===I.length)a(C,0,I.length===1?pn(Ma(I).name,v._0_is_declared_but_its_value_is_never_read,xq(Ma(I).name)):pn(C.parent.kind===243?C.parent:C,v.All_variables_are_unused));else for(let V of I)a(V,0,pn(V,v._0_is_declared_but_its_value_is_never_read,xq(V.name)))})}function fUt(){var r;for(let a of P2)if(!((r=jn(a))!=null&&r.isReferenced)){let _=IP(a);M.assert(db(_),"Only parameter declaration should be checked here");let h=pn(a.name,v._0_is_an_unused_renaming_of_1_Did_you_intend_to_use_it_as_a_type_annotation,Yo(a.name),Yo(a.propertyName));_.type||ca(h,bu(Ur(_),_.end,1,v.We_can_only_write_a_type_for_0_by_adding_a_type_for_the_entire_parameter_here,Yo(a.propertyName))),_o.add(h)}}function xq(r){switch(r.kind){case 80:return Nn(r);case 207:case 206:return xq(aa(Ma(r.elements),Xa).name);default:return M.assertNever(r)}}function eKe(r){return r.kind===273||r.kind===276||r.kind===274}function pUt(r){return r.kind===273?r:r.kind===274?r.parent:r.parent.parent}function dne(r){if(r.kind===241&&sv(r),U$(r)){let a=Rm;kt(r.statements,ja),Rm=a}else kt(r.statements,ja);r.locals&&jS(r)}function dUt(r){ee>=2||!G$(r)||r.flags&33554432||$c(r.body)||kt(r.parameters,a=>{a.name&&!Hs(a.name)&&a.name.escapedText===qe.escapedName&&dg("noEmit",a,v.Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters)})}function oL(r,a,_){if(a?.escapedText!==_||r.kind===172||r.kind===171||r.kind===174||r.kind===173||r.kind===177||r.kind===178||r.kind===303||r.flags&33554432||(ig(r)||ru(r)||_f(r))&&ib(r))return!1;let h=Bg(r);return!(ns(h)&&$c(h.parent.body))}function mUt(r){Pr(r,a=>iw(a)&4?(r.kind!==80?Qe(Ps(r),v.Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference):Qe(r,v.Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference),!0):!1)}function gUt(r){Pr(r,a=>iw(a)&8?(r.kind!==80?Qe(Ps(r),v.Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference):Qe(r,v.Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference),!0):!1)}function hUt(r,a){if(W>=5&&!(W>=100&&Ur(r).impliedNodeFormat===1)||!a||!oL(r,a,"require")&&!oL(r,a,"exports")||El(r)&&N0(r)!==1)return;let _=z2(r);_.kind===307&&Uf(_)&&dg("noEmit",a,v.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module,Yo(a),Yo(a))}function yUt(r,a){if(!a||ee>=4||!oL(r,a,"Promise")||El(r)&&N0(r)!==1)return;let _=z2(r);_.kind===307&&Uf(_)&&_.flags&4096&&dg("noEmit",a,v.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions,Yo(a),Yo(a))}function vUt(r,a){ee<=8&&(oL(r,a,"WeakMap")||oL(r,a,"WeakSet"))&&qb.push(r)}function SUt(r){let a=eg(r);iw(a)&1048576&&(M.assert(Wu(r)&&He(r.name)&&typeof r.name.escapedText=="string","The target of a WeakMap/WeakSet collision check should be an identifier"),dg("noEmit",r,v.Compiler_reserves_name_0_when_emitting_private_identifier_downlevel,r.name.escapedText))}function bUt(r,a){a&&ee>=2&&ee<=8&&oL(r,a,"Reflect")&&zb.push(r)}function TUt(r){let a=!1;if(eu(r)){for(let _ of r.members)if(iw(_)&2097152){a=!0;break}}else if(ic(r))iw(r)&2097152&&(a=!0);else{let _=eg(r);_&&iw(_)&2097152&&(a=!0)}a&&(M.assert(Wu(r)&&He(r.name),"The target of a Reflect collision check should be an identifier"),dg("noEmit",r,v.Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializers,Yo(r.name),"Reflect"))}function h4(r,a){a&&(hUt(r,a),yUt(r,a),vUt(r,a),bUt(r,a),gi(r)?(v4(a,v.Class_name_cannot_be_0),r.flags&33554432||KUt(a)):bb(r)&&v4(a,v.Enum_name_cannot_be_0))}function EUt(r){if(px(r)&7||db(r))return;let a=jn(r);if(a.flags&1){if(!He(r.name))return M.fail();let _=xr(r,r.name.escapedText,3,void 0,!1);if(_&&_!==a&&_.flags&2&&W2e(_)&7){let h=pb(_.valueDeclaration,261),T=h.parent.kind===243&&h.parent.parent?h.parent.parent:void 0;if(!(T&&(T.kind===241&&Bs(T.parent)||T.kind===268||T.kind===267||T.kind===307))){let I=rs(_);Qe(r,v.Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1,I,I)}}}}function cL(r){return r===tt?Me:r===Fo?Uo:r}function Cq(r){var a;if(Tq(r),Xa(r)||ja(r.type),!r.name)return;if(r.name.kind===167&&(gh(r.name),Hx(r)&&r.initializer&&yl(r.initializer)),Xa(r)){if(r.propertyName&&He(r.name)&&db(r)&&$c(Dp(r).body)){P2.push(r);return}Yp(r.parent)&&r.dotDotDotToken&&ee<5&&gu(r,4),r.propertyName&&r.propertyName.kind===167&&gh(r.propertyName);let T=r.parent.parent,C=r.dotDotDotToken?32:0,I=Mk(T,C),V=r.propertyName||r.name;if(I&&!Hs(V)){let H=d1(V);if(tm(H)){let X=rm(H),_e=ma(I,X);_e&&(oq(_e,void 0,!1),H2e(r,!!T.initializer&&T.initializer.kind===108,!1,I,_e))}}}if(Hs(r.name)&&(r.name.kind===207&&ee<2&&q.downlevelIteration&&gu(r,512),kt(r.name.elements,ja)),r.initializer&&db(r)&&$c(Dp(r).body)){Qe(r,v.A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation);return}if(Hs(r.name)){if(y2e(r))return;let T=Hx(r)&&r.initializer&&r.parent.parent.kind!==249,C=!Pt(r.name.elements,n5(pu));if(T||C){let I=B(r);if(T){let V=yl(r.initializer);ce&&C?xGe(V,r):RS(V,B(r),r,r.initializer)}C&&(Lv(r.name)?y1(65,I,nr,r):ce&&xGe(I,r))}return}let _=jn(r);if(_.flags&2097152&&(ZT(r)||ofe(r))){Sne(r);return}let h=cL(gn(_));if(r===_.valueDeclaration){let T=Hx(r)&&dR(r);if(T&&!(hn(r)&&Ca(T)&&(T.properties.length===0||$1(r.name))&&!!((a=_.exports)!=null&&a.size))&&r.parent.parent.kind!==249){let I=yl(T);RS(I,h,r,T,void 0);let V=px(r)&7;if(V===6){let H=SMt(!0),X=BWe(!0);if(H!==zi&&X!==zi){let _e=fi([H,X,Ke,nr]);I_(I,_e,T,v.The_initializer_of_an_await_using_declaration_must_be_either_an_object_with_a_Symbol_asyncDispose_or_Symbol_dispose_method_or_be_null_or_undefined)}}else if(V===4){let H=BWe(!0);if(H!==zi){let X=fi([H,Ke,nr]);I_(I,X,T,v.The_initializer_of_a_using_declaration_must_be_either_an_object_with_a_Symbol_dispose_method_or_be_null_or_undefined)}}}_.declarations&&_.declarations.length>1&&Pt(_.declarations,C=>C!==r&&rA(C)&&!rKe(C,r))&&Qe(r.name,v.All_declarations_of_0_must_have_identical_modifiers,Yo(r.name))}else{let T=cL(B(r));!ao(h)&&!ao(T)&&!Q0(h,T)&&!(_.flags&67108864)&&tKe(_.valueDeclaration,h,r,T),Hx(r)&&r.initializer&&RS(yl(r.initializer),T,r,r.initializer,void 0),_.valueDeclaration&&!rKe(r,_.valueDeclaration)&&Qe(r.name,v.All_declarations_of_0_must_have_identical_modifiers,Yo(r.name))}r.kind!==172&&r.kind!==171&&(rL(r),(r.kind===260||r.kind===208)&&EUt(r),h4(r,r.name))}function tKe(r,a,_,h){let T=Ps(_),C=_.kind===172||_.kind===171?v.Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2:v.Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2,I=Yo(T),V=Qe(T,C,I,ln(a),ln(h));r&&ca(V,pn(r,v._0_was_also_declared_here,I))}function rKe(r,a){if(r.kind===169&&a.kind===260||r.kind===260&&a.kind===169)return!0;if(oA(r)!==oA(a))return!1;let _=1358;return fA(r,_)===fA(a,_)}function xUt(r){var a,_;(a=Cn)==null||a.push(Cn.Phase.Check,"checkVariableDeclaration",{kind:r.kind,pos:r.pos,end:r.end,path:r.tracingPath}),iqt(r),Cq(r),(_=Cn)==null||_.pop()}function CUt(r){return tqt(r),Cq(r)}function mne(r){let a=f0(r)&7;(a===4||a===6)&&ee<99&&gu(r,16777216),kt(r.declarations,ja)}function AUt(r){!Xy(r)&&!cAe(r.declarationList)&&sqt(r),mne(r.declarationList)}function kUt(r){sv(r),hs(r.expression)}function PUt(r){sv(r);let a=y4(r.expression);LCe(r.expression,a,r.thenStatement),ja(r.thenStatement),r.thenStatement.kind===242&&Qe(r.thenStatement,v.The_body_of_an_if_statement_cannot_be_the_empty_statement),ja(r.elseStatement)}function LCe(r,a,_){if(!ce)return;h(r,_);function h(C,I){for(C=So(C),T(C,I);Pn(C)&&(C.operatorToken.kind===57||C.operatorToken.kind===61);)C=So(C.left),T(C,I)}function T(C,I){let V=jR(C)?So(C.right):C;if(Py(V))return;if(jR(V)){h(V,I);return}let H=V===C?a:y4(V);if(H.flags&1024&&Wn(V)&&(qn(V.expression).resolvedSymbol??St).flags&384){Qe(V,v.This_condition_will_always_return_0,H.value?"true":"false");return}let X=Wn(V)&&kYe(V.expression);if(!Eg(H,4194304)||X)return;let _e=Ys(H,0),we=!!m4(H);if(_e.length===0&&!we)return;let Ne=He(V)?V:Wn(V)?V.name:void 0,pt=Ne&&vm(Ne);if(!pt&&!we)return;pt&&Pn(C.parent)&&DUt(C.parent,pt)||pt&&I&&NUt(C,I,Ne,pt)||(we?Gb(V,!0,v.This_condition_will_always_return_true_since_this_0_is_always_defined,wD(H)):Qe(V,v.This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead))}}function NUt(r,a,_,h){return!!Js(a,function T(C){if(He(C)){let I=vm(C);if(I&&I===h){if(He(r)||He(_)&&Pn(_.parent))return!0;let V=_.parent,H=C.parent;for(;V&&H;){if(He(V)&&He(H)||V.kind===110&&H.kind===110)return vm(V)===vm(H);if(Wn(V)&&Wn(H)){if(vm(V.name)!==vm(H.name))return!1;H=H.expression,V=V.expression}else if(ea(V)&&ea(H))H=H.expression,V=V.expression;else return!1}}}return Js(C,T)})}function DUt(r,a){for(;Pn(r)&&r.operatorToken.kind===56;){if(Js(r.right,function h(T){if(He(T)){let C=vm(T);if(C&&C===a)return!0}return Js(T,h)}))return!0;r=r.parent}return!1}function wUt(r){sv(r),ja(r.statement),y4(r.expression)}function IUt(r){sv(r),y4(r.expression),ja(r.statement)}function FCe(r,a){return r.flags&16384&&Qe(a,v.An_expression_of_type_void_cannot_be_tested_for_truthiness),r}function y4(r,a){return FCe(hs(r,a),r)}function OUt(r){sv(r)||r.initializer&&r.initializer.kind===261&&cAe(r.initializer),r.initializer&&(r.initializer.kind===261?mne(r.initializer):hs(r.initializer)),r.condition&&y4(r.condition),r.incrementor&&hs(r.incrementor),ja(r.statement),r.locals&&jS(r)}function RUt(r){ZKe(r);let a=i9(r);if(r.awaitModifier?a&&Gc(a)?Or(r.awaitModifier,v.for_await_loops_cannot_be_used_inside_a_class_static_block):(Rl(a)&6)===2&&ee<5&&gu(r,16384):q.downlevelIteration&&ee<2&&gu(r,256),r.initializer.kind===261)mne(r.initializer);else{let _=r.initializer,h=Aq(r);if(_.kind===209||_.kind===210)uC(_,h||Oe);else{let T=hs(_);Z7(_,v.The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access,v.The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access),h&&RS(h,T,_,r.expression)}}ja(r.statement),r.locals&&jS(r)}function MUt(r){ZKe(r);let a=G2e(hs(r.expression));if(r.initializer.kind===261){let _=r.initializer.declarations[0];_&&Hs(_.name)&&Qe(_.name,v.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern),mne(r.initializer)}else{let _=r.initializer,h=hs(_);_.kind===209||_.kind===210?Qe(_,v.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern):ga(o7t(a),h)?Z7(_,v.The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access,v.The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access):Qe(_,v.The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any)}(a===Ar||!e_(a,126091264))&&Qe(r.expression,v.The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0,ln(a)),ja(r.statement),r.locals&&jS(r)}function Aq(r){let a=r.awaitModifier?15:13;return y1(a,QD(r.expression),nr,r.expression)}function y1(r,a,_,h){return Ao(a)?a:jCe(r,a,_,h,!0)||Me}function jCe(r,a,_,h,T){let C=(r&2)!==0;if(a===Ar){h&&qCe(h,a,C);return}let I=ee>=2,V=!I&&q.downlevelIteration,H=q.noUncheckedIndexedAccess&&!!(r&128);if(I||V||C){let pt=hne(a,r,I?h:void 0);if(T&&pt){let Tt=r&8?v.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_send_0:r&32?v.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_always_send_0:r&64?v.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring_will_always_send_0:r&16?v.Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_containing_generator_will_always_send_0:void 0;Tt&&I_(_,pt.nextType,h,Tt)}if(pt||I)return H?z7(pt&&pt.yieldType):pt&&pt.yieldType}let X=a,_e=!1;if(r&4){if(X.flags&1048576){let pt=a.types,Tt=Zn(pt,Mt=>!(Mt.flags&402653316));Tt!==pt&&(X=fi(Tt,2))}else X.flags&402653316&&(X=Ar);if(_e=X!==a,_e&&X.flags&131072)return H?z7(Ue):Ue}if(!g1(X)){if(h){let pt=!!(r&4)&&!_e,[Tt,Mt]=Ne(pt,V);Gb(h,Mt&&!!m4(X),Tt,ln(X))}return _e?H?z7(Ue):Ue:void 0}let we=dT(X,Te);if(_e&&we)return we.flags&402653316&&!q.noUncheckedIndexedAccess?Ue:fi(H?[we,Ue,nr]:[we,Ue],2);return r&128?z7(we):we;function Ne(pt,Tt){var Mt;return Tt?pt?[v.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator,!0]:[v.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator,!0]:BCe(r,0,a,void 0)?[v.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher,!1]:LUt((Mt=a.symbol)==null?void 0:Mt.escapedName)?[v.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher,!0]:pt?[v.Type_0_is_not_an_array_type_or_a_string_type,!0]:[v.Type_0_is_not_an_array_type,!0]}}function LUt(r){switch(r){case"Float32Array":case"Float64Array":case"Int16Array":case"Int32Array":case"Int8Array":case"NodeList":case"Uint16Array":case"Uint32Array":case"Uint8Array":case"Uint8ClampedArray":return!0}return!1}function BCe(r,a,_,h){if(Ao(_))return;let T=hne(_,r,h);return T&&T[ZRe(a)]}function v1(r=Ar,a=Ar,_=Rt){if(r.flags&67359327&&a.flags&180227&&_.flags&180227){let h=gm([r,a,_]),T=Vn.get(h);return T||(T={yieldType:r,returnType:a,nextType:_},Vn.set(h,T)),T}return{yieldType:r,returnType:a,nextType:_}}function nKe(r){let a,_,h;for(let T of r)if(!(T===void 0||T===pr)){if(T===Jn)return Jn;a=Bt(a,T.yieldType),_=Bt(_,T.returnType),h=Bt(h,T.nextType)}return a||_||h?v1(a&&fi(a),_&&fi(_),h&&Da(h)):pr}function gne(r,a){return r[a]}function Ky(r,a,_){return r[a]=_}function hne(r,a,_){var h,T;if(Ao(r))return Jn;if(!(r.flags&1048576)){let X=_?{errors:void 0}:void 0,_e=iKe(r,a,_,X);if(_e===pr){if(_){let we=qCe(_,r,!!(a&2));X?.errors&&ca(we,...X.errors)}return}else if((h=X?.errors)!=null&&h.length)for(let we of X.errors)_o.add(we);return _e}let C=a&2?"iterationTypesOfAsyncIterable":"iterationTypesOfIterable",I=gne(r,C);if(I)return I===pr?void 0:I;let V;for(let X of r.types){let _e=_?{errors:void 0}:void 0,we=iKe(X,a,_,_e);if(we===pr){if(_){let Ne=qCe(_,r,!!(a&2));_e?.errors&&ca(Ne,..._e.errors)}Ky(r,C,pr);return}else if((T=_e?.errors)!=null&&T.length)for(let Ne of _e.errors)_o.add(Ne);V=Bt(V,we)}let H=V?nKe(V):pr;return Ky(r,C,H),H===pr?void 0:H}function UCe(r,a){if(r===pr)return pr;if(r===Jn)return Jn;let{yieldType:_,returnType:h,nextType:T}=r;return a&&hxe(!0),v1(_C(_,a)||Me,_C(h,a)||Me,T)}function iKe(r,a,_,h){if(Ao(r))return Jn;let T=!1;if(a&2){let C=VCe(r,Na)||aKe(r,Na);if(C)if(C===pr&&_)T=!0;else return a&8?UCe(C,_):C}if(a&1){let C=VCe(r,gc)||aKe(r,gc);if(C)if(C===pr&&_)T=!0;else if(a&2){if(C!==pr)return C=UCe(C,_),T?C:Ky(r,"iterationTypesOfAsyncIterable",C)}else return C}if(a&2){let C=JCe(r,Na,_,h,T);if(C!==pr)return C}if(a&1){let C=JCe(r,gc,_,h,T);if(C!==pr)return a&2?(C=UCe(C,_),T?C:Ky(r,"iterationTypesOfAsyncIterable",C)):C}return pr}function VCe(r,a){return gne(r,a.iterableCacheKey)}function sKe(r,a){let _=VCe(r,a)||JCe(r,a,void 0,void 0,!1);return _===pr?Ai:_}function aKe(r,a){let _;if(AS(r,_=a.getGlobalIterableType(!1))||AS(r,_=a.getGlobalIterableIteratorType(!1))){let[h]=yc(r),{returnType:T,nextType:C}=sKe(_,a);return Ky(r,a.iterableCacheKey,v1(a.resolveIterationType(h,void 0)||h,a.resolveIterationType(T,void 0)||T,C))}if(AS(r,a.getGlobalGeneratorType(!1))){let[h,T,C]=yc(r);return Ky(r,a.iterableCacheKey,v1(a.resolveIterationType(h,void 0)||h,a.resolveIterationType(T,void 0)||T,C))}}function oKe(r){let a=LWe(!1),_=a&&il(gn(a),Uc(r));return _&&tm(_)?rm(_):`__@${r}`}function JCe(r,a,_,h,T){let C=ma(r,oKe(a.iteratorSymbolName)),I=C&&!(C.flags&16777216)?gn(C):void 0;if(Ao(I))return T?Jn:Ky(r,a.iterableCacheKey,Jn);let V=I?Ys(I,0):void 0;if(!Pt(V))return T?pr:Ky(r,a.iterableCacheKey,pr);let H=Da(Cr(V,ko)),X=cKe(H,a,_,h,T)??pr;return T?X:Ky(r,a.iterableCacheKey,X)}function qCe(r,a,_){let h=_?v.Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator:v.Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator,T=!!m4(a)||!_&&f8(r.parent)&&r.parent.expression===r&&Yte(!1)!==Fa&&ga(a,Yte(!1));return Gb(r,T,h,ln(a))}function FUt(r,a,_,h){return cKe(r,a,_,h,!1)}function cKe(r,a,_,h,T){if(Ao(r))return Jn;let C=lKe(r,a)||jUt(r,a);return C===pr&&_&&(C=void 0,T=!0),C??(C=_Ke(r,a,_,h,T)),C===pr?void 0:C}function lKe(r,a){return gne(r,a.iteratorCacheKey)}function jUt(r,a){let _=a.getGlobalIterableIteratorType(!1);if(AS(r,_)){let[h]=yc(r),T=lKe(_,a)||_Ke(_,a,void 0,void 0,!1),{returnType:C,nextType:I}=T===pr?Ai:T;return Ky(r,a.iteratorCacheKey,v1(h,C,I))}if(AS(r,a.getGlobalIteratorType(!1))||AS(r,a.getGlobalGeneratorType(!1))){let[h,T,C]=yc(r);return Ky(r,a.iteratorCacheKey,v1(h,T,C))}}function uKe(r,a){let _=il(r,"done")||It;return ga(a===0?It:Ht,_)}function BUt(r){return uKe(r,0)}function UUt(r){return uKe(r,1)}function VUt(r){if(Ao(r))return Jn;let a=gne(r,"iterationTypesOfIteratorResult");if(a)return a;if(AS(r,yMt(!1))){let I=yc(r)[0];return Ky(r,"iterationTypesOfIteratorResult",v1(I,void 0,void 0))}if(AS(r,vMt(!1))){let I=yc(r)[0];return Ky(r,"iterationTypesOfIteratorResult",v1(void 0,I,void 0))}let _=Fl(r,BUt),h=_!==Ar?il(_,"value"):void 0,T=Fl(r,UUt),C=T!==Ar?il(T,"value"):void 0;return!h&&!C?Ky(r,"iterationTypesOfIteratorResult",pr):Ky(r,"iterationTypesOfIteratorResult",v1(h,C||dn,void 0))}function zCe(r,a,_,h,T){var C,I,V,H;let X=ma(r,_);if(!X&&_!=="next")return;let _e=X&&!(_==="next"&&X.flags&16777216)?_==="next"?gn(X):hm(gn(X),2097152):void 0;if(Ao(_e))return _==="next"?Jn:Ri;let we=_e?Ys(_e,0):ve;if(we.length===0){if(h){let Dr=_==="next"?a.mustHaveANextMethodDiagnostic:a.mustBeAMethodDiagnostic;T?(T.errors??(T.errors=[]),T.errors.push(pn(h,Dr,_))):Qe(h,Dr,_)}return _==="next"?pr:void 0}if(_e?.symbol&&we.length===1){let Dr=a.getGlobalGeneratorType(!1),zr=a.getGlobalIteratorType(!1),Qr=((I=(C=Dr.symbol)==null?void 0:C.members)==null?void 0:I.get(_))===_e.symbol,$n=!Qr&&((H=(V=zr.symbol)==null?void 0:V.members)==null?void 0:H.get(_))===_e.symbol;if(Qr||$n){let ii=Qr?Dr:zr,{mapper:si}=_e;return v1(m1(ii.typeParameters[0],si),m1(ii.typeParameters[1],si),_==="next"?m1(ii.typeParameters[2],si):void 0)}}let Ne,pt;for(let Dr of we)_!=="throw"&&Pt(Dr.parameters)&&(Ne=Bt(Ne,xg(Dr,0))),pt=Bt(pt,ko(Dr));let Tt,Mt;if(_!=="throw"){let Dr=Ne?fi(Ne):Rt;if(_==="next")Mt=Dr;else if(_==="return"){let zr=a.resolveIterationType(Dr,h)||Me;Tt=Bt(Tt,zr)}}let mr,br=pt?Da(pt):Ar,en=a.resolveIterationType(br,h)||Me,Fn=VUt(en);return Fn===pr?(h&&(T?(T.errors??(T.errors=[]),T.errors.push(pn(h,a.mustHaveAValueDiagnostic,_))):Qe(h,a.mustHaveAValueDiagnostic,_)),mr=Me,Tt=Bt(Tt,Me)):(mr=Fn.yieldType,Tt=Bt(Tt,Fn.returnType)),v1(mr,fi(Tt),Mt)}function _Ke(r,a,_,h,T){let C=nKe([zCe(r,a,"next",_,h),zCe(r,a,"return",_,h),zCe(r,a,"throw",_,h)]);return T?C:Ky(r,a.iteratorCacheKey,C)}function _x(r,a,_){if(Ao(a))return;let h=WCe(a,_);return h&&h[ZRe(r)]}function WCe(r,a){if(Ao(r))return Jn;let _=a?2:1,h=a?Na:gc;return hne(r,_,void 0)||FUt(r,h,void 0,void 0)}function JUt(r){sv(r)||eqt(r)}function kq(r,a){let _=!!(a&1),h=!!(a&2);if(_){let T=_x(1,r,h);return T?h?h1(g4(T)):T:Oe}return h?h1(r)||Oe:r}function fKe(r,a){let _=kq(a,Rl(r));return!!(_&&(dl(_,16384)||_.flags&32769))}function qUt(r){if(sv(r))return;let a=i9(r);if(a&&Gc(a)){ju(r,v.A_return_statement_cannot_be_used_inside_a_class_static_block);return}if(!a){ju(r,v.A_return_statement_can_only_be_used_within_a_function_body);return}let _=md(a),h=ko(_),T=Rl(a);if(ce||r.expression||h.flags&131072){let C=r.expression?yl(r.expression):nr;if(a.kind===178)r.expression&&Qe(r,v.Setters_cannot_return_a_value);else if(a.kind===176)r.expression&&!RS(C,h,r,r.expression)&&Qe(r,v.Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class);else if(VD(a)){let I=kq(h,T)??h,V=T&2?iL(C,!1,r,v.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member):C;I&&RS(V,I,r,r.expression)}}else a.kind!==176&&q.noImplicitReturns&&!fKe(a,h)&&Qe(r,v.Not_all_code_paths_return_a_value)}function zUt(r){sv(r)||r.flags&65536&&ju(r,v.with_statements_are_not_allowed_in_an_async_function_block),hs(r.expression);let a=Ur(r);if(!BS(a)){let _=Bh(a,r.pos).start,h=r.statement.pos;fx(a,_,h-_,v.The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any)}}function WUt(r){sv(r);let a,_=!1,h=hs(r.expression);kt(r.caseBlock.clauses,T=>{T.kind===297&&!_&&(a===void 0?a=T:(Or(T,v.A_default_clause_cannot_appear_more_than_once_in_a_switch_statement),_=!0)),T.kind===296&&n(C(T)),kt(T.statements,ja),q.noFallthroughCasesInSwitch&&T.fallthroughFlowNode&&GJ(T.fallthroughFlowNode)&&Qe(T,v.Fallthrough_case_in_switch);function C(I){return()=>{let V=hs(I.expression);CCe(h,V)||O$e(V,h,I.expression,void 0)}}}),r.caseBlock.locals&&jS(r.caseBlock)}function $Ut(r){sv(r)||Pr(r.parent,a=>Bs(a)?"quit":a.kind===256&&a.label.escapedText===r.label.escapedText?(Or(r.label,v.Duplicate_label_0,Hc(r.label)),!0):!1),ja(r.statement)}function HUt(r){sv(r)||He(r.expression)&&!r.expression.escapedText&&mqt(r,v.Line_break_not_permitted_here),r.expression&&hs(r.expression)}function GUt(r){sv(r),dne(r.tryBlock);let a=r.catchClause;if(a){if(a.variableDeclaration){let _=a.variableDeclaration;Cq(_);let h=Vl(_);if(h){let T=Wi(h);T&&!(T.flags&3)&&ju(h,v.Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified)}else if(_.initializer)ju(_.initializer,v.Catch_clause_variable_cannot_have_an_initializer);else{let T=a.block.locals;T&&d0(a.locals,C=>{let I=T.get(C);I?.valueDeclaration&&I.flags&2&&Or(I.valueDeclaration,v.Cannot_redeclare_identifier_0_in_catch_clause,Qi(C))})}}dne(a.block)}r.finallyBlock&&dne(r.finallyBlock)}function yne(r,a,_){let h=X_(r);if(h.length===0)return;for(let C of PS(r))_&&C.flags&4194304||pKe(r,C,qk(C,8576,!0),CS(C));let T=a.valueDeclaration;if(T&&gi(T)){for(let C of T.members)if(!oa(C)&&!BD(C)){let I=jn(C);pKe(r,I,t_(C.name.expression),CS(I))}}if(h.length>1)for(let C of h)YUt(r,C)}function pKe(r,a,_,h){let T=a.valueDeclaration,C=Ps(T);if(C&&Zi(C))return;let I=ZEe(r,_),V=Kn(r)&2?Pc(r.symbol,264):void 0,H=T&&T.kind===226||C&&C.kind===167?T:void 0,X=Qu(a)===r.symbol?T:void 0;for(let _e of I){let we=_e.declaration&&Qu(jn(_e.declaration))===r.symbol?_e.declaration:void 0,Ne=X||we||(V&&!Pt(_i(r),pt=>!!ZE(pt,a.escapedName)&&!!dT(pt,_e.keyType))?V:void 0);if(Ne&&!ga(h,_e.type)){let pt=w2(Ne,v.Property_0_of_type_1_is_not_assignable_to_2_index_type_3,rs(a),ln(h),ln(_e.keyType),ln(_e.type));H&&Ne!==H&&ca(pt,pn(H,v._0_is_declared_here,rs(a))),_o.add(pt)}}}function YUt(r,a){let _=a.declaration,h=ZEe(r,a.keyType),T=Kn(r)&2?Pc(r.symbol,264):void 0,C=_&&Qu(jn(_))===r.symbol?_:void 0;for(let I of h){if(I===a)continue;let V=I.declaration&&Qu(jn(I.declaration))===r.symbol?I.declaration:void 0,H=C||V||(T&&!Pt(_i(r),X=>!!Gy(X,a.keyType)&&!!dT(X,I.keyType))?T:void 0);H&&!ga(a.type,I.type)&&Qe(H,v._0_index_type_1_is_not_assignable_to_2_index_type_3,ln(a.keyType),ln(a.type),ln(I.keyType),ln(I.type))}}function v4(r,a){switch(r.escapedText){case"any":case"unknown":case"never":case"number":case"bigint":case"boolean":case"string":case"symbol":case"void":case"object":case"undefined":Qe(r,a,r.escapedText)}}function KUt(r){ee>=1&&r.escapedText==="Object"&&(W<5||Ur(r).impliedNodeFormat===1)&&Qe(r,v.Class_name_cannot_be_Object_when_targeting_ES5_with_module_0,y3[W])}function XUt(r){let a=Zn(nb(r),Pd);if(!wt(a))return;let _=hn(r),h=new Set,T=new Set;if(kt(r.parameters,({name:I},V)=>{He(I)&&h.add(I.escapedText),Hs(I)&&T.add(V)}),nxe(r)){let I=a.length-1,V=a[I];_&&V&&He(V.name)&&V.typeExpression&&V.typeExpression.type&&!h.has(V.name.escapedText)&&!T.has(I)&&!Jd(Wi(V.typeExpression.type))&&Qe(V.name,v.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type,Nn(V.name))}else kt(a,({name:I,isNameFirst:V},H)=>{T.has(H)||He(I)&&h.has(I.escapedText)||(cf(I)?_&&Qe(I,v.Qualified_name_0_is_not_allowed_without_a_leading_param_object_1,op(I),op(I.left)):V||Cu(_,I,v.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name,Nn(I)))})}function Pq(r){let a=!1;if(r)for(let h=0;h<r.length;h++){let T=r[h];OYe(T),n(_(T,h))}function _(h,T){return()=>{h.default?(a=!0,QUt(h.default,r,T)):a&&Qe(h,v.Required_type_parameters_may_not_follow_optional_type_parameters);for(let C=0;C<T;C++)r[C].symbol===h.symbol&&Qe(h.name,v.Duplicate_identifier_0,Yo(h.name))}}}function QUt(r,a,_){h(r);function h(T){if(T.kind===183){let C=bJ(T);if(C.flags&262144)for(let I=_;I<a.length;I++)C.symbol===jn(a[I])&&Qe(T,v.Type_parameter_defaults_can_only_reference_previously_declared_type_parameters)}Js(T,h)}}function dKe(r){if(r.declarations&&r.declarations.length===1)return;let a=as(r);if(!a.typeParametersChecked){a.typeParametersChecked=!0;let _=aVt(r);if(!_||_.length<=1)return;let h=ac(r);if(!mKe(_,h.localTypeParameters,j1)){let T=rs(r);for(let C of _)Qe(C.name,v.All_declarations_of_0_must_have_identical_type_parameters,T)}}}function mKe(r,a,_){let h=wt(a),T=ph(a);for(let C of r){let I=_(C),V=I.length;if(V<T||V>h)return!1;for(let H=0;H<V;H++){let X=I[H],_e=a[H];if(X.name.escapedText!==_e.symbol.escapedName)return!1;let we=RP(X),Ne=we&&Wi(we),pt=mf(_e);if(Ne&&pt&&!Q0(Ne,pt))return!1;let Tt=X.default&&Wi(X.default),Mt=H2(_e);if(Tt&&Mt&&!Q0(Tt,Mt))return!1}}return!0}function gKe(r){let a=!pe&&ee<99&&Cv(!1,r),_=ee<9||ee<99,h=!re;if(a||_)for(let T of r.members){if(a&&yH(!1,T,r))return xo(F1(r))??r;if(_){if(Gc(T))return T;if(oa(T)&&(j_(T)||h&&B8(T)))return T}}}function ZUt(r){if(r.name)return;let a=_me(r);if(!MH(a))return;let _=!pe&&ee<99,h;_&&Cv(!1,r)?h=xo(F1(r))??r:h=gKe(r),h&&(gu(h,4194304),(ql(a)||Ns(a)||Xa(a))&&za(a.name)&&gu(h,8388608))}function eVt(r){return hKe(r),eP(r),ZUt(r),gn(jn(r))}function tVt(r){kt(r.members,ja),jS(r)}function rVt(r){let a=Ln(r.modifiers,fu);pe&&a&&Pt(r.members,_=>Jl(_)&&j_(_))&&Or(a,v.Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator),!r.name&&!li(r,2048)&&ju(r,v.A_class_declaration_without_the_default_modifier_must_have_a_name),hKe(r),kt(r.members,ja),jS(r)}function hKe(r){BJt(r),Tq(r),h4(r,r.name),Pq(j1(r)),rL(r);let a=jn(r),_=ac(a),h=bp(_),T=gn(a);dKe(a),_ne(a),gBt(r),!!(r.flags&33554432)||hBt(r);let I=Fg(r);if(I){kt(I.typeArguments,ja),ee<2&&gu(I.parent,1);let X=nE(r);X&&X!==I&&hs(X.expression);let _e=_i(_);_e.length&&n(()=>{let we=_e[0],Ne=Lr(_),pt=K_(Ne);if(iVt(pt,I),ja(I.expression),Pt(I.typeArguments)){kt(I.typeArguments,ja);for(let Mt of Mte(pt,I.typeArguments,I))if(!UYe(I,Mt.typeParameters))break}let Tt=bp(we,_.thisType);if(I_(h,Tt,void 0)?I_(T,k$e(pt),r.name||r,v.Class_static_side_0_incorrectly_extends_base_class_static_side_1):SKe(r,h,Tt,v.Class_0_incorrectly_extends_base_class_1),Ne.flags&8650752&&(uJ(T)?Ys(Ne,1).some(mr=>mr.flags&4)&&!li(r,64)&&Qe(r.name||r,v.A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_be_declared_abstract):Qe(r.name||r,v.A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any)),!(pt.symbol&&pt.symbol.flags&32)&&!(Ne.flags&8650752)){let Mt=pT(pt,I.typeArguments,I);kt(Mt,mr=>!vh(mr.declaration)&&!Q0(ko(mr),we))&&Qe(I.expression,v.Base_constructors_must_all_have_the_same_return_type)}oVt(_,we)})}nVt(r,_,h,T);let V=eN(r);if(V)for(let X of V)(!nc(X.expression)||S_(X.expression))&&Qe(X.expression,v.A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments),wCe(X),n(H(X));n(()=>{yne(_,a),yne(T,a,!0),NCe(r),uVt(r)});function H(X){return()=>{let _e=bg(Wi(X));if(!ao(_e))if(ku(_e)){let we=_e.symbol&&_e.symbol.flags&32?v.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass:v.Class_0_incorrectly_implements_interface_1,Ne=bp(_e,_.thisType);I_(h,Ne,void 0)||SKe(r,h,Ne,we)}else Qe(X,v.A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members)}}}function nVt(r,a,_,h){let C=Fg(r)&&_i(a),I=C?.length?bp(Ma(C),a.thisType):void 0,V=Lr(a);for(let H of r.members)KH(H)||(Vc(H)&&kt(H.parameters,X=>{ap(X,H)&&yKe(r,h,V,I,a,_,X,!0)}),yKe(r,h,V,I,a,_,H,!1))}function yKe(r,a,_,h,T,C,I,V,H=!0){let X=I.name&&vm(I.name)||vm(I);return X?vKe(r,a,_,h,T,C,I9(I),oE(I),oa(I),V,Qc(X),H?I:void 0):0}function vKe(r,a,_,h,T,C,I,V,H,X,_e,we){let Ne=hn(r),pt=!!(r.flags&33554432);if(h&&(I||q.noImplicitOverride)){let Tt=Uc(_e),Mt=H?a:C,mr=H?_:h,br=ma(Mt,Tt),en=ma(mr,Tt),Fn=ln(h);if(br&&!en&&I){if(we){let Dr=DGe(_e,mr);Dr?Qe(we,Ne?v.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1:v.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1,Fn,rs(Dr)):Qe(we,Ne?v.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0:v.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0,Fn)}return 2}else if(br&&en?.declarations&&q.noImplicitOverride&&!pt){let Dr=Pt(en.declarations,oE);if(I)return 0;if(Dr){if(V&&Dr)return we&&Qe(we,v.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0,Fn),1}else{if(we){let zr=X?Ne?v.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0:v.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0:Ne?v.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0:v.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0;Qe(we,zr,Fn)}return 1}}}else if(I){if(we){let Tt=ln(T);Qe(we,Ne?v.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class:v.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class,Tt)}return 2}return 0}function SKe(r,a,_,h){let T=!1;for(let C of r.members){if(oa(C))continue;let I=C.name&&vm(C.name)||vm(C);if(I){let V=ma(a,I.escapedName),H=ma(_,I.escapedName);if(V&&H){let X=()=>js(void 0,v.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2,rs(I),ln(a),ln(_));I_(gn(V),gn(H),C.name||C,void 0,X)||(T=!0)}}}T||I_(a,_,r.name||r,h)}function iVt(r,a){let _=Ys(r,1);if(_.length){let h=_[0].declaration;if(h&&up(h,2)){let T=S0(r.symbol);XCe(a,T)||Qe(a,v.Cannot_extend_a_class_0_Class_constructor_is_marked_as_private,uh(r.symbol))}}}function sVt(r,a,_){if(!a.name)return 0;let h=jn(r),T=ac(h),C=bp(T),I=gn(h),H=Fg(r)&&_i(T),X=H?.length?bp(Ma(H),T.thisType):void 0,_e=Lr(T),we=a.parent?I9(a):li(a,16);return vKe(r,I,_e,X,T,C,we,oE(a),oa(a),!1,Qc(_))}function nw(r){return ll(r)&1?r.links.target:r}function aVt(r){return Zn(r.declarations,a=>a.kind===263||a.kind===264)}function oVt(r,a){var _,h,T,C,I;let V=bo(a),H=new Map;e:for(let X of V){let _e=nw(X);if(_e.flags&4194304)continue;let we=ZE(r,_e.escapedName);if(!we)continue;let Ne=nw(we),pt=xd(_e);if(M.assert(!!Ne,"derived should point to something, even if it is the base class' declaration."),Ne===_e){let Tt=S0(r.symbol);if(pt&64&&(!Tt||!li(Tt,64))){for(let Fn of _i(r)){if(Fn===a)continue;let Dr=ZE(Fn,_e.escapedName),zr=Dr&&nw(Dr);if(zr&&zr!==_e)continue e}let Mt=ln(a),mr=ln(r),br=rs(X),en=Bt((_=H.get(Tt))==null?void 0:_.missedProperties,br);H.set(Tt,{baseTypeName:Mt,typeName:mr,missedProperties:en})}}else{let Tt=xd(Ne);if(pt&2||Tt&2)continue;let Mt,mr=_e.flags&98308,br=Ne.flags&98308;if(mr&&br){if((ll(_e)&6?(h=_e.declarations)!=null&&h.some(Dr=>bKe(Dr,pt)):(T=_e.declarations)!=null&&T.every(Dr=>bKe(Dr,pt)))||ll(_e)&262144||Ne.valueDeclaration&&Pn(Ne.valueDeclaration))continue;let en=mr!==4&&br===4;if(en||mr===4&&br!==4){let Dr=en?v._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property:v._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor;Qe(Ps(Ne.valueDeclaration)||Ne.valueDeclaration,Dr,rs(_e),ln(a),ln(r))}else if(K){let Dr=(C=Ne.declarations)==null?void 0:C.find(zr=>zr.kind===172&&!zr.initializer);if(Dr&&!(Ne.flags&33554432)&&!(pt&64)&&!(Tt&64)&&!((I=Ne.declarations)!=null&&I.some(zr=>!!(zr.flags&33554432)))){let zr=e8(S0(r.symbol)),Qr=Dr.name;if(Dr.exclamationToken||!zr||!He(Qr)||!ce||!EKe(Qr,r,zr)){let $n=v.Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration;Qe(Ps(Ne.valueDeclaration)||Ne.valueDeclaration,$n,rs(_e),ln(a))}}}continue}else if($2e(_e)){if($2e(Ne)||Ne.flags&4)continue;M.assert(!!(Ne.flags&98304)),Mt=v.Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor}else _e.flags&98304?Mt=v.Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function:Mt=v.Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function;Qe(Ps(Ne.valueDeclaration)||Ne.valueDeclaration,Mt,ln(a),rs(_e),ln(r))}}for(let[X,_e]of H)if(wt(_e.missedProperties)===1)eu(X)?Qe(X,v.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1,Ma(_e.missedProperties),_e.baseTypeName):Qe(X,v.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2,_e.typeName,Ma(_e.missedProperties),_e.baseTypeName);else if(wt(_e.missedProperties)>5){let we=Cr(_e.missedProperties.slice(0,4),pt=>`'${pt}'`).join(", "),Ne=wt(_e.missedProperties)-4;eu(X)?Qe(X,v.Non_abstract_class_expression_is_missing_implementations_for_the_following_members_of_0_Colon_1_and_2_more,_e.baseTypeName,we,Ne):Qe(X,v.Non_abstract_class_0_is_missing_implementations_for_the_following_members_of_1_Colon_2_and_3_more,_e.typeName,_e.baseTypeName,we,Ne)}else{let we=Cr(_e.missedProperties,Ne=>`'${Ne}'`).join(", ");eu(X)?Qe(X,v.Non_abstract_class_expression_is_missing_implementations_for_the_following_members_of_0_Colon_1,_e.baseTypeName,we):Qe(X,v.Non_abstract_class_0_is_missing_implementations_for_the_following_members_of_1_Colon_2,_e.typeName,_e.baseTypeName,we)}}function bKe(r,a){return a&64&&(!Ns(r)||!r.initializer)||Yu(r.parent)}function cVt(r,a,_){if(!wt(a))return _;let h=new Map;kt(_,T=>{h.set(T.escapedName,T)});for(let T of a){let C=bo(bp(T,r.thisType));for(let I of C){let V=h.get(I.escapedName);V&&I.parent===V.parent&&h.delete(I.escapedName)}}return Is(h.values())}function lVt(r,a){let _=_i(r);if(_.length<2)return!0;let h=new Map;kt(jEe(r).declaredProperties,C=>{h.set(C.escapedName,{prop:C,containingType:r})});let T=!0;for(let C of _){let I=bo(bp(C,r.thisType));for(let V of I){let H=h.get(V.escapedName);if(!H)h.set(V.escapedName,{prop:V,containingType:C});else if(H.containingType!==r&&!dLt(H.prop,V)){T=!1;let _e=ln(H.containingType),we=ln(C),Ne=js(void 0,v.Named_property_0_of_types_1_and_2_are_not_identical,rs(V),_e,we);Ne=js(Ne,v.Interface_0_cannot_simultaneously_extend_types_1_and_2,ln(r),_e,we),_o.add(ky(Ur(a),a,Ne))}}}return T}function uVt(r){if(!ce||!me||r.flags&33554432)return;let a=e8(r);for(let _ of r.members)if(!(U_(_)&128)&&!oa(_)&&TKe(_)){let h=_.name;if(He(h)||Zi(h)||za(h)){let T=gn(jn(_));T.flags&3||HD(T)||(!a||!EKe(h,T,a))&&Qe(_.name,v.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor,Yo(h))}}}function TKe(r){return r.kind===172&&!oE(r)&&!r.exclamationToken&&!r.initializer}function _Vt(r,a,_,h,T){for(let C of _)if(C.pos>=h&&C.pos<=T){let I=U.createPropertyAccessExpression(U.createThis(),r);lo(I.expression,I),lo(I,C),I.flowNode=C.returnFlowNode;let V=iv(I,a,LS(a));if(!HD(V))return!0}return!1}function EKe(r,a,_){let h=za(r)?U.createElementAccessExpression(U.createThis(),r.expression):U.createPropertyAccessExpression(U.createThis(),r);lo(h.expression,h),lo(h,_),h.flowNode=_.returnFlowNode;let T=iv(h,a,LS(a));return!HD(T)}function fVt(r){Xy(r)||$Jt(r),Pq(r.typeParameters),n(()=>{v4(r.name,v.Interface_name_cannot_be_0),rL(r);let a=jn(r);dKe(a);let _=Pc(a,264);if(r===_){let h=ac(a),T=bp(h);if(lVt(h,r.name)){for(let C of _i(h))I_(T,bp(C,h.thisType),r.name,v.Interface_0_incorrectly_extends_interface_1);yne(h,a)}}LYe(r)}),kt(UI(r),a=>{(!nc(a.expression)||S_(a.expression))&&Qe(a.expression,v.An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments),wCe(a)}),kt(r.members,ja),n(()=>{NCe(r),jS(r)})}function pVt(r){Xy(r),v4(r.name,v.Type_alias_name_cannot_be_0),rL(r),Pq(r.typeParameters),r.type.kind===141?(!gK.has(r.name.escapedText)||wt(r.typeParameters)!==1)&&Qe(r.type,v.The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types):(ja(r.type),jS(r))}function xKe(r){let a=qn(r);if(!(a.flags&1024)){a.flags|=1024;let _=0,h;for(let T of r.members){let C=dVt(T,_,h);qn(T).enumMemberValue=C,_=typeof C.value=="number"?C.value+1:void 0,h=T}}}function dVt(r,a,_){if(Q3(r.name))Qe(r.name,v.Computed_property_names_are_not_allowed_in_enums);else{let h=tA(r.name);Ry(h)&&!dO(h)&&Qe(r.name,v.An_enum_member_cannot_have_a_numeric_name)}if(r.initializer)return mVt(r);if(r.parent.flags&33554432&&!KT(r.parent))return _u(void 0);if(a===void 0)return Qe(r.name,v.Enum_member_must_have_initializer),_u(void 0);if(Cd(q)&&_?.initializer){let h=fC(_);typeof h.value=="number"&&!h.resolvedOtherFiles||Qe(r.name,v.Enum_member_following_a_non_literal_numeric_member_must_have_an_initializer_when_isolatedModules_is_enabled)}return _u(a)}function mVt(r){let a=KT(r.parent),_=r.initializer,h=ke(_,r);return h.value!==void 0?a&&typeof h.value=="number"&&!isFinite(h.value)?Qe(_,isNaN(h.value)?v.const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN:v.const_enum_member_initializer_was_evaluated_to_a_non_finite_value):Cd(q)&&typeof h.value=="string"&&!h.isSyntacticallyString&&Qe(_,v._0_has_a_string_type_but_must_have_syntactically_recognizable_string_syntax_when_isolatedModules_is_enabled,`${Nn(r.parent.name)}.${tA(r.name)}`):a?Qe(_,v.const_enum_member_initializers_must_be_constant_expressions):r.parent.flags&33554432?Qe(_,v.In_ambient_enum_declarations_member_initializer_must_be_constant_expression):I_(hs(_),Te,_,v.Type_0_is_not_assignable_to_type_1_as_required_for_computed_enum_member_values),h}function CKe(r,a){let _=nl(r,111551,!0);if(!_)return _u(void 0);if(r.kind===80){let h=r;if(dO(h.escapedText)&&_===WD(h.escapedText,111551,void 0))return _u(+h.escapedText,!1)}if(_.flags&8)return a?AKe(r,_,a):fC(_.valueDeclaration);if(Xk(_)){let h=_.valueDeclaration;if(h&&Ei(h)&&!h.type&&h.initializer&&(!a||h!==a&&Fm(h,a))){let T=ke(h.initializer,h);return a&&Ur(a)!==Ur(h)?_u(T.value,!1,!0,!0):_u(T.value,T.isSyntacticallyString,T.resolvedOtherFiles,!0)}}return _u(void 0)}function gVt(r,a){let _=r.expression;if(nc(_)&&No(r.argumentExpression)){let h=nl(_,111551,!0);if(h&&h.flags&384){let T=Uc(r.argumentExpression.text),C=h.exports.get(T);if(C)return M.assert(Ur(C.valueDeclaration)===Ur(h.valueDeclaration)),a?AKe(r,C,a):fC(C.valueDeclaration)}}return _u(void 0)}function AKe(r,a,_){let h=a.valueDeclaration;if(!h||h===_)return Qe(r,v.Property_0_is_used_before_being_assigned,rs(a)),_u(void 0);if(!Fm(h,_))return Qe(r,v.A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums),_u(0);let T=fC(h);return _.parent!==h.parent?_u(T.value,T.isSyntacticallyString,T.resolvedOtherFiles,!0):T}function hVt(r){n(()=>yVt(r))}function yVt(r){Xy(r),h4(r,r.name),rL(r),r.members.forEach(vVt),xKe(r);let a=jn(r),_=Pc(a,r.kind);if(r===_){if(a.declarations&&a.declarations.length>1){let T=KT(r);kt(a.declarations,C=>{bb(C)&&KT(C)!==T&&Qe(Ps(C),v.Enum_declarations_must_all_be_const_or_non_const)})}let h=!1;kt(a.declarations,T=>{if(T.kind!==266)return!1;let C=T;if(!C.members.length)return!1;let I=C.members[0];I.initializer||(h?Qe(I.name,v.In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element):h=!0)})}}function vVt(r){Zi(r.name)&&Qe(r,v.An_enum_member_cannot_be_named_with_a_private_identifier),r.initializer&&hs(r.initializer)}function SVt(r){let a=r.declarations;if(a){for(let _ of a)if((_.kind===263||_.kind===262&&Yd(_.body))&&!(_.flags&33554432))return _}}function bVt(r,a){let _=eg(r),h=eg(a);return Tv(_)?Tv(h):Tv(h)?!1:_===h}function TVt(r){r.body&&(ja(r.body),Rg(r)||jS(r)),n(a);function a(){var _,h;let T=Rg(r),C=r.flags&33554432;T&&!C&&Qe(r.name,v.Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context);let I=B_(r),V=I?v.An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file:v.A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module;if(Nq(r,V))return;Xy(r)||!C&&r.name.kind===11&&Or(r.name,v.Only_ambient_modules_can_use_quoted_names),He(r.name)&&h4(r,r.name),rL(r);let H=jn(r);if(H.flags&512&&!C&&hK(r,lE(q))){if(Cd(q)&&!Ur(r).externalModuleIndicator&&Qe(r.name,v.Namespaces_are_not_allowed_in_global_script_files_when_0_is_enabled_If_this_file_is_not_intended_to_be_a_global_script_set_moduleDetection_to_force_or_add_an_empty_export_statement,Ie),((_=H.declarations)==null?void 0:_.length)>1){let X=SVt(H);X&&(Ur(r)!==Ur(X)?Qe(r.name,v.A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged):r.pos<X.pos&&Qe(r.name,v.A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged));let _e=Pc(H,263);_e&&bVt(r,_e)&&(qn(r).flags|=2048)}if(q.verbatimModuleSyntax&&r.parent.kind===307&&(W===1||r.parent.impliedNodeFormat===1)){let X=(h=r.modifiers)==null?void 0:h.find(_e=>_e.kind===95);X&&Qe(X,v.A_top_level_export_modifier_cannot_be_used_on_value_declarations_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled)}}if(I)if(YT(r)){if((T||jn(r).flags&33554432)&&r.body)for(let _e of r.body.statements)$Ce(_e,T)}else Tv(r.parent)?T?Qe(r.name,v.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations):vu(Qd(r.name))&&Qe(r.name,v.Ambient_module_declaration_cannot_specify_relative_module_name):T?Qe(r.name,v.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations):Qe(r.name,v.Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces)}}function $Ce(r,a){switch(r.kind){case 243:for(let h of r.declarationList.declarations)$Ce(h,a);break;case 277:case 278:ju(r,v.Exports_and_export_assignments_are_not_permitted_in_module_augmentations);break;case 271:case 272:ju(r,v.Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module);break;case 208:case 260:let _=r.name;if(Hs(_)){for(let h of _.elements)$Ce(h,a);break}case 263:case 266:case 262:case 264:case 267:case 265:if(a)return;break}}function EVt(r){switch(r.kind){case 80:return r;case 166:do r=r.left;while(r.kind!==80);return r;case 211:do{if(Py(r.expression)&&!Zi(r.name))return r.name;r=r.expression}while(r.kind!==80);return r}}function vne(r){let a=sA(r);if(!a||$c(a))return!1;if(!La(a))return Qe(a,v.String_literal_expected),!1;let _=r.parent.kind===268&&B_(r.parent.parent);if(r.parent.kind!==307&&!_)return Qe(a,r.kind===278?v.Export_declarations_are_not_permitted_in_a_namespace:v.Import_declarations_in_a_namespace_cannot_reference_a_module),!1;if(_&&vu(a.text)&&!d7(r))return Qe(r,v.Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name),!1;if(!ru(r)&&r.attributes){let h=r.attributes.token===118?v.Import_attribute_values_must_be_string_literal_expressions:v.Import_assertion_values_must_be_string_literal_expressions,T=!1;for(let C of r.attributes.elements)La(C.value)||(T=!0,Qe(C.value,h));return!T}return!0}function Sne(r){var a,_,h,T;let C=jn(r),I=Au(C);if(I!==St){if(C=ro(C.exportSymbol||C),hn(r)&&!(I.flags&111551)&&!ib(r)){let X=GC(r)?r.propertyName||r.name:Wu(r)?r.name:r;if(M.assert(r.kind!==280),r.kind===281){let _e=Qe(X,v.Types_cannot_appear_in_export_declarations_in_JavaScript_files),we=(_=(a=Ur(r).symbol)==null?void 0:a.exports)==null?void 0:_.get((r.propertyName||r.name).escapedText);if(we===I){let Ne=(h=we.declarations)==null?void 0:h.find(FP);Ne&&ca(_e,pn(Ne,v._0_is_automatically_exported_here,Qi(we.escapedName)))}}else{M.assert(r.kind!==260);let _e=Pr(r,Jp(Yc,ru)),we=(_e&&((T=MI(_e))==null?void 0:T.text))??"...",Ne=Qi(He(X)?X.escapedText:C.escapedName);Qe(X,v._0_is_a_type_and_cannot_be_imported_in_JavaScript_files_Use_1_in_a_JSDoc_type_annotation,Ne,`import("${we}").${Ne}`)}return}let V=Gf(I),H=(C.flags&1160127?111551:0)|(C.flags&788968?788968:0)|(C.flags&1920?1920:0);if(V&H){let X=r.kind===281?v.Export_declaration_conflicts_with_exported_declaration_of_0:v.Import_declaration_conflicts_with_local_declaration_of_0;Qe(r,X,rs(C))}else r.kind!==281&&q.isolatedModules&&!Pr(r,ib)&&C.flags&1160127&&Qe(r,v.Import_0_conflicts_with_local_value_so_must_be_declared_with_a_type_only_import_when_isolatedModules_is_enabled,rs(C),Ie);if(Cd(q)&&!ib(r)&&!(r.flags&33554432)){let X=lh(C),_e=!(V&111551);if(_e||X)switch(r.kind){case 273:case 276:case 271:{if(q.verbatimModuleSyntax){M.assertIsDefined(r.name,"An ImportClause with a symbol should have a name");let we=q.verbatimModuleSyntax&&nA(r)?v.An_import_alias_cannot_resolve_to_a_type_or_type_only_declaration_when_verbatimModuleSyntax_is_enabled:_e?v._0_is_a_type_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled:v._0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled,Ne=Nn(r.kind===276&&r.propertyName||r.name);Xb(Qe(r,we,Ne),_e?void 0:X,Ne)}_e&&r.kind===271&&up(r,32)&&Qe(r,v.Cannot_use_export_import_on_a_type_or_type_only_namespace_when_0_is_enabled,Ie);break}case 281:if(q.verbatimModuleSyntax||Ur(X)!==Ur(r)){let we=Nn(r.propertyName||r.name),Ne=_e?Qe(r,v.Re_exporting_a_type_when_0_is_enabled_requires_using_export_type,Ie):Qe(r,v._0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_1_is_enabled,we,Ie);Xb(Ne,_e?void 0:X,we);break}}q.verbatimModuleSyntax&&r.kind!==271&&!hn(r)&&(W===1||Ur(r).impliedNodeFormat===1)&&Qe(r,v.ESM_syntax_is_not_allowed_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled)}if(_f(r)){let X=HCe(C,r);Md(X)&&X.declarations&&L0(r,X.declarations,X.escapedName)}}}function HCe(r,a){if(!(r.flags&2097152)||Md(r)||!yp(r))return r;let _=Au(r);if(_===St)return _;for(;r.flags&2097152;){let h=Jre(r);if(h){if(h===_)break;if(h.declarations&&wt(h.declarations))if(Md(h)){L0(a,h.declarations,h.escapedName);break}else{if(r===_)break;r=h}}else break}return _}function bne(r){h4(r,r.name),Sne(r),r.kind===276&&Nn(r.propertyName||r.name)==="default"&&Iy(q)&&W!==4&&(W<5||Ur(r).impliedNodeFormat===1)&&gu(r,131072)}function GCe(r){var a;let _=r.attributes;if(_){let h=dxe(!0);h!==zi&&I_(Y(_),UJ(h,32768),_);let T=ZK(r),C=BN(_,T?Or:void 0),I=r.attributes.token===118;if(T&&C)return;if((W===199&&r.moduleSpecifier&&r1(r.moduleSpecifier))!==99&&W!==99&&W!==200){let X=I?W===199?v.Import_attributes_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls:v.Import_attributes_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve:W===199?v.Import_assertions_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls:v.Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve;return Or(_,X)}if(Xg(r)||(Yc(r)?(a=r.importClause)==null?void 0:a.isTypeOnly:r.isTypeOnly))return Or(_,I?v.Import_attributes_cannot_be_used_with_type_only_imports_or_exports:v.Import_assertions_cannot_be_used_with_type_only_imports_or_exports);if(C)return Or(_,v.resolution_mode_can_only_be_set_for_type_only_imports)}}function xVt(r){return Q_(yl(r.value))}function CVt(r){if(!Nq(r,hn(r)?v.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module:v.An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module)){if(!Xy(r)&&r.modifiers&&ju(r,v.An_import_declaration_cannot_have_modifiers),vne(r)){let a=r.importClause;a&&!hqt(a)&&(a.name&&bne(a),a.namedBindings&&(a.namedBindings.kind===274?(bne(a.namedBindings),W!==4&&(W<5||Ur(r).impliedNodeFormat===1)&&Iy(q)&&gu(r,65536)):G_(r,r.moduleSpecifier)&&kt(a.namedBindings.elements,bne)))}GCe(r)}}function AVt(r){if(!Nq(r,hn(r)?v.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module:v.An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module)&&(Xy(r),nA(r)||vne(r)))if(bne(r),Qk(r,6),r.moduleReference.kind!==283){let a=Au(jn(r));if(a!==St){let _=Gf(a);if(_&111551){let h=_p(r.moduleReference);nl(h,112575).flags&1920||Qe(h,v.Module_0_is_hidden_by_a_local_declaration_with_the_same_name,Yo(h))}_&788968&&v4(r.name,v.Import_name_cannot_be_0)}r.isTypeOnly&&Or(r,v.An_import_alias_cannot_use_import_type)}else W>=5&&W!==200&&Ur(r).impliedNodeFormat===void 0&&!r.isTypeOnly&&!(r.flags&33554432)&&Or(r,v.Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead)}function kVt(r){if(!Nq(r,hn(r)?v.An_export_declaration_can_only_be_used_at_the_top_level_of_a_module:v.An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module)){if(!Xy(r)&&Ffe(r)&&ju(r,v.An_export_declaration_cannot_have_modifiers),PVt(r),!r.moduleSpecifier||vne(r))if(r.exportClause&&!zh(r.exportClause)){kt(r.exportClause.elements,NVt);let a=r.parent.kind===268&&B_(r.parent.parent),_=!a&&r.parent.kind===268&&!r.moduleSpecifier&&r.flags&33554432;r.parent.kind!==307&&!a&&!_&&Qe(r,v.Export_declarations_are_not_permitted_in_a_namespace)}else{let a=G_(r,r.moduleSpecifier);a&&sT(a)?Qe(r.moduleSpecifier,v.Module_0_uses_export_and_cannot_be_used_with_export_Asterisk,rs(a)):r.exportClause&&Sne(r.exportClause),W!==4&&(W<5||Ur(r).impliedNodeFormat===1)&&(r.exportClause?Iy(q)&&gu(r,65536):gu(r,32768))}GCe(r)}}function PVt(r){var a;return r.isTypeOnly&&((a=r.exportClause)==null?void 0:a.kind)===279?oXe(r.exportClause):!1}function Nq(r,a){let _=r.parent.kind===307||r.parent.kind===268||r.parent.kind===267;return _||ju(r,a),!_}function NVt(r){if(Sne(r),$p(q)&&KE(r.propertyName||r.name,!0),r.parent.parent.moduleSpecifier)Iy(q)&&W!==4&&(W<5||Ur(r).impliedNodeFormat===1)&&Nn(r.propertyName||r.name)==="default"&&gu(r,131072);else{let a=r.propertyName||r.name,_=xr(a,a.escapedText,2998271,void 0,!0);_&&(_===Be||_===ct||_.declarations&&Tv(z2(_.declarations[0])))?Qe(a,v.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module,Nn(a)):Qk(r,7)}}function DVt(r){let a=r.isExportEquals?v.An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration:v.A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration;if(Nq(r,a))return;let _=r.parent.kind===307?r.parent:r.parent.parent;if(_.kind===267&&!B_(_)){r.isExportEquals?Qe(r,v.An_export_assignment_cannot_be_used_in_a_namespace):Qe(r,v.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);return}!Xy(r)&&YH(r)&&ju(r,v.An_export_assignment_cannot_have_modifiers);let h=Vl(r);h&&I_(yl(r.expression),Wi(h),r.expression);let T=!r.isExportEquals&&!(r.flags&33554432)&&q.verbatimModuleSyntax&&(W===1||Ur(r).impliedNodeFormat===1);if(r.expression.kind===80){let C=r.expression,I=Mp(nl(C,-1,!0,!0,r));if(I){Qk(r,3);let V=lh(I,111551);if(Gf(I)&111551?(yl(C),!T&&!(r.flags&33554432)&&q.verbatimModuleSyntax&&V&&Qe(C,r.isExportEquals?v.An_export_declaration_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolves_to_a_type_only_declaration:v.An_export_default_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolves_to_a_type_only_declaration,Nn(C))):!T&&!(r.flags&33554432)&&q.verbatimModuleSyntax&&Qe(C,r.isExportEquals?v.An_export_declaration_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers_to_a_type:v.An_export_default_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers_to_a_type,Nn(C)),!T&&!(r.flags&33554432)&&Cd(q)&&!(I.flags&111551)){let H=Gf(I,!1,!0);I.flags&2097152&&H&788968&&!(H&111551)&&(!V||Ur(V)!==Ur(r))?Qe(C,r.isExportEquals?v._0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_import_type_where_0_is_imported:v._0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_export_type_0_as_default,Nn(C),Ie):V&&Ur(V)!==Ur(r)&&Xb(Qe(C,r.isExportEquals?v._0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_import_type_where_0_is_imported:v._0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_export_type_0_as_default,Nn(C),Ie),V,Nn(C))}}else yl(C);$p(q)&&KE(C,!0)}else yl(r.expression);T&&Qe(r,v.ESM_syntax_is_not_allowed_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled),kKe(_),r.flags&33554432&&!nc(r.expression)&&Or(r.expression,v.The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context),r.isExportEquals&&(W>=5&&W!==200&&(r.flags&33554432&&Ur(r).impliedNodeFormat===99||!(r.flags&33554432)&&Ur(r).impliedNodeFormat!==1)?Or(r,v.Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead):W===4&&!(r.flags&33554432)&&Or(r,v.Export_assignment_is_not_supported_when_module_flag_is_system))}function wVt(r){return Nu(r.exports,(a,_)=>_!=="export=")}function kKe(r){let a=jn(r),_=as(a);if(!_.exportsChecked){let h=a.exports.get("export=");if(h&&wVt(a)){let C=yp(h)||h.valueDeclaration;C&&!d7(C)&&!hn(C)&&Qe(C,v.An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements)}let T=mg(a);T&&T.forEach(({declarations:C,flags:I},V)=>{if(V==="__export"||I&1920)return;let H=vy(C,r5(WTt,n5(Yu)));if(!(I&524288&&H<=2)&&H>1&&!Tne(C))for(let X of C)XRe(X)&&_o.add(pn(X,v.Cannot_redeclare_exported_variable_0,Qi(V)))}),_.exportsChecked=!0}}function Tne(r){return r&&r.length>1&&r.every(a=>hn(a)&&oc(a)&&(Xx(a.expression)||Py(a.expression)))}function ja(r){if(r){let a=R;R=r,x=0,IVt(r),R=a}}function IVt(r){xR(r)&&kt(r.jsDoc,({comment:_,tags:h})=>{PKe(_),kt(h,T=>{PKe(T.comment),hn(r)&&ja(T)})});let a=r.kind;if(i)switch(a){case 267:case 263:case 264:case 262:i.throwIfCancellationRequested()}switch(a>=243&&a<=259&&ER(r)&&r.flowNode&&!GJ(r.flowNode)&&Cu(q.allowUnreachableCode===!1,r,v.Unreachable_code_detected),a){case 168:return OYe(r);case 169:return RYe(r);case 172:return FYe(r);case 171:return yBt(r);case 185:case 184:case 179:case 180:case 181:return tL(r);case 174:case 173:return vBt(r);case 175:return SBt(r);case 176:return bBt(r);case 177:case 178:return BYe(r);case 183:return wCe(r);case 182:return dBt(r);case 186:return kBt(r);case 187:return PBt(r);case 188:return NBt(r);case 189:return DBt(r);case 192:case 193:return wBt(r);case 196:case 190:case 191:return ja(r.type);case 197:return MBt(r);case 198:return LBt(r);case 194:return FBt(r);case 195:return jBt(r);case 203:return BBt(r);case 205:return UBt(r);case 202:return VBt(r);case 328:return oUt(r);case 329:return aUt(r);case 346:case 338:case 340:return KBt(r);case 345:return XBt(r);case 344:return QBt(r);case 324:case 325:case 326:return eUt(r);case 341:return tUt(r);case 348:return rUt(r);case 317:nUt(r);case 315:case 314:case 312:case 313:case 322:NKe(r),Js(r,ja);return;case 318:OVt(r);return;case 309:return ja(r.type);case 333:case 335:case 334:return cUt(r);case 350:return ZBt(r);case 343:return iUt(r);case 351:return sUt(r);case 199:return IBt(r);case 200:return OBt(r);case 262:return YBt(r);case 241:case 268:return dne(r);case 243:return AUt(r);case 244:return kUt(r);case 245:return PUt(r);case 246:return wUt(r);case 247:return IUt(r);case 248:return OUt(r);case 249:return MUt(r);case 250:return RUt(r);case 251:case 252:return JUt(r);case 253:return qUt(r);case 254:return zUt(r);case 255:return WUt(r);case 256:return $Ut(r);case 257:return HUt(r);case 258:return GUt(r);case 260:return xUt(r);case 208:return CUt(r);case 263:return rVt(r);case 264:return fVt(r);case 265:return pVt(r);case 266:return hVt(r);case 267:return TVt(r);case 272:return CVt(r);case 271:return AVt(r);case 278:return kVt(r);case 277:return DVt(r);case 242:case 259:sv(r);return;case 282:return EBt(r)}}function PKe(r){Rs(r)&&kt(r,a=>{QC(a)&&ja(a)})}function NKe(r){if(!hn(r))if(jj(r)||bN(r)){let a=Sa(jj(r)?54:58),_=r.postfix?v._0_at_the_end_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1:v._0_at_the_start_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1,h=r.type,T=Wi(h);Or(r,_,a,ln(bN(r)&&!(T===Ar||T===dn)?fi(Bt([T,nr],r.postfix?void 0:Ke)):T))}else Or(r,v.JSDoc_types_can_only_be_used_inside_documentation_comments)}function OVt(r){NKe(r),ja(r.type);let{parent:a}=r;if(ns(a)&&TN(a.parent)){Va(a.parent.parameters)!==a&&Qe(r,v.A_rest_parameter_must_be_last_in_a_parameter_list);return}Tb(a)||Qe(r,v.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);let _=r.parent.parent;if(!Pd(_)){Qe(r,v.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);return}let h=CR(_);if(!h)return;let T=ub(_);(!T||Va(T.parameters).symbol!==h)&&Qe(r,v.A_rest_parameter_must_be_last_in_a_parameter_list)}function RVt(r){let a=Wi(r.type),{parent:_}=r,h=r.parent.parent;if(Tb(r.parent)&&Pd(h)){let T=ub(h),C=aY(h.parent.parent);if(T||C){let I=vc(C?h.parent.parent.typeExpression.parameters:T.parameters),V=CR(h);if(!I||V&&I.symbol===V&&Fh(I))return g_(a)}}return ns(_)&&TN(_.parent)?g_(a):da(a)}function eP(r){let a=Ur(r),_=qn(a);_.flags&1?M.assert(!_.deferredNodes,"A type-checked file should have no deferred nodes."):(_.deferredNodes||(_.deferredNodes=new Set),_.deferredNodes.add(r))}function MVt(r){let a=qn(r);a.deferredNodes&&a.deferredNodes.forEach(LVt),a.deferredNodes=void 0}function LVt(r){var a,_;(a=Cn)==null||a.push(Cn.Phase.Check,"checkDeferredNode",{kind:r.kind,pos:r.pos,end:r.end,path:r.tracingPath});let h=R;switch(R=r,x=0,r.kind){case 213:case 214:case 215:case 170:case 286:cC(r);break;case 218:case 219:case 174:case 173:Ojt(r);break;case 177:case 178:BYe(r);break;case 231:tVt(r);break;case 168:pBt(r);break;case 285:U5t(r);break;case 284:J5t(r);break;case 216:case 234:case 217:njt(r);break;case 222:hs(r.expression);break;case 226:R9(r)&&cC(r);break}R=h,(_=Cn)==null||_.pop()}function FVt(r){var a,_;(a=Cn)==null||a.push(Cn.Phase.Check,"checkSourceFile",{path:r.path},!0),jc("beforeCheck"),jVt(r),jc("afterCheck"),vd("Check","beforeCheck","afterCheck"),(_=Cn)==null||_.pop()}function DKe(r,a){if(a)return!1;switch(r){case 0:return!!q.noUnusedLocals;case 1:return!!q.noUnusedParameters;default:return M.assertNever(r)}}function wKe(r){return od.get(r.path)||ve}function jVt(r){let a=qn(r);if(!(a.flags&1)){if(uO(r,q,e))return;pqt(r),Ym(FE),Ym(Jb),Ym(qb),Ym(zb),Ym(P2),kt(r.statements,ja),ja(r.endOfFileToken),MVt(r),Uf(r)&&jS(r),n(()=>{!r.isDeclarationFile&&(q.noUnusedLocals||q.noUnusedParameters)&&KYe(wKe(r),(_,h,T)=>{!VP(_)&&DKe(h,!!(_.flags&33554432))&&_o.add(T)}),r.isDeclarationFile||fUt()}),Uf(r)&&kKe(r),FE.length&&(kt(FE,mUt),Ym(FE)),Jb.length&&(kt(Jb,gUt),Ym(Jb)),qb.length&&(kt(qb,SUt),Ym(qb)),zb.length&&(kt(zb,TUt),Ym(zb)),a.flags|=1}}function IKe(r,a){try{return i=a,BVt(r)}finally{i=void 0}}function YCe(){for(let r of t)r();t=[]}function KCe(r){YCe();let a=n;n=_=>_(),FVt(r),n=a}function BVt(r){if(r){YCe();let a=_o.getGlobalDiagnostics(),_=a.length;KCe(r);let h=_o.getDiagnostics(r.fileName),T=_o.getGlobalDiagnostics();if(T!==a){let C=Un(a,T,rO);return ps(C,h)}else if(_===0&&T.length>0)return ps(T,h);return h}return kt(e.getSourceFiles(),KCe),_o.getDiagnostics()}function UVt(){return YCe(),_o.getGlobalDiagnostics()}function VVt(r,a){if(r.flags&67108864)return[];let _=fa(),h=!1;return T(),_.delete("this"),exe(_);function T(){for(;r;){switch(Lh(r)&&r.locals&&!Tv(r)&&I(r.locals,a),r.kind){case 307:if(!nu(r))break;case 267:V(jn(r).exports,a&2623475);break;case 266:I(jn(r).exports,a&8);break;case 231:r.name&&C(r.symbol,a);case 263:case 264:h||I(kS(jn(r)),a&788968);break;case 218:r.name&&C(r.symbol,a);break}X_e(r)&&C(qe,a),h=oa(r),r=r.parent}I(De,a)}function C(H,X){if(cN(H)&X){let _e=H.escapedName;_.has(_e)||_.set(_e,H)}}function I(H,X){X&&H.forEach(_e=>{C(_e,X)})}function V(H,X){X&&H.forEach(_e=>{!Pc(_e,281)&&!Pc(_e,280)&&_e.escapedName!=="default"&&C(_e,X)})}}function JVt(r){return r.kind===80&&EA(r.parent)&&Ps(r.parent)===r}function OKe(r){for(;r.parent.kind===166;)r=r.parent;return r.parent.kind===183}function qVt(r){for(;r.parent.kind===211;)r=r.parent;return r.parent.kind===233}function RKe(r,a){let _,h=Ou(r);for(;h&&!(_=a(h));)h=Ou(h);return _}function zVt(r){return!!Pr(r,a=>Vc(a)&&Yd(a.body)||Ns(a)?!0:gi(a)||Go(a)?"quit":!1)}function XCe(r,a){return!!RKe(r,_=>_===a)}function WVt(r){for(;r.parent.kind===166;)r=r.parent;if(r.parent.kind===271)return r.parent.moduleReference===r?r.parent:void 0;if(r.parent.kind===277)return r.parent.expression===r?r.parent:void 0}function Ene(r){return WVt(r)!==void 0}function $Vt(r){switch(cl(r.parent.parent)){case 1:case 3:return _d(r.parent);case 5:if(Wn(r.parent)&&lN(r.parent)===r)return;case 4:case 2:return jn(r.parent.parent)}}function HVt(r){let a=r.parent;for(;cf(a);)r=a,a=a.parent;if(a&&a.kind===205&&a.qualifier===r)return a}function GVt(r){if(r.expression.kind===110){let a=nf(r,!1,!1);if(Bs(a)){let _=KHe(a);if(_){let h=xT(_,void 0),T=QHe(_,h);return T&&!Ao(T)}}}}function MKe(r){if(Uh(r))return _d(r.parent);if(hn(r)&&r.parent.kind===211&&r.parent===r.parent.parent.left&&!Zi(r)&&!Eb(r)&&!GVt(r.parent)){let a=$Vt(r);if(a)return a}if(r.parent.kind===277&&nc(r)){let a=nl(r,2998271,!0);if(a&&a!==St)return a}else if(Tf(r)&&Ene(r)){let a=pb(r,271);return M.assert(a!==void 0),Ik(r,!0)}if(Tf(r)){let a=HVt(r);if(a){Wi(a);let _=qn(r).resolvedSymbol;return _===St?void 0:_}}for(;qfe(r);)r=r.parent;if(qVt(r)){let a=0;r.parent.kind===233?(a=Lg(r)?788968:111551,O9(r.parent)&&(a|=111551)):a=1920,a|=2097152;let _=nc(r)?nl(r,a,!0):void 0;if(_)return _}if(r.parent.kind===341)return CR(r.parent);if(r.parent.kind===168&&r.parent.parent.kind===345){M.assert(!hn(r));let a=ffe(r.parent);return a&&a.symbol}if(tg(r)){if($c(r))return;let a=Pr(r,Jp(QC,OO,Eb)),_=a?901119:111551;if(r.kind===80){if(GP(r)&&Zk(r)){let T=zre(r.parent);return T===St?void 0:T}let h=nl(r,_,!0,!0,ub(r));if(!h&&a){let T=Pr(r,Jp(gi,Yu));if(T)return Dq(r,!0,jn(T))}if(h&&a){let T=tE(r);if(T&&nS(T)&&T===h.valueDeclaration)return nl(r,_,!0,!0,Ur(T))||h}return h}else{if(Zi(r))return Hre(r);if(r.kind===211||r.kind===166){let h=qn(r);return h.resolvedSymbol?h.resolvedSymbol:(r.kind===211?($re(r,0),h.resolvedSymbol||(h.resolvedSymbol=LKe(yl(r.expression),d1(r.name)))):CGe(r,0),!h.resolvedSymbol&&a&&cf(r)?Dq(r):h.resolvedSymbol)}else if(Eb(r))return Dq(r)}}else if(OKe(r)){let a=r.parent.kind===183?788968:1920,_=nl(r,a,!1,!0);return _&&_!==St?_:Wte(r)}if(r.parent.kind===182)return nl(r,1)}function LKe(r,a){let _=ZEe(r,a);if(_.length&&r.members){let h=Jte(Sg(r).members);if(_===X_(r))return h;if(h){let T=as(h),C=Gi(_,V=>V.declaration),I=Cr(C,yo).join(",");if(T.filteredIndexSymbolCache||(T.filteredIndexSymbolCache=new Map),T.filteredIndexSymbolCache.has(I))return T.filteredIndexSymbolCache.get(I);{let V=Za(131072,"__index");return V.declarations=Gi(_,H=>H.declaration),V.parent=r.aliasSymbol?r.aliasSymbol:r.symbol?r.symbol:vm(V.declarations[0].parent),T.filteredIndexSymbolCache.set(I,V),V}}}}function Dq(r,a,_){if(Tf(r)){let I=nl(r,901119,a,!0,ub(r));if(!I&&He(r)&&_&&(I=ro(m_(Rp(_),r.escapedText,901119))),I)return I}let h=He(r)?_:Dq(r.left,a,_),T=He(r)?r.escapedText:r.right.escapedText;if(h){let C=h.flags&111551&&ma(gn(h),"prototype"),I=C?gn(C):ac(h);return ma(I,T)}}function vm(r,a){if(Ji(r))return nu(r)?ro(r.symbol):void 0;let{parent:_}=r,h=_.parent;if(!(r.flags&67108864)){if(QRe(r)){let T=jn(_);return GC(r.parent)&&r.parent.propertyName===r?Jre(T):T}else if(kR(r))return jn(_.parent);if(r.kind===80){if(Ene(r))return MKe(r);if(_.kind===208&&h.kind===206&&r===_.propertyName){let T=tP(h),C=ma(T,r.escapedText);if(C)return C}else if(AO(_)&&_.name===r)return _.keywordToken===105&&Nn(r)==="target"?dCe(_).symbol:_.keywordToken===102&&Nn(r)==="meta"?RWe().members.get("meta"):void 0}switch(r.kind){case 80:case 81:case 211:case 166:if(!aE(r))return MKe(r);case 110:let T=nf(r,!1,!1);if(Bs(T)){let V=md(T);if(V.thisParameter)return V.thisParameter}if(l9(r))return hs(r).symbol;case 197:return tre(r).symbol;case 108:return hs(r).symbol;case 137:let C=r.parent;return C&&C.kind===176?C.parent.symbol:void 0;case 11:case 15:if(cb(r.parent.parent)&&II(r.parent.parent)===r||(r.parent.kind===272||r.parent.kind===278)&&r.parent.moduleSpecifier===r||hn(r)&&Xg(r.parent)&&r.parent.moduleSpecifier===r||hn(r)&&kf(r.parent,!1)||Np(r.parent)||Mv(r.parent)&&Ev(r.parent.parent)&&r.parent.parent.argument===r.parent)return G_(r,r,a);if(ea(_)&&Qx(_)&&_.arguments[1]===r)return jn(_);case 9:let I=cc(_)?_.argumentExpression===r?t_(_.expression):void 0:Mv(_)&&mE(h)?Wi(h.objectType):void 0;return I&&ma(I,Uc(r.text));case 90:case 100:case 39:case 86:return _d(r.parent);case 205:return Ev(r)?vm(r.argument.literal,a):void 0;case 95:return dc(r.parent)?M.checkDefined(r.parent.symbol):void 0;case 102:case 105:return AO(r.parent)?cYe(r.parent).symbol:void 0;case 104:if(Pn(r.parent)){let V=t_(r.parent.right),H=xCe(V);return H?.symbol??V.symbol}return;case 236:return hs(r).symbol;case 295:if(GP(r)&&Zk(r)){let V=zre(r.parent);return V===St?void 0:V}default:return}}}function YVt(r){if(He(r)&&Wn(r.parent)&&r.parent.name===r){let a=d1(r),_=t_(r.parent.expression),h=_.flags&1048576?_.types:[_];return va(h,T=>Zn(X_(T),C=>Uk(a,C.keyType)))}}function KVt(r){if(r&&r.kind===304)return nl(r.name,2208703)}function XVt(r){return b_(r)?r.parent.parent.moduleSpecifier?Zb(r.parent.parent,r):nl(r.propertyName||r.name,2998271):nl(r,2998271)}function tP(r){if(Ji(r)&&!nu(r)||r.flags&67108864)return Oe;let a=eG(r),_=a&&Al(jn(a.class));if(Lg(r)){let h=Wi(r);return _?bp(h,_.thisType):h}if(tg(r))return QCe(r);if(_&&!a.isImplements){let h=xo(_i(_));return h?bp(h,_.thisType):Oe}if(EA(r)){let h=jn(r);return ac(h)}if(JVt(r)){let h=vm(r);return h?ac(h):Oe}if(Xa(r))return $a(r,!0,0)||Oe;if(u_(r)){let h=jn(r);return h?gn(h):Oe}if(QRe(r)){let h=vm(r);return h?gn(h):Oe}if(Hs(r))return $a(r.parent,!0,0)||Oe;if(Ene(r)){let h=vm(r);if(h){let T=ac(h);return ao(T)?gn(h):T}}return AO(r.parent)&&r.parent.keywordToken===r.kind?cYe(r.parent):l2(r)?dxe(!1):Oe}function xne(r){if(M.assert(r.kind===210||r.kind===209),r.parent.kind===250){let T=Aq(r.parent);return uC(r,T||Oe)}if(r.parent.kind===226){let T=t_(r.parent.right);return uC(r,T||Oe)}if(r.parent.kind===303){let T=aa(r.parent.parent,Ca),C=xne(T)||Oe,I=JP(T.properties,r.parent);return EYe(T,C,I)}let a=aa(r.parent,Gu),_=xne(a)||Oe,h=y1(65,_,nr,r.parent)||Oe;return xYe(a,_,a.elements.indexOf(r),h)}function QVt(r){let a=xne(aa(r.parent.parent,TI));return a&&ma(a,r.escapedText)}function QCe(r){return YI(r)&&(r=r.parent),Q_(t_(r))}function FKe(r){let a=_d(r.parent);return oa(r)?gn(a):ac(a)}function jKe(r){let a=r.name;switch(a.kind){case 80:return Lf(Nn(a));case 9:case 11:return Lf(a.text);case 167:let _=gh(a);return e_(_,12288)?_:Ue;default:return M.fail("Unsupported property name.")}}function ZCe(r){r=K_(r);let a=fa(bo(r)),_=Ys(r,0).length?nd:Ys(r,1).length?Je:void 0;return _&&kt(bo(_),h=>{a.has(h.escapedName)||a.set(h.escapedName,h)}),SS(a)}function Cne(r){return Ys(r,0).length!==0||Ys(r,1).length!==0}function BKe(r){let a=ZVt(r);return a?va(a,BKe):[r]}function ZVt(r){if(ll(r)&6)return Gi(as(r).containingType.types,a=>ma(a,r.escapedName));if(r.flags&33554432){let{links:{leftSpread:a,rightSpread:_,syntheticOrigin:h}}=r;return a?[a,_]:h?[h]:qC(eJt(r))}}function eJt(r){let a,_=r;for(;_=as(_).target;)a=_;return a}function tJt(r){if(xc(r))return!1;let a=ks(r,He);if(!a)return!1;let _=a.parent;return _?!((Wn(_)||ql(_))&&_.name===a)&&uL(a)===qe:!1}function rJt(r){return z3(r.parent)&&r===r.parent.name}function nJt(r,a){var _;let h=ks(r,He);if(h){let T=uL(h,rJt(h));if(T){if(T.flags&1048576){let I=ro(T.exportSymbol);if(!a&&I.flags&944&&!(I.flags&3))return;T=I}let C=Qu(T);if(C){if(C.flags&512&&((_=C.valueDeclaration)==null?void 0:_.kind)===307){let I=C.valueDeclaration,V=Ur(h);return I!==V?void 0:I}return Pr(h.parent,I=>z3(I)&&jn(I)===C)}}}}function iJt(r){let a=nde(r);if(a)return a;let _=ks(r,He);if(_){let h=SJt(_);if(ch(h,111551)&&!lh(h,111551))return yp(h)}}function sJt(r){return r.valueDeclaration&&Xa(r.valueDeclaration)&&IP(r.valueDeclaration).parent.kind===299}function UKe(r){if(r.flags&418&&r.valueDeclaration&&!Ji(r.valueDeclaration)){let a=as(r);if(a.isDeclarationWithCollidingName===void 0){let _=eg(r.valueDeclaration);if(x_e(_)||sJt(r))if(xr(_.parent,r.escapedName,111551,void 0,!1))a.isDeclarationWithCollidingName=!0;else if(eAe(r.valueDeclaration,16384)){let h=eAe(r.valueDeclaration,32768),T=V1(_,!1),C=_.kind===241&&V1(_.parent,!1);a.isDeclarationWithCollidingName=!I_e(_)&&(!h||!T&&!C)}else a.isDeclarationWithCollidingName=!1}return a.isDeclarationWithCollidingName}return!1}function aJt(r){if(!xc(r)){let a=ks(r,He);if(a){let _=uL(a);if(_&&UKe(_))return _.valueDeclaration}}}function oJt(r){let a=ks(r,u_);if(a){let _=jn(a);if(_)return UKe(_)}return!1}function VKe(r){switch(M.assert(_t),r.kind){case 271:return Ane(jn(r));case 273:case 274:case 276:case 281:let a=jn(r);return!!a&&Ane(a,!0);case 278:let _=r.exportClause;return!!_&&(zh(_)||Pt(_.elements,VKe));case 277:return r.expression&&r.expression.kind===80?Ane(jn(r),!0):!0}return!1}function cJt(r){let a=ks(r,ru);return a===void 0||a.parent.kind!==307||!nA(a)?!1:Ane(jn(a))&&a.moduleReference&&!$c(a.moduleReference)}function Ane(r,a){if(!r)return!1;let _=Ur(r.valueDeclaration),h=_&&jn(_);Mf(h);let T=Mp(Au(r));return T===St?!a||!lh(r):!!(Gf(r,a,!0)&111551)&&(lE(q)||!lL(T))}function lL(r){return ECe(r)||!!r.constEnumOnlyModule}function JKe(r,a){if(M.assert(_t),yn(r)){let _=jn(r),h=_&&as(_);if(h?.referenced)return!0;let T=as(_).aliasTarget;if(T&&U_(r)&32&&Gf(T)&111551&&(lE(q)||!lL(T)))return!0}return a?!!Js(r,_=>JKe(_,a)):!1}function qKe(r){if(Yd(r.body)){if(Sv(r)||Og(r))return!1;let a=jn(r),_=ex(a);return _.length>1||_.length===1&&_[0].declaration!==r}return!1}function lJt(r){let a=Pne(r);if(!a)return!1;let _=Wi(a);return HD(_)}function kne(r){return(uJt(r)||_Jt(r))&&!lJt(r)}function uJt(r){return!!ce&&!vJ(r)&&!Pd(r)&&!!r.initializer&&!li(r,31)}function _Jt(r){return ce&&vJ(r)&&(Pd(r)||!r.initializer)&&li(r,31)}function zKe(r){let a=ks(r,h=>Tl(h)||Ei(h));if(!a)return!1;let _;if(Ei(a)){if(a.type||!hn(a)&&!_L(a))return!1;let h=RI(a);if(!h||!Zm(h))return!1;_=jn(h)}else _=jn(a);return!_||!(_.flags&16|3)?!1:!!Nu(Rp(_),h=>h.flags&111551&&CA(h.valueDeclaration))}function fJt(r){let a=ks(r,Tl);if(!a)return ve;let _=jn(a);return _&&bo(gn(_))||ve}function iw(r){var a;let _=r.id||0;return _<0||_>=wa.length?0:((a=wa[_])==null?void 0:a.flags)||0}function eAe(r,a){return pJt(r,a),!!(iw(r)&a)}function pJt(r,a){if(!q.noCheck&&KR(Ur(r),q)||qn(r).calculatedFlags&a)return;switch(a){case 16:case 32:return I(r);case 128:case 256:case 2097152:return C(r);case 512:case 8192:case 65536:case 262144:return H(r);case 536870912:return _e(r);case 4096:case 32768:case 16384:return Ne(r);default:return M.assertNever(a,`Unhandled node check flag calculation: ${M.formatNodeCheckFlags(a)}`)}function h(Tt,Mt){let mr=Mt(Tt,Tt.parent);if(mr!=="skip")return mr||$A(Tt,Mt)}function T(Tt){let Mt=qn(Tt);if(Mt.calculatedFlags&a)return"skip";Mt.calculatedFlags|=2097536,I(Tt)}function C(Tt){h(Tt,T)}function I(Tt){let Mt=qn(Tt);Mt.calculatedFlags|=48,Tt.kind===108&&Lre(Tt)}function V(Tt){let Mt=qn(Tt);if(Mt.calculatedFlags&a)return"skip";Mt.calculatedFlags|=336384,_e(Tt)}function H(Tt){h(Tt,V)}function X(Tt){return tg(Tt)||p_(Tt.parent)&&(Tt.parent.objectAssignmentInitializer??Tt.parent.name)===Tt}function _e(Tt){let Mt=qn(Tt);if(Mt.calculatedFlags|=536920064,He(Tt)&&X(Tt)&&!(Wn(Tt.parent)&&Tt.parent.name===Tt)){let mr=gf(Tt);mr&&mr!==St&&$He(Tt,mr)}}function we(Tt){let Mt=qn(Tt);if(Mt.calculatedFlags&a)return"skip";Mt.calculatedFlags|=53248,pt(Tt)}function Ne(Tt){let Mt=eg(Uh(Tt)?Tt.parent:Tt);h(Mt,we)}function pt(Tt){_e(Tt),za(Tt)&&gh(Tt),Zi(Tt)&&uu(Tt.parent)&&cne(Tt.parent)}}function fC(r){return xKe(r.parent),qn(r).enumMemberValue??_u(void 0)}function WKe(r){switch(r.kind){case 306:case 211:case 212:return!0}return!1}function tAe(r){if(r.kind===306)return fC(r).value;qn(r).resolvedSymbol||yl(r);let a=qn(r).resolvedSymbol||(nc(r)?nl(r,111551,!0):void 0);if(a&&a.flags&8){let _=a.valueDeclaration;if(KT(_.parent))return fC(_).value}}function rAe(r){return!!(r.flags&524288)&&Ys(r,0).length>0}function dJt(r,a){var _;let h=ks(r,Tf);if(!h||a&&(a=ks(a),!a))return 0;let T=!1;if(cf(h)){let _e=nl(_p(h),111551,!0,!0,a);T=!!((_=_e?.declarations)!=null&&_.every(ib))}let C=nl(h,111551,!0,!0,a),I=C&&C.flags&2097152?Au(C):C;T||(T=!!(C&&lh(C,111551)));let V=nl(h,788968,!0,!0,a),H=V&&V.flags&2097152?Au(V):V;if(C||T||(T=!!(V&&lh(V,788968))),I&&I===H){let _e=mxe(!1);if(_e&&I===_e)return 9;let we=gn(I);if(we&&b7(we))return T?10:1}if(!H)return T?11:0;let X=ac(H);return ao(X)?T?11:0:X.flags&3?11:e_(X,245760)?2:e_(X,528)?6:e_(X,296)?3:e_(X,2112)?4:e_(X,402653316)?5:Ha(X)?7:e_(X,12288)?8:rAe(X)?10:Jd(X)?7:11}function mJt(r,a,_,h){let T=ks(r,G_e);if(!T)return U.createToken(133);let C=jn(T),I=C&&!(C.flags&133120)?ST(gn(C)):Oe;return Ve.serializeTypeForDeclaration(T,I,C,a,_|1024,h)}function gJt(r){return Bs(r)||dc(r)||rA(r)}function wq(r){r=ks(r,M3);let a=r.kind===178?177:178,_=Pc(jn(r),a),h=_&&_.pos<r.pos?_:r,T=_&&_.pos<r.pos?r:_,C=r.kind===178?r:_,I=r.kind===177?r:_;return{firstAccessor:h,secondAccessor:T,setAccessor:C,getAccessor:I}}function $Ke(r){return Bs(r)&&!Og(r)?HKe(r):dc(r)?r.expression:r.initializer?r.initializer:ns(r)&&Og(r.parent)?HKe(wq(r.parent).getAccessor):void 0}function HKe(r){let a;if(r&&!$c(r.body)){if(Rl(r)&3)return;let _=r.body;_&&Vs(_)?xv(_,h=>{if(!a)a=h.expression;else return a=void 0,!0}):a=_}return a}function hJt(r,a,_,h){let T=ks(r,Bs);return T?Ve.serializeReturnTypeForSignature(md(T),a,_|1024,h):U.createToken(133)}function yJt(r,a,_,h){let T=ks(r,Ct);if(!T)return U.createToken(133);let C=Qf(QCe(T));return Ve.expressionOrTypeToTypeNode(T,C,void 0,a,_|1024,h)}function vJt(r){return De.has(Uc(r))}function uL(r,a){let _=qn(r).resolvedSymbol;if(_)return _;let h=r;if(a){let T=r.parent;u_(T)&&r===T.name&&(h=z2(T))}return xr(h,r.escapedText,3257279,void 0,!0)}function SJt(r){let a=qn(r).resolvedSymbol;return a&&a!==St?a:xr(r,r.escapedText,3257279,void 0,!0,void 0)}function bJt(r){if(!xc(r)){let a=ks(r,He);if(a){let _=uL(a);if(_)return Mp(_).valueDeclaration}}}function TJt(r){if(!xc(r)){let a=ks(r,He);if(a){let _=uL(a);if(_)return Zn(Mp(_).declarations,h=>{switch(h.kind){case 260:case 169:case 208:case 172:case 303:case 304:case 306:case 210:case 262:case 218:case 219:case 263:case 231:case 266:case 174:case 177:case 178:case 267:return!0}return!1})}}}function EJt(r){return eR(r)||Ei(r)&&_L(r)?ix(gn(jn(r))):!1}function xJt(r,a,_){let h=r.flags&1056?Ve.symbolToExpression(r.symbol,111551,a,void 0,_):r===Ht?U.createTrue():r===It&&U.createFalse();if(h)return h;let T=r.value;return typeof T=="object"?U.createBigIntLiteral(T):typeof T=="string"?U.createStringLiteral(T):T<0?U.createPrefixUnaryExpression(41,U.createNumericLiteral(-T)):U.createNumericLiteral(T)}function CJt(r,a){let _=gn(jn(r));return xJt(_,r,a)}function GKe(r){return r?(Hb(r),Ur(r).localJsxFactory||M0):M0}function nAe(r){if(r){let a=Ur(r);if(a){if(a.localJsxFragmentFactory)return a.localJsxFragmentFactory;let _=a.pragmas.get("jsxfrag"),h=Rs(_)?_[0]:_;if(h)return a.localJsxFragmentFactory=GA(h.arguments.factory,ee),a.localJsxFragmentFactory}}if(q.jsxFragmentFactory)return GA(q.jsxFragmentFactory,ee)}function Pne(r){let a=Vl(r);if(a)return a;if(r.kind===169&&r.parent.kind===178){let _=wq(r.parent).getAccessor;if(_)return lp(_)}}function AJt(r){let a=lp(r);if(a)return a;if(r.kind===177){let _=wq(r).setAccessor;if(_){let h=aN(_);if(h)return Vl(h)}}}function kJt(){return{getReferencedExportContainer:nJt,getReferencedImportDeclaration:iJt,getReferencedDeclarationWithCollidingName:aJt,isDeclarationWithCollidingName:oJt,isValueAliasDeclaration:a=>{let _=ks(a);return _&&_t?VKe(_):!0},hasGlobalName:vJt,isReferencedAliasDeclaration:(a,_)=>{let h=ks(a);return h&&_t?JKe(h,_):!0},hasNodeCheckFlag:(a,_)=>{let h=ks(a);return h?eAe(h,_):!1},isTopLevelValueImportEqualsWithEntityName:cJt,isDeclarationVisible:H0,isImplementationOfOverload:qKe,requiresAddingImplicitUndefined:kne,isExpandoFunctionDeclaration:zKe,getPropertiesOfContainerFunction:fJt,createTypeOfDeclaration:mJt,createReturnTypeOfSignatureDeclaration:hJt,createTypeOfExpression:yJt,createLiteralConstValue:CJt,isSymbolAccessible:gg,isEntityNameVisible:bS,getConstantValue:a=>{let _=ks(a,WKe);return _?tAe(_):void 0},getEnumMemberValue:a=>{let _=ks(a,nS);return _?fC(_):void 0},collectLinkedAliases:KE,markLinkedReferences:a=>{let _=ks(a);return _&&Qk(_,0)},getReferencedValueDeclaration:bJt,getReferencedValueDeclarations:TJt,getTypeReferenceSerializationKind:dJt,isOptionalParameter:vJ,isArgumentsLocalBinding:tJt,getExternalModuleFileFromDeclaration:a=>{let _=ks(a,M_e);return _&&iAe(_)},isLiteralConstDeclaration:EJt,isLateBound:a=>{let _=ks(a,u_),h=_&&jn(_);return!!(h&&ll(h)&4096)},getJsxFactoryEntity:GKe,getJsxFragmentFactoryEntity:nAe,isBindingCapturedByNode:(a,_)=>{let h=ks(a),T=ks(_);return!!h&&!!T&&(Ei(T)||Xa(T))&&$Ft(h,T)},getDeclarationStatementsForSourceFile:(a,_,h)=>{let T=ks(a);M.assert(T&&T.kind===307,"Non-sourcefile node passed into getDeclarationsForSourceFile");let C=jn(a);return C?(Mf(C),C.exports?Ve.symbolTableToDeclarationStatements(C.exports,a,_,h):[]):a.locals?Ve.symbolTableToDeclarationStatements(a.locals,a,_,h):[]},isImportRequiredByAugmentation:r,isDefinitelyReferenceToGlobalSymbolObject:Ek};function r(a){let _=Ur(a);if(!_.symbol)return!1;let h=iAe(a);if(!h||h===_)return!1;let T=mg(_.symbol);for(let C of Is(T.values()))if(C.mergeId){let I=ro(C);if(I.declarations){for(let V of I.declarations)if(Ur(V)===h)return!0}}return!1}}function iAe(r){let a=r.kind===267?ai(r.name,La):sA(r),_=j2(a,a,void 0);if(_)return Pc(_,307)}function PJt(){for(let a of e.getSourceFiles())kge(a,q);Wl=new Map;let r;for(let a of e.getSourceFiles())if(!a.redirectInfo){if(!Uf(a)){let _=a.locals.get("globalThis");if(_?.declarations)for(let h of _.declarations)_o.add(pn(h,v.Declaration_name_conflicts_with_built_in_global_identifier_0,"globalThis"));Ip(De,a.locals)}a.jsGlobalAugmentations&&Ip(De,a.jsGlobalAugmentations),a.patternAmbientModules&&a.patternAmbientModules.length&&(mu=ps(mu,a.patternAmbientModules)),a.moduleAugmentations.length&&(r||(r=[])).push(a.moduleAugmentations),a.symbol&&a.symbol.globalExports&&a.symbol.globalExports.forEach((h,T)=>{De.has(T)||De.set(T,h)})}if(r)for(let a of r)for(let _ of a)Rg(_.parent)&&Zv(_);if(e1(),as(Be).type=Z,as(qe).type=kl("IArguments",0,!0),as(St).type=Oe,as(ct).type=Lp(16,ct),qt=kl("Array",1,!0),rl=kl("Object",0,!0),$l=kl("Function",0,!0),nd=le&&kl("CallableFunction",0,!0)||$l,Je=le&&kl("NewableFunction",0,!0)||$l,gs=kl("String",0,!0),Qa=kl("Number",0,!0),so=kl("Boolean",0,!0),fl=kl("RegExp",0,!0),Uo=g_(Me),Fo=g_(tt),Fo===zi&&(Fo=Zt(void 0,J,ve,ve,ve)),Gr=UWe("ReadonlyArray",1)||qt,Cl=Gr?P7(Gr,[Me]):Uo,au=UWe("ThisType",1),r)for(let a of r)for(let _ of a)Rg(_.parent)||Zv(_);Wl.forEach(({firstFile:a,secondFile:_,conflictingSymbols:h})=>{if(h.size<8)h.forEach(({isBlockScoped:T,firstFileLocations:C,secondFileLocations:I},V)=>{let H=T?v.Cannot_redeclare_block_scoped_variable_0:v.Duplicate_identifier_0;for(let X of C)Kb(X,H,V,I);for(let X of I)Kb(X,H,V,C)});else{let T=Is(h.keys()).join(", ");_o.add(ca(pn(a,v.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0,T),pn(_,v.Conflicts_are_in_this_file))),_o.add(ca(pn(_,v.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0,T),pn(a,v.Conflicts_are_in_this_file)))}}),Wl=void 0}function gu(r,a){if(q.importHelpers){let _=Ur(r);if(ZC(_,q)&&!(r.flags&33554432)){let h=DJt(_,r);if(h!==St){let T=as(h);if(T.requestedExternalEmitHelpers??(T.requestedExternalEmitHelpers=0),(T.requestedExternalEmitHelpers&a)!==a){let C=a&~T.requestedExternalEmitHelpers;for(let I=1;I<=16777216;I<<=1)if(C&I)for(let V of NJt(I)){let H=pl(m_(mg(h),Uc(V),111551));H?I&524288?Pt(ex(H),X=>ep(X)>3)||Qe(r,v.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0,ab,V,4):I&1048576?Pt(ex(H),X=>ep(X)>4)||Qe(r,v.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0,ab,V,5):I&1024&&(Pt(ex(H),X=>ep(X)>2)||Qe(r,v.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0,ab,V,3)):Qe(r,v.This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_version_of_0,ab,V)}}T.requestedExternalEmitHelpers|=a}}}}function NJt(r){switch(r){case 1:return["__extends"];case 2:return["__assign"];case 4:return["__rest"];case 8:return pe?["__decorate"]:["__esDecorate","__runInitializers"];case 16:return["__metadata"];case 32:return["__param"];case 64:return["__awaiter"];case 128:return["__generator"];case 256:return["__values"];case 512:return["__read"];case 1024:return["__spreadArray"];case 2048:return["__await"];case 4096:return["__asyncGenerator"];case 8192:return["__asyncDelegator"];case 16384:return["__asyncValues"];case 32768:return["__exportStar"];case 65536:return["__importStar"];case 131072:return["__importDefault"];case 262144:return["__makeTemplateObject"];case 524288:return["__classPrivateFieldGet"];case 1048576:return["__classPrivateFieldSet"];case 2097152:return["__classPrivateFieldIn"];case 4194304:return["__setFunctionName"];case 8388608:return["__propKey"];case 16777216:return["__addDisposableResource","__disposeResources"];default:return M.fail("Unrecognized helper")}}function DJt(r,a){let _=qn(r);return _.externalHelpersModule||(_.externalHelpersModule=WE(Cqt(r),ab,v.This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found,a)||St),_.externalHelpersModule}function Xy(r){var a;let _=OJt(r)||wJt(r);if(_!==void 0)return _;if(ns(r)&&sE(r))return ju(r,v.Neither_decorators_nor_modifiers_may_be_applied_to_this_parameters);let h=_l(r)?r.declarationList.flags&7:0,T,C,I,V,H,X=0,_e=!1,we=!1;for(let Ne of r.modifiers)if(fu(Ne)){if(cR(pe,r,r.parent,r.parent.parent)){if(pe&&(r.kind===177||r.kind===178)){let pt=wq(r);if(Wp(pt.firstAccessor)&&r===pt.secondAccessor)return ju(r,v.Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name)}}else return r.kind===174&&!Yd(r.body)?ju(r,v.A_decorator_can_only_decorate_a_method_implementation_not_an_overload):ju(r,v.Decorators_are_not_valid_here);if(X&-34849)return Or(Ne,v.Decorators_are_not_valid_here);if(we&&X&98303){M.assertIsDefined(H);let pt=Ur(Ne);return BS(pt)?!1:(ca(Qe(Ne,v.Decorators_may_not_appear_after_export_or_export_default_if_they_also_appear_before_export),pn(H,v.Decorator_used_before_export_here)),!0)}X|=32768,X&98303?X&32&&(_e=!0):we=!0,H??(H=Ne)}else{if(Ne.kind!==148){if(r.kind===171||r.kind===173)return Or(Ne,v._0_modifier_cannot_appear_on_a_type_member,Sa(Ne.kind));if(r.kind===181&&(Ne.kind!==126||!gi(r.parent)))return Or(Ne,v._0_modifier_cannot_appear_on_an_index_signature,Sa(Ne.kind))}if(Ne.kind!==103&&Ne.kind!==147&&Ne.kind!==87&&r.kind===168)return Or(Ne,v._0_modifier_cannot_appear_on_a_type_parameter,Sa(Ne.kind));switch(Ne.kind){case 87:{if(r.kind!==266&&r.kind!==168)return Or(r,v.A_class_member_cannot_have_the_0_keyword,Sa(87));let Mt=sm(r.parent)&&_b(r.parent)||r.parent;if(r.kind===168&&!(Go(Mt)||gi(Mt)||Jh(Mt)||gN(Mt)||MA(Mt)||u8(Mt)||$g(Mt)))return Or(Ne,v._0_modifier_can_only_appear_on_a_type_parameter_of_a_function_method_or_class,Sa(Ne.kind));break}case 164:if(X&16)return Or(Ne,v._0_modifier_already_seen,"override");if(X&128)return Or(Ne,v._0_modifier_cannot_be_used_with_1_modifier,"override","declare");if(X&8)return Or(Ne,v._0_modifier_must_precede_1_modifier,"override","readonly");if(X&512)return Or(Ne,v._0_modifier_must_precede_1_modifier,"override","accessor");if(X&1024)return Or(Ne,v._0_modifier_must_precede_1_modifier,"override","async");X|=16,V=Ne;break;case 125:case 124:case 123:let pt=$6(pA(Ne.kind));if(X&7)return Or(Ne,v.Accessibility_modifier_already_seen);if(X&16)return Or(Ne,v._0_modifier_must_precede_1_modifier,pt,"override");if(X&256)return Or(Ne,v._0_modifier_must_precede_1_modifier,pt,"static");if(X&512)return Or(Ne,v._0_modifier_must_precede_1_modifier,pt,"accessor");if(X&8)return Or(Ne,v._0_modifier_must_precede_1_modifier,pt,"readonly");if(X&1024)return Or(Ne,v._0_modifier_must_precede_1_modifier,pt,"async");if(r.parent.kind===268||r.parent.kind===307)return Or(Ne,v._0_modifier_cannot_appear_on_a_module_or_namespace_element,pt);if(X&64)return Ne.kind===123?Or(Ne,v._0_modifier_cannot_be_used_with_1_modifier,pt,"abstract"):Or(Ne,v._0_modifier_must_precede_1_modifier,pt,"abstract");if(j_(r))return Or(Ne,v.An_accessibility_modifier_cannot_be_used_with_a_private_identifier);X|=pA(Ne.kind);break;case 126:if(X&256)return Or(Ne,v._0_modifier_already_seen,"static");if(X&8)return Or(Ne,v._0_modifier_must_precede_1_modifier,"static","readonly");if(X&1024)return Or(Ne,v._0_modifier_must_precede_1_modifier,"static","async");if(X&512)return Or(Ne,v._0_modifier_must_precede_1_modifier,"static","accessor");if(r.parent.kind===268||r.parent.kind===307)return Or(Ne,v._0_modifier_cannot_appear_on_a_module_or_namespace_element,"static");if(r.kind===169)return Or(Ne,v._0_modifier_cannot_appear_on_a_parameter,"static");if(X&64)return Or(Ne,v._0_modifier_cannot_be_used_with_1_modifier,"static","abstract");if(X&16)return Or(Ne,v._0_modifier_must_precede_1_modifier,"static","override");X|=256,T=Ne;break;case 129:if(X&512)return Or(Ne,v._0_modifier_already_seen,"accessor");if(X&8)return Or(Ne,v._0_modifier_cannot_be_used_with_1_modifier,"accessor","readonly");if(X&128)return Or(Ne,v._0_modifier_cannot_be_used_with_1_modifier,"accessor","declare");if(r.kind!==172)return Or(Ne,v.accessor_modifier_can_only_appear_on_a_property_declaration);X|=512;break;case 148:if(X&8)return Or(Ne,v._0_modifier_already_seen,"readonly");if(r.kind!==172&&r.kind!==171&&r.kind!==181&&r.kind!==169)return Or(Ne,v.readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature);if(X&512)return Or(Ne,v._0_modifier_cannot_be_used_with_1_modifier,"readonly","accessor");X|=8;break;case 95:if(q.verbatimModuleSyntax&&!(r.flags&33554432)&&r.kind!==265&&r.kind!==264&&r.kind!==267&&r.parent.kind===307&&(W===1||Ur(r).impliedNodeFormat===1))return Or(Ne,v.A_top_level_export_modifier_cannot_be_used_on_value_declarations_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled);if(X&32)return Or(Ne,v._0_modifier_already_seen,"export");if(X&128)return Or(Ne,v._0_modifier_must_precede_1_modifier,"export","declare");if(X&64)return Or(Ne,v._0_modifier_must_precede_1_modifier,"export","abstract");if(X&1024)return Or(Ne,v._0_modifier_must_precede_1_modifier,"export","async");if(gi(r.parent))return Or(Ne,v._0_modifier_cannot_appear_on_class_elements_of_this_kind,"export");if(r.kind===169)return Or(Ne,v._0_modifier_cannot_appear_on_a_parameter,"export");if(h===4)return Or(Ne,v._0_modifier_cannot_appear_on_a_using_declaration,"export");if(h===6)return Or(Ne,v._0_modifier_cannot_appear_on_an_await_using_declaration,"export");X|=32;break;case 90:let Tt=r.parent.kind===307?r.parent:r.parent.parent;if(Tt.kind===267&&!B_(Tt))return Or(Ne,v.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);if(h===4)return Or(Ne,v._0_modifier_cannot_appear_on_a_using_declaration,"default");if(h===6)return Or(Ne,v._0_modifier_cannot_appear_on_an_await_using_declaration,"default");if(X&32){if(_e)return Or(H,v.Decorators_are_not_valid_here)}else return Or(Ne,v._0_modifier_must_precede_1_modifier,"export","default");X|=2048;break;case 138:if(X&128)return Or(Ne,v._0_modifier_already_seen,"declare");if(X&1024)return Or(Ne,v._0_modifier_cannot_be_used_in_an_ambient_context,"async");if(X&16)return Or(Ne,v._0_modifier_cannot_be_used_in_an_ambient_context,"override");if(gi(r.parent)&&!Ns(r))return Or(Ne,v._0_modifier_cannot_appear_on_class_elements_of_this_kind,"declare");if(r.kind===169)return Or(Ne,v._0_modifier_cannot_appear_on_a_parameter,"declare");if(h===4)return Or(Ne,v._0_modifier_cannot_appear_on_a_using_declaration,"declare");if(h===6)return Or(Ne,v._0_modifier_cannot_appear_on_an_await_using_declaration,"declare");if(r.parent.flags&33554432&&r.parent.kind===268)return Or(Ne,v.A_declare_modifier_cannot_be_used_in_an_already_ambient_context);if(j_(r))return Or(Ne,v._0_modifier_cannot_be_used_with_a_private_identifier,"declare");if(X&512)return Or(Ne,v._0_modifier_cannot_be_used_with_1_modifier,"declare","accessor");X|=128,C=Ne;break;case 128:if(X&64)return Or(Ne,v._0_modifier_already_seen,"abstract");if(r.kind!==263&&r.kind!==185){if(r.kind!==174&&r.kind!==172&&r.kind!==177&&r.kind!==178)return Or(Ne,v.abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration);if(!(r.parent.kind===263&&li(r.parent,64))){let Mt=r.kind===172?v.Abstract_properties_can_only_appear_within_an_abstract_class:v.Abstract_methods_can_only_appear_within_an_abstract_class;return Or(Ne,Mt)}if(X&256)return Or(Ne,v._0_modifier_cannot_be_used_with_1_modifier,"static","abstract");if(X&2)return Or(Ne,v._0_modifier_cannot_be_used_with_1_modifier,"private","abstract");if(X&1024&&I)return Or(I,v._0_modifier_cannot_be_used_with_1_modifier,"async","abstract");if(X&16)return Or(Ne,v._0_modifier_must_precede_1_modifier,"abstract","override");if(X&512)return Or(Ne,v._0_modifier_must_precede_1_modifier,"abstract","accessor")}if(Wu(r)&&r.name.kind===81)return Or(Ne,v._0_modifier_cannot_be_used_with_a_private_identifier,"abstract");X|=64;break;case 134:if(X&1024)return Or(Ne,v._0_modifier_already_seen,"async");if(X&128||r.parent.flags&33554432)return Or(Ne,v._0_modifier_cannot_be_used_in_an_ambient_context,"async");if(r.kind===169)return Or(Ne,v._0_modifier_cannot_appear_on_a_parameter,"async");if(X&64)return Or(Ne,v._0_modifier_cannot_be_used_with_1_modifier,"async","abstract");X|=1024,I=Ne;break;case 103:case 147:{let Mt=Ne.kind===103?8192:16384,mr=Ne.kind===103?"in":"out",br=sm(r.parent)&&(_b(r.parent)||Ln((a=QP(r.parent))==null?void 0:a.tags,p2))||r.parent;if(r.kind!==168||br&&!(Yu(br)||gi(br)||im(br)||p2(br)))return Or(Ne,v._0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias,mr);if(X&Mt)return Or(Ne,v._0_modifier_already_seen,mr);if(Mt&8192&&X&16384)return Or(Ne,v._0_modifier_must_precede_1_modifier,"in","out");X|=Mt;break}}}return r.kind===176?X&256?Or(T,v._0_modifier_cannot_appear_on_a_constructor_declaration,"static"):X&16?Or(V,v._0_modifier_cannot_appear_on_a_constructor_declaration,"override"):X&1024?Or(I,v._0_modifier_cannot_appear_on_a_constructor_declaration,"async"):!1:(r.kind===272||r.kind===271)&&X&128?Or(C,v.A_0_modifier_cannot_be_used_with_an_import_declaration,"declare"):r.kind===169&&X&31&&Hs(r.name)?Or(r,v.A_parameter_property_may_not_be_declared_using_a_binding_pattern):r.kind===169&&X&31&&r.dotDotDotToken?Or(r,v.A_parameter_property_cannot_be_declared_using_a_rest_parameter):X&1024?MJt(r,I):!1}function wJt(r){if(!r.modifiers)return!1;let a=IJt(r);return a&&ju(a,v.Modifiers_cannot_appear_here)}function Nne(r,a){let _=Ln(r.modifiers,Pa);return _&&_.kind!==a?_:void 0}function IJt(r){switch(r.kind){case 177:case 178:case 176:case 172:case 171:case 174:case 173:case 181:case 267:case 272:case 271:case 278:case 277:case 218:case 219:case 169:case 168:return;case 175:case 303:case 304:case 270:case 282:return Ln(r.modifiers,Pa);default:if(r.parent.kind===268||r.parent.kind===307)return;switch(r.kind){case 262:return Nne(r,134);case 263:case 185:return Nne(r,128);case 231:case 264:case 265:return Ln(r.modifiers,Pa);case 243:return r.declarationList.flags&4?Nne(r,135):Ln(r.modifiers,Pa);case 266:return Nne(r,87);default:M.assertNever(r)}}}function OJt(r){let a=RJt(r);return a&&ju(a,v.Decorators_are_not_valid_here)}function RJt(r){return EY(r)?Ln(r.modifiers,fu):void 0}function MJt(r,a){switch(r.kind){case 174:case 262:case 218:case 219:return!1}return Or(a,v._0_modifier_cannot_be_used_here,"async")}function rP(r,a=v.Trailing_comma_not_allowed){return r&&r.hasTrailingComma?fx(r[0],r.end-1,1,a):!1}function YKe(r,a){if(r&&r.length===0){let _=r.pos-1,h=Ja(a.text,r.end)+1;return fx(a,_,h-_,v.Type_parameter_list_cannot_be_empty)}return!1}function LJt(r){let a=!1,_=r.length;for(let h=0;h<_;h++){let T=r[h];if(T.dotDotDotToken){if(h!==_-1)return Or(T.dotDotDotToken,v.A_rest_parameter_must_be_last_in_a_parameter_list);if(T.flags&33554432||rP(r,v.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma),T.questionToken)return Or(T.questionToken,v.A_rest_parameter_cannot_be_optional);if(T.initializer)return Or(T.name,v.A_rest_parameter_cannot_have_an_initializer)}else if(rxe(T)){if(a=!0,T.questionToken&&T.initializer)return Or(T.name,v.Parameter_cannot_have_question_mark_and_initializer)}else if(a&&!T.initializer)return Or(T.name,v.A_required_parameter_cannot_follow_an_optional_parameter)}}function FJt(r){return Zn(r,a=>!!a.initializer||Hs(a.name)||Fh(a))}function jJt(r){if(ee>=3){let a=r.body&&Vs(r.body)&&vY(r.body.statements);if(a){let _=FJt(r.parameters);if(wt(_)){kt(_,T=>{ca(Qe(T,v.This_parameter_is_not_allowed_with_use_strict_directive),pn(a,v.use_strict_directive_used_here))});let h=_.map((T,C)=>C===0?pn(T,v.Non_simple_parameter_declared_here):pn(T,v.and_here));return ca(Qe(a,v.use_strict_directive_cannot_be_used_with_non_simple_parameter_list),...h),!0}}}return!1}function Dne(r){let a=Ur(r);return Xy(r)||YKe(r.typeParameters,a)||LJt(r.parameters)||UJt(r,a)||Go(r)&&jJt(r)}function BJt(r){let a=Ur(r);return WJt(r)||YKe(r.typeParameters,a)}function UJt(r,a){if(!pc(r))return!1;r.typeParameters&&!(wt(r.typeParameters)>1||r.typeParameters.hasTrailingComma||r.typeParameters[0].constraint)&&a&&wl(a.fileName,[".mts",".cts"])&&Or(r.typeParameters[0],v.This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_constraint);let{equalsGreaterThanToken:_}=r,h=ba(a,_.pos).line,T=ba(a,_.end).line;return h!==T&&Or(_,v.Line_terminator_not_permitted_before_arrow)}function VJt(r){let a=r.parameters[0];if(r.parameters.length!==1)return Or(a?a.name:r,v.An_index_signature_must_have_exactly_one_parameter);if(rP(r.parameters,v.An_index_signature_cannot_have_a_trailing_comma),a.dotDotDotToken)return Or(a.dotDotDotToken,v.An_index_signature_cannot_have_a_rest_parameter);if(YH(a))return Or(a.name,v.An_index_signature_parameter_cannot_have_an_accessibility_modifier);if(a.questionToken)return Or(a.questionToken,v.An_index_signature_parameter_cannot_have_a_question_mark);if(a.initializer)return Or(a.name,v.An_index_signature_parameter_cannot_have_an_initializer);if(!a.type)return Or(a.name,v.An_index_signature_parameter_must_have_a_type_annotation);let _=Wi(a.type);return ym(_,h=>!!(h.flags&8576))||Wk(_)?Or(a.name,v.An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead):Zf(_,qte)?r.type?!1:Or(r,v.An_index_signature_must_have_a_type_annotation):Or(a.name,v.An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type)}function JJt(r){return Xy(r)||VJt(r)}function qJt(r,a){if(a&&a.length===0){let _=Ur(r),h=a.pos-1,T=Ja(_.text,a.end)+1;return fx(_,h,T-h,v.Type_argument_list_cannot_be_empty)}return!1}function Iq(r,a){return rP(a)||qJt(r,a)}function zJt(r){return r.questionDotToken||r.flags&64?Or(r.template,v.Tagged_template_expressions_are_not_permitted_in_an_optional_chain):!1}function KKe(r){let a=r.types;if(rP(a))return!0;if(a&&a.length===0){let _=Sa(r.token);return fx(r,a.pos,0,v._0_list_cannot_be_empty,_)}return Pt(a,XKe)}function XKe(r){return x0(r)&&xO(r.expression)&&r.typeArguments?Or(r,v.This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments):Iq(r,r.typeArguments)}function WJt(r){let a=!1,_=!1;if(!Xy(r)&&r.heritageClauses)for(let h of r.heritageClauses){if(h.token===96){if(a)return ju(h,v.extends_clause_already_seen);if(_)return ju(h,v.extends_clause_must_precede_implements_clause);if(h.types.length>1)return ju(h.types[1],v.Classes_can_only_extend_a_single_class);a=!0}else{if(M.assert(h.token===119),_)return ju(h,v.implements_clause_already_seen);_=!0}KKe(h)}}function $Jt(r){let a=!1;if(r.heritageClauses)for(let _ of r.heritageClauses){if(_.token===96){if(a)return ju(_,v.extends_clause_already_seen);a=!0}else return M.assert(_.token===119),ju(_,v.Interface_declaration_cannot_have_implements_clause);KKe(_)}return!1}function wne(r){if(r.kind!==167)return!1;let a=r;return a.expression.kind===226&&a.expression.operatorToken.kind===28?Or(a.expression,v.A_comma_expression_is_not_allowed_in_a_computed_property_name):!1}function sAe(r){if(r.asteriskToken){if(M.assert(r.kind===262||r.kind===218||r.kind===174),r.flags&33554432)return Or(r.asteriskToken,v.Generators_are_not_allowed_in_an_ambient_context);if(!r.body)return Or(r.asteriskToken,v.An_overload_signature_cannot_be_declared_as_a_generator)}}function aAe(r,a){return!!r&&Or(r,a)}function QKe(r,a){return!!r&&Or(r,a)}function HJt(r,a){let _=new Map;for(let h of r.properties){if(h.kind===305){if(a){let I=So(h.expression);if(Gu(I)||Ca(I))return Or(h.expression,v.A_rest_element_cannot_contain_a_binding_pattern)}continue}let T=h.name;if(T.kind===167&&wne(T),h.kind===304&&!a&&h.objectAssignmentInitializer&&Or(h.equalsToken,v.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern),T.kind===81&&Or(T,v.Private_identifiers_are_not_allowed_outside_class_bodies),wm(h)&&h.modifiers)for(let I of h.modifiers)Pa(I)&&(I.kind!==134||h.kind!==174)&&Or(I,v._0_modifier_cannot_be_used_here,Hc(I));else if(mme(h)&&h.modifiers)for(let I of h.modifiers)Pa(I)&&Or(I,v._0_modifier_cannot_be_used_here,Hc(I));let C;switch(h.kind){case 304:case 303:QKe(h.exclamationToken,v.A_definite_assignment_assertion_is_not_permitted_in_this_context),aAe(h.questionToken,v.An_object_member_cannot_be_declared_optional),T.kind===9&&aXe(T),C=4;break;case 174:C=8;break;case 177:C=1;break;case 178:C=2;break;default:M.assertNever(h,"Unexpected syntax kind:"+h.kind)}if(!a){let I=lAe(T);if(I===void 0)continue;let V=_.get(I);if(!V)_.set(I,C);else if(C&8&&V&8)Or(T,v.Duplicate_identifier_0,Hc(T));else if(C&4&&V&4)Or(T,v.An_object_literal_cannot_have_multiple_properties_with_the_same_name,Hc(T));else if(C&3&&V&3)if(V!==3&&C!==V)_.set(I,C|V);else return Or(T,v.An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name);else return Or(T,v.An_object_literal_cannot_have_property_and_accessor_with_the_same_name)}}}function GJt(r){YJt(r.tagName),Iq(r,r.typeArguments);let a=new Map;for(let _ of r.attributes.properties){if(_.kind===293)continue;let{name:h,initializer:T}=_,C=gO(h);if(!a.get(C))a.set(C,!0);else return Or(h,v.JSX_elements_cannot_have_multiple_attributes_with_the_same_name);if(T&&T.kind===294&&!T.expression)return Or(T,v.JSX_attributes_must_only_be_assigned_a_non_empty_expression)}}function YJt(r){if(Wn(r)&&sg(r.expression))return Or(r.expression,v.JSX_property_access_expressions_cannot_include_JSX_namespace_names);if(sg(r)&&X9(q)&&!nN(r.namespace.escapedText))return Or(r,v.React_components_cannot_include_JSX_namespace_names)}function KJt(r){if(r.expression&&LO(r.expression))return Or(r.expression,v.JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array)}function ZKe(r){if(sv(r))return!0;if(r.kind===250&&r.awaitModifier&&!(r.flags&65536)){let a=Ur(r);if(a9(r)){if(!BS(a))switch(ZC(a,q)||_o.add(pn(r.awaitModifier,v.for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module)),W){case 100:case 199:if(a.impliedNodeFormat===1){_o.add(pn(r.awaitModifier,v.The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level));break}case 7:case 99:case 4:if(ee>=4)break;default:_o.add(pn(r.awaitModifier,v.Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher));break}}else if(!BS(a)){let _=pn(r.awaitModifier,v.for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules),h=Dp(r);if(h&&h.kind!==176){M.assert((Rl(h)&2)===0,"Enclosing function should never be an async function.");let T=pn(h,v.Did_you_mean_to_mark_this_function_as_async);ca(_,T)}return _o.add(_),!0}}if(f8(r)&&!(r.flags&65536)&&He(r.initializer)&&r.initializer.escapedText==="async")return Or(r.initializer,v.The_left_hand_side_of_a_for_of_statement_may_not_be_async),!1;if(r.initializer.kind===261){let a=r.initializer;if(!cAe(a)){let _=a.declarations;if(!_.length)return!1;if(_.length>1){let T=r.kind===249?v.Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement:v.Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement;return ju(a.declarations[1],T)}let h=_[0];if(h.initializer){let T=r.kind===249?v.The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer:v.The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer;return Or(h.name,T)}if(h.type){let T=r.kind===249?v.The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation:v.The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation;return Or(h,T)}}}return!1}function XJt(r){if(!(r.flags&33554432)&&r.parent.kind!==187&&r.parent.kind!==264){if(ee<2&&Zi(r.name))return Or(r.name,v.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);if(r.body===void 0&&!li(r,64))return fx(r,r.end-1,1,v._0_expected,"{")}if(r.body){if(li(r,64))return Or(r,v.An_abstract_accessor_cannot_have_an_implementation);if(r.parent.kind===187||r.parent.kind===264)return Or(r.body,v.An_implementation_cannot_be_declared_in_ambient_contexts)}if(r.typeParameters)return Or(r.name,v.An_accessor_cannot_have_type_parameters);if(!QJt(r))return Or(r.name,r.kind===177?v.A_get_accessor_cannot_have_parameters:v.A_set_accessor_must_have_exactly_one_parameter);if(r.kind===178){if(r.type)return Or(r.name,v.A_set_accessor_cannot_have_a_return_type_annotation);let a=M.checkDefined(aN(r),"Return value does not match parameter count assertion.");if(a.dotDotDotToken)return Or(a.dotDotDotToken,v.A_set_accessor_cannot_have_rest_parameter);if(a.questionToken)return Or(a.questionToken,v.A_set_accessor_cannot_have_an_optional_parameter);if(a.initializer)return Or(r.name,v.A_set_accessor_parameter_cannot_have_an_initializer)}return!1}function QJt(r){return oAe(r)||r.parameters.length===(r.kind===177?0:1)}function oAe(r){if(r.parameters.length===(r.kind===177?1:2))return iE(r)}function ZJt(r){if(r.operator===158){if(r.type.kind!==155)return Or(r.type,v._0_expected,Sa(155));let a=AR(r.parent);if(hn(a)&&Tb(a)){let _=tE(a);_&&(a=cA(_)||_)}switch(a.kind){case 260:let _=a;if(_.name.kind!==80)return Or(r,v.unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name);if(!NI(_))return Or(r,v.unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement);if(!(_.parent.flags&2))return Or(a.name,v.A_variable_whose_type_is_a_unique_symbol_type_must_be_const);break;case 172:if(!oa(a)||!HI(a))return Or(a.name,v.A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly);break;case 171:if(!li(a,8))return Or(a.name,v.A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly);break;default:return Or(r,v.unique_symbol_types_are_not_allowed_here)}}else if(r.operator===148&&r.type.kind!==188&&r.type.kind!==189)return ju(r,v.readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types,Sa(155))}function S4(r,a){if(c8t(r))return Or(r,a)}function eXe(r){if(Dne(r))return!0;if(r.kind===174){if(r.parent.kind===210){if(r.modifiers&&!(r.modifiers.length===1&&Ma(r.modifiers).kind===134))return ju(r,v.Modifiers_cannot_appear_here);if(aAe(r.questionToken,v.An_object_member_cannot_be_declared_optional))return!0;if(QKe(r.exclamationToken,v.A_definite_assignment_assertion_is_not_permitted_in_this_context))return!0;if(r.body===void 0)return fx(r,r.end-1,1,v._0_expected,"{")}if(sAe(r))return!0}if(gi(r.parent)){if(ee<2&&Zi(r.name))return Or(r.name,v.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);if(r.flags&33554432)return S4(r.name,v.A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);if(r.kind===174&&!r.body)return S4(r.name,v.A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type)}else{if(r.parent.kind===264)return S4(r.name,v.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);if(r.parent.kind===187)return S4(r.name,v.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type)}}function eqt(r){let a=r;for(;a;){if(LP(a))return Or(r,v.Jump_target_cannot_cross_function_boundary);switch(a.kind){case 256:if(r.label&&a.label.escapedText===r.label.escapedText)return r.kind===251&&!V1(a.statement,!0)?Or(r,v.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement):!1;break;case 255:if(r.kind===252&&!r.label)return!1;break;default:if(V1(a,!1)&&!r.label)return!1;break}a=a.parent}if(r.label){let _=r.kind===252?v.A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement:v.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement;return Or(r,_)}else{let _=r.kind===252?v.A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement:v.A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement;return Or(r,_)}}function tqt(r){if(r.dotDotDotToken){let a=r.parent.elements;if(r!==Va(a))return Or(r,v.A_rest_element_must_be_last_in_a_destructuring_pattern);if(rP(a,v.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma),r.propertyName)return Or(r.name,v.A_rest_element_cannot_have_a_property_name)}if(r.dotDotDotToken&&r.initializer)return fx(r,r.initializer.pos-1,1,v.A_rest_element_cannot_have_an_initializer)}function tXe(r){return zp(r)||r.kind===224&&r.operator===41&&r.operand.kind===9}function rqt(r){return r.kind===10||r.kind===224&&r.operator===41&&r.operand.kind===10}function nqt(r){if((Wn(r)||cc(r)&&tXe(r.argumentExpression))&&nc(r.expression))return!!(yl(r).flags&1056)}function rXe(r){let a=r.initializer;if(a){let _=!(tXe(a)||nqt(a)||a.kind===112||a.kind===97||rqt(a));if((eR(r)||Ei(r)&&_L(r))&&!r.type){if(_)return Or(a,v.A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference)}else return Or(a,v.Initializers_are_not_allowed_in_ambient_contexts)}}function iqt(r){let a=px(r),_=a&7;if(Hs(r.name))switch(_){case 6:return Or(r,v._0_declarations_may_not_have_binding_patterns,"await using");case 4:return Or(r,v._0_declarations_may_not_have_binding_patterns,"using")}if(r.parent.parent.kind!==249&&r.parent.parent.kind!==250){if(a&33554432)rXe(r);else if(!r.initializer){if(Hs(r.name)&&!Hs(r.parent))return Or(r,v.A_destructuring_declaration_must_have_an_initializer);switch(_){case 6:return Or(r,v._0_declarations_must_be_initialized,"await using");case 4:return Or(r,v._0_declarations_must_be_initialized,"using");case 2:return Or(r,v._0_declarations_must_be_initialized,"const")}}}if(r.exclamationToken&&(r.parent.parent.kind!==243||!r.type||r.initializer||a&33554432)){let h=r.initializer?v.Declarations_with_initializers_cannot_also_have_definite_assignment_assertions:r.type?v.A_definite_assignment_assertion_is_not_permitted_in_this_context:v.Declarations_with_definite_assignment_assertions_must_also_have_type_annotations;return Or(r.exclamationToken,h)}return(W<5||Ur(r).impliedNodeFormat===1)&&W!==4&&!(r.parent.parent.flags&33554432)&&li(r.parent.parent,32)&&nXe(r.name),!!_&&iXe(r.name)}function nXe(r){if(r.kind===80){if(Nn(r)==="__esModule")return oqt("noEmit",r,v.Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules)}else{let a=r.elements;for(let _ of a)if(!pu(_))return nXe(_.name)}return!1}function iXe(r){if(r.kind===80){if(r.escapedText==="let")return Or(r,v.let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations)}else{let a=r.elements;for(let _ of a)pu(_)||iXe(_.name)}return!1}function cAe(r){let a=r.declarations;if(rP(r.declarations))return!0;if(!r.declarations.length)return fx(r,a.pos,a.end-a.pos,v.Variable_declaration_list_cannot_be_empty);let _=r.flags&7;return(_===4||_===6)&&Fj(r.parent)?Or(r,_===4?v.The_left_hand_side_of_a_for_in_statement_cannot_be_a_using_declaration:v.The_left_hand_side_of_a_for_in_statement_cannot_be_an_await_using_declaration):_===6?TYe(r):!1}function sXe(r){switch(r.kind){case 245:case 246:case 247:case 254:case 248:case 249:case 250:return!1;case 256:return sXe(r.parent)}return!0}function sqt(r){if(!sXe(r.parent)){let a=px(r.declarationList)&7;if(a){let _=a===1?"let":a===2?"const":a===4?"using":a===6?"await using":M.fail("Unknown BlockScope flag");return Or(r,v._0_declarations_can_only_be_declared_inside_a_block,_)}}}function aqt(r){let a=r.name.escapedText;switch(r.keywordToken){case 105:if(a!=="target")return Or(r.name,v._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2,Qi(r.name.escapedText),Sa(r.keywordToken),"target");break;case 102:if(a!=="meta")return Or(r.name,v._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2,Qi(r.name.escapedText),Sa(r.keywordToken),"meta");break}}function BS(r){return r.parseDiagnostics.length>0}function ju(r,a,..._){let h=Ur(r);if(!BS(h)){let T=Bh(h,r.pos);return _o.add(bu(h,T.start,T.length,a,..._)),!0}return!1}function fx(r,a,_,h,...T){let C=Ur(r);return BS(C)?!1:(_o.add(bu(C,a,_,h,...T)),!0)}function oqt(r,a,_,...h){let T=Ur(a);return BS(T)?!1:(dg(r,a,_,...h),!0)}function Or(r,a,..._){let h=Ur(r);return BS(h)?!1:(_o.add(pn(r,a,..._)),!0)}function cqt(r){let a=hn(r)?w9(r):void 0,_=r.typeParameters||a&&xo(a);if(_){let h=_.pos===_.end?_.pos:Ja(Ur(r).text,_.pos);return fx(r,h,_.end-h,v.Type_parameters_cannot_appear_on_a_constructor_declaration)}}function lqt(r){let a=r.type||lp(r);if(a)return Or(a,v.Type_annotation_cannot_appear_on_a_constructor_declaration)}function uqt(r){if(za(r.name)&&Pn(r.name.expression)&&r.name.expression.operatorToken.kind===103)return Or(r.parent.members[0],v.A_mapped_type_may_not_declare_properties_or_methods);if(gi(r.parent)){if(La(r.name)&&r.name.text==="constructor")return Or(r.name,v.Classes_may_not_have_a_field_named_constructor);if(S4(r.name,v.A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_symbol_type))return!0;if(ee<2&&Zi(r.name))return Or(r.name,v.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);if(ee<2&&Ef(r))return Or(r.name,v.Properties_with_the_accessor_modifier_are_only_available_when_targeting_ECMAScript_2015_and_higher);if(Ef(r)&&aAe(r.questionToken,v.An_accessor_property_cannot_be_declared_optional))return!0}else if(r.parent.kind===264){if(S4(r.name,v.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type))return!0;if(M.assertNode(r,Nf),r.initializer)return Or(r.initializer,v.An_interface_property_cannot_have_an_initializer)}else if(lf(r.parent)){if(S4(r.name,v.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type))return!0;if(M.assertNode(r,Nf),r.initializer)return Or(r.initializer,v.A_type_literal_property_cannot_have_an_initializer)}if(r.flags&33554432&&rXe(r),Ns(r)&&r.exclamationToken&&(!gi(r.parent)||!r.type||r.initializer||r.flags&33554432||oa(r)||oE(r))){let a=r.initializer?v.Declarations_with_initializers_cannot_also_have_definite_assignment_assertions:r.type?v.A_definite_assignment_assertion_is_not_permitted_in_this_context:v.Declarations_with_definite_assignment_assertions_must_also_have_type_annotations;return Or(r.exclamationToken,a)}}function _qt(r){return r.kind===264||r.kind===265||r.kind===272||r.kind===271||r.kind===278||r.kind===277||r.kind===270||li(r,2208)?!1:ju(r,v.Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier)}function fqt(r){for(let a of r.statements)if((u_(a)||a.kind===243)&&_qt(a))return!0;return!1}function pqt(r){return!!(r.flags&33554432)&&fqt(r)}function sv(r){if(r.flags&33554432){if(!qn(r).hasReportedStatementInAmbientContext&&(Bs(r.parent)||U1(r.parent)))return qn(r).hasReportedStatementInAmbientContext=ju(r,v.An_implementation_cannot_be_declared_in_ambient_contexts);if(r.parent.kind===241||r.parent.kind===268||r.parent.kind===307){let _=qn(r.parent);if(!_.hasReportedStatementInAmbientContext)return _.hasReportedStatementInAmbientContext=ju(r,v.Statements_are_not_allowed_in_ambient_contexts)}}return!1}function aXe(r){let a=Hc(r).includes("."),_=r.numericLiteralFlags&16;a||_||+r.text<=2**53-1||Mm(!1,pn(r,v.Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers))}function dqt(r){return!!(!(Mv(r.parent)||tS(r.parent)&&Mv(r.parent.parent))&&ee<7&&Or(r,v.BigInt_literals_are_not_available_when_targeting_lower_than_ES2020))}function mqt(r,a,..._){let h=Ur(r);if(!BS(h)){let T=Bh(h,r.pos);return _o.add(bu(h,bl(T),0,a,..._)),!0}return!1}function gqt(){return hc||(hc=[],De.forEach((r,a)=>{Rge.test(a)&&hc.push(r)})),hc}function hqt(r){var a;return r.isTypeOnly&&r.name&&r.namedBindings?Or(r,v.A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both):r.isTypeOnly&&((a=r.namedBindings)==null?void 0:a.kind)===275?oXe(r.namedBindings):!1}function oXe(r){return!!kt(r.elements,a=>{if(a.isTypeOnly)return ju(a,a.kind===276?v.The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement:v.The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement)})}function yqt(r){if(q.verbatimModuleSyntax&&W===1)return Or(r,v.ESM_syntax_is_not_allowed_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled);if(W===5)return Or(r,v.Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd_system_umd_node16_or_nodenext);if(r.typeArguments)return Or(r,v.This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments);let a=r.arguments;if(W!==99&&W!==199&&W!==100&&(rP(a),a.length>1)){let h=a[1];return Or(h,v.Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nodenext)}if(a.length===0||a.length>2)return Or(r,v.Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_set_of_attributes_as_arguments);let _=Ln(a,Ad);return _?Or(_,v.Argument_of_dynamic_import_cannot_be_spread_element):!1}function vqt(r,a){let _=Kn(r);if(_&20&&a.flags&1048576)return Ln(a.types,h=>{if(h.flags&524288){let T=_&Kn(h);if(T&4)return r.target===h.target;if(T&16)return!!r.aliasSymbol&&r.aliasSymbol===h.aliasSymbol}return!1})}function Sqt(r,a){if(Kn(r)&128&&ym(a,g1))return Ln(a.types,_=>!g1(_))}function bqt(r,a){let _=0;if(Ys(r,_).length>0||(_=1,Ys(r,_).length>0))return Ln(a.types,T=>Ys(T,_).length>0)}function Tqt(r,a){let _;if(!(r.flags&406978556)){let h=0;for(let T of a.types)if(!(T.flags&406978556)){let C=Da([dh(r),dh(T)]);if(C.flags&4194304)return T;if(Tg(C)||C.flags&1048576){let I=C.flags&1048576?vy(C.types,Tg):1;I>=h&&(_=T,h=I)}}}return _}function Eqt(r){if(dl(r,67108864)){let a=Fl(r,_=>!(_.flags&402784252));if(!(a.flags&131072))return a}return r}function cXe(r,a,_){if(a.flags&1048576&&r.flags&2621440){let h=dHe(a,r);if(h)return h;let T=bo(r);if(T){let C=pHe(T,a);if(C){let I=Hxe(a,Cr(C,V=>[()=>gn(V),V.escapedName]),_);if(I!==a)return I}}}}function lAe(r){let a=e2(r);return a||(za(r)?v2e(t_(r.expression)):void 0)}function Ine(r){return rr===r||(rr=r,vr=eb(r)),vr}function px(r){return Xe===r||(Xe=r,ht=f0(r)),ht}function _L(r){let a=px(r)&7;return a===2||a===4||a===6}function xqt(r,a){let _=q.importHelpers?1:0,h=r?.imports[_];return h&&M.assert(Ko(h)&&h.text===a,`Expected sourceFile.imports[${_}] to be the synthesized JSX runtime import`),h}function Cqt(r){M.assert(q.importHelpers,"Expected importHelpers to be enabled");let a=r.imports[0];return M.assert(a&&Ko(a)&&a.text==="tslib","Expected sourceFile.imports[0] to be the synthesized tslib import"),a}}function HTt(e){return!U1(e)}function XRe(e){return e.kind!==262&&e.kind!==174||!!e.body}function QRe(e){switch(e.parent.kind){case 276:case 281:return He(e);default:return Uh(e)}}var Xp;(e=>{e.JSX="JSX",e.IntrinsicElements="IntrinsicElements",e.ElementClass="ElementClass",e.ElementAttributesPropertyNameContainer="ElementAttributesProperty",e.ElementChildrenAttributeNameContainer="ElementChildrenAttribute",e.Element="Element",e.ElementType="ElementType",e.IntrinsicAttributes="IntrinsicAttributes",e.IntrinsicClassAttributes="IntrinsicClassAttributes",e.LibraryManagedAttributes="LibraryManagedAttributes"})(Xp||(Xp={}));function ZRe(e){switch(e){case 0:return"yieldType";case 1:return"returnType";case 2:return"nextType"}}function E_(e){return!!(e.flags&1)}function yK(e){return!!(e.flags&2)}function GTt(e){return{getCommonSourceDirectory:e.getCommonSourceDirectory?()=>e.getCommonSourceDirectory():()=>"",getCurrentDirectory:()=>e.getCurrentDirectory(),getSymlinkCache:ia(e,e.getSymlinkCache),getPackageJsonInfoCache:()=>{var t;return(t=e.getPackageJsonInfoCache)==null?void 0:t.call(e)},useCaseSensitiveFileNames:ia(e,e.useCaseSensitiveFileNames),redirectTargetsMap:e.redirectTargetsMap,getProjectReferenceRedirect:t=>e.getProjectReferenceRedirect(t),isSourceOfProjectReferenceRedirect:t=>e.isSourceOfProjectReferenceRedirect(t),fileExists:t=>e.fileExists(t),getFileIncludeReasons:()=>e.getFileIncludeReasons(),readFile:e.readFile?t=>e.readFile(t):void 0}}var Fge=class Apt{constructor(t,n,i){this.moduleResolverHost=void 0,this.inner=void 0,this.disableTrackSymbol=!1;for(var s;n instanceof Apt;)n=n.inner;this.inner=n,this.moduleResolverHost=i,this.context=t,this.canTrackSymbol=!!((s=this.inner)!=null&&s.trackSymbol)}trackSymbol(t,n,i){var s,o;if((s=this.inner)!=null&&s.trackSymbol&&!this.disableTrackSymbol){if(this.inner.trackSymbol(t,n,i))return this.onDiagnosticReported(),!0;t.flags&262144||((o=this.context).trackedSymbols??(o.trackedSymbols=[])).push([t,n,i])}return!1}reportInaccessibleThisError(){var t;(t=this.inner)!=null&&t.reportInaccessibleThisError&&(this.onDiagnosticReported(),this.inner.reportInaccessibleThisError())}reportPrivateInBaseOfClassExpression(t){var n;(n=this.inner)!=null&&n.reportPrivateInBaseOfClassExpression&&(this.onDiagnosticReported(),this.inner.reportPrivateInBaseOfClassExpression(t))}reportInaccessibleUniqueSymbolError(){var t;(t=this.inner)!=null&&t.reportInaccessibleUniqueSymbolError&&(this.onDiagnosticReported(),this.inner.reportInaccessibleUniqueSymbolError())}reportCyclicStructureError(){var t;(t=this.inner)!=null&&t.reportCyclicStructureError&&(this.onDiagnosticReported(),this.inner.reportCyclicStructureError())}reportLikelyUnsafeImportRequiredError(t){var n;(n=this.inner)!=null&&n.reportLikelyUnsafeImportRequiredError&&(this.onDiagnosticReported(),this.inner.reportLikelyUnsafeImportRequiredError(t))}reportTruncationError(){var t;(t=this.inner)!=null&&t.reportTruncationError&&(this.onDiagnosticReported(),this.inner.reportTruncationError())}reportNonlocalAugmentation(t,n,i){var s;(s=this.inner)!=null&&s.reportNonlocalAugmentation&&(this.onDiagnosticReported(),this.inner.reportNonlocalAugmentation(t,n,i))}reportNonSerializableProperty(t){var n;(n=this.inner)!=null&&n.reportNonSerializableProperty&&(this.onDiagnosticReported(),this.inner.reportNonSerializableProperty(t))}onDiagnosticReported(){this.context.reportedDiagnostic=!0}reportInferenceFallback(t){var n;(n=this.inner)!=null&&n.reportInferenceFallback&&this.inner.reportInferenceFallback(t)}};function ot(e,t,n,i){if(e===void 0)return e;let s=t(e),o;if(s!==void 0)return Rs(s)?o=(i||eEt)(s):o=s,M.assertNode(o,n),o}function Kr(e,t,n,i,s){if(e===void 0)return e;let o=e.length;(i===void 0||i<0)&&(i=0),(s===void 0||s>o-i)&&(s=o-i);let u,m=-1,d=-1;i>0||s<o?u=e.hasTrailingComma&&i+s===o:(m=e.pos,d=e.end,u=e.hasTrailingComma);let S=e8e(e,t,n,i,s);if(S!==e){let E=U.createNodeArray(S,u);return qg(E,m,d),E}return e}function F8(e,t,n,i,s){if(e===void 0)return e;let o=e.length;return(i===void 0||i<0)&&(i=0),(s===void 0||s>o-i)&&(s=o-i),e8e(e,t,n,i,s)}function e8e(e,t,n,i,s){let o,u=e.length;(i>0||s<u)&&(o=[]);for(let m=0;m<s;m++){let d=e[m+i],S=d!==void 0?t?t(d):d:void 0;if((o!==void 0||S===void 0||S!==d)&&(o===void 0&&(o=e.slice(0,m),M.assertEachNode(o,n)),S))if(Rs(S))for(let E of S)M.assertNode(E,n),o.push(E);else M.assertNode(S,n),o.push(S)}return o||(M.assertEachNode(e,n),e)}function vK(e,t,n,i,s,o=Kr){return n.startLexicalEnvironment(),e=o(e,t,Vi,i),s&&(e=n.factory.ensureUseStrict(e)),U.mergeLexicalEnvironment(e,n.endLexicalEnvironment())}function Kc(e,t,n,i=Kr){let s;return n.startLexicalEnvironment(),e&&(n.setLexicalEnvironmentFlags(1,!0),s=i(e,t,ns),n.getLexicalEnvironmentFlags()&2&&Ka(n.getCompilerOptions())>=2&&(s=YTt(s,n)),n.setLexicalEnvironmentFlags(1,!1)),n.suspendLexicalEnvironment(),s}function YTt(e,t){let n;for(let i=0;i<e.length;i++){let s=e[i],o=KTt(s,t);(n||o!==s)&&(n||(n=e.slice(0,i)),n[i]=o)}return n?Et(t.factory.createNodeArray(n,e.hasTrailingComma),e):e}function KTt(e,t){return e.dotDotDotToken?e:Hs(e.name)?XTt(e,t):e.initializer?QTt(e,e.name,e.initializer,t):e}function XTt(e,t){let{factory:n}=t;return t.addInitializationStatement(n.createVariableStatement(void 0,n.createVariableDeclarationList([n.createVariableDeclaration(e.name,void 0,e.type,e.initializer?n.createConditionalExpression(n.createStrictEquality(n.getGeneratedNameForNode(e),n.createVoidZero()),void 0,e.initializer,void 0,n.getGeneratedNameForNode(e)):n.getGeneratedNameForNode(e))]))),n.updateParameterDeclaration(e,e.modifiers,e.dotDotDotToken,n.getGeneratedNameForNode(e),e.questionToken,e.type,void 0)}function QTt(e,t,n,i){let s=i.factory;return i.addInitializationStatement(s.createIfStatement(s.createTypeCheck(s.cloneNode(t),"undefined"),Tn(Et(s.createBlock([s.createExpressionStatement(Tn(Et(s.createAssignment(Tn(s.cloneNode(t),96),Tn(n,96|Ga(n)|3072)),e),3072))]),e),3905))),s.updateParameterDeclaration(e,e.modifiers,e.dotDotDotToken,e.name,e.questionToken,e.type,void 0)}function Qp(e,t,n,i=ot){n.resumeLexicalEnvironment();let s=i(e,t,O5),o=n.endLexicalEnvironment();if(Pt(o)){if(!s)return n.factory.createBlock(o);let u=n.factory.converters.convertToFunctionBlock(s),m=U.mergeLexicalEnvironment(u.statements,o);return n.factory.updateBlock(u,m)}return s}function ff(e,t,n,i=ot){n.startBlockScope();let s=i(e,t,Vi,n.factory.liftToBlock);M.assert(s);let o=n.endBlockScope();return Pt(o)?Vs(s)?(o.push(...s.statements),n.factory.updateBlock(s,o)):(o.push(s),n.factory.createBlock(o)):s}function j8(e,t,n=t){if(n===t||e.length<=1)return Kr(e,t,Ct);let i=0,s=e.length;return Kr(e,o=>{let u=i<s-1;return i++,u?n(o):t(o)},Ct)}function Mr(e,t,n=z8,i=Kr,s,o=ot){if(e===void 0)return;let u=ZTt[e.kind];return u===void 0?e:u(e,t,n,i,o,s)}var ZTt={166:function(t,n,i,s,o,u){return i.factory.updateQualifiedName(t,M.checkDefined(o(t.left,n,Tf)),M.checkDefined(o(t.right,n,He)))},167:function(t,n,i,s,o,u){return i.factory.updateComputedPropertyName(t,M.checkDefined(o(t.expression,n,Ct)))},168:function(t,n,i,s,o,u){return i.factory.updateTypeParameterDeclaration(t,s(t.modifiers,n,Pa),M.checkDefined(o(t.name,n,He)),o(t.constraint,n,Di),o(t.default,n,Di))},169:function(t,n,i,s,o,u){return i.factory.updateParameterDeclaration(t,s(t.modifiers,n,Cc),u?o(t.dotDotDotToken,u,Pj):t.dotDotDotToken,M.checkDefined(o(t.name,n,Wx)),u?o(t.questionToken,u,Q1):t.questionToken,o(t.type,n,Di),o(t.initializer,n,Ct))},170:function(t,n,i,s,o,u){return i.factory.updateDecorator(t,M.checkDefined(o(t.expression,n,Ct)))},171:function(t,n,i,s,o,u){return i.factory.updatePropertySignature(t,s(t.modifiers,n,Pa),M.checkDefined(o(t.name,n,Ol)),u?o(t.questionToken,u,Q1):t.questionToken,o(t.type,n,Di))},172:function(t,n,i,s,o,u){return i.factory.updatePropertyDeclaration(t,s(t.modifiers,n,Cc),M.checkDefined(o(t.name,n,Ol)),u?o(t.questionToken??t.exclamationToken,u,gme):t.questionToken??t.exclamationToken,o(t.type,n,Di),o(t.initializer,n,Ct))},173:function(t,n,i,s,o,u){return i.factory.updateMethodSignature(t,s(t.modifiers,n,Pa),M.checkDefined(o(t.name,n,Ol)),u?o(t.questionToken,u,Q1):t.questionToken,s(t.typeParameters,n,Ac),s(t.parameters,n,ns),o(t.type,n,Di))},174:function(t,n,i,s,o,u){return i.factory.updateMethodDeclaration(t,s(t.modifiers,n,Cc),u?o(t.asteriskToken,u,c8):t.asteriskToken,M.checkDefined(o(t.name,n,Ol)),u?o(t.questionToken,u,Q1):t.questionToken,s(t.typeParameters,n,Ac),Kc(t.parameters,n,i,s),o(t.type,n,Di),Qp(t.body,n,i,o))},176:function(t,n,i,s,o,u){return i.factory.updateConstructorDeclaration(t,s(t.modifiers,n,Cc),Kc(t.parameters,n,i,s),Qp(t.body,n,i,o))},177:function(t,n,i,s,o,u){return i.factory.updateGetAccessorDeclaration(t,s(t.modifiers,n,Cc),M.checkDefined(o(t.name,n,Ol)),Kc(t.parameters,n,i,s),o(t.type,n,Di),Qp(t.body,n,i,o))},178:function(t,n,i,s,o,u){return i.factory.updateSetAccessorDeclaration(t,s(t.modifiers,n,Cc),M.checkDefined(o(t.name,n,Ol)),Kc(t.parameters,n,i,s),Qp(t.body,n,i,o))},175:function(t,n,i,s,o,u){return i.startLexicalEnvironment(),i.suspendLexicalEnvironment(),i.factory.updateClassStaticBlockDeclaration(t,Qp(t.body,n,i,o))},179:function(t,n,i,s,o,u){return i.factory.updateCallSignature(t,s(t.typeParameters,n,Ac),s(t.parameters,n,ns),o(t.type,n,Di))},180:function(t,n,i,s,o,u){return i.factory.updateConstructSignature(t,s(t.typeParameters,n,Ac),s(t.parameters,n,ns),o(t.type,n,Di))},181:function(t,n,i,s,o,u){return i.factory.updateIndexSignature(t,s(t.modifiers,n,Cc),s(t.parameters,n,ns),M.checkDefined(o(t.type,n,Di)))},182:function(t,n,i,s,o,u){return i.factory.updateTypePredicateNode(t,o(t.assertsModifier,n,Fde),M.checkDefined(o(t.parameterName,n,hme)),o(t.type,n,Di))},183:function(t,n,i,s,o,u){return i.factory.updateTypeReferenceNode(t,M.checkDefined(o(t.typeName,n,Tf)),s(t.typeArguments,n,Di))},184:function(t,n,i,s,o,u){return i.factory.updateFunctionTypeNode(t,s(t.typeParameters,n,Ac),s(t.parameters,n,ns),M.checkDefined(o(t.type,n,Di)))},185:function(t,n,i,s,o,u){return i.factory.updateConstructorTypeNode(t,s(t.modifiers,n,Pa),s(t.typeParameters,n,Ac),s(t.parameters,n,ns),M.checkDefined(o(t.type,n,Di)))},186:function(t,n,i,s,o,u){return i.factory.updateTypeQueryNode(t,M.checkDefined(o(t.exprName,n,Tf)),s(t.typeArguments,n,Di))},187:function(t,n,i,s,o,u){return i.factory.updateTypeLiteralNode(t,s(t.members,n,$T))},188:function(t,n,i,s,o,u){return i.factory.updateArrayTypeNode(t,M.checkDefined(o(t.elementType,n,Di)))},189:function(t,n,i,s,o,u){return i.factory.updateTupleTypeNode(t,s(t.elements,n,Di))},190:function(t,n,i,s,o,u){return i.factory.updateOptionalTypeNode(t,M.checkDefined(o(t.type,n,Di)))},191:function(t,n,i,s,o,u){return i.factory.updateRestTypeNode(t,M.checkDefined(o(t.type,n,Di)))},192:function(t,n,i,s,o,u){return i.factory.updateUnionTypeNode(t,s(t.types,n,Di))},193:function(t,n,i,s,o,u){return i.factory.updateIntersectionTypeNode(t,s(t.types,n,Di))},194:function(t,n,i,s,o,u){return i.factory.updateConditionalTypeNode(t,M.checkDefined(o(t.checkType,n,Di)),M.checkDefined(o(t.extendsType,n,Di)),M.checkDefined(o(t.trueType,n,Di)),M.checkDefined(o(t.falseType,n,Di)))},195:function(t,n,i,s,o,u){return i.factory.updateInferTypeNode(t,M.checkDefined(o(t.typeParameter,n,Ac)))},205:function(t,n,i,s,o,u){return i.factory.updateImportTypeNode(t,M.checkDefined(o(t.argument,n,Di)),o(t.attributes,n,l2),o(t.qualifier,n,Tf),s(t.typeArguments,n,Di),t.isTypeOf)},302:function(t,n,i,s,o,u){return i.factory.updateImportTypeAssertionContainer(t,M.checkDefined(o(t.assertClause,n,Hde)),t.multiLine)},202:function(t,n,i,s,o,u){return i.factory.updateNamedTupleMember(t,u?o(t.dotDotDotToken,u,Pj):t.dotDotDotToken,M.checkDefined(o(t.name,n,He)),u?o(t.questionToken,u,Q1):t.questionToken,M.checkDefined(o(t.type,n,Di)))},196:function(t,n,i,s,o,u){return i.factory.updateParenthesizedType(t,M.checkDefined(o(t.type,n,Di)))},198:function(t,n,i,s,o,u){return i.factory.updateTypeOperatorNode(t,M.checkDefined(o(t.type,n,Di)))},199:function(t,n,i,s,o,u){return i.factory.updateIndexedAccessTypeNode(t,M.checkDefined(o(t.objectType,n,Di)),M.checkDefined(o(t.indexType,n,Di)))},200:function(t,n,i,s,o,u){return i.factory.updateMappedTypeNode(t,u?o(t.readonlyToken,u,yme):t.readonlyToken,M.checkDefined(o(t.typeParameter,n,Ac)),o(t.nameType,n,Di),u?o(t.questionToken,u,vme):t.questionToken,o(t.type,n,Di),s(t.members,n,$T))},201:function(t,n,i,s,o,u){return i.factory.updateLiteralTypeNode(t,M.checkDefined(o(t.literal,n,a_e)))},203:function(t,n,i,s,o,u){return i.factory.updateTemplateLiteralType(t,M.checkDefined(o(t.head,n,IA)),s(t.templateSpans,n,QG))},204:function(t,n,i,s,o,u){return i.factory.updateTemplateLiteralTypeSpan(t,M.checkDefined(o(t.type,n,Di)),M.checkDefined(o(t.literal,n,N5)))},206:function(t,n,i,s,o,u){return i.factory.updateObjectBindingPattern(t,s(t.elements,n,Xa))},207:function(t,n,i,s,o,u){return i.factory.updateArrayBindingPattern(t,s(t.elements,n,w5))},208:function(t,n,i,s,o,u){return i.factory.updateBindingElement(t,u?o(t.dotDotDotToken,u,Pj):t.dotDotDotToken,o(t.propertyName,n,Ol),M.checkDefined(o(t.name,n,Wx)),o(t.initializer,n,Ct))},209:function(t,n,i,s,o,u){return i.factory.updateArrayLiteralExpression(t,s(t.elements,n,Ct))},210:function(t,n,i,s,o,u){return i.factory.updateObjectLiteralExpression(t,s(t.properties,n,p0))},211:function(t,n,i,s,o,u){return A5(t)?i.factory.updatePropertyAccessChain(t,M.checkDefined(o(t.expression,n,Ct)),u?o(t.questionDotToken,u,Nj):t.questionDotToken,M.checkDefined(o(t.name,n,Cy))):i.factory.updatePropertyAccessExpression(t,M.checkDefined(o(t.expression,n,Ct)),M.checkDefined(o(t.name,n,Cy)))},212:function(t,n,i,s,o,u){return O$(t)?i.factory.updateElementAccessChain(t,M.checkDefined(o(t.expression,n,Ct)),u?o(t.questionDotToken,u,Nj):t.questionDotToken,M.checkDefined(o(t.argumentExpression,n,Ct))):i.factory.updateElementAccessExpression(t,M.checkDefined(o(t.expression,n,Ct)),M.checkDefined(o(t.argumentExpression,n,Ct)))},213:function(t,n,i,s,o,u){return qx(t)?i.factory.updateCallChain(t,M.checkDefined(o(t.expression,n,Ct)),u?o(t.questionDotToken,u,Nj):t.questionDotToken,s(t.typeArguments,n,Di),s(t.arguments,n,Ct)):i.factory.updateCallExpression(t,M.checkDefined(o(t.expression,n,Ct)),s(t.typeArguments,n,Di),s(t.arguments,n,Ct))},214:function(t,n,i,s,o,u){return i.factory.updateNewExpression(t,M.checkDefined(o(t.expression,n,Ct)),s(t.typeArguments,n,Di),s(t.arguments,n,Ct))},215:function(t,n,i,s,o,u){return i.factory.updateTaggedTemplateExpression(t,M.checkDefined(o(t.tag,n,Ct)),s(t.typeArguments,n,Di),M.checkDefined(o(t.template,n,XC)))},216:function(t,n,i,s,o,u){return i.factory.updateTypeAssertion(t,M.checkDefined(o(t.type,n,Di)),M.checkDefined(o(t.expression,n,Ct)))},217:function(t,n,i,s,o,u){return i.factory.updateParenthesizedExpression(t,M.checkDefined(o(t.expression,n,Ct)))},218:function(t,n,i,s,o,u){return i.factory.updateFunctionExpression(t,s(t.modifiers,n,Pa),u?o(t.asteriskToken,u,c8):t.asteriskToken,o(t.name,n,He),s(t.typeParameters,n,Ac),Kc(t.parameters,n,i,s),o(t.type,n,Di),Qp(t.body,n,i,o))},219:function(t,n,i,s,o,u){return i.factory.updateArrowFunction(t,s(t.modifiers,n,Pa),s(t.typeParameters,n,Ac),Kc(t.parameters,n,i,s),o(t.type,n,Di),u?M.checkDefined(o(t.equalsGreaterThanToken,u,Lde)):t.equalsGreaterThanToken,Qp(t.body,n,i,o))},220:function(t,n,i,s,o,u){return i.factory.updateDeleteExpression(t,M.checkDefined(o(t.expression,n,Ct)))},221:function(t,n,i,s,o,u){return i.factory.updateTypeOfExpression(t,M.checkDefined(o(t.expression,n,Ct)))},222:function(t,n,i,s,o,u){return i.factory.updateVoidExpression(t,M.checkDefined(o(t.expression,n,Ct)))},223:function(t,n,i,s,o,u){return i.factory.updateAwaitExpression(t,M.checkDefined(o(t.expression,n,Ct)))},224:function(t,n,i,s,o,u){return i.factory.updatePrefixUnaryExpression(t,M.checkDefined(o(t.operand,n,Ct)))},225:function(t,n,i,s,o,u){return i.factory.updatePostfixUnaryExpression(t,M.checkDefined(o(t.operand,n,Ct)))},226:function(t,n,i,s,o,u){return i.factory.updateBinaryExpression(t,M.checkDefined(o(t.left,n,Ct)),u?M.checkDefined(o(t.operatorToken,u,bme)):t.operatorToken,M.checkDefined(o(t.right,n,Ct)))},227:function(t,n,i,s,o,u){return i.factory.updateConditionalExpression(t,M.checkDefined(o(t.condition,n,Ct)),u?M.checkDefined(o(t.questionToken,u,Q1)):t.questionToken,M.checkDefined(o(t.whenTrue,n,Ct)),u?M.checkDefined(o(t.colonToken,u,Mde)):t.colonToken,M.checkDefined(o(t.whenFalse,n,Ct)))},228:function(t,n,i,s,o,u){return i.factory.updateTemplateExpression(t,M.checkDefined(o(t.head,n,IA)),s(t.templateSpans,n,PO))},229:function(t,n,i,s,o,u){return i.factory.updateYieldExpression(t,u?o(t.asteriskToken,u,c8):t.asteriskToken,o(t.expression,n,Ct))},230:function(t,n,i,s,o,u){return i.factory.updateSpreadElement(t,M.checkDefined(o(t.expression,n,Ct)))},231:function(t,n,i,s,o,u){return i.factory.updateClassExpression(t,s(t.modifiers,n,Cc),o(t.name,n,He),s(t.typeParameters,n,Ac),s(t.heritageClauses,n,pp),s(t.members,n,uu))},233:function(t,n,i,s,o,u){return i.factory.updateExpressionWithTypeArguments(t,M.checkDefined(o(t.expression,n,Ct)),s(t.typeArguments,n,Di))},234:function(t,n,i,s,o,u){return i.factory.updateAsExpression(t,M.checkDefined(o(t.expression,n,Ct)),M.checkDefined(o(t.type,n,Di)))},238:function(t,n,i,s,o,u){return i.factory.updateSatisfiesExpression(t,M.checkDefined(o(t.expression,n,Ct)),M.checkDefined(o(t.type,n,Di)))},235:function(t,n,i,s,o,u){return S_(t)?i.factory.updateNonNullChain(t,M.checkDefined(o(t.expression,n,Ct))):i.factory.updateNonNullExpression(t,M.checkDefined(o(t.expression,n,Ct)))},236:function(t,n,i,s,o,u){return i.factory.updateMetaProperty(t,M.checkDefined(o(t.name,n,He)))},239:function(t,n,i,s,o,u){return i.factory.updateTemplateSpan(t,M.checkDefined(o(t.expression,n,Ct)),M.checkDefined(o(t.literal,n,N5)))},241:function(t,n,i,s,o,u){return i.factory.updateBlock(t,s(t.statements,n,Vi))},243:function(t,n,i,s,o,u){return i.factory.updateVariableStatement(t,s(t.modifiers,n,Cc),M.checkDefined(o(t.declarationList,n,Ru)))},244:function(t,n,i,s,o,u){return i.factory.updateExpressionStatement(t,M.checkDefined(o(t.expression,n,Ct)))},245:function(t,n,i,s,o,u){return i.factory.updateIfStatement(t,M.checkDefined(o(t.expression,n,Ct)),M.checkDefined(o(t.thenStatement,n,Vi,i.factory.liftToBlock)),o(t.elseStatement,n,Vi,i.factory.liftToBlock))},246:function(t,n,i,s,o,u){return i.factory.updateDoStatement(t,ff(t.statement,n,i,o),M.checkDefined(o(t.expression,n,Ct)))},247:function(t,n,i,s,o,u){return i.factory.updateWhileStatement(t,M.checkDefined(o(t.expression,n,Ct)),ff(t.statement,n,i,o))},248:function(t,n,i,s,o,u){return i.factory.updateForStatement(t,o(t.initializer,n,Sd),o(t.condition,n,Ct),o(t.incrementor,n,Ct),ff(t.statement,n,i,o))},249:function(t,n,i,s,o,u){return i.factory.updateForInStatement(t,M.checkDefined(o(t.initializer,n,Sd)),M.checkDefined(o(t.expression,n,Ct)),ff(t.statement,n,i,o))},250:function(t,n,i,s,o,u){return i.factory.updateForOfStatement(t,u?o(t.awaitModifier,u,XG):t.awaitModifier,M.checkDefined(o(t.initializer,n,Sd)),M.checkDefined(o(t.expression,n,Ct)),ff(t.statement,n,i,o))},251:function(t,n,i,s,o,u){return i.factory.updateContinueStatement(t,o(t.label,n,He))},252:function(t,n,i,s,o,u){return i.factory.updateBreakStatement(t,o(t.label,n,He))},253:function(t,n,i,s,o,u){return i.factory.updateReturnStatement(t,o(t.expression,n,Ct))},254:function(t,n,i,s,o,u){return i.factory.updateWithStatement(t,M.checkDefined(o(t.expression,n,Ct)),M.checkDefined(o(t.statement,n,Vi,i.factory.liftToBlock)))},255:function(t,n,i,s,o,u){return i.factory.updateSwitchStatement(t,M.checkDefined(o(t.expression,n,Ct)),M.checkDefined(o(t.caseBlock,n,DO)))},256:function(t,n,i,s,o,u){return i.factory.updateLabeledStatement(t,M.checkDefined(o(t.label,n,He)),M.checkDefined(o(t.statement,n,Vi,i.factory.liftToBlock)))},257:function(t,n,i,s,o,u){return i.factory.updateThrowStatement(t,M.checkDefined(o(t.expression,n,Ct)))},258:function(t,n,i,s,o,u){return i.factory.updateTryStatement(t,M.checkDefined(o(t.tryBlock,n,Vs)),o(t.catchClause,n,bE),o(t.finallyBlock,n,Vs))},260:function(t,n,i,s,o,u){return i.factory.updateVariableDeclaration(t,M.checkDefined(o(t.name,n,Wx)),u?o(t.exclamationToken,u,l8):t.exclamationToken,o(t.type,n,Di),o(t.initializer,n,Ct))},261:function(t,n,i,s,o,u){return i.factory.updateVariableDeclarationList(t,s(t.declarations,n,Ei))},262:function(t,n,i,s,o,u){return i.factory.updateFunctionDeclaration(t,s(t.modifiers,n,Pa),u?o(t.asteriskToken,u,c8):t.asteriskToken,o(t.name,n,He),s(t.typeParameters,n,Ac),Kc(t.parameters,n,i,s),o(t.type,n,Di),Qp(t.body,n,i,o))},263:function(t,n,i,s,o,u){return i.factory.updateClassDeclaration(t,s(t.modifiers,n,Cc),o(t.name,n,He),s(t.typeParameters,n,Ac),s(t.heritageClauses,n,pp),s(t.members,n,uu))},264:function(t,n,i,s,o,u){return i.factory.updateInterfaceDeclaration(t,s(t.modifiers,n,Cc),M.checkDefined(o(t.name,n,He)),s(t.typeParameters,n,Ac),s(t.heritageClauses,n,pp),s(t.members,n,$T))},265:function(t,n,i,s,o,u){return i.factory.updateTypeAliasDeclaration(t,s(t.modifiers,n,Cc),M.checkDefined(o(t.name,n,He)),s(t.typeParameters,n,Ac),M.checkDefined(o(t.type,n,Di)))},266:function(t,n,i,s,o,u){return i.factory.updateEnumDeclaration(t,s(t.modifiers,n,Cc),M.checkDefined(o(t.name,n,He)),s(t.members,n,nS))},267:function(t,n,i,s,o,u){return i.factory.updateModuleDeclaration(t,s(t.modifiers,n,Cc),M.checkDefined(o(t.name,n,Sme)),o(t.body,n,l_e))},268:function(t,n,i,s,o,u){return i.factory.updateModuleBlock(t,s(t.statements,n,Vi))},269:function(t,n,i,s,o,u){return i.factory.updateCaseBlock(t,s(t.clauses,n,M5))},270:function(t,n,i,s,o,u){return i.factory.updateNamespaceExportDeclaration(t,M.checkDefined(o(t.name,n,He)))},271:function(t,n,i,s,o,u){return i.factory.updateImportEqualsDeclaration(t,s(t.modifiers,n,Cc),t.isTypeOnly,M.checkDefined(o(t.name,n,He)),M.checkDefined(o(t.moduleReference,n,d_e)))},272:function(t,n,i,s,o,u){return i.factory.updateImportDeclaration(t,s(t.modifiers,n,Cc),o(t.importClause,n,ig),M.checkDefined(o(t.moduleSpecifier,n,Ct)),o(t.attributes,n,l2))},300:function(t,n,i,s,o,u){return i.factory.updateImportAttributes(t,s(t.elements,n,Gde),t.multiLine)},301:function(t,n,i,s,o,u){return i.factory.updateImportAttribute(t,M.checkDefined(o(t.name,n,e_e)),M.checkDefined(o(t.value,n,Ct)))},273:function(t,n,i,s,o,u){return i.factory.updateImportClause(t,t.isTypeOnly,o(t.name,n,He),o(t.namedBindings,n,$$))},274:function(t,n,i,s,o,u){return i.factory.updateNamespaceImport(t,M.checkDefined(o(t.name,n,He)))},280:function(t,n,i,s,o,u){return i.factory.updateNamespaceExport(t,M.checkDefined(o(t.name,n,He)))},275:function(t,n,i,s,o,u){return i.factory.updateNamedImports(t,s(t.elements,n,_f))},276:function(t,n,i,s,o,u){return i.factory.updateImportSpecifier(t,t.isTypeOnly,o(t.propertyName,n,He),M.checkDefined(o(t.name,n,He)))},277:function(t,n,i,s,o,u){return i.factory.updateExportAssignment(t,s(t.modifiers,n,Cc),M.checkDefined(o(t.expression,n,Ct)))},278:function(t,n,i,s,o,u){return i.factory.updateExportDeclaration(t,s(t.modifiers,n,Cc),t.isTypeOnly,o(t.exportClause,n,M$),o(t.moduleSpecifier,n,Ct),o(t.attributes,n,l2))},279:function(t,n,i,s,o,u){return i.factory.updateNamedExports(t,s(t.elements,n,b_))},281:function(t,n,i,s,o,u){return i.factory.updateExportSpecifier(t,t.isTypeOnly,o(t.propertyName,n,He),M.checkDefined(o(t.name,n,He)))},283:function(t,n,i,s,o,u){return i.factory.updateExternalModuleReference(t,M.checkDefined(o(t.expression,n,Ct)))},284:function(t,n,i,s,o,u){return i.factory.updateJsxElement(t,M.checkDefined(o(t.openingElement,n,Yg)),s(t.children,n,$3),M.checkDefined(o(t.closingElement,n,yE)))},285:function(t,n,i,s,o,u){return i.factory.updateJsxSelfClosingElement(t,M.checkDefined(o(t.tagName,n,EI)),s(t.typeArguments,n,Di),M.checkDefined(o(t.attributes,n,SE)))},286:function(t,n,i,s,o,u){return i.factory.updateJsxOpeningElement(t,M.checkDefined(o(t.tagName,n,EI)),s(t.typeArguments,n,Di),M.checkDefined(o(t.attributes,n,SE)))},287:function(t,n,i,s,o,u){return i.factory.updateJsxClosingElement(t,M.checkDefined(o(t.tagName,n,EI)))},295:function(t,n,i,s,o,u){return i.factory.updateJsxNamespacedName(t,M.checkDefined(o(t.namespace,n,He)),M.checkDefined(o(t.name,n,He)))},288:function(t,n,i,s,o,u){return i.factory.updateJsxFragment(t,M.checkDefined(o(t.openingFragment,n,_2)),s(t.children,n,$3),M.checkDefined(o(t.closingFragment,n,Yde)))},291:function(t,n,i,s,o,u){return i.factory.updateJsxAttribute(t,M.checkDefined(o(t.name,n,Fpe)),o(t.initializer,n,m_e))},292:function(t,n,i,s,o,u){return i.factory.updateJsxAttributes(t,s(t.properties,n,R5))},293:function(t,n,i,s,o,u){return i.factory.updateJsxSpreadAttribute(t,M.checkDefined(o(t.expression,n,Ct)))},294:function(t,n,i,s,o,u){return i.factory.updateJsxExpression(t,o(t.expression,n,Ct))},296:function(t,n,i,s,o,u){return i.factory.updateCaseClause(t,M.checkDefined(o(t.expression,n,Ct)),s(t.statements,n,Vi))},297:function(t,n,i,s,o,u){return i.factory.updateDefaultClause(t,s(t.statements,n,Vi))},298:function(t,n,i,s,o,u){return i.factory.updateHeritageClause(t,s(t.types,n,x0))},299:function(t,n,i,s,o,u){return i.factory.updateCatchClause(t,o(t.variableDeclaration,n,Ei),M.checkDefined(o(t.block,n,Vs)))},303:function(t,n,i,s,o,u){return i.factory.updatePropertyAssignment(t,M.checkDefined(o(t.name,n,Ol)),M.checkDefined(o(t.initializer,n,Ct)))},304:function(t,n,i,s,o,u){return i.factory.updateShorthandPropertyAssignment(t,M.checkDefined(o(t.name,n,He)),o(t.objectAssignmentInitializer,n,Ct))},305:function(t,n,i,s,o,u){return i.factory.updateSpreadAssignment(t,M.checkDefined(o(t.expression,n,Ct)))},306:function(t,n,i,s,o,u){return i.factory.updateEnumMember(t,M.checkDefined(o(t.name,n,Ol)),o(t.initializer,n,Ct))},307:function(t,n,i,s,o,u){return i.factory.updateSourceFile(t,vK(t.statements,n,i))},354:function(t,n,i,s,o,u){return i.factory.updatePartiallyEmittedExpression(t,M.checkDefined(o(t.expression,n,Ct)))},355:function(t,n,i,s,o,u){return i.factory.updateCommaListExpression(t,s(t.elements,n,Ct))}};function eEt(e){return M.assert(e.length<=1,"Too many nodes written to output."),Dh(e)}function jge(e,t,n,i,s){var{enter:o,exit:u}=s.extendedDiagnostics?qW("Source Map","beforeSourcemap","afterSourcemap"):ole,m=[],d=[],S=new Map,E,x=[],D,w=[],R="",L=0,F=0,J=0,G=0,q=0,ee=0,W=!1,pe=0,K=0,re=0,ue=0,ce=0,ne=0,le=!1,me=!1,de=!1;return{getSources:()=>m,addSource:Ae,setSourceContent:xe,addName:te,addMapping:Ve,appendSourceMap:Pe,toJSON:qe,toString:()=>JSON.stringify(qe())};function Ae(Ie){o();let _t=WC(i,Ie,e.getCurrentDirectory(),e.getCanonicalFileName,!0),mt=S.get(_t);return mt===void 0&&(mt=d.length,d.push(_t),m.push(Ie),S.set(_t,mt)),u(),mt}function xe(Ie,_t){if(o(),_t!==null){for(E||(E=[]);E.length<Ie;)E.push(null);E[Ie]=_t}u()}function te(Ie){o(),D||(D=new Map);let _t=D.get(Ie);return _t===void 0&&(_t=x.length,x.push(Ie),D.set(Ie,_t)),u(),_t}function he(Ie,_t){return!le||pe!==Ie||K!==_t}function be(Ie,_t,mt){return Ie!==void 0&&_t!==void 0&&mt!==void 0&&re===Ie&&(ue>_t||ue===_t&&ce>mt)}function Ve(Ie,_t,mt,Xe,ht,rr){M.assert(Ie>=pe,"generatedLine cannot backtrack"),M.assert(_t>=0,"generatedCharacter cannot be negative"),M.assert(mt===void 0||mt>=0,"sourceIndex cannot be negative"),M.assert(Xe===void 0||Xe>=0,"sourceLine cannot be negative"),M.assert(ht===void 0||ht>=0,"sourceCharacter cannot be negative"),o(),(he(Ie,_t)||be(mt,Xe,ht))&&(Be(),pe=Ie,K=_t,me=!1,de=!1,le=!0),mt!==void 0&&Xe!==void 0&&ht!==void 0&&(re=mt,ue=Xe,ce=ht,me=!0,rr!==void 0&&(ne=rr,de=!0)),u()}function Pe(Ie,_t,mt,Xe,ht,rr){M.assert(Ie>=pe,"generatedLine cannot backtrack"),M.assert(_t>=0,"generatedCharacter cannot be negative"),o();let vr=[],xr,jr=EK(mt.mappings);for(let ur of jr){if(rr&&(ur.generatedLine>rr.line||ur.generatedLine===rr.line&&ur.generatedCharacter>rr.character))break;if(ht&&(ur.generatedLine<ht.line||ht.line===ur.generatedLine&&ur.generatedCharacter<ht.character))continue;let or,Zr,Oi,Sr;if(ur.sourceIndex!==void 0){if(or=vr[ur.sourceIndex],or===void 0){let $r=mt.sources[ur.sourceIndex],Xs=mt.sourceRoot?ri(mt.sourceRoot,$r):$r,$e=ri(mi(Xe),Xs);vr[ur.sourceIndex]=or=Ae($e),mt.sourcesContent&&typeof mt.sourcesContent[ur.sourceIndex]=="string"&&xe(or,mt.sourcesContent[ur.sourceIndex])}Zr=ur.sourceLine,Oi=ur.sourceCharacter,mt.names&&ur.nameIndex!==void 0&&(xr||(xr=[]),Sr=xr[ur.nameIndex],Sr===void 0&&(xr[ur.nameIndex]=Sr=te(mt.names[ur.nameIndex])))}let Pi=ur.generatedLine-(ht?ht.line:0),Cs=Pi+Ie,ss=ht&&ht.line===ur.generatedLine?ur.generatedCharacter-ht.character:ur.generatedCharacter,Ii=Pi===0?ss+_t:ss;Ve(Cs,Ii,or,Zr,Oi,Sr)}u()}function ke(){return!W||L!==pe||F!==K||J!==re||G!==ue||q!==ce||ee!==ne}function De(Ie){w.push(Ie),w.length>=1024&&ct()}function Be(){if(!(!le||!ke())){if(o(),L<pe){do De(59),L++;while(L<pe);F=0}else M.assertEqual(L,pe,"generatedLine cannot backtrack"),W&&De(44);et(K-F),F=K,me&&(et(re-J),J=re,et(ue-G),G=ue,et(ce-q),q=ce,de&&(et(ne-ee),ee=ne)),W=!0,u()}}function ct(){w.length>0&&(R+=String.fromCharCode.apply(void 0,w),w.length=0)}function qe(){return Be(),ct(),{version:3,file:t,sourceRoot:n,sources:d,names:x,mappings:R,sourcesContent:E}}function et(Ie){Ie<0?Ie=(-Ie<<1)+1:Ie=Ie<<1;do{let _t=Ie&31;Ie=Ie>>5,Ie>0&&(_t=_t|32),De(rEt(_t))}while(Ie>0)}}var Bge=/\/\/[@#] source[M]appingURL=(.+)\r?\n?$/,SK=/^\/\/[@#] source[M]appingURL=(.+)\r?\n?$/,bK=/^\s*(\/\/[@#] .*)?$/;function TK(e,t){return{getLineCount:()=>t.length,getLineText:n=>e.substring(t[n],t[n+1])}}function Uge(e){for(let t=e.getLineCount()-1;t>=0;t--){let n=e.getLineText(t),i=SK.exec(n);if(i)return i[1].trimEnd();if(!n.match(bK))break}}function tEt(e){return typeof e=="string"||e===null}function Vge(e){return e!==null&&typeof e=="object"&&e.version===3&&typeof e.file=="string"&&typeof e.mappings=="string"&&Rs(e.sources)&&wi(e.sources,bs)&&(e.sourceRoot===void 0||e.sourceRoot===null||typeof e.sourceRoot=="string")&&(e.sourcesContent===void 0||e.sourcesContent===null||Rs(e.sourcesContent)&&wi(e.sourcesContent,tEt))&&(e.names===void 0||e.names===null||Rs(e.names)&&wi(e.names,bs))}function Jge(e){try{let t=JSON.parse(e);if(Vge(t))return t}catch{}}function EK(e){let t=!1,n=0,i=0,s=0,o=0,u=0,m=0,d=0,S;return{get pos(){return n},get error(){return S},get state(){return E(!0,!0)},next(){for(;!t&&n<e.length;){let J=e.charCodeAt(n);if(J===59){i++,s=0,n++;continue}if(J===44){n++;continue}let G=!1,q=!1;if(s+=F(),R())return x();if(s<0)return w("Invalid generatedCharacter found");if(!L()){if(G=!0,o+=F(),R())return x();if(o<0)return w("Invalid sourceIndex found");if(L())return w("Unsupported Format: No entries after sourceIndex");if(u+=F(),R())return x();if(u<0)return w("Invalid sourceLine found");if(L())return w("Unsupported Format: No entries after sourceLine");if(m+=F(),R())return x();if(m<0)return w("Invalid sourceCharacter found");if(!L()){if(q=!0,d+=F(),R())return x();if(d<0)return w("Invalid nameIndex found");if(!L())return w("Unsupported Error Format: Entries after nameIndex")}}return{value:E(G,q),done:t}}return x()},[Symbol.iterator](){return this}};function E(J,G){return{generatedLine:i,generatedCharacter:s,sourceIndex:J?o:void 0,sourceLine:J?u:void 0,sourceCharacter:J?m:void 0,nameIndex:G?d:void 0}}function x(){return t=!0,{value:void 0,done:!0}}function D(J){S===void 0&&(S=J)}function w(J){return D(J),x()}function R(){return S!==void 0}function L(){return n===e.length||e.charCodeAt(n)===44||e.charCodeAt(n)===59}function F(){let J=!0,G=0,q=0;for(;J;n++){if(n>=e.length)return D("Error in decoding base64VLQFormatDecode, past the mapping string"),-1;let ee=nEt(e.charCodeAt(n));if(ee===-1)return D("Invalid character in VLQ"),-1;J=(ee&32)!==0,q=q|(ee&31)<<G,G+=5}return q&1?(q=q>>1,q=-q):q=q>>1,q}}function t8e(e,t){return e===t||e.generatedLine===t.generatedLine&&e.generatedCharacter===t.generatedCharacter&&e.sourceIndex===t.sourceIndex&&e.sourceLine===t.sourceLine&&e.sourceCharacter===t.sourceCharacter&&e.nameIndex===t.nameIndex}function qge(e){return e.sourceIndex!==void 0&&e.sourceLine!==void 0&&e.sourceCharacter!==void 0}function rEt(e){return e>=0&&e<26?65+e:e>=26&&e<52?97+e-26:e>=52&&e<62?48+e-52:e===62?43:e===63?47:M.fail(`${e}: not a base64 value`)}function nEt(e){return e>=65&&e<=90?e-65:e>=97&&e<=122?e-97+26:e>=48&&e<=57?e-48+52:e===43?62:e===47?63:-1}function r8e(e){return e.sourceIndex!==void 0&&e.sourcePosition!==void 0}function n8e(e,t){return e.generatedPosition===t.generatedPosition&&e.sourceIndex===t.sourceIndex&&e.sourcePosition===t.sourcePosition}function iEt(e,t){return M.assert(e.sourceIndex===t.sourceIndex),tc(e.sourcePosition,t.sourcePosition)}function sEt(e,t){return tc(e.generatedPosition,t.generatedPosition)}function aEt(e){return e.sourcePosition}function oEt(e){return e.generatedPosition}function zge(e,t,n){let i=mi(n),s=t.sourceRoot?xs(t.sourceRoot,i):i,o=xs(t.file,i),u=e.getSourceFileLike(o),m=t.sources.map(G=>xs(G,s)),d=new Map(m.map((G,q)=>[e.getCanonicalFileName(G),q])),S,E,x;return{getSourcePosition:J,getGeneratedPosition:F};function D(G){let q=u!==void 0?T3(u,G.generatedLine,G.generatedCharacter,!0):-1,ee,W;if(qge(G)){let pe=e.getSourceFileLike(m[G.sourceIndex]);ee=t.sources[G.sourceIndex],W=pe!==void 0?T3(pe,G.sourceLine,G.sourceCharacter,!0):-1}return{generatedPosition:q,source:ee,sourceIndex:G.sourceIndex,sourcePosition:W,nameIndex:G.nameIndex}}function w(){if(S===void 0){let G=EK(t.mappings),q=Is(G,D);G.error!==void 0?(e.log&&e.log(`Encountered error while decoding sourcemap: ${G.error}`),S=ve):S=q}return S}function R(G){if(x===void 0){let q=[];for(let ee of w()){if(!r8e(ee))continue;let W=q[ee.sourceIndex];W||(q[ee.sourceIndex]=W=[]),W.push(ee)}x=q.map(ee=>jC(ee,iEt,n8e))}return x[G]}function L(){if(E===void 0){let G=[];for(let q of w())G.push(q);E=jC(G,sEt,n8e)}return E}function F(G){let q=d.get(e.getCanonicalFileName(G.fileName));if(q===void 0)return G;let ee=R(q);if(!Pt(ee))return G;let W=BC(ee,G.pos,aEt,tc);W<0&&(W=~W);let pe=ee[W];return pe===void 0||pe.sourceIndex!==q?G:{fileName:o,pos:pe.generatedPosition}}function J(G){let q=L();if(!Pt(q))return G;let ee=BC(q,G.pos,oEt,tc);ee<0&&(ee=~ee);let W=q[ee];return W===void 0||!r8e(W)?G:{fileName:m[W.sourceIndex],pos:W.sourcePosition}}}var xK={getSourcePosition:ec,getGeneratedPosition:ec};function pf(e){return e=Bc(e),e?yo(e):0}function i8e(e){return!e||!Gg(e)&&!kd(e)?!1:Pt(e.elements,s8e)}function s8e(e){return e.propertyName!==void 0?e.propertyName.escapedText==="default":e.name.escapedText==="default"}function cg(e,t){return n;function n(s){return s.kind===307?t(s):i(s)}function i(s){return e.factory.createBundle(Cr(s.sourceFiles,t))}}function Wge(e){return!!KP(e)}function PB(e){if(KP(e))return!0;let t=e.importClause&&e.importClause.namedBindings;if(!t||!Gg(t))return!1;let n=0;for(let i of t.elements)s8e(i)&&n++;return n>0&&n!==t.elements.length||!!(t.elements.length-n)&&aA(e)}function CK(e){return!PB(e)&&(aA(e)||!!e.importClause&&Gg(e.importClause.namedBindings)&&i8e(e.importClause.namedBindings))}function AK(e,t){let n=e.getEmitResolver(),i=e.getCompilerOptions(),s=[],o=new $ge,u=[],m=new Map,d=new Set,S,E=!1,x,D=!1,w=!1,R=!1;for(let G of t.statements)switch(G.kind){case 272:s.push(G),!w&&PB(G)&&(w=!0),!R&&CK(G)&&(R=!0);break;case 271:G.moduleReference.kind===283&&s.push(G);break;case 278:if(G.moduleSpecifier)if(!G.exportClause)s.push(G),D=!0;else if(s.push(G),kd(G.exportClause))F(G),R||(R=i8e(G.exportClause));else{let q=G.exportClause.name;m.get(Nn(q))||(KO(u,pf(G),q),m.set(Nn(q),!0),S=Bt(S,q)),w=!0}else F(G);break;case 277:G.isExportEquals&&!x&&(x=G);break;case 243:if(li(G,32))for(let q of G.declarationList.declarations)S=a8e(q,m,S,u);break;case 262:li(G,32)&&J(G,void 0,li(G,2048));break;case 263:if(li(G,32))if(li(G,2048))E||(KO(u,pf(G),e.factory.getDeclarationName(G)),E=!0);else{let q=G.name;q&&!m.get(Nn(q))&&(KO(u,pf(G),q),m.set(Nn(q),!0),S=Bt(S,q))}break}let L=SY(e.factory,e.getEmitHelperFactory(),t,i,D,w,R);return L&&s.unshift(L),{externalImports:s,exportSpecifiers:o,exportEquals:x,hasExportStarsToExportValues:D,exportedBindings:u,exportedNames:S,exportedFunctions:d,externalHelpersImportDeclaration:L};function F(G){for(let q of aa(G.exportClause,kd).elements)if(!m.get(Nn(q.name))){let ee=q.propertyName||q.name;G.moduleSpecifier||o.add(ee,q);let W=n.getReferencedImportDeclaration(ee)||n.getReferencedValueDeclaration(ee);if(W){if(W.kind===262){J(W,q.name,q.name.escapedText==="default");continue}KO(u,pf(W),q.name)}m.set(Nn(q.name),!0),S=Bt(S,q.name)}}function J(G,q,ee){d.add(G),ee?E||(KO(u,pf(G),q??e.factory.getDeclarationName(G)),E=!0):(q??(q=G.name),m.get(Nn(q))||(KO(u,pf(G),q),m.set(Nn(q),!0)))}}function a8e(e,t,n,i){if(Hs(e.name))for(let s of e.name.elements)pu(s)||(n=a8e(s,t,n,i));else if(!xc(e.name)){let s=Nn(e.name);t.get(s)||(t.set(s,!0),n=Bt(n,e.name),k0(e.name)&&KO(i,pf(e),e.name))}return n}function KO(e,t,n){let i=e[t];return i?i.push(n):e[t]=i=[n],i}var LN=class Nw{constructor(){this._map=new Map}get size(){return this._map.size}has(t){return this._map.has(Nw.toKey(t))}get(t){return this._map.get(Nw.toKey(t))}set(t,n){return this._map.set(Nw.toKey(t),n),this}delete(t){var n;return((n=this._map)==null?void 0:n.delete(Nw.toKey(t)))??!1}clear(){this._map.clear()}values(){return this._map.values()}static toKey(t){if(zx(t)||xc(t)){let n=t.emitNode.autoGenerate;if((n.flags&7)===4){let i=b8(t),s=Cy(i)&&i!==t?Nw.toKey(i):`(generated@${yo(i)})`;return xb(!1,n.prefix,s,n.suffix,Nw.toKey)}else{let i=`(auto@${n.id})`;return xb(!1,n.prefix,i,n.suffix,Nw.toKey)}}return Zi(t)?Nn(t).slice(1):Nn(t)}},$ge=class extends LN{add(e,t){let n=this.get(e);return n?n.push(t):this.set(e,n=[t]),n}remove(e,t){let n=this.get(e);n&&(JC(n,t),n.length||this.delete(e))}};function xE(e){return No(e)||e.kind===9||sf(e.kind)||He(e)}function Qg(e){return!He(e)&&xE(e)}function XO(e){return e>=65&&e<=79}function QO(e){switch(e){case 65:return 40;case 66:return 41;case 67:return 42;case 68:return 43;case 69:return 44;case 70:return 45;case 71:return 48;case 72:return 49;case 73:return 50;case 74:return 51;case 75:return 52;case 79:return 53;case 76:return 57;case 77:return 56;case 78:return 61}}function NB(e){if(!Du(e))return;let t=So(e.expression);return Kx(t)?t:void 0}function o8e(e,t,n){for(let i=t;i<e.length;i+=1){let s=e[i];if(NB(s))return n.unshift(i),!0;if(c2(s)&&o8e(s.tryBlock.statements,0,n))return n.unshift(i),!0}return!1}function DB(e,t){let n=[];return o8e(e,t,n),n}function kK(e,t,n){return Zn(e.members,i=>lEt(i,t,n))}function cEt(e){return uEt(e)||Gc(e)}function wB(e){return Zn(e.members,cEt)}function lEt(e,t,n){return Ns(e)&&(!!e.initializer||!t)&&Jl(e)===n}function uEt(e){return Ns(e)&&Jl(e)}function B8(e){return e.kind===172&&e.initializer!==void 0}function Hge(e){return!oa(e)&&(KC(e)||Ef(e))&&Zi(e.name)}function Gge(e){let t;if(e){let n=e.parameters,i=n.length>0&&sE(n[0]),s=i?1:0,o=i?n.length-1:n.length;for(let u=0;u<o;u++){let m=n[u+s];(t||Wp(m))&&(t||(t=new Array(o)),t[u]=F1(m))}}return t}function PK(e){let t=F1(e),n=Gge(Ny(e));if(!(!Pt(t)&&!Pt(n)))return{decorators:t,parameters:n}}function IB(e,t,n){switch(e.kind){case 177:case 178:return n?_Et(e,t):c8e(e);case 174:return c8e(e);case 172:return fEt(e);default:return}}function _Et(e,t){if(!e.body)return;let{firstAccessor:n,secondAccessor:i,getAccessor:s,setAccessor:o}=W1(t.members,e),u=Wp(n)?n:i&&Wp(i)?i:void 0;if(!u||e!==u)return;let m=F1(u),d=Gge(o);if(!(!Pt(m)&&!Pt(d)))return{decorators:m,parameters:d,getDecorators:s&&F1(s),setDecorators:o&&F1(o)}}function c8e(e){if(!e.body)return;let t=F1(e),n=Gge(e);if(!(!Pt(t)&&!Pt(n)))return{decorators:t,parameters:n}}function fEt(e){let t=F1(e);if(Pt(t))return{decorators:t}}function Yge(e,t){for(;e;){let n=t(e);if(n!==void 0)return n;e=e.previous}}function Kge(e){return{data:e}}function NK(e,t){var n,i;return zx(t)?(n=e?.generatedIdentifiers)==null?void 0:n.get(b8(t)):(i=e?.identifiers)==null?void 0:i.get(t.escapedText)}function h2(e,t,n){zx(t)?(e.generatedIdentifiers??(e.generatedIdentifiers=new Map),e.generatedIdentifiers.set(b8(t),n)):(e.identifiers??(e.identifiers=new Map),e.identifiers.set(t.escapedText,n))}function Xge(e,t){return Yge(e,n=>NK(n.privateEnv,t))}function Qge(e){return!e.initializer&&He(e.name)}function U8(e){return wi(e,Qge)}var Zge=(e=>(e[e.All=0]="All",e[e.ObjectRest=1]="ObjectRest",e))(Zge||{});function y2(e,t,n,i,s,o){let u=e,m;if(Dv(e))for(m=e.right;Wfe(e.left)||rG(e.left);)if(Dv(m))u=e=m,m=e.right;else return M.checkDefined(ot(m,t,Ct));let d,S={context:n,level:i,downlevelIteration:!!n.getCompilerOptions().downlevelIteration,hoistTempVariables:!0,emitExpression:E,emitBindingOrAssignment:x,createArrayBindingOrAssignmentPattern:D=>SEt(n.factory,D),createObjectBindingOrAssignmentPattern:D=>TEt(n.factory,D),createArrayBindingOrAssignmentElement:xEt,visitor:t};if(m&&(m=ot(m,t,Ct),M.assert(m),He(m)&&ehe(e,m.escapedText)||the(e)?m=ZA(S,m,!1,u):s?m=ZA(S,m,!0,u):Ko(e)&&(u=m)),ZO(S,e,m,u,Dv(e)),m&&s){if(!Pt(d))return m;d.push(m)}return n.factory.inlineExpressions(d)||n.factory.createOmittedExpression();function E(D){d=Bt(d,D)}function x(D,w,R,L){M.assertNode(D,o?He:Ct);let F=o?o(D,w,R):Et(n.factory.createAssignment(M.checkDefined(ot(D,t,Ct)),w),R);F.original=L,E(F)}}function ehe(e,t){let n=iS(e);return B3(n)?pEt(n,t):He(n)?n.escapedText===t:!1}function pEt(e,t){let n=AN(e);for(let i of n)if(ehe(i,t))return!0;return!1}function the(e){let t=Yj(e);if(t&&za(t)&&!WT(t.expression))return!0;let n=iS(e);return!!n&&B3(n)&&dEt(n)}function dEt(e){return!!kt(AN(e),the)}function CE(e,t,n,i,s,o=!1,u){let m,d=[],S=[],E={context:n,level:i,downlevelIteration:!!n.getCompilerOptions().downlevelIteration,hoistTempVariables:o,emitExpression:x,emitBindingOrAssignment:D,createArrayBindingOrAssignmentPattern:w=>vEt(n.factory,w),createObjectBindingOrAssignmentPattern:w=>bEt(n.factory,w),createArrayBindingOrAssignmentElement:w=>EEt(n.factory,w),visitor:t};if(Ei(e)){let w=v8(e);w&&(He(w)&&ehe(e,w.escapedText)||the(e))&&(w=ZA(E,M.checkDefined(ot(w,E.visitor,Ct)),!1,w),e=n.factory.updateVariableDeclaration(e,e.name,void 0,void 0,w))}if(ZO(E,e,s,e,u),m){let w=n.factory.createTempVariable(void 0);if(o){let R=n.factory.inlineExpressions(m);m=void 0,D(w,R,void 0,void 0)}else{n.hoistVariableDeclaration(w);let R=Va(d);R.pendingExpressions=Bt(R.pendingExpressions,n.factory.createAssignment(w,R.value)),wn(R.pendingExpressions,m),R.value=w}}for(let{pendingExpressions:w,name:R,value:L,location:F,original:J}of d){let G=n.factory.createVariableDeclaration(R,void 0,void 0,w?n.factory.inlineExpressions(Bt(w,L)):L);G.original=J,Et(G,F),S.push(G)}return S;function x(w){m=Bt(m,w)}function D(w,R,L,F){M.assertNode(w,Wx),m&&(R=n.factory.inlineExpressions(Bt(m,R)),m=void 0),d.push({pendingExpressions:m,name:w,value:R,location:L,original:F})}}function ZO(e,t,n,i,s){let o=iS(t);if(!s){let u=ot(v8(t),e.visitor,Ct);u?n?(n=hEt(e,n,u,i),!Qg(u)&&B3(o)&&(n=ZA(e,n,!0,i))):n=u:n||(n=e.context.factory.createVoidZero())}V$(o)?mEt(e,t,o,n,i):J$(o)?gEt(e,t,o,n,i):e.emitBindingOrAssignment(o,n,i,t)}function mEt(e,t,n,i,s){let o=AN(n),u=o.length;if(u!==1){let S=!j3(t)||u!==0;i=ZA(e,i,S,s)}let m,d;for(let S=0;S<u;S++){let E=o[S];if(Gj(E)){if(S===u-1){m&&(e.emitBindingOrAssignment(e.createObjectBindingOrAssignmentPattern(m),i,s,n),m=void 0);let x=e.context.getEmitHelperFactory().createRestHelper(i,o,d,n);ZO(e,E,x,E)}}else{let x=bY(E);if(e.level>=1&&!(E.transformFlags&98304)&&!(iS(E).transformFlags&98304)&&!za(x))m=Bt(m,ot(E,e.visitor,n_e));else{m&&(e.emitBindingOrAssignment(e.createObjectBindingOrAssignmentPattern(m),i,s,n),m=void 0);let D=yEt(e,i,x);za(x)&&(d=Bt(d,D.argumentExpression)),ZO(e,E,D,E)}}}m&&e.emitBindingOrAssignment(e.createObjectBindingOrAssignmentPattern(m),i,s,n)}function gEt(e,t,n,i,s){let o=AN(n),u=o.length;if(e.level<1&&e.downlevelIteration)i=ZA(e,Et(e.context.getEmitHelperFactory().createReadHelper(i,u>0&&Gj(o[u-1])?void 0:u),s),!1,s);else if(u!==1&&(e.level<1||u===0)||wi(o,pu)){let S=!j3(t)||u!==0;i=ZA(e,i,S,s)}let m,d;for(let S=0;S<u;S++){let E=o[S];if(e.level>=1)if(E.transformFlags&65536||e.hasTransformedPriorElement&&!l8e(E)){e.hasTransformedPriorElement=!0;let x=e.context.factory.createTempVariable(void 0);e.hoistTempVariables&&e.context.hoistVariableDeclaration(x),d=Bt(d,[x,E]),m=Bt(m,e.createArrayBindingOrAssignmentElement(x))}else m=Bt(m,E);else{if(pu(E))continue;if(Gj(E)){if(S===u-1){let x=e.context.factory.createArraySliceCall(i,S);ZO(e,E,x,E)}}else{let x=e.context.factory.createElementAccessExpression(i,S);ZO(e,E,x,E)}}}if(m&&e.emitBindingOrAssignment(e.createArrayBindingOrAssignmentPattern(m),i,s,n),d)for(let[S,E]of d)ZO(e,E,S,E)}function l8e(e){let t=iS(e);if(!t||pu(t))return!0;let n=Yj(e);if(n&&!jg(n))return!1;let i=v8(e);return i&&!Qg(i)?!1:B3(t)?wi(AN(t),l8e):He(t)}function hEt(e,t,n,i){return t=ZA(e,t,!0,i),e.context.factory.createConditionalExpression(e.context.factory.createTypeCheck(t,"undefined"),void 0,n,void 0,t)}function yEt(e,t,n){let{factory:i}=e.context;if(za(n)){let s=ZA(e,M.checkDefined(ot(n.expression,e.visitor,Ct)),!1,n);return e.context.factory.createElementAccessExpression(t,s)}else if(zp(n)){let s=i.cloneNode(n);return e.context.factory.createElementAccessExpression(t,s)}else{let s=e.context.factory.createIdentifier(Nn(n));return e.context.factory.createPropertyAccessExpression(t,s)}}function ZA(e,t,n,i){if(He(t)&&n)return t;{let s=e.context.factory.createTempVariable(void 0);return e.hoistTempVariables?(e.context.hoistVariableDeclaration(s),e.emitExpression(Et(e.context.factory.createAssignment(s,t),i))):e.emitBindingOrAssignment(s,t,i,void 0),s}}function vEt(e,t){return M.assertEachNode(t,w5),e.createArrayBindingPattern(t)}function SEt(e,t){return M.assertEachNode(t,V3),e.createArrayLiteralExpression(Cr(t,e.converters.convertToArrayAssignmentElement))}function bEt(e,t){return M.assertEachNode(t,Xa),e.createObjectBindingPattern(t)}function TEt(e,t){return M.assertEachNode(t,U3),e.createObjectLiteralExpression(Cr(t,e.converters.convertToObjectAssignmentElement))}function EEt(e,t){return e.createBindingElement(void 0,void 0,t)}function xEt(e){return e}function rhe(e,t,n=e.createThis()){let i=e.createAssignment(t,n),s=e.createExpressionStatement(i),o=e.createBlock([s],!1),u=e.createClassStaticBlockDeclaration(o);return f_(u).classThis=t,u}function e6(e){var t;if(!Gc(e)||e.body.statements.length!==1)return!1;let n=e.body.statements[0];return Du(n)&&Su(n.expression,!0)&&He(n.expression.left)&&((t=e.emitNode)==null?void 0:t.classThis)===n.expression.left&&n.expression.right.kind===110}function DK(e){var t;return!!((t=e.emitNode)!=null&&t.classThis)&&Pt(e.members,e6)}function nhe(e,t,n,i){if(DK(t))return t;let s=rhe(e,n,i);t.name&&qa(s.body.statements[0],t.name);let o=e.createNodeArray([s,...t.members]);Et(o,t.members);let u=tu(t)?e.updateClassDeclaration(t,t.modifiers,t.name,t.typeParameters,t.heritageClauses,o):e.updateClassExpression(t,t.modifiers,t.name,t.typeParameters,t.heritageClauses,o);return f_(u).classThis=n,u}function t6(e,t,n){let i=Bc(Ml(n));return(tu(i)||Tl(i))&&!i.name&&li(i,2048)?e.createStringLiteral("default"):e.createStringLiteralFromNode(t)}function u8e(e,t,n){let{factory:i}=e;if(n!==void 0)return{assignedName:i.createStringLiteral(n),name:t};if(jg(t)||Zi(t))return{assignedName:i.createStringLiteralFromNode(t),name:t};if(jg(t.expression)&&!He(t.expression))return{assignedName:i.createStringLiteralFromNode(t.expression),name:t};let s=i.getGeneratedNameForNode(t);e.hoistVariableDeclaration(s);let o=e.getEmitHelperFactory().createPropKeyHelper(t.expression),u=i.createAssignment(s,o),m=i.updateComputedPropertyName(t,u);return{assignedName:s,name:m}}function ihe(e,t,n=e.factory.createThis()){let{factory:i}=e,s=e.getEmitHelperFactory().createSetFunctionNameHelper(n,t),o=i.createExpressionStatement(s),u=i.createBlock([o],!1),m=i.createClassStaticBlockDeclaration(u);return f_(m).assignedName=t,m}function ek(e){var t;if(!Gc(e)||e.body.statements.length!==1)return!1;let n=e.body.statements[0];return Du(n)&&bO(n.expression,"___setFunctionName")&&n.expression.arguments.length>=2&&n.expression.arguments[1]===((t=e.emitNode)==null?void 0:t.assignedName)}function OB(e){var t;return!!((t=e.emitNode)!=null&&t.assignedName)&&Pt(e.members,ek)}function wK(e){return!!e.name||OB(e)}function RB(e,t,n,i){if(OB(t))return t;let{factory:s}=e,o=ihe(e,n,i);t.name&&qa(o.body.statements[0],t.name);let u=Bo(t.members,e6)+1,m=t.members.slice(0,u),d=t.members.slice(u),S=s.createNodeArray([...m,o,...d]);return Et(S,t.members),t=tu(t)?s.updateClassDeclaration(t,t.modifiers,t.name,t.typeParameters,t.heritageClauses,S):s.updateClassExpression(t,t.modifiers,t.name,t.typeParameters,t.heritageClauses,S),f_(t).assignedName=n,t}function FN(e,t,n,i){if(i&&La(n)&&vH(n))return t;let{factory:s}=e,o=Ml(t),u=eu(o)?aa(RB(e,o,n),eu):e.getEmitHelperFactory().createSetFunctionNameHelper(o,n);return s.restoreOuterExpressions(t,u)}function CEt(e,t,n,i){let{factory:s}=e,{assignedName:o,name:u}=u8e(e,t.name,i),m=FN(e,t.initializer,o,n);return s.updatePropertyAssignment(t,u,m)}function AEt(e,t,n,i){let{factory:s}=e,o=i!==void 0?s.createStringLiteral(i):t6(s,t.name,t.objectAssignmentInitializer),u=FN(e,t.objectAssignmentInitializer,o,n);return s.updateShorthandPropertyAssignment(t,t.name,u)}function kEt(e,t,n,i){let{factory:s}=e,o=i!==void 0?s.createStringLiteral(i):t6(s,t.name,t.initializer),u=FN(e,t.initializer,o,n);return s.updateVariableDeclaration(t,t.name,t.exclamationToken,t.type,u)}function PEt(e,t,n,i){let{factory:s}=e,o=i!==void 0?s.createStringLiteral(i):t6(s,t.name,t.initializer),u=FN(e,t.initializer,o,n);return s.updateParameterDeclaration(t,t.modifiers,t.dotDotDotToken,t.name,t.questionToken,t.type,u)}function NEt(e,t,n,i){let{factory:s}=e,o=i!==void 0?s.createStringLiteral(i):t6(s,t.name,t.initializer),u=FN(e,t.initializer,o,n);return s.updateBindingElement(t,t.dotDotDotToken,t.propertyName,t.name,u)}function DEt(e,t,n,i){let{factory:s}=e,{assignedName:o,name:u}=u8e(e,t.name,i),m=FN(e,t.initializer,o,n);return s.updatePropertyDeclaration(t,t.modifiers,u,t.questionToken??t.exclamationToken,t.type,m)}function wEt(e,t,n,i){let{factory:s}=e,o=i!==void 0?s.createStringLiteral(i):t6(s,t.left,t.right),u=FN(e,t.right,o,n);return s.updateBinaryExpression(t,t.left,t.operatorToken,u)}function IEt(e,t,n,i){let{factory:s}=e,o=i!==void 0?s.createStringLiteral(i):s.createStringLiteral(t.isExportEquals?"":"default"),u=FN(e,t.expression,o,n);return s.updateExportAssignment(t,t.modifiers,u)}function dp(e,t,n,i){switch(t.kind){case 303:return CEt(e,t,n,i);case 304:return AEt(e,t,n,i);case 260:return kEt(e,t,n,i);case 169:return PEt(e,t,n,i);case 208:return NEt(e,t,n,i);case 172:return DEt(e,t,n,i);case 226:return wEt(e,t,n,i);case 277:return IEt(e,t,n,i)}}var she=(e=>(e[e.LiftRestriction=0]="LiftRestriction",e[e.All=1]="All",e))(she||{});function IK(e,t,n,i,s,o){let u=ot(t.tag,n,Ct);M.assert(u);let m=[void 0],d=[],S=[],E=t.template;if(o===0&&!JH(E))return Mr(t,n,e);let{factory:x}=e;if(wA(E))d.push(ahe(x,E)),S.push(ohe(x,E,i));else{d.push(ahe(x,E.head)),S.push(ohe(x,E.head,i));for(let w of E.templateSpans)d.push(ahe(x,w.literal)),S.push(ohe(x,w.literal,i)),m.push(M.checkDefined(ot(w.expression,n,Ct)))}let D=e.getEmitHelperFactory().createTemplateObjectHelper(x.createArrayLiteralExpression(d),x.createArrayLiteralExpression(S));if(nu(i)){let w=x.createUniqueName("templateObject");s(w),m[0]=x.createLogicalOr(w,x.createAssignment(w,D))}else m[0]=D;return x.createCallExpression(u,void 0,m)}function ahe(e,t){return t.templateFlags&26656?e.createVoidZero():e.createStringLiteral(t.text)}function ohe(e,t,n){let i=t.rawText;if(i===void 0){M.assertIsDefined(n,"Template literal node is missing 'rawText' and does not have a source file. Possibly bad transform."),i=GT(n,t);let s=t.kind===15||t.kind===18;i=i.substring(1,i.length-(s?1:2))}return i=i.replace(/\r\n?/g,`
`),Et(e.createStringLiteral(i),t)}var OEt=!1;function che(e){let{factory:t,getEmitHelperFactory:n,startLexicalEnvironment:i,resumeLexicalEnvironment:s,endLexicalEnvironment:o,hoistVariableDeclaration:u}=e,m=e.getEmitResolver(),d=e.getCompilerOptions(),S=Ka(d),E=V_(d),x=!!d.experimentalDecorators,D=d.emitDecoratorMetadata?uhe(e):void 0,w=e.onEmitNode,R=e.onSubstituteNode;e.onEmitNode=Fa,e.onSubstituteNode=bc,e.enableSubstitution(211),e.enableSubstitution(212);let L,F,J,G,q,ee,W,pe;return K;function K(ae){return ae.kind===308?re(ae):ue(ae)}function re(ae){return t.createBundle(ae.sourceFiles.map(ue))}function ue(ae){if(ae.isDeclarationFile)return ae;L=ae;let Ye=ce(ae,Ie);return E0(Ye,e.readEmitHelpers()),L=void 0,Ye}function ce(ae,Ye){let Ot=G,Tr=q,Vn=ee;ne(ae);let pr=Ye(ae);return G!==Ot&&(q=Tr),G=Ot,ee=Vn,pr}function ne(ae){switch(ae.kind){case 307:case 269:case 268:case 241:G=ae,q=void 0;break;case 263:case 262:if(li(ae,128))break;ae.name?z(ae):M.assert(ae.kind===263||li(ae,2048));break}}function le(ae){return ce(ae,me)}function me(ae){return ae.transformFlags&1?et(ae):ae}function de(ae){return ce(ae,Ae)}function Ae(ae){switch(ae.kind){case 272:case 271:case 277:case 278:return te(ae);default:return me(ae)}}function xe(ae){let Ye=ks(ae);if(Ye===ae||dc(ae))return!1;if(!Ye||Ye.kind!==ae.kind)return!0;switch(ae.kind){case 272:if(M.assertNode(Ye,Yc),ae.importClause!==Ye.importClause||ae.attributes!==Ye.attributes)return!0;break;case 271:if(M.assertNode(Ye,ru),ae.name!==Ye.name||ae.isTypeOnly!==Ye.isTypeOnly||ae.moduleReference!==Ye.moduleReference&&(Tf(ae.moduleReference)||Tf(Ye.moduleReference)))return!0;break;case 278:if(M.assertNode(Ye,xl),ae.exportClause!==Ye.exportClause||ae.attributes!==Ye.attributes)return!0;break}return!1}function te(ae){if(xe(ae))return ae.transformFlags&1?Mr(ae,le,e):ae;switch(ae.kind){case 272:return dr(ae);case 271:return tn(ae);case 277:return Ar(ae);case 278:return In(ae);default:M.fail("Unhandled ellided statement")}}function he(ae){return ce(ae,be)}function be(ae){if(!(ae.kind===278||ae.kind===272||ae.kind===273||ae.kind===271&&ae.moduleReference.kind===283))return ae.transformFlags&1||li(ae,32)?et(ae):ae}function Ve(ae){return Ye=>ce(Ye,Ot=>Pe(Ot,ae))}function Pe(ae,Ye){switch(ae.kind){case 176:return Vr(ae);case 172:return Yt(ae,Ye);case 177:return Gs(ae,Ye);case 178:return yr(ae,Ye);case 174:return Ui(ae,Ye);case 175:return Mr(ae,le,e);case 240:return ae;case 181:return;default:return M.failBadSyntaxKind(ae)}}function ke(ae){return Ye=>ce(Ye,Ot=>De(Ot,ae))}function De(ae,Ye){switch(ae.kind){case 303:case 304:case 305:return le(ae);case 177:return Gs(ae,Ye);case 178:return yr(ae,Ye);case 174:return Ui(ae,Ye);default:return M.failBadSyntaxKind(ae)}}function Be(ae){return fu(ae)?void 0:le(ae)}function ct(ae){return Pa(ae)?void 0:le(ae)}function qe(ae){if(!fu(ae)&&!(pA(ae.kind)&28895)&&!(F&&ae.kind===95))return ae}function et(ae){if(Vi(ae)&&li(ae,128))return t.createNotEmittedStatement(ae);switch(ae.kind){case 95:case 90:return F?void 0:ae;case 125:case 123:case 124:case 128:case 164:case 87:case 138:case 148:case 103:case 147:case 188:case 189:case 190:case 191:case 187:case 182:case 168:case 133:case 159:case 136:case 154:case 150:case 146:case 116:case 155:case 185:case 184:case 186:case 183:case 192:case 193:case 194:case 196:case 197:case 198:case 199:case 200:case 201:case 181:return;case 265:return t.createNotEmittedStatement(ae);case 270:return;case 264:return t.createNotEmittedStatement(ae);case 263:return rr(ae);case 231:return vr(ae);case 298:return $r(ae);case 233:return Xs(ae);case 210:return _t(ae);case 176:case 172:case 174:case 177:case 178:case 175:return M.fail("Class and object literal elements must be visited with their respective visitors");case 262:return to(ae);case 218:return lt(ae);case 219:return St(ae);case 169:return fe(ae);case 217:return Me(ae);case 216:case 234:return tt(ae);case 238:return tr(ae);case 213:return Oe(ae);case 214:return At(ae);case 215:return Nt(ae);case 235:return ft(ae);case 266:return Z(ae);case 243:return vt(ae);case 260:return nt(ae);case 267:return It(ae);case 271:return tn(ae);case 285:return Ut(ae);case 286:return Rt(ae);default:return Mr(ae,le,e)}}function Ie(ae){let Ye=J_(d,"alwaysStrict")&&!(nu(ae)&&E>=5)&&!Kd(ae);return t.updateSourceFile(ae,vK(ae.statements,de,e,0,Ye))}function _t(ae){return t.updateObjectLiteralExpression(ae,Kr(ae.properties,ke(ae),p0))}function mt(ae){let Ye=0;Pt(kK(ae,!0,!0))&&(Ye|=1);let Ot=Fg(ae);return Ot&&Ml(Ot.expression).kind!==106&&(Ye|=64),Cv(x,ae)&&(Ye|=2),wI(x,ae)&&(Ye|=4),er(ae)?Ye|=8:Mo(ae)?Ye|=32:uo(ae)&&(Ye|=16),Ye}function Xe(ae){return!!(ae.transformFlags&8192)}function ht(ae){return Wp(ae)||Pt(ae.typeParameters)||Pt(ae.heritageClauses,Xe)||Pt(ae.members,Xe)}function rr(ae){let Ye=mt(ae),Ot=S<=1&&!!(Ye&7);if(!ht(ae)&&!Cv(x,ae)&&!er(ae))return t.updateClassDeclaration(ae,Kr(ae.modifiers,qe,Pa),ae.name,void 0,Kr(ae.heritageClauses,le,pp),Kr(ae.members,Ve(ae),uu));Ot&&e.startLexicalEnvironment();let Tr=Ot||Ye&8,Vn=Tr?Kr(ae.modifiers,ct,Cc):Kr(ae.modifiers,le,Cc);Ye&2&&(Vn=jr(Vn,ae));let Jn=Tr&&!ae.name||Ye&4||Ye&1?ae.name??t.getGeneratedNameForNode(ae):ae.name,Ri=t.updateClassDeclaration(ae,Vn,Jn,void 0,Kr(ae.heritageClauses,le,pp),xr(ae)),Ai=Ga(ae);Ye&1&&(Ai|=64),Tn(Ri,Ai);let Na;if(Ot){let gc=[Ri],Wl=iG(Ja(L.text,ae.members.end),20),Oc=t.getInternalName(ae),du=t.createPartiallyEmittedExpression(Oc);pN(du,Wl.end),Tn(du,3072);let hc=t.createReturnStatement(du);fO(hc,Wl.pos),Tn(hc,3840),gc.push(hc),Ay(gc,e.endLexicalEnvironment());let mu=t.createImmediatelyInvokedArrowFunction(gc);i8(mu,1);let zf=t.createVariableDeclaration(t.getLocalName(ae,!1,!1),void 0,void 0,mu);zn(zf,ae);let rl=t.createVariableStatement(void 0,t.createVariableDeclarationList([zf],1));zn(rl,ae),Zl(rl,ae),qa(rl,v0(ae)),T_(rl),Na=rl}else Na=Ri;if(Tr){if(Ye&8)return[Na,Do(ae)];if(Ye&32)return[Na,t.createExportDefault(t.getLocalName(ae,!1,!0))];if(Ye&16)return[Na,t.createExternalModuleExport(t.getDeclarationName(ae,!1,!0))]}return Na}function vr(ae){let Ye=Kr(ae.modifiers,ct,Cc);return Cv(x,ae)&&(Ye=jr(Ye,ae)),t.updateClassExpression(ae,Ye,ae.name,void 0,Kr(ae.heritageClauses,le,pp),xr(ae))}function xr(ae){let Ye=Kr(ae.members,Ve(ae),uu),Ot,Tr=Ny(ae),Vn=Tr&&Zn(Tr.parameters,pr=>ap(pr,Tr));if(Vn)for(let pr of Vn){let Jn=t.createPropertyDeclaration(void 0,pr.name,void 0,void 0,void 0);zn(Jn,pr),Ot=Bt(Ot,Jn)}return Ot?(Ot=wn(Ot,Ye),Et(t.createNodeArray(Ot),ae.members)):Ye}function jr(ae,Ye){let Ot=or(Ye,Ye);if(Pt(Ot)){let Tr=[];wn(Tr,VW(ae,S8)),wn(Tr,Zn(ae,fu)),wn(Tr,Ot),wn(Tr,Zn(ele(ae,S8),Pa)),ae=Et(t.createNodeArray(Tr),ae)}return ae}function ur(ae,Ye,Ot){if(gi(Ot)&&yH(x,Ye,Ot)){let Tr=or(Ye,Ot);if(Pt(Tr)){let Vn=[];wn(Vn,Zn(ae,fu)),wn(Vn,Tr),wn(Vn,Zn(ae,Pa)),ae=Et(t.createNodeArray(Vn),ae)}}return ae}function or(ae,Ye){if(x)return OEt?Oi(ae,Ye):Zr(ae,Ye)}function Zr(ae,Ye){if(D){let Ot;if(Sr(ae)){let Tr=n().createMetadataHelper("design:type",D.serializeTypeOfNode({currentLexicalScope:G,currentNameScope:Ye},ae,Ye));Ot=Bt(Ot,t.createDecorator(Tr))}if(Cs(ae)){let Tr=n().createMetadataHelper("design:paramtypes",D.serializeParameterTypesOfNode({currentLexicalScope:G,currentNameScope:Ye},ae,Ye));Ot=Bt(Ot,t.createDecorator(Tr))}if(Pi(ae)){let Tr=n().createMetadataHelper("design:returntype",D.serializeReturnTypeOfNode({currentLexicalScope:G,currentNameScope:Ye},ae));Ot=Bt(Ot,t.createDecorator(Tr))}return Ot}}function Oi(ae,Ye){if(D){let Ot;if(Sr(ae)){let Tr=t.createPropertyAssignment("type",t.createArrowFunction(void 0,void 0,[],void 0,t.createToken(39),D.serializeTypeOfNode({currentLexicalScope:G,currentNameScope:Ye},ae,Ye)));Ot=Bt(Ot,Tr)}if(Cs(ae)){let Tr=t.createPropertyAssignment("paramTypes",t.createArrowFunction(void 0,void 0,[],void 0,t.createToken(39),D.serializeParameterTypesOfNode({currentLexicalScope:G,currentNameScope:Ye},ae,Ye)));Ot=Bt(Ot,Tr)}if(Pi(ae)){let Tr=t.createPropertyAssignment("returnType",t.createArrowFunction(void 0,void 0,[],void 0,t.createToken(39),D.serializeReturnTypeOfNode({currentLexicalScope:G,currentNameScope:Ye},ae)));Ot=Bt(Ot,Tr)}if(Ot){let Tr=n().createMetadataHelper("design:typeinfo",t.createObjectLiteralExpression(Ot,!0));return[t.createDecorator(Tr)]}}}function Sr(ae){let Ye=ae.kind;return Ye===174||Ye===177||Ye===178||Ye===172}function Pi(ae){return ae.kind===174}function Cs(ae){switch(ae.kind){case 263:case 231:return Ny(ae)!==void 0;case 174:case 177:case 178:return!0}return!1}function ss(ae,Ye){let Ot=ae.name;return Zi(Ot)?t.createIdentifier(""):za(Ot)?Ye&&!Qg(Ot.expression)?t.getGeneratedNameForNode(Ot):Ot.expression:He(Ot)?t.createStringLiteral(Nn(Ot)):t.cloneNode(Ot)}function Ii(ae){let Ye=ae.name;if(za(Ye)&&(!Jl(ae)&&ee||Wp(ae)&&x)){let Ot=ot(Ye.expression,le,Ct);M.assert(Ot);let Tr=km(Ot);if(!Qg(Tr)){let Vn=t.getGeneratedNameForNode(Ye);return u(Vn),t.updateComputedPropertyName(Ye,t.createAssignment(Vn,Ot))}}return M.checkDefined(ot(Ye,le,Ol))}function $r(ae){if(ae.token!==119)return Mr(ae,le,e)}function Xs(ae){return t.updateExpressionWithTypeArguments(ae,M.checkDefined(ot(ae.expression,le,xf)),void 0)}function $e(ae){return!$c(ae.body)}function Yt(ae,Ye){let Ot=ae.flags&33554432||li(ae,64);if(Ot&&!(x&&Wp(ae)))return;let Tr=gi(Ye)?Ot?Kr(ae.modifiers,ct,Cc):Kr(ae.modifiers,le,Cc):Kr(ae.modifiers,Be,Cc);return Tr=ur(Tr,ae,Ye),Ot?t.updatePropertyDeclaration(ae,ps(Tr,t.createModifiersFromModifierFlags(128)),M.checkDefined(ot(ae.name,le,Ol)),void 0,void 0,void 0):t.updatePropertyDeclaration(ae,Tr,Ii(ae),void 0,void 0,ot(ae.initializer,le,Ct))}function Vr(ae){if($e(ae))return t.updateConstructorDeclaration(ae,void 0,Kc(ae.parameters,le,e),vi(ae.body,ae))}function An(ae,Ye,Ot,Tr,Vn,pr){let Jn=Tr[Vn],Ri=Ye[Jn];if(wn(ae,Kr(Ye,le,Vi,Ot,Jn-Ot)),c2(Ri)){let Ai=[];An(Ai,Ri.tryBlock.statements,0,Tr,Vn+1,pr);let Na=t.createNodeArray(Ai);Et(Na,Ri.tryBlock.statements),ae.push(t.updateTryStatement(Ri,t.updateBlock(Ri.tryBlock,Ai),ot(Ri.catchClause,le,bE),ot(Ri.finallyBlock,le,Vs)))}else wn(ae,Kr(Ye,le,Vi,Jn,1)),wn(ae,pr);wn(ae,Kr(Ye,le,Vi,Jn+1))}function vi(ae,Ye){let Ot=Ye&&Zn(Ye.parameters,Ai=>ap(Ai,Ye));if(!Pt(Ot))return Qp(ae,le,e);let Tr=[];s();let Vn=t.copyPrologue(ae.statements,Tr,!1,le),pr=DB(ae.statements,Vn),Jn=Gi(Ot,Ci);pr.length?An(Tr,ae.statements,Vn,pr,0,Jn):(wn(Tr,Jn),wn(Tr,Kr(ae.statements,le,Vi,Vn))),Tr=t.mergeLexicalEnvironment(Tr,o());let Ri=t.createBlock(Et(t.createNodeArray(Tr),ae.statements),!0);return Et(Ri,ae),zn(Ri,ae),Ri}function Ci(ae){let Ye=ae.name;if(!He(Ye))return;let Ot=lo(Et(t.cloneNode(Ye),Ye),Ye.parent);Tn(Ot,3168);let Tr=lo(Et(t.cloneNode(Ye),Ye),Ye.parent);return Tn(Tr,3072),T_(n8(Et(zn(t.createExpressionStatement(t.createAssignment(Et(t.createPropertyAccessExpression(t.createThis(),Ot),ae.name),Tr)),ae),mb(ae,-1))))}function Ui(ae,Ye){if(!(ae.transformFlags&1))return ae;if(!$e(ae))return;let Ot=gi(Ye)?Kr(ae.modifiers,le,Cc):Kr(ae.modifiers,Be,Cc);return Ot=ur(Ot,ae,Ye),t.updateMethodDeclaration(ae,Ot,ae.asteriskToken,Ii(ae),void 0,void 0,Kc(ae.parameters,le,e),void 0,Qp(ae.body,le,e))}function la(ae){return!($c(ae.body)&&li(ae,64))}function Gs(ae,Ye){if(!(ae.transformFlags&1))return ae;if(!la(ae))return;let Ot=gi(Ye)?Kr(ae.modifiers,le,Cc):Kr(ae.modifiers,Be,Cc);return Ot=ur(Ot,ae,Ye),t.updateGetAccessorDeclaration(ae,Ot,Ii(ae),Kc(ae.parameters,le,e),void 0,Qp(ae.body,le,e)||t.createBlock([]))}function yr(ae,Ye){if(!(ae.transformFlags&1))return ae;if(!la(ae))return;let Ot=gi(Ye)?Kr(ae.modifiers,le,Cc):Kr(ae.modifiers,Be,Cc);return Ot=ur(Ot,ae,Ye),t.updateSetAccessorDeclaration(ae,Ot,Ii(ae),Kc(ae.parameters,le,e),Qp(ae.body,le,e)||t.createBlock([]))}function to(ae){if(!$e(ae))return t.createNotEmittedStatement(ae);let Ye=t.updateFunctionDeclaration(ae,Kr(ae.modifiers,qe,Pa),ae.asteriskToken,ae.name,void 0,Kc(ae.parameters,le,e),void 0,Qp(ae.body,le,e)||t.createBlock([]));if(er(ae)){let Ot=[Ye];return ms(Ot,ae),Ot}return Ye}function lt(ae){return $e(ae)?t.updateFunctionExpression(ae,Kr(ae.modifiers,qe,Pa),ae.asteriskToken,ae.name,void 0,Kc(ae.parameters,le,e),void 0,Qp(ae.body,le,e)||t.createBlock([])):t.createOmittedExpression()}function St(ae){return t.updateArrowFunction(ae,Kr(ae.modifiers,qe,Pa),void 0,Kc(ae.parameters,le,e),void 0,ae.equalsGreaterThanToken,Qp(ae.body,le,e))}function fe(ae){if(sE(ae))return;let Ye=t.updateParameterDeclaration(ae,Kr(ae.modifiers,Ot=>fu(Ot)?le(Ot):void 0,Cc),ae.dotDotDotToken,M.checkDefined(ot(ae.name,le,Wx)),void 0,void 0,ot(ae.initializer,le,Ct));return Ye!==ae&&(Zl(Ye,ae),Et(Ye,Jg(ae)),qa(Ye,Jg(ae)),Tn(Ye.name,64)),Ye}function vt(ae){if(er(ae)){let Ye=ZI(ae.declarationList);return Ye.length===0?void 0:Et(t.createExpressionStatement(t.inlineExpressions(Cr(Ye,Ce))),ae)}else return Mr(ae,le,e)}function Ce(ae){let Ye=ae.name;return Hs(Ye)?y2(ae,le,e,0,!1,Sc):Et(t.createAssignment(ts(Ye),M.checkDefined(ot(ae.initializer,le,Ct))),ae)}function nt(ae){let Ye=t.updateVariableDeclaration(ae,M.checkDefined(ot(ae.name,le,Wx)),void 0,void 0,ot(ae.initializer,le,Ct));return ae.type&&ede(Ye.name,ae.type),Ye}function Me(ae){let Ye=Ml(ae.expression,-7);if(sb(Ye)||Mj(Ye)){let Ot=ot(ae.expression,le,Ct);return M.assert(Ot),t.createPartiallyEmittedExpression(Ot,ae)}return Mr(ae,le,e)}function tt(ae){let Ye=ot(ae.expression,le,Ct);return M.assert(Ye),t.createPartiallyEmittedExpression(Ye,ae)}function ft(ae){let Ye=ot(ae.expression,le,xf);return M.assert(Ye),t.createPartiallyEmittedExpression(Ye,ae)}function tr(ae){let Ye=ot(ae.expression,le,Ct);return M.assert(Ye),t.createPartiallyEmittedExpression(Ye,ae)}function Oe(ae){return t.updateCallExpression(ae,M.checkDefined(ot(ae.expression,le,Ct)),void 0,Kr(ae.arguments,le,Ct))}function At(ae){return t.updateNewExpression(ae,M.checkDefined(ot(ae.expression,le,Ct)),void 0,Kr(ae.arguments,le,Ct))}function Nt(ae){return t.updateTaggedTemplateExpression(ae,M.checkDefined(ot(ae.tag,le,Ct)),void 0,M.checkDefined(ot(ae.template,le,XC)))}function Ut(ae){return t.updateJsxSelfClosingElement(ae,M.checkDefined(ot(ae.tagName,le,EI)),void 0,M.checkDefined(ot(ae.attributes,le,SE)))}function Rt(ae){return t.updateJsxOpeningElement(ae,M.checkDefined(ot(ae.tagName,le,EI)),void 0,M.checkDefined(ot(ae.attributes,le,SE)))}function nr(ae){return!KT(ae)||lE(d)}function Z(ae){if(!nr(ae))return t.createNotEmittedStatement(ae);let Ye=[],Ot=4,Tr=Re(Ye,ae);Tr&&(E!==4||G!==L)&&(Ot|=1024);let Vn=zi(ae),pr=Eu(ae),Jn=er(ae)?t.getExternalModuleOrNamespaceExportName(J,ae,!1,!0):t.getDeclarationName(ae,!1,!0),Ri=t.createLogicalOr(Jn,t.createAssignment(Jn,t.createObjectLiteralExpression()));if(er(ae)){let Na=t.getLocalName(ae,!1,!0);Ri=t.createAssignment(Na,Ri)}let Ai=t.createExpressionStatement(t.createCallExpression(t.createFunctionExpression(void 0,void 0,void 0,void 0,[t.createParameterDeclaration(void 0,void 0,Vn)],void 0,Ge(ae,pr)),void 0,[Ri]));return zn(Ai,ae),Tr&&(hb(Ai,void 0),PA(Ai,void 0)),Et(Ai,ae),zg(Ai,Ot),Ye.push(Ai),Ye}function Ge(ae,Ye){let Ot=J;J=Ye;let Tr=[];i();let Vn=Cr(ae.members,bt);return Ay(Tr,o()),wn(Tr,Vn),J=Ot,t.createBlock(Et(t.createNodeArray(Tr),ae.members),!0)}function bt(ae){let Ye=ss(ae,!1),Ot=m.getEnumMemberValue(ae),Tr=Q(ae,Ot?.value),Vn=t.createAssignment(t.createElementAccessExpression(J,Ye),Tr),pr=typeof Ot?.value=="string"||Ot?.isSyntacticallyString?Vn:t.createAssignment(t.createElementAccessExpression(J,Vn),Ye);return Et(t.createExpressionStatement(Et(pr,ae)),ae)}function Q(ae,Ye){return Ye!==void 0?typeof Ye=="string"?t.createStringLiteral(Ye):Ye<0?t.createPrefixUnaryExpression(41,t.createNumericLiteral(-Ye)):t.createNumericLiteral(Ye):(kc(),ae.initializer?M.checkDefined(ot(ae.initializer,le,Ct)):t.createVoidZero())}function Ke(ae){let Ye=ks(ae,El);return Ye?hK(Ye,lE(d)):!0}function z(ae){q||(q=new Map);let Ye=Te(ae);q.has(Ye)||q.set(Ye,ae)}function Ue(ae){if(q){let Ye=Te(ae);return q.get(Ye)===ae}return!0}function Te(ae){return M.assertNode(ae.name,He),ae.name.escapedText}function Re(ae,Ye){let Ot=t.createVariableDeclaration(t.getLocalName(Ye,!1,!0)),Tr=G.kind===307?0:1,Vn=t.createVariableStatement(Kr(Ye.modifiers,qe,Pa),t.createVariableDeclarationList([Ot],Tr));return zn(Ot,Ye),hb(Ot,void 0),PA(Ot,void 0),zn(Vn,Ye),z(Ye),Ue(Ye)?(Ye.kind===266?qa(Vn.declarationList,Ye):qa(Vn,Ye),Zl(Vn,Ye),zg(Vn,2048),ae.push(Vn),!0):!1}function It(ae){if(!Ke(ae))return t.createNotEmittedStatement(ae);M.assertNode(ae.name,He,"A TypeScript namespace should have an Identifier name."),P_();let Ye=[],Ot=4,Tr=Re(Ye,ae);Tr&&(E!==4||G!==L)&&(Ot|=1024);let Vn=zi(ae),pr=Eu(ae),Jn=er(ae)?t.getExternalModuleOrNamespaceExportName(J,ae,!1,!0):t.getDeclarationName(ae,!1,!0),Ri=t.createLogicalOr(Jn,t.createAssignment(Jn,t.createObjectLiteralExpression()));if(er(ae)){let Na=t.getLocalName(ae,!1,!0);Ri=t.createAssignment(Na,Ri)}let Ai=t.createExpressionStatement(t.createCallExpression(t.createFunctionExpression(void 0,void 0,void 0,void 0,[t.createParameterDeclaration(void 0,void 0,Vn)],void 0,$t(ae,pr)),void 0,[Ri]));return zn(Ai,ae),Tr&&(hb(Ai,void 0),PA(Ai,void 0)),Et(Ai,ae),zg(Ai,Ot),Ye.push(Ai),Ye}function $t(ae,Ye){let Ot=J,Tr=F,Vn=q;J=Ye,F=ae,q=void 0;let pr=[];i();let Jn,Ri;if(ae.body)if(ae.body.kind===268)ce(ae.body,Na=>wn(pr,Kr(Na.statements,he,Vi))),Jn=ae.body.statements,Ri=ae.body;else{let Na=It(ae.body);Na&&(Rs(Na)?wn(pr,Na):pr.push(Na));let gc=Ht(ae).body;Jn=mb(gc.statements,-1)}Ay(pr,o()),J=Ot,F=Tr,q=Vn;let Ai=t.createBlock(Et(t.createNodeArray(pr),Jn),!0);return Et(Ai,Ri),(!ae.body||ae.body.kind!==268)&&Tn(Ai,Ga(Ai)|3072),Ai}function Ht(ae){if(ae.body.kind===267)return Ht(ae.body)||ae.body}function dr(ae){if(!ae.importClause)return ae;if(ae.importClause.isTypeOnly)return;let Ye=ot(ae.importClause,qr,ig);return Ye?t.updateImportDeclaration(ae,void 0,Ye,ae.moduleSpecifier,ae.attributes):void 0}function qr(ae){M.assert(!ae.isTypeOnly);let Ye=Se(ae)?ae.name:void 0,Ot=ot(ae.namedBindings,Hr,$$);return Ye||Ot?t.updateImportClause(ae,!1,Ye,Ot):void 0}function Hr(ae){if(ae.kind===274)return Se(ae)?ae:void 0;{let Ye=d.verbatimModuleSyntax,Ot=Kr(ae.elements,dn,_f);return Ye||Pt(Ot)?t.updateNamedImports(ae,Ot):void 0}}function dn(ae){return!ae.isTypeOnly&&Se(ae)?ae:void 0}function Ar(ae){return d.verbatimModuleSyntax||m.isValueAliasDeclaration(ae)?Mr(ae,le,e):void 0}function In(ae){if(ae.isTypeOnly)return;if(!ae.exportClause||zh(ae.exportClause))return ae;let Ye=!!d.verbatimModuleSyntax,Ot=ot(ae.exportClause,Tr=>Yn(Tr,Ye),M$);return Ot?t.updateExportDeclaration(ae,void 0,ae.isTypeOnly,Ot,ae.moduleSpecifier,ae.attributes):void 0}function Ki(ae,Ye){let Ot=Kr(ae.elements,pi,b_);return Ye||Pt(Ot)?t.updateNamedExports(ae,Ot):void 0}function ls(ae){return t.updateNamespaceExport(ae,M.checkDefined(ot(ae.name,le,He)))}function Yn(ae,Ye){return zh(ae)?ls(ae):Ki(ae,Ye)}function pi(ae){return!ae.isTypeOnly&&(d.verbatimModuleSyntax||m.isValueAliasDeclaration(ae))?ae:void 0}function Er(ae){return Se(ae)||!nu(L)&&m.isTopLevelValueImportEqualsWithEntityName(ae)}function tn(ae){if(ae.isTypeOnly)return;if(cb(ae))return Se(ae)?Mr(ae,le,e):void 0;if(!Er(ae))return;let Ye=g8(t,ae.moduleReference);return Tn(Ye,7168),uo(ae)||!er(ae)?zn(Et(t.createVariableStatement(Kr(ae.modifiers,qe,Pa),t.createVariableDeclarationList([zn(t.createVariableDeclaration(ae.name,void 0,void 0,Ye),ae)])),ae),ae):zn(sa(ae.name,Ye,ae),ae)}function er(ae){return F!==void 0&&li(ae,32)}function qs(ae){return F===void 0&&li(ae,32)}function uo(ae){return qs(ae)&&!li(ae,2048)}function Mo(ae){return qs(ae)&&li(ae,2048)}function Do(ae){let Ye=t.createAssignment(t.getExternalModuleOrNamespaceExportName(J,ae,!1,!0),t.getLocalName(ae));qa(Ye,Td(ae.name?ae.name.pos:ae.pos,ae.end));let Ot=t.createExpressionStatement(Ye);return qa(Ot,Td(-1,ae.end)),Ot}function ms(ae,Ye){ae.push(Do(Ye))}function sa(ae,Ye,Ot){return Et(t.createExpressionStatement(t.createAssignment(t.getNamespaceMemberName(J,ae,!1,!0),Ye)),Ot)}function Sc(ae,Ye,Ot){return Et(t.createAssignment(ts(ae),Ye),Ot)}function ts(ae){return t.getNamespaceMemberName(J,ae,!1,!0)}function zi(ae){let Ye=t.getGeneratedNameForNode(ae);return qa(Ye,ae.name),Ye}function Eu(ae){return t.getGeneratedNameForNode(ae)}function kc(){W&8||(W|=8,e.enableSubstitution(80))}function P_(){W&2||(W|=2,e.enableSubstitution(80),e.enableSubstitution(304),e.enableEmitNotification(267))}function el(ae){return Bc(ae).kind===267}function Xu(ae){return Bc(ae).kind===266}function Fa(ae,Ye,Ot){let Tr=pe,Vn=L;Ji(Ye)&&(L=Ye),W&2&&el(Ye)&&(pe|=2),W&8&&Xu(Ye)&&(pe|=8),w(ae,Ye,Ot),pe=Tr,L=Vn}function bc(ae,Ye){return Ye=R(ae,Ye),ae===1?po(Ye):p_(Ye)?Lo(Ye):Ye}function Lo(ae){if(W&2){let Ye=ae.name,Ot=Jc(Ye);if(Ot){if(ae.objectAssignmentInitializer){let Tr=t.createAssignment(Ot,ae.objectAssignmentInitializer);return Et(t.createPropertyAssignment(Ye,Tr),ae)}return Et(t.createPropertyAssignment(Ye,Ot),ae)}}return ae}function po(ae){switch(ae.kind){case 80:return _r(ae);case 211:return z_(ae);case 212:return W_(ae)}return ae}function _r(ae){return Jc(ae)||ae}function Jc(ae){if(W&pe&&!xc(ae)&&!k0(ae)){let Ye=m.getReferencedExportContainer(ae,!1);if(Ye&&Ye.kind!==307&&(pe&2&&Ye.kind===267||pe&8&&Ye.kind===266))return Et(t.createPropertyAccessExpression(t.getGeneratedNameForNode(Ye),ae),ae)}}function z_(ae){return mc(ae)}function W_(ae){return mc(ae)}function qf(ae){return ae.replace(/\*\//g,"*_/")}function mc(ae){let Ye=tl(ae);if(Ye!==void 0){Qpe(ae,Ye);let Ot=typeof Ye=="string"?t.createStringLiteral(Ye):Ye<0?t.createPrefixUnaryExpression(41,t.createNumericLiteral(-Ye)):t.createNumericLiteral(Ye);if(!d.removeComments){let Tr=Bc(ae,oc);Tj(Ot,3,` ${qf(Hc(Tr))} `)}return Ot}return ae}function tl(ae){if(!Cd(d))return Wn(ae)||cc(ae)?m.getConstantValue(ae):void 0}function Se(ae){return d.verbatimModuleSyntax||hn(ae)||m.isReferencedAliasDeclaration(ae)}}function lhe(e){let{factory:t,getEmitHelperFactory:n,hoistVariableDeclaration:i,endLexicalEnvironment:s,startLexicalEnvironment:o,resumeLexicalEnvironment:u,addBlockScopedVariable:m}=e,d=e.getEmitResolver(),S=e.getCompilerOptions(),E=Ka(S),x=$R(S),D=!!S.experimentalDecorators,w=!x,R=x&&E<9,L=w||R,F=E<9,J=E<99?-1:x?0:3,G=E<9,q=G&&E>=2,ee=L||F||J===-1,W=e.onSubstituteNode;e.onSubstituteNode=z_;let pe=e.onEmitNode;e.onEmitNode=Jc;let K=!1,re,ue,ce,ne,le,me=new Map,de=new Set,Ae,xe,te=!1,he=!1;return cg(e,be);function be(Se){if(Se.isDeclarationFile||(le=void 0,K=!!(Pm(Se)&32),!ee&&!K))return Se;let ae=Mr(Se,Pe,e);return E0(ae,e.readEmitHelpers()),ae}function Ve(Se){switch(Se.kind){case 129:return Yt()?void 0:Se;default:return ai(Se,Pa)}}function Pe(Se){if(!(Se.transformFlags&16777216)&&!(Se.transformFlags&134234112))return Se;switch(Se.kind){case 129:return M.fail("Use `modifierVisitor` instead.");case 263:return Rt(Se);case 231:return Z(Se);case 175:case 172:return M.fail("Use `classElementVisitor` instead.");case 303:return Xe(Se);case 243:return ht(Se);case 260:return rr(Se);case 169:return vr(Se);case 208:return xr(Se);case 277:return jr(Se);case 81:return _t(Se);case 211:return la(Se);case 212:return Gs(Se);case 224:case 225:return yr(Se,!1);case 226:return Me(Se,!1);case 217:return ft(Se,!1);case 213:return fe(Se);case 244:return lt(Se);case 215:return vt(Se);case 248:return to(Se);case 110:return Q(Se);case 262:case 218:return Pi(void 0,ke,Se);case 176:case 174:case 177:case 178:return Pi(Se,ke,Se);default:return ke(Se)}}function ke(Se){return Mr(Se,Pe,e)}function De(Se){switch(Se.kind){case 224:case 225:return yr(Se,!0);case 226:return Me(Se,!0);case 355:return tt(Se,!0);case 217:return ft(Se,!0);default:return Pe(Se)}}function Be(Se){switch(Se.kind){case 298:return Mr(Se,Be,e);case 233:return Nt(Se);default:return Pe(Se)}}function ct(Se){switch(Se.kind){case 210:case 209:return _r(Se);default:return Pe(Se)}}function qe(Se){switch(Se.kind){case 176:return Pi(Se,Zr,Se);case 177:case 178:case 174:return Pi(Se,Sr,Se);case 172:return Pi(Se,Vr,Se);case 175:return Pi(Se,bt,Se);case 167:return or(Se);case 240:return Se;default:return Cc(Se)?Ve(Se):Pe(Se)}}function et(Se){switch(Se.kind){case 167:return or(Se);default:return Pe(Se)}}function Ie(Se){switch(Se.kind){case 172:return $e(Se);case 177:case 178:return qe(Se);default:M.assertMissingNode(Se,"Expected node to either be a PropertyDeclaration, GetAccessorDeclaration, or SetAccessorDeclaration");break}}function _t(Se){return!F||Vi(Se.parent)?Se:zn(t.createIdentifier(""),Se)}function mt(Se){let ae=zi(Se.left);if(ae){let Ye=ot(Se.right,Pe,Ct);return zn(n().createClassPrivateFieldInHelper(ae.brandCheckIdentifier,Ye),Se)}return Mr(Se,Pe,e)}function Xe(Se){return cp(Se,nt)&&(Se=dp(e,Se)),Mr(Se,Pe,e)}function ht(Se){let ae=ne;ne=[];let Ye=Mr(Se,Pe,e),Ot=Pt(ne)?[Ye,...ne]:Ye;return ne=ae,Ot}function rr(Se){return cp(Se,nt)&&(Se=dp(e,Se)),Mr(Se,Pe,e)}function vr(Se){return cp(Se,nt)&&(Se=dp(e,Se)),Mr(Se,Pe,e)}function xr(Se){return cp(Se,nt)&&(Se=dp(e,Se)),Mr(Se,Pe,e)}function jr(Se){return cp(Se,nt)&&(Se=dp(e,Se,!0,Se.isExportEquals?"":"default")),Mr(Se,Pe,e)}function ur(Se){return Pt(ce)&&(uf(Se)?(ce.push(Se.expression),Se=t.updateParenthesizedExpression(Se,t.inlineExpressions(ce))):(ce.push(Se),Se=t.inlineExpressions(ce)),ce=void 0),Se}function or(Se){let ae=ot(Se.expression,Pe,Ct);return t.updateComputedPropertyName(Se,ur(ae))}function Zr(Se){return Ae?Ue(Se,Ae):ke(Se)}function Oi(Se){return!!(F||Jl(Se)&&Pm(Se)&32)}function Sr(Se){if(M.assert(!Wp(Se)),!j_(Se)||!Oi(Se))return Mr(Se,qe,e);let ae=zi(Se.name);if(M.assert(ae,"Undeclared private name for property declaration."),!ae.isValid)return Se;let Ye=Cs(Se);Ye&&tn().push(t.createAssignment(Ye,t.createFunctionExpression(Zn(Se.modifiers,Ot=>Pa(Ot)&&!RA(Ot)&&!Vde(Ot)),Se.asteriskToken,Ye,void 0,Kc(Se.parameters,Pe,e),void 0,Qp(Se.body,Pe,e))))}function Pi(Se,ae,Ye){if(Se!==xe){let Ot=xe;xe=Se;let Tr=ae(Ye);return xe=Ot,Tr}return ae(Ye)}function Cs(Se){M.assert(Zi(Se.name));let ae=zi(Se.name);if(M.assert(ae,"Undeclared private name for property declaration."),ae.kind==="m")return ae.methodName;if(ae.kind==="a"){if(Sv(Se))return ae.getterName;if(Og(Se))return ae.setterName}}function ss(){let Se=pi();return Se.classThis??Se.classConstructor??Ae?.name}function Ii(Se){let ae=Wg(Se),Ye=Ov(Se),Ot=Se.name,Tr=Ot,Vn=Ot;if(za(Ot)&&!Qg(Ot.expression)){let Wl=Xj(Ot);if(Wl)Tr=t.updateComputedPropertyName(Ot,ot(Ot.expression,Pe,Ct)),Vn=t.updateComputedPropertyName(Ot,Wl.left);else{let Oc=t.createTempVariable(i);qa(Oc,Ot.expression);let du=ot(Ot.expression,Pe,Ct),hc=t.createAssignment(Oc,du);qa(hc,Ot.expression),Tr=t.updateComputedPropertyName(Ot,hc),Vn=t.updateComputedPropertyName(Ot,Oc)}}let pr=Kr(Se.modifiers,Ve,Pa),Jn=AY(t,Se,pr,Se.initializer);zn(Jn,Se),Tn(Jn,3072),qa(Jn,Ye);let Ri=oa(Se)?ss()??t.createThis():t.createThis(),Ai=Eme(t,Se,pr,Tr,Ri);zn(Ai,Se),Zl(Ai,ae),qa(Ai,Ye);let Na=t.createModifiersFromModifierFlags(Vg(pr)),gc=xme(t,Se,Na,Vn,Ri);return zn(gc,Se),Tn(gc,3072),qa(gc,Ye),F8([Jn,Ai,gc],Ie,uu)}function $r(Se){if(Oi(Se)){let ae=zi(Se.name);if(M.assert(ae,"Undeclared private name for property declaration."),!ae.isValid)return Se;if(ae.isStatic&&!F){let Ye=$t(Se,t.createThis());if(Ye)return t.createClassStaticBlockDeclaration(t.createBlock([Ye],!0))}return}return w&&!oa(Se)&&le?.data&&le.data.facts&16?t.updatePropertyDeclaration(Se,Kr(Se.modifiers,Pe,Cc),Se.name,void 0,void 0,void 0):(cp(Se,nt)&&(Se=dp(e,Se)),t.updatePropertyDeclaration(Se,Kr(Se.modifiers,Ve,Pa),ot(Se.name,et,Ol),void 0,void 0,ot(Se.initializer,Pe,Ct)))}function Xs(Se){if(L&&!Ef(Se)){let ae=Ki(Se.name,!!Se.initializer||x);if(ae&&tn().push(...Cme(ae)),oa(Se)&&!F){let Ye=$t(Se,t.createThis());if(Ye){let Ot=t.createClassStaticBlockDeclaration(t.createBlock([Ye]));return zn(Ot,Se),Zl(Ot,Se),Zl(Ye,{pos:-1,end:-1}),hb(Ye,void 0),PA(Ye,void 0),Ot}}return}return t.updatePropertyDeclaration(Se,Kr(Se.modifiers,Ve,Pa),ot(Se.name,et,Ol),void 0,void 0,ot(Se.initializer,Pe,Ct))}function $e(Se){return M.assert(!Wp(Se),"Decorators should already have been transformed and elided."),j_(Se)?$r(Se):Xs(Se)}function Yt(){return J===-1||J===3&&!!le?.data&&!!(le.data.facts&16)}function Vr(Se){return Ef(Se)&&(Yt()||Jl(Se)&&Pm(Se)&32)?Ii(Se):$e(Se)}function An(){return!!xe&&Jl(xe)&&U1(xe)&&Ef(Bc(xe))}function vi(Se){if(An()){let ae=Ml(Se);ae.kind===110&&de.add(ae)}}function Ci(Se,ae){return ae=ot(ae,Pe,Ct),vi(ae),Ui(Se,ae)}function Ui(Se,ae){switch(Zl(ae,mb(ae,-1)),Se.kind){case"a":return n().createClassPrivateFieldGetHelper(ae,Se.brandCheckIdentifier,Se.kind,Se.getterName);case"m":return n().createClassPrivateFieldGetHelper(ae,Se.brandCheckIdentifier,Se.kind,Se.methodName);case"f":return n().createClassPrivateFieldGetHelper(ae,Se.brandCheckIdentifier,Se.kind,Se.isStatic?Se.variableName:void 0);case"untransformed":return M.fail("Access helpers should not be created for untransformed private elements");default:M.assertNever(Se,"Unknown private element type")}}function la(Se){if(Zi(Se.name)){let ae=zi(Se.name);if(ae)return Et(zn(Ci(ae,Se.expression),Se),Se)}if(q&&xe&&Cf(Se)&&He(Se.name)&&r6(xe)&&le?.data){let{classConstructor:ae,superClassReference:Ye,facts:Ot}=le.data;if(Ot&1)return In(Se);if(ae&&Ye){let Tr=t.createReflectGetCall(Ye,t.createStringLiteralFromNode(Se.name),ae);return zn(Tr,Se.expression),Et(Tr,Se.expression),Tr}}return Mr(Se,Pe,e)}function Gs(Se){if(q&&xe&&Cf(Se)&&r6(xe)&&le?.data){let{classConstructor:ae,superClassReference:Ye,facts:Ot}=le.data;if(Ot&1)return In(Se);if(ae&&Ye){let Tr=t.createReflectGetCall(Ye,ot(Se.argumentExpression,Pe,Ct),ae);return zn(Tr,Se.expression),Et(Tr,Se.expression),Tr}}return Mr(Se,Pe,e)}function yr(Se,ae){if(Se.operator===46||Se.operator===47){let Ye=So(Se.operand);if(MP(Ye)){let Ot;if(Ot=zi(Ye.name)){let Tr=ot(Ye.expression,Pe,Ct);vi(Tr);let{readExpression:Vn,initializeExpression:pr}=St(Tr),Jn=Ci(Ot,Vn),Ri=tS(Se)||ae?void 0:t.createTempVariable(i);return Jn=zj(t,Se,Jn,i,Ri),Jn=tr(Ot,pr||Vn,Jn,64),zn(Jn,Se),Et(Jn,Se),Ri&&(Jn=t.createComma(Jn,Ri),Et(Jn,Se)),Jn}}else if(q&&xe&&Cf(Ye)&&r6(xe)&&le?.data){let{classConstructor:Ot,superClassReference:Tr,facts:Vn}=le.data;if(Vn&1){let pr=In(Ye);return tS(Se)?t.updatePrefixUnaryExpression(Se,pr):t.updatePostfixUnaryExpression(Se,pr)}if(Ot&&Tr){let pr,Jn;if(Wn(Ye)?He(Ye.name)&&(Jn=pr=t.createStringLiteralFromNode(Ye.name)):Qg(Ye.argumentExpression)?Jn=pr=Ye.argumentExpression:(Jn=t.createTempVariable(i),pr=t.createAssignment(Jn,ot(Ye.argumentExpression,Pe,Ct))),pr&&Jn){let Ri=t.createReflectGetCall(Tr,Jn,Ot);Et(Ri,Ye);let Ai=ae?void 0:t.createTempVariable(i);return Ri=zj(t,Se,Ri,i,Ai),Ri=t.createReflectSetCall(Tr,pr,Ri,Ot),zn(Ri,Se),Et(Ri,Se),Ai&&(Ri=t.createComma(Ri,Ai),Et(Ri,Se)),Ri}}}}return Mr(Se,Pe,e)}function to(Se){return t.updateForStatement(Se,ot(Se.initializer,De,Sd),ot(Se.condition,Pe,Ct),ot(Se.incrementor,De,Ct),ff(Se.statement,Pe,e))}function lt(Se){return t.updateExpressionStatement(Se,ot(Se.expression,De,Ct))}function St(Se){let ae=Ko(Se)?Se:t.cloneNode(Se);if(Se.kind===110&&de.has(Se)&&de.add(ae),Qg(Se))return{readExpression:ae,initializeExpression:void 0};let Ye=t.createTempVariable(i),Ot=t.createAssignment(Ye,ae);return{readExpression:Ye,initializeExpression:Ot}}function fe(Se){var ae;if(MP(Se.expression)&&zi(Se.expression.name)){let{thisArg:Ye,target:Ot}=t.createCallBinding(Se.expression,i,E);return qx(Se)?t.updateCallChain(Se,t.createPropertyAccessChain(ot(Ot,Pe,Ct),Se.questionDotToken,"call"),void 0,void 0,[ot(Ye,Pe,Ct),...Kr(Se.arguments,Pe,Ct)]):t.updateCallExpression(Se,t.createPropertyAccessExpression(ot(Ot,Pe,Ct),"call"),void 0,[ot(Ye,Pe,Ct),...Kr(Se.arguments,Pe,Ct)])}if(q&&xe&&Cf(Se.expression)&&r6(xe)&&((ae=le?.data)!=null&&ae.classConstructor)){let Ye=t.createFunctionCallCall(ot(Se.expression,Pe,Ct),le.data.classConstructor,Kr(Se.arguments,Pe,Ct));return zn(Ye,Se),Et(Ye,Se),Ye}return Mr(Se,Pe,e)}function vt(Se){var ae;if(MP(Se.tag)&&zi(Se.tag.name)){let{thisArg:Ye,target:Ot}=t.createCallBinding(Se.tag,i,E);return t.updateTaggedTemplateExpression(Se,t.createCallExpression(t.createPropertyAccessExpression(ot(Ot,Pe,Ct),"bind"),void 0,[ot(Ye,Pe,Ct)]),void 0,ot(Se.template,Pe,XC))}if(q&&xe&&Cf(Se.tag)&&r6(xe)&&((ae=le?.data)!=null&&ae.classConstructor)){let Ye=t.createFunctionBindCall(ot(Se.tag,Pe,Ct),le.data.classConstructor,[]);return zn(Ye,Se),Et(Ye,Se),t.updateTaggedTemplateExpression(Se,Ye,void 0,ot(Se.template,Pe,XC))}return Mr(Se,Pe,e)}function Ce(Se){if(le&&me.set(Bc(Se),le),F){if(e6(Se)){let Ot=ot(Se.body.statements[0].expression,Pe,Ct);return Su(Ot,!0)&&Ot.left===Ot.right?void 0:Ot}if(ek(Se))return ot(Se.body.statements[0].expression,Pe,Ct);o();let ae=Pi(Se,Ot=>Kr(Ot,Pe,Vi),Se.body.statements);ae=t.mergeLexicalEnvironment(ae,s());let Ye=t.createImmediatelyInvokedArrowFunction(ae);return zn(So(Ye.expression),Se),zg(So(Ye.expression),4),zn(Ye,Se),Et(Ye,Se),Ye}}function nt(Se){if(eu(Se)&&!Se.name){let ae=wB(Se);return Pt(ae,ek)?!1:(F||!!Pm(Se))&&Pt(ae,Ot=>Gc(Ot)||j_(Ot)||L&&B8(Ot))}return!1}function Me(Se,ae){if(Dv(Se)){let Ye=ce;ce=void 0,Se=t.updateBinaryExpression(Se,ot(Se.left,ct,Ct),Se.operatorToken,ot(Se.right,Pe,Ct));let Ot=Pt(ce)?t.inlineExpressions(cn([...ce,Se])):Se;return ce=Ye,Ot}if(Su(Se)){cp(Se,nt)&&(Se=dp(e,Se),M.assertNode(Se,Su));let Ye=Ml(Se.left,9);if(MP(Ye)){let Ot=zi(Ye.name);if(Ot)return Et(zn(tr(Ot,Ye.expression,Se.right,Se.operatorToken.kind),Se),Se)}else if(q&&xe&&Cf(Se.left)&&r6(xe)&&le?.data){let{classConstructor:Ot,superClassReference:Tr,facts:Vn}=le.data;if(Vn&1)return t.updateBinaryExpression(Se,In(Se.left),Se.operatorToken,ot(Se.right,Pe,Ct));if(Ot&&Tr){let pr=cc(Se.left)?ot(Se.left.argumentExpression,Pe,Ct):He(Se.left.name)?t.createStringLiteralFromNode(Se.left.name):void 0;if(pr){let Jn=ot(Se.right,Pe,Ct);if(XO(Se.operatorToken.kind)){let Ai=pr;Qg(pr)||(Ai=t.createTempVariable(i),pr=t.createAssignment(Ai,pr));let Na=t.createReflectGetCall(Tr,Ai,Ot);zn(Na,Se.left),Et(Na,Se.left),Jn=t.createBinaryExpression(Na,QO(Se.operatorToken.kind),Jn),Et(Jn,Se)}let Ri=ae?void 0:t.createTempVariable(i);return Ri&&(Jn=t.createAssignment(Ri,Jn),Et(Ri,Se)),Jn=t.createReflectSetCall(Tr,pr,Jn,Ot),zn(Jn,Se),Et(Jn,Se),Ri&&(Jn=t.createComma(Jn,Ri),Et(Jn,Se)),Jn}}}}return jEt(Se)?mt(Se):Mr(Se,Pe,e)}function tt(Se,ae){let Ye=ae?j8(Se.elements,De):j8(Se.elements,Pe,De);return t.updateCommaListExpression(Se,Ye)}function ft(Se,ae){let Ye=ae?De:Pe,Ot=ot(Se.expression,Ye,Ct);return t.updateParenthesizedExpression(Se,Ot)}function tr(Se,ae,Ye,Ot){if(ae=ot(ae,Pe,Ct),Ye=ot(Ye,Pe,Ct),vi(ae),XO(Ot)){let{readExpression:Tr,initializeExpression:Vn}=St(ae);ae=Vn||Tr,Ye=t.createBinaryExpression(Ui(Se,Tr),QO(Ot),Ye)}switch(Zl(ae,mb(ae,-1)),Se.kind){case"a":return n().createClassPrivateFieldSetHelper(ae,Se.brandCheckIdentifier,Ye,Se.kind,Se.setterName);case"m":return n().createClassPrivateFieldSetHelper(ae,Se.brandCheckIdentifier,Ye,Se.kind,void 0);case"f":return n().createClassPrivateFieldSetHelper(ae,Se.brandCheckIdentifier,Ye,Se.kind,Se.isStatic?Se.variableName:void 0);case"untransformed":return M.fail("Access helpers should not be created for untransformed private elements");default:M.assertNever(Se,"Unknown private element type")}}function Oe(Se){return Zn(Se.members,Hge)}function At(Se){var ae;let Ye=0,Ot=Bc(Se);gi(Ot)&&Cv(D,Ot)&&(Ye|=1),F&&(DK(Se)||OB(Se))&&(Ye|=2);let Tr=!1,Vn=!1,pr=!1,Jn=!1;for(let Ai of Se.members)oa(Ai)?((Ai.name&&(Zi(Ai.name)||Ef(Ai))&&F||Ef(Ai)&&J===-1&&!Se.name&&!((ae=Se.emitNode)!=null&&ae.classThis))&&(Ye|=2),(Ns(Ai)||Gc(Ai))&&(G&&Ai.transformFlags&16384&&(Ye|=8,Ye&1||(Ye|=2)),q&&Ai.transformFlags&134217728&&(Ye&1||(Ye|=6)))):oE(Bc(Ai))||(Ef(Ai)?(Jn=!0,pr||(pr=j_(Ai))):j_(Ai)?(pr=!0,d.hasNodeCheckFlag(Ai,262144)&&(Ye|=2)):Ns(Ai)&&(Tr=!0,Vn||(Vn=!!Ai.initializer)));return(R&&Tr||w&&Vn||F&&pr||F&&Jn&&J===-1)&&(Ye|=16),Ye}function Nt(Se){var ae;if((((ae=le?.data)==null?void 0:ae.facts)||0)&4){let Ot=t.createTempVariable(i,!0);return pi().superClassReference=Ot,t.updateExpressionWithTypeArguments(Se,t.createAssignment(Ot,ot(Se.expression,Pe,Ct)),void 0)}return Mr(Se,Pe,e)}function Ut(Se,ae){var Ye;let Ot=Ae,Tr=ce,Vn=le;Ae=Se,ce=void 0,ls();let pr=Pm(Se)&32;if(F||pr){let Ai=Ps(Se);if(Ai&&He(Ai))Er().data.className=Ai;else if((Ye=Se.emitNode)!=null&&Ye.assignedName&&La(Se.emitNode.assignedName)){if(Se.emitNode.assignedName.textSourceNode&&He(Se.emitNode.assignedName.textSourceNode))Er().data.className=Se.emitNode.assignedName.textSourceNode;else if(sp(Se.emitNode.assignedName.text,E)){let Na=t.createIdentifier(Se.emitNode.assignedName.text);Er().data.className=Na}}}if(F){let Ai=Oe(Se);Pt(Ai)&&(Er().data.weakSetName=Sc("instances",Ai[0].name))}let Jn=At(Se);Jn&&(pi().facts=Jn),Jn&8&&dn();let Ri=ae(Se,Jn);return Yn(),M.assert(le===Vn),Ae=Ot,ce=Tr,Ri}function Rt(Se){return Ut(Se,nr)}function nr(Se,ae){var Ye,Ot;let Tr;if(ae&2)if(F&&((Ye=Se.emitNode)!=null&&Ye.classThis))pi().classConstructor=Se.emitNode.classThis,Tr=t.createAssignment(Se.emitNode.classThis,t.getInternalName(Se));else{let hc=t.createTempVariable(i,!0);pi().classConstructor=t.cloneNode(hc),Tr=t.createAssignment(hc,t.getInternalName(Se))}(Ot=Se.emitNode)!=null&&Ot.classThis&&(pi().classThis=Se.emitNode.classThis);let Vn=d.hasNodeCheckFlag(Se,262144),pr=li(Se,32),Jn=li(Se,2048),Ri=Kr(Se.modifiers,Ve,Pa),Ai=Kr(Se.heritageClauses,Be,pp),{members:Na,prologue:gc}=Ke(Se),Wl=[];if(Tr&&tn().unshift(Tr),Pt(ce)&&Wl.push(t.createExpressionStatement(t.inlineExpressions(ce))),w||F||Pm(Se)&32){let hc=wB(Se);Pt(hc)&&It(Wl,hc,t.getInternalName(Se))}Wl.length>0&&pr&&Jn&&(Ri=Kr(Ri,hc=>S8(hc)?void 0:hc,Pa),Wl.push(t.createExportAssignment(void 0,!1,t.getLocalName(Se,!1,!0))));let Oc=pi().classConstructor;Vn&&Oc&&(Hr(),ue[pf(Se)]=Oc);let du=t.updateClassDeclaration(Se,Ri,Se.name,void 0,Ai,Na);return Wl.unshift(du),gc&&Wl.unshift(t.createExpressionStatement(gc)),Wl}function Z(Se){return Ut(Se,Ge)}function Ge(Se,ae){var Ye,Ot,Tr;let Vn=!!(ae&1),pr=wB(Se),Jn=d.hasNodeCheckFlag(Se,262144),Ri=d.hasNodeCheckFlag(Se,32768),Ai;function Na(){var rl;if(F&&((rl=Se.emitNode)!=null&&rl.classThis))return pi().classConstructor=Se.emitNode.classThis;let $l=t.createTempVariable(Ri?m:i,!0);return pi().classConstructor=t.cloneNode($l),$l}(Ye=Se.emitNode)!=null&&Ye.classThis&&(pi().classThis=Se.emitNode.classThis),ae&2&&(Ai??(Ai=Na()));let gc=Kr(Se.modifiers,Ve,Pa),Wl=Kr(Se.heritageClauses,Be,pp),{members:Oc,prologue:du}=Ke(Se),hc=t.updateClassExpression(Se,gc,Se.name,void 0,Wl,Oc),mu=[];if(du&&mu.push(du),(F||Pm(Se)&32)&&Pt(pr,rl=>Gc(rl)||j_(rl)||L&&B8(rl))||Pt(ce))if(Vn)M.assertIsDefined(ne,"Decorated classes transformed by TypeScript are expected to be within a variable declaration."),Pt(ce)&&wn(ne,Cr(ce,t.createExpressionStatement)),Pt(pr)&&It(ne,pr,((Ot=Se.emitNode)==null?void 0:Ot.classThis)??t.getInternalName(Se)),Ai?mu.push(t.createAssignment(Ai,hc)):F&&((Tr=Se.emitNode)!=null&&Tr.classThis)?mu.push(t.createAssignment(Se.emitNode.classThis,hc)):mu.push(hc);else{if(Ai??(Ai=Na()),Jn){Hr();let rl=t.cloneNode(Ai);rl.emitNode.autoGenerate.flags&=-9,ue[pf(Se)]=rl}mu.push(t.createAssignment(Ai,hc)),wn(mu,ce),wn(mu,Ht(pr,Ai)),mu.push(t.cloneNode(Ai))}else mu.push(hc);return mu.length>1&&(zg(hc,131072),mu.forEach(T_)),t.inlineExpressions(mu)}function bt(Se){if(!F)return Mr(Se,Pe,e)}function Q(Se){if(G&&xe&&Gc(xe)&&le?.data){let{classThis:ae,classConstructor:Ye}=le.data;return ae??Ye??Se}return Se}function Ke(Se){let ae=!!(Pm(Se)&32);if(F||K){for(let pr of Se.members)if(j_(pr))if(Oi(pr))sa(pr,pr.name,er);else{let Jn=Er();h2(Jn,pr.name,{kind:"untransformed"})}if(F&&Pt(Oe(Se))&&z(),Yt()){for(let pr of Se.members)if(Ef(pr)){let Jn=t.getGeneratedPrivateNameForNode(pr.name,void 0,"_accessor_storage");if(F||ae&&Jl(pr))sa(pr,Jn,qs);else{let Ri=Er();h2(Ri,Jn,{kind:"untransformed"})}}}}let Ye=Kr(Se.members,qe,uu),Ot;Pt(Ye,Vc)||(Ot=Ue(void 0,Se));let Tr,Vn;if(!F&&Pt(ce)){let pr=t.createExpressionStatement(t.inlineExpressions(ce));if(pr.transformFlags&134234112){let Ri=t.createTempVariable(i),Ai=t.createArrowFunction(void 0,void 0,[],void 0,void 0,t.createBlock([pr]));Tr=t.createAssignment(Ri,Ai),pr=t.createExpressionStatement(t.createCallExpression(Ri,void 0,[]))}let Jn=t.createBlock([pr]);Vn=t.createClassStaticBlockDeclaration(Jn),ce=void 0}if(Ot||Vn){let pr,Jn=Ln(Ye,e6),Ri=Ln(Ye,ek);pr=Bt(pr,Jn),pr=Bt(pr,Ri),pr=Bt(pr,Ot),pr=Bt(pr,Vn);let Ai=Jn||Ri?Zn(Ye,Na=>Na!==Jn&&Na!==Ri):Ye;pr=wn(pr,Ai),Ye=Et(t.createNodeArray(pr),Se.members)}return{members:Ye,prologue:Tr}}function z(){let{weakSetName:Se}=Er().data;M.assert(Se,"weakSetName should be set in private identifier environment"),tn().push(t.createAssignment(Se,t.createNewExpression(t.createIdentifier("WeakSet"),void 0,[])))}function Ue(Se,ae){if(Se=ot(Se,Pe,Vc),!le?.data||!(le.data.facts&16))return Se;let Ye=Fg(ae),Ot=!!(Ye&&Ml(Ye.expression).kind!==106),Tr=Kc(Se?Se.parameters:void 0,Pe,e),Vn=Re(ae,Se,Ot);return Vn?Se?(M.assert(Tr),t.updateConstructorDeclaration(Se,void 0,Tr,Vn)):T_(zn(Et(t.createConstructorDeclaration(void 0,Tr??[],Vn),Se||ae),Se)):Se}function Te(Se,ae,Ye,Ot,Tr,Vn,pr){let Jn=Ot[Tr],Ri=ae[Jn];if(wn(Se,Kr(ae,Pe,Vi,Ye,Jn-Ye)),Ye=Jn+1,c2(Ri)){let Ai=[];Te(Ai,Ri.tryBlock.statements,0,Ot,Tr+1,Vn,pr);let Na=t.createNodeArray(Ai);Et(Na,Ri.tryBlock.statements),Se.push(t.updateTryStatement(Ri,t.updateBlock(Ri.tryBlock,Ai),ot(Ri.catchClause,Pe,bE),ot(Ri.finallyBlock,Pe,Vs)))}else{for(wn(Se,Kr(ae,Pe,Vi,Jn,1));Ye<ae.length;){let Ai=ae[Ye];if(ap(Bc(Ai),pr))Ye++;else break}wn(Se,Vn)}wn(Se,Kr(ae,Pe,Vi,Ye))}function Re(Se,ae,Ye){let Ot=kK(Se,!1,!1),Tr=Ot;x||(Tr=Zn(Tr,Oc=>!!Oc.initializer||Zi(Oc.name)||Ug(Oc)));let Vn=Oe(Se),pr=Pt(Tr)||Pt(Vn);if(!ae&&!pr)return Qp(void 0,Pe,e);u();let Jn=!ae&&Ye,Ri=0,Ai=[],Na=[],gc=t.createThis();if(Ar(Na,Vn,gc),ae){let Oc=Zn(Ot,hc=>ap(Bc(hc),ae)),du=Zn(Tr,hc=>!ap(Bc(hc),ae));It(Na,Oc,gc),It(Na,du,gc)}else It(Na,Tr,gc);if(ae?.body){Ri=t.copyPrologue(ae.body.statements,Ai,!1,Pe);let Oc=DB(ae.body.statements,Ri);if(Oc.length)Te(Ai,ae.body.statements,Ri,Oc,0,Na,ae);else{for(;Ri<ae.body.statements.length;){let du=ae.body.statements[Ri];if(ap(Bc(du),ae))Ri++;else break}wn(Ai,Na),wn(Ai,Kr(ae.body.statements,Pe,Vi,Ri))}}else Jn&&Ai.push(t.createExpressionStatement(t.createCallExpression(t.createSuper(),void 0,[t.createSpreadElement(t.createIdentifier("arguments"))]))),wn(Ai,Na);if(Ai=t.mergeLexicalEnvironment(Ai,s()),Ai.length===0&&!ae)return;let Wl=ae?.body&&ae.body.statements.length>=Ai.length?ae.body.multiLine??Ai.length>0:Ai.length>0;return Et(t.createBlock(Et(t.createNodeArray(Ai),ae?ae.body.statements:Se.members),Wl),ae?ae.body:void 0)}function It(Se,ae,Ye){for(let Ot of ae){if(oa(Ot)&&!F)continue;let Tr=$t(Ot,Ye);Tr&&Se.push(Tr)}}function $t(Se,ae){let Ye=Gc(Se)?Pi(Se,Ce,Se):dr(Se,ae);if(!Ye)return;let Ot=t.createExpressionStatement(Ye);zn(Ot,Se),zg(Ot,Ga(Se)&3072),Zl(Ot,Se);let Tr=Bc(Se);return ns(Tr)?(qa(Ot,Tr),n8(Ot)):qa(Ot,Jg(Se)),hb(Ye,void 0),PA(Ye,void 0),Ug(Tr)&&zg(Ot,3072),Ot}function Ht(Se,ae){let Ye=[];for(let Ot of Se){let Tr=Gc(Ot)?Pi(Ot,Ce,Ot):Pi(Ot,()=>dr(Ot,ae),void 0);Tr&&(T_(Tr),zn(Tr,Ot),zg(Tr,Ga(Ot)&3072),qa(Tr,Jg(Ot)),Zl(Tr,Ot),Ye.push(Tr))}return Ye}function dr(Se,ae){var Ye;let Ot=xe,Tr=qr(Se,ae);return Tr&&Jl(Se)&&((Ye=le?.data)!=null&&Ye.facts)&&(zn(Tr,Se),zg(Tr,4),qa(Tr,Ov(Se.name)),me.set(Bc(Se),le)),xe=Ot,Tr}function qr(Se,ae){let Ye=!x;cp(Se,nt)&&(Se=dp(e,Se));let Ot=Ug(Se)?t.getGeneratedPrivateNameForNode(Se.name):za(Se.name)&&!Qg(Se.name.expression)?t.updateComputedPropertyName(Se.name,t.getGeneratedNameForNode(Se.name)):Se.name;if(Jl(Se)&&(xe=Se),Zi(Ot)&&Oi(Se)){let pr=zi(Ot);if(pr)return pr.kind==="f"?pr.isStatic?REt(t,pr.variableName,ot(Se.initializer,Pe,Ct)):MEt(t,ae,ot(Se.initializer,Pe,Ct),pr.brandCheckIdentifier):void 0;M.fail("Undeclared private name for property declaration.")}if((Zi(Ot)||Jl(Se))&&!Se.initializer)return;let Tr=Bc(Se);if(li(Tr,64))return;let Vn=ot(Se.initializer,Pe,Ct);if(ap(Tr,Tr.parent)&&He(Ot)){let pr=t.cloneNode(Ot);Vn?(uf(Vn)&&h8(Vn.expression)&&bO(Vn.expression.left,"___runInitializers")&&BA(Vn.expression.right)&&Pf(Vn.expression.right.expression)&&(Vn=Vn.expression.left),Vn=t.inlineExpressions([Vn,pr])):Vn=pr,Tn(Ot,3168),qa(pr,Tr.name),Tn(pr,3072)}else Vn??(Vn=t.createVoidZero());if(Ye||Zi(Ot)){let pr=d2(t,ae,Ot,Ot);return zg(pr,1024),t.createAssignment(pr,Vn)}else{let pr=za(Ot)?Ot.expression:He(Ot)?t.createStringLiteral(Qi(Ot.escapedText)):Ot,Jn=t.createPropertyDescriptor({value:Vn,configurable:!0,writable:!0,enumerable:!0});return t.createObjectDefinePropertyCall(ae,pr,Jn)}}function Hr(){re&1||(re|=1,e.enableSubstitution(80),ue=[])}function dn(){re&2||(re|=2,e.enableSubstitution(110),e.enableEmitNotification(262),e.enableEmitNotification(218),e.enableEmitNotification(176),e.enableEmitNotification(177),e.enableEmitNotification(178),e.enableEmitNotification(174),e.enableEmitNotification(172),e.enableEmitNotification(167))}function Ar(Se,ae,Ye){if(!F||!Pt(ae))return;let{weakSetName:Ot}=Er().data;M.assert(Ot,"weakSetName should be set in private identifier environment"),Se.push(t.createExpressionStatement(LEt(t,Ye,Ot)))}function In(Se){return Wn(Se)?t.updatePropertyAccessExpression(Se,t.createVoidZero(),Se.name):t.updateElementAccessExpression(Se,t.createVoidZero(),ot(Se.argumentExpression,Pe,Ct))}function Ki(Se,ae){if(za(Se)){let Ye=Xj(Se),Ot=ot(Se.expression,Pe,Ct),Tr=km(Ot),Vn=Qg(Tr);if(!(!!Ye||Su(Tr)&&xc(Tr.left))&&!Vn&&ae){let Jn=t.getGeneratedNameForNode(Se);return d.hasNodeCheckFlag(Se,32768)?m(Jn):i(Jn),t.createAssignment(Jn,Ot)}return Vn||He(Tr)?void 0:Ot}}function ls(){le={previous:le,data:void 0}}function Yn(){le=le?.previous}function pi(){return M.assert(le),le.data??(le.data={facts:0,classConstructor:void 0,classThis:void 0,superClassReference:void 0})}function Er(){return M.assert(le),le.privateEnv??(le.privateEnv=Kge({className:void 0,weakSetName:void 0}))}function tn(){return ce??(ce=[])}function er(Se,ae,Ye,Ot,Tr,Vn,pr){Ef(Se)?ms(Se,ae,Ye,Ot,Tr,Vn,pr):Ns(Se)?qs(Se,ae,Ye,Ot,Tr,Vn,pr):ul(Se)?uo(Se,ae,Ye,Ot,Tr,Vn,pr):Hp(Se)?Mo(Se,ae,Ye,Ot,Tr,Vn,pr):fp(Se)&&Do(Se,ae,Ye,Ot,Tr,Vn,pr)}function qs(Se,ae,Ye,Ot,Tr,Vn,pr){if(Tr){let Jn=M.checkDefined(Ye.classThis??Ye.classConstructor,"classConstructor should be set in private identifier environment"),Ri=ts(ae);h2(Ot,ae,{kind:"f",isStatic:!0,brandCheckIdentifier:Jn,variableName:Ri,isValid:Vn})}else{let Jn=ts(ae);h2(Ot,ae,{kind:"f",isStatic:!1,brandCheckIdentifier:Jn,isValid:Vn}),tn().push(t.createAssignment(Jn,t.createNewExpression(t.createIdentifier("WeakMap"),void 0,[])))}}function uo(Se,ae,Ye,Ot,Tr,Vn,pr){let Jn=ts(ae),Ri=Tr?M.checkDefined(Ye.classThis??Ye.classConstructor,"classConstructor should be set in private identifier environment"):M.checkDefined(Ot.data.weakSetName,"weakSetName should be set in private identifier environment");h2(Ot,ae,{kind:"m",methodName:Jn,brandCheckIdentifier:Ri,isStatic:Tr,isValid:Vn})}function Mo(Se,ae,Ye,Ot,Tr,Vn,pr){let Jn=ts(ae,"_get"),Ri=Tr?M.checkDefined(Ye.classThis??Ye.classConstructor,"classConstructor should be set in private identifier environment"):M.checkDefined(Ot.data.weakSetName,"weakSetName should be set in private identifier environment");pr?.kind==="a"&&pr.isStatic===Tr&&!pr.getterName?pr.getterName=Jn:h2(Ot,ae,{kind:"a",getterName:Jn,setterName:void 0,brandCheckIdentifier:Ri,isStatic:Tr,isValid:Vn})}function Do(Se,ae,Ye,Ot,Tr,Vn,pr){let Jn=ts(ae,"_set"),Ri=Tr?M.checkDefined(Ye.classThis??Ye.classConstructor,"classConstructor should be set in private identifier environment"):M.checkDefined(Ot.data.weakSetName,"weakSetName should be set in private identifier environment");pr?.kind==="a"&&pr.isStatic===Tr&&!pr.setterName?pr.setterName=Jn:h2(Ot,ae,{kind:"a",getterName:void 0,setterName:Jn,brandCheckIdentifier:Ri,isStatic:Tr,isValid:Vn})}function ms(Se,ae,Ye,Ot,Tr,Vn,pr){let Jn=ts(ae,"_get"),Ri=ts(ae,"_set"),Ai=Tr?M.checkDefined(Ye.classThis??Ye.classConstructor,"classConstructor should be set in private identifier environment"):M.checkDefined(Ot.data.weakSetName,"weakSetName should be set in private identifier environment");h2(Ot,ae,{kind:"a",getterName:Jn,setterName:Ri,brandCheckIdentifier:Ai,isStatic:Tr,isValid:Vn})}function sa(Se,ae,Ye){let Ot=pi(),Tr=Er(),Vn=NK(Tr,ae),pr=Jl(Se),Jn=!FEt(ae)&&Vn===void 0;Ye(Se,ae,Ot,Tr,pr,Jn,Vn)}function Sc(Se,ae,Ye){let{className:Ot}=Er().data,Tr=Ot?{prefix:"_",node:Ot,suffix:"_"}:"_",Vn=typeof Se=="object"?t.getGeneratedNameForNode(Se,24,Tr,Ye):typeof Se=="string"?t.createUniqueName(Se,16,Tr,Ye):t.createTempVariable(void 0,!0,Tr,Ye);return d.hasNodeCheckFlag(ae,32768)?m(Vn):i(Vn),Vn}function ts(Se,ae){let Ye=PI(Se);return Sc(Ye?.substring(1)??Se,Se,ae)}function zi(Se){let ae=Xge(le,Se);return ae?.kind==="untransformed"?void 0:ae}function Eu(Se){let ae=t.getGeneratedNameForNode(Se),Ye=zi(Se.name);if(!Ye)return Mr(Se,Pe,e);let Ot=Se.expression;return(aR(Se)||Cf(Se)||!xE(Se.expression))&&(Ot=t.createTempVariable(i,!0),tn().push(t.createBinaryExpression(Ot,64,ot(Se.expression,Pe,Ct)))),t.createAssignmentTargetWrapper(ae,tr(Ye,Ot,ae,64))}function kc(Se){if(Ca(Se)||Gu(Se))return _r(Se);if(MP(Se))return Eu(Se);if(q&&xe&&Cf(Se)&&r6(xe)&&le?.data){let{classConstructor:ae,superClassReference:Ye,facts:Ot}=le.data;if(Ot&1)return In(Se);if(ae&&Ye){let Tr=cc(Se)?ot(Se.argumentExpression,Pe,Ct):He(Se.name)?t.createStringLiteralFromNode(Se.name):void 0;if(Tr){let Vn=t.createTempVariable(void 0);return t.createAssignmentTargetWrapper(Vn,t.createReflectSetCall(Ye,Tr,Vn,ae))}}}return Mr(Se,Pe,e)}function P_(Se){if(cp(Se,nt)&&(Se=dp(e,Se)),Su(Se,!0)){let ae=kc(Se.left),Ye=ot(Se.right,Pe,Ct);return t.updateBinaryExpression(Se,ae,Se.operatorToken,Ye)}return kc(Se)}function el(Se){if(xf(Se.expression)){let ae=kc(Se.expression);return t.updateSpreadElement(Se,ae)}return Mr(Se,Pe,e)}function Xu(Se){if(V3(Se)){if(Ad(Se))return el(Se);if(!pu(Se))return P_(Se)}return Mr(Se,Pe,e)}function Fa(Se){let ae=ot(Se.name,Pe,Ol);if(Su(Se.initializer,!0)){let Ye=P_(Se.initializer);return t.updatePropertyAssignment(Se,ae,Ye)}if(xf(Se.initializer)){let Ye=kc(Se.initializer);return t.updatePropertyAssignment(Se,ae,Ye)}return Mr(Se,Pe,e)}function bc(Se){return cp(Se,nt)&&(Se=dp(e,Se)),Mr(Se,Pe,e)}function Lo(Se){if(xf(Se.expression)){let ae=kc(Se.expression);return t.updateSpreadAssignment(Se,ae)}return Mr(Se,Pe,e)}function po(Se){return M.assertNode(Se,U3),Fy(Se)?Lo(Se):p_(Se)?bc(Se):ql(Se)?Fa(Se):Mr(Se,Pe,e)}function _r(Se){return Gu(Se)?t.updateArrayLiteralExpression(Se,Kr(Se.elements,Xu,Ct)):t.updateObjectLiteralExpression(Se,Kr(Se.properties,po,p0))}function Jc(Se,ae,Ye){let Ot=Bc(ae),Tr=me.get(Ot);if(Tr){let Vn=le,pr=he;le=Tr,he=te,te=!Gc(Ot)||!(Pm(Ot)&32),pe(Se,ae,Ye),te=he,he=pr,le=Vn;return}switch(ae.kind){case 218:if(pc(Ot)||Ga(ae)&524288)break;case 262:case 176:case 177:case 178:case 174:case 172:{let Vn=le,pr=he;le=void 0,he=te,te=!1,pe(Se,ae,Ye),te=he,he=pr,le=Vn;return}case 167:{let Vn=le,pr=te;le=le?.previous,te=he,pe(Se,ae,Ye),te=pr,le=Vn;return}}pe(Se,ae,Ye)}function z_(Se,ae){return ae=W(Se,ae),Se===1?W_(ae):ae}function W_(Se){switch(Se.kind){case 80:return mc(Se);case 110:return qf(Se)}return Se}function qf(Se){if(re&2&&le?.data&&!de.has(Se)){let{facts:ae,classConstructor:Ye,classThis:Ot}=le.data,Tr=te?Ot??Ye:Ye;if(Tr)return Et(zn(t.cloneNode(Tr),Se),Se);if(ae&1&&D)return t.createParenthesizedExpression(t.createVoidZero())}return Se}function mc(Se){return tl(Se)||Se}function tl(Se){if(re&1&&d.hasNodeCheckFlag(Se,536870912)){let ae=d.getReferencedValueDeclaration(Se);if(ae){let Ye=ue[ae.id];if(Ye){let Ot=t.cloneNode(Ye);return qa(Ot,Se),Zl(Ot,Se),Ot}}}}}function REt(e,t,n){return e.createAssignment(t,e.createObjectLiteralExpression([e.createPropertyAssignment("value",n||e.createVoidZero())]))}function MEt(e,t,n,i){return e.createCallExpression(e.createPropertyAccessExpression(i,"set"),void 0,[t,n||e.createVoidZero()])}function LEt(e,t,n){return e.createCallExpression(e.createPropertyAccessExpression(n,"add"),void 0,[t])}function FEt(e){return!zx(e)&&e.escapedText==="#constructor"}function jEt(e){return Zi(e.left)&&e.operatorToken.kind===103}function BEt(e){return Ns(e)&&Jl(e)}function r6(e){return Gc(e)||BEt(e)}function uhe(e){let{factory:t,hoistVariableDeclaration:n}=e,i=e.getEmitResolver(),s=e.getCompilerOptions(),o=Ka(s),u=J_(s,"strictNullChecks"),m,d;return{serializeTypeNode:(ce,ne)=>S(ce,L,ne),serializeTypeOfNode:(ce,ne,le)=>S(ce,x,ne,le),serializeParameterTypesOfNode:(ce,ne,le)=>S(ce,D,ne,le),serializeReturnTypeOfNode:(ce,ne)=>S(ce,R,ne)};function S(ce,ne,le,me){let de=m,Ae=d;m=ce.currentLexicalScope,d=ce.currentNameScope;let xe=me===void 0?ne(le):ne(le,me);return m=de,d=Ae,xe}function E(ce,ne){let le=W1(ne.members,ce);return le.setAccessor&&Nfe(le.setAccessor)||le.getAccessor&&lp(le.getAccessor)}function x(ce,ne){switch(ce.kind){case 172:case 169:return L(ce.type);case 178:case 177:return L(E(ce,ne));case 263:case 231:case 174:return t.createIdentifier("Function");default:return t.createVoidZero()}}function D(ce,ne){let le=gi(ce)?Ny(ce):Bs(ce)&&Yd(ce.body)?ce:void 0,me=[];if(le){let de=w(le,ne),Ae=de.length;for(let xe=0;xe<Ae;xe++){let te=de[xe];xe===0&&He(te.name)&&te.name.escapedText==="this"||(te.dotDotDotToken?me.push(L(gH(te.type))):me.push(x(te,ne)))}}return t.createArrayLiteralExpression(me)}function w(ce,ne){if(ne&&ce.kind===177){let{setAccessor:le}=W1(ne.members,ce);if(le)return le.parameters}return ce.parameters}function R(ce){return Bs(ce)&&ce.type?L(ce.type):VI(ce)?t.createIdentifier("Promise"):t.createVoidZero()}function L(ce){if(ce===void 0)return t.createIdentifier("Object");switch(ce=FI(ce),ce.kind){case 116:case 157:case 146:return t.createVoidZero();case 184:case 185:return t.createIdentifier("Function");case 188:case 189:return t.createIdentifier("Array");case 182:return ce.assertsModifier?t.createVoidZero():t.createIdentifier("Boolean");case 136:return t.createIdentifier("Boolean");case 203:case 154:return t.createIdentifier("String");case 151:return t.createIdentifier("Object");case 201:return F(ce.literal);case 150:return t.createIdentifier("Number");case 163:return ue("BigInt",7);case 155:return ue("Symbol",2);case 183:return q(ce);case 193:return J(ce.types,!0);case 192:return J(ce.types,!1);case 194:return J([ce.trueType,ce.falseType],!1);case 198:if(ce.operator===148)return L(ce.type);break;case 186:case 199:case 200:case 187:case 133:case 159:case 197:case 205:break;case 312:case 313:case 317:case 318:case 319:break;case 314:case 315:case 316:return L(ce.type);default:return M.failBadSyntaxKind(ce)}return t.createIdentifier("Object")}function F(ce){switch(ce.kind){case 11:case 15:return t.createIdentifier("String");case 224:{let ne=ce.operand;switch(ne.kind){case 9:case 10:return F(ne);default:return M.failBadSyntaxKind(ne)}}case 9:return t.createIdentifier("Number");case 10:return ue("BigInt",7);case 112:case 97:return t.createIdentifier("Boolean");case 106:return t.createVoidZero();default:return M.failBadSyntaxKind(ce)}}function J(ce,ne){let le;for(let me of ce){if(me=FI(me),me.kind===146){if(ne)return t.createVoidZero();continue}if(me.kind===159){if(!ne)return t.createIdentifier("Object");continue}if(me.kind===133)return t.createIdentifier("Object");if(!u&&(Mv(me)&&me.literal.kind===106||me.kind===157))continue;let de=L(me);if(He(de)&&de.escapedText==="Object")return de;if(le){if(!G(le,de))return t.createIdentifier("Object")}else le=de}return le??t.createVoidZero()}function G(ce,ne){return xc(ce)?xc(ne):He(ce)?He(ne)&&ce.escapedText===ne.escapedText:Wn(ce)?Wn(ne)&&G(ce.expression,ne.expression)&&G(ce.name,ne.name):BA(ce)?BA(ne)&&Pf(ce.expression)&&ce.expression.text==="0"&&Pf(ne.expression)&&ne.expression.text==="0":La(ce)?La(ne)&&ce.text===ne.text:vN(ce)?vN(ne)&&G(ce.expression,ne.expression):uf(ce)?uf(ne)&&G(ce.expression,ne.expression):UA(ce)?UA(ne)&&G(ce.condition,ne.condition)&&G(ce.whenTrue,ne.whenTrue)&&G(ce.whenFalse,ne.whenFalse):Pn(ce)?Pn(ne)&&ce.operatorToken.kind===ne.operatorToken.kind&&G(ce.left,ne.left)&&G(ce.right,ne.right):!1}function q(ce){let ne=i.getTypeReferenceSerializationKind(ce.typeName,d??m);switch(ne){case 0:if(Pr(ce,de=>de.parent&&dE(de.parent)&&(de.parent.trueType===de||de.parent.falseType===de)))return t.createIdentifier("Object");let le=W(ce.typeName),me=t.createTempVariable(n);return t.createConditionalExpression(t.createTypeCheck(t.createAssignment(me,le),"function"),void 0,me,void 0,t.createIdentifier("Object"));case 1:return pe(ce.typeName);case 2:return t.createVoidZero();case 4:return ue("BigInt",7);case 6:return t.createIdentifier("Boolean");case 3:return t.createIdentifier("Number");case 5:return t.createIdentifier("String");case 7:return t.createIdentifier("Array");case 8:return ue("Symbol",2);case 10:return t.createIdentifier("Function");case 9:return t.createIdentifier("Promise");case 11:return t.createIdentifier("Object");default:return M.assertNever(ne)}}function ee(ce,ne){return t.createLogicalAnd(t.createStrictInequality(t.createTypeOfExpression(ce),t.createStringLiteral("undefined")),ne)}function W(ce){if(ce.kind===80){let me=pe(ce);return ee(me,me)}if(ce.left.kind===80)return ee(pe(ce.left),pe(ce));let ne=W(ce.left),le=t.createTempVariable(n);return t.createLogicalAnd(t.createLogicalAnd(ne.left,t.createStrictInequality(t.createAssignment(le,ne.right),t.createVoidZero())),t.createPropertyAccessExpression(le,ce.right))}function pe(ce){switch(ce.kind){case 80:let ne=lo(Et(Cb.cloneNode(ce),ce),ce.parent);return ne.original=void 0,lo(ne,ks(m)),ne;case 166:return K(ce)}}function K(ce){return t.createPropertyAccessExpression(pe(ce.left),ce.right)}function re(ce){return t.createConditionalExpression(t.createTypeCheck(t.createIdentifier(ce),"function"),void 0,t.createIdentifier(ce),void 0,t.createIdentifier("Object"))}function ue(ce,ne){return o<ne?re(ce):t.createIdentifier(ce)}}function _he(e){let{factory:t,getEmitHelperFactory:n,hoistVariableDeclaration:i}=e,s=e.getEmitResolver(),o=e.getCompilerOptions(),u=Ka(o),m=e.onSubstituteNode;e.onSubstituteNode=et;let d;return cg(e,S);function S(Xe){let ht=Mr(Xe,x,e);return E0(ht,e.readEmitHelpers()),ht}function E(Xe){return fu(Xe)?void 0:Xe}function x(Xe){if(!(Xe.transformFlags&33554432))return Xe;switch(Xe.kind){case 170:return;case 263:return D(Xe);case 231:return q(Xe);case 176:return ee(Xe);case 174:return pe(Xe);case 178:return re(Xe);case 177:return K(Xe);case 172:return ue(Xe);case 169:return ce(Xe);default:return Mr(Xe,x,e)}}function D(Xe){if(!(Cv(!0,Xe)||wI(!0,Xe)))return Mr(Xe,x,e);let ht=Cv(!0,Xe)?G(Xe,Xe.name):J(Xe,Xe.name);return wh(ht)}function w(Xe){return!!(Xe.transformFlags&536870912)}function R(Xe){return Pt(Xe,w)}function L(Xe){for(let ht of Xe.members){if(!TE(ht))continue;let rr=IB(ht,Xe,!0);if(Pt(rr?.decorators,w)||Pt(rr?.parameters,R))return!0}return!1}function F(Xe,ht){let rr=[];return me(rr,Xe,!1),me(rr,Xe,!0),L(Xe)&&(ht=Et(t.createNodeArray([...ht,t.createClassStaticBlockDeclaration(t.createBlock(rr,!0))]),ht),rr=void 0),{decorationStatements:rr,members:ht}}function J(Xe,ht){let rr=Kr(Xe.modifiers,E,Pa),vr=Kr(Xe.heritageClauses,x,pp),xr=Kr(Xe.members,x,uu),jr=[];({members:xr,decorationStatements:jr}=F(Xe,xr));let ur=t.updateClassDeclaration(Xe,rr,ht,void 0,vr,xr);return wn([ur],jr)}function G(Xe,ht){let rr=li(Xe,32),vr=li(Xe,2048),xr=Kr(Xe.modifiers,Yt=>S8(Yt)||fu(Yt)?void 0:Yt,Cc),jr=Jg(Xe),ur=Be(Xe),or=u<2?t.getInternalName(Xe,!1,!0):t.getLocalName(Xe,!1,!0),Zr=Kr(Xe.heritageClauses,x,pp),Oi=Kr(Xe.members,x,uu),Sr=[];({members:Oi,decorationStatements:Sr}=F(Xe,Oi));let Pi=u>=9&&!!ur&&Pt(Oi,Yt=>Ns(Yt)&&li(Yt,256)||Gc(Yt));Pi&&(Oi=Et(t.createNodeArray([t.createClassStaticBlockDeclaration(t.createBlock([t.createExpressionStatement(t.createAssignment(ur,t.createThis()))])),...Oi]),Oi));let Cs=t.createClassExpression(xr,ht&&xc(ht)?void 0:ht,void 0,Zr,Oi);zn(Cs,Xe),Et(Cs,jr);let ss=ur&&!Pi?t.createAssignment(ur,Cs):Cs,Ii=t.createVariableDeclaration(or,void 0,void 0,ss);zn(Ii,Xe);let $r=t.createVariableDeclarationList([Ii],1),Xs=t.createVariableStatement(void 0,$r);zn(Xs,Xe),Et(Xs,jr),Zl(Xs,Xe);let $e=[Xs];if(wn($e,Sr),he($e,Xe),rr)if(vr){let Yt=t.createExportDefault(or);$e.push(Yt)}else{let Yt=t.createExternalModuleExport(t.getDeclarationName(Xe));$e.push(Yt)}return $e}function q(Xe){return t.updateClassExpression(Xe,Kr(Xe.modifiers,E,Pa),Xe.name,void 0,Kr(Xe.heritageClauses,x,pp),Kr(Xe.members,x,uu))}function ee(Xe){return t.updateConstructorDeclaration(Xe,Kr(Xe.modifiers,E,Pa),Kr(Xe.parameters,x,ns),ot(Xe.body,x,Vs))}function W(Xe,ht){return Xe!==ht&&(Zl(Xe,ht),qa(Xe,Jg(ht))),Xe}function pe(Xe){return W(t.updateMethodDeclaration(Xe,Kr(Xe.modifiers,E,Pa),Xe.asteriskToken,M.checkDefined(ot(Xe.name,x,Ol)),void 0,void 0,Kr(Xe.parameters,x,ns),void 0,ot(Xe.body,x,Vs)),Xe)}function K(Xe){return W(t.updateGetAccessorDeclaration(Xe,Kr(Xe.modifiers,E,Pa),M.checkDefined(ot(Xe.name,x,Ol)),Kr(Xe.parameters,x,ns),void 0,ot(Xe.body,x,Vs)),Xe)}function re(Xe){return W(t.updateSetAccessorDeclaration(Xe,Kr(Xe.modifiers,E,Pa),M.checkDefined(ot(Xe.name,x,Ol)),Kr(Xe.parameters,x,ns),ot(Xe.body,x,Vs)),Xe)}function ue(Xe){if(!(Xe.flags&33554432||li(Xe,128)))return W(t.updatePropertyDeclaration(Xe,Kr(Xe.modifiers,E,Pa),M.checkDefined(ot(Xe.name,x,Ol)),void 0,void 0,ot(Xe.initializer,x,Ct)),Xe)}function ce(Xe){let ht=t.updateParameterDeclaration(Xe,Tme(t,Xe.modifiers),Xe.dotDotDotToken,M.checkDefined(ot(Xe.name,x,Wx)),void 0,void 0,ot(Xe.initializer,x,Ct));return ht!==Xe&&(Zl(ht,Xe),Et(ht,Jg(Xe)),qa(ht,Jg(Xe)),Tn(ht.name,64)),ht}function ne(Xe){return bO(Xe.expression,"___metadata")}function le(Xe){if(!Xe)return;let{false:ht,true:rr}=IW(Xe.decorators,ne),vr=[];return wn(vr,Cr(ht,Ve)),wn(vr,va(Xe.parameters,Pe)),wn(vr,Cr(rr,Ve)),vr}function me(Xe,ht,rr){wn(Xe,Cr(xe(ht,rr),vr=>t.createExpressionStatement(vr)))}function de(Xe,ht,rr){return lR(!0,Xe,rr)&&ht===oa(Xe)}function Ae(Xe,ht){return Zn(Xe.members,rr=>de(rr,ht,Xe))}function xe(Xe,ht){let rr=Ae(Xe,ht),vr;for(let xr of rr)vr=Bt(vr,te(Xe,xr));return vr}function te(Xe,ht){let rr=IB(ht,Xe,!0),vr=le(rr);if(!vr)return;let xr=qe(Xe,ht),jr=ke(ht,!li(ht,128)),ur=Ns(ht)&&!Ug(ht)?t.createVoidZero():t.createNull(),or=n().createDecorateHelper(vr,xr,jr,ur);return Tn(or,3072),qa(or,Jg(ht)),or}function he(Xe,ht){let rr=be(ht);rr&&Xe.push(zn(t.createExpressionStatement(rr),ht))}function be(Xe){let ht=PK(Xe),rr=le(ht);if(!rr)return;let vr=d&&d[pf(Xe)],xr=u<2?t.getInternalName(Xe,!1,!0):t.getDeclarationName(Xe,!1,!0),jr=n().createDecorateHelper(rr,xr),ur=t.createAssignment(xr,vr?t.createAssignment(vr,jr):jr);return Tn(ur,3072),qa(ur,Jg(Xe)),ur}function Ve(Xe){return M.checkDefined(ot(Xe.expression,x,Ct))}function Pe(Xe,ht){let rr;if(Xe){rr=[];for(let vr of Xe){let xr=n().createParamHelper(Ve(vr),ht);Et(xr,vr.expression),Tn(xr,3072),rr.push(xr)}}return rr}function ke(Xe,ht){let rr=Xe.name;return Zi(rr)?t.createIdentifier(""):za(rr)?ht&&!Qg(rr.expression)?t.getGeneratedNameForNode(rr):rr.expression:He(rr)?t.createStringLiteral(Nn(rr)):t.cloneNode(rr)}function De(){d||(e.enableSubstitution(80),d=[])}function Be(Xe){if(s.hasNodeCheckFlag(Xe,262144)){De();let ht=t.createUniqueName(Xe.name&&!xc(Xe.name)?Nn(Xe.name):"default");return d[pf(Xe)]=ht,i(ht),ht}}function ct(Xe){return t.createPropertyAccessExpression(t.getDeclarationName(Xe),"prototype")}function qe(Xe,ht){return oa(ht)?t.getDeclarationName(Xe):ct(Xe)}function et(Xe,ht){return ht=m(Xe,ht),Xe===1?Ie(ht):ht}function Ie(Xe){switch(Xe.kind){case 80:return _t(Xe)}return Xe}function _t(Xe){return mt(Xe)??Xe}function mt(Xe){if(d&&s.hasNodeCheckFlag(Xe,536870912)){let ht=s.getReferencedValueDeclaration(Xe);if(ht){let rr=d[ht.id];if(rr){let vr=t.cloneNode(rr);return qa(vr,Xe),Zl(vr,Xe),vr}}}}}function fhe(e){let{factory:t,getEmitHelperFactory:n,startLexicalEnvironment:i,endLexicalEnvironment:s,hoistVariableDeclaration:o}=e,u=Ka(e.getCompilerOptions()),m,d,S,E,x,D;return cg(e,w);function w(Q){m=void 0,D=!1;let Ke=Mr(Q,re,e);return E0(Ke,e.readEmitHelpers()),D&&(kA(Ke,32),D=!1),Ke}function R(){switch(d=void 0,S=void 0,E=void 0,m?.kind){case"class":d=m.classInfo;break;case"class-element":d=m.next.classInfo,S=m.classThis,E=m.classSuper;break;case"name":let Q=m.next.next.next;Q?.kind==="class-element"&&(d=Q.next.classInfo,S=Q.classThis,E=Q.classSuper);break}}function L(Q){m={kind:"class",next:m,classInfo:Q,savedPendingExpressions:x},x=void 0,R()}function F(){M.assert(m?.kind==="class","Incorrect value for top.kind.",()=>`Expected top.kind to be 'class' but got '${m?.kind}' instead.`),x=m.savedPendingExpressions,m=m.next,R()}function J(Q){var Ke,z;M.assert(m?.kind==="class","Incorrect value for top.kind.",()=>`Expected top.kind to be 'class' but got '${m?.kind}' instead.`),m={kind:"class-element",next:m},(Gc(Q)||Ns(Q)&&Jl(Q))&&(m.classThis=(Ke=m.next.classInfo)==null?void 0:Ke.classThis,m.classSuper=(z=m.next.classInfo)==null?void 0:z.classSuper),R()}function G(){var Q;M.assert(m?.kind==="class-element","Incorrect value for top.kind.",()=>`Expected top.kind to be 'class-element' but got '${m?.kind}' instead.`),M.assert(((Q=m.next)==null?void 0:Q.kind)==="class","Incorrect value for top.next.kind.",()=>{var Ke;return`Expected top.next.kind to be 'class' but got '${(Ke=m.next)==null?void 0:Ke.kind}' instead.`}),m=m.next,R()}function q(){M.assert(m?.kind==="class-element","Incorrect value for top.kind.",()=>`Expected top.kind to be 'class-element' but got '${m?.kind}' instead.`),m={kind:"name",next:m},R()}function ee(){M.assert(m?.kind==="name","Incorrect value for top.kind.",()=>`Expected top.kind to be 'name' but got '${m?.kind}' instead.`),m=m.next,R()}function W(){m?.kind==="other"?(M.assert(!x),m.depth++):(m={kind:"other",next:m,depth:0,savedPendingExpressions:x},x=void 0,R())}function pe(){M.assert(m?.kind==="other","Incorrect value for top.kind.",()=>`Expected top.kind to be 'other' but got '${m?.kind}' instead.`),m.depth>0?(M.assert(!x),m.depth--):(x=m.savedPendingExpressions,m=m.next,R())}function K(Q){return!!(Q.transformFlags&33554432)||!!S&&!!(Q.transformFlags&16384)||!!S&&!!E&&!!(Q.transformFlags&134217728)}function re(Q){if(!K(Q))return Q;switch(Q.kind){case 170:return M.fail("Use `modifierVisitor` instead.");case 263:return be(Q);case 231:return Ve(Q);case 176:case 172:case 175:return M.fail("Not supported outside of a class. Use 'classElementVisitor' instead.");case 169:return jr(Q);case 226:return Sr(Q,!1);case 303:return Xs(Q);case 260:return $e(Q);case 208:return Yt(Q);case 277:return lt(Q);case 110:return Xe(Q);case 248:return Zr(Q);case 244:return Oi(Q);case 355:return Cs(Q,!1);case 217:return St(Q,!1);case 354:return fe(Q,!1);case 213:return ht(Q);case 215:return rr(Q);case 224:case 225:return Pi(Q,!1);case 211:return vr(Q);case 212:return xr(Q);case 167:return $r(Q);case 174:case 178:case 177:case 218:case 262:{W();let Ke=Mr(Q,ue,e);return pe(),Ke}default:return Mr(Q,ue,e)}}function ue(Q){switch(Q.kind){case 170:return;default:return re(Q)}}function ce(Q){switch(Q.kind){case 170:return;default:return Q}}function ne(Q){switch(Q.kind){case 176:return De(Q);case 174:return qe(Q);case 177:return et(Q);case 178:return Ie(Q);case 172:return mt(Q);case 175:return _t(Q);default:return re(Q)}}function le(Q){switch(Q.kind){case 224:case 225:return Pi(Q,!0);case 226:return Sr(Q,!0);case 355:return Cs(Q,!0);case 217:return St(Q,!0);default:return re(Q)}}function me(Q){let Ke=Q.name&&He(Q.name)&&!xc(Q.name)?Nn(Q.name):Q.name&&Zi(Q.name)&&!xc(Q.name)?Nn(Q.name).slice(1):Q.name&&La(Q.name)&&sp(Q.name.text,99)?Q.name.text:gi(Q)?"class":"member";return Sv(Q)&&(Ke=`get_${Ke}`),Og(Q)&&(Ke=`set_${Ke}`),Q.name&&Zi(Q.name)&&(Ke=`private_${Ke}`),oa(Q)&&(Ke=`static_${Ke}`),"_"+Ke}function de(Q,Ke){return t.createUniqueName(`${me(Q)}_${Ke}`,24)}function Ae(Q,Ke){return t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(Q,void 0,void 0,Ke)],1))}function xe(Q){let Ke=t.createUniqueName("_metadata",48),z,Ue,Te=!1,Re=!1,It=!1,$t,Ht,dr;if(HP(!1,Q)){let qr=Pt(Q.members,Hr=>(j_(Hr)||Ef(Hr))&&Jl(Hr));$t=t.createUniqueName("_classThis",qr?24:48)}for(let qr of Q.members){if(KC(qr)&&lR(!1,qr,Q))if(Jl(qr)){if(!Ue){Ue=t.createUniqueName("_staticExtraInitializers",48);let Hr=n().createRunInitializersHelper($t??t.createThis(),Ue);qa(Hr,Q.name??v0(Q)),Ht??(Ht=[]),Ht.push(Hr)}}else{if(!z){z=t.createUniqueName("_instanceExtraInitializers",48);let Hr=n().createRunInitializersHelper(t.createThis(),z);qa(Hr,Q.name??v0(Q)),dr??(dr=[]),dr.push(Hr)}z??(z=t.createUniqueName("_instanceExtraInitializers",48))}if(Gc(qr)?ek(qr)||(Te=!0):Ns(qr)&&(Jl(qr)?Te||(Te=!!qr.initializer||Wp(qr)):Re||(Re=!lH(qr))),(j_(qr)||Ef(qr))&&Jl(qr)&&(It=!0),Ue&&z&&Te&&Re&&It)break}return{class:Q,classThis:$t,metadataReference:Ke,instanceMethodExtraInitializersName:z,staticMethodExtraInitializersName:Ue,hasStaticInitializers:Te,hasNonAmbientInstanceFields:Re,hasStaticPrivateClassElements:It,pendingStaticInitializers:Ht,pendingInstanceInitializers:dr}}function te(Q){i(),!wK(Q)&&Cv(!1,Q)&&(Q=RB(e,Q,t.createStringLiteral("")));let Ke=t.getLocalName(Q,!1,!1,!0),z=xe(Q),Ue=[],Te,Re,It,$t,Ht=!1,dr=Me(PK(Q));dr&&(z.classDecoratorsName=t.createUniqueName("_classDecorators",48),z.classDescriptorName=t.createUniqueName("_classDescriptor",48),z.classExtraInitializersName=t.createUniqueName("_classExtraInitializers",48),M.assertIsDefined(z.classThis),Ue.push(Ae(z.classDecoratorsName,t.createArrayLiteralExpression(dr)),Ae(z.classDescriptorName),Ae(z.classExtraInitializersName,t.createArrayLiteralExpression()),Ae(z.classThis)),z.hasStaticPrivateClassElements&&(Ht=!0,D=!0));let qr=NR(Q.heritageClauses,96),Hr=qr&&xo(qr.types),dn=Hr&&ot(Hr.expression,re,Ct);if(dn){z.classSuper=t.createUniqueName("_classSuper",48);let Er=Ml(dn),tn=eu(Er)&&!Er.name||ic(Er)&&!Er.name||pc(Er)?t.createComma(t.createNumericLiteral(0),dn):dn;Ue.push(Ae(z.classSuper,tn));let er=t.updateExpressionWithTypeArguments(Hr,z.classSuper,void 0),qs=t.updateHeritageClause(qr,[er]);$t=t.createNodeArray([qs])}let Ar=z.classThis??t.createThis();L(z),Te=Bt(Te,Z(z.metadataReference,z.classSuper));let In=Q.members;if(In=Kr(In,Er=>Vc(Er)?Er:ne(Er),uu),In=Kr(In,Er=>Vc(Er)?ne(Er):Er,uu),x){let Er;for(let tn of x){tn=ot(tn,function qs(uo){if(!(uo.transformFlags&16384))return uo;switch(uo.kind){case 110:return Er||(Er=t.createUniqueName("_outerThis",16),Ue.unshift(Ae(Er,t.createThis()))),Er;default:return Mr(uo,qs,e)}},Ct);let er=t.createExpressionStatement(tn);Te=Bt(Te,er)}x=void 0}if(F(),Pt(z.pendingInstanceInitializers)&&!Ny(Q)){let Er=Pe(Q,z);if(Er){let tn=Fg(Q),er=!!(tn&&Ml(tn.expression).kind!==106),qs=[];if(er){let Mo=t.createSpreadElement(t.createIdentifier("arguments")),Do=t.createCallExpression(t.createSuper(),void 0,[Mo]);qs.push(t.createExpressionStatement(Do))}wn(qs,Er);let uo=t.createBlock(qs,!0);It=t.createConstructorDeclaration(void 0,[],uo)}}if(z.staticMethodExtraInitializersName&&Ue.push(Ae(z.staticMethodExtraInitializersName,t.createArrayLiteralExpression())),z.instanceMethodExtraInitializersName&&Ue.push(Ae(z.instanceMethodExtraInitializersName,t.createArrayLiteralExpression())),z.memberInfos&&Nu(z.memberInfos,(Er,tn)=>{oa(tn)&&(Ue.push(Ae(Er.memberDecoratorsName)),Er.memberInitializersName&&Ue.push(Ae(Er.memberInitializersName,t.createArrayLiteralExpression())),Er.memberExtraInitializersName&&Ue.push(Ae(Er.memberExtraInitializersName,t.createArrayLiteralExpression())),Er.memberDescriptorName&&Ue.push(Ae(Er.memberDescriptorName)))}),z.memberInfos&&Nu(z.memberInfos,(Er,tn)=>{oa(tn)||(Ue.push(Ae(Er.memberDecoratorsName)),Er.memberInitializersName&&Ue.push(Ae(Er.memberInitializersName,t.createArrayLiteralExpression())),Er.memberExtraInitializersName&&Ue.push(Ae(Er.memberExtraInitializersName,t.createArrayLiteralExpression())),Er.memberDescriptorName&&Ue.push(Ae(Er.memberDescriptorName)))}),Te=wn(Te,z.staticNonFieldDecorationStatements),Te=wn(Te,z.nonStaticNonFieldDecorationStatements),Te=wn(Te,z.staticFieldDecorationStatements),Te=wn(Te,z.nonStaticFieldDecorationStatements),z.classDescriptorName&&z.classDecoratorsName&&z.classExtraInitializersName&&z.classThis){Te??(Te=[]);let Er=t.createPropertyAssignment("value",Ar),tn=t.createObjectLiteralExpression([Er]),er=t.createAssignment(z.classDescriptorName,tn),qs=t.createPropertyAccessExpression(Ar,"name"),uo=n().createESDecorateHelper(t.createNull(),er,z.classDecoratorsName,{kind:"class",name:qs,metadata:z.metadataReference},t.createNull(),z.classExtraInitializersName),Mo=t.createExpressionStatement(uo);qa(Mo,v0(Q)),Te.push(Mo);let Do=t.createPropertyAccessExpression(z.classDescriptorName,"value"),ms=t.createAssignment(z.classThis,Do),sa=t.createAssignment(Ke,ms);Te.push(t.createExpressionStatement(sa))}if(Te.push(Ge(Ar,z.metadataReference)),Pt(z.pendingStaticInitializers)){for(let Er of z.pendingStaticInitializers){let tn=t.createExpressionStatement(Er);qa(tn,Ov(Er)),Re=Bt(Re,tn)}z.pendingStaticInitializers=void 0}if(z.classExtraInitializersName){let Er=n().createRunInitializersHelper(Ar,z.classExtraInitializersName),tn=t.createExpressionStatement(Er);qa(tn,Q.name??v0(Q)),Re=Bt(Re,tn)}Te&&Re&&!z.hasStaticInitializers&&(wn(Te,Re),Re=void 0);let Ki=Te&&t.createClassStaticBlockDeclaration(t.createBlock(Te,!0));Ki&&Ht&&i8(Ki,32);let ls=Re&&t.createClassStaticBlockDeclaration(t.createBlock(Re,!0));if(Ki||It||ls){let Er=[],tn=In.findIndex(ek);Ki?(wn(Er,In,0,tn+1),Er.push(Ki),wn(Er,In,tn+1)):wn(Er,In),It&&Er.push(It),ls&&Er.push(ls),In=Et(t.createNodeArray(Er),In)}let Yn=s(),pi;if(dr){pi=t.createClassExpression(void 0,void 0,void 0,$t,In),z.classThis&&(pi=nhe(t,pi,z.classThis));let Er=t.createVariableDeclaration(Ke,void 0,void 0,pi),tn=t.createVariableDeclarationList([Er]),er=z.classThis?t.createAssignment(Ke,z.classThis):Ke;Ue.push(t.createVariableStatement(void 0,tn),t.createReturnStatement(er))}else pi=t.createClassExpression(void 0,Q.name,void 0,$t,In),Ue.push(t.createReturnStatement(pi));if(Ht){kA(pi,32);for(let Er of pi.members)(j_(Er)||Ef(Er))&&Jl(Er)&&kA(Er,32)}return zn(pi,Q),t.createImmediatelyInvokedArrowFunction(t.mergeLexicalEnvironment(Ue,Yn))}function he(Q){return Cv(!1,Q)||wI(!1,Q)}function be(Q){if(he(Q)){let Ke=[],z=Bc(Q,gi)??Q,Ue=z.name?t.createStringLiteralFromNode(z.name):t.createStringLiteral("default"),Te=li(Q,32),Re=li(Q,2048);if(Q.name||(Q=RB(e,Q,Ue)),Te&&Re){let It=te(Q);if(Q.name){let $t=t.createVariableDeclaration(t.getLocalName(Q),void 0,void 0,It);zn($t,Q);let Ht=t.createVariableDeclarationList([$t],1),dr=t.createVariableStatement(void 0,Ht);Ke.push(dr);let qr=t.createExportDefault(t.getDeclarationName(Q));zn(qr,Q),Zl(qr,Wg(Q)),qa(qr,v0(Q)),Ke.push(qr)}else{let $t=t.createExportDefault(It);zn($t,Q),Zl($t,Wg(Q)),qa($t,v0(Q)),Ke.push($t)}}else{M.assertIsDefined(Q.name,"A class declaration that is not a default export must have a name.");let It=te(Q),$t=Te?Ar=>OA(Ar)?void 0:ce(Ar):ce,Ht=Kr(Q.modifiers,$t,Pa),dr=t.getLocalName(Q,!1,!0),qr=t.createVariableDeclaration(dr,void 0,void 0,It);zn(qr,Q);let Hr=t.createVariableDeclarationList([qr],1),dn=t.createVariableStatement(Ht,Hr);if(zn(dn,Q),Zl(dn,Wg(Q)),Ke.push(dn),Te){let Ar=t.createExternalModuleExport(dr);zn(Ar,Q),Ke.push(Ar)}}return wh(Ke)}else{let Ke=Kr(Q.modifiers,ce,Pa),z=Kr(Q.heritageClauses,re,pp);L(void 0);let Ue=Kr(Q.members,ne,uu);return F(),t.updateClassDeclaration(Q,Ke,Q.name,void 0,z,Ue)}}function Ve(Q){if(he(Q)){let Ke=te(Q);return zn(Ke,Q),Ke}else{let Ke=Kr(Q.modifiers,ce,Pa),z=Kr(Q.heritageClauses,re,pp);L(void 0);let Ue=Kr(Q.members,ne,uu);return F(),t.updateClassExpression(Q,Ke,Q.name,void 0,z,Ue)}}function Pe(Q,Ke){if(Pt(Ke.pendingInstanceInitializers)){let z=[];return z.push(t.createExpressionStatement(t.inlineExpressions(Ke.pendingInstanceInitializers))),Ke.pendingInstanceInitializers=void 0,z}}function ke(Q,Ke,z,Ue,Te,Re){let It=Ue[Te],$t=Ke[It];if(wn(Q,Kr(Ke,re,Vi,z,It-z)),c2($t)){let Ht=[];ke(Ht,$t.tryBlock.statements,0,Ue,Te+1,Re);let dr=t.createNodeArray(Ht);Et(dr,$t.tryBlock.statements),Q.push(t.updateTryStatement($t,t.updateBlock($t.tryBlock,Ht),ot($t.catchClause,re,bE),ot($t.finallyBlock,re,Vs)))}else wn(Q,Kr(Ke,re,Vi,It,1)),wn(Q,Re);wn(Q,Kr(Ke,re,Vi,It+1))}function De(Q){J(Q);let Ke=Kr(Q.modifiers,ce,Pa),z=Kr(Q.parameters,re,ns),Ue;if(Q.body&&d){let Te=Pe(d.class,d);if(Te){let Re=[],It=t.copyPrologue(Q.body.statements,Re,!1,re),$t=DB(Q.body.statements,It);$t.length>0?ke(Re,Q.body.statements,It,$t,0,Te):(wn(Re,Te),wn(Re,Kr(Q.body.statements,re,Vi))),Ue=t.createBlock(Re,!0),zn(Ue,Q.body),Et(Ue,Q.body)}}return Ue??(Ue=ot(Q.body,re,Vs)),G(),t.updateConstructorDeclaration(Q,Ke,z,Ue)}function Be(Q,Ke){return Q!==Ke&&(Zl(Q,Ke),qa(Q,v0(Ke))),Q}function ct(Q,Ke,z){let Ue,Te,Re,It,$t,Ht;if(!Ke){let Hr=Kr(Q.modifiers,ce,Pa);return q(),Te=Ii(Q.name),ee(),{modifiers:Hr,referencedName:Ue,name:Te,initializersName:Re,descriptorName:Ht,thisArg:$t}}let dr=Me(IB(Q,Ke.class,!1)),qr=Kr(Q.modifiers,ce,Pa);if(dr){let Hr=de(Q,"decorators"),dn=t.createArrayLiteralExpression(dr),Ar=t.createAssignment(Hr,dn),In={memberDecoratorsName:Hr};Ke.memberInfos??(Ke.memberInfos=new Map),Ke.memberInfos.set(Q,In),x??(x=[]),x.push(Ar);let Ki=KC(Q)||Ef(Q)?oa(Q)?Ke.staticNonFieldDecorationStatements??(Ke.staticNonFieldDecorationStatements=[]):Ke.nonStaticNonFieldDecorationStatements??(Ke.nonStaticNonFieldDecorationStatements=[]):Ns(Q)&&!Ef(Q)?oa(Q)?Ke.staticFieldDecorationStatements??(Ke.staticFieldDecorationStatements=[]):Ke.nonStaticFieldDecorationStatements??(Ke.nonStaticFieldDecorationStatements=[]):M.fail(),ls=Hp(Q)?"getter":fp(Q)?"setter":ul(Q)?"method":Ef(Q)?"accessor":Ns(Q)?"field":M.fail(),Yn;if(He(Q.name)||Zi(Q.name))Yn={computed:!1,name:Q.name};else if(jg(Q.name))Yn={computed:!0,name:t.createStringLiteralFromNode(Q.name)};else{let Er=Q.name.expression;jg(Er)&&!He(Er)?Yn={computed:!0,name:t.createStringLiteralFromNode(Er)}:(q(),{referencedName:Ue,name:Te}=ss(Q.name),Yn={computed:!0,name:Ue},ee())}let pi={kind:ls,name:Yn,static:oa(Q),private:Zi(Q.name),access:{get:Ns(Q)||Hp(Q)||ul(Q),set:Ns(Q)||fp(Q)},metadata:Ke.metadataReference};if(KC(Q)){let Er=oa(Q)?Ke.staticMethodExtraInitializersName:Ke.instanceMethodExtraInitializersName;M.assertIsDefined(Er);let tn;j_(Q)&&z&&(tn=z(Q,Kr(qr,uo=>ai(uo,TO),Pa)),In.memberDescriptorName=Ht=de(Q,"descriptor"),tn=t.createAssignment(Ht,tn));let er=n().createESDecorateHelper(t.createThis(),tn??t.createNull(),Hr,pi,t.createNull(),Er),qs=t.createExpressionStatement(er);qa(qs,v0(Q)),Ki.push(qs)}else if(Ns(Q)){Re=In.memberInitializersName??(In.memberInitializersName=de(Q,"initializers")),It=In.memberExtraInitializersName??(In.memberExtraInitializersName=de(Q,"extraInitializers")),oa(Q)&&($t=Ke.classThis);let Er;j_(Q)&&Ug(Q)&&z&&(Er=z(Q,void 0),In.memberDescriptorName=Ht=de(Q,"descriptor"),Er=t.createAssignment(Ht,Er));let tn=n().createESDecorateHelper(Ef(Q)?t.createThis():t.createNull(),Er??t.createNull(),Hr,pi,Re,It),er=t.createExpressionStatement(tn);qa(er,v0(Q)),Ki.push(er)}}return Te===void 0&&(q(),Te=Ii(Q.name),ee()),!Pt(qr)&&(ul(Q)||Ns(Q))&&Tn(Te,1024),{modifiers:qr,referencedName:Ue,name:Te,initializersName:Re,extraInitializersName:It,descriptorName:Ht,thisArg:$t}}function qe(Q){J(Q);let{modifiers:Ke,name:z,descriptorName:Ue}=ct(Q,d,tr);if(Ue)return G(),Be(Ut(Ke,z,Ue),Q);{let Te=Kr(Q.parameters,re,ns),Re=ot(Q.body,re,Vs);return G(),Be(t.updateMethodDeclaration(Q,Ke,Q.asteriskToken,z,void 0,void 0,Te,void 0,Re),Q)}}function et(Q){J(Q);let{modifiers:Ke,name:z,descriptorName:Ue}=ct(Q,d,Oe);if(Ue)return G(),Be(Rt(Ke,z,Ue),Q);{let Te=Kr(Q.parameters,re,ns),Re=ot(Q.body,re,Vs);return G(),Be(t.updateGetAccessorDeclaration(Q,Ke,z,Te,void 0,Re),Q)}}function Ie(Q){J(Q);let{modifiers:Ke,name:z,descriptorName:Ue}=ct(Q,d,At);if(Ue)return G(),Be(nr(Ke,z,Ue),Q);{let Te=Kr(Q.parameters,re,ns),Re=ot(Q.body,re,Vs);return G(),Be(t.updateSetAccessorDeclaration(Q,Ke,z,Te,Re),Q)}}function _t(Q){J(Q);let Ke;if(ek(Q))Ke=Mr(Q,re,e);else if(e6(Q)){let z=S;S=void 0,Ke=Mr(Q,re,e),S=z}else if(Q=Mr(Q,re,e),Ke=Q,d&&(d.hasStaticInitializers=!0,Pt(d.pendingStaticInitializers))){let z=[];for(let Re of d.pendingStaticInitializers){let It=t.createExpressionStatement(Re);qa(It,Ov(Re)),z.push(It)}let Ue=t.createBlock(z,!0);Ke=[t.createClassStaticBlockDeclaration(Ue),Ke],d.pendingStaticInitializers=void 0}return G(),Ke}function mt(Q){cp(Q,ur)&&(Q=dp(e,Q,or(Q.initializer))),J(Q),M.assert(!lH(Q),"Not yet implemented.");let{modifiers:Ke,name:z,initializersName:Ue,extraInitializersName:Te,descriptorName:Re,thisArg:It}=ct(Q,d,Ug(Q)?Nt:void 0);i();let $t=ot(Q.initializer,re,Ct);Ue&&($t=n().createRunInitializersHelper(It??t.createThis(),Ue,$t??t.createVoidZero())),oa(Q)&&d&&$t&&(d.hasStaticInitializers=!0);let Ht=s();if(Pt(Ht)&&($t=t.createImmediatelyInvokedArrowFunction([...Ht,t.createReturnStatement($t)])),d&&(oa(Q)?($t=nt(d,!0,$t),Te&&(d.pendingStaticInitializers??(d.pendingStaticInitializers=[]),d.pendingStaticInitializers.push(n().createRunInitializersHelper(d.classThis??t.createThis(),Te)))):($t=nt(d,!1,$t),Te&&(d.pendingInstanceInitializers??(d.pendingInstanceInitializers=[]),d.pendingInstanceInitializers.push(n().createRunInitializersHelper(t.createThis(),Te))))),G(),Ug(Q)&&Re){let dr=Wg(Q),qr=Ov(Q),Hr=Q.name,dn=Hr,Ar=Hr;if(za(Hr)&&!Qg(Hr.expression)){let pi=Xj(Hr);if(pi)dn=t.updateComputedPropertyName(Hr,ot(Hr.expression,re,Ct)),Ar=t.updateComputedPropertyName(Hr,pi.left);else{let Er=t.createTempVariable(o);qa(Er,Hr.expression);let tn=ot(Hr.expression,re,Ct),er=t.createAssignment(Er,tn);qa(er,Hr.expression),dn=t.updateComputedPropertyName(Hr,er),Ar=t.updateComputedPropertyName(Hr,Er)}}let In=Kr(Ke,pi=>pi.kind!==129?pi:void 0,Pa),Ki=AY(t,Q,In,$t);zn(Ki,Q),Tn(Ki,3072),qa(Ki,qr),qa(Ki.name,Q.name);let ls=Rt(In,dn,Re);zn(ls,Q),Zl(ls,dr),qa(ls,qr);let Yn=nr(In,Ar,Re);return zn(Yn,Q),Tn(Yn,3072),qa(Yn,qr),[Ki,ls,Yn]}return Be(t.updatePropertyDeclaration(Q,Ke,z,void 0,void 0,$t),Q)}function Xe(Q){return S??Q}function ht(Q){if(Cf(Q.expression)&&S){let Ke=ot(Q.expression,re,Ct),z=Kr(Q.arguments,re,Ct),Ue=t.createFunctionCallCall(Ke,S,z);return zn(Ue,Q),Et(Ue,Q),Ue}return Mr(Q,re,e)}function rr(Q){if(Cf(Q.tag)&&S){let Ke=ot(Q.tag,re,Ct),z=t.createFunctionBindCall(Ke,S,[]);zn(z,Q),Et(z,Q);let Ue=ot(Q.template,re,XC);return t.updateTaggedTemplateExpression(Q,z,void 0,Ue)}return Mr(Q,re,e)}function vr(Q){if(Cf(Q)&&He(Q.name)&&S&&E){let Ke=t.createStringLiteralFromNode(Q.name),z=t.createReflectGetCall(E,Ke,S);return zn(z,Q.expression),Et(z,Q.expression),z}return Mr(Q,re,e)}function xr(Q){if(Cf(Q)&&S&&E){let Ke=ot(Q.argumentExpression,re,Ct),z=t.createReflectGetCall(E,Ke,S);return zn(z,Q.expression),Et(z,Q.expression),z}return Mr(Q,re,e)}function jr(Q){cp(Q,ur)&&(Q=dp(e,Q,or(Q.initializer)));let Ke=t.updateParameterDeclaration(Q,void 0,Q.dotDotDotToken,ot(Q.name,re,Wx),void 0,void 0,ot(Q.initializer,re,Ct));return Ke!==Q&&(Zl(Ke,Q),Et(Ke,Jg(Q)),qa(Ke,Jg(Q)),Tn(Ke.name,64)),Ke}function ur(Q){return eu(Q)&&!Q.name&&he(Q)}function or(Q){let Ke=Ml(Q);return eu(Ke)&&!Ke.name&&!Cv(!1,Ke)}function Zr(Q){return t.updateForStatement(Q,ot(Q.initializer,le,Sd),ot(Q.condition,re,Ct),ot(Q.incrementor,le,Ct),ff(Q.statement,re,e))}function Oi(Q){return Mr(Q,le,e)}function Sr(Q,Ke){if(Dv(Q)){let z=to(Q.left),Ue=ot(Q.right,re,Ct);return t.updateBinaryExpression(Q,z,Q.operatorToken,Ue)}if(Su(Q)){if(cp(Q,ur))return Q=dp(e,Q,or(Q.right)),Mr(Q,re,e);if(Cf(Q.left)&&S&&E){let z=cc(Q.left)?ot(Q.left.argumentExpression,re,Ct):He(Q.left.name)?t.createStringLiteralFromNode(Q.left.name):void 0;if(z){let Ue=ot(Q.right,re,Ct);if(XO(Q.operatorToken.kind)){let Re=z;Qg(z)||(Re=t.createTempVariable(o),z=t.createAssignment(Re,z));let It=t.createReflectGetCall(E,Re,S);zn(It,Q.left),Et(It,Q.left),Ue=t.createBinaryExpression(It,QO(Q.operatorToken.kind),Ue),Et(Ue,Q)}let Te=Ke?void 0:t.createTempVariable(o);return Te&&(Ue=t.createAssignment(Te,Ue),Et(Te,Q)),Ue=t.createReflectSetCall(E,z,Ue,S),zn(Ue,Q),Et(Ue,Q),Te&&(Ue=t.createComma(Ue,Te),Et(Ue,Q)),Ue}}}if(Q.operatorToken.kind===28){let z=ot(Q.left,le,Ct),Ue=ot(Q.right,Ke?le:re,Ct);return t.updateBinaryExpression(Q,z,Q.operatorToken,Ue)}return Mr(Q,re,e)}function Pi(Q,Ke){if(Q.operator===46||Q.operator===47){let z=So(Q.operand);if(Cf(z)&&S&&E){let Ue=cc(z)?ot(z.argumentExpression,re,Ct):He(z.name)?t.createStringLiteralFromNode(z.name):void 0;if(Ue){let Te=Ue;Qg(Ue)||(Te=t.createTempVariable(o),Ue=t.createAssignment(Te,Ue));let Re=t.createReflectGetCall(E,Te,S);zn(Re,Q),Et(Re,Q);let It=Ke?void 0:t.createTempVariable(o);return Re=zj(t,Q,Re,o,It),Re=t.createReflectSetCall(E,Ue,Re,S),zn(Re,Q),Et(Re,Q),It&&(Re=t.createComma(Re,It),Et(Re,Q)),Re}}}return Mr(Q,re,e)}function Cs(Q,Ke){let z=Ke?j8(Q.elements,le):j8(Q.elements,re,le);return t.updateCommaListExpression(Q,z)}function ss(Q){if(jg(Q)||Zi(Q)){let Re=t.createStringLiteralFromNode(Q),It=ot(Q,re,Ol);return{referencedName:Re,name:It}}if(jg(Q.expression)&&!He(Q.expression)){let Re=t.createStringLiteralFromNode(Q.expression),It=ot(Q,re,Ol);return{referencedName:Re,name:It}}let Ke=t.getGeneratedNameForNode(Q);o(Ke);let z=n().createPropKeyHelper(ot(Q.expression,re,Ct)),Ue=t.createAssignment(Ke,z),Te=t.updateComputedPropertyName(Q,Ce(Ue));return{referencedName:Ke,name:Te}}function Ii(Q){return za(Q)?$r(Q):ot(Q,re,Ol)}function $r(Q){let Ke=ot(Q.expression,re,Ct);return Qg(Ke)||(Ke=Ce(Ke)),t.updateComputedPropertyName(Q,Ke)}function Xs(Q){return cp(Q,ur)&&(Q=dp(e,Q,or(Q.initializer))),Mr(Q,re,e)}function $e(Q){return cp(Q,ur)&&(Q=dp(e,Q,or(Q.initializer))),Mr(Q,re,e)}function Yt(Q){return cp(Q,ur)&&(Q=dp(e,Q,or(Q.initializer))),Mr(Q,re,e)}function Vr(Q){if(Ca(Q)||Gu(Q))return to(Q);if(Cf(Q)&&S&&E){let Ke=cc(Q)?ot(Q.argumentExpression,re,Ct):He(Q.name)?t.createStringLiteralFromNode(Q.name):void 0;if(Ke){let z=t.createTempVariable(void 0),Ue=t.createAssignmentTargetWrapper(z,t.createReflectSetCall(E,Ke,z,S));return zn(Ue,Q),Et(Ue,Q),Ue}}return Mr(Q,re,e)}function An(Q){if(Su(Q,!0)){cp(Q,ur)&&(Q=dp(e,Q,or(Q.right)));let Ke=Vr(Q.left),z=ot(Q.right,re,Ct);return t.updateBinaryExpression(Q,Ke,Q.operatorToken,z)}else return Vr(Q)}function vi(Q){if(xf(Q.expression)){let Ke=Vr(Q.expression);return t.updateSpreadElement(Q,Ke)}return Mr(Q,re,e)}function Ci(Q){return M.assertNode(Q,V3),Ad(Q)?vi(Q):pu(Q)?Mr(Q,re,e):An(Q)}function Ui(Q){let Ke=ot(Q.name,re,Ol);if(Su(Q.initializer,!0)){let z=An(Q.initializer);return t.updatePropertyAssignment(Q,Ke,z)}if(xf(Q.initializer)){let z=Vr(Q.initializer);return t.updatePropertyAssignment(Q,Ke,z)}return Mr(Q,re,e)}function la(Q){return cp(Q,ur)&&(Q=dp(e,Q,or(Q.objectAssignmentInitializer))),Mr(Q,re,e)}function Gs(Q){if(xf(Q.expression)){let Ke=Vr(Q.expression);return t.updateSpreadAssignment(Q,Ke)}return Mr(Q,re,e)}function yr(Q){return M.assertNode(Q,U3),Fy(Q)?Gs(Q):p_(Q)?la(Q):ql(Q)?Ui(Q):Mr(Q,re,e)}function to(Q){if(Gu(Q)){let Ke=Kr(Q.elements,Ci,Ct);return t.updateArrayLiteralExpression(Q,Ke)}else{let Ke=Kr(Q.properties,yr,p0);return t.updateObjectLiteralExpression(Q,Ke)}}function lt(Q){return cp(Q,ur)&&(Q=dp(e,Q,or(Q.expression))),Mr(Q,re,e)}function St(Q,Ke){let z=Ke?le:re,Ue=ot(Q.expression,z,Ct);return t.updateParenthesizedExpression(Q,Ue)}function fe(Q,Ke){let z=Ke?le:re,Ue=ot(Q.expression,z,Ct);return t.updatePartiallyEmittedExpression(Q,Ue)}function vt(Q,Ke){return Pt(Q)&&(Ke?uf(Ke)?(Q.push(Ke.expression),Ke=t.updateParenthesizedExpression(Ke,t.inlineExpressions(Q))):(Q.push(Ke),Ke=t.inlineExpressions(Q)):Ke=t.inlineExpressions(Q)),Ke}function Ce(Q){let Ke=vt(x,Q);return M.assertIsDefined(Ke),Ke!==Q&&(x=void 0),Ke}function nt(Q,Ke,z){let Ue=vt(Ke?Q.pendingStaticInitializers:Q.pendingInstanceInitializers,z);return Ue!==z&&(Ke?Q.pendingStaticInitializers=void 0:Q.pendingInstanceInitializers=void 0),Ue}function Me(Q){if(!Q)return;let Ke=[];return wn(Ke,Cr(Q.decorators,tt)),Ke}function tt(Q){let Ke=ot(Q.expression,re,Ct);Tn(Ke,3072);let z=Ml(Ke);if(oc(z)){let{target:Ue,thisArg:Te}=t.createCallBinding(Ke,o,u,!0);return t.restoreOuterExpressions(Ke,t.createFunctionBindCall(Ue,Te,[]))}return Ke}function ft(Q,Ke,z,Ue,Te,Re,It){let $t=t.createFunctionExpression(z,Ue,void 0,void 0,Re,void 0,It??t.createBlock([]));zn($t,Q),qa($t,v0(Q)),Tn($t,3072);let Ht=Te==="get"||Te==="set"?Te:void 0,dr=t.createStringLiteralFromNode(Ke,void 0),qr=n().createSetFunctionNameHelper($t,dr,Ht),Hr=t.createPropertyAssignment(t.createIdentifier(Te),qr);return zn(Hr,Q),qa(Hr,v0(Q)),Tn(Hr,3072),Hr}function tr(Q,Ke){return t.createObjectLiteralExpression([ft(Q,Q.name,Ke,Q.asteriskToken,"value",Kr(Q.parameters,re,ns),ot(Q.body,re,Vs))])}function Oe(Q,Ke){return t.createObjectLiteralExpression([ft(Q,Q.name,Ke,void 0,"get",[],ot(Q.body,re,Vs))])}function At(Q,Ke){return t.createObjectLiteralExpression([ft(Q,Q.name,Ke,void 0,"set",Kr(Q.parameters,re,ns),ot(Q.body,re,Vs))])}function Nt(Q,Ke){return t.createObjectLiteralExpression([ft(Q,Q.name,Ke,void 0,"get",[],t.createBlock([t.createReturnStatement(t.createPropertyAccessExpression(t.createThis(),t.getGeneratedPrivateNameForNode(Q.name)))])),ft(Q,Q.name,Ke,void 0,"set",[t.createParameterDeclaration(void 0,void 0,"value")],t.createBlock([t.createExpressionStatement(t.createAssignment(t.createPropertyAccessExpression(t.createThis(),t.getGeneratedPrivateNameForNode(Q.name)),t.createIdentifier("value")))]))])}function Ut(Q,Ke,z){return Q=Kr(Q,Ue=>RA(Ue)?Ue:void 0,Pa),t.createGetAccessorDeclaration(Q,Ke,[],void 0,t.createBlock([t.createReturnStatement(t.createPropertyAccessExpression(z,t.createIdentifier("value")))]))}function Rt(Q,Ke,z){return Q=Kr(Q,Ue=>RA(Ue)?Ue:void 0,Pa),t.createGetAccessorDeclaration(Q,Ke,[],void 0,t.createBlock([t.createReturnStatement(t.createFunctionCallCall(t.createPropertyAccessExpression(z,t.createIdentifier("get")),t.createThis(),[]))]))}function nr(Q,Ke,z){return Q=Kr(Q,Ue=>RA(Ue)?Ue:void 0,Pa),t.createSetAccessorDeclaration(Q,Ke,[t.createParameterDeclaration(void 0,void 0,"value")],t.createBlock([t.createReturnStatement(t.createFunctionCallCall(t.createPropertyAccessExpression(z,t.createIdentifier("set")),t.createThis(),[t.createIdentifier("value")]))]))}function Z(Q,Ke){let z=t.createVariableDeclaration(Q,void 0,void 0,t.createConditionalExpression(t.createLogicalAnd(t.createTypeCheck(t.createIdentifier("Symbol"),"function"),t.createPropertyAccessExpression(t.createIdentifier("Symbol"),"metadata")),t.createToken(58),t.createCallExpression(t.createPropertyAccessExpression(t.createIdentifier("Object"),"create"),void 0,[Ke?bt(Ke):t.createNull()]),t.createToken(59),t.createVoidZero()));return t.createVariableStatement(void 0,t.createVariableDeclarationList([z],2))}function Ge(Q,Ke){let z=t.createObjectDefinePropertyCall(Q,t.createPropertyAccessExpression(t.createIdentifier("Symbol"),"metadata"),t.createPropertyDescriptor({configurable:!0,writable:!0,enumerable:!0,value:Ke},!0));return Tn(t.createIfStatement(Ke,t.createExpressionStatement(z)),1)}function bt(Q){return t.createBinaryExpression(t.createElementAccessExpression(Q,t.createPropertyAccessExpression(t.createIdentifier("Symbol"),"metadata")),61,t.createNull())}}function phe(e){let{factory:t,getEmitHelperFactory:n,resumeLexicalEnvironment:i,endLexicalEnvironment:s,hoistVariableDeclaration:o}=e,u=e.getEmitResolver(),m=e.getCompilerOptions(),d=Ka(m),S,E=0,x,D,w,R,L=[],F=0,J=e.onEmitNode,G=e.onSubstituteNode;return e.onEmitNode=Oi,e.onSubstituteNode=Sr,cg(e,q);function q($e){if($e.isDeclarationFile)return $e;ee(1,!1),ee(2,!cH($e,m));let Yt=Mr($e,ne,e);return E0(Yt,e.readEmitHelpers()),Yt}function ee($e,Yt){F=Yt?F|$e:F&~$e}function W($e){return(F&$e)!==0}function pe(){return!W(1)}function K(){return W(2)}function re($e,Yt,Vr){let An=$e&~F;if(An){ee(An,!0);let vi=Yt(Vr);return ee(An,!1),vi}return Yt(Vr)}function ue($e){return Mr($e,ne,e)}function ce($e){switch($e.kind){case 218:case 262:case 174:case 177:case 178:case 176:return $e;case 169:case 208:case 260:break;case 80:if(R&&u.isArgumentsLocalBinding($e))return R;break}return Mr($e,ce,e)}function ne($e){if(!($e.transformFlags&256))return R?ce($e):$e;switch($e.kind){case 134:return;case 223:return he($e);case 174:return re(3,Ve,$e);case 262:return re(3,De,$e);case 218:return re(3,Be,$e);case 219:return re(1,ct,$e);case 211:return D&&Wn($e)&&$e.expression.kind===108&&D.add($e.name.escapedText),Mr($e,ne,e);case 212:return D&&$e.expression.kind===108&&(w=!0),Mr($e,ne,e);case 177:return re(3,Pe,$e);case 178:return re(3,ke,$e);case 176:return re(3,be,$e);case 263:case 231:return re(3,ue,$e);default:return Mr($e,ne,e)}}function le($e){if(mfe($e))switch($e.kind){case 243:return de($e);case 248:return te($e);case 249:return Ae($e);case 250:return xe($e);case 299:return me($e);case 241:case 255:case 269:case 296:case 297:case 258:case 246:case 247:case 245:case 254:case 256:return Mr($e,le,e);default:return M.assertNever($e,"Unhandled node.")}return ne($e)}function me($e){let Yt=new Set;qe($e.variableDeclaration,Yt);let Vr;if(Yt.forEach((An,vi)=>{x.has(vi)&&(Vr||(Vr=new Set(x)),Vr.delete(vi))}),Vr){let An=x;x=Vr;let vi=Mr($e,le,e);return x=An,vi}else return Mr($e,le,e)}function de($e){if(et($e.declarationList)){let Yt=Ie($e.declarationList,!1);return Yt?t.createExpressionStatement(Yt):void 0}return Mr($e,ne,e)}function Ae($e){return t.updateForInStatement($e,et($e.initializer)?Ie($e.initializer,!0):M.checkDefined(ot($e.initializer,ne,Sd)),M.checkDefined(ot($e.expression,ne,Ct)),ff($e.statement,le,e))}function xe($e){return t.updateForOfStatement($e,ot($e.awaitModifier,ne,XG),et($e.initializer)?Ie($e.initializer,!0):M.checkDefined(ot($e.initializer,ne,Sd)),M.checkDefined(ot($e.expression,ne,Ct)),ff($e.statement,le,e))}function te($e){let Yt=$e.initializer;return t.updateForStatement($e,et(Yt)?Ie(Yt,!1):ot($e.initializer,ne,Sd),ot($e.condition,ne,Ct),ot($e.incrementor,ne,Ct),ff($e.statement,le,e))}function he($e){return pe()?Mr($e,ne,e):zn(Et(t.createYieldExpression(void 0,ot($e.expression,ne,Ct)),$e),$e)}function be($e){let Yt=R;R=void 0;let Vr=t.updateConstructorDeclaration($e,Kr($e.modifiers,ne,Pa),Kc($e.parameters,ne,e),rr($e));return R=Yt,Vr}function Ve($e){let Yt,Vr=Rl($e),An=R;R=void 0;let vi=t.updateMethodDeclaration($e,Kr($e.modifiers,ne,Cc),$e.asteriskToken,$e.name,void 0,void 0,Yt=Vr&2?xr($e):Kc($e.parameters,ne,e),void 0,Vr&2?jr($e,Yt):rr($e));return R=An,vi}function Pe($e){let Yt=R;R=void 0;let Vr=t.updateGetAccessorDeclaration($e,Kr($e.modifiers,ne,Cc),$e.name,Kc($e.parameters,ne,e),void 0,rr($e));return R=Yt,Vr}function ke($e){let Yt=R;R=void 0;let Vr=t.updateSetAccessorDeclaration($e,Kr($e.modifiers,ne,Cc),$e.name,Kc($e.parameters,ne,e),rr($e));return R=Yt,Vr}function De($e){let Yt,Vr=R;R=void 0;let An=Rl($e),vi=t.updateFunctionDeclaration($e,Kr($e.modifiers,ne,Cc),$e.asteriskToken,$e.name,void 0,Yt=An&2?xr($e):Kc($e.parameters,ne,e),void 0,An&2?jr($e,Yt):Qp($e.body,ne,e));return R=Vr,vi}function Be($e){let Yt,Vr=R;R=void 0;let An=Rl($e),vi=t.updateFunctionExpression($e,Kr($e.modifiers,ne,Pa),$e.asteriskToken,$e.name,void 0,Yt=An&2?xr($e):Kc($e.parameters,ne,e),void 0,An&2?jr($e,Yt):Qp($e.body,ne,e));return R=Vr,vi}function ct($e){let Yt,Vr=Rl($e);return t.updateArrowFunction($e,Kr($e.modifiers,ne,Pa),void 0,Yt=Vr&2?xr($e):Kc($e.parameters,ne,e),void 0,$e.equalsGreaterThanToken,Vr&2?jr($e,Yt):Qp($e.body,ne,e))}function qe({name:$e},Yt){if(He($e))Yt.add($e.escapedText);else for(let Vr of $e.elements)pu(Vr)||qe(Vr,Yt)}function et($e){return!!$e&&Ru($e)&&!($e.flags&7)&&$e.declarations.some(ht)}function Ie($e,Yt){_t($e);let Vr=ZI($e);return Vr.length===0?Yt?ot(t.converters.convertToAssignmentElementTarget($e.declarations[0].name),ne,Ct):void 0:t.inlineExpressions(Cr(Vr,Xe))}function _t($e){kt($e.declarations,mt)}function mt({name:$e}){if(He($e))o($e);else for(let Yt of $e.elements)pu(Yt)||mt(Yt)}function Xe($e){let Yt=qa(t.createAssignment(t.converters.convertToAssignmentElementTarget($e.name),$e.initializer),$e);return M.checkDefined(ot(Yt,ne,Ct))}function ht({name:$e}){if(He($e))return x.has($e.escapedText);for(let Yt of $e.elements)if(!pu(Yt)&&ht(Yt))return!0;return!1}function rr($e){M.assertIsDefined($e.body);let Yt=D,Vr=w;D=new Set,w=!1;let An=Qp($e.body,ne,e),vi=Bc($e,Go);if(d>=2&&(u.hasNodeCheckFlag($e,256)||u.hasNodeCheckFlag($e,128))&&(Rl(vi)&3)!==3){if(Zr(),D.size){let Ui=MB(t,u,$e,D);L[yo(Ui)]=!0;let la=An.statements.slice();Ay(la,[Ui]),An=t.updateBlock(An,la)}w&&(u.hasNodeCheckFlag($e,256)?NA(An,Aj):u.hasNodeCheckFlag($e,128)&&NA(An,Cj))}return D=Yt,w=Vr,An}function vr(){M.assert(R);let $e=t.createVariableDeclaration(R,void 0,void 0,t.createIdentifier("arguments")),Yt=t.createVariableStatement(void 0,[$e]);return T_(Yt),zg(Yt,2097152),Yt}function xr($e){if(U8($e.parameters))return Kc($e.parameters,ne,e);let Yt=[];for(let An of $e.parameters){if(An.initializer||An.dotDotDotToken){if($e.kind===219){let Ci=t.createParameterDeclaration(void 0,t.createToken(26),t.createUniqueName("args",8));Yt.push(Ci)}break}let vi=t.createParameterDeclaration(void 0,void 0,t.getGeneratedNameForNode(An.name,8));Yt.push(vi)}let Vr=t.createNodeArray(Yt);return Et(Vr,$e.parameters),Vr}function jr($e,Yt){let Vr=U8($e.parameters)?void 0:Kc($e.parameters,ne,e);i();let vi=Bc($e,Bs).type,Ci=d<2?or(vi):void 0,Ui=$e.kind===219,la=R,yr=u.hasNodeCheckFlag($e,512)&&!R;yr&&(R=t.createUniqueName("arguments"));let to;if(Vr)if(Ui){let Me=[];M.assert(Yt.length<=$e.parameters.length);for(let tt=0;tt<$e.parameters.length;tt++){M.assert(tt<Yt.length);let ft=$e.parameters[tt],tr=Yt[tt];if(M.assertNode(tr.name,He),ft.initializer||ft.dotDotDotToken){M.assert(tt===Yt.length-1),Me.push(t.createSpreadElement(tr.name));break}Me.push(tr.name)}to=t.createArrayLiteralExpression(Me)}else to=t.createIdentifier("arguments");let lt=x;x=new Set;for(let Me of $e.parameters)qe(Me,x);let St=D,fe=w;Ui||(D=new Set,w=!1);let vt=K(),Ce=ur($e.body);Ce=t.updateBlock(Ce,t.mergeLexicalEnvironment(Ce.statements,s()));let nt;if(Ui){if(nt=n().createAwaiterHelper(vt,to,Ci,Vr,Ce),yr){let Me=t.converters.convertToFunctionBlock(nt);nt=t.updateBlock(Me,t.mergeLexicalEnvironment(Me.statements,[vr()]))}}else{let Me=[];Me.push(t.createReturnStatement(n().createAwaiterHelper(vt,to,Ci,Vr,Ce)));let tt=d>=2&&(u.hasNodeCheckFlag($e,256)||u.hasNodeCheckFlag($e,128));if(tt&&(Zr(),D.size)){let tr=MB(t,u,$e,D);L[yo(tr)]=!0,Ay(Me,[tr])}yr&&Ay(Me,[vr()]);let ft=t.createBlock(Me,!0);Et(ft,$e.body),tt&&w&&(u.hasNodeCheckFlag($e,256)?NA(ft,Aj):u.hasNodeCheckFlag($e,128)&&NA(ft,Cj)),nt=ft}return x=lt,Ui||(D=St,w=fe,R=la),nt}function ur($e,Yt){return Vs($e)?t.updateBlock($e,Kr($e.statements,le,Vi,Yt)):t.converters.convertToFunctionBlock(M.checkDefined(ot($e,le,O5)))}function or($e){let Yt=$e&&oR($e);if(Yt&&Tf(Yt)){let Vr=u.getTypeReferenceSerializationKind(Yt);if(Vr===1||Vr===0)return Yt}}function Zr(){S&1||(S|=1,e.enableSubstitution(213),e.enableSubstitution(211),e.enableSubstitution(212),e.enableEmitNotification(263),e.enableEmitNotification(174),e.enableEmitNotification(177),e.enableEmitNotification(178),e.enableEmitNotification(176),e.enableEmitNotification(243))}function Oi($e,Yt,Vr){if(S&1&&$r(Yt)){let An=(u.hasNodeCheckFlag(Yt,128)?128:0)|(u.hasNodeCheckFlag(Yt,256)?256:0);if(An!==E){let vi=E;E=An,J($e,Yt,Vr),E=vi;return}}else if(S&&L[yo(Yt)]){let An=E;E=0,J($e,Yt,Vr),E=An;return}J($e,Yt,Vr)}function Sr($e,Yt){return Yt=G($e,Yt),$e===1&&E?Pi(Yt):Yt}function Pi($e){switch($e.kind){case 211:return Cs($e);case 212:return ss($e);case 213:return Ii($e)}return $e}function Cs($e){return $e.expression.kind===108?Et(t.createPropertyAccessExpression(t.createUniqueName("_super",48),$e.name),$e):$e}function ss($e){return $e.expression.kind===108?Xs($e.argumentExpression,$e):$e}function Ii($e){let Yt=$e.expression;if(Cf(Yt)){let Vr=Wn(Yt)?Cs(Yt):ss(Yt);return t.createCallExpression(t.createPropertyAccessExpression(Vr,"call"),void 0,[t.createThis(),...$e.arguments])}return $e}function $r($e){let Yt=$e.kind;return Yt===263||Yt===176||Yt===174||Yt===177||Yt===178}function Xs($e,Yt){return E&256?Et(t.createPropertyAccessExpression(t.createCallExpression(t.createUniqueName("_superIndex",48),void 0,[$e]),"value"),Yt):Et(t.createCallExpression(t.createUniqueName("_superIndex",48),void 0,[$e]),Yt)}}function MB(e,t,n,i){let s=t.hasNodeCheckFlag(n,256),o=[];return i.forEach((u,m)=>{let d=Qi(m),S=[];S.push(e.createPropertyAssignment("get",e.createArrowFunction(void 0,void 0,[],void 0,void 0,Tn(e.createPropertyAccessExpression(Tn(e.createSuper(),8),d),8)))),s&&S.push(e.createPropertyAssignment("set",e.createArrowFunction(void 0,void 0,[e.createParameterDeclaration(void 0,void 0,"v",void 0,void 0,void 0)],void 0,void 0,e.createAssignment(Tn(e.createPropertyAccessExpression(Tn(e.createSuper(),8),d),8),e.createIdentifier("v"))))),o.push(e.createPropertyAssignment(d,e.createObjectLiteralExpression(S)))}),e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(e.createUniqueName("_super",48),void 0,void 0,e.createCallExpression(e.createPropertyAccessExpression(e.createIdentifier("Object"),"create"),void 0,[e.createNull(),e.createObjectLiteralExpression(o,!0)]))],2))}function dhe(e){let{factory:t,getEmitHelperFactory:n,resumeLexicalEnvironment:i,endLexicalEnvironment:s,hoistVariableDeclaration:o}=e,u=e.getEmitResolver(),m=e.getCompilerOptions(),d=Ka(m),S=e.onEmitNode;e.onEmitNode=la;let E=e.onSubstituteNode;e.onSubstituteNode=Gs;let x=!1,D,w,R,L=0,F=0,J,G,q,ee,W=[];return cg(e,ce);function pe(Ce,nt){return F!==(F&~Ce|nt)}function K(Ce,nt){let Me=F;return F=(F&~Ce|nt)&3,Me}function re(Ce){F=Ce}function ue(Ce){G=Bt(G,t.createVariableDeclaration(Ce))}function ce(Ce){if(Ce.isDeclarationFile)return Ce;J=Ce;let nt=ct(Ce);return E0(nt,e.readEmitHelpers()),J=void 0,G=void 0,nt}function ne(Ce){return xe(Ce,!1)}function le(Ce){return xe(Ce,!0)}function me(Ce){if(Ce.kind!==134)return Ce}function de(Ce,nt,Me,tt){if(pe(Me,tt)){let ft=K(Me,tt),tr=Ce(nt);return re(ft),tr}return Ce(nt)}function Ae(Ce){return Mr(Ce,ne,e)}function xe(Ce,nt){if(!(Ce.transformFlags&128))return Ce;switch(Ce.kind){case 223:return te(Ce);case 229:return he(Ce);case 253:return be(Ce);case 256:return Ve(Ce);case 210:return ke(Ce);case 226:return et(Ce,nt);case 355:return Ie(Ce,nt);case 299:return _t(Ce);case 243:return mt(Ce);case 260:return Xe(Ce);case 246:case 247:case 249:return de(Ae,Ce,0,2);case 250:return xr(Ce,void 0);case 248:return de(rr,Ce,0,2);case 222:return vr(Ce);case 176:return de(Cs,Ce,2,1);case 174:return de($r,Ce,2,1);case 177:return de(ss,Ce,2,1);case 178:return de(Ii,Ce,2,1);case 262:return de(Xs,Ce,2,1);case 218:return de(Yt,Ce,2,1);case 219:return de($e,Ce,2,0);case 169:return Sr(Ce);case 244:return De(Ce);case 217:return Be(Ce,nt);case 215:return qe(Ce);case 211:return q&&Wn(Ce)&&Ce.expression.kind===108&&q.add(Ce.name.escapedText),Mr(Ce,ne,e);case 212:return q&&Ce.expression.kind===108&&(ee=!0),Mr(Ce,ne,e);case 263:case 231:return de(Ae,Ce,2,1);default:return Mr(Ce,ne,e)}}function te(Ce){return w&2&&w&1?zn(Et(t.createYieldExpression(void 0,n().createAwaitHelper(ot(Ce.expression,ne,Ct))),Ce),Ce):Mr(Ce,ne,e)}function he(Ce){if(w&2&&w&1){if(Ce.asteriskToken){let nt=ot(M.checkDefined(Ce.expression),ne,Ct);return zn(Et(t.createYieldExpression(void 0,n().createAwaitHelper(t.updateYieldExpression(Ce,Ce.asteriskToken,Et(n().createAsyncDelegatorHelper(Et(n().createAsyncValuesHelper(nt),nt)),nt)))),Ce),Ce)}return zn(Et(t.createYieldExpression(void 0,or(Ce.expression?ot(Ce.expression,ne,Ct):t.createVoidZero())),Ce),Ce)}return Mr(Ce,ne,e)}function be(Ce){return w&2&&w&1?t.updateReturnStatement(Ce,or(Ce.expression?ot(Ce.expression,ne,Ct):t.createVoidZero())):Mr(Ce,ne,e)}function Ve(Ce){if(w&2){let nt=hH(Ce);return nt.kind===250&&nt.awaitModifier?xr(nt,Ce):t.restoreEnclosingLabel(ot(nt,ne,Vi,t.liftToBlock),Ce)}return Mr(Ce,ne,e)}function Pe(Ce){let nt,Me=[];for(let tt of Ce)if(tt.kind===305){nt&&(Me.push(t.createObjectLiteralExpression(nt)),nt=void 0);let ft=tt.expression;Me.push(ot(ft,ne,Ct))}else nt=Bt(nt,tt.kind===303?t.createPropertyAssignment(tt.name,ot(tt.initializer,ne,Ct)):ot(tt,ne,p0));return nt&&Me.push(t.createObjectLiteralExpression(nt)),Me}function ke(Ce){if(Ce.transformFlags&65536){let nt=Pe(Ce.properties);nt.length&&nt[0].kind!==210&&nt.unshift(t.createObjectLiteralExpression());let Me=nt[0];if(nt.length>1){for(let tt=1;tt<nt.length;tt++)Me=n().createAssignHelper([Me,nt[tt]]);return Me}else return n().createAssignHelper(nt)}return Mr(Ce,ne,e)}function De(Ce){return Mr(Ce,le,e)}function Be(Ce,nt){return Mr(Ce,nt?le:ne,e)}function ct(Ce){let nt=K(2,cH(Ce,m)?0:1);x=!1;let Me=Mr(Ce,ne,e),tt=ps(Me.statements,G&&[t.createVariableStatement(void 0,t.createVariableDeclarationList(G))]),ft=t.updateSourceFile(Me,Et(t.createNodeArray(tt),Ce.statements));return re(nt),ft}function qe(Ce){return IK(e,Ce,ne,J,ue,0)}function et(Ce,nt){return Dv(Ce)&&T8(Ce.left)?y2(Ce,ne,e,1,!nt):Ce.operatorToken.kind===28?t.updateBinaryExpression(Ce,ot(Ce.left,le,Ct),Ce.operatorToken,ot(Ce.right,nt?le:ne,Ct)):Mr(Ce,ne,e)}function Ie(Ce,nt){if(nt)return Mr(Ce,le,e);let Me;for(let ft=0;ft<Ce.elements.length;ft++){let tr=Ce.elements[ft],Oe=ot(tr,ft<Ce.elements.length-1?le:ne,Ct);(Me||Oe!==tr)&&(Me||(Me=Ce.elements.slice(0,ft)),Me.push(Oe))}let tt=Me?Et(t.createNodeArray(Me),Ce.elements):Ce.elements;return t.updateCommaListExpression(Ce,tt)}function _t(Ce){if(Ce.variableDeclaration&&Hs(Ce.variableDeclaration.name)&&Ce.variableDeclaration.name.transformFlags&65536){let nt=t.getGeneratedNameForNode(Ce.variableDeclaration.name),Me=t.updateVariableDeclaration(Ce.variableDeclaration,Ce.variableDeclaration.name,void 0,void 0,nt),tt=CE(Me,ne,e,1),ft=ot(Ce.block,ne,Vs);return Pt(tt)&&(ft=t.updateBlock(ft,[t.createVariableStatement(void 0,tt),...ft.statements])),t.updateCatchClause(Ce,t.updateVariableDeclaration(Ce.variableDeclaration,nt,void 0,void 0,void 0),ft)}return Mr(Ce,ne,e)}function mt(Ce){if(li(Ce,32)){let nt=x;x=!0;let Me=Mr(Ce,ne,e);return x=nt,Me}return Mr(Ce,ne,e)}function Xe(Ce){if(x){let nt=x;x=!1;let Me=ht(Ce,!0);return x=nt,Me}return ht(Ce,!1)}function ht(Ce,nt){return Hs(Ce.name)&&Ce.name.transformFlags&65536?CE(Ce,ne,e,1,void 0,nt):Mr(Ce,ne,e)}function rr(Ce){return t.updateForStatement(Ce,ot(Ce.initializer,le,Sd),ot(Ce.condition,ne,Ct),ot(Ce.incrementor,le,Ct),ff(Ce.statement,ne,e))}function vr(Ce){return Mr(Ce,le,e)}function xr(Ce,nt){let Me=K(0,2);(Ce.initializer.transformFlags&65536||TI(Ce.initializer)&&T8(Ce.initializer))&&(Ce=jr(Ce));let tt=Ce.awaitModifier?Zr(Ce,nt,Me):t.restoreEnclosingLabel(Mr(Ce,ne,e),nt);return re(Me),tt}function jr(Ce){let nt=So(Ce.initializer);if(Ru(nt)||TI(nt)){let Me,tt,ft=t.createTempVariable(void 0),tr=[gY(t,nt,ft)];return Vs(Ce.statement)?(wn(tr,Ce.statement.statements),Me=Ce.statement,tt=Ce.statement.statements):Ce.statement&&(Bt(tr,Ce.statement),Me=Ce.statement,tt=Ce.statement),t.updateForOfStatement(Ce,Ce.awaitModifier,Et(t.createVariableDeclarationList([Et(t.createVariableDeclaration(ft),Ce.initializer)],1),Ce.initializer),Ce.expression,Et(t.createBlock(Et(t.createNodeArray(tr),tt),!0),Me))}return Ce}function ur(Ce,nt,Me){let tt=t.createTempVariable(o),ft=t.createAssignment(tt,nt),tr=t.createExpressionStatement(ft);qa(tr,Ce.expression);let Oe=t.createAssignment(Me,t.createFalse()),At=t.createExpressionStatement(Oe);qa(At,Ce.expression);let Nt=[tr,At],Ut=gY(t,Ce.initializer,tt);Nt.push(ot(Ut,ne,Vi));let Rt,nr,Z=ff(Ce.statement,ne,e);return Vs(Z)?(wn(Nt,Z.statements),Rt=Z,nr=Z.statements):Nt.push(Z),Et(t.createBlock(Et(t.createNodeArray(Nt),nr),!0),Rt)}function or(Ce){return w&1?t.createYieldExpression(void 0,n().createAwaitHelper(Ce)):t.createAwaitExpression(Ce)}function Zr(Ce,nt,Me){let tt=ot(Ce.expression,ne,Ct),ft=He(tt)?t.getGeneratedNameForNode(tt):t.createTempVariable(void 0),tr=He(tt)?t.getGeneratedNameForNode(ft):t.createTempVariable(void 0),Oe=t.createTempVariable(void 0),At=t.createTempVariable(o),Nt=t.createUniqueName("e"),Ut=t.getGeneratedNameForNode(Nt),Rt=t.createTempVariable(void 0),nr=Et(n().createAsyncValuesHelper(tt),Ce.expression),Z=t.createCallExpression(t.createPropertyAccessExpression(ft,"next"),void 0,[]),Ge=t.createPropertyAccessExpression(tr,"done"),bt=t.createPropertyAccessExpression(tr,"value"),Q=t.createFunctionCallCall(Rt,ft,[]);o(Nt),o(Rt);let Ke=Me&2?t.inlineExpressions([t.createAssignment(Nt,t.createVoidZero()),nr]):nr,z=Tn(Et(t.createForStatement(Tn(Et(t.createVariableDeclarationList([t.createVariableDeclaration(Oe,void 0,void 0,t.createTrue()),Et(t.createVariableDeclaration(ft,void 0,void 0,Ke),Ce.expression),t.createVariableDeclaration(tr)]),Ce.expression),4194304),t.inlineExpressions([t.createAssignment(tr,or(Z)),t.createAssignment(At,Ge),t.createLogicalNot(At)]),t.createAssignment(Oe,t.createTrue()),ur(Ce,bt,Oe)),Ce),512);return zn(z,Ce),t.createTryStatement(t.createBlock([t.restoreEnclosingLabel(z,nt)]),t.createCatchClause(t.createVariableDeclaration(Ut),Tn(t.createBlock([t.createExpressionStatement(t.createAssignment(Nt,t.createObjectLiteralExpression([t.createPropertyAssignment("error",Ut)])))]),1)),t.createBlock([t.createTryStatement(t.createBlock([Tn(t.createIfStatement(t.createLogicalAnd(t.createLogicalAnd(t.createLogicalNot(Oe),t.createLogicalNot(At)),t.createAssignment(Rt,t.createPropertyAccessExpression(ft,"return"))),t.createExpressionStatement(or(Q))),1)]),void 0,Tn(t.createBlock([Tn(t.createIfStatement(Nt,t.createThrowStatement(t.createPropertyAccessExpression(Nt,"error"))),1)]),1))]))}function Oi(Ce){return M.assertNode(Ce,ns),Sr(Ce)}function Sr(Ce){return R?.has(Ce)?t.updateParameterDeclaration(Ce,void 0,Ce.dotDotDotToken,Hs(Ce.name)?t.getGeneratedNameForNode(Ce):Ce.name,void 0,void 0,void 0):Ce.transformFlags&65536?t.updateParameterDeclaration(Ce,void 0,Ce.dotDotDotToken,t.getGeneratedNameForNode(Ce),void 0,void 0,ot(Ce.initializer,ne,Ct)):Mr(Ce,ne,e)}function Pi(Ce){let nt;for(let Me of Ce.parameters)nt?nt.add(Me):Me.transformFlags&65536&&(nt=new Set);return nt}function Cs(Ce){let nt=w,Me=R;w=Rl(Ce),R=Pi(Ce);let tt=t.updateConstructorDeclaration(Ce,Ce.modifiers,Kc(Ce.parameters,Oi,e),vi(Ce));return w=nt,R=Me,tt}function ss(Ce){let nt=w,Me=R;w=Rl(Ce),R=Pi(Ce);let tt=t.updateGetAccessorDeclaration(Ce,Ce.modifiers,ot(Ce.name,ne,Ol),Kc(Ce.parameters,Oi,e),void 0,vi(Ce));return w=nt,R=Me,tt}function Ii(Ce){let nt=w,Me=R;w=Rl(Ce),R=Pi(Ce);let tt=t.updateSetAccessorDeclaration(Ce,Ce.modifiers,ot(Ce.name,ne,Ol),Kc(Ce.parameters,Oi,e),vi(Ce));return w=nt,R=Me,tt}function $r(Ce){let nt=w,Me=R;w=Rl(Ce),R=Pi(Ce);let tt=t.updateMethodDeclaration(Ce,w&1?Kr(Ce.modifiers,me,Cc):Ce.modifiers,w&2?void 0:Ce.asteriskToken,ot(Ce.name,ne,Ol),ot(void 0,ne,Q1),void 0,w&2&&w&1?Vr(Ce):Kc(Ce.parameters,Oi,e),void 0,w&2&&w&1?An(Ce):vi(Ce));return w=nt,R=Me,tt}function Xs(Ce){let nt=w,Me=R;w=Rl(Ce),R=Pi(Ce);let tt=t.updateFunctionDeclaration(Ce,w&1?Kr(Ce.modifiers,me,Pa):Ce.modifiers,w&2?void 0:Ce.asteriskToken,Ce.name,void 0,w&2&&w&1?Vr(Ce):Kc(Ce.parameters,Oi,e),void 0,w&2&&w&1?An(Ce):vi(Ce));return w=nt,R=Me,tt}function $e(Ce){let nt=w,Me=R;w=Rl(Ce),R=Pi(Ce);let tt=t.updateArrowFunction(Ce,Ce.modifiers,void 0,Kc(Ce.parameters,Oi,e),void 0,Ce.equalsGreaterThanToken,vi(Ce));return w=nt,R=Me,tt}function Yt(Ce){let nt=w,Me=R;w=Rl(Ce),R=Pi(Ce);let tt=t.updateFunctionExpression(Ce,w&1?Kr(Ce.modifiers,me,Pa):Ce.modifiers,w&2?void 0:Ce.asteriskToken,Ce.name,void 0,w&2&&w&1?Vr(Ce):Kc(Ce.parameters,Oi,e),void 0,w&2&&w&1?An(Ce):vi(Ce));return w=nt,R=Me,tt}function Vr(Ce){if(U8(Ce.parameters))return Kc(Ce.parameters,ne,e);let nt=[];for(let tt of Ce.parameters){if(tt.initializer||tt.dotDotDotToken)break;let ft=t.createParameterDeclaration(void 0,void 0,t.getGeneratedNameForNode(tt.name,8));nt.push(ft)}let Me=t.createNodeArray(nt);return Et(Me,Ce.parameters),Me}function An(Ce){let nt=U8(Ce.parameters)?void 0:Kc(Ce.parameters,ne,e);i();let Me=q,tt=ee;q=new Set,ee=!1;let ft=[],tr=t.updateBlock(Ce.body,Kr(Ce.body.statements,ne,Vi));tr=t.updateBlock(tr,t.mergeLexicalEnvironment(tr.statements,Ci(s(),Ce)));let Oe=t.createReturnStatement(n().createAsyncGeneratorHelper(t.createFunctionExpression(void 0,t.createToken(42),Ce.name&&t.getGeneratedNameForNode(Ce.name),void 0,nt??[],void 0,tr),!!(F&1))),At=d>=2&&(u.hasNodeCheckFlag(Ce,256)||u.hasNodeCheckFlag(Ce,128));if(At){Ui();let Ut=MB(t,u,Ce,q);W[yo(Ut)]=!0,Ay(ft,[Ut])}ft.push(Oe);let Nt=t.updateBlock(Ce.body,ft);return At&&ee&&(u.hasNodeCheckFlag(Ce,256)?NA(Nt,Aj):u.hasNodeCheckFlag(Ce,128)&&NA(Nt,Cj)),q=Me,ee=tt,Nt}function vi(Ce){i();let nt=0,Me=[],tt=ot(Ce.body,ne,O5)??t.createBlock([]);Vs(tt)&&(nt=t.copyPrologue(tt.statements,Me,!1,ne)),wn(Me,Ci(void 0,Ce));let ft=s();if(nt>0||Pt(Me)||Pt(ft)){let tr=t.converters.convertToFunctionBlock(tt,!0);return Ay(Me,ft),wn(Me,tr.statements.slice(nt)),t.updateBlock(tr,Et(t.createNodeArray(Me),tr.statements))}return tt}function Ci(Ce,nt){let Me=!1;for(let tt of nt.parameters)if(Me){if(Hs(tt.name)){if(tt.name.elements.length>0){let ft=CE(tt,ne,e,0,t.getGeneratedNameForNode(tt));if(Pt(ft)){let tr=t.createVariableDeclarationList(ft),Oe=t.createVariableStatement(void 0,tr);Tn(Oe,2097152),Ce=Bt(Ce,Oe)}}else if(tt.initializer){let ft=t.getGeneratedNameForNode(tt),tr=ot(tt.initializer,ne,Ct),Oe=t.createAssignment(ft,tr),At=t.createExpressionStatement(Oe);Tn(At,2097152),Ce=Bt(Ce,At)}}else if(tt.initializer){let ft=t.cloneNode(tt.name);Et(ft,tt.name),Tn(ft,96);let tr=ot(tt.initializer,ne,Ct);zg(tr,3168);let Oe=t.createAssignment(ft,tr);Et(Oe,tt),Tn(Oe,3072);let At=t.createBlock([t.createExpressionStatement(Oe)]);Et(At,tt),Tn(At,3905);let Nt=t.createTypeCheck(t.cloneNode(tt.name),"undefined"),Ut=t.createIfStatement(Nt,At);T_(Ut),Et(Ut,tt),Tn(Ut,2101056),Ce=Bt(Ce,Ut)}}else if(tt.transformFlags&65536){Me=!0;let ft=CE(tt,ne,e,1,t.getGeneratedNameForNode(tt),!1,!0);if(Pt(ft)){let tr=t.createVariableDeclarationList(ft),Oe=t.createVariableStatement(void 0,tr);Tn(Oe,2097152),Ce=Bt(Ce,Oe)}}return Ce}function Ui(){D&1||(D|=1,e.enableSubstitution(213),e.enableSubstitution(211),e.enableSubstitution(212),e.enableEmitNotification(263),e.enableEmitNotification(174),e.enableEmitNotification(177),e.enableEmitNotification(178),e.enableEmitNotification(176),e.enableEmitNotification(243))}function la(Ce,nt,Me){if(D&1&&fe(nt)){let tt=(u.hasNodeCheckFlag(nt,128)?128:0)|(u.hasNodeCheckFlag(nt,256)?256:0);if(tt!==L){let ft=L;L=tt,S(Ce,nt,Me),L=ft;return}}else if(D&&W[yo(nt)]){let tt=L;L=0,S(Ce,nt,Me),L=tt;return}S(Ce,nt,Me)}function Gs(Ce,nt){return nt=E(Ce,nt),Ce===1&&L?yr(nt):nt}function yr(Ce){switch(Ce.kind){case 211:return to(Ce);case 212:return lt(Ce);case 213:return St(Ce)}return Ce}function to(Ce){return Ce.expression.kind===108?Et(t.createPropertyAccessExpression(t.createUniqueName("_super",48),Ce.name),Ce):Ce}function lt(Ce){return Ce.expression.kind===108?vt(Ce.argumentExpression,Ce):Ce}function St(Ce){let nt=Ce.expression;if(Cf(nt)){let Me=Wn(nt)?to(nt):lt(nt);return t.createCallExpression(t.createPropertyAccessExpression(Me,"call"),void 0,[t.createThis(),...Ce.arguments])}return Ce}function fe(Ce){let nt=Ce.kind;return nt===263||nt===176||nt===174||nt===177||nt===178}function vt(Ce,nt){return L&256?Et(t.createPropertyAccessExpression(t.createCallExpression(t.createIdentifier("_superIndex"),void 0,[Ce]),"value"),nt):Et(t.createCallExpression(t.createIdentifier("_superIndex"),void 0,[Ce]),nt)}}function mhe(e){let t=e.factory;return cg(e,n);function n(o){return o.isDeclarationFile?o:Mr(o,i,e)}function i(o){if(!(o.transformFlags&64))return o;switch(o.kind){case 299:return s(o);default:return Mr(o,i,e)}}function s(o){return o.variableDeclaration?Mr(o,i,e):t.updateCatchClause(o,t.createVariableDeclaration(t.createTempVariable(void 0)),ot(o.block,i,Vs))}}function ghe(e){let{factory:t,hoistVariableDeclaration:n}=e;return cg(e,i);function i(R){return R.isDeclarationFile?R:Mr(R,s,e)}function s(R){if(!(R.transformFlags&32))return R;switch(R.kind){case 213:{let L=d(R,!1);return M.assertNotNode(L,JA),L}case 211:case 212:if(S_(R)){let L=E(R,!1,!1);return M.assertNotNode(L,JA),L}return Mr(R,s,e);case 226:return R.operatorToken.kind===61?D(R):Mr(R,s,e);case 220:return w(R);default:return Mr(R,s,e)}}function o(R){M.assertNotNode(R,P5);let L=[R];for(;!R.questionDotToken&&!hE(R);)R=aa(km(R.expression),S_),M.assertNotNode(R,P5),L.unshift(R);return{expression:R.expression,chain:L}}function u(R,L,F){let J=S(R.expression,L,F);return JA(J)?t.createSyntheticReferenceExpression(t.updateParenthesizedExpression(R,J.expression),J.thisArg):t.updateParenthesizedExpression(R,J)}function m(R,L,F){if(S_(R))return E(R,L,F);let J=ot(R.expression,s,Ct);M.assertNotNode(J,JA);let G;return L&&(xE(J)?G=J:(G=t.createTempVariable(n),J=t.createAssignment(G,J))),J=R.kind===211?t.updatePropertyAccessExpression(R,J,ot(R.name,s,He)):t.updateElementAccessExpression(R,J,ot(R.argumentExpression,s,Ct)),G?t.createSyntheticReferenceExpression(J,G):J}function d(R,L){if(S_(R))return E(R,L,!1);if(uf(R.expression)&&S_(So(R.expression))){let F=u(R.expression,!0,!1),J=Kr(R.arguments,s,Ct);return JA(F)?Et(t.createFunctionCallCall(F.expression,F.thisArg,J),R):t.updateCallExpression(R,F,void 0,J)}return Mr(R,s,e)}function S(R,L,F){switch(R.kind){case 217:return u(R,L,F);case 211:case 212:return m(R,L,F);case 213:return d(R,L);default:return ot(R,s,Ct)}}function E(R,L,F){let{expression:J,chain:G}=o(R),q=S(km(J),qx(G[0]),!1),ee=JA(q)?q.thisArg:void 0,W=JA(q)?q.expression:q,pe=t.restoreOuterExpressions(J,W,8);xE(W)||(W=t.createTempVariable(n),pe=t.createAssignment(W,pe));let K=W,re;for(let ce=0;ce<G.length;ce++){let ne=G[ce];switch(ne.kind){case 211:case 212:ce===G.length-1&&L&&(xE(K)?re=K:(re=t.createTempVariable(n),K=t.createAssignment(re,K))),K=ne.kind===211?t.createPropertyAccessExpression(K,ot(ne.name,s,He)):t.createElementAccessExpression(K,ot(ne.argumentExpression,s,Ct));break;case 213:ce===0&&ee?(xc(ee)||(ee=t.cloneNode(ee),zg(ee,3072)),K=t.createFunctionCallCall(K,ee.kind===108?t.createThis():ee,Kr(ne.arguments,s,Ct))):K=t.createCallExpression(K,void 0,Kr(ne.arguments,s,Ct));break}zn(K,ne)}let ue=F?t.createConditionalExpression(x(pe,W,!0),void 0,t.createTrue(),void 0,t.createDeleteExpression(K)):t.createConditionalExpression(x(pe,W,!0),void 0,t.createVoidZero(),void 0,K);return Et(ue,R),re?t.createSyntheticReferenceExpression(ue,re):ue}function x(R,L,F){return t.createBinaryExpression(t.createBinaryExpression(R,t.createToken(F?37:38),t.createNull()),t.createToken(F?57:56),t.createBinaryExpression(L,t.createToken(F?37:38),t.createVoidZero()))}function D(R){let L=ot(R.left,s,Ct),F=L;return xE(L)||(F=t.createTempVariable(n),L=t.createAssignment(F,L)),Et(t.createConditionalExpression(x(L,F),void 0,F,void 0,ot(R.right,s,Ct)),R)}function w(R){return S_(So(R.expression))?zn(S(R.expression,!1,!0),R):t.updateDeleteExpression(R,ot(R.expression,s,Ct))}}function hhe(e){let{hoistVariableDeclaration:t,factory:n}=e;return cg(e,i);function i(u){return u.isDeclarationFile?u:Mr(u,s,e)}function s(u){return u.transformFlags&16?QH(u)?o(u):Mr(u,s,e):u}function o(u){let m=u.operatorToken,d=QO(m.kind),S=So(ot(u.left,s,xf)),E=S,x=So(ot(u.right,s,Ct));if(oc(S)){let D=xE(S.expression),w=D?S.expression:n.createTempVariable(t),R=D?S.expression:n.createAssignment(w,S.expression);if(Wn(S))E=n.createPropertyAccessExpression(w,S.name),S=n.createPropertyAccessExpression(R,S.name);else{let L=xE(S.argumentExpression),F=L?S.argumentExpression:n.createTempVariable(t);E=n.createElementAccessExpression(w,F),S=n.createElementAccessExpression(R,L?S.argumentExpression:n.createAssignment(F,S.argumentExpression))}}return n.createBinaryExpression(S,d,n.createParenthesizedExpression(n.createAssignment(E,x)))}}function yhe(e){let{factory:t,getEmitHelperFactory:n,hoistVariableDeclaration:i,startLexicalEnvironment:s,endLexicalEnvironment:o}=e,u,m,d,S;return cg(e,E);function E(de){if(de.isDeclarationFile)return de;let Ae=ot(de,x,Ji);return E0(Ae,e.readEmitHelpers()),m=void 0,u=void 0,d=void 0,Ae}function x(de){if(!(de.transformFlags&4))return de;switch(de.kind){case 307:return D(de);case 241:return w(de);case 248:return R(de);case 250:return L(de);case 255:return J(de);default:return Mr(de,x,e)}}function D(de){let Ae=OK(de.statements);if(Ae){s(),u=new LN,m=[];let xe=_8e(de.statements),te=[];wn(te,F8(de.statements,x,Vi,0,xe));let he=xe;for(;he<de.statements.length;){let Pe=de.statements[he];if(She(Pe)!==0){he>xe&&wn(te,Kr(de.statements,x,Vi,xe,he-xe));break}he++}M.assert(he<de.statements.length,"Should have encountered at least one 'using' statement.");let be=le(),Ve=G(de.statements,he,de.statements.length,be,te);return u.size&&Bt(te,t.createExportDeclaration(void 0,!1,t.createNamedExports(Is(u.values())))),wn(te,o()),m.length&&te.push(t.createVariableStatement(t.createModifiersFromModifierFlags(32),t.createVariableDeclarationList(m,1))),wn(te,me(Ve,be,Ae===2)),S&&te.push(t.createExportAssignment(void 0,!0,S)),t.updateSourceFile(de,te)}return Mr(de,x,e)}function w(de){let Ae=OK(de.statements);if(Ae){let xe=_8e(de.statements),te=le();return t.updateBlock(de,[...F8(de.statements,x,Vi,0,xe),...me(G(de.statements,xe,de.statements.length,te,void 0),te,Ae===2)])}return Mr(de,x,e)}function R(de){return de.initializer&&f8e(de.initializer)?ot(t.createBlock([t.createVariableStatement(void 0,de.initializer),t.updateForStatement(de,void 0,de.condition,de.incrementor,de.statement)]),x,Vi):Mr(de,x,e)}function L(de){if(f8e(de.initializer)){let Ae=de.initializer,xe=xo(Ae.declarations)||t.createVariableDeclaration(t.createTempVariable(void 0)),te=vhe(Ae)===2,he=t.getGeneratedNameForNode(xe.name),be=t.updateVariableDeclaration(xe,xe.name,void 0,void 0,he),Ve=t.createVariableDeclarationList([be],te?6:4),Pe=t.createVariableStatement(void 0,Ve);return ot(t.updateForOfStatement(de,de.awaitModifier,t.createVariableDeclarationList([t.createVariableDeclaration(he)],2),de.expression,Vs(de.statement)?t.updateBlock(de.statement,[Pe,...de.statement.statements]):t.createBlock([Pe,de.statement],!0)),x,Vi)}return Mr(de,x,e)}function F(de,Ae){return OK(de.statements)!==0?SN(de)?t.updateCaseClause(de,ot(de.expression,x,Ct),G(de.statements,0,de.statements.length,Ae,void 0)):t.updateDefaultClause(de,G(de.statements,0,de.statements.length,Ae,void 0)):Mr(de,x,e)}function J(de){let Ae=VEt(de.caseBlock.clauses);if(Ae){let xe=le();return me([t.updateSwitchStatement(de,ot(de.expression,x,Ct),t.updateCaseBlock(de.caseBlock,de.caseBlock.clauses.map(te=>F(te,xe))))],xe,Ae===2)}return Mr(de,x,e)}function G(de,Ae,xe,te,he){let be=[];for(let ke=Ae;ke<xe;ke++){let De=de[ke],Be=She(De);if(Be){M.assertNode(De,_l);let qe=[];for(let et of De.declarationList.declarations){if(!He(et.name)){qe.length=0;break}cp(et)&&(et=dp(e,et));let Ie=ot(et.initializer,x,Ct)??t.createVoidZero();qe.push(t.updateVariableDeclaration(et,et.name,void 0,void 0,n().createAddDisposableResourceHelper(te,Ie,Be===2)))}if(qe.length){let et=t.createVariableDeclarationList(qe,2);zn(et,De.declarationList),Et(et,De.declarationList),Ve(t.updateVariableStatement(De,void 0,et));continue}}let ct=x(De);Rs(ct)?ct.forEach(Ve):ct&&Ve(ct)}return be;function Ve(ke){M.assertNode(ke,Vi),Bt(be,Pe(ke))}function Pe(ke){if(!he)return ke;switch(ke.kind){case 272:case 271:case 278:case 262:return q(ke,he);case 277:return ee(ke);case 263:return K(ke);case 243:return re(ke)}return ke}}function q(de,Ae){Ae.push(de)}function ee(de){return de.isExportEquals?pe(de):W(de)}function W(de){if(d)return de;d=t.createUniqueName("_default",56),ne(d,!0,"default",de);let Ae=de.expression,xe=Ml(Ae);cp(xe)&&(xe=dp(e,xe,!1,"default"),Ae=t.restoreOuterExpressions(Ae,xe));let te=t.createAssignment(d,Ae);return t.createExpressionStatement(te)}function pe(de){if(S)return de;S=t.createUniqueName("_default",56),i(S);let Ae=t.createAssignment(S,de.expression);return t.createExpressionStatement(Ae)}function K(de){if(!de.name&&d)return de;let Ae=li(de,32),xe=li(de,2048),te=t.converters.convertToClassExpression(de);return de.name&&(ne(t.getLocalName(de),Ae&&!xe,void 0,de),te=t.createAssignment(t.getDeclarationName(de),te),cp(te)&&(te=dp(e,te,!1)),zn(te,de),qa(te,de),Zl(te,de)),xe&&!d&&(d=t.createUniqueName("_default",56),ne(d,!0,"default",de),te=t.createAssignment(d,te),cp(te)&&(te=dp(e,te,!1,"default")),zn(te,de)),t.createExpressionStatement(te)}function re(de){let Ae,xe=li(de,32);for(let te of de.declarationList.declarations)ce(te,xe,te),te.initializer&&(Ae=Bt(Ae,ue(te)));if(Ae){let te=t.createExpressionStatement(t.inlineExpressions(Ae));return zn(te,de),Zl(te,de),qa(te,de),te}}function ue(de){M.assertIsDefined(de.initializer);let Ae;He(de.name)?(Ae=t.cloneNode(de.name),Tn(Ae,Ga(Ae)&-114689)):Ae=t.converters.convertToAssignmentPattern(de.name);let xe=t.createAssignment(Ae,de.initializer);return zn(xe,de),Zl(xe,de),qa(xe,de),xe}function ce(de,Ae,xe){if(Hs(de.name))for(let te of de.name.elements)pu(te)||ce(te,Ae,xe);else ne(de.name,Ae,void 0,xe)}function ne(de,Ae,xe,te){let he=xc(de)?de:t.cloneNode(de);if(Ae){if(xe===void 0&&!k0(he)){let ke=t.createVariableDeclaration(he);te&&zn(ke,te),m.push(ke);return}let be=xe!==void 0?he:void 0,Ve=xe!==void 0?xe:he,Pe=t.createExportSpecifier(!1,be,Ve);te&&zn(Pe,te),u.set(he,Pe)}i(he)}function le(){return t.createUniqueName("env")}function me(de,Ae,xe){let te=[],he=t.createObjectLiteralExpression([t.createPropertyAssignment("stack",t.createArrayLiteralExpression()),t.createPropertyAssignment("error",t.createVoidZero()),t.createPropertyAssignment("hasError",t.createFalse())]),be=t.createVariableDeclaration(Ae,void 0,void 0,he),Ve=t.createVariableDeclarationList([be],2),Pe=t.createVariableStatement(void 0,Ve);te.push(Pe);let ke=t.createBlock(de,!0),De=t.createUniqueName("e"),Be=t.createCatchClause(De,t.createBlock([t.createExpressionStatement(t.createAssignment(t.createPropertyAccessExpression(Ae,"error"),De)),t.createExpressionStatement(t.createAssignment(t.createPropertyAccessExpression(Ae,"hasError"),t.createTrue()))],!0)),ct;if(xe){let et=t.createUniqueName("result");ct=t.createBlock([t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(et,void 0,void 0,n().createDisposeResourcesHelper(Ae))],2)),t.createIfStatement(et,t.createExpressionStatement(t.createAwaitExpression(et)))],!0)}else ct=t.createBlock([t.createExpressionStatement(n().createDisposeResourcesHelper(Ae))],!0);let qe=t.createTryStatement(ke,Be,ct);return te.push(qe),te}}function _8e(e){for(let t=0;t<e.length;t++)if(!Mg(e[t])&&!nR(e[t]))return t;return 0}function f8e(e){return Ru(e)&&vhe(e)!==0}function vhe(e){return(e.flags&7)===6?2:(e.flags&7)===4?1:0}function UEt(e){return vhe(e.declarationList)}function She(e){return _l(e)?UEt(e):0}function OK(e){let t=0;for(let n of e){let i=She(n);if(i===2)return 2;i>t&&(t=i)}return t}function VEt(e){let t=0;for(let n of e){let i=OK(n.statements);if(i===2)return 2;i>t&&(t=i)}return t}function bhe(e){let{factory:t,getEmitHelperFactory:n}=e,i=e.getCompilerOptions(),s,o;return cg(e,x);function u(){if(o.filenameDeclaration)return o.filenameDeclaration.name;let qe=t.createVariableDeclaration(t.createUniqueName("_jsxFileName",48),void 0,void 0,t.createStringLiteral(s.fileName));return o.filenameDeclaration=qe,o.filenameDeclaration.name}function m(qe){return i.jsx===5?"jsxDEV":qe?"jsxs":"jsx"}function d(qe){let et=m(qe);return E(et)}function S(){return E("Fragment")}function E(qe){var et,Ie;let _t=qe==="createElement"?o.importSpecifier:Z9(o.importSpecifier,i),mt=(Ie=(et=o.utilizedImplicitRuntimeImports)==null?void 0:et.get(_t))==null?void 0:Ie.get(qe);if(mt)return mt.name;o.utilizedImplicitRuntimeImports||(o.utilizedImplicitRuntimeImports=new Map);let Xe=o.utilizedImplicitRuntimeImports.get(_t);Xe||(Xe=new Map,o.utilizedImplicitRuntimeImports.set(_t,Xe));let ht=t.createUniqueName(`_${qe}`,112),rr=t.createImportSpecifier(!1,t.createIdentifier(qe),ht);return rde(ht,rr),Xe.set(qe,rr),ht}function x(qe){if(qe.isDeclarationFile)return qe;s=qe,o={},o.importSpecifier=Q9(i,qe);let et=Mr(qe,D,e);E0(et,e.readEmitHelpers());let Ie=et.statements;if(o.filenameDeclaration&&(Ie=Gx(Ie.slice(),t.createVariableStatement(void 0,t.createVariableDeclarationList([o.filenameDeclaration],2)))),o.utilizedImplicitRuntimeImports){for(let[_t,mt]of Is(o.utilizedImplicitRuntimeImports.entries()))if(nu(qe)){let Xe=t.createImportDeclaration(void 0,t.createImportClause(!1,void 0,t.createNamedImports(Is(mt.values()))),t.createStringLiteral(_t),void 0);T0(Xe,!1),Ie=Gx(Ie.slice(),Xe)}else if(Uf(qe)){let Xe=t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(t.createObjectBindingPattern(Is(mt.values(),ht=>t.createBindingElement(void 0,ht.propertyName,ht.name))),void 0,void 0,t.createCallExpression(t.createIdentifier("require"),void 0,[t.createStringLiteral(_t)]))],2));T0(Xe,!1),Ie=Gx(Ie.slice(),Xe)}}return Ie!==et.statements&&(et=t.updateSourceFile(et,Ie)),o=void 0,et}function D(qe){return qe.transformFlags&2?w(qe):qe}function w(qe){switch(qe.kind){case 284:return G(qe,!1);case 285:return q(qe,!1);case 288:return ee(qe,!1);case 294:return ct(qe);default:return Mr(qe,D,e)}}function R(qe){switch(qe.kind){case 12:return he(qe);case 294:return ct(qe);case 284:return G(qe,!0);case 285:return q(qe,!0);case 288:return ee(qe,!0);default:return M.failBadSyntaxKind(qe)}}function L(qe){return qe.properties.some(et=>ql(et)&&(He(et.name)&&Nn(et.name)==="__proto__"||La(et.name)&&et.name.text==="__proto__"))}function F(qe){let et=!1;for(let Ie of qe.attributes.properties)if(qA(Ie)&&(!Ca(Ie.expression)||Ie.expression.properties.some(Fy)))et=!0;else if(et&&Kg(Ie)&&He(Ie.name)&&Ie.name.escapedText==="key")return!0;return!1}function J(qe){return o.importSpecifier===void 0||F(qe)}function G(qe,et){return(J(qe.openingElement)?ue:K)(qe.openingElement,qe.children,et,qe)}function q(qe,et){return(J(qe)?ue:K)(qe,void 0,et,qe)}function ee(qe,et){return(o.importSpecifier===void 0?ne:ce)(qe.openingFragment,qe.children,et,qe)}function W(qe){let et=pe(qe);return et&&t.createObjectLiteralExpression([et])}function pe(qe){let et=rN(qe);if(wt(et)===1&&!et[0].dotDotDotToken){let _t=R(et[0]);return _t&&t.createPropertyAssignment("children",_t)}let Ie=Gi(qe,R);return wt(Ie)?t.createPropertyAssignment("children",t.createArrayLiteralExpression(Ie)):void 0}function K(qe,et,Ie,_t){let mt=De(qe),Xe=et&&et.length?pe(et):void 0,ht=Ln(qe.attributes.properties,xr=>!!xr.name&&He(xr.name)&&xr.name.escapedText==="key"),rr=ht?Zn(qe.attributes.properties,xr=>xr!==ht):qe.attributes.properties,vr=wt(rr)?me(rr,Xe):t.createObjectLiteralExpression(Xe?[Xe]:ve);return re(mt,vr,ht,et||ve,Ie,_t)}function re(qe,et,Ie,_t,mt,Xe){var ht;let rr=rN(_t),vr=wt(rr)>1||!!((ht=rr[0])!=null&&ht.dotDotDotToken),xr=[qe,et];if(Ie&&xr.push(te(Ie.initializer)),i.jsx===5){let ur=Bc(s);if(ur&&Ji(ur)){Ie===void 0&&xr.push(t.createVoidZero()),xr.push(vr?t.createTrue():t.createFalse());let or=ba(ur,Xe.pos);xr.push(t.createObjectLiteralExpression([t.createPropertyAssignment("fileName",u()),t.createPropertyAssignment("lineNumber",t.createNumericLiteral(or.line+1)),t.createPropertyAssignment("columnNumber",t.createNumericLiteral(or.character+1))])),xr.push(t.createThis())}}let jr=Et(t.createCallExpression(d(vr),void 0,xr),Xe);return mt&&T_(jr),jr}function ue(qe,et,Ie,_t){let mt=De(qe),Xe=qe.attributes.properties,ht=wt(Xe)?me(Xe):t.createNull(),rr=o.importSpecifier===void 0?mY(t,e.getEmitResolver().getJsxFactoryEntity(s),i.reactNamespace,qe):E("createElement"),vr=ome(t,rr,mt,ht,Gi(et,R),_t);return Ie&&T_(vr),vr}function ce(qe,et,Ie,_t){let mt;if(et&&et.length){let Xe=W(et);Xe&&(mt=Xe)}return re(S(),mt||t.createObjectLiteralExpression([]),void 0,et,Ie,_t)}function ne(qe,et,Ie,_t){let mt=cme(t,e.getEmitResolver().getJsxFactoryEntity(s),e.getEmitResolver().getJsxFragmentFactoryEntity(s),i.reactNamespace,Gi(et,R),qe,_t);return Ie&&T_(mt),mt}function le(qe){return Ca(qe.expression)&&!L(qe.expression)?Fs(qe.expression.properties,et=>M.checkDefined(ot(et,D,p0))):t.createSpreadAssignment(M.checkDefined(ot(qe.expression,D,Ct)))}function me(qe,et){let Ie=Ka(i);return Ie&&Ie>=5?t.createObjectLiteralExpression(de(qe,et)):Ae(qe,et)}function de(qe,et){let Ie=ef(EP(qe,qA,(_t,mt)=>ef(Cr(_t,Xe=>mt?le(Xe):xe(Xe)))));return et&&Ie.push(et),Ie}function Ae(qe,et){let Ie=[],_t=[];for(let Xe of qe){if(qA(Xe)){if(Ca(Xe.expression)&&!L(Xe.expression)){for(let ht of Xe.expression.properties){if(Fy(ht)){mt(),Ie.push(M.checkDefined(ot(ht.expression,D,Ct)));continue}_t.push(M.checkDefined(ot(ht,D)))}continue}mt(),Ie.push(M.checkDefined(ot(Xe.expression,D,Ct)));continue}_t.push(xe(Xe))}return et&&_t.push(et),mt(),Ie.length&&!Ca(Ie[0])&&Ie.unshift(t.createObjectLiteralExpression()),Dh(Ie)||n().createAssignHelper(Ie);function mt(){_t.length&&(Ie.push(t.createObjectLiteralExpression(_t)),_t=[])}}function xe(qe){let et=Be(qe),Ie=te(qe.initializer);return t.createPropertyAssignment(et,Ie)}function te(qe){if(qe===void 0)return t.createTrue();if(qe.kind===11){let et=qe.singleQuote!==void 0?qe.singleQuote:!d9(qe,s),Ie=t.createStringLiteral(ke(qe.text)||qe.text,et);return Et(Ie,qe)}return qe.kind===294?qe.expression===void 0?t.createTrue():M.checkDefined(ot(qe.expression,D,Ct)):Ly(qe)?G(qe,!1):u2(qe)?q(qe,!1):vE(qe)?ee(qe,!1):M.failBadSyntaxKind(qe)}function he(qe){let et=be(qe.text);return et===void 0?void 0:t.createStringLiteral(et)}function be(qe){let et,Ie=0,_t=-1;for(let mt=0;mt<qe.length;mt++){let Xe=qe.charCodeAt(mt);v_(Xe)?(Ie!==-1&&_t!==-1&&(et=Ve(et,qe.substr(Ie,_t-Ie+1))),Ie=-1):wg(Xe)||(_t=mt,Ie===-1&&(Ie=mt))}return Ie!==-1?Ve(et,qe.substr(Ie)):et}function Ve(qe,et){let Ie=Pe(et);return qe===void 0?Ie:qe+" "+Ie}function Pe(qe){return qe.replace(/&((#((\d+)|x([\da-fA-F]+)))|(\w+));/g,(et,Ie,_t,mt,Xe,ht,rr)=>{if(Xe)return _I(parseInt(Xe,10));if(ht)return _I(parseInt(ht,16));{let vr=JEt.get(rr);return vr?_I(vr):et}})}function ke(qe){let et=Pe(qe);return et===qe?void 0:et}function De(qe){if(qe.kind===284)return De(qe.openingElement);{let et=qe.tagName;return He(et)&&nN(et.escapedText)?t.createStringLiteral(Nn(et)):sg(et)?t.createStringLiteral(Nn(et.namespace)+":"+Nn(et.name)):g8(t,et)}}function Be(qe){let et=qe.name;if(He(et)){let Ie=Nn(et);return/^[A-Za-z_]\w*$/.test(Ie)?et:t.createStringLiteral(Ie)}return t.createStringLiteral(Nn(et.namespace)+":"+Nn(et.name))}function ct(qe){let et=ot(qe.expression,D,Ct);return qe.dotDotDotToken?t.createSpreadElement(et):et}}var JEt=new Map(Object.entries({quot:34,amp:38,apos:39,lt:60,gt:62,nbsp:160,iexcl:161,cent:162,pound:163,curren:164,yen:165,brvbar:166,sect:167,uml:168,copy:169,ordf:170,laquo:171,not:172,shy:173,reg:174,macr:175,deg:176,plusmn:177,sup2:178,sup3:179,acute:180,micro:181,para:182,middot:183,cedil:184,sup1:185,ordm:186,raquo:187,frac14:188,frac12:189,frac34:190,iquest:191,Agrave:192,Aacute:193,Acirc:194,Atilde:195,Auml:196,Aring:197,AElig:198,Ccedil:199,Egrave:200,Eacute:201,Ecirc:202,Euml:203,Igrave:204,Iacute:205,Icirc:206,Iuml:207,ETH:208,Ntilde:209,Ograve:210,Oacute:211,Ocirc:212,Otilde:213,Ouml:214,times:215,Oslash:216,Ugrave:217,Uacute:218,Ucirc:219,Uuml:220,Yacute:221,THORN:222,szlig:223,agrave:224,aacute:225,acirc:226,atilde:227,auml:228,aring:229,aelig:230,ccedil:231,egrave:232,eacute:233,ecirc:234,euml:235,igrave:236,iacute:237,icirc:238,iuml:239,eth:240,ntilde:241,ograve:242,oacute:243,ocirc:244,otilde:245,ouml:246,divide:247,oslash:248,ugrave:249,uacute:250,ucirc:251,uuml:252,yacute:253,thorn:254,yuml:255,OElig:338,oelig:339,Scaron:352,scaron:353,Yuml:376,fnof:402,circ:710,tilde:732,Alpha:913,Beta:914,Gamma:915,Delta:916,Epsilon:917,Zeta:918,Eta:919,Theta:920,Iota:921,Kappa:922,Lambda:923,Mu:924,Nu:925,Xi:926,Omicron:927,Pi:928,Rho:929,Sigma:931,Tau:932,Upsilon:933,Phi:934,Chi:935,Psi:936,Omega:937,alpha:945,beta:946,gamma:947,delta:948,epsilon:949,zeta:950,eta:951,theta:952,iota:953,kappa:954,lambda:955,mu:956,nu:957,xi:958,omicron:959,pi:960,rho:961,sigmaf:962,sigma:963,tau:964,upsilon:965,phi:966,chi:967,psi:968,omega:969,thetasym:977,upsih:978,piv:982,ensp:8194,emsp:8195,thinsp:8201,zwnj:8204,zwj:8205,lrm:8206,rlm:8207,ndash:8211,mdash:8212,lsquo:8216,rsquo:8217,sbquo:8218,ldquo:8220,rdquo:8221,bdquo:8222,dagger:8224,Dagger:8225,bull:8226,hellip:8230,permil:8240,prime:8242,Prime:8243,lsaquo:8249,rsaquo:8250,oline:8254,frasl:8260,euro:8364,image:8465,weierp:8472,real:8476,trade:8482,alefsym:8501,larr:8592,uarr:8593,rarr:8594,darr:8595,harr:8596,crarr:8629,lArr:8656,uArr:8657,rArr:8658,dArr:8659,hArr:8660,forall:8704,part:8706,exist:8707,empty:8709,nabla:8711,isin:8712,notin:8713,ni:8715,prod:8719,sum:8721,minus:8722,lowast:8727,radic:8730,prop:8733,infin:8734,ang:8736,and:8743,or:8744,cap:8745,cup:8746,int:8747,there4:8756,sim:8764,cong:8773,asymp:8776,ne:8800,equiv:8801,le:8804,ge:8805,sub:8834,sup:8835,nsub:8836,sube:8838,supe:8839,oplus:8853,otimes:8855,perp:8869,sdot:8901,lceil:8968,rceil:8969,lfloor:8970,rfloor:8971,lang:9001,rang:9002,loz:9674,spades:9824,clubs:9827,hearts:9829,diams:9830}));function The(e){let{factory:t,hoistVariableDeclaration:n}=e;return cg(e,i);function i(d){return d.isDeclarationFile?d:Mr(d,s,e)}function s(d){if(!(d.transformFlags&512))return d;switch(d.kind){case 226:return o(d);default:return Mr(d,s,e)}}function o(d){switch(d.operatorToken.kind){case 68:return u(d);case 43:return m(d);default:return Mr(d,s,e)}}function u(d){let S,E,x=ot(d.left,s,Ct),D=ot(d.right,s,Ct);if(cc(x)){let w=t.createTempVariable(n),R=t.createTempVariable(n);S=Et(t.createElementAccessExpression(Et(t.createAssignment(w,x.expression),x.expression),Et(t.createAssignment(R,x.argumentExpression),x.argumentExpression)),x),E=Et(t.createElementAccessExpression(w,R),x)}else if(Wn(x)){let w=t.createTempVariable(n);S=Et(t.createPropertyAccessExpression(Et(t.createAssignment(w,x.expression),x.expression),x.name),x),E=Et(t.createPropertyAccessExpression(w,x.name),x)}else S=x,E=x;return Et(t.createAssignment(S,Et(t.createGlobalMethodCall("Math","pow",[E,D]),d)),d)}function m(d){let S=ot(d.left,s,Ct),E=ot(d.right,s,Ct);return Et(t.createGlobalMethodCall("Math","pow",[S,E]),d)}}function p8e(e,t){return{kind:e,expression:t}}function Ehe(e){let{factory:t,getEmitHelperFactory:n,startLexicalEnvironment:i,resumeLexicalEnvironment:s,endLexicalEnvironment:o,hoistVariableDeclaration:u}=e,m=e.getCompilerOptions(),d=e.getEmitResolver(),S=e.onSubstituteNode,E=e.onEmitNode;e.onEmitNode=id,e.onSubstituteNode=sd;let x,D,w,R;function L(oe){R=Bt(R,t.createVariableDeclaration(oe))}let F,J;return cg(e,G);function G(oe){if(oe.isDeclarationFile)return oe;x=oe,D=oe.text;let yt=me(oe);return E0(yt,e.readEmitHelpers()),x=void 0,D=void 0,R=void 0,w=0,yt}function q(oe,yt){let Gt=w;return w=(w&~oe|yt)&32767,Gt}function ee(oe,yt,Gt){w=(w&~yt|Gt)&-32768|oe}function W(oe){return(w&8192)!==0&&oe.kind===253&&!oe.expression}function pe(oe){return oe.transformFlags&4194304&&(nm(oe)||vb(oe)||$de(oe)||NO(oe)||DO(oe)||SN(oe)||IO(oe)||c2(oe)||bE(oe)||rS(oe)||V1(oe,!1)||Vs(oe))}function K(oe){return(oe.transformFlags&1024)!==0||F!==void 0||w&8192&&pe(oe)||V1(oe,!1)&&ts(oe)||(Pm(oe)&1)!==0}function re(oe){return K(oe)?le(oe,!1):oe}function ue(oe){return K(oe)?le(oe,!0):oe}function ce(oe){if(K(oe)){let yt=Bc(oe);if(Ns(yt)&&Jl(yt)){let Gt=q(32670,16449),Xt=le(oe,!1);return ee(Gt,229376,0),Xt}return le(oe,!1)}return oe}function ne(oe){return oe.kind===108?Wf(oe,!0):re(oe)}function le(oe,yt){switch(oe.kind){case 126:return;case 263:return De(oe);case 231:return Be(oe);case 169:return Gs(oe);case 262:return Rt(oe);case 219:return Nt(oe);case 218:return Ut(oe);case 260:return dr(oe);case 80:return Pe(oe);case 261:return Re(oe);case 255:return de(oe);case 269:return Ae(oe);case 241:return Ge(oe,!1);case 252:case 251:return ke(oe);case 256:return dn(oe);case 246:case 247:return Ki(oe,void 0);case 248:return ls(oe,void 0);case 249:return pi(oe,void 0);case 250:return Er(oe,void 0);case 244:return bt(oe);case 210:return Mo(oe);case 299:return Ri(oe);case 304:return Wl(oe);case 167:return Oc(oe);case 209:return hc(oe);case 213:return mu(oe);case 214:return $l(oe);case 217:return Q(oe,yt);case 226:return Ke(oe,yt);case 355:return z(oe,yt);case 15:case 16:case 17:case 18:return so(oe);case 11:return fl(oe);case 9:return au(oe);case 215:return Uo(oe);case 228:return Fo(oe);case 229:return du(oe);case 230:return Qa(oe);case 108:return Wf(oe,!1);case 110:return be(oe);case 236:return fg(oe);case 174:return Na(oe);case 177:case 178:return gc(oe);case 243:return Te(oe);case 253:return he(oe);case 222:return Ve(oe);default:return Mr(oe,re,e)}}function me(oe){let yt=q(8064,64),Gt=[],Xt=[];i();let Fr=t.copyPrologue(oe.statements,Gt,!1,re);return wn(Xt,Kr(oe.statements,re,Vi,Fr)),R&&Xt.push(t.createVariableStatement(void 0,t.createVariableDeclarationList(R))),t.mergeLexicalEnvironment(Gt,o()),Ce(Gt,oe),ee(yt,0,0),t.updateSourceFile(oe,Et(t.createNodeArray(ps(Gt,Xt)),oe.statements))}function de(oe){if(F!==void 0){let yt=F.allowedNonLabeledJumps;F.allowedNonLabeledJumps|=2;let Gt=Mr(oe,re,e);return F.allowedNonLabeledJumps=yt,Gt}return Mr(oe,re,e)}function Ae(oe){let yt=q(7104,0),Gt=Mr(oe,re,e);return ee(yt,0,0),Gt}function xe(oe){return zn(t.createReturnStatement(te()),oe)}function te(){return t.createUniqueName("_this",48)}function he(oe){return F?(F.nonLocalJumps|=8,W(oe)&&(oe=xe(oe)),t.createReturnStatement(t.createObjectLiteralExpression([t.createPropertyAssignment(t.createIdentifier("value"),oe.expression?M.checkDefined(ot(oe.expression,re,Ct)):t.createVoidZero())]))):W(oe)?xe(oe):Mr(oe,re,e)}function be(oe){return w|=65536,w&2&&!(w&16384)&&(w|=131072),F?w&2?(F.containsLexicalThis=!0,oe):F.thisName||(F.thisName=t.createUniqueName("this")):oe}function Ve(oe){return Mr(oe,ue,e)}function Pe(oe){return F&&d.isArgumentsLocalBinding(oe)?F.argumentsName||(F.argumentsName=t.createUniqueName("arguments")):oe.flags&256?zn(Et(t.createIdentifier(Qi(oe.escapedText)),oe),oe):oe}function ke(oe){if(F){let yt=oe.kind===252?2:4;if(!(oe.label&&F.labels&&F.labels.get(Nn(oe.label))||!oe.label&&F.allowedNonLabeledJumps&yt)){let Xt,Fr=oe.label;Fr?oe.kind===252?(Xt=`break-${Fr.escapedText}`,ae(F,!0,Nn(Fr),Xt)):(Xt=`continue-${Fr.escapedText}`,ae(F,!1,Nn(Fr),Xt)):oe.kind===252?(F.nonLocalJumps|=2,Xt="break"):(F.nonLocalJumps|=4,Xt="continue");let nn=t.createStringLiteral(Xt);if(F.loopOutParameters.length){let Hn=F.loopOutParameters,Si;for(let $=0;$<Hn.length;$++){let Fe=qf(Hn[$],1);$===0?Si=Fe:Si=t.createBinaryExpression(Si,28,Fe)}nn=t.createBinaryExpression(Si,28,nn)}return t.createReturnStatement(nn)}}return Mr(oe,re,e)}function De(oe){let yt=t.createVariableDeclaration(t.getLocalName(oe,!0),void 0,void 0,ct(oe));zn(yt,oe);let Gt=[],Xt=t.createVariableStatement(void 0,t.createVariableDeclarationList([yt]));if(zn(Xt,oe),Et(Xt,oe),T_(Xt),Gt.push(Xt),li(oe,32)){let Fr=li(oe,2048)?t.createExportDefault(t.getLocalName(oe)):t.createExternalModuleExport(t.getLocalName(oe));zn(Fr,Xt),Gt.push(Fr)}return wh(Gt)}function Be(oe){return ct(oe)}function ct(oe){oe.name&&If();let yt=nE(oe),Gt=t.createFunctionExpression(void 0,void 0,void 0,void 0,yt?[t.createParameterDeclaration(void 0,void 0,Cl())]:[],void 0,qe(oe,yt));Tn(Gt,Ga(oe)&131072|1048576);let Xt=t.createPartiallyEmittedExpression(Gt);pN(Xt,oe.end),Tn(Xt,3072);let Fr=t.createPartiallyEmittedExpression(Xt);pN(Fr,Ja(D,oe.pos)),Tn(Fr,3072);let nn=t.createParenthesizedExpression(t.createCallExpression(Fr,void 0,yt?[M.checkDefined(ot(yt.expression,re,Ct))]:[]));return vO(nn,3,"* @class "),nn}function qe(oe,yt){let Gt=[],Xt=t.getInternalName(oe),Fr=RH(Xt)?t.getGeneratedNameForNode(Xt):Xt;i(),et(Gt,oe,yt),Ie(Gt,oe,Fr,yt),tt(Gt,oe);let nn=iG(Ja(D,oe.members.end),20),Hn=t.createPartiallyEmittedExpression(Fr);pN(Hn,nn.end),Tn(Hn,3072);let Si=t.createReturnStatement(Hn);fO(Si,nn.pos),Tn(Si,3840),Gt.push(Si),Ay(Gt,o());let $=t.createBlock(Et(t.createNodeArray(Gt),oe.members),!0);return Tn($,3072),$}function et(oe,yt,Gt){Gt&&oe.push(Et(t.createExpressionStatement(n().createExtendsHelper(t.getInternalName(yt))),Gt))}function Ie(oe,yt,Gt,Xt){let Fr=F;F=void 0;let nn=q(32662,73),Hn=Ny(yt),Si=ad(Hn,Xt!==void 0),$=t.createFunctionDeclaration(void 0,void 0,Gt,void 0,_t(Hn,Si),void 0,rr(Hn,yt,Xt,Si));Et($,Hn||yt),Xt&&Tn($,16),oe.push($),ee(nn,229376,0),F=Fr}function _t(oe,yt){return Kc(oe&&!yt?oe.parameters:void 0,re,e)||[]}function mt(oe,yt){let Gt=[];s(),t.mergeLexicalEnvironment(Gt,o()),yt&&Gt.push(t.createReturnStatement(la()));let Xt=t.createNodeArray(Gt);Et(Xt,oe.members);let Fr=t.createBlock(Xt,!0);return Et(Fr,oe),Tn(Fr,3072),Fr}function Xe(oe){return _l(oe)&&wi(oe.declarationList.declarations,yt=>He(yt.name)&&!yt.initializer)}function ht(oe){if(Kx(oe))return!0;if(!(oe.transformFlags&134217728))return!1;switch(oe.kind){case 219:case 218:case 262:case 176:case 175:return!1;case 177:case 178:case 174:case 172:{let yt=oe;return za(yt.name)?!!Js(yt.name,ht):!1}}return!!Js(oe,ht)}function rr(oe,yt,Gt,Xt){let Fr=!!Gt&&Ml(Gt.expression).kind!==106;if(!oe)return mt(yt,Fr);let nn=[],Hn=[];s();let Si=t.copyStandardPrologue(oe.body.statements,nn,0);(Xt||ht(oe.body))&&(w|=8192),wn(Hn,Kr(oe.body.statements,re,Vi,Si));let $=Fr||w&8192;to(nn,oe),vt(nn,oe,Xt),Me(nn,oe),$?nt(nn,oe,Ui()):Ce(nn,oe),t.mergeLexicalEnvironment(nn,o()),$&&!Ci(oe.body)&&Hn.push(t.createReturnStatement(te()));let Fe=t.createBlock(Et(t.createNodeArray([...nn,...Hn]),oe.body.statements),!0);return Et(Fe,oe.body),vi(Fe,oe.body,Xt)}function vr(oe){return xc(oe)&&Nn(oe)==="_this"}function xr(oe){return xc(oe)&&Nn(oe)==="_super"}function jr(oe){return _l(oe)&&oe.declarationList.declarations.length===1&&ur(oe.declarationList.declarations[0])}function ur(oe){return Ei(oe)&&vr(oe.name)&&!!oe.initializer}function or(oe){return Su(oe,!0)&&vr(oe.left)}function Zr(oe){return ea(oe)&&Wn(oe.expression)&&xr(oe.expression.expression)&&He(oe.expression.name)&&(Nn(oe.expression.name)==="call"||Nn(oe.expression.name)==="apply")&&oe.arguments.length>=1&&oe.arguments[0].kind===110}function Oi(oe){return Pn(oe)&&oe.operatorToken.kind===57&&oe.right.kind===110&&Zr(oe.left)}function Sr(oe){return Pn(oe)&&oe.operatorToken.kind===56&&Pn(oe.left)&&oe.left.operatorToken.kind===38&&xr(oe.left.left)&&oe.left.right.kind===106&&Zr(oe.right)&&Nn(oe.right.expression.name)==="apply"}function Pi(oe){return Pn(oe)&&oe.operatorToken.kind===57&&oe.right.kind===110&&Sr(oe.left)}function Cs(oe){return or(oe)&&Oi(oe.right)}function ss(oe){return or(oe)&&Pi(oe.right)}function Ii(oe){return Zr(oe)||Oi(oe)||Cs(oe)||Sr(oe)||Pi(oe)||ss(oe)}function $r(oe){for(let yt=0;yt<oe.statements.length-1;yt++){let Gt=oe.statements[yt];if(!jr(Gt))continue;let Xt=Gt.declarationList.declarations[0];if(Xt.initializer.kind!==110)continue;let Fr=yt,nn=yt+1;for(;nn<oe.statements.length;){let Mi=oe.statements[nn];if(Du(Mi)&&Ii(Ml(Mi.expression)))break;if(Xe(Mi)){nn++;continue}return oe}let Hn=oe.statements[nn],Si=Hn.expression;or(Si)&&(Si=Si.right);let $=t.updateVariableDeclaration(Xt,Xt.name,void 0,void 0,Si),Fe=t.updateVariableDeclarationList(Gt.declarationList,[$]),jt=t.createVariableStatement(Gt.modifiers,Fe);zn(jt,Hn),Et(jt,Hn);let Xr=t.createNodeArray([...oe.statements.slice(0,Fr),...oe.statements.slice(Fr+1,nn),jt,...oe.statements.slice(nn+1)]);return Et(Xr,oe.statements),t.updateBlock(oe,Xr)}return oe}function Xs(oe,yt){for(let Xt of yt.statements)if(Xt.transformFlags&134217728&&!NB(Xt))return oe;let Gt=!(yt.transformFlags&16384)&&!(w&65536)&&!(w&131072);for(let Xt=oe.statements.length-1;Xt>0;Xt--){let Fr=oe.statements[Xt];if(nm(Fr)&&Fr.expression&&vr(Fr.expression)){let nn=oe.statements[Xt-1],Hn;if(Du(nn)&&Cs(Ml(nn.expression)))Hn=nn.expression;else if(Gt&&jr(nn)){let Fe=nn.declarationList.declarations[0];Ii(Ml(Fe.initializer))&&(Hn=t.createAssignment(te(),Fe.initializer))}if(!Hn)break;let Si=t.createReturnStatement(Hn);zn(Si,nn),Et(Si,nn);let $=t.createNodeArray([...oe.statements.slice(0,Xt-1),Si,...oe.statements.slice(Xt+1)]);return Et($,oe.statements),t.updateBlock(oe,$)}}return oe}function $e(oe){if(jr(oe)){if(oe.declarationList.declarations[0].initializer.kind===110)return}else if(or(oe))return t.createPartiallyEmittedExpression(oe.right,oe);switch(oe.kind){case 219:case 218:case 262:case 176:case 175:return oe;case 177:case 178:case 174:case 172:{let yt=oe;return za(yt.name)?t.replacePropertyName(yt,Mr(yt.name,$e,void 0)):oe}}return Mr(oe,$e,void 0)}function Yt(oe,yt){if(yt.transformFlags&16384||w&65536||w&131072)return oe;for(let Gt of yt.statements)if(Gt.transformFlags&134217728&&!NB(Gt))return oe;return t.updateBlock(oe,Kr(oe.statements,$e,Vi))}function Vr(oe){if(Zr(oe)&&oe.arguments.length===2&&He(oe.arguments[1])&&Nn(oe.arguments[1])==="arguments")return t.createLogicalAnd(t.createStrictInequality(Cl(),t.createNull()),oe);switch(oe.kind){case 219:case 218:case 262:case 176:case 175:return oe;case 177:case 178:case 174:case 172:{let yt=oe;return za(yt.name)?t.replacePropertyName(yt,Mr(yt.name,Vr,void 0)):oe}}return Mr(oe,Vr,void 0)}function An(oe){return t.updateBlock(oe,Kr(oe.statements,Vr,Vi))}function vi(oe,yt,Gt){let Xt=oe;return oe=$r(oe),oe=Xs(oe,yt),oe!==Xt&&(oe=Yt(oe,yt)),Gt&&(oe=An(oe)),oe}function Ci(oe){if(oe.kind===253)return!0;if(oe.kind===245){let yt=oe;if(yt.elseStatement)return Ci(yt.thenStatement)&&Ci(yt.elseStatement)}else if(oe.kind===241){let yt=vc(oe.statements);if(yt&&Ci(yt))return!0}return!1}function Ui(){return Tn(t.createThis(),8)}function la(){return t.createLogicalOr(t.createLogicalAnd(t.createStrictInequality(Cl(),t.createNull()),t.createFunctionApplyCall(Cl(),Ui(),t.createIdentifier("arguments"))),Ui())}function Gs(oe){if(!oe.dotDotDotToken)return Hs(oe.name)?zn(Et(t.createParameterDeclaration(void 0,void 0,t.getGeneratedNameForNode(oe),void 0,void 0,void 0),oe),oe):oe.initializer?zn(Et(t.createParameterDeclaration(void 0,void 0,oe.name,void 0,void 0,void 0),oe),oe):oe}function yr(oe){return oe.initializer!==void 0||Hs(oe.name)}function to(oe,yt){if(!Pt(yt.parameters,yr))return!1;let Gt=!1;for(let Xt of yt.parameters){let{name:Fr,initializer:nn,dotDotDotToken:Hn}=Xt;Hn||(Hs(Fr)?Gt=lt(oe,Xt,Fr,nn)||Gt:nn&&(St(oe,Xt,Fr,nn),Gt=!0))}return Gt}function lt(oe,yt,Gt,Xt){return Gt.elements.length>0?(Gx(oe,Tn(t.createVariableStatement(void 0,t.createVariableDeclarationList(CE(yt,re,e,0,t.getGeneratedNameForNode(yt)))),2097152)),!0):Xt?(Gx(oe,Tn(t.createExpressionStatement(t.createAssignment(t.getGeneratedNameForNode(yt),M.checkDefined(ot(Xt,re,Ct)))),2097152)),!0):!1}function St(oe,yt,Gt,Xt){Xt=M.checkDefined(ot(Xt,re,Ct));let Fr=t.createIfStatement(t.createTypeCheck(t.cloneNode(Gt),"undefined"),Tn(Et(t.createBlock([t.createExpressionStatement(Tn(Et(t.createAssignment(Tn(lo(Et(t.cloneNode(Gt),Gt),Gt.parent),96),Tn(Xt,96|Ga(Xt)|3072)),yt),3072))]),yt),3905));T_(Fr),Et(Fr,yt),Tn(Fr,2101056),Gx(oe,Fr)}function fe(oe,yt){return!!(oe&&oe.dotDotDotToken&&!yt)}function vt(oe,yt,Gt){let Xt=[],Fr=vc(yt.parameters);if(!fe(Fr,Gt))return!1;let nn=Fr.name.kind===80?lo(Et(t.cloneNode(Fr.name),Fr.name),Fr.name.parent):t.createTempVariable(void 0);Tn(nn,96);let Hn=Fr.name.kind===80?t.cloneNode(Fr.name):nn,Si=yt.parameters.length-1,$=t.createLoopVariable();Xt.push(Tn(Et(t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(nn,void 0,void 0,t.createArrayLiteralExpression([]))])),Fr),2097152));let Fe=t.createForStatement(Et(t.createVariableDeclarationList([t.createVariableDeclaration($,void 0,void 0,t.createNumericLiteral(Si))]),Fr),Et(t.createLessThan($,t.createPropertyAccessExpression(t.createIdentifier("arguments"),"length")),Fr),Et(t.createPostfixIncrement($),Fr),t.createBlock([T_(Et(t.createExpressionStatement(t.createAssignment(t.createElementAccessExpression(Hn,Si===0?$:t.createSubtract($,t.createNumericLiteral(Si))),t.createElementAccessExpression(t.createIdentifier("arguments"),$))),Fr))]));return Tn(Fe,2097152),T_(Fe),Xt.push(Fe),Fr.name.kind!==80&&Xt.push(Tn(Et(t.createVariableStatement(void 0,t.createVariableDeclarationList(CE(Fr,re,e,0,Hn))),Fr),2097152)),Z$(oe,Xt),!0}function Ce(oe,yt){return w&131072&&yt.kind!==219?(nt(oe,yt,t.createThis()),!0):!1}function nt(oe,yt,Gt){wd();let Xt=t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(te(),void 0,void 0,Gt)]));Tn(Xt,2100224),qa(Xt,yt),Gx(oe,Xt)}function Me(oe,yt){if(w&32768){let Gt;switch(yt.kind){case 219:return oe;case 174:case 177:case 178:Gt=t.createVoidZero();break;case 176:Gt=t.createPropertyAccessExpression(Tn(t.createThis(),8),"constructor");break;case 262:case 218:Gt=t.createConditionalExpression(t.createLogicalAnd(Tn(t.createThis(),8),t.createBinaryExpression(Tn(t.createThis(),8),104,t.getLocalName(yt))),void 0,t.createPropertyAccessExpression(Tn(t.createThis(),8),"constructor"),void 0,t.createVoidZero());break;default:return M.failBadSyntaxKind(yt)}let Xt=t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(t.createUniqueName("_newTarget",48),void 0,void 0,Gt)]));Tn(Xt,2100224),Gx(oe,Xt)}return oe}function tt(oe,yt){for(let Gt of yt.members)switch(Gt.kind){case 240:oe.push(ft(Gt));break;case 174:oe.push(tr(nh(yt,Gt),Gt,yt));break;case 177:case 178:let Xt=W1(yt.members,Gt);Gt===Xt.firstAccessor&&oe.push(Oe(nh(yt,Gt),Xt,yt));break;case 176:case 175:break;default:M.failBadSyntaxKind(Gt,x&&x.fileName);break}}function ft(oe){return Et(t.createEmptyStatement(),oe)}function tr(oe,yt,Gt){let Xt=Wg(yt),Fr=Ov(yt),nn=nr(yt,yt,void 0,Gt),Hn=ot(yt.name,re,Ol);M.assert(Hn);let Si;if(!Zi(Hn)&&$R(e.getCompilerOptions())){let Fe=za(Hn)?Hn.expression:He(Hn)?t.createStringLiteral(Qi(Hn.escapedText)):Hn;Si=t.createObjectDefinePropertyCall(oe,Fe,t.createPropertyDescriptor({value:nn,enumerable:!1,writable:!0,configurable:!0}))}else{let Fe=d2(t,oe,Hn,yt.name);Si=t.createAssignment(Fe,nn)}Tn(nn,3072),qa(nn,Fr);let $=Et(t.createExpressionStatement(Si),yt);return zn($,yt),Zl($,Xt),Tn($,96),$}function Oe(oe,yt,Gt){let Xt=t.createExpressionStatement(At(oe,yt,Gt,!1));return Tn(Xt,3072),qa(Xt,Ov(yt.firstAccessor)),Xt}function At(oe,{firstAccessor:yt,getAccessor:Gt,setAccessor:Xt},Fr,nn){let Hn=lo(Et(t.cloneNode(oe),oe),oe.parent);Tn(Hn,3136),qa(Hn,yt.name);let Si=ot(yt.name,re,Ol);if(M.assert(Si),Zi(Si))return M.failBadSyntaxKind(Si,"Encountered unhandled private identifier while transforming ES2015.");let $=hY(t,Si);Tn($,3104),qa($,yt.name);let Fe=[];if(Gt){let Xr=nr(Gt,void 0,void 0,Fr);qa(Xr,Ov(Gt)),Tn(Xr,1024);let Mi=t.createPropertyAssignment("get",Xr);Zl(Mi,Wg(Gt)),Fe.push(Mi)}if(Xt){let Xr=nr(Xt,void 0,void 0,Fr);qa(Xr,Ov(Xt)),Tn(Xr,1024);let Mi=t.createPropertyAssignment("set",Xr);Zl(Mi,Wg(Xt)),Fe.push(Mi)}Fe.push(t.createPropertyAssignment("enumerable",Gt||Xt?t.createFalse():t.createTrue()),t.createPropertyAssignment("configurable",t.createTrue()));let jt=t.createCallExpression(t.createPropertyAccessExpression(t.createIdentifier("Object"),"defineProperty"),void 0,[Hn,$,t.createObjectLiteralExpression(Fe,!0)]);return nn&&T_(jt),jt}function Nt(oe){oe.transformFlags&16384&&!(w&16384)&&(w|=131072);let yt=F;F=void 0;let Gt=q(15232,66),Xt=t.createFunctionExpression(void 0,void 0,void 0,void 0,Kc(oe.parameters,re,e),void 0,Z(oe));return Et(Xt,oe),zn(Xt,oe),Tn(Xt,16),ee(Gt,0,0),F=yt,Xt}function Ut(oe){let yt=Ga(oe)&524288?q(32662,69):q(32670,65),Gt=F;F=void 0;let Xt=Kc(oe.parameters,re,e),Fr=Z(oe),nn=w&32768?t.getLocalName(oe):oe.name;return ee(yt,229376,0),F=Gt,t.updateFunctionExpression(oe,void 0,oe.asteriskToken,nn,void 0,Xt,void 0,Fr)}function Rt(oe){let yt=F;F=void 0;let Gt=q(32670,65),Xt=Kc(oe.parameters,re,e),Fr=Z(oe),nn=w&32768?t.getLocalName(oe):oe.name;return ee(Gt,229376,0),F=yt,t.updateFunctionDeclaration(oe,Kr(oe.modifiers,re,Pa),oe.asteriskToken,nn,void 0,Xt,void 0,Fr)}function nr(oe,yt,Gt,Xt){let Fr=F;F=void 0;let nn=Xt&&gi(Xt)&&!oa(oe)?q(32670,73):q(32670,65),Hn=Kc(oe.parameters,re,e),Si=Z(oe);return w&32768&&!Gt&&(oe.kind===262||oe.kind===218)&&(Gt=t.getGeneratedNameForNode(oe)),ee(nn,229376,0),F=Fr,zn(Et(t.createFunctionExpression(void 0,oe.asteriskToken,Gt,void 0,Hn,void 0,Si),yt),oe)}function Z(oe){let yt=!1,Gt=!1,Xt,Fr,nn=[],Hn=[],Si=oe.body,$;if(s(),Vs(Si)&&($=t.copyStandardPrologue(Si.statements,nn,0,!1),$=t.copyCustomPrologue(Si.statements,Hn,$,re,Z5),$=t.copyCustomPrologue(Si.statements,Hn,$,re,e9)),yt=to(Hn,oe)||yt,yt=vt(Hn,oe,!1)||yt,Vs(Si))$=t.copyCustomPrologue(Si.statements,Hn,$,re),Xt=Si.statements,wn(Hn,Kr(Si.statements,re,Vi,$)),!yt&&Si.multiLine&&(yt=!0);else{M.assert(oe.kind===219),Xt=F9(Si,-1);let jt=oe.equalsGreaterThanToken;!Ko(jt)&&!Ko(Si)&&(JR(jt,Si,x)?Gt=!0:yt=!0);let Xr=ot(Si,re,Ct),Mi=t.createReturnStatement(Xr);Et(Mi,Si),Kpe(Mi,Si),Tn(Mi,2880),Hn.push(Mi),Fr=Si}if(t.mergeLexicalEnvironment(nn,o()),Me(nn,oe),Ce(nn,oe),Pt(nn)&&(yt=!0),Hn.unshift(...nn),Vs(Si)&&Vp(Hn,Si.statements))return Si;let Fe=t.createBlock(Et(t.createNodeArray(Hn),Xt),yt);return Et(Fe,oe.body),!yt&&Gt&&Tn(Fe,1),Fr&&Ype(Fe,20,Fr),zn(Fe,oe.body),Fe}function Ge(oe,yt){if(yt)return Mr(oe,re,e);let Gt=w&256?q(7104,512):q(6976,128),Xt=Mr(oe,re,e);return ee(Gt,0,0),Xt}function bt(oe){return Mr(oe,ue,e)}function Q(oe,yt){return Mr(oe,yt?ue:re,e)}function Ke(oe,yt){return Dv(oe)?y2(oe,re,e,0,!yt):oe.operatorToken.kind===28?t.updateBinaryExpression(oe,M.checkDefined(ot(oe.left,ue,Ct)),oe.operatorToken,M.checkDefined(ot(oe.right,yt?ue:re,Ct))):Mr(oe,re,e)}function z(oe,yt){if(yt)return Mr(oe,ue,e);let Gt;for(let Fr=0;Fr<oe.elements.length;Fr++){let nn=oe.elements[Fr],Hn=ot(nn,Fr<oe.elements.length-1?ue:re,Ct);(Gt||Hn!==nn)&&(Gt||(Gt=oe.elements.slice(0,Fr)),M.assert(Hn),Gt.push(Hn))}let Xt=Gt?Et(t.createNodeArray(Gt),oe.elements):oe.elements;return t.updateCommaListExpression(oe,Xt)}function Ue(oe){return oe.declarationList.declarations.length===1&&!!oe.declarationList.declarations[0].initializer&&!!(Pm(oe.declarationList.declarations[0].initializer)&1)}function Te(oe){let yt=q(0,li(oe,32)?32:0),Gt;if(F&&!(oe.declarationList.flags&7)&&!Ue(oe)){let Xt;for(let Fr of oe.declarationList.declarations)if(Eu(F,Fr),Fr.initializer){let nn;Hs(Fr.name)?nn=y2(Fr,re,e,0):(nn=t.createBinaryExpression(Fr.name,64,M.checkDefined(ot(Fr.initializer,re,Ct))),Et(nn,Fr)),Xt=Bt(Xt,nn)}Xt?Gt=Et(t.createExpressionStatement(t.inlineExpressions(Xt)),oe):Gt=void 0}else Gt=Mr(oe,re,e);return ee(yt,0,0),Gt}function Re(oe){if(oe.flags&7||oe.transformFlags&524288){oe.flags&7&&If();let yt=Kr(oe.declarations,oe.flags&1?Ht:dr,Ei),Gt=t.createVariableDeclarationList(yt);return zn(Gt,oe),Et(Gt,oe),Zl(Gt,oe),oe.transformFlags&524288&&(Hs(oe.declarations[0].name)||Hs(Va(oe.declarations).name))&&qa(Gt,It(yt)),Gt}return Mr(oe,re,e)}function It(oe){let yt=-1,Gt=-1;for(let Xt of oe)yt=yt===-1?Xt.pos:Xt.pos===-1?yt:Math.min(yt,Xt.pos),Gt=Math.max(Gt,Xt.end);return Td(yt,Gt)}function $t(oe){let yt=d.hasNodeCheckFlag(oe,16384),Gt=d.hasNodeCheckFlag(oe,32768);return!((w&64)!==0||yt&&Gt&&(w&512)!==0)&&(w&4096)===0&&(!d.isDeclarationWithCollidingName(oe)||Gt&&!yt&&(w&6144)===0)}function Ht(oe){let yt=oe.name;return Hs(yt)?dr(oe):!oe.initializer&&$t(oe)?t.updateVariableDeclaration(oe,oe.name,void 0,void 0,t.createVoidZero()):Mr(oe,re,e)}function dr(oe){let yt=q(32,0),Gt;return Hs(oe.name)?Gt=CE(oe,re,e,0,void 0,(yt&32)!==0):Gt=Mr(oe,re,e),ee(yt,0,0),Gt}function qr(oe){F.labels.set(Nn(oe.label),!0)}function Hr(oe){F.labels.set(Nn(oe.label),!1)}function dn(oe){F&&!F.labels&&(F.labels=new Map);let yt=hH(oe,F&&qr);return V1(yt,!1)?Ar(yt,oe):t.restoreEnclosingLabel(M.checkDefined(ot(yt,re,Vi,t.liftToBlock)),oe,F&&Hr)}function Ar(oe,yt){switch(oe.kind){case 246:case 247:return Ki(oe,yt);case 248:return ls(oe,yt);case 249:return pi(oe,yt);case 250:return Er(oe,yt)}}function In(oe,yt,Gt,Xt,Fr){let nn=q(oe,yt),Hn=kc(Gt,Xt,nn,Fr);return ee(nn,0,0),Hn}function Ki(oe,yt){return In(0,1280,oe,yt)}function ls(oe,yt){return In(5056,3328,oe,yt)}function Yn(oe){return t.updateForStatement(oe,ot(oe.initializer,ue,Sd),ot(oe.condition,re,Ct),ot(oe.incrementor,ue,Ct),M.checkDefined(ot(oe.statement,re,Vi,t.liftToBlock)))}function pi(oe,yt){return In(3008,5376,oe,yt)}function Er(oe,yt){return In(3008,5376,oe,yt,m.downlevelIteration?uo:qs)}function tn(oe,yt,Gt){let Xt=[],Fr=oe.initializer;if(Ru(Fr)){oe.initializer.flags&7&&If();let nn=xo(Fr.declarations);if(nn&&Hs(nn.name)){let Hn=CE(nn,re,e,0,yt),Si=Et(t.createVariableDeclarationList(Hn),oe.initializer);zn(Si,oe.initializer),qa(Si,Td(Hn[0].pos,Va(Hn).end)),Xt.push(t.createVariableStatement(void 0,Si))}else Xt.push(Et(t.createVariableStatement(void 0,zn(Et(t.createVariableDeclarationList([t.createVariableDeclaration(nn?nn.name:t.createTempVariable(void 0),void 0,void 0,yt)]),mb(Fr,-1)),Fr)),F9(Fr,-1)))}else{let nn=t.createAssignment(Fr,yt);Dv(nn)?Xt.push(t.createExpressionStatement(Ke(nn,!0))):(pN(nn,Fr.end),Xt.push(Et(t.createExpressionStatement(M.checkDefined(ot(nn,re,Ct))),F9(Fr,-1))))}if(Gt)return er(wn(Xt,Gt));{let nn=ot(oe.statement,re,Vi,t.liftToBlock);return M.assert(nn),Vs(nn)?t.updateBlock(nn,Et(t.createNodeArray(ps(Xt,nn.statements)),nn.statements)):(Xt.push(nn),er(Xt))}}function er(oe){return Tn(t.createBlock(t.createNodeArray(oe),!0),864)}function qs(oe,yt,Gt){let Xt=ot(oe.expression,re,Ct);M.assert(Xt);let Fr=t.createLoopVariable(),nn=He(Xt)?t.getGeneratedNameForNode(Xt):t.createTempVariable(void 0);Tn(Xt,96|Ga(Xt));let Hn=Et(t.createForStatement(Tn(Et(t.createVariableDeclarationList([Et(t.createVariableDeclaration(Fr,void 0,void 0,t.createNumericLiteral(0)),mb(oe.expression,-1)),Et(t.createVariableDeclaration(nn,void 0,void 0,Xt),oe.expression)]),oe.expression),4194304),Et(t.createLessThan(Fr,t.createPropertyAccessExpression(nn,"length")),oe.expression),Et(t.createPostfixIncrement(Fr),oe.expression),tn(oe,t.createElementAccessExpression(nn,Fr),Gt)),oe);return Tn(Hn,512),Et(Hn,oe),t.restoreEnclosingLabel(Hn,yt,F&&Hr)}function uo(oe,yt,Gt,Xt){let Fr=ot(oe.expression,re,Ct);M.assert(Fr);let nn=He(Fr)?t.getGeneratedNameForNode(Fr):t.createTempVariable(void 0),Hn=He(Fr)?t.getGeneratedNameForNode(nn):t.createTempVariable(void 0),Si=t.createUniqueName("e"),$=t.getGeneratedNameForNode(Si),Fe=t.createTempVariable(void 0),jt=Et(n().createValuesHelper(Fr),oe.expression),Xr=t.createCallExpression(t.createPropertyAccessExpression(nn,"next"),void 0,[]);u(Si),u(Fe);let Mi=Xt&1024?t.inlineExpressions([t.createAssignment(Si,t.createVoidZero()),jt]):jt,Us=Tn(Et(t.createForStatement(Tn(Et(t.createVariableDeclarationList([Et(t.createVariableDeclaration(nn,void 0,void 0,Mi),oe.expression),t.createVariableDeclaration(Hn,void 0,void 0,Xr)]),oe.expression),4194304),t.createLogicalNot(t.createPropertyAccessExpression(Hn,"done")),t.createAssignment(Hn,Xr),tn(oe,t.createPropertyAccessExpression(Hn,"value"),Gt)),oe),512);return t.createTryStatement(t.createBlock([t.restoreEnclosingLabel(Us,yt,F&&Hr)]),t.createCatchClause(t.createVariableDeclaration($),Tn(t.createBlock([t.createExpressionStatement(t.createAssignment(Si,t.createObjectLiteralExpression([t.createPropertyAssignment("error",$)])))]),1)),t.createBlock([t.createTryStatement(t.createBlock([Tn(t.createIfStatement(t.createLogicalAnd(t.createLogicalAnd(Hn,t.createLogicalNot(t.createPropertyAccessExpression(Hn,"done"))),t.createAssignment(Fe,t.createPropertyAccessExpression(nn,"return"))),t.createExpressionStatement(t.createFunctionCallCall(Fe,nn,[]))),1)]),void 0,Tn(t.createBlock([Tn(t.createIfStatement(Si,t.createThrowStatement(t.createPropertyAccessExpression(Si,"error"))),1)]),1))]))}function Mo(oe){let yt=oe.properties,Gt=-1,Xt=!1;for(let Si=0;Si<yt.length;Si++){let $=yt[Si];if($.transformFlags&1048576&&w&4||(Xt=M.checkDefined($.name).kind===167)){Gt=Si;break}}if(Gt<0)return Mr(oe,re,e);let Fr=t.createTempVariable(u),nn=[],Hn=t.createAssignment(Fr,Tn(t.createObjectLiteralExpression(Kr(yt,re,p0,0,Gt),oe.multiLine),Xt?131072:0));return oe.multiLine&&T_(Hn),nn.push(Hn),Tr(nn,oe,Fr,Gt),nn.push(oe.multiLine?T_(lo(Et(t.cloneNode(Fr),Fr),Fr.parent)):Fr),t.inlineExpressions(nn)}function Do(oe){return d.hasNodeCheckFlag(oe,8192)}function ms(oe){return Sb(oe)&&!!oe.initializer&&Do(oe.initializer)}function sa(oe){return Sb(oe)&&!!oe.condition&&Do(oe.condition)}function Sc(oe){return Sb(oe)&&!!oe.incrementor&&Do(oe.incrementor)}function ts(oe){return zi(oe)||ms(oe)}function zi(oe){return d.hasNodeCheckFlag(oe,4096)}function Eu(oe,yt){oe.hoistedLocalVariables||(oe.hoistedLocalVariables=[]),Gt(yt.name);function Gt(Xt){if(Xt.kind===80)oe.hoistedLocalVariables.push(Xt);else for(let Fr of Xt.elements)pu(Fr)||Gt(Fr.name)}}function kc(oe,yt,Gt,Xt){if(!ts(oe)){let jt;F&&(jt=F.allowedNonLabeledJumps,F.allowedNonLabeledJumps=6);let Xr=Xt?Xt(oe,yt,void 0,Gt):t.restoreEnclosingLabel(Sb(oe)?Yn(oe):Mr(oe,re,e),yt,F&&Hr);return F&&(F.allowedNonLabeledJumps=jt),Xr}let Fr=po(oe),nn=[],Hn=F;F=Fr;let Si=ms(oe)?z_(oe,Fr):void 0,$=zi(oe)?W_(oe,Fr,Hn):void 0;F=Hn,Si&&nn.push(Si.functionDeclaration),$&&nn.push($.functionDeclaration),_r(nn,Fr,Hn),Si&&nn.push(tl(Si.functionName,Si.containsYield));let Fe;if($)if(Xt)Fe=Xt(oe,yt,$.part,Gt);else{let jt=P_(oe,Si,t.createBlock($.part,!0));Fe=t.restoreEnclosingLabel(jt,yt,F&&Hr)}else{let jt=P_(oe,Si,M.checkDefined(ot(oe.statement,re,Vi,t.liftToBlock)));Fe=t.restoreEnclosingLabel(jt,yt,F&&Hr)}return nn.push(Fe),nn}function P_(oe,yt,Gt){switch(oe.kind){case 248:return el(oe,yt,Gt);case 249:return Fa(oe,Gt);case 250:return Xu(oe,Gt);case 246:return bc(oe,Gt);case 247:return Lo(oe,Gt);default:return M.failBadSyntaxKind(oe,"IterationStatement expected")}}function el(oe,yt,Gt){let Xt=oe.condition&&Do(oe.condition),Fr=Xt||oe.incrementor&&Do(oe.incrementor);return t.updateForStatement(oe,ot(yt?yt.part:oe.initializer,ue,Sd),ot(Xt?void 0:oe.condition,re,Ct),ot(Fr?void 0:oe.incrementor,ue,Ct),Gt)}function Xu(oe,yt){return t.updateForOfStatement(oe,void 0,M.checkDefined(ot(oe.initializer,re,Sd)),M.checkDefined(ot(oe.expression,re,Ct)),yt)}function Fa(oe,yt){return t.updateForInStatement(oe,M.checkDefined(ot(oe.initializer,re,Sd)),M.checkDefined(ot(oe.expression,re,Ct)),yt)}function bc(oe,yt){return t.updateDoStatement(oe,yt,M.checkDefined(ot(oe.expression,re,Ct)))}function Lo(oe,yt){return t.updateWhileStatement(oe,M.checkDefined(ot(oe.expression,re,Ct)),yt)}function po(oe){let yt;switch(oe.kind){case 248:case 249:case 250:let nn=oe.initializer;nn&&nn.kind===261&&(yt=nn);break}let Gt=[],Xt=[];if(yt&&f0(yt)&7){let nn=ms(oe)||sa(oe)||Sc(oe);for(let Hn of yt.declarations)Ot(oe,Hn,Gt,Xt,nn)}let Fr={loopParameters:Gt,loopOutParameters:Xt};return F&&(F.argumentsName&&(Fr.argumentsName=F.argumentsName),F.thisName&&(Fr.thisName=F.thisName),F.hoistedLocalVariables&&(Fr.hoistedLocalVariables=F.hoistedLocalVariables)),Fr}function _r(oe,yt,Gt){let Xt;if(yt.argumentsName&&(Gt?Gt.argumentsName=yt.argumentsName:(Xt||(Xt=[])).push(t.createVariableDeclaration(yt.argumentsName,void 0,void 0,t.createIdentifier("arguments")))),yt.thisName&&(Gt?Gt.thisName=yt.thisName:(Xt||(Xt=[])).push(t.createVariableDeclaration(yt.thisName,void 0,void 0,t.createIdentifier("this")))),yt.hoistedLocalVariables)if(Gt)Gt.hoistedLocalVariables=yt.hoistedLocalVariables;else{Xt||(Xt=[]);for(let Fr of yt.hoistedLocalVariables)Xt.push(t.createVariableDeclaration(Fr))}if(yt.loopOutParameters.length){Xt||(Xt=[]);for(let Fr of yt.loopOutParameters)Xt.push(t.createVariableDeclaration(Fr.outParamName))}yt.conditionVariable&&(Xt||(Xt=[]),Xt.push(t.createVariableDeclaration(yt.conditionVariable,void 0,void 0,t.createFalse()))),Xt&&oe.push(t.createVariableStatement(void 0,t.createVariableDeclarationList(Xt)))}function Jc(oe){return t.createVariableDeclaration(oe.originalName,void 0,void 0,oe.outParamName)}function z_(oe,yt){let Gt=t.createUniqueName("_loop_init"),Xt=(oe.initializer.transformFlags&1048576)!==0,Fr=0;yt.containsLexicalThis&&(Fr|=16),Xt&&w&4&&(Fr|=524288);let nn=[];nn.push(t.createVariableStatement(void 0,oe.initializer)),mc(yt.loopOutParameters,2,1,nn);let Hn=t.createVariableStatement(void 0,Tn(t.createVariableDeclarationList([t.createVariableDeclaration(Gt,void 0,void 0,Tn(t.createFunctionExpression(void 0,Xt?t.createToken(42):void 0,void 0,void 0,void 0,void 0,M.checkDefined(ot(t.createBlock(nn,!0),re,Vs))),Fr))]),4194304)),Si=t.createVariableDeclarationList(Cr(yt.loopOutParameters,Jc));return{functionName:Gt,containsYield:Xt,functionDeclaration:Hn,part:Si}}function W_(oe,yt,Gt){let Xt=t.createUniqueName("_loop");i();let Fr=ot(oe.statement,re,Vi,t.liftToBlock),nn=o(),Hn=[];(sa(oe)||Sc(oe))&&(yt.conditionVariable=t.createUniqueName("inc"),oe.incrementor?Hn.push(t.createIfStatement(yt.conditionVariable,t.createExpressionStatement(M.checkDefined(ot(oe.incrementor,re,Ct))),t.createExpressionStatement(t.createAssignment(yt.conditionVariable,t.createTrue())))):Hn.push(t.createIfStatement(t.createLogicalNot(yt.conditionVariable),t.createExpressionStatement(t.createAssignment(yt.conditionVariable,t.createTrue())))),sa(oe)&&Hn.push(t.createIfStatement(t.createPrefixUnaryExpression(54,M.checkDefined(ot(oe.condition,re,Ct))),M.checkDefined(ot(t.createBreakStatement(),re,Vi))))),M.assert(Fr),Vs(Fr)?wn(Hn,Fr.statements):Hn.push(Fr),mc(yt.loopOutParameters,1,1,Hn),Ay(Hn,nn);let Si=t.createBlock(Hn,!0);Vs(Fr)&&zn(Si,Fr);let $=(oe.statement.transformFlags&1048576)!==0,Fe=1048576;yt.containsLexicalThis&&(Fe|=16),$&&w&4&&(Fe|=524288);let jt=t.createVariableStatement(void 0,Tn(t.createVariableDeclarationList([t.createVariableDeclaration(Xt,void 0,void 0,Tn(t.createFunctionExpression(void 0,$?t.createToken(42):void 0,void 0,void 0,yt.loopParameters,void 0,Si),Fe))]),4194304)),Xr=Se(Xt,yt,Gt,$);return{functionName:Xt,containsYield:$,functionDeclaration:jt,part:Xr}}function qf(oe,yt){let Gt=yt===0?oe.outParamName:oe.originalName,Xt=yt===0?oe.originalName:oe.outParamName;return t.createBinaryExpression(Xt,64,Gt)}function mc(oe,yt,Gt,Xt){for(let Fr of oe)Fr.flags&yt&&Xt.push(t.createExpressionStatement(qf(Fr,Gt)))}function tl(oe,yt){let Gt=t.createCallExpression(oe,void 0,[]),Xt=yt?t.createYieldExpression(t.createToken(42),Tn(Gt,8388608)):Gt;return t.createExpressionStatement(Xt)}function Se(oe,yt,Gt,Xt){let Fr=[],nn=!(yt.nonLocalJumps&-5)&&!yt.labeledNonLocalBreaks&&!yt.labeledNonLocalContinues,Hn=t.createCallExpression(oe,void 0,Cr(yt.loopParameters,$=>$.name)),Si=Xt?t.createYieldExpression(t.createToken(42),Tn(Hn,8388608)):Hn;if(nn)Fr.push(t.createExpressionStatement(Si)),mc(yt.loopOutParameters,1,0,Fr);else{let $=t.createUniqueName("state"),Fe=t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration($,void 0,void 0,Si)]));if(Fr.push(Fe),mc(yt.loopOutParameters,1,0,Fr),yt.nonLocalJumps&8){let jt;Gt?(Gt.nonLocalJumps|=8,jt=t.createReturnStatement($)):jt=t.createReturnStatement(t.createPropertyAccessExpression($,"value")),Fr.push(t.createIfStatement(t.createTypeCheck($,"object"),jt))}if(yt.nonLocalJumps&2&&Fr.push(t.createIfStatement(t.createStrictEquality($,t.createStringLiteral("break")),t.createBreakStatement())),yt.labeledNonLocalBreaks||yt.labeledNonLocalContinues){let jt=[];Ye(yt.labeledNonLocalBreaks,!0,$,Gt,jt),Ye(yt.labeledNonLocalContinues,!1,$,Gt,jt),Fr.push(t.createSwitchStatement($,t.createCaseBlock(jt)))}}return Fr}function ae(oe,yt,Gt,Xt){yt?(oe.labeledNonLocalBreaks||(oe.labeledNonLocalBreaks=new Map),oe.labeledNonLocalBreaks.set(Gt,Xt)):(oe.labeledNonLocalContinues||(oe.labeledNonLocalContinues=new Map),oe.labeledNonLocalContinues.set(Gt,Xt))}function Ye(oe,yt,Gt,Xt,Fr){oe&&oe.forEach((nn,Hn)=>{let Si=[];if(!Xt||Xt.labels&&Xt.labels.get(Hn)){let $=t.createIdentifier(Hn);Si.push(yt?t.createBreakStatement($):t.createContinueStatement($))}else ae(Xt,yt,Hn,nn),Si.push(t.createReturnStatement(Gt));Fr.push(t.createCaseClause(t.createStringLiteral(nn),Si))})}function Ot(oe,yt,Gt,Xt,Fr){let nn=yt.name;if(Hs(nn))for(let Hn of nn.elements)pu(Hn)||Ot(oe,Hn,Gt,Xt,Fr);else{Gt.push(t.createParameterDeclaration(void 0,void 0,nn));let Hn=d.hasNodeCheckFlag(yt,65536);if(Hn||Fr){let Si=t.createUniqueName("out_"+Nn(nn)),$=0;Hn&&($|=1),Sb(oe)&&(oe.initializer&&d.isBindingCapturedByNode(oe.initializer,yt)&&($|=2),(oe.condition&&d.isBindingCapturedByNode(oe.condition,yt)||oe.incrementor&&d.isBindingCapturedByNode(oe.incrementor,yt))&&($|=1)),Xt.push({flags:$,originalName:nn,outParamName:Si})}}}function Tr(oe,yt,Gt,Xt){let Fr=yt.properties,nn=Fr.length;for(let Hn=Xt;Hn<nn;Hn++){let Si=Fr[Hn];switch(Si.kind){case 177:case 178:let $=W1(yt.properties,Si);Si===$.firstAccessor&&oe.push(At(Gt,$,yt,!!yt.multiLine));break;case 174:oe.push(Jn(Si,Gt,yt,yt.multiLine));break;case 303:oe.push(Vn(Si,Gt,yt.multiLine));break;case 304:oe.push(pr(Si,Gt,yt.multiLine));break;default:M.failBadSyntaxKind(yt);break}}}function Vn(oe,yt,Gt){let Xt=t.createAssignment(d2(t,yt,M.checkDefined(ot(oe.name,re,Ol))),M.checkDefined(ot(oe.initializer,re,Ct)));return Et(Xt,oe),Gt&&T_(Xt),Xt}function pr(oe,yt,Gt){let Xt=t.createAssignment(d2(t,yt,M.checkDefined(ot(oe.name,re,Ol))),t.cloneNode(oe.name));return Et(Xt,oe),Gt&&T_(Xt),Xt}function Jn(oe,yt,Gt,Xt){let Fr=t.createAssignment(d2(t,yt,M.checkDefined(ot(oe.name,re,Ol))),nr(oe,oe,void 0,Gt));return Et(Fr,oe),Xt&&T_(Fr),Fr}function Ri(oe){let yt=q(7104,0),Gt;if(M.assert(!!oe.variableDeclaration,"Catch clause variable should always be present when downleveling ES2015."),Hs(oe.variableDeclaration.name)){let Xt=t.createTempVariable(void 0),Fr=t.createVariableDeclaration(Xt);Et(Fr,oe.variableDeclaration);let nn=CE(oe.variableDeclaration,re,e,0,Xt),Hn=t.createVariableDeclarationList(nn);Et(Hn,oe.variableDeclaration);let Si=t.createVariableStatement(void 0,Hn);Gt=t.updateCatchClause(oe,Fr,Ai(oe.block,Si))}else Gt=Mr(oe,re,e);return ee(yt,0,0),Gt}function Ai(oe,yt){let Gt=Kr(oe.statements,re,Vi);return t.updateBlock(oe,[yt,...Gt])}function Na(oe){M.assert(!za(oe.name));let yt=nr(oe,mb(oe,-1),void 0,void 0);return Tn(yt,1024|Ga(yt)),Et(t.createPropertyAssignment(oe.name,yt),oe)}function gc(oe){M.assert(!za(oe.name));let yt=F;F=void 0;let Gt=q(32670,65),Xt,Fr=Kc(oe.parameters,re,e),nn=Z(oe);return oe.kind===177?Xt=t.updateGetAccessorDeclaration(oe,oe.modifiers,oe.name,Fr,oe.type,nn):Xt=t.updateSetAccessorDeclaration(oe,oe.modifiers,oe.name,Fr,nn),ee(Gt,229376,0),F=yt,Xt}function Wl(oe){return Et(t.createPropertyAssignment(oe.name,Pe(t.cloneNode(oe.name))),oe)}function Oc(oe){return Mr(oe,re,e)}function du(oe){return Mr(oe,re,e)}function hc(oe){return Pt(oe.elements,Ad)?nd(oe.elements,!1,!!oe.multiLine,!!oe.elements.hasTrailingComma):Mr(oe,re,e)}function mu(oe){if(Pm(oe)&1)return zf(oe);let yt=Ml(oe.expression);return yt.kind===108||Cf(yt)||Pt(oe.arguments,Ad)?rl(oe,!0):t.updateCallExpression(oe,M.checkDefined(ot(oe.expression,ne,Ct)),void 0,Kr(oe.arguments,re,Ct))}function zf(oe){let yt=aa(aa(Ml(oe.expression),pc).body,Vs),Gt=qc=>_l(qc)&&!!Ma(qc.declarationList.declarations).initializer,Xt=F;F=void 0;let Fr=Kr(yt.statements,ce,Vi);F=Xt;let nn=Zn(Fr,Gt),Hn=Zn(Fr,qc=>!Gt(qc)),$=aa(Ma(nn),_l).declarationList.declarations[0],Fe=Ml($.initializer),jt=ai(Fe,Su);!jt&&Pn(Fe)&&Fe.operatorToken.kind===28&&(jt=ai(Fe.left,Su));let Xr=aa(jt?Ml(jt.right):Fe,ea),Mi=aa(Ml(Xr.expression),ic),Us=Mi.body.statements,Ss=0,zs=-1,vo=[];if(jt){let qc=ai(Us[Ss],Du);qc&&(vo.push(qc),Ss++),vo.push(Us[Ss]),Ss++,vo.push(t.createExpressionStatement(t.createAssignment(jt.left,aa($.name,He))))}for(;!nm(Dl(Us,zs));)zs--;wn(vo,Us,Ss,zs),zs<-1&&wn(vo,Us,zs+1);let Wa=ai(Dl(Us,zs),nm);for(let qc of Hn)nm(qc)&&Wa?.expression&&!He(Wa.expression)?vo.push(Wa):vo.push(qc);return wn(vo,nn,1),t.restoreOuterExpressions(oe.expression,t.restoreOuterExpressions($.initializer,t.restoreOuterExpressions(jt&&jt.right,t.updateCallExpression(Xr,t.restoreOuterExpressions(Xr.expression,t.updateFunctionExpression(Mi,void 0,void 0,void 0,void 0,Mi.parameters,void 0,t.updateBlock(Mi.body,vo))),void 0,Xr.arguments))))}function rl(oe,yt){if(oe.transformFlags&32768||oe.expression.kind===108||Cf(Ml(oe.expression))){let{target:Gt,thisArg:Xt}=t.createCallBinding(oe.expression,u);oe.expression.kind===108&&Tn(Xt,8);let Fr;if(oe.transformFlags&32768?Fr=t.createFunctionApplyCall(M.checkDefined(ot(Gt,ne,Ct)),oe.expression.kind===108?Xt:M.checkDefined(ot(Xt,re,Ct)),nd(oe.arguments,!0,!1,!1)):Fr=Et(t.createFunctionCallCall(M.checkDefined(ot(Gt,ne,Ct)),oe.expression.kind===108?Xt:M.checkDefined(ot(Xt,re,Ct)),Kr(oe.arguments,re,Ct)),oe),oe.expression.kind===108){let nn=t.createLogicalOr(Fr,Ui());Fr=yt?t.createAssignment(te(),nn):nn}return zn(Fr,oe)}return Kx(oe)&&(w|=131072),Mr(oe,re,e)}function $l(oe){if(Pt(oe.arguments,Ad)){let{target:yt,thisArg:Gt}=t.createCallBinding(t.createPropertyAccessExpression(oe.expression,"bind"),u);return t.createNewExpression(t.createFunctionApplyCall(M.checkDefined(ot(yt,re,Ct)),Gt,nd(t.createNodeArray([t.createVoidZero(),...oe.arguments]),!0,!1,!1)),void 0,[])}return Mr(oe,re,e)}function nd(oe,yt,Gt,Xt){let Fr=oe.length,nn=ef(EP(oe,Je,(Fe,jt,Xr,Mi)=>jt(Fe,Gt,Xt&&Mi===Fr)));if(nn.length===1){let Fe=nn[0];if(yt&&!m.downlevelIteration||IG(Fe.expression)||bO(Fe.expression,"___spreadArray"))return Fe.expression}let Hn=n(),Si=nn[0].kind!==0,$=Si?t.createArrayLiteralExpression():nn[0].expression;for(let Fe=Si?0:1;Fe<nn.length;Fe++){let jt=nn[Fe];$=Hn.createSpreadArrayHelper($,jt.expression,jt.kind===1&&!yt)}return $}function Je(oe){return Ad(oe)?qt:gs}function qt(oe){return Cr(oe,Gr)}function Gr(oe){M.assertNode(oe,Ad);let yt=ot(oe.expression,re,Ct);M.assert(yt);let Gt=bO(yt,"___read"),Xt=Gt||IG(yt)?2:1;return m.downlevelIteration&&Xt===1&&!Gu(yt)&&!Gt&&(yt=n().createReadHelper(yt,void 0),Xt=2),p8e(Xt,yt)}function gs(oe,yt,Gt){let Xt=t.createArrayLiteralExpression(Kr(t.createNodeArray(oe,Gt),re,Ct),yt);return p8e(0,Xt)}function Qa(oe){return ot(oe.expression,re,Ct)}function so(oe){return Et(t.createStringLiteral(oe.text),oe)}function fl(oe){return oe.hasExtendedUnicodeEscape?Et(t.createStringLiteral(oe.text),oe):oe}function au(oe){return oe.numericLiteralFlags&384?Et(t.createNumericLiteral(oe.text),oe):oe}function Uo(oe){return IK(e,oe,re,x,L,1)}function Fo(oe){let yt=t.createStringLiteral(oe.head.text);for(let Gt of oe.templateSpans){let Xt=[M.checkDefined(ot(Gt.expression,re,Ct))];Gt.literal.text.length>0&&Xt.push(t.createStringLiteral(Gt.literal.text)),yt=t.createCallExpression(t.createPropertyAccessExpression(yt,"concat"),void 0,Xt)}return Et(yt,oe)}function Cl(){return t.createUniqueName("_super",48)}function Wf(oe,yt){let Gt=w&8&&!yt?t.createPropertyAccessExpression(zn(Cl(),oe),"prototype"):Cl();return zn(Gt,oe),Zl(Gt,oe),qa(Gt,oe),Gt}function fg(oe){return oe.keywordToken===105&&oe.name.escapedText==="target"?(w|=32768,t.createUniqueName("_newTarget",48)):oe}function id(oe,yt,Gt){if(J&1&&Bs(yt)){let Xt=q(32670,Ga(yt)&16?81:65);E(oe,yt,Gt),ee(Xt,0,0);return}E(oe,yt,Gt)}function If(){J&2||(J|=2,e.enableSubstitution(80))}function wd(){J&1||(J|=1,e.enableSubstitution(110),e.enableEmitNotification(176),e.enableEmitNotification(174),e.enableEmitNotification(177),e.enableEmitNotification(178),e.enableEmitNotification(219),e.enableEmitNotification(218),e.enableEmitNotification(262))}function sd(oe,yt){return yt=S(oe,yt),oe===1?Of(yt):He(yt)?Gh(yt):yt}function Gh(oe){if(J&2&&!yY(oe)){let yt=ks(oe,He);if(yt&&Yh(yt))return Et(t.getGeneratedNameForNode(yt),oe)}return oe}function Yh(oe){switch(oe.parent.kind){case 208:case 263:case 266:case 260:return oe.parent.name===oe&&d.isDeclarationWithCollidingName(oe.parent)}return!1}function Of(oe){switch(oe.kind){case 80:return Hl(oe);case 110:return $f(oe)}return oe}function Hl(oe){if(J&2&&!yY(oe)){let yt=d.getReferencedDeclarationWithCollidingName(oe);if(yt&&!(gi(yt)&&Kh(yt,oe)))return Et(t.getGeneratedNameForNode(Ps(yt)),oe)}return oe}function Kh(oe,yt){let Gt=ks(yt);if(!Gt||Gt===oe||Gt.end<=oe.pos||Gt.pos>=oe.end)return!1;let Xt=eg(oe);for(;Gt;){if(Gt===Xt||Gt===oe)return!1;if(uu(Gt)&&Gt.parent===oe)return!0;Gt=Gt.parent}return!1}function $f(oe){return J&1&&w&16?Et(te(),oe):oe}function nh(oe,yt){return oa(yt)?t.getInternalName(oe):t.createPropertyAccessExpression(t.getInternalName(oe),"prototype")}function ad(oe,yt){if(!oe||!yt||Pt(oe.parameters))return!1;let Gt=xo(oe.body.statements);if(!Gt||!Ko(Gt)||Gt.kind!==244)return!1;let Xt=Gt.expression;if(!Ko(Xt)||Xt.kind!==213)return!1;let Fr=Xt.expression;if(!Ko(Fr)||Fr.kind!==108)return!1;let nn=Dh(Xt.arguments);if(!nn||!Ko(nn)||nn.kind!==230)return!1;let Hn=nn.expression;return He(Hn)&&Hn.escapedText==="arguments"}}function qEt(e){switch(e){case 2:return"return";case 3:return"break";case 4:return"yield";case 5:return"yield*";case 7:return"endfinally";default:return}}function xhe(e){let{factory:t,getEmitHelperFactory:n,resumeLexicalEnvironment:i,endLexicalEnvironment:s,hoistFunctionDeclaration:o,hoistVariableDeclaration:u}=e,m=e.getCompilerOptions(),d=Ka(m),S=e.getEmitResolver(),E=e.onSubstituteNode;e.onSubstituteNode=bt;let x,D,w,R,L,F,J,G,q,ee,W=1,pe,K,re,ue,ce=0,ne=0,le,me,de,Ae,xe,te,he,be;return cg(e,Ve);function Ve(Je){if(Je.isDeclarationFile||!(Je.transformFlags&2048))return Je;let qt=Mr(Je,Pe,e);return E0(qt,e.readEmitHelpers()),qt}function Pe(Je){let qt=Je.transformFlags;return R?ke(Je):w?De(Je):Go(Je)&&Je.asteriskToken?ct(Je):qt&2048?Mr(Je,Pe,e):Je}function ke(Je){switch(Je.kind){case 246:return la(Je);case 247:return yr(Je);case 255:return At(Je);case 256:return Ut(Je);default:return De(Je)}}function De(Je){switch(Je.kind){case 262:return qe(Je);case 218:return et(Je);case 177:case 178:return Ie(Je);case 243:return mt(Je);case 248:return lt(Je);case 249:return fe(Je);case 252:return Me(Je);case 251:return Ce(Je);case 253:return ft(Je);default:return Je.transformFlags&1048576?Be(Je):Je.transformFlags&4196352?Mr(Je,Pe,e):Je}}function Be(Je){switch(Je.kind){case 226:return Xe(Je);case 355:return xr(Je);case 227:return ur(Je);case 229:return or(Je);case 209:return Zr(Je);case 210:return Sr(Je);case 212:return Pi(Je);case 213:return Cs(Je);case 214:return ss(Je);default:return Mr(Je,Pe,e)}}function ct(Je){switch(Je.kind){case 262:return qe(Je);case 218:return et(Je);default:return M.failBadSyntaxKind(Je)}}function qe(Je){if(Je.asteriskToken)Je=zn(Et(t.createFunctionDeclaration(Je.modifiers,void 0,Je.name,void 0,Kc(Je.parameters,Pe,e),void 0,_t(Je.body)),Je),Je);else{let qt=w,Gr=R;w=!1,R=!1,Je=Mr(Je,Pe,e),w=qt,R=Gr}if(w){o(Je);return}else return Je}function et(Je){if(Je.asteriskToken)Je=zn(Et(t.createFunctionExpression(void 0,void 0,Je.name,void 0,Kc(Je.parameters,Pe,e),void 0,_t(Je.body)),Je),Je);else{let qt=w,Gr=R;w=!1,R=!1,Je=Mr(Je,Pe,e),w=qt,R=Gr}return Je}function Ie(Je){let qt=w,Gr=R;return w=!1,R=!1,Je=Mr(Je,Pe,e),w=qt,R=Gr,Je}function _t(Je){let qt=[],Gr=w,gs=R,Qa=L,so=F,fl=J,au=G,Uo=q,Fo=ee,Cl=W,Wf=pe,fg=K,id=re,If=ue;w=!0,R=!1,L=void 0,F=void 0,J=void 0,G=void 0,q=void 0,ee=void 0,W=1,pe=void 0,K=void 0,re=void 0,ue=t.createTempVariable(void 0),i();let wd=t.copyPrologue(Je.statements,qt,!1,Pe);Ii(Je.statements,wd);let sd=ae();return Ay(qt,s()),qt.push(t.createReturnStatement(sd)),w=Gr,R=gs,L=Qa,F=so,J=fl,G=au,q=Uo,ee=Fo,W=Cl,pe=Wf,K=fg,re=id,ue=If,Et(t.createBlock(qt,Je.multiLine),Je)}function mt(Je){if(Je.transformFlags&1048576){An(Je.declarationList);return}else{if(Ga(Je)&2097152)return Je;for(let Gr of Je.declarationList.declarations)u(Gr.name);let qt=ZI(Je.declarationList);return qt.length===0?void 0:qa(t.createExpressionStatement(t.inlineExpressions(Cr(qt,vi))),Je)}}function Xe(Je){let qt=jH(Je);switch(qt){case 0:return rr(Je);case 1:return ht(Je);default:return M.assertNever(qt)}}function ht(Je){let{left:qt,right:Gr}=Je;if(Z(Gr)){let gs;switch(qt.kind){case 211:gs=t.updatePropertyAccessExpression(qt,z(M.checkDefined(ot(qt.expression,Pe,xf))),qt.name);break;case 212:gs=t.updateElementAccessExpression(qt,z(M.checkDefined(ot(qt.expression,Pe,xf))),z(M.checkDefined(ot(qt.argumentExpression,Pe,Ct))));break;default:gs=M.checkDefined(ot(qt,Pe,Ct));break}let Qa=Je.operatorToken.kind;return XO(Qa)?Et(t.createAssignment(gs,Et(t.createBinaryExpression(z(gs),QO(Qa),M.checkDefined(ot(Gr,Pe,Ct))),Je)),Je):t.updateBinaryExpression(Je,gs,Je.operatorToken,M.checkDefined(ot(Gr,Pe,Ct)))}return Mr(Je,Pe,e)}function rr(Je){return Z(Je.right)?Jfe(Je.operatorToken.kind)?jr(Je):Je.operatorToken.kind===28?vr(Je):t.updateBinaryExpression(Je,z(M.checkDefined(ot(Je.left,Pe,Ct))),Je.operatorToken,M.checkDefined(ot(Je.right,Pe,Ct))):Mr(Je,Pe,e)}function vr(Je){let qt=[];return Gr(Je.left),Gr(Je.right),t.inlineExpressions(qt);function Gr(gs){Pn(gs)&&gs.operatorToken.kind===28?(Gr(gs.left),Gr(gs.right)):(Z(gs)&&qt.length>0&&(Se(1,[t.createExpressionStatement(t.inlineExpressions(qt))]),qt=[]),qt.push(M.checkDefined(ot(gs,Pe,Ct))))}}function xr(Je){let qt=[];for(let Gr of Je.elements)Pn(Gr)&&Gr.operatorToken.kind===28?qt.push(vr(Gr)):(Z(Gr)&&qt.length>0&&(Se(1,[t.createExpressionStatement(t.inlineExpressions(qt))]),qt=[]),qt.push(M.checkDefined(ot(Gr,Pe,Ct))));return t.inlineExpressions(qt)}function jr(Je){let qt=Te(),Gr=Ue();return Lo(Gr,M.checkDefined(ot(Je.left,Pe,Ct)),Je.left),Je.operatorToken.kind===56?Jc(qt,Gr,Je.left):_r(qt,Gr,Je.left),Lo(Gr,M.checkDefined(ot(Je.right,Pe,Ct)),Je.right),Re(qt),Gr}function ur(Je){if(Z(Je.whenTrue)||Z(Je.whenFalse)){let qt=Te(),Gr=Te(),gs=Ue();return Jc(qt,M.checkDefined(ot(Je.condition,Pe,Ct)),Je.condition),Lo(gs,M.checkDefined(ot(Je.whenTrue,Pe,Ct)),Je.whenTrue),po(Gr),Re(qt),Lo(gs,M.checkDefined(ot(Je.whenFalse,Pe,Ct)),Je.whenFalse),Re(Gr),gs}return Mr(Je,Pe,e)}function or(Je){let qt=Te(),Gr=ot(Je.expression,Pe,Ct);if(Je.asteriskToken){let gs=Ga(Je.expression)&8388608?Gr:Et(n().createValuesHelper(Gr),Je);z_(gs,Je)}else W_(Gr,Je);return Re(qt),Xu(Je)}function Zr(Je){return Oi(Je.elements,void 0,void 0,Je.multiLine)}function Oi(Je,qt,Gr,gs){let Qa=Ge(Je),so;if(Qa>0){so=Ue();let Uo=Kr(Je,Pe,Ct,0,Qa);Lo(so,t.createArrayLiteralExpression(qt?[qt,...Uo]:Uo)),qt=void 0}let fl=L_(Je,au,[],Qa);return so?t.createArrayConcatCall(so,[t.createArrayLiteralExpression(fl,gs)]):Et(t.createArrayLiteralExpression(qt?[qt,...fl]:fl,gs),Gr);function au(Uo,Fo){if(Z(Fo)&&Uo.length>0){let Cl=so!==void 0;so||(so=Ue()),Lo(so,Cl?t.createArrayConcatCall(so,[t.createArrayLiteralExpression(Uo,gs)]):t.createArrayLiteralExpression(qt?[qt,...Uo]:Uo,gs)),qt=void 0,Uo=[]}return Uo.push(M.checkDefined(ot(Fo,Pe,Ct))),Uo}}function Sr(Je){let qt=Je.properties,Gr=Je.multiLine,gs=Ge(qt),Qa=Ue();Lo(Qa,t.createObjectLiteralExpression(Kr(qt,Pe,p0,0,gs),Gr));let so=L_(qt,fl,[],gs);return so.push(Gr?T_(lo(Et(t.cloneNode(Qa),Qa),Qa.parent)):Qa),t.inlineExpressions(so);function fl(au,Uo){Z(Uo)&&au.length>0&&(bc(t.createExpressionStatement(t.inlineExpressions(au))),au=[]);let Fo=lme(t,Je,Uo,Qa),Cl=ot(Fo,Pe,Ct);return Cl&&(Gr&&T_(Cl),au.push(Cl)),au}}function Pi(Je){return Z(Je.argumentExpression)?t.updateElementAccessExpression(Je,z(M.checkDefined(ot(Je.expression,Pe,xf))),M.checkDefined(ot(Je.argumentExpression,Pe,Ct))):Mr(Je,Pe,e)}function Cs(Je){if(!Np(Je)&&kt(Je.arguments,Z)){let{target:qt,thisArg:Gr}=t.createCallBinding(Je.expression,u,d,!0);return zn(Et(t.createFunctionApplyCall(z(M.checkDefined(ot(qt,Pe,xf))),Gr,Oi(Je.arguments)),Je),Je)}return Mr(Je,Pe,e)}function ss(Je){if(kt(Je.arguments,Z)){let{target:qt,thisArg:Gr}=t.createCallBinding(t.createPropertyAccessExpression(Je.expression,"bind"),u);return zn(Et(t.createNewExpression(t.createFunctionApplyCall(z(M.checkDefined(ot(qt,Pe,Ct))),Gr,Oi(Je.arguments,t.createVoidZero())),void 0,[]),Je),Je)}return Mr(Je,Pe,e)}function Ii(Je,qt=0){let Gr=Je.length;for(let gs=qt;gs<Gr;gs++)Xs(Je[gs])}function $r(Je){Vs(Je)?Ii(Je.statements):Xs(Je)}function Xs(Je){let qt=R;R||(R=Z(Je)),$e(Je),R=qt}function $e(Je){switch(Je.kind){case 241:return Yt(Je);case 244:return Vr(Je);case 245:return Ci(Je);case 246:return Ui(Je);case 247:return Gs(Je);case 248:return to(Je);case 249:return St(Je);case 251:return vt(Je);case 252:return nt(Je);case 253:return tt(Je);case 254:return tr(Je);case 255:return Oe(Je);case 256:return Nt(Je);case 257:return Rt(Je);case 258:return nr(Je);default:return bc(ot(Je,Pe,Vi))}}function Yt(Je){Z(Je)?Ii(Je.statements):bc(ot(Je,Pe,Vi))}function Vr(Je){bc(ot(Je,Pe,Vi))}function An(Je){for(let so of Je.declarations){let fl=t.cloneNode(so.name);Zl(fl,so.name),u(fl)}let qt=ZI(Je),Gr=qt.length,gs=0,Qa=[];for(;gs<Gr;){for(let so=gs;so<Gr;so++){let fl=qt[so];if(Z(fl.initializer)&&Qa.length>0)break;Qa.push(vi(fl))}Qa.length&&(bc(t.createExpressionStatement(t.inlineExpressions(Qa))),gs+=Qa.length,Qa=[])}}function vi(Je){return qa(t.createAssignment(qa(t.cloneNode(Je.name),Je.name),M.checkDefined(ot(Je.initializer,Pe,Ct))),Je)}function Ci(Je){if(Z(Je))if(Z(Je.thenStatement)||Z(Je.elseStatement)){let qt=Te(),Gr=Je.elseStatement?Te():void 0;Jc(Je.elseStatement?Gr:qt,M.checkDefined(ot(Je.expression,Pe,Ct)),Je.expression),$r(Je.thenStatement),Je.elseStatement&&(po(qt),Re(Gr),$r(Je.elseStatement)),Re(qt)}else bc(ot(Je,Pe,Vi));else bc(ot(Je,Pe,Vi))}function Ui(Je){if(Z(Je)){let qt=Te(),Gr=Te();Yn(qt),Re(Gr),$r(Je.statement),Re(qt),_r(Gr,M.checkDefined(ot(Je.expression,Pe,Ct))),pi()}else bc(ot(Je,Pe,Vi))}function la(Je){return R?(ls(),Je=Mr(Je,Pe,e),pi(),Je):Mr(Je,Pe,e)}function Gs(Je){if(Z(Je)){let qt=Te(),Gr=Yn(qt);Re(qt),Jc(Gr,M.checkDefined(ot(Je.expression,Pe,Ct))),$r(Je.statement),po(qt),pi()}else bc(ot(Je,Pe,Vi))}function yr(Je){return R?(ls(),Je=Mr(Je,Pe,e),pi(),Je):Mr(Je,Pe,e)}function to(Je){if(Z(Je)){let qt=Te(),Gr=Te(),gs=Yn(Gr);if(Je.initializer){let Qa=Je.initializer;Ru(Qa)?An(Qa):bc(Et(t.createExpressionStatement(M.checkDefined(ot(Qa,Pe,Ct))),Qa))}Re(qt),Je.condition&&Jc(gs,M.checkDefined(ot(Je.condition,Pe,Ct))),$r(Je.statement),Re(Gr),Je.incrementor&&bc(Et(t.createExpressionStatement(M.checkDefined(ot(Je.incrementor,Pe,Ct))),Je.incrementor)),po(qt),pi()}else bc(ot(Je,Pe,Vi))}function lt(Je){R&&ls();let qt=Je.initializer;if(qt&&Ru(qt)){for(let gs of qt.declarations)u(gs.name);let Gr=ZI(qt);Je=t.updateForStatement(Je,Gr.length>0?t.inlineExpressions(Cr(Gr,vi)):void 0,ot(Je.condition,Pe,Ct),ot(Je.incrementor,Pe,Ct),ff(Je.statement,Pe,e))}else Je=Mr(Je,Pe,e);return R&&pi(),Je}function St(Je){if(Z(Je)){let qt=Ue(),Gr=Ue(),gs=Ue(),Qa=t.createLoopVariable(),so=Je.initializer;u(Qa),Lo(qt,M.checkDefined(ot(Je.expression,Pe,Ct))),Lo(Gr,t.createArrayLiteralExpression()),bc(t.createForInStatement(gs,qt,t.createExpressionStatement(t.createCallExpression(t.createPropertyAccessExpression(Gr,"push"),void 0,[gs])))),Lo(Qa,t.createNumericLiteral(0));let fl=Te(),au=Te(),Uo=Yn(au);Re(fl),Jc(Uo,t.createLessThan(Qa,t.createPropertyAccessExpression(Gr,"length"))),Lo(gs,t.createElementAccessExpression(Gr,Qa)),Jc(au,t.createBinaryExpression(gs,103,qt));let Fo;if(Ru(so)){for(let Cl of so.declarations)u(Cl.name);Fo=t.cloneNode(so.declarations[0].name)}else Fo=M.checkDefined(ot(so,Pe,Ct)),M.assert(xf(Fo));Lo(Fo,gs),$r(Je.statement),Re(au),bc(t.createExpressionStatement(t.createPostfixIncrement(Qa))),po(fl),pi()}else bc(ot(Je,Pe,Vi))}function fe(Je){R&&ls();let qt=Je.initializer;if(Ru(qt)){for(let Gr of qt.declarations)u(Gr.name);Je=t.updateForInStatement(Je,qt.declarations[0].name,M.checkDefined(ot(Je.expression,Pe,Ct)),M.checkDefined(ot(Je.statement,Pe,Vi,t.liftToBlock)))}else Je=Mr(Je,Pe,e);return R&&pi(),Je}function vt(Je){let qt=zi(Je.label?Nn(Je.label):void 0);qt>0?po(qt,Je):bc(Je)}function Ce(Je){if(R){let qt=zi(Je.label&&Nn(Je.label));if(qt>0)return P_(qt,Je)}return Mr(Je,Pe,e)}function nt(Je){let qt=ts(Je.label?Nn(Je.label):void 0);qt>0?po(qt,Je):bc(Je)}function Me(Je){if(R){let qt=ts(Je.label&&Nn(Je.label));if(qt>0)return P_(qt,Je)}return Mr(Je,Pe,e)}function tt(Je){qf(ot(Je.expression,Pe,Ct),Je)}function ft(Je){return el(ot(Je.expression,Pe,Ct),Je)}function tr(Je){Z(Je)?(qr(z(M.checkDefined(ot(Je.expression,Pe,Ct)))),$r(Je.statement),Hr()):bc(ot(Je,Pe,Vi))}function Oe(Je){if(Z(Je.caseBlock)){let qt=Je.caseBlock,Gr=qt.clauses.length,gs=tn(),Qa=z(M.checkDefined(ot(Je.expression,Pe,Ct))),so=[],fl=-1;for(let Fo=0;Fo<Gr;Fo++){let Cl=qt.clauses[Fo];so.push(Te()),Cl.kind===297&&fl===-1&&(fl=Fo)}let au=0,Uo=[];for(;au<Gr;){let Fo=0;for(let Cl=au;Cl<Gr;Cl++){let Wf=qt.clauses[Cl];if(Wf.kind===296){if(Z(Wf.expression)&&Uo.length>0)break;Uo.push(t.createCaseClause(M.checkDefined(ot(Wf.expression,Pe,Ct)),[P_(so[Cl],Wf.expression)]))}else Fo++}Uo.length&&(bc(t.createSwitchStatement(Qa,t.createCaseBlock(Uo))),au+=Uo.length,Uo=[]),Fo>0&&(au+=Fo,Fo=0)}fl>=0?po(so[fl]):po(gs);for(let Fo=0;Fo<Gr;Fo++)Re(so[Fo]),Ii(qt.clauses[Fo].statements);er()}else bc(ot(Je,Pe,Vi))}function At(Je){return R&&Er(),Je=Mr(Je,Pe,e),R&&er(),Je}function Nt(Je){Z(Je)?(uo(Nn(Je.label)),$r(Je.statement),Mo()):bc(ot(Je,Pe,Vi))}function Ut(Je){return R&&qs(Nn(Je.label)),Je=Mr(Je,Pe,e),R&&Mo(),Je}function Rt(Je){mc(M.checkDefined(ot(Je.expression??t.createVoidZero(),Pe,Ct)),Je)}function nr(Je){Z(Je)?(dn(),$r(Je.tryBlock),Je.catchClause&&(Ar(Je.catchClause.variableDeclaration),$r(Je.catchClause.block)),Je.finallyBlock&&(In(),$r(Je.finallyBlock)),Ki()):bc(Mr(Je,Pe,e))}function Z(Je){return!!Je&&(Je.transformFlags&1048576)!==0}function Ge(Je){let qt=Je.length;for(let Gr=0;Gr<qt;Gr++)if(Z(Je[Gr]))return Gr;return-1}function bt(Je,qt){return qt=E(Je,qt),Je===1?Q(qt):qt}function Q(Je){return He(Je)?Ke(Je):Je}function Ke(Je){if(!xc(Je)&&x&&x.has(Nn(Je))){let qt=Bc(Je);if(He(qt)&&qt.parent){let Gr=S.getReferencedValueDeclaration(qt);if(Gr){let gs=D[pf(Gr)];if(gs){let Qa=lo(Et(t.cloneNode(gs),gs),gs.parent);return qa(Qa,Je),Zl(Qa,Je),Qa}}}}return Je}function z(Je){if(xc(Je)||Ga(Je)&8192)return Je;let qt=t.createTempVariable(u);return Lo(qt,Je,Je),qt}function Ue(Je){let qt=Je?t.createUniqueName(Je):t.createTempVariable(void 0);return u(qt),qt}function Te(){q||(q=[]);let Je=W;return W++,q[Je]=-1,Je}function Re(Je){M.assert(q!==void 0,"No labels were defined."),q[Je]=pe?pe.length:0}function It(Je){L||(L=[],J=[],F=[],G=[]);let qt=J.length;return J[qt]=0,F[qt]=pe?pe.length:0,L[qt]=Je,G.push(Je),qt}function $t(){let Je=Ht();if(Je===void 0)return M.fail("beginBlock was never called.");let qt=J.length;return J[qt]=1,F[qt]=pe?pe.length:0,L[qt]=Je,G.pop(),Je}function Ht(){return vc(G)}function dr(){let Je=Ht();return Je&&Je.kind}function qr(Je){let qt=Te(),Gr=Te();Re(qt),It({kind:1,expression:Je,startLabel:qt,endLabel:Gr})}function Hr(){M.assert(dr()===1);let Je=$t();Re(Je.endLabel)}function dn(){let Je=Te(),qt=Te();return Re(Je),It({kind:0,state:0,startLabel:Je,endLabel:qt}),Fa(),qt}function Ar(Je){M.assert(dr()===0);let qt;if(xc(Je.name))qt=Je.name,u(Je.name);else{let so=Nn(Je.name);qt=Ue(so),x||(x=new Map,D=[],e.enableSubstitution(80)),x.set(so,!0),D[pf(Je)]=qt}let Gr=Ht();M.assert(Gr.state<1);let gs=Gr.endLabel;po(gs);let Qa=Te();Re(Qa),Gr.state=1,Gr.catchVariable=qt,Gr.catchLabel=Qa,Lo(qt,t.createCallExpression(t.createPropertyAccessExpression(ue,"sent"),void 0,[])),Fa()}function In(){M.assert(dr()===0);let Je=Ht();M.assert(Je.state<2);let qt=Je.endLabel;po(qt);let Gr=Te();Re(Gr),Je.state=2,Je.finallyLabel=Gr}function Ki(){M.assert(dr()===0);let Je=$t();Je.state<2?po(Je.endLabel):tl(),Re(Je.endLabel),Fa(),Je.state=3}function ls(){It({kind:3,isScript:!0,breakLabel:-1,continueLabel:-1})}function Yn(Je){let qt=Te();return It({kind:3,isScript:!1,breakLabel:qt,continueLabel:Je}),qt}function pi(){M.assert(dr()===3);let Je=$t(),qt=Je.breakLabel;Je.isScript||Re(qt)}function Er(){It({kind:2,isScript:!0,breakLabel:-1})}function tn(){let Je=Te();return It({kind:2,isScript:!1,breakLabel:Je}),Je}function er(){M.assert(dr()===2);let Je=$t(),qt=Je.breakLabel;Je.isScript||Re(qt)}function qs(Je){It({kind:4,isScript:!0,labelText:Je,breakLabel:-1})}function uo(Je){let qt=Te();It({kind:4,isScript:!1,labelText:Je,breakLabel:qt})}function Mo(){M.assert(dr()===4);let Je=$t();Je.isScript||Re(Je.breakLabel)}function Do(Je){return Je.kind===2||Je.kind===3}function ms(Je){return Je.kind===4}function sa(Je){return Je.kind===3}function Sc(Je,qt){for(let Gr=qt;Gr>=0;Gr--){let gs=G[Gr];if(ms(gs)){if(gs.labelText===Je)return!0}else break}return!1}function ts(Je){if(G)if(Je)for(let qt=G.length-1;qt>=0;qt--){let Gr=G[qt];if(ms(Gr)&&Gr.labelText===Je)return Gr.breakLabel;if(Do(Gr)&&Sc(Je,qt-1))return Gr.breakLabel}else for(let qt=G.length-1;qt>=0;qt--){let Gr=G[qt];if(Do(Gr))return Gr.breakLabel}return 0}function zi(Je){if(G)if(Je)for(let qt=G.length-1;qt>=0;qt--){let Gr=G[qt];if(sa(Gr)&&Sc(Je,qt-1))return Gr.continueLabel}else for(let qt=G.length-1;qt>=0;qt--){let Gr=G[qt];if(sa(Gr))return Gr.continueLabel}return 0}function Eu(Je){if(Je!==void 0&&Je>0){ee===void 0&&(ee=[]);let qt=t.createNumericLiteral(Number.MAX_SAFE_INTEGER);return ee[Je]===void 0?ee[Je]=[qt]:ee[Je].push(qt),qt}return t.createOmittedExpression()}function kc(Je){let qt=t.createNumericLiteral(Je);return Tj(qt,3,qEt(Je)),qt}function P_(Je,qt){return M.assertLessThan(0,Je,"Invalid label"),Et(t.createReturnStatement(t.createArrayLiteralExpression([kc(3),Eu(Je)])),qt)}function el(Je,qt){return Et(t.createReturnStatement(t.createArrayLiteralExpression(Je?[kc(2),Je]:[kc(2)])),qt)}function Xu(Je){return Et(t.createCallExpression(t.createPropertyAccessExpression(ue,"sent"),void 0,[]),Je)}function Fa(){Se(0)}function bc(Je){Je?Se(1,[Je]):Fa()}function Lo(Je,qt,Gr){Se(2,[Je,qt],Gr)}function po(Je,qt){Se(3,[Je],qt)}function _r(Je,qt,Gr){Se(4,[Je,qt],Gr)}function Jc(Je,qt,Gr){Se(5,[Je,qt],Gr)}function z_(Je,qt){Se(7,[Je],qt)}function W_(Je,qt){Se(6,[Je],qt)}function qf(Je,qt){Se(8,[Je],qt)}function mc(Je,qt){Se(9,[Je],qt)}function tl(){Se(10)}function Se(Je,qt,Gr){pe===void 0&&(pe=[],K=[],re=[]),q===void 0&&Re(Te());let gs=pe.length;pe[gs]=Je,K[gs]=qt,re[gs]=Gr}function ae(){ce=0,ne=0,le=void 0,me=!1,de=!1,Ae=void 0,xe=void 0,te=void 0,he=void 0,be=void 0;let Je=Ye();return n().createGeneratorHelper(Tn(t.createFunctionExpression(void 0,void 0,void 0,void 0,[t.createParameterDeclaration(void 0,void 0,ue)],void 0,t.createBlock(Je,Je.length>0)),1048576))}function Ye(){if(pe){for(let Je=0;Je<pe.length;Je++)Na(Je);Tr(pe.length)}else Tr(0);if(Ae){let Je=t.createPropertyAccessExpression(ue,"label"),qt=t.createSwitchStatement(Je,t.createCaseBlock(Ae));return[T_(qt)]}return xe||[]}function Ot(){xe&&(pr(!me),me=!1,de=!1,ne++)}function Tr(Je){Vn(Je)&&(Jn(Je),be=void 0,du(void 0,void 0)),xe&&Ae&&pr(!1),Ri()}function Vn(Je){if(!de)return!0;if(!q||!ee)return!1;for(let qt=0;qt<q.length;qt++)if(q[qt]===Je&&ee[qt])return!0;return!1}function pr(Je){if(Ae||(Ae=[]),xe){if(be)for(let qt=be.length-1;qt>=0;qt--){let Gr=be[qt];xe=[t.createWithStatement(Gr.expression,t.createBlock(xe))]}if(he){let{startLabel:qt,catchLabel:Gr,finallyLabel:gs,endLabel:Qa}=he;xe.unshift(t.createExpressionStatement(t.createCallExpression(t.createPropertyAccessExpression(t.createPropertyAccessExpression(ue,"trys"),"push"),void 0,[t.createArrayLiteralExpression([Eu(qt),Eu(Gr),Eu(gs),Eu(Qa)])]))),he=void 0}Je&&xe.push(t.createExpressionStatement(t.createAssignment(t.createPropertyAccessExpression(ue,"label"),t.createNumericLiteral(ne+1))))}Ae.push(t.createCaseClause(t.createNumericLiteral(ne),xe||[])),xe=void 0}function Jn(Je){if(q)for(let qt=0;qt<q.length;qt++)q[qt]===Je&&(Ot(),le===void 0&&(le=[]),le[ne]===void 0?le[ne]=[qt]:le[ne].push(qt))}function Ri(){if(ee!==void 0&&le!==void 0)for(let Je=0;Je<le.length;Je++){let qt=le[Je];if(qt!==void 0)for(let Gr of qt){let gs=ee[Gr];if(gs!==void 0)for(let Qa of gs)Qa.text=String(Je)}}}function Ai(Je){if(L)for(;ce<J.length&&F[ce]<=Je;ce++){let qt=L[ce],Gr=J[ce];switch(qt.kind){case 0:Gr===0?(te||(te=[]),xe||(xe=[]),te.push(he),he=qt):Gr===1&&(he=te.pop());break;case 1:Gr===0?(be||(be=[]),be.push(qt)):Gr===1&&be.pop();break}}}function Na(Je){if(Jn(Je),Ai(Je),me)return;me=!1,de=!1;let qt=pe[Je];if(qt===0)return;if(qt===10)return nd();let Gr=K[Je];if(qt===1)return gc(Gr[0]);let gs=re[Je];switch(qt){case 2:return Wl(Gr[0],Gr[1],gs);case 3:return hc(Gr[0],gs);case 4:return mu(Gr[0],Gr[1],gs);case 5:return zf(Gr[0],Gr[1],gs);case 6:return rl(Gr[0],gs);case 7:return $l(Gr[0],gs);case 8:return du(Gr[0],gs);case 9:return Oc(Gr[0],gs)}}function gc(Je){Je&&(xe?xe.push(Je):xe=[Je])}function Wl(Je,qt,Gr){gc(Et(t.createExpressionStatement(t.createAssignment(Je,qt)),Gr))}function Oc(Je,qt){me=!0,de=!0,gc(Et(t.createThrowStatement(Je),qt))}function du(Je,qt){me=!0,de=!0,gc(Tn(Et(t.createReturnStatement(t.createArrayLiteralExpression(Je?[kc(2),Je]:[kc(2)])),qt),768))}function hc(Je,qt){me=!0,gc(Tn(Et(t.createReturnStatement(t.createArrayLiteralExpression([kc(3),Eu(Je)])),qt),768))}function mu(Je,qt,Gr){gc(Tn(t.createIfStatement(qt,Tn(Et(t.createReturnStatement(t.createArrayLiteralExpression([kc(3),Eu(Je)])),Gr),768)),1))}function zf(Je,qt,Gr){gc(Tn(t.createIfStatement(t.createLogicalNot(qt),Tn(Et(t.createReturnStatement(t.createArrayLiteralExpression([kc(3),Eu(Je)])),Gr),768)),1))}function rl(Je,qt){me=!0,gc(Tn(Et(t.createReturnStatement(t.createArrayLiteralExpression(Je?[kc(4),Je]:[kc(4)])),qt),768))}function $l(Je,qt){me=!0,gc(Tn(Et(t.createReturnStatement(t.createArrayLiteralExpression([kc(5),Je])),qt),768))}function nd(){me=!0,gc(t.createReturnStatement(t.createArrayLiteralExpression([kc(7)])))}}function RK(e){function t(Z){switch(Z){case 2:return pe;case 3:return K;default:return W}}let{factory:n,getEmitHelperFactory:i,startLexicalEnvironment:s,endLexicalEnvironment:o,hoistVariableDeclaration:u}=e,m=e.getCompilerOptions(),d=e.getEmitResolver(),S=e.getEmitHost(),E=Ka(m),x=V_(m),D=e.onSubstituteNode,w=e.onEmitNode;e.onSubstituteNode=ft,e.onEmitNode=tt,e.enableSubstitution(213),e.enableSubstitution(215),e.enableSubstitution(80),e.enableSubstitution(226),e.enableSubstitution(304),e.enableEmitNotification(307);let R=[],L,F,J=[],G;return cg(e,q);function q(Z){if(Z.isDeclarationFile||!(ZC(Z,m)||Z.transformFlags&8388608||Kd(Z)&&G9(m)&&m.outFile))return Z;L=Z,F=AK(e,Z),R[pf(Z)]=F;let bt=t(x)(Z);return L=void 0,F=void 0,G=!1,bt}function ee(){return Oy(L.fileName)&&L.commonJsModuleIndicator&&(!L.externalModuleIndicator||L.externalModuleIndicator===!0)?!1:!!(!F.exportEquals&&nu(L))}function W(Z){s();let Ge=[],bt=J_(m,"alwaysStrict")||nu(L),Q=n.copyPrologue(Z.statements,Ge,bt&&!Kd(Z),le);if(ee()&&Bt(Ge,vt()),Pt(F.exportedNames))for(let Ue=0;Ue<F.exportedNames.length;Ue+=50)Bt(Ge,n.createExpressionStatement(L_(F.exportedNames.slice(Ue,Ue+50),(Te,Re)=>n.createAssignment(n.createPropertyAccessExpression(n.createIdentifier("exports"),n.createIdentifier(Nn(Re))),Te),n.createVoidZero())));for(let z of F.exportedFunctions)lt(Ge,z);Bt(Ge,ot(F.externalHelpersImportDeclaration,le,Vi)),wn(Ge,Kr(Z.statements,le,Vi,Q)),ne(Ge,!1),Ay(Ge,o());let Ke=n.updateSourceFile(Z,Et(n.createNodeArray(Ge),Z.statements));return E0(Ke,e.readEmitHelpers()),Ke}function pe(Z){let Ge=n.createIdentifier("define"),bt=y8(n,Z,S,m),Q=Kd(Z)&&Z,{aliasedModuleNames:Ke,unaliasedModuleNames:z,importAliasNames:Ue}=re(Z,!0),Te=n.updateSourceFile(Z,Et(n.createNodeArray([n.createExpressionStatement(n.createCallExpression(Ge,void 0,[...bt?[bt]:[],n.createArrayLiteralExpression(Q?ve:[n.createStringLiteral("require"),n.createStringLiteral("exports"),...Ke,...z]),Q?Q.statements.length?Q.statements[0].expression:n.createObjectLiteralExpression():n.createFunctionExpression(void 0,void 0,void 0,void 0,[n.createParameterDeclaration(void 0,void 0,"require"),n.createParameterDeclaration(void 0,void 0,"exports"),...Ue],void 0,ce(Z))]))]),Z.statements));return E0(Te,e.readEmitHelpers()),Te}function K(Z){let{aliasedModuleNames:Ge,unaliasedModuleNames:bt,importAliasNames:Q}=re(Z,!1),Ke=y8(n,Z,S,m),z=n.createFunctionExpression(void 0,void 0,void 0,void 0,[n.createParameterDeclaration(void 0,void 0,"factory")],void 0,Et(n.createBlock([n.createIfStatement(n.createLogicalAnd(n.createTypeCheck(n.createIdentifier("module"),"object"),n.createTypeCheck(n.createPropertyAccessExpression(n.createIdentifier("module"),"exports"),"object")),n.createBlock([n.createVariableStatement(void 0,[n.createVariableDeclaration("v",void 0,void 0,n.createCallExpression(n.createIdentifier("factory"),void 0,[n.createIdentifier("require"),n.createIdentifier("exports")]))]),Tn(n.createIfStatement(n.createStrictInequality(n.createIdentifier("v"),n.createIdentifier("undefined")),n.createExpressionStatement(n.createAssignment(n.createPropertyAccessExpression(n.createIdentifier("module"),"exports"),n.createIdentifier("v")))),1)]),n.createIfStatement(n.createLogicalAnd(n.createTypeCheck(n.createIdentifier("define"),"function"),n.createPropertyAccessExpression(n.createIdentifier("define"),"amd")),n.createBlock([n.createExpressionStatement(n.createCallExpression(n.createIdentifier("define"),void 0,[...Ke?[Ke]:[],n.createArrayLiteralExpression([n.createStringLiteral("require"),n.createStringLiteral("exports"),...Ge,...bt]),n.createIdentifier("factory")]))])))],!0),void 0)),Ue=n.updateSourceFile(Z,Et(n.createNodeArray([n.createExpressionStatement(n.createCallExpression(z,void 0,[n.createFunctionExpression(void 0,void 0,void 0,void 0,[n.createParameterDeclaration(void 0,void 0,"require"),n.createParameterDeclaration(void 0,void 0,"exports"),...Q],void 0,ce(Z))]))]),Z.statements));return E0(Ue,e.readEmitHelpers()),Ue}function re(Z,Ge){let bt=[],Q=[],Ke=[];for(let z of Z.amdDependencies)z.name?(bt.push(n.createStringLiteral(z.path)),Ke.push(n.createParameterDeclaration(void 0,void 0,z.name))):Q.push(n.createStringLiteral(z.path));for(let z of F.externalImports){let Ue=WA(n,z,L,S,d,m),Te=CN(n,z,L);Ue&&(Ge&&Te?(Tn(Te,8),bt.push(Ue),Ke.push(n.createParameterDeclaration(void 0,void 0,Te))):Q.push(Ue))}return{aliasedModuleNames:bt,unaliasedModuleNames:Q,importAliasNames:Ke}}function ue(Z){if(ru(Z)||xl(Z)||!WA(n,Z,L,S,d,m))return;let Ge=CN(n,Z,L),bt=Cs(Z,Ge);if(bt!==Ge)return n.createExpressionStatement(n.createAssignment(Ge,bt))}function ce(Z){s();let Ge=[],bt=n.copyPrologue(Z.statements,Ge,!0,le);ee()&&Bt(Ge,vt()),Pt(F.exportedNames)&&Bt(Ge,n.createExpressionStatement(L_(F.exportedNames,(Ke,z)=>n.createAssignment(n.createPropertyAccessExpression(n.createIdentifier("exports"),n.createIdentifier(Nn(z))),Ke),n.createVoidZero())));for(let Ke of F.exportedFunctions)lt(Ge,Ke);Bt(Ge,ot(F.externalHelpersImportDeclaration,le,Vi)),x===2&&wn(Ge,Gi(F.externalImports,ue)),wn(Ge,Kr(Z.statements,le,Vi,bt)),ne(Ge,!0),Ay(Ge,o());let Q=n.createBlock(Ge,!0);return G&&NA(Q,zEt),Q}function ne(Z,Ge){if(F.exportEquals){let bt=ot(F.exportEquals.expression,Ae,Ct);if(bt)if(Ge){let Q=n.createReturnStatement(bt);Et(Q,F.exportEquals),Tn(Q,3840),Z.push(Q)}else{let Q=n.createExpressionStatement(n.createAssignment(n.createPropertyAccessExpression(n.createIdentifier("module"),"exports"),bt));Et(Q,F.exportEquals),Tn(Q,3072),Z.push(Q)}}}function le(Z){switch(Z.kind){case 272:return ss(Z);case 271:return $r(Z);case 278:return Xs(Z);case 277:return $e(Z);default:return me(Z)}}function me(Z){switch(Z.kind){case 243:return An(Z);case 262:return Yt(Z);case 263:return Vr(Z);case 248:return be(Z,!0);case 249:return Ve(Z);case 250:return Pe(Z);case 246:return ke(Z);case 247:return De(Z);case 256:return Be(Z);case 254:return ct(Z);case 245:return qe(Z);case 255:return et(Z);case 269:return Ie(Z);case 296:return _t(Z);case 297:return mt(Z);case 258:return Xe(Z);case 299:return ht(Z);case 241:return rr(Z);default:return Ae(Z)}}function de(Z,Ge){if(!(Z.transformFlags&276828160))return Z;switch(Z.kind){case 248:return be(Z,!1);case 244:return vr(Z);case 217:return xr(Z,Ge);case 354:return jr(Z,Ge);case 213:if(Np(Z)&&L.impliedNodeFormat===void 0)return or(Z);break;case 226:if(Dv(Z))return he(Z,Ge);break;case 224:case 225:return ur(Z,Ge)}return Mr(Z,Ae,e)}function Ae(Z){return de(Z,!1)}function xe(Z){return de(Z,!0)}function te(Z){if(Ca(Z))for(let Ge of Z.properties)switch(Ge.kind){case 303:if(te(Ge.initializer))return!0;break;case 304:if(te(Ge.name))return!0;break;case 305:if(te(Ge.expression))return!0;break;case 174:case 177:case 178:return!1;default:M.assertNever(Ge,"Unhandled object member kind")}else if(Gu(Z)){for(let Ge of Z.elements)if(Ad(Ge)){if(te(Ge.expression))return!0}else if(te(Ge))return!0}else if(He(Z))return wt(nr(Z))>(Wj(Z)?1:0);return!1}function he(Z,Ge){return te(Z.left)?y2(Z,Ae,e,0,!Ge,vi):Mr(Z,Ae,e)}function be(Z,Ge){if(Ge&&Z.initializer&&Ru(Z.initializer)&&!(Z.initializer.flags&7)){let bt=yr(void 0,Z.initializer,!1);if(bt){let Q=[],Ke=ot(Z.initializer,xe,Ru),z=n.createVariableStatement(void 0,Ke);Q.push(z),wn(Q,bt);let Ue=ot(Z.condition,Ae,Ct),Te=ot(Z.incrementor,xe,Ct),Re=ff(Z.statement,Ge?me:Ae,e);return Q.push(n.updateForStatement(Z,void 0,Ue,Te,Re)),Q}}return n.updateForStatement(Z,ot(Z.initializer,xe,Sd),ot(Z.condition,Ae,Ct),ot(Z.incrementor,xe,Ct),ff(Z.statement,Ge?me:Ae,e))}function Ve(Z){if(Ru(Z.initializer)&&!(Z.initializer.flags&7)){let Ge=yr(void 0,Z.initializer,!0);if(Pt(Ge)){let bt=ot(Z.initializer,xe,Sd),Q=ot(Z.expression,Ae,Ct),Ke=ff(Z.statement,me,e),z=Vs(Ke)?n.updateBlock(Ke,[...Ge,...Ke.statements]):n.createBlock([...Ge,Ke],!0);return n.updateForInStatement(Z,bt,Q,z)}}return n.updateForInStatement(Z,ot(Z.initializer,xe,Sd),ot(Z.expression,Ae,Ct),ff(Z.statement,me,e))}function Pe(Z){if(Ru(Z.initializer)&&!(Z.initializer.flags&7)){let Ge=yr(void 0,Z.initializer,!0),bt=ot(Z.initializer,xe,Sd),Q=ot(Z.expression,Ae,Ct),Ke=ff(Z.statement,me,e);return Pt(Ge)&&(Ke=Vs(Ke)?n.updateBlock(Ke,[...Ge,...Ke.statements]):n.createBlock([...Ge,Ke],!0)),n.updateForOfStatement(Z,Z.awaitModifier,bt,Q,Ke)}return n.updateForOfStatement(Z,Z.awaitModifier,ot(Z.initializer,xe,Sd),ot(Z.expression,Ae,Ct),ff(Z.statement,me,e))}function ke(Z){return n.updateDoStatement(Z,ff(Z.statement,me,e),ot(Z.expression,Ae,Ct))}function De(Z){return n.updateWhileStatement(Z,ot(Z.expression,Ae,Ct),ff(Z.statement,me,e))}function Be(Z){return n.updateLabeledStatement(Z,Z.label,M.checkDefined(ot(Z.statement,me,Vi,n.liftToBlock)))}function ct(Z){return n.updateWithStatement(Z,ot(Z.expression,Ae,Ct),M.checkDefined(ot(Z.statement,me,Vi,n.liftToBlock)))}function qe(Z){return n.updateIfStatement(Z,ot(Z.expression,Ae,Ct),M.checkDefined(ot(Z.thenStatement,me,Vi,n.liftToBlock)),ot(Z.elseStatement,me,Vi,n.liftToBlock))}function et(Z){return n.updateSwitchStatement(Z,ot(Z.expression,Ae,Ct),M.checkDefined(ot(Z.caseBlock,me,DO)))}function Ie(Z){return n.updateCaseBlock(Z,Kr(Z.clauses,me,M5))}function _t(Z){return n.updateCaseClause(Z,ot(Z.expression,Ae,Ct),Kr(Z.statements,me,Vi))}function mt(Z){return Mr(Z,me,e)}function Xe(Z){return Mr(Z,me,e)}function ht(Z){return n.updateCatchClause(Z,Z.variableDeclaration,M.checkDefined(ot(Z.block,me,Vs)))}function rr(Z){return Z=Mr(Z,me,e),Z}function vr(Z){return n.updateExpressionStatement(Z,ot(Z.expression,xe,Ct))}function xr(Z,Ge){return n.updateParenthesizedExpression(Z,ot(Z.expression,Ge?xe:Ae,Ct))}function jr(Z,Ge){return n.updatePartiallyEmittedExpression(Z,ot(Z.expression,Ge?xe:Ae,Ct))}function ur(Z,Ge){if((Z.operator===46||Z.operator===47)&&He(Z.operand)&&!xc(Z.operand)&&!k0(Z.operand)&&!aG(Z.operand)){let bt=nr(Z.operand);if(bt){let Q,Ke=ot(Z.operand,Ae,Ct);tS(Z)?Ke=n.updatePrefixUnaryExpression(Z,Ke):(Ke=n.updatePostfixUnaryExpression(Z,Ke),Ge||(Q=n.createTempVariable(u),Ke=n.createAssignment(Q,Ke),Et(Ke,Z)),Ke=n.createComma(Ke,n.cloneNode(Z.operand)),Et(Ke,Z));for(let z of bt)J[yo(Ke)]=!0,Ke=nt(z,Ke),Et(Ke,Z);return Q&&(J[yo(Ke)]=!0,Ke=n.createComma(Ke,Q),Et(Ke,Z)),Ke}}return Mr(Z,Ae,e)}function or(Z){if(x===0&&E>=7)return Mr(Z,Ae,e);let Ge=WA(n,Z,L,S,d,m),bt=ot(xo(Z.arguments),Ae,Ct),Q=Ge&&(!bt||!La(bt)||bt.text!==Ge.text)?Ge:bt,Ke=!!(Z.transformFlags&16384);switch(m.module){case 2:return Oi(Q,Ke);case 3:return Zr(Q??n.createVoidZero(),Ke);case 1:default:return Sr(Q)}}function Zr(Z,Ge){if(G=!0,xE(Z)){let bt=xc(Z)?Z:La(Z)?n.createStringLiteralFromNode(Z):Tn(Et(n.cloneNode(Z),Z),3072);return n.createConditionalExpression(n.createIdentifier("__syncRequire"),void 0,Sr(Z),void 0,Oi(bt,Ge))}else{let bt=n.createTempVariable(u);return n.createComma(n.createAssignment(bt,Z),n.createConditionalExpression(n.createIdentifier("__syncRequire"),void 0,Sr(bt,!0),void 0,Oi(bt,Ge)))}}function Oi(Z,Ge){let bt=n.createUniqueName("resolve"),Q=n.createUniqueName("reject"),Ke=[n.createParameterDeclaration(void 0,void 0,bt),n.createParameterDeclaration(void 0,void 0,Q)],z=n.createBlock([n.createExpressionStatement(n.createCallExpression(n.createIdentifier("require"),void 0,[n.createArrayLiteralExpression([Z||n.createOmittedExpression()]),bt,Q]))]),Ue;E>=2?Ue=n.createArrowFunction(void 0,void 0,Ke,void 0,void 0,z):(Ue=n.createFunctionExpression(void 0,void 0,void 0,void 0,Ke,void 0,z),Ge&&Tn(Ue,16));let Te=n.createNewExpression(n.createIdentifier("Promise"),void 0,[Ue]);return Iy(m)?n.createCallExpression(n.createPropertyAccessExpression(Te,n.createIdentifier("then")),void 0,[i().createImportStarCallbackHelper()]):Te}function Sr(Z,Ge){let bt=Z&&!Qg(Z)&&!Ge,Q=n.createCallExpression(n.createPropertyAccessExpression(n.createIdentifier("Promise"),"resolve"),void 0,bt?E>=2?[n.createTemplateExpression(n.createTemplateHead(""),[n.createTemplateSpan(Z,n.createTemplateTail(""))])]:[n.createCallExpression(n.createPropertyAccessExpression(n.createStringLiteral(""),"concat"),void 0,[Z])]:[]),Ke=n.createCallExpression(n.createIdentifier("require"),void 0,bt?[n.createIdentifier("s")]:Z?[Z]:[]);Iy(m)&&(Ke=i().createImportStarHelper(Ke));let z=bt?[n.createParameterDeclaration(void 0,void 0,"s")]:[],Ue;return E>=2?Ue=n.createArrowFunction(void 0,void 0,z,void 0,void 0,Ke):Ue=n.createFunctionExpression(void 0,void 0,void 0,void 0,z,void 0,n.createBlock([n.createReturnStatement(Ke)])),n.createCallExpression(n.createPropertyAccessExpression(Q,"then"),void 0,[Ue])}function Pi(Z,Ge){return!Iy(m)||Pm(Z)&2?Ge:Wge(Z)?i().createImportStarHelper(Ge):Ge}function Cs(Z,Ge){return!Iy(m)||Pm(Z)&2?Ge:PB(Z)?i().createImportStarHelper(Ge):CK(Z)?i().createImportDefaultHelper(Ge):Ge}function ss(Z){let Ge,bt=KP(Z);if(x!==2)if(Z.importClause){let Q=[];bt&&!aA(Z)?Q.push(n.createVariableDeclaration(n.cloneNode(bt.name),void 0,void 0,Cs(Z,Ii(Z)))):(Q.push(n.createVariableDeclaration(n.getGeneratedNameForNode(Z),void 0,void 0,Cs(Z,Ii(Z)))),bt&&aA(Z)&&Q.push(n.createVariableDeclaration(n.cloneNode(bt.name),void 0,void 0,n.getGeneratedNameForNode(Z)))),Ge=Bt(Ge,zn(Et(n.createVariableStatement(void 0,n.createVariableDeclarationList(Q,E>=2?2:0)),Z),Z))}else return zn(Et(n.createExpressionStatement(Ii(Z)),Z),Z);else bt&&aA(Z)&&(Ge=Bt(Ge,n.createVariableStatement(void 0,n.createVariableDeclarationList([zn(Et(n.createVariableDeclaration(n.cloneNode(bt.name),void 0,void 0,n.getGeneratedNameForNode(Z)),Z),Z)],E>=2?2:0))));return Ge=Ui(Ge,Z),wh(Ge)}function Ii(Z){let Ge=WA(n,Z,L,S,d,m),bt=[];return Ge&&bt.push(Ge),n.createCallExpression(n.createIdentifier("require"),void 0,bt)}function $r(Z){M.assert(cb(Z),"import= for internal module references should be handled in an earlier transformer.");let Ge;return x!==2?li(Z,32)?Ge=Bt(Ge,zn(Et(n.createExpressionStatement(nt(Z.name,Ii(Z))),Z),Z)):Ge=Bt(Ge,zn(Et(n.createVariableStatement(void 0,n.createVariableDeclarationList([n.createVariableDeclaration(n.cloneNode(Z.name),void 0,void 0,Ii(Z))],E>=2?2:0)),Z),Z)):li(Z,32)&&(Ge=Bt(Ge,zn(Et(n.createExpressionStatement(nt(n.getExportName(Z),n.getLocalName(Z))),Z),Z))),Ge=la(Ge,Z),wh(Ge)}function Xs(Z){if(!Z.moduleSpecifier)return;let Ge=n.getGeneratedNameForNode(Z);if(Z.exportClause&&kd(Z.exportClause)){let bt=[];x!==2&&bt.push(zn(Et(n.createVariableStatement(void 0,n.createVariableDeclarationList([n.createVariableDeclaration(Ge,void 0,void 0,Ii(Z))])),Z),Z));for(let Q of Z.exportClause.elements){let Ke=!!Iy(m)&&!(Pm(Z)&2)&&Nn(Q.propertyName||Q.name)==="default",z=n.createPropertyAccessExpression(Ke?i().createImportDefaultHelper(Ge):Ge,Q.propertyName||Q.name);bt.push(zn(Et(n.createExpressionStatement(nt(n.getExportName(Q),z,void 0,!0)),Q),Q))}return wh(bt)}else if(Z.exportClause){let bt=[];return bt.push(zn(Et(n.createExpressionStatement(nt(n.cloneNode(Z.exportClause.name),Pi(Z,x!==2?Ii(Z):H5(Z)?Ge:n.createIdentifier(Nn(Z.exportClause.name))))),Z),Z)),wh(bt)}else return zn(Et(n.createExpressionStatement(i().createExportStarHelper(x!==2?Ii(Z):Ge)),Z),Z)}function $e(Z){if(!Z.isExportEquals)return Ce(n.createIdentifier("default"),ot(Z.expression,Ae,Ct),Z,!0)}function Yt(Z){let Ge;return li(Z,32)?Ge=Bt(Ge,zn(Et(n.createFunctionDeclaration(Kr(Z.modifiers,Me,Pa),Z.asteriskToken,n.getDeclarationName(Z,!0,!0),void 0,Kr(Z.parameters,Ae,ns),void 0,Mr(Z.body,Ae,e)),Z),Z)):Ge=Bt(Ge,Mr(Z,Ae,e)),wh(Ge)}function Vr(Z){let Ge;return li(Z,32)?Ge=Bt(Ge,zn(Et(n.createClassDeclaration(Kr(Z.modifiers,Me,Cc),n.getDeclarationName(Z,!0,!0),void 0,Kr(Z.heritageClauses,Ae,pp),Kr(Z.members,Ae,uu)),Z),Z)):Ge=Bt(Ge,Mr(Z,Ae,e)),Ge=lt(Ge,Z),wh(Ge)}function An(Z){let Ge,bt,Q;if(li(Z,32)){let Ke,z=!1;for(let Ue of Z.declarationList.declarations)if(He(Ue.name)&&k0(Ue.name))if(Ke||(Ke=Kr(Z.modifiers,Me,Pa)),Ue.initializer){let Te=n.updateVariableDeclaration(Ue,Ue.name,void 0,void 0,nt(Ue.name,ot(Ue.initializer,Ae,Ct)));bt=Bt(bt,Te)}else bt=Bt(bt,Ue);else if(Ue.initializer)if(!Hs(Ue.name)&&(pc(Ue.initializer)||ic(Ue.initializer)||eu(Ue.initializer))){let Te=n.createAssignment(Et(n.createPropertyAccessExpression(n.createIdentifier("exports"),Ue.name),Ue.name),n.createIdentifier(Qd(Ue.name))),Re=n.createVariableDeclaration(Ue.name,Ue.exclamationToken,Ue.type,ot(Ue.initializer,Ae,Ct));bt=Bt(bt,Re),Q=Bt(Q,Te),z=!0}else Q=Bt(Q,Ci(Ue));if(bt&&(Ge=Bt(Ge,n.updateVariableStatement(Z,Ke,n.updateVariableDeclarationList(Z.declarationList,bt)))),Q){let Ue=zn(Et(n.createExpressionStatement(n.inlineExpressions(Q)),Z),Z);z&&n8(Ue),Ge=Bt(Ge,Ue)}}else Ge=Bt(Ge,Mr(Z,Ae,e));return Ge=Gs(Ge,Z),wh(Ge)}function vi(Z,Ge,bt){let Q=nr(Z);if(Q){let Ke=Wj(Z)?Ge:n.createAssignment(Z,Ge);for(let z of Q)Tn(Ke,8),Ke=nt(z,Ke,bt);return Ke}return n.createAssignment(Z,Ge)}function Ci(Z){return Hs(Z.name)?y2(ot(Z,Ae,qR),Ae,e,0,!1,vi):n.createAssignment(Et(n.createPropertyAccessExpression(n.createIdentifier("exports"),Z.name),Z.name),Z.initializer?ot(Z.initializer,Ae,Ct):n.createVoidZero())}function Ui(Z,Ge){if(F.exportEquals)return Z;let bt=Ge.importClause;if(!bt)return Z;let Q=new LN;bt.name&&(Z=St(Z,Q,bt));let Ke=bt.namedBindings;if(Ke)switch(Ke.kind){case 274:Z=St(Z,Q,Ke);break;case 275:for(let z of Ke.elements)Z=St(Z,Q,z,!0);break}return Z}function la(Z,Ge){return F.exportEquals?Z:St(Z,new LN,Ge)}function Gs(Z,Ge){return yr(Z,Ge.declarationList,!1)}function yr(Z,Ge,bt){if(F.exportEquals)return Z;for(let Q of Ge.declarations)Z=to(Z,Q,bt);return Z}function to(Z,Ge,bt){if(F.exportEquals)return Z;if(Hs(Ge.name))for(let Q of Ge.name.elements)pu(Q)||(Z=to(Z,Q,bt));else!xc(Ge.name)&&(!Ei(Ge)||Ge.initializer||bt)&&(Z=St(Z,new LN,Ge));return Z}function lt(Z,Ge){if(F.exportEquals)return Z;let bt=new LN;if(li(Ge,32)){let Q=li(Ge,2048)?n.createIdentifier("default"):n.getDeclarationName(Ge);Z=fe(Z,bt,Q,n.getLocalName(Ge),Ge)}return Ge.name&&(Z=St(Z,bt,Ge)),Z}function St(Z,Ge,bt,Q){let Ke=n.getDeclarationName(bt),z=F.exportSpecifiers.get(Ke);if(z)for(let Ue of z)Z=fe(Z,Ge,Ue.name,Ke,Ue.name,void 0,Q);return Z}function fe(Z,Ge,bt,Q,Ke,z,Ue){return Ge.has(bt)||(Ge.set(bt,!0),Z=Bt(Z,Ce(bt,Q,Ke,z,Ue))),Z}function vt(){let Z=n.createExpressionStatement(n.createCallExpression(n.createPropertyAccessExpression(n.createIdentifier("Object"),"defineProperty"),void 0,[n.createIdentifier("exports"),n.createStringLiteral("__esModule"),n.createObjectLiteralExpression([n.createPropertyAssignment("value",n.createTrue())])]));return Tn(Z,2097152),Z}function Ce(Z,Ge,bt,Q,Ke){let z=Et(n.createExpressionStatement(nt(Z,Ge,void 0,Ke)),bt);return T_(z),Q||Tn(z,3072),z}function nt(Z,Ge,bt,Q){return Et(Q?n.createCallExpression(n.createPropertyAccessExpression(n.createIdentifier("Object"),"defineProperty"),void 0,[n.createIdentifier("exports"),n.createStringLiteralFromNode(Z),n.createObjectLiteralExpression([n.createPropertyAssignment("enumerable",n.createTrue()),n.createPropertyAssignment("get",n.createFunctionExpression(void 0,void 0,void 0,void 0,[],void 0,n.createBlock([n.createReturnStatement(Ge)])))])]):n.createAssignment(n.createPropertyAccessExpression(n.createIdentifier("exports"),n.cloneNode(Z)),Ge),bt)}function Me(Z){switch(Z.kind){case 95:case 90:return}return Z}function tt(Z,Ge,bt){Ge.kind===307?(L=Ge,F=R[pf(L)],w(Z,Ge,bt),L=void 0,F=void 0):w(Z,Ge,bt)}function ft(Z,Ge){return Ge=D(Z,Ge),Ge.id&&J[Ge.id]?Ge:Z===1?Oe(Ge):p_(Ge)?tr(Ge):Ge}function tr(Z){let Ge=Z.name,bt=Ut(Ge);if(bt!==Ge){if(Z.objectAssignmentInitializer){let Q=n.createAssignment(bt,Z.objectAssignmentInitializer);return Et(n.createPropertyAssignment(Ge,Q),Z)}return Et(n.createPropertyAssignment(Ge,bt),Z)}return Z}function Oe(Z){switch(Z.kind){case 80:return Ut(Z);case 213:return At(Z);case 215:return Nt(Z);case 226:return Rt(Z)}return Z}function At(Z){if(He(Z.expression)){let Ge=Ut(Z.expression);if(J[yo(Ge)]=!0,!He(Ge)&&!(Ga(Z.expression)&8192))return kA(n.updateCallExpression(Z,Ge,void 0,Z.arguments),16)}return Z}function Nt(Z){if(He(Z.tag)){let Ge=Ut(Z.tag);if(J[yo(Ge)]=!0,!He(Ge)&&!(Ga(Z.tag)&8192))return kA(n.updateTaggedTemplateExpression(Z,Ge,void 0,Z.template),16)}return Z}function Ut(Z){var Ge,bt;if(Ga(Z)&8192){let Q=Hj(L);return Q?n.createPropertyAccessExpression(Q,Z):Z}else if(!(xc(Z)&&!(Z.emitNode.autoGenerate.flags&64))&&!k0(Z)){let Q=d.getReferencedExportContainer(Z,Wj(Z));if(Q&&Q.kind===307)return Et(n.createPropertyAccessExpression(n.createIdentifier("exports"),n.cloneNode(Z)),Z);let Ke=d.getReferencedImportDeclaration(Z);if(Ke){if(ig(Ke))return Et(n.createPropertyAccessExpression(n.getGeneratedNameForNode(Ke.parent),n.createIdentifier("default")),Z);if(_f(Ke)){let z=Ke.propertyName||Ke.name;return Et(n.createPropertyAccessExpression(n.getGeneratedNameForNode(((bt=(Ge=Ke.parent)==null?void 0:Ge.parent)==null?void 0:bt.parent)||Ke),n.cloneNode(z)),Z)}}}return Z}function Rt(Z){if(y0(Z.operatorToken.kind)&&He(Z.left)&&(!xc(Z.left)||F3(Z.left))&&!k0(Z.left)){let Ge=nr(Z.left);if(Ge){let bt=Z;for(let Q of Ge)J[yo(bt)]=!0,bt=nt(Q,bt,Z);return bt}}return Z}function nr(Z){if(xc(Z)){if(F3(Z)){let Ge=F?.exportSpecifiers.get(Z);if(Ge){let bt=[];for(let Q of Ge)bt.push(Q.name);return bt}}}else{let Ge=d.getReferencedImportDeclaration(Z);if(Ge)return F?.exportedBindings[pf(Ge)];let bt=new Set,Q=d.getReferencedValueDeclarations(Z);if(Q){for(let Ke of Q){let z=F?.exportedBindings[pf(Ke)];if(z)for(let Ue of z)bt.add(Ue)}if(bt.size)return Is(bt)}}}}var zEt={name:"typescript:dynamicimport-sync-require",scoped:!0,text:`
            var __syncRequire = typeof module === "object" && typeof module.exports === "object";`};function Che(e){let{factory:t,startLexicalEnvironment:n,endLexicalEnvironment:i,hoistVariableDeclaration:s}=e,o=e.getCompilerOptions(),u=e.getEmitResolver(),m=e.getEmitHost(),d=e.onSubstituteNode,S=e.onEmitNode;e.onSubstituteNode=nt,e.onEmitNode=Ce,e.enableSubstitution(80),e.enableSubstitution(304),e.enableSubstitution(226),e.enableSubstitution(236),e.enableEmitNotification(307);let E=[],x=[],D=[],w=[],R,L,F,J,G,q,ee;return cg(e,W);function W(Z){if(Z.isDeclarationFile||!(ZC(Z,o)||Z.transformFlags&8388608))return Z;let Ge=pf(Z);R=Z,q=Z,L=E[Ge]=AK(e,Z),F=t.createUniqueName("exports"),x[Ge]=F,J=w[Ge]=t.createUniqueName("context");let bt=pe(L.externalImports),Q=K(Z,bt),Ke=t.createFunctionExpression(void 0,void 0,void 0,void 0,[t.createParameterDeclaration(void 0,void 0,F),t.createParameterDeclaration(void 0,void 0,J)],void 0,Q),z=y8(t,Z,m,o),Ue=t.createArrayLiteralExpression(Cr(bt,Re=>Re.name)),Te=Tn(t.updateSourceFile(Z,Et(t.createNodeArray([t.createExpressionStatement(t.createCallExpression(t.createPropertyAccessExpression(t.createIdentifier("System"),"register"),void 0,z?[z,Ue,Ke]:[Ue,Ke]))]),Z.statements)),2048);return o.outFile||Zpe(Te,Q,Re=>!Re.scoped),ee&&(D[Ge]=ee,ee=void 0),R=void 0,L=void 0,F=void 0,J=void 0,G=void 0,q=void 0,Te}function pe(Z){let Ge=new Map,bt=[];for(let Q of Z){let Ke=WA(t,Q,R,m,u,o);if(Ke){let z=Ke.text,Ue=Ge.get(z);Ue!==void 0?bt[Ue].externalImports.push(Q):(Ge.set(z,bt.length),bt.push({name:Ke,externalImports:[Q]}))}}return bt}function K(Z,Ge){let bt=[];n();let Q=J_(o,"alwaysStrict")||nu(R),Ke=t.copyPrologue(Z.statements,bt,Q,ne);bt.push(t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration("__moduleName",void 0,void 0,t.createLogicalAnd(J,t.createPropertyAccessExpression(J,"id")))]))),ot(L.externalHelpersImportDeclaration,ne,Vi);let z=Kr(Z.statements,ne,Vi,Ke);wn(bt,G),Ay(bt,i());let Ue=re(bt),Te=Z.transformFlags&2097152?t.createModifiersFromModifierFlags(1024):void 0,Re=t.createObjectLiteralExpression([t.createPropertyAssignment("setters",ce(Ue,Ge)),t.createPropertyAssignment("execute",t.createFunctionExpression(Te,void 0,void 0,void 0,[],void 0,t.createBlock(z,!0)))],!0);return bt.push(t.createReturnStatement(Re)),t.createBlock(bt,!0)}function re(Z){if(!L.hasExportStarsToExportValues)return;if(!Pt(L.exportedNames)&&L.exportedFunctions.size===0&&L.exportSpecifiers.size===0){let Ke=!1;for(let z of L.externalImports)if(z.kind===278&&z.exportClause){Ke=!0;break}if(!Ke){let z=ue(void 0);return Z.push(z),z.name}}let Ge=[];if(L.exportedNames)for(let Ke of L.exportedNames)Ke.escapedText!=="default"&&Ge.push(t.createPropertyAssignment(t.createStringLiteralFromNode(Ke),t.createTrue()));for(let Ke of L.exportedFunctions)li(Ke,2048)||(M.assert(!!Ke.name),Ge.push(t.createPropertyAssignment(t.createStringLiteralFromNode(Ke.name),t.createTrue())));let bt=t.createUniqueName("exportedNames");Z.push(t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(bt,void 0,void 0,t.createObjectLiteralExpression(Ge,!0))])));let Q=ue(bt);return Z.push(Q),Q.name}function ue(Z){let Ge=t.createUniqueName("exportStar"),bt=t.createIdentifier("m"),Q=t.createIdentifier("n"),Ke=t.createIdentifier("exports"),z=t.createStrictInequality(Q,t.createStringLiteral("default"));return Z&&(z=t.createLogicalAnd(z,t.createLogicalNot(t.createCallExpression(t.createPropertyAccessExpression(Z,"hasOwnProperty"),void 0,[Q])))),t.createFunctionDeclaration(void 0,void 0,Ge,void 0,[t.createParameterDeclaration(void 0,void 0,bt)],void 0,t.createBlock([t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(Ke,void 0,void 0,t.createObjectLiteralExpression([]))])),t.createForInStatement(t.createVariableDeclarationList([t.createVariableDeclaration(Q)]),bt,t.createBlock([Tn(t.createIfStatement(z,t.createExpressionStatement(t.createAssignment(t.createElementAccessExpression(Ke,Q),t.createElementAccessExpression(bt,Q)))),1)])),t.createExpressionStatement(t.createCallExpression(F,void 0,[Ke]))],!0))}function ce(Z,Ge){let bt=[];for(let Q of Ge){let Ke=kt(Q.externalImports,Te=>CN(t,Te,R)),z=Ke?t.getGeneratedNameForNode(Ke):t.createUniqueName(""),Ue=[];for(let Te of Q.externalImports){let Re=CN(t,Te,R);switch(Te.kind){case 272:if(!Te.importClause)break;case 271:M.assert(Re!==void 0),Ue.push(t.createExpressionStatement(t.createAssignment(Re,z))),li(Te,32)&&Ue.push(t.createExpressionStatement(t.createCallExpression(F,void 0,[t.createStringLiteral(Nn(Re)),z])));break;case 278:if(M.assert(Re!==void 0),Te.exportClause)if(kd(Te.exportClause)){let It=[];for(let $t of Te.exportClause.elements)It.push(t.createPropertyAssignment(t.createStringLiteral(Nn($t.name)),t.createElementAccessExpression(z,t.createStringLiteral(Nn($t.propertyName||$t.name)))));Ue.push(t.createExpressionStatement(t.createCallExpression(F,void 0,[t.createObjectLiteralExpression(It,!0)])))}else Ue.push(t.createExpressionStatement(t.createCallExpression(F,void 0,[t.createStringLiteral(Nn(Te.exportClause.name)),z])));else Ue.push(t.createExpressionStatement(t.createCallExpression(Z,void 0,[z])));break}}bt.push(t.createFunctionExpression(void 0,void 0,void 0,void 0,[t.createParameterDeclaration(void 0,void 0,z)],void 0,t.createBlock(Ue,!0)))}return t.createArrayLiteralExpression(bt,!0)}function ne(Z){switch(Z.kind){case 272:return le(Z);case 271:return de(Z);case 278:return me(Z);case 277:return Ae(Z);default:return vr(Z)}}function le(Z){let Ge;return Z.importClause&&s(CN(t,Z,R)),wh(ct(Ge,Z))}function me(Z){M.assertIsDefined(Z)}function de(Z){M.assert(cb(Z),"import= for internal module references should be handled in an earlier transformer.");let Ge;return s(CN(t,Z,R)),wh(qe(Ge,Z))}function Ae(Z){if(Z.isExportEquals)return;let Ge=ot(Z.expression,Ci,Ct);return ht(t.createIdentifier("default"),Ge,!0)}function xe(Z){li(Z,32)?G=Bt(G,t.updateFunctionDeclaration(Z,Kr(Z.modifiers,vt,Cc),Z.asteriskToken,t.getDeclarationName(Z,!0,!0),void 0,Kr(Z.parameters,Ci,ns),void 0,ot(Z.body,Ci,Vs))):G=Bt(G,Mr(Z,Ci,e)),G=_t(G,Z)}function te(Z){let Ge,bt=t.getLocalName(Z);return s(bt),Ge=Bt(Ge,Et(t.createExpressionStatement(t.createAssignment(bt,Et(t.createClassExpression(Kr(Z.modifiers,vt,Cc),Z.name,void 0,Kr(Z.heritageClauses,Ci,pp),Kr(Z.members,Ci,uu)),Z))),Z)),Ge=_t(Ge,Z),wh(Ge)}function he(Z){if(!Ve(Z.declarationList))return ot(Z,Ci,Vi);let Ge;if(rR(Z.declarationList)||tR(Z.declarationList)){let bt=Kr(Z.modifiers,vt,Cc),Q=[];for(let z of Z.declarationList.declarations)Q.push(t.updateVariableDeclaration(z,t.getGeneratedNameForNode(z.name),void 0,void 0,Pe(z,!1)));let Ke=t.updateVariableDeclarationList(Z.declarationList,Q);Ge=Bt(Ge,t.updateVariableStatement(Z,bt,Ke))}else{let bt,Q=li(Z,32);for(let Ke of Z.declarationList.declarations)Ke.initializer?bt=Bt(bt,Pe(Ke,Q)):be(Ke);bt&&(Ge=Bt(Ge,Et(t.createExpressionStatement(t.inlineExpressions(bt)),Z)))}return Ge=et(Ge,Z,!1),wh(Ge)}function be(Z){if(Hs(Z.name))for(let Ge of Z.name.elements)pu(Ge)||be(Ge);else s(t.cloneNode(Z.name))}function Ve(Z){return(Ga(Z)&4194304)===0&&(q.kind===307||(Bc(Z).flags&7)===0)}function Pe(Z,Ge){let bt=Ge?ke:De;return Hs(Z.name)?y2(Z,Ci,e,0,!1,bt):Z.initializer?bt(Z.name,ot(Z.initializer,Ci,Ct)):Z.name}function ke(Z,Ge,bt){return Be(Z,Ge,bt,!0)}function De(Z,Ge,bt){return Be(Z,Ge,bt,!1)}function Be(Z,Ge,bt,Q){return s(t.cloneNode(Z)),Q?rr(Z,Rt(Et(t.createAssignment(Z,Ge),bt))):Rt(Et(t.createAssignment(Z,Ge),bt))}function ct(Z,Ge){if(L.exportEquals)return Z;let bt=Ge.importClause;if(!bt)return Z;bt.name&&(Z=mt(Z,bt));let Q=bt.namedBindings;if(Q)switch(Q.kind){case 274:Z=mt(Z,Q);break;case 275:for(let Ke of Q.elements)Z=mt(Z,Ke);break}return Z}function qe(Z,Ge){return L.exportEquals?Z:mt(Z,Ge)}function et(Z,Ge,bt){if(L.exportEquals)return Z;for(let Q of Ge.declarationList.declarations)(Q.initializer||bt)&&(Z=Ie(Z,Q,bt));return Z}function Ie(Z,Ge,bt){if(L.exportEquals)return Z;if(Hs(Ge.name))for(let Q of Ge.name.elements)pu(Q)||(Z=Ie(Z,Q,bt));else if(!xc(Ge.name)){let Q;bt&&(Z=Xe(Z,Ge.name,t.getLocalName(Ge)),Q=Nn(Ge.name)),Z=mt(Z,Ge,Q)}return Z}function _t(Z,Ge){if(L.exportEquals)return Z;let bt;if(li(Ge,32)){let Q=li(Ge,2048)?t.createStringLiteral("default"):Ge.name;Z=Xe(Z,Q,t.getLocalName(Ge)),bt=Qd(Q)}return Ge.name&&(Z=mt(Z,Ge,bt)),Z}function mt(Z,Ge,bt){if(L.exportEquals)return Z;let Q=t.getDeclarationName(Ge),Ke=L.exportSpecifiers.get(Q);if(Ke)for(let z of Ke)z.name.escapedText!==bt&&(Z=Xe(Z,z.name,Q));return Z}function Xe(Z,Ge,bt,Q){return Z=Bt(Z,ht(Ge,bt,Q)),Z}function ht(Z,Ge,bt){let Q=t.createExpressionStatement(rr(Z,Ge));return T_(Q),bt||Tn(Q,3072),Q}function rr(Z,Ge){let bt=He(Z)?t.createStringLiteralFromNode(Z):Z;return Tn(Ge,Ga(Ge)|3072),Zl(t.createCallExpression(F,void 0,[bt,Ge]),Ge)}function vr(Z){switch(Z.kind){case 243:return he(Z);case 262:return xe(Z);case 263:return te(Z);case 248:return xr(Z,!0);case 249:return jr(Z);case 250:return ur(Z);case 246:return Oi(Z);case 247:return Sr(Z);case 256:return Pi(Z);case 254:return Cs(Z);case 245:return ss(Z);case 255:return Ii(Z);case 269:return $r(Z);case 296:return Xs(Z);case 297:return $e(Z);case 258:return Yt(Z);case 299:return Vr(Z);case 241:return An(Z);default:return Ci(Z)}}function xr(Z,Ge){let bt=q;return q=Z,Z=t.updateForStatement(Z,ot(Z.initializer,Ge?Zr:Ui,Sd),ot(Z.condition,Ci,Ct),ot(Z.incrementor,Ui,Ct),ff(Z.statement,Ge?vr:Ci,e)),q=bt,Z}function jr(Z){let Ge=q;return q=Z,Z=t.updateForInStatement(Z,Zr(Z.initializer),ot(Z.expression,Ci,Ct),ff(Z.statement,vr,e)),q=Ge,Z}function ur(Z){let Ge=q;return q=Z,Z=t.updateForOfStatement(Z,Z.awaitModifier,Zr(Z.initializer),ot(Z.expression,Ci,Ct),ff(Z.statement,vr,e)),q=Ge,Z}function or(Z){return Ru(Z)&&Ve(Z)}function Zr(Z){if(or(Z)){let Ge;for(let bt of Z.declarations)Ge=Bt(Ge,Pe(bt,!1)),bt.initializer||be(bt);return Ge?t.inlineExpressions(Ge):t.createOmittedExpression()}else return ot(Z,Ui,Sd)}function Oi(Z){return t.updateDoStatement(Z,ff(Z.statement,vr,e),ot(Z.expression,Ci,Ct))}function Sr(Z){return t.updateWhileStatement(Z,ot(Z.expression,Ci,Ct),ff(Z.statement,vr,e))}function Pi(Z){return t.updateLabeledStatement(Z,Z.label,M.checkDefined(ot(Z.statement,vr,Vi,t.liftToBlock)))}function Cs(Z){return t.updateWithStatement(Z,ot(Z.expression,Ci,Ct),M.checkDefined(ot(Z.statement,vr,Vi,t.liftToBlock)))}function ss(Z){return t.updateIfStatement(Z,ot(Z.expression,Ci,Ct),M.checkDefined(ot(Z.thenStatement,vr,Vi,t.liftToBlock)),ot(Z.elseStatement,vr,Vi,t.liftToBlock))}function Ii(Z){return t.updateSwitchStatement(Z,ot(Z.expression,Ci,Ct),M.checkDefined(ot(Z.caseBlock,vr,DO)))}function $r(Z){let Ge=q;return q=Z,Z=t.updateCaseBlock(Z,Kr(Z.clauses,vr,M5)),q=Ge,Z}function Xs(Z){return t.updateCaseClause(Z,ot(Z.expression,Ci,Ct),Kr(Z.statements,vr,Vi))}function $e(Z){return Mr(Z,vr,e)}function Yt(Z){return Mr(Z,vr,e)}function Vr(Z){let Ge=q;return q=Z,Z=t.updateCatchClause(Z,Z.variableDeclaration,M.checkDefined(ot(Z.block,vr,Vs))),q=Ge,Z}function An(Z){let Ge=q;return q=Z,Z=Mr(Z,vr,e),q=Ge,Z}function vi(Z,Ge){if(!(Z.transformFlags&276828160))return Z;switch(Z.kind){case 248:return xr(Z,!1);case 244:return la(Z);case 217:return Gs(Z,Ge);case 354:return yr(Z,Ge);case 226:if(Dv(Z))return lt(Z,Ge);break;case 213:if(Np(Z))return to(Z);break;case 224:case 225:return fe(Z,Ge)}return Mr(Z,Ci,e)}function Ci(Z){return vi(Z,!1)}function Ui(Z){return vi(Z,!0)}function la(Z){return t.updateExpressionStatement(Z,ot(Z.expression,Ui,Ct))}function Gs(Z,Ge){return t.updateParenthesizedExpression(Z,ot(Z.expression,Ge?Ui:Ci,Ct))}function yr(Z,Ge){return t.updatePartiallyEmittedExpression(Z,ot(Z.expression,Ge?Ui:Ci,Ct))}function to(Z){let Ge=WA(t,Z,R,m,u,o),bt=ot(xo(Z.arguments),Ci,Ct),Q=Ge&&(!bt||!La(bt)||bt.text!==Ge.text)?Ge:bt;return t.createCallExpression(t.createPropertyAccessExpression(J,t.createIdentifier("import")),void 0,Q?[Q]:[])}function lt(Z,Ge){return St(Z.left)?y2(Z,Ci,e,0,!Ge):Mr(Z,Ci,e)}function St(Z){if(Su(Z,!0))return St(Z.left);if(Ad(Z))return St(Z.expression);if(Ca(Z))return Pt(Z.properties,St);if(Gu(Z))return Pt(Z.elements,St);if(p_(Z))return St(Z.name);if(ql(Z))return St(Z.initializer);if(He(Z)){let Ge=u.getReferencedExportContainer(Z);return Ge!==void 0&&Ge.kind===307}else return!1}function fe(Z,Ge){if((Z.operator===46||Z.operator===47)&&He(Z.operand)&&!xc(Z.operand)&&!k0(Z.operand)&&!aG(Z.operand)){let bt=Nt(Z.operand);if(bt){let Q,Ke=ot(Z.operand,Ci,Ct);tS(Z)?Ke=t.updatePrefixUnaryExpression(Z,Ke):(Ke=t.updatePostfixUnaryExpression(Z,Ke),Ge||(Q=t.createTempVariable(s),Ke=t.createAssignment(Q,Ke),Et(Ke,Z)),Ke=t.createComma(Ke,t.cloneNode(Z.operand)),Et(Ke,Z));for(let z of bt)Ke=rr(z,Rt(Ke));return Q&&(Ke=t.createComma(Ke,Q),Et(Ke,Z)),Ke}}return Mr(Z,Ci,e)}function vt(Z){switch(Z.kind){case 95:case 90:return}return Z}function Ce(Z,Ge,bt){if(Ge.kind===307){let Q=pf(Ge);R=Ge,L=E[Q],F=x[Q],ee=D[Q],J=w[Q],ee&&delete D[Q],S(Z,Ge,bt),R=void 0,L=void 0,F=void 0,J=void 0,ee=void 0}else S(Z,Ge,bt)}function nt(Z,Ge){return Ge=d(Z,Ge),nr(Ge)?Ge:Z===1?ft(Ge):Z===4?Me(Ge):Ge}function Me(Z){switch(Z.kind){case 304:return tt(Z)}return Z}function tt(Z){var Ge,bt;let Q=Z.name;if(!xc(Q)&&!k0(Q)){let Ke=u.getReferencedImportDeclaration(Q);if(Ke){if(ig(Ke))return Et(t.createPropertyAssignment(t.cloneNode(Q),t.createPropertyAccessExpression(t.getGeneratedNameForNode(Ke.parent),t.createIdentifier("default"))),Z);if(_f(Ke))return Et(t.createPropertyAssignment(t.cloneNode(Q),t.createPropertyAccessExpression(t.getGeneratedNameForNode(((bt=(Ge=Ke.parent)==null?void 0:Ge.parent)==null?void 0:bt.parent)||Ke),t.cloneNode(Ke.propertyName||Ke.name))),Z)}}return Z}function ft(Z){switch(Z.kind){case 80:return tr(Z);case 226:return Oe(Z);case 236:return At(Z)}return Z}function tr(Z){var Ge,bt;if(Ga(Z)&8192){let Q=Hj(R);return Q?t.createPropertyAccessExpression(Q,Z):Z}if(!xc(Z)&&!k0(Z)){let Q=u.getReferencedImportDeclaration(Z);if(Q){if(ig(Q))return Et(t.createPropertyAccessExpression(t.getGeneratedNameForNode(Q.parent),t.createIdentifier("default")),Z);if(_f(Q))return Et(t.createPropertyAccessExpression(t.getGeneratedNameForNode(((bt=(Ge=Q.parent)==null?void 0:Ge.parent)==null?void 0:bt.parent)||Q),t.cloneNode(Q.propertyName||Q.name)),Z)}}return Z}function Oe(Z){if(y0(Z.operatorToken.kind)&&He(Z.left)&&(!xc(Z.left)||F3(Z.left))&&!k0(Z.left)){let Ge=Nt(Z.left);if(Ge){let bt=Z;for(let Q of Ge)bt=rr(Q,Rt(bt));return bt}}return Z}function At(Z){return WP(Z)?t.createPropertyAccessExpression(J,t.createIdentifier("meta")):Z}function Nt(Z){let Ge,bt=Ut(Z);if(bt){let Q=u.getReferencedExportContainer(Z,!1);Q&&Q.kind===307&&(Ge=Bt(Ge,t.getDeclarationName(bt))),Ge=wn(Ge,L?.exportedBindings[pf(bt)])}else if(xc(Z)&&F3(Z)){let Q=L?.exportSpecifiers.get(Z);if(Q){let Ke=[];for(let z of Q)Ke.push(z.name);return Ke}}return Ge}function Ut(Z){if(!xc(Z)){let Ge=u.getReferencedImportDeclaration(Z);if(Ge)return Ge;let bt=u.getReferencedValueDeclaration(Z);if(bt&&L?.exportedBindings[pf(bt)])return bt;let Q=u.getReferencedValueDeclarations(Z);if(Q){for(let Ke of Q)if(Ke!==bt&&L?.exportedBindings[pf(Ke)])return Ke}return bt}}function Rt(Z){return ee===void 0&&(ee=[]),ee[yo(Z)]=!0,Z}function nr(Z){return ee&&Z.id&&ee[Z.id]}}function MK(e){let{factory:t,getEmitHelperFactory:n}=e,i=e.getEmitHost(),s=e.getEmitResolver(),o=e.getCompilerOptions(),u=Ka(o),m=e.onEmitNode,d=e.onSubstituteNode;e.onEmitNode=ee,e.onSubstituteNode=W,e.enableEmitNotification(307),e.enableSubstitution(80);let S,E,x;return cg(e,D);function D(K){if(K.isDeclarationFile)return K;if(nu(K)||Cd(o)){E=K,x=void 0;let re=w(K);return E=void 0,x&&(re=t.updateSourceFile(re,Et(t.createNodeArray(Z$(re.statements.slice(),x)),re.statements))),!nu(K)||V_(o)===200||Pt(re.statements,q3)?re:t.updateSourceFile(re,Et(t.createNodeArray([...re.statements,m8(t)]),re.statements))}return K}function w(K){let re=SY(t,n(),K,o);if(re){let ue=[],ce=t.copyPrologue(K.statements,ue);return Bt(ue,re),wn(ue,Kr(K.statements,R,Vi,ce)),t.updateSourceFile(K,Et(t.createNodeArray(ue),K.statements))}else return Mr(K,R,e)}function R(K){switch(K.kind){case 271:return V_(o)>=100?F(K):void 0;case 277:return G(K);case 278:return q(K)}return K}function L(K){let re=WA(t,K,M.checkDefined(E),i,s,o),ue=[];if(re&&ue.push(re),V_(o)===200)return t.createCallExpression(t.createIdentifier("require"),void 0,ue);if(!x){let ne=t.createUniqueName("_createRequire",48),le=t.createImportDeclaration(void 0,t.createImportClause(!1,void 0,t.createNamedImports([t.createImportSpecifier(!1,t.createIdentifier("createRequire"),ne)])),t.createStringLiteral("module"),void 0),me=t.createUniqueName("__require",48),de=t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(me,void 0,void 0,t.createCallExpression(t.cloneNode(ne),void 0,[t.createPropertyAccessExpression(t.createMetaProperty(102,t.createIdentifier("meta")),t.createIdentifier("url"))]))],u>=2?2:0));x=[le,de]}let ce=x[1].declarationList.declarations[0].name;return M.assertNode(ce,He),t.createCallExpression(t.cloneNode(ce),void 0,ue)}function F(K){M.assert(cb(K),"import= for internal module references should be handled in an earlier transformer.");let re;return re=Bt(re,zn(Et(t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(t.cloneNode(K.name),void 0,void 0,L(K))],u>=2?2:0)),K),K)),re=J(re,K),wh(re)}function J(K,re){return li(re,32)&&(K=Bt(K,t.createExportDeclaration(void 0,re.isTypeOnly,t.createNamedExports([t.createExportSpecifier(!1,void 0,Nn(re.name))])))),K}function G(K){return K.isExportEquals?V_(o)===200?zn(t.createExpressionStatement(t.createAssignment(t.createPropertyAccessExpression(t.createIdentifier("module"),"exports"),K.expression)),K):void 0:K}function q(K){if(o.module!==void 0&&o.module>5||!K.exportClause||!zh(K.exportClause)||!K.moduleSpecifier)return K;let re=K.exportClause.name,ue=t.getGeneratedNameForNode(re),ce=t.createImportDeclaration(void 0,t.createImportClause(!1,void 0,t.createNamespaceImport(ue)),K.moduleSpecifier,K.attributes);zn(ce,K.exportClause);let ne=H5(K)?t.createExportDefault(ue):t.createExportDeclaration(void 0,!1,t.createNamedExports([t.createExportSpecifier(!1,ue,re)]));return zn(ne,K),[ce,ne]}function ee(K,re,ue){Ji(re)?((nu(re)||Cd(o))&&o.importHelpers&&(S=new Map),m(K,re,ue),S=void 0):m(K,re,ue)}function W(K,re){return re=d(K,re),S&&He(re)&&Ga(re)&8192?pe(re):re}function pe(K){let re=Nn(K),ue=S.get(re);return ue||S.set(re,ue=t.createUniqueName(re,48)),ue}}function Ahe(e){let t=e.onSubstituteNode,n=e.onEmitNode,i=MK(e),s=e.onSubstituteNode,o=e.onEmitNode;e.onSubstituteNode=t,e.onEmitNode=n;let u=RK(e),m=e.onSubstituteNode,d=e.onEmitNode;e.onSubstituteNode=E,e.onEmitNode=x,e.enableSubstitution(307),e.enableEmitNotification(307);let S;return R;function E(F,J){return Ji(J)?(S=J,t(F,J)):S?S.impliedNodeFormat===99?s(F,J):m(F,J):t(F,J)}function x(F,J,G){return Ji(J)&&(S=J),S?S.impliedNodeFormat===99?o(F,J,G):d(F,J,G):n(F,J,G)}function D(F){return F.impliedNodeFormat===99?i:u}function w(F){if(F.isDeclarationFile)return F;S=F;let J=D(F)(F);return S=void 0,M.assert(Ji(J)),J}function R(F){return F.kind===307?w(F):L(F)}function L(F){return e.factory.createBundle(Cr(F.sourceFiles,w))}}function LB(e){return Ei(e)||Ns(e)||Nf(e)||Xa(e)||Og(e)||Sv(e)||u8(e)||MA(e)||ul(e)||$g(e)||Tl(e)||ns(e)||Ac(e)||x0(e)||ru(e)||im(e)||Vc(e)||fE(e)||Wn(e)||cc(e)||Pn(e)||Xd(e)}function khe(e){if(Og(e)||Sv(e))return t;return $g(e)||ul(e)?i:Fv(e);function t(o){let u=n(o);return u!==void 0?{diagnosticMessage:u,errorNode:e,typeName:e.name}:void 0}function n(o){return oa(e)?o.errorModuleName?o.accessibility===2?v.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:v.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:v.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1:e.parent.kind===263?o.errorModuleName?o.accessibility===2?v.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:v.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:v.Public_property_0_of_exported_class_has_or_is_using_private_name_1:o.errorModuleName?v.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:v.Property_0_of_exported_interface_has_or_is_using_private_name_1}function i(o){let u=s(o);return u!==void 0?{diagnosticMessage:u,errorNode:e,typeName:e.name}:void 0}function s(o){return oa(e)?o.errorModuleName?o.accessibility===2?v.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:v.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:v.Public_static_method_0_of_exported_class_has_or_is_using_private_name_1:e.parent.kind===263?o.errorModuleName?o.accessibility===2?v.Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:v.Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:v.Public_method_0_of_exported_class_has_or_is_using_private_name_1:o.errorModuleName?v.Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:v.Method_0_of_exported_interface_has_or_is_using_private_name_1}}function Fv(e){if(Ei(e)||Ns(e)||Nf(e)||Wn(e)||cc(e)||Pn(e)||Xa(e)||Vc(e))return n;return Og(e)||Sv(e)?i:u8(e)||MA(e)||ul(e)||$g(e)||Tl(e)||fE(e)?s:ns(e)?ap(e,e.parent)&&li(e.parent,2)?n:o:Ac(e)?m:x0(e)?d:ru(e)?S:im(e)||Xd(e)?E:M.assertNever(e,`Attempted to set a declaration diagnostic context for unhandled node kind: ${M.formatSyntaxKind(e.kind)}`);function t(x){if(e.kind===260||e.kind===208)return x.errorModuleName?x.accessibility===2?v.Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:v.Exported_variable_0_has_or_is_using_name_1_from_private_module_2:v.Exported_variable_0_has_or_is_using_private_name_1;if(e.kind===172||e.kind===211||e.kind===212||e.kind===226||e.kind===171||e.kind===169&&li(e.parent,2))return oa(e)?x.errorModuleName?x.accessibility===2?v.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:v.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:v.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1:e.parent.kind===263||e.kind===169?x.errorModuleName?x.accessibility===2?v.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:v.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:v.Public_property_0_of_exported_class_has_or_is_using_private_name_1:x.errorModuleName?v.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:v.Property_0_of_exported_interface_has_or_is_using_private_name_1}function n(x){let D=t(x);return D!==void 0?{diagnosticMessage:D,errorNode:e,typeName:e.name}:void 0}function i(x){let D;return e.kind===178?oa(e)?D=x.errorModuleName?v.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:v.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1:D=x.errorModuleName?v.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:v.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1:oa(e)?D=x.errorModuleName?x.accessibility===2?v.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:v.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:v.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1:D=x.errorModuleName?x.accessibility===2?v.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:v.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:v.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1,{diagnosticMessage:D,errorNode:e.name,typeName:e.name}}function s(x){let D;switch(e.kind){case 180:D=x.errorModuleName?v.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:v.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0;break;case 179:D=x.errorModuleName?v.Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:v.Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0;break;case 181:D=x.errorModuleName?v.Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:v.Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0;break;case 174:case 173:oa(e)?D=x.errorModuleName?x.accessibility===2?v.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:v.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:v.Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0:e.parent.kind===263?D=x.errorModuleName?x.accessibility===2?v.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:v.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:v.Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0:D=x.errorModuleName?v.Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1:v.Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0;break;case 262:D=x.errorModuleName?x.accessibility===2?v.Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:v.Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1:v.Return_type_of_exported_function_has_or_is_using_private_name_0;break;default:return M.fail("This is unknown kind for signature: "+e.kind)}return{diagnosticMessage:D,errorNode:e.name||e}}function o(x){let D=u(x);return D!==void 0?{diagnosticMessage:D,errorNode:e,typeName:e.name}:void 0}function u(x){switch(e.parent.kind){case 176:return x.errorModuleName?x.accessibility===2?v.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:v.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2:v.Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1;case 180:case 185:return x.errorModuleName?v.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:v.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;case 179:return x.errorModuleName?v.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:v.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;case 181:return x.errorModuleName?v.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:v.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1;case 174:case 173:return oa(e.parent)?x.errorModuleName?x.accessibility===2?v.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:v.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:v.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:e.parent.parent.kind===263?x.errorModuleName?x.accessibility===2?v.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:v.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:v.Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:x.errorModuleName?v.Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2:v.Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;case 262:case 184:return x.errorModuleName?x.accessibility===2?v.Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:v.Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2:v.Parameter_0_of_exported_function_has_or_is_using_private_name_1;case 178:case 177:return x.errorModuleName?x.accessibility===2?v.Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:v.Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2:v.Parameter_0_of_accessor_has_or_is_using_private_name_1;default:return M.fail(`Unknown parent for parameter: ${M.formatSyntaxKind(e.parent.kind)}`)}}function m(){let x;switch(e.parent.kind){case 263:x=v.Type_parameter_0_of_exported_class_has_or_is_using_private_name_1;break;case 264:x=v.Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1;break;case 200:x=v.Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1;break;case 185:case 180:x=v.Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;break;case 179:x=v.Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;break;case 174:case 173:oa(e.parent)?x=v.Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:e.parent.parent.kind===263?x=v.Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:x=v.Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;break;case 184:case 262:x=v.Type_parameter_0_of_exported_function_has_or_is_using_private_name_1;break;case 195:x=v.Extends_clause_for_inferred_type_0_has_or_is_using_private_name_1;break;case 265:x=v.Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1;break;default:return M.fail("This is unknown parent for type parameter: "+e.parent.kind)}return{diagnosticMessage:x,errorNode:e,typeName:e.name}}function d(){let x;return tu(e.parent.parent)?x=pp(e.parent)&&e.parent.token===119?v.Implements_clause_of_exported_class_0_has_or_is_using_private_name_1:e.parent.parent.name?v.extends_clause_of_exported_class_0_has_or_is_using_private_name_1:v.extends_clause_of_exported_class_has_or_is_using_private_name_0:x=v.extends_clause_of_exported_interface_0_has_or_is_using_private_name_1,{diagnosticMessage:x,errorNode:e,typeName:Ps(e.parent.parent)}}function S(){return{diagnosticMessage:v.Import_declaration_0_is_using_private_name_1,errorNode:e,typeName:e.name}}function E(x){return{diagnosticMessage:x.errorModuleName?v.Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2:v.Exported_type_alias_0_has_or_is_using_private_name_1,errorNode:Xd(e)?M.checkDefined(e.typeExpression):e.type,typeName:Xd(e)?Ps(e):e.name}}}function Phe(e){let t={219:v.Add_a_return_type_to_the_function_expression,218:v.Add_a_return_type_to_the_function_expression,174:v.Add_a_return_type_to_the_method,177:v.Add_a_return_type_to_the_get_accessor_declaration,178:v.Add_a_type_to_parameter_of_the_set_accessor_declaration,262:v.Add_a_return_type_to_the_function_declaration,180:v.Add_a_return_type_to_the_function_declaration,169:v.Add_a_type_annotation_to_the_parameter_0,260:v.Add_a_type_annotation_to_the_variable_0,172:v.Add_a_type_annotation_to_the_property_0,171:v.Add_a_type_annotation_to_the_property_0,277:v.Move_the_expression_in_default_export_to_a_variable_and_add_a_type_annotation_to_it},n={218:v.Function_must_have_an_explicit_return_type_annotation_with_isolatedDeclarations,262:v.Function_must_have_an_explicit_return_type_annotation_with_isolatedDeclarations,219:v.Function_must_have_an_explicit_return_type_annotation_with_isolatedDeclarations,174:v.Method_must_have_an_explicit_return_type_annotation_with_isolatedDeclarations,180:v.Method_must_have_an_explicit_return_type_annotation_with_isolatedDeclarations,177:v.At_least_one_accessor_must_have_an_explicit_return_type_annotation_with_isolatedDeclarations,178:v.At_least_one_accessor_must_have_an_explicit_return_type_annotation_with_isolatedDeclarations,169:v.Parameter_must_have_an_explicit_type_annotation_with_isolatedDeclarations,260:v.Variable_must_have_an_explicit_type_annotation_with_isolatedDeclarations,172:v.Property_must_have_an_explicit_type_annotation_with_isolatedDeclarations,171:v.Property_must_have_an_explicit_type_annotation_with_isolatedDeclarations,167:v.Computed_property_names_on_class_or_object_literals_cannot_be_inferred_with_isolatedDeclarations,305:v.Objects_that_contain_spread_assignments_can_t_be_inferred_with_isolatedDeclarations,304:v.Objects_that_contain_shorthand_properties_can_t_be_inferred_with_isolatedDeclarations,209:v.Only_const_arrays_can_be_inferred_with_isolatedDeclarations,277:v.Default_exports_can_t_be_inferred_with_isolatedDeclarations,230:v.Arrays_with_spread_elements_can_t_inferred_with_isolatedDeclarations};return i;function i(F){if(Pr(F,pp))return pn(F,v.Extends_clause_can_t_contain_an_expression_with_isolatedDeclarations);if((Lg(F)||pE(F.parent))&&(Tf(F)||nc(F)))return R(F);switch(M.type(F),F.kind){case 177:case 178:return o(F);case 167:case 304:case 305:return m(F);case 209:case 230:return d(F);case 174:case 180:case 218:case 219:case 262:return S(F);case 208:return E(F);case 172:case 260:return x(F);case 169:return D(F);case 303:return L(F.initializer);case 231:return w(F);default:return L(F)}}function s(F){let J=Pr(F,G=>dc(G)||Vi(G)||Ei(G)||Ns(G)||ns(G));if(J)return dc(J)?J:nm(J)?Pr(J,G=>Go(G)&&!Vc(G)):Vi(J)?void 0:J}function o(F){let{getAccessor:J,setAccessor:G}=W1(F.symbol.declarations,F),q=(Og(F)?F.parameters[0]:F)??F,ee=pn(q,n[F.kind]);return G&&ca(ee,pn(G,t[G.kind])),J&&ca(ee,pn(J,t[J.kind])),ee}function u(F,J){let G=s(F);if(G){let q=dc(G)||!G.name?"":Hc(G.name,!1);ca(J,pn(G,t[G.kind],q))}return J}function m(F){let J=pn(F,n[F.kind]);return u(F,J),J}function d(F){let J=pn(F,n[F.kind]);return u(F,J),J}function S(F){let J=pn(F,n[F.kind]);return u(F,J),ca(J,pn(F,t[F.kind])),J}function E(F){return pn(F,v.Binding_elements_can_t_be_exported_directly_with_isolatedDeclarations)}function x(F){let J=pn(F,n[F.kind]),G=Hc(F.name,!1);return ca(J,pn(F,t[F.kind],G)),J}function D(F){if(Og(F.parent))return o(F.parent);let J=e.requiresAddingImplicitUndefined(F);if(!J&&F.initializer)return L(F.initializer);let G=J?v.Declaration_emit_for_this_parameter_requires_implicitly_adding_undefined_to_it_s_type_This_is_not_supported_with_isolatedDeclarations:n[F.kind],q=pn(F,G),ee=Hc(F.name,!1);return ca(q,pn(F,t[F.kind],ee)),q}function w(F){return L(F,v.Inference_from_class_expressions_is_not_supported_with_isolatedDeclarations)}function R(F){let J=pn(F,v.Type_containing_private_name_0_can_t_be_used_with_isolatedDeclarations,Hc(F,!1));return u(F,J),J}function L(F,J){let G=s(F),q;if(G){let ee=dc(G)||!G.name?"":Hc(G.name,!1),W=Pr(F.parent,pe=>dc(pe)||(Vi(pe)?"quit":!uf(pe)&&!ZG(pe)&&!CO(pe)));G===W?(q=pn(F,J??n[G.kind]),ca(q,pn(G,t[G.kind],ee))):(q=pn(F,J??v.Expression_type_can_t_be_inferred_with_isolatedDeclarations),ca(q,pn(G,t[G.kind],ee)),ca(q,pn(F,v.Add_satisfies_and_a_type_assertion_to_this_expression_satisfies_T_as_T_to_make_the_type_explicit)))}else q=pn(F,J??v.Expression_type_can_t_be_inferred_with_isolatedDeclarations);return q}}function Nhe(e,t,n){let i=e.getCompilerOptions(),s=Zn(P9(e,n),f9);return q8(t,e,U,i,n?Es(s,n)?[n]:ve:s,[LK],!1).diagnostics}var V8=531469;function LK(e){let t=()=>M.fail("Diagnostic emitted without context"),n=t,i=!0,s=!1,o=!1,u=!1,m=!1,d,S,E,x,{factory:D}=e,w=e.getEmitHost(),R={trackSymbol:me,reportInaccessibleThisError:he,reportInaccessibleUniqueSymbolError:xe,reportCyclicStructureError:te,reportPrivateInBaseOfClassExpression:de,reportLikelyUnsafeImportRequiredError:be,reportTruncationError:Ve,moduleResolverHost:w,reportNonlocalAugmentation:Pe,reportNonSerializableProperty:ke,reportInferenceFallback:ne},L,F,J,G,q,ee,W=e.getEmitResolver(),pe=e.getCompilerOptions(),K=Phe(W),{stripInternal:re,isolatedDeclarations:ue}=pe;return Be;function ce(fe){W.getPropertiesOfContainerFunction(fe).forEach(vt=>{if(CA(vt.valueDeclaration)){let Ce=Pn(vt.valueDeclaration)?vt.valueDeclaration.left:vt.valueDeclaration;e.addDiagnostic(pn(Ce,v.Assigning_properties_to_functions_without_declaring_them_is_not_supported_with_isolatedDeclarations_Add_an_explicit_declaration_for_the_properties_assigned_to_this_function))}})}function ne(fe){!ue||Af(J)||Ur(fe)===J&&(Ei(fe)&&W.isExpandoFunctionDeclaration(fe)?ce(fe):e.addDiagnostic(K(fe)))}function le(fe){if(fe.accessibility===0){if(fe.aliasesToMakeVisible)if(!S)S=fe.aliasesToMakeVisible;else for(let vt of fe.aliasesToMakeVisible)ol(S,vt)}else if(fe.accessibility!==3){let vt=n(fe);if(vt)return vt.typeName?e.addDiagnostic(pn(fe.errorNode||vt.errorNode,vt.diagnosticMessage,Hc(vt.typeName),fe.errorSymbolName,fe.errorModuleName)):e.addDiagnostic(pn(fe.errorNode||vt.errorNode,vt.diagnosticMessage,fe.errorSymbolName,fe.errorModuleName)),!0}return!1}function me(fe,vt,Ce){return fe.flags&262144?!1:le(W.isSymbolAccessible(fe,vt,Ce,!0))}function de(fe){(L||F)&&e.addDiagnostic(pn(L||F,v.Property_0_of_exported_class_expression_may_not_be_private_or_protected,fe))}function Ae(){return L?Yo(L):F&&Ps(F)?Yo(Ps(F)):F&&dc(F)?F.isExportEquals?"export=":"default":"(Missing)"}function xe(){(L||F)&&e.addDiagnostic(pn(L||F,v.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary,Ae(),"unique symbol"))}function te(){(L||F)&&e.addDiagnostic(pn(L||F,v.The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialized_A_type_annotation_is_necessary,Ae()))}function he(){(L||F)&&e.addDiagnostic(pn(L||F,v.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary,Ae(),"this"))}function be(fe){(L||F)&&e.addDiagnostic(pn(L||F,v.The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary,Ae(),fe))}function Ve(){(L||F)&&e.addDiagnostic(pn(L||F,v.The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_type_annotation_is_needed))}function Pe(fe,vt,Ce){var nt;let Me=(nt=vt.declarations)==null?void 0:nt.find(ft=>Ur(ft)===fe),tt=Zn(Ce.declarations,ft=>Ur(ft)!==fe);if(Me&&tt)for(let ft of tt)e.addDiagnostic(ca(pn(ft,v.Declaration_augments_declaration_in_another_file_This_cannot_be_serialized),pn(Me,v.This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_file)))}function ke(fe){(L||F)&&e.addDiagnostic(pn(L||F,v.The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized,fe))}function De(fe){let vt=n;n=nt=>nt.errorNode&&LB(nt.errorNode)?Fv(nt.errorNode)(nt):{diagnosticMessage:nt.errorModuleName?v.Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotation_may_unblock_declaration_emit:v.Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_declaration_emit,errorNode:nt.errorNode||fe};let Ce=W.getDeclarationStatementsForSourceFile(fe,V8,R);return n=vt,Ce}function Be(fe){if(fe.kind===307&&fe.isDeclarationFile)return fe;if(fe.kind===308){s=!0,G=[],q=[],ee=[];let Oe=!1,At=D.createBundle(Cr(fe.sourceFiles,Ut=>{if(Ut.isDeclarationFile)return;if(Oe=Oe||Ut.hasNoDefaultLib,J=Ut,d=Ut,S=void 0,x=!1,E=new Map,n=t,u=!1,m=!1,nt(Ut),Uf(Ut)||Kd(Ut)){o=!1,i=!1;let nr=Af(Ut)?D.createNodeArray(De(Ut)):Kr(Ut.statements,$r,Vi);return D.updateSourceFile(Ut,[D.createModuleDeclaration([D.createModifier(138)],D.createStringLiteral(WH(e.getEmitHost(),Ut)),D.createModuleBlock(Et(D.createNodeArray(Cs(nr)),Ut.statements)))],!0,[],[],!1,[])}i=!0;let Rt=Af(Ut)?D.createNodeArray(De(Ut)):Kr(Ut.statements,$r,Vi);return D.updateSourceFile(Ut,Cs(Rt),!0,[],[],!1,[])})),Nt=mi(qu(i6(fe,w,!0).declarationFilePath));return At.syntheticFileReferences=tr(Nt),At.syntheticTypeReferences=tt(),At.syntheticLibReferences=ft(),At.hasNoDefaultLib=Oe,At}i=!0,u=!1,m=!1,d=fe,J=fe,n=t,s=!1,o=!1,x=!1,S=void 0,E=new Map,G=[],q=[],ee=[],nt(J);let vt;if(Af(J))vt=D.createNodeArray(De(fe));else{let Oe=Kr(fe.statements,$r,Vi);vt=Et(D.createNodeArray(Cs(Oe)),fe.statements),nu(fe)&&(!o||u&&!m)&&(vt=Et(D.createNodeArray([...vt,m8(D)]),vt))}let Ce=mi(qu(i6(fe,w,!0).declarationFilePath));return D.updateSourceFile(fe,vt,!0,tr(Ce),tt(),fe.hasNoDefaultLib,ft());function nt(Oe){G=ps(G,Cr(Oe.referencedFiles,At=>[Oe,At])),q=ps(q,Oe.typeReferenceDirectives),ee=ps(ee,Oe.libReferenceDirectives)}function Me(Oe){let At={...Oe};return At.pos=-1,At.end=-1,At}function tt(){return Gi(q,Oe=>{if(Oe.preserve)return Me(Oe)})}function ft(){return Gi(ee,Oe=>{if(Oe.preserve)return Me(Oe)})}function tr(Oe){return Gi(G,([At,Nt])=>{if(!Nt.preserve)return;let Ut=w.getSourceFileFromReference(At,Nt);if(!Ut)return;let Rt;if(Ut.isDeclarationFile)Rt=Ut.fileName;else{if(s&&Es(fe.sourceFiles,Ut))return;let Ge=i6(Ut,w,!0);Rt=Ge.declarationFilePath||Ge.jsFilePath||Ut.fileName}if(!Rt)return;let nr=WC(Oe,Rt,w.getCurrentDirectory(),w.getCanonicalFileName,!1),Z=Me(Nt);return Z.fileName=nr,Z})}}function ct(fe){if(fe.kind===80)return fe;return fe.kind===207?D.updateArrayBindingPattern(fe,Kr(fe.elements,vt,w5)):D.updateObjectBindingPattern(fe,Kr(fe.elements,vt,Xa));function vt(Ce){return Ce.kind===232?Ce:(Ce.propertyName&&za(Ce.propertyName)&&nc(Ce.propertyName.expression)&&ur(Ce.propertyName.expression,d),D.updateBindingElement(Ce,Ce.dotDotDotToken,Ce.propertyName,ct(Ce.name),void 0))}}function qe(fe,vt,Ce){let nt;x||(nt=n,n=Fv(fe));let Me=D.updateParameterDeclaration(fe,$Et(D,fe,vt),fe.dotDotDotToken,ct(fe.name),W.isOptionalParameter(fe)?fe.questionToken||D.createToken(58):void 0,_t(fe,Ce||fe.type,!0),Ie(fe));return x||(n=nt),Me}function et(fe){return m8e(fe)&&!!fe.initializer&&W.isLiteralConstDeclaration(ks(fe))}function Ie(fe){if(et(fe)){let vt=Upe(fe.initializer);return yj(vt)||ne(fe),W.createLiteralConstValue(ks(fe,m8e),R)}}function _t(fe,vt,Ce){if(!Ce&&up(fe,2)||et(fe))return;let nt=fe.kind===169&&W.requiresAddingImplicitUndefined(fe);if(vt&&!nt)return ot(vt,ss,Di);L=fe.name;let Me;x||(Me=n,n=Fv(fe));let tt;switch(fe.kind){case 169:case 171:case 172:case 208:case 260:tt=W.createTypeOfDeclaration(fe,d,V8,R);break;case 262:case 180:case 173:case 174:case 177:case 179:tt=W.createReturnTypeOfSignatureDeclaration(fe,d,V8,R);break;default:M.assertNever(fe)}return L=void 0,x||(n=Me),tt??D.createKeywordTypeNode(133)}function mt(fe){switch(fe=ks(fe),fe.kind){case 262:case 267:case 264:case 263:case 265:case 266:return!W.isDeclarationVisible(fe);case 260:return!ht(fe);case 271:case 272:case 278:case 277:return!1;case 175:return!0}return!1}function Xe(fe){var vt;if(fe.body)return!0;let Ce=(vt=fe.symbol.declarations)==null?void 0:vt.filter(nt=>Tl(nt)&&!nt.body);return!Ce||Ce.indexOf(fe)===Ce.length-1}function ht(fe){return pu(fe)?!1:Hs(fe.name)?Pt(fe.name.elements,ht):W.isDeclarationVisible(fe)}function rr(fe,vt,Ce){if(up(fe,2))return D.createNodeArray();let nt=Cr(vt,Me=>qe(Me,Ce));return nt?D.createNodeArray(nt,vt.hasTrailingComma):D.createNodeArray()}function vr(fe,vt){let Ce;if(!vt){let nt=iE(fe);nt&&(Ce=[qe(nt)])}if(fp(fe)){let nt;if(!vt){let Me=aN(fe);if(Me){let tt=lt(fe,W1(Ca(fe.parent)?fe.parent.properties:fe.parent.members,fe));nt=qe(Me,void 0,tt)}}nt||(nt=D.createParameterDeclaration(void 0,void 0,"value")),Ce=Bt(Ce,nt)}return D.createNodeArray(Ce||ve)}function xr(fe,vt){return up(fe,2)?void 0:Kr(vt,ss,Ac)}function jr(fe){return Ji(fe)||im(fe)||El(fe)||tu(fe)||Yu(fe)||Bs(fe)||fE(fe)||o2(fe)}function ur(fe,vt){let Ce=W.isEntityNameVisible(fe,vt);le(Ce)}function or(fe,vt){return Pp(fe)&&Pp(vt)&&(fe.jsDoc=vt.jsDoc),Zl(fe,Wg(vt))}function Zr(fe,vt){if(vt){if(o=o||fe.kind!==267&&fe.kind!==205,No(vt)&&s){let Ce=Cfe(e.getEmitHost(),W,fe);if(Ce)return D.createStringLiteral(Ce)}return vt}}function Oi(fe){if(W.isDeclarationVisible(fe))if(fe.moduleReference.kind===283){let vt=II(fe);return D.updateImportEqualsDeclaration(fe,fe.modifiers,fe.isTypeOnly,fe.name,D.updateExternalModuleReference(fe.moduleReference,Zr(fe,vt)))}else{let vt=n;return n=Fv(fe),ur(fe.moduleReference,d),n=vt,fe}}function Sr(fe){if(!fe.importClause)return D.updateImportDeclaration(fe,fe.modifiers,fe.importClause,Zr(fe,fe.moduleSpecifier),Pi(fe.attributes));let vt=fe.importClause&&fe.importClause.name&&W.isDeclarationVisible(fe.importClause)?fe.importClause.name:void 0;if(!fe.importClause.namedBindings)return vt&&D.updateImportDeclaration(fe,fe.modifiers,D.updateImportClause(fe.importClause,fe.importClause.isTypeOnly,vt,void 0),Zr(fe,fe.moduleSpecifier),Pi(fe.attributes));if(fe.importClause.namedBindings.kind===274){let nt=W.isDeclarationVisible(fe.importClause.namedBindings)?fe.importClause.namedBindings:void 0;return vt||nt?D.updateImportDeclaration(fe,fe.modifiers,D.updateImportClause(fe.importClause,fe.importClause.isTypeOnly,vt,nt),Zr(fe,fe.moduleSpecifier),Pi(fe.attributes)):void 0}let Ce=Gi(fe.importClause.namedBindings.elements,nt=>W.isDeclarationVisible(nt)?nt:void 0);if(Ce&&Ce.length||vt)return D.updateImportDeclaration(fe,fe.modifiers,D.updateImportClause(fe.importClause,fe.importClause.isTypeOnly,vt,Ce&&Ce.length?D.updateNamedImports(fe.importClause.namedBindings,Ce):void 0),Zr(fe,fe.moduleSpecifier),Pi(fe.attributes));if(W.isImportRequiredByAugmentation(fe))return ue&&e.addDiagnostic(pn(fe,v.Declaration_emit_for_this_file_requires_preserving_this_import_for_augmentations_This_is_not_supported_with_isolatedDeclarations)),D.updateImportDeclaration(fe,fe.modifiers,void 0,Zr(fe,fe.moduleSpecifier),Pi(fe.attributes))}function Pi(fe){let vt=BN(fe);return fe&&vt!==void 0?fe:void 0}function Cs(fe){for(;wt(S);){let Ce=S.shift();if(!Y5(Ce))return M.fail(`Late replaced statement was found which is not handled by the declaration transformer!: ${M.formatSyntaxKind(Ce.kind)}`);let nt=i;i=Ce.parent&&Ji(Ce.parent)&&!(nu(Ce.parent)&&s);let Me=Yt(Ce);i=nt,E.set(pf(Ce),Me)}return Kr(fe,vt,Vi);function vt(Ce){if(Y5(Ce)){let nt=pf(Ce);if(E.has(nt)){let Me=E.get(nt);return E.delete(nt),Me&&((Rs(Me)?Pt(Me,I5):I5(Me))&&(u=!0),Ji(Ce.parent)&&(Rs(Me)?Pt(Me,q3):q3(Me))&&(o=!0)),Me}}return Ce}}function ss(fe){if(Ui(fe))return;if(u_(fe)){if(mt(fe))return;if(h0(fe)){if(ue){if(!W.isDefinitelyReferenceToGlobalSymbolObject(fe.name.expression)){if(tu(fe.parent)||Ca(fe.parent)){e.addDiagnostic(pn(fe,v.Computed_property_names_on_class_or_object_literals_cannot_be_inferred_with_isolatedDeclarations));return}else if((Yu(fe.parent)||lf(fe.parent))&&!nc(fe.name.expression)){e.addDiagnostic(pn(fe,v.Computed_properties_must_be_number_or_string_literals_variables_or_dotted_expressions_with_isolatedDeclarations));return}}}else if(!W.isLateBound(ks(fe))||!nc(fe.name.expression))return}}if(Bs(fe)&&W.isImplementationOfOverload(fe)||Wde(fe))return;let vt;jr(fe)&&(vt=d,d=fe);let Ce=n,nt=LB(fe),Me=x,tt=(fe.kind===187||fe.kind===200)&&fe.parent.kind!==265;if((ul(fe)||$g(fe))&&up(fe,2))return fe.symbol&&fe.symbol.declarations&&fe.symbol.declarations[0]!==fe?void 0:ft(D.createPropertyDeclaration(yr(fe),fe.name,void 0,void 0,void 0));if(nt&&!x&&(n=Fv(fe)),pE(fe)&&ur(fe.exprName,d),tt&&(x=!0),GEt(fe))switch(fe.kind){case 233:{(Tf(fe.expression)||nc(fe.expression))&&ur(fe.expression,d);let tr=Mr(fe,ss,e);return ft(D.updateExpressionWithTypeArguments(tr,tr.expression,tr.typeArguments))}case 183:{ur(fe.typeName,d);let tr=Mr(fe,ss,e);return ft(D.updateTypeReferenceNode(tr,tr.typeName,tr.typeArguments))}case 180:return ft(D.updateConstructSignature(fe,xr(fe,fe.typeParameters),rr(fe,fe.parameters),_t(fe,fe.type)));case 176:{let tr=D.createConstructorDeclaration(yr(fe),rr(fe,fe.parameters,0),void 0);return ft(tr)}case 174:{if(Zi(fe.name))return ft(void 0);let tr=D.createMethodDeclaration(yr(fe),void 0,fe.name,fe.questionToken,xr(fe,fe.typeParameters),rr(fe,fe.parameters),_t(fe,fe.type),void 0);return ft(tr)}case 177:{if(Zi(fe.name))return ft(void 0);let tr=lt(fe,W1(Ca(fe.parent)?fe.parent.properties:fe.parent.members,fe));return ft(D.updateGetAccessorDeclaration(fe,yr(fe),fe.name,vr(fe,up(fe,2)),_t(fe,tr),void 0))}case 178:return Zi(fe.name)?ft(void 0):ft(D.updateSetAccessorDeclaration(fe,yr(fe),fe.name,vr(fe,up(fe,2)),void 0));case 172:return Zi(fe.name)?ft(void 0):ft(D.updatePropertyDeclaration(fe,yr(fe),fe.name,fe.questionToken,_t(fe,fe.type),Ie(fe)));case 171:return Zi(fe.name)?ft(void 0):ft(D.updatePropertySignature(fe,yr(fe),fe.name,fe.questionToken,_t(fe,fe.type)));case 173:return Zi(fe.name)?ft(void 0):ft(D.updateMethodSignature(fe,yr(fe),fe.name,fe.questionToken,xr(fe,fe.typeParameters),rr(fe,fe.parameters),_t(fe,fe.type)));case 179:return ft(D.updateCallSignature(fe,xr(fe,fe.typeParameters),rr(fe,fe.parameters),_t(fe,fe.type)));case 181:return ft(D.updateIndexSignature(fe,yr(fe),rr(fe,fe.parameters),ot(fe.type,ss,Di)||D.createKeywordTypeNode(133)));case 260:return Hs(fe.name)?An(fe.name):(tt=!0,x=!0,ft(D.updateVariableDeclaration(fe,fe.name,void 0,_t(fe,fe.type),Ie(fe))));case 168:return Ii(fe)&&(fe.default||fe.constraint)?ft(D.updateTypeParameterDeclaration(fe,fe.modifiers,fe.name,void 0,void 0)):ft(Mr(fe,ss,e));case 194:{let tr=ot(fe.checkType,ss,Di),Oe=ot(fe.extendsType,ss,Di),At=d;d=fe.trueType;let Nt=ot(fe.trueType,ss,Di);d=At;let Ut=ot(fe.falseType,ss,Di);return M.assert(tr),M.assert(Oe),M.assert(Nt),M.assert(Ut),ft(D.updateConditionalTypeNode(fe,tr,Oe,Nt,Ut))}case 184:return ft(D.updateFunctionTypeNode(fe,Kr(fe.typeParameters,ss,Ac),rr(fe,fe.parameters),M.checkDefined(ot(fe.type,ss,Di))));case 185:return ft(D.updateConstructorTypeNode(fe,yr(fe),Kr(fe.typeParameters,ss,Ac),rr(fe,fe.parameters),M.checkDefined(ot(fe.type,ss,Di))));case 205:return Ev(fe)?ft(D.updateImportTypeNode(fe,D.updateLiteralTypeNode(fe.argument,Zr(fe,fe.argument.literal)),fe.attributes,fe.qualifier,Kr(fe.typeArguments,ss,Di),fe.isTypeOf)):ft(fe);default:M.assertNever(fe,`Attempted to process unhandled node kind: ${M.formatSyntaxKind(fe.kind)}`)}return FA(fe)&&ba(J,fe.pos).line===ba(J,fe.end).line&&Tn(fe,1),ft(Mr(fe,ss,e));function ft(tr){return tr&&nt&&h0(fe)&&Ci(fe),jr(fe)&&(d=vt),nt&&!x&&(n=Ce),tt&&(x=Me),tr===fe?tr:tr&&zn(or(tr,fe),fe)}}function Ii(fe){return fe.parent.kind===174&&up(fe.parent,2)}function $r(fe){if(!HEt(fe)||Ui(fe))return;switch(fe.kind){case 278:return Ji(fe.parent)&&(o=!0),m=!0,D.updateExportDeclaration(fe,fe.modifiers,fe.isTypeOnly,fe.exportClause,Zr(fe,fe.moduleSpecifier),Pi(fe.attributes));case 277:{if(Ji(fe.parent)&&(o=!0),m=!0,fe.expression.kind===80)return fe;{let Ce=D.createUniqueName("_default",16);n=()=>({diagnosticMessage:v.Default_export_of_the_module_has_or_is_using_private_name_0,errorNode:fe}),F=fe;let nt=D.createVariableDeclaration(Ce,void 0,W.createTypeOfExpression(fe.expression,fe,V8,R),void 0);F=void 0;let Me=D.createVariableStatement(i?[D.createModifier(138)]:[],D.createVariableDeclarationList([nt],2));return or(Me,fe),n8(fe),[Me,D.updateExportAssignment(fe,fe.modifiers,Ce)]}}}let vt=Yt(fe);return E.set(pf(fe),vt),fe}function Xs(fe){if(ru(fe)||up(fe,2048)||!wm(fe))return fe;let vt=D.createModifiersFromModifierFlags(U_(fe)&131039);return D.replaceModifiers(fe,vt)}function $e(fe,vt,Ce,nt){let Me=D.updateModuleDeclaration(fe,vt,Ce,nt);if(B_(Me)||Me.flags&32)return Me;let tt=D.createModuleDeclaration(Me.modifiers,Me.name,Me.body,Me.flags|32);return zn(tt,Me),Et(tt,Me),tt}function Yt(fe){if(S)for(;Gw(S,fe););if(Ui(fe))return;switch(fe.kind){case 271:return Oi(fe);case 272:return Sr(fe)}if(u_(fe)&&mt(fe)||Xg(fe)||Bs(fe)&&W.isImplementationOfOverload(fe))return;let vt;jr(fe)&&(vt=d,d=fe);let Ce=LB(fe),nt=n;Ce&&(n=Fv(fe));let Me=i;switch(fe.kind){case 265:{i=!1;let ft=tt(D.updateTypeAliasDeclaration(fe,yr(fe),fe.name,Kr(fe.typeParameters,ss,Ac),M.checkDefined(ot(fe.type,ss,Di))));return i=Me,ft}case 264:return tt(D.updateInterfaceDeclaration(fe,yr(fe),fe.name,xr(fe,fe.typeParameters),St(fe.heritageClauses),Kr(fe.members,ss,$T)));case 262:{let ft=tt(D.updateFunctionDeclaration(fe,yr(fe),void 0,fe.name,xr(fe,fe.typeParameters),rr(fe,fe.parameters),_t(fe,fe.type),void 0));if(ft&&W.isExpandoFunctionDeclaration(fe)&&Xe(fe)){let tr=W.getPropertiesOfContainerFunction(fe);ue&&ce(fe);let Oe=Cb.createModuleDeclaration(void 0,ft.name||D.createIdentifier("_default"),D.createModuleBlock([]),32);lo(Oe,d),Oe.locals=fa(tr),Oe.symbol=tr[0].parent;let At=[],Nt=Gi(tr,bt=>{if(!CA(bt.valueDeclaration))return;let Q=Qi(bt.escapedName);if(!sp(Q,99))return;n=Fv(bt.valueDeclaration);let Ke=W.createTypeOfDeclaration(bt.valueDeclaration,Oe,V8|-2147483648,R);n=nt;let z=uA(Q),Ue=z?D.getGeneratedNameForNode(bt.valueDeclaration):D.createIdentifier(Q);z&&At.push([Ue,Q]);let Te=D.createVariableDeclaration(Ue,void 0,Ke,void 0);return D.createVariableStatement(z?void 0:[D.createToken(95)],D.createVariableDeclarationList([Te]))});At.length?Nt.push(D.createExportDeclaration(void 0,!1,D.createNamedExports(Cr(At,([bt,Q])=>D.createExportSpecifier(!1,bt,Q))))):Nt=Gi(Nt,bt=>D.replaceModifiers(bt,0));let Ut=D.createModuleDeclaration(yr(fe),fe.name,D.createModuleBlock(Nt),32);if(!up(ft,2048))return[ft,Ut];let Rt=D.createModifiersFromModifierFlags(U_(ft)&-2081|128),nr=D.updateFunctionDeclaration(ft,Rt,void 0,ft.name,ft.typeParameters,ft.parameters,ft.type,void 0),Z=D.updateModuleDeclaration(Ut,Rt,Ut.name,Ut.body),Ge=D.createExportAssignment(void 0,!1,Ut.name);return Ji(fe.parent)&&(o=!0),m=!0,[nr,Z,Ge]}else return ft}case 267:{i=!1;let ft=fe.body;if(ft&&ft.kind===268){let tr=u,Oe=m;m=!1,u=!1;let At=Kr(ft.statements,$r,Vi),Nt=Cs(At);fe.flags&33554432&&(u=!1),!Rg(fe)&&!Gs(Nt)&&!m&&(u?Nt=D.createNodeArray([...Nt,m8(D)]):Nt=Kr(Nt,Xs,Vi));let Ut=D.updateModuleBlock(ft,Nt);i=Me,u=tr,m=Oe;let Rt=yr(fe);return tt($e(fe,Rt,YT(fe)?Zr(fe,fe.name):fe.name,Ut))}else{i=Me;let tr=yr(fe);i=!1,ot(ft,$r);let Oe=pf(ft),At=E.get(Oe);return E.delete(Oe),tt($e(fe,tr,fe.name,At))}}case 263:{L=fe.name,F=fe;let ft=D.createNodeArray(yr(fe)),tr=xr(fe,fe.typeParameters),Oe=Ny(fe),At;if(Oe){let Ge=n;At=cn(va(Oe.parameters,bt=>{if(!li(bt,31)||Ui(bt))return;if(n=Fv(bt),bt.name.kind===80)return or(D.createPropertyDeclaration(yr(bt),bt.name,bt.questionToken,_t(bt,bt.type),Ie(bt)),bt);return Q(bt.name);function Q(Ke){let z;for(let Ue of Ke.elements)pu(Ue)||(Hs(Ue.name)&&(z=ps(z,Q(Ue.name))),z=z||[],z.push(D.createPropertyDeclaration(yr(bt),Ue.name,void 0,_t(Ue,void 0),void 0)));return z}})),n=Ge}let Ut=Pt(fe.members,Ge=>!!Ge.name&&Zi(Ge.name))?[D.createPropertyDeclaration(void 0,D.createPrivateIdentifier("#private"),void 0,void 0,void 0)]:void 0,Rt=ps(ps(Ut,At),Kr(fe.members,ss,uu)),nr=D.createNodeArray(Rt),Z=Fg(fe);if(Z&&!nc(Z.expression)&&Z.expression.kind!==106){let Ge=fe.name?Qi(fe.name.escapedText):"default",bt=D.createUniqueName(`${Ge}_base`,16);n=()=>({diagnosticMessage:v.extends_clause_of_exported_class_0_has_or_is_using_private_name_1,errorNode:Z,typeName:fe.name});let Q=D.createVariableDeclaration(bt,void 0,W.createTypeOfExpression(Z.expression,fe,V8,R),void 0),Ke=D.createVariableStatement(i?[D.createModifier(138)]:[],D.createVariableDeclarationList([Q],2)),z=D.createNodeArray(Cr(fe.heritageClauses,Ue=>{if(Ue.token===96){let Te=n;n=Fv(Ue.types[0]);let Re=D.updateHeritageClause(Ue,Cr(Ue.types,It=>D.updateExpressionWithTypeArguments(It,bt,Kr(It.typeArguments,ss,Di))));return n=Te,Re}return D.updateHeritageClause(Ue,Kr(D.createNodeArray(Zn(Ue.types,Te=>nc(Te.expression)||Te.expression.kind===106)),ss,x0))}));return[Ke,tt(D.updateClassDeclaration(fe,ft,fe.name,tr,z,nr))]}else{let Ge=St(fe.heritageClauses);return tt(D.updateClassDeclaration(fe,ft,fe.name,tr,Ge,nr))}}case 243:return tt(Vr(fe));case 266:return tt(D.updateEnumDeclaration(fe,D.createNodeArray(yr(fe)),fe.name,D.createNodeArray(Gi(fe.members,ft=>{if(Ui(ft))return;let tr=W.getEnumMemberValue(ft),Oe=tr?.value;ue&&ft.initializer&&tr?.hasExternalReferences&&!za(ft.name)&&e.addDiagnostic(pn(ft,v.Enum_member_initializers_must_be_computable_without_references_to_external_symbols_with_isolatedDeclarations));let At=Oe===void 0?void 0:typeof Oe=="string"?D.createStringLiteral(Oe):Oe<0?D.createPrefixUnaryExpression(41,D.createNumericLiteral(-Oe)):D.createNumericLiteral(Oe);return or(D.updateEnumMember(ft,ft.name,At),ft)}))))}return M.assertNever(fe,`Unhandled top-level node in declaration emit: ${M.formatSyntaxKind(fe.kind)}`);function tt(ft){return jr(fe)&&(d=vt),Ce&&(n=nt),fe.kind===267&&(i=Me),ft===fe?ft:(F=void 0,L=void 0,ft&&zn(or(ft,fe),fe))}}function Vr(fe){if(!kt(fe.declarationList.declarations,ht))return;let vt=Kr(fe.declarationList.declarations,ss,Ei);if(!wt(vt))return;let Ce=D.createNodeArray(yr(fe)),nt;return rR(fe.declarationList)||tR(fe.declarationList)?(nt=D.createVariableDeclarationList(vt,2),zn(nt,fe.declarationList),Et(nt,fe.declarationList),Zl(nt,fe.declarationList)):nt=D.updateVariableDeclarationList(fe.declarationList,vt),D.updateVariableStatement(fe,Ce,nt)}function An(fe){return ef(Gi(fe.elements,vt=>vi(vt)))}function vi(fe){if(fe.kind!==232&&fe.name)return ht(fe)?Hs(fe.name)?An(fe.name):D.createVariableDeclaration(fe.name,void 0,_t(fe,void 0),void 0):void 0}function Ci(fe){let vt;x||(vt=n,n=khe(fe)),L=fe.name,M.assert(h0(fe));let nt=fe.name.expression;ur(nt,d),x||(n=vt),L=void 0}function Ui(fe){return!!re&&!!fe&&h_e(fe,J)}function la(fe){return dc(fe)||xl(fe)}function Gs(fe){return Pt(fe,la)}function yr(fe){let vt=U_(fe),Ce=to(fe);return vt===Ce?F8(fe.modifiers,nt=>ai(nt,Pa),Pa):D.createModifiersFromModifierFlags(Ce)}function to(fe){let vt=130030,Ce=i&&!WEt(fe)?128:0,nt=fe.parent.kind===307;return(!nt||s&&nt&&nu(fe.parent))&&(vt^=128,Ce=0),d8e(fe,vt,Ce)}function lt(fe,vt){let Ce=Dhe(fe);return!Ce&&fe!==vt.firstAccessor&&(Ce=Dhe(vt.firstAccessor),n=Fv(vt.firstAccessor)),!Ce&&vt.secondAccessor&&fe!==vt.secondAccessor&&(Ce=Dhe(vt.secondAccessor),n=Fv(vt.secondAccessor)),Ce}function St(fe){return D.createNodeArray(Zn(Cr(fe,vt=>D.updateHeritageClause(vt,Kr(D.createNodeArray(Zn(vt.types,Ce=>nc(Ce.expression)||vt.token===96&&Ce.expression.kind===106)),ss,x0))),vt=>vt.types&&!!vt.types.length))}}function WEt(e){return e.kind===264}function $Et(e,t,n,i){return e.createModifiersFromModifierFlags(d8e(t,n,i))}function d8e(e,t=131070,n=0){let i=U_(e)&t|n;return i&2048&&!(i&32)&&(i^=32),i&2048&&i&128&&(i^=128),i}function Dhe(e){if(e)return e.kind===177?e.type:e.parameters.length>0?e.parameters[0].type:void 0}function m8e(e){switch(e.kind){case 172:case 171:return!up(e,2);case 169:case 260:return!0}return!1}function HEt(e){switch(e.kind){case 262:case 267:case 271:case 264:case 263:case 265:case 266:case 243:case 272:case 278:case 277:return!0}return!1}function GEt(e){switch(e.kind){case 180:case 176:case 174:case 177:case 178:case 172:case 171:case 173:case 179:case 181:case 260:case 168:case 233:case 183:case 194:case 184:case 185:case 205:return!0}return!1}function YEt(e){switch(e){case 99:case 7:case 6:case 5:case 200:return MK;case 4:return Che;case 100:case 199:return Ahe;default:return RK}}var whe={scriptTransformers:ve,declarationTransformers:ve};function Ihe(e,t,n){return{scriptTransformers:KEt(e,t,n),declarationTransformers:XEt(t)}}function KEt(e,t,n){if(n)return ve;let i=Ka(e),s=V_(e),o=$R(e),u=[];return wn(u,t&&Cr(t.before,h8e)),u.push(che),e.experimentalDecorators&&u.push(_he),X9(e)&&u.push(bhe),i<99&&u.push(yhe),!e.experimentalDecorators&&(i<99||!o)&&u.push(fhe),u.push(lhe),i<8&&u.push(hhe),i<7&&u.push(ghe),i<6&&u.push(mhe),i<5&&u.push(dhe),i<4&&u.push(phe),i<3&&u.push(The),i<2&&(u.push(Ehe),u.push(xhe)),u.push(YEt(s)),wn(u,t&&Cr(t.after,h8e)),u}function XEt(e){let t=[];return t.push(LK),wn(t,e&&Cr(e.afterDeclarations,ZEt)),t}function QEt(e){return t=>Kde(t)?e.transformBundle(t):e.transformSourceFile(t)}function g8e(e,t){return n=>{let i=e(n);return typeof i=="function"?t(n,i):QEt(i)}}function h8e(e){return g8e(e,cg)}function ZEt(e){return g8e(e,(t,n)=>n)}function n6(e,t){return t}function J8(e,t,n){n(e,t)}function q8(e,t,n,i,s,o,u){var m,d;let S=new Array(357),E,x,D,w=0,R=[],L=[],F=[],J=[],G=0,q=!1,ee=[],W=0,pe,K,re=n6,ue=J8,ce=0,ne=[],le={factory:n,getCompilerOptions:()=>i,getEmitResolver:()=>e,getEmitHost:()=>t,getEmitHelperFactory:tf(()=>sde(le)),startLexicalEnvironment:qe,suspendLexicalEnvironment:et,resumeLexicalEnvironment:Ie,endLexicalEnvironment:_t,setLexicalEnvironmentFlags:mt,getLexicalEnvironmentFlags:Xe,hoistVariableDeclaration:De,hoistFunctionDeclaration:Be,addInitializationStatement:ct,startBlockScope:ht,endBlockScope:rr,addBlockScopedVariable:vr,requestEmitHelper:xr,readEmitHelpers:jr,enableSubstitution:te,enableEmitNotification:Ve,isSubstitutionEnabled:he,isEmitNotificationEnabled:Pe,get onSubstituteNode(){return re},set onSubstituteNode(or){M.assert(ce<1,"Cannot modify transformation hooks after initialization has completed."),M.assert(or!==void 0,"Value must not be 'undefined'"),re=or},get onEmitNode(){return ue},set onEmitNode(or){M.assert(ce<1,"Cannot modify transformation hooks after initialization has completed."),M.assert(or!==void 0,"Value must not be 'undefined'"),ue=or},addDiagnostic(or){ne.push(or)}};for(let or of s)VG(Ur(ks(or)));jc("beforeTransform");let me=o.map(or=>or(le)),de=or=>{for(let Zr of me)or=Zr(or);return or};ce=1;let Ae=[];for(let or of s)(m=Cn)==null||m.push(Cn.Phase.Emit,"transformNodes",or.kind===307?{path:or.path}:{kind:or.kind,pos:or.pos,end:or.end}),Ae.push((u?de:xe)(or)),(d=Cn)==null||d.pop();return ce=2,jc("afterTransform"),vd("transformTime","beforeTransform","afterTransform"),{transformed:Ae,substituteNode:be,emitNodeWithNotification:ke,isEmitNotificationEnabled:Pe,dispose:ur,diagnostics:ne};function xe(or){return or&&(!Ji(or)||!or.isDeclarationFile)?de(or):or}function te(or){M.assert(ce<2,"Cannot modify the transformation context after transformation has completed."),S[or]|=1}function he(or){return(S[or.kind]&1)!==0&&(Ga(or)&8)===0}function be(or,Zr){return M.assert(ce<3,"Cannot substitute a node after the result is disposed."),Zr&&he(Zr)&&re(or,Zr)||Zr}function Ve(or){M.assert(ce<2,"Cannot modify the transformation context after transformation has completed."),S[or]|=2}function Pe(or){return(S[or.kind]&2)!==0||(Ga(or)&4)!==0}function ke(or,Zr,Oi){M.assert(ce<3,"Cannot invoke TransformationResult callbacks after the result is disposed."),Zr&&(Pe(Zr)?ue(or,Zr,Oi):Oi(or,Zr))}function De(or){M.assert(ce>0,"Cannot modify the lexical environment during initialization."),M.assert(ce<2,"Cannot modify the lexical environment after transformation has completed.");let Zr=Tn(n.createVariableDeclaration(or),128);E?E.push(Zr):E=[Zr],w&1&&(w|=2)}function Be(or){M.assert(ce>0,"Cannot modify the lexical environment during initialization."),M.assert(ce<2,"Cannot modify the lexical environment after transformation has completed."),Tn(or,2097152),x?x.push(or):x=[or]}function ct(or){M.assert(ce>0,"Cannot modify the lexical environment during initialization."),M.assert(ce<2,"Cannot modify the lexical environment after transformation has completed."),Tn(or,2097152),D?D.push(or):D=[or]}function qe(){M.assert(ce>0,"Cannot modify the lexical environment during initialization."),M.assert(ce<2,"Cannot modify the lexical environment after transformation has completed."),M.assert(!q,"Lexical environment is suspended."),R[G]=E,L[G]=x,F[G]=D,J[G]=w,G++,E=void 0,x=void 0,D=void 0,w=0}function et(){M.assert(ce>0,"Cannot modify the lexical environment during initialization."),M.assert(ce<2,"Cannot modify the lexical environment after transformation has completed."),M.assert(!q,"Lexical environment is already suspended."),q=!0}function Ie(){M.assert(ce>0,"Cannot modify the lexical environment during initialization."),M.assert(ce<2,"Cannot modify the lexical environment after transformation has completed."),M.assert(q,"Lexical environment is not suspended."),q=!1}function _t(){M.assert(ce>0,"Cannot modify the lexical environment during initialization."),M.assert(ce<2,"Cannot modify the lexical environment after transformation has completed."),M.assert(!q,"Lexical environment is suspended.");let or;if(E||x||D){if(x&&(or=[...x]),E){let Zr=n.createVariableStatement(void 0,n.createVariableDeclarationList(E));Tn(Zr,2097152),or?or.push(Zr):or=[Zr]}D&&(or?or=[...or,...D]:or=[...D])}return G--,E=R[G],x=L[G],D=F[G],w=J[G],G===0&&(R=[],L=[],F=[],J=[]),or}function mt(or,Zr){w=Zr?w|or:w&~or}function Xe(){return w}function ht(){M.assert(ce>0,"Cannot start a block scope during initialization."),M.assert(ce<2,"Cannot start a block scope after transformation has completed."),ee[W]=pe,W++,pe=void 0}function rr(){M.assert(ce>0,"Cannot end a block scope during initialization."),M.assert(ce<2,"Cannot end a block scope after transformation has completed.");let or=Pt(pe)?[n.createVariableStatement(void 0,n.createVariableDeclarationList(pe.map(Zr=>n.createVariableDeclaration(Zr)),1))]:void 0;return W--,pe=ee[W],W===0&&(ee=[]),or}function vr(or){M.assert(W>0,"Cannot add a block scoped variable outside of an iteration body."),(pe||(pe=[])).push(or)}function xr(or){if(M.assert(ce>0,"Cannot modify the transformation context during initialization."),M.assert(ce<2,"Cannot modify the transformation context after transformation has completed."),M.assert(!or.scoped,"Cannot request a scoped emit helper."),or.dependencies)for(let Zr of or.dependencies)xr(Zr);K=Bt(K,or)}function jr(){M.assert(ce>0,"Cannot modify the transformation context during initialization."),M.assert(ce<2,"Cannot modify the transformation context after transformation has completed.");let or=K;return K=void 0,or}function ur(){if(ce<3){for(let or of s)VG(Ur(ks(or)));E=void 0,R=void 0,x=void 0,L=void 0,re=void 0,ue=void 0,K=void 0,ce=3}}}var z8={factory:U,getCompilerOptions:()=>({}),getEmitResolver:_a,getEmitHost:_a,getEmitHelperFactory:_a,startLexicalEnvironment:io,resumeLexicalEnvironment:io,suspendLexicalEnvironment:io,endLexicalEnvironment:VT,setLexicalEnvironmentFlags:io,getLexicalEnvironmentFlags:()=>0,hoistVariableDeclaration:io,hoistFunctionDeclaration:io,addInitializationStatement:io,startBlockScope:io,endBlockScope:VT,addBlockScopedVariable:io,requestEmitHelper:io,readEmitHelpers:_a,enableSubstitution:io,enableEmitNotification:io,isSubstitutionEnabled:_a,isEmitNotificationEnabled:_a,onSubstituteNode:n6,onEmitNode:J8,addDiagnostic:io},y8e=ext();function Ohe(e){return Ic(e,".tsbuildinfo")}function FK(e,t,n,i=!1,s,o){let u=Rs(n)?n:P9(e,n,i),m=e.getCompilerOptions();if(m.outFile){if(u.length){let d=U.createBundle(u),S=t(i6(d,e,i),d);if(S)return S}}else{if(!s)for(let d of u){let S=t(i6(d,e,i),d);if(S)return S}if(o){let d=jv(m);if(d)return t({buildInfoPath:d},void 0)}}}function jv(e){let t=e.configFilePath;if(!nO(e))return;if(e.tsBuildInfoFile)return e.tsBuildInfoFile;let n=e.outFile,i;if(n)i=of(n);else{if(!t)return;let s=of(t);i=e.outDir?e.rootDir?QS(e.outDir,Xm(e.rootDir,s,!0)):ri(e.outDir,Ul(s)):s}return i+".tsbuildinfo"}function FB(e,t){let n=e.outFile,i=e.emitDeclarationOnly?void 0:n,s=i&&v8e(i,e),o=t||$p(e)?of(n)+".d.ts":void 0,u=o&&$9(e)?o+".map":void 0,m=jv(e);return{jsFilePath:i,sourceMapFilePath:s,declarationFilePath:o,declarationMapPath:u,buildInfoPath:m}}function i6(e,t,n){let i=t.getCompilerOptions();if(e.kind===308)return FB(i,n);{let s=Afe(e.fileName,t,jB(e.fileName,i)),o=Kd(e),u=o&&_0(e.fileName,s,t.getCurrentDirectory(),!t.useCaseSensitiveFileNames())===0,m=i.emitDeclarationOnly||u?void 0:s,d=!m||Kd(e)?void 0:v8e(m,i),S=n||$p(i)&&!o?kfe(e.fileName,t):void 0,E=S&&$9(i)?S+".map":void 0;return{jsFilePath:m,sourceMapFilePath:d,declarationFilePath:S,declarationMapPath:E,buildInfoPath:void 0}}}function v8e(e,t){return t.sourceMap&&!t.inlineSourceMap?e+".map":void 0}function jB(e,t){return Ic(e,".json")?".json":t.jsx===1&&wl(e,[".jsx",".tsx"])?".jsx":wl(e,[".mts",".mjs"])?".mjs":wl(e,[".cts",".cjs"])?".cjs":".js"}function S8e(e,t,n,i){return n?QS(n,Xm(i(),e,t)):e}function jN(e,t,n,i=()=>tk(t,n)){return jK(e,t.options,n,i)}function jK(e,t,n,i){return Y1(S8e(e,n,t.declarationDir||t.outDir,i),A9(e))}function b8e(e,t,n,i=()=>tk(t,n)){if(t.options.emitDeclarationOnly)return;let s=Ic(e,".json"),o=BK(e,t.options,n,i);return!s||_0(e,o,M.checkDefined(t.options.configFilePath),n)!==0?o:void 0}function BK(e,t,n,i){return Y1(S8e(e,n,t.outDir,i),jB(e,t))}function T8e(){let e;return{addOutput:t,getOutputs:n};function t(i){i&&(e||(e=[])).push(i)}function n(){return e||ve}}function E8e(e,t){let{jsFilePath:n,sourceMapFilePath:i,declarationFilePath:s,declarationMapPath:o,buildInfoPath:u}=FB(e.options,!1);t(n),t(i),t(s),t(o),t(u)}function x8e(e,t,n,i,s){if(Mu(t))return;let o=b8e(t,e,n,s);if(i(o),!Ic(t,".json")&&(o&&e.options.sourceMap&&i(`${o}.map`),$p(e.options))){let u=jN(t,e,n,s);i(u),e.options.declarationMap&&i(`${u}.map`)}}function s6(e,t,n,i,s){let o;return e.rootDir?(o=xs(e.rootDir,n),s?.(e.rootDir)):e.composite&&e.configFilePath?(o=mi(qu(e.configFilePath)),s?.(o)):o=Vhe(t(),n,i),o&&o[o.length-1]!==Ec&&(o+=Ec),o}function tk({options:e,fileNames:t},n){return s6(e,()=>Zn(t,i=>!(e.noEmitForJsFiles&&wl(i,_N))&&!Mu(i)),mi(qu(M.checkDefined(e.configFilePath))),l_(!n))}function BB(e,t){let{addOutput:n,getOutputs:i}=T8e();if(e.options.outFile)E8e(e,n);else{let s=tf(()=>tk(e,t));for(let o of e.fileNames)x8e(e,o,t,n,s);n(jv(e.options))}return i()}function C8e(e,t,n){t=Zs(t),M.assert(Es(e.fileNames,t),"Expected fileName to be present in command line");let{addOutput:i,getOutputs:s}=T8e();return e.options.outFile?E8e(e,i):x8e(e,t,n,i),s()}function UK(e,t){if(e.options.outFile){let{jsFilePath:s,declarationFilePath:o}=FB(e.options,!1);return M.checkDefined(s||o,`project ${e.options.configFilePath} expected to have at least one output`)}let n=tf(()=>tk(e,t));for(let s of e.fileNames){if(Mu(s))continue;let o=b8e(s,e,t,n);if(o)return o;if(!Ic(s,".json")&&$p(e.options))return jN(s,e,t,n)}let i=jv(e.options);return i||M.fail(`project ${e.options.configFilePath} expected to have at least one output`)}function VK(e,t){return!!t&&!!e}function JK(e,t,n,{scriptTransformers:i,declarationTransformers:s},o,u,m){var d=t.getCompilerOptions(),S=d.sourceMap||d.inlineSourceMap||$9(d)?[]:void 0,E=d.listEmittedFiles?[]:void 0,x=WI(),D=wv(d),w=MR(D),{enter:R,exit:L}=qW("printTime","beforePrint","afterPrint"),F=!1;return R(),FK(t,J,P9(t,n,m),m,u,!n),L(),{emitSkipped:F,diagnostics:x.getDiagnostics(),emittedFiles:E,sourceMaps:S};function J({jsFilePath:le,sourceMapFilePath:me,declarationFilePath:de,declarationMapPath:Ae,buildInfoPath:xe},te){var he,be,Ve,Pe,ke,De;(he=Cn)==null||he.push(Cn.Phase.Emit,"emitJsFileOrBundle",{jsFilePath:le}),q(te,le,me),(be=Cn)==null||be.pop(),(Ve=Cn)==null||Ve.push(Cn.Phase.Emit,"emitDeclarationFileOrBundle",{declarationFilePath:de}),ee(te,de,Ae),(Pe=Cn)==null||Pe.pop(),(ke=Cn)==null||ke.push(Cn.Phase.Emit,"emitBuildInfo",{buildInfoPath:xe}),G(xe),(De=Cn)==null||De.pop()}function G(le){if(!le||n||F)return;if(t.isEmitBlocked(le)){F=!0;return}let me=t.getBuildInfo()||UB(void 0);LR(t,x,le,Rhe(me),!1,void 0,{buildInfo:me}),E?.push(le)}function q(le,me,de){if(!le||o||!me)return;if(t.isEmitBlocked(me)||d.noEmit){F=!0;return}(Ji(le)?[le]:Zn(le.sourceFiles,f9)).forEach(he=>{(d.noCheck||!KR(he,d))&&pe(he)});let Ae=q8(e,t,U,d,[le],i,!1),xe={removeComments:d.removeComments,newLine:d.newLine,noEmitHelpers:d.noEmitHelpers,module:V_(d),target:Ka(d),sourceMap:d.sourceMap,inlineSourceMap:d.inlineSourceMap,inlineSources:d.inlineSources,extendedDiagnostics:d.extendedDiagnostics},te=oS(xe,{hasGlobalName:e.hasGlobalName,onEmitNode:Ae.emitNodeWithNotification,isEmitNotificationEnabled:Ae.isEmitNotificationEnabled,substituteNode:Ae.substituteNode});M.assert(Ae.transformed.length===1,"Should only see one output from the transform"),K(me,de,Ae,te,d),Ae.dispose(),E&&(E.push(me),de&&E.push(de))}function ee(le,me,de){if(!le||o===0)return;if(!me){(o||d.emitDeclarationOnly)&&(F=!0);return}let Ae=Ji(le)?[le]:le.sourceFiles,xe=m?Ae:Zn(Ae,f9),te=d.outFile?[U.createBundle(xe)]:xe;xe.forEach(Ve=>{(o&&!$p(d)||d.noCheck||VK(o,m)||!KR(Ve,d))&&W(Ve)});let he=q8(e,t,U,d,te,s,!1);if(wt(he.diagnostics))for(let Ve of he.diagnostics)x.add(Ve);let be=!!he.diagnostics&&!!he.diagnostics.length||!!t.isEmitBlocked(me)||!!d.noEmit;if(F=F||be,!be||m){M.assert(he.transformed.length===1,"Should only see one output from the decl transform");let Ve={removeComments:d.removeComments,newLine:d.newLine,noEmitHelpers:!0,module:d.module,target:d.target,sourceMap:o!==2&&d.declarationMap,inlineSourceMap:d.inlineSourceMap,extendedDiagnostics:d.extendedDiagnostics,onlyPrintJsDocStyle:!0,omitBraceSourceMapPositions:!0},Pe=oS(Ve,{hasGlobalName:e.hasGlobalName,onEmitNode:he.emitNodeWithNotification,isEmitNotificationEnabled:he.isEmitNotificationEnabled,substituteNode:he.substituteNode});K(me,de,he,Pe,{sourceMap:Ve.sourceMap,sourceRoot:d.sourceRoot,mapRoot:d.mapRoot,extendedDiagnostics:d.extendedDiagnostics}),E&&(E.push(me),de&&E.push(de))}he.dispose()}function W(le){if(dc(le)){le.expression.kind===80&&e.collectLinkedAliases(le.expression,!0);return}else if(b_(le)){e.collectLinkedAliases(le.propertyName||le.name,!0);return}Js(le,W)}function pe(le){$A(le,me=>{if(ru(me)&&!(Nv(me)&32)||Yc(me))return"skip";e.markLinkedReferences(me)})}function K(le,me,de,Ae,xe){let te=de.transformed[0],he=te.kind===308?te:void 0,be=te.kind===307?te:void 0,Ve=he?he.sourceFiles:[be],Pe;re(xe,te)&&(Pe=jge(t,Ul(qu(le)),ue(xe),ce(xe,le,be),xe)),he?Ae.writeBundle(he,w,Pe):Ae.writeFile(be,w,Pe);let ke;if(Pe){S&&S.push({inputSourceFileNames:Pe.getSources(),sourceMap:Pe.toJSON()});let Be=ne(xe,Pe,le,me,be);if(Be&&(w.isAtStartOfLine()||w.rawWrite(D),ke=w.getTextPos(),w.writeComment(`//# sourceMappingURL=${Be}`)),me){let ct=Pe.toString();LR(t,x,me,ct,!1,Ve)}}else w.writeLine();let De=w.getText();LR(t,x,le,De,!!d.emitBOM,Ve,{sourceMapUrlPos:ke,diagnostics:de.diagnostics}),w.clear()}function re(le,me){return(le.sourceMap||le.inlineSourceMap)&&(me.kind!==307||!Ic(me.fileName,".json"))}function ue(le){let me=qu(le.sourceRoot||"");return me&&yu(me)}function ce(le,me,de){if(le.sourceRoot)return t.getCommonSourceDirectory();if(le.mapRoot){let Ae=qu(le.mapRoot);return de&&(Ae=mi(N9(de.fileName,t,Ae))),Rh(Ae)===0&&(Ae=ri(t.getCommonSourceDirectory(),Ae)),Ae}return mi(Zs(me))}function ne(le,me,de,Ae,xe){if(le.inlineSourceMap){let he=me.toString();return`data:application/json;base64,${Hfe(lu,he)}`}let te=Ul(qu(M.checkDefined(Ae)));if(le.mapRoot){let he=qu(le.mapRoot);return xe&&(he=mi(N9(xe.fileName,t,he))),Rh(he)===0?(he=ri(t.getCommonSourceDirectory(),he),encodeURI(WC(mi(Zs(de)),ri(he,te),t.getCurrentDirectory(),t.getCanonicalFileName,!0))):encodeURI(ri(he,te))}return encodeURI(te)}}function UB(e){return{program:e,version:se}}function Rhe(e){return JSON.stringify(e)}function qK(e,t){return nG(e,t)}var Mhe={hasGlobalName:_a,getReferencedExportContainer:_a,getReferencedImportDeclaration:_a,getReferencedDeclarationWithCollidingName:_a,isDeclarationWithCollidingName:_a,isValueAliasDeclaration:_a,isReferencedAliasDeclaration:_a,isTopLevelValueImportEqualsWithEntityName:_a,hasNodeCheckFlag:_a,isDeclarationVisible:_a,isLateBound:e=>!1,collectLinkedAliases:_a,markLinkedReferences:_a,isImplementationOfOverload:_a,requiresAddingImplicitUndefined:_a,isExpandoFunctionDeclaration:_a,getPropertiesOfContainerFunction:_a,createTypeOfDeclaration:_a,createReturnTypeOfSignatureDeclaration:_a,createTypeOfExpression:_a,createLiteralConstValue:_a,isSymbolAccessible:_a,isEntityNameVisible:_a,getConstantValue:_a,getEnumMemberValue:_a,getReferencedValueDeclaration:_a,getReferencedValueDeclarations:_a,getTypeReferenceSerializationKind:_a,isOptionalParameter:_a,isArgumentsLocalBinding:_a,getExternalModuleFileFromDeclaration:_a,isLiteralConstDeclaration:_a,getJsxFactoryEntity:_a,getJsxFragmentFactoryEntity:_a,isBindingCapturedByNode:_a,getDeclarationStatementsForSourceFile:_a,isImportRequiredByAugmentation:_a,isDefinitelyReferenceToGlobalSymbolObject:_a},Lhe=tf(()=>oS({})),v2=tf(()=>oS({removeComments:!0})),Fhe=tf(()=>oS({removeComments:!0,neverAsciiEscape:!0})),VB=tf(()=>oS({removeComments:!0,omitTrailingSemicolon:!0}));function oS(e={},t={}){var{hasGlobalName:n,onEmitNode:i=J8,isEmitNotificationEnabled:s,substituteNode:o=n6,onBeforeEmitNode:u,onAfterEmitNode:m,onBeforeEmitNodeArray:d,onAfterEmitNodeArray:S,onBeforeEmitToken:E,onAfterEmitToken:x}=t,D=!!e.extendedDiagnostics,w=!!e.omitBraceSourceMapPositions,R=wv(e),L=V_(e),F=new Map,J,G,q,ee,W,pe,K,re,ue,ce,ne,le,me,de,Ae,xe=e.preserveSourceNewlines,te,he,be,Ve=J6,Pe,ke=!0,De,Be,ct=-1,qe,et=-1,Ie=-1,_t=-1,mt=-1,Xe,ht,rr=!1,vr=!!e.removeComments,xr,jr,{enter:ur,exit:or}=bOe(D,"commentTime","beforeComment","afterComment"),Zr=U.parenthesizer,Oi={select:O=>O===0?Zr.parenthesizeLeadingTypeArgument:void 0},Sr=au();return la(),{printNode:Pi,printList:Cs,printFile:Ii,printBundle:ss,writeNode:$r,writeList:Xs,writeFile:Yt,writeBundle:$e};function Pi(O,ye,Dt){switch(O){case 0:M.assert(Ji(ye),"Expected a SourceFile node.");break;case 2:M.assert(He(ye),"Expected an Identifier node.");break;case 1:M.assert(Ct(ye),"Expected an Expression node.");break}switch(ye.kind){case 307:return Ii(ye);case 308:return ss(ye)}return $r(O,ye,Dt,Vr()),An()}function Cs(O,ye,Dt){return Xs(O,ye,Dt,Vr()),An()}function ss(O){return $e(O,Vr(),void 0),An()}function Ii(O){return Yt(O,Vr(),void 0),An()}function $r(O,ye,Dt,Zt){let bi=he;Ui(Zt,void 0),vi(O,ye,Dt),la(),he=bi}function Xs(O,ye,Dt,Zt){let bi=he;Ui(Zt,void 0),Dt&&Ci(Dt),sc(void 0,ye,O),la(),he=bi}function $e(O,ye,Dt){Pe=!1;let Zt=he;Ui(ye,Dt),j0(O),F0(O),Rt(O),V6(O);for(let bi of O.sourceFiles)vi(0,bi,bi);la(),he=Zt}function Yt(O,ye,Dt){Pe=!0;let Zt=he;Ui(ye,Dt),j0(O),F0(O),vi(0,O,O),la(),he=Zt}function Vr(){return be||(be=MR(R))}function An(){let O=be.getText();return be.clear(),O}function vi(O,ye,Dt){Dt&&Ci(Dt),Ce(O,ye,void 0)}function Ci(O){J=O,Xe=void 0,ht=void 0,O&&fd(O)}function Ui(O,ye){O&&e.omitTrailingSemicolon&&(O=zH(O)),he=O,De=ye,ke=!he||!De}function la(){G=[],q=[],ee=[],W=new Set,pe=[],K=new Map,re=[],ue=0,ce=[],ne=0,le=[],me=void 0,de=[],Ae=void 0,J=void 0,Xe=void 0,ht=void 0,Ui(void 0,void 0)}function Gs(){return Xe||(Xe=Sy(M.checkDefined(J)))}function yr(O,ye){O!==void 0&&Ce(4,O,ye)}function to(O){O!==void 0&&Ce(2,O,void 0)}function lt(O,ye){O!==void 0&&Ce(1,O,ye)}function St(O){Ce(La(O)?6:4,O)}function fe(O){xe&&Pm(O)&4&&(xe=!1)}function vt(O){xe=O}function Ce(O,ye,Dt){jr=Dt,tt(0,O,ye)(O,ye),jr=void 0}function nt(O){return!vr&&!Ji(O)}function Me(O){return!ke&&!Ji(O)&&!_9(O)}function tt(O,ye,Dt){switch(O){case 0:if(i!==J8&&(!s||s(Dt)))return tr;case 1:if(o!==n6&&(xr=o(ye,Dt)||Dt)!==Dt)return jr&&(xr=jr(xr)),Ut;case 2:if(nt(Dt))return WE;case 3:if(Me(Dt))return _h;case 4:return Oe;default:return M.assertNever(O)}}function ft(O,ye,Dt){return tt(O+1,ye,Dt)}function tr(O,ye){let Dt=ft(0,O,ye);i(O,ye,Dt)}function Oe(O,ye){if(u?.(ye),xe){let Dt=xe;fe(ye),At(O,ye),vt(Dt)}else At(O,ye);m?.(ye),jr=void 0}function At(O,ye,Dt=!0){if(Dt){let Zt=JG(ye);if(Zt)return bt(O,ye,Zt)}if(O===0)return L0(aa(ye,Ji));if(O===2)return z(aa(ye,He));if(O===6)return Ge(aa(ye,La),!0);if(O===3)return Nt(aa(ye,Ac));if(O===7)return En(aa(ye,l2));if(O===5)return M.assertNode(ye,tY),$f(!0);if(O===4){switch(ye.kind){case 16:case 17:case 18:return Ge(ye,!1);case 80:return z(ye);case 81:return Ue(ye);case 166:return Te(ye);case 167:return It(ye);case 168:return $t(ye);case 169:return Ht(ye);case 170:return dr(ye);case 171:return qr(ye);case 172:return Hr(ye);case 173:return dn(ye);case 174:return Ar(ye);case 175:return In(ye);case 176:return Ki(ye);case 177:case 178:return ls(ye);case 179:return Yn(ye);case 180:return pi(ye);case 181:return Er(ye);case 182:return qs(ye);case 183:return uo(ye);case 184:return Mo(ye);case 185:return Eu(ye);case 186:return kc(ye);case 187:return P_(ye);case 188:return el(ye);case 189:return Fa(ye);case 190:return Lo(ye);case 192:return po(ye);case 193:return _r(ye);case 194:return Jc(ye);case 195:return z_(ye);case 196:return W_(ye);case 233:return id(ye);case 197:return qf();case 198:return mc(ye);case 199:return tl(ye);case 200:return Se(ye);case 201:return ae(ye);case 202:return bc(ye);case 203:return Ye(ye);case 204:return tn(ye);case 205:return Ot(ye);case 206:return Tr(ye);case 207:return Vn(ye);case 208:return pr(ye);case 239:return Yh(ye);case 240:return er();case 241:return Of(ye);case 243:return Kh(ye);case 242:return $f(!1);case 244:return nh(ye);case 245:return ad(ye);case 246:return yt(ye);case 247:return Gt(ye);case 248:return Xt(ye);case 249:return Fr(ye);case 250:return nn(ye);case 251:return Si(ye);case 252:return $(ye);case 253:return Ss(ye);case 254:return zs(ye);case 255:return vo(ye);case 256:return Wa(ye);case 257:return qc(ye);case 258:return Id(ye);case 259:return Om(ye);case 260:return Xh(ye);case 261:return Vy(ye);case 262:return $v(ye);case 263:return pS(ye);case 264:return dS(ye);case 265:return lm(ye);case 266:return Vb(ye);case 267:return pg(ye);case 268:return cd(ye);case 269:return R0(ye);case 270:return Ds(ye);case 271:return We(ye);case 272:return Jt(ye);case 273:return sr(ye);case 274:return kr(ye);case 280:return wa(ye);case 275:return _n(ye);case 276:return Ir(ye);case 277:return kn(ye);case 278:return ji(ye);case 279:return xu(ye);case 281:return N_(ye);case 300:return Ni(ye);case 301:return an(ye);case 282:return;case 283:return _m(ye);case 12:return Jb(ye);case 286:case 289:return FE(ye);case 287:case 290:return qb(ye);case 291:return P2(ye);case 292:return zb(ye);case 293:return Yv(ye);case 294:return _o(ye);case 295:return N2(ye);case 296:return Wb(ye);case 297:return M0(ye);case 298:return Rd(ye);case 299:return Rf(ye);case 303:return hp(ye);case 304:return Hf(ye);case 305:return Kv(ye);case 306:return Tk(ye);case 307:return L0(ye);case 308:return M.fail("Bundles should be printed using printBundle");case 309:return sh(ye);case 310:return xk(ye);case 312:return Mn("*");case 313:return Mn("?");case 314:return Sc(ye);case 315:return ts(ye);case 316:return zi(ye);case 317:return sa(ye);case 191:case 318:return Xu(ye);case 319:return;case 320:return Ek(ye);case 322:return Mm(ye);case 323:return Cu(ye);case 327:case 332:case 337:return Qe(ye);case 328:case 329:return ou(ye);case 330:case 331:return;case 333:case 334:case 335:case 336:return;case 338:return dg(ye);case 339:return w2(ye);case 341:case 348:return Gb(ye);case 340:case 342:case 343:case 344:case 349:case 350:return $b(ye);case 345:return Qv(ye);case 346:return Ck(ye);case 347:return Xv(ye);case 351:return Hb(ye);case 353:return}if(Ct(ye)&&(O=1,o!==n6)){let Zt=o(O,ye)||ye;Zt!==ye&&(ye=Zt,jr&&(ye=jr(ye)))}}if(O===1)switch(ye.kind){case 9:case 10:return Z(ye);case 11:case 14:case 15:return Ge(ye,!1);case 80:return z(ye);case 81:return Ue(ye);case 209:return Jn(ye);case 210:return Ri(ye);case 211:return Ai(ye);case 212:return gc(ye);case 213:return Wl(ye);case 214:return Oc(ye);case 215:return du(ye);case 216:return hc(ye);case 217:return mu(ye);case 218:return zf(ye);case 219:return rl(ye);case 220:return Je(ye);case 221:return qt(ye);case 222:return Gr(ye);case 223:return gs(ye);case 224:return Qa(ye);case 225:return fl(ye);case 226:return Sr(ye);case 227:return Uo(ye);case 228:return Fo(ye);case 229:return Cl(ye);case 230:return Wf(ye);case 231:return fg(ye);case 232:return;case 234:return If(ye);case 235:return wd(ye);case 233:return id(ye);case 238:return sd(ye);case 236:return Gh(ye);case 237:return M.fail("SyntheticExpression should never be printed.");case 282:return;case 284:return Sk(ye);case 285:return mD(ye);case 288:return bk(ye);case 352:return M.fail("SyntaxList should not be printed");case 353:return;case 354:return I2(ye);case 355:return O2(ye);case 356:return M.fail("SyntheticReferenceExpression should not be printed")}if(sf(ye.kind))return qE(ye,Ls);if(L$(ye.kind))return qE(ye,Mn);M.fail(`Unhandled SyntaxKind: ${M.formatSyntaxKind(ye.kind)}.`)}function Nt(O){yr(O.name),yn(),Ls("in"),yn(),yr(O.constraint)}function Ut(O,ye){let Dt=ft(1,O,ye);M.assertIsDefined(xr),ye=xr,xr=void 0,Dt(O,ye)}function Rt(O){let ye=!1,Dt=O.kind===308?O:void 0;if(Dt&&L===0)return;let Zt=Dt?Dt.sourceFiles.length:1;for(let bi=0;bi<Zt;bi++){let ys=Dt?Dt.sourceFiles[bi]:O,fs=Ji(ys)?ys:J,As=e.noEmitHelpers||!!fs&&fme(fs),Ia=Ji(ys)&&!Pe,Y_=nr(ys);if(Y_)for(let w_ of Y_){if(w_.scoped){if(Dt)continue}else{if(As)continue;if(Ia){if(F.get(w_.name))continue;F.set(w_.name,!0)}}typeof w_.text=="string"?oh(w_.text):oh(w_.text(TD)),ye=!0}}return ye}function nr(O){let ye=Ej(O);return ye&&Qs(ye,ade)}function Z(O){Ge(O,!1)}function Ge(O,ye){let Dt=V0(O,e.neverAsciiEscape,ye);(e.sourceMap||e.inlineSourceMap)&&(O.kind===11||B1(O.kind))?JE(Dt):kk(Dt)}function bt(O,ye,Dt){switch(Dt.kind){case 1:Q(O,ye,Dt);break;case 0:Ke(O,ye,Dt);break}}function Q(O,ye,Dt){Nk(`\${${Dt.order}:`),At(O,ye,!1),Nk("}")}function Ke(O,ye,Dt){M.assert(ye.kind===242,`A tab stop cannot be attached to a node of kind ${M.formatSyntaxKind(ye.kind)}.`),M.assert(O!==5,"A tab stop cannot be attached to an embedded statement."),Nk(`$${Dt.order}`)}function z(O){(O.symbol?vD:Ve)(mS(O,!1),O.symbol),sc(O,i2(O),53776)}function Ue(O){Ve(mS(O,!1))}function Te(O){Re(O.left),Mn("."),yr(O.right)}function Re(O){O.kind===80?lt(O):yr(O)}function It(O){Mn("["),lt(O.expression,Zr.parenthesizeExpressionOfComputedPropertyName),Mn("]")}function $t(O){Ip(O,O.modifiers),yr(O.name),O.constraint&&(yn(),Ls("extends"),yn(),yr(O.constraint)),O.default&&(yn(),U0("="),yn(),yr(O.default))}function Ht(O){ld(O,O.modifiers,!0),yr(O.dotDotDotToken),Kb(O.name,M2),yr(O.questionToken),O.parent&&O.parent.kind===317&&!O.name?yr(O.type):Zv(O.type),e1(O.initializer,O.type?O.type.end:O.questionToken?O.questionToken.end:O.name?O.name.end:O.modifiers?O.modifiers.end:O.pos,O,Zr.parenthesizeExpressionForDisallowedComma)}function dr(O){Mn("@"),lt(O.expression,Zr.parenthesizeLeftSideOfAccess)}function qr(O){Ip(O,O.modifiers),Kb(O.name,Pk),yr(O.questionToken),Zv(O.type),D_()}function Hr(O){ld(O,O.modifiers,!0),yr(O.name),yr(O.questionToken),yr(O.exclamationToken),Zv(O.type),e1(O.initializer,O.type?O.type.end:O.questionToken?O.questionToken.end:O.name.end,O),D_()}function dn(O){Ip(O,O.modifiers),yr(O.name),yr(O.questionToken),Od(O,d_,Vo)}function Ar(O){ld(O,O.modifiers,!0),yr(O.asteriskToken),yr(O.name),yr(O.questionToken),Od(O,d_,od)}function In(O){Ls("static"),n1(O),Rm(O.body),pm(O)}function Ki(O){ld(O,O.modifiers,!1),Ls("constructor"),Od(O,d_,od)}function ls(O){let ye=ld(O,O.modifiers,!0),Dt=O.kind===177?139:153;Fe(Dt,ye,Ls,O),yn(),yr(O.name),Od(O,d_,od)}function Yn(O){Od(O,d_,Vo)}function pi(O){Ls("new"),yn(),Od(O,d_,Vo)}function Er(O){ld(O,O.modifiers,!1),Op(O,O.parameters),Zv(O.type),D_()}function tn(O){yr(O.type),yr(O.literal)}function er(){D_()}function qs(O){O.assertsModifier&&(yr(O.assertsModifier),yn()),yr(O.parameterName),O.type&&(yn(),Ls("is"),yn(),yr(O.type))}function uo(O){yr(O.typeName),Zh(O,O.typeArguments)}function Mo(O){Od(O,Do,ms)}function Do(O){t1(O,O.typeParameters),Xb(O,O.parameters),yn(),Mn("=>")}function ms(O){yn(),yr(O.type)}function sa(O){Ls("function"),B0(O,O.parameters),Mn(":"),yr(O.type)}function Sc(O){Mn("?"),yr(O.type)}function ts(O){Mn("!"),yr(O.type)}function zi(O){yr(O.type),Mn("=")}function Eu(O){Ip(O,O.modifiers),Ls("new"),yn(),Od(O,Do,ms)}function kc(O){Ls("typeof"),yn(),yr(O.exprName),Zh(O,O.typeArguments)}function P_(O){n1(O),kt(O.members,J0),Mn("{");let ye=Ga(O)&1?768:32897;sc(O,O.members,ye|524288),Mn("}"),pm(O)}function el(O){yr(O.elementType,Zr.parenthesizeNonArrayTypeOfPostfixType),Mn("["),Mn("]")}function Xu(O){Mn("..."),yr(O.type)}function Fa(O){Fe(23,O.pos,Mn,O);let ye=Ga(O)&1?528:657;sc(O,O.elements,ye|524288,Zr.parenthesizeElementTypeOfTupleType),Fe(24,O.elements.end,Mn,O)}function bc(O){yr(O.dotDotDotToken),yr(O.name),yr(O.questionToken),Fe(59,O.name.end,Mn,O),yn(),yr(O.type)}function Lo(O){yr(O.type,Zr.parenthesizeTypeOfOptionalType),Mn("?")}function po(O){sc(O,O.types,516,Zr.parenthesizeConstituentTypeOfUnionType)}function _r(O){sc(O,O.types,520,Zr.parenthesizeConstituentTypeOfIntersectionType)}function Jc(O){yr(O.checkType,Zr.parenthesizeCheckTypeOfConditionalType),yn(),Ls("extends"),yn(),yr(O.extendsType,Zr.parenthesizeExtendsTypeOfConditionalType),yn(),Mn("?"),yn(),yr(O.trueType),yn(),Mn(":"),yn(),yr(O.falseType)}function z_(O){Ls("infer"),yn(),yr(O.typeParameter)}function W_(O){Mn("("),yr(O.type),Mn(")")}function qf(){Ls("this")}function mc(O){ah(O.operator,Ls),yn();let ye=O.operator===148?Zr.parenthesizeOperandOfReadonlyTypeOperator:Zr.parenthesizeOperandOfTypeOperator;yr(O.type,ye)}function tl(O){yr(O.objectType,Zr.parenthesizeNonArrayTypeOfPostfixType),Mn("["),yr(O.indexType),Mn("]")}function Se(O){let ye=Ga(O);Mn("{"),ye&1?yn():(H_(),jm()),O.readonlyToken&&(yr(O.readonlyToken),O.readonlyToken.kind!==148&&Ls("readonly"),yn()),Mn("["),Ce(3,O.typeParameter),O.nameType&&(yn(),Ls("as"),yn(),yr(O.nameType)),Mn("]"),O.questionToken&&(yr(O.questionToken),O.questionToken.kind!==58&&Mn("?")),Mn(":"),yn(),yr(O.type),D_(),ye&1?yn():(H_(),fm()),sc(O,O.members,2),Mn("}")}function ae(O){lt(O.literal)}function Ye(O){yr(O.head),sc(O,O.templateSpans,262144)}function Ot(O){O.isTypeOf&&(Ls("typeof"),yn()),Ls("import"),Mn("("),yr(O.argument),O.attributes&&(Mn(","),yn(),Ce(7,O.attributes)),Mn(")"),O.qualifier&&(Mn("."),yr(O.qualifier)),Zh(O,O.typeArguments)}function Tr(O){Mn("{"),sc(O,O.elements,525136),Mn("}")}function Vn(O){Mn("["),sc(O,O.elements,524880),Mn("]")}function pr(O){yr(O.dotDotDotToken),O.propertyName&&(yr(O.propertyName),Mn(":"),yn()),yr(O.name),e1(O.initializer,O.name.end,O,Zr.parenthesizeExpressionForDisallowedComma)}function Jn(O){let ye=O.elements,Dt=O.multiLine?65536:0;zy(O,ye,8914|Dt,Zr.parenthesizeExpressionForDisallowedComma)}function Ri(O){n1(O),kt(O.properties,J0);let ye=Ga(O)&131072;ye&&jm();let Dt=O.multiLine?65536:0,Zt=J&&J.languageVersion>=1&&!Kd(J)?64:0;sc(O,O.properties,526226|Zt|Dt),ye&&fm(),pm(O)}function Ai(O){lt(O.expression,Zr.parenthesizeLeftSideOfAccess);let ye=O.questionDotToken||qg(U.createToken(25),O.expression.end,O.name.pos),Dt=Bm(O,O.expression,ye),Zt=Bm(O,ye,O.name);Ld(Dt,!1),ye.kind!==29&&Na(O.expression)&&!he.hasTrailingComment()&&!he.hasTrailingWhitespace()&&Mn("."),O.questionDotToken?yr(ye):Fe(ye.kind,O.expression.end,Mn,O),Ld(Zt,!1),yr(O.name),Wy(Dt,Zt)}function Na(O){if(O=km(O),Pf(O)){let ye=V0(O,!0,!1);return!(O.numericLiteralFlags&448)&&!ye.includes(Sa(25))&&!ye.includes("E")&&!ye.includes("e")}else if(oc(O)){let ye=Xpe(O);return typeof ye=="number"&&isFinite(ye)&&ye>=0&&Math.floor(ye)===ye}}function gc(O){lt(O.expression,Zr.parenthesizeLeftSideOfAccess),yr(O.questionDotToken),Fe(23,O.expression.end,Mn,O),lt(O.argumentExpression),Fe(24,O.argumentExpression.end,Mn,O)}function Wl(O){let ye=Pm(O)&16;ye&&(Mn("("),JE("0"),Mn(","),yn()),lt(O.expression,Zr.parenthesizeLeftSideOfAccess),ye&&Mn(")"),yr(O.questionDotToken),Zh(O,O.typeArguments),zy(O,O.arguments,2576,Zr.parenthesizeExpressionForDisallowedComma)}function Oc(O){Fe(105,O.pos,Ls,O),yn(),lt(O.expression,Zr.parenthesizeExpressionOfNew),Zh(O,O.typeArguments),zy(O,O.arguments,18960,Zr.parenthesizeExpressionForDisallowedComma)}function du(O){let ye=Pm(O)&16;ye&&(Mn("("),JE("0"),Mn(","),yn()),lt(O.tag,Zr.parenthesizeLeftSideOfAccess),ye&&Mn(")"),Zh(O,O.typeArguments),yn(),lt(O.template)}function hc(O){Mn("<"),yr(O.type),Mn(">"),lt(O.expression,Zr.parenthesizeOperandOfPrefixUnary)}function mu(O){let ye=Fe(21,O.pos,Mn,O),Dt=SD(O.expression,O);lt(O.expression,void 0),F2(O.expression,O),Wy(Dt),Fe(22,O.expression?O.expression.end:ye,Mn,O)}function zf(O){ch(O.name),Jy(O)}function rl(O){Ip(O,O.modifiers),Od(O,$l,nd)}function $l(O){t1(O,O.typeParameters),Xb(O,O.parameters),Zv(O.type),yn(),yr(O.equalsGreaterThanToken)}function nd(O){Vs(O.body)?Rm(O.body):(yn(),lt(O.body,Zr.parenthesizeConciseBodyOfArrowFunction))}function Je(O){Fe(91,O.pos,Ls,O),yn(),lt(O.expression,Zr.parenthesizeOperandOfPrefixUnary)}function qt(O){Fe(114,O.pos,Ls,O),yn(),lt(O.expression,Zr.parenthesizeOperandOfPrefixUnary)}function Gr(O){Fe(116,O.pos,Ls,O),yn(),lt(O.expression,Zr.parenthesizeOperandOfPrefixUnary)}function gs(O){Fe(135,O.pos,Ls,O),yn(),lt(O.expression,Zr.parenthesizeOperandOfPrefixUnary)}function Qa(O){ah(O.operator,U0),so(O)&&yn(),lt(O.operand,Zr.parenthesizeOperandOfPrefixUnary)}function so(O){let ye=O.operand;return ye.kind===224&&(O.operator===40&&(ye.operator===40||ye.operator===46)||O.operator===41&&(ye.operator===41||ye.operator===47))}function fl(O){lt(O.operand,Zr.parenthesizeOperandOfPostfixUnary),ah(O.operator,U0)}function au(){return Kj(O,ye,Dt,Zt,bi,void 0);function O(fs,As){if(As){As.stackIndex++,As.preserveSourceNewlinesStack[As.stackIndex]=xe,As.containerPosStack[As.stackIndex]=Ie,As.containerEndStack[As.stackIndex]=_t,As.declarationListContainerEndStack[As.stackIndex]=mt;let Ia=As.shouldEmitCommentsStack[As.stackIndex]=nt(fs),Y_=As.shouldEmitSourceMapsStack[As.stackIndex]=Me(fs);u?.(fs),Ia&&nT(fs),Y_&&z0(fs),fe(fs)}else As={stackIndex:0,preserveSourceNewlinesStack:[void 0],containerPosStack:[-1],containerEndStack:[-1],declarationListContainerEndStack:[-1],shouldEmitCommentsStack:[!1],shouldEmitSourceMapsStack:[!1]};return As}function ye(fs,As,Ia){return ys(fs,Ia,"left")}function Dt(fs,As,Ia){let Y_=fs.kind!==28,w_=Bm(Ia,Ia.left,fs),a1=Bm(Ia,fs,Ia.right);Ld(w_,Y_),ro(fs.pos),qE(fs,fs.kind===103?Ls:U0),Qu(fs.end,!0),Ld(a1,!0)}function Zt(fs,As,Ia){return ys(fs,Ia,"right")}function bi(fs,As){let Ia=Bm(fs,fs.left,fs.operatorToken),Y_=Bm(fs,fs.operatorToken,fs.right);if(Wy(Ia,Y_),As.stackIndex>0){let w_=As.preserveSourceNewlinesStack[As.stackIndex],a1=As.containerPosStack[As.stackIndex],HE=As.containerEndStack[As.stackIndex],Sp=As.declarationListContainerEndStack[As.stackIndex],gg=As.shouldEmitCommentsStack[As.stackIndex],W0=As.shouldEmitSourceMapsStack[As.stackIndex];vt(w_),W0&&J2(fs),gg&&Mf(fs,a1,HE,Sp),m?.(fs),As.stackIndex--}}function ys(fs,As,Ia){let Y_=Ia==="left"?Zr.getParenthesizeLeftSideOfBinaryForOperator(As.operatorToken.kind):Zr.getParenthesizeRightSideOfBinaryForOperator(As.operatorToken.kind),w_=tt(0,1,fs);if(w_===Ut&&(M.assertIsDefined(xr),fs=Y_(aa(xr,Ct)),w_=ft(1,1,fs),xr=void 0),(w_===WE||w_===_h||w_===Oe)&&Pn(fs))return fs;jr=Y_,w_(1,fs)}}function Uo(O){let ye=Bm(O,O.condition,O.questionToken),Dt=Bm(O,O.questionToken,O.whenTrue),Zt=Bm(O,O.whenTrue,O.colonToken),bi=Bm(O,O.colonToken,O.whenFalse);lt(O.condition,Zr.parenthesizeConditionOfConditionalExpression),Ld(ye,!0),yr(O.questionToken),Ld(Dt,!0),lt(O.whenTrue,Zr.parenthesizeBranchOfConditionalExpression),Wy(ye,Dt),Ld(Zt,!0),yr(O.colonToken),Ld(bi,!0),lt(O.whenFalse,Zr.parenthesizeBranchOfConditionalExpression),Wy(Zt,bi)}function Fo(O){yr(O.head),sc(O,O.templateSpans,262144)}function Cl(O){Fe(127,O.pos,Ls,O),yr(O.asteriskToken),m_(O.expression&&Mi(O.expression),Us)}function Wf(O){Fe(26,O.pos,Mn,O),lt(O.expression,Zr.parenthesizeExpressionForDisallowedComma)}function fg(O){ch(O.name),cm(O)}function id(O){lt(O.expression,Zr.parenthesizeLeftSideOfAccess),Zh(O,O.typeArguments)}function If(O){lt(O.expression,void 0),O.type&&(yn(),Ls("as"),yn(),yr(O.type))}function wd(O){lt(O.expression,Zr.parenthesizeLeftSideOfAccess),U0("!")}function sd(O){lt(O.expression,void 0),O.type&&(yn(),Ls("satisfies"),yn(),yr(O.type))}function Gh(O){r1(O.keywordToken,O.pos,Mn),Mn("."),yr(O.name)}function Yh(O){lt(O.expression),yr(O.literal)}function Of(O){Hl(O,!O.multiLine&&bD(O))}function Hl(O,ye){Fe(19,O.pos,Mn,O);let Dt=ye||Ga(O)&1?768:129;sc(O,O.statements,Dt),Fe(20,O.statements.end,Mn,O,!!(Dt&1))}function Kh(O){ld(O,O.modifiers,!1),yr(O.declarationList),D_()}function $f(O){O?Mn(";"):D_()}function nh(O){lt(O.expression,Zr.parenthesizeExpressionOfExpressionStatement),(!J||!Kd(J)||Ko(O.expression))&&D_()}function ad(O){let ye=Fe(101,O.pos,Ls,O);yn(),Fe(21,ye,Mn,O),lt(O.expression),Fe(22,O.expression.end,Mn,O),Fm(O,O.thenStatement),O.elseStatement&&(vp(O,O.thenStatement,O.elseStatement),Fe(93,O.thenStatement.end,Ls,O),O.elseStatement.kind===245?(yn(),yr(O.elseStatement)):Fm(O,O.elseStatement))}function oe(O,ye){let Dt=Fe(117,ye,Ls,O);yn(),Fe(21,Dt,Mn,O),lt(O.expression),Fe(22,O.expression.end,Mn,O)}function yt(O){Fe(92,O.pos,Ls,O),Fm(O,O.statement),Vs(O.statement)&&!xe?yn():vp(O,O.statement,O.expression),oe(O,O.statement.end),D_()}function Gt(O){oe(O,O.pos),Fm(O,O.statement)}function Xt(O){let ye=Fe(99,O.pos,Ls,O);yn();let Dt=Fe(21,ye,Mn,O);Hn(O.initializer),Dt=Fe(27,O.initializer?O.initializer.end:Dt,Mn,O),m_(O.condition),Dt=Fe(27,O.condition?O.condition.end:Dt,Mn,O),m_(O.incrementor),Fe(22,O.incrementor?O.incrementor.end:Dt,Mn,O),Fm(O,O.statement)}function Fr(O){let ye=Fe(99,O.pos,Ls,O);yn(),Fe(21,ye,Mn,O),Hn(O.initializer),yn(),Fe(103,O.initializer.end,Ls,O),yn(),lt(O.expression),Fe(22,O.expression.end,Mn,O),Fm(O,O.statement)}function nn(O){let ye=Fe(99,O.pos,Ls,O);yn(),gD(O.awaitModifier),Fe(21,ye,Mn,O),Hn(O.initializer),yn(),Fe(165,O.initializer.end,Ls,O),yn(),lt(O.expression),Fe(22,O.expression.end,Mn,O),Fm(O,O.statement)}function Hn(O){O!==void 0&&(O.kind===261?yr(O):lt(O))}function Si(O){Fe(88,O.pos,Ls,O),qn(O.label),D_()}function $(O){Fe(83,O.pos,Ls,O),qn(O.label),D_()}function Fe(O,ye,Dt,Zt,bi){let ys=ks(Zt),fs=ys&&ys.kind===Zt.kind,As=ye;if(fs&&J&&(ye=Ja(J.text,ye)),fs&&Zt.pos!==As){let Ia=bi&&J&&!Ed(As,ye,J);Ia&&jm(),ro(As),Ia&&fm()}if(!w&&(O===19||O===20)?ye=r1(O,ye,Dt,Zt):ye=ah(O,Dt,ye),fs&&Zt.end!==ye){let Ia=Zt.kind===294;Qu(ye,!Ia,Ia)}return ye}function jt(O){return O.kind===2||!!O.hasTrailingNewLine}function Xr(O){if(!J)return!1;let ye=Ty(J.text,O.pos);if(ye){let Dt=ks(O);if(Dt&&uf(Dt.parent))return!0}return Pt(ye,jt)||Pt(mN(O),jt)?!0:Lj(O)?O.pos!==O.expression.pos&&Pt(L1(J.text,O.expression.pos),jt)?!0:Xr(O.expression):!1}function Mi(O){if(!vr&&Lj(O)&&Xr(O)){let ye=ks(O);if(ye&&uf(ye)){let Dt=U.createParenthesizedExpression(O.expression);return zn(Dt,O),Et(Dt,ye),Dt}return U.createParenthesizedExpression(O)}return O}function Us(O){return Mi(Zr.parenthesizeExpressionForDisallowedComma(O))}function Ss(O){Fe(107,O.pos,Ls,O),m_(O.expression&&Mi(O.expression),Mi),D_()}function zs(O){let ye=Fe(118,O.pos,Ls,O);yn(),Fe(21,ye,Mn,O),lt(O.expression),Fe(22,O.expression.end,Mn,O),Fm(O,O.statement)}function vo(O){let ye=Fe(109,O.pos,Ls,O);yn(),Fe(21,ye,Mn,O),lt(O.expression),Fe(22,O.expression.end,Mn,O),yn(),yr(O.caseBlock)}function Wa(O){yr(O.label),Fe(59,O.label.end,Mn,O),yn(),yr(O.statement)}function qc(O){Fe(111,O.pos,Ls,O),m_(Mi(O.expression),Mi),D_()}function Id(O){Fe(113,O.pos,Ls,O),yn(),yr(O.tryBlock),O.catchClause&&(vp(O,O.tryBlock,O.catchClause),yr(O.catchClause)),O.finallyBlock&&(vp(O,O.catchClause||O.tryBlock,O.finallyBlock),Fe(98,(O.catchClause||O.tryBlock).end,Ls,O),yn(),yr(O.finallyBlock))}function Om(O){r1(89,O.pos,Ls),D_()}function Xh(O){var ye,Dt,Zt;yr(O.name),yr(O.exclamationToken),Zv(O.type),e1(O.initializer,((ye=O.type)==null?void 0:ye.end)??((Zt=(Dt=O.name.emitNode)==null?void 0:Dt.typeNode)==null?void 0:Zt.end)??O.name.end,O,Zr.parenthesizeExpressionForDisallowedComma)}function Vy(O){if(tR(O))Ls("await"),yn(),Ls("using");else{let ye=Q5(O)?"let":zP(O)?"const":rR(O)?"using":"var";Ls(ye)}yn(),sc(O,O.declarations,528)}function $v(O){Jy(O)}function Jy(O){ld(O,O.modifiers,!1),Ls("function"),yr(O.asteriskToken),yn(),to(O.name),Od(O,d_,od)}function Od(O,ye,Dt){let Zt=Ga(O)&131072;Zt&&jm(),n1(O),kt(O.parameters,wu),ye(O),Dt(O),pm(O),Zt&&fm()}function od(O){let ye=O.body;ye?Rm(ye):D_()}function Vo(O){D_()}function d_(O){t1(O,O.typeParameters),B0(O,O.parameters),Zv(O.type)}function $_(O){if(Ga(O)&1)return!0;if(O.multiLine||!Ko(O)&&J&&!n2(O,J)||Qb(O,xo(O.statements),2)||L2(O,vc(O.statements),2,O.statements))return!1;let ye;for(let Dt of O.statements){if(Dk(ye,Dt,2)>0)return!1;ye=Dt}return!0}function Rm(O){wu(O),u?.(O),yn(),Mn("{"),jm();let ye=$_(O)?Hv:O0;B2(O,O.statements,ye),fm(),r1(20,O.statements.end,Mn,O),m?.(O)}function Hv(O){O0(O,!0)}function O0(O,ye){let Dt=Yb(O.statements),Zt=he.getTextPos();Rt(O),Dt===0&&Zt===he.getTextPos()&&ye?(fm(),sc(O,O.statements,768),jm()):sc(O,O.statements,1,void 0,Dt)}function pS(O){cm(O)}function cm(O){ld(O,O.modifiers,!0),Fe(86,Jg(O).pos,Ls,O),O.name&&(yn(),to(O.name));let ye=Ga(O)&131072;ye&&jm(),t1(O,O.typeParameters),sc(O,O.heritageClauses,0),yn(),Mn("{"),n1(O),kt(O.members,J0),sc(O,O.members,129),pm(O),Mn("}"),ye&&fm()}function dS(O){ld(O,O.modifiers,!1),Ls("interface"),yn(),yr(O.name),t1(O,O.typeParameters),sc(O,O.heritageClauses,512),yn(),Mn("{"),n1(O),kt(O.members,J0),sc(O,O.members,129),pm(O),Mn("}")}function lm(O){ld(O,O.modifiers,!1),Ls("type"),yn(),yr(O.name),t1(O,O.typeParameters),yn(),Mn("="),yn(),yr(O.type),D_()}function Vb(O){ld(O,O.modifiers,!1),Ls("enum"),yn(),yr(O.name),yn(),Mn("{"),sc(O,O.members,145),Mn("}")}function pg(O){ld(O,O.modifiers,!1),~O.flags&2048&&(Ls(O.flags&32?"namespace":"module"),yn()),yr(O.name);let ye=O.body;if(!ye)return D_();for(;ye&&El(ye);)Mn("."),yr(ye.name),ye=ye.body;yn(),yr(ye)}function cd(O){n1(O),kt(O.statements,wu),Hl(O,bD(O)),pm(O)}function R0(O){Fe(19,O.pos,Mn,O),sc(O,O.clauses,129),Fe(20,O.clauses.end,Mn,O,!0)}function We(O){ld(O,O.modifiers,!1),Fe(102,O.modifiers?O.modifiers.end:O.pos,Ls,O),yn(),O.isTypeOnly&&(Fe(156,O.pos,Ls,O),yn()),yr(O.name),yn(),Fe(64,O.name.end,Mn,O),yn(),st(O.moduleReference),D_()}function st(O){O.kind===80?lt(O):yr(O)}function Jt(O){ld(O,O.modifiers,!1),Fe(102,O.modifiers?O.modifiers.end:O.pos,Ls,O),yn(),O.importClause&&(yr(O.importClause),yn(),Fe(161,O.importClause.end,Ls,O),yn()),lt(O.moduleSpecifier),O.attributes&&qn(O.attributes),D_()}function sr(O){O.isTypeOnly&&(Fe(156,O.pos,Ls,O),yn()),yr(O.name),O.name&&O.namedBindings&&(Fe(28,O.name.end,Mn,O),yn()),yr(O.namedBindings)}function kr(O){let ye=Fe(42,O.pos,Mn,O);yn(),Fe(130,ye,Ls,O),yn(),yr(O.name)}function _n(O){um(O)}function Ir(O){Gv(O)}function kn(O){let ye=Fe(95,O.pos,Ls,O);yn(),O.isExportEquals?Fe(64,ye,U0,O):Fe(90,ye,Ls,O),yn(),lt(O.expression,O.isExportEquals?Zr.getParenthesizeRightSideOfBinaryForOperator(64):Zr.parenthesizeExpressionOfExportDefault),D_()}function ji(O){ld(O,O.modifiers,!1);let ye=Fe(95,O.pos,Ls,O);if(yn(),O.isTypeOnly&&(ye=Fe(156,ye,Ls,O),yn()),O.exportClause?yr(O.exportClause):ye=Fe(42,ye,Mn,O),O.moduleSpecifier){yn();let Dt=O.exportClause?O.exportClause.end:ye;Fe(161,Dt,Ls,O),yn(),lt(O.moduleSpecifier)}O.attributes&&qn(O.attributes),D_()}function En(O){Mn("{"),yn(),Ls(O.token===132?"assert":"with"),Mn(":"),yn();let ye=O.elements;sc(O,ye,526226),yn(),Mn("}")}function Ni(O){Fe(O.token,O.pos,Ls,O),yn();let ye=O.elements;sc(O,ye,526226)}function an(O){yr(O.name),Mn(":"),yn();let ye=O.value;if(!(Ga(ye)&1024)){let Dt=Wg(ye);Qu(Dt.pos)}yr(ye)}function Ds(O){let ye=Fe(95,O.pos,Ls,O);yn(),ye=Fe(130,ye,Ls,O),yn(),ye=Fe(145,ye,Ls,O),yn(),yr(O.name),D_()}function wa(O){let ye=Fe(42,O.pos,Mn,O);yn(),Fe(130,ye,Ls,O),yn(),yr(O.name)}function xu(O){um(O)}function N_(O){Gv(O)}function um(O){Mn("{"),sc(O,O.elements,525136),Mn("}")}function Gv(O){O.isTypeOnly&&(Ls("type"),yn()),O.propertyName&&(yr(O.propertyName),yn(),Fe(130,O.propertyName.end,Ls,O),yn()),yr(O.name)}function _m(O){Ls("require"),Mn("("),lt(O.expression),Mn(")")}function Sk(O){yr(O.openingElement),sc(O,O.children,262144),yr(O.closingElement)}function mD(O){Mn("<"),D2(O.tagName),Zh(O,O.typeArguments),yn(),yr(O.attributes),Mn("/>")}function bk(O){yr(O.openingFragment),sc(O,O.children,262144),yr(O.closingFragment)}function FE(O){if(Mn("<"),Yg(O)){let ye=SD(O.tagName,O);D2(O.tagName),Zh(O,O.typeArguments),O.attributes.properties&&O.attributes.properties.length>0&&yn(),yr(O.attributes),F2(O.attributes,O),Wy(ye)}Mn(">")}function Jb(O){he.writeLiteral(O.text)}function qb(O){Mn("</"),yE(O)&&D2(O.tagName),Mn(">")}function zb(O){sc(O,O.properties,262656)}function P2(O){yr(O.name),as("=",Mn,O.initializer,St)}function Yv(O){Mn("{..."),lt(O.expression),Mn("}")}function jE(O){let ye=!1;return C3(J?.text||"",O+1,()=>ye=!0),ye}function qy(O){let ye=!1;return x3(J?.text||"",O+1,()=>ye=!0),ye}function BE(O){return jE(O)||qy(O)}function _o(O){var ye;if(O.expression||!vr&&!Ko(O)&&BE(O.pos)){let Dt=J&&!Ko(O)&&ba(J,O.pos).line!==ba(J,O.end).line;Dt&&he.increaseIndent();let Zt=Fe(19,O.pos,Mn,O);yr(O.dotDotDotToken),lt(O.expression),Fe(20,((ye=O.expression)==null?void 0:ye.end)||Zt,Mn,O),Dt&&he.decreaseIndent()}}function N2(O){to(O.namespace),Mn(":"),to(O.name)}function D2(O){O.kind===80?lt(O):yr(O)}function Wb(O){Fe(84,O.pos,Ls,O),yn(),lt(O.expression,Zr.parenthesizeExpressionForDisallowedComma),ih(O,O.statements,O.expression.end)}function M0(O){let ye=Fe(90,O.pos,Ls,O);ih(O,O.statements,ye)}function ih(O,ye,Dt){let Zt=ye.length===1&&(!J||Ko(O)||Ko(ye[0])||j9(O,ye[0],J)),bi=163969;Zt?(r1(59,Dt,Mn,O),yn(),bi&=-130):Fe(59,Dt,Mn,O),sc(O,ye,bi)}function Rd(O){yn(),ah(O.token,Ls),yn(),sc(O,O.types,528)}function Rf(O){let ye=Fe(85,O.pos,Ls,O);yn(),O.variableDeclaration&&(Fe(21,ye,Mn,O),yr(O.variableDeclaration),Fe(22,O.variableDeclaration.end,Mn,O),yn()),yr(O.block)}function hp(O){yr(O.name),Mn(":"),yn();let ye=O.initializer;if(!(Ga(ye)&1024)){let Dt=Wg(ye);Qu(Dt.pos)}lt(ye,Zr.parenthesizeExpressionForDisallowedComma)}function Hf(O){yr(O.name),O.objectAssignmentInitializer&&(yn(),Mn("="),yn(),lt(O.objectAssignmentInitializer,Zr.parenthesizeExpressionForDisallowedComma))}function Kv(O){O.expression&&(Fe(26,O.pos,Mn,O),lt(O.expression,Zr.parenthesizeExpressionForDisallowedComma))}function Tk(O){yr(O.name),e1(O.initializer,O.name.end,O,Zr.parenthesizeExpressionForDisallowedComma)}function Ek(O){if(Ve("/**"),O.comment){let ye=R3(O.comment);if(ye){let Dt=ye.split(/\r\n?|\n/g);for(let Zt of Dt)H_(),yn(),Mn("*"),yn(),Ve(Zt)}}O.tags&&(O.tags.length===1&&O.tags[0].kind===344&&!O.comment?(yn(),yr(O.tags[0])):sc(O,O.tags,33)),yn(),Ve("*/")}function $b(O){Qh(O.tagName),sh(O.typeExpression),Md(O.comment)}function Xv(O){Qh(O.tagName),yr(O.name),Md(O.comment)}function Hb(O){Qh(O.tagName),yn(),O.importClause&&(yr(O.importClause),yn(),Fe(161,O.importClause.end,Ls,O),yn()),lt(O.moduleSpecifier),O.attributes&&qn(O.attributes),Md(O.comment)}function xk(O){yn(),Mn("{"),yr(O.name),Mn("}")}function ou(O){Qh(O.tagName),yn(),Mn("{"),yr(O.class),Mn("}"),Md(O.comment)}function Qv(O){Qh(O.tagName),sh(O.constraint),yn(),sc(O,O.typeParameters,528),Md(O.comment)}function Ck(O){Qh(O.tagName),O.typeExpression&&(O.typeExpression.kind===309?sh(O.typeExpression):(yn(),Mn("{"),Ve("Object"),O.typeExpression.isArrayType&&(Mn("["),Mn("]")),Mn("}"))),O.fullName&&(yn(),yr(O.fullName)),Md(O.comment),O.typeExpression&&O.typeExpression.kind===322&&Mm(O.typeExpression)}function dg(O){Qh(O.tagName),O.name&&(yn(),yr(O.name)),Md(O.comment),Cu(O.typeExpression)}function w2(O){Md(O.comment),Cu(O.typeExpression)}function Qe(O){Qh(O.tagName),Md(O.comment)}function Mm(O){sc(O,U.createNodeArray(O.jsDocPropertyTags),33)}function Cu(O){O.typeParameters&&sc(O,U.createNodeArray(O.typeParameters),33),O.parameters&&sc(O,U.createNodeArray(O.parameters),33),O.type&&(H_(),yn(),Mn("*"),yn(),yr(O.type))}function Gb(O){Qh(O.tagName),sh(O.typeExpression),yn(),O.isBracketed&&Mn("["),yr(O.name),O.isBracketed&&Mn("]"),Md(O.comment)}function Qh(O){Mn("@"),yr(O)}function Md(O){let ye=R3(O);ye&&(yn(),Ve(ye))}function sh(O){O&&(yn(),Mn("{"),yr(O.type),Mn("}"))}function L0(O){H_();let ye=O.statements;if(ye.length===0||!Mg(ye[0])||Ko(ye[0])){B2(O,ye,UE);return}UE(O)}function V6(O){Lm(!!O.hasNoDefaultLib,O.syntheticFileReferences||[],O.syntheticTypeReferences||[],O.syntheticLibReferences||[])}function Za(O){O.isDeclarationFile&&Lm(O.hasNoDefaultLib,O.referencedFiles,O.typeReferenceDirectives,O.libReferenceDirectives)}function Lm(O,ye,Dt,Zt){if(O&&(yp('/// <reference no-default-lib="true"/>'),H_()),J&&J.moduleName&&(yp(`/// <amd-module name="${J.moduleName}" />`),H_()),J&&J.amdDependencies)for(let ys of J.amdDependencies)ys.name?yp(`/// <amd-dependency name="${ys.name}" path="${ys.path}" />`):yp(`/// <amd-dependency path="${ys.path}" />`),H_();function bi(ys,fs){for(let As of fs){let Ia=As.resolutionMode?`resolution-mode="${As.resolutionMode===99?"import":"require"}" `:"",Y_=As.preserve?'preserve="true" ':"";yp(`/// <reference ${ys}="${As.fileName}" ${Ia}${Y_}/>`),H_()}}bi("path",ye),bi("types",Dt),bi("lib",Zt)}function UE(O){let ye=O.statements;n1(O),kt(O.statements,wu),Rt(O);let Dt=Bo(ye,Zt=>!Mg(Zt));Za(O),sc(O,ye,1,void 0,Dt===-1?ye.length:Dt),pm(O)}function I2(O){let ye=Ga(O);!(ye&1024)&&O.pos!==O.expression.pos&&Qu(O.expression.pos),lt(O.expression),!(ye&2048)&&O.end!==O.expression.end&&ro(O.expression.end)}function O2(O){zy(O,O.elements,528,void 0)}function Yb(O,ye,Dt){let Zt=!!ye;for(let bi=0;bi<O.length;bi++){let ys=O[bi];if(Mg(ys))(Dt?!Dt.has(ys.expression.text):!0)&&(Zt&&(Zt=!1,Ci(ye)),H_(),yr(ys),Dt&&Dt.add(ys.expression.text));else return bi}return O.length}function F0(O){if(Ji(O))Yb(O.statements,O);else{let ye=new Set;for(let Dt of O.sourceFiles)Yb(Dt.statements,Dt,ye);Ci(void 0)}}function j0(O){if(Ji(O)){let ye=v5(O.text);if(ye)return yp(ye),H_(),!0}else for(let ye of O.sourceFiles)if(j0(ye))return!0}function Kb(O,ye){if(!O)return;let Dt=Ve;Ve=ye,yr(O),Ve=Dt}function ld(O,ye,Dt){if(ye?.length){if(wi(ye,Pa))return Ip(O,ye);if(wi(ye,fu))return Dt?Ak(O,ye):O.pos;d?.(ye);let Zt,bi,ys=0,fs=0,As;for(;ys<ye.length;){for(;fs<ye.length;){if(As=ye[fs],bi=fu(As)?"decorators":"modifiers",Zt===void 0)Zt=bi;else if(bi!==Zt)break;fs++}let Ia={pos:-1,end:-1};ys===0&&(Ia.pos=ye.pos),fs===ye.length-1&&(Ia.end=ye.end),(Zt==="modifiers"||Dt)&&R2(yr,O,ye,Zt==="modifiers"?2359808:2146305,void 0,ys,fs-ys,!1,Ia),ys=fs,Zt=bi,fs++}if(S?.(ye),As&&!ng(As.end))return As.end}return O.pos}function Ip(O,ye){sc(O,ye,2359808);let Dt=vc(ye);return Dt&&!ng(Dt.end)?Dt.end:O.pos}function Zv(O){O&&(Mn(":"),yn(),yr(O))}function e1(O,ye,Dt,Zt){O&&(yn(),Fe(64,ye,U0,Dt),yn(),lt(O,Zt))}function as(O,ye,Dt,Zt){Dt&&(ye(O),Zt(Dt))}function qn(O){O&&(yn(),yr(O))}function m_(O,ye){O&&(yn(),lt(O,ye))}function gD(O){O&&(yr(O),yn())}function Fm(O,ye){Vs(ye)||Ga(O)&1||xe&&!Qb(O,ye,0)?(yn(),yr(ye)):(H_(),jm(),tY(ye)?Ce(5,ye):yr(ye),fm())}function Ak(O,ye){sc(O,ye,2146305);let Dt=vc(ye);return Dt&&!ng(Dt.end)?Dt.end:O.pos}function Zh(O,ye){sc(O,ye,53776,Oi)}function t1(O,ye){if(Bs(O)&&O.typeArguments)return Zh(O,O.typeArguments);sc(O,ye,53776)}function B0(O,ye){sc(O,ye,2576)}function hD(O,ye){let Dt=Dh(ye);return Dt&&Dt.pos===O.pos&&pc(O)&&!O.type&&!Pt(O.modifiers)&&!Pt(O.typeParameters)&&!Pt(Dt.modifiers)&&!Dt.dotDotDotToken&&!Dt.questionToken&&!Dt.type&&!Dt.initializer&&He(Dt.name)}function Xb(O,ye){hD(O,ye)?sc(O,ye,528):B0(O,ye)}function Op(O,ye){sc(O,ye,8848)}function VE(O){switch(O&60){case 0:break;case 16:Mn(",");break;case 4:yn(),Mn("|");break;case 32:yn(),Mn("*"),yn();break;case 8:yn(),Mn("&");break}}function sc(O,ye,Dt,Zt,bi,ys){yD(yr,O,ye,Dt|(O&&Ga(O)&2?65536:0),Zt,bi,ys)}function zy(O,ye,Dt,Zt,bi,ys){yD(lt,O,ye,Dt,Zt,bi,ys)}function yD(O,ye,Dt,Zt,bi,ys=0,fs=Dt?Dt.length-ys:0){if(Dt===void 0&&Zt&16384)return;let Ia=Dt===void 0||ys>=Dt.length||fs===0;if(Ia&&Zt&32768){d?.(Dt),S?.(Dt);return}Zt&15360&&(Mn(txt(Zt)),Ia&&Dt&&Qu(Dt.pos,!0)),d?.(Dt),Ia?Zt&1&&!(xe&&(!ye||J&&n2(ye,J)))?H_():Zt&256&&!(Zt&524288)&&yn():R2(O,ye,Dt,Zt,bi,ys,fs,Dt.hasTrailingComma,Dt),S?.(Dt),Zt&15360&&(Ia&&Dt&&ro(Dt.end),Mn(rxt(Zt)))}function R2(O,ye,Dt,Zt,bi,ys,fs,As,Ia){let Y_=(Zt&262144)===0,w_=Y_,a1=Qb(ye,Dt[ys],Zt);a1?(H_(a1),w_=!1):Zt&256&&yn(),Zt&128&&jm();let HE=axt(O,bi),Sp,gg=!1;for(let oT=0;oT<fs;oT++){let o1=Dt[ys+oT];if(Zt&32)H_(),VE(Zt);else if(Sp){Zt&60&&Sp.end!==(ye?ye.end:-1)&&(Ga(Sp)&2048||ro(Sp.end)),VE(Zt);let bS=Dk(Sp,o1,Zt);if(bS>0){if(Zt&131||(jm(),gg=!0),w_&&Zt&60&&!ng(o1.pos)){let rs=Wg(o1);Qu(rs.pos,!!(Zt&512),!0)}H_(bS),w_=!1}else Sp&&Zt&512&&yn()}if(w_){let bS=Wg(o1);Qu(bS.pos)}else w_=Y_;te=o1.pos,HE(o1,O,bi,oT),gg&&(fm(),gg=!1),Sp=o1}let W0=Sp?Ga(Sp):0,GE=vr||!!(W0&2048),DD=As&&Zt&64&&Zt&16;DD&&(Sp&&!GE?Fe(28,Sp.end,Mn,Sp):Mn(",")),Sp&&(ye?ye.end:-1)!==Sp.end&&Zt&60&&!GE&&ro(DD&&Ia?.end?Ia.end:Sp.end),Zt&128&&fm();let $0=L2(ye,Dt[ys+fs-1],Zt,Ia);$0?H_($0):Zt&2097408&&yn()}function JE(O){he.writeLiteral(O)}function kk(O){he.writeStringLiteral(O)}function J6(O){he.write(O)}function vD(O,ye){he.writeSymbol(O,ye)}function Mn(O){he.writePunctuation(O)}function D_(){he.writeTrailingSemicolon(";")}function Ls(O){he.writeKeyword(O)}function U0(O){he.writeOperator(O)}function M2(O){he.writeParameter(O)}function yp(O){he.writeComment(O)}function yn(){he.writeSpace(" ")}function Pk(O){he.writeProperty(O)}function Nk(O){he.nonEscapingWrite?he.nonEscapingWrite(O):he.write(O)}function H_(O=1){for(let ye=0;ye<O;ye++)he.writeLine(ye>0)}function jm(){he.increaseIndent()}function fm(){he.decreaseIndent()}function r1(O,ye,Dt,Zt){return ke?ah(O,Dt,ye):s1(Zt,O,Dt,ye,ah)}function qE(O,ye){E&&E(O),ye(Sa(O.kind)),x&&x(O)}function ah(O,ye,Dt){let Zt=Sa(O);return ye(Zt),Dt<0?Dt:Dt+Zt.length}function vp(O,ye,Dt){if(Ga(O)&1)yn();else if(xe){let Zt=Bm(O,ye,Dt);Zt?H_(Zt):yn()}else H_()}function oh(O){let ye=O.split(/\r\n?|\n/g),Dt=g_e(ye);for(let Zt of ye){let bi=Dt?Zt.slice(Dt):Zt;bi.length&&(H_(),Ve(bi))}}function Ld(O,ye){O?(jm(),H_(O)):ye&&yn()}function Wy(O,ye){O&&fm(),ye&&fm()}function Qb(O,ye,Dt){if(Dt&2||xe){if(Dt&65536)return 1;if(ye===void 0)return!O||J&&n2(O,J)?0:1;if(ye.pos===te||ye.kind===12)return 0;if(J&&O&&!ng(O.pos)&&!Ko(ye)&&(!ye.parent||Bc(ye.parent)===Bc(O)))return xe?zE(Zt=>Qfe(ye.pos,O.pos,J,Zt)):j9(O,ye,J)?0:1;if(Zb(ye,Dt))return 1}return Dt&1?1:0}function Dk(O,ye,Dt){if(Dt&2||xe){if(O===void 0||ye===void 0||ye.kind===12)return 0;if(J&&!Ko(O)&&!Ko(ye))return xe&&AD(O,ye)?zE(Zt=>sG(O,ye,J,Zt)):!xe&&ud(O,ye)?JR(O,ye,J)?0:1:Dt&65536?1:0;if(Zb(O,Dt)||Zb(ye,Dt))return 1}else if(yO(ye))return 1;return Dt&1?1:0}function L2(O,ye,Dt,Zt){if(Dt&2||xe){if(Dt&65536)return 1;if(ye===void 0)return!O||J&&n2(O,J)?0:1;if(J&&O&&!ng(O.pos)&&!Ko(ye)&&(!ye.parent||ye.parent===O)){if(xe){let bi=Zt&&!ng(Zt.end)?Zt.end:ye.end;return zE(ys=>Zfe(bi,O.end,J,ys))}return Yfe(O,ye,J)?0:1}if(Zb(ye,Dt))return 1}return Dt&1&&!(Dt&131072)?1:0}function zE(O){M.assert(!!xe);let ye=O(!0);return ye===0?O(!1):ye}function SD(O,ye){let Dt=xe&&Qb(ye,O,0);return Dt&&Ld(Dt,!1),!!Dt}function F2(O,ye){let Dt=xe&&L2(ye,O,0,void 0);Dt&&H_(Dt)}function Zb(O,ye){if(Ko(O)){let Dt=yO(O);return Dt===void 0?(ye&65536)!==0:Dt}return(ye&65536)!==0}function Bm(O,ye,Dt){return Ga(O)&262144?0:(O=eT(O),ye=eT(ye),Dt=eT(Dt),yO(Dt)?1:J&&!Ko(O)&&!Ko(ye)&&!Ko(Dt)?xe?zE(Zt=>sG(ye,Dt,J,Zt)):JR(ye,Dt,J)?0:1:0)}function bD(O){return O.statements.length===0&&(!J||JR(O,O,J))}function eT(O){for(;O.kind===217&&Ko(O);)O=O.expression;return O}function mS(O,ye){if(xc(O)||zx(O))return pl(O);if(La(O)&&O.textSourceNode)return mS(O.textSourceNode,ye);let Dt=J,Zt=!!Dt&&!!O.parent&&!Ko(O);if(Cy(O)){if(!Zt||Ur(O)!==Bc(Dt))return Nn(O)}else if(sg(O)){if(!Zt||Ur(O)!==Bc(Dt))return hO(O)}else if(M.assertNode(O,WT),!Zt)return O.text;return GT(Dt,O,ye)}function V0(O,ye,Dt){if(O.kind===11&&O.textSourceNode){let bi=O.textSourceNode;if(He(bi)||Zi(bi)||Pf(bi)||sg(bi)){let ys=Pf(bi)?bi.text:mS(bi);return Dt?`"${qH(ys)}"`:ye||Ga(O)&16777216?`"${Vh(ys)}"`:`"${E9(ys)}"`}else return V0(bi,ye,Dt)}let Zt=(ye?1:0)|(Dt?2:0)|(e.terminateUnterminatedLiterals?4:0)|(e.target&&e.target>=8?8:0);return P_e(O,J,Zt)}function n1(O){re.push(ue),ue=0,de.push(Ae),!(O&&Ga(O)&1048576)&&(ce.push(ne),ne=0,pe.push(K),K=void 0,le.push(me))}function pm(O){ue=re.pop(),Ae=de.pop(),!(O&&Ga(O)&1048576)&&(ne=ce.pop(),K=pe.pop(),me=le.pop())}function i1(O){(!me||me===vc(le))&&(me=new Set),me.add(O)}function tT(O){(!Ae||Ae===vc(de))&&(Ae=new Set),Ae.add(O)}function wu(O){if(O)switch(O.kind){case 241:kt(O.statements,wu);break;case 256:case 254:case 246:case 247:wu(O.statement);break;case 245:wu(O.thenStatement),wu(O.elseStatement);break;case 248:case 250:case 249:wu(O.initializer),wu(O.statement);break;case 255:wu(O.caseBlock);break;case 269:kt(O.clauses,wu);break;case 296:case 297:kt(O.statements,wu);break;case 258:wu(O.tryBlock),wu(O.catchClause),wu(O.finallyBlock);break;case 299:wu(O.variableDeclaration),wu(O.block);break;case 243:wu(O.declarationList);break;case 261:kt(O.declarations,wu);break;case 260:case 169:case 208:case 263:ch(O.name);break;case 262:ch(O.name),Ga(O)&1048576&&(kt(O.parameters,wu),wu(O.body));break;case 206:case 207:kt(O.elements,wu);break;case 272:wu(O.importClause);break;case 273:ch(O.name),wu(O.namedBindings);break;case 274:ch(O.name);break;case 280:ch(O.name);break;case 275:kt(O.elements,wu);break;case 276:ch(O.propertyName||O.name);break}}function J0(O){if(O)switch(O.kind){case 303:case 304:case 172:case 171:case 174:case 173:case 177:case 178:ch(O.name);break}}function ch(O){O&&(xc(O)||zx(O)?pl(O):Hs(O)&&wu(O))}function pl(O){let ye=O.emitNode.autoGenerate;if((ye.flags&7)===4)return Au(b8(O),Zi(O),ye.flags,ye.prefix,ye.suffix);{let Dt=ye.id;return ee[Dt]||(ee[Dt]=j2(O))}}function Au(O,ye,Dt,Zt,bi){let ys=yo(O),fs=ye?q:G;return fs[ys]||(fs[ys]=G_(O,ye,Dt??0,kN(Zt,pl),kN(bi)))}function q0(O,ye){return Fd(O,ye)&&!Gf(O,ye)&&!W.has(O)}function Gf(O,ye){let Dt,Zt;if(ye?(Dt=Ae,Zt=de):(Dt=me,Zt=le),Dt?.has(O))return!0;for(let bi=Zt.length-1;bi>=0;bi--)if(Dt!==Zt[bi]&&(Dt=Zt[bi],Dt?.has(O)))return!0;return!1}function Fd(O,ye){return J?W5(J,O,n):!0}function wk(O,ye){for(let Dt=ye;Dt&&rE(Dt,ye);Dt=Dt.nextContainer)if(Lh(Dt)&&Dt.locals){let Zt=Dt.locals.get(Uc(O));if(Zt&&Zt.flags&3257279)return!1}return!0}function lh(O){switch(O){case"":return ne;case"#":return ue;default:return K?.get(O)??0}}function Ik(O,ye){switch(O){case"":ne=ye;break;case"#":ue=ye;break;default:K??(K=new Map),K.set(O,ye);break}}function uh(O,ye,Dt,Zt,bi){Zt.length>0&&Zt.charCodeAt(0)===35&&(Zt=Zt.slice(1));let ys=xb(Dt,Zt,"",bi),fs=lh(ys);if(O&&!(fs&O)){let Ia=xb(Dt,Zt,O===268435456?"_i":"_n",bi);if(q0(Ia,Dt))return fs|=O,Dt?tT(Ia):ye&&i1(Ia),Ik(ys,fs),Ia}for(;;){let As=fs&268435455;if(fs++,As!==8&&As!==13){let Ia=As<26?"_"+String.fromCharCode(97+As):"_"+(As-26),Y_=xb(Dt,Zt,Ia,bi);if(q0(Y_,Dt))return Dt?tT(Y_):ye&&i1(Y_),Ik(ys,fs),Y_}}}function gS(O,ye=q0,Dt,Zt,bi,ys,fs){if(O.length>0&&O.charCodeAt(0)===35&&(O=O.slice(1)),ys.length>0&&ys.charCodeAt(0)===35&&(ys=ys.slice(1)),Dt){let Ia=xb(bi,ys,O,fs);if(ye(Ia,bi))return bi?tT(Ia):Zt?i1(Ia):W.add(Ia),Ia}O.charCodeAt(O.length-1)!==95&&(O+="_");let As=1;for(;;){let Ia=xb(bi,ys,O+As,fs);if(ye(Ia,bi))return bi?tT(Ia):Zt?i1(Ia):W.add(Ia),Ia;As++}}function TD(O){return gS(O,Fd,!0,!1,!1,"","")}function nl(O){let ye=mS(O.name);return wk(ye,ai(O,Lh))?ye:gS(ye,q0,!1,!1,!1,"","")}function ED(O){let ye=sA(O),Dt=La(ye)?D_e(ye.text):"module";return gS(Dt,q0,!1,!1,!1,"","")}function xD(){return gS("default",q0,!1,!1,!1,"","")}function rT(){return gS("class",q0,!1,!1,!1,"","")}function q6(O,ye,Dt,Zt){return He(O.name)?Au(O.name,ye):uh(0,!1,ye,Dt,Zt)}function G_(O,ye,Dt,Zt,bi){switch(O.kind){case 80:case 81:return gS(mS(O),q0,!!(Dt&16),!!(Dt&8),ye,Zt,bi);case 267:case 266:return M.assert(!Zt&&!bi&&!ye),nl(O);case 272:case 278:return M.assert(!Zt&&!bi&&!ye),ED(O);case 262:case 263:{M.assert(!Zt&&!bi&&!ye);let ys=O.name;return ys&&!xc(ys)?G_(ys,!1,Dt,Zt,bi):xD()}case 277:return M.assert(!Zt&&!bi&&!ye),xD();case 231:return M.assert(!Zt&&!bi&&!ye),rT();case 174:case 177:case 178:return q6(O,ye,Zt,bi);case 167:return uh(0,!0,ye,Zt,bi);default:return uh(0,!1,ye,Zt,bi)}}function j2(O){let ye=O.emitNode.autoGenerate,Dt=kN(ye.prefix,pl),Zt=kN(ye.suffix);switch(ye.flags&7){case 1:return uh(0,!!(ye.flags&8),Zi(O),Dt,Zt);case 2:return M.assertNode(O,He),uh(268435456,!!(ye.flags&8),!1,Dt,Zt);case 3:return gS(Nn(O),ye.flags&32?Fd:q0,!!(ye.flags&16),!!(ye.flags&8),Zi(O),Dt,Zt)}return M.fail(`Unsupported GeneratedIdentifierKind: ${M.formatEnum(ye.flags&7,KW,!0)}.`)}function WE(O,ye){let Dt=ft(2,O,ye),Zt=Ie,bi=_t,ys=mt;nT(ye),Dt(O,ye),Mf(ye,Zt,bi,ys)}function nT(O){let ye=Ga(O),Dt=Wg(O);z6(O,ye,Dt.pos,Dt.end),ye&4096&&(vr=!0)}function Mf(O,ye,Dt,Zt){let bi=Ga(O),ys=Wg(O);bi&4096&&(vr=!1),iT(O,bi,ys.pos,ys.end,ye,Dt,Zt);let fs=tde(O);fs&&iT(O,bi,fs.pos,fs.end,ye,Dt,Zt)}function z6(O,ye,Dt,Zt){ur(),rr=!1;let bi=Dt<0||(ye&1024)!==0||O.kind===12,ys=Zt<0||(ye&2048)!==0||O.kind===12;(Dt>0||Zt>0)&&Dt!==Zt&&(bi||hS(Dt,O.kind!==353),(!bi||Dt>=0&&ye&1024)&&(Ie=Dt),(!ys||Zt>=0&&ye&2048)&&(_t=Zt,O.kind===261&&(mt=Zt))),kt(mN(O),CD),or()}function iT(O,ye,Dt,Zt,bi,ys,fs){ur();let As=Zt<0||(ye&2048)!==0||O.kind===12;kt(s8(O),sT),(Dt>0||Zt>0)&&Dt!==Zt&&(Ie=bi,_t=ys,mt=fs,!As&&O.kind!==353&&jn(Zt)),or()}function CD(O){(O.hasLeadingNewline||O.kind===2)&&he.writeLine(),$E(O),O.hasTrailingNewLine||O.kind===2?he.writeLine():he.writeSpace(" ")}function sT(O){he.isAtStartOfLine()||he.writeSpace(" "),$E(O),O.hasTrailingNewLine&&he.writeLine()}function $E(O){let ye=Ok(O),Dt=O.kind===3?$C(ye):void 0;oN(ye,Dt,he,0,ye.length,R)}function Ok(O){return O.kind===3?`/*${O.text}*/`:`//${O.text}`}function B2(O,ye,Dt){ur();let{pos:Zt,end:bi}=ye,ys=Ga(O),fs=Zt<0||(ys&1024)!==0,As=vr||bi<0||(ys&2048)!==0;fs||Um(ye),or(),ys&4096&&!vr?(vr=!0,Dt(O),vr=!1):Dt(O),ur(),As||(hS(ye.end,!0),rr&&!he.isAtStartOfLine()&&he.writeLine()),or()}function ud(O,ye){return O=Bc(O),O.parent&&O.parent===Bc(ye).parent}function AD(O,ye){if(ye.pos<O.end)return!1;O=Bc(O),ye=Bc(ye);let Dt=O.parent;if(!Dt||Dt!==ye.parent)return!1;let Zt=Ope(O),bi=Zt?.indexOf(O);return bi!==void 0&&bi>-1&&Zt.indexOf(ye)===bi+1}function hS(O,ye){rr=!1,ye?O===0&&J?.isDeclarationFile?aT(O,mg):aT(O,V2):O===0&&aT(O,Rp)}function Rp(O,ye,Dt,Zt,bi){ey(O,ye)&&V2(O,ye,Dt,Zt,bi)}function mg(O,ye,Dt,Zt,bi){ey(O,ye)||V2(O,ye,Dt,Zt,bi)}function U2(O,ye){return e.onlyPrintJsDocStyle?kY(O,ye)||$5(O,ye):!0}function V2(O,ye,Dt,Zt,bi){!J||!U2(J.text,O)||(rr||(Rfe(Gs(),he,bi,O),rr=!0),Vm(O),oN(J.text,Gs(),he,O,ye,R),Vm(ye),Zt?he.writeLine():Dt===3&&he.writeSpace(" "))}function ro(O){vr||O===-1||hS(O,!0)}function jn(O){yS(O,_d)}function _d(O,ye,Dt,Zt){!J||!U2(J.text,O)||(he.isAtStartOfLine()||he.writeSpace(" "),Vm(O),oN(J.text,Gs(),he,O,ye,R),Vm(ye),Zt&&he.writeLine())}function Qu(O,ye,Dt){vr||(ur(),yS(O,ye?_d:Dt?kD:PD),or())}function kD(O,ye,Dt){J&&(Vm(O),oN(J.text,Gs(),he,O,ye,R),Vm(ye),Dt===2&&he.writeLine())}function PD(O,ye,Dt,Zt){J&&(Vm(O),oN(J.text,Gs(),he,O,ye,R),Vm(ye),Zt?he.writeLine():he.writeSpace(" "))}function aT(O,ye){J&&(Ie===-1||O!==Ie)&&(ND(O)?vS(ye):x3(J.text,O,ye,O))}function yS(O,ye){J&&(_t===-1||O!==_t&&O!==mt)&&C3(J.text,O,ye)}function ND(O){return ht!==void 0&&Va(ht).nodePos===O}function vS(O){if(!J)return;let ye=Va(ht).detachedCommentEndPos;ht.length-1?ht.pop():ht=void 0,x3(J.text,ye,O,ye)}function Um(O){let ye=J&&Lfe(J.text,Gs(),he,Mp,O,R,vr);ye&&(ht?ht.push(ye):ht=[ye])}function Mp(O,ye,Dt,Zt,bi,ys){!J||!U2(J.text,Zt)||(Vm(Zt),oN(O,ye,Dt,Zt,bi,ys),Vm(bi))}function ey(O,ye){return!!J&&eH(J.text,O,ye)}function _h(O,ye){let Dt=ft(3,O,ye);z0(ye),Dt(O,ye),J2(ye)}function z0(O){let ye=Ga(O),Dt=Ov(O),Zt=Dt.source||Be;O.kind!==353&&!(ye&32)&&Dt.pos>=0&&Lp(Dt.source||Be,Ll(Zt,Dt.pos)),ye&128&&(ke=!0)}function J2(O){let ye=Ga(O),Dt=Ov(O);ye&128&&(ke=!1),O.kind!==353&&!(ye&64)&&Dt.end>=0&&Lp(Dt.source||Be,Dt.end)}function Ll(O,ye){return O.skipTrivia?O.skipTrivia(ye):Ja(O.text,ye)}function Vm(O){if(ke||ng(O)||SS(Be))return;let{line:ye,character:Dt}=ba(Be,O);De.addMapping(he.getLine(),he.getColumn(),ct,ye,Dt,void 0)}function Lp(O,ye){if(O!==Be){let Dt=Be,Zt=ct;fd(O),Vm(ye),q2(Dt,Zt)}else Vm(ye)}function s1(O,ye,Dt,Zt,bi){if(ke||O&&_9(O))return bi(ye,Dt,Zt);let ys=O&&O.emitNode,fs=ys&&ys.flags||0,As=ys&&ys.tokenSourceMapRanges&&ys.tokenSourceMapRanges[ye],Ia=As&&As.source||Be;return Zt=Ll(Ia,As?As.pos:Zt),!(fs&256)&&Zt>=0&&Lp(Ia,Zt),Zt=bi(ye,Dt,Zt),As&&(Zt=As.end),!(fs&512)&&Zt>=0&&Lp(Ia,Zt),Zt}function fd(O){if(!ke){if(Be=O,O===qe){ct=et;return}SS(O)||(ct=De.addSource(O.fileName),e.inlineSources&&De.setSourceContent(ct,O.text),qe=O,et=ct)}}function q2(O,ye){Be=O,ct=ye}function SS(O){return Ic(O.fileName,".json")}}function ext(){let e=[];return e[1024]=["{","}"],e[2048]=["(",")"],e[4096]=["<",">"],e[8192]=["[","]"],e}function txt(e){return y8e[e&15360][0]}function rxt(e){return y8e[e&15360][1]}function nxt(e,t,n,i){t(e)}function ixt(e,t,n,i){t(e,n.select(i))}function sxt(e,t,n,i){t(e,n)}function axt(e,t){return e.length===1?nxt:typeof t=="object"?ixt:sxt}function JB(e,t,n){if(!e.getDirectories||!e.readDirectory)return;let i=new Map,s=l_(n);return{useCaseSensitiveFileNames:n,fileExists:w,readFile:(K,re)=>e.readFile(K,re),directoryExists:e.directoryExists&&R,getDirectories:F,readDirectory:J,createDirectory:e.createDirectory&&L,writeFile:e.writeFile&&D,addOrDeleteFileOrDirectory:q,addOrDeleteFile:ee,clearCache:pe,realpath:e.realpath&&G};function o(K){return rc(K,t,s)}function u(K){return i.get(yu(K))}function m(K){let re=u(mi(K));return re&&(re.sortedAndCanonicalizedFiles||(re.sortedAndCanonicalizedFiles=re.files.map(s).sort(),re.sortedAndCanonicalizedDirectories=re.directories.map(s).sort()),re)}function d(K){return Ul(Zs(K))}function S(K,re){var ue;if(!e.realpath||yu(o(e.realpath(K)))===re){let ce={files:Cr(e.readDirectory(K,void 0,void 0,["*.*"]),d)||[],directories:e.getDirectories(K)||[]};return i.set(yu(re),ce),ce}if((ue=e.directoryExists)!=null&&ue.call(e,K))return i.set(re,!1),!1}function E(K,re){re=yu(re);let ue=u(re);if(ue)return ue;try{return S(K,re)}catch{M.assert(!i.has(yu(re)));return}}function x(K,re){return mv(K,re,ec,c_)>=0}function D(K,re,ue){let ce=o(K),ne=m(ce);return ne&&W(ne,d(K),!0),e.writeFile(K,re,ue)}function w(K){let re=o(K),ue=m(re);return ue&&x(ue.sortedAndCanonicalizedFiles,s(d(K)))||e.fileExists(K)}function R(K){let re=o(K);return i.has(yu(re))||e.directoryExists(K)}function L(K){let re=o(K),ue=m(re);if(ue){let ce=d(K),ne=s(ce),le=ue.sortedAndCanonicalizedDirectories;l0(le,ne,c_)&&ue.directories.push(ce)}e.createDirectory(K)}function F(K){let re=o(K),ue=E(K,re);return ue?ue.directories.slice():e.getDirectories(K)}function J(K,re,ue,ce,ne){let le=o(K),me=E(K,le),de;if(me!==void 0)return TG(K,re,ue,ce,n,t,ne,Ae,G);return e.readDirectory(K,re,ue,ce,ne);function Ae(te){let he=o(te);if(he===le)return me||xe(te,he);let be=E(te,he);return be!==void 0?be||xe(te,he):CG}function xe(te,he){if(de&&he===le)return de;let be={files:Cr(e.readDirectory(te,void 0,void 0,["*.*"]),d)||ve,directories:e.getDirectories(te)||ve};return he===le&&(de=be),be}}function G(K){return e.realpath?e.realpath(K):K}function q(K,re){if(u(re)!==void 0){pe();return}let ce=m(re);if(!ce)return;if(!e.directoryExists){pe();return}let ne=d(K),le={fileExists:e.fileExists(K),directoryExists:e.directoryExists(K)};return le.directoryExists||x(ce.sortedAndCanonicalizedDirectories,s(ne))?pe():W(ce,ne,le.fileExists),le}function ee(K,re,ue){if(ue===1)return;let ce=m(re);ce&&W(ce,d(K),ue===0)}function W(K,re,ue){let ce=K.sortedAndCanonicalizedFiles,ne=s(re);if(ue)l0(ce,ne,c_)&&K.files.push(re);else{let le=mv(ce,ne,ec,c_);if(le>=0){ce.splice(le,1);let me=K.files.findIndex(de=>s(de)===ne);K.files.splice(me,1)}}}function pe(){i.clear()}}var jhe=(e=>(e[e.Update=0]="Update",e[e.RootNamesAndUpdate=1]="RootNamesAndUpdate",e[e.Full=2]="Full",e))(jhe||{});function qB(e,t,n,i,s){var o;let u=xP(((o=t?.configFile)==null?void 0:o.extendedSourceFiles)||ve,s);n.forEach((m,d)=>{u.has(d)||(m.projects.delete(e),m.close())}),u.forEach((m,d)=>{let S=n.get(d);S?S.projects.add(e):n.set(d,{projects:new Set([e]),watcher:i(m,d),close:()=>{let E=n.get(d);!E||E.projects.size!==0||(E.watcher.close(),n.delete(d))}})})}function zK(e,t){t.forEach(n=>{n.projects.delete(e)&&n.close()})}function zB(e,t,n){e.delete(t)&&e.forEach(({extendedResult:i},s)=>{var o;(o=i.extendedSourceFiles)!=null&&o.some(u=>n(u)===t)&&zB(e,s,n)})}function WK(e,t,n){tO(t,e.getMissingFilePaths(),{createNewValue:n,onDeleteValue:Dm})}function W8(e,t,n){t?tO(e,new Map(Object.entries(t)),{createNewValue:i,onDeleteValue:Nd,onExistingValue:s}):Vf(e,Nd);function i(o,u){return{watcher:n(o,u),flags:u}}function s(o,u,m){o.flags!==u&&(o.watcher.close(),e.set(m,i(m,u)))}}function $8({watchedDirPath:e,fileOrDirectory:t,fileOrDirectoryPath:n,configFileName:i,options:s,program:o,extraFileExtensions:u,currentDirectory:m,useCaseSensitiveFileNames:d,writeLog:S,toPath:E,getScriptKind:x}){let D=ZB(n);if(!D)return S(`Project: ${i} Detected ignored path: ${t}`),!0;if(n=D,n===e)return!1;if(kP(n)&&!(xpe(t,s,u)||J()))return S(`Project: ${i} Detected file add/remove of non supported extension: ${t}`),!0;if(Zme(t,s.configFile.configFileSpecs,xs(mi(i),m),d,m))return S(`Project: ${i} Detected excluded file: ${t}`),!0;if(!o||s.outFile||s.outDir)return!1;if(Mu(n)){if(s.declarationDir)return!1}else if(!wl(n,_N))return!1;let w=of(n),R=Rs(o)?void 0:oxt(o)?o.getProgramOrUndefined():o,L=!R&&!Rs(o)?o:void 0;if(F(w+".ts")||F(w+".tsx"))return S(`Project: ${i} Detected output file: ${t}`),!0;return!1;function F(G){return R?!!R.getSourceFileByPath(G):L?L.getState().fileInfos.has(G):!!Ln(o,q=>E(q)===G)}function J(){if(!x)return!1;switch(x(t)){case 3:case 4:case 7:case 5:return!0;case 1:case 2:return H1(s);case 6:return cE(s);case 0:return!1}}}function oxt(e){return!!e.getState}function Bhe(e,t){return e?e.isEmittedFile(t):!1}var Uhe=(e=>(e[e.None=0]="None",e[e.TriggerOnly=1]="TriggerOnly",e[e.Verbose=2]="Verbose",e))(Uhe||{});function $K(e,t,n,i){pue(t===2?n:io);let s={watchFile:(L,F,J,G)=>e.watchFile(L,F,J,G),watchDirectory:(L,F,J,G)=>e.watchDirectory(L,F,(J&1)!==0,G)},o=t!==0?{watchFile:w("watchFile"),watchDirectory:w("watchDirectory")}:void 0,u=t===2?{watchFile:x,watchDirectory:D}:o||s,m=t===2?E:u6;return{watchFile:d("watchFile"),watchDirectory:d("watchDirectory")};function d(L){return(F,J,G,q,ee,W)=>{var pe;return pB(F,L==="watchFile"?q?.excludeFiles:q?.excludeDirectories,S(),((pe=e.getCurrentDirectory)==null?void 0:pe.call(e))||"")?m(F,G,q,ee,W):u[L].call(void 0,F,J,G,q,ee,W)}}function S(){return typeof e.useCaseSensitiveFileNames=="boolean"?e.useCaseSensitiveFileNames:e.useCaseSensitiveFileNames()}function E(L,F,J,G,q){return n(`ExcludeWatcher:: Added:: ${R(L,F,J,G,q,i)}`),{close:()=>n(`ExcludeWatcher:: Close:: ${R(L,F,J,G,q,i)}`)}}function x(L,F,J,G,q,ee){n(`FileWatcher:: Added:: ${R(L,J,G,q,ee,i)}`);let W=o.watchFile(L,F,J,G,q,ee);return{close:()=>{n(`FileWatcher:: Close:: ${R(L,J,G,q,ee,i)}`),W.close()}}}function D(L,F,J,G,q,ee){let W=`DirectoryWatcher:: Added:: ${R(L,J,G,q,ee,i)}`;n(W);let pe=Tc(),K=o.watchDirectory(L,F,J,G,q,ee),re=Tc()-pe;return n(`Elapsed:: ${re}ms ${W}`),{close:()=>{let ue=`DirectoryWatcher:: Close:: ${R(L,J,G,q,ee,i)}`;n(ue);let ce=Tc();K.close();let ne=Tc()-ce;n(`Elapsed:: ${ne}ms ${ue}`)}}}function w(L){return(F,J,G,q,ee,W)=>s[L].call(void 0,F,(...pe)=>{let K=`${L==="watchFile"?"FileWatcher":"DirectoryWatcher"}:: Triggered with ${pe[0]} ${pe[1]!==void 0?pe[1]:""}:: ${R(F,G,q,ee,W,i)}`;n(K);let re=Tc();J.call(void 0,...pe);let ue=Tc()-re;n(`Elapsed:: ${ue}ms ${K}`)},G,q,ee,W)}function R(L,F,J,G,q,ee){return`WatchInfo: ${L} ${F} ${JSON.stringify(J)} ${ee?ee(G,q):q===void 0?G:`${G} ${q}`}`}}function H8(e){let t=e?.fallbackPolling;return{watchFile:t!==void 0?t:1}}function Nd(e){e.watcher.close()}function HK(e,t,n="tsconfig.json"){return Am(e,i=>{let s=ri(i,n);return t(s)?s:void 0})}function GK(e,t){let n=mi(t),i=ip(e)?e:ri(n,e);return Zs(i)}function Vhe(e,t,n){let i;return kt(e,o=>{let u=S3(o,t);if(u.pop(),!i){i=u;return}let m=Math.min(i.length,u.length);for(let d=0;d<m;d++)if(n(i[d])!==n(u[d])){if(d===0)return!0;i.length=d;break}u.length<i.length&&(i.length=u.length)})?"":i?u0(i):t}function Jhe(e,t){return WB(e,t)}function YK(e,t){return(n,i,s)=>{let o;try{jc("beforeIORead"),o=e(n),jc("afterIORead"),vd("I/O Read","beforeIORead","afterIORead")}catch(u){s&&s(u.message),o=""}return o!==void 0?HA(n,o,i,t):void 0}}function KK(e,t,n){return(i,s,o,u)=>{try{jc("beforeIOWrite"),HH(i,s,o,e,t,n),jc("afterIOWrite"),vd("I/O Write","beforeIOWrite","afterIOWrite")}catch(m){u&&u(m.message)}}}function WB(e,t,n=lu){let i=new Map,s=l_(n.useCaseSensitiveFileNames);function o(E){return i.has(E)?!0:(S.directoryExists||n.directoryExists)(E)?(i.set(E,!0),!0):!1}function u(){return mi(Zs(n.getExecutingFilePath()))}let m=wv(e),d=n.realpath&&(E=>n.realpath(E)),S={getSourceFile:YK(E=>S.readFile(E),t),getDefaultLibLocation:u,getDefaultLibFileName:E=>ri(u(),k3(E)),writeFile:KK((E,x,D)=>n.writeFile(E,x,D),E=>(S.createDirectory||n.createDirectory)(E),E=>o(E)),getCurrentDirectory:tf(()=>n.getCurrentDirectory()),useCaseSensitiveFileNames:()=>n.useCaseSensitiveFileNames,getCanonicalFileName:s,getNewLine:()=>m,fileExists:E=>n.fileExists(E),readFile:E=>n.readFile(E),trace:E=>n.write(E+m),directoryExists:E=>n.directoryExists(E),getEnvironmentVariable:E=>n.getEnvironmentVariable?n.getEnvironmentVariable(E):"",getDirectories:E=>n.getDirectories(E),realpath:d,readDirectory:(E,x,D,w,R)=>n.readDirectory(E,x,D,w,R),createDirectory:E=>n.createDirectory(E),createHash:ia(n,n.createHash)};return S}function a6(e,t,n){let i=e.readFile,s=e.fileExists,o=e.directoryExists,u=e.createDirectory,m=e.writeFile,d=new Map,S=new Map,E=new Map,x=new Map,D=L=>{let F=t(L),J=d.get(F);return J!==void 0?J!==!1?J:void 0:w(F,L)},w=(L,F)=>{let J=i.call(e,F);return d.set(L,J!==void 0?J:!1),J};e.readFile=L=>{let F=t(L),J=d.get(F);return J!==void 0?J!==!1?J:void 0:!Ic(L,".json")&&!Ohe(L)?i.call(e,L):w(F,L)};let R=n?(L,F,J,G)=>{let q=t(L),ee=typeof F=="object"?F.impliedNodeFormat:void 0,W=x.get(ee),pe=W?.get(q);if(pe)return pe;let K=n(L,F,J,G);return K&&(Mu(L)||Ic(L,".json"))&&x.set(ee,(W||new Map).set(q,K)),K}:void 0;return e.fileExists=L=>{let F=t(L),J=S.get(F);if(J!==void 0)return J;let G=s.call(e,L);return S.set(F,!!G),G},m&&(e.writeFile=(L,F,...J)=>{let G=t(L);S.delete(G);let q=d.get(G);q!==void 0&&q!==F?(d.delete(G),x.forEach(ee=>ee.delete(G))):R&&x.forEach(ee=>{let W=ee.get(G);W&&W.text!==F&&ee.delete(G)}),m.call(e,L,F,...J)}),o&&(e.directoryExists=L=>{let F=t(L),J=E.get(F);if(J!==void 0)return J;let G=o.call(e,L);return E.set(F,!!G),G},u&&(e.createDirectory=L=>{let F=t(L);E.delete(F),u.call(e,L)})),{originalReadFile:i,originalFileExists:s,originalDirectoryExists:o,originalCreateDirectory:u,originalWriteFile:m,getSourceFileWithCache:R,readFileWithCache:D}}function A8e(e,t,n){let i;return i=wn(i,e.getConfigFileParsingDiagnostics()),i=wn(i,e.getOptionsDiagnostics(n)),i=wn(i,e.getSyntacticDiagnostics(t,n)),i=wn(i,e.getGlobalDiagnostics(n)),i=wn(i,e.getSemanticDiagnostics(t,n)),$p(e.getCompilerOptions())&&(i=wn(i,e.getDeclarationDiagnostics(t,n))),wP(i||ve)}function k8e(e,t){let n="";for(let i of e)n+=XK(i,t);return n}function XK(e,t){let n=`${Bx(e)} TS${e.code}: ${Zg(e.messageText,t.getNewLine())}${t.getNewLine()}`;if(e.file){let{line:i,character:s}=ba(e.file,e.start),o=e.file.fileName;return`${sI(o,t.getCurrentDirectory(),m=>t.getCanonicalFileName(m))}(${i+1},${s+1}): `+n}return n}var qhe=(e=>(e.Grey="\x1B[90m",e.Red="\x1B[91m",e.Yellow="\x1B[93m",e.Blue="\x1B[94m",e.Cyan="\x1B[96m",e))(qhe||{}),zhe="\x1B[7m",Whe=" ",P8e="\x1B[0m",N8e="...",cxt="  ",D8e="    ";function w8e(e){switch(e){case 1:return"\x1B[91m";case 0:return"\x1B[93m";case 2:return M.fail("Should never get an Info diagnostic on the command line.");case 3:return"\x1B[94m"}}function AE(e,t){return t+e+P8e}function I8e(e,t,n,i,s,o){let{line:u,character:m}=ba(e,t),{line:d,character:S}=ba(e,t+n),E=ba(e,e.text.length).line,x=d-u>=4,D=(d+1+"").length;x&&(D=Math.max(N8e.length,D));let w="";for(let R=u;R<=d;R++){w+=o.getNewLine(),x&&u+1<R&&R<d-1&&(w+=i+AE(N8e.padStart(D),zhe)+Whe+o.getNewLine(),R=d-1);let L=T3(e,R,0),F=R<E?T3(e,R+1,0):e.text.length,J=e.text.slice(L,F);if(J=J.trimEnd(),J=J.replace(/\t/g," "),w+=i+AE((R+1+"").padStart(D),zhe)+Whe,w+=J+o.getNewLine(),w+=i+AE("".padStart(D),zhe)+Whe,w+=s,R===u){let G=R===d?S:void 0;w+=J.slice(0,m).replace(/\S/g," "),w+=J.slice(m,G).replace(/./g,"~")}else R===d?w+=J.slice(0,S).replace(/./g,"~"):w+=J.replace(/./g,"~");w+=P8e}return w}function QK(e,t,n,i=AE){let{line:s,character:o}=ba(e,t),u=n?sI(e.fileName,n.getCurrentDirectory(),d=>n.getCanonicalFileName(d)):e.fileName,m="";return m+=i(u,"\x1B[96m"),m+=":",m+=i(`${s+1}`,"\x1B[93m"),m+=":",m+=i(`${o+1}`,"\x1B[93m"),m}function $he(e,t){let n="";for(let i of e){if(i.file){let{file:s,start:o}=i;n+=QK(s,o,t),n+=" - "}if(n+=AE(Bx(i),w8e(i.category)),n+=AE(` TS${i.code}: `,"\x1B[90m"),n+=Zg(i.messageText,t.getNewLine()),i.file&&i.code!==v.File_appears_to_be_binary.code&&(n+=t.getNewLine(),n+=I8e(i.file,i.start,i.length,"",w8e(i.category),t)),i.relatedInformation){n+=t.getNewLine();for(let{file:s,start:o,length:u,messageText:m}of i.relatedInformation)s&&(n+=t.getNewLine(),n+=cxt+QK(s,o,t),n+=I8e(s,o,u,D8e,"\x1B[96m",t)),n+=t.getNewLine(),n+=D8e+Zg(m,t.getNewLine())}n+=t.getNewLine()}return n}function Zg(e,t,n=0){if(bs(e))return e;if(e===void 0)return"";let i="";if(n){i+=t;for(let s=0;s<n;s++)i+="  "}if(i+=e.messageText,n++,e.next)for(let s of e.next)i+=Zg(s,t,n);return i}function G8(e,t){return(bs(e)?t:e.resolutionMode)||t}function Hhe(e,t,n){return tX(e,Q8(e,t),n)}function ZK(e){var t;return xl(e)?e.isTypeOnly:!!((t=e.importClause)!=null&&t.isTypeOnly)}function eX(e,t,n){return tX(e,t,n)}function tX(e,t,n){var i;if((Yc(t.parent)||xl(t.parent)||Xg(t.parent))&&ZK(t.parent)){let u=BN(t.parent.attributes);if(u)return u}if(t.parent.parent&&qh(t.parent.parent)){let o=BN(t.parent.parent.attributes);if(o)return o}if(n&&V_(n)===200)return t.parent.parent&&ru(t.parent.parent)||kf(t.parent,!1)?1:99;if(e.impliedNodeFormat===void 0)return;if(e.impliedNodeFormat!==99)return Np(g0(t.parent))?99:1;let s=(i=g0(t.parent))==null?void 0:i.parent;return s&&ru(s)?1:99}function BN(e,t){if(!e)return;if(wt(e.elements)!==1){t?.(e,e.token===118?v.Type_import_attributes_should_have_exactly_one_key_resolution_mode_with_value_import_or_require:v.Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require);return}let n=e.elements[0];if(No(n.name)){if(n.name.text!=="resolution-mode"){t?.(n.name,e.token===118?v.resolution_mode_is_the_only_valid_key_for_type_import_attributes:v.resolution_mode_is_the_only_valid_key_for_type_import_assertions);return}if(No(n.value)){if(n.value.text!=="import"&&n.value.text!=="require"){t?.(n.value,v.resolution_mode_should_be_either_require_or_import);return}return n.value.text==="import"?99:1}}}var O8e={resolvedModule:void 0,resolvedTypeReferenceDirective:void 0};function Ghe(e){return e.text}var rX={getName:Ghe,getMode:(e,t,n)=>eX(t,e,n)};function nX(e,t,n,i,s){return{nameAndMode:rX,resolve:(o,u)=>QA(o,e,n,i,s,t,u)}}function iX(e){return bs(e)?e:e.fileName}var lxt={getName:iX,getMode:(e,t)=>G8(e,t?.impliedNodeFormat)};function $B(e,t,n,i,s){return{nameAndMode:lxt,resolve:(o,u)=>lge(o,e,n,i,t,s,u)}}function Y8(e,t,n,i,s,o,u,m){if(e.length===0)return ve;let d=[],S=new Map,E=m(t,n,i,o,u);for(let x of e){let D=E.nameAndMode.getName(x),w=E.nameAndMode.getMode(x,s,n?.commandLine.options||i),R=WO(D,w),L=S.get(R);L||S.set(R,L=E.resolve(D,w)),d.push(L)}return d}function sX(e,t){return HB(void 0,e,(n,i)=>n&&t(n,i))}function HB(e,t,n,i){let s;return o(e,t,void 0);function o(u,m,d){if(i){let S=i(u,d);if(S)return S}return kt(m,(S,E)=>{if(S&&s?.has(S.sourceFile.path))return;let x=n(S,d,E);return x||!S?x:((s||(s=new Set)).add(S.sourceFile.path),o(S.commandLine.projectReferences,S.references,S))})}}var o6="__inferred type names__.ts";function GB(e,t,n){let i=e.configFilePath?mi(e.configFilePath):t;return ri(i,`__lib_node_modules_lookup_${n}__.ts`)}function aX(e){let t=e.split("."),n=t[1],i=2;for(;t[i]&&t[i]!=="d";)n+=(i===2?"/":"-")+t[i],i++;return"@typescript/lib-"+n}function R8e(e){return R1(e.fileName)}function M8e(e){let t=R8e(e);return OY.get(t)}function Ib(e){switch(e?.kind){case 3:case 4:case 5:case 7:return!0;default:return!1}}function UN(e){return e.pos!==void 0}function c6(e,t){var n,i,s,o;let u=M.checkDefined(e.getSourceFileByPath(t.file)),{kind:m,index:d}=t,S,E,x;switch(m){case 3:let D=Q8(u,d);if(x=(i=(n=e.getResolvedModuleFromModuleSpecifier(D,u))==null?void 0:n.resolvedModule)==null?void 0:i.packageId,D.pos===-1)return{file:u,packageId:x,text:D.text};S=Ja(u.text,D.pos),E=D.end;break;case 4:({pos:S,end:E}=u.referencedFiles[d]);break;case 5:({pos:S,end:E}=u.typeReferenceDirectives[d]),x=(o=(s=e.getResolvedTypeReferenceDirectiveFromTypeReferenceDirective(u.typeReferenceDirectives[d],u))==null?void 0:s.resolvedTypeReferenceDirective)==null?void 0:o.packageId;break;case 7:({pos:S,end:E}=u.libReferenceDirectives[d]);break;default:return M.assertNever(m)}return{file:u,pos:S,end:E,packageId:x}}function oX(e,t,n,i,s,o,u,m,d,S){if(!e||m?.()||!Vp(e.getRootFileNames(),t))return!1;let E;if(!Vp(e.getProjectReferences(),S,L)||e.getSourceFiles().some(w))return!1;let x=e.getMissingFilePaths();if(x&&Nu(x,s))return!1;let D=e.getCompilerOptions();if(!cG(D,n)||e.resolvedLibReferences&&Nu(e.resolvedLibReferences,(J,G)=>u(G)))return!1;if(D.configFile&&n.configFile)return D.configFile.text===n.configFile.text;return!0;function w(J){return!R(J)||o(J.path)}function R(J){return J.version===i(J.resolvedPath,J.fileName)}function L(J,G,q){return X$(J,G)&&F(e.getResolvedProjectReferences()[q],J)}function F(J,G){if(J){if(Es(E,J))return!0;let ee=VN(G),W=d(ee);return!W||J.commandLine.options.configFile!==W.options.configFile||!Vp(J.commandLine.fileNames,W.fileNames)?!1:((E||(E=[])).push(J),!kt(J.references,(pe,K)=>!F(pe,J.commandLine.projectReferences[K])))}let q=VN(G);return!d(q)}}function kE(e){return e.options.configFile?[...e.options.configFile.parseDiagnostics,...e.errors]:e.errors}function K8(e,t,n,i){let s=YB(e,t,n,i);return typeof s=="object"?s.impliedNodeFormat:s}function YB(e,t,n,i){switch(af(i)){case 3:case 99:return wl(e,[".d.mts",".mts",".mjs"])?99:wl(e,[".d.cts",".cts",".cjs"])?1:wl(e,[".d.ts",".ts",".tsx",".js",".jsx"])?s():void 0;default:return}function s(){let o=$O(t,n,i),u=[];o.failedLookupLocations=u,o.affectingLocations=u;let m=HO(e,o);return{impliedNodeFormat:m?.contents.packageJsonContent.type==="module"?99:1,packageJsonLocations:u,packageJsonScope:m}}}var cX=new Set([v.Cannot_redeclare_block_scoped_variable_0.code,v.A_module_cannot_have_multiple_default_exports.code,v.Another_export_default_is_here.code,v.The_first_export_default_is_here.code,v.Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module.code,v.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode.code,v.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here.code,v.constructor_is_a_reserved_word.code,v.delete_cannot_be_called_on_an_identifier_in_strict_mode.code,v.Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode.code,v.Invalid_use_of_0_Modules_are_automatically_in_strict_mode.code,v.Invalid_use_of_0_in_strict_mode.code,v.A_label_is_not_allowed_here.code,v.with_statements_are_not_allowed_in_strict_mode.code,v.A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement.code,v.A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement.code,v.A_class_declaration_without_the_default_modifier_must_have_a_name.code,v.A_class_member_cannot_have_the_0_keyword.code,v.A_comma_expression_is_not_allowed_in_a_computed_property_name.code,v.A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement.code,v.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement.code,v.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement.code,v.A_default_clause_cannot_appear_more_than_once_in_a_switch_statement.code,v.A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration.code,v.A_definite_assignment_assertion_is_not_permitted_in_this_context.code,v.A_destructuring_declaration_must_have_an_initializer.code,v.A_get_accessor_cannot_have_parameters.code,v.A_rest_element_cannot_contain_a_binding_pattern.code,v.A_rest_element_cannot_have_a_property_name.code,v.A_rest_element_cannot_have_an_initializer.code,v.A_rest_element_must_be_last_in_a_destructuring_pattern.code,v.A_rest_parameter_cannot_have_an_initializer.code,v.A_rest_parameter_must_be_last_in_a_parameter_list.code,v.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma.code,v.A_return_statement_cannot_be_used_inside_a_class_static_block.code,v.A_set_accessor_cannot_have_rest_parameter.code,v.A_set_accessor_must_have_exactly_one_parameter.code,v.An_export_declaration_can_only_be_used_at_the_top_level_of_a_module.code,v.An_export_declaration_cannot_have_modifiers.code,v.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module.code,v.An_import_declaration_cannot_have_modifiers.code,v.An_object_member_cannot_be_declared_optional.code,v.Argument_of_dynamic_import_cannot_be_spread_element.code,v.Cannot_assign_to_private_method_0_Private_methods_are_not_writable.code,v.Cannot_redeclare_identifier_0_in_catch_clause.code,v.Catch_clause_variable_cannot_have_an_initializer.code,v.Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator.code,v.Classes_can_only_extend_a_single_class.code,v.Classes_may_not_have_a_field_named_constructor.code,v.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern.code,v.Duplicate_label_0.code,v.Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_set_of_attributes_as_arguments.code,v.for_await_loops_cannot_be_used_inside_a_class_static_block.code,v.JSX_attributes_must_only_be_assigned_a_non_empty_expression.code,v.JSX_elements_cannot_have_multiple_attributes_with_the_same_name.code,v.JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array.code,v.JSX_property_access_expressions_cannot_include_JSX_namespace_names.code,v.Jump_target_cannot_cross_function_boundary.code,v.Line_terminator_not_permitted_before_arrow.code,v.Modifiers_cannot_appear_here.code,v.Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement.code,v.Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement.code,v.Private_identifiers_are_not_allowed_outside_class_bodies.code,v.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression.code,v.Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier.code,v.Tagged_template_expressions_are_not_permitted_in_an_optional_chain.code,v.The_left_hand_side_of_a_for_of_statement_may_not_be_async.code,v.The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer.code,v.The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer.code,v.Trailing_comma_not_allowed.code,v.Variable_declaration_list_cannot_be_empty.code,v._0_and_1_operations_cannot_be_mixed_without_parentheses.code,v._0_expected.code,v._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2.code,v._0_list_cannot_be_empty.code,v._0_modifier_already_seen.code,v._0_modifier_cannot_appear_on_a_constructor_declaration.code,v._0_modifier_cannot_appear_on_a_module_or_namespace_element.code,v._0_modifier_cannot_appear_on_a_parameter.code,v._0_modifier_cannot_appear_on_class_elements_of_this_kind.code,v._0_modifier_cannot_be_used_here.code,v._0_modifier_must_precede_1_modifier.code,v._0_declarations_can_only_be_declared_inside_a_block.code,v._0_declarations_must_be_initialized.code,v.extends_clause_already_seen.code,v.let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations.code,v.Class_constructor_may_not_be_a_generator.code,v.Class_constructor_may_not_be_an_accessor.code,v.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,v.await_using_statements_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,v.Private_field_0_must_be_declared_in_an_enclosing_class.code,v.This_condition_will_always_return_0_since_JavaScript_compares_objects_by_reference_not_value.code]);function uxt(e,t){return e?UP(e.getCompilerOptions(),t,LY):!1}function _xt(e,t,n,i,s,o){return{rootNames:e,options:t,host:n,oldProgram:i,configFileParsingDiagnostics:s,typeScriptVersion:o}}function X8(e,t,n,i,s){var o,u,m,d,S,E,x,D,w,R,L,F,J,G,q,ee;let W=Rs(e)?_xt(e,t,n,i,s):e,{rootNames:pe,options:K,configFileParsingDiagnostics:re,projectReferences:ue,typeScriptVersion:ce}=W,{oldProgram:ne}=W;for(let We of Ume)if(Ho(K,We.name)&&typeof K[We.name]=="string")throw new Error(`${We.name} is a string value; tsconfig JSON must be parsed with parseJsonSourceFileConfigFileContent or getParsedCommandLineOfConfigFile before passing to createProgram`);let le=tf(()=>d_("ignoreDeprecations",v.Invalid_value_for_ignoreDeprecations)),me,de,Ae,xe,te,he,be,Ve=new Map,Pe=yd(),ke,De,Be,ct={},qe={},et,Ie,_t,mt,Xe,ht,rr,vr,xr,jr,ur=typeof K.maxNodeModuleJsDepth=="number"?K.maxNodeModuleJsDepth:0,or=0,Zr=new Map,Oi=new Map;(o=Cn)==null||o.push(Cn.Phase.Program,"createProgram",{configFilePath:K.configFilePath,rootDir:K.rootDir},!0),jc("beforeProgram");let Sr=W.host||Jhe(K),Pi=XB(Sr),Cs=K.noLib,ss=tf(()=>Sr.getDefaultLibFileName(K)),Ii=Sr.getDefaultLibLocation?Sr.getDefaultLibLocation():mi(ss()),$r=WI(),Xs=[],$e=Sr.getCurrentDirectory(),Yt=aO(K),Vr=HR(K,Yt),An=new Map,vi,Ci,Ui,la,Gs=Sr.hasInvalidatedResolutions||Dg;Sr.resolveModuleNameLiterals?(la=Sr.resolveModuleNameLiterals.bind(Sr),Ui=(u=Sr.getModuleResolutionCache)==null?void 0:u.call(Sr)):Sr.resolveModuleNames?(la=(We,st,Jt,sr,kr,_n)=>Sr.resolveModuleNames(We.map(Ghe),st,_n?.map(Ghe),Jt,sr,kr).map(Ir=>Ir?Ir.extension!==void 0?{resolvedModule:Ir}:{resolvedModule:{...Ir,extension:cO(Ir.resolvedFileName)}}:O8e),Ui=(m=Sr.getModuleResolutionCache)==null?void 0:m.call(Sr)):(Ui=IN($e,Hn,K),la=(We,st,Jt,sr,kr)=>Y8(We,st,Jt,sr,kr,Sr,Ui,nX));let yr;if(Sr.resolveTypeReferenceDirectiveReferences)yr=Sr.resolveTypeReferenceDirectiveReferences.bind(Sr);else if(Sr.resolveTypeReferenceDirectives)yr=(We,st,Jt,sr,kr)=>Sr.resolveTypeReferenceDirectives(We.map(iX),st,Jt,sr,kr?.impliedNodeFormat).map(_n=>({resolvedTypeReferenceDirective:_n}));else{let We=yB($e,Hn,void 0,Ui?.getPackageJsonInfoCache(),Ui?.optionsToRedirectsKey);yr=(st,Jt,sr,kr,_n)=>Y8(st,Jt,sr,kr,_n,Sr,We,$B)}let to=Sr.hasInvalidatedLibResolutions||Dg,lt;if(Sr.resolveLibrary)lt=Sr.resolveLibrary.bind(Sr);else{let We=IN($e,Hn,K,Ui?.getPackageJsonInfoCache());lt=(st,Jt,sr)=>vB(st,Jt,sr,Sr,We)}let St=new Map,fe=new Map,vt=yd(),Ce=!1,nt=new Map,Me=new Map,tt=Sr.useCaseSensitiveFileNames()?new Map:void 0,ft,tr,Oe,At,Nt=!!((d=Sr.useSourceOfProjectReferenceRedirect)!=null&&d.call(Sr))&&!K.disableSourceOfProjectReferenceRedirect,{onProgramCreateComplete:Ut,fileExists:Rt,directoryExists:nr}=fxt({compilerHost:Sr,getSymlinkCache:pg,useSourceOfProjectReferenceRedirect:Nt,toPath:er,getResolvedProjectReferences:Eu,getSourceOfProjectReferenceRedirect:Kh,forEachResolvedProjectReference:Hl}),Z=Sr.readFile.bind(Sr);(S=Cn)==null||S.push(Cn.Phase.Program,"shouldProgramCreateNewSourceFiles",{hasOldProgram:!!ne});let Ge=uxt(ne,K);(E=Cn)==null||E.pop();let bt;if((x=Cn)==null||x.push(Cn.Phase.Program,"tryReuseStructureFromOldProgram",{}),bt=sa(),(D=Cn)==null||D.pop(),bt!==2){if(me=[],de=[],ue&&(ft||(ft=ue.map(Fe)),pe.length&&ft?.forEach((We,st)=>{if(!We)return;let Jt=We.commandLine.options.outFile;if(Nt){if(Jt||V_(We.commandLine.options)===0)for(let sr of We.commandLine.fileNames)au(sr,{kind:1,index:st})}else if(Jt)au(Y1(Jt,".d.ts"),{kind:2,index:st});else if(V_(We.commandLine.options)===0){let sr=tf(()=>tk(We.commandLine,!Sr.useCaseSensitiveFileNames()));for(let kr of We.commandLine.fileNames)!Mu(kr)&&!Ic(kr,".json")&&au(jN(kr,We.commandLine,!Sr.useCaseSensitiveFileNames(),sr),{kind:2,index:st})}})),(w=Cn)==null||w.push(Cn.Phase.Program,"processRootFiles",{count:pe.length}),kt(pe,(We,st)=>$l(We,!1,!1,{kind:0,index:st})),(R=Cn)==null||R.pop(),Ie??(Ie=pe.length?gB(K,Sr):ve),_t=wN(),Ie.length){(L=Cn)==null||L.push(Cn.Phase.Program,"processTypeReferences",{count:Ie.length});let We=K.configFilePath?mi(K.configFilePath):$e,st=ri(We,o6),Jt=Do(Ie,st);for(let sr=0;sr<Ie.length;sr++)_t.set(Ie[sr],void 0,Jt[sr]),yt(Ie[sr],void 0,Jt[sr],{kind:8,typeReference:Ie[sr],packageId:(J=(F=Jt[sr])==null?void 0:F.resolvedTypeReferenceDirective)==null?void 0:J.packageId});(G=Cn)==null||G.pop()}if(pe.length&&!Cs){let We=ss();!K.lib&&We?$l(We,!0,!1,{kind:6}):kt(K.lib,(st,Jt)=>{$l(Xt(st),!0,!1,{kind:6,index:Jt})})}Ae=Qs(me,Er).concat(de),me=void 0,de=void 0,ke=void 0}if(ne&&Sr.onReleaseOldSourceFile){let We=ne.getSourceFiles();for(let st of We){let Jt=_r(st.resolvedPath);(Ge||!Jt||Jt.impliedNodeFormat!==st.impliedNodeFormat||st.resolvedPath===st.path&&Jt.resolvedPath!==st.path)&&Sr.onReleaseOldSourceFile(st,ne.getCompilerOptions(),!!_r(st.path))}Sr.getParsedCommandLine||ne.forEachResolvedProjectReference(st=>{nh(st.sourceFile.path)||Sr.onReleaseOldSourceFile(st.sourceFile,ne.getCompilerOptions(),!1)})}ne&&Sr.onReleaseParsedCommandLine&&HB(ne.getProjectReferences(),ne.getResolvedProjectReferences(),(We,st,Jt)=>{let sr=st?.commandLine.projectReferences[Jt]||ne.getProjectReferences()[Jt],kr=VN(sr);tr?.has(er(kr))||Sr.onReleaseParsedCommandLine(kr,We,ne.getCompilerOptions())}),ne=void 0,Xe=void 0,rr=void 0,xr=void 0;let Q={getRootFileNames:()=>pe,getSourceFile:po,getSourceFileByPath:_r,getSourceFiles:()=>Ae,getMissingFilePaths:()=>Me,getModuleResolutionCache:()=>Ui,getFilesByNameMap:()=>nt,getCompilerOptions:()=>K,getSyntacticDiagnostics:z_,getOptionsDiagnostics:hc,getGlobalDiagnostics:zf,getSemanticDiagnostics:W_,getCachedSemanticDiagnostics:qf,getSuggestionDiagnostics:Ri,getDeclarationDiagnostics:Se,getBindAndCheckDiagnostics:mc,getProgramDiagnostics:tl,getTypeChecker:Xu,getClassifiableNames:uo,getCommonSourceDirectory:qs,emit:Fa,getCurrentDirectory:()=>$e,getNodeCount:()=>Xu().getNodeCount(),getIdentifierCount:()=>Xu().getIdentifierCount(),getSymbolCount:()=>Xu().getSymbolCount(),getTypeCount:()=>Xu().getTypeCount(),getInstantiationCount:()=>Xu().getInstantiationCount(),getRelationCacheSizes:()=>Xu().getRelationCacheSizes(),getFileProcessingDiagnostics:()=>et,getAutomaticTypeDirectiveNames:()=>Ie,getAutomaticTypeDirectiveResolutions:()=>_t,isSourceFileFromExternalLibrary:P_,isSourceFileDefaultLibrary:el,getModeForUsageLocation:cd,getModeForResolutionAtIndex:R0,getSourceFileFromReference:Qa,getLibFileFromReference:gs,sourceFileToPackageName:fe,redirectTargetsMap:vt,usesUriStyleNodeCoreModules:Ce,resolvedModules:ht,resolvedTypeReferenceDirectiveNames:vr,resolvedLibReferences:mt,getResolvedModule:Ue,getResolvedModuleFromModuleSpecifier:Te,getResolvedTypeReferenceDirective:Re,getResolvedTypeReferenceDirectiveFromTypeReferenceDirective:It,forEachResolvedModule:$t,forEachResolvedTypeReferenceDirective:Ht,getCurrentPackagesMap:()=>jr,typesPackageExists:Hr,packageBundlesTypes:dn,isEmittedFile:lm,getConfigFileParsingDiagnostics:rl,getProjectReferences:kc,getResolvedProjectReferences:Eu,getProjectReferenceRedirect:sd,getResolvedProjectReferenceToRedirect:Of,getResolvedProjectReferenceByPath:nh,forEachResolvedProjectReference:Hl,isSourceOfProjectReferenceRedirect:$f,getRedirectReferenceForResolutionFromSourceOfProject:pi,emitBuildInfo:zi,fileExists:Rt,readFile:Z,directoryExists:nr,getSymlinkCache:pg,realpath:(q=Sr.realpath)==null?void 0:q.bind(Sr),useCaseSensitiveFileNames:()=>Sr.useCaseSensitiveFileNames(),getCanonicalFileName:Hn,getFileIncludeReasons:()=>Pe,structureIsReused:bt,writeFile:ts};return Ut(),jt(),jc("afterProgram"),vd("Program","beforeProgram","afterProgram"),(ee=Cn)==null||ee.pop(),Q;function Ke(){return Xs&&(et?.forEach(We=>{switch(We.kind){case 1:return $r.add(zs(We.file&&_r(We.file),We.fileProcessingReason,We.diagnostic,We.args||ve));case 0:return $r.add(z(We));case 2:return We.diagnostics.forEach(st=>$r.add(st));default:M.assertNever(We)}}),Xs.forEach(({file:We,diagnostic:st,args:Jt})=>$r.add(zs(We,void 0,st,Jt))),Xs=void 0,De=void 0,Be=void 0),$r}function z({reason:We}){let{file:st,pos:Jt,end:sr}=c6(Q,We),kr=st.libReferenceDirectives[We.index],_n=R8e(kr),Ir=AP(Yw(_n,"lib."),".d.ts"),kn=Fx(Ir,eB,ec);return bu(st,M.checkDefined(Jt),M.checkDefined(sr)-Jt,kn?v.Cannot_find_lib_definition_for_0_Did_you_mean_1:v.Cannot_find_lib_definition_for_0,_n,kn)}function Ue(We,st,Jt){var sr;return(sr=ht?.get(We.path))==null?void 0:sr.get(st,Jt)}function Te(We,st){return st??(st=Ur(We)),M.assertIsDefined(st,"`moduleSpecifier` must have a `SourceFile` ancestor. Use `program.getResolvedModule` instead to provide the containing file and resolution mode."),Ue(st,We.text,cd(st,We))}function Re(We,st,Jt){var sr;return(sr=vr?.get(We.path))==null?void 0:sr.get(st,Jt)}function It(We,st){return Re(st,We.fileName,We.resolutionMode||st.impliedNodeFormat)}function $t(We,st){dr(ht,We,st)}function Ht(We,st){dr(vr,We,st)}function dr(We,st,Jt){var sr;Jt?(sr=We?.get(Jt.path))==null||sr.forEach((kr,_n,Ir)=>st(kr,_n,Ir,Jt.path)):We?.forEach((kr,_n)=>kr.forEach((Ir,kn,ji)=>st(Ir,kn,ji,_n)))}function qr(){return jr||(jr=new Map,$t(({resolvedModule:We})=>{We?.packageId&&jr.set(We.packageId.name,We.extension===".d.ts"||!!jr.get(We.packageId.name))}),jr)}function Hr(We){return qr().has(EB(We))}function dn(We){return!!qr().get(We)}function Ar(We){var st;(st=We.resolutionDiagnostics)!=null&&st.length&&(et??(et=[])).push({kind:2,diagnostics:We.resolutionDiagnostics})}function In(We,st,Jt,sr){if(Sr.resolveModuleNameLiterals||!Sr.resolveModuleNames)return Ar(Jt);if(!Ui||vu(st))return;let kr=xs(We.originalFileName,$e),_n=mi(kr),Ir=Yn(We),kn=Ui.getFromNonRelativeNameCache(st,sr,_n,Ir);kn&&Ar(kn)}function Ki(We,st,Jt){var sr,kr;if(!We.length)return ve;let _n=xs(st.originalFileName,$e),Ir=Yn(st);(sr=Cn)==null||sr.push(Cn.Phase.Program,"resolveModuleNamesWorker",{containingFileName:_n}),jc("beforeResolveModule");let kn=la(We,_n,Ir,K,st,Jt);return jc("afterResolveModule"),vd("ResolveModule","beforeResolveModule","afterResolveModule"),(kr=Cn)==null||kr.pop(),kn}function ls(We,st,Jt){var sr,kr;if(!We.length)return[];let _n=bs(st)?void 0:st,Ir=bs(st)?st:xs(st.originalFileName,$e),kn=_n&&Yn(_n);(sr=Cn)==null||sr.push(Cn.Phase.Program,"resolveTypeReferenceDirectiveNamesWorker",{containingFileName:Ir}),jc("beforeResolveTypeReference");let ji=yr(We,Ir,kn,K,_n,Jt);return jc("afterResolveTypeReference"),vd("ResolveTypeReference","beforeResolveTypeReference","afterResolveTypeReference"),(kr=Cn)==null||kr.pop(),ji}function Yn(We){let st=Of(We.originalFileName);if(st||!Mu(We.originalFileName))return st;let Jt=pi(We.path);if(Jt)return Jt;if(!Sr.realpath||!K.preserveSymlinks||!We.originalFileName.includes(jy))return;let sr=er(Sr.realpath(We.originalFileName));return sr===We.path?void 0:pi(sr)}function pi(We){let st=Kh(We);if(bs(st))return Of(st);if(st)return Hl(Jt=>{let sr=Jt.commandLine.options.outFile;if(sr)return er(sr)===We?Jt:void 0})}function Er(We,st){return tc(tn(We),tn(st))}function tn(We){if(Cm(Ii,We.fileName,!1)){let st=Ul(We.fileName);if(st==="lib.d.ts"||st==="lib.es6.d.ts")return 0;let Jt=AP(Yw(st,"lib."),".d.ts"),sr=eB.indexOf(Jt);if(sr!==-1)return sr+1}return eB.length+2}function er(We){return rc(We,$e,Hn)}function qs(){if(te===void 0){let We=Zn(Ae,st=>t2(st,Q));te=s6(K,()=>Gi(We,st=>st.isDeclarationFile?void 0:st.fileName),$e,Hn,st=>$(We,st))}return te}function uo(){var We;if(!be){Xu(),be=new Set;for(let st of Ae)(We=st.classifiableNames)==null||We.forEach(Jt=>be.add(Jt))}return be}function Mo(We,st){if(bt===0&&!st.ambientModuleNames.length)return Ki(We,st,void 0);let Jt,sr,kr,_n=O8e,Ir=ne&&ne.getSourceFile(st.fileName);for(let Ni=0;Ni<We.length;Ni++){let an=We[Ni];if(st===Ir&&!Gs(st.path)){let wa=ne?.getResolvedModule(st,an.text,cd(st,an));if(wa?.resolvedModule){P0(K,Sr)&&ds(Sr,wa.resolvedModule.packageId?v.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3:v.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2,an.text,xs(st.originalFileName,$e),wa.resolvedModule.resolvedFileName,wa.resolvedModule.packageId&&J1(wa.resolvedModule.packageId)),(sr??(sr=new Array(We.length)))[Ni]=wa,(kr??(kr=[])).push(an);continue}}let Ds=!1;Es(st.ambientModuleNames,an.text)?(Ds=!0,P0(K,Sr)&&ds(Sr,v.Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1,an.text,xs(st.originalFileName,$e))):Ds=En(an),Ds?(sr||(sr=new Array(We.length)))[Ni]=_n:(Jt??(Jt=[])).push(an)}let kn=Jt&&Jt.length?Ki(Jt,st,kr):ve;if(!sr)return M.assert(kn.length===We.length),kn;let ji=0;for(let Ni=0;Ni<sr.length;Ni++)sr[Ni]||(sr[Ni]=kn[ji],ji++);return M.assert(ji===kn.length),sr;function En(Ni){var an;let Ds=(an=ne?.getResolvedModule(st,Ni.text,cd(st,Ni)))==null?void 0:an.resolvedModule,wa=Ds&&ne.getSourceFile(Ds.resolvedFileName);if(Ds&&wa)return!1;let xu=Ve.get(Ni.text);return xu?(P0(K,Sr)&&ds(Sr,v.Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified,Ni.text,xu),!0):!1}}function Do(We,st){var Jt;if(bt===0)return ls(We,st,void 0);let sr,kr,_n,Ir=bs(st)?void 0:st,kn=bs(st)?void 0:ne&&ne.getSourceFile(st.fileName),ji=bs(st)?!Gs(er(st)):st===kn&&!Gs(st.path);for(let an=0;an<We.length;an++){let Ds=We[an];if(ji){let wa=iX(Ds),xu=G8(Ds,Ir?.impliedNodeFormat),N_=bs(st)?(Jt=ne?.getAutomaticTypeDirectiveResolutions())==null?void 0:Jt.get(wa,xu):ne?.getResolvedTypeReferenceDirective(st,wa,xu);if(N_?.resolvedTypeReferenceDirective){P0(K,Sr)&&ds(Sr,N_.resolvedTypeReferenceDirective.packageId?v.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3:v.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2,wa,bs(st)?st:xs(st.originalFileName,$e),N_.resolvedTypeReferenceDirective.resolvedFileName,N_.resolvedTypeReferenceDirective.packageId&&J1(N_.resolvedTypeReferenceDirective.packageId)),(kr??(kr=new Array(We.length)))[an]=N_,(_n??(_n=[])).push(Ds);continue}}(sr??(sr=[])).push(Ds)}if(!sr)return kr||ve;let En=ls(sr,st,_n);if(!kr)return M.assert(En.length===We.length),En;let Ni=0;for(let an=0;an<kr.length;an++)kr[an]||(kr[an]=En[Ni],Ni++);return M.assert(Ni===En.length),kr}function ms(){return!HB(ne.getProjectReferences(),ne.getResolvedProjectReferences(),(We,st,Jt)=>{let sr=(st?st.commandLine.projectReferences:ue)[Jt],kr=Fe(sr);return We?!kr||kr.sourceFile!==We.sourceFile||!Vp(We.commandLine.fileNames,kr.commandLine.fileNames):kr!==void 0},(We,st)=>{let Jt=st?nh(st.sourceFile.path).commandLine.projectReferences:ue;return!Vp(We,Jt,X$)})}function sa(){var We;if(!ne)return 0;let st=ne.getCompilerOptions();if(U5(st,K))return 0;let Jt=ne.getRootFileNames();if(!Vp(Jt,pe)||!ms())return 0;ue&&(ft=ue.map(Fe));let sr=[],kr=[];if(bt=2,Nu(ne.getMissingFilePaths(),En=>Sr.fileExists(En)))return 0;let _n=ne.getSourceFiles(),Ir;(En=>{En[En.Exists=0]="Exists",En[En.Modified=1]="Modified"})(Ir||(Ir={}));let kn=new Map;for(let En of _n){let Ni=Wf(En.fileName,Ui,Sr,K),an=Sr.getSourceFileByPath?Sr.getSourceFileByPath(En.fileName,En.resolvedPath,Ni,void 0,Ge):Sr.getSourceFile(En.fileName,Ni,void 0,Ge);if(!an)return 0;an.packageJsonLocations=(We=Ni.packageJsonLocations)!=null&&We.length?Ni.packageJsonLocations:void 0,an.packageJsonScope=Ni.packageJsonScope,M.assert(!an.redirectInfo,"Host should not return a redirect source file from `getSourceFile`");let Ds;if(En.redirectInfo){if(an!==En.redirectInfo.unredirected)return 0;Ds=!1,an=En}else if(ne.redirectTargetsMap.has(En.path)){if(an!==En)return 0;Ds=!1}else Ds=an!==En;an.path=En.path,an.originalFileName=En.originalFileName,an.resolvedPath=En.resolvedPath,an.fileName=En.fileName;let wa=ne.sourceFileToPackageName.get(En.path);if(wa!==void 0){let xu=kn.get(wa),N_=Ds?1:0;if(xu!==void 0&&N_===1||xu===1)return 0;kn.set(wa,N_)}if(Ds)En.impliedNodeFormat!==an.impliedNodeFormat?bt=1:Vp(En.libReferenceDirectives,an.libReferenceDirectives,nd)?En.hasNoDefaultLib!==an.hasNoDefaultLib?bt=1:Vp(En.referencedFiles,an.referencedFiles,nd)?(Gr(an),Vp(En.imports,an.imports,Je)&&Vp(En.moduleAugmentations,an.moduleAugmentations,Je)?(En.flags&12582912)!==(an.flags&12582912)?bt=1:Vp(En.typeReferenceDirectives,an.typeReferenceDirectives,nd)||(bt=1):bt=1):bt=1:bt=1,kr.push(an);else if(Gs(En.path))bt=1,kr.push(an);else for(let xu of En.ambientModuleNames)Ve.set(xu,En.fileName);sr.push(an)}if(bt!==2)return bt;for(let En of kr){let Ni=L8e(En),an=Mo(Ni,En);(rr??(rr=new Map)).set(En.path,an),Q$(Ni,an,um=>ne.getResolvedModule(En,um.text,cd(En,um)),T_e)&&(bt=1);let wa=En.typeReferenceDirectives,xu=Do(wa,En);(xr??(xr=new Map)).set(En.path,xu),Q$(wa,xu,um=>ne.getResolvedTypeReferenceDirective(En,iX(um),G8(um,En.impliedNodeFormat)),E_e)&&(bt=1)}if(bt!==2)return bt;if(S_e(st,K)||ne.resolvedLibReferences&&Nu(ne.resolvedLibReferences,(En,Ni)=>Fr(Ni).actual!==En.actual))return 1;if(Sr.hasChangedAutomaticTypeDirectiveNames){if(Sr.hasChangedAutomaticTypeDirectiveNames())return 1}else if(Ie=gB(K,Sr),!Vp(ne.getAutomaticTypeDirectiveNames(),Ie))return 1;Me=ne.getMissingFilePaths(),M.assert(sr.length===ne.getSourceFiles().length);for(let En of sr)nt.set(En.path,En);return ne.getFilesByNameMap().forEach((En,Ni)=>{if(!En){nt.set(Ni,En);return}if(En.path===Ni){ne.isSourceFileFromExternalLibrary(En)&&Oi.set(En.path,!0);return}nt.set(Ni,nt.get(En.path))}),Ae=sr,Pe=ne.getFileIncludeReasons(),et=ne.getFileProcessingDiagnostics(),Ie=ne.getAutomaticTypeDirectiveNames(),_t=ne.getAutomaticTypeDirectiveResolutions(),fe=ne.sourceFileToPackageName,vt=ne.redirectTargetsMap,Ce=ne.usesUriStyleNodeCoreModules,ht=ne.resolvedModules,vr=ne.resolvedTypeReferenceDirectiveNames,mt=ne.resolvedLibReferences,jr=ne.getCurrentPackagesMap(),2}function Sc(We){return{getCanonicalFileName:Hn,getCommonSourceDirectory:Q.getCommonSourceDirectory,getCompilerOptions:Q.getCompilerOptions,getCurrentDirectory:()=>$e,getSourceFile:Q.getSourceFile,getSourceFileByPath:Q.getSourceFileByPath,getSourceFiles:Q.getSourceFiles,isSourceFileFromExternalLibrary:P_,getResolvedProjectReferenceToRedirect:Of,getProjectReferenceRedirect:sd,isSourceOfProjectReferenceRedirect:$f,getSymlinkCache:pg,writeFile:We||ts,isEmitBlocked:bc,readFile:st=>Sr.readFile(st),fileExists:st=>{let Jt=er(st);return _r(Jt)?!0:Me.has(Jt)?!1:Sr.fileExists(st)},realpath:ia(Sr,Sr.realpath),useCaseSensitiveFileNames:()=>Sr.useCaseSensitiveFileNames(),getBuildInfo:()=>{var st;return(st=Q.getBuildInfo)==null?void 0:st.call(Q)},getSourceFileFromReference:(st,Jt)=>Q.getSourceFileFromReference(st,Jt),redirectTargetsMap:vt,getFileIncludeReasons:Q.getFileIncludeReasons,createHash:ia(Sr,Sr.createHash),getModuleResolutionCache:()=>Q.getModuleResolutionCache(),trace:ia(Sr,Sr.trace)}}function ts(We,st,Jt,sr,kr,_n){Sr.writeFile(We,st,Jt,sr,kr,_n)}function zi(We){var st,Jt;M.assert(!K.outFile),(st=Cn)==null||st.push(Cn.Phase.Emit,"emitBuildInfo",{},!0),jc("beforeEmit");let sr=JK(Mhe,Sc(We),void 0,whe,!1,!0);return jc("afterEmit"),vd("Emit","beforeEmit","afterEmit"),(Jt=Cn)==null||Jt.pop(),sr}function Eu(){return ft}function kc(){return ue}function P_(We){return!!Oi.get(We.path)}function el(We){if(!We.isDeclarationFile)return!1;if(We.hasNoDefaultLib)return!0;if(!K.noLib)return!1;let st=Sr.useCaseSensitiveFileNames()?Lx:KS;return K.lib?Pt(K.lib,Jt=>st(We.fileName,mt.get(Jt).actual)):st(We.fileName,ss())}function Xu(){return he||(he=Lge(Q))}function Fa(We,st,Jt,sr,kr,_n){var Ir,kn;(Ir=Cn)==null||Ir.push(Cn.Phase.Emit,"emit",{path:We?.path},!0);let ji=Ye(()=>Lo(Q,We,st,Jt,sr,kr,_n));return(kn=Cn)==null||kn.pop(),ji}function bc(We){return An.has(er(We))}function Lo(We,st,Jt,sr,kr,_n,Ir){if(!Ir){let Ni=uX(We,st,Jt,sr);if(Ni)return Ni}let kn=Xu(),ji=kn.getEmitResolver(K.outFile?void 0:st,sr,VK(kr,Ir));jc("beforeEmit");let En=kn.runWithCancellationToken(sr,()=>JK(ji,Sc(Jt),st,Ihe(K,_n,kr),kr,!1,Ir));return jc("afterEmit"),vd("Emit","beforeEmit","afterEmit"),En}function po(We){return _r(er(We))}function _r(We){return nt.get(We)||void 0}function Jc(We,st,Jt){return wP(We?st(We,Jt):va(Q.getSourceFiles(),sr=>(Jt&&Jt.throwIfCancellationRequested(),st(sr,Jt))))}function z_(We,st){return Jc(We,ae,st)}function W_(We,st){return Jc(We,Ot,st)}function qf(We){var st;return We?(st=ct.perFile)==null?void 0:st.get(We.path):ct.allDiagnostics}function mc(We,st){return Tr(We,st)}function tl(We){var st;if(uO(We,K,Q))return ve;let Jt=Ke().getDiagnostics(We.fileName);return(st=We.commentDirectives)!=null&&st.length?Jn(We,We.commentDirectives,Jt).diagnostics:Jt}function Se(We,st){let Jt=Q.getCompilerOptions();return!We||Jt.outFile?gc(We,st):Jc(We,du,st)}function ae(We){return Af(We)?(We.additionalSyntacticDiagnostics||(We.additionalSyntacticDiagnostics=Na(We)),ps(We.additionalSyntacticDiagnostics,We.parseDiagnostics)):We.parseDiagnostics}function Ye(We){try{return We()}catch(st){throw st instanceof tI&&(he=void 0),st}}function Ot(We,st){return ps(KB(Tr(We,st),K),tl(We))}function Tr(We,st){return Oc(We,st,ct,Vn)}function Vn(We,st){return Ye(()=>{if(uO(We,K,Q))return ve;let Jt=Xu();M.assert(!!We.bindDiagnostics);let kr=(We.scriptKind===1||We.scriptKind===2)&&lO(We,K),_n=AI(We,K.checkJs),Ir=We.bindDiagnostics,kn=Jt.getDiagnostics(We,st);return _n&&(Ir=Zn(Ir,ji=>cX.has(ji.code)),kn=Zn(kn,ji=>cX.has(ji.code))),pr(We,!_n,Ir,kn,kr?We.jsDocDiagnostics:void 0)})}function pr(We,st,...Jt){var sr;let kr=ef(Jt);if(!st||!((sr=We.commentDirectives)!=null&&sr.length))return kr;let{diagnostics:_n,directives:Ir}=Jn(We,We.commentDirectives,kr);for(let kn of Ir.getUnusedExpectations())_n.push(U_e(We,kn.range,v.Unused_ts_expect_error_directive));return _n}function Jn(We,st,Jt){let sr=A_e(We,st);return{diagnostics:Jt.filter(_n=>Ai(_n,sr)===-1),directives:sr}}function Ri(We,st){return Ye(()=>Xu().getSuggestionDiagnostics(We,st))}function Ai(We,st){let{file:Jt,start:sr}=We;if(!Jt)return-1;let kr=Sy(Jt),_n=NP(kr,sr).line-1;for(;_n>=0;){if(st.markUsed(_n))return _n;let Ir=Jt.text.slice(kr[_n],kr[_n+1]).trim();if(Ir!==""&&!/^(\s*)\/\/(.*)$/.test(Ir))return-1;_n--}return-1}function Na(We){return Ye(()=>{let st=[];return Jt(We,We),$A(We,Jt,sr),st;function Jt(kn,ji){switch(ji.kind){case 169:case 172:case 174:if(ji.questionToken===kn)return st.push(Ir(kn,v.The_0_modifier_can_only_be_used_in_TypeScript_files,"?")),"skip";case 173:case 176:case 177:case 178:case 218:case 262:case 219:case 260:if(ji.type===kn)return st.push(Ir(kn,v.Type_annotations_can_only_be_used_in_TypeScript_files)),"skip"}switch(kn.kind){case 273:if(kn.isTypeOnly)return st.push(Ir(ji,v._0_declarations_can_only_be_used_in_TypeScript_files,"import type")),"skip";break;case 278:if(kn.isTypeOnly)return st.push(Ir(kn,v._0_declarations_can_only_be_used_in_TypeScript_files,"export type")),"skip";break;case 276:case 281:if(kn.isTypeOnly)return st.push(Ir(kn,v._0_declarations_can_only_be_used_in_TypeScript_files,_f(kn)?"import...type":"export...type")),"skip";break;case 271:return st.push(Ir(kn,v.import_can_only_be_used_in_TypeScript_files)),"skip";case 277:if(kn.isExportEquals)return st.push(Ir(kn,v.export_can_only_be_used_in_TypeScript_files)),"skip";break;case 298:if(kn.token===119)return st.push(Ir(kn,v.implements_clauses_can_only_be_used_in_TypeScript_files)),"skip";break;case 264:let Ni=Sa(120);return M.assertIsDefined(Ni),st.push(Ir(kn,v._0_declarations_can_only_be_used_in_TypeScript_files,Ni)),"skip";case 267:let an=kn.flags&32?Sa(145):Sa(144);return M.assertIsDefined(an),st.push(Ir(kn,v._0_declarations_can_only_be_used_in_TypeScript_files,an)),"skip";case 265:return st.push(Ir(kn,v.Type_aliases_can_only_be_used_in_TypeScript_files)),"skip";case 176:case 174:case 262:return kn.body?void 0:(st.push(Ir(kn,v.Signature_declarations_can_only_be_used_in_TypeScript_files)),"skip");case 266:let Ds=M.checkDefined(Sa(94));return st.push(Ir(kn,v._0_declarations_can_only_be_used_in_TypeScript_files,Ds)),"skip";case 235:return st.push(Ir(kn,v.Non_null_assertions_can_only_be_used_in_TypeScript_files)),"skip";case 234:return st.push(Ir(kn.type,v.Type_assertion_expressions_can_only_be_used_in_TypeScript_files)),"skip";case 238:return st.push(Ir(kn.type,v.Type_satisfaction_expressions_can_only_be_used_in_TypeScript_files)),"skip";case 216:M.fail()}}function sr(kn,ji){if(EY(ji)){let En=Ln(ji.modifiers,fu);En&&st.push(Ir(En,v.Decorators_are_not_valid_here))}else if(TE(ji)&&ji.modifiers){let En=Bo(ji.modifiers,fu);if(En>=0){if(ns(ji)&&!K.experimentalDecorators)st.push(Ir(ji.modifiers[En],v.Decorators_are_not_valid_here));else if(tu(ji)){let Ni=Bo(ji.modifiers,OA);if(Ni>=0){let an=Bo(ji.modifiers,Dj);if(En>Ni&&an>=0&&En<an)st.push(Ir(ji.modifiers[En],v.Decorators_are_not_valid_here));else if(Ni>=0&&En<Ni){let Ds=Bo(ji.modifiers,fu,Ni);Ds>=0&&st.push(ca(Ir(ji.modifiers[Ds],v.Decorators_may_not_appear_after_export_or_export_default_if_they_also_appear_before_export),Ir(ji.modifiers[En],v.Decorator_used_before_export_here)))}}}}}switch(ji.kind){case 263:case 231:case 174:case 176:case 177:case 178:case 218:case 262:case 219:if(kn===ji.typeParameters)return st.push(_n(kn,v.Type_parameter_declarations_can_only_be_used_in_TypeScript_files)),"skip";case 243:if(kn===ji.modifiers)return kr(ji.modifiers,ji.kind===243),"skip";break;case 172:if(kn===ji.modifiers){for(let En of kn)Pa(En)&&En.kind!==126&&En.kind!==129&&st.push(Ir(En,v.The_0_modifier_can_only_be_used_in_TypeScript_files,Sa(En.kind)));return"skip"}break;case 169:if(kn===ji.modifiers&&Pt(kn,Pa))return st.push(_n(kn,v.Parameter_modifiers_can_only_be_used_in_TypeScript_files)),"skip";break;case 213:case 214:case 233:case 285:case 286:case 215:if(kn===ji.typeArguments)return st.push(_n(kn,v.Type_arguments_can_only_be_used_in_TypeScript_files)),"skip";break}}function kr(kn,ji){for(let En of kn)switch(En.kind){case 87:if(ji)continue;case 125:case 123:case 124:case 148:case 138:case 128:case 164:case 103:case 147:st.push(Ir(En,v.The_0_modifier_can_only_be_used_in_TypeScript_files,Sa(En.kind)));break;case 126:case 95:case 90:case 129:}}function _n(kn,ji,...En){let Ni=kn.pos;return bu(We,Ni,kn.end-Ni,ji,...En)}function Ir(kn,ji,...En){return bd(We,kn,ji,...En)}})}function gc(We,st){return Oc(We,st,qe,Wl)}function Wl(We,st){return Ye(()=>{let Jt=Xu().getEmitResolver(We,st);return Nhe(Sc(io),Jt,We)||ve})}function Oc(We,st,Jt,sr){var kr;let _n=We?(kr=Jt.perFile)==null?void 0:kr.get(We.path):Jt.allDiagnostics;if(_n)return _n;let Ir=sr(We,st);return We?(Jt.perFile||(Jt.perFile=new Map)).set(We.path,Ir):Jt.allDiagnostics=Ir,Ir}function du(We,st){return We.isDeclarationFile?[]:gc(We,st)}function hc(){return wP(ps(Ke().getGlobalDiagnostics(),mu()))}function mu(){if(!K.configFile)return ve;let We=Ke().getDiagnostics(K.configFile.fileName);return Hl(st=>{We=ps(We,Ke().getDiagnostics(st.sourceFile.fileName))}),We}function zf(){return pe.length?wP(Xu().getGlobalDiagnostics().slice()):ve}function rl(){return re||ve}function $l(We,st,Jt,sr){fl(Zs(We),st,Jt,void 0,sr)}function nd(We,st){return We.fileName===st.fileName}function Je(We,st){return We.kind===80?st.kind===80&&We.escapedText===st.escapedText:st.kind===11&&We.text===st.text}function qt(We,st){let Jt=U.createStringLiteral(We),sr=U.createImportDeclaration(void 0,void 0,Jt);return kA(sr,2),lo(Jt,sr),lo(sr,st),Jt.flags&=-17,sr.flags&=-17,Jt}function Gr(We){if(We.imports)return;let st=Af(We),Jt=nu(We),sr,kr,_n;if(st||!We.isDeclarationFile&&(Cd(K)||nu(We))){K.importHelpers&&(sr=[qt(ab,We)]);let En=Z9(Q9(K,We),K);En&&(sr||(sr=[])).push(qt(En,We))}for(let En of We.statements)Ir(En,!1);(We.flags&4194304||st)&&kn(We),We.imports=sr||ve,We.moduleAugmentations=kr||ve,We.ambientModuleNames=_n||ve;return;function Ir(En,Ni){if(X3(En)){let an=sA(En);an&&La(an)&&an.text&&(!Ni||!vu(an.text))&&(T0(En,!1),sr=Bt(sr,an),!Ce&&or===0&&!We.isDeclarationFile&&(Ce=_s(an.text,"node:")))}else if(El(En)&&B_(En)&&(Ni||li(En,128)||We.isDeclarationFile)){En.name.parent=En;let an=Qd(En.name);if(Jt||Ni&&!vu(an))(kr||(kr=[])).push(En.name);else if(!Ni){We.isDeclarationFile&&(_n||(_n=[])).push(an);let Ds=En.body;if(Ds)for(let wa of Ds.statements)Ir(wa,!0)}}}function kn(En){let Ni=/import|require/g;for(;Ni.exec(En.text)!==null;){let an=ji(En,Ni.lastIndex);if(st&&kf(an,!0))T0(an,!1),sr=Bt(sr,an.arguments[0]);else if(Np(an)&&an.arguments.length>=1&&No(an.arguments[0]))T0(an,!1),sr=Bt(sr,an.arguments[0]);else if(Ev(an))T0(an,!1),sr=Bt(sr,an.argument.literal);else if(st&&Xg(an)){let Ds=sA(an);Ds&&La(Ds)&&Ds.text&&(T0(an,!1),sr=Bt(sr,Ds))}}}function ji(En,Ni){let an=En,Ds=wa=>{if(wa.pos<=Ni&&(Ni<wa.end||Ni===wa.end&&wa.kind===1))return wa};for(;;){let wa=st&&Pp(an)&&kt(an.jsDoc,Ds)||Js(an,Ds);if(!wa)return an;an=wa}}}function gs(We){var st;let Jt=M8e(We),sr=Jt&&((st=mt?.get(Jt))==null?void 0:st.actual);return sr!==void 0?po(sr):void 0}function Qa(We,st){return so(GK(st.fileName,We.fileName),po)}function so(We,st,Jt,sr){if(kP(We)){let kr=Sr.getCanonicalFileName(We);if(!K.allowNonTsExtensions&&!kt(ef(Vr),Ir=>Ic(kr,Ir))){Jt&&(Oy(kr)?Jt(v.File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option,We):Jt(v.File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1,We,"'"+ef(Yt).join("', '")+"'"));return}let _n=st(We);if(Jt)if(_n)Ib(sr)&&kr===Sr.getCanonicalFileName(_r(sr.file).fileName)&&Jt(v.A_file_cannot_have_a_reference_to_itself);else{let Ir=sd(We);Ir?Jt(v.Output_file_0_has_not_been_built_from_source_file_1,Ir,We):Jt(v.File_0_not_found,We)}return _n}else{let kr=K.allowNonTsExtensions&&st(We);if(kr)return kr;if(Jt&&K.allowNonTsExtensions){Jt(v.File_0_not_found,We);return}let _n=kt(Yt[0],Ir=>st(We+Ir));return Jt&&!_n&&Jt(v.Could_not_resolve_the_path_0_with_the_extensions_Colon_1,We,"'"+ef(Yt).join("', '")+"'"),_n}}function fl(We,st,Jt,sr,kr){so(We,_n=>Cl(_n,st,Jt,kr,sr),(_n,...Ir)=>vo(void 0,kr,_n,Ir),kr)}function au(We,st){return fl(We,!1,!1,void 0,st)}function Uo(We,st,Jt){!Ib(Jt)&&Pt(Pe.get(st.path),Ib)?vo(st,Jt,v.Already_included_file_name_0_differs_from_file_name_1_only_in_casing,[st.fileName,We]):vo(st,Jt,v.File_name_0_differs_from_already_included_file_name_1_only_in_casing,[We,st.fileName])}function Fo(We,st,Jt,sr,kr,_n,Ir){var kn;let ji=Cb.createRedirectedSourceFile({redirectTarget:We,unredirected:st});return ji.fileName=Jt,ji.path=sr,ji.resolvedPath=kr,ji.originalFileName=_n,ji.packageJsonLocations=(kn=Ir.packageJsonLocations)!=null&&kn.length?Ir.packageJsonLocations:void 0,ji.packageJsonScope=Ir.packageJsonScope,Oi.set(sr,or>0),ji}function Cl(We,st,Jt,sr,kr){var _n,Ir;(_n=Cn)==null||_n.push(Cn.Phase.Program,"findSourceFile",{fileName:We,isDefaultLib:st||void 0,fileIncludeKind:XW[sr.kind]});let kn=fg(We,st,Jt,sr,kr);return(Ir=Cn)==null||Ir.pop(),kn}function Wf(We,st,Jt,sr){let kr=YB(xs(We,$e),st?.getPackageJsonInfoCache(),Jt,sr),_n=Ka(sr),Ir=WR(sr);return typeof kr=="object"?{...kr,languageVersion:_n,setExternalModuleIndicator:Ir,jsDocParsingMode:Jt.jsDocParsingMode}:{languageVersion:_n,impliedNodeFormat:kr,setExternalModuleIndicator:Ir,jsDocParsingMode:Jt.jsDocParsingMode}}function fg(We,st,Jt,sr,kr){var _n;let Ir=er(We);if(Nt){let an=Kh(Ir);if(!an&&Sr.realpath&&K.preserveSymlinks&&Mu(We)&&We.includes(jy)){let Ds=er(Sr.realpath(We));Ds!==Ir&&(an=Kh(Ds))}if(an){let Ds=bs(an)?Cl(an,st,Jt,sr,kr):void 0;return Ds&&If(Ds,Ir,We,void 0),Ds}}let kn=We;if(nt.has(Ir)){let an=nt.get(Ir),Ds=id(an||void 0,sr,!0);if(an&&Ds&&K.forceConsistentCasingInFileNames!==!1){let wa=an.fileName;er(wa)!==er(We)&&(We=sd(We)||We);let N_=m$(wa,$e),um=m$(We,$e);N_!==um&&Uo(We,an,sr)}return an&&Oi.get(an.path)&&or===0?(Oi.set(an.path,!1),K.noResolve||(ad(an,st),oe(an)),K.noLib||nn(an),Zr.set(an.path,!1),Si(an)):an&&Zr.get(an.path)&&or<ur&&(Zr.set(an.path,!1),Si(an)),an||void 0}let ji;if(!Nt){let an=Gh(We);if(an){if(an.commandLine.options.outFile)return;let Ds=Yh(an,We);We=Ds,ji=er(Ds)}}let En=Wf(We,Ui,Sr,K),Ni=Sr.getSourceFile(We,En,an=>vo(void 0,sr,v.Cannot_read_file_0_Colon_1,[We,an]),Ge);if(kr){let an=J1(kr),Ds=St.get(an);if(Ds){let wa=Fo(Ds,Ni,We,Ir,er(We),kn,En);return vt.add(Ds.path,We),If(wa,Ir,We,ji),id(wa,sr,!1),fe.set(Ir,q5(kr)),de.push(wa),wa}else Ni&&(St.set(an,Ni),fe.set(Ir,q5(kr)))}if(If(Ni,Ir,We,ji),Ni){if(Oi.set(Ir,or>0),Ni.fileName=We,Ni.path=Ir,Ni.resolvedPath=er(We),Ni.originalFileName=kn,Ni.packageJsonLocations=(_n=En.packageJsonLocations)!=null&&_n.length?En.packageJsonLocations:void 0,Ni.packageJsonScope=En.packageJsonScope,id(Ni,sr,!1),Sr.useCaseSensitiveFileNames()){let an=R1(Ir),Ds=tt.get(an);Ds?Uo(We,Ds,sr):tt.set(an,Ni)}Cs=Cs||Ni.hasNoDefaultLib&&!Jt,K.noResolve||(ad(Ni,st),oe(Ni)),K.noLib||nn(Ni),Si(Ni),st?me.push(Ni):de.push(Ni),(ke??(ke=new Set)).add(Ni.path)}return Ni}function id(We,st,Jt){return We&&(!Jt||!Ib(st)||!ke?.has(st.file))?(Pe.add(We.path,st),!0):!1}function If(We,st,Jt,sr){sr?(wd(Jt,sr,We),wd(Jt,st,We||!1)):wd(Jt,st,We)}function wd(We,st,Jt){nt.set(st,Jt),Jt!==void 0?Me.delete(st):Me.set(st,We)}function sd(We){let st=Gh(We);return st&&Yh(st,We)}function Gh(We){if(!(!ft||!ft.length||Mu(We)||Ic(We,".json")))return Of(We)}function Yh(We,st){let Jt=We.commandLine.options.outFile;return Jt?Y1(Jt,".d.ts"):jN(st,We.commandLine,!Sr.useCaseSensitiveFileNames())}function Of(We){Oe===void 0&&(Oe=new Map,Hl(Jt=>{er(K.configFilePath)!==Jt.sourceFile.path&&Jt.commandLine.fileNames.forEach(sr=>Oe.set(er(sr),Jt.sourceFile.path))}));let st=Oe.get(er(We));return st&&nh(st)}function Hl(We){return sX(ft,We)}function Kh(We){if(Mu(We))return At===void 0&&(At=new Map,Hl(st=>{let Jt=st.commandLine.options.outFile;if(Jt){let sr=Y1(Jt,".d.ts");At.set(er(sr),!0)}else{let sr=tf(()=>tk(st.commandLine,!Sr.useCaseSensitiveFileNames()));kt(st.commandLine.fileNames,kr=>{if(!Mu(kr)&&!Ic(kr,".json")){let _n=jN(kr,st.commandLine,!Sr.useCaseSensitiveFileNames(),sr);At.set(er(_n),kr)}})}})),At.get(We)}function $f(We){return Nt&&!!Of(We)}function nh(We){if(tr)return tr.get(We)||void 0}function ad(We,st){kt(We.referencedFiles,(Jt,sr)=>{fl(GK(Jt.fileName,We.fileName),st,!1,void 0,{kind:4,file:We.path,index:sr})})}function oe(We){let st=We.typeReferenceDirectives;if(!st.length)return;let Jt=xr?.get(We.path)||Do(st,We),sr=wN();(vr??(vr=new Map)).set(We.path,sr);for(let kr=0;kr<st.length;kr++){let _n=We.typeReferenceDirectives[kr],Ir=Jt[kr],kn=_n.fileName;sr.set(kn,G8(_n,We.impliedNodeFormat),Ir);let ji=_n.resolutionMode||We.impliedNodeFormat;yt(kn,ji,Ir,{kind:5,file:We.path,index:kr})}}function yt(We,st,Jt,sr){var kr,_n;(kr=Cn)==null||kr.push(Cn.Phase.Program,"processTypeReferenceDirective",{directive:We,hasResolved:!!Jt.resolvedTypeReferenceDirective,refKind:sr.kind,refPath:Ib(sr)?sr.file:void 0}),Gt(We,st,Jt,sr),(_n=Cn)==null||_n.pop()}function Gt(We,st,Jt,sr){Ar(Jt);let{resolvedTypeReferenceDirective:kr}=Jt;kr?(kr.isExternalLibraryImport&&or++,fl(kr.resolvedFileName,!1,!1,kr.packageId,sr),kr.isExternalLibraryImport&&or--):vo(void 0,sr,v.Cannot_find_type_definition_file_for_0,[We])}function Xt(We){let st=mt?.get(We);if(st)return st.actual;let Jt=Fr(We);return(mt??(mt=new Map)).set(We,Jt),Jt.actual}function Fr(We){var st,Jt,sr,kr,_n;let Ir=Xe?.get(We);if(Ir)return Ir;if(bt!==0&&ne&&!to(We)){let an=(st=ne.resolvedLibReferences)==null?void 0:st.get(We);if(an){if(an.resolution&&P0(K,Sr)){let Ds=aX(We),wa=GB(K,$e,We);ds(Sr,an.resolution.resolvedModule?an.resolution.resolvedModule.packageId?v.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3:v.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2:v.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved,Ds,xs(wa,$e),(Jt=an.resolution.resolvedModule)==null?void 0:Jt.resolvedFileName,((sr=an.resolution.resolvedModule)==null?void 0:sr.packageId)&&J1(an.resolution.resolvedModule.packageId))}return(Xe??(Xe=new Map)).set(We,an),an}}let kn=aX(We),ji=GB(K,$e,We);(kr=Cn)==null||kr.push(Cn.Phase.Program,"resolveLibrary",{resolveFrom:ji}),jc("beforeResolveLibrary");let En=lt(kn,ji,K,We);jc("afterResolveLibrary"),vd("ResolveLibrary","beforeResolveLibrary","afterResolveLibrary"),(_n=Cn)==null||_n.pop();let Ni={resolution:En,actual:En.resolvedModule?En.resolvedModule.resolvedFileName:ri(Ii,We)};return(Xe??(Xe=new Map)).set(We,Ni),Ni}function nn(We){kt(We.libReferenceDirectives,(st,Jt)=>{let sr=M8e(st);sr?$l(Xt(sr),!0,!0,{kind:7,file:We.path,index:Jt}):(et||(et=[])).push({kind:0,reason:{kind:7,file:We.path,index:Jt}})})}function Hn(We){return Sr.getCanonicalFileName(We)}function Si(We){var st;if(Gr(We),We.imports.length||We.moduleAugmentations.length){let Jt=L8e(We),sr=rr?.get(We.path)||Mo(Jt,We);M.assert(sr.length===Jt.length);let kr=((st=Yn(We))==null?void 0:st.commandLine.options)||K,_n=wN();(ht??(ht=new Map)).set(We.path,_n);for(let Ir=0;Ir<Jt.length;Ir++){let kn=sr[Ir].resolvedModule,ji=Jt[Ir].text,En=tX(We,Jt[Ir],kr);if(_n.set(ji,En,sr[Ir]),In(We,ji,sr[Ir],En),!kn)continue;let Ni=kn.isExternalLibraryImport,an=!oO(kn.extension)&&!Gh(kn.resolvedFileName),Ds=Ni&&an&&(!kn.originalPath||Nb(kn.resolvedFileName)),wa=kn.resolvedFileName;Ni&&or++;let xu=Ds&&or>ur,N_=wa&&!_X(kr,kn,We)&&!kr.noResolve&&Ir<We.imports.length&&!xu&&!(an&&!H1(kr))&&(hn(We.imports[Ir])||!(We.imports[Ir].flags&16777216));xu?Zr.set(We.path,!0):N_&&Cl(wa,!1,!1,{kind:3,file:We.path,index:Ir},kn.packageId),Ni&&or--}}}function $(We,st){let Jt=!0,sr=Sr.getCanonicalFileName(xs(st,$e));for(let kr of We)kr.isDeclarationFile||Sr.getCanonicalFileName(xs(kr.fileName,$e)).indexOf(sr)!==0&&(Wa(kr,v.File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files,[kr.fileName,st]),Jt=!1);return Jt}function Fe(We){tr||(tr=new Map);let st=VN(We),Jt=er(st),sr=tr.get(Jt);if(sr!==void 0)return sr||void 0;let kr,_n;if(Sr.getParsedCommandLine){if(kr=Sr.getParsedCommandLine(st),!kr){If(void 0,Jt,st,void 0),tr.set(Jt,!1);return}_n=M.checkDefined(kr.options.configFile),M.assert(!_n.path||_n.path===Jt),If(_n,Jt,st,void 0)}else{let kn=xs(mi(st),$e);if(_n=Sr.getSourceFile(st,100),If(_n,Jt,st,void 0),_n===void 0){tr.set(Jt,!1);return}kr=D8(_n,Pi,kn,void 0,st)}_n.fileName=st,_n.path=Jt,_n.resolvedPath=Jt,_n.originalFileName=st;let Ir={commandLine:kr,sourceFile:_n};return tr.set(Jt,Ir),kr.projectReferences&&(Ir.references=kr.projectReferences.map(Fe)),Ir}function jt(){K.strictPropertyInitialization&&!J_(K,"strictNullChecks")&&Vo(v.Option_0_cannot_be_specified_without_specifying_option_1,"strictPropertyInitialization","strictNullChecks"),K.exactOptionalPropertyTypes&&!J_(K,"strictNullChecks")&&Vo(v.Option_0_cannot_be_specified_without_specifying_option_1,"exactOptionalPropertyTypes","strictNullChecks"),(K.isolatedModules||K.verbatimModuleSyntax)&&K.outFile&&Vo(v.Option_0_cannot_be_specified_with_option_1,"outFile",K.verbatimModuleSyntax?"verbatimModuleSyntax":"isolatedModules"),K.isolatedDeclarations&&(H1(K)&&Vo(v.Option_0_cannot_be_specified_with_option_1,"allowJs","isolatedDeclarations"),$p(K)||Vo(v.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2,"isolatedDeclarations","declaration","composite")),K.inlineSourceMap&&(K.sourceMap&&Vo(v.Option_0_cannot_be_specified_with_option_1,"sourceMap","inlineSourceMap"),K.mapRoot&&Vo(v.Option_0_cannot_be_specified_with_option_1,"mapRoot","inlineSourceMap")),K.composite&&(K.declaration===!1&&Vo(v.Composite_projects_may_not_disable_declaration_emit,"declaration"),K.incremental===!1&&Vo(v.Composite_projects_may_not_disable_incremental_compilation,"declaration"));let We=K.outFile;if(K.tsBuildInfoFile?nO(K)||Vo(v.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2,"tsBuildInfoFile","incremental","composite"):K.incremental&&!We&&!K.configFilePath&&$r.add(Nc(v.Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified)),Us(),Om(),K.composite){let Ir=new Set(pe.map(er));for(let kn of Ae)t2(kn,Q)&&!Ir.has(kn.path)&&Wa(kn,v.File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_include_pattern,[kn.fileName,K.configFilePath||""])}if(K.paths){for(let Ir in K.paths)if(Ho(K.paths,Ir))if(yG(Ir)||Vy(!0,Ir,v.Pattern_0_can_have_at_most_one_Asterisk_character,Ir),Rs(K.paths[Ir])){let kn=K.paths[Ir].length;kn===0&&Vy(!1,Ir,v.Substitutions_for_pattern_0_shouldn_t_be_an_empty_array,Ir);for(let ji=0;ji<kn;ji++){let En=K.paths[Ir][ji],Ni=typeof En;Ni==="string"?(yG(En)||Xh(Ir,ji,v.Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character,En,Ir),!K.baseUrl&&!qp(En)&&!iI(En)&&Xh(Ir,ji,v.Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash)):Xh(Ir,ji,v.Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2,En,Ir,Ni)}}else Vy(!1,Ir,v.Substitutions_for_pattern_0_should_be_an_array,Ir)}!K.sourceMap&&!K.inlineSourceMap&&(K.inlineSources&&Vo(v.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided,"inlineSources"),K.sourceRoot&&Vo(v.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided,"sourceRoot")),K.mapRoot&&!(K.sourceMap||K.declarationMap)&&Vo(v.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2,"mapRoot","sourceMap","declarationMap"),K.declarationDir&&($p(K)||Vo(v.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2,"declarationDir","declaration","composite"),We&&Vo(v.Option_0_cannot_be_specified_with_option_1,"declarationDir","outFile")),K.declarationMap&&!$p(K)&&Vo(v.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2,"declarationMap","declaration","composite"),K.lib&&K.noLib&&Vo(v.Option_0_cannot_be_specified_with_option_1,"lib","noLib");let st=Ka(K),Jt=Ln(Ae,Ir=>nu(Ir)&&!Ir.isDeclarationFile);if(K.isolatedModules||K.verbatimModuleSyntax)K.module===0&&st<2&&K.isolatedModules&&Vo(v.Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher,"isolatedModules","target"),K.preserveConstEnums===!1&&Vo(v.Option_preserveConstEnums_cannot_be_disabled_when_0_is_enabled,K.verbatimModuleSyntax?"verbatimModuleSyntax":"isolatedModules","preserveConstEnums");else if(Jt&&st<2&&K.module===0){let Ir=Yx(Jt,typeof Jt.externalModuleIndicator=="boolean"?Jt:Jt.externalModuleIndicator);$r.add(bu(Jt,Ir.start,Ir.length,v.Cannot_use_imports_exports_or_module_augmentations_when_module_is_none))}if(We&&!K.emitDeclarationOnly){if(K.module&&!(K.module===2||K.module===4))Vo(v.Only_amd_and_system_modules_are_supported_alongside_0,"outFile","module");else if(K.module===void 0&&Jt){let Ir=Yx(Jt,typeof Jt.externalModuleIndicator=="boolean"?Jt:Jt.externalModuleIndicator);$r.add(bu(Jt,Ir.start,Ir.length,v.Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system,"outFile"))}}if(cE(K)&&(af(K)===1?Vo(v.Option_resolveJsonModule_cannot_be_specified_when_moduleResolution_is_set_to_classic,"resolveJsonModule"):G9(K)||Vo(v.Option_resolveJsonModule_cannot_be_specified_when_module_is_set_to_none_system_or_umd,"resolveJsonModule","module")),K.outDir||K.rootDir||K.sourceRoot||K.mapRoot||$p(K)&&K.declarationDir){let Ir=qs();K.outDir&&Ir===""&&Ae.some(kn=>Rh(kn.fileName)>1)&&Vo(v.Cannot_find_the_common_subdirectory_path_for_the_input_files,"outDir")}K.checkJs&&!H1(K)&&Vo(v.Option_0_cannot_be_specified_without_specifying_option_1,"checkJs","allowJs"),K.emitDeclarationOnly&&($p(K)||Vo(v.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2,"emitDeclarationOnly","declaration","composite"),K.noEmit&&Vo(v.Option_0_cannot_be_specified_with_option_1,"emitDeclarationOnly","noEmit")),K.noCheck&&K.noEmit&&Vo(v.Option_0_cannot_be_specified_with_option_1,"noCheck","noEmit"),K.emitDecoratorMetadata&&!K.experimentalDecorators&&Vo(v.Option_0_cannot_be_specified_without_specifying_option_1,"emitDecoratorMetadata","experimentalDecorators"),K.jsxFactory?(K.reactNamespace&&Vo(v.Option_0_cannot_be_specified_with_option_1,"reactNamespace","jsxFactory"),(K.jsx===4||K.jsx===5)&&Vo(v.Option_0_cannot_be_specified_when_option_jsx_is_1,"jsxFactory",C8.get(""+K.jsx)),GA(K.jsxFactory,st)||d_("jsxFactory",v.Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name,K.jsxFactory)):K.reactNamespace&&!sp(K.reactNamespace,st)&&d_("reactNamespace",v.Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier,K.reactNamespace),K.jsxFragmentFactory&&(K.jsxFactory||Vo(v.Option_0_cannot_be_specified_without_specifying_option_1,"jsxFragmentFactory","jsxFactory"),(K.jsx===4||K.jsx===5)&&Vo(v.Option_0_cannot_be_specified_when_option_jsx_is_1,"jsxFragmentFactory",C8.get(""+K.jsx)),GA(K.jsxFragmentFactory,st)||d_("jsxFragmentFactory",v.Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name,K.jsxFragmentFactory)),K.reactNamespace&&(K.jsx===4||K.jsx===5)&&Vo(v.Option_0_cannot_be_specified_when_option_jsx_is_1,"reactNamespace",C8.get(""+K.jsx)),K.jsxImportSource&&K.jsx===2&&Vo(v.Option_0_cannot_be_specified_when_option_jsx_is_1,"jsxImportSource",C8.get(""+K.jsx));let sr=V_(K);K.verbatimModuleSyntax&&(sr===2||sr===3||sr===4)&&Vo(v.Option_verbatimModuleSyntax_cannot_be_used_when_module_is_set_to_UMD_AMD_or_System,"verbatimModuleSyntax"),K.allowImportingTsExtensions&&!(K.noEmit||K.emitDeclarationOnly)&&d_("allowImportingTsExtensions",v.Option_allowImportingTsExtensions_can_only_be_used_when_either_noEmit_or_emitDeclarationOnly_is_set);let kr=af(K);if(K.resolvePackageJsonExports&&!bA(kr)&&Vo(v.Option_0_can_only_be_used_when_moduleResolution_is_set_to_node16_nodenext_or_bundler,"resolvePackageJsonExports"),K.resolvePackageJsonImports&&!bA(kr)&&Vo(v.Option_0_can_only_be_used_when_moduleResolution_is_set_to_node16_nodenext_or_bundler,"resolvePackageJsonImports"),K.customConditions&&!bA(kr)&&Vo(v.Option_0_can_only_be_used_when_moduleResolution_is_set_to_node16_nodenext_or_bundler,"customConditions"),kr===100&&!H9(sr)&&sr!==200&&d_("moduleResolution",v.Option_0_can_only_be_used_when_module_is_set_to_preserve_or_to_es2015_or_later,"bundler"),y3[sr]&&100<=sr&&sr<=199&&!(3<=kr&&kr<=99)){let Ir=y3[sr];d_("moduleResolution",v.Option_moduleResolution_must_be_set_to_0_or_left_unspecified_when_option_module_is_set_to_1,Ir,Ir)}else if(rI[kr]&&3<=kr&&kr<=99&&!(100<=sr&&sr<=199)){let Ir=rI[kr];d_("module",v.Option_module_must_be_set_to_0_when_option_moduleResolution_is_set_to_1,Ir,Ir)}if(!K.noEmit&&!K.suppressOutputPathCheck){let Ir=Sc(),kn=new Set;FK(Ir,ji=>{K.emitDeclarationOnly||_n(ji.jsFilePath,kn),_n(ji.declarationFilePath,kn)})}function _n(Ir,kn){if(Ir){let ji=er(Ir);if(nt.has(ji)){let Ni;K.configFilePath||(Ni=js(void 0,v.Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig)),Ni=js(Ni,v.Cannot_write_file_0_because_it_would_overwrite_input_file,Ir),dS(Ir,q9(Ni))}let En=Sr.useCaseSensitiveFileNames()?ji:R1(ji);kn.has(En)?dS(Ir,Nc(v.Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files,Ir)):kn.add(En)}}}function Xr(){let We=K.ignoreDeprecations;if(We){if(We==="5.0")return new Km(We);le()}return Km.zero}function Mi(We,st,Jt,sr,kr){let _n=new Km(We),Ir=new Km(Jt),kn=new Km(ce||j),ji=Xr(),En=Ir.compareTo(kn)!==1,Ni=!En&&ji.compareTo(_n)===-1;(En||Ni)&&kr((an,Ds,wa)=>{En?Ds===void 0?sr(an,Ds,wa,v.Option_0_has_been_removed_Please_remove_it_from_your_configuration,an):sr(an,Ds,wa,v.Option_0_1_has_been_removed_Please_remove_it_from_your_configuration,an,Ds):Ds===void 0?sr(an,Ds,wa,v.Option_0_is_deprecated_and_will_stop_functioning_in_TypeScript_1_Specify_compilerOption_ignoreDeprecations_Colon_2_to_silence_this_error,an,st,We):sr(an,Ds,wa,v.Option_0_1_is_deprecated_and_will_stop_functioning_in_TypeScript_2_Specify_compilerOption_ignoreDeprecations_Colon_3_to_silence_this_error,an,Ds,st,We)})}function Us(){function We(st,Jt,sr,kr,..._n){if(sr){let Ir=js(void 0,v.Use_0_instead,sr),kn=js(Ir,kr,..._n);Rm(!Jt,st,void 0,kn)}else Rm(!Jt,st,void 0,kr,..._n)}Mi("5.0","5.5","6.0",We,st=>{K.target===0&&st("target","ES3"),K.noImplicitUseStrict&&st("noImplicitUseStrict"),K.keyofStringsOnly&&st("keyofStringsOnly"),K.suppressExcessPropertyErrors&&st("suppressExcessPropertyErrors"),K.suppressImplicitAnyIndexErrors&&st("suppressImplicitAnyIndexErrors"),K.noStrictGenericChecks&&st("noStrictGenericChecks"),K.charset&&st("charset"),K.out&&st("out",void 0,"outFile"),K.importsNotUsedAsValues&&st("importsNotUsedAsValues",void 0,"verbatimModuleSyntax"),K.preserveValueImports&&st("preserveValueImports",void 0,"verbatimModuleSyntax")})}function Ss(We,st,Jt){function sr(kr,_n,Ir,kn,...ji){$_(st,Jt,kn,...ji)}Mi("5.0","5.5","6.0",sr,kr=>{We.prepend&&kr("prepend")})}function zs(We,st,Jt,sr){let kr,_n=We&&Pe.get(We.path),Ir,kn,ji=Ib(st)?st:void 0,En,Ni,an=We&&De?.get(We.path),Ds;an?(an.fileIncludeReasonDetails?(kr=new Set(_n),_n?.forEach(um)):_n?.forEach(N_),Ni=an.redirectInfo):(_n?.forEach(N_),Ni=We&&AX(We)),st&&N_(st);let wa=kr?.size!==_n?.length;ji&&kr?.size===1&&(kr=void 0),kr&&an&&(an.details&&!wa?Ds=js(an.details,Jt,...sr||ve):an.fileIncludeReasonDetails&&(wa?Gv()?Ir=Bt(an.fileIncludeReasonDetails.next.slice(0,_n.length),Ir[0]):Ir=[...an.fileIncludeReasonDetails.next,Ir[0]]:Gv()?Ir=an.fileIncludeReasonDetails.next.slice(0,_n.length):En=an.fileIncludeReasonDetails)),Ds||(En||(En=kr&&js(Ir,v.The_file_is_in_the_program_because_Colon)),Ds=js(Ni?En?[En,...Ni]:Ni:En,Jt,...sr||ve)),We&&(an?(!an.fileIncludeReasonDetails||!wa&&En)&&(an.fileIncludeReasonDetails=En):(De??(De=new Map)).set(We.path,an={fileIncludeReasonDetails:En,redirectInfo:Ni}),!an.details&&!wa&&(an.details=Ds.next));let xu=ji&&c6(Q,ji);return xu&&UN(xu)?X5(xu.file,xu.pos,xu.end-xu.pos,Ds,kn):q9(Ds,kn);function N_(_m){kr?.has(_m)||((kr??(kr=new Set)).add(_m),(Ir??(Ir=[])).push(NX(Q,_m)),um(_m))}function um(_m){!ji&&Ib(_m)?ji=_m:ji!==_m&&(kn=Bt(kn,qc(_m)))}function Gv(){var _m;return((_m=an.fileIncludeReasonDetails.next)==null?void 0:_m.length)!==_n?.length}}function vo(We,st,Jt,sr){(et||(et=[])).push({kind:1,file:We&&We.path,fileProcessingReason:st,diagnostic:Jt,args:sr})}function Wa(We,st,Jt){Xs.push({file:We,diagnostic:st,args:Jt})}function qc(We){let st=Be?.get(We);return st===void 0&&(Be??(Be=new Map)).set(We,st=Id(We)??!1),st||void 0}function Id(We){if(Ib(We)){let sr=c6(Q,We),kr;switch(We.kind){case 3:kr=v.File_is_included_via_import_here;break;case 4:kr=v.File_is_included_via_reference_here;break;case 5:kr=v.File_is_included_via_type_library_reference_here;break;case 7:kr=v.File_is_included_via_library_reference_here;break;default:M.assertNever(We)}return UN(sr)?bu(sr.file,sr.pos,sr.end-sr.pos,kr):void 0}if(!K.configFile)return;let st,Jt;switch(We.kind){case 0:if(!K.configFile.configFileSpecs)return;let sr=xs(pe[We.index],$e),kr=kX(Q,sr);if(kr){st=n9(K.configFile,"files",kr),Jt=v.File_is_matched_by_files_list_specified_here;break}let _n=PX(Q,sr);if(!_n||!bs(_n))return;st=n9(K.configFile,"include",_n),Jt=v.File_is_matched_by_include_pattern_specified_here;break;case 1:case 2:let Ir=M.checkDefined(ft?.[We.index]),kn=HB(ue,ft,(Ds,wa,xu)=>Ds===Ir?{sourceFile:wa?.sourceFile||K.configFile,index:xu}:void 0);if(!kn)return;let{sourceFile:ji,index:En}=kn,Ni=iR(ji,"references",Ds=>Gu(Ds.initializer)?Ds.initializer:void 0);return Ni&&Ni.elements.length>En?bd(ji,Ni.elements[En],We.kind===2?v.File_is_output_from_referenced_project_specified_here:v.File_is_source_from_referenced_project_specified_here):void 0;case 8:if(!K.types)return;st=od("types",We.typeReference),Jt=v.File_is_entry_point_of_type_library_specified_here;break;case 6:if(We.index!==void 0){st=od("lib",K.lib[We.index]),Jt=v.File_is_library_specified_here;break}let an=Y9(Ka(K));st=an?Od("target",an):void 0,Jt=v.File_is_default_library_for_target_specified_here;break;default:M.assertNever(We)}return st&&bd(K.configFile,st,Jt)}function Om(){let We=K.suppressOutputPathCheck?void 0:jv(K);HB(ue,ft,(st,Jt,sr)=>{let kr=(Jt?Jt.commandLine.projectReferences:ue)[sr],_n=Jt&&Jt.sourceFile;if(Ss(kr,_n,sr),!st){$_(_n,sr,v.File_0_not_found,kr.path);return}let Ir=st.commandLine.options;(!Ir.composite||Ir.noEmit)&&(Jt?Jt.commandLine.fileNames:pe).length&&(Ir.composite||$_(_n,sr,v.Referenced_project_0_must_have_setting_composite_Colon_true,kr.path),Ir.noEmit&&$_(_n,sr,v.Referenced_project_0_may_not_disable_emit,kr.path)),!Jt&&We&&We===jv(Ir)&&($_(_n,sr,v.Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1,We,kr.path),An.set(er(We),!0))})}function Xh(We,st,Jt,...sr){let kr=!0;Jy(_n=>{Ca(_n.initializer)&&$P(_n.initializer,We,Ir=>{let kn=Ir.initializer;Gu(kn)&&kn.elements.length>st&&($r.add(bd(K.configFile,kn.elements[st],Jt,...sr)),kr=!1)})}),kr&&Hv(Jt,...sr)}function Vy(We,st,Jt,...sr){let kr=!0;Jy(_n=>{Ca(_n.initializer)&&cm(_n.initializer,We,st,void 0,Jt,...sr)&&(kr=!1)}),kr&&Hv(Jt,...sr)}function $v(We,st){return $P(O0(),We,st)}function Jy(We){return $v("paths",We)}function Od(We,st){return $v(We,Jt=>La(Jt.initializer)&&Jt.initializer.text===st?Jt.initializer:void 0)}function od(We,st){let Jt=O0();return Jt&&efe(Jt,We,st)}function Vo(We,st,Jt,sr){Rm(!0,st,Jt,We,st,Jt,sr)}function d_(We,st,...Jt){Rm(!1,We,void 0,st,...Jt)}function $_(We,st,Jt,...sr){let kr=iR(We||K.configFile,"references",_n=>Gu(_n.initializer)?_n.initializer:void 0);kr&&kr.elements.length>st?$r.add(bd(We||K.configFile,kr.elements[st],Jt,...sr)):$r.add(Nc(Jt,...sr))}function Rm(We,st,Jt,sr,...kr){let _n=O0();(!_n||!cm(_n,We,st,Jt,sr,...kr))&&Hv(sr,...kr)}function Hv(We,...st){let Jt=pS();Jt?"messageText"in We?$r.add(ky(K.configFile,Jt.name,We)):$r.add(bd(K.configFile,Jt.name,We,...st)):"messageText"in We?$r.add(q9(We)):$r.add(Nc(We,...st))}function O0(){if(vi===void 0){let We=pS();vi=We&&ai(We.initializer,Ca)||!1}return vi||void 0}function pS(){return Ci===void 0&&(Ci=$P(DI(K.configFile),"compilerOptions",ec)||!1),Ci||void 0}function cm(We,st,Jt,sr,kr,..._n){let Ir=!1;return $P(We,Jt,kn=>{"messageText"in kr?$r.add(ky(K.configFile,st?kn.name:kn.initializer,kr)):$r.add(bd(K.configFile,st?kn.name:kn.initializer,kr,..._n)),Ir=!0},sr),Ir}function dS(We,st){An.set(er(We),!0),$r.add(st)}function lm(We){if(K.noEmit)return!1;let st=er(We);if(_r(st))return!1;let Jt=K.outFile;if(Jt)return Vb(st,Jt)||Vb(st,of(Jt)+".d.ts");if(K.declarationDir&&Cm(K.declarationDir,st,$e,!Sr.useCaseSensitiveFileNames()))return!0;if(K.outDir)return Cm(K.outDir,st,$e,!Sr.useCaseSensitiveFileNames());if(wl(st,_N)||Mu(st)){let sr=of(st);return!!_r(sr+".ts")||!!_r(sr+".tsx")}return!1}function Vb(We,st){return _0(We,st,$e,!Sr.useCaseSensitiveFileNames())===0}function pg(){return Sr.getSymlinkCache?Sr.getSymlinkCache():(xe||(xe=vG($e,Hn)),Ae&&!xe.hasProcessedResolutions()&&xe.setSymlinksFromResolutions($t,Ht,_t),xe)}function cd(We,st){var Jt;let sr=((Jt=Yn(We))==null?void 0:Jt.commandLine.options)||K;return tX(We,st,sr)}function R0(We,st){return cd(We,Q8(We,st))}}function fxt(e){let t,n=e.compilerHost.fileExists,i=e.compilerHost.directoryExists,s=e.compilerHost.getDirectories,o=e.compilerHost.realpath;if(!e.useSourceOfProjectReferenceRedirect)return{onProgramCreateComplete:io,fileExists:d};e.compilerHost.fileExists=d;let u;return i&&(u=e.compilerHost.directoryExists=w=>i.call(e.compilerHost,w)?(x(w),!0):e.getResolvedProjectReferences()?(t||(t=new Set,e.forEachResolvedProjectReference(R=>{let L=R.commandLine.options.outFile;if(L)t.add(mi(e.toPath(L)));else{let F=R.commandLine.options.declarationDir||R.commandLine.options.outDir;F&&t.add(e.toPath(F))}})),D(w,!1)):!1),s&&(e.compilerHost.getDirectories=w=>!e.getResolvedProjectReferences()||i&&i.call(e.compilerHost,w)?s.call(e.compilerHost,w):[]),o&&(e.compilerHost.realpath=w=>{var R;return((R=e.getSymlinkCache().getSymlinkedFiles())==null?void 0:R.get(e.toPath(w)))||o.call(e.compilerHost,w)}),{onProgramCreateComplete:m,fileExists:d,directoryExists:u};function m(){e.compilerHost.fileExists=n,e.compilerHost.directoryExists=i,e.compilerHost.getDirectories=s}function d(w){return n.call(e.compilerHost,w)?!0:!e.getResolvedProjectReferences()||!Mu(w)?!1:D(w,!0)}function S(w){let R=e.getSourceOfProjectReferenceRedirect(e.toPath(w));return R!==void 0?bs(R)?n.call(e.compilerHost,R):!0:void 0}function E(w){let R=e.toPath(w),L=`${R}${Ec}`;return d0(t,F=>R===F||_s(F,L)||_s(R,`${F}/`))}function x(w){var R;if(!e.getResolvedProjectReferences()||pO(w)||!o||!w.includes(jy))return;let L=e.getSymlinkCache(),F=yu(e.toPath(w));if((R=L.getSymlinkedDirectories())!=null&&R.has(F))return;let J=Zs(o.call(e.compilerHost,w)),G;if(J===w||(G=yu(e.toPath(J)))===F){L.setSymlinkedDirectory(F,!1);return}L.setSymlinkedDirectory(w,{real:yu(J),realPath:G})}function D(w,R){var L;let F=R?W=>S(W):W=>E(W),J=F(w);if(J!==void 0)return J;let G=e.getSymlinkCache(),q=G.getSymlinkedDirectories();if(!q)return!1;let ee=e.toPath(w);return ee.includes(jy)?R&&((L=G.getSymlinkedFiles())!=null&&L.has(ee))?!0:qo(q.entries(),([W,pe])=>{if(!pe||!_s(ee,W))return;let K=F(ee.replace(W,pe.realPath));if(R&&K){let re=xs(w,e.compilerHost.getCurrentDirectory());G.setSymlinkedFile(ee,`${pe.real}${re.replace(new RegExp(W,"i"),"")}`)}return K})||!1:!1}}var lX={diagnostics:ve,sourceMaps:void 0,emittedFiles:void 0,emitSkipped:!0};function uX(e,t,n,i){let s=e.getCompilerOptions();if(s.noEmit)return e.getSemanticDiagnostics(t,i),t||s.outFile?lX:e.emitBuildInfo(n,i);if(!s.noEmitOnError)return;let o=[...e.getOptionsDiagnostics(i),...e.getSyntacticDiagnostics(t,i),...e.getGlobalDiagnostics(i),...e.getSemanticDiagnostics(t,i)];if(o.length===0&&$p(e.getCompilerOptions())&&(o=e.getDeclarationDiagnostics(void 0,i)),!o.length)return;let u;if(!t&&!s.outFile){let m=e.emitBuildInfo(n,i);m.diagnostics&&(o=[...o,...m.diagnostics]),u=m.emittedFiles}return{diagnostics:o,sourceMaps:void 0,emittedFiles:u,emitSkipped:!0}}function KB(e,t){return Zn(e,n=>!n.skippedOn||!t[n.skippedOn])}function XB(e,t=e){return{fileExists:n=>t.fileExists(n),readDirectory(n,i,s,o,u){return M.assertIsDefined(t.readDirectory,"'CompilerHost.readDirectory' must be implemented to correctly process 'projectReferences'"),t.readDirectory(n,i,s,o,u)},readFile:n=>t.readFile(n),directoryExists:ia(t,t.directoryExists),getDirectories:ia(t,t.getDirectories),realpath:ia(t,t.realpath),useCaseSensitiveFileNames:e.useCaseSensitiveFileNames(),getCurrentDirectory:()=>e.getCurrentDirectory(),onUnRecoverableConfigFileDiagnostic:e.onUnRecoverableConfigFileDiagnostic||VT,trace:e.trace?n=>e.trace(n):void 0}}function VN(e){return jX(e.path)}function _X(e,{extension:t},{isDeclarationFile:n}){switch(t){case".ts":case".d.ts":case".mts":case".d.mts":case".cts":case".d.cts":return;case".tsx":return i();case".jsx":return i()||s();case".js":case".mjs":case".cjs":return s();case".json":return o();default:return u()}function i(){return e.jsx?void 0:v.Module_0_was_resolved_to_1_but_jsx_is_not_set}function s(){return H1(e)||!J_(e,"noImplicitAny")?void 0:v.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type}function o(){return cE(e)?void 0:v.Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used}function u(){return n||e.allowArbitraryExtensions?void 0:v.Module_0_was_resolved_to_1_but_allowArbitraryExtensions_is_not_set}}function L8e({imports:e,moduleAugmentations:t}){let n=e.map(i=>i);for(let i of t)i.kind===11&&n.push(i);return n}function Q8({imports:e,moduleAugmentations:t},n){if(n<e.length)return e[n];let i=e.length;for(let s of t)if(s.kind===11){if(n===i)return s;i++}M.fail("should never ask for module name at index higher than possible module name")}function Yhe(e,t,n,i,s,o){let u=[],{emitSkipped:m,diagnostics:d}=e.emit(t,S,i,n,s,o);return{outputFiles:u,emitSkipped:m,diagnostics:d};function S(E,x,D){u.push({name:E,writeByteOrderMark:D,text:x})}}var Khe=(e=>(e[e.ComputedDts=0]="ComputedDts",e[e.StoredSignatureAtEmit=1]="StoredSignatureAtEmit",e[e.UsedVersion=2]="UsedVersion",e))(Khe||{}),lg;(e=>{function t(){function ce(ne,le,me){let de={getKeys:Ae=>le.get(Ae),getValues:Ae=>ne.get(Ae),keys:()=>ne.keys(),size:()=>ne.size,deleteKey:Ae=>{(me||(me=new Set)).add(Ae);let xe=ne.get(Ae);return xe?(xe.forEach(te=>i(le,te,Ae)),ne.delete(Ae),!0):!1},set:(Ae,xe)=>{me?.delete(Ae);let te=ne.get(Ae);return ne.set(Ae,xe),te?.forEach(he=>{xe.has(he)||i(le,he,Ae)}),xe.forEach(he=>{te?.has(he)||n(le,he,Ae)}),de}};return de}return ce(new Map,new Map,void 0)}e.createManyToManyPathMap=t;function n(ce,ne,le){let me=ce.get(ne);me||(me=new Set,ce.set(ne,me)),me.add(le)}function i(ce,ne,le){let me=ce.get(ne);return me?.delete(le)?(me.size||ce.delete(ne),!0):!1}function s(ce){return Gi(ce.declarations,ne=>{var le;return(le=Ur(ne))==null?void 0:le.resolvedPath})}function o(ce,ne){let le=ce.getSymbolAtLocation(ne);return le&&s(le)}function u(ce,ne,le,me){return rc(ce.getProjectReferenceRedirect(ne)||ne,le,me)}function m(ce,ne,le){let me;if(ne.imports&&ne.imports.length>0){let te=ce.getTypeChecker();for(let he of ne.imports){let be=o(te,he);be?.forEach(xe)}}let de=mi(ne.resolvedPath);if(ne.referencedFiles&&ne.referencedFiles.length>0)for(let te of ne.referencedFiles){let he=u(ce,te.fileName,de,le);xe(he)}if(ce.forEachResolvedTypeReferenceDirective(({resolvedTypeReferenceDirective:te})=>{if(!te)return;let he=te.resolvedFileName,be=u(ce,he,de,le);xe(be)},ne),ne.moduleAugmentations.length){let te=ce.getTypeChecker();for(let he of ne.moduleAugmentations){if(!La(he))continue;let be=te.getSymbolAtLocation(he);be&&Ae(be)}}for(let te of ce.getTypeChecker().getAmbientModules())te.declarations&&te.declarations.length>1&&Ae(te);return me;function Ae(te){if(te.declarations)for(let he of te.declarations){let be=Ur(he);be&&be!==ne&&xe(be.resolvedPath)}}function xe(te){(me||(me=new Set)).add(te)}}function d(ce,ne){return ne&&!ne.referencedMap==!ce}e.canReuseOldState=d;function S(ce){return ce.module!==0&&!ce.outFile?t():void 0}e.createReferencedMap=S;function E(ce,ne,le){var me,de;let Ae=new Map,xe=ce.getCompilerOptions(),te=S(xe),he=d(te,ne);ce.getTypeChecker();for(let be of ce.getSourceFiles()){let Ve=M.checkDefined(be.version,"Program intended to be used with Builder should have source files with versions set"),Pe=he?(me=ne.oldSignatures)==null?void 0:me.get(be.resolvedPath):void 0,ke=Pe===void 0?he?(de=ne.fileInfos.get(be.resolvedPath))==null?void 0:de.signature:void 0:Pe||void 0;if(te){let De=m(ce,be,ce.getCanonicalFileName);De&&te.set(be.resolvedPath,De)}Ae.set(be.resolvedPath,{version:Ve,signature:ke,affectsGlobalScope:xe.outFile?void 0:pe(be)||void 0,impliedFormat:be.impliedNodeFormat})}return{fileInfos:Ae,referencedMap:te,useFileVersionAsSignature:!le&&!he}}e.create=E;function x(ce){ce.allFilesExcludingDefaultLibraryFile=void 0,ce.allFileNames=void 0}e.releaseCache=x;function D(ce,ne,le,me,de){var Ae;let xe=w(ce,ne,le,me,de);return(Ae=ce.oldSignatures)==null||Ae.clear(),xe}e.getFilesAffectedBy=D;function w(ce,ne,le,me,de){let Ae=ne.getSourceFileByPath(le);return Ae?F(ce,ne,Ae,me,de)?(ce.referencedMap?ue:re)(ce,ne,Ae,me,de):[Ae]:ve}e.getFilesAffectedByWithOldState=w;function R(ce,ne,le){ce.fileInfos.get(le).signature=ne,(ce.hasCalledUpdateShapeSignature||(ce.hasCalledUpdateShapeSignature=new Set)).add(le)}e.updateSignatureOfFile=R;function L(ce,ne,le,me,de){ce.emit(ne,(Ae,xe,te,he,be,Ve)=>{M.assert(Mu(Ae),`File extension for signature expected to be dts: Got:: ${Ae}`),de(fX(ce,ne,xe,me,Ve),be)},le,2,void 0,!0)}e.computeDtsSignature=L;function F(ce,ne,le,me,de,Ae=ce.useFileVersionAsSignature){var xe;if((xe=ce.hasCalledUpdateShapeSignature)!=null&&xe.has(le.resolvedPath))return!1;let te=ce.fileInfos.get(le.resolvedPath),he=te.signature,be;return!le.isDeclarationFile&&!Ae&&L(ne,le,me,de,Ve=>{be=Ve,de.storeSignatureInfo&&(ce.signatureInfo??(ce.signatureInfo=new Map)).set(le.resolvedPath,0)}),be===void 0&&(be=le.version,de.storeSignatureInfo&&(ce.signatureInfo??(ce.signatureInfo=new Map)).set(le.resolvedPath,2)),(ce.oldSignatures||(ce.oldSignatures=new Map)).set(le.resolvedPath,he||!1),(ce.hasCalledUpdateShapeSignature||(ce.hasCalledUpdateShapeSignature=new Set)).add(le.resolvedPath),te.signature=be,be!==he}e.updateShapeSignature=F;function J(ce,ne,le){if(ne.getCompilerOptions().outFile||!ce.referencedMap||pe(le))return G(ce,ne);let de=new Set,Ae=[le.resolvedPath];for(;Ae.length;){let xe=Ae.pop();if(!de.has(xe)){de.add(xe);let te=ce.referencedMap.getValues(xe);if(te)for(let he of te.keys())Ae.push(he)}}return Is(Up(de.keys(),xe=>{var te;return((te=ne.getSourceFileByPath(xe))==null?void 0:te.fileName)??xe}))}e.getAllDependencies=J;function G(ce,ne){if(!ce.allFileNames){let le=ne.getSourceFiles();ce.allFileNames=le===ve?ve:le.map(me=>me.fileName)}return ce.allFileNames}function q(ce,ne){let le=ce.referencedMap.getKeys(ne);return le?Is(le.keys()):[]}e.getReferencedByPaths=q;function ee(ce){for(let ne of ce.statements)if(!G5(ne))return!1;return!0}function W(ce){return Pt(ce.moduleAugmentations,ne=>Rg(ne.parent))}function pe(ce){return W(ce)||!Uf(ce)&&!Kd(ce)&&!ee(ce)}function K(ce,ne,le){if(ce.allFilesExcludingDefaultLibraryFile)return ce.allFilesExcludingDefaultLibraryFile;let me;le&&de(le);for(let Ae of ne.getSourceFiles())Ae!==le&&de(Ae);return ce.allFilesExcludingDefaultLibraryFile=me||ve,ce.allFilesExcludingDefaultLibraryFile;function de(Ae){ne.isSourceFileDefaultLibrary(Ae)||(me||(me=[])).push(Ae)}}e.getAllFilesExcludingDefaultLibraryFile=K;function re(ce,ne,le){let me=ne.getCompilerOptions();return me&&me.outFile?[le]:K(ce,ne,le)}function ue(ce,ne,le,me,de){if(pe(le))return K(ce,ne,le);let Ae=ne.getCompilerOptions();if(Ae&&(Cd(Ae)||Ae.outFile))return[le];let xe=new Map;xe.set(le.resolvedPath,le);let te=q(ce,le.resolvedPath);for(;te.length>0;){let he=te.pop();if(!xe.has(he)){let be=ne.getSourceFileByPath(he);xe.set(he,be),be&&F(ce,ne,be,me,de)&&te.push(...q(ce,be.resolvedPath))}}return Is(Up(xe.values(),he=>he))}})(lg||(lg={}));var Xhe=(e=>(e[e.None=0]="None",e[e.Js=1]="Js",e[e.JsMap=2]="JsMap",e[e.JsInlineMap=4]="JsInlineMap",e[e.Dts=8]="Dts",e[e.DtsMap=16]="DtsMap",e[e.AllJs=7]="AllJs",e[e.AllDts=24]="AllDts",e[e.All=31]="All",e))(Xhe||{});function cS(e){let t=1;return e.sourceMap&&(t=t|2),e.inlineSourceMap&&(t=t|4),$p(e)&&(t=t|8),e.declarationMap&&(t=t|16),e.emitDeclarationOnly&&(t=t&24),t}function JN(e,t){let n=t&&(O1(t)?t:cS(t)),i=O1(e)?e:cS(e);if(n===i)return 0;if(!n||!i)return i;let s=n^i,o=0;return s&7&&(o=i&7),s&24&&(o=o|i&24),o}function pxt(e,t){return e===t||e!==void 0&&t!==void 0&&e.size===t.size&&!d0(e,n=>!t.has(n))}function dxt(e,t){var n,i;let s=lg.create(e,t,!1);s.program=e;let o=e.getCompilerOptions();s.compilerOptions=o;let u=o.outFile;u?o.composite&&t?.outSignature&&u===t.compilerOptions.outFile&&(s.outSignature=t.outSignature&&j8e(o,t.compilerOptions,t.outSignature)):s.semanticDiagnosticsPerFile=new Map,s.changedFilesSet=new Set,s.latestChangedDtsFile=o.composite?t?.latestChangedDtsFile:void 0;let m=lg.canReuseOldState(s.referencedMap,t),d=m?t.compilerOptions:void 0,S=m&&t.semanticDiagnosticsPerFile&&!!s.semanticDiagnosticsPerFile&&!_pe(o,d),E=o.composite&&t?.emitSignatures&&!u&&!ppe(o,t.compilerOptions);m?((n=t.changedFilesSet)==null||n.forEach(L=>s.changedFilesSet.add(L)),!u&&((i=t.affectedFilesPendingEmit)!=null&&i.size)&&(s.affectedFilesPendingEmit=new Map(t.affectedFilesPendingEmit),s.seenAffectedFiles=new Set),s.programEmitPending=t.programEmitPending):s.buildInfoEmitPending=!0;let x=s.referencedMap,D=m?t.referencedMap:void 0,w=S&&!o.skipLibCheck==!d.skipLibCheck,R=w&&!o.skipDefaultLibCheck==!d.skipDefaultLibCheck;if(s.fileInfos.forEach((L,F)=>{var J;let G,q;if(!m||!(G=t.fileInfos.get(F))||G.version!==L.version||G.impliedFormat!==L.impliedFormat||!pxt(q=x&&x.getValues(F),D&&D.getValues(F))||q&&d0(q,ee=>!s.fileInfos.has(ee)&&t.fileInfos.has(ee)))F8e(s,F);else{let ee=e.getSourceFileByPath(F),W=(J=t.emitDiagnosticsPerFile)==null?void 0:J.get(F);if(W&&(s.emitDiagnosticsPerFile??(s.emitDiagnosticsPerFile=new Map)).set(F,t.hasReusableDiagnostic?V8e(W,F,e):B8e(W,e)),S){if(ee.isDeclarationFile&&!w||ee.hasNoDefaultLib&&!R)return;let pe=t.semanticDiagnosticsPerFile.get(F);pe&&(s.semanticDiagnosticsPerFile.set(F,t.hasReusableDiagnostic?V8e(pe,F,e):B8e(pe,e)),(s.semanticDiagnosticsFromOldState??(s.semanticDiagnosticsFromOldState=new Set)).add(F))}}if(E){let ee=t.emitSignatures.get(F);ee&&(s.emitSignatures??(s.emitSignatures=new Map)).set(F,j8e(o,t.compilerOptions,ee))}}),m&&Nu(t.fileInfos,(L,F)=>s.fileInfos.has(F)?!1:u||L.affectsGlobalScope?!0:(s.buildInfoEmitPending=!0,!1)))lg.getAllFilesExcludingDefaultLibraryFile(s,e,void 0).forEach(L=>F8e(s,L.resolvedPath));else if(d){let L=fpe(o,d)?cS(o):JN(o,d);L!==0&&(u?s.programEmitPending=s.programEmitPending?s.programEmitPending|L:L:(e.getSourceFiles().forEach(F=>{s.changedFilesSet.has(F.resolvedPath)||dX(s,F.resolvedPath,L)}),M.assert(!s.seenAffectedFiles||!s.seenAffectedFiles.size),s.seenAffectedFiles=s.seenAffectedFiles||new Set,s.buildInfoEmitPending=!0))}return s}function F8e(e,t){e.changedFilesSet.add(t),e.buildInfoEmitPending=!0,e.programEmitPending=void 0}function j8e(e,t,n){return!!e.declarationMap==!!t.declarationMap?n:bs(n)?[n]:n[0]}function B8e(e,t){return e.length?Fs(e,n=>{if(bs(n.messageText))return n;let i=Qhe(n.messageText,n.file,t,s=>{var o;return(o=s.repopulateInfo)==null?void 0:o.call(s)});return i===n.messageText?n:{...n,messageText:i}}):e}function Qhe(e,t,n,i){let s=i(e);if(s)return{...J5(t,n,s.moduleReference,s.mode,s.packageName||s.moduleReference),next:U8e(e.next,t,n,i)};let o=U8e(e.next,t,n,i);return o===e.next?e:{...e,next:o}}function U8e(e,t,n,i){return Fs(e,s=>Qhe(s,t,n,i))}function V8e(e,t,n){if(!e.length)return ve;let i;return e.map(o=>{let u=J8e(o,t,n,s);u.reportsUnnecessary=o.reportsUnnecessary,u.reportsDeprecated=o.reportDeprecated,u.source=o.source,u.skippedOn=o.skippedOn;let{relatedInformation:m}=o;return u.relatedInformation=m?m.length?m.map(d=>J8e(d,t,n,s)):[]:void 0,u});function s(o){return i??(i=mi(xs(jv(n.getCompilerOptions()),n.getCurrentDirectory()))),rc(o,i,n.getCanonicalFileName)}}function J8e(e,t,n,i){let{file:s}=e,o=s!==!1?n.getSourceFileByPath(s?i(s):t):void 0;return{...e,file:o,messageText:bs(e.messageText)?e.messageText:Qhe(e.messageText,o,n,u=>u.info)}}function mxt(e){lg.releaseCache(e),e.program=void 0}function gxt(e){let t=e.compilerOptions.outFile;return M.assert(!e.changedFilesSet.size||t),{affectedFilesPendingEmit:e.affectedFilesPendingEmit&&new Map(e.affectedFilesPendingEmit),seenEmittedFiles:e.seenEmittedFiles&&new Map(e.seenEmittedFiles),programEmitPending:e.programEmitPending,emitSignatures:e.emitSignatures&&new Map(e.emitSignatures),outSignature:e.outSignature,latestChangedDtsFile:e.latestChangedDtsFile,hasChangedEmitSignature:e.hasChangedEmitSignature,changedFilesSet:t?new Set(e.changedFilesSet):void 0,buildInfoEmitPending:e.buildInfoEmitPending,emitDiagnosticsPerFile:e.emitDiagnosticsPerFile&&new Map(e.emitDiagnosticsPerFile)}}function hxt(e,t){e.affectedFilesPendingEmit=t.affectedFilesPendingEmit,e.seenEmittedFiles=t.seenEmittedFiles,e.programEmitPending=t.programEmitPending,e.emitSignatures=t.emitSignatures,e.outSignature=t.outSignature,e.latestChangedDtsFile=t.latestChangedDtsFile,e.hasChangedEmitSignature=t.hasChangedEmitSignature,e.buildInfoEmitPending=t.buildInfoEmitPending,e.emitDiagnosticsPerFile=t.emitDiagnosticsPerFile,t.changedFilesSet&&(e.changedFilesSet=t.changedFilesSet)}function q8e(e,t){M.assert(!t||!e.affectedFiles||e.affectedFiles[e.affectedFilesIndex-1]!==t||!e.semanticDiagnosticsPerFile.has(t.resolvedPath))}function z8e(e,t,n){for(var i;;){let{affectedFiles:s}=e;if(s){let d=e.seenAffectedFiles,S=e.affectedFilesIndex;for(;S<s.length;){let E=s[S];if(!d.has(E.resolvedPath))return e.affectedFilesIndex=S,dX(e,E.resolvedPath,cS(e.compilerOptions)),bxt(e,E,t,n),E;S++}e.changedFilesSet.delete(e.currentChangedFilePath),e.currentChangedFilePath=void 0,(i=e.oldSignatures)==null||i.clear(),e.affectedFiles=void 0}let o=e.changedFilesSet.keys().next();if(o.done)return;let u=M.checkDefined(e.program);if(u.getCompilerOptions().outFile)return M.assert(!e.semanticDiagnosticsPerFile),u;e.affectedFiles=lg.getFilesAffectedByWithOldState(e,u,o.value,t,n),e.currentChangedFilePath=o.value,e.affectedFilesIndex=0,e.seenAffectedFiles||(e.seenAffectedFiles=new Set)}}function yxt(e,t){var n;if((n=e.affectedFilesPendingEmit)!=null&&n.size){if(!t)return e.affectedFilesPendingEmit=void 0;e.affectedFilesPendingEmit.forEach((i,s)=>{let o=i&7;o?e.affectedFilesPendingEmit.set(s,o):e.affectedFilesPendingEmit.delete(s)})}}function vxt(e,t){var n;if((n=e.affectedFilesPendingEmit)!=null&&n.size)return Nu(e.affectedFilesPendingEmit,(i,s)=>{var o;let u=e.program.getSourceFileByPath(s);if(!u||!t2(u,e.program)){e.affectedFilesPendingEmit.delete(s);return}let m=(o=e.seenEmittedFiles)==null?void 0:o.get(u.resolvedPath),d=JN(i,m);if(t&&(d=d&24),d)return{affectedFile:u,emitKind:d}})}function Sxt(e){var t;if((t=e.emitDiagnosticsPerFile)!=null&&t.size)return Nu(e.emitDiagnosticsPerFile,(n,i)=>{var s;let o=e.program.getSourceFileByPath(i);if(!o||!t2(o,e.program)){e.emitDiagnosticsPerFile.delete(i);return}let u=((s=e.seenEmittedFiles)==null?void 0:s.get(o.resolvedPath))||0;if(!(u&24))return{affectedFile:o,diagnostics:n,seenKind:u}})}function W8e(e){if(!e.cleanedDiagnosticsOfLibFiles){e.cleanedDiagnosticsOfLibFiles=!0;let t=M.checkDefined(e.program),n=t.getCompilerOptions();kt(t.getSourceFiles(),i=>t.isSourceFileDefaultLibrary(i)&&!uO(i,n,t)&&eye(e,i.resolvedPath))}}function bxt(e,t,n,i){if(eye(e,t.resolvedPath),e.allFilesExcludingDefaultLibraryFile===e.affectedFiles){W8e(e),lg.updateShapeSignature(e,M.checkDefined(e.program),t,n,i);return}e.compilerOptions.assumeChangesOnlyAffectDirectDependencies||Txt(e,t,n,i)}function Zhe(e,t,n,i,s){if(eye(e,t),!e.changedFilesSet.has(t)){let o=M.checkDefined(e.program),u=o.getSourceFileByPath(t);u&&(lg.updateShapeSignature(e,o,u,i,s,!0),n?dX(e,t,cS(e.compilerOptions)):$p(e.compilerOptions)&&dX(e,t,e.compilerOptions.declarationMap?24:8))}}function eye(e,t){return e.semanticDiagnosticsFromOldState?(e.semanticDiagnosticsFromOldState.delete(t),e.semanticDiagnosticsPerFile.delete(t),!e.semanticDiagnosticsFromOldState.size):!0}function $8e(e,t){let n=M.checkDefined(e.oldSignatures).get(t)||void 0;return M.checkDefined(e.fileInfos.get(t)).signature!==n}function tye(e,t,n,i,s){var o;return(o=e.fileInfos.get(t))!=null&&o.affectsGlobalScope?(lg.getAllFilesExcludingDefaultLibraryFile(e,e.program,void 0).forEach(u=>Zhe(e,u.resolvedPath,n,i,s)),W8e(e),!0):!1}function Txt(e,t,n,i){var s,o;if(!e.referencedMap||!e.changedFilesSet.has(t.resolvedPath)||!$8e(e,t.resolvedPath))return;if(Cd(e.compilerOptions)){let d=new Map;d.set(t.resolvedPath,!0);let S=lg.getReferencedByPaths(e,t.resolvedPath);for(;S.length>0;){let E=S.pop();if(!d.has(E)){if(d.set(E,!0),tye(e,E,!1,n,i))return;if(Zhe(e,E,!1,n,i),$8e(e,E)){let x=M.checkDefined(e.program).getSourceFileByPath(E);S.push(...lg.getReferencedByPaths(e,x.resolvedPath))}}}}let u=new Set,m=!!((s=t.symbol)!=null&&s.exports)&&!!Nu(t.symbol.exports,d=>{if(d.flags&128)return!0;let S=$u(d,e.program.getTypeChecker());return S===d?!1:(S.flags&128)!==0&&Pt(S.declarations,E=>Ur(E)===t)});(o=e.referencedMap.getKeys(t.resolvedPath))==null||o.forEach(d=>{if(tye(e,d,m,n,i))return!0;let S=e.referencedMap.getKeys(d);return S&&d0(S,E=>H8e(e,E,m,u,n,i))})}function H8e(e,t,n,i,s,o){var u;if(Pg(i,t)){if(tye(e,t,n,s,o))return!0;Zhe(e,t,n,s,o),(u=e.referencedMap.getKeys(t))==null||u.forEach(m=>H8e(e,m,n,i,s,o))}}function rye(e,t,n){return ps(Ext(e,t,n),M.checkDefined(e.program).getProgramDiagnostics(t))}function Ext(e,t,n){let i=t.resolvedPath;if(e.semanticDiagnosticsPerFile){let o=e.semanticDiagnosticsPerFile.get(i);if(o)return KB(o,e.compilerOptions)}let s=M.checkDefined(e.program).getBindAndCheckDiagnostics(t,n);return e.semanticDiagnosticsPerFile&&e.semanticDiagnosticsPerFile.set(i,s),KB(s,e.compilerOptions)}function nye(e){var t;return!!((t=e.options)!=null&&t.outFile)}function xxt(e){var t,n;let i=M.checkDefined(e.program).getCurrentDirectory(),s=mi(xs(jv(e.compilerOptions),i)),o=e.latestChangedDtsFile?ee(e.latestChangedDtsFile):void 0,u=[],m=new Map,d=new Set(e.program.getRootFileNames().map(he=>rc(he,i,e.program.getCanonicalFileName))),S=[];if(e.compilerOptions.outFile){let he=Is(e.fileInfos.entries(),([Ve,Pe])=>{let ke=pe(Ve);return re(Ve,ke),Pe.impliedFormat?{version:Pe.version,impliedFormat:Pe.impliedFormat,signature:void 0,affectsGlobalScope:void 0}:Pe.version}),be={fileNames:u,fileInfos:he,root:S,resolvedRoot:ue(),options:ce(e.compilerOptions),outSignature:e.outSignature,latestChangedDtsFile:o,pendingEmit:e.programEmitPending?e.programEmitPending===cS(e.compilerOptions)?!1:e.programEmitPending:void 0};return UB(be)}let E,x,D,w=Is(e.fileInfos.entries(),([he,be])=>{var Ve,Pe;let ke=pe(he);re(he,ke),M.assert(u[ke-1]===W(he));let De=(Ve=e.oldSignatures)==null?void 0:Ve.get(he),Be=De!==void 0?De||void 0:be.signature;if(e.compilerOptions.composite){let ct=e.program.getSourceFileByPath(he);if(!Kd(ct)&&t2(ct,e.program)){let qe=(Pe=e.emitSignatures)==null?void 0:Pe.get(he);qe!==Be&&(D=Bt(D,qe===void 0?ke:[ke,!bs(qe)&&qe[0]===Be?ve:qe]))}}return be.version===Be?be.affectsGlobalScope||be.impliedFormat?{version:be.version,signature:void 0,affectsGlobalScope:be.affectsGlobalScope,impliedFormat:be.impliedFormat}:be.version:Be!==void 0?De===void 0?be:{version:be.version,signature:Be,affectsGlobalScope:be.affectsGlobalScope,impliedFormat:be.impliedFormat}:{version:be.version,signature:!1,affectsGlobalScope:be.affectsGlobalScope,impliedFormat:be.impliedFormat}}),R;(t=e.referencedMap)!=null&&t.size()&&(R=Is(e.referencedMap.keys()).sort(c_).map(he=>[pe(he),K(e.referencedMap.getValues(he))]));let L=le(),F;if((n=e.affectedFilesPendingEmit)!=null&&n.size){let he=cS(e.compilerOptions),be=new Set;for(let Ve of Is(e.affectedFilesPendingEmit.keys()).sort(c_))if(Pg(be,Ve)){let Pe=e.program.getSourceFileByPath(Ve);if(!Pe||!t2(Pe,e.program))continue;let ke=pe(Ve),De=e.affectedFilesPendingEmit.get(Ve);F=Bt(F,De===he?ke:De===8?[ke]:[ke,De])}}let J;if(e.changedFilesSet.size)for(let he of Is(e.changedFilesSet.keys()).sort(c_))J=Bt(J,pe(he));let G=me(),q={fileNames:u,fileInfos:w,root:S,resolvedRoot:ue(),options:ce(e.compilerOptions),fileIdsList:E,referencedMap:R,semanticDiagnosticsPerFile:L,emitDiagnosticsPerFile:G,affectedFilesPendingEmit:F,changeFileSet:J,emitSignatures:D,latestChangedDtsFile:o};return UB(q);function ee(he){return W(xs(he,i))}function W(he){return Vx(Xm(s,he,e.program.getCanonicalFileName))}function pe(he){let be=m.get(he);return be===void 0&&(u.push(W(he)),m.set(he,be=u.length)),be}function K(he){let be=Is(he.keys(),pe).sort(tc),Ve=be.join(),Pe=x?.get(Ve);return Pe===void 0&&(E=Bt(E,be),(x??(x=new Map)).set(Ve,Pe=E.length)),Pe}function re(he,be){let Ve=e.program.getSourceFile(he);if(!e.program.getFileIncludeReasons().get(Ve.path).some(Be=>Be.kind===0))return;if(!S.length)return S.push(be);let Pe=S[S.length-1],ke=Rs(Pe);if(ke&&Pe[1]===be-1)return Pe[1]=be;if(ke||S.length===1||Pe!==be-1)return S.push(be);let De=S[S.length-2];return!O1(De)||De!==Pe-1?S.push(be):(S[S.length-2]=[De,be],S.length=S.length-1)}function ue(){let he;return d.forEach(be=>{let Ve=e.program.getSourceFileByPath(be);Ve&&be!==Ve.resolvedPath&&(he=Bt(he,[pe(Ve.resolvedPath),pe(be)]))}),he}function ce(he){let be,{optionsNameMap:Ve}=NN();for(let Pe of Ng(he).sort(c_)){let ke=Ve.get(Pe.toLowerCase());ke?.affectsBuildInfo&&((be||(be={}))[Pe]=ne(ke,he[Pe]))}return be}function ne(he,be){if(he){if(M.assert(he.type!=="listOrElement"),he.type==="list"){let Ve=be;if(he.element.isFilePath&&Ve.length)return Ve.map(ee)}else if(he.isFilePath)return ee(be)}return be}function le(){let he;return e.fileInfos.forEach((be,Ve)=>{var Pe;let ke=(Pe=e.semanticDiagnosticsPerFile)==null?void 0:Pe.get(Ve);ke?ke.length&&(he=Bt(he,[pe(Ve),de(ke,Ve)])):e.changedFilesSet.has(Ve)||(he=Bt(he,pe(Ve)))}),he}function me(){var he;let be;if(!((he=e.emitDiagnosticsPerFile)!=null&&he.size))return be;for(let Ve of Is(e.emitDiagnosticsPerFile.keys()).sort(c_)){let Pe=e.emitDiagnosticsPerFile.get(Ve);be=Bt(be,[pe(Ve),de(Pe,Ve)])}return be}function de(he,be){return M.assert(!!he.length),he.map(Ve=>{let Pe=Ae(Ve,be);Pe.reportsUnnecessary=Ve.reportsUnnecessary,Pe.reportDeprecated=Ve.reportsDeprecated,Pe.source=Ve.source,Pe.skippedOn=Ve.skippedOn;let{relatedInformation:ke}=Ve;return Pe.relatedInformation=ke?ke.length?ke.map(De=>Ae(De,be)):[]:void 0,Pe})}function Ae(he,be){let{file:Ve}=he;return{...he,file:Ve?Ve.resolvedPath===be?void 0:W(Ve.resolvedPath):!1,messageText:bs(he.messageText)?he.messageText:xe(he.messageText)}}function xe(he){if(he.repopulateInfo)return{info:he.repopulateInfo(),next:te(he.next)};let be=te(he.next);return be===he.next?he:{...he,next:be}}function te(he){return he&&(kt(he,(be,Ve)=>{let Pe=xe(be);if(be===Pe)return;let ke=Ve>0?he.slice(0,Ve-1):[];ke.push(Pe);for(let De=Ve+1;De<he.length;De++)ke.push(xe(he[De]));return ke})||he)}}var iye=(e=>(e[e.SemanticDiagnosticsBuilderProgram=0]="SemanticDiagnosticsBuilderProgram",e[e.EmitAndSemanticDiagnosticsBuilderProgram=1]="EmitAndSemanticDiagnosticsBuilderProgram",e))(iye||{});function QB(e,t,n,i,s,o){let u,m,d;return e===void 0?(M.assert(t===void 0),u=n,d=i,M.assert(!!d),m=d.getProgram()):Rs(e)?(d=i,m=X8({rootNames:e,options:t,host:n,oldProgram:d&&d.getProgramOrUndefined(),configFileParsingDiagnostics:s,projectReferences:o}),u=n):(m=e,u=t,d=n,s=i),{host:u,newProgram:m,oldProgram:d,configFileParsingDiagnostics:s||ve}}function G8e(e,t){return t?.sourceMapUrlPos!==void 0?e.substring(0,t.sourceMapUrlPos):e}function fX(e,t,n,i,s){var o;n=G8e(n,s);let u;return(o=s?.diagnostics)!=null&&o.length&&(n+=s.diagnostics.map(S=>`${d(S)}${c5[S.category]}${S.code}: ${m(S.messageText)}`).join(`
`)),(i.createHash??nI)(n);function m(S){return bs(S)?S:S===void 0?"":S.next?S.messageText+S.next.map(m).join(`
`):S.messageText}function d(S){return S.file.resolvedPath===t.resolvedPath?`(${S.start},${S.length})`:(u===void 0&&(u=mi(t.resolvedPath)),`${Vx(Xm(u,S.file.resolvedPath,e.getCanonicalFileName))}(${S.start},${S.length})`)}}function sye(e,t,n){return(t.createHash??nI)(G8e(e,n))}function pX(e,{newProgram:t,host:n,oldProgram:i,configFileParsingDiagnostics:s}){let o=i&&i.getState();if(o&&t===o.program&&s===t.getConfigFileParsingDiagnostics())return t=void 0,o=void 0,i;let u=dxt(t,o);t.getBuildInfo=()=>xxt(u),t=void 0,i=void 0,o=void 0;let m=()=>u,d=gX(m,s);return d.getState=m,d.saveEmitState=()=>gxt(u),d.restoreEmitState=L=>hxt(u,L),d.hasChangedEmitSignature=()=>!!u.hasChangedEmitSignature,d.getAllDependencies=L=>lg.getAllDependencies(u,M.checkDefined(u.program),L),d.getSemanticDiagnostics=R,d.emit=D,d.releaseProgram=()=>mxt(u),e===0?d.getSemanticDiagnosticsOfNextAffectedFile=w:e===1?(d.getSemanticDiagnosticsOfNextAffectedFile=w,d.emitNextAffectedFile=E,d.emitBuildInfo=S):_a(),d;function S(L,F){if(u.buildInfoEmitPending){let J=M.checkDefined(u.program).emitBuildInfo(L||ia(n,n.writeFile),F);return u.buildInfoEmitPending=!1,J}return lX}function E(L,F,J,G){var q,ee,W;let pe=z8e(u,F,n),K=cS(u.compilerOptions),re=J?K&24:K;if(!pe)if(u.compilerOptions.outFile){if(!u.programEmitPending||(re=u.programEmitPending,J&&(re=re&24),!re))return;pe=u.program}else{let ne=vxt(u,J);if(!ne){let le=Sxt(u);if(le)return(u.seenEmittedFiles??(u.seenEmittedFiles=new Map)).set(le.affectedFile.resolvedPath,le.seenKind|24),{result:{emitSkipped:!0,diagnostics:le.diagnostics},affected:le.affectedFile};if(!u.buildInfoEmitPending)return;let me=u.program,de=me.emitBuildInfo(L||ia(n,n.writeFile),F);return u.buildInfoEmitPending=!1,{result:de,affected:me}}({affectedFile:pe,emitKind:re}=ne)}let ue;re&7&&(ue=0),re&24&&(ue=ue===void 0?1:void 0),pe===u.program&&(u.programEmitPending=u.changedFilesSet.size?JN(K,re):u.programEmitPending?JN(u.programEmitPending,re):void 0);let ce=u.program.emit(pe===u.program?void 0:pe,x(L,G),F,ue,G);if(pe!==u.program){let ne=pe;u.seenAffectedFiles.add(ne.resolvedPath),u.affectedFilesIndex!==void 0&&u.affectedFilesIndex++,u.buildInfoEmitPending=!0;let le=((q=u.seenEmittedFiles)==null?void 0:q.get(ne.resolvedPath))||0;(u.seenEmittedFiles??(u.seenEmittedFiles=new Map)).set(ne.resolvedPath,re|le);let me=((ee=u.affectedFilesPendingEmit)==null?void 0:ee.get(ne.resolvedPath))||K,de=JN(me,re|le);de?(u.affectedFilesPendingEmit??(u.affectedFilesPendingEmit=new Map)).set(ne.resolvedPath,de):(W=u.affectedFilesPendingEmit)==null||W.delete(ne.resolvedPath),ce.diagnostics.length&&(u.emitDiagnosticsPerFile??(u.emitDiagnosticsPerFile=new Map)).set(ne.resolvedPath,ce.diagnostics)}else u.changedFilesSet.clear();return{result:ce,affected:pe}}function x(L,F){return $p(u.compilerOptions)?(J,G,q,ee,W,pe)=>{var K,re,ue;if(Mu(J))if(u.compilerOptions.outFile){if(u.compilerOptions.composite){let ne=ce(u.outSignature,void 0);if(!ne)return;u.outSignature=ne}}else{M.assert(W?.length===1);let ne;if(!F){let le=W[0],me=u.fileInfos.get(le.resolvedPath);if(me.signature===le.version){let de=fX(u.program,le,G,n,pe);(K=pe?.diagnostics)!=null&&K.length||(ne=de),de!==le.version&&(n.storeSignatureInfo&&(u.signatureInfo??(u.signatureInfo=new Map)).set(le.resolvedPath,1),u.affectedFiles&&((re=u.oldSignatures)==null?void 0:re.get(le.resolvedPath))===void 0&&(u.oldSignatures??(u.oldSignatures=new Map)).set(le.resolvedPath,me.signature||!1),me.signature=de)}}if(u.compilerOptions.composite){let le=W[0].resolvedPath;if(ne=ce((ue=u.emitSignatures)==null?void 0:ue.get(le),ne),!ne)return;(u.emitSignatures??(u.emitSignatures=new Map)).set(le,ne)}}L?L(J,G,q,ee,W,pe):n.writeFile?n.writeFile(J,G,q,ee,W,pe):u.program.writeFile(J,G,q,ee,W,pe);function ce(ne,le){let me=!ne||bs(ne)?ne:ne[0];if(le??(le=sye(G,n,pe)),le===me){if(ne===me)return;pe?pe.differsOnlyInMap=!0:pe={differsOnlyInMap:!0}}else u.hasChangedEmitSignature=!0,u.latestChangedDtsFile=J;return le}}:L||ia(n,n.writeFile)}function D(L,F,J,G,q){e===1&&q8e(u,L);let ee=uX(d,L,F,J);if(ee)return ee;if(!L)if(e===1){let W=[],pe=!1,K,re=[],ue;for(;ue=E(F,J,G,q);)pe=pe||ue.result.emitSkipped,K=wn(K,ue.result.diagnostics),re=wn(re,ue.result.emittedFiles),W=wn(W,ue.result.sourceMaps);return{emitSkipped:pe,diagnostics:K||ve,emittedFiles:re,sourceMaps:W}}else yxt(u,G);return M.checkDefined(u.program).emit(L,x(F,q),J,G,q)}function w(L,F){for(;;){let J=z8e(u,L,n),G;if(J)if(J!==u.program){let q=J;if((!F||!F(q))&&(G=rye(u,q,L)),u.seenAffectedFiles.add(q.resolvedPath),u.affectedFilesIndex++,u.buildInfoEmitPending=!0,!G)continue}else G=u.program.getSemanticDiagnostics(void 0,L),u.changedFilesSet.clear(),u.programEmitPending=cS(u.compilerOptions);else return;return{result:G,affected:J}}}function R(L,F){if(q8e(u,L),M.checkDefined(u.program).getCompilerOptions().outFile)return M.assert(!u.semanticDiagnosticsPerFile),M.checkDefined(u.program).getSemanticDiagnostics(L,F);if(L)return rye(u,L,F);for(;w(F););let G;for(let q of M.checkDefined(u.program).getSourceFiles())G=wn(G,rye(u,q,F));return G||ve}}function dX(e,t,n){var i,s;let o=((i=e.affectedFilesPendingEmit)==null?void 0:i.get(t))||0;(e.affectedFilesPendingEmit??(e.affectedFilesPendingEmit=new Map)).set(t,o|n),(s=e.emitDiagnosticsPerFile)==null||s.delete(t)}function aye(e){return bs(e)?{version:e,signature:e,affectsGlobalScope:void 0,impliedFormat:void 0}:bs(e.signature)?e:{version:e.version,signature:e.signature===!1?void 0:e.version,affectsGlobalScope:e.affectsGlobalScope,impliedFormat:e.impliedFormat}}function oye(e,t){return O1(e)?t:e[1]||8}function cye(e,t){return e||cS(t||{})}function lye(e,t,n){var i,s,o,u;let m=e.program,d=mi(xs(t,n.getCurrentDirectory())),S=l_(n.useCaseSensitiveFileNames()),E,x=(i=m.fileNames)==null?void 0:i.map(R),D,w=m.latestChangedDtsFile?L(m.latestChangedDtsFile):void 0;if(nye(m)){let W=new Map;m.fileInfos.forEach((pe,K)=>{let re=F(K+1);W.set(re,bs(pe)?{version:pe,signature:void 0,affectsGlobalScope:void 0,impliedFormat:void 0}:pe)}),E={fileInfos:W,compilerOptions:m.options?lB(m.options,L):{},latestChangedDtsFile:w,outSignature:m.outSignature,programEmitPending:m.pendingEmit===void 0?void 0:cye(m.pendingEmit,m.options)}}else{D=(s=m.fileIdsList)==null?void 0:s.map(ue=>new Set(ue.map(F)));let W=new Map,pe=(o=m.options)!=null&&o.composite&&!m.options.outFile?new Map:void 0;m.fileInfos.forEach((ue,ce)=>{let ne=F(ce+1),le=aye(ue);W.set(ne,le),pe&&le.signature&&pe.set(ne,le.signature)}),(u=m.emitSignatures)==null||u.forEach(ue=>{if(O1(ue))pe.delete(F(ue));else{let ce=F(ue[0]);pe.set(ce,!bs(ue[1])&&!ue[1].length?[pe.get(ce)]:ue[1])}});let K=new Set(Cr(m.changeFileSet,F)),re=m.affectedFilesPendingEmit?cS(m.options||{}):void 0;E={fileInfos:W,compilerOptions:m.options?lB(m.options,L):{},referencedMap:G(m.referencedMap,m.options??{}),semanticDiagnosticsPerFile:q(m.semanticDiagnosticsPerFile,W,K),emitDiagnosticsPerFile:ee(m.emitDiagnosticsPerFile),hasReusableDiagnostic:!0,affectedFilesPendingEmit:m.affectedFilesPendingEmit&&xP(m.affectedFilesPendingEmit,ue=>F(O1(ue)?ue:ue[0]),ue=>oye(ue,re)),changedFilesSet:K,latestChangedDtsFile:w,emitSignatures:pe?.size?pe:void 0}}return{getState:()=>E,saveEmitState:io,restoreEmitState:io,getProgram:_a,getProgramOrUndefined:VT,releaseProgram:io,getCompilerOptions:()=>E.compilerOptions,getSourceFile:_a,getSourceFiles:_a,getOptionsDiagnostics:_a,getGlobalDiagnostics:_a,getConfigFileParsingDiagnostics:_a,getSyntacticDiagnostics:_a,getDeclarationDiagnostics:_a,getSemanticDiagnostics:_a,emit:_a,getAllDependencies:_a,getCurrentDirectory:_a,emitNextAffectedFile:_a,getSemanticDiagnosticsOfNextAffectedFile:_a,emitBuildInfo:_a,close:io,hasChangedEmitSignature:Dg};function R(W){return rc(W,d,S)}function L(W){return xs(W,d)}function F(W){return x[W-1]}function J(W){return D[W-1]}function G(W,pe){let K=lg.createReferencedMap(pe);return!K||!W||W.forEach(([re,ue])=>K.set(F(re),J(ue))),K}function q(W,pe,K){let re=new Map(Up(pe.keys(),ue=>K.has(ue)?void 0:[ue,ve]));return W?.forEach(ue=>{O1(ue)?re.delete(F(ue)):re.set(F(ue[0]),ue[1])}),re.size?re:void 0}function ee(W){return W&&xP(W,pe=>F(pe[0]),pe=>pe[1])}}function mX(e,t,n){let i=mi(xs(t,n.getCurrentDirectory())),s=l_(n.useCaseSensitiveFileNames()),o=new Map,u=0,m=new Map,d=new Map(e.resolvedRoot);return e.fileInfos.forEach((E,x)=>{let D=rc(e.fileNames[x],i,s),w=bs(E)?E:E.version;if(o.set(D,w),u<e.root.length){let R=e.root[u],L=x+1;Rs(R)?R[0]<=L&&L<=R[1]&&(S(L,D),R[1]===L&&u++):R===L&&(S(L,D),u++)}}),{fileInfos:o,roots:m};function S(E,x){let D=d.get(E);D?m.set(rc(e.fileNames[D-1],i,s),x):m.set(x,void 0)}}function gX(e,t){return{getState:_a,saveEmitState:io,restoreEmitState:io,getProgram:n,getProgramOrUndefined:()=>e().program,releaseProgram:()=>e().program=void 0,getCompilerOptions:()=>e().compilerOptions,getSourceFile:i=>n().getSourceFile(i),getSourceFiles:()=>n().getSourceFiles(),getOptionsDiagnostics:i=>n().getOptionsDiagnostics(i),getGlobalDiagnostics:i=>n().getGlobalDiagnostics(i),getConfigFileParsingDiagnostics:()=>t,getSyntacticDiagnostics:(i,s)=>n().getSyntacticDiagnostics(i,s),getDeclarationDiagnostics:(i,s)=>n().getDeclarationDiagnostics(i,s),getSemanticDiagnostics:(i,s)=>n().getSemanticDiagnostics(i,s),emit:(i,s,o,u,m)=>n().emit(i,s,o,u,m),emitBuildInfo:(i,s)=>n().emitBuildInfo(i,s),getAllDependencies:_a,getCurrentDirectory:()=>n().getCurrentDirectory(),close:io};function n(){return M.checkDefined(e().program)}}function Y8e(e,t,n,i,s,o){return pX(0,QB(e,t,n,i,s,o))}function hX(e,t,n,i,s,o){return pX(1,QB(e,t,n,i,s,o))}function K8e(e,t,n,i,s,o){let{newProgram:u,configFileParsingDiagnostics:m}=QB(e,t,n,i,s,o);return gX(()=>({program:u,compilerOptions:u.getCompilerOptions()}),m)}function ZB(e){return Wc(e,"/node_modules/.staging")?AP(e,"/.staging"):Pt(_5,t=>e.includes(t))?void 0:e}function uye(e,t){if(t<=1)return 1;let n=1,i=e[0].search(/[a-zA-Z]:/)===0;if(e[0]!==Ec&&!i&&e[1].search(/[a-zA-Z]\$$/)===0){if(t===2)return 2;n=2,i=!0}return i&&!e[n].match(/^users$/i)?n:e[n].match(/^workspaces$/i)?n+1:n+2}function eU(e,t){if(t===void 0&&(t=e.length),t<=2)return!1;let n=uye(e,t);return t>n+1}function _ye(e){return Q8e(mi(e))}function X8e(e,t){if(t.length<t.length)return!1;for(let n=0;n<e.length;n++)if(t[n]!==e[n])return!1;return!0}function Q8e(e){return eU(hu(e))}function fye(e){return Q8e(e)}function yX(e,t,n,i,s,o){let u=hu(t);e=ip(e)?Zs(e):xs(e,o());let m=hu(e),d=uye(u,u.length);if(u.length<=d+1)return;let S=u.indexOf("node_modules");if(S!==-1&&S+1<=d+1)return;let E=u.lastIndexOf("node_modules");return X8e(s,u)?u.length>s.length+1?pye(m,u,Math.max(s.length+1,d+1),E):{dir:n,dirPath:i,nonRecursive:!0}:Z8e(m,u,u.length-1,d,S,s,E)}function Z8e(e,t,n,i,s,o,u){if(s!==-1)return pye(e,t,s+1,u);let m=!0,d=n;for(let S=0;S<n;S++)if(t[S]!==o[S]){m=!1,d=Math.max(S+1,i+1);break}return pye(e,t,d,u,m)}function pye(e,t,n,i,s){let o;return i!==-1&&i+1>=n&&i+2<t.length&&(_s(t[i+1],"@")?i+3<t.length&&(o=i+3):o=i+2),{dir:u0(e,n),dirPath:u0(t,n),nonRecursive:s,packageDir:o!==void 0?u0(e,o):void 0,packageDirPath:o!==void 0?u0(t,o):void 0}}function dye(e,t,n,i,s,o){let u=hu(t);if(X8e(i,u))return n;e=ip(e)?Zs(e):xs(e,s());let m=Z8e(hu(e),u,u.length,uye(u,u.length),u.indexOf("node_modules"),i,u.lastIndexOf("node_modules"));return m&&o(m.dirPath)?m.dirPath:void 0}function mye(e,t){let n=xs(e,t());return p$(n)?n:ZS(n)}function eMe(e){return e.split(Ec).length-(hv(e)?1:0)}function tU(e){var t;return((t=e.getCompilerHost)==null?void 0:t.call(e))||e}function gye(e,t,n,i,s){return{nameAndMode:rX,resolve:(o,u)=>Cxt(i,s,o,e,n,t,u)}}function Cxt(e,t,n,i,s,o,u){let m=tU(e),d=QA(n,i,s,m,t,o,u);if(!e.getGlobalCache)return d;let S=e.getGlobalCache();if(S!==void 0&&!vu(n)&&!(d.resolvedModule&&lj(d.resolvedModule.extension))){let{resolvedModule:E,failedLookupLocations:x,affectingLocations:D,resolutionDiagnostics:w}=Ege(M.checkDefined(e.globalCacheResolutionModuleName)(n),e.projectName,s,m,S,t);if(E)return d.resolvedModule=E,d.failedLookupLocations=DN(d.failedLookupLocations,x),d.affectingLocations=DN(d.affectingLocations,D),d.resolutionDiagnostics=DN(d.resolutionDiagnostics,w),d}return d}function vX(e,t,n){let i,s,o,u=yd(),m=new Set,d=new Set,S=new Map,E=new Map,x=!1,D,w,R,L,F,J=!1,G=tf(()=>e.getCurrentDirectory()),q=e.getCachedDirectoryStructureHost(),ee=new Map,W=IN(G(),e.getCanonicalFileName,e.getCompilationSettings()),pe=new Map,K=yB(G(),e.getCanonicalFileName,e.getCompilationSettings(),W.getPackageJsonInfoCache(),W.optionsToRedirectsKey),re=new Map,ue=IN(G(),e.getCanonicalFileName,rK(e.getCompilationSettings()),W.getPackageJsonInfoCache()),ce=new Map,ne=new Map,le=mye(t,G),me=e.toPath(le),de=hu(me),Ae=new Map,xe=new Map,te=new Map,he=new Map;return{rootDirForResolution:t,resolvedModuleNames:ee,resolvedTypeReferenceDirectives:pe,resolvedLibraries:re,resolvedFileToResolution:S,resolutionsWithFailedLookups:m,resolutionsWithOnlyAffectingLocations:d,directoryWatchesOfFailedLookups:ce,fileWatchesOfAffectingLocations:ne,packageDirWatchers:xe,dirPathToSymlinkPackageRefCount:te,watchFailedLookupLocationsOfExternalModuleResolutions:Zr,getModuleResolutionCache:()=>W,startRecordingFilesWithChangedResolutions:De,finishRecordingFilesWithChangedResolutions:Be,startCachingPerDirectoryResolution:et,finishCachingPerDirectoryResolution:_t,resolveModuleNameLiterals:xr,resolveTypeReferenceDirectiveReferences:vr,resolveLibrary:jr,resolveSingleModuleNameWithoutWatching:ur,removeResolutionsFromProjectReferenceRedirects:Ui,removeResolutionsOfFile:la,hasChangedAutomaticTypeDirectiveNames:()=>x,invalidateResolutionOfFile:yr,invalidateResolutionsOfFailedLookupLocations:fe,setFilesWithInvalidatedNonRelativeUnresolvedImports:to,createHasInvalidatedResolutions:qe,isFileWithInvalidatedNonRelativeUnresolvedImports:ct,updateTypeRootsWatch:ft,closeTypeRootsWatch:Me,clear:Pe,onChangesAffectModuleResolution:ke};function be(Oe){return Oe.resolvedModule}function Ve(Oe){return Oe.resolvedTypeReferenceDirective}function Pe(){Vf(ce,Nd),Vf(ne,Nd),Ae.clear(),xe.clear(),te.clear(),u.clear(),Me(),ee.clear(),pe.clear(),S.clear(),m.clear(),d.clear(),R=void 0,L=void 0,F=void 0,w=void 0,D=void 0,J=!1,W.clear(),K.clear(),W.update(e.getCompilationSettings()),K.update(e.getCompilationSettings()),ue.clear(),E.clear(),re.clear(),x=!1}function ke(){J=!0,W.clearAllExceptPackageJsonInfoCache(),K.clearAllExceptPackageJsonInfoCache(),W.update(e.getCompilationSettings()),K.update(e.getCompilationSettings())}function De(){i=[]}function Be(){let Oe=i;return i=void 0,Oe}function ct(Oe){if(!o)return!1;let At=o.get(Oe);return!!At&&!!At.length}function qe(Oe,At){fe();let Nt=s;return s=void 0,{hasInvalidatedResolutions:Ut=>Oe(Ut)||J||!!Nt?.has(Ut)||ct(Ut),hasInvalidatedLibResolutions:Ut=>{var Rt;return At(Ut)||!!((Rt=re?.get(Ut))!=null&&Rt.isInvalidated)}}}function et(){W.isReadonly=void 0,K.isReadonly=void 0,ue.isReadonly=void 0,W.getPackageJsonInfoCache().isReadonly=void 0,W.clearAllExceptPackageJsonInfoCache(),K.clearAllExceptPackageJsonInfoCache(),ue.clearAllExceptPackageJsonInfoCache(),u.forEach(Ii),u.clear(),Ae.clear()}function Ie(Oe){re.forEach((At,Nt)=>{var Ut;(Ut=Oe?.resolvedLibReferences)!=null&&Ut.has(Nt)||(Vr(At,e.toPath(GB(e.getCompilationSettings(),G(),Nt)),be),re.delete(Nt))})}function _t(Oe,At){o=void 0,J=!1,u.forEach(Ii),u.clear(),Oe!==At&&(Ie(Oe),Oe?.getSourceFiles().forEach(Nt=>{var Ut;let Rt=Uf(Nt)?((Ut=Nt.packageJsonLocations)==null?void 0:Ut.length)??0:0,nr=E.get(Nt.resolvedPath)??ve;for(let Z=nr.length;Z<Rt;Z++)Cs(Nt.packageJsonLocations[Z],!1);if(nr.length>Rt)for(let Z=Rt;Z<nr.length;Z++)ne.get(nr[Z]).files--;Rt?E.set(Nt.resolvedPath,Nt.packageJsonLocations):E.delete(Nt.resolvedPath)}),E.forEach((Nt,Ut)=>{let Rt=Oe?.getSourceFileByPath(Ut);(!Rt||Rt.resolvedPath!==Ut)&&(Nt.forEach(nr=>ne.get(nr).files--),E.delete(Ut))})),ce.forEach(Xe),ne.forEach(ht),xe.forEach(mt),x=!1,W.isReadonly=!0,K.isReadonly=!0,ue.isReadonly=!0,W.getPackageJsonInfoCache().isReadonly=!0,Ae.clear()}function mt(Oe,At){Oe.dirPathToWatcher.size===0&&xe.delete(At)}function Xe(Oe,At){Oe.refCount===0&&(ce.delete(At),Oe.watcher.close())}function ht(Oe,At){var Nt;Oe.files===0&&Oe.resolutions===0&&!((Nt=Oe.symlinks)!=null&&Nt.size)&&(ne.delete(At),Oe.watcher.close())}function rr({entries:Oe,containingFile:At,containingSourceFile:Nt,redirectedReference:Ut,options:Rt,perFileCache:nr,reusedNames:Z,loader:Ge,getResolutionWithResolvedFileName:bt,deferWatchingNonRelativeResolution:Q,shouldRetryResolution:Ke,logChanges:z}){let Ue=e.toPath(At),Te=nr.get(Ue)||nr.set(Ue,wN()).get(Ue),Re=[],It=z&&ct(Ue),$t=e.getCurrentProgram(),Ht=$t&&$t.getResolvedProjectReferenceToRedirect(At),dr=Ht?!Ut||Ut.sourceFile.path!==Ht.sourceFile.path:!!Ut,qr=wN();for(let dn of Oe){let Ar=Ge.nameAndMode.getName(dn),In=Ge.nameAndMode.getMode(dn,Nt,Ut?.commandLine.options||Rt),Ki=Te.get(Ar,In);if(!qr.has(Ar,In)&&(J||dr||!Ki||Ki.isInvalidated||It&&!vu(Ar)&&Ke(Ki))){let ls=Ki;Ki=Ge.resolve(Ar,In),e.onDiscoveredSymlink&&Axt(Ki)&&e.onDiscoveredSymlink(),Te.set(Ar,In,Ki),Ki!==ls&&(Zr(Ar,Ki,Ue,bt,Q),ls&&Vr(ls,Ue,bt)),z&&i&&!Hr(ls,Ki)&&(i.push(Ue),z=!1)}else{let ls=tU(e);if(P0(Rt,ls)&&!qr.has(Ar,In)){let Yn=bt(Ki);ds(ls,nr===ee?Yn?.resolvedFileName?Yn.packageId?v.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3:v.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2:v.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved:Yn?.resolvedFileName?Yn.packageId?v.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3:v.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2:v.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved,Ar,At,Yn?.resolvedFileName,Yn?.packageId&&J1(Yn.packageId))}}M.assert(Ki!==void 0&&!Ki.isInvalidated),qr.set(Ar,In,!0),Re.push(Ki)}return Z?.forEach(dn=>qr.set(Ge.nameAndMode.getName(dn),Ge.nameAndMode.getMode(dn,Nt,Ut?.commandLine.options||Rt),!0)),Te.size()!==qr.size()&&Te.forEach((dn,Ar,In)=>{qr.has(Ar,In)||(Vr(dn,Ue,bt),Te.delete(Ar,In))}),Re;function Hr(dn,Ar){if(dn===Ar)return!0;if(!dn||!Ar)return!1;let In=bt(dn),Ki=bt(Ar);return In===Ki?!0:!In||!Ki?!1:In.resolvedFileName===Ki.resolvedFileName}}function vr(Oe,At,Nt,Ut,Rt,nr){return rr({entries:Oe,containingFile:At,containingSourceFile:Rt,redirectedReference:Nt,options:Ut,reusedNames:nr,perFileCache:pe,loader:$B(At,Nt,Ut,tU(e),K),getResolutionWithResolvedFileName:Ve,shouldRetryResolution:Z=>Z.resolvedTypeReferenceDirective===void 0,deferWatchingNonRelativeResolution:!1})}function xr(Oe,At,Nt,Ut,Rt,nr){return rr({entries:Oe,containingFile:At,containingSourceFile:Rt,redirectedReference:Nt,options:Ut,reusedNames:nr,perFileCache:ee,loader:gye(At,Nt,Ut,e,W),getResolutionWithResolvedFileName:be,shouldRetryResolution:Z=>!Z.resolvedModule||!oO(Z.resolvedModule.extension),logChanges:n,deferWatchingNonRelativeResolution:!0})}function jr(Oe,At,Nt,Ut){let Rt=tU(e),nr=re?.get(Ut);if(!nr||nr.isInvalidated){let Z=nr;nr=vB(Oe,At,Nt,Rt,ue);let Ge=e.toPath(At);Zr(Oe,nr,Ge,be,!1),re.set(Ut,nr),Z&&Vr(Z,Ge,be)}else if(P0(Nt,Rt)){let Z=be(nr);ds(Rt,Z?.resolvedFileName?Z.packageId?v.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3:v.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2:v.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved,Oe,At,Z?.resolvedFileName,Z?.packageId&&J1(Z.packageId))}return nr}function ur(Oe,At){var Nt,Ut;let Rt=e.toPath(At),nr=ee.get(Rt),Z=nr?.get(Oe,void 0);if(Z&&!Z.isInvalidated)return Z;let Ge=(Nt=e.beforeResolveSingleModuleNameWithoutWatching)==null?void 0:Nt.call(e,W),bt=tU(e),Q=QA(Oe,At,e.getCompilationSettings(),bt,W);return(Ut=e.afterResolveSingleModuleNameWithoutWatching)==null||Ut.call(e,W,Oe,At,Q,Ge),Q}function or(Oe){return Wc(Oe,"/node_modules/@types")}function Zr(Oe,At,Nt,Ut,Rt){var nr;if(At.refCount)At.refCount++,M.assertIsDefined(At.files);else{At.refCount=1,M.assert(!((nr=At.files)!=null&&nr.size)),!Rt||vu(Oe)?Sr(At):u.add(Oe,At);let Z=Ut(At);if(Z&&Z.resolvedFileName){let Ge=e.toPath(Z.resolvedFileName),bt=S.get(Ge);bt||S.set(Ge,bt=new Set),bt.add(At)}}(At.files??(At.files=new Set)).add(Nt)}function Oi(Oe,At){let Nt=e.toPath(Oe),Ut=yX(Oe,Nt,le,me,de,G);if(Ut){let{dir:Rt,dirPath:nr,nonRecursive:Z,packageDir:Ge,packageDirPath:bt}=Ut;nr===me?(M.assert(Z),M.assert(!Ge),At=!0):Xs(Rt,nr,Ge,bt,Z)}return At}function Sr(Oe){M.assert(!!Oe.refCount);let{failedLookupLocations:At,affectingLocations:Nt,alternateResult:Ut}=Oe;if(!At?.length&&!Nt?.length&&!Ut)return;(At?.length||Ut)&&m.add(Oe);let Rt=!1;if(At)for(let nr of At)Rt=Oi(nr,Rt);Ut&&(Rt=Oi(Ut,Rt)),Rt&&Xs(le,me,void 0,void 0,!0),Pi(Oe,!At?.length&&!Ut)}function Pi(Oe,At){M.assert(!!Oe.refCount);let{affectingLocations:Nt}=Oe;if(Nt?.length){At&&d.add(Oe);for(let Ut of Nt)Cs(Ut,!0)}}function Cs(Oe,At){let Nt=ne.get(Oe);if(Nt){At?Nt.resolutions++:Nt.files++;return}let Ut=Oe,Rt=!1,nr;e.realpath&&(Ut=e.realpath(Oe),Oe!==Ut&&(Rt=!0,nr=ne.get(Ut)));let Z=At?1:0,Ge=At?0:1;if(!Rt||!nr){let bt={watcher:fye(e.toPath(Ut))?e.watchAffectingFileLocation(Ut,(Q,Ke)=>{q?.addOrDeleteFile(Q,e.toPath(Ut),Ke),ss(Ut,W.getPackageJsonInfoCache().getInternalMap()),e.scheduleInvalidateResolutionsOfFailedLookupLocations()}):l6,resolutions:Rt?0:Z,files:Rt?0:Ge,symlinks:void 0};ne.set(Ut,bt),Rt&&(nr=bt)}if(Rt){M.assert(!!nr);let bt={watcher:{close:()=>{var Q;let Ke=ne.get(Ut);(Q=Ke?.symlinks)!=null&&Q.delete(Oe)&&!Ke.symlinks.size&&!Ke.resolutions&&!Ke.files&&(ne.delete(Ut),Ke.watcher.close())}},resolutions:Z,files:Ge,symlinks:void 0};ne.set(Oe,bt),(nr.symlinks??(nr.symlinks=new Set)).add(Oe)}}function ss(Oe,At){var Nt;let Ut=ne.get(Oe);Ut?.resolutions&&(w??(w=new Set)).add(Oe),Ut?.files&&(D??(D=new Set)).add(Oe),(Nt=Ut?.symlinks)==null||Nt.forEach(Rt=>ss(Rt,At)),At?.delete(e.toPath(Oe))}function Ii(Oe,At){let Nt=e.getCurrentProgram();!Nt||!Nt.getTypeChecker().tryFindAmbientModuleWithoutAugmentations(At)?Oe.forEach(Sr):Oe.forEach(Ut=>Pi(Ut,!0))}function $r(Oe,At,Nt,Ut,Rt){M.assert(!Rt);let nr=Ae.get(Ut),Z=xe.get(Ut);if(nr===void 0){let Q=e.realpath(Nt);nr=Q!==Nt&&e.toPath(Q)!==Ut,Ae.set(Ut,nr),Z?Z.isSymlink!==nr&&(Z.dirPathToWatcher.forEach(Ke=>{An(Z.isSymlink?Ut:At,!1),Ke.watcher=bt()}),Z.isSymlink=nr):xe.set(Ut,Z={dirPathToWatcher:new Map,isSymlink:nr})}else M.assertIsDefined(Z),M.assert(nr===Z.isSymlink);let Ge=Z.dirPathToWatcher.get(At);Ge?Ge.refCount++:(Z.dirPathToWatcher.set(At,{watcher:bt(),refCount:1}),nr&&te.set(At,(te.get(At)??0)+1));function bt(){return nr?$e(Nt,Ut,Rt):$e(Oe,At,Rt)}}function Xs(Oe,At,Nt,Ut,Rt){!Ut||!e.realpath?$e(Oe,At,Rt):$r(Oe,At,Nt,Ut,Rt)}function $e(Oe,At,Nt){let Ut=ce.get(At);return Ut?(M.assert(!!Nt==!!Ut.nonRecursive),Ut.refCount++):ce.set(At,Ut={watcher:vi(Oe,At,Nt),refCount:1,nonRecursive:Nt}),Ut}function Yt(Oe,At,Nt){let Ut=e.toPath(Oe),Rt=yX(Oe,Ut,le,me,de,G);if(Rt){let{dirPath:nr,packageDirPath:Z}=Rt;if(nr===me)At=!0;else if(Z&&e.realpath){let Ge=xe.get(Z),bt=Ge.dirPathToWatcher.get(nr);if(bt.refCount--,bt.refCount===0){if(An(Ge.isSymlink?Z:nr,Nt),Ge.dirPathToWatcher.delete(nr),Ge.isSymlink){let Q=te.get(nr)-1;Q===0?te.delete(nr):te.set(nr,Q)}Nt&&mt(Ge,Z)}}else An(nr,Nt)}return At}function Vr(Oe,At,Nt,Ut){if(M.checkDefined(Oe.files).delete(At),Oe.refCount--,Oe.refCount)return;let Rt=Nt(Oe);if(Rt&&Rt.resolvedFileName){let bt=e.toPath(Rt.resolvedFileName),Q=S.get(bt);Q?.delete(Oe)&&!Q.size&&S.delete(bt)}let{failedLookupLocations:nr,affectingLocations:Z,alternateResult:Ge}=Oe;if(m.delete(Oe)){let bt=!1;if(nr)for(let Q of nr)bt=Yt(Q,bt,Ut);Ge&&(bt=Yt(Ge,bt,Ut)),bt&&An(me,Ut)}else Z?.length&&d.delete(Oe);if(Z)for(let bt of Z){let Q=ne.get(bt);Q.resolutions--,Ut&&ht(Q,bt)}}function An(Oe,At){let Nt=ce.get(Oe);Nt.refCount--,At&&Xe(Nt,Oe)}function vi(Oe,At,Nt){return e.watchDirectoryOfFailedLookupLocation(Oe,Ut=>{let Rt=e.toPath(Ut);q&&q.addOrDeleteFileOrDirectory(Ut,Rt),lt(Rt,At===Rt)},Nt?0:1)}function Ci(Oe,At,Nt,Ut){let Rt=Oe.get(At);Rt&&(Rt.forEach(nr=>Vr(nr,At,Nt,Ut)),Oe.delete(At))}function Ui(Oe){if(!Ic(Oe,".json"))return;let At=e.getCurrentProgram();if(!At)return;let Nt=At.getResolvedProjectReferenceByPath(Oe);Nt&&Nt.commandLine.fileNames.forEach(Ut=>la(e.toPath(Ut)))}function la(Oe,At){Ci(ee,Oe,be,At),Ci(pe,Oe,Ve,At)}function Gs(Oe,At){if(!Oe)return!1;let Nt=!1;return Oe.forEach(Ut=>{if(!(Ut.isInvalidated||!At(Ut))){Ut.isInvalidated=Nt=!0;for(let Rt of M.checkDefined(Ut.files))(s??(s=new Set)).add(Rt),x=x||Wc(Rt,o6)}}),Nt}function yr(Oe){la(Oe);let At=x;Gs(S.get(Oe),YS)&&x&&!At&&e.onChangedAutomaticTypeDirectiveNames()}function to(Oe){M.assert(o===Oe||o===void 0),o=Oe}function lt(Oe,At){if(At)(F||(F=new Set)).add(Oe);else{let Nt=ZB(Oe);if(!Nt||(Oe=Nt,e.fileIsOpen(Oe)))return!1;let Ut=mi(Oe);if(or(Oe)||d5(Oe)||or(Ut)||d5(Ut))(R||(R=new Set)).add(Oe),(L||(L=new Set)).add(Oe);else{if(Bhe(e.getCurrentProgram(),Oe)||Ic(Oe,".map"))return!1;(R||(R=new Set)).add(Oe);let Rt=O8(Oe,!0);Rt&&(L||(L=new Set)).add(Rt)}}e.scheduleInvalidateResolutionsOfFailedLookupLocations()}function St(){let Oe=W.getPackageJsonInfoCache().getInternalMap();Oe&&(R||L||F)&&Oe.forEach((At,Nt)=>Ce(Nt)?Oe.delete(Nt):void 0)}function fe(){var Oe;if(J)return D=void 0,St(),(R||L||F||w)&&Gs(re,vt),R=void 0,L=void 0,F=void 0,w=void 0,!0;let At=!1;return D&&((Oe=e.getCurrentProgram())==null||Oe.getSourceFiles().forEach(Nt=>{Pt(Nt.packageJsonLocations,Ut=>D.has(Ut))&&((s??(s=new Set)).add(Nt.path),At=!0)}),D=void 0),!R&&!L&&!F&&!w||(At=Gs(m,vt)||At,St(),R=void 0,L=void 0,F=void 0,At=Gs(d,nt)||At,w=void 0),At}function vt(Oe){var At;return nt(Oe)?!0:!R&&!L&&!F?!1:((At=Oe.failedLookupLocations)==null?void 0:At.some(Nt=>Ce(e.toPath(Nt))))||!!Oe.alternateResult&&Ce(e.toPath(Oe.alternateResult))}function Ce(Oe){return R?.has(Oe)||qo(L?.keys()||[],At=>_s(Oe,At)?!0:void 0)||qo(F?.keys()||[],At=>Oe.length>At.length&&_s(Oe,At)&&(p$(At)||Oe[At.length]===Ec)?!0:void 0)}function nt(Oe){var At;return!!w&&((At=Oe.affectingLocations)==null?void 0:At.some(Nt=>w.has(Nt)))}function Me(){Vf(he,Dm)}function tt(Oe){return tr(Oe)?e.watchTypeRootsDirectory(Oe,At=>{let Nt=e.toPath(At);q&&q.addOrDeleteFileOrDirectory(At,Nt),x=!0,e.onChangedAutomaticTypeDirectiveNames();let Ut=dye(Oe,e.toPath(Oe),me,de,G,Rt=>ce.has(Rt)||te.has(Rt));Ut&&lt(Nt,Ut===Nt)},1):l6}function ft(){let Oe=e.getCompilationSettings();if(Oe.types){Me();return}let At=zO(Oe,{getCurrentDirectory:G});At?tO(he,new Set(At),{createNewValue:tt,onDeleteValue:Dm}):Me()}function tr(Oe){return e.getCompilationSettings().typeRoots?!0:_ye(e.toPath(Oe))}}function Axt(e){var t,n;return!!((t=e.resolvedModule)!=null&&t.originalPath||(n=e.resolvedTypeReferenceDirective)!=null&&n.originalPath)}var tMe=lu?{getCurrentDirectory:()=>lu.getCurrentDirectory(),getNewLine:()=>lu.newLine,getCanonicalFileName:l_(lu.useCaseSensitiveFileNames)}:void 0;function rk(e,t){let n=e===lu&&tMe?tMe:{getCurrentDirectory:()=>e.getCurrentDirectory(),getNewLine:()=>e.newLine,getCanonicalFileName:l_(e.useCaseSensitiveFileNames)};if(!t)return s=>e.write(XK(s,n));let i=new Array(1);return s=>{i[0]=s,e.write($he(i,n)+n.getNewLine()),i[0]=void 0}}function rMe(e,t,n){return e.clearScreen&&!n.preserveWatchOutput&&!n.extendedDiagnostics&&!n.diagnostics&&Es(SX,t.code)?(e.clearScreen(),!0):!1}var SX=[v.Starting_compilation_in_watch_mode.code,v.File_change_detected_Starting_incremental_compilation.code];function kxt(e,t){return Es(SX,e.code)?t+t:t}function Z8(e){return e.now?e.now().toLocaleTimeString("en-US",{timeZone:"UTC"}).replace("\u202F"," "):new Date().toLocaleTimeString()}function bX(e,t){return t?(n,i,s)=>{rMe(e,n,s);let o=`[${AE(Z8(e),"\x1B[90m")}] `;o+=`${Zg(n.messageText,e.newLine)}${i+i}`,e.write(o)}:(n,i,s)=>{let o="";rMe(e,n,s)||(o+=i),o+=`${Z8(e)} - `,o+=`${Zg(n.messageText,e.newLine)}${kxt(n,i)}`,e.write(o)}}function hye(e,t,n,i,s,o){let u=s;u.onUnRecoverableConfigFileDiagnostic=d=>sMe(s,o,d);let m=k8(e,t,u,n,i);return u.onUnRecoverableConfigFileDiagnostic=void 0,m}function rU(e){return vy(e,t=>t.category===1)}function nU(e){return Zn(e,n=>n.category===1).map(n=>{if(n.file!==void 0)return`${n.file.fileName}`}).map(n=>{if(n===void 0)return;let i=Ln(e,s=>s.file!==void 0&&s.file.fileName===n);if(i!==void 0){let{line:s}=ba(i.file,i.start);return{fileName:n,line:s+1}}})}function TX(e){return e===1?v.Found_1_error_Watching_for_file_changes:v.Found_0_errors_Watching_for_file_changes}function nMe(e,t){let n=AE(":"+e.line,"\x1B[90m");return iI(e.fileName)&&iI(t)?Xm(t,e.fileName,!1)+n:e.fileName+n}function EX(e,t,n,i){if(e===0)return"";let s=t.filter(E=>E!==void 0),o=s.map(E=>`${E.fileName}:${E.line}`).filter((E,x,D)=>D.indexOf(E)===x),u=s[0]&&nMe(s[0],i.getCurrentDirectory()),m;e===1?m=t[0]!==void 0?[v.Found_1_error_in_0,u]:[v.Found_1_error]:m=o.length===0?[v.Found_0_errors,e]:o.length===1?[v.Found_0_errors_in_the_same_file_starting_at_Colon_1,e,u]:[v.Found_0_errors_in_1_files,e,o.length];let d=Nc(...m),S=o.length>1?Pxt(s,i):"";return`${n}${Zg(d.messageText,n)}${n}${n}${S}`}function Pxt(e,t){let n=e.filter((x,D,w)=>D===w.findIndex(R=>R?.fileName===x?.fileName));if(n.length===0)return"";let i=x=>Math.log(x)*Math.LOG10E+1,s=n.map(x=>[x,vy(e,D=>D.fileName===x.fileName)]),o=s.reduce((x,D)=>Math.max(x,D[1]||0),0),u=v.Errors_Files.message,m=u.split(" ")[0].length,d=Math.max(m,i(o)),S=Math.max(i(o)-m,0),E="";return E+=" ".repeat(S)+u+`
`,s.forEach(x=>{let[D,w]=x,R=Math.log(w)*Math.LOG10E+1|0,L=R<d?" ".repeat(d-R):"",F=nMe(D,t.getCurrentDirectory());E+=`${L}${w}  ${F}
`}),E}function yye(e){return!!e.getState}function xX(e,t){let n=e.getCompilerOptions();n.explainFiles?CX(yye(e)?e.getProgram():e,t):(n.listFiles||n.listFilesOnly)&&kt(e.getSourceFiles(),i=>{t(i.fileName)})}function CX(e,t){var n,i;let s=e.getFileIncludeReasons(),o=u=>sI(u,e.getCurrentDirectory(),e.getCanonicalFileName);for(let u of e.getSourceFiles())t(`${qN(u,o)}`),(n=s.get(u.path))==null||n.forEach(m=>t(`  ${NX(e,m,o).messageText}`)),(i=AX(u,o))==null||i.forEach(m=>t(`  ${m.messageText}`))}function AX(e,t){var n;let i;if(e.path!==e.resolvedPath&&(i??(i=[])).push(js(void 0,v.File_is_output_of_project_reference_source_0,qN(e.originalFileName,t))),e.redirectInfo&&(i??(i=[])).push(js(void 0,v.File_redirects_to_file_0,qN(e.redirectInfo.redirectTarget,t))),Uf(e))switch(e.impliedNodeFormat){case 99:e.packageJsonScope&&(i??(i=[])).push(js(void 0,v.File_is_ECMAScript_module_because_0_has_field_type_with_value_module,qN(Va(e.packageJsonLocations),t)));break;case 1:e.packageJsonScope?(i??(i=[])).push(js(void 0,e.packageJsonScope.contents.packageJsonContent.type?v.File_is_CommonJS_module_because_0_has_field_type_whose_value_is_not_module:v.File_is_CommonJS_module_because_0_does_not_have_field_type,qN(Va(e.packageJsonLocations),t))):(n=e.packageJsonLocations)!=null&&n.length&&(i??(i=[])).push(js(void 0,v.File_is_CommonJS_module_because_package_json_was_not_found));break}return i}function kX(e,t){var n;let i=e.getCompilerOptions().configFile;if(!((n=i?.configFileSpecs)!=null&&n.validatedFilesSpec))return;let s=e.getCanonicalFileName(t),o=mi(xs(i.fileName,e.getCurrentDirectory())),u=Bo(i.configFileSpecs.validatedFilesSpec,m=>e.getCanonicalFileName(xs(m,o))===s);return u!==-1?i.configFileSpecs.validatedFilesSpecBeforeSubstitution[u]:void 0}function PX(e,t){var n,i;let s=e.getCompilerOptions().configFile;if(!((n=s?.configFileSpecs)!=null&&n.validatedIncludeSpecs))return;if(s.configFileSpecs.isDefaultIncludeSpec)return!0;let o=Ic(t,".json"),u=mi(xs(s.fileName,e.getCurrentDirectory())),m=e.useCaseSensitiveFileNames(),d=Bo((i=s?.configFileSpecs)==null?void 0:i.validatedIncludeSpecs,S=>{if(o&&!Wc(S,".json"))return!1;let E=ype(S,u,"files");return!!E&&G1(`(${E})$`,m).test(t)});return d!==-1?s.configFileSpecs.validatedIncludeSpecsBeforeSubstitution[d]:void 0}function NX(e,t,n){var i,s;let o=e.getCompilerOptions();if(Ib(t)){let u=c6(e,t),m=UN(u)?u.file.text.substring(u.pos,u.end):`"${u.text}"`,d;switch(M.assert(UN(u)||t.kind===3,"Only synthetic references are imports"),t.kind){case 3:UN(u)?d=u.packageId?v.Imported_via_0_from_file_1_with_packageId_2:v.Imported_via_0_from_file_1:u.text===ab?d=u.packageId?v.Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions:v.Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions:d=u.packageId?v.Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions:v.Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions;break;case 4:M.assert(!u.packageId),d=v.Referenced_via_0_from_file_1;break;case 5:d=u.packageId?v.Type_library_referenced_via_0_from_file_1_with_packageId_2:v.Type_library_referenced_via_0_from_file_1;break;case 7:M.assert(!u.packageId),d=v.Library_referenced_via_0_from_file_1;break;default:M.assertNever(t)}return js(void 0,d,m,qN(u.file,n),u.packageId&&J1(u.packageId))}switch(t.kind){case 0:if(!((i=o.configFile)!=null&&i.configFileSpecs))return js(void 0,v.Root_file_specified_for_compilation);let u=xs(e.getRootFileNames()[t.index],e.getCurrentDirectory());if(kX(e,u))return js(void 0,v.Part_of_files_list_in_tsconfig_json);let d=PX(e,u);return bs(d)?js(void 0,v.Matched_by_include_pattern_0_in_1,d,qN(o.configFile,n)):js(void 0,d?v.Matched_by_default_include_pattern_Asterisk_Asterisk_Slash_Asterisk:v.Root_file_specified_for_compilation);case 1:case 2:let S=t.kind===2,E=M.checkDefined((s=e.getResolvedProjectReferences())==null?void 0:s[t.index]);return js(void 0,o.outFile?S?v.Output_from_referenced_project_0_included_because_1_specified:v.Source_from_referenced_project_0_included_because_1_specified:S?v.Output_from_referenced_project_0_included_because_module_is_specified_as_none:v.Source_from_referenced_project_0_included_because_module_is_specified_as_none,qN(E.sourceFile.fileName,n),o.outFile?"--outFile":"--out");case 8:{let x=o.types?t.packageId?[v.Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1,t.typeReference,J1(t.packageId)]:[v.Entry_point_of_type_library_0_specified_in_compilerOptions,t.typeReference]:t.packageId?[v.Entry_point_for_implicit_type_library_0_with_packageId_1,t.typeReference,J1(t.packageId)]:[v.Entry_point_for_implicit_type_library_0,t.typeReference];return js(void 0,...x)}case 6:{if(t.index!==void 0)return js(void 0,v.Library_0_specified_in_compilerOptions,o.lib[t.index]);let x=Y9(Ka(o)),D=x?[v.Default_library_for_target_0,x]:[v.Default_library];return js(void 0,...D)}default:M.assertNever(t)}}function qN(e,t){let n=bs(e)?e:e.fileName;return t?t(n):n}function iU(e,t,n,i,s,o,u,m){let d=!!e.getCompilerOptions().listFilesOnly,S=e.getConfigFileParsingDiagnostics().slice(),E=S.length;wn(S,e.getSyntacticDiagnostics(void 0,o)),S.length===E&&(wn(S,e.getOptionsDiagnostics(o)),d||(wn(S,e.getGlobalDiagnostics(o)),S.length===E&&wn(S,e.getSemanticDiagnostics(void 0,o))));let x=d?{emitSkipped:!0,diagnostics:ve}:e.emit(void 0,s,o,u,m),{emittedFiles:D,diagnostics:w}=x;wn(S,w);let R=wP(S);if(R.forEach(t),n){let L=e.getCurrentDirectory();kt(D,F=>{let J=xs(F,L);n(`TSFILE: ${J}`)}),xX(e,n)}return i&&i(rU(R),nU(R)),{emitResult:x,diagnostics:R}}function DX(e,t,n,i,s,o,u,m){let{emitResult:d,diagnostics:S}=iU(e,t,n,i,s,o,u,m);return d.emitSkipped&&S.length>0?1:S.length>0?2:0}var l6={close:io},u6=()=>l6;function wX(e=lu,t){return{onWatchStatusChange:t||bX(e),watchFile:ia(e,e.watchFile)||u6,watchDirectory:ia(e,e.watchDirectory)||u6,setTimeout:ia(e,e.setTimeout)||io,clearTimeout:ia(e,e.clearTimeout)||io}}var Tu={ConfigFile:"Config file",ExtendedConfigFile:"Extended config file",SourceFile:"Source file",MissingFile:"Missing file",WildcardDirectory:"Wild card directory",FailedLookupLocations:"Failed Lookup Locations",AffectingFileLocation:"File location affecting resolution",TypeRoots:"Type roots",ConfigFileOfReferencedProject:"Config file of referened project",ExtendedConfigOfReferencedProject:"Extended config file of referenced project",WildcardDirectoryOfReferencedProject:"Wild card directory of referenced project",PackageJson:"package.json file",ClosedScriptInfo:"Closed Script info",ConfigFileForInferredRoot:"Config file for the inferred project root",NodeModules:"node_modules for closed script infos and package.jsons affecting module specifier cache",MissingSourceMapFile:"Missing source map file",NoopConfigFileForInferredRoot:"Noop Config file for the inferred project root",MissingGeneratedFile:"Missing generated file",NodeModulesForModuleSpecifierCache:"node_modules for module specifier cache invalidation",TypingInstallerLocationFile:"File location for typing installer",TypingInstallerLocationDirectory:"Directory location for typing installer"};function IX(e,t){let n=e.trace?t.extendedDiagnostics?2:t.diagnostics?1:0:0,i=n!==0?o=>e.trace(o):io,s=$K(e,n,i);return s.writeLog=i,s}function OX(e,t,n=e){let i=e.useCaseSensitiveFileNames(),s={getSourceFile:YK((o,u)=>u?e.readFile(o,u):s.readFile(o),void 0),getDefaultLibLocation:ia(e,e.getDefaultLibLocation),getDefaultLibFileName:o=>e.getDefaultLibFileName(o),writeFile:KK((o,u,m)=>e.writeFile(o,u,m),o=>e.createDirectory(o),o=>e.directoryExists(o)),getCurrentDirectory:tf(()=>e.getCurrentDirectory()),useCaseSensitiveFileNames:()=>i,getCanonicalFileName:l_(i),getNewLine:()=>wv(t()),fileExists:o=>e.fileExists(o),readFile:o=>e.readFile(o),trace:ia(e,e.trace),directoryExists:ia(n,n.directoryExists),getDirectories:ia(n,n.getDirectories),realpath:ia(e,e.realpath),getEnvironmentVariable:ia(e,e.getEnvironmentVariable)||(()=>""),createHash:ia(e,e.createHash),readDirectory:ia(e,e.readDirectory),storeSignatureInfo:e.storeSignatureInfo,jsDocParsingMode:e.jsDocParsingMode};return s}function sU(e,t){if(t.match(Bge)){let n=t.length,i=n;for(let s=n-1;s>=0;s--){let o=t.charCodeAt(s);switch(o){case 10:s&&t.charCodeAt(s-1)===13&&s--;case 13:break;default:if(o<127||!v_(o)){i=s;continue}break}let u=t.substring(i,n);if(u.match(SK)){t=t.substring(0,i);break}else if(!u.match(bK))break;n=i}}return(e.createHash||nI)(t)}function aU(e){let t=e.getSourceFile;e.getSourceFile=(...n)=>{let i=t.call(e,...n);return i&&(i.version=sU(e,i.text)),i}}function RX(e,t){let n=tf(()=>mi(Zs(e.getExecutingFilePath())));return{useCaseSensitiveFileNames:()=>e.useCaseSensitiveFileNames,getNewLine:()=>e.newLine,getCurrentDirectory:tf(()=>e.getCurrentDirectory()),getDefaultLibLocation:n,getDefaultLibFileName:i=>ri(n(),k3(i)),fileExists:i=>e.fileExists(i),readFile:(i,s)=>e.readFile(i,s),directoryExists:i=>e.directoryExists(i),getDirectories:i=>e.getDirectories(i),readDirectory:(i,s,o,u,m)=>e.readDirectory(i,s,o,u,m),realpath:ia(e,e.realpath),getEnvironmentVariable:ia(e,e.getEnvironmentVariable),trace:i=>e.write(i+e.newLine),createDirectory:i=>e.createDirectory(i),writeFile:(i,s,o)=>e.writeFile(i,s,o),createHash:ia(e,e.createHash),createProgram:t||hX,storeSignatureInfo:e.storeSignatureInfo,now:ia(e,e.now)}}function iMe(e=lu,t,n,i){let s=u=>e.write(u+e.newLine),o=RX(e,t);return OW(o,wX(e,i)),o.afterProgramCreate=u=>{let m=u.getCompilerOptions(),d=wv(m);iU(u,n,s,S=>o.onWatchStatusChange(Nc(TX(S),S),d,m,S))},o}function sMe(e,t,n){t(n),e.exit(1)}function MX({configFileName:e,optionsToExtend:t,watchOptionsToExtend:n,extraFileExtensions:i,system:s,createProgram:o,reportDiagnostic:u,reportWatchStatus:m}){let d=u||rk(s),S=iMe(s,o,d,m);return S.onUnRecoverableConfigFileDiagnostic=E=>sMe(s,d,E),S.configFileName=e,S.optionsToExtend=t,S.watchOptionsToExtend=n,S.extraFileExtensions=i,S}function LX({rootFiles:e,options:t,watchOptions:n,projectReferences:i,system:s,createProgram:o,reportDiagnostic:u,reportWatchStatus:m}){let d=iMe(s,o,u||rk(s),m);return d.rootFiles=e,d.options=t,d.watchOptions=n,d.projectReferences=i,d}function vye(e){let t=e.system||lu,n=e.host||(e.host=cU(e.options,t)),i=Sye(e),s=DX(i,e.reportDiagnostic||rk(t),o=>n.trace&&n.trace(o),e.reportErrorSummary||e.options.pretty?(o,u)=>t.write(EX(o,u,t.newLine,n)):void 0);return e.afterProgramEmitAndDiagnostics&&e.afterProgramEmitAndDiagnostics(i),s}function oU(e,t){let n=jv(e);if(!n)return;let i;if(t.getBuildInfo)i=t.getBuildInfo(n,e.configFilePath);else{let s=t.readFile(n);if(!s)return;i=qK(n,s)}if(!(!i||i.version!==se||!i.program))return lye(i,n,t)}function cU(e,t=lu){let n=WB(e,void 0,t);return n.createHash=ia(t,t.createHash),n.storeSignatureInfo=t.storeSignatureInfo,aU(n),a6(n,i=>rc(i,n.getCurrentDirectory(),n.getCanonicalFileName)),n}function Sye({rootNames:e,options:t,configFileParsingDiagnostics:n,projectReferences:i,host:s,createProgram:o}){s=s||cU(t),o=o||hX;let u=oU(t,s);return o(e,t,s,u,n,i)}function aMe(e,t,n,i,s,o,u,m){return Rs(e)?LX({rootFiles:e,options:t,watchOptions:m,projectReferences:u,system:n,createProgram:i,reportDiagnostic:s,reportWatchStatus:o}):MX({configFileName:e,optionsToExtend:t,watchOptionsToExtend:u,extraFileExtensions:m,system:n,createProgram:i,reportDiagnostic:s,reportWatchStatus:o})}function FX(e){let t,n,i,s,o,u,m,d,S=e.extendedConfigCache,E=!1,x=new Map,D,w=!1,R=e.useCaseSensitiveFileNames(),L=e.getCurrentDirectory(),{configFileName:F,optionsToExtend:J={},watchOptionsToExtend:G,extraFileExtensions:q,createProgram:ee}=e,{rootFiles:W,options:pe,watchOptions:K,projectReferences:re}=e,ue,ce,ne=!1,le=!1,me=F===void 0?void 0:JB(e,L,R),de=me||e,Ae=XB(e,de),xe=xr();F&&e.configFileParsingResult&&(Gs(e.configFileParsingResult),xe=xr()),ss(v.Starting_compilation_in_watch_mode),F&&!e.configFileParsingResult&&(xe=wv(J),M.assert(!W),la(),xe=xr()),M.assert(pe),M.assert(W);let{watchFile:te,watchDirectory:he,writeLog:be}=IX(e,pe),Ve=l_(R);be(`Current directory: ${L} CaseSensitiveFileNames: ${R}`);let Pe;F&&(Pe=te(F,Vr,2e3,K,Tu.ConfigFile));let ke=OX(e,()=>pe,de);aU(ke);let De=ke.getSourceFile;ke.getSourceFile=(Oe,...At)=>Oi(Oe,jr(Oe),...At),ke.getSourceFileByPath=Oi,ke.getNewLine=()=>xe,ke.fileExists=Zr,ke.onReleaseOldSourceFile=Cs,ke.onReleaseParsedCommandLine=lt,ke.toPath=jr,ke.getCompilationSettings=()=>pe,ke.useSourceOfProjectReferenceRedirect=ia(e,e.useSourceOfProjectReferenceRedirect),ke.watchDirectoryOfFailedLookupLocation=(Oe,At,Nt)=>he(Oe,At,Nt,K,Tu.FailedLookupLocations),ke.watchAffectingFileLocation=(Oe,At)=>te(Oe,At,2e3,K,Tu.AffectingFileLocation),ke.watchTypeRootsDirectory=(Oe,At,Nt)=>he(Oe,At,Nt,K,Tu.TypeRoots),ke.getCachedDirectoryStructureHost=()=>me,ke.scheduleInvalidateResolutionsOfFailedLookupLocations=Xs,ke.onInvalidatedResolution=Yt,ke.onChangedAutomaticTypeDirectiveNames=Yt,ke.fileIsOpen=Dg,ke.getCurrentProgram=Xe,ke.writeLog=be,ke.getParsedCommandLine=yr;let Be=vX(ke,F?mi(xs(F,L)):L,!1);ke.resolveModuleNameLiterals=ia(e,e.resolveModuleNameLiterals),ke.resolveModuleNames=ia(e,e.resolveModuleNames),!ke.resolveModuleNameLiterals&&!ke.resolveModuleNames&&(ke.resolveModuleNameLiterals=Be.resolveModuleNameLiterals.bind(Be)),ke.resolveTypeReferenceDirectiveReferences=ia(e,e.resolveTypeReferenceDirectiveReferences),ke.resolveTypeReferenceDirectives=ia(e,e.resolveTypeReferenceDirectives),!ke.resolveTypeReferenceDirectiveReferences&&!ke.resolveTypeReferenceDirectives&&(ke.resolveTypeReferenceDirectiveReferences=Be.resolveTypeReferenceDirectiveReferences.bind(Be)),ke.resolveLibrary=e.resolveLibrary?e.resolveLibrary.bind(e):Be.resolveLibrary.bind(Be),ke.getModuleResolutionCache=e.resolveModuleNameLiterals||e.resolveModuleNames?ia(e,e.getModuleResolutionCache):()=>Be.getModuleResolutionCache();let qe=!!e.resolveModuleNameLiterals||!!e.resolveTypeReferenceDirectiveReferences||!!e.resolveModuleNames||!!e.resolveTypeReferenceDirectives?ia(e,e.hasInvalidatedResolutions)||YS:Dg,et=e.resolveLibrary?ia(e,e.hasInvalidatedLibResolutions)||YS:Dg;return t=oU(pe,ke),ht(),Me(),F&&ft(jr(F),pe,K,Tu.ExtendedConfigFile),F?{getCurrentProgram:mt,getProgram:vi,close:Ie,getResolutionCache:_t}:{getCurrentProgram:mt,getProgram:vi,updateRootFileNames:vr,close:Ie,getResolutionCache:_t};function Ie(){$r(),Be.clear(),Vf(x,Oe=>{Oe&&Oe.fileWatcher&&(Oe.fileWatcher.close(),Oe.fileWatcher=void 0)}),Pe&&(Pe.close(),Pe=void 0),S?.clear(),S=void 0,d&&(Vf(d,Nd),d=void 0),s&&(Vf(s,Nd),s=void 0),i&&(Vf(i,Dm),i=void 0),m&&(Vf(m,Oe=>{var At;(At=Oe.watcher)==null||At.close(),Oe.watcher=void 0,Oe.watchedDirectories&&Vf(Oe.watchedDirectories,Nd),Oe.watchedDirectories=void 0}),m=void 0),t=void 0}function _t(){return Be}function mt(){return t}function Xe(){return t&&t.getProgramOrUndefined()}function ht(){be("Synchronizing program"),M.assert(pe),M.assert(W),$r();let Oe=mt();w&&(xe=xr(),Oe&&U5(Oe.getCompilerOptions(),pe)&&Be.onChangesAffectModuleResolution());let{hasInvalidatedResolutions:At,hasInvalidatedLibResolutions:Nt}=Be.createHasInvalidatedResolutions(qe,et),{originalReadFile:Ut,originalFileExists:Rt,originalDirectoryExists:nr,originalCreateDirectory:Z,originalWriteFile:Ge,readFileWithCache:bt}=a6(ke,jr);return oX(Xe(),W,pe,Q=>Pi(Q,bt),Q=>ke.fileExists(Q),At,Nt,Ii,yr,re)?le&&(E&&ss(v.File_change_detected_Starting_incremental_compilation),t=ee(void 0,void 0,ke,t,ce,re),le=!1):(E&&ss(v.File_change_detected_Starting_incremental_compilation),rr(At,Nt)),E=!1,e.afterProgramCreate&&Oe!==t&&e.afterProgramCreate(t),ke.readFile=Ut,ke.fileExists=Rt,ke.directoryExists=nr,ke.createDirectory=Z,ke.writeFile=Ge,t}function rr(Oe,At){be("CreatingProgramWith::"),be(`  roots: ${JSON.stringify(W)}`),be(`  options: ${JSON.stringify(pe)}`),re&&be(`  projectReferences: ${JSON.stringify(re)}`);let Nt=w||!Xe();w=!1,le=!1,Be.startCachingPerDirectoryResolution(),ke.hasInvalidatedResolutions=Oe,ke.hasInvalidatedLibResolutions=At,ke.hasChangedAutomaticTypeDirectiveNames=Ii;let Ut=Xe();if(t=ee(W,pe,ke,t,ce,re),Be.finishCachingPerDirectoryResolution(t.getProgram(),Ut),WK(t.getProgram(),i||(i=new Map),Ce),Nt&&Be.updateTypeRootsWatch(),D){for(let Rt of D)i.has(Rt)||x.delete(Rt);D=void 0}}function vr(Oe){M.assert(!F,"Cannot update root file names with config file watch mode"),W=Oe,Yt()}function xr(){return wv(pe||J)}function jr(Oe){return rc(Oe,L,Ve)}function ur(Oe){return typeof Oe=="boolean"}function or(Oe){return typeof Oe.version=="boolean"}function Zr(Oe){let At=jr(Oe);return ur(x.get(At))?!1:de.fileExists(Oe)}function Oi(Oe,At,Nt,Ut,Rt){let nr=x.get(At);if(ur(nr))return;let Z=typeof Nt=="object"?Nt.impliedNodeFormat:void 0;if(nr===void 0||Rt||or(nr)||nr.sourceFile.impliedNodeFormat!==Z){let Ge=De(Oe,Nt,Ut);if(nr)Ge?(nr.sourceFile=Ge,nr.version=Ge.version,nr.fileWatcher||(nr.fileWatcher=St(At,Oe,fe,250,K,Tu.SourceFile))):(nr.fileWatcher&&nr.fileWatcher.close(),x.set(At,!1));else if(Ge){let bt=St(At,Oe,fe,250,K,Tu.SourceFile);x.set(At,{sourceFile:Ge,version:Ge.version,fileWatcher:bt})}else x.set(At,!1);return Ge}return nr.sourceFile}function Sr(Oe){let At=x.get(Oe);At!==void 0&&(ur(At)?x.set(Oe,{version:!1}):At.version=!1)}function Pi(Oe,At){let Nt=x.get(Oe);if(!Nt)return;if(Nt.version)return Nt.version;let Ut=At(Oe);return Ut!==void 0?sU(ke,Ut):void 0}function Cs(Oe,At,Nt){let Ut=x.get(Oe.resolvedPath);Ut!==void 0&&(ur(Ut)?(D||(D=[])).push(Oe.path):Ut.sourceFile===Oe&&(Ut.fileWatcher&&Ut.fileWatcher.close(),x.delete(Oe.resolvedPath),Nt||Be.removeResolutionsOfFile(Oe.path)))}function ss(Oe){e.onWatchStatusChange&&e.onWatchStatusChange(Nc(Oe),xe,pe||J)}function Ii(){return Be.hasChangedAutomaticTypeDirectiveNames()}function $r(){return u?(e.clearTimeout(u),u=void 0,!0):!1}function Xs(){if(!e.setTimeout||!e.clearTimeout)return Be.invalidateResolutionsOfFailedLookupLocations();let Oe=$r();be(`Scheduling invalidateFailedLookup${Oe?", Cancelled earlier one":""}`),u=e.setTimeout($e,250,"timerToInvalidateFailedLookupResolutions")}function $e(){u=void 0,Be.invalidateResolutionsOfFailedLookupLocations()&&Yt()}function Yt(){!e.setTimeout||!e.clearTimeout||(o&&e.clearTimeout(o),be("Scheduling update"),o=e.setTimeout(An,250,"timerToUpdateProgram"))}function Vr(){M.assert(!!F),n=2,Yt()}function An(){o=void 0,E=!0,vi()}function vi(){var Oe,At,Nt,Ut;switch(n){case 1:(Oe=rf)==null||Oe.logStartUpdateProgram("PartialConfigReload"),Ci();break;case 2:(At=rf)==null||At.logStartUpdateProgram("FullConfigReload"),Ui();break;default:(Nt=rf)==null||Nt.logStartUpdateProgram("SynchronizeProgram"),ht();break}return(Ut=rf)==null||Ut.logStopUpdateProgram("Done"),mt()}function Ci(){be("Reloading new file names and options"),M.assert(pe),M.assert(F),n=0,W=JO(pe.configFile.configFileSpecs,xs(mi(F),L),pe,Ae,q),fB(W,xs(F,L),pe.configFile.configFileSpecs,ce,ne)&&(le=!0),ht()}function Ui(){M.assert(F),be(`Reloading config file: ${F}`),n=0,me&&me.clearCache(),la(),w=!0,ht(),Me(),ft(jr(F),pe,K,Tu.ExtendedConfigFile)}function la(){M.assert(F),Gs(k8(F,J,Ae,S||(S=new Map),G,q))}function Gs(Oe){W=Oe.fileNames,pe=Oe.options,K=Oe.watchOptions,re=Oe.projectReferences,ue=Oe.wildcardDirectories,ce=kE(Oe).slice(),ne=VO(Oe.raw),le=!0}function yr(Oe){let At=jr(Oe),Nt=m?.get(At);if(Nt){if(!Nt.updateLevel)return Nt.parsedCommandLine;if(Nt.parsedCommandLine&&Nt.updateLevel===1&&!e.getParsedCommandLine){be("Reloading new file names and options"),M.assert(pe);let Rt=JO(Nt.parsedCommandLine.options.configFile.configFileSpecs,xs(mi(Oe),L),pe,Ae);return Nt.parsedCommandLine={...Nt.parsedCommandLine,fileNames:Rt},Nt.updateLevel=void 0,Nt.parsedCommandLine}}be(`Loading config file: ${Oe}`);let Ut=e.getParsedCommandLine?e.getParsedCommandLine(Oe):to(Oe);return Nt?(Nt.parsedCommandLine=Ut,Nt.updateLevel=void 0):(m||(m=new Map)).set(At,Nt={parsedCommandLine:Ut}),tr(Oe,At,Nt),Ut}function to(Oe){let At=Ae.onUnRecoverableConfigFileDiagnostic;Ae.onUnRecoverableConfigFileDiagnostic=io;let Nt=k8(Oe,void 0,Ae,S||(S=new Map),G);return Ae.onUnRecoverableConfigFileDiagnostic=At,Nt}function lt(Oe){var At;let Nt=jr(Oe),Ut=m?.get(Nt);Ut&&(m.delete(Nt),Ut.watchedDirectories&&Vf(Ut.watchedDirectories,Nd),(At=Ut.watcher)==null||At.close(),zK(Nt,d))}function St(Oe,At,Nt,Ut,Rt,nr){return te(At,(Z,Ge)=>Nt(Z,Ge,Oe),Ut,Rt,nr)}function fe(Oe,At,Nt){vt(Oe,Nt,At),At===2&&x.has(Nt)&&Be.invalidateResolutionOfFile(Nt),Sr(Nt),Yt()}function vt(Oe,At,Nt){me&&me.addOrDeleteFile(Oe,At,Nt)}function Ce(Oe,At){return m?.has(Oe)?l6:St(Oe,At,nt,500,K,Tu.MissingFile)}function nt(Oe,At,Nt){vt(Oe,Nt,At),At===0&&i.has(Nt)&&(i.get(Nt).close(),i.delete(Nt),Sr(Nt),Yt())}function Me(){W8(s||(s=new Map),ue,tt)}function tt(Oe,At){return he(Oe,Nt=>{M.assert(F),M.assert(pe);let Ut=jr(Nt);me&&me.addOrDeleteFileOrDirectory(Nt,Ut),Sr(Ut),!$8({watchedDirPath:jr(Oe),fileOrDirectory:Nt,fileOrDirectoryPath:Ut,configFileName:F,extraFileExtensions:q,options:pe,program:mt()||W,currentDirectory:L,useCaseSensitiveFileNames:R,writeLog:be,toPath:jr})&&n!==2&&(n=1,Yt())},At,K,Tu.WildcardDirectory)}function ft(Oe,At,Nt,Ut){qB(Oe,At,d||(d=new Map),(Rt,nr)=>te(Rt,(Z,Ge)=>{var bt;vt(Rt,nr,Ge),S&&zB(S,nr,jr);let Q=(bt=d.get(nr))==null?void 0:bt.projects;Q?.size&&Q.forEach(Ke=>{if(F&&jr(F)===Ke)n=2;else{let z=m?.get(Ke);z&&(z.updateLevel=2),Be.removeResolutionsFromProjectReferenceRedirects(Ke)}Yt()})},2e3,Nt,Ut),jr)}function tr(Oe,At,Nt){var Ut,Rt,nr,Z;Nt.watcher||(Nt.watcher=te(Oe,(Ge,bt)=>{vt(Oe,At,bt);let Q=m?.get(At);Q&&(Q.updateLevel=2),Be.removeResolutionsFromProjectReferenceRedirects(At),Yt()},2e3,((Ut=Nt.parsedCommandLine)==null?void 0:Ut.watchOptions)||K,Tu.ConfigFileOfReferencedProject)),W8(Nt.watchedDirectories||(Nt.watchedDirectories=new Map),(Rt=Nt.parsedCommandLine)==null?void 0:Rt.wildcardDirectories,(Ge,bt)=>{var Q;return he(Ge,Ke=>{let z=jr(Ke);me&&me.addOrDeleteFileOrDirectory(Ke,z),Sr(z);let Ue=m?.get(At);Ue?.parsedCommandLine&&($8({watchedDirPath:jr(Ge),fileOrDirectory:Ke,fileOrDirectoryPath:z,configFileName:Oe,options:Ue.parsedCommandLine.options,program:Ue.parsedCommandLine.fileNames,currentDirectory:L,useCaseSensitiveFileNames:R,writeLog:be,toPath:jr})||Ue.updateLevel!==2&&(Ue.updateLevel=1,Yt()))},bt,((Q=Nt.parsedCommandLine)==null?void 0:Q.watchOptions)||K,Tu.WildcardDirectoryOfReferencedProject)}),ft(At,(nr=Nt.parsedCommandLine)==null?void 0:nr.options,((Z=Nt.parsedCommandLine)==null?void 0:Z.watchOptions)||K,Tu.ExtendedConfigOfReferencedProject)}}var bye=(e=>(e[e.Unbuildable=0]="Unbuildable",e[e.UpToDate=1]="UpToDate",e[e.UpToDateWithUpstreamTypes=2]="UpToDateWithUpstreamTypes",e[e.OutputMissing=3]="OutputMissing",e[e.ErrorReadingFile=4]="ErrorReadingFile",e[e.OutOfDateWithSelf=5]="OutOfDateWithSelf",e[e.OutOfDateWithUpstream=6]="OutOfDateWithUpstream",e[e.OutOfDateBuildInfo=7]="OutOfDateBuildInfo",e[e.OutOfDateOptions=8]="OutOfDateOptions",e[e.OutOfDateRoots=9]="OutOfDateRoots",e[e.UpstreamOutOfDate=10]="UpstreamOutOfDate",e[e.UpstreamBlocked=11]="UpstreamBlocked",e[e.ComputingUpstream=12]="ComputingUpstream",e[e.TsVersionOutputOfDate=13]="TsVersionOutputOfDate",e[e.UpToDateWithInputFileText=14]="UpToDateWithInputFileText",e[e.ContainerOnly=15]="ContainerOnly",e[e.ForceBuild=16]="ForceBuild",e))(bye||{});function jX(e){return Ic(e,".json")?e:ri(e,"tsconfig.json")}var Nxt=new Date(-864e13),Dxt=new Date(864e13);function wxt(e,t,n){let i=e.get(t),s;return i||(s=n(),e.set(t,s)),i||s}function Tye(e,t){return wxt(e,t,()=>new Map)}function eM(e){return e.now?e.now():new Date}function nk(e){return!!e&&!!e.buildOrder}function tM(e){return nk(e)?e.buildOrder:e}function lU(e,t){return n=>{let i=t?`[${AE(Z8(e),"\x1B[90m")}] `:`${Z8(e)} - `;i+=`${Zg(n.messageText,e.newLine)}${e.newLine+e.newLine}`,e.write(i)}}function oMe(e,t,n,i){let s=RX(e,t);return s.getModifiedTime=e.getModifiedTime?o=>e.getModifiedTime(o):VT,s.setModifiedTime=e.setModifiedTime?(o,u)=>e.setModifiedTime(o,u):io,s.deleteFile=e.deleteFile?o=>e.deleteFile(o):io,s.reportDiagnostic=n||rk(e),s.reportSolutionBuilderStatus=i||lU(e),s.now=ia(e,e.now),s}function Eye(e=lu,t,n,i,s){let o=oMe(e,t,n,i);return o.reportErrorSummary=s,o}function xye(e=lu,t,n,i,s){let o=oMe(e,t,n,i),u=wX(e,s);return OW(o,u),o}function Ixt(e){let t={};return tB.forEach(n=>{Ho(e,n.name)&&(t[n.name]=e[n.name])}),t}function Cye(e,t,n){return DMe(!1,e,t,n)}function Aye(e,t,n,i){return DMe(!0,e,t,n,i)}function Oxt(e,t,n,i,s){let o=t,u=t,m=Ixt(i),d=OX(o,()=>L.projectCompilerOptions);aU(d),d.getParsedCommandLine=F=>zN(L,F,$h(L,F)),d.resolveModuleNameLiterals=ia(o,o.resolveModuleNameLiterals),d.resolveTypeReferenceDirectiveReferences=ia(o,o.resolveTypeReferenceDirectiveReferences),d.resolveLibrary=ia(o,o.resolveLibrary),d.resolveModuleNames=ia(o,o.resolveModuleNames),d.resolveTypeReferenceDirectives=ia(o,o.resolveTypeReferenceDirectives),d.getModuleResolutionCache=ia(o,o.getModuleResolutionCache);let S,E;!d.resolveModuleNameLiterals&&!d.resolveModuleNames&&(S=IN(d.getCurrentDirectory(),d.getCanonicalFileName),d.resolveModuleNameLiterals=(F,J,G,q,ee)=>Y8(F,J,G,q,ee,o,S,nX),d.getModuleResolutionCache=()=>S),!d.resolveTypeReferenceDirectiveReferences&&!d.resolveTypeReferenceDirectives&&(E=yB(d.getCurrentDirectory(),d.getCanonicalFileName,void 0,S?.getPackageJsonInfoCache(),S?.optionsToRedirectsKey),d.resolveTypeReferenceDirectiveReferences=(F,J,G,q,ee)=>Y8(F,J,G,q,ee,o,E,$B));let x;d.resolveLibrary||(x=IN(d.getCurrentDirectory(),d.getCanonicalFileName,void 0,S?.getPackageJsonInfoCache()),d.resolveLibrary=(F,J,G)=>vB(F,J,G,o,x)),d.getBuildInfo=(F,J)=>bMe(L,F,$h(L,J),void 0);let{watchFile:D,watchDirectory:w,writeLog:R}=IX(u,i),L={host:o,hostWithWatch:u,parseConfigFileHost:XB(o),write:ia(o,o.trace),options:i,baseCompilerOptions:m,rootNames:n,baseWatchOptions:s,resolvedConfigFilePaths:new Map,configFileCache:new Map,projectStatus:new Map,extendedConfigCache:new Map,buildInfoCache:new Map,outputTimeStamps:new Map,builderPrograms:new Map,diagnostics:new Map,projectPendingBuild:new Map,projectErrorsReported:new Map,compilerHost:d,moduleResolutionCache:S,typeReferenceDirectiveResolutionCache:E,libraryResolutionCache:x,buildOrder:void 0,readFileWithCache:F=>o.readFile(F),projectCompilerOptions:m,cache:void 0,allProjectBuildPending:!0,needsSummary:!0,watchAllProjectsPending:e,watch:e,allWatchedWildcardDirectories:new Map,allWatchedInputFiles:new Map,allWatchedConfigFiles:new Map,allWatchedExtendedConfigFiles:new Map,allWatchedPackageJsonFiles:new Map,filesWatched:new Map,lastCachedPackageJsonLookups:new Map,timerToBuildInvalidatedProject:void 0,reportFileChangeDetected:!1,watchFile:D,watchDirectory:w,writeLog:R};return L}function Im(e,t){return rc(t,e.compilerHost.getCurrentDirectory(),e.compilerHost.getCanonicalFileName)}function $h(e,t){let{resolvedConfigFilePaths:n}=e,i=n.get(t);if(i!==void 0)return i;let s=Im(e,t);return n.set(t,s),s}function cMe(e){return!!e.options}function Rxt(e,t){let n=e.configFileCache.get(t);return n&&cMe(n)?n:void 0}function zN(e,t,n){let{configFileCache:i}=e,s=i.get(n);if(s)return cMe(s)?s:void 0;jc("SolutionBuilder::beforeConfigFileParsing");let o,{parseConfigFileHost:u,baseCompilerOptions:m,baseWatchOptions:d,extendedConfigCache:S,host:E}=e,x;return E.getParsedCommandLine?(x=E.getParsedCommandLine(t),x||(o=Nc(v.File_0_not_found,t))):(u.onUnRecoverableConfigFileDiagnostic=D=>o=D,x=k8(t,m,u,S,d),u.onUnRecoverableConfigFileDiagnostic=io),i.set(n,x||o),jc("SolutionBuilder::afterConfigFileParsing"),vd("SolutionBuilder::Config file parsing","SolutionBuilder::beforeConfigFileParsing","SolutionBuilder::afterConfigFileParsing"),x}function rM(e,t){return jX(QS(e.compilerHost.getCurrentDirectory(),t))}function lMe(e,t){let n=new Map,i=new Map,s=[],o,u;for(let d of t)m(d);return u?{buildOrder:o||ve,circularDiagnostics:u}:o||ve;function m(d,S){let E=$h(e,d);if(i.has(E))return;if(n.has(E)){S||(u||(u=[])).push(Nc(v.Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0,s.join(`\r
`)));return}n.set(E,!0),s.push(d);let x=zN(e,d,E);if(x&&x.projectReferences)for(let D of x.projectReferences){let w=rM(e,D.path);m(w,S||D.circular)}s.pop(),i.set(E,!0),(o||(o=[])).push(d)}}function uU(e){return e.buildOrder||Mxt(e)}function Mxt(e){let t=lMe(e,e.rootNames.map(s=>rM(e,s)));e.resolvedConfigFilePaths.clear();let n=new Set(tM(t).map(s=>$h(e,s))),i={onDeleteValue:io};return Dy(e.configFileCache,n,i),Dy(e.projectStatus,n,i),Dy(e.builderPrograms,n,i),Dy(e.diagnostics,n,i),Dy(e.projectPendingBuild,n,i),Dy(e.projectErrorsReported,n,i),Dy(e.buildInfoCache,n,i),Dy(e.outputTimeStamps,n,i),Dy(e.lastCachedPackageJsonLookups,n,i),e.watch&&(Dy(e.allWatchedConfigFiles,n,{onDeleteValue:Dm}),e.allWatchedExtendedConfigFiles.forEach(s=>{s.projects.forEach(o=>{n.has(o)||s.projects.delete(o)}),s.close()}),Dy(e.allWatchedWildcardDirectories,n,{onDeleteValue:s=>s.forEach(Nd)}),Dy(e.allWatchedInputFiles,n,{onDeleteValue:s=>s.forEach(Dm)}),Dy(e.allWatchedPackageJsonFiles,n,{onDeleteValue:s=>s.forEach(Dm)})),e.buildOrder=t}function uMe(e,t,n){let i=t&&rM(e,t),s=uU(e);if(nk(s))return s;if(i){let u=$h(e,i);if(Bo(s,d=>$h(e,d)===u)===-1)return}let o=i?lMe(e,[i]):s;return M.assert(!nk(o)),M.assert(!n||i!==void 0),M.assert(!n||o[o.length-1]===i),n?o.slice(0,o.length-1):o}function _Me(e){e.cache&&kye(e);let{compilerHost:t,host:n}=e,i=e.readFileWithCache,s=t.getSourceFile,{originalReadFile:o,originalFileExists:u,originalDirectoryExists:m,originalCreateDirectory:d,originalWriteFile:S,getSourceFileWithCache:E,readFileWithCache:x}=a6(n,D=>Im(e,D),(...D)=>s.call(t,...D));e.readFileWithCache=x,t.getSourceFile=E,e.cache={originalReadFile:o,originalFileExists:u,originalDirectoryExists:m,originalCreateDirectory:d,originalWriteFile:S,originalReadFileWithCache:i,originalGetSourceFile:s}}function kye(e){if(!e.cache)return;let{cache:t,host:n,compilerHost:i,extendedConfigCache:s,moduleResolutionCache:o,typeReferenceDirectiveResolutionCache:u,libraryResolutionCache:m}=e;n.readFile=t.originalReadFile,n.fileExists=t.originalFileExists,n.directoryExists=t.originalDirectoryExists,n.createDirectory=t.originalCreateDirectory,n.writeFile=t.originalWriteFile,i.getSourceFile=t.originalGetSourceFile,e.readFileWithCache=t.originalReadFileWithCache,s.clear(),o?.clear(),u?.clear(),m?.clear(),e.cache=void 0}function fMe(e,t){e.projectStatus.delete(t),e.diagnostics.delete(t)}function pMe({projectPendingBuild:e},t,n){let i=e.get(t);(i===void 0||i<n)&&e.set(t,n)}function dMe(e,t){if(!e.allProjectBuildPending)return;e.allProjectBuildPending=!1,e.options.watch&&Bye(e,v.Starting_compilation_in_watch_mode),_Me(e),tM(uU(e)).forEach(i=>e.projectPendingBuild.set($h(e,i),0)),t&&t.throwIfCancellationRequested()}var Pye=(e=>(e[e.Build=0]="Build",e[e.UpdateOutputFileStamps=1]="UpdateOutputFileStamps",e))(Pye||{});function mMe(e,t){return e.projectPendingBuild.delete(t),e.diagnostics.has(t)?1:0}function Lxt(e,t,n,i,s){let o=!0;return{kind:1,project:t,projectPath:n,buildOrder:s,getCompilerOptions:()=>i.options,getCurrentDirectory:()=>e.compilerHost.getCurrentDirectory(),updateOutputFileStatmps:()=>{EMe(e,i,n),o=!1},done:()=>(o&&EMe(e,i,n),jc("SolutionBuilder::Timestamps only updates"),mMe(e,n))}}function Fxt(e,t,n,i,s,o){let u=0,m,d;return{kind:0,project:t,projectPath:n,buildOrder:o,getCompilerOptions:()=>s.options,getCurrentDirectory:()=>e.compilerHost.getCurrentDirectory(),getBuilderProgram:()=>E(ec),getProgram:()=>E(ee=>ee.getProgramOrUndefined()),getSourceFile:ee=>E(W=>W.getSourceFile(ee)),getSourceFiles:()=>x(ee=>ee.getSourceFiles()),getOptionsDiagnostics:ee=>x(W=>W.getOptionsDiagnostics(ee)),getGlobalDiagnostics:ee=>x(W=>W.getGlobalDiagnostics(ee)),getConfigFileParsingDiagnostics:()=>x(ee=>ee.getConfigFileParsingDiagnostics()),getSyntacticDiagnostics:(ee,W)=>x(pe=>pe.getSyntacticDiagnostics(ee,W)),getAllDependencies:ee=>x(W=>W.getAllDependencies(ee)),getSemanticDiagnostics:(ee,W)=>x(pe=>pe.getSemanticDiagnostics(ee,W)),getSemanticDiagnosticsOfNextAffectedFile:(ee,W)=>E(pe=>pe.getSemanticDiagnosticsOfNextAffectedFile&&pe.getSemanticDiagnosticsOfNextAffectedFile(ee,W)),emit:(ee,W,pe,K,re)=>{if(ee||K)return E(ue=>{var ce,ne;return ue.emit(ee,W,pe,K,re||((ne=(ce=e.host).getCustomTransformers)==null?void 0:ne.call(ce,t)))});if(q(2,pe),u===4)return J(W,pe);if(u===3)return F(W,pe,re)},done:S};function S(ee,W,pe){return q(6,ee,W,pe),jc("SolutionBuilder::Projects built"),mMe(e,n)}function E(ee){return q(0),m&&ee(m)}function x(ee){return E(ee)||ve}function D(){var ee,W,pe;if(M.assert(m===void 0),e.options.dry){wp(e,v.A_non_dry_build_would_build_project_0,t),d=1,u=5;return}if(e.options.verbose&&wp(e,v.Building_project_0,t),s.fileNames.length===0){_6(e,n,kE(s)),d=0,u=5;return}let{host:K,compilerHost:re}=e;if(e.projectCompilerOptions=s.options,(ee=e.moduleResolutionCache)==null||ee.update(s.options),(W=e.typeReferenceDirectiveResolutionCache)==null||W.update(s.options),m=K.createProgram(s.fileNames,s.options,re,jxt(e,n,s),kE(s),s.projectReferences),e.watch){let ue=(pe=e.moduleResolutionCache)==null?void 0:pe.getPackageJsonInfoCache().getInternalMap();e.lastCachedPackageJsonLookups.set(n,ue&&new Set(Is(ue.values(),ce=>e.host.realpath&&(hB(ce)||ce.directoryExists)?e.host.realpath(ri(ce.packageDirectory,"package.json")):ri(ce.packageDirectory,"package.json")))),e.builderPrograms.set(n,m)}u++}function w(ee,W,pe){ee.length?{buildResult:d,step:u}=wye(e,n,m,s,ee,W,pe):u++}function R(ee){M.assertIsDefined(m),w([...m.getConfigFileParsingDiagnostics(),...m.getOptionsDiagnostics(ee),...m.getGlobalDiagnostics(ee),...m.getSyntacticDiagnostics(void 0,ee)],8,"Syntactic")}function L(ee){w(M.checkDefined(m).getSemanticDiagnostics(void 0,ee),16,"Semantic")}function F(ee,W,pe){var K,re,ue;M.assertIsDefined(m),M.assert(u===3);let ce=m.saveEmitState(),ne,le=Be=>(ne||(ne=[])).push(Be),me=[],{emitResult:de}=iU(m,le,void 0,void 0,(Be,ct,qe,et,Ie,_t)=>me.push({name:Be,text:ct,writeByteOrderMark:qe,data:_t}),W,!1,pe||((re=(K=e.host).getCustomTransformers)==null?void 0:re.call(K,t)));if(ne)return m.restoreEmitState(ce),{buildResult:d,step:u}=wye(e,n,m,s,ne,32,"Declaration file"),{emitSkipped:!0,diagnostics:de.diagnostics};let{host:Ae,compilerHost:xe}=e,te=(ue=m.hasChangedEmitSignature)!=null&&ue.call(m)?0:2,he=WI(),be=new Map,Ve=m.getCompilerOptions(),Pe=nO(Ve),ke,De;return me.forEach(({name:Be,text:ct,writeByteOrderMark:qe,data:et})=>{let Ie=Im(e,Be);be.set(Im(e,Be),Be),et?.buildInfo&&SMe(e,et.buildInfo,n,Ve,te);let _t=et?.differsOnlyInMap?zC(e.host,Be):void 0;LR(ee?{writeFile:ee}:xe,he,Be,ct,qe),et?.differsOnlyInMap?e.host.setModifiedTime(Be,_t):!Pe&&e.watch&&(ke||(ke=Iye(e,n))).set(Ie,De||(De=eM(e.host)))}),G(he,be,me.length?me[0].name:UK(s,!Ae.useCaseSensitiveFileNames()),te),de}function J(ee,W){M.assertIsDefined(m),M.assert(u===4);let pe=m.emitBuildInfo((K,re,ue,ce,ne,le)=>{le?.buildInfo&&SMe(e,le.buildInfo,n,m.getCompilerOptions(),2),ee?ee(K,re,ue,ce,ne,le):e.compilerHost.writeFile(K,re,ue,ce,ne,le)},W);return pe.diagnostics.length&&(fU(e,pe.diagnostics),e.diagnostics.set(n,[...e.diagnostics.get(n),...pe.diagnostics]),d=64&d),pe.emittedFiles&&e.write&&pe.emittedFiles.forEach(K=>yMe(e,s,K)),Dye(e,m),u=5,pe}function G(ee,W,pe,K){let re=ee.getDiagnostics();return re.length?({buildResult:d,step:u}=wye(e,n,m,s,re,64,"Emit"),re):(e.write&&W.forEach(ue=>yMe(e,s,ue)),TMe(e,s,n,v.Updating_unchanged_output_timestamps_of_project_0,W),e.diagnostics.delete(n),e.projectStatus.set(n,{type:1,oldestOutputFileName:pe}),Dye(e,m),u=5,d=K,re)}function q(ee,W,pe,K){for(;u<=ee&&u<6;){let re=u;switch(u){case 0:D();break;case 1:R(W);break;case 2:L(W);break;case 3:F(pe,W,K);break;case 4:J(pe,W);break;case 5:Jxt(e,t,n,i,s,o,M.checkDefined(d)),u++;break;case 6:default:}M.assert(u>re)}}}function gMe(e,t,n){if(!e.projectPendingBuild.size||nk(t))return;let{options:i,projectPendingBuild:s}=e;for(let o=0;o<t.length;o++){let u=t[o],m=$h(e,u),d=e.projectPendingBuild.get(m);if(d===void 0)continue;n&&(n=!1,OMe(e,t));let S=zN(e,u,m);if(!S){wMe(e,m),s.delete(m);continue}d===2?(kMe(e,u,m,S),PMe(e,m,S),NMe(e,u,m,S),Fye(e,u,m,S),jye(e,u,m,S)):d===1&&(S.fileNames=JO(S.options.configFile.configFileSpecs,mi(u),S.options,e.parseConfigFileHost),fB(S.fileNames,u,S.options.configFile.configFileSpecs,S.errors,VO(S.raw)),Fye(e,u,m,S),jye(e,u,m,S));let E=Mye(e,S,m);if(!i.force){if(E.type===1){VX(e,u,E),_6(e,m,kE(S)),s.delete(m),i.dry&&wp(e,v.Project_0_is_up_to_date,u);continue}if(E.type===2||E.type===14)return _6(e,m,kE(S)),{kind:1,status:E,project:u,projectPath:m,projectIndex:o,config:S}}if(E.type===11){VX(e,u,E),_6(e,m,kE(S)),s.delete(m),i.verbose&&wp(e,E.upstreamProjectBlocked?v.Skipping_build_of_project_0_because_its_dependency_1_was_not_built:v.Skipping_build_of_project_0_because_its_dependency_1_has_errors,u,E.upstreamProjectName);continue}if(E.type===15){VX(e,u,E),_6(e,m,kE(S)),s.delete(m);continue}return{kind:0,status:E,project:u,projectPath:m,projectIndex:o,config:S}}}function hMe(e,t,n){return VX(e,t.project,t.status),t.kind!==1?Fxt(e,t.project,t.projectPath,t.projectIndex,t.config,n):Lxt(e,t.project,t.projectPath,t.config,n)}function Nye(e,t,n){let i=gMe(e,t,n);return i&&hMe(e,i,t)}function yMe({write:e},t,n){e&&t.options.listEmittedFiles&&e(`TSFILE: ${n}`)}function jxt({options:e,builderPrograms:t,compilerHost:n},i,s){if(e.force)return;let o=t.get(i);return o||oU(s.options,n)}function Dye(e,t){t&&(e.write&&xX(t,e.write),e.host.afterProgramEmitAndDiagnostics&&e.host.afterProgramEmitAndDiagnostics(t),t.releaseProgram()),e.projectCompilerOptions=e.baseCompilerOptions}function wye(e,t,n,i,s,o,u){let m=n&&!n.getCompilerOptions().outFile;return _6(e,t,s),e.projectStatus.set(t,{type:0,reason:`${u} errors`}),m?{buildResult:o,step:4}:(Dye(e,n),{buildResult:o,step:5})}function BX(e){return!!e.watcher}function vMe(e,t){let n=Im(e,t),i=e.filesWatched.get(n);if(e.watch&&i){if(!BX(i))return i;if(i.modifiedTime)return i.modifiedTime}let s=zC(e.host,t);return e.watch&&(i?i.modifiedTime=s:e.filesWatched.set(n,s)),s}function UX(e,t,n,i,s,o,u){let m=Im(e,t),d=e.filesWatched.get(m);if(d&&BX(d))d.callbacks.push(n);else{let S=e.watchFile(t,(E,x,D)=>{let w=M.checkDefined(e.filesWatched.get(m));M.assert(BX(w)),w.modifiedTime=D,w.callbacks.forEach(R=>R(E,x,D))},i,s,o,u);e.filesWatched.set(m,{callbacks:[n],watcher:S,modifiedTime:d})}return{close:()=>{let S=M.checkDefined(e.filesWatched.get(m));M.assert(BX(S)),S.callbacks.length===1?(e.filesWatched.delete(m),Nd(S)):JC(S.callbacks,n)}}}function Iye(e,t){if(!e.watch)return;let n=e.outputTimeStamps.get(t);return n||e.outputTimeStamps.set(t,n=new Map),n}function SMe(e,t,n,i,s){let o=jv(i),u=Oye(e,o,n),m=eM(e.host);u?(u.buildInfo=t,u.modifiedTime=m,s&2||(u.latestChangedDtsTime=m)):e.buildInfoCache.set(n,{path:Im(e,o),buildInfo:t,modifiedTime:m,latestChangedDtsTime:s&2?void 0:m})}function Oye(e,t,n){let i=Im(e,t),s=e.buildInfoCache.get(n);return s?.path===i?s:void 0}function bMe(e,t,n,i){let s=Im(e,t),o=e.buildInfoCache.get(n);if(o!==void 0&&o.path===s)return o.buildInfo||void 0;let u=e.readFileWithCache(t),m=u?qK(t,u):void 0;return e.buildInfoCache.set(n,{path:s,buildInfo:m||!1,modifiedTime:i||np}),m}function Rye(e,t,n,i){let s=vMe(e,t);if(n<s)return{type:5,outOfDateOutputFileName:i,newerInputFileName:t}}function Bxt(e,t,n){var i,s,o,u;if(!t.fileNames.length&&!VO(t.raw))return{type:15};let m,d=!!e.options.force;if(t.projectReferences){e.projectStatus.set(n,{type:12});for(let ce of t.projectReferences){let ne=VN(ce),le=$h(e,ne),me=zN(e,ne,le),de=Mye(e,me,le);if(!(de.type===12||de.type===15)){if(de.type===0||de.type===11)return{type:11,upstreamProjectName:ce.path,upstreamProjectBlocked:de.type===11};if(de.type!==1)return{type:10,upstreamProjectName:ce.path};d||(m||(m=[])).push({ref:ce,refStatus:de,resolvedRefPath:le,resolvedConfig:me})}}}if(d)return{type:16};let{host:S}=e,E=jv(t.options),x,D=Dxt,w,R,L;if(E){let ce=Oye(e,E,n);if(w=ce?.modifiedTime||zC(S,E),w===np)return ce||e.buildInfoCache.set(n,{path:Im(e,E),buildInfo:!1,modifiedTime:w}),{type:3,missingOutputFileName:E};let ne=bMe(e,E,n,w);if(!ne)return{type:4,fileName:E};if(ne.program&&ne.version!==se)return{type:13,version:ne.version};if(ne.program){if((i=ne.program.changeFileSet)!=null&&i.length||(t.options.noEmit?(u=ne.program.semanticDiagnosticsPerFile)!=null&&u.length:(s=ne.program.affectedFilesPendingEmit)!=null&&s.length||(o=ne.program.emitDiagnosticsPerFile)!=null&&o.length))return{type:7,buildInfoFile:E};if(!t.options.noEmit&&JN(t.options,ne.program.options||{}))return{type:8,buildInfoFile:E};R=ne.program}D=w,x=E}let F,J=Nxt,G=!1,q=new Set;for(let ce of t.fileNames){let ne=vMe(e,ce);if(ne===np)return{type:0,reason:`${ce} does not exist`};let le=R?Im(e,ce):void 0;if(w&&w<ne){let me,de;if(R){L||(L=mX(R,E,S));let Ae=L.roots.get(le);me=L.fileInfos.get(Ae??le);let xe=me?e.readFileWithCache(Ae??ce):void 0;de=xe!==void 0?sU(S,xe):void 0,me&&me===de&&(G=!0)}if(!me||me!==de)return{type:5,outOfDateOutputFileName:E,newerInputFileName:ce}}ne>J&&(F=ce,J=ne),R&&q.add(le)}if(R){L||(L=mX(R,E,S));let ce=Nu(L.roots,(ne,le)=>q.has(le)?void 0:le);if(ce)return{type:9,buildInfoFile:E,inputFile:ce}}if(!E){let ce=BB(t,!S.useCaseSensitiveFileNames()),ne=Iye(e,n);for(let le of ce){let me=Im(e,le),de=ne?.get(me);if(de||(de=zC(e.host,le),ne?.set(me,de)),de===np)return{type:3,missingOutputFileName:le};if(de<J)return{type:5,outOfDateOutputFileName:le,newerInputFileName:F};de<D&&(D=de,x=le)}}let ee=e.buildInfoCache.get(n),W=!1;if(m)for(let{ref:ce,refStatus:ne,resolvedConfig:le,resolvedRefPath:me}of m){if(ne.newestInputFileTime&&ne.newestInputFileTime<=D)continue;if(ee&&Uxt(e,ee,me))return{type:6,outOfDateOutputFileName:E,newerProjectName:ce.path};let de=Vxt(e,le.options,me);if(de&&de<=D){W=!0;continue}return M.assert(x!==void 0,"Should have an oldest output filename here"),{type:6,outOfDateOutputFileName:x,newerProjectName:ce.path}}let pe=Rye(e,t.options.configFilePath,D,x);if(pe)return pe;let K=kt(t.options.configFile.extendedSourceFiles||ve,ce=>Rye(e,ce,D,x));if(K)return K;let re=e.lastCachedPackageJsonLookups.get(n),ue=re&&d0(re,ce=>Rye(e,ce,D,x));return ue||{type:W?2:G?14:1,newestInputFileTime:J,newestInputFileName:F,oldestOutputFileName:x}}function Uxt(e,t,n){return e.buildInfoCache.get(n).path===t.path}function Mye(e,t,n){if(t===void 0)return{type:0,reason:"File deleted mid-build"};let i=e.projectStatus.get(n);if(i!==void 0)return i;jc("SolutionBuilder::beforeUpToDateCheck");let s=Bxt(e,t,n);return jc("SolutionBuilder::afterUpToDateCheck"),vd("SolutionBuilder::Up-to-date check","SolutionBuilder::beforeUpToDateCheck","SolutionBuilder::afterUpToDateCheck"),e.projectStatus.set(n,s),s}function TMe(e,t,n,i,s){if(t.options.noEmit)return;let o,u=jv(t.options);if(u){s?.has(Im(e,u))||(e.options.verbose&&wp(e,i,t.options.configFilePath),e.host.setModifiedTime(u,o=eM(e.host)),Oye(e,u,n).modifiedTime=o),e.outputTimeStamps.delete(n);return}let{host:m}=e,d=BB(t,!m.useCaseSensitiveFileNames()),S=Iye(e,n),E=S?new Set:void 0;if(!s||d.length!==s.size){let x=!!e.options.verbose;for(let D of d){let w=Im(e,D);s?.has(w)||(x&&(x=!1,wp(e,i,t.options.configFilePath)),m.setModifiedTime(D,o||(o=eM(e.host))),S&&(S.set(w,o),E.add(w)))}}S?.forEach((x,D)=>{!s?.has(D)&&!E.has(D)&&S.delete(D)})}function Vxt(e,t,n){if(!t.composite)return;let i=M.checkDefined(e.buildInfoCache.get(n));if(i.latestChangedDtsTime!==void 0)return i.latestChangedDtsTime||void 0;let s=i.buildInfo&&i.buildInfo.program&&i.buildInfo.program.latestChangedDtsFile?e.host.getModifiedTime(xs(i.buildInfo.program.latestChangedDtsFile,mi(i.path))):void 0;return i.latestChangedDtsTime=s||!1,s}function EMe(e,t,n){if(e.options.dry)return wp(e,v.A_non_dry_build_would_update_timestamps_for_output_of_project_0,t.options.configFilePath);TMe(e,t,n,v.Updating_output_timestamps_of_project_0),e.projectStatus.set(n,{type:1,oldestOutputFileName:UK(t,!e.host.useCaseSensitiveFileNames())})}function Jxt(e,t,n,i,s,o,u){if(!(u&124)&&s.options.composite)for(let m=i+1;m<o.length;m++){let d=o[m],S=$h(e,d);if(e.projectPendingBuild.has(S))continue;let E=zN(e,d,S);if(!(!E||!E.projectReferences))for(let x of E.projectReferences){let D=rM(e,x.path);if($h(e,D)!==n)continue;let w=e.projectStatus.get(S);if(w)switch(w.type){case 1:if(u&2){w.type=2;break}case 14:case 2:u&2||e.projectStatus.set(S,{type:6,outOfDateOutputFileName:w.oldestOutputFileName,newerProjectName:t});break;case 11:$h(e,rM(e,w.upstreamProjectName))===n&&fMe(e,S);break}pMe(e,S,0);break}}}function xMe(e,t,n,i,s,o){jc("SolutionBuilder::beforeBuild");let u=qxt(e,t,n,i,s,o);return jc("SolutionBuilder::afterBuild"),vd("SolutionBuilder::Build","SolutionBuilder::beforeBuild","SolutionBuilder::afterBuild"),u}function qxt(e,t,n,i,s,o){let u=uMe(e,t,o);if(!u)return 3;dMe(e,n);let m=!0,d=0;for(;;){let S=Nye(e,u,m);if(!S)break;m=!1,S.done(n,i,s?.(S.project)),e.diagnostics.has(S.projectPath)||d++}return kye(e),IMe(e,u),Hxt(e,u),nk(u)?4:u.some(S=>e.diagnostics.has($h(e,S)))?d?2:1:0}function CMe(e,t,n){jc("SolutionBuilder::beforeClean");let i=zxt(e,t,n);return jc("SolutionBuilder::afterClean"),vd("SolutionBuilder::Clean","SolutionBuilder::beforeClean","SolutionBuilder::afterClean"),i}function zxt(e,t,n){let i=uMe(e,t,n);if(!i)return 3;if(nk(i))return fU(e,i.circularDiagnostics),4;let{options:s,host:o}=e,u=s.dry?[]:void 0;for(let m of i){let d=$h(e,m),S=zN(e,m,d);if(S===void 0){wMe(e,d);continue}let E=BB(S,!o.useCaseSensitiveFileNames());if(!E.length)continue;let x=new Set(S.fileNames.map(D=>Im(e,D)));for(let D of E)x.has(Im(e,D))||o.fileExists(D)&&(u?u.push(D):(o.deleteFile(D),Lye(e,d,0)))}return u&&wp(e,v.A_non_dry_build_would_delete_the_following_files_Colon_0,u.map(m=>`\r
 * ${m}`).join("")),0}function Lye(e,t,n){e.host.getParsedCommandLine&&n===1&&(n=2),n===2&&(e.configFileCache.delete(t),e.buildOrder=void 0),e.needsSummary=!0,fMe(e,t),pMe(e,t,n),_Me(e)}function _U(e,t,n){e.reportFileChangeDetected=!0,Lye(e,t,n),AMe(e,250,!0)}function AMe(e,t,n){let{hostWithWatch:i}=e;!i.setTimeout||!i.clearTimeout||(e.timerToBuildInvalidatedProject&&i.clearTimeout(e.timerToBuildInvalidatedProject),e.timerToBuildInvalidatedProject=i.setTimeout(Wxt,t,"timerToBuildInvalidatedProject",e,n))}function Wxt(e,t,n){jc("SolutionBuilder::beforeBuild");let i=$xt(t,n);jc("SolutionBuilder::afterBuild"),vd("SolutionBuilder::Build","SolutionBuilder::beforeBuild","SolutionBuilder::afterBuild"),i&&IMe(t,i)}function $xt(e,t){e.timerToBuildInvalidatedProject=void 0,e.reportFileChangeDetected&&(e.reportFileChangeDetected=!1,e.projectErrorsReported.clear(),Bye(e,v.File_change_detected_Starting_incremental_compilation));let n=0,i=uU(e),s=Nye(e,i,!1);if(s)for(s.done(),n++;e.projectPendingBuild.size;){if(e.timerToBuildInvalidatedProject)return;let o=gMe(e,i,!1);if(!o)break;if(o.kind!==1&&(t||n===5)){AMe(e,100,!1);return}hMe(e,o,i).done(),o.kind!==1&&n++}return kye(e),i}function kMe(e,t,n,i){!e.watch||e.allWatchedConfigFiles.has(n)||e.allWatchedConfigFiles.set(n,UX(e,t,()=>_U(e,n,2),2e3,i?.watchOptions,Tu.ConfigFile,t))}function PMe(e,t,n){qB(t,n?.options,e.allWatchedExtendedConfigFiles,(i,s)=>UX(e,i,()=>{var o;return(o=e.allWatchedExtendedConfigFiles.get(s))==null?void 0:o.projects.forEach(u=>_U(e,u,2))},2e3,n?.watchOptions,Tu.ExtendedConfigFile),i=>Im(e,i))}function NMe(e,t,n,i){e.watch&&W8(Tye(e.allWatchedWildcardDirectories,n),i.wildcardDirectories,(s,o)=>e.watchDirectory(s,u=>{var m;$8({watchedDirPath:Im(e,s),fileOrDirectory:u,fileOrDirectoryPath:Im(e,u),configFileName:t,currentDirectory:e.compilerHost.getCurrentDirectory(),options:i.options,program:e.builderPrograms.get(n)||((m=Rxt(e,n))==null?void 0:m.fileNames),useCaseSensitiveFileNames:e.parseConfigFileHost.useCaseSensitiveFileNames,writeLog:d=>e.writeLog(d),toPath:d=>Im(e,d)})||_U(e,n,1)},o,i?.watchOptions,Tu.WildcardDirectory,t))}function Fye(e,t,n,i){e.watch&&tO(Tye(e.allWatchedInputFiles,n),new Set(i.fileNames),{createNewValue:s=>UX(e,s,()=>_U(e,n,0),250,i?.watchOptions,Tu.SourceFile,t),onDeleteValue:Dm})}function jye(e,t,n,i){!e.watch||!e.lastCachedPackageJsonLookups||tO(Tye(e.allWatchedPackageJsonFiles,n),e.lastCachedPackageJsonLookups.get(n),{createNewValue:s=>UX(e,s,()=>_U(e,n,0),2e3,i?.watchOptions,Tu.PackageJson,t),onDeleteValue:Dm})}function Hxt(e,t){if(e.watchAllProjectsPending){jc("SolutionBuilder::beforeWatcherCreation"),e.watchAllProjectsPending=!1;for(let n of tM(t)){let i=$h(e,n),s=zN(e,n,i);kMe(e,n,i,s),PMe(e,i,s),s&&(NMe(e,n,i,s),Fye(e,n,i,s),jye(e,n,i,s))}jc("SolutionBuilder::afterWatcherCreation"),vd("SolutionBuilder::Watcher creation","SolutionBuilder::beforeWatcherCreation","SolutionBuilder::afterWatcherCreation")}}function Gxt(e){Vf(e.allWatchedConfigFiles,Dm),Vf(e.allWatchedExtendedConfigFiles,Nd),Vf(e.allWatchedWildcardDirectories,t=>Vf(t,Nd)),Vf(e.allWatchedInputFiles,t=>Vf(t,Dm)),Vf(e.allWatchedPackageJsonFiles,t=>Vf(t,Dm))}function DMe(e,t,n,i,s){let o=Oxt(e,t,n,i,s);return{build:(u,m,d,S)=>xMe(o,u,m,d,S),clean:u=>CMe(o,u),buildReferences:(u,m,d,S)=>xMe(o,u,m,d,S,!0),cleanReferences:u=>CMe(o,u,!0),getNextInvalidatedProject:u=>(dMe(o,u),Nye(o,uU(o),!1)),getBuildOrder:()=>uU(o),getUpToDateStatusOfProject:u=>{let m=rM(o,u),d=$h(o,m);return Mye(o,zN(o,m,d),d)},invalidateProject:(u,m)=>Lye(o,u,m||0),close:()=>Gxt(o)}}function x_(e,t){return sI(t,e.compilerHost.getCurrentDirectory(),e.compilerHost.getCanonicalFileName)}function wp(e,t,...n){e.host.reportSolutionBuilderStatus(Nc(t,...n))}function Bye(e,t,...n){var i,s;(s=(i=e.hostWithWatch).onWatchStatusChange)==null||s.call(i,Nc(t,...n),e.host.getNewLine(),e.baseCompilerOptions)}function fU({host:e},t){t.forEach(n=>e.reportDiagnostic(n))}function _6(e,t,n){fU(e,n),e.projectErrorsReported.set(t,!0),n.length&&e.diagnostics.set(t,n)}function wMe(e,t){_6(e,t,[e.configFileCache.get(t)])}function IMe(e,t){if(!e.needsSummary)return;e.needsSummary=!1;let n=e.watch||!!e.host.reportErrorSummary,{diagnostics:i}=e,s=0,o=[];nk(t)?(OMe(e,t.buildOrder),fU(e,t.circularDiagnostics),n&&(s+=rU(t.circularDiagnostics)),n&&(o=[...o,...nU(t.circularDiagnostics)])):(t.forEach(u=>{let m=$h(e,u);e.projectErrorsReported.has(m)||fU(e,i.get(m)||ve)}),n&&i.forEach(u=>s+=rU(u)),n&&i.forEach(u=>[...o,...nU(u)])),e.watch?Bye(e,TX(s),s):e.host.reportErrorSummary&&e.host.reportErrorSummary(s,o)}function OMe(e,t){e.options.verbose&&wp(e,v.Projects_in_this_build_Colon_0,t.map(n=>`\r
    * `+x_(e,n)).join(""))}function Yxt(e,t,n){switch(n.type){case 5:return wp(e,v.Project_0_is_out_of_date_because_output_1_is_older_than_input_2,x_(e,t),x_(e,n.outOfDateOutputFileName),x_(e,n.newerInputFileName));case 6:return wp(e,v.Project_0_is_out_of_date_because_output_1_is_older_than_input_2,x_(e,t),x_(e,n.outOfDateOutputFileName),x_(e,n.newerProjectName));case 3:return wp(e,v.Project_0_is_out_of_date_because_output_file_1_does_not_exist,x_(e,t),x_(e,n.missingOutputFileName));case 4:return wp(e,v.Project_0_is_out_of_date_because_there_was_error_reading_file_1,x_(e,t),x_(e,n.fileName));case 7:return wp(e,v.Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_some_of_the_changes_were_not_emitted,x_(e,t),x_(e,n.buildInfoFile));case 8:return wp(e,v.Project_0_is_out_of_date_because_buildinfo_file_1_indicates_there_is_change_in_compilerOptions,x_(e,t),x_(e,n.buildInfoFile));case 9:return wp(e,v.Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_file_2_was_root_file_of_compilation_but_not_any_more,x_(e,t),x_(e,n.buildInfoFile),x_(e,n.inputFile));case 1:if(n.newestInputFileTime!==void 0)return wp(e,v.Project_0_is_up_to_date_because_newest_input_1_is_older_than_output_2,x_(e,t),x_(e,n.newestInputFileName||""),x_(e,n.oldestOutputFileName||""));break;case 2:return wp(e,v.Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies,x_(e,t));case 14:return wp(e,v.Project_0_is_up_to_date_but_needs_to_update_timestamps_of_output_files_that_are_older_than_input_files,x_(e,t));case 10:return wp(e,v.Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date,x_(e,t),x_(e,n.upstreamProjectName));case 11:return wp(e,n.upstreamProjectBlocked?v.Project_0_can_t_be_built_because_its_dependency_1_was_not_built:v.Project_0_can_t_be_built_because_its_dependency_1_has_errors,x_(e,t),x_(e,n.upstreamProjectName));case 0:return wp(e,v.Failed_to_parse_file_0_Colon_1,x_(e,t),n.reason);case 13:return wp(e,v.Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2,x_(e,t),n.version,se);case 16:return wp(e,v.Project_0_is_being_forcibly_rebuilt,x_(e,t));case 15:case 12:break;default:}}function VX(e,t,n){e.options.verbose&&Yxt(e,t,n)}var Uye=(e=>(e[e.time=0]="time",e[e.count=1]="count",e[e.memory=2]="memory",e))(Uye||{});function Kxt(e){let t=Xxt();return kt(e.getSourceFiles(),n=>{let i=Qxt(e,n),s=Sy(n).length;t.set(i,t.get(i)+s)}),t}function Xxt(){let e=new Map;return e.set("Library",0),e.set("Definitions",0),e.set("TypeScript",0),e.set("JavaScript",0),e.set("JSON",0),e.set("Other",0),e}function Qxt(e,t){if(e.isSourceFileDefaultLibrary(t))return"Library";if(t.isDeclarationFile)return"Definitions";let n=t.path;return wl(n,EG)?"TypeScript":wl(n,_N)?"JavaScript":Ic(n,".json")?"JSON":"Other"}function JX(e,t,n){return pU(e,n)?rk(e,!0):t}function RMe(e){return!!e.writeOutputIsTTY&&e.writeOutputIsTTY()&&!e.getEnvironmentVariable("NO_COLOR")}function pU(e,t){return!t||typeof t.pretty>"u"?RMe(e):t.pretty}function MMe(e){return e.options.all?pa(og,(t,n)=>d3(t.name,n.name)):Zn(og.slice(),t=>!!t.showInSimplifiedHelpView)}function qX(e){e.write(Df(v.Version_0,se)+e.newLine)}function zX(e){if(!RMe(e))return{bold:E=>E,blue:E=>E,blueBackground:E=>E,brightWhite:E=>E};function n(E){return`\x1B[1m${E}\x1B[22m`}let i=e.getEnvironmentVariable("OS")&&e.getEnvironmentVariable("OS").toLowerCase().includes("windows"),s=e.getEnvironmentVariable("WT_SESSION"),o=e.getEnvironmentVariable("TERM_PROGRAM")&&e.getEnvironmentVariable("TERM_PROGRAM")==="vscode";function u(E){return i&&!s&&!o?S(E):`\x1B[94m${E}\x1B[39m`}let m=e.getEnvironmentVariable("COLORTERM")==="truecolor"||e.getEnvironmentVariable("TERM")==="xterm-256color";function d(E){return m?`\x1B[48;5;68m${E}\x1B[39;49m`:`\x1B[44m${E}\x1B[39;49m`}function S(E){return`\x1B[97m${E}\x1B[39m`}return{bold:n,blue:u,brightWhite:S,blueBackground:d}}function LMe(e){return`--${e.name}${e.shortName?`, -${e.shortName}`:""}`}function Zxt(e,t,n,i){var s;let o=[],u=zX(e),m=LMe(t),d=R(t),S=typeof t.defaultValueDescription=="object"?Df(t.defaultValueDescription):x(t.defaultValueDescription,t.type==="list"||t.type==="listOrElement"?t.element.type:t.type),E=((s=e.getWidthOfTerminal)==null?void 0:s.call(e))??0;if(E>=80){let L="";t.description&&(L=Df(t.description)),o.push(...w(m,L,n,i,E,!0),e.newLine),D(d,t)&&(d&&o.push(...w(d.valueType,d.possibleValues,n,i,E,!1),e.newLine),S&&o.push(...w(Df(v.default_Colon),S,n,i,E,!1),e.newLine)),o.push(e.newLine)}else{if(o.push(u.blue(m),e.newLine),t.description){let L=Df(t.description);o.push(L)}if(o.push(e.newLine),D(d,t)){if(d&&o.push(`${d.valueType} ${d.possibleValues}`),S){d&&o.push(e.newLine);let L=Df(v.default_Colon);o.push(`${L} ${S}`)}o.push(e.newLine)}o.push(e.newLine)}return o;function x(L,F){return L!==void 0&&typeof F=="object"?Is(F.entries()).filter(([,J])=>J===L).map(([J])=>J).join("/"):String(L)}function D(L,F){let J=["string"],G=[void 0,"false","n/a"],q=F.defaultValueDescription;return!(F.category===v.Command_line_Options||Es(J,L?.possibleValues)&&Es(G,q))}function w(L,F,J,G,q,ee){let W=[],pe=!0,K=F,re=q-G;for(;K.length>0;){let ue="";pe?(ue=L.padStart(J),ue=ue.padEnd(G),ue=ee?u.blue(ue):ue):ue="".padStart(G);let ce=K.substr(0,re);K=K.slice(re),W.push(`${ue}${ce}`),pe=!1}return W}function R(L){if(L.type==="object")return;return{valueType:F(L),possibleValues:J(L)};function F(G){switch(M.assert(G.type!=="listOrElement"),G.type){case"string":case"number":case"boolean":return Df(v.type_Colon);case"list":return Df(v.one_or_more_Colon);default:return Df(v.one_of_Colon)}}function J(G){let q;switch(G.type){case"string":case"number":case"boolean":q=G.type;break;case"list":case"listOrElement":q=J(G.element);break;case"object":q="";break;default:let ee={};return G.type.forEach((W,pe)=>{var K;(K=G.deprecatedKeys)!=null&&K.has(pe)||(ee[W]||(ee[W]=[])).push(pe)}),Object.entries(ee).map(([,W])=>W.join("/")).join(", ")}return q}}}function FMe(e,t){let n=0;for(let u of t){let m=LMe(u).length;n=n>m?n:m}let i=n+2,s=i+2,o=[];for(let u of t){let m=Zxt(e,u,i,s);o=[...o,...m]}return o[o.length-2]!==e.newLine&&o.push(e.newLine),o}function nM(e,t,n,i,s,o){let u=[];if(u.push(zX(e).bold(t)+e.newLine+e.newLine),s&&u.push(s+e.newLine+e.newLine),!i)return u=[...u,...FMe(e,n)],o&&u.push(o+e.newLine+e.newLine),u;let m=new Map;for(let d of n){if(!d.category)continue;let S=Df(d.category),E=m.get(S)??[];E.push(d),m.set(S,E)}return m.forEach((d,S)=>{u.push(`### ${S}${e.newLine}${e.newLine}`),u=[...u,...FMe(e,d)]}),o&&u.push(o+e.newLine+e.newLine),u}function e2t(e,t){let n=zX(e),i=[...WX(e,`${Df(v.tsc_Colon_The_TypeScript_Compiler)} - ${Df(v.Version_0,se)}`)];i.push(n.bold(Df(v.COMMON_COMMANDS))+e.newLine+e.newLine),u("tsc",v.Compiles_the_current_project_tsconfig_json_in_the_working_directory),u("tsc app.ts util.ts",v.Ignoring_tsconfig_json_compiles_the_specified_files_with_default_compiler_options),u("tsc -b",v.Build_a_composite_project_in_the_working_directory),u("tsc --init",v.Creates_a_tsconfig_json_with_the_recommended_settings_in_the_working_directory),u("tsc -p ./path/to/tsconfig.json",v.Compiles_the_TypeScript_project_located_at_the_specified_path),u("tsc --help --all",v.An_expanded_version_of_this_information_showing_all_possible_compiler_options),u(["tsc --noEmit","tsc --target esnext"],v.Compiles_the_current_project_with_additional_settings);let s=t.filter(m=>m.isCommandLineOnly||m.category===v.Command_line_Options),o=t.filter(m=>!Es(s,m));i=[...i,...nM(e,Df(v.COMMAND_LINE_FLAGS),s,!1,void 0,void 0),...nM(e,Df(v.COMMON_COMPILER_OPTIONS),o,!1,void 0,vA(v.You_can_learn_about_all_of_the_compiler_options_at_0,"https://aka.ms/tsc"))];for(let m of i)e.write(m);function u(m,d){let S=typeof m=="string"?[m]:m;for(let E of S)i.push("  "+n.blue(E)+e.newLine);i.push("  "+Df(d)+e.newLine+e.newLine)}}function t2t(e,t,n,i){let s=[...WX(e,`${Df(v.tsc_Colon_The_TypeScript_Compiler)} - ${Df(v.Version_0,se)}`)];s=[...s,...nM(e,Df(v.ALL_COMPILER_OPTIONS),t,!0,void 0,vA(v.You_can_learn_about_all_of_the_compiler_options_at_0,"https://aka.ms/tsc"))],s=[...s,...nM(e,Df(v.WATCH_OPTIONS),i,!1,Df(v.Including_watch_w_will_start_watching_the_current_project_for_the_file_changes_Once_set_you_can_config_watch_mode_with_Colon))],s=[...s,...nM(e,Df(v.BUILD_OPTIONS),n,!1,vA(v.Using_build_b_will_make_tsc_behave_more_like_a_build_orchestrator_than_a_compiler_This_is_used_to_trigger_building_composite_projects_which_you_can_learn_more_about_at_0,"https://aka.ms/tsc-composite-builds"))];for(let o of s)e.write(o)}function jMe(e,t){let n=[...WX(e,`${Df(v.tsc_Colon_The_TypeScript_Compiler)} - ${Df(v.Version_0,se)}`)];n=[...n,...nM(e,Df(v.BUILD_OPTIONS),t,!1,vA(v.Using_build_b_will_make_tsc_behave_more_like_a_build_orchestrator_than_a_compiler_This_is_used_to_trigger_building_composite_projects_which_you_can_learn_more_about_at_0,"https://aka.ms/tsc-composite-builds"))];for(let i of n)e.write(i)}function WX(e,t){var n;let i=zX(e),s=[],o=((n=e.getWidthOfTerminal)==null?void 0:n.call(e))??0,u=5,m=i.blueBackground("".padStart(u)),d=i.blueBackground(i.brightWhite("TS ".padStart(u)));if(o>=t.length+u){let E=(o>120?120:o)-u;s.push(t.padEnd(E)+m+e.newLine),s.push("".padStart(E)+d+e.newLine)}else s.push(t+e.newLine),s.push(e.newLine);return s}function BMe(e,t){t.options.all?t2t(e,MMe(t),FY,YA):e2t(e,MMe(t))}function UMe(e,t,n){let i=rk(e);if(n.options.build)return i(Nc(v.Option_build_must_be_the_first_command_line_argument)),e.exit(1);let s;if(n.options.locale&&k$(n.options.locale,e,n.errors),n.errors.length>0)return n.errors.forEach(i),e.exit(1);if(n.options.init)return s2t(e,i,n.options,n.fileNames),e.exit(0);if(n.options.version)return qX(e),e.exit(0);if(n.options.help||n.options.all)return BMe(e,n),e.exit(0);if(n.options.watch&&n.options.listFilesOnly)return i(Nc(v.Options_0_and_1_cannot_be_combined,"watch","listFilesOnly")),e.exit(1);if(n.options.project){if(n.fileNames.length!==0)return i(Nc(v.Option_project_cannot_be_mixed_with_source_files_on_a_command_line)),e.exit(1);let m=Zs(n.options.project);if(!m||e.directoryExists(m)){if(s=ri(m,"tsconfig.json"),!e.fileExists(s))return i(Nc(v.Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0,n.options.project)),e.exit(1)}else if(s=m,!e.fileExists(s))return i(Nc(v.The_specified_path_does_not_exist_Colon_0,n.options.project)),e.exit(1)}else if(n.fileNames.length===0){let m=Zs(e.getCurrentDirectory());s=HK(m,d=>e.fileExists(d))}if(n.fileNames.length===0&&!s)return n.options.showConfig?i(Nc(v.Cannot_find_a_tsconfig_json_file_at_the_current_directory_Colon_0,Zs(e.getCurrentDirectory()))):(qX(e),BMe(e,n)),e.exit(1);let o=e.getCurrentDirectory(),u=lB(n.options,m=>xs(m,o));if(s){let m=new Map,d=hye(s,u,m,n.watchOptions,e,i);if(u.showConfig)return d.errors.length!==0?(i=JX(e,i,d.options),d.errors.forEach(i),e.exit(1)):(e.write(JSON.stringify(WY(d,s,e),null,4)+e.newLine),e.exit(0));if(i=JX(e,i,d.options),oG(d.options))return Jye(e,i)?void 0:r2t(e,t,i,d,u,n.watchOptions,m);nO(d.options)?zMe(e,t,i,d):qMe(e,t,i,d)}else{if(u.showConfig)return e.write(JSON.stringify(WY(n,ri(o,"tsconfig.json"),e),null,4)+e.newLine),e.exit(0);if(i=JX(e,i,u),oG(u))return Jye(e,i)?void 0:n2t(e,t,i,n.fileNames,u,n.watchOptions);nO(u)?zMe(e,t,i,{...n,options:u}):qMe(e,t,i,{...n,options:u})}}function Vye(e){if(e.length>0&&e[0].charCodeAt(0)===45){let t=e[0].slice(e[0].charCodeAt(1)===45?2:1).toLowerCase();return t==="build"||t==="b"}return!1}function VMe(e,t,n){if(Vye(n)){let{buildOptions:s,watchOptions:o,projects:u,errors:m}=$me(n.slice(1));if(s.generateCpuProfile&&e.enableCPUProfiler)e.enableCPUProfiler(s.generateCpuProfile,()=>JMe(e,t,s,o,u,m));else return JMe(e,t,s,o,u,m)}let i=zme(n,s=>e.readFile(s));if(i.options.generateCpuProfile&&e.enableCPUProfiler)e.enableCPUProfiler(i.options.generateCpuProfile,()=>UMe(e,t,i));else return UMe(e,t,i)}function Jye(e,t){return!e.watchFile||!e.watchDirectory?(t(Nc(v.The_current_host_does_not_support_the_0_option,"--watch")),e.exit(1),!0):!1}var dU=2;function JMe(e,t,n,i,s,o){let u=JX(e,rk(e),n);if(n.locale&&k$(n.locale,e,o),o.length>0)return o.forEach(u),e.exit(1);if(n.help||s.length===0)return qX(e),jMe(e,A8),e.exit(0);if(!e.getModifiedTime||!e.setModifiedTime||n.clean&&!e.deleteFile)return u(Nc(v.The_current_host_does_not_support_the_0_option,"--build")),e.exit(1);if(n.watch){if(Jye(e,u))return;let x=xye(e,void 0,u,lU(e,pU(e,n)),zye(e,n));x.jsDocParsingMode=dU;let D=GMe(e,n);WMe(e,t,x,D);let w=x.onWatchStatusChange,R=!1;x.onWatchStatusChange=(F,J,G,q)=>{w?.(F,J,G,q),R&&(F.code===v.Found_0_errors_Watching_for_file_changes.code||F.code===v.Found_1_error_Watching_for_file_changes.code)&&Wye(L,D)};let L=Aye(x,s,n,i);return L.build(),Wye(L,D),R=!0,L}let m=Eye(e,void 0,u,lU(e,pU(e,n)),qye(e,n));m.jsDocParsingMode=dU;let d=GMe(e,n);WMe(e,t,m,d);let S=Cye(m,s,n),E=n.clean?S.clean():S.build();return Wye(S,d),_le(),e.exit(E)}function qye(e,t){return pU(e,t)?(n,i)=>e.write(EX(n,i,e.newLine,e)):void 0}function qMe(e,t,n,i){let{fileNames:s,options:o,projectReferences:u}=i,m=WB(o,void 0,e);m.jsDocParsingMode=dU;let d=m.getCurrentDirectory(),S=l_(m.useCaseSensitiveFileNames());a6(m,w=>rc(w,d,S)),$ye(e,o,!1);let E={rootNames:s,options:o,projectReferences:u,host:m,configFileParsingDiagnostics:kE(i)},x=X8(E),D=DX(x,n,w=>e.write(w+e.newLine),qye(e,o));return HX(e,x,void 0),t(x),e.exit(D)}function zMe(e,t,n,i){let{options:s,fileNames:o,projectReferences:u}=i;$ye(e,s,!1);let m=cU(s,e);m.jsDocParsingMode=dU;let d=vye({host:m,system:e,rootNames:o,options:s,configFileParsingDiagnostics:kE(i),projectReferences:u,reportDiagnostic:n,reportErrorSummary:qye(e,s),afterProgramEmitAndDiagnostics:S=>{HX(e,S.getProgram(),void 0),t(S)}});return e.exit(d)}function WMe(e,t,n,i){$Me(e,n,!0),n.afterProgramEmitAndDiagnostics=s=>{HX(e,s.getProgram(),i),t(s)}}function $Me(e,t,n){let i=t.createProgram;t.createProgram=(s,o,u,m,d,S)=>(M.assert(s!==void 0||o===void 0&&!!m),o!==void 0&&$ye(e,o,n),i(s,o,u,m,d,S))}function HMe(e,t,n){n.jsDocParsingMode=dU,$Me(e,n,!1);let i=n.afterProgramCreate;n.afterProgramCreate=s=>{i(s),HX(e,s.getProgram(),void 0),t(s)}}function zye(e,t){return bX(e,pU(e,t))}function r2t(e,t,n,i,s,o,u){let m=MX({configFileName:i.options.configFilePath,optionsToExtend:s,watchOptionsToExtend:o,system:e,reportDiagnostic:n,reportWatchStatus:zye(e,i.options)});return HMe(e,t,m),m.configFileParsingResult=i,m.extendedConfigCache=u,FX(m)}function n2t(e,t,n,i,s,o){let u=LX({rootFiles:i,options:s,watchOptions:o,system:e,reportDiagnostic:n,reportWatchStatus:zye(e,s)});return HMe(e,t,u),FX(u)}function GMe(e,t){if(e===lu&&t.extendedDiagnostics)return WW(),i2t()}function i2t(){let e;return{addAggregateStatistic:t,forEachAggregateStatistics:n,clear:i};function t(s){let o=e?.get(s.name);o?o.type===2?o.value=Math.max(o.value,s.value):o.value+=s.value:(e??(e=new Map)).set(s.name,s)}function n(s){e?.forEach(s)}function i(){e=void 0}}function Wye(e,t){if(!t)return;if(!cle()){lu.write(v.Performance_timings_for_diagnostics_or_extendedDiagnostics_are_not_available_in_this_session_A_native_implementation_of_the_Web_Performance_API_could_not_be_found.message+`
`);return}let n=[];n.push({name:"Projects in scope",value:tM(e.getBuildOrder()).length,type:1}),i("SolutionBuilder::Projects built"),i("SolutionBuilder::Timestamps only updates"),i("SolutionBuilder::Bundles updated"),t.forEachAggregateStatistics(o=>{o.name=`Aggregate ${o.name}`,n.push(o)}),zW((o,u)=>{$X(o)&&n.push({name:`${s(o)} time`,value:u,type:0})}),lle(),WW(),t.clear(),XMe(lu,n);function i(o){let u=EOe(o);u&&n.push({name:s(o),value:u,type:1})}function s(o){return o.replace("SolutionBuilder::","")}}function YMe(e,t){return e===lu&&(t.diagnostics||t.extendedDiagnostics)}function KMe(e,t){return e===lu&&t.generateTrace}function $ye(e,t,n){YMe(e,t)&&WW(e),KMe(e,t)&&ule(n?"build":"project",t.generateTrace,t.configFilePath)}function $X(e){return _s(e,"SolutionBuilder::")}function HX(e,t,n){var i;let s=t.getCompilerOptions();KMe(e,s)&&((i=Cn)==null||i.stopTracing());let o;if(YMe(e,s)){o=[];let S=e.getMemoryUsage?e.getMemoryUsage():-1;m("Files",t.getSourceFiles().length);let E=Kxt(t);if(s.extendedDiagnostics)for(let[F,J]of E.entries())m("Lines of "+F,J);else m("Lines",Xl(E.values(),(F,J)=>F+J,0));m("Identifiers",t.getIdentifierCount()),m("Symbols",t.getSymbolCount()),m("Types",t.getTypeCount()),m("Instantiations",t.getInstantiationCount()),S>=0&&u({name:"Memory used",value:S,type:2},!0);let x=cle(),D=x?eI("Program"):0,w=x?eI("Bind"):0,R=x?eI("Check"):0,L=x?eI("Emit"):0;if(s.extendedDiagnostics){let F=t.getRelationCacheSizes();m("Assignability cache size",F.assignable),m("Identity cache size",F.identity),m("Subtype cache size",F.subtype),m("Strict subtype cache size",F.strictSubtype),x&&zW((J,G)=>{$X(J)||d(`${J} time`,G,!0)})}else x&&(d("I/O read",eI("I/O Read"),!0),d("I/O write",eI("I/O Write"),!0),d("Parse time",D,!0),d("Bind time",w,!0),d("Check time",R,!0),d("Emit time",L,!0));x&&d("Total time",D+w+R+L,!1),XMe(e,o),x?n?(zW(F=>{$X(F)||COe(F)}),xOe(F=>{$X(F)||AOe(F)})):lle():e.write(v.Performance_timings_for_diagnostics_or_extendedDiagnostics_are_not_available_in_this_session_A_native_implementation_of_the_Web_Performance_API_could_not_be_found.message+`
`)}function u(S,E){o.push(S),E&&n?.addAggregateStatistic(S)}function m(S,E){u({name:S,value:E,type:1},!0)}function d(S,E,x){u({name:S,value:E,type:0},x)}}function XMe(e,t){let n=0,i=0;for(let s of t){s.name.length>n&&(n=s.name.length);let o=QMe(s);o.length>i&&(i=o.length)}for(let s of t)e.write(`${s.name}:`.padEnd(n+2)+QMe(s).toString().padStart(i)+e.newLine)}function QMe(e){switch(e.type){case 1:return""+e.value;case 0:return(e.value/1e3).toFixed(2)+"s";case 2:return Math.round(e.value/1e3)+"K";default:M.assertNever(e.type)}}function s2t(e,t,n,i){let s=e.getCurrentDirectory(),o=Zs(ri(s,"tsconfig.json"));if(e.fileExists(o))t(Nc(v.A_tsconfig_json_file_is_already_defined_at_Colon_0,o));else{e.writeFile(o,Xme(n,i,e.newLine));let u=[e.newLine,...WX(e,"Created a new tsconfig.json with:")];u.push(Kme(n,e.newLine)+e.newLine+e.newLine),u.push("You can learn more at https://aka.ms/tsconfig"+e.newLine);for(let m of u)e.write(m)}}function Hye(e,t){let n=J_(e,"strictNullChecks");return{typeFromExpression:G,serializeTypeOfDeclaration:o,serializeReturnTypeForSignature:u,serializeTypeOfExpression:s};function i(te,he){return te!==void 0&&(!he||te&&de(te))?!0:void 0}function s(te,he,be,Ve){return G(te,he,!1,be,Ve)??R(te,he)}function o(te,he){switch(te.kind){case 171:return i(Vl(te));case 169:return x(te,he);case 260:return E(te,he);case 172:return D(te,he);case 208:return w(te,he);case 277:return s(te.expression,he,void 0,!0);case 211:case 212:case 226:return i(Vl(te))||w(te,he);case 303:return G(te.initializer,he)||w(te,he);default:M.assertNever(te,`Node needs to be an inferrable node, found ${M.formatSyntaxKind(te.kind)}`)}}function u(te,he){switch(te.kind){case 177:return S(te,he);case 174:case 262:case 180:case 173:case 179:case 176:case 178:case 181:case 184:case 185:case 218:case 219:case 317:case 323:return Ae(te,he);default:M.assertNever(te,`Node needs to be an inferrable node, found ${M.formatSyntaxKind(te.kind)}`)}}function m(te){if(te)return te.kind===177?lp(te):te.parameters.length>0?Vl(te.parameters[0]):void 0}function d(te,he){let be=m(te);return!be&&te!==he.firstAccessor&&(be=m(he.firstAccessor)),!be&&he.secondAccessor&&te!==he.secondAccessor&&(be=m(he.secondAccessor)),be}function S(te,he){let be=t.getAllAccessorDeclarations(te),Ve=d(te,be);return Ve?i(Ve):be.getAccessor?Ae(be.getAccessor,he):!1}function E(te,he){let be=Vl(te);if(be)return i(be);let Ve;return te.initializer&&(t.isExpandoFunctionDeclaration(te)||(Ve=G(te.initializer,he,void 0,void 0,q_e(te)))),Ve??w(te,he)}function x(te,he){let be=te.parent;if(be.kind===178)return S(be,he);let Ve=Vl(te),Pe=t.requiresAddingImplicitUndefined(te),ke;return Ve?ke=i(Ve,Pe):te.initializer&&He(te.name)&&(ke=G(te.initializer,he,void 0,Pe)),ke??w(te,he)}function D(te,he){let be=Vl(te);if(be)return i(be);let Ve;if(te.initializer){let Pe=eR(te);Ve=G(te.initializer,he,void 0,void 0,Pe)}return Ve??w(te,he)}function w(te,he){return he.tracker.reportInferenceFallback(te),!1}function R(te,he){return he.tracker.reportInferenceFallback(te),!1}function L(te,he){return he.tracker.reportInferenceFallback(te),!1}function F(te,he,be){return te.kind===177?Ae(te,be):(be.tracker.reportInferenceFallback(te),!1)}function J(te,he,be,Ve){return Qm(he)?G(te,be,!0,Ve):(Ve&&!de(he)&&be.tracker.reportInferenceFallback(he),i(he))}function G(te,he,be=!1,Ve=!1,Pe=!1){switch(te.kind){case 217:return m2(te)?J(te.expression,FO(te),he,Ve):G(te.expression,he,be,Ve);case 80:if(t.isUndefinedIdentifierExpression(te))return!0;break;case 106:return!0;case 219:case 218:return q(te,he);case 216:case 234:let ke=te;return J(ke.expression,ke.type,he,Ve);case 224:let De=te;if(yj(De)&&(De.operand.kind===10||De.operand.kind===9))return me();break;case 9:return me();case 228:if(!be&&!Pe)return!0;break;case 15:case 11:return me();case 10:return me();case 112:case 97:return me();case 209:return W(te,he,be);case 210:return K(te,he,be);case 231:return R(te,he)}}function q(te,he){let be=i(te.type)??Ae(te,he),Ve=ce(te.typeParameters),Pe=te.parameters.every(ke=>ue(ke,he));return be&&Ve&&Pe}function ee(te,he,be){if(!be)return he.tracker.reportInferenceFallback(te),!1;for(let Ve of te.elements)if(Ve.kind===230)return he.tracker.reportInferenceFallback(Ve),!1;return!0}function W(te,he,be){if(!ee(te,he,be))return!1;let Ve=!0;for(let Pe of te.elements)M.assert(Pe.kind!==230),Pe.kind!==232&&(Ve=(G(Pe,he,be)??R(Pe,he))&&Ve);return!0}function pe(te,he){let be=!0;for(let Ve of te.properties){if(Ve.flags&262144){be=!1;break}if(Ve.kind===304||Ve.kind===305)he.tracker.reportInferenceFallback(Ve),be=!1;else if(Ve.name.flags&262144){be=!1;break}else if(Ve.name.kind===81)be=!1;else if(Ve.name.kind===167){let Pe=Ve.name.expression;!yj(Pe,!1)&&!t.isDefinitelyReferenceToGlobalSymbolObject(Pe)&&(he.tracker.reportInferenceFallback(Ve.name),be=!1)}}return be}function K(te,he,be){if(!pe(te,he))return!1;let Ve=!0;for(let Pe of te.properties){M.assert(!p_(Pe)&&!Fy(Pe));let ke=Pe.name;switch(Pe.kind){case 174:Ve=!!ne(Pe,ke,he)&&Ve;break;case 303:Ve=!!re(Pe,ke,he,be)&&Ve;break;case 178:case 177:Ve=!!le(Pe,ke,he)&&Ve;break}}return Ve}function re(te,he,be,Ve){return G(te.initializer,be,Ve)??w(te,be)}function ue(te,he){return x(te,he)}function ce(te){return te?.every(he=>i(he.constraint)&&i(he.default))??!0}function ne(te,he,be){let Ve=Ae(te,be),Pe=ce(te.typeParameters),ke=te.parameters.every(De=>ue(De,be));return Ve&&Pe&&ke}function le(te,he,be){let Ve=t.getAllAccessorDeclarations(te),Pe=Ve.getAccessor&&m(Ve.getAccessor),ke=Ve.setAccessor&&m(Ve.setAccessor);if(Pe!==void 0&&ke!==void 0){let De=te.parameters.every(Be=>ue(Be,be));return Sv(te)?De&&i(Pe):De}else if(Ve.firstAccessor===te){let De=Pe??ke;return De?i(De):F(te,Ve,be)}return!1}function me(){return!0}function de(te){return!n||sf(te.kind)||te.kind===201||te.kind===184||te.kind===185||te.kind===188||te.kind===189||te.kind===187||te.kind===203||te.kind===197?!0:te.kind===196?de(te.type):te.kind===192||te.kind===193?te.types.every(de):!1}function Ae(te,he){let be,Ve=lp(te);return Ve&&(be=i(Ve)),!be&&lA(te)&&(be=xe(te,he)),be??L(te,he)}function xe(te,he){let be;if(te&&!$c(te.body)){if(Rl(te)&3)return;let Ve=te.body;Ve&&Vs(Ve)?xv(Ve,Pe=>{if(!be)be=Pe.expression;else return be=void 0,!0}):be=Ve}if(be)return G(be,he)}}var eh={};A(eh,{NameValidationResult:()=>l7e,discoverTypings:()=>c2t,isTypingUpToDate:()=>n7e,loadSafeList:()=>a2t,loadTypesMap:()=>o2t,nodeCoreModuleList:()=>a7e,nodeCoreModules:()=>o7e,nonRelativeModuleNameForTypingCache:()=>c7e,prefixedNodeCoreModuleList:()=>s7e,renderPackageNameValidationFailure:()=>u2t,validatePackageName:()=>l2t});var mU="action::set",gU="action::invalidate",hU="action::packageInstalled",GX="event::typesRegistry",YX="event::beginInstallTypes",KX="event::endInstallTypes",Gye="event::initializationFailed",iM="action::watchTypingLocations",XX;(e=>{e.GlobalCacheLocation="--globalTypingsCacheLocation",e.LogFile="--logFile",e.EnableTelemetry="--enableTelemetry",e.TypingSafeListLocation="--typingSafeListLocation",e.TypesMapLocation="--typesMapLocation",e.NpmLocation="--npmLocation",e.ValidateDefaultNpmLocation="--validateDefaultNpmLocation"})(XX||(XX={}));function ZMe(e){return lu.args.includes(e)}function e7e(e){let t=lu.args.indexOf(e);return t>=0&&t<lu.args.length-1?lu.args[t+1]:void 0}function t7e(){let e=new Date;return`${e.getHours().toString().padStart(2,"0")}:${e.getMinutes().toString().padStart(2,"0")}:${e.getSeconds().toString().padStart(2,"0")}.${e.getMilliseconds().toString().padStart(3,"0")}`}var r7e=`
    `;function f6(e){return r7e+e.replace(/\n/g,r7e)}function Ob(e){return f6(JSON.stringify(e,void 0,2))}function n7e(e,t){return new Km(QF(t,`ts${j}`)||QF(t,"latest")).compareTo(e.version)<=0}var i7e=["assert","assert/strict","async_hooks","buffer","child_process","cluster","console","constants","crypto","dgram","diagnostics_channel","dns","dns/promises","domain","events","fs","fs/promises","http","https","http2","inspector","module","net","os","path","perf_hooks","process","punycode","querystring","readline","repl","stream","stream/promises","string_decoder","timers","timers/promises","tls","trace_events","tty","url","util","util/types","v8","vm","wasi","worker_threads","zlib"],s7e=i7e.map(e=>`node:${e}`),a7e=[...i7e,...s7e],o7e=new Set(a7e);function c7e(e){return o7e.has(e)?"node":e}function a2t(e,t){let n=P8(t,i=>e.readFile(i));return new Map(Object.entries(n.config))}function o2t(e,t){var n;let i=P8(t,s=>e.readFile(s));if((n=i.config)!=null&&n.simpleMap)return new Map(Object.entries(i.config.simpleMap))}function c2t(e,t,n,i,s,o,u,m,d,S){if(!u||!u.enable)return{cachedTypingPaths:[],newTypingNames:[],filesToWatch:[]};let E=new Map;n=Gi(n,ee=>{let W=Zs(ee);if(Oy(W))return W});let x=[];u.include&&J(u.include,"Explicitly included types");let D=u.exclude||[];if(!S.types){let ee=new Set(n.map(mi));ee.add(i),ee.forEach(W=>{G(W,"bower.json","bower_components",x),G(W,"package.json","node_modules",x)})}if(u.disableFilenameBasedTypeAcquisition||q(n),m){let ee=I1(m.map(c7e),Lx,c_);J(ee,"Inferred typings from unresolved imports")}for(let ee of D)E.delete(ee)&&t&&t(`Typing for ${ee} is in exclude list, will be ignored.`);o.forEach((ee,W)=>{let pe=d.get(W);E.get(W)===!1&&pe!==void 0&&n7e(ee,pe)&&E.set(W,ee.typingLocation)});let w=[],R=[];E.forEach((ee,W)=>{ee?R.push(ee):w.push(W)});let L={cachedTypingPaths:R,newTypingNames:w,filesToWatch:x};return t&&t(`Finished typings discovery:${Ob(L)}`),L;function F(ee){E.has(ee)||E.set(ee,!1)}function J(ee,W){t&&t(`${W}: ${JSON.stringify(ee)}`),kt(ee,F)}function G(ee,W,pe,K){let re=ri(ee,W),ue,ce;e.fileExists(re)&&(K.push(re),ue=P8(re,de=>e.readFile(de)).config,ce=va([ue.dependencies,ue.devDependencies,ue.optionalDependencies,ue.peerDependencies],Ng),J(ce,`Typing names in '${re}' dependencies`));let ne=ri(ee,pe);if(K.push(ne),!e.directoryExists(ne))return;let le=[],me=ce?ce.map(de=>ri(ne,de,W)):e.readDirectory(ne,[".json"],void 0,void 0,3).filter(de=>{if(Ul(de)!==W)return!1;let Ae=hu(Zs(de)),xe=Ae[Ae.length-3][0]==="@";return xe&&R1(Ae[Ae.length-4])===pe||!xe&&R1(Ae[Ae.length-3])===pe});t&&t(`Searching for typing names in ${ne}; all files: ${JSON.stringify(me)}`);for(let de of me){let Ae=Zs(de),te=P8(Ae,be=>e.readFile(be)).config;if(!te.name)continue;let he=te.types||te.typings;if(he){let be=xs(he,mi(Ae));e.fileExists(be)?(t&&t(`    Package '${te.name}' provides its own types.`),E.set(te.name,be)):t&&t(`    Package '${te.name}' provides its own types but they are missing.`)}else le.push(te.name)}J(le,"    Found package names")}function q(ee){let W=Gi(ee,K=>{if(!Oy(K))return;let re=of(R1(Ul(K))),ue=FW(re);return s.get(ue)});W.length&&J(W,"Inferred typings from file names"),Pt(ee,K=>Ic(K,".jsx"))&&(t&&t("Inferred 'react' typings due to presence of '.jsx' extension"),F("react"))}}var l7e=(e=>(e[e.Ok=0]="Ok",e[e.EmptyName=1]="EmptyName",e[e.NameTooLong=2]="NameTooLong",e[e.NameStartsWithDot=3]="NameStartsWithDot",e[e.NameStartsWithUnderscore=4]="NameStartsWithUnderscore",e[e.NameContainsNonURISafeCharacters=5]="NameContainsNonURISafeCharacters",e))(l7e||{}),u7e=214;function l2t(e){return Yye(e,!0)}function Yye(e,t){if(!e)return 1;if(e.length>u7e)return 2;if(e.charCodeAt(0)===46)return 3;if(e.charCodeAt(0)===95)return 4;if(t){let n=/^@([^/]+)\/([^/]+)$/.exec(e);if(n){let i=Yye(n[1],!1);if(i!==0)return{name:n[1],isScopeName:!0,result:i};let s=Yye(n[2],!1);return s!==0?{name:n[2],isScopeName:!1,result:s}:0}}return encodeURIComponent(e)!==e?5:0}function u2t(e,t){return typeof e=="object"?_7e(t,e.result,e.name,e.isScopeName):_7e(t,e,t,!1)}function _7e(e,t,n,i){let s=i?"Scope":"Package";switch(t){case 1:return`'${e}':: ${s} name '${n}' cannot be empty`;case 2:return`'${e}':: ${s} name '${n}' should be less than ${u7e} characters`;case 3:return`'${e}':: ${s} name '${n}' cannot start with '.'`;case 4:return`'${e}':: ${s} name '${n}' cannot start with '_'`;case 5:return`'${e}':: ${s} name '${n}' contains non URI safe characters`;case 0:return M.fail();default:M.assertNever(t)}}var yU;(e=>{class t{constructor(s){this.text=s}getText(s,o){return s===0&&o===this.text.length?this.text:this.text.substring(s,o)}getLength(){return this.text.length}getChangeRange(){}}function n(i){return new t(i)}e.fromString=n})(yU||(yU={}));var Kye=(e=>(e[e.Dependencies=1]="Dependencies",e[e.DevDependencies=2]="DevDependencies",e[e.PeerDependencies=4]="PeerDependencies",e[e.OptionalDependencies=8]="OptionalDependencies",e[e.All=15]="All",e))(Kye||{}),Xye=(e=>(e[e.Off=0]="Off",e[e.On=1]="On",e[e.Auto=2]="Auto",e))(Xye||{}),Qye=(e=>(e[e.Semantic=0]="Semantic",e[e.PartialSemantic=1]="PartialSemantic",e[e.Syntactic=2]="Syntactic",e))(Qye||{}),am={},Zye=(e=>(e.Original="original",e.TwentyTwenty="2020",e))(Zye||{}),QX=(e=>(e.All="All",e.SortAndCombine="SortAndCombine",e.RemoveUnused="RemoveUnused",e))(QX||{}),ZX=(e=>(e[e.Invoked=1]="Invoked",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=3]="TriggerForIncompleteCompletions",e))(ZX||{}),e0e=(e=>(e.Type="Type",e.Parameter="Parameter",e.Enum="Enum",e))(e0e||{}),t0e=(e=>(e.none="none",e.definition="definition",e.reference="reference",e.writtenReference="writtenReference",e))(t0e||{}),r0e=(e=>(e[e.None=0]="None",e[e.Block=1]="Block",e[e.Smart=2]="Smart",e))(r0e||{}),eQ=(e=>(e.Ignore="ignore",e.Insert="insert",e.Remove="remove",e))(eQ||{});function vU(e){return{indentSize:4,tabSize:4,newLineCharacter:e||`
`,convertTabsToSpaces:!0,indentStyle:2,insertSpaceAfterConstructor:!1,insertSpaceAfterCommaDelimiter:!0,insertSpaceAfterSemicolonInForStatements:!0,insertSpaceBeforeAndAfterBinaryOperators:!0,insertSpaceAfterKeywordsInControlFlowStatements:!0,insertSpaceAfterFunctionKeywordForAnonymousFunctions:!1,insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis:!1,insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets:!1,insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces:!0,insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces:!1,insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces:!1,insertSpaceBeforeFunctionParenthesis:!1,placeOpenBraceOnNewLineForFunctions:!1,placeOpenBraceOnNewLineForControlBlocks:!1,semicolons:"ignore",trimTrailingWhitespace:!0,indentSwitchCase:!0}}var f7e=vU(`
`),SU=(e=>(e[e.aliasName=0]="aliasName",e[e.className=1]="className",e[e.enumName=2]="enumName",e[e.fieldName=3]="fieldName",e[e.interfaceName=4]="interfaceName",e[e.keyword=5]="keyword",e[e.lineBreak=6]="lineBreak",e[e.numericLiteral=7]="numericLiteral",e[e.stringLiteral=8]="stringLiteral",e[e.localName=9]="localName",e[e.methodName=10]="methodName",e[e.moduleName=11]="moduleName",e[e.operator=12]="operator",e[e.parameterName=13]="parameterName",e[e.propertyName=14]="propertyName",e[e.punctuation=15]="punctuation",e[e.space=16]="space",e[e.text=17]="text",e[e.typeParameterName=18]="typeParameterName",e[e.enumMemberName=19]="enumMemberName",e[e.functionName=20]="functionName",e[e.regularExpressionLiteral=21]="regularExpressionLiteral",e[e.link=22]="link",e[e.linkName=23]="linkName",e[e.linkText=24]="linkText",e))(SU||{}),n0e=(e=>(e[e.None=0]="None",e[e.MayIncludeAutoImports=1]="MayIncludeAutoImports",e[e.IsImportStatementCompletion=2]="IsImportStatementCompletion",e[e.IsContinuation=4]="IsContinuation",e[e.ResolvedModuleSpecifiers=8]="ResolvedModuleSpecifiers",e[e.ResolvedModuleSpecifiersBeyondLimit=16]="ResolvedModuleSpecifiersBeyondLimit",e[e.MayIncludeMethodSnippets=32]="MayIncludeMethodSnippets",e))(n0e||{}),i0e=(e=>(e.Comment="comment",e.Region="region",e.Code="code",e.Imports="imports",e))(i0e||{}),s0e=(e=>(e[e.JavaScript=0]="JavaScript",e[e.SourceMap=1]="SourceMap",e[e.Declaration=2]="Declaration",e))(s0e||{}),a0e=(e=>(e[e.None=0]="None",e[e.InMultiLineCommentTrivia=1]="InMultiLineCommentTrivia",e[e.InSingleQuoteStringLiteral=2]="InSingleQuoteStringLiteral",e[e.InDoubleQuoteStringLiteral=3]="InDoubleQuoteStringLiteral",e[e.InTemplateHeadOrNoSubstitutionTemplate=4]="InTemplateHeadOrNoSubstitutionTemplate",e[e.InTemplateMiddleOrTail=5]="InTemplateMiddleOrTail",e[e.InTemplateSubstitutionPosition=6]="InTemplateSubstitutionPosition",e))(a0e||{}),o0e=(e=>(e[e.Punctuation=0]="Punctuation",e[e.Keyword=1]="Keyword",e[e.Operator=2]="Operator",e[e.Comment=3]="Comment",e[e.Whitespace=4]="Whitespace",e[e.Identifier=5]="Identifier",e[e.NumberLiteral=6]="NumberLiteral",e[e.BigIntLiteral=7]="BigIntLiteral",e[e.StringLiteral=8]="StringLiteral",e[e.RegExpLiteral=9]="RegExpLiteral",e))(o0e||{}),c0e=(e=>(e.unknown="",e.warning="warning",e.keyword="keyword",e.scriptElement="script",e.moduleElement="module",e.classElement="class",e.localClassElement="local class",e.interfaceElement="interface",e.typeElement="type",e.enumElement="enum",e.enumMemberElement="enum member",e.variableElement="var",e.localVariableElement="local var",e.variableUsingElement="using",e.variableAwaitUsingElement="await using",e.functionElement="function",e.localFunctionElement="local function",e.memberFunctionElement="method",e.memberGetAccessorElement="getter",e.memberSetAccessorElement="setter",e.memberVariableElement="property",e.memberAccessorVariableElement="accessor",e.constructorImplementationElement="constructor",e.callSignatureElement="call",e.indexSignatureElement="index",e.constructSignatureElement="construct",e.parameterElement="parameter",e.typeParameterElement="type parameter",e.primitiveType="primitive type",e.label="label",e.alias="alias",e.constElement="const",e.letElement="let",e.directory="directory",e.externalModuleName="external module name",e.jsxAttribute="JSX attribute",e.string="string",e.link="link",e.linkName="link name",e.linkText="link text",e))(c0e||{}),l0e=(e=>(e.none="",e.publicMemberModifier="public",e.privateMemberModifier="private",e.protectedMemberModifier="protected",e.exportedModifier="export",e.ambientModifier="declare",e.staticModifier="static",e.abstractModifier="abstract",e.optionalModifier="optional",e.deprecatedModifier="deprecated",e.dtsModifier=".d.ts",e.tsModifier=".ts",e.tsxModifier=".tsx",e.jsModifier=".js",e.jsxModifier=".jsx",e.jsonModifier=".json",e.dmtsModifier=".d.mts",e.mtsModifier=".mts",e.mjsModifier=".mjs",e.dctsModifier=".d.cts",e.ctsModifier=".cts",e.cjsModifier=".cjs",e))(l0e||{}),u0e=(e=>(e.comment="comment",e.identifier="identifier",e.keyword="keyword",e.numericLiteral="number",e.bigintLiteral="bigint",e.operator="operator",e.stringLiteral="string",e.whiteSpace="whitespace",e.text="text",e.punctuation="punctuation",e.className="class name",e.enumName="enum name",e.interfaceName="interface name",e.moduleName="module name",e.typeParameterName="type parameter name",e.typeAliasName="type alias name",e.parameterName="parameter name",e.docCommentTagName="doc comment tag name",e.jsxOpenTagName="jsx open tag name",e.jsxCloseTagName="jsx close tag name",e.jsxSelfClosingTagName="jsx self closing tag name",e.jsxAttribute="jsx attribute",e.jsxText="jsx text",e.jsxAttributeStringLiteralValue="jsx attribute string literal value",e))(u0e||{}),tQ=(e=>(e[e.comment=1]="comment",e[e.identifier=2]="identifier",e[e.keyword=3]="keyword",e[e.numericLiteral=4]="numericLiteral",e[e.operator=5]="operator",e[e.stringLiteral=6]="stringLiteral",e[e.regularExpressionLiteral=7]="regularExpressionLiteral",e[e.whiteSpace=8]="whiteSpace",e[e.text=9]="text",e[e.punctuation=10]="punctuation",e[e.className=11]="className",e[e.enumName=12]="enumName",e[e.interfaceName=13]="interfaceName",e[e.moduleName=14]="moduleName",e[e.typeParameterName=15]="typeParameterName",e[e.typeAliasName=16]="typeAliasName",e[e.parameterName=17]="parameterName",e[e.docCommentTagName=18]="docCommentTagName",e[e.jsxOpenTagName=19]="jsxOpenTagName",e[e.jsxCloseTagName=20]="jsxCloseTagName",e[e.jsxSelfClosingTagName=21]="jsxSelfClosingTagName",e[e.jsxAttribute=22]="jsxAttribute",e[e.jsxText=23]="jsxText",e[e.jsxAttributeStringLiteralValue=24]="jsxAttributeStringLiteralValue",e[e.bigintLiteral=25]="bigintLiteral",e))(tQ||{}),q_=xy(99,!0),_0e=(e=>(e[e.None=0]="None",e[e.Value=1]="Value",e[e.Type=2]="Type",e[e.Namespace=4]="Namespace",e[e.All=7]="All",e))(_0e||{});function bU(e){switch(e.kind){case 260:return hn(e)&&w$(e)?7:1;case 169:case 208:case 172:case 171:case 303:case 304:case 174:case 173:case 176:case 177:case 178:case 262:case 218:case 219:case 299:case 291:return 1;case 168:case 264:case 265:case 187:return 2;case 346:return e.name===void 0?3:2;case 306:case 263:return 3;case 267:return B_(e)||N0(e)===1?5:4;case 266:case 275:case 276:case 271:case 272:case 277:case 278:return 7;case 307:return 5}return 7}function S2(e){e=dQ(e);let t=e.parent;return e.kind===307?1:dc(t)||b_(t)||C0(t)||_f(t)||ig(t)||ru(t)&&e===t.name?7:TU(e)?_2t(e):Uh(e)?bU(t):Tf(e)&&Pr(e,Jp(OO,QC,Eb))?7:m2t(e)?2:f2t(e)?4:Ac(t)?(M.assert(sm(t.parent)),2):Mv(t)?3:1}function _2t(e){let t=e.kind===166?e:cf(e.parent)&&e.parent.right===e?e.parent:void 0;return t&&t.parent.kind===271?7:4}function TU(e){for(;e.parent.kind===166;)e=e.parent;return nA(e.parent)&&e.parent.moduleReference===e}function f2t(e){return p2t(e)||d2t(e)}function p2t(e){let t=e,n=!0;if(t.parent.kind===166){for(;t.parent&&t.parent.kind===166;)t=t.parent;n=t.right===e}return t.parent.kind===183&&!n}function d2t(e){let t=e,n=!0;if(t.parent.kind===211){for(;t.parent&&t.parent.kind===211;)t=t.parent;n=t.name===e}if(!n&&t.parent.kind===233&&t.parent.parent.kind===298){let i=t.parent.parent.parent;return i.kind===263&&t.parent.parent.token===119||i.kind===264&&t.parent.parent.token===96}return!1}function m2t(e){switch(YI(e)&&(e=e.parent),e.kind){case 110:return!tg(e);case 197:return!0}switch(e.parent.kind){case 183:return!0;case 205:return!e.parent.isTypeOf;case 233:return Lg(e.parent)}return!1}function rQ(e,t=!1,n=!1){return sM(e,ea,iQ,t,n)}function p6(e,t=!1,n=!1){return sM(e,gE,iQ,t,n)}function nQ(e,t=!1,n=!1){return sM(e,Ig,iQ,t,n)}function f0e(e,t=!1,n=!1){return sM(e,hE,g2t,t,n)}function p0e(e,t=!1,n=!1){return sM(e,fu,iQ,t,n)}function d0e(e,t=!1,n=!1){return sM(e,__,h2t,t,n)}function iQ(e){return e.expression}function g2t(e){return e.tag}function h2t(e){return e.tagName}function sM(e,t,n,i,s){let o=i?m0e(e):EU(e);return s&&(o=Ml(o)),!!o&&!!o.parent&&t(o.parent)&&n(o.parent)===o}function EU(e){return WN(e)?e.parent:e}function m0e(e){return WN(e)||cQ(e)?e.parent:e}function xU(e,t){for(;e;){if(e.kind===256&&e.label.escapedText===t)return e.label;e=e.parent}}function aM(e,t){return Wn(e.expression)?e.expression.name.text===t:!1}function oM(e){var t;return He(e)&&((t=ai(e.parent,gI))==null?void 0:t.label)===e}function sQ(e){var t;return He(e)&&((t=ai(e.parent,rS))==null?void 0:t.label)===e}function aQ(e){return sQ(e)||oM(e)}function oQ(e){var t;return((t=ai(e.parent,jP))==null?void 0:t.tagName)===e}function g0e(e){var t;return((t=ai(e.parent,cf))==null?void 0:t.right)===e}function WN(e){var t;return((t=ai(e.parent,Wn))==null?void 0:t.name)===e}function cQ(e){var t;return((t=ai(e.parent,cc))==null?void 0:t.argumentExpression)===e}function lQ(e){var t;return((t=ai(e.parent,El))==null?void 0:t.name)===e}function uQ(e){var t;return He(e)&&((t=ai(e.parent,Bs))==null?void 0:t.name)===e}function CU(e){switch(e.parent.kind){case 172:case 171:case 303:case 306:case 174:case 173:case 177:case 178:case 267:return Ps(e.parent)===e;case 212:return e.parent.argumentExpression===e;case 167:return!0;case 201:return e.parent.parent.kind===199;default:return!1}}function h0e(e){return cb(e.parent.parent)&&II(e.parent.parent)===e}function b2(e){for(Xd(e)&&(e=e.parent.parent);;){if(e=e.parent,!e)return;switch(e.kind){case 307:case 174:case 173:case 262:case 218:case 177:case 178:case 263:case 264:case 266:case 267:return e}}}function PE(e){switch(e.kind){case 307:return nu(e)?"module":"script";case 267:return"module";case 263:case 231:return"class";case 264:return"interface";case 265:case 338:case 346:return"type";case 266:return"enum";case 260:return t(e);case 208:return t(Bg(e));case 219:case 262:case 218:return"function";case 177:return"getter";case 178:return"setter";case 174:case 173:return"method";case 303:let{initializer:n}=e;return Bs(n)?"method":"property";case 172:case 171:case 304:case 305:return"property";case 181:return"index";case 180:return"construct";case 179:return"call";case 176:case 175:return"constructor";case 168:return"type parameter";case 306:return"enum member";case 169:return li(e,31)?"property":"parameter";case 271:case 276:case 281:case 274:case 280:return"alias";case 226:let i=cl(e),{right:s}=e;switch(i){case 7:case 8:case 9:case 0:return"";case 1:case 2:let u=PE(s);return u===""?"const":u;case 3:return ic(s)?"method":"property";case 4:return"property";case 5:return ic(s)?"method":"property";case 6:return"local class";default:return""}case 80:return ig(e.parent)?"alias":"";case 277:let o=PE(e.expression);return o===""?"const":o;default:return""}function t(n){return zP(n)?"const":Q5(n)?"let":"var"}}function $N(e){switch(e.kind){case 110:return!0;case 80:return GH(e)&&e.parent.kind===169;default:return!1}}var y2t=/^\/\/\/\s*</;function om(e,t){let n=Sy(t),i=t.getLineAndCharacterOfPosition(e).line;return n[i]}function Zp(e,t){return _Q(e.pos,e.end,t)}function y0e(e,t){return lM(e,t.pos)&&lM(e,t.end)}function cM(e,t){return e.pos<=t&&t<=e.end}function lM(e,t){return e.pos<t&&t<e.end}function _Q(e,t,n){return e<=n.pos&&t>=n.end}function uM(e,t,n){return e.pos<=t&&e.end>=n}function d6(e,t,n){return kU(e.pos,e.end,t,n)}function AU(e,t,n,i){return kU(e.getStart(t),e.end,n,i)}function kU(e,t,n,i){let s=Math.max(e,n),o=Math.min(t,i);return s<o}function fQ(e,t,n){return M.assert(e.pos<=t),t<e.end||!ug(e,n)}function ug(e,t){if(e===void 0||$c(e))return!1;switch(e.kind){case 263:case 264:case 266:case 210:case 206:case 187:case 241:case 268:case 269:case 275:case 279:return pQ(e,20,t);case 299:return ug(e.block,t);case 214:if(!e.arguments)return!0;case 213:case 217:case 196:return pQ(e,22,t);case 184:case 185:return ug(e.type,t);case 176:case 177:case 178:case 262:case 218:case 174:case 173:case 180:case 179:case 219:return e.body?ug(e.body,t):e.type?ug(e.type,t):_M(e,22,t);case 267:return!!e.body&&ug(e.body,t);case 245:return e.elseStatement?ug(e.elseStatement,t):ug(e.thenStatement,t);case 244:return ug(e.expression,t)||_M(e,27,t);case 209:case 207:case 212:case 167:case 189:return pQ(e,24,t);case 181:return e.type?ug(e.type,t):_M(e,24,t);case 296:case 297:return!1;case 248:case 249:case 250:case 247:return ug(e.statement,t);case 246:return _M(e,117,t)?pQ(e,22,t):ug(e.statement,t);case 186:return ug(e.exprName,t);case 221:case 220:case 222:case 229:case 230:return ug(e.expression,t);case 215:return ug(e.template,t);case 228:let i=vc(e.templateSpans);return ug(i,t);case 239:return Yd(e.literal);case 278:case 272:return Yd(e.moduleSpecifier);case 224:return ug(e.operand,t);case 226:return ug(e.right,t);case 227:return ug(e.whenFalse,t);default:return!0}}function pQ(e,t,n){let i=e.getChildren(n);if(i.length){let s=Va(i);if(s.kind===t)return!0;if(s.kind===27&&i.length!==1)return i[i.length-2].kind===t}return!1}function v0e(e){let t=PU(e);if(!t)return;let n=t.getChildren();return{listItemIndex:JP(n,e),list:t}}function _M(e,t,n){return!!Oo(e,t,n)}function Oo(e,t,n){return Ln(e.getChildren(n),i=>i.kind===t)}function PU(e){let t=Ln(e.parent.getChildren(),n=>xN(n)&&Zp(n,e));return M.assert(!t||Es(t.getChildren(),e)),t}function p7e(e){return e.kind===90}function v2t(e){return e.kind===86}function S2t(e){return e.kind===100}function b2t(e){if(Wu(e))return e.name;if(tu(e)){let t=e.modifiers&&Ln(e.modifiers,p7e);if(t)return t}if(eu(e)){let t=Ln(e.getChildren(),v2t);if(t)return t}}function T2t(e){if(Wu(e))return e.name;if(Tl(e)){let t=Ln(e.modifiers,p7e);if(t)return t}if(ic(e)){let t=Ln(e.getChildren(),S2t);if(t)return t}}function E2t(e){let t;return Pr(e,n=>(Di(n)&&(t=n),!cf(n.parent)&&!Di(n.parent)&&!$T(n.parent))),t}function NU(e,t){if(e.flags&16777216)return;let n=HU(e,t);if(n)return n;let i=E2t(e);return i&&t.getTypeAtLocation(i)}function x2t(e,t){if(!t)switch(e.kind){case 263:case 231:return b2t(e);case 262:case 218:return T2t(e);case 176:return e}if(Wu(e))return e.name}function d7e(e,t){if(e.importClause){if(e.importClause.name&&e.importClause.namedBindings)return;if(e.importClause.name)return e.importClause.name;if(e.importClause.namedBindings){if(Gg(e.importClause.namedBindings)){let n=Dh(e.importClause.namedBindings.elements);return n?n.name:void 0}else if(My(e.importClause.namedBindings))return e.importClause.namedBindings.name}}if(!t)return e.moduleSpecifier}function m7e(e,t){if(e.exportClause){if(kd(e.exportClause))return Dh(e.exportClause.elements)?e.exportClause.elements[0].name:void 0;if(zh(e.exportClause))return e.exportClause.name}if(!t)return e.moduleSpecifier}function C2t(e){if(e.types.length===1)return e.types[0].expression}function g7e(e,t){let{parent:n}=e;if(Pa(e)&&(t||e.kind!==90)?wm(n)&&Es(n.modifiers,e):e.kind===86?tu(n)||eu(e):e.kind===100?Tl(n)||ic(e):e.kind===120?Yu(n):e.kind===94?bb(n):e.kind===156?im(n):e.kind===145||e.kind===144?El(n):e.kind===102?ru(n):e.kind===139?Hp(n):e.kind===153&&fp(n)){let i=x2t(n,t);if(i)return i}if((e.kind===115||e.kind===87||e.kind===121)&&Ru(n)&&n.declarations.length===1){let i=n.declarations[0];if(He(i.name))return i.name}if(e.kind===156){if(ig(n)&&n.isTypeOnly){let i=d7e(n.parent,t);if(i)return i}if(xl(n)&&n.isTypeOnly){let i=m7e(n,t);if(i)return i}}if(e.kind===130){if(_f(n)&&n.propertyName||b_(n)&&n.propertyName||My(n)||zh(n))return n.name;if(xl(n)&&n.exportClause&&zh(n.exportClause))return n.exportClause.name}if(e.kind===102&&Yc(n)){let i=d7e(n,t);if(i)return i}if(e.kind===95){if(xl(n)){let i=m7e(n,t);if(i)return i}if(dc(n))return Ml(n.expression)}if(e.kind===149&&C0(n))return n.expression;if(e.kind===161&&(Yc(n)||xl(n))&&n.moduleSpecifier)return n.moduleSpecifier;if((e.kind===96||e.kind===119)&&pp(n)&&n.token===e.kind){let i=C2t(n);if(i)return i}if(e.kind===96){if(Ac(n)&&n.constraint&&Gp(n.constraint))return n.constraint.typeName;if(dE(n)&&Gp(n.extendsType))return n.extendsType.typeName}if(e.kind===140&&s2(n))return n.typeParameter.name;if(e.kind===103&&Ac(n)&&o2(n.parent))return n.name;if(e.kind===143&&yb(n)&&n.operator===143&&Gp(n.type))return n.type.typeName;if(e.kind===148&&yb(n)&&n.operator===148&&_8(n.type)&&Gp(n.type.elementType))return n.type.elementType.typeName;if(!t){if((e.kind===105&&gE(n)||e.kind===116&&BA(n)||e.kind===114&&vN(n)||e.kind===135&&eS(n)||e.kind===127&&Rj(n)||e.kind===91&&zde(n))&&n.expression)return Ml(n.expression);if((e.kind===103||e.kind===104)&&Pn(n)&&n.operatorToken===e)return Ml(n.right);if(e.kind===130&&CO(n)&&Gp(n.type))return n.type.typeName;if(e.kind===103&&Fj(n)||e.kind===165&&f8(n))return Ml(n.expression)}return e}function dQ(e){return g7e(e,!1)}function DU(e){return g7e(e,!0)}function wf(e,t){return HN(e,t,n=>jg(n)||sf(n.kind)||Zi(n))}function HN(e,t,n){return h7e(e,t,!1,n,!1)}function Yi(e,t){return h7e(e,t,!0,void 0,!1)}function h7e(e,t,n,i,s){let o=e,u;e:for(;;){let d=o.getChildren(e),S=BC(d,t,(E,x)=>x,(E,x)=>{let D=d[E].getEnd();if(D<t)return-1;let w=n?d[E].getFullStart():d[E].getStart(e,!0);return w>t?1:m(d[E],w,D)?d[E-1]&&m(d[E-1])?1:0:i&&w===t&&d[E-1]&&d[E-1].getEnd()===t&&m(d[E-1])?1:-1});if(u)return u;if(S>=0&&d[S]){o=d[S];continue e}return o}function m(d,S,E){if(E??(E=d.getEnd()),E<t||(S??(S=n?d.getFullStart():d.getStart(e,!0)),S>t))return!1;if(t<E||t===E&&(d.kind===1||s))return!0;if(i&&E===t){let x=iu(t,e,d);if(x&&i(x))return u=x,!0}return!1}}function S0e(e,t){let n=Yi(e,t);for(;IU(n);){let i=NE(n,n.parent,e);if(!i)return;n=i}return n}function wU(e,t){let n=Yi(e,t);return HC(n)&&t>n.getStart(e)&&t<n.getEnd()?n:iu(t,e)}function NE(e,t,n){return i(t);function i(s){return HC(s)&&s.pos===e.end?s:yi(s.getChildren(n),o=>(o.pos<=e.pos&&o.end>e.end||o.pos===e.end)&&k0e(o,n)?i(o):void 0)}}function iu(e,t,n,i){let s=o(n||t);return M.assert(!(s&&IU(s))),s;function o(u){if(y7e(u)&&u.kind!==1)return u;let m=u.getChildren(t),d=BC(m,e,(E,x)=>x,(E,x)=>e<m[E].end?!m[E-1]||e>=m[E-1].end?0:1:-1);if(d>=0&&m[d]){let E=m[d];if(e<E.end)if(E.getStart(t,!i)>=e||!k0e(E,t)||IU(E)){let w=T0e(m,d,t,u.kind);return w?!i&&L5(w)&&w.getChildren(t).length?o(w):b0e(w,t):void 0}else return o(E)}M.assert(n!==void 0||u.kind===307||u.kind===1||L5(u));let S=T0e(m,m.length,t,u.kind);return S&&b0e(S,t)}}function y7e(e){return HC(e)&&!IU(e)}function b0e(e,t){if(y7e(e))return e;let n=e.getChildren(t);if(n.length===0)return e;let i=T0e(n,n.length,t,e.kind);return i&&b0e(i,t)}function T0e(e,t,n,i){for(let s=t-1;s>=0;s--){let o=e[s];if(IU(o))s===0&&(i===12||i===285)&&M.fail("`JsxText` tokens should not be the first child of `JsxElement | JsxSelfClosingElement`");else if(k0e(e[s],n))return e[s]}}function ik(e,t,n=iu(t,e)){if(n&&j$(n)){let i=n.getStart(e),s=n.getEnd();if(i<t&&t<s)return!0;if(t===s)return!!n.isUnterminated}return!1}function E0e(e,t){let n=Yi(e,t);return n?!!(n.kind===12||n.kind===30&&n.parent.kind===12||n.kind===30&&n.parent.kind===294||n&&n.kind===20&&n.parent.kind===294||n.kind===30&&n.parent.kind===287):!1}function IU(e){return DA(e)&&e.containsOnlyTriviaWhiteSpaces}function mQ(e,t){let n=Yi(e,t);return B1(n.kind)&&t>n.getStart(e)}function x0e(e,t){let n=Yi(e,t);return!!(DA(n)||n.kind===19&&wO(n.parent)&&Ly(n.parent.parent)||n.kind===30&&__(n.parent)&&Ly(n.parent.parent))}function OU(e,t){function n(i){for(;i;)if(i.kind>=285&&i.kind<=294||i.kind===12||i.kind===30||i.kind===32||i.kind===80||i.kind===20||i.kind===19||i.kind===44)i=i.parent;else if(i.kind===284){if(t>i.getStart(e))return!0;i=i.parent}else return!1;return!1}return n(Yi(e,t))}function RU(e,t,n){let i=Sa(e.kind),s=Sa(t),o=e.getFullStart(),u=n.text.lastIndexOf(s,o);if(u===-1)return;if(n.text.lastIndexOf(i,o-1)<u){let S=iu(u+1,n);if(S&&S.kind===t)return S}let m=e.kind,d=0;for(;;){let S=iu(e.getFullStart(),n);if(!S)return;if(e=S,e.kind===t){if(d===0)return e;d--}else e.kind===m&&d++}}function C0e(e,t,n){return t?e.getNonNullableType():n?e.getNonOptionalType():e}function fM(e,t,n){let i=hQ(e,t);return i!==void 0&&(Lg(i.called)||gQ(i.called,i.nTypeArguments,n).length!==0||fM(i.called,t,n))}function gQ(e,t,n){let i=n.getTypeAtLocation(e);return S_(e.parent)&&(i=C0e(i,dI(e.parent),!0)),(gE(e.parent)?i.getConstructSignatures():i.getCallSignatures()).filter(o=>!!o.typeParameters&&o.typeParameters.length>=t)}function hQ(e,t){if(t.text.lastIndexOf("<",e?e.pos:t.text.length)===-1)return;let n=e,i=0,s=0;for(;n;){switch(n.kind){case 30:if(n=iu(n.getFullStart(),t),n&&n.kind===29&&(n=iu(n.getFullStart(),t)),!n||!He(n))return;if(!i)return Uh(n)?void 0:{called:n,nTypeArguments:s};i--;break;case 50:i=3;break;case 49:i=2;break;case 32:i++;break;case 20:if(n=RU(n,19,t),!n)return;break;case 22:if(n=RU(n,21,t),!n)return;break;case 24:if(n=RU(n,23,t),!n)return;break;case 28:s++;break;case 39:case 80:case 11:case 9:case 10:case 112:case 97:case 114:case 96:case 143:case 25:case 52:case 58:case 59:break;default:if(Di(n))break;return}n=iu(n.getFullStart(),t)}}function Bv(e,t,n){return zl.getRangeOfEnclosingComment(e,t,void 0,n)}function A0e(e,t){let n=Yi(e,t);return!!Pr(n,ag)}function k0e(e,t){return e.kind===1?!!e.jsDoc:e.getWidth(t)!==0}function m6(e,t=0){let n=[],i=u_(e)?A$(e)&~t:0;return i&2&&n.push("private"),i&4&&n.push("protected"),i&1&&n.push("public"),(i&256||Gc(e))&&n.push("static"),i&64&&n.push("abstract"),i&32&&n.push("export"),i&65536&&n.push("deprecated"),e.flags&33554432&&n.push("declare"),e.kind===277&&n.push("export"),n.length>0?n.join(","):""}function P0e(e){if(e.kind===183||e.kind===213)return e.typeArguments;if(Bs(e)||e.kind===263||e.kind===264)return e.typeParameters}function MU(e){return e===2||e===3}function yQ(e){return!!(e===11||e===14||B1(e))}function v7e(e,t,n){return!!(t.flags&4)&&e.isEmptyAnonymousObjectType(n)}function N0e(e){if(!e.isIntersection())return!1;let{types:t,checker:n}=e;return t.length===2&&(v7e(n,t[0],t[1])||v7e(n,t[1],t[0]))}function pM(e,t,n){return B1(e.kind)&&e.getStart(n)<t&&t<e.end||!!e.isUnterminated&&t===e.end}function vQ(e){switch(e){case 125:case 123:case 124:return!0}return!1}function SQ(e){let t=Jce(e);return HY(t,e&&e.configFile),t}function Uv(e){return!!((e.kind===209||e.kind===210)&&(e.parent.kind===226&&e.parent.left===e&&e.parent.operatorToken.kind===64||e.parent.kind===250&&e.parent.initializer===e||Uv(e.parent.kind===303?e.parent.parent:e.parent)))}function D0e(e,t){return S7e(e,t,!0)}function w0e(e,t){return S7e(e,t,!1)}function S7e(e,t,n){let i=Bv(e,t,void 0);return!!i&&n===y2t.test(e.text.substring(i.pos,i.end))}function bQ(e,t){if(e)switch(e.kind){case 11:case 15:return TQ(e,t);default:return df(e)}}function df(e,t,n){return Il(e.getStart(t),(n||e).getEnd())}function TQ(e,t){let n=e.getEnd()-1;if(e.isUnterminated){if(e.getStart()===n)return;n=Math.min(t,e.getEnd())}return Il(e.getStart()+1,n)}function EQ(e,t){return Td(e.getStart(t),e.end)}function lS(e){return Il(e.pos,e.end)}function LU(e){return Td(e.start,e.start+e.length)}function FU(e,t,n){return dM(zu(e,t),n)}function dM(e,t){return{span:e,newText:t}}var xQ=[133,131,163,136,97,140,143,146,106,150,151,148,154,155,114,112,116,157,158,159];function g6(e){return Es(xQ,e)}function CQ(e){return e.kind===156}function jU(e){return CQ(e)||He(e)&&e.text==="type"}function GN(){let e=[];return t=>{let n=yo(t);return!e[n]&&(e[n]=!0)}}function sk(e){return e.getText(0,e.getLength())}function mM(e,t){let n="";for(let i=0;i<t;i++)n+=e;return n}function AQ(e){return e.isTypeParameter()&&e.getConstraint()||e}function gM(e){return e.kind===167?zp(e.expression)?e.expression.text:void 0:Zi(e)?Nn(e):Qd(e)}function I0e(e){return e.getSourceFiles().some(t=>!t.isDeclarationFile&&!e.isSourceFileFromExternalLibrary(t)&&!!(t.externalModuleIndicator||t.commonJsModuleIndicator))}function O0e(e){return e.getSourceFiles().some(t=>!t.isDeclarationFile&&!e.isSourceFileFromExternalLibrary(t)&&!!t.externalModuleIndicator)}function kQ(e){return!!e.module||Ka(e)>=2||!!e.noEmit}function ak(e,t){return{fileExists:n=>e.fileExists(n),getCurrentDirectory:()=>t.getCurrentDirectory(),readFile:ia(t,t.readFile),useCaseSensitiveFileNames:ia(t,t.useCaseSensitiveFileNames),getSymlinkCache:ia(t,t.getSymlinkCache)||e.getSymlinkCache,getModuleSpecifierCache:ia(t,t.getModuleSpecifierCache),getPackageJsonInfoCache:()=>{var n;return(n=e.getModuleResolutionCache())==null?void 0:n.getPackageJsonInfoCache()},getGlobalTypingsCacheLocation:ia(t,t.getGlobalTypingsCacheLocation),redirectTargetsMap:e.redirectTargetsMap,getProjectReferenceRedirect:n=>e.getProjectReferenceRedirect(n),isSourceOfProjectReferenceRedirect:n=>e.isSourceOfProjectReferenceRedirect(n),getNearestAncestorDirectoryWithPackageJson:ia(t,t.getNearestAncestorDirectoryWithPackageJson),getFileIncludeReasons:()=>e.getFileIncludeReasons(),getCommonSourceDirectory:()=>e.getCommonSourceDirectory()}}function PQ(e,t){return{...ak(e,t),getCommonSourceDirectory:()=>e.getCommonSourceDirectory()}}function BU(e){return e===2||e>=3&&e<=99||e===100}function uS(e,t,n,i,s){return U.createImportDeclaration(void 0,e||t?U.createImportClause(!!s,e,t&&t.length?U.createNamedImports(t):void 0):void 0,typeof n=="string"?h6(n,i):n,void 0)}function h6(e,t){return U.createStringLiteral(e,t===0)}var R0e=(e=>(e[e.Single=0]="Single",e[e.Double=1]="Double",e))(R0e||{});function NQ(e,t){return d9(e,t)?1:0}function ed(e,t){if(t.quotePreference&&t.quotePreference!=="auto")return t.quotePreference==="single"?0:1;{let n=Av(e)&&e.imports&&Ln(e.imports,i=>La(i)&&!Ko(i.parent));return n?NQ(n,e):1}}function DQ(e){switch(e){case 0:return"'";case 1:return'"';default:return M.assertNever(e)}}function wQ(e){let t=UU(e);return t===void 0?void 0:Qi(t)}function UU(e){return e.escapedName!=="default"?e.escapedName:yi(e.declarations,t=>{let n=Ps(t);return n&&n.kind===80?n.escapedText:void 0})}function VU(e){return No(e)&&(C0(e.parent)||Yc(e.parent)||Xg(e.parent)||kf(e.parent,!1)&&e.parent.arguments[0]===e||Np(e.parent)&&e.parent.arguments[0]===e)}function hM(e){return Xa(e)&&Yp(e.parent)&&He(e.name)&&!e.propertyName}function JU(e,t){let n=e.getTypeAtLocation(t.parent);return n&&e.getPropertyOfType(n,t.name.text)}function yM(e,t,n){if(e)for(;e.parent;){if(Ji(e.parent)||!A2t(n,e.parent,t))return e;e=e.parent}}function A2t(e,t,n){return C$(e,t.getStart(n))&&t.getEnd()<=bl(e)}function YN(e,t){return wm(e)?Ln(e.modifiers,n=>n.kind===t):void 0}function IQ(e,t,n,i,s){var o;let m=(Rs(n)?n[0]:n).kind===243?fR:eA,d=Zn(t.statements,m),{comparer:S,isSorted:E}=Ub.getOrganizeImportsStringComparerWithDetection(d,s),x=Rs(n)?Qs(n,(D,w)=>Ub.compareImportsOrRequireStatements(D,w,S)):[n];if(!d?.length){if(Av(t))e.insertNodesAtTopOfFile(t,x,i);else for(let D of x)e.insertStatementsInNewFile(t.fileName,[D],(o=Bc(D))==null?void 0:o.getSourceFile());return}if(M.assert(Av(t)),d&&E)for(let D of x){let w=Ub.getImportDeclarationInsertionIndex(d,D,S);if(w===0){let R=d[0]===t.statements[0]?{leadingTriviaOption:Sn.LeadingTriviaOption.Exclude}:{};e.insertNodeBefore(t,d[0],D,!1,R)}else{let R=d[w-1];e.insertNodeAfter(t,R,D)}}else{let D=vc(d);D?e.insertNodesAfter(t,D,x):e.insertNodesAtTopOfFile(t,x,i)}}function OQ(e,t){return M.assert(e.isTypeOnly),aa(e.getChildAt(0,t),CQ)}function KN(e,t){return!!e&&!!t&&e.start===t.start&&e.length===t.length}function RQ(e,t,n){return(n?Lx:KS)(e.fileName,t.fileName)&&KN(e.textSpan,t.textSpan)}function MQ(e){return(t,n)=>RQ(t,n,e)}function LQ(e,t){if(e){for(let n=0;n<e.length;n++)if(e.indexOf(e[n])===n){let i=t(e[n],n);if(i)return i}}}function M0e(e,t,n){for(let i=t;i<n;i++)if(!by(e.charCodeAt(i)))return!1;return!0}function y6(e,t,n){let i=t.tryGetSourcePosition(e);return i&&(!n||n(Zs(i.fileName))?i:void 0)}function qU(e,t,n){let{fileName:i,textSpan:s}=e,o=y6({fileName:i,pos:s.start},t,n);if(!o)return;let u=y6({fileName:i,pos:s.start+s.length},t,n),m=u?u.pos-o.pos:s.length;return{fileName:o.fileName,textSpan:{start:o.pos,length:m},originalFileName:e.fileName,originalTextSpan:e.textSpan,contextSpan:FQ(e,t,n),originalContextSpan:e.contextSpan}}function FQ(e,t,n){let i=e.contextSpan&&y6({fileName:e.fileName,pos:e.contextSpan.start},t,n),s=e.contextSpan&&y6({fileName:e.fileName,pos:e.contextSpan.start+e.contextSpan.length},t,n);return i&&s?{start:i.pos,length:s.pos-i.pos}:void 0}function jQ(e){let t=e.declarations?xo(e.declarations):void 0;return!!Pr(t,n=>ns(n)?!0:Xa(n)||Yp(n)||Lv(n)?!1:"quit")}var L0e=k2t();function k2t(){let e=xI*10,t,n,i,s;E();let o=x=>m(x,17);return{displayParts:()=>{let x=t.length&&t[t.length-1].text;return s>e&&x&&x!=="..."&&(by(x.charCodeAt(x.length-1))||t.push(Jf(" ",16)),t.push(Jf("...",15))),t},writeKeyword:x=>m(x,5),writeOperator:x=>m(x,12),writePunctuation:x=>m(x,15),writeTrailingSemicolon:x=>m(x,15),writeSpace:x=>m(x,16),writeStringLiteral:x=>m(x,8),writeParameter:x=>m(x,13),writeProperty:x=>m(x,14),writeLiteral:x=>m(x,8),writeSymbol:d,writeLine:S,write:o,writeComment:o,getText:()=>"",getTextPos:()=>0,getColumn:()=>0,getLine:()=>0,isAtStartOfLine:()=>!1,hasTrailingWhitespace:()=>!1,hasTrailingComment:()=>!1,rawWrite:_a,getIndent:()=>i,increaseIndent:()=>{i++},decreaseIndent:()=>{i--},clear:E};function u(){if(!(s>e)&&n){let x=x9(i);x&&(s+=x.length,t.push(Jf(x,16))),n=!1}}function m(x,D){s>e||(u(),s+=x.length,t.push(Jf(x,D)))}function d(x,D){s>e||(u(),s+=x.length,t.push(F0e(x,D)))}function S(){s>e||(s+=1,t.push(XN()),n=!0)}function E(){t=[],n=!0,i=0,s=0}}function F0e(e,t){return Jf(e,n(t));function n(i){let s=i.flags;return s&3?jQ(i)?13:9:s&4||s&32768||s&65536?14:s&8?19:s&16?20:s&32?1:s&64?4:s&384?2:s&1536?11:s&8192?10:s&262144?18:s&524288||s&2097152?0:17}}function Jf(e,t){return{text:e,kind:SU[t]}}function Zc(){return Jf(" ",16)}function mp(e){return Jf(Sa(e),5)}function C_(e){return Jf(Sa(e),15)}function v6(e){return Jf(Sa(e),12)}function j0e(e){return Jf(e,13)}function B0e(e){return Jf(e,14)}function BQ(e){let t=JT(e);return t===void 0?td(e):mp(t)}function td(e){return Jf(e,17)}function U0e(e){return Jf(e,0)}function V0e(e){return Jf(e,18)}function zU(e){return Jf(e,24)}function J0e(e,t){return{text:e,kind:SU[23],target:{fileName:Ur(t).fileName,textSpan:df(t)}}}function UQ(e){return Jf(e,22)}function q0e(e,t){var n;let i=Xde(e)?"link":Qde(e)?"linkcode":"linkplain",s=[UQ(`{@${i} `)];if(!e.name)e.text&&s.push(zU(e.text));else{let o=t?.getSymbolAtLocation(e.name),u=o&&t?qQ(o,t):void 0,m=N2t(e.text),d=Hc(e.name)+e.text.slice(0,m),S=P2t(e.text.slice(m)),E=u?.valueDeclaration||((n=u?.declarations)==null?void 0:n[0]);if(E)s.push(J0e(d,E)),S&&s.push(zU(S));else{let x=m===0||e.text.charCodeAt(m)===124&&d.charCodeAt(d.length-1)!==32?" ":"";s.push(zU(d+x+S))}}return s.push(UQ("}")),s}function P2t(e){let t=0;if(e.charCodeAt(t++)===124){for(;t<e.length&&e.charCodeAt(t)===32;)t++;return e.slice(t)}return e}function N2t(e){let t=e.indexOf("://");if(t===0){for(;t<e.length&&e.charCodeAt(t)!==124;)t++;return t}if(e.indexOf("()")===0)return 2;if(e.charAt(0)==="<"){let n=0,i=0;for(;i<e.length;)if(e[i]==="<"&&n++,e[i]===">"&&n--,i++,!n)return i}return 0}var D2t=`
`;function Vv(e,t){var n;return t?.newLineCharacter||((n=e.getNewLine)==null?void 0:n.call(e))||D2t}function XN(){return Jf(`
`,6)}function _S(e){try{return e(L0e),L0e.displayParts()}finally{L0e.clear()}}function vM(e,t,n,i=0){return _S(s=>{e.writeType(t,n,i|1024|16384,s)})}function S6(e,t,n,i,s=0){return _S(o=>{e.writeSymbol(t,n,i,s|8,o)})}function VQ(e,t,n,i=0){return i|=25632,_S(s=>{e.writeSignature(t,n,i,void 0,s)})}function b7e(e,t){let n=t.getSourceFile();return _S(i=>{VB().writeNode(4,e,n,i)})}function z0e(e){return!!e.parent&&GC(e.parent)&&e.parent.propertyName===e}function JQ(e,t){return nj(e,t.getScriptKind&&t.getScriptKind(e))}function qQ(e,t){let n=e;for(;w2t(n)||jh(n)&&n.links.target;)jh(n)&&n.links.target?n=n.links.target:n=$u(n,t);return n}function w2t(e){return(e.flags&2097152)!==0}function W0e(e,t){return Aa($u(e,t))}function $0e(e,t){for(;by(e.charCodeAt(t));)t+=1;return t}function WU(e,t){for(;t>-1&&wg(e.charCodeAt(t));)t-=1;return t+1}function Co(e,t=!0){let n=e&&T7e(e);return n&&!t&&gp(n),T0(n,!1)}function SM(e,t,n){let i=n(e);return i?zn(i,e):i=T7e(e,n),i&&!t&&gp(i),i}function T7e(e,t){let n=t?o=>SM(o,!0,t):Co,s=Mr(e,n,void 0,t?o=>o&&zQ(o,!0,t):o=>o&&DE(o),n);if(s===e){let o=La(e)?zn(U.createStringLiteralFromNode(e),e):Pf(e)?zn(U.createNumericLiteral(e.text,e.numericLiteralFlags),e):U.cloneNode(e);return Et(o,e)}return s.parent=void 0,s}function DE(e,t=!0){if(e){let n=U.createNodeArray(e.map(i=>Co(i,t)),e.hasTrailingComma);return Et(n,e),n}return e}function zQ(e,t,n){return U.createNodeArray(e.map(i=>SM(i,t,n)),e.hasTrailingComma)}function gp(e){WQ(e),H0e(e)}function WQ(e){G0e(e,1024,O2t)}function H0e(e){G0e(e,2048,lG)}function T2(e,t){let n=e.getSourceFile(),i=n.text;I2t(e,i)?QN(e,t,n):TM(e,t,n),b6(e,t,n)}function I2t(e,t){let n=e.getFullStart(),i=e.getStart();for(let s=n;s<i;s++)if(t.charCodeAt(s)===10)return!0;return!1}function G0e(e,t,n){zg(e,t);let i=n(e);i&&G0e(i,t,n)}function O2t(e){return e.forEachChild(t=>t)}function E2(e,t){let n=e;for(let i=1;!W5(t,n);i++)n=`${e}_${i}`;return n}function bM(e,t,n,i){let s=0,o=-1;for(let{fileName:u,textChanges:m}of e){M.assert(u===t);for(let d of m){let{span:S,newText:E}=d,x=R2t(E,Vh(n));if(x!==-1&&(o=S.start+s+x,!i))return o;s+=E.length-S.length}}return M.assert(i),M.assert(o>=0),o}function QN(e,t,n,i,s){x3(n.text,e.pos,Y0e(t,n,i,s,vO))}function b6(e,t,n,i,s){C3(n.text,e.end,Y0e(t,n,i,s,Tj))}function TM(e,t,n,i,s){C3(n.text,e.pos,Y0e(t,n,i,s,vO))}function Y0e(e,t,n,i,s){return(o,u,m,d)=>{m===3?(o+=2,u-=2):o+=2,s(e,n||m,t.text.slice(o,u),i!==void 0?i:d)}}function R2t(e,t){if(_s(e,t))return 0;let n=e.indexOf(" "+t);return n===-1&&(n=e.indexOf("."+t)),n===-1&&(n=e.indexOf('"'+t)),n===-1?-1:n+1}function $U(e){return Pn(e)&&e.operatorToken.kind===28||Ca(e)||(CO(e)||Mj(e))&&Ca(e.expression)}function HU(e,t,n){let i=g0(e.parent);switch(i.kind){case 214:return t.getContextualType(i,n);case 226:{let{left:s,operatorToken:o,right:u}=i;return GU(o.kind)?t.getTypeAtLocation(e===u?s:u):t.getContextualType(e,n)}case 296:return HQ(i,t);default:return t.getContextualType(e,n)}}function T6(e,t,n){let i=ed(e,t),s=JSON.stringify(n);return i===0?`'${Zd(s).replace(/'/g,()=>"\\'").replace(/\\"/g,'"')}'`:s}function GU(e){switch(e){case 37:case 35:case 38:case 36:return!0;default:return!1}}function K0e(e){switch(e.kind){case 11:case 15:case 228:case 215:return!0;default:return!1}}function $Q(e){return!!e.getStringIndexType()||!!e.getNumberIndexType()}function HQ(e,t){return t.getTypeAtLocation(e.parent.parent.expression)}var GQ="anonymous function";function E6(e,t,n,i){let s=n.getTypeChecker(),o=!0,u=()=>o=!1,m=s.typeToTypeNode(e,t,1,{trackSymbol:(d,S,E)=>(o=o&&s.isSymbolAccessible(d,S,E,!1).accessibility===0,!o),reportInaccessibleThisError:u,reportPrivateInBaseOfClassExpression:u,reportInaccessibleUniqueSymbolError:u,moduleResolverHost:PQ(n,i)});return o?m:void 0}function X0e(e){return e===179||e===180||e===181||e===171||e===173}function E7e(e){return e===262||e===176||e===174||e===177||e===178}function x7e(e){return e===267}function YU(e){return e===243||e===244||e===246||e===251||e===252||e===253||e===257||e===259||e===172||e===265||e===272||e===271||e===278||e===270||e===277}var Q0e=Jp(X0e,E7e,x7e,YU);function M2t(e,t){let n=e.getLastToken(t);if(n&&n.kind===27)return!1;if(X0e(e.kind)){if(n&&n.kind===28)return!1}else if(x7e(e.kind)){let m=Va(e.getChildren(t));if(m&&Hg(m))return!1}else if(E7e(e.kind)){let m=Va(e.getChildren(t));if(m&&XT(m))return!1}else if(!YU(e.kind))return!1;if(e.kind===246)return!0;let i=Pr(e,m=>!m.parent),s=NE(e,i,t);if(!s||s.kind===20)return!0;let o=t.getLineAndCharacterOfPosition(e.getEnd()).line,u=t.getLineAndCharacterOfPosition(s.getStart(t)).line;return o!==u}function KU(e,t,n){let i=Pr(t,s=>s.end!==e?"quit":Q0e(s.kind));return!!i&&M2t(i,n)}function EM(e){let t=0,n=0,i=5;return Js(e,function s(o){if(YU(o.kind)){let u=o.getLastToken(e);u?.kind===27?t++:n++}else if(X0e(o.kind)){let u=o.getLastToken(e);if(u?.kind===27)t++;else if(u&&u.kind!==28){let m=ba(e,u.getStart(e)).line,d=ba(e,Bh(e,u.end).start).line;m!==d&&n++}}return t+n>=i?!0:Js(o,s)}),t===0&&n<=1?!0:t/n>1/i}function XU(e,t){return eV(e,e.getDirectories,t)||[]}function YQ(e,t,n,i,s){return eV(e,e.readDirectory,t,n,i,s)||ve}function xM(e,t){return eV(e,e.fileExists,t)}function QU(e,t){return ZU(()=>rg(t,e))||!1}function ZU(e){try{return e()}catch{return}}function eV(e,t,...n){return ZU(()=>t&&t.apply(e,n))}function KQ(e,t,n){let i=[];return Am(e,s=>{if(s===n)return!0;let o=ri(s,"package.json");xM(t,o)&&i.push(o)}),i}function Z0e(e,t){let n;return Am(e,i=>{if(i==="node_modules"||(n=HK(i,s=>xM(t,s),"package.json"),n))return!0}),n}function eve(e,t){if(!t.fileExists)return[];let n=[];return Am(mi(e),i=>{let s=ri(i,"package.json");if(t.fileExists(s)){let o=XQ(s,t);o&&n.push(o)}}),n}function XQ(e,t){if(!t.readFile)return;let n=["dependencies","devDependencies","optionalDependencies","peerDependencies"],i=t.readFile(e)||"",s=L9(i),o={};if(s)for(let d of n){let S=s[d];if(!S)continue;let E=new Map;for(let x in S)E.set(x,S[x]);o[d]=E}let u=[[1,o.dependencies],[2,o.devDependencies],[8,o.optionalDependencies],[4,o.peerDependencies]];return{...o,parseable:!!s,fileName:e,get:m,has(d,S){return!!m(d,S)}};function m(d,S=15){for(let[E,x]of u)if(x&&S&E){let D=x.get(d);if(D!==void 0)return D}}}function ZN(e,t,n){let i=(n.getPackageJsonsVisibleToFile&&n.getPackageJsonsVisibleToFile(e.fileName)||eve(e.fileName,n)).filter(R=>R.parseable),s,o,u;return{allowsImportingAmbientModule:d,allowsImportingSourceFile:S,allowsImportingSpecifier:E};function m(R){let L=w(R);for(let F of i)if(F.has(L)||F.has(EB(L)))return!0;return!1}function d(R,L){if(!i.length||!R.valueDeclaration)return!0;if(!o)o=new Map;else{let ee=o.get(R);if(ee!==void 0)return ee}let F=Zd(R.getName());if(x(F))return o.set(R,!0),!0;let J=R.valueDeclaration.getSourceFile(),G=D(J.fileName,L);if(typeof G>"u")return o.set(R,!0),!0;let q=m(G)||m(F);return o.set(R,q),q}function S(R,L){if(!i.length)return!0;if(!u)u=new Map;else{let G=u.get(R);if(G!==void 0)return G}let F=D(R.fileName,L);if(!F)return u.set(R,!0),!0;let J=m(F);return u.set(R,J),J}function E(R){return!i.length||x(R)||qp(R)||ip(R)?!0:m(R)}function x(R){return!!(Av(e)&&Af(e)&&eh.nodeCoreModules.has(R)&&(s===void 0&&(s=tV(e)),s))}function D(R,L){if(!R.includes("node_modules"))return;let F=wb.getNodeModulesPackageName(n.getCompilationSettings(),e,R,L,t);if(F&&!qp(F)&&!ip(F))return w(F)}function w(R){let L=hu(GO(R)).slice(1);return _s(L[0],"@")?`${L[0]}/${L[1]}`:L[0]}}function tV(e){return Pt(e.imports,({text:t})=>eh.nodeCoreModules.has(t))}function CM(e){return Es(hu(e),"node_modules")}function QQ(e){return e.file!==void 0&&e.start!==void 0&&e.length!==void 0}function tve(e,t){let n=df(e),i=BC(t,n,ec,e5);if(i>=0){let s=t[i];return M.assertEqual(s.file,e.getSourceFile(),"Diagnostics proided to 'findDiagnosticForNode' must be from a single SourceFile"),aa(s,QQ)}}function rve(e,t){var n;let i=BC(t,e.start,u=>u.start,tc);for(i<0&&(i=~i);((n=t[i-1])==null?void 0:n.start)===e.start;)i--;let s=[],o=bl(e);for(;;){let u=ai(t[i],QQ);if(!u||u.start>o)break;Pue(e,u)&&s.push(u),i++}return s}function ok({startPosition:e,endPosition:t}){return Il(e,t===void 0?e:t)}function ZQ(e,t){let n=Yi(e,t.start);return Pr(n,s=>s.getStart(e)<t.start||s.getEnd()>bl(t)?"quit":Ct(s)&&KN(t,df(s,e)))}function eZ(e,t,n=ec){return e?Rs(e)?n(Cr(e,t)):t(e,0):void 0}function tZ(e){return Rs(e)?Ma(e):e}function nve(e,t){if(C7e(e)){let n=nV(e);if(n)return n;let i=x6(iV(e),t,!1),s=x6(iV(e),t,!0);return i===s?i:[i,s]}return e.name}function rV(e,t,n){return C7e(e)?nV(e)||x6(iV(e),t,!!n):e.name}function C7e(e){return!(e.flags&33554432)&&(e.escapedName==="export="||e.escapedName==="default")}function nV(e){return yi(e.declarations,t=>{var n,i,s;return dc(t)?(n=ai(Ml(t.expression),He))==null?void 0:n.text:b_(t)&&t.symbol.flags===2097152?(i=ai(t.propertyName,He))==null?void 0:i.text:(s=ai(Ps(t),He))==null?void 0:s.text})}function iV(e){var t;return M.checkDefined(e.parent,`Symbol parent was undefined. Flags: ${M.formatSymbolFlags(e.flags)}. Declarations: ${(t=e.declarations)==null?void 0:t.map(n=>{let i=M.formatSyntaxKind(n.kind),s=hn(n),{expression:o}=n;return(s?"[JS]":"")+i+(o?` (expression: ${M.formatSyntaxKind(o.kind)})`:"")}).join(", ")}.`)}function x6(e,t,n){return AM(of(Zd(e.name)),t,n)}function AM(e,t,n){let i=Ul(AP(e,"/index")),s="",o=!0,u=i.charCodeAt(0);Ey(u,t)?(s+=String.fromCharCode(u),n&&(s=s.toUpperCase())):o=!1;for(let m=1;m<i.length;m++){let d=i.charCodeAt(m),S=yv(d,t);if(S){let E=String.fromCharCode(d);o||(E=E.toUpperCase()),s+=E}o=S}return uA(s)?`_${s}`:s||"_"}function ive(e,t,n){let i=t.length;if(i+n>e.length)return!1;for(let s=0;s<i;s++)if(t.charCodeAt(s)!==e.charCodeAt(s+n))return!1;return!0}function rZ(e){return e.charCodeAt(0)===95}function A7e(e){return!sve(e)}function sve(e){let t=e.getSourceFile();return!t.externalModuleIndicator&&!t.commonJsModuleIndicator?!1:hn(e)||!Pr(e,n=>El(n)&&Rg(n))}function sV(e){return!!(A$(e)&65536)}function aV(e,t){return yi(e.imports,i=>{if(eh.nodeCoreModules.has(i.text))return _s(i.text,"node:")})??t.usesUriStyleNodeCoreModules}function kM(e){return e===`
`?1:0}function wE(e){return Rs(e)?wy(Ms(e[0]),e.slice(1)):Ms(e)}function oV({options:e},t){let n=!e.semicolons||e.semicolons==="ignore",i=e.semicolons==="remove"||n&&!EM(t);return{...e,semicolons:i?"remove":"ignore"}}function nZ(e){return e===2||e===3}function eD(e,t){return e.isSourceFileFromExternalLibrary(t)||e.isSourceFileDefaultLibrary(t)}function cV(e,t){let n=new Set,i=new Set,s=new Set;for(let m of t)if(!IO(m)){let d=So(m.expression);if(WT(d))switch(d.kind){case 15:case 11:n.add(d.text);break;case 9:i.add(parseInt(d.text));break;case 10:let S=Ppe(Wc(d.text,"n")?d.text.slice(0,-1):d.text);S&&s.add(uE(S));break}else{let S=e.getSymbolAtLocation(m.expression);if(S&&S.valueDeclaration&&nS(S.valueDeclaration)){let E=e.getConstantValue(S.valueDeclaration);E!==void 0&&o(E)}}}return{addValue:o,hasValue:u};function o(m){switch(typeof m){case"string":n.add(m);break;case"number":i.add(m)}}function u(m){switch(typeof m){case"string":return n.has(m);case"number":return i.has(m);case"object":return s.has(uE(m))}}}function iZ(e,t,n,i){var s;let o=typeof e=="string"?e:e.fileName;if(!Oy(o))return!1;let u=t.getCompilerOptions(),m=V_(u),d=typeof e=="string"?K8(rc(e,n.getCurrentDirectory(),Pv(n)),(s=t.getPackageJsonInfoCache)==null?void 0:s.call(t),n,u):e.impliedNodeFormat;if(d===99)return!1;if(d===1||u.verbatimModuleSyntax&&m===1)return!0;if(u.verbatimModuleSyntax&&H9(m))return!1;if(typeof e=="object"){if(e.commonJsModuleIndicator)return!0;if(e.externalModuleIndicator)return!1}return i}function tD(e){switch(e.kind){case 241:case 307:case 268:case 296:return!0;default:return!1}}function lV(e,t,n,i){var s;let o=YB(e,(s=n.getPackageJsonInfoCache)==null?void 0:s.call(n),i,n.getCompilerOptions()),u,m;return typeof o=="object"&&(u=o.impliedNodeFormat,m=o.packageJsonScope),{path:rc(e,n.getCurrentDirectory(),n.getCanonicalFileName),fileName:e,externalModuleIndicator:t===99?!0:void 0,commonJsModuleIndicator:t===1?!0:void 0,impliedNodeFormat:u,packageJsonScope:m,statements:ve,imports:ve}}var ave=(e=>(e[e.Named=0]="Named",e[e.Default=1]="Default",e[e.Namespace=2]="Namespace",e[e.CommonJS=3]="CommonJS",e))(ave||{}),ove=(e=>(e[e.Named=0]="Named",e[e.Default=1]="Default",e[e.ExportEquals=2]="ExportEquals",e[e.UMD=3]="UMD",e))(ove||{});function sZ(e){let t=1,n=yd(),i=new Map,s=new Map,o,u={isUsableByFile:w=>w===o,isEmpty:()=>!n.size,clear:()=>{n.clear(),i.clear(),o=void 0},add:(w,R,L,F,J,G,q,ee)=>{w!==o&&(u.clear(),o=w);let W;if(J){let xe=dj(J.fileName);if(xe){let{topLevelNodeModulesIndex:te,topLevelPackageNameIndex:he,packageRootIndex:be}=xe;if(W=M8(GO(J.fileName.substring(he+1,be))),_s(w,J.path.substring(0,te))){let Ve=s.get(W),Pe=J.fileName.substring(0,he+1);if(Ve){let ke=Ve.indexOf(jy);te>ke&&s.set(W,Pe)}else s.set(W,Pe)}}}let K=G===1&&KI(R)||R,re=G===0||BP(K)?Qi(L):nve(K,void 0),ue=typeof re=="string"?re:re[0],ce=typeof re=="string"?void 0:re[1],ne=Zd(F.name),le=t++,me=$u(R,ee),de=R.flags&33554432?void 0:R,Ae=F.flags&33554432?void 0:F;(!de||!Ae)&&i.set(le,[R,F]),n.add(d(ue,R,vu(ne)?void 0:ne,ee),{id:le,symbolTableKey:L,symbolName:ue,capitalizedSymbolName:ce,moduleName:ne,moduleFile:J,moduleFileName:J?.fileName,packageName:W,exportKind:G,targetFlags:me.flags,isFromPackageJson:q,symbol:de,moduleSymbol:Ae})},get:(w,R)=>{if(w!==o)return;let L=n.get(R);return L?.map(m)},search:(w,R,L,F)=>{if(w===o)return Nu(n,(J,G)=>{let{symbolName:q,ambientModuleName:ee}=S(G),W=R&&J[0].capitalizedSymbolName||q;if(L(W,J[0].targetFlags)){let K=J.map(m).filter((re,ue)=>D(re,J[ue].packageName));if(K.length){let re=F(K,W,!!ee,G);if(re!==void 0)return re}}})},releaseSymbols:()=>{i.clear()},onFileChanged:(w,R,L)=>E(w)&&E(R)?!1:o&&o!==R.path||L&&tV(w)!==tV(R)||!Vp(w.moduleAugmentations,R.moduleAugmentations)||!x(w,R)?(u.clear(),!0):(o=R.path,!1)};return M.isDebugging&&Object.defineProperty(u,"__cache",{value:n}),u;function m(w){if(w.symbol&&w.moduleSymbol)return w;let{id:R,exportKind:L,targetFlags:F,isFromPackageJson:J,moduleFileName:G}=w,[q,ee]=i.get(R)||ve;if(q&&ee)return{symbol:q,moduleSymbol:ee,moduleFileName:G,exportKind:L,targetFlags:F,isFromPackageJson:J};let W=(J?e.getPackageJsonAutoImportProvider():e.getCurrentProgram()).getTypeChecker(),pe=w.moduleSymbol||ee||M.checkDefined(w.moduleFile?W.getMergedSymbol(w.moduleFile.symbol):W.tryFindAmbientModule(w.moduleName)),K=w.symbol||q||M.checkDefined(L===2?W.resolveExternalModuleSymbol(pe):W.tryGetMemberInModuleExportsAndProperties(Qi(w.symbolTableKey),pe),`Could not find symbol '${w.symbolName}' by key '${w.symbolTableKey}' in module ${pe.name}`);return i.set(R,[K,pe]),{symbol:K,moduleSymbol:pe,moduleFileName:G,exportKind:L,targetFlags:F,isFromPackageJson:J}}function d(w,R,L,F){let J=L||"";return`${w.length} ${Aa($u(R,F))} ${w} ${J}`}function S(w){let R=w.indexOf(" "),L=w.indexOf(" ",R+1),F=parseInt(w.substring(0,R),10),J=w.substring(L+1),G=J.substring(0,F),q=J.substring(F+1);return{symbolName:G,ambientModuleName:q===""?void 0:q}}function E(w){return!w.commonJsModuleIndicator&&!w.externalModuleIndicator&&!w.moduleAugmentations&&!w.ambientModuleNames}function x(w,R){if(!Vp(w.ambientModuleNames,R.ambientModuleNames))return!1;let L=-1,F=-1;for(let J of R.ambientModuleNames){let G=q=>sH(q)&&q.name.text===J;if(L=Bo(w.statements,G,L+1),F=Bo(R.statements,G,F+1),w.statements[L]!==R.statements[F])return!1}return!0}function D(w,R){if(!R||!w.moduleFileName)return!0;let L=e.getGlobalTypingsCacheLocation();if(L&&_s(w.moduleFileName,L))return!0;let F=s.get(R);return!F||_s(w.moduleFileName,F)}}function aZ(e,t,n,i,s,o,u){var m;if(t===n)return!1;let d=u?.get(t.path,n.path,i,{});if(d?.isBlockedByPackageJsonDependencies!==void 0)return!d.isBlockedByPackageJsonDependencies;let S=Pv(o),E=(m=o.getGlobalTypingsCacheLocation)==null?void 0:m.call(o),x=!!wb.forEachFileNameOfModule(t.fileName,n.fileName,o,!1,D=>{let w=e.getSourceFile(D);return(w===n||!w)&&L2t(t.fileName,D,S,E)});if(s){let D=x&&s.allowsImportingSourceFile(n,o);return u?.setBlockedByPackageJsonDependencies(t.path,n.path,i,{},!D),D}return x}function L2t(e,t,n,i){let s=Am(t,u=>Ul(u)==="node_modules"?u:void 0),o=s&&mi(n(s));return o===void 0||_s(n(e),o)||!!i&&_s(n(i),o)}function oZ(e,t,n,i,s){var o,u;let m=sN(t),d=n.autoImportFileExcludePatterns&&Gi(n.autoImportFileExcludePatterns,E=>{let x=tj(E,"","exclude");return x?G1(x,m):void 0});k7e(e.getTypeChecker(),e.getSourceFiles(),d,t,(E,x)=>s(E,x,e,!1));let S=i&&((o=t.getPackageJsonAutoImportProvider)==null?void 0:o.call(t));if(S){let E=Tc(),x=e.getTypeChecker();k7e(S.getTypeChecker(),S.getSourceFiles(),d,t,(D,w)=>{(w&&!e.getSourceFile(w.fileName)||!w&&!x.resolveName(D.name,void 0,1536,!1))&&s(D,w,S,!0)}),(u=t.log)==null||u.call(t,`forEachExternalModuleToImportFrom autoImportProvider: ${Tc()-E}`)}}function k7e(e,t,n,i,s){var o,u;let m=(o=i.getSymlinkCache)==null?void 0:o.call(i).getSymlinkedDirectoriesByRealpath(),d=n&&(({fileName:S,path:E})=>{if(n.some(x=>x.test(S)))return!0;if(m?.size&&Nb(S)){let x=mi(S);return Am(mi(E),D=>{let w=m.get(yu(D));if(w)return w.some(R=>n.some(L=>L.test(S.replace(x,R))));x=mi(x)})??!1}return!1});for(let S of e.getAmbientModules())!S.name.includes("*")&&!(n&&((u=S.declarations)!=null&&u.every(E=>d(E.getSourceFile()))))&&s(S,void 0);for(let S of t)Uf(S)&&!d?.(S)&&s(e.getMergedSymbol(S.symbol),S)}function PM(e,t,n,i,s){var o,u,m,d,S;let E=Tc();(o=t.getPackageJsonAutoImportProvider)==null||o.call(t);let x=((u=t.getCachedExportInfoMap)==null?void 0:u.call(t))||sZ({getCurrentProgram:()=>n,getPackageJsonAutoImportProvider:()=>{var w;return(w=t.getPackageJsonAutoImportProvider)==null?void 0:w.call(t)},getGlobalTypingsCacheLocation:()=>{var w;return(w=t.getGlobalTypingsCacheLocation)==null?void 0:w.call(t)}});if(x.isUsableByFile(e.path))return(m=t.log)==null||m.call(t,"getExportInfoMap: cache hit"),x;(d=t.log)==null||d.call(t,"getExportInfoMap: cache miss or empty; calculating new results");let D=0;try{oZ(n,t,i,!0,(w,R,L,F)=>{++D%100===0&&s?.throwIfCancellationRequested();let J=new Map,G=L.getTypeChecker(),q=uV(w,G);q&&P7e(q.symbol,G)&&x.add(e.path,q.symbol,q.exportKind===1?"default":"export=",w,R,q.exportKind,F,G),G.forEachExportAndPropertyOfModule(w,(ee,W)=>{ee!==q?.symbol&&P7e(ee,G)&&em(J,W)&&x.add(e.path,ee,W,w,R,0,F,G)})})}catch(w){throw x.clear(),w}return(S=t.log)==null||S.call(t,`getExportInfoMap: done in ${Tc()-E} ms`),x}function uV(e,t){let n=t.resolveExternalModuleSymbol(e);if(n!==e)return{symbol:n,exportKind:2};let i=t.tryGetMemberInModuleExports("default",e);if(i)return{symbol:i,exportKind:1}}function P7e(e,t){return!t.isUndefinedSymbol(e)&&!t.isUnknownSymbol(e)&&!wR(e)&&!Sfe(e)}function cZ(e,t,n,i,s){let o,u=e,m=new Map;for(;u;){let d=nV(u);if(d){let S=s(d);if(S)return S}if(u.escapedName!=="default"&&u.escapedName!=="export="){let S=s(u.name);if(S)return S}if(o=Bt(o,u),!em(m,u))break;u=u.flags&2097152?t.getImmediateAliasedSymbol(u):void 0}for(let d of o??ve)if(d.parent&&BP(d.parent)){let S=s(x6(d.parent,Ka(n),i));if(S)return S}}function N7e(){let e=xy(99,!1);function t(i,s,o){return U2t(n(i,s,o),i)}function n(i,s,o){let u=0,m=0,d=[],{prefix:S,pushTemplate:E}=q2t(s);i=S+i;let x=S.length;E&&d.push(16),e.setText(i);let D=0,w=[],R=0;do{u=e.scan(),tN(u)||(L(),m=u);let F=e.getTokenEnd();if(B2t(e.getTokenStart(),F,x,$2t(u),w),F>=i.length){let J=j2t(e,u,vc(d));J!==void 0&&(D=J)}}while(u!==1);function L(){switch(u){case 44:case 69:!F2t[m]&&e.reScanSlashToken()===14&&(u=14);break;case 30:m===80&&R++;break;case 32:R>0&&R--;break;case 133:case 154:case 150:case 136:case 155:R>0&&!o&&(u=80);break;case 16:d.push(u);break;case 19:d.length>0&&d.push(u);break;case 20:if(d.length>0){let F=vc(d);F===16?(u=e.reScanTemplateToken(!1),u===18?d.pop():M.assertEqual(u,17,"Should have been a template middle.")):(M.assertEqual(F,19,"Should have been an open brace"),d.pop())}break;default:if(!sf(u))break;(m===25||sf(m)&&sf(u)&&!J2t(m,u))&&(u=80)}}return{endOfLineState:D,spans:w}}return{getClassificationsForLine:t,getEncodedLexicalClassifications:n}}var F2t=Vce([80,11,9,10,14,110,46,47,22,24,20,112,97],e=>e,()=>!0);function j2t(e,t,n){switch(t){case 11:{if(!e.isUnterminated())return;let i=e.getTokenText(),s=i.length-1,o=0;for(;i.charCodeAt(s-o)===92;)o++;return o&1?i.charCodeAt(0)===34?3:2:void 0}case 3:return e.isUnterminated()?1:void 0;default:if(B1(t)){if(!e.isUnterminated())return;switch(t){case 18:return 5;case 15:return 4;default:return M.fail("Only 'NoSubstitutionTemplateLiteral's and 'TemplateTail's can be unterminated; got SyntaxKind #"+t)}}return n===16?6:void 0}}function B2t(e,t,n,i,s){if(i===8)return;e===0&&n>0&&(e+=n);let o=t-e;o>0&&s.push(e-n,o,i)}function U2t(e,t){let n=[],i=e.spans,s=0;for(let u=0;u<i.length;u+=3){let m=i[u],d=i[u+1],S=i[u+2];if(s>=0){let E=m-s;E>0&&n.push({length:E,classification:4})}n.push({length:d,classification:V2t(S)}),s=m+d}let o=t.length-s;return o>0&&n.push({length:o,classification:4}),{entries:n,finalLexState:e.endOfLineState}}function V2t(e){switch(e){case 1:return 3;case 3:return 1;case 4:return 6;case 25:return 7;case 5:return 2;case 6:return 8;case 8:return 4;case 10:return 0;case 2:case 11:case 12:case 13:case 14:case 15:case 16:case 9:case 17:return 5;default:return}}function J2t(e,t){if(!vQ(e))return!0;switch(t){case 139:case 153:case 137:case 126:case 129:return!0;default:return!1}}function q2t(e){switch(e){case 3:return{prefix:`"\\
`};case 2:return{prefix:`'\\
`};case 1:return{prefix:`/*
`};case 4:return{prefix:"`\n"};case 5:return{prefix:`}
`,pushTemplate:!0};case 6:return{prefix:"",pushTemplate:!0};case 0:return{prefix:""};default:return M.assertNever(e)}}function z2t(e){switch(e){case 42:case 44:case 45:case 40:case 41:case 48:case 49:case 50:case 30:case 32:case 33:case 34:case 104:case 103:case 130:case 152:case 35:case 36:case 37:case 38:case 51:case 53:case 52:case 56:case 57:case 75:case 74:case 79:case 71:case 72:case 73:case 65:case 66:case 67:case 69:case 70:case 64:case 28:case 61:case 76:case 77:case 78:return!0;default:return!1}}function W2t(e){switch(e){case 40:case 41:case 55:case 54:case 46:case 47:return!0;default:return!1}}function $2t(e){if(sf(e))return 3;if(z2t(e)||W2t(e))return 5;if(e>=19&&e<=79)return 10;switch(e){case 9:return 4;case 10:return 25;case 11:return 6;case 14:return 7;case 7:case 3:case 2:return 1;case 5:case 4:return 8;case 80:default:return B1(e)?6:2}}function cve(e,t,n,i,s){return I7e(lZ(e,t,n,i,s))}function D7e(e,t){switch(t){case 267:case 263:case 264:case 262:case 231:case 218:case 219:e.throwIfCancellationRequested()}}function lZ(e,t,n,i,s){let o=[];return n.forEachChild(function m(d){if(!(!d||!S5(s,d.pos,d.getFullWidth()))){if(D7e(t,d.kind),He(d)&&!$c(d)&&i.has(d.escapedText)){let S=e.getSymbolAtLocation(d),E=S&&w7e(S,S2(d),e);E&&u(d.getStart(n),d.getEnd(),E)}d.forEachChild(m)}}),{spans:o,endOfLineState:0};function u(m,d,S){let E=d-m;M.assert(E>0,`Classification had non-positive length of ${E}`),o.push(m),o.push(E),o.push(S)}}function w7e(e,t,n){let i=e.getFlags();if(i&2885600)return i&32?11:i&384?12:i&524288?16:i&1536?t&4||t&1&&H2t(e)?14:void 0:i&2097152?w7e(n.getAliasedSymbol(e),t,n):t&2?i&64?13:i&262144?15:void 0:void 0}function H2t(e){return Pt(e.declarations,t=>El(t)&&N0(t)===1)}function G2t(e){switch(e){case 1:return"comment";case 2:return"identifier";case 3:return"keyword";case 4:return"number";case 25:return"bigint";case 5:return"operator";case 6:return"string";case 8:return"whitespace";case 9:return"text";case 10:return"punctuation";case 11:return"class name";case 12:return"enum name";case 13:return"interface name";case 14:return"module name";case 15:return"type parameter name";case 16:return"type alias name";case 17:return"parameter name";case 18:return"doc comment tag name";case 19:return"jsx open tag name";case 20:return"jsx close tag name";case 21:return"jsx self closing tag name";case 22:return"jsx attribute";case 23:return"jsx text";case 24:return"jsx attribute string literal value";default:return}}function I7e(e){M.assert(e.spans.length%3===0);let t=e.spans,n=[];for(let i=0;i<t.length;i+=3)n.push({textSpan:zu(t[i],t[i+1]),classificationType:G2t(t[i+2])});return n}function lve(e,t,n){return I7e(uZ(e,t,n))}function uZ(e,t,n){let i=n.start,s=n.length,o=xy(99,!1,t.languageVariant,t.text),u=xy(99,!1,t.languageVariant,t.text),m=[];return ee(t),{spans:m,endOfLineState:0};function d(W,pe,K){m.push(W),m.push(pe),m.push(K)}function S(W){for(o.resetTokenState(W.pos);;){let pe=o.getTokenEnd();if(!Eue(t.text,pe))return pe;let K=o.scan(),re=o.getTokenEnd(),ue=re-pe;if(!tN(K))return pe;switch(K){case 4:case 5:continue;case 2:case 3:E(W,K,pe,ue),o.resetTokenState(re);continue;case 7:let ce=t.text,ne=ce.charCodeAt(pe);if(ne===60||ne===62){d(pe,ue,1);continue}M.assert(ne===124||ne===61),L(ce,pe,re);break;case 6:break;default:M.assertNever(K)}}}function E(W,pe,K,re){if(pe===3){let ue=Pme(t.text,K,re);if(ue&&ue.jsDoc){lo(ue.jsDoc,W),D(ue.jsDoc);return}}else if(pe===2&&w(K,re))return;x(K,re)}function x(W,pe){d(W,pe,1)}function D(W){var pe,K,re,ue,ce,ne,le,me;let de=W.pos;if(W.tags)for(let xe of W.tags){xe.pos!==de&&x(de,xe.pos-de),d(xe.pos,1,10),d(xe.tagName.pos,xe.tagName.end-xe.tagName.pos,18),de=xe.tagName.end;let te=xe.tagName.end;switch(xe.kind){case 341:let he=xe;Ae(he),te=he.isNameFirst&&((pe=he.typeExpression)==null?void 0:pe.end)||he.name.end;break;case 348:let be=xe;te=be.isNameFirst&&((K=be.typeExpression)==null?void 0:K.end)||be.name.end;break;case 345:R(xe),de=xe.end,te=xe.typeParameters.end;break;case 346:let Ve=xe;te=((re=Ve.typeExpression)==null?void 0:re.kind)===309&&((ue=Ve.fullName)==null?void 0:ue.end)||((ce=Ve.typeExpression)==null?void 0:ce.end)||te;break;case 338:te=xe.typeExpression.end;break;case 344:ee(xe.typeExpression),de=xe.end,te=xe.typeExpression.end;break;case 343:case 340:te=xe.typeExpression.end;break;case 342:ee(xe.typeExpression),de=xe.end,te=((ne=xe.typeExpression)==null?void 0:ne.end)||te;break;case 347:te=((le=xe.name)==null?void 0:le.end)||te;break;case 328:case 329:te=xe.class.end;break;case 349:ee(xe.typeExpression),de=xe.end,te=((me=xe.typeExpression)==null?void 0:me.end)||te;break}typeof xe.comment=="object"?x(xe.comment.pos,xe.comment.end-xe.comment.pos):typeof xe.comment=="string"&&x(te,xe.end-te)}de!==W.end&&x(de,W.end-de);return;function Ae(xe){xe.isNameFirst&&(x(de,xe.name.pos-de),d(xe.name.pos,xe.name.end-xe.name.pos,17),de=xe.name.end),xe.typeExpression&&(x(de,xe.typeExpression.pos-de),ee(xe.typeExpression),de=xe.typeExpression.end),xe.isNameFirst||(x(de,xe.name.pos-de),d(xe.name.pos,xe.name.end-xe.name.pos,17),de=xe.name.end)}}function w(W,pe){let K=/^(\/\/\/\s*)(<)(?:(\S+)((?:[^/]|\/[^>])*)(\/>)?)?/im,re=/(\s)(\S+)(\s*)(=)(\s*)('[^']+'|"[^"]+")/img,ue=t.text.substr(W,pe),ce=K.exec(ue);if(!ce||!ce[3]||!(ce[3]in l5))return!1;let ne=W;x(ne,ce[1].length),ne+=ce[1].length,d(ne,ce[2].length,10),ne+=ce[2].length,d(ne,ce[3].length,21),ne+=ce[3].length;let le=ce[4],me=ne;for(;;){let Ae=re.exec(le);if(!Ae)break;let xe=ne+Ae.index+Ae[1].length;xe>me&&(x(me,xe-me),me=xe),d(me,Ae[2].length,22),me+=Ae[2].length,Ae[3].length&&(x(me,Ae[3].length),me+=Ae[3].length),d(me,Ae[4].length,5),me+=Ae[4].length,Ae[5].length&&(x(me,Ae[5].length),me+=Ae[5].length),d(me,Ae[6].length,24),me+=Ae[6].length}ne+=ce[4].length,ne>me&&x(me,ne-me),ce[5]&&(d(ne,ce[5].length,10),ne+=ce[5].length);let de=W+pe;return ne<de&&x(ne,de-ne),!0}function R(W){for(let pe of W.getChildren())ee(pe)}function L(W,pe,K){let re;for(re=pe;re<K&&!v_(W.charCodeAt(re));re++);for(d(pe,re-pe,1),u.resetTokenState(re);u.getTokenEnd()<K;)F()}function F(){let W=u.getTokenEnd(),pe=u.scan(),K=u.getTokenEnd(),re=q(pe);re&&d(W,K-W,re)}function J(W){if(ag(W)||$c(W))return!0;let pe=G(W);if(!HC(W)&&W.kind!==12&&pe===void 0)return!1;let K=W.kind===12?W.pos:S(W),re=W.end-K;if(M.assert(re>=0),re>0){let ue=pe||q(W.kind,W);ue&&d(K,re,ue)}return!0}function G(W){switch(W.parent&&W.parent.kind){case 286:if(W.parent.tagName===W)return 19;break;case 287:if(W.parent.tagName===W)return 20;break;case 285:if(W.parent.tagName===W)return 21;break;case 291:if(W.parent.name===W)return 22;break}}function q(W,pe){if(sf(W))return 3;if((W===30||W===32)&&pe&&P0e(pe.parent))return 10;if(IH(W)){if(pe){let K=pe.parent;if(W===64&&(K.kind===260||K.kind===172||K.kind===169||K.kind===291)||K.kind===226||K.kind===224||K.kind===225||K.kind===227)return 5}return 10}else{if(W===9)return 4;if(W===10)return 25;if(W===11)return pe&&pe.parent.kind===291?24:6;if(W===14)return 6;if(B1(W))return 6;if(W===12)return 23;if(W===80){if(pe){switch(pe.parent.kind){case 263:return pe.parent.name===pe?11:void 0;case 168:return pe.parent.name===pe?15:void 0;case 264:return pe.parent.name===pe?13:void 0;case 266:return pe.parent.name===pe?12:void 0;case 267:return pe.parent.name===pe?14:void 0;case 169:return pe.parent.name===pe?z1(pe)?3:17:void 0}if(Qm(pe.parent))return 3}return 2}}}function ee(W){if(W&&N3(i,s,W.pos,W.getFullWidth())){D7e(e,W.kind);for(let pe of W.getChildren(t))J(pe)||ee(pe)}}}var _V;(e=>{function t(ne,le,me,de,Ae){let xe=wf(me,de);if(xe.parent&&(Yg(xe.parent)&&xe.parent.tagName===xe||yE(xe.parent))){let{openingElement:te,closingElement:he}=xe.parent.parent,be=[te,he].map(({tagName:Ve})=>n(Ve,me));return[{fileName:me.fileName,highlightSpans:be}]}return i(de,xe,ne,le,Ae)||s(xe,me)}e.getDocumentHighlights=t;function n(ne,le){return{fileName:le.fileName,textSpan:df(ne,le),kind:"none"}}function i(ne,le,me,de,Ae){let xe=new Set(Ae.map(Ve=>Ve.fileName)),te=lc.getReferenceEntriesForNode(ne,le,me,Ae,de,void 0,xe);if(!te)return;let he=f3(te.map(lc.toHighlightSpan),Ve=>Ve.fileName,Ve=>Ve.span),be=l_(me.useCaseSensitiveFileNames());return Is(Up(he.entries(),([Ve,Pe])=>{if(!xe.has(Ve)){if(!me.redirectTargetsMap.has(rc(Ve,me.getCurrentDirectory(),be)))return;let ke=me.getSourceFile(Ve);Ve=Ln(Ae,Be=>!!Be.redirectInfo&&Be.redirectInfo.redirectTarget===ke).fileName,M.assert(xe.has(Ve))}return{fileName:Ve,highlightSpans:Pe}}))}function s(ne,le){let me=o(ne,le);return me&&[{fileName:le.fileName,highlightSpans:me}]}function o(ne,le){switch(ne.kind){case 101:case 93:return vb(ne.parent)?re(ne.parent,le):void 0;case 107:return de(ne.parent,nm,ee);case 111:return de(ne.parent,nY,q);case 113:case 85:case 98:let xe=ne.kind===85?ne.parent.parent:ne.parent;return de(xe,c2,G);case 109:return de(ne.parent,NO,J);case 84:case 90:return IO(ne.parent)||SN(ne.parent)?de(ne.parent.parent.parent,NO,J):void 0;case 83:case 88:return de(ne.parent,gI,F);case 99:case 117:case 92:return de(ne.parent,te=>V1(te,!0),L);case 137:return me(Vc,[137]);case 139:case 153:return me(U1,[139,153]);case 135:return de(ne.parent,eS,W);case 134:return Ae(W(ne));case 127:return Ae(pe(ne));case 103:case 147:return;default:return vv(ne.kind)&&(u_(ne.parent)||_l(ne.parent))?Ae(D(ne.kind,ne.parent)):void 0}function me(xe,te){return de(ne.parent,xe,he=>{var be;return Gi((be=ai(he,Zm))==null?void 0:be.symbol.declarations,Ve=>xe(Ve)?Ln(Ve.getChildren(le),Pe=>Es(te,Pe.kind)):void 0)})}function de(xe,te,he){return te(xe)?Ae(he(xe,le)):void 0}function Ae(xe){return xe&&xe.map(te=>n(te,le))}}function u(ne){return nY(ne)?[ne]:c2(ne)?ps(ne.catchClause?u(ne.catchClause):ne.tryBlock&&u(ne.tryBlock),ne.finallyBlock&&u(ne.finallyBlock)):Bs(ne)?void 0:S(ne,u)}function m(ne){let le=ne;for(;le.parent;){let me=le.parent;if(XT(me)||me.kind===307)return me;if(c2(me)&&me.tryBlock===le&&me.catchClause)return le;le=me}}function d(ne){return gI(ne)?[ne]:Bs(ne)?void 0:S(ne,d)}function S(ne,le){let me=[];return ne.forEachChild(de=>{let Ae=le(de);Ae!==void 0&&me.push(...VC(Ae))}),me}function E(ne,le){let me=x(le);return!!me&&me===ne}function x(ne){return Pr(ne,le=>{switch(le.kind){case 255:if(ne.kind===251)return!1;case 248:case 249:case 250:case 247:case 246:return!ne.label||ce(le,ne.label.escapedText);default:return Bs(le)&&"quit"}})}function D(ne,le){return Gi(w(le,pA(ne)),me=>YN(me,ne))}function w(ne,le){let me=ne.parent;switch(me.kind){case 268:case 307:case 241:case 296:case 297:return le&64&&tu(ne)?[...ne.members,ne]:me.statements;case 176:case 174:case 262:return[...me.parameters,...gi(me.parent)?me.parent.members:[]];case 263:case 231:case 264:case 187:let de=me.members;if(le&15){let Ae=Ln(me.members,Vc);if(Ae)return[...de,...Ae.parameters]}else if(le&64)return[...de,me];return de;case 210:return;default:M.assertNever(me,"Invalid container kind.")}}function R(ne,le,...me){return le&&Es(me,le.kind)?(ne.push(le),!0):!1}function L(ne){let le=[];if(R(le,ne.getFirstToken(),99,117,92)&&ne.kind===246){let me=ne.getChildren();for(let de=me.length-1;de>=0&&!R(le,me[de],117);de--);}return kt(d(ne.statement),me=>{E(ne,me)&&R(le,me.getFirstToken(),83,88)}),le}function F(ne){let le=x(ne);if(le)switch(le.kind){case 248:case 249:case 250:case 246:case 247:return L(le);case 255:return J(le)}}function J(ne){let le=[];return R(le,ne.getFirstToken(),109),kt(ne.caseBlock.clauses,me=>{R(le,me.getFirstToken(),84,90),kt(d(me),de=>{E(ne,de)&&R(le,de.getFirstToken(),83)})}),le}function G(ne,le){let me=[];if(R(me,ne.getFirstToken(),113),ne.catchClause&&R(me,ne.catchClause.getFirstToken(),85),ne.finallyBlock){let de=Oo(ne,98,le);R(me,de,98)}return me}function q(ne,le){let me=m(ne);if(!me)return;let de=[];return kt(u(me),Ae=>{de.push(Oo(Ae,111,le))}),XT(me)&&xv(me,Ae=>{de.push(Oo(Ae,107,le))}),de}function ee(ne,le){let me=Dp(ne);if(!me)return;let de=[];return xv(aa(me.body,Vs),Ae=>{de.push(Oo(Ae,107,le))}),kt(u(me.body),Ae=>{de.push(Oo(Ae,111,le))}),de}function W(ne){let le=Dp(ne);if(!le)return;let me=[];return le.modifiers&&le.modifiers.forEach(de=>{R(me,de,134)}),Js(le,de=>{K(de,Ae=>{eS(Ae)&&R(me,Ae.getFirstToken(),135)})}),me}function pe(ne){let le=Dp(ne);if(!le)return;let me=[];return Js(le,de=>{K(de,Ae=>{Rj(Ae)&&R(me,Ae.getFirstToken(),127)})}),me}function K(ne,le){le(ne),!Bs(ne)&&!gi(ne)&&!Yu(ne)&&!El(ne)&&!im(ne)&&!Di(ne)&&Js(ne,me=>K(me,le))}function re(ne,le){let me=ue(ne,le),de=[];for(let Ae=0;Ae<me.length;Ae++){if(me[Ae].kind===93&&Ae<me.length-1){let xe=me[Ae],te=me[Ae+1],he=!0;for(let be=te.getStart(le)-1;be>=xe.end;be--)if(!wg(le.text.charCodeAt(be))){he=!1;break}if(he){de.push({fileName:le.fileName,textSpan:Il(xe.getStart(),te.end),kind:"reference"}),Ae++;continue}}de.push(n(me[Ae],le))}return de}function ue(ne,le){let me=[];for(;vb(ne.parent)&&ne.parent.elseStatement===ne;)ne=ne.parent;for(;;){let de=ne.getChildren(le);R(me,de[0],101);for(let Ae=de.length-1;Ae>=0&&!R(me,de[Ae],93);Ae--);if(!ne.elseStatement||!vb(ne.elseStatement))break;ne=ne.elseStatement}return me}function ce(ne,le){return!!Pr(ne.parent,me=>rS(me)?me.label.escapedText===le:"quit")}})(_V||(_V={}));function NM(e){return!!e.sourceFile}function uve(e,t,n){return _Z(e,t,n)}function _Z(e,t="",n,i){let s=new Map,o=l_(!!e);function u(){let F=Is(s.keys()).filter(J=>J&&J.charAt(0)==="_").map(J=>{let G=s.get(J),q=[];return G.forEach((ee,W)=>{NM(ee)?q.push({name:W,scriptKind:ee.sourceFile.scriptKind,refCount:ee.languageServiceRefCount}):ee.forEach((pe,K)=>q.push({name:W,scriptKind:K,refCount:pe.languageServiceRefCount}))}),q.sort((ee,W)=>W.refCount-ee.refCount),{bucket:J,sourceFiles:q}});return JSON.stringify(F,void 0,2)}function m(F){return typeof F.getCompilationSettings=="function"?F.getCompilationSettings():F}function d(F,J,G,q,ee,W){let pe=rc(F,t,o),K=fZ(m(J));return S(F,pe,J,K,G,q,ee,W)}function S(F,J,G,q,ee,W,pe,K){return w(F,J,G,q,ee,W,!0,pe,K)}function E(F,J,G,q,ee,W){let pe=rc(F,t,o),K=fZ(m(J));return x(F,pe,J,K,G,q,ee,W)}function x(F,J,G,q,ee,W,pe,K){return w(F,J,m(G),q,ee,W,!1,pe,K)}function D(F,J){let G=NM(F)?F:F.get(M.checkDefined(J,"If there are more than one scriptKind's for same document the scriptKind should be provided"));return M.assert(J===void 0||!G||G.sourceFile.scriptKind===J,`Script kind should match provided ScriptKind:${J} and sourceFile.scriptKind: ${G?.sourceFile.scriptKind}, !entry: ${!G}`),G}function w(F,J,G,q,ee,W,pe,K,re){var ue,ce,ne,le;K=nj(F,K);let me=m(G),de=G===me?void 0:G,Ae=K===6?100:Ka(me),xe=typeof re=="object"?re:{languageVersion:Ae,impliedNodeFormat:de&&K8(J,(le=(ne=(ce=(ue=de.getCompilerHost)==null?void 0:ue.call(de))==null?void 0:ce.getModuleResolutionCache)==null?void 0:ne.call(ce))==null?void 0:le.getPackageJsonInfoCache(),de,me),setExternalModuleIndicator:WR(me),jsDocParsingMode:n};xe.languageVersion=Ae,M.assertEqual(n,xe.jsDocParsingMode);let te=s.size,he=_ve(q,xe.impliedNodeFormat),be=dv(s,he,()=>new Map);if(Cn){s.size>te&&Cn.instant(Cn.Phase.Session,"createdDocumentRegistryBucket",{configFilePath:me.configFilePath,key:he});let De=!Mu(J)&&Nu(s,(Be,ct)=>ct!==he&&Be.has(J)&&ct);De&&Cn.instant(Cn.Phase.Session,"documentRegistryBucketOverlap",{path:J,key1:De,key2:he})}let Ve=be.get(J),Pe=Ve&&D(Ve,K);if(!Pe&&i){let De=i.getDocument(he,J);De&&De.scriptKind===K&&De.text===sk(ee)&&(M.assert(pe),Pe={sourceFile:De,languageServiceRefCount:0},ke())}if(Pe)Pe.sourceFile.version!==W&&(Pe.sourceFile=WZ(Pe.sourceFile,ee,W,ee.getChangeRange(Pe.sourceFile.scriptSnapshot)),i&&i.setDocument(he,J,Pe.sourceFile)),pe&&Pe.languageServiceRefCount++;else{let De=kV(F,ee,xe,W,!1,K);i&&i.setDocument(he,J,De),Pe={sourceFile:De,languageServiceRefCount:1},ke()}return M.assert(Pe.languageServiceRefCount!==0),Pe.sourceFile;function ke(){if(!Ve)be.set(J,Pe);else if(NM(Ve)){let De=new Map;De.set(Ve.sourceFile.scriptKind,Ve),De.set(K,Pe),be.set(J,De)}else Ve.set(K,Pe)}}function R(F,J,G,q){let ee=rc(F,t,o),W=fZ(J);return L(ee,W,G,q)}function L(F,J,G,q){let ee=M.checkDefined(s.get(_ve(J,q))),W=ee.get(F),pe=D(W,G);pe.languageServiceRefCount--,M.assert(pe.languageServiceRefCount>=0),pe.languageServiceRefCount===0&&(NM(W)?ee.delete(F):(W.delete(G),W.size===1&&ee.set(F,qo(W.values(),ec))))}return{acquireDocument:d,acquireDocumentWithKey:S,updateDocument:E,updateDocumentWithKey:x,releaseDocument:R,releaseDocumentWithKey:L,getKeyForCompilationSettings:fZ,getDocumentRegistryBucketKeyWithMode:_ve,reportStats:u,getBuckets:()=>s}}function fZ(e){return eK(e,LY)}function _ve(e,t){return t?`${e}|${t}`:e}function fve(e,t,n,i,s,o,u){let m=sN(i),d=l_(m),S=pZ(t,n,d,u),E=pZ(n,t,d,u);return Sn.ChangeTracker.with({host:i,formatContext:s,preferences:o},x=>{K2t(e,x,S,t,n,i.getCurrentDirectory(),m),X2t(e,x,S,E,i,d)})}function pZ(e,t,n,i){let s=n(e);return u=>{let m=i&&i.tryGetSourcePosition({fileName:u,pos:0}),d=o(m?m.fileName:u);return m?d===void 0?void 0:Y2t(m.fileName,d,u,n):d};function o(u){if(n(u)===s)return t;let m=SG(u,s,n);return m===void 0?void 0:t+"/"+m}}function Y2t(e,t,n,i){let s=aI(e,t,i);return pve(mi(n),s)}function K2t(e,t,n,i,s,o,u){let{configFile:m}=e.getCompilerOptions();if(!m)return;let d=mi(m.fileName),S=DI(m);if(!S)return;dve(S,(w,R)=>{switch(R){case"files":case"include":case"exclude":{if(E(w)||R!=="include"||!Gu(w.initializer))return;let F=Gi(w.initializer.elements,G=>La(G)?G.text:void 0);if(F.length===0)return;let J=rj(d,[],F,u,o);G1(M.checkDefined(J.includeFilePattern),u).test(i)&&!G1(M.checkDefined(J.includeFilePattern),u).test(s)&&t.insertNodeAfter(m,Va(w.initializer.elements),U.createStringLiteral(D(s)));return}case"compilerOptions":dve(w.initializer,(L,F)=>{let J=UY(F);M.assert(J?.type!=="listOrElement"),J&&(J.isFilePath||J.type==="list"&&J.element.isFilePath)?E(L):F==="paths"&&dve(L.initializer,G=>{if(Gu(G.initializer))for(let q of G.initializer.elements)x(q)})});return}});function E(w){let R=Gu(w.initializer)?w.initializer.elements:[w.initializer],L=!1;for(let F of R)L=x(F)||L;return L}function x(w){if(!La(w))return!1;let R=pve(d,w.text),L=n(R);return L!==void 0?(t.replaceRangeWithText(m,R7e(w,m),D(L)),!0):!1}function D(w){return Xm(d,w,!u)}}function X2t(e,t,n,i,s,o){let u=e.getSourceFiles();for(let m of u){let d=n(m.fileName),S=d??m.fileName,E=mi(S),x=i(m.fileName),D=x||m.fileName,w=mi(D),R=d!==void 0||x!==void 0;eCt(m,t,L=>{if(!qp(L))return;let F=pve(w,L),J=n(F);return J===void 0?void 0:Vx(Xm(E,J,o))},L=>{let F=e.getTypeChecker().getSymbolAtLocation(L);if(F?.declarations&&F.declarations.some(G=>B_(G)))return;let J=x!==void 0?O7e(L,QA(L.text,D,e.getCompilerOptions(),s),n,u):Z2t(F,L,m,e,s,n);return J!==void 0&&(J.updated||R&&qp(L.text))?wb.updateModuleSpecifier(e.getCompilerOptions(),m,S,J.newFileName,ak(e,s),L.text):void 0})}}function Q2t(e,t){return Zs(ri(e,t))}function pve(e,t){return Vx(Q2t(e,t))}function Z2t(e,t,n,i,s,o){if(e){let u=Ln(e.declarations,Ji).fileName,m=o(u);return m===void 0?{newFileName:u,updated:!1}:{newFileName:m,updated:!0}}else{let u=i.getModeForUsageLocation(n,t),m=s.resolveModuleNameLiterals||!s.resolveModuleNames?i.getResolvedModuleFromModuleSpecifier(t,n):s.getResolvedModuleWithFailedLookupLocationsFromCache&&s.getResolvedModuleWithFailedLookupLocationsFromCache(t.text,n.fileName,u);return O7e(t,m,o,i.getSourceFiles())}}function O7e(e,t,n,i){if(!t)return;if(t.resolvedModule){let d=m(t.resolvedModule.resolvedFileName);if(d)return d}let s=kt(t.failedLookupLocations,o)||qp(e.text)&&kt(t.failedLookupLocations,u);if(s)return s;return t.resolvedModule&&{newFileName:t.resolvedModule.resolvedFileName,updated:!1};function o(d){let S=n(d);return S&&Ln(i,E=>E.fileName===S)?u(d):void 0}function u(d){return Wc(d,"/package.json")?void 0:m(d)}function m(d){let S=n(d);return S&&{newFileName:S,updated:!0}}}function eCt(e,t,n,i){for(let s of e.referencedFiles||ve){let o=n(s.fileName);o!==void 0&&o!==e.text.slice(s.pos,s.end)&&t.replaceRangeWithText(e,s,o)}for(let s of e.imports){let o=i(s);o!==void 0&&o!==s.text&&t.replaceRangeWithText(e,R7e(s,e),o)}}function R7e(e,t){return Td(e.getStart(t)+1,e.end-1)}function dve(e,t){if(Ca(e))for(let n of e.properties)ql(n)&&La(n.name)&&t(n,n.name.text)}var dZ=(e=>(e[e.exact=0]="exact",e[e.prefix=1]="prefix",e[e.substring=2]="substring",e[e.camelCase=3]="camelCase",e))(dZ||{});function C6(e,t){return{kind:e,isCaseSensitive:t}}function mve(e){let t=new Map,n=e.trim().split(".").map(i=>iCt(i.trim()));if(n.length===1&&n[0].totalTextChunk.text==="")return{getMatchForLastSegmentOfPattern:()=>C6(2,!0),getFullMatch:()=>C6(2,!0),patternContainsDots:!1};if(!n.some(i=>!i.subWordTextChunks.length))return{getFullMatch:(i,s)=>tCt(i,s,n,t),getMatchForLastSegmentOfPattern:i=>gve(i,Va(n),t),patternContainsDots:n.length>1}}function tCt(e,t,n,i){if(!gve(t,Va(n),i)||n.length-1>e.length)return;let o;for(let u=n.length-2,m=e.length-1;u>=0;u-=1,m-=1)o=F7e(o,gve(e[m],n[u],i));return o}function M7e(e,t){let n=t.get(e);return n||t.set(e,n=Tve(e)),n}function L7e(e,t,n){let i=sCt(e,t.textLowerCase);if(i===0)return C6(t.text.length===e.length?0:1,_s(e,t.text));if(t.isLowerCase){if(i===-1)return;let s=M7e(e,n);for(let o of s)if(hve(e,o,t.text,!0))return C6(2,hve(e,o,t.text,!1));if(t.text.length<e.length&&rD(e.charCodeAt(i)))return C6(2,!1)}else{if(e.indexOf(t.text)>0)return C6(2,!0);if(t.characterSpans.length>0){let s=M7e(e,n),o=j7e(e,s,t,!1)?!0:j7e(e,s,t,!0)?!1:void 0;if(o!==void 0)return C6(3,o)}}}function gve(e,t,n){if(mZ(t.totalTextChunk.text,o=>o!==32&&o!==42)){let o=L7e(e,t.totalTextChunk,n);if(o)return o}let i=t.subWordTextChunks,s;for(let o of i)s=F7e(s,L7e(e,o,n));return s}function F7e(e,t){return MW([e,t],rCt)}function rCt(e,t){return e===void 0?1:t===void 0?-1:tc(e.kind,t.kind)||XS(!e.isCaseSensitive,!t.isCaseSensitive)}function hve(e,t,n,i,s={start:0,length:n.length}){return s.length<=t.length&&J7e(0,s.length,o=>nCt(n.charCodeAt(s.start+o),e.charCodeAt(t.start+o),i))}function nCt(e,t,n){return n?yve(e)===yve(t):e===t}function j7e(e,t,n,i){let s=n.characterSpans,o=0,u=0,m,d;for(;;){if(u===s.length)return!0;if(o===t.length)return!1;let S=t[o],E=!1;for(;u<s.length;u++){let x=s[u];if(E&&(!rD(n.text.charCodeAt(s[u-1].start))||!rD(n.text.charCodeAt(s[u].start)))||!hve(e,S,n.text,i,x))break;E=!0,m=m===void 0?o:m,d=d===void 0?!0:d,S=zu(S.start+x.length,S.length-x.length)}!E&&d!==void 0&&(d=!1),o++}}function iCt(e){return{totalTextChunk:Sve(e),subWordTextChunks:oCt(e)}}function rD(e){if(e>=65&&e<=90)return!0;if(e<127||!g5(e,99))return!1;let t=String.fromCharCode(e);return t===t.toUpperCase()}function B7e(e){if(e>=97&&e<=122)return!0;if(e<127||!g5(e,99))return!1;let t=String.fromCharCode(e);return t===t.toLowerCase()}function sCt(e,t){let n=e.length-t.length;for(let i=0;i<=n;i++)if(mZ(t,(s,o)=>yve(e.charCodeAt(o+i))===s))return i;return-1}function yve(e){return e>=65&&e<=90?97+(e-65):e<127?e:String.fromCharCode(e).toLowerCase().charCodeAt(0)}function vve(e){return e>=48&&e<=57}function aCt(e){return rD(e)||B7e(e)||vve(e)||e===95||e===36}function oCt(e){let t=[],n=0,i=0;for(let s=0;s<e.length;s++){let o=e.charCodeAt(s);aCt(o)?(i===0&&(n=s),i++):i>0&&(t.push(Sve(e.substr(n,i))),i=0)}return i>0&&t.push(Sve(e.substr(n,i))),t}function Sve(e){let t=e.toLowerCase();return{text:e,textLowerCase:t,isLowerCase:e===t,characterSpans:bve(e)}}function bve(e){return U7e(e,!1)}function Tve(e){return U7e(e,!0)}function U7e(e,t){let n=[],i=0;for(let s=1;s<e.length;s++){let o=vve(e.charCodeAt(s-1)),u=vve(e.charCodeAt(s)),m=lCt(e,t,s),d=t&&cCt(e,s,i);(Eve(e.charCodeAt(s-1))||Eve(e.charCodeAt(s))||o!==u||m||d)&&(V7e(e,i,s)||n.push(zu(i,s-i)),i=s)}return V7e(e,i,e.length)||n.push(zu(i,e.length-i)),n}function Eve(e){switch(e){case 33:case 34:case 35:case 37:case 38:case 39:case 40:case 41:case 42:case 44:case 45:case 46:case 47:case 58:case 59:case 63:case 64:case 91:case 92:case 93:case 95:case 123:case 125:return!0}return!1}function V7e(e,t,n){return mZ(e,i=>Eve(i)&&i!==95,t,n)}function cCt(e,t,n){return t!==n&&t+1<e.length&&rD(e.charCodeAt(t))&&B7e(e.charCodeAt(t+1))&&mZ(e,rD,n,t)}function lCt(e,t,n){let i=rD(e.charCodeAt(n-1));return rD(e.charCodeAt(n))&&(!t||!i)}function J7e(e,t,n){for(let i=e;i<t;i++)if(!n(i))return!1;return!0}function mZ(e,t,n=0,i=e.length){return J7e(n,i,s=>t(e.charCodeAt(s),s))}function q7e(e,t=!0,n=!1){let i={languageVersion:1,pragmas:void 0,checkJsDirective:void 0,referencedFiles:[],typeReferenceDirectives:[],libReferenceDirectives:[],amdDependencies:[],hasNoDefaultLib:void 0,moduleName:void 0},s=[],o,u,m,d=0,S=!1;function E(){return u=m,m=q_.scan(),m===19?d++:m===20&&d--,m}function x(){let W=q_.getTokenValue(),pe=q_.getTokenStart();return{fileName:W,pos:pe,end:pe+W.length}}function D(){o||(o=[]),o.push({ref:x(),depth:d})}function w(){s.push(x()),R()}function R(){d===0&&(S=!0)}function L(){let W=q_.getToken();return W===138?(W=E(),W===144&&(W=E(),W===11&&D()),!0):!1}function F(){if(u===25)return!1;let W=q_.getToken();if(W===102){if(W=E(),W===21){if(W=E(),W===11||W===15)return w(),!0}else{if(W===11)return w(),!0;if(W===156&&q_.lookAhead(()=>{let K=q_.scan();return K!==161&&(K===42||K===19||K===80||sf(K))})&&(W=E()),W===80||sf(W))if(W=E(),W===161){if(W=E(),W===11)return w(),!0}else if(W===64){if(G(!0))return!0}else if(W===28)W=E();else return!0;if(W===19){for(W=E();W!==20&&W!==1;)W=E();W===20&&(W=E(),W===161&&(W=E(),W===11&&w()))}else W===42&&(W=E(),W===130&&(W=E(),(W===80||sf(W))&&(W=E(),W===161&&(W=E(),W===11&&w()))))}return!0}return!1}function J(){let W=q_.getToken();if(W===95){if(R(),W=E(),W===156&&q_.lookAhead(()=>{let K=q_.scan();return K===42||K===19})&&(W=E()),W===19){for(W=E();W!==20&&W!==1;)W=E();W===20&&(W=E(),W===161&&(W=E(),W===11&&w()))}else if(W===42)W=E(),W===161&&(W=E(),W===11&&w());else if(W===102&&(W=E(),W===156&&q_.lookAhead(()=>{let K=q_.scan();return K===80||sf(K)})&&(W=E()),(W===80||sf(W))&&(W=E(),W===64&&G(!0))))return!0;return!0}return!1}function G(W,pe=!1){let K=W?E():q_.getToken();return K===149?(K=E(),K===21&&(K=E(),(K===11||pe&&K===15)&&w()),!0):!1}function q(){let W=q_.getToken();if(W===80&&q_.getTokenValue()==="define"){if(W=E(),W!==21)return!0;if(W=E(),W===11||W===15)if(W=E(),W===28)W=E();else return!0;if(W!==23)return!0;for(W=E();W!==24&&W!==1;)(W===11||W===15)&&w(),W=E();return!0}return!1}function ee(){for(q_.setText(e),E();q_.getToken()!==1;){if(q_.getToken()===16){let W=[q_.getToken()];e:for(;wt(W);){let pe=q_.scan();switch(pe){case 1:break e;case 102:F();break;case 16:W.push(pe);break;case 19:wt(W)&&W.push(pe);break;case 20:wt(W)&&(vc(W)===16?q_.reScanTemplateToken(!1)===18&&W.pop():W.pop());break}}E()}L()||F()||J()||n&&(G(!1,!0)||q())||E()}q_.setText(void 0)}if(t&&ee(),wY(i,e),IY(i,io),S){if(o)for(let W of o)s.push(W.ref);return{referencedFiles:i.referencedFiles,typeReferenceDirectives:i.typeReferenceDirectives,libReferenceDirectives:i.libReferenceDirectives,importedFiles:s,isLibFile:!!i.hasNoDefaultLib,ambientExternalModules:void 0}}else{let W;if(o)for(let pe of o)pe.depth===0?(W||(W=[]),W.push(pe.ref.fileName)):s.push(pe.ref);return{referencedFiles:i.referencedFiles,typeReferenceDirectives:i.typeReferenceDirectives,libReferenceDirectives:i.libReferenceDirectives,importedFiles:s,isLibFile:!!i.hasNoDefaultLib,ambientExternalModules:W}}}var uCt=/^data:(?:application\/json(?:;charset=[uU][tT][fF]-8);base64,([A-Za-z0-9+/=]+)$)?/;function xve(e){let t=l_(e.useCaseSensitiveFileNames()),n=e.getCurrentDirectory(),i=new Map,s=new Map;return{tryGetSourcePosition:m,tryGetGeneratedPosition:d,toLineColumnOffset:D,clearCache:w,documentPositionMappers:s};function o(R){return rc(R,n,t)}function u(R,L){let F=o(R),J=s.get(F);if(J)return J;let G;if(e.getDocumentPositionMapper)G=e.getDocumentPositionMapper(R,L);else if(e.readFile){let q=x(R);G=q&&gZ({getSourceFileLike:x,getCanonicalFileName:t,log:ee=>e.log(ee)},R,TK(q.text,Sy(q)),ee=>!e.fileExists||e.fileExists(ee)?e.readFile(ee):void 0)}return s.set(F,G||xK),G||xK}function m(R){if(!Mu(R.fileName)||!S(R.fileName))return;let F=u(R.fileName).getSourcePosition(R);return!F||F===R?void 0:m(F)||F}function d(R){if(Mu(R.fileName))return;let L=S(R.fileName);if(!L)return;let F=e.getProgram();if(F.isSourceOfProjectReferenceRedirect(L.fileName))return;let G=F.getCompilerOptions().outFile,q=G?of(G)+".d.ts":C9(R.fileName,F.getCompilerOptions(),F);if(q===void 0)return;let ee=u(q,R.fileName).getGeneratedPosition(R);return ee===R?void 0:ee}function S(R){let L=e.getProgram();if(!L)return;let F=o(R),J=L.getSourceFileByPath(F);return J&&J.resolvedPath===F?J:void 0}function E(R){let L=o(R),F=i.get(L);if(F!==void 0)return F||void 0;if(!e.readFile||e.fileExists&&!e.fileExists(R)){i.set(L,!1);return}let J=e.readFile(R),G=J?_Ct(J):!1;return i.set(L,G),G||void 0}function x(R){return e.getSourceFileLike?e.getSourceFileLike(R):S(R)||E(R)}function D(R,L){return x(R).getLineAndCharacterOfPosition(L)}function w(){i.clear(),s.clear()}}function gZ(e,t,n,i){let s=Uge(n);if(s){let m=uCt.exec(s);if(m){if(m[1]){let d=m[1];return z7e(e,Gfe(lu,d),t)}s=void 0}}let o=[];s&&o.push(s),o.push(t+".map");let u=s&&xs(s,mi(t));for(let m of o){let d=xs(m,mi(t)),S=i(d,u);if(bs(S))return z7e(e,S,d);if(S!==void 0)return S||void 0}}function z7e(e,t,n){let i=Jge(t);if(!(!i||!i.sources||!i.file||!i.mappings)&&!(i.sourcesContent&&i.sourcesContent.some(bs)))return zge(e,i,n)}function _Ct(e,t){return{text:e,lineMap:t,getLineAndCharacterOfPosition(n){return NP(Sy(this),n)}}}var Cve=new Map;function hZ(e,t,n){var i;t.getSemanticDiagnostics(e,n);let s=[],o=t.getTypeChecker();!(e.impliedNodeFormat===1||wl(e.fileName,[".cts",".cjs"]))&&e.commonJsModuleIndicator&&(O0e(t)||kQ(t.getCompilerOptions()))&&fCt(e)&&s.push(pn(gCt(e.commonJsModuleIndicator),v.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module));let m=Af(e);if(Cve.clear(),d(e),SA(t.getCompilerOptions()))for(let S of e.imports){let E=LI(S),x=pCt(E);if(!x)continue;let D=(i=t.getResolvedModuleFromModuleSpecifier(S,e))==null?void 0:i.resolvedModule,w=D&&t.getSourceFile(D.resolvedFileName);w&&w.externalModuleIndicator&&w.externalModuleIndicator!==!0&&dc(w.externalModuleIndicator)&&w.externalModuleIndicator.isExportEquals&&s.push(pn(x,v.Import_may_be_converted_to_a_default_import))}return wn(s,e.bindSuggestionDiagnostics),wn(s,t.getSuggestionDiagnostics(e,n)),s.sort((S,E)=>S.start-E.start);function d(S){if(m)yCt(S,o)&&s.push(pn(Ei(S.parent)?S.parent.name:S,v.This_constructor_function_may_be_converted_to_a_class_declaration));else{if(_l(S)&&S.parent===e&&S.declarationList.flags&2&&S.declarationList.declarations.length===1){let x=S.declarationList.declarations[0].initializer;x&&kf(x,!0)&&s.push(pn(x,v.require_call_may_be_converted_to_an_import))}let E=A_.getJSDocTypedefNodes(S);for(let x of E)s.push(pn(x,v.JSDoc_typedef_may_be_converted_to_TypeScript_type));A_.parameterShouldGetTypeFromJSDoc(S)&&s.push(pn(S.name||S,v.JSDoc_types_may_be_moved_to_TypeScript_types))}SZ(S)&&dCt(S,o,s),S.forEachChild(d)}}function fCt(e){return e.statements.some(t=>{switch(t.kind){case 243:return t.declarationList.declarations.some(n=>!!n.initializer&&kf(W7e(n.initializer),!0));case 244:{let{expression:n}=t;if(!Pn(n))return kf(n,!0);let i=cl(n);return i===1||i===2}default:return!1}})}function W7e(e){return Wn(e)?W7e(e.expression):e}function pCt(e){switch(e.kind){case 272:let{importClause:t,moduleSpecifier:n}=e;return t&&!t.name&&t.namedBindings&&t.namedBindings.kind===274&&La(n)?t.namedBindings.name:void 0;case 271:return e.name;default:return}}function dCt(e,t,n){mCt(e,t)&&!Cve.has(Y7e(e))&&n.push(pn(!e.name&&Ei(e.parent)&&He(e.parent.name)?e.parent.name:e,v.This_may_be_converted_to_an_async_function))}function mCt(e,t){return!VI(e)&&e.body&&Vs(e.body)&&hCt(e.body,t)&&yZ(e,t)}function yZ(e,t){let n=t.getSignatureFromDeclaration(e),i=n?t.getReturnTypeOfSignature(n):void 0;return!!i&&!!t.getPromisedTypeOfPromise(i)}function gCt(e){return Pn(e)?e.left:e}function hCt(e,t){return!!xv(e,n=>fV(n,t))}function fV(e,t){return nm(e)&&!!e.expression&&vZ(e.expression,t)}function vZ(e,t){if(!$7e(e)||!H7e(e)||!e.arguments.every(i=>G7e(i,t)))return!1;let n=e.expression.expression;for(;$7e(n)||Wn(n);)if(ea(n)){if(!H7e(n)||!n.arguments.every(i=>G7e(i,t)))return!1;n=n.expression.expression}else n=n.expression;return!0}function $7e(e){return ea(e)&&(aM(e,"then")||aM(e,"catch")||aM(e,"finally"))}function H7e(e){let t=e.expression.name.text,n=t==="then"?2:t==="catch"||t==="finally"?1:0;return e.arguments.length>n?!1:e.arguments.length<n?!0:n===1||Pt(e.arguments,i=>i.kind===106||He(i)&&i.text==="undefined")}function G7e(e,t){switch(e.kind){case 262:case 218:if(Rl(e)&1)return!1;case 219:Cve.set(Y7e(e),!0);case 106:return!0;case 80:case 211:{let i=t.getSymbolAtLocation(e);return i?t.isUndefinedSymbol(i)||Pt($u(i,t).declarations,s=>Bs(s)||bv(s)&&!!s.initializer&&Bs(s.initializer)):!1}default:return!1}}function Y7e(e){return`${e.pos.toString()}:${e.end.toString()}`}function yCt(e,t){var n,i,s,o;if(ic(e)){if(Ei(e.parent)&&((n=e.symbol.members)!=null&&n.size))return!0;let u=t.getSymbolOfExpando(e,!1);return!!(u&&((i=u.exports)!=null&&i.size||(s=u.members)!=null&&s.size))}return Tl(e)?!!((o=e.symbol.members)!=null&&o.size):!1}function SZ(e){switch(e.kind){case 262:case 174:case 218:case 219:return!0;default:return!1}}var vCt=new Set(["isolatedModules"]);function Ave(e,t){return X7e(e,t,!1)}function K7e(e,t){return X7e(e,t,!0)}var SCt=`/// <reference no-default-lib="true"/>
interface Boolean {}
interface Function {}
interface CallableFunction {}
interface NewableFunction {}
interface IArguments {}
interface Number {}
interface Object {}
interface RegExp {}
interface String {}
interface Array<T> { length: number; [n: number]: T; }
interface SymbolConstructor {
    (desc?: string | number): symbol;
    for(name: string): symbol;
    readonly toStringTag: symbol;
}
declare var Symbol: SymbolConstructor;
interface Symbol {
    readonly [Symbol.toStringTag]: string;
}`,pV="lib.d.ts",kve;function X7e(e,t,n){kve??(kve=HA(pV,SCt,{languageVersion:99}));let i=[],s=t.compilerOptions?bZ(t.compilerOptions,i):{},o=AV();for(let L in o)Ho(o,L)&&s[L]===void 0&&(s[L]=o[L]);for(let L of Fme)s.verbatimModuleSyntax&&vCt.has(L.name)||(s[L.name]=L.transpileOptionValue);s.suppressOutputPathCheck=!0,s.allowNonTsExtensions=!0,n?(s.declaration=!0,s.emitDeclarationOnly=!0,s.isolatedDeclarations=!0):s.declaration=!1;let u=wv(s),m={getSourceFile:L=>L===Zs(d)?S:L===Zs(pV)?kve:void 0,writeFile:(L,F)=>{Ic(L,".map")?(M.assertEqual(x,void 0,"Unexpected multiple source map outputs, file:",L),x=F):(M.assertEqual(E,void 0,"Unexpected multiple outputs, file:",L),E=F)},getDefaultLibFileName:()=>pV,useCaseSensitiveFileNames:()=>!1,getCanonicalFileName:L=>L,getCurrentDirectory:()=>"",getNewLine:()=>u,fileExists:L=>L===d||!!n&&L===pV,readFile:()=>"",directoryExists:()=>!0,getDirectories:()=>[]},d=t.fileName||(t.compilerOptions&&t.compilerOptions.jsx?"module.tsx":"module.ts"),S=HA(d,e,{languageVersion:Ka(s),impliedNodeFormat:K8(rc(d,"",m.getCanonicalFileName),void 0,m,s),setExternalModuleIndicator:WR(s),jsDocParsingMode:t.jsDocParsingMode??0});t.moduleName&&(S.moduleName=t.moduleName),t.renamedDependencies&&(S.renamedDependencies=new Map(Object.entries(t.renamedDependencies)));let E,x,w=X8(n?[d,pV]:[d],s,m);t.reportDiagnostics&&(wn(i,w.getSyntacticDiagnostics(S)),wn(i,w.getOptionsDiagnostics()));let R=w.emit(void 0,void 0,void 0,n,t.transformers,n);return wn(i,R.diagnostics),E===void 0?M.fail("Output generation failed"):{outputText:E,diagnostics:i,sourceMapText:x}}function Q7e(e,t,n,i,s){let o=Ave(e,{compilerOptions:t,fileName:n,reportDiagnostics:!!i,moduleName:s});return wn(i,o.diagnostics),o.outputText}var Pve;function bZ(e,t){Pve=Pve||Zn(og,n=>typeof n.type=="object"&&!Nu(n.type,i=>typeof i!="number")),e=SQ(e);for(let n of Pve){if(!Ho(e,n.name))continue;let i=e[n.name];bs(i)?e[n.name]=iB(n,i,t):Nu(n.type,s=>s===i)||t.push(Vme(n))}return e}var Nve={};A(Nve,{getNavigateToItems:()=>Z7e});function Z7e(e,t,n,i,s,o,u){let m=mve(i);if(!m)return ve;let d=[],S=e.length===1?e[0]:void 0;for(let E of e)n.throwIfCancellationRequested(),!(o&&E.isDeclarationFile)&&(eLe(E,!!u,S)||E.getNamedDeclarations().forEach((x,D)=>{bCt(m,D,x,t,E.fileName,!!u,S,d)}));return d.sort(CCt),(s===void 0?d:d.slice(0,s)).map(ACt)}function eLe(e,t,n){return e!==n&&t&&(CM(e.path)||e.hasNoDefaultLib)}function bCt(e,t,n,i,s,o,u,m){let d=e.getMatchForLastSegmentOfPattern(t);if(d){for(let S of n)if(TCt(S,i,o,u))if(e.patternContainsDots){let E=e.getFullMatch(xCt(S),t);E&&m.push({name:t,fileName:s,matchKind:E.kind,isCaseSensitive:E.isCaseSensitive,declaration:S})}else m.push({name:t,fileName:s,matchKind:d.kind,isCaseSensitive:d.isCaseSensitive,declaration:S})}}function TCt(e,t,n,i){var s;switch(e.kind){case 273:case 276:case 271:let o=t.getSymbolAtLocation(e.name),u=t.getAliasedSymbol(o);return o.escapedName!==u.escapedName&&!((s=u.declarations)!=null&&s.every(m=>eLe(m.getSourceFile(),n,i)));default:return!0}}function ECt(e,t){let n=Ps(e);return!!n&&(tLe(n,t)||n.kind===167&&Dve(n.expression,t))}function Dve(e,t){return tLe(e,t)||Wn(e)&&(t.push(e.name.text),!0)&&Dve(e.expression,t)}function tLe(e,t){return jg(e)&&(t.push(Qd(e)),!0)}function xCt(e){let t=[],n=Ps(e);if(n&&n.kind===167&&!Dve(n.expression,t))return ve;t.shift();let i=b2(e);for(;i;){if(!ECt(i,t))return ve;i=b2(i)}return t.reverse()}function CCt(e,t){return tc(e.matchKind,t.matchKind)||m3(e.name,t.name)}function ACt(e){let t=e.declaration,n=b2(t),i=n&&Ps(n);return{name:e.name,kind:PE(t),kindModifiers:m6(t),matchKind:dZ[e.matchKind],isCaseSensitive:e.isCaseSensitive,fileName:e.fileName,textSpan:df(t),containerName:i?i.text:"",containerKind:i?PE(n):""}}var wve={};A(wve,{getNavigationBarItems:()=>nLe,getNavigationTree:()=>iLe});var kCt=/\s+/g,Ive=150,TZ,DM,dV=[],Jv,rLe=[],nD,Ove=[];function nLe(e,t){TZ=t,DM=e;try{return Cr(ICt(oLe(e)),OCt)}finally{sLe()}}function iLe(e,t){TZ=t,DM=e;try{return gLe(oLe(e))}finally{sLe()}}function sLe(){DM=void 0,TZ=void 0,dV=[],Jv=void 0,Ove=[]}function mV(e){return A6(e.getText(DM))}function EZ(e){return e.node.kind}function aLe(e,t){e.children?e.children.push(t):e.children=[t]}function oLe(e){M.assert(!dV.length);let t={node:e,name:void 0,additionalNodes:void 0,parent:void 0,children:void 0,indent:0};Jv=t;for(let n of e.statements)ck(n);return Rb(),M.assert(!Jv&&!dV.length),t}function IE(e,t){aLe(Jv,Rve(e,t))}function Rve(e,t){return{node:e,name:t||(u_(e)||Ct(e)?Ps(e):void 0),additionalNodes:void 0,parent:Jv,children:void 0,indent:Jv.indent+1}}function cLe(e){nD||(nD=new Map),nD.set(e,!0)}function lLe(e){for(let t=0;t<e;t++)Rb()}function uLe(e,t){let n=[];for(;!jg(t);){let i=hR(t),s=m0(t);t=t.expression,!(s==="prototype"||Zi(i))&&n.push(i)}n.push(t);for(let i=n.length-1;i>0;i--){let s=n[i];OE(e,s)}return[n.length-1,n[0]]}function OE(e,t){let n=Rve(e,t);aLe(Jv,n),dV.push(Jv),rLe.push(nD),nD=void 0,Jv=n}function Rb(){Jv.children&&(xZ(Jv.children,Jv),Fve(Jv.children)),Jv=dV.pop(),nD=rLe.pop()}function Mb(e,t,n){OE(e,n),ck(t),Rb()}function _Le(e){e.initializer&&MCt(e.initializer)?(OE(e),Js(e.initializer,ck),Rb()):Mb(e,e.initializer)}function Mve(e){let t=Ps(e);if(t===void 0)return!1;if(za(t)){let n=t.expression;return nc(n)||Pf(n)||zp(n)}return!!t}function ck(e){if(TZ.throwIfCancellationRequested(),!(!e||HC(e)))switch(e.kind){case 176:let t=e;Mb(t,t.body);for(let u of t.parameters)ap(u,t)&&IE(u);break;case 174:case 177:case 178:case 173:Mve(e)&&Mb(e,e.body);break;case 172:Mve(e)&&_Le(e);break;case 171:Mve(e)&&IE(e);break;case 273:let n=e;n.name&&IE(n.name);let{namedBindings:i}=n;if(i)if(i.kind===274)IE(i);else for(let u of i.elements)IE(u);break;case 304:Mb(e,e.name);break;case 305:let{expression:s}=e;He(s)?IE(e,s):IE(e);break;case 208:case 303:case 260:{let u=e;Hs(u.name)?ck(u.name):_Le(u);break}case 262:let o=e.name;o&&He(o)&&cLe(o.text),Mb(e,e.body);break;case 219:case 218:Mb(e,e.body);break;case 266:OE(e);for(let u of e.members)RCt(u)||IE(u);Rb();break;case 263:case 231:case 264:OE(e);for(let u of e.members)ck(u);Rb();break;case 267:Mb(e,yLe(e).body);break;case 277:{let u=e.expression,m=Ca(u)||ea(u)?u:pc(u)||ic(u)?u.body:void 0;m?(OE(e),ck(m),Rb()):IE(e);break}case 281:case 271:case 181:case 179:case 180:case 265:IE(e);break;case 213:case 226:{let u=cl(e);switch(u){case 1:case 2:Mb(e,e.right);return;case 6:case 3:{let m=e,d=m.left,S=u===3?d.expression:d,E=0,x;He(S.expression)?(cLe(S.expression.text),x=S.expression):[E,x]=uLe(m,S.expression),u===6?Ca(m.right)&&m.right.properties.length>0&&(OE(m,x),Js(m.right,ck),Rb()):ic(m.right)||pc(m.right)?Mb(e,m.right,x):(OE(m,x),Mb(e,m.right,d.name),Rb()),lLe(E);return}case 7:case 9:{let m=e,d=u===7?m.arguments[0]:m.arguments[0].expression,S=m.arguments[1],[E,x]=uLe(e,d);OE(e,x),OE(e,Et(U.createIdentifier(S.text),S)),ck(e.arguments[2]),Rb(),Rb(),lLe(E);return}case 5:{let m=e,d=m.left,S=d.expression;if(He(S)&&m0(d)!=="prototype"&&nD&&nD.has(S.text)){ic(m.right)||pc(m.right)?Mb(e,m.right,S):eE(d)&&(OE(m,S),Mb(m.left,m.right,hR(d)),Rb());return}break}case 4:case 0:case 8:break;default:M.assertNever(u)}}default:Pp(e)&&kt(e.jsDoc,u=>{kt(u.tags,m=>{Xd(m)&&IE(m)})}),Js(e,ck)}}function xZ(e,t){let n=new Map;zw(e,(i,s)=>{let o=i.name||Ps(i.node),u=o&&mV(o);if(!u)return!0;let m=n.get(u);if(!m)return n.set(u,i),!0;if(m instanceof Array){for(let d of m)if(fLe(d,i,s,t))return!1;return m.push(i),!0}else{let d=m;return fLe(d,i,s,t)?!1:(n.set(u,[d,i]),!0)}})}var wM={5:!0,3:!0,7:!0,9:!0,0:!1,1:!1,2:!1,8:!1,6:!0,4:!1};function PCt(e,t,n,i){function s(m){return ic(m)||Tl(m)||Ei(m)}let o=Pn(t.node)||ea(t.node)?cl(t.node):0,u=Pn(e.node)||ea(e.node)?cl(e.node):0;if(wM[o]&&wM[u]||s(e.node)&&wM[o]||s(t.node)&&wM[u]||tu(e.node)&&Lve(e.node)&&wM[o]||tu(t.node)&&wM[u]||tu(e.node)&&Lve(e.node)&&s(t.node)||tu(t.node)&&s(e.node)&&Lve(e.node)){let m=e.additionalNodes&&vc(e.additionalNodes)||e.node;if(!tu(e.node)&&!tu(t.node)||s(e.node)||s(t.node)){let S=s(e.node)?e.node:s(t.node)?t.node:void 0;if(S!==void 0){let E=Et(U.createConstructorDeclaration(void 0,[],void 0),S),x=Rve(E);x.indent=e.indent+1,x.children=e.node===S?e.children:t.children,e.children=e.node===S?ps([x],t.children||[t]):ps(e.children||[{...e}],[x])}else(e.children||t.children)&&(e.children=ps(e.children||[{...e}],t.children||[t]),e.children&&(xZ(e.children,e),Fve(e.children)));m=e.node=Et(U.createClassDeclaration(void 0,e.name||U.createIdentifier("__class__"),void 0,void 0,[]),e.node)}else e.children=ps(e.children,t.children),e.children&&xZ(e.children,e);let d=t.node;return i.children[n-1].node.end===m.end?Et(m,{pos:m.pos,end:d.end}):(e.additionalNodes||(e.additionalNodes=[]),e.additionalNodes.push(Et(U.createClassDeclaration(void 0,e.name||U.createIdentifier("__class__"),void 0,void 0,[]),t.node))),!0}return o!==0}function fLe(e,t,n,i){return PCt(e,t,n,i)?!0:NCt(e.node,t.node,i)?(DCt(e,t),!0):!1}function NCt(e,t,n){if(e.kind!==t.kind||e.parent!==t.parent&&!(pLe(e,n)&&pLe(t,n)))return!1;switch(e.kind){case 172:case 174:case 177:case 178:return oa(e)===oa(t);case 267:return dLe(e,t)&&Uve(e)===Uve(t);default:return!0}}function Lve(e){return!!(e.flags&16)}function pLe(e,t){let n=Hg(e.parent)?e.parent.parent:e.parent;return n===t.node||Es(t.additionalNodes,n)}function dLe(e,t){return!e.body||!t.body?e.body===t.body:e.body.kind===t.body.kind&&(e.body.kind!==267||dLe(e.body,t.body))}function DCt(e,t){e.additionalNodes=e.additionalNodes||[],e.additionalNodes.push(t.node),t.additionalNodes&&e.additionalNodes.push(...t.additionalNodes),e.children=ps(e.children,t.children),e.children&&(xZ(e.children,e),Fve(e.children))}function Fve(e){e.sort(wCt)}function wCt(e,t){return m3(mLe(e.node),mLe(t.node))||tc(EZ(e),EZ(t))}function mLe(e){if(e.kind===267)return hLe(e);let t=Ps(e);if(t&&Ol(t)){let n=e2(t);return n&&Qi(n)}switch(e.kind){case 218:case 219:case 231:return SLe(e);default:return}}function jve(e,t){if(e.kind===267)return A6(hLe(e));if(t){let n=He(t)?t.text:cc(t)?`[${mV(t.argumentExpression)}]`:mV(t);if(n.length>0)return A6(n)}switch(e.kind){case 307:let n=e;return nu(n)?`"${Vh(Ul(of(Zs(n.fileName))))}"`:"<global>";case 277:return dc(e)&&e.isExportEquals?"export=":"default";case 219:case 262:case 218:case 263:case 231:return Nv(e)&2048?"default":SLe(e);case 176:return"constructor";case 180:return"new()";case 179:return"()";case 181:return"[]";default:return"<unknown>"}}function ICt(e){let t=[];function n(s){if(i(s)&&(t.push(s),s.children))for(let o of s.children)n(o)}return n(e),t;function i(s){if(s.children)return!0;switch(EZ(s)){case 263:case 231:case 266:case 264:case 267:case 307:case 265:case 346:case 338:return!0;case 219:case 262:case 218:return o(s);default:return!1}function o(u){if(!u.node.body)return!1;switch(EZ(u.parent)){case 268:case 307:case 174:case 176:return!0;default:return!1}}}}function gLe(e){return{text:jve(e.node,e.name),kind:PE(e.node),kindModifiers:vLe(e.node),spans:Bve(e),nameSpan:e.name&&Vve(e.name),childItems:Cr(e.children,gLe)}}function OCt(e){return{text:jve(e.node,e.name),kind:PE(e.node),kindModifiers:vLe(e.node),spans:Bve(e),childItems:Cr(e.children,t)||Ove,indent:e.indent,bolded:!1,grayed:!1};function t(n){return{text:jve(n.node,n.name),kind:PE(n.node),kindModifiers:m6(n.node),spans:Bve(n),childItems:Ove,indent:0,bolded:!1,grayed:!1}}}function Bve(e){let t=[Vve(e.node)];if(e.additionalNodes)for(let n of e.additionalNodes)t.push(Vve(n));return t}function hLe(e){return B_(e)?Hc(e.name):Uve(e)}function Uve(e){let t=[Qd(e.name)];for(;e.body&&e.body.kind===267;)e=e.body,t.push(Qd(e.name));return t.join(".")}function yLe(e){return e.body&&El(e.body)?yLe(e.body):e}function RCt(e){return!e.name||e.name.kind===167}function Vve(e){return e.kind===307?lS(e):df(e,DM)}function vLe(e){return e.parent&&e.parent.kind===260&&(e=e.parent),m6(e)}function SLe(e){let{parent:t}=e;if(e.name&&H3(e.name)>0)return A6(Yo(e.name));if(Ei(t))return A6(Yo(t.name));if(Pn(t)&&t.operatorToken.kind===64)return mV(t.left).replace(kCt,"");if(ql(t))return mV(t.name);if(Nv(e)&2048)return"default";if(gi(e))return"<class>";if(ea(t)){let n=bLe(t.expression);if(n!==void 0){if(n=A6(n),n.length>Ive)return`${n} callback`;let i=A6(Gi(t.arguments,s=>No(s)||XC(s)?s.getText(DM):void 0).join(", "));return`${n}(${i}) callback`}}return"<function>"}function bLe(e){if(He(e))return e.text;if(Wn(e)){let t=bLe(e.expression),n=e.name.text;return t===void 0?n:`${t}.${n}`}else return}function MCt(e){switch(e.kind){case 219:case 218:case 231:return!0;default:return!1}}function A6(e){return e=e.length>Ive?e.substring(0,Ive)+"...":e,e.replace(/\\?(\r?\n|\r|\u2028|\u2029)/g,"")}var lk={};A(lk,{addExportToChanges:()=>zLe,addExportsInOldFile:()=>Qve,addImportsForMovedSymbols:()=>e1e,addNewFileToTsconfig:()=>Xve,addOrRemoveBracesToArrowFunction:()=>TAt,addTargetFileImports:()=>l1e,containsJsx:()=>i1e,convertArrowFunctionOrFunctionExpression:()=>kAt,convertParamsToDestructuredObject:()=>jAt,convertStringOrTemplateLiteral:()=>rkt,convertToOptionalChainExpression:()=>fkt,createNewFileName:()=>n1e,deleteMovedStatements:()=>ILe,deleteUnusedImports:()=>BLe,deleteUnusedOldImports:()=>OLe,doChangeNamedToNamespaceOrDefault:()=>kLe,extractSymbol:()=>AFe,filterImport:()=>JLe,forEachImportInStatement:()=>Zve,generateGetAccessorAndSetAccessor:()=>Ykt,getApplicableRefactors:()=>LCt,getEditsForRefactor:()=>FCt,getExistingLocals:()=>o1e,getIdentifierForNode:()=>c1e,getNewStatementsAndRemoveFromOldFile:()=>Kve,getStatementsToMove:()=>IM,getTopLevelDeclarationStatement:()=>r1e,getUsageInfo:()=>gV,inferFunctionReturnType:()=>Kkt,isRefactorErrorInfo:()=>D0,isTopLevelDeclaration:()=>OZ,moduleSpecifierFromImport:()=>LLe,nameOfTopLevelDeclaration:()=>qLe,refactorKindBeginsWith:()=>Lb,registerRefactor:()=>By,updateImportsInOtherFiles:()=>RLe});var Jve=new Map;function By(e,t){Jve.set(e,t)}function LCt(e,t){return Is(c3(Jve.values(),n=>{var i;return e.cancellationToken&&e.cancellationToken.isCancellationRequested()||!((i=n.kinds)!=null&&i.some(s=>Lb(s,e.kind)))?void 0:n.getAvailableActions(e,t)}))}function FCt(e,t,n,i){let s=Jve.get(t);return s&&s.getEditsForAction(e,n,i)}var qve="Convert export",CZ={name:"Convert default export to named export",description:Ms(v.Convert_default_export_to_named_export),kind:"refactor.rewrite.export.named"},AZ={name:"Convert named export to default export",description:Ms(v.Convert_named_export_to_default_export),kind:"refactor.rewrite.export.default"};By(qve,{kinds:[CZ.kind,AZ.kind],getAvailableActions:function(t){let n=TLe(t,t.triggerReason==="invoked");if(!n)return ve;if(!D0(n)){let i=n.wasDefault?CZ:AZ;return[{name:qve,description:i.description,actions:[i]}]}return t.preferences.provideRefactorNotApplicableReason?[{name:qve,description:Ms(v.Convert_default_export_to_named_export),actions:[{...CZ,notApplicableReason:n.error},{...AZ,notApplicableReason:n.error}]}]:ve},getEditsForAction:function(t,n){M.assert(n===CZ.name||n===AZ.name,"Unexpected action name");let i=TLe(t);return M.assert(i&&!D0(i),"Expected applicable refactor info"),{edits:Sn.ChangeTracker.with(t,o=>jCt(t.file,t.program,i,o,t.cancellationToken)),renameFilename:void 0,renameLocation:void 0}}});function TLe(e,t=!0){let{file:n,program:i}=e,s=ok(e),o=Yi(n,s.start),u=o.parent&&Nv(o.parent)&32&&t?o.parent:yM(o,n,s);if(!u||!Ji(u.parent)&&!(Hg(u.parent)&&B_(u.parent.parent)))return{error:Ms(v.Could_not_find_export_statement)};let m=i.getTypeChecker(),d=qCt(u.parent,m),S=Nv(u)||(dc(u)&&!u.isExportEquals?2080:0),E=!!(S&2048);if(!(S&32)||!E&&d.exports.has("default"))return{error:Ms(v.This_file_already_has_a_default_export)};let x=D=>He(D)&&m.getSymbolAtLocation(D)?void 0:{error:Ms(v.Can_only_convert_named_export)};switch(u.kind){case 262:case 263:case 264:case 266:case 265:case 267:{let D=u;return D.name?x(D.name)||{exportNode:D,exportName:D.name,wasDefault:E,exportingModuleSymbol:d}:void 0}case 243:{let D=u;if(!(D.declarationList.flags&2)||D.declarationList.declarations.length!==1)return;let w=Ma(D.declarationList.declarations);return w.initializer?(M.assert(!E,"Can't have a default flag here"),x(w.name)||{exportNode:D,exportName:w.name,wasDefault:E,exportingModuleSymbol:d}):void 0}case 277:{let D=u;return D.isExportEquals?void 0:x(D.expression)||{exportNode:D,exportName:D.expression,wasDefault:E,exportingModuleSymbol:d}}default:return}}function jCt(e,t,n,i,s){BCt(e,n,i,t.getTypeChecker()),UCt(t,n,i,s)}function BCt(e,{wasDefault:t,exportNode:n,exportName:i},s,o){if(t)if(dc(n)&&!n.isExportEquals){let u=n.expression,m=ELe(u.text,u.text);s.replaceNode(e,n,U.createExportDeclaration(void 0,!1,U.createNamedExports([m])))}else s.delete(e,M.checkDefined(YN(n,90),"Should find a default keyword in modifier list"));else{let u=M.checkDefined(YN(n,95),"Should find an export keyword in modifier list");switch(n.kind){case 262:case 263:case 264:s.insertNodeAfter(e,u,U.createToken(90));break;case 243:let m=Ma(n.declarationList.declarations);if(!lc.Core.isSymbolReferencedInFile(i,o,e)&&!m.type){s.replaceNode(e,n,U.createExportDefault(M.checkDefined(m.initializer,"Initializer was previously known to be present")));break}case 266:case 265:case 267:s.deleteModifier(e,u),s.insertNodeAfter(e,n,U.createExportDefault(U.createIdentifier(i.text)));break;default:M.fail(`Unexpected exportNode kind ${n.kind}`)}}}function UCt(e,{wasDefault:t,exportName:n,exportingModuleSymbol:i},s,o){let u=e.getTypeChecker(),m=M.checkDefined(u.getSymbolAtLocation(n),"Export name should resolve to a symbol");lc.Core.eachExportReference(e.getSourceFiles(),u,o,m,i,n.text,t,d=>{if(n===d)return;let S=d.getSourceFile();t?VCt(S,d,s,n.text):JCt(S,d,s)})}function VCt(e,t,n,i){let{parent:s}=t;switch(s.kind){case 211:n.replaceNode(e,t,U.createIdentifier(i));break;case 276:case 281:{let u=s;n.replaceNode(e,u,zve(i,u.name.text));break}case 273:{let u=s;M.assert(u.name===t,"Import clause name should match provided ref");let m=zve(i,t.text),{namedBindings:d}=u;if(!d)n.replaceNode(e,t,U.createNamedImports([m]));else if(d.kind===274){n.deleteRange(e,{pos:t.getStart(e),end:d.getStart(e)});let S=La(u.parent.moduleSpecifier)?NQ(u.parent.moduleSpecifier,e):1,E=uS(void 0,[zve(i,t.text)],u.parent.moduleSpecifier,S);n.insertNodeAfter(e,u.parent,E)}else n.delete(e,t),n.insertNodeAtEndOfList(e,d.elements,m);break}case 205:let o=s;n.replaceNode(e,s,U.createImportTypeNode(o.argument,o.attributes,U.createIdentifier(i),o.typeArguments,o.isTypeOf));break;default:M.failBadSyntaxKind(s)}}function JCt(e,t,n){let i=t.parent;switch(i.kind){case 211:n.replaceNode(e,t,U.createIdentifier("default"));break;case 276:{let s=U.createIdentifier(i.name.text);i.parent.elements.length===1?n.replaceNode(e,i.parent,s):(n.delete(e,i),n.insertNodeBefore(e,i.parent,s));break}case 281:{n.replaceNode(e,i,ELe("default",i.name.text));break}default:M.assertNever(i,`Unexpected parent kind ${i.kind}`)}}function zve(e,t){return U.createImportSpecifier(!1,e===t?void 0:U.createIdentifier(e),U.createIdentifier(t))}function ELe(e,t){return U.createExportSpecifier(!1,e===t?void 0:U.createIdentifier(e),U.createIdentifier(t))}function qCt(e,t){if(Ji(e))return e.symbol;let n=e.parent.symbol;return n.valueDeclaration&&YT(n.valueDeclaration)?t.getMergedSymbol(n):n}var Wve="Convert import",kZ={0:{name:"Convert namespace import to named imports",description:Ms(v.Convert_namespace_import_to_named_imports),kind:"refactor.rewrite.import.named"},2:{name:"Convert named imports to namespace import",description:Ms(v.Convert_named_imports_to_namespace_import),kind:"refactor.rewrite.import.namespace"},1:{name:"Convert named imports to default import",description:Ms(v.Convert_named_imports_to_default_import),kind:"refactor.rewrite.import.default"}};By(Wve,{kinds:UC(kZ).map(e=>e.kind),getAvailableActions:function(t){let n=xLe(t,t.triggerReason==="invoked");if(!n)return ve;if(!D0(n)){let i=kZ[n.convertTo];return[{name:Wve,description:i.description,actions:[i]}]}return t.preferences.provideRefactorNotApplicableReason?UC(kZ).map(i=>({name:Wve,description:i.description,actions:[{...i,notApplicableReason:n.error}]})):ve},getEditsForAction:function(t,n){M.assert(Pt(UC(kZ),o=>o.name===n),"Unexpected action name");let i=xLe(t);return M.assert(i&&!D0(i),"Expected applicable refactor info"),{edits:Sn.ChangeTracker.with(t,o=>zCt(t.file,t.program,o,i)),renameFilename:void 0,renameLocation:void 0}}});function xLe(e,t=!0){let{file:n}=e,i=ok(e),s=Yi(n,i.start),o=t?Pr(s,Jp(Yc,Xg)):yM(s,n,i);if(o===void 0||!(Yc(o)||Xg(o)))return{error:"Selection is not an import declaration."};let u=i.start+i.length,m=NE(o,o.parent,n);if(m&&u>m.getStart())return;let{importClause:d}=o;return d?d.namedBindings?d.namedBindings.kind===274?{convertTo:0,import:d.namedBindings}:CLe(e.program,d)?{convertTo:1,import:d.namedBindings}:{convertTo:2,import:d.namedBindings}:{error:Ms(v.Could_not_find_namespace_import_or_named_imports)}:{error:Ms(v.Could_not_find_import_clause)}}function CLe(e,t){return SA(e.getCompilerOptions())&&HCt(t.parent.moduleSpecifier,e.getTypeChecker())}function zCt(e,t,n,i){let s=t.getTypeChecker();i.convertTo===0?WCt(e,s,n,i.import,SA(t.getCompilerOptions())):kLe(e,t,n,i.import,i.convertTo===1)}function WCt(e,t,n,i,s){let o=!1,u=[],m=new Map;lc.Core.eachSymbolReferenceInFile(i.name,t,e,x=>{if(!J3(x.parent))o=!0;else{let D=ALe(x.parent).text;t.resolveName(D,x,-1,!0)&&m.set(D,!0),M.assert($Ct(x.parent)===x,"Parent expression should match id"),u.push(x.parent)}});let d=new Map;for(let x of u){let D=ALe(x).text,w=d.get(D);w===void 0&&d.set(D,w=m.has(D)?E2(D,e):D),n.replaceNode(e,x,U.createIdentifier(w))}let S=[];d.forEach((x,D)=>{S.push(U.createImportSpecifier(!1,x===D?void 0:U.createIdentifier(D),U.createIdentifier(x)))});let E=i.parent.parent;if(o&&!s&&Yc(E))n.insertNodeAfter(e,E,PLe(E,void 0,S));else{let x=o?U.createIdentifier(i.name.text):void 0;n.replaceNode(e,i.parent,NLe(x,S))}}function ALe(e){return Wn(e)?e.name:e.right}function $Ct(e){return Wn(e)?e.expression:e.left}function kLe(e,t,n,i,s=CLe(t,i.parent)){let o=t.getTypeChecker(),u=i.parent.parent,{moduleSpecifier:m}=u,d=new Set;i.elements.forEach(R=>{let L=o.getSymbolAtLocation(R.name);L&&d.add(L)});let S=m&&La(m)?AM(m.text,99):"module";function E(R){return!!lc.Core.eachSymbolReferenceInFile(R.name,o,e,L=>{let F=o.resolveName(S,L,-1,!0);return F?d.has(F)?b_(L.parent):!0:!1})}let D=i.elements.some(E)?E2(S,e):S,w=new Set;for(let R of i.elements){let L=(R.propertyName||R.name).text;lc.Core.eachSymbolReferenceInFile(R.name,o,e,F=>{let J=U.createPropertyAccessExpression(U.createIdentifier(D),L);p_(F.parent)?n.replaceNode(e,F.parent,U.createPropertyAssignment(F.text,J)):b_(F.parent)?w.add(R):n.replaceNode(e,F,J)})}if(n.replaceNode(e,i,s?U.createIdentifier(D):U.createNamespaceImport(U.createIdentifier(D))),w.size&&Yc(u)){let R=Is(w.values(),L=>U.createImportSpecifier(L.isTypeOnly,L.propertyName&&U.createIdentifier(L.propertyName.text),U.createIdentifier(L.name.text)));n.insertNodeAfter(e,i.parent.parent,PLe(u,void 0,R))}}function HCt(e,t){let n=t.resolveExternalModuleName(e);if(!n)return!1;let i=t.resolveExternalModuleSymbol(n);return n!==i}function PLe(e,t,n){return U.createImportDeclaration(void 0,NLe(t,n),e.moduleSpecifier,void 0)}function NLe(e,t){return U.createImportClause(!1,e,t&&t.length?U.createNamedImports(t):void 0)}var $ve="Extract type",PZ={name:"Extract to type alias",description:Ms(v.Extract_to_type_alias),kind:"refactor.extract.type"},NZ={name:"Extract to interface",description:Ms(v.Extract_to_interface),kind:"refactor.extract.interface"},DZ={name:"Extract to typedef",description:Ms(v.Extract_to_typedef),kind:"refactor.extract.typedef"};By($ve,{kinds:[PZ.kind,NZ.kind,DZ.kind],getAvailableActions:function(t){let{info:n,affectedTextRange:i}=DLe(t,t.triggerReason==="invoked");return n?D0(n)?t.preferences.provideRefactorNotApplicableReason?[{name:$ve,description:Ms(v.Extract_type),actions:[{...DZ,notApplicableReason:n.error},{...PZ,notApplicableReason:n.error},{...NZ,notApplicableReason:n.error}]}]:ve:[{name:$ve,description:Ms(v.Extract_type),actions:n.isJS?[DZ]:Bt([PZ],n.typeElements&&NZ)}].map(o=>({...o,actions:o.actions.map(u=>({...u,range:i?{start:{line:ba(t.file,i.pos).line,offset:ba(t.file,i.pos).character},end:{line:ba(t.file,i.end).line,offset:ba(t.file,i.end).character}}:void 0}))})):ve},getEditsForAction:function(t,n){let{file:i}=t,{info:s}=DLe(t);M.assert(s&&!D0(s),"Expected to find a range to extract");let o=E2("NewType",i),u=Sn.ChangeTracker.with(t,S=>{switch(n){case PZ.name:return M.assert(!s.isJS,"Invalid actionName/JS combo"),KCt(S,i,o,s);case DZ.name:return M.assert(s.isJS,"Invalid actionName/JS combo"),QCt(S,t,i,o,s);case NZ.name:return M.assert(!s.isJS&&!!s.typeElements,"Invalid actionName/JS combo"),XCt(S,i,o,s);default:M.fail("Unexpected action name")}}),m=i.fileName,d=bM(u,m,o,!1);return{edits:u,renameFilename:m,renameLocation:d}}});function DLe(e,t=!0){let{file:n,startPosition:i}=e,s=Af(n),o=LU(ok(e)),u=o.pos===o.end&&t,m=GCt(n,i,o,u);if(!m||!Di(m))return{info:{error:Ms(v.Selection_is_not_a_valid_type_node)},affectedTextRange:void 0};let d=e.program.getTypeChecker(),S=ZCt(m,s);if(S===void 0)return{info:{error:Ms(v.No_type_could_be_extracted_from_this_type_node)},affectedTextRange:void 0};let E=eAt(m,S);if(!Di(E))return{info:{error:Ms(v.Selection_is_not_a_valid_type_node)},affectedTextRange:void 0};let x=[];(Z1(E.parent)||jA(E.parent))&&o.end>m.end&&wn(x,E.parent.types.filter(F=>AU(F,n,o.pos,o.end)));let D=x.length>1?x:E,{typeParameters:w,affectedTextRange:R}=YCt(d,D,S,n);if(!w)return{info:{error:Ms(v.No_type_could_be_extracted_from_this_type_node)},affectedTextRange:void 0};let L=wZ(d,D);return{info:{isJS:s,selection:D,enclosingNode:S,typeParameters:w,typeElements:L},affectedTextRange:R}}function GCt(e,t,n,i){let s=[()=>Yi(e,t),()=>HN(e,t,()=>!0)];for(let o of s){let u=o(),m=AU(u,e,n.pos,n.end),d=Pr(u,S=>S.parent&&Di(S)&&!RE(n,S.parent,e)&&(i||m));if(d)return d}}function wZ(e,t){if(t){if(Rs(t)){let n=[];for(let i of t){let s=wZ(e,i);if(!s)return;wn(n,s)}return n}if(jA(t)){let n=[],i=new Map;for(let s of t.types){let o=wZ(e,s);if(!o||!o.every(u=>u.name&&em(i,gM(u.name))))return;wn(n,o)}return n}else{if(a2(t))return wZ(e,t.type);if(lf(t))return t.members}}}function RE(e,t,n){return uM(e,Ja(n.text,t.pos),t.end)}function YCt(e,t,n,i){let s=[],o=VC(t),u={pos:o[0].getStart(i),end:o[o.length-1].end};for(let d of o)if(m(d))return{typeParameters:void 0,affectedTextRange:void 0};return{typeParameters:s,affectedTextRange:u};function m(d){if(Gp(d)){if(He(d.typeName)){let S=d.typeName,E=e.resolveName(S.text,S,262144,!0);for(let x of E?.declarations||ve)if(Ac(x)&&x.getSourceFile()===i){if(x.name.escapedText===S.escapedText&&RE(x,u,i))return!0;if(RE(n,x,i)&&!RE(u,x,i)){ol(s,x);break}}}}else if(s2(d)){let S=Pr(d,E=>dE(E)&&RE(E.extendsType,d,i));if(!S||!RE(u,S,i))return!0}else if(LA(d)||yN(d)){let S=Pr(d.parent,Bs);if(S&&S.type&&RE(S.type,d,i)&&!RE(u,S,i))return!0}else if(pE(d)){if(He(d.exprName)){let S=e.resolveName(d.exprName.text,d.exprName,111551,!1);if(S?.valueDeclaration&&RE(n,S.valueDeclaration,i)&&!RE(u,S.valueDeclaration,i))return!0}else if(z1(d.exprName.left)&&!RE(u,d.parent,i))return!0}return i&&FA(d)&&ba(i,d.pos).line===ba(i,d.end).line&&Tn(d,1),Js(d,m)}}function KCt(e,t,n,i){let{enclosingNode:s,typeParameters:o}=i,{firstTypeNode:u,lastTypeNode:m,newTypeNode:d}=Hve(i),S=U.createTypeAliasDeclaration(void 0,n,o.map(E=>U.updateTypeParameterDeclaration(E,E.modifiers,E.name,E.constraint,void 0)),d);e.insertNodeBefore(t,s,zG(S),!0),e.replaceNodeRange(t,u,m,U.createTypeReferenceNode(n,o.map(E=>U.createTypeReferenceNode(E.name,void 0))),{leadingTriviaOption:Sn.LeadingTriviaOption.Exclude,trailingTriviaOption:Sn.TrailingTriviaOption.ExcludeWhitespace})}function XCt(e,t,n,i){var s;let{enclosingNode:o,typeParameters:u,typeElements:m}=i,d=U.createInterfaceDeclaration(void 0,n,u,void 0,m);Et(d,(s=m[0])==null?void 0:s.parent),e.insertNodeBefore(t,o,zG(d),!0);let{firstTypeNode:S,lastTypeNode:E}=Hve(i);e.replaceNodeRange(t,S,E,U.createTypeReferenceNode(n,u.map(x=>U.createTypeReferenceNode(x.name,void 0))),{leadingTriviaOption:Sn.LeadingTriviaOption.Exclude,trailingTriviaOption:Sn.TrailingTriviaOption.ExcludeWhitespace})}function QCt(e,t,n,i,s){var o;VC(s.selection).forEach(R=>{Tn(R,7168)});let{enclosingNode:u,typeParameters:m}=s,{firstTypeNode:d,lastTypeNode:S,newTypeNode:E}=Hve(s),x=U.createJSDocTypedefTag(U.createIdentifier("typedef"),U.createJSDocTypeExpression(E),U.createIdentifier(i)),D=[];kt(m,R=>{let L=RP(R),F=U.createTypeParameterDeclaration(void 0,R.name),J=U.createJSDocTemplateTag(U.createIdentifier("template"),L&&aa(L,Tb),[F]);D.push(J)});let w=U.createJSDocComment(void 0,U.createNodeArray(ps(D,[x])));if(ag(u)){let R=u.getStart(n),L=Vv(t.host,(o=t.formatContext)==null?void 0:o.options);e.insertNodeAt(n,u.getStart(n),w,{suffix:L+L+n.text.slice(WU(n.text,R-1),R)})}else e.insertNodeBefore(n,u,w,!0);e.replaceNodeRange(n,d,S,U.createTypeReferenceNode(i,m.map(R=>U.createTypeReferenceNode(R.name,void 0))))}function Hve(e){return Rs(e.selection)?{firstTypeNode:e.selection[0],lastTypeNode:e.selection[e.selection.length-1],newTypeNode:Z1(e.selection[0].parent)?U.createUnionTypeNode(e.selection):U.createIntersectionTypeNode(e.selection)}:{firstTypeNode:e.selection,lastTypeNode:e.selection,newTypeNode:e.selection}}function ZCt(e,t){return Pr(e,Vi)||(t?Pr(e,ag):void 0)}function eAt(e,t){return Pr(e,n=>n===t?"quit":!!(Z1(n.parent)||jA(n.parent)))??e}var IZ="Move to file",Gve=Ms(v.Move_to_file),Yve={name:"Move to file",description:Gve,kind:"refactor.move.file"};By(IZ,{kinds:[Yve.kind],getAvailableActions:function(t,n){let i=t.file,s=IM(t);if(!n)return ve;if(t.triggerReason==="implicit"&&t.endPosition!==void 0){let o=Pr(Yi(i,t.startPosition),tD),u=Pr(Yi(i,t.endPosition),tD);if(o&&!Ji(o)&&u&&!Ji(u))return ve}if(t.preferences.allowTextChangesInNewFiles&&s){let o={start:{line:ba(i,s.all[0].getStart(i)).line,offset:ba(i,s.all[0].getStart(i)).character},end:{line:ba(i,Va(s.all).end).line,offset:ba(i,Va(s.all).end).character}};return[{name:IZ,description:Gve,actions:[{...Yve,range:o}]}]}return t.preferences.provideRefactorNotApplicableReason?[{name:IZ,description:Gve,actions:[{...Yve,notApplicableReason:Ms(v.Selection_is_not_a_valid_statement_or_statements)}]}]:ve},getEditsForAction:function(t,n,i){M.assert(n===IZ,"Wrong refactor invoked");let s=M.checkDefined(IM(t)),{host:o,program:u}=t;M.assert(i,"No interactive refactor arguments available");let m=i.targetFile;return Oy(m)||TA(m)?o.fileExists(m)&&u.getSourceFile(m)===void 0?wLe(Ms(v.Cannot_move_statements_to_the_selected_file)):{edits:Sn.ChangeTracker.with(t,S=>tAt(t,t.file,i.targetFile,t.program,s,S,t.host,t.preferences)),renameFilename:void 0,renameLocation:void 0}:wLe(Ms(v.Cannot_move_to_file_selected_file_is_invalid))}});function wLe(e){return{edits:[],renameFilename:void 0,renameLocation:void 0,notApplicableReason:e}}function tAt(e,t,n,i,s,o,u,m){let d=i.getTypeChecker(),S=!u.fileExists(n),E=S?lV(n,t.externalModuleIndicator?99:t.commonJsModuleIndicator?1:void 0,i,u):M.checkDefined(i.getSourceFile(n)),x=A_.createImportAdder(t,e.program,e.preferences,e.host),D=A_.createImportAdder(E,e.program,e.preferences,e.host);Kve(t,E,gV(t,s.all,d,S?void 0:o1e(E,s.all,d)),o,s,i,u,m,D,x),S&&Xve(i,o,t.fileName,n,Pv(u))}function Kve(e,t,n,i,s,o,u,m,d,S){let E=o.getTypeChecker(),x=VW(e.statements,Mg),D=!iZ(t.fileName,o,u,!!e.commonJsModuleIndicator),w=ed(e,m);e1e(n.oldFileImportsFromTargetFile,t.fileName,S,o),OLe(e,s.all,n.unusedImportsFromOldFile,S),S.writeFixes(i,w),ILe(e,s.ranges,i),RLe(i,o,u,e,n.movedSymbols,t.fileName,w),Qve(e,n.targetFileImportsFromOldFile,i,D),l1e(e,n.oldImportsNeededByTargetFile,n.targetFileImportsFromOldFile,E,o,d),!Av(t)&&x.length&&i.insertStatementsInNewFile(t.fileName,x,e),d.writeFixes(i,w);let R=aAt(e,s.all,Is(n.oldFileImportsFromTargetFile.keys()),D);Av(t)&&t.statements.length>0?vAt(i,o,R,t,s):Av(t)?i.insertNodesAtEndOfFile(t,R,!1):i.insertStatementsInNewFile(t.fileName,d.hasFixes()?[4,...R]:R,e)}function Xve(e,t,n,i,s){let o=e.getCompilerOptions().configFile;if(!o)return;let u=Zs(ri(n,"..",i)),m=aI(o.fileName,u,s),d=o.statements[0]&&ai(o.statements[0].expression,Ca),S=d&&Ln(d.properties,E=>ql(E)&&La(E.name)&&E.name.text==="files");S&&Gu(S.initializer)&&t.insertNodeInListAfter(o,Va(S.initializer.elements),U.createStringLiteral(m),S.initializer.elements)}function ILe(e,t,n){for(let{first:i,afterLast:s}of t)n.deleteNodeRangeExcludingEnd(e,i,s)}function OLe(e,t,n,i){for(let s of e.statements)Es(t,s)||Zve(s,o=>{FLe(o,u=>{n.has(u.symbol)&&i.removeExistingImport(u)})})}function Qve(e,t,n,i){let s=GN();t.forEach((o,u)=>{if(u.declarations)for(let m of u.declarations){if(!OZ(m))continue;let d=qLe(m);if(!d)continue;let S=r1e(m);s(S)&&zLe(e,S,d,n,i)}})}function RLe(e,t,n,i,s,o,u){let m=t.getTypeChecker();for(let d of t.getSourceFiles())if(d!==i)for(let S of d.statements)Zve(S,E=>{if(m.getSymbolAtLocation(LLe(E))!==i.symbol)return;let x=F=>{let J=Xa(F.parent)?JU(m,F.parent):$u(m.getSymbolAtLocation(F),m);return!!J&&s.has(J)};BLe(d,E,e,x);let D=QS(mi(xs(i.fileName,t.getCurrentDirectory())),o);if(CP(!t.useCaseSensitiveFileNames())(D,d.fileName)===0)return;let w=IRe(t.getCompilerOptions(),d,d.fileName,D,ak(t,n)),R=JLe(E,h6(w,u),x);R&&e.insertNodeAfter(d,S,R);let L=rAt(E);L&&nAt(e,d,m,s,w,L,E,u)})}function rAt(e){switch(e.kind){case 272:return e.importClause&&e.importClause.namedBindings&&e.importClause.namedBindings.kind===274?e.importClause.namedBindings.name:void 0;case 271:return e.name;case 260:return ai(e.name,He);default:return M.assertNever(e,`Unexpected node kind ${e.kind}`)}}function nAt(e,t,n,i,s,o,u,m){let d=AM(s,99),S=!1,E=[];if(lc.Core.eachSymbolReferenceInFile(o,n,t,x=>{Wn(x.parent)&&(S=S||!!n.resolveName(d,x,-1,!0),i.has(n.getSymbolAtLocation(x.parent.name))&&E.push(x))}),E.length){let x=S?E2(d,t):d;for(let D of E)e.replaceNode(t,D,U.createIdentifier(x));e.insertNodeAfter(t,u,iAt(u,d,s,m))}}function iAt(e,t,n,i){let s=U.createIdentifier(t),o=h6(n,i);switch(e.kind){case 272:return U.createImportDeclaration(void 0,U.createImportClause(!1,void 0,U.createNamespaceImport(s)),o,void 0);case 271:return U.createImportEqualsDeclaration(void 0,!1,s,U.createExternalModuleReference(o));case 260:return U.createVariableDeclaration(s,void 0,void 0,MLe(o));default:return M.assertNever(e,`Unexpected node kind ${e.kind}`)}}function MLe(e){return U.createCallExpression(U.createIdentifier("require"),void 0,[e])}function LLe(e){return e.kind===272?e.moduleSpecifier:e.kind===271?e.moduleReference.expression:e.initializer.arguments[0]}function Zve(e,t){if(Yc(e))La(e.moduleSpecifier)&&t(e);else if(ru(e))C0(e.moduleReference)&&No(e.moduleReference.expression)&&t(e);else if(_l(e))for(let n of e.declarationList.declarations)n.initializer&&kf(n.initializer,!0)&&t(n)}function FLe(e,t){var n,i,s,o,u;if(e.kind===272){if((n=e.importClause)!=null&&n.name&&t(e.importClause),((s=(i=e.importClause)==null?void 0:i.namedBindings)==null?void 0:s.kind)===274&&t(e.importClause.namedBindings),((u=(o=e.importClause)==null?void 0:o.namedBindings)==null?void 0:u.kind)===275)for(let m of e.importClause.namedBindings.elements)t(m)}else if(e.kind===271)t(e);else if(e.kind===260){if(e.name.kind===80)t(e);else if(e.name.kind===206)for(let m of e.name.elements)He(m.name)&&t(m)}}function e1e(e,t,n,i){for(let[s,o]of e){let u=rV(s,Ka(i.getCompilerOptions())),m=s.name==="default"&&s.parent?1:0;n.addImportForNonExistentExport(u,t,m,s.flags,o)}}function sAt(e,t,n,i=2){return U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(e,void 0,t,n)],i))}function aAt(e,t,n,i){return va(t,s=>{if(ULe(s)&&!jLe(e,s,i)&&a1e(s,o=>{var u;return n.includes(M.checkDefined((u=ai(o,Zm))==null?void 0:u.symbol))})){let o=oAt(Co(s),i);if(o)return o}return Co(s)})}function jLe(e,t,n,i){var s;return n?!Du(t)&&li(t,32)||!!(i&&e.symbol&&((s=e.symbol.exports)!=null&&s.has(i.escapedText))):!!e.symbol&&!!e.symbol.exports&&t1e(t).some(o=>e.symbol.exports.has(Uc(o)))}function BLe(e,t,n,i){if(t.kind===272&&t.importClause){let{name:s,namedBindings:o}=t.importClause;if((!s||i(s))&&(!o||o.kind===275&&o.elements.length!==0&&o.elements.every(u=>i(u.name))))return n.delete(e,t)}FLe(t,s=>{s.name&&He(s.name)&&i(s.name)&&n.delete(e,s)})}function ULe(e){return M.assert(Ji(e.parent),"Node parent should be a SourceFile"),GLe(e)||_l(e)}function oAt(e,t){return t?[cAt(e)]:lAt(e)}function cAt(e){let t=wm(e)?ps([U.createModifier(95)],qT(e)):void 0;switch(e.kind){case 262:return U.updateFunctionDeclaration(e,t,e.asteriskToken,e.name,e.typeParameters,e.parameters,e.type,e.body);case 263:let n=TE(e)?F1(e):void 0;return U.updateClassDeclaration(e,ps(n,t),e.name,e.typeParameters,e.heritageClauses,e.members);case 243:return U.updateVariableStatement(e,t,e.declarationList);case 267:return U.updateModuleDeclaration(e,t,e.name,e.body);case 266:return U.updateEnumDeclaration(e,t,e.name,e.members);case 265:return U.updateTypeAliasDeclaration(e,t,e.name,e.typeParameters,e.type);case 264:return U.updateInterfaceDeclaration(e,t,e.name,e.typeParameters,e.heritageClauses,e.members);case 271:return U.updateImportEqualsDeclaration(e,t,e.isTypeOnly,e.name,e.moduleReference);case 244:return M.fail();default:return M.assertNever(e,`Unexpected declaration kind ${e.kind}`)}}function lAt(e){return[e,...t1e(e).map(VLe)]}function VLe(e){return U.createExpressionStatement(U.createBinaryExpression(U.createPropertyAccessExpression(U.createIdentifier("exports"),U.createIdentifier(e)),64,U.createIdentifier(e)))}function t1e(e){switch(e.kind){case 262:case 263:return[e.name.text];case 243:return Gi(e.declarationList.declarations,t=>He(t.name)?t.name.text:void 0);case 267:case 266:case 265:case 264:case 271:return ve;case 244:return M.fail("Can't export an ExpressionStatement");default:return M.assertNever(e,`Unexpected decl kind ${e.kind}`)}}function JLe(e,t,n){switch(e.kind){case 272:{let i=e.importClause;if(!i)return;let s=i.name&&n(i.name)?i.name:void 0,o=i.namedBindings&&uAt(i.namedBindings,n);return s||o?U.createImportDeclaration(void 0,U.createImportClause(i.isTypeOnly,s,o),Co(t),void 0):void 0}case 271:return n(e.name)?e:void 0;case 260:{let i=_At(e.name,n);return i?sAt(i,e.type,MLe(t),e.parent.flags):void 0}default:return M.assertNever(e,`Unexpected import kind ${e.kind}`)}}function uAt(e,t){if(e.kind===274)return t(e.name)?e:void 0;{let n=e.elements.filter(i=>t(i.name));return n.length?U.createNamedImports(n):void 0}}function _At(e,t){switch(e.kind){case 80:return t(e)?e:void 0;case 207:return e;case 206:{let n=e.elements.filter(i=>i.propertyName||!He(i.name)||t(i.name));return n.length?U.createObjectBindingPattern(n):void 0}}}function qLe(e){return Du(e)?ai(e.expression.left.name,He):ai(e.name,He)}function r1e(e){switch(e.kind){case 260:return e.parent.parent;case 208:return r1e(aa(e.parent.parent,t=>Ei(t)||Xa(t)));default:return e}}function zLe(e,t,n,i,s){if(!jLe(e,t,s,n))if(s)Du(t)||i.insertExportModifier(e,t);else{let o=t1e(t);o.length!==0&&i.insertNodesAfter(e,t,o.map(VLe))}}function n1e(e,t,n,i){let s=t.getTypeChecker();if(i){let o=gV(e,i.all,s),u=mi(e.fileName),m=cO(e.fileName);return ri(u,gAt(hAt(o.oldFileImportsFromTargetFile,o.movedSymbols),m,u,n))+m}return""}function fAt(e){let{file:t}=e,n=LU(ok(e)),{statements:i}=t,s=Bo(i,S=>S.end>n.pos);if(s===-1)return;let o=i[s],u=YLe(t,o);u&&(s=u.start);let m=Bo(i,S=>S.end>=n.end,s);m!==-1&&n.end<=i[m].getStart()&&m--;let d=YLe(t,i[m]);return d&&(m=d.end),{toMove:i.slice(s,m===-1?i.length:m+1),afterLast:m===-1?void 0:i[m+1]}}function IM(e){let t=fAt(e);if(t===void 0)return;let n=[],i=[],{toMove:s,afterLast:o}=t;return $w(s,pAt,(u,m)=>{for(let d=u;d<m;d++)n.push(s[d]);i.push({first:s[u],afterLast:o})}),n.length===0?void 0:{all:n,ranges:i}}function i1e(e){return Ln(e,t=>!!(t.transformFlags&2))}function pAt(e){return!dAt(e)&&!Mg(e)}function dAt(e){switch(e.kind){case 272:return!0;case 271:return!li(e,32);case 243:return e.declarationList.declarations.every(t=>!!t.initializer&&kf(t.initializer,!0));default:return!1}}function gV(e,t,n,i=new Set){var s;let o=new Set,u=new Map,m=new Map,d=x(i1e(t));d&&u.set(d,[!1,ai((s=d.declarations)==null?void 0:s[0],D=>_f(D)||ig(D)||My(D)||ru(D)||Xa(D)||Ei(D))]);for(let D of t)a1e(D,w=>{o.add(M.checkDefined(Du(w)?n.getSymbolAtLocation(w.expression.left):w.symbol,"Need a symbol here"))});let S=new Set;for(let D of t)s1e(D,n,(w,R)=>{if(!(!w.declarations||mAt(n,w))){if(i.has($u(w,n))){S.add(w);return}for(let L of w.declarations)if(WLe(L)){let F=u.get(w);u.set(w,[(F===void 0||F)&&R,ai(L,J=>_f(J)||ig(J)||My(J)||ru(J)||Xa(J)||Ei(J))])}else OZ(L)&&yAt(L)===e&&!o.has(w)&&m.set(w,R)}});for(let D of u.keys())S.add(D);let E=new Map;for(let D of e.statements)Es(t,D)||(d&&D.transformFlags&2&&S.delete(d),s1e(D,n,(w,R)=>{o.has(w)&&E.set(w,R),S.delete(w)}));return{movedSymbols:o,targetFileImportsFromOldFile:m,oldFileImportsFromTargetFile:E,oldImportsNeededByTargetFile:u,unusedImportsFromOldFile:S};function x(D){if(D===void 0)return;let w=n.getJsxNamespace(D),R=n.resolveName(w,D,1920,!0);return R&&Pt(R.declarations,WLe)?R:void 0}}function mAt(e,t){return!!e.resolveName(t.name,void 0,788968,!1)}function gAt(e,t,n,i){let s=e;for(let o=1;;o++){let u=ri(n,s+t);if(!i.fileExists(u))return s;s=`${e}.${o}`}}function hAt(e,t){return d0(e,wQ)||d0(t,wQ)||"newFile"}function s1e(e,t,n){e.forEachChild(function i(s){if(He(s)&&!Uh(s)){let o=t.getSymbolAtLocation(s);o&&n(o,gb(s))}else s.forEachChild(i)})}function a1e(e,t){switch(e.kind){case 262:case 263:case 267:case 266:case 265:case 264:case 271:return t(e);case 243:return yi(e.declarationList.declarations,n=>HLe(n.name,t));case 244:{let{expression:n}=e;return Pn(n)&&cl(n)===1?t(e):void 0}}}function WLe(e){switch(e.kind){case 271:case 276:case 273:case 274:return!0;case 260:return $Le(e);case 208:return Ei(e.parent.parent)&&$Le(e.parent.parent);default:return!1}}function $Le(e){return Ji(e.parent.parent.parent)&&!!e.initializer&&kf(e.initializer,!0)}function OZ(e){return GLe(e)&&Ji(e.parent)||Ei(e)&&Ji(e.parent.parent.parent)}function yAt(e){return Ei(e)?e.parent.parent.parent:e.parent}function HLe(e,t){switch(e.kind){case 80:return t(aa(e.parent,n=>Ei(n)||Xa(n)));case 207:case 206:return yi(e.elements,n=>pu(n)?void 0:HLe(n.name,t));default:return M.assertNever(e,`Unexpected name kind ${e.kind}`)}}function GLe(e){switch(e.kind){case 262:case 263:case 267:case 266:case 265:case 264:case 271:return!0;default:return!1}}function vAt(e,t,n,i,s){var o;let u=new Set,m=(o=i.symbol)==null?void 0:o.exports;if(m){let S=t.getTypeChecker(),E=new Map;for(let x of s.all)ULe(x)&&li(x,32)&&a1e(x,D=>{var w;let R=Zm(D)?(w=m.get(D.symbol.escapedName))==null?void 0:w.declarations:void 0,L=yi(R,F=>xl(F)?F:b_(F)?ai(F.parent.parent,xl):void 0);L&&L.moduleSpecifier&&E.set(L,(E.get(L)||new Set).add(D))});for(let[x,D]of Is(E))if(x.exportClause&&kd(x.exportClause)&&wt(x.exportClause.elements)){let w=x.exportClause.elements,R=Zn(w,L=>Ln($u(L.symbol,S).declarations,F=>OZ(F)&&D.has(F))===void 0);if(wt(R)===0){e.deleteNode(i,x),u.add(x);continue}wt(R)<wt(w)&&e.replaceNode(i,x,U.updateExportDeclaration(x,x.modifiers,x.isTypeOnly,U.updateNamedExports(x.exportClause,U.createNodeArray(R,w.hasTrailingComma)),x.moduleSpecifier,x.attributes))}}let d=xm(i.statements,S=>xl(S)&&!!S.moduleSpecifier&&!u.has(S));d?e.insertNodesBefore(i,d,n,!0):e.insertNodesAfter(i,i.statements[i.statements.length-1],n)}function YLe(e,t){if(Go(t)){let n=t.symbol.declarations;if(n===void 0||wt(n)<=1||!Es(n,t))return;let i=n[0],s=n[wt(n)-1],o=Gi(n,d=>Ur(d)===e&&Vi(d)?d:void 0),u=Bo(e.statements,d=>d.end>=s.end),m=Bo(e.statements,d=>d.end>=i.end);return{toMove:o,start:m,end:u}}}function o1e(e,t,n){let i=new Set;for(let s of e.imports){let o=LI(s);if(Yc(o)&&o.importClause&&o.importClause.namedBindings&&Gg(o.importClause.namedBindings))for(let u of o.importClause.namedBindings.elements){let m=n.getSymbolAtLocation(u.propertyName||u.name);m&&i.add($u(m,n))}if(_R(o.parent)&&Yp(o.parent.name))for(let u of o.parent.name.elements){let m=n.getSymbolAtLocation(u.propertyName||u.name);m&&i.add($u(m,n))}}for(let s of t)s1e(s,n,o=>{let u=$u(o,n);u.valueDeclaration&&Ur(u.valueDeclaration).path===e.path&&i.add(u)});return i}function D0(e){return e.error!==void 0}function Lb(e,t){return t?e.substr(0,t.length)===t:!0}function c1e(e,t,n,i){return Wn(e)&&!gi(t)&&!n.resolveName(e.name.text,e,111551,!1)&&!Zi(e.name)&&!Jx(e.name)?e.name.text:E2(gi(t)?"newProperty":"newLocal",i)}function l1e(e,t,n,i,s,o){t.forEach(([u,m],d)=>{var S;let E=$u(d,i);i.isUnknownSymbol(E)?o.addVerbatimImport(M.checkDefined(m??Pr((S=d.declarations)==null?void 0:S[0],R_e))):o.addImportFromExportedSymbol(E,u,m)}),e1e(n,e.fileName,o,s)}var hV="Inline variable",u1e=Ms(v.Inline_variable),_1e={name:hV,description:u1e,kind:"refactor.inline.variable"};By(hV,{kinds:[_1e.kind],getAvailableActions(e){let{file:t,program:n,preferences:i,startPosition:s,triggerReason:o}=e,u=KLe(t,s,o==="invoked",n);return u?lk.isRefactorErrorInfo(u)?i.provideRefactorNotApplicableReason?[{name:hV,description:u1e,actions:[{..._1e,notApplicableReason:u.error}]}]:ve:[{name:hV,description:u1e,actions:[_1e]}]:ve},getEditsForAction(e,t){M.assert(t===hV,"Unexpected refactor invoked");let{file:n,program:i,startPosition:s}=e,o=KLe(n,s,!0,i);if(!o||lk.isRefactorErrorInfo(o))return;let{references:u,declaration:m,replacement:d}=o;return{edits:Sn.ChangeTracker.with(e,E=>{for(let x of u)E.replaceNode(n,x,SAt(x,d));E.delete(n,m)})}}});function KLe(e,t,n,i){var s,o;let u=i.getTypeChecker(),m=wf(e,t),d=m.parent;if(He(m)){if(qR(d)&&NI(d)&&He(d.name)){if(((s=u.getMergedSymbol(d.symbol).declarations)==null?void 0:s.length)!==1)return{error:Ms(v.Variables_with_multiple_declarations_cannot_be_inlined)};if(XLe(d))return;let S=QLe(d,u,e);return S&&{references:S,declaration:d,replacement:d.initializer}}if(n){let S=u.resolveName(m.text,m,111551,!1);if(S=S&&u.getMergedSymbol(S),((o=S?.declarations)==null?void 0:o.length)!==1)return{error:Ms(v.Variables_with_multiple_declarations_cannot_be_inlined)};let E=S.declarations[0];if(!qR(E)||!NI(E)||!He(E.name)||XLe(E))return;let x=QLe(E,u,e);return x&&{references:x,declaration:E,replacement:E.initializer}}return{error:Ms(v.Could_not_find_variable_to_inline)}}}function XLe(e){let t=aa(e.parent.parent,_l);return Pt(t.modifiers,OA)}function QLe(e,t,n){let i=[],s=lc.Core.eachSymbolReferenceInFile(e.name,t,n,o=>{if(lc.isWriteAccessForReference(o)&&!p_(o.parent)||b_(o.parent)||dc(o.parent)||pE(o.parent)||P3(e,o.pos))return!0;i.push(o)});return i.length===0||s?void 0:i}function SAt(e,t){t=Co(t);let{parent:n}=e;return Ct(n)&&(zI(t)<zI(n)||$U(n))||Bs(t)&&(HT(n)||Wn(n))||Wn(n)&&(Pf(t)||Ca(t))?U.createParenthesizedExpression(t):He(e)&&p_(n)?U.createPropertyAssignment(e,t):t}var yV="Move to a new file",f1e=Ms(v.Move_to_a_new_file),p1e={name:yV,description:f1e,kind:"refactor.move.newFile"};By(yV,{kinds:[p1e.kind],getAvailableActions:function(t){let n=IM(t),i=t.file;if(t.triggerReason==="implicit"&&t.endPosition!==void 0){let s=Pr(Yi(i,t.startPosition),tD),o=Pr(Yi(i,t.endPosition),tD);if(s&&!Ji(s)&&o&&!Ji(o))return ve}if(t.preferences.allowTextChangesInNewFiles&&n){let s=t.file,o={start:{line:ba(s,n.all[0].getStart(s)).line,offset:ba(s,n.all[0].getStart(s)).character},end:{line:ba(s,Va(n.all).end).line,offset:ba(s,Va(n.all).end).character}};return[{name:yV,description:f1e,actions:[{...p1e,range:o}]}]}return t.preferences.provideRefactorNotApplicableReason?[{name:yV,description:f1e,actions:[{...p1e,notApplicableReason:Ms(v.Selection_is_not_a_valid_statement_or_statements)}]}]:ve},getEditsForAction:function(t,n){M.assert(n===yV,"Wrong refactor invoked");let i=M.checkDefined(IM(t));return{edits:Sn.ChangeTracker.with(t,o=>bAt(t.file,t.program,i,o,t.host,t,t.preferences)),renameFilename:void 0,renameLocation:void 0}}});function bAt(e,t,n,i,s,o,u){let m=t.getTypeChecker(),d=gV(e,n.all,m),S=n1e(e,t,s,n),E=lV(S,e.externalModuleIndicator?99:e.commonJsModuleIndicator?1:void 0,t,s),x=A_.createImportAdder(e,o.program,o.preferences,o.host),D=A_.createImportAdder(E,o.program,o.preferences,o.host);Kve(e,E,d,i,n,t,s,u,D,x),Xve(t,i,e.fileName,S,Pv(s))}var TAt={},d1e="Convert overload list to single signature",ZLe=Ms(v.Convert_overload_list_to_single_signature),eFe={name:d1e,description:ZLe,kind:"refactor.rewrite.function.overloadList"};By(d1e,{kinds:[eFe.kind],getEditsForAction:xAt,getAvailableActions:EAt});function EAt(e){let{file:t,startPosition:n,program:i}=e;return rFe(t,n,i)?[{name:d1e,description:ZLe,actions:[eFe]}]:ve}function xAt(e){let{file:t,startPosition:n,program:i}=e,s=rFe(t,n,i);if(!s)return;let o=i.getTypeChecker(),u=s[s.length-1],m=u;switch(u.kind){case 173:{m=U.updateMethodSignature(u,u.modifiers,u.name,u.questionToken,u.typeParameters,S(s),u.type);break}case 174:{m=U.updateMethodDeclaration(u,u.modifiers,u.asteriskToken,u.name,u.questionToken,u.typeParameters,S(s),u.type,u.body);break}case 179:{m=U.updateCallSignature(u,u.typeParameters,S(s),u.type);break}case 176:{m=U.updateConstructorDeclaration(u,u.modifiers,S(s),u.body);break}case 180:{m=U.updateConstructSignature(u,u.typeParameters,S(s),u.type);break}case 262:{m=U.updateFunctionDeclaration(u,u.modifiers,u.asteriskToken,u.name,u.typeParameters,S(s),u.type,u.body);break}default:return M.failBadSyntaxKind(u,"Unhandled signature kind in overload list conversion refactoring")}if(m===u)return;return{renameFilename:void 0,renameLocation:void 0,edits:Sn.ChangeTracker.with(e,D=>{D.replaceNodeRange(t,s[0],s[s.length-1],m)})};function S(D){let w=D[D.length-1];return Go(w)&&w.body&&(D=D.slice(0,D.length-1)),U.createNodeArray([U.createParameterDeclaration(void 0,U.createToken(26),"args",void 0,U.createUnionTypeNode(Cr(D,E)))])}function E(D){let w=Cr(D.parameters,x);return Tn(U.createTupleTypeNode(w),Pt(w,R=>!!wt(mN(R)))?0:1)}function x(D){M.assert(He(D.name));let w=Et(U.createNamedTupleMember(D.dotDotDotToken,D.name,D.questionToken,D.type||U.createKeywordTypeNode(133)),D),R=D.symbol&&D.symbol.getDocumentationComment(o);if(R){let L=MM(R);L.length&&hb(w,[{text:`*
${L.split(`
`).map(F=>` * ${F}`).join(`
`)}
 `,kind:3,pos:-1,end:-1,hasTrailingNewLine:!0,hasLeadingNewline:!0}])}return w}}function tFe(e){switch(e.kind){case 173:case 174:case 179:case 176:case 180:case 262:return!0}return!1}function rFe(e,t,n){let i=Yi(e,t),s=Pr(i,tFe);if(!s||Go(s)&&s.body&&cM(s.body,t))return;let o=n.getTypeChecker(),u=s.symbol;if(!u)return;let m=u.declarations;if(wt(m)<=1||!wi(m,D=>Ur(D)===e)||!tFe(m[0]))return;let d=m[0].kind;if(!wi(m,D=>D.kind===d))return;let S=m;if(Pt(S,D=>!!D.typeParameters||Pt(D.parameters,w=>!!w.modifiers||!He(w.name))))return;let E=Gi(S,D=>o.getSignatureFromDeclaration(D));if(wt(E)!==wt(m))return;let x=o.getReturnTypeOfSignature(E[0]);if(wi(E,D=>o.getReturnTypeOfSignature(D)===x))return S}var m1e="Add or remove braces in an arrow function",nFe=Ms(v.Add_or_remove_braces_in_an_arrow_function),RZ={name:"Add braces to arrow function",description:Ms(v.Add_braces_to_arrow_function),kind:"refactor.rewrite.arrow.braces.add"},vV={name:"Remove braces from arrow function",description:Ms(v.Remove_braces_from_arrow_function),kind:"refactor.rewrite.arrow.braces.remove"};By(m1e,{kinds:[vV.kind],getEditsForAction:AAt,getAvailableActions:CAt});function CAt(e){let{file:t,startPosition:n,triggerReason:i}=e,s=iFe(t,n,i==="invoked");return s?D0(s)?e.preferences.provideRefactorNotApplicableReason?[{name:m1e,description:nFe,actions:[{...RZ,notApplicableReason:s.error},{...vV,notApplicableReason:s.error}]}]:ve:[{name:m1e,description:nFe,actions:[s.addBraces?RZ:vV]}]:ve}function AAt(e,t){let{file:n,startPosition:i}=e,s=iFe(n,i);M.assert(s&&!D0(s),"Expected applicable refactor info");let{expression:o,returnStatement:u,func:m}=s,d;if(t===RZ.name){let E=U.createReturnStatement(o);d=U.createBlock([E],!0),QN(o,E,n,3,!0)}else if(t===vV.name&&u){let E=o||U.createVoidZero();d=$U(E)?U.createParenthesizedExpression(E):E,TM(u,d,n,3,!1),QN(u,d,n,3,!1),b6(u,d,n,3,!1)}else M.fail("invalid action");return{renameFilename:void 0,renameLocation:void 0,edits:Sn.ChangeTracker.with(e,E=>{E.replaceNode(n,m.body,d)})}}function iFe(e,t,n=!0,i){let s=Yi(e,t),o=Dp(s);if(!o)return{error:Ms(v.Could_not_find_a_containing_arrow_function)};if(!pc(o))return{error:Ms(v.Containing_function_is_not_an_arrow_function)};if(!(!Zp(o,s)||Zp(o.body,s)&&!n)){if(Lb(RZ.kind,i)&&Ct(o.body))return{func:o,addBraces:!0,expression:o.body};if(Lb(vV.kind,i)&&Vs(o.body)&&o.body.statements.length===1){let u=Ma(o.body.statements);if(nm(u)){let m=u.expression&&Ca(uN(u.expression,!1))?U.createParenthesizedExpression(u.expression):u.expression;return{func:o,addBraces:!1,expression:m,returnStatement:u}}}}}var kAt={},sFe="Convert arrow function or function expression",PAt=Ms(v.Convert_arrow_function_or_function_expression),SV={name:"Convert to anonymous function",description:Ms(v.Convert_to_anonymous_function),kind:"refactor.rewrite.function.anonymous"},bV={name:"Convert to named function",description:Ms(v.Convert_to_named_function),kind:"refactor.rewrite.function.named"},TV={name:"Convert to arrow function",description:Ms(v.Convert_to_arrow_function),kind:"refactor.rewrite.function.arrow"};By(sFe,{kinds:[SV.kind,bV.kind,TV.kind],getEditsForAction:DAt,getAvailableActions:NAt});function NAt(e){let{file:t,startPosition:n,program:i,kind:s}=e,o=oFe(t,n,i);if(!o)return ve;let{selectedVariableDeclaration:u,func:m}=o,d=[],S=[];if(Lb(bV.kind,s)){let E=u||pc(m)&&Ei(m.parent)?void 0:Ms(v.Could_not_convert_to_named_function);E?S.push({...bV,notApplicableReason:E}):d.push(bV)}if(Lb(SV.kind,s)){let E=!u&&pc(m)?void 0:Ms(v.Could_not_convert_to_anonymous_function);E?S.push({...SV,notApplicableReason:E}):d.push(SV)}if(Lb(TV.kind,s)){let E=ic(m)?void 0:Ms(v.Could_not_convert_to_arrow_function);E?S.push({...TV,notApplicableReason:E}):d.push(TV)}return[{name:sFe,description:PAt,actions:d.length===0&&e.preferences.provideRefactorNotApplicableReason?S:d}]}function DAt(e,t){let{file:n,startPosition:i,program:s}=e,o=oFe(n,i,s);if(!o)return;let{func:u}=o,m=[];switch(t){case SV.name:m.push(...RAt(e,u));break;case bV.name:let d=OAt(u);if(!d)return;m.push(...MAt(e,u,d));break;case TV.name:if(!ic(u))return;m.push(...LAt(e,u));break;default:return M.fail("invalid action")}return{renameFilename:void 0,renameLocation:void 0,edits:m}}function aFe(e){let t=!1;return e.forEachChild(function n(i){if($N(i)){t=!0;return}!gi(i)&&!Tl(i)&&!ic(i)&&Js(i,n)}),t}function oFe(e,t,n){let i=Yi(e,t),s=n.getTypeChecker(),o=IAt(e,s,i.parent);if(o&&!aFe(o.body)&&!s.containsArgumentsReference(o))return{selectedVariableDeclaration:!0,func:o};let u=Dp(i);if(u&&(ic(u)||pc(u))&&!Zp(u.body,i)&&!aFe(u.body)&&!s.containsArgumentsReference(u))return ic(u)&&lFe(e,s,u)?void 0:{selectedVariableDeclaration:!1,func:u}}function wAt(e){return Ei(e)||Ru(e)&&e.declarations.length===1}function IAt(e,t,n){if(!wAt(n))return;let s=(Ei(n)?n:Ma(n.declarations)).initializer;if(s&&(pc(s)||ic(s)&&!lFe(e,t,s)))return s}function cFe(e){if(Ct(e)){let t=U.createReturnStatement(e),n=e.getSourceFile();return Et(t,e),gp(t),TM(e,t,n,void 0,!0),U.createBlock([t],!0)}else return e}function OAt(e){let t=e.parent;if(!Ei(t)||!NI(t))return;let n=t.parent,i=n.parent;if(!(!Ru(n)||!_l(i)||!He(t.name)))return{variableDeclaration:t,variableDeclarationList:n,statement:i,name:t.name}}function RAt(e,t){let{file:n}=e,i=cFe(t.body),s=U.createFunctionExpression(t.modifiers,t.asteriskToken,void 0,t.typeParameters,t.parameters,t.type,i);return Sn.ChangeTracker.with(e,o=>o.replaceNode(n,t,s))}function MAt(e,t,n){let{file:i}=e,s=cFe(t.body),{variableDeclaration:o,variableDeclarationList:u,statement:m,name:d}=n;WQ(m);let S=eb(o)&32|U_(t),E=U.createModifiersFromModifierFlags(S),x=U.createFunctionDeclaration(wt(E)?E:void 0,t.asteriskToken,d,t.typeParameters,t.parameters,t.type,s);return u.declarations.length===1?Sn.ChangeTracker.with(e,D=>D.replaceNode(i,m,x)):Sn.ChangeTracker.with(e,D=>{D.delete(i,o),D.insertNodeAfter(i,m,x)})}function LAt(e,t){let{file:n}=e,s=t.body.statements[0],o;FAt(t.body,s)?(o=s.expression,gp(o),T2(s,o)):o=t.body;let u=U.createArrowFunction(t.modifiers,t.typeParameters,t.parameters,t.type,U.createToken(39),o);return Sn.ChangeTracker.with(e,m=>m.replaceNode(n,t,u))}function FAt(e,t){return e.statements.length===1&&nm(t)&&!!t.expression}function lFe(e,t,n){return!!n.name&&lc.Core.isSymbolReferencedInFile(n.name,t,e)}var jAt={},MZ="Convert parameters to destructured object",BAt=1,uFe=Ms(v.Convert_parameters_to_destructured_object),_Fe={name:MZ,description:uFe,kind:"refactor.rewrite.parameters.toDestructured"};By(MZ,{kinds:[_Fe.kind],getEditsForAction:VAt,getAvailableActions:UAt});function UAt(e){let{file:t,startPosition:n}=e;return Af(t)||!dFe(t,n,e.program.getTypeChecker())?ve:[{name:MZ,description:uFe,actions:[_Fe]}]}function VAt(e,t){M.assert(t===MZ,"Unexpected action name");let{file:n,startPosition:i,program:s,cancellationToken:o,host:u}=e,m=dFe(n,i,s.getTypeChecker());if(!m||!o)return;let d=qAt(m,s,o);return d.valid?{renameFilename:void 0,renameLocation:void 0,edits:Sn.ChangeTracker.with(e,E=>JAt(n,s,u,E,m,d))}:{edits:[]}}function JAt(e,t,n,i,s,o){let u=o.signature,m=Cr(yFe(s,t,n),E=>Co(E));if(u){let E=Cr(yFe(u,t,n),x=>Co(x));S(u,E)}S(s,m);let d=jC(o.functionCalls,(E,x)=>tc(E.pos,x.pos));for(let E of d)if(E.arguments&&E.arguments.length){let x=Co(ZAt(s,E.arguments),!0);i.replaceNodeRange(Ur(E),Ma(E.arguments),Va(E.arguments),x,{leadingTriviaOption:Sn.LeadingTriviaOption.IncludeAll,trailingTriviaOption:Sn.TrailingTriviaOption.Include})}function S(E,x){i.replaceNodeRangeWithNodes(e,Ma(E.parameters),Va(E.parameters),x,{joiner:", ",indentation:0,leadingTriviaOption:Sn.LeadingTriviaOption.IncludeAll,trailingTriviaOption:Sn.TrailingTriviaOption.Include})}}function qAt(e,t,n){let i=tkt(e),s=Vc(e)?ekt(e):[],o=I1([...i,...s],gv),u=t.getTypeChecker(),m=va(o,x=>lc.getReferenceEntriesForNode(-1,x,t,t.getSourceFiles(),n)),d=S(m);return wi(d.declarations,x=>Es(o,x))||(d.valid=!1),d;function S(x){let D={accessExpressions:[],typeUsages:[]},w={functionCalls:[],declarations:[],classReferences:D,valid:!0},R=Cr(i,E),L=Cr(s,E),F=Vc(e),J=Cr(i,G=>g1e(G,u));for(let G of x){if(G.kind===lc.EntryKind.Span){w.valid=!1;continue}if(Es(J,E(G.node))){if(HAt(G.node.parent)){w.signature=G.node.parent;continue}let ee=pFe(G);if(ee){w.functionCalls.push(ee);continue}}let q=g1e(G.node,u);if(q&&Es(J,q)){let ee=h1e(G);if(ee){w.declarations.push(ee);continue}}if(Es(R,E(G.node))||p6(G.node)){if(fFe(G))continue;let W=h1e(G);if(W){w.declarations.push(W);continue}let pe=pFe(G);if(pe){w.functionCalls.push(pe);continue}}if(F&&Es(L,E(G.node))){if(fFe(G))continue;let W=h1e(G);if(W){w.declarations.push(W);continue}let pe=zAt(G);if(pe){D.accessExpressions.push(pe);continue}if(tu(e.parent)){let K=WAt(G);if(K){D.typeUsages.push(K);continue}}}w.valid=!1}return w}function E(x){let D=u.getSymbolAtLocation(x);return D&&qQ(D,u)}}function g1e(e,t){let n=LM(e);if(n){let i=t.getContextualTypeForObjectLiteralElement(n),s=i?.getSymbol();if(s&&!(ll(s)&6))return s}}function fFe(e){let t=e.node;if(_f(t.parent)||ig(t.parent)||ru(t.parent)||My(t.parent)||b_(t.parent)||dc(t.parent))return t}function h1e(e){if(u_(e.node.parent))return e.node}function pFe(e){if(e.node.parent){let t=e.node,n=t.parent;switch(n.kind){case 213:case 214:let i=ai(n,Ig);if(i&&i.expression===t)return i;break;case 211:let s=ai(n,Wn);if(s&&s.parent&&s.name===t){let u=ai(s.parent,Ig);if(u&&u.expression===s)return u}break;case 212:let o=ai(n,cc);if(o&&o.parent&&o.argumentExpression===t){let u=ai(o.parent,Ig);if(u&&u.expression===o)return u}break}}}function zAt(e){if(e.node.parent){let t=e.node,n=t.parent;switch(n.kind){case 211:let i=ai(n,Wn);if(i&&i.expression===t)return i;break;case 212:let s=ai(n,cc);if(s&&s.expression===t)return s;break}}}function WAt(e){let t=e.node;if(S2(t)===2||O9(t.parent))return t}function dFe(e,t,n){let i=HN(e,t),s=tfe(i);if(!$At(i)&&s&&GAt(s,n)&&Zp(s,i)&&!(s.body&&Zp(s.body,i)))return s}function $At(e){let t=Pr(e,FP);if(t){let n=Pr(t,i=>!FP(i));return!!n&&Go(n)}return!1}function HAt(e){return $g(e)&&(Yu(e.parent)||lf(e.parent))}function GAt(e,t){var n;if(!YAt(e.parameters,t))return!1;switch(e.kind){case 262:return mFe(e)&&EV(e,t);case 174:if(Ca(e.parent)){let i=g1e(e.name,t);return((n=i?.declarations)==null?void 0:n.length)===1&&EV(e,t)}return EV(e,t);case 176:return tu(e.parent)?mFe(e.parent)&&EV(e,t):gFe(e.parent.parent)&&EV(e,t);case 218:case 219:return gFe(e.parent)}return!1}function EV(e,t){return!!e.body&&!t.isImplementationOfOverload(e)}function mFe(e){return e.name?!0:!!YN(e,90)}function YAt(e,t){return XAt(e)>=BAt&&wi(e,n=>KAt(n,t))}function KAt(e,t){if(Fh(e)){let n=t.getTypeAtLocation(e);if(!t.isArrayType(n)&&!t.isTupleType(n))return!1}return!e.modifiers&&He(e.name)}function gFe(e){return Ei(e)&&zP(e)&&He(e.name)&&!e.type}function y1e(e){return e.length>0&&$N(e[0].name)}function XAt(e){return y1e(e)?e.length-1:e.length}function hFe(e){return y1e(e)&&(e=U.createNodeArray(e.slice(1),e.hasTrailingComma)),e}function QAt(e,t){return He(t)&&Qd(t)===e?U.createShorthandPropertyAssignment(e):U.createPropertyAssignment(e,t)}function ZAt(e,t){let n=hFe(e.parameters),i=Fh(Va(n)),s=i?t.slice(0,n.length-1):t,o=Cr(s,(m,d)=>{let S=LZ(n[d]),E=QAt(S,m);return gp(E.name),ql(E)&&gp(E.initializer),T2(m,E),E});if(i&&t.length>=n.length){let m=t.slice(n.length-1),d=U.createPropertyAssignment(LZ(Va(n)),U.createArrayLiteralExpression(m));o.push(d)}return U.createObjectLiteralExpression(o,!1)}function yFe(e,t,n){let i=t.getTypeChecker(),s=hFe(e.parameters),o=Cr(s,E),u=U.createObjectBindingPattern(o),m=x(s),d;wi(s,R)&&(d=U.createObjectLiteralExpression());let S=U.createParameterDeclaration(void 0,void 0,u,void 0,m,d);if(y1e(e.parameters)){let L=e.parameters[0],F=U.createParameterDeclaration(void 0,void 0,L.name,void 0,L.type);return gp(F.name),T2(L.name,F.name),L.type&&(gp(F.type),T2(L.type,F.type)),U.createNodeArray([F,S])}return U.createNodeArray([S]);function E(L){let F=U.createBindingElement(void 0,void 0,LZ(L),Fh(L)&&R(L)?U.createArrayLiteralExpression():L.initializer);return gp(F),L.initializer&&F.initializer&&T2(L.initializer,F.initializer),F}function x(L){let F=Cr(L,D);return zg(U.createTypeLiteralNode(F),1)}function D(L){let F=L.type;!F&&(L.initializer||Fh(L))&&(F=w(L));let J=U.createPropertySignature(void 0,LZ(L),R(L)?U.createToken(58):L.questionToken,F);return gp(J),T2(L.name,J.name),L.type&&J.type&&T2(L.type,J.type),J}function w(L){let F=i.getTypeAtLocation(L);return E6(F,L,t,n)}function R(L){if(Fh(L)){let F=i.getTypeAtLocation(L);return!i.isTupleType(F)}return i.isOptionalParameter(L)}}function LZ(e){return Qd(e.name)}function ekt(e){switch(e.parent.kind){case 263:let t=e.parent;return t.name?[t.name]:[M.checkDefined(YN(t,90),"Nameless class declaration should be a default export")];case 231:let i=e.parent,s=e.parent.parent,o=i.name;return o?[o,s.name]:[s.name]}}function tkt(e){switch(e.kind){case 262:return e.name?[e.name]:[M.checkDefined(YN(e,90),"Nameless function declaration should be a default export")];case 174:return[e.name];case 176:let n=M.checkDefined(Oo(e,137,e.getSourceFile()),"Constructor declaration should have constructor keyword");return e.parent.kind===231?[e.parent.parent.name,n]:[n];case 219:return[e.parent.name];case 218:return e.name?[e.name,e.parent.name]:[e.parent.name];default:return M.assertNever(e,`Unexpected function declaration kind ${e.kind}`)}}var rkt={},v1e="Convert to template string",S1e=Ms(v.Convert_to_template_string),b1e={name:v1e,description:S1e,kind:"refactor.rewrite.string"};By(v1e,{kinds:[b1e.kind],getEditsForAction:ikt,getAvailableActions:nkt});function nkt(e){let{file:t,startPosition:n}=e,i=vFe(t,n),s=T1e(i),o=La(s),u={name:v1e,description:S1e,actions:[]};return o&&e.triggerReason!=="invoked"?ve:tg(s)&&(o||Pn(s)&&E1e(s).isValidConcatenation)?(u.actions.push(b1e),[u]):e.preferences.provideRefactorNotApplicableReason?(u.actions.push({...b1e,notApplicableReason:Ms(v.Can_only_convert_string_concatenations_and_string_literals)}),[u]):ve}function vFe(e,t){let n=Yi(e,t),i=T1e(n);return!E1e(i).isValidConcatenation&&uf(i.parent)&&Pn(i.parent.parent)?i.parent.parent:n}function ikt(e,t){let{file:n,startPosition:i}=e,s=vFe(n,i);switch(t){case S1e:return{edits:skt(e,s)};default:return M.fail("invalid action")}}function skt(e,t){let n=T1e(t),i=e.file,s=ukt(E1e(n),i),o=L1(i.text,n.end);if(o){let u=o[o.length-1],m={pos:o[0].pos,end:u.end};return Sn.ChangeTracker.with(e,d=>{d.deleteRange(i,m),d.replaceNode(i,n,s)})}else return Sn.ChangeTracker.with(e,u=>u.replaceNode(i,n,s))}function akt(e){return!(e.operatorToken.kind===64||e.operatorToken.kind===65)}function T1e(e){return Pr(e.parent,n=>{switch(n.kind){case 211:case 212:return!1;case 228:case 226:return!(Pn(n.parent)&&akt(n.parent));default:return"quit"}})||e}function E1e(e){let t=u=>{if(!Pn(u))return{nodes:[u],operators:[],validOperators:!0,hasString:La(u)||wA(u)};let{nodes:m,operators:d,hasString:S,validOperators:E}=t(u.left);if(!(S||La(u.right)||Oj(u.right)))return{nodes:[u],operators:[],hasString:!1,validOperators:!0};let x=u.operatorToken.kind===40,D=E&&x;return m.push(u.right),d.push(u.operatorToken),{nodes:m,operators:d,hasString:!0,validOperators:D}},{nodes:n,operators:i,validOperators:s,hasString:o}=t(e);return{nodes:n,operators:i,isValidConcatenation:s&&o}}var okt=(e,t)=>(n,i)=>{n<e.length&&b6(e[n],i,t,3,!1)},ckt=(e,t,n)=>(i,s)=>{for(;i.length>0;){let o=i.shift();b6(e[o],s,t,3,!1),n(o,s)}};function lkt(e){return e.replace(/\\.|[$`]/g,t=>t[0]==="\\"?t:"\\"+t)}function SFe(e){let t=IA(e)||GG(e)?-2:-1;return Hc(e).slice(1,t)}function bFe(e,t){let n=[],i="",s="";for(;e<t.length;){let o=t[e];if(No(o))i+=o.text,s+=lkt(Hc(o).slice(1,-1)),n.push(e),e++;else if(Oj(o)){i+=o.head.text,s+=SFe(o.head);break}else break}return[e,i,s,n]}function ukt({nodes:e,operators:t},n){let i=okt(t,n),s=ckt(e,n,i),[o,u,m,d]=bFe(0,e);if(o===e.length){let x=U.createNoSubstitutionTemplateLiteral(u,m);return s(d,x),x}let S=[],E=U.createTemplateHead(u,m);s(d,E);for(let x=o;x<e.length;x++){let D=_kt(e[x]);i(x,D);let[w,R,L,F]=bFe(x+1,e);x=w-1;let J=x===e.length-1;if(Oj(D)){let G=Cr(D.templateSpans,(q,ee)=>{TFe(q);let W=ee===D.templateSpans.length-1,pe=q.literal.text+(W?R:""),K=SFe(q.literal)+(W?L:"");return U.createTemplateSpan(q.expression,J&&W?U.createTemplateTail(pe,K):U.createTemplateMiddle(pe,K))});S.push(...G)}else{let G=J?U.createTemplateTail(R,L):U.createTemplateMiddle(R,L);s(F,G),S.push(U.createTemplateSpan(D,G))}}return U.createTemplateExpression(E,S)}function TFe(e){let t=e.getSourceFile();b6(e,e.expression,t,3,!1),TM(e.expression,e.expression,t,3,!1)}function _kt(e){return uf(e)&&(TFe(e),e=e.expression),e}var fkt={},FZ="Convert to optional chain expression",x1e=Ms(v.Convert_to_optional_chain_expression),C1e={name:FZ,description:x1e,kind:"refactor.rewrite.expression.optionalChain"};By(FZ,{kinds:[C1e.kind],getEditsForAction:dkt,getAvailableActions:pkt});function pkt(e){let t=EFe(e,e.triggerReason==="invoked");return t?D0(t)?e.preferences.provideRefactorNotApplicableReason?[{name:FZ,description:x1e,actions:[{...C1e,notApplicableReason:t.error}]}]:ve:[{name:FZ,description:x1e,actions:[C1e]}]:ve}function dkt(e,t){let n=EFe(e);return M.assert(n&&!D0(n),"Expected applicable refactor info"),{edits:Sn.ChangeTracker.with(e,s=>Tkt(e.file,e.program.getTypeChecker(),s,n,t)),renameFilename:void 0,renameLocation:void 0}}function jZ(e){return Pn(e)||UA(e)}function mkt(e){return Du(e)||nm(e)||_l(e)}function BZ(e){return jZ(e)||mkt(e)}function EFe(e,t=!0){let{file:n,program:i}=e,s=ok(e),o=s.length===0;if(o&&!t)return;let u=Yi(n,s.start),m=wU(n,s.start+s.length),d=Il(u.pos,m&&m.end>=u.pos?m.getEnd():u.getEnd()),S=o?Skt(u):vkt(u,d),E=S&&BZ(S)?bkt(S):void 0;if(!E)return{error:Ms(v.Could_not_find_convertible_access_expression)};let x=i.getTypeChecker();return UA(E)?gkt(E,x):hkt(E)}function gkt(e,t){let n=e.condition,i=k1e(e.whenTrue);if(!i||t.isNullableType(t.getTypeAtLocation(i)))return{error:Ms(v.Could_not_find_convertible_access_expression)};if((Wn(n)||He(n))&&A1e(n,i.expression))return{finalExpression:i,occurrences:[n],expression:e};if(Pn(n)){let s=xFe(i.expression,n);return s?{finalExpression:i,occurrences:s,expression:e}:{error:Ms(v.Could_not_find_matching_access_expressions)}}}function hkt(e){if(e.operatorToken.kind!==56)return{error:Ms(v.Can_only_convert_logical_AND_access_chains)};let t=k1e(e.right);if(!t)return{error:Ms(v.Could_not_find_convertible_access_expression)};let n=xFe(t.expression,e.left);return n?{finalExpression:t,occurrences:n,expression:e}:{error:Ms(v.Could_not_find_matching_access_expressions)}}function xFe(e,t){let n=[];for(;Pn(t)&&t.operatorToken.kind===56;){let s=A1e(So(e),So(t.right));if(!s)break;n.push(s),e=s,t=t.left}let i=A1e(e,t);return i&&n.push(i),n.length>0?n:void 0}function A1e(e,t){if(!(!He(t)&&!Wn(t)&&!cc(t)))return ykt(e,t)?t:void 0}function ykt(e,t){for(;(ea(e)||Wn(e)||cc(e))&&OM(e)!==OM(t);)e=e.expression;for(;Wn(e)&&Wn(t)||cc(e)&&cc(t);){if(OM(e)!==OM(t))return!1;e=e.expression,t=t.expression}return He(e)&&He(t)&&e.getText()===t.getText()}function OM(e){if(He(e)||zp(e))return e.getText();if(Wn(e))return OM(e.name);if(cc(e))return OM(e.argumentExpression)}function vkt(e,t){for(;e.parent;){if(BZ(e)&&t.length!==0&&e.end>=t.start+t.length)return e;e=e.parent}}function Skt(e){for(;e.parent;){if(BZ(e)&&!BZ(e.parent))return e;e=e.parent}}function bkt(e){if(jZ(e))return e;if(_l(e)){let t=cA(e),n=t?.initializer;return n&&jZ(n)?n:void 0}return e.expression&&jZ(e.expression)?e.expression:void 0}function k1e(e){if(e=So(e),Pn(e))return k1e(e.left);if((Wn(e)||cc(e)||ea(e))&&!S_(e))return e}function CFe(e,t,n){if(Wn(t)||cc(t)||ea(t)){let i=CFe(e,t.expression,n),s=n.length>0?n[n.length-1]:void 0,o=s?.getText()===t.expression.getText();if(o&&n.pop(),ea(t))return o?U.createCallChain(i,U.createToken(29),t.typeArguments,t.arguments):U.createCallChain(i,t.questionDotToken,t.typeArguments,t.arguments);if(Wn(t))return o?U.createPropertyAccessChain(i,U.createToken(29),t.name):U.createPropertyAccessChain(i,t.questionDotToken,t.name);if(cc(t))return o?U.createElementAccessChain(i,U.createToken(29),t.argumentExpression):U.createElementAccessChain(i,t.questionDotToken,t.argumentExpression)}return t}function Tkt(e,t,n,i,s){let{finalExpression:o,occurrences:u,expression:m}=i,d=u[u.length-1],S=CFe(t,o,u);S&&(Wn(S)||cc(S)||ea(S))&&(Pn(m)?n.replaceNodeRange(e,d,o,S):UA(m)&&n.replaceNode(e,m,U.createBinaryExpression(S,U.createToken(61),m.whenFalse)))}var AFe={};A(AFe,{Messages:()=>Ku,RangeFacts:()=>NFe,getRangeToExtract:()=>P1e,getRefactorActionsToExtractSymbol:()=>kFe,getRefactorEditsToExtractSymbol:()=>PFe});var k6="Extract Symbol",P6={name:"Extract Constant",description:Ms(v.Extract_constant),kind:"refactor.extract.constant"},N6={name:"Extract Function",description:Ms(v.Extract_function),kind:"refactor.extract.function"};By(k6,{kinds:[P6.kind,N6.kind],getEditsForAction:PFe,getAvailableActions:kFe});function kFe(e){let t=e.kind,n=P1e(e.file,ok(e),e.triggerReason==="invoked"),i=n.targetRange;if(i===void 0){if(!n.errors||n.errors.length===0||!e.preferences.provideRefactorNotApplicableReason)return ve;let L=[];return Lb(N6.kind,t)&&L.push({name:k6,description:N6.description,actions:[{...N6,notApplicableReason:R(n.errors)}]}),Lb(P6.kind,t)&&L.push({name:k6,description:P6.description,actions:[{...P6,notApplicableReason:R(n.errors)}]}),L}let{affectedTextRange:s,extractions:o}=Pkt(i,e);if(o===void 0)return ve;let u=[],m=new Map,d,S=[],E=new Map,x,D=0;for(let{functionExtraction:L,constantExtraction:F}of o){if(Lb(N6.kind,t)){let J=L.description;L.errors.length===0?m.has(J)||(m.set(J,!0),u.push({description:J,name:`function_scope_${D}`,kind:N6.kind,range:{start:{line:ba(e.file,s.pos).line,offset:ba(e.file,s.pos).character},end:{line:ba(e.file,s.end).line,offset:ba(e.file,s.end).character}}})):d||(d={description:J,name:`function_scope_${D}`,notApplicableReason:R(L.errors),kind:N6.kind})}if(Lb(P6.kind,t)){let J=F.description;F.errors.length===0?E.has(J)||(E.set(J,!0),S.push({description:J,name:`constant_scope_${D}`,kind:P6.kind,range:{start:{line:ba(e.file,s.pos).line,offset:ba(e.file,s.pos).character},end:{line:ba(e.file,s.end).line,offset:ba(e.file,s.end).character}}})):x||(x={description:J,name:`constant_scope_${D}`,notApplicableReason:R(F.errors),kind:P6.kind})}D++}let w=[];return u.length?w.push({name:k6,description:Ms(v.Extract_function),actions:u}):e.preferences.provideRefactorNotApplicableReason&&d&&w.push({name:k6,description:Ms(v.Extract_function),actions:[d]}),S.length?w.push({name:k6,description:Ms(v.Extract_constant),actions:S}):e.preferences.provideRefactorNotApplicableReason&&x&&w.push({name:k6,description:Ms(v.Extract_constant),actions:[x]}),w.length?w:ve;function R(L){let F=L[0].messageText;return typeof F!="string"&&(F=F.messageText),F}}function PFe(e,t){let i=P1e(e.file,ok(e)).targetRange,s=/^function_scope_(\d+)$/.exec(t);if(s){let u=+s[1];return M.assert(isFinite(u),"Expected to parse a finite number from the function scope index"),Akt(i,e,u)}let o=/^constant_scope_(\d+)$/.exec(t);if(o){let u=+o[1];return M.assert(isFinite(u),"Expected to parse a finite number from the constant scope index"),kkt(i,e,u)}M.fail("Unrecognized action name")}var Ku;(e=>{function t(n){return{message:n,code:0,category:3,key:n}}e.cannotExtractRange=t("Cannot extract range."),e.cannotExtractImport=t("Cannot extract import statement."),e.cannotExtractSuper=t("Cannot extract super call."),e.cannotExtractJSDoc=t("Cannot extract JSDoc."),e.cannotExtractEmpty=t("Cannot extract empty range."),e.expressionExpected=t("expression expected."),e.uselessConstantType=t("No reason to extract constant of type."),e.statementOrExpressionExpected=t("Statement or expression expected."),e.cannotExtractRangeContainingConditionalBreakOrContinueStatements=t("Cannot extract range containing conditional break or continue statements."),e.cannotExtractRangeContainingConditionalReturnStatement=t("Cannot extract range containing conditional return statement."),e.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange=t("Cannot extract range containing labeled break or continue with target outside of the range."),e.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators=t("Cannot extract range containing writes to references located outside of the target range in generators."),e.typeWillNotBeVisibleInTheNewScope=t("Type will not visible in the new scope."),e.functionWillNotBeVisibleInTheNewScope=t("Function will not visible in the new scope."),e.cannotExtractIdentifier=t("Select more than a single identifier."),e.cannotExtractExportedEntity=t("Cannot extract exported declaration"),e.cannotWriteInExpression=t("Cannot write back side-effects when extracting an expression"),e.cannotExtractReadonlyPropertyInitializerOutsideConstructor=t("Cannot move initialization of read-only class property outside of the constructor"),e.cannotExtractAmbientBlock=t("Cannot extract code from ambient contexts"),e.cannotAccessVariablesFromNestedScopes=t("Cannot access variables from nested scopes"),e.cannotExtractToJSClass=t("Cannot extract constant to a class scope in JS"),e.cannotExtractToExpressionArrowFunction=t("Cannot extract constant to an arrow function without a block"),e.cannotExtractFunctionsContainingThisToMethod=t("Cannot extract functions containing this to method")})(Ku||(Ku={}));var NFe=(e=>(e[e.None=0]="None",e[e.HasReturn=1]="HasReturn",e[e.IsGenerator=2]="IsGenerator",e[e.IsAsyncFunction=4]="IsAsyncFunction",e[e.UsesThis=8]="UsesThis",e[e.UsesThisInFunction=16]="UsesThisInFunction",e[e.InStaticRegion=32]="InStaticRegion",e))(NFe||{});function P1e(e,t,n=!0){let{length:i}=t;if(i===0&&!n)return{errors:[bu(e,t.start,i,Ku.cannotExtractEmpty)]};let s=i===0&&n,o=S0e(e,t.start),u=wU(e,bl(t)),m=o&&u&&n?Ekt(o,u,e):t,d=s?Gkt(o):yM(o,e,m),S=s?d:yM(u,e,m),E=0,x;if(!d||!S)return{errors:[bu(e,t.start,i,Ku.cannotExtractRange)]};if(d.flags&16777216)return{errors:[bu(e,t.start,i,Ku.cannotExtractJSDoc)]};if(d.parent!==S.parent)return{errors:[bu(e,t.start,i,Ku.cannotExtractRange)]};if(d!==S){if(!tD(d.parent))return{errors:[bu(e,t.start,i,Ku.cannotExtractRange)]};let G=[];for(let q of d.parent.statements){if(q===d||G.length){let ee=J(q);if(ee)return{errors:ee};G.push(q)}if(q===S)break}return G.length?{targetRange:{range:G,facts:E,thisNode:x}}:{errors:[bu(e,t.start,i,Ku.cannotExtractRange)]}}if(nm(d)&&!d.expression)return{errors:[bu(e,t.start,i,Ku.cannotExtractRange)]};let D=R(d),w=L(D)||J(D);if(w)return{errors:w};return{targetRange:{range:xkt(D),facts:E,thisNode:x}};function R(G){if(nm(G)){if(G.expression)return G.expression}else if(_l(G)||Ru(G)){let q=_l(G)?G.declarationList.declarations:G.declarations,ee=0,W;for(let pe of q)pe.initializer&&(ee++,W=pe.initializer);if(ee===1)return W}else if(Ei(G)&&G.initializer)return G.initializer;return G}function L(G){if(He(Du(G)?G.expression:G))return[pn(G,Ku.cannotExtractIdentifier)]}function F(G,q){let ee=G;for(;ee!==q;){if(ee.kind===172){oa(ee)&&(E|=32);break}else if(ee.kind===169){Dp(ee).kind===176&&(E|=32);break}else ee.kind===174&&oa(ee)&&(E|=32);ee=ee.parent}}function J(G){let q;if((ue=>{ue[ue.None=0]="None",ue[ue.Break=1]="Break",ue[ue.Continue=2]="Continue",ue[ue.Return=4]="Return"})(q||(q={})),M.assert(G.pos<=G.end,"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809 (1)"),M.assert(!ng(G.pos),"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809 (2)"),!Vi(G)&&!(tg(G)&&DFe(G))&&!O1e(G))return[pn(G,Ku.statementOrExpressionExpected)];if(G.flags&33554432)return[pn(G,Ku.cannotExtractAmbientBlock)];let ee=Ou(G);ee&&F(G,ee);let W,pe=4,K;if(re(G),E&8){let ue=nf(G,!1,!1);(ue.kind===262||ue.kind===174&&ue.parent.kind===210||ue.kind===218)&&(E|=16)}return W;function re(ue){if(W)return!0;if(u_(ue)){let ne=ue.kind===260?ue.parent.parent:ue;if(li(ne,32))return(W||(W=[])).push(pn(ue,Ku.cannotExtractExportedEntity)),!0}switch(ue.kind){case 272:return(W||(W=[])).push(pn(ue,Ku.cannotExtractImport)),!0;case 277:return(W||(W=[])).push(pn(ue,Ku.cannotExtractExportedEntity)),!0;case 108:if(ue.parent.kind===213){let ne=Ou(ue);if(ne===void 0||ne.pos<t.start||ne.end>=t.start+t.length)return(W||(W=[])).push(pn(ue,Ku.cannotExtractSuper)),!0}else E|=8,x=ue;break;case 219:Js(ue,function ne(le){if($N(le))E|=8,x=ue;else{if(gi(le)||Bs(le)&&!pc(le))return!1;Js(le,ne)}});case 263:case 262:Ji(ue.parent)&&ue.parent.externalModuleIndicator===void 0&&(W||(W=[])).push(pn(ue,Ku.functionWillNotBeVisibleInTheNewScope));case 231:case 218:case 174:case 176:case 177:case 178:return!1}let ce=pe;switch(ue.kind){case 245:pe&=-5;break;case 258:pe=0;break;case 241:ue.parent&&ue.parent.kind===258&&ue.parent.finallyBlock===ue&&(pe=4);break;case 297:case 296:pe|=1;break;default:V1(ue,!1)&&(pe|=3);break}switch(ue.kind){case 197:case 110:E|=8,x=ue;break;case 256:{let ne=ue.label;(K||(K=[])).push(ne.escapedText),Js(ue,re),K.pop();break}case 252:case 251:{let ne=ue.label;ne?Es(K,ne.escapedText)||(W||(W=[])).push(pn(ue,Ku.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange)):pe&(ue.kind===252?1:2)||(W||(W=[])).push(pn(ue,Ku.cannotExtractRangeContainingConditionalBreakOrContinueStatements));break}case 223:E|=4;break;case 229:E|=2;break;case 253:pe&4?E|=1:(W||(W=[])).push(pn(ue,Ku.cannotExtractRangeContainingConditionalReturnStatement));break;default:Js(ue,re);break}pe=ce}}}function Ekt(e,t,n){let i=e.getStart(n),s=t.getEnd();return n.text.charCodeAt(s)===59&&s++,{start:i,length:s-i}}function xkt(e){if(Vi(e))return[e];if(tg(e))return Du(e.parent)?[e.parent]:e;if(O1e(e))return e}function N1e(e){return pc(e)?W$(e.body):Go(e)||Ji(e)||Hg(e)||gi(e)}function Ckt(e){let t=qv(e.range)?Ma(e.range):e.range;if(e.facts&8&&!(e.facts&16)){let i=Ou(t);if(i){let s=Pr(t,Go);return s?[s,i]:[i]}}let n=[];for(;;)if(t=t.parent,t.kind===169&&(t=Pr(t,i=>Go(i)).parent),N1e(t)&&(n.push(t),t.kind===307))return n}function Akt(e,t,n){let{scopes:i,readsAndWrites:{target:s,usagesPerScope:o,functionErrorsPerScope:u,exposedVariableDeclarations:m}}=D1e(e,t);return M.assert(!u[n].length,"The extraction went missing? How?"),t.cancellationToken.throwIfCancellationRequested(),Rkt(s,i[n],o[n],m,e,t)}function kkt(e,t,n){let{scopes:i,readsAndWrites:{target:s,usagesPerScope:o,constantErrorsPerScope:u,exposedVariableDeclarations:m}}=D1e(e,t);M.assert(!u[n].length,"The extraction went missing? How?"),M.assert(m.length===0,"Extract constant accepted a range containing a variable declaration?"),t.cancellationToken.throwIfCancellationRequested();let d=Ct(s)?s:s.statements[0].expression;return Mkt(d,i[n],o[n],e.facts,t)}function Pkt(e,t){let{scopes:n,affectedTextRange:i,readsAndWrites:{functionErrorsPerScope:s,constantErrorsPerScope:o}}=D1e(e,t),u=n.map((m,d)=>{let S=Nkt(m),E=Dkt(m),x=Go(m)?wkt(m):gi(m)?Ikt(m):Okt(m),D,w;return x===1?(D=wy(Ms(v.Extract_to_0_in_1_scope),[S,"global"]),w=wy(Ms(v.Extract_to_0_in_1_scope),[E,"global"])):x===0?(D=wy(Ms(v.Extract_to_0_in_1_scope),[S,"module"]),w=wy(Ms(v.Extract_to_0_in_1_scope),[E,"module"])):(D=wy(Ms(v.Extract_to_0_in_1),[S,x]),w=wy(Ms(v.Extract_to_0_in_1),[E,x])),d===0&&!gi(m)&&(w=wy(Ms(v.Extract_to_0_in_enclosing_scope),[E])),{functionExtraction:{description:D,errors:s[d]},constantExtraction:{description:w,errors:o[d]}}});return{affectedTextRange:i,extractions:u}}function D1e(e,t){let{file:n}=t,i=Ckt(e),s=$kt(e,n),o=Hkt(e,i,s,n,t.program.getTypeChecker(),t.cancellationToken);return{scopes:i,affectedTextRange:s,readsAndWrites:o}}function Nkt(e){return Go(e)?"inner function":gi(e)?"method":"function"}function Dkt(e){return gi(e)?"readonly field":"constant"}function wkt(e){switch(e.kind){case 176:return"constructor";case 218:case 262:return e.name?`function '${e.name.text}'`:GQ;case 219:return"arrow function";case 174:return`method '${e.name.getText()}'`;case 177:return`'get ${e.name.getText()}'`;case 178:return`'set ${e.name.getText()}'`;default:M.assertNever(e,`Unexpected scope kind ${e.kind}`)}}function Ikt(e){return e.kind===263?e.name?`class '${e.name.text}'`:"anonymous class declaration":e.name?`class expression '${e.name.text}'`:"anonymous class expression"}function Okt(e){return e.kind===268?`namespace '${e.parent.name.getText()}'`:e.externalModuleIndicator?0:1}function Rkt(e,t,{usages:n,typeParameterUsages:i,substitutions:s},o,u,m){let d=m.program.getTypeChecker(),S=Ka(m.program.getCompilerOptions()),E=A_.createImportAdder(m.file,m.program,m.preferences,m.host),x=t.getSourceFile(),D=E2(gi(t)?"newMethod":"newFunction",x),w=hn(t),R=U.createIdentifier(D),L,F=[],J=[],G;n.forEach((ke,De)=>{let Be;if(!w){let qe=d.getTypeOfSymbolAtLocation(ke.symbol,ke.node);qe=d.getBaseTypeOfLiteralType(qe),Be=A_.typeToAutoImportableTypeNode(d,E,qe,t,S,1)}let ct=U.createParameterDeclaration(void 0,void 0,De,void 0,Be);F.push(ct),ke.usage===2&&(G||(G=[])).push(ke),J.push(U.createIdentifier(De))});let ee=Is(i.values(),ke=>({type:ke,declaration:Fkt(ke,m.startPosition)})).sort(jkt),W=ee.length===0?void 0:Gi(ee,({declaration:ke})=>ke),pe=W!==void 0?W.map(ke=>U.createTypeReferenceNode(ke.name,void 0)):void 0;if(Ct(e)&&!w){let ke=d.getContextualType(e);L=d.typeToTypeNode(ke,t,1)}let{body:K,returnValueProperty:re}=Ukt(e,o,G,s,!!(u.facts&1));gp(K);let ue,ce=!!(u.facts&16);if(gi(t)){let ke=w?[]:[U.createModifier(123)];u.facts&32&&ke.push(U.createModifier(126)),u.facts&4&&ke.push(U.createModifier(134)),ue=U.createMethodDeclaration(ke.length?ke:void 0,u.facts&2?U.createToken(42):void 0,R,void 0,W,F,L,K)}else ce&&F.unshift(U.createParameterDeclaration(void 0,void 0,"this",void 0,d.typeToTypeNode(d.getTypeAtLocation(u.thisNode),t,1),void 0)),ue=U.createFunctionDeclaration(u.facts&4?[U.createToken(134)]:void 0,u.facts&2?U.createToken(42):void 0,R,W,F,L,K);let ne=Sn.ChangeTracker.fromContext(m),le=(qv(u.range)?Va(u.range):u.range).end,me=qkt(le,t);me?ne.insertNodeBefore(m.file,me,ue,!0):ne.insertNodeAtEndOfScope(m.file,t,ue),E.writeFixes(ne);let de=[],Ae=Bkt(t,u,D);ce&&J.unshift(U.createIdentifier("this"));let xe=U.createCallExpression(ce?U.createPropertyAccessExpression(Ae,"call"):Ae,pe,J);if(u.facts&2&&(xe=U.createYieldExpression(U.createToken(42),xe)),u.facts&4&&(xe=U.createAwaitExpression(xe)),I1e(e)&&(xe=U.createJsxExpression(void 0,xe)),o.length&&!G)if(M.assert(!re,"Expected no returnValueProperty"),M.assert(!(u.facts&1),"Expected RangeFacts.HasReturn flag to be unset"),o.length===1){let ke=o[0];de.push(U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(Co(ke.name),void 0,Co(ke.type),xe)],ke.parent.flags)))}else{let ke=[],De=[],Be=o[0].parent.flags,ct=!1;for(let et of o){ke.push(U.createBindingElement(void 0,void 0,Co(et.name)));let Ie=d.typeToTypeNode(d.getBaseTypeOfLiteralType(d.getTypeAtLocation(et)),t,1);De.push(U.createPropertySignature(void 0,et.symbol.name,void 0,Ie)),ct=ct||et.type!==void 0,Be=Be&et.parent.flags}let qe=ct?U.createTypeLiteralNode(De):void 0;qe&&Tn(qe,1),de.push(U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(U.createObjectBindingPattern(ke),void 0,qe,xe)],Be)))}else if(o.length||G){if(o.length)for(let De of o){let Be=De.parent.flags;Be&2&&(Be=Be&-3|1),de.push(U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(De.symbol.name,void 0,Pe(De.type))],Be)))}re&&de.push(U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(re,void 0,Pe(L))],1)));let ke=w1e(o,G);re&&ke.unshift(U.createShorthandPropertyAssignment(re)),ke.length===1?(M.assert(!re,"Shouldn't have returnValueProperty here"),de.push(U.createExpressionStatement(U.createAssignment(ke[0].name,xe))),u.facts&1&&de.push(U.createReturnStatement())):(de.push(U.createExpressionStatement(U.createAssignment(U.createObjectLiteralExpression(ke),xe))),re&&de.push(U.createReturnStatement(U.createIdentifier(re))))}else u.facts&1?de.push(U.createReturnStatement(xe)):qv(u.range)?de.push(U.createExpressionStatement(xe)):de.push(xe);qv(u.range)?ne.replaceNodeRangeWithNodes(m.file,Ma(u.range),Va(u.range),de):ne.replaceNodeWithNodes(m.file,u.range,de);let te=ne.getChanges(),be=(qv(u.range)?Ma(u.range):u.range).getSourceFile().fileName,Ve=bM(te,be,D,!1);return{renameFilename:be,renameLocation:Ve,edits:te};function Pe(ke){if(ke===void 0)return;let De=Co(ke),Be=De;for(;a2(Be);)Be=Be.type;return Z1(Be)&&Ln(Be.types,ct=>ct.kind===157)?De:U.createUnionTypeNode([De,U.createKeywordTypeNode(157)])}}function Mkt(e,t,{substitutions:n},i,s){let o=s.program.getTypeChecker(),u=t.getSourceFile(),m=c1e(e,t,o,u),d=hn(t),S=d||!o.isContextSensitive(e)?void 0:o.typeToTypeNode(o.getContextualType(e),t,1),E=Vkt(So(e),n);({variableType:S,initializer:E}=L(S,E)),gp(E);let x=Sn.ChangeTracker.fromContext(s);if(gi(t)){M.assert(!d,"Cannot extract to a JS class");let F=[];F.push(U.createModifier(123)),i&32&&F.push(U.createModifier(126)),F.push(U.createModifier(148));let J=U.createPropertyDeclaration(F,m,void 0,S,E),G=U.createPropertyAccessExpression(i&32?U.createIdentifier(t.name.getText()):U.createThis(),U.createIdentifier(m));I1e(e)&&(G=U.createJsxExpression(void 0,G));let q=e.pos,ee=zkt(q,t);x.insertNodeBefore(s.file,ee,J,!0),x.replaceNode(s.file,e,G)}else{let F=U.createVariableDeclaration(m,void 0,S,E),J=Lkt(e,t);if(J){x.insertNodeBefore(s.file,J,F);let G=U.createIdentifier(m);x.replaceNode(s.file,e,G)}else if(e.parent.kind===244&&t===Pr(e,N1e)){let G=U.createVariableStatement(void 0,U.createVariableDeclarationList([F],2));x.replaceNode(s.file,e.parent,G)}else{let G=U.createVariableStatement(void 0,U.createVariableDeclarationList([F],2)),q=Wkt(e,t);if(q.pos===0?x.insertNodeAtTopOfFile(s.file,G,!1):x.insertNodeBefore(s.file,q,G,!1),e.parent.kind===244)x.delete(s.file,e.parent);else{let ee=U.createIdentifier(m);I1e(e)&&(ee=U.createJsxExpression(void 0,ee)),x.replaceNode(s.file,e,ee)}}}let D=x.getChanges(),w=e.getSourceFile().fileName,R=bM(D,w,m,!0);return{renameFilename:w,renameLocation:R,edits:D};function L(F,J){if(F===void 0)return{variableType:F,initializer:J};if(!ic(J)&&!pc(J)||J.typeParameters)return{variableType:F,initializer:J};let G=o.getTypeAtLocation(e),q=Dh(o.getSignaturesOfType(G,0));if(!q)return{variableType:F,initializer:J};if(q.getTypeParameters())return{variableType:F,initializer:J};let ee=[],W=!1;for(let pe of J.parameters)if(pe.type)ee.push(pe);else{let K=o.getTypeAtLocation(pe);K===o.getAnyType()&&(W=!0),ee.push(U.updateParameterDeclaration(pe,pe.modifiers,pe.dotDotDotToken,pe.name,pe.questionToken,pe.type||o.typeToTypeNode(K,t,1),pe.initializer))}if(W)return{variableType:F,initializer:J};if(F=void 0,pc(J))J=U.updateArrowFunction(J,wm(e)?qT(e):void 0,J.typeParameters,ee,J.type||o.typeToTypeNode(q.getReturnType(),t,1),J.equalsGreaterThanToken,J.body);else{if(q&&q.thisParameter){let pe=xo(ee);if(!pe||He(pe.name)&&pe.name.escapedText!=="this"){let K=o.getTypeOfSymbolAtLocation(q.thisParameter,e);ee.splice(0,0,U.createParameterDeclaration(void 0,void 0,"this",void 0,o.typeToTypeNode(K,t,1)))}}J=U.updateFunctionExpression(J,wm(e)?qT(e):void 0,J.asteriskToken,J.name,J.typeParameters,ee,J.type||o.typeToTypeNode(q.getReturnType(),t,1),J.body)}return{variableType:F,initializer:J}}}function Lkt(e,t){let n;for(;e!==void 0&&e!==t;){if(Ei(e)&&e.initializer===n&&Ru(e.parent)&&e.parent.declarations.length>1)return e;n=e,e=e.parent}}function Fkt(e,t){let n,i=e.symbol;if(i&&i.declarations)for(let s of i.declarations)(n===void 0||s.pos<n.pos)&&s.pos<t&&(n=s);return n}function jkt({type:e,declaration:t},{type:n,declaration:i}){return Yce(t,i,"pos",tc)||c_(e.symbol?e.symbol.getName():"",n.symbol?n.symbol.getName():"")||tc(e.id,n.id)}function Bkt(e,t,n){let i=U.createIdentifier(n);if(gi(e)){let s=t.facts&32?U.createIdentifier(e.name.text):U.createThis();return U.createPropertyAccessExpression(s,i)}else return i}function Ukt(e,t,n,i,s){let o=n!==void 0||t.length>0;if(Vs(e)&&!o&&i.size===0)return{body:U.createBlock(e.statements,!0),returnValueProperty:void 0};let u,m=!1,d=U.createNodeArray(Vs(e)?e.statements.slice(0):[Vi(e)?e:U.createReturnStatement(So(e))]);if(o||i.size){let E=Kr(d,S,Vi).slice();if(o&&!s&&Vi(e)){let x=w1e(t,n);x.length===1?E.push(U.createReturnStatement(x[0].name)):E.push(U.createReturnStatement(U.createObjectLiteralExpression(x)))}return{body:U.createBlock(E,!0),returnValueProperty:u}}else return{body:U.createBlock(d,!0),returnValueProperty:void 0};function S(E){if(!m&&nm(E)&&o){let x=w1e(t,n);return E.expression&&(u||(u="__return"),x.unshift(U.createPropertyAssignment(u,ot(E.expression,S,Ct)))),x.length===1?U.createReturnStatement(x[0].name):U.createReturnStatement(U.createObjectLiteralExpression(x))}else{let x=m;m=m||Go(E)||gi(E);let D=i.get(yo(E).toString()),w=D?Co(D):Mr(E,S,void 0);return m=x,w}}}function Vkt(e,t){return t.size?n(e):e;function n(i){let s=t.get(yo(i).toString());return s?Co(s):Mr(i,n,void 0)}}function Jkt(e){if(Go(e)){let t=e.body;if(Vs(t))return t.statements}else{if(Hg(e)||Ji(e))return e.statements;if(gi(e))return e.members;}return ve}function qkt(e,t){return Ln(Jkt(t),n=>n.pos>=e&&Go(n)&&!Vc(n))}function zkt(e,t){let n=t.members;M.assert(n.length>0,"Found no members");let i,s=!0;for(let o of n){if(o.pos>e)return i||n[0];if(s&&!Ns(o)){if(i!==void 0)return o;s=!1}i=o}return i===void 0?M.fail():i}function Wkt(e,t){M.assert(!gi(t));let n;for(let i=e;i!==t;i=i.parent)N1e(i)&&(n=i);for(let i=(n||e).parent;;i=i.parent){if(tD(i)){let s;for(let o of i.statements){if(o.pos>e.pos)break;s=o}return!s&&SN(i)?(M.assert(NO(i.parent.parent),"Grandparent isn't a switch statement"),i.parent.parent):M.checkDefined(s,"prevStatement failed to get set")}M.assert(i!==t,"Didn't encounter a block-like before encountering scope")}}function w1e(e,t){let n=Cr(e,s=>U.createShorthandPropertyAssignment(s.symbol.name)),i=Cr(t,s=>U.createShorthandPropertyAssignment(s.symbol.name));return n===void 0?i:i===void 0?n:n.concat(i)}function qv(e){return Rs(e)}function $kt(e,t){return qv(e.range)?{pos:Ma(e.range).getStart(t),end:Va(e.range).getEnd()}:e.range}function Hkt(e,t,n,i,s,o){let u=new Map,m=[],d=[],S=[],E=[],x=[],D=new Map,w=[],R,L=qv(e.range)?e.range.length===1&&Du(e.range[0])?e.range[0].expression:void 0:e.range,F;if(L===void 0){let me=e.range,de=Ma(me).getStart(),Ae=Va(me).end;F=bu(i,de,Ae-de,Ku.expressionExpected)}else s.getTypeAtLocation(L).flags&147456&&(F=pn(L,Ku.uselessConstantType));for(let me of t){m.push({usages:new Map,typeParameterUsages:new Map,substitutions:new Map}),d.push(new Map),S.push([]);let de=[];F&&de.push(F),gi(me)&&hn(me)&&de.push(pn(me,Ku.cannotExtractToJSClass)),pc(me)&&!Vs(me.body)&&de.push(pn(me,Ku.cannotExtractToExpressionArrowFunction)),E.push(de)}let J=new Map,G=qv(e.range)?U.createBlock(e.range):e.range,q=qv(e.range)?Ma(e.range):e.range,ee=W(q);if(K(G),ee&&!qv(e.range)&&!Kg(e.range)){let me=s.getContextualType(e.range);pe(me)}if(u.size>0){let me=new Map,de=0;for(let Ae=q;Ae!==void 0&&de<t.length;Ae=Ae.parent)if(Ae===t[de]&&(me.forEach((xe,te)=>{m[de].typeParameterUsages.set(te,xe)}),de++),_H(Ae))for(let xe of j1(Ae)){let te=s.getTypeAtLocation(xe);u.has(te.id.toString())&&me.set(te.id.toString(),te)}M.assert(de===t.length,"Should have iterated all scopes")}if(x.length){let me=uH(t[0],t[0].parent)?t[0]:eg(t[0]);Js(me,ce)}for(let me=0;me<t.length;me++){let de=m[me];if(me>0&&(de.usages.size>0||de.typeParameterUsages.size>0)){let te=qv(e.range)?e.range[0]:e.range;E[me].push(pn(te,Ku.cannotAccessVariablesFromNestedScopes))}e.facts&16&&gi(t[me])&&S[me].push(pn(e.thisNode,Ku.cannotExtractFunctionsContainingThisToMethod));let Ae=!1,xe;if(m[me].usages.forEach(te=>{te.usage===2&&(Ae=!0,te.symbol.flags&106500&&te.symbol.valueDeclaration&&up(te.symbol.valueDeclaration,8)&&(xe=te.symbol.valueDeclaration))}),M.assert(qv(e.range)||w.length===0,"No variable declarations expected if something was extracted"),Ae&&!qv(e.range)){let te=pn(e.range,Ku.cannotWriteInExpression);S[me].push(te),E[me].push(te)}else if(xe&&me>0){let te=pn(xe,Ku.cannotExtractReadonlyPropertyInitializerOutsideConstructor);S[me].push(te),E[me].push(te)}else if(R){let te=pn(R,Ku.cannotExtractExportedEntity);S[me].push(te),E[me].push(te)}}return{target:G,usagesPerScope:m,functionErrorsPerScope:S,constantErrorsPerScope:E,exposedVariableDeclarations:w};function W(me){return!!Pr(me,de=>_H(de)&&j1(de).length!==0)}function pe(me){let de=s.getSymbolWalker(()=>(o.throwIfCancellationRequested(),!0)),{visitedTypes:Ae}=de.walkType(me);for(let xe of Ae)xe.isTypeParameter()&&u.set(xe.id.toString(),xe)}function K(me,de=1){if(ee){let Ae=s.getTypeAtLocation(me);pe(Ae)}if(u_(me)&&me.symbol&&x.push(me),Su(me))K(me.left,2),K(me.right);else if(s_e(me))K(me.operand,2);else if(Wn(me)||cc(me))Js(me,K);else if(He(me)){if(!me.parent||cf(me.parent)&&me!==me.parent.left||Wn(me.parent)&&me!==me.parent.expression)return;re(me,de,Lg(me))}else Js(me,K)}function re(me,de,Ae){let xe=ue(me,de,Ae);if(xe)for(let te=0;te<t.length;te++){let he=d[te].get(xe);he&&m[te].substitutions.set(yo(me).toString(),he)}}function ue(me,de,Ae){let xe=ne(me);if(!xe)return;let te=Aa(xe).toString(),he=J.get(te);if(he&&he>=de)return te;if(J.set(te,de),he){for(let Pe of m)Pe.usages.get(me.text)&&Pe.usages.set(me.text,{usage:de,symbol:xe,node:me});return te}let be=xe.getDeclarations(),Ve=be&&Ln(be,Pe=>Pe.getSourceFile()===i);if(Ve&&!uM(n,Ve.getStart(),Ve.end)){if(e.facts&2&&de===2){let Pe=pn(me,Ku.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators);for(let ke of S)ke.push(Pe);for(let ke of E)ke.push(Pe)}for(let Pe=0;Pe<t.length;Pe++){let ke=t[Pe];if(s.resolveName(xe.name,ke,xe.flags,!1)!==xe&&!d[Pe].has(te)){let Be=le(xe.exportSymbol||xe,ke,Ae);if(Be)d[Pe].set(te,Be);else if(Ae){if(!(xe.flags&262144)){let ct=pn(me,Ku.typeWillNotBeVisibleInTheNewScope);S[Pe].push(ct),E[Pe].push(ct)}}else m[Pe].usages.set(me.text,{usage:de,symbol:xe,node:me})}}return te}}function ce(me){if(me===e.range||qv(e.range)&&e.range.includes(me))return;let de=He(me)?ne(me):s.getSymbolAtLocation(me);if(de){let Ae=Ln(x,xe=>xe.symbol===de);if(Ae)if(Ei(Ae)){let xe=Ae.symbol.id.toString();D.has(xe)||(w.push(Ae),D.set(xe,!0))}else R=R||Ae}Js(me,ce)}function ne(me){return me.parent&&p_(me.parent)&&me.parent.name===me?s.getShorthandAssignmentValueSymbol(me.parent):s.getSymbolAtLocation(me)}function le(me,de,Ae){if(!me)return;let xe=me.getDeclarations();if(xe&&xe.some(he=>he.parent===de))return U.createIdentifier(me.name);let te=le(me.parent,de,Ae);if(te!==void 0)return Ae?U.createQualifiedName(te,U.createIdentifier(me.name)):U.createPropertyAccessExpression(te,me.name)}}function Gkt(e){return Pr(e,t=>t.parent&&DFe(t)&&!Pn(t.parent))}function DFe(e){let{parent:t}=e;switch(t.kind){case 306:return!1}switch(e.kind){case 11:return t.kind!==272&&t.kind!==276;case 230:case 206:case 208:return!1;case 80:return t.kind!==208&&t.kind!==276&&t.kind!==281}return!0}function I1e(e){return O1e(e)||(Ly(e)||u2(e)||vE(e))&&(Ly(e.parent)||vE(e.parent))}function O1e(e){return La(e)&&e.parent&&Kg(e.parent)}var Ykt={},UZ="Generate 'get' and 'set' accessors",R1e=Ms(v.Generate_get_and_set_accessors),M1e={name:UZ,description:R1e,kind:"refactor.rewrite.property.generateAccessors"};By(UZ,{kinds:[M1e.kind],getEditsForAction:function(t,n){if(!t.endPosition)return;let i=A_.getAccessorConvertiblePropertyAtPosition(t.file,t.program,t.startPosition,t.endPosition);M.assert(i&&!D0(i),"Expected applicable refactor info");let s=A_.generateAccessorFromProperty(t.file,t.program,t.startPosition,t.endPosition,t,n);if(!s)return;let o=t.file.fileName,u=i.renameAccessor?i.accessorName:i.fieldName,d=(He(u)?0:-1)+bM(s,o,u.text,ns(i.declaration));return{renameFilename:o,renameLocation:d,edits:s}},getAvailableActions(e){if(!e.endPosition)return ve;let t=A_.getAccessorConvertiblePropertyAtPosition(e.file,e.program,e.startPosition,e.endPosition,e.triggerReason==="invoked");return t?D0(t)?e.preferences.provideRefactorNotApplicableReason?[{name:UZ,description:R1e,actions:[{...M1e,notApplicableReason:t.error}]}]:ve:[{name:UZ,description:R1e,actions:[M1e]}]:ve}});var Kkt={},VZ="Infer function return type",L1e=Ms(v.Infer_function_return_type),JZ={name:VZ,description:L1e,kind:"refactor.rewrite.function.returnType"};By(VZ,{kinds:[JZ.kind],getEditsForAction:Xkt,getAvailableActions:Qkt});function Xkt(e){let t=wFe(e);if(t&&!D0(t))return{renameFilename:void 0,renameLocation:void 0,edits:Sn.ChangeTracker.with(e,i=>Zkt(e.file,i,t.declaration,t.returnTypeNode))}}function Qkt(e){let t=wFe(e);return t?D0(t)?e.preferences.provideRefactorNotApplicableReason?[{name:VZ,description:L1e,actions:[{...JZ,notApplicableReason:t.error}]}]:ve:[{name:VZ,description:L1e,actions:[JZ]}]:ve}function Zkt(e,t,n,i){let s=Oo(n,22,e),o=pc(n)&&s===void 0,u=o?Ma(n.parameters):s;u&&(o&&(t.insertNodeBefore(e,u,U.createToken(21)),t.insertNodeAfter(e,u,U.createToken(22))),t.insertNodeAt(e,u.end,i,{prefix:": "}))}function wFe(e){if(hn(e.file)||!Lb(JZ.kind,e.kind))return;let t=wf(e.file,e.startPosition),n=Pr(t,u=>Vs(u)||u.parent&&pc(u.parent)&&(u.kind===39||u.parent.body===u)?"quit":ePt(u));if(!n||!n.body||n.type)return{error:Ms(v.Return_type_must_be_inferred_from_a_function)};let i=e.program.getTypeChecker(),s=tPt(i,n);if(!s)return{error:Ms(v.Could_not_determine_function_return_type)};let o=i.typeToTypeNode(s,n,1);if(o)return{declaration:n,returnTypeNode:o}}function ePt(e){switch(e.kind){case 262:case 218:case 219:case 174:return!0;default:return!1}}function tPt(e,t){if(e.isImplementationOfOverload(t)){let i=e.getTypeAtLocation(t).getCallSignatures();if(i.length>1)return e.getUnionType(Gi(i,s=>s.getReturnType()))}let n=e.getSignatureFromDeclaration(t);if(n)return e.getReturnTypeOfSignature(n)}var IFe=(e=>(e[e.typeOffset=8]="typeOffset",e[e.modifierMask=255]="modifierMask",e))(IFe||{}),OFe=(e=>(e[e.class=0]="class",e[e.enum=1]="enum",e[e.interface=2]="interface",e[e.namespace=3]="namespace",e[e.typeParameter=4]="typeParameter",e[e.type=5]="type",e[e.parameter=6]="parameter",e[e.variable=7]="variable",e[e.enumMember=8]="enumMember",e[e.property=9]="property",e[e.function=10]="function",e[e.member=11]="member",e))(OFe||{}),RFe=(e=>(e[e.declaration=0]="declaration",e[e.static=1]="static",e[e.async=2]="async",e[e.readonly=3]="readonly",e[e.defaultLibrary=4]="defaultLibrary",e[e.local=5]="local",e))(RFe||{});function MFe(e,t,n,i){let s=F1e(e,t,n,i);M.assert(s.spans.length%3===0);let o=s.spans,u=[];for(let m=0;m<o.length;m+=3)u.push({textSpan:zu(o[m],o[m+1]),classificationType:o[m+2]});return u}function F1e(e,t,n,i){return{spans:rPt(e,n,i,t),endOfLineState:0}}function rPt(e,t,n,i){let s=[];return e&&t&&nPt(e,t,n,(u,m,d)=>{s.push(u.getStart(t),u.getWidth(t),(m+1<<8)+d)},i),s}function nPt(e,t,n,i,s){let o=e.getTypeChecker(),u=!1;function m(d){switch(d.kind){case 267:case 263:case 264:case 262:case 231:case 218:case 219:s.throwIfCancellationRequested()}if(!d||!S5(n,d.pos,d.getFullWidth())||d.getFullWidth()===0)return;let S=u;if((Ly(d)||u2(d))&&(u=!0),wO(d)&&(u=!1),He(d)&&!u&&!oPt(d)&&!dO(d.escapedText)){let E=o.getSymbolAtLocation(d);if(E){E.flags&2097152&&(E=o.getAliasedSymbol(E));let x=iPt(E,S2(d));if(x!==void 0){let D=0;d.parent&&(Xa(d.parent)||jFe.get(d.parent.kind)===x)&&d.parent.name===d&&(D=1),x===6&&FFe(d)&&(x=9),x=sPt(o,d,x);let w=E.valueDeclaration;if(w){let R=eb(w),L=f0(w);R&256&&(D|=2),R&1024&&(D|=4),x!==0&&x!==2&&(R&8||L&2||E.getFlags()&8)&&(D|=8),(x===7||x===10)&&aPt(w,t)&&(D|=32),e.isSourceFileDefaultLibrary(w.getSourceFile())&&(D|=16)}else E.declarations&&E.declarations.some(R=>e.isSourceFileDefaultLibrary(R.getSourceFile()))&&(D|=16);i(d,x,D)}}}Js(d,m),u=S}m(t)}function iPt(e,t){let n=e.getFlags();if(n&32)return 0;if(n&384)return 1;if(n&524288)return 5;if(n&64){if(t&2)return 2}else if(n&262144)return 4;let i=e.valueDeclaration||e.declarations&&e.declarations[0];return i&&Xa(i)&&(i=LFe(i)),i&&jFe.get(i.kind)}function sPt(e,t,n){if(n===7||n===9||n===6){let i=e.getTypeAtLocation(t);if(i){let s=o=>o(i)||i.isUnion()&&i.types.some(o);if(n!==6&&s(o=>o.getConstructSignatures().length>0))return 0;if(s(o=>o.getCallSignatures().length>0)&&!s(o=>o.getProperties().length>0)||cPt(t))return n===9?11:10}}return n}function aPt(e,t){return Xa(e)&&(e=LFe(e)),Ei(e)?(!Ji(e.parent.parent.parent)||bE(e.parent))&&e.getSourceFile()===t:Tl(e)?!Ji(e.parent)&&e.getSourceFile()===t:!1}function LFe(e){for(;;)if(Xa(e.parent.parent))e=e.parent.parent;else return e.parent.parent}function oPt(e){let t=e.parent;return t&&(ig(t)||_f(t)||My(t))}function cPt(e){for(;FFe(e);)e=e.parent;return ea(e.parent)&&e.parent.expression===e}function FFe(e){return cf(e.parent)&&e.parent.right===e||Wn(e.parent)&&e.parent.name===e}var jFe=new Map([[260,7],[169,6],[172,9],[267,3],[266,1],[306,8],[263,0],[174,11],[262,10],[218,10],[173,11],[177,9],[178,9],[171,9],[264,2],[265,5],[168,4],[303,9],[304,9]]),BFe="0.8";function UFe(e,t,n,i){let s=L3(e)?new j1e(e,t,n):e===80?new JFe(80,t,n):e===81?new qFe(81,t,n):new VFe(e,t,n);return s.parent=i,s.flags=i.flags&101441536,s}var j1e=class{constructor(e,t,n){this.pos=t,this.end=n,this.kind=e,this.id=0,this.flags=0,this.modifierFlagsCache=0,this.transformFlags=0,this.parent=void 0,this.original=void 0,this.emitNode=void 0}assertHasRealPosition(e){M.assert(!ng(this.pos)&&!ng(this.end),e||"Node must have a real position for this operation")}getSourceFile(){return Ur(this)}getStart(e,t){return this.assertHasRealPosition(),ob(this,e,t)}getFullStart(){return this.assertHasRealPosition(),this.pos}getEnd(){return this.assertHasRealPosition(),this.end}getWidth(e){return this.assertHasRealPosition(),this.getEnd()-this.getStart(e)}getFullWidth(){return this.assertHasRealPosition(),this.end-this.pos}getLeadingTriviaWidth(e){return this.assertHasRealPosition(),this.getStart(e)-this.pos}getFullText(e){return this.assertHasRealPosition(),(e||this.getSourceFile()).text.substring(this.pos,this.end)}getText(e){return this.assertHasRealPosition(),e||(e=this.getSourceFile()),e.text.substring(this.getStart(e),this.getEnd())}getChildCount(e){return this.getChildren(e).length}getChildAt(e,t){return this.getChildren(t)[e]}getChildren(e=Ur(this)){return this.assertHasRealPosition("Node without a real position cannot be scanned and thus has no token nodes - use forEachChild and collect the result if that's fine"),pY(this,e)??nme(this,e,lPt(this,e))}getFirstToken(e){this.assertHasRealPosition();let t=this.getChildren(e);if(!t.length)return;let n=Ln(t,i=>i.kind<309||i.kind>351);return n.kind<166?n:n.getFirstToken(e)}getLastToken(e){this.assertHasRealPosition();let t=this.getChildren(e),n=vc(t);if(n)return n.kind<166?n:n.getLastToken(e)}forEachChild(e,t){return Js(this,e,t)}};function lPt(e,t){let n=[];if(L5(e))return e.forEachChild(u=>{n.push(u)}),n;q_.setText((t||e.getSourceFile()).text);let i=e.pos,s=u=>{xV(n,i,u.pos,e),n.push(u),i=u.end},o=u=>{xV(n,i,u.pos,e),n.push(uPt(u,e)),i=u.end};return kt(e.jsDoc,s),i=e.pos,e.forEachChild(s,o),xV(n,i,e.end,e),q_.setText(void 0),n}function xV(e,t,n,i){for(q_.resetTokenState(t);t<n;){let s=q_.scan(),o=q_.getTokenEnd();if(o<=n){if(s===80){if(Mpe(i))continue;M.fail(`Did not expect ${M.formatSyntaxKind(i.kind)} to have an Identifier in its trivia`)}e.push(UFe(s,t,o,i))}if(t=o,s===1)break}}function uPt(e,t){let n=UFe(352,e.pos,e.end,t),i=[],s=e.pos;for(let o of e)xV(i,s,o.pos,t),i.push(o),s=o.end;return xV(i,s,e.end,t),n._children=i,n}var B1e=class{constructor(e,t,n){this.pos=t,this.end=n,this.kind=e,this.id=0,this.flags=0,this.transformFlags=0,this.parent=void 0,this.emitNode=void 0}getSourceFile(){return Ur(this)}getStart(e,t){return ob(this,e,t)}getFullStart(){return this.pos}getEnd(){return this.end}getWidth(e){return this.getEnd()-this.getStart(e)}getFullWidth(){return this.end-this.pos}getLeadingTriviaWidth(e){return this.getStart(e)-this.pos}getFullText(e){return(e||this.getSourceFile()).text.substring(this.pos,this.end)}getText(e){return e||(e=this.getSourceFile()),e.text.substring(this.getStart(e),this.getEnd())}getChildCount(){return this.getChildren().length}getChildAt(e){return this.getChildren()[e]}getChildren(){return this.kind===1&&this.jsDoc||ve}getFirstToken(){}getLastToken(){}forEachChild(){}},_Pt=class{constructor(e,t){this.flags=e,this.escapedName=t,this.declarations=void 0,this.valueDeclaration=void 0,this.id=0,this.mergeId=0,this.parent=void 0,this.members=void 0,this.exports=void 0,this.exportSymbol=void 0,this.constEnumOnlyModule=void 0,this.isReferenced=void 0,this.lastAssignmentPos=void 0,this.links=void 0}getFlags(){return this.flags}get name(){return Qc(this)}getEscapedName(){return this.escapedName}getName(){return this.name}getDeclarations(){return this.declarations}getDocumentationComment(e){if(!this.documentationComment)if(this.documentationComment=ve,!this.declarations&&jh(this)&&this.links.target&&jh(this.links.target)&&this.links.target.links.tupleLabelDeclaration){let t=this.links.target.links.tupleLabelDeclaration;this.documentationComment=CV([t],e)}else this.documentationComment=CV(this.declarations,e);return this.documentationComment}getContextualDocumentationComment(e,t){if(e){if(Sv(e)&&(this.contextualGetAccessorDocumentationComment||(this.contextualGetAccessorDocumentationComment=CV(Zn(this.declarations,Sv),t)),wt(this.contextualGetAccessorDocumentationComment)))return this.contextualGetAccessorDocumentationComment;if(Og(e)&&(this.contextualSetAccessorDocumentationComment||(this.contextualSetAccessorDocumentationComment=CV(Zn(this.declarations,Og),t)),wt(this.contextualSetAccessorDocumentationComment)))return this.contextualSetAccessorDocumentationComment}return this.getDocumentationComment(t)}getJsDocTags(e){return this.tags===void 0&&(this.tags=ve,this.tags=qZ(this.declarations,e)),this.tags}getContextualJsDocTags(e,t){if(e){if(Sv(e)&&(this.contextualGetAccessorTags||(this.contextualGetAccessorTags=qZ(Zn(this.declarations,Sv),t)),wt(this.contextualGetAccessorTags)))return this.contextualGetAccessorTags;if(Og(e)&&(this.contextualSetAccessorTags||(this.contextualSetAccessorTags=qZ(Zn(this.declarations,Og),t)),wt(this.contextualSetAccessorTags)))return this.contextualSetAccessorTags}return this.getJsDocTags(t)}},VFe=class extends B1e{constructor(e,t,n){super(e,t,n)}},JFe=class extends B1e{constructor(e,t,n){super(e,t,n)}get text(){return Nn(this)}},qFe=class extends B1e{constructor(e,t,n){super(e,t,n)}get text(){return Nn(this)}},fPt=class{constructor(e,t){this.flags=t,this.checker=e}getFlags(){return this.flags}getSymbol(){return this.symbol}getProperties(){return this.checker.getPropertiesOfType(this)}getProperty(e){return this.checker.getPropertyOfType(this,e)}getApparentProperties(){return this.checker.getAugmentedPropertiesOfType(this)}getCallSignatures(){return this.checker.getSignaturesOfType(this,0)}getConstructSignatures(){return this.checker.getSignaturesOfType(this,1)}getStringIndexType(){return this.checker.getIndexTypeOfType(this,0)}getNumberIndexType(){return this.checker.getIndexTypeOfType(this,1)}getBaseTypes(){return this.isClassOrInterface()?this.checker.getBaseTypes(this):void 0}isNullableType(){return this.checker.isNullableType(this)}getNonNullableType(){return this.checker.getNonNullableType(this)}getNonOptionalType(){return this.checker.getNonOptionalType(this)}getConstraint(){return this.checker.getBaseConstraintOfType(this)}getDefault(){return this.checker.getDefaultFromTypeParameter(this)}isUnion(){return!!(this.flags&1048576)}isIntersection(){return!!(this.flags&2097152)}isUnionOrIntersection(){return!!(this.flags&3145728)}isLiteral(){return!!(this.flags&2432)}isStringLiteral(){return!!(this.flags&128)}isNumberLiteral(){return!!(this.flags&256)}isTypeParameter(){return!!(this.flags&262144)}isClassOrInterface(){return!!(Kn(this)&3)}isClass(){return!!(Kn(this)&1)}isIndexType(){return!!(this.flags&4194304)}get typeArguments(){if(Kn(this)&4)return this.checker.getTypeArguments(this)}},pPt=class{constructor(e,t){this.flags=t,this.checker=e}getDeclaration(){return this.declaration}getTypeParameters(){return this.typeParameters}getParameters(){return this.parameters}getReturnType(){return this.checker.getReturnTypeOfSignature(this)}getTypeParameterAtPosition(e){let t=this.checker.getParameterType(this,e);if(t.isIndexType()&&mO(t.type)){let n=t.type.getConstraint();if(n)return this.checker.getIndexType(n)}return t}getDocumentationComment(){return this.documentationComment||(this.documentationComment=CV(qC(this.declaration),this.checker))}getJsDocTags(){return this.jsDocTags||(this.jsDocTags=qZ(qC(this.declaration),this.checker))}};function zFe(e){return nb(e).some(t=>t.tagName.text==="inheritDoc"||t.tagName.text==="inheritdoc")}function qZ(e,t){if(!e)return ve;let n=Bb.getJsDocTagsFromDeclarations(e,t);if(t&&(n.length===0||e.some(zFe))){let i=new Set;for(let s of e){let o=WFe(t,s,u=>{var m;if(!i.has(u))return i.add(u),s.kind===177||s.kind===178?u.getContextualJsDocTags(s,t):((m=u.declarations)==null?void 0:m.length)===1?u.getJsDocTags(t):void 0});o&&(n=[...o,...n])}}return n}function CV(e,t){if(!e)return ve;let n=Bb.getJsDocCommentsFromDeclarations(e,t);if(t&&(n.length===0||e.some(zFe))){let i=new Set;for(let s of e){let o=WFe(t,s,u=>{if(!i.has(u))return i.add(u),s.kind===177||s.kind===178?u.getContextualDocumentationComment(s,t):u.getDocumentationComment(t)});o&&(n=n.length===0?o.slice():o.concat(XN(),n))}}return n}function WFe(e,t,n){var i;let s=((i=t.parent)==null?void 0:i.kind)===176?t.parent.parent:t.parent;if(!s)return;let o=Jl(t);return yi(BI(s),u=>{let m=e.getTypeAtLocation(u),d=o&&m.symbol?e.getTypeOfSymbol(m.symbol):m,S=e.getPropertyOfType(d,t.symbol.name);return S?n(S):void 0})}var dPt=class extends j1e{constructor(e,t,n){super(e,t,n)}update(e,t){return PY(this,e,t)}getLineAndCharacterOfPosition(e){return ba(this,e)}getLineStarts(){return Sy(this)}getPositionOfLineAndCharacter(e,t,n){return h5(Sy(this),e,t,this.text,n)}getLineEndOfPosition(e){let{line:t}=this.getLineAndCharacterOfPosition(e),n=this.getLineStarts(),i;t+1>=n.length&&(i=this.getEnd()),i||(i=n[t+1]-1);let s=this.getFullText();return s[i]===`
`&&s[i-1]==="\r"?i-1:i}getNamedDeclarations(){return this.namedDeclarations||(this.namedDeclarations=this.computeNamedDeclarations()),this.namedDeclarations}computeNamedDeclarations(){let e=yd();return this.forEachChild(s),e;function t(o){let u=i(o);u&&e.add(u,o)}function n(o){let u=e.get(o);return u||e.set(o,u=[]),u}function i(o){let u=T5(o);return u&&(za(u)&&Wn(u.expression)?u.expression.name.text:Ol(u)?gM(u):void 0)}function s(o){switch(o.kind){case 262:case 218:case 174:case 173:let u=o,m=i(u);if(m){let E=n(m),x=vc(E);x&&u.parent===x.parent&&u.symbol===x.symbol?u.body&&!x.body&&(E[E.length-1]=u):E.push(u)}Js(o,s);break;case 263:case 231:case 264:case 265:case 266:case 267:case 271:case 281:case 276:case 273:case 274:case 177:case 178:case 187:t(o),Js(o,s);break;case 169:if(!li(o,31))break;case 260:case 208:{let E=o;if(Hs(E.name)){Js(E.name,s);break}E.initializer&&s(E.initializer)}case 306:case 172:case 171:t(o);break;case 278:let d=o;d.exportClause&&(kd(d.exportClause)?kt(d.exportClause.elements,s):s(d.exportClause.name));break;case 272:let S=o.importClause;S&&(S.name&&t(S.name),S.namedBindings&&(S.namedBindings.kind===274?t(S.namedBindings):kt(S.namedBindings.elements,s)));break;case 226:cl(o)!==0&&t(o);default:Js(o,s)}}}},mPt=class{constructor(e,t,n){this.fileName=e,this.text=t,this.skipTrivia=n||(i=>i)}getLineAndCharacterOfPosition(e){return ba(this,e)}};function gPt(){return{getNodeConstructor:()=>j1e,getTokenConstructor:()=>VFe,getIdentifierConstructor:()=>JFe,getPrivateIdentifierConstructor:()=>qFe,getSourceFileConstructor:()=>dPt,getSymbolConstructor:()=>_Pt,getTypeConstructor:()=>fPt,getSignatureConstructor:()=>pPt,getSourceMapSourceConstructor:()=>mPt}}function RM(e){let t=!0;for(let i in e)if(Ho(e,i)&&!$Fe(i)){t=!1;break}if(t)return e;let n={};for(let i in e)if(Ho(e,i)){let s=$Fe(i)?i:i.charAt(0).toLowerCase()+i.substr(1);n[s]=e[i]}return n}function $Fe(e){return!e.length||e.charAt(0)===e.charAt(0).toLowerCase()}function MM(e){return e?Cr(e,t=>t.text).join(""):""}function AV(){return{target:1,jsx:1}}function zZ(){return A_.getSupportedErrorCodes()}var hPt=class{constructor(e){this.host=e}getCurrentSourceFile(e){var t,n,i,s,o,u,m,d;let S=this.host.getScriptSnapshot(e);if(!S)throw new Error("Could not find file: '"+e+"'.");let E=JQ(e,this.host),x=this.host.getScriptVersion(e),D;if(this.currentFileName!==e){let w={languageVersion:99,impliedNodeFormat:K8(rc(e,this.host.getCurrentDirectory(),((i=(n=(t=this.host).getCompilerHost)==null?void 0:n.call(t))==null?void 0:i.getCanonicalFileName)||Pv(this.host)),(d=(m=(u=(o=(s=this.host).getCompilerHost)==null?void 0:o.call(s))==null?void 0:u.getModuleResolutionCache)==null?void 0:m.call(u))==null?void 0:d.getPackageJsonInfoCache(),this.host,this.host.getCompilationSettings()),setExternalModuleIndicator:WR(this.host.getCompilationSettings()),jsDocParsingMode:0};D=kV(e,S,w,x,!0,E)}else if(this.currentFileVersion!==x){let w=S.getChangeRange(this.currentFileScriptSnapshot);D=WZ(this.currentSourceFile,S,x,w)}return D&&(this.currentFileVersion=x,this.currentFileName=e,this.currentFileScriptSnapshot=S,this.currentSourceFile=D),this.currentSourceFile}};function HFe(e,t,n){e.version=n,e.scriptSnapshot=t}function kV(e,t,n,i,s,o){let u=HA(e,sk(t),n,s,o);return HFe(u,t,i),u}function WZ(e,t,n,i,s){if(i&&n!==e.version){let u,m=i.span.start!==0?e.text.substr(0,i.span.start):"",d=bl(i.span)!==e.text.length?e.text.substr(bl(i.span)):"";if(i.newLength===0)u=m&&d?m+d:m||d;else{let E=t.getText(i.span.start,i.span.start+i.newLength);u=m&&d?m+E+d:m?m+E:E+d}let S=PY(e,u,i,s);return HFe(S,t,n),S.nameTable=void 0,e!==S&&e.scriptSnapshot&&(e.scriptSnapshot.dispose&&e.scriptSnapshot.dispose(),e.scriptSnapshot=void 0),S}let o={languageVersion:e.languageVersion,impliedNodeFormat:e.impliedNodeFormat,setExternalModuleIndicator:e.setExternalModuleIndicator,jsDocParsingMode:e.jsDocParsingMode};return kV(e.fileName,t,o,n,!0,e.scriptKind)}var yPt={isCancellationRequested:Dg,throwIfCancellationRequested:io},vPt=class{constructor(e){this.cancellationToken=e}isCancellationRequested(){return this.cancellationToken.isCancellationRequested()}throwIfCancellationRequested(){var e;if(this.isCancellationRequested())throw(e=Cn)==null||e.instant(Cn.Phase.Session,"cancellationThrown",{kind:"CancellationTokenObject"}),new tI}},U1e=class{constructor(e,t=20){this.hostCancellationToken=e,this.throttleWaitMilliseconds=t,this.lastCancellationCheckTime=0}isCancellationRequested(){let e=Tc();return Math.abs(e-this.lastCancellationCheckTime)>=this.throttleWaitMilliseconds?(this.lastCancellationCheckTime=e,this.hostCancellationToken.isCancellationRequested()):!1}throwIfCancellationRequested(){var e;if(this.isCancellationRequested())throw(e=Cn)==null||e.instant(Cn.Phase.Session,"cancellationThrown",{kind:"ThrottledCancellationToken"}),new tI}},GFe=["getSemanticDiagnostics","getSuggestionDiagnostics","getCompilerOptionsDiagnostics","getSemanticClassifications","getEncodedSemanticClassifications","getCodeFixesAtPosition","getCombinedCodeFix","applyCodeActionCommand","organizeImports","getEditsForFileRename","getEmitOutput","getApplicableRefactors","getEditsForRefactor","prepareCallHierarchy","provideCallHierarchyIncomingCalls","provideCallHierarchyOutgoingCalls","provideInlayHints","getSupportedCodeFixes","getPasteEdits"],SPt=[...GFe,"getCompletionsAtPosition","getCompletionEntryDetails","getCompletionEntrySymbol","getSignatureHelpItems","getQuickInfoAtPosition","getDefinitionAtPosition","getDefinitionAndBoundSpan","getImplementationAtPosition","getTypeDefinitionAtPosition","getReferencesAtPosition","findReferences","getDocumentHighlights","getNavigateToItems","getRenameInfo","findRenameLocations","getApplicableRefactors"];function V1e(e,t=uve(e.useCaseSensitiveFileNames&&e.useCaseSensitiveFileNames(),e.getCurrentDirectory(),e.jsDocParsingMode),n){var i;let s;n===void 0?s=0:typeof n=="boolean"?s=n?2:0:s=n;let o=new hPt(e),u,m,d=0,S=e.getCancellationToken?new vPt(e.getCancellationToken()):yPt,E=e.getCurrentDirectory();ape((i=e.getLocalizedDiagnosticMessages)==null?void 0:i.bind(e));function x(z){e.log&&e.log(z)}let D=sN(e),w=l_(D),R=xve({useCaseSensitiveFileNames:()=>D,getCurrentDirectory:()=>E,getProgram:G,fileExists:ia(e,e.fileExists),readFile:ia(e,e.readFile),getDocumentPositionMapper:ia(e,e.getDocumentPositionMapper),getSourceFileLike:ia(e,e.getSourceFileLike),log:x});function L(z){let Ue=u.getSourceFile(z);if(!Ue){let Te=new Error(`Could not find source file: '${z}'.`);throw Te.ProgramFiles=u.getSourceFiles().map(Re=>Re.fileName),Te}return Ue}function F(){e.updateFromProject&&!e.updateFromProjectInProgress?e.updateFromProject():J()}function J(){var z,Ue,Te;if(M.assert(s!==2),e.getProjectVersion){let ms=e.getProjectVersion();if(ms){if(m===ms&&!((z=e.hasChangedAutomaticTypeDirectiveNames)!=null&&z.call(e)))return;m=ms}}let Re=e.getTypeRootsVersion?e.getTypeRootsVersion():0;d!==Re&&(x("TypeRoots version has changed; provide new program"),u=void 0,d=Re);let It=e.getScriptFileNames().slice(),$t=e.getCompilationSettings()||AV(),Ht=e.hasInvalidatedResolutions||Dg,dr=ia(e,e.hasInvalidatedLibResolutions)||Dg,qr=ia(e,e.hasChangedAutomaticTypeDirectiveNames),Hr=(Ue=e.getProjectReferences)==null?void 0:Ue.call(e),dn,Ar={getSourceFile:Mo,getSourceFileByPath:Do,getCancellationToken:()=>S,getCanonicalFileName:w,useCaseSensitiveFileNames:()=>D,getNewLine:()=>wv($t),getDefaultLibFileName:ms=>e.getDefaultLibFileName(ms),writeFile:io,getCurrentDirectory:()=>E,fileExists:ms=>e.fileExists(ms),readFile:ms=>e.readFile&&e.readFile(ms),getSymlinkCache:ia(e,e.getSymlinkCache),realpath:ia(e,e.realpath),directoryExists:ms=>rg(ms,e),getDirectories:ms=>e.getDirectories?e.getDirectories(ms):[],readDirectory:(ms,sa,Sc,ts,zi)=>(M.checkDefined(e.readDirectory,"'LanguageServiceHost.readDirectory' must be implemented to correctly process 'projectReferences'"),e.readDirectory(ms,sa,Sc,ts,zi)),onReleaseOldSourceFile:uo,onReleaseParsedCommandLine:qs,hasInvalidatedResolutions:Ht,hasInvalidatedLibResolutions:dr,hasChangedAutomaticTypeDirectiveNames:qr,trace:ia(e,e.trace),resolveModuleNames:ia(e,e.resolveModuleNames),getModuleResolutionCache:ia(e,e.getModuleResolutionCache),createHash:ia(e,e.createHash),resolveTypeReferenceDirectives:ia(e,e.resolveTypeReferenceDirectives),resolveModuleNameLiterals:ia(e,e.resolveModuleNameLiterals),resolveTypeReferenceDirectiveReferences:ia(e,e.resolveTypeReferenceDirectiveReferences),resolveLibrary:ia(e,e.resolveLibrary),useSourceOfProjectReferenceRedirect:ia(e,e.useSourceOfProjectReferenceRedirect),getParsedCommandLine:tn,jsDocParsingMode:e.jsDocParsingMode},In=Ar.getSourceFile,{getSourceFileWithCache:Ki}=a6(Ar,ms=>rc(ms,E,w),(...ms)=>In.call(Ar,...ms));Ar.getSourceFile=Ki,(Te=e.setCompilerHost)==null||Te.call(e,Ar);let ls={useCaseSensitiveFileNames:D,fileExists:ms=>Ar.fileExists(ms),readFile:ms=>Ar.readFile(ms),directoryExists:ms=>Ar.directoryExists(ms),getDirectories:ms=>Ar.getDirectories(ms),realpath:Ar.realpath,readDirectory:(...ms)=>Ar.readDirectory(...ms),trace:Ar.trace,getCurrentDirectory:Ar.getCurrentDirectory,onUnRecoverableConfigFileDiagnostic:io},Yn=t.getKeyForCompilationSettings($t),pi=new Set;if(oX(u,It,$t,(ms,sa)=>e.getScriptVersion(sa),ms=>Ar.fileExists(ms),Ht,dr,qr,tn,Hr)){Ar=void 0,dn=void 0,pi=void 0;return}u=X8({rootNames:It,options:$t,host:Ar,oldProgram:u,projectReferences:Hr}),Ar=void 0,dn=void 0,pi=void 0,R.clearCache(),u.getTypeChecker();return;function tn(ms){let sa=rc(ms,E,w),Sc=dn?.get(sa);if(Sc!==void 0)return Sc||void 0;let ts=e.getParsedCommandLine?e.getParsedCommandLine(ms):er(ms);return(dn||(dn=new Map)).set(sa,ts||!1),ts}function er(ms){let sa=Mo(ms,100);if(sa)return sa.path=rc(ms,E,w),sa.resolvedPath=sa.path,sa.originalFileName=sa.fileName,D8(sa,ls,xs(mi(ms),E),void 0,xs(ms,E))}function qs(ms,sa,Sc){var ts;e.getParsedCommandLine?(ts=e.onReleaseParsedCommandLine)==null||ts.call(e,ms,sa,Sc):sa&&uo(sa.sourceFile,Sc)}function uo(ms,sa){let Sc=t.getKeyForCompilationSettings(sa);t.releaseDocumentWithKey(ms.resolvedPath,Sc,ms.scriptKind,ms.impliedNodeFormat)}function Mo(ms,sa,Sc,ts){return Do(ms,rc(ms,E,w),sa,Sc,ts)}function Do(ms,sa,Sc,ts,zi){M.assert(Ar,"getOrCreateSourceFileByPath called after typical CompilerHost lifetime, check the callstack something with a reference to an old host.");let Eu=e.getScriptSnapshot(ms);if(!Eu)return;let kc=JQ(ms,e),P_=e.getScriptVersion(ms);if(!zi){let el=u&&u.getSourceFileByPath(sa);if(el){if(kc===el.scriptKind||pi.has(el.resolvedPath))return t.updateDocumentWithKey(ms,sa,e,Yn,Eu,P_,kc,Sc);t.releaseDocumentWithKey(el.resolvedPath,t.getKeyForCompilationSettings(u.getCompilerOptions()),el.scriptKind,el.impliedNodeFormat),pi.add(el.resolvedPath)}}return t.acquireDocumentWithKey(ms,sa,e,Yn,Eu,P_,kc,Sc)}}function G(){if(s===2){M.assert(u===void 0);return}return F(),u}function q(){var z;return(z=e.getPackageJsonAutoImportProvider)==null?void 0:z.call(e)}function ee(z,Ue){let Te=u.getTypeChecker(),Re=It();if(!Re)return!1;for(let Ht of z)for(let dr of Ht.references){let qr=$t(dr);if(M.assertIsDefined(qr),Ue.has(dr)||lc.isDeclarationOfSymbol(qr,Re)){Ue.add(dr),dr.isDefinition=!0;let Hr=qU(dr,R,ia(e,e.fileExists));Hr&&Ue.add(Hr)}else dr.isDefinition=!1}return!0;function It(){for(let Ht of z)for(let dr of Ht.references){if(Ue.has(dr)){let Hr=$t(dr);return M.assertIsDefined(Hr),Te.getSymbolAtLocation(Hr)}let qr=qU(dr,R,ia(e,e.fileExists));if(qr&&Ue.has(qr)){let Hr=$t(qr);if(Hr)return Te.getSymbolAtLocation(Hr)}}}function $t(Ht){let dr=u.getSourceFile(Ht.fileName);if(!dr)return;let qr=wf(dr,Ht.textSpan.start);return lc.Core.getAdjustedNode(qr,{use:lc.FindReferencesUse.References})}}function W(){if(u){let z=t.getKeyForCompilationSettings(u.getCompilerOptions());kt(u.getSourceFiles(),Ue=>t.releaseDocumentWithKey(Ue.resolvedPath,z,Ue.scriptKind,Ue.impliedNodeFormat)),u=void 0}}function pe(){W(),e=void 0}function K(z){return F(),u.getSyntacticDiagnostics(L(z),S).slice()}function re(z){F();let Ue=L(z),Te=u.getSemanticDiagnostics(Ue,S);if(!$p(u.getCompilerOptions()))return Te.slice();let Re=u.getDeclarationDiagnostics(Ue,S);return[...Te,...Re]}function ue(z){return F(),hZ(L(z),u,S)}function ce(){return F(),[...u.getOptionsDiagnostics(S),...u.getGlobalDiagnostics(S)]}function ne(z,Ue,Te=am,Re){let It={...Te,includeCompletionsForModuleExports:Te.includeCompletionsForModuleExports||Te.includeExternalModuleExports,includeCompletionsWithInsertText:Te.includeCompletionsWithInsertText||Te.includeInsertTextCompletions};return F(),gk.getCompletionsAtPosition(e,u,x,L(z),Ue,It,Te.triggerCharacter,Te.triggerKind,S,Re&&zl.getFormatContext(Re,e),Te.includeSymbol)}function le(z,Ue,Te,Re,It,$t=am,Ht){return F(),gk.getCompletionEntryDetails(u,x,L(z),Ue,{name:Te,source:It,data:Ht},e,Re&&zl.getFormatContext(Re,e),$t,S)}function me(z,Ue,Te,Re,It=am){return F(),gk.getCompletionEntrySymbol(u,x,L(z),Ue,{name:Te,source:Re},e,It)}function de(z,Ue){F();let Te=L(z),Re=wf(Te,Ue);if(Re===Te)return;let It=u.getTypeChecker(),$t=xe(Re),Ht=xPt($t,It);if(!Ht||It.isUnknownSymbol(Ht)){let Ar=te(Te,$t,Ue)?It.getTypeAtLocation($t):void 0;return Ar&&{kind:"",kindModifiers:"",textSpan:df($t,Te),displayParts:It.runWithCancellationToken(S,In=>vM(In,Ar,b2($t))),documentation:Ar.symbol?Ar.symbol.getDocumentationComment(It):void 0,tags:Ar.symbol?Ar.symbol.getJsDocTags(It):void 0}}let{symbolKind:dr,displayParts:qr,documentation:Hr,tags:dn}=It.runWithCancellationToken(S,Ar=>zv.getSymbolDisplayPartsDocumentationAndSymbolKind(Ar,Ht,Te,b2($t),$t));return{kind:dr,kindModifiers:zv.getSymbolModifiers(It,Ht),textSpan:df($t,Te),displayParts:qr,documentation:Hr,tags:dn}}function Ae(z,Ue){return F(),nte.pasteEditsProvider(L(z.targetFile),z.pastedText,z.pasteLocations,z.copiedFrom?{file:L(z.copiedFrom.file),range:z.copiedFrom.range}:void 0,e,z.preferences,zl.getFormatContext(Ue,e),S)}function xe(z){return gE(z.parent)&&z.pos===z.parent.pos?z.parent.expression:hN(z.parent)&&z.pos===z.parent.pos||WP(z.parent)&&z.parent.name===z||sg(z.parent)?z.parent:z}function te(z,Ue,Te){switch(Ue.kind){case 80:return Ue.flags&16777216&&!hn(Ue)&&(Ue.parent.kind===171&&Ue.parent.name===Ue||Pr(Ue,Re=>Re.kind===169))?!1:!aQ(Ue)&&!oQ(Ue)&&!Qm(Ue.parent);case 211:case 166:return!Bv(z,Te);case 110:case 197:case 108:case 202:return!0;case 236:return WP(Ue);default:return!1}}function he(z,Ue,Te,Re){return F(),oD.getDefinitionAtPosition(u,L(z),Ue,Te,Re)}function be(z,Ue){return F(),oD.getDefinitionAndBoundSpan(u,L(z),Ue)}function Ve(z,Ue){return F(),oD.getTypeDefinitionAtPosition(u.getTypeChecker(),L(z),Ue)}function Pe(z,Ue){return F(),lc.getImplementationsAtPosition(u,S,u.getSourceFiles(),L(z),Ue)}function ke(z,Ue,Te){let Re=Zs(z);M.assert(Te.some(Ht=>Zs(Ht)===Re)),F();let It=Gi(Te,Ht=>u.getSourceFile(Ht)),$t=L(z);return _V.getDocumentHighlights(u,S,$t,Ue,It)}function De(z,Ue,Te,Re,It){F();let $t=L(z),Ht=DU(wf($t,Ue));if(KV.nodeIsEligibleForRename(Ht))if(He(Ht)&&(Yg(Ht.parent)||yE(Ht.parent))&&nN(Ht.escapedText)){let{openingElement:dr,closingElement:qr}=Ht.parent.parent;return[dr,qr].map(Hr=>{let dn=df(Hr.tagName,$t);return{fileName:$t.fileName,textSpan:dn,...lc.toContextSpan(dn,$t,Hr.parent)}})}else{let dr=ed($t,It??am),qr=typeof It=="boolean"?It:It?.providePrefixAndSuffixTextForRename;return ct(Ht,Ue,{findInStrings:Te,findInComments:Re,providePrefixAndSuffixTextForRename:qr,use:lc.FindReferencesUse.Rename},(Hr,dn,Ar)=>lc.toRenameLocation(Hr,dn,Ar,qr||!1,dr))}}function Be(z,Ue){return F(),ct(wf(L(z),Ue),Ue,{use:lc.FindReferencesUse.References},lc.toReferenceEntry)}function ct(z,Ue,Te,Re){F();let It=Te&&Te.use===lc.FindReferencesUse.Rename?u.getSourceFiles().filter($t=>!u.isSourceFileDefaultLibrary($t)):u.getSourceFiles();return lc.findReferenceOrRenameEntries(u,S,It,z,Ue,Te,Re)}function qe(z,Ue){return F(),lc.findReferencedSymbols(u,S,u.getSourceFiles(),L(z),Ue)}function et(z){return F(),lc.Core.getReferencesForFileName(z,u,u.getSourceFiles()).map(lc.toReferenceEntry)}function Ie(z,Ue,Te,Re=!1,It=!1){F();let $t=Te?[L(Te)]:u.getSourceFiles();return Z7e($t,u.getTypeChecker(),S,z,Ue,Re,It)}function _t(z,Ue,Te){F();let Re=L(z),It=e.getCustomTransformers&&e.getCustomTransformers();return Yhe(u,Re,!!Ue,S,It,Te)}function mt(z,Ue,{triggerReason:Te}=am){F();let Re=L(z);return YM.getSignatureHelpItems(u,Re,Ue,Te,S)}function Xe(z){return o.getCurrentSourceFile(z)}function ht(z,Ue,Te){let Re=o.getCurrentSourceFile(z),It=wf(Re,Ue);if(It===Re)return;switch(It.kind){case 211:case 166:case 11:case 97:case 112:case 106:case 108:case 110:case 197:case 80:break;default:return}let $t=It;for(;;)if(WN($t)||g0e($t))$t=$t.parent;else if(lQ($t))if($t.parent.parent.kind===267&&$t.parent.parent.body===$t.parent)$t=$t.parent.parent.name;else break;else break;return Il($t.getStart(),It.getEnd())}function rr(z,Ue){let Te=o.getCurrentSourceFile(z);return HZ.spanInSourceFileAtLocation(Te,Ue)}function vr(z){return nLe(o.getCurrentSourceFile(z),S)}function xr(z){return iLe(o.getCurrentSourceFile(z),S)}function jr(z,Ue,Te){return F(),(Te||"original")==="2020"?MFe(u,S,L(z),Ue):cve(u.getTypeChecker(),S,L(z),u.getClassifiableNames(),Ue)}function ur(z,Ue,Te){return F(),(Te||"original")==="original"?lZ(u.getTypeChecker(),S,L(z),u.getClassifiableNames(),Ue):F1e(u,S,L(z),Ue)}function or(z,Ue){return lve(S,o.getCurrentSourceFile(z),Ue)}function Zr(z,Ue){return uZ(S,o.getCurrentSourceFile(z),Ue)}function Oi(z){let Ue=o.getCurrentSourceFile(z);return Jee.collectElements(Ue,S)}let Sr=new Map(Object.entries({19:20,21:22,23:24,32:30}));Sr.forEach((z,Ue)=>Sr.set(z.toString(),Number(Ue)));function Pi(z,Ue){let Te=o.getCurrentSourceFile(z),Re=HN(Te,Ue),It=Re.getStart(Te)===Ue?Sr.get(Re.kind.toString()):void 0,$t=It&&Oo(Re.parent,It,Te);return $t?[df(Re,Te),df($t,Te)].sort((Ht,dr)=>Ht.start-dr.start):ve}function Cs(z,Ue,Te){let Re=Tc(),It=RM(Te),$t=o.getCurrentSourceFile(z);x("getIndentationAtPosition: getCurrentSourceFile: "+(Tc()-Re)),Re=Tc();let Ht=zl.SmartIndenter.getIndentation(Ue,$t,It);return x("getIndentationAtPosition: computeIndentation  : "+(Tc()-Re)),Ht}function ss(z,Ue,Te,Re){let It=o.getCurrentSourceFile(z);return zl.formatSelection(Ue,Te,It,zl.getFormatContext(RM(Re),e))}function Ii(z,Ue){return zl.formatDocument(o.getCurrentSourceFile(z),zl.getFormatContext(RM(Ue),e))}function $r(z,Ue,Te,Re){let It=o.getCurrentSourceFile(z),$t=zl.getFormatContext(RM(Re),e);if(!Bv(It,Ue))switch(Te){case"{":return zl.formatOnOpeningCurly(Ue,It,$t);case"}":return zl.formatOnClosingCurly(Ue,It,$t);case";":return zl.formatOnSemicolon(Ue,It,$t);case`
`:return zl.formatOnEnter(Ue,It,$t)}return[]}function Xs(z,Ue,Te,Re,It,$t=am){F();let Ht=L(z),dr=Il(Ue,Te),qr=zl.getFormatContext(It,e);return va(I1(Re,gv,tc),Hr=>(S.throwIfCancellationRequested(),A_.getFixes({errorCode:Hr,sourceFile:Ht,span:dr,program:u,host:e,cancellationToken:S,formatContext:qr,preferences:$t})))}function $e(z,Ue,Te,Re=am){F(),M.assert(z.type==="file");let It=L(z.fileName),$t=zl.getFormatContext(Te,e);return A_.getAllFixes({fixId:Ue,sourceFile:It,program:u,host:e,cancellationToken:S,formatContext:$t,preferences:Re})}function Yt(z,Ue,Te=am){F(),M.assert(z.type==="file");let Re=L(z.fileName),It=zl.getFormatContext(Ue,e),$t=z.mode??(z.skipDestructiveCodeActions?"SortAndCombine":"All");return Ub.organizeImports(Re,It,e,u,Te,$t)}function Vr(z,Ue,Te,Re=am){return fve(G(),z,Ue,e,zl.getFormatContext(Te,e),Re,R)}function An(z,Ue){let Te=typeof z=="string"?Ue:z;return Rs(Te)?Promise.all(Te.map(Re=>vi(Re))):vi(Te)}function vi(z){let Ue=Te=>rc(Te,E,w);return M.assertEqual(z.type,"install package"),e.installPackage?e.installPackage({fileName:Ue(z.file),packageName:z.packageName}):Promise.reject("Host does not implement `installPackage`")}function Ci(z,Ue,Te,Re){let It=Re?zl.getFormatContext(Re,e).options:void 0;return Bb.getDocCommentTemplateAtPosition(Vv(e,It),o.getCurrentSourceFile(z),Ue,Te)}function Ui(z,Ue,Te){if(Te===60)return!1;let Re=o.getCurrentSourceFile(z);if(ik(Re,Ue))return!1;if(E0e(Re,Ue))return Te===123;if(mQ(Re,Ue))return!1;switch(Te){case 39:case 34:case 96:return!Bv(Re,Ue)}return!0}function la(z,Ue){let Te=o.getCurrentSourceFile(z),Re=iu(Ue,Te);if(!Re)return;let It=Re.kind===32&&Yg(Re.parent)?Re.parent.parent:DA(Re)&&Ly(Re.parent)?Re.parent:void 0;if(It&&vt(It))return{newText:`</${It.openingElement.tagName.getText(Te)}>`};let $t=Re.kind===32&&_2(Re.parent)?Re.parent.parent:DA(Re)&&vE(Re.parent)?Re.parent:void 0;if($t&&Ce($t))return{newText:"</>"}}function Gs(z,Ue){let Te=o.getCurrentSourceFile(z),Re=iu(Ue,Te);if(!Re||Re.parent.kind===307)return;let It="[a-zA-Z0-9:\\-\\._$]*";if(vE(Re.parent.parent)){let $t=Re.parent.parent.openingFragment,Ht=Re.parent.parent.closingFragment;if(VP($t)||VP(Ht))return;let dr=$t.getStart(Te)+1,qr=Ht.getStart(Te)+2;return Ue!==dr&&Ue!==qr?void 0:{ranges:[{start:dr,length:0},{start:qr,length:0}],wordPattern:It}}else{let $t=Pr(Re.parent,Ki=>!!(Yg(Ki)||yE(Ki)));if(!$t)return;M.assert(Yg($t)||yE($t),"tag should be opening or closing element");let Ht=$t.parent.openingElement,dr=$t.parent.closingElement,qr=Ht.tagName.getStart(Te),Hr=Ht.tagName.end,dn=dr.tagName.getStart(Te),Ar=dr.tagName.end;return qr===Ht.getStart(Te)||dn===dr.getStart(Te)||Hr===Ht.getEnd()||Ar===dr.getEnd()||!(qr<=Ue&&Ue<=Hr||dn<=Ue&&Ue<=Ar)||Ht.tagName.getText(Te)!==dr.tagName.getText(Te)?void 0:{ranges:[{start:qr,length:Hr-qr},{start:dn,length:Ar-dn}],wordPattern:It}}}function yr(z,Ue){return{lineStarts:z.getLineStarts(),firstLine:z.getLineAndCharacterOfPosition(Ue.pos).line,lastLine:z.getLineAndCharacterOfPosition(Ue.end).line}}function to(z,Ue,Te){let Re=o.getCurrentSourceFile(z),It=[],{lineStarts:$t,firstLine:Ht,lastLine:dr}=yr(Re,Ue),qr=Te||!1,Hr=Number.MAX_VALUE,dn=new Map,Ar=new RegExp(/\S/),In=OU(Re,$t[Ht]),Ki=In?"{/*":"//";for(let ls=Ht;ls<=dr;ls++){let Yn=Re.text.substring($t[ls],Re.getLineEndOfPosition($t[ls])),pi=Ar.exec(Yn);pi&&(Hr=Math.min(Hr,pi.index),dn.set(ls.toString(),pi.index),Yn.substr(pi.index,Ki.length)!==Ki&&(qr=Te===void 0||Te))}for(let ls=Ht;ls<=dr;ls++){if(Ht!==dr&&$t[ls]===Ue.end)continue;let Yn=dn.get(ls.toString());Yn!==void 0&&(In?It.push(...lt(z,{pos:$t[ls]+Hr,end:Re.getLineEndOfPosition($t[ls])},qr,In)):qr?It.push({newText:Ki,span:{length:0,start:$t[ls]+Hr}}):Re.text.substr($t[ls]+Yn,Ki.length)===Ki&&It.push({newText:"",span:{length:Ki.length,start:$t[ls]+Yn}}))}return It}function lt(z,Ue,Te,Re){var It;let $t=o.getCurrentSourceFile(z),Ht=[],{text:dr}=$t,qr=!1,Hr=Te||!1,dn=[],{pos:Ar}=Ue,In=Re!==void 0?Re:OU($t,Ar),Ki=In?"{/*":"/*",ls=In?"*/}":"*/",Yn=In?"\\{\\/\\*":"\\/\\*",pi=In?"\\*\\/\\}":"\\*\\/";for(;Ar<=Ue.end;){let Er=dr.substr(Ar,Ki.length)===Ki?Ki.length:0,tn=Bv($t,Ar+Er);if(tn)In&&(tn.pos--,tn.end++),dn.push(tn.pos),tn.kind===3&&dn.push(tn.end),qr=!0,Ar=tn.end+1;else{let er=dr.substring(Ar,Ue.end).search(`(${Yn})|(${pi})`);Hr=Te!==void 0?Te:Hr||!M0e(dr,Ar,er===-1?Ue.end:Ar+er),Ar=er===-1?Ue.end+1:Ar+er+ls.length}}if(Hr||!qr){((It=Bv($t,Ue.pos))==null?void 0:It.kind)!==2&&l0(dn,Ue.pos,tc),l0(dn,Ue.end,tc);let Er=dn[0];dr.substr(Er,Ki.length)!==Ki&&Ht.push({newText:Ki,span:{length:0,start:Er}});for(let tn=1;tn<dn.length-1;tn++)dr.substr(dn[tn]-ls.length,ls.length)!==ls&&Ht.push({newText:ls,span:{length:0,start:dn[tn]}}),dr.substr(dn[tn],Ki.length)!==Ki&&Ht.push({newText:Ki,span:{length:0,start:dn[tn]}});Ht.length%2!==0&&Ht.push({newText:ls,span:{length:0,start:dn[dn.length-1]}})}else for(let Er of dn){let tn=Er-ls.length>0?Er-ls.length:0,er=dr.substr(tn,ls.length)===ls?ls.length:0;Ht.push({newText:"",span:{length:Ki.length,start:Er-er}})}return Ht}function St(z,Ue){let Te=o.getCurrentSourceFile(z),{firstLine:Re,lastLine:It}=yr(Te,Ue);return Re===It&&Ue.pos!==Ue.end?lt(z,Ue,!0):to(z,Ue,!0)}function fe(z,Ue){let Te=o.getCurrentSourceFile(z),Re=[],{pos:It}=Ue,{end:$t}=Ue;It===$t&&($t+=OU(Te,It)?2:1);for(let Ht=It;Ht<=$t;Ht++){let dr=Bv(Te,Ht);if(dr){switch(dr.kind){case 2:Re.push(...to(z,{end:dr.end,pos:dr.pos+1},!1));break;case 3:Re.push(...lt(z,{end:dr.end,pos:dr.pos+1},!1))}Ht=dr.end+1}}return Re}function vt({openingElement:z,closingElement:Ue,parent:Te}){return!kb(z.tagName,Ue.tagName)||Ly(Te)&&kb(z.tagName,Te.openingElement.tagName)&&vt(Te)}function Ce({closingFragment:z,parent:Ue}){return!!(z.flags&262144)||vE(Ue)&&Ce(Ue)}function nt(z,Ue,Te){let Re=o.getCurrentSourceFile(z),It=zl.getRangeOfEnclosingComment(Re,Ue);return It&&(!Te||It.kind===3)?lS(It):void 0}function Me(z,Ue){F();let Te=L(z);S.throwIfCancellationRequested();let Re=Te.text,It=[];if(Ue.length>0&&!qr(Te.fileName)){let Hr=Ht(),dn;for(;dn=Hr.exec(Re);){S.throwIfCancellationRequested();let Ar=3;M.assert(dn.length===Ue.length+Ar);let In=dn[1],Ki=dn.index+In.length;if(!Bv(Te,Ki))continue;let ls;for(let pi=0;pi<Ue.length;pi++)dn[pi+Ar]&&(ls=Ue[pi]);if(ls===void 0)return M.fail();if(dr(Re.charCodeAt(Ki+ls.text.length)))continue;let Yn=dn[2];It.push({descriptor:ls,message:Yn,position:Ki})}}return It;function $t(Hr){return Hr.replace(/[-[\]/{}()*+?.\\^$|]/g,"\\$&")}function Ht(){let Hr=/(?:\/\/+\s*)/.source,dn=/(?:\/\*+\s*)/.source,In="("+/(?:^(?:\s|\*)*)/.source+"|"+Hr+"|"+dn+")",Ki="(?:"+Cr(Ue,tn=>"("+$t(tn.text)+")").join("|")+")",ls=/(?:$|\*\/)/.source,Yn=/(?:.*?)/.source,pi="("+Ki+Yn+")",Er=In+pi+ls;return new RegExp(Er,"gim")}function dr(Hr){return Hr>=97&&Hr<=122||Hr>=65&&Hr<=90||Hr>=48&&Hr<=57}function qr(Hr){return Hr.includes("/node_modules/")}}function tt(z,Ue,Te){return F(),KV.getRenameInfo(u,L(z),Ue,Te||{})}function ft(z,Ue,Te,Re,It,$t){let[Ht,dr]=typeof Ue=="number"?[Ue,void 0]:[Ue.pos,Ue.end];return{file:z,startPosition:Ht,endPosition:dr,program:G(),host:e,formatContext:zl.getFormatContext(Re,e),cancellationToken:S,preferences:Te,triggerReason:It,kind:$t}}function tr(z,Ue,Te){return{file:z,program:G(),host:e,span:Ue,preferences:Te,cancellationToken:S}}function Oe(z,Ue){return Wee.getSmartSelectionRange(Ue,o.getCurrentSourceFile(z))}function At(z,Ue,Te=am,Re,It,$t){F();let Ht=L(z);return lk.getApplicableRefactors(ft(Ht,Ue,Te,am,Re,It),$t)}function Nt(z,Ue,Te=am){F();let Re=L(z),It=M.checkDefined(u.getSourceFiles()),$t=cO(z),Ht=IM(ft(Re,Ue,Te,am)),dr=i1e(Ht?.all),qr=Gi(It,Hr=>{let dn=cO(Hr.fileName);return!u?.isSourceFileFromExternalLibrary(Re)&&!(Re===L(Hr.fileName)||$t===".ts"&&dn===".d.ts"||$t===".d.ts"&&_s(Ul(Hr.fileName),"lib.")&&dn===".d.ts")&&($t===dn||($t===".tsx"&&dn===".ts"||$t===".jsx"&&dn===".js")&&!dr)?Hr.fileName:void 0});return{newFileName:n1e(Re,u,e,Ht),files:qr}}function Ut(z,Ue,Te,Re,It,$t=am,Ht){F();let dr=L(z);return lk.getEditsForRefactor(ft(dr,Te,$t,Ue),Re,It,Ht)}function Rt(z,Ue){return Ue===0?{line:0,character:0}:R.toLineColumnOffset(z,Ue)}function nr(z,Ue){F();let Te=uk.resolveCallHierarchyDeclaration(u,wf(L(z),Ue));return Te&&eZ(Te,Re=>uk.createCallHierarchyItem(u,Re))}function Z(z,Ue){F();let Te=L(z),Re=tZ(uk.resolveCallHierarchyDeclaration(u,Ue===0?Te:wf(Te,Ue)));return Re?uk.getIncomingCalls(u,Re,S):[]}function Ge(z,Ue){F();let Te=L(z),Re=tZ(uk.resolveCallHierarchyDeclaration(u,Ue===0?Te:wf(Te,Ue)));return Re?uk.getOutgoingCalls(u,Re):[]}function bt(z,Ue,Te=am){F();let Re=L(z);return jee.provideInlayHints(tr(Re,Ue,Te))}function Q(z,Ue,Te,Re,It){return Bee.mapCode(o.getCurrentSourceFile(z),Ue,Te,e,zl.getFormatContext(Re,e),It)}let Ke={dispose:pe,cleanupSemanticCache:W,getSyntacticDiagnostics:K,getSemanticDiagnostics:re,getSuggestionDiagnostics:ue,getCompilerOptionsDiagnostics:ce,getSyntacticClassifications:or,getSemanticClassifications:jr,getEncodedSyntacticClassifications:Zr,getEncodedSemanticClassifications:ur,getCompletionsAtPosition:ne,getCompletionEntryDetails:le,getCompletionEntrySymbol:me,getSignatureHelpItems:mt,getQuickInfoAtPosition:de,getDefinitionAtPosition:he,getDefinitionAndBoundSpan:be,getImplementationAtPosition:Pe,getTypeDefinitionAtPosition:Ve,getReferencesAtPosition:Be,findReferences:qe,getFileReferences:et,getDocumentHighlights:ke,getNameOrDottedNameSpan:ht,getBreakpointStatementAtPosition:rr,getNavigateToItems:Ie,getRenameInfo:tt,getSmartSelectionRange:Oe,findRenameLocations:De,getNavigationBarItems:vr,getNavigationTree:xr,getOutliningSpans:Oi,getTodoComments:Me,getBraceMatchingAtPosition:Pi,getIndentationAtPosition:Cs,getFormattingEditsForRange:ss,getFormattingEditsForDocument:Ii,getFormattingEditsAfterKeystroke:$r,getDocCommentTemplateAtPosition:Ci,isValidBraceCompletionAtPosition:Ui,getJsxClosingTagAtPosition:la,getLinkedEditingRangeAtPosition:Gs,getSpanOfEnclosingComment:nt,getCodeFixesAtPosition:Xs,getCombinedCodeFix:$e,applyCodeActionCommand:An,organizeImports:Yt,getEditsForFileRename:Vr,getEmitOutput:_t,getNonBoundSourceFile:Xe,getProgram:G,getCurrentProgram:()=>u,getAutoImportProvider:q,updateIsDefinitionOfReferencedSymbols:ee,getApplicableRefactors:At,getEditsForRefactor:Ut,getMoveToRefactoringFileSuggestions:Nt,toLineColumnOffset:Rt,getSourceMapper:()=>R,clearSourceMapperCache:()=>R.clearCache(),prepareCallHierarchy:nr,provideCallHierarchyIncomingCalls:Z,provideCallHierarchyOutgoingCalls:Ge,toggleLineComment:to,toggleMultilineComment:lt,commentSelection:St,uncommentSelection:fe,provideInlayHints:bt,getSupportedCodeFixes:zZ,getPasteEdits:Ae,mapCode:Q};switch(s){case 0:break;case 1:GFe.forEach(z=>Ke[z]=()=>{throw new Error(`LanguageService Operation: ${z} not allowed in LanguageServiceMode.PartialSemantic`)});break;case 2:SPt.forEach(z=>Ke[z]=()=>{throw new Error(`LanguageService Operation: ${z} not allowed in LanguageServiceMode.Syntactic`)});break;default:M.assertNever(s)}return Ke}function $Z(e){return e.nameTable||bPt(e),e.nameTable}function bPt(e){let t=e.nameTable=new Map;e.forEachChild(function n(i){if(He(i)&&!oQ(i)&&i.escapedText||zp(i)&&TPt(i)){let s=JI(i);t.set(s,t.get(s)===void 0?i.pos:-1)}else if(Zi(i)){let s=i.escapedText;t.set(s,t.get(s)===void 0?i.pos:-1)}if(Js(i,n),Pp(i))for(let s of i.jsDoc)Js(s,n)})}function TPt(e){return Uh(e)||e.parent.kind===283||CPt(e)||kR(e)}function LM(e){let t=EPt(e);return t&&(Ca(t.parent)||SE(t.parent))?t:void 0}function EPt(e){switch(e.kind){case 11:case 15:case 9:if(e.parent.kind===167)return H$(e.parent.parent)?e.parent.parent:void 0;case 80:return H$(e.parent)&&(e.parent.parent.kind===210||e.parent.parent.kind===292)&&e.parent.name===e?e.parent:void 0}}function xPt(e,t){let n=LM(e);if(n){let i=t.getContextualType(n.parent),s=i&&PV(n,t,i,!1);if(s&&s.length===1)return Ma(s)}return t.getSymbolAtLocation(e)}function PV(e,t,n,i){let s=gM(e.name);if(!s)return ve;if(!n.isUnion()){let m=n.getProperty(s);return m?[m]:ve}let o=Ca(e.parent)||SE(e.parent)?Zn(n.types,m=>!t.isTypeInvalidDueToUnionDiscriminant(m,e.parent)):n.types,u=Gi(o,m=>m.getProperty(s));if(i&&(u.length===0||u.length===n.types.length)){let m=n.getProperty(s);if(m)return[m]}return!o.length&&!u.length?Gi(n.types,m=>m.getProperty(s)):I1(u,gv)}function CPt(e){return e&&e.parent&&e.parent.kind===212&&e.parent.argumentExpression===e}function J1e(e){if(lu)return ri(mi(Zs(lu.getExecutingFilePath())),k3(e));throw new Error("getDefaultLibFilePath is only supported when consumed as a node module. ")}ipe(gPt());function YFe(e,t,n){let i=[];n=bZ(n,i);let s=Rs(e)?e:[e],o=q8(void 0,void 0,U,n,s,t,!0);return o.diagnostics=ps(o.diagnostics,i),o}var HZ={};A(HZ,{spanInSourceFileAtLocation:()=>APt});function APt(e,t){if(e.isDeclarationFile)return;let n=Yi(e,t),i=e.getLineAndCharacterOfPosition(t).line;if(e.getLineAndCharacterOfPosition(n.getStart(e)).line>i){let x=iu(n.pos,e);if(!x||e.getLineAndCharacterOfPosition(x.getEnd()).line!==i)return;n=x}if(n.flags&33554432)return;return E(n);function s(x,D){let w=TE(x)?xm(x.modifiers,fu):void 0,R=w?Ja(e.text,w.end):x.getStart(e);return Il(R,(D||x).getEnd())}function o(x,D){return s(x,NE(D,D.parent,e))}function u(x,D){return x&&i===e.getLineAndCharacterOfPosition(x.getStart(e)).line?E(x):E(D)}function m(x,D,w){if(x){let R=x.indexOf(D);if(R>=0){let L=R,F=R+1;for(;L>0&&w(x[L-1]);)L--;for(;F<x.length&&w(x[F]);)F++;return Il(Ja(e.text,x[L].pos),x[F-1].end)}}return s(D)}function d(x){return E(iu(x.pos,e))}function S(x){return E(NE(x,x.parent,e))}function E(x){if(x){let{parent:te}=x;switch(x.kind){case 243:return w(x.declarationList.declarations[0]);case 260:case 172:case 171:return w(x);case 169:return L(x);case 262:case 174:case 173:case 177:case 178:case 176:case 218:case 219:return J(x);case 241:if(XT(x))return G(x);case 268:return q(x);case 299:return q(x.block);case 244:return s(x.expression);case 253:return s(x.getChildAt(0),x.expression);case 247:return o(x,x.expression);case 246:return E(x.statement);case 259:return s(x.getChildAt(0));case 245:return o(x,x.expression);case 256:return E(x.statement);case 252:case 251:return s(x.getChildAt(0),x.label);case 248:return W(x);case 249:return o(x,x.expression);case 250:return ee(x);case 255:return o(x,x.expression);case 296:case 297:return E(x.statements[0]);case 258:return q(x.tryBlock);case 257:return s(x,x.expression);case 277:return s(x,x.expression);case 271:return s(x,x.moduleReference);case 272:return s(x,x.moduleSpecifier);case 278:return s(x,x.moduleSpecifier);case 267:if(N0(x)!==1)return;case 263:case 266:case 306:case 208:return s(x);case 254:return E(x.statement);case 170:return m(te.modifiers,x,fu);case 206:case 207:return pe(x);case 264:case 265:return;case 27:case 1:return u(iu(x.pos,e));case 28:return d(x);case 19:return re(x);case 20:return ue(x);case 24:return ce(x);case 21:return ne(x);case 22:return le(x);case 59:return me(x);case 32:case 30:return de(x);case 117:return Ae(x);case 93:case 85:case 98:return S(x);case 165:return xe(x);default:if(Uv(x))return K(x);if((x.kind===80||x.kind===230||x.kind===303||x.kind===304)&&Uv(te))return s(x);if(x.kind===226){let{left:he,operatorToken:be}=x;if(Uv(he))return K(he);if(be.kind===64&&Uv(x.parent))return s(x);if(be.kind===28)return E(he)}if(tg(x))switch(te.kind){case 246:return d(x);case 170:return E(x.parent);case 248:case 250:return s(x);case 226:if(x.parent.operatorToken.kind===28)return s(x);break;case 219:if(x.parent.body===x)return s(x);break}switch(x.parent.kind){case 303:if(x.parent.name===x&&!Uv(x.parent.parent))return E(x.parent.initializer);break;case 216:if(x.parent.type===x)return S(x.parent.type);break;case 260:case 169:{let{initializer:he,type:be}=x.parent;if(he===x||be===x||y0(x.kind))return d(x);break}case 226:{let{left:he}=x.parent;if(Uv(he)&&x!==he)return d(x);break}default:if(Bs(x.parent)&&x.parent.type===x)return d(x)}return E(x.parent)}}function D(te){return Ru(te.parent)&&te.parent.declarations[0]===te?s(iu(te.pos,e,te.parent),te):s(te)}function w(te){if(te.parent.parent.kind===249)return E(te.parent.parent);let he=te.parent;if(Hs(te.name))return pe(te.name);if(Hx(te)&&te.initializer||li(te,32)||he.parent.kind===250)return D(te);if(Ru(te.parent)&&te.parent.declarations[0]!==te)return E(iu(te.pos,e,te.parent))}function R(te){return!!te.initializer||te.dotDotDotToken!==void 0||li(te,3)}function L(te){if(Hs(te.name))return pe(te.name);if(R(te))return s(te);{let he=te.parent,be=he.parameters.indexOf(te);return M.assert(be!==-1),be!==0?L(he.parameters[be-1]):E(he.body)}}function F(te){return li(te,32)||te.parent.kind===263&&te.kind!==176}function J(te){if(te.body)return F(te)?s(te):E(te.body)}function G(te){let he=te.statements.length?te.statements[0]:te.getLastToken();return F(te.parent)?u(te.parent,he):E(he)}function q(te){switch(te.parent.kind){case 267:if(N0(te.parent)!==1)return;case 247:case 245:case 249:return u(te.parent,te.statements[0]);case 248:case 250:return u(iu(te.pos,e,te.parent),te.statements[0])}return E(te.statements[0])}function ee(te){if(te.initializer.kind===261){let he=te.initializer;if(he.declarations.length>0)return E(he.declarations[0])}else return E(te.initializer)}function W(te){if(te.initializer)return ee(te);if(te.condition)return s(te.condition);if(te.incrementor)return s(te.incrementor)}function pe(te){let he=kt(te.elements,be=>be.kind!==232?be:void 0);return he?E(he):te.parent.kind===208?s(te.parent):D(te.parent)}function K(te){M.assert(te.kind!==207&&te.kind!==206);let he=te.kind===209?te.elements:te.properties,be=kt(he,Ve=>Ve.kind!==232?Ve:void 0);return be?E(be):s(te.parent.kind===226?te.parent:te)}function re(te){switch(te.parent.kind){case 266:let he=te.parent;return u(iu(te.pos,e,te.parent),he.members.length?he.members[0]:he.getLastToken(e));case 263:let be=te.parent;return u(iu(te.pos,e,te.parent),be.members.length?be.members[0]:be.getLastToken(e));case 269:return u(te.parent.parent,te.parent.clauses[0])}return E(te.parent)}function ue(te){switch(te.parent.kind){case 268:if(N0(te.parent.parent)!==1)return;case 266:case 263:return s(te);case 241:if(XT(te.parent))return s(te);case 299:return E(vc(te.parent.statements));case 269:let he=te.parent,be=vc(he.clauses);return be?E(vc(be.statements)):void 0;case 206:let Ve=te.parent;return E(vc(Ve.elements)||Ve);default:if(Uv(te.parent)){let Pe=te.parent;return s(vc(Pe.properties)||Pe)}return E(te.parent)}}function ce(te){switch(te.parent.kind){case 207:let he=te.parent;return s(vc(he.elements)||he);default:if(Uv(te.parent)){let be=te.parent;return s(vc(be.elements)||be)}return E(te.parent)}}function ne(te){return te.parent.kind===246||te.parent.kind===213||te.parent.kind===214?d(te):te.parent.kind===217?S(te):E(te.parent)}function le(te){switch(te.parent.kind){case 218:case 262:case 219:case 174:case 173:case 177:case 178:case 176:case 247:case 246:case 248:case 250:case 213:case 214:case 217:return d(te);default:return E(te.parent)}}function me(te){return Bs(te.parent)||te.parent.kind===303||te.parent.kind===169?d(te):E(te.parent)}function de(te){return te.parent.kind===216?S(te):E(te.parent)}function Ae(te){return te.parent.kind===246?o(te,te.parent.expression):E(te.parent)}function xe(te){return te.parent.kind===250?S(te):E(te.parent)}}}var uk={};A(uk,{createCallHierarchyItem:()=>q1e,getIncomingCalls:()=>RPt,getOutgoingCalls:()=>zPt,resolveCallHierarchyDeclaration:()=>n5e});function kPt(e){return(ic(e)||eu(e))&&Wu(e)}function KFe(e){return Ns(e)||Ei(e)}function FM(e){return(ic(e)||pc(e)||eu(e))&&KFe(e.parent)&&e===e.parent.initializer&&He(e.parent.name)&&(!!(f0(e.parent)&2)||Ns(e.parent))}function XFe(e){return Ji(e)||El(e)||Tl(e)||ic(e)||tu(e)||eu(e)||Gc(e)||ul(e)||$g(e)||Hp(e)||fp(e)}function iD(e){return Ji(e)||El(e)&&He(e.name)||Tl(e)||tu(e)||Gc(e)||ul(e)||$g(e)||Hp(e)||fp(e)||kPt(e)||FM(e)}function QFe(e){return Ji(e)?e:Wu(e)?e.name:FM(e)?e.parent.name:M.checkDefined(e.modifiers&&Ln(e.modifiers,ZFe))}function ZFe(e){return e.kind===90}function e5e(e,t){let n=QFe(t);return n&&e.getSymbolAtLocation(n)}function PPt(e,t){if(Ji(t))return{text:t.fileName,pos:0,end:0};if((Tl(t)||tu(t))&&!Wu(t)){let s=t.modifiers&&Ln(t.modifiers,ZFe);if(s)return{text:"default",pos:s.getStart(),end:s.getEnd()}}if(Gc(t)){let s=t.getSourceFile(),o=Ja(s.text,Jg(t).pos),u=o+6,m=e.getTypeChecker(),d=m.getSymbolAtLocation(t.parent);return{text:`${d?`${m.symbolToString(d,t.parent)} `:""}static {}`,pos:o,end:u}}let n=FM(t)?t.parent.name:M.checkDefined(Ps(t),"Expected call hierarchy item to have a name"),i=He(n)?Nn(n):zp(n)?n.text:za(n)&&zp(n.expression)?n.expression.text:void 0;if(i===void 0){let s=e.getTypeChecker(),o=s.getSymbolAtLocation(n);o&&(i=s.symbolToString(o,t))}if(i===void 0){let s=VB();i=CI(o=>s.writeNode(4,t,t.getSourceFile(),o))}return{text:i,pos:n.getStart(),end:n.getEnd()}}function NPt(e){var t,n,i,s;if(FM(e))return Ns(e.parent)&&gi(e.parent.parent)?eu(e.parent.parent)?(t=E5(e.parent.parent))==null?void 0:t.getText():(n=e.parent.parent.name)==null?void 0:n.getText():Hg(e.parent.parent.parent.parent)&&He(e.parent.parent.parent.parent.parent.name)?e.parent.parent.parent.parent.parent.name.getText():void 0;switch(e.kind){case 177:case 178:case 174:return e.parent.kind===210?(i=E5(e.parent))==null?void 0:i.getText():(s=Ps(e.parent))==null?void 0:s.getText();case 262:case 263:case 267:if(Hg(e.parent)&&He(e.parent.parent.name))return e.parent.parent.name.getText()}}function t5e(e,t){if(t.body)return t;if(Vc(t))return Ny(t.parent);if(Tl(t)||ul(t)){let n=e5e(e,t);return n&&n.valueDeclaration&&Go(n.valueDeclaration)&&n.valueDeclaration.body?n.valueDeclaration:void 0}return t}function r5e(e,t){let n=e5e(e,t),i;if(n&&n.declarations){let s=Ox(n.declarations),o=Cr(n.declarations,d=>({file:d.getSourceFile().fileName,pos:d.pos}));s.sort((d,S)=>c_(o[d].file,o[S].file)||o[d].pos-o[S].pos);let u=Cr(s,d=>n.declarations[d]),m;for(let d of u)iD(d)&&((!m||m.parent!==d.parent||m.end!==d.pos)&&(i=Bt(i,d)),m=d)}return i}function GZ(e,t){return Gc(t)?t:Go(t)?t5e(e,t)??r5e(e,t)??t:r5e(e,t)??t}function n5e(e,t){let n=e.getTypeChecker(),i=!1;for(;;){if(iD(t))return GZ(n,t);if(XFe(t)){let s=Pr(t,iD);return s&&GZ(n,s)}if(Uh(t)){if(iD(t.parent))return GZ(n,t.parent);if(XFe(t.parent)){let s=Pr(t.parent,iD);return s&&GZ(n,s)}return KFe(t.parent)&&t.parent.initializer&&FM(t.parent.initializer)?t.parent.initializer:void 0}if(Vc(t))return iD(t.parent)?t.parent:void 0;if(t.kind===126&&Gc(t.parent)){t=t.parent;continue}if(Ei(t)&&t.initializer&&FM(t.initializer))return t.initializer;if(!i){let s=n.getSymbolAtLocation(t);if(s&&(s.flags&2097152&&(s=n.getAliasedSymbol(s)),s.valueDeclaration)){i=!0,t=s.valueDeclaration;continue}}return}}function q1e(e,t){let n=t.getSourceFile(),i=PPt(e,t),s=NPt(t),o=PE(t),u=m6(t),m=Il(Ja(n.text,t.getFullStart(),!1,!0),t.getEnd()),d=Il(i.pos,i.end);return{file:n.fileName,kind:o,kindModifiers:u,name:i.text,containerName:s,span:m,selectionSpan:d}}function DPt(e){return e!==void 0}function wPt(e){if(e.kind===lc.EntryKind.Node){let{node:t}=e;if(nQ(t,!0,!0)||f0e(t,!0,!0)||p0e(t,!0,!0)||d0e(t,!0,!0)||WN(t)||cQ(t)){let n=t.getSourceFile();return{declaration:Pr(t,iD)||n,range:EQ(t,n)}}}}function i5e(e){return yo(e.declaration)}function IPt(e,t){return{from:e,fromSpans:t}}function OPt(e,t){return IPt(q1e(e,t[0].declaration),Cr(t,n=>lS(n.range)))}function RPt(e,t,n){if(Ji(t)||El(t)||Gc(t))return[];let i=QFe(t),s=Zn(lc.findReferenceOrRenameEntries(e,n,e.getSourceFiles(),i,0,{use:lc.FindReferencesUse.References},wPt),DPt);return s?Hw(s,i5e,o=>OPt(e,o)):[]}function MPt(e,t){function n(s){let o=hE(s)?s.tag:__(s)?s.tagName:oc(s)||Gc(s)?s:s.expression,u=n5e(e,o);if(u){let m=EQ(o,s.getSourceFile());if(Rs(u))for(let d of u)t.push({declaration:d,range:m});else t.push({declaration:u,range:m})}}function i(s){if(s&&!(s.flags&33554432)){if(iD(s)){if(gi(s))for(let o of s.members)o.name&&za(o.name)&&i(o.name.expression);return}switch(s.kind){case 80:case 271:case 272:case 278:case 264:case 265:return;case 175:n(s);return;case 216:case 234:i(s.expression);return;case 260:case 169:i(s.name),i(s.initializer);return;case 213:n(s),i(s.expression),kt(s.arguments,i);return;case 214:n(s),i(s.expression),kt(s.arguments,i);return;case 215:n(s),i(s.tag),i(s.template);return;case 286:case 285:n(s),i(s.tagName),i(s.attributes);return;case 170:n(s),i(s.expression);return;case 211:case 212:n(s),Js(s,i);break;case 238:i(s.expression);return}Lg(s)||Js(s,i)}}return i}function LPt(e,t){kt(e.statements,t)}function FPt(e,t){!li(e,128)&&e.body&&Hg(e.body)&&kt(e.body.statements,t)}function jPt(e,t,n){let i=t5e(e,t);i&&(kt(i.parameters,n),n(i.body))}function BPt(e,t){t(e.body)}function UPt(e,t){kt(e.modifiers,t);let n=nE(e);n&&t(n.expression);for(let i of e.members)wm(i)&&kt(i.modifiers,t),Ns(i)?t(i.initializer):Vc(i)&&i.body?(kt(i.parameters,t),t(i.body)):Gc(i)&&t(i)}function VPt(e,t){let n=[],i=MPt(e,n);switch(t.kind){case 307:LPt(t,i);break;case 267:FPt(t,i);break;case 262:case 218:case 219:case 174:case 177:case 178:jPt(e.getTypeChecker(),t,i);break;case 263:case 231:UPt(t,i);break;case 175:BPt(t,i);break;default:M.assertNever(t)}return n}function JPt(e,t){return{to:e,fromSpans:t}}function qPt(e,t){return JPt(q1e(e,t[0].declaration),Cr(t,n=>lS(n.range)))}function zPt(e,t){return t.flags&33554432||$g(t)?[]:Hw(VPt(e,t),i5e,n=>qPt(e,n))}var z1e={};A(z1e,{v2020:()=>s5e});var s5e={};A(s5e,{TokenEncodingConsts:()=>IFe,TokenModifier:()=>RFe,TokenType:()=>OFe,getEncodedSemanticClassifications:()=>F1e,getSemanticClassifications:()=>MFe});var A_={};A(A_,{PreserveOptionalFlags:()=>dUe,addNewNodeForMemberSymbol:()=>mUe,codeFixAll:()=>Ro,createCodeFixAction:()=>ta,createCodeFixActionMaybeFixAll:()=>H1e,createCodeFixActionWithoutFixAll:()=>_g,createCombinedCodeActions:()=>_k,createFileTextChanges:()=>a5e,createImportAdder:()=>LE,createImportSpecifierResolver:()=>ZNt,createJsonPropertyAssignment:()=>Tee,createMissingMemberNodes:()=>_be,createSignatureDeclarationFromCallExpression:()=>fbe,createSignatureDeclarationFromSignature:()=>bee,createStubbedBody:()=>LV,eachDiagnostic:()=>fk,findAncestorMatchingSpan:()=>ybe,findJsonProperty:()=>hbe,generateAccessorFromProperty:()=>bUe,getAccessorConvertiblePropertyAtPosition:()=>xUe,getAllFixes:()=>GPt,getAllSupers:()=>vbe,getArgumentTypesAndTypeParameters:()=>yUe,getFixes:()=>HPt,getImportCompletionAction:()=>eDt,getImportKind:()=>aee,getJSDocTypedefNodes:()=>XNt,getNoopSymbolTrackerWithResolver:()=>aD,getPromoteTypeOnlyCompletionAction:()=>tDt,getSupportedErrorCodes:()=>WPt,importFixName:()=>A9e,importSymbols:()=>mk,parameterShouldGetTypeFromJSDoc:()=>M5e,registerCodeFix:()=>Ta,setJsonCompilerOptionValue:()=>gbe,setJsonCompilerOptionValues:()=>mbe,tryGetAutoImportableReferenceFromTypeNode:()=>x2,typeToAutoImportableTypeNode:()=>MV});var W1e=yd(),$1e=new Map;function _g(e,t,n){return G1e(e,wE(n),t,void 0,void 0)}function ta(e,t,n,i,s,o){return G1e(e,wE(n),t,i,wE(s),o)}function H1e(e,t,n,i,s,o){return G1e(e,wE(n),t,i,s&&wE(s),o)}function G1e(e,t,n,i,s,o){return{fixName:e,description:t,changes:n,fixId:i,fixAllDescription:s,commands:o?[o]:void 0}}function Ta(e){for(let t of e.errorCodes)Y1e=void 0,W1e.add(String(t),e);if(e.fixIds)for(let t of e.fixIds)M.assert(!$1e.has(t)),$1e.set(t,e)}var Y1e;function WPt(){return Y1e??(Y1e=Is(W1e.keys()))}function $Pt(e,t){let{errorCodes:n}=e,i=0;for(let o of t)if(Es(n,o.code)&&i++,i>1)break;let s=i<2;return({fixId:o,fixAllDescription:u,...m})=>s?m:{...m,fixId:o,fixAllDescription:u}}function HPt(e){let t=o5e(e),n=W1e.get(String(e.errorCode));return va(n,i=>Cr(i.getCodeActions(e),$Pt(i,t)))}function GPt(e){return $1e.get(aa(e.fixId,bs)).getAllCodeActions(e)}function _k(e,t){return{changes:e,commands:t}}function a5e(e,t){return{fileName:e,textChanges:t}}function Ro(e,t,n){let i=[],s=Sn.ChangeTracker.with(e,o=>fk(e,t,u=>n(o,u,i)));return _k(s,i.length===0?void 0:i)}function fk(e,t,n){for(let i of o5e(e))Es(t,i.code)&&n(i)}function o5e({program:e,sourceFile:t,cancellationToken:n}){let i=[...e.getSemanticDiagnostics(t,n),...e.getSyntacticDiagnostics(t,n),...hZ(t,e,n)];return $p(e.getCompilerOptions())&&i.push(...e.getDeclarationDiagnostics(t,n)),i}var K1e="addConvertToUnknownForNonOverlappingTypes",c5e=[v.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first.code];Ta({errorCodes:c5e,getCodeActions:function(t){let n=u5e(t.sourceFile,t.span.start);if(n===void 0)return;let i=Sn.ChangeTracker.with(t,s=>l5e(s,t.sourceFile,n));return[ta(K1e,i,v.Add_unknown_conversion_for_non_overlapping_types,K1e,v.Add_unknown_to_all_conversions_of_non_overlapping_types)]},fixIds:[K1e],getAllCodeActions:e=>Ro(e,c5e,(t,n)=>{let i=u5e(n.file,n.start);i&&l5e(t,n.file,i)})});function l5e(e,t,n){let i=CO(n)?U.createAsExpression(n.expression,U.createKeywordTypeNode(159)):U.createTypeAssertion(U.createKeywordTypeNode(159),n.expression);e.replaceNode(t,n.expression,i)}function u5e(e,t){if(!hn(e))return Pr(Yi(e,t),n=>CO(n)||ZG(n))}Ta({errorCodes:[v.await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code,v.await_using_statements_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code,v.for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code],getCodeActions:function(t){let{sourceFile:n}=t,i=Sn.ChangeTracker.with(t,s=>{let o=U.createExportDeclaration(void 0,!1,U.createNamedExports([]),void 0);s.insertNodeAtEndOfScope(n,n,o)});return[_g("addEmptyExportDeclaration",i,v.Add_export_to_make_this_file_into_a_module)]}});var X1e="addMissingAsync",_5e=[v.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,v.Type_0_is_not_assignable_to_type_1.code,v.Type_0_is_not_comparable_to_type_1.code];Ta({fixIds:[X1e],errorCodes:_5e,getCodeActions:function(t){let{sourceFile:n,errorCode:i,cancellationToken:s,program:o,span:u}=t,m=Ln(o.getTypeChecker().getDiagnostics(n,s),KPt(u,i)),d=m&&m.relatedInformation&&Ln(m.relatedInformation,x=>x.code===v.Did_you_mean_to_mark_this_function_as_async.code),S=p5e(n,d);return S?[f5e(t,S,x=>Sn.ChangeTracker.with(t,x))]:void 0},getAllCodeActions:e=>{let{sourceFile:t}=e,n=new Set;return Ro(e,_5e,(i,s)=>{let o=s.relatedInformation&&Ln(s.relatedInformation,d=>d.code===v.Did_you_mean_to_mark_this_function_as_async.code),u=p5e(t,o);return u?f5e(e,u,d=>(d(i),[]),n):void 0})}});function f5e(e,t,n,i){let s=n(o=>YPt(o,e.sourceFile,t,i));return ta(X1e,s,v.Add_async_modifier_to_containing_function,X1e,v.Add_all_missing_async_modifiers)}function YPt(e,t,n,i){if(i&&i.has(yo(n)))return;i?.add(yo(n));let s=U.replaceModifiers(Co(n,!0),U.createNodeArray(U.createModifiersFromModifierFlags(Nv(n)|1024)));e.replaceNode(t,n,s)}function p5e(e,t){if(!t)return;let n=Yi(e,t.start);return Pr(n,s=>s.getStart(e)<t.start||s.getEnd()>bl(t)?"quit":(pc(s)||ul(s)||ic(s)||Tl(s))&&KN(t,df(s,e)))}function KPt(e,t){return({start:n,length:i,relatedInformation:s,code:o})=>O1(n)&&O1(i)&&KN({start:n,length:i},e)&&o===t&&!!s&&Pt(s,u=>u.code===v.Did_you_mean_to_mark_this_function_as_async.code)}var Q1e="addMissingAwait",d5e=v.Property_0_does_not_exist_on_type_1.code,m5e=[v.This_expression_is_not_callable.code,v.This_expression_is_not_constructable.code],Z1e=[v.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type.code,v.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type.code,v.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type.code,v.Operator_0_cannot_be_applied_to_type_1.code,v.Operator_0_cannot_be_applied_to_types_1_and_2.code,v.This_comparison_appears_to_be_unintentional_because_the_types_0_and_1_have_no_overlap.code,v.This_condition_will_always_return_true_since_this_0_is_always_defined.code,v.Type_0_is_not_an_array_type.code,v.Type_0_is_not_an_array_type_or_a_string_type.code,v.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher.code,v.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator.code,v.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator.code,v.Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator.code,v.Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator.code,v.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,d5e,...m5e];Ta({fixIds:[Q1e],errorCodes:Z1e,getCodeActions:function(t){let{sourceFile:n,errorCode:i,span:s,cancellationToken:o,program:u}=t,m=g5e(n,i,s,o,u);if(!m)return;let d=t.program.getTypeChecker(),S=E=>Sn.ChangeTracker.with(t,E);return cn([h5e(t,m,i,d,S),y5e(t,m,i,d,S)])},getAllCodeActions:e=>{let{sourceFile:t,program:n,cancellationToken:i}=e,s=e.program.getTypeChecker(),o=new Set;return Ro(e,Z1e,(u,m)=>{let d=g5e(t,m.code,m,i,n);if(!d)return;let S=E=>(E(u),[]);return h5e(e,d,m.code,s,S,o)||y5e(e,d,m.code,s,S,o)})}});function g5e(e,t,n,i,s){let o=ZQ(e,n);return o&&XPt(e,t,n,i,s)&&v5e(o)?o:void 0}function h5e(e,t,n,i,s,o){let{sourceFile:u,program:m,cancellationToken:d}=e,S=QPt(t,u,d,m,i);if(S){let E=s(x=>{kt(S.initializers,({expression:D})=>eSe(x,n,u,i,D,o)),o&&S.needsSecondPassForFixAll&&eSe(x,n,u,i,t,o)});return _g("addMissingAwaitToInitializer",E,S.initializers.length===1?[v.Add_await_to_initializer_for_0,S.initializers[0].declarationSymbol.name]:v.Add_await_to_initializers)}}function y5e(e,t,n,i,s,o){let u=s(m=>eSe(m,n,e.sourceFile,i,t,o));return ta(Q1e,u,v.Add_await,Q1e,v.Fix_all_expressions_possibly_missing_await)}function XPt(e,t,n,i,s){let u=s.getTypeChecker().getDiagnostics(e,i);return Pt(u,({start:m,length:d,relatedInformation:S,code:E})=>O1(m)&&O1(d)&&KN({start:m,length:d},n)&&E===t&&!!S&&Pt(S,x=>x.code===v.Did_you_forget_to_use_await.code))}function QPt(e,t,n,i,s){let o=ZPt(e,s);if(!o)return;let u=o.isCompleteFix,m;for(let d of o.identifiers){let S=s.getSymbolAtLocation(d);if(!S)continue;let E=ai(S.valueDeclaration,Ei),x=E&&ai(E.name,He),D=pb(E,243);if(!E||!D||E.type||!E.initializer||D.getSourceFile()!==t||li(D,32)||!x||!v5e(E.initializer)){u=!1;continue}let w=i.getSemanticDiagnostics(t,n);if(lc.Core.eachSymbolReferenceInFile(x,s,t,L=>d!==L&&!eNt(L,w,t,s))){u=!1;continue}(m||(m=[])).push({expression:E.initializer,declarationSymbol:S})}return m&&{initializers:m,needsSecondPassForFixAll:!u}}function ZPt(e,t){if(Wn(e.parent)&&He(e.parent.expression))return{identifiers:[e.parent.expression],isCompleteFix:!0};if(He(e))return{identifiers:[e],isCompleteFix:!0};if(Pn(e)){let n,i=!0;for(let s of[e.left,e.right]){let o=t.getTypeAtLocation(s);if(t.getPromisedTypeOfPromise(o)){if(!He(s)){i=!1;continue}(n||(n=[])).push(s)}}return n&&{identifiers:n,isCompleteFix:i}}}function eNt(e,t,n,i){let s=Wn(e.parent)?e.parent.name:Pn(e.parent)?e.parent:e,o=Ln(t,u=>u.start===s.getStart(n)&&u.start+u.length===s.getEnd());return o&&Es(Z1e,o.code)||i.getTypeAtLocation(s).flags&1}function v5e(e){return e.flags&65536||!!Pr(e,t=>t.parent&&pc(t.parent)&&t.parent.body===t||Vs(t)&&(t.parent.kind===262||t.parent.kind===218||t.parent.kind===219||t.parent.kind===174))}function eSe(e,t,n,i,s,o){if(f8(s.parent)&&!s.parent.awaitModifier){let u=i.getTypeAtLocation(s),m=i.getAsyncIterableType();if(m&&i.isTypeAssignableTo(u,m)){let d=s.parent;e.replaceNode(n,d,U.updateForOfStatement(d,U.createToken(135),d.initializer,d.expression,d.statement));return}}if(Pn(s))for(let u of[s.left,s.right]){if(o&&He(u)){let S=i.getSymbolAtLocation(u);if(S&&o.has(Aa(S)))continue}let m=i.getTypeAtLocation(u),d=i.getPromisedTypeOfPromise(m)?U.createAwaitExpression(u):u;e.replaceNode(n,u,d)}else if(t===d5e&&Wn(s.parent)){if(o&&He(s.parent.expression)){let u=i.getSymbolAtLocation(s.parent.expression);if(u&&o.has(Aa(u)))return}e.replaceNode(n,s.parent.expression,U.createParenthesizedExpression(U.createAwaitExpression(s.parent.expression))),S5e(e,s.parent.expression,n)}else if(Es(m5e,t)&&Ig(s.parent)){if(o&&He(s)){let u=i.getSymbolAtLocation(s);if(u&&o.has(Aa(u)))return}e.replaceNode(n,s,U.createParenthesizedExpression(U.createAwaitExpression(s))),S5e(e,s,n)}else{if(o&&Ei(s.parent)&&He(s.parent.name)){let u=i.getSymbolAtLocation(s.parent.name);if(u&&!Pg(o,Aa(u)))return}e.replaceNode(n,s,U.createAwaitExpression(s))}}function S5e(e,t,n){let i=iu(t.pos,n);i&&KU(i.end,i.parent,n)&&e.insertText(n,t.getStart(n),";")}var tSe="addMissingConst",b5e=[v.Cannot_find_name_0.code,v.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer.code];Ta({errorCodes:b5e,getCodeActions:function(t){let n=Sn.ChangeTracker.with(t,i=>T5e(i,t.sourceFile,t.span.start,t.program));if(n.length>0)return[ta(tSe,n,v.Add_const_to_unresolved_variable,tSe,v.Add_const_to_all_unresolved_variables)]},fixIds:[tSe],getAllCodeActions:e=>{let t=new Set;return Ro(e,b5e,(n,i)=>T5e(n,i.file,i.start,e.program,t))}});function T5e(e,t,n,i,s){let o=Yi(t,n),u=Pr(o,S=>$x(S.parent)?S.parent.initializer===S:tNt(S)?!1:"quit");if(u)return YZ(e,u,t,s);let m=o.parent;if(Pn(m)&&m.operatorToken.kind===64&&Du(m.parent))return YZ(e,o,t,s);if(Gu(m)){let S=i.getTypeChecker();return wi(m.elements,E=>rNt(E,S))?YZ(e,m,t,s):void 0}let d=Pr(o,S=>Du(S.parent)?!0:nNt(S)?!1:"quit");if(d){let S=i.getTypeChecker();return E5e(d,S)?YZ(e,d,t,s):void 0}}function YZ(e,t,n,i){(!i||Pg(i,t))&&e.insertModifierBefore(n,87,t)}function tNt(e){switch(e.kind){case 80:case 209:case 210:case 303:case 304:return!0;default:return!1}}function rNt(e,t){let n=He(e)?e:Su(e,!0)&&He(e.left)?e.left:void 0;return!!n&&!t.getSymbolAtLocation(n)}function nNt(e){switch(e.kind){case 80:case 226:case 28:return!0;default:return!1}}function E5e(e,t){return Pn(e)?e.operatorToken.kind===28?wi([e.left,e.right],n=>E5e(n,t)):e.operatorToken.kind===64&&He(e.left)&&!t.getSymbolAtLocation(e.left):!1}var rSe="addMissingDeclareProperty",x5e=[v.Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration.code];Ta({errorCodes:x5e,getCodeActions:function(t){let n=Sn.ChangeTracker.with(t,i=>C5e(i,t.sourceFile,t.span.start));if(n.length>0)return[ta(rSe,n,v.Prefix_with_declare,rSe,v.Prefix_all_incorrect_property_declarations_with_declare)]},fixIds:[rSe],getAllCodeActions:e=>{let t=new Set;return Ro(e,x5e,(n,i)=>C5e(n,i.file,i.start,t))}});function C5e(e,t,n,i){let s=Yi(t,n);if(!He(s))return;let o=s.parent;o.kind===172&&(!i||Pg(i,o))&&e.insertModifierBefore(t,138,o)}var nSe="addMissingInvocationForDecorator",A5e=[v._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0.code];Ta({errorCodes:A5e,getCodeActions:function(t){let n=Sn.ChangeTracker.with(t,i=>k5e(i,t.sourceFile,t.span.start));return[ta(nSe,n,v.Call_decorator_expression,nSe,v.Add_to_all_uncalled_decorators)]},fixIds:[nSe],getAllCodeActions:e=>Ro(e,A5e,(t,n)=>k5e(t,n.file,n.start))});function k5e(e,t,n){let i=Yi(t,n),s=Pr(i,fu);M.assert(!!s,"Expected position to be owned by a decorator.");let o=U.createCallExpression(s.expression,void 0,void 0);e.replaceNode(t,s.expression,o)}var iSe="addNameToNamelessParameter",P5e=[v.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1.code];Ta({errorCodes:P5e,getCodeActions:function(t){let n=Sn.ChangeTracker.with(t,i=>N5e(i,t.sourceFile,t.span.start));return[ta(iSe,n,v.Add_parameter_name,iSe,v.Add_names_to_all_parameters_without_names)]},fixIds:[iSe],getAllCodeActions:e=>Ro(e,P5e,(t,n)=>N5e(t,n.file,n.start))});function N5e(e,t,n){let i=Yi(t,n),s=i.parent;if(!ns(s))return M.fail("Tried to add a parameter name to a non-parameter: "+M.formatSyntaxKind(i.kind));let o=s.parent.parameters.indexOf(s);M.assert(!s.type,"Tried to add a parameter name to a parameter that already had one."),M.assert(o>-1,"Parameter not found in parent parameter list.");let u=s.name.getEnd(),m=U.createTypeReferenceNode(s.name,void 0),d=D5e(t,s);for(;d;)m=U.createArrayTypeNode(m),u=d.getEnd(),d=D5e(t,d);let S=U.createParameterDeclaration(s.modifiers,s.dotDotDotToken,"arg"+o,s.questionToken,s.dotDotDotToken&&!_8(m)?U.createArrayTypeNode(m):m,s.initializer);e.replaceRange(t,Td(s.getStart(t),u),S)}function D5e(e,t){let n=NE(t.name,t.parent,e);if(n&&n.kind===23&&Lv(n.parent)&&ns(n.parent.parent))return n.parent.parent}var w5e="addOptionalPropertyUndefined",iNt=[v.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target.code,v.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code,v.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code];Ta({errorCodes:iNt,getCodeActions(e){let t=e.program.getTypeChecker(),n=sNt(e.sourceFile,e.span,t);if(!n.length)return;let i=Sn.ChangeTracker.with(e,s=>oNt(s,n));return[_g(w5e,i,v.Add_undefined_to_optional_property_type)]},fixIds:[w5e]});function sNt(e,t,n){var i,s;let o=I5e(ZQ(e,t),n);if(!o)return ve;let{source:u,target:m}=o,d=aNt(u,m,n)?n.getTypeAtLocation(m.expression):n.getTypeAtLocation(m);return(s=(i=d.symbol)==null?void 0:i.declarations)!=null&&s.some(S=>Ur(S).fileName.match(/\.d\.ts$/))?ve:n.getExactOptionalProperties(d)}function aNt(e,t,n){return Wn(t)&&!!n.getExactOptionalProperties(n.getTypeAtLocation(t.expression)).length&&n.getTypeAtLocation(e)===n.getUndefinedType()}function I5e(e,t){var n;if(e){if(Pn(e.parent)&&e.parent.operatorToken.kind===64)return{source:e.parent.right,target:e.parent.left};if(Ei(e.parent)&&e.parent.initializer)return{source:e.parent.initializer,target:e.parent.name};if(ea(e.parent)){let i=t.getSymbolAtLocation(e.parent.expression);if(!i?.valueDeclaration||!YC(i.valueDeclaration.kind)||!Ct(e))return;let s=e.parent.arguments.indexOf(e);if(s===-1)return;let o=i.valueDeclaration.parameters[s].name;if(He(o))return{source:e,target:o}}else if(ql(e.parent)&&He(e.parent.name)||p_(e.parent)){let i=I5e(e.parent.parent,t);if(!i)return;let s=t.getPropertyOfType(t.getTypeAtLocation(i.target),e.parent.name.text),o=(n=s?.declarations)==null?void 0:n[0];return o?{source:ql(e.parent)?e.parent.initializer:e.parent.name,target:o}:void 0}}else return}function oNt(e,t){for(let n of t){let i=n.valueDeclaration;if(i&&(Nf(i)||Ns(i))&&i.type){let s=U.createUnionTypeNode([...i.type.kind===192?i.type.types:[i.type],U.createTypeReferenceNode("undefined")]);e.replaceNode(i.getSourceFile(),i.type,s)}}}var sSe="annotateWithTypeFromJSDoc",O5e=[v.JSDoc_types_may_be_moved_to_TypeScript_types.code];Ta({errorCodes:O5e,getCodeActions(e){let t=R5e(e.sourceFile,e.span.start);if(!t)return;let n=Sn.ChangeTracker.with(e,i=>F5e(i,e.sourceFile,t));return[ta(sSe,n,v.Annotate_with_type_from_JSDoc,sSe,v.Annotate_everything_with_types_from_JSDoc)]},fixIds:[sSe],getAllCodeActions:e=>Ro(e,O5e,(t,n)=>{let i=R5e(n.file,n.start);i&&F5e(t,n.file,i)})});function R5e(e,t){let n=Yi(e,t);return ai(ns(n.parent)?n.parent.parent:n.parent,M5e)}function M5e(e){return cNt(e)&&L5e(e)}function L5e(e){return Go(e)?e.parameters.some(L5e)||!e.type&&!!I3(e):!e.type&&!!rb(e)}function F5e(e,t,n){if(Go(n)&&(I3(n)||n.parameters.some(i=>!!rb(i)))){if(!n.typeParameters){let s=w9(n);s.length&&e.insertTypeParameters(t,n,s)}let i=pc(n)&&!Oo(n,21,t);i&&e.insertNodeBefore(t,Ma(n.parameters),U.createToken(21));for(let s of n.parameters)if(!s.type){let o=rb(s);o&&e.tryInsertTypeAnnotation(t,s,ot(o,ME,Di))}if(i&&e.insertNodeAfter(t,Va(n.parameters),U.createToken(22)),!n.type){let s=I3(n);s&&e.tryInsertTypeAnnotation(t,n,ot(s,ME,Di))}}else{let i=M.checkDefined(rb(n),"A JSDocType for this declaration should exist");M.assert(!n.type,"The JSDocType decl should have a type"),e.tryInsertTypeAnnotation(t,n,ot(i,ME,Di))}}function cNt(e){return Go(e)||e.kind===260||e.kind===171||e.kind===172}function ME(e){switch(e.kind){case 312:case 313:return U.createTypeReferenceNode("any",ve);case 316:return uNt(e);case 315:return ME(e.type);case 314:return _Nt(e);case 318:return fNt(e);case 317:return pNt(e);case 183:return mNt(e);case 322:return lNt(e);default:let t=Mr(e,ME,void 0);return Tn(t,1),t}}function lNt(e){let t=U.createTypeLiteralNode(Cr(e.jsDocPropertyTags,n=>U.createPropertySignature(void 0,He(n.name)?n.name:n.name.right,QR(n)?U.createToken(58):void 0,n.typeExpression&&ot(n.typeExpression.type,ME,Di)||U.createKeywordTypeNode(133))));return Tn(t,1),t}function uNt(e){return U.createUnionTypeNode([ot(e.type,ME,Di),U.createTypeReferenceNode("undefined",ve)])}function _Nt(e){return U.createUnionTypeNode([ot(e.type,ME,Di),U.createTypeReferenceNode("null",ve)])}function fNt(e){return U.createArrayTypeNode(ot(e.type,ME,Di))}function pNt(e){return U.createFunctionTypeNode(ve,e.parameters.map(dNt),e.type??U.createKeywordTypeNode(133))}function dNt(e){let t=e.parent.parameters.indexOf(e),n=e.type.kind===318&&t===e.parent.parameters.length-1,i=e.name||(n?"rest":"arg"+t),s=n?U.createToken(26):e.dotDotDotToken;return U.createParameterDeclaration(e.modifiers,s,i,e.questionToken,ot(e.type,ME,Di),e.initializer)}function mNt(e){let t=e.typeName,n=e.typeArguments;if(He(e.typeName)){if(p9(e))return gNt(e);let i=e.typeName.text;switch(e.typeName.text){case"String":case"Boolean":case"Object":case"Number":i=i.toLowerCase();break;case"array":case"date":case"promise":i=i[0].toUpperCase()+i.slice(1);break}t=U.createIdentifier(i),(i==="Array"||i==="Promise")&&!e.typeArguments?n=U.createNodeArray([U.createTypeReferenceNode("any",ve)]):n=Kr(e.typeArguments,ME,Di)}return U.createTypeReferenceNode(t,n)}function gNt(e){let t=U.createParameterDeclaration(void 0,void 0,e.typeArguments[0].kind===150?"n":"s",void 0,U.createTypeReferenceNode(e.typeArguments[0].kind===150?"number":"string",[]),void 0),n=U.createTypeLiteralNode([U.createIndexSignature(void 0,[t],e.typeArguments[1])]);return Tn(n,1),n}var aSe="convertFunctionToEs6Class",j5e=[v.This_constructor_function_may_be_converted_to_a_class_declaration.code];Ta({errorCodes:j5e,getCodeActions(e){let t=Sn.ChangeTracker.with(e,n=>B5e(n,e.sourceFile,e.span.start,e.program.getTypeChecker(),e.preferences,e.program.getCompilerOptions()));return[ta(aSe,t,v.Convert_function_to_an_ES2015_class,aSe,v.Convert_all_constructor_functions_to_classes)]},fixIds:[aSe],getAllCodeActions:e=>Ro(e,j5e,(t,n)=>B5e(t,n.file,n.start,e.program.getTypeChecker(),e.preferences,e.program.getCompilerOptions()))});function B5e(e,t,n,i,s,o){let u=i.getSymbolAtLocation(Yi(t,n));if(!u||!u.valueDeclaration||!(u.flags&19))return;let m=u.valueDeclaration;if(Tl(m)||ic(m))e.replaceNode(t,m,E(m));else if(Ei(m)){let x=S(m);if(!x)return;let D=m.parent.parent;Ru(m.parent)&&m.parent.declarations.length>1?(e.delete(t,m),e.insertNodeAfter(t,D,x)):e.replaceNode(t,D,x)}function d(x){let D=[];return x.exports&&x.exports.forEach(L=>{if(L.name==="prototype"&&L.declarations){let F=L.declarations[0];if(L.declarations.length===1&&Wn(F)&&Pn(F.parent)&&F.parent.operatorToken.kind===64&&Ca(F.parent.right)){let J=F.parent.right;R(J.symbol,void 0,D)}}else R(L,[U.createToken(126)],D)}),x.members&&x.members.forEach((L,F)=>{var J,G,q,ee;if(F==="constructor"&&L.valueDeclaration){let W=(ee=(q=(G=(J=x.exports)==null?void 0:J.get("prototype"))==null?void 0:G.declarations)==null?void 0:q[0])==null?void 0:ee.parent;W&&Pn(W)&&Ca(W.right)&&Pt(W.right.properties,XZ)||e.delete(t,L.valueDeclaration.parent);return}R(L,void 0,D)}),D;function w(L,F){return oc(L)?Wn(L)&&XZ(L)?!0:Bs(F):wi(L.properties,J=>!!(ul(J)||M3(J)||ql(J)&&ic(J.initializer)&&J.name||XZ(J)))}function R(L,F,J){if(!(L.flags&8192)&&!(L.flags&4096))return;let G=L.valueDeclaration,q=G.parent,ee=q.right;if(!w(G,ee)||Pt(J,ue=>{let ce=Ps(ue);return!!(ce&&He(ce)&&Nn(ce)===Qc(L))}))return;let W=q.parent&&q.parent.kind===244?q.parent:q;if(e.delete(t,W),!ee){J.push(U.createPropertyDeclaration(F,L.name,void 0,void 0,void 0));return}if(oc(G)&&(ic(ee)||pc(ee))){let ue=ed(t,s),ce=hNt(G,o,ue);ce&&pe(J,ee,ce);return}else if(Ca(ee)){kt(ee.properties,ue=>{(ul(ue)||M3(ue))&&J.push(ue),ql(ue)&&ic(ue.initializer)&&pe(J,ue.initializer,ue.name),XZ(ue)});return}else{if(Af(t)||!Wn(G))return;let ue=U.createPropertyDeclaration(F,G.name,void 0,void 0,ee);QN(q.parent,ue,t),J.push(ue);return}function pe(ue,ce,ne){return ic(ce)?K(ue,ce,ne):re(ue,ce,ne)}function K(ue,ce,ne){let le=ps(F,KZ(ce,134)),me=U.createMethodDeclaration(le,void 0,ne,void 0,void 0,ce.parameters,void 0,ce.body);QN(q,me,t),ue.push(me)}function re(ue,ce,ne){let le=ce.body,me;le.kind===241?me=le:me=U.createBlock([U.createReturnStatement(le)]);let de=ps(F,KZ(ce,134)),Ae=U.createMethodDeclaration(de,void 0,ne,void 0,void 0,ce.parameters,void 0,me);QN(q,Ae,t),ue.push(Ae)}}}function S(x){let D=x.initializer;if(!D||!ic(D)||!He(x.name))return;let w=d(x.symbol);D.body&&w.unshift(U.createConstructorDeclaration(void 0,D.parameters,D.body));let R=KZ(x.parent.parent,95);return U.createClassDeclaration(R,x.name,void 0,void 0,w)}function E(x){let D=d(u);x.body&&D.unshift(U.createConstructorDeclaration(void 0,x.parameters,x.body));let w=KZ(x,95);return U.createClassDeclaration(w,x.name,void 0,void 0,D)}}function KZ(e,t){return wm(e)?Zn(e.modifiers,n=>n.kind===t):void 0}function XZ(e){return e.name?!!(He(e.name)&&e.name.text==="constructor"):!1}function hNt(e,t,n){if(Wn(e))return e.name;let i=e.argumentExpression;if(Pf(i))return i;if(No(i))return sp(i.text,Ka(t))?U.createIdentifier(i.text):wA(i)?U.createStringLiteral(i.text,n===0):i}var oSe="convertToAsyncFunction",U5e=[v.This_may_be_converted_to_an_async_function.code],QZ=!0;Ta({errorCodes:U5e,getCodeActions(e){QZ=!0;let t=Sn.ChangeTracker.with(e,n=>V5e(n,e.sourceFile,e.span.start,e.program.getTypeChecker()));return QZ?[ta(oSe,t,v.Convert_to_async_function,oSe,v.Convert_all_to_async_functions)]:[]},fixIds:[oSe],getAllCodeActions:e=>Ro(e,U5e,(t,n)=>V5e(t,n.file,n.start,e.program.getTypeChecker()))});function V5e(e,t,n,i){let s=Yi(t,n),o;if(He(s)&&Ei(s.parent)&&s.parent.initializer&&Go(s.parent.initializer)?o=s.parent.initializer:o=ai(Dp(Yi(t,n)),SZ),!o)return;let u=new Map,m=hn(o),d=vNt(o,i),S=SNt(o,i,u);if(!yZ(S,i))return;let E=S.body&&Vs(S.body)?yNt(S.body,i):ve,x={checker:i,synthNamesMap:u,setOfExpressionsToReturn:d,isInJSFile:m};if(!E.length)return;let D=Ja(t.text,Jg(o).pos);e.insertModifierAt(t,D,134,{suffix:" "});for(let w of E)if(Js(w,function R(L){if(ea(L)){let F=sD(L,L,x,!1);if(pk())return!0;e.replaceNodeWithNodes(t,w,F)}else if(!Bs(L)&&(Js(L,R),pk()))return!0}),pk())return}function yNt(e,t){let n=[];return xv(e,i=>{fV(i,t)&&n.push(i)}),n}function vNt(e,t){if(!e.body)return new Set;let n=new Set;return Js(e.body,function i(s){jM(s,t,"then")?(n.add(yo(s)),kt(s.arguments,i)):jM(s,t,"catch")||jM(s,t,"finally")?(n.add(yo(s)),Js(s,i)):q5e(s,t)?n.add(yo(s)):Js(s,i)}),n}function jM(e,t,n){if(!ea(e))return!1;let s=aM(e,n)&&t.getTypeAtLocation(e);return!!(s&&t.getPromisedTypeOfPromise(s))}function J5e(e,t){return(Kn(e)&4)!==0&&e.target===t}function ZZ(e,t,n){if(e.expression.name.escapedText==="finally")return;let i=n.getTypeAtLocation(e.expression.expression);if(J5e(i,n.getPromiseType())||J5e(i,n.getPromiseLikeType()))if(e.expression.name.escapedText==="then"){if(t===Dl(e.arguments,0))return Dl(e.typeArguments,0);if(t===Dl(e.arguments,1))return Dl(e.typeArguments,1)}else return Dl(e.typeArguments,0)}function q5e(e,t){return Ct(e)?!!t.getPromisedTypeOfPromise(t.getTypeAtLocation(e)):!1}function SNt(e,t,n){let i=new Map,s=yd();return Js(e,function o(u){if(!He(u)){Js(u,o);return}let m=t.getSymbolAtLocation(u);if(m){let d=t.getTypeAtLocation(u),S=Y5e(d,t),E=Aa(m).toString();if(S&&!ns(u.parent)&&!Go(u.parent)&&!n.has(E)){let x=xo(S.parameters),D=x?.valueDeclaration&&ns(x.valueDeclaration)&&ai(x.valueDeclaration.name,He)||U.createUniqueName("result",16),w=z5e(D,s);n.set(E,w),s.add(D.text,m)}else if(u.parent&&(ns(u.parent)||Ei(u.parent)||Xa(u.parent))){let x=u.text,D=s.get(x);if(D&&D.some(w=>w!==m)){let w=z5e(u,s);i.set(E,w.identifier),n.set(E,w),s.add(x,m)}else{let w=Co(u);n.set(E,D6(w)),s.add(x,m)}}}}),SM(e,!0,o=>{if(Xa(o)&&He(o.name)&&Yp(o.parent)){let u=t.getSymbolAtLocation(o.name),m=u&&i.get(String(Aa(u)));if(m&&m.text!==(o.name||o.propertyName).getText())return U.createBindingElement(o.dotDotDotToken,o.propertyName||o.name,m,o.initializer)}else if(He(o)){let u=t.getSymbolAtLocation(o),m=u&&i.get(String(Aa(u)));if(m)return U.createIdentifier(m.text)}})}function z5e(e,t){let n=(t.get(e.text)||ve).length,i=n===0?e:U.createIdentifier(e.text+"_"+n);return D6(i)}function pk(){return!QZ}function Fb(){return QZ=!1,ve}function sD(e,t,n,i,s){if(jM(t,n.checker,"then"))return ENt(t,Dl(t.arguments,0),Dl(t.arguments,1),n,i,s);if(jM(t,n.checker,"catch"))return H5e(t,Dl(t.arguments,0),n,i,s);if(jM(t,n.checker,"finally"))return TNt(t,Dl(t.arguments,0),n,i,s);if(Wn(t))return sD(e,t.expression,n,i,s);let o=n.checker.getTypeAtLocation(t);return o&&n.checker.getPromisedTypeOfPromise(o)?(M.assertNode(Bc(t).parent,Wn),xNt(e,t,n,i,s)):Fb()}function eee({checker:e},t){if(t.kind===106)return!0;if(He(t)&&!xc(t)&&Nn(t)==="undefined"){let n=e.getSymbolAtLocation(t);return!n||e.isUndefinedSymbol(n)}return!1}function bNt(e){let t=U.createUniqueName(e.identifier.text,16);return D6(t)}function W5e(e,t,n){let i;return n&&!UM(e,t)&&(BM(n)?(i=n,t.synthNamesMap.forEach((s,o)=>{if(s.identifier.text===n.identifier.text){let u=bNt(n);t.synthNamesMap.set(o,u)}})):i=D6(U.createUniqueName("result",16),n.types),_Se(i)),i}function $5e(e,t,n,i,s){let o=[],u;if(i&&!UM(e,t)){u=Co(_Se(i));let m=i.types,d=t.checker.getUnionType(m,2),S=t.isInJSFile?void 0:t.checker.typeToTypeNode(d,void 0,void 0),E=[U.createVariableDeclaration(u,void 0,S)],x=U.createVariableStatement(void 0,U.createVariableDeclarationList(E,1));o.push(x)}return o.push(n),s&&u&&kNt(s)&&o.push(U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(Co(Z5e(s)),void 0,void 0,u)],2))),o}function TNt(e,t,n,i,s){if(!t||eee(n,t))return sD(e,e.expression.expression,n,i,s);let o=W5e(e,n,s),u=sD(e,e.expression.expression,n,!0,o);if(pk())return Fb();let m=lSe(t,i,void 0,void 0,e,n);if(pk())return Fb();let d=U.createBlock(u),S=U.createBlock(m),E=U.createTryStatement(d,void 0,S);return $5e(e,n,E,o,s)}function H5e(e,t,n,i,s){if(!t||eee(n,t))return sD(e,e.expression.expression,n,i,s);let o=X5e(t,n),u=W5e(e,n,s),m=sD(e,e.expression.expression,n,!0,u);if(pk())return Fb();let d=lSe(t,i,u,o,e,n);if(pk())return Fb();let S=U.createBlock(m),E=U.createCatchClause(o&&Co(NV(o)),U.createBlock(d)),x=U.createTryStatement(S,E,void 0);return $5e(e,n,x,u,s)}function ENt(e,t,n,i,s,o){if(!t||eee(i,t))return H5e(e,n,i,s,o);if(n&&!eee(i,n))return Fb();let u=X5e(t,i),m=sD(e.expression.expression,e.expression.expression,i,!0,u);if(pk())return Fb();let d=lSe(t,s,o,u,e,i);return pk()?Fb():ps(m,d)}function xNt(e,t,n,i,s){if(UM(e,n)){let o=Co(t);return i&&(o=U.createAwaitExpression(o)),[U.createReturnStatement(o)]}return tee(s,U.createAwaitExpression(t),void 0)}function tee(e,t,n){return!e||Q5e(e)?[U.createExpressionStatement(t)]:BM(e)&&e.hasBeenDeclared?[U.createExpressionStatement(U.createAssignment(Co(uSe(e)),t))]:[U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(Co(NV(e)),void 0,n,t)],2))]}function cSe(e,t){if(t&&e){let n=U.createUniqueName("result",16);return[...tee(D6(n),e,t),U.createReturnStatement(n)]}return[U.createReturnStatement(e)]}function lSe(e,t,n,i,s,o){var u;switch(e.kind){case 106:break;case 211:case 80:if(!i)break;let m=U.createCallExpression(Co(e),void 0,BM(i)?[uSe(i)]:[]);if(UM(s,o))return cSe(m,ZZ(s,e,o.checker));let d=o.checker.getTypeAtLocation(e),S=o.checker.getSignaturesOfType(d,0);if(!S.length)return Fb();let E=S[0].getReturnType(),x=tee(n,U.createAwaitExpression(m),ZZ(s,e,o.checker));return n&&n.types.push(o.checker.getAwaitedType(E)||E),x;case 218:case 219:{let D=e.body,w=(u=Y5e(o.checker.getTypeAtLocation(e),o.checker))==null?void 0:u.getReturnType();if(Vs(D)){let R=[],L=!1;for(let F of D.statements)if(nm(F))if(L=!0,fV(F,o.checker))R=R.concat(K5e(o,F,t,n));else{let J=w&&F.expression?G5e(o.checker,w,F.expression):F.expression;R.push(...cSe(J,ZZ(s,e,o.checker)))}else{if(t&&xv(F,YS))return Fb();R.push(F)}return UM(s,o)?R.map(F=>Co(F)):CNt(R,n,o,L)}else{let R=vZ(D,o.checker)?K5e(o,U.createReturnStatement(D),t,n):ve;if(R.length>0)return R;if(w){let L=G5e(o.checker,w,D);if(UM(s,o))return cSe(L,ZZ(s,e,o.checker));{let F=tee(n,L,void 0);return n&&n.types.push(o.checker.getAwaitedType(w)||w),F}}else return Fb()}}default:return Fb()}return ve}function G5e(e,t,n){let i=Co(n);return e.getPromisedTypeOfPromise(t)?U.createAwaitExpression(i):i}function Y5e(e,t){let n=t.getSignaturesOfType(e,0);return vc(n)}function CNt(e,t,n,i){let s=[];for(let o of e)if(nm(o)){if(o.expression){let u=q5e(o.expression,n.checker)?U.createAwaitExpression(o.expression):o.expression;t===void 0?s.push(U.createExpressionStatement(u)):BM(t)&&t.hasBeenDeclared?s.push(U.createExpressionStatement(U.createAssignment(uSe(t),u))):s.push(U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(NV(t),void 0,void 0,u)],2)))}}else s.push(Co(o));return!i&&t!==void 0&&s.push(U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(NV(t),void 0,void 0,U.createIdentifier("undefined"))],2))),s}function K5e(e,t,n,i){let s=[];return Js(t,function o(u){if(ea(u)){let m=sD(u,u,e,n,i);if(s=s.concat(m),s.length>0)return}else Bs(u)||Js(u,o)}),s}function X5e(e,t){let n=[],i;if(Go(e)){if(e.parameters.length>0){let d=e.parameters[0].name;i=s(d)}}else He(e)?i=o(e):Wn(e)&&He(e.name)&&(i=o(e.name));if(!i||"identifier"in i&&i.identifier.text==="undefined")return;return i;function s(d){if(He(d))return o(d);let S=va(d.elements,E=>pu(E)?[]:[s(E.name)]);return ANt(d,S)}function o(d){let S=m(d),E=u(S);return E&&t.synthNamesMap.get(Aa(E).toString())||D6(d,n)}function u(d){var S;return((S=ai(d,Zm))==null?void 0:S.symbol)??t.checker.getSymbolAtLocation(d)}function m(d){return d.original?d.original:d}}function Q5e(e){return e?BM(e)?!e.identifier.text:wi(e.elements,Q5e):!0}function D6(e,t=[]){return{kind:0,identifier:e,types:t,hasBeenDeclared:!1,hasBeenReferenced:!1}}function ANt(e,t=ve,n=[]){return{kind:1,bindingPattern:e,elements:t,types:n}}function uSe(e){return e.hasBeenReferenced=!0,e.identifier}function NV(e){return BM(e)?_Se(e):Z5e(e)}function Z5e(e){for(let t of e.elements)NV(t);return e.bindingPattern}function _Se(e){return e.hasBeenDeclared=!0,e.identifier}function BM(e){return e.kind===0}function kNt(e){return e.kind===1}function UM(e,t){return!!e.original&&t.setOfExpressionsToReturn.has(yo(e.original))}Ta({errorCodes:[v.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module.code],getCodeActions(e){let{sourceFile:t,program:n,preferences:i}=e,s=Sn.ChangeTracker.with(e,o=>{if(NNt(t,n.getTypeChecker(),o,Ka(n.getCompilerOptions()),ed(t,i)))for(let m of n.getSourceFiles())PNt(m,t,n,o,ed(m,i))});return[_g("convertToEsModule",s,v.Convert_to_ES_module)]}});function PNt(e,t,n,i,s){var o;for(let u of e.imports){let m=(o=n.getResolvedModuleFromModuleSpecifier(u,e))==null?void 0:o.resolvedModule;if(!m||m.resolvedFileName!==t.fileName)continue;let d=LI(u);switch(d.kind){case 271:i.replaceNode(e,d,uS(d.name,void 0,u,s));break;case 213:kf(d,!1)&&i.replaceNode(e,d,U.createPropertyAccessExpression(Co(d),"default"));break}}}function NNt(e,t,n,i,s){let o={original:JNt(e),additional:new Set},u=DNt(e,t,o);wNt(e,u,n);let m=!1,d;for(let S of Zn(e.statements,_l)){let E=t9e(e,S,n,t,o,i,s);E&&V5(E,d??(d=new Map))}for(let S of Zn(e.statements,E=>!_l(E))){let E=INt(e,S,t,n,o,i,u,d,s);m=m||E}return d?.forEach((S,E)=>{n.replaceNode(e,E,S)}),m}function DNt(e,t,n){let i=new Map;return e9e(e,s=>{let{text:o}=s.name;!i.has(o)&&(RH(s.name)||t.resolveName(o,s,111551,!0))&&i.set(o,ree(`_${o}`,n))}),i}function wNt(e,t,n){e9e(e,(i,s)=>{if(s)return;let{text:o}=i.name;n.replaceNode(e,i,U.createIdentifier(t.get(o)||o))})}function e9e(e,t){e.forEachChild(function n(i){if(Wn(i)&&EE(e,i.expression)&&He(i.name)){let{parent:s}=i;t(i,Pn(s)&&s.left===i&&s.operatorToken.kind===64)}i.forEachChild(n)})}function INt(e,t,n,i,s,o,u,m,d){switch(t.kind){case 243:return t9e(e,t,i,n,s,o,d),!1;case 244:{let{expression:S}=t;switch(S.kind){case 213:return kf(S,!0)&&i.replaceNode(e,t,uS(void 0,void 0,S.arguments[0],d)),!1;case 226:{let{operatorToken:E}=S;return E.kind===64&&RNt(e,n,S,i,u,m)}}}default:return!1}}function t9e(e,t,n,i,s,o,u){let{declarationList:m}=t,d=!1,S=Cr(m.declarations,E=>{let{name:x,initializer:D}=E;if(D){if(EE(e,D))return d=!0,w6([]);if(kf(D,!0))return d=!0,UNt(x,D.arguments[0],i,s,o,u);if(Wn(D)&&kf(D.expression,!0))return d=!0,ONt(x,D.name.text,D.expression.arguments[0],s,u)}return w6([U.createVariableStatement(void 0,U.createVariableDeclarationList([E],m.flags))])});if(d){n.replaceNodeWithNodes(e,t,va(S,x=>x.newImports));let E;return kt(S,x=>{x.useSitesToUnqualify&&V5(x.useSitesToUnqualify,E??(E=new Map))}),E}}function ONt(e,t,n,i,s){switch(e.kind){case 206:case 207:{let o=ree(t,i);return w6([s9e(o,t,n,s),nee(void 0,e,U.createIdentifier(o))])}case 80:return w6([s9e(e.text,t,n,s)]);default:return M.assertNever(e,`Convert to ES module got invalid syntax form ${e.kind}`)}}function RNt(e,t,n,i,s,o){let{left:u,right:m}=n;if(!Wn(u))return!1;if(EE(e,u))if(EE(e,m))i.delete(e,n.parent);else{let d=Ca(m)?MNt(m,o):kf(m,!0)?FNt(m.arguments[0],t):void 0;return d?(i.replaceNodeWithNodes(e,n.parent,d[0]),d[1]):(i.replaceRangeWithText(e,Td(u.getStart(e),m.pos),"export default"),!0)}else EE(e,u.expression)&&LNt(e,n,i,s);return!1}function MNt(e,t){let n=Ww(e.properties,i=>{switch(i.kind){case 177:case 178:case 304:case 305:return;case 303:return He(i.name)?BNt(i.name.text,i.initializer,t):void 0;case 174:return He(i.name)?i9e(i.name.text,[U.createToken(95)],i,t):void 0;default:M.assertNever(i,`Convert to ES6 got invalid prop kind ${i.kind}`)}});return n&&[n,!1]}function LNt(e,t,n,i){let{text:s}=t.left.name,o=i.get(s);if(o!==void 0){let u=[nee(void 0,o,t.right),dSe([U.createExportSpecifier(!1,o,s)])];n.replaceNodeWithNodes(e,t.parent,u)}else jNt(t,e,n)}function FNt(e,t){let n=e.text,i=t.getSymbolAtLocation(e),s=i?i.exports:lr;return s.has("export=")?[[fSe(n)],!0]:s.has("default")?s.size>1?[[r9e(n),fSe(n)],!0]:[[fSe(n)],!0]:[[r9e(n)],!1]}function r9e(e){return dSe(void 0,e)}function fSe(e){return dSe([U.createExportSpecifier(!1,void 0,"default")],e)}function jNt({left:e,right:t,parent:n},i,s){let o=e.name.text;if((ic(t)||pc(t)||eu(t))&&(!t.name||t.name.text===o)){s.replaceRange(i,{pos:e.getStart(i),end:t.getStart(i)},U.createToken(95),{suffix:" "}),t.name||s.insertName(i,t,o);let u=Oo(n,27,i);u&&s.delete(i,u)}else s.replaceNodeRangeWithNodes(i,e.expression,Oo(e,25,i),[U.createToken(95),U.createToken(87)],{joiner:" ",suffix:" "})}function BNt(e,t,n){let i=[U.createToken(95)];switch(t.kind){case 218:{let{name:o}=t;if(o&&o.text!==e)return s()}case 219:return i9e(e,i,t,n);case 231:return zNt(e,i,t,n);default:return s()}function s(){return nee(i,U.createIdentifier(e),pSe(t,n))}}function pSe(e,t){if(!t||!Pt(Is(t.keys()),i=>Zp(e,i)))return e;return Rs(e)?zQ(e,!0,n):SM(e,!0,n);function n(i){if(i.kind===211){let s=t.get(i);return t.delete(i),s}}}function UNt(e,t,n,i,s,o){switch(e.kind){case 206:{let u=Ww(e.elements,m=>m.dotDotDotToken||m.initializer||m.propertyName&&!He(m.propertyName)||!He(m.name)?void 0:a9e(m.propertyName&&m.propertyName.text,m.name.text));if(u)return w6([uS(void 0,u,t,o)])}case 207:{let u=ree(AM(t.text,s),i);return w6([uS(U.createIdentifier(u),void 0,t,o),nee(void 0,Co(e),U.createIdentifier(u))])}case 80:return VNt(e,t,n,i,o);default:return M.assertNever(e,`Convert to ES module got invalid name kind ${e.kind}`)}}function VNt(e,t,n,i,s){let o=n.getSymbolAtLocation(e),u=new Map,m=!1,d;for(let E of i.original.get(e.text)){if(n.getSymbolAtLocation(E)!==o||E===e)continue;let{parent:x}=E;if(Wn(x)){let{name:{text:D}}=x;if(D==="default"){m=!0;let w=E.getText();(d??(d=new Map)).set(x,U.createIdentifier(w))}else{M.assert(x.expression===E,"Didn't expect expression === use");let w=u.get(D);w===void 0&&(w=ree(D,i),u.set(D,w)),(d??(d=new Map)).set(x,U.createIdentifier(w))}}else m=!0}let S=u.size===0?void 0:Is(Ix(u.entries(),([E,x])=>U.createImportSpecifier(!1,E===x?void 0:U.createIdentifier(E),U.createIdentifier(x))));return S||(m=!0),w6([uS(m?Co(e):void 0,S,t,s)],d)}function ree(e,t){for(;t.original.has(e)||t.additional.has(e);)e=`_${e}`;return t.additional.add(e),e}function JNt(e){let t=yd();return n9e(e,n=>t.add(n.text,n)),t}function n9e(e,t){He(e)&&qNt(e)&&t(e),e.forEachChild(n=>n9e(n,t))}function qNt(e){let{parent:t}=e;switch(t.kind){case 211:return t.name!==e;case 208:return t.propertyName!==e;case 276:return t.propertyName!==e;default:return!0}}function i9e(e,t,n,i){return U.createFunctionDeclaration(ps(t,DE(n.modifiers)),Co(n.asteriskToken),e,DE(n.typeParameters),DE(n.parameters),Co(n.type),U.converters.convertToFunctionBlock(pSe(n.body,i)))}function zNt(e,t,n,i){return U.createClassDeclaration(ps(t,DE(n.modifiers)),e,DE(n.typeParameters),DE(n.heritageClauses),pSe(n.members,i))}function s9e(e,t,n,i){return t==="default"?uS(U.createIdentifier(e),void 0,n,i):uS(void 0,[a9e(t,e)],n,i)}function a9e(e,t){return U.createImportSpecifier(!1,e!==void 0&&e!==t?U.createIdentifier(e):void 0,U.createIdentifier(t))}function nee(e,t,n){return U.createVariableStatement(e,U.createVariableDeclarationList([U.createVariableDeclaration(t,void 0,void 0,n)],2))}function dSe(e,t){return U.createExportDeclaration(void 0,!1,e&&U.createNamedExports(e),t===void 0?void 0:U.createStringLiteral(t))}function w6(e,t){return{newImports:e,useSitesToUnqualify:t}}var mSe="correctQualifiedNameToIndexedAccessType",o9e=[v.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1.code];Ta({errorCodes:o9e,getCodeActions(e){let t=c9e(e.sourceFile,e.span.start);if(!t)return;let n=Sn.ChangeTracker.with(e,s=>l9e(s,e.sourceFile,t)),i=`${t.left.text}["${t.right.text}"]`;return[ta(mSe,n,[v.Rewrite_as_the_indexed_access_type_0,i],mSe,v.Rewrite_all_as_indexed_access_types)]},fixIds:[mSe],getAllCodeActions:e=>Ro(e,o9e,(t,n)=>{let i=c9e(n.file,n.start);i&&l9e(t,n.file,i)})});function c9e(e,t){let n=Pr(Yi(e,t),cf);return M.assert(!!n,"Expected position to be owned by a qualified name."),He(n.left)?n:void 0}function l9e(e,t,n){let i=n.right.text,s=U.createIndexedAccessTypeNode(U.createTypeReferenceNode(n.left,void 0),U.createLiteralTypeNode(U.createStringLiteral(i)));e.replaceNode(t,n,s)}var gSe=[v.Re_exporting_a_type_when_0_is_enabled_requires_using_export_type.code],hSe="convertToTypeOnlyExport";Ta({errorCodes:gSe,getCodeActions:function(t){let n=Sn.ChangeTracker.with(t,i=>_9e(i,u9e(t.span,t.sourceFile),t));if(n.length)return[ta(hSe,n,v.Convert_to_type_only_export,hSe,v.Convert_all_re_exported_types_to_type_only_exports)]},fixIds:[hSe],getAllCodeActions:function(t){let n=new Map;return Ro(t,gSe,(i,s)=>{let o=u9e(s,t.sourceFile);o&&em(n,yo(o.parent.parent))&&_9e(i,o,t)})}});function u9e(e,t){return ai(Yi(t,e.start).parent,b_)}function _9e(e,t,n){if(!t)return;let i=t.parent,s=i.parent,o=WNt(t,n);if(o.length===i.elements.length)e.insertModifierBefore(n.sourceFile,156,i);else{let u=U.updateExportDeclaration(s,s.modifiers,!1,U.updateNamedExports(i,Zn(i.elements,d=>!Es(o,d))),s.moduleSpecifier,void 0),m=U.createExportDeclaration(void 0,!0,U.createNamedExports(o),s.moduleSpecifier,void 0);e.replaceNode(n.sourceFile,s,u,{leadingTriviaOption:Sn.LeadingTriviaOption.IncludeAll,trailingTriviaOption:Sn.TrailingTriviaOption.Exclude}),e.insertNodeAfter(n.sourceFile,s,m)}}function WNt(e,t){let n=e.parent;if(n.elements.length===1)return n.elements;let i=rve(df(n),t.program.getSemanticDiagnostics(t.sourceFile,t.cancellationToken));return Zn(n.elements,s=>{var o;return s===e||((o=tve(s,i))==null?void 0:o.code)===gSe[0]})}var f9e=[v._0_is_a_type_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled.code,v._0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled.code],iee="convertToTypeOnlyImport";Ta({errorCodes:f9e,getCodeActions:function(t){var n;let i=p9e(t.sourceFile,t.span.start);if(i){let s=Sn.ChangeTracker.with(t,m=>DV(m,t.sourceFile,i)),o=i.kind===276&&Yc(i.parent.parent.parent)&&d9e(i,t.sourceFile,t.program)?Sn.ChangeTracker.with(t,m=>DV(m,t.sourceFile,i.parent.parent.parent)):void 0,u=ta(iee,s,i.kind===276?[v.Use_type_0,((n=i.propertyName)==null?void 0:n.text)??i.name.text]:v.Use_import_type,iee,v.Fix_all_with_type_only_imports);return Pt(o)?[_g(iee,o,v.Use_import_type),u]:[u]}},fixIds:[iee],getAllCodeActions:function(t){let n=new Set;return Ro(t,f9e,(i,s)=>{let o=p9e(s.file,s.start);o?.kind===272&&!n.has(o)?(DV(i,s.file,o),n.add(o)):o?.kind===276&&Yc(o.parent.parent.parent)&&!n.has(o.parent.parent.parent)&&d9e(o,s.file,t.program)?(DV(i,s.file,o.parent.parent.parent),n.add(o.parent.parent.parent)):o?.kind===276&&DV(i,s.file,o)})}});function p9e(e,t){let{parent:n}=Yi(e,t);return _f(n)||Yc(n)&&n.importClause?n:void 0}function d9e(e,t,n){if(e.parent.parent.name)return!1;let i=e.parent.elements.filter(o=>!o.isTypeOnly);if(i.length===1)return!0;let s=n.getTypeChecker();for(let o of i)if(lc.Core.eachSymbolReferenceInFile(o.name,s,t,m=>{let d=s.getSymbolAtLocation(m);return!!d&&s.symbolIsValue(d)||!gb(m)}))return!1;return!0}function DV(e,t,n){var i;if(_f(n))e.replaceNode(t,n,U.updateImportSpecifier(n,!0,n.propertyName,n.name));else{let s=n.importClause;if(s.name&&s.namedBindings)e.replaceNodeWithNodes(t,n,[U.createImportDeclaration(DE(n.modifiers,!0),U.createImportClause(!0,Co(s.name,!0),void 0),Co(n.moduleSpecifier,!0),Co(n.attributes,!0)),U.createImportDeclaration(DE(n.modifiers,!0),U.createImportClause(!0,void 0,Co(s.namedBindings,!0)),Co(n.moduleSpecifier,!0),Co(n.attributes,!0))]);else{let o=((i=s.namedBindings)==null?void 0:i.kind)===275?U.updateNamedImports(s.namedBindings,Fs(s.namedBindings.elements,m=>U.updateImportSpecifier(m,!1,m.propertyName,m.name))):s.namedBindings,u=U.updateImportDeclaration(n,n.modifiers,U.updateImportClause(s,!0,s.name,o),n.moduleSpecifier,n.attributes);e.replaceNode(t,n,u)}}}var ySe="convertTypedefToType",m9e=[v.JSDoc_typedef_may_be_converted_to_TypeScript_type.code];Ta({fixIds:[ySe],errorCodes:m9e,getCodeActions(e){let t=Vv(e.host,e.formatContext.options),n=Yi(e.sourceFile,e.span.start);if(!n)return;let i=Sn.ChangeTracker.with(e,s=>g9e(s,n,e.sourceFile,t));if(i.length>0)return[ta(ySe,i,v.Convert_typedef_to_TypeScript_type,ySe,v.Convert_all_typedef_to_TypeScript_types)]},getAllCodeActions:e=>Ro(e,m9e,(t,n)=>{let i=Vv(e.host,e.formatContext.options),s=Yi(n.file,n.start);s&&g9e(t,s,n.file,i,!0)})});function g9e(e,t,n,i,s=!1){if(!p2(t))return;let o=HNt(t);if(!o)return;let u=t.parent,{leftSibling:m,rightSibling:d}=$Nt(t),S=u.getStart(),E="";!m&&u.comment&&(S=h9e(u,u.getStart(),t.getStart()),E=`${i} */${i}`),m&&(s&&p2(m)?(S=t.getStart(),E=""):(S=h9e(u,m.getStart(),t.getStart()),E=`${i} */${i}`));let x=u.getEnd(),D="";d&&(s&&p2(d)?(x=d.getStart(),D=`${i}${i}`):(x=d.getStart(),D=`${i}/**${i} * `)),e.replaceRange(n,{pos:S,end:x},o,{prefix:E,suffix:D})}function $Nt(e){let t=e.parent,n=t.getChildCount()-1,i=t.getChildren().findIndex(u=>u.getStart()===e.getStart()&&u.getEnd()===e.getEnd()),s=i>0?t.getChildAt(i-1):void 0,o=i<n?t.getChildAt(i+1):void 0;return{leftSibling:s,rightSibling:o}}function h9e(e,t,n){let i=e.getText().substring(t-e.getStart(),n-e.getStart());for(let s=i.length;s>0;s--)if(!/[*/\s]/g.test(i.substring(s-1,s)))return t+s;return n}function HNt(e){var t;let{typeExpression:n}=e;if(!n)return;let i=(t=e.name)==null?void 0:t.getText();if(i){if(n.kind===322)return GNt(i,n);if(n.kind===309)return YNt(i,n)}}function GNt(e,t){let n=y9e(t);if(Pt(n))return U.createInterfaceDeclaration(void 0,e,void 0,void 0,n)}function YNt(e,t){let n=Co(t.type);if(n)return U.createTypeAliasDeclaration(void 0,U.createIdentifier(e),void 0,n)}function y9e(e){let t=e.jsDocPropertyTags;return Pt(t)?Gi(t,i=>{var s;let o=KNt(i),u=(s=i.typeExpression)==null?void 0:s.type,m=i.isBracketed,d;if(u&&f2(u)){let S=y9e(u);d=U.createTypeLiteralNode(S)}else u&&(d=Co(u));if(d&&o){let S=m?U.createToken(58):void 0;return U.createPropertySignature(void 0,o,S,d)}}):void 0}function KNt(e){return e.name.kind===80?e.name.text:e.name.right.text}function XNt(e){return Pp(e)?va(e.jsDoc,t=>{var n;return(n=t.tags)==null?void 0:n.filter(i=>p2(i))}):[]}var vSe="convertLiteralTypeToMappedType",v9e=[v._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0.code];Ta({errorCodes:v9e,getCodeActions:function(t){let{sourceFile:n,span:i}=t,s=S9e(n,i.start);if(!s)return;let{name:o,constraint:u}=s,m=Sn.ChangeTracker.with(t,d=>b9e(d,n,s));return[ta(vSe,m,[v.Convert_0_to_1_in_0,u,o],vSe,v.Convert_all_type_literals_to_mapped_type)]},fixIds:[vSe],getAllCodeActions:e=>Ro(e,v9e,(t,n)=>{let i=S9e(n.file,n.start);i&&b9e(t,n.file,i)})});function S9e(e,t){let n=Yi(e,t);if(He(n)){let i=aa(n.parent.parent,Nf),s=n.getText(e);return{container:aa(i.parent,lf),typeNode:i.type,constraint:s,name:s==="K"?"P":"K"}}}function b9e(e,t,{container:n,typeNode:i,constraint:s,name:o}){e.replaceNode(t,n,U.createMappedTypeNode(void 0,U.createTypeParameterDeclaration(void 0,o,U.createTypeReferenceNode(s)),void 0,void 0,i,void 0))}var T9e=[v.Class_0_incorrectly_implements_interface_1.code,v.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code],SSe="fixClassIncorrectlyImplementsInterface";Ta({errorCodes:T9e,getCodeActions(e){let{sourceFile:t,span:n}=e,i=E9e(t,n.start);return Gi(eN(i),s=>{let o=Sn.ChangeTracker.with(e,u=>C9e(e,s,t,i,u,e.preferences));return o.length===0?void 0:ta(SSe,o,[v.Implement_interface_0,s.getText(t)],SSe,v.Implement_all_unimplemented_interfaces)})},fixIds:[SSe],getAllCodeActions(e){let t=new Map;return Ro(e,T9e,(n,i)=>{let s=E9e(i.file,i.start);if(em(t,yo(s)))for(let o of eN(s))C9e(e,o,i.file,s,n,e.preferences)})}});function E9e(e,t){return M.checkDefined(Ou(Yi(e,t)),"There should be a containing class")}function x9e(e){return!e.valueDeclaration||!(U_(e.valueDeclaration)&2)}function C9e(e,t,n,i,s,o){let u=e.program.getTypeChecker(),m=QNt(i,u),d=u.getTypeAtLocation(t),E=u.getPropertiesOfType(d).filter(r5(x9e,F=>!m.has(F.escapedName))),x=u.getTypeAtLocation(i),D=Ln(i.members,F=>Vc(F));x.getNumberIndexType()||R(d,1),x.getStringIndexType()||R(d,0);let w=LE(n,e.program,o,e.host);_be(i,E,n,e,o,w,F=>L(n,i,F)),w.writeFixes(s);function R(F,J){let G=u.getIndexInfoOfType(F,J);G&&L(n,i,u.indexInfoToIndexSignatureDeclaration(G,i,void 0,aD(e)))}function L(F,J,G){D?s.insertNodeAfter(F,D,G):s.insertMemberAtStart(F,J,G)}}function QNt(e,t){let n=Fg(e);if(!n)return fa();let i=t.getTypeAtLocation(n),s=t.getPropertiesOfType(i);return fa(s.filter(x9e))}var A9e="import",k9e="fixMissingImport",P9e=[v.Cannot_find_name_0.code,v.Cannot_find_name_0_Did_you_mean_1.code,v.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,v.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code,v.Cannot_find_namespace_0.code,v._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code,v._0_only_refers_to_a_type_but_is_being_used_as_a_value_here.code,v.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer.code,v._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type.code,v.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery.code,v.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_1_or_later.code,v.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom.code,v.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig.code,v.Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function.code,v.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig.code,v.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha.code,v.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode.code,v.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig.code,v.Cannot_find_namespace_0_Did_you_mean_1.code];Ta({errorCodes:P9e,getCodeActions(e){let{errorCode:t,preferences:n,sourceFile:i,span:s,program:o}=e,u=M9e(e,t,s.start,!0);if(u)return u.map(({fix:m,symbolName:d,errorIdentifierText:S})=>TSe(e,i,d,m,d!==S,o,n))},fixIds:[k9e],getAllCodeActions:e=>{let{sourceFile:t,program:n,preferences:i,host:s,cancellationToken:o}=e,u=N9e(t,n,!0,i,s,o);return fk(e,P9e,m=>u.addImportFromDiagnostic(m,e)),_k(Sn.ChangeTracker.with(e,u.writeFixes))}});function LE(e,t,n,i,s){return N9e(e,t,!1,n,i,s)}function N9e(e,t,n,i,s,o){let u=t.getCompilerOptions(),m=[],d=[],S=new Map,E=new Set,x=new Set,D=new Map;return{addImportFromDiagnostic:L,addImportFromExportedSymbol:F,writeFixes:ee,hasFixes:pe,addImportForUnresolvedIdentifier:R,addImportForNonExistentExport:J,removeExistingImport:G,addVerbatimImport:w};function w(K){x.add(K)}function R(K,re,ue){let ce=lDt(K,re,ue);!ce||!ce.length||q(Ma(ce))}function L(K,re){let ue=M9e(re,K.code,K.start,n);!ue||!ue.length||q(Ma(ue))}function F(K,re,ue){var ce;let ne=M.checkDefined(K.parent),le=rV(K,Ka(u)),me=t.getTypeChecker(),de=me.getMergedSymbol($u(K,me)),Ae=I9e(e,de,le,ne,!1,t,s,i,o),xe=IV(e,t),te=D9e(e,M.checkDefined(Ae),t,void 0,!!re,xe,s,i);if(te){let he=((ce=ai(ue?.name,He))==null?void 0:ce.text)??le;ue&&vI(ue)&&(te.kind===3||te.kind===2)&&te.addAsTypeOnly===1&&(te={...te,addAsTypeOnly:2}),q({fix:te,symbolName:he??le,errorIdentifierText:void 0})}}function J(K,re,ue,ce,ne){let le=t.getSourceFile(re),me=IV(e,t);if(le&&le.symbol){let{fixes:de}=wV([{exportKind:ue,isFromPackageJson:!1,moduleFileName:re,moduleSymbol:le.symbol,targetFlags:ce}],void 0,ne,me,t,e,s,i);de.length&&q({fix:de[0],symbolName:K,errorIdentifierText:K})}else{let de=lV(re,99,t,s),Ae=wb.getLocalModuleSpecifierBetweenFileNames(e,re,u,ak(t,s)),xe=aee(de,ue,u),te=see(ne,!0,void 0,ce,t.getTypeChecker(),u);q({fix:{kind:3,moduleSpecifierKind:"relative",moduleSpecifier:Ae,importKind:xe,addAsTypeOnly:te,useRequire:me},symbolName:K,errorIdentifierText:K})}}function G(K){K.kind===273&&M.assertIsDefined(K.name,"ImportClause should have a name if it's being removed"),E.add(K)}function q(K){var re,ue;let{fix:ce,symbolName:ne}=K;switch(ce.kind){case 0:m.push(ce);break;case 1:d.push(ce);break;case 2:{let{importClauseOrBindingPattern:Ae,importKind:xe,addAsTypeOnly:te}=ce,he=S.get(Ae);if(he||S.set(Ae,he={importClauseOrBindingPattern:Ae,defaultImport:void 0,namedImports:new Map}),xe===0){let be=he?.namedImports.get(ne);he.namedImports.set(ne,le(be,te))}else M.assert(he.defaultImport===void 0||he.defaultImport.name===ne,"(Add to Existing) Default import should be missing or match symbolName"),he.defaultImport={name:ne,addAsTypeOnly:le((re=he.defaultImport)==null?void 0:re.addAsTypeOnly,te)};break}case 3:{let{moduleSpecifier:Ae,importKind:xe,useRequire:te,addAsTypeOnly:he}=ce,be=me(Ae,xe,te,he);switch(M.assert(be.useRequire===te,"(Add new) Tried to add an `import` and a `require` for the same module"),xe){case 1:M.assert(be.defaultImport===void 0||be.defaultImport.name===ne,"(Add new) Default import should be missing or match symbolName"),be.defaultImport={name:ne,addAsTypeOnly:le((ue=be.defaultImport)==null?void 0:ue.addAsTypeOnly,he)};break;case 0:let Ve=(be.namedImports||(be.namedImports=new Map)).get(ne);be.namedImports.set(ne,le(Ve,he));break;case 3:if(u.verbatimModuleSyntax){let Pe=(be.namedImports||(be.namedImports=new Map)).get(ne);be.namedImports.set(ne,le(Pe,he))}else M.assert(be.namespaceLikeImport===void 0||be.namespaceLikeImport.name===ne,"Namespacelike import shoudl be missing or match symbolName"),be.namespaceLikeImport={importKind:xe,name:ne,addAsTypeOnly:he};break;case 2:M.assert(be.namespaceLikeImport===void 0||be.namespaceLikeImport.name===ne,"Namespacelike import shoudl be missing or match symbolName"),be.namespaceLikeImport={importKind:xe,name:ne,addAsTypeOnly:he};break}break}case 4:break;default:M.assertNever(ce,`fix wasn't never - got kind ${ce.kind}`)}function le(Ae,xe){return Math.max(Ae??0,xe)}function me(Ae,xe,te,he){let be=de(Ae,!0),Ve=de(Ae,!1),Pe=D.get(be),ke=D.get(Ve),De={defaultImport:void 0,namedImports:void 0,namespaceLikeImport:void 0,useRequire:te};return xe===1&&he===2?Pe||(D.set(be,De),De):he===1&&(Pe||ke)?Pe||ke:ke||(D.set(Ve,De),De)}function de(Ae,xe){return`${xe?1:0}|${Ae}`}}function ee(K,re){var ue,ce;let ne;Av(e)&&e.imports.length===0&&re!==void 0?ne=re:ne=ed(e,i);for(let de of m)ESe(K,e,de);for(let de of d)z9e(K,e,de,ne);let le;if(E.size){M.assert(Av(e),"Cannot remove imports from a future source file");let de=new Set(Gi([...E],be=>Pr(be,Yc))),Ae=new Set(Gi([...E],be=>Pr(be,_R))),xe=[...de].filter(be=>{var Ve,Pe,ke;return!S.has(be.importClause)&&(!((Ve=be.importClause)!=null&&Ve.name)||E.has(be.importClause))&&(!ai((Pe=be.importClause)==null?void 0:Pe.namedBindings,My)||E.has(be.importClause.namedBindings))&&(!ai((ke=be.importClause)==null?void 0:ke.namedBindings,Gg)||wi(be.importClause.namedBindings.elements,De=>E.has(De)))}),te=[...Ae].filter(be=>(be.name.kind!==206||!S.has(be.name))&&(be.name.kind!==206||wi(be.name.elements,Ve=>E.has(Ve)))),he=[...de].filter(be=>{var Ve,Pe;return((Ve=be.importClause)==null?void 0:Ve.namedBindings)&&xe.indexOf(be)===-1&&!((Pe=S.get(be.importClause))!=null&&Pe.namedImports)&&(be.importClause.namedBindings.kind===274||wi(be.importClause.namedBindings.elements,ke=>E.has(ke)))});for(let be of[...xe,...te])K.delete(e,be);for(let be of he)K.replaceNode(e,be.importClause,U.updateImportClause(be.importClause,be.importClause.isTypeOnly,be.importClause.name,void 0));for(let be of E){let Ve=Pr(be,Yc);Ve&&xe.indexOf(Ve)===-1&&he.indexOf(Ve)===-1?be.kind===273?K.delete(e,be.name):(M.assert(be.kind===276,"NamespaceImport should have been handled earlier"),(ue=S.get(Ve.importClause))!=null&&ue.namedImports?(le??(le=new Set)).add(be):K.delete(e,be)):be.kind===208?(ce=S.get(be.parent))!=null&&ce.namedImports?(le??(le=new Set)).add(be):K.delete(e,be):be.kind===271&&K.delete(e,be)}}S.forEach(({importClauseOrBindingPattern:de,defaultImport:Ae,namedImports:xe})=>{q9e(K,e,de,Ae,Is(xe.entries(),([te,he])=>({addAsTypeOnly:he,name:te})),le,i)});let me;D.forEach(({useRequire:de,defaultImport:Ae,namedImports:xe,namespaceLikeImport:te},he)=>{let be=he.slice(2),Pe=(de?H9e:$9e)(be,ne,Ae,xe&&Is(xe.entries(),([ke,De])=>({addAsTypeOnly:De,name:ke})),te,u,i);me=vs(me,Pe)}),me=vs(me,W()),me&&IQ(K,e,me,!0,i)}function W(){if(!x.size)return;let K=new Set(Gi([...x],ue=>Pr(ue,Yc))),re=new Set(Gi([...x],ue=>Pr(ue,fR)));return[...Gi([...x],ue=>ue.kind===271?Co(ue,!0):void 0),...[...K].map(ue=>{var ce;return x.has(ue)?Co(ue,!0):Co(U.updateImportDeclaration(ue,ue.modifiers,ue.importClause&&U.updateImportClause(ue.importClause,ue.importClause.isTypeOnly,x.has(ue.importClause)?ue.importClause.name:void 0,x.has(ue.importClause.namedBindings)?ue.importClause.namedBindings:(ce=ai(ue.importClause.namedBindings,Gg))!=null&&ce.elements.some(ne=>x.has(ne))?U.updateNamedImports(ue.importClause.namedBindings,ue.importClause.namedBindings.elements.filter(ne=>x.has(ne))):void 0),ue.moduleSpecifier,ue.attributes),!0)}),...[...re].map(ue=>x.has(ue)?Co(ue,!0):Co(U.updateVariableStatement(ue,ue.modifiers,U.updateVariableDeclarationList(ue.declarationList,Gi(ue.declarationList.declarations,ce=>x.has(ce)?ce:U.updateVariableDeclaration(ce,ce.name.kind===206?U.updateObjectBindingPattern(ce.name,ce.name.elements.filter(ne=>x.has(ne))):ce.name,ce.exclamationToken,ce.type,ce.initializer)))),!0))]}function pe(){return m.length>0||d.length>0||S.size>0||D.size>0||x.size>0||E.size>0}}function ZNt(e,t,n,i){let s=ZN(e,i,n),o=O9e(t.getTypeChecker(),e,t.getCompilerOptions());return{getModuleSpecifierForBestExportInfo:u};function u(m,d,S,E){let{fixes:x,computedWithoutCacheCount:D}=wV(m,d,S,!1,t,e,n,i,o,E),w=F9e(x,e,t,s,n,i);return w&&{...w,computedWithoutCacheCount:D}}}function eDt(e,t,n,i,s,o,u,m,d,S,E,x){let D;n?(D=PM(i,u,m,E,x).get(i.path,n),M.assertIsDefined(D,"Some exportInfo should match the specified exportMapKey")):(D=d$(Zd(t.name))?[rDt(e,s,t,m,u)]:I9e(i,e,s,t,o,m,u,E,x),M.assertIsDefined(D,"Some exportInfo should match the specified symbol / moduleSymbol"));let w=IV(i,m),R=gb(Yi(i,S)),L=M.checkDefined(D9e(i,D,m,S,R,w,u,E));return{moduleSpecifier:L.moduleSpecifier,codeAction:w9e(TSe({host:u,formatContext:d,preferences:E},i,s,L,!1,m,E))}}function tDt(e,t,n,i,s,o){let u=n.getCompilerOptions(),m=DW(bSe(e,n.getTypeChecker(),t,u)),d=V9e(e,t,m,n),S=m!==t.text;return d&&w9e(TSe({host:i,formatContext:s,preferences:o},e,m,d,S,n,o))}function D9e(e,t,n,i,s,o,u,m){let d=ZN(e,m,u);return F9e(wV(t,i,s,o,n,e,u,m).fixes,e,n,d,u,m)}function w9e({description:e,changes:t,commands:n}){return{description:e,changes:t,commands:n}}function I9e(e,t,n,i,s,o,u,m,d){let S=R9e(o,u);return PM(e,u,o,m,d).search(e.path,s,E=>E===n,E=>{if($u(E[0].symbol,S(E[0].isFromPackageJson))===t&&E.some(x=>x.moduleSymbol===i||x.symbol.parent===i))return E})}function rDt(e,t,n,i,s){var o,u;let m=S(i.getTypeChecker(),!1);if(m)return m;let d=(u=(o=s.getPackageJsonAutoImportProvider)==null?void 0:o.call(s))==null?void 0:u.getTypeChecker();return M.checkDefined(d&&S(d,!0),"Could not find symbol in specified module for code actions");function S(E,x){let D=uV(n,E);if(D&&$u(D.symbol,E)===e)return{symbol:D.symbol,moduleSymbol:n,moduleFileName:void 0,exportKind:D.exportKind,targetFlags:$u(e,E).flags,isFromPackageJson:x};let w=E.tryGetMemberInModuleExportsAndProperties(t,n);if(w&&$u(w,E)===e)return{symbol:w,moduleSymbol:n,moduleFileName:void 0,exportKind:0,targetFlags:$u(e,E).flags,isFromPackageJson:x}}}function wV(e,t,n,i,s,o,u,m,d=Av(o)?O9e(s.getTypeChecker(),o,s.getCompilerOptions()):void 0,S){let E=s.getTypeChecker(),x=d?va(e,d.getImportsForExportInfo):ve,D=t!==void 0&&nDt(x,t),w=sDt(x,n,E,s.getCompilerOptions());if(w)return{computedWithoutCacheCount:0,fixes:[...D?[D]:ve,w]};let{fixes:R,computedWithoutCacheCount:L=0}=oDt(e,x,s,o,t,n,i,u,m,S);return{computedWithoutCacheCount:L,fixes:[...D?[D]:ve,...R]}}function nDt(e,t){return yi(e,({declaration:n,importKind:i})=>{var s;if(i!==0)return;let o=iDt(n),u=o&&((s=MI(n))==null?void 0:s.text);if(u)return{kind:0,namespacePrefix:o,usagePosition:t,moduleSpecifierKind:void 0,moduleSpecifier:u}})}function iDt(e){var t,n,i;switch(e.kind){case 260:return(t=ai(e.name,He))==null?void 0:t.text;case 271:return e.name.text;case 351:case 272:return(i=ai((n=e.importClause)==null?void 0:n.namedBindings,My))==null?void 0:i.name.text;default:return M.assertNever(e)}}function see(e,t,n,i,s,o){return e?n&&o.verbatimModuleSyntax&&(!(i&111551)||s.getTypeOnlyAliasDeclaration(n))?2:1:4}function sDt(e,t,n,i){let s;for(let u of e){let m=o(u);if(!m)continue;let d=vI(m.importClauseOrBindingPattern);if(m.addAsTypeOnly!==4&&d||m.addAsTypeOnly===4&&!d)return m;s??(s=m)}return s;function o({declaration:u,importKind:m,symbol:d,targetFlags:S}){if(m===3||m===2||u.kind===271)return;if(u.kind===260)return(m===0||m===1)&&u.name.kind===206?{kind:2,importClauseOrBindingPattern:u.name,importKind:m,moduleSpecifierKind:void 0,moduleSpecifier:u.initializer.arguments[0].text,addAsTypeOnly:4}:void 0;let{importClause:E}=u;if(!E||!No(u.moduleSpecifier))return;let{name:x,namedBindings:D}=E;if(E.isTypeOnly&&!(m===0&&D))return;let w=see(t,!1,d,S,n,i);if(!(m===1&&(x||w===2&&D))&&!(m===0&&D?.kind===274))return{kind:2,importClauseOrBindingPattern:E,importKind:m,moduleSpecifierKind:void 0,moduleSpecifier:u.moduleSpecifier.text,addAsTypeOnly:w}}}function O9e(e,t,n){let i;for(let s of t.imports){let o=LI(s);if(_R(o.parent)){let u=e.resolveExternalModuleName(s);u&&(i||(i=yd())).add(Aa(u),o.parent)}else if(o.kind===272||o.kind===271||o.kind===351){let u=e.getSymbolAtLocation(s);u&&(i||(i=yd())).add(Aa(u),o)}}return{getImportsForExportInfo:({moduleSymbol:s,exportKind:o,targetFlags:u,symbol:m})=>{let d=i?.get(Aa(s));if(!d||Af(t)&&!(u&111551)&&!wi(d,Xg))return ve;let S=aee(t,o,n);return d.map(E=>({declaration:E,importKind:S,symbol:m,targetFlags:u}))}}}function IV(e,t){if(!Oy(e.fileName))return!1;if(e.commonJsModuleIndicator&&!e.externalModuleIndicator)return!0;if(e.externalModuleIndicator&&!e.commonJsModuleIndicator)return!1;let n=t.getCompilerOptions();if(n.configFile)return V_(n)<5;if(e.impliedNodeFormat===1)return!0;if(e.impliedNodeFormat===99)return!1;for(let i of t.getSourceFiles())if(!(i===e||!Af(i)||t.isSourceFileFromExternalLibrary(i))){if(i.commonJsModuleIndicator&&!i.externalModuleIndicator)return!0;if(i.externalModuleIndicator&&!i.commonJsModuleIndicator)return!1}return!0}function R9e(e,t){return Ih(n=>n?t.getPackageJsonAutoImportProvider().getTypeChecker():e.getTypeChecker())}function aDt(e,t,n,i,s,o,u,m,d){let S=Oy(t.fileName),E=e.getCompilerOptions(),x=ak(e,u),D=R9e(e,u),w=af(E),R=BU(w),L=d?G=>wb.tryGetModuleSpecifiersFromCache(G.moduleSymbol,t,x,m):(G,q)=>wb.getModuleSpecifiersWithCacheInfo(G.moduleSymbol,q,E,t,x,m,void 0,!0),F=0,J=va(o,(G,q)=>{let ee=D(G.isFromPackageJson),{computedWithoutCache:W,moduleSpecifiers:pe,kind:K}=L(G,ee)??{},re=!!(G.targetFlags&111551),ue=see(i,!0,G.symbol,G.targetFlags,ee,E);return F+=W?1:0,Gi(pe,ce=>{if(R&&Nb(ce))return;if(!re&&S&&n!==void 0)return{kind:1,moduleSpecifierKind:K,moduleSpecifier:ce,usagePosition:n,exportInfo:G,isReExport:q>0};let ne=aee(t,G.exportKind,E),le;if(n!==void 0&&ne===3&&G.exportKind===0){let me=ee.resolveExternalModuleSymbol(G.moduleSymbol),de;me!==G.moduleSymbol&&(de=cZ(me,ee,E,!1,ec)),de||(de=x6(G.moduleSymbol,Ka(E),!1)),le={namespacePrefix:de,usagePosition:n}}return{kind:3,moduleSpecifierKind:K,moduleSpecifier:ce,importKind:ne,useRequire:s,addAsTypeOnly:ue,exportInfo:G,isReExport:q>0,qualification:le}})});return{computedWithoutCacheCount:F,fixes:J}}function oDt(e,t,n,i,s,o,u,m,d,S){let E=yi(t,x=>cDt(x,o,u,n.getTypeChecker(),n.getCompilerOptions()));return E?{fixes:[E]}:aDt(n,i,s,o,u,e,m,d,S)}function cDt({declaration:e,importKind:t,symbol:n,targetFlags:i},s,o,u,m){var d;let S=(d=MI(e))==null?void 0:d.text;if(S){let E=o?4:see(s,!0,n,i,u,m);return{kind:3,moduleSpecifierKind:void 0,moduleSpecifier:S,importKind:t,addAsTypeOnly:E,useRequire:o}}}function M9e(e,t,n,i){let s=Yi(e.sourceFile,n),o;if(t===v._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code)o=pDt(e,s);else if(He(s))if(t===v._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type.code){let m=DW(bSe(e.sourceFile,e.program.getTypeChecker(),s,e.program.getCompilerOptions())),d=V9e(e.sourceFile,s,m,e.program);return d&&[{fix:d,symbolName:m,errorIdentifierText:s.text}]}else o=U9e(e,s,i);else return;let u=ZN(e.sourceFile,e.preferences,e.host);return o&&L9e(o,e.sourceFile,e.program,u,e.host,e.preferences)}function L9e(e,t,n,i,s,o){let u=m=>rc(m,s.getCurrentDirectory(),Pv(s));return pa(e,(m,d)=>XS(!!m.isJsxNamespaceFix,!!d.isJsxNamespaceFix)||tc(m.fix.kind,d.fix.kind)||j9e(m.fix,d.fix,t,n,o,i.allowsImportingSpecifier,u))}function lDt(e,t,n){let i=U9e(e,t,n),s=ZN(e.sourceFile,e.preferences,e.host);return i&&L9e(i,e.sourceFile,e.program,s,e.host,e.preferences)}function F9e(e,t,n,i,s,o){if(Pt(e))return e[0].kind===0||e[0].kind===2?e[0]:e.reduce((u,m)=>j9e(m,u,t,n,o,i.allowsImportingSpecifier,d=>rc(d,s.getCurrentDirectory(),Pv(s)))===-1?m:u)}function j9e(e,t,n,i,s,o,u){return e.kind!==0&&t.kind!==0?XS(t.moduleSpecifierKind!=="node_modules"||o(t.moduleSpecifier),e.moduleSpecifierKind!=="node_modules"||o(e.moduleSpecifier))||uDt(e,t,s)||fDt(e.moduleSpecifier,t.moduleSpecifier,n,i)||XS(B9e(e,n.path,u),B9e(t,n.path,u))||GR(e.moduleSpecifier,t.moduleSpecifier):0}function uDt(e,t,n){return n.importModuleSpecifierPreference==="non-relative"||n.importModuleSpecifierPreference==="project-relative"?XS(e.moduleSpecifierKind==="relative",t.moduleSpecifierKind==="relative"):0}function B9e(e,t,n){var i;if(e.isReExport&&((i=e.exportInfo)!=null&&i.moduleFileName)&&_Dt(e.exportInfo.moduleFileName)){let s=n(mi(e.exportInfo.moduleFileName));return _s(t,s)}return!1}function _Dt(e){return Ul(e,[".js",".jsx",".d.ts",".ts",".tsx"],!0)==="index"}function fDt(e,t,n,i){return _s(e,"node:")&&!_s(t,"node:")?aV(n,i)?-1:1:_s(t,"node:")&&!_s(e,"node:")?aV(n,i)?1:-1:0}function pDt({sourceFile:e,program:t,host:n,preferences:i},s){let o=t.getTypeChecker(),u=dDt(s,o);if(!u)return;let m=o.getAliasedSymbol(u),d=u.name,S=[{symbol:u,moduleSymbol:m,moduleFileName:void 0,exportKind:3,targetFlags:m.flags,isFromPackageJson:!1}],E=IV(e,t);return wV(S,void 0,!1,E,t,e,n,i).fixes.map(D=>{var w;return{fix:D,symbolName:d,errorIdentifierText:(w=ai(s,He))==null?void 0:w.text}})}function dDt(e,t){let n=He(e)?t.getSymbolAtLocation(e):void 0;if(U9(n))return n;let{parent:i}=e;if(__(i)&&i.tagName===e||_2(i)){let s=t.resolveName(t.getJsxNamespace(i),__(i)?e:i,111551,!1);if(U9(s))return s}}function aee(e,t,n,i){if(n.verbatimModuleSyntax&&(V_(n)===1||e.impliedNodeFormat===1))return 3;switch(t){case 0:return 0;case 1:return 1;case 2:return yDt(e,n,!!i);case 3:return mDt(e,n,!!i);default:return M.assertNever(t)}}function mDt(e,t,n){if(SA(t))return 1;let i=V_(t);switch(i){case 2:case 1:case 3:return Oy(e.fileName)&&(e.externalModuleIndicator||n)?2:3;case 4:case 5:case 6:case 7:case 99:case 0:case 200:return 2;case 100:case 199:return e.impliedNodeFormat===99?2:3;default:return M.assertNever(i,`Unexpected moduleKind ${i}`)}}function U9e({sourceFile:e,program:t,cancellationToken:n,host:i,preferences:s},o,u){let m=t.getTypeChecker(),d=t.getCompilerOptions();return va(bSe(e,m,o,d),S=>{if(S==="default")return;let E=gb(o),x=IV(e,t),D=hDt(S,GP(o),S2(o),n,e,t,u,i,s);return Is(c3(D.values(),w=>wV(w,o.getStart(e),E,x,t,e,i,s).fixes),w=>({fix:w,symbolName:S,errorIdentifierText:o.text,isJsxNamespaceFix:S!==o.text}))})}function V9e(e,t,n,i){let s=i.getTypeChecker(),o=s.resolveName(n,t,111551,!0);if(!o)return;let u=s.getTypeOnlyAliasDeclaration(o);if(!(!u||Ur(u)!==e))return{kind:4,typeOnlyAliasDeclaration:u}}function bSe(e,t,n,i){let s=n.parent;if((__(s)||yE(s))&&s.tagName===n&&nZ(i.jsx)){let o=t.getJsxNamespace(e);if(gDt(o,n,t))return!nN(n.text)&&!t.resolveName(n.text,n,111551,!1)?[n.text,o]:[o]}return[n.text]}function gDt(e,t,n){if(nN(t.text))return!0;let i=n.resolveName(e,t,111551,!0);return!i||Pt(i.declarations,ib)&&!(i.flags&111551)}function hDt(e,t,n,i,s,o,u,m,d){var S;let E=yd(),x=ZN(s,d,m),D=(S=m.getModuleSpecifierCache)==null?void 0:S.call(m),w=Ih(L=>ak(L?m.getPackageJsonAutoImportProvider():o,m));function R(L,F,J,G,q,ee){let W=w(ee);if(F&&aZ(q,s,F,d,x,W,D)||!F&&x.allowsImportingAmbientModule(L,W)){let pe=q.getTypeChecker();E.add(W0e(J,pe).toString(),{symbol:J,moduleSymbol:L,moduleFileName:F?.fileName,exportKind:G,targetFlags:$u(J,pe).flags,isFromPackageJson:ee})}}return oZ(o,m,d,u,(L,F,J,G)=>{let q=J.getTypeChecker();i.throwIfCancellationRequested();let ee=J.getCompilerOptions(),W=uV(L,q);W&&Y9e(q.getSymbolFlags(W.symbol),n)&&cZ(W.symbol,q,ee,t,K=>K===e)&&R(L,F,W.symbol,W.exportKind,J,G);let pe=q.tryGetMemberInModuleExportsAndProperties(e,L);pe&&Y9e(q.getSymbolFlags(pe),n)&&R(L,F,pe,0,J,G)}),E}function yDt(e,t,n){let i=SA(t),s=Oy(e.fileName);if(!s&&V_(t)>=5)return i?1:2;if(s)return e.externalModuleIndicator||n?i?1:2:3;for(let o of e.statements??ve)if(ru(o)&&!$c(o.moduleReference))return 3;return i?1:3}function TSe(e,t,n,i,s,o,u){let m,d=Sn.ChangeTracker.with(e,S=>{m=vDt(S,t,n,i,s,o,u)});return ta(A9e,d,m,k9e,v.Add_all_missing_imports)}function vDt(e,t,n,i,s,o,u){let m=ed(t,u);switch(i.kind){case 0:return ESe(e,t,i),[v.Change_0_to_1,n,`${i.namespacePrefix}.${n}`];case 1:return z9e(e,t,i,m),[v.Change_0_to_1,n,W9e(i.moduleSpecifier,m)+n];case 2:{let{importClauseOrBindingPattern:d,importKind:S,addAsTypeOnly:E,moduleSpecifier:x}=i;q9e(e,t,d,S===1?{name:n,addAsTypeOnly:E}:void 0,S===0?[{name:n,addAsTypeOnly:E}]:ve,void 0,u);let D=Zd(x);return s?[v.Import_0_from_1,n,D]:[v.Update_import_from_0,D]}case 3:{let{importKind:d,moduleSpecifier:S,addAsTypeOnly:E,useRequire:x,qualification:D}=i,w=x?H9e:$9e,R=d===1?{name:n,addAsTypeOnly:E}:void 0,L=d===0?[{name:n,addAsTypeOnly:E}]:void 0,F=d===2||d===3?{importKind:d,name:D?.namespacePrefix||n,addAsTypeOnly:E}:void 0;return IQ(e,t,w(S,m,R,L,F,o.getCompilerOptions(),u),!0,u),D&&ESe(e,t,D),s?[v.Import_0_from_1,n,S]:[v.Add_import_from_0,S]}case 4:{let{typeOnlyAliasDeclaration:d}=i,S=SDt(e,d,o,t,u);return S.kind===276?[v.Remove_type_from_import_of_0_from_1,n,J9e(S.parent.parent)]:[v.Remove_type_from_import_declaration_from_0,J9e(S)]}default:return M.assertNever(i,`Unexpected fix kind ${i.kind}`)}}function J9e(e){var t,n;return e.kind===271?((n=ai((t=ai(e.moduleReference,C0))==null?void 0:t.expression,No))==null?void 0:n.text)||e.moduleReference.getText():aa(e.parent.moduleSpecifier,La).text}function SDt(e,t,n,i,s){let o=n.getCompilerOptions(),u=o.verbatimModuleSyntax;switch(t.kind){case 276:if(t.isTypeOnly){if(t.parent.elements.length>1){let d=U.updateImportSpecifier(t,!1,t.propertyName,t.name),{specifierComparer:S}=Ub.getNamedImportSpecifierComparerWithDetection(t.parent.parent.parent,s,i),E=Ub.getImportSpecifierInsertionIndex(t.parent.elements,d,S);if(E!==t.parent.elements.indexOf(t))return e.delete(i,t),e.insertImportSpecifierAtIndex(i,d,t.parent,E),t}return e.deleteRange(i,{pos:ob(t.getFirstToken()),end:ob(t.propertyName??t.name)}),t}else return M.assert(t.parent.parent.isTypeOnly),m(t.parent.parent),t.parent.parent;case 273:return m(t),t;case 274:return m(t.parent),t.parent;case 271:return e.deleteRange(i,t.getChildAt(1)),t;default:M.failBadSyntaxKind(t)}function m(d){var S;if(e.delete(i,OQ(d,i)),!o.allowImportingTsExtensions){let E=MI(d.parent),x=E&&((S=n.getResolvedModuleFromModuleSpecifier(E,i))==null?void 0:S.resolvedModule);if(x?.resolvedUsingTsExtension){let D=b3(E.text,jB(E.text,o));e.replaceNode(i,E,U.createStringLiteral(D))}}if(u){let E=ai(d.namedBindings,Gg);if(E&&E.elements.length>1){Ub.getNamedImportSpecifierComparerWithDetection(d.parent,s,i).isSorted!==!1&&t.kind===276&&E.elements.indexOf(t)!==0&&(e.delete(i,t),e.insertImportSpecifierAtIndex(i,t,E,0));for(let D of E.elements)D!==t&&!D.isTypeOnly&&e.insertModifierBefore(i,156,D)}}}}function q9e(e,t,n,i,s,o,u){var m;if(n.kind===206){if(o&&n.elements.some(x=>o.has(x))){e.replaceNode(t,n,U.createObjectBindingPattern([...n.elements.filter(x=>!o.has(x)),...i?[U.createBindingElement(void 0,"default",i.name)]:ve,...s.map(x=>U.createBindingElement(void 0,void 0,x.name))]));return}i&&E(n,i.name,"default");for(let x of s)E(n,x.name,void 0);return}let d=n.isTypeOnly&&Pt([i,...s],x=>x?.addAsTypeOnly===4),S=n.namedBindings&&((m=ai(n.namedBindings,Gg))==null?void 0:m.elements);if(i&&(M.assert(!n.name,"Cannot add a default import to an import clause that already has one"),e.insertNodeAt(t,n.getStart(t),U.createIdentifier(i.name),{suffix:", "})),s.length){let{specifierComparer:x,isSorted:D}=Ub.getNamedImportSpecifierComparerWithDetection(n.parent,u,t),w=Qs(s.map(R=>U.createImportSpecifier((!n.isTypeOnly||d)&&oee(R,u),void 0,U.createIdentifier(R.name))),x);if(o)e.replaceNode(t,n.namedBindings,U.updateNamedImports(n.namedBindings,Qs([...S.filter(R=>!o.has(R)),...w],x)));else if(S?.length&&D!==!1){let R=d&&S?U.updateNamedImports(n.namedBindings,Fs(S,L=>U.updateImportSpecifier(L,!0,L.propertyName,L.name))).elements:S;for(let L of w){let F=Ub.getImportSpecifierInsertionIndex(R,L,x);e.insertImportSpecifierAtIndex(t,L,n.namedBindings,F)}}else if(S?.length)for(let R of w)e.insertNodeInListAfter(t,Va(S),R,S);else if(w.length){let R=U.createNamedImports(w);n.namedBindings?e.replaceNode(t,n.namedBindings,R):e.insertNodeAfter(t,M.checkDefined(n.name,"Import clause must have either named imports or a default import"),R)}}if(d&&(e.delete(t,OQ(n,t)),S))for(let x of S)e.insertModifierBefore(t,156,x);function E(x,D,w){let R=U.createBindingElement(void 0,w,D);x.elements.length?e.insertNodeInListAfter(t,Va(x.elements),R):e.replaceNode(t,x,U.createObjectBindingPattern([R]))}}function ESe(e,t,{namespacePrefix:n,usagePosition:i}){e.insertText(t,i,n+".")}function z9e(e,t,{moduleSpecifier:n,usagePosition:i},s){e.insertText(t,i,W9e(n,s))}function W9e(e,t){let n=DQ(t);return`import(${n}${e}${n}).`}function xSe({addAsTypeOnly:e}){return e===2}function oee(e,t){return xSe(e)||!!t.preferTypeOnlyAutoImports&&e.addAsTypeOnly!==4}function $9e(e,t,n,i,s,o,u){let m=h6(e,t),d;if(n!==void 0||i?.length){let S=(!n||xSe(n))&&wi(i,xSe)||(o.verbatimModuleSyntax||u.preferTypeOnlyAutoImports)&&n?.addAsTypeOnly!==4&&!Pt(i,E=>E.addAsTypeOnly===4);d=vs(d,uS(n&&U.createIdentifier(n.name),i?.map(E=>U.createImportSpecifier(!S&&oee(E,u),void 0,U.createIdentifier(E.name))),e,t,S))}if(s){let S=s.importKind===3?U.createImportEqualsDeclaration(void 0,oee(s,u),U.createIdentifier(s.name),U.createExternalModuleReference(m)):U.createImportDeclaration(void 0,U.createImportClause(oee(s,u),void 0,U.createNamespaceImport(U.createIdentifier(s.name))),m,void 0);d=vs(d,S)}return M.checkDefined(d)}function H9e(e,t,n,i,s){let o=h6(e,t),u;if(n||i?.length){let m=i?.map(({name:S})=>U.createBindingElement(void 0,void 0,S))||[];n&&m.unshift(U.createBindingElement(void 0,"default",n.name));let d=G9e(U.createObjectBindingPattern(m),o);u=vs(u,d)}if(s){let m=G9e(s.name,o);u=vs(u,m)}return M.checkDefined(u)}function G9e(e,t){return U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(typeof e=="string"?U.createIdentifier(e):e,void 0,void 0,U.createCallExpression(U.createIdentifier("require"),void 0,[t]))],2))}function Y9e(e,t){return t===7?!0:t&1?!!(e&111551):t&2?!!(e&788968):t&4?!!(e&1920):!1}var CSe="addMissingConstraint",K9e=[v.Type_0_is_not_comparable_to_type_1.code,v.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated.code,v.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code,v.Type_0_is_not_assignable_to_type_1.code,v.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code,v.Property_0_is_incompatible_with_index_signature.code,v.Property_0_in_type_1_is_not_assignable_to_type_2.code,v.Type_0_does_not_satisfy_the_constraint_1.code];Ta({errorCodes:K9e,getCodeActions(e){let{sourceFile:t,span:n,program:i,preferences:s,host:o}=e,u=X9e(i,t,n);if(u===void 0)return;let m=Sn.ChangeTracker.with(e,d=>Q9e(d,i,s,o,t,u));return[ta(CSe,m,v.Add_extends_constraint,CSe,v.Add_extends_constraint_to_all_type_parameters)]},fixIds:[CSe],getAllCodeActions:e=>{let{program:t,preferences:n,host:i}=e,s=new Map;return _k(Sn.ChangeTracker.with(e,o=>{fk(e,K9e,u=>{let m=X9e(t,u.file,zu(u.start,u.length));if(m&&em(s,yo(m.declaration)))return Q9e(o,t,n,i,u.file,m)})}))}});function X9e(e,t,n){let i=Ln(e.getSemanticDiagnostics(t),u=>u.start===n.start&&u.length===n.length);if(i===void 0||i.relatedInformation===void 0)return;let s=Ln(i.relatedInformation,u=>u.code===v.This_type_parameter_might_need_an_extends_0_constraint.code);if(s===void 0||s.file===void 0||s.start===void 0||s.length===void 0)return;let o=ybe(s.file,zu(s.start,s.length));if(o!==void 0&&(He(o)&&Ac(o.parent)&&(o=o.parent),Ac(o))){if(o2(o.parent))return;let u=Yi(t,n.start),m=e.getTypeChecker();return{constraint:TDt(m,u)||bDt(s.messageText),declaration:o,token:u}}}function Q9e(e,t,n,i,s,o){let{declaration:u,constraint:m}=o,d=t.getTypeChecker();if(bs(m))e.insertText(s,u.name.end,` extends ${m}`);else{let S=Ka(t.getCompilerOptions()),E=aD({program:t,host:i}),x=LE(s,t,n,i),D=MV(d,x,m,void 0,S,void 0,E);D&&(e.replaceNode(s,u,U.updateTypeParameterDeclaration(u,void 0,u.name,D,u.default)),x.writeFixes(e))}}function bDt(e){let[,t]=Zg(e,`
`,0).match(/`extends (.*)`/)||[];return t}function TDt(e,t){return Di(t.parent)?e.getTypeArgumentConstraint(t.parent):(Ct(t)?e.getContextualType(t):void 0)||e.getTypeAtLocation(t)}var Z9e="fixOverrideModifier",VM="fixAddOverrideModifier",OV="fixRemoveOverrideModifier",eje=[v.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code,v.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code,v.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code,v.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code,v.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code,v.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code,v.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code,v.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code,v.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code],tje={[v.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code]:{descriptions:v.Add_override_modifier,fixId:VM,fixAllDescriptions:v.Add_all_missing_override_modifiers},[v.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code]:{descriptions:v.Add_override_modifier,fixId:VM,fixAllDescriptions:v.Add_all_missing_override_modifiers},[v.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code]:{descriptions:v.Remove_override_modifier,fixId:OV,fixAllDescriptions:v.Remove_all_unnecessary_override_modifiers},[v.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code]:{descriptions:v.Remove_override_modifier,fixId:OV,fixAllDescriptions:v.Remove_override_modifier},[v.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code]:{descriptions:v.Add_override_modifier,fixId:VM,fixAllDescriptions:v.Add_all_missing_override_modifiers},[v.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code]:{descriptions:v.Add_override_modifier,fixId:VM,fixAllDescriptions:v.Add_all_missing_override_modifiers},[v.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code]:{descriptions:v.Add_override_modifier,fixId:VM,fixAllDescriptions:v.Remove_all_unnecessary_override_modifiers},[v.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code]:{descriptions:v.Remove_override_modifier,fixId:OV,fixAllDescriptions:v.Remove_all_unnecessary_override_modifiers},[v.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code]:{descriptions:v.Remove_override_modifier,fixId:OV,fixAllDescriptions:v.Remove_all_unnecessary_override_modifiers}};Ta({errorCodes:eje,getCodeActions:function(t){let{errorCode:n,span:i}=t,s=tje[n];if(!s)return ve;let{descriptions:o,fixId:u,fixAllDescriptions:m}=s,d=Sn.ChangeTracker.with(t,S=>rje(S,t,n,i.start));return[H1e(Z9e,d,o,u,m)]},fixIds:[Z9e,VM,OV],getAllCodeActions:e=>Ro(e,eje,(t,n)=>{let{code:i,start:s}=n,o=tje[i];!o||o.fixId!==e.fixId||rje(t,e,i,s)})});function rje(e,t,n,i){switch(n){case v.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code:case v.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code:case v.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code:case v.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code:case v.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code:return EDt(e,t.sourceFile,i);case v.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code:case v.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code:case v.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code:case v.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code:return xDt(e,t.sourceFile,i);default:M.fail("Unexpected error code: "+n)}}function EDt(e,t,n){let i=ije(t,n);if(Af(t)){e.addJSDocTags(t,i,[U.createJSDocOverrideTag(U.createIdentifier("override"))]);return}let s=i.modifiers||ve,o=Ln(s,RA),u=Ln(s,Bde),m=Ln(s,x=>vQ(x.kind)),d=xm(s,fu),S=u?u.end:o?o.end:m?m.end:d?Ja(t.text,d.end):i.getStart(t),E=m||o||u?{prefix:" "}:{suffix:" "};e.insertModifierAt(t,S,164,E)}function xDt(e,t,n){let i=ije(t,n);if(Af(t)){e.filterJSDocTags(t,i,n5(Uj));return}let s=Ln(i.modifiers,Ude);M.assertIsDefined(s),e.deleteModifier(t,s)}function nje(e){switch(e.kind){case 176:case 172:case 174:case 177:case 178:return!0;case 169:return ap(e,e.parent);default:return!1}}function ije(e,t){let n=Yi(e,t),i=Pr(n,s=>gi(s)?"quit":nje(s));return M.assert(i&&nje(i)),i}var ASe="fixNoPropertyAccessFromIndexSignature",sje=[v.Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0.code];Ta({errorCodes:sje,fixIds:[ASe],getCodeActions(e){let{sourceFile:t,span:n,preferences:i}=e,s=oje(t,n.start),o=Sn.ChangeTracker.with(e,u=>aje(u,e.sourceFile,s,i));return[ta(ASe,o,[v.Use_element_access_for_0,s.name.text],ASe,v.Use_element_access_for_all_undeclared_properties)]},getAllCodeActions:e=>Ro(e,sje,(t,n)=>aje(t,n.file,oje(n.file,n.start),e.preferences))});function aje(e,t,n,i){let s=ed(t,i),o=U.createStringLiteral(n.name.text,s===0);e.replaceNode(t,n,A5(n)?U.createElementAccessChain(n.expression,n.questionDotToken,o):U.createElementAccessExpression(n.expression,o))}function oje(e,t){return aa(Yi(e,t).parent,Wn)}var kSe="fixImplicitThis",cje=[v.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code];Ta({errorCodes:cje,getCodeActions:function(t){let{sourceFile:n,program:i,span:s}=t,o,u=Sn.ChangeTracker.with(t,m=>{o=lje(m,n,s.start,i.getTypeChecker())});return o?[ta(kSe,u,o,kSe,v.Fix_all_implicit_this_errors)]:ve},fixIds:[kSe],getAllCodeActions:e=>Ro(e,cje,(t,n)=>{lje(t,n.file,n.start,e.program.getTypeChecker())})});function lje(e,t,n,i){let s=Yi(t,n);if(!$N(s))return;let o=nf(s,!1,!1);if(!(!Tl(o)&&!ic(o))&&!Ji(nf(o,!1,!1))){let u=M.checkDefined(Oo(o,100,t)),{name:m}=o,d=M.checkDefined(o.body);return ic(o)?m&&lc.Core.isSymbolReferencedInFile(m,i,t,d)?void 0:(e.delete(t,u),m&&e.delete(t,m),e.insertText(t,d.pos," =>"),[v.Convert_function_expression_0_to_arrow_function,m?m.text:GQ]):(e.replaceNode(t,u,U.createToken(87)),e.insertText(t,m.end," = "),e.insertText(t,d.pos," =>"),[v.Convert_function_declaration_0_to_arrow_function,m.text])}}var PSe="fixImportNonExportedMember",uje=[v.Module_0_declares_1_locally_but_it_is_not_exported.code];Ta({errorCodes:uje,fixIds:[PSe],getCodeActions(e){let{sourceFile:t,span:n,program:i}=e,s=_je(t,n.start,i);if(s===void 0)return;let o=Sn.ChangeTracker.with(e,u=>CDt(u,i,s));return[ta(PSe,o,[v.Export_0_from_module_1,s.exportName.node.text,s.moduleSpecifier],PSe,v.Export_all_referenced_locals)]},getAllCodeActions(e){let{program:t}=e;return _k(Sn.ChangeTracker.with(e,n=>{let i=new Map;fk(e,uje,s=>{let o=_je(s.file,s.start,t);if(o===void 0)return;let{exportName:u,node:m,moduleSourceFile:d}=o;if(cee(d,u.isTypeOnly)===void 0&&XR(m))n.insertExportModifier(d,m);else{let S=i.get(d)||{typeOnlyExports:[],exports:[]};u.isTypeOnly?S.typeOnlyExports.push(u):S.exports.push(u),i.set(d,S)}}),i.forEach((s,o)=>{let u=cee(o,!0);u&&u.isTypeOnly?(NSe(n,t,o,s.typeOnlyExports,u),NSe(n,t,o,s.exports,cee(o,!1))):NSe(n,t,o,[...s.exports,...s.typeOnlyExports],u)})}))}});function _je(e,t,n){var i,s;let o=Yi(e,t);if(He(o)){let u=Pr(o,Yc);if(u===void 0)return;let m=La(u.moduleSpecifier)?u.moduleSpecifier:void 0;if(m===void 0)return;let d=(i=n.getResolvedModuleFromModuleSpecifier(m,e))==null?void 0:i.resolvedModule;if(d===void 0)return;let S=n.getSourceFile(d.resolvedFileName);if(S===void 0||eD(n,S))return;let E=S.symbol,x=(s=ai(E.valueDeclaration,Lh))==null?void 0:s.locals;if(x===void 0)return;let D=x.get(o.escapedText);if(D===void 0)return;let w=ADt(D);return w===void 0?void 0:{exportName:{node:o,isTypeOnly:EA(w)},node:w,moduleSourceFile:S,moduleSpecifier:m.text}}}function CDt(e,t,{exportName:n,node:i,moduleSourceFile:s}){let o=cee(s,n.isTypeOnly);o?fje(e,t,s,o,[n]):XR(i)?e.insertExportModifier(s,i):pje(e,t,s,[n])}function NSe(e,t,n,i,s){wt(i)&&(s?fje(e,t,n,s,i):pje(e,t,n,i))}function cee(e,t){let n=i=>xl(i)&&(t&&i.isTypeOnly||!i.isTypeOnly);return xm(e.statements,n)}function fje(e,t,n,i,s){let o=i.exportClause&&kd(i.exportClause)?i.exportClause.elements:U.createNodeArray([]),u=!i.isTypeOnly&&!!(Cd(t.getCompilerOptions())||Ln(o,m=>m.isTypeOnly));e.replaceNode(n,i,U.updateExportDeclaration(i,i.modifiers,i.isTypeOnly,U.createNamedExports(U.createNodeArray([...o,...dje(s,u)],o.hasTrailingComma)),i.moduleSpecifier,i.attributes))}function pje(e,t,n,i){e.insertNodeAtEndOfScope(n,n,U.createExportDeclaration(void 0,!1,U.createNamedExports(dje(i,Cd(t.getCompilerOptions()))),void 0,void 0))}function dje(e,t){return U.createNodeArray(Cr(e,n=>U.createExportSpecifier(t&&n.isTypeOnly,void 0,n.node)))}function ADt(e){if(e.valueDeclaration===void 0)return xo(e.declarations);let t=e.valueDeclaration,n=Ei(t)?ai(t.parent.parent,_l):void 0;return n&&wt(n.declarationList.declarations)===1?n:t}var DSe="fixIncorrectNamedTupleSyntax",kDt=[v.A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type.code,v.A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type.code];Ta({errorCodes:kDt,getCodeActions:function(t){let{sourceFile:n,span:i}=t,s=PDt(n,i.start),o=Sn.ChangeTracker.with(t,u=>NDt(u,n,s));return[ta(DSe,o,v.Move_labeled_tuple_element_modifiers_to_labels,DSe,v.Move_labeled_tuple_element_modifiers_to_labels)]},fixIds:[DSe]});function PDt(e,t){let n=Yi(e,t);return Pr(n,i=>i.kind===202)}function NDt(e,t,n){if(!n)return;let i=n.type,s=!1,o=!1;for(;i.kind===190||i.kind===191||i.kind===196;)i.kind===190?s=!0:i.kind===191&&(o=!0),i=i.type;let u=U.updateNamedTupleMember(n,n.dotDotDotToken||(o?U.createToken(26):void 0),n.name,n.questionToken||(s?U.createToken(58):void 0),i);u!==n&&e.replaceNode(t,n,u)}var mje="fixSpelling",gje=[v.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code,v.Property_0_may_not_exist_on_type_1_Did_you_mean_2.code,v.Cannot_find_name_0_Did_you_mean_1.code,v.Could_not_find_name_0_Did_you_mean_1.code,v.Cannot_find_namespace_0_Did_you_mean_1.code,v.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,v.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code,v._0_has_no_exported_member_named_1_Did_you_mean_2.code,v.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1.code,v.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1.code,v.No_overload_matches_this_call.code,v.Type_0_is_not_assignable_to_type_1.code];Ta({errorCodes:gje,getCodeActions(e){let{sourceFile:t,errorCode:n}=e,i=hje(t,e.span.start,e,n);if(!i)return;let{node:s,suggestedSymbol:o}=i,u=Ka(e.host.getCompilationSettings()),m=Sn.ChangeTracker.with(e,d=>yje(d,t,s,o,u));return[ta("spelling",m,[v.Change_spelling_to_0,Qc(o)],mje,v.Fix_all_detected_spelling_errors)]},fixIds:[mje],getAllCodeActions:e=>Ro(e,gje,(t,n)=>{let i=hje(n.file,n.start,e,n.code),s=Ka(e.host.getCompilationSettings());i&&yje(t,e.sourceFile,i.node,i.suggestedSymbol,s)})});function hje(e,t,n,i){let s=Yi(e,t),o=s.parent;if((i===v.No_overload_matches_this_call.code||i===v.Type_0_is_not_assignable_to_type_1.code)&&!Kg(o))return;let u=n.program.getTypeChecker(),m;if(Wn(o)&&o.name===s){M.assert(Cy(s),"Expected an identifier for spelling (property access)");let d=u.getTypeAtLocation(o.expression);o.flags&64&&(d=u.getNonNullableType(d)),m=u.getSuggestedSymbolForNonexistentProperty(s,d)}else if(Pn(o)&&o.operatorToken.kind===103&&o.left===s&&Zi(s)){let d=u.getTypeAtLocation(o.right);m=u.getSuggestedSymbolForNonexistentProperty(s,d)}else if(cf(o)&&o.right===s){let d=u.getSymbolAtLocation(o.left);d&&d.flags&1536&&(m=u.getSuggestedSymbolForNonexistentModule(o.right,d))}else if(_f(o)&&o.name===s){M.assertNode(s,He,"Expected an identifier for spelling (import)");let d=Pr(s,Yc),S=wDt(n,d,e);S&&S.symbol&&(m=u.getSuggestedSymbolForNonexistentModule(s,S.symbol))}else if(Kg(o)&&o.name===s){M.assertNode(s,He,"Expected an identifier for JSX attribute");let d=Pr(s,__),S=u.getContextualTypeForArgumentAtIndex(d,0);m=u.getSuggestedSymbolForNonexistentJSXAttribute(s,S)}else if(I9(o)&&uu(o)&&o.name===s){let d=Pr(s,gi),S=d?Fg(d):void 0,E=S?u.getTypeAtLocation(S):void 0;E&&(m=u.getSuggestedSymbolForNonexistentClassMember(Hc(s),E))}else{let d=S2(s),S=Hc(s);M.assert(S!==void 0,"name should be defined"),m=u.getSuggestedSymbolForNonexistentSymbol(s,S,DDt(d))}return m===void 0?void 0:{node:s,suggestedSymbol:m}}function yje(e,t,n,i,s){let o=Qc(i);if(!sp(o,s)&&Wn(n.parent)){let u=i.valueDeclaration;u&&Wu(u)&&Zi(u.name)?e.replaceNode(t,n,U.createIdentifier(o)):e.replaceNode(t,n.parent,U.createElementAccessExpression(n.parent.expression,U.createStringLiteral(o)))}else e.replaceNode(t,n,U.createIdentifier(o))}function DDt(e){let t=0;return e&4&&(t|=1920),e&2&&(t|=788968),e&1&&(t|=111551),t}function wDt(e,t,n){var i;if(!t||!No(t.moduleSpecifier))return;let s=(i=e.program.getResolvedModuleFromModuleSpecifier(t.moduleSpecifier,n))==null?void 0:i.resolvedModule;if(s)return e.program.getSourceFile(s.resolvedFileName)}var wSe="returnValueCorrect",ISe="fixAddReturnStatement",OSe="fixRemoveBracesFromArrowFunctionBody",RSe="fixWrapTheBlockWithParen",vje=[v.A_function_whose_declared_type_is_neither_undefined_void_nor_any_must_return_a_value.code,v.Type_0_is_not_assignable_to_type_1.code,v.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code];Ta({errorCodes:vje,fixIds:[ISe,OSe,RSe],getCodeActions:function(t){let{program:n,sourceFile:i,span:{start:s},errorCode:o}=t,u=bje(n.getTypeChecker(),i,s,o);if(u)return u.kind===0?Bt([ODt(t,u.expression,u.statement)],pc(u.declaration)?RDt(t,u.declaration,u.expression,u.commentSource):void 0):[MDt(t,u.declaration,u.expression)]},getAllCodeActions:e=>Ro(e,vje,(t,n)=>{let i=bje(e.program.getTypeChecker(),n.file,n.start,n.code);if(i)switch(e.fixId){case ISe:Tje(t,n.file,i.expression,i.statement);break;case OSe:if(!pc(i.declaration))return;Eje(t,n.file,i.declaration,i.expression,i.commentSource,!1);break;case RSe:if(!pc(i.declaration))return;xje(t,n.file,i.declaration,i.expression);break;default:M.fail(JSON.stringify(e.fixId))}})});function Sje(e,t,n){let i=e.createSymbol(4,t.escapedText);i.links.type=e.getTypeAtLocation(n);let s=fa([i]);return e.createAnonymousType(void 0,s,[],[],[])}function MSe(e,t,n,i){if(!t.body||!Vs(t.body)||wt(t.body.statements)!==1)return;let s=Ma(t.body.statements);if(Du(s)&&LSe(e,t,e.getTypeAtLocation(s.expression),n,i))return{declaration:t,kind:0,expression:s.expression,statement:s,commentSource:s.expression};if(rS(s)&&Du(s.statement)){let o=U.createObjectLiteralExpression([U.createPropertyAssignment(s.label,s.statement.expression)]),u=Sje(e,s.label,s.statement.expression);if(LSe(e,t,u,n,i))return pc(t)?{declaration:t,kind:1,expression:o,statement:s,commentSource:s.statement.expression}:{declaration:t,kind:0,expression:o,statement:s,commentSource:s.statement.expression}}else if(Vs(s)&&wt(s.statements)===1){let o=Ma(s.statements);if(rS(o)&&Du(o.statement)){let u=U.createObjectLiteralExpression([U.createPropertyAssignment(o.label,o.statement.expression)]),m=Sje(e,o.label,o.statement.expression);if(LSe(e,t,m,n,i))return{declaration:t,kind:0,expression:u,statement:s,commentSource:o}}}}function LSe(e,t,n,i,s){if(s){let o=e.getSignatureFromDeclaration(t);if(o){li(t,1024)&&(n=e.createPromiseType(n));let u=e.createSignature(t,o.typeParameters,o.thisParameter,o.parameters,n,void 0,o.minArgumentCount,o.flags);n=e.createAnonymousType(void 0,fa(),[u],[],[])}else n=e.getAnyType()}return e.isTypeAssignableTo(n,i)}function bje(e,t,n,i){let s=Yi(t,n);if(!s.parent)return;let o=Pr(s.parent,Go);switch(i){case v.A_function_whose_declared_type_is_neither_undefined_void_nor_any_must_return_a_value.code:return!o||!o.body||!o.type||!Zp(o.type,s)?void 0:MSe(e,o,e.getTypeFromTypeNode(o.type),!1);case v.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code:if(!o||!ea(o.parent)||!o.body)return;let u=o.parent.arguments.indexOf(o);if(u===-1)return;let m=e.getContextualTypeForArgumentAtIndex(o.parent,u);return m?MSe(e,o,m,!0):void 0;case v.Type_0_is_not_assignable_to_type_1.code:if(!Uh(s)||!rA(s.parent)&&!Kg(s.parent))return;let d=IDt(s.parent);return!d||!Go(d)||!d.body?void 0:MSe(e,d,e.getTypeAtLocation(s.parent),!0)}}function IDt(e){switch(e.kind){case 260:case 169:case 208:case 172:case 303:return e.initializer;case 291:return e.initializer&&(wO(e.initializer)?e.initializer.expression:void 0);case 304:case 171:case 306:case 348:case 341:return}}function Tje(e,t,n,i){gp(n);let s=EM(t);e.replaceNode(t,i,U.createReturnStatement(n),{leadingTriviaOption:Sn.LeadingTriviaOption.Exclude,trailingTriviaOption:Sn.TrailingTriviaOption.Exclude,suffix:s?";":void 0})}function Eje(e,t,n,i,s,o){let u=o||$U(i)?U.createParenthesizedExpression(i):i;gp(s),T2(s,u),e.replaceNode(t,n.body,u)}function xje(e,t,n,i){e.replaceNode(t,n.body,U.createParenthesizedExpression(i))}function ODt(e,t,n){let i=Sn.ChangeTracker.with(e,s=>Tje(s,e.sourceFile,t,n));return ta(wSe,i,v.Add_a_return_statement,ISe,v.Add_all_missing_return_statement)}function RDt(e,t,n,i){let s=Sn.ChangeTracker.with(e,o=>Eje(o,e.sourceFile,t,n,i,!1));return ta(wSe,s,v.Remove_braces_from_arrow_function_body,OSe,v.Remove_braces_from_all_arrow_function_bodies_with_relevant_issues)}function MDt(e,t,n){let i=Sn.ChangeTracker.with(e,s=>xje(s,e.sourceFile,t,n));return ta(wSe,i,v.Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal,RSe,v.Wrap_all_object_literal_with_parentheses)}var jb="fixMissingMember",lee="fixMissingProperties",uee="fixMissingAttributes",_ee="fixMissingFunctionDeclaration",Cje=[v.Property_0_does_not_exist_on_type_1.code,v.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code,v.Property_0_is_missing_in_type_1_but_required_in_type_2.code,v.Type_0_is_missing_the_following_properties_from_type_1_Colon_2.code,v.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more.code,v.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,v.Cannot_find_name_0.code];Ta({errorCodes:Cje,getCodeActions(e){let t=e.program.getTypeChecker(),n=Aje(e.sourceFile,e.span.start,e.errorCode,t,e.program);if(n){if(n.kind===3){let i=Sn.ChangeTracker.with(e,s=>Lje(s,e,n));return[ta(lee,i,v.Add_missing_properties,lee,v.Add_all_missing_properties)]}if(n.kind===4){let i=Sn.ChangeTracker.with(e,s=>Mje(s,e,n));return[ta(uee,i,v.Add_missing_attributes,uee,v.Add_all_missing_attributes)]}if(n.kind===2||n.kind===5){let i=Sn.ChangeTracker.with(e,s=>Rje(s,e,n));return[ta(_ee,i,[v.Add_missing_function_declaration_0,n.token.text],_ee,v.Add_all_missing_function_declarations)]}if(n.kind===1){let i=Sn.ChangeTracker.with(e,s=>Oje(s,e.program.getTypeChecker(),n));return[ta(jb,i,[v.Add_missing_enum_member_0,n.token.text],jb,v.Add_all_missing_members)]}return ps(UDt(e,n),LDt(e,n))}},fixIds:[jb,_ee,lee,uee],getAllCodeActions:e=>{let{program:t,fixId:n}=e,i=t.getTypeChecker(),s=new Map,o=new Map;return _k(Sn.ChangeTracker.with(e,u=>{fk(e,Cje,m=>{let d=Aje(m.file,m.start,m.code,i,e.program);if(!(!d||!em(s,yo(d.parentDeclaration)+"#"+(d.kind===3?d.identifier:d.token.text)))){if(n===_ee&&(d.kind===2||d.kind===5))Rje(u,e,d);else if(n===lee&&d.kind===3)Lje(u,e,d);else if(n===uee&&d.kind===4)Mje(u,e,d);else if(d.kind===1&&Oje(u,i,d),d.kind===0){let{parentDeclaration:S,token:E}=d,x=dv(o,S,()=>[]);x.some(D=>D.token.text===E.text)||x.push(d)}}}),o.forEach((m,d)=>{let S=lf(d)?void 0:vbe(d,i);for(let E of m){if(S?.some(J=>{let G=o.get(J);return!!G&&G.some(({token:q})=>q.text===E.token.text)}))continue;let{parentDeclaration:x,declSourceFile:D,modifierFlags:w,token:R,call:L,isJSFile:F}=E;if(L&&!Zi(R))Ije(e,u,L,R,w&256,x,D);else if(F&&!Yu(x)&&!lf(x))kje(u,D,x,R,!!(w&256));else{let J=Nje(i,x,R);Dje(u,D,x,R.text,J,w&256)}}})}))}});function Aje(e,t,n,i,s){var o;let u=Yi(e,t),m=u.parent;if(n===v.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code){if(!(u.kind===19&&Ca(m)&&ea(m.parent)))return;let w=Bo(m.parent.arguments,J=>J===m);if(w<0)return;let R=i.getResolvedSignature(m.parent);if(!(R&&R.declaration&&R.parameters[w]))return;let L=R.parameters[w].valueDeclaration;if(!(L&&ns(L)&&He(L.name)))return;let F=Is(i.getUnmatchedProperties(i.getTypeAtLocation(m),i.getParameterType(R,w),!1,!1));return wt(F)?{kind:3,token:L.name,identifier:L.name.text,properties:F,parentDeclaration:m}:void 0}if(u.kind===19&&Ca(m)){let w=i.getContextualType(m)||i.getTypeAtLocation(m),R=Is(i.getUnmatchedProperties(i.getTypeAtLocation(m),w,!1,!1));return wt(R)?{kind:3,token:m,identifier:"",properties:R,parentDeclaration:m}:void 0}if(!Cy(u))return;if(He(u)&&bv(m)&&m.initializer&&Ca(m.initializer)){let w=i.getContextualType(u)||i.getTypeAtLocation(u),R=Is(i.getUnmatchedProperties(i.getTypeAtLocation(m.initializer),w,!1,!1));return wt(R)?{kind:3,token:u,identifier:u.text,properties:R,parentDeclaration:m.initializer}:void 0}if(He(u)&&__(u.parent)){let w=Ka(s.getCompilerOptions()),R=JDt(i,w,u.parent);return wt(R)?{kind:4,token:u,attributes:R,parentDeclaration:u.parent}:void 0}if(He(u)){let w=(o=i.getContextualType(u))==null?void 0:o.getNonNullableType();if(w&&Kn(w)&16){let R=xo(i.getSignaturesOfType(w,0));return R===void 0?void 0:{kind:5,token:u,signature:R,sourceFile:e,parentDeclaration:Fje(u)}}if(ea(m)&&m.expression===u)return{kind:2,token:u,call:m,sourceFile:e,modifierFlags:0,parentDeclaration:Fje(u)}}if(!Wn(m))return;let d=AQ(i.getTypeAtLocation(m.expression)),S=d.symbol;if(!S||!S.declarations)return;if(He(u)&&ea(m.parent)){let w=Ln(S.declarations,El),R=w?.getSourceFile();if(w&&R&&!eD(s,R))return{kind:2,token:u,call:m.parent,sourceFile:e,modifierFlags:32,parentDeclaration:w};let L=Ln(S.declarations,Ji);if(e.commonJsModuleIndicator)return;if(L&&!eD(s,L))return{kind:2,token:u,call:m.parent,sourceFile:L,modifierFlags:32,parentDeclaration:L}}let E=Ln(S.declarations,gi);if(!E&&Zi(u))return;let x=E||Ln(S.declarations,w=>Yu(w)||lf(w));if(x&&!eD(s,x.getSourceFile())){let w=!lf(x)&&(d.target||d)!==i.getDeclaredTypeOfSymbol(S);if(w&&(Zi(u)||Yu(x)))return;let R=x.getSourceFile(),L=lf(x)?0:(w?256:0)|(rZ(u.text)?2:0),F=Af(R),J=ai(m.parent,ea);return{kind:0,token:u,call:J,modifierFlags:L,parentDeclaration:x,declSourceFile:R,isJSFile:F}}let D=Ln(S.declarations,bb);if(D&&!(d.flags&1056)&&!Zi(u)&&!eD(s,D.getSourceFile()))return{kind:1,token:u,parentDeclaration:D}}function LDt(e,t){return t.isJSFile?qC(FDt(e,t)):jDt(e,t)}function FDt(e,{parentDeclaration:t,declSourceFile:n,modifierFlags:i,token:s}){if(Yu(t)||lf(t))return;let o=Sn.ChangeTracker.with(e,m=>kje(m,n,t,s,!!(i&256)));if(o.length===0)return;let u=i&256?v.Initialize_static_property_0:Zi(s)?v.Declare_a_private_field_named_0:v.Initialize_property_0_in_the_constructor;return ta(jb,o,[u,s.text],jb,v.Add_all_missing_members)}function kje(e,t,n,i,s){let o=i.text;if(s){if(n.kind===231)return;let u=n.name.getText(),m=Pje(U.createIdentifier(u),o);e.insertNodeAfter(t,n,m)}else if(Zi(i)){let u=U.createPropertyDeclaration(void 0,o,void 0,void 0,void 0),m=wje(n);m?e.insertNodeAfter(t,m,u):e.insertMemberAtStart(t,n,u)}else{let u=Ny(n);if(!u)return;let m=Pje(U.createThis(),o);e.insertNodeAtConstructorEnd(t,u,m)}}function Pje(e,t){return U.createExpressionStatement(U.createAssignment(U.createPropertyAccessExpression(e,t),dk()))}function jDt(e,{parentDeclaration:t,declSourceFile:n,modifierFlags:i,token:s}){let o=s.text,u=i&256,m=Nje(e.program.getTypeChecker(),t,s),d=E=>Sn.ChangeTracker.with(e,x=>Dje(x,n,t,o,m,E)),S=[ta(jb,d(i&256),[u?v.Declare_static_property_0:v.Declare_property_0,o],jb,v.Add_all_missing_members)];return u||Zi(s)||(i&2&&S.unshift(_g(jb,d(2),[v.Declare_private_property_0,o])),S.push(BDt(e,n,t,s.text,m))),S}function Nje(e,t,n){let i;if(n.parent.parent.kind===226){let s=n.parent.parent,o=n.parent===s.left?s.right:s.left,u=e.getWidenedType(e.getBaseTypeOfLiteralType(e.getTypeAtLocation(o)));i=e.typeToTypeNode(u,t,1)}else{let s=e.getContextualType(n.parent);i=s?e.typeToTypeNode(s,void 0,1):void 0}return i||U.createKeywordTypeNode(133)}function Dje(e,t,n,i,s,o){let u=o?U.createNodeArray(U.createModifiersFromModifierFlags(o)):void 0,m=gi(n)?U.createPropertyDeclaration(u,i,void 0,s,void 0):U.createPropertySignature(void 0,i,void 0,s),d=wje(n);d?e.insertNodeAfter(t,d,m):e.insertMemberAtStart(t,n,m)}function wje(e){let t;for(let n of e.members){if(!Ns(n))break;t=n}return t}function BDt(e,t,n,i,s){let o=U.createKeywordTypeNode(154),u=U.createParameterDeclaration(void 0,void 0,"x",void 0,o,void 0),m=U.createIndexSignature(void 0,[u],s),d=Sn.ChangeTracker.with(e,S=>S.insertMemberAtStart(t,n,m));return _g(jb,d,[v.Add_index_signature_for_property_0,i])}function UDt(e,t){let{parentDeclaration:n,declSourceFile:i,modifierFlags:s,token:o,call:u}=t;if(u===void 0)return;let m=o.text,d=E=>Sn.ChangeTracker.with(e,x=>Ije(e,x,u,o,E,n,i)),S=[ta(jb,d(s&256),[s&256?v.Declare_static_method_0:v.Declare_method_0,m],jb,v.Add_all_missing_members)];return s&2&&S.unshift(_g(jb,d(2),[v.Declare_private_method_0,m])),S}function Ije(e,t,n,i,s,o,u){let m=LE(u,e.program,e.preferences,e.host),d=gi(o)?174:173,S=fbe(d,e,m,n,i,s,o),E=qDt(o,n);E?t.insertNodeAfter(u,E,S):t.insertMemberAtStart(u,o,S),m.writeFixes(t)}function Oje(e,t,{token:n,parentDeclaration:i}){let s=Pt(i.members,d=>{let S=t.getTypeAtLocation(d);return!!(S&&S.flags&402653316)}),o=i.getSourceFile(),u=U.createEnumMember(n,s?U.createStringLiteral(n.text):void 0),m=vc(i.members);m?e.insertNodeInListAfter(o,m,u,i.members):e.insertMemberAtStart(o,i,u)}function Rje(e,t,n){let i=ed(t.sourceFile,t.preferences),s=LE(t.sourceFile,t.program,t.preferences,t.host),o=n.kind===2?fbe(262,t,s,n.call,Nn(n.token),n.modifierFlags,n.parentDeclaration):bee(262,t,i,n.signature,LV(v.Function_not_implemented.message,i),n.token,void 0,void 0,void 0,s);o===void 0&&M.fail("fixMissingFunctionDeclaration codefix got unexpected error."),nm(n.parentDeclaration)?e.insertNodeBefore(n.sourceFile,n.parentDeclaration,o,!0):e.insertNodeAtEndOfScope(n.sourceFile,n.parentDeclaration,o),s.writeFixes(e)}function Mje(e,t,n){let i=LE(t.sourceFile,t.program,t.preferences,t.host),s=ed(t.sourceFile,t.preferences),o=t.program.getTypeChecker(),u=n.parentDeclaration.attributes,m=Pt(u.properties,qA),d=Cr(n.attributes,x=>{let D=fee(t,o,i,s,o.getTypeOfSymbol(x),n.parentDeclaration),w=U.createIdentifier(x.name),R=U.createJsxAttribute(w,U.createJsxExpression(void 0,D));return lo(w,R),R}),S=U.createJsxAttributes(m?[...d,...u.properties]:[...u.properties,...d]),E={prefix:u.pos===u.end?" ":void 0};e.replaceNode(t.sourceFile,u,S,E),i.writeFixes(e)}function Lje(e,t,n){let i=LE(t.sourceFile,t.program,t.preferences,t.host),s=ed(t.sourceFile,t.preferences),o=Ka(t.program.getCompilerOptions()),u=t.program.getTypeChecker(),m=Cr(n.properties,S=>{let E=fee(t,u,i,s,u.getTypeOfSymbol(S),n.parentDeclaration);return U.createPropertyAssignment(zDt(S,o,s,u),E)}),d={leadingTriviaOption:Sn.LeadingTriviaOption.Exclude,trailingTriviaOption:Sn.TrailingTriviaOption.Exclude,indentation:n.indentation};e.replaceNode(t.sourceFile,n.parentDeclaration,U.createObjectLiteralExpression([...n.parentDeclaration.properties,...m],!0),d),i.writeFixes(e)}function fee(e,t,n,i,s,o){if(s.flags&3)return dk();if(s.flags&134217732)return U.createStringLiteral("",i===0);if(s.flags&8)return U.createNumericLiteral(0);if(s.flags&64)return U.createBigIntLiteral("0n");if(s.flags&16)return U.createFalse();if(s.flags&1056){let u=s.symbol.exports?Nh(s.symbol.exports.values()):s.symbol,m=t.symbolToExpression(s.symbol.parent?s.symbol.parent:s.symbol,111551,void 0,64);return u===void 0||m===void 0?U.createNumericLiteral(0):U.createPropertyAccessExpression(m,t.symbolToString(u))}if(s.flags&256)return U.createNumericLiteral(s.value);if(s.flags&2048)return U.createBigIntLiteral(s.value);if(s.flags&128)return U.createStringLiteral(s.value,i===0);if(s.flags&512)return s===t.getFalseType()||s===t.getFalseType(!0)?U.createFalse():U.createTrue();if(s.flags&65536)return U.createNull();if(s.flags&1048576)return yi(s.types,m=>fee(e,t,n,i,m,o))??dk();if(t.isArrayLikeType(s))return U.createArrayLiteralExpression();if(VDt(s)){let u=Cr(t.getPropertiesOfType(s),m=>{let d=fee(e,t,n,i,t.getTypeOfSymbol(m),o);return U.createPropertyAssignment(m.name,d)});return U.createObjectLiteralExpression(u,!0)}if(Kn(s)&16){if(Ln(s.symbol.declarations||ve,Jp(Jh,$g,ul))===void 0)return dk();let m=t.getSignaturesOfType(s,0);return m===void 0?dk():bee(218,e,i,m[0],LV(v.Function_not_implemented.message,i),void 0,void 0,void 0,o,n)??dk()}if(Kn(s)&1){let u=S0(s.symbol);if(u===void 0||oE(u))return dk();let m=Ny(u);return m&&wt(m.parameters)?dk():U.createNewExpression(U.createIdentifier(s.symbol.name),void 0,void 0)}return dk()}function dk(){return U.createIdentifier("undefined")}function VDt(e){return e.flags&524288&&(Kn(e)&128||e.symbol&&ai(Dh(e.symbol.declarations),lf))}function JDt(e,t,n){let i=e.getContextualType(n.attributes);if(i===void 0)return ve;let s=i.getProperties();if(!wt(s))return ve;let o=new Set;for(let u of n.attributes.properties)if(Kg(u)&&o.add(gO(u.name)),qA(u)){let m=e.getTypeAtLocation(u.expression);for(let d of m.getProperties())o.add(d.escapedName)}return Zn(s,u=>sp(u.name,t,1)&&!(u.flags&16777216||ll(u)&48||o.has(u.escapedName)))}function qDt(e,t){if(lf(e))return;let n=Pr(t,i=>ul(i)||Vc(i));return n&&n.parent===e?n:void 0}function zDt(e,t,n,i){if(jh(e)){let s=i.symbolToNode(e,111551,void 0,1073741824);if(s&&za(s))return s}return pj(e.name,t,n===0,!1,!1)}function Fje(e){if(Pr(e,wO)){let t=Pr(e.parent,nm);if(t)return t}return Ur(e)}var FSe="addMissingNewOperator",jje=[v.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new.code];Ta({errorCodes:jje,getCodeActions(e){let{sourceFile:t,span:n}=e,i=Sn.ChangeTracker.with(e,s=>Bje(s,t,n));return[ta(FSe,i,v.Add_missing_new_operator_to_call,FSe,v.Add_missing_new_operator_to_all_calls)]},fixIds:[FSe],getAllCodeActions:e=>Ro(e,jje,(t,n)=>Bje(t,e.sourceFile,n))});function Bje(e,t,n){let i=aa(WDt(t,n),ea),s=U.createNewExpression(i.expression,i.typeArguments,i.arguments);e.replaceNode(t,i,s)}function WDt(e,t){let n=Yi(e,t.start),i=bl(t);for(;n.end<i;)n=n.parent;return n}var pee="addMissingParam",dee="addOptionalParam",Uje=[v.Expected_0_arguments_but_got_1.code];Ta({errorCodes:Uje,fixIds:[pee,dee],getCodeActions(e){let t=Vje(e.sourceFile,e.program,e.span.start);if(t===void 0)return;let{name:n,declarations:i,newParameters:s,newOptionalParameters:o}=t,u=[];return wt(s)&&Bt(u,ta(pee,Sn.ChangeTracker.with(e,m=>mee(m,e.program,e.preferences,e.host,i,s)),[wt(s)>1?v.Add_missing_parameters_to_0:v.Add_missing_parameter_to_0,n],pee,v.Add_all_missing_parameters)),wt(o)&&Bt(u,ta(dee,Sn.ChangeTracker.with(e,m=>mee(m,e.program,e.preferences,e.host,i,o)),[wt(o)>1?v.Add_optional_parameters_to_0:v.Add_optional_parameter_to_0,n],dee,v.Add_all_optional_parameters)),u},getAllCodeActions:e=>Ro(e,Uje,(t,n)=>{let i=Vje(e.sourceFile,e.program,n.start);if(i){let{declarations:s,newParameters:o,newOptionalParameters:u}=i;e.fixId===pee&&mee(t,e.program,e.preferences,e.host,s,o),e.fixId===dee&&mee(t,e.program,e.preferences,e.host,s,u)}})});function Vje(e,t,n){let i=Yi(e,n),s=Pr(i,ea);if(s===void 0||wt(s.arguments)===0)return;let o=t.getTypeChecker(),u=o.getTypeAtLocation(s.expression),m=Zn(u.symbol.declarations,Jje);if(m===void 0)return;let d=vc(m);if(d===void 0||d.body===void 0||eD(t,d.getSourceFile()))return;let S=$Dt(d);if(S===void 0)return;let E=[],x=[],D=wt(d.parameters),w=wt(s.arguments);if(D>w)return;let R=[d,...GDt(d,m)];for(let L=0,F=0,J=0;L<w;L++){let G=s.arguments[L],q=oc(G)?_G(G):G,ee=o.getWidenedType(o.getBaseTypeOfLiteralType(o.getTypeAtLocation(G))),W=F<D?d.parameters[F]:void 0;if(W&&o.isTypeAssignableTo(ee,o.getTypeAtLocation(W))){F++;continue}let pe=q&&He(q)?q.text:`p${J++}`,K=HDt(o,ee,d);Bt(E,{pos:L,declaration:zje(pe,K,void 0)}),!KDt(R,F)&&Bt(x,{pos:L,declaration:zje(pe,K,U.createToken(58))})}return{newParameters:E,newOptionalParameters:x,name:Yo(S),declarations:R}}function $Dt(e){let t=Ps(e);if(t)return t;if(Ei(e.parent)&&He(e.parent.name)||Ns(e.parent)||ns(e.parent))return e.parent.name}function HDt(e,t,n){return e.typeToTypeNode(e.getWidenedType(t),n,1)??U.createKeywordTypeNode(159)}function mee(e,t,n,i,s,o){let u=Ka(t.getCompilerOptions());kt(s,m=>{let d=Ur(m),S=LE(d,t,n,i);wt(m.parameters)?e.replaceNodeRangeWithNodes(d,Ma(m.parameters),Va(m.parameters),qje(S,u,m,o),{joiner:", ",indentation:0,leadingTriviaOption:Sn.LeadingTriviaOption.IncludeAll,trailingTriviaOption:Sn.TrailingTriviaOption.Include}):kt(qje(S,u,m,o),(E,x)=>{wt(m.parameters)===0&&x===0?e.insertNodeAt(d,m.parameters.end,E):e.insertNodeAtEndOfList(d,m.parameters,E)}),S.writeFixes(e)})}function Jje(e){switch(e.kind){case 262:case 218:case 174:case 219:return!0;default:return!1}}function qje(e,t,n,i){let s=Cr(n.parameters,o=>U.createParameterDeclaration(o.modifiers,o.dotDotDotToken,o.name,o.questionToken,o.type,o.initializer));for(let{pos:o,declaration:u}of i){let m=o>0?s[o-1]:void 0;s.splice(o,0,U.updateParameterDeclaration(u,u.modifiers,u.dotDotDotToken,u.name,m&&m.questionToken?U.createToken(58):u.questionToken,XDt(e,u.type,t),u.initializer))}return s}function GDt(e,t){let n=[];for(let i of t)if(YDt(i)){if(wt(i.parameters)===wt(e.parameters)){n.push(i);continue}if(wt(i.parameters)>wt(e.parameters))return[]}return n}function YDt(e){return Jje(e)&&e.body===void 0}function zje(e,t,n){return U.createParameterDeclaration(void 0,void 0,e,n,t,void 0)}function KDt(e,t){return wt(e)&&Pt(e,n=>t<wt(n.parameters)&&!!n.parameters[t]&&n.parameters[t].questionToken===void 0)}function XDt(e,t,n){let i=x2(t,n);return i?(mk(e,i.symbols),i.typeNode):t}var QDt="fixCannotFindModule",jSe="installTypesPackage",Wje=v.Cannot_find_module_0_or_its_corresponding_type_declarations.code,$je=[Wje,v.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type.code];Ta({errorCodes:$je,getCodeActions:function(t){let{host:n,sourceFile:i,span:{start:s}}=t,o=Gje(i,s);if(o===void 0)return;let u=Yje(o,n,t.errorCode);return u===void 0?[]:[ta(QDt,[],[v.Install_0,u],jSe,v.Install_all_missing_types_packages,Hje(i.fileName,u))]},fixIds:[jSe],getAllCodeActions:e=>Ro(e,$je,(t,n,i)=>{let s=Gje(n.file,n.start);if(s!==void 0)switch(e.fixId){case jSe:{let o=Yje(s,e.host,n.code);o&&i.push(Hje(n.file.fileName,o));break}default:M.fail(`Bad fixId: ${e.fixId}`)}})});function Hje(e,t){return{type:"install package",file:e,packageName:t}}function Gje(e,t){let n=ai(Yi(e,t),La);if(!n)return;let i=n.text,{packageName:s}=bB(i);return vu(s)?void 0:s}function Yje(e,t,n){var i;return n===Wje?eh.nodeCoreModules.has(e)?"@types/node":void 0:(i=t.isKnownTypesPackageName)!=null&&i.call(t,e)?EB(e):void 0}var Kje=[v.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2.code,v.Non_abstract_class_0_is_missing_implementations_for_the_following_members_of_1_Colon_2.code,v.Non_abstract_class_0_is_missing_implementations_for_the_following_members_of_1_Colon_2_and_3_more.code,v.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1.code,v.Non_abstract_class_expression_is_missing_implementations_for_the_following_members_of_0_Colon_1.code,v.Non_abstract_class_expression_is_missing_implementations_for_the_following_members_of_0_Colon_1_and_2_more.code],BSe="fixClassDoesntImplementInheritedAbstractMember";Ta({errorCodes:Kje,getCodeActions:function(t){let{sourceFile:n,span:i}=t,s=Sn.ChangeTracker.with(t,o=>Qje(Xje(n,i.start),n,t,o,t.preferences));return s.length===0?void 0:[ta(BSe,s,v.Implement_inherited_abstract_class,BSe,v.Implement_all_inherited_abstract_classes)]},fixIds:[BSe],getAllCodeActions:function(t){let n=new Map;return Ro(t,Kje,(i,s)=>{let o=Xje(s.file,s.start);em(n,yo(o))&&Qje(o,t.sourceFile,t,i,t.preferences)})}});function Xje(e,t){let n=Yi(e,t);return aa(n.parent,gi)}function Qje(e,t,n,i,s){let o=Fg(e),u=n.program.getTypeChecker(),m=u.getTypeAtLocation(o),d=u.getPropertiesOfType(m).filter(ZDt),S=LE(t,n.program,s,n.host);_be(e,d,t,n,s,S,E=>i.insertMemberAtStart(t,e,E)),S.writeFixes(i)}function ZDt(e){let t=Nv(Ma(e.getDeclarations()));return!(t&2)&&!!(t&64)}var USe="classSuperMustPrecedeThisAccess",Zje=[v.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class.code];Ta({errorCodes:Zje,getCodeActions(e){let{sourceFile:t,span:n}=e,i=tBe(t,n.start);if(!i)return;let{constructor:s,superCall:o}=i,u=Sn.ChangeTracker.with(e,m=>eBe(m,t,s,o));return[ta(USe,u,v.Make_super_call_the_first_statement_in_the_constructor,USe,v.Make_all_super_calls_the_first_statement_in_their_constructor)]},fixIds:[USe],getAllCodeActions(e){let{sourceFile:t}=e,n=new Map;return Ro(e,Zje,(i,s)=>{let o=tBe(s.file,s.start);if(!o)return;let{constructor:u,superCall:m}=o;em(n,yo(u.parent))&&eBe(i,t,u,m)})}});function eBe(e,t,n,i){e.insertNodeAtConstructorStart(t,n,i),e.delete(t,i)}function tBe(e,t){let n=Yi(e,t);if(n.kind!==110)return;let i=Dp(n),s=rBe(i.body);return s&&!s.expression.arguments.some(o=>Wn(o)&&o.expression===n)?{constructor:i,superCall:s}:void 0}function rBe(e){return Du(e)&&Kx(e.expression)?e:Bs(e)?void 0:Js(e,rBe)}var VSe="constructorForDerivedNeedSuperCall",nBe=[v.Constructors_for_derived_classes_must_contain_a_super_call.code];Ta({errorCodes:nBe,getCodeActions(e){let{sourceFile:t,span:n}=e,i=iBe(t,n.start),s=Sn.ChangeTracker.with(e,o=>sBe(o,t,i));return[ta(VSe,s,v.Add_missing_super_call,VSe,v.Add_all_missing_super_calls)]},fixIds:[VSe],getAllCodeActions:e=>Ro(e,nBe,(t,n)=>sBe(t,e.sourceFile,iBe(n.file,n.start)))});function iBe(e,t){let n=Yi(e,t);return M.assert(Vc(n.parent),"token should be at the constructor declaration"),n.parent}function sBe(e,t,n){let i=U.createExpressionStatement(U.createCallExpression(U.createSuper(),void 0,ve));e.insertNodeAtConstructorStart(t,n,i)}var aBe="fixEnableJsxFlag",oBe=[v.Cannot_use_JSX_unless_the_jsx_flag_is_provided.code];Ta({errorCodes:oBe,getCodeActions:function(t){let{configFile:n}=t.program.getCompilerOptions();if(n===void 0)return;let i=Sn.ChangeTracker.with(t,s=>cBe(s,n));return[_g(aBe,i,v.Enable_the_jsx_flag_in_your_configuration_file)]},fixIds:[aBe],getAllCodeActions:e=>Ro(e,oBe,t=>{let{configFile:n}=e.program.getCompilerOptions();n!==void 0&&cBe(t,n)})});function cBe(e,t){gbe(e,t,"jsx",U.createStringLiteral("react"))}var JSe="fixNaNEquality",lBe=[v.This_condition_will_always_return_0.code];Ta({errorCodes:lBe,getCodeActions(e){let{sourceFile:t,span:n,program:i}=e,s=uBe(i,t,n);if(s===void 0)return;let{suggestion:o,expression:u,arg:m}=s,d=Sn.ChangeTracker.with(e,S=>_Be(S,t,m,u));return[ta(JSe,d,[v.Use_0,o],JSe,v.Use_Number_isNaN_in_all_conditions)]},fixIds:[JSe],getAllCodeActions:e=>Ro(e,lBe,(t,n)=>{let i=uBe(e.program,n.file,zu(n.start,n.length));i&&_Be(t,n.file,i.arg,i.expression)})});function uBe(e,t,n){let i=Ln(e.getSemanticDiagnostics(t),u=>u.start===n.start&&u.length===n.length);if(i===void 0||i.relatedInformation===void 0)return;let s=Ln(i.relatedInformation,u=>u.code===v.Did_you_mean_0.code);if(s===void 0||s.file===void 0||s.start===void 0||s.length===void 0)return;let o=ybe(s.file,zu(s.start,s.length));if(o!==void 0&&Ct(o)&&Pn(o.parent))return{suggestion:ewt(s.messageText),expression:o.parent,arg:o}}function _Be(e,t,n,i){let s=U.createCallExpression(U.createPropertyAccessExpression(U.createIdentifier("Number"),U.createIdentifier("isNaN")),void 0,[n]),o=i.operatorToken.kind;e.replaceNode(t,i,o===38||o===36?U.createPrefixUnaryExpression(54,s):s)}function ewt(e){let[,t]=Zg(e,`
`,0).match(/'(.*)'/)||[];return t}Ta({errorCodes:[v.Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher.code,v.Top_level_await_using_statements_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher.code,v.Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher.code],getCodeActions:function(t){let n=t.program.getCompilerOptions(),{configFile:i}=n;if(i===void 0)return;let s=[],o=V_(n);if(o>=5&&o<99){let S=Sn.ChangeTracker.with(t,E=>{gbe(E,i,"module",U.createStringLiteral("esnext"))});s.push(_g("fixModuleOption",S,[v.Set_the_module_option_in_your_configuration_file_to_0,"esnext"]))}let m=Ka(n);if(m<4||m>99){let S=Sn.ChangeTracker.with(t,E=>{if(!DI(i))return;let D=[["target",U.createStringLiteral("es2017")]];o===1&&D.push(["module",U.createStringLiteral("commonjs")]),mbe(E,i,D)});s.push(_g("fixTargetOption",S,[v.Set_the_target_option_in_your_configuration_file_to_0,"es2017"]))}return s.length?s:void 0}});var qSe="fixPropertyAssignment",fBe=[v.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern.code];Ta({errorCodes:fBe,fixIds:[qSe],getCodeActions(e){let{sourceFile:t,span:n}=e,i=dBe(t,n.start),s=Sn.ChangeTracker.with(e,o=>pBe(o,e.sourceFile,i));return[ta(qSe,s,[v.Change_0_to_1,"=",":"],qSe,[v.Switch_each_misused_0_to_1,"=",":"])]},getAllCodeActions:e=>Ro(e,fBe,(t,n)=>pBe(t,n.file,dBe(n.file,n.start)))});function pBe(e,t,n){e.replaceNode(t,n,U.createPropertyAssignment(n.name,n.objectAssignmentInitializer))}function dBe(e,t){return aa(Yi(e,t).parent,p_)}var zSe="extendsInterfaceBecomesImplements",mBe=[v.Cannot_extend_an_interface_0_Did_you_mean_implements.code];Ta({errorCodes:mBe,getCodeActions(e){let{sourceFile:t}=e,n=gBe(t,e.span.start);if(!n)return;let{extendsToken:i,heritageClauses:s}=n,o=Sn.ChangeTracker.with(e,u=>hBe(u,t,i,s));return[ta(zSe,o,v.Change_extends_to_implements,zSe,v.Change_all_extended_interfaces_to_implements)]},fixIds:[zSe],getAllCodeActions:e=>Ro(e,mBe,(t,n)=>{let i=gBe(n.file,n.start);i&&hBe(t,n.file,i.extendsToken,i.heritageClauses)})});function gBe(e,t){let n=Yi(e,t),i=Ou(n).heritageClauses,s=i[0].getFirstToken();return s.kind===96?{extendsToken:s,heritageClauses:i}:void 0}function hBe(e,t,n,i){if(e.replaceNode(t,n,U.createToken(119)),i.length===2&&i[0].token===96&&i[1].token===119){let s=i[1].getFirstToken(),o=s.getFullStart();e.replaceRange(t,{pos:o,end:o},U.createToken(28));let u=t.text,m=s.end;for(;m<u.length&&wg(u.charCodeAt(m));)m++;e.deleteRange(t,{pos:s.getStart(),end:m})}}var WSe="forgottenThisPropertyAccess",yBe=v.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code,vBe=[v.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,v.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression.code,yBe];Ta({errorCodes:vBe,getCodeActions(e){let{sourceFile:t}=e,n=SBe(t,e.span.start,e.errorCode);if(!n)return;let i=Sn.ChangeTracker.with(e,s=>bBe(s,t,n));return[ta(WSe,i,[v.Add_0_to_unresolved_variable,n.className||"this"],WSe,v.Add_qualifier_to_all_unresolved_variables_matching_a_member_name)]},fixIds:[WSe],getAllCodeActions:e=>Ro(e,vBe,(t,n)=>{let i=SBe(n.file,n.start,n.code);i&&bBe(t,e.sourceFile,i)})});function SBe(e,t,n){let i=Yi(e,t);if(He(i)||Zi(i))return{node:i,className:n===yBe?Ou(i).name.text:void 0}}function bBe(e,t,{node:n,className:i}){gp(n),e.replaceNode(t,n,U.createPropertyAccessExpression(i?U.createIdentifier(i):U.createThis(),n))}var $Se="fixInvalidJsxCharacters_expression",gee="fixInvalidJsxCharacters_htmlEntity",TBe=[v.Unexpected_token_Did_you_mean_or_gt.code,v.Unexpected_token_Did_you_mean_or_rbrace.code];Ta({errorCodes:TBe,fixIds:[$Se,gee],getCodeActions(e){let{sourceFile:t,preferences:n,span:i}=e,s=Sn.ChangeTracker.with(e,u=>HSe(u,n,t,i.start,!1)),o=Sn.ChangeTracker.with(e,u=>HSe(u,n,t,i.start,!0));return[ta($Se,s,v.Wrap_invalid_character_in_an_expression_container,$Se,v.Wrap_all_invalid_characters_in_an_expression_container),ta(gee,o,v.Convert_invalid_character_to_its_html_entity_code,gee,v.Convert_all_invalid_characters_to_HTML_entity_code)]},getAllCodeActions(e){return Ro(e,TBe,(t,n)=>HSe(t,e.preferences,n.file,n.start,e.fixId===gee))}});var EBe={">":"&gt;","}":"&rbrace;"};function twt(e){return Ho(EBe,e)}function HSe(e,t,n,i,s){let o=n.getText()[i];if(!twt(o))return;let u=s?EBe[o]:`{${T6(n,t,o)}}`;e.replaceRangeWithText(n,{pos:i,end:i+1},u)}var hee="deleteUnmatchedParameter",xBe="renameUnmatchedParameter",CBe=[v.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name.code];Ta({fixIds:[hee,xBe],errorCodes:CBe,getCodeActions:function(t){let{sourceFile:n,span:i}=t,s=[],o=ABe(n,i.start);if(o)return Bt(s,rwt(t,o)),Bt(s,nwt(t,o)),s},getAllCodeActions:function(t){let n=new Map;return _k(Sn.ChangeTracker.with(t,i=>{fk(t,CBe,({file:s,start:o})=>{let u=ABe(s,o);u&&n.set(u.signature,Bt(n.get(u.signature),u.jsDocParameterTag))}),n.forEach((s,o)=>{if(t.fixId===hee){let u=new Set(s);i.filterJSDocTags(o.getSourceFile(),o,m=>!u.has(m))}})}))}});function rwt(e,{name:t,jsDocHost:n,jsDocParameterTag:i}){let s=Sn.ChangeTracker.with(e,o=>o.filterJSDocTags(e.sourceFile,n,u=>u!==i));return ta(hee,s,[v.Delete_unused_param_tag_0,t.getText(e.sourceFile)],hee,v.Delete_all_unused_param_tags)}function nwt(e,{name:t,jsDocHost:n,signature:i,jsDocParameterTag:s}){if(!wt(i.parameters))return;let o=e.sourceFile,u=nb(i),m=new Set;for(let x of u)Pd(x)&&He(x.name)&&m.add(x.name.escapedText);let d=yi(i.parameters,x=>He(x.name)&&!m.has(x.name.escapedText)?x.name.getText(o):void 0);if(d===void 0)return;let S=U.updateJSDocParameterTag(s,s.tagName,U.createIdentifier(d),s.isBracketed,s.typeExpression,s.isNameFirst,s.comment),E=Sn.ChangeTracker.with(e,x=>x.replaceJSDocComment(o,n,Cr(u,D=>D===s?S:D)));return _g(xBe,E,[v.Rename_param_tag_name_0_to_1,t.getText(o),d])}function ABe(e,t){let n=Yi(e,t);if(n.parent&&Pd(n.parent)&&He(n.parent.name)){let i=n.parent,s=tE(i),o=ub(i);if(s&&o)return{jsDocHost:s,signature:o,name:n.parent.name,jsDocParameterTag:i}}}var GSe="fixUnreferenceableDecoratorMetadata",iwt=[v.A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled.code];Ta({errorCodes:iwt,getCodeActions:e=>{let t=swt(e.sourceFile,e.program,e.span.start);if(!t)return;let n=Sn.ChangeTracker.with(e,o=>t.kind===276&&owt(o,e.sourceFile,t,e.program)),i=Sn.ChangeTracker.with(e,o=>awt(o,e.sourceFile,t,e.program)),s;return n.length&&(s=Bt(s,_g(GSe,n,v.Convert_named_imports_to_namespace_import))),i.length&&(s=Bt(s,_g(GSe,i,v.Use_import_type))),s},fixIds:[GSe]});function swt(e,t,n){let i=ai(Yi(e,n),He);if(!i||i.parent.kind!==183)return;let o=t.getTypeChecker().getSymbolAtLocation(i);return Ln(o?.declarations||ve,Jp(ig,_f,ru))}function awt(e,t,n,i){if(n.kind===271){e.insertModifierBefore(t,156,n.name);return}let s=n.kind===273?n:n.parent.parent;if(s.name&&s.namedBindings)return;let o=i.getTypeChecker();_fe(s,m=>{if($u(m.symbol,o).flags&111551)return!0})||e.insertModifierBefore(t,156,s)}function owt(e,t,n,i){lk.doChangeNamedToNamespaceOrDefault(t,i,e,n.parent)}var RV="unusedIdentifier",YSe="unusedIdentifier_prefix",KSe="unusedIdentifier_delete",yee="unusedIdentifier_deleteImports",XSe="unusedIdentifier_infer",kBe=[v._0_is_declared_but_its_value_is_never_read.code,v._0_is_declared_but_never_used.code,v.Property_0_is_declared_but_its_value_is_never_read.code,v.All_imports_in_import_declaration_are_unused.code,v.All_destructured_elements_are_unused.code,v.All_variables_are_unused.code,v.All_type_parameters_are_unused.code];Ta({errorCodes:kBe,getCodeActions(e){let{errorCode:t,sourceFile:n,program:i,cancellationToken:s}=e,o=i.getTypeChecker(),u=i.getSourceFiles(),m=Yi(n,e.span.start);if(sm(m))return[I6(Sn.ChangeTracker.with(e,x=>x.delete(n,m)),v.Remove_template_tag)];if(m.kind===30){let x=Sn.ChangeTracker.with(e,D=>NBe(D,n,m));return[I6(x,v.Remove_type_parameters)]}let d=DBe(m);if(d){let x=Sn.ChangeTracker.with(e,D=>D.delete(n,d));return[ta(RV,x,[v.Remove_import_from_0,tpe(d)],yee,v.Delete_all_unused_imports)]}else if(QSe(m)){let x=Sn.ChangeTracker.with(e,D=>vee(n,m,D,o,u,i,s,!1));if(x.length)return[ta(RV,x,[v.Remove_unused_declaration_for_Colon_0,m.getText(n)],yee,v.Delete_all_unused_imports)]}if(Yp(m.parent)||Lv(m.parent)){if(ns(m.parent.parent)){let x=m.parent.elements,D=[x.length>1?v.Remove_unused_declarations_for_Colon_0:v.Remove_unused_declaration_for_Colon_0,Cr(x,w=>w.getText(n)).join(", ")];return[I6(Sn.ChangeTracker.with(e,w=>cwt(w,n,m.parent)),D)]}return[I6(Sn.ChangeTracker.with(e,x=>lwt(e,x,n,m.parent)),v.Remove_unused_destructuring_declaration)]}if(wBe(n,m))return[I6(Sn.ChangeTracker.with(e,x=>IBe(x,n,m.parent)),v.Remove_variable_statement)];if(He(m)&&Tl(m.parent))return[I6(Sn.ChangeTracker.with(e,x=>gwt(x,n,m.parent)),[v.Remove_unused_declaration_for_Colon_0,m.getText(n)])];let S=[];if(m.kind===140){let x=Sn.ChangeTracker.with(e,w=>PBe(w,n,m)),D=aa(m.parent,s2).typeParameter.name.text;S.push(ta(RV,x,[v.Replace_infer_0_with_unknown,D],XSe,v.Replace_all_unused_infer_with_unknown))}else{let x=Sn.ChangeTracker.with(e,D=>vee(n,m,D,o,u,i,s,!1));if(x.length){let D=za(m.parent)?m.parent:m;S.push(I6(x,[v.Remove_unused_declaration_for_Colon_0,D.getText(n)]))}}let E=Sn.ChangeTracker.with(e,x=>OBe(x,t,n,m));return E.length&&S.push(ta(RV,E,[v.Prefix_0_with_an_underscore,m.getText(n)],YSe,v.Prefix_all_unused_declarations_with_where_possible)),S},fixIds:[YSe,KSe,yee,XSe],getAllCodeActions:e=>{let{sourceFile:t,program:n,cancellationToken:i}=e,s=n.getTypeChecker(),o=n.getSourceFiles();return Ro(e,kBe,(u,m)=>{let d=Yi(t,m.start);switch(e.fixId){case YSe:OBe(u,m.code,t,d);break;case yee:{let S=DBe(d);S?u.delete(t,S):QSe(d)&&vee(t,d,u,s,o,n,i,!0);break}case KSe:{if(d.kind===140||QSe(d))break;if(sm(d))u.delete(t,d);else if(d.kind===30)NBe(u,t,d);else if(Yp(d.parent)){if(d.parent.parent.initializer)break;(!ns(d.parent.parent)||RBe(d.parent.parent,s,o))&&u.delete(t,d.parent.parent)}else{if(Lv(d.parent.parent)&&d.parent.parent.parent.initializer)break;wBe(t,d)?IBe(u,t,d.parent):vee(t,d,u,s,o,n,i,!0)}break}case XSe:d.kind===140&&PBe(u,t,d);break;default:M.fail(JSON.stringify(e.fixId))}})}});function PBe(e,t,n){e.replaceNode(t,n.parent,U.createKeywordTypeNode(159))}function I6(e,t){return ta(RV,e,t,KSe,v.Delete_all_unused_declarations)}function NBe(e,t,n){e.delete(t,M.checkDefined(aa(n.parent,fH).typeParameters,"The type parameter to delete should exist"))}function QSe(e){return e.kind===102||e.kind===80&&(e.parent.kind===276||e.parent.kind===273)}function DBe(e){return e.kind===102?ai(e.parent,Yc):void 0}function wBe(e,t){return Ru(t.parent)&&Ma(t.parent.getChildren(e))===t}function IBe(e,t,n){e.delete(t,n.parent.kind===243?n.parent:n)}function cwt(e,t,n){kt(n.elements,i=>e.delete(t,i))}function lwt(e,t,n,{parent:i}){if(Ei(i)&&i.initializer&&HT(i.initializer))if(Ru(i.parent)&&wt(i.parent.declarations)>1){let s=i.parent.parent,o=s.getStart(n),u=s.end;t.delete(n,i),t.insertNodeAt(n,u,i.initializer,{prefix:Vv(e.host,e.formatContext.options)+n.text.slice(WU(n.text,o-1),o),suffix:EM(n)?";":""})}else t.replaceNode(n,i.parent,i.initializer);else t.delete(n,i)}function OBe(e,t,n,i){t!==v.Property_0_is_declared_but_its_value_is_never_read.code&&(i.kind===140&&(i=aa(i.parent,s2).typeParameter.name),He(i)&&uwt(i)&&(e.replaceNode(n,i,U.createIdentifier(`_${i.text}`)),ns(i.parent)&&OP(i.parent).forEach(s=>{He(s.name)&&e.replaceNode(n,s.name,U.createIdentifier(`_${s.name.text}`))})))}function uwt(e){switch(e.parent.kind){case 169:case 168:return!0;case 260:switch(e.parent.parent.parent.kind){case 250:case 249:return!0}}return!1}function vee(e,t,n,i,s,o,u,m){_wt(t,n,e,i,s,o,u,m),He(t)&&lc.Core.eachSymbolReferenceInFile(t,i,e,d=>{Wn(d.parent)&&d.parent.name===d&&(d=d.parent),!m&&mwt(d)&&n.delete(e,d.parent.parent)})}function _wt(e,t,n,i,s,o,u,m){let{parent:d}=e;if(ns(d))fwt(t,n,d,i,s,o,u,m);else if(!(m&&He(e)&&lc.Core.isSymbolReferencedInFile(e,i,n))){let S=ig(d)?e:za(d)?d.parent:d;M.assert(S!==n,"should not delete whole source file"),t.delete(n,S)}}function fwt(e,t,n,i,s,o,u,m=!1){if(pwt(i,t,n,s,o,u,m))if(n.modifiers&&n.modifiers.length>0&&(!He(n.name)||lc.Core.isSymbolReferencedInFile(n.name,i,t)))for(let d of n.modifiers)Pa(d)&&e.deleteModifier(t,d);else!n.initializer&&RBe(n,i,s)&&e.delete(t,n)}function RBe(e,t,n){let i=e.parent.parameters.indexOf(e);return!lc.Core.someSignatureUsage(e.parent,n,t,(s,o)=>!o||o.arguments.length>i)}function pwt(e,t,n,i,s,o,u){let{parent:m}=n;switch(m.kind){case 174:case 176:let d=m.parameters.indexOf(n),S=ul(m)?m.name:m,E=lc.Core.getReferencedSymbolsForNode(m.pos,S,s,i,o);if(E){for(let x of E)for(let D of x.references)if(D.kind===lc.EntryKind.Node){let w=EO(D.node)&&ea(D.node.parent)&&D.node.parent.arguments.length>d,R=Wn(D.node.parent)&&EO(D.node.parent.expression)&&ea(D.node.parent.parent)&&D.node.parent.parent.arguments.length>d,L=(ul(D.node.parent)||$g(D.node.parent))&&D.node.parent!==n.parent&&D.node.parent.parameters.length>d;if(w||R||L)return!1}}return!0;case 262:return m.name&&dwt(e,t,m.name)?MBe(m,n,u):!0;case 218:case 219:return MBe(m,n,u);case 178:return!1;case 177:return!0;default:return M.failBadSyntaxKind(m)}}function dwt(e,t,n){return!!lc.Core.eachSymbolReferenceInFile(n,e,t,i=>He(i)&&ea(i.parent)&&i.parent.arguments.includes(i))}function MBe(e,t,n){let i=e.parameters,s=i.indexOf(t);return M.assert(s!==-1,"The parameter should already be in the list"),n?i.slice(s+1).every(o=>He(o.name)&&!o.symbol.isReferenced):s===i.length-1}function mwt(e){return(Pn(e.parent)&&e.parent.left===e||(eY(e.parent)||tS(e.parent))&&e.parent.operand===e)&&Du(e.parent.parent)}function gwt(e,t,n){let i=n.symbol.declarations;if(i)for(let s of i)e.delete(t,s)}var ZSe="fixUnreachableCode",LBe=[v.Unreachable_code_detected.code];Ta({errorCodes:LBe,getCodeActions(e){if(e.program.getSyntacticDiagnostics(e.sourceFile,e.cancellationToken).length)return;let n=Sn.ChangeTracker.with(e,i=>FBe(i,e.sourceFile,e.span.start,e.span.length,e.errorCode));return[ta(ZSe,n,v.Remove_unreachable_code,ZSe,v.Remove_all_unreachable_code)]},fixIds:[ZSe],getAllCodeActions:e=>Ro(e,LBe,(t,n)=>FBe(t,n.file,n.start,n.length,n.code))});function FBe(e,t,n,i,s){let o=Yi(t,n),u=Pr(o,Vi);if(u.getStart(t)!==o.getStart(t)){let d=JSON.stringify({statementKind:M.formatSyntaxKind(u.kind),tokenKind:M.formatSyntaxKind(o.kind),errorCode:s,start:n,length:i});M.fail("Token and statement should start at the same point. "+d)}let m=(Vs(u.parent)?u.parent:u).parent;if(!Vs(u.parent)||u===Ma(u.parent.statements))switch(m.kind){case 245:if(m.elseStatement){if(Vs(u.parent))break;e.replaceNode(t,u,U.createBlock(ve));return}case 247:case 248:e.delete(t,m);return}if(Vs(u.parent)){let d=n+i,S=M.checkDefined(hwt(kG(u.parent.statements,u),E=>E.pos<d),"Some statement should be last");e.deleteNodeRange(t,u,S)}else e.delete(t,u)}function hwt(e,t){let n;for(let i of e){if(!t(i))break;n=i}return n}var ebe="fixUnusedLabel",jBe=[v.Unused_label.code];Ta({errorCodes:jBe,getCodeActions(e){let t=Sn.ChangeTracker.with(e,n=>BBe(n,e.sourceFile,e.span.start));return[ta(ebe,t,v.Remove_unused_label,ebe,v.Remove_all_unused_labels)]},fixIds:[ebe],getAllCodeActions:e=>Ro(e,jBe,(t,n)=>BBe(t,n.file,n.start))});function BBe(e,t,n){let i=Yi(t,n),s=aa(i.parent,rS),o=i.getStart(t),u=s.statement.getStart(t),m=Ed(o,u,t)?u:Ja(t.text,Oo(s,59,t).end,!0);e.deleteRange(t,{pos:o,end:m})}var UBe="fixJSDocTypes_plain",tbe="fixJSDocTypes_nullable",VBe=[v.JSDoc_types_can_only_be_used_inside_documentation_comments.code,v._0_at_the_end_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1.code,v._0_at_the_start_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1.code];Ta({errorCodes:VBe,getCodeActions(e){let{sourceFile:t}=e,n=e.program.getTypeChecker(),i=qBe(t,e.span.start,n);if(!i)return;let{typeNode:s,type:o}=i,u=s.getText(t),m=[d(o,UBe,v.Change_all_jsdoc_style_types_to_TypeScript)];return s.kind===314&&m.push(d(o,tbe,v.Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types)),m;function d(S,E,x){let D=Sn.ChangeTracker.with(e,w=>JBe(w,t,s,S,n));return ta("jdocTypes",D,[v.Change_0_to_1,u,n.typeToString(S)],E,x)}},fixIds:[UBe,tbe],getAllCodeActions(e){let{fixId:t,program:n,sourceFile:i}=e,s=n.getTypeChecker();return Ro(e,VBe,(o,u)=>{let m=qBe(u.file,u.start,s);if(!m)return;let{typeNode:d,type:S}=m,E=d.kind===314&&t===tbe?s.getNullableType(S,32768):S;JBe(o,i,d,E,s)})}});function JBe(e,t,n,i,s){e.replaceNode(t,n,s.typeToTypeNode(i,n,void 0))}function qBe(e,t,n){let i=Pr(Yi(e,t),ywt),s=i&&i.type;return s&&{typeNode:s,type:vwt(n,s)}}function ywt(e){switch(e.kind){case 234:case 179:case 180:case 262:case 177:case 181:case 200:case 174:case 173:case 169:case 172:case 171:case 178:case 265:case 216:case 260:return!0;default:return!1}}function vwt(e,t){if(bN(t)){let n=e.getTypeFromTypeNode(t.type);return n===e.getNeverType()||n===e.getVoidType()?n:e.getUnionType(Bt([n,e.getUndefinedType()],t.postfix?void 0:e.getNullType()))}return e.getTypeFromTypeNode(t)}var rbe="fixMissingCallParentheses",zBe=[v.This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead.code];Ta({errorCodes:zBe,fixIds:[rbe],getCodeActions(e){let{sourceFile:t,span:n}=e,i=$Be(t,n.start);if(!i)return;let s=Sn.ChangeTracker.with(e,o=>WBe(o,e.sourceFile,i));return[ta(rbe,s,v.Add_missing_call_parentheses,rbe,v.Add_all_missing_call_parentheses)]},getAllCodeActions:e=>Ro(e,zBe,(t,n)=>{let i=$Be(n.file,n.start);i&&WBe(t,n.file,i)})});function WBe(e,t,n){e.replaceNodeWithText(t,n,`${n.text}()`)}function $Be(e,t){let n=Yi(e,t);if(Wn(n.parent)){let i=n.parent;for(;Wn(i.parent);)i=i.parent;return i.name}if(He(n))return n}var HBe="fixMissingTypeAnnotationOnExports",nbe="add-annotation",ibe="add-type-assertion",Swt="extract-expression",GBe=[v.Function_must_have_an_explicit_return_type_annotation_with_isolatedDeclarations.code,v.Method_must_have_an_explicit_return_type_annotation_with_isolatedDeclarations.code,v.At_least_one_accessor_must_have_an_explicit_return_type_annotation_with_isolatedDeclarations.code,v.Variable_must_have_an_explicit_type_annotation_with_isolatedDeclarations.code,v.Parameter_must_have_an_explicit_type_annotation_with_isolatedDeclarations.code,v.Property_must_have_an_explicit_type_annotation_with_isolatedDeclarations.code,v.Expression_type_can_t_be_inferred_with_isolatedDeclarations.code,v.Binding_elements_can_t_be_exported_directly_with_isolatedDeclarations.code,v.Computed_property_names_on_class_or_object_literals_cannot_be_inferred_with_isolatedDeclarations.code,v.Computed_properties_must_be_number_or_string_literals_variables_or_dotted_expressions_with_isolatedDeclarations.code,v.Enum_member_initializers_must_be_computable_without_references_to_external_symbols_with_isolatedDeclarations.code,v.Extends_clause_can_t_contain_an_expression_with_isolatedDeclarations.code,v.Objects_that_contain_shorthand_properties_can_t_be_inferred_with_isolatedDeclarations.code,v.Objects_that_contain_spread_assignments_can_t_be_inferred_with_isolatedDeclarations.code,v.Arrays_with_spread_elements_can_t_inferred_with_isolatedDeclarations.code,v.Default_exports_can_t_be_inferred_with_isolatedDeclarations.code,v.Only_const_arrays_can_be_inferred_with_isolatedDeclarations.code,v.Assigning_properties_to_functions_without_declaring_them_is_not_supported_with_isolatedDeclarations_Add_an_explicit_declaration_for_the_properties_assigned_to_this_function.code,v.Declaration_emit_for_this_parameter_requires_implicitly_adding_undefined_to_it_s_type_This_is_not_supported_with_isolatedDeclarations.code,v.Type_containing_private_name_0_can_t_be_used_with_isolatedDeclarations.code,v.Add_satisfies_and_a_type_assertion_to_this_expression_satisfies_T_as_T_to_make_the_type_explicit.code],bwt=new Set([177,174,172,262,218,219,260,169,277,263,206,207]),Twt=1074273293;Ta({errorCodes:GBe,fixIds:[HBe],getCodeActions(e){let t=[];return O6(nbe,t,e,0,n=>n.addTypeAnnotation(e.span)),O6(nbe,t,e,1,n=>n.addTypeAnnotation(e.span)),O6(nbe,t,e,2,n=>n.addTypeAnnotation(e.span)),O6(ibe,t,e,0,n=>n.addInlineAssertion(e.span)),O6(ibe,t,e,1,n=>n.addInlineAssertion(e.span)),O6(ibe,t,e,2,n=>n.addInlineAssertion(e.span)),O6(Swt,t,e,0,n=>n.extractAsVariable(e.span)),t},getAllCodeActions:e=>{let t=YBe(e,0,n=>{fk(e,GBe,i=>{n.addTypeAnnotation(i)})});return _k(t.textChanges)}});function O6(e,t,n,i,s){let o=YBe(n,i,s);o.result&&o.textChanges.length&&t.push(ta(e,o.textChanges,o.result,HBe,v.Add_all_missing_type_annotations))}function YBe(e,t,n){let i={typeNode:void 0,mutatedTarget:!1},s=Sn.ChangeTracker.fromContext(e),o=e.sourceFile,u=e.program,m=u.getTypeChecker(),d=Ka(u.getCompilerOptions()),S=LE(e.sourceFile,e.program,e.preferences,e.host),E=new Set,x=new Set,D=oS({preserveSourceNewlines:!1}),w=n({addTypeAnnotation:R,addInlineAssertion:q,extractAsVariable:ee});return S.writeFixes(s),{result:w,textChanges:s.getChanges()};function R(Ie){e.cancellationToken.throwIfCancellationRequested();let _t=Yi(o,Ie.start),mt=W(_t);if(mt)return Tl(mt)?L(mt):pe(mt);let Xe=qe(_t);if(Xe)return pe(Xe)}function L(Ie){var _t;if(x?.has(Ie))return;x?.add(Ie);let mt=m.getTypeAtLocation(Ie),Xe=m.getPropertiesOfType(mt);if(!Ie.name||Xe.length===0)return;let ht=[];for(let xr of Xe)sp(xr.name,Ka(u.getCompilerOptions()))&&(xr.valueDeclaration&&Ei(xr.valueDeclaration)||ht.push(U.createVariableStatement([U.createModifier(95)],U.createVariableDeclarationList([U.createVariableDeclaration(xr.name,void 0,ke(m.getTypeOfSymbol(xr),Ie),void 0)]))));if(ht.length===0)return;let rr=[];(_t=Ie.modifiers)!=null&&_t.some(xr=>xr.kind===95)&&rr.push(U.createModifier(95)),rr.push(U.createModifier(138));let vr=U.createModuleDeclaration(rr,Ie.name,U.createModuleBlock(ht),101441696);return s.insertNodeAfter(o,Ie,vr),[v.Annotate_types_of_properties_expando_function_in_a_namespace]}function F(Ie){return!nc(Ie)&&!ea(Ie)&&!Ca(Ie)&&!Gu(Ie)}function J(Ie,_t){return F(Ie)&&(Ie=U.createParenthesizedExpression(Ie)),U.createAsExpression(Ie,_t)}function G(Ie,_t){return F(Ie)&&(Ie=U.createParenthesizedExpression(Ie)),U.createAsExpression(U.createSatisfiesExpression(Ie,Co(_t)),_t)}function q(Ie){e.cancellationToken.throwIfCancellationRequested();let _t=Yi(o,Ie.start);if(W(_t))return;let Xe=et(_t,Ie);if(!Xe||lA(Xe)||lA(Xe.parent))return;let ht=Ct(Xe),rr=p_(Xe);if(!rr&&u_(Xe)||Pr(Xe,Hs)||Pr(Xe,nS)||ht&&(Pr(Xe,pp)||Pr(Xe,Di))||Ad(Xe))return;let vr=Pr(Xe,Ei),xr=vr&&m.getTypeAtLocation(vr);if(xr&&xr.flags&8192||!(ht||rr))return;let{typeNode:jr,mutatedTarget:ur}=Ae(Xe,xr);if(!(!jr||ur))return rr?s.insertNodeAt(o,Xe.end,J(Co(Xe.name),jr),{prefix:": "}):ht?s.replaceNode(o,Xe,G(Co(Xe),jr)):M.assertNever(Xe),[v.Add_satisfies_and_an_inline_type_assertion_with_0,ct(jr)]}function ee(Ie){e.cancellationToken.throwIfCancellationRequested();let _t=Yi(o,Ie.start),mt=et(_t,Ie);if(!mt||lA(mt)||lA(mt.parent)||!Ct(mt))return;if(Gu(mt))return s.replaceNode(o,mt,J(mt,U.createTypeReferenceNode("const"))),[v.Mark_array_literal_as_const];let ht=Pr(mt,ql);if(ht){if(ht===mt.parent&&nc(mt))return;let rr=U.createUniqueName(c1e(mt,o,m,o),16),vr=mt,xr=mt;if(Ad(vr)&&(vr=g0(vr.parent),Ve(vr.parent)?xr=vr=vr.parent:xr=J(vr,U.createTypeReferenceNode("const"))),nc(vr))return;let jr=U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(rr,void 0,void 0,xr)],2)),ur=Pr(mt,Vi);return s.insertNodeBefore(o,ur,jr),s.replaceNode(o,vr,U.createAsExpression(U.cloneNode(rr),U.createTypeQueryNode(U.cloneNode(rr)))),[v.Extract_to_variable_and_replace_with_0_as_typeof_0,ct(rr)]}}function W(Ie){let _t=Pr(Ie,mt=>Vi(mt)?"quit":CA(mt));if(_t&&CA(_t)){let mt=_t;if(Pn(mt)&&(mt=mt.left,!CA(mt)))return;let Xe=m.getTypeAtLocation(mt.expression);if(!Xe)return;let ht=m.getPropertiesOfType(Xe);if(Pt(ht,rr=>rr.valueDeclaration===_t||rr.valueDeclaration===_t.parent)){let rr=Xe.symbol.valueDeclaration;if(rr){if(K1(rr)&&Ei(rr.parent))return rr.parent;if(Tl(rr))return rr}}}}function pe(Ie){if(!E?.has(Ie))switch(E?.add(Ie),Ie.kind){case 169:case 172:case 260:return Be(Ie);case 219:case 218:case 262:case 174:case 177:return K(Ie,o);case 277:return re(Ie);case 263:return ue(Ie);case 206:case 207:return ne(Ie);default:throw new Error(`Cannot find a fix for the given node ${Ie.kind}`)}}function K(Ie,_t){if(Ie.type)return;let{typeNode:mt}=Ae(Ie);if(mt)return s.tryInsertTypeAnnotation(_t,Ie,mt),[v.Add_return_type_0,ct(mt)]}function re(Ie){if(Ie.isExportEquals)return;let{typeNode:_t}=Ae(Ie.expression);if(!_t)return;let mt=U.createUniqueName("_default");return s.replaceNodeWithNodes(o,Ie,[U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(mt,void 0,_t,Ie.expression)],2)),U.updateExportAssignment(Ie,Ie?.modifiers,mt)]),[v.Extract_default_export_to_variable]}function ue(Ie){var _t,mt;let Xe=(_t=Ie.heritageClauses)==null?void 0:_t.find(or=>or.token===96),ht=Xe?.types[0];if(!ht)return;let{typeNode:rr}=Ae(ht.expression);if(!rr)return;let vr=U.createUniqueName(Ie.name?Ie.name.text+"Base":"Anonymous",16),xr=U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(vr,void 0,rr,ht.expression)],2));s.insertNodeBefore(o,Ie,xr);let jr=L1(o.text,ht.end),ur=((mt=jr?.[jr.length-1])==null?void 0:mt.end)??ht.end;return s.replaceRange(o,{pos:ht.getFullStart(),end:ur},vr,{prefix:" "}),[v.Extract_base_class_to_variable]}let ce;(Ie=>{Ie[Ie.Text=0]="Text",Ie[Ie.Computed=1]="Computed",Ie[Ie.ArrayAccess=2]="ArrayAccess",Ie[Ie.Identifier=3]="Identifier"})(ce||(ce={}));function ne(Ie){var _t;let mt=Ie.parent,Xe=Ie.parent.parent.parent;if(!mt.initializer)return;let ht,rr=[];if(He(mt.initializer))ht={expression:{kind:3,identifier:mt.initializer}};else{let jr=U.createUniqueName("dest",16);ht={expression:{kind:3,identifier:jr}},rr.push(U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(jr,void 0,void 0,mt.initializer)],2)))}let vr=[];Lv(Ie)?le(Ie,vr,ht):me(Ie,vr,ht);let xr=new Map;for(let jr of vr){if(jr.element.propertyName&&za(jr.element.propertyName)){let or=jr.element.propertyName.expression,Zr=U.getGeneratedNameForNode(or),Oi=U.createVariableDeclaration(Zr,void 0,void 0,or),Sr=U.createVariableDeclarationList([Oi],2),Pi=U.createVariableStatement(void 0,Sr);rr.push(Pi),xr.set(or,Zr)}let ur=jr.element.name;if(Lv(ur))le(ur,vr,jr);else if(Yp(ur))me(ur,vr,jr);else{let{typeNode:or}=Ae(ur),Zr=de(jr,xr);if(jr.element.initializer){let Sr=(_t=jr.element)==null?void 0:_t.propertyName,Pi=U.createUniqueName(Sr&&He(Sr)?Sr.text:"temp",16);rr.push(U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(Pi,void 0,void 0,Zr)],2))),Zr=U.createConditionalExpression(U.createBinaryExpression(Pi,U.createToken(37),U.createIdentifier("undefined")),U.createToken(58),jr.element.initializer,U.createToken(59),Zr)}let Oi=li(Xe,32)?[U.createToken(95)]:void 0;rr.push(U.createVariableStatement(Oi,U.createVariableDeclarationList([U.createVariableDeclaration(ur,void 0,or,Zr)],2)))}}return Xe.declarationList.declarations.length>1&&rr.push(U.updateVariableStatement(Xe,Xe.modifiers,U.updateVariableDeclarationList(Xe.declarationList,Xe.declarationList.declarations.filter(jr=>jr!==Ie.parent)))),s.replaceNodeWithNodes(o,Xe,rr),[v.Extract_binding_expressions_to_variable]}function le(Ie,_t,mt){for(let Xe=0;Xe<Ie.elements.length;++Xe){let ht=Ie.elements[Xe];pu(ht)||_t.push({element:ht,parent:mt,expression:{kind:2,arrayIndex:Xe}})}}function me(Ie,_t,mt){for(let Xe of Ie.elements){let ht;if(Xe.propertyName)if(za(Xe.propertyName)){_t.push({element:Xe,parent:mt,expression:{kind:1,computed:Xe.propertyName.expression}});continue}else ht=Xe.propertyName.text;else ht=Xe.name.text;_t.push({element:Xe,parent:mt,expression:{kind:0,text:ht}})}}function de(Ie,_t){let mt=[Ie];for(;Ie.parent;)Ie=Ie.parent,mt.push(Ie);let Xe=mt[mt.length-1].expression.identifier;for(let ht=mt.length-2;ht>=0;--ht){let rr=mt[ht].expression;rr.kind===0?Xe=U.createPropertyAccessChain(Xe,void 0,U.createIdentifier(rr.text)):rr.kind===1?Xe=U.createElementAccessExpression(Xe,_t.get(rr.computed)):rr.kind===2&&(Xe=U.createElementAccessExpression(Xe,rr.arrayIndex))}return Xe}function Ae(Ie,_t){if(t===1)return Pe(Ie);let mt=lA(Ie)?De(Ie):m.getTypeAtLocation(Ie);if(!mt)return i;if(t===2){_t&&(mt=_t);let ht=m.getWidenedLiteralType(mt);if(m.isTypeAssignableTo(ht,mt))return i;mt=ht}ns(Ie)&&m.requiresAddingImplicitUndefined(Ie)&&(mt=m.getUnionType([m.getUndefinedType(),mt],0));let Xe=(Ei(Ie)||Ns(Ie)&&li(Ie,264))&&mt.flags&8192?1048576:0;return{typeNode:ke(mt,Pr(Ie,u_)??o,Xe),mutatedTarget:!1}}function xe(Ie){return U.createTypeQueryNode(Co(Ie))}function te(Ie,_t="temp"){let mt=!!Pr(Ie,Ve);return mt?be(Ie,_t,mt,Xe=>Xe.elements,Ad,U.createSpreadElement,Xe=>U.createArrayLiteralExpression(Xe,!0),Xe=>U.createTupleTypeNode(Xe.map(U.createRestTypeNode))):i}function he(Ie,_t="temp"){let mt=!!Pr(Ie,Ve);return be(Ie,_t,mt,Xe=>Xe.properties,Fy,U.createSpreadAssignment,Xe=>U.createObjectLiteralExpression(Xe,!0),U.createIntersectionTypeNode)}function be(Ie,_t,mt,Xe,ht,rr,vr,xr){let jr=[],ur=[],or,Zr=Pr(Ie,Vi);for(let Pi of Xe(Ie))ht(Pi)?(Sr(),nc(Pi.expression)?(jr.push(xe(Pi.expression)),ur.push(Pi)):Oi(Pi.expression)):(or??(or=[])).push(Pi);if(ur.length===0)return i;return Sr(),s.replaceNode(o,Ie,vr(ur)),{typeNode:xr(jr),mutatedTarget:!0};function Oi(Pi){let Cs=U.createUniqueName(_t+"_Part"+(ur.length+1),16),ss=mt?U.createAsExpression(Pi,U.createTypeReferenceNode("const")):Pi,Ii=U.createVariableStatement(void 0,U.createVariableDeclarationList([U.createVariableDeclaration(Cs,void 0,void 0,ss)],2));s.insertNodeBefore(o,Zr,Ii),jr.push(xe(Cs)),ur.push(rr(Cs))}function Sr(){or&&(Oi(vr(or)),or=void 0)}}function Ve(Ie){return sb(Ie)&&Qm(Ie.type)}function Pe(Ie){if(ns(Ie))return i;if(p_(Ie))return{typeNode:xe(Ie.name),mutatedTarget:!1};if(nc(Ie))return{typeNode:xe(Ie),mutatedTarget:!1};if(Ve(Ie))return Pe(Ie.expression);if(Gu(Ie)){let _t=Pr(Ie,Ei),mt=_t&&He(_t.name)?_t.name.text:void 0;return te(Ie,mt)}if(Ca(Ie)){let _t=Pr(Ie,Ei),mt=_t&&He(_t.name)?_t.name.text:void 0;return he(Ie,mt)}if(Ei(Ie)&&Ie.initializer)return Pe(Ie.initializer);if(UA(Ie)){let{typeNode:_t,mutatedTarget:mt}=Pe(Ie.whenTrue);if(!_t)return i;let{typeNode:Xe,mutatedTarget:ht}=Pe(Ie.whenFalse);return Xe?{typeNode:U.createUnionTypeNode([_t,Xe]),mutatedTarget:mt||ht}:i}return i}function ke(Ie,_t,mt=0){let Xe=!1,ht=MV(m,S,Ie,_t,d,Twt|mt,{moduleResolverHost:u,trackSymbol(){return!0},reportTruncationError(){Xe=!0}});return Xe?U.createKeywordTypeNode(133):ht}function De(Ie){let _t=m.getSignatureFromDeclaration(Ie);if(_t)return m.getReturnTypeOfSignature(_t)}function Be(Ie){let{typeNode:_t}=Ae(Ie);if(_t)return Ie.type?s.replaceNode(Ur(Ie),Ie.type,_t):s.tryInsertTypeAnnotation(Ur(Ie),Ie,_t),[v.Add_annotation_of_type_0,ct(_t)]}function ct(Ie){Tn(Ie,1);let _t=D.printNode(4,Ie,o);return _t.length>xI?_t.substring(0,xI-3)+"...":(Tn(Ie,0),_t)}function qe(Ie){return Pr(Ie,_t=>bwt.has(_t.kind)&&(!Yp(_t)&&!Lv(_t)||Ei(_t.parent)))}function et(Ie,_t){for(;Ie&&Ie.end<_t.start+_t.length;)Ie=Ie.parent;for(;Ie.parent.pos===Ie.pos&&Ie.parent.end===Ie.end;)Ie=Ie.parent;return He(Ie)&&bv(Ie.parent)&&Ie.parent.initializer?Ie.parent.initializer:Ie}}var sbe="fixAwaitInSyncFunction",KBe=[v.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,v.await_using_statements_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,v.for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,v.Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function.code];Ta({errorCodes:KBe,getCodeActions(e){let{sourceFile:t,span:n}=e,i=XBe(t,n.start);if(!i)return;let s=Sn.ChangeTracker.with(e,o=>QBe(o,t,i));return[ta(sbe,s,v.Add_async_modifier_to_containing_function,sbe,v.Add_all_missing_async_modifiers)]},fixIds:[sbe],getAllCodeActions:function(t){let n=new Map;return Ro(t,KBe,(i,s)=>{let o=XBe(s.file,s.start);!o||!em(n,yo(o.insertBefore))||QBe(i,t.sourceFile,o)})}});function Ewt(e){if(e.type)return e.type;if(Ei(e.parent)&&e.parent.type&&Jh(e.parent.type))return e.parent.type.type}function XBe(e,t){let n=Yi(e,t),i=Dp(n);if(!i)return;let s;switch(i.kind){case 174:s=i.name;break;case 262:case 218:s=Oo(i,100,e);break;case 219:let o=i.typeParameters?30:21;s=Oo(i,o,e)||Ma(i.parameters);break;default:return}return s&&{insertBefore:s,returnType:Ewt(i)}}function QBe(e,t,{insertBefore:n,returnType:i}){if(i){let s=oR(i);(!s||s.kind!==80||s.text!=="Promise")&&e.replaceNode(t,i,U.createTypeReferenceNode("Promise",U.createNodeArray([i])))}e.insertModifierBefore(t,134,n)}var ZBe=[v._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property.code,v._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor.code],abe="fixPropertyOverrideAccessor";Ta({errorCodes:ZBe,getCodeActions(e){let t=eUe(e.sourceFile,e.span.start,e.span.length,e.errorCode,e);if(t)return[ta(abe,t,v.Generate_get_and_set_accessors,abe,v.Generate_get_and_set_accessors_for_all_overriding_properties)]},fixIds:[abe],getAllCodeActions:e=>Ro(e,ZBe,(t,n)=>{let i=eUe(n.file,n.start,n.length,n.code,e);if(i)for(let s of i)t.pushRaw(e.sourceFile,s)})});function eUe(e,t,n,i,s){let o,u;if(i===v._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property.code)o=t,u=t+n;else if(i===v._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor.code){let m=s.program.getTypeChecker(),d=Yi(e,t).parent;M.assert(U1(d),"error span of fixPropertyOverrideAccessor should only be on an accessor");let S=d.parent;M.assert(gi(S),"erroneous accessors should only be inside classes");let E=Dh(vbe(S,m));if(!E)return[];let x=Qi(tA(d.name)),D=m.getPropertyOfType(m.getTypeAtLocation(E),x);if(!D||!D.valueDeclaration)return[];o=D.valueDeclaration.pos,u=D.valueDeclaration.end,e=Ur(D.valueDeclaration)}else M.fail("fixPropertyOverrideAccessor codefix got unexpected error code "+i);return bUe(e,s.program,o,u,s,v.Generate_get_and_set_accessors.message)}var obe="inferFromUsage",tUe=[v.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code,v.Variable_0_implicitly_has_an_1_type.code,v.Parameter_0_implicitly_has_an_1_type.code,v.Rest_parameter_0_implicitly_has_an_any_type.code,v.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code,v._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code,v.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code,v.Member_0_implicitly_has_an_1_type.code,v.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code,v.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,v.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,v.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code,v.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code,v._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code,v.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code,v.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,v.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code];Ta({errorCodes:tUe,getCodeActions(e){let{sourceFile:t,program:n,span:{start:i},errorCode:s,cancellationToken:o,host:u,preferences:m}=e,d=Yi(t,i),S,E=Sn.ChangeTracker.with(e,D=>{S=rUe(D,t,d,s,n,o,YS,u,m)}),x=S&&Ps(S);return!x||E.length===0?void 0:[ta(obe,E,[xwt(s,d),Hc(x)],obe,v.Infer_all_types_from_usage)]},fixIds:[obe],getAllCodeActions(e){let{sourceFile:t,program:n,cancellationToken:i,host:s,preferences:o}=e,u=GN();return Ro(e,tUe,(m,d)=>{rUe(m,t,Yi(d.file,d.start),d.code,n,i,u,s,o)})}});function xwt(e,t){switch(e){case v.Parameter_0_implicitly_has_an_1_type.code:case v.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:return fp(Dp(t))?v.Infer_type_of_0_from_usage:v.Infer_parameter_types_from_usage;case v.Rest_parameter_0_implicitly_has_an_any_type.code:case v.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:return v.Infer_parameter_types_from_usage;case v.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code:return v.Infer_this_type_of_0_from_usage;default:return v.Infer_type_of_0_from_usage}}function Cwt(e){switch(e){case v.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code:return v.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code;case v.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:return v.Variable_0_implicitly_has_an_1_type.code;case v.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:return v.Parameter_0_implicitly_has_an_1_type.code;case v.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:return v.Rest_parameter_0_implicitly_has_an_any_type.code;case v.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code:return v.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code;case v._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code:return v._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code;case v.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code:return v.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code;case v.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:return v.Member_0_implicitly_has_an_1_type.code}return e}function rUe(e,t,n,i,s,o,u,m,d){if(!SI(n.kind)&&n.kind!==80&&n.kind!==26&&n.kind!==110)return;let{parent:S}=n,E=LE(t,s,d,m);switch(i=Cwt(i),i){case v.Member_0_implicitly_has_an_1_type.code:case v.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code:if(Ei(S)&&u(S)||Ns(S)||Nf(S))return nUe(e,E,t,S,s,m,o),E.writeFixes(e),S;if(Wn(S)){let w=JM(S.name,s,o),R=E6(w,S,s,m);if(R){let L=U.createJSDocTypeTag(void 0,U.createJSDocTypeExpression(R),void 0);e.addJSDocTags(t,aa(S.parent.parent,Du),[L])}return E.writeFixes(e),S}return;case v.Variable_0_implicitly_has_an_1_type.code:{let w=s.getTypeChecker().getSymbolAtLocation(n);return w&&w.valueDeclaration&&Ei(w.valueDeclaration)&&u(w.valueDeclaration)?(nUe(e,E,Ur(w.valueDeclaration),w.valueDeclaration,s,m,o),E.writeFixes(e),w.valueDeclaration):void 0}}let x=Dp(n);if(x===void 0)return;let D;switch(i){case v.Parameter_0_implicitly_has_an_1_type.code:if(fp(x)){iUe(e,E,t,x,s,m,o),D=x;break}case v.Rest_parameter_0_implicitly_has_an_any_type.code:if(u(x)){let w=aa(S,ns);Awt(e,E,t,w,x,s,m,o),D=w}break;case v.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code:case v._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code:Hp(x)&&He(x.name)&&(See(e,E,t,x,JM(x.name,s,o),s,m),D=x);break;case v.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code:fp(x)&&(iUe(e,E,t,x,s,m,o),D=x);break;case v.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code:Sn.isThisTypeAnnotatable(x)&&u(x)&&(kwt(e,t,x,s,m,o),D=x);break;default:return M.fail(String(i))}return E.writeFixes(e),D}function nUe(e,t,n,i,s,o,u){He(i.name)&&See(e,t,n,i,JM(i.name,s,u),s,o)}function Awt(e,t,n,i,s,o,u,m){if(!He(i.name))return;let d=Dwt(s,n,o,m);if(M.assert(s.parameters.length===d.length,"Parameter count and inference count should match"),hn(s))sUe(e,n,d,o,u);else{let S=pc(s)&&!Oo(s,21,n);S&&e.insertNodeBefore(n,Ma(s.parameters),U.createToken(21));for(let{declaration:E,type:x}of d)E&&!E.type&&!E.initializer&&See(e,t,n,E,x,o,u);S&&e.insertNodeAfter(n,Va(s.parameters),U.createToken(22))}}function kwt(e,t,n,i,s,o){let u=aUe(n,t,i,o);if(!u||!u.length)return;let m=lbe(i,u,o).thisParameter(),d=E6(m,n,i,s);d&&(hn(n)?Pwt(e,t,n,d):e.tryInsertThisTypeAnnotation(t,n,d))}function Pwt(e,t,n,i){e.addJSDocTags(t,n,[U.createJSDocThisTag(void 0,U.createJSDocTypeExpression(i))])}function iUe(e,t,n,i,s,o,u){let m=xo(i.parameters);if(m&&He(i.name)&&He(m.name)){let d=JM(i.name,s,u);d===s.getTypeChecker().getAnyType()&&(d=JM(m.name,s,u)),hn(i)?sUe(e,n,[{declaration:m,type:d}],s,o):See(e,t,n,m,d,s,o)}}function See(e,t,n,i,s,o,u){let m=E6(s,i,o,u);if(m)if(hn(n)&&i.kind!==171){let d=Ei(i)?ai(i.parent.parent,_l):i;if(!d)return;let S=U.createJSDocTypeExpression(m),E=Hp(i)?U.createJSDocReturnTag(void 0,S,void 0):U.createJSDocTypeTag(void 0,S,void 0);e.addJSDocTags(n,d,[E])}else Nwt(m,i,n,e,t,Ka(o.getCompilerOptions()))||e.tryInsertTypeAnnotation(n,i,m)}function Nwt(e,t,n,i,s,o){let u=x2(e,o);return u&&i.tryInsertTypeAnnotation(n,t,u.typeNode)?(kt(u.symbols,m=>s.addImportFromExportedSymbol(m,!0)),!0):!1}function sUe(e,t,n,i,s){let o=n.length&&n[0].declaration.parent;if(!o)return;let u=Gi(n,m=>{let d=m.declaration;if(d.initializer||rb(d)||!He(d.name))return;let S=m.type&&E6(m.type,d,i,s);if(S){let E=U.cloneNode(d.name);return Tn(E,7168),{name:U.cloneNode(d.name),param:d,isOptional:!!m.isOptional,typeNode:S}}});if(u.length)if(pc(o)||ic(o)){let m=pc(o)&&!Oo(o,21,t);m&&e.insertNodeBefore(t,Ma(o.parameters),U.createToken(21)),kt(u,({typeNode:d,param:S})=>{let E=U.createJSDocTypeTag(void 0,U.createJSDocTypeExpression(d)),x=U.createJSDocComment(void 0,[E]);e.insertNodeAt(t,S.getStart(t),x,{suffix:" "})}),m&&e.insertNodeAfter(t,Va(o.parameters),U.createToken(22))}else{let m=Cr(u,({name:d,typeNode:S,isOptional:E})=>U.createJSDocParameterTag(void 0,d,!!E,U.createJSDocTypeExpression(S),!1,void 0));e.addJSDocTags(t,o,m)}}function cbe(e,t,n){return Gi(lc.getReferenceEntriesForNode(-1,e,t,t.getSourceFiles(),n),i=>i.kind!==lc.EntryKind.Span?ai(i.node,He):void 0)}function JM(e,t,n){let i=cbe(e,t,n);return lbe(t,i,n).single()}function Dwt(e,t,n,i){let s=aUe(e,t,n,i);return s&&lbe(n,s,i).parameters(e)||e.parameters.map(o=>({declaration:o,type:He(o.name)?JM(o.name,n,i):n.getTypeChecker().getAnyType()}))}function aUe(e,t,n,i){let s;switch(e.kind){case 176:s=Oo(e,137,t);break;case 219:case 218:let o=e.parent;s=(Ei(o)||Ns(o))&&He(o.name)?o.name:e.name;break;case 262:case 174:case 173:s=e.name;break}if(s)return cbe(s,n,i)}function lbe(e,t,n){let i=e.getTypeChecker(),s={string:()=>i.getStringType(),number:()=>i.getNumberType(),Array:ke=>i.createArrayType(ke),Promise:ke=>i.createPromiseType(ke)},o=[i.getStringType(),i.getNumberType(),i.createArrayType(i.getAnyType()),i.createPromiseType(i.getAnyType())];return{single:d,parameters:S,thisParameter:E};function u(){return{isNumber:void 0,isString:void 0,isNumberOrString:void 0,candidateTypes:void 0,properties:void 0,calls:void 0,constructs:void 0,numberIndex:void 0,stringIndex:void 0,candidateThisTypes:void 0,inferredTypes:void 0}}function m(ke){let De=new Map;for(let ct of ke)ct.properties&&ct.properties.forEach((qe,et)=>{De.has(et)||De.set(et,[]),De.get(et).push(qe)});let Be=new Map;return De.forEach((ct,qe)=>{Be.set(qe,m(ct))}),{isNumber:ke.some(ct=>ct.isNumber),isString:ke.some(ct=>ct.isString),isNumberOrString:ke.some(ct=>ct.isNumberOrString),candidateTypes:va(ke,ct=>ct.candidateTypes),properties:Be,calls:va(ke,ct=>ct.calls),constructs:va(ke,ct=>ct.constructs),numberIndex:kt(ke,ct=>ct.numberIndex),stringIndex:kt(ke,ct=>ct.stringIndex),candidateThisTypes:va(ke,ct=>ct.candidateThisTypes),inferredTypes:void 0}}function d(){return ue(x(t))}function S(ke){if(t.length===0||!ke.parameters)return;let De=u();for(let ct of t)n.throwIfCancellationRequested(),D(ct,De);let Be=[...De.constructs||[],...De.calls||[]];return ke.parameters.map((ct,qe)=>{let et=[],Ie=Fh(ct),_t=!1;for(let Xe of Be)if(Xe.argumentTypes.length<=qe)_t=hn(ke),et.push(i.getUndefinedType());else if(Ie)for(let ht=qe;ht<Xe.argumentTypes.length;ht++)et.push(i.getBaseTypeOfLiteralType(Xe.argumentTypes[ht]));else et.push(i.getBaseTypeOfLiteralType(Xe.argumentTypes[qe]));if(He(ct.name)){let Xe=x(cbe(ct.name,e,n));et.push(...Ie?Gi(Xe,i.getElementTypeOfArrayType):Xe)}let mt=ue(et);return{type:Ie?i.createArrayType(mt):mt,isOptional:_t&&!Ie,declaration:ct}})}function E(){let ke=u();for(let De of t)n.throwIfCancellationRequested(),D(De,ke);return ue(ke.candidateThisTypes||ve)}function x(ke){let De=u();for(let Be of ke)n.throwIfCancellationRequested(),D(Be,De);return ne(De)}function D(ke,De){for(;YI(ke);)ke=ke.parent;switch(ke.parent.kind){case 244:R(ke,De);break;case 225:De.isNumber=!0;break;case 224:L(ke.parent,De);break;case 226:F(ke,ke.parent,De);break;case 296:case 297:J(ke.parent,De);break;case 213:case 214:ke.parent.expression===ke?G(ke.parent,De):w(ke,De);break;case 211:q(ke.parent,De);break;case 212:ee(ke.parent,ke,De);break;case 303:case 304:W(ke.parent,De);break;case 172:pe(ke.parent,De);break;case 260:{let{name:Be,initializer:ct}=ke.parent;if(ke===Be){ct&&Ve(De,i.getTypeAtLocation(ct));break}}default:return w(ke,De)}}function w(ke,De){tg(ke)&&Ve(De,i.getContextualType(ke))}function R(ke,De){Ve(De,ea(ke)?i.getVoidType():i.getAnyType())}function L(ke,De){switch(ke.operator){case 46:case 47:case 41:case 55:De.isNumber=!0;break;case 40:De.isNumberOrString=!0;break}}function F(ke,De,Be){switch(De.operatorToken.kind){case 43:case 42:case 44:case 45:case 48:case 49:case 50:case 51:case 52:case 53:case 66:case 68:case 67:case 69:case 70:case 74:case 75:case 79:case 71:case 73:case 72:case 41:case 30:case 33:case 32:case 34:let ct=i.getTypeAtLocation(De.left===ke?De.right:De.left);ct.flags&1056?Ve(Be,ct):Be.isNumber=!0;break;case 65:case 40:let qe=i.getTypeAtLocation(De.left===ke?De.right:De.left);qe.flags&1056?Ve(Be,qe):qe.flags&296?Be.isNumber=!0:qe.flags&402653316?Be.isString=!0:qe.flags&1||(Be.isNumberOrString=!0);break;case 64:case 35:case 37:case 38:case 36:case 77:case 78:case 76:Ve(Be,i.getTypeAtLocation(De.left===ke?De.right:De.left));break;case 103:ke===De.left&&(Be.isString=!0);break;case 57:case 61:ke===De.left&&(ke.parent.parent.kind===260||Su(ke.parent.parent,!0))&&Ve(Be,i.getTypeAtLocation(De.right));break;case 56:case 28:case 104:break}}function J(ke,De){Ve(De,i.getTypeAtLocation(ke.parent.parent.expression))}function G(ke,De){let Be={argumentTypes:[],return_:u()};if(ke.arguments)for(let ct of ke.arguments)Be.argumentTypes.push(i.getTypeAtLocation(ct));D(ke,Be.return_),ke.kind===213?(De.calls||(De.calls=[])).push(Be):(De.constructs||(De.constructs=[])).push(Be)}function q(ke,De){let Be=Uc(ke.name.text);De.properties||(De.properties=new Map);let ct=De.properties.get(Be)||u();D(ke,ct),De.properties.set(Be,ct)}function ee(ke,De,Be){if(De===ke.argumentExpression){Be.isNumberOrString=!0;return}else{let ct=i.getTypeAtLocation(ke.argumentExpression),qe=u();D(ke,qe),ct.flags&296?Be.numberIndex=qe:Be.stringIndex=qe}}function W(ke,De){let Be=Ei(ke.parent.parent)?ke.parent.parent:ke.parent;Pe(De,i.getTypeAtLocation(Be))}function pe(ke,De){Pe(De,i.getTypeAtLocation(ke.parent))}function K(ke,De){let Be=[];for(let ct of ke)for(let{high:qe,low:et}of De)qe(ct)&&(M.assert(!et(ct),"Priority can't have both low and high"),Be.push(et));return ke.filter(ct=>Be.every(qe=>!qe(ct)))}function re(ke){return ue(ne(ke))}function ue(ke){if(!ke.length)return i.getAnyType();let De=i.getUnionType([i.getStringType(),i.getNumberType()]),ct=K(ke,[{high:et=>et===i.getStringType()||et===i.getNumberType(),low:et=>et===De},{high:et=>!(et.flags&16385),low:et=>!!(et.flags&16385)},{high:et=>!(et.flags&114689)&&!(Kn(et)&16),low:et=>!!(Kn(et)&16)}]),qe=ct.filter(et=>Kn(et)&16);return qe.length&&(ct=ct.filter(et=>!(Kn(et)&16)),ct.push(ce(qe))),i.getWidenedType(i.getUnionType(ct.map(i.getBaseTypeOfLiteralType),2))}function ce(ke){if(ke.length===1)return ke[0];let De=[],Be=[],ct=[],qe=[],et=!1,Ie=!1,_t=yd();for(let ht of ke){for(let xr of i.getPropertiesOfType(ht))_t.add(xr.escapedName,xr.valueDeclaration?i.getTypeOfSymbolAtLocation(xr,xr.valueDeclaration):i.getAnyType());De.push(...i.getSignaturesOfType(ht,0)),Be.push(...i.getSignaturesOfType(ht,1));let rr=i.getIndexInfoOfType(ht,0);rr&&(ct.push(rr.type),et=et||rr.isReadonly);let vr=i.getIndexInfoOfType(ht,1);vr&&(qe.push(vr.type),Ie=Ie||vr.isReadonly)}let mt=u3(_t,(ht,rr)=>{let vr=rr.length<ke.length?16777216:0,xr=i.createSymbol(4|vr,ht);return xr.links.type=i.getUnionType(rr),[ht,xr]}),Xe=[];return ct.length&&Xe.push(i.createIndexInfo(i.getStringType(),i.getUnionType(ct),et)),qe.length&&Xe.push(i.createIndexInfo(i.getNumberType(),i.getUnionType(qe),Ie)),i.createAnonymousType(ke[0].symbol,mt,De,Be,Xe)}function ne(ke){var De,Be,ct;let qe=[];ke.isNumber&&qe.push(i.getNumberType()),ke.isString&&qe.push(i.getStringType()),ke.isNumberOrString&&qe.push(i.getUnionType([i.getStringType(),i.getNumberType()])),ke.numberIndex&&qe.push(i.createArrayType(re(ke.numberIndex))),((De=ke.properties)!=null&&De.size||(Be=ke.constructs)!=null&&Be.length||ke.stringIndex)&&qe.push(le(ke));let et=(ke.candidateTypes||[]).map(_t=>i.getBaseTypeOfLiteralType(_t)),Ie=(ct=ke.calls)!=null&&ct.length?le(ke):void 0;return Ie&&et?qe.push(i.getUnionType([Ie,...et],2)):(Ie&&qe.push(Ie),wt(et)&&qe.push(...et)),qe.push(...me(ke)),qe}function le(ke){let De=new Map;ke.properties&&ke.properties.forEach((et,Ie)=>{let _t=i.createSymbol(4,Ie);_t.links.type=re(et),De.set(Ie,_t)});let Be=ke.calls?[be(ke.calls)]:[],ct=ke.constructs?[be(ke.constructs)]:[],qe=ke.stringIndex?[i.createIndexInfo(i.getStringType(),re(ke.stringIndex),!1)]:[];return i.createAnonymousType(void 0,De,Be,ct,qe)}function me(ke){if(!ke.properties||!ke.properties.size)return[];let De=o.filter(Be=>de(Be,ke));return 0<De.length&&De.length<3?De.map(Be=>Ae(Be,ke)):[]}function de(ke,De){return De.properties?!Nu(De.properties,(Be,ct)=>{let qe=i.getTypeOfPropertyOfType(ke,ct);return qe?Be.calls?!i.getSignaturesOfType(qe,0).length||!i.isTypeAssignableTo(qe,he(Be.calls)):!i.isTypeAssignableTo(qe,re(Be)):!0}):!1}function Ae(ke,De){if(!(Kn(ke)&4)||!De.properties)return ke;let Be=ke.target,ct=Dh(Be.typeParameters);if(!ct)return ke;let qe=[];return De.properties.forEach((et,Ie)=>{let _t=i.getTypeOfPropertyOfType(Be,Ie);M.assert(!!_t,"generic should have all the properties of its reference."),qe.push(...xe(_t,re(et),ct))}),s[ke.symbol.escapedName](ue(qe))}function xe(ke,De,Be){if(ke===Be)return[De];if(ke.flags&3145728)return va(ke.types,et=>xe(et,De,Be));if(Kn(ke)&4&&Kn(De)&4){let et=i.getTypeArguments(ke),Ie=i.getTypeArguments(De),_t=[];if(et&&Ie)for(let mt=0;mt<et.length;mt++)Ie[mt]&&_t.push(...xe(et[mt],Ie[mt],Be));return _t}let ct=i.getSignaturesOfType(ke,0),qe=i.getSignaturesOfType(De,0);return ct.length===1&&qe.length===1?te(ct[0],qe[0],Be):[]}function te(ke,De,Be){var ct;let qe=[];for(let _t=0;_t<ke.parameters.length;_t++){let mt=ke.parameters[_t],Xe=De.parameters[_t],ht=ke.declaration&&Fh(ke.declaration.parameters[_t]);if(!Xe)break;let rr=mt.valueDeclaration?i.getTypeOfSymbolAtLocation(mt,mt.valueDeclaration):i.getAnyType(),vr=ht&&i.getElementTypeOfArrayType(rr);vr&&(rr=vr);let xr=((ct=ai(Xe,jh))==null?void 0:ct.links.type)||(Xe.valueDeclaration?i.getTypeOfSymbolAtLocation(Xe,Xe.valueDeclaration):i.getAnyType());qe.push(...xe(rr,xr,Be))}let et=i.getReturnTypeOfSignature(ke),Ie=i.getReturnTypeOfSignature(De);return qe.push(...xe(et,Ie,Be)),qe}function he(ke){return i.createAnonymousType(void 0,fa(),[be(ke)],ve,ve)}function be(ke){let De=[],Be=Math.max(...ke.map(qe=>qe.argumentTypes.length));for(let qe=0;qe<Be;qe++){let et=i.createSymbol(1,Uc(`arg${qe}`));et.links.type=ue(ke.map(Ie=>Ie.argumentTypes[qe]||i.getUndefinedType())),ke.some(Ie=>Ie.argumentTypes[qe]===void 0)&&(et.flags|=16777216),De.push(et)}let ct=re(m(ke.map(qe=>qe.return_)));return i.createSignature(void 0,void 0,void 0,De,ct,void 0,Be,0)}function Ve(ke,De){De&&!(De.flags&1)&&!(De.flags&131072)&&(ke.candidateTypes||(ke.candidateTypes=[])).push(De)}function Pe(ke,De){De&&!(De.flags&1)&&!(De.flags&131072)&&(ke.candidateThisTypes||(ke.candidateThisTypes=[])).push(De)}}var ube="fixReturnTypeInAsyncFunction",oUe=[v.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0.code];Ta({errorCodes:oUe,fixIds:[ube],getCodeActions:function(t){let{sourceFile:n,program:i,span:s}=t,o=i.getTypeChecker(),u=cUe(n,i.getTypeChecker(),s.start);if(!u)return;let{returnTypeNode:m,returnType:d,promisedTypeNode:S,promisedType:E}=u,x=Sn.ChangeTracker.with(t,D=>lUe(D,n,m,S));return[ta(ube,x,[v.Replace_0_with_Promise_1,o.typeToString(d),o.typeToString(E)],ube,v.Fix_all_incorrect_return_type_of_an_async_functions)]},getAllCodeActions:e=>Ro(e,oUe,(t,n)=>{let i=cUe(n.file,e.program.getTypeChecker(),n.start);i&&lUe(t,n.file,i.returnTypeNode,i.promisedTypeNode)})});function cUe(e,t,n){if(hn(e))return;let i=Yi(e,n),s=Pr(i,Go),o=s?.type;if(!o)return;let u=t.getTypeFromTypeNode(o),m=t.getAwaitedType(u)||t.getVoidType(),d=t.typeToTypeNode(m,o,void 0);if(d)return{returnTypeNode:o,returnType:u,promisedTypeNode:d,promisedType:m}}function lUe(e,t,n,i){e.replaceNode(t,n,U.createTypeReferenceNode("Promise",[i]))}var uUe="disableJsDiagnostics",_Ue="disableJsDiagnostics",fUe=Gi(Object.keys(v),e=>{let t=v[e];return t.category===1?t.code:void 0});Ta({errorCodes:fUe,getCodeActions:function(t){let{sourceFile:n,program:i,span:s,host:o,formatContext:u}=t;if(!hn(n)||!lO(n,i.getCompilerOptions()))return;let m=n.checkJsDirective?"":Vv(o,u.options),d=[_g(uUe,[a5e(n.fileName,[dM(n.checkJsDirective?Il(n.checkJsDirective.pos,n.checkJsDirective.end):zu(0,0),`// @ts-nocheck${m}`)])],v.Disable_checking_for_this_file)];return Sn.isValidLocationToAddComment(n,s.start)&&d.unshift(ta(uUe,Sn.ChangeTracker.with(t,S=>pUe(S,n,s.start)),v.Ignore_this_error_message,_Ue,v.Add_ts_ignore_to_all_error_messages)),d},fixIds:[_Ue],getAllCodeActions:e=>{let t=new Set;return Ro(e,fUe,(n,i)=>{Sn.isValidLocationToAddComment(i.file,i.start)&&pUe(n,i.file,i.start,t)})}});function pUe(e,t,n,i){let{line:s}=ba(t,n);(!i||Pg(i,s))&&e.insertCommentBeforeLine(t,s,n," @ts-ignore")}function _be(e,t,n,i,s,o,u){let m=e.symbol.members;for(let d of t)m.has(d.escapedName)||mUe(d,e,n,i,s,o,u,void 0)}function aD(e){return{trackSymbol:()=>!1,moduleResolverHost:PQ(e.program,e.host)}}var dUe=(e=>(e[e.Method=1]="Method",e[e.Property=2]="Property",e[e.All=3]="All",e))(dUe||{});function mUe(e,t,n,i,s,o,u,m,d=3,S=!1){let E=e.getDeclarations(),x=xo(E),D=i.program.getTypeChecker(),w=Ka(i.program.getCompilerOptions()),R=x?.kind??171,L=me(e,x),F=x?U_(x):0,J=F&256;J|=F&1?1:F&4?4:0,x&&Ef(x)&&(J|=512);let G=re(),q=D.getWidenedType(D.getTypeOfSymbolAtLocation(e,t)),ee=!!(e.flags&16777216),W=!!(t.flags&33554432)||S,pe=ed(n,s);switch(R){case 171:case 172:let de=1;de|=pe===0?268435456:0;let Ae=D.typeToTypeNode(q,t,de,aD(i));if(o){let te=x2(Ae,w);te&&(Ae=te.typeNode,mk(o,te.symbols))}u(U.createPropertyDeclaration(G,x?ce(L):e.getName(),ee&&d&2?U.createToken(58):void 0,Ae,void 0));break;case 177:case 178:{M.assertIsDefined(E);let te=D.typeToTypeNode(q,t,void 0,aD(i)),he=W1(E,x),be=he.secondAccessor?[he.firstAccessor,he.secondAccessor]:[he.firstAccessor];if(o){let Ve=x2(te,w);Ve&&(te=Ve.typeNode,mk(o,Ve.symbols))}for(let Ve of be)if(Hp(Ve))u(U.createGetAccessorDeclaration(G,ce(L),ve,le(te),ne(m,pe,W)));else{M.assertNode(Ve,fp,"The counterpart to a getter should be a setter");let Pe=aN(Ve),ke=Pe&&He(Pe.name)?Nn(Pe.name):void 0;u(U.createSetAccessorDeclaration(G,ce(L),pbe(1,[ke],[le(te)],1,!1),ne(m,pe,W)))}break}case 173:case 174:M.assertIsDefined(E);let xe=q.isUnion()?va(q.types,te=>te.getCallSignatures()):q.getCallSignatures();if(!Pt(xe))break;if(E.length===1){M.assert(xe.length===1,"One declaration implies one signature");let te=xe[0];K(pe,te,G,ce(L),ne(m,pe,W));break}for(let te of xe)K(pe,te,G,ce(L));if(!W)if(E.length>xe.length){let te=D.getSignatureFromDeclaration(E[E.length-1]);K(pe,te,G,ce(L),ne(m,pe))}else M.assert(E.length===xe.length,"Declarations and signatures should match count"),u(Owt(D,i,t,xe,ce(L),ee&&!!(d&1),G,pe,m));break}function K(de,Ae,xe,te,he){let be=bee(174,i,de,Ae,he,te,xe,ee&&!!(d&1),t,o);be&&u(be)}function re(){let de;return J&&(de=vs(de,U.createModifiersFromModifierFlags(J))),ue()&&(de=Bt(de,U.createToken(164))),de&&U.createNodeArray(de)}function ue(){return!!(i.program.getCompilerOptions().noImplicitOverride&&x&&oE(x))}function ce(de){return He(de)&&de.escapedText==="constructor"?U.createComputedPropertyName(U.createStringLiteral(Nn(de),pe===0)):Co(de,!1)}function ne(de,Ae,xe){return xe?void 0:Co(de,!1)||dbe(Ae)}function le(de){return Co(de,!1)}function me(de,Ae){if(ll(de)&262144){let xe=de.links.nameType;if(xe&&tm(xe))return U.createIdentifier(Qi(rm(xe)))}return Co(Ps(Ae),!1)}}function bee(e,t,n,i,s,o,u,m,d,S){let E=t.program,x=E.getTypeChecker(),D=Ka(E.getCompilerOptions()),w=hn(d),R=524545|(n===0?268435456:0),L=x.signatureToSignatureDeclaration(i,e,d,R,aD(t));if(!L)return;let F=w?void 0:L.typeParameters,J=L.parameters,G=w?void 0:Co(L.type);if(S){if(F){let pe=Fs(F,K=>{let re=K.constraint,ue=K.default;if(re){let ce=x2(re,D);ce&&(re=ce.typeNode,mk(S,ce.symbols))}if(ue){let ce=x2(ue,D);ce&&(ue=ce.typeNode,mk(S,ce.symbols))}return U.updateTypeParameterDeclaration(K,K.modifiers,K.name,re,ue)});F!==pe&&(F=Et(U.createNodeArray(pe,F.hasTrailingComma),F))}let W=Fs(J,pe=>{let K=w?void 0:pe.type;if(K){let re=x2(K,D);re&&(K=re.typeNode,mk(S,re.symbols))}return U.updateParameterDeclaration(pe,pe.modifiers,pe.dotDotDotToken,pe.name,w?void 0:pe.questionToken,K,pe.initializer)});if(J!==W&&(J=Et(U.createNodeArray(W,J.hasTrailingComma),J)),G){let pe=x2(G,D);pe&&(G=pe.typeNode,mk(S,pe.symbols))}}let q=m?U.createToken(58):void 0,ee=L.asteriskToken;if(ic(L))return U.updateFunctionExpression(L,u,L.asteriskToken,ai(o,He),F,J,G,s??L.body);if(pc(L))return U.updateArrowFunction(L,u,F,J,G,L.equalsGreaterThanToken,s??L.body);if(ul(L))return U.updateMethodDeclaration(L,u,ee,o??U.createIdentifier(""),q,F,J,G,s);if(Tl(L))return U.updateFunctionDeclaration(L,u,L.asteriskToken,ai(o,He),F,J,G,s??L.body)}function fbe(e,t,n,i,s,o,u){let m=ed(t.sourceFile,t.preferences),d=Ka(t.program.getCompilerOptions()),S=aD(t),E=t.program.getTypeChecker(),x=hn(u),{typeArguments:D,arguments:w,parent:R}=i,L=x?void 0:E.getContextualType(i),F=Cr(w,ue=>He(ue)?ue.text:Wn(ue)&&He(ue.name)?ue.name.text:void 0),J=x?[]:Cr(w,ue=>E.getTypeAtLocation(ue)),{argumentTypeNodes:G,argumentTypeParameters:q}=yUe(E,n,J,u,d,1,S),ee=o?U.createNodeArray(U.createModifiersFromModifierFlags(o)):void 0,W=Rj(R)?U.createToken(42):void 0,pe=x?void 0:wwt(E,q,D),K=pbe(w.length,F,G,void 0,x),re=x||L===void 0?void 0:E.typeToTypeNode(L,u,void 0,S);switch(e){case 174:return U.createMethodDeclaration(ee,W,s,void 0,pe,K,re,dbe(m));case 173:return U.createMethodSignature(ee,s,void 0,pe,K,re===void 0?U.createKeywordTypeNode(159):re);case 262:return M.assert(typeof s=="string"||He(s),"Unexpected name"),U.createFunctionDeclaration(ee,W,s,pe,K,re,LV(v.Function_not_implemented.message,m));default:M.fail("Unexpected kind")}}function wwt(e,t,n){let i=new Set(t.map(o=>o[0])),s=new Map(t);if(n){let o=n.filter(m=>!t.some(d=>{var S;return e.getTypeAtLocation(m)===((S=d[1])==null?void 0:S.argumentType)})),u=i.size+o.length;for(let m=0;i.size<u;m+=1)i.add(gUe(m))}return Is(i.values(),o=>{var u;return U.createTypeParameterDeclaration(void 0,o,(u=s.get(o))==null?void 0:u.constraint)})}function gUe(e){return 84+e<=90?String.fromCharCode(84+e):`T${e}`}function MV(e,t,n,i,s,o,u){let m=e.typeToTypeNode(n,i,o,u);if(m&&qh(m)){let d=x2(m,s);d&&(mk(t,d.symbols),m=d.typeNode)}return Co(m)}function hUe(e){return e.isUnionOrIntersection()?e.types.some(hUe):e.flags&262144}function yUe(e,t,n,i,s,o,u){let m=[],d=new Map;for(let S=0;S<n.length;S+=1){let E=n[S];if(E.isUnionOrIntersection()&&E.types.some(hUe)){let L=gUe(S);m.push(U.createTypeReferenceNode(L)),d.set(L,void 0);continue}let x=e.getBaseTypeOfLiteralType(E),D=MV(e,t,x,i,s,o,u);if(!D)continue;m.push(D);let w=vUe(E),R=E.isTypeParameter()&&E.constraint&&!Iwt(E.constraint)?MV(e,t,E.constraint,i,s,o,u):void 0;w&&d.set(w,{argumentType:E,constraint:R})}return{argumentTypeNodes:m,argumentTypeParameters:Is(d.entries())}}function Iwt(e){return e.flags&524288&&e.objectFlags===16}function vUe(e){var t;if(e.flags&3145728)for(let n of e.types){let i=vUe(n);if(i)return i}return e.flags&262144?(t=e.getSymbol())==null?void 0:t.getName():void 0}function pbe(e,t,n,i,s){let o=[],u=new Map;for(let m=0;m<e;m++){let d=t?.[m]||`arg${m}`,S=u.get(d);u.set(d,(S||0)+1);let E=U.createParameterDeclaration(void 0,void 0,d+(S||""),i!==void 0&&m>=i?U.createToken(58):void 0,s?void 0:n?.[m]||U.createKeywordTypeNode(159),void 0);o.push(E)}return o}function Owt(e,t,n,i,s,o,u,m,d){let S=i[0],E=i[0].minArgumentCount,x=!1;for(let L of i)E=Math.min(L.minArgumentCount,E),E_(L)&&(x=!0),L.parameters.length>=S.parameters.length&&(!E_(L)||E_(S))&&(S=L);let D=S.parameters.length-(E_(S)?1:0),w=S.parameters.map(L=>L.name),R=pbe(D,w,void 0,E,!1);if(x){let L=U.createParameterDeclaration(void 0,U.createToken(26),w[D]||"rest",D>=E?U.createToken(58):void 0,U.createArrayTypeNode(U.createKeywordTypeNode(159)),void 0);R.push(L)}return Mwt(u,s,o,void 0,R,Rwt(i,e,t,n),m,d)}function Rwt(e,t,n,i){if(wt(e)){let s=t.getUnionType(Cr(e,t.getReturnTypeOfSignature));return t.typeToTypeNode(s,i,1,aD(n))}}function Mwt(e,t,n,i,s,o,u,m){return U.createMethodDeclaration(e,void 0,t,n?U.createToken(58):void 0,i,s,o,m||dbe(u))}function dbe(e){return LV(v.Method_not_implemented.message,e)}function LV(e,t){return U.createBlock([U.createThrowStatement(U.createNewExpression(U.createIdentifier("Error"),void 0,[U.createStringLiteral(e,t===0)]))],!0)}function mbe(e,t,n){let i=DI(t);if(!i)return;let s=hbe(i,"compilerOptions");if(s===void 0){e.insertNodeAtObjectStart(t,i,Tee("compilerOptions",U.createObjectLiteralExpression(n.map(([u,m])=>Tee(u,m)),!0)));return}let o=s.initializer;if(Ca(o))for(let[u,m]of n){let d=hbe(o,u);d===void 0?e.insertNodeAtObjectStart(t,o,Tee(u,m)):e.replaceNode(t,d.initializer,m)}}function gbe(e,t,n,i){mbe(e,t,[[n,i]])}function Tee(e,t){return U.createPropertyAssignment(U.createStringLiteral(e),t)}function hbe(e,t){return Ln(e.properties,n=>ql(n)&&!!n.name&&La(n.name)&&n.name.text===t)}function x2(e,t){let n,i=ot(e,s,Di);if(n&&i)return{typeNode:i,symbols:n};function s(o){if(Ev(o)&&o.qualifier){let u=_p(o.qualifier);if(!u.symbol)return Mr(o,s,void 0);let m=rV(u.symbol,t),d=m!==u.text?SUe(o.qualifier,U.createIdentifier(m)):o.qualifier;n=Bt(n,u.symbol);let S=Kr(o.typeArguments,s,Di);return U.createTypeReferenceNode(d,S)}return Mr(o,s,void 0)}}function SUe(e,t){return e.kind===80?t:U.createQualifiedName(SUe(e.left,t),e.right)}function mk(e,t){t.forEach(n=>e.addImportFromExportedSymbol(n,!0))}function ybe(e,t){let n=bl(t),i=Yi(e,t.start);for(;i.end<n;)i=i.parent;return i}function bUe(e,t,n,i,s,o){let u=xUe(e,t,n,i);if(!u||lk.isRefactorErrorInfo(u))return;let m=Sn.ChangeTracker.fromContext(s),{isStatic:d,isReadonly:S,fieldName:E,accessorName:x,originalName:D,type:w,container:R,declaration:L}=u;gp(E),gp(x),gp(L),gp(R);let F,J;if(gi(R)){let q=U_(L);if(Af(e)){let ee=U.createModifiersFromModifierFlags(q);F=ee,J=ee}else F=U.createModifiersFromModifierFlags(jwt(q)),J=U.createModifiersFromModifierFlags(Bwt(q));TE(L)&&(J=ps(F1(L),J))}zwt(m,e,L,w,E,J);let G=Uwt(E,x,w,F,d,R);if(gp(G),CUe(m,e,G,L,R),S){let q=Ny(R);q&&Wwt(m,e,q,E.text,D)}else{let q=Vwt(E,x,w,F,d,R);gp(q),CUe(m,e,q,L,R)}return m.getChanges()}function Lwt(e){return He(e)||La(e)}function Fwt(e){return ap(e,e.parent)||Ns(e)||ql(e)}function TUe(e,t){return He(t)?U.createIdentifier(e):U.createStringLiteral(e)}function EUe(e,t,n){let i=t?n.name:U.createThis();return He(e)?U.createPropertyAccessExpression(i,e):U.createElementAccessExpression(i,U.createStringLiteralFromNode(e))}function jwt(e){return e&=-9,e&=-3,e&4||(e|=1),e}function Bwt(e){return e&=-2,e&=-5,e|=2,e}function xUe(e,t,n,i,s=!0){let o=Yi(e,n),u=n===i&&s,m=Pr(o.parent,Fwt),d=271;if(!m||!(AU(m.name,e,n,i)||u))return{error:Ms(v.Could_not_find_property_for_which_to_generate_accessor)};if(!Lwt(m.name))return{error:Ms(v.Name_is_not_valid)};if((U_(m)&98303|d)!==d)return{error:Ms(v.Can_only_convert_property_with_modifier)};let S=m.name.text,E=rZ(S),x=TUe(E?S:E2(`_${S}`,e),m.name),D=TUe(E?E2(S.substring(1),e):S,m.name);return{isStatic:Jl(m),isReadonly:HI(m),type:$wt(m,t),container:m.kind===169?m.parent.parent:m.parent,originalName:m.name.text,declaration:m,fieldName:x,accessorName:D,renameAccessor:E}}function Uwt(e,t,n,i,s,o){return U.createGetAccessorDeclaration(i,t,[],n,U.createBlock([U.createReturnStatement(EUe(e,s,o))],!0))}function Vwt(e,t,n,i,s,o){return U.createSetAccessorDeclaration(i,t,[U.createParameterDeclaration(void 0,void 0,U.createIdentifier("value"),void 0,n)],U.createBlock([U.createExpressionStatement(U.createAssignment(EUe(e,s,o),U.createIdentifier("value")))],!0))}function Jwt(e,t,n,i,s,o){let u=U.updatePropertyDeclaration(n,o,s,n.questionToken||n.exclamationToken,i,n.initializer);e.replaceNode(t,n,u)}function qwt(e,t,n,i){let s=U.updatePropertyAssignment(n,i,n.initializer);(s.modifiers||s.questionToken||s.exclamationToken)&&(s===n&&(s=U.cloneNode(s)),s.modifiers=void 0,s.questionToken=void 0,s.exclamationToken=void 0),e.replacePropertyAssignment(t,n,s)}function zwt(e,t,n,i,s,o){Ns(n)?Jwt(e,t,n,i,s,o):ql(n)?qwt(e,t,n,s):e.replaceNode(t,n,U.updateParameterDeclaration(n,o,n.dotDotDotToken,aa(s,He),n.questionToken,n.type,n.initializer))}function CUe(e,t,n,i,s){ap(i,i.parent)?e.insertMemberAtStart(t,s,n):ql(i)?e.insertNodeAfterComma(t,i,n):e.insertNodeAfter(t,i,n)}function Wwt(e,t,n,i,s){n.body&&n.body.forEachChild(function o(u){cc(u)&&u.expression.kind===110&&La(u.argumentExpression)&&u.argumentExpression.text===s&&mA(u)&&e.replaceNode(t,u.argumentExpression,U.createStringLiteral(i)),Wn(u)&&u.expression.kind===110&&u.name.text===s&&mA(u)&&e.replaceNode(t,u.name,U.createIdentifier(i)),!Bs(u)&&!gi(u)&&u.forEachChild(o)})}function $wt(e,t){let n=Dfe(e);if(Ns(e)&&n&&e.questionToken){let i=t.getTypeChecker(),s=i.getTypeFromTypeNode(n);if(!i.isTypeAssignableTo(i.getUndefinedType(),s)){let o=Z1(n)?n.types:[n];return U.createUnionTypeNode([...o,U.createKeywordTypeNode(157)])}}return n}function vbe(e,t){let n=[];for(;e;){let i=nE(e),s=i&&t.getSymbolAtLocation(i.expression);if(!s)break;let o=s.flags&2097152?t.getAliasedSymbol(s):s,u=o.declarations&&Ln(o.declarations,gi);if(!u)break;n.push(u),e=u}return n}var AUe="invalidImportSyntax";function Hwt(e,t){let n=Ur(t),i=KP(t),s=e.program.getCompilerOptions(),o=[];return o.push(kUe(e,n,t,uS(i.name,void 0,t.moduleSpecifier,ed(n,e.preferences)))),V_(s)===1&&o.push(kUe(e,n,t,U.createImportEqualsDeclaration(void 0,!1,i.name,U.createExternalModuleReference(t.moduleSpecifier)))),o}function kUe(e,t,n,i){let s=Sn.ChangeTracker.with(e,o=>o.replaceNode(t,n,i));return _g(AUe,s,[v.Replace_import_with_0,s[0].textChanges[0].newText])}Ta({errorCodes:[v.This_expression_is_not_callable.code,v.This_expression_is_not_constructable.code],getCodeActions:Gwt});function Gwt(e){let t=e.sourceFile,n=v.This_expression_is_not_callable.code===e.errorCode?213:214,i=Pr(Yi(t,e.span.start),o=>o.kind===n);if(!i)return[];let s=i.expression;return PUe(e,s)}Ta({errorCodes:[v.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,v.Type_0_does_not_satisfy_the_constraint_1.code,v.Type_0_is_not_assignable_to_type_1.code,v.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated.code,v.Type_predicate_0_is_not_assignable_to_1.code,v.Property_0_of_type_1_is_not_assignable_to_2_index_type_3.code,v._0_index_type_1_is_not_assignable_to_2_index_type_3.code,v.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2.code,v.Property_0_in_type_1_is_not_assignable_to_type_2.code,v.Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property.code,v.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1.code],getCodeActions:Ywt});function Ywt(e){let t=e.sourceFile,n=Pr(Yi(t,e.span.start),i=>i.getStart()===e.span.start&&i.getEnd()===e.span.start+e.span.length);return n?PUe(e,n):[]}function PUe(e,t){let n=e.program.getTypeChecker().getTypeAtLocation(t);if(!(n.symbol&&jh(n.symbol)&&n.symbol.links.originatingImport))return[];let i=[],s=n.symbol.links.originatingImport;if(Np(s)||wn(i,Hwt(e,s)),Ct(t)&&!(Wu(t.parent)&&t.parent.name===t)){let o=e.sourceFile,u=Sn.ChangeTracker.with(e,m=>m.replaceNode(o,t,U.createPropertyAccessExpression(t,"default"),{}));i.push(_g(AUe,u,v.Use_synthetic_default_member))}return i}var Sbe="strictClassInitialization",bbe="addMissingPropertyDefiniteAssignmentAssertions",Tbe="addMissingPropertyUndefinedType",Ebe="addMissingPropertyInitializer",NUe=[v.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor.code];Ta({errorCodes:NUe,getCodeActions:function(t){let n=DUe(t.sourceFile,t.span.start);if(!n)return;let i=[];return Bt(i,Xwt(t,n)),Bt(i,Kwt(t,n)),Bt(i,Qwt(t,n)),i},fixIds:[bbe,Tbe,Ebe],getAllCodeActions:e=>Ro(e,NUe,(t,n)=>{let i=DUe(n.file,n.start);if(i)switch(e.fixId){case bbe:wUe(t,n.file,i.prop);break;case Tbe:IUe(t,n.file,i);break;case Ebe:let s=e.program.getTypeChecker(),o=RUe(s,i.prop);if(!o)return;OUe(t,n.file,i.prop,o);break;default:M.fail(JSON.stringify(e.fixId))}})});function DUe(e,t){let n=Yi(e,t);if(He(n)&&Ns(n.parent)){let i=Vl(n.parent);if(i)return{type:i,prop:n.parent,isJs:hn(n.parent)}}}function Kwt(e,t){if(t.isJs)return;let n=Sn.ChangeTracker.with(e,i=>wUe(i,e.sourceFile,t.prop));return ta(Sbe,n,[v.Add_definite_assignment_assertion_to_property_0,t.prop.getText()],bbe,v.Add_definite_assignment_assertions_to_all_uninitialized_properties)}function wUe(e,t,n){gp(n);let i=U.updatePropertyDeclaration(n,n.modifiers,n.name,U.createToken(54),n.type,n.initializer);e.replaceNode(t,n,i)}function Xwt(e,t){let n=Sn.ChangeTracker.with(e,i=>IUe(i,e.sourceFile,t));return ta(Sbe,n,[v.Add_undefined_type_to_property_0,t.prop.name.getText()],Tbe,v.Add_undefined_type_to_all_uninitialized_properties)}function IUe(e,t,n){let i=U.createKeywordTypeNode(157),s=Z1(n.type)?n.type.types.concat(i):[n.type,i],o=U.createUnionTypeNode(s);n.isJs?e.addJSDocTags(t,n.prop,[U.createJSDocTypeTag(void 0,U.createJSDocTypeExpression(o))]):e.replaceNode(t,n.type,o)}function Qwt(e,t){if(t.isJs)return;let n=e.program.getTypeChecker(),i=RUe(n,t.prop);if(!i)return;let s=Sn.ChangeTracker.with(e,o=>OUe(o,e.sourceFile,t.prop,i));return ta(Sbe,s,[v.Add_initializer_to_property_0,t.prop.name.getText()],Ebe,v.Add_initializers_to_all_uninitialized_properties)}function OUe(e,t,n,i){gp(n);let s=U.updatePropertyDeclaration(n,n.modifiers,n.name,n.questionToken,n.type,i);e.replaceNode(t,n,s)}function RUe(e,t){return MUe(e,e.getTypeFromTypeNode(t.type))}function MUe(e,t){if(t.flags&512)return t===e.getFalseType()||t===e.getFalseType(!0)?U.createFalse():U.createTrue();if(t.isStringLiteral())return U.createStringLiteral(t.value);if(t.isNumberLiteral())return U.createNumericLiteral(t.value);if(t.flags&2048)return U.createBigIntLiteral(t.value);if(t.isUnion())return yi(t.types,n=>MUe(e,n));if(t.isClass()){let n=S0(t.symbol);if(!n||li(n,64))return;let i=Ny(n);return i&&i.parameters.length?void 0:U.createNewExpression(U.createIdentifier(t.symbol.name),void 0,void 0)}else if(e.isArrayLikeType(t))return U.createArrayLiteralExpression()}var xbe="requireInTs",LUe=[v.require_call_may_be_converted_to_an_import.code];Ta({errorCodes:LUe,getCodeActions(e){let t=jUe(e.sourceFile,e.program,e.span.start);if(!t)return;let n=Sn.ChangeTracker.with(e,i=>FUe(i,e.sourceFile,t));return[ta(xbe,n,v.Convert_require_to_import,xbe,v.Convert_all_require_to_import)]},fixIds:[xbe],getAllCodeActions:e=>Ro(e,LUe,(t,n)=>{let i=jUe(n.file,e.program,n.start);i&&FUe(t,e.sourceFile,i)})});function FUe(e,t,n){let{allowSyntheticDefaults:i,defaultImportName:s,namedImports:o,statement:u,required:m}=n;e.replaceNode(t,u,s&&!i?U.createImportEqualsDeclaration(void 0,!1,s,U.createExternalModuleReference(m)):U.createImportDeclaration(void 0,U.createImportClause(!1,s,o),m,void 0))}function jUe(e,t,n){let{parent:i}=Yi(e,n);kf(i,!0)||M.failBadSyntaxKind(i);let s=aa(i.parent,Ei),o=ai(s.name,He),u=Yp(s.name)?Zwt(s.name):void 0;if(o||u)return{allowSyntheticDefaults:SA(t.getCompilerOptions()),defaultImportName:o,namedImports:u,statement:aa(s.parent.parent,_l),required:Ma(i.arguments)}}function Zwt(e){let t=[];for(let n of e.elements){if(!He(n.name)||n.initializer)return;t.push(U.createImportSpecifier(!1,ai(n.propertyName,He),n.name))}if(t.length)return U.createNamedImports(t)}var Cbe="useDefaultImport",BUe=[v.Import_may_be_converted_to_a_default_import.code];Ta({errorCodes:BUe,getCodeActions(e){let{sourceFile:t,span:{start:n}}=e,i=UUe(t,n);if(!i)return;let s=Sn.ChangeTracker.with(e,o=>VUe(o,t,i,e.preferences));return[ta(Cbe,s,v.Convert_to_default_import,Cbe,v.Convert_all_to_default_imports)]},fixIds:[Cbe],getAllCodeActions:e=>Ro(e,BUe,(t,n)=>{let i=UUe(n.file,n.start);i&&VUe(t,n.file,i,e.preferences)})});function UUe(e,t){let n=Yi(e,t);if(!He(n))return;let{parent:i}=n;if(ru(i)&&C0(i.moduleReference))return{importNode:i,name:n,moduleSpecifier:i.moduleReference.expression};if(My(i)&&Yc(i.parent.parent)){let s=i.parent.parent;return{importNode:s,name:n,moduleSpecifier:s.moduleSpecifier}}}function VUe(e,t,n,i){e.replaceNode(t,n.importNode,uS(n.name,void 0,n.moduleSpecifier,ed(t,i)))}var Abe="useBigintLiteral",JUe=[v.Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers.code];Ta({errorCodes:JUe,getCodeActions:function(t){let n=Sn.ChangeTracker.with(t,i=>qUe(i,t.sourceFile,t.span));if(n.length>0)return[ta(Abe,n,v.Convert_to_a_bigint_numeric_literal,Abe,v.Convert_all_to_bigint_numeric_literals)]},fixIds:[Abe],getAllCodeActions:e=>Ro(e,JUe,(t,n)=>qUe(t,n.file,n))});function qUe(e,t,n){let i=ai(Yi(t,n.start),Pf);if(!i)return;let s=i.getText(t)+"n";e.replaceNode(t,i,U.createBigIntLiteral(s))}var eIt="fixAddModuleReferTypeMissingTypeof",kbe=eIt,zUe=[v.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0.code];Ta({errorCodes:zUe,getCodeActions:function(t){let{sourceFile:n,span:i}=t,s=WUe(n,i.start),o=Sn.ChangeTracker.with(t,u=>$Ue(u,n,s));return[ta(kbe,o,v.Add_missing_typeof,kbe,v.Add_missing_typeof)]},fixIds:[kbe],getAllCodeActions:e=>Ro(e,zUe,(t,n)=>$Ue(t,e.sourceFile,WUe(n.file,n.start)))});function WUe(e,t){let n=Yi(e,t);return M.assert(n.kind===102,"This token should be an ImportKeyword"),M.assert(n.parent.kind===205,"Token parent should be an ImportType"),n.parent}function $Ue(e,t,n){let i=U.updateImportTypeNode(n,n.argument,n.attributes,n.qualifier,n.typeArguments,!0);e.replaceNode(t,n,i)}var Pbe="wrapJsxInFragment",HUe=[v.JSX_expressions_must_have_one_parent_element.code];Ta({errorCodes:HUe,getCodeActions:function(t){let{sourceFile:n,span:i}=t,s=GUe(n,i.start);if(!s)return;let o=Sn.ChangeTracker.with(t,u=>YUe(u,n,s));return[ta(Pbe,o,v.Wrap_in_JSX_fragment,Pbe,v.Wrap_all_unparented_JSX_in_JSX_fragment)]},fixIds:[Pbe],getAllCodeActions:e=>Ro(e,HUe,(t,n)=>{let i=GUe(e.sourceFile,n.start);i&&YUe(t,e.sourceFile,i)})});function GUe(e,t){let s=Yi(e,t).parent.parent;if(!(!Pn(s)&&(s=s.parent,!Pn(s)))&&$c(s.operatorToken))return s}function YUe(e,t,n){let i=tIt(n);i&&e.replaceNode(t,n,U.createJsxFragment(U.createJsxOpeningFragment(),i,U.createJsxJsxClosingFragment()))}function tIt(e){let t=[],n=e;for(;;)if(Pn(n)&&$c(n.operatorToken)&&n.operatorToken.kind===28){if(t.push(n.left),$3(n.right))return t.push(n.right),t;if(Pn(n.right)){n=n.right;continue}else return}else return}var Nbe="wrapDecoratorInParentheses",KUe=[v.Expression_must_be_enclosed_in_parentheses_to_be_used_as_a_decorator.code];Ta({errorCodes:KUe,getCodeActions:function(t){let n=Sn.ChangeTracker.with(t,i=>XUe(i,t.sourceFile,t.span.start));return[ta(Nbe,n,v.Wrap_in_parentheses,Nbe,v.Wrap_all_invalid_decorator_expressions_in_parentheses)]},fixIds:[Nbe],getAllCodeActions:e=>Ro(e,KUe,(t,n)=>XUe(t,n.file,n.start))});function XUe(e,t,n){let i=Yi(t,n),s=Pr(i,fu);M.assert(!!s,"Expected position to be owned by a decorator.");let o=U.createParenthesizedExpression(s.expression);e.replaceNode(t,s.expression,o)}var Dbe="fixConvertToMappedObjectType",QUe=[v.An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead.code];Ta({errorCodes:QUe,getCodeActions:function(t){let{sourceFile:n,span:i}=t,s=ZUe(n,i.start);if(!s)return;let o=Sn.ChangeTracker.with(t,m=>eVe(m,n,s)),u=Nn(s.container.name);return[ta(Dbe,o,[v.Convert_0_to_mapped_object_type,u],Dbe,[v.Convert_0_to_mapped_object_type,u])]},fixIds:[Dbe],getAllCodeActions:e=>Ro(e,QUe,(t,n)=>{let i=ZUe(n.file,n.start);i&&eVe(t,n.file,i)})});function ZUe(e,t){let n=Yi(e,t),i=ai(n.parent.parent,fE);if(!i)return;let s=Yu(i.parent)?i.parent:ai(i.parent.parent,im);if(s)return{indexSignature:i,container:s}}function rIt(e,t){return U.createTypeAliasDeclaration(e.modifiers,e.name,e.typeParameters,t)}function eVe(e,t,{indexSignature:n,container:i}){let o=(Yu(i)?i.members:i.type.members).filter(E=>!fE(E)),u=Ma(n.parameters),m=U.createTypeParameterDeclaration(void 0,aa(u.name,He),u.type),d=U.createMappedTypeNode(HI(n)?U.createModifier(148):void 0,m,void 0,n.questionToken,n.type,void 0),S=U.createIntersectionTypeNode([...BI(i),d,...o.length?[U.createTypeLiteralNode(o)]:ve]);e.replaceNode(t,i,rIt(i,S))}var tVe="removeAccidentalCallParentheses",nIt=[v.This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without.code];Ta({errorCodes:nIt,getCodeActions(e){let t=Pr(Yi(e.sourceFile,e.span.start),ea);if(!t)return;let n=Sn.ChangeTracker.with(e,i=>{i.deleteRange(e.sourceFile,{pos:t.expression.end,end:t.end})});return[_g(tVe,n,v.Remove_parentheses)]},fixIds:[tVe]});var wbe="removeUnnecessaryAwait",rVe=[v.await_has_no_effect_on_the_type_of_this_expression.code];Ta({errorCodes:rVe,getCodeActions:function(t){let n=Sn.ChangeTracker.with(t,i=>nVe(i,t.sourceFile,t.span));if(n.length>0)return[ta(wbe,n,v.Remove_unnecessary_await,wbe,v.Remove_all_unnecessary_uses_of_await)]},fixIds:[wbe],getAllCodeActions:e=>Ro(e,rVe,(t,n)=>nVe(t,n.file,n))});function nVe(e,t,n){let i=ai(Yi(t,n.start),m=>m.kind===135),s=i&&ai(i.parent,eS);if(!s)return;let o=s;if(uf(s.parent)){let m=uN(s.expression,!1);if(He(m)){let d=iu(s.parent.pos,t);d&&d.kind!==105&&(o=s.parent)}}e.replaceNode(t,o,s.expression)}var iVe=[v.A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both.code],Ibe="splitTypeOnlyImport";Ta({errorCodes:iVe,fixIds:[Ibe],getCodeActions:function(t){let n=Sn.ChangeTracker.with(t,i=>aVe(i,sVe(t.sourceFile,t.span),t));if(n.length)return[ta(Ibe,n,v.Split_into_two_separate_import_declarations,Ibe,v.Split_all_invalid_type_only_imports)]},getAllCodeActions:e=>Ro(e,iVe,(t,n)=>{aVe(t,sVe(e.sourceFile,n),e)})});function sVe(e,t){return Pr(Yi(e,t.start),Yc)}function aVe(e,t,n){if(!t)return;let i=M.checkDefined(t.importClause);e.replaceNode(n.sourceFile,t,U.updateImportDeclaration(t,t.modifiers,U.updateImportClause(i,i.isTypeOnly,i.name,void 0),t.moduleSpecifier,t.attributes)),e.insertNodeAfter(n.sourceFile,t,U.createImportDeclaration(void 0,U.updateImportClause(i,i.isTypeOnly,void 0,i.namedBindings),t.moduleSpecifier,t.attributes))}var Obe="fixConvertConstToLet",oVe=[v.Cannot_assign_to_0_because_it_is_a_constant.code];Ta({errorCodes:oVe,getCodeActions:function(t){let{sourceFile:n,span:i,program:s}=t,o=cVe(n,i.start,s);if(o===void 0)return;let u=Sn.ChangeTracker.with(t,m=>lVe(m,n,o.token));return[H1e(Obe,u,v.Convert_const_to_let,Obe,v.Convert_all_const_to_let)]},getAllCodeActions:e=>{let{program:t}=e,n=new Map;return _k(Sn.ChangeTracker.with(e,i=>{fk(e,oVe,s=>{let o=cVe(s.file,s.start,t);if(o&&em(n,Aa(o.symbol)))return lVe(i,s.file,o.token)})}))},fixIds:[Obe]});function cVe(e,t,n){var i;let o=n.getTypeChecker().getSymbolAtLocation(Yi(e,t));if(o===void 0)return;let u=ai((i=o?.valueDeclaration)==null?void 0:i.parent,Ru);if(u===void 0)return;let m=Oo(u,87,e);if(m!==void 0)return{symbol:o,token:m}}function lVe(e,t,n){e.replaceNode(t,n,U.createToken(121))}var Rbe="fixExpectedComma",iIt=v._0_expected.code,uVe=[iIt];Ta({errorCodes:uVe,getCodeActions(e){let{sourceFile:t}=e,n=_Ve(t,e.span.start,e.errorCode);if(!n)return;let i=Sn.ChangeTracker.with(e,s=>fVe(s,t,n));return[ta(Rbe,i,[v.Change_0_to_1,";",","],Rbe,[v.Change_0_to_1,";",","])]},fixIds:[Rbe],getAllCodeActions:e=>Ro(e,uVe,(t,n)=>{let i=_Ve(n.file,n.start,n.code);i&&fVe(t,e.sourceFile,i)})});function _Ve(e,t,n){let i=Yi(e,t);return i.kind===27&&i.parent&&(Ca(i.parent)||Gu(i.parent))?{node:i}:void 0}function fVe(e,t,{node:n}){let i=U.createToken(28);e.replaceNode(t,n,i)}var sIt="addVoidToPromise",pVe="addVoidToPromise",dVe=[v.Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments.code,v.Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise.code];Ta({errorCodes:dVe,fixIds:[pVe],getCodeActions(e){let t=Sn.ChangeTracker.with(e,n=>mVe(n,e.sourceFile,e.span,e.program));if(t.length>0)return[ta(sIt,t,v.Add_void_to_Promise_resolved_without_a_value,pVe,v.Add_void_to_all_Promises_resolved_without_a_value)]},getAllCodeActions(e){return Ro(e,dVe,(t,n)=>mVe(t,n.file,n,e.program,new Set))}});function mVe(e,t,n,i,s){let o=Yi(t,n.start);if(!He(o)||!ea(o.parent)||o.parent.expression!==o||o.parent.arguments.length!==0)return;let u=i.getTypeChecker(),m=u.getSymbolAtLocation(o),d=m?.valueDeclaration;if(!d||!ns(d)||!gE(d.parent.parent)||s?.has(d))return;s?.add(d);let S=aIt(d.parent.parent);if(Pt(S)){let E=S[0],x=!Z1(E)&&!a2(E)&&a2(U.createUnionTypeNode([E,U.createKeywordTypeNode(116)]).types[0]);x&&e.insertText(t,E.pos,"("),e.insertText(t,E.end,x?") | void":" | void")}else{let E=u.getResolvedSignature(o.parent),x=E?.parameters[0],D=x&&u.getTypeOfSymbolAtLocation(x,d.parent.parent);hn(d)?(!D||D.flags&3)&&(e.insertText(t,d.parent.parent.end,")"),e.insertText(t,Ja(t.text,d.parent.parent.pos),"/** @type {Promise<void>} */(")):(!D||D.flags&2)&&e.insertText(t,d.parent.parent.expression.end,"<void>")}}function aIt(e){var t;if(hn(e)){if(uf(e.parent)){let n=(t=tb(e.parent))==null?void 0:t.typeExpression.type;if(n&&Gp(n)&&He(n.typeName)&&Nn(n.typeName)==="Promise")return n.typeArguments}}else return e.typeArguments}var gk={};A(gk,{CompletionKind:()=>OVe,CompletionSource:()=>hVe,SortText:()=>k_,StringCompletions:()=>Oee,SymbolOriginInfoKind:()=>yVe,createCompletionDetails:()=>BV,createCompletionDetailsForSymbol:()=>Jbe,getCompletionEntriesFromSymbols:()=>Ube,getCompletionEntryDetails:()=>LIt,getCompletionEntrySymbol:()=>jIt,getCompletionsAtPosition:()=>dIt,getPropertiesForObjectExpression:()=>Dee,moduleSpecifierResolutionCacheAttemptLimit:()=>gVe,moduleSpecifierResolutionLimit:()=>Mbe});var Mbe=100,gVe=1e3,k_={LocalDeclarationPriority:"10",LocationPriority:"11",OptionalMember:"12",MemberDeclaredBySpreadAssignment:"13",SuggestedClassMembers:"14",GlobalsOrKeywords:"15",AutoImportSuggestions:"16",ClassMemberSnippets:"17",JavascriptIdentifiers:"18",Deprecated(e){return"z"+e},ObjectLiteralProperty(e,t){return`${e}\0${t}\0`},SortBelow(e){return e+"1"}},hVe=(e=>(e.ThisProperty="ThisProperty/",e.ClassMemberSnippet="ClassMemberSnippet/",e.TypeOnlyAlias="TypeOnlyAlias/",e.ObjectLiteralMethodSnippet="ObjectLiteralMethodSnippet/",e.SwitchCases="SwitchCases/",e.ObjectLiteralMemberWithComma="ObjectLiteralMemberWithComma/",e))(hVe||{}),yVe=(e=>(e[e.ThisType=1]="ThisType",e[e.SymbolMember=2]="SymbolMember",e[e.Export=4]="Export",e[e.Promise=8]="Promise",e[e.Nullable=16]="Nullable",e[e.ResolvedExport=32]="ResolvedExport",e[e.TypeOnlyAlias=64]="TypeOnlyAlias",e[e.ObjectLiteralMethod=128]="ObjectLiteralMethod",e[e.Ignore=256]="Ignore",e[e.ComputedPropertyName=512]="ComputedPropertyName",e[e.SymbolMemberNoExport=2]="SymbolMemberNoExport",e[e.SymbolMemberExport=6]="SymbolMemberExport",e))(yVe||{});function oIt(e){return!!(e.kind&1)}function cIt(e){return!!(e.kind&2)}function FV(e){return!!(e&&e.kind&4)}function R6(e){return!!(e&&e.kind===32)}function lIt(e){return FV(e)||R6(e)||Lbe(e)}function uIt(e){return(FV(e)||R6(e))&&!!e.isFromPackageJson}function _It(e){return!!(e.kind&8)}function fIt(e){return!!(e.kind&16)}function vVe(e){return!!(e&&e.kind&64)}function SVe(e){return!!(e&&e.kind&128)}function pIt(e){return!!(e&&e.kind&256)}function Lbe(e){return!!(e&&e.kind&512)}function bVe(e,t,n,i,s,o,u,m,d){var S,E,x;let D=Tc(),w=u||bA(af(i.getCompilerOptions())),R=!1,L=0,F=0,J=0,G=0,q=d({tryResolve:W,skippedAny:()=>R,resolvedAny:()=>F>0,resolvedBeyondLimit:()=>F>Mbe}),ee=G?` (${(J/G*100).toFixed(1)}% hit rate)`:"";return(S=t.log)==null||S.call(t,`${e}: resolved ${F} module specifiers, plus ${L} ambient and ${J} from cache${ee}`),(E=t.log)==null||E.call(t,`${e}: response is ${R?"incomplete":"complete"}`),(x=t.log)==null||x.call(t,`${e}: ${Tc()-D}`),q;function W(pe,K){if(K){let ne=n.getModuleSpecifierForBestExportInfo(pe,s,m);return ne&&L++,ne||"failed"}let re=w||o.allowIncompleteCompletions&&F<Mbe,ue=!re&&o.allowIncompleteCompletions&&G<gVe,ce=re||ue?n.getModuleSpecifierForBestExportInfo(pe,s,m,ue):void 0;return(!re&&!ue||ue&&!ce)&&(R=!0),F+=ce?.computedWithoutCacheCount||0,J+=pe.length-(ce?.computedWithoutCacheCount||0),ue&&G++,ce||(w?"failed":"skipped")}}function dIt(e,t,n,i,s,o,u,m,d,S,E=!1){var x;let{previousToken:D}=Aee(s,i);if(u&&!ik(i,s,D)&&!YIt(i,u,D,s))return;if(u===" ")return o.includeCompletionsForImportStatements&&o.includeCompletionsWithInsertText?{isGlobalCompletion:!0,isMemberCompletion:!1,isNewIdentifierLocation:!0,isIncomplete:!0,entries:[]}:void 0;let w=t.getCompilerOptions(),R=t.getTypeChecker(),L=o.allowIncompleteCompletions?(x=e.getIncompleteCompletionsCache)==null?void 0:x.call(e):void 0;if(L&&m===3&&D&&He(D)){let G=mIt(L,i,D,t,e,o,d,s);if(G)return G}else L?.clear();let F=Oee.getStringLiteralCompletions(i,s,D,w,e,t,n,o,E);if(F)return F;if(D&&gI(D.parent)&&(D.kind===83||D.kind===88||D.kind===80))return RIt(D.parent);let J=RVe(t,n,i,w,s,o,void 0,e,S,d);if(J)switch(J.kind){case 0:let G=SIt(i,e,t,w,n,J,o,S,s,E);return G?.isIncomplete&&L?.set(G),G;case 1:return Fbe([...Bb.getJSDocTagNameCompletions(),...EVe(i,s,R,w,o,!0)]);case 2:return Fbe([...Bb.getJSDocTagCompletions(),...EVe(i,s,R,w,o,!1)]);case 3:return Fbe(Bb.getJSDocParameterNameCompletions(J.tag));case 4:return yIt(J.keywordCompletions,J.isNewIdentifierLocation);default:return M.assertNever(J)}}function jV(e,t){var n,i;let s=m3(e.sortText,t.sortText);return s===0&&(s=m3(e.name,t.name)),s===0&&((n=e.data)!=null&&n.moduleSpecifier)&&((i=t.data)!=null&&i.moduleSpecifier)&&(s=GR(e.data.moduleSpecifier,t.data.moduleSpecifier)),s===0?-1:s}function TVe(e){return!!e?.moduleSpecifier}function mIt(e,t,n,i,s,o,u,m){let d=e.get();if(!d)return;let S=wf(t,m),E=n.text.toLowerCase(),x=PM(t,s,i,o,u),D=bVe("continuePreviousIncompleteResponse",s,A_.createImportSpecifierResolver(t,i,s,o),i,n.getStart(),o,!1,gb(n),w=>{let R=Gi(d.entries,L=>{var F;if(!L.hasAction||!L.source||!L.data||TVe(L.data))return L;if(!YVe(L.name,E))return;let{origin:J}=M.checkDefined(MVe(L.name,L.data,i,s)),G=x.get(t.path,L.data.exportMapKey),q=G&&w.tryResolve(G,!vu(Zd(J.moduleSymbol.name)));if(q==="skipped")return L;if(!q||q==="failed"){(F=s.log)==null||F.call(s,`Unexpected failure resolving auto import for '${L.name}' from '${L.source}'`);return}let ee={...J,kind:32,moduleSpecifier:q.moduleSpecifier};return L.data=DVe(ee),L.source=Bbe(ee),L.sourceDisplay=[td(ee.moduleSpecifier)],L});return w.skippedAny()||(d.isIncomplete=void 0),R});return d.entries=D,d.flags=(d.flags||0)|4,d.optionalReplacementSpan=AVe(S),d}function Fbe(e){return{isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:!1,entries:e}}function EVe(e,t,n,i,s,o){let u=Yi(e,t);if(!jP(u)&&!ag(u))return[];let m=ag(u)?u:u.parent;if(!ag(m))return[];let d=m.parent;if(!Bs(d))return[];let S=Af(e),E=s.includeCompletionsWithSnippetText||void 0,x=vy(m.tags,D=>Pd(D)&&D.getEnd()<=t);return Gi(d.parameters,D=>{if(!OP(D).length){if(He(D.name)){let w={tabstop:1},R=D.name.text,L=qM(R,D.initializer,D.dotDotDotToken,S,!1,!1,n,i,s),F=E?qM(R,D.initializer,D.dotDotDotToken,S,!1,!0,n,i,s,w):void 0;return o&&(L=L.slice(1),F&&(F=F.slice(1))),{name:L,kind:"parameter",sortText:k_.LocationPriority,insertText:E?F:void 0,isSnippet:E}}else if(D.parent.parameters.indexOf(D)===x){let w=`param${x}`,R=xVe(w,D.name,D.initializer,D.dotDotDotToken,S,!1,n,i,s),L=E?xVe(w,D.name,D.initializer,D.dotDotDotToken,S,!0,n,i,s):void 0,F=R.join(wv(i)+"* "),J=L?.join(wv(i)+"* ");return o&&(F=F.slice(1),J&&(J=J.slice(1))),{name:F,kind:"parameter",sortText:k_.LocationPriority,insertText:E?J:void 0,isSnippet:E}}}})}function xVe(e,t,n,i,s,o,u,m,d){if(!s)return[qM(e,n,i,s,!1,o,u,m,d,{tabstop:1})];return S(e,t,n,i,{tabstop:1});function S(x,D,w,R,L){if(Yp(D)&&!R){let J={tabstop:L.tabstop},G=qM(x,w,R,s,!0,o,u,m,d,J),q=[];for(let ee of D.elements){let W=E(x,ee,J);if(W)q.push(...W);else{q=void 0;break}}if(q)return L.tabstop=J.tabstop,[G,...q]}return[qM(x,w,R,s,!1,o,u,m,d,L)]}function E(x,D,w){if(!D.propertyName&&He(D.name)||He(D.name)){let R=D.propertyName?PI(D.propertyName):D.name.text;if(!R)return;let L=`${x}.${R}`;return[qM(L,D.initializer,D.dotDotDotToken,s,!1,o,u,m,d,w)]}else if(D.propertyName){let R=PI(D.propertyName);return R&&S(`${x}.${R}`,D.name,D.initializer,D.dotDotDotToken,w)}}}function qM(e,t,n,i,s,o,u,m,d,S){if(o&&M.assertIsDefined(S),t&&(e=gIt(e,t)),o&&(e=_E(e)),i){let E="*";if(s)M.assert(!n,"Cannot annotate a rest parameter with type 'Object'."),E="Object";else{if(t){let w=u.getTypeAtLocation(t.parent);if(!(w.flags&16385)){let R=t.getSourceFile(),F=ed(R,d)===0?268435456:0,J=u.typeToTypeNode(w,Pr(t,Bs),F);if(J){let G=o?Cee({removeComments:!0,module:m.module,target:m.target}):oS({removeComments:!0,module:m.module,target:m.target});Tn(J,1),E=G.printNode(4,J,R)}}}o&&E==="*"&&(E=`\${${S.tabstop++}:${E}}`)}let x=!s&&n?"...":"",D=o?`\${${S.tabstop++}}`:"";return`@param {${x}${E}} ${e} ${D}`}else{let E=o?`\${${S.tabstop++}}`:"";return`@param ${e} ${E}`}}function gIt(e,t){let n=t.getText().trim();return n.includes(`
`)||n.length>80?`[${e}]`:`[${e}=${n}]`}function hIt(e){return{name:Sa(e),kind:"keyword",kindModifiers:"",sortText:k_.GlobalsOrKeywords}}function yIt(e,t){return{isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:t,entries:e.slice()}}function CVe(e,t,n){return{kind:4,keywordCompletions:FVe(e,t),isNewIdentifierLocation:n}}function vIt(e){switch(e){case 156:return 8;default:M.fail("Unknown mapping from SyntaxKind to KeywordCompletionFilters")}}function AVe(e){return e?.kind===80?df(e):void 0}function SIt(e,t,n,i,s,o,u,m,d,S){let{symbols:E,contextToken:x,completionKind:D,isInSnippetScope:w,isNewIdentifierLocation:R,location:L,propertyAccessToConvert:F,keywordFilters:J,symbolToOriginInfoMap:G,recommendedCompletion:q,isJsxInitializer:ee,isTypeOnlyLocation:W,isJsxIdentifierExpected:pe,isRightOfOpenTag:K,isRightOfDotOrQuestionDot:re,importStatementCompletion:ue,insideJsDocTagTypeExpression:ce,symbolToSortTextMap:ne,hasUnresolvedAutoImports:le}=o,me=o.literals,de=n.getTypeChecker();if(zR(e.scriptKind)===1){let Ve=TIt(L,e);if(Ve)return Ve}let Ae=Pr(x,SN);if(Ae&&(Jde(x)||rE(x,Ae.expression))){let Ve=cV(de,Ae.parent.clauses);me=me.filter(Pe=>!Ve.hasValue(Pe)),E.forEach((Pe,ke)=>{if(Pe.valueDeclaration&&nS(Pe.valueDeclaration)){let De=de.getConstantValue(Pe.valueDeclaration);De!==void 0&&Ve.hasValue(De)&&(G[ke]={kind:256})}})}let xe=Rx(),te=kVe(e,i);if(te&&!R&&(!E||E.length===0)&&J===0)return;let he=Ube(E,xe,void 0,x,L,d,e,t,n,Ka(i),s,D,u,i,m,W,F,pe,ee,ue,q,G,ne,pe,K,S);if(J!==0)for(let Ve of FVe(J,!ce&&Af(e)))(W&&g6(JT(Ve.name))||!W&&nOt(Ve.name)||!he.has(Ve.name))&&(he.add(Ve.name),l0(xe,Ve,jV,void 0,!0));for(let Ve of zIt(x,d))he.has(Ve.name)||(he.add(Ve.name),l0(xe,Ve,jV,void 0,!0));for(let Ve of me){let Pe=xIt(e,u,Ve);he.add(Pe.name),l0(xe,Pe,jV,void 0,!0)}te||EIt(e,L.pos,he,Ka(i),xe);let be;if(u.includeCompletionsWithInsertText&&x&&!K&&!re&&(be=Pr(x,DO))){let Ve=PVe(be,e,u,i,t,n,m);Ve&&xe.push(Ve.entry)}return{flags:o.flags,isGlobalCompletion:w,isIncomplete:u.allowIncompleteCompletions&&le?!0:void 0,isMemberCompletion:bIt(D),isNewIdentifierLocation:R,optionalReplacementSpan:AVe(L),entries:xe}}function kVe(e,t){return!Af(e)||!!lO(e,t)}function PVe(e,t,n,i,s,o,u){let m=e.clauses,d=o.getTypeChecker(),S=d.getTypeAtLocation(e.parent.expression);if(S&&S.isUnion()&&wi(S.types,E=>E.isLiteral())){let E=cV(d,m),x=Ka(i),D=ed(t,n),w=A_.createImportAdder(t,o,n,s),R=[];for(let W of S.types)if(W.flags&1024){M.assert(W.symbol,"An enum member type should have a symbol"),M.assert(W.symbol.parent,"An enum member type should have a parent symbol (the enum symbol)");let pe=W.symbol.valueDeclaration&&d.getConstantValue(W.symbol.valueDeclaration);if(pe!==void 0){if(E.hasValue(pe))continue;E.addValue(pe)}let K=A_.typeToAutoImportableTypeNode(d,w,W,e,x);if(!K)return;let re=Eee(K,x,D);if(!re)return;R.push(re)}else if(!E.hasValue(W.value))switch(typeof W.value){case"object":R.push(W.value.negative?U.createPrefixUnaryExpression(41,U.createBigIntLiteral({negative:!1,base10Value:W.value.base10Value})):U.createBigIntLiteral(W.value));break;case"number":R.push(W.value<0?U.createPrefixUnaryExpression(41,U.createNumericLiteral(-W.value)):U.createNumericLiteral(W.value));break;case"string":R.push(U.createStringLiteral(W.value,D===0));break}if(R.length===0)return;let L=Cr(R,W=>U.createCaseClause(W,[])),F=Vv(s,u?.options),J=Cee({removeComments:!0,module:i.module,target:i.target,newLine:kM(F)}),G=u?W=>J.printAndFormatNode(4,W,t,u):W=>J.printNode(4,W,t),q=Cr(L,(W,pe)=>n.includeCompletionsWithSnippetText?`${G(W)}$${pe+1}`:`${G(W)}`).join(F);return{entry:{name:`${J.printNode(4,L[0],t)} ...`,kind:"",sortText:k_.GlobalsOrKeywords,insertText:q,hasAction:w.hasFixes()||void 0,source:"SwitchCases/",isSnippet:n.includeCompletionsWithSnippetText?!0:void 0},importAdder:w}}}function Eee(e,t,n){switch(e.kind){case 183:let i=e.typeName;return xee(i,t,n);case 199:let s=Eee(e.objectType,t,n),o=Eee(e.indexType,t,n);return s&&o&&U.createElementAccessExpression(s,o);case 201:let u=e.literal;switch(u.kind){case 11:return U.createStringLiteral(u.text,n===0);case 9:return U.createNumericLiteral(u.text,u.numericLiteralFlags)}return;case 196:let m=Eee(e.type,t,n);return m&&(He(m)?m:U.createParenthesizedExpression(m));case 186:return xee(e.exprName,t,n);case 205:M.fail("We should not get an import type after calling 'codefix.typeToAutoImportableTypeNode'.")}}function xee(e,t,n){if(He(e))return e;let i=Qi(e.right.escapedText);return OG(i,t)?U.createPropertyAccessExpression(xee(e.left,t,n),i):U.createElementAccessExpression(xee(e.left,t,n),U.createStringLiteral(i,n===0))}function bIt(e){switch(e){case 0:case 3:case 2:return!0;default:return!1}}function TIt(e,t){let n=Pr(e,i=>{switch(i.kind){case 287:return!0;case 44:case 32:case 80:case 211:return!1;default:return"quit"}});if(n){let i=!!Oo(n,32,t),u=n.parent.openingElement.tagName.getText(t)+(i?"":">"),m=df(n.tagName),d={name:u,kind:"class",kindModifiers:void 0,sortText:k_.LocationPriority};return{isGlobalCompletion:!1,isMemberCompletion:!0,isNewIdentifierLocation:!1,optionalReplacementSpan:m,entries:[d]}}}function EIt(e,t,n,i,s){$Z(e).forEach((o,u)=>{if(o===t)return;let m=Qi(u);!n.has(m)&&sp(m,i)&&(n.add(m),l0(s,{name:m,kind:"warning",kindModifiers:"",sortText:k_.JavascriptIdentifiers,isFromUncheckedFile:!0},jV))})}function jbe(e,t,n){return typeof n=="object"?uE(n)+"n":bs(n)?T6(e,t,n):JSON.stringify(n)}function xIt(e,t,n){return{name:jbe(e,t,n),kind:"string",kindModifiers:"",sortText:k_.LocationPriority}}function CIt(e,t,n,i,s,o,u,m,d,S,E,x,D,w,R,L,F,J,G,q,ee,W,pe,K){var re,ue;let ce,ne,le=bQ(n,o),me,de,Ae=Bbe(x),xe,te,he,be=d.getTypeChecker(),Ve=x&&fIt(x),Pe=x&&cIt(x)||E;if(x&&oIt(x))ce=E?`this${Ve?"?.":""}[${wVe(u,G,S)}]`:`this${Ve?"?.":"."}${S}`;else if((Pe||Ve)&&w){ce=Pe?E?`[${wVe(u,G,S)}]`:`[${S}]`:S,(Ve||w.questionDotToken)&&(ce=`?.${ce}`);let De=Oo(w,25,u)||Oo(w,29,u);if(!De)return;let Be=_s(S,w.name.text)?w.name.end:De.end;le=Il(De.getStart(u),Be)}if(R&&(ce===void 0&&(ce=S),ce=`{${ce}}`,typeof R!="boolean"&&(le=df(R,u))),x&&_It(x)&&w){ce===void 0&&(ce=S);let De=iu(w.pos,u),Be="";De&&KU(De.end,De.parent,u)&&(Be=";"),Be+=`(await ${w.expression.getText()})`,ce=E?`${Be}${ce}`:`${Be}${Ve?"?.":"."}${ce}`;let qe=ai(w.parent,eS)?w.parent:w.expression;le=Il(qe.getStart(u),w.end)}if(R6(x)&&(xe=[td(x.moduleSpecifier)],L&&({insertText:ce,replacementSpan:le}=IIt(S,L,x,F,u,J,G),de=G.includeCompletionsWithSnippetText?!0:void 0)),x?.kind===64&&(te=!0),q===0&&i&&((re=iu(i.pos,u,i))==null?void 0:re.kind)!==28&&(ul(i.parent.parent)||Hp(i.parent.parent)||fp(i.parent.parent)||Fy(i.parent)||((ue=Pr(i.parent,ql))==null?void 0:ue.getLastToken(u))===i||p_(i.parent)&&ba(u,i.getEnd()).line!==ba(u,o).line)&&(Ae="ObjectLiteralMemberWithComma/",te=!0),G.includeCompletionsWithClassMemberSnippets&&G.includeCompletionsWithInsertText&&q===3&&AIt(e,s,u)){let De,Be=NVe(m,d,J,G,S,e,s,o,i,ee);if(Be)({insertText:ce,filterText:ne,isSnippet:de,importAdder:De}=Be),(De?.hasFixes()||Be.eraseRange)&&(te=!0,Ae="ClassMemberSnippet/");else return}if(x&&SVe(x)&&({insertText:ce,isSnippet:de,labelDetails:he}=x,G.useLabelDetailsInCompletionEntries||(S=S+he.detail,he=void 0),Ae="ObjectLiteralMethodSnippet/",t=k_.SortBelow(t)),W&&!pe&&G.includeCompletionsWithSnippetText&&G.jsxAttributeCompletionStyle&&G.jsxAttributeCompletionStyle!=="none"&&!(Kg(s.parent)&&s.parent.initializer)){let De=G.jsxAttributeCompletionStyle==="braces",Be=be.getTypeOfSymbolAtLocation(e,s);G.jsxAttributeCompletionStyle==="auto"&&!(Be.flags&528)&&!(Be.flags&1048576&&Ln(Be.types,ct=>!!(ct.flags&528)))&&(Be.flags&402653316||Be.flags&1048576&&wi(Be.types,ct=>!!(ct.flags&402686084||N0e(ct)))?(ce=`${_E(S)}=${T6(u,G,"$1")}`,de=!0):De=!0),De&&(ce=`${_E(S)}={$1}`,de=!0)}if(ce!==void 0&&!G.includeCompletionsWithInsertText)return;(FV(x)||R6(x))&&(me=DVe(x),te=!L);let ke=Pr(s,V9);if(ke?.kind===275){let De=JT(S);ke&&De&&(De===135||OH(De))&&(ce=`${S} as ${S}_`)}return{name:S,kind:zv.getSymbolKind(be,e,s),kindModifiers:zv.getSymbolModifiers(be,e),sortText:t,source:Ae,hasAction:te?!0:void 0,isRecommended:OIt(e,D,be)||void 0,insertText:ce,filterText:ne,replacementSpan:le,sourceDisplay:xe,labelDetails:he,isSnippet:de,isPackageJsonImport:uIt(x)||void 0,isImportStatementCompletion:!!L||void 0,data:me,...K?{symbol:e}:void 0}}function AIt(e,t,n){return hn(t)?!1:!!(e.flags&106500)&&(gi(t)||t.parent&&t.parent.parent&&uu(t.parent)&&t===t.parent.name&&t.parent.getLastToken(n)===t.parent.name&&gi(t.parent.parent)||t.parent&&xN(t)&&gi(t.parent))}function NVe(e,t,n,i,s,o,u,m,d,S){let E=Pr(u,gi);if(!E)return;let x,D=s,w=s,R=t.getTypeChecker(),L=u.getSourceFile(),F=Cee({removeComments:!0,module:n.module,target:n.target,omitTrailingSemicolon:!1,newLine:kM(Vv(e,S?.options))}),J=A_.createImportAdder(L,t,i,e),G;if(i.includeCompletionsWithSnippetText){x=!0;let ue=U.createEmptyStatement();G=U.createBlock([ue],!0),qG(ue,{kind:0,order:0})}else G=U.createBlock([],!0);let q=0,{modifiers:ee,range:W,decorators:pe}=kIt(d,L,m),K=ee&64&&E.modifierFlagsCache&64,re=[];if(A_.addNewNodeForMemberSymbol(o,E,L,{program:t,host:e},i,J,ue=>{let ce=0;K&&(ce|=64),uu(ue)&&R.getMemberOverrideModifierStatus(E,ue,o)===1&&(ce|=16),re.length||(q=ue.modifierFlagsCache|ce),ue=U.replaceModifiers(ue,q),re.push(ue)},G,A_.PreserveOptionalFlags.Property,!!K),re.length){let ue=o.flags&8192,ce=q|16|1;ue?ce|=1024:ce|=136;let ne=ee&ce;if(ee&~ce)return;if(q&4&&ne&1&&(q&=-5),ne!==0&&!(ne&1)&&(q&=-2),q|=ne,re=re.map(me=>U.replaceModifiers(me,q)),pe?.length){let me=re[re.length-1];TE(me)&&(re[re.length-1]=U.replaceDecoratorsAndModifiers(me,pe.concat(qT(me)||[])))}let le=131073;S?D=F.printAndFormatSnippetList(le,U.createNodeArray(re),L,S):D=F.printSnippetList(le,U.createNodeArray(re),L)}return{insertText:D,filterText:w,isSnippet:x,importAdder:J,eraseRange:W}}function kIt(e,t,n){if(!e||ba(t,n).line>ba(t,e.getEnd()).line)return{modifiers:0};let i=0,s,o,u={pos:n,end:n};if(Ns(e.parent)&&(o=PIt(e))){e.parent.modifiers&&(i|=Vg(e.parent.modifiers)&98303,s=e.parent.modifiers.filter(fu)||[],u.pos=Math.min(...e.parent.modifiers.map(d=>d.getStart(t))));let m=pA(o);i&m||(i|=m,u.pos=Math.min(u.pos,e.getStart(t))),e.parent.name!==e&&(u.end=e.parent.name.getStart(t))}return{modifiers:i,decorators:s,range:u.pos<u.end?u:void 0}}function PIt(e){if(Pa(e))return e.kind;if(He(e)){let t=Jx(e);if(t&&vv(t))return t}}function NIt(e,t,n,i,s,o,u,m){let d=u.includeCompletionsWithSnippetText||void 0,S=t,E=n.getSourceFile(),x=DIt(e,n,E,i,s,u);if(!x)return;let D=Cee({removeComments:!0,module:o.module,target:o.target,omitTrailingSemicolon:!1,newLine:kM(Vv(s,m?.options))});m?S=D.printAndFormatSnippetList(80,U.createNodeArray([x],!0),E,m):S=D.printSnippetList(80,U.createNodeArray([x],!0),E);let w=oS({removeComments:!0,module:o.module,target:o.target,omitTrailingSemicolon:!0}),R=U.createMethodSignature(void 0,"",x.questionToken,x.typeParameters,x.parameters,x.type),L={detail:w.printNode(4,R,E)};return{isSnippet:d,insertText:S,labelDetails:L}}function DIt(e,t,n,i,s,o){let u=e.getDeclarations();if(!(u&&u.length))return;let m=i.getTypeChecker(),d=u[0],S=Co(Ps(d),!1),E=m.getWidenedType(m.getTypeOfSymbolAtLocation(e,t)),D=33554432|(ed(n,o)===0?268435456:0);switch(d.kind){case 171:case 172:case 173:case 174:{let w=E.flags&1048576&&E.types.length<10?m.getUnionType(E.types,2):E;if(w.flags&1048576){let G=Zn(w.types,q=>m.getSignaturesOfType(q,0).length>0);if(G.length===1)w=G[0];else return}if(m.getSignaturesOfType(w,0).length!==1)return;let L=m.typeToTypeNode(w,t,D,A_.getNoopSymbolTrackerWithResolver({program:i,host:s}));if(!L||!Jh(L))return;let F;if(o.includeCompletionsWithSnippetText){let G=U.createEmptyStatement();F=U.createBlock([G],!0),qG(G,{kind:0,order:0})}else F=U.createBlock([],!0);let J=L.parameters.map(G=>U.createParameterDeclaration(void 0,G.dotDotDotToken,G.name,void 0,void 0,G.initializer));return U.createMethodDeclaration(void 0,void 0,S,void 0,void 0,J,void 0,F)}default:return}}function Cee(e){let t,n=Sn.createWriter(wv(e)),i=oS(e,n),s={...n,write:D=>o(D,()=>n.write(D)),nonEscapingWrite:n.write,writeLiteral:D=>o(D,()=>n.writeLiteral(D)),writeStringLiteral:D=>o(D,()=>n.writeStringLiteral(D)),writeSymbol:(D,w)=>o(D,()=>n.writeSymbol(D,w)),writeParameter:D=>o(D,()=>n.writeParameter(D)),writeComment:D=>o(D,()=>n.writeComment(D)),writeProperty:D=>o(D,()=>n.writeProperty(D))};return{printSnippetList:u,printAndFormatSnippetList:d,printNode:S,printAndFormatNode:x};function o(D,w){let R=_E(D);if(R!==D){let L=n.getTextPos();w();let F=n.getTextPos();t=Bt(t||(t=[]),{newText:R,span:{start:L,length:F-L}})}else w()}function u(D,w,R){let L=m(D,w,R);return t?Sn.applyChanges(L,t):L}function m(D,w,R){return t=void 0,s.clear(),i.writeList(D,w,R,s),s.getText()}function d(D,w,R,L){let F={text:m(D,w,R),getLineAndCharacterOfPosition(ee){return ba(this,ee)}},J=oV(L,R),G=va(w,ee=>{let W=Sn.assignPositionsToNode(ee);return zl.formatNodeGivenIndentation(W,F,R.languageVariant,0,0,{...L,options:J})}),q=t?Qs(ps(G,t),(ee,W)=>e5(ee.span,W.span)):G;return Sn.applyChanges(F.text,q)}function S(D,w,R){let L=E(D,w,R);return t?Sn.applyChanges(L,t):L}function E(D,w,R){return t=void 0,s.clear(),i.writeNode(D,w,R,s),s.getText()}function x(D,w,R,L){let F={text:E(D,w,R),getLineAndCharacterOfPosition(W){return ba(this,W)}},J=oV(L,R),G=Sn.assignPositionsToNode(w),q=zl.formatNodeGivenIndentation(G,F,R.languageVariant,0,0,{...L,options:J}),ee=t?Qs(ps(q,t),(W,pe)=>e5(W.span,pe.span)):q;return Sn.applyChanges(F.text,ee)}}function DVe(e){let t=e.fileName?void 0:Zd(e.moduleSymbol.name),n=e.isFromPackageJson?!0:void 0;return R6(e)?{exportName:e.exportName,exportMapKey:e.exportMapKey,moduleSpecifier:e.moduleSpecifier,ambientModuleName:t,fileName:e.fileName,isPackageJsonImport:n}:{exportName:e.exportName,exportMapKey:e.exportMapKey,fileName:e.fileName,ambientModuleName:e.fileName?void 0:Zd(e.moduleSymbol.name),isPackageJsonImport:e.isFromPackageJson?!0:void 0}}function wIt(e,t,n){let i=e.exportName==="default",s=!!e.isPackageJsonImport;return TVe(e)?{kind:32,exportName:e.exportName,exportMapKey:e.exportMapKey,moduleSpecifier:e.moduleSpecifier,symbolName:t,fileName:e.fileName,moduleSymbol:n,isDefaultExport:i,isFromPackageJson:s}:{kind:4,exportName:e.exportName,exportMapKey:e.exportMapKey,symbolName:t,fileName:e.fileName,moduleSymbol:n,isDefaultExport:i,isFromPackageJson:s}}function IIt(e,t,n,i,s,o,u){let m=t.replacementSpan,d=_E(T6(s,u,n.moduleSpecifier)),S=n.isDefaultExport?1:n.exportName==="export="?2:0,E=u.includeCompletionsWithSnippetText?"$1":"",x=A_.getImportKind(s,S,o,!0),D=t.couldBeTypeOnlyImportSpecifier,w=t.isTopLevelTypeOnly?` ${Sa(156)} `:" ",R=D?`${Sa(156)} `:"",L=i?";":"";switch(x){case 3:return{replacementSpan:m,insertText:`import${w}${_E(e)}${E} = require(${d})${L}`};case 1:return{replacementSpan:m,insertText:`import${w}${_E(e)}${E} from ${d}${L}`};case 2:return{replacementSpan:m,insertText:`import${w}* as ${_E(e)} from ${d}${L}`};case 0:return{replacementSpan:m,insertText:`import${w}{ ${R}${_E(e)}${E} } from ${d}${L}`}}}function wVe(e,t,n){return/^\d+$/.test(n)?n:T6(e,t,n)}function OIt(e,t,n){return e===t||!!(e.flags&1048576)&&n.getExportSymbolOfSymbol(e)===t}function Bbe(e){if(FV(e))return Zd(e.moduleSymbol.name);if(R6(e))return e.moduleSpecifier;if(e?.kind===1)return"ThisProperty/";if(e?.kind===64)return"TypeOnlyAlias/"}function Ube(e,t,n,i,s,o,u,m,d,S,E,x,D,w,R,L,F,J,G,q,ee,W,pe,K,re,ue=!1){let ce=Tc(),ne=eOt(i,s),le=EM(u),me=d.getTypeChecker(),de=new Map;for(let te=0;te<e.length;te++){let he=e[te],be=W?.[te],Ve=kee(he,S,be,x,!!J);if(!Ve||de.get(Ve.name)&&(!be||!SVe(be))||x===1&&pe&&!Ae(he,pe)||!L&&hn(u)&&xe(he))continue;let{name:Pe,needsConvertPropertyAccess:ke}=Ve,De=pe?.[Aa(he)]??k_.LocationPriority,Be=tOt(he,me)?k_.Deprecated(De):De,ct=CIt(he,Be,n,i,s,o,u,m,d,Pe,ke,be,ee,F,G,q,le,w,D,x,R,K,re,ue);if(!ct)continue;let qe=(!be||vVe(be))&&!(he.parent===void 0&&!Pt(he.declarations,et=>et.getSourceFile()===s.getSourceFile()));de.set(Pe,qe),l0(t,ct,jV,void 0,!0)}return E("getCompletionsAtPosition: getCompletionEntriesFromSymbols: "+(Tc()-ce)),{has:te=>de.has(te),add:te=>de.set(te,!0)};function Ae(te,he){var be;let Ve=te.flags;if(!Ji(s)){if(dc(s.parent))return!0;if(ai(ne,Ei)&&te.valueDeclaration===ne)return!1;let Pe=te.valueDeclaration??((be=te.declarations)==null?void 0:be[0]);if(ne&&Pe&&(Ac(ne)&&Ac(Pe)||ns(ne)&&ns(Pe))){let De=Pe.pos,Be=ns(ne)?ne.parent.parameters:s2(ne.parent)?void 0:ne.parent.typeParameters;if(De>=ne.pos&&Be&&De<Be.end)return!1}let ke=$u(te,me);if(u.externalModuleIndicator&&!w.allowUmdGlobalAccess&&he[Aa(te)]===k_.GlobalsOrKeywords&&(he[Aa(ke)]===k_.AutoImportSuggestions||he[Aa(ke)]===k_.LocationPriority))return!1;if(Ve|=cN(ke),TU(s))return!!(Ve&1920);if(L)return Wbe(te,me)}return!!(Ve&111551)}function xe(te){var he;let be=cN($u(te,me));return!(be&111551)&&(!hn((he=te.declarations)==null?void 0:he[0])||!!(be&788968))}}function RIt(e){let t=MIt(e);if(t.length)return{isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:!1,entries:t}}function MIt(e){let t=[],n=new Map,i=e;for(;i&&!Bs(i);){if(rS(i)){let s=i.label.text;n.has(s)||(n.set(s,!0),t.push({name:s,kindModifiers:"",kind:"label",sortText:k_.LocationPriority}))}i=i.parent}return t}function IVe(e,t,n,i,s,o,u){if(s.source==="SwitchCases/")return{type:"cases"};if(s.data){let q=MVe(s.name,s.data,e,o);if(q){let{contextToken:ee,previousToken:W}=Aee(i,n);return{type:"symbol",symbol:q.symbol,location:wf(n,i),previousToken:W,contextToken:ee,isJsxInitializer:!1,isTypeOnlyLocation:!1,origin:q.origin}}}let m=e.getCompilerOptions(),d=RVe(e,t,n,m,i,{includeCompletionsForModuleExports:!0,includeCompletionsWithInsertText:!0},s,o,void 0);if(!d)return{type:"none"};if(d.kind!==0)return{type:"request",request:d};let{symbols:S,literals:E,location:x,completionKind:D,symbolToOriginInfoMap:w,contextToken:R,previousToken:L,isJsxInitializer:F,isTypeOnlyLocation:J}=d,G=Ln(E,q=>jbe(n,u,q)===s.name);return G!==void 0?{type:"literal",literal:G}:yi(S,(q,ee)=>{let W=w[ee],pe=kee(q,Ka(m),W,D,d.isJsxIdentifierExpected);return pe&&pe.name===s.name&&(s.source==="ClassMemberSnippet/"&&q.flags&106500||s.source==="ObjectLiteralMethodSnippet/"&&q.flags&8196||Bbe(W)===s.source||s.source==="ObjectLiteralMemberWithComma/")?{type:"symbol",symbol:q,location:x,origin:W,contextToken:R,previousToken:L,isJsxInitializer:F,isTypeOnlyLocation:J}:void 0})||{type:"none"}}function LIt(e,t,n,i,s,o,u,m,d){let S=e.getTypeChecker(),E=e.getCompilerOptions(),{name:x,source:D,data:w}=s,{previousToken:R,contextToken:L}=Aee(i,n);if(ik(n,i,R))return Oee.getStringLiteralCompletionDetails(x,n,i,R,e,o,d,m);let F=IVe(e,t,n,i,s,o,m);switch(F.type){case"request":{let{request:J}=F;switch(J.kind){case 1:return Bb.getJSDocTagNameCompletionDetails(x);case 2:return Bb.getJSDocTagCompletionDetails(x);case 3:return Bb.getJSDocParameterNameCompletionDetails(x);case 4:return Pt(J.keywordCompletions,G=>G.name===x)?Vbe(x,"keyword",5):void 0;default:return M.assertNever(J)}}case"symbol":{let{symbol:J,location:G,contextToken:q,origin:ee,previousToken:W}=F,{codeActions:pe,sourceDisplay:K}=FIt(x,G,q,ee,J,e,o,E,n,i,W,u,m,w,D,d),re=Lbe(ee)?ee.symbolName:J.name;return Jbe(J,re,S,n,G,d,pe,K)}case"literal":{let{literal:J}=F;return Vbe(jbe(n,m,J),"string",typeof J=="string"?8:7)}case"cases":{let J=PVe(L.parent,n,m,e.getCompilerOptions(),o,e,void 0);if(J?.importAdder.hasFixes()){let{entry:G,importAdder:q}=J,ee=Sn.ChangeTracker.with({host:o,formatContext:u,preferences:m},q.writeFixes);return{name:G.name,kind:"",kindModifiers:"",displayParts:[],sourceDisplay:void 0,codeActions:[{changes:ee,description:wE([v.Includes_imports_of_types_referenced_by_0,x])}]}}return{name:x,kind:"",kindModifiers:"",displayParts:[],sourceDisplay:void 0}}case"none":return LVe().some(J=>J.name===x)?Vbe(x,"keyword",5):void 0;default:M.assertNever(F)}}function Vbe(e,t,n){return BV(e,"",t,[Jf(e,n)])}function Jbe(e,t,n,i,s,o,u,m){let{displayParts:d,documentation:S,symbolKind:E,tags:x}=n.runWithCancellationToken(o,D=>zv.getSymbolDisplayPartsDocumentationAndSymbolKind(D,e,i,s,s,7));return BV(t,zv.getSymbolModifiers(n,e),E,d,S,x,u,m)}function BV(e,t,n,i,s,o,u,m){return{name:e,kindModifiers:t,kind:n,displayParts:i,documentation:s,tags:o,codeActions:u,source:m,sourceDisplay:m}}function FIt(e,t,n,i,s,o,u,m,d,S,E,x,D,w,R,L){if(w?.moduleSpecifier&&E&&zVe(n||E,d).replacementSpan)return{codeActions:void 0,sourceDisplay:[td(w.moduleSpecifier)]};if(R==="ClassMemberSnippet/"){let{importAdder:pe,eraseRange:K}=NVe(u,o,m,D,e,s,t,S,n,x);if(pe?.hasFixes()||K)return{sourceDisplay:void 0,codeActions:[{changes:Sn.ChangeTracker.with({host:u,formatContext:x,preferences:D},ue=>{pe&&pe.writeFixes(ue),K&&ue.deleteRange(d,K)}),description:pe?.hasFixes()?wE([v.Includes_imports_of_types_referenced_by_0,e]):wE([v.Update_modifiers_of_0,e])}]}}if(vVe(i)){let pe=A_.getPromoteTypeOnlyCompletionAction(d,i.declaration.name,o,u,x,D);return M.assertIsDefined(pe,"Expected to have a code action for promoting type-only alias"),{codeActions:[pe],sourceDisplay:void 0}}if(R==="ObjectLiteralMemberWithComma/"&&n){let pe=Sn.ChangeTracker.with({host:u,formatContext:x,preferences:D},K=>K.insertText(d,n.end,","));if(pe)return{sourceDisplay:void 0,codeActions:[{changes:pe,description:wE([v.Add_missing_comma_for_object_member_completion_0,e])}]}}if(!i||!(FV(i)||R6(i)))return{codeActions:void 0,sourceDisplay:void 0};let F=i.isFromPackageJson?u.getPackageJsonAutoImportProvider().getTypeChecker():o.getTypeChecker(),{moduleSymbol:J}=i,G=F.getMergedSymbol($u(s.exportSymbol||s,F)),q=n?.kind===30&&__(n.parent),{moduleSpecifier:ee,codeAction:W}=A_.getImportCompletionAction(G,J,w?.exportMapKey,d,e,q,u,o,x,E&&He(E)?E.getStart(d):S,D,L);return M.assert(!w?.moduleSpecifier||ee===w.moduleSpecifier),{sourceDisplay:[td(ee)],codeActions:[W]}}function jIt(e,t,n,i,s,o,u){let m=IVe(e,t,n,i,s,o,u);return m.type==="symbol"?m.symbol:void 0}var OVe=(e=>(e[e.ObjectPropertyDeclaration=0]="ObjectPropertyDeclaration",e[e.Global=1]="Global",e[e.PropertyAccess=2]="PropertyAccess",e[e.MemberLike=3]="MemberLike",e[e.String=4]="String",e[e.None=5]="None",e))(OVe||{});function BIt(e,t,n){return yi(t&&(t.isUnion()?t.types:[t]),i=>{let s=i&&i.symbol;return s&&s.flags&424&&!epe(s)?qbe(s,e,n):void 0})}function UIt(e,t,n,i){let{parent:s}=e;switch(e.kind){case 80:return HU(e,i);case 64:switch(s.kind){case 260:return i.getContextualType(s.initializer);case 226:return i.getTypeAtLocation(s.left);case 291:return i.getContextualTypeForJsxAttribute(s);default:return}case 105:return i.getContextualType(s);case 84:let o=ai(s,SN);return o?HQ(o,i):void 0;case 19:return wO(s)&&!Ly(s.parent)&&!vE(s.parent)?i.getContextualTypeForJsxAttribute(s.parent):void 0;default:let u=YM.getArgumentInfoForCompletions(e,t,n,i);return u?i.getContextualTypeForArgumentAtIndex(u.invocation,u.argumentIndex):GU(e.kind)&&Pn(s)&&GU(s.operatorToken.kind)?i.getTypeAtLocation(s.left):i.getContextualType(e,4)||i.getContextualType(e)}}function qbe(e,t,n){let i=n.getAccessibleSymbolChain(e,t,-1,!1);return i?Ma(i):e.parent&&(VIt(e.parent)?e:qbe(e.parent,t,n))}function VIt(e){var t;return!!((t=e.declarations)!=null&&t.some(n=>n.kind===307))}function RVe(e,t,n,i,s,o,u,m,d,S){let E=e.getTypeChecker(),x=kVe(n,i),D=Tc(),w=Yi(n,s);t("getCompletionData: Get current token: "+(Tc()-D)),D=Tc();let R=Bv(n,s,w);t("getCompletionData: Is inside comment: "+(Tc()-D));let L=!1,F=!1,J=!1;if(R){if(A0e(n,s)){if(n.text.charCodeAt(s-1)===64)return{kind:1};{let Re=om(s,n);if(!/[^*|\s(/)]/.test(n.text.substring(Re,s)))return{kind:2}}}let Te=WIt(w,s);if(Te){if(Te.tagName.pos<=s&&s<=Te.tagName.end)return{kind:1};if(Xg(Te))F=!0;else{let Re=vr(Te);if(Re&&(w=Yi(n,s),(!w||!Uh(w)&&(w.parent.kind!==348||w.parent.name!==w))&&(L=Ue(Re))),!L&&Pd(Te)&&($c(Te.name)||Te.name.pos<=s&&s<=Te.name.end))return{kind:3,tag:Te}}}if(!L&&!F){t("Returning an empty list because completion was inside a regular comment or plain text part of a JsDoc comment.");return}}D=Tc();let G=!L&&!F&&Af(n),q=Aee(s,n),ee=q.previousToken,W=q.contextToken;t("getCompletionData: Get previous token: "+(Tc()-D));let pe=w,K,re=!1,ue=!1,ce=!1,ne=!1,le=!1,me=!1,de,Ae=wf(n,s),xe=0,te=!1,he=0;if(W){let Te=zVe(W,n);if(Te.keywordCompletion){if(Te.isKeywordOnlyCompletion)return{kind:4,keywordCompletions:[hIt(Te.keywordCompletion)],isNewIdentifierLocation:Te.isNewIdentifierLocation};xe=vIt(Te.keywordCompletion)}if(Te.replacementSpan&&o.includeCompletionsForImportStatements&&o.includeCompletionsWithInsertText&&(he|=2,de=Te,te=Te.isNewIdentifierLocation),!Te.replacementSpan&&Ui(W))return t("Returning an empty list because completion was requested in an invalid position."),xe?CVe(xe,G,Gs()):void 0;let Re=W.parent;if(W.kind===25||W.kind===29)switch(re=W.kind===25,ue=W.kind===29,Re.kind){case 211:K=Re,pe=K.expression;let It=lN(K);if($c(It)||(ea(pe)||Bs(pe))&&pe.end===W.pos&&pe.getChildCount(n)&&Va(pe.getChildren(n)).kind!==22)return;break;case 166:pe=Re.left;break;case 267:pe=Re.name;break;case 205:pe=Re;break;case 236:pe=Re.getFirstToken(n),M.assert(pe.kind===102||pe.kind===105);break;default:return}else if(!de){if(Re&&Re.kind===211&&(W=Re,Re=Re.parent),w.parent===Ae)switch(w.kind){case 32:(w.parent.kind===284||w.parent.kind===286)&&(Ae=w);break;case 44:w.parent.kind===285&&(Ae=w);break}switch(Re.kind){case 287:W.kind===44&&(ne=!0,Ae=W);break;case 226:if(!qVe(Re))break;case 285:case 284:case 286:me=!0,W.kind===30&&(ce=!0,Ae=W);break;case 294:case 293:(ee.kind===20||ee.kind===80&&ee.parent.kind===291)&&(me=!0);break;case 291:if(Re.initializer===ee&&ee.end<s){me=!0;break}switch(ee.kind){case 64:le=!0;break;case 80:me=!0,Re!==ee.parent&&!Re.initializer&&Oo(Re,64,n)&&(le=ee)}break}}}let be=Tc(),Ve=5,Pe=!1,ke=[],De,Be=[],ct=[],qe=new Map,et=$r(),Ie=Ih(Te=>ak(Te?m.getPackageJsonAutoImportProvider():e,m));if(re||ue)xr();else if(ce)ke=E.getJsxIntrinsicTagNamesAt(Ae),M.assertEachIsDefined(ke,"getJsxIntrinsicTagNames() should all be defined"),Zr(),Ve=1,xe=0;else if(ne){let Te=W.parent.parent.openingElement.tagName,Re=E.getSymbolAtLocation(Te);Re&&(ke=[Re]),Ve=1,xe=0}else if(!Zr())return xe?CVe(xe,G,te):void 0;t("getCompletionData: Semantic work: "+(Tc()-be));let _t=ee&&UIt(ee,s,n,E),Xe=!ai(ee,No)&&!me?Gi(_t&&(_t.isUnion()?_t.types:[_t]),Te=>Te.isLiteral()&&!(Te.flags&1024)?Te.value:void 0):[],ht=ee&&_t&&BIt(ee,_t,E);return{kind:0,symbols:ke,completionKind:Ve,isInSnippetScope:J,propertyAccessToConvert:K,isNewIdentifierLocation:te,location:Ae,keywordFilters:xe,literals:Xe,symbolToOriginInfoMap:Be,recommendedCompletion:ht,previousToken:ee,contextToken:W,isJsxInitializer:le,insideJsDocTagTypeExpression:L,symbolToSortTextMap:ct,isTypeOnlyLocation:et,isJsxIdentifierExpected:me,isRightOfOpenTag:ce,isRightOfDotOrQuestionDot:re||ue,importStatementCompletion:de,hasUnresolvedAutoImports:Pe,flags:he};function rr(Te){switch(Te.kind){case 341:case 348:case 342:case 344:case 346:case 349:case 350:return!0;case 345:return!!Te.constraint;default:return!1}}function vr(Te){if(rr(Te)){let Re=sm(Te)?Te.constraint:Te.typeExpression;return Re&&Re.kind===309?Re:void 0}if(zA(Te)||Jj(Te))return Te.class}function xr(){Ve=2;let Te=Ev(pe),Re=Te&&!pe.isTypeOf||Lg(pe.parent)||fM(W,n,E),It=TU(pe);if(Tf(pe)||Te||Wn(pe)){let $t=El(pe.parent);$t&&(te=!0);let Ht=E.getSymbolAtLocation(pe);if(Ht&&(Ht=$u(Ht,E),Ht.flags&1920)){let dr=E.getExportsOfModule(Ht);M.assertEachIsDefined(dr,"getExportsOfModule() should all be defined");let qr=Ar=>E.isValidPropertyAccess(Te?pe:pe.parent,Ar.name),Hr=Ar=>Wbe(Ar,E),dn=$t?Ar=>{var In;return!!(Ar.flags&1920)&&!((In=Ar.declarations)!=null&&In.every(Ki=>Ki.parent===pe.parent))}:It?Ar=>Hr(Ar)||qr(Ar):Re||L?Hr:qr;for(let Ar of dr)dn(Ar)&&ke.push(Ar);if(!Re&&!L&&Ht.declarations&&Ht.declarations.some(Ar=>Ar.kind!==307&&Ar.kind!==267&&Ar.kind!==266)){let Ar=E.getTypeOfSymbolAtLocation(Ht,pe).getNonOptionalType(),In=!1;if(Ar.isNullableType()){let Ki=re&&!ue&&o.includeAutomaticOptionalChainCompletions!==!1;(Ki||ue)&&(Ar=Ar.getNonNullableType(),Ki&&(In=!0))}jr(Ar,!!(pe.flags&65536),In)}return}}if(!Re||_A(pe)){E.tryGetThisTypeAt(pe,!1);let $t=E.getTypeAtLocation(pe).getNonOptionalType();if(Re)jr($t.getNonNullableType(),!1,!1);else{let Ht=!1;if($t.isNullableType()){let dr=re&&!ue&&o.includeAutomaticOptionalChainCompletions!==!1;(dr||ue)&&($t=$t.getNonNullableType(),dr&&(Ht=!0))}jr($t,!!(pe.flags&65536),Ht)}}}function jr(Te,Re,It){te=!!Te.getStringIndexType(),ue&&Pt(Te.getCallSignatures())&&(te=!0);let $t=pe.kind===205?pe:pe.parent;if(x)for(let Ht of Te.getApparentProperties())E.isValidPropertyAccessForCompletions($t,Te,Ht)&&ur(Ht,!1,It);else ke.push(...Zn(wee(Te,E),Ht=>E.isValidPropertyAccessForCompletions($t,Te,Ht)));if(Re&&o.includeCompletionsWithInsertText){let Ht=E.getPromisedTypeOfPromise(Te);if(Ht)for(let dr of Ht.getApparentProperties())E.isValidPropertyAccessForCompletions($t,Ht,dr)&&ur(dr,!0,It)}}function ur(Te,Re,It){var $t;let Ht=yi(Te.declarations,dn=>ai(Ps(dn),za));if(Ht){let dn=or(Ht.expression),Ar=dn&&E.getSymbolAtLocation(dn),In=Ar&&qbe(Ar,W,E),Ki=In&&Aa(In);if(Ki&&em(qe,Ki)){let ls=ke.length;ke.push(In);let Yn=In.parent;if(!Yn||!BP(Yn)||E.tryGetMemberInModuleExportsAndProperties(In.name,Yn)!==In)Be[ls]={kind:Hr(2)};else{let pi=vu(Zd(Yn.name))?($t=z5(Yn))==null?void 0:$t.fileName:void 0,{moduleSpecifier:Er}=(De||(De=A_.createImportSpecifierResolver(n,e,m,o))).getModuleSpecifierForBestExportInfo([{exportKind:0,moduleFileName:pi,isFromPackageJson:!1,moduleSymbol:Yn,symbol:In,targetFlags:$u(In,E).flags}],s,gb(Ae))||{};if(Er){let tn={kind:Hr(6),moduleSymbol:Yn,isDefaultExport:!1,symbolName:In.name,exportName:In.name,fileName:pi,moduleSpecifier:Er};Be[ls]=tn}}}else if(o.includeCompletionsWithInsertText){if(Ki&&qe.has(Ki))return;qr(Te),dr(Te),ke.push(Te)}}else qr(Te),dr(Te),ke.push(Te);function dr(dn){XIt(dn)&&(ct[Aa(dn)]=k_.LocalDeclarationPriority)}function qr(dn){o.includeCompletionsWithInsertText&&(Re&&em(qe,Aa(dn))?Be[ke.length]={kind:Hr(8)}:It&&(Be[ke.length]={kind:16}))}function Hr(dn){return It?dn|16:dn}}function or(Te){return He(Te)?Te:Wn(Te)?or(Te.expression):void 0}function Zr(){return(to()||lt()||Pi()||St()||fe()||vt()||Oi()||Ce()||Sr()||(Cs(),1))===1}function Oi(){return Me(W)?(Ve=5,te=!0,xe=4,1):0}function Sr(){let Te=ft(W),Re=Te&&E.getContextualType(Te.attributes);if(!Re)return 0;let It=Te&&E.getContextualType(Te.attributes,4);return ke=ps(ke,z(Dee(Re,It,Te.attributes,E),Te.attributes.properties)),Ge(),Ve=3,te=!1,1}function Pi(){return de?(te=!0,Yt(),1):0}function Cs(){xe=tt(W)?5:1,Ve=1,te=Gs(),ee!==W&&M.assert(!!ee,"Expected 'contextToken' to be defined when different from 'previousToken'.");let Te=ee!==W?ee.getStart():s,Re=Ci(W,Te,n)||n;J=Ii(Re);let It=(et?0:111551)|788968|1920|2097152,$t=ee&&!gb(ee);ke=ps(ke,E.getSymbolsInScope(Re,It)),M.assertEachIsDefined(ke,"getSymbolsInScope() should all be defined");for(let Ht=0;Ht<ke.length;Ht++){let dr=ke[Ht];if(!E.isArgumentsSymbol(dr)&&!Pt(dr.declarations,qr=>qr.getSourceFile()===n)&&(ct[Aa(dr)]=k_.GlobalsOrKeywords),$t&&!(dr.flags&111551)){let qr=dr.declarations&&Ln(dr.declarations,vI);if(qr){let Hr={kind:64,declaration:qr};Be[Ht]=Hr}}}if(o.includeCompletionsWithInsertText&&Re.kind!==307){let Ht=E.tryGetThisTypeAt(Re,!1,gi(Re.parent)?Re:void 0);if(Ht&&!KIt(Ht,n,E))for(let dr of wee(Ht,E))Be[ke.length]={kind:1},ke.push(dr),ct[Aa(dr)]=k_.SuggestedClassMembers}Yt(),et&&(xe=W&&sb(W.parent)?6:7)}function ss(){var Te;return de?!0:o.includeCompletionsForModuleExports?n.externalModuleIndicator||n.commonJsModuleIndicator||kQ(e.getCompilerOptions())?!0:((Te=e.getSymlinkCache)==null?void 0:Te.call(e).hasAnySymlinks())||!!e.getCompilerOptions().paths||I0e(e):!1}function Ii(Te){switch(Te.kind){case 307:case 228:case 294:case 241:return!0;default:return Vi(Te)}}function $r(){return L||F||!!de&&ib(Ae.parent)||!Xs(W)&&(fM(W,n,E)||Lg(Ae)||$e(W))}function Xs(Te){return Te&&(Te.kind===114&&(Te.parent.kind===186||vN(Te.parent))||Te.kind===131&&Te.parent.kind===182)}function $e(Te){if(Te){let Re=Te.parent.kind;switch(Te.kind){case 59:return Re===172||Re===171||Re===169||Re===260||YC(Re);case 64:return Re===265||Re===168;case 130:return Re===234;case 30:return Re===183||Re===216;case 96:return Re===168;case 152:return Re===238}}return!1}function Yt(){var Te,Re;if(!ss()||(M.assert(!u?.data,"Should not run 'collectAutoImports' when faster path is available via `data`"),u&&!u.source))return;he|=1;let $t=ee===W&&de?"":ee&&He(ee)?ee.text.toLowerCase():"",Ht=(Te=m.getModuleSpecifierCache)==null?void 0:Te.call(m),dr=PM(n,m,e,o,S),qr=(Re=m.getPackageJsonAutoImportProvider)==null?void 0:Re.call(m),Hr=u?void 0:ZN(n,o,m);bVe("collectAutoImports",m,De||(De=A_.createImportSpecifierResolver(n,e,m,o)),e,s,o,!!de,gb(Ae),Ar=>{dr.search(n.path,ce,(In,Ki)=>{if(!sp(In,Ka(m.getCompilationSettings()))||!u&&uA(In)||!et&&!de&&!(Ki&111551)||et&&!(Ki&790504))return!1;let ls=In.charCodeAt(0);return ce&&(ls<65||ls>90)?!1:u?!0:YVe(In,$t)},(In,Ki,ls,Yn)=>{if(u&&!Pt(In,uo=>u.source===Zd(uo.moduleSymbol.name))||(In=Zn(In,dn),!In.length))return;let pi=Ar.tryResolve(In,ls)||{};if(pi==="failed")return;let Er=In[0],tn;pi!=="skipped"&&({exportInfo:Er=In[0],moduleSpecifier:tn}=pi);let er=Er.exportKind===1,qs=er&&KI(M.checkDefined(Er.symbol))||M.checkDefined(Er.symbol);Vr(qs,{kind:tn?32:4,moduleSpecifier:tn,symbolName:Ki,exportMapKey:Yn,exportName:Er.exportKind===2?"export=":M.checkDefined(Er.symbol).name,fileName:Er.moduleFileName,isDefaultExport:er,moduleSymbol:Er.moduleSymbol,isFromPackageJson:Er.isFromPackageJson})}),Pe=Ar.skippedAny(),he|=Ar.resolvedAny()?8:0,he|=Ar.resolvedBeyondLimit()?16:0});function dn(Ar){let In=ai(Ar.moduleSymbol.valueDeclaration,Ji);if(!In){let Ki=Zd(Ar.moduleSymbol.name);return eh.nodeCoreModules.has(Ki)&&_s(Ki,"node:")!==aV(n,e)?!1:Hr?Hr.allowsImportingAmbientModule(Ar.moduleSymbol,Ie(Ar.isFromPackageJson)):!0}return aZ(Ar.isFromPackageJson?qr:e,n,In,o,Hr,Ie(Ar.isFromPackageJson),Ht)}}function Vr(Te,Re){let It=Aa(Te);ct[It]!==k_.GlobalsOrKeywords&&(Be[ke.length]=Re,ct[It]=de?k_.LocationPriority:k_.AutoImportSuggestions,ke.push(Te))}function An(Te,Re){hn(Ae)||Te.forEach(It=>{if(!vi(It))return;let $t=kee(It,Ka(i),void 0,0,!1);if(!$t)return;let{name:Ht}=$t,dr=NIt(It,Ht,Re,e,m,i,o,d);if(!dr)return;let qr={kind:128,...dr};he|=32,Be[ke.length]=qr,ke.push(It)})}function vi(Te){return!!(Te.flags&8196)}function Ci(Te,Re,It){let $t=Te;for(;$t&&!fQ($t,Re,It);)$t=$t.parent;return $t}function Ui(Te){let Re=Tc(),It=yr(Te)||Oe(Te)||Ut(Te)||la(Te)||o8(Te);return t("getCompletionsAtPosition: isCompletionListBlocker: "+(Tc()-Re)),It}function la(Te){if(Te.kind===12)return!0;if(Te.kind===32&&Te.parent){if(Ae===Te.parent&&(Ae.kind===286||Ae.kind===285))return!1;if(Te.parent.kind===286)return Ae.parent.kind!==286;if(Te.parent.kind===287||Te.parent.kind===285)return!!Te.parent.parent&&Te.parent.parent.kind===284}return!1}function Gs(){if(W){let Te=W.parent.kind,Re=Nee(W);switch(Re){case 28:return Te===213||Te===176||Te===214||Te===209||Te===226||Te===184||Te===210;case 21:return Te===213||Te===176||Te===214||Te===217||Te===196;case 23:return Te===209||Te===181||Te===167;case 144:case 145:case 102:return!0;case 25:return Te===267;case 19:return Te===263||Te===210;case 64:return Te===260||Te===226;case 16:return Te===228;case 17:return Te===239;case 134:return Te===174||Te===304;case 42:return Te===174}if(UV(Re))return!0}return!1}function yr(Te){return(HG(Te)||j$(Te))&&(lM(Te,s)||s===Te.end&&(!!Te.isUnterminated||HG(Te)))}function to(){let Te=GIt(W);if(!Te)return 0;let It=(jA(Te.parent)?Te.parent:void 0)||Te,$t=JVe(It,E);if(!$t)return 0;let Ht=E.getTypeFromTypeNode(It),dr=wee($t,E),qr=wee(Ht,E),Hr=new Set;return qr.forEach(dn=>Hr.add(dn.escapedName)),ke=ps(ke,Zn(dr,dn=>!Hr.has(dn.escapedName))),Ve=0,te=!0,1}function lt(){if(W?.kind===26)return 0;let Te=ke.length,Re=JIt(W,s,n);if(!Re)return 0;Ve=0;let It,$t;if(Re.kind===210){let Ht=QIt(Re,E);if(Ht===void 0)return Re.flags&67108864?2:0;let dr=E.getContextualType(Re,4),qr=(dr||Ht).getStringIndexType(),Hr=(dr||Ht).getNumberIndexType();if(te=!!qr||!!Hr,It=Dee(Ht,dr,Re,E),$t=Re.properties,It.length===0&&!Hr)return 0}else{M.assert(Re.kind===206),te=!1;let Ht=Bg(Re.parent);if(!rA(Ht))return M.fail("Root declaration is not variable-like.");let dr=bv(Ht)||!!Vl(Ht)||Ht.parent.parent.kind===250;if(!dr&&Ht.kind===169&&(Ct(Ht.parent)?dr=!!E.getContextualType(Ht.parent):(Ht.parent.kind===174||Ht.parent.kind===178)&&(dr=Ct(Ht.parent.parent)&&!!E.getContextualType(Ht.parent.parent))),dr){let qr=E.getTypeAtLocation(Re);if(!qr)return 2;It=E.getPropertiesOfType(qr).filter(Hr=>E.isPropertyAccessible(Re,!1,!1,qr,Hr)),$t=Re.elements}}if(It&&It.length>0){let Ht=nr(It,M.checkDefined($t));ke=ps(ke,Ht),Ge(),Re.kind===210&&o.includeCompletionsWithObjectLiteralMethodSnippets&&o.includeCompletionsWithInsertText&&(Q(Te),An(Ht,Re))}return 1}function St(){if(!W)return 0;let Te=W.kind===19||W.kind===28?ai(W.parent,V9):jU(W)?ai(W.parent.parent,V9):void 0;if(!Te)return 0;jU(W)||(xe=8);let{moduleSpecifier:Re}=Te.kind===275?Te.parent.parent:Te.parent;if(!Re)return te=!0,Te.kind===275?2:0;let It=E.getSymbolAtLocation(Re);if(!It)return te=!0,2;Ve=3,te=!1;let $t=E.getExportsAndPropertiesOfModule(It),Ht=new Set(Te.elements.filter(qr=>!Ue(qr)).map(qr=>(qr.propertyName||qr.name).escapedText)),dr=$t.filter(qr=>qr.escapedName!=="default"&&!Ht.has(qr.escapedName));return ke=ps(ke,dr),dr.length||(xe=0),1}function fe(){if(W===void 0)return 0;let Te=W.kind===19||W.kind===28?ai(W.parent,l2):W.kind===59?ai(W.parent.parent,l2):void 0;if(Te===void 0)return 0;let Re=new Set(Te.elements.map(hj));return ke=Zn(E.getTypeAtLocation(Te).getApparentProperties(),It=>!Re.has(It.escapedName)),1}function vt(){var Te;let Re=W&&(W.kind===19||W.kind===28)?ai(W.parent,kd):void 0;if(!Re)return 0;let It=Pr(Re,Jp(Ji,El));return Ve=5,te=!1,(Te=It.locals)==null||Te.forEach(($t,Ht)=>{var dr,qr;ke.push($t),(qr=(dr=It.symbol)==null?void 0:dr.exports)!=null&&qr.has(Ht)&&(ct[Aa($t)]=k_.OptionalMember)}),1}function Ce(){let Te=HIt(n,W,Ae,s);if(!Te)return 0;if(Ve=3,te=!0,xe=W.kind===42?0:gi(Te)?2:3,!gi(Te))return 1;let Re=W.kind===27?W.parent.parent:W.parent,It=uu(Re)?U_(Re):0;if(W.kind===80&&!Ue(W))switch(W.getText()){case"private":It=It|2;break;case"static":It=It|256;break;case"override":It=It|16;break}if(Gc(Re)&&(It|=256),!(It&2)){let $t=gi(Te)&&It&16?qC(Fg(Te)):BI(Te),Ht=va($t,dr=>{let qr=E.getTypeAtLocation(dr);return It&256?qr?.symbol&&E.getPropertiesOfType(E.getTypeOfSymbolAtLocation(qr.symbol,Te)):qr&&E.getPropertiesOfType(qr)});ke=ps(ke,Ke(Ht,Te.members,It)),kt(ke,(dr,qr)=>{let Hr=dr?.valueDeclaration;if(Hr&&uu(Hr)&&Hr.name&&za(Hr.name)){let dn={kind:512,symbolName:E.symbolToString(dr)};Be[qr]=dn}})}return 1}function nt(Te){return!!Te.parent&&ns(Te.parent)&&Vc(Te.parent.parent)&&(SI(Te.kind)||Uh(Te))}function Me(Te){if(Te){let Re=Te.parent;switch(Te.kind){case 21:case 28:return Vc(Te.parent)?Te.parent:void 0;default:if(nt(Te))return Re.parent}}}function tt(Te){if(Te){let Re,It=Pr(Te.parent,$t=>gi($t)?"quit":Go($t)&&Re===$t.body?!0:(Re=$t,!1));return It&&It}}function ft(Te){if(Te){let Re=Te.parent;switch(Te.kind){case 32:case 31:case 44:case 80:case 211:case 292:case 291:case 293:if(Re&&(Re.kind===285||Re.kind===286)){if(Te.kind===32){let It=iu(Te.pos,n,void 0);if(!Re.typeArguments||It&&It.kind===44)break}return Re}else if(Re.kind===291)return Re.parent.parent;break;case 11:if(Re&&(Re.kind===291||Re.kind===293))return Re.parent.parent;break;case 20:if(Re&&Re.kind===294&&Re.parent&&Re.parent.kind===291)return Re.parent.parent.parent;if(Re&&Re.kind===293)return Re.parent.parent;break}}}function tr(Te,Re){return n.getLineEndOfPosition(Te.getEnd())<Re}function Oe(Te){let Re=Te.parent,It=Re.kind;switch(Te.kind){case 28:return It===260||Rt(Te)||It===243||It===266||Nt(It)||It===264||It===207||It===265||gi(Re)&&!!Re.typeParameters&&Re.typeParameters.end>=Te.pos;case 25:return It===207;case 59:return It===208;case 23:return It===207;case 21:return It===299||Nt(It);case 19:return It===266;case 30:return It===263||It===231||It===264||It===265||YC(It);case 126:return It===172&&!gi(Re.parent);case 26:return It===169||!!Re.parent&&Re.parent.kind===207;case 125:case 123:case 124:return It===169&&!Vc(Re.parent);case 130:return It===276||It===281||It===274;case 139:case 153:return!Iee(Te);case 80:{if(It===276&&Te===Re.name&&Te.text==="type"||Pr(Te.parent,Ei)&&tr(Te,s))return!1;break}case 86:case 94:case 120:case 100:case 115:case 102:case 121:case 87:case 140:return!0;case 156:return It!==276;case 42:return Bs(Te.parent)&&!ul(Te.parent)}if(UV(Nee(Te))&&Iee(Te)||nt(Te)&&(!He(Te)||SI(Nee(Te))||Ue(Te)))return!1;switch(Nee(Te)){case 128:case 86:case 87:case 138:case 94:case 100:case 120:case 121:case 123:case 124:case 125:case 126:case 115:return!0;case 134:return Ns(Te.parent)}if(Pr(Te.parent,gi)&&Te===ee&&At(Te,s))return!1;let Ht=pb(Te.parent,172);if(Ht&&Te!==ee&&gi(ee.parent.parent)&&s<=ee.end){if(At(Te,ee.end))return!1;if(Te.kind!==64&&(B8(Ht)||F5(Ht)))return!0}return Uh(Te)&&!p_(Te.parent)&&!Kg(Te.parent)&&!((gi(Te.parent)||Yu(Te.parent)||Ac(Te.parent))&&(Te!==ee||s>ee.end))}function At(Te,Re){return Te.kind!==64&&(Te.kind===27||!Ed(Te.end,Re,n))}function Nt(Te){return YC(Te)&&Te!==176}function Ut(Te){if(Te.kind===9){let Re=Te.getFullText();return Re.charAt(Re.length-1)==="."}return!1}function Rt(Te){return Te.parent.kind===261&&!fM(Te,n,E)}function nr(Te,Re){if(Re.length===0)return Te;let It=new Set,$t=new Set;for(let dr of Re){if(dr.kind!==303&&dr.kind!==304&&dr.kind!==208&&dr.kind!==174&&dr.kind!==177&&dr.kind!==178&&dr.kind!==305||Ue(dr))continue;let qr;if(Fy(dr))Z(dr,It);else if(Xa(dr)&&dr.propertyName)dr.propertyName.kind===80&&(qr=dr.propertyName.escapedText);else{let Hr=Ps(dr);qr=Hr&&jg(Hr)?JI(Hr):void 0}qr!==void 0&&$t.add(qr)}let Ht=Te.filter(dr=>!$t.has(dr.escapedName));return bt(It,Ht),Ht}function Z(Te,Re){let It=Te.expression,$t=E.getSymbolAtLocation(It),Ht=$t&&E.getTypeOfSymbolAtLocation($t,It),dr=Ht&&Ht.properties;dr&&dr.forEach(qr=>{Re.add(qr.name)})}function Ge(){ke.forEach(Te=>{if(Te.flags&16777216){let Re=Aa(Te);ct[Re]=ct[Re]??k_.OptionalMember}})}function bt(Te,Re){if(Te.size!==0)for(let It of Re)Te.has(It.name)&&(ct[Aa(It)]=k_.MemberDeclaredBySpreadAssignment)}function Q(Te){for(let Re=Te;Re<ke.length;Re++){let It=ke[Re],$t=Aa(It),Ht=Be?.[Re],dr=Ka(i),qr=kee(It,dr,Ht,0,!1);if(qr){let Hr=ct[$t]??k_.LocationPriority,{name:dn}=qr;ct[$t]=k_.ObjectLiteralProperty(Hr,dn)}}}function Ke(Te,Re,It){let $t=new Set;for(let Ht of Re){if(Ht.kind!==172&&Ht.kind!==174&&Ht.kind!==177&&Ht.kind!==178||Ue(Ht)||up(Ht,2)||oa(Ht)!==!!(It&256))continue;let dr=e2(Ht.name);dr&&$t.add(dr)}return Te.filter(Ht=>!$t.has(Ht.escapedName)&&!!Ht.declarations&&!(xd(Ht)&2)&&!(Ht.valueDeclaration&&j_(Ht.valueDeclaration)))}function z(Te,Re){let It=new Set,$t=new Set;for(let dr of Re)Ue(dr)||(dr.kind===291?It.add(gO(dr.name)):qA(dr)&&Z(dr,$t));let Ht=Te.filter(dr=>!It.has(dr.escapedName));return bt($t,Ht),Ht}function Ue(Te){return Te.getStart(n)<=s&&s<=Te.getEnd()}}function JIt(e,t,n){var i;if(e){let{parent:s}=e;switch(e.kind){case 19:case 28:if(Ca(s)||Yp(s))return s;break;case 42:return ul(s)?ai(s.parent,Ca):void 0;case 134:return ai(s.parent,Ca);case 80:if(e.text==="async"&&p_(e.parent))return e.parent.parent;{if(Ca(e.parent.parent)&&(Fy(e.parent)||p_(e.parent)&&ba(n,e.getEnd()).line!==ba(n,t).line))return e.parent.parent;let u=Pr(s,ql);if(u?.getLastToken(n)===e&&Ca(u.parent))return u.parent}break;default:if((i=s.parent)!=null&&i.parent&&(ul(s.parent)||Hp(s.parent)||fp(s.parent))&&Ca(s.parent.parent))return s.parent.parent;if(Fy(s)&&Ca(s.parent))return s.parent;let o=Pr(s,ql);if(e.kind!==59&&o?.getLastToken(n)===e&&Ca(o.parent))return o.parent}}}function Aee(e,t){let n=iu(e,t);return n&&e<=n.end&&(Cy(n)||sf(n.kind))?{contextToken:iu(n.getFullStart(),t,void 0),previousToken:n}:{contextToken:n,previousToken:n}}function MVe(e,t,n,i){let s=t.isPackageJsonImport?i.getPackageJsonAutoImportProvider():n,o=s.getTypeChecker(),u=t.ambientModuleName?o.tryFindAmbientModule(t.ambientModuleName):t.fileName?o.getMergedSymbol(M.checkDefined(s.getSourceFile(t.fileName)).symbol):void 0;if(!u)return;let m=t.exportName==="export="?o.resolveExternalModuleSymbol(u):o.tryGetMemberInModuleExportsAndProperties(t.exportName,u);return m?(m=t.exportName==="default"&&KI(m)||m,{symbol:m,origin:wIt(t,e,u)}):void 0}function kee(e,t,n,i,s){if(pIt(n))return;let o=lIt(n)?n.symbolName:e.name;if(o===void 0||e.flags&1536&&pR(o.charCodeAt(0))||wR(e))return;let u={name:o,needsConvertPropertyAccess:!1};if(sp(o,t,s?1:0)||e.valueDeclaration&&j_(e.valueDeclaration))return u;switch(i){case 3:return Lbe(n)?{name:n.symbolName,needsConvertPropertyAccess:!1}:void 0;case 0:return{name:JSON.stringify(o),needsConvertPropertyAccess:!1};case 2:case 1:return o.charCodeAt(0)===32?void 0:{name:o,needsConvertPropertyAccess:!0};case 5:case 4:return u;default:M.assertNever(i)}}var Pee=[],LVe=tf(()=>{let e=[];for(let t=83;t<=165;t++)e.push({name:Sa(t),kind:"keyword",kindModifiers:"",sortText:k_.GlobalsOrKeywords});return e});function FVe(e,t){if(!t)return jVe(e);let n=e+8+1;return Pee[n]||(Pee[n]=jVe(e).filter(i=>!qIt(JT(i.name))))}function jVe(e){return Pee[e]||(Pee[e]=LVe().filter(t=>{let n=JT(t.name);switch(e){case 0:return!1;case 1:return UVe(n)||n===138||n===144||n===156||n===145||n===128||g6(n)&&n!==157;case 5:return UVe(n);case 2:return UV(n);case 3:return BVe(n);case 4:return SI(n);case 6:return g6(n)||n===87;case 7:return g6(n);case 8:return n===156;default:return M.assertNever(e)}}))}function qIt(e){switch(e){case 128:case 133:case 163:case 136:case 138:case 94:case 162:case 119:case 140:case 120:case 142:case 143:case 144:case 145:case 146:case 150:case 151:case 164:case 123:case 124:case 125:case 148:case 154:case 155:case 156:case 158:case 159:return!0;default:return!1}}function BVe(e){return e===148}function UV(e){switch(e){case 128:case 129:case 137:case 139:case 153:case 134:case 138:case 164:return!0;default:return B$(e)}}function UVe(e){return e===134||e===135||e===160||e===130||e===152||e===156||!S9(e)&&!UV(e)}function Nee(e){return He(e)?Jx(e)??0:e.kind}function zIt(e,t){let n=[];if(e){let i=e.getSourceFile(),s=e.parent,o=i.getLineAndCharacterOfPosition(e.end).line,u=i.getLineAndCharacterOfPosition(t).line;(Yc(s)||xl(s)&&s.moduleSpecifier)&&e===s.moduleSpecifier&&o===u&&n.push({name:Sa(132),kind:"keyword",kindModifiers:"",sortText:k_.GlobalsOrKeywords})}return n}function WIt(e,t){return Pr(e,n=>jP(n)&&cM(n,t)?!0:ag(n)?"quit":!1)}function Dee(e,t,n,i){let s=t&&t!==e,o=s&&!(t.flags&3)?i.getUnionType([e,t]):e,u=$It(o,n,i);return o.isClass()&&VVe(u)?[]:s?Zn(u,m):u;function m(d){return wt(d.declarations)?Pt(d.declarations,S=>S.parent!==n):!0}}function $It(e,t,n){return e.isUnion()?n.getAllPossiblePropertiesOfTypes(Zn(e.types,i=>!(i.flags&402784252||n.isArrayLikeType(i)||n.isTypeInvalidDueToUnionDiscriminant(i,t)||n.typeHasCallOrConstructSignatures(i)||i.isClass()&&VVe(i.getApparentProperties())))):e.getApparentProperties()}function VVe(e){return Pt(e,t=>!!(xd(t)&6))}function wee(e,t){return e.isUnion()?M.checkEachDefined(t.getAllPossiblePropertiesOfTypes(e.types),"getAllPossiblePropertiesOfTypes() should all be defined"):M.checkEachDefined(e.getApparentProperties(),"getApparentProperties() should all be defined")}function HIt(e,t,n,i){switch(n.kind){case 352:return ai(n.parent,gA);case 1:let s=ai(vc(aa(n.parent,Ji).statements),gA);if(s&&!Oo(s,20,e))return s;break;case 81:if(ai(n.parent,Ns))return Pr(n,gi);break;case 80:{if(Jx(n)||Ns(n.parent)&&n.parent.initializer===n)return;if(Iee(n))return Pr(n,gA)}}if(t){if(n.kind===137||He(t)&&Ns(t.parent)&&gi(n))return Pr(t,gi);switch(t.kind){case 64:return;case 27:case 20:return Iee(n)&&n.parent.name===n?n.parent.parent:ai(n,gA);case 19:case 28:return ai(t.parent,gA);default:if(gA(n)){if(ba(e,t.getEnd()).line!==ba(e,i).line)return n;let s=gi(t.parent.parent)?UV:BVe;return s(t.kind)||t.kind===42||He(t)&&s(Jx(t)??0)?t.parent.parent:void 0}return}}}function GIt(e){if(!e)return;let t=e.parent;switch(e.kind){case 19:if(lf(t))return t;break;case 27:case 28:case 80:if(t.kind===171&&lf(t.parent))return t.parent;break}}function JVe(e,t){if(!e)return;if(Di(e)&&j5(e.parent))return t.getTypeArgumentConstraint(e);let n=JVe(e.parent,t);if(n)switch(e.kind){case 171:return t.getTypeOfPropertyOfContextualType(n,e.symbol.escapedName);case 193:case 187:case 192:return n}}function Iee(e){return e.parent&&D5(e.parent)&&gA(e.parent.parent)}function YIt(e,t,n,i){switch(t){case".":case"@":return!0;case'"':case"'":case"`":return!!n&&K0e(n)&&i===n.getStart(e)+1;case"#":return!!n&&Zi(n)&&!!Ou(n);case"<":return!!n&&n.kind===30&&(!Pn(n.parent)||qVe(n.parent));case"/":return!!n&&(No(n)?!!bR(n):n.kind===44&&yE(n.parent));case" ":return!!n&&xO(n)&&n.parent.kind===307;default:return M.assertNever(t)}}function qVe({left:e}){return $c(e)}function KIt(e,t,n){let i=n.resolveName("self",void 0,111551,!1);if(i&&n.getTypeOfSymbolAtLocation(i,t)===e)return!0;let s=n.resolveName("global",void 0,111551,!1);if(s&&n.getTypeOfSymbolAtLocation(s,t)===e)return!0;let o=n.resolveName("globalThis",void 0,111551,!1);return!!(o&&n.getTypeOfSymbolAtLocation(o,t)===e)}function XIt(e){return!!(e.valueDeclaration&&U_(e.valueDeclaration)&256&&gi(e.valueDeclaration.parent))}function QIt(e,t){let n=t.getContextualType(e);if(n)return n;let i=g0(e.parent);if(Pn(i)&&i.operatorToken.kind===64&&e===i.left)return t.getTypeAtLocation(i);if(Ct(i))return t.getContextualType(i)}function zVe(e,t){var n,i,s;let o,u=!1,m=d();return{isKeywordOnlyCompletion:u,keywordCompletion:o,isNewIdentifierLocation:!!(m||o===156),isTopLevelTypeOnly:!!((i=(n=ai(m,Yc))==null?void 0:n.importClause)!=null&&i.isTypeOnly)||!!((s=ai(m,ru))!=null&&s.isTypeOnly),couldBeTypeOnlyImportSpecifier:!!m&&$Ve(m,e),replacementSpan:ZIt(m)};function d(){let S=e.parent;if(ru(S)){let E=S.getLastToken(t);if(He(e)&&E!==e){o=161,u=!0;return}return o=e.kind===156?void 0:156,zbe(S.moduleReference)?S:void 0}if($Ve(S,e)&&HVe(S.parent))return S;if(Gg(S)||My(S)){if(!S.parent.isTypeOnly&&(e.kind===19||e.kind===102||e.kind===28)&&(o=156),HVe(S))if(e.kind===20||e.kind===80)u=!0,o=161;else return S.parent.parent;return}if(xl(S)&&e.kind===42||kd(S)&&e.kind===20){u=!0,o=161;return}if(xO(e)&&Ji(S))return o=156,e;if(xO(e)&&Yc(S))return o=156,zbe(S.moduleSpecifier)?S:void 0}}function ZIt(e){var t;if(!e)return;let n=Pr(e,Jp(Yc,ru,Xg))??e,i=n.getSourceFile();if(n2(n,i))return df(n,i);M.assert(n.kind!==102&&n.kind!==276);let s=n.kind===272||n.kind===351?WVe((t=n.importClause)==null?void 0:t.namedBindings)??n.moduleSpecifier:n.moduleReference,o={pos:n.getFirstToken().getStart(),end:s.pos};if(n2(o,i))return lS(o)}function WVe(e){var t;return Ln((t=ai(e,Gg))==null?void 0:t.elements,n=>{var i;return!n.propertyName&&uA(n.name.text)&&((i=iu(n.name.pos,e.getSourceFile(),e))==null?void 0:i.kind)!==28})}function $Ve(e,t){return _f(e)&&(e.isTypeOnly||t===e.name&&jU(t))}function HVe(e){if(!zbe(e.parent.parent.moduleSpecifier)||e.parent.name)return!1;if(Gg(e)){let t=WVe(e);return(t?e.elements.indexOf(t):e.elements.length)<2}return!0}function zbe(e){var t;return $c(e)?!0:!((t=ai(C0(e)?e.expression:e,No))!=null&&t.text)}function eOt(e,t){if(!e)return;let n=Pr(e,s=>XT(s)||GVe(s)||Hs(s)?"quit":(ns(s)||Ac(s))&&!fE(s.parent)),i=Pr(t,s=>XT(s)||GVe(s)||Hs(s)?"quit":Ei(s));return n||i}function GVe(e){return e.parent&&pc(e.parent)&&(e.parent.body===e||e.kind===39)}function Wbe(e,t,n=new Map){return i(e)||i($u(e.exportSymbol||e,t));function i(s){return!!(s.flags&788968)||t.isUnknownSymbol(s)||!!(s.flags&1536)&&em(n,Aa(s))&&t.getExportsOfModule(s).some(o=>Wbe(o,t,n))}}function tOt(e,t){let n=$u(e,t).declarations;return!!wt(n)&&wi(n,sV)}function YVe(e,t){if(t.length===0)return!0;let n=!1,i,s=0,o=e.length;for(let u=0;u<o;u++){let m=e.charCodeAt(u),d=t.charCodeAt(s);if((m===d||m===rOt(d))&&(n||(n=i===void 0||97<=i&&i<=122&&65<=m&&m<=90||i===95&&m!==95),n&&s++,s===t.length))return!0;i=m}return!1}function rOt(e){return 97<=e&&e<=122?e-32:e}function nOt(e){return e==="abstract"||e==="async"||e==="await"||e==="declare"||e==="module"||e==="namespace"||e==="type"||e==="satisfies"||e==="as"}var Oee={};A(Oee,{getStringLiteralCompletionDetails:()=>aOt,getStringLiteralCompletions:()=>iOt});var KVe={directory:0,script:1,"external module name":2};function $be(){let e=new Map;function t(n){let i=e.get(n.name);(!i||KVe[i.kind]<KVe[n.kind])&&e.set(n.name,n)}return{add:t,has:e.has.bind(e),values:e.values.bind(e)}}function iOt(e,t,n,i,s,o,u,m,d){if(D0e(e,t)){let S=SOt(e,t,i,s);return S&&XVe(S)}if(ik(e,t,n)){if(!n||!No(n))return;let S=ZVe(e,n,t,o,s,m);return sOt(S,n,e,s,o,u,i,m,t,d)}}function sOt(e,t,n,i,s,o,u,m,d,S){if(e===void 0)return;let E=TQ(t,d);switch(e.kind){case 0:return XVe(e.paths);case 1:{let x=Rx();return Ube(e.symbols,x,t,t,n,d,n,i,s,99,o,4,m,u,void 0,void 0,void 0,void 0,void 0,void 0,void 0,void 0,void 0,void 0,void 0,S),{isGlobalCompletion:!1,isMemberCompletion:!0,isNewIdentifierLocation:e.hasIndexSignature,optionalReplacementSpan:E,entries:x}}case 2:{let x=t.kind===15?96:_s(Hc(t),"'")?39:34,D=e.types.map(w=>({name:Vh(w.value,x),kindModifiers:"",kind:"string",sortText:k_.LocationPriority,replacementSpan:bQ(t,d)}));return{isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:e.isNewIdentifier,optionalReplacementSpan:E,entries:D}}default:return M.assertNever(e)}}function aOt(e,t,n,i,s,o,u,m){if(!i||!No(i))return;let d=ZVe(t,i,n,s,o,m);return d&&oOt(e,i,d,t,s.getTypeChecker(),u)}function oOt(e,t,n,i,s,o){switch(n.kind){case 0:{let u=Ln(n.paths,m=>m.name===e);return u&&BV(e,QVe(u.extension),u.kind,[td(e)])}case 1:{let u=Ln(n.symbols,m=>m.name===e);return u&&Jbe(u,u.name,s,i,t,o)}case 2:return Ln(n.types,u=>u.value===e)?BV(e,"","string",[td(e)]):void 0;default:return M.assertNever(n)}}function XVe(e){return{isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:!0,entries:e.map(({name:s,kind:o,span:u,extension:m})=>({name:s,kind:o,kindModifiers:QVe(m),sortText:k_.LocationPriority,replacementSpan:u}))}}function QVe(e){switch(e){case".d.ts":return".d.ts";case".js":return".js";case".json":return".json";case".jsx":return".jsx";case".ts":return".ts";case".tsx":return".tsx";case".d.mts":return".d.mts";case".mjs":return".mjs";case".mts":return".mts";case".d.cts":return".d.cts";case".cjs":return".cjs";case".cts":return".cts";case".tsbuildinfo":return M.fail("Extension .tsbuildinfo is unsupported.");case void 0:return"";default:return M.assertNever(e)}}function ZVe(e,t,n,i,s,o){let u=i.getTypeChecker(),m=Hbe(t.parent);switch(m.kind){case 201:{let w=Hbe(m.parent);return w.kind===205?{kind:0,paths:rJe(e,t,i,s,o)}:d(w)}case 303:return Ca(m.parent)&&m.name===t?uOt(u,m.parent):S()||S(0);case 212:{let{expression:w,argumentExpression:R}=m;return t===So(R)?eJe(u.getTypeAtLocation(w)):void 0}case 213:case 214:case 291:if(!AOt(t)&&!Np(m)){let w=YM.getArgumentInfoForCompletions(m.kind===291?m.parent:t,n,e,u);return w&&lOt(w.invocation,t,w,u)||S(0)}case 272:case 278:case 283:case 351:return{kind:0,paths:rJe(e,t,i,s,o)};case 296:let E=cV(u,m.parent.clauses),x=S();return x?{kind:2,types:x.types.filter(w=>!E.hasValue(w.value)),isNewIdentifier:!1}:void 0;default:return S()||S(0)}function d(E){switch(E.kind){case 233:case 183:{let w=Pr(m,R=>R.parent===E);return w?{kind:2,types:Ree(u.getTypeArgumentConstraint(w)),isNewIdentifier:!1}:void 0}case 199:let{indexType:x,objectType:D}=E;return cM(x,n)?eJe(u.getTypeFromTypeNode(D)):void 0;case 192:{let w=d(Hbe(E.parent));if(!w)return;let R=cOt(E,m);return w.kind===1?{kind:1,symbols:w.symbols.filter(L=>!Es(R,L.name)),hasIndexSignature:w.hasIndexSignature}:{kind:2,types:w.types.filter(L=>!Es(R,L.value)),isNewIdentifier:!1}}default:return}}function S(E=4){let x=Ree(HU(t,u,E));if(x.length)return{kind:2,types:x,isNewIdentifier:!1}}}function Hbe(e){switch(e.kind){case 196:return AR(e);case 217:return g0(e);default:return e}}function cOt(e,t){return Gi(e.types,n=>n!==t&&Mv(n)&&La(n.literal)?n.literal.text:void 0)}function lOt(e,t,n,i){let s=!1,o=new Map,u=__(e)?M.checkDefined(Pr(t.parent,Kg)):t,m=i.getCandidateSignaturesForStringLiteralCompletions(e,u),d=va(m,S=>{if(!E_(S)&&n.argumentCount>S.parameters.length)return;let E=S.getTypeParameterAtPosition(n.argumentIndex);if(__(e)){let x=i.getTypeOfPropertyOfType(E,ZR(u.name));x&&(E=x)}return s=s||!!(E.flags&4),Ree(E,o)});return wt(d)?{kind:2,types:d,isNewIdentifier:s}:void 0}function eJe(e){return e&&{kind:1,symbols:Zn(e.getApparentProperties(),t=>!(t.valueDeclaration&&j_(t.valueDeclaration))),hasIndexSignature:$Q(e)}}function uOt(e,t){let n=e.getContextualType(t);if(!n)return;let i=e.getContextualType(t,4);return{kind:1,symbols:Dee(n,i,t,e),hasIndexSignature:$Q(n)}}function Ree(e,t=new Map){return e?(e=AQ(e),e.isUnion()?va(e.types,n=>Ree(n,t)):e.isStringLiteral()&&!(e.flags&1024)&&em(t,e.value)?[e]:ve):ve}function M6(e,t,n){return{name:e,kind:t,extension:n}}function Gbe(e){return M6(e,"directory",void 0)}function tJe(e,t,n){let i=TOt(e,t),s=e.length===0?void 0:zu(t,e.length);return n.map(({name:o,kind:u,extension:m})=>o.includes(Ec)||o.includes(f5)?{name:o,kind:u,extension:m,span:s}:{name:o,kind:u,extension:m,span:i})}function rJe(e,t,n,i,s){return tJe(t.text,t.getStart(e)+1,_Ot(e,t,n,i,s))}function _Ot(e,t,n,i,s){let o=qu(t.text),u=No(t)?n.getModeForUsageLocation(e,t):void 0,m=e.path,d=mi(m),S=n.getCompilerOptions(),E=n.getTypeChecker(),x=Ybe(S,1,e,E,s,u);return EOt(o)||!S.baseUrl&&!S.paths&&(ip(o)||hue(o))?fOt(o,d,S,i,m,x):gOt(o,d,u,S,i,x,E)}function Ybe(e,t,n,i,s,o){return{extensionsToSearch:ef(pOt(e,i)),referenceKind:t,importingSourceFile:n,endingPreference:s?.importModuleSpecifierEnding,resolutionMode:o}}function fOt(e,t,n,i,s,o){return n.rootDirs?mOt(n.rootDirs,e,t,o,n,i,s):Is(zM(e,t,o,i,!0,s).values())}function pOt(e,t){let n=t?Gi(t.getAmbientModules(),o=>{let u=o.name.slice(1,-1);if(!(!u.startsWith("*.")||u.includes("/")))return u.slice(1)}):[],i=[...aO(e),n],s=af(e);return BU(s)?HR(e,i):i}function dOt(e,t,n,i){e=e.map(o=>yu(Zs(ip(o)?o:ri(t,o))));let s=yi(e,o=>Cm(o,n,t,i)?n.substr(o.length):void 0);return I1([...e.map(o=>ri(o,s)),n].map(o=>ZS(o)),Lx,c_)}function mOt(e,t,n,i,s,o,u){let m=s.project||o.getCurrentDirectory(),d=!(o.useCaseSensitiveFileNames&&o.useCaseSensitiveFileNames()),S=dOt(e,m,n,d);return I1(va(S,E=>Is(zM(t,E,i,o,!0,u).values())),(E,x)=>E.name===x.name&&E.kind===x.kind&&E.extension===x.extension)}function zM(e,t,n,i,s,o,u=$be()){var m;e===void 0&&(e=""),e=qu(e),hv(e)||(e=mi(e)),e===""&&(e="."+Ec),e=yu(e);let d=QS(t,e),S=hv(d)?d:mi(d);if(!s){let w=Z0e(S,i);if(w){let L=XI(w,i).typesVersions;if(typeof L=="object"){let F=(m=mB(L))==null?void 0:m.paths;if(F){let J=mi(w),G=d.slice(yu(J).length);if(iJe(u,G,J,n,i,F))return u}}}}let E=!(i.useCaseSensitiveFileNames&&i.useCaseSensitiveFileNames());if(!QU(i,S))return u;let x=YQ(i,S,n.extensionsToSearch,void 0,["./*"]);if(x)for(let w of x){if(w=Zs(w),o&&_0(w,o,t,E)===0)continue;let{name:R,extension:L}=nJe(Ul(w),i.getCompilationSettings(),n,!1);u.add(M6(R,"script",L))}let D=XU(i,S);if(D)for(let w of D){let R=Ul(Zs(w));R!=="@types"&&u.add(Gbe(R))}return u}function nJe(e,t,n,i){let s=wb.tryGetRealFileNameForNonJsDeclarationFileName(e);if(s)return{name:s,extension:b0(s)};if(n.referenceKind===0)return{name:e,extension:b0(e)};let o=YO({importModuleSpecifierEnding:n.endingPreference},t,n.importingSourceFile).getAllowedEndingsInPreferredOrder(n.resolutionMode);if(i&&(o=o.filter(m=>m!==0&&m!==1)),o[0]===3){if(wl(e,aj))return{name:e,extension:b0(e)};let m=wb.tryGetJSExtensionForFile(e,t);return m?{name:Y1(e,m),extension:m}:{name:e,extension:b0(e)}}if(!i&&(o[0]===0||o[0]===1)&&wl(e,[".js",".jsx",".ts",".tsx",".d.ts"]))return{name:of(e),extension:b0(e)};let u=wb.tryGetJSExtensionForFile(e,t);return u?{name:Y1(e,u),extension:u}:{name:e,extension:b0(e)}}function iJe(e,t,n,i,s,o){let u=d=>o[d],m=(d,S)=>{let E=fN(d),x=fN(S),D=typeof E=="object"?E.prefix.length:d.length,w=typeof x=="object"?x.prefix.length:S.length;return tc(w,D)};return sJe(e,!1,t,n,i,s,Ng(o),u,m)}function sJe(e,t,n,i,s,o,u,m,d){let S=[],E;for(let x of u){if(x===".")continue;let D=x.replace(/^\.\//,""),w=m(x);if(w){let R=fN(D);if(!R)continue;let L=typeof R=="object"&&t5(R,n);L&&(E===void 0||d(x,E)===-1)&&(E=x,S=S.filter(J=>!J.matchedPattern)),(typeof R=="string"||E===void 0||d(x,E)!==1)&&S.push({matchedPattern:L,results:hOt(D,w,n,i,s,t&&L,o).map(({name:J,kind:G,extension:q})=>M6(J,G,q))})}}return S.forEach(x=>x.results.forEach(D=>e.add(D))),E!==void 0}function gOt(e,t,n,i,s,o,u){let{baseUrl:m,paths:d}=i,S=$be(),E=af(i);if(m){let D=Zs(ri(s.getCurrentDirectory(),m));zM(e,D,o,s,!1,void 0,S)}if(d){let D=k9(i,s);iJe(S,e,D,o,s,d)}let x=oJe(e);for(let D of vOt(e,x,u))S.add(M6(D,"external module name",void 0));if(uJe(s,i,t,x,o,S),BU(E)){let D=!1;if(x===void 0)for(let w of bOt(s,t)){let R=M6(w,"external module name",void 0);S.has(R.name)||(D=!0,S.add(R))}if(!D){let w=R=>{let L=ri(R,"node_modules");QU(s,L)&&zM(e,L,o,s,!1,void 0,S)};if(x&&mG(i)){let R=w;w=L=>{let F=hu(e);F.shift();let J=F.shift();if(!J)return R(L);if(_s(J,"@")){let ee=F.shift();if(!ee)return R(L);J=ri(J,ee)}let G=ri(L,"node_modules",J),q=ri(G,"package.json");if(xM(s,q)){let W=XI(q,s).exports;if(W){if(typeof W!="object"||W===null)return;let pe=Ng(W),K=F.join("/")+(F.length&&hv(e)?"/":""),re=sS(i,n);sJe(S,!0,K,G,o,s,pe,ue=>qC(aJe(W[ue],re)),lK);return}}return R(L)}}Am(t,w)}}return Is(S.values())}function aJe(e,t){if(typeof e=="string")return e;if(e&&typeof e=="object"&&!Rs(e)){for(let n in e)if(n==="default"||t.includes(n)||R8(t,n)){let i=e[n];return aJe(i,t)}}}function oJe(e){return Kbe(e)?hv(e)?e:mi(e):void 0}function hOt(e,t,n,i,s,o,u){if(!Wc(e,"*"))return e.includes("*")?ve:S(e,"script");let m=e.slice(0,e.length-1),d=UW(n,m);if(d===void 0)return e[e.length-2]==="/"?S(m,"directory"):va(t,x=>{var D;return(D=cJe("",i,x,s,o,u))==null?void 0:D.map(({name:w,...R})=>({name:m+w,...R}))});return va(t,E=>cJe(d,i,E,s,o,u));function S(E,x){return _s(E,n)?[{name:ZS(E),kind:x,extension:void 0}]:ve}}function cJe(e,t,n,i,s,o){if(!o.readDirectory)return;let u=fN(n);if(u===void 0||bs(u))return;let m=QS(u.prefix),d=hv(u.prefix)?m:mi(m),S=hv(u.prefix)?"":Ul(m),E=Kbe(e),x=E?hv(e)?e:mi(e):void 0,D=E?ri(d,S+x):d,w=Zs(u.suffix),R=w&&A9("_"+w),L=R?[Y1(w,R),w]:[w],F=Zs(ri(t,D)),J=E?F:yu(F)+S,G=w?L.map(pe=>"**/*"+pe):["./*"],q=Gi(YQ(o,F,i.extensionsToSearch,void 0,G),pe=>{let K=W(pe);if(K){if(Kbe(K))return Gbe(hu(lJe(K))[1]);let{name:re,extension:ue}=nJe(K,o.getCompilationSettings(),i,s);return M6(re,"script",ue)}}),ee=w?ve:Gi(XU(o,F),pe=>pe==="node_modules"?void 0:Gbe(pe));return[...q,...ee];function W(pe){return yi(L,K=>{let re=yOt(Zs(pe),J,K);return re===void 0?void 0:lJe(re)})}}function yOt(e,t,n){return _s(e,t)&&Wc(e,n)?e.slice(t.length,e.length-n.length):void 0}function lJe(e){return e[0]===Ec?e.slice(1):e}function vOt(e,t,n){let s=n.getAmbientModules().map(o=>Zd(o.name)).filter(o=>_s(o,e)&&!o.includes("*"));if(t!==void 0){let o=yu(t);return s.map(u=>Yw(u,o))}return s}function SOt(e,t,n,i){let s=Yi(e,t),o=Ty(e.text,s.pos),u=o&&Ln(o,R=>t>=R.pos&&t<=R.end);if(!u)return;let m=e.text.slice(u.pos,t),d=xOt.exec(m);if(!d)return;let[,S,E,x]=d,D=mi(e.path),w=E==="path"?zM(x,D,Ybe(n,0,e),i,!0,e.path):E==="types"?uJe(i,n,D,oJe(x),Ybe(n,1,e)):M.fail();return tJe(x,u.pos+S.length,Is(w.values()))}function uJe(e,t,n,i,s,o=$be()){let u=new Map,m=ZU(()=>zO(t,e))||ve;for(let S of m)d(S);for(let S of KQ(n,e)){let E=ri(mi(S),"node_modules/@types");d(E)}return o;function d(S){if(QU(e,S))for(let E of XU(e,S)){let x=M8(E);if(!(t.types&&!Es(t.types,x)))if(i===void 0)u.has(x)||(o.add(M6(x,"external module name",void 0)),u.set(x,!0));else{let D=ri(S,E),w=SG(i,x,Pv(e));w!==void 0&&zM(w,D,s,e,!1,void 0,o)}}}}function bOt(e,t){if(!e.readFile||!e.fileExists)return ve;let n=[];for(let i of KQ(t,e)){let s=XI(i,e);for(let o of COt){let u=s[o];if(u)for(let m in u)Ho(u,m)&&!_s(m,"@types/")&&n.push(m)}}return n}function TOt(e,t){let n=Math.max(e.lastIndexOf(Ec),e.lastIndexOf(f5)),i=n!==-1?n+1:0,s=e.length-i;return s===0||sp(e.substr(i,s),99)?void 0:zu(t+i,s)}function EOt(e){if(e&&e.length>=2&&e.charCodeAt(0)===46){let t=e.length>=3&&e.charCodeAt(1)===46?2:1,n=e.charCodeAt(t);return n===47||n===92}return!1}var xOt=/^(\/\/\/\s*<reference\s+(path|types)\s*=\s*(?:'|"))([^\x03"]*)$/,COt=["dependencies","devDependencies","peerDependencies","optionalDependencies"];function Kbe(e){return e.includes(Ec)}function AOt(e){return ea(e.parent)&&xo(e.parent.arguments)===e&&He(e.parent.expression)&&e.parent.expression.escapedText==="require"}var lc={};A(lc,{Core:()=>hk,DefinitionKind:()=>hJe,EntryKind:()=>yJe,ExportKind:()=>_Je,FindReferencesUse:()=>vJe,ImportExport:()=>fJe,createImportTracker:()=>Xbe,findModuleReferences:()=>pJe,findReferenceOrRenameEntries:()=>UOt,findReferencedSymbols:()=>FOt,getContextNode:()=>C2,getExportInfo:()=>Qbe,getImplementationsAtPosition:()=>BOt,getImportOrExportSymbol:()=>gJe,getReferenceEntriesForNode:()=>bJe,getTextSpanOfEntry:()=>rTe,isContextWithStartAndEndNode:()=>eTe,isDeclarationOfSymbol:()=>CJe,isWriteAccessForReference:()=>nTe,nodeEntry:()=>Uy,toContextSpan:()=>tTe,toHighlightSpan:()=>HOt,toReferenceEntry:()=>xJe,toRenameLocation:()=>JOt});function Xbe(e,t,n,i){let s=DOt(e,n,i);return(o,u,m)=>{let{directImports:d,indirectUsers:S}=kOt(e,t,s,u,n,i);return{indirectUsers:S,...POt(d,o,u.exportKind,n,m)}}}var _Je=(e=>(e[e.Named=0]="Named",e[e.Default=1]="Default",e[e.ExportEquals=2]="ExportEquals",e))(_Je||{}),fJe=(e=>(e[e.Import=0]="Import",e[e.Export=1]="Export",e))(fJe||{});function kOt(e,t,n,{exportingModuleSymbol:i,exportKind:s},o,u){let m=GN(),d=GN(),S=[],E=!!i.globalExports,x=E?void 0:[];return w(i),{directImports:S,indirectUsers:D()};function D(){if(E)return e;if(i.declarations)for(let q of i.declarations)YT(q)&&t.has(q.getSourceFile().fileName)&&J(q);return x.map(Ur)}function w(q){let ee=G(q);if(ee){for(let W of ee)if(m(W))switch(u&&u.throwIfCancellationRequested(),W.kind){case 213:if(Np(W)){R(W);break}if(!E){let K=W.parent;if(s===2&&K.kind===260){let{name:re}=K;if(re.kind===80){S.push(re);break}}}break;case 80:break;case 271:F(W,W.name,li(W,32),!1);break;case 272:case 351:S.push(W);let pe=W.importClause&&W.importClause.namedBindings;pe&&pe.kind===274?F(W,pe.name,!1,!0):!E&&aA(W)&&J(VV(W));break;case 278:W.exportClause?W.exportClause.kind===280?J(VV(W),!0):S.push(W):w(MOt(W,o));break;case 205:!E&&W.isTypeOf&&!W.qualifier&&L(W)&&J(W.getSourceFile(),!0),S.push(W);break;default:M.failBadSyntaxKind(W,"Unexpected import kind.")}}}function R(q){let ee=Pr(q,Mee)||q.getSourceFile();J(ee,!!L(q,!0))}function L(q,ee=!1){return Pr(q,W=>ee&&Mee(W)?"quit":wm(W)&&Pt(W.modifiers,OA))}function F(q,ee,W,pe){if(s===2)pe||S.push(q);else if(!E){let K=VV(q);M.assert(K.kind===307||K.kind===267),W||NOt(K,ee,o)?J(K,!0):J(K)}}function J(q,ee=!1){if(M.assert(!E),!d(q)||(x.push(q),!ee))return;let pe=o.getMergedSymbol(q.symbol);if(!pe)return;M.assert(!!(pe.flags&1536));let K=G(pe);if(K)for(let re of K)qh(re)||J(VV(re),!0)}function G(q){return n.get(Aa(q).toString())}}function POt(e,t,n,i,s){let o=[],u=[];function m(D,w){o.push([D,w])}if(e)for(let D of e)d(D);return{importSearches:o,singleReferences:u};function d(D){if(D.kind===271){Zbe(D)&&S(D.name);return}if(D.kind===80){S(D);return}if(D.kind===205){if(D.qualifier){let L=_p(D.qualifier);L.escapedText===Qc(t)&&u.push(L)}else n===2&&u.push(D.argument.literal);return}if(D.moduleSpecifier.kind!==11)return;if(D.kind===278){D.exportClause&&kd(D.exportClause)&&E(D.exportClause);return}let{name:w,namedBindings:R}=D.importClause||{name:void 0,namedBindings:void 0};if(R)switch(R.kind){case 274:S(R.name);break;case 275:(n===0||n===1)&&E(R);break;default:M.assertNever(R)}if(w&&(n===1||n===2)&&(!s||w.escapedText===UU(t))){let L=i.getSymbolAtLocation(w);m(w,L)}}function S(D){n===2&&(!s||x(D.escapedText))&&m(D,i.getSymbolAtLocation(D))}function E(D){if(D)for(let w of D.elements){let{name:R,propertyName:L}=w;if(x((L||R).escapedText))if(L)u.push(L),(!s||R.escapedText===t.escapedName)&&m(R,i.getSymbolAtLocation(R));else{let F=w.kind===281&&w.propertyName?i.getExportSpecifierLocalTargetSymbol(w):i.getSymbolAtLocation(R);m(R,F)}}}function x(D){return D===t.escapedName||n!==0&&D==="default"}}function NOt(e,t,n){let i=n.getSymbolAtLocation(t);return!!dJe(e,s=>{if(!xl(s))return;let{exportClause:o,moduleSpecifier:u}=s;return!u&&o&&kd(o)&&o.elements.some(m=>n.getExportSpecifierLocalTargetSymbol(m)===i)})}function pJe(e,t,n){var i;let s=[],o=e.getTypeChecker();for(let u of t){let m=n.valueDeclaration;if(m?.kind===307){for(let d of u.referencedFiles)e.getSourceFileFromReference(u,d)===m&&s.push({kind:"reference",referencingFile:u,ref:d});for(let d of u.typeReferenceDirectives){let S=(i=e.getResolvedTypeReferenceDirectiveFromTypeReferenceDirective(d,u))==null?void 0:i.resolvedTypeReferenceDirective;S!==void 0&&S.resolvedFileName===m.fileName&&s.push({kind:"reference",referencingFile:u,ref:d})}}mJe(u,(d,S)=>{o.getSymbolAtLocation(S)===n&&s.push(Ko(d)?{kind:"implicit",literal:S,referencingFile:u}:{kind:"import",literal:S})})}return s}function DOt(e,t,n){let i=new Map;for(let s of e)n&&n.throwIfCancellationRequested(),mJe(s,(o,u)=>{let m=t.getSymbolAtLocation(u);if(m){let d=Aa(m).toString(),S=i.get(d);S||i.set(d,S=[]),S.push(o)}});return i}function dJe(e,t){return kt(e.kind===307?e.statements:e.body.statements,n=>t(n)||Mee(n)&&kt(n.body&&n.body.statements,t))}function mJe(e,t){if(e.externalModuleIndicator||e.imports!==void 0)for(let n of e.imports)t(LI(n),n);else dJe(e,n=>{switch(n.kind){case 278:case 272:{let i=n;i.moduleSpecifier&&La(i.moduleSpecifier)&&t(i,i.moduleSpecifier);break}case 271:{let i=n;Zbe(i)&&t(i,i.moduleReference.expression);break}}})}function gJe(e,t,n,i){return i?s():s()||o();function s(){var d;let{parent:S}=e,E=S.parent;if(t.exportSymbol)return S.kind===211?(d=t.declarations)!=null&&d.some(w=>w===S)&&Pn(E)?D(E,!1):void 0:u(t.exportSymbol,m(S));{let w=IOt(S,e);if(w&&li(w,32))return ru(w)&&w.moduleReference===e?i?void 0:{kind:0,symbol:n.getSymbolAtLocation(w.name)}:u(t,m(w));if(zh(S))return u(t,0);if(dc(S))return x(S);if(dc(E))return x(E);if(Pn(S))return D(S,!0);if(Pn(E))return D(E,!0);if(p2(S)||aY(S))return u(t,0)}function x(w){if(!w.symbol.parent)return;let R=w.isExportEquals?2:1;return{kind:1,symbol:t,exportInfo:{exportingModuleSymbol:w.symbol.parent,exportKind:R}}}function D(w,R){let L;switch(cl(w)){case 1:L=0;break;case 2:L=2;break;default:return}let F=R?n.getSymbolAtLocation(_G(aa(w.left,oc))):t;return F&&u(F,L)}}function o(){if(!OOt(e))return;let S=n.getImmediateAliasedSymbol(t);if(!S||(S=ROt(S,n),S.escapedName==="export="&&(S=wOt(S,n),S===void 0)))return;let E=UU(S);if(E===void 0||E==="default"||E===t.escapedName)return{kind:0,symbol:S}}function u(d,S){let E=Qbe(d,S,n);return E&&{kind:1,symbol:d,exportInfo:E}}function m(d){return li(d,2048)?1:0}}function wOt(e,t){var n,i;if(e.flags&2097152)return t.getImmediateAliasedSymbol(e);let s=M.checkDefined(e.valueDeclaration);if(dc(s))return(n=ai(s.expression,Zm))==null?void 0:n.symbol;if(Pn(s))return(i=ai(s.right,Zm))==null?void 0:i.symbol;if(Ji(s))return s.symbol}function IOt(e,t){let n=Ei(e)?e:Xa(e)?IP(e):void 0;return n?e.name!==t||bE(n.parent)?void 0:_l(n.parent.parent)?n.parent.parent:void 0:e}function OOt(e){let{parent:t}=e;switch(t.kind){case 271:return t.name===e&&Zbe(t);case 276:return!t.propertyName;case 273:case 274:return M.assert(t.name===e),!0;case 208:return hn(e)&&ZT(t.parent.parent);default:return!1}}function Qbe(e,t,n){let i=e.parent;if(!i)return;let s=n.getMergedSymbol(i);return BP(s)?{exportingModuleSymbol:s,exportKind:t}:void 0}function ROt(e,t){if(e.declarations)for(let n of e.declarations){if(b_(n)&&!n.propertyName&&!n.parent.parent.moduleSpecifier)return t.getExportSpecifierLocalTargetSymbol(n)||e;if(Wn(n)&&Py(n.expression)&&!Zi(n.name))return t.getSymbolAtLocation(n);if(p_(n)&&Pn(n.parent.parent)&&cl(n.parent.parent)===2)return t.getExportSpecifierLocalTargetSymbol(n.name)}return e}function MOt(e,t){return t.getMergedSymbol(VV(e).symbol)}function VV(e){if(e.kind===213||e.kind===351)return e.getSourceFile();let{parent:t}=e;return t.kind===307?t:(M.assert(t.kind===268),aa(t.parent,Mee))}function Mee(e){return e.kind===267&&e.name.kind===11}function Zbe(e){return e.moduleReference.kind===283&&e.moduleReference.expression.kind===11}var hJe=(e=>(e[e.Symbol=0]="Symbol",e[e.Label=1]="Label",e[e.Keyword=2]="Keyword",e[e.This=3]="This",e[e.String=4]="String",e[e.TripleSlashReference=5]="TripleSlashReference",e))(hJe||{}),yJe=(e=>(e[e.Span=0]="Span",e[e.Node=1]="Node",e[e.StringLiteral=2]="StringLiteral",e[e.SearchedLocalFoundProperty=3]="SearchedLocalFoundProperty",e[e.SearchedPropertyFoundLocal=4]="SearchedPropertyFoundLocal",e))(yJe||{});function Uy(e,t=1){return{kind:t,node:e.name||e,context:LOt(e)}}function eTe(e){return e&&e.kind===void 0}function LOt(e){if(u_(e))return C2(e);if(e.parent){if(!u_(e.parent)&&!dc(e.parent)){if(hn(e)){let n=Pn(e.parent)?e.parent:oc(e.parent)&&Pn(e.parent.parent)&&e.parent.parent.left===e.parent?e.parent.parent:void 0;if(n&&cl(n)!==0)return C2(n)}if(Yg(e.parent)||yE(e.parent))return e.parent.parent;if(u2(e.parent)||rS(e.parent)||gI(e.parent))return e.parent;if(No(e)){let n=bR(e);if(n){let i=Pr(n,s=>u_(s)||Vi(s)||jP(s));return u_(i)?C2(i):i}}let t=Pr(e,za);return t?C2(t.parent):void 0}if(e.parent.name===e||Vc(e.parent)||dc(e.parent)||(GC(e.parent)||Xa(e.parent))&&e.parent.propertyName===e||e.kind===90&&li(e.parent,2080))return C2(e.parent)}}function C2(e){if(e)switch(e.kind){case 260:return!Ru(e.parent)||e.parent.declarations.length!==1?e:_l(e.parent.parent)?e.parent.parent:$x(e.parent.parent)?C2(e.parent.parent):e.parent;case 208:return C2(e.parent.parent);case 276:return e.parent.parent.parent;case 281:case 274:return e.parent.parent;case 273:case 280:return e.parent;case 226:return Du(e.parent)?e.parent:e;case 250:case 249:return{start:e.initializer,end:e.expression};case 303:case 304:return Uv(e.parent)?C2(Pr(e.parent,t=>Pn(t)||$x(t))):e;case 255:return{start:Ln(e.getChildren(e.getSourceFile()),t=>t.kind===109),end:e.caseBlock};default:return e}}function tTe(e,t,n){if(!n)return;let i=eTe(n)?qV(n.start,t,n.end):qV(n,t);return i.start!==e.start||i.length!==e.length?{contextSpan:i}:void 0}var vJe=(e=>(e[e.Other=0]="Other",e[e.References=1]="References",e[e.Rename=2]="Rename",e))(vJe||{});function FOt(e,t,n,i,s){let o=wf(i,s),u={use:1},m=hk.getReferencedSymbolsForNode(s,o,e,n,t,u),d=e.getTypeChecker(),S=hk.getAdjustedNode(o,u),E=jOt(S)?d.getSymbolAtLocation(S):void 0;return!m||!m.length?void 0:Gi(m,({definition:x,references:D})=>x&&{definition:d.runWithCancellationToken(t,w=>VOt(x,w,o)),references:D.map(w=>qOt(w,E))})}function jOt(e){return e.kind===90||!!jI(e)||kR(e)||e.kind===137&&Vc(e.parent)}function BOt(e,t,n,i,s){let o=wf(i,s),u,m=SJe(e,t,n,o,s);if(o.parent.kind===211||o.parent.kind===208||o.parent.kind===212||o.kind===108)u=m&&[...m];else if(m){let S=p3(m),E=new Map;for(;!S.isEmpty();){let x=S.dequeue();if(!em(E,yo(x.node)))continue;u=Bt(u,x);let D=SJe(e,t,n,x.node,x.node.pos);D&&S.enqueue(...D)}}let d=e.getTypeChecker();return Cr(u,S=>WOt(S,d))}function SJe(e,t,n,i,s){if(i.kind===307)return;let o=e.getTypeChecker();if(i.parent.kind===304){let u=[];return hk.getReferenceEntriesForShorthandPropertyAssignment(i,o,m=>u.push(Uy(m))),u}else if(i.kind===108||Cf(i.parent)){let u=o.getSymbolAtLocation(i);return u.valueDeclaration&&[Uy(u.valueDeclaration)]}else return bJe(s,i,e,n,t,{implementations:!0,use:1})}function UOt(e,t,n,i,s,o,u){return Cr(TJe(hk.getReferencedSymbolsForNode(s,i,e,n,t,o)),m=>u(m,i,e.getTypeChecker()))}function bJe(e,t,n,i,s,o={},u=new Set(i.map(m=>m.fileName))){return TJe(hk.getReferencedSymbolsForNode(e,t,n,i,s,o,u))}function TJe(e){return e&&va(e,t=>t.references)}function VOt(e,t,n){let i=(()=>{switch(e.type){case 0:{let{symbol:E}=e,{displayParts:x,kind:D}=EJe(E,t,n),w=x.map(F=>F.text).join(""),R=E.declarations&&xo(E.declarations),L=R?Ps(R)||R:n;return{...JV(L),name:w,kind:D,displayParts:x,context:C2(R)}}case 1:{let{node:E}=e;return{...JV(E),name:E.text,kind:"label",displayParts:[Jf(E.text,17)]}}case 2:{let{node:E}=e,x=Sa(E.kind);return{...JV(E),name:x,kind:"keyword",displayParts:[{text:x,kind:"keyword"}]}}case 3:{let{node:E}=e,x=t.getSymbolAtLocation(E),D=x&&zv.getSymbolDisplayPartsDocumentationAndSymbolKind(t,x,E.getSourceFile(),b2(E),E).displayParts||[td("this")];return{...JV(E),name:"this",kind:"var",displayParts:D}}case 4:{let{node:E}=e;return{...JV(E),name:E.text,kind:"var",displayParts:[Jf(Hc(E),8)]}}case 5:return{textSpan:lS(e.reference),sourceFile:e.file,name:e.reference.fileName,kind:"string",displayParts:[Jf(`"${e.reference.fileName}"`,8)]};default:return M.assertNever(e)}})(),{sourceFile:s,textSpan:o,name:u,kind:m,displayParts:d,context:S}=i;return{containerKind:"",containerName:"",fileName:s.fileName,kind:m,name:u,textSpan:o,displayParts:d,...tTe(o,s,S)}}function JV(e){let t=e.getSourceFile();return{sourceFile:t,textSpan:qV(za(e)?e.expression:e,t)}}function EJe(e,t,n){let i=hk.getIntersectingMeaningFromDeclarations(n,e),s=e.declarations&&xo(e.declarations)||n,{displayParts:o,symbolKind:u}=zv.getSymbolDisplayPartsDocumentationAndSymbolKind(t,e,s.getSourceFile(),s,s,i);return{displayParts:o,kind:u}}function JOt(e,t,n,i,s){return{...Lee(e),...i&&zOt(e,t,n,s)}}function qOt(e,t){let n=xJe(e);return t?{...n,isDefinition:e.kind!==0&&CJe(e.node,t)}:n}function xJe(e){let t=Lee(e);if(e.kind===0)return{...t,isWriteAccess:!1};let{kind:n,node:i}=e;return{...t,isWriteAccess:nTe(i),isInString:n===2?!0:void 0}}function Lee(e){if(e.kind===0)return{textSpan:e.textSpan,fileName:e.fileName};{let t=e.node.getSourceFile(),n=qV(e.node,t);return{textSpan:n,fileName:t.fileName,...tTe(n,t,e.context)}}}function zOt(e,t,n,i){if(e.kind!==0&&(He(t)||No(t))){let{node:s,kind:o}=e,u=s.parent,m=t.text,d=p_(u);if(d||hM(u)&&u.name===s&&u.dotDotDotToken===void 0){let S={prefixText:m+": "},E={suffixText:": "+m};if(o===3)return S;if(o===4)return E;if(d){let x=u.parent;return Ca(x)&&Pn(x.parent)&&Py(x.parent.left)?S:E}else return S}else if(_f(u)&&!u.propertyName){let S=b_(t.parent)?n.getExportSpecifierLocalTargetSymbol(t.parent):n.getSymbolAtLocation(t);return Es(S.declarations,u)?{prefixText:m+" as "}:am}else if(b_(u)&&!u.propertyName)return t===e.node||n.getSymbolAtLocation(t)===n.getSymbolAtLocation(e.node)?{prefixText:m+" as "}:{suffixText:" as "+m}}if(e.kind!==0&&Pf(e.node)&&oc(e.node.parent)){let s=DQ(i);return{prefixText:s,suffixText:s}}return am}function WOt(e,t){let n=Lee(e);if(e.kind!==0){let{node:i}=e;return{...n,...$Ot(i,t)}}else return{...n,kind:"",displayParts:[]}}function $Ot(e,t){let n=t.getSymbolAtLocation(u_(e)&&e.name?e.name:e);return n?EJe(n,t,e):e.kind===210?{kind:"interface",displayParts:[C_(21),td("object literal"),C_(22)]}:e.kind===231?{kind:"local class",displayParts:[C_(21),td("anonymous local class"),C_(22)]}:{kind:PE(e),displayParts:[]}}function HOt(e){let t=Lee(e);if(e.kind===0)return{fileName:t.fileName,span:{textSpan:t.textSpan,kind:"reference"}};let n=nTe(e.node),i={textSpan:t.textSpan,kind:n?"writtenReference":"reference",isInString:e.kind===2?!0:void 0,...t.contextSpan&&{contextSpan:t.contextSpan}};return{fileName:t.fileName,span:i}}function qV(e,t,n){let i=e.getStart(t),s=(n||e).getEnd();return No(e)&&s-i>2&&(M.assert(n===void 0),i+=1,s-=1),n?.kind===269&&(s=n.getFullStart()),Il(i,s)}function rTe(e){return e.kind===0?e.textSpan:qV(e.node,e.node.getSourceFile())}function nTe(e){let t=jI(e);return!!t&&GOt(t)||e.kind===90||mA(e)}function CJe(e,t){var n;if(!t)return!1;let i=jI(e)||(e.kind===90?e.parent:kR(e)||e.kind===137&&Vc(e.parent)?e.parent.parent:void 0),s=i&&Pn(i)?i.left:void 0;return!!(i&&((n=t.declarations)!=null&&n.some(o=>o===i||o===s)))}function GOt(e){if(e.flags&33554432)return!0;switch(e.kind){case 226:case 208:case 263:case 231:case 90:case 266:case 306:case 281:case 273:case 271:case 276:case 264:case 338:case 346:case 291:case 267:case 270:case 274:case 280:case 169:case 304:case 265:case 168:return!0;case 303:return!Uv(e.parent);case 262:case 218:case 176:case 174:case 177:case 178:return!!e.body;case 260:case 172:return!!e.initializer||bE(e.parent);case 173:case 171:case 348:case 341:return!1;default:return M.failBadSyntaxKind(e)}}var hk;(e=>{function t(lt,St,fe,vt,Ce,nt={},Me=new Set(vt.map(tt=>tt.fileName))){var tt,ft;if(St=n(St,nt),Ji(St)){let nr=oD.getReferenceAtPosition(St,lt,fe);if(!nr?.file)return;let Z=fe.getTypeChecker().getMergedSymbol(nr.file.symbol);if(Z)return S(fe,Z,!1,vt,Me);let Ge=fe.getFileIncludeReasons();return Ge?[{definition:{type:5,reference:nr.reference,file:St},references:s(nr.file,Ge,fe)||ve}]:void 0}if(!nt.implementations){let nr=x(St,vt,Ce);if(nr)return nr}let tr=fe.getTypeChecker(),Oe=tr.getSymbolAtLocation(Vc(St)&&St.parent.name||St);if(!Oe){if(!nt.implementations&&No(St)){if(VU(St)){let nr=fe.getFileIncludeReasons(),Z=(ft=(tt=fe.getResolvedModuleFromModuleSpecifier(St))==null?void 0:tt.resolvedModule)==null?void 0:ft.resolvedFileName,Ge=Z?fe.getSourceFile(Z):void 0;if(Ge)return[{definition:{type:4,node:St},references:s(Ge,nr,fe)||ve}]}return Ii(St,vt,tr,Ce)}return}if(Oe.escapedName==="export=")return S(fe,Oe.parent,!1,vt,Me);let At=u(Oe,fe,vt,Ce,nt,Me);if(At&&!(Oe.flags&33554432))return At;let Nt=o(St,Oe,tr),Ut=Nt&&u(Nt,fe,vt,Ce,nt,Me),Rt=D(Oe,St,vt,Me,tr,Ce,nt);return m(fe,At,Rt,Ut)}e.getReferencedSymbolsForNode=t;function n(lt,St){return St.use===1?lt=dQ(lt):St.use===2&&(lt=DU(lt)),lt}e.getAdjustedNode=n;function i(lt,St,fe,vt=new Set(fe.map(Ce=>Ce.fileName))){var Ce,nt;let Me=(Ce=St.getSourceFile(lt))==null?void 0:Ce.symbol;if(Me)return((nt=S(St,Me,!1,fe,vt)[0])==null?void 0:nt.references)||ve;let tt=St.getFileIncludeReasons(),ft=St.getSourceFile(lt);return ft&&tt&&s(ft,tt,St)||ve}e.getReferencesForFileName=i;function s(lt,St,fe){let vt,Ce=St.get(lt.path)||ve;for(let nt of Ce)if(Ib(nt)){let Me=fe.getSourceFileByPath(nt.file),tt=c6(fe,nt);UN(tt)&&(vt=Bt(vt,{kind:0,fileName:Me.fileName,textSpan:lS(tt)}))}return vt}function o(lt,St,fe){if(lt.parent&&p8(lt.parent)){let vt=fe.getAliasedSymbol(St),Ce=fe.getMergedSymbol(vt);if(vt!==Ce)return Ce}}function u(lt,St,fe,vt,Ce,nt){let Me=lt.flags&1536&&lt.declarations&&Ln(lt.declarations,Ji);if(!Me)return;let tt=lt.exports.get("export="),ft=S(St,lt,!!tt,fe,nt);if(!tt||!nt.has(Me.fileName))return ft;let tr=St.getTypeChecker();return lt=$u(tt,tr),m(St,ft,D(lt,void 0,fe,nt,tr,vt,Ce))}function m(lt,...St){let fe;for(let vt of St)if(!(!vt||!vt.length)){if(!fe){fe=vt;continue}for(let Ce of vt){if(!Ce.definition||Ce.definition.type!==0){fe.push(Ce);continue}let nt=Ce.definition.symbol,Me=Bo(fe,ft=>!!ft.definition&&ft.definition.type===0&&ft.definition.symbol===nt);if(Me===-1){fe.push(Ce);continue}let tt=fe[Me];fe[Me]={definition:tt.definition,references:tt.references.concat(Ce.references).sort((ft,tr)=>{let Oe=d(lt,ft),At=d(lt,tr);if(Oe!==At)return tc(Oe,At);let Nt=rTe(ft),Ut=rTe(tr);return Nt.start!==Ut.start?tc(Nt.start,Ut.start):tc(Nt.length,Ut.length)})}}}return fe}function d(lt,St){let fe=St.kind===0?lt.getSourceFile(St.fileName):St.node.getSourceFile();return lt.getSourceFiles().indexOf(fe)}function S(lt,St,fe,vt,Ce){M.assert(!!St.valueDeclaration);let nt=Gi(pJe(lt,vt,St),tt=>{if(tt.kind==="import"){let ft=tt.literal.parent;if(Mv(ft)){let tr=aa(ft.parent,qh);if(fe&&!tr.qualifier)return}return Uy(tt.literal)}else if(tt.kind==="implicit"){let ft=tt.literal.text!==ab&&$A(tt.referencingFile,tr=>tr.transformFlags&2?Ly(tr)||u2(tr)||vE(tr)?tr:void 0:"skip")||tt.referencingFile.statements[0]||tt.referencingFile;return Uy(ft)}else return{kind:0,fileName:tt.referencingFile.fileName,textSpan:lS(tt.ref)}});if(St.declarations)for(let tt of St.declarations)switch(tt.kind){case 307:break;case 267:Ce.has(tt.getSourceFile().fileName)&&nt.push(Uy(tt.name));break;default:M.assert(!!(St.flags&33554432),"Expected a module symbol to be declared by a SourceFile or ModuleDeclaration.")}let Me=St.exports.get("export=");if(Me?.declarations)for(let tt of Me.declarations){let ft=tt.getSourceFile();if(Ce.has(ft.fileName)){let tr=Pn(tt)&&Wn(tt.left)?tt.left.expression:dc(tt)?M.checkDefined(Oo(tt,95,ft)):Ps(tt)||tt;nt.push(Uy(tr))}}return nt.length?[{definition:{type:0,symbol:St},references:nt}]:ve}function E(lt){return lt.kind===148&&yb(lt.parent)&&lt.parent.operator===148}function x(lt,St,fe){if(g6(lt.kind))return lt.kind===116&&BA(lt.parent)||lt.kind===148&&!E(lt)?void 0:be(St,lt.kind,fe,lt.kind===148?E:void 0);if(WP(lt.parent)&&lt.parent.name===lt)return he(St,fe);if(RA(lt)&&Gc(lt.parent))return[{definition:{type:2,node:lt},references:[Uy(lt)]}];if(oM(lt)){let vt=xU(lt.parent,lt.text);return vt&&xe(vt.parent,vt)}else if(sQ(lt))return xe(lt.parent,lt);if($N(lt))return ss(lt,St,fe);if(lt.kind===108)return Pi(lt)}function D(lt,St,fe,vt,Ce,nt,Me){let tt=St&&L(lt,St,Ce,!to(Me))||lt,ft=St?vi(St,tt):7,tr=[],Oe=new G(fe,vt,St?R(St):0,Ce,nt,ft,Me,tr),At=!to(Me)||!tt.declarations?void 0:Ln(tt.declarations,b_);if(At)ct(At.name,tt,At,Oe.createSearch(St,lt,void 0),Oe,!0,!0);else if(St&&St.kind===90&&tt.escapedName==="default"&&tt.parent)mt(St,tt,Oe),q(St,tt,{exportingModuleSymbol:tt.parent,exportKind:1},Oe);else{let Nt=Oe.createSearch(St,tt,void 0,{allSearchSymbols:St?Xs(tt,St,Ce,Me.use===2,!!Me.providePrefixAndSuffixTextForRename,!!Me.implementations):[tt]});w(tt,Oe,Nt)}return tr}function w(lt,St,fe){let vt=ue(lt);if(vt)Pe(vt,vt.getSourceFile(),fe,St,!(Ji(vt)&&!Es(St.sourceFiles,vt)));else for(let Ce of St.sourceFiles)St.cancellationToken.throwIfCancellationRequested(),K(Ce,fe,St)}function R(lt){switch(lt.kind){case 176:case 137:return 1;case 80:if(gi(lt.parent))return M.assert(lt.parent.name===lt),2;default:return 0}}function L(lt,St,fe,vt){let{parent:Ce}=St;return b_(Ce)&&vt?qe(St,lt,Ce,fe):yi(lt.declarations,nt=>{if(!nt.parent){if(lt.flags&33554432)return;M.fail(`Unexpected symbol at ${M.formatSyntaxKind(St.kind)}: ${M.formatSymbol(lt)}`)}return lf(nt.parent)&&Z1(nt.parent.parent)?fe.getPropertyOfType(fe.getTypeFromTypeNode(nt.parent.parent),lt.name):void 0})}let F;(lt=>{lt[lt.None=0]="None",lt[lt.Constructor=1]="Constructor",lt[lt.Class=2]="Class"})(F||(F={}));function J(lt){if(!(lt.flags&33555968))return;let St=lt.declarations&&Ln(lt.declarations,fe=>!Ji(fe)&&!El(fe));return St&&St.symbol}class G{constructor(St,fe,vt,Ce,nt,Me,tt,ft){this.sourceFiles=St,this.sourceFilesSet=fe,this.specialSearchKind=vt,this.checker=Ce,this.cancellationToken=nt,this.searchMeaning=Me,this.options=tt,this.result=ft,this.inheritsFromCache=new Map,this.markSeenContainingTypeReference=GN(),this.markSeenReExportRHS=GN(),this.symbolIdToReferences=[],this.sourceFileToSeenSymbols=[]}includesSourceFile(St){return this.sourceFilesSet.has(St.fileName)}getImportSearches(St,fe){return this.importTracker||(this.importTracker=Xbe(this.sourceFiles,this.sourceFilesSet,this.checker,this.cancellationToken)),this.importTracker(St,fe,this.options.use===2)}createSearch(St,fe,vt,Ce={}){let{text:nt=Zd(Qc(KI(fe)||J(fe)||fe)),allSearchSymbols:Me=[fe]}=Ce,tt=Uc(nt),ft=this.options.implementations&&St?yr(St,fe,this.checker):void 0;return{symbol:fe,comingFrom:vt,text:nt,escapedText:tt,parents:ft,allSearchSymbols:Me,includes:tr=>Es(Me,tr)}}referenceAdder(St){let fe=Aa(St),vt=this.symbolIdToReferences[fe];return vt||(vt=this.symbolIdToReferences[fe]=[],this.result.push({definition:{type:0,symbol:St},references:vt})),(Ce,nt)=>vt.push(Uy(Ce,nt))}addStringOrCommentReference(St,fe){this.result.push({definition:void 0,references:[{kind:0,fileName:St,textSpan:fe}]})}markSearchedSymbols(St,fe){let vt=yo(St),Ce=this.sourceFileToSeenSymbols[vt]||(this.sourceFileToSeenSymbols[vt]=new Set),nt=!1;for(let Me of fe)nt=Pg(Ce,Aa(Me))||nt;return nt}}function q(lt,St,fe,vt){let{importSearches:Ce,singleReferences:nt,indirectUsers:Me}=vt.getImportSearches(St,fe);if(nt.length){let tt=vt.referenceAdder(St);for(let ft of nt)W(ft,vt)&&tt(ft)}for(let[tt,ft]of Ce)Ve(tt.getSourceFile(),vt.createSearch(tt,ft,1),vt);if(Me.length){let tt;switch(fe.exportKind){case 0:tt=vt.createSearch(lt,St,1);break;case 1:tt=vt.options.use===2?void 0:vt.createSearch(lt,St,1,{text:"default"});break;case 2:break}if(tt)for(let ft of Me)K(ft,tt,vt)}}function ee(lt,St,fe,vt,Ce,nt,Me,tt){let ft=Xbe(lt,new Set(lt.map(Nt=>Nt.fileName)),St,fe),{importSearches:tr,indirectUsers:Oe,singleReferences:At}=ft(vt,{exportKind:Me?1:0,exportingModuleSymbol:Ce},!1);for(let[Nt]of tr)tt(Nt);for(let Nt of At)He(Nt)&&qh(Nt.parent)&&tt(Nt);for(let Nt of Oe)for(let Ut of de(Nt,Me?"default":nt)){let Rt=St.getSymbolAtLocation(Ut),nr=Pt(Rt?.declarations,Z=>!!ai(Z,dc));He(Ut)&&!GC(Ut.parent)&&(Rt===vt||nr)&&tt(Ut)}}e.eachExportReference=ee;function W(lt,St){return ke(lt,St)?St.options.use!==2?!0:He(lt)?!(GC(lt.parent)&&lt.escapedText==="default"):!1:!1}function pe(lt,St){if(lt.declarations)for(let fe of lt.declarations){let vt=fe.getSourceFile();Ve(vt,St.createSearch(fe,lt,0),St,St.includesSourceFile(vt))}}function K(lt,St,fe){$Z(lt).get(St.escapedText)!==void 0&&Ve(lt,St,fe)}function re(lt,St){return Uv(lt.parent.parent)?St.getPropertySymbolOfDestructuringAssignment(lt):void 0}function ue(lt){let{declarations:St,flags:fe,parent:vt,valueDeclaration:Ce}=lt;if(Ce&&(Ce.kind===218||Ce.kind===231))return Ce;if(!St)return;if(fe&8196){let tt=Ln(St,ft=>up(ft,2)||j_(ft));return tt?pb(tt,263):void 0}if(St.some(hM))return;let nt=vt&&!(lt.flags&262144);if(nt&&!(BP(vt)&&!vt.globalExports))return;let Me;for(let tt of St){let ft=b2(tt);if(Me&&Me!==ft||!ft||ft.kind===307&&!Uf(ft))return;if(Me=ft,ic(Me)){let tr;for(;tr=AH(Me);)Me=tr}}return nt?Me.getSourceFile():Me}function ce(lt,St,fe,vt=fe){return ne(lt,St,fe,()=>!0,vt)||!1}e.isSymbolReferencedInFile=ce;function ne(lt,St,fe,vt,Ce=fe){let nt=ap(lt.parent,lt.parent.parent)?Ma(St.getSymbolsOfParameterPropertyDeclaration(lt.parent,lt.text)):St.getSymbolAtLocation(lt);if(nt)for(let Me of de(fe,nt.name,Ce)){if(!He(Me)||Me===lt||Me.escapedText!==lt.escapedText)continue;let tt=St.getSymbolAtLocation(Me);if(tt===nt||St.getShorthandAssignmentValueSymbol(Me.parent)===nt||b_(Me.parent)&&qe(Me,tt,Me.parent,St)===nt){let ft=vt(Me);if(ft)return ft}}}e.eachSymbolReferenceInFile=ne;function le(lt,St){return Zn(de(St,lt),Ce=>!!jI(Ce)).reduce((Ce,nt)=>{let Me=vt(nt);return!Pt(Ce.declarationNames)||Me===Ce.depth?(Ce.declarationNames.push(nt),Ce.depth=Me):Me<Ce.depth&&(Ce.declarationNames=[nt],Ce.depth=Me),Ce},{depth:1/0,declarationNames:[]}).declarationNames;function vt(Ce){let nt=0;for(;Ce;)Ce=b2(Ce),nt++;return nt}}e.getTopMostDeclarationNamesInFile=le;function me(lt,St,fe,vt){if(!lt.name||!He(lt.name))return!1;let Ce=M.checkDefined(fe.getSymbolAtLocation(lt.name));for(let nt of St)for(let Me of de(nt,Ce.name)){if(!He(Me)||Me===lt.name||Me.escapedText!==lt.name.escapedText)continue;let tt=EU(Me),ft=ea(tt.parent)&&tt.parent.expression===tt?tt.parent:void 0,tr=fe.getSymbolAtLocation(Me);if(tr&&fe.getRootSymbols(tr).some(Oe=>Oe===Ce)&&vt(Me,ft))return!0}return!1}e.someSignatureUsage=me;function de(lt,St,fe=lt){return Gi(Ae(lt,St,fe),vt=>{let Ce=wf(lt,vt);return Ce===lt?void 0:Ce})}function Ae(lt,St,fe=lt){let vt=[];if(!St||!St.length)return vt;let Ce=lt.text,nt=Ce.length,Me=St.length,tt=Ce.indexOf(St,fe.pos);for(;tt>=0&&!(tt>fe.end);){let ft=tt+Me;(tt===0||!yv(Ce.charCodeAt(tt-1),99))&&(ft===nt||!yv(Ce.charCodeAt(ft),99))&&vt.push(tt),tt=Ce.indexOf(St,tt+Me+1)}return vt}function xe(lt,St){let fe=lt.getSourceFile(),vt=St.text,Ce=Gi(de(fe,vt,lt),nt=>nt===St||oM(nt)&&xU(nt,vt)===St?Uy(nt):void 0);return[{definition:{type:1,node:St},references:Ce}]}function te(lt,St){switch(lt.kind){case 81:if(Eb(lt.parent))return!0;case 80:return lt.text.length===St.length;case 15:case 11:{let fe=lt;return(CU(fe)||lQ(lt)||h0e(lt)||ea(lt.parent)&&Qx(lt.parent)&&lt.parent.arguments[1]===lt)&&fe.text.length===St.length}case 9:return CU(lt)&&lt.text.length===St.length;case 90:return St.length===7;default:return!1}}function he(lt,St){let fe=va(lt,vt=>(St.throwIfCancellationRequested(),Gi(de(vt,"meta",vt),Ce=>{let nt=Ce.parent;if(WP(nt))return Uy(nt)})));return fe.length?[{definition:{type:2,node:fe[0].node},references:fe}]:void 0}function be(lt,St,fe,vt){let Ce=va(lt,nt=>(fe.throwIfCancellationRequested(),Gi(de(nt,Sa(St),nt),Me=>{if(Me.kind===St&&(!vt||vt(Me)))return Uy(Me)})));return Ce.length?[{definition:{type:2,node:Ce[0].node},references:Ce}]:void 0}function Ve(lt,St,fe,vt=!0){return fe.cancellationToken.throwIfCancellationRequested(),Pe(lt,lt,St,fe,vt)}function Pe(lt,St,fe,vt,Ce){if(vt.markSearchedSymbols(St,fe.allSearchSymbols))for(let nt of Ae(St,fe.text,lt))De(St,nt,fe,vt,Ce)}function ke(lt,St){return!!(S2(lt)&St.searchMeaning)}function De(lt,St,fe,vt,Ce){let nt=wf(lt,St);if(!te(nt,fe.text)){!vt.options.implementations&&(vt.options.findInStrings&&ik(lt,St)||vt.options.findInComments&&w0e(lt,St))&&vt.addStringOrCommentReference(lt.fileName,zu(St,fe.text.length));return}if(!ke(nt,vt))return;let Me=vt.checker.getSymbolAtLocation(nt);if(!Me)return;let tt=nt.parent;if(_f(tt)&&tt.propertyName===nt)return;if(b_(tt)){M.assert(nt.kind===80),ct(nt,Me,tt,fe,vt,Ce);return}if(hI(tt)&&tt.isNameFirst&&tt.typeExpression&&f2(tt.typeExpression.type)&&tt.typeExpression.type.jsDocPropertyTags&&wt(tt.typeExpression.type.jsDocPropertyTags)){Be(tt.typeExpression.type.jsDocPropertyTags,nt,fe,vt);return}let ft=An(fe,Me,nt,vt);if(!ft){_t(Me,fe,vt);return}switch(vt.specialSearchKind){case 0:Ce&&mt(nt,ft,vt);break;case 1:Xe(nt,lt,fe,vt);break;case 2:ht(nt,fe,vt);break;default:M.assertNever(vt.specialSearchKind)}hn(nt)&&Xa(nt.parent)&&ZT(nt.parent.parent.parent)&&(Me=nt.parent.symbol,!Me)||Ie(nt,Me,fe,vt)}function Be(lt,St,fe,vt){let Ce=vt.referenceAdder(fe.symbol);mt(St,fe.symbol,vt),kt(lt,nt=>{cf(nt.name)&&Ce(nt.name.left)})}function ct(lt,St,fe,vt,Ce,nt,Me){M.assert(!Me||!!Ce.options.providePrefixAndSuffixTextForRename,"If alwaysGetReferences is true, then prefix/suffix text must be enabled");let{parent:tt,propertyName:ft,name:tr}=fe,Oe=tt.parent,At=qe(lt,St,fe,Ce.checker);if(!Me&&!vt.includes(At))return;if(ft?lt===ft?(Oe.moduleSpecifier||Nt(),nt&&Ce.options.use!==2&&Ce.markSeenReExportRHS(tr)&&mt(tr,M.checkDefined(fe.symbol),Ce)):Ce.markSeenReExportRHS(lt)&&Nt():Ce.options.use===2&&tr.escapedText==="default"||Nt(),!to(Ce.options)||Me){let Rt=lt.escapedText==="default"||fe.name.escapedText==="default"?1:0,nr=M.checkDefined(fe.symbol),Z=Qbe(nr,Rt,Ce.checker);Z&&q(lt,nr,Z,Ce)}if(vt.comingFrom!==1&&Oe.moduleSpecifier&&!ft&&!to(Ce.options)){let Ut=Ce.checker.getExportSpecifierLocalTargetSymbol(fe);Ut&&pe(Ut,Ce)}function Nt(){nt&&mt(lt,At,Ce)}}function qe(lt,St,fe,vt){return et(lt,fe)&&vt.getExportSpecifierLocalTargetSymbol(fe)||St}function et(lt,St){let{parent:fe,propertyName:vt,name:Ce}=St;return M.assert(vt===lt||Ce===lt),vt?vt===lt:!fe.parent.moduleSpecifier}function Ie(lt,St,fe,vt){let Ce=gJe(lt,St,vt.checker,fe.comingFrom===1);if(!Ce)return;let{symbol:nt}=Ce;Ce.kind===0?to(vt.options)||pe(nt,vt):q(lt,nt,Ce.exportInfo,vt)}function _t({flags:lt,valueDeclaration:St},fe,vt){let Ce=vt.checker.getShorthandAssignmentValueSymbol(St),nt=St&&Ps(St);!(lt&33554432)&&nt&&fe.includes(Ce)&&mt(nt,Ce,vt)}function mt(lt,St,fe){let{kind:vt,symbol:Ce}="kind"in St?St:{kind:void 0,symbol:St};if(fe.options.use===2&&lt.kind===90)return;let nt=fe.referenceAdder(Ce);fe.options.implementations?or(lt,nt,fe):nt(lt,vt)}function Xe(lt,St,fe,vt){p6(lt)&&mt(lt,fe.symbol,vt);let Ce=()=>vt.referenceAdder(fe.symbol);if(gi(lt.parent))M.assert(lt.kind===90||lt.parent.name===lt),rr(fe.symbol,St,Ce());else{let nt=Gs(lt);nt&&(xr(nt,Ce()),ur(nt,vt))}}function ht(lt,St,fe){mt(lt,St.symbol,fe);let vt=lt.parent;if(fe.options.use===2||!gi(vt))return;M.assert(vt.name===lt);let Ce=fe.referenceAdder(St.symbol);for(let nt of vt.members)KC(nt)&&oa(nt)&&nt.body&&nt.body.forEachChild(function Me(tt){tt.kind===110?Ce(tt):!Bs(tt)&&!gi(tt)&&tt.forEachChild(Me)})}function rr(lt,St,fe){let vt=vr(lt);if(vt&&vt.declarations)for(let Ce of vt.declarations){let nt=Oo(Ce,137,St);M.assert(Ce.kind===176&&!!nt),fe(nt)}lt.exports&&lt.exports.forEach(Ce=>{let nt=Ce.valueDeclaration;if(nt&&nt.kind===174){let Me=nt.body;Me&&la(Me,110,tt=>{p6(tt)&&fe(tt)})}})}function vr(lt){return lt.members&&lt.members.get("__constructor")}function xr(lt,St){let fe=vr(lt.symbol);if(fe&&fe.declarations)for(let vt of fe.declarations){M.assert(vt.kind===176);let Ce=vt.body;Ce&&la(Ce,108,nt=>{rQ(nt)&&St(nt)})}}function jr(lt){return!!vr(lt.symbol)}function ur(lt,St){if(jr(lt))return;let fe=lt.symbol,vt=St.createSearch(void 0,fe,void 0);w(fe,St,vt)}function or(lt,St,fe){if(Uh(lt)&&Ci(lt.parent)){St(lt);return}if(lt.kind!==80)return;lt.parent.kind===304&&Ui(lt,fe.checker,St);let vt=Zr(lt);if(vt){St(vt);return}let Ce=Pr(lt,tt=>!cf(tt.parent)&&!Di(tt.parent)&&!$T(tt.parent)),nt=Ce.parent;if(F5(nt)&&nt.type===Ce&&fe.markSeenContainingTypeReference(nt))if(bv(nt))Me(nt.initializer);else if(Bs(nt)&&nt.body){let tt=nt.body;tt.kind===241?xv(tt,ft=>{ft.expression&&Me(ft.expression)}):Me(tt)}else sb(nt)&&Me(nt.expression);function Me(tt){Oi(tt)&&St(tt)}}function Zr(lt){return He(lt)||Wn(lt)?Zr(lt.parent):x0(lt)?ai(lt.parent.parent,Jp(gi,Yu)):void 0}function Oi(lt){switch(lt.kind){case 217:return Oi(lt.expression);case 219:case 218:case 210:case 231:case 209:return!0;default:return!1}}function Sr(lt,St,fe,vt){if(lt===St)return!0;let Ce=Aa(lt)+","+Aa(St),nt=fe.get(Ce);if(nt!==void 0)return nt;fe.set(Ce,!1);let Me=!!lt.declarations&&lt.declarations.some(tt=>BI(tt).some(ft=>{let tr=vt.getTypeAtLocation(ft);return!!tr&&!!tr.symbol&&Sr(tr.symbol,St,fe,vt)}));return fe.set(Ce,Me),Me}function Pi(lt){let St=sR(lt,!1);if(!St)return;let fe=256;switch(St.kind){case 172:case 171:case 174:case 173:case 176:case 177:case 178:fe&=Nv(St),St=St.parent;break;default:return}let vt=St.getSourceFile(),Ce=Gi(de(vt,"super",St),nt=>{if(nt.kind!==108)return;let Me=sR(nt,!1);return Me&&oa(Me)===!!fe&&Me.parent.symbol===St.symbol?Uy(nt):void 0});return[{definition:{type:0,symbol:St.symbol},references:Ce}]}function Cs(lt){return lt.kind===80&&lt.parent.kind===169&&lt.parent.name===lt}function ss(lt,St,fe){let vt=nf(lt,!1,!1),Ce=256;switch(vt.kind){case 174:case 173:if(Nm(vt)){Ce&=Nv(vt),vt=vt.parent;break}case 172:case 171:case 176:case 177:case 178:Ce&=Nv(vt),vt=vt.parent;break;case 307:if(nu(vt)||Cs(lt))return;case 262:case 218:break;default:return}let nt=va(vt.kind===307?St:[vt.getSourceFile()],tt=>(fe.throwIfCancellationRequested(),de(tt,"this",Ji(vt)?tt:vt).filter(ft=>{if(!$N(ft))return!1;let tr=nf(ft,!1,!1);if(!Zm(tr))return!1;switch(vt.kind){case 218:case 262:return vt.symbol===tr.symbol;case 174:case 173:return Nm(vt)&&vt.symbol===tr.symbol;case 231:case 263:case 210:return tr.parent&&Zm(tr.parent)&&vt.symbol===tr.parent.symbol&&oa(tr)===!!Ce;case 307:return tr.kind===307&&!nu(tr)&&!Cs(ft)}}))).map(tt=>Uy(tt));return[{definition:{type:3,node:yi(nt,tt=>ns(tt.node.parent)?tt.node:void 0)||lt},references:nt}]}function Ii(lt,St,fe,vt){let Ce=NU(lt,fe),nt=va(St,Me=>(vt.throwIfCancellationRequested(),Gi(de(Me,lt.text),tt=>{if(No(tt)&&tt.text===lt.text)if(Ce){let ft=NU(tt,fe);if(Ce!==fe.getStringType()&&(Ce===ft||$r(tt,fe)))return Uy(tt,2)}else return wA(tt)&&!n2(tt,Me)?void 0:Uy(tt,2)})));return[{definition:{type:4,node:lt},references:nt}]}function $r(lt,St){if(Nf(lt.parent))return St.getPropertyOfType(St.getTypeAtLocation(lt.parent.parent),lt.text)}function Xs(lt,St,fe,vt,Ce,nt){let Me=[];return $e(lt,St,fe,vt,!(vt&&Ce),(tt,ft,tr)=>{tr&&Vr(lt)!==Vr(tr)&&(tr=void 0),Me.push(tr||ft||tt)},()=>!nt),Me}function $e(lt,St,fe,vt,Ce,nt,Me){let tt=LM(St);if(tt){let Rt=fe.getShorthandAssignmentValueSymbol(St.parent);if(Rt&&vt)return nt(Rt,void 0,void 0,3);let nr=fe.getContextualType(tt.parent),Z=nr&&yi(PV(tt,fe,nr,!0),Ke=>Nt(Ke,4));if(Z)return Z;let Ge=re(St,fe),bt=Ge&&nt(Ge,void 0,void 0,4);if(bt)return bt;let Q=Rt&&nt(Rt,void 0,void 0,3);if(Q)return Q}let ft=o(St,lt,fe);if(ft){let Rt=nt(ft,void 0,void 0,1);if(Rt)return Rt}let tr=Nt(lt);if(tr)return tr;if(lt.valueDeclaration&&ap(lt.valueDeclaration,lt.valueDeclaration.parent)){let Rt=fe.getSymbolsOfParameterPropertyDeclaration(aa(lt.valueDeclaration,ns),lt.name);return M.assert(Rt.length===2&&!!(Rt[0].flags&1)&&!!(Rt[1].flags&4)),Nt(lt.flags&1?Rt[1]:Rt[0])}let Oe=Pc(lt,281);if(!vt||Oe&&!Oe.propertyName){let Rt=Oe&&fe.getExportSpecifierLocalTargetSymbol(Oe);if(Rt){let nr=nt(Rt,void 0,void 0,1);if(nr)return nr}}if(!vt){let Rt;return Ce?Rt=hM(St.parent)?JU(fe,St.parent):void 0:Rt=Ut(lt,fe),Rt&&Nt(Rt,4)}if(M.assert(vt),Ce){let Rt=Ut(lt,fe);return Rt&&Nt(Rt,4)}function Nt(Rt,nr){return yi(fe.getRootSymbols(Rt),Z=>nt(Rt,Z,void 0,nr)||(Z.parent&&Z.parent.flags&96&&Me(Z)?Yt(Z.parent,Z.name,fe,Ge=>nt(Rt,Z,Ge,nr)):void 0))}function Ut(Rt,nr){let Z=Pc(Rt,208);if(Z&&hM(Z))return JU(nr,Z)}}function Yt(lt,St,fe,vt){let Ce=new Map;return nt(lt);function nt(Me){if(!(!(Me.flags&96)||!em(Ce,Aa(Me))))return yi(Me.declarations,tt=>yi(BI(tt),ft=>{let tr=fe.getTypeAtLocation(ft),Oe=tr&&tr.symbol&&fe.getPropertyOfType(tr,St);return tr&&Oe&&(yi(fe.getRootSymbols(Oe),vt)||nt(tr.symbol))}))}}function Vr(lt){return lt.valueDeclaration?!!(U_(lt.valueDeclaration)&256):!1}function An(lt,St,fe,vt){let{checker:Ce}=vt;return $e(St,fe,Ce,!1,vt.options.use!==2||!!vt.options.providePrefixAndSuffixTextForRename,(nt,Me,tt,ft)=>(tt&&Vr(St)!==Vr(tt)&&(tt=void 0),lt.includes(tt||Me||nt)?{symbol:Me&&!(ll(nt)&6)?Me:nt,kind:ft}:void 0),nt=>!(lt.parents&&!lt.parents.some(Me=>Sr(nt.parent,Me,vt.inheritsFromCache,Ce))))}function vi(lt,St){let fe=S2(lt),{declarations:vt}=St;if(vt){let Ce;do{Ce=fe;for(let nt of vt){let Me=bU(nt);Me&fe&&(fe|=Me)}}while(fe!==Ce)}return fe}e.getIntersectingMeaningFromDeclarations=vi;function Ci(lt){return lt.flags&33554432?!(Yu(lt)||im(lt)):rA(lt)?bv(lt):Go(lt)?!!lt.body:gi(lt)||z3(lt)}function Ui(lt,St,fe){let vt=St.getSymbolAtLocation(lt),Ce=St.getShorthandAssignmentValueSymbol(vt.valueDeclaration);if(Ce)for(let nt of Ce.getDeclarations())bU(nt)&1&&fe(nt)}e.getReferenceEntriesForShorthandPropertyAssignment=Ui;function la(lt,St,fe){Js(lt,vt=>{vt.kind===St&&fe(vt),la(vt,St,fe)})}function Gs(lt){return ZH(EU(lt).parent)}function yr(lt,St,fe){let vt=WN(lt)?lt.parent:void 0,Ce=vt&&fe.getTypeAtLocation(vt.expression),nt=Gi(Ce&&(Ce.isUnionOrIntersection()?Ce.types:Ce.symbol===St.parent?void 0:[Ce]),Me=>Me.symbol&&Me.symbol.flags&96?Me.symbol:void 0);return nt.length===0?void 0:nt}function to(lt){return lt.use===2&&lt.providePrefixAndSuffixTextForRename}})(hk||(hk={}));var oD={};A(oD,{createDefinitionInfo:()=>$M,findReferenceInPosition:()=>F6,getDefinitionAndBoundSpan:()=>t6t,getDefinitionAtPosition:()=>AJe,getReferenceAtPosition:()=>PJe,getTypeDefinitionAtPosition:()=>ZOt});function AJe(e,t,n,i,s){var o;let u=PJe(t,n,e),m=u&&[a6t(u.reference.fileName,u.fileName,u.unverified)]||ve;if(u?.file)return m;let d=wf(t,n);if(d===t)return;let{parent:S}=d,E=e.getTypeChecker();if(d.kind===164||He(d)&&Uj(S)&&S.tagName===d)return KOt(E,d)||ve;if(oM(d)){let F=xU(d.parent,d.text);return F?[iTe(E,F,"label",d.text,void 0)]:void 0}switch(d.kind){case 107:let F=Pr(d.parent,G=>Gc(G)?"quit":Go(G));return F?[zV(E,F)]:void 0;case 90:if(!IO(d.parent))break;case 84:let J=Pr(d.parent,NO);if(J)return[s6t(J,t)];break}if(d.kind===135){let F=Pr(d,G=>Go(G));return F&&Pt(F.modifiers,G=>G.kind===134)?[zV(E,F)]:void 0}if(d.kind===127){let F=Pr(d,G=>Go(G));return F&&F.asteriskToken?[zV(E,F)]:void 0}if(RA(d)&&Gc(d.parent)){let F=d.parent.parent,{symbol:J,failedAliasResolution:G}=Fee(F,E,s),q=Zn(F.members,Gc),ee=J?E.symbolToString(J,F):"",W=d.getSourceFile();return Cr(q,pe=>{let{pos:K}=Jg(pe);return K=Ja(W.text,K),iTe(E,pe,"constructor","static {}",ee,!1,G,{start:K,length:6})})}let{symbol:x,failedAliasResolution:D}=Fee(d,E,s),w=d;if(i&&D){let F=kt([d,...x?.declarations||ve],G=>Pr(G,O_e)),J=F&&MI(F);J&&({symbol:x,failedAliasResolution:D}=Fee(J,E,s),w=J)}if(!x&&VU(w)){let F=(o=e.getResolvedModuleFromModuleSpecifier(w,t))==null?void 0:o.resolvedModule;if(F)return[{name:w.text,fileName:F.resolvedFileName,containerName:void 0,containerKind:void 0,kind:"script",textSpan:zu(0,0),failedAliasResolution:D,isAmbient:Mu(F.resolvedFileName),unverified:w!==d}]}if(!x)return ps(m,r6t(d,E));if(i&&wi(x.declarations,F=>F.getSourceFile().fileName===t.fileName))return;let R=c6t(E,d);if(R&&!(__(d.parent)&&l6t(R))){let F=zV(E,R,D);if(E.getRootSymbols(x).some(J=>YOt(J,R)))return[F];{let J=L6(E,x,d,D,R)||ve;return d.kind===108?[F,...J]:[...J,F]}}if(d.parent.kind===304){let F=E.getShorthandAssignmentValueSymbol(x.valueDeclaration),J=F?.declarations?F.declarations.map(G=>$M(G,E,F,d,!1,D)):ve;return ps(J,kJe(E,d))}if(Ol(d)&&Xa(S)&&Yp(S.parent)&&d===(S.propertyName||S.name)){let F=gM(d),J=E.getTypeAtLocation(S.parent);return F===void 0?ve:va(J.isUnion()?J.types:[J],G=>{let q=G.getProperty(F);return q&&L6(E,q,d)})}let L=kJe(E,d);return ps(m,L.length?L:L6(E,x,d,D))}function YOt(e,t){var n;return e===t.symbol||e===t.symbol.parent||Su(t.parent)||!HT(t.parent)&&e===((n=ai(t.parent,Zm))==null?void 0:n.symbol)}function kJe(e,t){let n=LM(t);if(n){let i=n&&e.getContextualType(n.parent);if(i)return va(PV(n,e,i,!1),s=>L6(e,s,t))}return ve}function KOt(e,t){let n=Pr(t,uu);if(!(n&&n.name))return;let i=Pr(n,gi);if(!i)return;let s=Fg(i);if(!s)return;let o=So(s.expression),u=eu(o)?o.symbol:e.getSymbolAtLocation(o);if(!u)return;let m=Qi(tA(n.name)),d=Jl(n)?e.getPropertyOfType(e.getTypeOfSymbol(u),m):e.getPropertyOfType(e.getDeclaredTypeOfSymbol(u),m);if(d)return L6(e,d,t)}function PJe(e,t,n){var i,s;let o=F6(e.referencedFiles,t);if(o){let d=n.getSourceFileFromReference(e,o);return d&&{reference:o,fileName:d.fileName,file:d,unverified:!1}}let u=F6(e.typeReferenceDirectives,t);if(u){let d=(i=n.getResolvedTypeReferenceDirectiveFromTypeReferenceDirective(u,e))==null?void 0:i.resolvedTypeReferenceDirective,S=d&&n.getSourceFile(d.resolvedFileName);return S&&{reference:u,fileName:S.fileName,file:S,unverified:!1}}let m=F6(e.libReferenceDirectives,t);if(m){let d=n.getLibFileFromReference(m);return d&&{reference:m,fileName:d.fileName,file:d,unverified:!1}}if(e.imports.length||e.moduleAugmentations.length){let d=HN(e,t),S;if(VU(d)&&vu(d.text)&&(S=n.getResolvedModuleFromModuleSpecifier(d,e))){let E=(s=S.resolvedModule)==null?void 0:s.resolvedFileName,x=E||QS(mi(e.fileName),d.text);return{file:n.getSourceFile(x),fileName:x,reference:{pos:d.getStart(),end:d.getEnd(),fileName:d.text},unverified:!E}}}}var NJe=new Set(["Array","ArrayLike","ReadonlyArray","Promise","PromiseLike","Iterable","IterableIterator","AsyncIterable","Set","WeakSet","ReadonlySet","Map","WeakMap","ReadonlyMap","Partial","Required","Readonly","Pick","Omit"]);function XOt(e,t){let n=t.symbol.name;if(!NJe.has(n))return!1;let i=e.resolveName(n,void 0,788968,!1);return!!i&&i===t.target.symbol}function DJe(e,t){if(!t.aliasSymbol)return!1;let n=t.aliasSymbol.name;if(!NJe.has(n))return!1;let i=e.resolveName(n,void 0,788968,!1);return!!i&&i===t.aliasSymbol}function QOt(e,t,n,i){var s,o;if(Kn(t)&4&&XOt(e,t))return WM(e.getTypeArguments(t)[0],e,n,i);if(DJe(e,t)&&t.aliasTypeArguments)return WM(t.aliasTypeArguments[0],e,n,i);if(Kn(t)&32&&t.target&&DJe(e,t.target)){let u=(o=(s=t.aliasSymbol)==null?void 0:s.declarations)==null?void 0:o[0];if(u&&im(u)&&Gp(u.type)&&u.type.typeArguments)return WM(e.getTypeAtLocation(u.type.typeArguments[0]),e,n,i)}return[]}function ZOt(e,t,n){let i=wf(t,n);if(i===t)return;if(WP(i.parent)&&i.parent.name===i)return WM(e.getTypeAtLocation(i.parent),e,i.parent,!1);let{symbol:s,failedAliasResolution:o}=Fee(i,e,!1);if(!s)return;let u=e.getTypeOfSymbolAtLocation(s,i),m=e6t(s,u,e),d=m&&WM(m,e,i,o),[S,E]=d&&d.length!==0?[m,d]:[u,WM(u,e,i,o)];return E.length?[...QOt(e,S,i,o),...E]:!(s.flags&111551)&&s.flags&788968?L6(e,$u(s,e),i,o):void 0}function WM(e,t,n,i){return va(e.isUnion()&&!(e.flags&32)?e.types:[e],s=>s.symbol&&L6(t,s.symbol,n,i))}function e6t(e,t,n){if(t.symbol===e||e.valueDeclaration&&t.symbol&&Ei(e.valueDeclaration)&&e.valueDeclaration.initializer===t.symbol.valueDeclaration){let i=t.getCallSignatures();if(i.length===1)return n.getReturnTypeOfSignature(Ma(i))}}function t6t(e,t,n){let i=AJe(e,t,n);if(!i||i.length===0)return;let s=F6(t.referencedFiles,n)||F6(t.typeReferenceDirectives,n)||F6(t.libReferenceDirectives,n);if(s)return{definitions:i,textSpan:lS(s)};let o=wf(t,n),u=zu(o.getStart(),o.getWidth());return{definitions:i,textSpan:u}}function r6t(e,t){return Gi(t.getIndexInfosAtLocation(e),n=>n.declaration&&zV(t,n.declaration))}function Fee(e,t,n){let i=t.getSymbolAtLocation(e),s=!1;if(i?.declarations&&i.flags&2097152&&!n&&n6t(e,i.declarations[0])){let o=t.getAliasedSymbol(i);if(o.declarations)return{symbol:o};s=!0}return{symbol:i,failedAliasResolution:s}}function n6t(e,t){return e.kind!==80?!1:e.parent===t?!0:t.kind!==274}function i6t(e){if(!OI(e))return!1;let t=Pr(e,n=>Su(n)?!0:OI(n)?!1:"quit");return!!t&&cl(t)===5}function L6(e,t,n,i,s){let o=Zn(t.declarations,D=>D!==s),u=S()||E();if(u)return u;let m=Zn(o,D=>!i6t(D)),d=Pt(m)?m:o;return Cr(d,D=>$M(D,e,t,n,!1,i));function S(){if(t.flags&32&&!(t.flags&19)&&(p6(n)||n.kind===137)){let D=Ln(o,gi);return D&&x(D.members,!0)}}function E(){return nQ(n)||uQ(n)?x(o,!1):void 0}function x(D,w){if(!D)return;let R=D.filter(w?Vc:Bs),L=R.filter(F=>!!F.body);return R.length?L.length!==0?L.map(F=>$M(F,e,t,n)):[$M(Va(R),e,t,n,!1,i)]:void 0}}function $M(e,t,n,i,s,o){let u=t.symbolToString(n),m=zv.getSymbolKind(t,n,i),d=n.parent?t.symbolToString(n.parent,i):"";return iTe(t,e,m,u,d,s,o)}function iTe(e,t,n,i,s,o,u,m){let d=t.getSourceFile();if(!m){let S=Ps(t)||t;m=df(S,d)}return{fileName:d.fileName,textSpan:m,kind:n,name:i,containerKind:void 0,containerName:s,...lc.toContextSpan(m,d,lc.getContextNode(t)),isLocal:!sTe(e,t),isAmbient:!!(t.flags&33554432),unverified:o,failedAliasResolution:u}}function s6t(e,t){let n=lc.getContextNode(e),i=df(eTe(n)?n.start:n,t);return{fileName:t.fileName,textSpan:i,kind:"keyword",name:"switch",containerKind:void 0,containerName:"",...lc.toContextSpan(i,t,n),isLocal:!0,isAmbient:!1,unverified:!1,failedAliasResolution:void 0}}function sTe(e,t){if(e.isDeclarationVisible(t))return!0;if(!t.parent)return!1;if(bv(t.parent)&&t.parent.initializer===t)return sTe(e,t.parent);switch(t.kind){case 172:case 177:case 178:case 174:if(up(t,2))return!1;case 176:case 303:case 304:case 210:case 231:case 219:case 218:return sTe(e,t.parent);default:return!1}}function zV(e,t,n){return $M(t,e,t.symbol,t,!1,n)}function F6(e,t){return Ln(e,n=>P3(n,t))}function a6t(e,t,n){return{fileName:t,textSpan:Il(0,0),kind:"script",name:e,containerName:void 0,containerKind:void 0,unverified:n}}function o6t(e){let t=Pr(e,i=>!WN(i)),n=t?.parent;return n&&HT(n)&&c9(n)===t?n:void 0}function c6t(e,t){let n=o6t(t),i=n&&e.getResolvedSignature(n);return ai(i&&i.declaration,s=>Bs(s)&&!Jh(s))}function l6t(e){switch(e.kind){case 176:case 185:case 179:case 180:return!0;default:return!1}}var jee={};A(jee,{provideInlayHints:()=>p6t});var u6t=e=>new RegExp(`^\\s?/\\*\\*?\\s?${e}\\s?\\*\\/\\s?$`);function _6t(e){return e.includeInlayParameterNameHints==="literals"||e.includeInlayParameterNameHints==="all"}function f6t(e){return e.includeInlayParameterNameHints==="literals"}function wJe(e){return e.interactiveInlayHints===!0}function p6t(e){let{file:t,program:n,span:i,cancellationToken:s,preferences:o}=e,u=t.text,m=n.getCompilerOptions(),d=ed(t,o),S=n.getTypeChecker(),E=[];return x(t),E;function x(xe){if(!(!xe||xe.getFullWidth()===0)){switch(xe.kind){case 267:case 263:case 264:case 262:case 231:case 218:case 174:case 219:s.throwIfCancellationRequested()}if(S5(i,xe.pos,xe.getFullWidth())&&!(Di(xe)&&!x0(xe)))return o.includeInlayVariableTypeHints&&Ei(xe)||o.includeInlayPropertyDeclarationTypeHints&&Ns(xe)?G(xe):o.includeInlayEnumMemberValueHints&&nS(xe)?F(xe):_6t(o)&&(ea(xe)||gE(xe))?q(xe):(o.includeInlayFunctionParameterTypeHints&&Go(xe)&&fj(xe)&&ue(xe),o.includeInlayFunctionLikeReturnTypeHints&&D(xe)&&K(xe)),Js(xe,x)}}function D(xe){return pc(xe)||ic(xe)||Tl(xe)||ul(xe)||Hp(xe)}function w(xe,te,he,be){let Ve=`${be?"...":""}${xe}`,Pe;wJe(o)?(Pe=[Ae(Ve,te),{text:":"}],Ve=""):Ve+=":",E.push({text:Ve,position:he,kind:"Parameter",whitespaceAfter:!0,displayParts:Pe})}function R(xe,te){E.push({text:typeof xe=="string"?`: ${xe}`:"",displayParts:typeof xe=="string"?void 0:[{text:": "},...xe],position:te,kind:"Type",whitespaceBefore:!0})}function L(xe,te){E.push({text:`= ${xe}`,position:te,kind:"Enum",whitespaceBefore:!0})}function F(xe){if(xe.initializer)return;let te=S.getConstantValue(xe);te!==void 0&&L(te.toString(),xe.end)}function J(xe){return xe.symbol&&xe.symbol.flags&1536}function G(xe){if(xe.initializer===void 0&&!(Ns(xe)&&!(S.getTypeAtLocation(xe).flags&1))||Hs(xe.name)||Ei(xe)&&!de(xe)||Vl(xe))return;let he=S.getTypeAtLocation(xe);if(J(he))return;let be=le(he);if(be){let Ve=typeof be=="string"?be:be.map(ke=>ke.text).join("");if(o.includeInlayVariableTypeHintsWhenTypeMatchesName===!1&&KS(xe.name.getText(),Ve))return;R(be,xe.name.end)}}function q(xe){let te=xe.arguments;if(!te||!te.length)return;let he=[],be=S.getResolvedSignatureForSignatureHelp(xe,he);if(!be||!he.length)return;let Ve=0;for(let Pe of te){let ke=So(Pe);if(f6t(o)&&!pe(ke)){Ve++;continue}let De=0;if(Ad(ke)){let ct=S.getTypeAtLocation(ke.expression);if(S.isTupleType(ct)){let{elementFlags:qe,fixedLength:et}=ct.target;if(et===0)continue;let Ie=Bo(qe,mt=>!(mt&1));(Ie<0?et:Ie)>0&&(De=Ie<0?et:Ie)}}let Be=S.getParameterIdentifierInfoAtPosition(be,Ve);if(Ve=Ve+(De||1),Be){let{parameter:ct,parameterName:qe,isRestParameter:et}=Be;if(!(o.includeInlayParameterNameHintsWhenArgumentMatchesName||!ee(ke,qe))&&!et)continue;let _t=Qi(qe);if(W(ke,_t))continue;w(_t,ct,Pe.getStart(),et)}}}function ee(xe,te){return He(xe)?xe.text===te:Wn(xe)?xe.name.text===te:!1}function W(xe,te){if(!sp(te,Ka(m),zR(t.scriptKind)))return!1;let he=Ty(u,xe.pos);if(!he?.length)return!1;let be=u6t(te);return Pt(he,Ve=>be.test(u.substring(Ve.pos,Ve.end)))}function pe(xe){switch(xe.kind){case 224:{let te=xe.operand;return WT(te)||He(te)&&dO(te.escapedText)}case 112:case 97:case 106:case 15:case 228:return!0;case 80:{let te=xe.escapedText;return me(te)||dO(te)}}return WT(xe)}function K(xe){if(pc(xe)&&!Oo(xe,21,t)||lp(xe)||!xe.body)return;let he=S.getSignatureFromDeclaration(xe);if(!he)return;let be=S.getReturnTypeOfSignature(he);if(J(be))return;let Ve=le(be);Ve&&R(Ve,re(xe))}function re(xe){let te=Oo(xe,22,t);return te?te.end:xe.parameters.end}function ue(xe){let te=S.getSignatureFromDeclaration(xe);if(te)for(let he=0;he<xe.parameters.length&&he<te.parameters.length;++he){let be=xe.parameters[he];if(!de(be)||Vl(be))continue;let Pe=ce(te.parameters[he]);Pe&&R(Pe,be.questionToken?be.questionToken.end:be.name.end)}}function ce(xe){let te=xe.valueDeclaration;if(!te||!ns(te))return;let he=S.getTypeOfSymbolAtLocation(xe,te);if(!J(he))return le(he)}function ne(xe){let he=v2();return CI(be=>{let Ve=S.typeToTypeNode(xe,void 0,71286784);M.assertIsDefined(Ve,"should always get typenode"),he.writeNode(4,Ve,t,be)})}function le(xe){if(!wJe(o))return ne(xe);let he=S.typeToTypeNode(xe,void 0,71286784);M.assertIsDefined(he,"should always get typenode");let be=[];return Ve(he),be;function Ve(Be){var ct,qe;if(!Be)return;let et=Sa(Be.kind);if(et){be.push({text:et});return}if(WT(Be)){be.push({text:De(Be)});return}switch(Be.kind){case 80:M.assertNode(Be,He);let Ie=Nn(Be),_t=Be.symbol&&Be.symbol.declarations&&Be.symbol.declarations.length&&Ps(Be.symbol.declarations[0]);_t?be.push(Ae(Ie,_t)):be.push({text:Ie});break;case 166:M.assertNode(Be,cf),Ve(Be.left),be.push({text:"."}),Ve(Be.right);break;case 182:M.assertNode(Be,LA),Be.assertsModifier&&be.push({text:"asserts "}),Ve(Be.parameterName),Be.type&&(be.push({text:" is "}),Ve(Be.type));break;case 183:M.assertNode(Be,Gp),Ve(Be.typeName),Be.typeArguments&&(be.push({text:"<"}),ke(Be.typeArguments,", "),be.push({text:">"}));break;case 168:M.assertNode(Be,Ac),Be.modifiers&&ke(Be.modifiers," "),Ve(Be.name),Be.constraint&&(be.push({text:" extends "}),Ve(Be.constraint)),Be.default&&(be.push({text:" = "}),Ve(Be.default));break;case 169:M.assertNode(Be,ns),Be.modifiers&&ke(Be.modifiers," "),Be.dotDotDotToken&&be.push({text:"..."}),Ve(Be.name),Be.questionToken&&be.push({text:"?"}),Be.type&&(be.push({text:": "}),Ve(Be.type));break;case 185:M.assertNode(Be,gN),be.push({text:"new "}),Pe(Be),be.push({text:" => "}),Ve(Be.type);break;case 186:M.assertNode(Be,pE),be.push({text:"typeof "}),Ve(Be.exprName),Be.typeArguments&&(be.push({text:"<"}),ke(Be.typeArguments,", "),be.push({text:">"}));break;case 187:M.assertNode(Be,lf),be.push({text:"{"}),Be.members.length&&(be.push({text:" "}),ke(Be.members,"; "),be.push({text:" "})),be.push({text:"}"});break;case 188:M.assertNode(Be,_8),Ve(Be.elementType),be.push({text:"[]"});break;case 189:M.assertNode(Be,FA),be.push({text:"["}),ke(Be.elements,", "),be.push({text:"]"});break;case 202:M.assertNode(Be,hN),Be.dotDotDotToken&&be.push({text:"..."}),Ve(Be.name),Be.questionToken&&be.push({text:"?"}),be.push({text:": "}),Ve(Be.type);break;case 190:M.assertNode(Be,wj),Ve(Be.type),be.push({text:"?"});break;case 191:M.assertNode(Be,Ij),be.push({text:"..."}),Ve(Be.type);break;case 192:M.assertNode(Be,Z1),ke(Be.types," | ");break;case 193:M.assertNode(Be,jA),ke(Be.types," & ");break;case 194:M.assertNode(Be,dE),Ve(Be.checkType),be.push({text:" extends "}),Ve(Be.extendsType),be.push({text:" ? "}),Ve(Be.trueType),be.push({text:" : "}),Ve(Be.falseType);break;case 195:M.assertNode(Be,s2),be.push({text:"infer "}),Ve(Be.typeParameter);break;case 196:M.assertNode(Be,a2),be.push({text:"("}),Ve(Be.type),be.push({text:")"});break;case 198:M.assertNode(Be,yb),be.push({text:`${Sa(Be.operator)} `}),Ve(Be.type);break;case 199:M.assertNode(Be,mE),Ve(Be.objectType),be.push({text:"["}),Ve(Be.indexType),be.push({text:"]"});break;case 200:M.assertNode(Be,o2),be.push({text:"{ "}),Be.readonlyToken&&(Be.readonlyToken.kind===40?be.push({text:"+"}):Be.readonlyToken.kind===41&&be.push({text:"-"}),be.push({text:"readonly "})),be.push({text:"["}),Ve(Be.typeParameter),Be.nameType&&(be.push({text:" as "}),Ve(Be.nameType)),be.push({text:"]"}),Be.questionToken&&(Be.questionToken.kind===40?be.push({text:"+"}):Be.questionToken.kind===41&&be.push({text:"-"}),be.push({text:"?"})),be.push({text:": "}),Be.type&&Ve(Be.type),be.push({text:"; }"});break;case 201:M.assertNode(Be,Mv),Ve(Be.literal);break;case 184:M.assertNode(Be,Jh),Pe(Be),be.push({text:" => "}),Ve(Be.type);break;case 205:M.assertNode(Be,qh),Be.isTypeOf&&be.push({text:"typeof "}),be.push({text:"import("}),Ve(Be.argument),Be.assertions&&(be.push({text:", { assert: "}),ke(Be.assertions.assertClause.elements,", "),be.push({text:" }"})),be.push({text:")"}),Be.qualifier&&(be.push({text:"."}),Ve(Be.qualifier)),Be.typeArguments&&(be.push({text:"<"}),ke(Be.typeArguments,", "),be.push({text:">"}));break;case 171:M.assertNode(Be,Nf),(ct=Be.modifiers)!=null&&ct.length&&(ke(Be.modifiers," "),be.push({text:" "})),Ve(Be.name),Be.questionToken&&be.push({text:"?"}),Be.type&&(be.push({text:": "}),Ve(Be.type));break;case 181:M.assertNode(Be,fE),be.push({text:"["}),ke(Be.parameters,", "),be.push({text:"]"}),Be.type&&(be.push({text:": "}),Ve(Be.type));break;case 173:M.assertNode(Be,$g),(qe=Be.modifiers)!=null&&qe.length&&(ke(Be.modifiers," "),be.push({text:" "})),Ve(Be.name),Be.questionToken&&be.push({text:"?"}),Pe(Be),Be.type&&(be.push({text:": "}),Ve(Be.type));break;case 179:M.assertNode(Be,MA),Pe(Be),Be.type&&(be.push({text:": "}),Ve(Be.type));break;case 207:M.assertNode(Be,Lv),be.push({text:"["}),ke(Be.elements,", "),be.push({text:"]"});break;case 206:M.assertNode(Be,Yp),be.push({text:"{"}),Be.elements.length&&(be.push({text:" "}),ke(Be.elements,", "),be.push({text:" "})),be.push({text:"}"});break;case 208:M.assertNode(Be,Xa),Ve(Be.name);break;case 224:M.assertNode(Be,tS),be.push({text:Sa(Be.operator)}),Ve(Be.operand);break;case 203:M.assertNode(Be,qde),Ve(Be.head),Be.templateSpans.forEach(Ve);break;case 16:M.assertNode(Be,IA),be.push({text:De(Be)});break;case 204:M.assertNode(Be,QG),Ve(Be.type),Ve(Be.literal);break;case 17:M.assertNode(Be,GG),be.push({text:De(Be)});break;case 18:M.assertNode(Be,kj),be.push({text:De(Be)});break;case 197:M.assertNode(Be,yN),be.push({text:"this"});break;default:M.failBadSyntaxKind(Be)}}function Pe(Be){Be.typeParameters&&(be.push({text:"<"}),ke(Be.typeParameters,", "),be.push({text:">"})),be.push({text:"("}),ke(Be.parameters,", "),be.push({text:")"})}function ke(Be,ct){Be.forEach((qe,et)=>{et>0&&be.push({text:ct}),Ve(qe)})}function De(Be){switch(Be.kind){case 11:return d===0?`'${Vh(Be.text,39)}'`:`"${Vh(Be.text,34)}"`;case 16:case 17:case 18:{let ct=Be.rawText??VH(Vh(Be.text,96));switch(Be.kind){case 16:return"`"+ct+"${";case 17:return"}"+ct+"${";case 18:return"}"+ct+"`"}}}return Be.text}}function me(xe){return xe==="undefined"}function de(xe){if((db(xe)||Ei(xe)&&zP(xe))&&xe.initializer){let te=So(xe.initializer);return!(pe(te)||gE(te)||Ca(te)||sb(te))}return!0}function Ae(xe,te){let he=te.getSourceFile();return{text:xe,span:df(te,he),file:he.fileName}}}var Bb={};A(Bb,{getDocCommentTemplateAtPosition:()=>x6t,getJSDocParameterNameCompletionDetails:()=>E6t,getJSDocParameterNameCompletions:()=>T6t,getJSDocTagCompletionDetails:()=>jJe,getJSDocTagCompletions:()=>b6t,getJSDocTagNameCompletionDetails:()=>S6t,getJSDocTagNameCompletions:()=>v6t,getJsDocCommentsFromDeclarations:()=>d6t,getJsDocTagsFromDeclarations:()=>h6t});var IJe=["abstract","access","alias","argument","async","augments","author","borrows","callback","class","classdesc","constant","constructor","constructs","copyright","default","deprecated","description","emits","enum","event","example","exports","extends","external","field","file","fileoverview","fires","function","generator","global","hideconstructor","host","ignore","implements","import","inheritdoc","inner","instance","interface","kind","lends","license","link","linkcode","linkplain","listens","member","memberof","method","mixes","module","name","namespace","overload","override","package","param","private","prop","property","protected","public","readonly","requires","returns","satisfies","see","since","static","summary","template","this","throws","todo","tutorial","type","typedef","var","variation","version","virtual","yields"],OJe,RJe;function d6t(e,t){let n=[];return LQ(e,i=>{for(let s of g6t(i)){let o=ag(s)&&s.tags&&Ln(s.tags,m=>m.kind===327&&(m.tagName.escapedText==="inheritDoc"||m.tagName.escapedText==="inheritdoc"));if(s.comment===void 0&&!o||ag(s)&&i.kind!==346&&i.kind!==338&&s.tags&&s.tags.some(m=>m.kind===346||m.kind===338)&&!s.tags.some(m=>m.kind===341||m.kind===342))continue;let u=s.comment?cD(s.comment,t):[];o&&o.comment&&(u=u.concat(cD(o.comment,t))),Es(n,u,m6t)||n.push(u)}}),ef(bf(n,[XN()]))}function m6t(e,t){return UT(e,t,(n,i)=>n.kind===i.kind&&n.text===i.text)}function g6t(e){switch(e.kind){case 341:case 348:return[e];case 338:case 346:return[e,e.parent];case 323:if(EN(e.parent))return[e.parent.parent];default:return CH(e)}}function h6t(e,t){let n=[];return LQ(e,i=>{let s=nb(i);if(!(s.some(o=>o.kind===346||o.kind===338)&&!s.some(o=>o.kind===341||o.kind===342)))for(let o of s)n.push({name:o.tagName.text,text:FJe(o,t)}),n.push(...MJe(LJe(o),t))}),n}function MJe(e,t){return va(e,n=>ps([{name:n.tagName.text,text:FJe(n,t)}],MJe(LJe(n),t)))}function LJe(e){return hI(e)&&e.isNameFirst&&e.typeExpression&&f2(e.typeExpression.type)?e.typeExpression.type.jsDocPropertyTags:void 0}function cD(e,t){return typeof e=="string"?[td(e)]:va(e,n=>n.kind===321?[td(n.text)]:q0e(n,t))}function FJe(e,t){let{comment:n,kind:i}=e,s=y6t(i);switch(i){case 349:let m=e.typeExpression;return m?o(m):n===void 0?void 0:cD(n,t);case 329:return o(e.class);case 328:return o(e.class);case 345:let d=e,S=[];if(d.constraint&&S.push(td(d.constraint.getText())),wt(d.typeParameters)){wt(S)&&S.push(Zc());let x=d.typeParameters[d.typeParameters.length-1];kt(d.typeParameters,D=>{S.push(s(D.getText())),x!==D&&S.push(C_(28),Zc())})}return n&&S.push(Zc(),...cD(n,t)),S;case 344:case 350:return o(e.typeExpression);case 346:case 338:case 348:case 341:case 347:let{name:E}=e;return E?o(E):n===void 0?void 0:cD(n,t);default:return n===void 0?void 0:cD(n,t)}function o(m){return u(m.getText())}function u(m){return n?m.match(/^https?$/)?[td(m),...cD(n,t)]:[s(m),Zc(),...cD(n,t)]:[td(m)]}}function y6t(e){switch(e){case 341:return j0e;case 348:return B0e;case 345:return V0e;case 346:case 338:return U0e;default:return td}}function v6t(){return OJe||(OJe=Cr(IJe,e=>({name:e,kind:"keyword",kindModifiers:"",sortText:gk.SortText.LocationPriority})))}var S6t=jJe;function b6t(){return RJe||(RJe=Cr(IJe,e=>({name:`@${e}`,kind:"keyword",kindModifiers:"",sortText:gk.SortText.LocationPriority})))}function jJe(e){return{name:e,kind:"",kindModifiers:"",displayParts:[td(e)],documentation:ve,tags:void 0,codeActions:void 0}}function T6t(e){if(!He(e.name))return ve;let t=e.name.text,n=e.parent,i=n.parent;return Bs(i)?Gi(i.parameters,s=>{if(!He(s.name))return;let o=s.name.text;if(!(n.tags.some(u=>u!==e&&Pd(u)&&He(u.name)&&u.name.escapedText===o)||t!==void 0&&!_s(o,t)))return{name:o,kind:"parameter",kindModifiers:"",sortText:gk.SortText.LocationPriority}}):[]}function E6t(e){return{name:e,kind:"parameter",kindModifiers:"",displayParts:[td(e)],documentation:ve,tags:void 0,codeActions:void 0}}function x6t(e,t,n,i){let s=Yi(t,n),o=Pr(s,ag);if(o&&(o.comment!==void 0||wt(o.tags)))return;let u=s.getStart(t);if(!o&&u<n)return;let m=P6t(s,i);if(!m)return;let{commentOwner:d,parameters:S,hasReturn:E}=m,x=Pp(d)&&d.jsDoc?d.jsDoc:void 0,D=vc(x);if(d.getStart(t)<n||D&&o&&D!==o)return;let w=C6t(t,n),R=Oy(t.fileName),L=(S?A6t(S||[],R,w,e):"")+(E?k6t(w,e):""),F="/**",J=" */",G=wt(nb(d))>0;if(L&&!G){let q=F+e+w+" * ",ee=u===n?e+w:"";return{newText:q+e+L+w+J+ee,caretOffset:q.length}}return{newText:F+J,caretOffset:3}}function C6t(e,t){let{text:n}=e,i=om(t,e),s=i;for(;s<=t&&wg(n.charCodeAt(s));s++);return n.slice(i,s)}function A6t(e,t,n,i){return e.map(({name:s,dotDotDotToken:o},u)=>{let m=s.kind===80?s.text:"param"+u;return`${n} * @param ${t?o?"{...any} ":"{any} ":""}${m}${i}`}).join("")}function k6t(e,t){return`${e} * @returns${t}`}function P6t(e,t){return b_e(e,n=>aTe(n,t))}function aTe(e,t){switch(e.kind){case 262:case 218:case 174:case 176:case 173:case 219:let n=e;return{commentOwner:e,parameters:n.parameters,hasReturn:WV(n,t)};case 303:return aTe(e.initializer,t);case 263:case 264:case 266:case 306:case 265:return{commentOwner:e};case 171:{let s=e;return s.type&&Jh(s.type)?{commentOwner:e,parameters:s.type.parameters,hasReturn:WV(s.type,t)}:{commentOwner:e}}case 243:{let o=e.declarationList.declarations,u=o.length===1&&o[0].initializer?N6t(o[0].initializer):void 0;return u?{commentOwner:e,parameters:u.parameters,hasReturn:WV(u,t)}:{commentOwner:e}}case 307:return"quit";case 267:return e.parent.kind===267?void 0:{commentOwner:e};case 244:return aTe(e.expression,t);case 226:{let s=e;return cl(s)===0?"quit":Bs(s.right)?{commentOwner:e,parameters:s.right.parameters,hasReturn:WV(s.right,t)}:{commentOwner:e}}case 172:let i=e.initializer;if(i&&(ic(i)||pc(i)))return{commentOwner:e,parameters:i.parameters,hasReturn:WV(i,t)}}}function WV(e,t){return!!t?.generateReturnInDocTemplate&&(Jh(e)||pc(e)&&Ct(e.body)||Go(e)&&e.body&&Vs(e.body)&&!!xv(e.body,n=>n))}function N6t(e){for(;e.kind===217;)e=e.expression;switch(e.kind){case 218:case 219:return e;case 231:return Ln(e.members,Vc)}}var Bee={};A(Bee,{mapCode:()=>D6t});function D6t(e,t,n,i,s,o){return Sn.ChangeTracker.with({host:i,formatContext:s,preferences:o},u=>{let m=t.map(S=>w6t(e,S)),d=n&&ef(n);for(let S of m)I6t(e,u,S,d)})}function w6t(e,t){let n=[{parse:()=>HA("__mapcode_content_nodes.ts",t,e.languageVersion,!0,e.scriptKind),body:o=>o.statements},{parse:()=>HA("__mapcode_class_content_nodes.ts",`class __class {
${t}
}`,e.languageVersion,!0,e.scriptKind),body:o=>o.statements[0].members}],i=[];for(let{parse:o,body:u}of n){let m=o(),d=u(m);if(d.length&&m.parseDiagnostics.length===0)return d;d.length&&i.push({sourceFile:m,body:d})}let{body:s}=i.sort((o,u)=>o.sourceFile.parseDiagnostics.length-u.sourceFile.parseDiagnostics.length)[0];return s}function I6t(e,t,n,i){uu(n[0])||$T(n[0])?O6t(e,t,n,i):R6t(e,t,n,i)}function O6t(e,t,n,i){let s;if(!i||!i.length?s=Ln(e.statements,Jp(gi,Yu)):s=kt(i,u=>Pr(Yi(e,u.start),Jp(gi,Yu))),!s)return;let o=s.members.find(u=>n.some(m=>$V(m,u)));if(o){let u=xm(s.members,m=>n.some(d=>$V(d,m)));kt(n,Uee),t.replaceNodeRangeWithNodes(e,o,u,n);return}kt(n,Uee),t.insertNodesAfter(e,s.members[s.members.length-1],n)}function R6t(e,t,n,i){if(!i?.length){t.insertNodesAtEndOfFile(e,n,!1);return}for(let o of i){let u=Pr(Yi(e,o.start),m=>Jp(Vs,Ji)(m)&&Pt(m.statements,d=>n.some(S=>$V(S,d))));if(u){let m=u.statements.find(d=>n.some(S=>$V(S,d)));if(m){let d=xm(u.statements,S=>n.some(E=>$V(E,S)));kt(n,Uee),t.replaceNodeRangeWithNodes(e,m,d,n);return}}}let s=e.statements;for(let o of i){let u=Pr(Yi(e,o.start),Vs);if(u){s=u.statements;break}}kt(n,Uee),t.insertNodesAfter(e,s[s.length-1],n)}function $V(e,t){var n,i,s,o,u,m;return e.kind!==t.kind?!1:e.kind===176?e.kind===t.kind:Wu(e)&&Wu(t)?e.name.getText()===t.name.getText():vb(e)&&vb(t)||rY(e)&&rY(t)?e.expression.getText()===t.expression.getText():Sb(e)&&Sb(t)?((n=e.initializer)==null?void 0:n.getText())===((i=t.initializer)==null?void 0:i.getText())&&((s=e.incrementor)==null?void 0:s.getText())===((o=t.incrementor)==null?void 0:o.getText())&&((u=e.condition)==null?void 0:u.getText())===((m=t.condition)==null?void 0:m.getText()):$x(e)&&$x(t)?e.expression.getText()===t.expression.getText()&&e.initializer.getText()===t.initializer.getText():rS(e)&&rS(t)?e.label.getText()===t.label.getText():e.getText()===t.getText()}function Uee(e){BJe(e),e.parent=void 0}function BJe(e){e.pos=-1,e.end=-1,e.forEachChild(BJe)}var Ub={};A(Ub,{compareImportsOrRequireStatements:()=>pTe,compareModuleSpecifiers:()=>Z6t,getDetectionLists:()=>Vee,getImportDeclarationInsertionIndex:()=>Y6t,getImportSpecifierInsertionIndex:()=>K6t,getNamedImportSpecifierComparerWithDetection:()=>G6t,getOrganizeImportsStringComparerWithDetection:()=>H6t,organizeImports:()=>M6t,testCoalesceExports:()=>Q6t,testCoalesceImports:()=>X6t});function M6t(e,t,n,i,s,o){let u=Sn.ChangeTracker.fromContext({host:n,formatContext:t,preferences:s}),m=o==="SortAndCombine"||o==="All",d=m,S=o==="RemoveUnused"||o==="All",E=e.statements.filter(Yc),x=oTe(e,E),{comparersToTest:D,typeOrdersToTest:w}=Vee(s),R=D[0],L={moduleSpecifierComparer:typeof s.organizeImportsIgnoreCase=="boolean"?R:void 0,namedImportComparer:typeof s.organizeImportsIgnoreCase=="boolean"?R:void 0,typeOrder:s.organizeImportsTypeOrder};if(typeof s.organizeImportsIgnoreCase!="boolean"&&({comparer:L.moduleSpecifierComparer}=JJe(x,D)),!L.typeOrder||typeof s.organizeImportsIgnoreCase!="boolean"){let q=_Te(E,D,w);if(q){let{namedImportComparer:ee,typeOrder:W}=q;L.namedImportComparer=L.namedImportComparer??ee,L.typeOrder=L.typeOrder??W}}x.forEach(q=>J(q,L)),o!=="RemoveUnused"&&F6t(e).forEach(q=>G(q,L.namedImportComparer));for(let q of e.statements.filter(B_)){if(!q.body)continue;if(oTe(e,q.body.statements.filter(Yc)).forEach(W=>J(W,L)),o!=="RemoveUnused"){let W=q.body.statements.filter(xl);G(W,L.namedImportComparer)}}return u.getChanges();function F(q,ee){if(wt(q)===0)return;Tn(q[0],1024);let W=d?Hw(q,re=>HV(re.moduleSpecifier)):[q],pe=m?Qs(W,(re,ue)=>lTe(re[0].moduleSpecifier,ue[0].moduleSpecifier,L.moduleSpecifierComparer??R)):W,K=va(pe,re=>HV(re[0].moduleSpecifier)||re[0].moduleSpecifier===void 0?ee(re):re);if(K.length===0)u.deleteNodes(e,q,{leadingTriviaOption:Sn.LeadingTriviaOption.Exclude,trailingTriviaOption:Sn.TrailingTriviaOption.Include},!0);else{let re={leadingTriviaOption:Sn.LeadingTriviaOption.Exclude,trailingTriviaOption:Sn.TrailingTriviaOption.Include,suffix:Vv(n,t.options)};u.replaceNodeWithNodes(e,q[0],K,re);let ue=u.nodeHasTrailingComment(e,q[0],re);u.deleteNodes(e,q.slice(1),{trailingTriviaOption:Sn.TrailingTriviaOption.Include},ue)}}function J(q,ee){let W=ee.moduleSpecifierComparer??R,pe=ee.namedImportComparer??R,K=ee.typeOrder??"last",re=GM({organizeImportsTypeOrder:K},pe);F(q,ce=>(S&&(ce=j6t(ce,e,i)),d&&(ce=UJe(ce,W,re,e)),m&&(ce=Qs(ce,(ne,le)=>pTe(ne,le,W))),ce))}function G(q,ee){let W=GM(s,ee);F(q,pe=>VJe(pe,W))}}function Vee(e){return{comparersToTest:typeof e.organizeImportsIgnoreCase=="boolean"?[fTe(e,e.organizeImportsIgnoreCase)]:[fTe(e,!0),fTe(e,!1)],typeOrdersToTest:e.organizeImportsTypeOrder?[e.organizeImportsTypeOrder]:["last","inline","first"]}}function oTe(e,t){let n=xy(e.languageVersion,!1,e.languageVariant),i=[],s=0;for(let o of t)i[s]&&L6t(e,o,n)&&s++,i[s]||(i[s]=[]),i[s].push(o);return i}function L6t(e,t,n){let i=t.getFullStart(),s=t.getStart();n.setText(e.text,i,s-i);let o=0;for(;n.getTokenStart()<s;)if(n.scan()===4&&(o++,o>=2))return!0;return!1}function F6t(e){let t=[],n=e.statements,i=wt(n),s=0,o=0;for(;s<i;)if(xl(n[s])){t[o]===void 0&&(t[o]=[]);let u=n[s];if(u.moduleSpecifier)t[o].push(u),s++;else{for(;s<i&&xl(n[s]);)t[o].push(n[s++]);o++}}else s++;return va(t,u=>oTe(e,u))}function j6t(e,t,n){let i=n.getTypeChecker(),s=n.getCompilerOptions(),o=i.getJsxNamespace(t),u=i.getJsxFragmentFactory(t),m=!!(t.transformFlags&2),d=[];for(let E of e){let{importClause:x,moduleSpecifier:D}=E;if(!x){d.push(E);continue}let{name:w,namedBindings:R}=x;if(w&&!S(w)&&(w=void 0),R)if(My(R))S(R.name)||(R=void 0);else{let L=R.elements.filter(F=>S(F.name));L.length<R.elements.length&&(R=L.length?U.updateNamedImports(R,L):void 0)}w||R?d.push(HM(E,w,R)):V6t(t,D)&&(t.isDeclarationFile?d.push(U.createImportDeclaration(E.modifiers,void 0,D,void 0)):d.push(E))}return d;function S(E){return m&&(E.text===o||u&&E.text===u)&&nZ(s.jsx)||lc.Core.isSymbolReferencedInFile(E,i,t)}}function HV(e){return e!==void 0&&No(e)?e.text:void 0}function B6t(e){let t,n={defaultImports:[],namespaceImports:[],namedImports:[]},i={defaultImports:[],namespaceImports:[],namedImports:[]};for(let s of e){if(s.importClause===void 0){t=t||s;continue}let o=s.importClause.isTypeOnly?n:i,{name:u,namedBindings:m}=s.importClause;u&&o.defaultImports.push(s),m&&(My(m)?o.namespaceImports.push(s):o.namedImports.push(s))}return{importWithoutClause:t,typeOnlyImports:n,regularImports:i}}function UJe(e,t,n,i){if(e.length===0)return e;let s=IW(e,u=>{if(u.attributes){let m=u.attributes.token+" ";for(let d of pa(u.attributes.elements,(S,E)=>c_(S.name.text,E.name.text)))m+=d.name.text+":",m+=No(d.value)?`"${d.value.text}"`:d.value.getText()+" ";return m}return""}),o=[];for(let u in s){let m=s[u],{importWithoutClause:d,typeOnlyImports:S,regularImports:E}=B6t(m);d&&o.push(d);for(let x of[E,S]){let D=x===S,{defaultImports:w,namespaceImports:R,namedImports:L}=x;if(!D&&w.length===1&&R.length===1&&L.length===0){let re=w[0];o.push(HM(re,re.importClause.name,R[0].importClause.namedBindings));continue}let F=Qs(R,(re,ue)=>t(re.importClause.namedBindings.name.text,ue.importClause.namedBindings.name.text));for(let re of F)o.push(HM(re,void 0,re.importClause.namedBindings));let J=xo(w),G=xo(L),q=J??G;if(!q)continue;let ee,W=[];if(w.length===1)ee=w[0].importClause.name;else for(let re of w)W.push(U.createImportSpecifier(!1,U.createIdentifier("default"),re.importClause.name));W.push(...J6t(L));let pe=U.createNodeArray(Qs(W,n),G?.importClause.namedBindings.elements.hasTrailingComma),K=pe.length===0?ee?void 0:U.createNamedImports(ve):G?U.updateNamedImports(G.importClause.namedBindings,pe):U.createNamedImports(pe);i&&K&&G?.importClause.namedBindings&&!n2(G.importClause.namedBindings,i)&&Tn(K,2),D&&ee&&K?(o.push(HM(q,ee,void 0)),o.push(HM(G??q,void 0,K))):o.push(HM(q,ee,K))}}return o}function VJe(e,t){if(e.length===0)return e;let{exportWithoutClause:n,namedExports:i,typeOnlyExports:s}=u(e),o=[];n&&o.push(n);for(let m of[i,s]){if(m.length===0)continue;let d=[];d.push(...va(m,x=>x.exportClause&&kd(x.exportClause)?x.exportClause.elements:ve));let S=Qs(d,t),E=m[0];o.push(U.updateExportDeclaration(E,E.modifiers,E.isTypeOnly,E.exportClause&&(kd(E.exportClause)?U.updateNamedExports(E.exportClause,S):U.updateNamespaceExport(E.exportClause,E.exportClause.name)),E.moduleSpecifier,E.attributes))}return o;function u(m){let d,S=[],E=[];for(let x of m)x.exportClause===void 0?d=d||x:x.isTypeOnly?E.push(x):S.push(x);return{exportWithoutClause:d,namedExports:S,typeOnlyExports:E}}}function HM(e,t,n){return U.updateImportDeclaration(e,e.modifiers,U.updateImportClause(e.importClause,e.importClause.isTypeOnly,t,n),e.moduleSpecifier,e.attributes)}function cTe(e,t,n,i){switch(i?.organizeImportsTypeOrder){case"first":return XS(t.isTypeOnly,e.isTypeOnly)||n(e.name.text,t.name.text);case"inline":return n(e.name.text,t.name.text);default:return XS(e.isTypeOnly,t.isTypeOnly)||n(e.name.text,t.name.text)}}function lTe(e,t,n){let i=e===void 0?void 0:HV(e),s=t===void 0?void 0:HV(t);return XS(i===void 0,s===void 0)||XS(vu(i),vu(s))||n(i,s)}function U6t(e){return e.map(t=>HV(uTe(t))||"")}function uTe(e){var t;switch(e.kind){case 271:return(t=ai(e.moduleReference,C0))==null?void 0:t.expression;case 272:return e.moduleSpecifier;case 243:return e.declarationList.declarations[0].initializer.arguments[0]}}function V6t(e,t){let n=La(t)&&t.text;return bs(n)&&Pt(e.moduleAugmentations,i=>La(i)&&i.text===n)}function J6t(e){return va(e,t=>Cr(q6t(t),n=>n.name&&n.propertyName&&n.name.escapedText===n.propertyName.escapedText?U.updateImportSpecifier(n,n.isTypeOnly,void 0,n.name):n))}function q6t(e){var t;return(t=e.importClause)!=null&&t.namedBindings&&Gg(e.importClause.namedBindings)?e.importClause.namedBindings.elements:void 0}function JJe(e,t){let n=[];return e.forEach(i=>{n.push(U6t(i))}),zJe(n,t)}function _Te(e,t,n){let i=!1,s=e.filter(d=>{var S,E;let x=(E=ai((S=d.importClause)==null?void 0:S.namedBindings,Gg))==null?void 0:E.elements;return x?.length?(!i&&x.some(D=>D.isTypeOnly)&&x.some(D=>!D.isTypeOnly)&&(i=!0),!0):!1});if(s.length===0)return;let o=s.map(d=>{var S,E;return(E=ai((S=d.importClause)==null?void 0:S.namedBindings,Gg))==null?void 0:E.elements}).filter(d=>d!==void 0);if(!i||n.length===0){let d=zJe(o.map(S=>S.map(E=>E.name.text)),t);return{namedImportComparer:d.comparer,typeOrder:n.length===1?n[0]:void 0,isSorted:d.isSorted}}let u={first:1/0,last:1/0,inline:1/0},m={first:t[0],last:t[0],inline:t[0]};for(let d of t){let S={first:0,last:0,inline:0};for(let E of o)for(let x of n)S[x]=(S[x]??0)+qJe(E,(D,w)=>cTe(D,w,d,{organizeImportsTypeOrder:x}));for(let E of n){let x=E;S[x]<u[x]&&(u[x]=S[x],m[x]=d)}}e:for(let d of n){let S=d;for(let E of n)if(u[E]<u[S])continue e;return{namedImportComparer:m[S],typeOrder:S,isSorted:u[S]===0}}return{namedImportComparer:m.last,typeOrder:"last",isSorted:u.last===0}}function qJe(e,t){let n=0;for(let i=0;i<e.length-1;i++)t(e[i],e[i+1])>0&&n++;return n}function zJe(e,t){let n,i=1/0;for(let s of t){let o=0;for(let u of e){if(u.length<=1)continue;let m=qJe(u,s);o+=m}o<i&&(i=o,n=s)}return{comparer:n??t[0],isSorted:i===0}}function z6t(e,t){return tc(WJe(e),WJe(t))}function WJe(e){var t;switch(e.kind){case 272:return e.importClause?e.importClause.isTypeOnly?1:((t=e.importClause.namedBindings)==null?void 0:t.kind)===274?2:e.importClause.name?3:4:0;case 271:return 5;case 243:return 6}}function GV(e){return e?Wce:c_}function W6t(e,t){let n=$6t(t),i=t.organizeImportsCaseFirst??!1,s=t.organizeImportsNumericCollation??!1,o=t.organizeImportsAccentCollation??!0,u=e?o?"accent":"base":o?"variant":"case";return new Intl.Collator(n,{usage:"sort",caseFirst:i||"false",sensitivity:u,numeric:s}).compare}function $6t(e){let t=e.organizeImportsLocale;t==="auto"&&(t=Hce()),t===void 0&&(t="en");let n=Intl.Collator.supportedLocalesOf(t);return n.length?n[0]:"en"}function fTe(e,t){return(e.organizeImportsCollation??"ordinal")==="unicode"?W6t(t,e):GV(t)}function H6t(e,t){return JJe([e],Vee(t).comparersToTest)}function GM(e,t){let n=t??GV(!!e.organizeImportsIgnoreCase);return(i,s)=>cTe(i,s,n,e)}function G6t(e,t,n){let{comparersToTest:i,typeOrdersToTest:s}=Vee(t),o=_Te([e],i,s),u=GM(t,i[0]),m;if(typeof t.organizeImportsIgnoreCase!="boolean"||!t.organizeImportsTypeOrder){if(o){let{namedImportComparer:d,typeOrder:S,isSorted:E}=o;m=E,u=GM({organizeImportsTypeOrder:S},d)}else if(n){let d=_Te(n.statements.filter(Yc),i,s);if(d){let{namedImportComparer:S,typeOrder:E,isSorted:x}=d;m=x,u=GM({organizeImportsTypeOrder:E},S)}}}return{specifierComparer:u,isSorted:m}}function Y6t(e,t,n){let i=mv(e,t,ec,(s,o)=>pTe(s,o,n));return i<0?~i:i}function K6t(e,t,n){let i=mv(e,t,ec,n);return i<0?~i:i}function pTe(e,t,n){return lTe(uTe(e),uTe(t),n)||z6t(e,t)}function X6t(e,t,n,i){let s=GV(t),o=GM({organizeImportsTypeOrder:i?.organizeImportsTypeOrder},s);return UJe(e,s,o,n)}function Q6t(e,t,n){return VJe(e,(s,o)=>cTe(s,o,GV(t),{organizeImportsTypeOrder:n?.organizeImportsTypeOrder??"last"}))}function Z6t(e,t,n){let i=GV(!!n);return lTe(e,t,i)}var Jee={};A(Jee,{collectElements:()=>e4t});function e4t(e,t){let n=[];return t4t(e,t,n),r4t(e,n),n.sort((i,s)=>i.textSpan.start-s.textSpan.start)}function t4t(e,t,n){let i=40,s=0,o=[...e.statements,e.endOfFileToken],u=o.length;for(;s<u;){for(;s<u&&!eA(o[s]);)m(o[s]),s++;if(s===u)break;let d=s;for(;s<u&&eA(o[s]);)m(o[s]),s++;let S=s-1;S!==d&&n.push(YV(Oo(o[d],102,e).getStart(e),o[S].getEnd(),"imports"))}function m(d){var S;if(i===0)return;t.throwIfCancellationRequested(),(u_(d)||_l(d)||nm(d)||Ig(d)||d.kind===1)&&HJe(d,e,t,n),Bs(d)&&Pn(d.parent)&&Wn(d.parent.left)&&HJe(d.parent.left,e,t,n),(Vs(d)||Hg(d))&&dTe(d.statements.end,e,t,n),(gi(d)||Yu(d))&&dTe(d.members.end,e,t,n);let E=i4t(d,e);E&&n.push(E),i--,ea(d)?(i++,m(d.expression),i--,d.arguments.forEach(m),(S=d.typeArguments)==null||S.forEach(m)):vb(d)&&d.elseStatement&&vb(d.elseStatement)?(m(d.expression),m(d.thenStatement),i++,m(d.elseStatement),i--):d.forEachChild(m),i++}}function r4t(e,t){let n=[],i=e.getLineStarts();for(let s of i){let o=e.getLineEndOfPosition(s),u=e.text.substring(s,o),m=$Je(u);if(!(!m||Bv(e,s)))if(m[1]){let d=n.pop();d&&(d.textSpan.length=o-d.textSpan.start,d.hintSpan.length=o-d.textSpan.start,t.push(d))}else{let d=Il(e.text.indexOf("//",s),o);n.push(yk(d,"region",d,!1,m[2]||"#region"))}}}var n4t=/^#(end)?region(?:\s+(.*))?(?:\r)?$/;function $Je(e){return e=e.trimStart(),_s(e,"//")?(e=e.slice(2).trim(),n4t.exec(e)):null}function dTe(e,t,n,i){let s=Ty(t.text,e);if(!s)return;let o=-1,u=-1,m=0,d=t.getFullText();for(let{kind:E,pos:x,end:D}of s)switch(n.throwIfCancellationRequested(),E){case 2:let w=d.slice(x,D);if($Je(w)){S(),m=0;break}m===0&&(o=x),u=D,m++;break;case 3:S(),i.push(YV(x,D,"comment")),m=0;break;default:M.assertNever(E)}S();function S(){m>1&&i.push(YV(o,u,"comment"))}}function HJe(e,t,n,i){DA(e)||dTe(e.pos,t,n,i)}function YV(e,t,n){return yk(Il(e,t),n)}function i4t(e,t){switch(e.kind){case 241:if(Bs(e.parent))return s4t(e.parent,e,t);switch(e.parent.kind){case 246:case 249:case 250:case 248:case 245:case 247:case 254:case 299:return E(e.parent);case 258:let w=e.parent;if(w.tryBlock===e)return E(e.parent);if(w.finallyBlock===e){let R=Oo(w,98,t);if(R)return E(R)}default:return yk(df(e,t),"code")}case 268:return E(e.parent);case 263:case 231:case 264:case 266:case 269:case 187:case 206:return E(e);case 189:return E(e,!1,!FA(e.parent),23);case 296:case 297:return x(e.statements);case 210:return S(e);case 209:return S(e,23);case 284:return o(e);case 288:return u(e);case 285:case 286:return m(e.attributes);case 228:case 15:return d(e);case 207:return E(e,!1,!Xa(e.parent),23);case 219:return s(e);case 213:return i(e);case 217:return D(e);case 275:case 279:case 300:return n(e)}function n(w){if(!w.elements.length)return;let R=Oo(w,19,t),L=Oo(w,20,t);if(!(!R||!L||Ed(R.pos,L.pos,t)))return qee(R,L,w,t,!1,!1)}function i(w){if(!w.arguments.length)return;let R=Oo(w,21,t),L=Oo(w,22,t);if(!(!R||!L||Ed(R.pos,L.pos,t)))return qee(R,L,w,t,!1,!0)}function s(w){if(Vs(w.body)||uf(w.body)||Ed(w.body.getFullStart(),w.body.getEnd(),t))return;let R=Il(w.body.getFullStart(),w.body.getEnd());return yk(R,"code",df(w))}function o(w){let R=Il(w.openingElement.getStart(t),w.closingElement.getEnd()),L=w.openingElement.tagName.getText(t),F="<"+L+">...</"+L+">";return yk(R,"code",R,!1,F)}function u(w){let R=Il(w.openingFragment.getStart(t),w.closingFragment.getEnd());return yk(R,"code",R,!1,"<>...</>")}function m(w){if(w.properties.length!==0)return YV(w.getStart(t),w.getEnd(),"code")}function d(w){if(!(w.kind===15&&w.text.length===0))return YV(w.getStart(t),w.getEnd(),"code")}function S(w,R=19){return E(w,!1,!Gu(w.parent)&&!ea(w.parent),R)}function E(w,R=!1,L=!0,F=19,J=F===19?20:24){let G=Oo(e,F,t),q=Oo(e,J,t);return G&&q&&qee(G,q,w,t,R,L)}function x(w){return w.length?yk(lS(w),"code"):void 0}function D(w){if(Ed(w.getStart(),w.getEnd(),t))return;let R=Il(w.getStart(),w.getEnd());return yk(R,"code",df(w))}}function s4t(e,t,n){let i=a4t(e,t,n),s=Oo(t,20,n);return i&&s&&qee(i,s,e,n,e.kind!==219)}function qee(e,t,n,i,s=!1,o=!0){let u=Il(o?e.getFullStart():e.getStart(i),t.getEnd());return yk(u,"code",df(n,i),s)}function yk(e,t,n=e,i=!1,s="..."){return{textSpan:e,kind:t,hintSpan:n,bannerText:s,autoCollapse:i}}function a4t(e,t,n){if(Xfe(e.parameters,n)){let i=Oo(e,21,n);if(i)return i}return Oo(t,19,n)}var KV={};A(KV,{getRenameInfo:()=>o4t,nodeIsEligibleForRename:()=>YJe});function o4t(e,t,n,i){let s=DU(wf(t,n));if(YJe(s)){let o=c4t(s,e.getTypeChecker(),t,e,i);if(o)return o}return zee(v.You_cannot_rename_this_element)}function c4t(e,t,n,i,s){let o=t.getSymbolAtLocation(e);if(!o){if(No(e)){let D=NU(e,t);if(D&&(D.flags&128||D.flags&1048576&&wi(D.types,w=>!!(w.flags&128))))return mTe(e.text,e.text,"string","",e,n)}else if(aQ(e)){let D=Hc(e);return mTe(D,D,"label","",e,n)}return}let{declarations:u}=o;if(!u||u.length===0)return;if(u.some(D=>l4t(i,D)))return zee(v.You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library);if(He(e)&&e.escapedText==="default"&&o.parent&&o.parent.flags&1536)return;if(No(e)&&bR(e))return s.allowRenameOfImportPath?_4t(e,n,o):void 0;let m=u4t(n,o,t,s);if(m)return zee(m);let d=zv.getSymbolKind(t,o,e),S=z0e(e)||zp(e)&&e.parent.kind===167?Zd(Qd(e)):void 0,E=S||t.symbolToString(o),x=S||t.getFullyQualifiedName(o);return mTe(E,x,d,zv.getSymbolModifiers(t,o),e,n)}function l4t(e,t){let n=t.getSourceFile();return e.isSourceFileDefaultLibrary(n)&&Ic(n.fileName,".d.ts")}function u4t(e,t,n,i){if(!i.providePrefixAndSuffixTextForRename&&t.flags&2097152){let u=t.declarations&&Ln(t.declarations,m=>_f(m));u&&!u.propertyName&&(t=n.getAliasedSymbol(t))}let{declarations:s}=t;if(!s)return;let o=GJe(e.path);if(o===void 0)return Pt(s,u=>CM(u.getSourceFile().path))?v.You_cannot_rename_elements_that_are_defined_in_a_node_modules_folder:void 0;for(let u of s){let m=GJe(u.getSourceFile().path);if(m){let d=Math.min(o.length,m.length);for(let S=0;S<=d;S++)if(c_(o[S],m[S])!==0)return v.You_cannot_rename_elements_that_are_defined_in_another_node_modules_folder}}}function GJe(e){let t=hu(e),n=t.lastIndexOf("node_modules");if(n!==-1)return t.slice(0,n+2)}function _4t(e,t,n){if(!vu(e.text))return zee(v.You_cannot_rename_a_module_via_a_global_import);let i=n.declarations&&Ln(n.declarations,Ji);if(!i)return;let s=Wc(e.text,"/index")||Wc(e.text,"/index.js")?void 0:Kce(of(i.fileName),"/index"),o=s===void 0?i.fileName:s,u=s===void 0?"module":"directory",m=e.text.lastIndexOf("/")+1,d=zu(e.getStart(t)+1+m,e.text.length-m);return{canRename:!0,fileToRename:o,kind:u,displayName:o,fullDisplayName:e.text,kindModifiers:"",triggerSpan:d}}function mTe(e,t,n,i,s,o){return{canRename:!0,fileToRename:void 0,kind:n,displayName:e,fullDisplayName:t,kindModifiers:i,triggerSpan:f4t(s,o)}}function zee(e){return{canRename:!1,localizedErrorMessage:Ms(e)}}function f4t(e,t){let n=e.getStart(t),i=e.getWidth(t);return No(e)&&(n+=1,i-=2),zu(n,i)}function YJe(e){switch(e.kind){case 80:case 81:case 11:case 15:case 110:return!0;case 9:return CU(e);default:return!1}}var YM={};A(YM,{getArgumentInfoForCompletions:()=>h4t,getSignatureHelpItems:()=>p4t});function p4t(e,t,n,i,s){let o=e.getTypeChecker(),u=wU(t,n);if(!u)return;let m=!!i&&i.kind==="characterTyped";if(m&&(ik(t,n,u)||Bv(t,n)))return;let d=!!i&&i.kind==="invoked",S=D4t(u,n,t,o,d);if(!S)return;s.throwIfCancellationRequested();let E=d4t(S,o,t,u,m);return s.throwIfCancellationRequested(),E?o.runWithCancellationToken(s,x=>E.kind===0?nqe(E.candidates,E.resolvedSignature,S,t,x):I4t(E.symbol,S,t,x)):Af(t)?g4t(S,e,s):void 0}function d4t({invocation:e,argumentCount:t},n,i,s,o){switch(e.kind){case 0:{if(o&&!m4t(s,e.node,i))return;let u=[],m=n.getResolvedSignatureForSignatureHelp(e.node,u,t);return u.length===0?void 0:{kind:0,candidates:u,resolvedSignature:m}}case 1:{let{called:u}=e;if(o&&!KJe(s,i,He(u)?u.parent:u))return;let m=gQ(u,t,n);if(m.length!==0)return{kind:0,candidates:m,resolvedSignature:Ma(m)};let d=n.getSymbolAtLocation(u);return d&&{kind:1,symbol:d}}case 2:return{kind:0,candidates:[e.signature],resolvedSignature:e.signature};default:return M.assertNever(e)}}function m4t(e,t,n){if(!Ig(t))return!1;let i=t.getChildren(n);switch(e.kind){case 21:return Es(i,e);case 28:{let s=PU(e);return!!s&&Es(i,s)}case 30:return KJe(e,n,t.expression);default:return!1}}function g4t(e,t,n){if(e.invocation.kind===2)return;let i=tqe(e.invocation),s=Wn(i)?i.name.text:void 0,o=t.getTypeChecker();return s===void 0?void 0:yi(t.getSourceFiles(),u=>yi(u.getNamedDeclarations().get(s),m=>{let d=m.symbol&&o.getTypeOfSymbolAtLocation(m.symbol,m),S=d&&d.getCallSignatures();if(S&&S.length)return o.runWithCancellationToken(n,E=>nqe(S,S[0],e,u,E,!0))}))}function KJe(e,t,n){let i=e.getFullStart(),s=e.parent;for(;s;){let o=iu(i,t,s,!0);if(o)return Zp(n,o);s=s.parent}return M.fail("Could not find preceding token")}function h4t(e,t,n,i){let s=QJe(e,t,n,i);return!s||s.isTypeParameterList||s.invocation.kind!==0?void 0:{invocation:s.invocation.node,argumentCount:s.argumentCount,argumentIndex:s.argumentIndex}}function XJe(e,t,n,i){let s=y4t(e,n,i);if(!s)return;let{list:o,argumentIndex:u}=s,m=A4t(i,o);u!==0&&M.assertLessThan(u,m);let d=P4t(o,n);return{list:o,argumentIndex:u,argumentCount:m,argumentsSpan:d}}function y4t(e,t,n){if(e.kind===30||e.kind===21)return{list:w4t(e.parent,e,t),argumentIndex:0};{let i=PU(e);return i&&{list:i,argumentIndex:C4t(n,i,e)}}}function QJe(e,t,n,i){let{parent:s}=e;if(Ig(s)){let o=s,u=XJe(e,t,n,i);if(!u)return;let{list:m,argumentIndex:d,argumentCount:S,argumentsSpan:E}=u;return{isTypeParameterList:!!s.typeArguments&&s.typeArguments.pos===m.pos,invocation:{kind:0,node:o},argumentsSpan:E,argumentIndex:d,argumentCount:S}}else{if(wA(e)&&hE(s))return pM(e,t,n)?hTe(s,0,n):void 0;if(IA(e)&&s.parent.kind===215){let o=s,u=o.parent;M.assert(o.kind===228);let m=pM(e,t,n)?0:1;return hTe(u,m,n)}else if(PO(s)&&hE(s.parent.parent)){let o=s,u=s.parent.parent;if(kj(e)&&!pM(e,t,n))return;let m=o.parent.templateSpans.indexOf(o),d=k4t(m,e,t,n);return hTe(u,d,n)}else if(__(s)){let o=s.attributes.pos,u=Ja(n.text,s.attributes.end,!1);return{isTypeParameterList:!1,invocation:{kind:0,node:s},argumentsSpan:zu(o,u-o),argumentIndex:0,argumentCount:1}}else{let o=hQ(e,n);if(o){let{called:u,nTypeArguments:m}=o,d={kind:1,called:u},S=Il(u.getStart(n),e.end);return{isTypeParameterList:!0,invocation:d,argumentsSpan:S,argumentIndex:m,argumentCount:m+1}}return}}}function v4t(e,t,n,i){return S4t(e,t,n,i)||QJe(e,t,n,i)}function ZJe(e){return Pn(e.parent)?ZJe(e.parent):e}function gTe(e){return Pn(e.left)?gTe(e.left)+1:2}function S4t(e,t,n,i){let s=b4t(e);if(s===void 0)return;let o=T4t(s,n,t,i);if(o===void 0)return;let{contextualType:u,argumentIndex:m,argumentCount:d,argumentsSpan:S}=o,E=u.getNonNullableType(),x=E.symbol;if(x===void 0)return;let D=vc(E.getCallSignatures());return D===void 0?void 0:{isTypeParameterList:!1,invocation:{kind:2,signature:D,node:e,symbol:E4t(x)},argumentsSpan:S,argumentIndex:m,argumentCount:d}}function b4t(e){switch(e.kind){case 21:case 28:return e;default:return Pr(e.parent,t=>ns(t)?!0:Xa(t)||Yp(t)||Lv(t)?!1:"quit")}}function T4t(e,t,n,i){let{parent:s}=e;switch(s.kind){case 217:case 174:case 218:case 219:let o=XJe(e,n,t,i);if(!o)return;let{argumentIndex:u,argumentCount:m,argumentsSpan:d}=o,S=ul(s)?i.getContextualTypeForObjectLiteralElement(s):i.getContextualType(s);return S&&{contextualType:S,argumentIndex:u,argumentCount:m,argumentsSpan:d};case 226:{let E=ZJe(s),x=i.getContextualType(E),D=e.kind===21?0:gTe(s)-1,w=gTe(E);return x&&{contextualType:x,argumentIndex:D,argumentCount:w,argumentsSpan:df(s)}}default:return}}function E4t(e){return e.name==="__type"&&yi(e.declarations,t=>{var n;return Jh(t)?(n=ai(t.parent,Zm))==null?void 0:n.symbol:void 0})||e}function x4t(e,t){let n=t.getTypeAtLocation(e.expression);if(t.isTupleType(n)){let{elementFlags:i,fixedLength:s}=n.target;if(s===0)return 0;let o=Bo(i,u=>!(u&1));return o<0?s:o}return 0}function C4t(e,t,n){return eqe(e,t,n)}function A4t(e,t){return eqe(e,t,void 0)}function eqe(e,t,n){let i=t.getChildren(),s=0,o=!1;for(let u of i){if(n&&u===n)return!o&&u.kind===28&&s++,s;if(Ad(u)){s+=x4t(u,e),o=!0;continue}if(u.kind!==28){s++,o=!0;continue}if(o){o=!1;continue}s++}return n?s:i.length&&Va(i).kind===28?s+1:s}function k4t(e,t,n,i){return M.assert(n>=t.getStart(),"Assumed 'position' could not occur before node."),Que(t)?pM(t,n,i)?0:e+2:e+1}function hTe(e,t,n){let i=wA(e.template)?1:e.template.templateSpans.length+1;return t!==0&&M.assertLessThan(t,i),{isTypeParameterList:!1,invocation:{kind:0,node:e},argumentsSpan:N4t(e,n),argumentIndex:t,argumentCount:i}}function P4t(e,t){let n=e.getFullStart(),i=Ja(t.text,e.getEnd(),!1);return zu(n,i-n)}function N4t(e,t){let n=e.template,i=n.getStart(),s=n.getEnd();return n.kind===228&&Va(n.templateSpans).literal.getFullWidth()===0&&(s=Ja(t.text,s,!1)),zu(i,s-i)}function D4t(e,t,n,i,s){for(let o=e;!Ji(o)&&(s||!Vs(o));o=o.parent){M.assert(Zp(o.parent,o),"Not a subspan",()=>`Child: ${M.formatSyntaxKind(o.kind)}, parent: ${M.formatSyntaxKind(o.parent.kind)}`);let u=v4t(o,t,n,i);if(u)return u}}function w4t(e,t,n){let i=e.getChildren(n),s=i.indexOf(t);return M.assert(s>=0&&i.length>s+1),i[s+1]}function tqe(e){return e.kind===0?c9(e.node):e.called}function rqe(e){return e.kind===0?e.node:e.kind===1?e.called:e.node}var XV=70246400;function nqe(e,t,{isTypeParameterList:n,argumentCount:i,argumentsSpan:s,invocation:o,argumentIndex:u},m,d,S){var E;let x=rqe(o),D=o.kind===2?o.symbol:d.getSymbolAtLocation(tqe(o))||S&&((E=t.declaration)==null?void 0:E.symbol),w=D?S6(d,D,S?m:void 0,void 0):ve,R=Cr(e,q=>R4t(q,w,n,d,x,m));u!==0&&M.assertLessThan(u,i);let L=0,F=0;for(let q=0;q<R.length;q++){let ee=R[q];if(e[q]===t&&(L=F,ee.length>1)){let W=0;for(let pe of ee){if(pe.isVariadic||pe.parameters.length>=i){L=F+W;break}W++}}F+=ee.length}M.assert(L!==-1);let J={items:M_(R,ec),applicableSpan:s,selectedItemIndex:L,argumentIndex:u,argumentCount:i},G=J.items[L];if(G.isVariadic){let q=Bo(G.parameters,ee=>!!ee.isRest);-1<q&&q<G.parameters.length-1?J.argumentIndex=G.parameters.length:J.argumentIndex=Math.min(J.argumentIndex,G.parameters.length-1)}return J}function I4t(e,{argumentCount:t,argumentsSpan:n,invocation:i,argumentIndex:s},o,u){let m=u.getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(e);return m?{items:[O4t(e,m,u,rqe(i),o)],applicableSpan:n,selectedItemIndex:0,argumentIndex:s,argumentCount:t}:void 0}function O4t(e,t,n,i,s){let o=S6(n,e),u=v2(),m=t.map(x=>sqe(x,n,i,s,u)),d=e.getDocumentationComment(n),S=e.getJsDocTags(n);return{isVariadic:!1,prefixDisplayParts:[...o,C_(30)],suffixDisplayParts:[C_(32)],separatorDisplayParts:iqe,parameters:m,documentation:d,tags:S}}var iqe=[C_(28),Zc()];function R4t(e,t,n,i,s,o){let u=(n?L4t:F4t)(e,i,s,o);return Cr(u,({isVariadic:m,parameters:d,prefix:S,suffix:E})=>{let x=[...t,...S],D=[...E,...M4t(e,s,i)],w=e.getDocumentationComment(i),R=e.getJsDocTags();return{isVariadic:m,prefixDisplayParts:x,suffixDisplayParts:D,separatorDisplayParts:iqe,parameters:d,documentation:w,tags:R}})}function M4t(e,t,n){return _S(i=>{i.writePunctuation(":"),i.writeSpace(" ");let s=n.getTypePredicateOfSignature(e);s?n.writeTypePredicate(s,t,void 0,i):n.writeType(n.getReturnTypeOfSignature(e),t,void 0,i)})}function L4t(e,t,n,i){let s=(e.target||e).typeParameters,o=v2(),u=(s||ve).map(d=>sqe(d,t,n,i,o)),m=e.thisParameter?[t.symbolToParameterDeclaration(e.thisParameter,n,XV)]:[];return t.getExpandedParameters(e).map(d=>{let S=U.createNodeArray([...m,...Cr(d,x=>t.symbolToParameterDeclaration(x,n,XV))]),E=_S(x=>{o.writeList(2576,S,i,x)});return{isVariadic:!1,parameters:u,prefix:[C_(30)],suffix:[C_(32),...E]}})}function F4t(e,t,n,i){let s=v2(),o=_S(d=>{if(e.typeParameters&&e.typeParameters.length){let S=U.createNodeArray(e.typeParameters.map(E=>t.typeParameterToDeclaration(E,n,XV)));s.writeList(53776,S,i,d)}}),u=t.getExpandedParameters(e),m=t.hasEffectiveRestParameter(e)?u.length===1?d=>!0:d=>{var S;return!!(d.length&&((S=ai(d[d.length-1],jh))==null?void 0:S.links.checkFlags)&32768)}:d=>!1;return u.map(d=>({isVariadic:m(d),parameters:d.map(S=>j4t(S,t,n,i,s)),prefix:[...o,C_(21)],suffix:[C_(22)]}))}function j4t(e,t,n,i,s){let o=_S(d=>{let S=t.symbolToParameterDeclaration(e,n,XV);s.writeNode(4,S,i,d)}),u=t.isOptionalParameter(e.valueDeclaration),m=jh(e)&&!!(e.links.checkFlags&32768);return{name:e.name,documentation:e.getDocumentationComment(t),displayParts:o,isOptional:u,isRest:m}}function sqe(e,t,n,i,s){let o=_S(u=>{let m=t.typeParameterToDeclaration(e,n,XV);s.writeNode(4,m,i,u)});return{name:e.symbol.name,documentation:e.symbol.getDocumentationComment(t),displayParts:o,isOptional:!1,isRest:!1}}var Wee={};A(Wee,{getSmartSelectionRange:()=>B4t});function B4t(e,t){var n,i;let s={textSpan:Il(t.getFullStart(),t.getEnd())},o=t;e:for(;;){let d=J4t(o);if(!d.length)break;for(let S=0;S<d.length;S++){let E=d[S-1],x=d[S],D=d[S+1];if(ob(x,t,!0)>e)break e;let w=Dh(L1(t.text,x.end));if(w&&w.kind===2&&m(w.pos,w.end),U4t(t,e,x)){if(W$(x)&&Go(o)&&!Ed(x.getStart(t),x.getEnd(),t)&&u(x.getStart(t),x.getEnd()),Vs(x)||PO(x)||IA(x)||kj(x)||E&&IA(E)||Ru(x)&&_l(o)||xN(x)&&Ru(o)||Ei(x)&&xN(o)&&d.length===1||Tb(x)||A0(x)||f2(x)){o=x;break}if(PO(o)&&D&&N5(D)){let J=x.getFullStart()-2,G=D.getStart()+1;u(J,G)}let R=xN(x)&&q4t(E)&&z4t(D)&&!Ed(E.getStart(),D.getStart(),t),L=R?E.getEnd():x.getStart(),F=R?D.getStart():W4t(t,x);if(Pp(x)&&((n=x.jsDoc)!=null&&n.length)&&u(Ma(x.jsDoc).getStart(),F),xN(x)){let J=x.getChildren()[0];J&&Pp(J)&&((i=J.jsDoc)!=null&&i.length)&&J.getStart()!==x.pos&&(L=Math.min(L,Ma(J.jsDoc).getStart()))}u(L,F),(La(x)||XC(x))&&u(L+1,F-1),o=x;break}if(S===d.length-1)break e}}return s;function u(d,S){if(d!==S){let E=Il(d,S);(!s||!KN(E,s.textSpan)&&Due(E,e))&&(s={textSpan:E,...s&&{parent:s}})}}function m(d,S){u(d,S);let E=d;for(;t.text.charCodeAt(E)===47;)E++;u(E,S)}}function U4t(e,t,n){return M.assert(n.pos<=t),t<n.end?!0:n.getEnd()===t?wf(e,t).pos<n.end:!1}var V4t=Jp(Yc,ru);function J4t(e){var t;if(Ji(e))return KM(e.getChildAt(0).getChildren(),V4t);if(o2(e)){let[n,...i]=e.getChildren(),s=M.checkDefined(i.pop());M.assertEqual(n.kind,19),M.assertEqual(s.kind,20);let o=KM(i,m=>m===e.readonlyToken||m.kind===148||m===e.questionToken||m.kind===58),u=KM(o,({kind:m})=>m===23||m===168||m===24);return[n,XM($ee(u,({kind:m})=>m===59)),s]}if(Nf(e)){let n=KM(e.getChildren(),u=>u===e.name||Es(e.modifiers,u)),i=((t=n[0])==null?void 0:t.kind)===320?n[0]:void 0,s=i?n.slice(1):n,o=$ee(s,({kind:u})=>u===59);return i?[i,XM(o)]:o}if(ns(e)){let n=KM(e.getChildren(),s=>s===e.dotDotDotToken||s===e.name),i=KM(n,s=>s===n[0]||s===e.questionToken);return $ee(i,({kind:s})=>s===64)}return Xa(e)?$ee(e.getChildren(),({kind:n})=>n===64):e.getChildren()}function KM(e,t){let n=[],i;for(let s of e)t(s)?(i=i||[],i.push(s)):(i&&(n.push(XM(i)),i=void 0),n.push(s));return i&&n.push(XM(i)),n}function $ee(e,t,n=!0){if(e.length<2)return e;let i=Bo(e,t);if(i===-1)return e;let s=e.slice(0,i),o=e[i],u=Va(e),m=n&&u.kind===27,d=e.slice(i+1,m?e.length-1:void 0),S=cn([s.length?XM(s):void 0,o,d.length?XM(d):void 0]);return m?S.concat(u):S}function XM(e){return M.assertGreaterThanOrEqual(e.length,1),qg(Cb.createSyntaxList(e),e[0].pos,Va(e).end)}function q4t(e){let t=e&&e.kind;return t===19||t===23||t===21||t===286}function z4t(e){let t=e&&e.kind;return t===20||t===24||t===22||t===287}function W4t(e,t){switch(t.kind){case 341:case 338:case 348:case 346:case 343:return e.getLineEndOfPosition(t.getStart());default:return t.getEnd()}}var zv={};A(zv,{getSymbolDisplayPartsDocumentationAndSymbolKind:()=>H4t,getSymbolKind:()=>oqe,getSymbolModifiers:()=>$4t});var aqe=70246400;function oqe(e,t,n){let i=cqe(e,t,n);if(i!=="")return i;let s=cN(t);return s&32?Pc(t,231)?"local class":"class":s&384?"enum":s&524288?"type":s&64?"interface":s&262144?"type parameter":s&8?"enum member":s&2097152?"alias":s&1536?"module":i}function cqe(e,t,n){let i=e.getRootSymbols(t);if(i.length===1&&Ma(i).flags&8192&&e.getTypeOfSymbolAtLocation(t,n).getNonNullableType().getCallSignatures().length!==0)return"method";if(e.isUndefinedSymbol(t))return"var";if(e.isArgumentsSymbol(t))return"local var";if(n.kind===110&&Ct(n)||aE(n))return"parameter";let s=cN(t);if(s&3)return jQ(t)?"parameter":t.valueDeclaration&&zP(t.valueDeclaration)?"const":t.valueDeclaration&&rR(t.valueDeclaration)?"using":t.valueDeclaration&&tR(t.valueDeclaration)?"await using":kt(t.declarations,Q5)?"let":_qe(t)?"local var":"var";if(s&16)return _qe(t)?"local function":"function";if(s&32768)return"getter";if(s&65536)return"setter";if(s&8192)return"method";if(s&16384)return"constructor";if(s&131072)return"index";if(s&4){if(s&33554432&&t.links.checkFlags&6){let o=kt(e.getRootSymbols(t),u=>{if(u.getFlags()&98311)return"property"});return o||(e.getTypeOfSymbolAtLocation(t,n).getCallSignatures().length?"method":"property")}return"property"}return""}function lqe(e){if(e.declarations&&e.declarations.length){let[t,...n]=e.declarations,i=wt(n)&&sV(t)&&Pt(n,o=>!sV(o))?65536:0,s=m6(t,i);if(s)return s.split(",")}return[]}function $4t(e,t){if(!t)return"";let n=new Set(lqe(t));if(t.flags&2097152){let i=e.getAliasedSymbol(t);i!==t&&kt(lqe(i),s=>{n.add(s)})}return t.flags&16777216&&n.add("optional"),n.size>0?Is(n.values()).join(","):""}function uqe(e,t,n,i,s,o,u,m){var d;let S=[],E=[],x=[],D=cN(t),w=u&1?cqe(e,t,s):"",R=!1,L=s.kind===110&&l9(s)||aE(s),F,J,G=!1;if(s.kind===110&&!L)return{displayParts:[mp(110)],documentation:[],symbolKind:"primitive type",tags:void 0};if(w!==""||D&32||D&2097152){if(w==="getter"||w==="setter"){let de=Ln(t.declarations,Ae=>Ae.name===s);if(de)switch(de.kind){case 177:w="getter";break;case 178:w="setter";break;case 172:w="accessor";break;default:M.assertNever(de)}else w="property"}let le;if(o??(o=L?e.getTypeAtLocation(s):e.getTypeOfSymbolAtLocation(t,s)),s.parent&&s.parent.kind===211){let de=s.parent.name;(de===s||de&&de.getFullWidth()===0)&&(s=s.parent)}let me;if(Ig(s)?me=s:(rQ(s)||p6(s)||s.parent&&(__(s.parent)||hE(s.parent))&&Bs(t.valueDeclaration))&&(me=s.parent),me){le=e.getResolvedSignature(me);let de=me.kind===214||ea(me)&&me.expression.kind===108,Ae=de?o.getConstructSignatures():o.getCallSignatures();if(le&&!Es(Ae,le.target)&&!Es(Ae,le)&&(le=Ae.length?Ae[0]:void 0),le){switch(de&&D&32?(w="constructor",re(o.symbol,w)):D&2097152?(w="alias",ue(w),S.push(Zc()),de&&(le.flags&4&&(S.push(mp(128)),S.push(Zc())),S.push(mp(105)),S.push(Zc())),K(t)):re(t,w),w){case"JSX attribute":case"property":case"var":case"const":case"let":case"parameter":case"local var":S.push(C_(59)),S.push(Zc()),!(Kn(o)&16)&&o.symbol&&(wn(S,S6(e,o.symbol,i,void 0,5)),S.push(XN())),de&&(le.flags&4&&(S.push(mp(128)),S.push(Zc())),S.push(mp(105)),S.push(Zc())),ce(le,Ae,262144);break;default:ce(le,Ae)}R=!0,G=Ae.length>1}}else if(uQ(s)&&!(D&98304)||s.kind===137&&s.parent.kind===176){let de=s.parent;if(t.declarations&&Ln(t.declarations,xe=>xe===(s.kind===137?de.parent:de))){let xe=de.kind===176?o.getNonNullableType().getConstructSignatures():o.getNonNullableType().getCallSignatures();e.isImplementationOfOverload(de)?le=xe[0]:le=e.getSignatureFromDeclaration(de),de.kind===176?(w="constructor",re(o.symbol,w)):re(de.kind===179&&!(o.symbol.flags&2048||o.symbol.flags&4096)?o.symbol:t,w),le&&ce(le,xe),R=!0,G=xe.length>1}}}if(D&32&&!R&&!L&&(W(),Pc(t,231)?ue("local class"):S.push(mp(86)),S.push(Zc()),K(t),ne(t,n)),D&64&&u&2&&(ee(),S.push(mp(120)),S.push(Zc()),K(t),ne(t,n)),D&524288&&u&2&&(ee(),S.push(mp(156)),S.push(Zc()),K(t),ne(t,n),S.push(Zc()),S.push(v6(64)),S.push(Zc()),wn(S,vM(e,s.parent&&Qm(s.parent)?e.getTypeAtLocation(s.parent):e.getDeclaredTypeOfSymbol(t),i,8388608))),D&384&&(ee(),Pt(t.declarations,le=>bb(le)&&KT(le))&&(S.push(mp(87)),S.push(Zc())),S.push(mp(94)),S.push(Zc()),K(t)),D&1536&&!L){ee();let le=Pc(t,267),me=le&&le.name&&le.name.kind===80;S.push(mp(me?145:144)),S.push(Zc()),K(t)}if(D&262144&&u&2)if(ee(),S.push(C_(21)),S.push(td("type parameter")),S.push(C_(22)),S.push(Zc()),K(t),t.parent)pe(),K(t.parent,i),ne(t.parent,i);else{let le=Pc(t,168);if(le===void 0)return M.fail();let me=le.parent;if(me)if(Bs(me)){pe();let de=e.getSignatureFromDeclaration(me);me.kind===180?(S.push(mp(105)),S.push(Zc())):me.kind!==179&&me.name&&K(me.symbol),wn(S,VQ(e,de,n,32))}else im(me)&&(pe(),S.push(mp(156)),S.push(Zc()),K(me.symbol),ne(me.symbol,n))}if(D&8){w="enum member",re(t,"enum member");let le=(d=t.declarations)==null?void 0:d[0];if(le?.kind===306){let me=e.getConstantValue(le);me!==void 0&&(S.push(Zc()),S.push(v6(64)),S.push(Zc()),S.push(Jf(N_e(me),typeof me=="number"?7:8)))}}if(t.flags&2097152){if(ee(),!R||E.length===0&&x.length===0){let le=e.getAliasedSymbol(t);if(le!==t&&le.declarations&&le.declarations.length>0){let me=le.declarations[0],de=Ps(me);if(de&&!R){let Ae=G5(me)&&li(me,128),xe=t.name!=="default"&&!Ae,te=uqe(e,le,Ur(me),i,de,o,u,xe?t:le);S.push(...te.displayParts),S.push(XN()),F=te.documentation,J=te.tags}else F=le.getContextualDocumentationComment(me,e),J=le.getJsDocTags(e)}}if(t.declarations)switch(t.declarations[0].kind){case 270:S.push(mp(95)),S.push(Zc()),S.push(mp(145));break;case 277:S.push(mp(95)),S.push(Zc()),S.push(mp(t.declarations[0].isExportEquals?64:90));break;case 281:S.push(mp(95));break;default:S.push(mp(102))}S.push(Zc()),K(t),kt(t.declarations,le=>{if(le.kind===271){let me=le;if(cb(me))S.push(Zc()),S.push(v6(64)),S.push(Zc()),S.push(mp(149)),S.push(C_(21)),S.push(Jf(Hc(II(me)),8)),S.push(C_(22));else{let de=e.getSymbolAtLocation(me.moduleReference);de&&(S.push(Zc()),S.push(v6(64)),S.push(Zc()),K(de,i))}return!0}})}if(!R)if(w!==""){if(o){if(L?(ee(),S.push(mp(110))):re(t,w),w==="property"||w==="accessor"||w==="getter"||w==="setter"||w==="JSX attribute"||D&3||w==="local var"||w==="index"||w==="using"||w==="await using"||L){if(S.push(C_(59)),S.push(Zc()),o.symbol&&o.symbol.flags&262144&&w!=="index"){let le=_S(me=>{let de=e.typeParameterToDeclaration(o,i,aqe);q().writeNode(4,de,Ur(ks(i)),me)});wn(S,le)}else wn(S,vM(e,o,i));if(jh(t)&&t.links.target&&jh(t.links.target)&&t.links.target.links.tupleLabelDeclaration){let le=t.links.target.links.tupleLabelDeclaration;M.assertNode(le.name,He),S.push(Zc()),S.push(C_(21)),S.push(td(Nn(le.name))),S.push(C_(22))}}else if(D&16||D&8192||D&16384||D&131072||D&98304||w==="method"){let le=o.getNonNullableType().getCallSignatures();le.length&&(ce(le[0],le),G=le.length>1)}}}else w=oqe(e,t,s);if(E.length===0&&!G&&(E=t.getContextualDocumentationComment(i,e)),E.length===0&&D&4&&t.parent&&t.declarations&&kt(t.parent.declarations,le=>le.kind===307))for(let le of t.declarations){if(!le.parent||le.parent.kind!==226)continue;let me=e.getSymbolAtLocation(le.parent.right);if(me&&(E=me.getDocumentationComment(e),x=me.getJsDocTags(e),E.length>0))break}if(E.length===0&&He(s)&&t.valueDeclaration&&Xa(t.valueDeclaration)){let le=t.valueDeclaration,me=le.parent,de=le.propertyName||le.name;if(He(de)&&Yp(me)){let Ae=Qd(de),xe=e.getTypeAtLocation(me);E=yi(xe.isUnion()?xe.types:[xe],te=>{let he=te.getProperty(Ae);return he?he.getDocumentationComment(e):void 0})||ve}}return x.length===0&&!G&&(x=t.getContextualJsDocTags(i,e)),E.length===0&&F&&(E=F),x.length===0&&J&&(x=J),{displayParts:S,documentation:E,symbolKind:w,tags:x.length===0?void 0:x};function q(){return v2()}function ee(){S.length&&S.push(XN()),W()}function W(){m&&(ue("alias"),S.push(Zc()))}function pe(){S.push(Zc()),S.push(mp(103)),S.push(Zc())}function K(le,me){let de;m&&le===t&&(le=m),w==="index"&&(de=e.getIndexInfosOfIndexSymbol(le));let Ae=[];le.flags&131072&&de?(le.parent&&(Ae=S6(e,le.parent)),Ae.push(C_(23)),de.forEach((xe,te)=>{Ae.push(...vM(e,xe.keyType)),te!==de.length-1&&(Ae.push(Zc()),Ae.push(C_(52)),Ae.push(Zc()))}),Ae.push(C_(24))):Ae=S6(e,le,me||n,void 0,7),wn(S,Ae),t.flags&16777216&&S.push(C_(58))}function re(le,me){ee(),me&&(ue(me),le&&!Pt(le.declarations,de=>pc(de)||(ic(de)||eu(de))&&!de.name)&&(S.push(Zc()),K(le)))}function ue(le){switch(le){case"var":case"function":case"let":case"const":case"constructor":case"using":case"await using":S.push(BQ(le));return;default:S.push(C_(21)),S.push(BQ(le)),S.push(C_(22));return}}function ce(le,me,de=0){wn(S,VQ(e,le,i,de|32)),me.length>1&&(S.push(Zc()),S.push(C_(21)),S.push(v6(40)),S.push(Jf((me.length-1).toString(),7)),S.push(Zc()),S.push(td(me.length===2?"overload":"overloads")),S.push(C_(22))),E=le.getDocumentationComment(e),x=le.getJsDocTags(),me.length>1&&E.length===0&&x.length===0&&(E=me[0].getDocumentationComment(e),x=me[0].getJsDocTags().filter(Ae=>Ae.name!=="deprecated"))}function ne(le,me){let de=_S(Ae=>{let xe=e.symbolToTypeParameterDeclarations(le,me,aqe);q().writeList(53776,xe,Ur(ks(me)),Ae)});wn(S,de)}}function H4t(e,t,n,i,s,o=S2(s),u){return uqe(e,t,n,i,s,void 0,o,u)}function _qe(e){return e.parent?!1:kt(e.declarations,t=>{if(t.kind===218)return!0;if(t.kind!==260&&t.kind!==262)return!1;for(let n=t.parent;!XT(n);n=n.parent)if(n.kind===307||n.kind===268)return!1;return!0})}var Sn={};A(Sn,{ChangeTracker:()=>K4t,LeadingTriviaOption:()=>dqe,TrailingTriviaOption:()=>mqe,applyChanges:()=>TTe,assignPositionsToNode:()=>Kee,createWriter:()=>hqe,deleteNode:()=>w0,isThisTypeAnnotatable:()=>Y4t,isValidLocationToAddComment:()=>yqe});function fqe(e){let t=e.__pos;return M.assert(typeof t=="number"),t}function yTe(e,t){M.assert(typeof t=="number"),e.__pos=t}function pqe(e){let t=e.__end;return M.assert(typeof t=="number"),t}function vTe(e,t){M.assert(typeof t=="number"),e.__end=t}var dqe=(e=>(e[e.Exclude=0]="Exclude",e[e.IncludeAll=1]="IncludeAll",e[e.JSDoc=2]="JSDoc",e[e.StartLine=3]="StartLine",e))(dqe||{}),mqe=(e=>(e[e.Exclude=0]="Exclude",e[e.ExcludeWhitespace=1]="ExcludeWhitespace",e[e.Include=2]="Include",e))(mqe||{});function gqe(e,t){return Ja(e,t,!1,!0)}function G4t(e,t){let n=t;for(;n<e.length;){let i=e.charCodeAt(n);if(wg(i)){n++;continue}return i===47}return!1}var QM={leadingTriviaOption:0,trailingTriviaOption:0};function ZM(e,t,n,i){return{pos:A2(e,t,i),end:lD(e,n,i)}}function A2(e,t,n,i=!1){var s,o;let{leadingTriviaOption:u}=n;if(u===0)return t.getStart(e);if(u===3){let w=t.getStart(e),R=om(w,e);return cM(t,R)?R:w}if(u===2){let w=mH(t,e.text);if(w?.length)return om(w[0].pos,e)}let m=t.getFullStart(),d=t.getStart(e);if(m===d)return d;let S=om(m,e);if(om(d,e)===S)return u===1?m:d;if(i){let w=((s=Ty(e.text,m))==null?void 0:s[0])||((o=L1(e.text,m))==null?void 0:o[0]);if(w)return Ja(e.text,w.end,!0,!0)}let x=m>0?1:0,D=q1($I(e,S)+x,e);return D=gqe(e.text,D),q1($I(e,D),e)}function STe(e,t,n){let{end:i}=t,{trailingTriviaOption:s}=n;if(s===2){let o=L1(e.text,i);if(o){let u=$I(e,t.end);for(let m of o){if(m.kind===2||$I(e,m.pos)>u)break;if($I(e,m.end)>u)return Ja(e.text,m.end,!0,!0)}}}}function lD(e,t,n){var i;let{end:s}=t,{trailingTriviaOption:o}=n;if(o===0)return s;if(o===1){let d=ps(L1(e.text,s),Ty(e.text,s)),S=(i=d?.[d.length-1])==null?void 0:i.end;return S||s}let u=STe(e,t,n);if(u)return u;let m=Ja(e.text,s,!0);return m!==s&&(o===2||v_(e.text.charCodeAt(m-1)))?m:s}function Hee(e,t){return!!t&&!!e.parent&&(t.kind===28||t.kind===27&&e.parent.kind===210)}function Y4t(e){return ic(e)||Tl(e)}var K4t=class wDe{constructor(t,n){this.newLineCharacter=t,this.formatContext=n,this.changes=[],this.classesWithNodesInsertedAtStart=new Map,this.deletedNodes=[]}static fromContext(t){return new wDe(Vv(t.host,t.formatContext.options),t.formatContext)}static with(t,n){let i=wDe.fromContext(t);return n(i),i.getChanges()}pushRaw(t,n){M.assertEqual(t.fileName,n.fileName);for(let i of n.textChanges)this.changes.push({kind:3,sourceFile:t,text:i.newText,range:LU(i.span)})}deleteRange(t,n){this.changes.push({kind:0,sourceFile:t,range:n})}delete(t,n){this.deletedNodes.push({sourceFile:t,node:n})}deleteNode(t,n,i={leadingTriviaOption:1}){this.deleteRange(t,ZM(t,n,n,i))}deleteNodes(t,n,i={leadingTriviaOption:1},s){for(let o of n){let u=A2(t,o,i,s),m=lD(t,o,i);this.deleteRange(t,{pos:u,end:m}),s=!!STe(t,o,i)}}deleteModifier(t,n){this.deleteRange(t,{pos:n.getStart(t),end:Ja(t.text,n.end,!0)})}deleteNodeRange(t,n,i,s={leadingTriviaOption:1}){let o=A2(t,n,s),u=lD(t,i,s);this.deleteRange(t,{pos:o,end:u})}deleteNodeRangeExcludingEnd(t,n,i,s={leadingTriviaOption:1}){let o=A2(t,n,s),u=i===void 0?t.text.length:A2(t,i,s);this.deleteRange(t,{pos:o,end:u})}replaceRange(t,n,i,s={}){this.changes.push({kind:1,sourceFile:t,range:n,options:s,node:i})}replaceNode(t,n,i,s=QM){this.replaceRange(t,ZM(t,n,n,s),i,s)}replaceNodeRange(t,n,i,s,o=QM){this.replaceRange(t,ZM(t,n,i,o),s,o)}replaceRangeWithNodes(t,n,i,s={}){this.changes.push({kind:2,sourceFile:t,range:n,options:s,nodes:i})}replaceNodeWithNodes(t,n,i,s=QM){this.replaceRangeWithNodes(t,ZM(t,n,n,s),i,s)}replaceNodeWithText(t,n,i){this.replaceRangeWithText(t,ZM(t,n,n,QM),i)}replaceNodeRangeWithNodes(t,n,i,s,o=QM){this.replaceRangeWithNodes(t,ZM(t,n,i,o),s,o)}nodeHasTrailingComment(t,n,i=QM){return!!STe(t,n,i)}nextCommaToken(t,n){let i=NE(n,n.parent,t);return i&&i.kind===28?i:void 0}replacePropertyAssignment(t,n,i){let s=this.nextCommaToken(t,n)?"":","+this.newLineCharacter;this.replaceNode(t,n,i,{suffix:s})}insertNodeAt(t,n,i,s={}){this.replaceRange(t,Td(n),i,s)}insertNodesAt(t,n,i,s={}){this.replaceRangeWithNodes(t,Td(n),i,s)}insertNodeAtTopOfFile(t,n,i){this.insertAtTopOfFile(t,n,i)}insertNodesAtTopOfFile(t,n,i){this.insertAtTopOfFile(t,n,i)}insertAtTopOfFile(t,n,i){let s=i3t(t),o={prefix:s===0?void 0:this.newLineCharacter,suffix:(v_(t.text.charCodeAt(s))?"":this.newLineCharacter)+(i?this.newLineCharacter:"")};Rs(n)?this.insertNodesAt(t,s,n,o):this.insertNodeAt(t,s,n,o)}insertNodesAtEndOfFile(t,n,i){this.insertAtEndOfFile(t,n,i)}insertAtEndOfFile(t,n,i){let s=t.end+1,o={prefix:this.newLineCharacter,suffix:this.newLineCharacter+(i?this.newLineCharacter:"")};this.insertNodesAt(t,s,n,o)}insertStatementsInNewFile(t,n,i){this.newFileChanges||(this.newFileChanges=yd()),this.newFileChanges.add(t,{oldFile:i,statements:n})}insertFirstParameter(t,n,i){let s=xo(n);s?this.insertNodeBefore(t,s,i):this.insertNodeAt(t,n.pos,i)}insertNodeBefore(t,n,i,s=!1,o={}){this.insertNodeAt(t,A2(t,n,o),i,this.getOptionsForInsertNodeBefore(n,i,s))}insertNodesBefore(t,n,i,s=!1,o={}){this.insertNodesAt(t,A2(t,n,o),i,this.getOptionsForInsertNodeBefore(n,Ma(i),s))}insertModifierAt(t,n,i,s={}){this.insertNodeAt(t,n,U.createToken(i),s)}insertModifierBefore(t,n,i){return this.insertModifierAt(t,i.getStart(t),n,{suffix:" "})}insertCommentBeforeLine(t,n,i,s){let o=q1(n,t),u=$0e(t.text,o),m=yqe(t,u),d=HN(t,m?u:i),S=t.text.slice(o,u),E=`${m?"":this.newLineCharacter}//${s}${this.newLineCharacter}${S}`;this.insertText(t,d.getStart(t),E)}insertJsdocCommentBefore(t,n,i){let s=n.getStart(t);if(n.jsDoc)for(let m of n.jsDoc)this.deleteRange(t,{pos:om(m.getStart(t),t),end:lD(t,m,{})});let o=WU(t.text,s-1),u=t.text.slice(o,s);this.insertNodeAt(t,s,i,{suffix:this.newLineCharacter+u})}createJSDocText(t,n){let i=va(n.jsDoc,o=>bs(o.comment)?U.createJSDocText(o.comment):o.comment),s=Dh(n.jsDoc);return s&&Ed(s.pos,s.end,t)&&wt(i)===0?void 0:U.createNodeArray(bf(i,U.createJSDocText(`
`)))}replaceJSDocComment(t,n,i){this.insertJsdocCommentBefore(t,X4t(n),U.createJSDocComment(this.createJSDocText(t,n),U.createNodeArray(i)))}addJSDocTags(t,n,i){let s=M_(n.jsDoc,u=>u.tags),o=i.filter(u=>!s.some((m,d)=>{let S=Q4t(m,u);return S&&(s[d]=S),!!S}));this.replaceJSDocComment(t,n,[...s,...o])}filterJSDocTags(t,n,i){this.replaceJSDocComment(t,n,Zn(M_(n.jsDoc,s=>s.tags),i))}replaceRangeWithText(t,n,i){this.changes.push({kind:3,sourceFile:t,range:n,text:i})}insertText(t,n,i){this.replaceRangeWithText(t,Td(n),i)}tryInsertTypeAnnotation(t,n,i){let s;if(Bs(n)){if(s=Oo(n,22,t),!s){if(!pc(n))return!1;s=Ma(n.parameters)}}else s=(n.kind===260?n.exclamationToken:n.questionToken)??n.name;return this.insertNodeAt(t,s.end,i,{prefix:": "}),!0}tryInsertThisTypeAnnotation(t,n,i){let s=Oo(n,21,t).getStart(t)+1,o=n.parameters.length?", ":"";this.insertNodeAt(t,s,i,{prefix:"this: ",suffix:o})}insertTypeParameters(t,n,i){let s=(Oo(n,21,t)||Ma(n.parameters)).getStart(t);this.insertNodesAt(t,s,i,{prefix:"<",suffix:">",joiner:", "})}getOptionsForInsertNodeBefore(t,n,i){return Vi(t)||uu(t)?{suffix:i?this.newLineCharacter+this.newLineCharacter:this.newLineCharacter}:Ei(t)?{suffix:", "}:ns(t)?ns(n)?{suffix:", "}:{}:La(t)&&Yc(t.parent)||Gg(t)?{suffix:", "}:_f(t)?{suffix:","+(i?this.newLineCharacter:" ")}:M.failBadSyntaxKind(t)}insertNodeAtConstructorStart(t,n,i){let s=xo(n.body.statements);!s||!n.body.multiLine?this.replaceConstructorBody(t,n,[i,...n.body.statements]):this.insertNodeBefore(t,s,i)}insertNodeAtConstructorStartAfterSuperCall(t,n,i){let s=Ln(n.body.statements,o=>Du(o)&&Kx(o.expression));!s||!n.body.multiLine?this.replaceConstructorBody(t,n,[...n.body.statements,i]):this.insertNodeAfter(t,s,i)}insertNodeAtConstructorEnd(t,n,i){let s=vc(n.body.statements);!s||!n.body.multiLine?this.replaceConstructorBody(t,n,[...n.body.statements,i]):this.insertNodeAfter(t,s,i)}replaceConstructorBody(t,n,i){this.replaceNode(t,n.body,U.createBlock(i,!0))}insertNodeAtEndOfScope(t,n,i){let s=A2(t,n.getLastToken(),{});this.insertNodeAt(t,s,i,{prefix:v_(t.text.charCodeAt(n.getLastToken().pos))?this.newLineCharacter:this.newLineCharacter+this.newLineCharacter,suffix:this.newLineCharacter})}insertMemberAtStart(t,n,i){this.insertNodeAtStartWorker(t,n,i)}insertNodeAtObjectStart(t,n,i){this.insertNodeAtStartWorker(t,n,i)}insertNodeAtStartWorker(t,n,i){let s=this.guessIndentationFromExistingMembers(t,n)??this.computeIndentationForNewMember(t,n);this.insertNodeAt(t,Gee(n).pos,i,this.getInsertNodeAtStartInsertOptions(t,n,s))}guessIndentationFromExistingMembers(t,n){let i,s=n;for(let o of Gee(n)){if(j9(s,o,t))return;let u=o.getStart(t),m=zl.SmartIndenter.findFirstNonWhitespaceColumn(om(u,t),u,t,this.formatContext.options);if(i===void 0)i=m;else if(m!==i)return;s=o}return i}computeIndentationForNewMember(t,n){let i=n.getStart(t);return zl.SmartIndenter.findFirstNonWhitespaceColumn(om(i,t),i,t,this.formatContext.options)+(this.formatContext.options.indentSize??4)}getInsertNodeAtStartInsertOptions(t,n,i){let o=Gee(n).length===0,u=em(this.classesWithNodesInsertedAtStart,yo(n),{node:n,sourceFile:t}),m=Ca(n)&&(!Kd(t)||!o),d=Ca(n)&&Kd(t)&&o&&!u;return{indentation:i,prefix:(d?",":"")+this.newLineCharacter,suffix:m?",":Yu(n)&&o?";":""}}insertNodeAfterComma(t,n,i){let s=this.insertNodeAfterWorker(t,this.nextCommaToken(t,n)||n,i);this.insertNodeAt(t,s,i,this.getInsertNodeAfterOptions(t,n))}insertNodeAfter(t,n,i){let s=this.insertNodeAfterWorker(t,n,i);this.insertNodeAt(t,s,i,this.getInsertNodeAfterOptions(t,n))}insertNodeAtEndOfList(t,n,i){this.insertNodeAt(t,n.end,i,{prefix:", "})}insertNodesAfter(t,n,i){let s=this.insertNodeAfterWorker(t,n,Ma(i));this.insertNodesAt(t,s,i,this.getInsertNodeAfterOptions(t,n))}insertNodeAfterWorker(t,n,i){return s3t(n,i)&&t.text.charCodeAt(n.end-1)!==59&&this.replaceRange(t,Td(n.end),U.createToken(27)),lD(t,n,{})}getInsertNodeAfterOptions(t,n){let i=this.getInsertNodeAfterOptionsWorker(n);return{...i,prefix:n.end===t.end&&Vi(n)?i.prefix?`
${i.prefix}`:`
`:i.prefix}}getInsertNodeAfterOptionsWorker(t){switch(t.kind){case 263:case 267:return{prefix:this.newLineCharacter,suffix:this.newLineCharacter};case 260:case 11:case 80:return{prefix:", "};case 303:return{suffix:","+this.newLineCharacter};case 95:return{prefix:" "};case 169:return{};default:return M.assert(Vi(t)||D5(t)),{suffix:this.newLineCharacter}}}insertName(t,n,i){if(M.assert(!n.name),n.kind===219){let s=Oo(n,39,t),o=Oo(n,21,t);o?(this.insertNodesAt(t,o.getStart(t),[U.createToken(100),U.createIdentifier(i)],{joiner:" "}),w0(this,t,s)):(this.insertText(t,Ma(n.parameters).getStart(t),`function ${i}(`),this.replaceRange(t,s,U.createToken(22))),n.body.kind!==241&&(this.insertNodesAt(t,n.body.getStart(t),[U.createToken(19),U.createToken(107)],{joiner:" ",suffix:" "}),this.insertNodesAt(t,n.body.end,[U.createToken(27),U.createToken(20)],{joiner:" "}))}else{let s=Oo(n,n.kind===218?100:86,t).end;this.insertNodeAt(t,s,U.createIdentifier(i),{prefix:" "})}}insertExportModifier(t,n){this.insertText(t,n.getStart(t),"export ")}insertImportSpecifierAtIndex(t,n,i,s){let o=i.elements[s-1];o?this.insertNodeInListAfter(t,o,n):this.insertNodeBefore(t,i.elements[0],n,!Ed(i.elements[0].getStart(),i.parent.parent.getStart(),t))}insertNodeInListAfter(t,n,i,s=zl.SmartIndenter.getContainingList(n,t)){if(!s){M.fail("node is not a list element");return}let o=JP(s,n);if(o<0)return;let u=n.getEnd();if(o!==s.length-1){let m=Yi(t,n.end);if(m&&Hee(n,m)){let d=s[o+1],S=gqe(t.text,d.getFullStart()),E=`${Sa(m.kind)}${t.text.substring(m.end,S)}`;this.insertNodesAt(t,S,[i],{suffix:E})}}else{let m=n.getStart(t),d=om(m,t),S,E=!1;if(s.length===1)S=28;else{let x=iu(n.pos,t);S=Hee(n,x)?x.kind:28,E=om(s[o-1].getStart(t),t)!==d}if((G4t(t.text,n.end)||!Ed(s.pos,s.end,t))&&(E=!0),E){this.replaceRange(t,Td(u),U.createToken(S));let x=zl.SmartIndenter.findFirstNonWhitespaceColumn(d,m,t,this.formatContext.options),D=Ja(t.text,u,!0,!1);for(;D!==u&&v_(t.text.charCodeAt(D-1));)D--;this.replaceRange(t,Td(D),i,{indentation:x,prefix:this.newLineCharacter})}else this.replaceRange(t,Td(u),i,{prefix:`${Sa(S)} `})}}parenthesizeExpression(t,n){this.replaceRange(t,PG(n),U.createParenthesizedExpression(n))}finishClassesWithNodesInsertedAtStart(){this.classesWithNodesInsertedAtStart.forEach(({node:t,sourceFile:n})=>{let[i,s]=e3t(t,n);if(i!==void 0&&s!==void 0){let o=Gee(t).length===0,u=Ed(i,s,n);o&&u&&i!==s-1&&this.deleteRange(n,Td(i,s-1)),u&&this.insertText(n,s-1,this.newLineCharacter)}})}finishDeleteDeclarations(){let t=new Set;for(let{sourceFile:n,node:i}of this.deletedNodes)this.deletedNodes.some(s=>s.sourceFile===n&&y0e(s.node,i))||(Rs(i)?this.deleteRange(n,NG(n,i)):ETe.deleteDeclaration(this,t,n,i));t.forEach(n=>{let i=n.getSourceFile(),s=zl.SmartIndenter.getContainingList(n,i);if(n!==Va(s))return;let o=pv(s,u=>!t.has(u),s.length-2);o!==-1&&this.deleteRange(i,{pos:s[o].end,end:bTe(i,s[o+1])})})}getChanges(t){this.finishDeleteDeclarations(),this.finishClassesWithNodesInsertedAtStart();let n=Yee.getTextChangesFromChanges(this.changes,this.newLineCharacter,this.formatContext,t);return this.newFileChanges&&this.newFileChanges.forEach((i,s)=>{n.push(Yee.newFileChanges(s,i,this.newLineCharacter,this.formatContext))}),n}createNewFile(t,n,i){this.insertStatementsInNewFile(n,i,t)}};function X4t(e){if(e.kind!==219)return e;let t=e.parent.kind===172?e.parent:e.parent.parent;return t.jsDoc=e.jsDoc,t}function Q4t(e,t){if(e.kind===t.kind)switch(e.kind){case 341:{let n=e,i=t;return He(n.name)&&He(i.name)&&n.name.escapedText===i.name.escapedText?U.createJSDocParameterTag(void 0,i.name,!1,i.typeExpression,i.isNameFirst,n.comment):void 0}case 342:return U.createJSDocReturnTag(void 0,t.typeExpression,e.comment);case 344:return U.createJSDocTypeTag(void 0,t.typeExpression,e.comment)}}function bTe(e,t){return Ja(e.text,A2(e,t,{leadingTriviaOption:1}),!1,!0)}function Z4t(e,t,n,i){let s=bTe(e,i);if(n===void 0||Ed(lD(e,t,{}),s,e))return s;let o=iu(i.getStart(e),e);if(Hee(t,o)){let u=iu(t.getStart(e),e);if(Hee(n,u)){let m=Ja(e.text,o.getEnd(),!0,!0);if(Ed(u.getStart(e),o.getStart(e),e))return v_(e.text.charCodeAt(m-1))?m-1:m;if(v_(e.text.charCodeAt(m)))return m}}return s}function e3t(e,t){let n=Oo(e,19,t),i=Oo(e,20,t);return[n?.end,i?.end]}function Gee(e){return Ca(e)?e.properties:e.members}var Yee;(e=>{function t(m,d,S,E){return Gi(Hw(m,x=>x.sourceFile.path),x=>{let D=x[0].sourceFile,w=Qs(x,(L,F)=>L.range.pos-F.range.pos||L.range.end-F.range.end);for(let L=0;L<w.length-1;L++)M.assert(w[L].range.end<=w[L+1].range.pos,"Changes overlap",()=>`${JSON.stringify(w[L].range)} and ${JSON.stringify(w[L+1].range)}`);let R=Gi(w,L=>{let F=lS(L.range),J=L.kind===1?Ur(Bc(L.node))??L.sourceFile:L.kind===2?Ur(Bc(L.nodes[0]))??L.sourceFile:L.sourceFile,G=s(L,J,D,d,S,E);if(!(F.length===G.length&&ive(J.text,G,F.start)))return dM(F,G)});return R.length>0?{fileName:D.fileName,textChanges:R}:void 0})}e.getTextChangesFromChanges=t;function n(m,d,S,E){let x=i(ij(m),d,S,E);return{fileName:m,textChanges:[dM(zu(0,0),x)],isNewFile:!0}}e.newFileChanges=n;function i(m,d,S,E){let x=va(d,R=>R.statements.map(L=>L===4?"":u(L,R.oldFile,S).text)).join(S),D=HA("any file name",x,{languageVersion:99,jsDocParsingMode:1},!0,m),w=zl.formatDocument(D,E);return TTe(x,w)+S}e.newFileChangesWorker=i;function s(m,d,S,E,x,D){var w;if(m.kind===0)return"";if(m.kind===3)return m.text;let{options:R={},range:{pos:L}}=m,F=q=>o(q,d,S,L,R,E,x,D),J=m.kind===2?m.nodes.map(q=>AP(F(q),E)).join(((w=m.options)==null?void 0:w.joiner)||E):F(m.node),G=R.indentation!==void 0||om(L,d)===L?J:J.replace(/^\s+/,"");return(R.prefix||"")+G+(!R.suffix||Wc(G,R.suffix)?"":R.suffix)}function o(m,d,S,E,{indentation:x,prefix:D,delta:w},R,L,F){let{node:J,text:G}=u(m,d,R);F&&F(J,G);let q=oV(L,d),ee=x!==void 0?x:zl.SmartIndenter.getIndentation(E,S,q,D===R||om(E,d)===E);w===void 0&&(w=zl.SmartIndenter.shouldIndentChildNode(q,m)&&q.indentSize||0);let W={text:G,getLineAndCharacterOfPosition(K){return ba(this,K)}},pe=zl.formatNodeGivenIndentation(J,W,d.languageVariant,ee,w,{...L,options:q});return TTe(G,pe)}function u(m,d,S){let E=hqe(S),x=kM(S);return oS({newLine:x,neverAsciiEscape:!0,preserveSourceNewlines:!0,terminateUnterminatedLiterals:!0},E).writeNode(4,m,d,E),{text:E.getText(),node:Kee(m)}}e.getNonformattedText=u})(Yee||(Yee={}));function TTe(e,t){for(let n=t.length-1;n>=0;n--){let{span:i,newText:s}=t[n];e=`${e.substring(0,i.start)}${s}${e.substring(bl(i))}`}return e}function t3t(e){return Ja(e,0)===e.length}var r3t={...z8,factory:t8(z8.factory.flags|1,z8.factory.baseFactory)};function Kee(e){let t=Mr(e,Kee,r3t,n3t,Kee),n=Ko(t)?t:Object.create(t);return qg(n,fqe(e),pqe(e)),n}function n3t(e,t,n,i,s){let o=Kr(e,t,n,i,s);if(!o)return o;M.assert(e);let u=o===e?U.createNodeArray(o.slice(0)):o;return qg(u,fqe(e),pqe(e)),u}function hqe(e){let t=0,n=MR(e),i=te=>{te&&yTe(te,t)},s=te=>{te&&vTe(te,t)},o=te=>{te&&yTe(te,t)},u=te=>{te&&vTe(te,t)},m=te=>{te&&yTe(te,t)},d=te=>{te&&vTe(te,t)};function S(te,he){if(he||!t3t(te)){t=n.getTextPos();let be=0;for(;by(te.charCodeAt(te.length-be-1));)be++;t-=be}}function E(te){n.write(te),S(te,!1)}function x(te){n.writeComment(te)}function D(te){n.writeKeyword(te),S(te,!1)}function w(te){n.writeOperator(te),S(te,!1)}function R(te){n.writePunctuation(te),S(te,!1)}function L(te){n.writeTrailingSemicolon(te),S(te,!1)}function F(te){n.writeParameter(te),S(te,!1)}function J(te){n.writeProperty(te),S(te,!1)}function G(te){n.writeSpace(te),S(te,!1)}function q(te){n.writeStringLiteral(te),S(te,!1)}function ee(te,he){n.writeSymbol(te,he),S(te,!1)}function W(te){n.writeLine(te)}function pe(){n.increaseIndent()}function K(){n.decreaseIndent()}function re(){return n.getText()}function ue(te){n.rawWrite(te),S(te,!1)}function ce(te){n.writeLiteral(te),S(te,!0)}function ne(){return n.getTextPos()}function le(){return n.getLine()}function me(){return n.getColumn()}function de(){return n.getIndent()}function Ae(){return n.isAtStartOfLine()}function xe(){n.clear(),t=0}return{onBeforeEmitNode:i,onAfterEmitNode:s,onBeforeEmitNodeArray:o,onAfterEmitNodeArray:u,onBeforeEmitToken:m,onAfterEmitToken:d,write:E,writeComment:x,writeKeyword:D,writeOperator:w,writePunctuation:R,writeTrailingSemicolon:L,writeParameter:F,writeProperty:J,writeSpace:G,writeStringLiteral:q,writeSymbol:ee,writeLine:W,increaseIndent:pe,decreaseIndent:K,getText:re,rawWrite:ue,writeLiteral:ce,getTextPos:ne,getLine:le,getColumn:me,getIndent:de,isAtStartOfLine:Ae,hasTrailingComment:()=>n.hasTrailingComment(),hasTrailingWhitespace:()=>n.hasTrailingWhitespace(),clear:xe}}function i3t(e){let t;for(let S of e.statements)if(Mg(S))t=S;else break;let n=0,i=e.text;if(t)return n=t.end,d(),n;let s=v5(i);s!==void 0&&(n=s.length,d());let o=Ty(i,n);if(!o)return n;let u,m;for(let S of o){if(S.kind===3){if($5(i,S.pos)){u={range:S,pinnedOrTripleSlash:!0};continue}}else if(eH(i,S.pos,S.end)){u={range:S,pinnedOrTripleSlash:!0};continue}if(u){if(u.pinnedOrTripleSlash)break;let E=e.getLineAndCharacterOfPosition(S.pos).line,x=e.getLineAndCharacterOfPosition(u.range.end).line;if(E>=x+2)break}if(e.statements.length){m===void 0&&(m=e.getLineAndCharacterOfPosition(e.statements[0].getStart()).line);let E=e.getLineAndCharacterOfPosition(S.end).line;if(m<E+2)break}u={range:S,pinnedOrTripleSlash:!1}}return u&&(n=u.range.end,d()),n;function d(){if(n<i.length){let S=i.charCodeAt(n);v_(S)&&(n++,n<i.length&&S===13&&i.charCodeAt(n)===10&&n++)}}}function yqe(e,t){return!Bv(e,t)&&!ik(e,t)&&!mQ(e,t)&&!x0e(e,t)}function s3t(e,t){return(Nf(e)||Ns(e))&&D5(t)&&t.name.kind===167||W3(e)&&W3(t)}var ETe;(e=>{function t(o,u,m,d){switch(d.kind){case 169:{let w=d.parent;pc(w)&&w.parameters.length===1&&!Oo(w,21,m)?o.replaceNodeWithText(m,d,"()"):e7(o,u,m,d);break}case 272:case 271:let S=m.imports.length&&d===Ma(m.imports).parent||d===Ln(m.statements,eA);w0(o,m,d,{leadingTriviaOption:S?0:Pp(d)?2:3});break;case 208:let E=d.parent;E.kind===207&&d!==Va(E.elements)?w0(o,m,d):e7(o,u,m,d);break;case 260:s(o,u,m,d);break;case 168:e7(o,u,m,d);break;case 276:let D=d.parent;D.elements.length===1?i(o,m,D):e7(o,u,m,d);break;case 274:i(o,m,d);break;case 27:w0(o,m,d,{trailingTriviaOption:0});break;case 100:w0(o,m,d,{leadingTriviaOption:0});break;case 263:case 262:w0(o,m,d,{leadingTriviaOption:Pp(d)?2:3});break;default:d.parent?ig(d.parent)&&d.parent.name===d?n(o,m,d.parent):ea(d.parent)&&Es(d.parent.arguments,d)?e7(o,u,m,d):w0(o,m,d):w0(o,m,d)}}e.deleteDeclaration=t;function n(o,u,m){if(!m.namedBindings)w0(o,u,m.parent);else{let d=m.name.getStart(u),S=Yi(u,m.name.end);if(S&&S.kind===28){let E=Ja(u.text,S.end,!1,!0);o.deleteRange(u,{pos:d,end:E})}else w0(o,u,m.name)}}function i(o,u,m){if(m.parent.name){let d=M.checkDefined(Yi(u,m.pos-1));o.deleteRange(u,{pos:d.getStart(u),end:m.end})}else{let d=pb(m,272);w0(o,u,d)}}function s(o,u,m,d){let{parent:S}=d;if(S.kind===299){o.deleteNodeRange(m,Oo(S,21,m),Oo(S,22,m));return}if(S.declarations.length!==1){e7(o,u,m,d);return}let E=S.parent;switch(E.kind){case 250:case 249:o.replaceNode(m,d,U.createObjectLiteralExpression());break;case 248:w0(o,m,S);break;case 243:w0(o,m,E,{leadingTriviaOption:Pp(E)?2:3});break;default:M.assertNever(E)}}})(ETe||(ETe={}));function w0(e,t,n,i={leadingTriviaOption:1}){let s=A2(t,n,i),o=lD(t,n,i);e.deleteRange(t,{pos:s,end:o})}function e7(e,t,n,i){let s=M.checkDefined(zl.SmartIndenter.getContainingList(i,n)),o=JP(s,i);if(M.assert(o!==-1),s.length===1){w0(e,n,i);return}M.assert(!t.has(i),"Deleting a node twice"),t.add(i),e.deleteRange(n,{pos:bTe(n,i),end:o===s.length-1?lD(n,i,{}):Z4t(n,i,s[o-1],s[o+1])})}var zl={};A(zl,{FormattingContext:()=>Sqe,FormattingRequestKind:()=>vqe,RuleAction:()=>bqe,RuleFlags:()=>Tqe,SmartIndenter:()=>rh,anyContext:()=>Xee,createTextRangeWithKind:()=>tte,formatDocument:()=>K3t,formatNodeGivenIndentation:()=>nRt,formatOnClosingCurly:()=>Y3t,formatOnEnter:()=>$3t,formatOnOpeningCurly:()=>G3t,formatOnSemicolon:()=>H3t,formatSelection:()=>X3t,getAllRules:()=>Eqe,getFormatContext:()=>j3t,getFormattingScanner:()=>xTe,getIndentationString:()=>jTe,getRangeOfEnclosingComment:()=>Gqe});var vqe=(e=>(e[e.FormatDocument=0]="FormatDocument",e[e.FormatSelection=1]="FormatSelection",e[e.FormatOnEnter=2]="FormatOnEnter",e[e.FormatOnSemicolon=3]="FormatOnSemicolon",e[e.FormatOnOpeningCurlyBrace=4]="FormatOnOpeningCurlyBrace",e[e.FormatOnClosingCurlyBrace=5]="FormatOnClosingCurlyBrace",e))(vqe||{}),Sqe=class{constructor(e,t,n){this.sourceFile=e,this.formattingRequestKind=t,this.options=n}updateContext(e,t,n,i,s){this.currentTokenSpan=M.checkDefined(e),this.currentTokenParent=M.checkDefined(t),this.nextTokenSpan=M.checkDefined(n),this.nextTokenParent=M.checkDefined(i),this.contextNode=M.checkDefined(s),this.contextNodeAllOnSameLine=void 0,this.nextNodeAllOnSameLine=void 0,this.tokensAreOnSameLine=void 0,this.contextNodeBlockIsOnOneLine=void 0,this.nextNodeBlockIsOnOneLine=void 0}ContextNodeAllOnSameLine(){return this.contextNodeAllOnSameLine===void 0&&(this.contextNodeAllOnSameLine=this.NodeIsOnOneLine(this.contextNode)),this.contextNodeAllOnSameLine}NextNodeAllOnSameLine(){return this.nextNodeAllOnSameLine===void 0&&(this.nextNodeAllOnSameLine=this.NodeIsOnOneLine(this.nextTokenParent)),this.nextNodeAllOnSameLine}TokensAreOnSameLine(){if(this.tokensAreOnSameLine===void 0){let e=this.sourceFile.getLineAndCharacterOfPosition(this.currentTokenSpan.pos).line,t=this.sourceFile.getLineAndCharacterOfPosition(this.nextTokenSpan.pos).line;this.tokensAreOnSameLine=e===t}return this.tokensAreOnSameLine}ContextNodeBlockIsOnOneLine(){return this.contextNodeBlockIsOnOneLine===void 0&&(this.contextNodeBlockIsOnOneLine=this.BlockIsOnOneLine(this.contextNode)),this.contextNodeBlockIsOnOneLine}NextNodeBlockIsOnOneLine(){return this.nextNodeBlockIsOnOneLine===void 0&&(this.nextNodeBlockIsOnOneLine=this.BlockIsOnOneLine(this.nextTokenParent)),this.nextNodeBlockIsOnOneLine}NodeIsOnOneLine(e){let t=this.sourceFile.getLineAndCharacterOfPosition(e.getStart(this.sourceFile)).line,n=this.sourceFile.getLineAndCharacterOfPosition(e.getEnd()).line;return t===n}BlockIsOnOneLine(e){let t=Oo(e,19,this.sourceFile),n=Oo(e,20,this.sourceFile);if(t&&n){let i=this.sourceFile.getLineAndCharacterOfPosition(t.getEnd()).line,s=this.sourceFile.getLineAndCharacterOfPosition(n.getStart(this.sourceFile)).line;return i===s}return!1}},a3t=xy(99,!1,0),o3t=xy(99,!1,1);function xTe(e,t,n,i,s){let o=t===1?o3t:a3t;o.setText(e),o.resetTokenState(n);let u=!0,m,d,S,E,x,D=s({advance:w,readTokenInfo:W,readEOFTokenRange:K,isOnToken:re,isOnEOF:ue,getCurrentLeadingTrivia:()=>m,lastTrailingTriviaWasNewLine:()=>u,skipToEndOf:ne,skipToStartOf:le,getTokenFullStart:()=>x?.token.pos??o.getTokenStart(),getStartPos:()=>x?.token.pos??o.getTokenStart()});return x=void 0,o.setText(void 0),D;function w(){x=void 0,o.getTokenFullStart()!==n?u=!!d&&Va(d).kind===4:o.scan(),m=void 0,d=void 0;let de=o.getTokenFullStart();for(;de<i;){let Ae=o.getToken();if(!tN(Ae))break;o.scan();let xe={pos:de,end:o.getTokenFullStart(),kind:Ae};de=o.getTokenFullStart(),m=Bt(m,xe)}S=o.getTokenFullStart()}function R(me){switch(me.kind){case 34:case 72:case 73:case 50:case 49:return!0}return!1}function L(me){if(me.parent)switch(me.parent.kind){case 291:case 286:case 287:case 285:return sf(me.kind)||me.kind===80}return!1}function F(me){return DA(me)||Ly(me)&&x?.token.kind===12}function J(me){return me.kind===14}function G(me){return me.kind===17||me.kind===18}function q(me){return me.parent&&Kg(me.parent)&&me.parent.initializer===me}function ee(me){return me===44||me===69}function W(me){M.assert(re());let de=R(me)?1:J(me)?2:G(me)?3:L(me)?4:F(me)?5:q(me)?6:0;if(x&&de===E)return ce(x,me);o.getTokenFullStart()!==S&&(M.assert(x!==void 0),o.resetTokenState(S),o.scan());let Ae=pe(me,de),xe=tte(o.getTokenFullStart(),o.getTokenEnd(),Ae);for(d&&(d=void 0);o.getTokenFullStart()<i&&(Ae=o.scan(),!!tN(Ae));){let te=tte(o.getTokenFullStart(),o.getTokenEnd(),Ae);if(d||(d=[]),d.push(te),Ae===4){o.scan();break}}return x={leadingTrivia:m,trailingTrivia:d,token:xe},ce(x,me)}function pe(me,de){let Ae=o.getToken();switch(E=0,de){case 1:if(Ae===32){E=1;let xe=o.reScanGreaterToken();return M.assert(me.kind===xe),xe}break;case 2:if(ee(Ae)){E=2;let xe=o.reScanSlashToken();return M.assert(me.kind===xe),xe}break;case 3:if(Ae===20)return E=3,o.reScanTemplateToken(!1);break;case 4:return E=4,o.scanJsxIdentifier();case 5:return E=5,o.reScanJsxToken(!1);case 6:return E=6,o.reScanJsxAttributeValue();case 0:break;default:M.assertNever(de)}return Ae}function K(){return M.assert(ue()),tte(o.getTokenFullStart(),o.getTokenEnd(),1)}function re(){let me=x?x.token.kind:o.getToken();return me!==1&&!tN(me)}function ue(){return(x?x.token.kind:o.getToken())===1}function ce(me,de){return HC(de)&&me.token.kind!==de.kind&&(me.token.kind=de.kind),me}function ne(me){o.resetTokenState(me.end),S=o.getTokenFullStart(),E=void 0,x=void 0,u=!1,m=void 0,d=void 0}function le(me){o.resetTokenState(me.pos),S=o.getTokenFullStart(),E=void 0,x=void 0,u=!1,m=void 0,d=void 0}}var Xee=ve,bqe=(e=>(e[e.None=0]="None",e[e.StopProcessingSpaceActions=1]="StopProcessingSpaceActions",e[e.StopProcessingTokenActions=2]="StopProcessingTokenActions",e[e.InsertSpace=4]="InsertSpace",e[e.InsertNewLine=8]="InsertNewLine",e[e.DeleteSpace=16]="DeleteSpace",e[e.DeleteToken=32]="DeleteToken",e[e.InsertTrailingSemicolon=64]="InsertTrailingSemicolon",e[e.StopAction=3]="StopAction",e[e.ModifySpaceAction=28]="ModifySpaceAction",e[e.ModifyTokenAction=96]="ModifyTokenAction",e))(bqe||{}),Tqe=(e=>(e[e.None=0]="None",e[e.CanDeleteNewLines=1]="CanDeleteNewLines",e))(Tqe||{});function Eqe(){let e=[];for(let pe=0;pe<=165;pe++)pe!==1&&e.push(pe);function t(...pe){return{tokens:e.filter(K=>!pe.some(re=>re===K)),isSpecific:!1}}let n={tokens:e,isSpecific:!1},i=j6([...e,3]),s=j6([...e,1]),o=Cqe(83,165),u=Cqe(30,79),m=[103,104,165,130,142,152],d=[46,47,55,54],S=[9,10,80,21,23,19,110,105],E=[80,21,110,105],x=[80,22,24,105],D=[80,21,110,105],w=[80,22,24,105],R=[2,3],L=[80,...xQ],F=i,J=j6([80,32,3,86,95,102]),G=j6([22,3,92,113,98,93,85]),q=[oi("IgnoreBeforeComment",n,R,Xee,1),oi("IgnoreAfterLineComment",2,n,Xee,1),oi("NotSpaceBeforeColon",n,59,[es,QV,Pqe],16),oi("SpaceAfterColon",59,n,[es,QV,x3t],4),oi("NoSpaceBeforeQuestionMark",n,58,[es,QV,Pqe],16),oi("SpaceAfterQuestionMarkInConditionalOperator",58,n,[es,_3t],4),oi("NoSpaceAfterQuestionMark",58,n,[es,u3t],16),oi("NoSpaceBeforeDot",n,[25,29],[es,F3t],16),oi("NoSpaceAfterDot",[25,29],n,[es],16),oi("NoSpaceBetweenImportParenInImportType",102,21,[es,T3t],16),oi("NoSpaceAfterUnaryPrefixOperator",d,S,[es,QV],16),oi("NoSpaceAfterUnaryPreincrementOperator",46,E,[es],16),oi("NoSpaceAfterUnaryPredecrementOperator",47,D,[es],16),oi("NoSpaceBeforeUnaryPostincrementOperator",x,46,[es,zqe],16),oi("NoSpaceBeforeUnaryPostdecrementOperator",w,47,[es,zqe],16),oi("SpaceAfterPostincrementWhenFollowedByAdd",46,40,[es,fS],4),oi("SpaceAfterAddWhenFollowedByUnaryPlus",40,40,[es,fS],4),oi("SpaceAfterAddWhenFollowedByPreincrement",40,46,[es,fS],4),oi("SpaceAfterPostdecrementWhenFollowedBySubtract",47,41,[es,fS],4),oi("SpaceAfterSubtractWhenFollowedByUnaryMinus",41,41,[es,fS],4),oi("SpaceAfterSubtractWhenFollowedByPredecrement",41,47,[es,fS],4),oi("NoSpaceAfterCloseBrace",20,[28,27],[es],16),oi("NewLineBeforeCloseBraceInBlockContext",i,20,[Dqe],8),oi("SpaceAfterCloseBrace",20,t(22),[es,d3t],4),oi("SpaceBetweenCloseBraceAndElse",20,93,[es],4),oi("SpaceBetweenCloseBraceAndWhile",20,117,[es],4),oi("NoSpaceBetweenEmptyBraceBrackets",19,20,[es,Lqe],16),oi("SpaceAfterConditionalClosingParen",22,23,[ZV],4),oi("NoSpaceBetweenFunctionKeywordAndStar",100,42,[Oqe],16),oi("SpaceAfterStarInGeneratorDeclaration",42,80,[Oqe],4),oi("SpaceAfterFunctionInFuncDecl",100,n,[k2],4),oi("NewLineAfterOpenBraceInBlockContext",19,n,[Dqe],8),oi("SpaceAfterGetSetInMember",[139,153],80,[k2],4),oi("NoSpaceBetweenYieldKeywordAndStar",127,42,[es,qqe],16),oi("SpaceBetweenYieldOrYieldStarAndOperand",[127,42],n,[es,qqe],4),oi("NoSpaceBetweenReturnAndSemicolon",107,27,[es],16),oi("SpaceAfterCertainKeywords",[115,111,105,91,107,114,135],n,[es],4),oi("SpaceAfterLetConstInVariableDeclaration",[121,87],n,[es,k3t],4),oi("NoSpaceBeforeOpenParenInFuncCall",n,21,[es,h3t,y3t],16),oi("SpaceBeforeBinaryKeywordOperator",n,m,[es,fS],4),oi("SpaceAfterBinaryKeywordOperator",m,n,[es,fS],4),oi("SpaceAfterVoidOperator",116,n,[es,I3t],4),oi("SpaceBetweenAsyncAndOpenParen",134,21,[b3t,es],4),oi("SpaceBetweenAsyncAndFunctionKeyword",134,[100,80],[es],4),oi("NoSpaceBetweenTagAndTemplateString",[80,22],[15,16],[es],16),oi("SpaceBeforeJsxAttribute",n,80,[E3t,es],4),oi("SpaceBeforeSlashInJsxOpeningElement",n,44,[Uqe,es],4),oi("NoSpaceBeforeGreaterThanTokenInJsxOpeningElement",44,32,[Uqe,es],16),oi("NoSpaceBeforeEqualInJsxAttribute",n,64,[jqe,es],16),oi("NoSpaceAfterEqualInJsxAttribute",64,n,[jqe,es],16),oi("NoSpaceBeforeJsxNamespaceColon",80,59,[Bqe],16),oi("NoSpaceAfterJsxNamespaceColon",59,80,[Bqe],16),oi("NoSpaceAfterModuleImport",[144,149],21,[es],16),oi("SpaceAfterCertainTypeScriptKeywords",[128,129,86,138,90,94,95,96,139,119,102,120,144,145,123,125,124,148,153,126,156,161,143,140],n,[es],4),oi("SpaceBeforeCertainTypeScriptKeywords",n,[96,119,161],[es],4),oi("SpaceAfterModuleName",11,19,[P3t],4),oi("SpaceBeforeArrow",n,39,[es],4),oi("SpaceAfterArrow",39,n,[es],4),oi("NoSpaceAfterEllipsis",26,80,[es],16),oi("NoSpaceAfterOptionalParameters",58,[22,28],[es,QV],16),oi("NoSpaceBetweenEmptyInterfaceBraceBrackets",19,20,[es,N3t],16),oi("NoSpaceBeforeOpenAngularBracket",L,30,[es,eJ],16),oi("NoSpaceBetweenCloseParenAndAngularBracket",22,30,[es,eJ],16),oi("NoSpaceAfterOpenAngularBracket",30,n,[es,eJ],16),oi("NoSpaceBeforeCloseAngularBracket",n,32,[es,eJ],16),oi("NoSpaceAfterCloseAngularBracket",32,[21,23,32,28],[es,eJ,p3t,w3t],16),oi("SpaceBeforeAt",[22,80],60,[es],4),oi("NoSpaceAfterAt",60,n,[es],16),oi("SpaceAfterDecorator",n,[128,80,95,90,86,126,125,123,124,139,153,23,42],[A3t],4),oi("NoSpaceBeforeNonNullAssertionOperator",n,54,[es,O3t],16),oi("NoSpaceAfterNewKeywordOnConstructorSignature",105,21,[es,D3t],16),oi("SpaceLessThanAndNonJSXTypeAnnotation",30,30,[es],4)],ee=[oi("SpaceAfterConstructor",137,21,[rd("insertSpaceAfterConstructor"),es],4),oi("NoSpaceAfterConstructor",137,21,[th("insertSpaceAfterConstructor"),es],16),oi("SpaceAfterComma",28,n,[rd("insertSpaceAfterCommaDelimiter"),es,wTe,v3t,S3t],4),oi("NoSpaceAfterComma",28,n,[th("insertSpaceAfterCommaDelimiter"),es,wTe],16),oi("SpaceAfterAnonymousFunctionKeyword",[100,42],21,[rd("insertSpaceAfterFunctionKeywordForAnonymousFunctions"),k2],4),oi("NoSpaceAfterAnonymousFunctionKeyword",[100,42],21,[th("insertSpaceAfterFunctionKeywordForAnonymousFunctions"),k2],16),oi("SpaceAfterKeywordInControl",o,21,[rd("insertSpaceAfterKeywordsInControlFlowStatements"),ZV],4),oi("NoSpaceAfterKeywordInControl",o,21,[th("insertSpaceAfterKeywordsInControlFlowStatements"),ZV],16),oi("SpaceAfterOpenParen",21,n,[rd("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),es],4),oi("SpaceBeforeCloseParen",n,22,[rd("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),es],4),oi("SpaceBetweenOpenParens",21,21,[rd("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),es],4),oi("NoSpaceBetweenParens",21,22,[es],16),oi("NoSpaceAfterOpenParen",21,n,[th("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),es],16),oi("NoSpaceBeforeCloseParen",n,22,[th("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),es],16),oi("SpaceAfterOpenBracket",23,n,[rd("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"),es],4),oi("SpaceBeforeCloseBracket",n,24,[rd("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"),es],4),oi("NoSpaceBetweenBrackets",23,24,[es],16),oi("NoSpaceAfterOpenBracket",23,n,[th("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"),es],16),oi("NoSpaceBeforeCloseBracket",n,24,[th("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"),es],16),oi("SpaceAfterOpenBrace",19,n,[kqe("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"),Nqe],4),oi("SpaceBeforeCloseBrace",n,20,[kqe("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"),Nqe],4),oi("NoSpaceBetweenEmptyBraceBrackets",19,20,[es,Lqe],16),oi("NoSpaceAfterOpenBrace",19,n,[CTe("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"),es],16),oi("NoSpaceBeforeCloseBrace",n,20,[CTe("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"),es],16),oi("SpaceBetweenEmptyBraceBrackets",19,20,[rd("insertSpaceAfterOpeningAndBeforeClosingEmptyBraces")],4),oi("NoSpaceBetweenEmptyBraceBrackets",19,20,[CTe("insertSpaceAfterOpeningAndBeforeClosingEmptyBraces"),es],16),oi("SpaceAfterTemplateHeadAndMiddle",[16,17],n,[rd("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"),Fqe],4,1),oi("SpaceBeforeTemplateMiddleAndTail",n,[17,18],[rd("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"),es],4),oi("NoSpaceAfterTemplateHeadAndMiddle",[16,17],n,[th("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"),Fqe],16,1),oi("NoSpaceBeforeTemplateMiddleAndTail",n,[17,18],[th("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"),es],16),oi("SpaceAfterOpenBraceInJsxExpression",19,n,[rd("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"),es,Zee],4),oi("SpaceBeforeCloseBraceInJsxExpression",n,20,[rd("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"),es,Zee],4),oi("NoSpaceAfterOpenBraceInJsxExpression",19,n,[th("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"),es,Zee],16),oi("NoSpaceBeforeCloseBraceInJsxExpression",n,20,[th("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"),es,Zee],16),oi("SpaceAfterSemicolonInFor",27,n,[rd("insertSpaceAfterSemicolonInForStatements"),es,kTe],4),oi("NoSpaceAfterSemicolonInFor",27,n,[th("insertSpaceAfterSemicolonInForStatements"),es,kTe],16),oi("SpaceBeforeBinaryOperator",n,u,[rd("insertSpaceBeforeAndAfterBinaryOperators"),es,fS],4),oi("SpaceAfterBinaryOperator",u,n,[rd("insertSpaceBeforeAndAfterBinaryOperators"),es,fS],4),oi("NoSpaceBeforeBinaryOperator",n,u,[th("insertSpaceBeforeAndAfterBinaryOperators"),es,fS],16),oi("NoSpaceAfterBinaryOperator",u,n,[th("insertSpaceBeforeAndAfterBinaryOperators"),es,fS],16),oi("SpaceBeforeOpenParenInFuncDecl",n,21,[rd("insertSpaceBeforeFunctionParenthesis"),es,k2],4),oi("NoSpaceBeforeOpenParenInFuncDecl",n,21,[th("insertSpaceBeforeFunctionParenthesis"),es,k2],16),oi("NewLineBeforeOpenBraceInControl",G,19,[rd("placeOpenBraceOnNewLineForControlBlocks"),ZV,DTe],8,1),oi("NewLineBeforeOpenBraceInFunction",F,19,[rd("placeOpenBraceOnNewLineForFunctions"),k2,DTe],8,1),oi("NewLineBeforeOpenBraceInTypeScriptDeclWithBlock",J,19,[rd("placeOpenBraceOnNewLineForFunctions"),Rqe,DTe],8,1),oi("SpaceAfterTypeAssertion",32,n,[rd("insertSpaceAfterTypeAssertion"),es,OTe],4),oi("NoSpaceAfterTypeAssertion",32,n,[th("insertSpaceAfterTypeAssertion"),es,OTe],16),oi("SpaceBeforeTypeAnnotation",n,[58,59],[rd("insertSpaceBeforeTypeAnnotation"),es,PTe],4),oi("NoSpaceBeforeTypeAnnotation",n,[58,59],[th("insertSpaceBeforeTypeAnnotation"),es,PTe],16),oi("NoOptionalSemicolon",27,s,[Aqe("semicolons","remove"),M3t],32),oi("OptionalSemicolon",n,s,[Aqe("semicolons","insert"),L3t],64)],W=[oi("NoSpaceBeforeSemicolon",n,27,[es],16),oi("SpaceBeforeOpenBraceInControl",G,19,[ATe("placeOpenBraceOnNewLineForControlBlocks"),ZV,ITe,NTe],4,1),oi("SpaceBeforeOpenBraceInFunction",F,19,[ATe("placeOpenBraceOnNewLineForFunctions"),k2,Qee,ITe,NTe],4,1),oi("SpaceBeforeOpenBraceInTypeScriptDeclWithBlock",J,19,[ATe("placeOpenBraceOnNewLineForFunctions"),Rqe,ITe,NTe],4,1),oi("NoSpaceBeforeComma",n,28,[es],16),oi("NoSpaceBeforeOpenBracket",t(134,84),23,[es],16),oi("NoSpaceAfterCloseBracket",24,n,[es,C3t],16),oi("SpaceAfterSemicolon",27,n,[es],4),oi("SpaceBetweenForAndAwaitKeyword",99,135,[es],4),oi("SpaceBetweenDotDotDotAndTypeName",26,L,[es],16),oi("SpaceBetweenStatements",[22,92,93,84],n,[es,wTe,c3t],4),oi("SpaceAfterTryCatchFinally",[113,85,98],19,[es],4)];return[...q,...ee,...W]}function oi(e,t,n,i,s,o=0){return{leftTokenRange:xqe(t),rightTokenRange:xqe(n),rule:{debugName:e,context:i,action:s,flags:o}}}function j6(e){return{tokens:e,isSpecific:!0}}function xqe(e){return typeof e=="number"?j6([e]):Rs(e)?j6(e):e}function Cqe(e,t,n=[]){let i=[];for(let s=e;s<=t;s++)Es(n,s)||i.push(s);return j6(i)}function Aqe(e,t){return n=>n.options&&n.options[e]===t}function rd(e){return t=>t.options&&Ho(t.options,e)&&!!t.options[e]}function CTe(e){return t=>t.options&&Ho(t.options,e)&&!t.options[e]}function th(e){return t=>!t.options||!Ho(t.options,e)||!t.options[e]}function ATe(e){return t=>!t.options||!Ho(t.options,e)||!t.options[e]||t.TokensAreOnSameLine()}function kqe(e){return t=>!t.options||!Ho(t.options,e)||!!t.options[e]}function kTe(e){return e.contextNode.kind===248}function c3t(e){return!kTe(e)}function fS(e){switch(e.contextNode.kind){case 226:return e.contextNode.operatorToken.kind!==28;case 227:case 194:case 234:case 281:case 276:case 182:case 192:case 193:case 238:return!0;case 208:case 265:case 271:case 277:case 260:case 169:case 306:case 172:case 171:return e.currentTokenSpan.kind===64||e.nextTokenSpan.kind===64;case 249:case 168:return e.currentTokenSpan.kind===103||e.nextTokenSpan.kind===103||e.currentTokenSpan.kind===64||e.nextTokenSpan.kind===64;case 250:return e.currentTokenSpan.kind===165||e.nextTokenSpan.kind===165}return!1}function QV(e){return!fS(e)}function Pqe(e){return!PTe(e)}function PTe(e){let t=e.contextNode.kind;return t===172||t===171||t===169||t===260||YC(t)}function l3t(e){return Ns(e.contextNode)&&e.contextNode.questionToken}function u3t(e){return!l3t(e)}function _3t(e){return e.contextNode.kind===227||e.contextNode.kind===194}function NTe(e){return e.TokensAreOnSameLine()||Qee(e)}function Nqe(e){return e.contextNode.kind===206||e.contextNode.kind===200||f3t(e)}function DTe(e){return Qee(e)&&!(e.NextNodeAllOnSameLine()||e.NextNodeBlockIsOnOneLine())}function Dqe(e){return wqe(e)&&!(e.ContextNodeAllOnSameLine()||e.ContextNodeBlockIsOnOneLine())}function f3t(e){return wqe(e)&&(e.ContextNodeAllOnSameLine()||e.ContextNodeBlockIsOnOneLine())}function wqe(e){return Iqe(e.contextNode)}function Qee(e){return Iqe(e.nextTokenParent)}function Iqe(e){if(Mqe(e))return!0;switch(e.kind){case 241:case 269:case 210:case 268:return!0}return!1}function k2(e){switch(e.contextNode.kind){case 262:case 174:case 173:case 177:case 178:case 179:case 218:case 176:case 219:case 264:return!0}return!1}function p3t(e){return!k2(e)}function Oqe(e){return e.contextNode.kind===262||e.contextNode.kind===218}function Rqe(e){return Mqe(e.contextNode)}function Mqe(e){switch(e.kind){case 263:case 231:case 264:case 266:case 187:case 267:case 278:case 279:case 272:case 275:return!0}return!1}function d3t(e){switch(e.currentTokenParent.kind){case 263:case 267:case 266:case 299:case 268:case 255:return!0;case 241:{let t=e.currentTokenParent.parent;if(!t||t.kind!==219&&t.kind!==218)return!0}}return!1}function ZV(e){switch(e.contextNode.kind){case 245:case 255:case 248:case 249:case 250:case 247:case 258:case 246:case 254:case 299:return!0;default:return!1}}function Lqe(e){return e.contextNode.kind===210}function m3t(e){return e.contextNode.kind===213}function g3t(e){return e.contextNode.kind===214}function h3t(e){return m3t(e)||g3t(e)}function y3t(e){return e.currentTokenSpan.kind!==28}function v3t(e){return e.nextTokenSpan.kind!==24}function S3t(e){return e.nextTokenSpan.kind!==22}function b3t(e){return e.contextNode.kind===219}function T3t(e){return e.contextNode.kind===205}function es(e){return e.TokensAreOnSameLine()&&e.contextNode.kind!==12}function Fqe(e){return e.contextNode.kind!==12}function wTe(e){return e.contextNode.kind!==284&&e.contextNode.kind!==288}function Zee(e){return e.contextNode.kind===294||e.contextNode.kind===293}function E3t(e){return e.nextTokenParent.kind===291||e.nextTokenParent.kind===295&&e.nextTokenParent.parent.kind===291}function jqe(e){return e.contextNode.kind===291}function x3t(e){return e.nextTokenParent.kind!==295}function Bqe(e){return e.nextTokenParent.kind===295}function Uqe(e){return e.contextNode.kind===285}function C3t(e){return!k2(e)&&!Qee(e)}function A3t(e){return e.TokensAreOnSameLine()&&Wp(e.contextNode)&&Vqe(e.currentTokenParent)&&!Vqe(e.nextTokenParent)}function Vqe(e){for(;e&&Ct(e);)e=e.parent;return e&&e.kind===170}function k3t(e){return e.currentTokenParent.kind===261&&e.currentTokenParent.getStart(e.sourceFile)===e.currentTokenSpan.pos}function ITe(e){return e.formattingRequestKind!==2}function P3t(e){return e.contextNode.kind===267}function N3t(e){return e.contextNode.kind===187}function D3t(e){return e.contextNode.kind===180}function Jqe(e,t){if(e.kind!==30&&e.kind!==32)return!1;switch(t.kind){case 183:case 216:case 265:case 263:case 231:case 264:case 262:case 218:case 219:case 174:case 173:case 179:case 180:case 213:case 214:case 233:return!0;default:return!1}}function eJ(e){return Jqe(e.currentTokenSpan,e.currentTokenParent)||Jqe(e.nextTokenSpan,e.nextTokenParent)}function OTe(e){return e.contextNode.kind===216}function w3t(e){return!OTe(e)}function I3t(e){return e.currentTokenSpan.kind===116&&e.currentTokenParent.kind===222}function qqe(e){return e.contextNode.kind===229&&e.contextNode.expression!==void 0}function O3t(e){return e.contextNode.kind===235}function zqe(e){return!R3t(e)}function R3t(e){switch(e.contextNode.kind){case 245:case 248:case 249:case 250:case 246:case 247:return!0;default:return!1}}function M3t(e){let t=e.nextTokenSpan.kind,n=e.nextTokenSpan.pos;if(tN(t)){let o=e.nextTokenParent===e.currentTokenParent?NE(e.currentTokenParent,Pr(e.currentTokenParent,u=>!u.parent),e.sourceFile):e.nextTokenParent.getFirstToken(e.sourceFile);if(!o)return!0;t=o.kind,n=o.getStart(e.sourceFile)}let i=e.sourceFile.getLineAndCharacterOfPosition(e.currentTokenSpan.pos).line,s=e.sourceFile.getLineAndCharacterOfPosition(n).line;return i===s?t===20||t===1:t===240||t===27?!1:e.contextNode.kind===264||e.contextNode.kind===265?!Nf(e.currentTokenParent)||!!e.currentTokenParent.type||t!==21:Ns(e.currentTokenParent)?!e.currentTokenParent.initializer:e.currentTokenParent.kind!==248&&e.currentTokenParent.kind!==242&&e.currentTokenParent.kind!==240&&t!==23&&t!==21&&t!==40&&t!==41&&t!==44&&t!==14&&t!==28&&t!==228&&t!==16&&t!==15&&t!==25}function L3t(e){return KU(e.currentTokenSpan.end,e.currentTokenParent,e.sourceFile)}function F3t(e){return!Wn(e.contextNode)||!Pf(e.contextNode.expression)||e.contextNode.expression.getText().includes(".")}function j3t(e,t){return{options:e,getRules:B3t(),host:t}}var RTe;function B3t(){return RTe===void 0&&(RTe=V3t(Eqe())),RTe}function U3t(e){let t=0;return e&1&&(t|=28),e&2&&(t|=96),e&28&&(t|=28),e&96&&(t|=96),t}function V3t(e){let t=J3t(e);return n=>{let i=t[Wqe(n.currentTokenSpan.kind,n.nextTokenSpan.kind)];if(i){let s=[],o=0;for(let u of i){let m=~U3t(o);u.action&m&&wi(u.context,d=>d(n))&&(s.push(u),o|=u.action)}if(s.length)return s}}}function J3t(e){let t=new Array(MTe*MTe),n=new Array(t.length);for(let i of e){let s=i.leftTokenRange.isSpecific&&i.rightTokenRange.isSpecific;for(let o of i.leftTokenRange.tokens)for(let u of i.rightTokenRange.tokens){let m=Wqe(o,u),d=t[m];d===void 0&&(d=t[m]=[]),q3t(d,i.rule,s,n,m)}}return t}function Wqe(e,t){return M.assert(e<=165&&t<=165,"Must compute formatting context from tokens"),e*MTe+t}var B6=5,ete=31,MTe=166,t7=(e=>(e[e.StopRulesSpecific=0]="StopRulesSpecific",e[e.StopRulesAny=B6*1]="StopRulesAny",e[e.ContextRulesSpecific=B6*2]="ContextRulesSpecific",e[e.ContextRulesAny=B6*3]="ContextRulesAny",e[e.NoContextRulesSpecific=B6*4]="NoContextRulesSpecific",e[e.NoContextRulesAny=B6*5]="NoContextRulesAny",e))(t7||{});function q3t(e,t,n,i,s){let o=t.action&3?n?0:t7.StopRulesAny:t.context!==Xee?n?t7.ContextRulesSpecific:t7.ContextRulesAny:n?t7.NoContextRulesSpecific:t7.NoContextRulesAny,u=i[s]||0;e.splice(z3t(u,o),0,t),i[s]=W3t(u,o)}function z3t(e,t){let n=0;for(let i=0;i<=t;i+=B6)n+=e&ete,e>>=B6;return n}function W3t(e,t){let n=(e>>t&ete)+1;return M.assert((n&ete)===n,"Adding more rules into the sub-bucket than allowed. Maximum allowed is 32 rules."),e&~(ete<<t)|n<<t}function tte(e,t,n){let i={pos:e,end:t,kind:n};return M.isDebugging&&Object.defineProperty(i,"__debugKind",{get:()=>M.formatSyntaxKind(n)}),i}function $3t(e,t,n){let i=t.getLineAndCharacterOfPosition(e).line;if(i===0)return[];let s=G3(i,t);for(;wg(t.text.charCodeAt(s));)s--;v_(t.text.charCodeAt(s))&&s--;let o={pos:q1(i-1,t),end:s+1};return tJ(o,t,n,2)}function H3t(e,t,n){let i=LTe(e,27,t);return $qe(FTe(i),t,n,3)}function G3t(e,t,n){let i=LTe(e,19,t);if(!i)return[];let s=i.parent,o=FTe(s),u={pos:om(o.getStart(t),t),end:e};return tJ(u,t,n,4)}function Y3t(e,t,n){let i=LTe(e,20,t);return $qe(FTe(i),t,n,5)}function K3t(e,t){let n={pos:0,end:e.text.length};return tJ(n,e,t,0)}function X3t(e,t,n,i){let s={pos:om(e,n),end:t};return tJ(s,n,i,1)}function LTe(e,t,n){let i=iu(e,n);return i&&i.kind===t&&e===i.getEnd()?i:void 0}function FTe(e){let t=e;for(;t&&t.parent&&t.parent.end===e.end&&!Q3t(t.parent,t);)t=t.parent;return t}function Q3t(e,t){switch(e.kind){case 263:case 264:return Zp(e.members,t);case 267:let n=e.body;return!!n&&n.kind===268&&Zp(n.statements,t);case 307:case 241:case 268:return Zp(e.statements,t);case 299:return Zp(e.block.statements,t)}return!1}function Z3t(e,t){return n(t);function n(i){let s=Js(i,o=>_Q(o.getStart(t),o.end,e)&&o);if(s){let o=n(s);if(o)return o}return i}}function eRt(e,t){if(!e.length)return s;let n=e.filter(o=>d6(t,o.start,o.start+o.length)).sort((o,u)=>o.start-u.start);if(!n.length)return s;let i=0;return o=>{for(;;){if(i>=n.length)return!1;let u=n[i];if(o.end<=u.start)return!1;if(kU(o.pos,o.end,u.start,u.start+u.length))return!0;i++}};function s(){return!1}}function tRt(e,t,n){let i=e.getStart(n);if(i===t.pos&&e.end===t.end)return i;let s=iu(t.pos,n);return!s||s.end>=t.pos?e.pos:s.end}function rRt(e,t,n){let i=-1,s;for(;e;){let o=n.getLineAndCharacterOfPosition(e.getStart(n)).line;if(i!==-1&&o!==i)break;if(rh.shouldIndentChildNode(t,e,s,n))return t.indentSize;i=o,s=e,e=e.parent}return 0}function nRt(e,t,n,i,s,o){let u={pos:e.pos,end:e.end};return xTe(t.text,n,u.pos,u.end,m=>Hqe(u,e,i,s,m,o,1,d=>!1,t))}function $qe(e,t,n,i){if(!e)return[];let s={pos:om(e.getStart(t),t),end:e.end};return tJ(s,t,n,i)}function tJ(e,t,n,i){let s=Z3t(e,t);return xTe(t.text,t.languageVariant,tRt(s,e,t),e.end,o=>Hqe(e,s,rh.getIndentationForNode(s,e,t,n.options),rRt(s,n.options,t),o,n,i,eRt(t.parseDiagnostics,e),t))}function Hqe(e,t,n,i,s,{options:o,getRules:u,host:m},d,S,E){var x;let D=new Sqe(E,d,o),w,R,L,F,J,G=-1,q=[];if(s.advance(),s.isOnToken()){let qe=E.getLineAndCharacterOfPosition(t.getStart(E)).line,et=qe;Wp(t)&&(et=E.getLineAndCharacterOfPosition(tH(t,E)).line),ue(t,t,qe,et,n,i)}let ee=s.getCurrentLeadingTrivia();if(ee){let qe=rh.nodeWillIndentChild(o,t,void 0,E,!1)?n+o.indentSize:n;ce(ee,qe,!0,et=>{le(et,E.getLineAndCharacterOfPosition(et.pos),t,t,void 0),de(et.pos,qe,!1)}),o.trimTrailingWhitespace!==!1&&Ve(ee)}if(R&&s.getTokenFullStart()>=e.end){let qe=s.isOnEOF()?s.readEOFTokenRange():s.isOnToken()?s.readTokenInfo(t).token:void 0;if(qe&&qe.pos===w){let et=((x=iu(qe.end,E,t))==null?void 0:x.parent)||L;me(qe,E.getLineAndCharacterOfPosition(qe.pos).line,et,R,F,L,et,void 0)}}return q;function W(qe,et,Ie,_t,mt){if(d6(_t,qe,et)||uM(_t,qe,et)){if(mt!==-1)return mt}else{let Xe=E.getLineAndCharacterOfPosition(qe).line,ht=om(qe,E),rr=rh.findFirstNonWhitespaceColumn(ht,qe,E,o);if(Xe!==Ie||qe===rr){let vr=rh.getBaseIndentation(o);return vr>rr?vr:rr}}return-1}function pe(qe,et,Ie,_t,mt,Xe){let ht=rh.shouldIndentChildNode(o,qe)?o.indentSize:0;return Xe===et?{indentation:et===J?G:mt.getIndentation(),delta:Math.min(o.indentSize,mt.getDelta(qe)+ht)}:Ie===-1?qe.kind===21&&et===J?{indentation:G,delta:mt.getDelta(qe)}:rh.childStartsOnTheSameLineWithElseInIfStatement(_t,qe,et,E)||rh.childIsUnindentedBranchOfConditionalExpression(_t,qe,et,E)||rh.argumentStartsOnSameLineAsPreviousArgument(_t,qe,et,E)?{indentation:mt.getIndentation(),delta:ht}:{indentation:mt.getIndentation()+mt.getDelta(qe),delta:ht}:{indentation:Ie,delta:ht}}function K(qe){if(wm(qe)){let et=Ln(qe.modifiers,Pa,Bo(qe.modifiers,fu));if(et)return et.kind}switch(qe.kind){case 263:return 86;case 264:return 120;case 262:return 100;case 266:return 266;case 177:return 139;case 178:return 153;case 174:if(qe.asteriskToken)return 42;case 172:case 169:let et=Ps(qe);if(et)return et.kind}}function re(qe,et,Ie,_t){return{getIndentationForComment:(ht,rr,vr)=>{switch(ht){case 20:case 24:case 22:return Ie+Xe(vr)}return rr!==-1?rr:Ie},getIndentationForToken:(ht,rr,vr,xr)=>!xr&&mt(ht,rr,vr)?Ie+Xe(vr):Ie,getIndentation:()=>Ie,getDelta:Xe,recomputeIndentation:(ht,rr)=>{rh.shouldIndentChildNode(o,rr,qe,E)&&(Ie+=ht?o.indentSize:-o.indentSize,_t=rh.shouldIndentChildNode(o,qe)?o.indentSize:0)}};function mt(ht,rr,vr){switch(rr){case 19:case 20:case 22:case 93:case 117:case 60:return!1;case 44:case 32:switch(vr.kind){case 286:case 287:case 285:return!1}break;case 23:case 24:if(vr.kind!==200)return!1;break}return et!==ht&&!(Wp(qe)&&rr===K(qe))}function Xe(ht){return rh.nodeWillIndentChild(o,qe,ht,E,!0)?_t:0}}function ue(qe,et,Ie,_t,mt,Xe){if(!d6(e,qe.getStart(E),qe.getEnd()))return;let ht=re(qe,Ie,mt,Xe),rr=et;for(Js(qe,ur=>{vr(ur,-1,qe,ht,Ie,_t,!1)},ur=>{xr(ur,qe,Ie,ht)});s.isOnToken()&&s.getTokenFullStart()<e.end;){let ur=s.readTokenInfo(qe);if(ur.token.end>Math.min(qe.end,e.end))break;jr(ur,qe,ht,qe)}function vr(ur,or,Zr,Oi,Sr,Pi,Cs,ss){if(M.assert(!Ko(ur)),$c(ur)||C_e(Zr,ur))return or;let Ii=ur.getStart(E),$r=E.getLineAndCharacterOfPosition(Ii).line,Xs=$r;Wp(ur)&&(Xs=E.getLineAndCharacterOfPosition(tH(ur,E)).line);let $e=-1;if(Cs&&Zp(e,Zr)&&($e=W(Ii,ur.end,Sr,e,or),$e!==-1&&(or=$e)),!d6(e,ur.pos,ur.end))return ur.end<e.pos&&s.skipToEndOf(ur),or;if(ur.getFullWidth()===0)return or;for(;s.isOnToken()&&s.getTokenFullStart()<e.end;){let An=s.readTokenInfo(qe);if(An.token.end>e.end)return or;if(An.token.end>Ii){An.token.pos>Ii&&s.skipToStartOf(ur);break}jr(An,qe,Oi,qe)}if(!s.isOnToken()||s.getTokenFullStart()>=e.end)return or;if(HC(ur)){let An=s.readTokenInfo(ur);if(ur.kind!==12)return M.assert(An.token.end===ur.end,"Token end is child end"),jr(An,qe,Oi,ur),or}let Yt=ur.kind===170?$r:Pi,Vr=pe(ur,$r,$e,qe,Oi,Yt);return ue(ur,rr,$r,Xs,Vr.indentation,Vr.delta),rr=qe,ss&&Zr.kind===209&&or===-1&&(or=Vr.indentation),or}function xr(ur,or,Zr,Oi){M.assert(zT(ur)),M.assert(!Ko(ur));let Sr=iRt(or,ur),Pi=Oi,Cs=Zr;if(!d6(e,ur.pos,ur.end)){ur.end<e.pos&&s.skipToEndOf(ur);return}if(Sr!==0)for(;s.isOnToken()&&s.getTokenFullStart()<e.end;){let $r=s.readTokenInfo(or);if($r.token.end>ur.pos)break;if($r.token.kind===Sr){Cs=E.getLineAndCharacterOfPosition($r.token.pos).line,jr($r,or,Oi,or);let Xs;if(G!==-1)Xs=G;else{let $e=om($r.token.pos,E);Xs=rh.findFirstNonWhitespaceColumn($e,$r.token.pos,E,o)}Pi=re(or,Zr,Xs,o.indentSize)}else jr($r,or,Oi,or)}let ss=-1;for(let $r=0;$r<ur.length;$r++){let Xs=ur[$r];ss=vr(Xs,ss,qe,Pi,Cs,Cs,!0,$r===0)}let Ii=sRt(Sr);if(Ii!==0&&s.isOnToken()&&s.getTokenFullStart()<e.end){let $r=s.readTokenInfo(or);$r.token.kind===28&&(jr($r,or,Pi,or),$r=s.isOnToken()?s.readTokenInfo(or):void 0),$r&&$r.token.kind===Ii&&Zp(or,$r.token)&&jr($r,or,Pi,or,!0)}}function jr(ur,or,Zr,Oi,Sr){M.assert(Zp(or,ur.token));let Pi=s.lastTrailingTriviaWasNewLine(),Cs=!1;ur.leadingTrivia&&ne(ur.leadingTrivia,or,rr,Zr);let ss=0,Ii=Zp(e,ur.token),$r=E.getLineAndCharacterOfPosition(ur.token.pos);if(Ii){let Xs=S(ur.token),$e=R;if(ss=le(ur.token,$r,or,rr,Zr),!Xs)if(ss===0){let Yt=$e&&E.getLineAndCharacterOfPosition($e.end).line;Cs=Pi&&$r.line!==Yt}else Cs=ss===1}if(ur.trailingTrivia&&(w=Va(ur.trailingTrivia).end,ne(ur.trailingTrivia,or,rr,Zr)),Cs){let Xs=Ii&&!S(ur.token)?Zr.getIndentationForToken($r.line,ur.token.kind,Oi,!!Sr):-1,$e=!0;if(ur.leadingTrivia){let Yt=Zr.getIndentationForComment(ur.token.kind,Xs,Oi);$e=ce(ur.leadingTrivia,Yt,$e,Vr=>de(Vr.pos,Yt,!1))}Xs!==-1&&$e&&(de(ur.token.pos,Xs,ss===1),J=$r.line,G=Xs)}s.advance(),rr=or}}function ce(qe,et,Ie,_t){for(let mt of qe){let Xe=Zp(e,mt);switch(mt.kind){case 3:Xe&&te(mt,et,!Ie),Ie=!1;break;case 2:Ie&&Xe&&_t(mt),Ie=!1;break;case 4:Ie=!0;break}}return Ie}function ne(qe,et,Ie,_t){for(let mt of qe)if(MU(mt.kind)&&Zp(e,mt)){let Xe=E.getLineAndCharacterOfPosition(mt.pos);le(mt,Xe,et,Ie,_t)}}function le(qe,et,Ie,_t,mt){let Xe=S(qe),ht=0;if(!Xe)if(R)ht=me(qe,et.line,Ie,R,F,L,_t,mt);else{let rr=E.getLineAndCharacterOfPosition(e.pos);he(rr.line,et.line)}return R=qe,w=qe.end,L=Ie,F=et.line,ht}function me(qe,et,Ie,_t,mt,Xe,ht,rr){D.updateContext(_t,Xe,qe,Ie,ht);let vr=u(D),xr=D.options.trimTrailingWhitespace!==!1,jr=0;return vr?Fi(vr,ur=>{if(jr=ct(ur,_t,mt,qe,et),rr)switch(jr){case 2:Ie.getStart(E)===qe.pos&&rr.recomputeIndentation(!1,ht);break;case 1:Ie.getStart(E)===qe.pos&&rr.recomputeIndentation(!0,ht);break;default:M.assert(jr===0)}xr=xr&&!(ur.action&16)&&ur.flags!==1}):xr=xr&&qe.kind!==1,et!==mt&&xr&&he(mt,et,_t),jr}function de(qe,et,Ie){let _t=jTe(et,o);if(Ie)De(qe,0,_t);else{let mt=E.getLineAndCharacterOfPosition(qe),Xe=q1(mt.line,E);(et!==Ae(Xe,mt.character)||xe(_t,Xe))&&De(Xe,mt.character,_t)}}function Ae(qe,et){let Ie=0;for(let _t=0;_t<et;_t++)E.text.charCodeAt(qe+_t)===9?Ie+=o.tabSize-Ie%o.tabSize:Ie++;return Ie}function xe(qe,et){return qe!==E.text.substr(et,qe.length)}function te(qe,et,Ie,_t=!0){let mt=E.getLineAndCharacterOfPosition(qe.pos).line,Xe=E.getLineAndCharacterOfPosition(qe.end).line;if(mt===Xe){Ie||de(qe.pos,et,!1);return}let ht=[],rr=qe.pos;for(let or=mt;or<Xe;or++){let Zr=G3(or,E);ht.push({pos:rr,end:Zr}),rr=q1(or+1,E)}if(_t&&ht.push({pos:rr,end:qe.end}),ht.length===0)return;let vr=q1(mt,E),xr=rh.findFirstNonWhitespaceCharacterAndColumn(vr,ht[0].pos,E,o),jr=0;Ie&&(jr=1,mt++);let ur=et-xr.column;for(let or=jr;or<ht.length;or++,mt++){let Zr=q1(mt,E),Oi=or===0?xr:rh.findFirstNonWhitespaceCharacterAndColumn(ht[or].pos,ht[or].end,E,o),Sr=Oi.column+ur;if(Sr>0){let Pi=jTe(Sr,o);De(Zr,Oi.character,Pi)}else ke(Zr,Oi.character)}}function he(qe,et,Ie){for(let _t=qe;_t<et;_t++){let mt=q1(_t,E),Xe=G3(_t,E);if(Ie&&(MU(Ie.kind)||yQ(Ie.kind))&&Ie.pos<=Xe&&Ie.end>Xe)continue;let ht=be(mt,Xe);ht!==-1&&(M.assert(ht===mt||!wg(E.text.charCodeAt(ht-1))),ke(ht,Xe+1-ht))}}function be(qe,et){let Ie=et;for(;Ie>=qe&&wg(E.text.charCodeAt(Ie));)Ie--;return Ie!==et?Ie+1:-1}function Ve(qe){let et=R?R.end:e.pos;for(let Ie of qe)MU(Ie.kind)&&(et<Ie.pos&&Pe(et,Ie.pos-1,R),et=Ie.end+1);et<e.end&&Pe(et,e.end,R)}function Pe(qe,et,Ie){let _t=E.getLineAndCharacterOfPosition(qe).line,mt=E.getLineAndCharacterOfPosition(et).line;he(_t,mt+1,Ie)}function ke(qe,et){et&&q.push(FU(qe,et,""))}function De(qe,et,Ie){(et||Ie)&&q.push(FU(qe,et,Ie))}function Be(qe,et){et&&q.push(FU(qe,0,et))}function ct(qe,et,Ie,_t,mt){let Xe=mt!==Ie;switch(qe.action){case 1:return 0;case 16:if(et.end!==_t.pos)return ke(et.end,_t.pos-et.end),Xe?2:0;break;case 32:ke(et.pos,et.end-et.pos);break;case 8:if(qe.flags!==1&&Ie!==mt)return 0;if(mt-Ie!==1)return De(et.end,_t.pos-et.end,Vv(m,o)),Xe?0:1;break;case 4:if(qe.flags!==1&&Ie!==mt)return 0;if(_t.pos-et.end!==1||E.text.charCodeAt(et.end)!==32)return De(et.end,_t.pos-et.end," "),Xe?2:0;break;case 64:Be(et.end,";")}return 0}}function Gqe(e,t,n,i=Yi(e,t)){let s=Pr(i,ag);if(s&&(i=s.parent),i.getStart(e)<=t&&t<i.getEnd())return;n=n===null?void 0:n===void 0?iu(t,e):n;let u=n&&L1(e.text,n.end),m=dH(i,e),d=ps(u,m);return d&&Ln(d,S=>lM(S,t)||t===S.end&&(S.kind===2||t===e.getFullWidth()))}function iRt(e,t){switch(e.kind){case 176:case 262:case 218:case 174:case 173:case 219:case 179:case 180:case 184:case 185:case 177:case 178:if(e.typeParameters===t)return 30;if(e.parameters===t)return 21;break;case 213:case 214:if(e.typeArguments===t)return 30;if(e.arguments===t)return 21;break;case 263:case 231:case 264:case 265:if(e.typeParameters===t)return 30;break;case 183:case 215:case 186:case 233:case 205:if(e.typeArguments===t)return 30;break;case 187:return 19}return 0}function sRt(e){switch(e){case 21:return 22;case 30:return 32;case 19:return 20}return 0}var rte,r7,n7;function jTe(e,t){if((!rte||rte.tabSize!==t.tabSize||rte.indentSize!==t.indentSize)&&(rte={tabSize:t.tabSize,indentSize:t.indentSize},r7=n7=void 0),t.convertTabsToSpaces){let i,s=Math.floor(e/t.indentSize),o=e%t.indentSize;return n7||(n7=[]),n7[s]===void 0?(i=mM(" ",t.indentSize*s),n7[s]=i):i=n7[s],o?i+mM(" ",o):i}else{let i=Math.floor(e/t.tabSize),s=e-i*t.tabSize,o;return r7||(r7=[]),r7[i]===void 0?r7[i]=o=mM("	",i):o=r7[i],s?o+mM(" ",s):o}}var rh;(e=>{let t;(te=>{te[te.Unknown=-1]="Unknown"})(t||(t={}));function n(te,he,be,Ve=!1){if(te>he.text.length)return m(be);if(be.indentStyle===0)return 0;let Pe=iu(te,he,void 0,!0),ke=Gqe(he,te,Pe||null);if(ke&&ke.kind===3)return i(he,te,be,ke);if(!Pe)return m(be);if(yQ(Pe.kind)&&Pe.getStart(he)<=te&&te<Pe.end)return 0;let Be=he.getLineAndCharacterOfPosition(te).line,ct=Yi(he,te),qe=ct.kind===19&&ct.parent.kind===210;if(be.indentStyle===1||qe)return s(he,te,be);if(Pe.kind===28&&Pe.parent.kind!==226){let Ie=E(Pe,he,be);if(Ie!==-1)return Ie}let et=ee(te,Pe.parent,he);if(et&&!Zp(et,Pe)){let _t=[218,219].includes(ct.parent.kind)?0:be.indentSize;return K(et,he,be)+_t}return o(he,te,Pe,Be,Ve,be)}e.getIndentation=n;function i(te,he,be,Ve){let Pe=ba(te,he).line-1,ke=ba(te,Ve.pos).line;if(M.assert(ke>=0),Pe<=ke)return le(q1(ke,te),he,te,be);let De=q1(Pe,te),{column:Be,character:ct}=ne(De,he,te,be);return Be===0?Be:te.text.charCodeAt(De+ct)===42?Be-1:Be}function s(te,he,be){let Ve=he;for(;Ve>0;){let ke=te.text.charCodeAt(Ve);if(!by(ke))break;Ve--}let Pe=om(Ve,te);return le(Pe,Ve,te,be)}function o(te,he,be,Ve,Pe,ke){let De,Be=be;for(;Be;){if(fQ(Be,he,te)&&Ae(ke,Be,De,te,!0)){let qe=R(Be,te),et=w(be,Be,Ve,te),Ie=et!==0?Pe&&et===2?ke.indentSize:0:Ve!==qe.line?ke.indentSize:0;return d(Be,qe,void 0,Ie,te,!0,ke)}let ct=re(Be,te,ke,!0);if(ct!==-1)return ct;De=Be,Be=Be.parent}return m(ke)}function u(te,he,be,Ve){let Pe=be.getLineAndCharacterOfPosition(te.getStart(be));return d(te,Pe,he,0,be,!1,Ve)}e.getIndentationForNode=u;function m(te){return te.baseIndentSize||0}e.getBaseIndentation=m;function d(te,he,be,Ve,Pe,ke,De){var Be;let ct=te.parent;for(;ct;){let qe=!0;if(be){let mt=te.getStart(Pe);qe=mt<be.pos||mt>be.end}let et=S(ct,te,Pe),Ie=et.line===he.line||F(ct,te,he.line,Pe);if(qe){let mt=(Be=q(te,Pe))==null?void 0:Be[0],Xe=!!mt&&R(mt,Pe).line>et.line,ht=re(te,Pe,De,Xe);if(ht!==-1||(ht=x(te,ct,he,Ie,Pe,De),ht!==-1))return ht+Ve}Ae(De,ct,te,Pe,ke)&&!Ie&&(Ve+=De.indentSize);let _t=L(ct,te,he.line,Pe);te=ct,ct=te.parent,he=_t?Pe.getLineAndCharacterOfPosition(te.getStart(Pe)):et}return Ve+m(De)}function S(te,he,be){let Ve=q(he,be),Pe=Ve?Ve.pos:te.getStart(be);return be.getLineAndCharacterOfPosition(Pe)}function E(te,he,be){let Ve=v0e(te);return Ve&&Ve.listItemIndex>0?ue(Ve.list.getChildren(),Ve.listItemIndex-1,he,be):-1}function x(te,he,be,Ve,Pe,ke){return(u_(te)||W3(te))&&(he.kind===307||!Ve)?ce(be,Pe,ke):-1}let D;(te=>{te[te.Unknown=0]="Unknown",te[te.OpenBrace=1]="OpenBrace",te[te.CloseBrace=2]="CloseBrace"})(D||(D={}));function w(te,he,be,Ve){let Pe=NE(te,he,Ve);if(!Pe)return 0;if(Pe.kind===19)return 1;if(Pe.kind===20){let ke=R(Pe,Ve).line;return be===ke?2:0}return 0}function R(te,he){return he.getLineAndCharacterOfPosition(te.getStart(he))}function L(te,he,be,Ve){if(!(ea(te)&&Es(te.arguments,he)))return!1;let Pe=te.expression.getEnd();return ba(Ve,Pe).line===be}e.isArgumentAndStartLineOverlapsExpressionBeingCalled=L;function F(te,he,be,Ve){if(te.kind===245&&te.elseStatement===he){let Pe=Oo(te,93,Ve);return M.assert(Pe!==void 0),R(Pe,Ve).line===be}return!1}e.childStartsOnTheSameLineWithElseInIfStatement=F;function J(te,he,be,Ve){if(UA(te)&&(he===te.whenTrue||he===te.whenFalse)){let Pe=ba(Ve,te.condition.end).line;if(he===te.whenTrue)return be===Pe;{let ke=R(te.whenTrue,Ve).line,De=ba(Ve,te.whenTrue.end).line;return Pe===ke&&De===be}}return!1}e.childIsUnindentedBranchOfConditionalExpression=J;function G(te,he,be,Ve){if(Ig(te)){if(!te.arguments)return!1;let Pe=Ln(te.arguments,ct=>ct.pos===he.pos);if(!Pe)return!1;let ke=te.arguments.indexOf(Pe);if(ke===0)return!1;let De=te.arguments[ke-1],Be=ba(Ve,De.getEnd()).line;if(be===Be)return!0}return!1}e.argumentStartsOnSameLineAsPreviousArgument=G;function q(te,he){return te.parent&&W(te.getStart(he),te.getEnd(),te.parent,he)}e.getContainingList=q;function ee(te,he,be){return he&&W(te,te,he,be)}function W(te,he,be,Ve){switch(be.kind){case 183:return Pe(be.typeArguments);case 210:return Pe(be.properties);case 209:return Pe(be.elements);case 187:return Pe(be.members);case 262:case 218:case 219:case 174:case 173:case 179:case 176:case 185:case 180:return Pe(be.typeParameters)||Pe(be.parameters);case 177:return Pe(be.parameters);case 263:case 231:case 264:case 265:case 345:return Pe(be.typeParameters);case 214:case 213:return Pe(be.typeArguments)||Pe(be.arguments);case 261:return Pe(be.declarations);case 275:case 279:return Pe(be.elements);case 206:case 207:return Pe(be.elements)}function Pe(ke){return ke&&uM(pe(be,ke,Ve),te,he)?ke:void 0}}function pe(te,he,be){let Ve=te.getChildren(be);for(let Pe=1;Pe<Ve.length-1;Pe++)if(Ve[Pe].pos===he.pos&&Ve[Pe].end===he.end)return{pos:Ve[Pe-1].end,end:Ve[Pe+1].getStart(be)};return he}function K(te,he,be){return te?ce(he.getLineAndCharacterOfPosition(te.pos),he,be):-1}function re(te,he,be,Ve){if(te.parent&&te.parent.kind===261)return-1;let Pe=q(te,he);if(Pe){let ke=Pe.indexOf(te);if(ke!==-1){let De=ue(Pe,ke,he,be);if(De!==-1)return De}return K(Pe,he,be)+(Ve?be.indentSize:0)}return-1}function ue(te,he,be,Ve){M.assert(he>=0&&he<te.length);let Pe=te[he],ke=R(Pe,be);for(let De=he-1;De>=0;De--){if(te[De].kind===28)continue;if(be.getLineAndCharacterOfPosition(te[De].end).line!==ke.line)return ce(ke,be,Ve);ke=R(te[De],be)}return-1}function ce(te,he,be){let Ve=he.getPositionOfLineAndCharacter(te.line,0);return le(Ve,Ve+te.character,he,be)}function ne(te,he,be,Ve){let Pe=0,ke=0;for(let De=te;De<he;De++){let Be=be.text.charCodeAt(De);if(!wg(Be))break;Be===9?ke+=Ve.tabSize+ke%Ve.tabSize:ke++,Pe++}return{column:ke,character:Pe}}e.findFirstNonWhitespaceCharacterAndColumn=ne;function le(te,he,be,Ve){return ne(te,he,be,Ve).column}e.findFirstNonWhitespaceColumn=le;function me(te,he,be,Ve,Pe){let ke=be?be.kind:0;switch(he.kind){case 244:case 263:case 231:case 264:case 266:case 265:case 209:case 241:case 268:case 210:case 187:case 200:case 189:case 217:case 211:case 213:case 214:case 243:case 277:case 253:case 227:case 207:case 206:case 286:case 289:case 285:case 294:case 173:case 179:case 180:case 169:case 184:case 185:case 196:case 215:case 223:case 279:case 275:case 281:case 276:case 172:case 296:case 297:return!0;case 269:return te.indentSwitchCase??!0;case 260:case 303:case 226:if(!te.indentMultiLineObjectLiteralBeginningOnBlankLine&&Ve&&ke===210)return xe(Ve,be);if(he.kind===226&&Ve&&be&&ke===284){let De=Ve.getLineAndCharacterOfPosition(Ja(Ve.text,he.pos)).line,Be=Ve.getLineAndCharacterOfPosition(Ja(Ve.text,be.pos)).line;return De!==Be}if(he.kind!==226)return!0;break;case 246:case 247:case 249:case 250:case 248:case 245:case 262:case 218:case 174:case 176:case 177:case 178:return ke!==241;case 219:return Ve&&ke===217?xe(Ve,be):ke!==241;case 278:return ke!==279;case 272:return ke!==273||!!be.namedBindings&&be.namedBindings.kind!==275;case 284:return ke!==287;case 288:return ke!==290;case 193:case 192:case 238:if(ke===187||ke===189||ke===200)return!1;break}return Pe}e.nodeWillIndentChild=me;function de(te,he){switch(te){case 253:case 257:case 251:case 252:return he.kind!==241;default:return!1}}function Ae(te,he,be,Ve,Pe=!1){return me(te,he,be,Ve,!1)&&!(Pe&&be&&de(be.kind,he))}e.shouldIndentChildNode=Ae;function xe(te,he){let be=Ja(te.text,he.pos),Ve=te.getLineAndCharacterOfPosition(be).line,Pe=te.getLineAndCharacterOfPosition(he.end).line;return Ve===Pe}})(rh||(rh={}));var nte={};A(nte,{pasteEditsProvider:()=>oRt});var aRt="providePostPasteEdits";function oRt(e,t,n,i,s,o,u,m){return{edits:Sn.ChangeTracker.with({host:s,formatContext:u,preferences:o},S=>cRt(e,t,n,i,s,o,u,m,S)),fixId:aRt}}function cRt(e,t,n,i,s,o,u,m,d){let S;t.length!==n.length&&(S=t.length===1?t:[t.join(`
`)]);let E=[],x=e.text;for(let D=n.length-1;D>=0;D--){let{pos:w,end:R}=n[D];x=S?x.slice(0,w)+S[0]+x.slice(R):x.slice(0,w)+t[D]+x.slice(R)}M.checkDefined(s.runWithTemporaryFileUpdate).call(s,e.fileName,x,(D,w,R)=>{let L=A_.createImportAdder(R,D,o,s);if(i?.range){M.assert(i.range.length===t.length),i.range.forEach(G=>{let q=i.file.statements,ee=Bo(q,pe=>pe.end>G.pos);if(ee===-1)return;let W=Bo(q,pe=>pe.end>=G.end,ee);W!==-1&&G.end<=q[W].getStart()&&W--,E.push(...q.slice(ee,W===-1?q.length:W+1))});let F=gV(i.file,E,w.getTypeChecker(),o1e(R,E,w.getTypeChecker()));M.assertIsDefined(w);let J=!iZ(e.fileName,w,s,!!i.file.commonJsModuleIndicator);Qve(i.file,F.targetFileImportsFromOldFile,d,J),l1e(i.file,F.oldImportsNeededByTargetFile,F.targetFileImportsFromOldFile,w.getTypeChecker(),D,L)}else{let F={sourceFile:R,program:w,cancellationToken:m,host:s,preferences:o,formatContext:u};Js(R,function J(G){He(G)&&!w?.getTypeChecker().resolveName(G.text,G,-1,!1)&&L.addImportForUnresolvedIdentifier(F,G,!0),G.forEachChild(J)})}L.writeFixes(d,ed(i?i.file:e,o))}),n.forEach((D,w)=>{d.replaceRangeWithText(e,{pos:D.pos,end:D.end},S?S[0]:t[w])})}var Yqe={};A(Yqe,{ANONYMOUS:()=>GQ,AccessFlags:()=>Rle,AssertionLevel:()=>zce,AssignmentDeclarationKind:()=>qle,AssignmentKind:()=>pfe,Associativity:()=>Tfe,BreakpointResolver:()=>HZ,BuilderFileEmit:()=>Xhe,BuilderProgramKind:()=>iye,BuilderState:()=>lg,CallHierarchy:()=>uk,CharacterCodes:()=>eue,CheckFlags:()=>Dle,CheckMode:()=>dK,ClassificationType:()=>tQ,ClassificationTypeNames:()=>u0e,CommentDirectiveType:()=>mle,Comparison:()=>ze,CompletionInfoFlags:()=>n0e,CompletionTriggerKind:()=>ZX,Completions:()=>gk,ContainerFlags:()=>Age,ContextFlags:()=>Tle,Debug:()=>M,DiagnosticCategory:()=>c5,Diagnostics:()=>v,DocumentHighlights:()=>_V,ElementFlags:()=>Ole,EmitFlags:()=>o$,EmitHint:()=>sue,EmitOnly:()=>hle,EndOfLineState:()=>a0e,ExitStatus:()=>yle,ExportKind:()=>ove,Extension:()=>tue,ExternalEmitHelpers:()=>iue,FileIncludeKind:()=>XW,FilePreprocessingDiagnosticsKind:()=>gle,FileSystemEntryKind:()=>due,FileWatcherEventKind:()=>_ue,FindAllReferences:()=>lc,FlattenLevel:()=>Zge,FlowFlags:()=>o5,ForegroundColorEscapeSequences:()=>qhe,FunctionFlags:()=>vfe,GeneratedIdentifierFlags:()=>KW,GetLiteralTextFlags:()=>k_e,GoToDefinition:()=>oD,HighlightSpanKind:()=>t0e,IdentifierNameMap:()=>LN,IdentifierNameMultiMap:()=>$ge,ImportKind:()=>ave,ImportsNotUsedAsValues:()=>Yle,IndentStyle:()=>r0e,IndexFlags:()=>Mle,IndexKind:()=>jle,InferenceFlags:()=>Vle,InferencePriority:()=>Ule,InlayHintKind:()=>e0e,InlayHints:()=>jee,InternalEmitFlags:()=>rue,InternalSymbolName:()=>wle,IntersectionFlags:()=>ble,InvalidatedProjectKind:()=>Pye,JSDocParsingMode:()=>uue,JsDoc:()=>Bb,JsTyping:()=>eh,JsxEmit:()=>Gle,JsxFlags:()=>fle,JsxReferenceKind:()=>Lle,LanguageFeatureMinimumTarget:()=>nue,LanguageServiceMode:()=>Qye,LanguageVariant:()=>Qle,LexicalEnvironmentFlags:()=>oue,ListFormat:()=>cue,LogLevel:()=>tle,MapCode:()=>Bee,MemberOverrideStatus:()=>vle,ModifierFlags:()=>GW,ModuleDetectionKind:()=>zle,ModuleInstanceState:()=>xge,ModuleKind:()=>y3,ModuleResolutionKind:()=>rI,ModuleSpecifierEnding:()=>bpe,NavigateTo:()=>Nve,NavigationBar:()=>wve,NewLineKind:()=>Kle,NodeBuilderFlags:()=>Ele,NodeCheckFlags:()=>e$,NodeFactoryFlags:()=>Hpe,NodeFlags:()=>HW,NodeResolutionFeatures:()=>dge,ObjectFlags:()=>r$,OperationCanceledException:()=>tI,OperatorPrecedence:()=>Efe,OrganizeImports:()=>Ub,OrganizeImportsMode:()=>QX,OuterExpressionKinds:()=>aue,OutliningElementsCollector:()=>Jee,OutliningSpanKind:()=>i0e,OutputFileType:()=>s0e,PackageJsonAutoImportPreference:()=>Xye,PackageJsonDependencyGroup:()=>Kye,PatternMatchKind:()=>dZ,PollingInterval:()=>c$,PollingWatchKind:()=>Hle,PragmaKindFlags:()=>lue,PrivateIdentifierKind:()=>ide,ProcessLevel:()=>she,ProgramUpdateLevel:()=>jhe,QuotePreference:()=>R0e,RegularExpressionFlags:()=>ple,RelationComparisonResult:()=>YW,Rename:()=>KV,ScriptElementKind:()=>c0e,ScriptElementKindModifier:()=>l0e,ScriptKind:()=>i$,ScriptSnapshot:()=>yU,ScriptTarget:()=>Xle,SemanticClassificationFormat:()=>Zye,SemanticMeaning:()=>_0e,SemicolonPreference:()=>eQ,SignatureCheckMode:()=>mK,SignatureFlags:()=>n$,SignatureHelp:()=>YM,SignatureInfo:()=>Khe,SignatureKind:()=>Fle,SmartSelectionRange:()=>Wee,SnippetKind:()=>a$,StatisticType:()=>Uye,StructureIsReused:()=>QW,SymbolAccessibility:()=>Ale,SymbolDisplay:()=>zv,SymbolDisplayPartKind:()=>SU,SymbolFlags:()=>ZW,SymbolFormatFlags:()=>Cle,SyntaxKind:()=>$W,SyntheticSymbolKind:()=>kle,Ternary:()=>Jle,ThrottledCancellationToken:()=>U1e,TokenClass:()=>o0e,TokenFlags:()=>dle,TransformFlags:()=>s$,TypeFacts:()=>pK,TypeFlags:()=>t$,TypeFormatFlags:()=>xle,TypeMapKind:()=>Ble,TypePredicateKind:()=>Ple,TypeReferenceSerializationKind:()=>Nle,UnionReduction:()=>Sle,UpToDateStatusType:()=>bye,VarianceFlags:()=>Ile,Version:()=>Km,VersionRange:()=>s5,WatchDirectoryFlags:()=>Zle,WatchDirectoryKind:()=>$le,WatchFileKind:()=>Wle,WatchLogLevel:()=>Uhe,WatchType:()=>Tu,accessPrivateIdentifier:()=>Xge,addDisposableResourceHelper:()=>Ide,addEmitFlags:()=>zg,addEmitHelper:()=>NA,addEmitHelpers:()=>E0,addInternalEmitFlags:()=>kA,addNodeFactoryPatcher:()=>f4e,addObjectAllocatorPatcher:()=>X6e,addRange:()=>wn,addRelatedInfo:()=>ca,addSyntheticLeadingComment:()=>vO,addSyntheticTrailingComment:()=>Tj,addToSeen:()=>em,advancedAsyncSuperHelper:()=>Aj,affectsDeclarationPathOptionDeclarations:()=>Mme,affectsEmitOptionDeclarations:()=>Rme,allKeysStartWithDot:()=>TB,altDirectorySeparator:()=>f5,and:()=>r5,append:()=>Bt,appendIfUnique:()=>$o,arrayFrom:()=>Is,arrayIsEqualTo:()=>Vp,arrayIsHomogeneous:()=>Dpe,arrayIsSorted:()=>NW,arrayOf:()=>Bce,arrayReverseIterator:()=>Ra,arrayToMap:()=>xP,arrayToMultiMap:()=>f3,arrayToNumericMap:()=>Vce,arraysEqual:()=>UT,assertType:()=>mOe,assign:()=>Mx,assignHelper:()=>fde,asyncDelegator:()=>dde,asyncGeneratorHelper:()=>pde,asyncSuperHelper:()=>Cj,asyncValues:()=>mde,attachFileToDiagnostics:()=>yA,awaitHelper:()=>SO,awaiterHelper:()=>hde,base64decode:()=>Gfe,base64encode:()=>Hfe,binarySearch:()=>mv,binarySearchKey:()=>BC,bindSourceFile:()=>kge,breakIntoCharacterSpans:()=>bve,breakIntoWordSpans:()=>Tve,buildLinkParts:()=>q0e,buildOpts:()=>A8,buildOverload:()=>Qqe,bundlerModuleNameResolver:()=>mge,canBeConvertedToAsync:()=>SZ,canHaveDecorators:()=>TE,canHaveExportModifier:()=>XR,canHaveFlowNode:()=>ER,canHaveIllegalDecorators:()=>EY,canHaveIllegalModifiers:()=>mme,canHaveIllegalType:()=>j4e,canHaveIllegalTypeParameters:()=>dme,canHaveJSDoc:()=>xR,canHaveLocals:()=>Lh,canHaveModifiers:()=>wm,canHaveSymbol:()=>Zm,canIncludeBindAndCheckDiagnsotics:()=>KR,canJsonReportNoInputFiles:()=>VO,canProduceDiagnostics:()=>LB,canUsePropertyAccess:()=>OG,canWatchAffectingLocation:()=>fye,canWatchAtTypes:()=>_ye,canWatchDirectoryOrFile:()=>eU,cartesianProduct:()=>Zce,cast:()=>aa,chainBundle:()=>cg,chainDiagnosticMessages:()=>js,changeAnyExtension:()=>b3,changeCompilerHostLikeToUseCache:()=>a6,changeExtension:()=>Y1,changeFullExtension:()=>yue,changesAffectModuleResolution:()=>U5,changesAffectingProgramStructure:()=>S_e,characterToRegularExpressionFlag:()=>S$,childIsDecorated:()=>wI,classElementOrClassElementParameterIsDecorated:()=>yH,classHasClassThisAssignment:()=>DK,classHasDeclaredOrExplicitlyAssignedName:()=>wK,classHasExplicitlyAssignedName:()=>OB,classOrConstructorParameterIsDecorated:()=>Cv,classPrivateFieldGetHelper:()=>Nde,classPrivateFieldInHelper:()=>wde,classPrivateFieldSetHelper:()=>Dde,classicNameResolver:()=>Tge,classifier:()=>z1e,cleanExtendedConfigCache:()=>zB,clear:()=>Ym,clearMap:()=>Vf,clearSharedExtendedConfigFileWatcher:()=>zK,climbPastPropertyAccess:()=>EU,climbPastPropertyOrElementAccess:()=>m0e,clone:()=>Jce,cloneCompilerOptions:()=>SQ,closeFileWatcher:()=>Dm,closeFileWatcherOf:()=>Nd,codefix:()=>A_,collapseTextChangeRangesAcrossMultipleVersions:()=>Oue,collectExternalModuleInfo:()=>AK,combine:()=>vs,combinePaths:()=>ri,commandLineOptionOfCustomType:()=>Ume,commentPragmas:()=>l5,commonOptionsWithBuild:()=>tB,commonPackageFolders:()=>mpe,compact:()=>cn,compareBooleans:()=>XS,compareDataObjects:()=>cG,compareDiagnostics:()=>rO,compareDiagnosticsSkipRelatedInformation:()=>z9,compareEmitHelpers:()=>ade,compareNumberOfDirectorySeparators:()=>GR,comparePaths:()=>_0,comparePathsCaseInsensitive:()=>jOe,comparePathsCaseSensitive:()=>FOe,comparePatternKeys:()=>lK,compareProperties:()=>Yce,compareStringsCaseInsensitive:()=>d3,compareStringsCaseInsensitiveEslintCompatible:()=>Wce,compareStringsCaseSensitive:()=>c_,compareStringsCaseSensitiveUI:()=>m3,compareTextSpans:()=>e5,compareValues:()=>tc,compileOnSaveCommandLineOption:()=>Zj,compilerOptionsAffectDeclarationPath:()=>ppe,compilerOptionsAffectEmit:()=>fpe,compilerOptionsAffectSemanticDiagnostics:()=>_pe,compilerOptionsDidYouMeanDiagnostics:()=>sB,compilerOptionsIndicateEsModules:()=>kQ,compose:()=>pOe,computeCommonSourceDirectoryOfFilenames:()=>Vhe,computeLineAndCharacterOfPosition:()=>NP,computeLineOfPosition:()=>oI,computeLineStarts:()=>$C,computePositionOfLineAndCharacter:()=>h5,computeSignature:()=>sye,computeSignatureWithDiagnostics:()=>fX,computeSuggestionDiagnostics:()=>hZ,computedOptions:()=>Ql,concatenate:()=>ps,concatenateDiagnosticMessageChains:()=>ope,configDirTemplateSubstitutionOptions:()=>jme,configDirTemplateSubstitutionWatchOptions:()=>Bme,consumesNodeCoreModules:()=>tV,contains:()=>Es,containsIgnoredPath:()=>pO,containsObjectRestOrSpread:()=>T8,containsParseError:()=>VP,containsPath:()=>Cm,convertCompilerOptionsForTelemetry:()=>rge,convertCompilerOptionsFromJson:()=>G3e,convertJsonOption:()=>g2,convertToBase64:()=>$fe,convertToJson:()=>N8,convertToObject:()=>Yme,convertToOptionsWithAbsolutePaths:()=>lB,convertToRelativePath:()=>sI,convertToTSConfig:()=>WY,convertTypeAcquisitionFromJson:()=>Y3e,copyComments:()=>T2,copyEntries:()=>V5,copyLeadingComments:()=>QN,copyProperties:()=>OW,copyTrailingAsLeadingComments:()=>TM,copyTrailingComments:()=>b6,couldStartTrivia:()=>Eue,countWhere:()=>vy,createAbstractBuilder:()=>K8e,createAccessorPropertyBackingField:()=>AY,createAccessorPropertyGetRedirector:()=>Eme,createAccessorPropertySetRedirector:()=>xme,createBaseNodeFactory:()=>Jpe,createBinaryExpressionTrampoline:()=>Kj,createBindingHelper:()=>xj,createBuildInfo:()=>UB,createBuilderProgram:()=>pX,createBuilderProgramUsingProgramBuildInfo:()=>lye,createBuilderStatusReporter:()=>lU,createCacheWithRedirects:()=>tK,createCacheableExportInfoMap:()=>sZ,createCachedDirectoryStructureHost:()=>JB,createClassNamedEvaluationHelperBlock:()=>ihe,createClassThisAssignmentBlock:()=>rhe,createClassifier:()=>N7e,createCommentDirectivesMap:()=>A_e,createCompilerDiagnostic:()=>Nc,createCompilerDiagnosticForInvalidCustomType:()=>Vme,createCompilerDiagnosticFromMessageChain:()=>q9,createCompilerHost:()=>Jhe,createCompilerHostFromProgramHost:()=>OX,createCompilerHostWorker:()=>WB,createDetachedDiagnostic:()=>hA,createDiagnosticCollection:()=>WI,createDiagnosticForFileFromMessageChain:()=>pH,createDiagnosticForNode:()=>pn,createDiagnosticForNodeArray:()=>qP,createDiagnosticForNodeArrayFromMessageChain:()=>Z3,createDiagnosticForNodeFromMessageChain:()=>ky,createDiagnosticForNodeInSourceFile:()=>bd,createDiagnosticForRange:()=>U_e,createDiagnosticMessageChainFromDiagnostic:()=>B_e,createDiagnosticReporter:()=>rk,createDocumentPositionMapper:()=>zge,createDocumentRegistry:()=>uve,createDocumentRegistryInternal:()=>_Z,createEmitAndSemanticDiagnosticsBuilderProgram:()=>hX,createEmitHelperFactory:()=>sde,createEmptyExports:()=>m8,createEvaluator:()=>Bpe,createExpressionForJsxElement:()=>ome,createExpressionForJsxFragment:()=>cme,createExpressionForObjectLiteralElementLike:()=>lme,createExpressionForPropertyName:()=>hY,createExpressionFromEntityName:()=>g8,createExternalHelpersImportDeclarationIfNeeded:()=>SY,createFileDiagnostic:()=>bu,createFileDiagnosticFromMessageChain:()=>X5,createFlowNode:()=>Wh,createForOfBindingStatement:()=>gY,createFutureSourceFile:()=>lV,createGetCanonicalFileName:()=>l_,createGetIsolatedDeclarationErrors:()=>Phe,createGetSourceFile:()=>YK,createGetSymbolAccessibilityDiagnosticForNode:()=>Fv,createGetSymbolAccessibilityDiagnosticForNodeName:()=>khe,createGetSymbolWalker:()=>Pge,createIncrementalCompilerHost:()=>cU,createIncrementalProgram:()=>Sye,createJsxFactoryExpression:()=>mY,createLanguageService:()=>V1e,createLanguageServiceSourceFile:()=>kV,createMemberAccessForPropertyName:()=>d2,createModeAwareCache:()=>wN,createModeAwareCacheKey:()=>WO,createModuleNotFoundChain:()=>J5,createModuleResolutionCache:()=>IN,createModuleResolutionLoader:()=>nX,createModuleResolutionLoaderUsingGlobalCache:()=>gye,createModuleSpecifierResolutionHost:()=>ak,createMultiMap:()=>yd,createNameResolver:()=>jG,createNodeConverters:()=>Wpe,createNodeFactory:()=>t8,createOptionNameMap:()=>nB,createOverload:()=>ite,createPackageJsonImportFilter:()=>ZN,createPackageJsonInfo:()=>XQ,createParenthesizerRules:()=>qpe,createPatternMatcher:()=>mve,createPrinter:()=>oS,createPrinterWithDefaults:()=>Lhe,createPrinterWithRemoveComments:()=>v2,createPrinterWithRemoveCommentsNeverAsciiEscape:()=>Fhe,createPrinterWithRemoveCommentsOmitTrailingSemicolon:()=>VB,createProgram:()=>X8,createProgramHost:()=>RX,createPropertyNameNodeForIdentifierOrLiteral:()=>pj,createQueue:()=>p3,createRange:()=>Td,createRedirectedBuilderProgram:()=>gX,createResolutionCache:()=>vX,createRuntimeTypeSerializer:()=>uhe,createScanner:()=>xy,createSemanticDiagnosticsBuilderProgram:()=>Y8e,createSet:()=>RW,createSolutionBuilder:()=>Cye,createSolutionBuilderHost:()=>Eye,createSolutionBuilderWithWatch:()=>Aye,createSolutionBuilderWithWatchHost:()=>xye,createSortedArray:()=>Rx,createSourceFile:()=>HA,createSourceMapGenerator:()=>jge,createSourceMapSource:()=>g4e,createSuperAccessVariableStatement:()=>MB,createSymbolTable:()=>fa,createSymlinkCache:()=>vG,createSyntacticTypeNodeBuilder:()=>Hye,createSystemWatchFunctions:()=>mue,createTextChange:()=>dM,createTextChangeFromStartLength:()=>FU,createTextChangeRange:()=>D3,createTextRangeFromNode:()=>EQ,createTextRangeFromSpan:()=>LU,createTextSpan:()=>zu,createTextSpanFromBounds:()=>Il,createTextSpanFromNode:()=>df,createTextSpanFromRange:()=>lS,createTextSpanFromStringLiteralLikeContent:()=>TQ,createTextWriter:()=>MR,createTokenRange:()=>iG,createTypeChecker:()=>Lge,createTypeReferenceDirectiveResolutionCache:()=>yB,createTypeReferenceResolutionLoader:()=>$B,createWatchCompilerHost:()=>aMe,createWatchCompilerHostOfConfigFile:()=>MX,createWatchCompilerHostOfFilesAndCompilerOptions:()=>LX,createWatchFactory:()=>IX,createWatchHost:()=>wX,createWatchProgram:()=>FX,createWatchStatusReporter:()=>bX,createWriteFileMeasuringIO:()=>KK,declarationNameToString:()=>Yo,decodeMappings:()=>EK,decodedTextSpanIntersectsWith:()=>N3,decorateHelper:()=>ode,deduplicate:()=>I1,defaultIncludeSpec:()=>GY,defaultInitCompilerOptions:()=>jY,defaultMaximumTruncationLength:()=>xI,diagnosticCategoryName:()=>Bx,diagnosticToString:()=>wE,diagnosticsEqualityComparer:()=>W9,directoryProbablyExists:()=>rg,directorySeparator:()=>Ec,displayPart:()=>Jf,displayPartsToString:()=>MM,disposeEmitNodes:()=>VG,disposeResourcesHelper:()=>Ode,documentSpansEqual:()=>RQ,dumpTracingLegend:()=>_le,elementAt:()=>Dl,elideNodes:()=>Tme,emitComments:()=>Mfe,emitDetachedComments:()=>Lfe,emitFiles:()=>JK,emitFilesAndReportErrors:()=>iU,emitFilesAndReportErrorsAndGetExitStatus:()=>DX,emitModuleKindIsNonNodeESM:()=>H9,emitNewLineBeforeLeadingCommentOfPosition:()=>Rfe,emitNewLineBeforeLeadingComments:()=>Ife,emitNewLineBeforeLeadingCommentsOfPosition:()=>Ofe,emitResolverSkipsTypeChecking:()=>VK,emitSkippedWithNoDiagnostics:()=>lX,emptyArray:()=>ve,emptyFileSystemEntries:()=>CG,emptyMap:()=>lr,emptyOptions:()=>am,emptySet:()=>Br,endsWith:()=>Wc,ensurePathIsNonModuleName:()=>Vx,ensureScriptKind:()=>nj,ensureTrailingDirectorySeparator:()=>yu,entityNameToString:()=>op,enumerateInsertsAndDeletes:()=>i5,equalOwnProperties:()=>Uce,equateStringsCaseInsensitive:()=>KS,equateStringsCaseSensitive:()=>Lx,equateValues:()=>gv,esDecorateHelper:()=>ude,escapeJsxAttributeString:()=>qH,escapeLeadingUnderscores:()=>Uc,escapeNonAsciiString:()=>E9,escapeSnippetText:()=>_E,escapeString:()=>Vh,escapeTemplateSubstitution:()=>VH,evaluatorResult:()=>_u,every:()=>wi,executeCommandLine:()=>VMe,expandPreOrPostfixIncrementOrDecrementExpression:()=>zj,explainFiles:()=>CX,explainIfFileIsRedirectAndImpliedFormat:()=>AX,exportAssignmentIsAlias:()=>ZP,exportStarHelper:()=>Pde,expressionResultIsUnused:()=>Ipe,extend:()=>ZF,extendsHelper:()=>yde,extensionFromPath:()=>cO,extensionIsTS:()=>lj,extensionsNotSupportingExtensionlessResolution:()=>oj,externalHelpersModuleNameText:()=>ab,factory:()=>U,fileExtensionIs:()=>Ic,fileExtensionIsOneOf:()=>wl,fileIncludeReasonToDiagnostics:()=>NX,fileShouldUseJavaScriptRequire:()=>iZ,filter:()=>Zn,filterMutate:()=>zw,filterSemanticDiagnostics:()=>KB,find:()=>Ln,findAncestor:()=>Pr,findBestPatternMatch:()=>BW,findChildOfKind:()=>Oo,findComputedPropertyNameCacheAssignment:()=>Xj,findConfigFile:()=>HK,findConstructorDeclaration:()=>e8,findContainingList:()=>PU,findDiagnosticForNode:()=>tve,findFirstNonJsxWhitespaceToken:()=>S0e,findIndex:()=>Bo,findLast:()=>xm,findLastIndex:()=>pv,findListItemInfo:()=>v0e,findMap:()=>Jw,findModifier:()=>YN,findNextToken:()=>NE,findPackageJson:()=>Z0e,findPackageJsons:()=>KQ,findPrecedingMatchingToken:()=>RU,findPrecedingToken:()=>iu,findSuperStatementIndexPath:()=>DB,findTokenOnLeftOfPosition:()=>wU,findUseStrictPrologue:()=>vY,first:()=>Ma,firstDefined:()=>yi,firstDefinedIterator:()=>qo,firstIterator:()=>_3,firstOrOnly:()=>tZ,firstOrUndefined:()=>xo,firstOrUndefinedIterator:()=>Nh,fixupCompilerOptions:()=>bZ,flatMap:()=>va,flatMapIterator:()=>c3,flatMapToMutable:()=>M_,flatten:()=>ef,flattenCommaList:()=>Cme,flattenDestructuringAssignment:()=>y2,flattenDestructuringBinding:()=>CE,flattenDiagnosticMessageText:()=>Zg,forEach:()=>kt,forEachAncestor:()=>b_e,forEachAncestorDirectory:()=>Am,forEachChild:()=>Js,forEachChildRecursively:()=>$A,forEachEmittedFile:()=>FK,forEachEnclosingBlockScopeContainer:()=>L_e,forEachEntry:()=>Nu,forEachExternalModuleToImportFrom:()=>oZ,forEachImportClauseDeclaration:()=>_fe,forEachKey:()=>d0,forEachLeadingCommentRange:()=>x3,forEachNameInAccessChainWalkingLeft:()=>rpe,forEachNameOfDefaultExport:()=>cZ,forEachPropertyAssignment:()=>$P,forEachResolvedProjectReference:()=>sX,forEachReturnStatement:()=>xv,forEachRight:()=>Fi,forEachTrailingCommentRange:()=>C3,forEachTsConfigPropArray:()=>iR,forEachUnique:()=>LQ,forEachYieldExpression:()=>$_e,forSomeAncestorDirectory:()=>Y6e,formatColorAndReset:()=>AE,formatDiagnostic:()=>XK,formatDiagnostics:()=>k8e,formatDiagnosticsWithColorAndContext:()=>$he,formatGeneratedName:()=>xb,formatGeneratedNamePart:()=>kN,formatLocation:()=>QK,formatMessage:()=>vA,formatStringFromArgs:()=>wy,formatting:()=>zl,fullTripleSlashAMDReferencePathRegEx:()=>W_e,fullTripleSlashReferencePathRegEx:()=>z_e,generateDjb2Hash:()=>nI,generateTSConfig:()=>Xme,generatorHelper:()=>Cde,getAdjustedReferenceLocation:()=>dQ,getAdjustedRenameLocation:()=>DU,getAliasDeclarationFromName:()=>DH,getAllAccessorDeclarations:()=>W1,getAllDecoratorsOfClass:()=>PK,getAllDecoratorsOfClassElement:()=>IB,getAllJSDocTags:()=>C5,getAllJSDocTagsOfKind:()=>a6e,getAllKeys:()=>lOe,getAllProjectOutputs:()=>BB,getAllSuperTypeNodes:()=>BI,getAllowJSCompilerOption:()=>H1,getAllowSyntheticDefaultImports:()=>SA,getAncestor:()=>pb,getAnyExtensionFromPath:()=>PP,getAreDeclarationMapsEnabled:()=>$9,getAssignedExpandoInitializer:()=>iA,getAssignedName:()=>E5,getAssignedNameOfIdentifier:()=>t6,getAssignmentDeclarationKind:()=>cl,getAssignmentDeclarationPropertyAccessKind:()=>yR,getAssignmentTargetKind:()=>fb,getAutomaticTypeDirectiveNames:()=>gB,getBaseFileName:()=>Ul,getBinaryOperatorPrecedence:()=>OR,getBuildInfo:()=>qK,getBuildInfoFileVersionMap:()=>mX,getBuildInfoText:()=>Rhe,getBuildOrderFromAnyBuildOrder:()=>tM,getBuilderCreationParameters:()=>QB,getBuilderFileEmit:()=>cS,getCanonicalDiagnostic:()=>V_e,getCheckFlags:()=>ll,getClassExtendsHeritageElement:()=>nE,getClassLikeDeclarationOfSymbol:()=>S0,getCombinedLocalAndExportSymbolFlags:()=>cN,getCombinedModifierFlags:()=>eb,getCombinedNodeFlags:()=>f0,getCombinedNodeFlagsAlwaysIncludeJSDoc:()=>A$,getCommentRange:()=>Wg,getCommonSourceDirectory:()=>s6,getCommonSourceDirectoryOfConfig:()=>tk,getCompilerOptionValue:()=>K9,getCompilerOptionsDiffValue:()=>Kme,getConditions:()=>sS,getConfigFileParsingDiagnostics:()=>kE,getConstantValue:()=>Xpe,getContainerFlags:()=>_K,getContainerNode:()=>b2,getContainingClass:()=>Ou,getContainingClassExcludingClassDecorators:()=>s9,getContainingClassStaticBlock:()=>rfe,getContainingFunction:()=>Dp,getContainingFunctionDeclaration:()=>tfe,getContainingFunctionOrClassStaticBlock:()=>i9,getContainingNodeArray:()=>Ope,getContainingObjectLiteralElement:()=>LM,getContextualTypeFromParent:()=>HU,getContextualTypeFromParentOrAncestorTypeNode:()=>NU,getCurrentTime:()=>eM,getDeclarationDiagnostics:()=>Nhe,getDeclarationEmitExtensionForPath:()=>A9,getDeclarationEmitOutputFilePath:()=>kfe,getDeclarationEmitOutputFilePathWorker:()=>C9,getDeclarationFileExtension:()=>DY,getDeclarationFromName:()=>jI,getDeclarationModifierFlagsFromSymbol:()=>xd,getDeclarationOfKind:()=>Pc,getDeclarationsOfKind:()=>y_e,getDeclaredExpandoInitializer:()=>RI,getDecorators:()=>F1,getDefaultCompilerOptions:()=>AV,getDefaultFormatCodeSettings:()=>vU,getDefaultLibFileName:()=>k3,getDefaultLibFilePath:()=>J1e,getDefaultLikeExportInfo:()=>uV,getDefaultLikeExportNameFromDeclaration:()=>nV,getDiagnosticText:()=>Df,getDiagnosticsWithinSpan:()=>rve,getDirectoryPath:()=>mi,getDirectoryToWatchFailedLookupLocation:()=>yX,getDirectoryToWatchFailedLookupLocationFromTypeRoot:()=>dye,getDocumentPositionMapper:()=>gZ,getDocumentSpansEqualityComparer:()=>MQ,getESModuleInterop:()=>Iy,getEditsForFileRename:()=>fve,getEffectiveBaseTypeNode:()=>Fg,getEffectiveConstraintOfTypeParameter:()=>RP,getEffectiveContainerForJSDocTemplateTag:()=>y9,getEffectiveImplementsTypeNodes:()=>eN,getEffectiveInitializer:()=>dR,getEffectiveJSDocHost:()=>_b,getEffectiveModifierFlags:()=>U_,getEffectiveModifierFlagsAlwaysIncludeJSDoc:()=>Ufe,getEffectiveModifierFlagsNoCache:()=>Vfe,getEffectiveReturnTypeNode:()=>lp,getEffectiveSetAccessorTypeAnnotationNode:()=>wfe,getEffectiveTypeAnnotationNode:()=>Vl,getEffectiveTypeParameterDeclarations:()=>j1,getEffectiveTypeRoots:()=>zO,getElementOrPropertyAccessArgumentExpressionOrName:()=>h9,getElementOrPropertyAccessName:()=>m0,getElementsOfBindingOrAssignmentPattern:()=>AN,getEmitDeclarations:()=>$p,getEmitFlags:()=>Ga,getEmitHelpers:()=>Ej,getEmitModuleDetectionKind:()=>cpe,getEmitModuleKind:()=>V_,getEmitModuleResolutionKind:()=>af,getEmitScriptTarget:()=>Ka,getEmitStandardClassFields:()=>hG,getEnclosingBlockScopeContainer:()=>eg,getEnclosingContainer:()=>K5,getEncodedSemanticClassifications:()=>lZ,getEncodedSyntacticClassifications:()=>uZ,getEndLinePosition:()=>G3,getEntityNameFromTypeNode:()=>oR,getEntrypointsFromPackageJsonInfo:()=>aK,getErrorCountForSummary:()=>rU,getErrorSpanForNode:()=>Yx,getErrorSummaryText:()=>EX,getEscapedTextOfIdentifierOrLiteral:()=>JI,getEscapedTextOfJsxAttributeName:()=>gO,getEscapedTextOfJsxNamespacedName:()=>xA,getExpandoInitializer:()=>lb,getExportAssignmentExpression:()=>wH,getExportInfoMap:()=>PM,getExportNeedsImportStarHelper:()=>Wge,getExpressionAssociativity:()=>jH,getExpressionPrecedence:()=>zI,getExternalHelpersModuleName:()=>Hj,getExternalModuleImportEqualsDeclarationExpression:()=>II,getExternalModuleName:()=>sA,getExternalModuleNameFromDeclaration:()=>Cfe,getExternalModuleNameFromPath:()=>$H,getExternalModuleNameLiteral:()=>WA,getExternalModuleRequireArgument:()=>SH,getFallbackOptions:()=>H8,getFileEmitOutput:()=>Yhe,getFileMatcherPatterns:()=>rj,getFileNamesFromConfigSpecs:()=>JO,getFileWatcherEventKind:()=>_$,getFilesInErrorForSummary:()=>nU,getFirstConstructorWithBody:()=>Ny,getFirstIdentifier:()=>_p,getFirstNonSpaceCharacterPosition:()=>$0e,getFirstProjectOutput:()=>UK,getFixableErrorSpanExpression:()=>ZQ,getFormatCodeSettingsForWriting:()=>oV,getFullWidth:()=>H3,getFunctionFlags:()=>Rl,getHeritageClause:()=>NR,getHostSignatureFromJSDoc:()=>ub,getIdentifierAutoGenerate:()=>v4e,getIdentifierGeneratedImportReference:()=>nde,getIdentifierTypeArguments:()=>i2,getImmediatelyInvokedFunctionExpression:()=>QT,getImpliedNodeFormatForFile:()=>K8,getImpliedNodeFormatForFileWorker:()=>YB,getImportNeedsImportDefaultHelper:()=>CK,getImportNeedsImportStarHelper:()=>PB,getIndentSize:()=>iN,getIndentString:()=>x9,getInferredLibraryNameResolveFrom:()=>GB,getInitializedVariables:()=>ZI,getInitializerOfBinaryExpression:()=>EH,getInitializerOfBindingOrAssignmentElement:()=>v8,getInterfaceBaseTypeNodes:()=>UI,getInternalEmitFlags:()=>Pm,getInvokedExpression:()=>c9,getIsolatedModules:()=>Cd,getJSDocAugmentsTag:()=>que,getJSDocClassTag:()=>N$,getJSDocCommentRanges:()=>mH,getJSDocCommentsAndTags:()=>CH,getJSDocDeprecatedTag:()=>D$,getJSDocDeprecatedTagNoCache:()=>Kue,getJSDocEnumTag:()=>w$,getJSDocHost:()=>tE,getJSDocImplementsTags:()=>zue,getJSDocOverloadTags:()=>kH,getJSDocOverrideTagNoCache:()=>Yue,getJSDocParameterTags:()=>OP,getJSDocParameterTagsNoCache:()=>Bue,getJSDocPrivateTag:()=>t6e,getJSDocPrivateTagNoCache:()=>$ue,getJSDocProtectedTag:()=>r6e,getJSDocProtectedTagNoCache:()=>Hue,getJSDocPublicTag:()=>e6e,getJSDocPublicTagNoCache:()=>Wue,getJSDocReadonlyTag:()=>n6e,getJSDocReadonlyTagNoCache:()=>Gue,getJSDocReturnTag:()=>Xue,getJSDocReturnType:()=>I3,getJSDocRoot:()=>QP,getJSDocSatisfiesExpressionType:()=>MG,getJSDocSatisfiesTag:()=>I$,getJSDocTags:()=>nb,getJSDocTagsNoCache:()=>s6e,getJSDocTemplateTag:()=>i6e,getJSDocThisTag:()=>x5,getJSDocType:()=>rb,getJSDocTypeAliasName:()=>TY,getJSDocTypeAssertionType:()=>FO,getJSDocTypeParameterDeclarations:()=>w9,getJSDocTypeParameterTags:()=>Uue,getJSDocTypeParameterTagsNoCache:()=>Vue,getJSDocTypeTag:()=>tb,getJSXImplicitImportBase:()=>Q9,getJSXRuntimeImport:()=>Z9,getJSXTransformEnabled:()=>X9,getKeyForCompilerOptions:()=>eK,getLanguageVariant:()=>zR,getLastChild:()=>lG,getLeadingCommentRanges:()=>Ty,getLeadingCommentRangesOfNode:()=>dH,getLeftmostAccessExpression:()=>lN,getLeftmostExpression:()=>uN,getLibraryNameFromLibFileName:()=>aX,getLineAndCharacterOfPosition:()=>ba,getLineInfo:()=>TK,getLineOfLocalPosition:()=>$I,getLineOfLocalPositionFromLineMap:()=>r2,getLineStartPositionForPosition:()=>om,getLineStarts:()=>Sy,getLinesBetweenPositionAndNextNonWhitespaceCharacter:()=>Zfe,getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter:()=>Qfe,getLinesBetweenPositions:()=>cI,getLinesBetweenRangeEndAndRangeStart:()=>sG,getLinesBetweenRangeEndPositions:()=>G6e,getLiteralText:()=>P_e,getLocalNameForExternalImport:()=>CN,getLocalSymbolForExportDefault:()=>KI,getLocaleSpecificMessage:()=>Ms,getLocaleTimeString:()=>Z8,getMappedContextSpan:()=>FQ,getMappedDocumentSpan:()=>qU,getMappedLocation:()=>y6,getMatchedFileSpec:()=>kX,getMatchedIncludeSpec:()=>PX,getMeaningFromDeclaration:()=>bU,getMeaningFromLocation:()=>S2,getMembersOfDeclaration:()=>H_e,getModeForFileReference:()=>G8,getModeForResolutionAtIndex:()=>Hhe,getModeForUsageLocation:()=>eX,getModifiedTime:()=>zC,getModifiers:()=>qT,getModuleInstanceState:()=>N0,getModuleNameStringLiteralAt:()=>Q8,getModuleSpecifierEndingPreference:()=>Epe,getModuleSpecifierResolverHost:()=>PQ,getNameForExportedSymbol:()=>rV,getNameFromImportAttribute:()=>hj,getNameFromIndexInfo:()=>F_e,getNameFromPropertyName:()=>gM,getNameOfAccessExpression:()=>_G,getNameOfCompilerOptionValue:()=>$Y,getNameOfDeclaration:()=>Ps,getNameOfExpando:()=>bH,getNameOfJSDocTypedef:()=>jue,getNameOfScriptTarget:()=>Y9,getNameOrArgument:()=>hR,getNameTable:()=>$Z,getNamesForExportedSymbol:()=>nve,getNamespaceDeclarationNode:()=>KP,getNewLineCharacter:()=>wv,getNewLineKind:()=>kM,getNewLineOrDefaultFromHost:()=>Vv,getNewTargetContainer:()=>ife,getNextJSDocCommentLocation:()=>AH,getNodeChildren:()=>pY,getNodeForGeneratedName:()=>b8,getNodeId:()=>yo,getNodeKind:()=>PE,getNodeModifiers:()=>m6,getNodeModulePathParts:()=>dj,getNonAssignedNameOfDeclaration:()=>T5,getNonAssignmentOperatorForCompoundAssignment:()=>QO,getNonAugmentationDeclaration:()=>oH,getNonDecoratorTokenPosOfNode:()=>tH,getNormalizedAbsolutePath:()=>xs,getNormalizedAbsolutePathWithoutRoot:()=>m$,getNormalizedPathComponents:()=>S3,getObjectFlags:()=>Kn,getOperator:()=>UH,getOperatorAssociativity:()=>BH,getOperatorPrecedence:()=>IR,getOptionFromName:()=>UY,getOptionsForLibraryResolution:()=>rK,getOptionsNameMap:()=>NN,getOrCreateEmitNode:()=>f_,getOrCreateExternalHelpersModuleNameIfNeeded:()=>pme,getOrUpdate:()=>dv,getOriginalNode:()=>Bc,getOriginalNodeId:()=>pf,getOriginalSourceFile:()=>F6e,getOutputDeclarationFileName:()=>jN,getOutputDeclarationFileNameWorker:()=>jK,getOutputExtension:()=>jB,getOutputFileNames:()=>C8e,getOutputJSFileNameWorker:()=>BK,getOutputPathsFor:()=>i6,getOutputPathsForBundle:()=>FB,getOwnEmitOutputFilePath:()=>Afe,getOwnKeys:()=>Ng,getOwnValues:()=>UC,getPackageJsonInfo:()=>Db,getPackageJsonTypesVersionsPaths:()=>mB,getPackageJsonsVisibleToFile:()=>eve,getPackageNameFromTypesPackageName:()=>GO,getPackageScopeForPath:()=>HO,getParameterSymbolFromJSDoc:()=>CR,getParameterTypeNode:()=>u4e,getParentNodeInSpan:()=>yM,getParseTreeNode:()=>ks,getParsedCommandLineOfConfigFile:()=>k8,getPathComponents:()=>hu,getPathComponentsRelativeTo:()=>y$,getPathFromPathComponents:()=>u0,getPathUpdater:()=>pZ,getPathsBasePath:()=>k9,getPatternFromSpec:()=>ype,getPendingEmitKind:()=>JN,getPositionOfLineAndCharacter:()=>T3,getPossibleGenericSignatures:()=>gQ,getPossibleOriginalInputExtensionForExtension:()=>Pfe,getPossibleTypeArgumentsInfo:()=>hQ,getPreEmitDiagnostics:()=>A8e,getPrecedingNonSpaceCharacterPosition:()=>WU,getPrivateIdentifier:()=>NK,getProperties:()=>kK,getProperty:()=>QF,getPropertyArrayElementValue:()=>efe,getPropertyAssignmentAliasLikeExpression:()=>yfe,getPropertyNameForPropertyNameNode:()=>e2,getPropertyNameForUniqueESSymbol:()=>M6e,getPropertyNameFromType:()=>rm,getPropertyNameOfBindingOrAssignmentElement:()=>bY,getPropertySymbolFromBindingElement:()=>JU,getPropertySymbolsFromContextualType:()=>PV,getQuoteFromPreference:()=>DQ,getQuotePreference:()=>ed,getRangesWhere:()=>$w,getRefactorContextSpan:()=>ok,getReferencedFileLocation:()=>c6,getRegexFromPattern:()=>G1,getRegularExpressionForWildcard:()=>iO,getRegularExpressionsForWildcards:()=>ej,getRelativePathFromDirectory:()=>Xm,getRelativePathFromFile:()=>aI,getRelativePathToDirectoryOrUrl:()=>WC,getRenameLocation:()=>bM,getReplacementSpanForContextToken:()=>bQ,getResolutionDiagnostic:()=>_X,getResolutionModeOverride:()=>BN,getResolveJsonModule:()=>cE,getResolvePackageJsonExports:()=>mG,getResolvePackageJsonImports:()=>gG,getResolvedExternalModuleName:()=>WH,getRestIndicatorOfBindingOrAssignmentElement:()=>Gj,getRestParameterElementType:()=>gH,getRightMostAssignedExpression:()=>mR,getRootDeclaration:()=>Bg,getRootDirectoryOfResolutionCache:()=>mye,getRootLength:()=>Rh,getRootPathSplitLength:()=>eMe,getScriptKind:()=>JQ,getScriptKindFromFileName:()=>ij,getScriptTargetFeatures:()=>rH,getSelectedEffectiveModifierFlags:()=>fA,getSelectedSyntacticModifierFlags:()=>jfe,getSemanticClassifications:()=>cve,getSemanticJsxChildren:()=>rN,getSetAccessorTypeAnnotationNode:()=>Nfe,getSetAccessorValueParameter:()=>aN,getSetExternalModuleIndicator:()=>WR,getShebang:()=>v5,getSingleInitializerOfVariableStatementOrPropertyDeclaration:()=>xH,getSingleVariableOfVariableStatement:()=>cA,getSnapshotText:()=>sk,getSnippetElement:()=>JG,getSourceFileOfModule:()=>z5,getSourceFileOfNode:()=>Ur,getSourceFilePathInNewDir:()=>N9,getSourceFilePathInNewDirWorker:()=>D9,getSourceFileVersionAsHashFromText:()=>sU,getSourceFilesToEmit:()=>P9,getSourceMapRange:()=>Ov,getSourceMapper:()=>xve,getSourceTextOfNodeFromSourceFile:()=>GT,getSpanOfTokenAtPosition:()=>Bh,getSpellingSuggestion:()=>Fx,getStartPositionOfLine:()=>q1,getStartPositionOfRange:()=>QI,getStartsOnNewLine:()=>yO,getStaticPropertiesAndClassStaticBlock:()=>wB,getStrictOptionValue:()=>J_,getStringComparer:()=>CP,getSubPatternFromSpec:()=>tj,getSuperCallFromStatement:()=>NB,getSuperContainer:()=>sR,getSupportedCodeFixes:()=>zZ,getSupportedExtensions:()=>aO,getSupportedExtensionsWithJsonIfResolveJsonModule:()=>HR,getSwitchedType:()=>HQ,getSymbolId:()=>Aa,getSymbolNameForPrivateIdentifier:()=>DR,getSymbolParentOrFail:()=>iV,getSymbolTarget:()=>qQ,getSyntacticClassifications:()=>lve,getSyntacticModifierFlags:()=>Nv,getSyntacticModifierFlagsNoCache:()=>XH,getSynthesizedDeepClone:()=>Co,getSynthesizedDeepCloneWithReplacements:()=>SM,getSynthesizedDeepClones:()=>DE,getSynthesizedDeepClonesWithReplacements:()=>zQ,getSyntheticLeadingComments:()=>mN,getSyntheticTrailingComments:()=>s8,getTargetLabel:()=>xU,getTargetOfBindingOrAssignmentElement:()=>iS,getTemporaryModuleResolutionState:()=>$O,getTextOfConstantValue:()=>N_e,getTextOfIdentifierOrLiteral:()=>Qd,getTextOfJSDocComment:()=>R3,getTextOfJsxAttributeName:()=>ZR,getTextOfJsxNamespacedName:()=>hO,getTextOfNode:()=>Hc,getTextOfNodeFromSourceText:()=>kI,getTextOfPropertyName:()=>tA,getThisContainer:()=>nf,getThisParameter:()=>iE,getTokenAtPosition:()=>Yi,getTokenPosOfNode:()=>ob,getTokenSourceMapRange:()=>h4e,getTouchingPropertyName:()=>wf,getTouchingToken:()=>HN,getTrailingCommentRanges:()=>L1,getTrailingSemicolonDeferringWriter:()=>zH,getTransformFlagsSubtreeExclusions:()=>Gpe,getTransformers:()=>Ihe,getTsBuildInfoEmitOutputFilePath:()=>jv,getTsConfigObjectLiteralExpression:()=>DI,getTsConfigPropArrayElementValue:()=>n9,getTypeAnnotationNode:()=>Dfe,getTypeArgumentOrTypeParameterList:()=>P0e,getTypeKeywordOfTypeOnlyImport:()=>OQ,getTypeNode:()=>tde,getTypeNodeIfAccessible:()=>E6,getTypeParameterFromJsDoc:()=>ffe,getTypeParameterOwner:()=>KOe,getTypesPackageName:()=>EB,getUILocale:()=>Hce,getUniqueName:()=>E2,getUniqueSymbolId:()=>W0e,getUseDefineForClassFields:()=>$R,getWatchErrorSummaryDiagnosticMessage:()=>TX,getWatchFactory:()=>$K,group:()=>Hw,groupBy:()=>IW,guessIndentation:()=>g_e,handleNoEmitOptions:()=>uX,handleWatchOptionsConfigDirTemplateSubstitution:()=>uB,hasAbstractModifier:()=>oE,hasAccessorModifier:()=>Ug,hasAmbientModifier:()=>KH,hasChangesInResolutions:()=>Q$,hasChildOfKind:()=>_M,hasContextSensitiveParameters:()=>fj,hasDecorators:()=>Wp,hasDocComment:()=>A0e,hasDynamicName:()=>h0,hasEffectiveModifier:()=>up,hasEffectiveModifiers:()=>YH,hasEffectiveReadonlyModifier:()=>HI,hasExtension:()=>kP,hasIndexSignature:()=>$Q,hasInferredType:()=>Vpe,hasInitializer:()=>bv,hasInvalidEscape:()=>JH,hasJSDocNodes:()=>Pp,hasJSDocParameterTags:()=>Jue,hasJSFileExtension:()=>Oy,hasJsonModuleEmitEnabled:()=>G9,hasOnlyExpressionInitializer:()=>Hx,hasOverrideModifier:()=>I9,hasPossibleExternalModuleReference:()=>M_e,hasProperty:()=>Ho,hasPropertyAccessExpressionWithName:()=>aM,hasQuestionToken:()=>oA,hasRecordedExternalHelpers:()=>fme,hasResolutionModeOverride:()=>jpe,hasRestParameter:()=>G$,hasScopeMarker:()=>c_e,hasStaticModifier:()=>Jl,hasSyntacticModifier:()=>li,hasSyntacticModifiers:()=>Ffe,hasTSFileExtension:()=>TA,hasTabstop:()=>Mpe,hasTrailingDirectorySeparator:()=>hv,hasType:()=>F5,hasTypeArguments:()=>D6e,hasZeroOrOneAsteriskCharacter:()=>yG,helperString:()=>WG,hostGetCanonicalFileName:()=>Pv,hostUsesCaseSensitiveFileNames:()=>sN,idText:()=>Nn,identifierIsThisKeyword:()=>GH,identifierToKeywordKind:()=>Jx,identity:()=>ec,identitySourceMapConsumer:()=>xK,ignoreSourceNewlines:()=>zG,ignoredPaths:()=>_5,importDefaultHelper:()=>kde,importFromModuleSpecifier:()=>LI,importStarHelper:()=>$G,indexOfAnyCharCode:()=>qw,indexOfNode:()=>JP,indicesOf:()=>Ox,inferredTypesContainingFile:()=>o6,injectClassNamedEvaluationHelperBlockIfMissing:()=>RB,injectClassThisAssignmentIfMissing:()=>nhe,insertImports:()=>IQ,insertLeadingStatement:()=>R4e,insertSorted:()=>l0,insertStatementAfterCustomPrologue:()=>Gx,insertStatementAfterStandardPrologue:()=>b6e,insertStatementsAfterCustomPrologue:()=>Z$,insertStatementsAfterStandardPrologue:()=>Ay,intersperse:()=>bf,intrinsicTagNameToString:()=>LG,introducesArgumentsExoticObject:()=>X_e,inverseJsxOptionMap:()=>C8,isAbstractConstructorSymbol:()=>epe,isAbstractModifier:()=>Bde,isAccessExpression:()=>oc,isAccessibilityModifier:()=>vQ,isAccessor:()=>U1,isAccessorModifier:()=>Vde,isAliasSymbolDeclaration:()=>I6e,isAliasableExpression:()=>PR,isAmbientModule:()=>B_,isAmbientPropertyDeclaration:()=>lH,isAnonymousFunctionDefinition:()=>qI,isAnyDirectorySeparator:()=>f$,isAnyImportOrBareOrAccessedRequire:()=>O_e,isAnyImportOrReExport:()=>X3,isAnyImportOrRequireStatement:()=>R_e,isAnyImportSyntax:()=>eA,isAnySupportedFileExtension:()=>c4e,isApplicableVersionedTypesKey:()=>R8,isArgumentExpressionOfElementAccess:()=>cQ,isArray:()=>Rs,isArrayBindingElement:()=>w5,isArrayBindingOrAssignmentElement:()=>V3,isArrayBindingOrAssignmentPattern:()=>J$,isArrayBindingPattern:()=>Lv,isArrayLiteralExpression:()=>Gu,isArrayLiteralOrObjectLiteralDestructuringPattern:()=>Uv,isArrayTypeNode:()=>_8,isArrowFunction:()=>pc,isAsExpression:()=>CO,isAssertClause:()=>Hde,isAssertEntry:()=>A4e,isAssertionExpression:()=>sb,isAssertsKeyword:()=>Fde,isAssignmentDeclaration:()=>OI,isAssignmentExpression:()=>Su,isAssignmentOperator:()=>y0,isAssignmentPattern:()=>TI,isAssignmentTarget:()=>kv,isAsteriskToken:()=>c8,isAsyncFunction:()=>VI,isAsyncModifier:()=>TO,isAutoAccessorPropertyDeclaration:()=>Ef,isAwaitExpression:()=>eS,isAwaitKeyword:()=>XG,isBigIntLiteral:()=>o8,isBinaryExpression:()=>Pn,isBinaryOperatorToken:()=>bme,isBindableObjectDefinePropertyCall:()=>Qx,isBindableStaticAccessExpression:()=>eE,isBindableStaticElementAccessExpression:()=>g9,isBindableStaticNameExpression:()=>Zx,isBindingElement:()=>Xa,isBindingElementOfBareOrAccessedRequire:()=>ofe,isBindingName:()=>Wx,isBindingOrAssignmentElement:()=>n_e,isBindingOrAssignmentPattern:()=>B3,isBindingPattern:()=>Hs,isBlock:()=>Vs,isBlockLike:()=>tD,isBlockOrCatchScoped:()=>nH,isBlockScope:()=>uH,isBlockScopedContainerTopLevel:()=>I_e,isBooleanLiteral:()=>bI,isBreakOrContinueStatement:()=>gI,isBreakStatement:()=>E4e,isBuild:()=>Vye,isBuildInfoFile:()=>Ohe,isBuilderProgram:()=>yye,isBundle:()=>Kde,isCallChain:()=>qx,isCallExpression:()=>ea,isCallExpressionTarget:()=>rQ,isCallLikeExpression:()=>HT,isCallLikeOrFunctionLikeExpression:()=>q$,isCallOrNewExpression:()=>Ig,isCallOrNewExpressionTarget:()=>nQ,isCallSignatureDeclaration:()=>MA,isCallToHelper:()=>bO,isCaseBlock:()=>DO,isCaseClause:()=>SN,isCaseKeyword:()=>Jde,isCaseOrDefaultClause:()=>M5,isCatchClause:()=>bE,isCatchClauseVariableDeclaration:()=>Rpe,isCatchClauseVariableDeclarationOrBindingElement:()=>iH,isCheckJsEnabledForFile:()=>lO,isChildOfNodeWithKind:()=>E6e,isCircularBuildOrder:()=>nk,isClassDeclaration:()=>tu,isClassElement:()=>uu,isClassExpression:()=>eu,isClassInstanceProperty:()=>t_e,isClassLike:()=>gi,isClassMemberModifier:()=>B$,isClassNamedEvaluationHelperBlock:()=>ek,isClassOrTypeElement:()=>D5,isClassStaticBlockDeclaration:()=>Gc,isClassThisAssignmentBlock:()=>e6,isCollapsedRange:()=>H6e,isColonToken:()=>Mde,isCommaExpression:()=>h8,isCommaListExpression:()=>kO,isCommaSequence:()=>LO,isCommaToken:()=>Rde,isComment:()=>MU,isCommonJsExportPropertyAssignment:()=>t9,isCommonJsExportedExpression:()=>Y_e,isCompoundAssignment:()=>XO,isComputedNonLiteralName:()=>Q3,isComputedPropertyName:()=>za,isConciseBody:()=>O5,isConditionalExpression:()=>UA,isConditionalTypeNode:()=>dE,isConstAssertion:()=>FG,isConstTypeReference:()=>Qm,isConstructSignatureDeclaration:()=>u8,isConstructorDeclaration:()=>Vc,isConstructorTypeNode:()=>gN,isContextualKeyword:()=>S9,isContinueStatement:()=>T4e,isCustomPrologue:()=>nR,isDebuggerStatement:()=>x4e,isDeclaration:()=>u_,isDeclarationBindingElement:()=>j3,isDeclarationFileName:()=>Mu,isDeclarationName:()=>Uh,isDeclarationNameOfEnumOrNamespace:()=>aG,isDeclarationReadonly:()=>eR,isDeclarationStatement:()=>f_e,isDeclarationWithTypeParameterChildren:()=>fH,isDeclarationWithTypeParameters:()=>_H,isDecorator:()=>fu,isDecoratorTarget:()=>p0e,isDefaultClause:()=>IO,isDefaultImport:()=>aA,isDefaultModifier:()=>Dj,isDefaultedExpandoInitializer:()=>cfe,isDeleteExpression:()=>zde,isDeleteTarget:()=>NH,isDeprecatedDeclaration:()=>sV,isDestructuringAssignment:()=>Dv,isDiagnosticWithLocation:()=>QQ,isDiskPathRoot:()=>p$,isDoStatement:()=>b4e,isDocumentRegistryEntry:()=>NM,isDotDotDotToken:()=>Pj,isDottedName:()=>BR,isDynamicName:()=>T9,isESSymbolIdentifier:()=>L6e,isEffectiveExternalModule:()=>ZC,isEffectiveModuleDeclaration:()=>w_e,isEffectiveStrictModeSourceFile:()=>cH,isElementAccessChain:()=>O$,isElementAccessExpression:()=>cc,isEmittedFileOfProgram:()=>Bhe,isEmptyArrayLiteral:()=>Wfe,isEmptyBindingElement:()=>Mue,isEmptyBindingPattern:()=>Rue,isEmptyObjectLiteral:()=>rG,isEmptyStatement:()=>tY,isEmptyStringLiteral:()=>vH,isEntityName:()=>Tf,isEntityNameExpression:()=>nc,isEnumConst:()=>KT,isEnumDeclaration:()=>bb,isEnumMember:()=>nS,isEqualityOperatorKind:()=>GU,isEqualsGreaterThanToken:()=>Lde,isExclamationToken:()=>l8,isExcludedFile:()=>Zme,isExclusivelyTypeOnlyImportOrExport:()=>ZK,isExpandoPropertyDeclaration:()=>CA,isExportAssignment:()=>dc,isExportDeclaration:()=>xl,isExportModifier:()=>OA,isExportName:()=>Wj,isExportNamespaceAsDefaultDeclaration:()=>H5,isExportOrDefaultModifier:()=>S8,isExportSpecifier:()=>b_,isExportsIdentifier:()=>Xx,isExportsOrModuleExportsOrAlias:()=>EE,isExpression:()=>Ct,isExpressionNode:()=>tg,isExpressionOfExternalModuleImportEqualsDeclaration:()=>h0e,isExpressionOfOptionalChainRoot:()=>k5,isExpressionStatement:()=>Du,isExpressionWithTypeArguments:()=>x0,isExpressionWithTypeArgumentsInClassExtendsClause:()=>O9,isExternalModule:()=>nu,isExternalModuleAugmentation:()=>YT,isExternalModuleImportEqualsDeclaration:()=>cb,isExternalModuleIndicator:()=>q3,isExternalModuleNameRelative:()=>vu,isExternalModuleReference:()=>C0,isExternalModuleSymbol:()=>BP,isExternalOrCommonJsModule:()=>Uf,isFileLevelReservedGeneratedIdentifier:()=>F3,isFileLevelUniqueName:()=>W5,isFileProbablyExternalModule:()=>E8,isFirstDeclarationOfSymbolParameter:()=>jQ,isFixablePromiseHandler:()=>vZ,isForInOrOfStatement:()=>$x,isForInStatement:()=>Fj,isForInitializer:()=>Sd,isForOfStatement:()=>f8,isForStatement:()=>Sb,isFullSourceFile:()=>Av,isFunctionBlock:()=>XT,isFunctionBody:()=>W$,isFunctionDeclaration:()=>Tl,isFunctionExpression:()=>ic,isFunctionExpressionOrArrowFunction:()=>K1,isFunctionLike:()=>Bs,isFunctionLikeDeclaration:()=>Go,isFunctionLikeKind:()=>YC,isFunctionLikeOrClassStaticBlockDeclaration:()=>LP,isFunctionOrConstructorTypeNode:()=>r_e,isFunctionOrModuleBlock:()=>U$,isFunctionSymbol:()=>ufe,isFunctionTypeNode:()=>Jh,isFutureReservedKeyword:()=>O6e,isGeneratedIdentifier:()=>xc,isGeneratedPrivateIdentifier:()=>zx,isGetAccessor:()=>Sv,isGetAccessorDeclaration:()=>Hp,isGetOrSetAccessorDeclaration:()=>M3,isGlobalDeclaration:()=>A7e,isGlobalScopeAugmentation:()=>Rg,isGlobalSourceFile:()=>Tv,isGrammarError:()=>C_e,isHeritageClause:()=>pp,isHoistedFunction:()=>Z5,isHoistedVariableStatement:()=>e9,isIdentifier:()=>He,isIdentifierANonContextualKeyword:()=>RH,isIdentifierName:()=>hfe,isIdentifierOrThisTypeNode:()=>hme,isIdentifierPart:()=>yv,isIdentifierStart:()=>Ey,isIdentifierText:()=>sp,isIdentifierTypePredicate:()=>Q_e,isIdentifierTypeReference:()=>Npe,isIfStatement:()=>vb,isIgnoredFileFromWildCardWatching:()=>$8,isImplicitGlob:()=>bG,isImportAttribute:()=>Gde,isImportAttributeName:()=>e_e,isImportAttributes:()=>l2,isImportCall:()=>Np,isImportClause:()=>ig,isImportDeclaration:()=>Yc,isImportEqualsDeclaration:()=>ru,isImportKeyword:()=>xO,isImportMeta:()=>WP,isImportOrExportSpecifier:()=>GC,isImportOrExportSpecifierName:()=>z0e,isImportSpecifier:()=>_f,isImportTypeAssertionContainer:()=>C4e,isImportTypeNode:()=>qh,isImportableFile:()=>aZ,isInComment:()=>Bv,isInCompoundLikeAssignment:()=>PH,isInExpressionContext:()=>l9,isInJSDoc:()=>uR,isInJSFile:()=>hn,isInJSXText:()=>x0e,isInJsonFile:()=>_9,isInNonReferenceComment:()=>w0e,isInReferenceComment:()=>D0e,isInRightSideOfInternalImportEqualsDeclaration:()=>TU,isInString:()=>ik,isInTemplateString:()=>mQ,isInTopLevelContext:()=>a9,isInTypeQuery:()=>_A,isIncrementalCompilation:()=>nO,isIndexSignatureDeclaration:()=>fE,isIndexedAccessTypeNode:()=>mE,isInferTypeNode:()=>s2,isInfinityOrNaNString:()=>dO,isInitializedProperty:()=>B8,isInitializedVariable:()=>qR,isInsideJsxElement:()=>OU,isInsideJsxElementOrAttribute:()=>E0e,isInsideNodeModules:()=>CM,isInsideTemplateLiteral:()=>pM,isInstanceOfExpression:()=>R9,isInstantiatedModule:()=>hK,isInterfaceDeclaration:()=>Yu,isInternalDeclaration:()=>h_e,isInternalModuleImportEqualsDeclaration:()=>nA,isInternalName:()=>yY,isIntersectionTypeNode:()=>jA,isIntrinsicJsxName:()=>nN,isIterationStatement:()=>V1,isJSDoc:()=>ag,isJSDocAllType:()=>Zde,isJSDocAugmentsTag:()=>zA,isJSDocAuthorTag:()=>D4e,isJSDocCallbackTag:()=>aY,isJSDocClassTag:()=>tme,isJSDocCommentContainingNode:()=>L5,isJSDocConstructSignature:()=>XP,isJSDocDeprecatedTag:()=>_Y,isJSDocEnumTag:()=>d8,isJSDocFunctionType:()=>TN,isJSDocImplementsTag:()=>Jj,isJSDocImportTag:()=>Xg,isJSDocIndexSignature:()=>p9,isJSDocLikeText:()=>kY,isJSDocLink:()=>Xde,isJSDocLinkCode:()=>Qde,isJSDocLinkLike:()=>QC,isJSDocLinkPlain:()=>P4e,isJSDocMemberName:()=>Eb,isJSDocNameReference:()=>OO,isJSDocNamepathType:()=>N4e,isJSDocNamespaceBody:()=>d6e,isJSDocNode:()=>FP,isJSDocNonNullableType:()=>jj,isJSDocNullableType:()=>bN,isJSDocOptionalParameter:()=>mj,isJSDocOptionalType:()=>sY,isJSDocOverloadTag:()=>EN,isJSDocOverrideTag:()=>Uj,isJSDocParameterTag:()=>Pd,isJSDocPrivateTag:()=>cY,isJSDocPropertyLikeTag:()=>hI,isJSDocPropertyTag:()=>rme,isJSDocProtectedTag:()=>lY,isJSDocPublicTag:()=>oY,isJSDocReadonlyTag:()=>uY,isJSDocReturnTag:()=>Vj,isJSDocSatisfiesExpression:()=>RG,isJSDocSatisfiesTag:()=>qj,isJSDocSeeTag:()=>w4e,isJSDocSignature:()=>A0,isJSDocTag:()=>jP,isJSDocTemplateTag:()=>sm,isJSDocThisTag:()=>fY,isJSDocThrowsTag:()=>O4e,isJSDocTypeAlias:()=>Xd,isJSDocTypeAssertion:()=>m2,isJSDocTypeExpression:()=>Tb,isJSDocTypeLiteral:()=>f2,isJSDocTypeTag:()=>RO,isJSDocTypedefTag:()=>p2,isJSDocUnknownTag:()=>I4e,isJSDocUnknownType:()=>eme,isJSDocVariadicType:()=>Bj,isJSXTagName:()=>GP,isJsonEqual:()=>uj,isJsonSourceFile:()=>Kd,isJsxAttribute:()=>Kg,isJsxAttributeLike:()=>R5,isJsxAttributeName:()=>Fpe,isJsxAttributes:()=>SE,isJsxChild:()=>$3,isJsxClosingElement:()=>yE,isJsxClosingFragment:()=>Yde,isJsxElement:()=>Ly,isJsxExpression:()=>wO,isJsxFragment:()=>vE,isJsxNamespacedName:()=>sg,isJsxOpeningElement:()=>Yg,isJsxOpeningFragment:()=>_2,isJsxOpeningLikeElement:()=>__,isJsxOpeningLikeElementTagName:()=>d0e,isJsxSelfClosingElement:()=>u2,isJsxSpreadAttribute:()=>qA,isJsxTagNameExpression:()=>EI,isJsxText:()=>DA,isJumpStatementTarget:()=>oM,isKeyword:()=>sf,isKeywordOrPunctuation:()=>v9,isKnownSymbol:()=>wR,isLabelName:()=>aQ,isLabelOfLabeledStatement:()=>sQ,isLabeledStatement:()=>rS,isLateVisibilityPaintedStatement:()=>Y5,isLeftHandSideExpression:()=>xf,isLeftHandSideOfAssignment:()=>$6e,isLet:()=>Q5,isLineBreak:()=>v_,isLiteralComputedPropertyDeclarationName:()=>kR,isLiteralExpression:()=>WT,isLiteralExpressionOfObject:()=>F$,isLiteralImportTypeNode:()=>Ev,isLiteralKind:()=>yI,isLiteralLikeAccess:()=>m9,isLiteralLikeElementAccess:()=>gR,isLiteralNameOfPropertyDeclarationOrIndexAccess:()=>CU,isLiteralTypeLikeExpression:()=>B4e,isLiteralTypeLiteral:()=>a_e,isLiteralTypeNode:()=>Mv,isLocalName:()=>k0,isLogicalOperator:()=>Jfe,isLogicalOrCoalescingAssignmentExpression:()=>QH,isLogicalOrCoalescingAssignmentOperator:()=>GI,isLogicalOrCoalescingBinaryExpression:()=>jR,isLogicalOrCoalescingBinaryOperator:()=>FR,isMappedTypeNode:()=>o2,isMemberName:()=>Cy,isMetaProperty:()=>AO,isMethodDeclaration:()=>ul,isMethodOrAccessor:()=>KC,isMethodSignature:()=>$g,isMinusToken:()=>KG,isMissingDeclaration:()=>k4e,isMissingPackageJsonInfo:()=>_ge,isModifier:()=>Pa,isModifierKind:()=>vv,isModifierLike:()=>Cc,isModuleAugmentationExternal:()=>aH,isModuleBlock:()=>Hg,isModuleBody:()=>l_e,isModuleDeclaration:()=>El,isModuleExportsAccessExpression:()=>Py,isModuleIdentifier:()=>TH,isModuleName:()=>Sme,isModuleOrEnumDeclaration:()=>z3,isModuleReference:()=>d_e,isModuleSpecifierLike:()=>VU,isModuleWithStringLiteralName:()=>G5,isNameOfFunctionDeclaration:()=>uQ,isNameOfModuleDeclaration:()=>lQ,isNamedClassElement:()=>l6e,isNamedDeclaration:()=>Wu,isNamedEvaluation:()=>cp,isNamedEvaluationSource:()=>MH,isNamedExportBindings:()=>M$,isNamedExports:()=>kd,isNamedImportBindings:()=>$$,isNamedImports:()=>Gg,isNamedImportsOrExports:()=>V9,isNamedTupleMember:()=>hN,isNamespaceBody:()=>p6e,isNamespaceExport:()=>zh,isNamespaceExportDeclaration:()=>p8,isNamespaceImport:()=>My,isNamespaceReexportDeclaration:()=>afe,isNewExpression:()=>gE,isNewExpressionTarget:()=>p6,isNoSubstitutionTemplateLiteral:()=>wA,isNode:()=>o6e,isNodeArray:()=>zT,isNodeArrayMultiLine:()=>Xfe,isNodeDescendantOf:()=>rE,isNodeKind:()=>L3,isNodeLikeSystem:()=>JW,isNodeModulesDirectory:()=>d5,isNodeWithPossibleHoistedDeclaration:()=>mfe,isNonContextualKeyword:()=>OH,isNonExportDefaultModifier:()=>V4e,isNonGlobalAmbientModule:()=>sH,isNonGlobalDeclaration:()=>sve,isNonNullAccess:()=>Lpe,isNonNullChain:()=>P5,isNonNullExpression:()=>VA,isNonStaticMethodOrAccessorWithPrivateName:()=>Hge,isNotEmittedOrPartiallyEmittedNode:()=>f6e,isNotEmittedStatement:()=>iY,isNullishCoalesce:()=>R$,isNumber:()=>O1,isNumericLiteral:()=>Pf,isNumericLiteralName:()=>Ry,isObjectBindingElementWithoutPropertyName:()=>hM,isObjectBindingOrAssignmentElement:()=>U3,isObjectBindingOrAssignmentPattern:()=>V$,isObjectBindingPattern:()=>Yp,isObjectLiteralElement:()=>H$,isObjectLiteralElementLike:()=>p0,isObjectLiteralExpression:()=>Ca,isObjectLiteralMethod:()=>Nm,isObjectLiteralOrClassExpressionMethodOrAccessor:()=>r9,isObjectTypeDeclaration:()=>gA,isOctalDigit:()=>y5,isOmittedExpression:()=>pu,isOptionalChain:()=>S_,isOptionalChainRoot:()=>dI,isOptionalDeclaration:()=>dN,isOptionalJSDocPropertyLikeTag:()=>QR,isOptionalTypeNode:()=>wj,isOuterExpression:()=>$j,isOutermostOptionalChain:()=>mI,isOverrideModifier:()=>Ude,isPackageJsonInfo:()=>hB,isPackedArrayLiteral:()=>IG,isParameter:()=>ns,isParameterPropertyDeclaration:()=>ap,isParameterPropertyModifier:()=>SI,isParenthesizedExpression:()=>uf,isParenthesizedTypeNode:()=>a2,isParseTreeNode:()=>pI,isPartOfParameterDeclaration:()=>db,isPartOfTypeNode:()=>Lg,isPartOfTypeQuery:()=>u9,isPartiallyEmittedExpression:()=>Lj,isPatternMatch:()=>t5,isPinnedComment:()=>$5,isPlainJsFile:()=>AI,isPlusToken:()=>YG,isPossiblyTypeArgumentPosition:()=>fM,isPostfixUnaryExpression:()=>eY,isPrefixUnaryExpression:()=>tS,isPrimitiveLiteralValue:()=>yj,isPrivateIdentifier:()=>Zi,isPrivateIdentifierClassElementDeclaration:()=>j_,isPrivateIdentifierPropertyAccessExpression:()=>MP,isPrivateIdentifierSymbol:()=>Sfe,isProgramBundleEmitBuildInfo:()=>nye,isProgramUptoDate:()=>oX,isPrologueDirective:()=>Mg,isPropertyAccessChain:()=>A5,isPropertyAccessEntityNameExpression:()=>UR,isPropertyAccessExpression:()=>Wn,isPropertyAccessOrQualifiedName:()=>J3,isPropertyAccessOrQualifiedNameOrImportTypeNode:()=>i_e,isPropertyAssignment:()=>ql,isPropertyDeclaration:()=>Ns,isPropertyName:()=>Ol,isPropertyNameLiteral:()=>jg,isPropertySignature:()=>Nf,isProtoSetter:()=>bfe,isPrototypeAccess:()=>$1,isPrototypePropertyAssignment:()=>vR,isPunctuation:()=>IH,isPushOrUnshiftIdentifier:()=>LH,isQualifiedName:()=>cf,isQuestionDotToken:()=>Nj,isQuestionOrExclamationToken:()=>gme,isQuestionOrPlusOrMinusToken:()=>vme,isQuestionToken:()=>Q1,isRawSourceMap:()=>Vge,isReadonlyKeyword:()=>jde,isReadonlyKeywordOrPlusOrMinusToken:()=>yme,isRecognizedTripleSlashComment:()=>eH,isReferenceFileLocation:()=>UN,isReferencedFile:()=>Ib,isRegularExpressionLiteral:()=>HG,isRequireCall:()=>kf,isRequireVariableStatement:()=>fR,isRestParameter:()=>Fh,isRestTypeNode:()=>Ij,isReturnStatement:()=>nm,isReturnStatementWithFixablePromiseHandler:()=>fV,isRightSideOfAccessExpression:()=>tG,isRightSideOfInstanceofExpression:()=>zfe,isRightSideOfPropertyAccess:()=>WN,isRightSideOfQualifiedName:()=>g0e,isRightSideOfQualifiedNameOrPropertyAccess:()=>YI,isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName:()=>qfe,isRootedDiskPath:()=>ip,isSameEntityName:()=>YP,isSatisfiesExpression:()=>Mj,isScopeMarker:()=>o_e,isSemicolonClassElement:()=>Wde,isSetAccessor:()=>Og,isSetAccessorDeclaration:()=>fp,isShebangTrivia:()=>T$,isShiftOperatorOrHigher:()=>xY,isShorthandAmbientModuleSymbol:()=>K3,isShorthandPropertyAssignment:()=>p_,isSignedNumericLiteral:()=>b9,isSimpleCopiableExpression:()=>xE,isSimpleInlineableExpression:()=>Qg,isSimpleParameter:()=>Qge,isSimpleParameterList:()=>U8,isSingleOrDoubleQuote:()=>pR,isSourceFile:()=>Ji,isSourceFileFromLibrary:()=>eD,isSourceFileJS:()=>Af,isSourceFileNotJS:()=>C6e,isSourceFileNotJson:()=>f9,isSourceMapping:()=>qge,isSpecialPropertyDeclaration:()=>lfe,isSpreadAssignment:()=>Fy,isSpreadElement:()=>Ad,isStatement:()=>Vi,isStatementButNotDeclaration:()=>W3,isStatementOrBlock:()=>p_e,isStatementWithLocals:()=>x_e,isStatic:()=>oa,isStaticModifier:()=>RA,isString:()=>bs,isStringAKeyword:()=>R6e,isStringANonContextualKeyword:()=>uA,isStringAndEmptyAnonymousObjectIntersection:()=>N0e,isStringDoubleQuoted:()=>d9,isStringLiteral:()=>La,isStringLiteralLike:()=>No,isStringLiteralOrJsxExpression:()=>m_e,isStringLiteralOrTemplate:()=>K0e,isStringOrNumericLiteralLike:()=>zp,isStringOrRegularExpressionOrTemplateLiteral:()=>yQ,isStringTextContainingNode:()=>j$,isSuperCall:()=>Kx,isSuperKeyword:()=>EO,isSuperOrSuperProperty:()=>x6e,isSuperProperty:()=>Cf,isSupportedSourceFileName:()=>xpe,isSwitchStatement:()=>NO,isSyntaxList:()=>xN,isSyntheticExpression:()=>S4e,isSyntheticReference:()=>JA,isTagName:()=>oQ,isTaggedTemplateExpression:()=>hE,isTaggedTemplateTag:()=>f0e,isTemplateExpression:()=>Oj,isTemplateHead:()=>IA,isTemplateLiteral:()=>XC,isTemplateLiteralKind:()=>B1,isTemplateLiteralToken:()=>Que,isTemplateLiteralTypeNode:()=>qde,isTemplateLiteralTypeSpan:()=>QG,isTemplateMiddle:()=>GG,isTemplateMiddleOrTemplateTail:()=>N5,isTemplateSpan:()=>PO,isTemplateTail:()=>kj,isTextWhiteSpaceLike:()=>M0e,isThis:()=>$N,isThisContainerOrFunctionBlock:()=>nfe,isThisIdentifier:()=>z1,isThisInTypeQuery:()=>aE,isThisInitializedDeclaration:()=>o9,isThisInitializedObjectBindingExpression:()=>sfe,isThisProperty:()=>aR,isThisTypeNode:()=>yN,isThisTypeParameter:()=>mO,isThisTypePredicate:()=>Z_e,isThrowStatement:()=>nY,isToken:()=>HC,isTokenKind:()=>L$,isTraceEnabled:()=>P0,isTransientSymbol:()=>jh,isTrivia:()=>tN,isTryStatement:()=>c2,isTupleTypeNode:()=>FA,isTypeAlias:()=>TR,isTypeAliasDeclaration:()=>im,isTypeAssertionExpression:()=>ZG,isTypeDeclaration:()=>EA,isTypeElement:()=>$T,isTypeKeyword:()=>g6,isTypeKeywordToken:()=>CQ,isTypeKeywordTokenOrIdentifier:()=>jU,isTypeLiteralNode:()=>lf,isTypeNode:()=>Di,isTypeNodeKind:()=>uG,isTypeOfExpression:()=>vN,isTypeOnlyExportDeclaration:()=>Zue,isTypeOnlyImportDeclaration:()=>vI,isTypeOnlyImportOrExportDeclaration:()=>ib,isTypeOperatorNode:()=>yb,isTypeParameterDeclaration:()=>Ac,isTypePredicateNode:()=>LA,isTypeQueryNode:()=>pE,isTypeReferenceNode:()=>Gp,isTypeReferenceType:()=>j5,isTypeUsableAsPropertyName:()=>tm,isUMDExportSymbol:()=>U9,isUnaryExpression:()=>z$,isUnaryExpressionWithWrite:()=>s_e,isUnicodeIdentifierStart:()=>g5,isUnionTypeNode:()=>Z1,isUrl:()=>hue,isValidBigIntString:()=>_j,isValidESSymbolDeclaration:()=>K_e,isValidTypeOnlyAliasUseSite:()=>gb,isValueSignatureDeclaration:()=>lA,isVarAwaitUsing:()=>tR,isVarConst:()=>zP,isVarConstLike:()=>q_e,isVarUsing:()=>rR,isVariableDeclaration:()=>Ei,isVariableDeclarationInVariableStatement:()=>NI,isVariableDeclarationInitializedToBareOrAccessedRequire:()=>ZT,isVariableDeclarationInitializedToRequire:()=>_R,isVariableDeclarationList:()=>Ru,isVariableLike:()=>rA,isVariableLikeOrAccessor:()=>G_e,isVariableStatement:()=>_l,isVoidExpression:()=>BA,isWatchSet:()=>oG,isWhileStatement:()=>rY,isWhiteSpaceLike:()=>by,isWhiteSpaceSingleLine:()=>wg,isWithStatement:()=>$de,isWriteAccess:()=>mA,isWriteOnlyAccess:()=>B9,isYieldExpression:()=>Rj,jsxModeNeedsExplicitImport:()=>nZ,keywordPart:()=>mp,last:()=>Va,lastOrUndefined:()=>vc,length:()=>wt,libMap:()=>OY,libs:()=>eB,lineBreakPart:()=>XN,linkNamePart:()=>J0e,linkPart:()=>UQ,linkTextPart:()=>zU,listFiles:()=>xX,loadModuleFromGlobalCache:()=>Ege,loadWithModeAwareCache:()=>Y8,makeIdentifierFromModuleName:()=>D_e,makeImport:()=>uS,makeStringLiteral:()=>h6,mangleScopedPackageName:()=>RN,map:()=>Cr,mapAllOrFail:()=>Ww,mapDefined:()=>Gi,mapDefinedEntries:()=>l3,mapDefinedIterator:()=>Up,mapEntries:()=>u3,mapIterator:()=>Ix,mapOneOrMany:()=>eZ,mapToDisplayParts:()=>_S,matchFiles:()=>TG,matchPatternOrExact:()=>AG,matchedText:()=>Qce,matchesExclude:()=>pB,maybeBind:()=>ia,maybeSetLocalizedDiagnosticMessages:()=>ape,memoize:()=>tf,memoizeCached:()=>fOe,memoizeOne:()=>Ih,memoizeWeak:()=>_Oe,metadataHelper:()=>cde,min:()=>MW,minAndMax:()=>kpe,missingFileModifiedTime:()=>np,modifierToFlag:()=>pA,modifiersToFlags:()=>Vg,moduleOptionDeclaration:()=>wme,moduleResolutionIsEqualTo:()=>T_e,moduleResolutionNameAndModeGetter:()=>rX,moduleResolutionOptionDeclarations:()=>MY,moduleResolutionSupportsPackageJsonExportsAndImports:()=>bA,moduleResolutionUsesNodeModules:()=>BU,moduleSpecifierToValidIdentifier:()=>AM,moduleSpecifiers:()=>wb,moduleSymbolToValidIdentifier:()=>x6,moveEmitHelpers:()=>Zpe,moveRangeEnd:()=>F9,moveRangePastDecorators:()=>v0,moveRangePastModifiers:()=>Jg,moveRangePos:()=>mb,moveSyntheticComments:()=>Kpe,mutateMap:()=>tO,mutateMapSkippingNewValues:()=>Dy,needsParentheses:()=>$U,needsScopeMarker:()=>I5,newCaseClauseTracker:()=>cV,newPrivateEnvironment:()=>Kge,noEmitNotification:()=>J8,noEmitSubstitution:()=>n6,noTransformers:()=>whe,noTruncationMaximumTruncationLength:()=>K$,nodeCanBeDecorated:()=>cR,nodeHasName:()=>w3,nodeIsDecorated:()=>HP,nodeIsMissing:()=>$c,nodeIsPresent:()=>Yd,nodeIsSynthesized:()=>Ko,nodeModuleNameResolver:()=>gge,nodeModulesPathPart:()=>jy,nodeNextJsonConfigResolver:()=>hge,nodeOrChildIsDecorated:()=>lR,nodeOverlapsWithStartEnd:()=>AU,nodePosToString:()=>h6e,nodeSeenTracker:()=>GN,nodeStartsNewLexicalEnvironment:()=>FH,nodeToDisplayParts:()=>b7e,noop:()=>io,noopFileWatcher:()=>l6,normalizePath:()=>Zs,normalizeSlashes:()=>qu,not:()=>n5,notImplemented:()=>_a,notImplementedResolver:()=>Mhe,nullNodeConverters:()=>$pe,nullParenthesizerRules:()=>zpe,nullTransformationContext:()=>z8,objectAllocator:()=>Hu,operatorPart:()=>v6,optionDeclarations:()=>og,optionMapToObject:()=>oB,optionsAffectingProgramStructure:()=>Lme,optionsForBuild:()=>FY,optionsForWatch:()=>YA,optionsHaveChanges:()=>UP,optionsHaveModuleResolutionChanges:()=>v_e,or:()=>Jp,orderedRemoveItem:()=>Gw,orderedRemoveItemAt:()=>M1,packageIdToPackageName:()=>q5,packageIdToString:()=>J1,paramHelper:()=>lde,parameterIsThisKeyword:()=>sE,parameterNamePart:()=>j0e,parseBaseNodeFactory:()=>Ame,parseBigInt:()=>Ppe,parseBuildCommand:()=>$me,parseCommandLine:()=>zme,parseCommandLineWorker:()=>BY,parseConfigFileTextToJson:()=>VY,parseConfigFileWithSystem:()=>hye,parseConfigHostFromCompilerHostLike:()=>XB,parseCustomTypeOption:()=>iB,parseIsolatedEntityName:()=>GA,parseIsolatedJSDocComment:()=>Pme,parseJSDocTypeExpressionForTests:()=>c3e,parseJsonConfigFileContent:()=>F3e,parseJsonSourceFileConfigFileContent:()=>D8,parseJsonText:()=>x8,parseListTypeOption:()=>Jme,parseNodeFactory:()=>Cb,parseNodeModuleFromPath:()=>O8,parsePackageName:()=>bB,parsePseudoBigInt:()=>_O,parseValidBigInt:()=>DG,pasteEdits:()=>nte,patchWriteFileEnsuringDirectory:()=>gue,pathContainsNodeModules:()=>Nb,pathIsAbsolute:()=>iI,pathIsBareSpecifier:()=>d$,pathIsRelative:()=>qp,patternText:()=>Xce,perfLogger:()=>rf,performIncrementalCompilation:()=>vye,performance:()=>ale,plainJSErrors:()=>cX,positionBelongsToNode:()=>fQ,positionIsASICandidate:()=>KU,positionIsSynthesized:()=>ng,positionsAreOnSameLine:()=>Ed,preProcessFile:()=>q7e,probablyUsesSemicolons:()=>EM,processCommentPragmas:()=>wY,processPragmasIntoFields:()=>IY,processTaggedTemplateExpression:()=>IK,programContainsEsModules:()=>O0e,programContainsModules:()=>I0e,projectReferenceIsEqualTo:()=>X$,propKeyHelper:()=>Tde,propertyNamePart:()=>B0e,pseudoBigIntToString:()=>uE,punctuationPart:()=>C_,pushIfUnique:()=>ol,quote:()=>T6,quotePreferenceFromString:()=>NQ,rangeContainsPosition:()=>cM,rangeContainsPositionExclusive:()=>lM,rangeContainsRange:()=>Zp,rangeContainsRangeExclusive:()=>y0e,rangeContainsStartEnd:()=>uM,rangeEndIsOnSameLineAsRangeStart:()=>JR,rangeEndPositionsAreOnSameLine:()=>Yfe,rangeEquals:()=>hl,rangeIsOnSingleLine:()=>n2,rangeOfNode:()=>PG,rangeOfTypeParameters:()=>NG,rangeOverlapsWithStartEnd:()=>d6,rangeStartIsOnSameLineAsRangeEnd:()=>Kfe,rangeStartPositionsAreOnSameLine:()=>j9,readBuilderProgram:()=>oU,readConfigFile:()=>P8,readHelper:()=>Sde,readJson:()=>XI,readJsonConfigFile:()=>Hme,readJsonOrUndefined:()=>nG,reduceEachLeadingCommentRange:()=>Cue,reduceEachTrailingCommentRange:()=>Aue,reduceLeft:()=>L_,reduceLeftIterator:()=>Xl,reducePathComponents:()=>Ux,refactor:()=>lk,regExpEscape:()=>n4e,regularExpressionFlagToCharacter:()=>JOe,relativeComplement:()=>Un,removeAllComments:()=>n8,removeEmitHelper:()=>y4e,removeExtension:()=>YR,removeFileExtension:()=>of,removeIgnoredPath:()=>ZB,removeMinAndVersionNumbers:()=>FW,removeOptionality:()=>C0e,removePrefix:()=>Yw,removeSuffix:()=>AP,removeTrailingDirectorySeparator:()=>ZS,repeatString:()=>mM,replaceElement:()=>wW,replaceFirstStar:()=>AA,resolutionExtensionIsTSOrJson:()=>oO,resolveConfigFileProjectName:()=>jX,resolveJSModule:()=>pge,resolveLibrary:()=>vB,resolveModuleName:()=>QA,resolveModuleNameFromCache:()=>_Re,resolvePackageNameToPackageJson:()=>ZY,resolvePath:()=>QS,resolveProjectReferencePath:()=>VN,resolveTripleslashReference:()=>GK,resolveTypeReferenceDirective:()=>lge,resolvingEmptyArray:()=>Y$,restHelper:()=>gde,returnFalse:()=>Dg,returnNoopFileWatcher:()=>u6,returnTrue:()=>YS,returnUndefined:()=>VT,returnsPromise:()=>yZ,runInitializersHelper:()=>_de,sameFlatMap:()=>KF,sameMap:()=>Fs,sameMapping:()=>t8e,scanShebangTrivia:()=>E$,scanTokenAtPosition:()=>J_e,scanner:()=>q_,screenStartingMessageCodes:()=>SX,semanticDiagnosticsOptionDeclarations:()=>Ome,serializeCompilerOptions:()=>cB,server:()=>Zqe,servicesVersion:()=>BFe,setCommentRange:()=>Zl,setConfigFileInOptions:()=>HY,setConstantValue:()=>Qpe,setEachParent:()=>l4e,setEmitFlags:()=>Tn,setFunctionNameHelper:()=>Ede,setGetSourceFileAsHashVersioned:()=>aU,setIdentifierAutoGenerate:()=>a8,setIdentifierGeneratedImportReference:()=>rde,setIdentifierTypeArguments:()=>Rv,setInternalEmitFlags:()=>i8,setLocalizedDiagnosticMessages:()=>spe,setModuleDefaultHelper:()=>Ade,setNodeChildren:()=>nme,setNodeFlags:()=>wpe,setObjectAllocator:()=>ipe,setOriginalNode:()=>zn,setParent:()=>lo,setParentRecursive:()=>T0,setPrivateIdentifier:()=>h2,setSnippetElement:()=>qG,setSourceMapRange:()=>qa,setStackTraceLimit:()=>kOe,setStartsOnNewLine:()=>bj,setSyntheticLeadingComments:()=>hb,setSyntheticTrailingComments:()=>PA,setSys:()=>OOe,setSysLog:()=>pue,setTextRange:()=>Et,setTextRangeEnd:()=>pN,setTextRangePos:()=>fO,setTextRangePosEnd:()=>qg,setTextRangePosWidth:()=>wG,setTokenSourceMapRange:()=>Ype,setTypeNode:()=>ede,setUILocale:()=>Gce,setValueDeclaration:()=>SR,shouldAllowImportingTsExtension:()=>MN,shouldPreserveConstEnums:()=>lE,shouldUseUriStyleNodeCoreModules:()=>aV,showModuleSpecifier:()=>tpe,signatureHasLiteralTypes:()=>yK,signatureHasRestParameter:()=>E_,signatureToDisplayParts:()=>VQ,single:()=>DW,singleElementArray:()=>qC,singleIterator:()=>XF,singleOrMany:()=>wh,singleOrUndefined:()=>Dh,skipAlias:()=>$u,skipAssertions:()=>L4e,skipConstraint:()=>AQ,skipOuterExpressions:()=>Ml,skipParentheses:()=>So,skipPartiallyEmittedExpressions:()=>km,skipTrivia:()=>Ja,skipTypeChecking:()=>uO,skipTypeParentheses:()=>FI,skipWhile:()=>ele,sliceAfter:()=>kG,some:()=>Pt,sort:()=>pa,sortAndDeduplicate:()=>jC,sortAndDeduplicateDiagnostics:()=>wP,sourceFileAffectingCompilerOptions:()=>LY,sourceFileMayBeEmitted:()=>t2,sourceMapCommentRegExp:()=>SK,sourceMapCommentRegExpDontCareLineStart:()=>Bge,spacePart:()=>Zc,spanMap:()=>EP,spreadArrayHelper:()=>bde,stableSort:()=>Qs,startEndContainsRange:()=>_Q,startEndOverlapsWithStartEnd:()=>kU,startOnNewLine:()=>T_,startTracing:()=>ule,startsWith:()=>_s,startsWithDirectory:()=>h$,startsWithUnderscore:()=>rZ,startsWithUseStrict:()=>ume,stringContainsAt:()=>ive,stringToToken:()=>JT,stripQuotes:()=>Zd,supportedDeclarationExtensions:()=>sj,supportedJSExtensions:()=>Spe,supportedJSExtensionsFlat:()=>_N,supportedLocaleDirectories:()=>Fue,supportedTSExtensions:()=>sO,supportedTSExtensionsFlat:()=>EG,supportedTSImplementationExtensions:()=>aj,suppressLeadingAndTrailingTrivia:()=>gp,suppressLeadingTrivia:()=>WQ,suppressTrailingTrivia:()=>H0e,symbolEscapedNameNoDefault:()=>UU,symbolName:()=>Qc,symbolNameNoDefault:()=>wQ,symbolPart:()=>F0e,symbolToDisplayParts:()=>S6,syntaxMayBeASICandidate:()=>Q0e,syntaxRequiresTrailingSemicolonOrASI:()=>YU,sys:()=>lu,sysLog:()=>v3,tagNamesAreEquivalent:()=>kb,takeWhile:()=>VW,targetOptionDeclaration:()=>RY,templateObjectHelper:()=>vde,testFormatSettings:()=>f7e,textChangeRangeIsUnchanged:()=>Iue,textChangeRangeNewSpan:()=>fI,textChanges:()=>Sn,textOrKeywordPart:()=>BQ,textPart:()=>td,textRangeContainsPositionInclusive:()=>P3,textSpanContainsPosition:()=>C$,textSpanContainsTextSpan:()=>Pue,textSpanEnd:()=>bl,textSpanIntersection:()=>wue,textSpanIntersectsWith:()=>S5,textSpanIntersectsWithPosition:()=>Due,textSpanIntersectsWithTextSpan:()=>YOe,textSpanIsEmpty:()=>kue,textSpanOverlap:()=>Nue,textSpanOverlapsWith:()=>GOe,textSpansEqual:()=>KN,textToKeywordObj:()=>m5,timestamp:()=>Tc,toArray:()=>VC,toBuilderFileEmit:()=>oye,toBuilderStateFileInfoForMultiEmit:()=>aye,toEditorSettings:()=>RM,toFileNameLowerCase:()=>R1,toLowerCase:()=>qce,toPath:()=>rc,toProgramEmitPending:()=>cye,tokenIsIdentifierOrKeyword:()=>F_,tokenIsIdentifierOrKeywordOrGreaterThan:()=>Sue,tokenToString:()=>Sa,trace:()=>ds,tracing:()=>Cn,tracingEnabled:()=>h3,transferSourceFileChildren:()=>ime,transform:()=>YFe,transformClassFields:()=>lhe,transformDeclarations:()=>LK,transformECMAScriptModule:()=>MK,transformES2015:()=>Ehe,transformES2016:()=>The,transformES2017:()=>phe,transformES2018:()=>dhe,transformES2019:()=>mhe,transformES2020:()=>ghe,transformES2021:()=>hhe,transformESDecorators:()=>fhe,transformESNext:()=>yhe,transformGenerators:()=>xhe,transformJsx:()=>bhe,transformLegacyDecorators:()=>_he,transformModule:()=>RK,transformNamedEvaluation:()=>dp,transformNodeModule:()=>Ahe,transformNodes:()=>q8,transformSystemModule:()=>Che,transformTypeScript:()=>che,transpile:()=>Q7e,transpileDeclaration:()=>K7e,transpileModule:()=>Ave,transpileOptionValueCompilerOptions:()=>Fme,tryAddToSet:()=>Pg,tryAndIgnoreErrors:()=>ZU,tryCast:()=>ai,tryDirectoryExists:()=>QU,tryExtractTSExtension:()=>M9,tryFileExists:()=>xM,tryGetClassExtendingExpressionWithTypeArguments:()=>ZH,tryGetClassImplementingOrExtendingExpressionWithTypeArguments:()=>eG,tryGetDirectories:()=>XU,tryGetExtensionFromPath:()=>b0,tryGetImportFromModuleSpecifier:()=>bR,tryGetJSDocSatisfiesTypeNode:()=>gj,tryGetModuleNameFromFile:()=>y8,tryGetModuleSpecifierFromDeclaration:()=>MI,tryGetNativePerformanceHooks:()=>sle,tryGetPropertyAccessOrIdentifierToString:()=>VR,tryGetPropertyNameOfBindingOrAssignmentElement:()=>Yj,tryGetSourceMappingURL:()=>Uge,tryGetTextOfPropertyName:()=>PI,tryIOAndConsumeErrors:()=>eV,tryParseJson:()=>L9,tryParsePattern:()=>fN,tryParsePatterns:()=>cj,tryParseRawSourceMap:()=>Jge,tryReadDirectory:()=>YQ,tryReadFile:()=>UO,tryRemoveDirectoryPrefix:()=>SG,tryRemoveExtension:()=>Ape,tryRemovePrefix:()=>UW,tryRemoveSuffix:()=>Kce,typeAcquisitionDeclarations:()=>rB,typeAliasNamePart:()=>U0e,typeDirectiveIsEqualTo:()=>E_e,typeKeywords:()=>xQ,typeParameterNamePart:()=>V0e,typeToDisplayParts:()=>vM,unchangedPollThresholds:()=>u5,unchangedTextChangeRange:()=>b5,unescapeLeadingUnderscores:()=>Qi,unmangleScopedPackageName:()=>M8,unorderedRemoveItem:()=>JC,unorderedRemoveItemAt:()=>jW,unreachableCodeIsError:()=>lpe,unsetNodeChildren:()=>dY,unusedLabelIsError:()=>upe,unwrapInnermostStatementOfLabel:()=>hH,unwrapParenthesizedExpression:()=>Upe,updateErrorForNoInputFiles:()=>fB,updateLanguageServiceSourceFile:()=>WZ,updateMissingFilePathsWatch:()=>WK,updateResolutionField:()=>DN,updateSharedExtendedConfigFileWatcher:()=>qB,updateSourceFile:()=>PY,updateWatchingWildcardDirectories:()=>W8,usesExtensionsOnImports:()=>Tpe,usingSingleLineStringWriter:()=>CI,utf16EncodeAsString:()=>_I,validateLocaleAndSetLanguage:()=>k$,valuesHelper:()=>xde,version:()=>se,versionMajorMinor:()=>j,visitArray:()=>F8,visitCommaListElements:()=>j8,visitEachChild:()=>Mr,visitFunctionBody:()=>Qp,visitIterationBody:()=>ff,visitLexicalEnvironment:()=>vK,visitNode:()=>ot,visitNodes:()=>Kr,visitParameterList:()=>Kc,walkUpBindingElementsAndPatterns:()=>IP,walkUpLexicalEnvironments:()=>Yge,walkUpOuterExpressions:()=>_me,walkUpParenthesizedExpressions:()=>g0,walkUpParenthesizedTypes:()=>AR,walkUpParenthesizedTypesAndGetParentAndChild:()=>gfe,whitespaceOrMapCommentRegExp:()=>bK,writeCommentRange:()=>oN,writeFile:()=>LR,writeFileEnsuringDirectories:()=>HH,zipWith:()=>ho});var lRt=!0,Kqe;function uRt(){return Kqe??(Kqe=new Km(se))}function Xqe(e,t,n,i,s){let o=t?"DeprecationError: ":"DeprecationWarning: ";return o+=`'${e}' `,o+=i?`has been deprecated since v${i}`:"is deprecated",o+=t?" and can no longer be used.":n?` and will no longer be usable after v${n}.`:".",o+=s?` ${wy(s,[e])}`:"",o}function _Rt(e,t,n,i){let s=Xqe(e,!0,t,n,i);return()=>{throw new TypeError(s)}}function fRt(e,t,n,i){let s=!1;return()=>{lRt&&!s&&(M.log.warn(Xqe(e,!1,t,n,i)),s=!0)}}function pRt(e,t={}){let n=typeof t.typeScriptVersion=="string"?new Km(t.typeScriptVersion):t.typeScriptVersion??uRt(),i=typeof t.errorAfter=="string"?new Km(t.errorAfter):t.errorAfter,s=typeof t.warnAfter=="string"?new Km(t.warnAfter):t.warnAfter,o=typeof t.since=="string"?new Km(t.since):t.since??s,u=t.error||i&&n.compareTo(i)>=0,m=!s||n.compareTo(s)>=0;return u?_Rt(e,i,o,t.message):m?fRt(e,i,o,t.message):io}function dRt(e,t){return function(){return e(),t.apply(this,arguments)}}function mRt(e,t){let n=pRt(t?.name??M.getFunctionName(e),t);return dRt(n,e)}function ite(e,t,n,i){if(Object.defineProperty(o,"name",{...Object.getOwnPropertyDescriptor(o,"name"),value:e}),i)for(let u of Object.keys(i)){let m=+u;!isNaN(m)&&Ho(t,`${m}`)&&(t[m]=mRt(t[m],{...i[m],name:e}))}let s=gRt(t,n);return o;function o(...u){let m=s(u),d=m!==void 0?t[m]:void 0;if(typeof d=="function")return d(...u);throw new TypeError("Invalid arguments")}}function gRt(e,t){return n=>{for(let i=0;Ho(e,`${i}`)&&Ho(t,`${i}`);i++){let s=t[i];if(s(n))return i}}}function Qqe(e){return{overload:t=>({bind:n=>({finish:()=>ite(e,t,n),deprecate:i=>({finish:()=>ite(e,t,n,i)})})})}}var Zqe={};A(Zqe,{ActionInvalidate:()=>gU,ActionPackageInstalled:()=>hU,ActionSet:()=>mU,ActionWatchTypingLocations:()=>iM,Arguments:()=>XX,AutoImportProviderProject:()=>cEe,AuxiliaryProject:()=>aEe,CharRangeSection:()=>wEe,CloseFileWatcherEvent:()=>yte,CommandNames:()=>Dze,ConfigFileDiagEvent:()=>pte,ConfiguredProject:()=>lEe,ConfiguredProjectLoadKind:()=>mEe,CreateDirectoryWatcherEvent:()=>hte,CreateFileWatcherEvent:()=>gte,Errors:()=>I0,EventBeginInstallTypes:()=>YX,EventEndInstallTypes:()=>KX,EventInitializationFailed:()=>Gye,EventTypesRegistry:()=>GX,ExternalProject:()=>ote,GcTimer:()=>YTe,InferredProject:()=>sEe,LargeFileReferencedEvent:()=>fte,LineIndex:()=>f7,LineLeaf:()=>sJ,LineNode:()=>dD,LogLevel:()=>UTe,Msg:()=>VTe,OpenFileInfoTelemetryEvent:()=>uEe,Project:()=>vk,ProjectInfoTelemetryEvent:()=>mte,ProjectKind:()=>a7,ProjectLanguageServiceStateEvent:()=>dte,ProjectLoadingFinishEvent:()=>_te,ProjectLoadingStartEvent:()=>ute,ProjectService:()=>bEe,ProjectsUpdatedInBackgroundEvent:()=>nJ,ScriptInfo:()=>ZTe,ScriptVersionCache:()=>Dte,Session:()=>Mze,TextStorage:()=>QTe,ThrottledOperations:()=>GTe,TypingsCache:()=>eEe,TypingsInstallerAdapter:()=>Uze,allFilesAreJsOrDts:()=>rEe,allRootFilesAreJsOrDts:()=>tEe,asNormalizedPath:()=>nze,convertCompilerOptions:()=>iJ,convertFormatOptions:()=>_D,convertScriptKindName:()=>Ste,convertTypeAcquisition:()=>fEe,convertUserPreferences:()=>pEe,convertWatchOptions:()=>u7,countEachFileTypes:()=>o7,createInstallTypingsRequest:()=>JTe,createModuleSpecifierCache:()=>xEe,createNormalizedPathMap:()=>ize,createPackageJsonCache:()=>CEe,createSortedArray:()=>HTe,emptyArray:()=>su,findArgument:()=>e7e,forEachResolvedProjectReferenceProject:()=>xte,formatDiagnosticToProtocol:()=>_7,formatMessage:()=>AEe,getBaseConfigFileName:()=>ste,getLocationInNewDocument:()=>DEe,hasArgument:()=>ZMe,hasNoTypeScriptSource:()=>nEe,indent:()=>f6,isBackgroundProject:()=>l7,isConfigFile:()=>TEe,isConfiguredProject:()=>Wv,isDynamicFileName:()=>s7,isExternalProject:()=>c7,isInferredProject:()=>uD,isInferredProjectName:()=>qTe,isProjectDeferredClose:()=>rJ,makeAutoImportProviderProjectName:()=>WTe,makeAuxiliaryProjectName:()=>$Te,makeInferredProjectName:()=>zTe,maxFileSize:()=>lte,maxProgramSizeForNonTsFiles:()=>cte,normalizedPathToPath:()=>i7,nowString:()=>t7e,nullCancellationToken:()=>kze,nullTypingsInstaller:()=>ate,protocol:()=>KTe,removeSorted:()=>sze,stringifyIndented:()=>Ob,toEvent:()=>kEe,toNormalizedPath:()=>Dc,tryConvertScriptKindName:()=>vte,typingsInstaller:()=>BTe,updateProjectIfDirty:()=>Dd});var BTe={};A(BTe,{TypingsInstaller:()=>vRt,getNpmCommandForInstallation:()=>tze,installNpmPackages:()=>yRt,typingsName:()=>rze});var hRt={isEnabled:()=>!1,writeLine:io};function eze(e,t,n,i){try{let s=QA(t,ri(e,"index.d.ts"),{moduleResolution:2},n);return s.resolvedModule&&s.resolvedModule.resolvedFileName}catch(s){i.isEnabled()&&i.writeLine(`Failed to resolve ${t} in folder '${e}': ${s.message}`);return}}function yRt(e,t,n,i){let s=!1;for(let o=n.length;o>0;){let u=tze(e,t,n,o);o=u.remaining,s=i(u.command)||s}return s}function tze(e,t,n,i){let s=n.length-i,o,u=i;for(;o=`${e} install --ignore-scripts ${(u===n.length?n:n.slice(s,s+u)).join(" ")} --save-dev --user-agent="typesInstaller/${t}"`,!(o.length<8e3);)u=u-Math.floor(u/2);return{command:o,remaining:i-u}}var vRt=class{constructor(e,t,n,i,s,o=hRt){this.installTypingHost=e,this.globalCachePath=t,this.safeListPath=n,this.typesMapLocation=i,this.throttleLimit=s,this.log=o,this.packageNameToTypingLocation=new Map,this.missingTypingsSet=new Set,this.knownCachesSet=new Set,this.projectWatchers=new Map,this.pendingRunRequests=[],this.installRunCount=1,this.inFlightRequestCount=0,this.latestDistTag="latest",this.log.isEnabled()&&this.log.writeLine(`Global cache location '${t}', safe file path '${n}', types map path ${i}`),this.processCacheLocation(this.globalCachePath)}handleRequest(e){switch(e.kind){case"discover":this.install(e);break;case"closeProject":this.closeProject(e);break;case"typesRegistry":{let t={};this.typesRegistry.forEach((i,s)=>{t[s]=i});let n={kind:GX,typesRegistry:t};this.sendResponse(n);break}case"installPackage":{this.installPackage(e);break}default:M.assertNever(e)}}closeProject(e){this.closeWatchers(e.projectName)}closeWatchers(e){if(this.log.isEnabled()&&this.log.writeLine(`Closing file watchers for project '${e}'`),!this.projectWatchers.get(e)){this.log.isEnabled()&&this.log.writeLine(`No watchers are registered for project '${e}'`);return}this.projectWatchers.delete(e),this.sendResponse({kind:iM,projectName:e,files:[]}),this.log.isEnabled()&&this.log.writeLine(`Closing file watchers for project '${e}' - done.`)}install(e){this.log.isEnabled()&&this.log.writeLine(`Got install request${Ob(e)}`),e.cachePath&&(this.log.isEnabled()&&this.log.writeLine(`Request specifies cache path '${e.cachePath}', loading cached information...`),this.processCacheLocation(e.cachePath)),this.safeList===void 0&&this.initializeSafeList();let t=eh.discoverTypings(this.installTypingHost,this.log.isEnabled()?n=>this.log.writeLine(n):void 0,e.fileNames,e.projectRootPath,this.safeList,this.packageNameToTypingLocation,e.typeAcquisition,e.unresolvedImports,this.typesRegistry,e.compilerOptions);this.watchFiles(e.projectName,t.filesToWatch),t.newTypingNames.length?this.installTypings(e,e.cachePath||this.globalCachePath,t.cachedTypingPaths,t.newTypingNames):(this.sendResponse(this.createSetTypings(e,t.cachedTypingPaths)),this.log.isEnabled()&&this.log.writeLine("No new typings were requested as a result of typings discovery"))}installPackage(e){let{fileName:t,packageName:n,projectName:i,projectRootPath:s,id:o}=e,u=Am(mi(t),m=>{if(this.installTypingHost.fileExists(ri(m,"package.json")))return m})||s;if(u)this.installWorker(-1,[n],u,m=>{let d=m?`Package ${n} installed.`:`There was an error installing ${n}.`,S={kind:hU,projectName:i,id:o,success:m,message:d};this.sendResponse(S)});else{let m={kind:hU,projectName:i,id:o,success:!1,message:"Could not determine a project root path."};this.sendResponse(m)}}initializeSafeList(){if(this.typesMapLocation){let e=eh.loadTypesMap(this.installTypingHost,this.typesMapLocation);if(e){this.log.writeLine(`Loaded safelist from types map file '${this.typesMapLocation}'`),this.safeList=e;return}this.log.writeLine(`Failed to load safelist from types map file '${this.typesMapLocation}'`)}this.safeList=eh.loadSafeList(this.installTypingHost,this.safeListPath)}processCacheLocation(e){if(this.log.isEnabled()&&this.log.writeLine(`Processing cache location '${e}'`),this.knownCachesSet.has(e)){this.log.isEnabled()&&this.log.writeLine("Cache location was already processed...");return}let t=ri(e,"package.json"),n=ri(e,"package-lock.json");if(this.log.isEnabled()&&this.log.writeLine(`Trying to find '${t}'...`),this.installTypingHost.fileExists(t)&&this.installTypingHost.fileExists(n)){let i=JSON.parse(this.installTypingHost.readFile(t)),s=JSON.parse(this.installTypingHost.readFile(n));if(this.log.isEnabled()&&(this.log.writeLine(`Loaded content of '${t}':${Ob(i)}`),this.log.writeLine(`Loaded content of '${n}':${Ob(s)}`)),i.devDependencies&&s.dependencies)for(let o in i.devDependencies){if(!Ho(s.dependencies,o))continue;let u=Ul(o);if(!u)continue;let m=eze(e,u,this.installTypingHost,this.log);if(!m){this.missingTypingsSet.add(u);continue}let d=this.packageNameToTypingLocation.get(u);if(d){if(d.typingLocation===m)continue;this.log.isEnabled()&&this.log.writeLine(`New typing for package ${u} from '${m}' conflicts with existing typing file '${d}'`)}this.log.isEnabled()&&this.log.writeLine(`Adding entry into typings cache: '${u}' => '${m}'`);let S=QF(s.dependencies,o),E=S&&S.version;if(!E)continue;let x={typingLocation:m,version:new Km(E)};this.packageNameToTypingLocation.set(u,x)}}this.log.isEnabled()&&this.log.writeLine(`Finished processing cache location '${e}'`),this.knownCachesSet.add(e)}filterTypings(e){return Gi(e,t=>{let n=RN(t);if(this.missingTypingsSet.has(n)){this.log.isEnabled()&&this.log.writeLine(`'${t}':: '${n}' is in missingTypingsSet - skipping...`);return}let i=eh.validatePackageName(t);if(i!==eh.NameValidationResult.Ok){this.missingTypingsSet.add(n),this.log.isEnabled()&&this.log.writeLine(eh.renderPackageNameValidationFailure(i,t));return}if(!this.typesRegistry.has(n)){this.log.isEnabled()&&this.log.writeLine(`'${t}':: Entry for package '${n}' does not exist in local types registry - skipping...`);return}if(this.packageNameToTypingLocation.get(n)&&eh.isTypingUpToDate(this.packageNameToTypingLocation.get(n),this.typesRegistry.get(n))){this.log.isEnabled()&&this.log.writeLine(`'${t}':: '${n}' already has an up-to-date typing - skipping...`);return}return n})}ensurePackageDirectoryExists(e){let t=ri(e,"package.json");this.log.isEnabled()&&this.log.writeLine(`Npm config file: ${t}`),this.installTypingHost.fileExists(t)||(this.log.isEnabled()&&this.log.writeLine(`Npm config file: '${t}' is missing, creating new one...`),this.ensureDirectoryExists(e,this.installTypingHost),this.installTypingHost.writeFile(t,'{ "private": true }'))}installTypings(e,t,n,i){this.log.isEnabled()&&this.log.writeLine(`Installing typings ${JSON.stringify(i)}`);let s=this.filterTypings(i);if(s.length===0){this.log.isEnabled()&&this.log.writeLine("All typings are known to be missing or invalid - no need to install more typings"),this.sendResponse(this.createSetTypings(e,n));return}this.ensurePackageDirectoryExists(t);let o=this.installRunCount;this.installRunCount++,this.sendResponse({kind:YX,eventId:o,typingsInstallerVersion:se,projectName:e.projectName});let u=s.map(rze);this.installTypingsAsync(o,u,t,m=>{try{if(!m){this.log.isEnabled()&&this.log.writeLine(`install request failed, marking packages as missing to prevent repeated requests: ${JSON.stringify(s)}`);for(let S of s)this.missingTypingsSet.add(S);return}this.log.isEnabled()&&this.log.writeLine(`Installed typings ${JSON.stringify(u)}`);let d=[];for(let S of s){let E=eze(t,S,this.installTypingHost,this.log);if(!E){this.missingTypingsSet.add(S);continue}let x=this.typesRegistry.get(S),D=new Km(x[`ts${j}`]||x[this.latestDistTag]),w={typingLocation:E,version:D};this.packageNameToTypingLocation.set(S,w),d.push(E)}this.log.isEnabled()&&this.log.writeLine(`Installed typing files ${JSON.stringify(d)}`),this.sendResponse(this.createSetTypings(e,n.concat(d)))}finally{let d={kind:KX,eventId:o,projectName:e.projectName,packagesToInstall:u,installSuccess:m,typingsInstallerVersion:se};this.sendResponse(d)}})}ensureDirectoryExists(e,t){let n=mi(e);t.directoryExists(n)||this.ensureDirectoryExists(n,t),t.directoryExists(e)||t.createDirectory(e)}watchFiles(e,t){if(!t.length){this.closeWatchers(e);return}let n=this.projectWatchers.get(e),i=new Set(t);!n||d0(i,s=>!n.has(s))||d0(n,s=>!i.has(s))?(this.projectWatchers.set(e,i),this.sendResponse({kind:iM,projectName:e,files:t})):this.sendResponse({kind:iM,projectName:e,files:void 0})}createSetTypings(e,t){return{projectName:e.projectName,typeAcquisition:e.typeAcquisition,compilerOptions:e.compilerOptions,typings:t,unresolvedImports:e.unresolvedImports,kind:mU}}installTypingsAsync(e,t,n,i){this.pendingRunRequests.unshift({requestId:e,packageNames:t,cwd:n,onRequestCompleted:i}),this.executeWithThrottling()}executeWithThrottling(){for(;this.inFlightRequestCount<this.throttleLimit&&this.pendingRunRequests.length;){this.inFlightRequestCount++;let e=this.pendingRunRequests.pop();this.installWorker(e.requestId,e.packageNames,e.cwd,t=>{this.inFlightRequestCount--,e.onRequestCompleted(t),this.executeWithThrottling()})}}};function rze(e){return`@types/${e}@ts${j}`}var UTe=(e=>(e[e.terse=0]="terse",e[e.normal=1]="normal",e[e.requestTime=2]="requestTime",e[e.verbose=3]="verbose",e))(UTe||{}),su=HTe(),VTe=(e=>(e.Err="Err",e.Info="Info",e.Perf="Perf",e))(VTe||{});function JTe(e,t,n,i){return{projectName:e.getProjectName(),fileNames:e.getFileNames(!0,!0).concat(e.getExcludedFiles()),compilerOptions:e.getCompilationSettings(),typeAcquisition:t,unresolvedImports:n,projectRootPath:e.getCurrentDirectory(),cachePath:i,kind:"discover"}}var I0;(e=>{function t(){throw new Error("No Project.")}e.ThrowNoProject=t;function n(){throw new Error("The project's language service is disabled.")}e.ThrowProjectLanguageServiceDisabled=n;function i(s,o){throw new Error(`Project '${o.getProjectName()}' does not contain document '${s}'`)}e.ThrowProjectDoesNotContainDocument=i})(I0||(I0={}));function Dc(e){return Zs(e)}function i7(e,t,n){let i=ip(e)?e:xs(e,t);return n(i)}function nze(e){return e}function ize(){let e=new Map;return{get(t){return e.get(t)},set(t,n){e.set(t,n)},contains(t){return e.has(t)},remove(t){e.delete(t)}}}function qTe(e){return/dev\/null\/inferredProject\d+\*/.test(e)}function zTe(e){return`/dev/null/inferredProject${e}*`}function WTe(e){return`/dev/null/autoImportProviderProject${e}*`}function $Te(e){return`/dev/null/auxiliaryProject${e}*`}function HTe(){return[]}var GTe=class kpt{constructor(t,n){this.host=t,this.pendingTimeouts=new Map,this.logger=n.hasLevel(3)?n:void 0}schedule(t,n,i){let s=this.pendingTimeouts.get(t);s&&this.host.clearTimeout(s),this.pendingTimeouts.set(t,this.host.setTimeout(kpt.run,n,t,this,i)),this.logger&&this.logger.info(`Scheduled: ${t}${s?", Cancelled earlier one":""}`)}cancel(t){let n=this.pendingTimeouts.get(t);return n?(this.host.clearTimeout(n),this.pendingTimeouts.delete(t)):!1}static run(t,n,i){var s,o;(s=rf)==null||s.logStartScheduledOperation(t),n.pendingTimeouts.delete(t),n.logger&&n.logger.info(`Running: ${t}`),i(),(o=rf)==null||o.logStopScheduledOperation()}},YTe=class Ppt{constructor(t,n,i){this.host=t,this.delay=n,this.logger=i}scheduleCollect(){!this.host.gc||this.timerId!==void 0||(this.timerId=this.host.setTimeout(Ppt.run,this.delay,this))}static run(t){var n,i;t.timerId=void 0,(n=rf)==null||n.logStartScheduledOperation("GC collect");let s=t.logger.hasLevel(2),o=s&&t.host.getMemoryUsage();if(t.host.gc(),s){let u=t.host.getMemoryUsage();t.logger.perftrc(`GC::before ${o}, after ${u}`)}(i=rf)==null||i.logStopScheduledOperation()}};function ste(e){let t=Ul(e);return t==="tsconfig.json"||t==="jsconfig.json"?t:void 0}function sze(e,t,n){if(!e||e.length===0)return;if(e[0]===t){e.splice(0,1);return}let i=mv(e,t,ec,n);i>=0&&e.splice(i,1)}var KTe={};A(KTe,{ClassificationType:()=>tQ,CommandTypes:()=>XTe,CompletionTriggerKind:()=>ZX,IndentStyle:()=>lze,JsxEmit:()=>uze,ModuleKind:()=>_ze,ModuleResolutionKind:()=>fze,NewLineKind:()=>pze,OrganizeImportsMode:()=>QX,PollingWatchKind:()=>cze,ScriptTarget:()=>dze,SemicolonPreference:()=>eQ,WatchDirectoryKind:()=>oze,WatchFileKind:()=>aze});var XTe=(e=>(e.JsxClosingTag="jsxClosingTag",e.LinkedEditingRange="linkedEditingRange",e.Brace="brace",e.BraceFull="brace-full",e.BraceCompletion="braceCompletion",e.GetSpanOfEnclosingComment="getSpanOfEnclosingComment",e.Change="change",e.Close="close",e.Completions="completions",e.CompletionInfo="completionInfo",e.CompletionsFull="completions-full",e.CompletionDetails="completionEntryDetails",e.CompletionDetailsFull="completionEntryDetails-full",e.CompileOnSaveAffectedFileList="compileOnSaveAffectedFileList",e.CompileOnSaveEmitFile="compileOnSaveEmitFile",e.Configure="configure",e.Definition="definition",e.DefinitionFull="definition-full",e.DefinitionAndBoundSpan="definitionAndBoundSpan",e.DefinitionAndBoundSpanFull="definitionAndBoundSpan-full",e.Implementation="implementation",e.ImplementationFull="implementation-full",e.EmitOutput="emit-output",e.Exit="exit",e.FileReferences="fileReferences",e.FileReferencesFull="fileReferences-full",e.Format="format",e.Formatonkey="formatonkey",e.FormatFull="format-full",e.FormatonkeyFull="formatonkey-full",e.FormatRangeFull="formatRange-full",e.Geterr="geterr",e.GeterrForProject="geterrForProject",e.SemanticDiagnosticsSync="semanticDiagnosticsSync",e.SyntacticDiagnosticsSync="syntacticDiagnosticsSync",e.SuggestionDiagnosticsSync="suggestionDiagnosticsSync",e.NavBar="navbar",e.NavBarFull="navbar-full",e.Navto="navto",e.NavtoFull="navto-full",e.NavTree="navtree",e.NavTreeFull="navtree-full",e.DocumentHighlights="documentHighlights",e.DocumentHighlightsFull="documentHighlights-full",e.Open="open",e.Quickinfo="quickinfo",e.QuickinfoFull="quickinfo-full",e.References="references",e.ReferencesFull="references-full",e.Reload="reload",e.Rename="rename",e.RenameInfoFull="rename-full",e.RenameLocationsFull="renameLocations-full",e.Saveto="saveto",e.SignatureHelp="signatureHelp",e.SignatureHelpFull="signatureHelp-full",e.FindSourceDefinition="findSourceDefinition",e.Status="status",e.TypeDefinition="typeDefinition",e.ProjectInfo="projectInfo",e.ReloadProjects="reloadProjects",e.Unknown="unknown",e.OpenExternalProject="openExternalProject",e.OpenExternalProjects="openExternalProjects",e.CloseExternalProject="closeExternalProject",e.SynchronizeProjectList="synchronizeProjectList",e.ApplyChangedToOpenFiles="applyChangedToOpenFiles",e.UpdateOpen="updateOpen",e.EncodedSyntacticClassificationsFull="encodedSyntacticClassifications-full",e.EncodedSemanticClassificationsFull="encodedSemanticClassifications-full",e.Cleanup="cleanup",e.GetOutliningSpans="getOutliningSpans",e.GetOutliningSpansFull="outliningSpans",e.TodoComments="todoComments",e.Indentation="indentation",e.DocCommentTemplate="docCommentTemplate",e.CompilerOptionsDiagnosticsFull="compilerOptionsDiagnostics-full",e.NameOrDottedNameSpan="nameOrDottedNameSpan",e.BreakpointStatement="breakpointStatement",e.CompilerOptionsForInferredProjects="compilerOptionsForInferredProjects",e.GetCodeFixes="getCodeFixes",e.GetCodeFixesFull="getCodeFixes-full",e.GetCombinedCodeFix="getCombinedCodeFix",e.GetCombinedCodeFixFull="getCombinedCodeFix-full",e.ApplyCodeActionCommand="applyCodeActionCommand",e.GetSupportedCodeFixes="getSupportedCodeFixes",e.GetApplicableRefactors="getApplicableRefactors",e.GetEditsForRefactor="getEditsForRefactor",e.GetMoveToRefactoringFileSuggestions="getMoveToRefactoringFileSuggestions",e.GetPasteEdits="getPasteEdits",e.GetEditsForRefactorFull="getEditsForRefactor-full",e.OrganizeImports="organizeImports",e.OrganizeImportsFull="organizeImports-full",e.GetEditsForFileRename="getEditsForFileRename",e.GetEditsForFileRenameFull="getEditsForFileRename-full",e.ConfigurePlugin="configurePlugin",e.SelectionRange="selectionRange",e.SelectionRangeFull="selectionRange-full",e.ToggleLineComment="toggleLineComment",e.ToggleLineCommentFull="toggleLineComment-full",e.ToggleMultilineComment="toggleMultilineComment",e.ToggleMultilineCommentFull="toggleMultilineComment-full",e.CommentSelection="commentSelection",e.CommentSelectionFull="commentSelection-full",e.UncommentSelection="uncommentSelection",e.UncommentSelectionFull="uncommentSelection-full",e.PrepareCallHierarchy="prepareCallHierarchy",e.ProvideCallHierarchyIncomingCalls="provideCallHierarchyIncomingCalls",e.ProvideCallHierarchyOutgoingCalls="provideCallHierarchyOutgoingCalls",e.ProvideInlayHints="provideInlayHints",e.WatchChange="watchChange",e.MapCode="mapCode",e))(XTe||{}),aze=(e=>(e.FixedPollingInterval="FixedPollingInterval",e.PriorityPollingInterval="PriorityPollingInterval",e.DynamicPriorityPolling="DynamicPriorityPolling",e.FixedChunkSizePolling="FixedChunkSizePolling",e.UseFsEvents="UseFsEvents",e.UseFsEventsOnParentDirectory="UseFsEventsOnParentDirectory",e))(aze||{}),oze=(e=>(e.UseFsEvents="UseFsEvents",e.FixedPollingInterval="FixedPollingInterval",e.DynamicPriorityPolling="DynamicPriorityPolling",e.FixedChunkSizePolling="FixedChunkSizePolling",e))(oze||{}),cze=(e=>(e.FixedInterval="FixedInterval",e.PriorityInterval="PriorityInterval",e.DynamicPriority="DynamicPriority",e.FixedChunkSize="FixedChunkSize",e))(cze||{}),lze=(e=>(e.None="None",e.Block="Block",e.Smart="Smart",e))(lze||{}),uze=(e=>(e.None="none",e.Preserve="preserve",e.ReactNative="react-native",e.React="react",e.ReactJSX="react-jsx",e.ReactJSXDev="react-jsxdev",e))(uze||{}),_ze=(e=>(e.None="none",e.CommonJS="commonjs",e.AMD="amd",e.UMD="umd",e.System="system",e.ES6="es6",e.ES2015="es2015",e.ES2020="es2020",e.ES2022="es2022",e.ESNext="esnext",e.Node16="node16",e.NodeNext="nodenext",e.Preserve="preserve",e))(_ze||{}),fze=(e=>(e.Classic="classic",e.Node="node",e.NodeJs="node",e.Node10="node10",e.Node16="node16",e.NodeNext="nodenext",e.Bundler="bundler",e))(fze||{}),pze=(e=>(e.Crlf="Crlf",e.Lf="Lf",e))(pze||{}),dze=(e=>(e.ES3="es3",e.ES5="es5",e.ES6="es6",e.ES2015="es2015",e.ES2016="es2016",e.ES2017="es2017",e.ES2018="es2018",e.ES2019="es2019",e.ES2020="es2020",e.ES2021="es2021",e.ES2022="es2022",e.ES2023="es2023",e.ESNext="esnext",e.JSON="json",e.Latest="esnext",e))(dze||{}),QTe=class{constructor(e,t,n){this.host=e,this.info=t,this.isOpen=!1,this.ownFileText=!1,this.pendingReloadFromDisk=!1,this.version=n||0}getVersion(){return this.svc?`SVC-${this.version}-${this.svc.getSnapshotVersion()}`:`Text-${this.version}`}hasScriptVersionCache_TestOnly(){return this.svc!==void 0}resetSourceMapInfo(){this.info.sourceFileLike=void 0,this.info.closeSourceMapFileWatcher(),this.info.sourceMapFilePath=void 0,this.info.declarationInfoPath=void 0,this.info.sourceInfos=void 0,this.info.documentPositionMapper=void 0}useText(e){this.svc=void 0,this.text=e,this.textSnapshot=void 0,this.lineMap=void 0,this.fileSize=void 0,this.resetSourceMapInfo(),this.version++}edit(e,t,n){this.switchToScriptVersionCache().edit(e,t-e,n),this.ownFileText=!1,this.text=void 0,this.textSnapshot=void 0,this.lineMap=void 0,this.fileSize=void 0,this.resetSourceMapInfo()}reload(e){return M.assert(e!==void 0),this.pendingReloadFromDisk=!1,!this.text&&this.svc&&(this.text=sk(this.svc.getSnapshot())),this.text!==e?(this.useText(e),this.ownFileText=!1,!0):!1}reloadWithFileText(e){let{text:t,fileSize:n}=e||!this.info.isDynamicOrHasMixedContent()?this.getFileTextAndSize(e):{text:"",fileSize:void 0},i=this.reload(t);return this.fileSize=n,this.ownFileText=!e||e===this.info.fileName,this.ownFileText&&this.info.mTime===np.getTime()&&(this.info.mTime=(this.host.getModifiedTime(this.info.fileName)||np).getTime()),i}scheduleReloadIfNeeded(){return!this.pendingReloadFromDisk&&!this.ownFileText?this.pendingReloadFromDisk=!0:!1}delayReloadFromFileIntoText(){this.pendingReloadFromDisk=!0}getTelemetryFileSize(){return this.fileSize?this.fileSize:this.text?this.text.length:this.svc?this.svc.getSnapshot().getLength():this.getSnapshot().getLength()}getSnapshot(){var e;return((e=this.tryUseScriptVersionCache())==null?void 0:e.getSnapshot())||(this.textSnapshot??(this.textSnapshot=yU.fromString(M.checkDefined(this.text))))}getAbsolutePositionAndLineText(e){let t=this.tryUseScriptVersionCache();if(t)return t.getAbsolutePositionAndLineText(e);let n=this.getLineMap();return e<=n.length?{absolutePosition:n[e-1],lineText:this.text.substring(n[e-1],n[e])}:{absolutePosition:this.text.length,lineText:void 0}}lineToTextSpan(e){let t=this.tryUseScriptVersionCache();if(t)return t.lineToTextSpan(e);let n=this.getLineMap(),i=n[e],s=e+1<n.length?n[e+1]:this.text.length;return Il(i,s)}lineOffsetToPosition(e,t,n){let i=this.tryUseScriptVersionCache();return i?i.lineOffsetToPosition(e,t):h5(this.getLineMap(),e-1,t-1,this.text,n)}positionToLineOffset(e){let t=this.tryUseScriptVersionCache();if(t)return t.positionToLineOffset(e);let{line:n,character:i}=NP(this.getLineMap(),e);return{line:n+1,offset:i+1}}getFileTextAndSize(e){let t,n=e||this.info.fileName,i=()=>t===void 0?t=this.host.readFile(n)||"":t;if(!TA(this.info.fileName)){let s=this.host.getFileSize?this.host.getFileSize(n):i().length;if(s>lte)return M.assert(!!this.info.containingProjects.length),this.info.containingProjects[0].projectService.logger.info(`Skipped loading contents of large file ${n} for info ${this.info.fileName}: fileSize: ${s}`),this.info.containingProjects[0].projectService.sendLargeFileReferencedEvent(n,s),{text:"",fileSize:s}}return{text:i()}}switchToScriptVersionCache(){return(!this.svc||this.pendingReloadFromDisk)&&(this.svc=Dte.fromString(this.getOrLoadText()),this.textSnapshot=void 0,this.version++),this.svc}tryUseScriptVersionCache(){return(!this.svc||this.pendingReloadFromDisk)&&this.getOrLoadText(),this.isOpen?(!this.svc&&!this.textSnapshot&&(this.svc=Dte.fromString(M.checkDefined(this.text)),this.textSnapshot=void 0),this.svc):this.svc}getOrLoadText(){return(this.text===void 0||this.pendingReloadFromDisk)&&(M.assert(!this.svc||this.pendingReloadFromDisk,"ScriptVersionCache should not be set when reloading from disk"),this.reloadWithFileText()),this.text}getLineMap(){return M.assert(!this.svc,"ScriptVersionCache should not be set"),this.lineMap||(this.lineMap=$C(M.checkDefined(this.text)))}getLineInfo(){let e=this.tryUseScriptVersionCache();if(e)return{getLineCount:()=>e.getLineCount(),getLineText:n=>e.getAbsolutePositionAndLineText(n+1).lineText};let t=this.getLineMap();return TK(this.text,t)}};function s7(e){return e[0]==="^"||(e.includes("walkThroughSnippet:/")||e.includes("untitled:/"))&&Ul(e)[0]==="^"||e.includes(":^")&&!e.includes(Ec)}var ZTe=class{constructor(e,t,n,i,s,o){this.host=e,this.fileName=t,this.scriptKind=n,this.hasMixedContent=i,this.path=s,this.containingProjects=[],this.isDynamic=s7(t),this.textStorage=new QTe(e,this,o),(i||this.isDynamic)&&(this.realpath=this.path),this.scriptKind=n||ij(t)}isDynamicOrHasMixedContent(){return this.hasMixedContent||this.isDynamic}isScriptOpen(){return this.textStorage.isOpen}open(e){this.textStorage.isOpen=!0,e!==void 0&&this.textStorage.reload(e)&&this.markContainingProjectsAsDirty()}close(e=!0){this.textStorage.isOpen=!1,e&&this.textStorage.scheduleReloadIfNeeded()&&this.markContainingProjectsAsDirty()}getSnapshot(){return this.textStorage.getSnapshot()}ensureRealPath(){if(this.realpath===void 0&&(this.realpath=this.path,this.host.realpath)){M.assert(!!this.containingProjects.length);let e=this.containingProjects[0],t=this.host.realpath(this.path);t&&(this.realpath=e.toPath(t),this.realpath!==this.path&&e.projectService.realpathToScriptInfos.add(this.realpath,this))}}getRealpathIfDifferent(){return this.realpath&&this.realpath!==this.path?this.realpath:void 0}isSymlink(){return this.realpath&&this.realpath!==this.path}getFormatCodeSettings(){return this.formatSettings}getPreferences(){return this.preferences}attachToProject(e){let t=!this.isAttached(e);return t&&(this.containingProjects.push(e),e.getCompilerOptions().preserveSymlinks||this.ensureRealPath(),e.onFileAddedOrRemoved(this.isSymlink())),t}isAttached(e){switch(this.containingProjects.length){case 0:return!1;case 1:return this.containingProjects[0]===e;case 2:return this.containingProjects[0]===e||this.containingProjects[1]===e;default:return Es(this.containingProjects,e)}}detachFromProject(e){switch(this.containingProjects.length){case 0:return;case 1:this.containingProjects[0]===e&&(e.onFileAddedOrRemoved(this.isSymlink()),this.containingProjects.pop());break;case 2:this.containingProjects[0]===e?(e.onFileAddedOrRemoved(this.isSymlink()),this.containingProjects[0]=this.containingProjects.pop()):this.containingProjects[1]===e&&(e.onFileAddedOrRemoved(this.isSymlink()),this.containingProjects.pop());break;default:Gw(this.containingProjects,e)&&e.onFileAddedOrRemoved(this.isSymlink());break}}detachAllProjects(){for(let e of this.containingProjects){Wv(e)&&e.getCachedDirectoryStructureHost().addOrDeleteFile(this.fileName,this.path,2);let t=e.getRootFilesMap().get(this.path);e.removeFile(this,!1,!1),e.onFileAddedOrRemoved(this.isSymlink()),t&&!uD(e)&&e.addMissingFileRoot(t.fileName)}Ym(this.containingProjects)}getDefaultProject(){switch(this.containingProjects.length){case 0:return I0.ThrowNoProject();case 1:return rJ(this.containingProjects[0])||l7(this.containingProjects[0])?I0.ThrowNoProject():this.containingProjects[0];default:let e,t,n,i;for(let s=0;s<this.containingProjects.length;s++){let o=this.containingProjects[s];if(Wv(o)){if(o.deferredClose)continue;if(!o.isSourceOfProjectReferenceRedirect(this.fileName)){if(i===void 0&&s!==this.containingProjects.length-1&&(i=o.projectService.findDefaultConfiguredProject(this)||!1),i===o)return o;n||(n=o)}e||(e=o)}else{if(c7(o))return o;!t&&uD(o)&&(t=o)}}return(i||n||e||t)??I0.ThrowNoProject()}}registerFileUpdate(){for(let e of this.containingProjects)e.registerFileUpdate(this.path)}setOptions(e,t){e&&(this.formatSettings?this.formatSettings={...this.formatSettings,...e}:(this.formatSettings=vU(this.host.newLine),Mx(this.formatSettings,e))),t&&(this.preferences||(this.preferences=am),this.preferences={...this.preferences,...t})}getLatestVersion(){return this.textStorage.getSnapshot(),this.textStorage.getVersion()}saveTo(e){this.host.writeFile(e,sk(this.textStorage.getSnapshot()))}delayReloadNonMixedContentFile(){M.assert(!this.isDynamicOrHasMixedContent()),this.textStorage.delayReloadFromFileIntoText(),this.markContainingProjectsAsDirty()}reloadFromFile(e){return this.textStorage.reloadWithFileText(e)?(this.markContainingProjectsAsDirty(),!0):!1}editContent(e,t,n){this.textStorage.edit(e,t,n),this.markContainingProjectsAsDirty()}markContainingProjectsAsDirty(){for(let e of this.containingProjects)e.markFileAsDirty(this.path)}isOrphan(){return this.deferredDelete||!kt(this.containingProjects,e=>!e.isOrphan())}isContainedByBackgroundProject(){return Pt(this.containingProjects,l7)}lineToTextSpan(e){return this.textStorage.lineToTextSpan(e)}lineOffsetToPosition(e,t,n){return this.textStorage.lineOffsetToPosition(e,t,n)}positionToLineOffset(e){SRt(e);let t=this.textStorage.positionToLineOffset(e);return bRt(t),t}isJavaScript(){return this.scriptKind===1||this.scriptKind===2}closeSourceMapFileWatcher(){this.sourceMapFilePath&&!bs(this.sourceMapFilePath)&&(Nd(this.sourceMapFilePath),this.sourceMapFilePath=void 0)}};function SRt(e){M.assert(typeof e=="number",`Expected position ${e} to be a number.`),M.assert(e>=0,"Expected position to be non-negative.")}function bRt(e){M.assert(typeof e.line=="number",`Expected line ${e.line} to be a number.`),M.assert(typeof e.offset=="number",`Expected offset ${e.offset} to be a number.`),M.assert(e.line>0,`Expected line to be non-${e.line===0?"zero":"negative"}`),M.assert(e.offset>0,`Expected offset to be non-${e.offset===0?"zero":"negative"}`)}var ate={isKnownTypesPackageName:Dg,installPackage:_a,enqueueInstallTypingsRequest:io,attach:io,onProjectClosed:io,globalTypingsCacheLocation:void 0};function mze(e,t){if(e===t||(e||su).length===0&&(t||su).length===0)return!0;let n=new Map,i=0;for(let s of e)n.get(s)!==!0&&(n.set(s,!0),i++);for(let s of t){let o=n.get(s);if(o===void 0)return!1;o===!0&&(n.set(s,!1),i--)}return i===0}function TRt(e,t){return e.enable!==t.enable||!mze(e.include,t.include)||!mze(e.exclude,t.exclude)}function ERt(e,t){return H1(e)!==H1(t)}function xRt(e,t){return e===t?!1:!Vp(e,t)}var eEe=class{constructor(e){this.installer=e,this.perProjectCache=new Map}isKnownTypesPackageName(e){return this.installer.isKnownTypesPackageName(e)}installPackage(e){return this.installer.installPackage(e)}enqueueInstallTypingsForProject(e,t,n){let i=e.getTypeAcquisition();if(!i||!i.enable)return;let s=this.perProjectCache.get(e.getProjectName());(n||!s||TRt(i,s.typeAcquisition)||ERt(e.getCompilationSettings(),s.compilerOptions)||xRt(t,s.unresolvedImports))&&(this.perProjectCache.set(e.getProjectName(),{compilerOptions:e.getCompilationSettings(),typeAcquisition:i,typings:s?s.typings:su,unresolvedImports:t,poisoned:!0}),this.installer.enqueueInstallTypingsRequest(e,i,t))}updateTypingsForProject(e,t,n,i,s){let o=pa(s);return this.perProjectCache.set(e,{compilerOptions:t,typeAcquisition:n,typings:o,unresolvedImports:i,poisoned:!1}),!n||!n.enable?su:o}onProjectClosed(e){this.perProjectCache.delete(e.getProjectName())&&this.installer.onProjectClosed(e)}},a7=(e=>(e[e.Inferred=0]="Inferred",e[e.Configured=1]="Configured",e[e.External=2]="External",e[e.AutoImportProvider=3]="AutoImportProvider",e[e.Auxiliary=4]="Auxiliary",e))(a7||{});function o7(e,t=!1){let n={js:0,jsSize:0,jsx:0,jsxSize:0,ts:0,tsSize:0,tsx:0,tsxSize:0,dts:0,dtsSize:0,deferred:0,deferredSize:0};for(let i of e){let s=t?i.textStorage.getTelemetryFileSize():0;switch(i.scriptKind){case 1:n.js+=1,n.jsSize+=s;break;case 2:n.jsx+=1,n.jsxSize+=s;break;case 3:Mu(i.fileName)?(n.dts+=1,n.dtsSize+=s):(n.ts+=1,n.tsSize+=s);break;case 4:n.tsx+=1,n.tsxSize+=s;break;case 7:n.deferred+=1,n.deferredSize+=s;break}}return n}function CRt(e){let t=o7(e.getScriptInfos());return t.js>0&&t.ts===0&&t.tsx===0}function tEe(e){let t=o7(e.getRootScriptInfos());return t.ts===0&&t.tsx===0}function rEe(e){let t=o7(e.getScriptInfos());return t.ts===0&&t.tsx===0}function nEe(e){return!e.some(t=>Ic(t,".ts")&&!Mu(t)||Ic(t,".tsx"))}function iEe(e){return e.generatedFilePath!==void 0}var vk=class Npt{constructor(t,n,i,s,o,u,m,d,S,E,x){switch(this.projectKind=n,this.projectService=i,this.documentRegistry=s,this.compilerOptions=m,this.compileOnSaveEnabled=d,this.watchOptions=S,this.rootFilesMap=new Map,this.plugins=[],this.cachedUnresolvedImportsPerFile=new Map,this.hasAddedorRemovedFiles=!1,this.hasAddedOrRemovedSymlinks=!1,this.lastReportedVersion=0,this.projectProgramVersion=0,this.projectStateVersion=0,this.isInitialLoadPending=Dg,this.dirty=!1,this.typingFiles=su,this.moduleSpecifierCache=xEe(this),this.createHash=ia(this.projectService.host,this.projectService.host.createHash),this.globalCacheResolutionModuleName=eh.nonRelativeModuleNameForTypingCache,this.updateFromProjectInProgress=!1,this.projectName=t,this.directoryStructureHost=E,this.currentDirectory=this.projectService.getNormalizedAbsolutePath(x),this.getCanonicalFileName=this.projectService.toCanonicalFileName,this.jsDocParsingMode=this.projectService.jsDocParsingMode,this.cancellationToken=new U1e(this.projectService.cancellationToken,this.projectService.throttleWaitMilliseconds),this.compilerOptions?(o||H1(this.compilerOptions)||this.projectService.hasDeferredExtension())&&(this.compilerOptions.allowNonTsExtensions=!0):(this.compilerOptions=AV(),this.compilerOptions.allowNonTsExtensions=!0,this.compilerOptions.allowJs=!0),i.serverMode){case 0:this.languageServiceEnabled=!0;break;case 1:this.languageServiceEnabled=!0,this.compilerOptions.noResolve=!0,this.compilerOptions.types=[];break;case 2:this.languageServiceEnabled=!1,this.compilerOptions.noResolve=!0,this.compilerOptions.types=[];break;default:M.assertNever(i.serverMode)}this.setInternalCompilerOptionsForEmittingJsFiles();let D=this.projectService.host;this.projectService.logger.loggingEnabled()?this.trace=w=>this.writeLog(w):D.trace&&(this.trace=w=>D.trace(w)),this.realpath=ia(D,D.realpath),this.resolutionCache=vX(this,this.currentDirectory,!0),this.languageService=V1e(this,this.documentRegistry,this.projectService.serverMode),u&&this.disableLanguageService(u),this.markAsDirty(),l7(this)||(this.projectService.pendingEnsureProjectForOpenFiles=!0),this.projectService.onProjectCreation(this)}getResolvedProjectReferenceToRedirect(t){}isNonTsProject(){return Dd(this),rEe(this)}isJsOnlyProject(){return Dd(this),CRt(this)}static resolveModule(t,n,i,s){return Npt.importServicePluginSync({name:t},[n],i,s).resolvedModule}static importServicePluginSync(t,n,i,s){M.assertIsDefined(i.require);let o,u;for(let m of n){let d=qu(i.resolvePath(ri(m,"node_modules")));s(`Loading ${t.name} from ${m} (resolved to ${d})`);let S=i.require(d,t.name);if(!S.error){u=S.module;break}let E=S.error.stack||S.error.message||JSON.stringify(S.error);(o??(o=[])).push(`Failed to load module '${t.name}' from ${d}: ${E}`)}return{pluginConfigEntry:t,resolvedModule:u,errorLogs:o}}static async importServicePluginAsync(t,n,i,s){M.assertIsDefined(i.importPlugin);let o,u;for(let m of n){let d=ri(m,"node_modules");s(`Dynamically importing ${t.name} from ${m} (resolved to ${d})`);let S;try{S=await i.importPlugin(d,t.name)}catch(x){S={module:void 0,error:x}}if(!S.error){u=S.module;break}let E=S.error.stack||S.error.message||JSON.stringify(S.error);(o??(o=[])).push(`Failed to dynamically import module '${t.name}' from ${d}: ${E}`)}return{pluginConfigEntry:t,resolvedModule:u,errorLogs:o}}isKnownTypesPackageName(t){return this.typingsCache.isKnownTypesPackageName(t)}installPackage(t){return this.typingsCache.installPackage({...t,projectName:this.projectName,projectRootPath:this.toPath(this.currentDirectory)})}getGlobalTypingsCacheLocation(){return this.getGlobalCache()}get typingsCache(){return this.projectService.typingsCache}getSymlinkCache(){return this.symlinks||(this.symlinks=vG(this.getCurrentDirectory(),this.getCanonicalFileName)),this.program&&!this.symlinks.hasProcessedResolutions()&&this.symlinks.setSymlinksFromResolutions(this.program.forEachResolvedModule,this.program.forEachResolvedTypeReferenceDirective,this.program.getAutomaticTypeDirectiveResolutions()),this.symlinks}getCompilationSettings(){return this.compilerOptions}getCompilerOptions(){return this.getCompilationSettings()}getNewLine(){return this.projectService.host.newLine}getProjectVersion(){return this.projectStateVersion.toString()}getProjectReferences(){}getScriptFileNames(){if(!this.rootFilesMap.size)return ve;let t;return this.rootFilesMap.forEach(n=>{(this.languageServiceEnabled||n.info&&n.info.isScriptOpen())&&(t||(t=[])).push(n.fileName)}),wn(t,this.typingFiles)||ve}getOrCreateScriptInfoAndAttachToProject(t){let n=this.projectService.getOrCreateScriptInfoNotOpenedByClient(t,this.currentDirectory,this.directoryStructureHost,!1);if(n){let i=this.rootFilesMap.get(n.path);i&&i.info!==n&&(i.info=n),n.attachToProject(this)}return n}getScriptKind(t){let n=this.projectService.getScriptInfoForPath(this.toPath(t));return n&&n.scriptKind}getScriptVersion(t){let n=this.projectService.getOrCreateScriptInfoNotOpenedByClient(t,this.currentDirectory,this.directoryStructureHost,!1);return n&&n.getLatestVersion()}getScriptSnapshot(t){let n=this.getOrCreateScriptInfoAndAttachToProject(t);if(n)return n.getSnapshot()}getCancellationToken(){return this.cancellationToken}getCurrentDirectory(){return this.currentDirectory}getDefaultLibFileName(){let t=mi(Zs(this.projectService.getExecutingFilePath()));return ri(t,k3(this.compilerOptions))}useCaseSensitiveFileNames(){return this.projectService.host.useCaseSensitiveFileNames}readDirectory(t,n,i,s,o){return this.directoryStructureHost.readDirectory(t,n,i,s,o)}readFile(t){return this.projectService.host.readFile(t)}writeFile(t,n){return this.projectService.host.writeFile(t,n)}fileExists(t){let n=this.toPath(t);return!this.isWatchedMissingFile(n)&&this.directoryStructureHost.fileExists(t)}resolveModuleNameLiterals(t,n,i,s,o,u){return this.resolutionCache.resolveModuleNameLiterals(t,n,i,s,o,u)}getModuleResolutionCache(){return this.resolutionCache.getModuleResolutionCache()}resolveTypeReferenceDirectiveReferences(t,n,i,s,o,u){return this.resolutionCache.resolveTypeReferenceDirectiveReferences(t,n,i,s,o,u)}resolveLibrary(t,n,i,s){return this.resolutionCache.resolveLibrary(t,n,i,s)}directoryExists(t){return this.directoryStructureHost.directoryExists(t)}getDirectories(t){return this.directoryStructureHost.getDirectories(t)}getCachedDirectoryStructureHost(){}toPath(t){return rc(t,this.currentDirectory,this.projectService.toCanonicalFileName)}watchDirectoryOfFailedLookupLocation(t,n,i){return this.projectService.watchFactory.watchDirectory(t,n,i,this.projectService.getWatchOptions(this),Tu.FailedLookupLocations,this)}watchAffectingFileLocation(t,n){return this.projectService.watchFactory.watchFile(t,n,2e3,this.projectService.getWatchOptions(this),Tu.AffectingFileLocation,this)}clearInvalidateResolutionOfFailedLookupTimer(){return this.projectService.throttledOperations.cancel(`${this.getProjectName()}FailedLookupInvalidation`)}scheduleInvalidateResolutionsOfFailedLookupLocations(){this.projectService.throttledOperations.schedule(`${this.getProjectName()}FailedLookupInvalidation`,1e3,()=>{this.resolutionCache.invalidateResolutionsOfFailedLookupLocations()&&this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this)})}invalidateResolutionsOfFailedLookupLocations(){this.clearInvalidateResolutionOfFailedLookupTimer()&&this.resolutionCache.invalidateResolutionsOfFailedLookupLocations()&&(this.markAsDirty(),this.projectService.delayEnsureProjectForOpenFiles())}onInvalidatedResolution(){this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this)}watchTypeRootsDirectory(t,n,i){return this.projectService.watchFactory.watchDirectory(t,n,i,this.projectService.getWatchOptions(this),Tu.TypeRoots,this)}hasChangedAutomaticTypeDirectiveNames(){return this.resolutionCache.hasChangedAutomaticTypeDirectiveNames()}onChangedAutomaticTypeDirectiveNames(){this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this)}getGlobalCache(){return this.getTypeAcquisition().enable?this.projectService.typingsInstaller.globalTypingsCacheLocation:void 0}fileIsOpen(t){return this.projectService.openFiles.has(t)}writeLog(t){this.projectService.logger.info(t)}log(t){this.writeLog(t)}error(t){this.projectService.logger.msg(t,"Err")}setInternalCompilerOptionsForEmittingJsFiles(){(this.projectKind===0||this.projectKind===2)&&(this.compilerOptions.noEmitForJsFiles=!0)}getGlobalProjectErrors(){return Zn(this.projectErrors,t=>!t.file)||su}getAllProjectErrors(){return this.projectErrors||su}setProjectErrors(t){this.projectErrors=t}getLanguageService(t=!0){return t&&Dd(this),this.languageService}getSourceMapper(){return this.getLanguageService().getSourceMapper()}clearSourceMapperCache(){this.languageService.clearSourceMapperCache()}getDocumentPositionMapper(t,n){return this.projectService.getDocumentPositionMapper(this,t,n)}getSourceFileLike(t){return this.projectService.getSourceFileLike(t,this)}shouldEmitFile(t){return t&&!t.isDynamicOrHasMixedContent()&&!this.program.isSourceOfProjectReferenceRedirect(t.path)}getCompileOnSaveAffectedFileList(t){return this.languageServiceEnabled?(Dd(this),this.builderState=lg.create(this.program,this.builderState,!0),Gi(lg.getFilesAffectedBy(this.builderState,this.program,t.path,this.cancellationToken,this.projectService.host),n=>this.shouldEmitFile(this.projectService.getScriptInfoForPath(n.path))?n.fileName:void 0)):[]}emitFile(t,n){if(!this.languageServiceEnabled||!this.shouldEmitFile(t))return{emitSkipped:!0,diagnostics:su};let{emitSkipped:i,diagnostics:s,outputFiles:o}=this.getLanguageService().getEmitOutput(t.fileName);if(!i){for(let u of o){let m=xs(u.name,this.currentDirectory);n(m,u.text,u.writeByteOrderMark)}if(this.builderState&&$p(this.compilerOptions)){let u=o.filter(m=>Mu(m.name));if(u.length===1){let m=this.program.getSourceFile(t.fileName),d=this.projectService.host.createHash?this.projectService.host.createHash(u[0].text):nI(u[0].text);lg.updateSignatureOfFile(this.builderState,d,m.resolvedPath)}}}return{emitSkipped:i,diagnostics:s}}enableLanguageService(){this.languageServiceEnabled||this.projectService.serverMode===2||(this.languageServiceEnabled=!0,this.lastFileExceededProgramSize=void 0,this.projectService.onUpdateLanguageServiceStateForProject(this,!0))}cleanupProgram(){if(this.program){for(let t of this.program.getSourceFiles())this.detachScriptInfoIfNotRoot(t.fileName);this.program.forEachResolvedProjectReference(t=>this.detachScriptInfoFromProject(t.sourceFile.fileName)),this.program=void 0}}disableLanguageService(t){this.languageServiceEnabled&&(M.assert(this.projectService.serverMode!==2),this.languageService.cleanupSemanticCache(),this.languageServiceEnabled=!1,this.cleanupProgram(),this.lastFileExceededProgramSize=t,this.builderState=void 0,this.autoImportProviderHost&&this.autoImportProviderHost.close(),this.autoImportProviderHost=void 0,this.resolutionCache.closeTypeRootsWatch(),this.clearGeneratedFileWatch(),this.projectService.verifyDocumentRegistry(),this.projectService.onUpdateLanguageServiceStateForProject(this,!1))}getProjectName(){return this.projectName}removeLocalTypingsFromTypeAcquisition(t){return!t||!t.include?t:{...t,include:this.removeExistingTypings(t.include)}}getExternalFiles(t){return pa(va(this.plugins,n=>{if(typeof n.module.getExternalFiles=="function")try{return n.module.getExternalFiles(this,t||0)}catch(i){this.projectService.logger.info(`A plugin threw an exception in getExternalFiles: ${i}`),i.stack&&this.projectService.logger.info(i.stack)}}))}getSourceFile(t){if(this.program)return this.program.getSourceFileByPath(t)}getSourceFileOrConfigFile(t){let n=this.program.getCompilerOptions();return t===n.configFilePath?n.configFile:this.getSourceFile(t)}close(){var t;this.projectService.typingsCache.onProjectClosed(this),this.closeWatchingTypingLocations(),this.cleanupProgram(),kt(this.externalFiles,n=>this.detachScriptInfoIfNotRoot(n)),this.rootFilesMap.forEach(n=>{var i;return(i=n.info)==null?void 0:i.detachFromProject(this)}),this.projectService.pendingEnsureProjectForOpenFiles=!0,this.rootFilesMap=void 0,this.externalFiles=void 0,this.program=void 0,this.builderState=void 0,this.resolutionCache.clear(),this.resolutionCache=void 0,this.cachedUnresolvedImportsPerFile=void 0,(t=this.packageJsonWatches)==null||t.forEach(n=>{n.projects.delete(this),n.close()}),this.packageJsonWatches=void 0,this.moduleSpecifierCache.clear(),this.moduleSpecifierCache=void 0,this.directoryStructureHost=void 0,this.exportMapCache=void 0,this.projectErrors=void 0,this.plugins.length=0,this.missingFilesMap&&(Vf(this.missingFilesMap,Dm),this.missingFilesMap=void 0),this.clearGeneratedFileWatch(),this.clearInvalidateResolutionOfFailedLookupTimer(),this.autoImportProviderHost&&this.autoImportProviderHost.close(),this.autoImportProviderHost=void 0,this.noDtsResolutionProject&&this.noDtsResolutionProject.close(),this.noDtsResolutionProject=void 0,this.languageService.dispose(),this.languageService=void 0}detachScriptInfoIfNotRoot(t){let n=this.projectService.getScriptInfo(t);n&&!this.isRoot(n)&&n.detachFromProject(this)}isClosed(){return this.rootFilesMap===void 0}hasRoots(){var t;return!!((t=this.rootFilesMap)!=null&&t.size)}isOrphan(){return!1}getRootFiles(){return this.rootFilesMap&&Is(Up(this.rootFilesMap.values(),t=>{var n;return(n=t.info)==null?void 0:n.fileName}))}getRootFilesMap(){return this.rootFilesMap}getRootScriptInfos(){return Is(Up(this.rootFilesMap.values(),t=>t.info))}getScriptInfos(){return this.languageServiceEnabled?Cr(this.program.getSourceFiles(),t=>{let n=this.projectService.getScriptInfoForPath(t.resolvedPath);return M.assert(!!n,"getScriptInfo",()=>`scriptInfo for a file '${t.fileName}' Path: '${t.path}' / '${t.resolvedPath}' is missing.`),n}):this.getRootScriptInfos()}getExcludedFiles(){return su}getFileNames(t,n){if(!this.program)return[];if(!this.languageServiceEnabled){let s=this.getRootFiles();if(this.compilerOptions){let o=J1e(this.compilerOptions);o&&(s||(s=[])).push(o)}return s}let i=[];for(let s of this.program.getSourceFiles())t&&this.program.isSourceFileFromExternalLibrary(s)||i.push(s.fileName);if(!n){let s=this.program.getCompilerOptions().configFile;if(s&&(i.push(s.fileName),s.extendedSourceFiles))for(let o of s.extendedSourceFiles)i.push(o)}return i}getFileNamesWithRedirectInfo(t){return this.getFileNames().map(n=>({fileName:n,isSourceOfProjectReferenceRedirect:t&&this.isSourceOfProjectReferenceRedirect(n)}))}hasConfigFile(t){if(this.program&&this.languageServiceEnabled){let n=this.program.getCompilerOptions().configFile;if(n){if(t===n.fileName)return!0;if(n.extendedSourceFiles){for(let i of n.extendedSourceFiles)if(t===i)return!0}}}return!1}containsScriptInfo(t){if(this.isRoot(t))return!0;if(!this.program)return!1;let n=this.program.getSourceFileByPath(t.path);return!!n&&n.resolvedPath===t.path}containsFile(t,n){let i=this.projectService.getScriptInfoForNormalizedPath(t);return i&&(i.isScriptOpen()||!n)?this.containsScriptInfo(i):!1}isRoot(t){var n,i;return((i=(n=this.rootFilesMap)==null?void 0:n.get(t.path))==null?void 0:i.info)===t}addRoot(t,n){M.assert(!this.isRoot(t)),this.rootFilesMap.set(t.path,{fileName:n||t.fileName,info:t}),t.attachToProject(this),this.markAsDirty()}addMissingFileRoot(t){let n=this.projectService.toPath(t);this.rootFilesMap.set(n,{fileName:t}),this.markAsDirty()}removeFile(t,n,i){this.isRoot(t)&&this.removeRoot(t),n?this.resolutionCache.removeResolutionsOfFile(t.path):this.resolutionCache.invalidateResolutionOfFile(t.path),this.cachedUnresolvedImportsPerFile.delete(t.path),i&&t.detachFromProject(this),this.markAsDirty()}registerFileUpdate(t){(this.updatedFileNames||(this.updatedFileNames=new Set)).add(t)}markFileAsDirty(t){this.markAsDirty(),this.exportMapCache&&!this.exportMapCache.isEmpty()&&(this.changedFilesForExportMapCache||(this.changedFilesForExportMapCache=new Set)).add(t)}markAsDirty(){this.dirty||(this.projectStateVersion++,this.dirty=!0)}markAutoImportProviderAsDirty(){var t;this.autoImportProviderHost||(this.autoImportProviderHost=void 0),(t=this.autoImportProviderHost)==null||t.markAsDirty()}onAutoImportProviderSettingsChanged(){var t;this.autoImportProviderHost===!1?this.autoImportProviderHost=void 0:(t=this.autoImportProviderHost)==null||t.markAsDirty()}onPackageJsonChange(){this.moduleSpecifierCache.clear(),this.autoImportProviderHost&&this.autoImportProviderHost.markAsDirty()}onFileAddedOrRemoved(t){this.hasAddedorRemovedFiles=!0,t&&(this.hasAddedOrRemovedSymlinks=!0)}onDiscoveredSymlink(){this.hasAddedOrRemovedSymlinks=!0}updateFromProject(){Dd(this)}updateGraph(){var t,n,i,s;(t=Cn)==null||t.push(Cn.Phase.Session,"updateGraph",{name:this.projectName,kind:a7[this.projectKind]}),(n=rf)==null||n.logStartUpdateGraph(),this.resolutionCache.startRecordingFilesWithChangedResolutions();let o=this.updateGraphWorker(),u=this.hasAddedorRemovedFiles;this.hasAddedorRemovedFiles=!1,this.hasAddedOrRemovedSymlinks=!1;let m=this.resolutionCache.finishRecordingFilesWithChangedResolutions()||su;for(let S of m)this.cachedUnresolvedImportsPerFile.delete(S);this.languageServiceEnabled&&this.projectService.serverMode===0&&!this.isOrphan()?((o||m.length)&&(this.lastCachedUnresolvedImportsList=ARt(this.program,this.cachedUnresolvedImportsPerFile)),this.projectService.typingsCache.enqueueInstallTypingsForProject(this,this.lastCachedUnresolvedImportsList,u)):this.lastCachedUnresolvedImportsList=void 0;let d=this.projectProgramVersion===0&&o;return o&&this.projectProgramVersion++,u&&this.markAutoImportProviderAsDirty(),d&&this.getPackageJsonAutoImportProvider(),(i=rf)==null||i.logStopUpdateGraph(),(s=Cn)==null||s.pop(),!o}updateTypingFiles(t){i5(t,this.typingFiles,CP(!this.useCaseSensitiveFileNames()),io,n=>this.detachScriptInfoFromProject(n))&&(this.typingFiles=t,this.resolutionCache.setFilesWithInvalidatedNonRelativeUnresolvedImports(this.cachedUnresolvedImportsPerFile),this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this))}closeWatchingTypingLocations(){this.typingWatchers&&Vf(this.typingWatchers,Dm),this.typingWatchers=void 0}onTypingInstallerWatchInvoke(){this.typingWatchers.isInvoked=!0,this.projectService.updateTypingsForProject({projectName:this.getProjectName(),kind:gU})}watchTypingLocations(t){if(!t){this.typingWatchers.isInvoked=!1;return}if(!t.length){this.closeWatchingTypingLocations();return}let n=new Map(this.typingWatchers);this.typingWatchers||(this.typingWatchers=new Map),this.typingWatchers.isInvoked=!1;let i=(s,o)=>{let u=this.toPath(s);n.delete(u),this.typingWatchers.has(u)||this.typingWatchers.set(u,o==="FileWatcher"?this.projectService.watchFactory.watchFile(s,()=>this.typingWatchers.isInvoked?this.writeLog("TypingWatchers already invoked"):this.onTypingInstallerWatchInvoke(),2e3,this.projectService.getWatchOptions(this),Tu.TypingInstallerLocationFile,this):this.projectService.watchFactory.watchDirectory(s,m=>{if(this.typingWatchers.isInvoked)return this.writeLog("TypingWatchers already invoked");if(!Ic(m,".json"))return this.writeLog("Ignoring files that are not *.json");if(_0(m,ri(this.projectService.typingsInstaller.globalTypingsCacheLocation,"package.json"),!this.useCaseSensitiveFileNames()))return this.writeLog("Ignoring package.json change at global typings location");this.onTypingInstallerWatchInvoke()},1,this.projectService.getWatchOptions(this),Tu.TypingInstallerLocationDirectory,this))};for(let s of t){let o=Ul(s);if(o==="package.json"||o==="bower.json"){i(s,"FileWatcher");continue}if(Cm(this.currentDirectory,s,this.currentDirectory,!this.useCaseSensitiveFileNames())){let u=s.indexOf(Ec,this.currentDirectory.length+1);i(u!==-1?s.substr(0,u):s,"DirectoryWatcher");continue}if(Cm(this.projectService.typingsInstaller.globalTypingsCacheLocation,s,this.currentDirectory,!this.useCaseSensitiveFileNames())){i(this.projectService.typingsInstaller.globalTypingsCacheLocation,"DirectoryWatcher");continue}i(s,"DirectoryWatcher")}n.forEach((s,o)=>{s.close(),this.typingWatchers.delete(o)})}getCurrentProgram(){return this.program}removeExistingTypings(t){let n=gB(this.getCompilerOptions(),this.directoryStructureHost);return t.filter(i=>!n.includes(i))}updateGraphWorker(){var t,n;let i=this.languageService.getCurrentProgram();M.assert(i===this.program),M.assert(!this.isClosed(),"Called update graph worker of closed project"),this.writeLog(`Starting updateGraphWorker: Project: ${this.getProjectName()}`);let s=Tc(),{hasInvalidatedResolutions:o,hasInvalidatedLibResolutions:u}=this.resolutionCache.createHasInvalidatedResolutions(Dg,Dg);this.hasInvalidatedResolutions=o,this.hasInvalidatedLibResolutions=u,this.resolutionCache.startCachingPerDirectoryResolution(),this.dirty=!1,this.updateFromProjectInProgress=!0,this.program=this.languageService.getProgram(),this.updateFromProjectInProgress=!1,(t=Cn)==null||t.push(Cn.Phase.Session,"finishCachingPerDirectoryResolution"),this.resolutionCache.finishCachingPerDirectoryResolution(this.program,i),(n=Cn)==null||n.pop(),M.assert(i===void 0||this.program!==void 0);let m=!1;if(this.program&&(!i||this.program!==i&&this.program.structureIsReused!==2)){if(m=!0,i){for(let E of i.getSourceFiles()){let x=this.program.getSourceFileByPath(E.resolvedPath);(!x||E.resolvedPath===E.path&&x.resolvedPath!==E.path)&&this.detachScriptInfoFromProject(E.fileName,!!this.program.getSourceFileByPath(E.path),!0)}i.forEachResolvedProjectReference(E=>{this.program.getResolvedProjectReferenceByPath(E.sourceFile.path)||this.detachScriptInfoFromProject(E.sourceFile.fileName,void 0,!0)})}if(this.rootFilesMap.forEach((E,x)=>{var D;let w=this.program.getSourceFileByPath(x),R=E.info;!w||((D=E.info)==null?void 0:D.path)===w.resolvedPath||(E.info=this.projectService.getScriptInfo(w.fileName),M.assert(E.info.isAttached(this)),R?.detachFromProject(this))}),WK(this.program,this.missingFilesMap||(this.missingFilesMap=new Map),(E,x)=>this.addMissingFileWatcher(E,x)),this.generatedFilesMap){let E=this.compilerOptions.outFile;iEe(this.generatedFilesMap)?(!E||!this.isValidGeneratedFileWatcher(of(E)+".d.ts",this.generatedFilesMap))&&this.clearGeneratedFileWatch():E?this.clearGeneratedFileWatch():this.generatedFilesMap.forEach((x,D)=>{let w=this.program.getSourceFileByPath(D);(!w||w.resolvedPath!==D||!this.isValidGeneratedFileWatcher(C9(w.fileName,this.compilerOptions,this.program),x))&&(Nd(x),this.generatedFilesMap.delete(D))})}this.languageServiceEnabled&&this.projectService.serverMode===0&&this.resolutionCache.updateTypeRootsWatch()}this.projectService.verifyProgram(this),this.exportMapCache&&!this.exportMapCache.isEmpty()&&(this.exportMapCache.releaseSymbols(),this.hasAddedorRemovedFiles||i&&!this.program.structureIsReused?this.exportMapCache.clear():this.changedFilesForExportMapCache&&i&&this.program&&d0(this.changedFilesForExportMapCache,E=>{let x=i.getSourceFileByPath(E),D=this.program.getSourceFileByPath(E);return!x||!D?(this.exportMapCache.clear(),!0):this.exportMapCache.onFileChanged(x,D,!!this.getTypeAcquisition().enable)})),this.changedFilesForExportMapCache&&this.changedFilesForExportMapCache.clear(),(this.hasAddedOrRemovedSymlinks||this.program&&!this.program.structureIsReused&&this.getCompilerOptions().preserveSymlinks)&&(this.symlinks=void 0,this.moduleSpecifierCache.clear());let d=this.externalFiles||su;this.externalFiles=this.getExternalFiles(),i5(this.externalFiles,d,CP(!this.useCaseSensitiveFileNames()),E=>{let x=this.projectService.getOrCreateScriptInfoNotOpenedByClient(E,this.currentDirectory,this.directoryStructureHost,!1);x?.attachToProject(this)},E=>this.detachScriptInfoFromProject(E));let S=Tc()-s;return this.sendPerformanceEvent("UpdateGraph",S),this.writeLog(`Finishing updateGraphWorker: Project: ${this.getProjectName()} projectStateVersion: ${this.projectStateVersion} projectProgramVersion: ${this.projectProgramVersion} structureChanged: ${m}${this.program?` structureIsReused:: ${QW[this.program.structureIsReused]}`:""} Elapsed: ${S}ms`),this.projectService.logger.isTestLogger?this.program!==i?this.print(!0,this.hasAddedorRemovedFiles,!0):this.writeLog("Same program as before"):this.hasAddedorRemovedFiles?this.print(!0,!0,!1):this.program!==i&&this.writeLog("Different program with same set of files"),this.projectService.verifyDocumentRegistry(),m}sendPerformanceEvent(t,n){this.projectService.sendPerformanceEvent(t,n)}detachScriptInfoFromProject(t,n,i){let s=this.projectService.getScriptInfo(t);s&&(s.detachFromProject(this),n||this.resolutionCache.removeResolutionsOfFile(s.path,i))}addMissingFileWatcher(t,n){var i;if(Wv(this)){let o=this.projectService.configFileExistenceInfoCache.get(t);if((i=o?.config)!=null&&i.projects.has(this.canonicalConfigFilePath))return l6}let s=this.projectService.watchFactory.watchFile(xs(n,this.currentDirectory),(o,u)=>{Wv(this)&&this.getCachedDirectoryStructureHost().addOrDeleteFile(o,t,u),u===0&&this.missingFilesMap.has(t)&&(this.missingFilesMap.delete(t),s.close(),this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this))},500,this.projectService.getWatchOptions(this),Tu.MissingFile,this);return s}isWatchedMissingFile(t){return!!this.missingFilesMap&&this.missingFilesMap.has(t)}addGeneratedFileWatch(t,n){if(this.compilerOptions.outFile)this.generatedFilesMap||(this.generatedFilesMap=this.createGeneratedFileWatcher(t));else{let i=this.toPath(n);if(this.generatedFilesMap){if(iEe(this.generatedFilesMap)){M.fail(`${this.projectName} Expected to not have --out watcher for generated file with options: ${JSON.stringify(this.compilerOptions)}`);return}if(this.generatedFilesMap.has(i))return}else this.generatedFilesMap=new Map;this.generatedFilesMap.set(i,this.createGeneratedFileWatcher(t))}}createGeneratedFileWatcher(t){return{generatedFilePath:this.toPath(t),watcher:this.projectService.watchFactory.watchFile(t,()=>{this.clearSourceMapperCache(),this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this)},2e3,this.projectService.getWatchOptions(this),Tu.MissingGeneratedFile,this)}}isValidGeneratedFileWatcher(t,n){return this.toPath(t)===n.generatedFilePath}clearGeneratedFileWatch(){this.generatedFilesMap&&(iEe(this.generatedFilesMap)?Nd(this.generatedFilesMap):Vf(this.generatedFilesMap,Nd),this.generatedFilesMap=void 0)}getScriptInfoForNormalizedPath(t){let n=this.projectService.getScriptInfoForPath(this.toPath(t));return n&&!n.isAttached(this)?I0.ThrowProjectDoesNotContainDocument(t,this):n}getScriptInfo(t){return this.projectService.getScriptInfo(t)}filesToString(t){return this.filesToStringWorker(t,!0,!1)}filesToStringWorker(t,n,i){if(this.isInitialLoadPending())return`	Files (0) InitialLoadPending
`;if(!this.program)return`	Files (0) NoProgram
`;let s=this.program.getSourceFiles(),o=`	Files (${s.length})
`;if(t){for(let u of s)o+=`	${u.fileName}${i?` ${u.version} ${JSON.stringify(u.text)}`:""}
`;n&&(o+=`

`,CX(this.program,u=>o+=`	${u}
`))}return o}print(t,n,i){var s;this.writeLog(`Project '${this.projectName}' (${a7[this.projectKind]})`),this.writeLog(this.filesToStringWorker(t&&this.projectService.logger.hasLevel(3),n&&this.projectService.logger.hasLevel(3),i&&this.projectService.logger.hasLevel(3))),this.writeLog("-----------------------------------------------"),this.autoImportProviderHost&&this.autoImportProviderHost.print(!1,!1,!1),(s=this.noDtsResolutionProject)==null||s.print(!1,!1,!1)}setCompilerOptions(t){var n;if(t){t.allowNonTsExtensions=!0;let i=this.compilerOptions;this.compilerOptions=t,this.setInternalCompilerOptionsForEmittingJsFiles(),(n=this.noDtsResolutionProject)==null||n.setCompilerOptions(this.getCompilerOptionsForNoDtsResolutionProject()),U5(i,t)&&(this.cachedUnresolvedImportsPerFile.clear(),this.lastCachedUnresolvedImportsList=void 0,this.resolutionCache.onChangesAffectModuleResolution(),this.moduleSpecifierCache.clear()),this.markAsDirty()}}setWatchOptions(t){this.watchOptions=t}getWatchOptions(){return this.watchOptions}setTypeAcquisition(t){t&&(this.typeAcquisition=this.removeLocalTypingsFromTypeAcquisition(t))}getTypeAcquisition(){return this.typeAcquisition||{}}getChangesSinceVersion(t,n){var i,s;let o=n?d=>Is(d.entries(),([S,E])=>({fileName:S,isSourceOfProjectReferenceRedirect:E})):d=>Is(d.keys());this.isInitialLoadPending()||Dd(this);let u={projectName:this.getProjectName(),version:this.projectProgramVersion,isInferred:uD(this),options:this.getCompilationSettings(),languageServiceDisabled:!this.languageServiceEnabled,lastFileExceededProgramSize:this.lastFileExceededProgramSize},m=this.updatedFileNames;if(this.updatedFileNames=void 0,this.lastReportedFileNames&&t===this.lastReportedVersion){if(this.projectProgramVersion===this.lastReportedVersion&&!m)return{info:u,projectErrors:this.getGlobalProjectErrors()};let d=this.lastReportedFileNames,S=((i=this.externalFiles)==null?void 0:i.map(L=>({fileName:Dc(L),isSourceOfProjectReferenceRedirect:!1})))||su,E=xP(this.getFileNamesWithRedirectInfo(!!n).concat(S),L=>L.fileName,L=>L.isSourceOfProjectReferenceRedirect),x=new Map,D=new Map,w=m?Is(m.keys()):[],R=[];return Nu(E,(L,F)=>{d.has(F)?n&&L!==d.get(F)&&R.push({fileName:F,isSourceOfProjectReferenceRedirect:L}):x.set(F,L)}),Nu(d,(L,F)=>{E.has(F)||D.set(F,L)}),this.lastReportedFileNames=E,this.lastReportedVersion=this.projectProgramVersion,{info:u,changes:{added:o(x),removed:o(D),updated:n?w.map(L=>({fileName:L,isSourceOfProjectReferenceRedirect:this.isSourceOfProjectReferenceRedirect(L)})):w,updatedRedirects:n?R:void 0},projectErrors:this.getGlobalProjectErrors()}}else{let d=this.getFileNamesWithRedirectInfo(!!n),S=((s=this.externalFiles)==null?void 0:s.map(x=>({fileName:Dc(x),isSourceOfProjectReferenceRedirect:!1})))||su,E=d.concat(S);return this.lastReportedFileNames=xP(E,x=>x.fileName,x=>x.isSourceOfProjectReferenceRedirect),this.lastReportedVersion=this.projectProgramVersion,{info:u,files:n?E:E.map(x=>x.fileName),projectErrors:this.getGlobalProjectErrors()}}}removeRoot(t){this.rootFilesMap.delete(t.path)}isSourceOfProjectReferenceRedirect(t){return!!this.program&&this.program.isSourceOfProjectReferenceRedirect(t)}getGlobalPluginSearchPaths(){return[...this.projectService.pluginProbeLocations,ri(this.projectService.getExecutingFilePath(),"../../..")]}enableGlobalPlugins(t){if(!this.projectService.globalPlugins.length)return;let n=this.projectService.host;if(!n.require&&!n.importPlugin){this.projectService.logger.info("Plugins were requested but not running in environment that supports 'require'. Nothing will be loaded");return}let i=this.getGlobalPluginSearchPaths();for(let s of this.projectService.globalPlugins)s&&(t.plugins&&t.plugins.some(o=>o.name===s)||(this.projectService.logger.info(`Loading global plugin ${s}`),this.enablePlugin({name:s,global:!0},i)))}enablePlugin(t,n){this.projectService.requestEnablePlugin(this,t,n)}enableProxy(t,n){try{if(typeof t!="function"){this.projectService.logger.info(`Skipped loading plugin ${n.name} because it did not expose a proper factory function`);return}let i={config:n,project:this,languageService:this.languageService,languageServiceHost:this,serverHost:this.projectService.host,session:this.projectService.session},s=t({typescript:Yqe}),o=s.create(i);for(let u of Object.keys(this.languageService))u in o||(this.projectService.logger.info(`Plugin activation warning: Missing proxied method ${u} in created LS. Patching.`),o[u]=this.languageService[u]);this.projectService.logger.info("Plugin validation succeeded"),this.languageService=o,this.plugins.push({name:n.name,module:s})}catch(i){this.projectService.logger.info(`Plugin activation failed: ${i}`)}}onPluginConfigurationChanged(t,n){this.plugins.filter(i=>i.name===t).forEach(i=>{i.module.onConfigurationChanged&&i.module.onConfigurationChanged(n)})}refreshDiagnostics(){this.projectService.sendProjectsUpdatedInBackgroundEvent()}getPackageJsonsVisibleToFile(t,n){return this.projectService.serverMode!==0?su:this.projectService.getPackageJsonsVisibleToFile(t,this,n)}getNearestAncestorDirectoryWithPackageJson(t){return this.projectService.getNearestAncestorDirectoryWithPackageJson(t)}getPackageJsonsForAutoImport(t){return this.getPackageJsonsVisibleToFile(ri(this.currentDirectory,o6),t)}getPackageJsonCache(){return this.projectService.packageJsonCache}getCachedExportInfoMap(){return this.exportMapCache||(this.exportMapCache=sZ(this))}clearCachedExportInfoMap(){var t;(t=this.exportMapCache)==null||t.clear()}getModuleSpecifierCache(){return this.moduleSpecifierCache}includePackageJsonAutoImports(){return this.projectService.includePackageJsonAutoImports()===0||!this.languageServiceEnabled||CM(this.currentDirectory)||!this.isDefaultProjectForOpenFiles()?0:this.projectService.includePackageJsonAutoImports()}getHostForAutoImportProvider(){var t,n;return this.program?{fileExists:this.program.fileExists,directoryExists:this.program.directoryExists,realpath:this.program.realpath||((t=this.projectService.host.realpath)==null?void 0:t.bind(this.projectService.host)),getCurrentDirectory:this.getCurrentDirectory.bind(this),readFile:this.projectService.host.readFile.bind(this.projectService.host),getDirectories:this.projectService.host.getDirectories.bind(this.projectService.host),trace:(n=this.projectService.host.trace)==null?void 0:n.bind(this.projectService.host),useCaseSensitiveFileNames:this.program.useCaseSensitiveFileNames(),readDirectory:this.projectService.host.readDirectory.bind(this.projectService.host)}:this.projectService.host}getPackageJsonAutoImportProvider(){var t,n,i;if(this.autoImportProviderHost===!1)return;if(this.projectService.serverMode!==0){this.autoImportProviderHost=!1;return}if(this.autoImportProviderHost){if(Dd(this.autoImportProviderHost),this.autoImportProviderHost.isEmpty()){this.autoImportProviderHost.close(),this.autoImportProviderHost=void 0;return}return this.autoImportProviderHost.getCurrentProgram()}let s=this.includePackageJsonAutoImports();if(s){(t=Cn)==null||t.push(Cn.Phase.Session,"getPackageJsonAutoImportProvider");let o=Tc();if(this.autoImportProviderHost=cEe.create(s,this,this.getHostForAutoImportProvider(),this.documentRegistry),this.autoImportProviderHost)return Dd(this.autoImportProviderHost),this.sendPerformanceEvent("CreatePackageJsonAutoImportProvider",Tc()-o),(n=Cn)==null||n.pop(),this.autoImportProviderHost.getCurrentProgram();(i=Cn)==null||i.pop()}}isDefaultProjectForOpenFiles(){return!!Nu(this.projectService.openFiles,(t,n)=>this.projectService.tryGetDefaultProjectForFile(this.projectService.getScriptInfoForPath(n))===this)}watchNodeModulesForPackageJsonChanges(t){return this.projectService.watchPackageJsonsInNodeModules(t,this)}getIncompleteCompletionsCache(){return this.projectService.getIncompleteCompletionsCache()}getNoDtsResolutionProject(t){return M.assert(this.projectService.serverMode===0),this.noDtsResolutionProject||(this.noDtsResolutionProject=new aEe(this.projectService,this.documentRegistry,this.getCompilerOptionsForNoDtsResolutionProject(),this.currentDirectory)),this.noDtsResolutionProject.rootFile!==t&&(this.projectService.setFileNamesOfAutpImportProviderOrAuxillaryProject(this.noDtsResolutionProject,[t]),this.noDtsResolutionProject.rootFile=t),this.noDtsResolutionProject}runWithTemporaryFileUpdate(t,n,i){var s,o,u,m;let d=this.program,S=M.checkDefined((s=this.program)==null?void 0:s.getSourceFile(t),"Expected file to be part of program"),E=M.checkDefined(S.getText());(o=this.getScriptInfo(t))==null||o.editContent(0,E.length,n),this.updateGraph();try{i(this.program,d,(u=this.program)==null?void 0:u.getSourceFile(t))}finally{(m=this.getScriptInfo(t))==null||m.editContent(0,this.program.getSourceFile(t).getText().length,E)}}getCompilerOptionsForNoDtsResolutionProject(){return{...this.getCompilerOptions(),noDtsResolution:!0,allowJs:!0,maxNodeModuleJsDepth:3,diagnostics:!1,skipLibCheck:!0,sourceMap:!1,types:ve,lib:ve,noLib:!0}}};function ARt(e,t){var n,i;let s=e.getSourceFiles();(n=Cn)==null||n.push(Cn.Phase.Session,"getUnresolvedImports",{count:s.length});let o=e.getTypeChecker().getAmbientModules().map(m=>Zd(m.getName())),u=jC(va(s,m=>kRt(e,m,o,t)));return(i=Cn)==null||i.pop(),u}function kRt(e,t,n,i){return dv(i,t.path,()=>{let s;return e.forEachResolvedModule(({resolvedModule:o},u)=>{(!o||!oO(o.extension))&&!vu(u)&&!n.some(m=>m===u)&&(s=Bt(s,bB(u).packageName))},t),s||su})}var sEe=class extends vk{constructor(e,t,n,i,s,o,u){super(e.newInferredProjectName(),0,e,t,void 0,void 0,n,!1,i,e.host,o),this._isJsInferredProject=!1,this.typeAcquisition=u,this.projectRootPath=s&&e.toCanonicalFileName(s),!s&&!e.useSingleInferredProject&&(this.canonicalCurrentDirectory=e.toCanonicalFileName(this.currentDirectory)),this.enableGlobalPlugins(this.getCompilerOptions())}toggleJsInferredProject(e){e!==this._isJsInferredProject&&(this._isJsInferredProject=e,this.setCompilerOptions())}setCompilerOptions(e){if(!e&&!this.getCompilationSettings())return;let t=SQ(e||this.getCompilationSettings());this._isJsInferredProject&&typeof t.maxNodeModuleJsDepth!="number"?t.maxNodeModuleJsDepth=2:this._isJsInferredProject||(t.maxNodeModuleJsDepth=void 0),t.allowJs=!0,super.setCompilerOptions(t)}addRoot(e){M.assert(e.isScriptOpen()),this.projectService.startWatchingConfigFilesForInferredProjectRoot(e),!this._isJsInferredProject&&e.isJavaScript()?this.toggleJsInferredProject(!0):this.isOrphan()&&this._isJsInferredProject&&!e.isJavaScript()&&this.toggleJsInferredProject(!1),super.addRoot(e)}removeRoot(e){this.projectService.stopWatchingConfigFilesForScriptInfo(e),super.removeRoot(e),!this.isOrphan()&&this._isJsInferredProject&&e.isJavaScript()&&wi(this.getRootScriptInfos(),t=>!t.isJavaScript())&&this.toggleJsInferredProject(!1)}isOrphan(){return!this.hasRoots()}isProjectWithSingleRoot(){return!this.projectRootPath&&!this.projectService.useSingleInferredProject||this.getRootScriptInfos().length===1}close(){kt(this.getRootScriptInfos(),e=>this.projectService.stopWatchingConfigFilesForScriptInfo(e)),super.close()}getTypeAcquisition(){return this.typeAcquisition||{enable:tEe(this),include:ve,exclude:ve}}},aEe=class extends vk{constructor(e,t,n,i){super(e.newAuxiliaryProjectName(),4,e,t,!1,void 0,n,!1,void 0,e.host,i)}isOrphan(){return!0}scheduleInvalidateResolutionsOfFailedLookupLocations(){}},oEe=class IDe extends vk{constructor(t,n,i,s){super(t.projectService.newAutoImportProviderProjectName(),3,t.projectService,i,!1,void 0,s,!1,t.getWatchOptions(),t.projectService.host,t.currentDirectory),this.hostProject=t,this.rootFileNames=n,this.useSourceOfProjectReferenceRedirect=ia(this.hostProject,this.hostProject.useSourceOfProjectReferenceRedirect),this.getParsedCommandLine=ia(this.hostProject,this.hostProject.getParsedCommandLine)}static getRootFileNames(t,n,i,s){var o,u;if(!t)return ve;let m=n.getCurrentProgram();if(!m)return ve;let d=Tc(),S,E,x=ri(n.currentDirectory,o6),D=n.getPackageJsonsForAutoImport(ri(n.currentDirectory,x));for(let ee of D)(o=ee.dependencies)==null||o.forEach((W,pe)=>J(pe)),(u=ee.peerDependencies)==null||u.forEach((W,pe)=>J(pe));let w=0;if(S){let ee=n.getSymlinkCache();for(let W of Is(S.keys())){if(t===2&&w>this.maxDependencies)return n.log(`AutoImportProviderProject: attempted to add more than ${this.maxDependencies} dependencies. Aborting.`),ve;let pe=ZY(W,n.currentDirectory,s,i,m.getModuleResolutionCache());if(pe){let re=G(pe,m,ee);if(re){w+=F(re);continue}}if(!kt([n.currentDirectory,n.getGlobalTypingsCacheLocation()],re=>{if(re){let ue=ZY(`@types/${W}`,re,s,i,m.getModuleResolutionCache());if(ue){let ce=G(ue,m,ee);return w+=F(ce),!0}}})&&pe&&s.allowJs&&s.maxNodeModuleJsDepth){let re=G(pe,m,ee,!0);w+=F(re)}}}let R=m.getResolvedProjectReferences(),L=0;return R?.length&&n.projectService.getHostPreferences().includeCompletionsForModuleExports&&R.forEach(ee=>{if(ee?.commandLine.options.outFile)L+=F(q([Y1(ee.commandLine.options.outFile,".d.ts")]));else if(ee){let W=tf(()=>tk(ee.commandLine,!n.useCaseSensitiveFileNames()));L+=F(q(Gi(ee.commandLine.fileNames,pe=>!Mu(pe)&&!Ic(pe,".json")&&!m.getSourceFile(pe)?jN(pe,ee.commandLine,!n.useCaseSensitiveFileNames(),W):void 0)))}}),E?.size&&n.log(`AutoImportProviderProject: found ${E.size} root files in ${w} dependencies ${L} referenced projects in ${Tc()-d} ms`),E?Is(E.values()):ve;function F(ee){return ee?.length?(E??(E=new Set),ee.forEach(W=>E.add(W)),1):0}function J(ee){_s(ee,"@types/")||(S||(S=new Set)).add(ee)}function G(ee,W,pe,K){var re;let ue=aK(ee,s,i,W.getModuleResolutionCache(),K);if(ue){let ce=(re=i.realpath)==null?void 0:re.call(i,ee.packageDirectory),ne=ce?n.toPath(ce):void 0,le=ne&&ne!==n.toPath(ee.packageDirectory);return le&&pe.setSymlinkedDirectory(ee.packageDirectory,{real:yu(ce),realPath:yu(ne)}),q(ue,le?me=>me.replace(ee.packageDirectory,ce):void 0)}}function q(ee,W){return Gi(ee,pe=>{let K=W?W(pe):pe;if(!m.getSourceFile(K)&&!(W&&m.getSourceFile(pe)))return K})}}static create(t,n,i,s){if(t===0)return;let o={...n.getCompilerOptions(),...this.compilerOptionsOverrides},u=this.getRootFileNames(t,n,i,o);if(u.length)return new IDe(n,u,s,o)}isEmpty(){return!Pt(this.rootFileNames)}isOrphan(){return!0}updateGraph(){let t=this.rootFileNames;t||(t=IDe.getRootFileNames(this.hostProject.includePackageJsonAutoImports(),this.hostProject,this.hostProject.getHostForAutoImportProvider(),this.getCompilationSettings())),this.projectService.setFileNamesOfAutpImportProviderOrAuxillaryProject(this,t),this.rootFileNames=t;let n=this.getCurrentProgram(),i=super.updateGraph();return n&&n!==this.getCurrentProgram()&&this.hostProject.clearCachedExportInfoMap(),i}scheduleInvalidateResolutionsOfFailedLookupLocations(){}hasRoots(){var t;return!!((t=this.rootFileNames)!=null&&t.length)}markAsDirty(){this.rootFileNames=void 0,super.markAsDirty()}getScriptFileNames(){return this.rootFileNames||ve}getLanguageService(){throw new Error("AutoImportProviderProject language service should never be used. To get the program, use `project.getCurrentProgram()`.")}onAutoImportProviderSettingsChanged(){throw new Error("AutoImportProviderProject is an auto import provider; use `markAsDirty()` instead.")}onPackageJsonChange(){throw new Error("package.json changes should be notified on an AutoImportProvider's host project")}getHostForAutoImportProvider(){throw new Error("AutoImportProviderProject cannot provide its own host; use `hostProject.getModuleResolutionHostForAutomImportProvider()` instead.")}getProjectReferences(){return this.hostProject.getProjectReferences()}includePackageJsonAutoImports(){return 0}getSymlinkCache(){return this.hostProject.getSymlinkCache()}getModuleResolutionCache(){var t;return(t=this.hostProject.getCurrentProgram())==null?void 0:t.getModuleResolutionCache()}};oEe.maxDependencies=10,oEe.compilerOptionsOverrides={diagnostics:!1,skipLibCheck:!0,sourceMap:!1,types:ve,lib:ve,noLib:!0};var cEe=oEe,lEe=class extends vk{constructor(e,t,n,i,s,o){super(e,1,n,i,!1,void 0,{},!1,void 0,s,mi(e)),this.canonicalConfigFilePath=t,this.openFileWatchTriggered=new Map,this.canConfigFileJsonReportNoInputFiles=!1,this.isInitialLoadPending=YS,this.sendLoadingProjectFinish=!1,this.pendingUpdateLevel=2,this.pendingUpdateReason=o}setCompilerHost(e){this.compilerHost=e}getCompilerHost(){return this.compilerHost}useSourceOfProjectReferenceRedirect(){return this.languageServiceEnabled}getParsedCommandLine(e){let t=Zs(e),n=this.projectService.toCanonicalFileName(t),i=this.projectService.configFileExistenceInfoCache.get(n);return i||this.projectService.configFileExistenceInfoCache.set(n,i={exists:this.projectService.host.fileExists(t)}),this.projectService.ensureParsedConfigUptoDate(t,n,i,this),this.languageServiceEnabled&&this.projectService.serverMode===0&&this.projectService.watchWildcards(t,i,this),i.exists?i.config.parsedCommandLine:void 0}onReleaseParsedCommandLine(e){this.releaseParsedConfig(this.projectService.toCanonicalFileName(Zs(e)))}releaseParsedConfig(e){this.projectService.stopWatchingWildCards(e,this),this.projectService.releaseParsedConfig(e,this)}updateGraph(){if(this.deferredClose)return!1;let e=this.dirty;this.isInitialLoadPending=Dg;let t=this.pendingUpdateLevel;this.pendingUpdateLevel=0;let n;switch(t){case 1:this.openFileWatchTriggered.clear(),n=this.projectService.reloadFileNamesOfConfiguredProject(this);break;case 2:this.openFileWatchTriggered.clear();let i=M.checkDefined(this.pendingUpdateReason);this.projectService.reloadConfiguredProject(this,i),n=!0;break;default:n=super.updateGraph()}return this.compilerHost=void 0,this.projectService.sendProjectLoadingFinishEvent(this),this.projectService.sendProjectTelemetry(this),t===2||n&&(!e||!this.triggerFileForConfigFileDiag||this.getCurrentProgram().structureIsReused===2)?this.triggerFileForConfigFileDiag=void 0:this.triggerFileForConfigFileDiag||this.projectService.sendConfigFileDiagEvent(this,void 0,!1),n}getCachedDirectoryStructureHost(){return this.directoryStructureHost}getConfigFilePath(){return this.getProjectName()}getProjectReferences(){return this.projectReferences}updateReferences(e){this.projectReferences=e,this.potentialProjectReferences=void 0}setPotentialProjectReference(e){M.assert(this.isInitialLoadPending()),(this.potentialProjectReferences||(this.potentialProjectReferences=new Set)).add(e)}getResolvedProjectReferenceToRedirect(e){let t=this.getCurrentProgram();return t&&t.getResolvedProjectReferenceToRedirect(e)}forEachResolvedProjectReference(e){var t;return(t=this.getCurrentProgram())==null?void 0:t.forEachResolvedProjectReference(e)}enablePluginsWithOptions(e){var t;if(this.plugins.length=0,!((t=e.plugins)!=null&&t.length)&&!this.projectService.globalPlugins.length)return;let n=this.projectService.host;if(!n.require&&!n.importPlugin){this.projectService.logger.info("Plugins were requested but not running in environment that supports 'require'. Nothing will be loaded");return}let i=this.getGlobalPluginSearchPaths();if(this.projectService.allowLocalPluginLoads){let s=mi(this.canonicalConfigFilePath);this.projectService.logger.info(`Local plugin loading enabled; adding ${s} to search paths`),i.unshift(s)}if(e.plugins)for(let s of e.plugins)this.enablePlugin(s,i);return this.enableGlobalPlugins(e)}getGlobalProjectErrors(){return Zn(this.projectErrors,e=>!e.file)||su}getAllProjectErrors(){return this.projectErrors||su}setProjectErrors(e){this.projectErrors=e}close(){this.projectService.configFileExistenceInfoCache.forEach((e,t)=>this.releaseParsedConfig(t)),this.projectErrors=void 0,this.openFileWatchTriggered.clear(),this.compilerHost=void 0,super.close()}markAsDirty(){this.deferredClose||super.markAsDirty()}isSolution(){return this.getRootFilesMap().size===0&&!this.canConfigFileJsonReportNoInputFiles}isOrphan(){return!!this.deferredClose}getEffectiveTypeRoots(){return zO(this.getCompilationSettings(),this)||[]}updateErrorOnNoInputFiles(e){fB(e,this.getConfigFilePath(),this.getCompilerOptions().configFile.configFileSpecs,this.projectErrors,this.canConfigFileJsonReportNoInputFiles)}},ote=class extends vk{constructor(e,t,n,i,s,o,u,m){super(e,2,t,n,!0,s,i,o,m,t.host,mi(u||qu(e))),this.externalProjectName=e,this.compileOnSaveEnabled=o,this.excludedFiles=[],this.enableGlobalPlugins(this.getCompilerOptions())}updateGraph(){let e=super.updateGraph();return this.projectService.sendProjectTelemetry(this),e}getExcludedFiles(){return this.excludedFiles}};function uD(e){return e.projectKind===0}function Wv(e){return e.projectKind===1}function c7(e){return e.projectKind===2}function l7(e){return e.projectKind===3||e.projectKind===4}function rJ(e){return Wv(e)&&!!e.deferredClose}var cte=20*1024*1024,lte=4*1024*1024,nJ="projectsUpdatedInBackground",ute="projectLoadingStart",_te="projectLoadingFinish",fte="largeFileReferenced",pte="configFileDiag",dte="projectLanguageServiceState",mte="projectInfo",uEe="openFileInfo",gte="createFileWatcher",hte="createDirectoryWatcher",yte="closeFileWatcher",gze="*ensureProjectForOpenFiles*";function hze(e){let t=new Map;for(let n of e)if(typeof n.type=="object"){let i=n.type;i.forEach(s=>{M.assert(typeof s=="number")}),t.set(n.name,i)}return t}var PRt=hze(og),NRt=hze(YA),DRt=new Map(Object.entries({none:0,block:1,smart:2})),_Ee={jquery:{match:/jquery(-[\d.]+)?(\.intellisense)?(\.min)?\.js$/i,types:["jquery"]},WinJS:{match:/^(.*\/winjs-[.\d]+)\/js\/base\.js$/i,exclude:[["^",1,"/.*"]],types:["winjs"]},Kendo:{match:/^(.*\/kendo(-ui)?)\/kendo\.all(\.min)?\.js$/i,exclude:[["^",1,"/.*"]],types:["kendo-ui"]},"Office Nuget":{match:/^(.*\/office\/1)\/excel-\d+\.debug\.js$/i,exclude:[["^",1,"/.*"]],types:["office"]},References:{match:/^(.*\/_references\.js)$/i,exclude:[["^",1,"$"]]}};function _D(e){return bs(e.indentStyle)&&(e.indentStyle=DRt.get(e.indentStyle.toLowerCase()),M.assert(e.indentStyle!==void 0)),e}function iJ(e){return PRt.forEach((t,n)=>{let i=e[n];bs(i)&&(e[n]=t.get(i.toLowerCase()))}),e}function u7(e,t){let n,i;return YA.forEach(s=>{let o=e[s.name];if(o===void 0)return;let u=NRt.get(s.name);(n||(n={}))[s.name]=u?bs(o)?u.get(o.toLowerCase()):o:g2(s,o,t||"",i||(i=[]))}),n&&{watchOptions:n,errors:i}}function fEe(e){let t;return rB.forEach(n=>{let i=e[n.name];i!==void 0&&((t||(t={}))[n.name]=i)}),t}function vte(e){return bs(e)?Ste(e):e}function Ste(e){switch(e){case"JS":return 1;case"JSX":return 2;case"TS":return 3;case"TSX":return 4;default:return 0}}function pEe(e){let{lazyConfiguredProjectsFromExternalProject:t,...n}=e;return n}var bte={getFileName:e=>e,getScriptKind:(e,t)=>{let n;if(t){let i=PP(e);i&&Pt(t,s=>s.extension===i?(n=s.scriptKind,!0):!1)}return n},hasMixedContent:(e,t)=>Pt(t,n=>n.isMixedContent&&Ic(e,n.extension))},Tte={getFileName:e=>e.fileName,getScriptKind:e=>vte(e.scriptKind),hasMixedContent:e=>!!e.hasMixedContent};function yze(e,t){for(let n of t)if(n.getProjectName()===e)return n}var dEe={close:io};function vze(e,t){if(!(!t||Ete(e)))return t.get(e.path)}function wRt(e){return!!e.containingProjects}function Ete(e){return!!e.configFileInfo}var mEe=(e=>(e[e.Find=0]="Find",e[e.Create=1]="Create",e[e.Reload=2]="Reload",e))(mEe||{});function IRt(e,t,n,i,s,o,u,m){for(;;){if(!t.isInitialLoadPending()&&(!t.getCompilerOptions().composite||t.getCompilerOptions().disableSolutionSearching))return;let d=t.projectService.getConfigFileNameForFile({fileName:t.getConfigFilePath(),path:e.path,configFileInfo:!0},i===0);if(!d)return;let S=t.projectService.findCreateOrReloadConfiguredProject(d,i,s,o,void 0,u,!0,m);if(!S)return;S.project.isInitialLoadPending()&&t.getCompilerOptions().composite&&S.project.setPotentialProjectReference(t.canonicalConfigFilePath);let E=n(S.project);if(E)return E;t=S.project}}function xte(e,t,n,i,s,o,u,m){var d;let S=(d=e.getCurrentProgram())==null?void 0:d.getResolvedProjectReferences();if(!S)return;let E=t?e.getResolvedProjectReferenceToRedirect(t):void 0;if(E){let w=Dc(E.sourceFile.fileName),R=e.projectService.findConfiguredProjectByProjectName(w,o);if(R){let L=D(R);if(L)return L}else if(i!==0){let L=gEe(S,e.getCompilerOptions(),(F,J)=>E===F?x(F,J):void 0,i,e.projectService);if(L)return L}}return gEe(S,e.getCompilerOptions(),(w,R)=>E!==w?x(w,R):void 0,i,e.projectService);function x(w,R){let L=e.projectService.findCreateOrReloadConfiguredProject(Dc(w.sourceFile.fileName),R,s,o,u,m);return L&&(R===i?n(L.project,L.sentConfigFileDiag):D(L.project))}function D(w){let R=!1;switch(i){case 1:R=xze(w,u);break;case 2:R=w.projectService.reloadConfiguredProjectClearingSemanticCache(w,s,m);break;case 0:break;default:M.assertNever(i)}let L=n(w,R);if(L)return L}}function gEe(e,t,n,i,s,o){let u=t.disableReferencedProjectLoad?0:i;return kt(e,m=>{if(!m)return;let d=Dc(m.sourceFile.fileName),S=s.toCanonicalFileName(d),E=o?.get(S);if(E!==void 0&&E>=u)return;let x=n(m,u);return x||((o||(o=new Map)).set(S,u),m.references&&gEe(m.references,m.commandLine.options,n,u,s,o))})}function Sze(e,t){return e.potentialProjectReferences&&d0(e.potentialProjectReferences,t)}function ORt(e,t,n,i){return e.getCurrentProgram()?e.forEachResolvedProjectReference(t):e.isInitialLoadPending()?Sze(e,i):kt(e.getProjectReferences(),n)}function hEe(e,t,n){let i=n&&e.projectService.configuredProjects.get(n);return i&&t(i)}function bze(e,t){return ORt(e,n=>hEe(e,t,n.sourceFile.path),n=>hEe(e,t,e.toPath(VN(n))),n=>hEe(e,t,n))}function RRt(e,t){return`${bs(t)?`Config: ${t} `:t?`Project: ${t.getProjectName()} `:""}WatchType: ${e}`}function Tze(e){return!e.isScriptOpen()&&e.mTime!==void 0}function Dd(e){return e.invalidateResolutionsOfFailedLookupLocations(),e.dirty&&!e.updateGraph()}function Eze(e,t,n){if(!n&&(e.invalidateResolutionsOfFailedLookupLocations(),!e.dirty))return!1;e.triggerFileForConfigFileDiag=t;let i=e.pendingUpdateLevel;if(e.updateGraph(),!e.triggerFileForConfigFileDiag&&!n)return i===2;let s=e.projectService.sendConfigFileDiagEvent(e,t,n);return e.triggerFileForConfigFileDiag=void 0,s}function xze(e,t){if(t){if(Eze(e,t,!1))return!0}else Dd(e);return!1}function Cze(e){return`Creating possible configured project for ${e.fileName} to open`}function Cte(e){return`User requested reload projects: ${e}`}function yEe(e){Wv(e)&&(e.projectOptions=!0)}function vEe(e){let t=1;return()=>e(t++)}function SEe(){return{idToCallbacks:new Map,pathToId:new Map}}function MRt(e,t){if(!t||!e.eventHandler||!e.session)return;let n=SEe(),i=SEe(),s=SEe(),o=1;return e.session.addProtocolHandler("watchChange",w=>(S(w.arguments),{responseRequired:!1})),{watchFile:u,watchDirectory:m,getCurrentDirectory:()=>e.host.getCurrentDirectory(),useCaseSensitiveFileNames:e.host.useCaseSensitiveFileNames};function u(w,R){return d(n,w,R,L=>({eventName:gte,data:{id:L,path:w}}))}function m(w,R,L){return d(L?s:i,w,R,F=>({eventName:hte,data:{id:F,path:w,recursive:!!L,ignoreUpdate:w.endsWith("/node_modules")?void 0:!0}}))}function d({pathToId:w,idToCallbacks:R},L,F,J){let G=e.toPath(L),q=w.get(G);q||w.set(G,q=o++);let ee=R.get(q);return ee||(R.set(q,ee=new Set),e.eventHandler(J(q))),ee.add(F),{close(){let W=R.get(q);W?.delete(F)&&(W.size||(R.delete(q),w.delete(G),e.eventHandler({eventName:yte,data:{id:q}})))}}}function S(w){Rs(w)?w.forEach(E):E(w)}function E({id:w,created:R,deleted:L,updated:F}){x(w,R,0),x(w,L,2),x(w,F,1)}function x(w,R,L){R?.length&&(D(n,w,R,(F,J)=>F(J,L)),D(i,w,R,(F,J)=>F(J)),D(s,w,R,(F,J)=>F(J)))}function D(w,R,L,F){var J;(J=w.idToCallbacks.get(R))==null||J.forEach(G=>{L.forEach(q=>F(G,qu(q)))})}}var Aze=class ODe{constructor(t){this.filenameToScriptInfo=new Map,this.nodeModulesWatchers=new Map,this.filenameToScriptInfoVersion=new Map,this.allJsFilesForOpenFileTelemetry=new Map,this.externalProjectToConfiguredProjectMap=new Map,this.externalProjects=[],this.inferredProjects=[],this.configuredProjects=new Map,this.newInferredProjectName=vEe(zTe),this.newAutoImportProviderProjectName=vEe(WTe),this.newAuxiliaryProjectName=vEe($Te),this.openFiles=new Map,this.configFileForOpenFiles=new Map,this.rootOfInferredProjects=new Set,this.openFilesWithNonRootedDiskPath=new Map,this.compilerOptionsForInferredProjectsPerProjectRoot=new Map,this.watchOptionsForInferredProjectsPerProjectRoot=new Map,this.typeAcquisitionForInferredProjectsPerProjectRoot=new Map,this.projectToSizeMap=new Map,this.configFileExistenceInfoCache=new Map,this.safelist=_Ee,this.legacySafelist=new Map,this.pendingProjectUpdates=new Map,this.pendingEnsureProjectForOpenFiles=!1,this.seenProjects=new Map,this.sharedExtendedConfigFileWatchers=new Map,this.extendedConfigCache=new Map,this.baseline=io,this.verifyDocumentRegistry=io,this.verifyProgram=io,this.onProjectCreation=io;var n;this.host=t.host,this.logger=t.logger,this.cancellationToken=t.cancellationToken,this.useSingleInferredProject=t.useSingleInferredProject,this.useInferredProjectPerProjectRoot=t.useInferredProjectPerProjectRoot,this.typingsInstaller=t.typingsInstaller||ate,this.throttleWaitMilliseconds=t.throttleWaitMilliseconds,this.eventHandler=t.eventHandler,this.suppressDiagnosticEvents=t.suppressDiagnosticEvents,this.globalPlugins=t.globalPlugins||su,this.pluginProbeLocations=t.pluginProbeLocations||su,this.allowLocalPluginLoads=!!t.allowLocalPluginLoads,this.typesMapLocation=t.typesMapLocation===void 0?ri(mi(this.getExecutingFilePath()),"typesMap.json"):t.typesMapLocation,this.session=t.session,this.jsDocParsingMode=t.jsDocParsingMode,t.serverMode!==void 0?this.serverMode=t.serverMode:this.serverMode=0,this.host.realpath&&(this.realpathToScriptInfos=yd()),this.currentDirectory=Dc(this.host.getCurrentDirectory()),this.toCanonicalFileName=l_(this.host.useCaseSensitiveFileNames),this.globalCacheLocationDirectoryPath=this.typingsInstaller.globalTypingsCacheLocation?yu(this.toPath(this.typingsInstaller.globalTypingsCacheLocation)):void 0,this.throttledOperations=new GTe(this.host,this.logger),this.typesMapLocation?this.loadTypesMap():this.logger.info("No types map provided; using the default"),this.typingsInstaller.attach(this),this.typingsCache=new eEe(this.typingsInstaller),this.hostConfiguration={formatCodeOptions:vU(this.host.newLine),preferences:am,hostInfo:"Unknown host",extraFileExtensions:[]},this.documentRegistry=_Z(this.host.useCaseSensitiveFileNames,this.currentDirectory,this.jsDocParsingMode,this);let i=this.logger.hasLevel(3)?2:this.logger.loggingEnabled()?1:0,s=i!==0?o=>this.logger.info(o):io;this.packageJsonCache=CEe(this),this.watchFactory=this.serverMode!==0?{watchFile:u6,watchDirectory:u6}:$K(MRt(this,t.canUseWatchEvents)||this.host,i,s,RRt),(n=t.incrementalVerifier)==null||n.call(t,this)}toPath(t){return rc(t,this.currentDirectory,this.toCanonicalFileName)}getExecutingFilePath(){return this.getNormalizedAbsolutePath(this.host.getExecutingFilePath())}getNormalizedAbsolutePath(t){return xs(t,this.host.getCurrentDirectory())}setDocument(t,n,i){let s=M.checkDefined(this.getScriptInfoForPath(n));s.cacheSourceFile={key:t,sourceFile:i}}getDocument(t,n){let i=this.getScriptInfoForPath(n);return i&&i.cacheSourceFile&&i.cacheSourceFile.key===t?i.cacheSourceFile.sourceFile:void 0}ensureInferredProjectsUpToDate_TestOnly(){this.ensureProjectStructuresUptoDate()}getCompilerOptionsForInferredProjects(){return this.compilerOptionsForInferredProjects}onUpdateLanguageServiceStateForProject(t,n){if(!this.eventHandler)return;let i={eventName:dte,data:{project:t,languageServiceEnabled:n}};this.eventHandler(i)}loadTypesMap(){try{let t=this.host.readFile(this.typesMapLocation);if(t===void 0){this.logger.info(`Provided types map file "${this.typesMapLocation}" doesn't exist`);return}let n=JSON.parse(t);for(let i of Object.keys(n.typesMap))n.typesMap[i].match=new RegExp(n.typesMap[i].match,"i");this.safelist=n.typesMap;for(let i in n.simpleMap)Ho(n.simpleMap,i)&&this.legacySafelist.set(i,n.simpleMap[i].toLowerCase())}catch(t){this.logger.info(`Error loading types map: ${t}`),this.safelist=_Ee,this.legacySafelist.clear()}}updateTypingsForProject(t){let n=this.findProject(t.projectName);if(n)switch(t.kind){case mU:n.updateTypingFiles(this.typingsCache.updateTypingsForProject(t.projectName,t.compilerOptions,t.typeAcquisition,t.unresolvedImports,t.typings));return;case gU:this.typingsCache.enqueueInstallTypingsForProject(n,n.lastCachedUnresolvedImportsList,!0);return}}watchTypingLocations(t){var n;(n=this.findProject(t.projectName))==null||n.watchTypingLocations(t.files)}delayEnsureProjectForOpenFiles(){this.openFiles.size&&(this.pendingEnsureProjectForOpenFiles=!0,this.throttledOperations.schedule(gze,2500,()=>{this.pendingProjectUpdates.size!==0?this.delayEnsureProjectForOpenFiles():this.pendingEnsureProjectForOpenFiles&&(this.ensureProjectForOpenFiles(),this.sendProjectsUpdatedInBackgroundEvent())}))}delayUpdateProjectGraph(t){if(rJ(t)||(t.markAsDirty(),l7(t)))return;let n=t.getProjectName();this.pendingProjectUpdates.set(n,t),this.throttledOperations.schedule(n,250,()=>{this.pendingProjectUpdates.delete(n)&&Dd(t)})}hasPendingProjectUpdate(t){return this.pendingProjectUpdates.has(t.getProjectName())}sendProjectsUpdatedInBackgroundEvent(){if(!this.eventHandler)return;let t={eventName:nJ,data:{openFiles:Is(this.openFiles.keys(),n=>this.getScriptInfoForPath(n).fileName)}};this.eventHandler(t)}sendLargeFileReferencedEvent(t,n){if(!this.eventHandler)return;let i={eventName:fte,data:{file:t,fileSize:n,maxFileSize:lte}};this.eventHandler(i)}sendProjectLoadingStartEvent(t,n){if(!this.eventHandler)return;t.sendLoadingProjectFinish=!0;let i={eventName:ute,data:{project:t,reason:n}};this.eventHandler(i)}sendProjectLoadingFinishEvent(t){if(!this.eventHandler||!t.sendLoadingProjectFinish)return;t.sendLoadingProjectFinish=!1;let n={eventName:_te,data:{project:t}};this.eventHandler(n)}sendPerformanceEvent(t,n){this.performanceEventHandler&&this.performanceEventHandler({kind:t,durationMs:n})}delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(t){this.delayUpdateProjectGraph(t),this.delayEnsureProjectForOpenFiles()}delayUpdateProjectGraphs(t,n){if(t.length){for(let i of t)n&&i.clearSourceMapperCache(),this.delayUpdateProjectGraph(i);this.delayEnsureProjectForOpenFiles()}}setCompilerOptionsForInferredProjects(t,n){M.assert(n===void 0||this.useInferredProjectPerProjectRoot,"Setting compiler options per project root path is only supported when useInferredProjectPerProjectRoot is enabled");let i=iJ(t),s=u7(t,n),o=fEe(t);i.allowNonTsExtensions=!0;let u=n&&this.toCanonicalFileName(n);u?(this.compilerOptionsForInferredProjectsPerProjectRoot.set(u,i),this.watchOptionsForInferredProjectsPerProjectRoot.set(u,s||!1),this.typeAcquisitionForInferredProjectsPerProjectRoot.set(u,o)):(this.compilerOptionsForInferredProjects=i,this.watchOptionsForInferredProjects=s,this.typeAcquisitionForInferredProjects=o);for(let m of this.inferredProjects)(u?m.projectRootPath===u:!m.projectRootPath||!this.compilerOptionsForInferredProjectsPerProjectRoot.has(m.projectRootPath))&&(m.setCompilerOptions(i),m.setTypeAcquisition(o),m.setWatchOptions(s?.watchOptions),m.setProjectErrors(s?.errors),m.compileOnSaveEnabled=i.compileOnSave,m.markAsDirty(),this.delayUpdateProjectGraph(m));this.delayEnsureProjectForOpenFiles()}findProject(t){if(t!==void 0)return qTe(t)?yze(t,this.inferredProjects):this.findExternalProjectByProjectName(t)||this.findConfiguredProjectByProjectName(Dc(t))}forEachProject(t){this.externalProjects.forEach(t),this.configuredProjects.forEach(t),this.inferredProjects.forEach(t)}forEachEnabledProject(t){this.forEachProject(n=>{!n.isOrphan()&&n.languageServiceEnabled&&t(n)})}getDefaultProjectForFile(t,n){return n?this.ensureDefaultProjectForFile(t):this.tryGetDefaultProjectForFile(t)}tryGetDefaultProjectForFile(t){let n=bs(t)?this.getScriptInfoForNormalizedPath(t):t;return n&&!n.isOrphan()?n.getDefaultProject():void 0}tryGetDefaultProjectForEnsuringConfiguredProjectForFile(t){var n;let i=bs(t)?this.getScriptInfoForNormalizedPath(t):t;if(i)return(n=this.pendingOpenFileProjectUpdates)!=null&&n.delete(i.path)&&(this.tryFindDefaultConfiguredProjectAndLoadAncestorsForOpenScriptInfo(i,1),i.isOrphan()&&this.assignOrphanScriptInfoToInferredProject(i,this.openFiles.get(i.path))),this.tryGetDefaultProjectForFile(i)}ensureDefaultProjectForFile(t){return this.tryGetDefaultProjectForEnsuringConfiguredProjectForFile(t)||this.doEnsureDefaultProjectForFile(t)}doEnsureDefaultProjectForFile(t){this.ensureProjectStructuresUptoDate();let n=bs(t)?this.getScriptInfoForNormalizedPath(t):t;return n?n.getDefaultProject():(this.logErrorForScriptInfoNotFound(bs(t)?t:t.fileName),I0.ThrowNoProject())}getScriptInfoEnsuringProjectsUptoDate(t){return this.ensureProjectStructuresUptoDate(),this.getScriptInfo(t)}ensureProjectStructuresUptoDate(){let t=this.pendingEnsureProjectForOpenFiles;this.pendingProjectUpdates.clear();let n=i=>{t=Dd(i)||t};this.externalProjects.forEach(n),this.configuredProjects.forEach(n),this.inferredProjects.forEach(n),t&&this.ensureProjectForOpenFiles()}getFormatCodeOptions(t){let n=this.getScriptInfoForNormalizedPath(t);return n&&n.getFormatCodeSettings()||this.hostConfiguration.formatCodeOptions}getPreferences(t){let n=this.getScriptInfoForNormalizedPath(t);return{...this.hostConfiguration.preferences,...n&&n.getPreferences()}}getHostFormatCodeOptions(){return this.hostConfiguration.formatCodeOptions}getHostPreferences(){return this.hostConfiguration.preferences}onSourceFileChanged(t,n){M.assert(!t.isScriptOpen()),n===2?this.handleDeletedFile(t,!0):(t.deferredDelete&&(t.deferredDelete=void 0),t.delayReloadNonMixedContentFile(),this.delayUpdateProjectGraphs(t.containingProjects,!1),this.handleSourceMapProjects(t))}handleSourceMapProjects(t){if(t.sourceMapFilePath)if(bs(t.sourceMapFilePath)){let n=this.getScriptInfoForPath(t.sourceMapFilePath);this.delayUpdateSourceInfoProjects(n?.sourceInfos)}else this.delayUpdateSourceInfoProjects(t.sourceMapFilePath.sourceInfos);this.delayUpdateSourceInfoProjects(t.sourceInfos),t.declarationInfoPath&&this.delayUpdateProjectsOfScriptInfoPath(t.declarationInfoPath)}delayUpdateSourceInfoProjects(t){t&&t.forEach((n,i)=>this.delayUpdateProjectsOfScriptInfoPath(i))}delayUpdateProjectsOfScriptInfoPath(t){let n=this.getScriptInfoForPath(t);n&&this.delayUpdateProjectGraphs(n.containingProjects,!0)}handleDeletedFile(t,n){M.assert(!t.isScriptOpen()),this.delayUpdateProjectGraphs(t.containingProjects,!1),this.handleSourceMapProjects(t),t.detachAllProjects(),n?(t.delayReloadNonMixedContentFile(),t.deferredDelete=!0):this.deleteScriptInfo(t)}watchWildcardDirectory(t,n,i,s){let o=this.watchFactory.watchDirectory(t,m=>{let d=this.toPath(m),S=s.cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(m,d);if(Ul(d)==="package.json"&&!CM(d)&&(S&&S.fileExists||!S&&this.host.fileExists(m))){let x=this.getNormalizedAbsolutePath(m);this.logger.info(`Config: ${i} Detected new package.json: ${x}`),this.packageJsonCache.addOrUpdate(x,d),this.watchPackageJsonFile(x,d,u)}let E=this.findConfiguredProjectByProjectName(i);$8({watchedDirPath:this.toPath(t),fileOrDirectory:m,fileOrDirectoryPath:d,configFileName:i,extraFileExtensions:this.hostConfiguration.extraFileExtensions,currentDirectory:this.currentDirectory,options:s.parsedCommandLine.options,program:E?.getCurrentProgram()||s.parsedCommandLine.fileNames,useCaseSensitiveFileNames:this.host.useCaseSensitiveFileNames,writeLog:x=>this.logger.info(x),toPath:x=>this.toPath(x),getScriptKind:E?x=>E.getScriptKind(x):void 0})||(s.updateLevel!==2&&(s.updateLevel=1),s.projects.forEach((x,D)=>{var w;if(!x)return;let R=this.getConfiguredProjectByCanonicalConfigFilePath(D);if(!R)return;if(E!==R&&this.getHostPreferences().includeCompletionsForModuleExports){let F=this.toPath(i);Ln((w=R.getCurrentProgram())==null?void 0:w.getResolvedProjectReferences(),J=>J?.sourceFile.path===F)&&R.markAutoImportProviderAsDirty()}let L=E===R?1:0;if(!(R.pendingUpdateLevel>L))if(this.openFiles.has(d))if(M.checkDefined(this.getScriptInfoForPath(d)).isAttached(R)){let J=Math.max(L,R.openFileWatchTriggered.get(d)||0);R.openFileWatchTriggered.set(d,J)}else R.pendingUpdateLevel=L,this.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(R);else R.pendingUpdateLevel=L,this.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(R)}))},n,this.getWatchOptionsFromProjectWatchOptions(s.parsedCommandLine.watchOptions,mi(i)),Tu.WildcardDirectory,i),u={packageJsonWatches:void 0,close(){var m;o&&(o.close(),o=void 0,(m=u.packageJsonWatches)==null||m.forEach(d=>{d.projects.delete(u),d.close()}),u.packageJsonWatches=void 0)}};return u}delayUpdateProjectsFromParsedConfigOnConfigFileChange(t,n){let i=this.configFileExistenceInfoCache.get(t);if(!i?.config)return!1;let s=!1;return i.config.updateLevel=2,i.config.projects.forEach((o,u)=>{var m;let d=this.getConfiguredProjectByCanonicalConfigFilePath(u);if(d)if(s=!0,u===t){if(d.isInitialLoadPending())return;d.pendingUpdateLevel=2,d.pendingUpdateReason=n,this.delayUpdateProjectGraph(d),d.markAutoImportProviderAsDirty()}else{let S=this.toPath(t);d.resolutionCache.removeResolutionsFromProjectReferenceRedirects(S),this.delayUpdateProjectGraph(d),this.getHostPreferences().includeCompletionsForModuleExports&&Ln((m=d.getCurrentProgram())==null?void 0:m.getResolvedProjectReferences(),E=>E?.sourceFile.path===S)&&d.markAutoImportProviderAsDirty()}}),s}onConfigFileChanged(t,n,i){let s=this.configFileExistenceInfoCache.get(n),o=this.getConfiguredProjectByCanonicalConfigFilePath(n),u=o?.deferredClose;i===2?(s.exists=!1,o&&(o.deferredClose=!0)):(s.exists=!0,u&&(o.deferredClose=void 0,o.markAsDirty())),this.delayUpdateProjectsFromParsedConfigOnConfigFileChange(n,"Change in config file detected");let m=new Set(o?[o]:void 0);this.openFiles.forEach((d,S)=>{var E,x;let D=this.configFileForOpenFiles.get(S);if(!((E=s.openFilesImpactedByConfigFile)!=null&&E.has(S)))return;this.configFileForOpenFiles.delete(S);let w=this.getScriptInfoForPath(S),R=this.getConfigFileNameForFile(w,!1);if(!R)return;let L=this.findConfiguredProjectByProjectName(R)??this.createConfiguredProject(R,`Change in config file ${t} detected, ${Cze(w)}`);(x=this.pendingOpenFileProjectUpdates)!=null&&x.has(S)||(this.pendingOpenFileProjectUpdates??(this.pendingOpenFileProjectUpdates=new Map)).set(S,D),Pg(m,L)&&L.isInitialLoadPending()&&this.delayUpdateProjectGraph(L)}),this.delayEnsureProjectForOpenFiles()}removeProject(t){switch(this.logger.info("`remove Project::"),t.print(!0,!0,!1),t.close(),M.shouldAssert(1)&&this.filenameToScriptInfo.forEach(n=>M.assert(!n.isAttached(t),"Found script Info still attached to project",()=>`${t.projectName}: ScriptInfos still attached: ${JSON.stringify(Is(Up(this.filenameToScriptInfo.values(),i=>i.isAttached(t)?{fileName:i.fileName,projects:i.containingProjects.map(s=>s.projectName),hasMixedContent:i.hasMixedContent}:void 0)),void 0," ")}`)),this.pendingProjectUpdates.delete(t.getProjectName()),t.projectKind){case 2:JC(this.externalProjects,t),this.projectToSizeMap.delete(t.getProjectName());break;case 1:this.configuredProjects.delete(t.canonicalConfigFilePath),this.projectToSizeMap.delete(t.canonicalConfigFilePath);break;case 0:JC(this.inferredProjects,t);break}}assignOrphanScriptInfoToInferredProject(t,n){M.assert(t.isOrphan());let i=this.getOrCreateInferredProjectForProjectRootPathIfEnabled(t,n)||this.getOrCreateSingleInferredProjectIfEnabled()||this.getOrCreateSingleInferredWithoutProjectRoot(t.isDynamic?n||this.currentDirectory:mi(ip(t.fileName)?t.fileName:xs(t.fileName,n?this.getNormalizedAbsolutePath(n):this.currentDirectory)));if(i.addRoot(t),t.containingProjects[0]!==i&&(Gw(t.containingProjects,i),t.containingProjects.unshift(i)),i.updateGraph(),!this.useSingleInferredProject&&!i.projectRootPath)for(let s of this.inferredProjects){if(s===i||s.isOrphan())continue;let o=s.getRootScriptInfos();M.assert(o.length===1||!!s.projectRootPath),o.length===1&&kt(o[0].containingProjects,u=>u!==o[0].containingProjects[0]&&!u.isOrphan())&&s.removeFile(o[0],!0,!0)}return i}assignOrphanScriptInfosToInferredProject(){this.openFiles.forEach((t,n)=>{let i=this.getScriptInfoForPath(n);i.isOrphan()&&this.assignOrphanScriptInfoToInferredProject(i,t)})}closeOpenFile(t,n){var i;let s=t.isDynamic?!1:this.host.fileExists(t.fileName);t.close(s),this.stopWatchingConfigFilesForScriptInfo(t);let o=this.toCanonicalFileName(t.fileName);this.openFilesWithNonRootedDiskPath.get(o)===t&&this.openFilesWithNonRootedDiskPath.delete(o);let u=!1;for(let m of t.containingProjects){if(Wv(m)){t.hasMixedContent&&t.registerFileUpdate();let d=m.openFileWatchTriggered.get(t.path);d!==void 0&&(m.openFileWatchTriggered.delete(t.path),m.pendingUpdateLevel<d&&(m.pendingUpdateLevel=d,m.markFileAsDirty(t.path)))}else uD(m)&&m.isRoot(t)&&(m.isProjectWithSingleRoot()&&(u=!0),m.removeFile(t,s,!0));m.languageServiceEnabled||m.markAsDirty()}return this.openFiles.delete(t.path),this.configFileForOpenFiles.delete(t.path),(i=this.pendingOpenFileProjectUpdates)==null||i.delete(t.path),M.assert(!this.rootOfInferredProjects.has(t)),!n&&u&&this.assignOrphanScriptInfosToInferredProject(),s?this.watchClosedScriptInfo(t):this.handleDeletedFile(t,!1),u}deleteScriptInfo(t){M.assert(!t.isScriptOpen()),this.filenameToScriptInfo.delete(t.path),this.filenameToScriptInfoVersion.set(t.path,t.textStorage.version),this.stopWatchingScriptInfo(t);let n=t.getRealpathIfDifferent();n&&this.realpathToScriptInfos.remove(n,t),t.closeSourceMapFileWatcher()}configFileExists(t,n,i){let s=this.configFileExistenceInfoCache.get(n),o;if(this.openFiles.has(i.path)&&!Ete(i)&&(s?(s.openFilesImpactedByConfigFile??(s.openFilesImpactedByConfigFile=new Set)).add(i.path):(o=new Set).add(i.path)),s)return s.exists;let u=this.host.fileExists(t);return this.configFileExistenceInfoCache.set(n,{exists:u,openFilesImpactedByConfigFile:o}),u}createConfigFileWatcherForParsedConfig(t,n,i){var s,o;let u=this.configFileExistenceInfoCache.get(n);(!u.watcher||u.watcher===dEe)&&(u.watcher=this.watchFactory.watchFile(t,(d,S)=>this.onConfigFileChanged(t,n,S),2e3,this.getWatchOptionsFromProjectWatchOptions((o=(s=u?.config)==null?void 0:s.parsedCommandLine)==null?void 0:o.watchOptions,mi(t)),Tu.ConfigFile,i));let m=u.config.projects;m.set(i.canonicalConfigFilePath,m.get(i.canonicalConfigFilePath)||!1)}releaseParsedConfig(t,n){var i,s,o;let u=this.configFileExistenceInfoCache.get(t);(i=u.config)!=null&&i.projects.delete(n.canonicalConfigFilePath)&&((s=u.config)!=null&&s.projects.size||(u.config=void 0,zK(t,this.sharedExtendedConfigFileWatchers),M.checkDefined(u.watcher),(o=u.openFilesImpactedByConfigFile)!=null&&o.size?u.inferredProjectRoots?eU(hu(mi(t)))||(u.watcher.close(),u.watcher=dEe):(u.watcher.close(),u.watcher=void 0):(u.watcher.close(),this.configFileExistenceInfoCache.delete(t))))}stopWatchingConfigFilesForScriptInfo(t){if(this.serverMode!==0)return;let n=this.rootOfInferredProjects.delete(t),i=t.isScriptOpen();i&&!n||this.forEachConfigFileLocation(t,s=>{var o,u,m;let d=this.configFileExistenceInfoCache.get(s);if(d){if(i){if(!((o=d?.openFilesImpactedByConfigFile)!=null&&o.has(t.path)))return}else if(!((u=d.openFilesImpactedByConfigFile)!=null&&u.delete(t.path)))return;n&&(d.inferredProjectRoots--,d.watcher&&!d.config&&!d.inferredProjectRoots&&(d.watcher.close(),d.watcher=void 0)),!((m=d.openFilesImpactedByConfigFile)!=null&&m.size)&&!d.config&&(M.assert(!d.watcher),this.configFileExistenceInfoCache.delete(s))}})}startWatchingConfigFilesForInferredProjectRoot(t){this.serverMode===0&&(M.assert(t.isScriptOpen()),this.rootOfInferredProjects.add(t),this.forEachConfigFileLocation(t,(n,i)=>{let s=this.configFileExistenceInfoCache.get(n);s?s.inferredProjectRoots=(s.inferredProjectRoots??0)+1:(s={exists:this.host.fileExists(i),inferredProjectRoots:1},this.configFileExistenceInfoCache.set(n,s)),(s.openFilesImpactedByConfigFile??(s.openFilesImpactedByConfigFile=new Set)).add(t.path),s.watcher||(s.watcher=eU(hu(mi(n)))?this.watchFactory.watchFile(i,(o,u)=>this.onConfigFileChanged(i,n,u),2e3,this.hostConfiguration.watchOptions,Tu.ConfigFileForInferredRoot):dEe)}))}forEachConfigFileLocation(t,n){if(this.serverMode!==0)return;M.assert(!wRt(t)||this.openFiles.has(t.path));let i=this.openFiles.get(t.path);if(M.checkDefined(this.getScriptInfo(t.path)).isDynamic)return;let o=mi(t.fileName),u=()=>Cm(i,o,this.currentDirectory,!this.host.useCaseSensitiveFileNames),m=!i||!u(),d=!Ete(t);do{if(d){let E=i7(o,this.currentDirectory,this.toCanonicalFileName),x=ri(o,"tsconfig.json"),D=n(ri(E,"tsconfig.json"),x);if(D)return x;let w=ri(o,"jsconfig.json");if(D=n(ri(E,"jsconfig.json"),w),D)return w;if(d5(E))break}let S=mi(o);if(S===o)break;o=S,d=!0}while(m||u())}findDefaultConfiguredProject(t){var n;return t.isScriptOpen()?(n=this.tryFindDefaultConfiguredProjectForOpenScriptInfo(t,0))==null?void 0:n.defaultProject:void 0}getConfigFileNameForFileFromCache(t,n){if(n){let i=vze(t,this.pendingOpenFileProjectUpdates);if(i!==void 0)return i}return vze(t,this.configFileForOpenFiles)}setConfigFileNameForFileInCache(t,n){this.openFiles.has(t.path)&&(Ete(t)||this.configFileForOpenFiles.set(t.path,n||!1))}getConfigFileNameForFile(t,n){let i=this.getConfigFileNameForFileFromCache(t,n);if(i!==void 0)return i||void 0;if(n)return;let s=this.forEachConfigFileLocation(t,(o,u)=>this.configFileExists(u,o,t));return this.logger.info(`getConfigFileNameForFile:: File: ${t.fileName} ProjectRootPath: ${this.openFiles.get(t.path)}:: Result: ${s}`),this.setConfigFileNameForFileInCache(t,s),s}printProjects(){this.logger.hasLevel(1)&&(this.logger.startGroup(),this.externalProjects.forEach(EEe),this.configuredProjects.forEach(EEe),this.inferredProjects.forEach(EEe),this.logger.info("Open files: "),this.openFiles.forEach((t,n)=>{let i=this.getScriptInfoForPath(n);this.logger.info(`	FileName: ${i.fileName} ProjectRootPath: ${t}`),this.logger.info(`		Projects: ${i.containingProjects.map(s=>s.getProjectName())}`)}),this.logger.endGroup())}findConfiguredProjectByProjectName(t,n){let i=this.toCanonicalFileName(t),s=this.getConfiguredProjectByCanonicalConfigFilePath(i);return n?s:s?.deferredClose?void 0:s}getConfiguredProjectByCanonicalConfigFilePath(t){return this.configuredProjects.get(t)}findExternalProjectByProjectName(t){return yze(t,this.externalProjects)}getFilenameForExceededTotalSizeLimitForNonTsFiles(t,n,i,s){if(n&&n.disableSizeLimit||!this.host.getFileSize)return;let o=cte;this.projectToSizeMap.set(t,0),this.projectToSizeMap.forEach(m=>o-=m||0);let u=0;for(let m of i){let d=s.getFileName(m);if(!TA(d)&&(u+=this.host.getFileSize(d),u>cte||u>o)){let S=i.map(E=>s.getFileName(E)).filter(E=>!TA(E)).map(E=>({name:E,size:this.host.getFileSize(E)})).sort((E,x)=>x.size-E.size).slice(0,5);return this.logger.info(`Non TS file size exceeded limit (${u}). Largest files: ${S.map(E=>`${E.name}:${E.size}`).join(", ")}`),d}}this.projectToSizeMap.set(t,u)}createExternalProject(t,n,i,s,o){let u=iJ(i),m=u7(i,mi(qu(t))),d=new ote(t,this,this.documentRegistry,u,this.getFilenameForExceededTotalSizeLimitForNonTsFiles(t,u,n,Tte),i.compileOnSave===void 0?!0:i.compileOnSave,void 0,m?.watchOptions);return d.setProjectErrors(m?.errors),d.excludedFiles=o,this.addFilesToNonInferredProject(d,n,Tte,s),this.externalProjects.push(d),d}sendProjectTelemetry(t){if(this.seenProjects.has(t.projectName)){yEe(t);return}if(this.seenProjects.set(t.projectName,!0),!this.eventHandler||!this.host.createSHA256Hash){yEe(t);return}let n=Wv(t)?t.projectOptions:void 0;yEe(t);let i={projectId:this.host.createSHA256Hash(t.projectName),fileStats:o7(t.getScriptInfos(),!0),compilerOptions:rge(t.getCompilationSettings()),typeAcquisition:o(t.getTypeAcquisition()),extends:n&&n.configHasExtendsProperty,files:n&&n.configHasFilesProperty,include:n&&n.configHasIncludeProperty,exclude:n&&n.configHasExcludeProperty,compileOnSave:t.compileOnSaveEnabled,configFileName:s(),projectType:t instanceof ote?"external":"configured",languageServiceEnabled:t.languageServiceEnabled,version:se};this.eventHandler({eventName:mte,data:i});function s(){return Wv(t)&&ste(t.getConfigFilePath())||"other"}function o({enable:u,include:m,exclude:d}){return{enable:u,include:m!==void 0&&m.length!==0,exclude:d!==void 0&&d.length!==0}}}addFilesToNonInferredProject(t,n,i,s){this.updateNonInferredProjectFiles(t,n,i),t.setTypeAcquisition(s),t.markAsDirty()}createConfiguredProject(t,n){var i;(i=Cn)==null||i.instant(Cn.Phase.Session,"createConfiguredProject",{configFilePath:t}),this.logger.info(`Creating configuration project ${t}`);let s=this.toCanonicalFileName(t),o=this.configFileExistenceInfoCache.get(s);o?o.exists=!0:this.configFileExistenceInfoCache.set(s,o={exists:!0}),o.config||(o.config={cachedDirectoryStructureHost:JB(this.host,this.host.getCurrentDirectory(),this.host.useCaseSensitiveFileNames),projects:new Map,updateLevel:2});let u=new lEe(t,s,this,this.documentRegistry,o.config.cachedDirectoryStructureHost,n);return M.assert(!this.configuredProjects.has(s)),this.configuredProjects.set(s,u),this.createConfigFileWatcherForParsedConfig(t,s,u),u}loadConfiguredProject(t,n){var i,s;(i=Cn)==null||i.push(Cn.Phase.Session,"loadConfiguredProject",{configFilePath:t.canonicalConfigFilePath}),this.sendProjectLoadingStartEvent(t,n);let o=Zs(t.getConfigFilePath()),u=this.ensureParsedConfigUptoDate(o,t.canonicalConfigFilePath,this.configFileExistenceInfoCache.get(t.canonicalConfigFilePath),t),m=u.config.parsedCommandLine;M.assert(!!m.fileNames);let d=m.options;t.projectOptions||(t.projectOptions={configHasExtendsProperty:m.raw.extends!==void 0,configHasFilesProperty:m.raw.files!==void 0,configHasIncludeProperty:m.raw.include!==void 0,configHasExcludeProperty:m.raw.exclude!==void 0}),t.canConfigFileJsonReportNoInputFiles=VO(m.raw),t.setProjectErrors(m.options.configFile.parseDiagnostics),t.updateReferences(m.projectReferences);let S=this.getFilenameForExceededTotalSizeLimitForNonTsFiles(t.canonicalConfigFilePath,d,m.fileNames,bte);S?(t.disableLanguageService(S),this.configFileExistenceInfoCache.forEach((x,D)=>this.stopWatchingWildCards(D,t))):(t.setCompilerOptions(d),t.setWatchOptions(m.watchOptions),t.enableLanguageService(),this.watchWildcards(o,u,t)),t.enablePluginsWithOptions(d);let E=m.fileNames.concat(t.getExternalFiles(2));this.updateRootAndOptionsOfNonInferredProject(t,E,bte,d,m.typeAcquisition,m.compileOnSave,m.watchOptions),(s=Cn)==null||s.pop()}ensureParsedConfigUptoDate(t,n,i,s){var o,u,m;if(i.config){if(!i.config.updateLevel)return i;if(i.config.updateLevel===1)return this.reloadFileNamesOfParsedConfig(t,i.config),i}let d=((o=i.config)==null?void 0:o.cachedDirectoryStructureHost)||JB(this.host,this.host.getCurrentDirectory(),this.host.useCaseSensitiveFileNames),S=UO(t,L=>this.host.readFile(L)),E=x8(t,bs(S)?S:""),x=E.parseDiagnostics;bs(S)||x.push(S);let D=mi(t),w=D8(E,d,D,void 0,t,void 0,this.hostConfiguration.extraFileExtensions,this.extendedConfigCache);w.errors.length&&x.push(...w.errors),this.logger.info(`Config: ${t} : ${JSON.stringify({rootNames:w.fileNames,options:w.options,watchOptions:w.watchOptions,projectReferences:w.projectReferences},void 0," ")}`);let R=(u=i.config)==null?void 0:u.parsedCommandLine;return i.config?(i.config.parsedCommandLine=w,i.config.watchedDirectoriesStale=!0,i.config.updateLevel=void 0):i.config={parsedCommandLine:w,cachedDirectoryStructureHost:d,projects:new Map},!R&&!uj(this.getWatchOptionsFromProjectWatchOptions(void 0,D),this.getWatchOptionsFromProjectWatchOptions(w.watchOptions,D))&&((m=i.watcher)==null||m.close(),i.watcher=void 0),this.createConfigFileWatcherForParsedConfig(t,n,s),qB(n,w.options,this.sharedExtendedConfigFileWatchers,(L,F)=>this.watchFactory.watchFile(L,()=>{var J;zB(this.extendedConfigCache,F,q=>this.toPath(q));let G=!1;(J=this.sharedExtendedConfigFileWatchers.get(F))==null||J.projects.forEach(q=>{G=this.delayUpdateProjectsFromParsedConfigOnConfigFileChange(q,`Change in extended config file ${L} detected`)||G}),G&&this.delayEnsureProjectForOpenFiles()},2e3,this.hostConfiguration.watchOptions,Tu.ExtendedConfigFile,t),L=>this.toPath(L)),i}watchWildcards(t,{exists:n,config:i},s){if(i.projects.set(s.canonicalConfigFilePath,!0),n){if(i.watchedDirectories&&!i.watchedDirectoriesStale)return;i.watchedDirectoriesStale=!1,W8(i.watchedDirectories||(i.watchedDirectories=new Map),i.parsedCommandLine.wildcardDirectories,(o,u)=>this.watchWildcardDirectory(o,u,t,i))}else{if(i.watchedDirectoriesStale=!1,!i.watchedDirectories)return;Vf(i.watchedDirectories,Nd),i.watchedDirectories=void 0}}stopWatchingWildCards(t,n){let i=this.configFileExistenceInfoCache.get(t);!i.config||!i.config.projects.get(n.canonicalConfigFilePath)||(i.config.projects.set(n.canonicalConfigFilePath,!1),!Nu(i.config.projects,ec)&&(i.config.watchedDirectories&&(Vf(i.config.watchedDirectories,Nd),i.config.watchedDirectories=void 0),i.config.watchedDirectoriesStale=void 0))}updateNonInferredProjectFiles(t,n,i){var s;let o=t.getRootFilesMap(),u=new Map;for(let m of n){let d=i.getFileName(m),S=Dc(d),E=s7(S),x;if(!E&&!t.fileExists(d)){x=i7(S,this.currentDirectory,this.toCanonicalFileName);let D=o.get(x);D?(((s=D.info)==null?void 0:s.path)===x&&(t.removeFile(D.info,!1,!0),D.info=void 0),D.fileName=S):o.set(x,{fileName:S})}else{let D=i.getScriptKind(m,this.hostConfiguration.extraFileExtensions),w=i.hasMixedContent(m,this.hostConfiguration.extraFileExtensions),R=M.checkDefined(this.getOrCreateScriptInfoNotOpenedByClientForNormalizedPath(S,t.currentDirectory,D,w,t.directoryStructureHost,!1));x=R.path;let L=o.get(x);!L||L.info!==R?(t.addRoot(R,S),R.isScriptOpen()&&this.removeRootOfInferredProjectIfNowPartOfOtherProject(R)):L.fileName=S}u.set(x,!0)}o.size>u.size&&o.forEach((m,d)=>{u.has(d)||(m.info?t.removeFile(m.info,t.fileExists(m.info.fileName),!0):o.delete(d))})}updateRootAndOptionsOfNonInferredProject(t,n,i,s,o,u,m){t.setCompilerOptions(s),t.setWatchOptions(m),u!==void 0&&(t.compileOnSaveEnabled=u),this.addFilesToNonInferredProject(t,n,i,o)}reloadFileNamesOfConfiguredProject(t){let n=this.reloadFileNamesOfParsedConfig(t.getConfigFilePath(),this.configFileExistenceInfoCache.get(t.canonicalConfigFilePath).config);return t.updateErrorOnNoInputFiles(n),this.updateNonInferredProjectFiles(t,n.concat(t.getExternalFiles(1)),bte),t.markAsDirty(),t.updateGraph()}reloadFileNamesOfParsedConfig(t,n){if(n.updateLevel===void 0)return n.parsedCommandLine.fileNames;M.assert(n.updateLevel===1);let i=n.parsedCommandLine.options.configFile.configFileSpecs,s=JO(i,mi(t),n.parsedCommandLine.options,n.cachedDirectoryStructureHost,this.hostConfiguration.extraFileExtensions);return n.parsedCommandLine={...n.parsedCommandLine,fileNames:s},s}setFileNamesOfAutpImportProviderOrAuxillaryProject(t,n){this.updateNonInferredProjectFiles(t,n,bte)}reloadConfiguredProjectClearingSemanticCache(t,n,i){return Pg(i,t)?(this.clearSemanticCache(t),this.reloadConfiguredProject(t,Cte(n)),!0):!1}reloadConfiguredProject(t,n){t.isInitialLoadPending=Dg,t.pendingUpdateReason=void 0,t.pendingUpdateLevel=0,t.getCachedDirectoryStructureHost().clearCache(),this.loadConfiguredProject(t,n),Eze(t,t.triggerFileForConfigFileDiag??t.getConfigFilePath(),!0)}clearSemanticCache(t){t.originalConfiguredProjects=void 0,t.resolutionCache.clear(),t.getLanguageService(!1).cleanupSemanticCache(),t.cleanupProgram(),t.markAsDirty()}sendConfigFileDiagEvent(t,n,i){if(!this.eventHandler||this.suppressDiagnosticEvents)return!1;let s=t.getLanguageService().getCompilerOptionsDiagnostics();return s.push(...t.getAllProjectErrors()),!i&&s.length===(t.configDiagDiagnosticsReported??0)?!1:(t.configDiagDiagnosticsReported=s.length,this.eventHandler({eventName:pte,data:{configFileName:t.getConfigFilePath(),diagnostics:s,triggerFile:n??t.getConfigFilePath()}}),!0)}getOrCreateInferredProjectForProjectRootPathIfEnabled(t,n){if(!this.useInferredProjectPerProjectRoot||t.isDynamic&&n===void 0)return;if(n){let s=this.toCanonicalFileName(n);for(let o of this.inferredProjects)if(o.projectRootPath===s)return o;return this.createInferredProject(n,!1,n)}let i;for(let s of this.inferredProjects)s.projectRootPath&&Cm(s.projectRootPath,t.path,this.host.getCurrentDirectory(),!this.host.useCaseSensitiveFileNames)&&(i&&i.projectRootPath.length>s.projectRootPath.length||(i=s));return i}getOrCreateSingleInferredProjectIfEnabled(){if(this.useSingleInferredProject)return this.inferredProjects.length>0&&this.inferredProjects[0].projectRootPath===void 0?this.inferredProjects[0]:this.createInferredProject("",!0)}getOrCreateSingleInferredWithoutProjectRoot(t){M.assert(!this.useSingleInferredProject);let n=this.toCanonicalFileName(this.getNormalizedAbsolutePath(t));for(let i of this.inferredProjects)if(!i.projectRootPath&&i.isOrphan()&&i.canonicalCurrentDirectory===n)return i;return this.createInferredProject(t)}createInferredProject(t,n,i){let s=i&&this.compilerOptionsForInferredProjectsPerProjectRoot.get(i)||this.compilerOptionsForInferredProjects,o,u;i&&(o=this.watchOptionsForInferredProjectsPerProjectRoot.get(i),u=this.typeAcquisitionForInferredProjectsPerProjectRoot.get(i)),o===void 0&&(o=this.watchOptionsForInferredProjects),u===void 0&&(u=this.typeAcquisitionForInferredProjects),o=o||void 0;let m=new sEe(this,this.documentRegistry,s,o?.watchOptions,i,t,u);return m.setProjectErrors(o?.errors),n?this.inferredProjects.unshift(m):this.inferredProjects.push(m),m}getOrCreateScriptInfoNotOpenedByClient(t,n,i,s){return this.getOrCreateScriptInfoNotOpenedByClientForNormalizedPath(Dc(t),n,void 0,void 0,i,s)}getScriptInfo(t){return this.getScriptInfoForNormalizedPath(Dc(t))}getScriptInfoOrConfig(t){let n=Dc(t),i=this.getScriptInfoForNormalizedPath(n);if(i)return i;let s=this.configuredProjects.get(this.toPath(t));return s&&s.getCompilerOptions().configFile}logErrorForScriptInfoNotFound(t){let n=Is(Up(this.filenameToScriptInfo.entries(),i=>i[1].deferredDelete?void 0:i),([i,s])=>({path:i,fileName:s.fileName}));this.logger.msg(`Could not find file ${JSON.stringify(t)}.
All files are: ${JSON.stringify(n)}`,"Err")}getSymlinkedProjects(t){let n;if(this.realpathToScriptInfos){let s=t.getRealpathIfDifferent();s&&kt(this.realpathToScriptInfos.get(s),i),kt(this.realpathToScriptInfos.get(t.path),i)}return n;function i(s){if(s!==t)for(let o of s.containingProjects)o.languageServiceEnabled&&!o.isOrphan()&&!o.getCompilerOptions().preserveSymlinks&&!t.isAttached(o)&&(n?Nu(n,(u,m)=>m===s.path?!1:Es(u,o))||n.add(s.path,o):(n=yd(),n.add(s.path,o)))}}watchClosedScriptInfo(t){if(M.assert(!t.fileWatcher),!t.isDynamicOrHasMixedContent()&&(!this.globalCacheLocationDirectoryPath||!_s(t.path,this.globalCacheLocationDirectoryPath))){let n=t.fileName.indexOf("/node_modules/");!this.host.getModifiedTime||n===-1?t.fileWatcher=this.watchFactory.watchFile(t.fileName,(i,s)=>this.onSourceFileChanged(t,s),500,this.hostConfiguration.watchOptions,Tu.ClosedScriptInfo):(t.mTime=this.getModifiedTime(t),t.fileWatcher=this.watchClosedScriptInfoInNodeModules(t.fileName.substring(0,n)))}}createNodeModulesWatcher(t,n){let i=this.watchFactory.watchDirectory(t,o=>{var u;let m=ZB(this.toPath(o));if(!m)return;let d=Ul(m);if((u=s.affectedModuleSpecifierCacheProjects)!=null&&u.size&&(d==="package.json"||d==="node_modules")&&s.affectedModuleSpecifierCacheProjects.forEach(S=>{var E;(E=S.getModuleSpecifierCache())==null||E.clear()}),s.refreshScriptInfoRefCount)if(n===m)this.refreshScriptInfosInDirectory(n);else{let S=this.filenameToScriptInfo.get(m);S?Tze(S)&&this.refreshScriptInfo(S):kP(m)||this.refreshScriptInfosInDirectory(m)}},1,this.hostConfiguration.watchOptions,Tu.NodeModules),s={refreshScriptInfoRefCount:0,affectedModuleSpecifierCacheProjects:void 0,close:()=>{var o;i&&!s.refreshScriptInfoRefCount&&!((o=s.affectedModuleSpecifierCacheProjects)!=null&&o.size)&&(i.close(),i=void 0,this.nodeModulesWatchers.delete(n))}};return this.nodeModulesWatchers.set(n,s),s}watchPackageJsonsInNodeModules(t,n){var i;let s=this.toPath(t),o=this.nodeModulesWatchers.get(s)||this.createNodeModulesWatcher(t,s);return M.assert(!((i=o.affectedModuleSpecifierCacheProjects)!=null&&i.has(n))),(o.affectedModuleSpecifierCacheProjects||(o.affectedModuleSpecifierCacheProjects=new Set)).add(n),{close:()=>{var u;(u=o.affectedModuleSpecifierCacheProjects)==null||u.delete(n),o.close()}}}watchClosedScriptInfoInNodeModules(t){let n=t+"/node_modules",i=this.toPath(n),s=this.nodeModulesWatchers.get(i)||this.createNodeModulesWatcher(n,i);return s.refreshScriptInfoRefCount++,{close:()=>{s.refreshScriptInfoRefCount--,s.close()}}}getModifiedTime(t){return(this.host.getModifiedTime(t.fileName)||np).getTime()}refreshScriptInfo(t){let n=this.getModifiedTime(t);if(n!==t.mTime){let i=_$(t.mTime,n);t.mTime=n,this.onSourceFileChanged(t,i)}}refreshScriptInfosInDirectory(t){t=t+Ec,this.filenameToScriptInfo.forEach(n=>{Tze(n)&&_s(n.path,t)&&this.refreshScriptInfo(n)})}stopWatchingScriptInfo(t){t.fileWatcher&&(t.fileWatcher.close(),t.fileWatcher=void 0)}getOrCreateScriptInfoNotOpenedByClientForNormalizedPath(t,n,i,s,o,u){if(ip(t)||s7(t))return this.getOrCreateScriptInfoWorker(t,n,!1,void 0,i,!!s,o,u);let m=this.openFilesWithNonRootedDiskPath.get(this.toCanonicalFileName(t));if(m)return m}getOrCreateScriptInfoForNormalizedPath(t,n,i,s,o,u){return this.getOrCreateScriptInfoWorker(t,this.currentDirectory,n,i,s,!!o,u,!1)}getOrCreateScriptInfoWorker(t,n,i,s,o,u,m,d){M.assert(s===void 0||i,"ScriptInfo needs to be opened by client to be able to set its user defined content");let S=i7(t,n,this.toCanonicalFileName),E=this.filenameToScriptInfo.get(S);if(E){if(E.deferredDelete){if(M.assert(!E.isDynamic),!i&&!(m||this.host).fileExists(t))return d?E:void 0;E.deferredDelete=void 0}}else{let x=s7(t);if(M.assert(ip(t)||x||i,"",()=>`${JSON.stringify({fileName:t,currentDirectory:n,hostCurrentDirectory:this.currentDirectory,openKeys:Is(this.openFilesWithNonRootedDiskPath.keys())})}
Script info with non-dynamic relative file name can only be open script info or in context of host currentDirectory`),M.assert(!ip(t)||this.currentDirectory===n||!this.openFilesWithNonRootedDiskPath.has(this.toCanonicalFileName(t)),"",()=>`${JSON.stringify({fileName:t,currentDirectory:n,hostCurrentDirectory:this.currentDirectory,openKeys:Is(this.openFilesWithNonRootedDiskPath.keys())})}
Open script files with non rooted disk path opened with current directory context cannot have same canonical names`),M.assert(!x||this.currentDirectory===n||this.useInferredProjectPerProjectRoot,"",()=>`${JSON.stringify({fileName:t,currentDirectory:n,hostCurrentDirectory:this.currentDirectory,openKeys:Is(this.openFilesWithNonRootedDiskPath.keys())})}
Dynamic files must always be opened with service's current directory or service should support inferred project per projectRootPath.`),!i&&!x&&!(m||this.host).fileExists(t))return;E=new ZTe(this.host,t,o,u,S,this.filenameToScriptInfoVersion.get(S)),this.filenameToScriptInfo.set(E.path,E),this.filenameToScriptInfoVersion.delete(E.path),i?!ip(t)&&(!x||this.currentDirectory!==n)&&this.openFilesWithNonRootedDiskPath.set(this.toCanonicalFileName(t),E):this.watchClosedScriptInfo(E)}return i&&(this.stopWatchingScriptInfo(E),E.open(s),u&&E.registerFileUpdate()),E}getScriptInfoForNormalizedPath(t){return!ip(t)&&this.openFilesWithNonRootedDiskPath.get(this.toCanonicalFileName(t))||this.getScriptInfoForPath(i7(t,this.currentDirectory,this.toCanonicalFileName))}getScriptInfoForPath(t){let n=this.filenameToScriptInfo.get(t);return!n||!n.deferredDelete?n:void 0}getDocumentPositionMapper(t,n,i){let s=this.getOrCreateScriptInfoNotOpenedByClient(n,t.currentDirectory,this.host,!1);if(!s){i&&t.addGeneratedFileWatch(n,i);return}if(s.getSnapshot(),bs(s.sourceMapFilePath)){let S=this.getScriptInfoForPath(s.sourceMapFilePath);if(S&&(S.getSnapshot(),S.documentPositionMapper!==void 0))return S.sourceInfos=this.addSourceInfoToSourceMap(i,t,S.sourceInfos),S.documentPositionMapper?S.documentPositionMapper:void 0;s.sourceMapFilePath=void 0}else if(s.sourceMapFilePath){s.sourceMapFilePath.sourceInfos=this.addSourceInfoToSourceMap(i,t,s.sourceMapFilePath.sourceInfos);return}else if(s.sourceMapFilePath!==void 0)return;let o,u=(S,E)=>{let x=this.getOrCreateScriptInfoNotOpenedByClient(S,t.currentDirectory,this.host,!0);if(o=x||E,!x||x.deferredDelete)return;let D=x.getSnapshot();return x.documentPositionMapper!==void 0?x.documentPositionMapper:sk(D)},m=t.projectName,d=gZ({getCanonicalFileName:this.toCanonicalFileName,log:S=>this.logger.info(S),getSourceFileLike:S=>this.getSourceFileLike(S,m,s)},s.fileName,s.textStorage.getLineInfo(),u);return u=void 0,o?bs(o)?s.sourceMapFilePath={watcher:this.addMissingSourceMapFile(t.currentDirectory===this.currentDirectory?o:xs(o,t.currentDirectory),s.path),sourceInfos:this.addSourceInfoToSourceMap(i,t)}:(s.sourceMapFilePath=o.path,o.declarationInfoPath=s.path,o.deferredDelete||(o.documentPositionMapper=d||!1),o.sourceInfos=this.addSourceInfoToSourceMap(i,t,o.sourceInfos)):s.sourceMapFilePath=!1,d}addSourceInfoToSourceMap(t,n,i){if(t){let s=this.getOrCreateScriptInfoNotOpenedByClient(t,n.currentDirectory,n.directoryStructureHost,!1);(i||(i=new Set)).add(s.path)}return i}addMissingSourceMapFile(t,n){return this.watchFactory.watchFile(t,()=>{let s=this.getScriptInfoForPath(n);s&&s.sourceMapFilePath&&!bs(s.sourceMapFilePath)&&(this.delayUpdateProjectGraphs(s.containingProjects,!0),this.delayUpdateSourceInfoProjects(s.sourceMapFilePath.sourceInfos),s.closeSourceMapFileWatcher())},2e3,this.hostConfiguration.watchOptions,Tu.MissingSourceMapFile)}getSourceFileLike(t,n,i){let s=n.projectName?n:this.findProject(n);if(s){let u=s.toPath(t),m=s.getSourceFile(u);if(m&&m.resolvedPath===u)return m}let o=this.getOrCreateScriptInfoNotOpenedByClient(t,(s||this).currentDirectory,s?s.directoryStructureHost:this.host,!1);if(o){if(i&&bs(i.sourceMapFilePath)&&o!==i){let u=this.getScriptInfoForPath(i.sourceMapFilePath);u&&(u.sourceInfos??(u.sourceInfos=new Set)).add(o.path)}return o.cacheSourceFile?o.cacheSourceFile.sourceFile:(o.sourceFileLike||(o.sourceFileLike={get text(){return M.fail("shouldnt need text"),""},getLineAndCharacterOfPosition:u=>{let m=o.positionToLineOffset(u);return{line:m.line-1,character:m.offset-1}},getPositionOfLineAndCharacter:(u,m,d)=>o.lineOffsetToPosition(u+1,m+1,d)}),o.sourceFileLike)}}setPerformanceEventHandler(t){this.performanceEventHandler=t}setHostConfiguration(t){var n;if(t.file){let i=this.getScriptInfoForNormalizedPath(Dc(t.file));i&&(i.setOptions(_D(t.formatOptions),t.preferences),this.logger.info(`Host configuration update for file ${t.file}`))}else{if(t.hostInfo!==void 0&&(this.hostConfiguration.hostInfo=t.hostInfo,this.logger.info(`Host information ${t.hostInfo}`)),t.formatOptions&&(this.hostConfiguration.formatCodeOptions={...this.hostConfiguration.formatCodeOptions,..._D(t.formatOptions)},this.logger.info("Format host information updated")),t.preferences){let{lazyConfiguredProjectsFromExternalProject:i,includePackageJsonAutoImports:s,includeCompletionsForModuleExports:o}=this.hostConfiguration.preferences;this.hostConfiguration.preferences={...this.hostConfiguration.preferences,...t.preferences},i&&!this.hostConfiguration.preferences.lazyConfiguredProjectsFromExternalProject&&this.externalProjectToConfiguredProjectMap.forEach(u=>u.forEach(m=>{!m.deferredClose&&!m.isClosed()&&m.pendingUpdateLevel===2&&!this.hasPendingProjectUpdate(m)&&m.updateGraph()})),(s!==t.preferences.includePackageJsonAutoImports||!!o!=!!t.preferences.includeCompletionsForModuleExports)&&this.forEachProject(u=>{u.onAutoImportProviderSettingsChanged()})}if(t.extraFileExtensions&&(this.hostConfiguration.extraFileExtensions=t.extraFileExtensions,this.reloadProjects(),this.logger.info("Host file extension mappings updated")),t.watchOptions){let i=(n=u7(t.watchOptions))==null?void 0:n.watchOptions,s=uB(i,this.currentDirectory);this.hostConfiguration.watchOptions=s,this.hostConfiguration.beforeSubstitution=s===i?void 0:i,this.logger.info(`Host watch options changed to ${JSON.stringify(this.hostConfiguration.watchOptions)}, it will be take effect for next watches.`)}}}getWatchOptions(t){return this.getWatchOptionsFromProjectWatchOptions(t.getWatchOptions(),t.getCurrentDirectory())}getWatchOptionsFromProjectWatchOptions(t,n){let i=this.hostConfiguration.beforeSubstitution?uB(this.hostConfiguration.beforeSubstitution,n):this.hostConfiguration.watchOptions;return t&&i?{...i,...t}:t||i}closeLog(){this.logger.close()}reloadProjects(){this.logger.info("reload projects."),this.filenameToScriptInfo.forEach(i=>{this.openFiles.has(i.path)||i.fileWatcher&&this.onSourceFileChanged(i,this.host.fileExists(i.fileName)?i.deferredDelete?0:1:2)}),this.pendingProjectUpdates.forEach((i,s)=>{this.throttledOperations.cancel(s),this.pendingProjectUpdates.delete(s)}),this.throttledOperations.cancel(gze),this.pendingOpenFileProjectUpdates=void 0,this.pendingEnsureProjectForOpenFiles=!1,this.configFileExistenceInfoCache.forEach(i=>{i.config&&(i.config.updateLevel=2)}),this.configFileForOpenFiles.clear(),this.externalProjects.forEach(i=>{this.clearSemanticCache(i),i.updateGraph()});let t=new Set,n=new Set;this.externalProjectToConfiguredProjectMap.forEach((i,s)=>{let o=`Reloading configured project in external project: ${s}`;i.forEach(u=>{this.getHostPreferences().lazyConfiguredProjectsFromExternalProject?(u.isInitialLoadPending()||(this.clearSemanticCache(u),u.pendingUpdateLevel=2,u.pendingUpdateReason=Cte(o)),n.add(u)):this.reloadConfiguredProjectClearingSemanticCache(u,o,t)})}),this.openFiles.forEach((i,s)=>{let o=this.getScriptInfoForPath(s);Ln(o.containingProjects,c7)||this.tryFindDefaultConfiguredProjectAndLoadAncestorsForOpenScriptInfo(o,2,t,n)}),n.forEach(i=>t.add(i)),this.inferredProjects.forEach(i=>this.clearSemanticCache(i)),this.ensureProjectForOpenFiles(),this.cleanupProjectsAndScriptInfos(t,new Set(this.openFiles.keys()),new Set(this.externalProjectToConfiguredProjectMap.keys())),this.logger.info("After reloading projects.."),this.printProjects()}removeRootOfInferredProjectIfNowPartOfOtherProject(t){M.assert(t.containingProjects.length>0);let n=t.containingProjects[0];!n.isOrphan()&&uD(n)&&n.isRoot(t)&&kt(t.containingProjects,i=>i!==n&&!i.isOrphan())&&n.removeFile(t,!0,!0)}ensureProjectForOpenFiles(){this.logger.info("Before ensureProjectForOpenFiles:"),this.printProjects();let t=this.pendingOpenFileProjectUpdates;this.pendingOpenFileProjectUpdates=void 0,t?.forEach((n,i)=>this.tryFindDefaultConfiguredProjectAndLoadAncestorsForOpenScriptInfo(this.getScriptInfoForPath(i),1)),this.openFiles.forEach((n,i)=>{let s=this.getScriptInfoForPath(i);s.isOrphan()?this.assignOrphanScriptInfoToInferredProject(s,n):this.removeRootOfInferredProjectIfNowPartOfOtherProject(s)}),this.pendingEnsureProjectForOpenFiles=!1,this.inferredProjects.forEach(Dd),this.logger.info("After ensureProjectForOpenFiles:"),this.printProjects()}openClientFile(t,n,i,s){return this.openClientFileWithNormalizedPath(Dc(t),n,i,!1,s?Dc(s):void 0)}getOriginalLocationEnsuringConfiguredProject(t,n){let i=t.isSourceOfProjectReferenceRedirect(n.fileName),s=i?n:t.getSourceMapper().tryGetSourcePosition(n);if(!s)return;let{fileName:o}=s,u=this.getScriptInfo(o);if(!u&&!this.host.fileExists(o))return;let m={fileName:Dc(o),path:this.toPath(o)},d=this.getConfigFileNameForFile(m,!1);if(!d)return;let S=this.findConfiguredProjectByProjectName(d);if(!S){if(t.getCompilerOptions().disableReferencedProjectLoad)return i?n:u?.containingProjects.length?s:n;S=this.createConfiguredProject(d,`Creating project for original file: ${m.fileName}${n!==s?" for location: "+n.fileName:""}`)}Dd(S);let E=w=>{let R=this.getScriptInfo(o);return R&&w.containsScriptInfo(R)&&!w.isSourceOfProjectReferenceRedirect(R.path)};if(S.isSolution()||!E(S)){if(S=xte(S,o,w=>E(w)?w:void 0,1,`Creating project referenced in solution ${S.projectName} to find possible configured project for original file: ${m.fileName}${n!==s?" for location: "+n.fileName:""}`),!S)return;if(S===t)return s}D(S);let x=this.getScriptInfo(o);if(!x||!x.containingProjects.length)return;return x.containingProjects.forEach(w=>{Wv(w)&&D(w)}),s;function D(w){(t.originalConfiguredProjects??(t.originalConfiguredProjects=new Set)).add(w.canonicalConfigFilePath)}}fileExists(t){return!!this.getScriptInfoForNormalizedPath(t)||this.host.fileExists(t)}findExternalProjectContainingOpenScriptInfo(t){return Ln(this.externalProjects,n=>(Dd(n),n.containsScriptInfo(t)))}getOrCreateOpenScriptInfo(t,n,i,s,o){let u=this.getOrCreateScriptInfoWorker(t,o?this.getNormalizedAbsolutePath(o):this.currentDirectory,!0,n,i,!!s,void 0,!0);return this.openFiles.set(u.path,o),u}assignProjectToOpenedScriptInfo(t){let n,i,s=this.findExternalProjectContainingOpenScriptInfo(t),o,u;if(!s&&this.serverMode===0){let m=this.tryFindDefaultConfiguredProjectAndLoadAncestorsForOpenScriptInfo(t,1);m&&(o=m.seenProjects,u=m.sentConfigDiag,m.defaultProject&&(n=m.defaultProject.getConfigFilePath(),i=m.defaultProject.getAllProjectErrors()))}return t.containingProjects.forEach(Dd),t.isOrphan()&&(o?.forEach(m=>{u.has(m)||this.sendConfigFileDiagEvent(m,t.fileName,!0)}),M.assert(this.openFiles.has(t.path)),this.assignOrphanScriptInfoToInferredProject(t,this.openFiles.get(t.path))),M.assert(!t.isOrphan()),{configFileName:n,configFileErrors:i,retainProjects:o}}findCreateOrReloadConfiguredProject(t,n,i,s,o,u,m,d){let S=this.findConfiguredProjectByProjectName(t,s),E=!1;switch(n){case 0:if(!S)return;break;case 1:S??(S=this.createConfiguredProject(t,i)),E=!m&&xze(S,o);break;case 2:S??(S=this.createConfiguredProject(t,Cte(i))),E=!d&&this.reloadConfiguredProjectClearingSemanticCache(S,i,u),d&&!d.has(S)&&!u.has(S)&&(S.pendingUpdateLevel=2,S.pendingUpdateReason=Cte(i),d.add(S));break;default:M.assertNever(n)}return{project:S,sentConfigFileDiag:E}}tryFindDefaultConfiguredProjectForOpenScriptInfo(t,n,i,s){let o=this.getConfigFileNameForFile(t,n===0);if(!o)return;let u=this.findCreateOrReloadConfiguredProject(o,n,Cze(t),i,t.fileName,s);if(!u)return;let m=new Set,d=new Set(u.sentConfigFileDiag?[u.project]:void 0),S,E;return x(u.project),{defaultProject:S??E,sentConfigDiag:d,seenProjects:m};function x(R){return D(R)?S:w(R)}function D(R){if(!Pg(m,R))return;let L=R.containsScriptInfo(t);if(L&&!R.isSourceOfProjectReferenceRedirect(t.path))return S=R;E??(E=L?R:void 0)}function w(R){return xte(R,t.path,(L,F)=>(F&&d.add(L),D(L)),n,`Creating project referenced in solution ${R.projectName} to find possible configured project for ${t.fileName} to open`,i,t.fileName,s)}}tryFindDefaultConfiguredProjectAndLoadAncestorsForOpenScriptInfo(t,n,i,s){let o=n===0,u=this.tryFindDefaultConfiguredProjectForOpenScriptInfo(t,n,o,i);if(!u)return;let{defaultProject:m,seenProjects:d}=u;return m&&IRt(t,m,S=>{d.add(S)},n,`Creating project possibly referencing default composite project ${m.getProjectName()} of open file ${t.fileName}`,o,i,s),u}loadAncestorProjectTree(t){t=t||l3(this.configuredProjects,(i,s)=>s.isInitialLoadPending()?void 0:[i,!0]);let n=new Set;for(let i of Is(this.configuredProjects.values()))Sze(i,s=>t.has(s))&&Dd(i),this.ensureProjectChildren(i,t,n)}ensureProjectChildren(t,n,i){var s;if(!Pg(i,t.canonicalConfigFilePath)||t.getCompilerOptions().disableReferencedProjectLoad)return;let o=(s=t.getCurrentProgram())==null?void 0:s.getResolvedProjectReferences();if(o)for(let u of o){if(!u)continue;let m=sX(u.references,E=>n.has(E.sourceFile.path)?E:void 0);if(!m)continue;let d=Dc(u.sourceFile.fileName),S=this.findConfiguredProjectByProjectName(d)??this.createConfiguredProject(d,`Creating project referenced by : ${t.projectName} as it references project ${m.sourceFile.fileName}`);Dd(S),this.ensureProjectChildren(S,n,i)}}cleanupConfiguredProjects(t,n,i){this.getOrphanConfiguredProjects(t,i,n).forEach(s=>this.removeProject(s))}cleanupProjectsAndScriptInfos(t,n,i){this.cleanupConfiguredProjects(t,i,n);for(let s of this.inferredProjects.slice())s.isOrphan()&&this.removeProject(s);this.removeOrphanScriptInfos()}openClientFileWithNormalizedPath(t,n,i,s,o){let u=this.getOrCreateOpenScriptInfo(t,n,i,s,o),{retainProjects:m,...d}=this.assignProjectToOpenedScriptInfo(u);return this.cleanupProjectsAndScriptInfos(m,new Set([u.path]),void 0),this.telemetryOnOpenFile(u),this.printProjects(),d}getOrphanConfiguredProjects(t,n,i){let s=new Set(this.configuredProjects.values()),o=S=>{S.originalConfiguredProjects&&(Wv(S)||!S.isOrphan())&&S.originalConfiguredProjects.forEach((E,x)=>{let D=this.getConfiguredProjectByCanonicalConfigFilePath(x);return D&&d(D)})};return t?.forEach(d),this.inferredProjects.forEach(o),this.externalProjects.forEach(o),this.externalProjectToConfiguredProjectMap.forEach((S,E)=>{i?.has(E)||S.forEach(d)}),this.openFiles.forEach((S,E)=>{if(n?.has(E))return;let x=this.getScriptInfoForPath(E);if(Ln(x.containingProjects,c7))return;let D=this.tryFindDefaultConfiguredProjectAndLoadAncestorsForOpenScriptInfo(x,0);D?.defaultProject&&D?.seenProjects.forEach(d)}),this.configuredProjects.forEach(S=>{s.has(S)&&(m(S)||bze(S,u))&&d(S)}),s;function u(S){return!s.has(S)||m(S)}function m(S){var E,x;return(S.deferredClose||S.projectService.hasPendingProjectUpdate(S))&&!!((x=(E=S.projectService.configFileExistenceInfoCache.get(S.canonicalConfigFilePath))==null?void 0:E.openFilesImpactedByConfigFile)!=null&&x.size)}function d(S){s.delete(S)&&(o(S),bze(S,d))}}removeOrphanScriptInfos(){let t=new Map(this.filenameToScriptInfo);this.filenameToScriptInfo.forEach(n=>{if(!n.deferredDelete){if(!n.isScriptOpen()&&n.isOrphan()&&!n.isContainedByBackgroundProject()){if(!n.sourceMapFilePath)return;let i;if(bs(n.sourceMapFilePath)){let s=this.filenameToScriptInfo.get(n.sourceMapFilePath);i=s?.sourceInfos}else i=n.sourceMapFilePath.sourceInfos;if(!i||!d0(i,s=>{let o=this.getScriptInfoForPath(s);return!!o&&(o.isScriptOpen()||!o.isOrphan())}))return}if(t.delete(n.path),n.sourceMapFilePath){let i;if(bs(n.sourceMapFilePath)){let s=this.filenameToScriptInfo.get(n.sourceMapFilePath);s?.deferredDelete?n.sourceMapFilePath={watcher:this.addMissingSourceMapFile(s.fileName,n.path),sourceInfos:s.sourceInfos}:t.delete(n.sourceMapFilePath),i=s?.sourceInfos}else i=n.sourceMapFilePath.sourceInfos;i&&i.forEach((s,o)=>t.delete(o))}}}),t.forEach(n=>this.deleteScriptInfo(n))}telemetryOnOpenFile(t){if(this.serverMode!==0||!this.eventHandler||!t.isJavaScript()||!em(this.allJsFilesForOpenFileTelemetry,t.path))return;let n=this.ensureDefaultProjectForFile(t);if(!n.languageServiceEnabled)return;let i=n.getSourceFile(t.path),s=!!i&&!!i.checkJsDirective;this.eventHandler({eventName:uEe,data:{info:{checkJs:s}}})}closeClientFile(t,n){let i=this.getScriptInfoForNormalizedPath(Dc(t)),s=i?this.closeOpenFile(i,n):!1;return n||this.printProjects(),s}collectChanges(t,n,i,s){for(let o of n){let u=Ln(t,m=>m.projectName===o.getProjectName());s.push(o.getChangesSinceVersion(u&&u.version,i))}}synchronizeProjectList(t,n){let i=[];return this.collectChanges(t,this.externalProjects,n,i),this.collectChanges(t,Up(this.configuredProjects.values(),s=>s.deferredClose?void 0:s),n,i),this.collectChanges(t,this.inferredProjects,n,i),i}applyChangesInOpenFiles(t,n,i){let s,o=!1;if(t)for(let m of t){let d=this.getOrCreateOpenScriptInfo(Dc(m.fileName),m.content,vte(m.scriptKind),m.hasMixedContent,m.projectRootPath?Dc(m.projectRootPath):void 0);(s||(s=[])).push(d)}if(n)for(let m of n){let d=this.getScriptInfo(m.fileName);M.assert(!!d),this.applyChangesToFile(d,m.changes)}if(i)for(let m of i)o=this.closeClientFile(m,!0)||o;let u;s?.forEach(m=>{var d;return(d=this.assignProjectToOpenedScriptInfo(m).retainProjects)==null?void 0:d.forEach(S=>(u??(u=new Set)).add(S))}),o&&this.assignOrphanScriptInfosToInferredProject(),s?(this.cleanupProjectsAndScriptInfos(u,new Set(s.map(m=>m.path)),void 0),s.forEach(m=>this.telemetryOnOpenFile(m)),this.printProjects()):wt(i)&&this.printProjects()}applyChangesToFile(t,n){for(let i of n)t.editContent(i.span.start,i.span.start+i.span.length,i.newText)}closeExternalProject(t,n){let i=Dc(t);if(this.externalProjectToConfiguredProjectMap.get(i))this.externalProjectToConfiguredProjectMap.delete(i);else{let o=this.findExternalProjectByProjectName(t);o&&this.removeProject(o)}n&&(this.cleanupConfiguredProjects(),this.printProjects())}openExternalProjects(t){let n=new Set(this.externalProjects.map(i=>i.getProjectName()));this.externalProjectToConfiguredProjectMap.forEach((i,s)=>n.add(s));for(let i of t)this.openExternalProject(i,!1),n.delete(i.projectFileName);n.forEach(i=>this.closeExternalProject(i,!1)),this.cleanupConfiguredProjects(),this.printProjects()}static escapeFilenameForRegex(t){return t.replace(this.filenameEscapeRegexp,"\\$&")}resetSafeList(){this.safelist=_Ee}applySafeList(t){let n=t.typeAcquisition;M.assert(!!n,"proj.typeAcquisition should be set by now");let i=this.applySafeListWorker(t,t.rootFiles,n);return i?.excludedFiles??[]}applySafeListWorker(t,n,i){if(i.enable===!1||i.disableFilenameBasedTypeAcquisition)return;let s=i.include||(i.include=[]),o=[],u=n.map(x=>qu(x.fileName));for(let x of Object.keys(this.safelist)){let D=this.safelist[x];for(let w of u)if(D.match.test(w)){if(this.logger.info(`Excluding files based on rule ${x} matching file '${w}'`),D.types)for(let R of D.types)s.includes(R)||s.push(R);if(D.exclude)for(let R of D.exclude){let L=w.replace(D.match,(...F)=>R.map(J=>typeof J=="number"?bs(F[J])?ODe.escapeFilenameForRegex(F[J]):(this.logger.info(`Incorrect RegExp specification in safelist rule ${x} - not enough groups`),"\\*"):J).join(""));o.includes(L)||o.push(L)}else{let R=ODe.escapeFilenameForRegex(w);o.includes(R)||o.push(R)}}}let m=o.map(x=>new RegExp(x,"i")),d,S;for(let x=0;x<n.length;x++)if(m.some(D=>D.test(u[x])))E(x);else{if(i.enable){let D=Ul(R1(u[x]));if(Ic(D,"js")){let w=of(D),R=FW(w),L=this.legacySafelist.get(R);if(L!==void 0){this.logger.info(`Excluded '${u[x]}' because it matched ${R} from the legacy safelist`),E(x),s.includes(L)||s.push(L);continue}}}/^.+[.-]min\.js$/.test(u[x])?E(x):d?.push(n[x])}return S?{rootFiles:d,excludedFiles:S}:void 0;function E(x){S||(M.assert(!d),d=n.slice(0,x),S=[]),S.push(u[x])}}openExternalProject(t,n){let i=this.findExternalProjectByProjectName(t.projectFileName),s,o=[];for(let u of t.rootFiles){let m=Dc(u.fileName);if(ste(m)){if(this.serverMode===0&&this.host.fileExists(m)){let d=this.findConfiguredProjectByProjectName(m);d||(d=this.createConfiguredProject(m,`Creating configured project in external project: ${t.projectFileName}`),this.getHostPreferences().lazyConfiguredProjectsFromExternalProject||d.updateGraph()),(s??(s=new Set)).add(d),M.assert(!d.isClosed())}}else o.push(u)}if(s)this.externalProjectToConfiguredProjectMap.set(t.projectFileName,s),i&&this.removeProject(i);else{this.externalProjectToConfiguredProjectMap.delete(t.projectFileName);let u=t.typeAcquisition||{};u.include=u.include||[],u.exclude=u.exclude||[],u.enable===void 0&&(u.enable=nEe(o.map(S=>S.fileName)));let m=this.applySafeListWorker(t,o,u),d=m?.excludedFiles??[];if(o=m?.rootFiles??o,i){i.excludedFiles=d;let S=iJ(t.options),E=u7(t.options,i.getCurrentDirectory()),x=this.getFilenameForExceededTotalSizeLimitForNonTsFiles(t.projectFileName,S,o,Tte);x?i.disableLanguageService(x):i.enableLanguageService(),i.setProjectErrors(E?.errors),this.updateRootAndOptionsOfNonInferredProject(i,o,Tte,S,u,t.options.compileOnSave,E?.watchOptions),i.updateGraph()}else this.createExternalProject(t.projectFileName,o,t.options,u,d).updateGraph()}n&&(this.cleanupConfiguredProjects(s,new Set(t.projectFileName)),this.printProjects())}hasDeferredExtension(){for(let t of this.hostConfiguration.extraFileExtensions)if(t.scriptKind===7)return!0;return!1}requestEnablePlugin(t,n,i){if(!this.host.importPlugin&&!this.host.require){this.logger.info("Plugins were requested but not running in environment that supports 'require'. Nothing will be loaded");return}if(this.logger.info(`Enabling plugin ${n.name} from candidate paths: ${i.join(",")}`),!n.name||vu(n.name)||/[\\/]\.\.?($|[\\/])/.test(n.name)){this.logger.info(`Skipped loading plugin ${n.name||JSON.stringify(n)} because only package name is allowed plugin name`);return}if(this.host.importPlugin){let s=vk.importServicePluginAsync(n,i,this.host,u=>this.logger.info(u));this.pendingPluginEnablements??(this.pendingPluginEnablements=new Map);let o=this.pendingPluginEnablements.get(t);o||this.pendingPluginEnablements.set(t,o=[]),o.push(s);return}this.endEnablePlugin(t,vk.importServicePluginSync(n,i,this.host,s=>this.logger.info(s)))}endEnablePlugin(t,{pluginConfigEntry:n,resolvedModule:i,errorLogs:s}){var o;if(i){let u=(o=this.currentPluginConfigOverrides)==null?void 0:o.get(n.name);if(u){let m=n.name;n=u,n.name=m}t.enableProxy(i,n)}else kt(s,u=>this.logger.info(u)),this.logger.info(`Couldn't find ${n.name}`)}hasNewPluginEnablementRequests(){return!!this.pendingPluginEnablements}hasPendingPluginEnablements(){return!!this.currentPluginEnablementPromise}async waitForPendingPlugins(){for(;this.currentPluginEnablementPromise;)await this.currentPluginEnablementPromise}enableRequestedPlugins(){this.pendingPluginEnablements&&this.enableRequestedPluginsAsync()}async enableRequestedPluginsAsync(){if(this.currentPluginEnablementPromise&&await this.waitForPendingPlugins(),!this.pendingPluginEnablements)return;let t=Is(this.pendingPluginEnablements.entries());this.pendingPluginEnablements=void 0,this.currentPluginEnablementPromise=this.enableRequestedPluginsWorker(t),await this.currentPluginEnablementPromise}async enableRequestedPluginsWorker(t){M.assert(this.currentPluginEnablementPromise===void 0);let n=!1;await Promise.all(Cr(t,async([i,s])=>{let o=await Promise.all(s);if(i.isClosed()||rJ(i)){this.logger.info(`Cancelling plugin enabling for ${i.getProjectName()} as it is ${i.isClosed()?"closed":"deferred close"}`);return}n=!0;for(let u of o)this.endEnablePlugin(i,u);this.delayUpdateProjectGraph(i)})),this.currentPluginEnablementPromise=void 0,n&&this.sendProjectsUpdatedInBackgroundEvent()}configurePlugin(t){this.forEachEnabledProject(n=>n.onPluginConfigurationChanged(t.pluginName,t.configuration)),this.currentPluginConfigOverrides=this.currentPluginConfigOverrides||new Map,this.currentPluginConfigOverrides.set(t.pluginName,t.configuration)}getPackageJsonsVisibleToFile(t,n,i){let s=this.packageJsonCache,o=i&&this.toPath(i),u=[],m=d=>{switch(s.directoryHasPackageJson(d)){case 3:return s.searchDirectoryAndAncestors(d),m(d);case-1:let S=ri(d,"package.json");this.watchPackageJsonFile(S,this.toPath(S),n);let E=s.getInDirectory(d);E&&u.push(E)}if(o&&o===d)return!0};return Am(mi(t),m),u}getNearestAncestorDirectoryWithPackageJson(t){return Am(t,n=>{switch(this.packageJsonCache.directoryHasPackageJson(n)){case-1:return n;case 0:return;case 3:return this.host.fileExists(ri(n,"package.json"))?n:void 0}})}watchPackageJsonFile(t,n,i){M.assert(i!==void 0);let s=(this.packageJsonFilesMap??(this.packageJsonFilesMap=new Map)).get(n);if(!s){let o=this.watchFactory.watchFile(t,(u,m)=>{switch(m){case 0:case 1:this.packageJsonCache.addOrUpdate(u,n),this.onPackageJsonChange(s);break;case 2:this.packageJsonCache.delete(n),this.onPackageJsonChange(s),s.projects.clear(),s.close()}},250,this.hostConfiguration.watchOptions,Tu.PackageJson);s={projects:new Set,close:()=>{var u;s.projects.size||!o||(o.close(),o=void 0,(u=this.packageJsonFilesMap)==null||u.delete(n),this.packageJsonCache.invalidate(n))}},this.packageJsonFilesMap.set(n,s)}s.projects.add(i),(i.packageJsonWatches??(i.packageJsonWatches=new Set)).add(s)}onPackageJsonChange(t){t.projects.forEach(n=>{var i;return(i=n.onPackageJsonChange)==null?void 0:i.call(n)})}includePackageJsonAutoImports(){switch(this.hostConfiguration.preferences.includePackageJsonAutoImports){case"on":return 1;case"off":return 0;default:return 2}}getIncompleteCompletionsCache(){return this.incompleteCompletionsCache||(this.incompleteCompletionsCache=LRt())}};Aze.filenameEscapeRegexp=/[-/\\^$*+?.()|[\]{}]/g;var bEe=Aze;function LRt(){let e;return{get(){return e},set(t){e=t},clear(){e=void 0}}}function TEe(e){return e.kind!==void 0}function EEe(e){e.print(!1,!1,!1)}function xEe(e){let t,n,i,s={get(d,S,E,x){if(!(!n||i!==u(d,E,x)))return n.get(S)},set(d,S,E,x,D,w,R){if(o(d,E,x).set(S,m(D,w,R,!1)),R){for(let L of w)if(L.isInNodeModules){let F=L.path.substring(0,L.path.indexOf(jy)+jy.length-1),J=e.toPath(F);t?.has(J)||(t||(t=new Map)).set(J,e.watchNodeModulesForPackageJsonChanges(F))}}},setModulePaths(d,S,E,x,D){let w=o(d,E,x),R=w.get(S);R?R.modulePaths=D:w.set(S,m(void 0,D,void 0,void 0))},setBlockedByPackageJsonDependencies(d,S,E,x,D){let w=o(d,E,x),R=w.get(S);R?R.isBlockedByPackageJsonDependencies=D:w.set(S,m(void 0,void 0,void 0,D))},clear(){t?.forEach(Dm),n?.clear(),t?.clear(),i=void 0},count(){return n?n.size:0}};return M.isDebugging&&Object.defineProperty(s,"__cache",{get:()=>n}),s;function o(d,S,E){let x=u(d,S,E);return n&&i!==x&&s.clear(),i=x,n||(n=new Map)}function u(d,S,E){return`${d},${S.importModuleSpecifierEnding},${S.importModuleSpecifierPreference},${E.overrideImportMode}`}function m(d,S,E,x){return{kind:d,modulePaths:S,moduleSpecifiers:E,isBlockedByPackageJsonDependencies:x}}}function CEe(e){let t=new Map,n=new Map;return{addOrUpdate:i,invalidate:s,delete:u=>{t.delete(u),n.set(mi(u),!0)},getInDirectory:u=>t.get(e.toPath(ri(u,"package.json")))||void 0,directoryHasPackageJson:u=>o(e.toPath(u)),searchDirectoryAndAncestors:u=>{Am(u,m=>{let d=e.toPath(m);if(o(d)!==3)return!0;let S=ri(m,"package.json");xM(e,S)?i(S,ri(d,"package.json")):n.set(d,!0)})}};function i(u,m){let d=M.checkDefined(XQ(u,e.host));t.set(m,d),n.delete(mi(m))}function s(u){t.delete(u),n.delete(mi(u))}function o(u){return t.has(ri(u,"package.json"))?-1:n.has(u)?0:3}}var kze={isCancellationRequested:()=>!1,setRequest:()=>{},resetRequest:()=>{}};function FRt(e){let t=e[0],n=e[1];return(1e9*t+n)/1e6}function Pze(e,t){if((uD(e)||c7(e))&&e.isJsOnlyProject()){let n=e.getScriptInfoForNormalizedPath(t);return n&&!n.isJavaScript()}return!1}function jRt(e){return $p(e)||!!e.emitDecoratorMetadata}function Nze(e,t,n){let i=t.getScriptInfoForNormalizedPath(e);return{start:i.positionToLineOffset(n.start),end:i.positionToLineOffset(n.start+n.length),text:Zg(n.messageText,`
`),code:n.code,category:Bx(n),reportsUnnecessary:n.reportsUnnecessary,reportsDeprecated:n.reportsDeprecated,source:n.source,relatedInformation:Cr(n.relatedInformation,Ate)}}function Ate(e){return e.file?{span:{start:fD(ba(e.file,e.start)),end:fD(ba(e.file,e.start+e.length)),file:e.file.fileName},message:Zg(e.messageText,`
`),category:Bx(e),code:e.code}:{message:Zg(e.messageText,`
`),category:Bx(e),code:e.code}}function fD(e){return{line:e.line+1,offset:e.character+1}}function _7(e,t){let n=e.file&&fD(ba(e.file,e.start)),i=e.file&&fD(ba(e.file,e.start+e.length)),s=Zg(e.messageText,`
`),{code:o,source:u}=e,m=Bx(e),d={start:n,end:i,text:s,code:o,category:m,reportsUnnecessary:e.reportsUnnecessary,reportsDeprecated:e.reportsDeprecated,source:u,relatedInformation:Cr(e.relatedInformation,Ate)};return t?{...d,fileName:e.file&&e.file.fileName}:d}function BRt(e,t){return e.every(n=>bl(n.span)<t)}var Dze=XTe;function AEe(e,t,n,i){let s=t.hasLevel(3),o=JSON.stringify(e);return s&&t.info(`${e.type}:${Ob(e)}`),`Content-Length: ${1+n(o,"utf8")}\r
\r
${o}${i}`}var URt=class{constructor(e){this.operationHost=e}startNew(e){this.complete(),this.requestId=this.operationHost.getCurrentRequestId(),this.executeAction(e)}complete(){this.requestId!==void 0&&(this.operationHost.sendRequestCompletedEvent(this.requestId),this.requestId=void 0),this.setTimerHandle(void 0),this.setImmediateId(void 0)}immediate(e,t){let n=this.requestId;M.assert(n===this.operationHost.getCurrentRequestId(),"immediate: incorrect request id"),this.setImmediateId(this.operationHost.getServerHost().setImmediate(()=>{this.immediateId=void 0,this.operationHost.executeWithRequestId(n,()=>this.executeAction(t))},e))}delay(e,t,n){let i=this.requestId;M.assert(i===this.operationHost.getCurrentRequestId(),"delay: incorrect request id"),this.setTimerHandle(this.operationHost.getServerHost().setTimeout(()=>{this.timerHandle=void 0,this.operationHost.executeWithRequestId(i,()=>this.executeAction(n))},t,e))}executeAction(e){var t,n,i,s,o,u;let m=!1;try{this.operationHost.isCancellationRequested()?(m=!0,(t=Cn)==null||t.instant(Cn.Phase.Session,"stepCanceled",{seq:this.requestId,early:!0})):((n=Cn)==null||n.push(Cn.Phase.Session,"stepAction",{seq:this.requestId}),e(this),(i=Cn)==null||i.pop())}catch(d){(s=Cn)==null||s.popAll(),m=!0,d instanceof tI?(o=Cn)==null||o.instant(Cn.Phase.Session,"stepCanceled",{seq:this.requestId}):((u=Cn)==null||u.instant(Cn.Phase.Session,"stepError",{seq:this.requestId,message:d.message}),this.operationHost.logError(d,`delayed processing of request ${this.requestId}`))}(m||!this.hasPendingWork())&&this.complete()}setTimerHandle(e){this.timerHandle!==void 0&&this.operationHost.getServerHost().clearTimeout(this.timerHandle),this.timerHandle=e}setImmediateId(e){this.immediateId!==void 0&&this.operationHost.getServerHost().clearImmediate(this.immediateId),this.immediateId=e}hasPendingWork(){return!!this.timerHandle||!!this.immediateId}};function kEe(e,t){return{seq:0,type:"event",event:e,body:t}}function VRt(e,t,n,i){let s=M_(Rs(n)?n:n.projects,o=>i(o,e));return!Rs(n)&&n.symLinkedProjects&&n.symLinkedProjects.forEach((o,u)=>{let m=t(u);s.push(...va(o,d=>i(d,m)))}),I1(s,gv)}function kte(e){return RW(({textSpan:t})=>t.start+100003*t.length,MQ(e))}function JRt(e,t,n,i,s,o,u){let m=wze(e,t,n,!0,(E,x)=>E.getLanguageService().findRenameLocations(x.fileName,x.pos,i,s,o),(E,x)=>x(U6(E)));if(Rs(m))return m;let d=[],S=kte(u);return m.forEach((E,x)=>{for(let D of E)!S.has(D)&&!Pte(U6(D),x)&&(d.push(D),S.add(D))}),d}function qRt(e,t,n){let i=e.getLanguageService().getDefinitionAtPosition(t.fileName,t.pos,!1,n),s=i&&xo(i);return s&&!s.isLocal?{fileName:s.fileName,pos:s.textSpan.start}:void 0}function zRt(e,t,n,i,s){var o,u;let m=wze(e,t,n,!1,(x,D)=>(s.info(`Finding references to ${D.fileName} position ${D.pos} in project ${x.getProjectName()}`),x.getLanguageService().findReferences(D.fileName,D.pos)),(x,D)=>{D(U6(x.definition));for(let w of x.references)D(U6(w))});if(Rs(m))return m;let d=m.get(t);if(((u=(o=d?.[0])==null?void 0:o.references[0])==null?void 0:u.isDefinition)===void 0)m.forEach(x=>{for(let D of x)for(let w of D.references)delete w.isDefinition});else{let x=kte(i);for(let w of d)for(let R of w.references)if(R.isDefinition){x.add(R);break}let D=new Set;for(;;){let w=!1;if(m.forEach((R,L)=>{if(D.has(L))return;L.getLanguageService().updateIsDefinitionOfReferencedSymbols(R,x)&&(D.add(L),w=!0)}),!w)break}m.forEach((w,R)=>{if(!D.has(R))for(let L of w)for(let F of L.references)F.isDefinition=!1})}let S=[],E=kte(i);return m.forEach((x,D)=>{for(let w of x){let R=Pte(U6(w.definition),D),L=R===void 0?w.definition:{...w.definition,textSpan:zu(R.pos,w.definition.textSpan.length),fileName:R.fileName,contextSpan:HRt(w.definition,D)},F=Ln(S,J=>RQ(J.definition,L,i));F||(F={definition:L,references:[]},S.push(F));for(let J of w.references)!E.has(J)&&!Pte(U6(J),D)&&(E.add(J),F.references.push(J))}}),S.filter(x=>x.references.length!==0)}function PEe(e,t,n){for(let i of Rs(e)?e:e.projects)n(i,t);!Rs(e)&&e.symLinkedProjects&&e.symLinkedProjects.forEach((i,s)=>{for(let o of i)n(o,s)})}function wze(e,t,n,i,s,o){let u=new Map,m=p3();m.enqueue({project:t,location:n}),PEe(e,n.fileName,(L,F)=>{let J={fileName:F,pos:n.pos};m.enqueue({project:L,location:J})});let d=t.projectService,S=t.getCancellationToken(),E=qRt(t,n,i),x=tf(()=>t.isSourceOfProjectReferenceRedirect(E.fileName)?E:t.getLanguageService().getSourceMapper().tryGetGeneratedPosition(E)),D=tf(()=>t.isSourceOfProjectReferenceRedirect(E.fileName)?E:t.getLanguageService().getSourceMapper().tryGetSourcePosition(E)),w=new Set;e:for(;!m.isEmpty();){for(;!m.isEmpty();){if(S.isCancellationRequested())break e;let{project:L,location:F}=m.dequeue();if(u.has(L)||Ize(L,F)||(Dd(L),!L.containsFile(Dc(F.fileName))))continue;let J=R(L,F);u.set(L,J??su),w.add($Rt(L))}E&&(d.loadAncestorProjectTree(w),d.forEachEnabledProject(L=>{if(S.isCancellationRequested()||u.has(L))return;let F=WRt(E,L,x,D);F&&m.enqueue({project:L,location:F})}))}if(u.size===1)return _3(u.values());return u;function R(L,F){let J=s(L,F);if(J){for(let G of J)o(G,q=>{let ee=d.getOriginalLocationEnsuringConfiguredProject(L,q);if(!ee)return;let W=d.getScriptInfo(ee.fileName);for(let K of W.containingProjects)!K.isOrphan()&&!u.has(K)&&m.enqueue({project:K,location:ee});let pe=d.getSymlinkedProjects(W);pe&&pe.forEach((K,re)=>{for(let ue of K)!ue.isOrphan()&&!u.has(ue)&&m.enqueue({project:ue,location:{fileName:re,pos:ee.pos}})})});return J}}}function WRt(e,t,n,i){if(t.containsFile(Dc(e.fileName))&&!Ize(t,e))return e;let s=n();if(s&&t.containsFile(Dc(s.fileName)))return s;let o=i();return o&&t.containsFile(Dc(o.fileName))?o:void 0}function Ize(e,t){if(!t)return!1;let n=e.getLanguageService().getProgram();if(!n)return!1;let i=n.getSourceFile(t.fileName);return!!i&&i.resolvedPath!==i.path&&i.resolvedPath!==e.toPath(t.fileName)}function $Rt(e){return Wv(e)?e.canonicalConfigFilePath:e.getProjectName()}function U6({fileName:e,textSpan:t}){return{fileName:e,pos:t.start}}function Pte(e,t){return y6(e,t.getSourceMapper(),n=>t.projectService.fileExists(n))}function Oze(e,t){return qU(e,t.getSourceMapper(),n=>t.projectService.fileExists(n))}function HRt(e,t){return FQ(e,t.getSourceMapper(),n=>t.projectService.fileExists(n))}var Rze=["openExternalProject","openExternalProjects","closeExternalProject","synchronizeProjectList","emit-output","compileOnSaveAffectedFileList","compileOnSaveEmitFile","compilerOptionsDiagnostics-full","encodedSemanticClassifications-full","semanticDiagnosticsSync","suggestionDiagnosticsSync","geterrForProject","reload","reloadProjects","getCodeFixes","getCodeFixes-full","getCombinedCodeFix","getCombinedCodeFix-full","applyCodeActionCommand","getSupportedCodeFixes","getApplicableRefactors","getMoveToRefactoringFileSuggestions","getEditsForRefactor","getEditsForRefactor-full","organizeImports","organizeImports-full","getEditsForFileRename","getEditsForFileRename-full","prepareCallHierarchy","provideCallHierarchyIncomingCalls","provideCallHierarchyOutgoingCalls","getPasteEdits"],GRt=[...Rze,"definition","definition-full","definitionAndBoundSpan","definitionAndBoundSpan-full","typeDefinition","implementation","implementation-full","references","references-full","rename","renameLocations-full","rename-full","quickinfo","quickinfo-full","completionInfo","completions","completions-full","completionEntryDetails","completionEntryDetails-full","signatureHelp","signatureHelp-full","navto","navto-full","documentHighlights","documentHighlights-full"],Mze=class Wae{constructor(t){this.changeSeq=0,this.handlers=new Map(Object.entries({status:()=>{let o={version:se};return this.requiredResponse(o)},openExternalProject:o=>(this.projectService.openExternalProject(o.arguments,!0),this.requiredResponse(!0)),openExternalProjects:o=>(this.projectService.openExternalProjects(o.arguments.projects),this.requiredResponse(!0)),closeExternalProject:o=>(this.projectService.closeExternalProject(o.arguments.projectFileName,!0),this.requiredResponse(!0)),synchronizeProjectList:o=>{let u=this.projectService.synchronizeProjectList(o.arguments.knownProjects,o.arguments.includeProjectReferenceRedirectInfo);if(!u.some(d=>d.projectErrors&&d.projectErrors.length!==0))return this.requiredResponse(u);let m=Cr(u,d=>!d.projectErrors||d.projectErrors.length===0?d:{info:d.info,changes:d.changes,files:d.files,projectErrors:this.convertToDiagnosticsWithLinePosition(d.projectErrors,void 0)});return this.requiredResponse(m)},updateOpen:o=>(this.changeSeq++,this.projectService.applyChangesInOpenFiles(o.arguments.openFiles&&Ix(o.arguments.openFiles,u=>({fileName:u.file,content:u.fileContent,scriptKind:u.scriptKindName,projectRootPath:u.projectRootPath})),o.arguments.changedFiles&&Ix(o.arguments.changedFiles,u=>({fileName:u.fileName,changes:Up(Ra(u.textChanges),m=>{let d=M.checkDefined(this.projectService.getScriptInfo(u.fileName)),S=d.lineOffsetToPosition(m.start.line,m.start.offset),E=d.lineOffsetToPosition(m.end.line,m.end.offset);return S>=0?{span:{start:S,length:E-S},newText:m.newText}:void 0})})),o.arguments.closedFiles),this.requiredResponse(!0)),applyChangedToOpenFiles:o=>(this.changeSeq++,this.projectService.applyChangesInOpenFiles(o.arguments.openFiles,o.arguments.changedFiles&&Ix(o.arguments.changedFiles,u=>({fileName:u.fileName,changes:Ra(u.changes)})),o.arguments.closedFiles),this.requiredResponse(!0)),exit:()=>(this.exit(),this.notRequired()),definition:o=>this.requiredResponse(this.getDefinition(o.arguments,!0)),"definition-full":o=>this.requiredResponse(this.getDefinition(o.arguments,!1)),definitionAndBoundSpan:o=>this.requiredResponse(this.getDefinitionAndBoundSpan(o.arguments,!0)),"definitionAndBoundSpan-full":o=>this.requiredResponse(this.getDefinitionAndBoundSpan(o.arguments,!1)),findSourceDefinition:o=>this.requiredResponse(this.findSourceDefinition(o.arguments)),"emit-output":o=>this.requiredResponse(this.getEmitOutput(o.arguments)),typeDefinition:o=>this.requiredResponse(this.getTypeDefinition(o.arguments)),implementation:o=>this.requiredResponse(this.getImplementation(o.arguments,!0)),"implementation-full":o=>this.requiredResponse(this.getImplementation(o.arguments,!1)),references:o=>this.requiredResponse(this.getReferences(o.arguments,!0)),"references-full":o=>this.requiredResponse(this.getReferences(o.arguments,!1)),rename:o=>this.requiredResponse(this.getRenameLocations(o.arguments,!0)),"renameLocations-full":o=>this.requiredResponse(this.getRenameLocations(o.arguments,!1)),"rename-full":o=>this.requiredResponse(this.getRenameInfo(o.arguments)),open:o=>(this.openClientFile(Dc(o.arguments.file),o.arguments.fileContent,Ste(o.arguments.scriptKindName),o.arguments.projectRootPath?Dc(o.arguments.projectRootPath):void 0),this.notRequired()),quickinfo:o=>this.requiredResponse(this.getQuickInfoWorker(o.arguments,!0)),"quickinfo-full":o=>this.requiredResponse(this.getQuickInfoWorker(o.arguments,!1)),getOutliningSpans:o=>this.requiredResponse(this.getOutliningSpans(o.arguments,!0)),outliningSpans:o=>this.requiredResponse(this.getOutliningSpans(o.arguments,!1)),todoComments:o=>this.requiredResponse(this.getTodoComments(o.arguments)),indentation:o=>this.requiredResponse(this.getIndentation(o.arguments)),nameOrDottedNameSpan:o=>this.requiredResponse(this.getNameOrDottedNameSpan(o.arguments)),breakpointStatement:o=>this.requiredResponse(this.getBreakpointStatement(o.arguments)),braceCompletion:o=>this.requiredResponse(this.isValidBraceCompletion(o.arguments)),docCommentTemplate:o=>this.requiredResponse(this.getDocCommentTemplate(o.arguments)),getSpanOfEnclosingComment:o=>this.requiredResponse(this.getSpanOfEnclosingComment(o.arguments)),fileReferences:o=>this.requiredResponse(this.getFileReferences(o.arguments,!0)),"fileReferences-full":o=>this.requiredResponse(this.getFileReferences(o.arguments,!1)),format:o=>this.requiredResponse(this.getFormattingEditsForRange(o.arguments)),formatonkey:o=>this.requiredResponse(this.getFormattingEditsAfterKeystroke(o.arguments)),"format-full":o=>this.requiredResponse(this.getFormattingEditsForDocumentFull(o.arguments)),"formatonkey-full":o=>this.requiredResponse(this.getFormattingEditsAfterKeystrokeFull(o.arguments)),"formatRange-full":o=>this.requiredResponse(this.getFormattingEditsForRangeFull(o.arguments)),completionInfo:o=>this.requiredResponse(this.getCompletions(o.arguments,"completionInfo")),completions:o=>this.requiredResponse(this.getCompletions(o.arguments,"completions")),"completions-full":o=>this.requiredResponse(this.getCompletions(o.arguments,"completions-full")),completionEntryDetails:o=>this.requiredResponse(this.getCompletionEntryDetails(o.arguments,!1)),"completionEntryDetails-full":o=>this.requiredResponse(this.getCompletionEntryDetails(o.arguments,!0)),compileOnSaveAffectedFileList:o=>this.requiredResponse(this.getCompileOnSaveAffectedFileList(o.arguments)),compileOnSaveEmitFile:o=>this.requiredResponse(this.emitFile(o.arguments)),signatureHelp:o=>this.requiredResponse(this.getSignatureHelpItems(o.arguments,!0)),"signatureHelp-full":o=>this.requiredResponse(this.getSignatureHelpItems(o.arguments,!1)),"compilerOptionsDiagnostics-full":o=>this.requiredResponse(this.getCompilerOptionsDiagnostics(o.arguments)),"encodedSyntacticClassifications-full":o=>this.requiredResponse(this.getEncodedSyntacticClassifications(o.arguments)),"encodedSemanticClassifications-full":o=>this.requiredResponse(this.getEncodedSemanticClassifications(o.arguments)),cleanup:()=>(this.cleanup(),this.requiredResponse(!0)),semanticDiagnosticsSync:o=>this.requiredResponse(this.getSemanticDiagnosticsSync(o.arguments)),syntacticDiagnosticsSync:o=>this.requiredResponse(this.getSyntacticDiagnosticsSync(o.arguments)),suggestionDiagnosticsSync:o=>this.requiredResponse(this.getSuggestionDiagnosticsSync(o.arguments)),geterr:o=>(this.errorCheck.startNew(u=>this.getDiagnostics(u,o.arguments.delay,o.arguments.files)),this.notRequired()),geterrForProject:o=>(this.errorCheck.startNew(u=>this.getDiagnosticsForProject(u,o.arguments.delay,o.arguments.file)),this.notRequired()),change:o=>(this.change(o.arguments),this.notRequired()),configure:o=>(this.projectService.setHostConfiguration(o.arguments),this.doOutput(void 0,"configure",o.seq,!0),this.notRequired()),reload:o=>(this.reload(o.arguments,o.seq),this.requiredResponse({reloadFinished:!0})),saveto:o=>{let u=o.arguments;return this.saveToTmp(u.file,u.tmpfile),this.notRequired()},close:o=>{let u=o.arguments;return this.closeClientFile(u.file),this.notRequired()},navto:o=>this.requiredResponse(this.getNavigateToItems(o.arguments,!0)),"navto-full":o=>this.requiredResponse(this.getNavigateToItems(o.arguments,!1)),brace:o=>this.requiredResponse(this.getBraceMatching(o.arguments,!0)),"brace-full":o=>this.requiredResponse(this.getBraceMatching(o.arguments,!1)),navbar:o=>this.requiredResponse(this.getNavigationBarItems(o.arguments,!0)),"navbar-full":o=>this.requiredResponse(this.getNavigationBarItems(o.arguments,!1)),navtree:o=>this.requiredResponse(this.getNavigationTree(o.arguments,!0)),"navtree-full":o=>this.requiredResponse(this.getNavigationTree(o.arguments,!1)),documentHighlights:o=>this.requiredResponse(this.getDocumentHighlights(o.arguments,!0)),"documentHighlights-full":o=>this.requiredResponse(this.getDocumentHighlights(o.arguments,!1)),compilerOptionsForInferredProjects:o=>(this.setCompilerOptionsForInferredProjects(o.arguments),this.requiredResponse(!0)),projectInfo:o=>this.requiredResponse(this.getProjectInfo(o.arguments)),reloadProjects:()=>(this.projectService.reloadProjects(),this.notRequired()),jsxClosingTag:o=>this.requiredResponse(this.getJsxClosingTag(o.arguments)),linkedEditingRange:o=>this.requiredResponse(this.getLinkedEditingRange(o.arguments)),getCodeFixes:o=>this.requiredResponse(this.getCodeFixes(o.arguments,!0)),"getCodeFixes-full":o=>this.requiredResponse(this.getCodeFixes(o.arguments,!1)),getCombinedCodeFix:o=>this.requiredResponse(this.getCombinedCodeFix(o.arguments,!0)),"getCombinedCodeFix-full":o=>this.requiredResponse(this.getCombinedCodeFix(o.arguments,!1)),applyCodeActionCommand:o=>this.requiredResponse(this.applyCodeActionCommand(o.arguments)),getSupportedCodeFixes:o=>this.requiredResponse(this.getSupportedCodeFixes(o.arguments)),getApplicableRefactors:o=>this.requiredResponse(this.getApplicableRefactors(o.arguments)),getEditsForRefactor:o=>this.requiredResponse(this.getEditsForRefactor(o.arguments,!0)),getMoveToRefactoringFileSuggestions:o=>this.requiredResponse(this.getMoveToRefactoringFileSuggestions(o.arguments)),getPasteEdits:o=>this.requiredResponse(this.getPasteEdits(o.arguments)),"getEditsForRefactor-full":o=>this.requiredResponse(this.getEditsForRefactor(o.arguments,!1)),organizeImports:o=>this.requiredResponse(this.organizeImports(o.arguments,!0)),"organizeImports-full":o=>this.requiredResponse(this.organizeImports(o.arguments,!1)),getEditsForFileRename:o=>this.requiredResponse(this.getEditsForFileRename(o.arguments,!0)),"getEditsForFileRename-full":o=>this.requiredResponse(this.getEditsForFileRename(o.arguments,!1)),configurePlugin:o=>(this.configurePlugin(o.arguments),this.doOutput(void 0,"configurePlugin",o.seq,!0),this.notRequired()),selectionRange:o=>this.requiredResponse(this.getSmartSelectionRange(o.arguments,!0)),"selectionRange-full":o=>this.requiredResponse(this.getSmartSelectionRange(o.arguments,!1)),prepareCallHierarchy:o=>this.requiredResponse(this.prepareCallHierarchy(o.arguments)),provideCallHierarchyIncomingCalls:o=>this.requiredResponse(this.provideCallHierarchyIncomingCalls(o.arguments)),provideCallHierarchyOutgoingCalls:o=>this.requiredResponse(this.provideCallHierarchyOutgoingCalls(o.arguments)),toggleLineComment:o=>this.requiredResponse(this.toggleLineComment(o.arguments,!0)),"toggleLineComment-full":o=>this.requiredResponse(this.toggleLineComment(o.arguments,!1)),toggleMultilineComment:o=>this.requiredResponse(this.toggleMultilineComment(o.arguments,!0)),"toggleMultilineComment-full":o=>this.requiredResponse(this.toggleMultilineComment(o.arguments,!1)),commentSelection:o=>this.requiredResponse(this.commentSelection(o.arguments,!0)),"commentSelection-full":o=>this.requiredResponse(this.commentSelection(o.arguments,!1)),uncommentSelection:o=>this.requiredResponse(this.uncommentSelection(o.arguments,!0)),"uncommentSelection-full":o=>this.requiredResponse(this.uncommentSelection(o.arguments,!1)),provideInlayHints:o=>this.requiredResponse(this.provideInlayHints(o.arguments)),mapCode:o=>this.requiredResponse(this.mapCode(o.arguments))})),this.host=t.host,this.cancellationToken=t.cancellationToken,this.typingsInstaller=t.typingsInstaller||ate,this.byteLength=t.byteLength,this.hrtime=t.hrtime,this.logger=t.logger,this.canUseEvents=t.canUseEvents,this.suppressDiagnosticEvents=t.suppressDiagnosticEvents,this.noGetErrOnBackgroundUpdate=t.noGetErrOnBackgroundUpdate;let{throttleWaitMilliseconds:n}=t;this.eventHandler=this.canUseEvents?t.eventHandler||(o=>this.defaultEventHandler(o)):void 0;let i={executeWithRequestId:(o,u)=>this.executeWithRequestId(o,u),getCurrentRequestId:()=>this.currentRequestId,getServerHost:()=>this.host,logError:(o,u)=>this.logError(o,u),sendRequestCompletedEvent:o=>this.sendRequestCompletedEvent(o),isCancellationRequested:()=>this.cancellationToken.isCancellationRequested()};this.errorCheck=new URt(i);let s={host:this.host,logger:this.logger,cancellationToken:this.cancellationToken,useSingleInferredProject:t.useSingleInferredProject,useInferredProjectPerProjectRoot:t.useInferredProjectPerProjectRoot,typingsInstaller:this.typingsInstaller,throttleWaitMilliseconds:n,eventHandler:this.eventHandler,suppressDiagnosticEvents:this.suppressDiagnosticEvents,globalPlugins:t.globalPlugins,pluginProbeLocations:t.pluginProbeLocations,allowLocalPluginLoads:t.allowLocalPluginLoads,typesMapLocation:t.typesMapLocation,serverMode:t.serverMode,session:this,canUseWatchEvents:t.canUseWatchEvents,incrementalVerifier:t.incrementalVerifier};switch(this.projectService=new bEe(s),this.projectService.setPerformanceEventHandler(this.performanceEventHandler.bind(this)),this.gcTimer=new YTe(this.host,7e3,this.logger),this.projectService.serverMode){case 0:break;case 1:Rze.forEach(o=>this.handlers.set(o,u=>{throw new Error(`Request: ${u.command} not allowed in LanguageServiceMode.PartialSemantic`)}));break;case 2:GRt.forEach(o=>this.handlers.set(o,u=>{throw new Error(`Request: ${u.command} not allowed in LanguageServiceMode.Syntactic`)}));break;default:M.assertNever(this.projectService.serverMode)}}sendRequestCompletedEvent(t){this.event({request_seq:t},"requestCompleted")}addPerformanceData(t,n){this.performanceData||(this.performanceData={}),this.performanceData[t]=(this.performanceData[t]??0)+n}performanceEventHandler(t){switch(t.kind){case"UpdateGraph":this.addPerformanceData("updateGraphDurationMs",t.durationMs);break;case"CreatePackageJsonAutoImportProvider":this.addPerformanceData("createAutoImportProviderProgramDurationMs",t.durationMs);break}}defaultEventHandler(t){switch(t.eventName){case nJ:this.projectsUpdatedInBackgroundEvent(t.data.openFiles);break;case ute:this.event({projectName:t.data.project.getProjectName(),reason:t.data.reason},t.eventName);break;case _te:this.event({projectName:t.data.project.getProjectName()},t.eventName);break;case fte:case gte:case hte:case yte:this.event(t.data,t.eventName);break;case pte:this.event({triggerFile:t.data.triggerFile,configFile:t.data.configFileName,diagnostics:Cr(t.data.diagnostics,n=>_7(n,!0))},t.eventName);break;case dte:{this.event({projectName:t.data.project.getProjectName(),languageServiceEnabled:t.data.languageServiceEnabled},t.eventName);break}case mte:{this.event({telemetryEventName:t.eventName,payload:t.data},"telemetry");break}}}projectsUpdatedInBackgroundEvent(t){this.projectService.logger.info(`got projects updated in background ${t}`),t.length&&(!this.suppressDiagnosticEvents&&!this.noGetErrOnBackgroundUpdate&&(this.projectService.logger.info(`Queueing diagnostics update for ${t}`),this.errorCheck.startNew(n=>this.updateErrorCheck(n,t,100,!0))),this.event({openFiles:t},nJ))}logError(t,n){this.logErrorWorker(t,n)}logErrorWorker(t,n,i){let s="Exception on executing command "+n;if(t.message&&(s+=`:
`+f6(t.message),t.stack&&(s+=`
`+f6(t.stack))),this.logger.hasLevel(3)){if(i)try{let{file:o,project:u}=this.getFileAndProject(i),m=u.getScriptInfoForNormalizedPath(o);if(m){let d=sk(m.getSnapshot());s+=`

File text of ${i.file}:${f6(d)}
`}}catch{}if(t.ProgramFiles){s+=`

Program files: ${JSON.stringify(t.ProgramFiles)}
`,s+=`

Projects::
`;let o=0,u=m=>{s+=`
Project '${m.projectName}' (${a7[m.projectKind]}) ${o}
`,s+=m.filesToString(!0),s+=`
-----------------------------------------------
`,o++};this.projectService.externalProjects.forEach(u),this.projectService.configuredProjects.forEach(u),this.projectService.inferredProjects.forEach(u)}}this.logger.msg(s,"Err")}send(t){if(t.type==="event"&&!this.canUseEvents){this.logger.hasLevel(3)&&this.logger.info(`Session does not support events: ignored event: ${Ob(t)}`);return}this.writeMessage(t)}writeMessage(t){var n;let i=AEe(t,this.logger,this.byteLength,this.host.newLine);(n=rf)==null||n.logEvent(`Response message size: ${i.length}`),this.host.write(i)}event(t,n){this.send(kEe(n,t))}doOutput(t,n,i,s,o){let u={seq:0,type:"response",command:n,request_seq:i,success:s,performanceData:this.performanceData};if(s){let m;if(Rs(t))u.body=t,m=t.metadata,delete t.metadata;else if(typeof t=="object")if(t.metadata){let{metadata:d,...S}=t;u.body=S,m=d}else u.body=t;else u.body=t;m&&(u.metadata=m)}else M.assert(t===void 0);o&&(u.message=o),this.send(u)}semanticCheck(t,n){var i,s;(i=Cn)==null||i.push(Cn.Phase.Session,"semanticCheck",{file:t,configFilePath:n.canonicalConfigFilePath});let o=Pze(n,t)?su:n.getLanguageService().getSemanticDiagnostics(t).filter(u=>!!u.file);this.sendDiagnosticsEvent(t,n,o,"semanticDiag"),(s=Cn)==null||s.pop()}syntacticCheck(t,n){var i,s;(i=Cn)==null||i.push(Cn.Phase.Session,"syntacticCheck",{file:t,configFilePath:n.canonicalConfigFilePath}),this.sendDiagnosticsEvent(t,n,n.getLanguageService().getSyntacticDiagnostics(t),"syntaxDiag"),(s=Cn)==null||s.pop()}suggestionCheck(t,n){var i,s;(i=Cn)==null||i.push(Cn.Phase.Session,"suggestionCheck",{file:t,configFilePath:n.canonicalConfigFilePath}),this.sendDiagnosticsEvent(t,n,n.getLanguageService().getSuggestionDiagnostics(t),"suggestionDiag"),(s=Cn)==null||s.pop()}sendDiagnosticsEvent(t,n,i,s){try{this.event({file:t,diagnostics:i.map(o=>Nze(t,n,o))},s)}catch(o){this.logError(o,s)}}updateErrorCheck(t,n,i,s=!0){M.assert(!this.suppressDiagnosticEvents);let o=this.changeSeq,u=Math.min(i,200),m=0,d=()=>{m++,n.length>m&&t.delay("checkOne",u,S)},S=()=>{if(this.changeSeq!==o)return;let E=n[m];if(bs(E)&&(E=this.toPendingErrorCheck(E),!E)){d();return}let{fileName:x,project:D}=E;if(Dd(D),!!D.containsFile(x,s)&&(this.syntacticCheck(x,D),this.changeSeq===o)){if(D.projectService.serverMode!==0){d();return}t.immediate("semanticCheck",()=>{if(this.semanticCheck(x,D),this.changeSeq===o){if(this.getPreferences(x).disableSuggestions){d();return}t.immediate("suggestionCheck",()=>{this.suggestionCheck(x,D),d()})}})}};n.length>m&&this.changeSeq===o&&t.delay("checkOne",i,S)}cleanProjects(t,n){if(n){this.logger.info(`cleaning ${t}`);for(let i of n)i.getLanguageService(!1).cleanupSemanticCache(),i.cleanupProgram()}}cleanup(){this.cleanProjects("inferred projects",this.projectService.inferredProjects),this.cleanProjects("configured projects",Is(this.projectService.configuredProjects.values())),this.cleanProjects("external projects",this.projectService.externalProjects),this.host.gc&&(this.logger.info("host.gc()"),this.host.gc())}getEncodedSyntacticClassifications(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t);return i.getEncodedSyntacticClassifications(n,t)}getEncodedSemanticClassifications(t){let{file:n,project:i}=this.getFileAndProject(t),s=t.format==="2020"?"2020":"original";return i.getLanguageService().getEncodedSemanticClassifications(n,t,s)}getProject(t){return t===void 0?void 0:this.projectService.findProject(t)}getConfigFileAndProject(t){let n=this.getProject(t.projectFileName),i=Dc(t.file);return{configFile:n&&n.hasConfigFile(i)?i:void 0,project:n}}getConfigFileDiagnostics(t,n,i){let s=n.getAllProjectErrors(),o=n.getLanguageService().getCompilerOptionsDiagnostics(),u=Zn(ps(s,o),m=>!!m.file&&m.file.fileName===t);return i?this.convertToDiagnosticsWithLinePositionFromDiagnosticFile(u):Cr(u,m=>_7(m,!1))}convertToDiagnosticsWithLinePositionFromDiagnosticFile(t){return t.map(n=>({message:Zg(n.messageText,this.host.newLine),start:n.start,length:n.length,category:Bx(n),code:n.code,source:n.source,startLocation:n.file&&fD(ba(n.file,n.start)),endLocation:n.file&&fD(ba(n.file,n.start+n.length)),reportsUnnecessary:n.reportsUnnecessary,reportsDeprecated:n.reportsDeprecated,relatedInformation:Cr(n.relatedInformation,Ate)}))}getCompilerOptionsDiagnostics(t){let n=this.getProject(t.projectFileName);return this.convertToDiagnosticsWithLinePosition(Zn(n.getLanguageService().getCompilerOptionsDiagnostics(),i=>!i.file),void 0)}convertToDiagnosticsWithLinePosition(t,n){return t.map(i=>({message:Zg(i.messageText,this.host.newLine),start:i.start,length:i.length,category:Bx(i),code:i.code,source:i.source,startLocation:n&&n.positionToLineOffset(i.start),endLocation:n&&n.positionToLineOffset(i.start+i.length),reportsUnnecessary:i.reportsUnnecessary,reportsDeprecated:i.reportsDeprecated,relatedInformation:Cr(i.relatedInformation,Ate)}))}getDiagnosticsWorker(t,n,i,s){let{project:o,file:u}=this.getFileAndProject(t);if(n&&Pze(o,u))return su;let m=o.getScriptInfoForNormalizedPath(u),d=i(o,u);return s?this.convertToDiagnosticsWithLinePosition(d,m):d.map(S=>Nze(u,o,S))}getDefinition(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=this.getPositionInFile(t,i),u=this.mapDefinitionInfoLocations(s.getLanguageService().getDefinitionAtPosition(i,o)||su,s);return n?this.mapDefinitionInfo(u,s):u.map(Wae.mapToOriginalLocation)}mapDefinitionInfoLocations(t,n){return t.map(i=>{let s=Oze(i,n);return s?{...s,containerKind:i.containerKind,containerName:i.containerName,kind:i.kind,name:i.name,failedAliasResolution:i.failedAliasResolution,...i.unverified&&{unverified:i.unverified}}:i})}getDefinitionAndBoundSpan(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=this.getPositionInFile(t,i),u=M.checkDefined(s.getScriptInfo(i)),m=s.getLanguageService().getDefinitionAndBoundSpan(i,o);if(!m||!m.definitions)return{definitions:su,textSpan:void 0};let d=this.mapDefinitionInfoLocations(m.definitions,s),{textSpan:S}=m;return n?{definitions:this.mapDefinitionInfo(d,s),textSpan:Hh(S,u)}:{definitions:d.map(Wae.mapToOriginalLocation),textSpan:S}}findSourceDefinition(t){var n;let{file:i,project:s}=this.getFileAndProject(t),o=this.getPositionInFile(t,i),u=s.getLanguageService().getDefinitionAtPosition(i,o),m=this.mapDefinitionInfoLocations(u||su,s).slice();if(this.projectService.serverMode===0&&(!Pt(m,w=>Dc(w.fileName)!==i&&!w.isAmbient)||Pt(m,w=>!!w.failedAliasResolution))){let w=RW(J=>J.textSpan.start,MQ(this.host.useCaseSensitiveFileNames));m?.forEach(J=>w.add(J));let R=s.getNoDtsResolutionProject(i),L=R.getLanguageService(),F=(n=L.getDefinitionAtPosition(i,o,!0,!1))==null?void 0:n.filter(J=>Dc(J.fileName)!==i);if(Pt(F))for(let J of F){if(J.unverified){let G=x(J,s.getLanguageService().getProgram(),L.getProgram());if(Pt(G)){for(let q of G)w.add(q);continue}}w.add(J)}else{let J=m.filter(G=>Dc(G.fileName)!==i&&G.isAmbient);for(let G of Pt(J)?J:E()){let q=S(G.fileName,i,R);if(!q)continue;let ee=this.projectService.getOrCreateScriptInfoNotOpenedByClient(q,R.currentDirectory,R.directoryStructureHost,!1);if(!ee)continue;R.containsScriptInfo(ee)||(R.addRoot(ee),R.updateGraph());let W=L.getProgram(),pe=M.checkDefined(W.getSourceFile(q));for(let K of D(G.name,pe,W))w.add(K)}}m=Is(w.values())}return m=m.filter(w=>!w.isAmbient&&!w.failedAliasResolution),this.mapDefinitionInfo(m,s);function S(w,R,L){var F,J,G;let q=dj(w);if(q&&w.lastIndexOf(jy)===q.topLevelNodeModulesIndex){let ee=w.substring(0,q.packageRootIndex),W=(F=s.getModuleResolutionCache())==null?void 0:F.getPackageJsonInfoCache(),pe=s.getCompilationSettings(),K=HO(xs(ee+"/package.json",s.getCurrentDirectory()),$O(W,s,pe));if(!K)return;let re=aK(K,{moduleResolution:2},s,s.getModuleResolutionCache()),ue=w.substring(q.topLevelPackageNameIndex+1,q.packageRootIndex),ce=GO(M8(ue)),ne=s.toPath(w);if(re&&Pt(re,le=>s.toPath(le)===ne))return(J=L.resolutionCache.resolveSingleModuleNameWithoutWatching(ce,R).resolvedModule)==null?void 0:J.resolvedFileName;{let le=w.substring(q.packageRootIndex+1),me=`${ce}/${of(le)}`;return(G=L.resolutionCache.resolveSingleModuleNameWithoutWatching(me,R).resolvedModule)==null?void 0:G.resolvedFileName}}}function E(){let w=s.getLanguageService(),R=w.getProgram(),L=wf(R.getSourceFile(i),o);return(No(L)||He(L))&&oc(L.parent)&&rpe(L,F=>{var J;if(F===L)return;let G=(J=w.getDefinitionAtPosition(i,F.getStart(),!0,!1))==null?void 0:J.filter(q=>Dc(q.fileName)!==i&&q.isAmbient).map(q=>({fileName:q.fileName,name:Qd(L)}));if(Pt(G))return G})||su}function x(w,R,L){var F;let J=L.getSourceFile(w.fileName);if(!J)return;let G=wf(R.getSourceFile(i),o),q=R.getTypeChecker().getSymbolAtLocation(G),ee=q&&Pc(q,276);if(!ee)return;let W=((F=ee.propertyName)==null?void 0:F.text)||ee.name.text;return D(W,J,L)}function D(w,R,L){let F=lc.Core.getTopMostDeclarationNamesInFile(w,R);return Gi(F,J=>{let G=L.getTypeChecker().getSymbolAtLocation(J),q=jI(J);if(G&&q)return oD.createDefinitionInfo(q,L.getTypeChecker(),G,q,!0)})}}getEmitOutput(t){let{file:n,project:i}=this.getFileAndProject(t);if(!i.shouldEmitFile(i.getScriptInfo(n)))return{emitSkipped:!0,outputFiles:[],diagnostics:[]};let s=i.getLanguageService().getEmitOutput(n);return t.richResponse?{...s,diagnostics:t.includeLinePosition?this.convertToDiagnosticsWithLinePositionFromDiagnosticFile(s.diagnostics):s.diagnostics.map(o=>_7(o,!0))}:s}mapJSDocTagInfo(t,n,i){return t?t.map(s=>{var o;return{...s,text:i?this.mapDisplayParts(s.text,n):(o=s.text)==null?void 0:o.map(u=>u.text).join("")}}):[]}mapDisplayParts(t,n){return t?t.map(i=>i.kind!=="linkName"?i:{...i,target:this.toFileSpan(i.target.fileName,i.target.textSpan,n)}):[]}mapSignatureHelpItems(t,n,i){return t.map(s=>({...s,documentation:this.mapDisplayParts(s.documentation,n),parameters:s.parameters.map(o=>({...o,documentation:this.mapDisplayParts(o.documentation,n)})),tags:this.mapJSDocTagInfo(s.tags,n,i)}))}mapDefinitionInfo(t,n){return t.map(i=>({...this.toFileSpanWithContext(i.fileName,i.textSpan,i.contextSpan,n),...i.unverified&&{unverified:i.unverified}}))}static mapToOriginalLocation(t){return t.originalFileName?(M.assert(t.originalTextSpan!==void 0,"originalTextSpan should be present if originalFileName is"),{...t,fileName:t.originalFileName,textSpan:t.originalTextSpan,targetFileName:t.fileName,targetTextSpan:t.textSpan,contextSpan:t.originalContextSpan,targetContextSpan:t.contextSpan}):t}toFileSpan(t,n,i){let s=i.getLanguageService(),o=s.toLineColumnOffset(t,n.start),u=s.toLineColumnOffset(t,bl(n));return{file:t,start:{line:o.line+1,offset:o.character+1},end:{line:u.line+1,offset:u.character+1}}}toFileSpanWithContext(t,n,i,s){let o=this.toFileSpan(t,n,s),u=i&&this.toFileSpan(t,i,s);return u?{...o,contextStart:u.start,contextEnd:u.end}:o}getTypeDefinition(t){let{file:n,project:i}=this.getFileAndProject(t),s=this.getPositionInFile(t,n),o=this.mapDefinitionInfoLocations(i.getLanguageService().getTypeDefinitionAtPosition(n,s)||su,i);return this.mapDefinitionInfo(o,i)}mapImplementationLocations(t,n){return t.map(i=>{let s=Oze(i,n);return s?{...s,kind:i.kind,displayParts:i.displayParts}:i})}getImplementation(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=this.getPositionInFile(t,i),u=this.mapImplementationLocations(s.getLanguageService().getImplementationAtPosition(i,o)||su,s);return n?u.map(({fileName:m,textSpan:d,contextSpan:S})=>this.toFileSpanWithContext(m,d,S,s)):u.map(Wae.mapToOriginalLocation)}getSyntacticDiagnosticsSync(t){let{configFile:n}=this.getConfigFileAndProject(t);return n?su:this.getDiagnosticsWorker(t,!1,(i,s)=>i.getLanguageService().getSyntacticDiagnostics(s),!!t.includeLinePosition)}getSemanticDiagnosticsSync(t){let{configFile:n,project:i}=this.getConfigFileAndProject(t);return n?this.getConfigFileDiagnostics(n,i,!!t.includeLinePosition):this.getDiagnosticsWorker(t,!0,(s,o)=>s.getLanguageService().getSemanticDiagnostics(o).filter(u=>!!u.file),!!t.includeLinePosition)}getSuggestionDiagnosticsSync(t){let{configFile:n}=this.getConfigFileAndProject(t);return n?su:this.getDiagnosticsWorker(t,!0,(i,s)=>i.getLanguageService().getSuggestionDiagnostics(s),!!t.includeLinePosition)}getJsxClosingTag(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.getPositionInFile(t,n),o=i.getJsxClosingTagAtPosition(n,s);return o===void 0?void 0:{newText:o.newText,caretOffset:0}}getLinkedEditingRange(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.getPositionInFile(t,n),o=i.getLinkedEditingRangeAtPosition(n,s),u=this.projectService.getScriptInfoForNormalizedPath(n);if(!(u===void 0||o===void 0))return KRt(o,u)}getDocumentHighlights(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=this.getPositionInFile(t,i),u=s.getLanguageService().getDocumentHighlights(i,o,t.filesToSearch);return u?n?u.map(({fileName:m,highlightSpans:d})=>{let S=s.getScriptInfo(m);return{file:m,highlightSpans:d.map(({textSpan:E,kind:x,contextSpan:D})=>({...NEe(E,D,S),kind:x}))}}):u:su}provideInlayHints(t){let{file:n,project:i}=this.getFileAndProject(t),s=this.projectService.getScriptInfoForNormalizedPath(n);return i.getLanguageService().provideInlayHints(n,t,this.getPreferences(n)).map(u=>{let{position:m,displayParts:d}=u;return{...u,position:s.positionToLineOffset(m),displayParts:d?.map(({text:S,span:E,file:x})=>{if(E){M.assertIsDefined(x,"Target file should be defined together with its span.");let D=this.projectService.getScriptInfo(x);return{text:S,span:{start:D.positionToLineOffset(E.start),end:D.positionToLineOffset(E.start+E.length),file:x}}}else return{text:S}})}})}mapCode(t){var n;let i=this.getHostFormatOptions(),s=this.getHostPreferences(),{file:o,languageService:u}=this.getFileAndLanguageServiceForSyntacticOperation(t),m=this.projectService.getScriptInfoForNormalizedPath(o),d=(n=t.mapping.focusLocations)==null?void 0:n.map(E=>E.map(x=>{let D=m.lineOffsetToPosition(x.start.line,x.start.offset),w=m.lineOffsetToPosition(x.end.line,x.end.offset);return{start:D,length:w-D}})),S=u.mapCode(o,t.mapping.contents,d,i,s);return this.mapTextChangesToCodeEdits(S)}setCompilerOptionsForInferredProjects(t){this.projectService.setCompilerOptionsForInferredProjects(t.options,t.projectRootPath)}getProjectInfo(t){return this.getProjectInfoWorker(t.file,t.projectFileName,t.needFileNameList,!1)}getProjectInfoWorker(t,n,i,s){let{project:o}=this.getFileAndProjectWorker(t,n);return Dd(o),{configFileName:o.getProjectName(),languageServiceDisabled:!o.languageServiceEnabled,fileNames:i?o.getFileNames(!1,s):void 0}}getRenameInfo(t){let{file:n,project:i}=this.getFileAndProject(t),s=this.getPositionInFile(t,n),o=this.getPreferences(n);return i.getLanguageService().getRenameInfo(n,s,o)}getProjects(t,n,i){let s,o;if(t.projectFileName){let u=this.getProject(t.projectFileName);u&&(s=[u])}else{let u=n?this.projectService.getScriptInfoEnsuringProjectsUptoDate(t.file):this.projectService.getScriptInfo(t.file);if(u)n||this.projectService.ensureDefaultProjectForFile(u);else return i?su:(this.projectService.logErrorForScriptInfoNotFound(t.file),I0.ThrowNoProject());s=u.containingProjects,o=this.projectService.getSymlinkedProjects(u)}return s=Zn(s,u=>u.languageServiceEnabled&&!u.isOrphan()),!i&&(!s||!s.length)&&!o?(this.projectService.logErrorForScriptInfoNotFound(t.file??t.projectFileName),I0.ThrowNoProject()):o?{projects:s,symLinkedProjects:o}:s}getDefaultProject(t){if(t.projectFileName){let i=this.getProject(t.projectFileName);if(i)return i;if(!t.file)return I0.ThrowNoProject()}return this.projectService.getScriptInfo(t.file).getDefaultProject()}getRenameLocations(t,n){let i=Dc(t.file),s=this.getPositionInFile(t,i),o=this.getProjects(t),u=this.getDefaultProject(t),m=this.getPreferences(i),d=this.mapRenameInfo(u.getLanguageService().getRenameInfo(i,s,m),M.checkDefined(this.projectService.getScriptInfo(i)));if(!d.canRename)return n?{info:d,locs:[]}:[];let S=JRt(o,u,{fileName:t.file,pos:s},!!t.findInStrings,!!t.findInComments,m,this.host.useCaseSensitiveFileNames);return n?{info:d,locs:this.toSpanGroups(S)}:S}mapRenameInfo(t,n){if(t.canRename){let{canRename:i,fileToRename:s,displayName:o,fullDisplayName:u,kind:m,kindModifiers:d,triggerSpan:S}=t;return{canRename:i,fileToRename:s,displayName:o,fullDisplayName:u,kind:m,kindModifiers:d,triggerSpan:Hh(S,n)}}else return t}toSpanGroups(t){let n=new Map;for(let{fileName:i,textSpan:s,contextSpan:o,originalContextSpan:u,originalTextSpan:m,originalFileName:d,...S}of t){let E=n.get(i);E||n.set(i,E={file:i,locs:[]});let x=M.checkDefined(this.projectService.getScriptInfo(i));E.locs.push({...NEe(s,o,x),...S})}return Is(n.values())}getReferences(t,n){let i=Dc(t.file),s=this.getProjects(t),o=this.getPositionInFile(t,i),u=zRt(s,this.getDefaultProject(t),{fileName:t.file,pos:o},this.host.useCaseSensitiveFileNames,this.logger);if(!n)return u;let m=this.getPreferences(i),d=this.getDefaultProject(t),S=d.getScriptInfoForNormalizedPath(i),E=d.getLanguageService().getQuickInfoAtPosition(i,o),x=E?MM(E.displayParts):"",D=E&&E.textSpan,w=D?S.positionToLineOffset(D.start).offset:0,R=D?S.getSnapshot().getText(D.start,bl(D)):"";return{refs:va(u,F=>F.references.map(J=>Fze(this.projectService,J,m))),symbolName:R,symbolStartOffset:w,symbolDisplayString:x}}getFileReferences(t,n){let i=this.getProjects(t),s=t.file,o=this.getPreferences(Dc(s)),u=[],m=kte(this.host.useCaseSensitiveFileNames);return PEe(i,void 0,S=>{if(S.getCancellationToken().isCancellationRequested())return;let E=S.getLanguageService().getFileReferences(s);if(E)for(let x of E)m.has(x)||(u.push(x),m.add(x))}),n?{refs:u.map(S=>Fze(this.projectService,S,o)),symbolName:`"${t.file}"`}:u}openClientFile(t,n,i,s){this.projectService.openClientFileWithNormalizedPath(t,n,i,!1,s)}getPosition(t,n){return t.position!==void 0?t.position:n.lineOffsetToPosition(t.line,t.offset)}getPositionInFile(t,n){let i=this.projectService.getScriptInfoForNormalizedPath(n);return this.getPosition(t,i)}getFileAndProject(t){return this.getFileAndProjectWorker(t.file,t.projectFileName)}getFileAndLanguageServiceForSyntacticOperation(t){let{file:n,project:i}=this.getFileAndProject(t);return{file:n,languageService:i.getLanguageService(!1)}}getFileAndProjectWorker(t,n){let i=Dc(t),s=this.getProject(n)||this.projectService.ensureDefaultProjectForFile(i);return{file:i,project:s}}getOutliningSpans(t,n){let{file:i,languageService:s}=this.getFileAndLanguageServiceForSyntacticOperation(t),o=s.getOutliningSpans(i);if(n){let u=this.projectService.getScriptInfoForNormalizedPath(i);return o.map(m=>({textSpan:Hh(m.textSpan,u),hintSpan:Hh(m.hintSpan,u),bannerText:m.bannerText,autoCollapse:m.autoCollapse,kind:m.kind}))}else return o}getTodoComments(t){let{file:n,project:i}=this.getFileAndProject(t);return i.getLanguageService().getTodoComments(n,t.descriptors)}getDocCommentTemplate(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.getPositionInFile(t,n);return i.getDocCommentTemplateAtPosition(n,s,this.getPreferences(n),this.getFormatOptions(n))}getSpanOfEnclosingComment(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=t.onlyMultiLine,o=this.getPositionInFile(t,n);return i.getSpanOfEnclosingComment(n,o,s)}getIndentation(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.getPositionInFile(t,n),o=t.options?_D(t.options):this.getFormatOptions(n),u=i.getIndentationAtPosition(n,s,o);return{position:s,indentation:u}}getBreakpointStatement(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.getPositionInFile(t,n);return i.getBreakpointStatementAtPosition(n,s)}getNameOrDottedNameSpan(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.getPositionInFile(t,n);return i.getNameOrDottedNameSpan(n,s,s)}isValidBraceCompletion(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.getPositionInFile(t,n);return i.isValidBraceCompletionAtPosition(n,s,t.openingBrace.charCodeAt(0))}getQuickInfoWorker(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=this.projectService.getScriptInfoForNormalizedPath(i),u=s.getLanguageService().getQuickInfoAtPosition(i,this.getPosition(t,o));if(!u)return;let m=!!this.getPreferences(i).displayPartsForJSDoc;if(n){let d=MM(u.displayParts);return{kind:u.kind,kindModifiers:u.kindModifiers,start:o.positionToLineOffset(u.textSpan.start),end:o.positionToLineOffset(bl(u.textSpan)),displayString:d,documentation:m?this.mapDisplayParts(u.documentation,s):MM(u.documentation),tags:this.mapJSDocTagInfo(u.tags,s,m)}}else return m?u:{...u,tags:this.mapJSDocTagInfo(u.tags,s,!1)}}getFormattingEditsForRange(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.projectService.getScriptInfoForNormalizedPath(n),o=s.lineOffsetToPosition(t.line,t.offset),u=s.lineOffsetToPosition(t.endLine,t.endOffset),m=i.getFormattingEditsForRange(n,o,u,this.getFormatOptions(n));if(m)return m.map(d=>this.convertTextChangeToCodeEdit(d,s))}getFormattingEditsForRangeFull(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=t.options?_D(t.options):this.getFormatOptions(n);return i.getFormattingEditsForRange(n,t.position,t.endPosition,s)}getFormattingEditsForDocumentFull(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=t.options?_D(t.options):this.getFormatOptions(n);return i.getFormattingEditsForDocument(n,s)}getFormattingEditsAfterKeystrokeFull(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=t.options?_D(t.options):this.getFormatOptions(n);return i.getFormattingEditsAfterKeystroke(n,t.position,t.key,s)}getFormattingEditsAfterKeystroke(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.projectService.getScriptInfoForNormalizedPath(n),o=s.lineOffsetToPosition(t.line,t.offset),u=this.getFormatOptions(n),m=i.getFormattingEditsAfterKeystroke(n,o,t.key,u);if(t.key===`
`&&(!m||m.length===0||BRt(m,o))){let{lineText:d,absolutePosition:S}=s.textStorage.getAbsolutePositionAndLineText(t.line);if(d&&d.search("\\S")<0){let E=i.getIndentationAtPosition(n,o,u),x=0,D,w;for(D=0,w=d.length;D<w;D++)if(d.charAt(D)===" ")x++;else if(d.charAt(D)==="	")x+=u.tabSize;else break;if(E!==x){let R=S+D;m.push({span:Il(S,R),newText:zl.getIndentationString(E,u)})}}}if(m)return m.map(d=>({start:s.positionToLineOffset(d.span.start),end:s.positionToLineOffset(bl(d.span)),newText:d.newText?d.newText:""}))}getCompletions(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=this.projectService.getScriptInfoForNormalizedPath(i),u=this.getPosition(t,o),m=s.getLanguageService().getCompletionsAtPosition(i,u,{...pEe(this.getPreferences(i)),triggerCharacter:t.triggerCharacter,triggerKind:t.triggerKind,includeExternalModuleExports:t.includeExternalModuleExports,includeInsertTextCompletions:t.includeInsertTextCompletions},s.projectService.getFormatCodeOptions(i));if(m===void 0)return;if(n==="completions-full")return m;let d=t.prefix||"",S=Gi(m.entries,x=>{if(m.isMemberCompletion||_s(x.name.toLowerCase(),d.toLowerCase())){let{name:D,kind:w,kindModifiers:R,sortText:L,insertText:F,filterText:J,replacementSpan:G,hasAction:q,source:ee,sourceDisplay:W,labelDetails:pe,isSnippet:K,isRecommended:re,isPackageJsonImport:ue,isImportStatementCompletion:ce,data:ne}=x,le=G?Hh(G,o):void 0;return{name:D,kind:w,kindModifiers:R,sortText:L,insertText:F,filterText:J,replacementSpan:le,isSnippet:K,hasAction:q||void 0,source:ee,sourceDisplay:W,labelDetails:pe,isRecommended:re,isPackageJsonImport:ue,isImportStatementCompletion:ce,data:ne}}});return n==="completions"?(m.metadata&&(S.metadata=m.metadata),S):{...m,optionalReplacementSpan:m.optionalReplacementSpan&&Hh(m.optionalReplacementSpan,o),entries:S}}getCompletionEntryDetails(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=this.projectService.getScriptInfoForNormalizedPath(i),u=this.getPosition(t,o),m=s.projectService.getFormatCodeOptions(i),d=!!this.getPreferences(i).displayPartsForJSDoc,S=Gi(t.entryNames,E=>{let{name:x,source:D,data:w}=typeof E=="string"?{name:E,source:void 0,data:void 0}:E;return s.getLanguageService().getCompletionEntryDetails(i,u,x,m,D,this.getPreferences(i),w?aa(w,t8t):void 0)});return n?d?S:S.map(E=>({...E,tags:this.mapJSDocTagInfo(E.tags,s,!1)})):S.map(E=>({...E,codeActions:Cr(E.codeActions,x=>this.mapCodeAction(x)),documentation:this.mapDisplayParts(E.documentation,s),tags:this.mapJSDocTagInfo(E.tags,s,d)}))}getCompileOnSaveAffectedFileList(t){let n=this.getProjects(t,!0,!0),i=this.projectService.getScriptInfo(t.file);return i?VRt(i,s=>this.projectService.getScriptInfoForPath(s),n,(s,o)=>{if(!s.compileOnSaveEnabled||!s.languageServiceEnabled||s.isOrphan())return;let u=s.getCompilationSettings();if(!(u.noEmit||Mu(o.fileName)&&!jRt(u)))return{projectFileName:s.getProjectName(),fileNames:s.getCompileOnSaveAffectedFileList(o),projectUsesOutFile:!!u.outFile}}):su}emitFile(t){let{file:n,project:i}=this.getFileAndProject(t);if(i||I0.ThrowNoProject(),!i.languageServiceEnabled)return t.richResponse?{emitSkipped:!0,diagnostics:[]}:!1;let s=i.getScriptInfo(n),{emitSkipped:o,diagnostics:u}=i.emitFile(s,(m,d,S)=>this.host.writeFile(m,d,S));return t.richResponse?{emitSkipped:o,diagnostics:t.includeLinePosition?this.convertToDiagnosticsWithLinePositionFromDiagnosticFile(u):u.map(m=>_7(m,!0))}:!o}getSignatureHelpItems(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=this.projectService.getScriptInfoForNormalizedPath(i),u=this.getPosition(t,o),m=s.getLanguageService().getSignatureHelpItems(i,u,t),d=!!this.getPreferences(i).displayPartsForJSDoc;if(m&&n){let S=m.applicableSpan;return{...m,applicableSpan:{start:o.positionToLineOffset(S.start),end:o.positionToLineOffset(S.start+S.length)},items:this.mapSignatureHelpItems(m.items,s,d)}}else return d||!m?m:{...m,items:m.items.map(S=>({...S,tags:this.mapJSDocTagInfo(S.tags,s,!1)}))}}toPendingErrorCheck(t){let n=Dc(t),i=this.projectService.tryGetDefaultProjectForFile(n);return i&&{fileName:n,project:i}}getDiagnostics(t,n,i){this.suppressDiagnosticEvents||i.length>0&&this.updateErrorCheck(t,i,n)}change(t){let n=this.projectService.getScriptInfo(t.file);M.assert(!!n),n.textStorage.switchToScriptVersionCache();let i=n.lineOffsetToPosition(t.line,t.offset),s=n.lineOffsetToPosition(t.endLine,t.endOffset);i>=0&&(this.changeSeq++,this.projectService.applyChangesToFile(n,XF({span:{start:i,length:s-i},newText:t.insertString})))}reload(t,n){let i=Dc(t.file),s=t.tmpfile===void 0?void 0:Dc(t.tmpfile),o=this.projectService.getScriptInfoForNormalizedPath(i);o&&(this.changeSeq++,o.reloadFromFile(s)&&this.doOutput(void 0,"reload",n,!0))}saveToTmp(t,n){let i=this.projectService.getScriptInfo(t);i&&i.saveTo(n)}closeClientFile(t){if(!t)return;let n=Zs(t);this.projectService.closeClientFile(n)}mapLocationNavigationBarItems(t,n){return Cr(t,i=>({text:i.text,kind:i.kind,kindModifiers:i.kindModifiers,spans:i.spans.map(s=>Hh(s,n)),childItems:this.mapLocationNavigationBarItems(i.childItems,n),indent:i.indent}))}getNavigationBarItems(t,n){let{file:i,languageService:s}=this.getFileAndLanguageServiceForSyntacticOperation(t),o=s.getNavigationBarItems(i);return o?n?this.mapLocationNavigationBarItems(o,this.projectService.getScriptInfoForNormalizedPath(i)):o:void 0}toLocationNavigationTree(t,n){return{text:t.text,kind:t.kind,kindModifiers:t.kindModifiers,spans:t.spans.map(i=>Hh(i,n)),nameSpan:t.nameSpan&&Hh(t.nameSpan,n),childItems:Cr(t.childItems,i=>this.toLocationNavigationTree(i,n))}}getNavigationTree(t,n){let{file:i,languageService:s}=this.getFileAndLanguageServiceForSyntacticOperation(t),o=s.getNavigationTree(i);return o?n?this.toLocationNavigationTree(o,this.projectService.getScriptInfoForNormalizedPath(i)):o:void 0}getNavigateToItems(t,n){let i=this.getFullNavigateToItems(t);return n?va(i,({project:s,navigateToItems:o})=>o.map(u=>{let m=s.getScriptInfo(u.fileName),d={name:u.name,kind:u.kind,kindModifiers:u.kindModifiers,isCaseSensitive:u.isCaseSensitive,matchKind:u.matchKind,file:u.fileName,start:m.positionToLineOffset(u.textSpan.start),end:m.positionToLineOffset(bl(u.textSpan))};return u.kindModifiers&&u.kindModifiers!==""&&(d.kindModifiers=u.kindModifiers),u.containerName&&u.containerName.length>0&&(d.containerName=u.containerName),u.containerKind&&u.containerKind.length>0&&(d.containerKind=u.containerKind),d})):va(i,({navigateToItems:s})=>s)}getFullNavigateToItems(t){let{currentFileOnly:n,searchValue:i,maxResultCount:s,projectFileName:o}=t;if(n){M.assertIsDefined(t.file);let{file:D,project:w}=this.getFileAndProject(t);return[{project:w,navigateToItems:w.getLanguageService().getNavigateToItems(i,s,D)}]}let u=this.getHostPreferences(),m=[],d=new Map;if(!t.file&&!o)this.projectService.loadAncestorProjectTree(),this.projectService.forEachEnabledProject(D=>S(D));else{let D=this.getProjects(t);PEe(D,void 0,w=>S(w))}return m;function S(D){let w=D.getLanguageService().getNavigateToItems(i,s,void 0,D.isNonTsProject(),u.excludeLibrarySymbolsInNavTo),R=Zn(w,L=>E(L)&&!Pte(U6(L),D));R.length&&m.push({project:D,navigateToItems:R})}function E(D){let w=D.name;if(!d.has(w))return d.set(w,[D]),!0;let R=d.get(w);for(let L of R)if(x(L,D))return!1;return R.push(D),!0}function x(D,w){return D===w?!0:!D||!w?!1:D.containerKind===w.containerKind&&D.containerName===w.containerName&&D.fileName===w.fileName&&D.isCaseSensitive===w.isCaseSensitive&&D.kind===w.kind&&D.kindModifiers===w.kindModifiers&&D.matchKind===w.matchKind&&D.name===w.name&&D.textSpan.start===w.textSpan.start&&D.textSpan.length===w.textSpan.length}}getSupportedCodeFixes(t){if(!t)return zZ();if(t.file){let{file:i,project:s}=this.getFileAndProject(t);return s.getLanguageService().getSupportedCodeFixes(i)}let n=this.getProject(t.projectFileName);return n||I0.ThrowNoProject(),n.getLanguageService().getSupportedCodeFixes()}isLocation(t){return t.line!==void 0}extractPositionOrRange(t,n){let i,s;return this.isLocation(t)?i=o(t):s=this.getRange(t,n),M.checkDefined(i===void 0?s:i);function o(u){return u.position!==void 0?u.position:n.lineOffsetToPosition(u.line,u.offset)}}getRange(t,n){let{startPosition:i,endPosition:s}=this.getStartAndEndPosition(t,n);return{pos:i,end:s}}getApplicableRefactors(t){let{file:n,project:i}=this.getFileAndProject(t),s=i.getScriptInfoForNormalizedPath(n);return i.getLanguageService().getApplicableRefactors(n,this.extractPositionOrRange(t,s),this.getPreferences(n),t.triggerReason,t.kind,t.includeInteractiveActions).map(u=>({...u,actions:u.actions.map(m=>({...m,range:m.range?{start:fD({line:m.range.start.line,character:m.range.start.offset}),end:fD({line:m.range.end.line,character:m.range.end.offset})}:void 0}))}))}getEditsForRefactor(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=s.getScriptInfoForNormalizedPath(i),u=s.getLanguageService().getEditsForRefactor(i,this.getFormatOptions(i),this.extractPositionOrRange(t,o),t.refactor,t.action,this.getPreferences(i),t.interactiveRefactorArguments);if(u===void 0)return{edits:[]};if(n){let{renameFilename:m,renameLocation:d,edits:S}=u,E;if(m!==void 0&&d!==void 0){let x=s.getScriptInfoForNormalizedPath(Dc(m));E=DEe(sk(x.getSnapshot()),m,d,S)}return{renameLocation:E,renameFilename:m,edits:this.mapTextChangesToCodeEdits(S),notApplicableReason:u.notApplicableReason}}return u}getMoveToRefactoringFileSuggestions(t){let{file:n,project:i}=this.getFileAndProject(t),s=i.getScriptInfoForNormalizedPath(n);return i.getLanguageService().getMoveToRefactoringFileSuggestions(n,this.extractPositionOrRange(t,s),this.getPreferences(n))}getPasteEdits(t){let{file:n,project:i}=this.getFileAndProject(t),s=t.copiedFrom?{file:t.copiedFrom.file,range:t.copiedFrom.spans.map(u=>this.getRange({file:t.copiedFrom.file,startLine:u.start.line,startOffset:u.start.offset,endLine:u.end.line,endOffset:u.end.offset},i.getScriptInfoForNormalizedPath(Dc(t.copiedFrom.file))))}:void 0,o=i.getLanguageService().getPasteEdits({targetFile:n,pastedText:t.pastedText,pasteLocations:t.pasteLocations.map(u=>this.getRange({file:n,startLine:u.start.line,startOffset:u.start.offset,endLine:u.end.line,endOffset:u.end.offset},i.getScriptInfoForNormalizedPath(n))),copiedFrom:s,preferences:this.getPreferences(n)},this.getFormatOptions(n));return o&&this.mapPasteEditsAction(o)}organizeImports(t,n){M.assert(t.scope.type==="file");let{file:i,project:s}=this.getFileAndProject(t.scope.args),o=s.getLanguageService().organizeImports({fileName:i,mode:t.mode??(t.skipDestructiveCodeActions?"SortAndCombine":void 0),type:"file"},this.getFormatOptions(i),this.getPreferences(i));return n?this.mapTextChangesToCodeEdits(o):o}getEditsForFileRename(t,n){let i=Dc(t.oldFilePath),s=Dc(t.newFilePath),o=this.getHostFormatOptions(),u=this.getHostPreferences(),m=new Set,d=[];return this.projectService.loadAncestorProjectTree(),this.projectService.forEachEnabledProject(S=>{let E=S.getLanguageService().getEditsForFileRename(i,s,o,u),x=[];for(let D of E)m.has(D.fileName)||(d.push(D),x.push(D.fileName));for(let D of x)m.add(D)}),n?d.map(S=>this.mapTextChangeToCodeEdit(S)):d}getCodeFixes(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=s.getScriptInfoForNormalizedPath(i),{startPosition:u,endPosition:m}=this.getStartAndEndPosition(t,o),d;try{d=s.getLanguageService().getCodeFixesAtPosition(i,u,m,t.errorCodes,this.getFormatOptions(i),this.getPreferences(i))}catch(S){let E=s.getLanguageService(),x=[...E.getSyntacticDiagnostics(i),...E.getSemanticDiagnostics(i),...E.getSuggestionDiagnostics(i)].map(w=>N3(u,m-u,w.start,w.length)&&w.code),D=t.errorCodes.find(w=>!x.includes(w));throw D!==void 0&&(S.message=`BADCLIENT: Bad error code, ${D} not found in range ${u}..${m} (found: ${x.join(", ")}); could have caused this error:
${S.message}`),S}return n?d.map(S=>this.mapCodeFixAction(S)):d}getCombinedCodeFix({scope:t,fixId:n},i){M.assert(t.type==="file");let{file:s,project:o}=this.getFileAndProject(t.args),u=o.getLanguageService().getCombinedCodeFix({type:"file",fileName:s},n,this.getFormatOptions(s),this.getPreferences(s));return i?{changes:this.mapTextChangesToCodeEdits(u.changes),commands:u.commands}:u}applyCodeActionCommand(t){let n=t.command;for(let i of VC(n)){let{file:s,project:o}=this.getFileAndProject(i);o.getLanguageService().applyCodeActionCommand(i,this.getFormatOptions(s)).then(u=>{},u=>{})}return{}}getStartAndEndPosition(t,n){let i,s;return t.startPosition!==void 0?i=t.startPosition:(i=n.lineOffsetToPosition(t.startLine,t.startOffset),t.startPosition=i),t.endPosition!==void 0?s=t.endPosition:(s=n.lineOffsetToPosition(t.endLine,t.endOffset),t.endPosition=s),{startPosition:i,endPosition:s}}mapCodeAction({description:t,changes:n,commands:i}){return{description:t,changes:this.mapTextChangesToCodeEdits(n),commands:i}}mapCodeFixAction({fixName:t,description:n,changes:i,commands:s,fixId:o,fixAllDescription:u}){return{fixName:t,description:n,changes:this.mapTextChangesToCodeEdits(i),commands:s,fixId:o,fixAllDescription:u}}mapPasteEditsAction({edits:t,fixId:n}){return{edits:this.mapTextChangesToCodeEdits(t),fixId:n}}mapTextChangesToCodeEdits(t){return t.map(n=>this.mapTextChangeToCodeEdit(n))}mapTextChangeToCodeEdit(t){let n=this.projectService.getScriptInfoOrConfig(t.fileName);return!!t.isNewFile==!!n&&(n||this.projectService.logErrorForScriptInfoNotFound(t.fileName),M.fail("Expected isNewFile for (only) new files. "+JSON.stringify({isNewFile:!!t.isNewFile,hasScriptInfo:!!n}))),n?{fileName:t.fileName,textChanges:t.textChanges.map(i=>YRt(i,n))}:QRt(t)}convertTextChangeToCodeEdit(t,n){return{start:n.positionToLineOffset(t.span.start),end:n.positionToLineOffset(t.span.start+t.span.length),newText:t.newText?t.newText:""}}getBraceMatching(t,n){let{file:i,languageService:s}=this.getFileAndLanguageServiceForSyntacticOperation(t),o=this.projectService.getScriptInfoForNormalizedPath(i),u=this.getPosition(t,o),m=s.getBraceMatchingAtPosition(i,u);return m?n?m.map(d=>Hh(d,o)):m:void 0}getDiagnosticsForProject(t,n,i){if(this.suppressDiagnosticEvents)return;let{fileNames:s,languageServiceDisabled:o}=this.getProjectInfoWorker(i,void 0,!0,!0);if(o)return;let u=s.filter(L=>!L.includes("lib.d.ts"));if(u.length===0)return;let m=[],d=[],S=[],E=[],x=Dc(i),D=this.projectService.ensureDefaultProjectForFile(x);for(let L of u)this.getCanonicalFileName(L)===this.getCanonicalFileName(i)?m.push(L):this.projectService.getScriptInfo(L).isScriptOpen()?d.push(L):Mu(L)?E.push(L):S.push(L);let R=[...m,...d,...S,...E].map(L=>({fileName:L,project:D}));this.updateErrorCheck(t,R,n,!1)}configurePlugin(t){this.projectService.configurePlugin(t)}getSmartSelectionRange(t,n){let{locations:i}=t,{file:s,languageService:o}=this.getFileAndLanguageServiceForSyntacticOperation(t),u=M.checkDefined(this.projectService.getScriptInfo(s));return Cr(i,m=>{let d=this.getPosition(m,u),S=o.getSmartSelectionRange(s,d);return n?this.mapSelectionRange(S,u):S})}toggleLineComment(t,n){let{file:i,languageService:s}=this.getFileAndLanguageServiceForSyntacticOperation(t),o=this.projectService.getScriptInfo(i),u=this.getRange(t,o),m=s.toggleLineComment(i,u);if(n){let d=this.projectService.getScriptInfoForNormalizedPath(i);return m.map(S=>this.convertTextChangeToCodeEdit(S,d))}return m}toggleMultilineComment(t,n){let{file:i,languageService:s}=this.getFileAndLanguageServiceForSyntacticOperation(t),o=this.projectService.getScriptInfoForNormalizedPath(i),u=this.getRange(t,o),m=s.toggleMultilineComment(i,u);if(n){let d=this.projectService.getScriptInfoForNormalizedPath(i);return m.map(S=>this.convertTextChangeToCodeEdit(S,d))}return m}commentSelection(t,n){let{file:i,languageService:s}=this.getFileAndLanguageServiceForSyntacticOperation(t),o=this.projectService.getScriptInfoForNormalizedPath(i),u=this.getRange(t,o),m=s.commentSelection(i,u);if(n){let d=this.projectService.getScriptInfoForNormalizedPath(i);return m.map(S=>this.convertTextChangeToCodeEdit(S,d))}return m}uncommentSelection(t,n){let{file:i,languageService:s}=this.getFileAndLanguageServiceForSyntacticOperation(t),o=this.projectService.getScriptInfoForNormalizedPath(i),u=this.getRange(t,o),m=s.uncommentSelection(i,u);if(n){let d=this.projectService.getScriptInfoForNormalizedPath(i);return m.map(S=>this.convertTextChangeToCodeEdit(S,d))}return m}mapSelectionRange(t,n){let i={textSpan:Hh(t.textSpan,n)};return t.parent&&(i.parent=this.mapSelectionRange(t.parent,n)),i}getScriptInfoFromProjectService(t){let n=Dc(t),i=this.projectService.getScriptInfoForNormalizedPath(n);return i||(this.projectService.logErrorForScriptInfoNotFound(n),I0.ThrowNoProject())}toProtocolCallHierarchyItem(t){let n=this.getScriptInfoFromProjectService(t.file);return{name:t.name,kind:t.kind,kindModifiers:t.kindModifiers,file:t.file,containerName:t.containerName,span:Hh(t.span,n),selectionSpan:Hh(t.selectionSpan,n)}}toProtocolCallHierarchyIncomingCall(t){let n=this.getScriptInfoFromProjectService(t.from.file);return{from:this.toProtocolCallHierarchyItem(t.from),fromSpans:t.fromSpans.map(i=>Hh(i,n))}}toProtocolCallHierarchyOutgoingCall(t,n){return{to:this.toProtocolCallHierarchyItem(t.to),fromSpans:t.fromSpans.map(i=>Hh(i,n))}}prepareCallHierarchy(t){let{file:n,project:i}=this.getFileAndProject(t),s=this.projectService.getScriptInfoForNormalizedPath(n);if(s){let o=this.getPosition(t,s),u=i.getLanguageService().prepareCallHierarchy(n,o);return u&&eZ(u,m=>this.toProtocolCallHierarchyItem(m))}}provideCallHierarchyIncomingCalls(t){let{file:n,project:i}=this.getFileAndProject(t),s=this.getScriptInfoFromProjectService(n);return i.getLanguageService().provideCallHierarchyIncomingCalls(n,this.getPosition(t,s)).map(u=>this.toProtocolCallHierarchyIncomingCall(u))}provideCallHierarchyOutgoingCalls(t){let{file:n,project:i}=this.getFileAndProject(t),s=this.getScriptInfoFromProjectService(n);return i.getLanguageService().provideCallHierarchyOutgoingCalls(n,this.getPosition(t,s)).map(u=>this.toProtocolCallHierarchyOutgoingCall(u,s))}getCanonicalFileName(t){let n=this.host.useCaseSensitiveFileNames?t:R1(t);return Zs(n)}exit(){}notRequired(){return{responseRequired:!1}}requiredResponse(t){return{response:t,responseRequired:!0}}addProtocolHandler(t,n){if(this.handlers.has(t))throw new Error(`Protocol handler already exists for command "${t}"`);this.handlers.set(t,n)}setCurrentRequest(t){M.assert(this.currentRequestId===void 0),this.currentRequestId=t,this.cancellationToken.setRequest(t)}resetCurrentRequest(t){M.assert(this.currentRequestId===t),this.currentRequestId=void 0,this.cancellationToken.resetRequest(t)}executeWithRequestId(t,n){try{return this.setCurrentRequest(t),n()}finally{this.resetCurrentRequest(t)}}executeCommand(t){let n=this.handlers.get(t.command);if(n){let i=this.executeWithRequestId(t.seq,()=>n(t));return this.projectService.enableRequestedPlugins(),i}else return this.logger.msg(`Unrecognized JSON command:${Ob(t)}`,"Err"),this.doOutput(void 0,"unknown",t.seq,!1,`Unrecognized JSON command: ${t.command}`),{responseRequired:!1}}onMessage(t){var n,i,s,o,u,m,d,S,E,x,D;this.gcTimer.scheduleCollect(),this.performanceData=void 0;let w;this.logger.hasLevel(2)&&(w=this.hrtime(),this.logger.hasLevel(3)&&this.logger.info(`request:${f6(this.toStringMessage(t))}`));let R,L;try{R=this.parseMessage(t),L=R.arguments&&R.arguments.file?R.arguments:void 0,(n=Cn)==null||n.instant(Cn.Phase.Session,"request",{seq:R.seq,command:R.command}),(i=rf)==null||i.logStartCommand(""+R.command,this.toStringMessage(t).substring(0,100)),(s=Cn)==null||s.push(Cn.Phase.Session,"executeCommand",{seq:R.seq,command:R.command},!0);let{response:F,responseRequired:J}=this.executeCommand(R);if((o=Cn)==null||o.pop(),this.logger.hasLevel(2)){let G=FRt(this.hrtime(w)).toFixed(4);J?this.logger.perftrc(`${R.seq}::${R.command}: elapsed time (in milliseconds) ${G}`):this.logger.perftrc(`${R.seq}::${R.command}: async elapsed time (in milliseconds) ${G}`)}(u=rf)==null||u.logStopCommand(""+R.command,"Success"),(m=Cn)==null||m.instant(Cn.Phase.Session,"response",{seq:R.seq,command:R.command,success:!!F}),F?this.doOutput(F,R.command,R.seq,!0):J&&this.doOutput(void 0,R.command,R.seq,!1,"No content available.")}catch(F){if((d=Cn)==null||d.popAll(),F instanceof tI){(S=rf)==null||S.logStopCommand(""+(R&&R.command),"Canceled: "+F),(E=Cn)==null||E.instant(Cn.Phase.Session,"commandCanceled",{seq:R?.seq,command:R?.command}),this.doOutput({canceled:!0},R.command,R.seq,!0);return}this.logErrorWorker(F,this.toStringMessage(t),L),(x=rf)==null||x.logStopCommand(""+(R&&R.command),"Error: "+F),(D=Cn)==null||D.instant(Cn.Phase.Session,"commandError",{seq:R?.seq,command:R?.command,message:F.message}),this.doOutput(void 0,R?R.command:"unknown",R?R.seq:0,!1,"Error processing request. "+F.message+`
`+F.stack)}}parseMessage(t){return JSON.parse(t)}toStringMessage(t){return t}getFormatOptions(t){return this.projectService.getFormatCodeOptions(t)}getPreferences(t){return this.projectService.getPreferences(t)}getHostFormatOptions(){return this.projectService.getHostFormatCodeOptions()}getHostPreferences(){return this.projectService.getHostPreferences()}};function Hh(e,t){return{start:t.positionToLineOffset(e.start),end:t.positionToLineOffset(bl(e))}}function NEe(e,t,n){let i=Hh(e,n),s=t&&Hh(t,n);return s?{...i,contextStart:s.start,contextEnd:s.end}:i}function YRt(e,t){return{start:Lze(t,e.span.start),end:Lze(t,bl(e.span)),newText:e.newText}}function Lze(e,t){return TEe(e)?XRt(e.getLineAndCharacterOfPosition(t)):e.positionToLineOffset(t)}function KRt(e,t){let n=e.ranges.map(i=>({start:t.positionToLineOffset(i.start),end:t.positionToLineOffset(i.start+i.length)}));return e.wordPattern?{ranges:n,wordPattern:e.wordPattern}:{ranges:n}}function XRt(e){return{line:e.line+1,offset:e.character+1}}function QRt(e){M.assert(e.textChanges.length===1);let t=Ma(e.textChanges);return M.assert(t.span.start===0&&t.span.length===0),{fileName:e.fileName,textChanges:[{start:{line:0,offset:0},end:{line:0,offset:0},newText:t.newText}]}}function DEe(e,t,n,i){let s=ZRt(e,t,i),{line:o,character:u}=NP($C(s),n);return{line:o+1,offset:u+1}}function ZRt(e,t,n){for(let{fileName:i,textChanges:s}of n)if(i===t)for(let o=s.length-1;o>=0;o--){let{newText:u,span:{start:m,length:d}}=s[o];e=e.slice(0,m)+u+e.slice(m+d)}return e}function Fze(e,{fileName:t,textSpan:n,contextSpan:i,isWriteAccess:s,isDefinition:o},{disableLineTextInReferences:u}){let m=M.checkDefined(e.getScriptInfo(t)),d=NEe(n,i,m),S=u?void 0:e8t(m,d);return{file:t,...d,lineText:S,isWriteAccess:s,isDefinition:o}}function e8t(e,t){let n=e.lineToTextSpan(t.start.line-1);return e.getSnapshot().getText(n.start,bl(n)).replace(/\r|\n/g,"")}function t8t(e){return e===void 0||e&&typeof e=="object"&&typeof e.exportName=="string"&&(e.fileName===void 0||typeof e.fileName=="string")&&(e.ambientModuleName===void 0||typeof e.ambientModuleName=="string"&&(e.isPackageJsonImport===void 0||typeof e.isPackageJsonImport=="boolean"))}var pD=4,wEe=(e=>(e[e.PreStart=0]="PreStart",e[e.Start=1]="Start",e[e.Entire=2]="Entire",e[e.Mid=3]="Mid",e[e.End=4]="End",e[e.PostEnd=5]="PostEnd",e))(wEe||{}),r8t=class{constructor(){this.goSubtree=!0,this.lineIndex=new f7,this.endBranch=[],this.state=2,this.initialText="",this.trailingText="",this.lineIndex.root=new dD,this.startPath=[this.lineIndex.root],this.stack=[this.lineIndex.root]}get done(){return!1}insertLines(e,t){t&&(this.trailingText=""),e?e=this.initialText+e+this.trailingText:e=this.initialText+this.trailingText;let i=f7.linesFromText(e).lines;i.length>1&&i[i.length-1]===""&&i.pop();let s,o;for(let m=this.endBranch.length-1;m>=0;m--)this.endBranch[m].updateCounts(),this.endBranch[m].charCount()===0&&(o=this.endBranch[m],m>0?s=this.endBranch[m-1]:s=this.branchNode);o&&s.remove(o);let u=this.startPath[this.startPath.length-1];if(i.length>0)if(u.text=i[0],i.length>1){let m=new Array(i.length-1),d=u;for(let x=1;x<i.length;x++)m[x-1]=new sJ(i[x]);let S=this.startPath.length-2;for(;S>=0;){let x=this.startPath[S];m=x.insertAt(d,m),S--,d=x}let E=m.length;for(;E>0;){let x=new dD;x.add(this.lineIndex.root),m=x.insertAt(this.lineIndex.root,m),E=m.length,this.lineIndex.root=x}this.lineIndex.root.updateCounts()}else for(let m=this.startPath.length-2;m>=0;m--)this.startPath[m].updateCounts();else{this.startPath[this.startPath.length-2].remove(u);for(let d=this.startPath.length-2;d>=0;d--)this.startPath[d].updateCounts()}return this.lineIndex}post(e,t,n){n===this.lineCollectionAtBranch&&(this.state=4),this.stack.pop()}pre(e,t,n,i,s){let o=this.stack[this.stack.length-1];this.state===2&&s===1&&(this.state=1,this.branchNode=o,this.lineCollectionAtBranch=n);let u;function m(d){return d.isLeaf()?new sJ(""):new dD}switch(s){case 0:this.goSubtree=!1,this.state!==4&&o.add(n);break;case 1:this.state===4?this.goSubtree=!1:(u=m(n),o.add(u),this.startPath.push(u));break;case 2:this.state!==4?(u=m(n),o.add(u),this.startPath.push(u)):n.isLeaf()||(u=m(n),o.add(u),this.endBranch.push(u));break;case 3:this.goSubtree=!1;break;case 4:this.state!==4?this.goSubtree=!1:n.isLeaf()||(u=m(n),o.add(u),this.endBranch.push(u));break;case 5:this.goSubtree=!1,this.state!==1&&o.add(n);break}this.goSubtree&&this.stack.push(u)}leaf(e,t,n){this.state===1?this.initialText=n.text.substring(0,e):this.state===2?(this.initialText=n.text.substring(0,e),this.trailingText=n.text.substring(e+t)):this.trailingText=n.text.substring(e+t)}},n8t=class{constructor(e,t,n){this.pos=e,this.deleteLen=t,this.insertedText=n}getTextChangeRange(){return D3(zu(this.pos,this.deleteLen),this.insertedText?this.insertedText.length:0)}},Nte=class CC{constructor(){this.changes=[],this.versions=new Array(CC.maxVersions),this.minVersion=0,this.currentVersion=0}versionToIndex(t){if(!(t<this.minVersion||t>this.currentVersion))return t%CC.maxVersions}currentVersionToIndex(){return this.currentVersion%CC.maxVersions}edit(t,n,i){this.changes.push(new n8t(t,n,i)),(this.changes.length>CC.changeNumberThreshold||n>CC.changeLengthThreshold||i&&i.length>CC.changeLengthThreshold)&&this.getSnapshot()}getSnapshot(){return this._getSnapshot()}_getSnapshot(){let t=this.versions[this.currentVersionToIndex()];if(this.changes.length>0){let n=t.index;for(let i of this.changes)n=n.edit(i.pos,i.deleteLen,i.insertedText);t=new jze(this.currentVersion+1,this,n,this.changes),this.currentVersion=t.version,this.versions[this.currentVersionToIndex()]=t,this.changes=[],this.currentVersion-this.minVersion>=CC.maxVersions&&(this.minVersion=this.currentVersion-CC.maxVersions+1)}return t}getSnapshotVersion(){return this._getSnapshot().version}getAbsolutePositionAndLineText(t){return this._getSnapshot().index.lineNumberToInfo(t)}lineOffsetToPosition(t,n){return this._getSnapshot().index.absolutePositionOfStartOfLine(t)+(n-1)}positionToLineOffset(t){return this._getSnapshot().index.positionToLineOffset(t)}lineToTextSpan(t){let n=this._getSnapshot().index,{lineText:i,absolutePosition:s}=n.lineNumberToInfo(t+1),o=i!==void 0?i.length:n.absolutePositionOfStartOfLine(t+2)-s;return zu(s,o)}getTextChangesBetweenVersions(t,n){if(t<n)if(t>=this.minVersion){let i=[];for(let s=t+1;s<=n;s++){let o=this.versions[this.versionToIndex(s)];for(let u of o.changesSincePreviousVersion)i.push(u.getTextChangeRange())}return Oue(i)}else return;else return b5}getLineCount(){return this._getSnapshot().index.getLineCount()}static fromString(t){let n=new CC,i=new jze(0,n,new f7);n.versions[n.currentVersion]=i;let s=f7.linesFromText(t);return i.index.load(s.lines),n}};Nte.changeNumberThreshold=8,Nte.changeLengthThreshold=256,Nte.maxVersions=8;var Dte=Nte,jze=class Dpt{constructor(t,n,i,s=su){this.version=t,this.cache=n,this.index=i,this.changesSincePreviousVersion=s}getText(t,n){return this.index.getText(t,n-t)}getLength(){return this.index.getLength()}getChangeRange(t){if(t instanceof Dpt&&this.cache===t.cache)return this.version<=t.version?b5:this.cache.getTextChangesBetweenVersions(t.version,this.version)}},f7=class RDe{constructor(){this.checkEdits=!1}absolutePositionOfStartOfLine(t){return this.lineNumberToInfo(t).absolutePosition}positionToLineOffset(t){let{oneBasedLine:n,zeroBasedColumn:i}=this.root.charOffsetToLineInfo(1,t);return{line:n,offset:i+1}}positionToColumnAndLineText(t){return this.root.charOffsetToLineInfo(1,t)}getLineCount(){return this.root.lineCount()}lineNumberToInfo(t){let n=this.getLineCount();if(t<=n){let{position:i,leaf:s}=this.root.lineNumberToInfo(t,0);return{absolutePosition:i,lineText:s&&s.text}}else return{absolutePosition:this.root.charCount(),lineText:void 0}}load(t){if(t.length>0){let n=[];for(let i=0;i<t.length;i++)n[i]=new sJ(t[i]);this.root=RDe.buildTreeFromBottom(n)}else this.root=new dD}walk(t,n,i){this.root.walk(t,n,i)}getText(t,n){let i="";return n>0&&t<this.root.charCount()&&this.walk(t,n,{goSubtree:!0,done:!1,leaf:(s,o,u)=>{i=i.concat(u.text.substring(s,s+o))}}),i}getLength(){return this.root.charCount()}every(t,n,i){i||(i=this.root.charCount());let s={goSubtree:!0,done:!1,leaf(o,u,m){t(m,o,u)||(this.done=!0)}};return this.walk(n,i-n,s),!s.done}edit(t,n,i){if(this.root.charCount()===0)return M.assert(n===0),i!==void 0?(this.load(RDe.linesFromText(i).lines),this):void 0;{let s;if(this.checkEdits){let m=this.getText(0,this.root.charCount());s=m.slice(0,t)+i+m.slice(t+n)}let o=new r8t,u=!1;if(t>=this.root.charCount()){t=this.root.charCount()-1;let m=this.getText(t,1);i?i=m+i:i=m,n=0,u=!0}else if(n>0){let m=t+n,{zeroBasedColumn:d,lineText:S}=this.positionToColumnAndLineText(m);d===0&&(n+=S.length,i=i?i+S:S)}if(this.root.walk(t,n,o),o.insertLines(i,u),this.checkEdits){let m=o.lineIndex.getText(0,o.lineIndex.getLength());M.assert(s===m,"buffer edit mismatch")}return o.lineIndex}}static buildTreeFromBottom(t){if(t.length<pD)return new dD(t);let n=new Array(Math.ceil(t.length/pD)),i=0;for(let s=0;s<n.length;s++){let o=Math.min(i+pD,t.length);n[s]=new dD(t.slice(i,o)),i=o}return this.buildTreeFromBottom(n)}static linesFromText(t){let n=$C(t);if(n.length===0)return{lines:[],lineMap:n};let i=new Array(n.length),s=n.length-1;for(let u=0;u<s;u++)i[u]=t.substring(n[u],n[u+1]);let o=t.substring(n[s]);return o.length>0?i[s]=o:i.pop(),{lines:i,lineMap:n}}},dD=class MDe{constructor(t=[]){this.children=t,this.totalChars=0,this.totalLines=0,t.length&&this.updateCounts()}isLeaf(){return!1}updateCounts(){this.totalChars=0,this.totalLines=0;for(let t of this.children)this.totalChars+=t.charCount(),this.totalLines+=t.lineCount()}execWalk(t,n,i,s,o){return i.pre&&i.pre(t,n,this.children[s],this,o),i.goSubtree?(this.children[s].walk(t,n,i),i.post&&i.post(t,n,this.children[s],this,o)):i.goSubtree=!0,i.done}skipChild(t,n,i,s,o){s.pre&&!s.done&&(s.pre(t,n,this.children[i],this,o),s.goSubtree=!0)}walk(t,n,i){let s=0,o=this.children[s].charCount(),u=t;for(;u>=o;)this.skipChild(u,n,s,i,0),u-=o,s++,o=this.children[s].charCount();if(u+n<=o){if(this.execWalk(u,n,i,s,2))return}else{if(this.execWalk(u,o-u,i,s,1))return;let m=n-(o-u);for(s++,o=this.children[s].charCount();m>o;){if(this.execWalk(0,o,i,s,3))return;m-=o,s++,o=this.children[s].charCount()}if(m>0&&this.execWalk(0,m,i,s,4))return}if(i.pre){let m=this.children.length;if(s<m-1)for(let d=s+1;d<m;d++)this.skipChild(0,0,d,i,5)}}charOffsetToLineInfo(t,n){if(this.children.length===0)return{oneBasedLine:t,zeroBasedColumn:n,lineText:void 0};for(let o of this.children){if(o.charCount()>n)return o.isLeaf()?{oneBasedLine:t,zeroBasedColumn:n,lineText:o.text}:o.charOffsetToLineInfo(t,n);n-=o.charCount(),t+=o.lineCount()}let i=this.lineCount();if(i===0)return{oneBasedLine:1,zeroBasedColumn:0,lineText:void 0};let s=M.checkDefined(this.lineNumberToInfo(i,0).leaf);return{oneBasedLine:i,zeroBasedColumn:s.charCount(),lineText:void 0}}lineNumberToInfo(t,n){for(let i of this.children){let s=i.lineCount();if(s>=t)return i.isLeaf()?{position:n,leaf:i}:i.lineNumberToInfo(t,n);t-=s,n+=i.charCount()}return{position:n,leaf:void 0}}splitAfter(t){let n,i=this.children.length;t++;let s=t;if(t<i){for(n=new MDe;t<i;)n.add(this.children[t]),t++;n.updateCounts()}return this.children.length=s,n}remove(t){let n=this.findChildIndex(t),i=this.children.length;if(n<i-1)for(let s=n;s<i-1;s++)this.children[s]=this.children[s+1];this.children.pop()}findChildIndex(t){let n=this.children.indexOf(t);return M.assert(n!==-1),n}insertAt(t,n){let i=this.findChildIndex(t),s=this.children.length,o=n.length;if(s<pD&&i===s-1&&o===1)return this.add(n[0]),this.updateCounts(),[];{let u=this.splitAfter(i),m=0;for(i++;i<pD&&m<o;)this.children[i]=n[m],i++,m++;let d=[],S=0;if(m<o){S=Math.ceil((o-m)/pD),d=new Array(S);let E=0;for(let D=0;D<S;D++)d[D]=new MDe;let x=d[0];for(;m<o;)x.add(n[m]),m++,x.children.length===pD&&(E++,x=d[E]);for(let D=d.length-1;D>=0;D--)d[D].children.length===0&&d.pop()}u&&d.push(u),this.updateCounts();for(let E=0;E<S;E++)d[E].updateCounts();return d}}add(t){this.children.push(t),M.assert(this.children.length<=pD)}charCount(){return this.totalChars}lineCount(){return this.totalLines}},sJ=class{constructor(e){this.text=e}isLeaf(){return!0}walk(e,t,n){n.leaf(e,t,this)}charCount(){return this.text.length}lineCount(){return 1}},Bze=class wpt{constructor(t,n,i,s,o,u){this.telemetryEnabled=t,this.logger=n,this.host=i,this.globalTypingsCacheLocation=s,this.event=o,this.maxActiveRequestCount=u,this.activeRequestCount=0,this.requestQueue=p3(),this.requestMap=new Map,this.requestedRegistry=!1,this.packageInstallId=0}isKnownTypesPackageName(t){var n;return eh.validatePackageName(t)!==eh.NameValidationResult.Ok?!1:(this.requestedRegistry||(this.requestedRegistry=!0,this.installer.send({kind:"typesRegistry"})),!!((n=this.typesRegistryCache)!=null&&n.has(t)))}installPackage(t){this.packageInstallId++;let n={kind:"installPackage",...t,id:this.packageInstallId},i=new Promise((s,o)=>{(this.packageInstalledPromise??(this.packageInstalledPromise=new Map)).set(this.packageInstallId,{resolve:s,reject:o})});return this.installer.send(n),i}attach(t){this.projectService=t,this.installer=this.createInstallerProcess()}onProjectClosed(t){this.installer.send({projectName:t.getProjectName(),kind:"closeProject"})}enqueueInstallTypingsRequest(t,n,i){let s=JTe(t,n,i);this.logger.hasLevel(3)&&this.logger.info(`TIAdapter:: Scheduling throttled operation:${Ob(s)}`),this.activeRequestCount<this.maxActiveRequestCount?this.scheduleRequest(s):(this.logger.hasLevel(3)&&this.logger.info(`TIAdapter:: Deferring request for: ${s.projectName}`),this.requestQueue.enqueue(s),this.requestMap.set(s.projectName,s))}handleMessage(t){var n,i;switch(this.logger.hasLevel(3)&&this.logger.info(`TIAdapter:: Received response:${Ob(t)}`),t.kind){case GX:this.typesRegistryCache=new Map(Object.entries(t.typesRegistry));break;case hU:{let s=(n=this.packageInstalledPromise)==null?void 0:n.get(t.id);M.assertIsDefined(s,"Should find the promise for package install"),(i=this.packageInstalledPromise)==null||i.delete(t.id),t.success?s.resolve({successMessage:t.message}):s.reject(t.message),this.projectService.updateTypingsForProject(t),this.event(t,"setTypings");break}case Gye:{let s={message:t.message};this.event(s,"typesInstallerInitializationFailed");break}case YX:{let s={eventId:t.eventId,packages:t.packagesToInstall};this.event(s,"beginInstallTypes");break}case KX:{if(this.telemetryEnabled){let u={telemetryEventName:"typingsInstalled",payload:{installedPackages:t.packagesToInstall.join(","),installSuccess:t.installSuccess,typingsInstallerVersion:t.typingsInstallerVersion}};this.event(u,"telemetry")}let s={eventId:t.eventId,packages:t.packagesToInstall,success:t.installSuccess};this.event(s,"endInstallTypes");break}case gU:{this.projectService.updateTypingsForProject(t);break}case mU:{for(this.activeRequestCount>0?this.activeRequestCount--:M.fail("TIAdapter:: Received too many responses");!this.requestQueue.isEmpty();){let s=this.requestQueue.dequeue();if(this.requestMap.get(s.projectName)===s){this.requestMap.delete(s.projectName),this.scheduleRequest(s);break}this.logger.hasLevel(3)&&this.logger.info(`TIAdapter:: Skipping defunct request for: ${s.projectName}`)}this.projectService.updateTypingsForProject(t),this.event(t,"setTypings");break}case iM:this.projectService.watchTypingLocations(t);break;default:}}scheduleRequest(t){this.logger.hasLevel(3)&&this.logger.info(`TIAdapter:: Scheduling request for: ${t.projectName}`),this.activeRequestCount++,this.host.setTimeout(()=>{this.logger.hasLevel(3)&&this.logger.info(`TIAdapter:: Sending request:${Ob(t)}`),this.installer.send(t)},wpt.requestDelayMillis,`${t.projectName}::${t.kind}`)}};Bze.requestDelayMillis=100;var Uze=Bze,Vze={};A(Vze,{ActionInvalidate:()=>gU,ActionPackageInstalled:()=>hU,ActionSet:()=>mU,ActionWatchTypingLocations:()=>iM,Arguments:()=>XX,AutoImportProviderProject:()=>cEe,AuxiliaryProject:()=>aEe,CharRangeSection:()=>wEe,CloseFileWatcherEvent:()=>yte,CommandNames:()=>Dze,ConfigFileDiagEvent:()=>pte,ConfiguredProject:()=>lEe,ConfiguredProjectLoadKind:()=>mEe,CreateDirectoryWatcherEvent:()=>hte,CreateFileWatcherEvent:()=>gte,Errors:()=>I0,EventBeginInstallTypes:()=>YX,EventEndInstallTypes:()=>KX,EventInitializationFailed:()=>Gye,EventTypesRegistry:()=>GX,ExternalProject:()=>ote,GcTimer:()=>YTe,InferredProject:()=>sEe,LargeFileReferencedEvent:()=>fte,LineIndex:()=>f7,LineLeaf:()=>sJ,LineNode:()=>dD,LogLevel:()=>UTe,Msg:()=>VTe,OpenFileInfoTelemetryEvent:()=>uEe,Project:()=>vk,ProjectInfoTelemetryEvent:()=>mte,ProjectKind:()=>a7,ProjectLanguageServiceStateEvent:()=>dte,ProjectLoadingFinishEvent:()=>_te,ProjectLoadingStartEvent:()=>ute,ProjectService:()=>bEe,ProjectsUpdatedInBackgroundEvent:()=>nJ,ScriptInfo:()=>ZTe,ScriptVersionCache:()=>Dte,Session:()=>Mze,TextStorage:()=>QTe,ThrottledOperations:()=>GTe,TypingsCache:()=>eEe,TypingsInstallerAdapter:()=>Uze,allFilesAreJsOrDts:()=>rEe,allRootFilesAreJsOrDts:()=>tEe,asNormalizedPath:()=>nze,convertCompilerOptions:()=>iJ,convertFormatOptions:()=>_D,convertScriptKindName:()=>Ste,convertTypeAcquisition:()=>fEe,convertUserPreferences:()=>pEe,convertWatchOptions:()=>u7,countEachFileTypes:()=>o7,createInstallTypingsRequest:()=>JTe,createModuleSpecifierCache:()=>xEe,createNormalizedPathMap:()=>ize,createPackageJsonCache:()=>CEe,createSortedArray:()=>HTe,emptyArray:()=>su,findArgument:()=>e7e,forEachResolvedProjectReferenceProject:()=>xte,formatDiagnosticToProtocol:()=>_7,formatMessage:()=>AEe,getBaseConfigFileName:()=>ste,getLocationInNewDocument:()=>DEe,hasArgument:()=>ZMe,hasNoTypeScriptSource:()=>nEe,indent:()=>f6,isBackgroundProject:()=>l7,isConfigFile:()=>TEe,isConfiguredProject:()=>Wv,isDynamicFileName:()=>s7,isExternalProject:()=>c7,isInferredProject:()=>uD,isInferredProjectName:()=>qTe,isProjectDeferredClose:()=>rJ,makeAutoImportProviderProjectName:()=>WTe,makeAuxiliaryProjectName:()=>$Te,makeInferredProjectName:()=>zTe,maxFileSize:()=>lte,maxProgramSizeForNonTsFiles:()=>cte,normalizedPathToPath:()=>i7,nowString:()=>t7e,nullCancellationToken:()=>kze,nullTypingsInstaller:()=>ate,protocol:()=>KTe,removeSorted:()=>sze,stringifyIndented:()=>Ob,toEvent:()=>kEe,toNormalizedPath:()=>Dc,tryConvertScriptKindName:()=>vte,typingsInstaller:()=>BTe,updateProjectIfDirty:()=>Dd}),typeof console<"u"&&(M.loggingHost={log(e,t){switch(e){case 1:return console.error(t);case 2:return console.warn(t);case 3:return console.log(t);case 4:return console.log(t)}}})})({get exports(){return xpt},set exports(l){xpt=l,typeof $ae<"u"&&$ae.exports&&($ae.exports=l)}})});var Uz=xt((JIr,mdt)=>{var Jfr="2.0.0",qfr=Number.MAX_SAFE_INTEGER||9007199254740991,zfr=16,Wfr=250,$fr=["major","premajor","minor","preminor","patch","prepatch","prerelease"];mdt.exports={MAX_LENGTH:256,MAX_SAFE_COMPONENT_LENGTH:zfr,MAX_SAFE_BUILD_LENGTH:Wfr,MAX_SAFE_INTEGER:qfr,RELEASE_TYPES:$fr,SEMVER_SPEC_VERSION:Jfr,FLAG_INCLUDE_PRERELEASE:1,FLAG_LOOSE:2}});var Vz=xt((qIr,gdt)=>{var Hfr=typeof process=="object"&&process.env&&process.env.NODE_DEBUG&&/\bsemver\b/i.test(process.env.NODE_DEBUG)?(...l)=>console.error("SEMVER",...l):()=>{};gdt.exports=Hfr});var xF=xt((gP,hdt)=>{var{MAX_SAFE_COMPONENT_LENGTH:zDe,MAX_SAFE_BUILD_LENGTH:Gfr,MAX_LENGTH:Yfr}=Uz(),Kfr=Vz();gP=hdt.exports={};var Xfr=gP.re=[],Qfr=gP.safeRe=[],Ba=gP.src=[],Ua=gP.t={},Zfr=0,WDe="[a-zA-Z0-9-]",epr=[["\\s",1],["\\d",Yfr],[WDe,Gfr]],tpr=l=>{for(let[c,f]of epr)l=l.split(`${c}*`).join(`${c}{0,${f}}`).split(`${c}+`).join(`${c}{1,${f}}`);return l},al=(l,c,f)=>{let y=tpr(c),b=Zfr++;Kfr(l,b,c),Ua[l]=b,Ba[b]=c,Xfr[b]=new RegExp(c,f?"g":void 0),Qfr[b]=new RegExp(y,f?"g":void 0)};al("NUMERICIDENTIFIER","0|[1-9]\\d*");al("NUMERICIDENTIFIERLOOSE","\\d+");al("NONNUMERICIDENTIFIER",`\\d*[a-zA-Z-]${WDe}*`);al("MAINVERSION",`(${Ba[Ua.NUMERICIDENTIFIER]})\\.(${Ba[Ua.NUMERICIDENTIFIER]})\\.(${Ba[Ua.NUMERICIDENTIFIER]})`);al("MAINVERSIONLOOSE",`(${Ba[Ua.NUMERICIDENTIFIERLOOSE]})\\.(${Ba[Ua.NUMERICIDENTIFIERLOOSE]})\\.(${Ba[Ua.NUMERICIDENTIFIERLOOSE]})`);al("PRERELEASEIDENTIFIER",`(?:${Ba[Ua.NUMERICIDENTIFIER]}|${Ba[Ua.NONNUMERICIDENTIFIER]})`);al("PRERELEASEIDENTIFIERLOOSE",`(?:${Ba[Ua.NUMERICIDENTIFIERLOOSE]}|${Ba[Ua.NONNUMERICIDENTIFIER]})`);al("PRERELEASE",`(?:-(${Ba[Ua.PRERELEASEIDENTIFIER]}(?:\\.${Ba[Ua.PRERELEASEIDENTIFIER]})*))`);al("PRERELEASELOOSE",`(?:-?(${Ba[Ua.PRERELEASEIDENTIFIERLOOSE]}(?:\\.${Ba[Ua.PRERELEASEIDENTIFIERLOOSE]})*))`);al("BUILDIDENTIFIER",`${WDe}+`);al("BUILD",`(?:\\+(${Ba[Ua.BUILDIDENTIFIER]}(?:\\.${Ba[Ua.BUILDIDENTIFIER]})*))`);al("FULLPLAIN",`v?${Ba[Ua.MAINVERSION]}${Ba[Ua.PRERELEASE]}?${Ba[Ua.BUILD]}?`);al("FULL",`^${Ba[Ua.FULLPLAIN]}$`);al("LOOSEPLAIN",`[v=\\s]*${Ba[Ua.MAINVERSIONLOOSE]}${Ba[Ua.PRERELEASELOOSE]}?${Ba[Ua.BUILD]}?`);al("LOOSE",`^${Ba[Ua.LOOSEPLAIN]}$`);al("GTLT","((?:<|>)?=?)");al("XRANGEIDENTIFIERLOOSE",`${Ba[Ua.NUMERICIDENTIFIERLOOSE]}|x|X|\\*`);al("XRANGEIDENTIFIER",`${Ba[Ua.NUMERICIDENTIFIER]}|x|X|\\*`);al("XRANGEPLAIN",`[v=\\s]*(${Ba[Ua.XRANGEIDENTIFIER]})(?:\\.(${Ba[Ua.XRANGEIDENTIFIER]})(?:\\.(${Ba[Ua.XRANGEIDENTIFIER]})(?:${Ba[Ua.PRERELEASE]})?${Ba[Ua.BUILD]}?)?)?`);al("XRANGEPLAINLOOSE",`[v=\\s]*(${Ba[Ua.XRANGEIDENTIFIERLOOSE]})(?:\\.(${Ba[Ua.XRANGEIDENTIFIERLOOSE]})(?:\\.(${Ba[Ua.XRANGEIDENTIFIERLOOSE]})(?:${Ba[Ua.PRERELEASELOOSE]})?${Ba[Ua.BUILD]}?)?)?`);al("XRANGE",`^${Ba[Ua.GTLT]}\\s*${Ba[Ua.XRANGEPLAIN]}$`);al("XRANGELOOSE",`^${Ba[Ua.GTLT]}\\s*${Ba[Ua.XRANGEPLAINLOOSE]}$`);al("COERCEPLAIN",`(^|[^\\d])(\\d{1,${zDe}})(?:\\.(\\d{1,${zDe}}))?(?:\\.(\\d{1,${zDe}}))?`);al("COERCE",`${Ba[Ua.COERCEPLAIN]}(?:$|[^\\d])`);al("COERCEFULL",Ba[Ua.COERCEPLAIN]+`(?:${Ba[Ua.PRERELEASE]})?(?:${Ba[Ua.BUILD]})?(?:$|[^\\d])`);al("COERCERTL",Ba[Ua.COERCE],!0);al("COERCERTLFULL",Ba[Ua.COERCEFULL],!0);al("LONETILDE","(?:~>?)");al("TILDETRIM",`(\\s*)${Ba[Ua.LONETILDE]}\\s+`,!0);gP.tildeTrimReplace="$1~";al("TILDE",`^${Ba[Ua.LONETILDE]}${Ba[Ua.XRANGEPLAIN]}$`);al("TILDELOOSE",`^${Ba[Ua.LONETILDE]}${Ba[Ua.XRANGEPLAINLOOSE]}$`);al("LONECARET","(?:\\^)");al("CARETTRIM",`(\\s*)${Ba[Ua.LONECARET]}\\s+`,!0);gP.caretTrimReplace="$1^";al("CARET",`^${Ba[Ua.LONECARET]}${Ba[Ua.XRANGEPLAIN]}$`);al("CARETLOOSE",`^${Ba[Ua.LONECARET]}${Ba[Ua.XRANGEPLAINLOOSE]}$`);al("COMPARATORLOOSE",`^${Ba[Ua.GTLT]}\\s*(${Ba[Ua.LOOSEPLAIN]})$|^$`);al("COMPARATOR",`^${Ba[Ua.GTLT]}\\s*(${Ba[Ua.FULLPLAIN]})$|^$`);al("COMPARATORTRIM",`(\\s*)${Ba[Ua.GTLT]}\\s*(${Ba[Ua.LOOSEPLAIN]}|${Ba[Ua.XRANGEPLAIN]})`,!0);gP.comparatorTrimReplace="$1$2$3";al("HYPHENRANGE",`^\\s*(${Ba[Ua.XRANGEPLAIN]})\\s+-\\s+(${Ba[Ua.XRANGEPLAIN]})\\s*$`);al("HYPHENRANGELOOSE",`^\\s*(${Ba[Ua.XRANGEPLAINLOOSE]})\\s+-\\s+(${Ba[Ua.XRANGEPLAINLOOSE]})\\s*$`);al("STAR","(<|>)?=?\\s*\\*");al("GTE0","^\\s*>=\\s*0\\.0\\.0\\s*$");al("GTE0PRE","^\\s*>=\\s*0\\.0\\.0-0\\s*$")});var Coe=xt((zIr,ydt)=>{var rpr=Object.freeze({loose:!0}),npr=Object.freeze({}),ipr=l=>l?typeof l!="object"?rpr:l:npr;ydt.exports=ipr});var $De=xt((WIr,bdt)=>{var vdt=/^[0-9]+$/,Sdt=(l,c)=>{let f=vdt.test(l),y=vdt.test(c);return f&&y&&(l=+l,c=+c),l===c?0:f&&!y?-1:y&&!f?1:l<c?-1:1},spr=(l,c)=>Sdt(c,l);bdt.exports={compareIdentifiers:Sdt,rcompareIdentifiers:spr}});var i0=xt(($Ir,Cdt)=>{var Aoe=Vz(),{MAX_LENGTH:Tdt,MAX_SAFE_INTEGER:koe}=Uz(),{safeRe:Edt,t:xdt}=xF(),apr=Coe(),{compareIdentifiers:CF}=$De(),HDe=class l{constructor(c,f){if(f=apr(f),c instanceof l){if(c.loose===!!f.loose&&c.includePrerelease===!!f.includePrerelease)return c;c=c.version}else if(typeof c!="string")throw new TypeError(`Invalid version. Must be a string. Got type "${typeof c}".`);if(c.length>Tdt)throw new TypeError(`version is longer than ${Tdt} characters`);Aoe("SemVer",c,f),this.options=f,this.loose=!!f.loose,this.includePrerelease=!!f.includePrerelease;let y=c.trim().match(f.loose?Edt[xdt.LOOSE]:Edt[xdt.FULL]);if(!y)throw new TypeError(`Invalid Version: ${c}`);if(this.raw=c,this.major=+y[1],this.minor=+y[2],this.patch=+y[3],this.major>koe||this.major<0)throw new TypeError("Invalid major version");if(this.minor>koe||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>koe||this.patch<0)throw new TypeError("Invalid patch version");y[4]?this.prerelease=y[4].split(".").map(b=>{if(/^[0-9]+$/.test(b)){let A=+b;if(A>=0&&A<koe)return A}return b}):this.prerelease=[],this.build=y[5]?y[5].split("."):[],this.format()}format(){return this.version=`${this.major}.${this.minor}.${this.patch}`,this.prerelease.length&&(this.version+=`-${this.prerelease.join(".")}`),this.version}toString(){return this.version}compare(c){if(Aoe("SemVer.compare",this.version,this.options,c),!(c instanceof l)){if(typeof c=="string"&&c===this.version)return 0;c=new l(c,this.options)}return c.version===this.version?0:this.compareMain(c)||this.comparePre(c)}compareMain(c){return c instanceof l||(c=new l(c,this.options)),CF(this.major,c.major)||CF(this.minor,c.minor)||CF(this.patch,c.patch)}comparePre(c){if(c instanceof l||(c=new l(c,this.options)),this.prerelease.length&&!c.prerelease.length)return-1;if(!this.prerelease.length&&c.prerelease.length)return 1;if(!this.prerelease.length&&!c.prerelease.length)return 0;let f=0;do{let y=this.prerelease[f],b=c.prerelease[f];if(Aoe("prerelease compare",f,y,b),y===void 0&&b===void 0)return 0;if(b===void 0)return 1;if(y===void 0)return-1;if(y===b)continue;return CF(y,b)}while(++f)}compareBuild(c){c instanceof l||(c=new l(c,this.options));let f=0;do{let y=this.build[f],b=c.build[f];if(Aoe("build compare",f,y,b),y===void 0&&b===void 0)return 0;if(b===void 0)return 1;if(y===void 0)return-1;if(y===b)continue;return CF(y,b)}while(++f)}inc(c,f,y){switch(c){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",f,y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",f,y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",f,y),this.inc("pre",f,y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",f,y),this.inc("pre",f,y);break;case"major":(this.minor!==0||this.patch!==0||this.prerelease.length===0)&&this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":(this.patch!==0||this.prerelease.length===0)&&this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":{let b=Number(y)?1:0;if(!f&&y===!1)throw new Error("invalid increment argument: identifier is empty");if(this.prerelease.length===0)this.prerelease=[b];else{let A=this.prerelease.length;for(;--A>=0;)typeof this.prerelease[A]=="number"&&(this.prerelease[A]++,A=-2);if(A===-1){if(f===this.prerelease.join(".")&&y===!1)throw new Error("invalid increment argument: identifier already exists");this.prerelease.push(b)}}if(f){let A=[f,b];y===!1&&(A=[f]),CF(this.prerelease[0],f)===0?isNaN(this.prerelease[1])&&(this.prerelease=A):this.prerelease=A}break}default:throw new Error(`invalid increment argument: ${c}`)}return this.raw=this.format(),this.build.length&&(this.raw+=`+${this.build.join(".")}`),this}};Cdt.exports=HDe});var H4=xt((HIr,kdt)=>{var Adt=i0(),opr=(l,c,f=!1)=>{if(l instanceof Adt)return l;try{return new Adt(l,c)}catch(y){if(!f)return null;throw y}};kdt.exports=opr});var Ndt=xt((GIr,Pdt)=>{var cpr=H4(),lpr=(l,c)=>{let f=cpr(l,c);return f?f.version:null};Pdt.exports=lpr});var wdt=xt((YIr,Ddt)=>{var upr=H4(),_pr=(l,c)=>{let f=upr(l.trim().replace(/^[=v]+/,""),c);return f?f.version:null};Ddt.exports=_pr});var Rdt=xt((KIr,Odt)=>{var Idt=i0(),fpr=(l,c,f,y,b)=>{typeof f=="string"&&(b=y,y=f,f=void 0);try{return new Idt(l instanceof Idt?l.version:l,f).inc(c,y,b).version}catch{return null}};Odt.exports=fpr});var Fdt=xt((XIr,Ldt)=>{var Mdt=H4(),ppr=(l,c)=>{let f=Mdt(l,null,!0),y=Mdt(c,null,!0),b=f.compare(y);if(b===0)return null;let A=b>0,g=A?f:y,p=A?y:f,k=!!g.prerelease.length;if(!!p.prerelease.length&&!k)return!p.patch&&!p.minor?"major":g.patch?"patch":g.minor?"minor":"major";let se=k?"pre":"";return f.major!==y.major?se+"major":f.minor!==y.minor?se+"minor":f.patch!==y.patch?se+"patch":"prerelease"};Ldt.exports=ppr});var Bdt=xt((QIr,jdt)=>{var dpr=i0(),mpr=(l,c)=>new dpr(l,c).major;jdt.exports=mpr});var Vdt=xt((ZIr,Udt)=>{var gpr=i0(),hpr=(l,c)=>new gpr(l,c).minor;Udt.exports=hpr});var qdt=xt((eOr,Jdt)=>{var ypr=i0(),vpr=(l,c)=>new ypr(l,c).patch;Jdt.exports=vpr});var Wdt=xt((tOr,zdt)=>{var Spr=H4(),bpr=(l,c)=>{let f=Spr(l,c);return f&&f.prerelease.length?f.prerelease:null};zdt.exports=bpr});var OT=xt((rOr,Hdt)=>{var $dt=i0(),Tpr=(l,c,f)=>new $dt(l,f).compare(new $dt(c,f));Hdt.exports=Tpr});var Ydt=xt((nOr,Gdt)=>{var Epr=OT(),xpr=(l,c,f)=>Epr(c,l,f);Gdt.exports=xpr});var Xdt=xt((iOr,Kdt)=>{var Cpr=OT(),Apr=(l,c)=>Cpr(l,c,!0);Kdt.exports=Apr});var Poe=xt((sOr,Zdt)=>{var Qdt=i0(),kpr=(l,c,f)=>{let y=new Qdt(l,f),b=new Qdt(c,f);return y.compare(b)||y.compareBuild(b)};Zdt.exports=kpr});var tmt=xt((aOr,emt)=>{var Ppr=Poe(),Npr=(l,c)=>l.sort((f,y)=>Ppr(f,y,c));emt.exports=Npr});var nmt=xt((oOr,rmt)=>{var Dpr=Poe(),wpr=(l,c)=>l.sort((f,y)=>Dpr(y,f,c));rmt.exports=wpr});var Jz=xt((cOr,imt)=>{var Ipr=OT(),Opr=(l,c,f)=>Ipr(l,c,f)>0;imt.exports=Opr});var Noe=xt((lOr,smt)=>{var Rpr=OT(),Mpr=(l,c,f)=>Rpr(l,c,f)<0;smt.exports=Mpr});var GDe=xt((uOr,amt)=>{var Lpr=OT(),Fpr=(l,c,f)=>Lpr(l,c,f)===0;amt.exports=Fpr});var YDe=xt((_Or,omt)=>{var jpr=OT(),Bpr=(l,c,f)=>jpr(l,c,f)!==0;omt.exports=Bpr});var Doe=xt((fOr,cmt)=>{var Upr=OT(),Vpr=(l,c,f)=>Upr(l,c,f)>=0;cmt.exports=Vpr});var woe=xt((pOr,lmt)=>{var Jpr=OT(),qpr=(l,c,f)=>Jpr(l,c,f)<=0;lmt.exports=qpr});var KDe=xt((dOr,umt)=>{var zpr=GDe(),Wpr=YDe(),$pr=Jz(),Hpr=Doe(),Gpr=Noe(),Ypr=woe(),Kpr=(l,c,f,y)=>{switch(c){case"===":return typeof l=="object"&&(l=l.version),typeof f=="object"&&(f=f.version),l===f;case"!==":return typeof l=="object"&&(l=l.version),typeof f=="object"&&(f=f.version),l!==f;case"":case"=":case"==":return zpr(l,f,y);case"!=":return Wpr(l,f,y);case">":return $pr(l,f,y);case">=":return Hpr(l,f,y);case"<":return Gpr(l,f,y);case"<=":return Ypr(l,f,y);default:throw new TypeError(`Invalid operator: ${c}`)}};umt.exports=Kpr});var fmt=xt((mOr,_mt)=>{var Xpr=i0(),Qpr=H4(),{safeRe:Ioe,t:Ooe}=xF(),Zpr=(l,c)=>{if(l instanceof Xpr)return l;if(typeof l=="number"&&(l=String(l)),typeof l!="string")return null;c=c||{};let f=null;if(!c.rtl)f=l.match(c.includePrerelease?Ioe[Ooe.COERCEFULL]:Ioe[Ooe.COERCE]);else{let k=c.includePrerelease?Ioe[Ooe.COERCERTLFULL]:Ioe[Ooe.COERCERTL],j;for(;(j=k.exec(l))&&(!f||f.index+f[0].length!==l.length);)(!f||j.index+j[0].length!==f.index+f[0].length)&&(f=j),k.lastIndex=j.index+j[1].length+j[2].length;k.lastIndex=-1}if(f===null)return null;let y=f[2],b=f[3]||"0",A=f[4]||"0",g=c.includePrerelease&&f[5]?`-${f[5]}`:"",p=c.includePrerelease&&f[6]?`+${f[6]}`:"";return Qpr(`${y}.${b}.${A}${g}${p}`,c)};_mt.exports=Zpr});var dmt=xt((gOr,pmt)=>{var XDe=class{constructor(){this.max=1e3,this.map=new Map}get(c){let f=this.map.get(c);if(f!==void 0)return this.map.delete(c),this.map.set(c,f),f}delete(c){return this.map.delete(c)}set(c,f){if(!this.delete(c)&&f!==void 0){if(this.map.size>=this.max){let b=this.map.keys().next().value;this.delete(b)}this.map.set(c,f)}return this}};pmt.exports=XDe});var RT=xt((hOr,ymt)=>{var edr=/\s+/g,QDe=class l{constructor(c,f){if(f=rdr(f),c instanceof l)return c.loose===!!f.loose&&c.includePrerelease===!!f.includePrerelease?c:new l(c.raw,f);if(c instanceof ZDe)return this.raw=c.value,this.set=[[c]],this.formatted=void 0,this;if(this.options=f,this.loose=!!f.loose,this.includePrerelease=!!f.includePrerelease,this.raw=c.trim().replace(edr," "),this.set=this.raw.split("||").map(y=>this.parseRange(y.trim())).filter(y=>y.length),!this.set.length)throw new TypeError(`Invalid SemVer Range: ${this.raw}`);if(this.set.length>1){let y=this.set[0];if(this.set=this.set.filter(b=>!gmt(b[0])),this.set.length===0)this.set=[y];else if(this.set.length>1){for(let b of this.set)if(b.length===1&&ldr(b[0])){this.set=[b];break}}}this.formatted=void 0}get range(){if(this.formatted===void 0){this.formatted="";for(let c=0;c<this.set.length;c++){c>0&&(this.formatted+="||");let f=this.set[c];for(let y=0;y<f.length;y++)y>0&&(this.formatted+=" "),this.formatted+=f[y].toString().trim()}}return this.formatted}format(){return this.range}toString(){return this.range}parseRange(c){let y=((this.options.includePrerelease&&odr)|(this.options.loose&&cdr))+":"+c,b=mmt.get(y);if(b)return b;let A=this.options.loose,g=A?C1[cv.HYPHENRANGELOOSE]:C1[cv.HYPHENRANGE];c=c.replace(g,vdr(this.options.includePrerelease)),Cp("hyphen replace",c),c=c.replace(C1[cv.COMPARATORTRIM],idr),Cp("comparator trim",c),c=c.replace(C1[cv.TILDETRIM],sdr),Cp("tilde trim",c),c=c.replace(C1[cv.CARETTRIM],adr),Cp("caret trim",c);let p=c.split(" ").map(ze=>udr(ze,this.options)).join(" ").split(/\s+/).map(ze=>ydr(ze,this.options));A&&(p=p.filter(ze=>(Cp("loose invalid filter",ze,this.options),!!ze.match(C1[cv.COMPARATORLOOSE])))),Cp("range list",p);let k=new Map,j=p.map(ze=>new ZDe(ze,this.options));for(let ze of j){if(gmt(ze))return[ze];k.set(ze.value,ze)}k.size>1&&k.has("")&&k.delete("");let se=[...k.values()];return mmt.set(y,se),se}intersects(c,f){if(!(c instanceof l))throw new TypeError("a Range is required");return this.set.some(y=>hmt(y,f)&&c.set.some(b=>hmt(b,f)&&y.every(A=>b.every(g=>A.intersects(g,f)))))}test(c){if(!c)return!1;if(typeof c=="string")try{c=new ndr(c,this.options)}catch{return!1}for(let f=0;f<this.set.length;f++)if(Sdr(this.set[f],c,this.options))return!0;return!1}};ymt.exports=QDe;var tdr=dmt(),mmt=new tdr,rdr=Coe(),ZDe=qz(),Cp=Vz(),ndr=i0(),{safeRe:C1,t:cv,comparatorTrimReplace:idr,tildeTrimReplace:sdr,caretTrimReplace:adr}=xF(),{FLAG_INCLUDE_PRERELEASE:odr,FLAG_LOOSE:cdr}=Uz(),gmt=l=>l.value==="<0.0.0-0",ldr=l=>l.value==="",hmt=(l,c)=>{let f=!0,y=l.slice(),b=y.pop();for(;f&&y.length;)f=y.every(A=>b.intersects(A,c)),b=y.pop();return f},udr=(l,c)=>(Cp("comp",l,c),l=pdr(l,c),Cp("caret",l),l=_dr(l,c),Cp("tildes",l),l=mdr(l,c),Cp("xrange",l),l=hdr(l,c),Cp("stars",l),l),lv=l=>!l||l.toLowerCase()==="x"||l==="*",_dr=(l,c)=>l.trim().split(/\s+/).map(f=>fdr(f,c)).join(" "),fdr=(l,c)=>{let f=c.loose?C1[cv.TILDELOOSE]:C1[cv.TILDE];return l.replace(f,(y,b,A,g,p)=>{Cp("tilde",l,y,b,A,g,p);let k;return lv(b)?k="":lv(A)?k=`>=${b}.0.0 <${+b+1}.0.0-0`:lv(g)?k=`>=${b}.${A}.0 <${b}.${+A+1}.0-0`:p?(Cp("replaceTilde pr",p),k=`>=${b}.${A}.${g}-${p} <${b}.${+A+1}.0-0`):k=`>=${b}.${A}.${g} <${b}.${+A+1}.0-0`,Cp("tilde return",k),k})},pdr=(l,c)=>l.trim().split(/\s+/).map(f=>ddr(f,c)).join(" "),ddr=(l,c)=>{Cp("caret",l,c);let f=c.loose?C1[cv.CARETLOOSE]:C1[cv.CARET],y=c.includePrerelease?"-0":"";return l.replace(f,(b,A,g,p,k)=>{Cp("caret",l,b,A,g,p,k);let j;return lv(A)?j="":lv(g)?j=`>=${A}.0.0${y} <${+A+1}.0.0-0`:lv(p)?A==="0"?j=`>=${A}.${g}.0${y} <${A}.${+g+1}.0-0`:j=`>=${A}.${g}.0${y} <${+A+1}.0.0-0`:k?(Cp("replaceCaret pr",k),A==="0"?g==="0"?j=`>=${A}.${g}.${p}-${k} <${A}.${g}.${+p+1}-0`:j=`>=${A}.${g}.${p}-${k} <${A}.${+g+1}.0-0`:j=`>=${A}.${g}.${p}-${k} <${+A+1}.0.0-0`):(Cp("no pr"),A==="0"?g==="0"?j=`>=${A}.${g}.${p}${y} <${A}.${g}.${+p+1}-0`:j=`>=${A}.${g}.${p}${y} <${A}.${+g+1}.0-0`:j=`>=${A}.${g}.${p} <${+A+1}.0.0-0`),Cp("caret return",j),j})},mdr=(l,c)=>(Cp("replaceXRanges",l,c),l.split(/\s+/).map(f=>gdr(f,c)).join(" ")),gdr=(l,c)=>{l=l.trim();let f=c.loose?C1[cv.XRANGELOOSE]:C1[cv.XRANGE];return l.replace(f,(y,b,A,g,p,k)=>{Cp("xRange",l,y,b,A,g,p,k);let j=lv(A),se=j||lv(g),ze=se||lv(p),ve=ze;return b==="="&&ve&&(b=""),k=c.includePrerelease?"-0":"",j?b===">"||b==="<"?y="<0.0.0-0":y="*":b&&ve?(se&&(g=0),p=0,b===">"?(b=">=",se?(A=+A+1,g=0,p=0):(g=+g+1,p=0)):b==="<="&&(b="<",se?A=+A+1:g=+g+1),b==="<"&&(k="-0"),y=`${b+A}.${g}.${p}${k}`):se?y=`>=${A}.0.0${k} <${+A+1}.0.0-0`:ze&&(y=`>=${A}.${g}.0${k} <${A}.${+g+1}.0-0`),Cp("xRange return",y),y})},hdr=(l,c)=>(Cp("replaceStars",l,c),l.trim().replace(C1[cv.STAR],"")),ydr=(l,c)=>(Cp("replaceGTE0",l,c),l.trim().replace(C1[c.includePrerelease?cv.GTE0PRE:cv.GTE0],"")),vdr=l=>(c,f,y,b,A,g,p,k,j,se,ze,ve)=>(lv(y)?f="":lv(b)?f=`>=${y}.0.0${l?"-0":""}`:lv(A)?f=`>=${y}.${b}.0${l?"-0":""}`:g?f=`>=${f}`:f=`>=${f}${l?"-0":""}`,lv(j)?k="":lv(se)?k=`<${+j+1}.0.0-0`:lv(ze)?k=`<${j}.${+se+1}.0-0`:ve?k=`<=${j}.${se}.${ze}-${ve}`:l?k=`<${j}.${se}.${+ze+1}-0`:k=`<=${k}`,`${f} ${k}`.trim()),Sdr=(l,c,f)=>{for(let y=0;y<l.length;y++)if(!l[y].test(c))return!1;if(c.prerelease.length&&!f.includePrerelease){for(let y=0;y<l.length;y++)if(Cp(l[y].semver),l[y].semver!==ZDe.ANY&&l[y].semver.prerelease.length>0){let b=l[y].semver;if(b.major===c.major&&b.minor===c.minor&&b.patch===c.patch)return!0}return!1}return!0}});var qz=xt((yOr,xmt)=>{var zz=Symbol("SemVer ANY"),rwe=class l{static get ANY(){return zz}constructor(c,f){if(f=vmt(f),c instanceof l){if(c.loose===!!f.loose)return c;c=c.value}c=c.trim().split(/\s+/).join(" "),twe("comparator",c,f),this.options=f,this.loose=!!f.loose,this.parse(c),this.semver===zz?this.value="":this.value=this.operator+this.semver.version,twe("comp",this)}parse(c){let f=this.options.loose?Smt[bmt.COMPARATORLOOSE]:Smt[bmt.COMPARATOR],y=c.match(f);if(!y)throw new TypeError(`Invalid comparator: ${c}`);this.operator=y[1]!==void 0?y[1]:"",this.operator==="="&&(this.operator=""),y[2]?this.semver=new Tmt(y[2],this.options.loose):this.semver=zz}toString(){return this.value}test(c){if(twe("Comparator.test",c,this.options.loose),this.semver===zz||c===zz)return!0;if(typeof c=="string")try{c=new Tmt(c,this.options)}catch{return!1}return ewe(c,this.operator,this.semver,this.options)}intersects(c,f){if(!(c instanceof l))throw new TypeError("a Comparator is required");return this.operator===""?this.value===""?!0:new Emt(c.value,f).test(this.value):c.operator===""?c.value===""?!0:new Emt(this.value,f).test(c.semver):(f=vmt(f),f.includePrerelease&&(this.value==="<0.0.0-0"||c.value==="<0.0.0-0")||!f.includePrerelease&&(this.value.startsWith("<0.0.0")||c.value.startsWith("<0.0.0"))?!1:!!(this.operator.startsWith(">")&&c.operator.startsWith(">")||this.operator.startsWith("<")&&c.operator.startsWith("<")||this.semver.version===c.semver.version&&this.operator.includes("=")&&c.operator.includes("=")||ewe(this.semver,"<",c.semver,f)&&this.operator.startsWith(">")&&c.operator.startsWith("<")||ewe(this.semver,">",c.semver,f)&&this.operator.startsWith("<")&&c.operator.startsWith(">")))}};xmt.exports=rwe;var vmt=Coe(),{safeRe:Smt,t:bmt}=xF(),ewe=KDe(),twe=Vz(),Tmt=i0(),Emt=RT()});var Wz=xt((vOr,Cmt)=>{var bdr=RT(),Tdr=(l,c,f)=>{try{c=new bdr(c,f)}catch{return!1}return c.test(l)};Cmt.exports=Tdr});var kmt=xt((SOr,Amt)=>{var Edr=RT(),xdr=(l,c)=>new Edr(l,c).set.map(f=>f.map(y=>y.value).join(" ").trim().split(" "));Amt.exports=xdr});var Nmt=xt((bOr,Pmt)=>{var Cdr=i0(),Adr=RT(),kdr=(l,c,f)=>{let y=null,b=null,A=null;try{A=new Adr(c,f)}catch{return null}return l.forEach(g=>{A.test(g)&&(!y||b.compare(g)===-1)&&(y=g,b=new Cdr(y,f))}),y};Pmt.exports=kdr});var wmt=xt((TOr,Dmt)=>{var Pdr=i0(),Ndr=RT(),Ddr=(l,c,f)=>{let y=null,b=null,A=null;try{A=new Ndr(c,f)}catch{return null}return l.forEach(g=>{A.test(g)&&(!y||b.compare(g)===1)&&(y=g,b=new Pdr(y,f))}),y};Dmt.exports=Ddr});var Rmt=xt((EOr,Omt)=>{var nwe=i0(),wdr=RT(),Imt=Jz(),Idr=(l,c)=>{l=new wdr(l,c);let f=new nwe("0.0.0");if(l.test(f)||(f=new nwe("0.0.0-0"),l.test(f)))return f;f=null;for(let y=0;y<l.set.length;++y){let b=l.set[y],A=null;b.forEach(g=>{let p=new nwe(g.semver.version);switch(g.operator){case">":p.prerelease.length===0?p.patch++:p.prerelease.push(0),p.raw=p.format();case"":case">=":(!A||Imt(p,A))&&(A=p);break;case"<":case"<=":break;default:throw new Error(`Unexpected operation: ${g.operator}`)}}),A&&(!f||Imt(f,A))&&(f=A)}return f&&l.test(f)?f:null};Omt.exports=Idr});var Lmt=xt((xOr,Mmt)=>{var Odr=RT(),Rdr=(l,c)=>{try{return new Odr(l,c).range||"*"}catch{return null}};Mmt.exports=Rdr});var Roe=xt((COr,Umt)=>{var Mdr=i0(),Bmt=qz(),{ANY:Ldr}=Bmt,Fdr=RT(),jdr=Wz(),Fmt=Jz(),jmt=Noe(),Bdr=woe(),Udr=Doe(),Vdr=(l,c,f,y)=>{l=new Mdr(l,y),c=new Fdr(c,y);let b,A,g,p,k;switch(f){case">":b=Fmt,A=Bdr,g=jmt,p=">",k=">=";break;case"<":b=jmt,A=Udr,g=Fmt,p="<",k="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(jdr(l,c,y))return!1;for(let j=0;j<c.set.length;++j){let se=c.set[j],ze=null,ve=null;if(se.forEach(lr=>{lr.semver===Ldr&&(lr=new Bmt(">=0.0.0")),ze=ze||lr,ve=ve||lr,b(lr.semver,ze.semver,y)?ze=lr:g(lr.semver,ve.semver,y)&&(ve=lr)}),ze.operator===p||ze.operator===k||(!ve.operator||ve.operator===p)&&A(l,ve.semver))return!1;if(ve.operator===k&&g(l,ve.semver))return!1}return!0};Umt.exports=Vdr});var Jmt=xt((AOr,Vmt)=>{var Jdr=Roe(),qdr=(l,c,f)=>Jdr(l,c,">",f);Vmt.exports=qdr});var zmt=xt((kOr,qmt)=>{var zdr=Roe(),Wdr=(l,c,f)=>zdr(l,c,"<",f);qmt.exports=Wdr});var Hmt=xt((POr,$mt)=>{var Wmt=RT(),$dr=(l,c,f)=>(l=new Wmt(l,f),c=new Wmt(c,f),l.intersects(c,f));$mt.exports=$dr});var Ymt=xt((NOr,Gmt)=>{var Hdr=Wz(),Gdr=OT();Gmt.exports=(l,c,f)=>{let y=[],b=null,A=null,g=l.sort((se,ze)=>Gdr(se,ze,f));for(let se of g)Hdr(se,c,f)?(A=se,b||(b=se)):(A&&y.push([b,A]),A=null,b=null);b&&y.push([b,null]);let p=[];for(let[se,ze]of y)se===ze?p.push(se):!ze&&se===g[0]?p.push("*"):ze?se===g[0]?p.push(`<=${ze}`):p.push(`${se} - ${ze}`):p.push(`>=${se}`);let k=p.join(" || "),j=typeof c.raw=="string"?c.raw:String(c);return k.length<j.length?k:c}});var tgt=xt((DOr,egt)=>{var Kmt=RT(),swe=qz(),{ANY:iwe}=swe,$z=Wz(),awe=OT(),Ydr=(l,c,f={})=>{if(l===c)return!0;l=new Kmt(l,f),c=new Kmt(c,f);let y=!1;e:for(let b of l.set){for(let A of c.set){let g=Xdr(b,A,f);if(y=y||g!==null,g)continue e}if(y)return!1}return!0},Kdr=[new swe(">=0.0.0-0")],Xmt=[new swe(">=0.0.0")],Xdr=(l,c,f)=>{if(l===c)return!0;if(l.length===1&&l[0].semver===iwe){if(c.length===1&&c[0].semver===iwe)return!0;f.includePrerelease?l=Kdr:l=Xmt}if(c.length===1&&c[0].semver===iwe){if(f.includePrerelease)return!0;c=Xmt}let y=new Set,b,A;for(let lr of l)lr.operator===">"||lr.operator===">="?b=Qmt(b,lr,f):lr.operator==="<"||lr.operator==="<="?A=Zmt(A,lr,f):y.add(lr.semver);if(y.size>1)return null;let g;if(b&&A){if(g=awe(b.semver,A.semver,f),g>0)return null;if(g===0&&(b.operator!==">="||A.operator!=="<="))return null}for(let lr of y){if(b&&!$z(lr,String(b),f)||A&&!$z(lr,String(A),f))return null;for(let Br of c)if(!$z(lr,String(Br),f))return!1;return!0}let p,k,j,se,ze=A&&!f.includePrerelease&&A.semver.prerelease.length?A.semver:!1,ve=b&&!f.includePrerelease&&b.semver.prerelease.length?b.semver:!1;ze&&ze.prerelease.length===1&&A.operator==="<"&&ze.prerelease[0]===0&&(ze=!1);for(let lr of c){if(se=se||lr.operator===">"||lr.operator===">=",j=j||lr.operator==="<"||lr.operator==="<=",b){if(ve&&lr.semver.prerelease&&lr.semver.prerelease.length&&lr.semver.major===ve.major&&lr.semver.minor===ve.minor&&lr.semver.patch===ve.patch&&(ve=!1),lr.operator===">"||lr.operator===">="){if(p=Qmt(b,lr,f),p===lr&&p!==b)return!1}else if(b.operator===">="&&!$z(b.semver,String(lr),f))return!1}if(A){if(ze&&lr.semver.prerelease&&lr.semver.prerelease.length&&lr.semver.major===ze.major&&lr.semver.minor===ze.minor&&lr.semver.patch===ze.patch&&(ze=!1),lr.operator==="<"||lr.operator==="<="){if(k=Zmt(A,lr,f),k===lr&&k!==A)return!1}else if(A.operator==="<="&&!$z(A.semver,String(lr),f))return!1}if(!lr.operator&&(A||b)&&g!==0)return!1}return!(b&&j&&!A&&g!==0||A&&se&&!b&&g!==0||ve||ze)},Qmt=(l,c,f)=>{if(!l)return c;let y=awe(l.semver,c.semver,f);return y>0?l:y<0||c.operator===">"&&l.operator===">="?c:l},Zmt=(l,c,f)=>{if(!l)return c;let y=awe(l.semver,c.semver,f);return y<0?l:y>0||c.operator==="<"&&l.operator==="<="?c:l};egt.exports=Ydr});var sgt=xt((wOr,igt)=>{var owe=xF(),rgt=Uz(),Qdr=i0(),ngt=$De(),Zdr=H4(),emr=Ndt(),tmr=wdt(),rmr=Rdt(),nmr=Fdt(),imr=Bdt(),smr=Vdt(),amr=qdt(),omr=Wdt(),cmr=OT(),lmr=Ydt(),umr=Xdt(),_mr=Poe(),fmr=tmt(),pmr=nmt(),dmr=Jz(),mmr=Noe(),gmr=GDe(),hmr=YDe(),ymr=Doe(),vmr=woe(),Smr=KDe(),bmr=fmt(),Tmr=qz(),Emr=RT(),xmr=Wz(),Cmr=kmt(),Amr=Nmt(),kmr=wmt(),Pmr=Rmt(),Nmr=Lmt(),Dmr=Roe(),wmr=Jmt(),Imr=zmt(),Omr=Hmt(),Rmr=Ymt(),Mmr=tgt();igt.exports={parse:Zdr,valid:emr,clean:tmr,inc:rmr,diff:nmr,major:imr,minor:smr,patch:amr,prerelease:omr,compare:cmr,rcompare:lmr,compareLoose:umr,compareBuild:_mr,sort:fmr,rsort:pmr,gt:dmr,lt:mmr,eq:gmr,neq:hmr,gte:ymr,lte:vmr,cmp:Smr,coerce:bmr,Comparator:Tmr,Range:Emr,satisfies:xmr,toComparators:Cmr,maxSatisfying:Amr,minSatisfying:kmr,minVersion:Pmr,validRange:Nmr,outside:Dmr,gtr:wmr,ltr:Imr,intersects:Omr,simplifyRange:Rmr,subset:Mmr,SemVer:Qdr,re:owe.re,src:owe.src,tokens:owe.t,SEMVER_SPEC_VERSION:rgt.SEMVER_SPEC_VERSION,RELEASE_TYPES:rgt.RELEASE_TYPES,compareIdentifiers:ngt.compareIdentifiers,rcompareIdentifiers:ngt.rcompareIdentifiers}});var Yz=xt(Vu=>{"use strict";Object.defineProperty(Vu,"__esModule",{value:!0});Vu.regexpCode=Vu.getEsmExportName=Vu.getProperty=Vu.safeStringify=Vu.stringify=Vu.strConcat=Vu.addCodeArg=Vu.str=Vu._=Vu.nil=Vu._Code=Vu.Name=Vu.IDENTIFIER=Vu._CodeOrName=void 0;var Hz=class{};Vu._CodeOrName=Hz;Vu.IDENTIFIER=/^[a-z$_][a-z$_0-9]*$/i;var K4=class extends Hz{constructor(c){if(super(),!Vu.IDENTIFIER.test(c))throw new Error("CodeGen: name must be a valid identifier");this.str=c}toString(){return this.str}emptyStr(){return!1}get names(){return{[this.str]:1}}};Vu.Name=K4;var LT=class extends Hz{constructor(c){super(),this._items=typeof c=="string"?[c]:c}toString(){return this.str}emptyStr(){if(this._items.length>1)return!1;let c=this._items[0];return c===""||c==='""'}get str(){var c;return(c=this._str)!==null&&c!==void 0?c:this._str=this._items.reduce((f,y)=>`${f}${y}`,"")}get names(){var c;return(c=this._names)!==null&&c!==void 0?c:this._names=this._items.reduce((f,y)=>(y instanceof K4&&(f[y.str]=(f[y.str]||0)+1),f),{})}};Vu._Code=LT;Vu.nil=new LT("");function bgt(l,...c){let f=[l[0]],y=0;for(;y<c.length;)uwe(f,c[y]),f.push(l[++y]);return new LT(f)}Vu._=bgt;var lwe=new LT("+");function Tgt(l,...c){let f=[Gz(l[0])],y=0;for(;y<c.length;)f.push(lwe),uwe(f,c[y]),f.push(lwe,Gz(l[++y]));return Fmr(f),new LT(f)}Vu.str=Tgt;function uwe(l,c){c instanceof LT?l.push(...c._items):c instanceof K4?l.push(c):l.push(Umr(c))}Vu.addCodeArg=uwe;function Fmr(l){let c=1;for(;c<l.length-1;){if(l[c]===lwe){let f=jmr(l[c-1],l[c+1]);if(f!==void 0){l.splice(c-1,3,f);continue}l[c++]="+"}c++}}function jmr(l,c){if(c==='""')return l;if(l==='""')return c;if(typeof l=="string")return c instanceof K4||l[l.length-1]!=='"'?void 0:typeof c!="string"?`${l.slice(0,-1)}${c}"`:c[0]==='"'?l.slice(0,-1)+c.slice(1):void 0;if(typeof c=="string"&&c[0]==='"'&&!(l instanceof K4))return`"${l}${c.slice(1)}`}function Bmr(l,c){return c.emptyStr()?l:l.emptyStr()?c:Tgt`${l}${c}`}Vu.strConcat=Bmr;function Umr(l){return typeof l=="number"||typeof l=="boolean"||l===null?l:Gz(Array.isArray(l)?l.join(","):l)}function Vmr(l){return new LT(Gz(l))}Vu.stringify=Vmr;function Gz(l){return JSON.stringify(l).replace(/\u2028/g,"\\u2028").replace(/\u2029/g,"\\u2029")}Vu.safeStringify=Gz;function Jmr(l){return typeof l=="string"&&Vu.IDENTIFIER.test(l)?new LT(`.${l}`):bgt`[${l}]`}Vu.getProperty=Jmr;function qmr(l){if(typeof l=="string"&&Vu.IDENTIFIER.test(l))return new LT(`${l}`);throw new Error(`CodeGen: invalid export name: ${l}, use explicit $id name mapping`)}Vu.getEsmExportName=qmr;function zmr(l){return new LT(l.toString())}Vu.regexpCode=zmr});var pwe=xt(k1=>{"use strict";Object.defineProperty(k1,"__esModule",{value:!0});k1.ValueScope=k1.ValueScopeName=k1.Scope=k1.varKinds=k1.UsedValueState=void 0;var A1=Yz(),_we=class extends Error{constructor(c){super(`CodeGen: "code" for ${c} not defined`),this.value=c.value}},Goe;(function(l){l[l.Started=0]="Started",l[l.Completed=1]="Completed"})(Goe||(k1.UsedValueState=Goe={}));k1.varKinds={const:new A1.Name("const"),let:new A1.Name("let"),var:new A1.Name("var")};var Yoe=class{constructor({prefixes:c,parent:f}={}){this._names={},this._prefixes=c,this._parent=f}toName(c){return c instanceof A1.Name?c:this.name(c)}name(c){return new A1.Name(this._newName(c))}_newName(c){let f=this._names[c]||this._nameGroup(c);return`${c}${f.index++}`}_nameGroup(c){var f,y;if(!((y=(f=this._parent)===null||f===void 0?void 0:f._prefixes)===null||y===void 0)&&y.has(c)||this._prefixes&&!this._prefixes.has(c))throw new Error(`CodeGen: prefix "${c}" is not allowed in this scope`);return this._names[c]={prefix:c,index:0}}};k1.Scope=Yoe;var Koe=class extends A1.Name{constructor(c,f){super(f),this.prefix=c}setValue(c,{property:f,itemIndex:y}){this.value=c,this.scopePath=(0,A1._)`.${new A1.Name(f)}[${y}]`}};k1.ValueScopeName=Koe;var Wmr=(0,A1._)`\n`,fwe=class extends Yoe{constructor(c){super(c),this._values={},this._scope=c.scope,this.opts={...c,_n:c.lines?Wmr:A1.nil}}get(){return this._scope}name(c){return new Koe(c,this._newName(c))}value(c,f){var y;if(f.ref===void 0)throw new Error("CodeGen: ref must be passed in value");let b=this.toName(c),{prefix:A}=b,g=(y=f.key)!==null&&y!==void 0?y:f.ref,p=this._values[A];if(p){let se=p.get(g);if(se)return se}else p=this._values[A]=new Map;p.set(g,b);let k=this._scope[A]||(this._scope[A]=[]),j=k.length;return k[j]=f.ref,b.setValue(f,{property:A,itemIndex:j}),b}getValue(c,f){let y=this._values[c];if(y)return y.get(f)}scopeRefs(c,f=this._values){return this._reduceValues(f,y=>{if(y.scopePath===void 0)throw new Error(`CodeGen: name "${y}" has no value`);return(0,A1._)`${c}${y.scopePath}`})}scopeCode(c=this._values,f,y){return this._reduceValues(c,b=>{if(b.value===void 0)throw new Error(`CodeGen: name "${b}" has no value`);return b.value.code},f,y)}_reduceValues(c,f,y={},b){let A=A1.nil;for(let g in c){let p=c[g];if(!p)continue;let k=y[g]=y[g]||new Map;p.forEach(j=>{if(k.has(j))return;k.set(j,Goe.Started);let se=f(j);if(se){let ze=this.opts.es5?k1.varKinds.var:k1.varKinds.const;A=(0,A1._)`${A}${ze} ${j} = ${se};${this.opts._n}`}else if(se=b?.(j))A=(0,A1._)`${A}${se}${this.opts._n}`;else throw new _we(j);k.set(j,Goe.Completed)})}return A}};k1.ValueScope=fwe});var Yl=xt(Bl=>{"use strict";Object.defineProperty(Bl,"__esModule",{value:!0});Bl.or=Bl.and=Bl.not=Bl.CodeGen=Bl.operators=Bl.varKinds=Bl.ValueScopeName=Bl.ValueScope=Bl.Scope=Bl.Name=Bl.regexpCode=Bl.stringify=Bl.getProperty=Bl.nil=Bl.strConcat=Bl.str=Bl._=void 0;var Pu=Yz(),kx=pwe(),Iw=Yz();Object.defineProperty(Bl,"_",{enumerable:!0,get:function(){return Iw._}});Object.defineProperty(Bl,"str",{enumerable:!0,get:function(){return Iw.str}});Object.defineProperty(Bl,"strConcat",{enumerable:!0,get:function(){return Iw.strConcat}});Object.defineProperty(Bl,"nil",{enumerable:!0,get:function(){return Iw.nil}});Object.defineProperty(Bl,"getProperty",{enumerable:!0,get:function(){return Iw.getProperty}});Object.defineProperty(Bl,"stringify",{enumerable:!0,get:function(){return Iw.stringify}});Object.defineProperty(Bl,"regexpCode",{enumerable:!0,get:function(){return Iw.regexpCode}});Object.defineProperty(Bl,"Name",{enumerable:!0,get:function(){return Iw.Name}});var ece=pwe();Object.defineProperty(Bl,"Scope",{enumerable:!0,get:function(){return ece.Scope}});Object.defineProperty(Bl,"ValueScope",{enumerable:!0,get:function(){return ece.ValueScope}});Object.defineProperty(Bl,"ValueScopeName",{enumerable:!0,get:function(){return ece.ValueScopeName}});Object.defineProperty(Bl,"varKinds",{enumerable:!0,get:function(){return ece.varKinds}});Bl.operators={GT:new Pu._Code(">"),GTE:new Pu._Code(">="),LT:new Pu._Code("<"),LTE:new Pu._Code("<="),EQ:new Pu._Code("==="),NEQ:new Pu._Code("!=="),NOT:new Pu._Code("!"),OR:new Pu._Code("||"),AND:new Pu._Code("&&"),ADD:new Pu._Code("+")};var hP=class{optimizeNodes(){return this}optimizeNames(c,f){return this}},dwe=class extends hP{constructor(c,f,y){super(),this.varKind=c,this.name=f,this.rhs=y}render({es5:c,_n:f}){let y=c?kx.varKinds.var:this.varKind,b=this.rhs===void 0?"":` = ${this.rhs}`;return`${y} ${this.name}${b};`+f}optimizeNames(c,f){if(c[this.name.str])return this.rhs&&(this.rhs=IF(this.rhs,c,f)),this}get names(){return this.rhs instanceof Pu._CodeOrName?this.rhs.names:{}}},Xoe=class extends hP{constructor(c,f,y){super(),this.lhs=c,this.rhs=f,this.sideEffects=y}render({_n:c}){return`${this.lhs} = ${this.rhs};`+c}optimizeNames(c,f){if(!(this.lhs instanceof Pu.Name&&!c[this.lhs.str]&&!this.sideEffects))return this.rhs=IF(this.rhs,c,f),this}get names(){let c=this.lhs instanceof Pu.Name?{}:{...this.lhs.names};return Zoe(c,this.rhs)}},mwe=class extends Xoe{constructor(c,f,y,b){super(c,y,b),this.op=f}render({_n:c}){return`${this.lhs} ${this.op}= ${this.rhs};`+c}},gwe=class extends hP{constructor(c){super(),this.label=c,this.names={}}render({_n:c}){return`${this.label}:`+c}},hwe=class extends hP{constructor(c){super(),this.label=c,this.names={}}render({_n:c}){return`break${this.label?` ${this.label}`:""};`+c}},ywe=class extends hP{constructor(c){super(),this.error=c}render({_n:c}){return`throw ${this.error};`+c}get names(){return this.error.names}},vwe=class extends hP{constructor(c){super(),this.code=c}render({_n:c}){return`${this.code};`+c}optimizeNodes(){return`${this.code}`?this:void 0}optimizeNames(c,f){return this.code=IF(this.code,c,f),this}get names(){return this.code instanceof Pu._CodeOrName?this.code.names:{}}},Kz=class extends hP{constructor(c=[]){super(),this.nodes=c}render(c){return this.nodes.reduce((f,y)=>f+y.render(c),"")}optimizeNodes(){let{nodes:c}=this,f=c.length;for(;f--;){let y=c[f].optimizeNodes();Array.isArray(y)?c.splice(f,1,...y):y?c[f]=y:c.splice(f,1)}return c.length>0?this:void 0}optimizeNames(c,f){let{nodes:y}=this,b=y.length;for(;b--;){let A=y[b];A.optimizeNames(c,f)||($mr(c,A.names),y.splice(b,1))}return y.length>0?this:void 0}get names(){return this.nodes.reduce((c,f)=>Z4(c,f.names),{})}},yP=class extends Kz{render(c){return"{"+c._n+super.render(c)+"}"+c._n}},Swe=class extends Kz{},wF=class extends yP{};wF.kind="else";var X4=class l extends yP{constructor(c,f){super(f),this.condition=c}render(c){let f=`if(${this.condition})`+super.render(c);return this.else&&(f+="else "+this.else.render(c)),f}optimizeNodes(){super.optimizeNodes();let c=this.condition;if(c===!0)return this.nodes;let f=this.else;if(f){let y=f.optimizeNodes();f=this.else=Array.isArray(y)?new wF(y):y}if(f)return c===!1?f instanceof l?f:f.nodes:this.nodes.length?this:new l(Egt(c),f instanceof l?[f]:f.nodes);if(!(c===!1||!this.nodes.length))return this}optimizeNames(c,f){var y;if(this.else=(y=this.else)===null||y===void 0?void 0:y.optimizeNames(c,f),!!(super.optimizeNames(c,f)||this.else))return this.condition=IF(this.condition,c,f),this}get names(){let c=super.names;return Zoe(c,this.condition),this.else&&Z4(c,this.else.names),c}};X4.kind="if";var Q4=class extends yP{};Q4.kind="for";var bwe=class extends Q4{constructor(c){super(),this.iteration=c}render(c){return`for(${this.iteration})`+super.render(c)}optimizeNames(c,f){if(super.optimizeNames(c,f))return this.iteration=IF(this.iteration,c,f),this}get names(){return Z4(super.names,this.iteration.names)}},Twe=class extends Q4{constructor(c,f,y,b){super(),this.varKind=c,this.name=f,this.from=y,this.to=b}render(c){let f=c.es5?kx.varKinds.var:this.varKind,{name:y,from:b,to:A}=this;return`for(${f} ${y}=${b}; ${y}<${A}; ${y}++)`+super.render(c)}get names(){let c=Zoe(super.names,this.from);return Zoe(c,this.to)}},Qoe=class extends Q4{constructor(c,f,y,b){super(),this.loop=c,this.varKind=f,this.name=y,this.iterable=b}render(c){return`for(${this.varKind} ${this.name} ${this.loop} ${this.iterable})`+super.render(c)}optimizeNames(c,f){if(super.optimizeNames(c,f))return this.iterable=IF(this.iterable,c,f),this}get names(){return Z4(super.names,this.iterable.names)}},Xz=class extends yP{constructor(c,f,y){super(),this.name=c,this.args=f,this.async=y}render(c){return`${this.async?"async ":""}function ${this.name}(${this.args})`+super.render(c)}};Xz.kind="func";var Qz=class extends Kz{render(c){return"return "+super.render(c)}};Qz.kind="return";var Ewe=class extends yP{render(c){let f="try"+super.render(c);return this.catch&&(f+=this.catch.render(c)),this.finally&&(f+=this.finally.render(c)),f}optimizeNodes(){var c,f;return super.optimizeNodes(),(c=this.catch)===null||c===void 0||c.optimizeNodes(),(f=this.finally)===null||f===void 0||f.optimizeNodes(),this}optimizeNames(c,f){var y,b;return super.optimizeNames(c,f),(y=this.catch)===null||y===void 0||y.optimizeNames(c,f),(b=this.finally)===null||b===void 0||b.optimizeNames(c,f),this}get names(){let c=super.names;return this.catch&&Z4(c,this.catch.names),this.finally&&Z4(c,this.finally.names),c}},Zz=class extends yP{constructor(c){super(),this.error=c}render(c){return`catch(${this.error})`+super.render(c)}};Zz.kind="catch";var eW=class extends yP{render(c){return"finally"+super.render(c)}};eW.kind="finally";var xwe=class{constructor(c,f={}){this._values={},this._blockStarts=[],this._constants={},this.opts={...f,_n:f.lines?`
`:""},this._extScope=c,this._scope=new kx.Scope({parent:c}),this._nodes=[new Swe]}toString(){return this._root.render(this.opts)}name(c){return this._scope.name(c)}scopeName(c){return this._extScope.name(c)}scopeValue(c,f){let y=this._extScope.value(c,f);return(this._values[y.prefix]||(this._values[y.prefix]=new Set)).add(y),y}getScopeValue(c,f){return this._extScope.getValue(c,f)}scopeRefs(c){return this._extScope.scopeRefs(c,this._values)}scopeCode(){return this._extScope.scopeCode(this._values)}_def(c,f,y,b){let A=this._scope.toName(f);return y!==void 0&&b&&(this._constants[A.str]=y),this._leafNode(new dwe(c,A,y)),A}const(c,f,y){return this._def(kx.varKinds.const,c,f,y)}let(c,f,y){return this._def(kx.varKinds.let,c,f,y)}var(c,f,y){return this._def(kx.varKinds.var,c,f,y)}assign(c,f,y){return this._leafNode(new Xoe(c,f,y))}add(c,f){return this._leafNode(new mwe(c,Bl.operators.ADD,f))}code(c){return typeof c=="function"?c():c!==Pu.nil&&this._leafNode(new vwe(c)),this}object(...c){let f=["{"];for(let[y,b]of c)f.length>1&&f.push(","),f.push(y),(y!==b||this.opts.es5)&&(f.push(":"),(0,Pu.addCodeArg)(f,b));return f.push("}"),new Pu._Code(f)}if(c,f,y){if(this._blockNode(new X4(c)),f&&y)this.code(f).else().code(y).endIf();else if(f)this.code(f).endIf();else if(y)throw new Error('CodeGen: "else" body without "then" body');return this}elseIf(c){return this._elseNode(new X4(c))}else(){return this._elseNode(new wF)}endIf(){return this._endBlockNode(X4,wF)}_for(c,f){return this._blockNode(c),f&&this.code(f).endFor(),this}for(c,f){return this._for(new bwe(c),f)}forRange(c,f,y,b,A=this.opts.es5?kx.varKinds.var:kx.varKinds.let){let g=this._scope.toName(c);return this._for(new Twe(A,g,f,y),()=>b(g))}forOf(c,f,y,b=kx.varKinds.const){let A=this._scope.toName(c);if(this.opts.es5){let g=f instanceof Pu.Name?f:this.var("_arr",f);return this.forRange("_i",0,(0,Pu._)`${g}.length`,p=>{this.var(A,(0,Pu._)`${g}[${p}]`),y(A)})}return this._for(new Qoe("of",b,A,f),()=>y(A))}forIn(c,f,y,b=this.opts.es5?kx.varKinds.var:kx.varKinds.const){if(this.opts.ownProperties)return this.forOf(c,(0,Pu._)`Object.keys(${f})`,y);let A=this._scope.toName(c);return this._for(new Qoe("in",b,A,f),()=>y(A))}endFor(){return this._endBlockNode(Q4)}label(c){return this._leafNode(new gwe(c))}break(c){return this._leafNode(new hwe(c))}return(c){let f=new Qz;if(this._blockNode(f),this.code(c),f.nodes.length!==1)throw new Error('CodeGen: "return" should have one node');return this._endBlockNode(Qz)}try(c,f,y){if(!f&&!y)throw new Error('CodeGen: "try" without "catch" and "finally"');let b=new Ewe;if(this._blockNode(b),this.code(c),f){let A=this.name("e");this._currNode=b.catch=new Zz(A),f(A)}return y&&(this._currNode=b.finally=new eW,this.code(y)),this._endBlockNode(Zz,eW)}throw(c){return this._leafNode(new ywe(c))}block(c,f){return this._blockStarts.push(this._nodes.length),c&&this.code(c).endBlock(f),this}endBlock(c){let f=this._blockStarts.pop();if(f===void 0)throw new Error("CodeGen: not in self-balancing block");let y=this._nodes.length-f;if(y<0||c!==void 0&&y!==c)throw new Error(`CodeGen: wrong number of nodes: ${y} vs ${c} expected`);return this._nodes.length=f,this}func(c,f=Pu.nil,y,b){return this._blockNode(new Xz(c,f,y)),b&&this.code(b).endFunc(),this}endFunc(){return this._endBlockNode(Xz)}optimize(c=1){for(;c-- >0;)this._root.optimizeNodes(),this._root.optimizeNames(this._root.names,this._constants)}_leafNode(c){return this._currNode.nodes.push(c),this}_blockNode(c){this._currNode.nodes.push(c),this._nodes.push(c)}_endBlockNode(c,f){let y=this._currNode;if(y instanceof c||f&&y instanceof f)return this._nodes.pop(),this;throw new Error(`CodeGen: not in block "${f?`${c.kind}/${f.kind}`:c.kind}"`)}_elseNode(c){let f=this._currNode;if(!(f instanceof X4))throw new Error('CodeGen: "else" without "if"');return this._currNode=f.else=c,this}get _root(){return this._nodes[0]}get _currNode(){let c=this._nodes;return c[c.length-1]}set _currNode(c){let f=this._nodes;f[f.length-1]=c}};Bl.CodeGen=xwe;function Z4(l,c){for(let f in c)l[f]=(l[f]||0)+(c[f]||0);return l}function Zoe(l,c){return c instanceof Pu._CodeOrName?Z4(l,c.names):l}function IF(l,c,f){if(l instanceof Pu.Name)return y(l);if(!b(l))return l;return new Pu._Code(l._items.reduce((A,g)=>(g instanceof Pu.Name&&(g=y(g)),g instanceof Pu._Code?A.push(...g._items):A.push(g),A),[]));function y(A){let g=f[A.str];return g===void 0||c[A.str]!==1?A:(delete c[A.str],g)}function b(A){return A instanceof Pu._Code&&A._items.some(g=>g instanceof Pu.Name&&c[g.str]===1&&f[g.str]!==void 0)}}function $mr(l,c){for(let f in c)l[f]=(l[f]||0)-(c[f]||0)}function Egt(l){return typeof l=="boolean"||typeof l=="number"||l===null?!l:(0,Pu._)`!${Cwe(l)}`}Bl.not=Egt;var Hmr=xgt(Bl.operators.AND);function Gmr(...l){return l.reduce(Hmr)}Bl.and=Gmr;var Ymr=xgt(Bl.operators.OR);function Kmr(...l){return l.reduce(Ymr)}Bl.or=Kmr;function xgt(l){return(c,f)=>c===Pu.nil?f:f===Pu.nil?c:(0,Pu._)`${Cwe(c)} ${l} ${Cwe(f)}`}function Cwe(l){return l instanceof Pu.Name?l:(0,Pu._)`(${l})`}});var Ju=xt(Kl=>{"use strict";Object.defineProperty(Kl,"__esModule",{value:!0});Kl.checkStrictMode=Kl.getErrorPath=Kl.Type=Kl.useFunc=Kl.setEvaluated=Kl.evaluatedPropsToName=Kl.mergeEvaluated=Kl.eachItem=Kl.unescapeJsonPointer=Kl.escapeJsonPointer=Kl.escapeFragment=Kl.unescapeFragment=Kl.schemaRefOrVal=Kl.schemaHasRulesButRef=Kl.schemaHasRules=Kl.checkUnknownRules=Kl.alwaysValidSchema=Kl.toHash=void 0;var Bf=Yl(),Xmr=Yz();function Qmr(l){let c={};for(let f of l)c[f]=!0;return c}Kl.toHash=Qmr;function Zmr(l,c){return typeof c=="boolean"?c:Object.keys(c).length===0?!0:(kgt(l,c),!Pgt(c,l.self.RULES.all))}Kl.alwaysValidSchema=Zmr;function kgt(l,c=l.schema){let{opts:f,self:y}=l;if(!f.strictSchema||typeof c=="boolean")return;let b=y.RULES.keywords;for(let A in c)b[A]||wgt(l,`unknown keyword: "${A}"`)}Kl.checkUnknownRules=kgt;function Pgt(l,c){if(typeof l=="boolean")return!l;for(let f in l)if(c[f])return!0;return!1}Kl.schemaHasRules=Pgt;function egr(l,c){if(typeof l=="boolean")return!l;for(let f in l)if(f!=="$ref"&&c.all[f])return!0;return!1}Kl.schemaHasRulesButRef=egr;function tgr({topSchemaRef:l,schemaPath:c},f,y,b){if(!b){if(typeof f=="number"||typeof f=="boolean")return f;if(typeof f=="string")return(0,Bf._)`${f}`}return(0,Bf._)`${l}${c}${(0,Bf.getProperty)(y)}`}Kl.schemaRefOrVal=tgr;function rgr(l){return Ngt(decodeURIComponent(l))}Kl.unescapeFragment=rgr;function ngr(l){return encodeURIComponent(kwe(l))}Kl.escapeFragment=ngr;function kwe(l){return typeof l=="number"?`${l}`:l.replace(/~/g,"~0").replace(/\//g,"~1")}Kl.escapeJsonPointer=kwe;function Ngt(l){return l.replace(/~1/g,"/").replace(/~0/g,"~")}Kl.unescapeJsonPointer=Ngt;function igr(l,c){if(Array.isArray(l))for(let f of l)c(f);else c(l)}Kl.eachItem=igr;function Cgt({mergeNames:l,mergeToName:c,mergeValues:f,resultToName:y}){return(b,A,g,p)=>{let k=g===void 0?A:g instanceof Bf.Name?(A instanceof Bf.Name?l(b,A,g):c(b,A,g),g):A instanceof Bf.Name?(c(b,g,A),A):f(A,g);return p===Bf.Name&&!(k instanceof Bf.Name)?y(b,k):k}}Kl.mergeEvaluated={props:Cgt({mergeNames:(l,c,f)=>l.if((0,Bf._)`${f} !== true && ${c} !== undefined`,()=>{l.if((0,Bf._)`${c} === true`,()=>l.assign(f,!0),()=>l.assign(f,(0,Bf._)`${f} || {}`).code((0,Bf._)`Object.assign(${f}, ${c})`))}),mergeToName:(l,c,f)=>l.if((0,Bf._)`${f} !== true`,()=>{c===!0?l.assign(f,!0):(l.assign(f,(0,Bf._)`${f} || {}`),Pwe(l,f,c))}),mergeValues:(l,c)=>l===!0?!0:{...l,...c},resultToName:Dgt}),items:Cgt({mergeNames:(l,c,f)=>l.if((0,Bf._)`${f} !== true && ${c} !== undefined`,()=>l.assign(f,(0,Bf._)`${c} === true ? true : ${f} > ${c} ? ${f} : ${c}`)),mergeToName:(l,c,f)=>l.if((0,Bf._)`${f} !== true`,()=>l.assign(f,c===!0?!0:(0,Bf._)`${f} > ${c} ? ${f} : ${c}`)),mergeValues:(l,c)=>l===!0?!0:Math.max(l,c),resultToName:(l,c)=>l.var("items",c)})};function Dgt(l,c){if(c===!0)return l.var("props",!0);let f=l.var("props",(0,Bf._)`{}`);return c!==void 0&&Pwe(l,f,c),f}Kl.evaluatedPropsToName=Dgt;function Pwe(l,c,f){Object.keys(f).forEach(y=>l.assign((0,Bf._)`${c}${(0,Bf.getProperty)(y)}`,!0))}Kl.setEvaluated=Pwe;var Agt={};function sgr(l,c){return l.scopeValue("func",{ref:c,code:Agt[c.code]||(Agt[c.code]=new Xmr._Code(c.code))})}Kl.useFunc=sgr;var Awe;(function(l){l[l.Num=0]="Num",l[l.Str=1]="Str"})(Awe||(Kl.Type=Awe={}));function agr(l,c,f){if(l instanceof Bf.Name){let y=c===Awe.Num;return f?y?(0,Bf._)`"[" + ${l} + "]"`:(0,Bf._)`"['" + ${l} + "']"`:y?(0,Bf._)`"/" + ${l}`:(0,Bf._)`"/" + ${l}.replace(/~/g, "~0").replace(/\\//g, "~1")`}return f?(0,Bf.getProperty)(l).toString():"/"+kwe(l)}Kl.getErrorPath=agr;function wgt(l,c,f=l.opts.strictSchema){if(f){if(c=`strict mode: ${c}`,f===!0)throw new Error(c);l.self.logger.warn(c)}}Kl.checkStrictMode=wgt});var vP=xt(Nwe=>{"use strict";Object.defineProperty(Nwe,"__esModule",{value:!0});var s0=Yl(),ogr={data:new s0.Name("data"),valCxt:new s0.Name("valCxt"),instancePath:new s0.Name("instancePath"),parentData:new s0.Name("parentData"),parentDataProperty:new s0.Name("parentDataProperty"),rootData:new s0.Name("rootData"),dynamicAnchors:new s0.Name("dynamicAnchors"),vErrors:new s0.Name("vErrors"),errors:new s0.Name("errors"),this:new s0.Name("this"),self:new s0.Name("self"),scope:new s0.Name("scope"),json:new s0.Name("json"),jsonPos:new s0.Name("jsonPos"),jsonLen:new s0.Name("jsonLen"),jsonPart:new s0.Name("jsonPart")};Nwe.default=ogr});var tW=xt(a0=>{"use strict";Object.defineProperty(a0,"__esModule",{value:!0});a0.extendErrors=a0.resetErrorsCount=a0.reportExtraError=a0.reportError=a0.keyword$DataError=a0.keywordError=void 0;var Iu=Yl(),tce=Ju(),uv=vP();a0.keywordError={message:({keyword:l})=>(0,Iu.str)`must pass "${l}" keyword validation`};a0.keyword$DataError={message:({keyword:l,schemaType:c})=>c?(0,Iu.str)`"${l}" keyword must be ${c} ($data)`:(0,Iu.str)`"${l}" keyword is invalid ($data)`};function cgr(l,c=a0.keywordError,f,y){let{it:b}=l,{gen:A,compositeRule:g,allErrors:p}=b,k=Rgt(l,c,f);y??(g||p)?Igt(A,k):Ogt(b,(0,Iu._)`[${k}]`)}a0.reportError=cgr;function lgr(l,c=a0.keywordError,f){let{it:y}=l,{gen:b,compositeRule:A,allErrors:g}=y,p=Rgt(l,c,f);Igt(b,p),A||g||Ogt(y,uv.default.vErrors)}a0.reportExtraError=lgr;function ugr(l,c){l.assign(uv.default.errors,c),l.if((0,Iu._)`${uv.default.vErrors} !== null`,()=>l.if(c,()=>l.assign((0,Iu._)`${uv.default.vErrors}.length`,c),()=>l.assign(uv.default.vErrors,null)))}a0.resetErrorsCount=ugr;function _gr({gen:l,keyword:c,schemaValue:f,data:y,errsCount:b,it:A}){if(b===void 0)throw new Error("ajv implementation error");let g=l.name("err");l.forRange("i",b,uv.default.errors,p=>{l.const(g,(0,Iu._)`${uv.default.vErrors}[${p}]`),l.if((0,Iu._)`${g}.instancePath === undefined`,()=>l.assign((0,Iu._)`${g}.instancePath`,(0,Iu.strConcat)(uv.default.instancePath,A.errorPath))),l.assign((0,Iu._)`${g}.schemaPath`,(0,Iu.str)`${A.errSchemaPath}/${c}`),A.opts.verbose&&(l.assign((0,Iu._)`${g}.schema`,f),l.assign((0,Iu._)`${g}.data`,y))})}a0.extendErrors=_gr;function Igt(l,c){let f=l.const("err",c);l.if((0,Iu._)`${uv.default.vErrors} === null`,()=>l.assign(uv.default.vErrors,(0,Iu._)`[${f}]`),(0,Iu._)`${uv.default.vErrors}.push(${f})`),l.code((0,Iu._)`${uv.default.errors}++`)}function Ogt(l,c){let{gen:f,validateName:y,schemaEnv:b}=l;b.$async?f.throw((0,Iu._)`new ${l.ValidationError}(${c})`):(f.assign((0,Iu._)`${y}.errors`,c),f.return(!1))}var e3={keyword:new Iu.Name("keyword"),schemaPath:new Iu.Name("schemaPath"),params:new Iu.Name("params"),propertyName:new Iu.Name("propertyName"),message:new Iu.Name("message"),schema:new Iu.Name("schema"),parentSchema:new Iu.Name("parentSchema")};function Rgt(l,c,f){let{createErrors:y}=l.it;return y===!1?(0,Iu._)`{}`:fgr(l,c,f)}function fgr(l,c,f={}){let{gen:y,it:b}=l,A=[pgr(b,f),dgr(l,f)];return mgr(l,c,A),y.object(...A)}function pgr({errorPath:l},{instancePath:c}){let f=c?(0,Iu.str)`${l}${(0,tce.getErrorPath)(c,tce.Type.Str)}`:l;return[uv.default.instancePath,(0,Iu.strConcat)(uv.default.instancePath,f)]}function dgr({keyword:l,it:{errSchemaPath:c}},{schemaPath:f,parentSchema:y}){let b=y?c:(0,Iu.str)`${c}/${l}`;return f&&(b=(0,Iu.str)`${b}${(0,tce.getErrorPath)(f,tce.Type.Str)}`),[e3.schemaPath,b]}function mgr(l,{params:c,message:f},y){let{keyword:b,data:A,schemaValue:g,it:p}=l,{opts:k,propertyName:j,topSchemaRef:se,schemaPath:ze}=p;y.push([e3.keyword,b],[e3.params,typeof c=="function"?c(l):c||(0,Iu._)`{}`]),k.messages&&y.push([e3.message,typeof f=="function"?f(l):f]),k.verbose&&y.push([e3.schema,g],[e3.parentSchema,(0,Iu._)`${se}${ze}`],[uv.default.data,A]),j&&y.push([e3.propertyName,j])}});var Lgt=xt(OF=>{"use strict";Object.defineProperty(OF,"__esModule",{value:!0});OF.boolOrEmptySchema=OF.topBoolOrEmptySchema=void 0;var ggr=tW(),hgr=Yl(),ygr=vP(),vgr={message:"boolean schema is false"};function Sgr(l){let{gen:c,schema:f,validateName:y}=l;f===!1?Mgt(l,!1):typeof f=="object"&&f.$async===!0?c.return(ygr.default.data):(c.assign((0,hgr._)`${y}.errors`,null),c.return(!0))}OF.topBoolOrEmptySchema=Sgr;function bgr(l,c){let{gen:f,schema:y}=l;y===!1?(f.var(c,!1),Mgt(l)):f.var(c,!0)}OF.boolOrEmptySchema=bgr;function Mgt(l,c){let{gen:f,data:y}=l,b={gen:f,keyword:"false schema",data:y,schema:!1,schemaCode:!1,schemaValue:!1,params:{},it:l};(0,ggr.reportError)(b,vgr,void 0,c)}});var Dwe=xt(RF=>{"use strict";Object.defineProperty(RF,"__esModule",{value:!0});RF.getRules=RF.isJSONType=void 0;var Tgr=["string","number","integer","boolean","null","object","array"],Egr=new Set(Tgr);function xgr(l){return typeof l=="string"&&Egr.has(l)}RF.isJSONType=xgr;function Cgr(){let l={number:{type:"number",rules:[]},string:{type:"string",rules:[]},array:{type:"array",rules:[]},object:{type:"object",rules:[]}};return{types:{...l,integer:!0,boolean:!0,null:!0},rules:[{rules:[]},l.number,l.string,l.array,l.object],post:{rules:[]},all:{},keywords:{}}}RF.getRules=Cgr});var wwe=xt(Ow=>{"use strict";Object.defineProperty(Ow,"__esModule",{value:!0});Ow.shouldUseRule=Ow.shouldUseGroup=Ow.schemaHasRulesForType=void 0;function Agr({schema:l,self:c},f){let y=c.RULES.types[f];return y&&y!==!0&&Fgt(l,y)}Ow.schemaHasRulesForType=Agr;function Fgt(l,c){return c.rules.some(f=>jgt(l,f))}Ow.shouldUseGroup=Fgt;function jgt(l,c){var f;return l[c.keyword]!==void 0||((f=c.definition.implements)===null||f===void 0?void 0:f.some(y=>l[y]!==void 0))}Ow.shouldUseRule=jgt});var rW=xt(o0=>{"use strict";Object.defineProperty(o0,"__esModule",{value:!0});o0.reportTypeError=o0.checkDataTypes=o0.checkDataType=o0.coerceAndCheckDataType=o0.getJSONTypes=o0.getSchemaTypes=o0.DataType=void 0;var kgr=Dwe(),Pgr=wwe(),Ngr=tW(),Sl=Yl(),Bgt=Ju(),MF;(function(l){l[l.Correct=0]="Correct",l[l.Wrong=1]="Wrong"})(MF||(o0.DataType=MF={}));function Dgr(l){let c=Ugt(l.type);if(c.includes("null")){if(l.nullable===!1)throw new Error("type: null contradicts nullable: false")}else{if(!c.length&&l.nullable!==void 0)throw new Error('"nullable" cannot be used without "type"');l.nullable===!0&&c.push("null")}return c}o0.getSchemaTypes=Dgr;function Ugt(l){let c=Array.isArray(l)?l:l?[l]:[];if(c.every(kgr.isJSONType))return c;throw new Error("type must be JSONType or JSONType[]: "+c.join(","))}o0.getJSONTypes=Ugt;function wgr(l,c){let{gen:f,data:y,opts:b}=l,A=Igr(c,b.coerceTypes),g=c.length>0&&!(A.length===0&&c.length===1&&(0,Pgr.schemaHasRulesForType)(l,c[0]));if(g){let p=Owe(c,y,b.strictNumbers,MF.Wrong);f.if(p,()=>{A.length?Ogr(l,c,A):Rwe(l)})}return g}o0.coerceAndCheckDataType=wgr;var Vgt=new Set(["string","number","integer","boolean","null"]);function Igr(l,c){return c?l.filter(f=>Vgt.has(f)||c==="array"&&f==="array"):[]}function Ogr(l,c,f){let{gen:y,data:b,opts:A}=l,g=y.let("dataType",(0,Sl._)`typeof ${b}`),p=y.let("coerced",(0,Sl._)`undefined`);A.coerceTypes==="array"&&y.if((0,Sl._)`${g} == 'object' && Array.isArray(${b}) && ${b}.length == 1`,()=>y.assign(b,(0,Sl._)`${b}[0]`).assign(g,(0,Sl._)`typeof ${b}`).if(Owe(c,b,A.strictNumbers),()=>y.assign(p,b))),y.if((0,Sl._)`${p} !== undefined`);for(let j of f)(Vgt.has(j)||j==="array"&&A.coerceTypes==="array")&&k(j);y.else(),Rwe(l),y.endIf(),y.if((0,Sl._)`${p} !== undefined`,()=>{y.assign(b,p),Rgr(l,p)});function k(j){switch(j){case"string":y.elseIf((0,Sl._)`${g} == "number" || ${g} == "boolean"`).assign(p,(0,Sl._)`"" + ${b}`).elseIf((0,Sl._)`${b} === null`).assign(p,(0,Sl._)`""`);return;case"number":y.elseIf((0,Sl._)`${g} == "boolean" || ${b} === null
              || (${g} == "string" && ${b} && ${b} == +${b})`).assign(p,(0,Sl._)`+${b}`);return;case"integer":y.elseIf((0,Sl._)`${g} === "boolean" || ${b} === null
              || (${g} === "string" && ${b} && ${b} == +${b} && !(${b} % 1))`).assign(p,(0,Sl._)`+${b}`);return;case"boolean":y.elseIf((0,Sl._)`${b} === "false" || ${b} === 0 || ${b} === null`).assign(p,!1).elseIf((0,Sl._)`${b} === "true" || ${b} === 1`).assign(p,!0);return;case"null":y.elseIf((0,Sl._)`${b} === "" || ${b} === 0 || ${b} === false`),y.assign(p,null);return;case"array":y.elseIf((0,Sl._)`${g} === "string" || ${g} === "number"
              || ${g} === "boolean" || ${b} === null`).assign(p,(0,Sl._)`[${b}]`)}}}function Rgr({gen:l,parentData:c,parentDataProperty:f},y){l.if((0,Sl._)`${c} !== undefined`,()=>l.assign((0,Sl._)`${c}[${f}]`,y))}function Iwe(l,c,f,y=MF.Correct){let b=y===MF.Correct?Sl.operators.EQ:Sl.operators.NEQ,A;switch(l){case"null":return(0,Sl._)`${c} ${b} null`;case"array":A=(0,Sl._)`Array.isArray(${c})`;break;case"object":A=(0,Sl._)`${c} && typeof ${c} == "object" && !Array.isArray(${c})`;break;case"integer":A=g((0,Sl._)`!(${c} % 1) && !isNaN(${c})`);break;case"number":A=g();break;default:return(0,Sl._)`typeof ${c} ${b} ${l}`}return y===MF.Correct?A:(0,Sl.not)(A);function g(p=Sl.nil){return(0,Sl.and)((0,Sl._)`typeof ${c} == "number"`,p,f?(0,Sl._)`isFinite(${c})`:Sl.nil)}}o0.checkDataType=Iwe;function Owe(l,c,f,y){if(l.length===1)return Iwe(l[0],c,f,y);let b,A=(0,Bgt.toHash)(l);if(A.array&&A.object){let g=(0,Sl._)`typeof ${c} != "object"`;b=A.null?g:(0,Sl._)`!${c} || ${g}`,delete A.null,delete A.array,delete A.object}else b=Sl.nil;A.number&&delete A.integer;for(let g in A)b=(0,Sl.and)(b,Iwe(g,c,f,y));return b}o0.checkDataTypes=Owe;var Mgr={message:({schema:l})=>`must be ${l}`,params:({schema:l,schemaValue:c})=>typeof l=="string"?(0,Sl._)`{type: ${l}}`:(0,Sl._)`{type: ${c}}`};function Rwe(l){let c=Lgr(l);(0,Ngr.reportError)(c,Mgr)}o0.reportTypeError=Rwe;function Lgr(l){let{gen:c,data:f,schema:y}=l,b=(0,Bgt.schemaRefOrVal)(l,y,"type");return{gen:c,keyword:"type",data:f,schema:y.type,schemaCode:b,schemaValue:b,parentSchema:y,params:{},it:l}}});var qgt=xt(rce=>{"use strict";Object.defineProperty(rce,"__esModule",{value:!0});rce.assignDefaults=void 0;var LF=Yl(),Fgr=Ju();function jgr(l,c){let{properties:f,items:y}=l.schema;if(c==="object"&&f)for(let b in f)Jgt(l,b,f[b].default);else c==="array"&&Array.isArray(y)&&y.forEach((b,A)=>Jgt(l,A,b.default))}rce.assignDefaults=jgr;function Jgt(l,c,f){let{gen:y,compositeRule:b,data:A,opts:g}=l;if(f===void 0)return;let p=(0,LF._)`${A}${(0,LF.getProperty)(c)}`;if(b){(0,Fgr.checkStrictMode)(l,`default is ignored for: ${p}`);return}let k=(0,LF._)`${p} === undefined`;g.useDefaults==="empty"&&(k=(0,LF._)`${k} || ${p} === null || ${p} === ""`),y.if(k,(0,LF._)`${p} = ${(0,LF.stringify)(f)}`)}});var FT=xt(Sf=>{"use strict";Object.defineProperty(Sf,"__esModule",{value:!0});Sf.validateUnion=Sf.validateArray=Sf.usePattern=Sf.callValidateCode=Sf.schemaProperties=Sf.allSchemaProperties=Sf.noPropertyInData=Sf.propertyInData=Sf.isOwnProperty=Sf.hasPropFunc=Sf.reportMissingProp=Sf.checkMissingProp=Sf.checkReportMissingProp=void 0;var Ap=Yl(),Mwe=Ju(),Rw=vP(),Bgr=Ju();function Ugr(l,c){let{gen:f,data:y,it:b}=l;f.if(Fwe(f,y,c,b.opts.ownProperties),()=>{l.setParams({missingProperty:(0,Ap._)`${c}`},!0),l.error()})}Sf.checkReportMissingProp=Ugr;function Vgr({gen:l,data:c,it:{opts:f}},y,b){return(0,Ap.or)(...y.map(A=>(0,Ap.and)(Fwe(l,c,A,f.ownProperties),(0,Ap._)`${b} = ${A}`)))}Sf.checkMissingProp=Vgr;function Jgr(l,c){l.setParams({missingProperty:c},!0),l.error()}Sf.reportMissingProp=Jgr;function zgt(l){return l.scopeValue("func",{ref:Object.prototype.hasOwnProperty,code:(0,Ap._)`Object.prototype.hasOwnProperty`})}Sf.hasPropFunc=zgt;function Lwe(l,c,f){return(0,Ap._)`${zgt(l)}.call(${c}, ${f})`}Sf.isOwnProperty=Lwe;function qgr(l,c,f,y){let b=(0,Ap._)`${c}${(0,Ap.getProperty)(f)} !== undefined`;return y?(0,Ap._)`${b} && ${Lwe(l,c,f)}`:b}Sf.propertyInData=qgr;function Fwe(l,c,f,y){let b=(0,Ap._)`${c}${(0,Ap.getProperty)(f)} === undefined`;return y?(0,Ap.or)(b,(0,Ap.not)(Lwe(l,c,f))):b}Sf.noPropertyInData=Fwe;function Wgt(l){return l?Object.keys(l).filter(c=>c!=="__proto__"):[]}Sf.allSchemaProperties=Wgt;function zgr(l,c){return Wgt(c).filter(f=>!(0,Mwe.alwaysValidSchema)(l,c[f]))}Sf.schemaProperties=zgr;function Wgr({schemaCode:l,data:c,it:{gen:f,topSchemaRef:y,schemaPath:b,errorPath:A},it:g},p,k,j){let se=j?(0,Ap._)`${l}, ${c}, ${y}${b}`:c,ze=[[Rw.default.instancePath,(0,Ap.strConcat)(Rw.default.instancePath,A)],[Rw.default.parentData,g.parentData],[Rw.default.parentDataProperty,g.parentDataProperty],[Rw.default.rootData,Rw.default.rootData]];g.opts.dynamicRef&&ze.push([Rw.default.dynamicAnchors,Rw.default.dynamicAnchors]);let ve=(0,Ap._)`${se}, ${f.object(...ze)}`;return k!==Ap.nil?(0,Ap._)`${p}.call(${k}, ${ve})`:(0,Ap._)`${p}(${ve})`}Sf.callValidateCode=Wgr;var $gr=(0,Ap._)`new RegExp`;function Hgr({gen:l,it:{opts:c}},f){let y=c.unicodeRegExp?"u":"",{regExp:b}=c.code,A=b(f,y);return l.scopeValue("pattern",{key:A.toString(),ref:A,code:(0,Ap._)`${b.code==="new RegExp"?$gr:(0,Bgr.useFunc)(l,b)}(${f}, ${y})`})}Sf.usePattern=Hgr;function Ggr(l){let{gen:c,data:f,keyword:y,it:b}=l,A=c.name("valid");if(b.allErrors){let p=c.let("valid",!0);return g(()=>c.assign(p,!1)),p}return c.var(A,!0),g(()=>c.break()),A;function g(p){let k=c.const("len",(0,Ap._)`${f}.length`);c.forRange("i",0,k,j=>{l.subschema({keyword:y,dataProp:j,dataPropType:Mwe.Type.Num},A),c.if((0,Ap.not)(A),p)})}}Sf.validateArray=Ggr;function Ygr(l){let{gen:c,schema:f,keyword:y,it:b}=l;if(!Array.isArray(f))throw new Error("ajv implementation error");if(f.some(k=>(0,Mwe.alwaysValidSchema)(b,k))&&!b.opts.unevaluated)return;let g=c.let("valid",!1),p=c.name("_valid");c.block(()=>f.forEach((k,j)=>{let se=l.subschema({keyword:y,schemaProp:j,compositeRule:!0},p);c.assign(g,(0,Ap._)`${g} || ${p}`),l.mergeValidEvaluated(se,p)||c.if((0,Ap.not)(g))})),l.result(g,()=>l.reset(),()=>l.error(!0))}Sf.validateUnion=Ygr});var Ggt=xt(IC=>{"use strict";Object.defineProperty(IC,"__esModule",{value:!0});IC.validateKeywordUsage=IC.validSchemaType=IC.funcKeywordCode=IC.macroKeywordCode=void 0;var _v=Yl(),t3=vP(),Kgr=FT(),Xgr=tW();function Qgr(l,c){let{gen:f,keyword:y,schema:b,parentSchema:A,it:g}=l,p=c.macro.call(g.self,b,A,g),k=Hgt(f,y,p);g.opts.validateSchema!==!1&&g.self.validateSchema(p,!0);let j=f.name("valid");l.subschema({schema:p,schemaPath:_v.nil,errSchemaPath:`${g.errSchemaPath}/${y}`,topSchemaRef:k,compositeRule:!0},j),l.pass(j,()=>l.error(!0))}IC.macroKeywordCode=Qgr;function Zgr(l,c){var f;let{gen:y,keyword:b,schema:A,parentSchema:g,$data:p,it:k}=l;thr(k,c);let j=!p&&c.compile?c.compile.call(k.self,A,g,k):c.validate,se=Hgt(y,b,j),ze=y.let("valid");l.block$data(ze,ve),l.ok((f=c.valid)!==null&&f!==void 0?f:ze);function ve(){if(c.errors===!1)wt(),c.modifying&&$gt(l),kt(()=>l.error());else{let Fi=c.async?lr():Br();c.modifying&&$gt(l),kt(()=>ehr(l,Fi))}}function lr(){let Fi=y.let("ruleErrs",null);return y.try(()=>wt((0,_v._)`await `),yi=>y.assign(ze,!1).if((0,_v._)`${yi} instanceof ${k.ValidationError}`,()=>y.assign(Fi,(0,_v._)`${yi}.errors`),()=>y.throw(yi))),Fi}function Br(){let Fi=(0,_v._)`${se}.errors`;return y.assign(Fi,null),wt(_v.nil),Fi}function wt(Fi=c.async?(0,_v._)`await `:_v.nil){let yi=k.opts.passContext?t3.default.this:t3.default.self,qo=!("compile"in c&&!p||c.schema===!1);y.assign(ze,(0,_v._)`${Fi}${(0,Kgr.callValidateCode)(l,se,yi,qo)}`,c.modifying)}function kt(Fi){var yi;y.if((0,_v.not)((yi=c.valid)!==null&&yi!==void 0?yi:ze),Fi)}}IC.funcKeywordCode=Zgr;function $gt(l){let{gen:c,data:f,it:y}=l;c.if(y.parentData,()=>c.assign(f,(0,_v._)`${y.parentData}[${y.parentDataProperty}]`))}function ehr(l,c){let{gen:f}=l;f.if((0,_v._)`Array.isArray(${c})`,()=>{f.assign(t3.default.vErrors,(0,_v._)`${t3.default.vErrors} === null ? ${c} : ${t3.default.vErrors}.concat(${c})`).assign(t3.default.errors,(0,_v._)`${t3.default.vErrors}.length`),(0,Xgr.extendErrors)(l)},()=>l.error())}function thr({schemaEnv:l},c){if(c.async&&!l.$async)throw new Error("async keyword in sync schema")}function Hgt(l,c,f){if(f===void 0)throw new Error(`keyword "${c}" failed to compile`);return l.scopeValue("keyword",typeof f=="function"?{ref:f}:{ref:f,code:(0,_v.stringify)(f)})}function rhr(l,c,f=!1){return!c.length||c.some(y=>y==="array"?Array.isArray(l):y==="object"?l&&typeof l=="object"&&!Array.isArray(l):typeof l==y||f&&typeof l>"u")}IC.validSchemaType=rhr;function nhr({schema:l,opts:c,self:f,errSchemaPath:y},b,A){if(Array.isArray(b.keyword)?!b.keyword.includes(A):b.keyword!==A)throw new Error("ajv implementation error");let g=b.dependencies;if(g?.some(p=>!Object.prototype.hasOwnProperty.call(l,p)))throw new Error(`parent schema must have dependencies of ${A}: ${g.join(",")}`);if(b.validateSchema&&!b.validateSchema(l[A])){let k=`keyword "${A}" value is invalid at path "${y}": `+f.errorsText(b.validateSchema.errors);if(c.validateSchema==="log")f.logger.error(k);else throw new Error(k)}}IC.validateKeywordUsage=nhr});var Kgt=xt(Mw=>{"use strict";Object.defineProperty(Mw,"__esModule",{value:!0});Mw.extendSubschemaMode=Mw.extendSubschemaData=Mw.getSubschema=void 0;var OC=Yl(),Ygt=Ju();function ihr(l,{keyword:c,schemaProp:f,schema:y,schemaPath:b,errSchemaPath:A,topSchemaRef:g}){if(c!==void 0&&y!==void 0)throw new Error('both "keyword" and "schema" passed, only one allowed');if(c!==void 0){let p=l.schema[c];return f===void 0?{schema:p,schemaPath:(0,OC._)`${l.schemaPath}${(0,OC.getProperty)(c)}`,errSchemaPath:`${l.errSchemaPath}/${c}`}:{schema:p[f],schemaPath:(0,OC._)`${l.schemaPath}${(0,OC.getProperty)(c)}${(0,OC.getProperty)(f)}`,errSchemaPath:`${l.errSchemaPath}/${c}/${(0,Ygt.escapeFragment)(f)}`}}if(y!==void 0){if(b===void 0||A===void 0||g===void 0)throw new Error('"schemaPath", "errSchemaPath" and "topSchemaRef" are required with "schema"');return{schema:y,schemaPath:b,topSchemaRef:g,errSchemaPath:A}}throw new Error('either "keyword" or "schema" must be passed')}Mw.getSubschema=ihr;function shr(l,c,{dataProp:f,dataPropType:y,data:b,dataTypes:A,propertyName:g}){if(b!==void 0&&f!==void 0)throw new Error('both "data" and "dataProp" passed, only one allowed');let{gen:p}=c;if(f!==void 0){let{errorPath:j,dataPathArr:se,opts:ze}=c,ve=p.let("data",(0,OC._)`${c.data}${(0,OC.getProperty)(f)}`,!0);k(ve),l.errorPath=(0,OC.str)`${j}${(0,Ygt.getErrorPath)(f,y,ze.jsPropertySyntax)}`,l.parentDataProperty=(0,OC._)`${f}`,l.dataPathArr=[...se,l.parentDataProperty]}if(b!==void 0){let j=b instanceof OC.Name?b:p.let("data",b,!0);k(j),g!==void 0&&(l.propertyName=g)}A&&(l.dataTypes=A);function k(j){l.data=j,l.dataLevel=c.dataLevel+1,l.dataTypes=[],c.definedProperties=new Set,l.parentData=c.data,l.dataNames=[...c.dataNames,j]}}Mw.extendSubschemaData=shr;function ahr(l,{jtdDiscriminator:c,jtdMetadata:f,compositeRule:y,createErrors:b,allErrors:A}){y!==void 0&&(l.compositeRule=y),b!==void 0&&(l.createErrors=b),A!==void 0&&(l.allErrors=A),l.jtdDiscriminator=c,l.jtdMetadata=f}Mw.extendSubschemaMode=ahr});var jwe=xt((Z4r,Xgt)=>{"use strict";Xgt.exports=function l(c,f){if(c===f)return!0;if(c&&f&&typeof c=="object"&&typeof f=="object"){if(c.constructor!==f.constructor)return!1;var y,b,A;if(Array.isArray(c)){if(y=c.length,y!=f.length)return!1;for(b=y;b--!==0;)if(!l(c[b],f[b]))return!1;return!0}if(c.constructor===RegExp)return c.source===f.source&&c.flags===f.flags;if(c.valueOf!==Object.prototype.valueOf)return c.valueOf()===f.valueOf();if(c.toString!==Object.prototype.toString)return c.toString()===f.toString();if(A=Object.keys(c),y=A.length,y!==Object.keys(f).length)return!1;for(b=y;b--!==0;)if(!Object.prototype.hasOwnProperty.call(f,A[b]))return!1;for(b=y;b--!==0;){var g=A[b];if(!l(c[g],f[g]))return!1}return!0}return c!==c&&f!==f}});var Zgt=xt((e3r,Qgt)=>{"use strict";var Lw=Qgt.exports=function(l,c,f){typeof c=="function"&&(f=c,c={}),f=c.cb||f;var y=typeof f=="function"?f:f.pre||function(){},b=f.post||function(){};nce(c,y,b,l,"",l)};Lw.keywords={additionalItems:!0,items:!0,contains:!0,additionalProperties:!0,propertyNames:!0,not:!0,if:!0,then:!0,else:!0};Lw.arrayKeywords={items:!0,allOf:!0,anyOf:!0,oneOf:!0};Lw.propsKeywords={$defs:!0,definitions:!0,properties:!0,patternProperties:!0,dependencies:!0};Lw.skipKeywords={default:!0,enum:!0,const:!0,required:!0,maximum:!0,minimum:!0,exclusiveMaximum:!0,exclusiveMinimum:!0,multipleOf:!0,maxLength:!0,minLength:!0,pattern:!0,format:!0,maxItems:!0,minItems:!0,uniqueItems:!0,maxProperties:!0,minProperties:!0};function nce(l,c,f,y,b,A,g,p,k,j){if(y&&typeof y=="object"&&!Array.isArray(y)){c(y,b,A,g,p,k,j);for(var se in y){var ze=y[se];if(Array.isArray(ze)){if(se in Lw.arrayKeywords)for(var ve=0;ve<ze.length;ve++)nce(l,c,f,ze[ve],b+"/"+se+"/"+ve,A,b,se,y,ve)}else if(se in Lw.propsKeywords){if(ze&&typeof ze=="object")for(var lr in ze)nce(l,c,f,ze[lr],b+"/"+se+"/"+ohr(lr),A,b,se,y,lr)}else(se in Lw.keywords||l.allKeys&&!(se in Lw.skipKeywords))&&nce(l,c,f,ze,b+"/"+se,A,b,se,y)}f(y,b,A,g,p,k,j)}}function ohr(l){return l.replace(/~/g,"~0").replace(/\//g,"~1")}});var nW=xt(P1=>{"use strict";Object.defineProperty(P1,"__esModule",{value:!0});P1.getSchemaRefs=P1.resolveUrl=P1.normalizeId=P1._getFullPath=P1.getFullPath=P1.inlineRef=void 0;var chr=Ju(),lhr=jwe(),uhr=Zgt(),_hr=new Set(["type","format","pattern","maxLength","minLength","maxProperties","minProperties","maxItems","minItems","maximum","minimum","uniqueItems","multipleOf","required","enum","const"]);function fhr(l,c=!0){return typeof l=="boolean"?!0:c===!0?!Bwe(l):c?eht(l)<=c:!1}P1.inlineRef=fhr;var phr=new Set(["$ref","$recursiveRef","$recursiveAnchor","$dynamicRef","$dynamicAnchor"]);function Bwe(l){for(let c in l){if(phr.has(c))return!0;let f=l[c];if(Array.isArray(f)&&f.some(Bwe)||typeof f=="object"&&Bwe(f))return!0}return!1}function eht(l){let c=0;for(let f in l){if(f==="$ref")return 1/0;if(c++,!_hr.has(f)&&(typeof l[f]=="object"&&(0,chr.eachItem)(l[f],y=>c+=eht(y)),c===1/0))return 1/0}return c}function tht(l,c="",f){f!==!1&&(c=FF(c));let y=l.parse(c);return rht(l,y)}P1.getFullPath=tht;function rht(l,c){return l.serialize(c).split("#")[0]+"#"}P1._getFullPath=rht;var dhr=/#\/?$/;function FF(l){return l?l.replace(dhr,""):""}P1.normalizeId=FF;function mhr(l,c,f){return f=FF(f),l.resolve(c,f)}P1.resolveUrl=mhr;var ghr=/^[a-z_][-a-z0-9._]*$/i;function hhr(l,c){if(typeof l=="boolean")return{};let{schemaId:f,uriResolver:y}=this.opts,b=FF(l[f]||c),A={"":b},g=tht(y,b,!1),p={},k=new Set;return uhr(l,{allKeys:!0},(ze,ve,lr,Br)=>{if(Br===void 0)return;let wt=g+ve,kt=A[Br];typeof ze[f]=="string"&&(kt=Fi.call(this,ze[f])),yi.call(this,ze.$anchor),yi.call(this,ze.$dynamicAnchor),A[ve]=kt;function Fi(qo){let Xl=this.opts.uriResolver.resolve;if(qo=FF(kt?Xl(kt,qo):qo),k.has(qo))throw se(qo);k.add(qo);let ho=this.refs[qo];return typeof ho=="string"&&(ho=this.refs[ho]),typeof ho=="object"?j(ze,ho.schema,qo):qo!==FF(wt)&&(qo[0]==="#"?(j(ze,p[qo],qo),p[qo]=ze):this.refs[qo]=wt),qo}function yi(qo){if(typeof qo=="string"){if(!ghr.test(qo))throw new Error(`invalid anchor "${qo}"`);Fi.call(this,`#${qo}`)}}}),p;function j(ze,ve,lr){if(ve!==void 0&&!lhr(ze,ve))throw se(lr)}function se(ze){return new Error(`reference "${ze}" resolves to more than one schema`)}}P1.getSchemaRefs=hhr});var aW=xt(Fw=>{"use strict";Object.defineProperty(Fw,"__esModule",{value:!0});Fw.getData=Fw.KeywordCxt=Fw.validateFunctionCode=void 0;var oht=Lgt(),nht=rW(),Vwe=wwe(),ice=rW(),yhr=qgt(),sW=Ggt(),Uwe=Kgt(),Po=Yl(),Fc=vP(),vhr=nW(),SP=Ju(),iW=tW();function Shr(l){if(uht(l)&&(_ht(l),lht(l))){Ehr(l);return}cht(l,()=>(0,oht.topBoolOrEmptySchema)(l))}Fw.validateFunctionCode=Shr;function cht({gen:l,validateName:c,schema:f,schemaEnv:y,opts:b},A){b.code.es5?l.func(c,(0,Po._)`${Fc.default.data}, ${Fc.default.valCxt}`,y.$async,()=>{l.code((0,Po._)`"use strict"; ${iht(f,b)}`),Thr(l,b),l.code(A)}):l.func(c,(0,Po._)`${Fc.default.data}, ${bhr(b)}`,y.$async,()=>l.code(iht(f,b)).code(A))}function bhr(l){return(0,Po._)`{${Fc.default.instancePath}="", ${Fc.default.parentData}, ${Fc.default.parentDataProperty}, ${Fc.default.rootData}=${Fc.default.data}${l.dynamicRef?(0,Po._)`, ${Fc.default.dynamicAnchors}={}`:Po.nil}}={}`}function Thr(l,c){l.if(Fc.default.valCxt,()=>{l.var(Fc.default.instancePath,(0,Po._)`${Fc.default.valCxt}.${Fc.default.instancePath}`),l.var(Fc.default.parentData,(0,Po._)`${Fc.default.valCxt}.${Fc.default.parentData}`),l.var(Fc.default.parentDataProperty,(0,Po._)`${Fc.default.valCxt}.${Fc.default.parentDataProperty}`),l.var(Fc.default.rootData,(0,Po._)`${Fc.default.valCxt}.${Fc.default.rootData}`),c.dynamicRef&&l.var(Fc.default.dynamicAnchors,(0,Po._)`${Fc.default.valCxt}.${Fc.default.dynamicAnchors}`)},()=>{l.var(Fc.default.instancePath,(0,Po._)`""`),l.var(Fc.default.parentData,(0,Po._)`undefined`),l.var(Fc.default.parentDataProperty,(0,Po._)`undefined`),l.var(Fc.default.rootData,Fc.default.data),c.dynamicRef&&l.var(Fc.default.dynamicAnchors,(0,Po._)`{}`)})}function Ehr(l){let{schema:c,opts:f,gen:y}=l;cht(l,()=>{f.$comment&&c.$comment&&pht(l),Phr(l),y.let(Fc.default.vErrors,null),y.let(Fc.default.errors,0),f.unevaluated&&xhr(l),fht(l),whr(l)})}function xhr(l){let{gen:c,validateName:f}=l;l.evaluated=c.const("evaluated",(0,Po._)`${f}.evaluated`),c.if((0,Po._)`${l.evaluated}.dynamicProps`,()=>c.assign((0,Po._)`${l.evaluated}.props`,(0,Po._)`undefined`)),c.if((0,Po._)`${l.evaluated}.dynamicItems`,()=>c.assign((0,Po._)`${l.evaluated}.items`,(0,Po._)`undefined`))}function iht(l,c){let f=typeof l=="object"&&l[c.schemaId];return f&&(c.code.source||c.code.process)?(0,Po._)`/*# sourceURL=${f} */`:Po.nil}function Chr(l,c){if(uht(l)&&(_ht(l),lht(l))){Ahr(l,c);return}(0,oht.boolOrEmptySchema)(l,c)}function lht({schema:l,self:c}){if(typeof l=="boolean")return!l;for(let f in l)if(c.RULES.all[f])return!0;return!1}function uht(l){return typeof l.schema!="boolean"}function Ahr(l,c){let{schema:f,gen:y,opts:b}=l;b.$comment&&f.$comment&&pht(l),Nhr(l),Dhr(l);let A=y.const("_errs",Fc.default.errors);fht(l,A),y.var(c,(0,Po._)`${A} === ${Fc.default.errors}`)}function _ht(l){(0,SP.checkUnknownRules)(l),khr(l)}function fht(l,c){if(l.opts.jtd)return sht(l,[],!1,c);let f=(0,nht.getSchemaTypes)(l.schema),y=(0,nht.coerceAndCheckDataType)(l,f);sht(l,f,!y,c)}function khr(l){let{schema:c,errSchemaPath:f,opts:y,self:b}=l;c.$ref&&y.ignoreKeywordsWithRef&&(0,SP.schemaHasRulesButRef)(c,b.RULES)&&b.logger.warn(`$ref: keywords ignored in schema at path "${f}"`)}function Phr(l){let{schema:c,opts:f}=l;c.default!==void 0&&f.useDefaults&&f.strictSchema&&(0,SP.checkStrictMode)(l,"default is ignored in the schema root")}function Nhr(l){let c=l.schema[l.opts.schemaId];c&&(l.baseId=(0,vhr.resolveUrl)(l.opts.uriResolver,l.baseId,c))}function Dhr(l){if(l.schema.$async&&!l.schemaEnv.$async)throw new Error("async schema in sync schema")}function pht({gen:l,schemaEnv:c,schema:f,errSchemaPath:y,opts:b}){let A=f.$comment;if(b.$comment===!0)l.code((0,Po._)`${Fc.default.self}.logger.log(${A})`);else if(typeof b.$comment=="function"){let g=(0,Po.str)`${y}/$comment`,p=l.scopeValue("root",{ref:c.root});l.code((0,Po._)`${Fc.default.self}.opts.$comment(${A}, ${g}, ${p}.schema)`)}}function whr(l){let{gen:c,schemaEnv:f,validateName:y,ValidationError:b,opts:A}=l;f.$async?c.if((0,Po._)`${Fc.default.errors} === 0`,()=>c.return(Fc.default.data),()=>c.throw((0,Po._)`new ${b}(${Fc.default.vErrors})`)):(c.assign((0,Po._)`${y}.errors`,Fc.default.vErrors),A.unevaluated&&Ihr(l),c.return((0,Po._)`${Fc.default.errors} === 0`))}function Ihr({gen:l,evaluated:c,props:f,items:y}){f instanceof Po.Name&&l.assign((0,Po._)`${c}.props`,f),y instanceof Po.Name&&l.assign((0,Po._)`${c}.items`,y)}function sht(l,c,f,y){let{gen:b,schema:A,data:g,allErrors:p,opts:k,self:j}=l,{RULES:se}=j;if(A.$ref&&(k.ignoreKeywordsWithRef||!(0,SP.schemaHasRulesButRef)(A,se))){b.block(()=>mht(l,"$ref",se.all.$ref.definition));return}k.jtd||Ohr(l,c),b.block(()=>{for(let ve of se.rules)ze(ve);ze(se.post)});function ze(ve){(0,Vwe.shouldUseGroup)(A,ve)&&(ve.type?(b.if((0,ice.checkDataType)(ve.type,g,k.strictNumbers)),aht(l,ve),c.length===1&&c[0]===ve.type&&f&&(b.else(),(0,ice.reportTypeError)(l)),b.endIf()):aht(l,ve),p||b.if((0,Po._)`${Fc.default.errors} === ${y||0}`))}}function aht(l,c){let{gen:f,schema:y,opts:{useDefaults:b}}=l;b&&(0,yhr.assignDefaults)(l,c.type),f.block(()=>{for(let A of c.rules)(0,Vwe.shouldUseRule)(y,A)&&mht(l,A.keyword,A.definition,c.type)})}function Ohr(l,c){l.schemaEnv.meta||!l.opts.strictTypes||(Rhr(l,c),l.opts.allowUnionTypes||Mhr(l,c),Lhr(l,l.dataTypes))}function Rhr(l,c){if(c.length){if(!l.dataTypes.length){l.dataTypes=c;return}c.forEach(f=>{dht(l.dataTypes,f)||Jwe(l,`type "${f}" not allowed by context "${l.dataTypes.join(",")}"`)}),jhr(l,c)}}function Mhr(l,c){c.length>1&&!(c.length===2&&c.includes("null"))&&Jwe(l,"use allowUnionTypes to allow union type keyword")}function Lhr(l,c){let f=l.self.RULES.all;for(let y in f){let b=f[y];if(typeof b=="object"&&(0,Vwe.shouldUseRule)(l.schema,b)){let{type:A}=b.definition;A.length&&!A.some(g=>Fhr(c,g))&&Jwe(l,`missing type "${A.join(",")}" for keyword "${y}"`)}}}function Fhr(l,c){return l.includes(c)||c==="number"&&l.includes("integer")}function dht(l,c){return l.includes(c)||c==="integer"&&l.includes("number")}function jhr(l,c){let f=[];for(let y of l.dataTypes)dht(c,y)?f.push(y):c.includes("integer")&&y==="number"&&f.push("integer");l.dataTypes=f}function Jwe(l,c){let f=l.schemaEnv.baseId+l.errSchemaPath;c+=` at "${f}" (strictTypes)`,(0,SP.checkStrictMode)(l,c,l.opts.strictTypes)}var sce=class{constructor(c,f,y){if((0,sW.validateKeywordUsage)(c,f,y),this.gen=c.gen,this.allErrors=c.allErrors,this.keyword=y,this.data=c.data,this.schema=c.schema[y],this.$data=f.$data&&c.opts.$data&&this.schema&&this.schema.$data,this.schemaValue=(0,SP.schemaRefOrVal)(c,this.schema,y,this.$data),this.schemaType=f.schemaType,this.parentSchema=c.schema,this.params={},this.it=c,this.def=f,this.$data)this.schemaCode=c.gen.const("vSchema",ght(this.$data,c));else if(this.schemaCode=this.schemaValue,!(0,sW.validSchemaType)(this.schema,f.schemaType,f.allowUndefined))throw new Error(`${y} value must be ${JSON.stringify(f.schemaType)}`);("code"in f?f.trackErrors:f.errors!==!1)&&(this.errsCount=c.gen.const("_errs",Fc.default.errors))}result(c,f,y){this.failResult((0,Po.not)(c),f,y)}failResult(c,f,y){this.gen.if(c),y?y():this.error(),f?(this.gen.else(),f(),this.allErrors&&this.gen.endIf()):this.allErrors?this.gen.endIf():this.gen.else()}pass(c,f){this.failResult((0,Po.not)(c),void 0,f)}fail(c){if(c===void 0){this.error(),this.allErrors||this.gen.if(!1);return}this.gen.if(c),this.error(),this.allErrors?this.gen.endIf():this.gen.else()}fail$data(c){if(!this.$data)return this.fail(c);let{schemaCode:f}=this;this.fail((0,Po._)`${f} !== undefined && (${(0,Po.or)(this.invalid$data(),c)})`)}error(c,f,y){if(f){this.setParams(f),this._error(c,y),this.setParams({});return}this._error(c,y)}_error(c,f){(c?iW.reportExtraError:iW.reportError)(this,this.def.error,f)}$dataError(){(0,iW.reportError)(this,this.def.$dataError||iW.keyword$DataError)}reset(){if(this.errsCount===void 0)throw new Error('add "trackErrors" to keyword definition');(0,iW.resetErrorsCount)(this.gen,this.errsCount)}ok(c){this.allErrors||this.gen.if(c)}setParams(c,f){f?Object.assign(this.params,c):this.params=c}block$data(c,f,y=Po.nil){this.gen.block(()=>{this.check$data(c,y),f()})}check$data(c=Po.nil,f=Po.nil){if(!this.$data)return;let{gen:y,schemaCode:b,schemaType:A,def:g}=this;y.if((0,Po.or)((0,Po._)`${b} === undefined`,f)),c!==Po.nil&&y.assign(c,!0),(A.length||g.validateSchema)&&(y.elseIf(this.invalid$data()),this.$dataError(),c!==Po.nil&&y.assign(c,!1)),y.else()}invalid$data(){let{gen:c,schemaCode:f,schemaType:y,def:b,it:A}=this;return(0,Po.or)(g(),p());function g(){if(y.length){if(!(f instanceof Po.Name))throw new Error("ajv implementation error");let k=Array.isArray(y)?y:[y];return(0,Po._)`${(0,ice.checkDataTypes)(k,f,A.opts.strictNumbers,ice.DataType.Wrong)}`}return Po.nil}function p(){if(b.validateSchema){let k=c.scopeValue("validate$data",{ref:b.validateSchema});return(0,Po._)`!${k}(${f})`}return Po.nil}}subschema(c,f){let y=(0,Uwe.getSubschema)(this.it,c);(0,Uwe.extendSubschemaData)(y,this.it,c),(0,Uwe.extendSubschemaMode)(y,c);let b={...this.it,...y,items:void 0,props:void 0};return Chr(b,f),b}mergeEvaluated(c,f){let{it:y,gen:b}=this;y.opts.unevaluated&&(y.props!==!0&&c.props!==void 0&&(y.props=SP.mergeEvaluated.props(b,c.props,y.props,f)),y.items!==!0&&c.items!==void 0&&(y.items=SP.mergeEvaluated.items(b,c.items,y.items,f)))}mergeValidEvaluated(c,f){let{it:y,gen:b}=this;if(y.opts.unevaluated&&(y.props!==!0||y.items!==!0))return b.if(f,()=>this.mergeEvaluated(c,Po.Name)),!0}};Fw.KeywordCxt=sce;function mht(l,c,f,y){let b=new sce(l,f,c);"code"in f?f.code(b,y):b.$data&&f.validate?(0,sW.funcKeywordCode)(b,f):"macro"in f?(0,sW.macroKeywordCode)(b,f):(f.compile||f.validate)&&(0,sW.funcKeywordCode)(b,f)}var Bhr=/^\/(?:[^~]|~0|~1)*$/,Uhr=/^([0-9]+)(#|\/(?:[^~]|~0|~1)*)?$/;function ght(l,{dataLevel:c,dataNames:f,dataPathArr:y}){let b,A;if(l==="")return Fc.default.rootData;if(l[0]==="/"){if(!Bhr.test(l))throw new Error(`Invalid JSON-pointer: ${l}`);b=l,A=Fc.default.rootData}else{let j=Uhr.exec(l);if(!j)throw new Error(`Invalid JSON-pointer: ${l}`);let se=+j[1];if(b=j[2],b==="#"){if(se>=c)throw new Error(k("property/index",se));return y[c-se]}if(se>c)throw new Error(k("data",se));if(A=f[c-se],!b)return A}let g=A,p=b.split("/");for(let j of p)j&&(A=(0,Po._)`${A}${(0,Po.getProperty)((0,SP.unescapeJsonPointer)(j))}`,g=(0,Po._)`${g} && ${A}`);return g;function k(j,se){return`Cannot access ${j} ${se} levels up, current level is ${c}`}}Fw.getData=ght});var ace=xt(zwe=>{"use strict";Object.defineProperty(zwe,"__esModule",{value:!0});var qwe=class extends Error{constructor(c){super("validation failed"),this.errors=c,this.ajv=this.validation=!0}};zwe.default=qwe});var oW=xt(Hwe=>{"use strict";Object.defineProperty(Hwe,"__esModule",{value:!0});var Wwe=nW(),$we=class extends Error{constructor(c,f,y,b){super(b||`can't resolve reference ${y} from id ${f}`),this.missingRef=(0,Wwe.resolveUrl)(c,f,y),this.missingSchema=(0,Wwe.normalizeId)((0,Wwe.getFullPath)(c,this.missingRef))}};Hwe.default=$we});var cce=xt(jT=>{"use strict";Object.defineProperty(jT,"__esModule",{value:!0});jT.resolveSchema=jT.getCompilingSchema=jT.resolveRef=jT.compileSchema=jT.SchemaEnv=void 0;var Px=Yl(),Vhr=ace(),r3=vP(),Nx=nW(),hht=Ju(),Jhr=aW(),jF=class{constructor(c){var f;this.refs={},this.dynamicAnchors={};let y;typeof c.schema=="object"&&(y=c.schema),this.schema=c.schema,this.schemaId=c.schemaId,this.root=c.root||this,this.baseId=(f=c.baseId)!==null&&f!==void 0?f:(0,Nx.normalizeId)(y?.[c.schemaId||"$id"]),this.schemaPath=c.schemaPath,this.localRefs=c.localRefs,this.meta=c.meta,this.$async=y?.$async,this.refs={}}};jT.SchemaEnv=jF;function Ywe(l){let c=yht.call(this,l);if(c)return c;let f=(0,Nx.getFullPath)(this.opts.uriResolver,l.root.baseId),{es5:y,lines:b}=this.opts.code,{ownProperties:A}=this.opts,g=new Px.CodeGen(this.scope,{es5:y,lines:b,ownProperties:A}),p;l.$async&&(p=g.scopeValue("Error",{ref:Vhr.default,code:(0,Px._)`require("ajv/dist/runtime/validation_error").default`}));let k=g.scopeName("validate");l.validateName=k;let j={gen:g,allErrors:this.opts.allErrors,data:r3.default.data,parentData:r3.default.parentData,parentDataProperty:r3.default.parentDataProperty,dataNames:[r3.default.data],dataPathArr:[Px.nil],dataLevel:0,dataTypes:[],definedProperties:new Set,topSchemaRef:g.scopeValue("schema",this.opts.code.source===!0?{ref:l.schema,code:(0,Px.stringify)(l.schema)}:{ref:l.schema}),validateName:k,ValidationError:p,schema:l.schema,schemaEnv:l,rootId:f,baseId:l.baseId||f,schemaPath:Px.nil,errSchemaPath:l.schemaPath||(this.opts.jtd?"":"#"),errorPath:(0,Px._)`""`,opts:this.opts,self:this},se;try{this._compilations.add(l),(0,Jhr.validateFunctionCode)(j),g.optimize(this.opts.code.optimize);let ze=g.toString();se=`${g.scopeRefs(r3.default.scope)}return ${ze}`,this.opts.code.process&&(se=this.opts.code.process(se,l));let lr=new Function(`${r3.default.self}`,`${r3.default.scope}`,se)(this,this.scope.get());if(this.scope.value(k,{ref:lr}),lr.errors=null,lr.schema=l.schema,lr.schemaEnv=l,l.$async&&(lr.$async=!0),this.opts.code.source===!0&&(lr.source={validateName:k,validateCode:ze,scopeValues:g._values}),this.opts.unevaluated){let{props:Br,items:wt}=j;lr.evaluated={props:Br instanceof Px.Name?void 0:Br,items:wt instanceof Px.Name?void 0:wt,dynamicProps:Br instanceof Px.Name,dynamicItems:wt instanceof Px.Name},lr.source&&(lr.source.evaluated=(0,Px.stringify)(lr.evaluated))}return l.validate=lr,l}catch(ze){throw delete l.validate,delete l.validateName,se&&this.logger.error("Error compiling schema, function code:",se),ze}finally{this._compilations.delete(l)}}jT.compileSchema=Ywe;function qhr(l,c,f){var y;f=(0,Nx.resolveUrl)(this.opts.uriResolver,c,f);let b=l.refs[f];if(b)return b;let A=$hr.call(this,l,f);if(A===void 0){let g=(y=l.localRefs)===null||y===void 0?void 0:y[f],{schemaId:p}=this.opts;g&&(A=new jF({schema:g,schemaId:p,root:l,baseId:c}))}if(A!==void 0)return l.refs[f]=zhr.call(this,A)}jT.resolveRef=qhr;function zhr(l){return(0,Nx.inlineRef)(l.schema,this.opts.inlineRefs)?l.schema:l.validate?l:Ywe.call(this,l)}function yht(l){for(let c of this._compilations)if(Whr(c,l))return c}jT.getCompilingSchema=yht;function Whr(l,c){return l.schema===c.schema&&l.root===c.root&&l.baseId===c.baseId}function $hr(l,c){let f;for(;typeof(f=this.refs[c])=="string";)c=f;return f||this.schemas[c]||oce.call(this,l,c)}function oce(l,c){let f=this.opts.uriResolver.parse(c),y=(0,Nx._getFullPath)(this.opts.uriResolver,f),b=(0,Nx.getFullPath)(this.opts.uriResolver,l.baseId,void 0);if(Object.keys(l.schema).length>0&&y===b)return Gwe.call(this,f,l);let A=(0,Nx.normalizeId)(y),g=this.refs[A]||this.schemas[A];if(typeof g=="string"){let p=oce.call(this,l,g);return typeof p?.schema!="object"?void 0:Gwe.call(this,f,p)}if(typeof g?.schema=="object"){if(g.validate||Ywe.call(this,g),A===(0,Nx.normalizeId)(c)){let{schema:p}=g,{schemaId:k}=this.opts,j=p[k];return j&&(b=(0,Nx.resolveUrl)(this.opts.uriResolver,b,j)),new jF({schema:p,schemaId:k,root:l,baseId:b})}return Gwe.call(this,f,g)}}jT.resolveSchema=oce;var Hhr=new Set(["properties","patternProperties","enum","dependencies","definitions"]);function Gwe(l,{baseId:c,schema:f,root:y}){var b;if(((b=l.fragment)===null||b===void 0?void 0:b[0])!=="/")return;for(let p of l.fragment.slice(1).split("/")){if(typeof f=="boolean")return;let k=f[(0,hht.unescapeFragment)(p)];if(k===void 0)return;f=k;let j=typeof f=="object"&&f[this.opts.schemaId];!Hhr.has(p)&&j&&(c=(0,Nx.resolveUrl)(this.opts.uriResolver,c,j))}let A;if(typeof f!="boolean"&&f.$ref&&!(0,hht.schemaHasRulesButRef)(f,this.RULES)){let p=(0,Nx.resolveUrl)(this.opts.uriResolver,c,f.$ref);A=oce.call(this,y,p)}let{schemaId:g}=this.opts;if(A=A||new jF({schema:f,schemaId:g,root:y,baseId:c}),A.schema!==A.root.schema)return A}});var vht=xt((a3r,Ghr)=>{Ghr.exports={$id:"https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#",description:"Meta-schema for $data reference (JSON AnySchema extension proposal)",type:"object",required:["$data"],properties:{$data:{type:"string",anyOf:[{format:"relative-json-pointer"},{format:"json-pointer"}]}},additionalProperties:!1}});var bht=xt((o3r,Sht)=>{"use strict";var Yhr={0:0,1:1,2:2,3:3,4:4,5:5,6:6,7:7,8:8,9:9,a:10,A:10,b:11,B:11,c:12,C:12,d:13,D:13,e:14,E:14,f:15,F:15};Sht.exports={HEX:Yhr}});var Nht=xt((c3r,Pht)=>{"use strict";var{HEX:Khr}=bht();function Cht(l){if(kht(l,".")<3)return{host:l,isIPV4:!1};let c=l.match(/^(?:(?:25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])\.){3}(?:25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])$/u)||[],[f]=c;return f?{host:Qhr(f,"."),isIPV4:!0}:{host:l,isIPV4:!1}}function Kwe(l,c=!1){let f="",y=!0;for(let b of l){if(Khr[b]===void 0)return;b!=="0"&&y===!0&&(y=!1),y||(f+=b)}return c&&f.length===0&&(f="0"),f}function Xhr(l){let c=0,f={error:!1,address:"",zone:""},y=[],b=[],A=!1,g=!1,p=!1;function k(){if(b.length){if(A===!1){let j=Kwe(b);if(j!==void 0)y.push(j);else return f.error=!0,!1}b.length=0}return!0}for(let j=0;j<l.length;j++){let se=l[j];if(!(se==="["||se==="]"))if(se===":"){if(g===!0&&(p=!0),!k())break;if(c++,y.push(":"),c>7){f.error=!0;break}j-1>=0&&l[j-1]===":"&&(g=!0);continue}else if(se==="%"){if(!k())break;A=!0}else{b.push(se);continue}}return b.length&&(A?f.zone=b.join(""):p?y.push(b.join("")):y.push(Kwe(b))),f.address=y.join(""),f}function Aht(l,c={}){if(kht(l,":")<2)return{host:l,isIPV6:!1};let f=Xhr(l);if(f.error)return{host:l,isIPV6:!1};{let y=f.address,b=f.address;return f.zone&&(y+="%"+f.zone,b+="%25"+f.zone),{host:y,escapedHost:b,isIPV6:!0}}}function Qhr(l,c){let f="",y=!0,b=l.length;for(let A=0;A<b;A++){let g=l[A];g==="0"&&y?(A+1<=b&&l[A+1]===c||A+1===b)&&(f+=g,y=!1):(g===c?y=!0:y=!1,f+=g)}return f}function kht(l,c){let f=0;for(let y=0;y<l.length;y++)l[y]===c&&f++;return f}var Tht=/^\.\.?\//u,Eht=/^\/\.(?:\/|$)/u,xht=/^\/\.\.(?:\/|$)/u,Zhr=/^\/?(?:.|\n)*?(?=\/|$)/u;function eyr(l){let c=[];for(;l.length;)if(l.match(Tht))l=l.replace(Tht,"");else if(l.match(Eht))l=l.replace(Eht,"/");else if(l.match(xht))l=l.replace(xht,"/"),c.pop();else if(l==="."||l==="..")l="";else{let f=l.match(Zhr);if(f){let y=f[0];l=l.slice(y.length),c.push(y)}else throw new Error("Unexpected dot segment condition")}return c.join("")}function tyr(l,c){let f=c!==!0?escape:unescape;return l.scheme!==void 0&&(l.scheme=f(l.scheme)),l.userinfo!==void 0&&(l.userinfo=f(l.userinfo)),l.host!==void 0&&(l.host=f(l.host)),l.path!==void 0&&(l.path=f(l.path)),l.query!==void 0&&(l.query=f(l.query)),l.fragment!==void 0&&(l.fragment=f(l.fragment)),l}function ryr(l,c){let f=[];if(l.userinfo!==void 0&&(f.push(l.userinfo),f.push("@")),l.host!==void 0){let y=unescape(l.host),b=Cht(y);if(b.isIPV4)y=b.host;else{let A=Aht(b.host,{isIPV4:!1});A.isIPV6===!0?y=`[${A.escapedHost}]`:y=l.host}f.push(y)}return(typeof l.port=="number"||typeof l.port=="string")&&(f.push(":"),f.push(String(l.port))),f.length?f.join(""):void 0}Pht.exports={recomposeAuthority:ryr,normalizeComponentEncoding:tyr,removeDotSegments:eyr,normalizeIPv4:Cht,normalizeIPv6:Aht,stringArrayToHexStripped:Kwe}});var Mht=xt((l3r,Rht)=>{"use strict";var nyr=/^[\da-f]{8}\b-[\da-f]{4}\b-[\da-f]{4}\b-[\da-f]{4}\b-[\da-f]{12}$/iu,iyr=/([\da-z][\d\-a-z]{0,31}):((?:[\w!$'()*+,\-.:;=@]|%[\da-f]{2})+)/iu;function Dht(l){return typeof l.secure=="boolean"?l.secure:String(l.scheme).toLowerCase()==="wss"}function wht(l){return l.host||(l.error=l.error||"HTTP URIs must have a host."),l}function Iht(l){let c=String(l.scheme).toLowerCase()==="https";return(l.port===(c?443:80)||l.port==="")&&(l.port=void 0),l.path||(l.path="/"),l}function syr(l){return l.secure=Dht(l),l.resourceName=(l.path||"/")+(l.query?"?"+l.query:""),l.path=void 0,l.query=void 0,l}function ayr(l){if((l.port===(Dht(l)?443:80)||l.port==="")&&(l.port=void 0),typeof l.secure=="boolean"&&(l.scheme=l.secure?"wss":"ws",l.secure=void 0),l.resourceName){let[c,f]=l.resourceName.split("?");l.path=c&&c!=="/"?c:void 0,l.query=f,l.resourceName=void 0}return l.fragment=void 0,l}function oyr(l,c){if(!l.path)return l.error="URN can not be parsed",l;let f=l.path.match(iyr);if(f){let y=c.scheme||l.scheme||"urn";l.nid=f[1].toLowerCase(),l.nss=f[2];let b=`${y}:${c.nid||l.nid}`,A=Xwe[b];l.path=void 0,A&&(l=A.parse(l,c))}else l.error=l.error||"URN can not be parsed.";return l}function cyr(l,c){let f=c.scheme||l.scheme||"urn",y=l.nid.toLowerCase(),b=`${f}:${c.nid||y}`,A=Xwe[b];A&&(l=A.serialize(l,c));let g=l,p=l.nss;return g.path=`${y||c.nid}:${p}`,c.skipEscape=!0,g}function lyr(l,c){let f=l;return f.uuid=f.nss,f.nss=void 0,!c.tolerant&&(!f.uuid||!nyr.test(f.uuid))&&(f.error=f.error||"UUID is not valid."),f}function uyr(l){let c=l;return c.nss=(l.uuid||"").toLowerCase(),c}var Oht={scheme:"http",domainHost:!0,parse:wht,serialize:Iht},_yr={scheme:"https",domainHost:Oht.domainHost,parse:wht,serialize:Iht},lce={scheme:"ws",domainHost:!0,parse:syr,serialize:ayr},fyr={scheme:"wss",domainHost:lce.domainHost,parse:lce.parse,serialize:lce.serialize},pyr={scheme:"urn",parse:oyr,serialize:cyr,skipNormalize:!0},dyr={scheme:"urn:uuid",parse:lyr,serialize:uyr,skipNormalize:!0},Xwe={http:Oht,https:_yr,ws:lce,wss:fyr,urn:pyr,"urn:uuid":dyr};Rht.exports=Xwe});var Fht=xt((u3r,_ce)=>{"use strict";var{normalizeIPv6:myr,normalizeIPv4:gyr,removeDotSegments:cW,recomposeAuthority:hyr,normalizeComponentEncoding:uce}=Nht(),Qwe=Mht();function yyr(l,c){return typeof l=="string"?l=RC(bP(l,c),c):typeof l=="object"&&(l=bP(RC(l,c),c)),l}function vyr(l,c,f){let y=Object.assign({scheme:"null"},f),b=Lht(bP(l,y),bP(c,y),y,!0);return RC(b,{...y,skipEscape:!0})}function Lht(l,c,f,y){let b={};return y||(l=bP(RC(l,f),f),c=bP(RC(c,f),f)),f=f||{},!f.tolerant&&c.scheme?(b.scheme=c.scheme,b.userinfo=c.userinfo,b.host=c.host,b.port=c.port,b.path=cW(c.path||""),b.query=c.query):(c.userinfo!==void 0||c.host!==void 0||c.port!==void 0?(b.userinfo=c.userinfo,b.host=c.host,b.port=c.port,b.path=cW(c.path||""),b.query=c.query):(c.path?(c.path.charAt(0)==="/"?b.path=cW(c.path):((l.userinfo!==void 0||l.host!==void 0||l.port!==void 0)&&!l.path?b.path="/"+c.path:l.path?b.path=l.path.slice(0,l.path.lastIndexOf("/")+1)+c.path:b.path=c.path,b.path=cW(b.path)),b.query=c.query):(b.path=l.path,c.query!==void 0?b.query=c.query:b.query=l.query),b.userinfo=l.userinfo,b.host=l.host,b.port=l.port),b.scheme=l.scheme),b.fragment=c.fragment,b}function Syr(l,c,f){return typeof l=="string"?(l=unescape(l),l=RC(uce(bP(l,f),!0),{...f,skipEscape:!0})):typeof l=="object"&&(l=RC(uce(l,!0),{...f,skipEscape:!0})),typeof c=="string"?(c=unescape(c),c=RC(uce(bP(c,f),!0),{...f,skipEscape:!0})):typeof c=="object"&&(c=RC(uce(c,!0),{...f,skipEscape:!0})),l.toLowerCase()===c.toLowerCase()}function RC(l,c){let f={host:l.host,scheme:l.scheme,userinfo:l.userinfo,port:l.port,path:l.path,query:l.query,nid:l.nid,nss:l.nss,uuid:l.uuid,fragment:l.fragment,reference:l.reference,resourceName:l.resourceName,secure:l.secure,error:""},y=Object.assign({},c),b=[],A=Qwe[(y.scheme||f.scheme||"").toLowerCase()];A&&A.serialize&&A.serialize(f,y),f.path!==void 0&&(y.skipEscape?f.path=unescape(f.path):(f.path=escape(f.path),f.scheme!==void 0&&(f.path=f.path.split("%3A").join(":")))),y.reference!=="suffix"&&f.scheme&&(b.push(f.scheme),b.push(":"));let g=hyr(f,y);if(g!==void 0&&(y.reference!=="suffix"&&b.push("//"),b.push(g),f.path&&f.path.charAt(0)!=="/"&&b.push("/")),f.path!==void 0){let p=f.path;!y.absolutePath&&(!A||!A.absolutePath)&&(p=cW(p)),g===void 0&&(p=p.replace(/^\/\//u,"/%2F")),b.push(p)}return f.query!==void 0&&(b.push("?"),b.push(f.query)),f.fragment!==void 0&&(b.push("#"),b.push(f.fragment)),b.join("")}var byr=Array.from({length:127},(l,c)=>/[^!"$&'()*+,\-.;=_`a-z{}~]/u.test(String.fromCharCode(c)));function Tyr(l){let c=0;for(let f=0,y=l.length;f<y;++f)if(c=l.charCodeAt(f),c>126||byr[c])return!0;return!1}var Eyr=/^(?:([^#/:?]+):)?(?:\/\/((?:([^#/?@]*)@)?(\[[^#/?\]]+\]|[^#/:?]*)(?::(\d*))?))?([^#?]*)(?:\?([^#]*))?(?:#((?:.|[\n\r])*))?/u;function bP(l,c){let f=Object.assign({},c),y={scheme:void 0,userinfo:void 0,host:"",port:void 0,path:"",query:void 0,fragment:void 0},b=l.indexOf("%")!==-1,A=!1;f.reference==="suffix"&&(l=(f.scheme?f.scheme+":":"")+"//"+l);let g=l.match(Eyr);if(g){if(y.scheme=g[1],y.userinfo=g[3],y.host=g[4],y.port=parseInt(g[5],10),y.path=g[6]||"",y.query=g[7],y.fragment=g[8],isNaN(y.port)&&(y.port=g[5]),y.host){let k=gyr(y.host);if(k.isIPV4===!1){let j=myr(k.host,{isIPV4:!1});y.host=j.host.toLowerCase(),A=j.isIPV6}else y.host=k.host,A=!0}y.scheme===void 0&&y.userinfo===void 0&&y.host===void 0&&y.port===void 0&&!y.path&&y.query===void 0?y.reference="same-document":y.scheme===void 0?y.reference="relative":y.fragment===void 0?y.reference="absolute":y.reference="uri",f.reference&&f.reference!=="suffix"&&f.reference!==y.reference&&(y.error=y.error||"URI is not a "+f.reference+" reference.");let p=Qwe[(f.scheme||y.scheme||"").toLowerCase()];if(!f.unicodeSupport&&(!p||!p.unicodeSupport)&&y.host&&(f.domainHost||p&&p.domainHost)&&A===!1&&Tyr(y.host))try{y.host=URL.domainToASCII(y.host.toLowerCase())}catch(k){y.error=y.error||"Host's domain name can not be converted to ASCII: "+k}(!p||p&&!p.skipNormalize)&&(b&&y.scheme!==void 0&&(y.scheme=unescape(y.scheme)),b&&y.userinfo!==void 0&&(y.userinfo=unescape(y.userinfo)),b&&y.host!==void 0&&(y.host=unescape(y.host)),y.path!==void 0&&y.path.length&&(y.path=escape(unescape(y.path))),y.fragment!==void 0&&y.fragment.length&&(y.fragment=encodeURI(decodeURIComponent(y.fragment)))),p&&p.parse&&p.parse(y,f)}else y.error=y.error||"URI can not be parsed.";return y}var Zwe={SCHEMES:Qwe,normalize:yyr,resolve:vyr,resolveComponents:Lht,equal:Syr,serialize:RC,parse:bP};_ce.exports=Zwe;_ce.exports.default=Zwe;_ce.exports.fastUri=Zwe});var Bht=xt(eIe=>{"use strict";Object.defineProperty(eIe,"__esModule",{value:!0});var jht=Fht();jht.code='require("ajv/dist/runtime/uri").default';eIe.default=jht});var Hht=xt(gy=>{"use strict";Object.defineProperty(gy,"__esModule",{value:!0});gy.CodeGen=gy.Name=gy.nil=gy.stringify=gy.str=gy._=gy.KeywordCxt=void 0;var xyr=aW();Object.defineProperty(gy,"KeywordCxt",{enumerable:!0,get:function(){return xyr.KeywordCxt}});var BF=Yl();Object.defineProperty(gy,"_",{enumerable:!0,get:function(){return BF._}});Object.defineProperty(gy,"str",{enumerable:!0,get:function(){return BF.str}});Object.defineProperty(gy,"stringify",{enumerable:!0,get:function(){return BF.stringify}});Object.defineProperty(gy,"nil",{enumerable:!0,get:function(){return BF.nil}});Object.defineProperty(gy,"Name",{enumerable:!0,get:function(){return BF.Name}});Object.defineProperty(gy,"CodeGen",{enumerable:!0,get:function(){return BF.CodeGen}});var Cyr=ace(),zht=oW(),Ayr=Dwe(),lW=cce(),kyr=Yl(),uW=nW(),fce=rW(),rIe=Ju(),Uht=vht(),Pyr=Bht(),Wht=(l,c)=>new RegExp(l,c);Wht.code="new RegExp";var Nyr=["removeAdditional","useDefaults","coerceTypes"],Dyr=new Set(["validate","serialize","parse","wrapper","root","schema","keyword","pattern","formats","validate$data","func","obj","Error"]),wyr={errorDataPath:"",format:"`validateFormats: false` can be used instead.",nullable:'"nullable" keyword is supported by default.',jsonPointers:"Deprecated jsPropertySyntax can be used instead.",extendRefs:"Deprecated ignoreKeywordsWithRef can be used instead.",missingRefs:"Pass empty schema with $id that should be ignored to ajv.addSchema.",processCode:"Use option `code: {process: (code, schemaEnv: object) => string}`",sourceCode:"Use option `code: {source: true}`",strictDefaults:"It is default now, see option `strict`.",strictKeywords:"It is default now, see option `strict`.",uniqueItems:'"uniqueItems" keyword is always validated.',unknownFormats:"Disable strict mode or pass `true` to `ajv.addFormat` (or `formats` option).",cache:"Map is used as cache, schema object as key.",serialize:"Map is used as cache, schema object as key.",ajvErrors:"It is default now."},Iyr={ignoreKeywordsWithRef:"",jsPropertySyntax:"",unicode:'"minLength"/"maxLength" account for unicode characters by default.'},Vht=200;function Oyr(l){var c,f,y,b,A,g,p,k,j,se,ze,ve,lr,Br,wt,kt,Fi,yi,qo,Xl,ho,bf,wi,Ln,xm;let Bo=l.strict,pv=(c=l.code)===null||c===void 0?void 0:c.optimize,Jw=pv===!0||pv===void 0?1:pv||0,Es=(y=(f=l.code)===null||f===void 0?void 0:f.regExp)!==null&&y!==void 0?y:Wht,UT=(b=l.uriResolver)!==null&&b!==void 0?b:Pyr.default;return{strictSchema:(g=(A=l.strictSchema)!==null&&A!==void 0?A:Bo)!==null&&g!==void 0?g:!0,strictNumbers:(k=(p=l.strictNumbers)!==null&&p!==void 0?p:Bo)!==null&&k!==void 0?k:!0,strictTypes:(se=(j=l.strictTypes)!==null&&j!==void 0?j:Bo)!==null&&se!==void 0?se:"log",strictTuples:(ve=(ze=l.strictTuples)!==null&&ze!==void 0?ze:Bo)!==null&&ve!==void 0?ve:"log",strictRequired:(Br=(lr=l.strictRequired)!==null&&lr!==void 0?lr:Bo)!==null&&Br!==void 0?Br:!1,code:l.code?{...l.code,optimize:Jw,regExp:Es}:{optimize:Jw,regExp:Es},loopRequired:(wt=l.loopRequired)!==null&&wt!==void 0?wt:Vht,loopEnum:(kt=l.loopEnum)!==null&&kt!==void 0?kt:Vht,meta:(Fi=l.meta)!==null&&Fi!==void 0?Fi:!0,messages:(yi=l.messages)!==null&&yi!==void 0?yi:!0,inlineRefs:(qo=l.inlineRefs)!==null&&qo!==void 0?qo:!0,schemaId:(Xl=l.schemaId)!==null&&Xl!==void 0?Xl:"$id",addUsedSchema:(ho=l.addUsedSchema)!==null&&ho!==void 0?ho:!0,validateSchema:(bf=l.validateSchema)!==null&&bf!==void 0?bf:!0,validateFormats:(wi=l.validateFormats)!==null&&wi!==void 0?wi:!0,unicodeRegExp:(Ln=l.unicodeRegExp)!==null&&Ln!==void 0?Ln:!0,int32range:(xm=l.int32range)!==null&&xm!==void 0?xm:!0,uriResolver:UT}}var _W=class{constructor(c={}){this.schemas={},this.refs={},this.formats={},this._compilations=new Set,this._loading={},this._cache=new Map,c=this.opts={...c,...Oyr(c)};let{es5:f,lines:y}=this.opts.code;this.scope=new kyr.ValueScope({scope:{},prefixes:Dyr,es5:f,lines:y}),this.logger=Byr(c.logger);let b=c.validateFormats;c.validateFormats=!1,this.RULES=(0,Ayr.getRules)(),Jht.call(this,wyr,c,"NOT SUPPORTED"),Jht.call(this,Iyr,c,"DEPRECATED","warn"),this._metaOpts=Fyr.call(this),c.formats&&Myr.call(this),this._addVocabularies(),this._addDefaultMetaSchema(),c.keywords&&Lyr.call(this,c.keywords),typeof c.meta=="object"&&this.addMetaSchema(c.meta),Ryr.call(this),c.validateFormats=b}_addVocabularies(){this.addKeyword("$async")}_addDefaultMetaSchema(){let{$data:c,meta:f,schemaId:y}=this.opts,b=Uht;y==="id"&&(b={...Uht},b.id=b.$id,delete b.$id),f&&c&&this.addMetaSchema(b,b[y],!1)}defaultMeta(){let{meta:c,schemaId:f}=this.opts;return this.opts.defaultMeta=typeof c=="object"?c[f]||c:void 0}validate(c,f){let y;if(typeof c=="string"){if(y=this.getSchema(c),!y)throw new Error(`no schema with key or ref "${c}"`)}else y=this.compile(c);let b=y(f);return"$async"in y||(this.errors=y.errors),b}compile(c,f){let y=this._addSchema(c,f);return y.validate||this._compileSchemaEnv(y)}compileAsync(c,f){if(typeof this.opts.loadSchema!="function")throw new Error("options.loadSchema should be a function");let{loadSchema:y}=this.opts;return b.call(this,c,f);async function b(se,ze){await A.call(this,se.$schema);let ve=this._addSchema(se,ze);return ve.validate||g.call(this,ve)}async function A(se){se&&!this.getSchema(se)&&await b.call(this,{$ref:se},!0)}async function g(se){try{return this._compileSchemaEnv(se)}catch(ze){if(!(ze instanceof zht.default))throw ze;return p.call(this,ze),await k.call(this,ze.missingSchema),g.call(this,se)}}function p({missingSchema:se,missingRef:ze}){if(this.refs[se])throw new Error(`AnySchema ${se} is loaded but ${ze} cannot be resolved`)}async function k(se){let ze=await j.call(this,se);this.refs[se]||await A.call(this,ze.$schema),this.refs[se]||this.addSchema(ze,se,f)}async function j(se){let ze=this._loading[se];if(ze)return ze;try{return await(this._loading[se]=y(se))}finally{delete this._loading[se]}}}addSchema(c,f,y,b=this.opts.validateSchema){if(Array.isArray(c)){for(let g of c)this.addSchema(g,void 0,y,b);return this}let A;if(typeof c=="object"){let{schemaId:g}=this.opts;if(A=c[g],A!==void 0&&typeof A!="string")throw new Error(`schema ${g} must be string`)}return f=(0,uW.normalizeId)(f||A),this._checkUnique(f),this.schemas[f]=this._addSchema(c,y,f,b,!0),this}addMetaSchema(c,f,y=this.opts.validateSchema){return this.addSchema(c,f,!0,y),this}validateSchema(c,f){if(typeof c=="boolean")return!0;let y;if(y=c.$schema,y!==void 0&&typeof y!="string")throw new Error("$schema must be a string");if(y=y||this.opts.defaultMeta||this.defaultMeta(),!y)return this.logger.warn("meta-schema not available"),this.errors=null,!0;let b=this.validate(y,c);if(!b&&f){let A="schema is invalid: "+this.errorsText();if(this.opts.validateSchema==="log")this.logger.error(A);else throw new Error(A)}return b}getSchema(c){let f;for(;typeof(f=qht.call(this,c))=="string";)c=f;if(f===void 0){let{schemaId:y}=this.opts,b=new lW.SchemaEnv({schema:{},schemaId:y});if(f=lW.resolveSchema.call(this,b,c),!f)return;this.refs[c]=f}return f.validate||this._compileSchemaEnv(f)}removeSchema(c){if(c instanceof RegExp)return this._removeAllSchemas(this.schemas,c),this._removeAllSchemas(this.refs,c),this;switch(typeof c){case"undefined":return this._removeAllSchemas(this.schemas),this._removeAllSchemas(this.refs),this._cache.clear(),this;case"string":{let f=qht.call(this,c);return typeof f=="object"&&this._cache.delete(f.schema),delete this.schemas[c],delete this.refs[c],this}case"object":{let f=c;this._cache.delete(f);let y=c[this.opts.schemaId];return y&&(y=(0,uW.normalizeId)(y),delete this.schemas[y],delete this.refs[y]),this}default:throw new Error("ajv.removeSchema: invalid parameter")}}addVocabulary(c){for(let f of c)this.addKeyword(f);return this}addKeyword(c,f){let y;if(typeof c=="string")y=c,typeof f=="object"&&(this.logger.warn("these parameters are deprecated, see docs for addKeyword"),f.keyword=y);else if(typeof c=="object"&&f===void 0){if(f=c,y=f.keyword,Array.isArray(y)&&!y.length)throw new Error("addKeywords: keyword must be string or non-empty array")}else throw new Error("invalid addKeywords parameters");if(Vyr.call(this,y,f),!f)return(0,rIe.eachItem)(y,A=>tIe.call(this,A)),this;qyr.call(this,f);let b={...f,type:(0,fce.getJSONTypes)(f.type),schemaType:(0,fce.getJSONTypes)(f.schemaType)};return(0,rIe.eachItem)(y,b.type.length===0?A=>tIe.call(this,A,b):A=>b.type.forEach(g=>tIe.call(this,A,b,g))),this}getKeyword(c){let f=this.RULES.all[c];return typeof f=="object"?f.definition:!!f}removeKeyword(c){let{RULES:f}=this;delete f.keywords[c],delete f.all[c];for(let y of f.rules){let b=y.rules.findIndex(A=>A.keyword===c);b>=0&&y.rules.splice(b,1)}return this}addFormat(c,f){return typeof f=="string"&&(f=new RegExp(f)),this.formats[c]=f,this}errorsText(c=this.errors,{separator:f=", ",dataVar:y="data"}={}){return!c||c.length===0?"No errors":c.map(b=>`${y}${b.instancePath} ${b.message}`).reduce((b,A)=>b+f+A)}$dataMetaSchema(c,f){let y=this.RULES.all;c=JSON.parse(JSON.stringify(c));for(let b of f){let A=b.split("/").slice(1),g=c;for(let p of A)g=g[p];for(let p in y){let k=y[p];if(typeof k!="object")continue;let{$data:j}=k.definition,se=g[p];j&&se&&(g[p]=$ht(se))}}return c}_removeAllSchemas(c,f){for(let y in c){let b=c[y];(!f||f.test(y))&&(typeof b=="string"?delete c[y]:b&&!b.meta&&(this._cache.delete(b.schema),delete c[y]))}}_addSchema(c,f,y,b=this.opts.validateSchema,A=this.opts.addUsedSchema){let g,{schemaId:p}=this.opts;if(typeof c=="object")g=c[p];else{if(this.opts.jtd)throw new Error("schema must be object");if(typeof c!="boolean")throw new Error("schema must be object or boolean")}let k=this._cache.get(c);if(k!==void 0)return k;y=(0,uW.normalizeId)(g||y);let j=uW.getSchemaRefs.call(this,c,y);return k=new lW.SchemaEnv({schema:c,schemaId:p,meta:f,baseId:y,localRefs:j}),this._cache.set(k.schema,k),A&&!y.startsWith("#")&&(y&&this._checkUnique(y),this.refs[y]=k),b&&this.validateSchema(c,!0),k}_checkUnique(c){if(this.schemas[c]||this.refs[c])throw new Error(`schema with key or id "${c}" already exists`)}_compileSchemaEnv(c){if(c.meta?this._compileMetaSchema(c):lW.compileSchema.call(this,c),!c.validate)throw new Error("ajv implementation error");return c.validate}_compileMetaSchema(c){let f=this.opts;this.opts=this._metaOpts;try{lW.compileSchema.call(this,c)}finally{this.opts=f}}};_W.ValidationError=Cyr.default;_W.MissingRefError=zht.default;gy.default=_W;function Jht(l,c,f,y="error"){for(let b in l){let A=b;A in c&&this.logger[y](`${f}: option ${b}. ${l[A]}`)}}function qht(l){return l=(0,uW.normalizeId)(l),this.schemas[l]||this.refs[l]}function Ryr(){let l=this.opts.schemas;if(l)if(Array.isArray(l))this.addSchema(l);else for(let c in l)this.addSchema(l[c],c)}function Myr(){for(let l in this.opts.formats){let c=this.opts.formats[l];c&&this.addFormat(l,c)}}function Lyr(l){if(Array.isArray(l)){this.addVocabulary(l);return}this.logger.warn("keywords option as map is deprecated, pass array");for(let c in l){let f=l[c];f.keyword||(f.keyword=c),this.addKeyword(f)}}function Fyr(){let l={...this.opts};for(let c of Nyr)delete l[c];return l}var jyr={log(){},warn(){},error(){}};function Byr(l){if(l===!1)return jyr;if(l===void 0)return console;if(l.log&&l.warn&&l.error)return l;throw new Error("logger must implement log, warn and error methods")}var Uyr=/^[a-z_$][a-z0-9_$:-]*$/i;function Vyr(l,c){let{RULES:f}=this;if((0,rIe.eachItem)(l,y=>{if(f.keywords[y])throw new Error(`Keyword ${y} is already defined`);if(!Uyr.test(y))throw new Error(`Keyword ${y} has invalid name`)}),!!c&&c.$data&&!("code"in c||"validate"in c))throw new Error('$data keyword must have "code" or "validate" function')}function tIe(l,c,f){var y;let b=c?.post;if(f&&b)throw new Error('keyword with "post" flag cannot have "type"');let{RULES:A}=this,g=b?A.post:A.rules.find(({type:k})=>k===f);if(g||(g={type:f,rules:[]},A.rules.push(g)),A.keywords[l]=!0,!c)return;let p={keyword:l,definition:{...c,type:(0,fce.getJSONTypes)(c.type),schemaType:(0,fce.getJSONTypes)(c.schemaType)}};c.before?Jyr.call(this,g,p,c.before):g.rules.push(p),A.all[l]=p,(y=c.implements)===null||y===void 0||y.forEach(k=>this.addKeyword(k))}function Jyr(l,c,f){let y=l.rules.findIndex(b=>b.keyword===f);y>=0?l.rules.splice(y,0,c):(l.rules.push(c),this.logger.warn(`rule ${f} is not defined`))}function qyr(l){let{metaSchema:c}=l;c!==void 0&&(l.$data&&this.opts.$data&&(c=$ht(c)),l.validateSchema=this.compile(c,!0))}var zyr={$ref:"https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#"};function $ht(l){return{anyOf:[l,zyr]}}});var Ght=xt(nIe=>{"use strict";Object.defineProperty(nIe,"__esModule",{value:!0});var Wyr={keyword:"id",code(){throw new Error('NOT SUPPORTED: keyword "id", use "$id" for schema ID')}};nIe.default=Wyr});var Qht=xt(n3=>{"use strict";Object.defineProperty(n3,"__esModule",{value:!0});n3.callRef=n3.getValidate=void 0;var $yr=oW(),Yht=FT(),N1=Yl(),UF=vP(),Kht=cce(),pce=Ju(),Hyr={keyword:"$ref",schemaType:"string",code(l){let{gen:c,schema:f,it:y}=l,{baseId:b,schemaEnv:A,validateName:g,opts:p,self:k}=y,{root:j}=A;if((f==="#"||f==="#/")&&b===j.baseId)return ze();let se=Kht.resolveRef.call(k,j,b,f);if(se===void 0)throw new $yr.default(y.opts.uriResolver,b,f);if(se instanceof Kht.SchemaEnv)return ve(se);return lr(se);function ze(){if(A===j)return dce(l,g,A,A.$async);let Br=c.scopeValue("root",{ref:j});return dce(l,(0,N1._)`${Br}.validate`,j,j.$async)}function ve(Br){let wt=Xht(l,Br);dce(l,wt,Br,Br.$async)}function lr(Br){let wt=c.scopeValue("schema",p.code.source===!0?{ref:Br,code:(0,N1.stringify)(Br)}:{ref:Br}),kt=c.name("valid"),Fi=l.subschema({schema:Br,dataTypes:[],schemaPath:N1.nil,topSchemaRef:wt,errSchemaPath:f},kt);l.mergeEvaluated(Fi),l.ok(kt)}}};function Xht(l,c){let{gen:f}=l;return c.validate?f.scopeValue("validate",{ref:c.validate}):(0,N1._)`${f.scopeValue("wrapper",{ref:c})}.validate`}n3.getValidate=Xht;function dce(l,c,f,y){let{gen:b,it:A}=l,{allErrors:g,schemaEnv:p,opts:k}=A,j=k.passContext?UF.default.this:N1.nil;y?se():ze();function se(){if(!p.$async)throw new Error("async schema referenced by sync schema");let Br=b.let("valid");b.try(()=>{b.code((0,N1._)`await ${(0,Yht.callValidateCode)(l,c,j)}`),lr(c),g||b.assign(Br,!0)},wt=>{b.if((0,N1._)`!(${wt} instanceof ${A.ValidationError})`,()=>b.throw(wt)),ve(wt),g||b.assign(Br,!1)}),l.ok(Br)}function ze(){l.result((0,Yht.callValidateCode)(l,c,j),()=>lr(c),()=>ve(c))}function ve(Br){let wt=(0,N1._)`${Br}.errors`;b.assign(UF.default.vErrors,(0,N1._)`${UF.default.vErrors} === null ? ${wt} : ${UF.default.vErrors}.concat(${wt})`),b.assign(UF.default.errors,(0,N1._)`${UF.default.vErrors}.length`)}function lr(Br){var wt;if(!A.opts.unevaluated)return;let kt=(wt=f?.validate)===null||wt===void 0?void 0:wt.evaluated;if(A.props!==!0)if(kt&&!kt.dynamicProps)kt.props!==void 0&&(A.props=pce.mergeEvaluated.props(b,kt.props,A.props));else{let Fi=b.var("props",(0,N1._)`${Br}.evaluated.props`);A.props=pce.mergeEvaluated.props(b,Fi,A.props,N1.Name)}if(A.items!==!0)if(kt&&!kt.dynamicItems)kt.items!==void 0&&(A.items=pce.mergeEvaluated.items(b,kt.items,A.items));else{let Fi=b.var("items",(0,N1._)`${Br}.evaluated.items`);A.items=pce.mergeEvaluated.items(b,Fi,A.items,N1.Name)}}}n3.callRef=dce;n3.default=Hyr});var Zht=xt(iIe=>{"use strict";Object.defineProperty(iIe,"__esModule",{value:!0});var Gyr=Ght(),Yyr=Qht(),Kyr=["$schema","$id","$defs","$vocabulary",{keyword:"$comment"},"definitions",Gyr.default,Yyr.default];iIe.default=Kyr});var eyt=xt(sIe=>{"use strict";Object.defineProperty(sIe,"__esModule",{value:!0});var mce=Yl(),jw=mce.operators,gce={maximum:{okStr:"<=",ok:jw.LTE,fail:jw.GT},minimum:{okStr:">=",ok:jw.GTE,fail:jw.LT},exclusiveMaximum:{okStr:"<",ok:jw.LT,fail:jw.GTE},exclusiveMinimum:{okStr:">",ok:jw.GT,fail:jw.LTE}},Xyr={message:({keyword:l,schemaCode:c})=>(0,mce.str)`must be ${gce[l].okStr} ${c}`,params:({keyword:l,schemaCode:c})=>(0,mce._)`{comparison: ${gce[l].okStr}, limit: ${c}}`},Qyr={keyword:Object.keys(gce),type:"number",schemaType:"number",$data:!0,error:Xyr,code(l){let{keyword:c,data:f,schemaCode:y}=l;l.fail$data((0,mce._)`${f} ${gce[c].fail} ${y} || isNaN(${f})`)}};sIe.default=Qyr});var tyt=xt(aIe=>{"use strict";Object.defineProperty(aIe,"__esModule",{value:!0});var fW=Yl(),Zyr={message:({schemaCode:l})=>(0,fW.str)`must be multiple of ${l}`,params:({schemaCode:l})=>(0,fW._)`{multipleOf: ${l}}`},e0r={keyword:"multipleOf",type:"number",schemaType:"number",$data:!0,error:Zyr,code(l){let{gen:c,data:f,schemaCode:y,it:b}=l,A=b.opts.multipleOfPrecision,g=c.let("res"),p=A?(0,fW._)`Math.abs(Math.round(${g}) - ${g}) > 1e-${A}`:(0,fW._)`${g} !== parseInt(${g})`;l.fail$data((0,fW._)`(${y} === 0 || (${g} = ${f}/${y}, ${p}))`)}};aIe.default=e0r});var nyt=xt(oIe=>{"use strict";Object.defineProperty(oIe,"__esModule",{value:!0});function ryt(l){let c=l.length,f=0,y=0,b;for(;y<c;)f++,b=l.charCodeAt(y++),b>=55296&&b<=56319&&y<c&&(b=l.charCodeAt(y),(b&64512)===56320&&y++);return f}oIe.default=ryt;ryt.code='require("ajv/dist/runtime/ucs2length").default'});var iyt=xt(cIe=>{"use strict";Object.defineProperty(cIe,"__esModule",{value:!0});var i3=Yl(),t0r=Ju(),r0r=nyt(),n0r={message({keyword:l,schemaCode:c}){let f=l==="maxLength"?"more":"fewer";return(0,i3.str)`must NOT have ${f} than ${c} characters`},params:({schemaCode:l})=>(0,i3._)`{limit: ${l}}`},i0r={keyword:["maxLength","minLength"],type:"string",schemaType:"number",$data:!0,error:n0r,code(l){let{keyword:c,data:f,schemaCode:y,it:b}=l,A=c==="maxLength"?i3.operators.GT:i3.operators.LT,g=b.opts.unicode===!1?(0,i3._)`${f}.length`:(0,i3._)`${(0,t0r.useFunc)(l.gen,r0r.default)}(${f})`;l.fail$data((0,i3._)`${g} ${A} ${y}`)}};cIe.default=i0r});var syt=xt(lIe=>{"use strict";Object.defineProperty(lIe,"__esModule",{value:!0});var s0r=FT(),hce=Yl(),a0r={message:({schemaCode:l})=>(0,hce.str)`must match pattern "${l}"`,params:({schemaCode:l})=>(0,hce._)`{pattern: ${l}}`},o0r={keyword:"pattern",type:"string",schemaType:"string",$data:!0,error:a0r,code(l){let{data:c,$data:f,schema:y,schemaCode:b,it:A}=l,g=A.opts.unicodeRegExp?"u":"",p=f?(0,hce._)`(new RegExp(${b}, ${g}))`:(0,s0r.usePattern)(l,y);l.fail$data((0,hce._)`!${p}.test(${c})`)}};lIe.default=o0r});var ayt=xt(uIe=>{"use strict";Object.defineProperty(uIe,"__esModule",{value:!0});var pW=Yl(),c0r={message({keyword:l,schemaCode:c}){let f=l==="maxProperties"?"more":"fewer";return(0,pW.str)`must NOT have ${f} than ${c} properties`},params:({schemaCode:l})=>(0,pW._)`{limit: ${l}}`},l0r={keyword:["maxProperties","minProperties"],type:"object",schemaType:"number",$data:!0,error:c0r,code(l){let{keyword:c,data:f,schemaCode:y}=l,b=c==="maxProperties"?pW.operators.GT:pW.operators.LT;l.fail$data((0,pW._)`Object.keys(${f}).length ${b} ${y}`)}};uIe.default=l0r});var oyt=xt(_Ie=>{"use strict";Object.defineProperty(_Ie,"__esModule",{value:!0});var dW=FT(),mW=Yl(),u0r=Ju(),_0r={message:({params:{missingProperty:l}})=>(0,mW.str)`must have required property '${l}'`,params:({params:{missingProperty:l}})=>(0,mW._)`{missingProperty: ${l}}`},f0r={keyword:"required",type:"object",schemaType:"array",$data:!0,error:_0r,code(l){let{gen:c,schema:f,schemaCode:y,data:b,$data:A,it:g}=l,{opts:p}=g;if(!A&&f.length===0)return;let k=f.length>=p.loopRequired;if(g.allErrors?j():se(),p.strictRequired){let lr=l.parentSchema.properties,{definedProperties:Br}=l.it;for(let wt of f)if(lr?.[wt]===void 0&&!Br.has(wt)){let kt=g.schemaEnv.baseId+g.errSchemaPath,Fi=`required property "${wt}" is not defined at "${kt}" (strictRequired)`;(0,u0r.checkStrictMode)(g,Fi,g.opts.strictRequired)}}function j(){if(k||A)l.block$data(mW.nil,ze);else for(let lr of f)(0,dW.checkReportMissingProp)(l,lr)}function se(){let lr=c.let("missing");if(k||A){let Br=c.let("valid",!0);l.block$data(Br,()=>ve(lr,Br)),l.ok(Br)}else c.if((0,dW.checkMissingProp)(l,f,lr)),(0,dW.reportMissingProp)(l,lr),c.else()}function ze(){c.forOf("prop",y,lr=>{l.setParams({missingProperty:lr}),c.if((0,dW.noPropertyInData)(c,b,lr,p.ownProperties),()=>l.error())})}function ve(lr,Br){l.setParams({missingProperty:lr}),c.forOf(lr,y,()=>{c.assign(Br,(0,dW.propertyInData)(c,b,lr,p.ownProperties)),c.if((0,mW.not)(Br),()=>{l.error(),c.break()})},mW.nil)}}};_Ie.default=f0r});var cyt=xt(fIe=>{"use strict";Object.defineProperty(fIe,"__esModule",{value:!0});var gW=Yl(),p0r={message({keyword:l,schemaCode:c}){let f=l==="maxItems"?"more":"fewer";return(0,gW.str)`must NOT have ${f} than ${c} items`},params:({schemaCode:l})=>(0,gW._)`{limit: ${l}}`},d0r={keyword:["maxItems","minItems"],type:"array",schemaType:"number",$data:!0,error:p0r,code(l){let{keyword:c,data:f,schemaCode:y}=l,b=c==="maxItems"?gW.operators.GT:gW.operators.LT;l.fail$data((0,gW._)`${f}.length ${b} ${y}`)}};fIe.default=d0r});var yce=xt(pIe=>{"use strict";Object.defineProperty(pIe,"__esModule",{value:!0});var lyt=jwe();lyt.code='require("ajv/dist/runtime/equal").default';pIe.default=lyt});var uyt=xt(mIe=>{"use strict";Object.defineProperty(mIe,"__esModule",{value:!0});var dIe=rW(),hy=Yl(),m0r=Ju(),g0r=yce(),h0r={message:({params:{i:l,j:c}})=>(0,hy.str)`must NOT have duplicate items (items ## ${c} and ${l} are identical)`,params:({params:{i:l,j:c}})=>(0,hy._)`{i: ${l}, j: ${c}}`},y0r={keyword:"uniqueItems",type:"array",schemaType:"boolean",$data:!0,error:h0r,code(l){let{gen:c,data:f,$data:y,schema:b,parentSchema:A,schemaCode:g,it:p}=l;if(!y&&!b)return;let k=c.let("valid"),j=A.items?(0,dIe.getSchemaTypes)(A.items):[];l.block$data(k,se,(0,hy._)`${g} === false`),l.ok(k);function se(){let Br=c.let("i",(0,hy._)`${f}.length`),wt=c.let("j");l.setParams({i:Br,j:wt}),c.assign(k,!0),c.if((0,hy._)`${Br} > 1`,()=>(ze()?ve:lr)(Br,wt))}function ze(){return j.length>0&&!j.some(Br=>Br==="object"||Br==="array")}function ve(Br,wt){let kt=c.name("item"),Fi=(0,dIe.checkDataTypes)(j,kt,p.opts.strictNumbers,dIe.DataType.Wrong),yi=c.const("indices",(0,hy._)`{}`);c.for((0,hy._)`;${Br}--;`,()=>{c.let(kt,(0,hy._)`${f}[${Br}]`),c.if(Fi,(0,hy._)`continue`),j.length>1&&c.if((0,hy._)`typeof ${kt} == "string"`,(0,hy._)`${kt} += "_"`),c.if((0,hy._)`typeof ${yi}[${kt}] == "number"`,()=>{c.assign(wt,(0,hy._)`${yi}[${kt}]`),l.error(),c.assign(k,!1).break()}).code((0,hy._)`${yi}[${kt}] = ${Br}`)})}function lr(Br,wt){let kt=(0,m0r.useFunc)(c,g0r.default),Fi=c.name("outer");c.label(Fi).for((0,hy._)`;${Br}--;`,()=>c.for((0,hy._)`${wt} = ${Br}; ${wt}--;`,()=>c.if((0,hy._)`${kt}(${f}[${Br}], ${f}[${wt}])`,()=>{l.error(),c.assign(k,!1).break(Fi)})))}}};mIe.default=y0r});var _yt=xt(hIe=>{"use strict";Object.defineProperty(hIe,"__esModule",{value:!0});var gIe=Yl(),v0r=Ju(),S0r=yce(),b0r={message:"must be equal to constant",params:({schemaCode:l})=>(0,gIe._)`{allowedValue: ${l}}`},T0r={keyword:"const",$data:!0,error:b0r,code(l){let{gen:c,data:f,$data:y,schemaCode:b,schema:A}=l;y||A&&typeof A=="object"?l.fail$data((0,gIe._)`!${(0,v0r.useFunc)(c,S0r.default)}(${f}, ${b})`):l.fail((0,gIe._)`${A} !== ${f}`)}};hIe.default=T0r});var fyt=xt(yIe=>{"use strict";Object.defineProperty(yIe,"__esModule",{value:!0});var hW=Yl(),E0r=Ju(),x0r=yce(),C0r={message:"must be equal to one of the allowed values",params:({schemaCode:l})=>(0,hW._)`{allowedValues: ${l}}`},A0r={keyword:"enum",schemaType:"array",$data:!0,error:C0r,code(l){let{gen:c,data:f,$data:y,schema:b,schemaCode:A,it:g}=l;if(!y&&b.length===0)throw new Error("enum must have non-empty array");let p=b.length>=g.opts.loopEnum,k,j=()=>k??(k=(0,E0r.useFunc)(c,x0r.default)),se;if(p||y)se=c.let("valid"),l.block$data(se,ze);else{if(!Array.isArray(b))throw new Error("ajv implementation error");let lr=c.const("vSchema",A);se=(0,hW.or)(...b.map((Br,wt)=>ve(lr,wt)))}l.pass(se);function ze(){c.assign(se,!1),c.forOf("v",A,lr=>c.if((0,hW._)`${j()}(${f}, ${lr})`,()=>c.assign(se,!0).break()))}function ve(lr,Br){let wt=b[Br];return typeof wt=="object"&&wt!==null?(0,hW._)`${j()}(${f}, ${lr}[${Br}])`:(0,hW._)`${f} === ${wt}`}}};yIe.default=A0r});var pyt=xt(vIe=>{"use strict";Object.defineProperty(vIe,"__esModule",{value:!0});var k0r=eyt(),P0r=tyt(),N0r=iyt(),D0r=syt(),w0r=ayt(),I0r=oyt(),O0r=cyt(),R0r=uyt(),M0r=_yt(),L0r=fyt(),F0r=[k0r.default,P0r.default,N0r.default,D0r.default,w0r.default,I0r.default,O0r.default,R0r.default,{keyword:"type",schemaType:["string","array"]},{keyword:"nullable",schemaType:"boolean"},M0r.default,L0r.default];vIe.default=F0r});var bIe=xt(yW=>{"use strict";Object.defineProperty(yW,"__esModule",{value:!0});yW.validateAdditionalItems=void 0;var s3=Yl(),SIe=Ju(),j0r={message:({params:{len:l}})=>(0,s3.str)`must NOT have more than ${l} items`,params:({params:{len:l}})=>(0,s3._)`{limit: ${l}}`},B0r={keyword:"additionalItems",type:"array",schemaType:["boolean","object"],before:"uniqueItems",error:j0r,code(l){let{parentSchema:c,it:f}=l,{items:y}=c;if(!Array.isArray(y)){(0,SIe.checkStrictMode)(f,'"additionalItems" is ignored when "items" is not an array of schemas');return}dyt(l,y)}};function dyt(l,c){let{gen:f,schema:y,data:b,keyword:A,it:g}=l;g.items=!0;let p=f.const("len",(0,s3._)`${b}.length`);if(y===!1)l.setParams({len:c.length}),l.pass((0,s3._)`${p} <= ${c.length}`);else if(typeof y=="object"&&!(0,SIe.alwaysValidSchema)(g,y)){let j=f.var("valid",(0,s3._)`${p} <= ${c.length}`);f.if((0,s3.not)(j),()=>k(j)),l.ok(j)}function k(j){f.forRange("i",c.length,p,se=>{l.subschema({keyword:A,dataProp:se,dataPropType:SIe.Type.Num},j),g.allErrors||f.if((0,s3.not)(j),()=>f.break())})}}yW.validateAdditionalItems=dyt;yW.default=B0r});var TIe=xt(vW=>{"use strict";Object.defineProperty(vW,"__esModule",{value:!0});vW.validateTuple=void 0;var myt=Yl(),vce=Ju(),U0r=FT(),V0r={keyword:"items",type:"array",schemaType:["object","array","boolean"],before:"uniqueItems",code(l){let{schema:c,it:f}=l;if(Array.isArray(c))return gyt(l,"additionalItems",c);f.items=!0,!(0,vce.alwaysValidSchema)(f,c)&&l.ok((0,U0r.validateArray)(l))}};function gyt(l,c,f=l.schema){let{gen:y,parentSchema:b,data:A,keyword:g,it:p}=l;se(b),p.opts.unevaluated&&f.length&&p.items!==!0&&(p.items=vce.mergeEvaluated.items(y,f.length,p.items));let k=y.name("valid"),j=y.const("len",(0,myt._)`${A}.length`);f.forEach((ze,ve)=>{(0,vce.alwaysValidSchema)(p,ze)||(y.if((0,myt._)`${j} > ${ve}`,()=>l.subschema({keyword:g,schemaProp:ve,dataProp:ve},k)),l.ok(k))});function se(ze){let{opts:ve,errSchemaPath:lr}=p,Br=f.length,wt=Br===ze.minItems&&(Br===ze.maxItems||ze[c]===!1);if(ve.strictTuples&&!wt){let kt=`"${g}" is ${Br}-tuple, but minItems or maxItems/${c} are not specified or different at path "${lr}"`;(0,vce.checkStrictMode)(p,kt,ve.strictTuples)}}}vW.validateTuple=gyt;vW.default=V0r});var hyt=xt(EIe=>{"use strict";Object.defineProperty(EIe,"__esModule",{value:!0});var J0r=TIe(),q0r={keyword:"prefixItems",type:"array",schemaType:["array"],before:"uniqueItems",code:l=>(0,J0r.validateTuple)(l,"items")};EIe.default=q0r});var vyt=xt(xIe=>{"use strict";Object.defineProperty(xIe,"__esModule",{value:!0});var yyt=Yl(),z0r=Ju(),W0r=FT(),$0r=bIe(),H0r={message:({params:{len:l}})=>(0,yyt.str)`must NOT have more than ${l} items`,params:({params:{len:l}})=>(0,yyt._)`{limit: ${l}}`},G0r={keyword:"items",type:"array",schemaType:["object","boolean"],before:"uniqueItems",error:H0r,code(l){let{schema:c,parentSchema:f,it:y}=l,{prefixItems:b}=f;y.items=!0,!(0,z0r.alwaysValidSchema)(y,c)&&(b?(0,$0r.validateAdditionalItems)(l,b):l.ok((0,W0r.validateArray)(l)))}};xIe.default=G0r});var Syt=xt(CIe=>{"use strict";Object.defineProperty(CIe,"__esModule",{value:!0});var BT=Yl(),Sce=Ju(),Y0r={message:({params:{min:l,max:c}})=>c===void 0?(0,BT.str)`must contain at least ${l} valid item(s)`:(0,BT.str)`must contain at least ${l} and no more than ${c} valid item(s)`,params:({params:{min:l,max:c}})=>c===void 0?(0,BT._)`{minContains: ${l}}`:(0,BT._)`{minContains: ${l}, maxContains: ${c}}`},K0r={keyword:"contains",type:"array",schemaType:["object","boolean"],before:"uniqueItems",trackErrors:!0,error:Y0r,code(l){let{gen:c,schema:f,parentSchema:y,data:b,it:A}=l,g,p,{minContains:k,maxContains:j}=y;A.opts.next?(g=k===void 0?1:k,p=j):g=1;let se=c.const("len",(0,BT._)`${b}.length`);if(l.setParams({min:g,max:p}),p===void 0&&g===0){(0,Sce.checkStrictMode)(A,'"minContains" == 0 without "maxContains": "contains" keyword ignored');return}if(p!==void 0&&g>p){(0,Sce.checkStrictMode)(A,'"minContains" > "maxContains" is always invalid'),l.fail();return}if((0,Sce.alwaysValidSchema)(A,f)){let wt=(0,BT._)`${se} >= ${g}`;p!==void 0&&(wt=(0,BT._)`${wt} && ${se} <= ${p}`),l.pass(wt);return}A.items=!0;let ze=c.name("valid");p===void 0&&g===1?lr(ze,()=>c.if(ze,()=>c.break())):g===0?(c.let(ze,!0),p!==void 0&&c.if((0,BT._)`${b}.length > 0`,ve)):(c.let(ze,!1),ve()),l.result(ze,()=>l.reset());function ve(){let wt=c.name("_valid"),kt=c.let("count",0);lr(wt,()=>c.if(wt,()=>Br(kt)))}function lr(wt,kt){c.forRange("i",0,se,Fi=>{l.subschema({keyword:"contains",dataProp:Fi,dataPropType:Sce.Type.Num,compositeRule:!0},wt),kt()})}function Br(wt){c.code((0,BT._)`${wt}++`),p===void 0?c.if((0,BT._)`${wt} >= ${g}`,()=>c.assign(ze,!0).break()):(c.if((0,BT._)`${wt} > ${p}`,()=>c.assign(ze,!1).break()),g===1?c.assign(ze,!0):c.if((0,BT._)`${wt} >= ${g}`,()=>c.assign(ze,!0)))}}};CIe.default=K0r});var Eyt=xt(MC=>{"use strict";Object.defineProperty(MC,"__esModule",{value:!0});MC.validateSchemaDeps=MC.validatePropertyDeps=MC.error=void 0;var AIe=Yl(),X0r=Ju(),SW=FT();MC.error={message:({params:{property:l,depsCount:c,deps:f}})=>{let y=c===1?"property":"properties";return(0,AIe.str)`must have ${y} ${f} when property ${l} is present`},params:({params:{property:l,depsCount:c,deps:f,missingProperty:y}})=>(0,AIe._)`{property: ${l},
    missingProperty: ${y},
    depsCount: ${c},
    deps: ${f}}`};var Q0r={keyword:"dependencies",type:"object",schemaType:"object",error:MC.error,code(l){let[c,f]=Z0r(l);byt(l,c),Tyt(l,f)}};function Z0r({schema:l}){let c={},f={};for(let y in l){if(y==="__proto__")continue;let b=Array.isArray(l[y])?c:f;b[y]=l[y]}return[c,f]}function byt(l,c=l.schema){let{gen:f,data:y,it:b}=l;if(Object.keys(c).length===0)return;let A=f.let("missing");for(let g in c){let p=c[g];if(p.length===0)continue;let k=(0,SW.propertyInData)(f,y,g,b.opts.ownProperties);l.setParams({property:g,depsCount:p.length,deps:p.join(", ")}),b.allErrors?f.if(k,()=>{for(let j of p)(0,SW.checkReportMissingProp)(l,j)}):(f.if((0,AIe._)`${k} && (${(0,SW.checkMissingProp)(l,p,A)})`),(0,SW.reportMissingProp)(l,A),f.else())}}MC.validatePropertyDeps=byt;function Tyt(l,c=l.schema){let{gen:f,data:y,keyword:b,it:A}=l,g=f.name("valid");for(let p in c)(0,X0r.alwaysValidSchema)(A,c[p])||(f.if((0,SW.propertyInData)(f,y,p,A.opts.ownProperties),()=>{let k=l.subschema({keyword:b,schemaProp:p},g);l.mergeValidEvaluated(k,g)},()=>f.var(g,!0)),l.ok(g))}MC.validateSchemaDeps=Tyt;MC.default=Q0r});var Cyt=xt(kIe=>{"use strict";Object.defineProperty(kIe,"__esModule",{value:!0});var xyt=Yl(),evr=Ju(),tvr={message:"property name must be valid",params:({params:l})=>(0,xyt._)`{propertyName: ${l.propertyName}}`},rvr={keyword:"propertyNames",type:"object",schemaType:["object","boolean"],error:tvr,code(l){let{gen:c,schema:f,data:y,it:b}=l;if((0,evr.alwaysValidSchema)(b,f))return;let A=c.name("valid");c.forIn("key",y,g=>{l.setParams({propertyName:g}),l.subschema({keyword:"propertyNames",data:g,dataTypes:["string"],propertyName:g,compositeRule:!0},A),c.if((0,xyt.not)(A),()=>{l.error(!0),b.allErrors||c.break()})}),l.ok(A)}};kIe.default=rvr});var NIe=xt(PIe=>{"use strict";Object.defineProperty(PIe,"__esModule",{value:!0});var bce=FT(),Dx=Yl(),nvr=vP(),Tce=Ju(),ivr={message:"must NOT have additional properties",params:({params:l})=>(0,Dx._)`{additionalProperty: ${l.additionalProperty}}`},svr={keyword:"additionalProperties",type:["object"],schemaType:["boolean","object"],allowUndefined:!0,trackErrors:!0,error:ivr,code(l){let{gen:c,schema:f,parentSchema:y,data:b,errsCount:A,it:g}=l;if(!A)throw new Error("ajv implementation error");let{allErrors:p,opts:k}=g;if(g.props=!0,k.removeAdditional!=="all"&&(0,Tce.alwaysValidSchema)(g,f))return;let j=(0,bce.allSchemaProperties)(y.properties),se=(0,bce.allSchemaProperties)(y.patternProperties);ze(),l.ok((0,Dx._)`${A} === ${nvr.default.errors}`);function ze(){c.forIn("key",b,kt=>{!j.length&&!se.length?Br(kt):c.if(ve(kt),()=>Br(kt))})}function ve(kt){let Fi;if(j.length>8){let yi=(0,Tce.schemaRefOrVal)(g,y.properties,"properties");Fi=(0,bce.isOwnProperty)(c,yi,kt)}else j.length?Fi=(0,Dx.or)(...j.map(yi=>(0,Dx._)`${kt} === ${yi}`)):Fi=Dx.nil;return se.length&&(Fi=(0,Dx.or)(Fi,...se.map(yi=>(0,Dx._)`${(0,bce.usePattern)(l,yi)}.test(${kt})`))),(0,Dx.not)(Fi)}function lr(kt){c.code((0,Dx._)`delete ${b}[${kt}]`)}function Br(kt){if(k.removeAdditional==="all"||k.removeAdditional&&f===!1){lr(kt);return}if(f===!1){l.setParams({additionalProperty:kt}),l.error(),p||c.break();return}if(typeof f=="object"&&!(0,Tce.alwaysValidSchema)(g,f)){let Fi=c.name("valid");k.removeAdditional==="failing"?(wt(kt,Fi,!1),c.if((0,Dx.not)(Fi),()=>{l.reset(),lr(kt)})):(wt(kt,Fi),p||c.if((0,Dx.not)(Fi),()=>c.break()))}}function wt(kt,Fi,yi){let qo={keyword:"additionalProperties",dataProp:kt,dataPropType:Tce.Type.Str};yi===!1&&Object.assign(qo,{compositeRule:!0,createErrors:!1,allErrors:!1}),l.subschema(qo,Fi)}}};PIe.default=svr});var Pyt=xt(wIe=>{"use strict";Object.defineProperty(wIe,"__esModule",{value:!0});var avr=aW(),Ayt=FT(),DIe=Ju(),kyt=NIe(),ovr={keyword:"properties",type:"object",schemaType:"object",code(l){let{gen:c,schema:f,parentSchema:y,data:b,it:A}=l;A.opts.removeAdditional==="all"&&y.additionalProperties===void 0&&kyt.default.code(new avr.KeywordCxt(A,kyt.default,"additionalProperties"));let g=(0,Ayt.allSchemaProperties)(f);for(let ze of g)A.definedProperties.add(ze);A.opts.unevaluated&&g.length&&A.props!==!0&&(A.props=DIe.mergeEvaluated.props(c,(0,DIe.toHash)(g),A.props));let p=g.filter(ze=>!(0,DIe.alwaysValidSchema)(A,f[ze]));if(p.length===0)return;let k=c.name("valid");for(let ze of p)j(ze)?se(ze):(c.if((0,Ayt.propertyInData)(c,b,ze,A.opts.ownProperties)),se(ze),A.allErrors||c.else().var(k,!0),c.endIf()),l.it.definedProperties.add(ze),l.ok(k);function j(ze){return A.opts.useDefaults&&!A.compositeRule&&f[ze].default!==void 0}function se(ze){l.subschema({keyword:"properties",schemaProp:ze,dataProp:ze},k)}}};wIe.default=ovr});var Iyt=xt(IIe=>{"use strict";Object.defineProperty(IIe,"__esModule",{value:!0});var Nyt=FT(),Ece=Yl(),Dyt=Ju(),wyt=Ju(),cvr={keyword:"patternProperties",type:"object",schemaType:"object",code(l){let{gen:c,schema:f,data:y,parentSchema:b,it:A}=l,{opts:g}=A,p=(0,Nyt.allSchemaProperties)(f),k=p.filter(wt=>(0,Dyt.alwaysValidSchema)(A,f[wt]));if(p.length===0||k.length===p.length&&(!A.opts.unevaluated||A.props===!0))return;let j=g.strictSchema&&!g.allowMatchingProperties&&b.properties,se=c.name("valid");A.props!==!0&&!(A.props instanceof Ece.Name)&&(A.props=(0,wyt.evaluatedPropsToName)(c,A.props));let{props:ze}=A;ve();function ve(){for(let wt of p)j&&lr(wt),A.allErrors?Br(wt):(c.var(se,!0),Br(wt),c.if(se))}function lr(wt){for(let kt in j)new RegExp(wt).test(kt)&&(0,Dyt.checkStrictMode)(A,`property ${kt} matches pattern ${wt} (use allowMatchingProperties)`)}function Br(wt){c.forIn("key",y,kt=>{c.if((0,Ece._)`${(0,Nyt.usePattern)(l,wt)}.test(${kt})`,()=>{let Fi=k.includes(wt);Fi||l.subschema({keyword:"patternProperties",schemaProp:wt,dataProp:kt,dataPropType:wyt.Type.Str},se),A.opts.unevaluated&&ze!==!0?c.assign((0,Ece._)`${ze}[${kt}]`,!0):!Fi&&!A.allErrors&&c.if((0,Ece.not)(se),()=>c.break())})})}}};IIe.default=cvr});var Oyt=xt(OIe=>{"use strict";Object.defineProperty(OIe,"__esModule",{value:!0});var lvr=Ju(),uvr={keyword:"not",schemaType:["object","boolean"],trackErrors:!0,code(l){let{gen:c,schema:f,it:y}=l;if((0,lvr.alwaysValidSchema)(y,f)){l.fail();return}let b=c.name("valid");l.subschema({keyword:"not",compositeRule:!0,createErrors:!1,allErrors:!1},b),l.failResult(b,()=>l.reset(),()=>l.error())},error:{message:"must NOT be valid"}};OIe.default=uvr});var Ryt=xt(RIe=>{"use strict";Object.defineProperty(RIe,"__esModule",{value:!0});var _vr=FT(),fvr={keyword:"anyOf",schemaType:"array",trackErrors:!0,code:_vr.validateUnion,error:{message:"must match a schema in anyOf"}};RIe.default=fvr});var Myt=xt(MIe=>{"use strict";Object.defineProperty(MIe,"__esModule",{value:!0});var xce=Yl(),pvr=Ju(),dvr={message:"must match exactly one schema in oneOf",params:({params:l})=>(0,xce._)`{passingSchemas: ${l.passing}}`},mvr={keyword:"oneOf",schemaType:"array",trackErrors:!0,error:dvr,code(l){let{gen:c,schema:f,parentSchema:y,it:b}=l;if(!Array.isArray(f))throw new Error("ajv implementation error");if(b.opts.discriminator&&y.discriminator)return;let A=f,g=c.let("valid",!1),p=c.let("passing",null),k=c.name("_valid");l.setParams({passing:p}),c.block(j),l.result(g,()=>l.reset(),()=>l.error(!0));function j(){A.forEach((se,ze)=>{let ve;(0,pvr.alwaysValidSchema)(b,se)?c.var(k,!0):ve=l.subschema({keyword:"oneOf",schemaProp:ze,compositeRule:!0},k),ze>0&&c.if((0,xce._)`${k} && ${g}`).assign(g,!1).assign(p,(0,xce._)`[${p}, ${ze}]`).else(),c.if(k,()=>{c.assign(g,!0),c.assign(p,ze),ve&&l.mergeEvaluated(ve,xce.Name)})})}}};MIe.default=mvr});var Lyt=xt(LIe=>{"use strict";Object.defineProperty(LIe,"__esModule",{value:!0});var gvr=Ju(),hvr={keyword:"allOf",schemaType:"array",code(l){let{gen:c,schema:f,it:y}=l;if(!Array.isArray(f))throw new Error("ajv implementation error");let b=c.name("valid");f.forEach((A,g)=>{if((0,gvr.alwaysValidSchema)(y,A))return;let p=l.subschema({keyword:"allOf",schemaProp:g},b);l.ok(b),l.mergeEvaluated(p)})}};LIe.default=hvr});var Byt=xt(FIe=>{"use strict";Object.defineProperty(FIe,"__esModule",{value:!0});var Cce=Yl(),jyt=Ju(),yvr={message:({params:l})=>(0,Cce.str)`must match "${l.ifClause}" schema`,params:({params:l})=>(0,Cce._)`{failingKeyword: ${l.ifClause}}`},vvr={keyword:"if",schemaType:["object","boolean"],trackErrors:!0,error:yvr,code(l){let{gen:c,parentSchema:f,it:y}=l;f.then===void 0&&f.else===void 0&&(0,jyt.checkStrictMode)(y,'"if" without "then" and "else" is ignored');let b=Fyt(y,"then"),A=Fyt(y,"else");if(!b&&!A)return;let g=c.let("valid",!0),p=c.name("_valid");if(k(),l.reset(),b&&A){let se=c.let("ifClause");l.setParams({ifClause:se}),c.if(p,j("then",se),j("else",se))}else b?c.if(p,j("then")):c.if((0,Cce.not)(p),j("else"));l.pass(g,()=>l.error(!0));function k(){let se=l.subschema({keyword:"if",compositeRule:!0,createErrors:!1,allErrors:!1},p);l.mergeEvaluated(se)}function j(se,ze){return()=>{let ve=l.subschema({keyword:se},p);c.assign(g,p),l.mergeValidEvaluated(ve,g),ze?c.assign(ze,(0,Cce._)`${se}`):l.setParams({ifClause:se})}}}};function Fyt(l,c){let f=l.schema[c];return f!==void 0&&!(0,jyt.alwaysValidSchema)(l,f)}FIe.default=vvr});var Uyt=xt(jIe=>{"use strict";Object.defineProperty(jIe,"__esModule",{value:!0});var Svr=Ju(),bvr={keyword:["then","else"],schemaType:["object","boolean"],code({keyword:l,parentSchema:c,it:f}){c.if===void 0&&(0,Svr.checkStrictMode)(f,`"${l}" without "if" is ignored`)}};jIe.default=bvr});var Vyt=xt(BIe=>{"use strict";Object.defineProperty(BIe,"__esModule",{value:!0});var Tvr=bIe(),Evr=hyt(),xvr=TIe(),Cvr=vyt(),Avr=Syt(),kvr=Eyt(),Pvr=Cyt(),Nvr=NIe(),Dvr=Pyt(),wvr=Iyt(),Ivr=Oyt(),Ovr=Ryt(),Rvr=Myt(),Mvr=Lyt(),Lvr=Byt(),Fvr=Uyt();function jvr(l=!1){let c=[Ivr.default,Ovr.default,Rvr.default,Mvr.default,Lvr.default,Fvr.default,Pvr.default,Nvr.default,kvr.default,Dvr.default,wvr.default];return l?c.push(Evr.default,Cvr.default):c.push(Tvr.default,xvr.default),c.push(Avr.default),c}BIe.default=jvr});var Jyt=xt(UIe=>{"use strict";Object.defineProperty(UIe,"__esModule",{value:!0});var Em=Yl(),Bvr={message:({schemaCode:l})=>(0,Em.str)`must match format "${l}"`,params:({schemaCode:l})=>(0,Em._)`{format: ${l}}`},Uvr={keyword:"format",type:["number","string"],schemaType:"string",$data:!0,error:Bvr,code(l,c){let{gen:f,data:y,$data:b,schema:A,schemaCode:g,it:p}=l,{opts:k,errSchemaPath:j,schemaEnv:se,self:ze}=p;if(!k.validateFormats)return;b?ve():lr();function ve(){let Br=f.scopeValue("formats",{ref:ze.formats,code:k.code.formats}),wt=f.const("fDef",(0,Em._)`${Br}[${g}]`),kt=f.let("fType"),Fi=f.let("format");f.if((0,Em._)`typeof ${wt} == "object" && !(${wt} instanceof RegExp)`,()=>f.assign(kt,(0,Em._)`${wt}.type || "string"`).assign(Fi,(0,Em._)`${wt}.validate`),()=>f.assign(kt,(0,Em._)`"string"`).assign(Fi,wt)),l.fail$data((0,Em.or)(yi(),qo()));function yi(){return k.strictSchema===!1?Em.nil:(0,Em._)`${g} && !${Fi}`}function qo(){let Xl=se.$async?(0,Em._)`(${wt}.async ? await ${Fi}(${y}) : ${Fi}(${y}))`:(0,Em._)`${Fi}(${y})`,ho=(0,Em._)`(typeof ${Fi} == "function" ? ${Xl} : ${Fi}.test(${y}))`;return(0,Em._)`${Fi} && ${Fi} !== true && ${kt} === ${c} && !${ho}`}}function lr(){let Br=ze.formats[A];if(!Br){yi();return}if(Br===!0)return;let[wt,kt,Fi]=qo(Br);wt===c&&l.pass(Xl());function yi(){if(k.strictSchema===!1){ze.logger.warn(ho());return}throw new Error(ho());function ho(){return`unknown format "${A}" ignored in schema at path "${j}"`}}function qo(ho){let bf=ho instanceof RegExp?(0,Em.regexpCode)(ho):k.code.formats?(0,Em._)`${k.code.formats}${(0,Em.getProperty)(A)}`:void 0,wi=f.scopeValue("formats",{key:A,ref:ho,code:bf});return typeof ho=="object"&&!(ho instanceof RegExp)?[ho.type||"string",ho.validate,(0,Em._)`${wi}.validate`]:["string",ho,wi]}function Xl(){if(typeof Br=="object"&&!(Br instanceof RegExp)&&Br.async){if(!se.$async)throw new Error("async format in sync schema");return(0,Em._)`await ${Fi}(${y})`}return typeof kt=="function"?(0,Em._)`${Fi}(${y})`:(0,Em._)`${Fi}.test(${y})`}}}};UIe.default=Uvr});var qyt=xt(VIe=>{"use strict";Object.defineProperty(VIe,"__esModule",{value:!0});var Vvr=Jyt(),Jvr=[Vvr.default];VIe.default=Jvr});var zyt=xt(VF=>{"use strict";Object.defineProperty(VF,"__esModule",{value:!0});VF.contentVocabulary=VF.metadataVocabulary=void 0;VF.metadataVocabulary=["title","description","default","deprecated","readOnly","writeOnly","examples"];VF.contentVocabulary=["contentMediaType","contentEncoding","contentSchema"]});var $yt=xt(JIe=>{"use strict";Object.defineProperty(JIe,"__esModule",{value:!0});var qvr=Zht(),zvr=pyt(),Wvr=Vyt(),$vr=qyt(),Wyt=zyt(),Hvr=[qvr.default,zvr.default,(0,Wvr.default)(),$vr.default,Wyt.metadataVocabulary,Wyt.contentVocabulary];JIe.default=Hvr});var Gyt=xt(Ace=>{"use strict";Object.defineProperty(Ace,"__esModule",{value:!0});Ace.DiscrError=void 0;var Hyt;(function(l){l.Tag="tag",l.Mapping="mapping"})(Hyt||(Ace.DiscrError=Hyt={}))});var Kyt=xt(zIe=>{"use strict";Object.defineProperty(zIe,"__esModule",{value:!0});var JF=Yl(),qIe=Gyt(),Yyt=cce(),Gvr=oW(),Yvr=Ju(),Kvr={message:({params:{discrError:l,tagName:c}})=>l===qIe.DiscrError.Tag?`tag "${c}" must be string`:`value of tag "${c}" must be in oneOf`,params:({params:{discrError:l,tag:c,tagName:f}})=>(0,JF._)`{error: ${l}, tag: ${f}, tagValue: ${c}}`},Xvr={keyword:"discriminator",type:"object",schemaType:"object",error:Kvr,code(l){let{gen:c,data:f,schema:y,parentSchema:b,it:A}=l,{oneOf:g}=b;if(!A.opts.discriminator)throw new Error("discriminator: requires discriminator option");let p=y.propertyName;if(typeof p!="string")throw new Error("discriminator: requires propertyName");if(y.mapping)throw new Error("discriminator: mapping is not supported");if(!g)throw new Error("discriminator: requires oneOf keyword");let k=c.let("valid",!1),j=c.const("tag",(0,JF._)`${f}${(0,JF.getProperty)(p)}`);c.if((0,JF._)`typeof ${j} == "string"`,()=>se(),()=>l.error(!1,{discrError:qIe.DiscrError.Tag,tag:j,tagName:p})),l.ok(k);function se(){let lr=ve();c.if(!1);for(let Br in lr)c.elseIf((0,JF._)`${j} === ${Br}`),c.assign(k,ze(lr[Br]));c.else(),l.error(!1,{discrError:qIe.DiscrError.Mapping,tag:j,tagName:p}),c.endIf()}function ze(lr){let Br=c.name("valid"),wt=l.subschema({keyword:"oneOf",schemaProp:lr},Br);return l.mergeEvaluated(wt,JF.Name),Br}function ve(){var lr;let Br={},wt=Fi(b),kt=!0;for(let Xl=0;Xl<g.length;Xl++){let ho=g[Xl];if(ho?.$ref&&!(0,Yvr.schemaHasRulesButRef)(ho,A.self.RULES)){let wi=ho.$ref;if(ho=Yyt.resolveRef.call(A.self,A.schemaEnv.root,A.baseId,wi),ho instanceof Yyt.SchemaEnv&&(ho=ho.schema),ho===void 0)throw new Gvr.default(A.opts.uriResolver,A.baseId,wi)}let bf=(lr=ho?.properties)===null||lr===void 0?void 0:lr[p];if(typeof bf!="object")throw new Error(`discriminator: oneOf subschemas (or referenced schemas) must have "properties/${p}"`);kt=kt&&(wt||Fi(ho)),yi(bf,Xl)}if(!kt)throw new Error(`discriminator: "${p}" must be required`);return Br;function Fi({required:Xl}){return Array.isArray(Xl)&&Xl.includes(p)}function yi(Xl,ho){if(Xl.const)qo(Xl.const,ho);else if(Xl.enum)for(let bf of Xl.enum)qo(bf,ho);else throw new Error(`discriminator: "properties/${p}" must have "const" or "enum"`)}function qo(Xl,ho){if(typeof Xl!="string"||Xl in Br)throw new Error(`discriminator: "${p}" values must be unique strings`);Br[Xl]=ho}}}};zIe.default=Xvr});var Xyt=xt((Q3r,Qvr)=>{Qvr.exports={$schema:"http://json-schema.org/draft-07/schema#",$id:"http://json-schema.org/draft-07/schema#",title:"Core schema meta-schema",definitions:{schemaArray:{type:"array",minItems:1,items:{$ref:"#"}},nonNegativeInteger:{type:"integer",minimum:0},nonNegativeIntegerDefault0:{allOf:[{$ref:"#/definitions/nonNegativeInteger"},{default:0}]},simpleTypes:{enum:["array","boolean","integer","null","number","object","string"]},stringArray:{type:"array",items:{type:"string"},uniqueItems:!0,default:[]}},type:["object","boolean"],properties:{$id:{type:"string",format:"uri-reference"},$schema:{type:"string",format:"uri"},$ref:{type:"string",format:"uri-reference"},$comment:{type:"string"},title:{type:"string"},description:{type:"string"},default:!0,readOnly:{type:"boolean",default:!1},examples:{type:"array",items:!0},multipleOf:{type:"number",exclusiveMinimum:0},maximum:{type:"number"},exclusiveMaximum:{type:"number"},minimum:{type:"number"},exclusiveMinimum:{type:"number"},maxLength:{$ref:"#/definitions/nonNegativeInteger"},minLength:{$ref:"#/definitions/nonNegativeIntegerDefault0"},pattern:{type:"string",format:"regex"},additionalItems:{$ref:"#"},items:{anyOf:[{$ref:"#"},{$ref:"#/definitions/schemaArray"}],default:!0},maxItems:{$ref:"#/definitions/nonNegativeInteger"},minItems:{$ref:"#/definitions/nonNegativeIntegerDefault0"},uniqueItems:{type:"boolean",default:!1},contains:{$ref:"#"},maxProperties:{$ref:"#/definitions/nonNegativeInteger"},minProperties:{$ref:"#/definitions/nonNegativeIntegerDefault0"},required:{$ref:"#/definitions/stringArray"},additionalProperties:{$ref:"#"},definitions:{type:"object",additionalProperties:{$ref:"#"},default:{}},properties:{type:"object",additionalProperties:{$ref:"#"},default:{}},patternProperties:{type:"object",additionalProperties:{$ref:"#"},propertyNames:{format:"regex"},default:{}},dependencies:{type:"object",additionalProperties:{anyOf:[{$ref:"#"},{$ref:"#/definitions/stringArray"}]}},propertyNames:{$ref:"#"},const:!0,enum:{type:"array",items:!0,minItems:1,uniqueItems:!0},type:{anyOf:[{$ref:"#/definitions/simpleTypes"},{type:"array",items:{$ref:"#/definitions/simpleTypes"},minItems:1,uniqueItems:!0}]},format:{type:"string"},contentMediaType:{type:"string"},contentEncoding:{type:"string"},if:{$ref:"#"},then:{$ref:"#"},else:{$ref:"#"},allOf:{$ref:"#/definitions/schemaArray"},anyOf:{$ref:"#/definitions/schemaArray"},oneOf:{$ref:"#/definitions/schemaArray"},not:{$ref:"#"}},default:!0}});var Zyt=xt((kp,WIe)=>{"use strict";Object.defineProperty(kp,"__esModule",{value:!0});kp.MissingRefError=kp.ValidationError=kp.CodeGen=kp.Name=kp.nil=kp.stringify=kp.str=kp._=kp.KeywordCxt=kp.Ajv=void 0;var Zvr=Hht(),e1r=$yt(),t1r=Kyt(),Qyt=Xyt(),r1r=["/properties"],kce="http://json-schema.org/draft-07/schema",qF=class extends Zvr.default{_addVocabularies(){super._addVocabularies(),e1r.default.forEach(c=>this.addVocabulary(c)),this.opts.discriminator&&this.addKeyword(t1r.default)}_addDefaultMetaSchema(){if(super._addDefaultMetaSchema(),!this.opts.meta)return;let c=this.opts.$data?this.$dataMetaSchema(Qyt,r1r):Qyt;this.addMetaSchema(c,kce,!1),this.refs["http://json-schema.org/schema"]=kce}defaultMeta(){return this.opts.defaultMeta=super.defaultMeta()||(this.getSchema(kce)?kce:void 0)}};kp.Ajv=qF;WIe.exports=kp=qF;WIe.exports.Ajv=qF;Object.defineProperty(kp,"__esModule",{value:!0});kp.default=qF;var n1r=aW();Object.defineProperty(kp,"KeywordCxt",{enumerable:!0,get:function(){return n1r.KeywordCxt}});var zF=Yl();Object.defineProperty(kp,"_",{enumerable:!0,get:function(){return zF._}});Object.defineProperty(kp,"str",{enumerable:!0,get:function(){return zF.str}});Object.defineProperty(kp,"stringify",{enumerable:!0,get:function(){return zF.stringify}});Object.defineProperty(kp,"nil",{enumerable:!0,get:function(){return zF.nil}});Object.defineProperty(kp,"Name",{enumerable:!0,get:function(){return zF.Name}});Object.defineProperty(kp,"CodeGen",{enumerable:!0,get:function(){return zF.CodeGen}});var i1r=ace();Object.defineProperty(kp,"ValidationError",{enumerable:!0,get:function(){return i1r.default}});var s1r=oW();Object.defineProperty(kp,"MissingRefError",{enumerable:!0,get:function(){return s1r.default}})});var t0t=xt((iRr,c1r)=>{c1r.exports=[{name:"Agola CI",constant:"AGOLA",env:"AGOLA_GIT_REF",pr:"AGOLA_PULL_REQUEST_ID"},{name:"Appcircle",constant:"APPCIRCLE",env:"AC_APPCIRCLE"},{name:"AppVeyor",constant:"APPVEYOR",env:"APPVEYOR",pr:"APPVEYOR_PULL_REQUEST_NUMBER"},{name:"AWS CodeBuild",constant:"CODEBUILD",env:"CODEBUILD_BUILD_ARN"},{name:"Azure Pipelines",constant:"AZURE_PIPELINES",env:"TF_BUILD",pr:{BUILD_REASON:"PullRequest"}},{name:"Bamboo",constant:"BAMBOO",env:"bamboo_planKey"},{name:"Bitbucket Pipelines",constant:"BITBUCKET",env:"BITBUCKET_COMMIT",pr:"BITBUCKET_PR_ID"},{name:"Bitrise",constant:"BITRISE",env:"BITRISE_IO",pr:"BITRISE_PULL_REQUEST"},{name:"Buddy",constant:"BUDDY",env:"BUDDY_WORKSPACE_ID",pr:"BUDDY_EXECUTION_PULL_REQUEST_ID"},{name:"Buildkite",constant:"BUILDKITE",env:"BUILDKITE",pr:{env:"BUILDKITE_PULL_REQUEST",ne:"false"}},{name:"CircleCI",constant:"CIRCLE",env:"CIRCLECI",pr:"CIRCLE_PULL_REQUEST"},{name:"Cirrus CI",constant:"CIRRUS",env:"CIRRUS_CI",pr:"CIRRUS_PR"},{name:"Codefresh",constant:"CODEFRESH",env:"CF_BUILD_ID",pr:{any:["CF_PULL_REQUEST_NUMBER","CF_PULL_REQUEST_ID"]}},{name:"Codemagic",constant:"CODEMAGIC",env:"CM_BUILD_ID",pr:"CM_PULL_REQUEST"},{name:"Codeship",constant:"CODESHIP",env:{CI_NAME:"codeship"}},{name:"Drone",constant:"DRONE",env:"DRONE",pr:{DRONE_BUILD_EVENT:"pull_request"}},{name:"dsari",constant:"DSARI",env:"DSARI"},{name:"Earthly",constant:"EARTHLY",env:"EARTHLY_CI"},{name:"Expo Application Services",constant:"EAS",env:"EAS_BUILD"},{name:"Gerrit",constant:"GERRIT",env:"GERRIT_PROJECT"},{name:"Gitea Actions",constant:"GITEA_ACTIONS",env:"GITEA_ACTIONS"},{name:"GitHub Actions",constant:"GITHUB_ACTIONS",env:"GITHUB_ACTIONS",pr:{GITHUB_EVENT_NAME:"pull_request"}},{name:"GitLab CI",constant:"GITLAB",env:"GITLAB_CI",pr:"CI_MERGE_REQUEST_ID"},{name:"GoCD",constant:"GOCD",env:"GO_PIPELINE_LABEL"},{name:"Google Cloud Build",constant:"GOOGLE_CLOUD_BUILD",env:"BUILDER_OUTPUT"},{name:"Harness CI",constant:"HARNESS",env:"HARNESS_BUILD_ID"},{name:"Heroku",constant:"HEROKU",env:{env:"NODE",includes:"/app/.heroku/node/bin/node"}},{name:"Hudson",constant:"HUDSON",env:"HUDSON_URL"},{name:"Jenkins",constant:"JENKINS",env:["JENKINS_URL","BUILD_ID"],pr:{any:["ghprbPullId","CHANGE_ID"]}},{name:"LayerCI",constant:"LAYERCI",env:"LAYERCI",pr:"LAYERCI_PULL_REQUEST"},{name:"Magnum CI",constant:"MAGNUM",env:"MAGNUM"},{name:"Netlify CI",constant:"NETLIFY",env:"NETLIFY",pr:{env:"PULL_REQUEST",ne:"false"}},{name:"Nevercode",constant:"NEVERCODE",env:"NEVERCODE",pr:{env:"NEVERCODE_PULL_REQUEST",ne:"false"}},{name:"Prow",constant:"PROW",env:"PROW_JOB_ID"},{name:"ReleaseHub",constant:"RELEASEHUB",env:"RELEASE_BUILD_ID"},{name:"Render",constant:"RENDER",env:"RENDER",pr:{IS_PULL_REQUEST:"true"}},{name:"Sail CI",constant:"SAIL",env:"SAILCI",pr:"SAIL_PULL_REQUEST_NUMBER"},{name:"Screwdriver",constant:"SCREWDRIVER",env:"SCREWDRIVER",pr:{env:"SD_PULL_REQUEST",ne:"false"}},{name:"Semaphore",constant:"SEMAPHORE",env:"SEMAPHORE",pr:"PULL_REQUEST_NUMBER"},{name:"Sourcehut",constant:"SOURCEHUT",env:{CI_NAME:"sourcehut"}},{name:"Strider CD",constant:"STRIDER",env:"STRIDER"},{name:"TaskCluster",constant:"TASKCLUSTER",env:["TASK_ID","RUN_ID"]},{name:"TeamCity",constant:"TEAMCITY",env:"TEAMCITY_VERSION"},{name:"Travis CI",constant:"TRAVIS",env:"TRAVIS",pr:{env:"TRAVIS_PULL_REQUEST",ne:"false"}},{name:"Vela",constant:"VELA",env:"VELA",pr:{VELA_PULL_REQUEST:"1"}},{name:"Vercel",constant:"VERCEL",env:{any:["NOW_BUILDER","VERCEL"]},pr:"VERCEL_GIT_PULL_REQUEST_ID"},{name:"Visual Studio App Center",constant:"APPCENTER",env:"APPCENTER_BUILD_ID"},{name:"Woodpecker",constant:"WOODPECKER",env:{CI:"woodpecker"},pr:{CI_BUILD_EVENT:"pull_request"}},{name:"Xcode Cloud",constant:"XCODE_CLOUD",env:"CI_XCODE_PROJECT",pr:"CI_PULL_REQUEST_NUMBER"},{name:"Xcode Server",constant:"XCODE_SERVER",env:"XCS"}]});var i0t=xt(HS=>{"use strict";var n0t=t0t(),Ag=process.env;Object.defineProperty(HS,"_vendors",{value:n0t.map(function(l){return l.constant})});HS.name=null;HS.isPR=null;n0t.forEach(function(l){let f=(Array.isArray(l.env)?l.env:[l.env]).every(function(y){return r0t(y)});if(HS[l.constant]=f,!!f)switch(HS.name=l.name,typeof l.pr){case"string":HS.isPR=!!Ag[l.pr];break;case"object":"env"in l.pr?HS.isPR=l.pr.env in Ag&&Ag[l.pr.env]!==l.pr.ne:"any"in l.pr?HS.isPR=l.pr.any.some(function(y){return!!Ag[y]}):HS.isPR=r0t(l.pr);break;default:HS.isPR=null}});HS.isCI=!!(Ag.CI!=="false"&&(Ag.BUILD_ID||Ag.BUILD_NUMBER||Ag.CI||Ag.CI_APP_ID||Ag.CI_BUILD_ID||Ag.CI_BUILD_NUMBER||Ag.CI_NAME||Ag.CONTINUOUS_INTEGRATION||Ag.RUN_ID||HS.name));function r0t(l){return typeof l=="string"?!!Ag[l]:"env"in l?Ag[l.env]&&Ag[l.env].includes(l.includes):"any"in l?l.any.some(function(c){return!!Ag[c]}):Object.keys(l).every(function(c){return Ag[c]===l[c]})}});import*as _vt from"node:os";import*as Mce from"node:path";var PAe={};fAe(PAe,{Argument:()=>szt,Command:()=>izt,CommanderError:()=>tzt,Help:()=>ozt,InvalidArgumentError:()=>rzt,InvalidOptionArgumentError:()=>nzt,Option:()=>azt,createArgument:()=>Zqt,createCommand:()=>Qqt,createOption:()=>ezt,program:()=>Xqt});var CXe=vf(xXe(),1),{program:Xqt,createCommand:Qqt,createArgument:Zqt,createOption:ezt,CommanderError:tzt,InvalidArgumentError:rzt,InvalidOptionArgumentError:nzt,Command:izt,Argument:szt,Option:azt,Help:ozt}=CXe.default;import{createHash as Lbr}from"node:crypto";import*as wx from"node:net";var Ep=Object.freeze({PROJECT_ID:"project.id",DATE:"date",ENVIRONMENT_NAME:"environment.name",TELEMETRY_EMITTER_NAME:"telemetry.emitter.name",TELEMETRY_EMITTER_VERSION:"telemetry.emitter.version",SCAN_ID:"scan.id",ANALYZED_PATH:"analyzed.path",ANALYZED_HOST:"analyzed.host",ANALYZED_OWNER:"analyzed.owner",ANALYZED_OWNER_PATH:"analyzed.ownerPath",ANALYZED_REPOSITORY:"analyzed.repository",ANALYZED_COMMIT:"analyzed.commit",ANALYZED_REFS:"analyzed.refs"});var gx=Object.freeze({SCOPE_NAME:"js",JS_TOKEN_METRIC:"js.token",JS_FUNCTION_METRIC:"js.function",TOKEN_NAME:"js.token.name",TOKEN_ACCESS_PATH:"js.token.accessPath",TOKEN_MODULE_SPECIFIER:"js.token.module.specifier",FUNCTION_NAME:"js.function.name",FUNCTION_ACCESS_PATH:"js.function.accessPath",FUNCTION_ARGUMENT_VALUES:"js.function.arguments.values",FUNCTION_MODULE_SPECIFIER:"js.function.module.specifier"});var ow=Object.freeze({SCOPE_NAME:"jsx",JSX_ELEMENT_METRIC:"jsx.element",NAME:"jsx.element.name",MODULE_SPECIFIER:"jsx.element.module.specifier",ATTRIBUTE_NAMES:"jsx.element.attributes.names",ATTRIBUTE_VALUES:"jsx.element.attributes.values"});var czt=Object.freeze({PROJECT_ID:"project.id",DATE:"date",LOGS:"logs",ENVIRONMENT_NAME:"environment.name",ANALYZED_PATH:"analyzed.path",ANALYZED_HOST:"analyzed.host",ANALYZED_OWNER:"analyzed.owner",ANALYZED_OWNER_PATH:"analyzed.ownerPath",ANALYZED_REPOSITORY:"analyzed.repository",ANALYZED_COMMIT:"analyzed.commit",ANALYZED_REFS:"analyzed.refs",SCAN_ID:"scan.id",RESULTS_IS_COMPLETED:"results.isCompleted",RESULTS_TOTAL_DURATION:"results.totalDuration",RESULTS_TOTAL_PACKAGES:"results.totalPackages"});var xa=Object.freeze({SCOPE_NAME:"npm",NPM_DEPENDENCY_METRIC:"npm.dependency",RAW:"npm.dependency.raw",OWNER:"npm.dependency.owner",NAME:"npm.dependency.name",IS_INSTRUMENTED:"npm.dependency.isInstrumented",INSTRUMENTED_RAW:"npm.dependency.instrumented.raw",INSTRUMENTED_OWNER:"npm.dependency.instrumented.owner",INSTRUMENTED_NAME:"npm.dependency.instrumented.name",INSTRUMENTED_VERSION_RAW:"npm.dependency.instrumented.version.raw",INSTRUMENTED_VERSION_MAJOR:"npm.dependency.instrumented.version.major",INSTRUMENTED_VERSION_MINOR:"npm.dependency.instrumented.version.minor",INSTRUMENTED_VERSION_PATCH:"npm.dependency.instrumented.version.patch",INSTRUMENTED_VERSION_PRE_RELEASE:"npm.dependency.instrumented.version.preRelease",VERSION_RAW:"npm.dependency.version.raw",VERSION_MAJOR:"npm.dependency.version.major",VERSION_MINOR:"npm.dependency.version.minor",VERSION_PATCH:"npm.dependency.version.patch",VERSION_PRE_RELEASE:"npm.dependency.version.preRelease"});var uTr=[gx.SCOPE_NAME,ow.SCOPE_NAME,xa.SCOPE_NAME];var Lne={$ref:"#/definitions/ConfigSchema",$schema:"http://json-schema.org/draft-07/schema#",definitions:{ConfigSchema:{$id:"https://unpkg.com/@ibm/telemetry-config-schema/dist/config.schema.json",additionalProperties:!1,description:"Configuration outline for metrics collection using IBM telemetry.",properties:{collect:{additionalProperties:!1,description:"The keys under `collect` represent the various types of data that Telemetry is capable of collecting (i.e. `scopes`).",minProperties:1,properties:{js:{additionalProperties:!1,description:"Configuration for collecting telemetry data from JS files.",minProperties:1,properties:{functions:{anyOf:[{type:"null"},{additionalProperties:!1,properties:{allowedArgumentStringValues:{description:"Enable telemetry data collection for specific string function argument values. These are collected for all included functions. Boolean and numeric values are collected by default.",items:{type:"string"},minItems:1,type:"array"}},type:"object"}],description:"Enable telemetry data collection for JS functions. The set of included functions is determined by looking at import/require statements across analyzed source files."},tokens:{description:"Enable telemetry data collection for JS tokens. The set of included tokens is determined by looking at import/require statements across analyzed source files.",type:"null"}},type:"object"},jsx:{additionalProperties:!1,description:"Configuration for collecting telemetry data from JSX files.",minProperties:1,properties:{elements:{anyOf:[{type:"null"},{additionalProperties:!1,properties:{allowedAttributeNames:{description:"Enable telemetry data collection for specific JSX attributes. These are collected for all included JSX elements. Specifying an `attributeName` here will turn on data collection for boolean and numeric attribute values. String value data collection is handled separately via the `allowedAttributeStringValues` key.",items:{type:"string"},minItems:1,type:"array"},allowedAttributeStringValues:{description:"Enable telemetry data collection for specific string attribute values. These are collected for all defined attributes in the `allowedAttributeNames` key.",items:{type:"string"},minItems:1,type:"array"}},type:"object"}],description:"Enable telemetry data collection for JSX elements. The set of included elements is determined by looking at import/require statements across analyzed source files."}},type:"object"},npm:{additionalProperties:!1,description:"Configuration for collecting telemetry data from an npm environment.",minProperties:1,properties:{dependencies:{description:"Enable telemetry data collection for `dependencies`, `devDependencies`, and `peerDependencies` that are siblings of the instrumented package.",type:"null"}},type:"object"}},type:"object"},endpoint:{description:"URL of the telemetry data collection endpoint.",type:"string"},projectId:{description:"Unique identifier assigned on a per-project basis.",type:"string"},version:{const:1,description:"Current schema version.",type:"number"}},required:["version","projectId","endpoint","collect"],title:"Telemetry Config Schema",type:"object"}}};var ygt=vf(Lut(),1),vgt=vf(PNe(),1),Sgt=vf(YL(),1);import*as jut from"node:child_process";var bz=class extends Error{constructor(c){super(JSON.stringify(c,void 0,2))}};var bae=class extends Error{};function Fut(l){if(/[\\$;`]/.exec(l)!=null)throw new bae("Command contained forbidden characters: "+l)}var Ycr=5,Tz=new Set;async function ov(l,c,f={},y=!0){for(c.traceEnter("","runCommand",[l,f,y]),Fut(l);Tz.size>=Ycr;)await Promise.any(Tz);let b,A,g="",p="",k=!1,j={env:process.env,shell:!0,...f},se=new Promise((ve,lr)=>{b=ve,A=lr});Tz.add(se);let ze=jut.spawn(l,j);return ze.stdout?.on("data",ve=>{g+=ve.toString()}),ze.stderr?.on("data",ve=>{p+=ve.toString()}),ze.on("error",ve=>{if(k)return;let lr;Tz.delete(se),y?(lr=new bz({exitCode:"errno"in ve&&typeof ve.errno=="number"?ve.errno:-1,stderr:p.trim(),stdout:g.trim(),exception:ve,spawnOptions:j}),A(lr)):(lr={exitCode:"errno"in ve&&typeof ve.errno=="number"?ve.errno:-1,stderr:p,stdout:g},b(lr)),k=!0,c.traceExit("","runCommand",lr)}),ze.on("close",ve=>{if(k)return;Tz.delete(se);let lr;ve!==0&&y?(lr=new bz({exitCode:ve??999,stderr:p.trim(),stdout:g.trim(),spawnOptions:j}),A(lr)):(lr={exitCode:ve??999,stderr:p.trim(),stdout:g.trim()},b(lr)),k=!0,c.traceExit("","runCommand",lr)}),await se}var Tae=new Map;async function Eae(l,c){return Tae.has(l)?(c.debug("getRepositoryRoot cache hit for "+l),Tae.get(l)):(Tae.set(l,(await ov("git rev-parse --show-toplevel",c,{cwd:l},!0)).stdout),Tae.get(l))}import*as But from"node:util";function Ph(l){return typeof l=="string"?l:But.inspect(l,{compact:!0,breakLength:1/0,depth:10,showHidden:!1,maxArrayLength:1e4,maxStringLength:1e4})}var hkr=vf(Vut(),1);var xae=class extends Error{constructor(){super("Attempt to trace method without a defined Logger instance")}};import{appendFile as Kcr}from"node:fs/promises";var eDe=function(l,c,f,y,b){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof c=="function"?l!==c||!b:!c.has(l))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?b.call(l,f):b?b.value=f:c.set(l,f),f},Ez=function(l,c,f,y){if(f==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof c=="function"?l!==c||!y:!c.has(l))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?y:f==="a"?y.call(l):y?y.value:c.get(l)},Cae,iF,Aae,Xcr=250,Qcr=1,sF=class{constructor(c){Cae.set(this,void 0),iF.set(this,void 0),Aae.set(this,void 0),eDe(this,Cae,c,"f"),eDe(this,iF,[],"f"),eDe(this,Aae,setInterval(()=>{this.flush()},Xcr),"f"),console.log("Log file:",c)}async flush(){let c=Ez(this,iF,"f").join("");await Kcr(Ez(this,Cae,"f"),c),Ez(this,iF,"f").splice(0)}async close(){clearInterval(Ez(this,Aae,"f")),await this.flush()}debug(c,...f){this.log("debug",[c,...f])}error(c){let f;c instanceof Error?f=c.constructor.name+" "+c.stack:f=c,this.log("error",[f])}traceEnter(c,f,y){let b=y.map(Ph).join(", ");this.debug(`--> ${c}::${f}(${b})`)}traceExit(c,f,y){if(y instanceof Promise){let b=Qcr++;this.debug(`-?- ${c}::${f}(...): awaiting [Promise${b}]`),y.then(A=>{this.debug(`<-- ${c}::${f}(...): resolved [Promise${b}]: ${Ph(A)}`)},A=>{this.error(`-x- ${c}::${f}(...): ${Ph(A)}`),A instanceof Error&&this.error(A)})}else y instanceof Error?(this.error(`-x- ${c}::${f}(...): ${Ph(y)}`),this.error(y)):this.debug(`<-- ${c}::${f}(...): ${Ph(y)}`)}log(c,f){let y=new Date().toISOString();Ez(this,iF,"f").push(c+" "+process.pid+" "+y+" "+f.join(" ")+`
`)}};Cae=new WeakMap,iF=new WeakMap,Aae=new WeakMap;function Nl(l){return function(f,y,b){if(b.value===null||b.value===void 0||!(b.value instanceof Function))return;let A=f.constructor.name,g=b,p=b.value;b.value=function(...k){let j=this.logger;if(!(j instanceof sF))throw new xae;j.traceEnter(A,String(y),l?.argFormatter!==void 0?k.map(l.argFormatter):k);let se;try{se=p.apply(this,k)}catch(ze){throw j.traceExit(A,String(y),ze),ze}return j.traceExit(A,String(y),se),se},Object.defineProperty(b.value,"name",{value:p.name}),Reflect.getMetadataKeys(p).forEach(k=>{Reflect.defineMetadata(k,Reflect.getMetadata(k,p),g.value)})}}var tDe=vf(NPe(),1),qut=vf(YL(),1);hC();var Jut=vf(YL(),1),kae=class extends Jut.MetricReader{async collect(c){return await super.collect(c)}async onShutdown(){throw new Error("Method not implemented.")}async onForceFlush(){throw new Error("Method not implemented.")}};var aF=class l{static getInstance(c=!1){return(c||l.instance===void 0)&&(l.instance=new l),l.instance}constructor(){this.isInitialized=!1}initialize(){if(this.isInitialized)return;let c=tDe.Resource.default().merge(new tDe.Resource({[vke]:"IBM Telemetry",...this.attributes}));this.metricReader=new kae,this.meterProvider=new qut.MeterProvider({resource:c,readers:[this.metricReader]}),this.isInitialized=!0}setAttributes(c){this.attributes=c}getMetricReader(){return this.initialize(),this.metricReader}getMeterProvider(){return this.initialize(),this.meterProvider}};var Pae=class extends Error{constructor(c){super("Unknown scope: "+c)}};import*as zut from"node:path";import*as Wut from"node:url";import*as wae from"node:path";var Nae=class extends Error{constructor(c,f){super(`${c} is not a subpath of ${f}`)}};var Zcr=function(l,c,f,y){if(f==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof c=="function"?l!==c||!y:!c.has(l))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?y:f==="a"?y.call(l):y?y.value:c.get(l)},elr=function(l,c,f,y,b){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof c=="function"?l!==c||!b:!c.has(l))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?b.call(l,f):b?b.value=f:c.set(l,f),f},Dae,Wd=class{get logger(){return Zcr(this,Dae,"f")}constructor(c){Dae.set(this,void 0),elr(this,Dae,c,"f")}};Dae=new WeakMap;var tlr=function(l,c,f,y){var b=arguments.length,A=b<3?c:y===null?y=Object.getOwnPropertyDescriptor(c,f):y,g;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(l,c,f,y);else for(var p=l.length-1;p>=0;p--)(g=l[p])&&(A=(b<3?g(A):b>3?g(c,f,A):g(c,f))||A);return b>3&&A&&Object.defineProperty(c,f,A),A},rDe=function(l,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(l,c)},V4=class extends Wd{async find(c,f,y){if(wae.relative(f,c).startsWith(".."))throw new Nae(c,f);let b=[];for(let g=c;g!==f;g=wae.resolve(g,".."))b.push(g);b.push(f);let A=await Promise.all(b.map(y));return b.filter((g,p)=>A[p]===!0)}};tlr([Nl(),rDe("design:type",Function),rDe("design:paramtypes",[String,String,Function]),rDe("design:returntype",Promise)],V4.prototype,"find",null);var Iae=class extends Error{constructor(c){super(`No package data available for directory ${c}`)}};var Oae=new Map;async function EC(l,c,f){f.traceEnter("","getPackageData",[l]);let y=await new V4(f).find(l,c,()=>!0),b;for(let A of y){try{b=await rlr(A,f)}catch(g){f.debug(String(g))}if(b?.name!==void 0&&b?.version!==void 0)break}if(b===void 0)throw new Iae(l);return f.traceExit("","getPackageData",b),b}async function rlr(l,c){if(Oae.has(l))return c.debug("getImmediatePackageData cache hit for "+l),await Oae.get(l);let f=ov("npm pkg get name version",c,{cwd:l}),y=async()=>{let b=await f,[A]=/{[^{]*?}/.exec(b.stdout)??[];if(A===void 0)throw new SyntaxError("Invalid JSON response from package get: "+b.stdout);return JSON.parse(A)};return Oae.set(l,y()),await Oae.get(l)}async function $ut(l){let c=zut.dirname(Wut.fileURLToPath(import.meta.url));return l.debug("getTelemetryPackageData: Current file directory discovered as: "+c),await EC(c,c,l)}zc();function Rae(l){return Object.entries(l).reduce((c,[f,y])=>y==null?c:{...c,[f]:y},{})}var nlr=function(l,c,f,y){var b=arguments.length,A=b<3?c:y===null?y=Object.getOwnPropertyDescriptor(c,f):y,g;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(l,c,f,y);else for(var p=l.length-1;p>=0;p--)(g=l[p])&&(A=(b<3?g(A):b>3?g(c,f,A):g(c,f))||A);return b>3&&A&&Object.defineProperty(c,f,A),A},nDe=function(l,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(l,c)},fP=class extends Wd{constructor(c,f,y,b){super(b),this.cwd=c,this.root=f,this.config=y,this.metrics={}}capture(c){this.scopeMeter===void 0&&(this.scopeMeter=aF.getInstance().getMeterProvider().getMeter(this.name)),this.metrics[c.name]===void 0&&(this.metrics[c.name]=this.scopeMeter.createCounter(c.name,{valueType:hL.INT})),this.metrics[c.name]?.add(1,{...Rae(c.attributes)})}};nlr([Nl(),nDe("design:type",Function),nDe("design:paramtypes",[Function]),nDe("design:returntype",void 0)],fP.prototype,"capture",null);var Aw=class extends Error{constructor(c){super(`No configuration defined for ${c} scope`)}};var sdt=vf(Pz(),1);import*as idt from"node:path";var Hae=vf(x1(),1);import{readFile as Nfr}from"node:fs/promises";import*as FDe from"node:path";import*as Ipt from"node:path";var Pfr=function(l,c,f,y){var b=arguments.length,A=b<3?c:y===null?y=Object.getOwnPropertyDescriptor(c,f):y,g;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(l,c,f,y);else for(var p=l.length-1;p>=0;p--)(g=l[p])&&(A=(b<3?g(A):b>3?g(c,f,A):g(c,f))||A);return b>3&&A&&Object.defineProperty(c,f,A),A},LDe=function(l,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(l,c)},Rz=class extends Wd{async find(c,f,y){let b=(await ov(`git ls-tree --full-tree --name-only -r HEAD ${f}`,this.logger,{cwd:c})).stdout.split(/\r?\n/g).filter(g=>g!==""),A=await Promise.all(b.map(y));return await Promise.all(b.filter((g,p)=>A[p]===!0).map(async g=>Ipt.join(await Eae(c,this.logger),g)))}};Pfr([Nl(),LDe("design:type",Function),LDe("design:paramtypes",[String,String,Function]),LDe("design:returntype",Promise)],Rz.prototype,"find",null);async function Opt(l,c,f,y){f.traceEnter("","getTrackedSourceFiles",[c,y]);let b=new Rz(f),A=[];y.includes(FDe.extname(c))?A.push(c):A.push(...await b.find(l,c,k=>y.includes(FDe.extname(k))));let g=A.map(async k=>({fileName:k,async createSourceFile(){return Hae.createSourceFile(k,(await Nfr(k)).toString(),Hae.ScriptTarget.ES2021,!0)}})),p=await Promise.all(g);return f.traceExit("","getTrackedSourceFiles",p.map(k=>k.fileName)),p}var Gae=class extends Error{constructor(c){super(`No package installation found for ${c}`)}};var Yae=class extends Error{constructor(c,f){super(`No node_modules folders found between ${f} and ${c}`)}};import{access as Dfr}from"node:fs/promises";import*as Rpt from"node:path";async function Mpt(l){let c;try{await Dfr(Rpt.join(l,"node_modules"))}catch(f){c=f}return c===void 0}var Kae=new Map;async function Xae(l,c,f){let y=`${l} ${c}`;if(Kae.has(y)){f.debug("getDependencyTree cache hit for "+y);let g=await Kae.get(y);return f.traceExit("","getDependencyTree",g),g}let b=async()=>{let p=(await new V4(f).find(l,c,Mpt)).pop();if(p===void 0)throw new Yae(l,c);let k=await ov("npm ls --all --json",f,{cwd:p},!1),j=JSON.parse(k.stdout);return f.traceExit("","getDependencyTree inner promise",j),j};return Kae.set(y,b()),await Kae.get(y)}var Qae=new Map;async function Lpt(l,c){if(c.traceEnter("","getDirectoryPrefix",[l]),Qae.has(l)){c.debug("getDirectoryPrefix cache hit for "+l);let b=await Qae.get(l);return c.traceExit("","getDirectoryPrefix",b),b}let f=async()=>(await ov("npm prefix --no-workspaces",c,{cwd:l})).stdout;Qae.set(l,f());let y=await Qae.get(l);return c.traceExit("","getDirectoryPrefix",y),y}var Ex=(l,c="Internal Logic Error")=>{if(!l)throw new Error(typeof c=="function"?c():c)};var dP=class{constructor(c,f){this.value=c,this.excluded=f,this.isSimpleStarRec=c==="**",this.isRegexStarRec=c.startsWith("**(")&&c.endsWith(")"),this.isStarRec=this.isSimpleStarRec||this.isRegexStarRec}};var $4=class l{constructor(c,f=null){this.left=f===null,this.link=f===null?new l(c,this):f,this.type=c,this.isStarRec=this.type==="**",this.node=null,this.pointer=null}setPointer(c){this.pointer=c,this.link.pointer=c}setNode(c){this.node=c,this.link.node=c}};var mP=(l,c,f={})=>{throw new Error(Object.entries(f).reduce((y,[b,A])=>`${y}, ${b} ${A}`,`${l}: ${c}`))},Fpt=l=>l.length===1?l[0]:l,wfr=/^[?*+\d]+$/,jpt=l=>{let c=[];c.or=!0;let f=!1,y=!1,b=0,A=[],g=k=>{c.excluded===!0&&(Ex(y===!1),y=!0),A.push(c),c=[],c.or=k},p=()=>{let k=A.pop(),j=Fpt(c);k.or===!0&&j.or===!0?k.push(...j):k.push(j),c=k};return g(!1),{setInArray:(k,j)=>{f===k&&mP(f?"Bad Array Start":"Bad Array Terminator",l,{char:j}),f=k},finishElement:(k,j,se,{finReq:ze=!1,group:ve=!1}={})=>{if(b===k)se.includes(l[k-1]||null)||mP(j,l,{char:k}),b+=1;else{ze&&mP(j,l,{char:k});let Br=l.slice(b,k);ve&&!["**","++"].includes(Br)&&mP("Bad Group Start",l,{char:k}),f&&!(wfr.test(Br)||Br.startsWith("(")&&Br.endsWith(")"))&&mP("Bad Array Selector",l,{selector:Br}),ve?c.push(new $4(Br)):(c.push(new dP(f?`[${Br}]`:Br,y)),y=!1),b=k+1}},startExclusion:k=>{y!==!1&&mP("Redundant Exclusion",l,{char:k}),y=!0},startGroup:()=>{g(!0),y&&(c.excluded=!0,y=!1),g(!1)},newGroupElement:()=>{p(),g(!1)},finishGroup:k=>{A.length<2&&mP("Unexpected Group Terminator",l,{char:k}),p(),p(),Ex(Array.isArray(c));let j=c[c.length-2];j instanceof $4&&j.left===!0&&c.push(j.link)},finalizeResult:()=>(p(),Ex(y===!1),A.length!==0&&mP("Non Terminated Group",l),f&&mP("Non Terminated Array",l),Fpt(c))}};var Mz=(l,c,f={})=>{throw new Error(Object.entries(f).reduce((y,[b,A])=>`${y}, ${b} ${A}`,`${l}: ${c}`))},Ifr=(l,c)=>{if(l==="")return new dP("",!1);if(Array.isArray(l))return l.length===0?new dP("",!1):l.map((g,p)=>typeof g=="number"?(c.useArraySelector||Mz("Forbidden Array Selector",JSON.stringify(l),{idx:p}),new dP(`[${g}]`,!1)):new dP(g.replaceAll("\\","\\\\"),!1));let f=jpt(l),y=l.length,b=!1,A=0;for(let g=0;g<y;g+=1){let p=l[g];if(b===!1){if(A===0)switch(p){case".":f.finishElement(g,"Bad Path Separator",["]","}"]);break;case"[":c.useArraySelector||Mz("Forbidden Array Selector",l,{char:g}),f.finishElement(g,"Bad Array Start",[null,"!","{",",","}","]"]),f.setInArray(!0,g);break;case"]":f.finishElement(g,"Bad Array Terminator",["}"]),f.setInArray(!1,g);break;case"{":f.finishElement(g,"Bad Group Start",[null,"!",".","[","{",","],{group:!0}),f.startGroup();break;case",":f.finishElement(g,"Bad Group Separator",["]","}"]),f.newGroupElement();break;case"}":f.finishElement(g,"Bad Group Terminator",["]","}"]),f.finishGroup(g);break;case"!":f.finishElement(g,"Bad Exclusion",[null,".",",","{","["],{finReq:!0}),f.startExclusion(g);break;default:break}switch(p){case"(":A+=1;break;case")":A===0&&Mz("Unexpected Parentheses",l,{char:g}),A-=1;break;default:break}}b=p==="\\"?!b:!1}return b!==!1&&Mz("Dangling Escape",l,{char:y-1}),A!==0&&Mz("Unterminated Parentheses",l),f.finishElement(y,"Bad Terminator",["]","}"]),f.finalizeResult()},Bpt={parse:Ifr};var Upt=(l,c)=>{let f=[l],y=[null],b=[],A=[],g=0,p=!0;for(;g!==-1;){let k=f[g];Array.isArray(k)?k.or!==!0?(f.splice(g,1,...k),y.splice(g,1,...new Array(k.length).fill(y[g])),y[g]!==null&&(A[y[g]]+=k.length-1)):(b[g]===void 0?(b[g]=0,A[g]=0):A[g]!==0&&(f.splice(g+1,A[g]),y.splice(g+1,A[g]),A[g]=0),b[g]<k.length?(f.splice(g+1,0,k[b[g]]),y.splice(g+1,0,g),b[g]=(b[g]||0)+1,A[g]+=1,p=!0,g+=1):(b[g]=0,g-=1)):p===!0?(c("ADD",k),g===f.length-1?(c("FIN",k),p=!1):g+=1):(c("RM",k),g-=1)}};var Vpt=(l,c,f,{onAdd:y,onFin:b})=>{let A=[[[l,null]]],g=!1;Upt(f,(p,k)=>{if(p==="RM")k.excluded===!0&&(g=!1),A.length-=2;else if(p==="ADD"){if(k.excluded===!0){if(g)throw new Error(`Redundant Exclusion: "${c}"`);g=!0}let j=[],se=A[A.length-2];A[A.length-1].forEach(([ze,ve])=>y(ze,ve,k,se,lr=>j.push([lr,ze]))),A.push(k,j)}else A[A.length-1].filter(([j])=>j!==l).forEach(([j,se])=>b(j,se,k,g))})};var Ofr=/[?!,.*+[\](){}\\]/g,Rfr=l=>l.replace(Ofr,"\\$&"),Mfr=/^\^?[^-/\\^$*+?.()|[\]{}]*\$?$/g,Zae=l=>{if(Mfr.test(l)){let c=l.startsWith("^"),f=l.endsWith("$");if(c&&f){let y=l.slice(1,-1);return{test:b=>String(b)===y}}if(c){let y=l.slice(1);return{test:b=>String(b).startsWith(y)}}if(f){let y=l.slice(0,-1);return{test:b=>String(b).endsWith(y)}}return{test:y=>String(y).includes(l)}}try{return new RegExp(l)}catch{throw new Error(`Invalid Regex: "${l}"`)}},jDe=l=>l.reduce((c,f)=>`${c}${typeof f=="number"?`[${f}]`:`${c?".":""}${Rfr(f)}`}`,""),BDe=l=>Array.isArray(l)?jDe(l):l;var Lfr=["-","/","\\","^","$","*","+","?",".","(",")","|","[","]","{","}"],Jpt=l=>{let c="",f=!1,y=!0;for(let b=0;b<l.length;b+=1){let A=l[b];!f&&A==="\\"?f=!0:!f&&A==="*"?(y=!1,c+=".*"):!f&&A==="+"?(y=!1,c+=".+"):!f&&A==="?"?(y=!1,c+="."):(Lfr.includes(A)&&(y=!1,c+="\\"),c+=A,f=!1)}return y?{test:b=>String(b)===c}:c===".+"?{test:b=>b!==""}:new RegExp(`^${c}$`)},qpt=l=>(l.startsWith("**(")||l.startsWith("++("))&&l.endsWith(")")?Zae(l.slice(3,-1)):l.startsWith("[(")&&l.endsWith(")]")?Zae(l.slice(2,-2)):l.startsWith("(")&&l.endsWith(")")?Zae(l.slice(1,-1)):l.startsWith("[")&&l.endsWith("]")?Jpt(l.slice(1,-1)):Jpt(l);var gF=class{constructor(c,f){if(f.nodes.push(this),this.value=c,this.ctx=f,this.order=f.counter,this.children=[],this.match=!1,this.matches=!1,this.needles=[],this.leafNeedles=[],this.leafNeedlesExclude=[],this.leafNeedlesMatch=[],this.isArrayTarget=c.startsWith("[")&&c.endsWith("]"),this.isSimpleStarRec=c==="**",this.isSimplePlusRec=c==="++",this.isSimpleRec=this.isSimpleStarRec||this.isSimplePlusRec,this.isRegexStarRec=c.startsWith("**(")&&c.endsWith(")"),this.isRegexPlusRec=c.startsWith("++(")&&c.endsWith(")"),this.isStarRec=this.isSimpleStarRec||this.isRegexStarRec,this.isPlusRec=this.isSimplePlusRec||this.isRegexPlusRec,this.isRec=this.isStarRec||this.isPlusRec,this.isAnyArrayTarget=c==="[*]",this.isAnyObjTarget=c==="*",this.isSimpleRec||this.isAnyObjTarget||this.isAnyArrayTarget)this.regex=null;else{let{regex:y}=f;c in y||(y[c]=qpt(c)),this.regex=y[c]}}recMatch(c){return this.isRec?this.isSimpleRec?!0:this.regex.test(c):!1}typeMatch(c,f){return this.isSimpleRec?!0:this.isAnyArrayTarget?f:this.isAnyObjTarget?!f:f!==this.isArrayTarget&&!this.isRec?!1:this.regex.test(c)}add(c){this.children.push(c)}get(c){return this.children.find(({value:f})=>f===c)}markMatches(){this.matches=!0}addNeedle(c){this.needles.includes(c)||this.needles.push(c)}setRoots(c){this.roots=c}finish(c,f,y){this.addNeedle(c),this.leafNeedles.includes(c)||this.leafNeedles.push(c);let b=f?this.leafNeedlesExclude:this.leafNeedlesMatch;b.includes(c)||b.push(c),this.match=!f,this.matches=this.match,this.index=y}};var Ffr=(l,c,f,y)=>{Vpt(l,c,f,{onAdd:(b,A,g,p,k)=>{if(b.addNeedle(c),g instanceof $4){g.left===!0?(g.isStarRec&&g.setPointer(b),g.setNode(new gF("*",y)),y.links.push(b,g.node),k(g.node)):(g.target="target"in p?p.target:A.get(p.value),y.links.push(g.target,g.node),g.pointer!==null&&(k(g.pointer),g.setPointer(null)),k(b));return}let j=g.isStarRec&&g.value===p?.value;if(j&&y.strict)throw new Error(`Redundant Recursion: "${c}"`);if(j)g.target=b;else{let se=b.get(g.value);se===void 0&&(se=new gF(g.value,y),b.add(se)),k(se)}g.isStarRec&&k(b)},onFin:(b,A,g,p)=>{if(y.strict&&g.isSimpleStarRec){let k=A.children.filter(({value:j})=>!["","**"].includes(j));if(k.length!==0)throw new Error(`Needle Target Invalidated: "${k[0].needles[0]}" by "${c}"`)}if(y.strict&&b.leafNeedles.length!==0){let k=BDe(b.leafNeedles[0]),j=BDe(c);throw new Error(`Redundant Needle Target: "${k}" vs "${j}"`)}b.finish(c,p,y.counter),y.counter+=1}})},jfr=(l,c)=>{let{links:f}=c;for(;f.length!==0;){let b=f.pop(),A=f.pop(),{children:g}=A;A.children=[...b.children.filter(p=>!g.includes(p)),...g]}c.useArraySelector===!1&&l.setRoots(l.children.filter(({isStarRec:b,value:A})=>b||A===""));let{nodes:y}=c;for(;y.length!==0;){let b=y.pop(),{children:A}=b;A.reverse(),A.some(({matches:g})=>g)&&b.markMatches()}},zpt=(l,c)=>{c.counter=0,c.links=[],c.nodes=[],c.regex=Object.create(null);let f=new gF("*",c);for(let y=0;y<l.length;y+=1){let b=l[y],A=[Bpt.parse(b,c)];Ffr(f,b,A,c)}return jfr(f,c),f};var UDe=(l,c)=>{let f=[];for(let y=0,b=l.length;y<b;y+=1){let A=l[y][c];for(let g=0,p=A.length;g<p;g+=1){let k=A[g];f.includes(k)||f.push(k)}}return f},Wpt=l=>UDe(l,"leafNeedlesMatch"),$pt=l=>UDe(l,"leafNeedlesExclude"),Hpt=l=>UDe(l,"needles"),Gpt=l=>{let c=-1,f=!1,y=l.length;for(;y--;){let{index:b,match:A}=l[y];b>c&&(c=b,f=A)}return f},VDe=(l,c)=>c?jDe(l):[...l];var Ypt=(l,c)=>{if(c.rtn==="context")return{onMatch:()=>{},get:()=>l.context};if(c.rtn==="bool"){let y=!1;return{onMatch:()=>{y=!0},get:()=>y}}if(c.rtn==="count"){let y=0;return{onMatch:()=>{y+=1},get:()=>y}}if(c.rtn==="sum"){let y=0;return{onMatch:({value:b})=>{y+=b},get:()=>y}}let f=[];return{onMatch:typeof c.rtn=="function"?()=>f.push(c.rtn(l)):Array.isArray(c.rtn)?()=>f.push(c.rtn.map(y=>l[y])):()=>f.push(l[c.rtn]),get:()=>c.abort?f[0]:f}};var Kpt=(l,c,f)=>{let y={haystack:l,context:f.context};if(f.beforeFn!==void 0){let Br=f.beforeFn(y);Br!==void 0&&(y.haystack=Br)}let b=[!1,[c],null,0],A=[],g=[],p,k,j,se,ze=y.haystack,ve={getKey:(Br=f.joined)=>VDe(A,Br),get key(){return ve.getKey()},getValue:()=>ze,get value(){return ve.getValue()},getEntry:(Br=f.joined)=>[VDe(A,Br),ze],get entry(){return ve.getEntry()},getIsMatch:()=>se,get isMatch(){return ve.getIsMatch()},getMatchedBy:()=>Wpt(j),get matchedBy(){return ve.getMatchedBy()},getExcludedBy:()=>$pt(j),get excludedBy(){return ve.getExcludedBy()},getTraversedBy:()=>Hpt(j),get traversedBy(){return ve.getTraversedBy()},getGproperty:()=>A[A.length-2],get gproperty(){return ve.getGproperty()},getProperty:()=>A[A.length-1],get property(){return ve.getProperty()},getGparent:()=>g[g.length-2],get gparent(){return ve.getGparent()},getParent:()=>g[g.length-1],get parent(){return ve.getParent()},getParents:()=>[...g].reverse(),get parents(){return ve.getParents()},getIsCircular:()=>g.includes(ze),get isCircular(){return ve.getIsCircular()},getIsLeaf:()=>!(ze instanceof Object),get isLeaf(){return ve.getIsLeaf()},getDepth:()=>A.length,get depth(){return ve.getDepth()},get result(){return ve.getResult()},context:y.context},lr=Ypt(ve,f);if(ve.getResult=()=>lr.get(),f.useArraySelector||!Array.isArray(y.haystack)){let Br=c.get("");Br!==void 0&&b[1].push(Br)}do{p=b.pop(),k=b.pop(),j=b.pop(),se=b.pop();let Br=A.length-p;for(let kt=0;kt<Br;kt+=1)g.pop(),A.pop();if(Br===-1?(g.push(ze),A.push(k),ze=ze[k]):k!==null?(A[A.length-1]=k,ze=g[g.length-1][k]):ze=y.haystack,se){(f.filterFn===void 0||f.filterFn(ve)!==!1)&&(lr.onMatch(ve),f.abort&&(b.length=0));continue}if(!j.some(({matches:kt})=>kt))continue;let wt=f.useArraySelector===!1&&Array.isArray(ze);if(!wt&&Gpt(j)&&(b.push(!0,j,k,p),se=!0),(f.breakFn===void 0||f.breakFn(ve)!==!0)&&ze instanceof Object){let kt=Array.isArray(ze),Fi=kt?ze.map((yi,qo)=>qo).filter(()=>!0):Object.keys(ze);!kt&&f.compareFn&&Fi.sort(f.compareFn(ve)),f.reverse||Fi.reverse();for(let yi=0,qo=Fi.length;yi<qo;yi+=1){let Xl=Fi[yi],ho=[];if(wt)ho.push(...j),p===0&&ho.push(...c.roots);else for(let bf=0,wi=j.length;bf!==wi;bf+=1){let Ln=j[bf];Ln.recMatch(Xl)&&ho.push(Ln);let{children:xm}=Ln,Bo=xm.length;for(;Bo--;){let pv=xm[Bo];pv.typeMatch(Xl,kt)&&ho.push(pv)}}if(f.orderByNeedles){ho.index=Buffer.from(ho.map(({order:Ln})=>Ln).sort());let bf=b.length-3,wi=bf-yi*4;for(;bf!==wi&&Buffer.compare(ho.index,b[bf].index)===1;)bf-=4;b.splice(bf+3,0,!1,ho,Xl,p+1)}else b.push(!1,ho,Xl,p+1)}}}while(b.length!==0);if(y.result=lr.get(),f.afterFn!==void 0){let Br=f.afterFn(y);Br!==void 0&&(y.result=Br)}return y.result};var xx=(l,c,f)=>{Ex(f.includes(typeof l[c]),()=>`Option "${c}" not one of [${f.join(", ")}]`)},Xpt=l=>{let c={filterFn:void 0,breakFn:void 0,beforeFn:void 0,afterFn:void 0,compareFn:void 0,reverse:!0,orderByNeedles:!1,abort:!1,rtn:void 0,joined:!1,useArraySelector:!0,strict:!0,...l};return Ex(Object.keys(c).length===12,"Unexpected Option provided"),xx(c,"filterFn",["function","undefined"]),xx(c,"breakFn",["function","undefined"]),xx(c,"beforeFn",["function","undefined"]),xx(c,"afterFn",["function","undefined"]),xx(c,"compareFn",["function","undefined"]),xx(c,"reverse",["boolean"]),xx(c,"orderByNeedles",["boolean"]),xx(c,"abort",["boolean"]),Ex(typeof c.rtn=="function"&&c.rtn.length===1||[void 0,"context","key","value","entry","property","gproperty","parent","gparent","parents","isMatch","matchedBy","excludedBy","traversedBy","isCircular","isLeaf","depth","bool","count","sum"].includes(c.rtn)||Array.isArray(c.rtn)&&c.rtn.every(f=>["key","value","entry","property","gproperty","parent","gparent","parents","isMatch","matchedBy","excludedBy","traversedBy","isCircular","isLeaf","depth"].includes(f)),'Option "rtn" is malformed'),xx(c,"joined",["boolean"]),xx(c,"useArraySelector",["boolean"]),xx(c,"strict",["boolean"]),c};var Qpt=(l,c={})=>{if(Ex(Array.isArray(l),'Argument "needles" expected to be Array'),Ex(c instanceof Object&&!Array.isArray(c),'Argument "opts" expected to be Object'),l.length===0)return(b,A)=>A===void 0?[]:A;let f=Xpt(c),y=zpt(l,f);return(b,A)=>Kpt(b,y,{context:A,...f,rtn:f.rtn||(A===void 0?"key":"context")})};function hF(l,c,f){return Qpt([`**.dependencies.${c}`],{filterFn:f})(l)}function Zpt(l,c){let f=hF(l,c,()=>!0).sort((y,b)=>y.length-b.length);return f.length>0?f.filter(y=>y.length===f[0]?.length):[]}var edt=vf(Pz(),1);function tdt(l,c){if(l.name===c.name&&l.version===c.version)return l.path=[],[l];let f=hF(l,c.name,({value:y})=>y.version===c.version);return f.length>0?f.map(y=>({path:y,...(0,edt.default)(l,y)})):[]}var rdt=vf(Pz(),1);function ndt(l,c){if(c.length!==0)return c.length===2?{path:[],...l}:{path:c.slice(0,-2),...(0,rdt.default)(l,c.slice(0,-2))}}async function eoe(l,c,f,y,b){b.traceEnter("","findRelevantSourceFiles",[l,c,f,y]);let A=await Opt(c,f,b,y),g=await Xae(c,f,b),p=A.map(async se=>{let ze=await Lpt(idt.dirname(se.fileName),b),ve=await EC(ze,f,b),lr=tdt(g,ve),Br,wt;do{for(let kt of lr){let Fi=Zpt(kt,l.name);if(Fi.length>0){let yi=Fi[0]?.length??0;(wt===void 0||yi<wt)&&(Br=Fi.map(qo=>(0,sdt.default)(kt,qo).version),wt=yi)}}lr=lr.map(kt=>ndt(g,kt.path)).filter(kt=>kt!==void 0)}while(wt===void 0&&lr.length>0);return Br===void 0?(b.error(new Gae(l.name)),!1):Br.some(kt=>kt===l.version)}),k=await Promise.all(p),j=A.filter((se,ze)=>k[ze]);return b.traceExit("","findRelevantSourceFiles",j),j}var adt=vf(x1(),1);var toe=class extends Wd{constructor(c,f,y){super(y),this.accumulator=c,this.nodeHandlerMap=f}handle(c,f){let y=this.nodeHandlerMap[c.kind];y!==void 0&&new y(f,this.logger).handle(c,this.accumulator),adt.forEachChild(c,b=>{this.handle(b,f)})}};function roe(l,c,f,y){y.traceEnter("","processFile",[c.fileName]),new toe(l,f,y).handle(c,c),y.traceExit("","processFile",void 0)}function noe(l,c){l.imports=l.imports.filter(f=>f.path===c||f.path.startsWith(`${c}/`))}var ioe=class{findMatch(c,f){return c.accessPath.length>=2?f.find(y=>y.isAll&&y.name===c.accessPath[0]):void 0}};var soe=class{findMatch(c,f){return f.find(y=>!y.isDefault&&!y.isAll&&y.rename===void 0&&y.name===c.accessPath[0])}};var aoe=class{findMatch(c,f){return f.find(y=>y.rename!==void 0&&y.rename===c.accessPath[0])}};var yF=class{constructor(){this.imports=[]}};var ooe=class extends yF{constructor(){super(),this.tokens=[],this.functions=[],this.functionImports=new Map,this.tokenImports=new Map}};var EF=vf(x1(),1);var odt=vf(x1(),1);var AC=class{};var coe=class extends AC{parse(c,f){let y=[];return c.namedBindings?.kind===odt.SyntaxKind.NamespaceImport&&y.push({name:c.namedBindings.name.escapedText.toString(),path:f,isDefault:!1,isAll:!0}),y}};var ldt=vf(x1(),1);var JDe="[Default]",cdt="default";var loe=class extends AC{parse(c,f){let y=[];return c.namedBindings?.kind===ldt.SyntaxKind.NamedImports&&c.namedBindings.elements.forEach(b=>{b.propertyName?.escapedText===cdt&&y.push({name:JDe,path:f,rename:b.name.escapedText.toString(),isDefault:!0,isAll:!1})}),c.name&&y.push({name:JDe,path:f,rename:c.name.escapedText.toString(),isDefault:!0,isAll:!1}),y}};var udt=vf(x1(),1);var uoe=class extends AC{parse(c,f){let y=[];return c.namedBindings?.kind===udt.SyntaxKind.NamedImports&&c.namedBindings.elements.forEach(b=>{b.propertyName||y.push({name:b.name.escapedText.toString(),path:f,isDefault:!1,isAll:!1})}),y}};var _dt=vf(x1(),1);var _oe=class extends AC{parse(c,f){let y=[];return c.namedBindings?.kind===_dt.SyntaxKind.NamedImports&&c.namedBindings.elements.forEach(b=>{b.propertyName&&b.propertyName.escapedText!=="default"&&y.push({name:b.propertyName.escapedText.toString(),path:f,rename:b.name.escapedText.toString(),isDefault:!1,isAll:!1})}),y}};var wT=class extends Wd{constructor(c,f){super(f),this.sourceFile=c}};var vF=class extends wT{handle(c,f){f.imports.push(...this.getData(c))}getData(c){let f=[new coe,new loe,new uoe,new _oe],y=[],b=c.importClause,A=c.moduleSpecifier.getText(this.sourceFile).slice(1,-1);return b&&f.forEach(g=>y.push(...g.parse(b,A))),y}};var boe=vf(x1(),1);var Soe=vf(x1(),1);var IT=class{constructor(c){this.complexValue=c}};var PC=vf(x1(),1);var $d=class extends Wd{constructor(c,f){super(f),this.sourceFile=c}};var SF=class extends $d{getData(c){return new IT(this.sourceFile.text.substring(c.pos,c.end).trim())}};var foe=class extends $d{getData(c){return!1}};var poe=class extends $d{getData(c){if(c.escapedText.toString()!=="undefined")return new SF(this.sourceFile,this.logger).getData(c)}};var bF=class extends $d{getData(c){return!0}};var doe=class extends $d{getData(c){return c.initializer===void 0?new bF(this.sourceFile,this.logger).getData(c):kC(c.initializer.kind,this.sourceFile,this.logger).getData(c.initializer)}};var TF=class extends Error{constructor(c){super("No expression found in attribute "+c)}};var moe=class extends $d{getData(c){if(c.expression===void 0)throw new TF(c.getText(this.sourceFile));return kC(c.expression.kind,this.sourceFile,this.logger).getData(c.expression)}};var goe=class extends $d{getData(c){return new IT(c.getText(this.sourceFile))}};var hoe=class extends $d{getData(c){return null}};var yoe=class extends $d{getData(c){return Number(c.text)}};var voe=class extends $d{getData(c){return c.text}};var Bfr={[PC.SyntaxKind.StringLiteral]:voe,[PC.SyntaxKind.FalseKeyword]:foe,[PC.SyntaxKind.NullKeyword]:hoe,[PC.SyntaxKind.NumericLiteral]:yoe,[PC.SyntaxKind.TrueKeyword]:bF,[PC.SyntaxKind.JsxExpression]:moe,[PC.SyntaxKind.JsxAttribute]:doe,[PC.SyntaxKind.JsxSpreadAttribute]:goe,[PC.SyntaxKind.Identifier]:poe},kC=(l,c,f)=>{let y=Bfr[l]??SF;return new y(c,f)};function Lz(l,c,f){return fdt(l,c,[],!0,f)}function fdt(l,c,f,y,b){switch(l.kind){case Soe.SyntaxKind.Identifier:return[...f,l.escapedText.toString()];case Soe.SyntaxKind.PropertyAccessExpression:f.push(l.name.escapedText.toString());break;case Soe.SyntaxKind.ElementAccessExpression:{let g=l.argumentExpression,p=kC(g.kind,c,b).getData(g);p!=null&&f.push(p instanceof IT?p:p.toString());break}}let A=f;return"expression"in l&&(A=fdt(l.expression,c,f,!1,b)),y?A.reverse():A}var Fz=class extends wT{handle(c,f){c.parent.kind===boe.SyntaxKind.ElementAccessExpression&&c.parent.argumentExpression!==c||[boe.SyntaxKind.PropertyAccessExpression,boe.SyntaxKind.CallExpression].includes(c.parent.kind)||f.tokens.push(this.getData(c))}getData(c){return{name:c.getText(this.sourceFile),accessPath:Lz(c,this.sourceFile,this.logger),startPos:c.pos,endPos:c.end}}};var Toe=class extends wT{handle(c,f){let y=this.getData(c);f.functions.push(y)}getData(c){let f=c.arguments.end-c.arguments.pos,y=c.getText(this.sourceFile),b=y.substring(0,y.length-f-1).replace(/\s/g,"");b=b.substring(0,b.length-1);let A={name:b,accessPath:[],arguments:[],startPos:c.pos,endPos:c.end};return A.arguments=c.arguments.map(g=>kC(g.kind,this.sourceFile,this.logger).getData(g)),A.accessPath=Lz(c,this.sourceFile,this.logger),A}};var Cx=vf(x1(),1);var Eoe=class extends wT{handle(c,f){c.parent.kind===Cx.SyntaxKind.ElementAccessExpression&&c.parent.argumentExpression!==c||[Cx.SyntaxKind.JsxOpeningElement,Cx.SyntaxKind.JsxSelfClosingElement,Cx.SyntaxKind.JsxClosingElement,Cx.SyntaxKind.PropertyAccessExpression,Cx.SyntaxKind.CallExpression,Cx.SyntaxKind.ImportClause,Cx.SyntaxKind.ImportDeclaration,Cx.SyntaxKind.ImportSpecifier].includes(c.parent.kind)||c.parent.kind===Cx.SyntaxKind.VariableDeclaration&&c.parent.name===c||f.tokens.push(this.getData(c))}getData(c){return{name:c.escapedText.toString(),accessPath:[c.escapedText.toString()],startPos:c.pos,endPos:c.end}}};var pdt={[EF.SyntaxKind.ImportDeclaration]:vF,[EF.SyntaxKind.CallExpression]:Toe,[EF.SyntaxKind.PropertyAccessExpression]:Fz,[EF.SyntaxKind.ElementAccessExpression]:Fz,[EF.SyntaxKind.Identifier]:Eoe};import{createHash as ddt}from"node:crypto";function NC(l,c){let f=Object.entries(l).map(([y,b])=>{if(!c.includes(y))return[y,b];if(Array.isArray(b)){let g=b.map(p=>{if(typeof p!="string")return p;let k=ddt("sha256");return k.update(p),k.digest("hex")});return[y,g]}if(typeof b!="string")return[y,b];let A=ddt("sha256");return A.update(b),[y,A.digest("hex")]});return Object.fromEntries(f)}var xoe=class extends Map{has(c){let f=new jz(typeof c,c);return super.has(Ph(f))}get(c){let f=new jz(typeof c,c);return super.get(Ph(f))}set(c,f){let y=new jz(typeof c,c);return super.set(Ph(y),f)}},jz=class{constructor(c,f){this.type=c,this.val=f}};var qDe=new xoe,Ufr=1;function Vfr(){return`[redacted${Ufr++}]`}var DC=class{put(c){if(qDe.has(c))return qDe.get(c);let f=Vfr();return qDe.set(c,f),f}};function Bz(l,c){let f=new DC;return l.map(y=>typeof y=="string"&&!c.includes(y)||typeof y=="object"&&y!==null&&!c.includes(y)?f.put(y):y)}var agt=vf(sgt(),1);var Lmr=function(l,c,f,y){var b=arguments.length,A=b<3?c:y===null?y=Object.getOwnPropertyDescriptor(c,f):y,g;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(l,c,f,y);else for(var p=l.length-1;p>=0;p--)(g=l[p])&&(A=(b<3?g(A):b>3?g(c,f,A):g(c,f))||A);return b>3&&A&&Object.defineProperty(c,f,A),A},cwe=function(l,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(l,c)},Ax=class extends Wd{getPackageDetails(c,f){let[,y,b]=/^(@[^/]+)\/(.+)/.exec(c)??[];if(f!==void 0){let{major:A,minor:g,patch:p,prerelease:k}=new agt.SemVer(f);return{owner:y,name:b??c,major:A,minor:g,patch:p,preRelease:k.length===0?void 0:k}}return{owner:y,name:b??c}}};Lmr([Nl(),cwe("design:type",Function),cwe("design:paramtypes",[String,String]),cwe("design:returntype",Object)],Ax.prototype,"getPackageDetails",null);var wC=class extends Wd{};var Moe=class extends wC{constructor(c,f,y,b,A){super(A),this.name="js.function",this.jsFunction=c,this.matchingImport=f,this.instrumentedPackage=y,this.allowedArgumentStringValues=b.collect.js?.functions?.allowedArgumentStringValues??[]}get attributes(){let c=new Ax(this.logger),{owner:f,name:y,major:b,minor:A,patch:g,preRelease:p}=c.getPackageDetails(this.instrumentedPackage.name,this.instrumentedPackage.version),k=Ph(this.jsFunction.name),j=[...this.jsFunction.accessPath];this.matchingImport.rename!==void 0&&(k=k.replace(this.matchingImport.rename,this.matchingImport.name),j[0]=this.matchingImport.name);let se=new DC;j.forEach(ve=>{ve instanceof IT&&(k=k.replace(Ph(ve.complexValue),se.put(ve)))}),this.matchingImport.isAll&&(j[0]=se.put(this.matchingImport.name),k=k.replace(this.matchingImport.name,se.put(this.matchingImport.name)));let ze={[gx.FUNCTION_NAME]:k,[gx.FUNCTION_MODULE_SPECIFIER]:this.matchingImport.path,[gx.FUNCTION_ACCESS_PATH]:Bz(j,j.filter(ve=>typeof ve=="string")).join(" "),[gx.FUNCTION_ARGUMENT_VALUES]:Bz(this.jsFunction.arguments,this.allowedArgumentStringValues).map(ve=>String(ve)),[xa.INSTRUMENTED_RAW]:this.instrumentedPackage.name,[xa.INSTRUMENTED_OWNER]:f,[xa.INSTRUMENTED_NAME]:y,[xa.INSTRUMENTED_VERSION_RAW]:this.instrumentedPackage.version,[xa.INSTRUMENTED_VERSION_MAJOR]:b?.toString(),[xa.INSTRUMENTED_VERSION_MINOR]:A?.toString(),[xa.INSTRUMENTED_VERSION_PATCH]:g?.toString(),[xa.INSTRUMENTED_VERSION_PRE_RELEASE]:p?.join(".")};return ze=NC(ze,[xa.INSTRUMENTED_RAW,xa.INSTRUMENTED_OWNER,xa.INSTRUMENTED_NAME,xa.INSTRUMENTED_VERSION_RAW,xa.INSTRUMENTED_VERSION_PRE_RELEASE]),ze}};var Loe=class extends wC{constructor(c,f,y,b){super(b),this.name="js.token",this.jsToken=c,this.matchingImport=f,this.instrumentedPackage=y}get attributes(){let c=new Ax(this.logger),{owner:f,name:y,major:b,minor:A,patch:g,preRelease:p}=c.getPackageDetails(this.instrumentedPackage.name,this.instrumentedPackage.version),k=Ph(this.jsToken.name),j=[...this.jsToken.accessPath];this.matchingImport.rename!==void 0&&(k=k.replace(this.matchingImport.rename,this.matchingImport.name),j[0]=this.matchingImport.name);let se=new DC;j.forEach(ve=>{ve instanceof IT&&(k=k.replace(Ph(ve.complexValue),se.put(ve)))}),this.matchingImport.isAll&&(j[0]=se.put(this.matchingImport.name),k=k.replace(this.matchingImport.name,se.put(this.matchingImport.name)));let ze={[gx.TOKEN_NAME]:k,[gx.TOKEN_MODULE_SPECIFIER]:this.matchingImport.path,[gx.TOKEN_ACCESS_PATH]:Bz(j,j.filter(ve=>typeof ve=="string")).join(" "),[xa.INSTRUMENTED_RAW]:this.instrumentedPackage.name,[xa.INSTRUMENTED_OWNER]:f,[xa.INSTRUMENTED_NAME]:y,[xa.INSTRUMENTED_VERSION_RAW]:this.instrumentedPackage.version,[xa.INSTRUMENTED_VERSION_MAJOR]:b?.toString(),[xa.INSTRUMENTED_VERSION_MINOR]:A?.toString(),[xa.INSTRUMENTED_VERSION_PATCH]:g?.toString(),[xa.INSTRUMENTED_VERSION_PRE_RELEASE]:p?.join(".")};return ze=NC(ze,[xa.INSTRUMENTED_RAW,xa.INSTRUMENTED_OWNER,xa.INSTRUMENTED_NAME,xa.INSTRUMENTED_VERSION_RAW,xa.INSTRUMENTED_VERSION_PRE_RELEASE]),ze}};var ogt=function(l,c,f,y){var b=arguments.length,A=b<3?c:y===null?y=Object.getOwnPropertyDescriptor(c,f):y,g;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(l,c,f,y);else for(var p=l.length-1;p>=0;p--)(g=l[p])&&(A=(b<3?g(A):b>3?g(c,f,A):g(c,f))||A);return b>3&&A&&Object.defineProperty(c,f,A),A},AF=function(l,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(l,c)},G4=class l extends fP{constructor(){super(...arguments),this.name="js",this.runSync=!1}async run(){let c=this.config.collect[this.name];if(c===void 0||Object.keys(c).length===0)throw new Aw(this.name);await this.captureAllMetrics(c)}async captureAllMetrics(c){let f=[new ioe,new soe,new aoe],y=await EC(this.cwd,this.cwd,this.logger),b=await eoe(y,this.cwd,this.root,l.fileExtensions,this.logger);this.logger.debug("Filtered source files: "+b.map(g=>g.fileName));let A=[];for(let g of b){let p=this.captureFileMetrics(await g.createSourceFile(),y,f,c);this.runSync?await p:A.push(p)}await Promise.allSettled(A)}async captureFileMetrics(c,f,y,b){let A=new ooe;roe(A,c,pdt,this.logger),this.deduplicateFunctions(A),this.deduplicateTokens(A),noe(A,f.name);let g=[];Object.keys(b).forEach(p=>{switch(p){case"tokens":g.push(this.captureTokenFileMetrics(A,f,y));break;case"functions":g.push(this.captureFunctionFileMetrics(A,f,y));break}}),await Promise.allSettled(g)}async captureTokenFileMetrics(c,f,y){this.resolveTokenImports(c,y),c.tokens.forEach(b=>{let A=c.tokenImports.get(b);A!==void 0&&this.capture(new Loe(b,A,f,this.logger))})}async captureFunctionFileMetrics(c,f,y){this.resolveFunctionImports(c,y),c.functions.forEach(b=>{let A=c.functionImports.get(b);A!==void 0&&this.capture(new Moe(b,A,f,this.config,this.logger))})}resolveTokenImports(c,f){c.tokens.forEach(y=>{let b=f.map(A=>A.findMatch(y,c.imports)).find(A=>A!==void 0);b!==void 0&&c.tokenImports.set(y,b)})}resolveFunctionImports(c,f){c.functions.forEach(y=>{let b=f.map(A=>A.findMatch(y,c.imports)).find(A=>A!==void 0);b!==void 0&&c.functionImports.set(y,b)})}deduplicateFunctions(c){c.functions=c.functions.filter(f=>!c.functions.some(y=>y.startPos>=f.startPos&&y.endPos<=f.endPos&&y!==f))}deduplicateTokens(c){c.tokens=c.tokens.filter(f=>!c.functions.some(y=>y.startPos>=f.startPos&&y.endPos<=f.endPos))}setRunSync(c){this.runSync=c}};G4.fileExtensions=[".jsx",".mjs",".js",".cjs",".tsx",".mts",".ts",".cts",".mjsx",".cjsx",".mtsx",".ctsx"];ogt([Nl(),AF("design:type",Function),AF("design:paramtypes",[]),AF("design:returntype",Promise)],G4.prototype,"run",null);ogt([Nl(),AF("design:type",Function),AF("design:paramtypes",[Object]),AF("design:returntype",Promise)],G4.prototype,"captureAllMetrics",null);var Foe=class{findMatch(c,f){return c.prefix!==void 0?f.find(y=>y.isAll&&y.name===c.prefix):void 0}};var joe=class{findMatch(c,f){return c.prefix!==void 0?f.find(y=>!y.isDefault&&!y.isAll&&y.name===c.prefix):f.find(y=>!y.isDefault&&!y.isAll&&y.name===c.name)}};var Boe=class{findMatch(c,f){return c.prefix!==void 0?f.find(y=>y.rename===c.prefix):f.find(y=>y.rename===c.name)}};var Uoe=class extends yF{constructor(){super(),this.elements=[],this.elementImports=new Map}};var qoe=vf(x1(),1);var b6r=vf(x1(),1);var cgt=function(l,c,f,y){var b=arguments.length,A=b<3?c:y===null?y=Object.getOwnPropertyDescriptor(c,f):y,g;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(l,c,f,y);else for(var p=l.length-1;p>=0;p--)(g=l[p])&&(A=(b<3?g(A):b>3?g(c,f,A):g(c,f))||A);return b>3&&A&&Object.defineProperty(c,f,A),A},kF=function(l,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(l,c)},Dw=class extends wT{getElementNameAndPrefix(c){let f=c.getText(this.sourceFile).split("."),[y,...b]=f.length===1?[void 0,f]:f;return{name:b.join("."),prefix:y}}getElementAttributes(c){let f=[];return c.properties.forEach(y=>{if(y.name&&"escapedText"in y.name)try{f.push({name:y.name.escapedText.toString(),value:kC(y.kind,this.sourceFile,this.logger).getData(y)})}catch(b){if(b instanceof TF)this.logger.error(b);else throw b}}),f}};cgt([Nl({argFormatter:l=>l.getText()}),kF("design:type",Function),kF("design:paramtypes",[Object]),kF("design:returntype",void 0)],Dw.prototype,"getElementNameAndPrefix",null);cgt([Nl({argFormatter:l=>l.getText()}),kF("design:type",Function),kF("design:paramtypes",[Object]),kF("design:returntype",void 0)],Dw.prototype,"getElementAttributes",null);var Voe=class extends Dw{handle(c,f){f.elements.push(this.getData(c))}getData(c){let{name:f,prefix:y}=this.getElementNameAndPrefix(c.openingElement.tagName),b=this.getElementAttributes(c.openingElement.attributes);return{name:f,prefix:y,attributes:b}}};var Joe=class extends Dw{handle(c,f){f.elements.push(this.getData(c))}getData(c){let{name:f,prefix:y}=this.getElementNameAndPrefix(c.tagName);return{name:f,prefix:y,attributes:this.getElementAttributes(c.attributes)}}};var lgt={[qoe.SyntaxKind.ImportDeclaration]:vF,[qoe.SyntaxKind.JsxElement]:Voe,[qoe.SyntaxKind.JsxSelfClosingElement]:Joe};function ugt(l,c,f){let y=new DC,b=Object.entries(l).map(([A,g])=>{if(!c.includes(A)){let p=y.put(A),k=y.put(g);return[p,k]}return typeof g=="string"&&!f.includes(g)?[A,y.put(g)]:typeof g=="object"&&g!==null&&!f.includes(g)?[A,y.put(g)]:[A,g]});return Object.fromEntries(b)}var zoe=class extends wC{constructor(c,f,y,b,A){super(A),this.name="jsx.element",this.jsxElement=c,this.matchingImport=f,this.instrumentedPackage=y,this.allowedAttributeNames=b.collect.jsx?.elements?.allowedAttributeNames??[],this.allowedAttributeStringValues=b.collect.jsx?.elements?.allowedAttributeStringValues??[]}get attributes(){let c=Rae(this.jsxElement.attributes.reduce((ze,ve)=>({...ze,[ve.name]:ve.value}),{})),f=ugt(c,this.allowedAttributeNames,this.allowedAttributeStringValues),y=new Ax(this.logger),{owner:b,name:A,major:g,minor:p,patch:k,preRelease:j}=y.getPackageDetails(this.instrumentedPackage.name,this.instrumentedPackage.version),se={[ow.NAME]:this.jsxElement.name,[ow.MODULE_SPECIFIER]:this.matchingImport.path,[ow.ATTRIBUTE_NAMES]:Object.keys(f),[ow.ATTRIBUTE_VALUES]:Object.values(f).map(ze=>String(ze)),[xa.INSTRUMENTED_RAW]:this.instrumentedPackage.name,[xa.INSTRUMENTED_OWNER]:b,[xa.INSTRUMENTED_NAME]:A,[xa.INSTRUMENTED_VERSION_RAW]:this.instrumentedPackage.version,[xa.INSTRUMENTED_VERSION_MAJOR]:g?.toString(),[xa.INSTRUMENTED_VERSION_MINOR]:p?.toString(),[xa.INSTRUMENTED_VERSION_PATCH]:k?.toString(),[xa.INSTRUMENTED_VERSION_PRE_RELEASE]:j?.join(".")};return this.matchingImport.rename!==void 0&&(se[ow.NAME]=this.jsxElement.name.replace(this.matchingImport.rename,this.matchingImport.name)),se=NC(se,[xa.INSTRUMENTED_RAW,xa.INSTRUMENTED_OWNER,xa.INSTRUMENTED_NAME,xa.INSTRUMENTED_VERSION_RAW,xa.INSTRUMENTED_VERSION_PRE_RELEASE]),se}};var _gt=function(l,c,f,y){var b=arguments.length,A=b<3?c:y===null?y=Object.getOwnPropertyDescriptor(c,f):y,g;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(l,c,f,y);else for(var p=l.length-1;p>=0;p--)(g=l[p])&&(A=(b<3?g(A):b>3?g(c,f,A):g(c,f))||A);return b>3&&A&&Object.defineProperty(c,f,A),A},PF=function(l,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(l,c)},Y4=class l extends fP{constructor(){super(...arguments),this.name="jsx",this.runSync=!1}async run(){let c=this.config.collect[this.name];if(c===void 0||Object.keys(c).length===0)throw new Aw(this.name);let f=[];Object.keys(c).forEach(y=>{switch(y){case"elements":f.push(this.captureAllMetrics());break}}),await Promise.allSettled(f)}async captureAllMetrics(){let c=[new Foe,new joe,new Boe],f=await EC(this.cwd,this.cwd,this.logger),y=await eoe(f,this.cwd,this.root,l.fileExtensions,this.logger);this.logger.debug("Filtered source files: "+y.map(A=>A.fileName));let b=[];for(let A of y){let g=this.captureFileMetrics(await A.createSourceFile(),f,c);this.runSync?await g:b.push(g)}await Promise.allSettled(b)}async captureFileMetrics(c,f,y){let b=new Uoe;roe(b,c,lgt,this.logger),noe(b,f.name),this.resolveElementImports(b,y),b.elements.forEach(A=>{let g=b.elementImports.get(A);g!==void 0&&this.capture(new zoe(A,g,f,this.config,this.logger))})}resolveElementImports(c,f){c.elements.forEach(y=>{let b=f.map(A=>A.findMatch(y,c.imports)).find(A=>A!==void 0);b!==void 0&&c.elementImports.set(y,b)})}setRunSync(c){this.runSync=c}};Y4.fileExtensions=[".js",".mjs",".cjs",".jsx",".tsx",".mjsx",".cjsx",".mtsx",".ctsx"];_gt([Nl(),PF("design:type",Function),PF("design:paramtypes",[]),PF("design:returntype",Promise)],Y4.prototype,"run",null);_gt([Nl(),PF("design:type",Function),PF("design:paramtypes",[]),PF("design:returntype",Promise)],Y4.prototype,"captureAllMetrics",null);var fgt=vf(Pz(),1);var Woe=class extends Error{};function pgt(l,c){let f=c.length===0?l:(0,fgt.default)(l,c);if(f===void 0)throw new Woe;return f.name===void 0&&(f.name=c[c.length-1]),{name:f.name,version:f.version,dependencies:Object.entries(f.dependencies).map(([y,b])=>({name:y,version:b.version}))}}function dgt(l,c,f,y){y.traceEnter("","findInstallersFromTree",[l,c,f]);let b=[],A=hF(l,c,f);return A.length>=1&&(b=A.map(g=>pgt(l,g.slice(0,-2)))),y.traceExit("","findInstallersFromTree",b),b}async function mgt(l,c,f,y,b){b.traceEnter("","findInstallingPackages",[f,y,l,c]);let A=await Xae(l,c,b),g=dgt(A,f,y,b);return b.traceExit("","findInstallingPackages",g),g}var $oe=class extends wC{constructor(c,f,y){super(y),this.name="npm.dependency",this.data=c,this.instrumentedPackage=f}get attributes(){let c=new Ax(this.logger),{owner:f,name:y,major:b,minor:A,patch:g,preRelease:p}=c.getPackageDetails(this.data.rawName,this.data.rawVersion),{owner:k,name:j,major:se,minor:ze,patch:ve,preRelease:lr}=c.getPackageDetails(this.instrumentedPackage.name,this.instrumentedPackage.version),Br={[xa.RAW]:this.data.rawName,[xa.OWNER]:f,[xa.NAME]:y,[xa.IS_INSTRUMENTED]:this.data.isInstrumented,[xa.VERSION_RAW]:this.data.rawVersion,[xa.VERSION_MAJOR]:b?.toString(),[xa.VERSION_MINOR]:A?.toString(),[xa.VERSION_PATCH]:g?.toString(),[xa.VERSION_PRE_RELEASE]:p?.join("."),[xa.INSTRUMENTED_RAW]:this.instrumentedPackage.name,[xa.INSTRUMENTED_OWNER]:k,[xa.INSTRUMENTED_NAME]:j,[xa.INSTRUMENTED_VERSION_RAW]:this.instrumentedPackage.version,[xa.INSTRUMENTED_VERSION_MAJOR]:se?.toString(),[xa.INSTRUMENTED_VERSION_MINOR]:ze?.toString(),[xa.INSTRUMENTED_VERSION_PATCH]:ve?.toString(),[xa.INSTRUMENTED_VERSION_PRE_RELEASE]:lr?.join(".")};return NC(Br,[xa.RAW,xa.OWNER,xa.NAME,xa.VERSION_RAW,xa.VERSION_PRE_RELEASE,xa.INSTRUMENTED_RAW,xa.INSTRUMENTED_OWNER,xa.INSTRUMENTED_NAME,xa.INSTRUMENTED_VERSION_RAW,xa.INSTRUMENTED_VERSION_PRE_RELEASE])}};var ggt=function(l,c,f,y){var b=arguments.length,A=b<3?c:y===null?y=Object.getOwnPropertyDescriptor(c,f):y,g;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(l,c,f,y);else for(var p=l.length-1;p>=0;p--)(g=l[p])&&(A=(b<3?g(A):b>3?g(c,f,A):g(c,f))||A);return b>3&&A&&Object.defineProperty(c,f,A),A},NF=function(l,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(l,c)},DF=class extends fP{constructor(){super(...arguments),this.name="npm"}async collectDependencies(){let c=await EC(this.cwd,this.cwd,this.logger);(await mgt(this.cwd,this.root,c.name,({value:y})=>y.version===c.version,this.logger)).forEach(y=>{y.dependencies.forEach(b=>{this.capture(new $oe({rawName:b.name,rawVersion:b.version,isInstrumented:b.name===c.name&&b.version===c.version?"true":"false"},c,this.logger))})})}async run(){let c=this.config.collect[this.name];if(c===void 0||Object.keys(c).length===0)throw new Aw(this.name);let f=[];Object.keys(c).forEach(y=>{switch(y){case"dependencies":f.push(this.collectDependencies());break}}),await Promise.allSettled(f)}};ggt([Nl(),NF("design:type",Function),NF("design:paramtypes",[]),NF("design:returntype",Promise)],DF.prototype,"collectDependencies",null);ggt([Nl(),NF("design:type",Function),NF("design:paramtypes",[]),NF("design:returntype",Promise)],DF.prototype,"run",null);var hgt={js:G4,jsx:Y4,npm:DF};var Hoe=function(l,c,f,y){var b=arguments.length,A=b<3?c:y===null?y=Object.getOwnPropertyDescriptor(c,f):y,g;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(l,c,f,y);else for(var p=l.length-1;p>=0;p--)(g=l[p])&&(A=(b<3?g(A):b>3?g(c,f,A):g(c,f))||A);return b>3&&A&&Object.defineProperty(c,f,A),A},MT=function(l,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(l,c)},ww=class{constructor(c,f,y,b,A){this.config=c,this.date=A,this.environment=f,this.gitInfo=y,this.logger=b}async run(){if(this.logger.debug("Environment: "+JSON.stringify(this.environment)),!this.environment.isTelemetryEnabled){this.logger.debug("Telemetry disabled via environment variable");return}if(!this.environment.isCI){this.logger.debug("Telemetry disabled because not running in CI");return}this.logger.debug("Schema: "+JSON.stringify(Lne)),this.logger.debug("Config: "+JSON.stringify(this.config,void 0,2));let c=aF.getInstance(!0),{projectRoot:f,documentObject:y}=await this.getData();c.setAttributes(y);let b=this.runScopes(this.environment.cwd,f,this.config);await Promise.allSettled(b);let A=await c.getMetricReader().collect();this.logger.debug("Collection results:"),this.logger.debug(JSON.stringify(A,void 0,2)),this.environment.isExportEnabled&&await this.emitMetrics(A.resourceMetrics,this.config)}runScopes(c,f,y){let b=[];for(let A of Object.keys(y.collect)){let g=hgt[A];if(g===void 0)throw new Pae(A);let p=Reflect.construct(g,[c,f,y,this.logger]);b.push(p.run().then(()=>{this.logger.debug("Scope succeeded: "+A)}).catch(k=>{this.logger.error("Scope failed: "+A),k instanceof Error?this.logger.error(k):this.logger.error(String(k))}))}return b}async emitMetrics(c,f){if(c.scopeMetrics.length<=0)return;let y=new ygt.OTLPMetricExporter({url:f.endpoint,temporalityPreference:Sgt.AggregationTemporality.DELTA,compression:vgt.CompressionAlgorithm.GZIP});return await new Promise(b=>{y.export(c,A=>{this.logger.debug("Metrics exporter finished"),this.logger.debug(Ph(A)),b(void 0)})})}async getData(){this.logger.debug("Date: "+this.date);let c=this.environment.cwd;this.logger.debug("cwd: "+c);let f=await Eae(c,this.logger);this.logger.debug("projectRoot: "+f);let y=await $ut(this.logger);return{projectRoot:f,emitterInfo:y,documentObject:{[Ep.TELEMETRY_EMITTER_NAME]:y.name,[Ep.TELEMETRY_EMITTER_VERSION]:y.version,[Ep.PROJECT_ID]:this.config.projectId,...this.gitInfo,[Ep.DATE]:this.date}}}};Hoe([Nl(),MT("design:type",Function),MT("design:paramtypes",[]),MT("design:returntype",Promise)],ww.prototype,"run",null);Hoe([Nl(),MT("design:type",Function),MT("design:paramtypes",[String,String,Object]),MT("design:returntype",void 0)],ww.prototype,"runScopes",null);Hoe([Nl(),MT("design:type",Function),MT("design:paramtypes",[Object,Object]),MT("design:returntype",Promise)],ww.prototype,"emitMetrics",null);Hoe([Nl(),MT("design:type",Function),MT("design:paramtypes",[]),MT("design:returntype",Promise)],ww.prototype,"getData",null);var e0t=vf(Zyt(),1);var Pce=class extends Error{constructor(c){super(JSON.stringify(c,void 0,2)),this.errors=c}};var a1r=function(l,c,f,y){var b=arguments.length,A=b<3?c:y===null?y=Object.getOwnPropertyDescriptor(c,f):y,g;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(l,c,f,y);else for(var p=l.length-1;p>=0;p--)(g=l[p])&&(A=(b<3?g(A):b>3?g(c,f,A):g(c,f))||A);return b>3&&A&&Object.defineProperty(c,f,A),A},$Ie=function(l,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(l,c)},o1r=e0t.default.default,bW=class extends Wd{constructor(c,f){super(f),this.ajvValidate=new o1r({allErrors:!0,verbose:!0}).compile(c)}validate(c){if(!this.ajvValidate(c))throw new Pce(this.ajvValidate.errors?.map(f=>{let{instancePath:y,keyword:b,message:A,params:g}=f;return{instancePath:y,keyword:b,message:A,params:g}})??[])}};a1r([Nl(),$Ie("design:type",Function),$Ie("design:paramtypes",[Object]),$Ie("design:returntype",void 0)],bW.prototype,"validate",null);var WF=vf(i0t(),1);import{createHash as l1r}from"node:crypto";import{existsSync as HIe,readFileSync as u1r}from"node:fs";var _1r={"Secure Pipelines Services":["PIPELINE_RUN_URL","PIPELINE_RUN_ID","PIPELINE_ID"]},Bw=class{constructor(c){this.name=WF.name!==null&&WF.name!==void 0?WF.name:"",this.isCI=WF.isCI||this.customCICheck()||this.containerCheck(),this.isExportEnabled=process.env.IBM_TELEMETRY_EXPORT_DISABLED!=="true",this.isTelemetryEnabled=process.env.IBM_TELEMETRY_DISABLED!=="true",this.cwd=process.cwd(),c?.isCI!==void 0&&(this.isCI=c.isCI),c?.isExportEnabled!==void 0&&(this.isExportEnabled=c.isExportEnabled),c?.isTelemetryEnabled!==void 0&&(this.isTelemetryEnabled=c.isTelemetryEnabled),c?.cwd!==void 0&&(this.cwd=c.cwd);let f=l1r("sha256");f.update(this.name),this.name=f.digest("hex")}customCICheck(){for(let[c,f]of Object.entries(_1r))if(f.some(y=>process.env[y]!==void 0))return this.name=c,!0;return!1}containerCheck(){if(HIe("/run/.containerenv"))return this.name="Podman",!0;if(HIe("/.dockerenv"))return this.name="Docker",!0;if(HIe("/proc/self/cgroup"))try{if(u1r("/proc/self/cgroup","utf8").includes("docker"))return this.name="Docker",!0}catch(c){console.log("Error reading /proc/self/cgroup:",c)}return!1}getConfig(){return{cwd:this.cwd,isCI:this.isCI,name:this.name,isExportEnabled:this.isExportEnabled,isTelemetryEnabled:this.isTelemetryEnabled}}};function s0t(l){let c={host:void 0,owner:void 0,repository:void 0};return l.startsWith("http")?c=f1r(l):l.startsWith("git@")&&(c=p1r(l)),c.repository?.endsWith(".git")===!0&&(c.repository=c.repository.slice(0,-4)),c}function f1r(l){let c=/^https?:\/\/([^/]+)\/([^/]+)\/([^/]+)/.exec(l)??[],[f,y,b,A]=c;return{host:y,owner:b,repository:A}}function p1r(l){let c=/^([^@]+)@([^:]+):([^/]+)\/([^/]+)/.exec(l)??[],[f,y,b,A,g]=c;return{host:b,owner:A,repository:g}}var d1r=function(l,c,f,y){var b=arguments.length,A=b<3?c:y===null?y=Object.getOwnPropertyDescriptor(c,f):y,g;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(l,c,f,y);else for(var p=l.length-1;p>=0;p--)(g=l[p])&&(A=(b<3?g(A):b>3?g(c,f,A):g(c,f))||A);return b>3&&A&&Object.defineProperty(c,f,A),A},GIe=function(l,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(l,c)},TW=class{constructor(c,f){this.cwd=c,this.logger=f}async getGitInfo(){let c=(await ov("git remote get-url origin",this.logger)).stdout,f=(await ov("git rev-parse HEAD",this.logger)).stdout,y=await this.getCommitBranches(f,this.cwd,this.logger),b=await this.getCommitTags(f,this.cwd,this.logger),A=s0t(c);return{gitOrigin:c,commitHash:f,commitBranches:y,commitTags:b,repository:A}}async getCommitBranches(c,f,y){return(await ov(`git branch --points-at=${c} --format='%(refname:short)'`,y,{cwd:f},!0)).stdout.split(/\r?\n/g).filter(A=>A!=="")}async getCommitTags(c,f,y){return(await ov(`git tag --points-at=${c} --format='%(refname:short)'`,y,{cwd:f},!0)).stdout.split(/\r?\n/g).filter(A=>A!=="")}};d1r([Nl(),GIe("design:type",Function),GIe("design:paramtypes",[]),GIe("design:returntype",Promise)],TW.prototype,"getGitInfo",null);import{readFile as Mbr}from"node:fs/promises";function b0t(l){return typeof l>"u"||l===null}function m1r(l){return typeof l=="object"&&l!==null}function g1r(l){return Array.isArray(l)?l:b0t(l)?[]:[l]}function h1r(l,c){var f,y,b,A;if(c)for(A=Object.keys(c),f=0,y=A.length;f<y;f+=1)b=A[f],l[b]=c[b];return l}function y1r(l,c){var f="",y;for(y=0;y<c;y+=1)f+=l;return f}function v1r(l){return l===0&&Number.NEGATIVE_INFINITY===1/l}var S1r=b0t,b1r=m1r,T1r=g1r,E1r=y1r,x1r=v1r,C1r=h1r,kg={isNothing:S1r,isObject:b1r,toArray:T1r,repeat:E1r,isNegativeZero:x1r,extend:C1r};function T0t(l,c){var f="",y=l.reason||"(unknown reason)";return l.mark?(l.mark.name&&(f+='in "'+l.mark.name+'" '),f+="("+(l.mark.line+1)+":"+(l.mark.column+1)+")",!c&&l.mark.snippet&&(f+=`

`+l.mark.snippet),y+" "+f):y}function xW(l,c){Error.call(this),this.name="YAMLException",this.reason=l,this.mark=c,this.message=T0t(this,!1),Error.captureStackTrace?Error.captureStackTrace(this,this.constructor):this.stack=new Error().stack||""}xW.prototype=Object.create(Error.prototype);xW.prototype.constructor=xW;xW.prototype.toString=function(c){return this.name+": "+T0t(this,c)};var fv=xW;function YIe(l,c,f,y,b){var A="",g="",p=Math.floor(b/2)-1;return y-c>p&&(A=" ... ",c=y-p+A.length),f-y>p&&(g=" ...",f=y+p-g.length),{str:A+l.slice(c,f).replace(/\t/g,"\u2192")+g,pos:y-c+A.length}}function KIe(l,c){return kg.repeat(" ",c-l.length)+l}function A1r(l,c){if(c=Object.create(c||null),!l.buffer)return null;c.maxLength||(c.maxLength=79),typeof c.indent!="number"&&(c.indent=1),typeof c.linesBefore!="number"&&(c.linesBefore=3),typeof c.linesAfter!="number"&&(c.linesAfter=2);for(var f=/\r?\n|\r|\0/g,y=[0],b=[],A,g=-1;A=f.exec(l.buffer);)b.push(A.index),y.push(A.index+A[0].length),l.position<=A.index&&g<0&&(g=y.length-2);g<0&&(g=y.length-1);var p="",k,j,se=Math.min(l.line+c.linesAfter,b.length).toString().length,ze=c.maxLength-(c.indent+se+3);for(k=1;k<=c.linesBefore&&!(g-k<0);k++)j=YIe(l.buffer,y[g-k],b[g-k],l.position-(y[g]-y[g-k]),ze),p=kg.repeat(" ",c.indent)+KIe((l.line-k+1).toString(),se)+" | "+j.str+`
`+p;for(j=YIe(l.buffer,y[g],b[g],l.position,ze),p+=kg.repeat(" ",c.indent)+KIe((l.line+1).toString(),se)+" | "+j.str+`
`,p+=kg.repeat("-",c.indent+se+3+j.pos)+`^
`,k=1;k<=c.linesAfter&&!(g+k>=b.length);k++)j=YIe(l.buffer,y[g+k],b[g+k],l.position-(y[g]-y[g+k]),ze),p+=kg.repeat(" ",c.indent)+KIe((l.line+k+1).toString(),se)+" | "+j.str+`
`;return p.replace(/\n$/,"")}var k1r=A1r,P1r=["kind","multi","resolve","construct","instanceOf","predicate","represent","representName","defaultStyle","styleAliases"],N1r=["scalar","sequence","mapping"];function D1r(l){var c={};return l!==null&&Object.keys(l).forEach(function(f){l[f].forEach(function(y){c[String(y)]=f})}),c}function w1r(l,c){if(c=c||{},Object.keys(c).forEach(function(f){if(P1r.indexOf(f)===-1)throw new fv('Unknown option "'+f+'" is met in definition of "'+l+'" YAML type.')}),this.options=c,this.tag=l,this.kind=c.kind||null,this.resolve=c.resolve||function(){return!0},this.construct=c.construct||function(f){return f},this.instanceOf=c.instanceOf||null,this.predicate=c.predicate||null,this.represent=c.represent||null,this.representName=c.representName||null,this.defaultStyle=c.defaultStyle||null,this.multi=c.multi||!1,this.styleAliases=D1r(c.styleAliases||null),N1r.indexOf(this.kind)===-1)throw new fv('Unknown kind "'+this.kind+'" is specified for "'+l+'" YAML type.')}var yy=w1r;function a0t(l,c){var f=[];return l[c].forEach(function(y){var b=f.length;f.forEach(function(A,g){A.tag===y.tag&&A.kind===y.kind&&A.multi===y.multi&&(b=g)}),f[b]=y}),f}function I1r(){var l={scalar:{},sequence:{},mapping:{},fallback:{},multi:{scalar:[],sequence:[],mapping:[],fallback:[]}},c,f;function y(b){b.multi?(l.multi[b.kind].push(b),l.multi.fallback.push(b)):l[b.kind][b.tag]=l.fallback[b.tag]=b}for(c=0,f=arguments.length;c<f;c+=1)arguments[c].forEach(y);return l}function QIe(l){return this.extend(l)}QIe.prototype.extend=function(c){var f=[],y=[];if(c instanceof yy)y.push(c);else if(Array.isArray(c))y=y.concat(c);else if(c&&(Array.isArray(c.implicit)||Array.isArray(c.explicit)))c.implicit&&(f=f.concat(c.implicit)),c.explicit&&(y=y.concat(c.explicit));else throw new fv("Schema.extend argument should be a Type, [ Type ], or a schema definition ({ implicit: [...], explicit: [...] })");f.forEach(function(A){if(!(A instanceof yy))throw new fv("Specified list of YAML types (or a single Type object) contains a non-Type object.");if(A.loadKind&&A.loadKind!=="scalar")throw new fv("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.");if(A.multi)throw new fv("There is a multi type in the implicit list of a schema. Multi tags can only be listed as explicit.")}),y.forEach(function(A){if(!(A instanceof yy))throw new fv("Specified list of YAML types (or a single Type object) contains a non-Type object.")});var b=Object.create(QIe.prototype);return b.implicit=(this.implicit||[]).concat(f),b.explicit=(this.explicit||[]).concat(y),b.compiledImplicit=a0t(b,"implicit"),b.compiledExplicit=a0t(b,"explicit"),b.compiledTypeMap=I1r(b.compiledImplicit,b.compiledExplicit),b};var E0t=QIe,x0t=new yy("tag:yaml.org,2002:str",{kind:"scalar",construct:function(l){return l!==null?l:""}}),C0t=new yy("tag:yaml.org,2002:seq",{kind:"sequence",construct:function(l){return l!==null?l:[]}}),A0t=new yy("tag:yaml.org,2002:map",{kind:"mapping",construct:function(l){return l!==null?l:{}}}),k0t=new E0t({explicit:[x0t,C0t,A0t]});function O1r(l){if(l===null)return!0;var c=l.length;return c===1&&l==="~"||c===4&&(l==="null"||l==="Null"||l==="NULL")}function R1r(){return null}function M1r(l){return l===null}var P0t=new yy("tag:yaml.org,2002:null",{kind:"scalar",resolve:O1r,construct:R1r,predicate:M1r,represent:{canonical:function(){return"~"},lowercase:function(){return"null"},uppercase:function(){return"NULL"},camelcase:function(){return"Null"},empty:function(){return""}},defaultStyle:"lowercase"});function L1r(l){if(l===null)return!1;var c=l.length;return c===4&&(l==="true"||l==="True"||l==="TRUE")||c===5&&(l==="false"||l==="False"||l==="FALSE")}function F1r(l){return l==="true"||l==="True"||l==="TRUE"}function j1r(l){return Object.prototype.toString.call(l)==="[object Boolean]"}var N0t=new yy("tag:yaml.org,2002:bool",{kind:"scalar",resolve:L1r,construct:F1r,predicate:j1r,represent:{lowercase:function(l){return l?"true":"false"},uppercase:function(l){return l?"TRUE":"FALSE"},camelcase:function(l){return l?"True":"False"}},defaultStyle:"lowercase"});function B1r(l){return 48<=l&&l<=57||65<=l&&l<=70||97<=l&&l<=102}function U1r(l){return 48<=l&&l<=55}function V1r(l){return 48<=l&&l<=57}function J1r(l){if(l===null)return!1;var c=l.length,f=0,y=!1,b;if(!c)return!1;if(b=l[f],(b==="-"||b==="+")&&(b=l[++f]),b==="0"){if(f+1===c)return!0;if(b=l[++f],b==="b"){for(f++;f<c;f++)if(b=l[f],b!=="_"){if(b!=="0"&&b!=="1")return!1;y=!0}return y&&b!=="_"}if(b==="x"){for(f++;f<c;f++)if(b=l[f],b!=="_"){if(!B1r(l.charCodeAt(f)))return!1;y=!0}return y&&b!=="_"}if(b==="o"){for(f++;f<c;f++)if(b=l[f],b!=="_"){if(!U1r(l.charCodeAt(f)))return!1;y=!0}return y&&b!=="_"}}if(b==="_")return!1;for(;f<c;f++)if(b=l[f],b!=="_"){if(!V1r(l.charCodeAt(f)))return!1;y=!0}return!(!y||b==="_")}function q1r(l){var c=l,f=1,y;if(c.indexOf("_")!==-1&&(c=c.replace(/_/g,"")),y=c[0],(y==="-"||y==="+")&&(y==="-"&&(f=-1),c=c.slice(1),y=c[0]),c==="0")return 0;if(y==="0"){if(c[1]==="b")return f*parseInt(c.slice(2),2);if(c[1]==="x")return f*parseInt(c.slice(2),16);if(c[1]==="o")return f*parseInt(c.slice(2),8)}return f*parseInt(c,10)}function z1r(l){return Object.prototype.toString.call(l)==="[object Number]"&&l%1===0&&!kg.isNegativeZero(l)}var D0t=new yy("tag:yaml.org,2002:int",{kind:"scalar",resolve:J1r,construct:q1r,predicate:z1r,represent:{binary:function(l){return l>=0?"0b"+l.toString(2):"-0b"+l.toString(2).slice(1)},octal:function(l){return l>=0?"0o"+l.toString(8):"-0o"+l.toString(8).slice(1)},decimal:function(l){return l.toString(10)},hexadecimal:function(l){return l>=0?"0x"+l.toString(16).toUpperCase():"-0x"+l.toString(16).toUpperCase().slice(1)}},defaultStyle:"decimal",styleAliases:{binary:[2,"bin"],octal:[8,"oct"],decimal:[10,"dec"],hexadecimal:[16,"hex"]}}),W1r=new RegExp("^(?:[-+]?(?:[0-9][0-9_]*)(?:\\.[0-9_]*)?(?:[eE][-+]?[0-9]+)?|\\.[0-9_]+(?:[eE][-+]?[0-9]+)?|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$");function $1r(l){return!(l===null||!W1r.test(l)||l[l.length-1]==="_")}function H1r(l){var c,f;return c=l.replace(/_/g,"").toLowerCase(),f=c[0]==="-"?-1:1,"+-".indexOf(c[0])>=0&&(c=c.slice(1)),c===".inf"?f===1?Number.POSITIVE_INFINITY:Number.NEGATIVE_INFINITY:c===".nan"?NaN:f*parseFloat(c,10)}var G1r=/^[-+]?[0-9]+e/;function Y1r(l,c){var f;if(isNaN(l))switch(c){case"lowercase":return".nan";case"uppercase":return".NAN";case"camelcase":return".NaN"}else if(Number.POSITIVE_INFINITY===l)switch(c){case"lowercase":return".inf";case"uppercase":return".INF";case"camelcase":return".Inf"}else if(Number.NEGATIVE_INFINITY===l)switch(c){case"lowercase":return"-.inf";case"uppercase":return"-.INF";case"camelcase":return"-.Inf"}else if(kg.isNegativeZero(l))return"-0.0";return f=l.toString(10),G1r.test(f)?f.replace("e",".e"):f}function K1r(l){return Object.prototype.toString.call(l)==="[object Number]"&&(l%1!==0||kg.isNegativeZero(l))}var w0t=new yy("tag:yaml.org,2002:float",{kind:"scalar",resolve:$1r,construct:H1r,predicate:K1r,represent:Y1r,defaultStyle:"lowercase"}),I0t=k0t.extend({implicit:[P0t,N0t,D0t,w0t]}),O0t=I0t,R0t=new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9])-([0-9][0-9])$"),M0t=new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?$");function X1r(l){return l===null?!1:R0t.exec(l)!==null||M0t.exec(l)!==null}function Q1r(l){var c,f,y,b,A,g,p,k=0,j=null,se,ze,ve;if(c=R0t.exec(l),c===null&&(c=M0t.exec(l)),c===null)throw new Error("Date resolve error");if(f=+c[1],y=+c[2]-1,b=+c[3],!c[4])return new Date(Date.UTC(f,y,b));if(A=+c[4],g=+c[5],p=+c[6],c[7]){for(k=c[7].slice(0,3);k.length<3;)k+="0";k=+k}return c[9]&&(se=+c[10],ze=+(c[11]||0),j=(se*60+ze)*6e4,c[9]==="-"&&(j=-j)),ve=new Date(Date.UTC(f,y,b,A,g,p,k)),j&&ve.setTime(ve.getTime()-j),ve}function Z1r(l){return l.toISOString()}var L0t=new yy("tag:yaml.org,2002:timestamp",{kind:"scalar",resolve:X1r,construct:Q1r,instanceOf:Date,represent:Z1r});function eSr(l){return l==="<<"||l===null}var F0t=new yy("tag:yaml.org,2002:merge",{kind:"scalar",resolve:eSr}),nOe=`ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=
\r`;function tSr(l){if(l===null)return!1;var c,f,y=0,b=l.length,A=nOe;for(f=0;f<b;f++)if(c=A.indexOf(l.charAt(f)),!(c>64)){if(c<0)return!1;y+=6}return y%8===0}function rSr(l){var c,f,y=l.replace(/[\r\n=]/g,""),b=y.length,A=nOe,g=0,p=[];for(c=0;c<b;c++)c%4===0&&c&&(p.push(g>>16&255),p.push(g>>8&255),p.push(g&255)),g=g<<6|A.indexOf(y.charAt(c));return f=b%4*6,f===0?(p.push(g>>16&255),p.push(g>>8&255),p.push(g&255)):f===18?(p.push(g>>10&255),p.push(g>>2&255)):f===12&&p.push(g>>4&255),new Uint8Array(p)}function nSr(l){var c="",f=0,y,b,A=l.length,g=nOe;for(y=0;y<A;y++)y%3===0&&y&&(c+=g[f>>18&63],c+=g[f>>12&63],c+=g[f>>6&63],c+=g[f&63]),f=(f<<8)+l[y];return b=A%3,b===0?(c+=g[f>>18&63],c+=g[f>>12&63],c+=g[f>>6&63],c+=g[f&63]):b===2?(c+=g[f>>10&63],c+=g[f>>4&63],c+=g[f<<2&63],c+=g[64]):b===1&&(c+=g[f>>2&63],c+=g[f<<4&63],c+=g[64],c+=g[64]),c}function iSr(l){return Object.prototype.toString.call(l)==="[object Uint8Array]"}var j0t=new yy("tag:yaml.org,2002:binary",{kind:"scalar",resolve:tSr,construct:rSr,predicate:iSr,represent:nSr}),sSr=Object.prototype.hasOwnProperty,aSr=Object.prototype.toString;function oSr(l){if(l===null)return!0;var c=[],f,y,b,A,g,p=l;for(f=0,y=p.length;f<y;f+=1){if(b=p[f],g=!1,aSr.call(b)!=="[object Object]")return!1;for(A in b)if(sSr.call(b,A))if(!g)g=!0;else return!1;if(!g)return!1;if(c.indexOf(A)===-1)c.push(A);else return!1}return!0}function cSr(l){return l!==null?l:[]}var B0t=new yy("tag:yaml.org,2002:omap",{kind:"sequence",resolve:oSr,construct:cSr}),lSr=Object.prototype.toString;function uSr(l){if(l===null)return!0;var c,f,y,b,A,g=l;for(A=new Array(g.length),c=0,f=g.length;c<f;c+=1){if(y=g[c],lSr.call(y)!=="[object Object]"||(b=Object.keys(y),b.length!==1))return!1;A[c]=[b[0],y[b[0]]]}return!0}function _Sr(l){if(l===null)return[];var c,f,y,b,A,g=l;for(A=new Array(g.length),c=0,f=g.length;c<f;c+=1)y=g[c],b=Object.keys(y),A[c]=[b[0],y[b[0]]];return A}var U0t=new yy("tag:yaml.org,2002:pairs",{kind:"sequence",resolve:uSr,construct:_Sr}),fSr=Object.prototype.hasOwnProperty;function pSr(l){if(l===null)return!0;var c,f=l;for(c in f)if(fSr.call(f,c)&&f[c]!==null)return!1;return!0}function dSr(l){return l!==null?l:{}}var V0t=new yy("tag:yaml.org,2002:set",{kind:"mapping",resolve:pSr,construct:dSr}),iOe=O0t.extend({implicit:[L0t,F0t],explicit:[j0t,B0t,U0t,V0t]}),Vw=Object.prototype.hasOwnProperty,Nce=1,J0t=2,q0t=3,Dce=4,XIe=1,mSr=2,o0t=3,gSr=/[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/,hSr=/[\x85\u2028\u2029]/,ySr=/[,\[\]\{\}]/,z0t=/^(?:!|!!|![a-z\-]+!)$/i,W0t=/^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i;function c0t(l){return Object.prototype.toString.call(l)}function LC(l){return l===10||l===13}function o3(l){return l===9||l===32}function D1(l){return l===9||l===32||l===10||l===13}function HF(l){return l===44||l===91||l===93||l===123||l===125}function vSr(l){var c;return 48<=l&&l<=57?l-48:(c=l|32,97<=c&&c<=102?c-97+10:-1)}function SSr(l){return l===120?2:l===117?4:l===85?8:0}function bSr(l){return 48<=l&&l<=57?l-48:-1}function l0t(l){return l===48?"\0":l===97?"\x07":l===98?"\b":l===116||l===9?"	":l===110?`
`:l===118?"\v":l===102?"\f":l===114?"\r":l===101?"\x1B":l===32?" ":l===34?'"':l===47?"/":l===92?"\\":l===78?"\x85":l===95?"\xA0":l===76?"\u2028":l===80?"\u2029":""}function TSr(l){return l<=65535?String.fromCharCode(l):String.fromCharCode((l-65536>>10)+55296,(l-65536&1023)+56320)}var $0t=new Array(256),H0t=new Array(256);for(a3=0;a3<256;a3++)$0t[a3]=l0t(a3)?1:0,H0t[a3]=l0t(a3);var a3;function ESr(l,c){this.input=l,this.filename=c.filename||null,this.schema=c.schema||iOe,this.onWarning=c.onWarning||null,this.legacy=c.legacy||!1,this.json=c.json||!1,this.listener=c.listener||null,this.implicitTypes=this.schema.compiledImplicit,this.typeMap=this.schema.compiledTypeMap,this.length=l.length,this.position=0,this.line=0,this.lineStart=0,this.lineIndent=0,this.firstTabInLine=-1,this.documents=[]}function G0t(l,c){var f={name:l.filename,buffer:l.input.slice(0,-1),position:l.position,line:l.line,column:l.position-l.lineStart};return f.snippet=k1r(f),new fv(c,f)}function jo(l,c){throw G0t(l,c)}function wce(l,c){l.onWarning&&l.onWarning.call(null,G0t(l,c))}var u0t={YAML:function(c,f,y){var b,A,g;c.version!==null&&jo(c,"duplication of %YAML directive"),y.length!==1&&jo(c,"YAML directive accepts exactly one argument"),b=/^([0-9]+)\.([0-9]+)$/.exec(y[0]),b===null&&jo(c,"ill-formed argument of the YAML directive"),A=parseInt(b[1],10),g=parseInt(b[2],10),A!==1&&jo(c,"unacceptable YAML version of the document"),c.version=y[0],c.checkLineBreaks=g<2,g!==1&&g!==2&&wce(c,"unsupported YAML version of the document")},TAG:function(c,f,y){var b,A;y.length!==2&&jo(c,"TAG directive accepts exactly two arguments"),b=y[0],A=y[1],z0t.test(b)||jo(c,"ill-formed tag handle (first argument) of the TAG directive"),Vw.call(c.tagMap,b)&&jo(c,'there is a previously declared suffix for "'+b+'" tag handle'),W0t.test(A)||jo(c,"ill-formed tag prefix (second argument) of the TAG directive");try{A=decodeURIComponent(A)}catch{jo(c,"tag prefix is malformed: "+A)}c.tagMap[b]=A}};function Uw(l,c,f,y){var b,A,g,p;if(c<f){if(p=l.input.slice(c,f),y)for(b=0,A=p.length;b<A;b+=1)g=p.charCodeAt(b),g===9||32<=g&&g<=1114111||jo(l,"expected valid JSON character");else gSr.test(p)&&jo(l,"the stream contains non-printable characters");l.result+=p}}function _0t(l,c,f,y){var b,A,g,p;for(kg.isObject(f)||jo(l,"cannot merge mappings; the provided source object is unacceptable"),b=Object.keys(f),g=0,p=b.length;g<p;g+=1)A=b[g],Vw.call(c,A)||(c[A]=f[A],y[A]=!0)}function GF(l,c,f,y,b,A,g,p,k){var j,se;if(Array.isArray(b))for(b=Array.prototype.slice.call(b),j=0,se=b.length;j<se;j+=1)Array.isArray(b[j])&&jo(l,"nested arrays are not supported inside keys"),typeof b=="object"&&c0t(b[j])==="[object Object]"&&(b[j]="[object Object]");if(typeof b=="object"&&c0t(b)==="[object Object]"&&(b="[object Object]"),b=String(b),c===null&&(c={}),y==="tag:yaml.org,2002:merge")if(Array.isArray(A))for(j=0,se=A.length;j<se;j+=1)_0t(l,c,A[j],f);else _0t(l,c,A,f);else!l.json&&!Vw.call(f,b)&&Vw.call(c,b)&&(l.line=g||l.line,l.lineStart=p||l.lineStart,l.position=k||l.position,jo(l,"duplicated mapping key")),b==="__proto__"?Object.defineProperty(c,b,{configurable:!0,enumerable:!0,writable:!0,value:A}):c[b]=A,delete f[b];return c}function sOe(l){var c;c=l.input.charCodeAt(l.position),c===10?l.position++:c===13?(l.position++,l.input.charCodeAt(l.position)===10&&l.position++):jo(l,"a line break is expected"),l.line+=1,l.lineStart=l.position,l.firstTabInLine=-1}function Gm(l,c,f){for(var y=0,b=l.input.charCodeAt(l.position);b!==0;){for(;o3(b);)b===9&&l.firstTabInLine===-1&&(l.firstTabInLine=l.position),b=l.input.charCodeAt(++l.position);if(c&&b===35)do b=l.input.charCodeAt(++l.position);while(b!==10&&b!==13&&b!==0);if(LC(b))for(sOe(l),b=l.input.charCodeAt(l.position),y++,l.lineIndent=0;b===32;)l.lineIndent++,b=l.input.charCodeAt(++l.position);else break}return f!==-1&&y!==0&&l.lineIndent<f&&wce(l,"deficient indentation"),y}function Rce(l){var c=l.position,f;return f=l.input.charCodeAt(c),!!((f===45||f===46)&&f===l.input.charCodeAt(c+1)&&f===l.input.charCodeAt(c+2)&&(c+=3,f=l.input.charCodeAt(c),f===0||D1(f)))}function aOe(l,c){c===1?l.result+=" ":c>1&&(l.result+=kg.repeat(`
`,c-1))}function xSr(l,c,f){var y,b,A,g,p,k,j,se,ze=l.kind,ve=l.result,lr;if(lr=l.input.charCodeAt(l.position),D1(lr)||HF(lr)||lr===35||lr===38||lr===42||lr===33||lr===124||lr===62||lr===39||lr===34||lr===37||lr===64||lr===96||(lr===63||lr===45)&&(b=l.input.charCodeAt(l.position+1),D1(b)||f&&HF(b)))return!1;for(l.kind="scalar",l.result="",A=g=l.position,p=!1;lr!==0;){if(lr===58){if(b=l.input.charCodeAt(l.position+1),D1(b)||f&&HF(b))break}else if(lr===35){if(y=l.input.charCodeAt(l.position-1),D1(y))break}else{if(l.position===l.lineStart&&Rce(l)||f&&HF(lr))break;if(LC(lr))if(k=l.line,j=l.lineStart,se=l.lineIndent,Gm(l,!1,-1),l.lineIndent>=c){p=!0,lr=l.input.charCodeAt(l.position);continue}else{l.position=g,l.line=k,l.lineStart=j,l.lineIndent=se;break}}p&&(Uw(l,A,g,!1),aOe(l,l.line-k),A=g=l.position,p=!1),o3(lr)||(g=l.position+1),lr=l.input.charCodeAt(++l.position)}return Uw(l,A,g,!1),l.result?!0:(l.kind=ze,l.result=ve,!1)}function CSr(l,c){var f,y,b;if(f=l.input.charCodeAt(l.position),f!==39)return!1;for(l.kind="scalar",l.result="",l.position++,y=b=l.position;(f=l.input.charCodeAt(l.position))!==0;)if(f===39)if(Uw(l,y,l.position,!0),f=l.input.charCodeAt(++l.position),f===39)y=l.position,l.position++,b=l.position;else return!0;else LC(f)?(Uw(l,y,b,!0),aOe(l,Gm(l,!1,c)),y=b=l.position):l.position===l.lineStart&&Rce(l)?jo(l,"unexpected end of the document within a single quoted scalar"):(l.position++,b=l.position);jo(l,"unexpected end of the stream within a single quoted scalar")}function ASr(l,c){var f,y,b,A,g,p;if(p=l.input.charCodeAt(l.position),p!==34)return!1;for(l.kind="scalar",l.result="",l.position++,f=y=l.position;(p=l.input.charCodeAt(l.position))!==0;){if(p===34)return Uw(l,f,l.position,!0),l.position++,!0;if(p===92){if(Uw(l,f,l.position,!0),p=l.input.charCodeAt(++l.position),LC(p))Gm(l,!1,c);else if(p<256&&$0t[p])l.result+=H0t[p],l.position++;else if((g=SSr(p))>0){for(b=g,A=0;b>0;b--)p=l.input.charCodeAt(++l.position),(g=vSr(p))>=0?A=(A<<4)+g:jo(l,"expected hexadecimal character");l.result+=TSr(A),l.position++}else jo(l,"unknown escape sequence");f=y=l.position}else LC(p)?(Uw(l,f,y,!0),aOe(l,Gm(l,!1,c)),f=y=l.position):l.position===l.lineStart&&Rce(l)?jo(l,"unexpected end of the document within a double quoted scalar"):(l.position++,y=l.position)}jo(l,"unexpected end of the stream within a double quoted scalar")}function kSr(l,c){var f=!0,y,b,A,g=l.tag,p,k=l.anchor,j,se,ze,ve,lr,Br=Object.create(null),wt,kt,Fi,yi;if(yi=l.input.charCodeAt(l.position),yi===91)se=93,lr=!1,p=[];else if(yi===123)se=125,lr=!0,p={};else return!1;for(l.anchor!==null&&(l.anchorMap[l.anchor]=p),yi=l.input.charCodeAt(++l.position);yi!==0;){if(Gm(l,!0,c),yi=l.input.charCodeAt(l.position),yi===se)return l.position++,l.tag=g,l.anchor=k,l.kind=lr?"mapping":"sequence",l.result=p,!0;f?yi===44&&jo(l,"expected the node content, but found ','"):jo(l,"missed comma between flow collection entries"),kt=wt=Fi=null,ze=ve=!1,yi===63&&(j=l.input.charCodeAt(l.position+1),D1(j)&&(ze=ve=!0,l.position++,Gm(l,!0,c))),y=l.line,b=l.lineStart,A=l.position,YF(l,c,Nce,!1,!0),kt=l.tag,wt=l.result,Gm(l,!0,c),yi=l.input.charCodeAt(l.position),(ve||l.line===y)&&yi===58&&(ze=!0,yi=l.input.charCodeAt(++l.position),Gm(l,!0,c),YF(l,c,Nce,!1,!0),Fi=l.result),lr?GF(l,p,Br,kt,wt,Fi,y,b,A):ze?p.push(GF(l,null,Br,kt,wt,Fi,y,b,A)):p.push(wt),Gm(l,!0,c),yi=l.input.charCodeAt(l.position),yi===44?(f=!0,yi=l.input.charCodeAt(++l.position)):f=!1}jo(l,"unexpected end of the stream within a flow collection")}function PSr(l,c){var f,y,b=XIe,A=!1,g=!1,p=c,k=0,j=!1,se,ze;if(ze=l.input.charCodeAt(l.position),ze===124)y=!1;else if(ze===62)y=!0;else return!1;for(l.kind="scalar",l.result="";ze!==0;)if(ze=l.input.charCodeAt(++l.position),ze===43||ze===45)XIe===b?b=ze===43?o0t:mSr:jo(l,"repeat of a chomping mode identifier");else if((se=bSr(ze))>=0)se===0?jo(l,"bad explicit indentation width of a block scalar; it cannot be less than one"):g?jo(l,"repeat of an indentation width identifier"):(p=c+se-1,g=!0);else break;if(o3(ze)){do ze=l.input.charCodeAt(++l.position);while(o3(ze));if(ze===35)do ze=l.input.charCodeAt(++l.position);while(!LC(ze)&&ze!==0)}for(;ze!==0;){for(sOe(l),l.lineIndent=0,ze=l.input.charCodeAt(l.position);(!g||l.lineIndent<p)&&ze===32;)l.lineIndent++,ze=l.input.charCodeAt(++l.position);if(!g&&l.lineIndent>p&&(p=l.lineIndent),LC(ze)){k++;continue}if(l.lineIndent<p){b===o0t?l.result+=kg.repeat(`
`,A?1+k:k):b===XIe&&A&&(l.result+=`
`);break}for(y?o3(ze)?(j=!0,l.result+=kg.repeat(`
`,A?1+k:k)):j?(j=!1,l.result+=kg.repeat(`
`,k+1)):k===0?A&&(l.result+=" "):l.result+=kg.repeat(`
`,k):l.result+=kg.repeat(`
`,A?1+k:k),A=!0,g=!0,k=0,f=l.position;!LC(ze)&&ze!==0;)ze=l.input.charCodeAt(++l.position);Uw(l,f,l.position,!1)}return!0}function f0t(l,c){var f,y=l.tag,b=l.anchor,A=[],g,p=!1,k;if(l.firstTabInLine!==-1)return!1;for(l.anchor!==null&&(l.anchorMap[l.anchor]=A),k=l.input.charCodeAt(l.position);k!==0&&(l.firstTabInLine!==-1&&(l.position=l.firstTabInLine,jo(l,"tab characters must not be used in indentation")),!(k!==45||(g=l.input.charCodeAt(l.position+1),!D1(g))));){if(p=!0,l.position++,Gm(l,!0,-1)&&l.lineIndent<=c){A.push(null),k=l.input.charCodeAt(l.position);continue}if(f=l.line,YF(l,c,q0t,!1,!0),A.push(l.result),Gm(l,!0,-1),k=l.input.charCodeAt(l.position),(l.line===f||l.lineIndent>c)&&k!==0)jo(l,"bad indentation of a sequence entry");else if(l.lineIndent<c)break}return p?(l.tag=y,l.anchor=b,l.kind="sequence",l.result=A,!0):!1}function NSr(l,c,f){var y,b,A,g,p,k,j=l.tag,se=l.anchor,ze={},ve=Object.create(null),lr=null,Br=null,wt=null,kt=!1,Fi=!1,yi;if(l.firstTabInLine!==-1)return!1;for(l.anchor!==null&&(l.anchorMap[l.anchor]=ze),yi=l.input.charCodeAt(l.position);yi!==0;){if(!kt&&l.firstTabInLine!==-1&&(l.position=l.firstTabInLine,jo(l,"tab characters must not be used in indentation")),y=l.input.charCodeAt(l.position+1),A=l.line,(yi===63||yi===58)&&D1(y))yi===63?(kt&&(GF(l,ze,ve,lr,Br,null,g,p,k),lr=Br=wt=null),Fi=!0,kt=!0,b=!0):kt?(kt=!1,b=!0):jo(l,"incomplete explicit mapping pair; a key node is missed; or followed by a non-tabulated empty line"),l.position+=1,yi=y;else{if(g=l.line,p=l.lineStart,k=l.position,!YF(l,f,J0t,!1,!0))break;if(l.line===A){for(yi=l.input.charCodeAt(l.position);o3(yi);)yi=l.input.charCodeAt(++l.position);if(yi===58)yi=l.input.charCodeAt(++l.position),D1(yi)||jo(l,"a whitespace character is expected after the key-value separator within a block mapping"),kt&&(GF(l,ze,ve,lr,Br,null,g,p,k),lr=Br=wt=null),Fi=!0,kt=!1,b=!1,lr=l.tag,Br=l.result;else if(Fi)jo(l,"can not read an implicit mapping pair; a colon is missed");else return l.tag=j,l.anchor=se,!0}else if(Fi)jo(l,"can not read a block mapping entry; a multiline key may not be an implicit key");else return l.tag=j,l.anchor=se,!0}if((l.line===A||l.lineIndent>c)&&(kt&&(g=l.line,p=l.lineStart,k=l.position),YF(l,c,Dce,!0,b)&&(kt?Br=l.result:wt=l.result),kt||(GF(l,ze,ve,lr,Br,wt,g,p,k),lr=Br=wt=null),Gm(l,!0,-1),yi=l.input.charCodeAt(l.position)),(l.line===A||l.lineIndent>c)&&yi!==0)jo(l,"bad indentation of a mapping entry");else if(l.lineIndent<c)break}return kt&&GF(l,ze,ve,lr,Br,null,g,p,k),Fi&&(l.tag=j,l.anchor=se,l.kind="mapping",l.result=ze),Fi}function DSr(l){var c,f=!1,y=!1,b,A,g;if(g=l.input.charCodeAt(l.position),g!==33)return!1;if(l.tag!==null&&jo(l,"duplication of a tag property"),g=l.input.charCodeAt(++l.position),g===60?(f=!0,g=l.input.charCodeAt(++l.position)):g===33?(y=!0,b="!!",g=l.input.charCodeAt(++l.position)):b="!",c=l.position,f){do g=l.input.charCodeAt(++l.position);while(g!==0&&g!==62);l.position<l.length?(A=l.input.slice(c,l.position),g=l.input.charCodeAt(++l.position)):jo(l,"unexpected end of the stream within a verbatim tag")}else{for(;g!==0&&!D1(g);)g===33&&(y?jo(l,"tag suffix cannot contain exclamation marks"):(b=l.input.slice(c-1,l.position+1),z0t.test(b)||jo(l,"named tag handle cannot contain such characters"),y=!0,c=l.position+1)),g=l.input.charCodeAt(++l.position);A=l.input.slice(c,l.position),ySr.test(A)&&jo(l,"tag suffix cannot contain flow indicator characters")}A&&!W0t.test(A)&&jo(l,"tag name cannot contain such characters: "+A);try{A=decodeURIComponent(A)}catch{jo(l,"tag name is malformed: "+A)}return f?l.tag=A:Vw.call(l.tagMap,b)?l.tag=l.tagMap[b]+A:b==="!"?l.tag="!"+A:b==="!!"?l.tag="tag:yaml.org,2002:"+A:jo(l,'undeclared tag handle "'+b+'"'),!0}function wSr(l){var c,f;if(f=l.input.charCodeAt(l.position),f!==38)return!1;for(l.anchor!==null&&jo(l,"duplication of an anchor property"),f=l.input.charCodeAt(++l.position),c=l.position;f!==0&&!D1(f)&&!HF(f);)f=l.input.charCodeAt(++l.position);return l.position===c&&jo(l,"name of an anchor node must contain at least one character"),l.anchor=l.input.slice(c,l.position),!0}function ISr(l){var c,f,y;if(y=l.input.charCodeAt(l.position),y!==42)return!1;for(y=l.input.charCodeAt(++l.position),c=l.position;y!==0&&!D1(y)&&!HF(y);)y=l.input.charCodeAt(++l.position);return l.position===c&&jo(l,"name of an alias node must contain at least one character"),f=l.input.slice(c,l.position),Vw.call(l.anchorMap,f)||jo(l,'unidentified alias "'+f+'"'),l.result=l.anchorMap[f],Gm(l,!0,-1),!0}function YF(l,c,f,y,b){var A,g,p,k=1,j=!1,se=!1,ze,ve,lr,Br,wt,kt;if(l.listener!==null&&l.listener("open",l),l.tag=null,l.anchor=null,l.kind=null,l.result=null,A=g=p=Dce===f||q0t===f,y&&Gm(l,!0,-1)&&(j=!0,l.lineIndent>c?k=1:l.lineIndent===c?k=0:l.lineIndent<c&&(k=-1)),k===1)for(;DSr(l)||wSr(l);)Gm(l,!0,-1)?(j=!0,p=A,l.lineIndent>c?k=1:l.lineIndent===c?k=0:l.lineIndent<c&&(k=-1)):p=!1;if(p&&(p=j||b),(k===1||Dce===f)&&(Nce===f||J0t===f?wt=c:wt=c+1,kt=l.position-l.lineStart,k===1?p&&(f0t(l,kt)||NSr(l,kt,wt))||kSr(l,wt)?se=!0:(g&&PSr(l,wt)||CSr(l,wt)||ASr(l,wt)?se=!0:ISr(l)?(se=!0,(l.tag!==null||l.anchor!==null)&&jo(l,"alias node should not have any properties")):xSr(l,wt,Nce===f)&&(se=!0,l.tag===null&&(l.tag="?")),l.anchor!==null&&(l.anchorMap[l.anchor]=l.result)):k===0&&(se=p&&f0t(l,kt))),l.tag===null)l.anchor!==null&&(l.anchorMap[l.anchor]=l.result);else if(l.tag==="?"){for(l.result!==null&&l.kind!=="scalar"&&jo(l,'unacceptable node kind for !<?> tag; it should be "scalar", not "'+l.kind+'"'),ze=0,ve=l.implicitTypes.length;ze<ve;ze+=1)if(Br=l.implicitTypes[ze],Br.resolve(l.result)){l.result=Br.construct(l.result),l.tag=Br.tag,l.anchor!==null&&(l.anchorMap[l.anchor]=l.result);break}}else if(l.tag!=="!"){if(Vw.call(l.typeMap[l.kind||"fallback"],l.tag))Br=l.typeMap[l.kind||"fallback"][l.tag];else for(Br=null,lr=l.typeMap.multi[l.kind||"fallback"],ze=0,ve=lr.length;ze<ve;ze+=1)if(l.tag.slice(0,lr[ze].tag.length)===lr[ze].tag){Br=lr[ze];break}Br||jo(l,"unknown tag !<"+l.tag+">"),l.result!==null&&Br.kind!==l.kind&&jo(l,"unacceptable node kind for !<"+l.tag+'> tag; it should be "'+Br.kind+'", not "'+l.kind+'"'),Br.resolve(l.result,l.tag)?(l.result=Br.construct(l.result,l.tag),l.anchor!==null&&(l.anchorMap[l.anchor]=l.result)):jo(l,"cannot resolve a node with !<"+l.tag+"> explicit tag")}return l.listener!==null&&l.listener("close",l),l.tag!==null||l.anchor!==null||se}function OSr(l){var c=l.position,f,y,b,A=!1,g;for(l.version=null,l.checkLineBreaks=l.legacy,l.tagMap=Object.create(null),l.anchorMap=Object.create(null);(g=l.input.charCodeAt(l.position))!==0&&(Gm(l,!0,-1),g=l.input.charCodeAt(l.position),!(l.lineIndent>0||g!==37));){for(A=!0,g=l.input.charCodeAt(++l.position),f=l.position;g!==0&&!D1(g);)g=l.input.charCodeAt(++l.position);for(y=l.input.slice(f,l.position),b=[],y.length<1&&jo(l,"directive name must not be less than one character in length");g!==0;){for(;o3(g);)g=l.input.charCodeAt(++l.position);if(g===35){do g=l.input.charCodeAt(++l.position);while(g!==0&&!LC(g));break}if(LC(g))break;for(f=l.position;g!==0&&!D1(g);)g=l.input.charCodeAt(++l.position);b.push(l.input.slice(f,l.position))}g!==0&&sOe(l),Vw.call(u0t,y)?u0t[y](l,y,b):wce(l,'unknown document directive "'+y+'"')}if(Gm(l,!0,-1),l.lineIndent===0&&l.input.charCodeAt(l.position)===45&&l.input.charCodeAt(l.position+1)===45&&l.input.charCodeAt(l.position+2)===45?(l.position+=3,Gm(l,!0,-1)):A&&jo(l,"directives end mark is expected"),YF(l,l.lineIndent-1,Dce,!1,!0),Gm(l,!0,-1),l.checkLineBreaks&&hSr.test(l.input.slice(c,l.position))&&wce(l,"non-ASCII line breaks are interpreted as content"),l.documents.push(l.result),l.position===l.lineStart&&Rce(l)){l.input.charCodeAt(l.position)===46&&(l.position+=3,Gm(l,!0,-1));return}if(l.position<l.length-1)jo(l,"end of the stream or a document separator is expected");else return}function Y0t(l,c){l=String(l),c=c||{},l.length!==0&&(l.charCodeAt(l.length-1)!==10&&l.charCodeAt(l.length-1)!==13&&(l+=`
`),l.charCodeAt(0)===65279&&(l=l.slice(1)));var f=new ESr(l,c),y=l.indexOf("\0");for(y!==-1&&(f.position=y,jo(f,"null byte is not allowed in input")),f.input+="\0";f.input.charCodeAt(f.position)===32;)f.lineIndent+=1,f.position+=1;for(;f.position<f.length-1;)OSr(f);return f.documents}function RSr(l,c,f){c!==null&&typeof c=="object"&&typeof f>"u"&&(f=c,c=null);var y=Y0t(l,f);if(typeof c!="function")return y;for(var b=0,A=y.length;b<A;b+=1)c(y[b])}function MSr(l,c){var f=Y0t(l,c);if(f.length!==0){if(f.length===1)return f[0];throw new fv("expected a single document in the stream, but found more")}}var LSr=RSr,FSr=MSr,K0t={loadAll:LSr,load:FSr},X0t=Object.prototype.toString,Q0t=Object.prototype.hasOwnProperty,oOe=65279,jSr=9,CW=10,BSr=13,USr=32,VSr=33,JSr=34,ZIe=35,qSr=37,zSr=38,WSr=39,$Sr=42,Z0t=44,HSr=45,Ice=58,GSr=61,YSr=62,KSr=63,XSr=64,evt=91,tvt=93,QSr=96,rvt=123,ZSr=124,nvt=125,c0={};c0[0]="\\0";c0[7]="\\a";c0[8]="\\b";c0[9]="\\t";c0[10]="\\n";c0[11]="\\v";c0[12]="\\f";c0[13]="\\r";c0[27]="\\e";c0[34]='\\"';c0[92]="\\\\";c0[133]="\\N";c0[160]="\\_";c0[8232]="\\L";c0[8233]="\\P";var ebr=["y","Y","yes","Yes","YES","on","On","ON","n","N","no","No","NO","off","Off","OFF"],tbr=/^[-+]?[0-9_]+(?::[0-9_]+)+(?:\.[0-9_]*)?$/;function rbr(l,c){var f,y,b,A,g,p,k;if(c===null)return{};for(f={},y=Object.keys(c),b=0,A=y.length;b<A;b+=1)g=y[b],p=String(c[g]),g.slice(0,2)==="!!"&&(g="tag:yaml.org,2002:"+g.slice(2)),k=l.compiledTypeMap.fallback[g],k&&Q0t.call(k.styleAliases,p)&&(p=k.styleAliases[p]),f[g]=p;return f}function nbr(l){var c,f,y;if(c=l.toString(16).toUpperCase(),l<=255)f="x",y=2;else if(l<=65535)f="u",y=4;else if(l<=4294967295)f="U",y=8;else throw new fv("code point within a string may not be greater than 0xFFFFFFFF");return"\\"+f+kg.repeat("0",y-c.length)+c}var ibr=1,AW=2;function sbr(l){this.schema=l.schema||iOe,this.indent=Math.max(1,l.indent||2),this.noArrayIndent=l.noArrayIndent||!1,this.skipInvalid=l.skipInvalid||!1,this.flowLevel=kg.isNothing(l.flowLevel)?-1:l.flowLevel,this.styleMap=rbr(this.schema,l.styles||null),this.sortKeys=l.sortKeys||!1,this.lineWidth=l.lineWidth||80,this.noRefs=l.noRefs||!1,this.noCompatMode=l.noCompatMode||!1,this.condenseFlow=l.condenseFlow||!1,this.quotingType=l.quotingType==='"'?AW:ibr,this.forceQuotes=l.forceQuotes||!1,this.replacer=typeof l.replacer=="function"?l.replacer:null,this.implicitTypes=this.schema.compiledImplicit,this.explicitTypes=this.schema.compiledExplicit,this.tag=null,this.result="",this.duplicates=[],this.usedDuplicates=null}function p0t(l,c){for(var f=kg.repeat(" ",c),y=0,b=-1,A="",g,p=l.length;y<p;)b=l.indexOf(`
`,y),b===-1?(g=l.slice(y),y=p):(g=l.slice(y,b+1),y=b+1),g.length&&g!==`
`&&(A+=f),A+=g;return A}function eOe(l,c){return`
`+kg.repeat(" ",l.indent*c)}function abr(l,c){var f,y,b;for(f=0,y=l.implicitTypes.length;f<y;f+=1)if(b=l.implicitTypes[f],b.resolve(c))return!0;return!1}function Oce(l){return l===USr||l===jSr}function kW(l){return 32<=l&&l<=126||161<=l&&l<=55295&&l!==8232&&l!==8233||57344<=l&&l<=65533&&l!==oOe||65536<=l&&l<=1114111}function d0t(l){return kW(l)&&l!==oOe&&l!==BSr&&l!==CW}function m0t(l,c,f){var y=d0t(l),b=y&&!Oce(l);return(f?y:y&&l!==Z0t&&l!==evt&&l!==tvt&&l!==rvt&&l!==nvt)&&l!==ZIe&&!(c===Ice&&!b)||d0t(c)&&!Oce(c)&&l===ZIe||c===Ice&&b}function obr(l){return kW(l)&&l!==oOe&&!Oce(l)&&l!==HSr&&l!==KSr&&l!==Ice&&l!==Z0t&&l!==evt&&l!==tvt&&l!==rvt&&l!==nvt&&l!==ZIe&&l!==zSr&&l!==$Sr&&l!==VSr&&l!==ZSr&&l!==GSr&&l!==YSr&&l!==WSr&&l!==JSr&&l!==qSr&&l!==XSr&&l!==QSr}function cbr(l){return!Oce(l)&&l!==Ice}function EW(l,c){var f=l.charCodeAt(c),y;return f>=55296&&f<=56319&&c+1<l.length&&(y=l.charCodeAt(c+1),y>=56320&&y<=57343)?(f-55296)*1024+y-56320+65536:f}function ivt(l){var c=/^\n* /;return c.test(l)}var svt=1,tOe=2,avt=3,ovt=4,$F=5;function lbr(l,c,f,y,b,A,g,p){var k,j=0,se=null,ze=!1,ve=!1,lr=y!==-1,Br=-1,wt=obr(EW(l,0))&&cbr(EW(l,l.length-1));if(c||g)for(k=0;k<l.length;j>=65536?k+=2:k++){if(j=EW(l,k),!kW(j))return $F;wt=wt&&m0t(j,se,p),se=j}else{for(k=0;k<l.length;j>=65536?k+=2:k++){if(j=EW(l,k),j===CW)ze=!0,lr&&(ve=ve||k-Br-1>y&&l[Br+1]!==" ",Br=k);else if(!kW(j))return $F;wt=wt&&m0t(j,se,p),se=j}ve=ve||lr&&k-Br-1>y&&l[Br+1]!==" "}return!ze&&!ve?wt&&!g&&!b(l)?svt:A===AW?$F:tOe:f>9&&ivt(l)?$F:g?A===AW?$F:tOe:ve?ovt:avt}function ubr(l,c,f,y,b){l.dump=function(){if(c.length===0)return l.quotingType===AW?'""':"''";if(!l.noCompatMode&&(ebr.indexOf(c)!==-1||tbr.test(c)))return l.quotingType===AW?'"'+c+'"':"'"+c+"'";var A=l.indent*Math.max(1,f),g=l.lineWidth===-1?-1:Math.max(Math.min(l.lineWidth,40),l.lineWidth-A),p=y||l.flowLevel>-1&&f>=l.flowLevel;function k(j){return abr(l,j)}switch(lbr(c,p,l.indent,g,k,l.quotingType,l.forceQuotes&&!y,b)){case svt:return c;case tOe:return"'"+c.replace(/'/g,"''")+"'";case avt:return"|"+g0t(c,l.indent)+h0t(p0t(c,A));case ovt:return">"+g0t(c,l.indent)+h0t(p0t(_br(c,g),A));case $F:return'"'+fbr(c)+'"';default:throw new fv("impossible error: invalid scalar style")}}()}function g0t(l,c){var f=ivt(l)?String(c):"",y=l[l.length-1]===`
`,b=y&&(l[l.length-2]===`
`||l===`
`),A=b?"+":y?"":"-";return f+A+`
`}function h0t(l){return l[l.length-1]===`
`?l.slice(0,-1):l}function _br(l,c){for(var f=/(\n+)([^\n]*)/g,y=function(){var j=l.indexOf(`
`);return j=j!==-1?j:l.length,f.lastIndex=j,y0t(l.slice(0,j),c)}(),b=l[0]===`
`||l[0]===" ",A,g;g=f.exec(l);){var p=g[1],k=g[2];A=k[0]===" ",y+=p+(!b&&!A&&k!==""?`
`:"")+y0t(k,c),b=A}return y}function y0t(l,c){if(l===""||l[0]===" ")return l;for(var f=/ [^ ]/g,y,b=0,A,g=0,p=0,k="";y=f.exec(l);)p=y.index,p-b>c&&(A=g>b?g:p,k+=`
`+l.slice(b,A),b=A+1),g=p;return k+=`
`,l.length-b>c&&g>b?k+=l.slice(b,g)+`
`+l.slice(g+1):k+=l.slice(b),k.slice(1)}function fbr(l){for(var c="",f=0,y,b=0;b<l.length;f>=65536?b+=2:b++)f=EW(l,b),y=c0[f],!y&&kW(f)?(c+=l[b],f>=65536&&(c+=l[b+1])):c+=y||nbr(f);return c}function pbr(l,c,f){var y="",b=l.tag,A,g,p;for(A=0,g=f.length;A<g;A+=1)p=f[A],l.replacer&&(p=l.replacer.call(f,String(A),p)),(TP(l,c,p,!1,!1)||typeof p>"u"&&TP(l,c,null,!1,!1))&&(y!==""&&(y+=","+(l.condenseFlow?"":" ")),y+=l.dump);l.tag=b,l.dump="["+y+"]"}function v0t(l,c,f,y){var b="",A=l.tag,g,p,k;for(g=0,p=f.length;g<p;g+=1)k=f[g],l.replacer&&(k=l.replacer.call(f,String(g),k)),(TP(l,c+1,k,!0,!0,!1,!0)||typeof k>"u"&&TP(l,c+1,null,!0,!0,!1,!0))&&((!y||b!=="")&&(b+=eOe(l,c)),l.dump&&CW===l.dump.charCodeAt(0)?b+="-":b+="- ",b+=l.dump);l.tag=A,l.dump=b||"[]"}function dbr(l,c,f){var y="",b=l.tag,A=Object.keys(f),g,p,k,j,se;for(g=0,p=A.length;g<p;g+=1)se="",y!==""&&(se+=", "),l.condenseFlow&&(se+='"'),k=A[g],j=f[k],l.replacer&&(j=l.replacer.call(f,k,j)),TP(l,c,k,!1,!1)&&(l.dump.length>1024&&(se+="? "),se+=l.dump+(l.condenseFlow?'"':"")+":"+(l.condenseFlow?"":" "),TP(l,c,j,!1,!1)&&(se+=l.dump,y+=se));l.tag=b,l.dump="{"+y+"}"}function mbr(l,c,f,y){var b="",A=l.tag,g=Object.keys(f),p,k,j,se,ze,ve;if(l.sortKeys===!0)g.sort();else if(typeof l.sortKeys=="function")g.sort(l.sortKeys);else if(l.sortKeys)throw new fv("sortKeys must be a boolean or a function");for(p=0,k=g.length;p<k;p+=1)ve="",(!y||b!=="")&&(ve+=eOe(l,c)),j=g[p],se=f[j],l.replacer&&(se=l.replacer.call(f,j,se)),TP(l,c+1,j,!0,!0,!0)&&(ze=l.tag!==null&&l.tag!=="?"||l.dump&&l.dump.length>1024,ze&&(l.dump&&CW===l.dump.charCodeAt(0)?ve+="?":ve+="? "),ve+=l.dump,ze&&(ve+=eOe(l,c)),TP(l,c+1,se,!0,ze)&&(l.dump&&CW===l.dump.charCodeAt(0)?ve+=":":ve+=": ",ve+=l.dump,b+=ve));l.tag=A,l.dump=b||"{}"}function S0t(l,c,f){var y,b,A,g,p,k;for(b=f?l.explicitTypes:l.implicitTypes,A=0,g=b.length;A<g;A+=1)if(p=b[A],(p.instanceOf||p.predicate)&&(!p.instanceOf||typeof c=="object"&&c instanceof p.instanceOf)&&(!p.predicate||p.predicate(c))){if(f?p.multi&&p.representName?l.tag=p.representName(c):l.tag=p.tag:l.tag="?",p.represent){if(k=l.styleMap[p.tag]||p.defaultStyle,X0t.call(p.represent)==="[object Function]")y=p.represent(c,k);else if(Q0t.call(p.represent,k))y=p.represent[k](c,k);else throw new fv("!<"+p.tag+'> tag resolver accepts not "'+k+'" style');l.dump=y}return!0}return!1}function TP(l,c,f,y,b,A,g){l.tag=null,l.dump=f,S0t(l,f,!1)||S0t(l,f,!0);var p=X0t.call(l.dump),k=y,j;y&&(y=l.flowLevel<0||l.flowLevel>c);var se=p==="[object Object]"||p==="[object Array]",ze,ve;if(se&&(ze=l.duplicates.indexOf(f),ve=ze!==-1),(l.tag!==null&&l.tag!=="?"||ve||l.indent!==2&&c>0)&&(b=!1),ve&&l.usedDuplicates[ze])l.dump="*ref_"+ze;else{if(se&&ve&&!l.usedDuplicates[ze]&&(l.usedDuplicates[ze]=!0),p==="[object Object]")y&&Object.keys(l.dump).length!==0?(mbr(l,c,l.dump,b),ve&&(l.dump="&ref_"+ze+l.dump)):(dbr(l,c,l.dump),ve&&(l.dump="&ref_"+ze+" "+l.dump));else if(p==="[object Array]")y&&l.dump.length!==0?(l.noArrayIndent&&!g&&c>0?v0t(l,c-1,l.dump,b):v0t(l,c,l.dump,b),ve&&(l.dump="&ref_"+ze+l.dump)):(pbr(l,c,l.dump),ve&&(l.dump="&ref_"+ze+" "+l.dump));else if(p==="[object String]")l.tag!=="?"&&ubr(l,l.dump,c,A,k);else{if(p==="[object Undefined]")return!1;if(l.skipInvalid)return!1;throw new fv("unacceptable kind of an object to dump "+p)}l.tag!==null&&l.tag!=="?"&&(j=encodeURI(l.tag[0]==="!"?l.tag.slice(1):l.tag).replace(/!/g,"%21"),l.tag[0]==="!"?j="!"+j:j.slice(0,18)==="tag:yaml.org,2002:"?j="!!"+j.slice(18):j="!<"+j+">",l.dump=j+" "+l.dump)}return!0}function gbr(l,c){var f=[],y=[],b,A;for(rOe(l,f,y),b=0,A=y.length;b<A;b+=1)c.duplicates.push(f[y[b]]);c.usedDuplicates=new Array(A)}function rOe(l,c,f){var y,b,A;if(l!==null&&typeof l=="object")if(b=c.indexOf(l),b!==-1)f.indexOf(b)===-1&&f.push(b);else if(c.push(l),Array.isArray(l))for(b=0,A=l.length;b<A;b+=1)rOe(l[b],c,f);else for(y=Object.keys(l),b=0,A=y.length;b<A;b+=1)rOe(l[y[b]],c,f)}function hbr(l,c){c=c||{};var f=new sbr(c);f.noRefs||gbr(l,f);var y=l;return f.replacer&&(y=f.replacer.call({"":y},"",y)),TP(f,0,y,!0,!0)?f.dump+`
`:""}var ybr=hbr,vbr={dump:ybr};function cOe(l,c){return function(){throw new Error("Function yaml."+l+" is removed in js-yaml 4. Use yaml."+c+" instead, which is now safe by default.")}}var Sbr=yy,bbr=E0t,Tbr=k0t,Ebr=I0t,xbr=O0t,Cbr=iOe,Abr=K0t.load,kbr=K0t.loadAll,Pbr=vbr.dump,Nbr=fv,Dbr={binary:j0t,float:w0t,map:A0t,null:P0t,pairs:U0t,set:V0t,timestamp:L0t,bool:N0t,int:D0t,merge:F0t,omap:B0t,seq:C0t,str:x0t},wbr=cOe("safeLoad","load"),Ibr=cOe("safeLoadAll","loadAll"),Obr=cOe("safeDump","dump"),Rbr={Type:Sbr,Schema:bbr,FAILSAFE_SCHEMA:Tbr,JSON_SCHEMA:Ebr,CORE_SCHEMA:xbr,DEFAULT_SCHEMA:Cbr,load:Abr,loadAll:kbr,dump:Pbr,YAMLException:Nbr,types:Dbr,safeLoad:wbr,safeLoadAll:Ibr,safeDump:Obr},cvt=Rbr;async function lvt(l){let c;try{c=await Mbr(l,"utf8")}catch(f){throw new Error(String(f))}return cvt.load(c)}var FC=function(l,c,f,y){var b=arguments.length,A=b<3?c:y===null?y=Object.getOwnPropertyDescriptor(c,f):y,g;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(l,c,f,y);else for(var p=l.length-1;p>=0;p--)(g=l[p])&&(A=(b<3?g(A):b>3?g(c,f,A):g(c,f))||A);return b>3&&A&&Object.defineProperty(c,f,A),A},R_=function(l,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(l,c)},Fbr=3,jbr=64,w1=class extends Wd{constructor(c,f,y,b){super(b),this.workQueue=[],this.ipcAddr=c,this.workQueue.push({cwd:f.cwd,configFilePath:y})}async run(){let c;for(let f=0;f<Fbr&&!c;f++){try{c=await this.createServerSocket(this.handleServerConnection.bind(this))}catch{}if(!c)try{c=await this.createClientSocket()}catch{}}if(!c){this.logger.debug("Could not establish server or client connection. Exiting");return}try{c instanceof wx.Server?await this.doWork(c):await this.sendWorkToConductor(c)}finally{await this.logger.close()}}async createServerSocket(c){return new Promise((f,y)=>{let b=wx.createServer({});b.on("connection",c),b.on("listening",()=>{f(b)}),b.on("error",A=>{this.sendLogs(`Conductor experienced error on project ${this.projectId} against analyzed path ${this.analyzedPath} at commit ${this.analyzedCommit}`,A).then(()=>y(A)).catch(()=>y(A))}),process.on("SIGINT",()=>this.handleSignal(b,"SIGINT")),process.on("SIGTERM",()=>this.handleSignal(b,"SIGTERM")),b.listen(this.ipcAddr,jbr)})}createClientSocket(){return new Promise((c,f)=>{let y=wx.connect(this.ipcAddr);y.on("connect",()=>c(y)),y.on("error",b=>{this.sendLogs(`Wagon experienced error on project ${this.projectId} against analyzed path ${this.analyzedPath} at commit ${this.analyzedCommit}`,b).then(()=>f(b)).catch(()=>f(b))})})}handleServerConnection(c){let f="";c.on("data",y=>{f+=y.toString()}),c.on("close",()=>{let y=JSON.parse(f);this.workQueue.push(y)})}sendWorkToConductor(c){return new Promise((f,y)=>{let b=this.workQueue.shift();this.logger.debug("Sending work through IPC: ",JSON.stringify(b)),c.on("close",f),c.on("error",A=>{this.sendLogs(`Wagon experienced error sending work to conductor on project ${this.projectId} against analyzed path ${this.analyzedPath} at commit ${this.analyzedCommit}`,A).then(()=>y(A)).catch(()=>y(A))}),c.on("timeout",y),c.write(Buffer.from(JSON.stringify(b))),c.end()})}async doWork(c){this.logger.debug("We are the conductor of the choo-choo train. Running all available work in queue");let f=performance.now(),y=this.workQueue?.[0];for(y&&(this.environment=new Bw({cwd:y.cwd}),this.gitInfo=await this.getRepoData(y),await this.getPackageData(y),this.sendLogs(`The ChooChooTrain ride for analyzed path ${this.analyzedPath} at commit ${this.analyzedCommit} has started`)),this.totalPackages=0;this.workQueue.length>0;){this.logger.debug("Queue length",this.workQueue.length);let b=this.workQueue.shift();if(!b)return;let A=await this.getPackageData(b);this.environment=new Bw({cwd:b.cwd}),await this.collect(this.environment,A),this.totalPackages++}this.totalDuration=Number((performance.now()-f).toFixed(2)),this.sendLogs(`The ChooChooTrain ride with ${this.totalPackages} packages at analyzed path ${this.analyzedPath} at commit ${this.analyzedCommit} took ${this.totalDuration}ms`,void 0,!0),c.close()}async getRepoData(c){let f=await new TW(c.cwd,this.logger).getGitInfo(),{repository:y,commitHash:b,commitTags:A,commitBranches:g}=f,p=[...A,...g],k=`${y.host??""}/${y.owner??""}/${y.repository??""}`;this.date=new Date().toISOString();let j=this.date.split("T")[0];this.scanId=j+k+b+p;let se=Lbr("sha256");se.update(this.scanId),this.scanId=se.digest("hex");let ze=this.environment?.name,ve=NC({[Ep.ANALYZED_COMMIT]:b,[Ep.ANALYZED_HOST]:y.host,[Ep.ANALYZED_OWNER]:y.owner,[Ep.ANALYZED_PATH]:k,[Ep.ANALYZED_OWNER_PATH]:`${y.host??""}/${y.owner??""}`,[Ep.ANALYZED_REPOSITORY]:y.repository,[Ep.ANALYZED_REFS]:p,[Ep.ENVIRONMENT_NAME]:ze,[Ep.SCAN_ID]:this.scanId},[Ep.ANALYZED_COMMIT,Ep.ANALYZED_HOST,Ep.ANALYZED_OWNER,Ep.ANALYZED_PATH,Ep.ANALYZED_OWNER_PATH,Ep.ANALYZED_REPOSITORY,Ep.ANALYZED_REFS]);return this.analyzedCommit=ve[Ep.ANALYZED_COMMIT],this.analyzedPath=ve[Ep.ANALYZED_PATH],await this.getPackageData(c),ve}async getPackageData(c){let f=await lvt(c.configFilePath);return new bW(Lne,this.logger).validate(f),this.projectId=f.projectId,this.logEndpoint===void 0&&(this.logEndpoint=f.endpoint.split("/metrics")[0]+"/logs",this.logger.debug("Log endpoint: "+this.logEndpoint)),f}async collect(c,f){let y=new ww(f,c,this.gitInfo??{},this.logger,this.date??new Date().toISOString());try{await y.run()}catch(b){b instanceof Error?(this.logger.error(b),this.sendLogs("Telemetry runner error: ",b)):(this.logger.error(String(b)),this.sendLogs("Telemetry runner error: ",String(b)))}}handleSignal(c,f){c.close(y=>{y&&this.sendLogs(`Process ${f} signal error: `,y).catch(b=>{b instanceof Error?this.logger.error(b):this.logger.error(String(b))})})}async sendLogs(c,f,y=!1){if(this.date===void 0||this.logEndpoint===void 0||this.gitInfo===void 0||this.projectId===void 0||this.scanId===void 0||this.environment===void 0)return;let b={date:this.date,environment:this.environment.getConfig(),gitInfo:this.gitInfo,message:c,projectId:this.projectId,scanId:this.scanId,isCompleted:y};this.totalDuration!==void 0&&this.totalPackages!==void 0&&(b.totalDuration=this.totalDuration,b.totalPackages=this.totalPackages),f!=null&&(f instanceof Error?b.error={message:f.message}:b.error=f),this.logger.debug("Current log payload: ",JSON.stringify(b));try{let A=await fetch(this.logEndpoint??"",{method:"POST",headers:{"Content-Type":"application/json"},body:JSON.stringify(b)});A.ok||this.logger.error(`Failed to send log: ${A.statusText}`)}catch(A){A instanceof Error?this.logger.error(A):this.logger.error(String(A))}}};FC([Nl({argFormatter:()=>"[onConnect]"}),R_("design:type",Function),R_("design:paramtypes",[Function]),R_("design:returntype",Promise)],w1.prototype,"createServerSocket",null);FC([Nl(),R_("design:type",Function),R_("design:paramtypes",[]),R_("design:returntype",Promise)],w1.prototype,"createClientSocket",null);FC([Nl({argFormatter:()=>"[socket]"}),R_("design:type",Function),R_("design:paramtypes",[wx.Socket]),R_("design:returntype",void 0)],w1.prototype,"handleServerConnection",null);FC([Nl({argFormatter:()=>"[socket]"}),R_("design:type",Function),R_("design:paramtypes",[wx.Socket]),R_("design:returntype",void 0)],w1.prototype,"sendWorkToConductor",null);FC([Nl({argFormatter:()=>"[server]"}),R_("design:type",Function),R_("design:paramtypes",[wx.Server]),R_("design:returntype",Promise)],w1.prototype,"doWork",null);FC([Nl(),R_("design:type",Function),R_("design:paramtypes",[Object]),R_("design:returntype",Promise)],w1.prototype,"getRepoData",null);FC([Nl(),R_("design:type",Function),R_("design:paramtypes",[Object]),R_("design:returntype",Promise)],w1.prototype,"getPackageData",null);FC([Nl(),R_("design:type",Function),R_("design:paramtypes",[Bw,Object]),R_("design:returntype",Promise)],w1.prototype,"collect",null);FC([Nl(),R_("design:type",Function),R_("design:paramtypes",[wx.Server,String]),R_("design:returntype",void 0)],w1.prototype,"handleSignal",null);FC([Nl(),R_("design:type",Function),R_("design:paramtypes",[String,Object,Boolean]),R_("design:returntype",Promise)],w1.prototype,"sendLogs",null);import{tmpdir as Bbr}from"node:os";import{join as Ubr}from"node:path";function uvt(l){let c=Math.round(Math.random()*999999).toString().padStart(6,"0");return Ubr(Bbr(),`ibmtelemetry-${l.replace(/[:.-]/g,"")}-${c}.log`)}var Vbr=Mce.join(_vt.tmpdir(),"ibmtelemetry-ipc"),{Command:Jbr}=PAe;function qbr(){try{new Jbr().description("Collect telemetry data for a package.").requiredOption("--config <config-path>","Path to a telemetry configuration file").option("--log <log-path>","Path to temp log file").action(zbr).parseAsync().catch(c=>{console.error(c)})}catch(l){console.error(l)}}async function zbr(l){let c=new Date().toISOString(),f=l.log??uvt(c),y=new sF(f),b=Mce.resolve(l.config);y.traceEnter("","runBackgroundProcess",[l]);let A=new w1(Vbr,new Bw,b,y);try{await A.run()}catch(g){g instanceof Error?y.error(g):y.error(String(g))}y.traceExit("","runBackgroundProcess",void 0),await y.close()}qbr();
/*! Bundled license information:

reflect-metadata/Reflect.js:
  (*! *****************************************************************************
  Copyright (C) Microsoft. All rights reserved.
  Licensed under the Apache License, Version 2.0 (the "License"); you may not use
  this file except in compliance with the License. You may obtain a copy of the
  License at http://www.apache.org/licenses/LICENSE-2.0
  
  THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
  WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
  MERCHANTABLITY OR NON-INFRINGEMENT.
  
  See the Apache Version 2.0 License for specific language governing permissions
  and limitations under the License.
  ***************************************************************************** *)

typescript/lib/typescript.js:
  (*! *****************************************************************************
  Copyright (c) Microsoft Corporation. All rights reserved.
  Licensed under the Apache License, Version 2.0 (the "License"); you may not use
  this file except in compliance with the License. You may obtain a copy of the
  License at http://www.apache.org/licenses/LICENSE-2.0
  
  THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
  WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
  MERCHANTABLITY OR NON-INFRINGEMENT.
  
  See the Apache Version 2.0 License for specific language governing permissions
  and limitations under the License.
  ***************************************************************************** *)

js-yaml/dist/js-yaml.mjs:
  (*! js-yaml 4.1.0 https://github.com/nodeca/js-yaml @license MIT *)
*/
